/* Copyright 2020 Siemens Digital Industries Software
==================================================
Copyright 2019.
Siemens Product Lifecycle Management Software Inc.
All Rights Reserved.
==================================================
Copyright 2020 Siemens Digital Industries Software
==================================================
===============================================================================
File Description:

    The header file that defines the export symbols for the
    evm0viewmgmt library

===============================================================================
Date                     Name                       Description

$HISTORY$
=============================================================================*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libEvm0ViewMgmt

#if !defined(LIBEVM0VIEWMGMT) && !defined(IPLIB)
#   error IPLIB or LIBEVM0VIEWMGMT is not defined
#endif

/* Handwritten code should use the EVM0VIEWMGMT_API version, not EVM0VIEWMGMTEXPORT */

#define EVM0VIEWMGMT_API EVM0VIEWMGMTEXPORT

/* Support EVM0VIEWMGMTEXPORT for autogenerated schema/pif code only */

#if IPLIB==libEvm0ViewMgmt || defined(LIBEVM0VIEWMGMT)
#   if defined(__lint)
#       define EVM0VIEWMGMTEXPORT       __export(Evm0ViewMgmt)
#       define EVM0VIEWMGMTGLOBAL       extern __global(Evm0ViewMgmt)
#       define EVM0VIEWMGMTPRIVATE      extern __private(Evm0ViewMgmt)
#   elif defined(_WIN32)
#       define EVM0VIEWMGMTEXPORT       __declspec(dllexport)
#       define EVM0VIEWMGMTGLOBAL       extern __declspec(dllexport)
#       define EVM0VIEWMGMTPRIVATE      extern
#   else
#       define EVM0VIEWMGMTEXPORT
#       define EVM0VIEWMGMTGLOBAL       extern
#       define EVM0VIEWMGMTPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define EVM0VIEWMGMTEXPORT       __export(Evm0ViewMgmt)
#       define EVM0VIEWMGMTGLOBAL       extern __global(Evm0ViewMgmt)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define EVM0VIEWMGMTEXPORT       __declspec(dllimport)
#       define EVM0VIEWMGMTGLOBAL       extern __declspec(dllimport)
#   else
#       define EVM0VIEWMGMTEXPORT
#       define EVM0VIEWMGMTGLOBAL       extern
#   endif
#endif
