/*
    Copyright 2020 Siemens Digital Industries Software
    ==================================================
    Copyright 2018.
    Siemens Product Lifecycle Management Software Inc.
    All Rights Reserved.
    ==================================================
    Copyright 2020 Siemens Digital Industries Software
*/

/**

    @libFnd0Participant_exports.h
    Export defines for the Particpant library

**/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libFnd0Participant

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

#define PARTICIPANT_LIBRARY_NAME    libFnd0Participant
#define PARTICIPANT_LIBRARY_ID_NAME Fnd0Participant

/* Handwritten code should use PARTICIPANT_API, not PARTICIPANTEXPORT */

#define PARTICIPANT_API PARTICIPANTEXPORT

/* Support EPMEXPORT for autogenerated schema/pif code only */

#if IPLIB==PARTICIPANT_LIBRARY_NAME
#   if defined(__lint)
#       define PARTICIPANTEXPORT       __export(PARTICIPANT_LIBRARY_ID_NAME)
#       define PARTICIPANTGLOBAL       extern __global(PARTICIPANT_LIBRARY_ID_NAME)
#       define PARTICIPANTPRIVATE      extern __private(PARTICIPANT_LIBRARY_ID_NAME)
#   elif defined(_WIN32)
#       define PARTICIPANTEXPORT       __declspec(dllexport)
#       define PARTICIPANTGLOBAL       extern __declspec(dllexport)
#       define PARTICIPANTPRIVATE      extern
#   else
#       define PARTICIPANTEXPORT
#       define PARTICIPANTGLOBAL       extern
#       define PARTICIPANTPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define PARTICIPANTEXPORT       __export(PARTICIPANT_LIBRARY_ID_NAME)
#       define PARTICIPANTGLOBAL       extern __global(PARTICIPANT_LIBRARY_ID_NAME)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define PARTICIPANTEXPORT      __declspec(dllimport)
#       define PARTICIPANTGLOBAL       extern __declspec(dllimport)
#   else
#       define PARTICIPANTEXPORT
#       define PARTICIPANTGLOBAL       extern
#   endif
#endif

