/*
    Copyright 2020 Siemens Digital Industries Software
    ==================================================
    Copyright 2017.
    Siemens Product Lifecycle Management Software Inc.
    All Rights Reserved.
    ==================================================
    Copyright 2020 Siemens Digital Industries Software
*/

/**

    @libLis0ldfepm_exports.h
    Export defines for the Lifecycle Interoperability Services Workflow library

**/

#include <common/library_indicators.h>

#ifdef EXPORTLIB
#error ExportLibrary was already defined
#endif

#define EXPORTLIB       libLis0ldfepm

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

#define LIS0LDFEPM_LIBRARY_NAME libLis0ldfepm
#define LIS0LDFEPM_LIBRARY_ID_NAME Lis0ldfepm

/* Handwritten code should use LIS0LDFEPM_API, not LIS0LDFEPMEXPORT */

#define LIS0LDFEPM_API LIS0LDFEPMEXPORT

/* Support LIS0LDFEPMEXPORT for autogenerated schema/pif code only */

#if IPLIB==LIS0LDFEPM_LIBRARY_NAME
#   if defined(__lint)
#       define LIS0LDFEPMEXPORT       __export(LIS0LDFEPM_LIBRARY_ID_NAME)
#       define LIS0LDFEPMGLOBAL       extern __global(LIS0LDFEPM_LIBRARY_ID_NAME)
#       define LIS0LDFEPMPRIVATE      extern __private(LIS0LDFEPM_LIBRARY_ID_NAME)
#   elif defined(_WIN32)
#       define LIS0LDFEPMEXPORT       __declspec(dllexport)
#       define LIS0LDFEPMGLOBAL       extern __declspec(dllexport)
#       define LIS0LDFEPMPRIVATE      extern
#   else
#       define LIS0LDFEPMEXPORT
#       define LIS0LDFEPMGLOBAL       extern
#       define LIS0LDFEPMPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define LIS0LDFEPMEXPORT       __export(LIS0LDFEPM_LIBRARY_ID_NAME)
#       define LIS0LDFEPMGLOBAL       extern __global(LIS0LDFEPM_LIBRARY_ID_NAME)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define LIS0LDFEPMEXPORT       __declspec(dllimport)
#       define LIS0LDFEPMGLOBAL       extern __declspec(dllimport)
#   else
#       define LIS0LDFEPMEXPORT
#       define LIS0LDFEPMGLOBAL       extern
#   endif
#endif
