// Copyright 2020 Siemens Digital Industries Software
// ==================================================
// Copyright 2014.
// Siemens Product Lifecycle Management Software Inc.
// All Rights Reserved.
// ==================================================
// Copyright 2020 Siemens Digital Industries Software


/**
    @libLis0lisfmwrk_exports.h
    Export defines for the Lifecycle Interoperability Services library

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libLis0lisfmwrk

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

#define LIS0LISFMWRK_LIBRARY_NAME libLis0lisfmwrk
#define LIS0LISFMWRK_LIBRARY_ID_NAME Lis0lisfmwrk

/* Handwritten code should use LIS0LISFMWRK_API, not LIS0LISFMWRKEXPORT */

#define LIS0LISFMWRK_API LIS0LISFMWRKEXPORT

/* Support LIS0LISFMWRKEXPORT for autogenerated schema/pif code only */

#if IPLIB==LIS0LISFMWRK_LIBRARY_NAME
#   if defined(__lint)
#       define LIS0LISFMWRKEXPORT       __export(LIS0LISFMWRK_LIBRARY_ID_NAME)
#       define LIS0LISFMWRKGLOBAL       extern __global(LIS0LISFMWRK_LIBRARY_ID_NAME)
#       define LIS0LISFMWRKPRIVATE      extern __private(LIS0LISFMWRK_LIBRARY_ID_NAME)
#   elif defined(_WIN32)
#       define LIS0LISFMWRKEXPORT       __declspec(dllexport)
#       define LIS0LISFMWRKGLOBAL       extern __declspec(dllexport)
#       define LIS0LISFMWRKPRIVATE      extern
#   else
#       define LIS0LISFMWRKEXPORT
#       define LIS0LISFMWRKGLOBAL       extern
#       define LIS0LISFMWRKPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define LIS0LISFMWRKEXPORT       __export(LIS0LISFMWRK_LIBRARY_ID_NAME)
#       define LIS0LISFMWRKGLOBAL       extern __global(LIS0LISFMWRK_LIBRARY_ID_NAME)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define LIS0LISFMWRKEXPORT       __declspec(dllimport)
#       define LIS0LISFMWRKGLOBAL       extern __declspec(dllimport)
#   else
#       define LIS0LISFMWRKEXPORT
#       define LIS0LISFMWRKGLOBAL       extern
#   endif
#endif
