/*==============================================================================
                Copyright (c) 2003-2005 UGS Corporation
                   Unpublished - All Rights Reserved
 ==============================================================================*/

/*
    File Description:

    The header file that defines the export symbols for the AE library
 */

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libae

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use AE_API, not AEEXPORT */

#define AE_API AEEXPORT

/* Support AEEXPORT for autogenerated schema/pif code only */

#if IPLIB==libae
#   if defined(__lint)
#       define AEEXPORT       __export(ae)
#       define AEGLOBAL       extern __global(ae)
#       define AEPRIVATE      extern __private(ae)
#   elif defined(_WIN32)
#       define AEEXPORT       __declspec(dllexport)
#       define AEGLOBAL       extern __declspec(dllexport)
#       define AEPRIVATE      extern
#   else
#       define AEEXPORT
#       define AEGLOBAL       extern
#       define AEPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define AEEXPORT       __export(ae)
#       define AEGLOBAL       extern __global(ae)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define AEEXPORT      __declspec(dllimport)
#       define AEGLOBAL       extern __declspec(dllimport)
#   else
#       define AEEXPORT
#       define AEGLOBAL       extern
#   endif
#endif

