/*==============================================================================
                Copyright (c) 2003-2005 UGS Corporation
                   Unpublished - All Rights Reserved
 ==============================================================================*/

/*
    File Description:

    The header file that defines the export symbols for the ARCHIVE library
 */

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libarchive

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use ARCHIVE_API, not ARCHIVEEXPORT */

#define ARCHIVE_API ARCHIVEEXPORT

/* Support ARCHIVEEXPORT for autogenerated schema/pif code only */

#if IPLIB==libarchive
#   if defined(__lint)
#       define ARCHIVEEXPORT       __export(archive)
#       define ARCHIVEGLOBAL       extern __global(archive)
#       define ARCHIVEPRIVATE      extern __private(archive)
#   elif defined(_WIN32)
#       define ARCHIVEEXPORT       __declspec(dllexport)
#       define ARCHIVEGLOBAL       extern __declspec(dllexport)
#       define ARCHIVEPRIVATE      extern
#   else
#       define ARCHIVEEXPORT
#       define ARCHIVEGLOBAL       extern
#       define ARCHIVEPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define ARCHIVEEXPORT       __export(archive)
#       define ARCHIVEGLOBAL       extern __global(archive)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define ARCHIVEEXPORT      __declspec(dllimport)
#       define ARCHIVEGLOBAL       extern __declspec(dllimport)
#   else
#       define ARCHIVEEXPORT
#       define ARCHIVEGLOBAL       extern
#   endif
#endif

