
/*=============================================================================
 ===============================================================================
File Description:

    The header file that defines the export symbols for the
    ASBASMALIGNMENT library

===============================================================================
Date                     Name                       Description

$HISTORY$
=============================================================================*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libasbasmalignment

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten iMAN code should use the ASBASMALIGNMENT_API version, not ASBASMALIGNMENTEXPORT */

#define ASBASMALIGNMENT_API ASBASMALIGNMENTEXPORT

/* Support ASBASMALIGNMENTEXPORT for autogenerated schema/pif code only */

#if IPLIB==libasbasmalignment
#   if defined(__lint)
#       define ASBASMALIGNMENTEXPORT       __export(asbasmalignment)
#       define ASBASMALIGNMENTGLOBAL       extern __global(asbasmalignment)
#       define ASBASMALIGNMENTPRIVATE      extern __private(asbasmalignment)
#   elif defined(_WIN32)
#       define ASBASMALIGNMENTEXPORT       __declspec(dllexport)
#       define ASBASMALIGNMENTGLOBAL       extern __declspec(dllexport)
#       define ASBASMALIGNMENTPRIVATE      extern
#   else
#       define ASBASMALIGNMENTEXPORT
#       define ASBASMALIGNMENTGLOBAL       extern
#       define ASBASMALIGNMENTPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define ASBASMALIGNMENTEXPORT       __export(asbasmalignment)
#       define ASBASMALIGNMENTGLOBAL       extern __global(asbasmalignment)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define ASBASMALIGNMENTEXPORT       __declspec(dllimport)
#       define ASBASMALIGNMENTGLOBAL       extern __declspec(dllimport)
#   else
#       define ASBASMALIGNMENTEXPORT
#       define ASBASMALIGNMENTGLOBAL       extern
#   endif
#endif
