
/*=============================================================================
 ===============================================================================
File Description:

    The header file that defines the export symbols for the
    ASBUILT library

===============================================================================
Date                     Name                       Description

$HISTORY$
=============================================================================*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libasbuilt

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten iMAN code should use the ASBUILT_API version, not ASBUILTEXPORT */

#define ASBUILT_API ASBUILTEXPORT

/* Support ASBUILTEXPORT for autogenerated schema/pif code only */

#if IPLIB==libasbuilt
#   if defined(__lint)
#       define ASBUILTEXPORT       __export(asbuilt)
#       define ASBUILTGLOBAL       extern __global(asbuilt)
#       define ASBUILTPRIVATE      extern __private(asbuilt)
#   elif defined(_WIN32)
#       define ASBUILTEXPORT       __declspec(dllexport)
#       define ASBUILTGLOBAL       extern __declspec(dllexport)
#       define ASBUILTPRIVATE      extern
#   else
#       define ASBUILTEXPORT
#       define ASBUILTGLOBAL       extern
#       define ASBUILTPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define ASBUILTEXPORT       __export(asbuilt)
#       define ASBUILTGLOBAL       extern __global(asbuilt)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define ASBUILTEXPORT       __declspec(dllimport)
#       define ASBUILTGLOBAL       extern __declspec(dllimport)
#   else
#       define ASBUILTEXPORT
#       define ASBUILTGLOBAL       extern
#   endif
#endif
