/*==============================================================================
                Copyright (c) 2003-2005 UGS Corporation
                   Unpublished - All Rights Reserved
 ==============================================================================*/

/*
    File Description:

    The header file that defines the export symbols for the ASSY_JT library
 */

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libassy_jt

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use ASSY_JT_API, not ASSY_JTEXPORT */

#define ASSY_JT_API ASSY_JTEXPORT

/* Support QRYEXPORT for autogenerated schema/pif code only */

#if IPLIB==libassy_jt
#   if defined(__lint)
#       define ASSY_JTEXPORT       __export(assy_jt)
#       define ASSY_JTGLOBAL       extern __global(assy_jt)
#       define ASSY_JTPRIVATE      extern __private(assy_jt)
#   elif defined(_WIN32)
#       define ASSY_JTEXPORT       __declspec(dllexport)
#       define ASSY_JTGLOBAL       extern __declspec(dllexport)
#       define ASSY_JTPRIVATE      extern
#   else
#       define ASSY_JTEXPORT
#       define ASSY_JTGLOBAL       extern
#       define ASSY_JTPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define ASSY_JTEXPORT       __export(assy_jt)
#       define ASSY_JTGLOBAL       extern __global(assy_jt)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define ASSY_JTEXPORT       __declspec(dllimport)
#       define ASSY_JTGLOBAL       extern __declspec(dllimport)
#   else
#       define ASSY_JTEXPORT
#       define ASSY_JTGLOBAL       extern
#   endif
#endif

