/*=============================================================================
           Copyright (c) 2004 UGS
                   Unpublished - All rights reserved

   THIS PROGRAM IS AN UNPUBLISHED WORK FULLY PROTECTED BY THE UNITED STATES
  COPYRIGHT LAWS AND IS CONSIDERED A TRADE SECRET BELONGING TO THE COPYRIGHT
                                   HOLDER.
===============================================================================*/

/**
    @file

    This file contains the published identifiers of error codes that can be
    generated by this module. Obtaining and using the numeric values of these
    manifest constants is not supported. We reserve the right to change the
    actual values as necessary.
*/

/** @if HISTORY_SECTION
===============================================================================
   Date      Name                    Description of Change
14-Sep-2004  William Hinton          BMF errors
12-Oct-2004  William Hinton          add detailed errors
15-Oct-2004  William Hinton          Add more errors
28-Oct-2004  William Hinton          Add system admin error
01-Nov-2004  William Hinton          more errors
11-Nov-2004  Molugu Ramesh           cm changes from brahma
06-Dec-2004  Andy Perry              Add error processing for customer implementor path.
08-Dec-2004  Gayatri Beera           Add Debashis's changes
20-Dec-2004  Debashis Das            added new error code
04-Feb-2005  Andy Perry              Add new implementer error.
08-Mar-2005  Molugu Ramesh           Add BMF_cannot_modify_internal error.
$HISTORY$
=============================================================================
@endif */

#ifndef BMF_ERRORS_H
#define BMF_ERRORS_H

#include <common/emh_const.h>

/**
    @defgroup BMF_ERRORS Errors
    @ingroup BMF
    @{
*/

#define BMF_ERROR_BASE                    EMH_BMF_error_base

#define BMF_init_error                    (BMF_ERROR_BASE + 1)
#define BMF_create_error                  (BMF_ERROR_BASE + 2)
#define BMF_save_error                    (BMF_ERROR_BASE + 3)
#define BMF_destroy_error                 (BMF_ERROR_BASE + 4)
#define BMF_not_system_admin              (BMF_ERROR_BASE + 5)
#define BMF_BMOperation_ldExtPts          (BMF_ERROR_BASE + 6)
#define BMF_BMOperation_askExtPtNm        (BMF_ERROR_BASE + 7)
#define BMF_BMOperation_addExtPt          (BMF_ERROR_BASE + 8)
#define BMF_unable_to_create_enquiry      (BMF_ERROR_BASE + 9)
#define BMF_unable_to_execute_enquiry     (BMF_ERROR_BASE + 10)
#define BMF_Extension_missing             (BMF_ERROR_BASE + 11)
#define BMF_extension_desc_count_mismatch (BMF_ERROR_BASE + 12)
#define BMF_cust_impl_path_not_found      (BMF_ERROR_BASE + 13)
#define BMF_cust_ext_symbol_not_found     (BMF_ERROR_BASE + 14)
#define BMF_internal_error                (BMF_ERROR_BASE + 15)
#define BMF_missing_required_parms        (BMF_ERROR_BASE + 16)
#define BMF_cannot_modify_internal        (BMF_ERROR_BASE + 17)

/** @} */

#endif
