
//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2010.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/**
    @file
    The header file that defines the export symbols for the CDM library
*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libcdm0contractmanagement

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten iMAN code should use the XXX_API version, not XXXEXPORT */

#define CDM0CONTRACTMANAGEMENT_API CONTRACTMANAGEMENTEXPORT

/* Support CONTRACTMANAGEMENTEXPORT for autogenerated schema/pif code only */

#if IPLIB==libcdm0contractmanagement
#   if defined(__lint)
#       define CONTRACTMANAGEMENTEXPORT       __export(Cdm0contractmanagement)
#       define CONTRACTMANAGEMENTGLOBAL       extern __global(Cdm0contractmanagement)
#       define CONTRACTMANAGEMENTPRIVATE      extern __private(Cdm0contractmanagement)
#   elif defined(_WIN32)
#       define CONTRACTMANAGEMENTEXPORT       __declspec(dllexport)
#       define CONTRACTMANAGEMENTGLOBAL       extern __declspec(dllexport)
#       define CONTRACTMANAGEMENTPRIVATE      extern
#   else
#       define CONTRACTMANAGEMENTEXPORT
#       define CONTRACTMANAGEMENTGLOBAL       extern
#       define CONTRACTMANAGEMENTPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CONTRACTMANAGEMENTEXPORT       __export(Cdm0contractmanagement)
#       define CONTRACTMANAGEMENTGLOBAL       extern __global(Cdm0contractmanagement)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CONTRACTMANAGEMENTEXPORT       __declspec(dllimport)
#       define CONTRACTMANAGEMENTGLOBAL       extern __declspec(dllimport)
#   else
#       define CONTRACTMANAGEMENTEXPORT
#       define CONTRACTMANAGEMENTGLOBAL       extern
#   endif
#endif
