/*==============================================================================
                Copyright (c) 2003-2005 UGS Corporation
                   Unpublished - All Rights Reserved
 ==============================================================================*/

/*
    File Description:

    The header file that defines the export symbols for the CFM library
 */

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libcfm

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use CFM_API, not CFMEXPORT */

#define CFM_API CFMEXPORT

/* Support CFMEXPORT for autogenerated schema/pif code only */

#if IPLIB==libcfm
#   if defined(__lint)
#       define CFMEXPORT       __export(cfm)
#       define CFMGLOBAL       extern __global(cfm)
#       define CFMPRIVATE      extern __private(cfm)
#   elif defined(_WIN32)
#       define CFMEXPORT       __declspec(dllexport)
#       define CFMGLOBAL       extern __declspec(dllexport)
#       define CFMPRIVATE      extern
#   else
#       define CFMEXPORT
#       define CFMGLOBAL       extern
#       define CFMPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CFMEXPORT       __export(cfm)
#       define CFMGLOBAL       extern __global(cfm)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CFMEXPORT      __declspec(dllimport)
#       define CFMGLOBAL       extern __declspec(dllimport)
#   else
#       define CFMEXPORT
#       define CFMGLOBAL       extern
#   endif
#endif

