/*==============================================================================
                Copyright (c) 2003-2005 UGS Corporation
                   Unpublished - All Rights Reserved
 ==============================================================================*/

/*
    File Description:

    The header file that defines the export symbols for the COLLABCTX library
 */

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#error ExportLibrary is defined to be EXPORTLIBRARY
#endif

#define EXPORTLIBRARY            libcollabctx

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use COLLABCTX_API, not COLLABCTXEXPORT */

#define COLLABCTX_API COLLABCTXEXPORT

/* Support COLLABCTXEXPORT for autogenerated schema/pif code only */

#if IPLIB==libcollabctx
#   if defined(__lint)
#       define COLLABCTXEXPORT       __export(collabctx)
#       define COLLABCTXGLOBAL       extern __global(collabctx)
#       define COLLABCTXPRIVATE      extern __private(collabctx)
#   elif defined(_WIN32)
#       define COLLABCTXEXPORT       __declspec(dllexport)
#       define COLLABCTXGLOBAL       extern __declspec(dllexport)
#       define COLLABCTXPRIVATE      extern
#   else
#       define COLLABCTXEXPORT
#       define COLLABCTXGLOBAL       extern
#       define COLLABCTXPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define COLLABCTXEXPORT       __export(collabctx)
#       define COLLABCTXGLOBAL       extern __global(collabctx)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define COLLABCTXEXPORT      __declspec(dllimport)
#       define COLLABCTXGLOBAL       extern __declspec(dllimport)
#   else
#       define COLLABCTXEXPORT
#       define COLLABCTXGLOBAL       extern
#   endif
#endif

