/*==============================================================================
                Copyright (c) 2009-2010 SIEMENS
                   Unpublished - All Rights Reserved
 ==============================================================================*/

/*
    File Description:

    The header file that defines the export symbols for the PS library
 */

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libconfigurator

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use CONFIGURATOR_API, not CONFIGURATOREXPORT */

#define CONFIGURATOR_API CONFIGURATOREXPORT

/* Support CONFIGURATOREXPORT for autogenerated schema/pif code only */

#if IPLIB==libconfigurator
#   if defined(__lint)
#       define CONFIGURATOREXPORT       __export(configurator)
#       define CONFIGURATORGLOBAL       extern __global(configurator)
#       define CONFIGURATORPRIVATE      extern __private(configurator)
#   elif defined(_WIN32)
#       define CONFIGURATOREXPORT       __declspec(dllexport)
#       define CONFIGURATORGLOBAL       extern __declspec(dllexport)
#       define CONFIGURATORPRIVATE      extern
#   else
#       define CONFIGURATOREXPORT
#       define CONFIGURATORGLOBAL       extern
#       define CONFIGURATORPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CONFIGURATOREXPORT       __export(configurator)
#       define CONFIGURATORGLOBAL       extern __global(configurator)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CONFIGURATOREXPORT      __declspec(dllimport)
#       define CONFIGURATORGLOBAL       extern __declspec(dllimport)
#   else
#       define CONFIGURATOREXPORT
#       define CONFIGURATORGLOBAL       extern
#   endif
#endif


