/* @<COPYRIGHT_START>@
 ===============================================
 Copyright 2007 UGS Corp. All Rights Reserved.
 ===============================================
 @<COPYRIGHT_END>@ */


/** 
    @file 

    This file contains the published identifiers of error codes that can be
    generated by this module. Obtaining and using the numeric values of these
    manifest constants is not supported. We reserve the right to change the
    actual values as necessary.

*/


#ifndef CONSTANTS_ERRORS_H
#define CONSTANTS_ERRORS_H

#include <common/emh_const.h>


/**
    @defgroup CONSTANTS_ERRORS Errors
    @ingroup CONSTANTS
    @{
*/

#define CONSTANTS_ERROR_BASE                         EMH_CONSTANTS_error_base

#define CONSTANTS_init_error                         (CONSTANTS_ERROR_BASE + 1)
#define CONSTANTS_cant_add_to_global_default_cache   (CONSTANTS_ERROR_BASE + 2)
#define CONSTANTS_cant_add_to_global_attach_cache    (CONSTANTS_ERROR_BASE + 3)
#define CONSTANTS_cant_add_to_type_default_cache     (CONSTANTS_ERROR_BASE + 4)
#define CONSTANTS_cant_add_to_type_attach_cache      (CONSTANTS_ERROR_BASE + 5)
#define CONSTANTS_cant_add_to_property_default_cache (CONSTANTS_ERROR_BASE + 6)
#define CONSTANTS_cant_add_to_property_attach_cache  (CONSTANTS_ERROR_BASE + 7)
#define CONSTANTS_error_finding_global_constant      (CONSTANTS_ERROR_BASE + 8)
#define CONSTANTS_error_global_constant_extent       (CONSTANTS_ERROR_BASE + 9)
#define CONSTANTS_error_get_global_const_attach_value (CONSTANTS_ERROR_BASE + 10)
#define CONSTANTS_error_get_global_const_def_value   (CONSTANTS_ERROR_BASE + 11)
#define CONSTANTS_error_get_global_constant_name     (CONSTANTS_ERROR_BASE + 12)
#define CONSTANTS_error_finding_type_constant        (CONSTANTS_ERROR_BASE + 13)
#define CONSTANTS_error_type_constant_extent         (CONSTANTS_ERROR_BASE + 14)
#define CONSTANTS_error_get_type_const_value         (CONSTANTS_ERROR_BASE + 15)
#define CONSTANTS_error_get_type_const_attach_value  (CONSTANTS_ERROR_BASE + 16)
#define CONSTANTS_error_get_type_const_def_value     (CONSTANTS_ERROR_BASE + 17)
#define CONSTANTS_error_get_type_constant_name       (CONSTANTS_ERROR_BASE + 18)
#define CONSTANTS_error_finding_prop_constant        (CONSTANTS_ERROR_BASE + 19)
#define CONSTANTS_error_prop_constant_extent         (CONSTANTS_ERROR_BASE + 20)
#define CONSTANTS_error_get_prop_const_value         (CONSTANTS_ERROR_BASE + 21)
#define CONSTANTS_error_get_prop_const_attach_value  (CONSTANTS_ERROR_BASE + 22)
#define CONSTANTS_error_get_prop_const_def_value     (CONSTANTS_ERROR_BASE + 23)
#define CONSTANTS_error_get_prop_constant_name       (CONSTANTS_ERROR_BASE + 24)
#define CONSTANTS_error_deleting_global_constant     (CONSTANTS_ERROR_BASE + 25)
#define CONSTANTS_error_deleting_type_constant       (CONSTANTS_ERROR_BASE + 26)
#define CONSTANTS_error_deleting_property_constant   (CONSTANTS_ERROR_BASE + 27)
#define CONSTANTS_error_is_mulitvalued               (CONSTANTS_ERROR_BASE + 28)
#define CONSTANTS_error_attach_value_null            (CONSTANTS_ERROR_BASE + 29)

/** @} */
#endif

