/*
   Copyright 2020 Siemens Digital Industries Software
   ==================================================
   Copyright 2008.
   Siemens Product Lifecycle Management Software Inc.
   All Rights Reserved.
   ==================================================
   Copyright 2020 Siemens Digital Industries Software
*/

/**
    @file

    The header file that defines the export symbols for the CONTMGMTBASE library

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#error ExportLibrary is defined to be EXPORTLIBRARY
#endif

#define EXPORTLIBRARY            libcontmgmtbase

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

#define CONTMGMTBASE_LIBRARY_NAME libcontmgmtbase
#define CONTMGMTBASE_LIBRARY_ID_NAME contmgmtbase

/* Handwritten code should use CONTMGMTBASE_API, not CONTMGMTBASEEXPORT */

#define CONTMGMTBASE_API CONTMGMTBASEEXPORT

/* Support CONTMGMTBASEEXPORT for autogenerated schema/pif code only */

#if IPLIB==CONTMGMTBASE_LIBRARY_NAME
#   if defined(__lint)
#       define CONTMGMTBASEEXPORT       __export(CONTMGMTBASE_LIBRARY_ID_NAME)
#       define CONTMGMTBASEGLOBAL       extern __global(CONTMGMTBASE_LIBRARY_ID_NAME)
#       define CONTMGMTBASEPRIVATE      extern __private(CONTMGMTBASE_LIBRARY_ID_NAME)
#   elif defined(_WIN32)
#       define CONTMGMTBASEEXPORT       __declspec(dllexport)
#       define CONTMGMTBASEGLOBAL       extern __declspec(dllexport)
#       define CONTMGMTBASEPRIVATE      extern
#   else
#       define CONTMGMTBASEEXPORT
#       define CONTMGMTBASEGLOBAL       extern
#       define CONTMGMTBASEPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CONTMGMTBASEEXPORT       __export(CONTMGMTBASE_LIBRARY_ID_NAME)
#       define CONTMGMTBASEGLOBAL       extern __global(CONTMGMTBASE_LIBRARY_ID_NAME)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CONTMGMTBASEEXPORT       __declspec(dllimport)
#       define CONTMGMTBASEGLOBAL       extern __declspec(dllimport)
#   else
#       define CONTMGMTBASEEXPORT
#       define CONTMGMTBASEGLOBAL       extern
#   endif
#endif
