/*==============================================================================
                Copyright (c) 2003-2005 UGS Corporation
                   Unpublished - All Rights Reserved
 ==============================================================================*/

/*
    File Description:

    The header file that defines the export symbols for the CXPOM library
 */

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libcxpom

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use CXPOM_API, not CXPOMEXPORT */

#define CXPOM_API CXPOMEXPORT

/* Support CXPOMEXPORT for autogenerated schema/pif code only */

#if IPLIB==libcxpom
#   if defined(__lint)
#       define CXPOMEXPORT       __export(cxpom)
#       define CXPOMGLOBAL       extern __global(cxpom)
#       define CXPOMPRIVATE      extern __private(cxpom)
#   elif defined(_WIN32)
#       define CXPOMEXPORT       __declspec(dllexport)
#       define CXPOMGLOBAL       extern __declspec(dllexport)
#       define CXPOMPRIVATE      extern
#   else
#       define CXPOMEXPORT
#       define CXPOMGLOBAL       extern
#       define CXPOMPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CXPOMEXPORT       __export(cxpom)
#       define CXPOMGLOBAL       extern __global(cxpom)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CXPOMEXPORT      __declspec(dllimport)
#       define CXPOMGLOBAL       extern __declspec(dllimport)
#   else
#       define CXPOMEXPORT
#       define CXPOMGLOBAL       extern
#   endif
#endif

