/*==================================================================================================
         Copyright (c) 2003 Electronic Data Systems Corporation
               Unpublished - All rights reserved

   THIS PROGRAM IS AN UNPUBLISHED WORK FULLY PROTECTED BY THE UNITED STATES
  COPYRIGHT LAWS AND IS CONSIDERED A TRADE SECRET BELONGING TO THE COPYRIGHT
                           HOLDER.
====================================================================================================
File description:   The header file that defines the export symbols for the
                    DISPATCHER library

      Filename:   libdispatcher_exports.h
      Module  :   DISPATCHER

====================================================================================================
   Date     Name               Description of Change
25-Sep-2003  bgast                   header file that defines the export symbols for the DISPATCHER library
21-Sep-2004  peschell                Added library_indicators header and associated value definition for libdispatcher
22-Sep-2004  peschell                Comment out include of library_exports.h, does not exist for 8.1.1 and does not contribute anything
25-Oct-2005  peschell                add module to include statements and enable library_indicators include
$HISTORY$
==================================================================================================*/
#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libdispatcher

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use DISPATCHER_API, not DISPATCHEREXPORT */

#define DISPATCHER_API DISPATCHEREXPORT

/* Support DISPATCHEREXPORT for autogenerated schema/pif code only */

#if IPLIB==libdispatcher
#   if defined(__lint)
#       define DISPATCHEREXPORT       __export(dispatcher)
#       define DISPATCHERGLOBAL       extern __global(dispatcher)
#       define DISPATCHERPRIVATE      extern __private(dispatcher)
#   elif defined(_WIN32)
#       define DISPATCHEREXPORT       __declspec(dllexport)
#       define DISPATCHERGLOBAL       extern __declspec(dllexport)
#       define DISPATCHERPRIVATE      extern
#   else
#       define DISPATCHEREXPORT
#       define DISPATCHERGLOBAL       extern
#       define DISPATCHERPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define DISPATCHEREXPORT       __export(dispatcher)
#       define DISPATCHERGLOBAL       extern __global(dispatcher)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define DISPATCHEREXPORT       __declspec(dllimport)
#       define DISPATCHERGLOBAL       extern __declspec(dllimport)
#   else
#       define DISPATCHEREXPORT
#       define DISPATCHERGLOBAL       extern
#   endif
#endif

