/*==============================================================================
                Copyright (c) 2003-2005 UGS Corporation
                   Unpublished - All Rights Reserved
 ==============================================================================*/

/*
    File Description:

    The header file that defines the export symbols for the DMI library
 */

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libdmi

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use DMI_API, not DMIEXPORT */

#define DMI_API DMIEXPORT

/* Support DMIEXPORT for autogenerated schema/pif code only */

#if IPLIB==libdmi
#   if defined(__lint)
#       define DMIEXPORT       __export(dmi)
#       define DMIGLOBAL       extern __global(dmi)
#       define DMIPRIVATE      extern __private(dmi)
#   elif defined(_WIN32)
#       define DMIEXPORT       __declspec(dllexport)
#       define DMIGLOBAL       extern __declspec(dllexport)
#       define DMIPRIVATE      extern
#   else
#       define DMIEXPORT
#       define DMIGLOBAL       extern
#       define DMIPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define DMIEXPORT       __export(dmi)
#       define DMIGLOBAL       extern __global(dmi)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define DMIEXPORT      __declspec(dllimport)
#       define DMIGLOBAL       extern __declspec(dllimport)
#   else
#       define DMIEXPORT
#       define DMIGLOBAL       extern
#   endif
#endif

