/*==============================================================================
                Copyright (c) 2003-2005 UGS Corporation
                   Unpublished - All Rights Reserved
 ==============================================================================*/

/*
    File Description:

    The header file that defines the export symbols for the EINT library
 */

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libeint

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use EINT_API, not EINTEXPORT */

#define EINT_API EINTEXPORT

/* Support EINTEXPORT for autogenerated schema/pif code only */

#if IPLIB==libeint
#   if defined(__lint)
#       define EINTEXPORT       __export(eint)
#       define EINTGLOBAL       extern __global(eint)
#       define EINTPRIVATE      extern __private(eint)
#   elif defined(_WIN32)
#       define EINTEXPORT       __declspec(dllexport)
#       define EINTGLOBAL       extern __declspec(dllexport)
#       define EINTPRIVATE      extern
#   else
#       define EINTEXPORT
#       define EINTGLOBAL       extern
#       define EINTPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define EINTEXPORT       __export(eint)
#       define EINTGLOBAL       extern __global(eint)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define EINTEXPORT      __declspec(dllimport)
#       define EINTGLOBAL       extern __declspec(dllimport)
#   else
#       define EINTEXPORT
#       define EINTGLOBAL       extern
#   endif
#endif

