/*==============================================================================
                Copyright (c) 2003-2005 UGS Corporation
                   Unpublished - All Rights Reserved
 ==============================================================================*/

/*
    File Description:

    The header file that defines the export symbols for the EDA library
 */

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libeintstub

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use EINTSTUB_API, not EINTSTUBEXPORT */

#define EINTSTUB_API EINTSTUBEXPORT

/* Support EINTSTUBEXPORT for autogenerated schema/pif code only */

#if IPLIB==libeintstub
#   if defined(__lint)
#       define EINTSTUBEXPORT       __export(eintstub)
#       define EINTSTUBGLOBAL       extern __global(eintstub)
#       define EINTSTUBPRIVATE      extern __private(eintstub)
#   elif defined(_WIN32)
#       define EINTSTUBEXPORT       __declspec(dllexport)
#       define EINTSTUBGLOBAL       extern __declspec(dllexport)
#       define EINTSTUBPRIVATE      extern
#   else
#       define EINTSTUBEXPORT
#       define EINTSTUBGLOBAL       extern
#       define EINTSTUBPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define EINTSTUBEXPORT       __export(eintstub)
#       define EINTSTUBGLOBAL       extern __global(eintstub)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define EINTSTUBEXPORT       __declspec(dllimport)
#       define EINTSTUBGLOBAL       extern __declspec(dllimport)
#   else
#       define EINTSTUBEXPORT
#       define EINTSTUBGLOBAL       extern
#   endif
#endif

