/*==============================================================================
                Copyright (c) 2003-2005 UGS Corporation
                   Unpublished - All Rights Reserved
 ==============================================================================*/

/*
    File Description:

    The header file that defines the export symbols for the FCLASSES library
 */

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libfclasses

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use FCLASSES_API, not FCLASSESEXPORT */

#define FCLASSES_API FCLASSESEXPORT

/* Support FCLASSESEXPORT for autogenerated schema/pif code only */

#if IPLIB==libfclasses
#   if defined(__lint)
#       define FCLASSESEXPORT       __export(fclasses)
#       define FCLASSESGLOBAL       extern __global(fclasses)
#       define FCLASSESPRIVATE      extern __private(fclasses)
#   elif defined(_WIN32)
#       define FCLASSESEXPORT       __declspec(dllexport)
#       define FCLASSESGLOBAL       extern __declspec(dllexport)
#       define FCLASSESPRIVATE      extern
#   else
#       define FCLASSESEXPORT
#       define FCLASSESGLOBAL       extern
#       define FCLASSESPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define FCLASSESEXPORT       __export(fclasses)
#       define FCLASSESGLOBAL       extern __global(fclasses)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define FCLASSESEXPORT      __declspec(dllimport)
#       define FCLASSESGLOBAL       extern __declspec(dllimport)
#   else
#       define FCLASSESEXPORT
#       define FCLASSESGLOBAL       extern
#   endif
#endif

