/*==============================================================================
                Copyright (c) 2003-2005 UGS Corporation
                   Unpublished - All Rights Reserved
 ==============================================================================*/

/*
    File Description:

    The header file that defines the export symbols for the FORM library
 */

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libform

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use FORM_API, not FORMEXPORT */

#define FORM_API FORMEXPORT

/* Support FORMEXPORT for autogenerated schema/pif code only */

#if IPLIB==libform
#   if defined(__lint)
#       define FORMEXPORT       __export(form)
#       define FORMGLOBAL       extern __global(form)
#       define FORMPRIVATE      extern __private(form)
#   elif defined(_WIN32)
#       define FORMEXPORT       __declspec(dllexport)
#       define FORMGLOBAL       extern __declspec(dllexport)
#       define FORMPRIVATE      extern
#   else
#       define FORMEXPORT
#       define FORMGLOBAL       extern
#       define FORMPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define FORMEXPORT       __export(form)
#       define FORMGLOBAL       extern __global(form)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define FORMEXPORT      __declspec(dllimport)
#       define FORMGLOBAL       extern __declspec(dllimport)
#   else
#       define FORMEXPORT
#       define FORMGLOBAL       extern
#   endif
#endif

