// Copyright 2020 Siemens Digital Industries Software
// ==================================================
// Copyright 2009.
// Siemens Product Lifecycle Management Software Inc.
// All Rights Reserved.
// ==================================================
// Copyright 2020 Siemens Digital Industries Software

/**
    @file

    The header file that defines the export symbols for the functionality library.
*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libfunctionality

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use FUNCTIONALITY_API, not FUNCTIONALITYEXPORT */

#define FUNCTIONALITY_API FUNCTIONALITYEXPORT

/* Support FUNCTIONALITYEXPORT for autogenerated schema/pif code only */

#if IPLIB==libfunctionality
#   if defined(__lint)
#       define FUNCTIONALITYEXPORT       __export(functionality)
#       define FUNCTIONALITYGLOBAL       extern __global(functionality)
#       define FUNCTIONALITYPRIVATE      extern __private(functionality)
#   elif defined(_WIN32)
#       define FUNCTIONALITYEXPORT       __declspec(dllexport)
#       define FUNCTIONALITYGLOBAL       extern __declspec(dllexport)
#       define FUNCTIONALITYPRIVATE      extern
#   else
#       define FUNCTIONALITYEXPORT
#       define FUNCTIONALITYGLOBAL       extern
#       define FUNCTIONALITYPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define FUNCTIONALITYEXPORT       __export(functionality)
#       define FUNCTIONALITYGLOBAL       extern __global(functionality)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define FUNCTIONALITYEXPORT      __declspec(dllimport)
#       define FUNCTIONALITYGLOBAL       extern __declspec(dllimport)
#   else
#       define FUNCTIONALITYEXPORT
#       define FUNCTIONALITYGLOBAL       extern
#   endif
#endif
