/*==============================================================================
                     Copyright (c) UGS Corporation
                   Unpublished - All Rights Reserved
 ==============================================================================*/

/**
    @file

    Header File defining the export symbols for gdis module
*/

/*  */


#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libgdis

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use GDIS_API, not GDISEXPORT */

#define GDIS_API GDISEXPORT

/* Support GDISEXPORT for autogenerated schema/pif code only */

#if IPLIB==libgdis
#   if defined(__lint)
#       define GDISEXPORT       __export(gdis)
#       define GDISGLOBAL       extern __global(gdis)
#       define GDISPRIVATE      extern __private(gdis)
#   elif defined(_WIN32)
#       define GDISEXPORT       __declspec(dllexport)
#       define GDISGLOBAL       extern __declspec(dllexport)
#       define GDISPRIVATE      extern
#   else
#       define GDISEXPORT
#       define GDISGLOBAL       extern
#       define GDISPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define GDISEXPORT       __export(gdis)
#       define GDISGLOBAL       extern __global(gdis)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define GDISEXPORT      __declspec(dllimport)
#       define GDISGLOBAL       extern __declspec(dllimport)
#   else
#       define GDISEXPORT
#       define GDISGLOBAL       extern
#   endif
#endif
