/*==============================================================================
                Copyright (c) 2003-2005 UGS Corporation
                   Unpublished - All Rights Reserved
 ==============================================================================*/

/*
    File Description:

    The header file that defines the export symbols for the GRM library
 */

#define libgrm                   -10031

#ifdef EXPORTLIBRARY
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libgrm

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use GRM_API, not GRMEXPORT */

#define GRM_API GRMEXPORT

/* Support GRMEXPORT for autogenerated code only */

#if IPLIB==libgrm
#   if defined(__lint)
#       define GRMEXPORT       __export(grm)
#       define GRMGLOBAL       extern __global(grm)
#       define GRMPRIVATE      extern __private(grm)
#   elif defined(_WIN32)
#       define GRMEXPORT       __declspec(dllexport)
#       define GRMGLOBAL       extern __declspec(dllexport)
#       define GRMPRIVATE      extern
#   else
#       define GRMEXPORT
#       define GRMGLOBAL       extern
#       define GRMPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define GRMEXPORT       __export(grm)
#       define GRMGLOBAL       extern __global(grm)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define GRMEXPORT      __declspec(dllimport)
#       define GRMGLOBAL       extern __declspec(dllimport)
#   else
#       define GRMEXPORT
#       define GRMGLOBAL       extern
#   endif
#endif
