/*==============================================================================
                Copyright (c) 2003-2005 UGS Corporation
                   Unpublished - All Rights Reserved
 ==============================================================================*/

/*
    File Description:

    The header file that defines the export symbols for the ICS library
 */

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libics

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use ICS_API, not ICSEXPORT */

#define ICS_API ICSEXPORT

/* Support ICSEXPORT for autogenerated schema/pif code only */

#if IPLIB==libics
#   if defined(__lint)
#       define ICSEXPORT       __export(ics)
#       define ICSGLOBAL       extern __global(ics)
#       define ICSPRIVATE      extern __private(ics)
#   elif defined(_WIN32)
#       define ICSEXPORT       __declspec(dllexport)
#       define ICSGLOBAL       extern __declspec(dllexport)
#       define ICSPRIVATE      extern
#   else
#       define ICSEXPORT
#       define ICSGLOBAL       extern
#       define ICSPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define ICSEXPORT       __export(ics)
#       define ICSGLOBAL       extern __global(ics)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define ICSEXPORT       __declspec(dllimport)
#       define ICSGLOBAL       extern __declspec(dllimport)
#   else
#       define ICSEXPORT
#       define ICSGLOBAL       extern
#   endif
#endif

