/*==============================================================================
                Copyright (c) 2003-2005 UGS Corporation
                   Unpublished - All Rights Reserved
 ==============================================================================*/

/*
    File Description:

    The header file that defines the export symbols for the ITK library
 */

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libitk

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use ITK_API, not ITKEXPORT */

#define ITK_API ITKEXPORT

/* Support ITKEXPORT for autogenerated schema/pif code only */

#if IPLIB==libitk
#   if defined(__lint)
#       define ITKEXPORT       __export(itk)
#       define ITKGLOBAL       extern __global(itk)
#       define ITKPRIVATE      extern __private(itk)
#   elif defined(_WIN32)
#       define ITKEXPORT       __declspec(dllexport)
#       define ITKGLOBAL       extern __declspec(dllexport)
#       define ITKPRIVATE      extern
#   else
#       define ITKEXPORT
#       define ITKGLOBAL       extern
#       define ITKPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define ITKEXPORT       __export(itk)
#       define ITKGLOBAL       extern __global(itk)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define ITKEXPORT      __declspec(dllimport)
#       define ITKGLOBAL       extern __declspec(dllimport)
#   else
#       define ITKEXPORT
#       define ITKGLOBAL       extern
#   endif
#endif

