/*==============================================================================
                Copyright (c) 2003-2005 UGS Corporation
                   Unpublished - All Rights Reserved
 ==============================================================================*/

/*
    File Description:

    The header file that defines the export symbols for the LOV library
 */

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            liblov

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use LOV_API, not LOVEXPORT */

#define LOV_API LOVEXPORT

/* Support LOVEXPORT for autogenerated schema/pif code only */

#if IPLIB==liblov
#   if defined(__lint)
#       define LOVEXPORT       __export(lov)
#       define LOVGLOBAL       extern __global(lov)
#       define LOVPRIVATE      extern __private(lov)
#   elif defined(_WIN32)
#       define LOVEXPORT       __declspec(dllexport)
#       define LOVGLOBAL       extern __declspec(dllexport)
#       define LOVPRIVATE      extern
#   else
#       define LOVEXPORT
#       define LOVGLOBAL       extern
#       define LOVPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define LOVEXPORT       __export(lov)
#       define LOVGLOBAL       extern __global(lov)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define LOVEXPORT      __declspec(dllimport)
#       define LOVGLOBAL       extern __declspec(dllimport)
#   else
#       define LOVEXPORT
#       define LOVGLOBAL       extern
#   endif
#endif

