/*HEAD LIBMES_EXPORTS HHH CMTMES */
/*=============================================================================
                Copyright (c) 2008 Unigraphics Solutions Inc.
                             Unpublished - All rights reserved
===============================================================================
File Description:

     The header file that defines the export symbols for the
     CMTMES library

===============================================================================
Date          Name                   Description
$HISTORY$
============================================================================*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libmes

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use CMTMES_API, not CMTMESEXPORT */

#define MES_API CMTMESEXPORT

/* Support CMTMESEXPORT for autogenerated schema/pif code only */

#if IPLIB==libmes
#   if defined(__lint)
#       define CMTMESEXPORT       __export(cmtmes)
#       define CMTMESGLOBAL       extern __global(cmtmes)
#       define CMTMESPRIVATE      extern __private(cmtmes)
#   elif defined(_WIN32)
#       define CMTMESEXPORT       __declspec(dllexport)
#       define CMTMESGLOBAL       extern __declspec(dllexport)
#       define CMTMESPRIVATE      extern
#   else
#       define CMTMESEXPORT
#       define CMTMESGLOBAL       extern
#       define CMTMESPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CMTMESEXPORT       __export(cmtmes)
#       define CMTMESGLOBAL       extern __global(cmtmes)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CMTMESEXPORT      __declspec(dllimport)
#       define CMTMESGLOBAL       extern __declspec(dllimport)
#   else
#       define CMTMESEXPORT
#       define CMTMESGLOBAL       extern
#   endif
#endif

