//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2009.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/**
    @file

File description:
     The header file that defines the export symbols for the MFG library
*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libmfg

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use MFG_API, not MFGEXPORT */

#define MFG_API MFGEXPORT

/* Support MFGEXPORT for autogenerated schema/pif code only */

#if IPLIB==libmfg
#   if defined(__lint)
#       define MFGEXPORT       __export(mfg)
#       define MFGGLOBAL       extern __global(mfg)
#       define MFGPRIVATE      extern __private(mfg)
#   elif defined(_WIN32)
#       define MFGEXPORT       __declspec(dllexport)
#       define MFGGLOBAL       extern __declspec(dllexport)
#       define MFGPRIVATE      extern
#   else
#       define MFGEXPORT
#       define MFGGLOBAL       extern
#       define MFGPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define MFGEXPORT       __export(mfg)
#       define MFGGLOBAL       extern __global(mfg)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define MFGEXPORT      __declspec(dllimport)
#       define MFGGLOBAL       extern __declspec(dllimport)
#   else
#       define MFGEXPORT
#       define MFGGLOBAL       extern
#   endif
#endif

