//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2009.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/**
    @file

File description:
     The header file that defines the export symbols for the MFGBVR library
*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libmfgbvr

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use MFGBVR_API, not MFGBVREXPORT */

#define MFGBVR_API MFGBVREXPORT

/* Support MFGBVREXPORT for autogenerated schema/pif code only */

#if IPLIB==libmfgbvr
#   if defined(__lint)
#       define MFGBVREXPORT       __export(mfgbvr)
#       define MFGBVRGLOBAL       extern __global(mfgbvr)
#       define MFGBVRPRIVATE      extern __private(mfgbvr)
#   elif defined(_WIN32)
#       define MFGBVREXPORT       __declspec(dllexport)
#       define MFGBVRGLOBAL       extern __declspec(dllexport)
#       define MFGBVRPRIVATE      extern
#   else
#       define MFGBVREXPORT
#       define MFGBVRGLOBAL       extern
#       define MFGBVRPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define MFGBVREXPORT       __export(mfgbvr)
#       define MFGBVRGLOBAL       extern __global(mfgbvr)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define MFGBVREXPORT      __declspec(dllimport)
#       define MFGBVRGLOBAL       extern __declspec(dllimport)
#   else
#       define MFGBVREXPORT
#       define MFGBVRGLOBAL       extern
#   endif
#endif

