/*==============================================================================
                Copyright (c) 2003-2005 UGS Corporation
                   Unpublished - All Rights Reserved
 ==============================================================================*/

/*
    File Description:

    The header file that defines the export symbols for the MGC library
 */

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libmgc

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use MGC_API, not MGCEXPORT */

#define MGC_API MGCEXPORT

/* Support MGCEXPORT for autogenerated schema/pif code only */

#if IPLIB==libmgc
#   if defined(__lint)
#       define MGCEXPORT       __export(mgc)
#       define MGCGLOBAL       extern __global(mgc)
#       define MGCPRIVATE      extern __private(mgc)
#   elif defined(_WIN32)
#       define MGCEXPORT       __declspec(dllexport)
#       define MGCGLOBAL       extern __declspec(dllexport)
#       define MGCPRIVATE      extern
#   else
#       define MGCEXPORT
#       define MGCGLOBAL       extern
#       define MGCPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define MGCEXPORT       __export(mgc)
#       define MGCGLOBAL       extern __global(mgc)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define MGCEXPORT      __declspec(dllimport)
#       define MGCGLOBAL       extern __declspec(dllimport)
#   else
#       define MGCEXPORT
#       define MGCGLOBAL       extern
#   endif
#endif

