
/*=============================================================================
 ===============================================================================
File Description:

    The header file that defines the export symbols for the
    MROCORE library

===============================================================================
Date                     Name                       Description

$HISTORY$
=============================================================================*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libmrocore

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use the MROCORE_API version, not MROCOREEXPORT */

#define MROCORE_API MROCOREEXPORT

/* Support MROCOREEXPORT for autogenerated schema/pif code only */

#if IPLIB==libmrocore
#   if defined(__lint)
#       define MROCOREEXPORT       __export(mrocore)
#       define MROCOREGLOBAL       extern __global(mrocore)
#       define MROCOREPRIVATE      extern __private(mrocore)
#   elif defined(_WIN32)
#       define MROCOREEXPORT       __declspec(dllexport)
#       define MROCOREGLOBAL       extern __declspec(dllexport)
#       define MROCOREPRIVATE      extern
#   else
#       define MROCOREEXPORT
#       define MROCOREGLOBAL       extern
#       define MROCOREPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define MROCOREEXPORT       __export(mrocore)
#       define MROCOREGLOBAL       extern __global(mrocore)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define MROCOREEXPORT       __declspec(dllimport)
#       define MROCOREGLOBAL       extern __declspec(dllimport)
#   else
#       define MROCOREEXPORT
#       define MROCOREGLOBAL       extern
#   endif
#endif
