/*==============================================================================
                Copyright (c) 2003-2005 UGS Corporation
                   Unpublished - All Rights Reserved
 ==============================================================================*/

/*
    File Description:

    The header file that defines the export symbols for the OBJIO library
 */

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libobjio

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use OBJIO_API, not OBJIOEXPORT */

#define OBJIO_API OBJIOEXPORT

/* Support OBJIOEXPORT for autogenerated schema/pif code only */

#if IPLIB==libobjio
#   if defined(__lint)
#       define OBJIOEXPORT       __export(objio)
#       define OBJIOGLOBAL       extern __global(objio)
#       define OBJIOPRIVATE      extern __private(objio)
#   elif defined(_WIN32)
#       define OBJIOEXPORT       __declspec(dllexport)
#       define OBJIOGLOBAL       extern __declspec(dllexport)
#       define OBJIOPRIVATE      extern
#   else
#       define OBJIOEXPORT
#       define OBJIOGLOBAL       extern
#       define OBJIOPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define OBJIOEXPORT       __export(objio)
#       define OBJIOGLOBAL       extern __global(objio)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define OBJIOEXPORT      __declspec(dllimport)
#       define OBJIOGLOBAL       extern __declspec(dllimport)
#   else
#       define OBJIOEXPORT
#       define OBJIOGLOBAL       extern
#   endif
#endif

