/*==============================================================================
                Copyright (c) 2003-2005 UGS Corporation
                   Unpublished - All Rights Reserved
 ==============================================================================*/

/**
    @file

    This file contains the publish identifiers of error codes that can be
    generated by this module. Obtaining and using the numeric values of these
    manifest constants is not supported. We reserve the right to change the
    actual values as necessary.
*/

/*  */

#ifndef OBJIO_SM_ERRORS_H
#define OBJIO_SM_ERRORS_H

#ifndef EMH_CONST_H
    #include <common/emh_const.h>
#endif

#include <objio/libobjio_exports.h>

/**
    @defgroup OBJIO_SM_ERRORS Errors
    @ingroup OBJIO_SM
    @{
*/

#define OBJIO_SM_error_base                     EMH_ARCHIVE_error_base

#define OBJIO_SM_unable_to_create               (OBJIO_SM_error_base + 1)
#define OBJIO_SM_invalid_type                   (OBJIO_SM_error_base + 2)
#define OBJIO_SM_unable_to_check_status         (OBJIO_SM_error_base + 3)
#define OBJIO_SM_no_selection                   (OBJIO_SM_error_base + 4)
#define OBJIO_SM_name_not_unique                (OBJIO_SM_error_base + 5)
#define OBJIO_SM_tape_os_err                    (OBJIO_SM_error_base + 6)
#define OBJIO_SM_tape_eot                       (OBJIO_SM_error_base + 7)
#define OBJIO_XML_delete_instances_failed       (OBJIO_SM_error_base + 8)
#define OBJIO_XML_create_instances_failed       (OBJIO_SM_error_base + 9)
#define OBJIO_XML_null_instance                 (OBJIO_SM_error_base + 10)
#define OBJIO_XML_save_instance_failed          (OBJIO_SM_error_base + 11)
#define OBJIO_XML_no_instances                  (OBJIO_SM_error_base + 12)
#define OBJIO_XML_no_scanner_object             (OBJIO_SM_error_base + 13)
#define OBJIO_XML_no_sa_privilege               (OBJIO_SM_error_base + 14)
#define OBJIO_XML_no_rules_to_populate          (OBJIO_SM_error_base + 15)
#define OBJIO_XML_init_platform_utils_failed    (OBJIO_SM_error_base + 16)
#define OBJIO_XML_invalid_xml_file              (OBJIO_SM_error_base + 17)
#define OBJIO_XML_failed_to_write_xml_file      (OBJIO_SM_error_base + 18)
#define OBJIO_XML_failed_to_parse_xml_file      (OBJIO_SM_error_base + 19)
#define OBJIO_XML_null_value_found              (OBJIO_SM_error_base + 20)
#define OBJIO_XML_failed_to_get_DTD_info        (OBJIO_SM_error_base + 21)
#define OBJIO_XML_dtd_missing_module_info       (OBJIO_SM_error_base + 22)
#define OBJIO_XML_create_default_tree_failed    (OBJIO_SM_error_base + 23)
#define OBJIO_XML_import_failed_restart_session (OBJIO_SM_error_base + 24)
#define OBJIO_SM_owning_org                     (OBJIO_SM_error_base + 25)
#define OBJIO_SM_owning_project                 (OBJIO_SM_error_base + 26)
#define OBJIO_SM_owning_project_invalid_name    (OBJIO_SM_error_base + 27)
#define OBJIO_SM_owning_project_invalid_security (OBJIO_SM_error_base + 28)

/** @} */

#include <objio/libobjio_undef.h>
#endif
