/*==============================================================================
                Copyright (c) 2003-2005 UGS Corporation
                   Unpublished - All Rights Reserved
 ==============================================================================*/

/*
    File Description:

    The header file that defines the export symbols for the PROPERTY library
 */

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libproperty

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use PROPERTY_API, not PROPERTYEXPORT */

#define PROPERTY_API PROPERTYEXPORT

/* Support PROPERTYEXPORT for autogenerated schema/pif code only */

#if IPLIB==libproperty
#   if defined(__lint)
#       define PROPERTYEXPORT       __export(property)
#       define PROPERTYGLOBAL       extern __global(property)
#       define PROPERTYPRIVATE      extern __private(property)
#   elif defined(_WIN32)
#       define PROPERTYEXPORT       __declspec(dllexport)
#       define PROPERTYGLOBAL       extern __declspec(dllexport)
#       define PROPERTYPRIVATE      extern
#   else
#       define PROPERTYEXPORT
#       define PROPERTYGLOBAL       extern
#       define PROPERTYPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define PROPERTYEXPORT       __export(property)
#       define PROPERTYGLOBAL       extern __global(property)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define PROPERTYEXPORT      __declspec(dllimport)
#       define PROPERTYGLOBAL       extern __declspec(dllimport)
#   else
#       define PROPERTYEXPORT
#       define PROPERTYGLOBAL       extern
#   endif
#endif

