/*==============================================================================
                Copyright (c) 2003-2005 UGS Corporation
                   Unpublished - All Rights Reserved
 ==============================================================================*/

/*
    File Description:

    The header file that defines the export symbols for the PS library
 */

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libps

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use PS_API, not PSEXPORT */

#define PS_API PSEXPORT

/* Support PSEXPORT for autogenerated schema/pif code only */

#if IPLIB==libps
#   if defined(__lint)
#       define PSEXPORT       __export(ps)
#       define PSGLOBAL       extern __global(ps)
#       define PSPRIVATE      extern __private(ps)
#   elif defined(_WIN32)
#       define PSEXPORT       __declspec(dllexport)
#       define PSGLOBAL       extern __declspec(dllexport)
#       define PSPRIVATE      extern
#   else
#       define PSEXPORT
#       define PSGLOBAL       extern
#       define PSPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define PSEXPORT       __export(ps)
#       define PSGLOBAL       extern __global(ps)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define PSEXPORT      __declspec(dllimport)
#       define PSGLOBAL       extern __declspec(dllimport)
#   else
#       define PSEXPORT
#       define PSGLOBAL       extern
#   endif
#endif

