/*==============================================================================
                Copyright (c) 2003-2005 UGS Corporation
                   Unpublished - All Rights Reserved
 ==============================================================================*/

/*
    File Description:

    The header file that defines the export symbols for the PUBLICATION library
 */

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libpublication

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use PUBLICATION_API, not PUBLICATIONEXPORT */

#define PUBLICATION_API PUBLICATIONEXPORT

/* Support PUBLICATIONEXPORT for autogenerated schema/pif code only */

#if IPLIB==libpublication
#   if defined(__lint)
#       define PUBLICATIONEXPORT       __export(publication)
#       define PUBLICATIONGLOBAL       extern __global(publication)
#       define PUBLICATIONPRIVATE      extern __private(publication)
#   elif defined(_WIN32)
#       define PUBLICATIONEXPORT       __declspec(dllexport)
#       define PUBLICATIONGLOBAL       extern __declspec(dllexport)
#       define PUBLICATIONPRIVATE      extern
#   else
#       define PUBLICATIONEXPORT
#       define PUBLICATIONGLOBAL       extern
#       define PUBLICATIONPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define PUBLICATIONEXPORT       __export(publication)
#       define PUBLICATIONGLOBAL       extern __global(publication)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define PUBLICATIONEXPORT      __declspec(dllimport)
#       define PUBLICATIONGLOBAL       extern __declspec(dllimport)
#   else
#       define PUBLICATIONEXPORT
#       define PUBLICATIONGLOBAL       extern
#   endif
#endif

