/*==============================================================================
                Copyright (c) 2003-2005 UGS Corporation
                   Unpublished - All Rights Reserved
 ==============================================================================*/

/*
    File Description:

    The header file that defines the export symbols for the QRY library
 */

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#error ExportLibrary was already defined to EXPORTLIBRARY
#define EXPORTLIBRARY something else
#endif

#define EXPORTLIBRARY            libqry

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use QRY_API, not QRYEXPORT */

#define QRY_API QRYEXPORT

/* Support QRYEXPORT for autogenerated schema/pif code only */

#if IPLIB==libqry
#   if defined(__lint)
#       define QRYEXPORT       __export(qry)
#       define QRYGLOBAL       extern __global(qry)
#       define QRYPRIVATE      extern __private(qry)
#   elif defined(_WIN32)
#       define QRYEXPORT       __declspec(dllexport)
#       define QRYGLOBAL       extern __declspec(dllexport)
#       define QRYPRIVATE      extern
#   else
#       define QRYEXPORT
#       define QRYGLOBAL       extern
#       define QRYPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define QRYEXPORT       __export(qry)
#       define QRYGLOBAL       extern __global(qry)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define QRYEXPORT      __declspec(dllimport)
#       define QRYGLOBAL       extern __declspec(dllimport)
#   else
#       define QRYEXPORT
#       define QRYGLOBAL       extern
#   endif
#endif

