// @<COPYRIGHT_START>@
// ===============================================
// Copyright 2008 Seimens Corp. All Rights Reserved.
// ===============================================
// @<COPYRIGHT_END>@

/** 
    @file 

    Define exports for libqsearch.
*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY             libqsearch

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use QSEARCH_API, not QSEARCHEXPORT */

#define QSEARCH_API QSEARCHEXPORT

/* Support QSEARCHEXPORT for autogenerated schema/pif code only */

#if IPLIB==libqsearch
#   if defined(__lint)
#       define QSEARCHEXPORT       __export(qsearch)
#       define QSEARCHGLOBAL       extern __global(qsearch)
#       define QSEARCHPRIVATE      extern __private(qsearch)
#   elif defined(_WIN32)
#       define QSEARCHEXPORT       __declspec(dllexport)
#       define QSEARCHGLOBAL       extern __declspec(dllexport)
#       define QSEARCHPRIVATE      extern
#   else
#       define QSEARCHEXPORT
#       define QSEARCHGLOBAL       extern
#       define QSEARCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define QSEARCHEXPORT       __export(qsearch)
#       define QSEARCHGLOBAL       extern __global(qsearch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define QSEARCHEXPORT      __declspec(dllimport)
#       define QSEARCHGLOBAL       extern __declspec(dllimport)
#   else
#       define QSEARCHEXPORT
#       define QSEARCHGLOBAL       extern
#   endif
#endif

