/*==============================================================================
                Copyright (c) 2003-2005 UGS Corporation
                   Unpublished - All Rights Reserved
 ==============================================================================*/

/*
    File Description:

    The header file that defines the export symbols for the RES library
 */

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libres

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use RES_API, not RESEXPORT */

#define RES_API RESEXPORT

/* Support RESEXPORT for autogenerated schema/pif code only */

#if IPLIB==libres
#   if defined(__lint)
#       define RESEXPORT       __export(res)
#       define RESGLOBAL       extern __global(res)
#       define RESPRIVATE      extern __private(res)
#   elif defined(_WIN32)
#       define RESEXPORT       __declspec(dllexport)
#       define RESGLOBAL       extern __declspec(dllexport)
#       define RESPRIVATE      extern
#   else
#       define RESEXPORT
#       define RESGLOBAL       extern
#       define RESPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define RESEXPORT       __export(res)
#       define RESGLOBAL       extern __global(res)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define RESEXPORT      __declspec(dllimport)
#       define RESGLOBAL       extern __declspec(dllimport)
#   else
#       define RESEXPORT
#       define RESGLOBAL       extern
#   endif
#endif

