/*==============================================================================
                Copyright (c) 2003-2005 UGS Corporation
                   Unpublished - All Rights Reserved
 ==============================================================================*/

/*
    File Description:

    The header file that defines the export symbols for the RWR library
 */

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            librwr

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use RWR_API, not RWREXPORT */

#define RWR_API RWREXPORT

/* Support RWREXPORT for autogenerated schema/pif code only */

#if IPLIB==librwr
#   if defined(__lint)
#       define RWREXPORT       __export(rwr)
#       define RWRGLOBAL       extern __global(rwr)
#       define RWRPRIVATE      extern __private(rwr)
#   elif defined(_WIN32)
#       define RWREXPORT       __declspec(dllexport)
#       define RWRGLOBAL       extern __declspec(dllexport)
#       define RWRPRIVATE      extern
#   else
#       define RWREXPORT
#       define RWRGLOBAL       extern
#       define RWRPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define RWREXPORT       __export(rwr)
#       define RWRGLOBAL       extern __global(rwr)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define RWREXPORT      __declspec(dllimport)
#       define RWRGLOBAL       extern __declspec(dllimport)
#   else
#       define RWREXPORT
#       define RWRGLOBAL       extern
#   endif
#endif

