/*==============================================================================
                Copyright (c) 2003-2005 UGS Corporation
                   Unpublished - All Rights Reserved
 ==============================================================================*/

/*
    File Description:

    The header file that defines the export symbols for the SA library
 */

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libsa

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use SA_API, not SAEXPORT */

#define SA_API SAEXPORT

/* Support SAEXPORT for autogenerated schema/pif code only */

#if IPLIB==libsa
#   if defined(__lint)
#       define SAEXPORT       __export(sa)
#       define SAGLOBAL       extern __global(sa)
#       define SAPRIVATE      extern __private(sa)
#   elif defined(_WIN32)
#       define SAEXPORT       __declspec(dllexport)
#       define SAGLOBAL       extern __declspec(dllexport)
#       define SAPRIVATE      extern
#   else
#       define SAEXPORT
#       define SAGLOBAL       extern
#       define SAPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define SAEXPORT       __export(sa)
#       define SAGLOBAL       extern __global(sa)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define SAEXPORT      __declspec(dllimport)
#       define SAGLOBAL       extern __declspec(dllimport)
#   else
#       define SAEXPORT
#       define SAGLOBAL       extern
#   endif
#endif

