/*==================================================================================================

                          Copyright (c) 2020 Siemens Product Lifecycle Management Software Inc.

====================================================================================================
File description:

    Filename: libsanitizer_undef.h
==================================================================================================*/

#ifndef libsanitizer
#define libsanitizer                     -21000
#endif

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libsanitizer

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use SANITIZER_API, not SANITIZEREXPORT */
#define SANITIZER_API SANITIZEREXPORT

/* Support SANITIZEREXPORT for autogenerated schema/pif code only */
#if IPLIB==libsanitizer
#   if defined(__lint)
#       define SANITIZEREXPORT       __export(sanitizer)
#       define SANITIZERGLOBAL       extern __global(sanitizer)
#       define SANITIZERPRIVATE      extern __private(sanitizer)
#   elif defined(_WIN32)
#       define SANITIZEREXPORT       __declspec(dllexport)
#       define SANITIZERGLOBAL       extern __declspec(dllexport)
#       define SANITIZERPRIVATE      extern
#   else
#       define SANITIZEREXPORT
#       define SANITIZERGLOBAL       extern
#       define SANITIZERPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define SANITIZEREXPORT       __export(sanitizer)
#       define SANITIZERGLOBAL       extern __global(sanitizer)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define SANITIZEREXPORT      __declspec(dllimport)
#       define SANITIZERGLOBAL       extern __declspec(dllimport)
#   else
#       define SANITIZEREXPORT
#       define SANITIZERGLOBAL       extern
#   endif
#endif
