// @<COPYRIGHT_START>@
// ===============================================
// Copyright 2006 UGS Corp. All Rights Reserved.
// ===============================================
// @<COPYRIGHT_END>@


/**
    @libschmgt_bridge_exports.h
    Export defines for the Schedule Management library

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libschmgt_bridge

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use SCHMGTBRI_API, not SCHMGTBRIEXPORT */
#define SCHMGTBRI_API SCHMGTBRIEXPORT

/* Support SCHMGTBRIEXPORT for autogenerated code only */
#if IPLIB==libschmgt_bridge
#   if defined(__lint)
#       define SCHMGTBRIEXPORT       __export(schmgt_bridge)
#       define SCHMGTBRIGLOBAL       extern __global(schmgt_bridge)
#       define SCHMGTBRIPRIVATE      extern __private(schmgt_bridge)
#   elif defined(_WIN32)
#       define SCHMGTBRIEXPORT       __declspec(dllexport)
#       define SCHMGTBRIGLOBAL       extern __declspec(dllexport)
#       define SCHMGTBRIPRIVATE      extern
#   else
#       define SCHMGTBRIEXPORT
#       define SCHMGTBRIGLOBAL       extern
#       define SCHMGTBRIPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define SCHMGTBRIEXPORT       __export(schmgt_bridge)
#       define SCHMGTBRIGLOBAL       extern __global(schmgt_bridge)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define SCHMGTBRIEXPORT      __declspec(dllimport)
#       define SCHMGTBRIGLOBAL       extern __declspec(dllimport)
#   else
#       define SCHMGTBRIEXPORT
#       define SCHMGTBRIGLOBAL       extern
#   endif
#endif
