
/*=============================================================================
 ===============================================================================
File Description:

    The header file that defines the export symbols for the
    SERVICEPLANNING library

===============================================================================
Date                     Name                       Description

$HISTORY$
=============================================================================*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libserviceplanning

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use the SERVICEPLANNING_API version, not SERVICEPLANNINGEXPORT */

#define SERVICEPLANNING_API SERVICEPLANNINGEXPORT

/* Support SERVICEPLANNINGEXPORT for autogenerated schema/pif code only */

#if IPLIB==libserviceplanning
#   if defined(__lint)
#       define SERVICEPLANNINGEXPORT       __export(serviceplanning)
#       define SERVICEPLANNINGGLOBAL       extern __global(serviceplanning)
#       define SERVICEPLANNINGPRIVATE      extern __private(serviceplanning)
#   elif defined(_WIN32)
#       define SERVICEPLANNINGEXPORT       __declspec(dllexport)
#       define SERVICEPLANNINGGLOBAL       extern __declspec(dllexport)
#       define SERVICEPLANNINGPRIVATE      extern
#   else
#       define SERVICEPLANNINGEXPORT
#       define SERVICEPLANNINGGLOBAL       extern
#       define SERVICEPLANNINGPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define SERVICEPLANNINGEXPORT       __export(serviceplanning)
#       define SERVICEPLANNINGGLOBAL       extern __global(serviceplanning)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define SERVICEPLANNINGEXPORT       __declspec(dllimport)
#       define SERVICEPLANNINGGLOBAL       extern __declspec(dllimport)
#   else
#       define SERVICEPLANNINGEXPORT
#       define SERVICEPLANNINGGLOBAL       extern
#   endif
#endif
