
/*=============================================================================
 ===============================================================================
File Description:

    The header file that defines the export symbols for the
    SERVICEPROCESSING library

===============================================================================
Date                     Name                       Description

$HISTORY$
=============================================================================*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libserviceprocessing

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use the serviceprocessing_API version, not serviceprocessingEXPORT */

#define SERVICEPROCESSING_API SERVICEPROCESSINGEXPORT

/* Support SERVICEPROCESSINGEXPORT for autogenerated schema/pif code only */

#if IPLIB==libserviceprocessing
#   if defined(__lint)
#       define SERVICEPROCESSINGEXPORT       __export(serviceprocessing)
#       define SERVICEPROCESSINGGLOBAL       extern __global(serviceprocessing)
#       define SERVICEPROCESSINGPRIVATE      extern __private(serviceprocessing)
#   elif defined(_WIN32)
#       define SERVICEPROCESSINGEXPORT       __declspec(dllexport)
#       define SERVICEPROCESSINGGLOBAL       extern __declspec(dllexport)
#       define SERVICEPROCESSINGPRIVATE      extern
#   else
#       define SERVICEPROCESSINGEXPORT
#       define SERVICEPROCESSINGGLOBAL       extern
#       define SERVICEPROCESSINGPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define SERVICEPROCESSINGEXPORT       __export(serviceprocessing)
#       define SERVICEPROCESSINGGLOBAL       extern __global(serviceprocessing)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define SERVICEPROCESSINGEXPORT       __declspec(dllimport)
#       define SERVICEPROCESSINGGLOBAL       extern __declspec(dllimport)
#   else
#       define SERVICEPROCESSINGEXPORT
#       define SERVICEPROCESSINGGLOBAL       extern
#   endif
#endif
