
/*=============================================================================
 ===============================================================================
File Description:

    The header file that defines the export symbols for the
    SERVICEPROCESSING library

===============================================================================
Date                     Name                       Description

$HISTORY$
=============================================================================*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libservicerequest

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use the servicerequest_API version, not servicerequestEXPORT */

#define SERVICEREQUEST_API SERVICEREQUESTEXPORT

/* Support SERVICEREQUESTEXPORT for autogenerated schema/pif code only */

#if IPLIB==libservicerequest
#   if defined(__lint)
#       define SERVICEREQUESTEXPORT       __export(servicerequest)
#       define SERVICEREQUESTGLOBAL       extern __global(servicerequest)
#       define SERVICEREQUESTPRIVATE      extern __private(servicerequest)
#   elif defined(_WIN32)
#       define SERVICEREQUESTEXPORT       __declspec(dllexport)
#       define SERVICEREQUESTGLOBAL       extern __declspec(dllexport)
#       define SERVICEREQUESTPRIVATE      extern
#   else
#       define SERVICEREQUESTEXPORT
#       define SERVICEREQUESTGLOBAL       extern
#       define SERVICEREQUESTPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define SERVICEREQUESTEXPORT       __export(servicerequest)
#       define SERVICEREQUESTGLOBAL       extern __global(servicerequest)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define SERVICEREQUESTEXPORT       __declspec(dllimport)
#       define SERVICEREQUESTGLOBAL       extern __declspec(dllimport)
#   else
#       define SERVICEREQUESTEXPORT
#       define SERVICEREQUESTGLOBAL       extern
#   endif
#endif
