// Copyright 2020 Siemens Digital Industries Software
// ==================================================
// Copyright 2010.
// Siemens Product Lifecycle Management Software Inc.
// All Rights Reserved.
// ==================================================
// Copyright 2020 Siemens Digital Industries Software


/** 
    @file 

    This file contains the published identifiers of error codes that can be
    generated by this module. Obtaining and using the numeric values of these
    manifest constants is not supported. We reserve the right to change the
    actual values as necessary.

*/

#ifndef SHAREDCACHETYPES_ERRORS_H
#define SHAREDCACHETYPES_ERRORS_H

#ifndef EMH_CONST_H
    #include <common/emh_const.h>
#endif

/**
    @defgroup SHAREDCACHETYPES_ERRORS SHAREDCACHETYPES Errors
    @ingroup SHAREDCACHETYPES
    @{
*/

#define SHAREDCACHETYPES_ERROR_BASE                  EMH_SHAREDCACHETYPES_error_base

#define SHAREDCACHETYPES_init_error                  (SHAREDCACHETYPES_ERROR_BASE + 1)
#define SHAREDCACHETYPES_file_error                  (SHAREDCACHETYPES_ERROR_BASE + 2)
#define SHAREDCACHETYPES_file_open_error             (SHAREDCACHETYPES_ERROR_BASE + 3)
#define SHAREDCACHETYPES_buffer_read_error           (SHAREDCACHETYPES_ERROR_BASE + 4)
#define SHAREDCACHETYPES_read_overflow_error         (SHAREDCACHETYPES_ERROR_BASE + 5)
#define SHAREDCACHETYPES_write_overflow_error        (SHAREDCACHETYPES_ERROR_BASE + 6)
#define SHAREDCACHETYPES_memory_allocation_error     (SHAREDCACHETYPES_ERROR_BASE + 7)
#define SHAREDCACHETYPES_buffer_size_invalid_error   (SHAREDCACHETYPES_ERROR_BASE + 8)
#define SHAREDCACHETYPES_classid_invalid_error       (SHAREDCACHETYPES_ERROR_BASE + 9)


/** @} */

#endif

