/*==============================================================================
                Copyright (c) 2003-2005 UGS Corporation
                   Unpublished - All Rights Reserved
 ==============================================================================*/

/*
    File Description:

    The header file that defines the export symbols for the TC library
 */

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libtc

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use TC_API, not TCEXPORT */

#define TC_API TCEXPORT

/* Support TCEXPORT for autogenerated schema/pif code only */

#if IPLIB==libtc
#   if defined(__lint)
#       define TCEXPORT       __export(iman)
#       define TCGLOBAL       extern __global(iman)
#       define TCPRIVATE      extern __private(iman)
#   elif defined(_WIN32)
#       define TCEXPORT       __declspec(dllexport)
#       define TCGLOBAL       extern __declspec(dllexport)
#       define TCPRIVATE      extern
#   else
#       define TCEXPORT
#       define TCGLOBAL       extern
#       define TCPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define TCEXPORT       __export(iman)
#       define TCGLOBAL       extern __global(iman)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define TCEXPORT      __declspec(dllimport)
#       define TCGLOBAL       extern __declspec(dllimport)
#   else
#       define TCEXPORT
#       define TCGLOBAL       extern
#   endif
#endif

