/*==============================================================================
                Copyright (c) 2003-2005 UGS Corporation
                   Unpublished - All Rights Reserved
 ==============================================================================*/

/**
    @file

    Log Manager errors
*/

/*  */

#ifndef LM_ERRORS_H
#define LM_ERRORS_H

/**
    @defgroup LM_ERRORS Errors
    @ingroup LM
    @{
*/

/** Log file busy */
#define LM_LOGBUSY      23001

/** Not open administration log */
#define LM_NOADMIN      23002

/** Not open application log */
#define LM_NOAPPL       23003

/** Administration log file busy */
#define LM_ADMINBUSY    23004

/** Application log file busy */
#define LM_APPLBUSY     23005

/** Installation log file busy */
#define LM_INSTLBUSY    23006

/** Not open installation log */
#define LM_NOINSTL      23007

/** Not open security log */
#define LM_NOSECUR      23008

/** Security log file busy */
#define LM_SECURBUSY    23009

/** Not open system log */
#define LM_NOSYSTM      23010

/** System log file busy */
#define LM_SYSTMBUSY    23011

/** @} */

#endif

