/*==============================================================================
                Copyright (c) 2003-2005 UGS Corporation
                   Unpublished - All Rights Reserved
 ==============================================================================*/

/**
    @file

    This file contains the publish identifiers of error codes that can be
    generated by this module. Obtaining and using the numeric values of these
    manifest constants is not supported. We reserve the right to change the
    actual values as necessary.
*/

/*  */

#ifndef ITEM_ERRORS_H
#define ITEM_ERRORS_H

#include <common/emh_const.h>

/**
    @defgroup ITEM_ERRORS Errors
    @ingroup ITEM
    @{
*/

#define ITEM_internal_error                     (EMH_ITEM_error_base + 1)
#define ITEM_initialization_failed              (EMH_ITEM_error_base + 2)
#define ITEM_unable_to_bind_attributes          (EMH_ITEM_error_base + 3)
#define ITEM_cannot_attach_to_self              (EMH_ITEM_error_base + 4)
#define ITEM_unable_to_create                   (EMH_ITEM_error_base + 5)
#define ITEM_unable_to_delete                   (EMH_ITEM_error_base + 6)
#define ITEM_unable_to_save                     (EMH_ITEM_error_base + 7)
#define ITEM_unable_to_find                     (EMH_ITEM_error_base + 8)
#define ITEM_unable_to_attach_object            (EMH_ITEM_error_base + 9)
#define ITEM_unable_to_detach_object            (EMH_ITEM_error_base + 10)
#define ITEM_invalid_attachment_type            (EMH_ITEM_error_base + 11)
#define ITEM_list_attachment_failed             (EMH_ITEM_error_base + 12)
#define ITEM_invalid_object                     (EMH_ITEM_error_base + 13)
#define ITEM_invalid_revision                   (EMH_ITEM_error_base + 14)
#define ITEM_same_parent_item                   (EMH_ITEM_error_base + 15)
#define ITEM_master_form_attached               (EMH_ITEM_error_base + 16)
#define ITEM_unable_to_create_form              (EMH_ITEM_error_base + 17)
#define ITEM_master_form_exists                 (EMH_ITEM_error_base + 18)
#define ITEM_invalid_master_form                (EMH_ITEM_error_base + 19)
#define ITEM_item_not_modifiable                (EMH_ITEM_error_base + 20)
#define ITEM_rev_not_modifiable                 (EMH_ITEM_error_base + 21)
#define ITEM_folder_not_allowed                 (EMH_ITEM_error_base + 22)
#define ITEM_dataset_only_rev0_allowed          (EMH_ITEM_error_base + 23)
#define ITEM_envelope_not_allowed               (EMH_ITEM_error_base + 24)
#define ITEM_bv_not_allowed                     (EMH_ITEM_error_base + 25)
#define ITEM_bvr_not_allowed                    (EMH_ITEM_error_base + 26)
#define ITEM_invalid_attch_object               (EMH_ITEM_error_base + 27)
#define ITEM_delete_master_form                 (EMH_ITEM_error_base + 28)
#define ITEM_restricted_relation                (EMH_ITEM_error_base + 29)
#define ITEM_already_owned                      (EMH_ITEM_error_base + 30)
#define ITEM_invalid_rev                        (EMH_ITEM_error_base + 31)
#define ITEM_rev_unable_to_create               (EMH_ITEM_error_base + 32)
#define ITEM_invalid_type                       (EMH_ITEM_error_base + 33)
#define ITEM_access_denied                      (EMH_ITEM_error_base + 34)
#define ITEM_delete_last_rev_failed             (EMH_ITEM_error_base + 35)
#define ITEM_attachment_already_exists          (EMH_ITEM_error_base + 36)
#define ITEM_rev_no_status                      (EMH_ITEM_error_base + 37)
/** The user "%1$" has already created the revision "%2$" on the Item "%3$" on date "%4$".*/
#define ITEM_duplicate_rev                      (EMH_ITEM_error_base + 38)
#define ITEM_cant_change_uom                    (EMH_ITEM_error_base + 39)
#define ITEM_used_in_structure                  (EMH_ITEM_error_base + 40)
#define ITEM_rev_is_released                    (EMH_ITEM_error_base + 41)
#define ITEM_item_not_allowed                   (EMH_ITEM_error_base + 42)
/** The Item "%1$" is not unique.*/
#define ITEM_duplicate_id                       (EMH_ITEM_error_base + 43)

/**
    @name Item ID Generator Errors
    @{
*/
#define ITEM_next_id_not_found                  (EMH_ITEM_error_base + 44)
#define ITEM_next_id_lock_failed                (EMH_ITEM_error_base + 45)
#define ITEM_illegal_parameter                  (EMH_ITEM_error_base + 46)
#define ITEM_mem_alloc_failed                   (EMH_ITEM_error_base + 47)
#define ITEM_max_id_exceeded                    (EMH_ITEM_error_base + 48)
#define ITEM_create_id_gen_failed               (EMH_ITEM_error_base + 49)
#define ITEM_copy_id_gen_failed                 (EMH_ITEM_error_base + 50)
#define ITEM_create_revid_gen_failed            (EMH_ITEM_error_base + 51)
#define ITEM_copy_revid_gen_failed              (EMH_ITEM_error_base + 52)
/** @} */

#define ITEM_itemrev_not_found                  (EMH_ITEM_error_base + 53)
#define ITEM_need_id_rev_name                   (EMH_ITEM_error_base + 54)
#define ITEM_duplicate_ids_found                (EMH_ITEM_error_base + 55)
#define ITEM_duplicate_rev_ids_found            (EMH_ITEM_error_base + 56)
#define ITEM_non_matching_uom                   (EMH_ITEM_error_base + 57)
#define ITEM_master_data_exists                 (EMH_ITEM_error_base + 58)
/** The dataset "%1$" of type "%2$" cannot be removed, because it is related to "%3$" ("%4$") which is used in an assembly.*/
#define ITEM_ugmaster_used_in_assy              (EMH_ITEM_error_base + 59)
#define ITEM_ugaltrep_used_in_assy              (EMH_ITEM_error_base + 60)

/**
    @name Baseline Errors
    @{
*/
#define ITEM_bl_invl_no_of_rel_levels           (EMH_ITEM_error_base + 61)
#define ITEM_bl_no_release_procedure            (EMH_ITEM_error_base + 62)
#define ITEM_bl_not_created                     (EMH_ITEM_error_base + 63)
/** @} */

#define ITEM_multiple_revs_one_status           (EMH_ITEM_error_base + 64)
#define ITEM_type_name_too_long                 (EMH_ITEM_error_base + 65)

/**
    @name Deep Copy Rule Errors
    @{
*/
#define ITEM_null_inputs_not_allowed            (EMH_ITEM_error_base + 66)
#define ITEM_revision_name_not_valid            (EMH_ITEM_error_base + 67)
#define ITEM_relation_type_not_valid            (EMH_ITEM_error_base + 68)
#define ITEM_attach_type_not_valid              (EMH_ITEM_error_base + 69)
#define ITEM_operation_type_not_valid           (EMH_ITEM_error_base + 70)
#define ITEM_copy_type_not_valid                (EMH_ITEM_error_base + 71)
#define ITEM_failed_to_create_dcrdefinition     (EMH_ITEM_error_base + 72)
#define ITEM_duplicate_rules                    (EMH_ITEM_error_base + 73)
#define ITEM_invalid_deepcopy_rule              (EMH_ITEM_error_base + 74)
#define ITEM_operation_and_copy_type_not_valid  (EMH_ITEM_error_base + 75)
#define ITEM_copy_and_attach_type_not_valid     (EMH_ITEM_error_base + 76)
/** @} */

/**
    @name Variant Item Errors
    @{
*/
#define ITEM_not_a_vi                           (EMH_ITEM_error_base + 100)
#define ITEM_bomline_does_not_have_sos          (EMH_ITEM_error_base + 101)
#define ITEM_vi_cannot_have_legacy_options      (EMH_ITEM_error_base + 102)
#define ITEM_sos_val_not_defined                (EMH_ITEM_error_base + 103)
#define ITEM_vi_already_unlinked                (EMH_ITEM_error_base + 104)
/** @} */

/**
    @name Global Alternate Errors
    @{
*/
#define ITEM_no_such_global_alternate           (EMH_ITEM_error_base + 106)
#define ITEM_duplicate_global_alternate         (EMH_ITEM_error_base + 107)
#define ITEM_cant_delete_preferred_globalalt    (EMH_ITEM_error_base + 108)
/** @} */

/**
    @name Baseline Errors
    @{
*/
#define ITEM_bl_nxbvr_not_in_sync               (EMH_ITEM_error_base + 109)
#define ITEM_bl_baserevision_released           (EMH_ITEM_error_base + 110)
/** @} */


/**
    @name Error message take type as input, so can be used for any type
    @{
*/
#define ALL_TYPE_internal_error                     (EMH_ITEM_error_base + 111)
#define ALL_TYPE_unable_to_find                     (EMH_ITEM_error_base + 112)
#define ALL_TYPE_invalid_type                       (EMH_ITEM_error_base + 113)
/** @} */

/**
    @name Part-Design errors
    @{
*/
#define PART_unable_to_reset_is_design_reqd                     (EMH_ITEM_error_base + 114)
#define PART_DESIGN_ASSO_unable_to_associate                    (EMH_ITEM_error_base + 115)
#define PART_DESIGN_ASSO_not_associated                         (EMH_ITEM_error_base + 116)

/** "%1$" Part does not require a Design. */
#define PART_not_require_design                                 (EMH_ITEM_error_base + 117)

#define PART_DESIGN_not_eligible                                (EMH_ITEM_error_base + 118)
#define PART_DESIGN_jt_file_not_present                         (EMH_ITEM_error_base + 119)
#define PART_DESIGN_xml_file_not_present                        (EMH_ITEM_error_base + 120)
#define PART_module_initialization_failed                       (EMH_ITEM_error_base + 121)
#define DESIGN_module_initialization_failed                     (EMH_ITEM_error_base + 122)
#define PART_DESIGN_already_primary                             (EMH_ITEM_error_base + 123)

/** "%1$" Design does not require a Part. */
#define DESIGN_not_require_part                                 (EMH_ITEM_error_base + 124)

/** The unalignment operation is not supported, as Part "%1$" is released. */
#define PART_DESIGN_unalign_not_supported_for_released_part     (EMH_ITEM_error_base + 125)

/** @} */

/**
    @name Sequence errors
    @{
*/
#define SEQUENCE_unable_to_purge                    (EMH_ITEM_error_base + 130)
#define SEQUENCE_unable_to_make_immune              (EMH_ITEM_error_base + 131)
#define SEQUENCE_unable_to_remove_immunity          (EMH_ITEM_error_base + 132)
#define SEQUENCE_action_invalid_for_active_sequence (EMH_ITEM_error_base + 133)
#define SEQUENCE_is_not_purgable                    (EMH_ITEM_error_base + 134)
#define SEQUENCE_is_not_immune                      (EMH_ITEM_error_base + 135)
#define SEQUENCE_is_already_immune                  (EMH_ITEM_error_base + 136)
#define SEQUENCE_illegal_revise                     (EMH_ITEM_error_base + 137)
#define SEQUENCE_unable_to_create_sequence          (EMH_ITEM_error_base + 138)
#define SEQUENCE_unable_to_restore_sequence         (EMH_ITEM_error_base + 139)
/** "Delete" is only valid for the latest sequence. Use "Purge" to remove the sequence "%1$". */
#define SEQUENCE_delete_invalid_use_purge_instead   (EMH_ITEM_error_base + 140)

/** @} */


/**
    @name ITEM_rev_delete_attached_dataset_failed
    @{
*/
#define ITEM_rev_delete_attached_dataset_failed     (EMH_ITEM_error_base + 150)
/** @} */


/**
    @name ITEM_multiple_revisions_one_status
    @{
*/
#define ITEM_multiple_revisions_one_status          (EMH_ITEM_error_base + 151)
/** @} */


/**
    @name Multiple Field Keys related errors
    @{
*/
#define ITEM_item_not_found                         (EMH_ITEM_error_base + 160)
#define ITEM_multiple_items_returned                (EMH_ITEM_error_base + 161)

/** An empty key string was found for the given Item "%1$". */
#define ITEM_empty_key_string                       (EMH_ITEM_error_base + 162)

/** @} */

/**
    @name Update Thumbnail errros
    @{
*/
#define THUMBNAIL_no_eligible_source                (EMH_ITEM_error_base + 170)
#define THUMBNAIL_generation_disabled               (EMH_ITEM_error_base + 171)
#define THUMBNAIL_source_is_not_a_dataset           (EMH_ITEM_error_base + 172)
#define THUMBNAIL_no_dispatcher_request             (EMH_ITEM_error_base + 173)
/** @} */

/**
    @name ITEM_rev_del_ref_var_exp
    @{
*/
#define ITEM_rev_preserve_variant_exp               (EMH_ITEM_error_base + 174)
/** @} */

/**
    @name ITEM_invalid_saveas_new_revision
    @{
*/
#define ITEM_invalid_saveas_new_revision               (EMH_ITEM_error_base + 175)
/** @} */

/**
    @name Commercial And Government Entity code related errors
    @{
*/
#define ITEM_invalid_cage_code                      (EMH_ITEM_error_base + 176)
#define ITEM_invalid_cage_warning                   (EMH_ITEM_error_base + 177)
/** @} */

/**
    @name Part-Design errors
    @{
*/
#define PART_is_invalid                             (EMH_ITEM_error_base + 178)
#define DESIGN_is_invalid                           (EMH_ITEM_error_base + 179)
/** @} */

/**
    @name Baseline error
    @{
*/
#define ITEM_bl_multiple_base_revs                  (EMH_ITEM_error_base + 180)
/** @} */

/**
    @name ITEM_rev_cut_not_allowed
    @{
*/
#define ITEM_rev_cut_not_allowed                    (EMH_ITEM_error_base + 181)
/** @} */
/**
    @name ITEM_insufficient_parameters
    @{
*/
#define ITEM_insufficient_parameters                (EMH_ITEM_error_base + 182)
/** @} */
/**
    @name ITEM_invalid_linkage_option
    @{
*/
#define ITEM_invalid_linkage_option                 (EMH_ITEM_error_base + 183)
/** @} */
/**
    @name ITEM_heterogeneous_types
    @{
*/
#define ITEM_heterogeneous_types                    (EMH_ITEM_error_base + 184)
/** @} */
/**
    @name ITEM_target_not_created
    @{
*/
#define ITEM_target_not_created                     (EMH_ITEM_error_base + 185)
/** @} */
/**
    @name Item Revision deletion errors
    @{
*/
/** The Item Revision "%1$" cannot be deleted, because it is linked to a Variant Item. Use the variant search function to locate the linked Variant Item. */
#define ITEM_revision_has_linked_vi                 (EMH_ITEM_error_base + 190)

/** The Item Revision "%1$" cannot be deleted, because it declares Options that are referenced. */
#define ITEM_revision_has_referenced_options        (EMH_ITEM_error_base + 191)

/** Participants could not be reassigned. Please consult the Teamcenter server syslog file for more details. */
#define ITEM_rev_failed_to_reassign_participants    (EMH_ITEM_error_base + 192)

/** The participant of type "%1$" could not be reassigned to the object "%2$". */
#define ITEM_rev_failed_to_reassign_participant_for_type    (EMH_ITEM_error_base + 193)

/** "%2$" cannot be reassigned, because the "%1$" participant is not assignable. */
#define ITEM_rev_participant_not_assignable          (EMH_ITEM_error_base + 194)

/** The selected Item cannot be added as its own global alternate. */
#define ITEM_cant_addItself_globalalt               (EMH_ITEM_error_base + 195)
/** @} */

/** The "Save As..." command has failed because there is no deep copy data for Item Revisions.*/
#define ITEM_copy_without_itemrevision               (EMH_ITEM_error_base + 196)

/** The preference "%1$" is not defined.*/
#define ITEM_preference_not_defined                  (EMH_ITEM_error_base + 197)

/** @} */

#endif
