// Copyright 2020 Siemens Digital Industries Software
// ==================================================
// Copyright 2009.
// Siemens Product Lifecycle Management Software Inc.
// All Rights Reserved.
// ==================================================
// Copyright 2020 Siemens Digital Industries Software
 
/** 
    @file 
    File Description:

    The header file that defines the export symbols for the TCinit library
*/

/*  */

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libtcinit

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use TCINIT_API, not TCINITEXPORT */

#define TCINIT_API TCINITEXPORT

/* Support TCINITEXPORT for autogenerated schema/pif code only */

#if IPLIB==libtcinit
#   if defined(__lint)
#       define TCINITEXPORT       __export(tcinit)
#       define TCINITGLOBAL       extern __global(tcinit)
#       define TCINITPRIVATE      extern __private(tcinit)
#   elif defined(_WIN32)
#       define TCINITEXPORT       __declspec(dllexport)
#       define TCINITGLOBAL       extern __declspec(dllexport)
#       define TCINITPRIVATE      extern
#   else
#       define TCINITEXPORT
#       define TCINITGLOBAL       extern
#       define TCINITPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define TCINITEXPORT       __export(tcinit)
#       define TCINITGLOBAL       extern __global(tcinit)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define TCINITEXPORT      __declspec(dllimport)
#       define TCINITGLOBAL       extern __declspec(dllimport)
#   else
#       define TCINITEXPORT
#       define TCINITGLOBAL       extern
#   endif
#endif

