/*==============================================================================
                Copyright (c) 2005 UGS Corporation
                   Unpublished - All Rights Reserved
 ==============================================================================*/

/*
    File Description:

    The header file that defines the export symbols for the USAGE library
 */

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libusage

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use USAGE_API, not USAGEEXPORT */

#define USAGE_API USAGEEXPORT

/* Support USAGEEXPORT for autogenerated schema/pif code only */

#if IPLIB==libusage
#   if defined(__lint)
#       define USAGEEXPORT       __export(usage)
#       define USAGEGLOBAL       extern __global(usage)
#       define USAGEPRIVATE      extern __private(usage)
#   elif defined(_WIN32)
#       define USAGEEXPORT       __declspec(dllexport)
#       define USAGEGLOBAL       extern __declspec(dllexport)
#       define USAGEPRIVATE      extern
#   else
#       define USAGEEXPORT
#       define USAGEGLOBAL       extern
#       define USAGEPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define USAGEEXPORT       __export(usage)
#       define USAGEGLOBAL       extern __global(usage)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define USAGEEXPORT      __declspec(dllimport)
#       define USAGEGLOBAL       extern __declspec(dllimport)
#   else
#       define USAGEEXPORT
#       define USAGEGLOBAL       extern
#   endif
#endif

