/*==============================================================================
                Copyright (c) 2005 UGS Corporation
                   Unpublished - All Rights Reserved
 ==============================================================================*/

/*
    File Description:

    The header file that defines the export symbols for the USAGEWC library
 */

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libusagewc

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use USAGEWC_API, not USAGEWCEXPORT */

#define USAGEWC_API USAGEWCEXPORT

/* Support USAGEWCEXPORT for autogenerated schema/pif code only */

#if IPLIB==libusagewc
#   if defined(__lint)
#       define USAGEWCEXPORT       __export(usagewc)
#       define USAGEWCGLOBAL       extern __global(usagewc)
#       define USAGEWCPRIVATE      extern __private(usagewc)
#   elif defined(_WIN32)
#       define USAGEWCEXPORT       __declspec(dllexport)
#       define USAGEWCGLOBAL       extern __declspec(dllexport)
#       define USAGEWCPRIVATE      extern
#   else
#       define USAGEWCEXPORT
#       define USAGEWCGLOBAL       extern
#       define USAGEWCPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define USAGEWCEXPORT       __export(usagewc)
#       define USAGEWCGLOBAL       extern __global(usagewc)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define USAGEWCEXPORT      __declspec(dllimport)
#       define USAGEWCGLOBAL       extern __declspec(dllimport)
#   else
#       define USAGEWCEXPORT
#       define USAGEWCGLOBAL       extern
#   endif
#endif

