/*==============================================================================
                Copyright (c) 2003-2005 UGS Corporation
                   Unpublished - All Rights Reserved
 ==============================================================================*/

/*
    File Description:

    The header file that defines the export symbols for the VALIDATION library
 */

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libvalidation

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use VALIDATION_API, not VALIDATIONEXPORT */

#define VALIDATION_API VALIDATIONEXPORT

/* Support VALIDATIONEXPORT for autogenerated schema/pif code only */

#if IPLIB==libvalidation
#   if defined(__lint)
#       define VALIDATIONEXPORT       __export(validation)
#       define VALIDATIONGLOBAL       extern __global(validation)
#       define VALIDATIONPRIVATE      extern __private(validation)
#   elif defined(_WIN32)
#       define VALIDATIONEXPORT       __declspec(dllexport)
#       define VALIDATIONGLOBAL       extern __declspec(dllexport)
#       define VALIDATIONPRIVATE      extern
#   else
#       define VALIDATIONEXPORT
#       define VALIDATIONGLOBAL       extern
#       define VALIDATIONPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define VALIDATIONEXPORT       __export(validation)
#       define VALIDATIONGLOBAL       extern __global(validation)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define VALIDATIONEXPORT      __declspec(dllimport)
#       define VALIDATIONGLOBAL       extern __declspec(dllimport)
#   else
#       define VALIDATIONEXPORT
#       define VALIDATIONGLOBAL       extern
#   endif
#endif
