/*HEAD LIBVISPUBLISH_EXPORTS HHH VISPUBLISH */
/*=============================================================================
                Copyright (c) 2004 UGS PLM Solutions
                             Unpublished - All rights reserved
===============================================================================
File Description:

     The header file that defines the export symbols for the
     VISPUBLISH library

===============================================================================
Date          Name                   Description
23-Jul-2004  guthrie                 Initial
20-Sep-2004  guthrie                 Merged from P10.0.0.3 and eug_p10.0.0.4
10-Oct-2005  guthrie                 Merged VisPub to 10.0.1
$HISTORY$
60============================================================================*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libvispublish

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten code should use VISPUBLISH_API, not VISPUBLISHEXPORT */

#define VISPUBLISH_API VISPUBLISHEXPORT

/* Support VISPUBLISHEXPORT for autogenerated schema/pif code only */

#if IPLIB==libvispublish
#   if defined(__lint)
#       define VISPUBLISHEXPORT       __export(publish)
#       define VISPUBLISHGLOBAL       extern __global(vispublish)
#       define VISPUBLISHPRIVATE      extern __private(vispublish)
#   elif defined(_WIN32)
#       define VISPUBLISHEXPORT       __declspec(dllexport)
#       define VISPUBLISHGLOBAL       extern __declspec(dllexport)
#       define VISPUBLISHPRIVATE      extern
#   else
#       define VISPUBLISHEXPORT
#       define VISPUBLISHGLOBAL       extern
#       define VISPUBLISHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define VISPUBLISHEXPORT       __export(vispublish)
#       define VISPUBLISHGLOBAL       extern __global(vispublish)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define VISPUBLISHEXPORT      __declspec(dllimport)
#       define VISPUBLISHGLOBAL       extern __declspec(dllimport)
#   else
#       define VISPUBLISHEXPORT
#       define VISPUBLISHGLOBAL       extern
#   endif
#endif

