
/*=============================================================================
 ===============================================================================
File Description:

    The header file that defines the export symbols for the
    visualization library

===============================================================================
Date                     Name                       Description
12-Mar-2007              Ram Narsimha               Initial Version
12-Mar-2007              Ram Kishore                Initial Version


$HISTORY$
=============================================================================*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libwproxy

#if !defined(IPLIB)
#   error IPLIB is not defined
#endif

/* Handwritten iMAN code should use the XXX_API version, not XXXEXPORT */

#define WPROXY_API WPROXYEXPORT

/* Support WPROXYEXPORT for autogenerated schema/pif code only */

#if IPLIB==libwproxy
#   if defined(__lint)
#       define WPROXYEXPORT       __export(wproxy)
#       define WPROXYGLOBAL       extern __global(wproxy)
#       define WPROXYPRIVATE      extern __private(wproxy)
#   elif defined(_WIN32)
#       define WPROXYEXPORT       __declspec(dllexport)
#       define WPROXYGLOBAL       extern __declspec(dllexport)
#       define WPROXYPRIVATE      extern
#   else
#       define WPROXYEXPORT
#       define WPROXYGLOBAL       extern
#       define WPROXYPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define WPROXYEXPORT       __export(wproxy)
#       define WPROXYGLOBAL       extern __global(wproxy)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define WPROXYEXPORT       __declspec(dllimport)
#       define WPROXYGLOBAL       extern __declspec(dllimport)
#   else
#       define WPROXYEXPORT
#       define WPROXYGLOBAL       extern
#   endif
#endif
