//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Aed0EngObjectElementDelegate
    Filename:   Aed0EngObjectElementDelegate.hxx
    Module:     Aed0automationelectricdesign
    @BMIDE autogenerated
==================================================================================================*/

#ifndef AED0AUTOMATIONELECTRICDESIGN__AED0ENGOBJECTELEMENTDELEGATE_HXX
#define AED0AUTOMATIONELECTRICDESIGN__AED0ENGOBJECTELEMENTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Aed0automationelectricdesign/Aed0EngObjectElement.hxx>

#include <Aed0automationelectricdesign/libaed0automationelectricdesign_exports.h>

namespace aed0automationelectricdesign
{
    class Aed0EngObjectElementDelegate;
}
namespace aed0automationelectricdesign
{
    class Aed0EngObjectElementImpl;
}
namespace aed0automationelectricdesign
{
    class Aed0EngObjectElement;
}
namespace aed0automationelectricdesign
{
    class Aed0EngObjectElementGenImpl;
}

namespace aed0automationelectricdesign_alias = ::aed0automationelectricdesign;


class  AED0AUTOMATIONELECTRICDESIGN_API aed0automationelectricdesign_alias::Aed0EngObjectElementDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Aed0EngObjectElementDelegate instance
    static Aed0EngObjectElementDelegate&  getInstance();

    //  Method to create the Aed0EngObjectElementImpl pointer
    static Aed0EngObjectElementImpl*  createImpl( Aed0EngObjectElement&  ifObj );

    //  Method to delete the Aed0EngObjectElementImpl pointer
    static void deleteImpl( Aed0EngObjectElementImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.2.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getAed0AttachedPortsBase(const Aed0EngObjectElement &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAed0CustProductNoBase(const Aed0EngObjectElement &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 13
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAed0CutLengthBase(const Aed0EngObjectElement &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAed0FuncParentMRDBase(const Aed0EngObjectElement &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAed0FunctionMRDBase(const Aed0EngObjectElement &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAed0FunctionSLRDBase(const Aed0EngObjectElement &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAed0GtinBase(const Aed0EngObjectElement &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAed0LocationMRDBase(const Aed0EngObjectElement &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAed0LocationSLRDBase(const Aed0EngObjectElement &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAed0LocParentMRDBase(const Aed0EngObjectElement &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAed0MfgNameBase(const Aed0EngObjectElement &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAed0MfgOrderNumberBase(const Aed0EngObjectElement &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAed0MfgShortDescBase(const Aed0EngObjectElement &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAed0MfgTypeBase(const Aed0EngObjectElement &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAed0NetWeightBase(const Aed0EngObjectElement &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAed0ParentRDSBase(const Aed0EngObjectElement &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAed0ProductMRDBase(const Aed0EngObjectElement &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAed0ProductParentMRDBase(const Aed0EngObjectElement &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAed0ProductSLRDBase(const Aed0EngObjectElement &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.6
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAed0RDSBase(const Aed0EngObjectElement &ifObj,  std::string &value, bool &isNull ) const;



protected:
    //  Pointer to the instance
    static Aed0EngObjectElementDelegate*  m_pInstance;

    Aed0EngObjectElementDelegate();
    virtual ~Aed0EngObjectElementDelegate();
    static void setInstance( Aed0EngObjectElementDelegate*  instance );


private:
    friend class  ::aed0automationelectricdesign::Aed0EngObjectElementGenImpl;

};

#include <Aed0automationelectricdesign/libaed0automationelectricdesign_undef.h>
#endif  //  AED0AUTOMATIONELECTRICDESIGN__AED0ENGOBJECTELEMENTDELEGATE_HXX
