//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//e
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ap0ArchCarVarsListDelegate
    Filename:   Ap0ArchCarVarsListDelegate.hxx
    Module:     Ap0advanceplanner
    @BMIDE autogenerated
==================================================================================================*/

#ifndef AP0ADVANCEPLANNER__AP0ARCHCARVARSLISTDELEGATE_HXX
#define AP0ADVANCEPLANNER__AP0ARCHCARVARSLISTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Ap0advanceplanner/Ap0ArchCarVarsList.hxx>

#include <Ap0advanceplanner/libap0advanceplanner_exports.h>

namespace ap0advanceplanner
{
    class Ap0ArchCarVarsListDelegate;
}
namespace ap0advanceplanner
{
    class Ap0ArchCarVarsListImpl;
}
namespace ap0advanceplanner
{
    class Ap0ArchCarVarsList;
}
namespace ap0advanceplanner
{
    class Ap0ArchCarVarsListGenImpl;
}

namespace ap0advanceplanner_alias = ::ap0advanceplanner;


class  AP0ADVANCEPLANNER_API ap0advanceplanner_alias::Ap0ArchCarVarsListDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Ap0ArchCarVarsListDelegate instance
    static Ap0ArchCarVarsListDelegate&  getInstance();

    //  Method to create the Ap0ArchCarVarsListImpl pointer
    static Ap0ArchCarVarsListImpl*  createImpl( Ap0ArchCarVarsList&  ifObj );

    //  Method to delete the Ap0ArchCarVarsListImpl pointer
    static void deleteImpl( Ap0ArchCarVarsListImpl*  impl );


    ///
    /// Returns List Of Values based on Dynamic LOV definition and user search criteria.
    /// @version Teamcenter 10
    /// @param operationInputTag - Operation Input containing the modified values.
    /// @param propertyName - Name of the selected property.
    /// @param searchString - User entered search string.
    /// @param sortByProp - Property to use for sorting.
    /// @param sortOrder - order for sorting (0=Ascending, 1=Descending).
    /// @param nResults - Number of returned results.
    /// @param results - Returned Values for LOV.
    /// @return - Zero (0) if everything is alright otherwise the error code.
    ///
    int  fnd0askLOVValuesBase(const Ap0ArchCarVarsList &ifObj,  const tag_t operationInputTag, const std::string *propertyName, const std::string *searchString, const char *sortByProp, const int sortOrder, int *nResults, tag_t **results ) const;



protected:
    //  Pointer to the instance
    static Ap0ArchCarVarsListDelegate*  m_pInstance;

    Ap0ArchCarVarsListDelegate();
    virtual ~Ap0ArchCarVarsListDelegate();
    static void setInstance( Ap0ArchCarVarsListDelegate*  instance );


private:
    friend class  ::ap0advanceplanner::Ap0ArchCarVarsListGenImpl;

};

#include <Ap0advanceplanner/libap0advanceplanner_undef.h>
#endif  //  AP0ADVANCEPLANNER__AP0ARCHCARVARSLISTDELEGATE_HXX
