//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Asp0Aspect
    Filename:   Asp0Aspect.hxx
    Module:     Asp0aspect
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ASP0ASPECT__ASP0ASPECT__HXX
#define TEAMCENTER__ASP0ASPECT__ASP0ASPECT__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0ModelElement.hxx>

#include <Asp0aspect/libasp0aspect_exports.h>

namespace Teamcenter
{
    namespace Asp0aspect
    {
        class Asp0Aspect;
    }
}
namespace Teamcenter
{
    namespace Asp0aspect
    {
        class Asp0AspectImpl;
    }
}
namespace Teamcenter
{
    namespace Asp0aspect
    {
        class Asp0AspectDelegate;
    }
}
namespace Teamcenter
{
    namespace Asp0aspect
    {
        class Asp0AspectDispatch;
    }
}
namespace Teamcenter
{
    namespace Asp0aspect
    {
        class Asp0AspectGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ASP0ASPECT_API  Teamcenter::Asp0aspect::Asp0Aspect
     : public  ::Teamcenter::AppModel::Mdl0ModelElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @deprecated Teamcenter::Asp0aspect::Asp0Aspect::setAsp0Parent deprecated in Teamcenter 11.5
    /// @return - Status. 0 if successful
    ///
    TC_DEPRECATED_WITH_DEPRECATION_INFO("Teamcenter 11.5","Teamcenter::Asp0aspect::Asp0Aspect::setAsp0Parent","The asp0Parent property has been deprecated in tc11.5.0. Please use asp0ParentObject instead.")
    int  setAsp0Parent( const tag_t &value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.5
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAsp0ParentObject( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Asp0Aspect();

    /**
     * Destructor
     */
    virtual ~Asp0Aspect();

private:
    //  Getter method for the Implementation Object
    Asp0AspectImpl*  getAsp0AspectImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAsp0AspectImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Asp0AspectImpl*  m_asp0aspectImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Asp0Aspect - desc for Asp0Aspect parameter
     */
    Asp0Aspect( const Asp0Aspect& );
    Asp0Aspect& operator=( const Asp0Aspect& );

    friend class  Asp0AspectDelegate;
    friend class  Asp0AspectDispatch;
    friend class  Asp0AspectGenImpl;
};

#include <Asp0aspect/libasp0aspect_undef.h>
#endif //   TEAMCENTER__ASP0ASPECT__ASP0ASPECT__HXX
