//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Asp0AspectDelegate
    Filename:   Asp0AspectDelegate.hxx
    Module:     Asp0aspect
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ASP0ASPECT__ASP0ASPECTDELEGATE_HXX
#define TEAMCENTER__ASP0ASPECT__ASP0ASPECTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Asp0aspect/Asp0Aspect.hxx>

#include <Asp0aspect/libasp0aspect_exports.h>

namespace Teamcenter
{
    namespace Asp0aspect
    {
        class Asp0AspectDelegate;
    }
}
namespace Teamcenter
{
    namespace Asp0aspect
    {
        class Asp0AspectImpl;
    }
}
namespace Teamcenter
{
    namespace Asp0aspect
    {
        class Asp0Aspect;
    }
}
namespace Teamcenter
{
    namespace Asp0aspect
    {
        class Asp0AspectGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  ASP0ASPECT_API Teamcenter_alias::Asp0aspect::Asp0AspectDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Asp0AspectDelegate instance
    static Asp0AspectDelegate&  getInstance();

    //  Method to create the Asp0AspectImpl pointer
    static Asp0AspectImpl*  createImpl( Asp0Aspect&  ifObj );

    //  Method to delete the Asp0AspectImpl pointer
    static void deleteImpl( Asp0AspectImpl*  impl );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @deprecated Teamcenter::Asp0aspect::Asp0Aspect::setAsp0Parent deprecated in Teamcenter 11.5
    /// @return - Status. 0 if successful
    ///
    TC_DEPRECATED_WITH_DEPRECATION_INFO("Teamcenter 11.5","Teamcenter::Asp0aspect::Asp0Aspect::setAsp0Parent","The asp0Parent property has been deprecated in tc11.5.0. Please use asp0ParentObject instead.")
    int  setAsp0ParentBase(Asp0Aspect &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.5
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAsp0ParentObjectBase(Asp0Aspect &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Asp0Aspect &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be created
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0FinalizeCreateInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.3
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0SaveAsPostBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.3
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0ValidateSaveAsInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// Generic saveAsPost operation.
    /// @version Teamcenter 8.1
    /// @param pSavAsInput - Input argument as SaveAsInput object.
    /// @param vecDeepCopyData - vector deepcopy data
    /// @return - Return integer value.
    ///
    int  saveAsPostBase(const Asp0Aspect &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// validate saveas input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  validateSaveAsInputBase(const Asp0Aspect &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static Asp0AspectDelegate*  m_pInstance;

    Asp0AspectDelegate();
    virtual ~Asp0AspectDelegate();
    static void setInstance( Asp0AspectDelegate*  instance );


private:
    friend class  ::Teamcenter::Asp0aspect::Asp0AspectGenImpl;

};

#include <Asp0aspect/libasp0aspect_undef.h>
#endif  //  TEAMCENTER__ASP0ASPECT__ASP0ASPECTDELEGATE_HXX
