//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Asp0AspectScheme
    Filename:   Asp0AspectScheme.hxx
    Module:     Asp0aspect
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ASP0ASPECT__ASP0ASPECTSCHEME__HXX
#define TEAMCENTER__ASP0ASPECT__ASP0ASPECTSCHEME__HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0ModelElement.hxx>

#include <Asp0aspect/libasp0aspect_exports.h>

namespace Teamcenter
{
    namespace Asp0aspect
    {
        class Asp0AspectScheme;
    }
}
namespace Teamcenter
{
    namespace Asp0aspect
    {
        class Asp0AspectSchemeImpl;
    }
}
namespace Teamcenter
{
    namespace Asp0aspect
    {
        class Asp0AspectSchemeDelegate;
    }
}
namespace Teamcenter
{
    namespace Asp0aspect
    {
        class Asp0AspectSchemeDispatch;
    }
}
namespace Teamcenter
{
    namespace Asp0aspect
    {
        class Asp0AspectSchemeGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ASP0ASPECT_API  Teamcenter::Asp0aspect::Asp0AspectScheme
     : public  ::Teamcenter::AppModel::Mdl0ModelElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Asp0AspectScheme();

    /**
     * Destructor
     */
    virtual ~Asp0AspectScheme();

private:
    //  Getter method for the Implementation Object
    Asp0AspectSchemeImpl*  getAsp0AspectSchemeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAsp0AspectSchemeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Asp0AspectSchemeImpl*  m_asp0aspectschemeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Asp0AspectScheme - desc for Asp0AspectScheme parameter
     */
    Asp0AspectScheme( const Asp0AspectScheme& );
    Asp0AspectScheme& operator=( const Asp0AspectScheme& );

    friend class  Asp0AspectSchemeDelegate;
    friend class  Asp0AspectSchemeDispatch;
    friend class  Asp0AspectSchemeGenImpl;
};

#include <Asp0aspect/libasp0aspect_undef.h>
#endif //   TEAMCENTER__ASP0ASPECT__ASP0ASPECTSCHEME__HXX
