//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Asp0AspectSchemeDelegate
    Filename:   Asp0AspectSchemeDelegate.hxx
    Module:     Asp0aspect
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ASP0ASPECT__ASP0ASPECTSCHEMEDELEGATE_HXX
#define TEAMCENTER__ASP0ASPECT__ASP0ASPECTSCHEMEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Asp0aspect/Asp0AspectScheme.hxx>

#include <Asp0aspect/libasp0aspect_exports.h>

namespace Teamcenter
{
    namespace Asp0aspect
    {
        class Asp0AspectSchemeDelegate;
    }
}
namespace Teamcenter
{
    namespace Asp0aspect
    {
        class Asp0AspectSchemeImpl;
    }
}
namespace Teamcenter
{
    namespace Asp0aspect
    {
        class Asp0AspectScheme;
    }
}
namespace Teamcenter
{
    namespace Asp0aspect
    {
        class Asp0AspectSchemeGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  ASP0ASPECT_API Teamcenter_alias::Asp0aspect::Asp0AspectSchemeDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Asp0AspectSchemeDelegate instance
    static Asp0AspectSchemeDelegate&  getInstance();

    //  Method to create the Asp0AspectSchemeImpl pointer
    static Asp0AspectSchemeImpl*  createImpl( Asp0AspectScheme&  ifObj );

    //  Method to delete the Asp0AspectSchemeImpl pointer
    static void deleteImpl( Asp0AspectSchemeImpl*  impl );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Asp0AspectScheme &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0CreatePostBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static Asp0AspectSchemeDelegate*  m_pInstance;

    Asp0AspectSchemeDelegate();
    virtual ~Asp0AspectSchemeDelegate();
    static void setInstance( Asp0AspectSchemeDelegate*  instance );


private:
    friend class  ::Teamcenter::Asp0aspect::Asp0AspectSchemeGenImpl;

};

#include <Asp0aspect/libasp0aspect_undef.h>
#endif  //  TEAMCENTER__ASP0ASPECT__ASP0ASPECTSCHEMEDELEGATE_HXX
