//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Asp0AspectSearchDef
    Filename:   Asp0AspectSearchDef.hxx
    Module:     Asp0aspect
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ASP0ASPECT__ASP0ASPECTSEARCHDEF__HXX
#define TEAMCENTER__ASP0ASPECT__ASP0ASPECTSEARCHDEF__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0SearchDef.hxx>

#include <Asp0aspect/libasp0aspect_exports.h>

namespace Teamcenter
{
    namespace Asp0aspect
    {
        class Asp0AspectSearchDef;
    }
}
namespace Teamcenter
{
    namespace Asp0aspect
    {
        class Asp0AspectSearchDefImpl;
    }
}
namespace Teamcenter
{
    namespace Asp0aspect
    {
        class Asp0AspectSearchDefDelegate;
    }
}
namespace Teamcenter
{
    namespace Asp0aspect
    {
        class Asp0AspectSearchDefDispatch;
    }
}
namespace Teamcenter
{
    namespace Asp0aspect
    {
        class Asp0AspectSearchDefGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ASP0ASPECT_API  Teamcenter::Asp0aspect::Asp0AspectSearchDef
     : public  ::Teamcenter::AppModel::Mdl0SearchDef
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.5
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getAsp0AspectList( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAsp0LevelsToTraverse( int &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAsp0TraverseDown( bool &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 11.5
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setAsp0AspectList( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 11.5
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAsp0LevelsToTraverse( int value, bool isNull=false );

    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 11.5
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAsp0TraverseDown( bool value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Asp0AspectSearchDef();

    /**
     * Destructor
     */
    virtual ~Asp0AspectSearchDef();

private:
    //  Getter method for the Implementation Object
    Asp0AspectSearchDefImpl*  getAsp0AspectSearchDefImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAsp0AspectSearchDefImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Asp0AspectSearchDefImpl*  m_asp0aspectsearchdefImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Asp0AspectSearchDef - desc for Asp0AspectSearchDef parameter
     */
    Asp0AspectSearchDef( const Asp0AspectSearchDef& );
    Asp0AspectSearchDef& operator=( const Asp0AspectSearchDef& );

    friend class  Asp0AspectSearchDefDelegate;
    friend class  Asp0AspectSearchDefDispatch;
    friend class  Asp0AspectSearchDefGenImpl;
};

#include <Asp0aspect/libasp0aspect_undef.h>
#endif //   TEAMCENTER__ASP0ASPECT__ASP0ASPECTSEARCHDEF__HXX
