//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Asp0AspectSearchDefDelegate
    Filename:   Asp0AspectSearchDefDelegate.hxx
    Module:     Asp0aspect
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ASP0ASPECT__ASP0ASPECTSEARCHDEFDELEGATE_HXX
#define TEAMCENTER__ASP0ASPECT__ASP0ASPECTSEARCHDEFDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Asp0aspect/Asp0AspectSearchDef.hxx>

#include <Asp0aspect/libasp0aspect_exports.h>

namespace Teamcenter
{
    namespace Asp0aspect
    {
        class Asp0AspectSearchDefDelegate;
    }
}
namespace Teamcenter
{
    namespace Asp0aspect
    {
        class Asp0AspectSearchDefImpl;
    }
}
namespace Teamcenter
{
    namespace Asp0aspect
    {
        class Asp0AspectSearchDef;
    }
}
namespace Teamcenter
{
    namespace Asp0aspect
    {
        class Asp0AspectSearchDefGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  ASP0ASPECT_API Teamcenter_alias::Asp0aspect::Asp0AspectSearchDefDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Asp0AspectSearchDefDelegate instance
    static Asp0AspectSearchDefDelegate&  getInstance();

    //  Method to create the Asp0AspectSearchDefImpl pointer
    static Asp0AspectSearchDefImpl*  createImpl( Asp0AspectSearchDef&  ifObj );

    //  Method to delete the Asp0AspectSearchDefImpl pointer
    static void deleteImpl( Asp0AspectSearchDefImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.5
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getAsp0AspectListBase(const Asp0AspectSearchDef &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAsp0LevelsToTraverseBase(const Asp0AspectSearchDef &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAsp0TraverseDownBase(const Asp0AspectSearchDef &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 11.5
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setAsp0AspectListBase(Asp0AspectSearchDef &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 11.5
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAsp0LevelsToTraverseBase(Asp0AspectSearchDef &ifObj,  int value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 11.5
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAsp0TraverseDownBase(Asp0AspectSearchDef &ifObj,  bool value, bool isNull );


    ///
    /// Generates permanent ID/recipe. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param recipe - Permanent ID/recipe
    /// @return - Failure code.
    ///
    int  fnd0GenerateRecipeBase(const Asp0AspectSearchDef &ifObj,  std::string *recipe );



protected:
    //  Pointer to the instance
    static Asp0AspectSearchDefDelegate*  m_pInstance;

    Asp0AspectSearchDefDelegate();
    virtual ~Asp0AspectSearchDefDelegate();
    static void setInstance( Asp0AspectSearchDefDelegate*  instance );


private:
    friend class  ::Teamcenter::Asp0aspect::Asp0AspectSearchDefGenImpl;

};

#include <Asp0aspect/libasp0aspect_undef.h>
#endif  //  TEAMCENTER__ASP0ASPECT__ASP0ASPECTSEARCHDEFDELEGATE_HXX
