//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Att0AbstractMapping
    Filename:   Att0AbstractMapping.hxx
    Module:     Att0attrtargetmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef ATT0ATTRTARGETMGMT__ATT0ABSTRACTMAPPING__HXX
#define ATT0ATTRTARGETMGMT__ATT0ABSTRACTMAPPING__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_exports.h>

namespace att0attrtargetmgmt
{
    class Att0AbstractMapping;
}
namespace att0attrtargetmgmt
{
    class Att0AbstractMappingImpl;
}
namespace att0attrtargetmgmt
{
    class Att0AbstractMappingDelegate;
}
namespace att0attrtargetmgmt
{
    class Att0AbstractMappingDispatch;
}
namespace att0attrtargetmgmt
{
    class Att0AbstractMappingGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ATT0ATTRTARGETMGMT_API  att0attrtargetmgmt::Att0AbstractMapping
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.4
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getAtt0Alignments( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Att0AbstractMapping();

    /**
     * Destructor
     */
    virtual ~Att0AbstractMapping();

private:
    //  Getter method for the Implementation Object
    Att0AbstractMappingImpl*  getAtt0AbstractMappingImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAtt0AbstractMappingImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Att0AbstractMappingImpl*  m_att0abstractmappingImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Att0AbstractMapping - desc for Att0AbstractMapping parameter
     */
    Att0AbstractMapping( const Att0AbstractMapping& );
    Att0AbstractMapping& operator=( const Att0AbstractMapping& );

    friend class  Att0AbstractMappingDelegate;
    friend class  Att0AbstractMappingDispatch;
    friend class  Att0AbstractMappingGenImpl;
};

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_undef.h>
#endif //   ATT0ATTRTARGETMGMT__ATT0ABSTRACTMAPPING__HXX
