//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Att0AbstractMappingDelegate
    Filename:   Att0AbstractMappingDelegate.hxx
    Module:     Att0attrtargetmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef ATT0ATTRTARGETMGMT__ATT0ABSTRACTMAPPINGDELEGATE_HXX
#define ATT0ATTRTARGETMGMT__ATT0ABSTRACTMAPPINGDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Att0attrtargetmgmt/Att0AbstractMapping.hxx>

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_exports.h>

namespace att0attrtargetmgmt
{
    class Att0AbstractMappingDelegate;
}
namespace att0attrtargetmgmt
{
    class Att0AbstractMappingImpl;
}
namespace att0attrtargetmgmt
{
    class Att0AbstractMapping;
}
namespace att0attrtargetmgmt
{
    class Att0AbstractMappingGenImpl;
}

namespace att0attrtargetmgmt_alias = ::att0attrtargetmgmt;


class  ATT0ATTRTARGETMGMT_API att0attrtargetmgmt_alias::Att0AbstractMappingDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Att0AbstractMappingDelegate instance
    static Att0AbstractMappingDelegate&  getInstance();

    //  Method to create the Att0AbstractMappingImpl pointer
    static Att0AbstractMappingImpl*  createImpl( Att0AbstractMapping&  ifObj );

    //  Method to delete the Att0AbstractMappingImpl pointer
    static void deleteImpl( Att0AbstractMappingImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.4
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getAtt0AlignmentsBase(const Att0AbstractMapping &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Att0AbstractMapping &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Att0AbstractMappingDelegate*  m_pInstance;

    Att0AbstractMappingDelegate();
    virtual ~Att0AbstractMappingDelegate();
    static void setInstance( Att0AbstractMappingDelegate*  instance );


private:
    friend class  ::att0attrtargetmgmt::Att0AbstractMappingGenImpl;

};

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_undef.h>
#endif  //  ATT0ATTRTARGETMGMT__ATT0ABSTRACTMAPPINGDELEGATE_HXX
