//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Att0AttributeDefDelegate
    Filename:   Att0AttributeDefDelegate.hxx
    Module:     Att0attrtargetmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef ATT0ATTRTARGETMGMT__ATT0ATTRIBUTEDEFDELEGATE_HXX
#define ATT0ATTRTARGETMGMT__ATT0ATTRIBUTEDEFDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Att0attrtargetmgmt/Att0AttributeDef.hxx>

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_exports.h>

namespace att0attrtargetmgmt
{
    class Att0AttributeDefDelegate;
}
namespace att0attrtargetmgmt
{
    class Att0AttributeDefImpl;
}
namespace att0attrtargetmgmt
{
    class Att0AttributeDef;
}
namespace att0attrtargetmgmt
{
    class Att0AttributeDefGenImpl;
}

namespace att0attrtargetmgmt_alias = ::att0attrtargetmgmt;


class  ATT0ATTRTARGETMGMT_API att0attrtargetmgmt_alias::Att0AttributeDefDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Att0AttributeDefDelegate instance
    static Att0AttributeDefDelegate&  getInstance();

    //  Method to create the Att0AttributeDefImpl pointer
    static Att0AttributeDefImpl*  createImpl( Att0AttributeDef&  ifObj );

    //  Method to delete the Att0AttributeDefImpl pointer
    static void deleteImpl( Att0AttributeDefImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Att0AttributeDef &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// validate saveas input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  validateSaveAsInputBase(const Att0AttributeDef &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setObject_nameBase(Att0AttributeDef &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setUom_tagBase(Att0AttributeDef &ifObj,  const tag_t &value, bool isNull );



protected:
    //  Pointer to the instance
    static Att0AttributeDefDelegate*  m_pInstance;

    Att0AttributeDefDelegate();
    virtual ~Att0AttributeDefDelegate();
    static void setInstance( Att0AttributeDefDelegate*  instance );


private:
    friend class  ::att0attrtargetmgmt::Att0AttributeDefGenImpl;

};

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_undef.h>
#endif  //  ATT0ATTRTARGETMGMT__ATT0ATTRIBUTEDEFDELEGATE_HXX
