//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Att0AttributeDefRevision
    Filename:   Att0AttributeDefRevision.hxx
    Module:     Att0attrtargetmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef ATT0ATTRTARGETMGMT__ATT0ATTRIBUTEDEFREVISION__HXX
#define ATT0ATTRTARGETMGMT__ATT0ATTRIBUTEDEFREVISION__HXX

#include <vector>
#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_exports.h>

namespace att0attrtargetmgmt
{
    class Att0AttributeDefRevision;
}
namespace att0attrtargetmgmt
{
    class Att0AttributeDefRevisionImpl;
}
namespace att0attrtargetmgmt
{
    class Att0AttributeDefRevisionDelegate;
}
namespace att0attrtargetmgmt
{
    class Att0AttributeDefRevisionDispatch;
}
namespace att0attrtargetmgmt
{
    class Att0AttributeDefRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ATT0ATTRTARGETMGMT_API  att0attrtargetmgmt::Att0AttributeDefRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 12.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getAtt0ParamDictionaries( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAtt0AttrType( const std::string &value, bool isNull=false );

    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 10.1.3
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setAtt0ListOfValues( const std::vector< std::string > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Att0AttributeDefRevision();

    /**
     * Destructor
     */
    virtual ~Att0AttributeDefRevision();

private:
    //  Getter method for the Implementation Object
    Att0AttributeDefRevisionImpl*  getAtt0AttributeDefRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAtt0AttributeDefRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Att0AttributeDefRevisionImpl*  m_att0attributedefrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Att0AttributeDefRevision - desc for Att0AttributeDefRevision parameter
     */
    Att0AttributeDefRevision( const Att0AttributeDefRevision& );
    Att0AttributeDefRevision& operator=( const Att0AttributeDefRevision& );

    friend class  Att0AttributeDefRevisionDelegate;
    friend class  Att0AttributeDefRevisionDispatch;
    friend class  Att0AttributeDefRevisionGenImpl;
};

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_undef.h>
#endif //   ATT0ATTRTARGETMGMT__ATT0ATTRIBUTEDEFREVISION__HXX
