//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Att0AttributeDefRevisionDelegate
    Filename:   Att0AttributeDefRevisionDelegate.hxx
    Module:     Att0attrtargetmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef ATT0ATTRTARGETMGMT__ATT0ATTRIBUTEDEFREVISIONDELEGATE_HXX
#define ATT0ATTRTARGETMGMT__ATT0ATTRIBUTEDEFREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Att0attrtargetmgmt/Att0AttributeDefRevision.hxx>

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_exports.h>

namespace att0attrtargetmgmt
{
    class Att0AttributeDefRevisionDelegate;
}
namespace att0attrtargetmgmt
{
    class Att0AttributeDefRevisionImpl;
}
namespace att0attrtargetmgmt
{
    class Att0AttributeDefRevision;
}
namespace att0attrtargetmgmt
{
    class Att0AttributeDefRevisionGenImpl;
}

namespace att0attrtargetmgmt_alias = ::att0attrtargetmgmt;


class  ATT0ATTRTARGETMGMT_API att0attrtargetmgmt_alias::Att0AttributeDefRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Att0AttributeDefRevisionDelegate instance
    static Att0AttributeDefRevisionDelegate&  getInstance();

    //  Method to create the Att0AttributeDefRevisionImpl pointer
    static Att0AttributeDefRevisionImpl*  createImpl( Att0AttributeDefRevision&  ifObj );

    //  Method to delete the Att0AttributeDefRevisionImpl pointer
    static void deleteImpl( Att0AttributeDefRevisionImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 12.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getAtt0ParamDictionariesBase(const Att0AttributeDefRevision &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAtt0AttrTypeBase(Att0AttributeDefRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 10.1.3
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setAtt0ListOfValuesBase(Att0AttributeDefRevision &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Att0AttributeDefRevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// validate saveas input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  validateSaveAsInputBase(const Att0AttributeDefRevision &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setObject_nameBase(Att0AttributeDefRevision &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static Att0AttributeDefRevisionDelegate*  m_pInstance;

    Att0AttributeDefRevisionDelegate();
    virtual ~Att0AttributeDefRevisionDelegate();
    static void setInstance( Att0AttributeDefRevisionDelegate*  instance );


private:
    friend class  ::att0attrtargetmgmt::Att0AttributeDefRevisionGenImpl;

};

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_undef.h>
#endif  //  ATT0ATTRTARGETMGMT__ATT0ATTRIBUTEDEFREVISIONDELEGATE_HXX
