//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Att0HasGoalFile
    Filename:   Att0HasGoalFile.hxx
    Module:     Att0attrtargetmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef ATT0ATTRTARGETMGMT__ATT0HASGOALFILE__HXX
#define ATT0ATTRTARGETMGMT__ATT0HASGOALFILE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_exports.h>

namespace att0attrtargetmgmt
{
    class Att0HasGoalFile;
}
namespace att0attrtargetmgmt
{
    class Att0HasGoalFileImpl;
}
namespace att0attrtargetmgmt
{
    class Att0HasGoalFileDelegate;
}
namespace att0attrtargetmgmt
{
    class Att0HasGoalFileDispatch;
}
namespace att0attrtargetmgmt
{
    class Att0HasGoalFileGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ATT0ATTRTARGETMGMT_API  att0attrtargetmgmt::Att0HasGoalFile
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Att0HasGoalFile();

    /**
     * Destructor
     */
    virtual ~Att0HasGoalFile();

private:
    //  Getter method for the Implementation Object
    Att0HasGoalFileImpl*  getAtt0HasGoalFileImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAtt0HasGoalFileImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Att0HasGoalFileImpl*  m_att0hasgoalfileImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Att0HasGoalFile - desc for Att0HasGoalFile parameter
     */
    Att0HasGoalFile( const Att0HasGoalFile& );
    Att0HasGoalFile& operator=( const Att0HasGoalFile& );

    friend class  Att0HasGoalFileDelegate;
    friend class  Att0HasGoalFileDispatch;
    friend class  Att0HasGoalFileGenImpl;
};

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_undef.h>
#endif //   ATT0ATTRTARGETMGMT__ATT0HASGOALFILE__HXX
