//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Att0HasParamValue
    Filename:   Att0HasParamValue.hxx
    Module:     Att0attrtargetmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef ATT0ATTRTARGETMGMT__ATT0HASPARAMVALUE__HXX
#define ATT0ATTRTARGETMGMT__ATT0HASPARAMVALUE__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_exports.h>

namespace att0attrtargetmgmt
{
    class Att0HasParamValue;
}
namespace att0attrtargetmgmt
{
    class Att0HasParamValueImpl;
}
namespace att0attrtargetmgmt
{
    class Att0HasParamValueDelegate;
}
namespace att0attrtargetmgmt
{
    class Att0HasParamValueDispatch;
}
namespace att0attrtargetmgmt
{
    class Att0HasParamValueGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ATT0ATTRTARGETMGMT_API  att0attrtargetmgmt::Att0HasParamValue
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Setter for a string Property
    /// @version Teamcenter 13.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAtt0Direction( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Att0HasParamValue();

    /**
     * Destructor
     */
    virtual ~Att0HasParamValue();

private:
    //  Getter method for the Implementation Object
    Att0HasParamValueImpl*  getAtt0HasParamValueImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAtt0HasParamValueImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Att0HasParamValueImpl*  m_att0hasparamvalueImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Att0HasParamValue - desc for Att0HasParamValue parameter
     */
    Att0HasParamValue( const Att0HasParamValue& );
    Att0HasParamValue& operator=( const Att0HasParamValue& );

    friend class  Att0HasParamValueDelegate;
    friend class  Att0HasParamValueDispatch;
    friend class  Att0HasParamValueGenImpl;
};

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_undef.h>
#endif //   ATT0ATTRTARGETMGMT__ATT0HASPARAMVALUE__HXX
