//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Att0MeasurableAttribute
    Filename:   Att0MeasurableAttribute.hxx
    Module:     Att0attrtargetmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef ATT0ATTRTARGETMGMT__ATT0MEASURABLEATTRIBUTE__HXX
#define ATT0ATTRTARGETMGMT__ATT0MEASURABLEATTRIBUTE__HXX

#include <metaframework/ReviseInput.hxx>
#include <metaframework/DeepCopyData.hxx>
#include <unidefs.h>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_exports.h>

namespace att0attrtargetmgmt
{
    class Att0MeasurableAttribute;
}
namespace att0attrtargetmgmt
{
    class Att0MeasurableAttributeImpl;
}
namespace att0attrtargetmgmt
{
    class Att0MeasurableAttributeDelegate;
}
namespace att0attrtargetmgmt
{
    class Att0MeasurableAttributeDispatch;
}
namespace att0attrtargetmgmt
{
    class Att0MeasurableAttributeGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ATT0ATTRTARGETMGMT_API  att0attrtargetmgmt::Att0MeasurableAttribute
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 12.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getAtt0ParamProjectsOrGroups( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Finalize Revise Input Operation
    /// @version Teamcenter 11.2
    /// @param pReviseInput - Revise input
    /// @param vecDeepCopyData - Deep Copy Data Vector
    /// @return - Failure Code
    ///
    int  finalizeReviseInput( ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );

    ///
    /// Bom0ConfigurableBomElement Revise Operation
    /// @version Teamcenter 11.2
    /// @param pReviseInput - Revise Input
    /// @param vecDeepCopyData - Deep Copy Data Vactor
    /// @param newObjTag - New Object tag
    /// @return - Failure Code
    ///
    int  revise( ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData, tag_t *newObjTag );

    ///
    /// Reivse post operation
    /// @version Teamcenter 11.2
    /// @param pReviseInput - Revise Input Descriptor
    /// @param vecDeepCopyData - Deep Copy Data Vector
    /// @return - Failure Code
    ///
    int  revisePost( ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );

    ///
    /// Set properties from revise input Operation
    /// @version Teamcenter 11.2
    /// @param pReviseInput - Revise Input Descriptor
    /// @return - Failure code
    ///
    int  setPropertiesFromReviseInput( ::Teamcenter::ReviseInput *pReviseInput );

    ///
    /// Validate Revise Input Operation
    /// @version Teamcenter 11.2
    /// @param pReviseInput - Revise Input Descriptor
    /// @param vecDeepCopyData - Deep Copy Data Vector
    /// @return - Failure Code
    ///
    int  validateReviseInput( ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Att0MeasurableAttribute();

    /**
     * Destructor
     */
    virtual ~Att0MeasurableAttribute();

private:
    //  Getter method for the Implementation Object
    Att0MeasurableAttributeImpl*  getAtt0MeasurableAttributeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAtt0MeasurableAttributeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Att0MeasurableAttributeImpl*  m_att0measurableattributeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Att0MeasurableAttribute - desc for Att0MeasurableAttribute parameter
     */
    Att0MeasurableAttribute( const Att0MeasurableAttribute& );
    Att0MeasurableAttribute& operator=( const Att0MeasurableAttribute& );

    friend class  Att0MeasurableAttributeDelegate;
    friend class  Att0MeasurableAttributeDispatch;
    friend class  Att0MeasurableAttributeGenImpl;
};

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_undef.h>
#endif //   ATT0ATTRTARGETMGMT__ATT0MEASURABLEATTRIBUTE__HXX
