//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Att0MeasurableAttributeBoolDelegate
    Filename:   Att0MeasurableAttributeBoolDelegate.hxx
    Module:     Att0attrtargetmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef ATT0ATTRTARGETMGMT__ATT0MEASURABLEATTRIBUTEBOOLDELEGATE_HXX
#define ATT0ATTRTARGETMGMT__ATT0MEASURABLEATTRIBUTEBOOLDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Att0attrtargetmgmt/Att0MeasurableAttributeBool.hxx>

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_exports.h>

namespace att0attrtargetmgmt
{
    class Att0MeasurableAttributeBoolDelegate;
}
namespace att0attrtargetmgmt
{
    class Att0MeasurableAttributeBoolImpl;
}
namespace att0attrtargetmgmt
{
    class Att0MeasurableAttributeBool;
}
namespace att0attrtargetmgmt
{
    class Att0MeasurableAttributeBoolGenImpl;
}

namespace att0attrtargetmgmt_alias = ::att0attrtargetmgmt;


class  ATT0ATTRTARGETMGMT_API att0attrtargetmgmt_alias::Att0MeasurableAttributeBoolDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Att0MeasurableAttributeBoolDelegate instance
    static Att0MeasurableAttributeBoolDelegate&  getInstance();

    //  Method to create the Att0MeasurableAttributeBoolImpl pointer
    static Att0MeasurableAttributeBoolImpl*  createImpl( Att0MeasurableAttributeBool&  ifObj );

    //  Method to delete the Att0MeasurableAttributeBoolImpl pointer
    static void deleteImpl( Att0MeasurableAttributeBoolImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAtt0CurrentValueBase(const Att0MeasurableAttributeBool &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAtt0DisplayGoalBase(const Att0MeasurableAttributeBool &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAtt0MeasurementBase(const Att0MeasurableAttributeBool &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10.1.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAtt0GoalBase(Att0MeasurableAttributeBool &ifObj,  bool value, bool isNull );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Att0MeasurableAttributeBool &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Generic saveAsPost operation.
    /// @version Teamcenter 8.1
    /// @param pSavAsInput - Input argument as SaveAsInput object.
    /// @param vecDeepCopyData - vector deepcopy data
    /// @return - Return integer value.
    ///
    int  saveAsPostBase(const Att0MeasurableAttributeBool &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Att0MeasurableAttributeBool &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Att0MeasurableAttributeBoolDelegate*  m_pInstance;

    Att0MeasurableAttributeBoolDelegate();
    virtual ~Att0MeasurableAttributeBoolDelegate();
    static void setInstance( Att0MeasurableAttributeBoolDelegate*  instance );


private:
    friend class  ::att0attrtargetmgmt::Att0MeasurableAttributeBoolGenImpl;

};

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_undef.h>
#endif  //  ATT0ATTRTARGETMGMT__ATT0MEASURABLEATTRIBUTEBOOLDELEGATE_HXX
