//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Att0MeasurableAttributeDelegate
    Filename:   Att0MeasurableAttributeDelegate.hxx
    Module:     Att0attrtargetmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef ATT0ATTRTARGETMGMT__ATT0MEASURABLEATTRIBUTEDELEGATE_HXX
#define ATT0ATTRTARGETMGMT__ATT0MEASURABLEATTRIBUTEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Att0attrtargetmgmt/Att0MeasurableAttribute.hxx>

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_exports.h>

namespace att0attrtargetmgmt
{
    class Att0MeasurableAttributeDelegate;
}
namespace att0attrtargetmgmt
{
    class Att0MeasurableAttributeImpl;
}
namespace att0attrtargetmgmt
{
    class Att0MeasurableAttribute;
}
namespace att0attrtargetmgmt
{
    class Att0MeasurableAttributeGenImpl;
}

namespace att0attrtargetmgmt_alias = ::att0attrtargetmgmt;


class  ATT0ATTRTARGETMGMT_API att0attrtargetmgmt_alias::Att0MeasurableAttributeDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Att0MeasurableAttributeDelegate instance
    static Att0MeasurableAttributeDelegate&  getInstance();

    //  Method to create the Att0MeasurableAttributeImpl pointer
    static Att0MeasurableAttributeImpl*  createImpl( Att0MeasurableAttribute&  ifObj );

    //  Method to delete the Att0MeasurableAttributeImpl pointer
    static void deleteImpl( Att0MeasurableAttributeImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 12.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getAtt0ParamProjectsOrGroupsBase(const Att0MeasurableAttribute &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Finalize Revise Input Operation
    /// @version Teamcenter 11.2
    /// @param pReviseInput - Revise input
    /// @param vecDeepCopyData - Deep Copy Data Vector
    /// @return - Failure Code
    ///
    int  finalizeReviseInputBase(const Att0MeasurableAttribute &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// Bom0ConfigurableBomElement Revise Operation
    /// @version Teamcenter 11.2
    /// @param pReviseInput - Revise Input
    /// @param vecDeepCopyData - Deep Copy Data Vactor
    /// @param newObjTag - New Object tag
    /// @return - Failure Code
    ///
    int  reviseBase(const Att0MeasurableAttribute &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData, tag_t *newObjTag );


    ///
    /// Reivse post operation
    /// @version Teamcenter 11.2
    /// @param pReviseInput - Revise Input Descriptor
    /// @param vecDeepCopyData - Deep Copy Data Vector
    /// @return - Failure Code
    ///
    int  revisePostBase(const Att0MeasurableAttribute &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// Set properties from revise input Operation
    /// @version Teamcenter 11.2
    /// @param pReviseInput - Revise Input Descriptor
    /// @return - Failure code
    ///
    int  setPropertiesFromReviseInputBase(const Att0MeasurableAttribute &ifObj,  ::Teamcenter::ReviseInput *pReviseInput );


    ///
    /// Validate Revise Input Operation
    /// @version Teamcenter 11.2
    /// @param pReviseInput - Revise Input Descriptor
    /// @param vecDeepCopyData - Deep Copy Data Vector
    /// @return - Failure Code
    ///
    int  validateReviseInputBase(const Att0MeasurableAttribute &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Att0MeasurableAttribute &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Att0MeasurableAttribute &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// finalize operation input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  finalizeSaveAsInputBase(const Att0MeasurableAttribute &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// Generic saveAsPost operation.
    /// @version Teamcenter 8.1
    /// @param pSavAsInput - Input argument as SaveAsInput object.
    /// @param vecDeepCopyData - vector deepcopy data
    /// @return - Return integer value.
    ///
    int  saveAsPostBase(const Att0MeasurableAttribute &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Att0MeasurableAttribute &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// validate saveas input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  validateSaveAsInputBase(const Att0MeasurableAttribute &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static Att0MeasurableAttributeDelegate*  m_pInstance;

    Att0MeasurableAttributeDelegate();
    virtual ~Att0MeasurableAttributeDelegate();
    static void setInstance( Att0MeasurableAttributeDelegate*  instance );


private:
    friend class  ::att0attrtargetmgmt::Att0MeasurableAttributeGenImpl;

};

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_undef.h>
#endif  //  ATT0ATTRTARGETMGMT__ATT0MEASURABLEATTRIBUTEDELEGATE_HXX
