//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Att0MeasurableAttributePnt
    Filename:   Att0MeasurableAttributePnt.hxx
    Module:     Att0attrtargetmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef ATT0ATTRTARGETMGMT__ATT0MEASURABLEATTRIBUTEPNT__HXX
#define ATT0ATTRTARGETMGMT__ATT0MEASURABLEATTRIBUTEPNT__HXX

#include <unidefs.h>
#include <string>
#include <common/tc_deprecation_macros.h>
#include <Att0attrtargetmgmt/Att0MeasurableAttribute.hxx>

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_exports.h>

namespace att0attrtargetmgmt
{
    class Att0MeasurableAttributePnt;
}
namespace att0attrtargetmgmt
{
    class Att0MeasurableAttributePntImpl;
}
namespace att0attrtargetmgmt
{
    class Att0MeasurableAttributePntDelegate;
}
namespace att0attrtargetmgmt
{
    class Att0MeasurableAttributePntDispatch;
}
namespace att0attrtargetmgmt
{
    class Att0MeasurableAttributePntGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ATT0ATTRTARGETMGMT_API  att0attrtargetmgmt::Att0MeasurableAttributePnt
     : public  ::att0attrtargetmgmt::Att0MeasurableAttribute
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAtt0CurrentValue( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAtt0Goal( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAtt0Measurement( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAtt0CurrentValue( const tag_t &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAtt0Goal( const std::string &value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAtt0Measurement( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Att0MeasurableAttributePnt();

    /**
     * Destructor
     */
    virtual ~Att0MeasurableAttributePnt();

private:
    //  Getter method for the Implementation Object
    Att0MeasurableAttributePntImpl*  getAtt0MeasurableAttributePntImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAtt0MeasurableAttributePntImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Att0MeasurableAttributePntImpl*  m_att0measurableattributepntImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Att0MeasurableAttributePnt - desc for Att0MeasurableAttributePnt parameter
     */
    Att0MeasurableAttributePnt( const Att0MeasurableAttributePnt& );
    Att0MeasurableAttributePnt& operator=( const Att0MeasurableAttributePnt& );

    friend class  Att0MeasurableAttributePntDelegate;
    friend class  Att0MeasurableAttributePntDispatch;
    friend class  Att0MeasurableAttributePntGenImpl;
};

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_undef.h>
#endif //   ATT0ATTRTARGETMGMT__ATT0MEASURABLEATTRIBUTEPNT__HXX
