//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Att0MeasurableAttributeStr
    Filename:   Att0MeasurableAttributeStr.hxx
    Module:     Att0attrtargetmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef ATT0ATTRTARGETMGMT__ATT0MEASURABLEATTRIBUTESTR__HXX
#define ATT0ATTRTARGETMGMT__ATT0MEASURABLEATTRIBUTESTR__HXX

#include <unidefs.h>
#include <string>
#include <common/tc_deprecation_macros.h>
#include <Att0attrtargetmgmt/Att0MeasurableAttribute.hxx>

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_exports.h>

namespace att0attrtargetmgmt
{
    class Att0MeasurableAttributeStr;
}
namespace att0attrtargetmgmt
{
    class Att0MeasurableAttributeStrImpl;
}
namespace att0attrtargetmgmt
{
    class Att0MeasurableAttributeStrDelegate;
}
namespace att0attrtargetmgmt
{
    class Att0MeasurableAttributeStrDispatch;
}
namespace att0attrtargetmgmt
{
    class Att0MeasurableAttributeStrGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ATT0ATTRTARGETMGMT_API  att0attrtargetmgmt::Att0MeasurableAttributeStr
     : public  ::att0attrtargetmgmt::Att0MeasurableAttribute
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAtt0CurrentValue( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAtt0DisplayGoal( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAtt0Measurement( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAtt0Goal( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Att0MeasurableAttributeStr();

    /**
     * Destructor
     */
    virtual ~Att0MeasurableAttributeStr();

private:
    //  Getter method for the Implementation Object
    Att0MeasurableAttributeStrImpl*  getAtt0MeasurableAttributeStrImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAtt0MeasurableAttributeStrImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Att0MeasurableAttributeStrImpl*  m_att0measurableattributestrImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Att0MeasurableAttributeStr - desc for Att0MeasurableAttributeStr parameter
     */
    Att0MeasurableAttributeStr( const Att0MeasurableAttributeStr& );
    Att0MeasurableAttributeStr& operator=( const Att0MeasurableAttributeStr& );

    friend class  Att0MeasurableAttributeStrDelegate;
    friend class  Att0MeasurableAttributeStrDispatch;
    friend class  Att0MeasurableAttributeStrGenImpl;
};

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_undef.h>
#endif //   ATT0ATTRTARGETMGMT__ATT0MEASURABLEATTRIBUTESTR__HXX
