//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Att0MeasureValue
    Filename:   Att0MeasureValue.hxx
    Module:     Att0attrtargetmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef ATT0ATTRTARGETMGMT__ATT0MEASUREVALUE__HXX
#define ATT0ATTRTARGETMGMT__ATT0MEASUREVALUE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_exports.h>

namespace att0attrtargetmgmt
{
    class Att0MeasureValue;
}
namespace att0attrtargetmgmt
{
    class Att0MeasureValueImpl;
}
namespace att0attrtargetmgmt
{
    class Att0MeasureValueDelegate;
}
namespace att0attrtargetmgmt
{
    class Att0MeasureValueDispatch;
}
namespace att0attrtargetmgmt
{
    class Att0MeasureValueGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ATT0ATTRTARGETMGMT_API  att0attrtargetmgmt::Att0MeasureValue
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Att0MeasureValue();

    /**
     * Destructor
     */
    virtual ~Att0MeasureValue();

private:
    //  Getter method for the Implementation Object
    Att0MeasureValueImpl*  getAtt0MeasureValueImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAtt0MeasureValueImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Att0MeasureValueImpl*  m_att0measurevalueImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Att0MeasureValue - desc for Att0MeasureValue parameter
     */
    Att0MeasureValue( const Att0MeasureValue& );
    Att0MeasureValue& operator=( const Att0MeasureValue& );

    friend class  Att0MeasureValueDelegate;
    friend class  Att0MeasureValueDispatch;
    friend class  Att0MeasureValueGenImpl;
};

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_undef.h>
#endif //   ATT0ATTRTARGETMGMT__ATT0MEASUREVALUE__HXX
