//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Att0MeasureValueInt
    Filename:   Att0MeasureValueInt.hxx
    Module:     Att0attrtargetmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef ATT0ATTRTARGETMGMT__ATT0MEASUREVALUEINT__HXX
#define ATT0ATTRTARGETMGMT__ATT0MEASUREVALUEINT__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <Att0attrtargetmgmt/Att0MeasureValue.hxx>

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_exports.h>

namespace att0attrtargetmgmt
{
    class Att0MeasureValueInt;
}
namespace att0attrtargetmgmt
{
    class Att0MeasureValueIntImpl;
}
namespace att0attrtargetmgmt
{
    class Att0MeasureValueIntDelegate;
}
namespace att0attrtargetmgmt
{
    class Att0MeasureValueIntDispatch;
}
namespace att0attrtargetmgmt
{
    class Att0MeasureValueIntGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ATT0ATTRTARGETMGMT_API  att0attrtargetmgmt::Att0MeasureValueInt
     : public  ::att0attrtargetmgmt::Att0MeasureValue
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAtt0DisplayValue( std::string &value, bool &isNull ) const;

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 10.1.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAtt0Value( int value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Att0MeasureValueInt();

    /**
     * Destructor
     */
    virtual ~Att0MeasureValueInt();

private:
    //  Getter method for the Implementation Object
    Att0MeasureValueIntImpl*  getAtt0MeasureValueIntImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAtt0MeasureValueIntImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Att0MeasureValueIntImpl*  m_att0measurevalueintImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Att0MeasureValueInt - desc for Att0MeasureValueInt parameter
     */
    Att0MeasureValueInt( const Att0MeasureValueInt& );
    Att0MeasureValueInt& operator=( const Att0MeasureValueInt& );

    friend class  Att0MeasureValueIntDelegate;
    friend class  Att0MeasureValueIntDispatch;
    friend class  Att0MeasureValueIntGenImpl;
};

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_undef.h>
#endif //   ATT0ATTRTARGETMGMT__ATT0MEASUREVALUEINT__HXX
