//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Att0MeasureValuePnt
    Filename:   Att0MeasureValuePnt.hxx
    Module:     Att0attrtargetmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef ATT0ATTRTARGETMGMT__ATT0MEASUREVALUEPNT__HXX
#define ATT0ATTRTARGETMGMT__ATT0MEASUREVALUEPNT__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <Att0attrtargetmgmt/Att0MeasureValue.hxx>

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_exports.h>

namespace att0attrtargetmgmt
{
    class Att0MeasureValuePnt;
}
namespace att0attrtargetmgmt
{
    class Att0MeasureValuePntImpl;
}
namespace att0attrtargetmgmt
{
    class Att0MeasureValuePntDelegate;
}
namespace att0attrtargetmgmt
{
    class Att0MeasureValuePntDispatch;
}
namespace att0attrtargetmgmt
{
    class Att0MeasureValuePntGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ATT0ATTRTARGETMGMT_API  att0attrtargetmgmt::Att0MeasureValuePnt
     : public  ::att0attrtargetmgmt::Att0MeasureValue
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAtt0Value( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAtt0Value( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Att0MeasureValuePnt();

    /**
     * Destructor
     */
    virtual ~Att0MeasureValuePnt();

private:
    //  Getter method for the Implementation Object
    Att0MeasureValuePntImpl*  getAtt0MeasureValuePntImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAtt0MeasureValuePntImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Att0MeasureValuePntImpl*  m_att0measurevaluepntImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Att0MeasureValuePnt - desc for Att0MeasureValuePnt parameter
     */
    Att0MeasureValuePnt( const Att0MeasureValuePnt& );
    Att0MeasureValuePnt& operator=( const Att0MeasureValuePnt& );

    friend class  Att0MeasureValuePntDelegate;
    friend class  Att0MeasureValuePntDispatch;
    friend class  Att0MeasureValuePntGenImpl;
};

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_undef.h>
#endif //   ATT0ATTRTARGETMGMT__ATT0MEASUREVALUEPNT__HXX
