//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Att0MeasureValuePntDelegate
    Filename:   Att0MeasureValuePntDelegate.hxx
    Module:     Att0attrtargetmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef ATT0ATTRTARGETMGMT__ATT0MEASUREVALUEPNTDELEGATE_HXX
#define ATT0ATTRTARGETMGMT__ATT0MEASUREVALUEPNTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Att0attrtargetmgmt/Att0MeasureValuePnt.hxx>

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_exports.h>

namespace att0attrtargetmgmt
{
    class Att0MeasureValuePntDelegate;
}
namespace att0attrtargetmgmt
{
    class Att0MeasureValuePntImpl;
}
namespace att0attrtargetmgmt
{
    class Att0MeasureValuePnt;
}
namespace att0attrtargetmgmt
{
    class Att0MeasureValuePntGenImpl;
}

namespace att0attrtargetmgmt_alias = ::att0attrtargetmgmt;


class  ATT0ATTRTARGETMGMT_API att0attrtargetmgmt_alias::Att0MeasureValuePntDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Att0MeasureValuePntDelegate instance
    static Att0MeasureValuePntDelegate&  getInstance();

    //  Method to create the Att0MeasureValuePntImpl pointer
    static Att0MeasureValuePntImpl*  createImpl( Att0MeasureValuePnt&  ifObj );

    //  Method to delete the Att0MeasureValuePntImpl pointer
    static void deleteImpl( Att0MeasureValuePntImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAtt0ValueBase(const Att0MeasureValuePnt &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAtt0ValueBase(Att0MeasureValuePnt &ifObj,  const std::string &value, bool isNull );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Att0MeasureValuePnt &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Generic saveAsPost operation.
    /// @version Teamcenter 8.1
    /// @param pSavAsInput - Input argument as SaveAsInput object.
    /// @param vecDeepCopyData - vector deepcopy data
    /// @return - Return integer value.
    ///
    int  saveAsPostBase(const Att0MeasureValuePnt &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Att0MeasureValuePnt &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Att0MeasureValuePntDelegate*  m_pInstance;

    Att0MeasureValuePntDelegate();
    virtual ~Att0MeasureValuePntDelegate();
    static void setInstance( Att0MeasureValuePntDelegate*  instance );


private:
    friend class  ::att0attrtargetmgmt::Att0MeasureValuePntGenImpl;

};

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_undef.h>
#endif  //  ATT0ATTRTARGETMGMT__ATT0MEASUREVALUEPNTDELEGATE_HXX
