//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Att0Measurement
    Filename:   Att0Measurement.hxx
    Module:     Att0attrtargetmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef ATT0ATTRTARGETMGMT__ATT0MEASUREMENT__HXX
#define ATT0ATTRTARGETMGMT__ATT0MEASUREMENT__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_exports.h>

namespace att0attrtargetmgmt
{
    class Att0Measurement;
}
namespace att0attrtargetmgmt
{
    class Att0MeasurementImpl;
}
namespace att0attrtargetmgmt
{
    class Att0MeasurementDelegate;
}
namespace att0attrtargetmgmt
{
    class Att0MeasurementDispatch;
}
namespace att0attrtargetmgmt
{
    class Att0MeasurementGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ATT0ATTRTARGETMGMT_API  att0attrtargetmgmt::Att0Measurement
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 10.1.4
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setAtt0MeasuredValues( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Att0Measurement();

    /**
     * Destructor
     */
    virtual ~Att0Measurement();

private:
    //  Getter method for the Implementation Object
    Att0MeasurementImpl*  getAtt0MeasurementImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAtt0MeasurementImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Att0MeasurementImpl*  m_att0measurementImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Att0Measurement - desc for Att0Measurement parameter
     */
    Att0Measurement( const Att0Measurement& );
    Att0Measurement& operator=( const Att0Measurement& );

    friend class  Att0MeasurementDelegate;
    friend class  Att0MeasurementDispatch;
    friend class  Att0MeasurementGenImpl;
};

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_undef.h>
#endif //   ATT0ATTRTARGETMGMT__ATT0MEASUREMENT__HXX
