//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Att0ParamDictionary
    Filename:   Att0ParamDictionary.hxx
    Module:     Att0attrtargetmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef ATT0ATTRTARGETMGMT__ATT0PARAMDICTIONARY__HXX
#define ATT0ATTRTARGETMGMT__ATT0PARAMDICTIONARY__HXX

#include <common/tc_deprecation_macros.h>
#include <tc/Folder.hxx>

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_exports.h>

namespace att0attrtargetmgmt
{
    class Att0ParamDictionary;
}
namespace att0attrtargetmgmt
{
    class Att0ParamDictionaryImpl;
}
namespace att0attrtargetmgmt
{
    class Att0ParamDictionaryDelegate;
}
namespace att0attrtargetmgmt
{
    class Att0ParamDictionaryDispatch;
}
namespace att0attrtargetmgmt
{
    class Att0ParamDictionaryGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ATT0ATTRTARGETMGMT_API  att0attrtargetmgmt::Att0ParamDictionary
     : public  ::Teamcenter::Folder
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Att0ParamDictionary();

    /**
     * Destructor
     */
    virtual ~Att0ParamDictionary();

private:
    //  Getter method for the Implementation Object
    Att0ParamDictionaryImpl*  getAtt0ParamDictionaryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAtt0ParamDictionaryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Att0ParamDictionaryImpl*  m_att0paramdictionaryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Att0ParamDictionary - desc for Att0ParamDictionary parameter
     */
    Att0ParamDictionary( const Att0ParamDictionary& );
    Att0ParamDictionary& operator=( const Att0ParamDictionary& );

    friend class  Att0ParamDictionaryDelegate;
    friend class  Att0ParamDictionaryDispatch;
    friend class  Att0ParamDictionaryGenImpl;
};

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_undef.h>
#endif //   ATT0ATTRTARGETMGMT__ATT0PARAMDICTIONARY__HXX
