//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Att0ParamGroupDelegate
    Filename:   Att0ParamGroupDelegate.hxx
    Module:     Att0attrtargetmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef ATT0ATTRTARGETMGMT__ATT0PARAMGROUPDELEGATE_HXX
#define ATT0ATTRTARGETMGMT__ATT0PARAMGROUPDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Att0attrtargetmgmt/Att0ParamGroup.hxx>

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_exports.h>

namespace att0attrtargetmgmt
{
    class Att0ParamGroupDelegate;
}
namespace att0attrtargetmgmt
{
    class Att0ParamGroupImpl;
}
namespace att0attrtargetmgmt
{
    class Att0ParamGroup;
}
namespace att0attrtargetmgmt
{
    class Att0ParamGroupGenImpl;
}

namespace att0attrtargetmgmt_alias = ::att0attrtargetmgmt;


class  ATT0ATTRTARGETMGMT_API att0attrtargetmgmt_alias::Att0ParamGroupDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Att0ParamGroupDelegate instance
    static Att0ParamGroupDelegate&  getInstance();

    //  Method to create the Att0ParamGroupImpl pointer
    static Att0ParamGroupImpl*  createImpl( Att0ParamGroup&  ifObj );

    //  Method to delete the Att0ParamGroupImpl pointer
    static void deleteImpl( Att0ParamGroupImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.6
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getAtt0ChildParamGroupsBase(const Att0ParamGroup &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.6
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getAtt0ChildParamValuesBase(const Att0ParamGroup &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Att0ParamGroup &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Att0ParamGroupDelegate*  m_pInstance;

    Att0ParamGroupDelegate();
    virtual ~Att0ParamGroupDelegate();
    static void setInstance( Att0ParamGroupDelegate*  instance );


private:
    friend class  ::att0attrtargetmgmt::Att0ParamGroupGenImpl;

};

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_undef.h>
#endif  //  ATT0ATTRTARGETMGMT__ATT0PARAMGROUPDELEGATE_HXX
