//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Att0ParamVarConfObject
    Filename:   Att0ParamVarConfObject.hxx
    Module:     Att0attrtargetmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef ATT0ATTRTARGETMGMT__ATT0PARAMVARCONFOBJECT__HXX
#define ATT0ATTRTARGETMGMT__ATT0PARAMVARCONFOBJECT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_exports.h>

namespace att0attrtargetmgmt
{
    class Att0ParamVarConfObject;
}
namespace att0attrtargetmgmt
{
    class Att0ParamVarConfObjectImpl;
}
namespace att0attrtargetmgmt
{
    class Att0ParamVarConfObjectDelegate;
}
namespace att0attrtargetmgmt
{
    class Att0ParamVarConfObjectDispatch;
}
namespace att0attrtargetmgmt
{
    class Att0ParamVarConfObjectGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ATT0ATTRTARGETMGMT_API  att0attrtargetmgmt::Att0ParamVarConfObject
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Att0ParamVarConfObject();

    /**
     * Destructor
     */
    virtual ~Att0ParamVarConfObject();

private:
    //  Getter method for the Implementation Object
    Att0ParamVarConfObjectImpl*  getAtt0ParamVarConfObjectImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAtt0ParamVarConfObjectImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Att0ParamVarConfObjectImpl*  m_att0paramvarconfobjectImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Att0ParamVarConfObject - desc for Att0ParamVarConfObject parameter
     */
    Att0ParamVarConfObject( const Att0ParamVarConfObject& );
    Att0ParamVarConfObject& operator=( const Att0ParamVarConfObject& );

    friend class  Att0ParamVarConfObjectDelegate;
    friend class  Att0ParamVarConfObjectDispatch;
    friend class  Att0ParamVarConfObjectGenImpl;
};

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_undef.h>
#endif //   ATT0ATTRTARGETMGMT__ATT0PARAMVARCONFOBJECT__HXX
