//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Att0Target
    Filename:   Att0Target.hxx
    Module:     Att0attrtargetmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef ATT0ATTRTARGETMGMT__ATT0TARGET__HXX
#define ATT0ATTRTARGETMGMT__ATT0TARGET__HXX

#include <common/tc_deprecation_macros.h>
#include <req/Requirement.hxx>

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_exports.h>

namespace att0attrtargetmgmt
{
    class Att0Target;
}
namespace att0attrtargetmgmt
{
    class Att0TargetImpl;
}
namespace att0attrtargetmgmt
{
    class Att0TargetDelegate;
}
namespace att0attrtargetmgmt
{
    class Att0TargetDispatch;
}
namespace att0attrtargetmgmt
{
    class Att0TargetGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ATT0ATTRTARGETMGMT_API  att0attrtargetmgmt::Att0Target
     : public  ::Teamcenter::Requirement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Att0Target();

    /**
     * Destructor
     */
    virtual ~Att0Target();

private:
    //  Getter method for the Implementation Object
    Att0TargetImpl*  getAtt0TargetImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAtt0TargetImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Att0TargetImpl*  m_att0targetImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Att0Target - desc for Att0Target parameter
     */
    Att0Target( const Att0Target& );
    Att0Target& operator=( const Att0Target& );

    friend class  Att0TargetDelegate;
    friend class  Att0TargetDispatch;
    friend class  Att0TargetGenImpl;
};

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_undef.h>
#endif //   ATT0ATTRTARGETMGMT__ATT0TARGET__HXX
