//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Att0TargetRevision
    Filename:   Att0TargetRevision.hxx
    Module:     Att0attrtargetmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef ATT0ATTRTARGETMGMT__ATT0TARGETREVISION__HXX
#define ATT0ATTRTARGETMGMT__ATT0TARGETREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <req/Requirement_0_Revision_alt.hxx>

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_exports.h>

namespace att0attrtargetmgmt
{
    class Att0TargetRevision;
}
namespace att0attrtargetmgmt
{
    class Att0TargetRevisionImpl;
}
namespace att0attrtargetmgmt
{
    class Att0TargetRevisionDelegate;
}
namespace att0attrtargetmgmt
{
    class Att0TargetRevisionDispatch;
}
namespace att0attrtargetmgmt
{
    class Att0TargetRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ATT0ATTRTARGETMGMT_API  att0attrtargetmgmt::Att0TargetRevision
     : public  ::Teamcenter::Requirement_0_Revision_alt
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Att0TargetRevision();

    /**
     * Destructor
     */
    virtual ~Att0TargetRevision();

private:
    //  Getter method for the Implementation Object
    Att0TargetRevisionImpl*  getAtt0TargetRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAtt0TargetRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Att0TargetRevisionImpl*  m_att0targetrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Att0TargetRevision - desc for Att0TargetRevision parameter
     */
    Att0TargetRevision( const Att0TargetRevision& );
    Att0TargetRevision& operator=( const Att0TargetRevision& );

    friend class  Att0TargetRevisionDelegate;
    friend class  Att0TargetRevisionDispatch;
    friend class  Att0TargetRevisionGenImpl;
};

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_undef.h>
#endif //   ATT0ATTRTARGETMGMT__ATT0TARGETREVISION__HXX
