//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Att0TargetRevisionDelegate
    Filename:   Att0TargetRevisionDelegate.hxx
    Module:     Att0attrtargetmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef ATT0ATTRTARGETMGMT__ATT0TARGETREVISIONDELEGATE_HXX
#define ATT0ATTRTARGETMGMT__ATT0TARGETREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Att0attrtargetmgmt/Att0TargetRevision.hxx>

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_exports.h>

namespace att0attrtargetmgmt
{
    class Att0TargetRevisionDelegate;
}
namespace att0attrtargetmgmt
{
    class Att0TargetRevisionImpl;
}
namespace att0attrtargetmgmt
{
    class Att0TargetRevision;
}
namespace att0attrtargetmgmt
{
    class Att0TargetRevisionGenImpl;
}

namespace att0attrtargetmgmt_alias = ::att0attrtargetmgmt;


class  ATT0ATTRTARGETMGMT_API att0attrtargetmgmt_alias::Att0TargetRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Att0TargetRevisionDelegate instance
    static Att0TargetRevisionDelegate&  getInstance();

    //  Method to create the Att0TargetRevisionImpl pointer
    static Att0TargetRevisionImpl*  createImpl( Att0TargetRevision&  ifObj );

    //  Method to delete the Att0TargetRevisionImpl pointer
    static void deleteImpl( Att0TargetRevisionImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Att0TargetRevision &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Att0TargetRevisionDelegate*  m_pInstance;

    Att0TargetRevisionDelegate();
    virtual ~Att0TargetRevisionDelegate();
    static void setInstance( Att0TargetRevisionDelegate*  instance );


private:
    friend class  ::att0attrtargetmgmt::Att0TargetRevisionGenImpl;

};

#include <Att0attrtargetmgmt/libatt0attrtargetmgmt_undef.h>
#endif  //  ATT0ATTRTARGETMGMT__ATT0TARGETREVISIONDELEGATE_HXX
