//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Bom0AbstractPartBrkdownElem
    Filename:   Bom0AbstractPartBrkdownElem.hxx
    Module:     Bom0bommanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOM0BOMMANAGEMENT__BOM0ABSTRACTPARTBRKDOWNELEM__HXX
#define TEAMCENTER__BOM0BOMMANAGEMENT__BOM0ABSTRACTPARTBRKDOWNELEM__HXX

#include <vector>
#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <Bom0bommanagement/Bom0ConfigurableBomElement.hxx>

#include <Bom0bommanagement/libbom0bommanagement_exports.h>

namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPartBrkdownElem;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPartBrkdownElemImpl;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPartBrkdownElemDelegate;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPartBrkdownElemDispatch;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPartBrkdownElemGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BOM0BOMMANAGEMENT_API  Teamcenter::Bom0bommanagement::Bom0AbstractPartBrkdownElem
     : public  ::Teamcenter::Bom0bommanagement::Bom0ConfigurableBomElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for Property Display Value
    /// @version Teamcenter 11.2.3
    /// @param values - Parameter value
    /// @return - Status. 0 if successful
    ///
    int  getBom0QuantityDisplayableValues( std::vector< std::string > &values );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setBom0ChildPart( const tag_t &value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setBom0ParentPart( const tag_t &value, bool isNull=false );

    ///
    /// Setter for a Double Property
    /// @version Teamcenter 11.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setBom0Quantity( double value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setBom0UOM( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Bom0AbstractPartBrkdownElem();

    /**
     * Destructor
     */
    virtual ~Bom0AbstractPartBrkdownElem();

private:
    //  Getter method for the Implementation Object
    Bom0AbstractPartBrkdownElemImpl*  getBom0AbstractPartBrkdownElemImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBom0AbstractPartBrkdownElemImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Bom0AbstractPartBrkdownElemImpl*  m_bom0abstractpartbrkdownelemImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Bom0AbstractPartBrkdownElem - desc for Bom0AbstractPartBrkdownElem parameter
     */
    Bom0AbstractPartBrkdownElem( const Bom0AbstractPartBrkdownElem& );
    Bom0AbstractPartBrkdownElem& operator=( const Bom0AbstractPartBrkdownElem& );

    friend class  Bom0AbstractPartBrkdownElemDelegate;
    friend class  Bom0AbstractPartBrkdownElemDispatch;
    friend class  Bom0AbstractPartBrkdownElemGenImpl;
};

#include <Bom0bommanagement/libbom0bommanagement_undef.h>
#endif //   TEAMCENTER__BOM0BOMMANAGEMENT__BOM0ABSTRACTPARTBRKDOWNELEM__HXX
