//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Bom0AbstractPartDelegate
    Filename:   Bom0AbstractPartDelegate.hxx
    Module:     Bom0bommanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOM0BOMMANAGEMENT__BOM0ABSTRACTPARTDELEGATE_HXX
#define TEAMCENTER__BOM0BOMMANAGEMENT__BOM0ABSTRACTPARTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Bom0bommanagement/Bom0AbstractPart.hxx>

#include <Bom0bommanagement/libbom0bommanagement_exports.h>

namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPartDelegate;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPartImpl;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPart;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPartGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  BOM0BOMMANAGEMENT_API Teamcenter_alias::Bom0bommanagement::Bom0AbstractPartDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Bom0AbstractPartDelegate instance
    static Bom0AbstractPartDelegate&  getInstance();

    //  Method to create the Bom0AbstractPartImpl pointer
    static Bom0AbstractPartImpl*  createImpl( Bom0AbstractPart&  ifObj );

    //  Method to delete the Bom0AbstractPartImpl pointer
    static void deleteImpl( Bom0AbstractPartImpl*  impl );


    ///
    /// The operation aligns part (Bom0AbstractPart) and design revision(s) (ItemRevision). For each part, primary design given as input will be marked as primary design. If none of the aligned design(s) exists as primary design and no primary design is given as input, first design getting aligned will be marked as primary design.
    /// @version Teamcenter 11.2.3
    /// @param input - A vector of data that contains part, corresponding design revision(s) and design revision to mark as primary design. It should be of type Bom0PartDesignAlgnmtInput.
    /// @param bulkData - A data structure to store objects and other information relevant for set based operation.
    /// @return - This operation returns ITK_ok on success and error code on failure.
    ///
    int  bom0AlignDesignsBase( std::vector<  ::Teamcenter::BulkInput* > *input, ::Teamcenter::BulkData *bulkData );


    ///
    /// The operation marks design revision (ItemRevision) as primary design on a part (Bom0AbstractPart). This will remove existing primary design (if any).
    /// @version Teamcenter 11.2.3
    /// @param input - A vector of data that contains part and corresponding design to be marked as primary design. It should be of type Bom0MarkPrimaryDesignInput.
    /// @param bulkData - A data structure to store objects and other information relevant for set based operation.
    /// @return - This operation returns ITK_ok on success and error code on failure.
    ///
    int  bom0MarkPrimaryDesignBase( std::vector<  ::Teamcenter::BulkInput* > *input, ::Teamcenter::BulkData *bulkData );


    ///
    /// The operation un-aligns part (Bom0AbstractPart) and design revision(s) (ItemRevision). If the primary design is being un-aligned, primary relationship will also be removed.
    /// @version Teamcenter 11.2.3
    /// @param input - A vector of data that contains part and corresponding design revision(s) for unalignment. It should be of type Bom0PartDesignUnAlgnmtInput.
    /// @param bulkData - A data structure to store objects and other information relevant for set based operation.
    /// @return - This operation returns ITK_ok on success and error code on failure.
    ///
    int  bom0UnAlignDesignsBase( std::vector<  ::Teamcenter::BulkInput* > *input, ::Teamcenter::BulkData *bulkData );



protected:
    //  Pointer to the instance
    static Bom0AbstractPartDelegate*  m_pInstance;

    Bom0AbstractPartDelegate();
    virtual ~Bom0AbstractPartDelegate();
    static void setInstance( Bom0AbstractPartDelegate*  instance );


private:
    friend class  ::Teamcenter::Bom0bommanagement::Bom0AbstractPartGenImpl;

};

#include <Bom0bommanagement/libbom0bommanagement_undef.h>
#endif  //  TEAMCENTER__BOM0BOMMANAGEMENT__BOM0ABSTRACTPARTDELEGATE_HXX
