//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Bom0AbstractPartUsage
    Filename:   Bom0AbstractPartUsage.hxx
    Module:     Bom0bommanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOM0BOMMANAGEMENT__BOM0ABSTRACTPARTUSAGE__HXX
#define TEAMCENTER__BOM0BOMMANAGEMENT__BOM0ABSTRACTPARTUSAGE__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0ConditionalElement.hxx>

#include <Bom0bommanagement/libbom0bommanagement_exports.h>

namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPartUsage;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPartUsageImpl;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPartUsageDelegate;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPartUsageDispatch;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPartUsageGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BOM0BOMMANAGEMENT_API  Teamcenter::Bom0bommanagement::Bom0AbstractPartUsage
     : public  ::Teamcenter::AppModel::Mdl0ConditionalElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for Property Display Value
    /// @version Teamcenter 11.2.3
    /// @param values - Parameter value
    /// @return - Status. 0 if successful
    ///
    int  getBom0QuantityDisplayableValues( std::vector< std::string > &values );

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getBom0WherePartitioned( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for a Double Property
    /// @version Teamcenter 11.6
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setBom0Quantity( double value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Bom0AbstractPartUsage();

    /**
     * Destructor
     */
    virtual ~Bom0AbstractPartUsage();

private:
    //  Getter method for the Implementation Object
    Bom0AbstractPartUsageImpl*  getBom0AbstractPartUsageImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBom0AbstractPartUsageImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Bom0AbstractPartUsageImpl*  m_bom0abstractpartusageImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Bom0AbstractPartUsage - desc for Bom0AbstractPartUsage parameter
     */
    Bom0AbstractPartUsage( const Bom0AbstractPartUsage& );
    Bom0AbstractPartUsage& operator=( const Bom0AbstractPartUsage& );

    friend class  Bom0AbstractPartUsageDelegate;
    friend class  Bom0AbstractPartUsageDispatch;
    friend class  Bom0AbstractPartUsageGenImpl;
};

#include <Bom0bommanagement/libbom0bommanagement_undef.h>
#endif //   TEAMCENTER__BOM0BOMMANAGEMENT__BOM0ABSTRACTPARTUSAGE__HXX
