//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Bom0AbstractPartUsageAlgnmt
    Filename:   Bom0AbstractPartUsageAlgnmt.hxx
    Module:     Bom0bommanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOM0BOMMANAGEMENT__BOM0ABSTRACTPARTUSAGEALGNMT__HXX
#define TEAMCENTER__BOM0BOMMANAGEMENT__BOM0ABSTRACTPARTUSAGEALGNMT__HXX

#include <metaframework/BulkInput.hxx>
#include <metaframework/BulkData.hxx>
#include <common/tc_deprecation_macros.h>
#include <Bom0bommanagement/Bom0AbstractUsageAlignment.hxx>

#include <Bom0bommanagement/libbom0bommanagement_exports.h>

namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPartUsageAlgnmt;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPartUsageAlgnmtImpl;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPartUsageAlgnmtDelegate;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPartUsageAlgnmtDispatch;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPartUsageAlgnmtGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BOM0BOMMANAGEMENT_API  Teamcenter::Bom0bommanagement::Bom0AbstractPartUsageAlgnmt
     : public  ::Teamcenter::Bom0bommanagement::Bom0AbstractUsageAlignment
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// This operation removes the input design component(s) from Part Usage Alignment object
    /// @version Teamcenter 11.2.3
    /// @param alignmentInputs - An input vector of type Bom0PUDEAlgnmtInput objects
    /// @param bulkData - A data structure to store objects for set based operation.
    /// @return - This operation returns ITK_ok on success and error code on failure.
    ///
    static int  bom0RemoveDesignElements( const std::vector<  ::Teamcenter::BulkInput* > *alignmentInputs, ::Teamcenter::BulkData *bulkData );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Bom0AbstractPartUsageAlgnmt();

    /**
     * Destructor
     */
    virtual ~Bom0AbstractPartUsageAlgnmt();

private:
    //  Getter method for the Implementation Object
    Bom0AbstractPartUsageAlgnmtImpl*  getBom0AbstractPartUsageAlgnmtImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBom0AbstractPartUsageAlgnmtImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Bom0AbstractPartUsageAlgnmtImpl*  m_bom0abstractpartusagealgnmtImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Bom0AbstractPartUsageAlgnmt - desc for Bom0AbstractPartUsageAlgnmt parameter
     */
    Bom0AbstractPartUsageAlgnmt( const Bom0AbstractPartUsageAlgnmt& );
    Bom0AbstractPartUsageAlgnmt& operator=( const Bom0AbstractPartUsageAlgnmt& );

    friend class  Bom0AbstractPartUsageAlgnmtDelegate;
    friend class  Bom0AbstractPartUsageAlgnmtDispatch;
    friend class  Bom0AbstractPartUsageAlgnmtGenImpl;
};

#include <Bom0bommanagement/libbom0bommanagement_undef.h>
#endif //   TEAMCENTER__BOM0BOMMANAGEMENT__BOM0ABSTRACTPARTUSAGEALGNMT__HXX
