//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Bom0AbstractPartUsageAlgnmtDelegate
    Filename:   Bom0AbstractPartUsageAlgnmtDelegate.hxx
    Module:     Bom0bommanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOM0BOMMANAGEMENT__BOM0ABSTRACTPARTUSAGEALGNMTDELEGATE_HXX
#define TEAMCENTER__BOM0BOMMANAGEMENT__BOM0ABSTRACTPARTUSAGEALGNMTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Bom0bommanagement/Bom0AbstractPartUsageAlgnmt.hxx>

#include <Bom0bommanagement/libbom0bommanagement_exports.h>

namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPartUsageAlgnmtDelegate;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPartUsageAlgnmtImpl;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPartUsageAlgnmt;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPartUsageAlgnmtGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  BOM0BOMMANAGEMENT_API Teamcenter_alias::Bom0bommanagement::Bom0AbstractPartUsageAlgnmtDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Bom0AbstractPartUsageAlgnmtDelegate instance
    static Bom0AbstractPartUsageAlgnmtDelegate&  getInstance();

    //  Method to create the Bom0AbstractPartUsageAlgnmtImpl pointer
    static Bom0AbstractPartUsageAlgnmtImpl*  createImpl( Bom0AbstractPartUsageAlgnmt&  ifObj );

    //  Method to delete the Bom0AbstractPartUsageAlgnmtImpl pointer
    static void deleteImpl( Bom0AbstractPartUsageAlgnmtImpl*  impl );


    ///
    /// This operation removes the input design component(s) from Part Usage Alignment object
    /// @version Teamcenter 11.2.3
    /// @param alignmentInputs - An input vector of type Bom0PUDEAlgnmtInput objects
    /// @param bulkData - A data structure to store objects for set based operation.
    /// @return - This operation returns ITK_ok on success and error code on failure.
    ///
    int  bom0RemoveDesignElementsBase( const std::vector<  ::Teamcenter::BulkInput* > *alignmentInputs, ::Teamcenter::BulkData *bulkData );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Bom0AbstractPartUsageAlgnmt &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Bom0AbstractPartUsageAlgnmtDelegate*  m_pInstance;

    Bom0AbstractPartUsageAlgnmtDelegate();
    virtual ~Bom0AbstractPartUsageAlgnmtDelegate();
    static void setInstance( Bom0AbstractPartUsageAlgnmtDelegate*  instance );


private:
    friend class  ::Teamcenter::Bom0bommanagement::Bom0AbstractPartUsageAlgnmtGenImpl;

};

#include <Bom0bommanagement/libbom0bommanagement_undef.h>
#endif  //  TEAMCENTER__BOM0BOMMANAGEMENT__BOM0ABSTRACTPARTUSAGEALGNMTDELEGATE_HXX
