//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Bom0AbstractPartUsageDelegate
    Filename:   Bom0AbstractPartUsageDelegate.hxx
    Module:     Bom0bommanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOM0BOMMANAGEMENT__BOM0ABSTRACTPARTUSAGEDELEGATE_HXX
#define TEAMCENTER__BOM0BOMMANAGEMENT__BOM0ABSTRACTPARTUSAGEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Bom0bommanagement/Bom0AbstractPartUsage.hxx>

#include <Bom0bommanagement/libbom0bommanagement_exports.h>

namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPartUsageDelegate;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPartUsageImpl;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPartUsage;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPartUsageGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  BOM0BOMMANAGEMENT_API Teamcenter_alias::Bom0bommanagement::Bom0AbstractPartUsageDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Bom0AbstractPartUsageDelegate instance
    static Bom0AbstractPartUsageDelegate&  getInstance();

    //  Method to create the Bom0AbstractPartUsageImpl pointer
    static Bom0AbstractPartUsageImpl*  createImpl( Bom0AbstractPartUsage&  ifObj );

    //  Method to delete the Bom0AbstractPartUsageImpl pointer
    static void deleteImpl( Bom0AbstractPartUsageImpl*  impl );


    ///
    /// Getter for Property Display Value
    /// @version Teamcenter 11.2.3
    /// @param values - Parameter value
    /// @return - Status. 0 if successful
    ///
    int  getBom0QuantityDisplayableValuesBase(Bom0AbstractPartUsage &ifObj,  std::vector< std::string > &values );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getBom0WherePartitionedBase(const Bom0AbstractPartUsage &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a Double Property
    /// @version Teamcenter 11.6
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setBom0QuantityBase(Bom0AbstractPartUsage &ifObj,  double value, bool isNull );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Bom0AbstractPartUsage &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Bom0AbstractPartUsage &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.3
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0PerformDeepCopyBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// perform deep copy
    /// @version Teamcenter 9
    /// @param pOperationInput - desc
    /// @param vecDeepCopyData - deep copy data
    /// @return - returns an int
    ///
    int  performDeepCopyBase(const Bom0AbstractPartUsage &ifObj,  ::Teamcenter::OperationInput *pOperationInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Bom0AbstractPartUsage &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Bom0AbstractPartUsageDelegate*  m_pInstance;

    Bom0AbstractPartUsageDelegate();
    virtual ~Bom0AbstractPartUsageDelegate();
    static void setInstance( Bom0AbstractPartUsageDelegate*  instance );


private:
    friend class  ::Teamcenter::Bom0bommanagement::Bom0AbstractPartUsageGenImpl;

};

#include <Bom0bommanagement/libbom0bommanagement_undef.h>
#endif  //  TEAMCENTER__BOM0BOMMANAGEMENT__BOM0ABSTRACTPARTUSAGEDELEGATE_HXX
