//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Bom0AbstractPartUsageThread
    Filename:   Bom0AbstractPartUsageThread.hxx
    Module:     Bom0bommanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOM0BOMMANAGEMENT__BOM0ABSTRACTPARTUSAGETHREAD__HXX
#define TEAMCENTER__BOM0BOMMANAGEMENT__BOM0ABSTRACTPARTUSAGETHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0ElementThread.hxx>

#include <Bom0bommanagement/libbom0bommanagement_exports.h>

namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPartUsageThread;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPartUsageThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPartUsageThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPartUsageThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPartUsageThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BOM0BOMMANAGEMENT_API  Teamcenter::Bom0bommanagement::Bom0AbstractPartUsageThread
     : public  ::Teamcenter::AppModel::Mdl0ElementThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Bom0AbstractPartUsageThread();

    /**
     * Destructor
     */
    virtual ~Bom0AbstractPartUsageThread();

private:
    //  Getter method for the Implementation Object
    Bom0AbstractPartUsageThreadImpl*  getBom0AbstractPartUsageThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBom0AbstractPartUsageThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Bom0AbstractPartUsageThreadImpl*  m_bom0abstractpartusagethreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Bom0AbstractPartUsageThread - desc for Bom0AbstractPartUsageThread parameter
     */
    Bom0AbstractPartUsageThread( const Bom0AbstractPartUsageThread& );
    Bom0AbstractPartUsageThread& operator=( const Bom0AbstractPartUsageThread& );

    friend class  Bom0AbstractPartUsageThreadDelegate;
    friend class  Bom0AbstractPartUsageThreadDispatch;
    friend class  Bom0AbstractPartUsageThreadGenImpl;
};

#include <Bom0bommanagement/libbom0bommanagement_undef.h>
#endif //   TEAMCENTER__BOM0BOMMANAGEMENT__BOM0ABSTRACTPARTUSAGETHREAD__HXX
