//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Bom0AbstractStructAlgnmtThd
    Filename:   Bom0AbstractStructAlgnmtThd.hxx
    Module:     Bom0bommanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOM0BOMMANAGEMENT__BOM0ABSTRACTSTRUCTALGNMTTHD__HXX
#define TEAMCENTER__BOM0BOMMANAGEMENT__BOM0ABSTRACTSTRUCTALGNMTTHD__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Fnd0WSOThread.hxx>

#include <Bom0bommanagement/libbom0bommanagement_exports.h>

namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractStructAlgnmtThd;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractStructAlgnmtThdImpl;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractStructAlgnmtThdDelegate;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractStructAlgnmtThdDispatch;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractStructAlgnmtThdGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BOM0BOMMANAGEMENT_API  Teamcenter::Bom0bommanagement::Bom0AbstractStructAlgnmtThd
     : public  ::Teamcenter::Fnd0WSOThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Bom0AbstractStructAlgnmtThd();

    /**
     * Destructor
     */
    virtual ~Bom0AbstractStructAlgnmtThd();

private:
    //  Getter method for the Implementation Object
    Bom0AbstractStructAlgnmtThdImpl*  getBom0AbstractStructAlgnmtThdImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBom0AbstractStructAlgnmtThdImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Bom0AbstractStructAlgnmtThdImpl*  m_bom0abstractstructalgnmtthdImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Bom0AbstractStructAlgnmtThd - desc for Bom0AbstractStructAlgnmtThd parameter
     */
    Bom0AbstractStructAlgnmtThd( const Bom0AbstractStructAlgnmtThd& );
    Bom0AbstractStructAlgnmtThd& operator=( const Bom0AbstractStructAlgnmtThd& );

    friend class  Bom0AbstractStructAlgnmtThdDelegate;
    friend class  Bom0AbstractStructAlgnmtThdDispatch;
    friend class  Bom0AbstractStructAlgnmtThdGenImpl;
};

#include <Bom0bommanagement/libbom0bommanagement_undef.h>
#endif //   TEAMCENTER__BOM0BOMMANAGEMENT__BOM0ABSTRACTSTRUCTALGNMTTHD__HXX
