//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Bom0AbstractUsageAlignment
    Filename:   Bom0AbstractUsageAlignment.hxx
    Module:     Bom0bommanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOM0BOMMANAGEMENT__BOM0ABSTRACTUSAGEALIGNMENT__HXX
#define TEAMCENTER__BOM0BOMMANAGEMENT__BOM0ABSTRACTUSAGEALIGNMENT__HXX

#include <common/tc_deprecation_macros.h>
#include <Bom0bommanagement/Bom0ConfigurableBomElement.hxx>

#include <Bom0bommanagement/libbom0bommanagement_exports.h>

namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractUsageAlignment;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractUsageAlignmentImpl;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractUsageAlignmentDelegate;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractUsageAlignmentDispatch;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractUsageAlignmentGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BOM0BOMMANAGEMENT_API  Teamcenter::Bom0bommanagement::Bom0AbstractUsageAlignment
     : public  ::Teamcenter::Bom0bommanagement::Bom0ConfigurableBomElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Bom0AbstractUsageAlignment();

    /**
     * Destructor
     */
    virtual ~Bom0AbstractUsageAlignment();

private:
    //  Getter method for the Implementation Object
    Bom0AbstractUsageAlignmentImpl*  getBom0AbstractUsageAlignmentImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBom0AbstractUsageAlignmentImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Bom0AbstractUsageAlignmentImpl*  m_bom0abstractusagealignmentImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Bom0AbstractUsageAlignment - desc for Bom0AbstractUsageAlignment parameter
     */
    Bom0AbstractUsageAlignment( const Bom0AbstractUsageAlignment& );
    Bom0AbstractUsageAlignment& operator=( const Bom0AbstractUsageAlignment& );

    friend class  Bom0AbstractUsageAlignmentDelegate;
    friend class  Bom0AbstractUsageAlignmentDispatch;
    friend class  Bom0AbstractUsageAlignmentGenImpl;
};

#include <Bom0bommanagement/libbom0bommanagement_undef.h>
#endif //   TEAMCENTER__BOM0BOMMANAGEMENT__BOM0ABSTRACTUSAGEALIGNMENT__HXX
