//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Bom0CompositePBESubstituteDelegate
    Filename:   Bom0CompositePBESubstituteDelegate.hxx
    Module:     Bom0bommanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOM0BOMMANAGEMENT__BOM0COMPOSITEPBESUBSTITUTEDELEGATE_HXX
#define TEAMCENTER__BOM0BOMMANAGEMENT__BOM0COMPOSITEPBESUBSTITUTEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Bom0bommanagement/Bom0CompositePBESubstitute.hxx>

#include <Bom0bommanagement/libbom0bommanagement_exports.h>

namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0CompositePBESubstituteDelegate;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0CompositePBESubstituteImpl;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0CompositePBESubstitute;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0CompositePBESubstituteGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  BOM0BOMMANAGEMENT_API Teamcenter_alias::Bom0bommanagement::Bom0CompositePBESubstituteDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Bom0CompositePBESubstituteDelegate instance
    static Bom0CompositePBESubstituteDelegate&  getInstance();

    //  Method to create the Bom0CompositePBESubstituteImpl pointer
    static Bom0CompositePBESubstituteImpl*  createImpl( Bom0CompositePBESubstitute&  ifObj );

    //  Method to delete the Bom0CompositePBESubstituteImpl pointer
    static void deleteImpl( Bom0CompositePBESubstituteImpl*  impl );


    ///
    /// This is the getter for retrieving the recipe/permanent ID if its been created (and cached on the instance). Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param uid - Recipe/permanent ID
    /// @param isFirstTime - If Session Recovery Uid is yet to be set or does the object need to be serialized again?
    /// @return - Failure code
    ///
    int  fnd0AskSRUidBase(const Bom0CompositePBESubstitute &ifObj,  std::string *uid, bool *isFirstTime ) const;


    ///
    /// Generates permanent ID/recipe. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param recipe - Permanent ID/recipe
    /// @return - Failure code.
    ///
    int  fnd0GenerateRecipeBase(const Bom0CompositePBESubstitute &ifObj,  std::string *recipe );


    ///
    /// If Business Object supports recoverable ID. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param isPersistedRecipe - isPersistedRecipe param should be set to true if the recipe is limited to the user session and should be serialized to the database
    /// @param isRecoverableIDSupported - Returning true indicates support for recoverability/permanent IDs
    /// @return - Failure code.
    ///
    int  fnd0IsRecoverableBase(const Bom0CompositePBESubstitute &ifObj,  bool *isPersistedRecipe, bool *isRecoverableIDSupported ) const;


    ///
    /// This is the setter for the recipe/permanent ID when it is created (to be cached on the instance). Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param uid - Rrecipe/permanent ID
    /// @return - Failure code.
    ///
    int  fnd0SetSRUidBase(const Bom0CompositePBESubstitute &ifObj,  const std::string *uid );



protected:
    //  Pointer to the instance
    static Bom0CompositePBESubstituteDelegate*  m_pInstance;

    Bom0CompositePBESubstituteDelegate();
    virtual ~Bom0CompositePBESubstituteDelegate();
    static void setInstance( Bom0CompositePBESubstituteDelegate*  instance );


private:
    friend class  ::Teamcenter::Bom0bommanagement::Bom0CompositePBESubstituteGenImpl;

};

#include <Bom0bommanagement/libbom0bommanagement_undef.h>
#endif  //  TEAMCENTER__BOM0BOMMANAGEMENT__BOM0COMPOSITEPBESUBSTITUTEDELEGATE_HXX
