//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Bom0CompositePartUsage
    Filename:   Bom0CompositePartUsage.hxx
    Module:     Bom0bommanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOM0BOMMANAGEMENT__BOM0COMPOSITEPARTUSAGE__HXX
#define TEAMCENTER__BOM0BOMMANAGEMENT__BOM0COMPOSITEPARTUSAGE__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <Bom0bommanagement/libbom0bommanagement_exports.h>

namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0CompositePartUsage;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0CompositePartUsageImpl;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0CompositePartUsageDelegate;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0CompositePartUsageDispatch;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0CompositePartUsageGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BOM0BOMMANAGEMENT_API  Teamcenter::Bom0bommanagement::Bom0CompositePartUsage
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Bom0CompositePartUsage();

    /**
     * Destructor
     */
    virtual ~Bom0CompositePartUsage();

private:
    //  Getter method for the Implementation Object
    Bom0CompositePartUsageImpl*  getBom0CompositePartUsageImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBom0CompositePartUsageImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Bom0CompositePartUsageImpl*  m_bom0compositepartusageImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Bom0CompositePartUsage - desc for Bom0CompositePartUsage parameter
     */
    Bom0CompositePartUsage( const Bom0CompositePartUsage& );
    Bom0CompositePartUsage& operator=( const Bom0CompositePartUsage& );

    friend class  Bom0CompositePartUsageDelegate;
    friend class  Bom0CompositePartUsageDispatch;
    friend class  Bom0CompositePartUsageGenImpl;
};

#include <Bom0bommanagement/libbom0bommanagement_undef.h>
#endif //   TEAMCENTER__BOM0BOMMANAGEMENT__BOM0COMPOSITEPARTUSAGE__HXX
