//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Bom0CompositePartUsageAlignmentDelegate
    Filename:   Bom0CompositePartUsageAlignmentDelegate.hxx
    Module:     Bom0bommanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOM0BOMMANAGEMENT__BOM0COMPOSITEPARTUSAGEALIGNMENTDELEGATE_HXX
#define TEAMCENTER__BOM0BOMMANAGEMENT__BOM0COMPOSITEPARTUSAGEALIGNMENTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Bom0bommanagement/Bom0CompositePartUsageAlignment.hxx>

#include <Bom0bommanagement/libbom0bommanagement_exports.h>

namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0CompositePartUsageAlignmentDelegate;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0CompositePartUsageAlignmentImpl;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0CompositePartUsageAlignment;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0CompositePartUsageAlignmentGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  BOM0BOMMANAGEMENT_API Teamcenter_alias::Bom0bommanagement::Bom0CompositePartUsageAlignmentDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Bom0CompositePartUsageAlignmentDelegate instance
    static Bom0CompositePartUsageAlignmentDelegate&  getInstance();

    //  Method to create the Bom0CompositePartUsageAlignmentImpl pointer
    static Bom0CompositePartUsageAlignmentImpl*  createImpl( Bom0CompositePartUsageAlignment&  ifObj );

    //  Method to delete the Bom0CompositePartUsageAlignmentImpl pointer
    static void deleteImpl( Bom0CompositePartUsageAlignmentImpl*  impl );


    ///
    /// This is the getter for retrieving the recipe/permanent ID if its been created (and cached on the instance). Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param uid - Recipe/permanent ID
    /// @param isFirstTime - If Session Recovery Uid is yet to be set or does the object need to be serialized again?
    /// @return - Failure code
    ///
    int  fnd0AskSRUidBase(const Bom0CompositePartUsageAlignment &ifObj,  std::string *uid, bool *isFirstTime ) const;


    ///
    /// Generates permanent ID/recipe. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param recipe - Permanent ID/recipe
    /// @return - Failure code.
    ///
    int  fnd0GenerateRecipeBase(const Bom0CompositePartUsageAlignment &ifObj,  std::string *recipe );


    ///
    /// If Business Object supports recoverable ID. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param isPersistedRecipe - isPersistedRecipe param should be set to true if the recipe is limited to the user session and should be serialized to the database
    /// @param isRecoverableIDSupported - Returning true indicates support for recoverability/permanent IDs
    /// @return - Failure code.
    ///
    int  fnd0IsRecoverableBase(const Bom0CompositePartUsageAlignment &ifObj,  bool *isPersistedRecipe, bool *isRecoverableIDSupported ) const;


    ///
    /// This is the setter for the recipe/permanent ID when it is created (to be cached on the instance). Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param uid - Rrecipe/permanent ID
    /// @return - Failure code.
    ///
    int  fnd0SetSRUidBase(const Bom0CompositePartUsageAlignment &ifObj,  const std::string *uid );


    ///
    /// validate saveas input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  validateSaveAsInputBase(const Bom0CompositePartUsageAlignment &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static Bom0CompositePartUsageAlignmentDelegate*  m_pInstance;

    Bom0CompositePartUsageAlignmentDelegate();
    virtual ~Bom0CompositePartUsageAlignmentDelegate();
    static void setInstance( Bom0CompositePartUsageAlignmentDelegate*  instance );


private:
    friend class  ::Teamcenter::Bom0bommanagement::Bom0CompositePartUsageAlignmentGenImpl;

};

#include <Bom0bommanagement/libbom0bommanagement_undef.h>
#endif  //  TEAMCENTER__BOM0BOMMANAGEMENT__BOM0COMPOSITEPARTUSAGEALIGNMENTDELEGATE_HXX
