//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Bom0EffectivityExprBlock
    Filename:   Bom0EffectivityExprBlock.hxx
    Module:     Bom0bommanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOM0BOMMANAGEMENT__BOM0EFFECTIVITYEXPRBLOCK__HXX
#define TEAMCENTER__BOM0BOMMANAGEMENT__BOM0EFFECTIVITYEXPRBLOCK__HXX

#include <common/tc_deprecation_macros.h>
#include <fnd0booleansolve/Fnd0EffectivityExprBlock.hxx>

#include <Bom0bommanagement/libbom0bommanagement_exports.h>

namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0EffectivityExprBlock;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0EffectivityExprBlockImpl;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0EffectivityExprBlockDelegate;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0EffectivityExprBlockDispatch;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0EffectivityExprBlockGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BOM0BOMMANAGEMENT_API  Teamcenter::Bom0bommanagement::Bom0EffectivityExprBlock
     : public  ::Teamcenter::Fnd0EffectivityExprBlock
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Bom0EffectivityExprBlock();

    /**
     * Destructor
     */
    virtual ~Bom0EffectivityExprBlock();

private:
    //  Getter method for the Implementation Object
    Bom0EffectivityExprBlockImpl*  getBom0EffectivityExprBlockImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBom0EffectivityExprBlockImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Bom0EffectivityExprBlockImpl*  m_bom0effectivityexprblockImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Bom0EffectivityExprBlock - desc for Bom0EffectivityExprBlock parameter
     */
    Bom0EffectivityExprBlock( const Bom0EffectivityExprBlock& );
    Bom0EffectivityExprBlock& operator=( const Bom0EffectivityExprBlock& );

    friend class  Bom0EffectivityExprBlockDelegate;
    friend class  Bom0EffectivityExprBlockDispatch;
    friend class  Bom0EffectivityExprBlockGenImpl;
};

#include <Bom0bommanagement/libbom0bommanagement_undef.h>
#endif //   TEAMCENTER__BOM0BOMMANAGEMENT__BOM0EFFECTIVITYEXPRBLOCK__HXX
