//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Bom0MarkPrimaryDesignInput
    Filename:   Bom0MarkPrimaryDesignInput.hxx
    Module:     Bom0bommanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOM0BOMMANAGEMENT__BOM0MARKPRIMARYDESIGNINPUT__HXX
#define TEAMCENTER__BOM0BOMMANAGEMENT__BOM0MARKPRIMARYDESIGNINPUT__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/BulkInput.hxx>

#include <Bom0bommanagement/libbom0bommanagement_exports.h>

namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0MarkPrimaryDesignInput;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0MarkPrimaryDesignInputImpl;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0MarkPrimaryDesignInputDelegate;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0MarkPrimaryDesignInputDispatch;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0MarkPrimaryDesignInputGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BOM0BOMMANAGEMENT_API  Teamcenter::Bom0bommanagement::Bom0MarkPrimaryDesignInput
     : public  ::Teamcenter::BulkInput
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Bom0MarkPrimaryDesignInput();

    /**
     * Destructor
     */
    virtual ~Bom0MarkPrimaryDesignInput();

private:
    //  Getter method for the Implementation Object
    Bom0MarkPrimaryDesignInputImpl*  getBom0MarkPrimaryDesignInputImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBom0MarkPrimaryDesignInputImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Bom0MarkPrimaryDesignInputImpl*  m_bom0markprimarydesigninputImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Bom0MarkPrimaryDesignInput - desc for Bom0MarkPrimaryDesignInput parameter
     */
    Bom0MarkPrimaryDesignInput( const Bom0MarkPrimaryDesignInput& );
    Bom0MarkPrimaryDesignInput& operator=( const Bom0MarkPrimaryDesignInput& );

    friend class  Bom0MarkPrimaryDesignInputDelegate;
    friend class  Bom0MarkPrimaryDesignInputDispatch;
    friend class  Bom0MarkPrimaryDesignInputGenImpl;
};

#include <Bom0bommanagement/libbom0bommanagement_undef.h>
#endif //   TEAMCENTER__BOM0BOMMANAGEMENT__BOM0MARKPRIMARYDESIGNINPUT__HXX
