//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Bom0OccDesignator
    Filename:   Bom0OccDesignator.hxx
    Module:     Bom0bommanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOM0BOMMANAGEMENT__BOM0OCCDESIGNATOR__HXX
#define TEAMCENTER__BOM0BOMMANAGEMENT__BOM0OCCDESIGNATOR__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <Bom0bommanagement/libbom0bommanagement_exports.h>

namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0OccDesignator;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0OccDesignatorImpl;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0OccDesignatorDelegate;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0OccDesignatorDispatch;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0OccDesignatorGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BOM0BOMMANAGEMENT_API  Teamcenter::Bom0bommanagement::Bom0OccDesignator
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Bom0OccDesignator();

    /**
     * Destructor
     */
    virtual ~Bom0OccDesignator();

private:
    //  Getter method for the Implementation Object
    Bom0OccDesignatorImpl*  getBom0OccDesignatorImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBom0OccDesignatorImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Bom0OccDesignatorImpl*  m_bom0occdesignatorImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Bom0OccDesignator - desc for Bom0OccDesignator parameter
     */
    Bom0OccDesignator( const Bom0OccDesignator& );
    Bom0OccDesignator& operator=( const Bom0OccDesignator& );

    friend class  Bom0OccDesignatorDelegate;
    friend class  Bom0OccDesignatorDispatch;
    friend class  Bom0OccDesignatorGenImpl;
};

#include <Bom0bommanagement/libbom0bommanagement_undef.h>
#endif //   TEAMCENTER__BOM0BOMMANAGEMENT__BOM0OCCDESIGNATOR__HXX
