//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Bom0PBELine
    Filename:   Bom0PBELine.hxx
    Module:     Bom0bommanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOM0BOMMANAGEMENT__BOM0PBELINE__HXX
#define TEAMCENTER__BOM0BOMMANAGEMENT__BOM0PBELINE__HXX

#include <metaframework/BulkInput.hxx>
#include <metaframework/BulkData.hxx>
#include <common/tc_deprecation_macros.h>
#include <bom/BOMLine.hxx>

#include <Bom0bommanagement/libbom0bommanagement_exports.h>

namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PBELine;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PBELineImpl;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PBELineDelegate;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PBELineDispatch;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PBELineGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BOM0BOMMANAGEMENT_API  Teamcenter::Bom0bommanagement::Bom0PBELine
     : public  ::Teamcenter::BOMLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// The operation aligns part occurences (Bom0PBELine) with design occurrences (ImanItemLine). The operation returns corresponding alignment information. If the inputs are already aligned this operation returns the existing alignment information.
    /// @version Teamcenter 11.2.3
    /// @param input - A vector of data that contains part occurrence, design occurrence as input and alignment information as output. It should be of type Bom0PartOccAlgnmtInputOp.
    /// @param bulkData - A data structure to store objects and other information relevant for set based operation.
    /// @return - This operation returns ITK_ok on success and error code on failure.
    ///
    static int  bom0AlignPartOccurrences( std::vector<  ::Teamcenter::BulkInput* > *input, ::Teamcenter::BulkData *bulkData );

    ///
    /// This operation un-aligns part occurences (Bom0PBELine) and design occurrences (ImanItemLine). User can also un-align the children of each input part occurence. If input part occurence is not aligned to any design occurrence, this operation does not update the input part occurence.
    /// @version Teamcenter 11.2.3
    /// @param input - A vector of data that contains part occurrence and intent of user to un-align child part occurrences of input Bom0PBELine. It should be of type Bom0PartOccUnAlgnmtInput.
    /// @param bulkData - A data structure to store objects and other information relevant for set based operation.
    /// @return - This operation returns ITK_ok on success and error code on failure.
    ///
    static int  bom0UnAlignPartOccurrences( std::vector<  ::Teamcenter::BulkInput* > *input, ::Teamcenter::BulkData *bulkData );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Bom0PBELine();

    /**
     * Destructor
     */
    virtual ~Bom0PBELine();

private:
    //  Getter method for the Implementation Object
    Bom0PBELineImpl*  getBom0PBELineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBom0PBELineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Bom0PBELineImpl*  m_bom0pbelineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Bom0PBELine - desc for Bom0PBELine parameter
     */
    Bom0PBELine( const Bom0PBELine& );
    Bom0PBELine& operator=( const Bom0PBELine& );

    friend class  Bom0PBELineDelegate;
    friend class  Bom0PBELineDispatch;
    friend class  Bom0PBELineGenImpl;
};

#include <Bom0bommanagement/libbom0bommanagement_undef.h>
#endif //   TEAMCENTER__BOM0BOMMANAGEMENT__BOM0PBELINE__HXX
