//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Bom0PUDEAlgnmtInput
    Filename:   Bom0PUDEAlgnmtInput.hxx
    Module:     Bom0bommanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOM0BOMMANAGEMENT__BOM0PUDEALGNMTINPUT__HXX
#define TEAMCENTER__BOM0BOMMANAGEMENT__BOM0PUDEALGNMTINPUT__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/BulkInput.hxx>

#include <Bom0bommanagement/libbom0bommanagement_exports.h>

namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PUDEAlgnmtInput;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PUDEAlgnmtInputImpl;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PUDEAlgnmtInputDelegate;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PUDEAlgnmtInputDispatch;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PUDEAlgnmtInputGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BOM0BOMMANAGEMENT_API  Teamcenter::Bom0bommanagement::Bom0PUDEAlgnmtInput
     : public  ::Teamcenter::BulkInput
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Bom0PUDEAlgnmtInput();

    /**
     * Destructor
     */
    virtual ~Bom0PUDEAlgnmtInput();

private:
    //  Getter method for the Implementation Object
    Bom0PUDEAlgnmtInputImpl*  getBom0PUDEAlgnmtInputImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBom0PUDEAlgnmtInputImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Bom0PUDEAlgnmtInputImpl*  m_bom0pudealgnmtinputImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Bom0PUDEAlgnmtInput - desc for Bom0PUDEAlgnmtInput parameter
     */
    Bom0PUDEAlgnmtInput( const Bom0PUDEAlgnmtInput& );
    Bom0PUDEAlgnmtInput& operator=( const Bom0PUDEAlgnmtInput& );

    friend class  Bom0PUDEAlgnmtInputDelegate;
    friend class  Bom0PUDEAlgnmtInputDispatch;
    friend class  Bom0PUDEAlgnmtInputGenImpl;
};

#include <Bom0bommanagement/libbom0bommanagement_undef.h>
#endif //   TEAMCENTER__BOM0BOMMANAGEMENT__BOM0PUDEALGNMTINPUT__HXX
