//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Bom0PUSubstitute
    Filename:   Bom0PUSubstitute.hxx
    Module:     Bom0bommanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOM0BOMMANAGEMENT__BOM0PUSUBSTITUTE__HXX
#define TEAMCENTER__BOM0BOMMANAGEMENT__BOM0PUSUBSTITUTE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <Bom0bommanagement/libbom0bommanagement_exports.h>

namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PUSubstitute;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PUSubstituteImpl;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PUSubstituteDelegate;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PUSubstituteDispatch;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PUSubstituteGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BOM0BOMMANAGEMENT_API  Teamcenter::Bom0bommanagement::Bom0PUSubstitute
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Bom0PUSubstitute();

    /**
     * Destructor
     */
    virtual ~Bom0PUSubstitute();

private:
    //  Getter method for the Implementation Object
    Bom0PUSubstituteImpl*  getBom0PUSubstituteImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBom0PUSubstituteImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Bom0PUSubstituteImpl*  m_bom0pusubstituteImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Bom0PUSubstitute - desc for Bom0PUSubstitute parameter
     */
    Bom0PUSubstitute( const Bom0PUSubstitute& );
    Bom0PUSubstitute& operator=( const Bom0PUSubstitute& );

    friend class  Bom0PUSubstituteDelegate;
    friend class  Bom0PUSubstituteDispatch;
    friend class  Bom0PUSubstituteGenImpl;
};

#include <Bom0bommanagement/libbom0bommanagement_undef.h>
#endif //   TEAMCENTER__BOM0BOMMANAGEMENT__BOM0PUSUBSTITUTE__HXX
