//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Bom0PUSubstituteDelegate
    Filename:   Bom0PUSubstituteDelegate.hxx
    Module:     Bom0bommanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOM0BOMMANAGEMENT__BOM0PUSUBSTITUTEDELEGATE_HXX
#define TEAMCENTER__BOM0BOMMANAGEMENT__BOM0PUSUBSTITUTEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Bom0bommanagement/Bom0PUSubstitute.hxx>

#include <Bom0bommanagement/libbom0bommanagement_exports.h>

namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PUSubstituteDelegate;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PUSubstituteImpl;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PUSubstitute;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PUSubstituteGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  BOM0BOMMANAGEMENT_API Teamcenter_alias::Bom0bommanagement::Bom0PUSubstituteDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Bom0PUSubstituteDelegate instance
    static Bom0PUSubstituteDelegate&  getInstance();

    //  Method to create the Bom0PUSubstituteImpl pointer
    static Bom0PUSubstituteImpl*  createImpl( Bom0PUSubstitute&  ifObj );

    //  Method to delete the Bom0PUSubstituteImpl pointer
    static void deleteImpl( Bom0PUSubstituteImpl*  impl );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Bom0PUSubstitute &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// finalize operation input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  finalizeSaveAsInputBase(const Bom0PUSubstitute &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.3
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0FinalizeSaveAsInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.3
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0PerformDeepCopyBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// perform deep copy
    /// @version Teamcenter 9
    /// @param pOperationInput - desc
    /// @param vecDeepCopyData - deep copy data
    /// @return - returns an int
    ///
    int  performDeepCopyBase(const Bom0PUSubstitute &ifObj,  ::Teamcenter::OperationInput *pOperationInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static Bom0PUSubstituteDelegate*  m_pInstance;

    Bom0PUSubstituteDelegate();
    virtual ~Bom0PUSubstituteDelegate();
    static void setInstance( Bom0PUSubstituteDelegate*  instance );


private:
    friend class  ::Teamcenter::Bom0bommanagement::Bom0PUSubstituteGenImpl;

};

#include <Bom0bommanagement/libbom0bommanagement_undef.h>
#endif  //  TEAMCENTER__BOM0BOMMANAGEMENT__BOM0PUSUBSTITUTEDELEGATE_HXX
