//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Bom0PartDesignAlgnmtInput
    Filename:   Bom0PartDesignAlgnmtInput.hxx
    Module:     Bom0bommanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOM0BOMMANAGEMENT__BOM0PARTDESIGNALGNMTINPUT__HXX
#define TEAMCENTER__BOM0BOMMANAGEMENT__BOM0PARTDESIGNALGNMTINPUT__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/BulkInput.hxx>

#include <Bom0bommanagement/libbom0bommanagement_exports.h>

namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PartDesignAlgnmtInput;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PartDesignAlgnmtInputImpl;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PartDesignAlgnmtInputDelegate;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PartDesignAlgnmtInputDispatch;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PartDesignAlgnmtInputGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BOM0BOMMANAGEMENT_API  Teamcenter::Bom0bommanagement::Bom0PartDesignAlgnmtInput
     : public  ::Teamcenter::BulkInput
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Bom0PartDesignAlgnmtInput();

    /**
     * Destructor
     */
    virtual ~Bom0PartDesignAlgnmtInput();

private:
    //  Getter method for the Implementation Object
    Bom0PartDesignAlgnmtInputImpl*  getBom0PartDesignAlgnmtInputImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBom0PartDesignAlgnmtInputImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Bom0PartDesignAlgnmtInputImpl*  m_bom0partdesignalgnmtinputImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Bom0PartDesignAlgnmtInput - desc for Bom0PartDesignAlgnmtInput parameter
     */
    Bom0PartDesignAlgnmtInput( const Bom0PartDesignAlgnmtInput& );
    Bom0PartDesignAlgnmtInput& operator=( const Bom0PartDesignAlgnmtInput& );

    friend class  Bom0PartDesignAlgnmtInputDelegate;
    friend class  Bom0PartDesignAlgnmtInputDispatch;
    friend class  Bom0PartDesignAlgnmtInputGenImpl;
};

#include <Bom0bommanagement/libbom0bommanagement_undef.h>
#endif //   TEAMCENTER__BOM0BOMMANAGEMENT__BOM0PARTDESIGNALGNMTINPUT__HXX
