//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Bom0PartOccurrence
    Filename:   Bom0PartOccurrence.hxx
    Module:     Bom0bommanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOM0BOMMANAGEMENT__BOM0PARTOCCURRENCE__HXX
#define TEAMCENTER__BOM0BOMMANAGEMENT__BOM0PARTOCCURRENCE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <Bom0bommanagement/libbom0bommanagement_exports.h>

namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PartOccurrence;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PartOccurrenceImpl;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PartOccurrenceDelegate;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PartOccurrenceDispatch;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PartOccurrenceGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BOM0BOMMANAGEMENT_API  Teamcenter::Bom0bommanagement::Bom0PartOccurrence
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Bom0PartOccurrence();

    /**
     * Destructor
     */
    virtual ~Bom0PartOccurrence();

private:
    //  Getter method for the Implementation Object
    Bom0PartOccurrenceImpl*  getBom0PartOccurrenceImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBom0PartOccurrenceImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Bom0PartOccurrenceImpl*  m_bom0partoccurrenceImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Bom0PartOccurrence - desc for Bom0PartOccurrence parameter
     */
    Bom0PartOccurrence( const Bom0PartOccurrence& );
    Bom0PartOccurrence& operator=( const Bom0PartOccurrence& );

    friend class  Bom0PartOccurrenceDelegate;
    friend class  Bom0PartOccurrenceDispatch;
    friend class  Bom0PartOccurrenceGenImpl;
};

#include <Bom0bommanagement/libbom0bommanagement_undef.h>
#endif //   TEAMCENTER__BOM0BOMMANAGEMENT__BOM0PARTOCCURRENCE__HXX
