//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Bom0PartStructureWindow
    Filename:   Bom0PartStructureWindow.hxx
    Module:     Bom0bommanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOM0BOMMANAGEMENT__BOM0PARTSTRUCTUREWINDOW__HXX
#define TEAMCENTER__BOM0BOMMANAGEMENT__BOM0PARTSTRUCTUREWINDOW__HXX

#include <common/tc_deprecation_macros.h>
#include <bom/BOMWindow.hxx>

#include <Bom0bommanagement/libbom0bommanagement_exports.h>

namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PartStructureWindow;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PartStructureWindowImpl;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PartStructureWindowDelegate;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PartStructureWindowDispatch;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PartStructureWindowGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BOM0BOMMANAGEMENT_API  Teamcenter::Bom0bommanagement::Bom0PartStructureWindow
     : public  ::Teamcenter::BOMWindow
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Bom0PartStructureWindow();

    /**
     * Destructor
     */
    virtual ~Bom0PartStructureWindow();

private:
    //  Getter method for the Implementation Object
    Bom0PartStructureWindowImpl*  getBom0PartStructureWindowImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBom0PartStructureWindowImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Bom0PartStructureWindowImpl*  m_bom0partstructurewindowImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Bom0PartStructureWindow - desc for Bom0PartStructureWindow parameter
     */
    Bom0PartStructureWindow( const Bom0PartStructureWindow& );
    Bom0PartStructureWindow& operator=( const Bom0PartStructureWindow& );

    friend class  Bom0PartStructureWindowDelegate;
    friend class  Bom0PartStructureWindowDispatch;
    friend class  Bom0PartStructureWindowGenImpl;
};

#include <Bom0bommanagement/libbom0bommanagement_undef.h>
#endif //   TEAMCENTER__BOM0BOMMANAGEMENT__BOM0PARTSTRUCTUREWINDOW__HXX
