//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ItemRevisionDelegate
    Filename:   ItemRevisionDelegateExt.hxx
    Module:     Bom0bommanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef BOM0__TEAMCENTER__BOM0BOMMANAGEMENT__ITEMREVISIONDELEGATE_HXX
#define BOM0__TEAMCENTER__BOM0BOMMANAGEMENT__ITEMREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Bom0bommanagement/ItemRevisionExt.hxx>

#include <Bom0bommanagement/libbom0bommanagement_exports.h>

namespace bom0
{
    namespace Teamcenter
    {
        namespace Bom0bommanagement
        {
            class ItemRevisionDelegate;
        }
    }
}
namespace bom0
{
    namespace Teamcenter
    {
        namespace Bom0bommanagement
        {
            class ItemRevisionImpl;
        }
    }
}
namespace bom0
{
    namespace Teamcenter
    {
        namespace Bom0bommanagement
        {
            class ItemRevision;
        }
    }
}
namespace bom0
{
    namespace Teamcenter
    {
        namespace Bom0bommanagement
        {
            class ItemRevisionGenImpl;
        }
    }
}

namespace bom0_alias = ::bom0;


class  BOM0BOMMANAGEMENT_API bom0_alias::Teamcenter::Bom0bommanagement::ItemRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ItemRevisionDelegate instance
    static ItemRevisionDelegate&  getInstance();

    //  Method to create the ItemRevisionImpl pointer
    static ItemRevisionImpl*  createImpl( ItemRevision&  ifObj );

    //  Method to delete the ItemRevisionImpl pointer
    static void deleteImpl( ItemRevisionImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.2.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getBom0AlignedPartsBase(const ItemRevision &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;



protected:
    //  Pointer to the instance
    static ItemRevisionDelegate*  m_pInstance;

    ItemRevisionDelegate();
    virtual ~ItemRevisionDelegate();
    static void setInstance( ItemRevisionDelegate*  instance );


private:
    friend class  ::bom0::Teamcenter::Bom0bommanagement::ItemRevisionGenImpl;

};

#include <Bom0bommanagement/libbom0bommanagement_undef.h>
#endif  //  BOM0__TEAMCENTER__BOM0BOMMANAGEMENT__ITEMREVISIONDELEGATE_HXX
