//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ItemRevision
    Filename:   ItemRevisionExt.hxx
    Module:     Bom0bommanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef BOM0__TEAMCENTER__BOM0BOMMANAGEMENT__ITEMREVISION__HXX
#define BOM0__TEAMCENTER__BOM0BOMMANAGEMENT__ITEMREVISION__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <metaframework/BusinessObjectExtender.hxx>
#include <metaframework/BusinessObjectExtenderRef.hxx>
#include <metaframework/BusinessObjectExtenderRegistry.hxx>

#include <Bom0bommanagement/libbom0bommanagement_exports.h>

namespace bom0
{
    namespace Teamcenter
    {
        namespace Bom0bommanagement
        {
            class ItemRevision;
        }
    }
}
namespace bom0
{
    namespace Teamcenter
    {
        namespace Bom0bommanagement
        {
            class ItemRevisionImpl;
        }
    }
}
namespace bom0
{
    namespace Teamcenter
    {
        namespace Bom0bommanagement
        {
            class ItemRevisionDelegate;
        }
    }
}
namespace bom0
{
    namespace Teamcenter
    {
        namespace Bom0bommanagement
        {
            class ItemRevisionDispatch;
        }
    }
}
namespace bom0
{
    namespace Teamcenter
    {
        namespace Bom0bommanagement
        {
            class ItemRevisionGenImpl;
        }
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BOM0BOMMANAGEMENT_API  bom0::Teamcenter::Bom0bommanagement::ItemRevision
     : public  ::Teamcenter::BusinessObjectExtender
{
public:

    /**
     * Constructor
     */
    ItemRevision( tag_t  objTag );
    /**
     * Get the Extender Registry
     * @return - return Extender Registry
     */
    static ::Teamcenter::BusinessObjectExtenderRegistry< bom0::Teamcenter::Bom0bommanagement::ItemRevision >&  extenderRegistry();

    /**
     * Get the Extender Interface Name
     * @return - return desc for getExtenderInterfaceName
     */
    static const std::string&  getExtenderInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.2.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getBom0AlignedParts( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );


    /**
     * Destructor
     */
    virtual ~ItemRevision();

private:
    //  Getter method for the Implementation Object
    ItemRevisionImpl*  getItemRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setItemRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ItemRevisionImpl*  m_itemrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ItemRevision - desc for ItemRevision parameter
     */
    ItemRevision( const ItemRevision& );
    ItemRevision& operator=( const ItemRevision& );

    friend class  ItemRevisionDelegate;
    friend class  ItemRevisionDispatch;
    friend class  ItemRevisionGenImpl;
    friend class  ItemRevisionImpl;
};

#include <Bom0bommanagement/libbom0bommanagement_undef.h>
#endif //   BOM0__TEAMCENTER__BOM0BOMMANAGEMENT__ITEMREVISION__HXX
