//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Bom0AbstractPartSourcing
    Filename:   Bom0AbstractPartSourcing.hxx
    Module:     Bom0plantbommgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOM0BOMMANAGEMENT__BOM0ABSTRACTPARTSOURCING__HXX
#define TEAMCENTER__BOM0BOMMANAGEMENT__BOM0ABSTRACTPARTSOURCING__HXX

#include <common/tc_deprecation_macros.h>
#include <Bom0bommanagement/Bom0ConfigurableBomElement.hxx>

#include <Bom0plantbommgmt/libbom0plantbommgmt_exports.h>

namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPartSourcing;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPartSourcingImpl;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPartSourcingDelegate;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPartSourcingDispatch;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPartSourcingGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BOM0PLANTBOMMGMT_API  Teamcenter::Bom0bommanagement::Bom0AbstractPartSourcing
     : public  ::Teamcenter::Bom0bommanagement::Bom0ConfigurableBomElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Bom0AbstractPartSourcing();

    /**
     * Destructor
     */
    virtual ~Bom0AbstractPartSourcing();

private:
    //  Getter method for the Implementation Object
    Bom0AbstractPartSourcingImpl*  getBom0AbstractPartSourcingImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBom0AbstractPartSourcingImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Bom0AbstractPartSourcingImpl*  m_bom0abstractpartsourcingImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Bom0AbstractPartSourcing - desc for Bom0AbstractPartSourcing parameter
     */
    Bom0AbstractPartSourcing( const Bom0AbstractPartSourcing& );
    Bom0AbstractPartSourcing& operator=( const Bom0AbstractPartSourcing& );

    friend class  Bom0AbstractPartSourcingDelegate;
    friend class  Bom0AbstractPartSourcingDispatch;
    friend class  Bom0AbstractPartSourcingGenImpl;
};

#include <Bom0plantbommgmt/libbom0plantbommgmt_undef.h>
#endif //   TEAMCENTER__BOM0BOMMANAGEMENT__BOM0ABSTRACTPARTSOURCING__HXX
