//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Bom0AbstractPSDAlignment
    Filename:   Bom0AbstractPSDAlignment.hxx
    Module:     Bom0psdalignment
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOM0BOMMANAGEMENT__BOM0ABSTRACTPSDALIGNMENT__HXX
#define TEAMCENTER__BOM0BOMMANAGEMENT__BOM0ABSTRACTPSDALIGNMENT__HXX

#include <common/tc_deprecation_macros.h>
#include <Bom0bommanagement/Bom0ConfigurableBomElement.hxx>

#include <Bom0psdalignment/libbom0psdalignment_exports.h>

namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPSDAlignment;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPSDAlignmentImpl;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPSDAlignmentDelegate;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPSDAlignmentDispatch;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPSDAlignmentGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BOM0PSDALIGNMENT_API  Teamcenter::Bom0bommanagement::Bom0AbstractPSDAlignment
     : public  ::Teamcenter::Bom0bommanagement::Bom0ConfigurableBomElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Bom0AbstractPSDAlignment();

    /**
     * Destructor
     */
    virtual ~Bom0AbstractPSDAlignment();

private:
    //  Getter method for the Implementation Object
    Bom0AbstractPSDAlignmentImpl*  getBom0AbstractPSDAlignmentImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBom0AbstractPSDAlignmentImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Bom0AbstractPSDAlignmentImpl*  m_bom0abstractpsdalignmentImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Bom0AbstractPSDAlignment - desc for Bom0AbstractPSDAlignment parameter
     */
    Bom0AbstractPSDAlignment( const Bom0AbstractPSDAlignment& );
    Bom0AbstractPSDAlignment& operator=( const Bom0AbstractPSDAlignment& );

    friend class  Bom0AbstractPSDAlignmentDelegate;
    friend class  Bom0AbstractPSDAlignmentDispatch;
    friend class  Bom0AbstractPSDAlignmentGenImpl;
};

#include <Bom0psdalignment/libbom0psdalignment_undef.h>
#endif //   TEAMCENTER__BOM0BOMMANAGEMENT__BOM0ABSTRACTPSDALIGNMENT__HXX
