//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Bom0AbstractPSDAlignmentThd
    Filename:   Bom0AbstractPSDAlignmentThd.hxx
    Module:     Bom0psdalignment
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOM0BOMMANAGEMENT__BOM0ABSTRACTPSDALIGNMENTTHD__HXX
#define TEAMCENTER__BOM0BOMMANAGEMENT__BOM0ABSTRACTPSDALIGNMENTTHD__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Fnd0WSOThread.hxx>

#include <Bom0psdalignment/libbom0psdalignment_exports.h>

namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPSDAlignmentThd;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPSDAlignmentThdImpl;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPSDAlignmentThdDelegate;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPSDAlignmentThdDispatch;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0AbstractPSDAlignmentThdGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BOM0PSDALIGNMENT_API  Teamcenter::Bom0bommanagement::Bom0AbstractPSDAlignmentThd
     : public  ::Teamcenter::Fnd0WSOThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Bom0AbstractPSDAlignmentThd();

    /**
     * Destructor
     */
    virtual ~Bom0AbstractPSDAlignmentThd();

private:
    //  Getter method for the Implementation Object
    Bom0AbstractPSDAlignmentThdImpl*  getBom0AbstractPSDAlignmentThdImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBom0AbstractPSDAlignmentThdImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Bom0AbstractPSDAlignmentThdImpl*  m_bom0abstractpsdalignmentthdImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Bom0AbstractPSDAlignmentThd - desc for Bom0AbstractPSDAlignmentThd parameter
     */
    Bom0AbstractPSDAlignmentThd( const Bom0AbstractPSDAlignmentThd& );
    Bom0AbstractPSDAlignmentThd& operator=( const Bom0AbstractPSDAlignmentThd& );

    friend class  Bom0AbstractPSDAlignmentThdDelegate;
    friend class  Bom0AbstractPSDAlignmentThdDispatch;
    friend class  Bom0AbstractPSDAlignmentThdGenImpl;
};

#include <Bom0psdalignment/libbom0psdalignment_undef.h>
#endif //   TEAMCENTER__BOM0BOMMANAGEMENT__BOM0ABSTRACTPSDALIGNMENTTHD__HXX
