//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Bom0PULine
    Filename:   Bom0PULine.hxx
    Module:     Bom0psdalignment
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOM0BOMMANAGEMENT__BOM0PULINE__HXX
#define TEAMCENTER__BOM0BOMMANAGEMENT__BOM0PULINE__HXX

#include <common/tc_deprecation_macros.h>
#include <bom/BOMLine.hxx>

#include <Bom0psdalignment/libbom0psdalignment_exports.h>

namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PULine;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PULineImpl;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PULineDelegate;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PULineDispatch;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PULineGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BOM0PSDALIGNMENT_API  Teamcenter::Bom0bommanagement::Bom0PULine
     : public  ::Teamcenter::BOMLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Bom0PULine();

    /**
     * Destructor
     */
    virtual ~Bom0PULine();

private:
    //  Getter method for the Implementation Object
    Bom0PULineImpl*  getBom0PULineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBom0PULineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Bom0PULineImpl*  m_bom0pulineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Bom0PULine - desc for Bom0PULine parameter
     */
    Bom0PULine( const Bom0PULine& );
    Bom0PULine& operator=( const Bom0PULine& );

    friend class  Bom0PULineDelegate;
    friend class  Bom0PULineDispatch;
    friend class  Bom0PULineGenImpl;
};

#include <Bom0psdalignment/libbom0psdalignment_undef.h>
#endif //   TEAMCENTER__BOM0BOMMANAGEMENT__BOM0PULINE__HXX
