//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Bom0PULineDelegate
    Filename:   Bom0PULineDelegate.hxx
    Module:     Bom0psdalignment
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOM0BOMMANAGEMENT__BOM0PULINEDELEGATE_HXX
#define TEAMCENTER__BOM0BOMMANAGEMENT__BOM0PULINEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Bom0psdalignment/Bom0PULine.hxx>

#include <Bom0psdalignment/libbom0psdalignment_exports.h>

namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PULineDelegate;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PULineImpl;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PULine;
    }
}
namespace Teamcenter
{
    namespace Bom0bommanagement
    {
        class Bom0PULineGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  BOM0PSDALIGNMENT_API Teamcenter_alias::Bom0bommanagement::Bom0PULineDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Bom0PULineDelegate instance
    static Bom0PULineDelegate&  getInstance();

    //  Method to create the Bom0PULineImpl pointer
    static Bom0PULineImpl*  createImpl( Bom0PULine&  ifObj );

    //  Method to delete the Bom0PULineImpl pointer
    static void deleteImpl( Bom0PULineImpl*  impl );


    ///
    /// This is the getter for retrieving the recipe/permanent ID if its been created (and cached on the instance). Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param uid - Recipe/permanent ID
    /// @param isFirstTime - If Session Recovery Uid is yet to be set or does the object need to be serialized again?
    /// @return - Failure code
    ///
    int  fnd0AskSRUidBase(const Bom0PULine &ifObj,  std::string *uid, bool *isFirstTime ) const;


    ///
    /// Generates permanent ID/recipe. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param recipe - Permanent ID/recipe
    /// @return - Failure code.
    ///
    int  fnd0GenerateRecipeBase(const Bom0PULine &ifObj,  std::string *recipe );


    ///
    /// If Business Object supports recoverable ID. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param isPersistedRecipe - isPersistedRecipe param should be set to true if the recipe is limited to the user session and should be serialized to the database
    /// @param isRecoverableIDSupported - Returning true indicates support for recoverability/permanent IDs
    /// @return - Failure code.
    ///
    int  fnd0IsRecoverableBase(const Bom0PULine &ifObj,  bool *isPersistedRecipe, bool *isRecoverableIDSupported ) const;


    ///
    /// This is the setter for the recipe/permanent ID when it is created (to be cached on the instance). Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param uid - Rrecipe/permanent ID
    /// @return - Failure code.
    ///
    int  fnd0SetSRUidBase(const Bom0PULine &ifObj,  const std::string *uid );



protected:
    //  Pointer to the instance
    static Bom0PULineDelegate*  m_pInstance;

    Bom0PULineDelegate();
    virtual ~Bom0PULineDelegate();
    static void setInstance( Bom0PULineDelegate*  instance );


private:
    friend class  ::Teamcenter::Bom0bommanagement::Bom0PULineGenImpl;

};

#include <Bom0psdalignment/libbom0psdalignment_undef.h>
#endif  //  TEAMCENTER__BOM0BOMMANAGEMENT__BOM0PULINEDELEGATE_HXX
