//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAE0Config
    Filename:   CAE0Config.hxx
    Module:     CAE0SimulationProcessManagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CAE__CAE0CONFIG__HXX
#define CAE__CAE0CONFIG__HXX

#include <common/tc_deprecation_macros.h>
#include <cae/CAEItem.hxx>

#include <CAE0SimulationProcessManagement/libcae0simulationprocessmanagement_exports.h>

namespace cae
{
    class CAE0Config;
}
namespace cae
{
    class CAE0ConfigImpl;
}
namespace cae
{
    class CAE0ConfigDelegate;
}
namespace cae
{
    class CAE0ConfigDispatch;
}
namespace cae
{
    class CAE0ConfigGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CAE0SIMULATIONPROCESSMANAGEMENT_API  cae::CAE0Config
     : public  ::Teamcenter::CAEItem
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CAE0Config();

    /**
     * Destructor
     */
    virtual ~CAE0Config();

private:
    //  Getter method for the Implementation Object
    CAE0ConfigImpl*  getCAE0ConfigImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCAE0ConfigImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CAE0ConfigImpl*  m_cae0configImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CAE0Config - desc for CAE0Config parameter
     */
    CAE0Config( const CAE0Config& );
    CAE0Config& operator=( const CAE0Config& );

    friend class  CAE0ConfigDelegate;
    friend class  CAE0ConfigDispatch;
    friend class  CAE0ConfigGenImpl;
};

#include <CAE0SimulationProcessManagement/libcae0simulationprocessmanagement_undef.h>
#endif //   CAE__CAE0CONFIG__HXX
