//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAE0ConfigDelegate
    Filename:   CAE0ConfigDelegate.hxx
    Module:     CAE0SimulationProcessManagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CAE__CAE0CONFIGDELEGATE_HXX
#define CAE__CAE0CONFIGDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <CAE0SimulationProcessManagement/CAE0Config.hxx>

#include <CAE0SimulationProcessManagement/libcae0simulationprocessmanagement_exports.h>

namespace cae
{
    class CAE0ConfigDelegate;
}
namespace cae
{
    class CAE0ConfigImpl;
}
namespace cae
{
    class CAE0Config;
}
namespace cae
{
    class CAE0ConfigGenImpl;
}

namespace cae_alias = ::cae;


class  CAE0SIMULATIONPROCESSMANAGEMENT_API cae_alias::CAE0ConfigDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CAE0ConfigDelegate instance
    static CAE0ConfigDelegate&  getInstance();

    //  Method to create the CAE0ConfigImpl pointer
    static CAE0ConfigImpl*  createImpl( CAE0Config&  ifObj );

    //  Method to delete the CAE0ConfigImpl pointer
    static void deleteImpl( CAE0ConfigImpl*  impl );



protected:
    //  Pointer to the instance
    static CAE0ConfigDelegate*  m_pInstance;

    CAE0ConfigDelegate();
    virtual ~CAE0ConfigDelegate();
    static void setInstance( CAE0ConfigDelegate*  instance );


private:
    friend class  ::cae::CAE0ConfigGenImpl;

};

#include <CAE0SimulationProcessManagement/libcae0simulationprocessmanagement_undef.h>
#endif  //  CAE__CAE0CONFIGDELEGATE_HXX
