//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAE0ConfigRevision
    Filename:   CAE0ConfigRevision.hxx
    Module:     CAE0SimulationProcessManagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CAE__CAE0CONFIGREVISION__HXX
#define CAE__CAE0CONFIGREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <cae/CAEItemRevision.hxx>

#include <CAE0SimulationProcessManagement/libcae0simulationprocessmanagement_exports.h>

namespace cae
{
    class CAE0ConfigRevision;
}
namespace cae
{
    class CAE0ConfigRevisionImpl;
}
namespace cae
{
    class CAE0ConfigRevisionDelegate;
}
namespace cae
{
    class CAE0ConfigRevisionDispatch;
}
namespace cae
{
    class CAE0ConfigRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CAE0SIMULATIONPROCESSMANAGEMENT_API  cae::CAE0ConfigRevision
     : public  ::Teamcenter::CAEItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CAE0ConfigRevision();

    /**
     * Destructor
     */
    virtual ~CAE0ConfigRevision();

private:
    //  Getter method for the Implementation Object
    CAE0ConfigRevisionImpl*  getCAE0ConfigRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCAE0ConfigRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CAE0ConfigRevisionImpl*  m_cae0configrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CAE0ConfigRevision - desc for CAE0ConfigRevision parameter
     */
    CAE0ConfigRevision( const CAE0ConfigRevision& );
    CAE0ConfigRevision& operator=( const CAE0ConfigRevision& );

    friend class  CAE0ConfigRevisionDelegate;
    friend class  CAE0ConfigRevisionDispatch;
    friend class  CAE0ConfigRevisionGenImpl;
};

#include <CAE0SimulationProcessManagement/libcae0simulationprocessmanagement_undef.h>
#endif //   CAE__CAE0CONFIGREVISION__HXX
