//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAE0FileCollectionDelegate
    Filename:   CAE0FileCollectionDelegate.hxx
    Module:     CAE0SimulationProcessManagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CAE__CAE0FILECOLLECTIONDELEGATE_HXX
#define CAE__CAE0FILECOLLECTIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <CAE0SimulationProcessManagement/CAE0FileCollection.hxx>

#include <CAE0SimulationProcessManagement/libcae0simulationprocessmanagement_exports.h>

namespace cae
{
    class CAE0FileCollectionDelegate;
}
namespace cae
{
    class CAE0FileCollectionImpl;
}
namespace cae
{
    class CAE0FileCollection;
}
namespace cae
{
    class CAE0FileCollectionGenImpl;
}

namespace cae_alias = ::cae;


class  CAE0SIMULATIONPROCESSMANAGEMENT_API cae_alias::CAE0FileCollectionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CAE0FileCollectionDelegate instance
    static CAE0FileCollectionDelegate&  getInstance();

    //  Method to create the CAE0FileCollectionImpl pointer
    static CAE0FileCollectionImpl*  createImpl( CAE0FileCollection&  ifObj );

    //  Method to delete the CAE0FileCollectionImpl pointer
    static void deleteImpl( CAE0FileCollectionImpl*  impl );


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 11.5
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setCae0FoldersBase(CAE0FileCollection &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const CAE0FileCollection &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Deletes the instance.
    /// @version Teamcenter 11.1
    /// @return - Failure code.
    ///
    int  fnd0DeleteBase(const CAE0FileCollection &ifObj  );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const CAE0FileCollection &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setObject_nameBase(CAE0FileCollection &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static CAE0FileCollectionDelegate*  m_pInstance;

    CAE0FileCollectionDelegate();
    virtual ~CAE0FileCollectionDelegate();
    static void setInstance( CAE0FileCollectionDelegate*  instance );


private:
    friend class  ::cae::CAE0FileCollectionGenImpl;

};

#include <CAE0SimulationProcessManagement/libcae0simulationprocessmanagement_undef.h>
#endif  //  CAE__CAE0FILECOLLECTIONDELEGATE_HXX
