//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAE0MDOAnalysisRevision
    Filename:   CAE0MDOAnalysisRevision.hxx
    Module:     CAE0SimulationProcessManagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CAE__CAE0MDOANALYSISREVISION__HXX
#define CAE__CAE0MDOANALYSISREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <cae/CAEAnalysisRevision.hxx>

#include <CAE0SimulationProcessManagement/libcae0simulationprocessmanagement_exports.h>

namespace cae
{
    class CAE0MDOAnalysisRevision;
}
namespace cae
{
    class CAE0MDOAnalysisRevisionImpl;
}
namespace cae
{
    class CAE0MDOAnalysisRevisionDelegate;
}
namespace cae
{
    class CAE0MDOAnalysisRevisionDispatch;
}
namespace cae
{
    class CAE0MDOAnalysisRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CAE0SIMULATIONPROCESSMANAGEMENT_API  cae::CAE0MDOAnalysisRevision
     : public  ::Teamcenter::CAEAnalysisRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CAE0MDOAnalysisRevision();

    /**
     * Destructor
     */
    virtual ~CAE0MDOAnalysisRevision();

private:
    //  Getter method for the Implementation Object
    CAE0MDOAnalysisRevisionImpl*  getCAE0MDOAnalysisRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCAE0MDOAnalysisRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CAE0MDOAnalysisRevisionImpl*  m_cae0mdoanalysisrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CAE0MDOAnalysisRevision - desc for CAE0MDOAnalysisRevision parameter
     */
    CAE0MDOAnalysisRevision( const CAE0MDOAnalysisRevision& );
    CAE0MDOAnalysisRevision& operator=( const CAE0MDOAnalysisRevision& );

    friend class  CAE0MDOAnalysisRevisionDelegate;
    friend class  CAE0MDOAnalysisRevisionDispatch;
    friend class  CAE0MDOAnalysisRevisionGenImpl;
};

#include <CAE0SimulationProcessManagement/libcae0simulationprocessmanagement_undef.h>
#endif //   CAE__CAE0MDOANALYSISREVISION__HXX
