//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAE0MDOAnalysisRevisionDelegate
    Filename:   CAE0MDOAnalysisRevisionDelegate.hxx
    Module:     CAE0SimulationProcessManagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CAE__CAE0MDOANALYSISREVISIONDELEGATE_HXX
#define CAE__CAE0MDOANALYSISREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <CAE0SimulationProcessManagement/CAE0MDOAnalysisRevision.hxx>

#include <CAE0SimulationProcessManagement/libcae0simulationprocessmanagement_exports.h>

namespace cae
{
    class CAE0MDOAnalysisRevisionDelegate;
}
namespace cae
{
    class CAE0MDOAnalysisRevisionImpl;
}
namespace cae
{
    class CAE0MDOAnalysisRevision;
}
namespace cae
{
    class CAE0MDOAnalysisRevisionGenImpl;
}

namespace cae_alias = ::cae;


class  CAE0SIMULATIONPROCESSMANAGEMENT_API cae_alias::CAE0MDOAnalysisRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CAE0MDOAnalysisRevisionDelegate instance
    static CAE0MDOAnalysisRevisionDelegate&  getInstance();

    //  Method to create the CAE0MDOAnalysisRevisionImpl pointer
    static CAE0MDOAnalysisRevisionImpl*  createImpl( CAE0MDOAnalysisRevision&  ifObj );

    //  Method to delete the CAE0MDOAnalysisRevisionImpl pointer
    static void deleteImpl( CAE0MDOAnalysisRevisionImpl*  impl );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const CAE0MDOAnalysisRevision &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static CAE0MDOAnalysisRevisionDelegate*  m_pInstance;

    CAE0MDOAnalysisRevisionDelegate();
    virtual ~CAE0MDOAnalysisRevisionDelegate();
    static void setInstance( CAE0MDOAnalysisRevisionDelegate*  instance );


private:
    friend class  ::cae::CAE0MDOAnalysisRevisionGenImpl;

};

#include <CAE0SimulationProcessManagement/libcae0simulationprocessmanagement_undef.h>
#endif  //  CAE__CAE0MDOANALYSISREVISIONDELEGATE_HXX
