//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAE0StrMapFilterRelation
    Filename:   CAE0StrMapFilterRelation.hxx
    Module:     CAE0SimulationProcessManagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CAE__CAE0STRMAPFILTERRELATION__HXX
#define CAE__CAE0STRMAPFILTERRELATION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <CAE0SimulationProcessManagement/libcae0simulationprocessmanagement_exports.h>

namespace cae
{
    class CAE0StrMapFilterRelation;
}
namespace cae
{
    class CAE0StrMapFilterRelationImpl;
}
namespace cae
{
    class CAE0StrMapFilterRelationDelegate;
}
namespace cae
{
    class CAE0StrMapFilterRelationDispatch;
}
namespace cae
{
    class CAE0StrMapFilterRelationGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CAE0SIMULATIONPROCESSMANAGEMENT_API  cae::CAE0StrMapFilterRelation
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CAE0StrMapFilterRelation();

    /**
     * Destructor
     */
    virtual ~CAE0StrMapFilterRelation();

private:
    //  Getter method for the Implementation Object
    CAE0StrMapFilterRelationImpl*  getCAE0StrMapFilterRelationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCAE0StrMapFilterRelationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CAE0StrMapFilterRelationImpl*  m_cae0strmapfilterrelationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CAE0StrMapFilterRelation - desc for CAE0StrMapFilterRelation parameter
     */
    CAE0StrMapFilterRelation( const CAE0StrMapFilterRelation& );
    CAE0StrMapFilterRelation& operator=( const CAE0StrMapFilterRelation& );

    friend class  CAE0StrMapFilterRelationDelegate;
    friend class  CAE0StrMapFilterRelationDispatch;
    friend class  CAE0StrMapFilterRelationGenImpl;
};

#include <CAE0SimulationProcessManagement/libcae0simulationprocessmanagement_undef.h>
#endif //   CAE__CAE0STRMAPFILTERRELATION__HXX
