//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAE0StrMapFilterRelationDelegate
    Filename:   CAE0StrMapFilterRelationDelegate.hxx
    Module:     CAE0SimulationProcessManagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CAE__CAE0STRMAPFILTERRELATIONDELEGATE_HXX
#define CAE__CAE0STRMAPFILTERRELATIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <CAE0SimulationProcessManagement/CAE0StrMapFilterRelation.hxx>

#include <CAE0SimulationProcessManagement/libcae0simulationprocessmanagement_exports.h>

namespace cae
{
    class CAE0StrMapFilterRelationDelegate;
}
namespace cae
{
    class CAE0StrMapFilterRelationImpl;
}
namespace cae
{
    class CAE0StrMapFilterRelation;
}
namespace cae
{
    class CAE0StrMapFilterRelationGenImpl;
}

namespace cae_alias = ::cae;


class  CAE0SIMULATIONPROCESSMANAGEMENT_API cae_alias::CAE0StrMapFilterRelationDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CAE0StrMapFilterRelationDelegate instance
    static CAE0StrMapFilterRelationDelegate&  getInstance();

    //  Method to create the CAE0StrMapFilterRelationImpl pointer
    static CAE0StrMapFilterRelationImpl*  createImpl( CAE0StrMapFilterRelation&  ifObj );

    //  Method to delete the CAE0StrMapFilterRelationImpl pointer
    static void deleteImpl( CAE0StrMapFilterRelationImpl*  impl );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const CAE0StrMapFilterRelation &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0CreatePostBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static CAE0StrMapFilterRelationDelegate*  m_pInstance;

    CAE0StrMapFilterRelationDelegate();
    virtual ~CAE0StrMapFilterRelationDelegate();
    static void setInstance( CAE0StrMapFilterRelationDelegate*  instance );


private:
    friend class  ::cae::CAE0StrMapFilterRelationGenImpl;

};

#include <CAE0SimulationProcessManagement/libcae0simulationprocessmanagement_undef.h>
#endif  //  CAE__CAE0STRMAPFILTERRELATIONDELEGATE_HXX
