//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//e
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, C2Capa
    Filename:   C2Capa.hxx
    Module:     CPA0capadatamodel
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CAPADATAMODEL__C2CAPA__HXX
#define CAPADATAMODEL__C2CAPA__HXX

#include <common/tc_deprecation_macros.h>
#include <cm/ProblemReport.hxx>

#include <CPA0capadatamodel/libcpa0capadatamodel_exports.h>

namespace capadatamodel
{
    class C2Capa;
}
namespace capadatamodel
{
    class C2CapaImpl;
}
namespace capadatamodel
{
    class C2CapaDelegate;
}
namespace capadatamodel
{
    class C2CapaDispatch;
}
namespace capadatamodel
{
    class C2CapaGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CPA0CAPADATAMODEL_API  capadatamodel::C2Capa
     : public  ::Teamcenter::ProblemReport
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    C2Capa();

    /**
     * Destructor
     */
    virtual ~C2Capa();

private:
    //  Getter method for the Implementation Object
    C2CapaImpl*  getC2CapaImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setC2CapaImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    C2CapaImpl*  m_c2capaImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param C2Capa - desc for C2Capa parameter
     */
    C2Capa( const C2Capa& );
    C2Capa& operator=( const C2Capa& );

    friend class  C2CapaDelegate;
    friend class  C2CapaDispatch;
    friend class  C2CapaGenImpl;
};

#include <CPA0capadatamodel/libcpa0capadatamodel_undef.h>
#endif //   CAPADATAMODEL__C2CAPA__HXX
