//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//e
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, C2CapaRevision
    Filename:   C2CapaRevision.hxx
    Module:     CPA0capadatamodel
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CAPADATAMODEL__C2CAPAREVISION__HXX
#define CAPADATAMODEL__C2CAPAREVISION__HXX

#include <string>
#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <cm/ProblemReportRevision.hxx>

#include <CPA0capadatamodel/libcpa0capadatamodel_exports.h>

namespace capadatamodel
{
    class C2CapaRevision;
}
namespace capadatamodel
{
    class C2CapaRevisionImpl;
}
namespace capadatamodel
{
    class C2CapaRevisionDelegate;
}
namespace capadatamodel
{
    class C2CapaRevisionDispatch;
}
namespace capadatamodel
{
    class C2CapaRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CPA0CAPADATAMODEL_API  capadatamodel::C2CapaRevision
     : public  ::Teamcenter::ProblemReportRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Setter for a string Property
    /// @version Teamcenter 12.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setC2_capa_category( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 12.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setC2_capa_subtype( const std::string &value, bool isNull=false );

    ///
    /// Setter for a Date Property
    /// @version Teamcenter 12.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setC2_Due_date( const date_t &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 12.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setC2_Priority( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 12.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCpa0actualStep( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 12.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCpa0processType( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    C2CapaRevision();

    /**
     * Destructor
     */
    virtual ~C2CapaRevision();

private:
    //  Getter method for the Implementation Object
    C2CapaRevisionImpl*  getC2CapaRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setC2CapaRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    C2CapaRevisionImpl*  m_c2caparevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param C2CapaRevision - desc for C2CapaRevision parameter
     */
    C2CapaRevision( const C2CapaRevision& );
    C2CapaRevision& operator=( const C2CapaRevision& );

    friend class  C2CapaRevisionDelegate;
    friend class  C2CapaRevisionDispatch;
    friend class  C2CapaRevisionGenImpl;
};

#include <CPA0capadatamodel/libcpa0capadatamodel_undef.h>
#endif //   CAPADATAMODEL__C2CAPAREVISION__HXX
