//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//e
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, C2CapaRevisionDelegate
    Filename:   C2CapaRevisionDelegate.hxx
    Module:     CPA0capadatamodel
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CAPADATAMODEL__C2CAPAREVISIONDELEGATE_HXX
#define CAPADATAMODEL__C2CAPAREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <CPA0capadatamodel/C2CapaRevision.hxx>

#include <CPA0capadatamodel/libcpa0capadatamodel_exports.h>

namespace capadatamodel
{
    class C2CapaRevisionDelegate;
}
namespace capadatamodel
{
    class C2CapaRevisionImpl;
}
namespace capadatamodel
{
    class C2CapaRevision;
}
namespace capadatamodel
{
    class C2CapaRevisionGenImpl;
}

namespace capadatamodel_alias = ::capadatamodel;


class  CPA0CAPADATAMODEL_API capadatamodel_alias::C2CapaRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the C2CapaRevisionDelegate instance
    static C2CapaRevisionDelegate&  getInstance();

    //  Method to create the C2CapaRevisionImpl pointer
    static C2CapaRevisionImpl*  createImpl( C2CapaRevision&  ifObj );

    //  Method to delete the C2CapaRevisionImpl pointer
    static void deleteImpl( C2CapaRevisionImpl*  impl );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 12.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setC2_capa_categoryBase(C2CapaRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 12.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setC2_capa_subtypeBase(C2CapaRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Date Property
    /// @version Teamcenter 12.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setC2_Due_dateBase(C2CapaRevision &ifObj,  const date_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 12.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setC2_PriorityBase(C2CapaRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 12.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCpa0actualStepBase(C2CapaRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 12.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCpa0processTypeBase(C2CapaRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const C2CapaRevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCMClosureCommentsBase(C2CapaRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setObject_descBase(C2CapaRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setObject_nameBase(C2CapaRevision &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static C2CapaRevisionDelegate*  m_pInstance;

    C2CapaRevisionDelegate();
    virtual ~C2CapaRevisionDelegate();
    static void setInstance( C2CapaRevisionDelegate*  instance );


private:
    friend class  ::capadatamodel::C2CapaRevisionGenImpl;

};

#include <CPA0capadatamodel/libcpa0capadatamodel_undef.h>
#endif  //  CAPADATAMODEL__C2CAPAREVISIONDELEGATE_HXX
