//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//e
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, C2Issue
    Filename:   C2Issue.hxx
    Module:     CPA0capadatamodel
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CAPADATAMODEL__C2ISSUE__HXX
#define CAPADATAMODEL__C2ISSUE__HXX

#include <common/tc_deprecation_macros.h>
#include <issuemgmt/IssueReport.hxx>

#include <CPA0capadatamodel/libcpa0capadatamodel_exports.h>

namespace capadatamodel
{
    class C2Issue;
}
namespace capadatamodel
{
    class C2IssueImpl;
}
namespace capadatamodel
{
    class C2IssueDelegate;
}
namespace capadatamodel
{
    class C2IssueDispatch;
}
namespace capadatamodel
{
    class C2IssueGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CPA0CAPADATAMODEL_API  capadatamodel::C2Issue
     : public  ::Teamcenter::issuemgmt::IssueReport
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    C2Issue();

    /**
     * Destructor
     */
    virtual ~C2Issue();

private:
    //  Getter method for the Implementation Object
    C2IssueImpl*  getC2IssueImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setC2IssueImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    C2IssueImpl*  m_c2issueImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param C2Issue - desc for C2Issue parameter
     */
    C2Issue( const C2Issue& );
    C2Issue& operator=( const C2Issue& );

    friend class  C2IssueDelegate;
    friend class  C2IssueDispatch;
    friend class  C2IssueGenImpl;
};

#include <CPA0capadatamodel/libcpa0capadatamodel_undef.h>
#endif //   CAPADATAMODEL__C2ISSUE__HXX
