//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//e
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, C2IssueRevision
    Filename:   C2IssueRevision.hxx
    Module:     CPA0capadatamodel
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CAPADATAMODEL__C2ISSUEREVISION__HXX
#define CAPADATAMODEL__C2ISSUEREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <issuemgmt/IssueReportRevision.hxx>

#include <CPA0capadatamodel/libcpa0capadatamodel_exports.h>

namespace capadatamodel
{
    class C2IssueRevision;
}
namespace capadatamodel
{
    class C2IssueRevisionImpl;
}
namespace capadatamodel
{
    class C2IssueRevisionDelegate;
}
namespace capadatamodel
{
    class C2IssueRevisionDispatch;
}
namespace capadatamodel
{
    class C2IssueRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CPA0CAPADATAMODEL_API  capadatamodel::C2IssueRevision
     : public  ::Teamcenter::issuemgmt::IssueReportRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    C2IssueRevision();

    /**
     * Destructor
     */
    virtual ~C2IssueRevision();

private:
    //  Getter method for the Implementation Object
    C2IssueRevisionImpl*  getC2IssueRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setC2IssueRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    C2IssueRevisionImpl*  m_c2issuerevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param C2IssueRevision - desc for C2IssueRevision parameter
     */
    C2IssueRevision( const C2IssueRevision& );
    C2IssueRevision& operator=( const C2IssueRevision& );

    friend class  C2IssueRevisionDelegate;
    friend class  C2IssueRevisionDispatch;
    friend class  C2IssueRevisionGenImpl;
};

#include <CPA0capadatamodel/libcpa0capadatamodel_undef.h>
#endif //   CAPADATAMODEL__C2ISSUEREVISION__HXX
