//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cbm0ColorRule
    Filename:   Cbm0ColorRule.hxx
    Module:     Cbm0colorbompmm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CBM0COLORBOMPMM__CBM0COLORRULE__HXX
#define CBM0COLORBOMPMM__CBM0COLORRULE__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <Clr1colorrule/Clr1AbsColorRule.hxx>

#include <Cbm0colorbompmm/libcbm0colorbompmm_exports.h>

namespace Cbm0colorbompmm
{
    class Cbm0ColorRule;
}
namespace Cbm0colorbompmm
{
    class Cbm0ColorRuleImpl;
}
namespace Cbm0colorbompmm
{
    class Cbm0ColorRuleDelegate;
}
namespace Cbm0colorbompmm
{
    class Cbm0ColorRuleDispatch;
}
namespace Cbm0colorbompmm
{
    class Cbm0ColorRuleGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CBM0COLORBOMPMM_API  Cbm0colorbompmm::Cbm0ColorRule
     : public  ::Clr1ColorRule::Clr1AbsColorRule
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 10.1.6
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCbm0LessFinishPartNumbers( std::vector< std::string > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cbm0ColorRule();

    /**
     * Destructor
     */
    virtual ~Cbm0ColorRule();

private:
    //  Getter method for the Implementation Object
    Cbm0ColorRuleImpl*  getCbm0ColorRuleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCbm0ColorRuleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cbm0ColorRuleImpl*  m_cbm0colorruleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cbm0ColorRule - desc for Cbm0ColorRule parameter
     */
    Cbm0ColorRule( const Cbm0ColorRule& );
    Cbm0ColorRule& operator=( const Cbm0ColorRule& );

    friend class  Cbm0ColorRuleDelegate;
    friend class  Cbm0ColorRuleDispatch;
    friend class  Cbm0ColorRuleGenImpl;
};

#include <Cbm0colorbompmm/libcbm0colorbompmm_undef.h>
#endif //   CBM0COLORBOMPMM__CBM0COLORRULE__HXX
