//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsAdmissibility
    Filename:   Cfg0AbsAdmissibility.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSADMISSIBILITY__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSADMISSIBILITY__HXX

#include <string>
#include <tccore/POM_object.hxx>
#include <unidefs.h>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsAssociation.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAdmissibility;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAdmissibilityImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAdmissibilityDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAdmissibilityDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAdmissibilityGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsAdmissibility
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsAssociation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Operation to update the admissibility state and revise admissibility if needed.
    /// @version Teamcenter 10.1.3
    /// @param admissibilityState - input admissibilitystate
    /// @param context - The input context for which admissibility is to be updated
    /// @param outputAdmissibility - newly created/ updated admissibility object
    /// @param objectsToDelete - Output paramter to return the objects to be deleted when admissibility state to be updated is empty.
    /// @return - Returns iFail.
    ///
    int  cfg0UpdateAdmissibility( const std::string *admissibilityState, const ::Teamcenter::POM_object *context, tag_t *outputAdmissibility, std::vector< tag_t > *objectsToDelete );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsAdmissibility();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsAdmissibility();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsAdmissibilityImpl*  getCfg0AbsAdmissibilityImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsAdmissibilityImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsAdmissibilityImpl*  m_cfg0absadmissibilityImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsAdmissibility - desc for Cfg0AbsAdmissibility parameter
     */
    Cfg0AbsAdmissibility( const Cfg0AbsAdmissibility& );
    Cfg0AbsAdmissibility& operator=( const Cfg0AbsAdmissibility& );

    friend class  Cfg0AbsAdmissibilityDelegate;
    friend class  Cfg0AbsAdmissibilityDispatch;
    friend class  Cfg0AbsAdmissibilityGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSADMISSIBILITY__HXX
