//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsAdmissibilityDelegate
    Filename:   Cfg0AbsAdmissibilityDelegate.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSADMISSIBILITYDELEGATE_HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSADMISSIBILITYDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsAdmissibility.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAdmissibilityDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAdmissibilityImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAdmissibility;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAdmissibilityGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CFG0CONFIGURATOR_API Teamcenter_alias::Cfg0configurator::Cfg0AbsAdmissibilityDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cfg0AbsAdmissibilityDelegate instance
    static Cfg0AbsAdmissibilityDelegate&  getInstance();

    //  Method to create the Cfg0AbsAdmissibilityImpl pointer
    static Cfg0AbsAdmissibilityImpl*  createImpl( Cfg0AbsAdmissibility&  ifObj );

    //  Method to delete the Cfg0AbsAdmissibilityImpl pointer
    static void deleteImpl( Cfg0AbsAdmissibilityImpl*  impl );


    ///
    /// Operation to update the admissibility state and revise admissibility if needed.
    /// @version Teamcenter 10.1.3
    /// @param admissibilityState - input admissibilitystate
    /// @param context - The input context for which admissibility is to be updated
    /// @param outputAdmissibility - newly created/ updated admissibility object
    /// @param objectsToDelete - Output paramter to return the objects to be deleted when admissibility state to be updated is empty.
    /// @return - Returns iFail.
    ///
    int  cfg0UpdateAdmissibilityBase(const Cfg0AbsAdmissibility &ifObj,  const std::string *admissibilityState, const ::Teamcenter::POM_object *context, tag_t *outputAdmissibility, std::vector< tag_t > *objectsToDelete );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Cfg0AbsAdmissibility &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Cfg0AbsAdmissibilityDelegate*  m_pInstance;

    Cfg0AbsAdmissibilityDelegate();
    virtual ~Cfg0AbsAdmissibilityDelegate();
    static void setInstance( Cfg0AbsAdmissibilityDelegate*  instance );


private:
    friend class  ::Teamcenter::Cfg0configurator::Cfg0AbsAdmissibilityGenImpl;

};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif  //  TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSADMISSIBILITYDELEGATE_HXX
