//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsAdmissibilityThread
    Filename:   Cfg0AbsAdmissibilityThread.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSADMISSIBILITYTHREAD__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSADMISSIBILITYTHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsAssociationThread.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAdmissibilityThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAdmissibilityThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAdmissibilityThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAdmissibilityThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAdmissibilityThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsAdmissibilityThread
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsAssociationThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsAdmissibilityThread();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsAdmissibilityThread();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsAdmissibilityThreadImpl*  getCfg0AbsAdmissibilityThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsAdmissibilityThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsAdmissibilityThreadImpl*  m_cfg0absadmissibilitythreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsAdmissibilityThread - desc for Cfg0AbsAdmissibilityThread parameter
     */
    Cfg0AbsAdmissibilityThread( const Cfg0AbsAdmissibilityThread& );
    Cfg0AbsAdmissibilityThread& operator=( const Cfg0AbsAdmissibilityThread& );

    friend class  Cfg0AbsAdmissibilityThreadDelegate;
    friend class  Cfg0AbsAdmissibilityThreadDispatch;
    friend class  Cfg0AbsAdmissibilityThreadGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSADMISSIBILITYTHREAD__HXX
