//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsAllocation
    Filename:   Cfg0AbsAllocation.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSALLOCATION__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSALLOCATION__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsAssociation.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAllocation;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAllocationImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAllocationDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAllocationDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAllocationGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsAllocation
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsAssociation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsAllocation();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsAllocation();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsAllocationImpl*  getCfg0AbsAllocationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsAllocationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsAllocationImpl*  m_cfg0absallocationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsAllocation - desc for Cfg0AbsAllocation parameter
     */
    Cfg0AbsAllocation( const Cfg0AbsAllocation& );
    Cfg0AbsAllocation& operator=( const Cfg0AbsAllocation& );

    friend class  Cfg0AbsAllocationDelegate;
    friend class  Cfg0AbsAllocationDispatch;
    friend class  Cfg0AbsAllocationGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSALLOCATION__HXX
