//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsAllocationThreadDelegate
    Filename:   Cfg0AbsAllocationThreadDelegate.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSALLOCATIONTHREADDELEGATE_HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSALLOCATIONTHREADDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsAllocationThread.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAllocationThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAllocationThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAllocationThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAllocationThreadGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CFG0CONFIGURATOR_API Teamcenter_alias::Cfg0configurator::Cfg0AbsAllocationThreadDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cfg0AbsAllocationThreadDelegate instance
    static Cfg0AbsAllocationThreadDelegate&  getInstance();

    //  Method to create the Cfg0AbsAllocationThreadImpl pointer
    static Cfg0AbsAllocationThreadImpl*  createImpl( Cfg0AbsAllocationThread&  ifObj );

    //  Method to delete the Cfg0AbsAllocationThreadImpl pointer
    static void deleteImpl( Cfg0AbsAllocationThreadImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Cfg0AbsAllocationThread &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Cfg0AbsAllocationThreadDelegate*  m_pInstance;

    Cfg0AbsAllocationThreadDelegate();
    virtual ~Cfg0AbsAllocationThreadDelegate();
    static void setInstance( Cfg0AbsAllocationThreadDelegate*  instance );


private:
    friend class  ::Teamcenter::Cfg0configurator::Cfg0AbsAllocationThreadGenImpl;

};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif  //  TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSALLOCATIONTHREADDELEGATE_HXX
