//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsAssociationThread
    Filename:   Cfg0AbsAssociationThread.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSASSOCIATIONTHREAD__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSASSOCIATIONTHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsConfiguratorWSOThrd.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAssociationThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAssociationThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAssociationThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAssociationThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAssociationThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsAssociationThread
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsConfiguratorWSOThrd
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsAssociationThread();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsAssociationThread();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsAssociationThreadImpl*  getCfg0AbsAssociationThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsAssociationThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsAssociationThreadImpl*  m_cfg0absassociationthreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsAssociationThread - desc for Cfg0AbsAssociationThread parameter
     */
    Cfg0AbsAssociationThread( const Cfg0AbsAssociationThread& );
    Cfg0AbsAssociationThread& operator=( const Cfg0AbsAssociationThread& );

    friend class  Cfg0AbsAssociationThreadDelegate;
    friend class  Cfg0AbsAssociationThreadDispatch;
    friend class  Cfg0AbsAssociationThreadGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSASSOCIATIONTHREAD__HXX
