//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsAvailability
    Filename:   Cfg0AbsAvailability.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSAVAILABILITY__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSAVAILABILITY__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsAssociation.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAvailability;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAvailabilityImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAvailabilityDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAvailabilityDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAvailabilityGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsAvailability
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsAssociation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0ContextObject( tag_t &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsAvailability();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsAvailability();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsAvailabilityImpl*  getCfg0AbsAvailabilityImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsAvailabilityImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsAvailabilityImpl*  m_cfg0absavailabilityImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsAvailability - desc for Cfg0AbsAvailability parameter
     */
    Cfg0AbsAvailability( const Cfg0AbsAvailability& );
    Cfg0AbsAvailability& operator=( const Cfg0AbsAvailability& );

    friend class  Cfg0AbsAvailabilityDelegate;
    friend class  Cfg0AbsAvailabilityDispatch;
    friend class  Cfg0AbsAvailabilityGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSAVAILABILITY__HXX
