//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsAvailabilityRule
    Filename:   Cfg0AbsAvailabilityRule.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSAVAILABILITYRULE__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSAVAILABILITYRULE__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsValidationRule.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAvailabilityRule;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAvailabilityRuleImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAvailabilityRuleDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAvailabilityRuleDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAvailabilityRuleGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsAvailabilityRule
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsValidationRule
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsAvailabilityRule();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsAvailabilityRule();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsAvailabilityRuleImpl*  getCfg0AbsAvailabilityRuleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsAvailabilityRuleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsAvailabilityRuleImpl*  m_cfg0absavailabilityruleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsAvailabilityRule - desc for Cfg0AbsAvailabilityRule parameter
     */
    Cfg0AbsAvailabilityRule( const Cfg0AbsAvailabilityRule& );
    Cfg0AbsAvailabilityRule& operator=( const Cfg0AbsAvailabilityRule& );

    friend class  Cfg0AbsAvailabilityRuleDelegate;
    friend class  Cfg0AbsAvailabilityRuleDispatch;
    friend class  Cfg0AbsAvailabilityRuleGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSAVAILABILITYRULE__HXX
