//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsAvailabilityThread
    Filename:   Cfg0AbsAvailabilityThread.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSAVAILABILITYTHREAD__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSAVAILABILITYTHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsAssociationThread.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAvailabilityThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAvailabilityThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAvailabilityThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAvailabilityThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsAvailabilityThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsAvailabilityThread
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsAssociationThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsAvailabilityThread();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsAvailabilityThread();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsAvailabilityThreadImpl*  getCfg0AbsAvailabilityThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsAvailabilityThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsAvailabilityThreadImpl*  m_cfg0absavailabilitythreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsAvailabilityThread - desc for Cfg0AbsAvailabilityThread parameter
     */
    Cfg0AbsAvailabilityThread( const Cfg0AbsAvailabilityThread& );
    Cfg0AbsAvailabilityThread& operator=( const Cfg0AbsAvailabilityThread& );

    friend class  Cfg0AbsAvailabilityThreadDelegate;
    friend class  Cfg0AbsAvailabilityThreadDispatch;
    friend class  Cfg0AbsAvailabilityThreadGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSAVAILABILITYTHREAD__HXX
