//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsCompoundFamilyThread
    Filename:   Cfg0AbsCompoundFamilyThread.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSCOMPOUNDFAMILYTHREAD__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSCOMPOUNDFAMILYTHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsOptionFamilyThread.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsCompoundFamilyThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsCompoundFamilyThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsCompoundFamilyThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsCompoundFamilyThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsCompoundFamilyThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsCompoundFamilyThread
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsOptionFamilyThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsCompoundFamilyThread();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsCompoundFamilyThread();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsCompoundFamilyThreadImpl*  getCfg0AbsCompoundFamilyThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsCompoundFamilyThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsCompoundFamilyThreadImpl*  m_cfg0abscompoundfamilythreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsCompoundFamilyThread - desc for Cfg0AbsCompoundFamilyThread parameter
     */
    Cfg0AbsCompoundFamilyThread( const Cfg0AbsCompoundFamilyThread& );
    Cfg0AbsCompoundFamilyThread& operator=( const Cfg0AbsCompoundFamilyThread& );

    friend class  Cfg0AbsCompoundFamilyThreadDelegate;
    friend class  Cfg0AbsCompoundFamilyThreadDispatch;
    friend class  Cfg0AbsCompoundFamilyThreadGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSCOMPOUNDFAMILYTHREAD__HXX
