//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsCompoundOptionValueDelegate
    Filename:   Cfg0AbsCompoundOptionValueDelegate.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSCOMPOUNDOPTIONVALUEDELEGATE_HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSCOMPOUNDOPTIONVALUEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsCompoundOptionValue.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsCompoundOptionValueDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsCompoundOptionValueImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsCompoundOptionValue;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsCompoundOptionValueGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CFG0CONFIGURATOR_API Teamcenter_alias::Cfg0configurator::Cfg0AbsCompoundOptionValueDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cfg0AbsCompoundOptionValueDelegate instance
    static Cfg0AbsCompoundOptionValueDelegate&  getInstance();

    //  Method to create the Cfg0AbsCompoundOptionValueImpl pointer
    static Cfg0AbsCompoundOptionValueImpl*  createImpl( Cfg0AbsCompoundOptionValue&  ifObj );

    //  Method to delete the Cfg0AbsCompoundOptionValueImpl pointer
    static void deleteImpl( Cfg0AbsCompoundOptionValueImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0OptionValuesBase(const Cfg0AbsCompoundOptionValue &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 10.1.2
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setCfg0OptionValuesBase(Cfg0AbsCompoundOptionValue &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Cfg0AbsCompoundOptionValue &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Cfg0AbsCompoundOptionValue &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Cfg0AbsCompoundOptionValueDelegate*  m_pInstance;

    Cfg0AbsCompoundOptionValueDelegate();
    virtual ~Cfg0AbsCompoundOptionValueDelegate();
    static void setInstance( Cfg0AbsCompoundOptionValueDelegate*  instance );


private:
    friend class  ::Teamcenter::Cfg0configurator::Cfg0AbsCompoundOptionValueGenImpl;

};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif  //  TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSCOMPOUNDOPTIONVALUEDELEGATE_HXX
