//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsCompoundValueFamily
    Filename:   Cfg0AbsCompoundValueFamily.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSCOMPOUNDVALUEFAMILY__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSCOMPOUNDVALUEFAMILY__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsOptionFamily.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsCompoundValueFamily;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsCompoundValueFamilyImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsCompoundValueFamilyDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsCompoundValueFamilyDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsCompoundValueFamilyGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsCompoundValueFamily
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsOptionFamily
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsCompoundValueFamily();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsCompoundValueFamily();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsCompoundValueFamilyImpl*  getCfg0AbsCompoundValueFamilyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsCompoundValueFamilyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsCompoundValueFamilyImpl*  m_cfg0abscompoundvaluefamilyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsCompoundValueFamily - desc for Cfg0AbsCompoundValueFamily parameter
     */
    Cfg0AbsCompoundValueFamily( const Cfg0AbsCompoundValueFamily& );
    Cfg0AbsCompoundValueFamily& operator=( const Cfg0AbsCompoundValueFamily& );

    friend class  Cfg0AbsCompoundValueFamilyDelegate;
    friend class  Cfg0AbsCompoundValueFamilyDispatch;
    friend class  Cfg0AbsCompoundValueFamilyGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSCOMPOUNDVALUEFAMILY__HXX
