//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsConfigurationModule
    Filename:   Cfg0AbsConfigurationModule.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSCONFIGURATIONMODULE__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSCONFIGURATIONMODULE__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsConfiguratorWSO.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsConfigurationModule;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsConfigurationModuleImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsConfigurationModuleDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsConfigurationModuleDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsConfigurationModuleGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsConfigurationModule
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsConfiguratorWSO
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 12.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0ModulePerspective( tag_t &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsConfigurationModule();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsConfigurationModule();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsConfigurationModuleImpl*  getCfg0AbsConfigurationModuleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsConfigurationModuleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsConfigurationModuleImpl*  m_cfg0absconfigurationmoduleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsConfigurationModule - desc for Cfg0AbsConfigurationModule parameter
     */
    Cfg0AbsConfigurationModule( const Cfg0AbsConfigurationModule& );
    Cfg0AbsConfigurationModule& operator=( const Cfg0AbsConfigurationModule& );

    friend class  Cfg0AbsConfigurationModuleDelegate;
    friend class  Cfg0AbsConfigurationModuleDispatch;
    friend class  Cfg0AbsConfigurationModuleGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSCONFIGURATIONMODULE__HXX
