//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsConfigurationModuleDelegate
    Filename:   Cfg0AbsConfigurationModuleDelegate.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSCONFIGURATIONMODULEDELEGATE_HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSCONFIGURATIONMODULEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsConfigurationModule.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsConfigurationModuleDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsConfigurationModuleImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsConfigurationModule;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsConfigurationModuleGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CFG0CONFIGURATOR_API Teamcenter_alias::Cfg0configurator::Cfg0AbsConfigurationModuleDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cfg0AbsConfigurationModuleDelegate instance
    static Cfg0AbsConfigurationModuleDelegate&  getInstance();

    //  Method to create the Cfg0AbsConfigurationModuleImpl pointer
    static Cfg0AbsConfigurationModuleImpl*  createImpl( Cfg0AbsConfigurationModule&  ifObj );

    //  Method to delete the Cfg0AbsConfigurationModuleImpl pointer
    static void deleteImpl( Cfg0AbsConfigurationModuleImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 12.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0ModulePerspectiveBase(const Cfg0AbsConfigurationModule &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Cfg0AbsConfigurationModule &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Cfg0AbsConfigurationModule &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Validate revise input.
    /// @version Teamcenter 10.1
    /// @param pReviseInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - Returns an int.
    ///
    int  validateReviseInputBase(const Cfg0AbsConfigurationModule &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static Cfg0AbsConfigurationModuleDelegate*  m_pInstance;

    Cfg0AbsConfigurationModuleDelegate();
    virtual ~Cfg0AbsConfigurationModuleDelegate();
    static void setInstance( Cfg0AbsConfigurationModuleDelegate*  instance );


private:
    friend class  ::Teamcenter::Cfg0configurator::Cfg0AbsConfigurationModuleGenImpl;

};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif  //  TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSCONFIGURATIONMODULEDELEGATE_HXX
