//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsConfiguratorCriteria
    Filename:   Cfg0AbsConfiguratorCriteria.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSCONFIGURATORCRITERIA__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSCONFIGURATORCRITERIA__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsConfiguratorWSO.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsConfiguratorCriteria;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsConfiguratorCriteriaImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsConfiguratorCriteriaDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsConfiguratorCriteriaDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsConfiguratorCriteriaGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsConfiguratorCriteria
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsConfiguratorWSO
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsConfiguratorCriteria();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsConfiguratorCriteria();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsConfiguratorCriteriaImpl*  getCfg0AbsConfiguratorCriteriaImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsConfiguratorCriteriaImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsConfiguratorCriteriaImpl*  m_cfg0absconfiguratorcriteriaImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsConfiguratorCriteria - desc for Cfg0AbsConfiguratorCriteria parameter
     */
    Cfg0AbsConfiguratorCriteria( const Cfg0AbsConfiguratorCriteria& );
    Cfg0AbsConfiguratorCriteria& operator=( const Cfg0AbsConfiguratorCriteria& );

    friend class  Cfg0AbsConfiguratorCriteriaDelegate;
    friend class  Cfg0AbsConfiguratorCriteriaDispatch;
    friend class  Cfg0AbsConfiguratorCriteriaGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSCONFIGURATORCRITERIA__HXX
