//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsConstraintRuleThread
    Filename:   Cfg0AbsConstraintRuleThread.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSCONSTRAINTRULETHREAD__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSCONSTRAINTRULETHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsRuleThread.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsConstraintRuleThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsConstraintRuleThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsConstraintRuleThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsConstraintRuleThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsConstraintRuleThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsConstraintRuleThread
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsRuleThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsConstraintRuleThread();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsConstraintRuleThread();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsConstraintRuleThreadImpl*  getCfg0AbsConstraintRuleThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsConstraintRuleThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsConstraintRuleThreadImpl*  m_cfg0absconstraintrulethreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsConstraintRuleThread - desc for Cfg0AbsConstraintRuleThread parameter
     */
    Cfg0AbsConstraintRuleThread( const Cfg0AbsConstraintRuleThread& );
    Cfg0AbsConstraintRuleThread& operator=( const Cfg0AbsConstraintRuleThread& );

    friend class  Cfg0AbsConstraintRuleThreadDelegate;
    friend class  Cfg0AbsConstraintRuleThreadDispatch;
    friend class  Cfg0AbsConstraintRuleThreadGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSCONSTRAINTRULETHREAD__HXX
