//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsDefaultRule
    Filename:   Cfg0AbsDefaultRule.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSDEFAULTRULE__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSDEFAULTRULE__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsRule.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsDefaultRule;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsDefaultRuleImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsDefaultRuleDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsDefaultRuleDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsDefaultRuleGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsDefaultRule
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsRule
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsDefaultRule();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsDefaultRule();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsDefaultRuleImpl*  getCfg0AbsDefaultRuleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsDefaultRuleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsDefaultRuleImpl*  m_cfg0absdefaultruleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsDefaultRule - desc for Cfg0AbsDefaultRule parameter
     */
    Cfg0AbsDefaultRule( const Cfg0AbsDefaultRule& );
    Cfg0AbsDefaultRule& operator=( const Cfg0AbsDefaultRule& );

    friend class  Cfg0AbsDefaultRuleDelegate;
    friend class  Cfg0AbsDefaultRuleDispatch;
    friend class  Cfg0AbsDefaultRuleGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSDEFAULTRULE__HXX
