//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsDefaultRuleThread
    Filename:   Cfg0AbsDefaultRuleThread.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSDEFAULTRULETHREAD__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSDEFAULTRULETHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsRuleThread.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsDefaultRuleThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsDefaultRuleThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsDefaultRuleThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsDefaultRuleThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsDefaultRuleThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsDefaultRuleThread
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsRuleThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsDefaultRuleThread();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsDefaultRuleThread();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsDefaultRuleThreadImpl*  getCfg0AbsDefaultRuleThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsDefaultRuleThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsDefaultRuleThreadImpl*  m_cfg0absdefaultrulethreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsDefaultRuleThread - desc for Cfg0AbsDefaultRuleThread parameter
     */
    Cfg0AbsDefaultRuleThread( const Cfg0AbsDefaultRuleThread& );
    Cfg0AbsDefaultRuleThread& operator=( const Cfg0AbsDefaultRuleThread& );

    friend class  Cfg0AbsDefaultRuleThreadDelegate;
    friend class  Cfg0AbsDefaultRuleThreadDispatch;
    friend class  Cfg0AbsDefaultRuleThreadGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSDEFAULTRULETHREAD__HXX
