//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsEffFamilyThread
    Filename:   Cfg0AbsEffFamilyThread.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSEFFFAMILYTHREAD__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSEFFFAMILYTHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsFamilyThread.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsEffFamilyThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsEffFamilyThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsEffFamilyThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsEffFamilyThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsEffFamilyThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsEffFamilyThread
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsFamilyThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsEffFamilyThread();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsEffFamilyThread();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsEffFamilyThreadImpl*  getCfg0AbsEffFamilyThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsEffFamilyThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsEffFamilyThreadImpl*  m_cfg0absefffamilythreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsEffFamilyThread - desc for Cfg0AbsEffFamilyThread parameter
     */
    Cfg0AbsEffFamilyThread( const Cfg0AbsEffFamilyThread& );
    Cfg0AbsEffFamilyThread& operator=( const Cfg0AbsEffFamilyThread& );

    friend class  Cfg0AbsEffFamilyThreadDelegate;
    friend class  Cfg0AbsEffFamilyThreadDispatch;
    friend class  Cfg0AbsEffFamilyThreadGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSEFFFAMILYTHREAD__HXX
