//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsEffIntentThread
    Filename:   Cfg0AbsEffIntentThread.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSEFFINTENTTHREAD__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSEFFINTENTTHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsValueThread.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsEffIntentThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsEffIntentThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsEffIntentThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsEffIntentThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsEffIntentThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsEffIntentThread
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsValueThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsEffIntentThread();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsEffIntentThread();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsEffIntentThreadImpl*  getCfg0AbsEffIntentThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsEffIntentThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsEffIntentThreadImpl*  m_cfg0abseffintentthreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsEffIntentThread - desc for Cfg0AbsEffIntentThread parameter
     */
    Cfg0AbsEffIntentThread( const Cfg0AbsEffIntentThread& );
    Cfg0AbsEffIntentThread& operator=( const Cfg0AbsEffIntentThread& );

    friend class  Cfg0AbsEffIntentThreadDelegate;
    friend class  Cfg0AbsEffIntentThreadDispatch;
    friend class  Cfg0AbsEffIntentThreadGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSEFFINTENTTHREAD__HXX
