//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsEffectivityFamily
    Filename:   Cfg0AbsEffectivityFamily.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSEFFECTIVITYFAMILY__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSEFFECTIVITYFAMILY__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsFamily.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsEffectivityFamily;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsEffectivityFamilyImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsEffectivityFamilyDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsEffectivityFamilyDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsEffectivityFamilyGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsEffectivityFamily
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsFamily
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsEffectivityFamily();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsEffectivityFamily();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsEffectivityFamilyImpl*  getCfg0AbsEffectivityFamilyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsEffectivityFamilyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsEffectivityFamilyImpl*  m_cfg0abseffectivityfamilyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsEffectivityFamily - desc for Cfg0AbsEffectivityFamily parameter
     */
    Cfg0AbsEffectivityFamily( const Cfg0AbsEffectivityFamily& );
    Cfg0AbsEffectivityFamily& operator=( const Cfg0AbsEffectivityFamily& );

    friend class  Cfg0AbsEffectivityFamilyDelegate;
    friend class  Cfg0AbsEffectivityFamilyDispatch;
    friend class  Cfg0AbsEffectivityFamilyGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSEFFECTIVITYFAMILY__HXX
