//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsEffectivityIntent
    Filename:   Cfg0AbsEffectivityIntent.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSEFFECTIVITYINTENT__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSEFFECTIVITYINTENT__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsValue.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsEffectivityIntent;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsEffectivityIntentImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsEffectivityIntentDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsEffectivityIntentDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsEffectivityIntentGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsEffectivityIntent
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsValue
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsEffectivityIntent();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsEffectivityIntent();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsEffectivityIntentImpl*  getCfg0AbsEffectivityIntentImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsEffectivityIntentImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsEffectivityIntentImpl*  m_cfg0abseffectivityintentImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsEffectivityIntent - desc for Cfg0AbsEffectivityIntent parameter
     */
    Cfg0AbsEffectivityIntent( const Cfg0AbsEffectivityIntent& );
    Cfg0AbsEffectivityIntent& operator=( const Cfg0AbsEffectivityIntent& );

    friend class  Cfg0AbsEffectivityIntentDelegate;
    friend class  Cfg0AbsEffectivityIntentDispatch;
    friend class  Cfg0AbsEffectivityIntentGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSEFFECTIVITYINTENT__HXX
