//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsExceptionRuleDelegate
    Filename:   Cfg0AbsExceptionRuleDelegate.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSEXCEPTIONRULEDELEGATE_HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSEXCEPTIONRULEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsExceptionRule.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsExceptionRuleDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsExceptionRuleImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsExceptionRule;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsExceptionRuleGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CFG0CONFIGURATOR_API Teamcenter_alias::Cfg0configurator::Cfg0AbsExceptionRuleDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cfg0AbsExceptionRuleDelegate instance
    static Cfg0AbsExceptionRuleDelegate&  getInstance();

    //  Method to create the Cfg0AbsExceptionRuleImpl pointer
    static Cfg0AbsExceptionRuleImpl*  createImpl( Cfg0AbsExceptionRule&  ifObj );

    //  Method to delete the Cfg0AbsExceptionRuleImpl pointer
    static void deleteImpl( Cfg0AbsExceptionRuleImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0ExceptionFeatureBase(const Cfg0AbsExceptionRule &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Cfg0AbsExceptionRule &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Cfg0AbsExceptionRule &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// validate saveas input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  validateSaveAsInputBase(const Cfg0AbsExceptionRule &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// Validate revise input.
    /// @version Teamcenter 10.1
    /// @param pReviseInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - Returns an int.
    ///
    int  validateReviseInputBase(const Cfg0AbsExceptionRule &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.7
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCfg0SubjectConditionBase(Cfg0AbsExceptionRule &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static Cfg0AbsExceptionRuleDelegate*  m_pInstance;

    Cfg0AbsExceptionRuleDelegate();
    virtual ~Cfg0AbsExceptionRuleDelegate();
    static void setInstance( Cfg0AbsExceptionRuleDelegate*  instance );


private:
    friend class  ::Teamcenter::Cfg0configurator::Cfg0AbsExceptionRuleGenImpl;

};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif  //  TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSEXCEPTIONRULEDELEGATE_HXX
