//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsExcludeRuleThread
    Filename:   Cfg0AbsExcludeRuleThread.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSEXCLUDERULETHREAD__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSEXCLUDERULETHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsValidationRuleThread.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsExcludeRuleThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsExcludeRuleThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsExcludeRuleThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsExcludeRuleThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsExcludeRuleThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsExcludeRuleThread
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsValidationRuleThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsExcludeRuleThread();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsExcludeRuleThread();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsExcludeRuleThreadImpl*  getCfg0AbsExcludeRuleThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsExcludeRuleThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsExcludeRuleThreadImpl*  m_cfg0absexcluderulethreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsExcludeRuleThread - desc for Cfg0AbsExcludeRuleThread parameter
     */
    Cfg0AbsExcludeRuleThread( const Cfg0AbsExcludeRuleThread& );
    Cfg0AbsExcludeRuleThread& operator=( const Cfg0AbsExcludeRuleThread& );

    friend class  Cfg0AbsExcludeRuleThreadDelegate;
    friend class  Cfg0AbsExcludeRuleThreadDispatch;
    friend class  Cfg0AbsExcludeRuleThreadGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSEXCLUDERULETHREAD__HXX
