//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsExternalOperBlock
    Filename:   Cfg0AbsExternalOperBlock.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSEXTERNALOPERBLOCK__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSEXTERNALOPERBLOCK__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsConfiguratorWSO.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsExternalOperBlock;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsExternalOperBlockImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsExternalOperBlockDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsExternalOperBlockDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsExternalOperBlockGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsExternalOperBlock
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsConfiguratorWSO
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsExternalOperBlock();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsExternalOperBlock();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsExternalOperBlockImpl*  getCfg0AbsExternalOperBlockImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsExternalOperBlockImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsExternalOperBlockImpl*  m_cfg0absexternaloperblockImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsExternalOperBlock - desc for Cfg0AbsExternalOperBlock parameter
     */
    Cfg0AbsExternalOperBlock( const Cfg0AbsExternalOperBlock& );
    Cfg0AbsExternalOperBlock& operator=( const Cfg0AbsExternalOperBlock& );

    friend class  Cfg0AbsExternalOperBlockDelegate;
    friend class  Cfg0AbsExternalOperBlockDispatch;
    friend class  Cfg0AbsExternalOperBlockGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSEXTERNALOPERBLOCK__HXX
