//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsFamilyAvailability
    Filename:   Cfg0AbsFamilyAvailability.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSFAMILYAVAILABILITY__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSFAMILYAVAILABILITY__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsAvailability.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsFamilyAvailability;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsFamilyAvailabilityImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsFamilyAvailabilityDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsFamilyAvailabilityDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsFamilyAvailabilityGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsFamilyAvailability
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsAvailability
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsFamilyAvailability();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsFamilyAvailability();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsFamilyAvailabilityImpl*  getCfg0AbsFamilyAvailabilityImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsFamilyAvailabilityImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsFamilyAvailabilityImpl*  m_cfg0absfamilyavailabilityImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsFamilyAvailability - desc for Cfg0AbsFamilyAvailability parameter
     */
    Cfg0AbsFamilyAvailability( const Cfg0AbsFamilyAvailability& );
    Cfg0AbsFamilyAvailability& operator=( const Cfg0AbsFamilyAvailability& );

    friend class  Cfg0AbsFamilyAvailabilityDelegate;
    friend class  Cfg0AbsFamilyAvailabilityDispatch;
    friend class  Cfg0AbsFamilyAvailabilityGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSFAMILYAVAILABILITY__HXX
