//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsFamilyGroupThread
    Filename:   Cfg0AbsFamilyGroupThread.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSFAMILYGROUPTHREAD__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSFAMILYGROUPTHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsConfiguratorWSOThrd.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsFamilyGroupThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsFamilyGroupThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsFamilyGroupThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsFamilyGroupThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsFamilyGroupThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsFamilyGroupThread
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsConfiguratorWSOThrd
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsFamilyGroupThread();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsFamilyGroupThread();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsFamilyGroupThreadImpl*  getCfg0AbsFamilyGroupThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsFamilyGroupThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsFamilyGroupThreadImpl*  m_cfg0absfamilygroupthreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsFamilyGroupThread - desc for Cfg0AbsFamilyGroupThread parameter
     */
    Cfg0AbsFamilyGroupThread( const Cfg0AbsFamilyGroupThread& );
    Cfg0AbsFamilyGroupThread& operator=( const Cfg0AbsFamilyGroupThread& );

    friend class  Cfg0AbsFamilyGroupThreadDelegate;
    friend class  Cfg0AbsFamilyGroupThreadDispatch;
    friend class  Cfg0AbsFamilyGroupThreadGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSFAMILYGROUPTHREAD__HXX
