//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsFeasibilityRule
    Filename:   Cfg0AbsFeasibilityRule.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSFEASIBILITYRULE__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSFEASIBILITYRULE__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsValidationRule.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsFeasibilityRule;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsFeasibilityRuleImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsFeasibilityRuleDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsFeasibilityRuleDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsFeasibilityRuleGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsFeasibilityRule
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsValidationRule
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsFeasibilityRule();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsFeasibilityRule();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsFeasibilityRuleImpl*  getCfg0AbsFeasibilityRuleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsFeasibilityRuleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsFeasibilityRuleImpl*  m_cfg0absfeasibilityruleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsFeasibilityRule - desc for Cfg0AbsFeasibilityRule parameter
     */
    Cfg0AbsFeasibilityRule( const Cfg0AbsFeasibilityRule& );
    Cfg0AbsFeasibilityRule& operator=( const Cfg0AbsFeasibilityRule& );

    friend class  Cfg0AbsFeasibilityRuleDelegate;
    friend class  Cfg0AbsFeasibilityRuleDispatch;
    friend class  Cfg0AbsFeasibilityRuleGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSFEASIBILITYRULE__HXX
