//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsFeasibilityRuleDelegate
    Filename:   Cfg0AbsFeasibilityRuleDelegate.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSFEASIBILITYRULEDELEGATE_HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSFEASIBILITYRULEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsFeasibilityRule.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsFeasibilityRuleDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsFeasibilityRuleImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsFeasibilityRule;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsFeasibilityRuleGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CFG0CONFIGURATOR_API Teamcenter_alias::Cfg0configurator::Cfg0AbsFeasibilityRuleDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cfg0AbsFeasibilityRuleDelegate instance
    static Cfg0AbsFeasibilityRuleDelegate&  getInstance();

    //  Method to create the Cfg0AbsFeasibilityRuleImpl pointer
    static Cfg0AbsFeasibilityRuleImpl*  createImpl( Cfg0AbsFeasibilityRule&  ifObj );

    //  Method to delete the Cfg0AbsFeasibilityRuleImpl pointer
    static void deleteImpl( Cfg0AbsFeasibilityRuleImpl*  impl );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Cfg0AbsFeasibilityRule &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// validate saveas input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  validateSaveAsInputBase(const Cfg0AbsFeasibilityRule &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// Validate revise input.
    /// @version Teamcenter 10.1
    /// @param pReviseInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - Returns an int.
    ///
    int  validateReviseInputBase(const Cfg0AbsFeasibilityRule &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static Cfg0AbsFeasibilityRuleDelegate*  m_pInstance;

    Cfg0AbsFeasibilityRuleDelegate();
    virtual ~Cfg0AbsFeasibilityRuleDelegate();
    static void setInstance( Cfg0AbsFeasibilityRuleDelegate*  instance );


private:
    friend class  ::Teamcenter::Cfg0configurator::Cfg0AbsFeasibilityRuleGenImpl;

};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif  //  TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSFEASIBILITYRULEDELEGATE_HXX
