//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsFeatureSetDelegate
    Filename:   Cfg0AbsFeatureSetDelegate.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSFEATURESETDELEGATE_HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSFEATURESETDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsFeatureSet.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsFeatureSetDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsFeatureSetImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsFeatureSet;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsFeatureSetGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CFG0CONFIGURATOR_API Teamcenter_alias::Cfg0configurator::Cfg0AbsFeatureSetDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cfg0AbsFeatureSetDelegate instance
    static Cfg0AbsFeatureSetDelegate&  getInstance();

    //  Method to create the Cfg0AbsFeatureSetImpl pointer
    static Cfg0AbsFeatureSetImpl*  createImpl( Cfg0AbsFeatureSet&  ifObj );

    //  Method to delete the Cfg0AbsFeatureSetImpl pointer
    static void deleteImpl( Cfg0AbsFeatureSetImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.5
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0FeaturesBase(const Cfg0AbsFeatureSet &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.5
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0FeatureThreadsBase(const Cfg0AbsFeatureSet &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.5
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0ProductItemsBase(const Cfg0AbsFeatureSet &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 11.5
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setCfg0FeaturesBase(Cfg0AbsFeatureSet &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 11.5
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setCfg0FeatureThreadsBase(Cfg0AbsFeatureSet &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Cfg0AbsFeatureSet &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Cfg0AbsFeatureSet &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// finalize operation input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  finalizeSaveAsInputBase(const Cfg0AbsFeatureSet &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Cfg0AbsFeatureSet &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// validate saveas input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  validateSaveAsInputBase(const Cfg0AbsFeatureSet &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static Cfg0AbsFeatureSetDelegate*  m_pInstance;

    Cfg0AbsFeatureSetDelegate();
    virtual ~Cfg0AbsFeatureSetDelegate();
    static void setInstance( Cfg0AbsFeatureSetDelegate*  instance );


private:
    friend class  ::Teamcenter::Cfg0configurator::Cfg0AbsFeatureSetGenImpl;

};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif  //  TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSFEATURESETDELEGATE_HXX
