//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsFeatureSetThread
    Filename:   Cfg0AbsFeatureSetThread.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSFEATURESETTHREAD__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSFEATURESETTHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsFamilyThread.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsFeatureSetThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsFeatureSetThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsFeatureSetThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsFeatureSetThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsFeatureSetThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsFeatureSetThread
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsFamilyThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsFeatureSetThread();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsFeatureSetThread();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsFeatureSetThreadImpl*  getCfg0AbsFeatureSetThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsFeatureSetThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsFeatureSetThreadImpl*  m_cfg0absfeaturesetthreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsFeatureSetThread - desc for Cfg0AbsFeatureSetThread parameter
     */
    Cfg0AbsFeatureSetThread( const Cfg0AbsFeatureSetThread& );
    Cfg0AbsFeatureSetThread& operator=( const Cfg0AbsFeatureSetThread& );

    friend class  Cfg0AbsFeatureSetThreadDelegate;
    friend class  Cfg0AbsFeatureSetThreadDispatch;
    friend class  Cfg0AbsFeatureSetThreadGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSFEATURESETTHREAD__HXX
