//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsIncludeRuleThread
    Filename:   Cfg0AbsIncludeRuleThread.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSINCLUDERULETHREAD__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSINCLUDERULETHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsConstraintRuleThread.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsIncludeRuleThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsIncludeRuleThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsIncludeRuleThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsIncludeRuleThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsIncludeRuleThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsIncludeRuleThread
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsConstraintRuleThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsIncludeRuleThread();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsIncludeRuleThread();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsIncludeRuleThreadImpl*  getCfg0AbsIncludeRuleThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsIncludeRuleThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsIncludeRuleThreadImpl*  m_cfg0absincluderulethreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsIncludeRuleThread - desc for Cfg0AbsIncludeRuleThread parameter
     */
    Cfg0AbsIncludeRuleThread( const Cfg0AbsIncludeRuleThread& );
    Cfg0AbsIncludeRuleThread& operator=( const Cfg0AbsIncludeRuleThread& );

    friend class  Cfg0AbsIncludeRuleThreadDelegate;
    friend class  Cfg0AbsIncludeRuleThreadDispatch;
    friend class  Cfg0AbsIncludeRuleThreadGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSINCLUDERULETHREAD__HXX
