//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsLiteralFamilyThread
    Filename:   Cfg0AbsLiteralFamilyThread.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSLITERALFAMILYTHREAD__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSLITERALFAMILYTHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsOptionFamilyThread.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsLiteralFamilyThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsLiteralFamilyThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsLiteralFamilyThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsLiteralFamilyThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsLiteralFamilyThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsLiteralFamilyThread
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsOptionFamilyThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsLiteralFamilyThread();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsLiteralFamilyThread();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsLiteralFamilyThreadImpl*  getCfg0AbsLiteralFamilyThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsLiteralFamilyThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsLiteralFamilyThreadImpl*  m_cfg0absliteralfamilythreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsLiteralFamilyThread - desc for Cfg0AbsLiteralFamilyThread parameter
     */
    Cfg0AbsLiteralFamilyThread( const Cfg0AbsLiteralFamilyThread& );
    Cfg0AbsLiteralFamilyThread& operator=( const Cfg0AbsLiteralFamilyThread& );

    friend class  Cfg0AbsLiteralFamilyThreadDelegate;
    friend class  Cfg0AbsLiteralFamilyThreadDispatch;
    friend class  Cfg0AbsLiteralFamilyThreadGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSLITERALFAMILYTHREAD__HXX
