//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsLiteralOptionValue
    Filename:   Cfg0AbsLiteralOptionValue.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSLITERALOPTIONVALUE__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSLITERALOPTIONVALUE__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsOptionValue.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsLiteralOptionValue;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsLiteralOptionValueImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsLiteralOptionValueDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsLiteralOptionValueDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsLiteralOptionValueGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsLiteralOptionValue
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsOptionValue
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsLiteralOptionValue();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsLiteralOptionValue();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsLiteralOptionValueImpl*  getCfg0AbsLiteralOptionValueImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsLiteralOptionValueImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsLiteralOptionValueImpl*  m_cfg0absliteraloptionvalueImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsLiteralOptionValue - desc for Cfg0AbsLiteralOptionValue parameter
     */
    Cfg0AbsLiteralOptionValue( const Cfg0AbsLiteralOptionValue& );
    Cfg0AbsLiteralOptionValue& operator=( const Cfg0AbsLiteralOptionValue& );

    friend class  Cfg0AbsLiteralOptionValueDelegate;
    friend class  Cfg0AbsLiteralOptionValueDispatch;
    friend class  Cfg0AbsLiteralOptionValueGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSLITERALOPTIONVALUE__HXX
