//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsLiteralValueFamily
    Filename:   Cfg0AbsLiteralValueFamily.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSLITERALVALUEFAMILY__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSLITERALVALUEFAMILY__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsOptionFamily.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsLiteralValueFamily;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsLiteralValueFamilyImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsLiteralValueFamilyDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsLiteralValueFamilyDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsLiteralValueFamilyGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsLiteralValueFamily
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsOptionFamily
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsLiteralValueFamily();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsLiteralValueFamily();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsLiteralValueFamilyImpl*  getCfg0AbsLiteralValueFamilyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsLiteralValueFamilyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsLiteralValueFamilyImpl*  m_cfg0absliteralvaluefamilyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsLiteralValueFamily - desc for Cfg0AbsLiteralValueFamily parameter
     */
    Cfg0AbsLiteralValueFamily( const Cfg0AbsLiteralValueFamily& );
    Cfg0AbsLiteralValueFamily& operator=( const Cfg0AbsLiteralValueFamily& );

    friend class  Cfg0AbsLiteralValueFamilyDelegate;
    friend class  Cfg0AbsLiteralValueFamilyDispatch;
    friend class  Cfg0AbsLiteralValueFamilyGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSLITERALVALUEFAMILY__HXX
