//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsLiteralValueThread
    Filename:   Cfg0AbsLiteralValueThread.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSLITERALVALUETHREAD__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSLITERALVALUETHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsOptionValueThread.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsLiteralValueThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsLiteralValueThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsLiteralValueThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsLiteralValueThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsLiteralValueThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsLiteralValueThread
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsOptionValueThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsLiteralValueThread();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsLiteralValueThread();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsLiteralValueThreadImpl*  getCfg0AbsLiteralValueThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsLiteralValueThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsLiteralValueThreadImpl*  m_cfg0absliteralvaluethreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsLiteralValueThread - desc for Cfg0AbsLiteralValueThread parameter
     */
    Cfg0AbsLiteralValueThread( const Cfg0AbsLiteralValueThread& );
    Cfg0AbsLiteralValueThread& operator=( const Cfg0AbsLiteralValueThread& );

    friend class  Cfg0AbsLiteralValueThreadDelegate;
    friend class  Cfg0AbsLiteralValueThreadDispatch;
    friend class  Cfg0AbsLiteralValueThreadGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSLITERALVALUETHREAD__HXX
