//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsModelDelegate
    Filename:   Cfg0AbsModelDelegate.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSMODELDELEGATE_HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSMODELDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsModel.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsModelDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsModelImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsModel;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsModelGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CFG0CONFIGURATOR_API Teamcenter_alias::Cfg0configurator::Cfg0AbsModelDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cfg0AbsModelDelegate instance
    static Cfg0AbsModelDelegate&  getInstance();

    //  Method to create the Cfg0AbsModelImpl pointer
    static Cfg0AbsModelImpl*  createImpl( Cfg0AbsModel&  ifObj );

    //  Method to delete the Cfg0AbsModelImpl pointer
    static void deleteImpl( Cfg0AbsModelImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 12.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0CharacteristicsBase(const Cfg0AbsModel &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0ModelFamilyBase(const Cfg0AbsModel &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property. This property will be loaded based on application configurations.
    /// @version Teamcenter 12.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0ParentBase(const Cfg0AbsModel &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property. This property setter will update the property cfg0ParentThread.
    /// @version Teamcenter 12.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCfg0ParentBase(Cfg0AbsModel &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Cfg0AbsModel &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Cfg0AbsModel &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Cfg0AbsModelDelegate*  m_pInstance;

    Cfg0AbsModelDelegate();
    virtual ~Cfg0AbsModelDelegate();
    static void setInstance( Cfg0AbsModelDelegate*  instance );


private:
    friend class  ::Teamcenter::Cfg0configurator::Cfg0AbsModelGenImpl;

};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif  //  TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSMODELDELEGATE_HXX
