//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsModelFamily
    Filename:   Cfg0AbsModelFamily.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSMODELFAMILY__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSMODELFAMILY__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsFamily.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsModelFamily;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsModelFamilyImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsModelFamilyDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsModelFamilyDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsModelFamilyGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsModelFamily
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsFamily
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsModelFamily();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsModelFamily();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsModelFamilyImpl*  getCfg0AbsModelFamilyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsModelFamilyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsModelFamilyImpl*  m_cfg0absmodelfamilyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsModelFamily - desc for Cfg0AbsModelFamily parameter
     */
    Cfg0AbsModelFamily( const Cfg0AbsModelFamily& );
    Cfg0AbsModelFamily& operator=( const Cfg0AbsModelFamily& );

    friend class  Cfg0AbsModelFamilyDelegate;
    friend class  Cfg0AbsModelFamilyDispatch;
    friend class  Cfg0AbsModelFamilyGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSMODELFAMILY__HXX
