//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsModelScopedWSODelegate
    Filename:   Cfg0AbsModelScopedWSODelegate.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSMODELSCOPEDWSODELEGATE_HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSMODELSCOPEDWSODELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsModelScopedWSO.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsModelScopedWSODelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsModelScopedWSOImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsModelScopedWSO;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsModelScopedWSOGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CFG0CONFIGURATOR_API Teamcenter_alias::Cfg0configurator::Cfg0AbsModelScopedWSODelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cfg0AbsModelScopedWSODelegate instance
    static Cfg0AbsModelScopedWSODelegate&  getInstance();

    //  Method to create the Cfg0AbsModelScopedWSOImpl pointer
    static Cfg0AbsModelScopedWSOImpl*  createImpl( Cfg0AbsModelScopedWSO&  ifObj );

    //  Method to delete the Cfg0AbsModelScopedWSOImpl pointer
    static void deleteImpl( Cfg0AbsModelScopedWSOImpl*  impl );


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 10.1.2
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setCfg0ProductItemsBase(Cfg0AbsModelScopedWSO &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Cfg0AbsModelScopedWSO &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Cfg0AbsModelScopedWSO &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Cfg0AbsModelScopedWSODelegate*  m_pInstance;

    Cfg0AbsModelScopedWSODelegate();
    virtual ~Cfg0AbsModelScopedWSODelegate();
    static void setInstance( Cfg0AbsModelScopedWSODelegate*  instance );


private:
    friend class  ::Teamcenter::Cfg0configurator::Cfg0AbsModelScopedWSOGenImpl;

};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif  //  TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSMODELSCOPEDWSODELEGATE_HXX
