//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsOptionFamilyThread
    Filename:   Cfg0AbsOptionFamilyThread.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSOPTIONFAMILYTHREAD__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSOPTIONFAMILYTHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsFamilyThread.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsOptionFamilyThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsOptionFamilyThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsOptionFamilyThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsOptionFamilyThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsOptionFamilyThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsOptionFamilyThread
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsFamilyThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsOptionFamilyThread();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsOptionFamilyThread();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsOptionFamilyThreadImpl*  getCfg0AbsOptionFamilyThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsOptionFamilyThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsOptionFamilyThreadImpl*  m_cfg0absoptionfamilythreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsOptionFamilyThread - desc for Cfg0AbsOptionFamilyThread parameter
     */
    Cfg0AbsOptionFamilyThread( const Cfg0AbsOptionFamilyThread& );
    Cfg0AbsOptionFamilyThread& operator=( const Cfg0AbsOptionFamilyThread& );

    friend class  Cfg0AbsOptionFamilyThreadDelegate;
    friend class  Cfg0AbsOptionFamilyThreadDispatch;
    friend class  Cfg0AbsOptionFamilyThreadGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSOPTIONFAMILYTHREAD__HXX
