//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsOptionValueThread
    Filename:   Cfg0AbsOptionValueThread.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSOPTIONVALUETHREAD__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSOPTIONVALUETHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsValueThread.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsOptionValueThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsOptionValueThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsOptionValueThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsOptionValueThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsOptionValueThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsOptionValueThread
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsValueThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsOptionValueThread();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsOptionValueThread();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsOptionValueThreadImpl*  getCfg0AbsOptionValueThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsOptionValueThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsOptionValueThreadImpl*  m_cfg0absoptionvaluethreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsOptionValueThread - desc for Cfg0AbsOptionValueThread parameter
     */
    Cfg0AbsOptionValueThread( const Cfg0AbsOptionValueThread& );
    Cfg0AbsOptionValueThread& operator=( const Cfg0AbsOptionValueThread& );

    friend class  Cfg0AbsOptionValueThreadDelegate;
    friend class  Cfg0AbsOptionValueThreadDispatch;
    friend class  Cfg0AbsOptionValueThreadGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSOPTIONVALUETHREAD__HXX
