//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsPackageOptionFamily
    Filename:   Cfg0AbsPackageOptionFamily.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSPACKAGEOPTIONFAMILY__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSPACKAGEOPTIONFAMILY__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsCompoundValueFamily.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsPackageOptionFamily;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsPackageOptionFamilyImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsPackageOptionFamilyDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsPackageOptionFamilyDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsPackageOptionFamilyGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsPackageOptionFamily
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsCompoundValueFamily
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsPackageOptionFamily();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsPackageOptionFamily();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsPackageOptionFamilyImpl*  getCfg0AbsPackageOptionFamilyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsPackageOptionFamilyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsPackageOptionFamilyImpl*  m_cfg0abspackageoptionfamilyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsPackageOptionFamily - desc for Cfg0AbsPackageOptionFamily parameter
     */
    Cfg0AbsPackageOptionFamily( const Cfg0AbsPackageOptionFamily& );
    Cfg0AbsPackageOptionFamily& operator=( const Cfg0AbsPackageOptionFamily& );

    friend class  Cfg0AbsPackageOptionFamilyDelegate;
    friend class  Cfg0AbsPackageOptionFamilyDispatch;
    friend class  Cfg0AbsPackageOptionFamilyGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSPACKAGEOPTIONFAMILY__HXX
