//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsPackageOptionValue
    Filename:   Cfg0AbsPackageOptionValue.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSPACKAGEOPTIONVALUE__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSPACKAGEOPTIONVALUE__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsCompoundOptionValue.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsPackageOptionValue;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsPackageOptionValueImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsPackageOptionValueDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsPackageOptionValueDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsPackageOptionValueGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsPackageOptionValue
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsCompoundOptionValue
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsPackageOptionValue();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsPackageOptionValue();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsPackageOptionValueImpl*  getCfg0AbsPackageOptionValueImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsPackageOptionValueImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsPackageOptionValueImpl*  m_cfg0abspackageoptionvalueImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsPackageOptionValue - desc for Cfg0AbsPackageOptionValue parameter
     */
    Cfg0AbsPackageOptionValue( const Cfg0AbsPackageOptionValue& );
    Cfg0AbsPackageOptionValue& operator=( const Cfg0AbsPackageOptionValue& );

    friend class  Cfg0AbsPackageOptionValueDelegate;
    friend class  Cfg0AbsPackageOptionValueDispatch;
    friend class  Cfg0AbsPackageOptionValueGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSPACKAGEOPTIONVALUE__HXX
