//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsPackageOptionValueDelegate
    Filename:   Cfg0AbsPackageOptionValueDelegate.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSPACKAGEOPTIONVALUEDELEGATE_HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSPACKAGEOPTIONVALUEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsPackageOptionValue.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsPackageOptionValueDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsPackageOptionValueImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsPackageOptionValue;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsPackageOptionValueGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CFG0CONFIGURATOR_API Teamcenter_alias::Cfg0configurator::Cfg0AbsPackageOptionValueDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cfg0AbsPackageOptionValueDelegate instance
    static Cfg0AbsPackageOptionValueDelegate&  getInstance();

    //  Method to create the Cfg0AbsPackageOptionValueImpl pointer
    static Cfg0AbsPackageOptionValueImpl*  createImpl( Cfg0AbsPackageOptionValue&  ifObj );

    //  Method to delete the Cfg0AbsPackageOptionValueImpl pointer
    static void deleteImpl( Cfg0AbsPackageOptionValueImpl*  impl );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Cfg0AbsPackageOptionValue &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 10.1.2
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setCfg0OptionValuesBase(Cfg0AbsPackageOptionValue &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );



protected:
    //  Pointer to the instance
    static Cfg0AbsPackageOptionValueDelegate*  m_pInstance;

    Cfg0AbsPackageOptionValueDelegate();
    virtual ~Cfg0AbsPackageOptionValueDelegate();
    static void setInstance( Cfg0AbsPackageOptionValueDelegate*  instance );


private:
    friend class  ::Teamcenter::Cfg0configurator::Cfg0AbsPackageOptionValueGenImpl;

};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif  //  TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSPACKAGEOPTIONVALUEDELEGATE_HXX
