//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsPackageRule
    Filename:   Cfg0AbsPackageRule.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSPACKAGERULE__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSPACKAGERULE__HXX

#include <string>
#include <vector>
#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsConstraintRule.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsPackageRule;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsPackageRuleImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsPackageRuleDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsPackageRuleDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsPackageRuleGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsPackageRule
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsConstraintRule
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0DefaultCondition( std::string &value, bool &isNull ) const;

    ///
    /// Getter for Property Display Value
    /// @version Teamcenter 11.5
    /// @param values - Parameter value
    /// @return - Status. 0 if successful
    ///
    int  getCfg0DefaultConditionDisplayableValues( std::vector< std::string > &values );

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0Package( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.5
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCfg0DefaultCondition( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsPackageRule();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsPackageRule();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsPackageRuleImpl*  getCfg0AbsPackageRuleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsPackageRuleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsPackageRuleImpl*  m_cfg0abspackageruleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsPackageRule - desc for Cfg0AbsPackageRule parameter
     */
    Cfg0AbsPackageRule( const Cfg0AbsPackageRule& );
    Cfg0AbsPackageRule& operator=( const Cfg0AbsPackageRule& );

    friend class  Cfg0AbsPackageRuleDelegate;
    friend class  Cfg0AbsPackageRuleDispatch;
    friend class  Cfg0AbsPackageRuleGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSPACKAGERULE__HXX
