//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsProductLineDelegate
    Filename:   Cfg0AbsProductLineDelegate.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSPRODUCTLINEDELEGATE_HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSPRODUCTLINEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsProductLine.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsProductLineDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsProductLineImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsProductLine;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsProductLineGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CFG0CONFIGURATOR_API Teamcenter_alias::Cfg0configurator::Cfg0AbsProductLineDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cfg0AbsProductLineDelegate instance
    static Cfg0AbsProductLineDelegate&  getInstance();

    //  Method to create the Cfg0AbsProductLineImpl pointer
    static Cfg0AbsProductLineImpl*  createImpl( Cfg0AbsProductLine&  ifObj );

    //  Method to delete the Cfg0AbsProductLineImpl pointer
    static void deleteImpl( Cfg0AbsProductLineImpl*  impl );


    ///
    /// Getter for a Tag Array Property. This property will be loaded based on application configurations.
    /// @version Teamcenter 12.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @deprecated Teamcenter::Cfg0configurator::Cfg0AbsProductLine::getCfg0Characterstics deprecated in Teamcenter 12.3
    /// @return - Status. 0 if successful
    ///
    TC_DEPRECATED_WITH_DEPRECATION_INFO("Teamcenter 12.3","Teamcenter::Cfg0configurator::Cfg0AbsProductLine::getCfg0Characterstics","Deprecated. See Support Announcement "getCfg0Characterstics Command Deprecated" in the Teamcenter 12.3 README.")
    int  getCfg0CharactersticsBase(const Cfg0AbsProductLine &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1.5
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0OptionValuesBase(const Cfg0AbsProductLine &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1.5
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0ProductModelsBase(const Cfg0AbsProductLine &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 10.1.5
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setCfg0OptionValuesBase(Cfg0AbsProductLine &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Cfg0AbsProductLine &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Generic saveAsPost operation.
    /// @version Teamcenter 8.1
    /// @param pSavAsInput - Input argument as SaveAsInput object.
    /// @param vecDeepCopyData - vector deepcopy data
    /// @return - Return integer value.
    ///
    int  saveAsPostBase(const Cfg0AbsProductLine &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 12.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0CharacteristicsBase(const Cfg0AbsProductLine &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;



protected:
    //  Pointer to the instance
    static Cfg0AbsProductLineDelegate*  m_pInstance;

    Cfg0AbsProductLineDelegate();
    virtual ~Cfg0AbsProductLineDelegate();
    static void setInstance( Cfg0AbsProductLineDelegate*  instance );


private:
    friend class  ::Teamcenter::Cfg0configurator::Cfg0AbsProductLineGenImpl;

};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif  //  TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSPRODUCTLINEDELEGATE_HXX
