//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsProductLineFamily
    Filename:   Cfg0AbsProductLineFamily.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSPRODUCTLINEFAMILY__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSPRODUCTLINEFAMILY__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsModelFamily.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsProductLineFamily;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsProductLineFamilyImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsProductLineFamilyDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsProductLineFamilyDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsProductLineFamilyGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsProductLineFamily
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsModelFamily
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsProductLineFamily();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsProductLineFamily();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsProductLineFamilyImpl*  getCfg0AbsProductLineFamilyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsProductLineFamilyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsProductLineFamilyImpl*  m_cfg0absproductlinefamilyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsProductLineFamily - desc for Cfg0AbsProductLineFamily parameter
     */
    Cfg0AbsProductLineFamily( const Cfg0AbsProductLineFamily& );
    Cfg0AbsProductLineFamily& operator=( const Cfg0AbsProductLineFamily& );

    friend class  Cfg0AbsProductLineFamilyDelegate;
    friend class  Cfg0AbsProductLineFamilyDispatch;
    friend class  Cfg0AbsProductLineFamilyGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSPRODUCTLINEFAMILY__HXX
