//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsProductModel
    Filename:   Cfg0AbsProductModel.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSPRODUCTMODEL__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSPRODUCTMODEL__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsModel.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsProductModel;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsProductModelImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsProductModelDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsProductModelDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsProductModelGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsProductModel
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsModel
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property. This property will be loaded based on application configurations.
    /// @version Teamcenter 12.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @deprecated Teamcenter::Cfg0configurator::Cfg0AbsProductModel::getCfg0Characterstics deprecated in Teamcenter 12.3
    /// @return - Status. 0 if successful
    ///
    TC_DEPRECATED_WITH_DEPRECATION_INFO("Teamcenter 12.3","Teamcenter::Cfg0configurator::Cfg0AbsProductModel::getCfg0Characterstics","deprecated. See Support Announcement "getCfg0Characterstics Command Deprecated" in the Teamcenter 12.3 README.")
    int  getCfg0Characterstics( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0OptionValues( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Sets a list of Features as members to the product model. It also sets the expression created from the Features on the product model.
    /// @version Teamcenter 10.1.7
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setCfg0OptionValues( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsProductModel();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsProductModel();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsProductModelImpl*  getCfg0AbsProductModelImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsProductModelImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsProductModelImpl*  m_cfg0absproductmodelImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsProductModel - desc for Cfg0AbsProductModel parameter
     */
    Cfg0AbsProductModel( const Cfg0AbsProductModel& );
    Cfg0AbsProductModel& operator=( const Cfg0AbsProductModel& );

    friend class  Cfg0AbsProductModelDelegate;
    friend class  Cfg0AbsProductModelDispatch;
    friend class  Cfg0AbsProductModelGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSPRODUCTMODEL__HXX
