//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsProductModelDelegate
    Filename:   Cfg0AbsProductModelDelegate.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSPRODUCTMODELDELEGATE_HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSPRODUCTMODELDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsProductModel.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsProductModelDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsProductModelImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsProductModel;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsProductModelGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CFG0CONFIGURATOR_API Teamcenter_alias::Cfg0configurator::Cfg0AbsProductModelDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cfg0AbsProductModelDelegate instance
    static Cfg0AbsProductModelDelegate&  getInstance();

    //  Method to create the Cfg0AbsProductModelImpl pointer
    static Cfg0AbsProductModelImpl*  createImpl( Cfg0AbsProductModel&  ifObj );

    //  Method to delete the Cfg0AbsProductModelImpl pointer
    static void deleteImpl( Cfg0AbsProductModelImpl*  impl );


    ///
    /// Getter for a Tag Array Property. This property will be loaded based on application configurations.
    /// @version Teamcenter 12.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @deprecated Teamcenter::Cfg0configurator::Cfg0AbsProductModel::getCfg0Characterstics deprecated in Teamcenter 12.3
    /// @return - Status. 0 if successful
    ///
    TC_DEPRECATED_WITH_DEPRECATION_INFO("Teamcenter 12.3","Teamcenter::Cfg0configurator::Cfg0AbsProductModel::getCfg0Characterstics","deprecated. See Support Announcement "getCfg0Characterstics Command Deprecated" in the Teamcenter 12.3 README.")
    int  getCfg0CharactersticsBase(const Cfg0AbsProductModel &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0OptionValuesBase(const Cfg0AbsProductModel &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Sets a list of Features as members to the product model. It also sets the expression created from the Features on the product model.
    /// @version Teamcenter 10.1.7
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setCfg0OptionValuesBase(Cfg0AbsProductModel &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Cfg0AbsProductModel &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Generic saveAsPost operation.
    /// @version Teamcenter 8.1
    /// @param pSavAsInput - Input argument as SaveAsInput object.
    /// @param vecDeepCopyData - vector deepcopy data
    /// @return - Return integer value.
    ///
    int  saveAsPostBase(const Cfg0AbsProductModel &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 12.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0CharacteristicsBase(const Cfg0AbsProductModel &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;



protected:
    //  Pointer to the instance
    static Cfg0AbsProductModelDelegate*  m_pInstance;

    Cfg0AbsProductModelDelegate();
    virtual ~Cfg0AbsProductModelDelegate();
    static void setInstance( Cfg0AbsProductModelDelegate*  instance );


private:
    friend class  ::Teamcenter::Cfg0configurator::Cfg0AbsProductModelGenImpl;

};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif  //  TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSPRODUCTMODELDELEGATE_HXX
