//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsSumModelFamilyThread
    Filename:   Cfg0AbsSumModelFamilyThread.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSSUMMODELFAMILYTHREAD__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSSUMMODELFAMILYTHREAD__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsModelFamilyThread.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsSumModelFamilyThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsSumModelFamilyThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsSumModelFamilyThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsSumModelFamilyThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsSumModelFamilyThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsSumModelFamilyThread
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsModelFamilyThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @deprecated Teamcenter::Cfg0configurator::Cfg0AbsSumModelFamilyThread::getCfg0SummarizedModelFamily deprecated in Teamcenter 10.1.3
    /// @return - Status. 0 if successful
    ///
    TC_DEPRECATED_WITH_DEPRECATION_INFO("Teamcenter 10.1.3","Teamcenter::Cfg0configurator::Cfg0AbsSumModelFamilyThread::getCfg0SummarizedModelFamily","This property is deprecated Teamcenter 10.1.3 onwards and will be removed in Teamcenter 11.1. Please do not use this property.")
    int  getCfg0SummarizedModelFamily( tag_t &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsSumModelFamilyThread();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsSumModelFamilyThread();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsSumModelFamilyThreadImpl*  getCfg0AbsSumModelFamilyThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsSumModelFamilyThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsSumModelFamilyThreadImpl*  m_cfg0abssummodelfamilythreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsSumModelFamilyThread - desc for Cfg0AbsSumModelFamilyThread parameter
     */
    Cfg0AbsSumModelFamilyThread( const Cfg0AbsSumModelFamilyThread& );
    Cfg0AbsSumModelFamilyThread& operator=( const Cfg0AbsSumModelFamilyThread& );

    friend class  Cfg0AbsSumModelFamilyThreadDelegate;
    friend class  Cfg0AbsSumModelFamilyThreadDispatch;
    friend class  Cfg0AbsSumModelFamilyThreadGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSSUMMODELFAMILYTHREAD__HXX
