//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsSummaryFamilyThread
    Filename:   Cfg0AbsSummaryFamilyThread.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSSUMMARYFAMILYTHREAD__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSSUMMARYFAMILYTHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsCompoundFamilyThread.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsSummaryFamilyThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsSummaryFamilyThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsSummaryFamilyThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsSummaryFamilyThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsSummaryFamilyThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsSummaryFamilyThread
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsCompoundFamilyThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsSummaryFamilyThread();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsSummaryFamilyThread();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsSummaryFamilyThreadImpl*  getCfg0AbsSummaryFamilyThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsSummaryFamilyThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsSummaryFamilyThreadImpl*  m_cfg0abssummaryfamilythreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsSummaryFamilyThread - desc for Cfg0AbsSummaryFamilyThread parameter
     */
    Cfg0AbsSummaryFamilyThread( const Cfg0AbsSummaryFamilyThread& );
    Cfg0AbsSummaryFamilyThread& operator=( const Cfg0AbsSummaryFamilyThread& );

    friend class  Cfg0AbsSummaryFamilyThreadDelegate;
    friend class  Cfg0AbsSummaryFamilyThreadDispatch;
    friend class  Cfg0AbsSummaryFamilyThreadGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSSUMMARYFAMILYTHREAD__HXX
