//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsSummaryModelThread
    Filename:   Cfg0AbsSummaryModelThread.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSSUMMARYMODELTHREAD__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSSUMMARYMODELTHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsModelThread.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsSummaryModelThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsSummaryModelThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsSummaryModelThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsSummaryModelThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsSummaryModelThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsSummaryModelThread
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsModelThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsSummaryModelThread();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsSummaryModelThread();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsSummaryModelThreadImpl*  getCfg0AbsSummaryModelThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsSummaryModelThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsSummaryModelThreadImpl*  m_cfg0abssummarymodelthreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsSummaryModelThread - desc for Cfg0AbsSummaryModelThread parameter
     */
    Cfg0AbsSummaryModelThread( const Cfg0AbsSummaryModelThread& );
    Cfg0AbsSummaryModelThread& operator=( const Cfg0AbsSummaryModelThread& );

    friend class  Cfg0AbsSummaryModelThreadDelegate;
    friend class  Cfg0AbsSummaryModelThreadDispatch;
    friend class  Cfg0AbsSummaryModelThreadGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSSUMMARYMODELTHREAD__HXX
