//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsSummaryOptionValue
    Filename:   Cfg0AbsSummaryOptionValue.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSSUMMARYOPTIONVALUE__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSSUMMARYOPTIONVALUE__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsCompoundOptionValue.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsSummaryOptionValue;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsSummaryOptionValueImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsSummaryOptionValueDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsSummaryOptionValueDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsSummaryOptionValueGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsSummaryOptionValue
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsCompoundOptionValue
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsSummaryOptionValue();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsSummaryOptionValue();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsSummaryOptionValueImpl*  getCfg0AbsSummaryOptionValueImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsSummaryOptionValueImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsSummaryOptionValueImpl*  m_cfg0abssummaryoptionvalueImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsSummaryOptionValue - desc for Cfg0AbsSummaryOptionValue parameter
     */
    Cfg0AbsSummaryOptionValue( const Cfg0AbsSummaryOptionValue& );
    Cfg0AbsSummaryOptionValue& operator=( const Cfg0AbsSummaryOptionValue& );

    friend class  Cfg0AbsSummaryOptionValueDelegate;
    friend class  Cfg0AbsSummaryOptionValueDispatch;
    friend class  Cfg0AbsSummaryOptionValueGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSSUMMARYOPTIONVALUE__HXX
