//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsSummaryValueThread
    Filename:   Cfg0AbsSummaryValueThread.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSSUMMARYVALUETHREAD__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSSUMMARYVALUETHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsCompoundValueThread.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsSummaryValueThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsSummaryValueThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsSummaryValueThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsSummaryValueThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsSummaryValueThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsSummaryValueThread
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsCompoundValueThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsSummaryValueThread();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsSummaryValueThread();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsSummaryValueThreadImpl*  getCfg0AbsSummaryValueThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsSummaryValueThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsSummaryValueThreadImpl*  m_cfg0abssummaryvaluethreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsSummaryValueThread - desc for Cfg0AbsSummaryValueThread parameter
     */
    Cfg0AbsSummaryValueThread( const Cfg0AbsSummaryValueThread& );
    Cfg0AbsSummaryValueThread& operator=( const Cfg0AbsSummaryValueThread& );

    friend class  Cfg0AbsSummaryValueThreadDelegate;
    friend class  Cfg0AbsSummaryValueThreadDispatch;
    friend class  Cfg0AbsSummaryValueThreadGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSSUMMARYVALUETHREAD__HXX
