//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsValidationRuleThread
    Filename:   Cfg0AbsValidationRuleThread.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSVALIDATIONRULETHREAD__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSVALIDATIONRULETHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsConstraintRuleThread.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsValidationRuleThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsValidationRuleThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsValidationRuleThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsValidationRuleThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsValidationRuleThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsValidationRuleThread
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsConstraintRuleThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsValidationRuleThread();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsValidationRuleThread();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsValidationRuleThreadImpl*  getCfg0AbsValidationRuleThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsValidationRuleThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsValidationRuleThreadImpl*  m_cfg0absvalidationrulethreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsValidationRuleThread - desc for Cfg0AbsValidationRuleThread parameter
     */
    Cfg0AbsValidationRuleThread( const Cfg0AbsValidationRuleThread& );
    Cfg0AbsValidationRuleThread& operator=( const Cfg0AbsValidationRuleThread& );

    friend class  Cfg0AbsValidationRuleThreadDelegate;
    friend class  Cfg0AbsValidationRuleThreadDispatch;
    friend class  Cfg0AbsValidationRuleThreadGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSVALIDATIONRULETHREAD__HXX
