//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsValueAvailability
    Filename:   Cfg0AbsValueAvailability.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSVALUEAVAILABILITY__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSVALUEAVAILABILITY__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsAvailability.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsValueAvailability;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsValueAvailabilityImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsValueAvailabilityDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsValueAvailabilityDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsValueAvailabilityGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AbsValueAvailability
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsAvailability
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AbsValueAvailability();

    /**
     * Destructor
     */
    virtual ~Cfg0AbsValueAvailability();

private:
    //  Getter method for the Implementation Object
    Cfg0AbsValueAvailabilityImpl*  getCfg0AbsValueAvailabilityImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AbsValueAvailabilityImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AbsValueAvailabilityImpl*  m_cfg0absvalueavailabilityImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AbsValueAvailability - desc for Cfg0AbsValueAvailability parameter
     */
    Cfg0AbsValueAvailability( const Cfg0AbsValueAvailability& );
    Cfg0AbsValueAvailability& operator=( const Cfg0AbsValueAvailability& );

    friend class  Cfg0AbsValueAvailabilityDelegate;
    friend class  Cfg0AbsValueAvailabilityDispatch;
    friend class  Cfg0AbsValueAvailabilityGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSVALUEAVAILABILITY__HXX
