//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AbsValueDelegate
    Filename:   Cfg0AbsValueDelegate.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSVALUEDELEGATE_HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSVALUEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsValue.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsValueDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsValueImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsValue;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AbsValueGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CFG0CONFIGURATOR_API Teamcenter_alias::Cfg0configurator::Cfg0AbsValueDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cfg0AbsValueDelegate instance
    static Cfg0AbsValueDelegate&  getInstance();

    //  Method to create the Cfg0AbsValueImpl pointer
    static Cfg0AbsValueImpl*  createImpl( Cfg0AbsValue&  ifObj );

    //  Method to delete the Cfg0AbsValueImpl pointer
    static void deleteImpl( Cfg0AbsValueImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0FamilyBase(const Cfg0AbsValue &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Cfg0AbsValue &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Cfg0AbsValueDelegate*  m_pInstance;

    Cfg0AbsValueDelegate();
    virtual ~Cfg0AbsValueDelegate();
    static void setInstance( Cfg0AbsValueDelegate*  instance );


private:
    friend class  ::Teamcenter::Cfg0configurator::Cfg0AbsValueGenImpl;

};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif  //  TEAMCENTER__CFG0CONFIGURATOR__CFG0ABSVALUEDELEGATE_HXX
