//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AllocationDelegate
    Filename:   Cfg0AllocationDelegate.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0ALLOCATIONDELEGATE_HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0ALLOCATIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0Allocation.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AllocationDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AllocationImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0Allocation;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AllocationGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CFG0CONFIGURATOR_API Teamcenter_alias::Cfg0configurator::Cfg0AllocationDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cfg0AllocationDelegate instance
    static Cfg0AllocationDelegate&  getInstance();

    //  Method to create the Cfg0AllocationImpl pointer
    static Cfg0AllocationImpl*  createImpl( Cfg0Allocation&  ifObj );

    //  Method to delete the Cfg0AllocationImpl pointer
    static void deleteImpl( Cfg0AllocationImpl*  impl );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Cfg0Allocation &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Cfg0Allocation &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Cfg0AllocationDelegate*  m_pInstance;

    Cfg0AllocationDelegate();
    virtual ~Cfg0AllocationDelegate();
    static void setInstance( Cfg0AllocationDelegate*  instance );


private:
    friend class  ::Teamcenter::Cfg0configurator::Cfg0AllocationGenImpl;

};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif  //  TEAMCENTER__CFG0CONFIGURATOR__CFG0ALLOCATIONDELEGATE_HXX
