//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AppVariantCriteriaExpr
    Filename:   Cfg0AppVariantCriteriaExpr.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0APPVARIANTCRITERIAEXPR__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0APPVARIANTCRITERIAEXPR__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0ApplicationVariantExp.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AppVariantCriteriaExpr;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AppVariantCriteriaExprImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AppVariantCriteriaExprDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AppVariantCriteriaExprDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AppVariantCriteriaExprGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AppVariantCriteriaExpr
     : public  ::Teamcenter::Cfg0configurator::Cfg0ApplicationVariantExp
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AppVariantCriteriaExpr();

    /**
     * Destructor
     */
    virtual ~Cfg0AppVariantCriteriaExpr();

private:
    //  Getter method for the Implementation Object
    Cfg0AppVariantCriteriaExprImpl*  getCfg0AppVariantCriteriaExprImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AppVariantCriteriaExprImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AppVariantCriteriaExprImpl*  m_cfg0appvariantcriteriaexprImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AppVariantCriteriaExpr - desc for Cfg0AppVariantCriteriaExpr parameter
     */
    Cfg0AppVariantCriteriaExpr( const Cfg0AppVariantCriteriaExpr& );
    Cfg0AppVariantCriteriaExpr& operator=( const Cfg0AppVariantCriteriaExpr& );

    friend class  Cfg0AppVariantCriteriaExprDelegate;
    friend class  Cfg0AppVariantCriteriaExprDispatch;
    friend class  Cfg0AppVariantCriteriaExprGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0APPVARIANTCRITERIAEXPR__HXX
