//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0ApplicationVariantExp
    Filename:   Cfg0ApplicationVariantExp.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0APPLICATIONVARIANTEXP__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0APPLICATIONVARIANTEXP__HXX

#include <common/tc_deprecation_macros.h>
#include <fnd0booleansolve/Fnd0VariantExpression.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ApplicationVariantExp;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ApplicationVariantExpImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ApplicationVariantExpDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ApplicationVariantExpDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ApplicationVariantExpGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0ApplicationVariantExp
     : public  ::Teamcenter::Fnd0VariantExpression
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0ApplicationVariantExp();

    /**
     * Destructor
     */
    virtual ~Cfg0ApplicationVariantExp();

private:
    //  Getter method for the Implementation Object
    Cfg0ApplicationVariantExpImpl*  getCfg0ApplicationVariantExpImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0ApplicationVariantExpImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0ApplicationVariantExpImpl*  m_cfg0applicationvariantexpImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0ApplicationVariantExp - desc for Cfg0ApplicationVariantExp parameter
     */
    Cfg0ApplicationVariantExp( const Cfg0ApplicationVariantExp& );
    Cfg0ApplicationVariantExp& operator=( const Cfg0ApplicationVariantExp& );

    friend class  Cfg0ApplicationVariantExpDelegate;
    friend class  Cfg0ApplicationVariantExpDispatch;
    friend class  Cfg0ApplicationVariantExpGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0APPLICATIONVARIANTEXP__HXX
