//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AvailabilityRule
    Filename:   Cfg0AvailabilityRule.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0AVAILABILITYRULE__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0AVAILABILITYRULE__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsAvailabilityRule.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AvailabilityRule;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AvailabilityRuleImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AvailabilityRuleDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AvailabilityRuleDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AvailabilityRuleGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AvailabilityRule
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsAvailabilityRule
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AvailabilityRule();

    /**
     * Destructor
     */
    virtual ~Cfg0AvailabilityRule();

private:
    //  Getter method for the Implementation Object
    Cfg0AvailabilityRuleImpl*  getCfg0AvailabilityRuleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AvailabilityRuleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AvailabilityRuleImpl*  m_cfg0availabilityruleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AvailabilityRule - desc for Cfg0AvailabilityRule parameter
     */
    Cfg0AvailabilityRule( const Cfg0AvailabilityRule& );
    Cfg0AvailabilityRule& operator=( const Cfg0AvailabilityRule& );

    friend class  Cfg0AvailabilityRuleDelegate;
    friend class  Cfg0AvailabilityRuleDispatch;
    friend class  Cfg0AvailabilityRuleGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0AVAILABILITYRULE__HXX
