//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AvailabilityThread
    Filename:   Cfg0AvailabilityThread.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0AVAILABILITYTHREAD__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0AVAILABILITYTHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsAvailabilityThread.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AvailabilityThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AvailabilityThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AvailabilityThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AvailabilityThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AvailabilityThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0AvailabilityThread
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsAvailabilityThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0AvailabilityThread();

    /**
     * Destructor
     */
    virtual ~Cfg0AvailabilityThread();

private:
    //  Getter method for the Implementation Object
    Cfg0AvailabilityThreadImpl*  getCfg0AvailabilityThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0AvailabilityThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0AvailabilityThreadImpl*  m_cfg0availabilitythreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0AvailabilityThread - desc for Cfg0AvailabilityThread parameter
     */
    Cfg0AvailabilityThread( const Cfg0AvailabilityThread& );
    Cfg0AvailabilityThread& operator=( const Cfg0AvailabilityThread& );

    friend class  Cfg0AvailabilityThreadDelegate;
    friend class  Cfg0AvailabilityThreadDispatch;
    friend class  Cfg0AvailabilityThreadGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0AVAILABILITYTHREAD__HXX
