//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0AvailabilityThreadDelegate
    Filename:   Cfg0AvailabilityThreadDelegate.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0AVAILABILITYTHREADDELEGATE_HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0AVAILABILITYTHREADDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AvailabilityThread.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AvailabilityThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AvailabilityThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AvailabilityThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0AvailabilityThreadGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CFG0CONFIGURATOR_API Teamcenter_alias::Cfg0configurator::Cfg0AvailabilityThreadDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cfg0AvailabilityThreadDelegate instance
    static Cfg0AvailabilityThreadDelegate&  getInstance();

    //  Method to create the Cfg0AvailabilityThreadImpl pointer
    static Cfg0AvailabilityThreadImpl*  createImpl( Cfg0AvailabilityThread&  ifObj );

    //  Method to delete the Cfg0AvailabilityThreadImpl pointer
    static void deleteImpl( Cfg0AvailabilityThreadImpl*  impl );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Cfg0AvailabilityThread &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Cfg0AvailabilityThread &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Cfg0AvailabilityThread &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Cfg0AvailabilityThreadDelegate*  m_pInstance;

    Cfg0AvailabilityThreadDelegate();
    virtual ~Cfg0AvailabilityThreadDelegate();
    static void setInstance( Cfg0AvailabilityThreadDelegate*  instance );


private:
    friend class  ::Teamcenter::Cfg0configurator::Cfg0AvailabilityThreadGenImpl;

};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif  //  TEAMCENTER__CFG0CONFIGURATOR__CFG0AVAILABILITYTHREADDELEGATE_HXX
