//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0CompiledRuleSet
    Filename:   Cfg0CompiledRuleSet.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0COMPILEDRULESET__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0COMPILEDRULESET__HXX

#include <common/tc_deprecation_macros.h>
#include <ae/Dataset.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0CompiledRuleSet;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0CompiledRuleSetImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0CompiledRuleSetDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0CompiledRuleSetDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0CompiledRuleSetGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0CompiledRuleSet
     : public  ::Teamcenter::Dataset
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0CompiledRuleSet();

    /**
     * Destructor
     */
    virtual ~Cfg0CompiledRuleSet();

private:
    //  Getter method for the Implementation Object
    Cfg0CompiledRuleSetImpl*  getCfg0CompiledRuleSetImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0CompiledRuleSetImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0CompiledRuleSetImpl*  m_cfg0compiledrulesetImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0CompiledRuleSet - desc for Cfg0CompiledRuleSet parameter
     */
    Cfg0CompiledRuleSet( const Cfg0CompiledRuleSet& );
    Cfg0CompiledRuleSet& operator=( const Cfg0CompiledRuleSet& );

    friend class  Cfg0CompiledRuleSetDelegate;
    friend class  Cfg0CompiledRuleSetDispatch;
    friend class  Cfg0CompiledRuleSetGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0COMPILEDRULESET__HXX
