//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0CompiledRuleSetDelegate
    Filename:   Cfg0CompiledRuleSetDelegate.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0COMPILEDRULESETDELEGATE_HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0COMPILEDRULESETDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0CompiledRuleSet.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0CompiledRuleSetDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0CompiledRuleSetImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0CompiledRuleSet;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0CompiledRuleSetGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CFG0CONFIGURATOR_API Teamcenter_alias::Cfg0configurator::Cfg0CompiledRuleSetDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cfg0CompiledRuleSetDelegate instance
    static Cfg0CompiledRuleSetDelegate&  getInstance();

    //  Method to create the Cfg0CompiledRuleSetImpl pointer
    static Cfg0CompiledRuleSetImpl*  createImpl( Cfg0CompiledRuleSet&  ifObj );

    //  Method to delete the Cfg0CompiledRuleSetImpl pointer
    static void deleteImpl( Cfg0CompiledRuleSetImpl*  impl );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Cfg0CompiledRuleSet &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Cfg0CompiledRuleSet &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// validate saveas input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  validateSaveAsInputBase(const Cfg0CompiledRuleSet &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static Cfg0CompiledRuleSetDelegate*  m_pInstance;

    Cfg0CompiledRuleSetDelegate();
    virtual ~Cfg0CompiledRuleSetDelegate();
    static void setInstance( Cfg0CompiledRuleSetDelegate*  instance );


private:
    friend class  ::Teamcenter::Cfg0configurator::Cfg0CompiledRuleSetGenImpl;

};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif  //  TEAMCENTER__CFG0CONFIGURATOR__CFG0COMPILEDRULESETDELEGATE_HXX
