//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0ConfContextDelegate
    Filename:   Cfg0ConfContextDelegate.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0CONFCONTEXTDELEGATE_HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0CONFCONTEXTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0ConfContext.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ConfContextDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ConfContextImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ConfContext;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ConfContextGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CFG0CONFIGURATOR_API Teamcenter_alias::Cfg0configurator::Cfg0ConfContextDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cfg0ConfContextDelegate instance
    static Cfg0ConfContextDelegate&  getInstance();

    //  Method to create the Cfg0ConfContextImpl pointer
    static Cfg0ConfContextImpl*  createImpl( Cfg0ConfContext&  ifObj );

    //  Method to delete the Cfg0ConfContextImpl pointer
    static void deleteImpl( Cfg0ConfContextImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0DefaultCfgPerspectiveBase(const Cfg0ConfContext &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Cfg0ConfContext &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Cfg0ConfContextDelegate*  m_pInstance;

    Cfg0ConfContextDelegate();
    virtual ~Cfg0ConfContextDelegate();
    static void setInstance( Cfg0ConfContextDelegate*  instance );


private:
    friend class  ::Teamcenter::Cfg0configurator::Cfg0ConfContextGenImpl;

};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif  //  TEAMCENTER__CFG0CONFIGURATOR__CFG0CONFCONTEXTDELEGATE_HXX
