//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0ConfigCriteriaEntry
    Filename:   Cfg0ConfigCriteriaEntry.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0CONFIGCRITERIAENTRY__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0CONFIGCRITERIAENTRY__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ConfigCriteriaEntry;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ConfigCriteriaEntryImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ConfigCriteriaEntryDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ConfigCriteriaEntryDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ConfigCriteriaEntryGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0ConfigCriteriaEntry
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0ConfigCriteriaEntry();

    /**
     * Destructor
     */
    virtual ~Cfg0ConfigCriteriaEntry();

private:
    //  Getter method for the Implementation Object
    Cfg0ConfigCriteriaEntryImpl*  getCfg0ConfigCriteriaEntryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0ConfigCriteriaEntryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0ConfigCriteriaEntryImpl*  m_cfg0configcriteriaentryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0ConfigCriteriaEntry - desc for Cfg0ConfigCriteriaEntry parameter
     */
    Cfg0ConfigCriteriaEntry( const Cfg0ConfigCriteriaEntry& );
    Cfg0ConfigCriteriaEntry& operator=( const Cfg0ConfigCriteriaEntry& );

    friend class  Cfg0ConfigCriteriaEntryDelegate;
    friend class  Cfg0ConfigCriteriaEntryDispatch;
    friend class  Cfg0ConfigCriteriaEntryGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0CONFIGCRITERIAENTRY__HXX
