//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0ConfigCriteriaKey
    Filename:   Cfg0ConfigCriteriaKey.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0CONFIGCRITERIAKEY__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0CONFIGCRITERIAKEY__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ConfigCriteriaKey;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ConfigCriteriaKeyImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ConfigCriteriaKeyDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ConfigCriteriaKeyDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ConfigCriteriaKeyGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0ConfigCriteriaKey
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0ConfigCriteriaKey();

    /**
     * Destructor
     */
    virtual ~Cfg0ConfigCriteriaKey();

private:
    //  Getter method for the Implementation Object
    Cfg0ConfigCriteriaKeyImpl*  getCfg0ConfigCriteriaKeyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0ConfigCriteriaKeyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0ConfigCriteriaKeyImpl*  m_cfg0configcriteriakeyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0ConfigCriteriaKey - desc for Cfg0ConfigCriteriaKey parameter
     */
    Cfg0ConfigCriteriaKey( const Cfg0ConfigCriteriaKey& );
    Cfg0ConfigCriteriaKey& operator=( const Cfg0ConfigCriteriaKey& );

    friend class  Cfg0ConfigCriteriaKeyDelegate;
    friend class  Cfg0ConfigCriteriaKeyDispatch;
    friend class  Cfg0ConfigCriteriaKeyGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0CONFIGCRITERIAKEY__HXX
