//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0ConfigCriteriaThread
    Filename:   Cfg0ConfigCriteriaThread.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0CONFIGCRITERIATHREAD__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0CONFIGCRITERIATHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsConfigCriteriaThread.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ConfigCriteriaThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ConfigCriteriaThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ConfigCriteriaThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ConfigCriteriaThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ConfigCriteriaThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0ConfigCriteriaThread
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsConfigCriteriaThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0ConfigCriteriaThread();

    /**
     * Destructor
     */
    virtual ~Cfg0ConfigCriteriaThread();

private:
    //  Getter method for the Implementation Object
    Cfg0ConfigCriteriaThreadImpl*  getCfg0ConfigCriteriaThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0ConfigCriteriaThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0ConfigCriteriaThreadImpl*  m_cfg0configcriteriathreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0ConfigCriteriaThread - desc for Cfg0ConfigCriteriaThread parameter
     */
    Cfg0ConfigCriteriaThread( const Cfg0ConfigCriteriaThread& );
    Cfg0ConfigCriteriaThread& operator=( const Cfg0ConfigCriteriaThread& );

    friend class  Cfg0ConfigCriteriaThreadDelegate;
    friend class  Cfg0ConfigCriteriaThreadDispatch;
    friend class  Cfg0ConfigCriteriaThreadGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0CONFIGCRITERIATHREAD__HXX
