//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0ConfigModuleThread
    Filename:   Cfg0ConfigModuleThread.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0CONFIGMODULETHREAD__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0CONFIGMODULETHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsConfigModuleThread.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ConfigModuleThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ConfigModuleThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ConfigModuleThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ConfigModuleThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ConfigModuleThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0ConfigModuleThread
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsConfigModuleThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0ConfigModuleThread();

    /**
     * Destructor
     */
    virtual ~Cfg0ConfigModuleThread();

private:
    //  Getter method for the Implementation Object
    Cfg0ConfigModuleThreadImpl*  getCfg0ConfigModuleThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0ConfigModuleThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0ConfigModuleThreadImpl*  m_cfg0configmodulethreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0ConfigModuleThread - desc for Cfg0ConfigModuleThread parameter
     */
    Cfg0ConfigModuleThread( const Cfg0ConfigModuleThread& );
    Cfg0ConfigModuleThread& operator=( const Cfg0ConfigModuleThread& );

    friend class  Cfg0ConfigModuleThreadDelegate;
    friend class  Cfg0ConfigModuleThreadDispatch;
    friend class  Cfg0ConfigModuleThreadGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0CONFIGMODULETHREAD__HXX
