//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0ConfigurationModule
    Filename:   Cfg0ConfigurationModule.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0CONFIGURATIONMODULE__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0CONFIGURATIONMODULE__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsConfigurationModule.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ConfigurationModule;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ConfigurationModuleImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ConfigurationModuleDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ConfigurationModuleDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ConfigurationModuleGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0ConfigurationModule
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsConfigurationModule
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0ConfigurationModule();

    /**
     * Destructor
     */
    virtual ~Cfg0ConfigurationModule();

private:
    //  Getter method for the Implementation Object
    Cfg0ConfigurationModuleImpl*  getCfg0ConfigurationModuleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0ConfigurationModuleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0ConfigurationModuleImpl*  m_cfg0configurationmoduleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0ConfigurationModule - desc for Cfg0ConfigurationModule parameter
     */
    Cfg0ConfigurationModule( const Cfg0ConfigurationModule& );
    Cfg0ConfigurationModule& operator=( const Cfg0ConfigurationModule& );

    friend class  Cfg0ConfigurationModuleDelegate;
    friend class  Cfg0ConfigurationModuleDispatch;
    friend class  Cfg0ConfigurationModuleGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0CONFIGURATIONMODULE__HXX
