//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0ConfigurationModuleDelegate
    Filename:   Cfg0ConfigurationModuleDelegate.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0CONFIGURATIONMODULEDELEGATE_HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0CONFIGURATIONMODULEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0ConfigurationModule.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ConfigurationModuleDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ConfigurationModuleImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ConfigurationModule;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ConfigurationModuleGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CFG0CONFIGURATOR_API Teamcenter_alias::Cfg0configurator::Cfg0ConfigurationModuleDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cfg0ConfigurationModuleDelegate instance
    static Cfg0ConfigurationModuleDelegate&  getInstance();

    //  Method to create the Cfg0ConfigurationModuleImpl pointer
    static Cfg0ConfigurationModuleImpl*  createImpl( Cfg0ConfigurationModule&  ifObj );

    //  Method to delete the Cfg0ConfigurationModuleImpl pointer
    static void deleteImpl( Cfg0ConfigurationModuleImpl*  impl );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Cfg0ConfigurationModule &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Cfg0ConfigurationModule &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Validate revise input.
    /// @version Teamcenter 10.1
    /// @param pReviseInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - Returns an int.
    ///
    int  validateReviseInputBase(const Cfg0ConfigurationModule &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static Cfg0ConfigurationModuleDelegate*  m_pInstance;

    Cfg0ConfigurationModuleDelegate();
    virtual ~Cfg0ConfigurationModuleDelegate();
    static void setInstance( Cfg0ConfigurationModuleDelegate*  instance );


private:
    friend class  ::Teamcenter::Cfg0configurator::Cfg0ConfigurationModuleGenImpl;

};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif  //  TEAMCENTER__CFG0CONFIGURATOR__CFG0CONFIGURATIONMODULEDELEGATE_HXX
