//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0ConfiguratorCriteria
    Filename:   Cfg0ConfiguratorCriteria.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0CONFIGURATORCRITERIA__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0CONFIGURATORCRITERIA__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsConfiguratorCriteria.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ConfiguratorCriteria;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ConfiguratorCriteriaImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ConfiguratorCriteriaDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ConfiguratorCriteriaDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ConfiguratorCriteriaGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0ConfiguratorCriteria
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsConfiguratorCriteria
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0ConfiguratorCriteria();

    /**
     * Destructor
     */
    virtual ~Cfg0ConfiguratorCriteria();

private:
    //  Getter method for the Implementation Object
    Cfg0ConfiguratorCriteriaImpl*  getCfg0ConfiguratorCriteriaImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0ConfiguratorCriteriaImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0ConfiguratorCriteriaImpl*  m_cfg0configuratorcriteriaImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0ConfiguratorCriteria - desc for Cfg0ConfiguratorCriteria parameter
     */
    Cfg0ConfiguratorCriteria( const Cfg0ConfiguratorCriteria& );
    Cfg0ConfiguratorCriteria& operator=( const Cfg0ConfiguratorCriteria& );

    friend class  Cfg0ConfiguratorCriteriaDelegate;
    friend class  Cfg0ConfiguratorCriteriaDispatch;
    friend class  Cfg0ConfiguratorCriteriaGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0CONFIGURATORCRITERIA__HXX
