//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0DefaultRule
    Filename:   Cfg0DefaultRule.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0DEFAULTRULE__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0DEFAULTRULE__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsDefaultRule.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0DefaultRule;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0DefaultRuleImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0DefaultRuleDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0DefaultRuleDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0DefaultRuleGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0DefaultRule
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsDefaultRule
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0DefaultRule();

    /**
     * Destructor
     */
    virtual ~Cfg0DefaultRule();

private:
    //  Getter method for the Implementation Object
    Cfg0DefaultRuleImpl*  getCfg0DefaultRuleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0DefaultRuleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0DefaultRuleImpl*  m_cfg0defaultruleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0DefaultRule - desc for Cfg0DefaultRule parameter
     */
    Cfg0DefaultRule( const Cfg0DefaultRule& );
    Cfg0DefaultRule& operator=( const Cfg0DefaultRule& );

    friend class  Cfg0DefaultRuleDelegate;
    friend class  Cfg0DefaultRuleDispatch;
    friend class  Cfg0DefaultRuleGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0DEFAULTRULE__HXX
