//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0DefaultRuleThread
    Filename:   Cfg0DefaultRuleThread.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0DEFAULTRULETHREAD__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0DEFAULTRULETHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsDefaultRuleThread.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0DefaultRuleThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0DefaultRuleThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0DefaultRuleThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0DefaultRuleThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0DefaultRuleThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0DefaultRuleThread
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsDefaultRuleThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0DefaultRuleThread();

    /**
     * Destructor
     */
    virtual ~Cfg0DefaultRuleThread();

private:
    //  Getter method for the Implementation Object
    Cfg0DefaultRuleThreadImpl*  getCfg0DefaultRuleThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0DefaultRuleThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0DefaultRuleThreadImpl*  m_cfg0defaultrulethreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0DefaultRuleThread - desc for Cfg0DefaultRuleThread parameter
     */
    Cfg0DefaultRuleThread( const Cfg0DefaultRuleThread& );
    Cfg0DefaultRuleThread& operator=( const Cfg0DefaultRuleThread& );

    friend class  Cfg0DefaultRuleThreadDelegate;
    friend class  Cfg0DefaultRuleThreadDispatch;
    friend class  Cfg0DefaultRuleThreadGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0DEFAULTRULETHREAD__HXX
