//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0Dictionary
    Filename:   Cfg0Dictionary.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0DICTIONARY__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0DICTIONARY__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0ConfContext.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0Dictionary;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0DictionaryImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0DictionaryDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0DictionaryDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0DictionaryGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0Dictionary
     : public  ::Teamcenter::Cfg0configurator::Cfg0ConfContext
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0Dictionary();

    /**
     * Destructor
     */
    virtual ~Cfg0Dictionary();

private:
    //  Getter method for the Implementation Object
    Cfg0DictionaryImpl*  getCfg0DictionaryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0DictionaryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0DictionaryImpl*  m_cfg0dictionaryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0Dictionary - desc for Cfg0Dictionary parameter
     */
    Cfg0Dictionary( const Cfg0Dictionary& );
    Cfg0Dictionary& operator=( const Cfg0Dictionary& );

    friend class  Cfg0DictionaryDelegate;
    friend class  Cfg0DictionaryDispatch;
    friend class  Cfg0DictionaryGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0DICTIONARY__HXX
