//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0EffIntentThread
    Filename:   Cfg0EffIntentThread.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0EFFINTENTTHREAD__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0EFFINTENTTHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsEffIntentThread.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0EffIntentThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0EffIntentThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0EffIntentThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0EffIntentThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0EffIntentThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0EffIntentThread
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsEffIntentThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0EffIntentThread();

    /**
     * Destructor
     */
    virtual ~Cfg0EffIntentThread();

private:
    //  Getter method for the Implementation Object
    Cfg0EffIntentThreadImpl*  getCfg0EffIntentThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0EffIntentThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0EffIntentThreadImpl*  m_cfg0effintentthreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0EffIntentThread - desc for Cfg0EffIntentThread parameter
     */
    Cfg0EffIntentThread( const Cfg0EffIntentThread& );
    Cfg0EffIntentThread& operator=( const Cfg0EffIntentThread& );

    friend class  Cfg0EffIntentThreadDelegate;
    friend class  Cfg0EffIntentThreadDispatch;
    friend class  Cfg0EffIntentThreadGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0EFFINTENTTHREAD__HXX
