//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0EffectivityExprBlock
    Filename:   Cfg0EffectivityExprBlock.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0EFFECTIVITYEXPRBLOCK__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0EFFECTIVITYEXPRBLOCK__HXX

#include <common/tc_deprecation_macros.h>
#include <fnd0booleansolve/Fnd0EffectivityExprBlock.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0EffectivityExprBlock;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0EffectivityExprBlockImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0EffectivityExprBlockDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0EffectivityExprBlockDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0EffectivityExprBlockGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0EffectivityExprBlock
     : public  ::Teamcenter::Fnd0EffectivityExprBlock
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0EffectivityExprBlock();

    /**
     * Destructor
     */
    virtual ~Cfg0EffectivityExprBlock();

private:
    //  Getter method for the Implementation Object
    Cfg0EffectivityExprBlockImpl*  getCfg0EffectivityExprBlockImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0EffectivityExprBlockImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0EffectivityExprBlockImpl*  m_cfg0effectivityexprblockImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0EffectivityExprBlock - desc for Cfg0EffectivityExprBlock parameter
     */
    Cfg0EffectivityExprBlock( const Cfg0EffectivityExprBlock& );
    Cfg0EffectivityExprBlock& operator=( const Cfg0EffectivityExprBlock& );

    friend class  Cfg0EffectivityExprBlockDelegate;
    friend class  Cfg0EffectivityExprBlockDispatch;
    friend class  Cfg0EffectivityExprBlockGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0EFFECTIVITYEXPRBLOCK__HXX
