//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0EffectivityFamily
    Filename:   Cfg0EffectivityFamily.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0EFFECTIVITYFAMILY__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0EFFECTIVITYFAMILY__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsEffectivityFamily.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0EffectivityFamily;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0EffectivityFamilyImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0EffectivityFamilyDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0EffectivityFamilyDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0EffectivityFamilyGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0EffectivityFamily
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsEffectivityFamily
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0EffectivityFamily();

    /**
     * Destructor
     */
    virtual ~Cfg0EffectivityFamily();

private:
    //  Getter method for the Implementation Object
    Cfg0EffectivityFamilyImpl*  getCfg0EffectivityFamilyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0EffectivityFamilyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0EffectivityFamilyImpl*  m_cfg0effectivityfamilyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0EffectivityFamily - desc for Cfg0EffectivityFamily parameter
     */
    Cfg0EffectivityFamily( const Cfg0EffectivityFamily& );
    Cfg0EffectivityFamily& operator=( const Cfg0EffectivityFamily& );

    friend class  Cfg0EffectivityFamilyDelegate;
    friend class  Cfg0EffectivityFamilyDispatch;
    friend class  Cfg0EffectivityFamilyGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0EFFECTIVITYFAMILY__HXX
