//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0EffectivityIntent
    Filename:   Cfg0EffectivityIntent.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0EFFECTIVITYINTENT__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0EFFECTIVITYINTENT__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsEffectivityIntent.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0EffectivityIntent;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0EffectivityIntentImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0EffectivityIntentDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0EffectivityIntentDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0EffectivityIntentGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0EffectivityIntent
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsEffectivityIntent
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0EffectivityIntent();

    /**
     * Destructor
     */
    virtual ~Cfg0EffectivityIntent();

private:
    //  Getter method for the Implementation Object
    Cfg0EffectivityIntentImpl*  getCfg0EffectivityIntentImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0EffectivityIntentImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0EffectivityIntentImpl*  m_cfg0effectivityintentImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0EffectivityIntent - desc for Cfg0EffectivityIntent parameter
     */
    Cfg0EffectivityIntent( const Cfg0EffectivityIntent& );
    Cfg0EffectivityIntent& operator=( const Cfg0EffectivityIntent& );

    friend class  Cfg0EffectivityIntentDelegate;
    friend class  Cfg0EffectivityIntentDispatch;
    friend class  Cfg0EffectivityIntentGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0EFFECTIVITYINTENT__HXX
