//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0ExceptionRule
    Filename:   Cfg0ExceptionRule.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0EXCEPTIONRULE__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0EXCEPTIONRULE__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsExceptionRule.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ExceptionRule;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ExceptionRuleImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ExceptionRuleDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ExceptionRuleDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ExceptionRuleGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0ExceptionRule
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsExceptionRule
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0ExceptionRule();

    /**
     * Destructor
     */
    virtual ~Cfg0ExceptionRule();

private:
    //  Getter method for the Implementation Object
    Cfg0ExceptionRuleImpl*  getCfg0ExceptionRuleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0ExceptionRuleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0ExceptionRuleImpl*  m_cfg0exceptionruleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0ExceptionRule - desc for Cfg0ExceptionRule parameter
     */
    Cfg0ExceptionRule( const Cfg0ExceptionRule& );
    Cfg0ExceptionRule& operator=( const Cfg0ExceptionRule& );

    friend class  Cfg0ExceptionRuleDelegate;
    friend class  Cfg0ExceptionRuleDispatch;
    friend class  Cfg0ExceptionRuleGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0EXCEPTIONRULE__HXX
