//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0ExcludeRule
    Filename:   Cfg0ExcludeRule.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0EXCLUDERULE__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0EXCLUDERULE__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsExcludeRule.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ExcludeRule;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ExcludeRuleImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ExcludeRuleDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ExcludeRuleDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ExcludeRuleGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0ExcludeRule
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsExcludeRule
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0ExcludeRule();

    /**
     * Destructor
     */
    virtual ~Cfg0ExcludeRule();

private:
    //  Getter method for the Implementation Object
    Cfg0ExcludeRuleImpl*  getCfg0ExcludeRuleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0ExcludeRuleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0ExcludeRuleImpl*  m_cfg0excluderuleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0ExcludeRule - desc for Cfg0ExcludeRule parameter
     */
    Cfg0ExcludeRule( const Cfg0ExcludeRule& );
    Cfg0ExcludeRule& operator=( const Cfg0ExcludeRule& );

    friend class  Cfg0ExcludeRuleDelegate;
    friend class  Cfg0ExcludeRuleDispatch;
    friend class  Cfg0ExcludeRuleGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0EXCLUDERULE__HXX
