//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0ExcludeRuleThread
    Filename:   Cfg0ExcludeRuleThread.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0EXCLUDERULETHREAD__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0EXCLUDERULETHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsExcludeRuleThread.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ExcludeRuleThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ExcludeRuleThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ExcludeRuleThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ExcludeRuleThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ExcludeRuleThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0ExcludeRuleThread
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsExcludeRuleThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0ExcludeRuleThread();

    /**
     * Destructor
     */
    virtual ~Cfg0ExcludeRuleThread();

private:
    //  Getter method for the Implementation Object
    Cfg0ExcludeRuleThreadImpl*  getCfg0ExcludeRuleThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0ExcludeRuleThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0ExcludeRuleThreadImpl*  m_cfg0excluderulethreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0ExcludeRuleThread - desc for Cfg0ExcludeRuleThread parameter
     */
    Cfg0ExcludeRuleThread( const Cfg0ExcludeRuleThread& );
    Cfg0ExcludeRuleThread& operator=( const Cfg0ExcludeRuleThread& );

    friend class  Cfg0ExcludeRuleThreadDelegate;
    friend class  Cfg0ExcludeRuleThreadDispatch;
    friend class  Cfg0ExcludeRuleThreadGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0EXCLUDERULETHREAD__HXX
