//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0ExternalOperation
    Filename:   Cfg0ExternalOperation.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0EXTERNALOPERATION__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0EXTERNALOPERATION__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsExternalOperation.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ExternalOperation;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ExternalOperationImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ExternalOperationDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ExternalOperationDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ExternalOperationGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0ExternalOperation
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsExternalOperation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0ExternalOperation();

    /**
     * Destructor
     */
    virtual ~Cfg0ExternalOperation();

private:
    //  Getter method for the Implementation Object
    Cfg0ExternalOperationImpl*  getCfg0ExternalOperationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0ExternalOperationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0ExternalOperationImpl*  m_cfg0externaloperationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0ExternalOperation - desc for Cfg0ExternalOperation parameter
     */
    Cfg0ExternalOperation( const Cfg0ExternalOperation& );
    Cfg0ExternalOperation& operator=( const Cfg0ExternalOperation& );

    friend class  Cfg0ExternalOperationDelegate;
    friend class  Cfg0ExternalOperationDispatch;
    friend class  Cfg0ExternalOperationGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0EXTERNALOPERATION__HXX
