//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0ExternalOperationBlock
    Filename:   Cfg0ExternalOperationBlock.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0EXTERNALOPERATIONBLOCK__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0EXTERNALOPERATIONBLOCK__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsExternalOperBlock.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ExternalOperationBlock;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ExternalOperationBlockImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ExternalOperationBlockDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ExternalOperationBlockDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ExternalOperationBlockGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0ExternalOperationBlock
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsExternalOperBlock
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0ExternalOperationBlock();

    /**
     * Destructor
     */
    virtual ~Cfg0ExternalOperationBlock();

private:
    //  Getter method for the Implementation Object
    Cfg0ExternalOperationBlockImpl*  getCfg0ExternalOperationBlockImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0ExternalOperationBlockImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0ExternalOperationBlockImpl*  m_cfg0externaloperationblockImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0ExternalOperationBlock - desc for Cfg0ExternalOperationBlock parameter
     */
    Cfg0ExternalOperationBlock( const Cfg0ExternalOperationBlock& );
    Cfg0ExternalOperationBlock& operator=( const Cfg0ExternalOperationBlock& );

    friend class  Cfg0ExternalOperationBlockDelegate;
    friend class  Cfg0ExternalOperationBlockDispatch;
    friend class  Cfg0ExternalOperationBlockGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0EXTERNALOPERATIONBLOCK__HXX
