//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0FamilyAvailability
    Filename:   Cfg0FamilyAvailability.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0FAMILYAVAILABILITY__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0FAMILYAVAILABILITY__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsFamilyAvailability.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0FamilyAvailability;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0FamilyAvailabilityImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0FamilyAvailabilityDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0FamilyAvailabilityDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0FamilyAvailabilityGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0FamilyAvailability
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsFamilyAvailability
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0FamilyAvailability();

    /**
     * Destructor
     */
    virtual ~Cfg0FamilyAvailability();

private:
    //  Getter method for the Implementation Object
    Cfg0FamilyAvailabilityImpl*  getCfg0FamilyAvailabilityImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0FamilyAvailabilityImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0FamilyAvailabilityImpl*  m_cfg0familyavailabilityImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0FamilyAvailability - desc for Cfg0FamilyAvailability parameter
     */
    Cfg0FamilyAvailability( const Cfg0FamilyAvailability& );
    Cfg0FamilyAvailability& operator=( const Cfg0FamilyAvailability& );

    friend class  Cfg0FamilyAvailabilityDelegate;
    friend class  Cfg0FamilyAvailabilityDispatch;
    friend class  Cfg0FamilyAvailabilityGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0FAMILYAVAILABILITY__HXX
