//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0FamilyGroup
    Filename:   Cfg0FamilyGroup.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0FAMILYGROUP__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0FAMILYGROUP__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsFamilyGroup.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0FamilyGroup;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0FamilyGroupImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0FamilyGroupDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0FamilyGroupDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0FamilyGroupGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0FamilyGroup
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsFamilyGroup
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0FamilyGroup();

    /**
     * Destructor
     */
    virtual ~Cfg0FamilyGroup();

private:
    //  Getter method for the Implementation Object
    Cfg0FamilyGroupImpl*  getCfg0FamilyGroupImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0FamilyGroupImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0FamilyGroupImpl*  m_cfg0familygroupImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0FamilyGroup - desc for Cfg0FamilyGroup parameter
     */
    Cfg0FamilyGroup( const Cfg0FamilyGroup& );
    Cfg0FamilyGroup& operator=( const Cfg0FamilyGroup& );

    friend class  Cfg0FamilyGroupDelegate;
    friend class  Cfg0FamilyGroupDispatch;
    friend class  Cfg0FamilyGroupGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0FAMILYGROUP__HXX
