//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0FamilyGroupDelegate
    Filename:   Cfg0FamilyGroupDelegate.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0FAMILYGROUPDELEGATE_HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0FAMILYGROUPDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0FamilyGroup.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0FamilyGroupDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0FamilyGroupImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0FamilyGroup;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0FamilyGroupGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CFG0CONFIGURATOR_API Teamcenter_alias::Cfg0configurator::Cfg0FamilyGroupDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cfg0FamilyGroupDelegate instance
    static Cfg0FamilyGroupDelegate&  getInstance();

    //  Method to create the Cfg0FamilyGroupImpl pointer
    static Cfg0FamilyGroupImpl*  createImpl( Cfg0FamilyGroup&  ifObj );

    //  Method to delete the Cfg0FamilyGroupImpl pointer
    static void deleteImpl( Cfg0FamilyGroupImpl*  impl );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Cfg0FamilyGroup &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Generic saveAsPost operation.
    /// @version Teamcenter 8.1
    /// @param pSavAsInput - Input argument as SaveAsInput object.
    /// @param vecDeepCopyData - vector deepcopy data
    /// @return - Return integer value.
    ///
    int  saveAsPostBase(const Cfg0FamilyGroup &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static Cfg0FamilyGroupDelegate*  m_pInstance;

    Cfg0FamilyGroupDelegate();
    virtual ~Cfg0FamilyGroupDelegate();
    static void setInstance( Cfg0FamilyGroupDelegate*  instance );


private:
    friend class  ::Teamcenter::Cfg0configurator::Cfg0FamilyGroupGenImpl;

};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif  //  TEAMCENTER__CFG0CONFIGURATOR__CFG0FAMILYGROUPDELEGATE_HXX
