//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0FamilyGroupThread
    Filename:   Cfg0FamilyGroupThread.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0FAMILYGROUPTHREAD__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0FAMILYGROUPTHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsFamilyGroupThread.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0FamilyGroupThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0FamilyGroupThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0FamilyGroupThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0FamilyGroupThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0FamilyGroupThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0FamilyGroupThread
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsFamilyGroupThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0FamilyGroupThread();

    /**
     * Destructor
     */
    virtual ~Cfg0FamilyGroupThread();

private:
    //  Getter method for the Implementation Object
    Cfg0FamilyGroupThreadImpl*  getCfg0FamilyGroupThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0FamilyGroupThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0FamilyGroupThreadImpl*  m_cfg0familygroupthreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0FamilyGroupThread - desc for Cfg0FamilyGroupThread parameter
     */
    Cfg0FamilyGroupThread( const Cfg0FamilyGroupThread& );
    Cfg0FamilyGroupThread& operator=( const Cfg0FamilyGroupThread& );

    friend class  Cfg0FamilyGroupThreadDelegate;
    friend class  Cfg0FamilyGroupThreadDispatch;
    friend class  Cfg0FamilyGroupThreadGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0FAMILYGROUPTHREAD__HXX
