//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0FeasibilityRule
    Filename:   Cfg0FeasibilityRule.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0FEASIBILITYRULE__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0FEASIBILITYRULE__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsFeasibilityRule.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0FeasibilityRule;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0FeasibilityRuleImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0FeasibilityRuleDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0FeasibilityRuleDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0FeasibilityRuleGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0FeasibilityRule
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsFeasibilityRule
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0FeasibilityRule();

    /**
     * Destructor
     */
    virtual ~Cfg0FeasibilityRule();

private:
    //  Getter method for the Implementation Object
    Cfg0FeasibilityRuleImpl*  getCfg0FeasibilityRuleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0FeasibilityRuleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0FeasibilityRuleImpl*  m_cfg0feasibilityruleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0FeasibilityRule - desc for Cfg0FeasibilityRule parameter
     */
    Cfg0FeasibilityRule( const Cfg0FeasibilityRule& );
    Cfg0FeasibilityRule& operator=( const Cfg0FeasibilityRule& );

    friend class  Cfg0FeasibilityRuleDelegate;
    friend class  Cfg0FeasibilityRuleDispatch;
    friend class  Cfg0FeasibilityRuleGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0FEASIBILITYRULE__HXX
