//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0FeatureFamilyThread
    Filename:   Cfg0FeatureFamilyThread.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0FEATUREFAMILYTHREAD__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0FEATUREFAMILYTHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsFeatureFamilyThread.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0FeatureFamilyThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0FeatureFamilyThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0FeatureFamilyThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0FeatureFamilyThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0FeatureFamilyThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0FeatureFamilyThread
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsFeatureFamilyThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0FeatureFamilyThread();

    /**
     * Destructor
     */
    virtual ~Cfg0FeatureFamilyThread();

private:
    //  Getter method for the Implementation Object
    Cfg0FeatureFamilyThreadImpl*  getCfg0FeatureFamilyThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0FeatureFamilyThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0FeatureFamilyThreadImpl*  m_cfg0featurefamilythreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0FeatureFamilyThread - desc for Cfg0FeatureFamilyThread parameter
     */
    Cfg0FeatureFamilyThread( const Cfg0FeatureFamilyThread& );
    Cfg0FeatureFamilyThread& operator=( const Cfg0FeatureFamilyThread& );

    friend class  Cfg0FeatureFamilyThreadDelegate;
    friend class  Cfg0FeatureFamilyThreadDispatch;
    friend class  Cfg0FeatureFamilyThreadGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0FEATUREFAMILYTHREAD__HXX
