//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0FeatureSet
    Filename:   Cfg0FeatureSet.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0FEATURESET__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0FEATURESET__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsFeatureSet.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0FeatureSet;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0FeatureSetImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0FeatureSetDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0FeatureSetDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0FeatureSetGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0FeatureSet
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsFeatureSet
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0FeatureSet();

    /**
     * Destructor
     */
    virtual ~Cfg0FeatureSet();

private:
    //  Getter method for the Implementation Object
    Cfg0FeatureSetImpl*  getCfg0FeatureSetImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0FeatureSetImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0FeatureSetImpl*  m_cfg0featuresetImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0FeatureSet - desc for Cfg0FeatureSet parameter
     */
    Cfg0FeatureSet( const Cfg0FeatureSet& );
    Cfg0FeatureSet& operator=( const Cfg0FeatureSet& );

    friend class  Cfg0FeatureSetDelegate;
    friend class  Cfg0FeatureSetDispatch;
    friend class  Cfg0FeatureSetGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0FEATURESET__HXX
