//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0FeatureSetThread
    Filename:   Cfg0FeatureSetThread.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0FEATURESETTHREAD__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0FEATURESETTHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsFeatureSetThread.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0FeatureSetThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0FeatureSetThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0FeatureSetThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0FeatureSetThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0FeatureSetThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0FeatureSetThread
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsFeatureSetThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0FeatureSetThread();

    /**
     * Destructor
     */
    virtual ~Cfg0FeatureSetThread();

private:
    //  Getter method for the Implementation Object
    Cfg0FeatureSetThreadImpl*  getCfg0FeatureSetThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0FeatureSetThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0FeatureSetThreadImpl*  m_cfg0featuresetthreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0FeatureSetThread - desc for Cfg0FeatureSetThread parameter
     */
    Cfg0FeatureSetThread( const Cfg0FeatureSetThread& );
    Cfg0FeatureSetThread& operator=( const Cfg0FeatureSetThread& );

    friend class  Cfg0FeatureSetThreadDelegate;
    friend class  Cfg0FeatureSetThreadDispatch;
    friend class  Cfg0FeatureSetThreadGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0FEATURESETTHREAD__HXX
