//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0IncludeRule
    Filename:   Cfg0IncludeRule.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0INCLUDERULE__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0INCLUDERULE__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsIncludeRule.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0IncludeRule;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0IncludeRuleImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0IncludeRuleDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0IncludeRuleDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0IncludeRuleGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0IncludeRule
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsIncludeRule
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0IncludeRule();

    /**
     * Destructor
     */
    virtual ~Cfg0IncludeRule();

private:
    //  Getter method for the Implementation Object
    Cfg0IncludeRuleImpl*  getCfg0IncludeRuleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0IncludeRuleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0IncludeRuleImpl*  m_cfg0includeruleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0IncludeRule - desc for Cfg0IncludeRule parameter
     */
    Cfg0IncludeRule( const Cfg0IncludeRule& );
    Cfg0IncludeRule& operator=( const Cfg0IncludeRule& );

    friend class  Cfg0IncludeRuleDelegate;
    friend class  Cfg0IncludeRuleDispatch;
    friend class  Cfg0IncludeRuleGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0INCLUDERULE__HXX
