//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0IncludeRuleThread
    Filename:   Cfg0IncludeRuleThread.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0INCLUDERULETHREAD__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0INCLUDERULETHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsIncludeRuleThread.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0IncludeRuleThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0IncludeRuleThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0IncludeRuleThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0IncludeRuleThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0IncludeRuleThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0IncludeRuleThread
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsIncludeRuleThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0IncludeRuleThread();

    /**
     * Destructor
     */
    virtual ~Cfg0IncludeRuleThread();

private:
    //  Getter method for the Implementation Object
    Cfg0IncludeRuleThreadImpl*  getCfg0IncludeRuleThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0IncludeRuleThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0IncludeRuleThreadImpl*  m_cfg0includerulethreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0IncludeRuleThread - desc for Cfg0IncludeRuleThread parameter
     */
    Cfg0IncludeRuleThread( const Cfg0IncludeRuleThread& );
    Cfg0IncludeRuleThread& operator=( const Cfg0IncludeRuleThread& );

    friend class  Cfg0IncludeRuleThreadDelegate;
    friend class  Cfg0IncludeRuleThreadDispatch;
    friend class  Cfg0IncludeRuleThreadGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0INCLUDERULETHREAD__HXX
