//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0LiteralOptionValue
    Filename:   Cfg0LiteralOptionValue.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0LITERALOPTIONVALUE__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0LITERALOPTIONVALUE__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsLiteralOptionValue.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0LiteralOptionValue;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0LiteralOptionValueImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0LiteralOptionValueDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0LiteralOptionValueDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0LiteralOptionValueGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0LiteralOptionValue
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsLiteralOptionValue
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0LiteralOptionValue();

    /**
     * Destructor
     */
    virtual ~Cfg0LiteralOptionValue();

private:
    //  Getter method for the Implementation Object
    Cfg0LiteralOptionValueImpl*  getCfg0LiteralOptionValueImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0LiteralOptionValueImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0LiteralOptionValueImpl*  m_cfg0literaloptionvalueImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0LiteralOptionValue - desc for Cfg0LiteralOptionValue parameter
     */
    Cfg0LiteralOptionValue( const Cfg0LiteralOptionValue& );
    Cfg0LiteralOptionValue& operator=( const Cfg0LiteralOptionValue& );

    friend class  Cfg0LiteralOptionValueDelegate;
    friend class  Cfg0LiteralOptionValueDispatch;
    friend class  Cfg0LiteralOptionValueGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0LITERALOPTIONVALUE__HXX
