//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0LiteralValueThread
    Filename:   Cfg0LiteralValueThread.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0LITERALVALUETHREAD__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0LITERALVALUETHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsLiteralValueThread.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0LiteralValueThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0LiteralValueThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0LiteralValueThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0LiteralValueThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0LiteralValueThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0LiteralValueThread
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsLiteralValueThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0LiteralValueThread();

    /**
     * Destructor
     */
    virtual ~Cfg0LiteralValueThread();

private:
    //  Getter method for the Implementation Object
    Cfg0LiteralValueThreadImpl*  getCfg0LiteralValueThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0LiteralValueThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0LiteralValueThreadImpl*  m_cfg0literalvaluethreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0LiteralValueThread - desc for Cfg0LiteralValueThread parameter
     */
    Cfg0LiteralValueThread( const Cfg0LiteralValueThread& );
    Cfg0LiteralValueThread& operator=( const Cfg0LiteralValueThread& );

    friend class  Cfg0LiteralValueThreadDelegate;
    friend class  Cfg0LiteralValueThreadDispatch;
    friend class  Cfg0LiteralValueThreadGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0LITERALVALUETHREAD__HXX
