//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0OptionValueAvailability
    Filename:   Cfg0OptionValueAvailability.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0OPTIONVALUEAVAILABILITY__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0OPTIONVALUEAVAILABILITY__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsValueAvailability.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0OptionValueAvailability;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0OptionValueAvailabilityImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0OptionValueAvailabilityDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0OptionValueAvailabilityDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0OptionValueAvailabilityGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0OptionValueAvailability
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsValueAvailability
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0OptionValueAvailability();

    /**
     * Destructor
     */
    virtual ~Cfg0OptionValueAvailability();

private:
    //  Getter method for the Implementation Object
    Cfg0OptionValueAvailabilityImpl*  getCfg0OptionValueAvailabilityImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0OptionValueAvailabilityImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0OptionValueAvailabilityImpl*  m_cfg0optionvalueavailabilityImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0OptionValueAvailability - desc for Cfg0OptionValueAvailability parameter
     */
    Cfg0OptionValueAvailability( const Cfg0OptionValueAvailability& );
    Cfg0OptionValueAvailability& operator=( const Cfg0OptionValueAvailability& );

    friend class  Cfg0OptionValueAvailabilityDelegate;
    friend class  Cfg0OptionValueAvailabilityDispatch;
    friend class  Cfg0OptionValueAvailabilityGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0OPTIONVALUEAVAILABILITY__HXX
