//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0PackageFamilyThread
    Filename:   Cfg0PackageFamilyThread.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0PACKAGEFAMILYTHREAD__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0PACKAGEFAMILYTHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsPackageFamilyThread.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0PackageFamilyThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0PackageFamilyThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0PackageFamilyThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0PackageFamilyThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0PackageFamilyThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0PackageFamilyThread
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsPackageFamilyThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0PackageFamilyThread();

    /**
     * Destructor
     */
    virtual ~Cfg0PackageFamilyThread();

private:
    //  Getter method for the Implementation Object
    Cfg0PackageFamilyThreadImpl*  getCfg0PackageFamilyThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0PackageFamilyThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0PackageFamilyThreadImpl*  m_cfg0packagefamilythreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0PackageFamilyThread - desc for Cfg0PackageFamilyThread parameter
     */
    Cfg0PackageFamilyThread( const Cfg0PackageFamilyThread& );
    Cfg0PackageFamilyThread& operator=( const Cfg0PackageFamilyThread& );

    friend class  Cfg0PackageFamilyThreadDelegate;
    friend class  Cfg0PackageFamilyThreadDispatch;
    friend class  Cfg0PackageFamilyThreadGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0PACKAGEFAMILYTHREAD__HXX
