//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0PackageOptionFamily
    Filename:   Cfg0PackageOptionFamily.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0PACKAGEOPTIONFAMILY__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0PACKAGEOPTIONFAMILY__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsPackageOptionFamily.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0PackageOptionFamily;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0PackageOptionFamilyImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0PackageOptionFamilyDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0PackageOptionFamilyDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0PackageOptionFamilyGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0PackageOptionFamily
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsPackageOptionFamily
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0PackageOptionFamily();

    /**
     * Destructor
     */
    virtual ~Cfg0PackageOptionFamily();

private:
    //  Getter method for the Implementation Object
    Cfg0PackageOptionFamilyImpl*  getCfg0PackageOptionFamilyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0PackageOptionFamilyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0PackageOptionFamilyImpl*  m_cfg0packageoptionfamilyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0PackageOptionFamily - desc for Cfg0PackageOptionFamily parameter
     */
    Cfg0PackageOptionFamily( const Cfg0PackageOptionFamily& );
    Cfg0PackageOptionFamily& operator=( const Cfg0PackageOptionFamily& );

    friend class  Cfg0PackageOptionFamilyDelegate;
    friend class  Cfg0PackageOptionFamilyDispatch;
    friend class  Cfg0PackageOptionFamilyGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0PACKAGEOPTIONFAMILY__HXX
