//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0PackageRule
    Filename:   Cfg0PackageRule.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0PACKAGERULE__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0PACKAGERULE__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsPackageRule.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0PackageRule;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0PackageRuleImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0PackageRuleDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0PackageRuleDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0PackageRuleGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0PackageRule
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsPackageRule
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0PackageRule();

    /**
     * Destructor
     */
    virtual ~Cfg0PackageRule();

private:
    //  Getter method for the Implementation Object
    Cfg0PackageRuleImpl*  getCfg0PackageRuleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0PackageRuleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0PackageRuleImpl*  m_cfg0packageruleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0PackageRule - desc for Cfg0PackageRule parameter
     */
    Cfg0PackageRule( const Cfg0PackageRule& );
    Cfg0PackageRule& operator=( const Cfg0PackageRule& );

    friend class  Cfg0PackageRuleDelegate;
    friend class  Cfg0PackageRuleDispatch;
    friend class  Cfg0PackageRuleGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0PACKAGERULE__HXX
