//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0PackageValueThread
    Filename:   Cfg0PackageValueThread.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0PACKAGEVALUETHREAD__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0PACKAGEVALUETHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsPackageValueThread.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0PackageValueThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0PackageValueThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0PackageValueThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0PackageValueThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0PackageValueThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0PackageValueThread
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsPackageValueThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0PackageValueThread();

    /**
     * Destructor
     */
    virtual ~Cfg0PackageValueThread();

private:
    //  Getter method for the Implementation Object
    Cfg0PackageValueThreadImpl*  getCfg0PackageValueThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0PackageValueThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0PackageValueThreadImpl*  m_cfg0packagevaluethreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0PackageValueThread - desc for Cfg0PackageValueThread parameter
     */
    Cfg0PackageValueThread( const Cfg0PackageValueThread& );
    Cfg0PackageValueThread& operator=( const Cfg0PackageValueThread& );

    friend class  Cfg0PackageValueThreadDelegate;
    friend class  Cfg0PackageValueThreadDispatch;
    friend class  Cfg0PackageValueThreadGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0PACKAGEVALUETHREAD__HXX
