//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0ProdModelFamilyThread
    Filename:   Cfg0ProdModelFamilyThread.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0PRODMODELFAMILYTHREAD__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0PRODMODELFAMILYTHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsProdModelFamilyThrd.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ProdModelFamilyThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ProdModelFamilyThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ProdModelFamilyThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ProdModelFamilyThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ProdModelFamilyThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0ProdModelFamilyThread
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsProdModelFamilyThrd
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0ProdModelFamilyThread();

    /**
     * Destructor
     */
    virtual ~Cfg0ProdModelFamilyThread();

private:
    //  Getter method for the Implementation Object
    Cfg0ProdModelFamilyThreadImpl*  getCfg0ProdModelFamilyThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0ProdModelFamilyThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0ProdModelFamilyThreadImpl*  m_cfg0prodmodelfamilythreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0ProdModelFamilyThread - desc for Cfg0ProdModelFamilyThread parameter
     */
    Cfg0ProdModelFamilyThread( const Cfg0ProdModelFamilyThread& );
    Cfg0ProdModelFamilyThread& operator=( const Cfg0ProdModelFamilyThread& );

    friend class  Cfg0ProdModelFamilyThreadDelegate;
    friend class  Cfg0ProdModelFamilyThreadDispatch;
    friend class  Cfg0ProdModelFamilyThreadGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0PRODMODELFAMILYTHREAD__HXX
