//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0ProductItem
    Filename:   Cfg0ProductItem.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0PRODUCTITEM__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0PRODUCTITEM__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0ConfContext.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ProductItem;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ProductItemImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ProductItemDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ProductItemDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ProductItemGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0ProductItem
     : public  ::Teamcenter::Cfg0configurator::Cfg0ConfContext
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0ProductItem();

    /**
     * Destructor
     */
    virtual ~Cfg0ProductItem();

private:
    //  Getter method for the Implementation Object
    Cfg0ProductItemImpl*  getCfg0ProductItemImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0ProductItemImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0ProductItemImpl*  m_cfg0productitemImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0ProductItem - desc for Cfg0ProductItem parameter
     */
    Cfg0ProductItem( const Cfg0ProductItem& );
    Cfg0ProductItem& operator=( const Cfg0ProductItem& );

    friend class  Cfg0ProductItemDelegate;
    friend class  Cfg0ProductItemDispatch;
    friend class  Cfg0ProductItemGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0PRODUCTITEM__HXX
