//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0ProductLineThread
    Filename:   Cfg0ProductLineThread.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0PRODUCTLINETHREAD__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0PRODUCTLINETHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsProductLineThread.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ProductLineThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ProductLineThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ProductLineThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ProductLineThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ProductLineThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0ProductLineThread
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsProductLineThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0ProductLineThread();

    /**
     * Destructor
     */
    virtual ~Cfg0ProductLineThread();

private:
    //  Getter method for the Implementation Object
    Cfg0ProductLineThreadImpl*  getCfg0ProductLineThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0ProductLineThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0ProductLineThreadImpl*  m_cfg0productlinethreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0ProductLineThread - desc for Cfg0ProductLineThread parameter
     */
    Cfg0ProductLineThread( const Cfg0ProductLineThread& );
    Cfg0ProductLineThread& operator=( const Cfg0ProductLineThread& );

    friend class  Cfg0ProductLineThreadDelegate;
    friend class  Cfg0ProductLineThreadDispatch;
    friend class  Cfg0ProductLineThreadGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0PRODUCTLINETHREAD__HXX
