//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0ProductModel
    Filename:   Cfg0ProductModel.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0PRODUCTMODEL__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0PRODUCTMODEL__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsProductModel.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ProductModel;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ProductModelImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ProductModelDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ProductModelDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ProductModelGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0ProductModel
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsProductModel
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0ProductModel();

    /**
     * Destructor
     */
    virtual ~Cfg0ProductModel();

private:
    //  Getter method for the Implementation Object
    Cfg0ProductModelImpl*  getCfg0ProductModelImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0ProductModelImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0ProductModelImpl*  m_cfg0productmodelImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0ProductModel - desc for Cfg0ProductModel parameter
     */
    Cfg0ProductModel( const Cfg0ProductModel& );
    Cfg0ProductModel& operator=( const Cfg0ProductModel& );

    friend class  Cfg0ProductModelDelegate;
    friend class  Cfg0ProductModelDispatch;
    friend class  Cfg0ProductModelGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0PRODUCTMODEL__HXX
