//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0ProductModelThread
    Filename:   Cfg0ProductModelThread.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0PRODUCTMODELTHREAD__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0PRODUCTMODELTHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsProductModelThread.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ProductModelThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ProductModelThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ProductModelThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ProductModelThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0ProductModelThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0ProductModelThread
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsProductModelThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0ProductModelThread();

    /**
     * Destructor
     */
    virtual ~Cfg0ProductModelThread();

private:
    //  Getter method for the Implementation Object
    Cfg0ProductModelThreadImpl*  getCfg0ProductModelThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0ProductModelThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0ProductModelThreadImpl*  m_cfg0productmodelthreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0ProductModelThread - desc for Cfg0ProductModelThread parameter
     */
    Cfg0ProductModelThread( const Cfg0ProductModelThread& );
    Cfg0ProductModelThread& operator=( const Cfg0ProductModelThread& );

    friend class  Cfg0ProductModelThreadDelegate;
    friend class  Cfg0ProductModelThreadDispatch;
    friend class  Cfg0ProductModelThreadGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0PRODUCTMODELTHREAD__HXX
