//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0RangeExpression
    Filename:   Cfg0RangeExpression.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0RANGEEXPRESSION__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0RANGEEXPRESSION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0RangeExpression;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0RangeExpressionImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0RangeExpressionDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0RangeExpressionDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0RangeExpressionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0RangeExpression
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0RangeExpression();

    /**
     * Destructor
     */
    virtual ~Cfg0RangeExpression();

private:
    //  Getter method for the Implementation Object
    Cfg0RangeExpressionImpl*  getCfg0RangeExpressionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0RangeExpressionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0RangeExpressionImpl*  m_cfg0rangeexpressionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0RangeExpression - desc for Cfg0RangeExpression parameter
     */
    Cfg0RangeExpression( const Cfg0RangeExpression& );
    Cfg0RangeExpression& operator=( const Cfg0RangeExpression& );

    friend class  Cfg0RangeExpressionDelegate;
    friend class  Cfg0RangeExpressionDispatch;
    friend class  Cfg0RangeExpressionGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0RANGEEXPRESSION__HXX
