//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0RangeExpressionDelegate
    Filename:   Cfg0RangeExpressionDelegate.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0RANGEEXPRESSIONDELEGATE_HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0RANGEEXPRESSIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0RangeExpression.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0RangeExpressionDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0RangeExpressionImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0RangeExpression;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0RangeExpressionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CFG0CONFIGURATOR_API Teamcenter_alias::Cfg0configurator::Cfg0RangeExpressionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cfg0RangeExpressionDelegate instance
    static Cfg0RangeExpressionDelegate&  getInstance();

    //  Method to create the Cfg0RangeExpressionImpl pointer
    static Cfg0RangeExpressionImpl*  createImpl( Cfg0RangeExpression&  ifObj );

    //  Method to delete the Cfg0RangeExpressionImpl pointer
    static void deleteImpl( Cfg0RangeExpressionImpl*  impl );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Cfg0RangeExpression &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Cfg0RangeExpression &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Cfg0RangeExpressionDelegate*  m_pInstance;

    Cfg0RangeExpressionDelegate();
    virtual ~Cfg0RangeExpressionDelegate();
    static void setInstance( Cfg0RangeExpressionDelegate*  instance );


private:
    friend class  ::Teamcenter::Cfg0configurator::Cfg0RangeExpressionGenImpl;

};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif  //  TEAMCENTER__CFG0CONFIGURATOR__CFG0RANGEEXPRESSIONDELEGATE_HXX
