//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0SearchCursorDelegate
    Filename:   Cfg0SearchCursorDelegate.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0SEARCHCURSORDELEGATE_HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0SEARCHCURSORDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0SearchCursor.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SearchCursorDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SearchCursorImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SearchCursor;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SearchCursorGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CFG0CONFIGURATOR_API Teamcenter_alias::Cfg0configurator::Cfg0SearchCursorDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cfg0SearchCursorDelegate instance
    static Cfg0SearchCursorDelegate&  getInstance();

    //  Method to create the Cfg0SearchCursorImpl pointer
    static Cfg0SearchCursorImpl*  createImpl( Cfg0SearchCursor&  ifObj );

    //  Method to delete the Cfg0SearchCursorImpl pointer
    static void deleteImpl( Cfg0SearchCursorImpl*  impl );


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0CountBase(const Cfg0SearchCursor &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for Tag Array Property
    /// @version Teamcenter 10.1.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0FoundObjectsBase(const Cfg0SearchCursor &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0IndexBase(const Cfg0SearchCursor &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0SearchDefinitionBase(const Cfg0SearchCursor &ifObj,  tag_t &value, bool &isNull ) const;



protected:
    //  Pointer to the instance
    static Cfg0SearchCursorDelegate*  m_pInstance;

    Cfg0SearchCursorDelegate();
    virtual ~Cfg0SearchCursorDelegate();
    static void setInstance( Cfg0SearchCursorDelegate*  instance );


private:
    friend class  ::Teamcenter::Cfg0configurator::Cfg0SearchCursorGenImpl;

};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif  //  TEAMCENTER__CFG0CONFIGURATOR__CFG0SEARCHCURSORDELEGATE_HXX
