//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0SearchDefinitionDelegate
    Filename:   Cfg0SearchDefinitionDelegate.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0SEARCHDEFINITIONDELEGATE_HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0SEARCHDEFINITIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0SearchDefinition.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SearchDefinitionDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SearchDefinitionImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SearchDefinition;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SearchDefinitionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CFG0CONFIGURATOR_API Teamcenter_alias::Cfg0configurator::Cfg0SearchDefinitionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cfg0SearchDefinitionDelegate instance
    static Cfg0SearchDefinitionDelegate&  getInstance();

    //  Method to create the Cfg0SearchDefinitionImpl pointer
    static Cfg0SearchDefinitionImpl*  createImpl( Cfg0SearchDefinition&  ifObj );

    //  Method to delete the Cfg0SearchDefinitionImpl pointer
    static void deleteImpl( Cfg0SearchDefinitionImpl*  impl );


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0SearchResultColumnAliasesBase(const Cfg0SearchDefinition &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0SearchResultColumnNamesBase(const Cfg0SearchDefinition &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0SearchTypeBase(const Cfg0SearchDefinition &ifObj,  int &value, bool &isNull ) const;



protected:
    //  Pointer to the instance
    static Cfg0SearchDefinitionDelegate*  m_pInstance;

    Cfg0SearchDefinitionDelegate();
    virtual ~Cfg0SearchDefinitionDelegate();
    static void setInstance( Cfg0SearchDefinitionDelegate*  instance );


private:
    friend class  ::Teamcenter::Cfg0configurator::Cfg0SearchDefinitionGenImpl;

};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif  //  TEAMCENTER__CFG0CONFIGURATOR__CFG0SEARCHDEFINITIONDELEGATE_HXX
