//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0SearchGroupDelegate
    Filename:   Cfg0SearchGroupDelegate.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0SEARCHGROUPDELEGATE_HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0SEARCHGROUPDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0SearchGroup.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SearchGroupDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SearchGroupImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SearchGroup;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SearchGroupGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CFG0CONFIGURATOR_API Teamcenter_alias::Cfg0configurator::Cfg0SearchGroupDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cfg0SearchGroupDelegate instance
    static Cfg0SearchGroupDelegate&  getInstance();

    //  Method to create the Cfg0SearchGroupImpl pointer
    static Cfg0SearchGroupImpl*  createImpl( Cfg0SearchGroup&  ifObj );

    //  Method to delete the Cfg0SearchGroupImpl pointer
    static void deleteImpl( Cfg0SearchGroupImpl*  impl );


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0OperatorBase(const Cfg0SearchGroup &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0SearchDefinitionsBase(const Cfg0SearchGroup &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;



protected:
    //  Pointer to the instance
    static Cfg0SearchGroupDelegate*  m_pInstance;

    Cfg0SearchGroupDelegate();
    virtual ~Cfg0SearchGroupDelegate();
    static void setInstance( Cfg0SearchGroupDelegate*  instance );


private:
    friend class  ::Teamcenter::Cfg0configurator::Cfg0SearchGroupGenImpl;

};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif  //  TEAMCENTER__CFG0CONFIGURATOR__CFG0SEARCHGROUPDELEGATE_HXX
