//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0SearchJoin
    Filename:   Cfg0SearchJoin.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0SEARCHJOIN__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0SEARCHJOIN__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0SearchDefinition.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SearchJoin;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SearchJoinImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SearchJoinDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SearchJoinDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SearchJoinGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0SearchJoin
     : public  ::Teamcenter::Cfg0configurator::Cfg0SearchDefinition
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0Operator( int &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0SearchDefinitions( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for an Integer Array Property
    /// @version Teamcenter 10.1.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0SearchJoinCondLeftCols( std::vector< int > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for an Integer Array Property
    /// @version Teamcenter 10.1.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0SearchJoinCondOperators( std::vector< int > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for an Integer Array Property
    /// @version Teamcenter 10.1.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0SearchJoinCondRightCols( std::vector< int > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0SearchJoin();

    /**
     * Destructor
     */
    virtual ~Cfg0SearchJoin();

private:
    //  Getter method for the Implementation Object
    Cfg0SearchJoinImpl*  getCfg0SearchJoinImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0SearchJoinImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0SearchJoinImpl*  m_cfg0searchjoinImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0SearchJoin - desc for Cfg0SearchJoin parameter
     */
    Cfg0SearchJoin( const Cfg0SearchJoin& );
    Cfg0SearchJoin& operator=( const Cfg0SearchJoin& );

    friend class  Cfg0SearchJoinDelegate;
    friend class  Cfg0SearchJoinDispatch;
    friend class  Cfg0SearchJoinGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0SEARCHJOIN__HXX
