//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0SearchJoinDelegate
    Filename:   Cfg0SearchJoinDelegate.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0SEARCHJOINDELEGATE_HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0SEARCHJOINDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0SearchJoin.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SearchJoinDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SearchJoinImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SearchJoin;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SearchJoinGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CFG0CONFIGURATOR_API Teamcenter_alias::Cfg0configurator::Cfg0SearchJoinDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cfg0SearchJoinDelegate instance
    static Cfg0SearchJoinDelegate&  getInstance();

    //  Method to create the Cfg0SearchJoinImpl pointer
    static Cfg0SearchJoinImpl*  createImpl( Cfg0SearchJoin&  ifObj );

    //  Method to delete the Cfg0SearchJoinImpl pointer
    static void deleteImpl( Cfg0SearchJoinImpl*  impl );


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0OperatorBase(const Cfg0SearchJoin &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0SearchDefinitionsBase(const Cfg0SearchJoin &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for an Integer Array Property
    /// @version Teamcenter 10.1.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0SearchJoinCondLeftColsBase(const Cfg0SearchJoin &ifObj,  std::vector< int > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for an Integer Array Property
    /// @version Teamcenter 10.1.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0SearchJoinCondOperatorsBase(const Cfg0SearchJoin &ifObj,  std::vector< int > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for an Integer Array Property
    /// @version Teamcenter 10.1.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0SearchJoinCondRightColsBase(const Cfg0SearchJoin &ifObj,  std::vector< int > &values, std::vector< int > &isNull ) const;



protected:
    //  Pointer to the instance
    static Cfg0SearchJoinDelegate*  m_pInstance;

    Cfg0SearchJoinDelegate();
    virtual ~Cfg0SearchJoinDelegate();
    static void setInstance( Cfg0SearchJoinDelegate*  instance );


private:
    friend class  ::Teamcenter::Cfg0configurator::Cfg0SearchJoinGenImpl;

};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif  //  TEAMCENTER__CFG0CONFIGURATOR__CFG0SEARCHJOINDELEGATE_HXX
