//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0SearchSavedQuery
    Filename:   Cfg0SearchSavedQuery.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0SEARCHSAVEDQUERY__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0SEARCHSAVEDQUERY__HXX

#include <vector>
#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0SearchDefinition.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SearchSavedQuery;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SearchSavedQueryImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SearchSavedQueryDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SearchSavedQueryDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SearchSavedQueryGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0SearchSavedQuery
     : public  ::Teamcenter::Cfg0configurator::Cfg0SearchDefinition
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 10.1.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0Entries( std::vector< std::string > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0Query( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 10.1.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0Values( std::vector< std::string > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0SearchSavedQuery();

    /**
     * Destructor
     */
    virtual ~Cfg0SearchSavedQuery();

private:
    //  Getter method for the Implementation Object
    Cfg0SearchSavedQueryImpl*  getCfg0SearchSavedQueryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0SearchSavedQueryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0SearchSavedQueryImpl*  m_cfg0searchsavedqueryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0SearchSavedQuery - desc for Cfg0SearchSavedQuery parameter
     */
    Cfg0SearchSavedQuery( const Cfg0SearchSavedQuery& );
    Cfg0SearchSavedQuery& operator=( const Cfg0SearchSavedQuery& );

    friend class  Cfg0SearchSavedQueryDelegate;
    friend class  Cfg0SearchSavedQueryDispatch;
    friend class  Cfg0SearchSavedQueryGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0SEARCHSAVEDQUERY__HXX
