//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0SearchTraversalDelegate
    Filename:   Cfg0SearchTraversalDelegate.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0SEARCHTRAVERSALDELEGATE_HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0SEARCHTRAVERSALDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0SearchTraversal.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SearchTraversalDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SearchTraversalImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SearchTraversal;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SearchTraversalGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CFG0CONFIGURATOR_API Teamcenter_alias::Cfg0configurator::Cfg0SearchTraversalDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cfg0SearchTraversalDelegate instance
    static Cfg0SearchTraversalDelegate&  getInstance();

    //  Method to create the Cfg0SearchTraversalImpl pointer
    static Cfg0SearchTraversalImpl*  createImpl( Cfg0SearchTraversal&  ifObj );

    //  Method to delete the Cfg0SearchTraversalImpl pointer
    static void deleteImpl( Cfg0SearchTraversalImpl*  impl );


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 10.1.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0OptionNamesBase(const Cfg0SearchTraversal &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0OptionSetBase(const Cfg0SearchTraversal &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 10.1.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCfg0OptionValuesBase(const Cfg0SearchTraversal &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;



protected:
    //  Pointer to the instance
    static Cfg0SearchTraversalDelegate*  m_pInstance;

    Cfg0SearchTraversalDelegate();
    virtual ~Cfg0SearchTraversalDelegate();
    static void setInstance( Cfg0SearchTraversalDelegate*  instance );


private:
    friend class  ::Teamcenter::Cfg0configurator::Cfg0SearchTraversalGenImpl;

};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif  //  TEAMCENTER__CFG0CONFIGURATOR__CFG0SEARCHTRAVERSALDELEGATE_HXX
