//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0SummaryFamilyThread
    Filename:   Cfg0SummaryFamilyThread.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0SUMMARYFAMILYTHREAD__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0SUMMARYFAMILYTHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsSummaryFamilyThread.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SummaryFamilyThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SummaryFamilyThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SummaryFamilyThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SummaryFamilyThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SummaryFamilyThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0SummaryFamilyThread
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsSummaryFamilyThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0SummaryFamilyThread();

    /**
     * Destructor
     */
    virtual ~Cfg0SummaryFamilyThread();

private:
    //  Getter method for the Implementation Object
    Cfg0SummaryFamilyThreadImpl*  getCfg0SummaryFamilyThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0SummaryFamilyThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0SummaryFamilyThreadImpl*  m_cfg0summaryfamilythreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0SummaryFamilyThread - desc for Cfg0SummaryFamilyThread parameter
     */
    Cfg0SummaryFamilyThread( const Cfg0SummaryFamilyThread& );
    Cfg0SummaryFamilyThread& operator=( const Cfg0SummaryFamilyThread& );

    friend class  Cfg0SummaryFamilyThreadDelegate;
    friend class  Cfg0SummaryFamilyThreadDispatch;
    friend class  Cfg0SummaryFamilyThreadGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0SUMMARYFAMILYTHREAD__HXX
