//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0SummaryModelThread
    Filename:   Cfg0SummaryModelThread.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0SUMMARYMODELTHREAD__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0SUMMARYMODELTHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsSummaryModelThread.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SummaryModelThread;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SummaryModelThreadImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SummaryModelThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SummaryModelThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SummaryModelThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0SummaryModelThread
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsSummaryModelThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0SummaryModelThread();

    /**
     * Destructor
     */
    virtual ~Cfg0SummaryModelThread();

private:
    //  Getter method for the Implementation Object
    Cfg0SummaryModelThreadImpl*  getCfg0SummaryModelThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0SummaryModelThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0SummaryModelThreadImpl*  m_cfg0summarymodelthreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0SummaryModelThread - desc for Cfg0SummaryModelThread parameter
     */
    Cfg0SummaryModelThread( const Cfg0SummaryModelThread& );
    Cfg0SummaryModelThread& operator=( const Cfg0SummaryModelThread& );

    friend class  Cfg0SummaryModelThreadDelegate;
    friend class  Cfg0SummaryModelThreadDispatch;
    friend class  Cfg0SummaryModelThreadGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0SUMMARYMODELTHREAD__HXX
