//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0SummaryOptionFamily
    Filename:   Cfg0SummaryOptionFamily.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0SUMMARYOPTIONFAMILY__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0SUMMARYOPTIONFAMILY__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsSummaryOptionFamily.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SummaryOptionFamily;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SummaryOptionFamilyImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SummaryOptionFamilyDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SummaryOptionFamilyDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SummaryOptionFamilyGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0SummaryOptionFamily
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsSummaryOptionFamily
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0SummaryOptionFamily();

    /**
     * Destructor
     */
    virtual ~Cfg0SummaryOptionFamily();

private:
    //  Getter method for the Implementation Object
    Cfg0SummaryOptionFamilyImpl*  getCfg0SummaryOptionFamilyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0SummaryOptionFamilyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0SummaryOptionFamilyImpl*  m_cfg0summaryoptionfamilyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0SummaryOptionFamily - desc for Cfg0SummaryOptionFamily parameter
     */
    Cfg0SummaryOptionFamily( const Cfg0SummaryOptionFamily& );
    Cfg0SummaryOptionFamily& operator=( const Cfg0SummaryOptionFamily& );

    friend class  Cfg0SummaryOptionFamilyDelegate;
    friend class  Cfg0SummaryOptionFamilyDispatch;
    friend class  Cfg0SummaryOptionFamilyGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0SUMMARYOPTIONFAMILY__HXX
