//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0SummaryOptionValue
    Filename:   Cfg0SummaryOptionValue.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0SUMMARYOPTIONVALUE__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0SUMMARYOPTIONVALUE__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsSummaryOptionValue.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SummaryOptionValue;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SummaryOptionValueImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SummaryOptionValueDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SummaryOptionValueDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0SummaryOptionValueGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0SummaryOptionValue
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsSummaryOptionValue
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0SummaryOptionValue();

    /**
     * Destructor
     */
    virtual ~Cfg0SummaryOptionValue();

private:
    //  Getter method for the Implementation Object
    Cfg0SummaryOptionValueImpl*  getCfg0SummaryOptionValueImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0SummaryOptionValueImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0SummaryOptionValueImpl*  m_cfg0summaryoptionvalueImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0SummaryOptionValue - desc for Cfg0SummaryOptionValue parameter
     */
    Cfg0SummaryOptionValue( const Cfg0SummaryOptionValue& );
    Cfg0SummaryOptionValue& operator=( const Cfg0SummaryOptionValue& );

    friend class  Cfg0SummaryOptionValueDelegate;
    friend class  Cfg0SummaryOptionValueDispatch;
    friend class  Cfg0SummaryOptionValueGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0SUMMARYOPTIONVALUE__HXX
