//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0VariantCriteriaBlock
    Filename:   Cfg0VariantCriteriaBlock.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0VARIANTCRITERIABLOCK__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0VARIANTCRITERIABLOCK__HXX

#include <common/tc_deprecation_macros.h>
#include <fnd0booleansolve/Fnd0VariantExprBlock.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0VariantCriteriaBlock;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0VariantCriteriaBlockImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0VariantCriteriaBlockDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0VariantCriteriaBlockDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0VariantCriteriaBlockGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0VariantCriteriaBlock
     : public  ::Teamcenter::Fnd0VariantExprBlock
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0VariantCriteriaBlock();

    /**
     * Destructor
     */
    virtual ~Cfg0VariantCriteriaBlock();

private:
    //  Getter method for the Implementation Object
    Cfg0VariantCriteriaBlockImpl*  getCfg0VariantCriteriaBlockImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0VariantCriteriaBlockImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0VariantCriteriaBlockImpl*  m_cfg0variantcriteriablockImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0VariantCriteriaBlock - desc for Cfg0VariantCriteriaBlock parameter
     */
    Cfg0VariantCriteriaBlock( const Cfg0VariantCriteriaBlock& );
    Cfg0VariantCriteriaBlock& operator=( const Cfg0VariantCriteriaBlock& );

    friend class  Cfg0VariantCriteriaBlockDelegate;
    friend class  Cfg0VariantCriteriaBlockDispatch;
    friend class  Cfg0VariantCriteriaBlockGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0VARIANTCRITERIABLOCK__HXX
