//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0VariantCriteriaDelegate
    Filename:   Cfg0VariantCriteriaDelegate.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0VARIANTCRITERIADELEGATE_HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0VARIANTCRITERIADELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0VariantCriteria.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0VariantCriteriaDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0VariantCriteriaImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0VariantCriteria;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0VariantCriteriaGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CFG0CONFIGURATOR_API Teamcenter_alias::Cfg0configurator::Cfg0VariantCriteriaDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cfg0VariantCriteriaDelegate instance
    static Cfg0VariantCriteriaDelegate&  getInstance();

    //  Method to create the Cfg0VariantCriteriaImpl pointer
    static Cfg0VariantCriteriaImpl*  createImpl( Cfg0VariantCriteria&  ifObj );

    //  Method to delete the Cfg0VariantCriteriaImpl pointer
    static void deleteImpl( Cfg0VariantCriteriaImpl*  impl );


    ///
    /// Finalize Revise Input Descriptor
    /// @version Teamcenter 11.6
    /// @param pReviseInput - Revise input
    /// @param vecDeepCopyData - Deep Copy Data Vector
    /// @return - Failure Code
    ///
    int  finalizeReviseInputBase(const Cfg0VariantCriteria &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.6
    /// @param inputs - A vector of data that contains reference information to the objects to be revised
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0FinalizeReviseInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.6
    /// @param inputs - A vector of data that contains reference information to the objects to be revised
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0ReviseBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.6
    /// @param inputs - A vector of data that contains reference information to the objects to be revised
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0RevisePostBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.6
    /// @param inputs - A vector of data that contains reference information to the objects to be revised
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0SetPropertiesFromReviseInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.6
    /// @param inputs - A vector of data that contains reference information to the objects to be revised
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0ValidateReviseInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// Cfg0VariantCriteria Revise Operation
    /// @version Teamcenter 11.6
    /// @param pReviseInput - Revise Input
    /// @param vecDeepCopyData - Deep Copy Data Vactor
    /// @param newObject - New Object tag
    /// @return - Failure Code
    ///
    int  reviseBase(const Cfg0VariantCriteria &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData, tag_t *newObject );


    ///
    /// Reivse post operation
    /// @version Teamcenter 11.6
    /// @param pReviseInput - Revise Input Descriptor
    /// @param vecDeepCopyData - Deep Copy Data Vector
    /// @return - Failure Code
    ///
    int  revisePostBase(const Cfg0VariantCriteria &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// Set properties from revise input.
    /// @version Teamcenter 11.6
    /// @param pReviseInput - Revise Input Descriptor
    /// @return - Failure code
    ///
    int  setPropertiesFromReviseInputBase(const Cfg0VariantCriteria &ifObj,  ::Teamcenter::ReviseInput *pReviseInput );


    ///
    /// Validate Revise Input Descriptor
    /// @version Teamcenter 11.6
    /// @param pReviseInput - Revise Input Descriptor
    /// @param vecDeepCopyData - Deep Copy Data Vector
    /// @return - Failure Code
    ///
    int  validateReviseInputBase(const Cfg0VariantCriteria &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Cfg0VariantCriteria &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// finalize operation input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  finalizeSaveAsInputBase(const Cfg0VariantCriteria &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// Generic saveAsPost operation.
    /// @version Teamcenter 8.1
    /// @param pSavAsInput - Input argument as SaveAsInput object.
    /// @param vecDeepCopyData - vector deepcopy data
    /// @return - Return integer value.
    ///
    int  saveAsPostBase(const Cfg0VariantCriteria &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Cfg0VariantCriteria &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// validate saveas input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  validateSaveAsInputBase(const Cfg0VariantCriteria &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static Cfg0VariantCriteriaDelegate*  m_pInstance;

    Cfg0VariantCriteriaDelegate();
    virtual ~Cfg0VariantCriteriaDelegate();
    static void setInstance( Cfg0VariantCriteriaDelegate*  instance );


private:
    friend class  ::Teamcenter::Cfg0configurator::Cfg0VariantCriteriaGenImpl;

};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif  //  TEAMCENTER__CFG0CONFIGURATOR__CFG0VARIANTCRITERIADELEGATE_HXX
