//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0VariantCriteriaExpr
    Filename:   Cfg0VariantCriteriaExpr.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0VARIANTCRITERIAEXPR__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0VARIANTCRITERIAEXPR__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0VariantExpression.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0VariantCriteriaExpr;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0VariantCriteriaExprImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0VariantCriteriaExprDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0VariantCriteriaExprDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0VariantCriteriaExprGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0VariantCriteriaExpr
     : public  ::Teamcenter::Cfg0configurator::Cfg0VariantExpression
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0VariantCriteriaExpr();

    /**
     * Destructor
     */
    virtual ~Cfg0VariantCriteriaExpr();

private:
    //  Getter method for the Implementation Object
    Cfg0VariantCriteriaExprImpl*  getCfg0VariantCriteriaExprImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0VariantCriteriaExprImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0VariantCriteriaExprImpl*  m_cfg0variantcriteriaexprImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0VariantCriteriaExpr - desc for Cfg0VariantCriteriaExpr parameter
     */
    Cfg0VariantCriteriaExpr( const Cfg0VariantCriteriaExpr& );
    Cfg0VariantCriteriaExpr& operator=( const Cfg0VariantCriteriaExpr& );

    friend class  Cfg0VariantCriteriaExprDelegate;
    friend class  Cfg0VariantCriteriaExprDispatch;
    friend class  Cfg0VariantCriteriaExprGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0VARIANTCRITERIAEXPR__HXX
