//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0VariantExprBlock
    Filename:   Cfg0VariantExprBlock.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0VARIANTEXPRBLOCK__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0VARIANTEXPRBLOCK__HXX

#include <common/tc_deprecation_macros.h>
#include <fnd0booleansolve/Fnd0VariantExprBlock.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0VariantExprBlock;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0VariantExprBlockImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0VariantExprBlockDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0VariantExprBlockDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0VariantExprBlockGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0VariantExprBlock
     : public  ::Teamcenter::Fnd0VariantExprBlock
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0VariantExprBlock();

    /**
     * Destructor
     */
    virtual ~Cfg0VariantExprBlock();

private:
    //  Getter method for the Implementation Object
    Cfg0VariantExprBlockImpl*  getCfg0VariantExprBlockImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0VariantExprBlockImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0VariantExprBlockImpl*  m_cfg0variantexprblockImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0VariantExprBlock - desc for Cfg0VariantExprBlock parameter
     */
    Cfg0VariantExprBlock( const Cfg0VariantExprBlock& );
    Cfg0VariantExprBlock& operator=( const Cfg0VariantExprBlock& );

    friend class  Cfg0VariantExprBlockDelegate;
    friend class  Cfg0VariantExprBlockDispatch;
    friend class  Cfg0VariantExprBlockGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0VARIANTEXPRBLOCK__HXX
