//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0VariantExpression
    Filename:   Cfg0VariantExpression.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0VARIANTEXPRESSION__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0VARIANTEXPRESSION__HXX

#include <common/tc_deprecation_macros.h>
#include <fnd0booleansolve/Fnd0VariantExpression.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0VariantExpression;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0VariantExpressionImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0VariantExpressionDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0VariantExpressionDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0VariantExpressionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0VariantExpression
     : public  ::Teamcenter::Fnd0VariantExpression
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0VariantExpression();

    /**
     * Destructor
     */
    virtual ~Cfg0VariantExpression();

private:
    //  Getter method for the Implementation Object
    Cfg0VariantExpressionImpl*  getCfg0VariantExpressionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0VariantExpressionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0VariantExpressionImpl*  m_cfg0variantexpressionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0VariantExpression - desc for Cfg0VariantExpression parameter
     */
    Cfg0VariantExpression( const Cfg0VariantExpression& );
    Cfg0VariantExpression& operator=( const Cfg0VariantExpression& );

    friend class  Cfg0VariantExpressionDelegate;
    friend class  Cfg0VariantExpressionDispatch;
    friend class  Cfg0VariantExpressionGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0VARIANTEXPRESSION__HXX
