//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0VariantExpressionGroup
    Filename:   Cfg0VariantExpressionGroup.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0VARIANTEXPRESSIONGROUP__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0VARIANTEXPRESSIONGROUP__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0VariantExpressionGroup;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0VariantExpressionGroupImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0VariantExpressionGroupDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0VariantExpressionGroupDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0VariantExpressionGroupGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0VariantExpressionGroup
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0VariantExpressionGroup();

    /**
     * Destructor
     */
    virtual ~Cfg0VariantExpressionGroup();

private:
    //  Getter method for the Implementation Object
    Cfg0VariantExpressionGroupImpl*  getCfg0VariantExpressionGroupImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0VariantExpressionGroupImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0VariantExpressionGroupImpl*  m_cfg0variantexpressiongroupImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0VariantExpressionGroup - desc for Cfg0VariantExpressionGroup parameter
     */
    Cfg0VariantExpressionGroup( const Cfg0VariantExpressionGroup& );
    Cfg0VariantExpressionGroup& operator=( const Cfg0VariantExpressionGroup& );

    friend class  Cfg0VariantExpressionGroupDelegate;
    friend class  Cfg0VariantExpressionGroupDispatch;
    friend class  Cfg0VariantExpressionGroupGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0VARIANTEXPRESSIONGROUP__HXX
