//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cfg0VariantSubExpression
    Filename:   Cfg0VariantSubExpression.hxx
    Module:     Cfg0configurator
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFG0CONFIGURATOR__CFG0VARIANTSUBEXPRESSION__HXX
#define TEAMCENTER__CFG0CONFIGURATOR__CFG0VARIANTSUBEXPRESSION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <Cfg0configurator/libcfg0configurator_exports.h>

namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0VariantSubExpression;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0VariantSubExpressionImpl;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0VariantSubExpressionDelegate;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0VariantSubExpressionDispatch;
    }
}
namespace Teamcenter
{
    namespace Cfg0configurator
    {
        class Cfg0VariantSubExpressionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFG0CONFIGURATOR_API  Teamcenter::Cfg0configurator::Cfg0VariantSubExpression
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cfg0VariantSubExpression();

    /**
     * Destructor
     */
    virtual ~Cfg0VariantSubExpression();

private:
    //  Getter method for the Implementation Object
    Cfg0VariantSubExpressionImpl*  getCfg0VariantSubExpressionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfg0VariantSubExpressionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cfg0VariantSubExpressionImpl*  m_cfg0variantsubexpressionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cfg0VariantSubExpression - desc for Cfg0VariantSubExpression parameter
     */
    Cfg0VariantSubExpression( const Cfg0VariantSubExpression& );
    Cfg0VariantSubExpression& operator=( const Cfg0VariantSubExpression& );

    friend class  Cfg0VariantSubExpressionDelegate;
    friend class  Cfg0VariantSubExpressionDispatch;
    friend class  Cfg0VariantSubExpressionGenImpl;
};

#include <Cfg0configurator/libcfg0configurator_undef.h>
#endif //   TEAMCENTER__CFG0CONFIGURATOR__CFG0VARIANTSUBEXPRESSION__HXX
