//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cip0ControlPlan
    Filename:   Cip0ControlPlan.hxx
    Module:     Cip0controlinspplan
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CIP0CONTROLINSPPLAN__CIP0CONTROLPLAN__HXX
#define CIP0CONTROLINSPPLAN__CIP0CONTROLPLAN__HXX

#include <common/tc_deprecation_macros.h>
#include <me/MEProcess.hxx>

#include <Cip0controlinspplan/libcip0controlinspplan_exports.h>

namespace cip0controlinspplan
{
    class Cip0ControlPlan;
}
namespace cip0controlinspplan
{
    class Cip0ControlPlanImpl;
}
namespace cip0controlinspplan
{
    class Cip0ControlPlanDelegate;
}
namespace cip0controlinspplan
{
    class Cip0ControlPlanDispatch;
}
namespace cip0controlinspplan
{
    class Cip0ControlPlanGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CIP0CONTROLINSPPLAN_API  cip0controlinspplan::Cip0ControlPlan
     : public  ::Teamcenter::MEProcess
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cip0ControlPlan();

    /**
     * Destructor
     */
    virtual ~Cip0ControlPlan();

private:
    //  Getter method for the Implementation Object
    Cip0ControlPlanImpl*  getCip0ControlPlanImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCip0ControlPlanImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cip0ControlPlanImpl*  m_cip0controlplanImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cip0ControlPlan - desc for Cip0ControlPlan parameter
     */
    Cip0ControlPlan( const Cip0ControlPlan& );
    Cip0ControlPlan& operator=( const Cip0ControlPlan& );

    friend class  Cip0ControlPlanDelegate;
    friend class  Cip0ControlPlanDispatch;
    friend class  Cip0ControlPlanGenImpl;
};

#include <Cip0controlinspplan/libcip0controlinspplan_undef.h>
#endif //   CIP0CONTROLINSPPLAN__CIP0CONTROLPLAN__HXX
