//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cip0ControlPlanRevision
    Filename:   Cip0ControlPlanRevision.hxx
    Module:     Cip0controlinspplan
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CIP0CONTROLINSPPLAN__CIP0CONTROLPLANREVISION__HXX
#define CIP0CONTROLINSPPLAN__CIP0CONTROLPLANREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <me/MEProcessRevision.hxx>

#include <Cip0controlinspplan/libcip0controlinspplan_exports.h>

namespace cip0controlinspplan
{
    class Cip0ControlPlanRevision;
}
namespace cip0controlinspplan
{
    class Cip0ControlPlanRevisionImpl;
}
namespace cip0controlinspplan
{
    class Cip0ControlPlanRevisionDelegate;
}
namespace cip0controlinspplan
{
    class Cip0ControlPlanRevisionDispatch;
}
namespace cip0controlinspplan
{
    class Cip0ControlPlanRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CIP0CONTROLINSPPLAN_API  cip0controlinspplan::Cip0ControlPlanRevision
     : public  ::Teamcenter::MEProcessRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cip0ControlPlanRevision();

    /**
     * Destructor
     */
    virtual ~Cip0ControlPlanRevision();

private:
    //  Getter method for the Implementation Object
    Cip0ControlPlanRevisionImpl*  getCip0ControlPlanRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCip0ControlPlanRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cip0ControlPlanRevisionImpl*  m_cip0controlplanrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cip0ControlPlanRevision - desc for Cip0ControlPlanRevision parameter
     */
    Cip0ControlPlanRevision( const Cip0ControlPlanRevision& );
    Cip0ControlPlanRevision& operator=( const Cip0ControlPlanRevision& );

    friend class  Cip0ControlPlanRevisionDelegate;
    friend class  Cip0ControlPlanRevisionDispatch;
    friend class  Cip0ControlPlanRevisionGenImpl;
};

#include <Cip0controlinspplan/libcip0controlinspplan_undef.h>
#endif //   CIP0CONTROLINSPPLAN__CIP0CONTROLPLANREVISION__HXX
