//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Clr0AppSchmBrkdn
    Filename:   Clr0AppSchmBrkdn.hxx
    Module:     Clr0colorappearance
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CLR0COLORAPPEARANCE__CLR0APPSCHMBRKDN__HXX
#define CLR0COLORAPPEARANCE__CLR0APPSCHMBRKDN__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <Clr0colorappearance/libclr0colorappearance_exports.h>

namespace Clr0ColorAppearance
{
    class Clr0AppSchmBrkdn;
}
namespace Clr0ColorAppearance
{
    class Clr0AppSchmBrkdnImpl;
}
namespace Clr0ColorAppearance
{
    class Clr0AppSchmBrkdnDelegate;
}
namespace Clr0ColorAppearance
{
    class Clr0AppSchmBrkdnDispatch;
}
namespace Clr0ColorAppearance
{
    class Clr0AppSchmBrkdnGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CLR0COLORAPPEARANCE_API  Clr0ColorAppearance::Clr0AppSchmBrkdn
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.6
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setClr0AppearanceArea( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Clr0AppSchmBrkdn();

    /**
     * Destructor
     */
    virtual ~Clr0AppSchmBrkdn();

private:
    //  Getter method for the Implementation Object
    Clr0AppSchmBrkdnImpl*  getClr0AppSchmBrkdnImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setClr0AppSchmBrkdnImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Clr0AppSchmBrkdnImpl*  m_clr0appschmbrkdnImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Clr0AppSchmBrkdn - desc for Clr0AppSchmBrkdn parameter
     */
    Clr0AppSchmBrkdn( const Clr0AppSchmBrkdn& );
    Clr0AppSchmBrkdn& operator=( const Clr0AppSchmBrkdn& );

    friend class  Clr0AppSchmBrkdnDelegate;
    friend class  Clr0AppSchmBrkdnDispatch;
    friend class  Clr0AppSchmBrkdnGenImpl;
};

#include <Clr0colorappearance/libclr0colorappearance_undef.h>
#endif //   CLR0COLORAPPEARANCE__CLR0APPSCHMBRKDN__HXX
