//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Clr0AppearanceArea
    Filename:   Clr0AppearanceArea.hxx
    Module:     Clr0colorappearance
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CLR0COLORAPPEARANCE__CLR0APPEARANCEAREA__HXX
#define CLR0COLORAPPEARANCE__CLR0APPEARANCEAREA__HXX

#include <unidefs.h>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <Clr0colorappearance/libclr0colorappearance_exports.h>

namespace Clr0ColorAppearance
{
    class Clr0AppearanceArea;
}
namespace Clr0ColorAppearance
{
    class Clr0AppearanceAreaImpl;
}
namespace Clr0ColorAppearance
{
    class Clr0AppearanceAreaDelegate;
}
namespace Clr0ColorAppearance
{
    class Clr0AppearanceAreaDispatch;
}
namespace Clr0ColorAppearance
{
    class Clr0AppearanceAreaGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CLR0COLORAPPEARANCE_API  Clr0ColorAppearance::Clr0AppearanceArea
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getClr0AppearanceAreaBreakdown( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 11.6
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setClr0ChildAppDesignators( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.6
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setClr0PABRoot( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Clr0AppearanceArea();

    /**
     * Destructor
     */
    virtual ~Clr0AppearanceArea();

private:
    //  Getter method for the Implementation Object
    Clr0AppearanceAreaImpl*  getClr0AppearanceAreaImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setClr0AppearanceAreaImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Clr0AppearanceAreaImpl*  m_clr0appearanceareaImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Clr0AppearanceArea - desc for Clr0AppearanceArea parameter
     */
    Clr0AppearanceArea( const Clr0AppearanceArea& );
    Clr0AppearanceArea& operator=( const Clr0AppearanceArea& );

    friend class  Clr0AppearanceAreaDelegate;
    friend class  Clr0AppearanceAreaDispatch;
    friend class  Clr0AppearanceAreaGenImpl;
};

#include <Clr0colorappearance/libclr0colorappearance_undef.h>
#endif //   CLR0COLORAPPEARANCE__CLR0APPEARANCEAREA__HXX
