//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Clr0AppearanceAreaBreakdown
    Filename:   Clr0AppearanceAreaBreakdown.hxx
    Module:     Clr0colorappearance
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CLR0COLORAPPEARANCE__CLR0APPEARANCEAREABREAKDOWN__HXX
#define CLR0COLORAPPEARANCE__CLR0APPEARANCEAREABREAKDOWN__HXX

#include <vector>
#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <Clr0colorappearance/libclr0colorappearance_exports.h>

namespace Clr0ColorAppearance
{
    class Clr0AppearanceAreaBreakdown;
}
namespace Clr0ColorAppearance
{
    class Clr0AppearanceAreaBreakdownImpl;
}
namespace Clr0ColorAppearance
{
    class Clr0AppearanceAreaBreakdownDelegate;
}
namespace Clr0ColorAppearance
{
    class Clr0AppearanceAreaBreakdownDispatch;
}
namespace Clr0ColorAppearance
{
    class Clr0AppearanceAreaBreakdownGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CLR0COLORAPPEARANCE_API  Clr0ColorAppearance::Clr0AppearanceAreaBreakdown
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 12.4
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getClr0Children( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getClr0ParentAppAreaBreakdown( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 11.6
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setClr0ChildAppAreaBreakdown( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );

    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 11.6
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setClr0ChildAppAreas( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.6
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setClr0PABRoot( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Clr0AppearanceAreaBreakdown();

    /**
     * Destructor
     */
    virtual ~Clr0AppearanceAreaBreakdown();

private:
    //  Getter method for the Implementation Object
    Clr0AppearanceAreaBreakdownImpl*  getClr0AppearanceAreaBreakdownImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setClr0AppearanceAreaBreakdownImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Clr0AppearanceAreaBreakdownImpl*  m_clr0appearanceareabreakdownImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Clr0AppearanceAreaBreakdown - desc for Clr0AppearanceAreaBreakdown parameter
     */
    Clr0AppearanceAreaBreakdown( const Clr0AppearanceAreaBreakdown& );
    Clr0AppearanceAreaBreakdown& operator=( const Clr0AppearanceAreaBreakdown& );

    friend class  Clr0AppearanceAreaBreakdownDelegate;
    friend class  Clr0AppearanceAreaBreakdownDispatch;
    friend class  Clr0AppearanceAreaBreakdownGenImpl;
};

#include <Clr0colorappearance/libclr0colorappearance_undef.h>
#endif //   CLR0COLORAPPEARANCE__CLR0APPEARANCEAREABREAKDOWN__HXX
