//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Clr0AppearanceAreaBreakdownDelegate
    Filename:   Clr0AppearanceAreaBreakdownDelegate.hxx
    Module:     Clr0colorappearance
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CLR0COLORAPPEARANCE__CLR0APPEARANCEAREABREAKDOWNDELEGATE_HXX
#define CLR0COLORAPPEARANCE__CLR0APPEARANCEAREABREAKDOWNDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Clr0colorappearance/Clr0AppearanceAreaBreakdown.hxx>

#include <Clr0colorappearance/libclr0colorappearance_exports.h>

namespace Clr0ColorAppearance
{
    class Clr0AppearanceAreaBreakdownDelegate;
}
namespace Clr0ColorAppearance
{
    class Clr0AppearanceAreaBreakdownImpl;
}
namespace Clr0ColorAppearance
{
    class Clr0AppearanceAreaBreakdown;
}
namespace Clr0ColorAppearance
{
    class Clr0AppearanceAreaBreakdownGenImpl;
}

namespace Clr0ColorAppearance_alias = ::Clr0ColorAppearance;


class  CLR0COLORAPPEARANCE_API Clr0ColorAppearance_alias::Clr0AppearanceAreaBreakdownDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Clr0AppearanceAreaBreakdownDelegate instance
    static Clr0AppearanceAreaBreakdownDelegate&  getInstance();

    //  Method to create the Clr0AppearanceAreaBreakdownImpl pointer
    static Clr0AppearanceAreaBreakdownImpl*  createImpl( Clr0AppearanceAreaBreakdown&  ifObj );

    //  Method to delete the Clr0AppearanceAreaBreakdownImpl pointer
    static void deleteImpl( Clr0AppearanceAreaBreakdownImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 12.4
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getClr0ChildrenBase(const Clr0AppearanceAreaBreakdown &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getClr0ParentAppAreaBreakdownBase(const Clr0AppearanceAreaBreakdown &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 11.6
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setClr0ChildAppAreaBreakdownBase(Clr0AppearanceAreaBreakdown &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 11.6
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setClr0ChildAppAreasBase(Clr0AppearanceAreaBreakdown &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.6
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setClr0PABRootBase(Clr0AppearanceAreaBreakdown &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Deletes the instance.
    /// @version Teamcenter 11.1
    /// @return - Failure code.
    ///
    int  fnd0DeleteBase(const Clr0AppearanceAreaBreakdown &ifObj  );



protected:
    //  Pointer to the instance
    static Clr0AppearanceAreaBreakdownDelegate*  m_pInstance;

    Clr0AppearanceAreaBreakdownDelegate();
    virtual ~Clr0AppearanceAreaBreakdownDelegate();
    static void setInstance( Clr0AppearanceAreaBreakdownDelegate*  instance );


private:
    friend class  ::Clr0ColorAppearance::Clr0AppearanceAreaBreakdownGenImpl;

};

#include <Clr0colorappearance/libclr0colorappearance_undef.h>
#endif  //  CLR0COLORAPPEARANCE__CLR0APPEARANCEAREABREAKDOWNDELEGATE_HXX
