//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Clr0AppearanceAreaDelegate
    Filename:   Clr0AppearanceAreaDelegate.hxx
    Module:     Clr0colorappearance
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CLR0COLORAPPEARANCE__CLR0APPEARANCEAREADELEGATE_HXX
#define CLR0COLORAPPEARANCE__CLR0APPEARANCEAREADELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Clr0colorappearance/Clr0AppearanceArea.hxx>

#include <Clr0colorappearance/libclr0colorappearance_exports.h>

namespace Clr0ColorAppearance
{
    class Clr0AppearanceAreaDelegate;
}
namespace Clr0ColorAppearance
{
    class Clr0AppearanceAreaImpl;
}
namespace Clr0ColorAppearance
{
    class Clr0AppearanceArea;
}
namespace Clr0ColorAppearance
{
    class Clr0AppearanceAreaGenImpl;
}

namespace Clr0ColorAppearance_alias = ::Clr0ColorAppearance;


class  CLR0COLORAPPEARANCE_API Clr0ColorAppearance_alias::Clr0AppearanceAreaDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Clr0AppearanceAreaDelegate instance
    static Clr0AppearanceAreaDelegate&  getInstance();

    //  Method to create the Clr0AppearanceAreaImpl pointer
    static Clr0AppearanceAreaImpl*  createImpl( Clr0AppearanceArea&  ifObj );

    //  Method to delete the Clr0AppearanceAreaImpl pointer
    static void deleteImpl( Clr0AppearanceAreaImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getClr0AppearanceAreaBreakdownBase(const Clr0AppearanceArea &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 11.6
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setClr0ChildAppDesignatorsBase(Clr0AppearanceArea &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.6
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setClr0PABRootBase(Clr0AppearanceArea &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Deletes the instance.
    /// @version Teamcenter 11.1
    /// @return - Failure code.
    ///
    int  fnd0DeleteBase(const Clr0AppearanceArea &ifObj  );



protected:
    //  Pointer to the instance
    static Clr0AppearanceAreaDelegate*  m_pInstance;

    Clr0AppearanceAreaDelegate();
    virtual ~Clr0AppearanceAreaDelegate();
    static void setInstance( Clr0AppearanceAreaDelegate*  instance );


private:
    friend class  ::Clr0ColorAppearance::Clr0AppearanceAreaGenImpl;

};

#include <Clr0colorappearance/libclr0colorappearance_undef.h>
#endif  //  CLR0COLORAPPEARANCE__CLR0APPEARANCEAREADELEGATE_HXX
