//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Clr0AppearanceBlock
    Filename:   Clr0AppearanceBlock.hxx
    Module:     Clr0colorappearance
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CLR0COLORAPPEARANCE__CLR0APPEARANCEBLOCK__HXX
#define CLR0COLORAPPEARANCE__CLR0APPEARANCEBLOCK__HXX

#include <string>
#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <Clr0colorappearance/libclr0colorappearance_exports.h>

namespace Clr0ColorAppearance
{
    class Clr0AppearanceBlock;
}
namespace Clr0ColorAppearance
{
    class Clr0AppearanceBlockImpl;
}
namespace Clr0ColorAppearance
{
    class Clr0AppearanceBlockDelegate;
}
namespace Clr0ColorAppearance
{
    class Clr0AppearanceBlockDispatch;
}
namespace Clr0ColorAppearance
{
    class Clr0AppearanceBlockGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CLR0COLORAPPEARANCE_API  Clr0ColorAppearance::Clr0AppearanceBlock
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getClr0GroupName( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setClr0GroupName( const std::string &value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10.1.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setClr0OwningObject( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Clr0AppearanceBlock();

    /**
     * Destructor
     */
    virtual ~Clr0AppearanceBlock();

private:
    //  Getter method for the Implementation Object
    Clr0AppearanceBlockImpl*  getClr0AppearanceBlockImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setClr0AppearanceBlockImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Clr0AppearanceBlockImpl*  m_clr0appearanceblockImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Clr0AppearanceBlock - desc for Clr0AppearanceBlock parameter
     */
    Clr0AppearanceBlock( const Clr0AppearanceBlock& );
    Clr0AppearanceBlock& operator=( const Clr0AppearanceBlock& );

    friend class  Clr0AppearanceBlockDelegate;
    friend class  Clr0AppearanceBlockDispatch;
    friend class  Clr0AppearanceBlockGenImpl;
};

#include <Clr0colorappearance/libclr0colorappearance_undef.h>
#endif //   CLR0COLORAPPEARANCE__CLR0APPEARANCEBLOCK__HXX
