//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Clr0AppearanceBlockDelegate
    Filename:   Clr0AppearanceBlockDelegate.hxx
    Module:     Clr0colorappearance
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CLR0COLORAPPEARANCE__CLR0APPEARANCEBLOCKDELEGATE_HXX
#define CLR0COLORAPPEARANCE__CLR0APPEARANCEBLOCKDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Clr0colorappearance/Clr0AppearanceBlock.hxx>

#include <Clr0colorappearance/libclr0colorappearance_exports.h>

namespace Clr0ColorAppearance
{
    class Clr0AppearanceBlockDelegate;
}
namespace Clr0ColorAppearance
{
    class Clr0AppearanceBlockImpl;
}
namespace Clr0ColorAppearance
{
    class Clr0AppearanceBlock;
}
namespace Clr0ColorAppearance
{
    class Clr0AppearanceBlockGenImpl;
}

namespace Clr0ColorAppearance_alias = ::Clr0ColorAppearance;


class  CLR0COLORAPPEARANCE_API Clr0ColorAppearance_alias::Clr0AppearanceBlockDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Clr0AppearanceBlockDelegate instance
    static Clr0AppearanceBlockDelegate&  getInstance();

    //  Method to create the Clr0AppearanceBlockImpl pointer
    static Clr0AppearanceBlockImpl*  createImpl( Clr0AppearanceBlock&  ifObj );

    //  Method to delete the Clr0AppearanceBlockImpl pointer
    static void deleteImpl( Clr0AppearanceBlockImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getClr0GroupNameBase(const Clr0AppearanceBlock &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setClr0GroupNameBase(Clr0AppearanceBlock &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10.1.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setClr0OwningObjectBase(Clr0AppearanceBlock &ifObj,  const tag_t &value, bool isNull );



protected:
    //  Pointer to the instance
    static Clr0AppearanceBlockDelegate*  m_pInstance;

    Clr0AppearanceBlockDelegate();
    virtual ~Clr0AppearanceBlockDelegate();
    static void setInstance( Clr0AppearanceBlockDelegate*  instance );


private:
    friend class  ::Clr0ColorAppearance::Clr0AppearanceBlockGenImpl;

};

#include <Clr0colorappearance/libclr0colorappearance_undef.h>
#endif  //  CLR0COLORAPPEARANCE__CLR0APPEARANCEBLOCKDELEGATE_HXX
