//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Clr0AppearanceDesignator
    Filename:   Clr0AppearanceDesignator.hxx
    Module:     Clr0colorappearance
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CLR0COLORAPPEARANCE__CLR0APPEARANCEDESIGNATOR__HXX
#define CLR0COLORAPPEARANCE__CLR0APPEARANCEDESIGNATOR__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <Clr0colorappearance/libclr0colorappearance_exports.h>

namespace Clr0ColorAppearance
{
    class Clr0AppearanceDesignator;
}
namespace Clr0ColorAppearance
{
    class Clr0AppearanceDesignatorImpl;
}
namespace Clr0ColorAppearance
{
    class Clr0AppearanceDesignatorDelegate;
}
namespace Clr0ColorAppearance
{
    class Clr0AppearanceDesignatorDispatch;
}
namespace Clr0ColorAppearance
{
    class Clr0AppearanceDesignatorGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CLR0COLORAPPEARANCE_API  Clr0ColorAppearance::Clr0AppearanceDesignator
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getClr0ParentAppArea( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.6
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setClr0PABRoot( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Clr0AppearanceDesignator();

    /**
     * Destructor
     */
    virtual ~Clr0AppearanceDesignator();

private:
    //  Getter method for the Implementation Object
    Clr0AppearanceDesignatorImpl*  getClr0AppearanceDesignatorImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setClr0AppearanceDesignatorImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Clr0AppearanceDesignatorImpl*  m_clr0appearancedesignatorImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Clr0AppearanceDesignator - desc for Clr0AppearanceDesignator parameter
     */
    Clr0AppearanceDesignator( const Clr0AppearanceDesignator& );
    Clr0AppearanceDesignator& operator=( const Clr0AppearanceDesignator& );

    friend class  Clr0AppearanceDesignatorDelegate;
    friend class  Clr0AppearanceDesignatorDispatch;
    friend class  Clr0AppearanceDesignatorGenImpl;
};

#include <Clr0colorappearance/libclr0colorappearance_undef.h>
#endif //   CLR0COLORAPPEARANCE__CLR0APPEARANCEDESIGNATOR__HXX
