//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Clr0DesignatorAssignments
    Filename:   Clr0DesignatorAssignments.hxx
    Module:     Clr0colorappearance
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CLR0COLORAPPEARANCE__CLR0DESIGNATORASSIGNMENTS__HXX
#define CLR0COLORAPPEARANCE__CLR0DESIGNATORASSIGNMENTS__HXX

#include <vector>
#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <ae/Dataset.hxx>

#include <Clr0colorappearance/libclr0colorappearance_exports.h>

namespace Clr0ColorAppearance
{
    class Clr0DesignatorAssignments;
}
namespace Clr0ColorAppearance
{
    class Clr0DesignatorAssignmentsImpl;
}
namespace Clr0ColorAppearance
{
    class Clr0DesignatorAssignmentsDelegate;
}
namespace Clr0ColorAppearance
{
    class Clr0DesignatorAssignmentsDispatch;
}
namespace Clr0ColorAppearance
{
    class Clr0DesignatorAssignmentsGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CLR0COLORAPPEARANCE_API  Clr0ColorAppearance::Clr0DesignatorAssignments
     : public  ::Teamcenter::Dataset
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 11.6
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setClr0AssignedDesignators( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.6
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setClr0PABRoot( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Clr0DesignatorAssignments();

    /**
     * Destructor
     */
    virtual ~Clr0DesignatorAssignments();

private:
    //  Getter method for the Implementation Object
    Clr0DesignatorAssignmentsImpl*  getClr0DesignatorAssignmentsImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setClr0DesignatorAssignmentsImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Clr0DesignatorAssignmentsImpl*  m_clr0designatorassignmentsImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Clr0DesignatorAssignments - desc for Clr0DesignatorAssignments parameter
     */
    Clr0DesignatorAssignments( const Clr0DesignatorAssignments& );
    Clr0DesignatorAssignments& operator=( const Clr0DesignatorAssignments& );

    friend class  Clr0DesignatorAssignmentsDelegate;
    friend class  Clr0DesignatorAssignmentsDispatch;
    friend class  Clr0DesignatorAssignmentsGenImpl;
};

#include <Clr0colorappearance/libclr0colorappearance_undef.h>
#endif //   CLR0COLORAPPEARANCE__CLR0DESIGNATORASSIGNMENTS__HXX
