//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Clr0ProductAppBreakdown
    Filename:   Clr0ProductAppBreakdown.hxx
    Module:     Clr0colorappearance
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CLR0COLORAPPEARANCE__CLR0PRODUCTAPPBREAKDOWN__HXX
#define CLR0COLORAPPEARANCE__CLR0PRODUCTAPPBREAKDOWN__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <Clr0colorappearance/libclr0colorappearance_exports.h>

namespace Clr0ColorAppearance
{
    class Clr0ProductAppBreakdown;
}
namespace Clr0ColorAppearance
{
    class Clr0ProductAppBreakdownImpl;
}
namespace Clr0ColorAppearance
{
    class Clr0ProductAppBreakdownDelegate;
}
namespace Clr0ColorAppearance
{
    class Clr0ProductAppBreakdownDispatch;
}
namespace Clr0ColorAppearance
{
    class Clr0ProductAppBreakdownGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CLR0COLORAPPEARANCE_API  Clr0ColorAppearance::Clr0ProductAppBreakdown
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 11.6
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setClr0ChildAppAreaBreakdown( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Clr0ProductAppBreakdown();

    /**
     * Destructor
     */
    virtual ~Clr0ProductAppBreakdown();

private:
    //  Getter method for the Implementation Object
    Clr0ProductAppBreakdownImpl*  getClr0ProductAppBreakdownImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setClr0ProductAppBreakdownImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Clr0ProductAppBreakdownImpl*  m_clr0productappbreakdownImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Clr0ProductAppBreakdown - desc for Clr0ProductAppBreakdown parameter
     */
    Clr0ProductAppBreakdown( const Clr0ProductAppBreakdown& );
    Clr0ProductAppBreakdown& operator=( const Clr0ProductAppBreakdown& );

    friend class  Clr0ProductAppBreakdownDelegate;
    friend class  Clr0ProductAppBreakdownDispatch;
    friend class  Clr0ProductAppBreakdownGenImpl;
};

#include <Clr0colorappearance/libclr0colorappearance_undef.h>
#endif //   CLR0COLORAPPEARANCE__CLR0PRODUCTAPPBREAKDOWN__HXX
