//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Clr1AbsColorRule
    Filename:   Clr1AbsColorRule.hxx
    Module:     Clr1colorrule
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CLR1COLORRULE__CLR1ABSCOLORRULE__HXX
#define CLR1COLORRULE__CLR1ABSCOLORRULE__HXX

#include <metaframework/ReviseInput.hxx>
#include <metaframework/DeepCopyData.hxx>
#include <unidefs.h>
#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <Clr1colorrule/libclr1colorrule_exports.h>

namespace Clr1ColorRule
{
    class Clr1AbsColorRule;
}
namespace Clr1ColorRule
{
    class Clr1AbsColorRuleImpl;
}
namespace Clr1ColorRule
{
    class Clr1AbsColorRuleDelegate;
}
namespace Clr1ColorRule
{
    class Clr1AbsColorRuleDispatch;
}
namespace Clr1ColorRule
{
    class Clr1AbsColorRuleGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CLR1COLORRULE_API  Clr1ColorRule::Clr1AbsColorRule
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getClr1GroupName( std::string &value, bool &isNull ) const;

    ///
    /// Finalize Revise Input Operation
    /// @version Teamcenter 11.3
    /// @param pReviseInput - Revise input
    /// @param vecDeepCopyData - Deep Copy Data Vector
    /// @return - Failure Code
    ///
    int  finalizeReviseInput( ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );

    ///
    /// Clr1AbsColorRule Revise Operation
    /// @version Teamcenter 11.3
    /// @param pReviseInput - Revise Input
    /// @param vecDeepCopyData - Deep Copy Data Vactor
    /// @param newObjTag - New Object tag
    /// @return - Failure Code
    ///
    int  revise( ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData, tag_t *newObjTag );

    ///
    /// Reivse post operation
    /// @version Teamcenter 11.3
    /// @param pReviseInput - Revise Input Descriptor
    /// @param vecDeepCopyData - Deep Copy Data Vector
    /// @return - Failure Code
    ///
    int  revisePost( ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );

    ///
    /// Set properties from revise input Operation
    /// @version Teamcenter 11.3
    /// @param pReviseInput - Revise Input Descriptor
    /// @return - Failure code
    ///
    int  setPropertiesFromReviseInput( ::Teamcenter::ReviseInput *pReviseInput );

    ///
    /// Validate Revise Input Operation
    /// @version Teamcenter 11.3
    /// @param pReviseInput - Revise Input Descriptor
    /// @param vecDeepCopyData - Deep Copy Data Vector
    /// @return - Failure Code
    ///
    int  validateReviseInput( ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Clr1AbsColorRule();

    /**
     * Destructor
     */
    virtual ~Clr1AbsColorRule();

private:
    //  Getter method for the Implementation Object
    Clr1AbsColorRuleImpl*  getClr1AbsColorRuleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setClr1AbsColorRuleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Clr1AbsColorRuleImpl*  m_clr1abscolorruleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Clr1AbsColorRule - desc for Clr1AbsColorRule parameter
     */
    Clr1AbsColorRule( const Clr1AbsColorRule& );
    Clr1AbsColorRule& operator=( const Clr1AbsColorRule& );

    friend class  Clr1AbsColorRuleDelegate;
    friend class  Clr1AbsColorRuleDispatch;
    friend class  Clr1AbsColorRuleGenImpl;
};

#include <Clr1colorrule/libclr1colorrule_undef.h>
#endif //   CLR1COLORRULE__CLR1ABSCOLORRULE__HXX
