//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Clr1AbsColorRuleDelegate
    Filename:   Clr1AbsColorRuleDelegate.hxx
    Module:     Clr1colorrule
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CLR1COLORRULE__CLR1ABSCOLORRULEDELEGATE_HXX
#define CLR1COLORRULE__CLR1ABSCOLORRULEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Clr1colorrule/Clr1AbsColorRule.hxx>

#include <Clr1colorrule/libclr1colorrule_exports.h>

namespace Clr1ColorRule
{
    class Clr1AbsColorRuleDelegate;
}
namespace Clr1ColorRule
{
    class Clr1AbsColorRuleImpl;
}
namespace Clr1ColorRule
{
    class Clr1AbsColorRule;
}
namespace Clr1ColorRule
{
    class Clr1AbsColorRuleGenImpl;
}

namespace Clr1ColorRule_alias = ::Clr1ColorRule;


class  CLR1COLORRULE_API Clr1ColorRule_alias::Clr1AbsColorRuleDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Clr1AbsColorRuleDelegate instance
    static Clr1AbsColorRuleDelegate&  getInstance();

    //  Method to create the Clr1AbsColorRuleImpl pointer
    static Clr1AbsColorRuleImpl*  createImpl( Clr1AbsColorRule&  ifObj );

    //  Method to delete the Clr1AbsColorRuleImpl pointer
    static void deleteImpl( Clr1AbsColorRuleImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getClr1GroupNameBase(const Clr1AbsColorRule &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Finalize Revise Input Operation
    /// @version Teamcenter 11.3
    /// @param pReviseInput - Revise input
    /// @param vecDeepCopyData - Deep Copy Data Vector
    /// @return - Failure Code
    ///
    int  finalizeReviseInputBase(const Clr1AbsColorRule &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// Clr1AbsColorRule Revise Operation
    /// @version Teamcenter 11.3
    /// @param pReviseInput - Revise Input
    /// @param vecDeepCopyData - Deep Copy Data Vactor
    /// @param newObjTag - New Object tag
    /// @return - Failure Code
    ///
    int  reviseBase(const Clr1AbsColorRule &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData, tag_t *newObjTag );


    ///
    /// Reivse post operation
    /// @version Teamcenter 11.3
    /// @param pReviseInput - Revise Input Descriptor
    /// @param vecDeepCopyData - Deep Copy Data Vector
    /// @return - Failure Code
    ///
    int  revisePostBase(const Clr1AbsColorRule &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// Set properties from revise input Operation
    /// @version Teamcenter 11.3
    /// @param pReviseInput - Revise Input Descriptor
    /// @return - Failure code
    ///
    int  setPropertiesFromReviseInputBase(const Clr1AbsColorRule &ifObj,  ::Teamcenter::ReviseInput *pReviseInput );


    ///
    /// Validate Revise Input Operation
    /// @version Teamcenter 11.3
    /// @param pReviseInput - Revise Input Descriptor
    /// @param vecDeepCopyData - Deep Copy Data Vector
    /// @return - Failure Code
    ///
    int  validateReviseInputBase(const Clr1AbsColorRule &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Clr1AbsColorRule &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Clr1AbsColorRule &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Clr1AbsColorRuleDelegate*  m_pInstance;

    Clr1AbsColorRuleDelegate();
    virtual ~Clr1AbsColorRuleDelegate();
    static void setInstance( Clr1AbsColorRuleDelegate*  instance );


private:
    friend class  ::Clr1ColorRule::Clr1AbsColorRuleGenImpl;

};

#include <Clr1colorrule/libclr1colorrule_undef.h>
#endif  //  CLR1COLORRULE__CLR1ABSCOLORRULEDELEGATE_HXX
