//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Clr1AbsColorRuleThread
    Filename:   Clr1AbsColorRuleThread.hxx
    Module:     Clr1colorrule
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CLR1COLORRULE__CLR1ABSCOLORRULETHREAD__HXX
#define CLR1COLORRULE__CLR1ABSCOLORRULETHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Fnd0WSOThread.hxx>

#include <Clr1colorrule/libclr1colorrule_exports.h>

namespace Clr1ColorRule
{
    class Clr1AbsColorRuleThread;
}
namespace Clr1ColorRule
{
    class Clr1AbsColorRuleThreadImpl;
}
namespace Clr1ColorRule
{
    class Clr1AbsColorRuleThreadDelegate;
}
namespace Clr1ColorRule
{
    class Clr1AbsColorRuleThreadDispatch;
}
namespace Clr1ColorRule
{
    class Clr1AbsColorRuleThreadGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CLR1COLORRULE_API  Clr1ColorRule::Clr1AbsColorRuleThread
     : public  ::Teamcenter::Fnd0WSOThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Clr1AbsColorRuleThread();

    /**
     * Destructor
     */
    virtual ~Clr1AbsColorRuleThread();

private:
    //  Getter method for the Implementation Object
    Clr1AbsColorRuleThreadImpl*  getClr1AbsColorRuleThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setClr1AbsColorRuleThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Clr1AbsColorRuleThreadImpl*  m_clr1abscolorrulethreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Clr1AbsColorRuleThread - desc for Clr1AbsColorRuleThread parameter
     */
    Clr1AbsColorRuleThread( const Clr1AbsColorRuleThread& );
    Clr1AbsColorRuleThread& operator=( const Clr1AbsColorRuleThread& );

    friend class  Clr1AbsColorRuleThreadDelegate;
    friend class  Clr1AbsColorRuleThreadDispatch;
    friend class  Clr1AbsColorRuleThreadGenImpl;
};

#include <Clr1colorrule/libclr1colorrule_undef.h>
#endif //   CLR1COLORRULE__CLR1ABSCOLORRULETHREAD__HXX
