//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  Clr1colorrule

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libClr1colorrule

#if !defined(LIBCLR1COLORRULE) && !defined(IPLIB)
#   error IPLIB or LIBCLR1COLORRULE is not defined
#endif

/* Handwritten code should use CLR1COLORRULE_API, not CLR1COLORRULEEXPORT */

#define CLR1COLORRULE_API CLR1COLORRULEEXPORT

#if IPLIB==libClr1colorrule || defined(LIBCLR1COLORRULE)
#   if defined(__lint)
#       define CLR1COLORRULEEXPORT       __export(Clr1colorrule)
#       define CLR1COLORRULEGLOBAL       extern __global(Clr1colorrule)
#       define CLR1COLORRULEPRIVATE      extern __private(Clr1colorrule)
#   elif defined(_WIN32)
#       define CLR1COLORRULEEXPORT       __declspec(dllexport)
#       define CLR1COLORRULEGLOBAL       extern __declspec(dllexport)
#       define CLR1COLORRULEPRIVATE      extern
#   else
#       define CLR1COLORRULEEXPORT
#       define CLR1COLORRULEGLOBAL       extern
#       define CLR1COLORRULEPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CLR1COLORRULEEXPORT       __export(Clr1colorrule)
#       define CLR1COLORRULEGLOBAL       extern __global(Clr1colorrule)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CLR1COLORRULEEXPORT      __declspec(dllimport)
#       define CLR1COLORRULEGLOBAL       extern __declspec(dllimport)
#   else
#       define CLR1COLORRULEEXPORT
#       define CLR1COLORRULEGLOBAL       extern
#   endif
#endif
