//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cls0ClassificationScheme
    Filename:   Cls0ClassificationScheme.hxx
    Module:     Cls0classification
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CLASSIFICATION__CLS0CLASSIFICATIONSCHEME__HXX
#define TEAMCENTER__CLASSIFICATION__CLS0CLASSIFICATIONSCHEME__HXX

#include <common/tc_deprecation_macros.h>
#include <ptn0partition/Ptn0PartitionScheme.hxx>

#include <Cls0classification/libcls0classification_exports.h>

namespace Teamcenter
{
    namespace Classification
    {
        class Cls0ClassificationScheme;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0ClassificationSchemeImpl;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0ClassificationSchemeDelegate;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0ClassificationSchemeDispatch;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0ClassificationSchemeGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CLS0CLASSIFICATION_API  Teamcenter::Classification::Cls0ClassificationScheme
     : public  ::Teamcenter::Partition::Ptn0PartitionScheme
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cls0ClassificationScheme();

    /**
     * Destructor
     */
    virtual ~Cls0ClassificationScheme();

private:
    //  Getter method for the Implementation Object
    Cls0ClassificationSchemeImpl*  getCls0ClassificationSchemeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCls0ClassificationSchemeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cls0ClassificationSchemeImpl*  m_cls0classificationschemeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cls0ClassificationScheme - desc for Cls0ClassificationScheme parameter
     */
    Cls0ClassificationScheme( const Cls0ClassificationScheme& );
    Cls0ClassificationScheme& operator=( const Cls0ClassificationScheme& );

    friend class  Cls0ClassificationSchemeDelegate;
    friend class  Cls0ClassificationSchemeDispatch;
    friend class  Cls0ClassificationSchemeGenImpl;
};

#include <Cls0classification/libcls0classification_undef.h>
#endif //   TEAMCENTER__CLASSIFICATION__CLS0CLASSIFICATIONSCHEME__HXX
