//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cls0ClassificationSchemeDelegate
    Filename:   Cls0ClassificationSchemeDelegate.hxx
    Module:     Cls0classification
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CLASSIFICATION__CLS0CLASSIFICATIONSCHEMEDELEGATE_HXX
#define TEAMCENTER__CLASSIFICATION__CLS0CLASSIFICATIONSCHEMEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Cls0classification/Cls0ClassificationScheme.hxx>

#include <Cls0classification/libcls0classification_exports.h>

namespace Teamcenter
{
    namespace Classification
    {
        class Cls0ClassificationSchemeDelegate;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0ClassificationSchemeImpl;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0ClassificationScheme;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0ClassificationSchemeGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CLS0CLASSIFICATION_API Teamcenter_alias::Classification::Cls0ClassificationSchemeDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cls0ClassificationSchemeDelegate instance
    static Cls0ClassificationSchemeDelegate&  getInstance();

    //  Method to create the Cls0ClassificationSchemeImpl pointer
    static Cls0ClassificationSchemeImpl*  createImpl( Cls0ClassificationScheme&  ifObj );

    //  Method to delete the Cls0ClassificationSchemeImpl pointer
    static void deleteImpl( Cls0ClassificationSchemeImpl*  impl );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Cls0ClassificationScheme &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Cls0ClassificationScheme &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// finalize operation input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  finalizeSaveAsInputBase(const Cls0ClassificationScheme &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Cls0ClassificationScheme &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Cls0ClassificationSchemeDelegate*  m_pInstance;

    Cls0ClassificationSchemeDelegate();
    virtual ~Cls0ClassificationSchemeDelegate();
    static void setInstance( Cls0ClassificationSchemeDelegate*  instance );


private:
    friend class  ::Teamcenter::Classification::Cls0ClassificationSchemeGenImpl;

};

#include <Cls0classification/libcls0classification_undef.h>
#endif  //  TEAMCENTER__CLASSIFICATION__CLS0CLASSIFICATIONSCHEMEDELEGATE_HXX
