//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cls0Context
    Filename:   Cls0Context.hxx
    Module:     Cls0classification
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CLASSIFICATION__CLS0CONTEXT__HXX
#define TEAMCENTER__CLASSIFICATION__CLS0CONTEXT__HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0ApplicationModel.hxx>

#include <Cls0classification/libcls0classification_exports.h>

namespace Teamcenter
{
    namespace Classification
    {
        class Cls0Context;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0ContextImpl;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0ContextDelegate;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0ContextDispatch;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0ContextGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CLS0CLASSIFICATION_API  Teamcenter::Classification::Cls0Context
     : public  ::Teamcenter::AppModel::Mdl0ApplicationModel
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cls0Context();

    /**
     * Destructor
     */
    virtual ~Cls0Context();

private:
    //  Getter method for the Implementation Object
    Cls0ContextImpl*  getCls0ContextImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCls0ContextImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cls0ContextImpl*  m_cls0contextImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cls0Context - desc for Cls0Context parameter
     */
    Cls0Context( const Cls0Context& );
    Cls0Context& operator=( const Cls0Context& );

    friend class  Cls0ContextDelegate;
    friend class  Cls0ContextDispatch;
    friend class  Cls0ContextGenImpl;
};

#include <Cls0classification/libcls0classification_undef.h>
#endif //   TEAMCENTER__CLASSIFICATION__CLS0CONTEXT__HXX
