//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cls0CstObject
    Filename:   Cls0CstObject.hxx
    Module:     Cls0classification
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CLASSIFICATION__CLS0CSTOBJECT__HXX
#define TEAMCENTER__CLASSIFICATION__CLS0CSTOBJECT__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <Cls0classification/Cls0ClassBase.hxx>

#include <Cls0classification/libcls0classification_exports.h>

namespace Teamcenter
{
    namespace Classification
    {
        class Cls0CstObject;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0CstObjectImpl;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0CstObjectDelegate;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0CstObjectDispatch;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0CstObjectGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CLS0CLASSIFICATION_API  Teamcenter::Classification::Cls0CstObject
     : public  ::Teamcenter::Classification::Cls0ClassBase
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCls0CstProperties( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCls0CstProperties( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cls0CstObject();

    /**
     * Destructor
     */
    virtual ~Cls0CstObject();

private:
    //  Getter method for the Implementation Object
    Cls0CstObjectImpl*  getCls0CstObjectImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCls0CstObjectImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cls0CstObjectImpl*  m_cls0cstobjectImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cls0CstObject - desc for Cls0CstObject parameter
     */
    Cls0CstObject( const Cls0CstObject& );
    Cls0CstObject& operator=( const Cls0CstObject& );

    friend class  Cls0CstObjectDelegate;
    friend class  Cls0CstObjectDispatch;
    friend class  Cls0CstObjectGenImpl;
};

#include <Cls0classification/libcls0classification_undef.h>
#endif //   TEAMCENTER__CLASSIFICATION__CLS0CSTOBJECT__HXX
