//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cls0CstObjectDelegate
    Filename:   Cls0CstObjectDelegate.hxx
    Module:     Cls0classification
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CLASSIFICATION__CLS0CSTOBJECTDELEGATE_HXX
#define TEAMCENTER__CLASSIFICATION__CLS0CSTOBJECTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Cls0classification/Cls0CstObject.hxx>

#include <Cls0classification/libcls0classification_exports.h>

namespace Teamcenter
{
    namespace Classification
    {
        class Cls0CstObjectDelegate;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0CstObjectImpl;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0CstObject;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0CstObjectGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CLS0CLASSIFICATION_API Teamcenter_alias::Classification::Cls0CstObjectDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cls0CstObjectDelegate instance
    static Cls0CstObjectDelegate&  getInstance();

    //  Method to create the Cls0CstObjectImpl pointer
    static Cls0CstObjectImpl*  createImpl( Cls0CstObject&  ifObj );

    //  Method to delete the Cls0CstObjectImpl pointer
    static void deleteImpl( Cls0CstObjectImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCls0CstPropertiesBase(const Cls0CstObject &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCls0CstPropertiesBase(Cls0CstObject &ifObj,  const std::string &value, bool isNull );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Cls0CstObject &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be created
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0FinalizeCreateInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static Cls0CstObjectDelegate*  m_pInstance;

    Cls0CstObjectDelegate();
    virtual ~Cls0CstObjectDelegate();
    static void setInstance( Cls0CstObjectDelegate*  instance );


private:
    friend class  ::Teamcenter::Classification::Cls0CstObjectGenImpl;

};

#include <Cls0classification/libcls0classification_undef.h>
#endif  //  TEAMCENTER__CLASSIFICATION__CLS0CSTOBJECTDELEGATE_HXX
