//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cls0GroupNode
    Filename:   Cls0GroupNode.hxx
    Module:     Cls0classification
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CLASSIFICATION__CLS0GROUPNODE__HXX
#define TEAMCENTER__CLASSIFICATION__CLS0GROUPNODE__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <Cls0classification/Cls0HierarchyNode.hxx>

#include <Cls0classification/libcls0classification_exports.h>

namespace Teamcenter
{
    namespace Classification
    {
        class Cls0GroupNode;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0GroupNodeImpl;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0GroupNodeDelegate;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0GroupNodeDispatch;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0GroupNodeGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CLS0CLASSIFICATION_API  Teamcenter::Classification::Cls0GroupNode
     : public  ::Teamcenter::Classification::Cls0HierarchyNode
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 12.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCls0HierarchyPosition( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 12.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCls0HierarchyPosition( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cls0GroupNode();

    /**
     * Destructor
     */
    virtual ~Cls0GroupNode();

private:
    //  Getter method for the Implementation Object
    Cls0GroupNodeImpl*  getCls0GroupNodeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCls0GroupNodeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cls0GroupNodeImpl*  m_cls0groupnodeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cls0GroupNode - desc for Cls0GroupNode parameter
     */
    Cls0GroupNode( const Cls0GroupNode& );
    Cls0GroupNode& operator=( const Cls0GroupNode& );

    friend class  Cls0GroupNodeDelegate;
    friend class  Cls0GroupNodeDispatch;
    friend class  Cls0GroupNodeGenImpl;
};

#include <Cls0classification/libcls0classification_undef.h>
#endif //   TEAMCENTER__CLASSIFICATION__CLS0GROUPNODE__HXX
