//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cls0HierarchyNodeDelegate
    Filename:   Cls0HierarchyNodeDelegate.hxx
    Module:     Cls0classification
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CLASSIFICATION__CLS0HIERARCHYNODEDELEGATE_HXX
#define TEAMCENTER__CLASSIFICATION__CLS0HIERARCHYNODEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Cls0classification/Cls0HierarchyNode.hxx>

#include <Cls0classification/libcls0classification_exports.h>

namespace Teamcenter
{
    namespace Classification
    {
        class Cls0HierarchyNodeDelegate;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0HierarchyNodeImpl;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0HierarchyNode;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0HierarchyNodeGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CLS0CLASSIFICATION_API Teamcenter_alias::Classification::Cls0HierarchyNodeDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cls0HierarchyNodeDelegate instance
    static Cls0HierarchyNodeDelegate&  getInstance();

    //  Method to create the Cls0HierarchyNodeImpl pointer
    static Cls0HierarchyNodeImpl*  createImpl( Cls0HierarchyNode&  ifObj );

    //  Method to delete the Cls0HierarchyNodeImpl pointer
    static void deleteImpl( Cls0HierarchyNodeImpl*  impl );


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 10
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCls0ancestorsBase(const Cls0HierarchyNode &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCls0child_countBase(const Cls0HierarchyNode &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCls0classify_in_replicaBase(const Cls0HierarchyNode &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCls0filter_by_read_accessBase(const Cls0HierarchyNode &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCls0hierarchy_viewBase(const Cls0HierarchyNode &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCls0iconBase(const Cls0HierarchyNode &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCls0imageBase(const Cls0HierarchyNode &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCls0instance_countBase(const Cls0HierarchyNode &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCls0is_abstractBase(const Cls0HierarchyNode &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCls0is_assemblyBase(const Cls0HierarchyNode &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCls0is_leaf_nodeBase(const Cls0HierarchyNode &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCls0level_sort_indexBase(const Cls0HierarchyNode &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCls0multiple_classificationBase(const Cls0HierarchyNode &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 10
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setCls0ancestorsBase(Cls0HierarchyNode &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCls0hierarchy_viewBase(Cls0HierarchyNode &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCls0is_leaf_nodeBase(Cls0HierarchyNode &ifObj,  bool value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCls0level_sort_indexBase(Cls0HierarchyNode &ifObj,  int value, bool isNull );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Cls0HierarchyNode &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Cls0HierarchyNode &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Finalize operation input.
    /// @version Teamcenter 10.1
    /// @param pReviseInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns n int.
    ///
    int  finalizeReviseInputBase(const Cls0HierarchyNode &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// finalize operation input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  finalizeSaveAsInputBase(const Cls0HierarchyNode &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0CreatePostBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be created
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0FinalizeCreateInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation returns the children to be displayed when expanding this object.
    /// @version Teamcenter 10
    /// @param propertyNames - The list of propertyNames to expand.  If empty, then the properties defined in <TYPE>_DefaultChildProperties and <TYPE>_DefaultPseudoFolder are returned.
    /// @param childTags - Tags of children.
    /// @param childContextPropertyNames - The propertyName in which this child exists in the parent.
    /// @return - status
    ///
    int  fnd0GetChildrenBase(const Cls0HierarchyNode &ifObj,  const std::vector< std::string > *propertyNames, std::vector< tag_t > *childTags, std::vector< std::string > *childContextPropertyNames );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be created
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0ValidateCreateInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// similar to finalizeSaveAsInputBase, this method allows for final changes to the revise descriptor before actually performing the revise
    /// @version Teamcenter 9
    /// @param pSavAsInput - saveAs input
    /// @param vecDeepCopyData - vector of deep copy data for revise
    /// @deprecated #Teamcenter::AppModel::Mdl0ConditionalElement::mdl0finalizeReviseInput deprecated in Teamcenter 11.2
    /// @return - SaveAsInput is updated
    ///
    TC_DEPRECATED_WITH_DEPRECATION_INFO("Teamcenter 11.2","Teamcenter::AppModel::Mdl0ConditionalElement::mdl0finalizeReviseInput","This operation is deprecated in Teamcenter 11.2 and will be removed in Teamcenter 13. Please use finalizeReviseInput operation instead.")
    int  mdl0finalizeReviseInputBase(const Cls0HierarchyNode &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// save as operation
    /// @version Teamcenter 9
    /// @param pSavAsInput - save as input
    /// @param vecDeepCopyData - vector deepcopy data
    /// @param newObjTag - new object tag
    /// @return - returns an int
    ///
    int  saveAsBase(const Cls0HierarchyNode &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData, tag_t *newObjTag );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Cls0HierarchyNode &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Cls0HierarchyNodeDelegate*  m_pInstance;

    Cls0HierarchyNodeDelegate();
    virtual ~Cls0HierarchyNodeDelegate();
    static void setInstance( Cls0HierarchyNodeDelegate*  instance );


private:
    friend class  ::Teamcenter::Classification::Cls0HierarchyNodeGenImpl;

};

#include <Cls0classification/libcls0classification_undef.h>
#endif  //  TEAMCENTER__CLASSIFICATION__CLS0HIERARCHYNODEDELEGATE_HXX
