//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cls0HierarchyView
    Filename:   Cls0HierarchyView.hxx
    Module:     Cls0classification
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CLASSIFICATION__CLS0HIERARCHYVIEW__HXX
#define TEAMCENTER__CLASSIFICATION__CLS0HIERARCHYVIEW__HXX

#include <common/tc_deprecation_macros.h>
#include <ptn0partition/Ptn0Partition.hxx>

#include <Cls0classification/libcls0classification_exports.h>

namespace Teamcenter
{
    namespace Classification
    {
        class Cls0HierarchyView;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0HierarchyViewImpl;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0HierarchyViewDelegate;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0HierarchyViewDispatch;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0HierarchyViewGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CLS0CLASSIFICATION_API  Teamcenter::Classification::Cls0HierarchyView
     : public  ::Teamcenter::Partition::Ptn0Partition
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cls0HierarchyView();

    /**
     * Destructor
     */
    virtual ~Cls0HierarchyView();

private:
    //  Getter method for the Implementation Object
    Cls0HierarchyViewImpl*  getCls0HierarchyViewImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCls0HierarchyViewImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cls0HierarchyViewImpl*  m_cls0hierarchyviewImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cls0HierarchyView - desc for Cls0HierarchyView parameter
     */
    Cls0HierarchyView( const Cls0HierarchyView& );
    Cls0HierarchyView& operator=( const Cls0HierarchyView& );

    friend class  Cls0HierarchyViewDelegate;
    friend class  Cls0HierarchyViewDispatch;
    friend class  Cls0HierarchyViewGenImpl;
};

#include <Cls0classification/libcls0classification_undef.h>
#endif //   TEAMCENTER__CLASSIFICATION__CLS0HIERARCHYVIEW__HXX
