//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cls0HierarchyViewDelegate
    Filename:   Cls0HierarchyViewDelegate.hxx
    Module:     Cls0classification
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CLASSIFICATION__CLS0HIERARCHYVIEWDELEGATE_HXX
#define TEAMCENTER__CLASSIFICATION__CLS0HIERARCHYVIEWDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Cls0classification/Cls0HierarchyView.hxx>

#include <Cls0classification/libcls0classification_exports.h>

namespace Teamcenter
{
    namespace Classification
    {
        class Cls0HierarchyViewDelegate;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0HierarchyViewImpl;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0HierarchyView;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0HierarchyViewGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CLS0CLASSIFICATION_API Teamcenter_alias::Classification::Cls0HierarchyViewDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cls0HierarchyViewDelegate instance
    static Cls0HierarchyViewDelegate&  getInstance();

    //  Method to create the Cls0HierarchyViewImpl pointer
    static Cls0HierarchyViewImpl*  createImpl( Cls0HierarchyView&  ifObj );

    //  Method to delete the Cls0HierarchyViewImpl pointer
    static void deleteImpl( Cls0HierarchyViewImpl*  impl );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Cls0HierarchyView &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Cls0HierarchyView &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Finalize operation input.
    /// @version Teamcenter 10.1
    /// @param pReviseInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns n int.
    ///
    int  finalizeReviseInputBase(const Cls0HierarchyView &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// finalize operation input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  finalizeSaveAsInputBase(const Cls0HierarchyView &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// This operation returns the children to be displayed when expanding this object.
    /// @version Teamcenter 10
    /// @param propertyNames - The list of propertyNames to expand.  If empty, then the properties defined in <TYPE>_DefaultChildProperties and <TYPE>_DefaultPseudoFolder are returned.
    /// @param childTags - Tags of children.
    /// @param childContextPropertyNames - The propertyName in which this child exists in the parent.
    /// @return - status
    ///
    int  fnd0GetChildrenBase(const Cls0HierarchyView &ifObj,  const std::vector< std::string > *propertyNames, std::vector< tag_t > *childTags, std::vector< std::string > *childContextPropertyNames );


    ///
    /// similar to finalizeSaveAsInputBase, this method allows for final changes to the revise descriptor before actually performing the revise
    /// @version Teamcenter 9
    /// @param pSavAsInput - saveAs input
    /// @param vecDeepCopyData - vector of deep copy data for revise
    /// @deprecated #Teamcenter::AppModel::Mdl0ConditionalElement::mdl0finalizeReviseInput deprecated in Teamcenter 11.2
    /// @return - SaveAsInput is updated
    ///
    TC_DEPRECATED_WITH_DEPRECATION_INFO("Teamcenter 11.2","Teamcenter::AppModel::Mdl0ConditionalElement::mdl0finalizeReviseInput","This operation is deprecated in Teamcenter 11.2 and will be removed in Teamcenter 13. Please use finalizeReviseInput operation instead.")
    int  mdl0finalizeReviseInputBase(const Cls0HierarchyView &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Cls0HierarchyView &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Cls0HierarchyViewDelegate*  m_pInstance;

    Cls0HierarchyViewDelegate();
    virtual ~Cls0HierarchyViewDelegate();
    static void setInstance( Cls0HierarchyViewDelegate*  instance );


private:
    friend class  ::Teamcenter::Classification::Cls0HierarchyViewGenImpl;

};

#include <Cls0classification/libcls0classification_undef.h>
#endif  //  TEAMCENTER__CLASSIFICATION__CLS0HIERARCHYVIEWDELEGATE_HXX
