//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cls0MasterNode
    Filename:   Cls0MasterNode.hxx
    Module:     Cls0classification
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CLASSIFICATION__CLS0MASTERNODE__HXX
#define TEAMCENTER__CLASSIFICATION__CLS0MASTERNODE__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <Cls0classification/Cls0HierarchyNode.hxx>

#include <Cls0classification/libcls0classification_exports.h>

namespace Teamcenter
{
    namespace Classification
    {
        class Cls0MasterNode;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0MasterNodeImpl;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0MasterNodeDelegate;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0MasterNodeDispatch;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0MasterNodeGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CLS0CLASSIFICATION_API  Teamcenter::Classification::Cls0MasterNode
     : public  ::Teamcenter::Classification::Cls0HierarchyNode
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCls0class_type_name( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCls0class_type_name( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cls0MasterNode();

    /**
     * Destructor
     */
    virtual ~Cls0MasterNode();

private:
    //  Getter method for the Implementation Object
    Cls0MasterNodeImpl*  getCls0MasterNodeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCls0MasterNodeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cls0MasterNodeImpl*  m_cls0masternodeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cls0MasterNode - desc for Cls0MasterNode parameter
     */
    Cls0MasterNode( const Cls0MasterNode& );
    Cls0MasterNode& operator=( const Cls0MasterNode& );

    friend class  Cls0MasterNodeDelegate;
    friend class  Cls0MasterNodeDispatch;
    friend class  Cls0MasterNodeGenImpl;
};

#include <Cls0classification/libcls0classification_undef.h>
#endif //   TEAMCENTER__CLASSIFICATION__CLS0MASTERNODE__HXX
