//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cls0NodeImage
    Filename:   Cls0NodeImage.hxx
    Module:     Cls0classification
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CLASSIFICATION__CLS0NODEIMAGE__HXX
#define TEAMCENTER__CLASSIFICATION__CLS0NODEIMAGE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <Cls0classification/libcls0classification_exports.h>

namespace Teamcenter
{
    namespace Classification
    {
        class Cls0NodeImage;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0NodeImageImpl;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0NodeImageDelegate;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0NodeImageDispatch;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0NodeImageGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CLS0CLASSIFICATION_API  Teamcenter::Classification::Cls0NodeImage
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCls0image_index( int &value, bool &isNull ) const;

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCls0image_index( int value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cls0NodeImage();

    /**
     * Destructor
     */
    virtual ~Cls0NodeImage();

private:
    //  Getter method for the Implementation Object
    Cls0NodeImageImpl*  getCls0NodeImageImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCls0NodeImageImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cls0NodeImageImpl*  m_cls0nodeimageImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cls0NodeImage - desc for Cls0NodeImage parameter
     */
    Cls0NodeImage( const Cls0NodeImage& );
    Cls0NodeImage& operator=( const Cls0NodeImage& );

    friend class  Cls0NodeImageDelegate;
    friend class  Cls0NodeImageDispatch;
    friend class  Cls0NodeImageGenImpl;
};

#include <Cls0classification/libcls0classification_undef.h>
#endif //   TEAMCENTER__CLASSIFICATION__CLS0NODEIMAGE__HXX
