//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cls0NodeImageDelegate
    Filename:   Cls0NodeImageDelegate.hxx
    Module:     Cls0classification
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CLASSIFICATION__CLS0NODEIMAGEDELEGATE_HXX
#define TEAMCENTER__CLASSIFICATION__CLS0NODEIMAGEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Cls0classification/Cls0NodeImage.hxx>

#include <Cls0classification/libcls0classification_exports.h>

namespace Teamcenter
{
    namespace Classification
    {
        class Cls0NodeImageDelegate;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0NodeImageImpl;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0NodeImage;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0NodeImageGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CLS0CLASSIFICATION_API Teamcenter_alias::Classification::Cls0NodeImageDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cls0NodeImageDelegate instance
    static Cls0NodeImageDelegate&  getInstance();

    //  Method to create the Cls0NodeImageImpl pointer
    static Cls0NodeImageImpl*  createImpl( Cls0NodeImage&  ifObj );

    //  Method to delete the Cls0NodeImageImpl pointer
    static void deleteImpl( Cls0NodeImageImpl*  impl );


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCls0image_indexBase(const Cls0NodeImage &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCls0image_indexBase(Cls0NodeImage &ifObj,  int value, bool isNull );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Cls0NodeImage &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Cls0NodeImage &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Cls0NodeImage &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Cls0NodeImageDelegate*  m_pInstance;

    Cls0NodeImageDelegate();
    virtual ~Cls0NodeImageDelegate();
    static void setInstance( Cls0NodeImageDelegate*  instance );


private:
    friend class  ::Teamcenter::Classification::Cls0NodeImageGenImpl;

};

#include <Cls0classification/libcls0classification_undef.h>
#endif  //  TEAMCENTER__CLASSIFICATION__CLS0NODEIMAGEDELEGATE_HXX
