//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cls0Object
    Filename:   Cls0Object.hxx
    Module:     Cls0classification
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CLASSIFICATION__CLS0OBJECT__HXX
#define TEAMCENTER__CLASSIFICATION__CLS0OBJECT__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <Cls0classification/Cls0ClassBase.hxx>

#include <Cls0classification/libcls0classification_exports.h>

namespace Teamcenter
{
    namespace Classification
    {
        class Cls0Object;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0ObjectImpl;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0ObjectDelegate;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0ObjectDispatch;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0ObjectGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CLS0CLASSIFICATION_API  Teamcenter::Classification::Cls0Object
     : public  ::Teamcenter::Classification::Cls0ClassBase
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCls0properties( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCls0properties( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cls0Object();

    /**
     * Destructor
     */
    virtual ~Cls0Object();

private:
    //  Getter method for the Implementation Object
    Cls0ObjectImpl*  getCls0ObjectImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCls0ObjectImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cls0ObjectImpl*  m_cls0objectImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cls0Object - desc for Cls0Object parameter
     */
    Cls0Object( const Cls0Object& );
    Cls0Object& operator=( const Cls0Object& );

    friend class  Cls0ObjectDelegate;
    friend class  Cls0ObjectDispatch;
    friend class  Cls0ObjectGenImpl;
};

#include <Cls0classification/libcls0classification_undef.h>
#endif //   TEAMCENTER__CLASSIFICATION__CLS0OBJECT__HXX
