//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cls0ObjectDelegate
    Filename:   Cls0ObjectDelegate.hxx
    Module:     Cls0classification
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CLASSIFICATION__CLS0OBJECTDELEGATE_HXX
#define TEAMCENTER__CLASSIFICATION__CLS0OBJECTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Cls0classification/Cls0Object.hxx>

#include <Cls0classification/libcls0classification_exports.h>

namespace Teamcenter
{
    namespace Classification
    {
        class Cls0ObjectDelegate;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0ObjectImpl;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0Object;
    }
}
namespace Teamcenter
{
    namespace Classification
    {
        class Cls0ObjectGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CLS0CLASSIFICATION_API Teamcenter_alias::Classification::Cls0ObjectDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cls0ObjectDelegate instance
    static Cls0ObjectDelegate&  getInstance();

    //  Method to create the Cls0ObjectImpl pointer
    static Cls0ObjectImpl*  createImpl( Cls0Object&  ifObj );

    //  Method to delete the Cls0ObjectImpl pointer
    static void deleteImpl( Cls0ObjectImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCls0propertiesBase(const Cls0Object &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCls0propertiesBase(Cls0Object &ifObj,  const tag_t &value, bool isNull );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Cls0Object &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Cls0Object &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0CreatePostBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be created
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0FinalizeCreateInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @param isLockForDelete - A boolean to indicate if object(s) are to be locked for deletion
    /// @param allowRelock - A boolean to indicate if object(s) can be relocked, which will discard all unsaved changes, if already locked by the same user
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0LockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd, const bool isLockForDelete, const bool allowRelock );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0RefreshBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0UnlockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be created
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0ValidateCreateInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Cls0Object &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Cls0ObjectDelegate*  m_pInstance;

    Cls0ObjectDelegate();
    virtual ~Cls0ObjectDelegate();
    static void setInstance( Cls0ObjectDelegate*  instance );


private:
    friend class  ::Teamcenter::Classification::Cls0ObjectGenImpl;

};

#include <Cls0classification/libcls0classification_undef.h>
#endif  //  TEAMCENTER__CLASSIFICATION__CLS0OBJECTDELEGATE_HXX
