//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Crt0AttributeElement
    Filename:   Crt0AttributeElement.hxx
    Module:     Crt0ValidationContract
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CRT0VALIDATIONCONTRACT__CRT0ATTRIBUTEELEMENT__HXX
#define CRT0VALIDATIONCONTRACT__CRT0ATTRIBUTEELEMENT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <Crt0ValidationContract/libcrt0validationcontract_exports.h>

namespace crt0validationcontract
{
    class Crt0AttributeElement;
}
namespace crt0validationcontract
{
    class Crt0AttributeElementImpl;
}
namespace crt0validationcontract
{
    class Crt0AttributeElementDelegate;
}
namespace crt0validationcontract
{
    class Crt0AttributeElementDispatch;
}
namespace crt0validationcontract
{
    class Crt0AttributeElementGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CRT0VALIDATIONCONTRACT_API  crt0validationcontract::Crt0AttributeElement
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Crt0AttributeElement();

    /**
     * Destructor
     */
    virtual ~Crt0AttributeElement();

private:
    //  Getter method for the Implementation Object
    Crt0AttributeElementImpl*  getCrt0AttributeElementImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCrt0AttributeElementImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Crt0AttributeElementImpl*  m_crt0attributeelementImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Crt0AttributeElement - desc for Crt0AttributeElement parameter
     */
    Crt0AttributeElement( const Crt0AttributeElement& );
    Crt0AttributeElement& operator=( const Crt0AttributeElement& );

    friend class  Crt0AttributeElementDelegate;
    friend class  Crt0AttributeElementDispatch;
    friend class  Crt0AttributeElementGenImpl;
};

#include <Crt0ValidationContract/libcrt0validationcontract_undef.h>
#endif //   CRT0VALIDATIONCONTRACT__CRT0ATTRIBUTEELEMENT__HXX
