//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Crt0GDERef
    Filename:   Crt0GDERef.hxx
    Module:     Crt0ValidationContract
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CRT0VALIDATIONCONTRACT__CRT0GDEREF__HXX
#define CRT0VALIDATIONCONTRACT__CRT0GDEREF__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <Crt0ValidationContract/libcrt0validationcontract_exports.h>

namespace crt0validationcontract
{
    class Crt0GDERef;
}
namespace crt0validationcontract
{
    class Crt0GDERefImpl;
}
namespace crt0validationcontract
{
    class Crt0GDERefDelegate;
}
namespace crt0validationcontract
{
    class Crt0GDERefDispatch;
}
namespace crt0validationcontract
{
    class Crt0GDERefGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CRT0VALIDATIONCONTRACT_API  crt0validationcontract::Crt0GDERef
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Crt0GDERef();

    /**
     * Destructor
     */
    virtual ~Crt0GDERef();

private:
    //  Getter method for the Implementation Object
    Crt0GDERefImpl*  getCrt0GDERefImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCrt0GDERefImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Crt0GDERefImpl*  m_crt0gderefImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Crt0GDERef - desc for Crt0GDERef parameter
     */
    Crt0GDERef( const Crt0GDERef& );
    Crt0GDERef& operator=( const Crt0GDERef& );

    friend class  Crt0GDERefDelegate;
    friend class  Crt0GDERefDispatch;
    friend class  Crt0GDERefGenImpl;
};

#include <Crt0ValidationContract/libcrt0validationcontract_undef.h>
#endif //   CRT0VALIDATIONCONTRACT__CRT0GDEREF__HXX
