//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Crt0SimulationEngineer
    Filename:   Crt0SimulationEngineer.hxx
    Module:     Crt0ValidationContract
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CRT0VALIDATIONCONTRACT__CRT0SIMULATIONENGINEER__HXX
#define CRT0VALIDATIONCONTRACT__CRT0SIMULATIONENGINEER__HXX

#include <common/tc_deprecation_macros.h>
#include <epm/Participant.hxx>

#include <Crt0ValidationContract/libcrt0validationcontract_exports.h>

namespace crt0validationcontract
{
    class Crt0SimulationEngineer;
}
namespace crt0validationcontract
{
    class Crt0SimulationEngineerImpl;
}
namespace crt0validationcontract
{
    class Crt0SimulationEngineerDelegate;
}
namespace crt0validationcontract
{
    class Crt0SimulationEngineerDispatch;
}
namespace crt0validationcontract
{
    class Crt0SimulationEngineerGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CRT0VALIDATIONCONTRACT_API  crt0validationcontract::Crt0SimulationEngineer
     : public  ::Teamcenter::Participant
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Crt0SimulationEngineer();

    /**
     * Destructor
     */
    virtual ~Crt0SimulationEngineer();

private:
    //  Getter method for the Implementation Object
    Crt0SimulationEngineerImpl*  getCrt0SimulationEngineerImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCrt0SimulationEngineerImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Crt0SimulationEngineerImpl*  m_crt0simulationengineerImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Crt0SimulationEngineer - desc for Crt0SimulationEngineer parameter
     */
    Crt0SimulationEngineer( const Crt0SimulationEngineer& );
    Crt0SimulationEngineer& operator=( const Crt0SimulationEngineer& );

    friend class  Crt0SimulationEngineerDelegate;
    friend class  Crt0SimulationEngineerDispatch;
    friend class  Crt0SimulationEngineerGenImpl;
};

#include <Crt0ValidationContract/libcrt0validationcontract_undef.h>
#endif //   CRT0VALIDATIONCONTRACT__CRT0SIMULATIONENGINEER__HXX
