//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Crt0SimulationEngineerDelegate
    Filename:   Crt0SimulationEngineerDelegate.hxx
    Module:     Crt0ValidationContract
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CRT0VALIDATIONCONTRACT__CRT0SIMULATIONENGINEERDELEGATE_HXX
#define CRT0VALIDATIONCONTRACT__CRT0SIMULATIONENGINEERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Crt0ValidationContract/Crt0SimulationEngineer.hxx>

#include <Crt0ValidationContract/libcrt0validationcontract_exports.h>

namespace crt0validationcontract
{
    class Crt0SimulationEngineerDelegate;
}
namespace crt0validationcontract
{
    class Crt0SimulationEngineerImpl;
}
namespace crt0validationcontract
{
    class Crt0SimulationEngineer;
}
namespace crt0validationcontract
{
    class Crt0SimulationEngineerGenImpl;
}

namespace crt0validationcontract_alias = ::crt0validationcontract;


class  CRT0VALIDATIONCONTRACT_API crt0validationcontract_alias::Crt0SimulationEngineerDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Crt0SimulationEngineerDelegate instance
    static Crt0SimulationEngineerDelegate&  getInstance();

    //  Method to create the Crt0SimulationEngineerImpl pointer
    static Crt0SimulationEngineerImpl*  createImpl( Crt0SimulationEngineer&  ifObj );

    //  Method to delete the Crt0SimulationEngineerImpl pointer
    static void deleteImpl( Crt0SimulationEngineerImpl*  impl );


    ///
    /// This operation determines if the participant is assignable.
    /// @version Tc 8
    /// @param user - A user tag
    /// @param object - An object tag
    /// @param assignable - A pointer to a boolean whose value, when returned, is the result of the evaluation
    /// @return - An ifail integer
    ///
    int  isAssignableBase(const Crt0SimulationEngineer &ifObj,  tag_t user, tag_t object, bool *assignable );



protected:
    //  Pointer to the instance
    static Crt0SimulationEngineerDelegate*  m_pInstance;

    Crt0SimulationEngineerDelegate();
    virtual ~Crt0SimulationEngineerDelegate();
    static void setInstance( Crt0SimulationEngineerDelegate*  instance );


private:
    friend class  ::crt0validationcontract::Crt0SimulationEngineerGenImpl;

};

#include <Crt0ValidationContract/libcrt0validationcontract_undef.h>
#endif  //  CRT0VALIDATIONCONTRACT__CRT0SIMULATIONENGINEERDELEGATE_HXX
