//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Crt0StudyRevision
    Filename:   Crt0StudyRevision.hxx
    Module:     Crt0ValidationContract
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CRT0VALIDATIONCONTRACT__CRT0STUDYREVISION__HXX
#define CRT0VALIDATIONCONTRACT__CRT0STUDYREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <Crt0ValidationContract/Crt0VldnContractRevision.hxx>

#include <Crt0ValidationContract/libcrt0validationcontract_exports.h>

namespace crt0validationcontract
{
    class Crt0StudyRevision;
}
namespace crt0validationcontract
{
    class Crt0StudyRevisionImpl;
}
namespace crt0validationcontract
{
    class Crt0StudyRevisionDelegate;
}
namespace crt0validationcontract
{
    class Crt0StudyRevisionDispatch;
}
namespace crt0validationcontract
{
    class Crt0StudyRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CRT0VALIDATIONCONTRACT_API  crt0validationcontract::Crt0StudyRevision
     : public  ::crt0validationcontract::Crt0VldnContractRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Crt0StudyRevision();

    /**
     * Destructor
     */
    virtual ~Crt0StudyRevision();

private:
    //  Getter method for the Implementation Object
    Crt0StudyRevisionImpl*  getCrt0StudyRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCrt0StudyRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Crt0StudyRevisionImpl*  m_crt0studyrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Crt0StudyRevision - desc for Crt0StudyRevision parameter
     */
    Crt0StudyRevision( const Crt0StudyRevision& );
    Crt0StudyRevision& operator=( const Crt0StudyRevision& );

    friend class  Crt0StudyRevisionDelegate;
    friend class  Crt0StudyRevisionDispatch;
    friend class  Crt0StudyRevisionGenImpl;
};

#include <Crt0ValidationContract/libcrt0validationcontract_undef.h>
#endif //   CRT0VALIDATIONCONTRACT__CRT0STUDYREVISION__HXX
