//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Crt0StudyRevisionDelegate
    Filename:   Crt0StudyRevisionDelegate.hxx
    Module:     Crt0ValidationContract
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CRT0VALIDATIONCONTRACT__CRT0STUDYREVISIONDELEGATE_HXX
#define CRT0VALIDATIONCONTRACT__CRT0STUDYREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Crt0ValidationContract/Crt0StudyRevision.hxx>

#include <Crt0ValidationContract/libcrt0validationcontract_exports.h>

namespace crt0validationcontract
{
    class Crt0StudyRevisionDelegate;
}
namespace crt0validationcontract
{
    class Crt0StudyRevisionImpl;
}
namespace crt0validationcontract
{
    class Crt0StudyRevision;
}
namespace crt0validationcontract
{
    class Crt0StudyRevisionGenImpl;
}

namespace crt0validationcontract_alias = ::crt0validationcontract;


class  CRT0VALIDATIONCONTRACT_API crt0validationcontract_alias::Crt0StudyRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Crt0StudyRevisionDelegate instance
    static Crt0StudyRevisionDelegate&  getInstance();

    //  Method to create the Crt0StudyRevisionImpl pointer
    static Crt0StudyRevisionImpl*  createImpl( Crt0StudyRevision&  ifObj );

    //  Method to delete the Crt0StudyRevisionImpl pointer
    static void deleteImpl( Crt0StudyRevisionImpl*  impl );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Crt0StudyRevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Crt0StudyRevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// validate saveas input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  validateSaveAsInputBase(const Crt0StudyRevision &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setObject_nameBase(Crt0StudyRevision &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static Crt0StudyRevisionDelegate*  m_pInstance;

    Crt0StudyRevisionDelegate();
    virtual ~Crt0StudyRevisionDelegate();
    static void setInstance( Crt0StudyRevisionDelegate*  instance );


private:
    friend class  ::crt0validationcontract::Crt0StudyRevisionGenImpl;

};

#include <Crt0ValidationContract/libcrt0validationcontract_undef.h>
#endif  //  CRT0VALIDATIONCONTRACT__CRT0STUDYREVISIONDELEGATE_HXX
