//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Crt0SystemsDesigner
    Filename:   Crt0SystemsDesigner.hxx
    Module:     Crt0ValidationContract
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CRT0VALIDATIONCONTRACT__CRT0SYSTEMSDESIGNER__HXX
#define CRT0VALIDATIONCONTRACT__CRT0SYSTEMSDESIGNER__HXX

#include <common/tc_deprecation_macros.h>
#include <epm/Participant.hxx>

#include <Crt0ValidationContract/libcrt0validationcontract_exports.h>

namespace crt0validationcontract
{
    class Crt0SystemsDesigner;
}
namespace crt0validationcontract
{
    class Crt0SystemsDesignerImpl;
}
namespace crt0validationcontract
{
    class Crt0SystemsDesignerDelegate;
}
namespace crt0validationcontract
{
    class Crt0SystemsDesignerDispatch;
}
namespace crt0validationcontract
{
    class Crt0SystemsDesignerGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CRT0VALIDATIONCONTRACT_API  crt0validationcontract::Crt0SystemsDesigner
     : public  ::Teamcenter::Participant
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Crt0SystemsDesigner();

    /**
     * Destructor
     */
    virtual ~Crt0SystemsDesigner();

private:
    //  Getter method for the Implementation Object
    Crt0SystemsDesignerImpl*  getCrt0SystemsDesignerImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCrt0SystemsDesignerImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Crt0SystemsDesignerImpl*  m_crt0systemsdesignerImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Crt0SystemsDesigner - desc for Crt0SystemsDesigner parameter
     */
    Crt0SystemsDesigner( const Crt0SystemsDesigner& );
    Crt0SystemsDesigner& operator=( const Crt0SystemsDesigner& );

    friend class  Crt0SystemsDesignerDelegate;
    friend class  Crt0SystemsDesignerDispatch;
    friend class  Crt0SystemsDesignerGenImpl;
};

#include <Crt0ValidationContract/libcrt0validationcontract_undef.h>
#endif //   CRT0VALIDATIONCONTRACT__CRT0SYSTEMSDESIGNER__HXX
