//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Crt0SystemsDesignerDelegate
    Filename:   Crt0SystemsDesignerDelegate.hxx
    Module:     Crt0ValidationContract
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CRT0VALIDATIONCONTRACT__CRT0SYSTEMSDESIGNERDELEGATE_HXX
#define CRT0VALIDATIONCONTRACT__CRT0SYSTEMSDESIGNERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Crt0ValidationContract/Crt0SystemsDesigner.hxx>

#include <Crt0ValidationContract/libcrt0validationcontract_exports.h>

namespace crt0validationcontract
{
    class Crt0SystemsDesignerDelegate;
}
namespace crt0validationcontract
{
    class Crt0SystemsDesignerImpl;
}
namespace crt0validationcontract
{
    class Crt0SystemsDesigner;
}
namespace crt0validationcontract
{
    class Crt0SystemsDesignerGenImpl;
}

namespace crt0validationcontract_alias = ::crt0validationcontract;


class  CRT0VALIDATIONCONTRACT_API crt0validationcontract_alias::Crt0SystemsDesignerDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Crt0SystemsDesignerDelegate instance
    static Crt0SystemsDesignerDelegate&  getInstance();

    //  Method to create the Crt0SystemsDesignerImpl pointer
    static Crt0SystemsDesignerImpl*  createImpl( Crt0SystemsDesigner&  ifObj );

    //  Method to delete the Crt0SystemsDesignerImpl pointer
    static void deleteImpl( Crt0SystemsDesignerImpl*  impl );


    ///
    /// This operation determines if the participant is assignable.
    /// @version Tc 8
    /// @param user - A user tag
    /// @param object - An object tag
    /// @param assignable - A pointer to a boolean whose value, when returned, is the result of the evaluation
    /// @return - An ifail integer
    ///
    int  isAssignableBase(const Crt0SystemsDesigner &ifObj,  tag_t user, tag_t object, bool *assignable );



protected:
    //  Pointer to the instance
    static Crt0SystemsDesignerDelegate*  m_pInstance;

    Crt0SystemsDesignerDelegate();
    virtual ~Crt0SystemsDesignerDelegate();
    static void setInstance( Crt0SystemsDesignerDelegate*  instance );


private:
    friend class  ::crt0validationcontract::Crt0SystemsDesignerGenImpl;

};

#include <Crt0ValidationContract/libcrt0validationcontract_undef.h>
#endif  //  CRT0VALIDATIONCONTRACT__CRT0SYSTEMSDESIGNERDELEGATE_HXX
