//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Crt0VCDefn
    Filename:   Crt0VCDefn.hxx
    Module:     Crt0ValidationContract
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CRT0VALIDATIONCONTRACT__CRT0VCDEFN__HXX
#define CRT0VALIDATIONCONTRACT__CRT0VCDEFN__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <Crt0ValidationContract/libcrt0validationcontract_exports.h>

namespace crt0validationcontract
{
    class Crt0VCDefn;
}
namespace crt0validationcontract
{
    class Crt0VCDefnImpl;
}
namespace crt0validationcontract
{
    class Crt0VCDefnDelegate;
}
namespace crt0validationcontract
{
    class Crt0VCDefnDispatch;
}
namespace crt0validationcontract
{
    class Crt0VCDefnGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CRT0VALIDATIONCONTRACT_API  crt0validationcontract::Crt0VCDefn
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Validates the attached Contract Package
    /// @version Teamcenter 10.1.2
    /// @param tcUidContractDefn - Uid of Contract Definition object
    /// @return - Returns true or false based on the result of validation
    ///
    int  crt0ValidateContractPackage( const std::string *tcUidContractDefn );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Crt0VCDefn();

    /**
     * Destructor
     */
    virtual ~Crt0VCDefn();

private:
    //  Getter method for the Implementation Object
    Crt0VCDefnImpl*  getCrt0VCDefnImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCrt0VCDefnImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Crt0VCDefnImpl*  m_crt0vcdefnImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Crt0VCDefn - desc for Crt0VCDefn parameter
     */
    Crt0VCDefn( const Crt0VCDefn& );
    Crt0VCDefn& operator=( const Crt0VCDefn& );

    friend class  Crt0VCDefnDelegate;
    friend class  Crt0VCDefnDispatch;
    friend class  Crt0VCDefnGenImpl;
};

#include <Crt0ValidationContract/libcrt0validationcontract_undef.h>
#endif //   CRT0VALIDATIONCONTRACT__CRT0VCDEFN__HXX
