//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Crt0VCDefnDelegate
    Filename:   Crt0VCDefnDelegate.hxx
    Module:     Crt0ValidationContract
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CRT0VALIDATIONCONTRACT__CRT0VCDEFNDELEGATE_HXX
#define CRT0VALIDATIONCONTRACT__CRT0VCDEFNDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Crt0ValidationContract/Crt0VCDefn.hxx>

#include <Crt0ValidationContract/libcrt0validationcontract_exports.h>

namespace crt0validationcontract
{
    class Crt0VCDefnDelegate;
}
namespace crt0validationcontract
{
    class Crt0VCDefnImpl;
}
namespace crt0validationcontract
{
    class Crt0VCDefn;
}
namespace crt0validationcontract
{
    class Crt0VCDefnGenImpl;
}

namespace crt0validationcontract_alias = ::crt0validationcontract;


class  CRT0VALIDATIONCONTRACT_API crt0validationcontract_alias::Crt0VCDefnDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Crt0VCDefnDelegate instance
    static Crt0VCDefnDelegate&  getInstance();

    //  Method to create the Crt0VCDefnImpl pointer
    static Crt0VCDefnImpl*  createImpl( Crt0VCDefn&  ifObj );

    //  Method to delete the Crt0VCDefnImpl pointer
    static void deleteImpl( Crt0VCDefnImpl*  impl );


    ///
    /// Validates the attached Contract Package
    /// @version Teamcenter 10.1.2
    /// @param tcUidContractDefn - Uid of Contract Definition object
    /// @return - Returns true or false based on the result of validation
    ///
    int  crt0ValidateContractPackageBase(const Crt0VCDefn &ifObj,  const std::string *tcUidContractDefn );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Crt0VCDefn &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// validate saveas input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  validateSaveAsInputBase(const Crt0VCDefn &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setObject_nameBase(Crt0VCDefn &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static Crt0VCDefnDelegate*  m_pInstance;

    Crt0VCDefnDelegate();
    virtual ~Crt0VCDefnDelegate();
    static void setInstance( Crt0VCDefnDelegate*  instance );


private:
    friend class  ::crt0validationcontract::Crt0VCDefnGenImpl;

};

#include <Crt0ValidationContract/libcrt0validationcontract_undef.h>
#endif  //  CRT0VALIDATIONCONTRACT__CRT0VCDEFNDELEGATE_HXX
