//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Crt0VCDefnRevision
    Filename:   Crt0VCDefnRevision.hxx
    Module:     Crt0ValidationContract
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CRT0VALIDATIONCONTRACT__CRT0VCDEFNREVISION__HXX
#define CRT0VALIDATIONCONTRACT__CRT0VCDEFNREVISION__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <Crt0ValidationContract/libcrt0validationcontract_exports.h>

namespace crt0validationcontract
{
    class Crt0VCDefnRevision;
}
namespace crt0validationcontract
{
    class Crt0VCDefnRevisionImpl;
}
namespace crt0validationcontract
{
    class Crt0VCDefnRevisionDelegate;
}
namespace crt0validationcontract
{
    class Crt0VCDefnRevisionDispatch;
}
namespace crt0validationcontract
{
    class Crt0VCDefnRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CRT0VALIDATIONCONTRACT_API  crt0validationcontract::Crt0VCDefnRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Validates the attached Contract Package.
    /// @version Teamcenter 10.1.2
    /// @param tcUidofContractDefn - Uid of Contract Definition object.
    /// @return - Returns true or false based on the result of validation of the attached Contract Package.
    ///
    int  crt0ValidateContractPackage( const std::string *tcUidofContractDefn );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Crt0VCDefnRevision();

    /**
     * Destructor
     */
    virtual ~Crt0VCDefnRevision();

private:
    //  Getter method for the Implementation Object
    Crt0VCDefnRevisionImpl*  getCrt0VCDefnRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCrt0VCDefnRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Crt0VCDefnRevisionImpl*  m_crt0vcdefnrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Crt0VCDefnRevision - desc for Crt0VCDefnRevision parameter
     */
    Crt0VCDefnRevision( const Crt0VCDefnRevision& );
    Crt0VCDefnRevision& operator=( const Crt0VCDefnRevision& );

    friend class  Crt0VCDefnRevisionDelegate;
    friend class  Crt0VCDefnRevisionDispatch;
    friend class  Crt0VCDefnRevisionGenImpl;
};

#include <Crt0ValidationContract/libcrt0validationcontract_undef.h>
#endif //   CRT0VALIDATIONCONTRACT__CRT0VCDEFNREVISION__HXX
