//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Crt0VCDefnRevisionDelegate
    Filename:   Crt0VCDefnRevisionDelegate.hxx
    Module:     Crt0ValidationContract
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CRT0VALIDATIONCONTRACT__CRT0VCDEFNREVISIONDELEGATE_HXX
#define CRT0VALIDATIONCONTRACT__CRT0VCDEFNREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Crt0ValidationContract/Crt0VCDefnRevision.hxx>

#include <Crt0ValidationContract/libcrt0validationcontract_exports.h>

namespace crt0validationcontract
{
    class Crt0VCDefnRevisionDelegate;
}
namespace crt0validationcontract
{
    class Crt0VCDefnRevisionImpl;
}
namespace crt0validationcontract
{
    class Crt0VCDefnRevision;
}
namespace crt0validationcontract
{
    class Crt0VCDefnRevisionGenImpl;
}

namespace crt0validationcontract_alias = ::crt0validationcontract;


class  CRT0VALIDATIONCONTRACT_API crt0validationcontract_alias::Crt0VCDefnRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Crt0VCDefnRevisionDelegate instance
    static Crt0VCDefnRevisionDelegate&  getInstance();

    //  Method to create the Crt0VCDefnRevisionImpl pointer
    static Crt0VCDefnRevisionImpl*  createImpl( Crt0VCDefnRevision&  ifObj );

    //  Method to delete the Crt0VCDefnRevisionImpl pointer
    static void deleteImpl( Crt0VCDefnRevisionImpl*  impl );


    ///
    /// Validates the attached Contract Package.
    /// @version Teamcenter 10.1.2
    /// @param tcUidofContractDefn - Uid of Contract Definition object.
    /// @return - Returns true or false based on the result of validation of the attached Contract Package.
    ///
    int  crt0ValidateContractPackageBase(const Crt0VCDefnRevision &ifObj,  const std::string *tcUidofContractDefn );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Crt0VCDefnRevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// validate saveas input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  validateSaveAsInputBase(const Crt0VCDefnRevision &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setObject_nameBase(Crt0VCDefnRevision &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static Crt0VCDefnRevisionDelegate*  m_pInstance;

    Crt0VCDefnRevisionDelegate();
    virtual ~Crt0VCDefnRevisionDelegate();
    static void setInstance( Crt0VCDefnRevisionDelegate*  instance );


private:
    friend class  ::crt0validationcontract::Crt0VCDefnRevisionGenImpl;

};

#include <Crt0ValidationContract/libcrt0validationcontract_undef.h>
#endif  //  CRT0VALIDATIONCONTRACT__CRT0VCDEFNREVISIONDELEGATE_HXX
