//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Crt0ValidationLink
    Filename:   Crt0ValidationLink.hxx
    Module:     Crt0ValidationContract
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CRT0VALIDATIONCONTRACT__CRT0VALIDATIONLINK__HXX
#define CRT0VALIDATIONCONTRACT__CRT0VALIDATIONLINK__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/FND_TraceLink.hxx>

#include <Crt0ValidationContract/libcrt0validationcontract_exports.h>

namespace crt0validationcontract
{
    class Crt0ValidationLink;
}
namespace crt0validationcontract
{
    class Crt0ValidationLinkImpl;
}
namespace crt0validationcontract
{
    class Crt0ValidationLinkDelegate;
}
namespace crt0validationcontract
{
    class Crt0ValidationLinkDispatch;
}
namespace crt0validationcontract
{
    class Crt0ValidationLinkGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CRT0VALIDATIONCONTRACT_API  crt0validationcontract::Crt0ValidationLink
     : public  ::Teamcenter::FND_TraceLink
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Crt0ValidationLink();

    /**
     * Destructor
     */
    virtual ~Crt0ValidationLink();

private:
    //  Getter method for the Implementation Object
    Crt0ValidationLinkImpl*  getCrt0ValidationLinkImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCrt0ValidationLinkImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Crt0ValidationLinkImpl*  m_crt0validationlinkImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Crt0ValidationLink - desc for Crt0ValidationLink parameter
     */
    Crt0ValidationLink( const Crt0ValidationLink& );
    Crt0ValidationLink& operator=( const Crt0ValidationLink& );

    friend class  Crt0ValidationLinkDelegate;
    friend class  Crt0ValidationLinkDispatch;
    friend class  Crt0ValidationLinkGenImpl;
};

#include <Crt0ValidationContract/libcrt0validationcontract_undef.h>
#endif //   CRT0VALIDATIONCONTRACT__CRT0VALIDATIONLINK__HXX
