//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Crt0VldnContract
    Filename:   Crt0VldnContract.hxx
    Module:     Crt0ValidationContract
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CRT0VALIDATIONCONTRACT__CRT0VLDNCONTRACT__HXX
#define CRT0VALIDATIONCONTRACT__CRT0VLDNCONTRACT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <Crt0ValidationContract/libcrt0validationcontract_exports.h>

namespace crt0validationcontract
{
    class Crt0VldnContract;
}
namespace crt0validationcontract
{
    class Crt0VldnContractImpl;
}
namespace crt0validationcontract
{
    class Crt0VldnContractDelegate;
}
namespace crt0validationcontract
{
    class Crt0VldnContractDispatch;
}
namespace crt0validationcontract
{
    class Crt0VldnContractGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CRT0VALIDATIONCONTRACT_API  crt0validationcontract::Crt0VldnContract
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Crt0VldnContract();

    /**
     * Destructor
     */
    virtual ~Crt0VldnContract();

private:
    //  Getter method for the Implementation Object
    Crt0VldnContractImpl*  getCrt0VldnContractImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCrt0VldnContractImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Crt0VldnContractImpl*  m_crt0vldncontractImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Crt0VldnContract - desc for Crt0VldnContract parameter
     */
    Crt0VldnContract( const Crt0VldnContract& );
    Crt0VldnContract& operator=( const Crt0VldnContract& );

    friend class  Crt0VldnContractDelegate;
    friend class  Crt0VldnContractDispatch;
    friend class  Crt0VldnContractGenImpl;
};

#include <Crt0ValidationContract/libcrt0validationcontract_undef.h>
#endif //   CRT0VALIDATIONCONTRACT__CRT0VLDNCONTRACT__HXX
