//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Crt0VldnContractDelegate
    Filename:   Crt0VldnContractDelegate.hxx
    Module:     Crt0ValidationContract
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CRT0VALIDATIONCONTRACT__CRT0VLDNCONTRACTDELEGATE_HXX
#define CRT0VALIDATIONCONTRACT__CRT0VLDNCONTRACTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Crt0ValidationContract/Crt0VldnContract.hxx>

#include <Crt0ValidationContract/libcrt0validationcontract_exports.h>

namespace crt0validationcontract
{
    class Crt0VldnContractDelegate;
}
namespace crt0validationcontract
{
    class Crt0VldnContractImpl;
}
namespace crt0validationcontract
{
    class Crt0VldnContract;
}
namespace crt0validationcontract
{
    class Crt0VldnContractGenImpl;
}

namespace crt0validationcontract_alias = ::crt0validationcontract;


class  CRT0VALIDATIONCONTRACT_API crt0validationcontract_alias::Crt0VldnContractDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Crt0VldnContractDelegate instance
    static Crt0VldnContractDelegate&  getInstance();

    //  Method to create the Crt0VldnContractImpl pointer
    static Crt0VldnContractImpl*  createImpl( Crt0VldnContract&  ifObj );

    //  Method to delete the Crt0VldnContractImpl pointer
    static void deleteImpl( Crt0VldnContractImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static Crt0VldnContractDelegate*  m_pInstance;

    Crt0VldnContractDelegate();
    virtual ~Crt0VldnContractDelegate();
    static void setInstance( Crt0VldnContractDelegate*  instance );


private:
    friend class  ::crt0validationcontract::Crt0VldnContractGenImpl;

};

#include <Crt0ValidationContract/libcrt0validationcontract_undef.h>
#endif  //  CRT0VALIDATIONCONTRACT__CRT0VLDNCONTRACTDELEGATE_HXX
