//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Crt0VldnContractRevision
    Filename:   Crt0VldnContractRevision.hxx
    Module:     Crt0ValidationContract
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CRT0VALIDATIONCONTRACT__CRT0VLDNCONTRACTREVISION__HXX
#define CRT0VALIDATIONCONTRACT__CRT0VLDNCONTRACTREVISION__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <Crt0ValidationContract/libcrt0validationcontract_exports.h>

namespace crt0validationcontract
{
    class Crt0VldnContractRevision;
}
namespace crt0validationcontract
{
    class Crt0VldnContractRevisionImpl;
}
namespace crt0validationcontract
{
    class Crt0VldnContractRevisionDelegate;
}
namespace crt0validationcontract
{
    class Crt0VldnContractRevisionDispatch;
}
namespace crt0validationcontract
{
    class Crt0VldnContractRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CRT0VALIDATIONCONTRACT_API  crt0validationcontract::Crt0VldnContractRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 12.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCrt0VerificationType( std::string &value, bool &isNull ) const;

    ///
    /// 
    /// @version Teamcenter 10.1.5
    /// @param participantType - Participant business object type.
    /// @param result - Returns the result as true if current user belongs to given participant type, otherwise returns the result as false.
    /// @return - 
    ///
    int  crt0IsParticipant( const std::string &participantType, bool *result );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Crt0VldnContractRevision();

    /**
     * Destructor
     */
    virtual ~Crt0VldnContractRevision();

private:
    //  Getter method for the Implementation Object
    Crt0VldnContractRevisionImpl*  getCrt0VldnContractRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCrt0VldnContractRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Crt0VldnContractRevisionImpl*  m_crt0vldncontractrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Crt0VldnContractRevision - desc for Crt0VldnContractRevision parameter
     */
    Crt0VldnContractRevision( const Crt0VldnContractRevision& );
    Crt0VldnContractRevision& operator=( const Crt0VldnContractRevision& );

    friend class  Crt0VldnContractRevisionDelegate;
    friend class  Crt0VldnContractRevisionDispatch;
    friend class  Crt0VldnContractRevisionGenImpl;
};

#include <Crt0ValidationContract/libcrt0validationcontract_undef.h>
#endif //   CRT0VALIDATIONCONTRACT__CRT0VLDNCONTRACTREVISION__HXX
