//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Crt0VldnContractRevisionDelegate
    Filename:   Crt0VldnContractRevisionDelegate.hxx
    Module:     Crt0ValidationContract
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CRT0VALIDATIONCONTRACT__CRT0VLDNCONTRACTREVISIONDELEGATE_HXX
#define CRT0VALIDATIONCONTRACT__CRT0VLDNCONTRACTREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Crt0ValidationContract/Crt0VldnContractRevision.hxx>

#include <Crt0ValidationContract/libcrt0validationcontract_exports.h>

namespace crt0validationcontract
{
    class Crt0VldnContractRevisionDelegate;
}
namespace crt0validationcontract
{
    class Crt0VldnContractRevisionImpl;
}
namespace crt0validationcontract
{
    class Crt0VldnContractRevision;
}
namespace crt0validationcontract
{
    class Crt0VldnContractRevisionGenImpl;
}

namespace crt0validationcontract_alias = ::crt0validationcontract;


class  CRT0VALIDATIONCONTRACT_API crt0validationcontract_alias::Crt0VldnContractRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Crt0VldnContractRevisionDelegate instance
    static Crt0VldnContractRevisionDelegate&  getInstance();

    //  Method to create the Crt0VldnContractRevisionImpl pointer
    static Crt0VldnContractRevisionImpl*  createImpl( Crt0VldnContractRevision&  ifObj );

    //  Method to delete the Crt0VldnContractRevisionImpl pointer
    static void deleteImpl( Crt0VldnContractRevisionImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 12.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCrt0VerificationTypeBase(const Crt0VldnContractRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// 
    /// @version Teamcenter 10.1.5
    /// @param participantType - Participant business object type.
    /// @param result - Returns the result as true if current user belongs to given participant type, otherwise returns the result as false.
    /// @return - 
    ///
    int  crt0IsParticipantBase(const Crt0VldnContractRevision &ifObj,  const std::string &participantType, bool *result );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Crt0VldnContractRevision &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Crt0VldnContractRevisionDelegate*  m_pInstance;

    Crt0VldnContractRevisionDelegate();
    virtual ~Crt0VldnContractRevisionDelegate();
    static void setInstance( Crt0VldnContractRevisionDelegate*  instance );


private:
    friend class  ::crt0validationcontract::Crt0VldnContractRevisionGenImpl;

};

#include <Crt0ValidationContract/libcrt0validationcontract_undef.h>
#endif  //  CRT0VALIDATIONCONTRACT__CRT0VLDNCONTRACTREVISIONDELEGATE_HXX
