//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  Crt0ValidationContract

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libCrt0ValidationContract

#if !defined(LIBCRT0VALIDATIONCONTRACT) && !defined(IPLIB)
#   error IPLIB or LIBCRT0VALIDATIONCONTRACT is not defined
#endif

/* Handwritten code should use CRT0VALIDATIONCONTRACT_API, not CRT0VALIDATIONCONTRACTEXPORT */

#define CRT0VALIDATIONCONTRACT_API CRT0VALIDATIONCONTRACTEXPORT

#if IPLIB==libCrt0ValidationContract || defined(LIBCRT0VALIDATIONCONTRACT)
#   if defined(__lint)
#       define CRT0VALIDATIONCONTRACTEXPORT       __export(Crt0ValidationContract)
#       define CRT0VALIDATIONCONTRACTGLOBAL       extern __global(Crt0ValidationContract)
#       define CRT0VALIDATIONCONTRACTPRIVATE      extern __private(Crt0ValidationContract)
#   elif defined(_WIN32)
#       define CRT0VALIDATIONCONTRACTEXPORT       __declspec(dllexport)
#       define CRT0VALIDATIONCONTRACTGLOBAL       extern __declspec(dllexport)
#       define CRT0VALIDATIONCONTRACTPRIVATE      extern
#   else
#       define CRT0VALIDATIONCONTRACTEXPORT
#       define CRT0VALIDATIONCONTRACTGLOBAL       extern
#       define CRT0VALIDATIONCONTRACTPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CRT0VALIDATIONCONTRACTEXPORT       __export(Crt0ValidationContract)
#       define CRT0VALIDATIONCONTRACTGLOBAL       extern __global(Crt0ValidationContract)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CRT0VALIDATIONCONTRACTEXPORT      __declspec(dllimport)
#       define CRT0VALIDATIONCONTRACTGLOBAL       extern __declspec(dllimport)
#   else
#       define CRT0VALIDATIONCONTRACTEXPORT
#       define CRT0VALIDATIONCONTRACTGLOBAL       extern
#   endif
#endif
