//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Dia0Sheet
    Filename:   Dia0Sheet.hxx
    Module:     Dia0diagramming
    @BMIDE autogenerated
==================================================================================================*/

#ifndef DIA0DIAGRAMMING__DIA0SHEET__HXX
#define DIA0DIAGRAMMING__DIA0SHEET__HXX

#include <common/tc_deprecation_macros.h>
#include <rlz0realization/Rlz0Composition.hxx>

#include <Dia0diagramming/libdia0diagramming_exports.h>

namespace dia0diagramming
{
    class Dia0Sheet;
}
namespace dia0diagramming
{
    class Dia0SheetImpl;
}
namespace dia0diagramming
{
    class Dia0SheetDelegate;
}
namespace dia0diagramming
{
    class Dia0SheetDispatch;
}
namespace dia0diagramming
{
    class Dia0SheetGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  DIA0DIAGRAMMING_API  dia0diagramming::Dia0Sheet
     : public  ::Teamcenter::Realization::Rlz0Composition
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Dia0Sheet();

    /**
     * Destructor
     */
    virtual ~Dia0Sheet();

private:
    //  Getter method for the Implementation Object
    Dia0SheetImpl*  getDia0SheetImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDia0SheetImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Dia0SheetImpl*  m_dia0sheetImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Dia0Sheet - desc for Dia0Sheet parameter
     */
    Dia0Sheet( const Dia0Sheet& );
    Dia0Sheet& operator=( const Dia0Sheet& );

    friend class  Dia0SheetDelegate;
    friend class  Dia0SheetDispatch;
    friend class  Dia0SheetGenImpl;
};

#include <Dia0diagramming/libdia0diagramming_undef.h>
#endif //   DIA0DIAGRAMMING__DIA0SHEET__HXX
