//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0FasnGroupHardwareRow
    Filename:   Fnd0FasnGroupHardwareRow.hxx
    Module:     Fnd0FastenerMgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0FASNGROUPHARDWAREROW__HXX
#define TEAMCENTER__FND0FASNGROUPHARDWAREROW__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <property/Fnd0TableRow.hxx>

#include <Fnd0FastenerMgmt/libfnd0fastenermgmt_exports.h>

namespace Teamcenter
{
    class Fnd0FasnGroupHardwareRow;
}
namespace Teamcenter
{
    class Fnd0FasnGroupHardwareRowImpl;
}
namespace Teamcenter
{
    class Fnd0FasnGroupHardwareRowDelegate;
}
namespace Teamcenter
{
    class Fnd0FasnGroupHardwareRowDispatch;
}
namespace Teamcenter
{
    class Fnd0FasnGroupHardwareRowGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0FASTENERMGMT_API  Teamcenter::Fnd0FasnGroupHardwareRow
     : public  ::Teamcenter::Fnd0TableRow
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ItemRevision( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0ItemRevision( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0FasnGroupHardwareRow();

    /**
     * Destructor
     */
    virtual ~Fnd0FasnGroupHardwareRow();

private:
    //  Getter method for the Implementation Object
    Fnd0FasnGroupHardwareRowImpl*  getFnd0FasnGroupHardwareRowImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0FasnGroupHardwareRowImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0FasnGroupHardwareRowImpl*  m_fnd0fasngrouphardwarerowImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0FasnGroupHardwareRow - desc for Fnd0FasnGroupHardwareRow parameter
     */
    Fnd0FasnGroupHardwareRow( const Fnd0FasnGroupHardwareRow& );
    Fnd0FasnGroupHardwareRow& operator=( const Fnd0FasnGroupHardwareRow& );

    friend class  Fnd0FasnGroupHardwareRowDelegate;
    friend class  Fnd0FasnGroupHardwareRowDispatch;
    friend class  Fnd0FasnGroupHardwareRowGenImpl;
};

#include <Fnd0FastenerMgmt/libfnd0fastenermgmt_undef.h>
#endif //   TEAMCENTER__FND0FASNGROUPHARDWAREROW__HXX
