//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0JoinedPartsTableRow
    Filename:   Fnd0JoinedPartsTableRow.hxx
    Module:     Fnd0FastenerMgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0JOINEDPARTSTABLEROW__HXX
#define TEAMCENTER__FND0JOINEDPARTSTABLEROW__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <property/Fnd0TableRow.hxx>

#include <Fnd0FastenerMgmt/libfnd0fastenermgmt_exports.h>

namespace Teamcenter
{
    class Fnd0JoinedPartsTableRow;
}
namespace Teamcenter
{
    class Fnd0JoinedPartsTableRowImpl;
}
namespace Teamcenter
{
    class Fnd0JoinedPartsTableRowDelegate;
}
namespace Teamcenter
{
    class Fnd0JoinedPartsTableRowDispatch;
}
namespace Teamcenter
{
    class Fnd0JoinedPartsTableRowGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0FASTENERMGMT_API  Teamcenter::Fnd0JoinedPartsTableRow
     : public  ::Teamcenter::Fnd0TableRow
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0Part( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0Part( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0JoinedPartsTableRow();

    /**
     * Destructor
     */
    virtual ~Fnd0JoinedPartsTableRow();

private:
    //  Getter method for the Implementation Object
    Fnd0JoinedPartsTableRowImpl*  getFnd0JoinedPartsTableRowImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0JoinedPartsTableRowImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0JoinedPartsTableRowImpl*  m_fnd0joinedpartstablerowImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0JoinedPartsTableRow - desc for Fnd0JoinedPartsTableRow parameter
     */
    Fnd0JoinedPartsTableRow( const Fnd0JoinedPartsTableRow& );
    Fnd0JoinedPartsTableRow& operator=( const Fnd0JoinedPartsTableRow& );

    friend class  Fnd0JoinedPartsTableRowDelegate;
    friend class  Fnd0JoinedPartsTableRowDispatch;
    friend class  Fnd0JoinedPartsTableRowGenImpl;
};

#include <Fnd0FastenerMgmt/libfnd0fastenermgmt_undef.h>
#endif //   TEAMCENTER__FND0JOINEDPARTSTABLEROW__HXX
