//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0SealantTableRow
    Filename:   Fnd0SealantTableRow.hxx
    Module:     Fnd0FastenerMgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0SEALANTTABLEROW__HXX
#define TEAMCENTER__FND0SEALANTTABLEROW__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <property/Fnd0TableRow.hxx>

#include <Fnd0FastenerMgmt/libfnd0fastenermgmt_exports.h>

namespace Teamcenter
{
    class Fnd0SealantTableRow;
}
namespace Teamcenter
{
    class Fnd0SealantTableRowImpl;
}
namespace Teamcenter
{
    class Fnd0SealantTableRowDelegate;
}
namespace Teamcenter
{
    class Fnd0SealantTableRowDispatch;
}
namespace Teamcenter
{
    class Fnd0SealantTableRowGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0FASTENERMGMT_API  Teamcenter::Fnd0SealantTableRow
     : public  ::Teamcenter::Fnd0TableRow
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0Sealant( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0Sealant( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0SealantTableRow();

    /**
     * Destructor
     */
    virtual ~Fnd0SealantTableRow();

private:
    //  Getter method for the Implementation Object
    Fnd0SealantTableRowImpl*  getFnd0SealantTableRowImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0SealantTableRowImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0SealantTableRowImpl*  m_fnd0sealanttablerowImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0SealantTableRow - desc for Fnd0SealantTableRow parameter
     */
    Fnd0SealantTableRow( const Fnd0SealantTableRow& );
    Fnd0SealantTableRow& operator=( const Fnd0SealantTableRow& );

    friend class  Fnd0SealantTableRowDelegate;
    friend class  Fnd0SealantTableRowDispatch;
    friend class  Fnd0SealantTableRowGenImpl;
};

#include <Fnd0FastenerMgmt/libfnd0fastenermgmt_undef.h>
#endif //   TEAMCENTER__FND0SEALANTTABLEROW__HXX
