//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  Fnd0FastenerMgmt

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libFnd0FastenerMgmt

#if !defined(LIBFND0FASTENERMGMT) && !defined(IPLIB)
#   error IPLIB or LIBFND0FASTENERMGMT is not defined
#endif

/* Handwritten code should use FND0FASTENERMGMT_API, not FND0FASTENERMGMTEXPORT */

#define FND0FASTENERMGMT_API FND0FASTENERMGMTEXPORT

#if IPLIB==libFnd0FastenerMgmt || defined(LIBFND0FASTENERMGMT)
#   if defined(__lint)
#       define FND0FASTENERMGMTEXPORT       __export(Fnd0FastenerMgmt)
#       define FND0FASTENERMGMTGLOBAL       extern __global(Fnd0FastenerMgmt)
#       define FND0FASTENERMGMTPRIVATE      extern __private(Fnd0FastenerMgmt)
#   elif defined(_WIN32)
#       define FND0FASTENERMGMTEXPORT       __declspec(dllexport)
#       define FND0FASTENERMGMTGLOBAL       extern __declspec(dllexport)
#       define FND0FASTENERMGMTPRIVATE      extern
#   else
#       define FND0FASTENERMGMTEXPORT
#       define FND0FASTENERMGMTGLOBAL       extern
#       define FND0FASTENERMGMTPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define FND0FASTENERMGMTEXPORT       __export(Fnd0FastenerMgmt)
#       define FND0FASTENERMGMTGLOBAL       extern __global(Fnd0FastenerMgmt)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define FND0FASTENERMGMTEXPORT      __declspec(dllimport)
#       define FND0FASTENERMGMTGLOBAL       extern __declspec(dllimport)
#   else
#       define FND0FASTENERMGMTEXPORT
#       define FND0FASTENERMGMTGLOBAL       extern
#   endif
#endif
