//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0BopFastenerDelegate
    Filename:   Fnd0BopFastenerDelegate.hxx
    Module:     Fnd0FastenerMgmtBvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0BOPFASTENERDELEGATE_HXX
#define TEAMCENTER__FND0BOPFASTENERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Fnd0FastenerMgmtBvr/Fnd0BopFastener.hxx>

#include <Fnd0FastenerMgmtBvr/libfnd0fastenermgmtbvr_exports.h>

namespace Teamcenter
{
    class Fnd0BopFastenerDelegate;
}
namespace Teamcenter
{
    class Fnd0BopFastenerImpl;
}
namespace Teamcenter
{
    class Fnd0BopFastener;
}
namespace Teamcenter
{
    class Fnd0BopFastenerGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  FND0FASTENERMGMTBVR_API Teamcenter_alias::Fnd0BopFastenerDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0BopFastenerDelegate instance
    static Fnd0BopFastenerDelegate&  getInstance();

    //  Method to create the Fnd0BopFastenerImpl pointer
    static Fnd0BopFastenerImpl*  createImpl( Fnd0BopFastener&  ifObj );

    //  Method to delete the Fnd0BopFastenerImpl pointer
    static void deleteImpl( Fnd0BopFastenerImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0FastenerTypeBase(const Fnd0BopFastener &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0FitTypeClassBase(const Fnd0BopFastener &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0HoleDiaBase(const Fnd0BopFastener &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0HoleDiaMaxBase(const Fnd0BopFastener &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0HoleDiaMinBase(const Fnd0BopFastener &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0HoleTypeBase(const Fnd0BopFastener &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 11.4
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0JoinedPartsBase(const Fnd0BopFastener &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0LengthUnitsBase(const Fnd0BopFastener &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 11.4
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0SealantsBase(const Fnd0BopFastener &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0FastenerTypeBase(Fnd0BopFastener &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0FitTypeClassBase(Fnd0BopFastener &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Teamcenter 11.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0HoleDiaBase(Fnd0BopFastener &ifObj,  double value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Teamcenter 11.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0HoleDiaMaxBase(Fnd0BopFastener &ifObj,  double value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Teamcenter 11.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0HoleDiaMinBase(Fnd0BopFastener &ifObj,  double value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0HoleTypeBase(Fnd0BopFastener &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 11.4
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0JoinedPartsBase(Fnd0BopFastener &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0LengthUnitsBase(Fnd0BopFastener &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 11.4
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0SealantsBase(Fnd0BopFastener &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );



protected:
    //  Pointer to the instance
    static Fnd0BopFastenerDelegate*  m_pInstance;

    Fnd0BopFastenerDelegate();
    virtual ~Fnd0BopFastenerDelegate();
    static void setInstance( Fnd0BopFastenerDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0BopFastenerGenImpl;

};

#include <Fnd0FastenerMgmtBvr/libfnd0fastenermgmtbvr_undef.h>
#endif  //  TEAMCENTER__FND0BOPFASTENERDELEGATE_HXX
