//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0BopFastenerGroupDelegate
    Filename:   Fnd0BopFastenerGroupDelegate.hxx
    Module:     Fnd0FastenerMgmtBvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0BOPFASTENERGROUPDELEGATE_HXX
#define TEAMCENTER__FND0BOPFASTENERGROUPDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Fnd0FastenerMgmtBvr/Fnd0BopFastenerGroup.hxx>

#include <Fnd0FastenerMgmtBvr/libfnd0fastenermgmtbvr_exports.h>

namespace Teamcenter
{
    class Fnd0BopFastenerGroupDelegate;
}
namespace Teamcenter
{
    class Fnd0BopFastenerGroupImpl;
}
namespace Teamcenter
{
    class Fnd0BopFastenerGroup;
}
namespace Teamcenter
{
    class Fnd0BopFastenerGroupGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  FND0FASTENERMGMTBVR_API Teamcenter_alias::Fnd0BopFastenerGroupDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0BopFastenerGroupDelegate instance
    static Fnd0BopFastenerGroupDelegate&  getInstance();

    //  Method to create the Fnd0BopFastenerGroupImpl pointer
    static Fnd0BopFastenerGroupImpl*  createImpl( Fnd0BopFastenerGroup&  ifObj );

    //  Method to delete the Fnd0BopFastenerGroupImpl pointer
    static void deleteImpl( Fnd0BopFastenerGroupImpl*  impl );


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0FastenerQuantityBase(const Fnd0BopFastenerGroup &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 11.4
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0HardwareBase(const Fnd0BopFastenerGroup &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 11.4
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0HoleSummaryBase(const Fnd0BopFastenerGroup &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 11.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0FastenerQuantityBase(Fnd0BopFastenerGroup &ifObj,  int value, bool isNull );


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 11.4
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0HardwareBase(Fnd0BopFastenerGroup &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 11.4
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0HoleSummaryBase(Fnd0BopFastenerGroup &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );



protected:
    //  Pointer to the instance
    static Fnd0BopFastenerGroupDelegate*  m_pInstance;

    Fnd0BopFastenerGroupDelegate();
    virtual ~Fnd0BopFastenerGroupDelegate();
    static void setInstance( Fnd0BopFastenerGroupDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0BopFastenerGroupGenImpl;

};

#include <Fnd0FastenerMgmtBvr/libfnd0fastenermgmtbvr_undef.h>
#endif  //  TEAMCENTER__FND0BOPFASTENERGROUPDELEGATE_HXX
