//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0BvrFastener
    Filename:   Fnd0BvrFastener.hxx
    Module:     Fnd0FastenerMgmtBvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0BVRFASTENER__HXX
#define TEAMCENTER__FND0BVRFASTENER__HXX

#include <string>
#include <vector>
#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrManufacturingFeature.hxx>

#include <Fnd0FastenerMgmtBvr/libfnd0fastenermgmtbvr_exports.h>

namespace Teamcenter
{
    class Fnd0BvrFastener;
}
namespace Teamcenter
{
    class Fnd0BvrFastenerImpl;
}
namespace Teamcenter
{
    class Fnd0BvrFastenerDelegate;
}
namespace Teamcenter
{
    class Fnd0BvrFastenerDispatch;
}
namespace Teamcenter
{
    class Fnd0BvrFastenerGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0FASTENERMGMTBVR_API  Teamcenter::Fnd0BvrFastener
     : public  ::Teamcenter::Mfg0BvrManufacturingFeature
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0FastenerType( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0FitTypeClass( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Double Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0HoleDia( double &value, bool &isNull ) const;

    ///
    /// Getter for a Double Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0HoleDiaMax( double &value, bool &isNull ) const;

    ///
    /// Getter for a Double Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0HoleDiaMin( double &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0HoleType( std::string &value, bool &isNull ) const;

    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 11.4
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0JoinedParts( std::vector< std::string > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0LengthUnits( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 11.4
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0Sealants( std::vector< std::string > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0FastenerType( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0FitTypeClass( const std::string &value, bool isNull=false );

    ///
    /// Setter for a Double Property
    /// @version Teamcenter 11.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0HoleDia( double value, bool isNull=false );

    ///
    /// Setter for a Double Property
    /// @version Teamcenter 11.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0HoleDiaMax( double value, bool isNull=false );

    ///
    /// Setter for a Double Property
    /// @version Teamcenter 11.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0HoleDiaMin( double value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0HoleType( const std::string &value, bool isNull=false );

    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 11.4
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0JoinedParts( const std::vector< std::string > &values, const std::vector< int > *isNull=0 );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0LengthUnits( const tag_t &value, bool isNull=false );

    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 11.4
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0Sealants( const std::vector< std::string > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0BvrFastener();

    /**
     * Destructor
     */
    virtual ~Fnd0BvrFastener();

private:
    //  Getter method for the Implementation Object
    Fnd0BvrFastenerImpl*  getFnd0BvrFastenerImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0BvrFastenerImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0BvrFastenerImpl*  m_fnd0bvrfastenerImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0BvrFastener - desc for Fnd0BvrFastener parameter
     */
    Fnd0BvrFastener( const Fnd0BvrFastener& );
    Fnd0BvrFastener& operator=( const Fnd0BvrFastener& );

    friend class  Fnd0BvrFastenerDelegate;
    friend class  Fnd0BvrFastenerDispatch;
    friend class  Fnd0BvrFastenerGenImpl;
};

#include <Fnd0FastenerMgmtBvr/libfnd0fastenermgmtbvr_undef.h>
#endif //   TEAMCENTER__FND0BVRFASTENER__HXX
