//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0BvrFastenerGroup
    Filename:   Fnd0BvrFastenerGroup.hxx
    Module:     Fnd0FastenerMgmtBvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0BVRFASTENERGROUP__HXX
#define TEAMCENTER__FND0BVRFASTENERGROUP__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrManufacturingFeature.hxx>

#include <Fnd0FastenerMgmtBvr/libfnd0fastenermgmtbvr_exports.h>

namespace Teamcenter
{
    class Fnd0BvrFastenerGroup;
}
namespace Teamcenter
{
    class Fnd0BvrFastenerGroupImpl;
}
namespace Teamcenter
{
    class Fnd0BvrFastenerGroupDelegate;
}
namespace Teamcenter
{
    class Fnd0BvrFastenerGroupDispatch;
}
namespace Teamcenter
{
    class Fnd0BvrFastenerGroupGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0FASTENERMGMTBVR_API  Teamcenter::Fnd0BvrFastenerGroup
     : public  ::Teamcenter::Mfg0BvrManufacturingFeature
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0FastenerQuantity( int &value, bool &isNull ) const;

    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 11.4
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0Hardware( std::vector< std::string > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 11.4
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0HoleSummary( std::vector< std::string > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 11.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0FastenerQuantity( int value, bool isNull=false );

    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 11.4
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0Hardware( const std::vector< std::string > &values, const std::vector< int > *isNull=0 );

    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 11.4
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0HoleSummary( const std::vector< std::string > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0BvrFastenerGroup();

    /**
     * Destructor
     */
    virtual ~Fnd0BvrFastenerGroup();

private:
    //  Getter method for the Implementation Object
    Fnd0BvrFastenerGroupImpl*  getFnd0BvrFastenerGroupImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0BvrFastenerGroupImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0BvrFastenerGroupImpl*  m_fnd0bvrfastenergroupImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0BvrFastenerGroup - desc for Fnd0BvrFastenerGroup parameter
     */
    Fnd0BvrFastenerGroup( const Fnd0BvrFastenerGroup& );
    Fnd0BvrFastenerGroup& operator=( const Fnd0BvrFastenerGroup& );

    friend class  Fnd0BvrFastenerGroupDelegate;
    friend class  Fnd0BvrFastenerGroupDispatch;
    friend class  Fnd0BvrFastenerGroupGenImpl;
};

#include <Fnd0FastenerMgmtBvr/libfnd0fastenermgmtbvr_undef.h>
#endif //   TEAMCENTER__FND0BVRFASTENERGROUP__HXX
