//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0BvrFastenerGroupDelegate
    Filename:   Fnd0BvrFastenerGroupDelegate.hxx
    Module:     Fnd0FastenerMgmtBvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0BVRFASTENERGROUPDELEGATE_HXX
#define TEAMCENTER__FND0BVRFASTENERGROUPDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Fnd0FastenerMgmtBvr/Fnd0BvrFastenerGroup.hxx>

#include <Fnd0FastenerMgmtBvr/libfnd0fastenermgmtbvr_exports.h>

namespace Teamcenter
{
    class Fnd0BvrFastenerGroupDelegate;
}
namespace Teamcenter
{
    class Fnd0BvrFastenerGroupImpl;
}
namespace Teamcenter
{
    class Fnd0BvrFastenerGroup;
}
namespace Teamcenter
{
    class Fnd0BvrFastenerGroupGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  FND0FASTENERMGMTBVR_API Teamcenter_alias::Fnd0BvrFastenerGroupDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0BvrFastenerGroupDelegate instance
    static Fnd0BvrFastenerGroupDelegate&  getInstance();

    //  Method to create the Fnd0BvrFastenerGroupImpl pointer
    static Fnd0BvrFastenerGroupImpl*  createImpl( Fnd0BvrFastenerGroup&  ifObj );

    //  Method to delete the Fnd0BvrFastenerGroupImpl pointer
    static void deleteImpl( Fnd0BvrFastenerGroupImpl*  impl );


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0FastenerQuantityBase(const Fnd0BvrFastenerGroup &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 11.4
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0HardwareBase(const Fnd0BvrFastenerGroup &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 11.4
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0HoleSummaryBase(const Fnd0BvrFastenerGroup &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 11.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0FastenerQuantityBase(Fnd0BvrFastenerGroup &ifObj,  int value, bool isNull );


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 11.4
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0HardwareBase(Fnd0BvrFastenerGroup &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 11.4
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0HoleSummaryBase(Fnd0BvrFastenerGroup &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );



protected:
    //  Pointer to the instance
    static Fnd0BvrFastenerGroupDelegate*  m_pInstance;

    Fnd0BvrFastenerGroupDelegate();
    virtual ~Fnd0BvrFastenerGroupDelegate();
    static void setInstance( Fnd0BvrFastenerGroupDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0BvrFastenerGroupGenImpl;

};

#include <Fnd0FastenerMgmtBvr/libfnd0fastenermgmtbvr_undef.h>
#endif  //  TEAMCENTER__FND0BVRFASTENERGROUPDELEGATE_HXX
