//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0AuditDefProperty
    Filename:   Fnd0AuditDefProperty.hxx
    Module:     Fnd0audit_mgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0AUDITDEFPROPERTY__HXX
#define TEAMCENTER__FND0AUDITDEFPROPERTY__HXX

#include <unidefs.h>
#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <Fnd0audit_mgr/libfnd0audit_mgr_exports.h>

namespace Teamcenter
{
    class Fnd0AuditDefProperty;
}
namespace Teamcenter
{
    class Fnd0AuditDefPropertyImpl;
}
namespace Teamcenter
{
    class Fnd0AuditDefPropertyDelegate;
}
namespace Teamcenter
{
    class Fnd0AuditDefPropertyDispatch;
}
namespace Teamcenter
{
    class Fnd0AuditDefPropertyGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0AUDIT_MGR_API  Teamcenter::Fnd0AuditDefProperty
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0AuditDef( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0EnableTracking( int &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0IsSecondary( bool &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ObjectType( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0OvlRefDisplayPropName( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0OvlTargetPropName( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0PropName( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0RefDisplayPropName( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0TargetPropName( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0AuditDef( const tag_t &value, bool isNull=false );

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0EnableTracking( int value, bool isNull=false );

    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0IsSecondary( bool value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0ObjectType( const tag_t &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0OvlRefDisplayPropName( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0OvlTargetPropName( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0PropName( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0RefDisplayPropName( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0TargetPropName( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0AuditDefProperty();

    /**
     * Destructor
     */
    virtual ~Fnd0AuditDefProperty();

private:
    //  Getter method for the Implementation Object
    Fnd0AuditDefPropertyImpl*  getFnd0AuditDefPropertyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0AuditDefPropertyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0AuditDefPropertyImpl*  m_fnd0auditdefpropertyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0AuditDefProperty - desc for Fnd0AuditDefProperty parameter
     */
    Fnd0AuditDefProperty( const Fnd0AuditDefProperty& );
    Fnd0AuditDefProperty& operator=( const Fnd0AuditDefProperty& );

    friend class  Fnd0AuditDefPropertyDelegate;
    friend class  Fnd0AuditDefPropertyDispatch;
    friend class  Fnd0AuditDefPropertyGenImpl;
};

#include <Fnd0audit_mgr/libfnd0audit_mgr_undef.h>
#endif //   TEAMCENTER__FND0AUDITDEFPROPERTY__HXX
