//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0AuditDefPropertyDelegate
    Filename:   Fnd0AuditDefPropertyDelegate.hxx
    Module:     Fnd0audit_mgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0AUDITDEFPROPERTYDELEGATE_HXX
#define TEAMCENTER__FND0AUDITDEFPROPERTYDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Fnd0audit_mgr/Fnd0AuditDefProperty.hxx>

#include <Fnd0audit_mgr/libfnd0audit_mgr_exports.h>

namespace Teamcenter
{
    class Fnd0AuditDefPropertyDelegate;
}
namespace Teamcenter
{
    class Fnd0AuditDefPropertyImpl;
}
namespace Teamcenter
{
    class Fnd0AuditDefProperty;
}
namespace Teamcenter
{
    class Fnd0AuditDefPropertyGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  FND0AUDIT_MGR_API Teamcenter_alias::Fnd0AuditDefPropertyDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0AuditDefPropertyDelegate instance
    static Fnd0AuditDefPropertyDelegate&  getInstance();

    //  Method to create the Fnd0AuditDefPropertyImpl pointer
    static Fnd0AuditDefPropertyImpl*  createImpl( Fnd0AuditDefProperty&  ifObj );

    //  Method to delete the Fnd0AuditDefPropertyImpl pointer
    static void deleteImpl( Fnd0AuditDefPropertyImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0AuditDefBase(const Fnd0AuditDefProperty &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0EnableTrackingBase(const Fnd0AuditDefProperty &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0IsSecondaryBase(const Fnd0AuditDefProperty &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ObjectTypeBase(const Fnd0AuditDefProperty &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0OvlRefDisplayPropNameBase(const Fnd0AuditDefProperty &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0OvlTargetPropNameBase(const Fnd0AuditDefProperty &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0PropNameBase(const Fnd0AuditDefProperty &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0RefDisplayPropNameBase(const Fnd0AuditDefProperty &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0TargetPropNameBase(const Fnd0AuditDefProperty &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0AuditDefBase(Fnd0AuditDefProperty &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0EnableTrackingBase(Fnd0AuditDefProperty &ifObj,  int value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0IsSecondaryBase(Fnd0AuditDefProperty &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0ObjectTypeBase(Fnd0AuditDefProperty &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0OvlRefDisplayPropNameBase(Fnd0AuditDefProperty &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0OvlTargetPropNameBase(Fnd0AuditDefProperty &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0PropNameBase(Fnd0AuditDefProperty &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0RefDisplayPropNameBase(Fnd0AuditDefProperty &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0TargetPropNameBase(Fnd0AuditDefProperty &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static Fnd0AuditDefPropertyDelegate*  m_pInstance;

    Fnd0AuditDefPropertyDelegate();
    virtual ~Fnd0AuditDefPropertyDelegate();
    static void setInstance( Fnd0AuditDefPropertyDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0AuditDefPropertyGenImpl;

};

#include <Fnd0audit_mgr/libfnd0audit_mgr_undef.h>
#endif  //  TEAMCENTER__FND0AUDITDEFPROPERTYDELEGATE_HXX
