//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0AuditDefinitionDelegate
    Filename:   Fnd0AuditDefinitionDelegate.hxx
    Module:     Fnd0audit_mgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0AUDITDEFINITIONDELEGATE_HXX
#define TEAMCENTER__FND0AUDITDEFINITIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Fnd0audit_mgr/Fnd0AuditDefinition.hxx>

#include <Fnd0audit_mgr/libfnd0audit_mgr_exports.h>

namespace Teamcenter
{
    class Fnd0AuditDefinitionDelegate;
}
namespace Teamcenter
{
    class Fnd0AuditDefinitionImpl;
}
namespace Teamcenter
{
    class Fnd0AuditDefinition;
}
namespace Teamcenter
{
    class Fnd0AuditDefinitionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  FND0AUDIT_MGR_API Teamcenter_alias::Fnd0AuditDefinitionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0AuditDefinitionDelegate instance
    static Fnd0AuditDefinitionDelegate&  getInstance();

    //  Method to create the Fnd0AuditDefinitionImpl pointer
    static Fnd0AuditDefinitionImpl*  createImpl( Fnd0AuditDefinition&  ifObj );

    //  Method to delete the Fnd0AuditDefinitionImpl pointer
    static void deleteImpl( Fnd0AuditDefinitionImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0AuditPropertyChangeOnlyBase(const Fnd0AuditDefinition &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ConditionBase(const Fnd0AuditDefinition &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0DescriptionBase(const Fnd0AuditDefinition &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0EventTypeBase(const Fnd0AuditDefinition &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0EventTypeMapBase(const Fnd0AuditDefinition &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 10
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ExtensionsBase(const Fnd0AuditDefinition &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0IsActiveBase(const Fnd0AuditDefinition &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0PrimaryTypeBase(const Fnd0AuditDefinition &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0TrackOldValuesBase(const Fnd0AuditDefinition &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0AuditPropertyChangeOnlyBase(Fnd0AuditDefinition &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0ConditionBase(Fnd0AuditDefinition &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0DescriptionBase(Fnd0AuditDefinition &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0EventTypeBase(Fnd0AuditDefinition &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0EventTypeMapBase(Fnd0AuditDefinition &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 10
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0ExtensionsBase(Fnd0AuditDefinition &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0IsActiveBase(Fnd0AuditDefinition &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0PrimaryTypeBase(Fnd0AuditDefinition &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0TrackOldValuesBase(Fnd0AuditDefinition &ifObj,  bool value, bool isNull );


    ///
    /// writeAuditLog for log handler
    /// @version Teamcenter 10
    /// @param primaryObject - Primary Object Tag
    /// @param secondaryObjectCount - Secondary Object count
    /// @param secondaryObject - Secondary Object Tags
    /// @param secondaryQualifiers - Secondary Object Qualifiers if the object is Target or Reference
    /// @param eventTypeName - Event Type Name
    /// @param attrCount - Number of attributes
    /// @param attrNames - Names of the attributes
    /// @param attrValues - Values of the attributes
    /// @param errorCode - Error Code
    /// @param errorMessage - Error Message
    /// @param primaryAudit - Primary audit tag
    /// @param secondaryAudit - Vector of secondary audit tags
    /// @return - 0 if succeessful
    ///
    int  fnd0writeAuditLogBase(const Fnd0AuditDefinition &ifObj,  tag_t primaryObject, int secondaryObjectCount, tag_t *secondaryObject, char **secondaryQualifiers, char *eventTypeName, int attrCount, char **attrNames, char **attrValues, int errorCode, const char *errorMessage, tag_t *primaryAudit, std::vector< tag_t > *secondaryAudit );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static Fnd0AuditDefinitionDelegate*  m_pInstance;

    Fnd0AuditDefinitionDelegate();
    virtual ~Fnd0AuditDefinitionDelegate();
    static void setInstance( Fnd0AuditDefinitionDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0AuditDefinitionGenImpl;

};

#include <Fnd0audit_mgr/libfnd0audit_mgr_undef.h>
#endif  //  TEAMCENTER__FND0AUDITDEFINITIONDELEGATE_HXX
