//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0AuditLink
    Filename:   Fnd0AuditLink.hxx
    Module:     Fnd0audit_mgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0AUDITLINK__HXX
#define TEAMCENTER__FND0AUDITLINK__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <Fnd0audit_mgr/libfnd0audit_mgr_exports.h>

namespace Teamcenter
{
    class Fnd0AuditLink;
}
namespace Teamcenter
{
    class Fnd0AuditLinkImpl;
}
namespace Teamcenter
{
    class Fnd0AuditLinkDelegate;
}
namespace Teamcenter
{
    class Fnd0AuditLinkDispatch;
}
namespace Teamcenter
{
    class Fnd0AuditLinkGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0AUDIT_MGR_API  Teamcenter::Fnd0AuditLink
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0AuditLink();

    /**
     * Destructor
     */
    virtual ~Fnd0AuditLink();

private:
    //  Getter method for the Implementation Object
    Fnd0AuditLinkImpl*  getFnd0AuditLinkImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0AuditLinkImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0AuditLinkImpl*  m_fnd0auditlinkImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0AuditLink - desc for Fnd0AuditLink parameter
     */
    Fnd0AuditLink( const Fnd0AuditLink& );
    Fnd0AuditLink& operator=( const Fnd0AuditLink& );

    friend class  Fnd0AuditLinkDelegate;
    friend class  Fnd0AuditLinkDispatch;
    friend class  Fnd0AuditLinkGenImpl;
};

#include <Fnd0audit_mgr/libfnd0audit_mgr_undef.h>
#endif //   TEAMCENTER__FND0AUDITLINK__HXX
