//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0AuditLog
    Filename:   Fnd0AuditLog.hxx
    Module:     Fnd0audit_mgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0AUDITLOG__HXX
#define TEAMCENTER__FND0AUDITLOG__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <Fnd0audit_mgr/libfnd0audit_mgr_exports.h>

namespace Teamcenter
{
    class Fnd0AuditLog;
}
namespace Teamcenter
{
    class Fnd0AuditLogImpl;
}
namespace Teamcenter
{
    class Fnd0AuditLogDelegate;
}
namespace Teamcenter
{
    class Fnd0AuditLogDispatch;
}
namespace Teamcenter
{
    class Fnd0AuditLogGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0AUDIT_MGR_API  Teamcenter::Fnd0AuditLog
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0SecondaryAuditLogs( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0AuditLog();

    /**
     * Destructor
     */
    virtual ~Fnd0AuditLog();

private:
    //  Getter method for the Implementation Object
    Fnd0AuditLogImpl*  getFnd0AuditLogImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0AuditLogImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0AuditLogImpl*  m_fnd0auditlogImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0AuditLog - desc for Fnd0AuditLog parameter
     */
    Fnd0AuditLog( const Fnd0AuditLog& );
    Fnd0AuditLog& operator=( const Fnd0AuditLog& );

    friend class  Fnd0AuditLogDelegate;
    friend class  Fnd0AuditLogDispatch;
    friend class  Fnd0AuditLogGenImpl;
};

#include <Fnd0audit_mgr/libfnd0audit_mgr_undef.h>
#endif //   TEAMCENTER__FND0AUDITLOG__HXX
