//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0EventTypeMappingDelegate
    Filename:   Fnd0EventTypeMappingDelegate.hxx
    Module:     Fnd0audit_mgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0EVENTTYPEMAPPINGDELEGATE_HXX
#define TEAMCENTER__FND0EVENTTYPEMAPPINGDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Fnd0audit_mgr/Fnd0EventTypeMapping.hxx>

#include <Fnd0audit_mgr/libfnd0audit_mgr_exports.h>

namespace Teamcenter
{
    class Fnd0EventTypeMappingDelegate;
}
namespace Teamcenter
{
    class Fnd0EventTypeMappingImpl;
}
namespace Teamcenter
{
    class Fnd0EventTypeMapping;
}
namespace Teamcenter
{
    class Fnd0EventTypeMappingGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  FND0AUDIT_MGR_API Teamcenter_alias::Fnd0EventTypeMappingDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0EventTypeMappingDelegate instance
    static Fnd0EventTypeMappingDelegate&  getInstance();

    //  Method to create the Fnd0EventTypeMappingImpl pointer
    static Fnd0EventTypeMappingImpl*  createImpl( Fnd0EventTypeMapping&  ifObj );

    //  Method to delete the Fnd0EventTypeMappingImpl pointer
    static void deleteImpl( Fnd0EventTypeMappingImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0AuditableBase(const Fnd0EventTypeMapping &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0AuditTypeBase(const Fnd0EventTypeMapping &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0DescriptionBase(const Fnd0EventTypeMapping &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0EventTypeBase(const Fnd0EventTypeMapping &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ObjectTypeBase(const Fnd0EventTypeMapping &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0SecPropAuditTypeBase(const Fnd0EventTypeMapping &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0SubscribableBase(const Fnd0EventTypeMapping &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0AuditableBase(Fnd0EventTypeMapping &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0AuditTypeBase(Fnd0EventTypeMapping &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0DescriptionBase(Fnd0EventTypeMapping &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0EventTypeBase(Fnd0EventTypeMapping &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0ObjectTypeBase(Fnd0EventTypeMapping &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0SecPropAuditTypeBase(Fnd0EventTypeMapping &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0SubscribableBase(Fnd0EventTypeMapping &ifObj,  bool value, bool isNull );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static Fnd0EventTypeMappingDelegate*  m_pInstance;

    Fnd0EventTypeMappingDelegate();
    virtual ~Fnd0EventTypeMappingDelegate();
    static void setInstance( Fnd0EventTypeMappingDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0EventTypeMappingGenImpl;

};

#include <Fnd0audit_mgr/libfnd0audit_mgr_undef.h>
#endif  //  TEAMCENTER__FND0EVENTTYPEMAPPINGDELEGATE_HXX
