//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0FileAccessAudit
    Filename:   Fnd0FileAccessAudit.hxx
    Module:     Fnd0audit_mgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0FILEACCESSAUDIT__HXX
#define TEAMCENTER__FND0FILEACCESSAUDIT__HXX

#include <common/tc_deprecation_macros.h>
#include <Fnd0audit_mgr/Fnd0AuditLog.hxx>

#include <Fnd0audit_mgr/libfnd0audit_mgr_exports.h>

namespace Teamcenter
{
    class Fnd0FileAccessAudit;
}
namespace Teamcenter
{
    class Fnd0FileAccessAuditImpl;
}
namespace Teamcenter
{
    class Fnd0FileAccessAuditDelegate;
}
namespace Teamcenter
{
    class Fnd0FileAccessAuditDispatch;
}
namespace Teamcenter
{
    class Fnd0FileAccessAuditGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0AUDIT_MGR_API  Teamcenter::Fnd0FileAccessAudit
     : public  ::Teamcenter::Fnd0AuditLog
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0FileAccessAudit();

    /**
     * Destructor
     */
    virtual ~Fnd0FileAccessAudit();

private:
    //  Getter method for the Implementation Object
    Fnd0FileAccessAuditImpl*  getFnd0FileAccessAuditImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0FileAccessAuditImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0FileAccessAuditImpl*  m_fnd0fileaccessauditImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0FileAccessAudit - desc for Fnd0FileAccessAudit parameter
     */
    Fnd0FileAccessAudit( const Fnd0FileAccessAudit& );
    Fnd0FileAccessAudit& operator=( const Fnd0FileAccessAudit& );

    friend class  Fnd0FileAccessAuditDelegate;
    friend class  Fnd0FileAccessAuditDispatch;
    friend class  Fnd0FileAccessAuditGenImpl;
};

#include <Fnd0audit_mgr/libfnd0audit_mgr_undef.h>
#endif //   TEAMCENTER__FND0FILEACCESSAUDIT__HXX
