//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0GeneralAudit
    Filename:   Fnd0GeneralAudit.hxx
    Module:     Fnd0audit_mgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0GENERALAUDIT__HXX
#define TEAMCENTER__FND0GENERALAUDIT__HXX

#include <common/tc_deprecation_macros.h>
#include <Fnd0audit_mgr/Fnd0AuditLog.hxx>

#include <Fnd0audit_mgr/libfnd0audit_mgr_exports.h>

namespace Teamcenter
{
    class Fnd0GeneralAudit;
}
namespace Teamcenter
{
    class Fnd0GeneralAuditImpl;
}
namespace Teamcenter
{
    class Fnd0GeneralAuditDelegate;
}
namespace Teamcenter
{
    class Fnd0GeneralAuditDispatch;
}
namespace Teamcenter
{
    class Fnd0GeneralAuditGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0AUDIT_MGR_API  Teamcenter::Fnd0GeneralAudit
     : public  ::Teamcenter::Fnd0AuditLog
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0GeneralAudit();

    /**
     * Destructor
     */
    virtual ~Fnd0GeneralAudit();

private:
    //  Getter method for the Implementation Object
    Fnd0GeneralAuditImpl*  getFnd0GeneralAuditImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0GeneralAuditImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0GeneralAuditImpl*  m_fnd0generalauditImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0GeneralAudit - desc for Fnd0GeneralAudit parameter
     */
    Fnd0GeneralAudit( const Fnd0GeneralAudit& );
    Fnd0GeneralAudit& operator=( const Fnd0GeneralAudit& );

    friend class  Fnd0GeneralAuditDelegate;
    friend class  Fnd0GeneralAuditDispatch;
    friend class  Fnd0GeneralAuditGenImpl;
};

#include <Fnd0audit_mgr/libfnd0audit_mgr_undef.h>
#endif //   TEAMCENTER__FND0GENERALAUDIT__HXX
