//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0LicenseChangeAudit
    Filename:   Fnd0LicenseChangeAudit.hxx
    Module:     Fnd0audit_mgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0LICENSECHANGEAUDIT__HXX
#define TEAMCENTER__FND0LICENSECHANGEAUDIT__HXX

#include <common/tc_deprecation_macros.h>
#include <Fnd0audit_mgr/Fnd0AuditLog.hxx>

#include <Fnd0audit_mgr/libfnd0audit_mgr_exports.h>

namespace Teamcenter
{
    class Fnd0LicenseChangeAudit;
}
namespace Teamcenter
{
    class Fnd0LicenseChangeAuditImpl;
}
namespace Teamcenter
{
    class Fnd0LicenseChangeAuditDelegate;
}
namespace Teamcenter
{
    class Fnd0LicenseChangeAuditDispatch;
}
namespace Teamcenter
{
    class Fnd0LicenseChangeAuditGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0AUDIT_MGR_API  Teamcenter::Fnd0LicenseChangeAudit
     : public  ::Teamcenter::Fnd0AuditLog
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0LicenseChangeAudit();

    /**
     * Destructor
     */
    virtual ~Fnd0LicenseChangeAudit();

private:
    //  Getter method for the Implementation Object
    Fnd0LicenseChangeAuditImpl*  getFnd0LicenseChangeAuditImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0LicenseChangeAuditImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0LicenseChangeAuditImpl*  m_fnd0licensechangeauditImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0LicenseChangeAudit - desc for Fnd0LicenseChangeAudit parameter
     */
    Fnd0LicenseChangeAudit( const Fnd0LicenseChangeAudit& );
    Fnd0LicenseChangeAudit& operator=( const Fnd0LicenseChangeAudit& );

    friend class  Fnd0LicenseChangeAuditDelegate;
    friend class  Fnd0LicenseChangeAuditDispatch;
    friend class  Fnd0LicenseChangeAuditGenImpl;
};

#include <Fnd0audit_mgr/libfnd0audit_mgr_undef.h>
#endif //   TEAMCENTER__FND0LICENSECHANGEAUDIT__HXX
