//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0LicenseExportAudit
    Filename:   Fnd0LicenseExportAudit.hxx
    Module:     Fnd0audit_mgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0LICENSEEXPORTAUDIT__HXX
#define TEAMCENTER__FND0LICENSEEXPORTAUDIT__HXX

#include <common/tc_deprecation_macros.h>
#include <Fnd0audit_mgr/Fnd0AuditLog.hxx>

#include <Fnd0audit_mgr/libfnd0audit_mgr_exports.h>

namespace Teamcenter
{
    class Fnd0LicenseExportAudit;
}
namespace Teamcenter
{
    class Fnd0LicenseExportAuditImpl;
}
namespace Teamcenter
{
    class Fnd0LicenseExportAuditDelegate;
}
namespace Teamcenter
{
    class Fnd0LicenseExportAuditDispatch;
}
namespace Teamcenter
{
    class Fnd0LicenseExportAuditGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0AUDIT_MGR_API  Teamcenter::Fnd0LicenseExportAudit
     : public  ::Teamcenter::Fnd0AuditLog
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0LicenseExportAudit();

    /**
     * Destructor
     */
    virtual ~Fnd0LicenseExportAudit();

private:
    //  Getter method for the Implementation Object
    Fnd0LicenseExportAuditImpl*  getFnd0LicenseExportAuditImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0LicenseExportAuditImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0LicenseExportAuditImpl*  m_fnd0licenseexportauditImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0LicenseExportAudit - desc for Fnd0LicenseExportAudit parameter
     */
    Fnd0LicenseExportAudit( const Fnd0LicenseExportAudit& );
    Fnd0LicenseExportAudit& operator=( const Fnd0LicenseExportAudit& );

    friend class  Fnd0LicenseExportAuditDelegate;
    friend class  Fnd0LicenseExportAuditDispatch;
    friend class  Fnd0LicenseExportAuditGenImpl;
};

#include <Fnd0audit_mgr/libfnd0audit_mgr_undef.h>
#endif //   TEAMCENTER__FND0LICENSEEXPORTAUDIT__HXX
