//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0OrganizationAudit
    Filename:   Fnd0OrganizationAudit.hxx
    Module:     Fnd0audit_mgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0ORGANIZATIONAUDIT__HXX
#define TEAMCENTER__FND0ORGANIZATIONAUDIT__HXX

#include <common/tc_deprecation_macros.h>
#include <Fnd0audit_mgr/Fnd0AuditLog.hxx>

#include <Fnd0audit_mgr/libfnd0audit_mgr_exports.h>

namespace Teamcenter
{
    class Fnd0OrganizationAudit;
}
namespace Teamcenter
{
    class Fnd0OrganizationAuditImpl;
}
namespace Teamcenter
{
    class Fnd0OrganizationAuditDelegate;
}
namespace Teamcenter
{
    class Fnd0OrganizationAuditDispatch;
}
namespace Teamcenter
{
    class Fnd0OrganizationAuditGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0AUDIT_MGR_API  Teamcenter::Fnd0OrganizationAudit
     : public  ::Teamcenter::Fnd0AuditLog
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0OrganizationAudit();

    /**
     * Destructor
     */
    virtual ~Fnd0OrganizationAudit();

private:
    //  Getter method for the Implementation Object
    Fnd0OrganizationAuditImpl*  getFnd0OrganizationAuditImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0OrganizationAuditImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0OrganizationAuditImpl*  m_fnd0organizationauditImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0OrganizationAudit - desc for Fnd0OrganizationAudit parameter
     */
    Fnd0OrganizationAudit( const Fnd0OrganizationAudit& );
    Fnd0OrganizationAudit& operator=( const Fnd0OrganizationAudit& );

    friend class  Fnd0OrganizationAuditDelegate;
    friend class  Fnd0OrganizationAuditDispatch;
    friend class  Fnd0OrganizationAuditGenImpl;
};

#include <Fnd0audit_mgr/libfnd0audit_mgr_undef.h>
#endif //   TEAMCENTER__FND0ORGANIZATIONAUDIT__HXX
