//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ScheduleAudit
    Filename:   Fnd0ScheduleAudit.hxx
    Module:     Fnd0audit_mgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0SCHEDULEAUDIT__HXX
#define TEAMCENTER__FND0SCHEDULEAUDIT__HXX

#include <common/tc_deprecation_macros.h>
#include <Fnd0audit_mgr/Fnd0AuditLog.hxx>

#include <Fnd0audit_mgr/libfnd0audit_mgr_exports.h>

namespace Teamcenter
{
    class Fnd0ScheduleAudit;
}
namespace Teamcenter
{
    class Fnd0ScheduleAuditImpl;
}
namespace Teamcenter
{
    class Fnd0ScheduleAuditDelegate;
}
namespace Teamcenter
{
    class Fnd0ScheduleAuditDispatch;
}
namespace Teamcenter
{
    class Fnd0ScheduleAuditGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0AUDIT_MGR_API  Teamcenter::Fnd0ScheduleAudit
     : public  ::Teamcenter::Fnd0AuditLog
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0ScheduleAudit();

    /**
     * Destructor
     */
    virtual ~Fnd0ScheduleAudit();

private:
    //  Getter method for the Implementation Object
    Fnd0ScheduleAuditImpl*  getFnd0ScheduleAuditImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0ScheduleAuditImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0ScheduleAuditImpl*  m_fnd0scheduleauditImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0ScheduleAudit - desc for Fnd0ScheduleAudit parameter
     */
    Fnd0ScheduleAudit( const Fnd0ScheduleAudit& );
    Fnd0ScheduleAudit& operator=( const Fnd0ScheduleAudit& );

    friend class  Fnd0ScheduleAuditDelegate;
    friend class  Fnd0ScheduleAuditDispatch;
    friend class  Fnd0ScheduleAuditGenImpl;
};

#include <Fnd0audit_mgr/libfnd0audit_mgr_undef.h>
#endif //   TEAMCENTER__FND0SCHEDULEAUDIT__HXX
