//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0SecondaryAudit
    Filename:   Fnd0SecondaryAudit.hxx
    Module:     Fnd0audit_mgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0SECONDARYAUDIT__HXX
#define TEAMCENTER__FND0SECONDARYAUDIT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <Fnd0audit_mgr/libfnd0audit_mgr_exports.h>

namespace Teamcenter
{
    class Fnd0SecondaryAudit;
}
namespace Teamcenter
{
    class Fnd0SecondaryAuditImpl;
}
namespace Teamcenter
{
    class Fnd0SecondaryAuditDelegate;
}
namespace Teamcenter
{
    class Fnd0SecondaryAuditDispatch;
}
namespace Teamcenter
{
    class Fnd0SecondaryAuditGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0AUDIT_MGR_API  Teamcenter::Fnd0SecondaryAudit
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0SecondaryAudit();

    /**
     * Destructor
     */
    virtual ~Fnd0SecondaryAudit();

private:
    //  Getter method for the Implementation Object
    Fnd0SecondaryAuditImpl*  getFnd0SecondaryAuditImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0SecondaryAuditImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0SecondaryAuditImpl*  m_fnd0secondaryauditImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0SecondaryAudit - desc for Fnd0SecondaryAudit parameter
     */
    Fnd0SecondaryAudit( const Fnd0SecondaryAudit& );
    Fnd0SecondaryAudit& operator=( const Fnd0SecondaryAudit& );

    friend class  Fnd0SecondaryAuditDelegate;
    friend class  Fnd0SecondaryAuditDispatch;
    friend class  Fnd0SecondaryAuditGenImpl;
};

#include <Fnd0audit_mgr/libfnd0audit_mgr_undef.h>
#endif //   TEAMCENTER__FND0SECONDARYAUDIT__HXX
