//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0StructureAudit
    Filename:   Fnd0StructureAudit.hxx
    Module:     Fnd0audit_mgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0STRUCTUREAUDIT__HXX
#define TEAMCENTER__FND0STRUCTUREAUDIT__HXX

#include <common/tc_deprecation_macros.h>
#include <Fnd0audit_mgr/Fnd0AuditLog.hxx>

#include <Fnd0audit_mgr/libfnd0audit_mgr_exports.h>

namespace Teamcenter
{
    class Fnd0StructureAudit;
}
namespace Teamcenter
{
    class Fnd0StructureAuditImpl;
}
namespace Teamcenter
{
    class Fnd0StructureAuditDelegate;
}
namespace Teamcenter
{
    class Fnd0StructureAuditDispatch;
}
namespace Teamcenter
{
    class Fnd0StructureAuditGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0AUDIT_MGR_API  Teamcenter::Fnd0StructureAudit
     : public  ::Teamcenter::Fnd0AuditLog
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0StructureAudit();

    /**
     * Destructor
     */
    virtual ~Fnd0StructureAudit();

private:
    //  Getter method for the Implementation Object
    Fnd0StructureAuditImpl*  getFnd0StructureAuditImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0StructureAuditImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0StructureAuditImpl*  m_fnd0structureauditImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0StructureAudit - desc for Fnd0StructureAudit parameter
     */
    Fnd0StructureAudit( const Fnd0StructureAudit& );
    Fnd0StructureAudit& operator=( const Fnd0StructureAudit& );

    friend class  Fnd0StructureAuditDelegate;
    friend class  Fnd0StructureAuditDispatch;
    friend class  Fnd0StructureAuditGenImpl;
};

#include <Fnd0audit_mgr/libfnd0audit_mgr_undef.h>
#endif //   TEAMCENTER__FND0STRUCTUREAUDIT__HXX
