//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0WorkflowAuditDelegate
    Filename:   Fnd0WorkflowAuditDelegate.hxx
    Module:     Fnd0audit_mgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0WORKFLOWAUDITDELEGATE_HXX
#define TEAMCENTER__FND0WORKFLOWAUDITDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Fnd0audit_mgr/Fnd0WorkflowAudit.hxx>

#include <Fnd0audit_mgr/libfnd0audit_mgr_exports.h>

namespace Teamcenter
{
    class Fnd0WorkflowAuditDelegate;
}
namespace Teamcenter
{
    class Fnd0WorkflowAuditImpl;
}
namespace Teamcenter
{
    class Fnd0WorkflowAudit;
}
namespace Teamcenter
{
    class Fnd0WorkflowAuditGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  FND0AUDIT_MGR_API Teamcenter_alias::Fnd0WorkflowAuditDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0WorkflowAuditDelegate instance
    static Fnd0WorkflowAuditDelegate&  getInstance();

    //  Method to create the Fnd0WorkflowAuditImpl pointer
    static Fnd0WorkflowAuditImpl*  createImpl( Fnd0WorkflowAudit&  ifObj );

    //  Method to delete the Fnd0WorkflowAuditImpl pointer
    static void deleteImpl( Fnd0WorkflowAuditImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ActualDurationDisplayBase(const Fnd0WorkflowAudit &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0CommentsBase(const Fnd0WorkflowAudit &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0SelectedObjectBase(const Fnd0WorkflowAudit &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0TargetReleaseStatusBase(const Fnd0WorkflowAudit &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0SelectedObjectBase(Fnd0WorkflowAudit &ifObj,  const tag_t &value, bool isNull );



protected:
    //  Pointer to the instance
    static Fnd0WorkflowAuditDelegate*  m_pInstance;

    Fnd0WorkflowAuditDelegate();
    virtual ~Fnd0WorkflowAuditDelegate();
    static void setInstance( Fnd0WorkflowAuditDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0WorkflowAuditGenImpl;

};

#include <Fnd0audit_mgr/libfnd0audit_mgr_undef.h>
#endif  //  TEAMCENTER__FND0WORKFLOWAUDITDELEGATE_HXX
