//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  Fnd0audit_mgr

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libFnd0audit_mgr

#if !defined(LIBFND0AUDIT_MGR) && !defined(IPLIB)
#   error IPLIB or LIBFND0AUDIT_MGR is not defined
#endif

/* Handwritten code should use FND0AUDIT_MGR_API, not FND0AUDIT_MGREXPORT */

#define FND0AUDIT_MGR_API FND0AUDIT_MGREXPORT

#if IPLIB==libFnd0audit_mgr || defined(LIBFND0AUDIT_MGR)
#   if defined(__lint)
#       define FND0AUDIT_MGREXPORT       __export(Fnd0audit_mgr)
#       define FND0AUDIT_MGRGLOBAL       extern __global(Fnd0audit_mgr)
#       define FND0AUDIT_MGRPRIVATE      extern __private(Fnd0audit_mgr)
#   elif defined(_WIN32)
#       define FND0AUDIT_MGREXPORT       __declspec(dllexport)
#       define FND0AUDIT_MGRGLOBAL       extern __declspec(dllexport)
#       define FND0AUDIT_MGRPRIVATE      extern
#   else
#       define FND0AUDIT_MGREXPORT
#       define FND0AUDIT_MGRGLOBAL       extern
#       define FND0AUDIT_MGRPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define FND0AUDIT_MGREXPORT       __export(Fnd0audit_mgr)
#       define FND0AUDIT_MGRGLOBAL       extern __global(Fnd0audit_mgr)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define FND0AUDIT_MGREXPORT      __declspec(dllimport)
#       define FND0AUDIT_MGRGLOBAL       extern __declspec(dllimport)
#   else
#       define FND0AUDIT_MGREXPORT
#       define FND0AUDIT_MGRGLOBAL       extern
#   endif
#endif
