//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0BOMLineLiteDelegate
    Filename:   Fnd0BOMLineLiteDelegate.hxx
    Module:     Fnd0bomlite
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0BOMLINELITEDELEGATE_HXX
#define TEAMCENTER__FND0BOMLINELITEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Fnd0bomlite/Fnd0BOMLineLite.hxx>

#include <Fnd0bomlite/libfnd0bomlite_exports.h>

namespace Teamcenter
{
    class Fnd0BOMLineLiteDelegate;
}
namespace Teamcenter
{
    class Fnd0BOMLineLiteImpl;
}
namespace Teamcenter
{
    class Fnd0BOMLineLite;
}
namespace Teamcenter
{
    class Fnd0BOMLineLiteGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  FND0BOMLITE_API Teamcenter_alias::Fnd0BOMLineLiteDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0BOMLineLiteDelegate instance
    static Fnd0BOMLineLiteDelegate&  getInstance();

    //  Method to create the Fnd0BOMLineLiteImpl pointer
    static Fnd0BOMLineLiteImpl*  createImpl( Fnd0BOMLineLite&  ifObj );

    //  Method to delete the Fnd0BOMLineLiteImpl pointer
    static void deleteImpl( Fnd0BOMLineLiteImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBl_abs_occ_idBase(const Fnd0BOMLineLite &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBl_absocc_uid_in_topline_contextBase(const Fnd0BOMLineLite &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBl_apn_uid_in_topline_contextBase(const Fnd0BOMLineLite &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBl_clone_stable_occurrence_idBase(const Fnd0BOMLineLite &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBl_config_windowBase(const Fnd0BOMLineLite &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBl_has_childrenBase(const Fnd0BOMLineLite &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBl_is_occ_suppressedBase(const Fnd0BOMLineLite &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBl_jt_dataset_tagBase(const Fnd0BOMLineLite &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBl_jt_override_childrenBase(const Fnd0BOMLineLite &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBl_line_nameBase(const Fnd0BOMLineLite &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBl_occurrence_uidBase(const Fnd0BOMLineLite &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.6
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getbl_parentBase(const Fnd0BOMLineLite &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBl_plmxml_abs_xformBase(const Fnd0BOMLineLite &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBl_plmxml_occ_xformBase(const Fnd0BOMLineLite &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getBl_property_overridesBase(const Fnd0BOMLineLite &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBl_windowBase(const Fnd0BOMLineLite &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 12.4
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0bl_configured_outBase(const Fnd0BOMLineLite &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0bl_plmxml_override_xformBase(const Fnd0BOMLineLite &ifObj,  std::string &value, bool &isNull ) const;



protected:
    //  Pointer to the instance
    static Fnd0BOMLineLiteDelegate*  m_pInstance;

    Fnd0BOMLineLiteDelegate();
    virtual ~Fnd0BOMLineLiteDelegate();
    static void setInstance( Fnd0BOMLineLiteDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0BOMLineLiteGenImpl;

};

#include <Fnd0bomlite/libfnd0bomlite_undef.h>
#endif  //  TEAMCENTER__FND0BOMLINELITEDELEGATE_HXX
