//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ItemLineLite
    Filename:   Fnd0ItemLineLite.hxx
    Module:     Fnd0bomlite
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0ITEMLINELITE__HXX
#define TEAMCENTER__FND0ITEMLINELITE__HXX

#include <string>
#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <Fnd0bomlite/Fnd0BOMLineLite.hxx>

#include <Fnd0bomlite/libfnd0bomlite_exports.h>

namespace Teamcenter
{
    class Fnd0ItemLineLite;
}
namespace Teamcenter
{
    class Fnd0ItemLineLiteImpl;
}
namespace Teamcenter
{
    class Fnd0ItemLineLiteDelegate;
}
namespace Teamcenter
{
    class Fnd0ItemLineLiteDispatch;
}
namespace Teamcenter
{
    class Fnd0ItemLineLiteGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0BOMLITE_API  Teamcenter::Fnd0ItemLineLite
     : public  ::Teamcenter::Fnd0BOMLineLite
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBl_bomview_uid( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getbl_formula( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getbl_is_occ_configured( bool &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getbl_is_suppressed( bool &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBl_item( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getbl_rev_effectivity_text( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBl_revision( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getbl_used_arrangement( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getbl_used_arrangement_name( std::string &value, bool &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getbl_variant_state( int &value, bool &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0bl_is_mono_override( int &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getfnd0bl_occ_effectivity_text( std::string &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0ItemLineLite();

    /**
     * Destructor
     */
    virtual ~Fnd0ItemLineLite();

private:
    //  Getter method for the Implementation Object
    Fnd0ItemLineLiteImpl*  getFnd0ItemLineLiteImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0ItemLineLiteImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0ItemLineLiteImpl*  m_fnd0itemlineliteImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0ItemLineLite - desc for Fnd0ItemLineLite parameter
     */
    Fnd0ItemLineLite( const Fnd0ItemLineLite& );
    Fnd0ItemLineLite& operator=( const Fnd0ItemLineLite& );

    friend class  Fnd0ItemLineLiteDelegate;
    friend class  Fnd0ItemLineLiteDispatch;
    friend class  Fnd0ItemLineLiteGenImpl;
};

#include <Fnd0bomlite/libfnd0bomlite_undef.h>
#endif //   TEAMCENTER__FND0ITEMLINELITE__HXX
