//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  Fnd0bomlite

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libFnd0bomlite

#if !defined(LIBFND0BOMLITE) && !defined(IPLIB)
#   error IPLIB or LIBFND0BOMLITE is not defined
#endif

/* Handwritten code should use FND0BOMLITE_API, not FND0BOMLITEEXPORT */

#define FND0BOMLITE_API FND0BOMLITEEXPORT

#if IPLIB==libFnd0bomlite || defined(LIBFND0BOMLITE)
#   if defined(__lint)
#       define FND0BOMLITEEXPORT       __export(Fnd0bomlite)
#       define FND0BOMLITEGLOBAL       extern __global(Fnd0bomlite)
#       define FND0BOMLITEPRIVATE      extern __private(Fnd0bomlite)
#   elif defined(_WIN32)
#       define FND0BOMLITEEXPORT       __declspec(dllexport)
#       define FND0BOMLITEGLOBAL       extern __declspec(dllexport)
#       define FND0BOMLITEPRIVATE      extern
#   else
#       define FND0BOMLITEEXPORT
#       define FND0BOMLITEGLOBAL       extern
#       define FND0BOMLITEPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define FND0BOMLITEEXPORT       __export(Fnd0bomlite)
#       define FND0BOMLITEGLOBAL       extern __global(Fnd0bomlite)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define FND0BOMLITEEXPORT      __declspec(dllimport)
#       define FND0BOMLITEGLOBAL       extern __declspec(dllimport)
#   else
#       define FND0BOMLITEEXPORT
#       define FND0BOMLITEGLOBAL       extern
#   endif
#endif
