//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0DisclosedModelViewData
    Filename:   Fnd0DisclosedModelViewData.hxx
    Module:     Fnd0disclosure
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0DISCLOSEDMODELVIEWDATA__HXX
#define TEAMCENTER__FND0DISCLOSEDMODELVIEWDATA__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <Fnd0disclosure/libfnd0disclosure_exports.h>

namespace Teamcenter
{
    class Fnd0DisclosedModelViewData;
}
namespace Teamcenter
{
    class Fnd0DisclosedModelViewDataImpl;
}
namespace Teamcenter
{
    class Fnd0DisclosedModelViewDataDelegate;
}
namespace Teamcenter
{
    class Fnd0DisclosedModelViewDataDispatch;
}
namespace Teamcenter
{
    class Fnd0DisclosedModelViewDataGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0DISCLOSURE_API  Teamcenter::Fnd0DisclosedModelViewData
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0DisclosedModelViewData();

    /**
     * Destructor
     */
    virtual ~Fnd0DisclosedModelViewData();

private:
    //  Getter method for the Implementation Object
    Fnd0DisclosedModelViewDataImpl*  getFnd0DisclosedModelViewDataImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0DisclosedModelViewDataImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0DisclosedModelViewDataImpl*  m_fnd0disclosedmodelviewdataImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0DisclosedModelViewData - desc for Fnd0DisclosedModelViewData parameter
     */
    Fnd0DisclosedModelViewData( const Fnd0DisclosedModelViewData& );
    Fnd0DisclosedModelViewData& operator=( const Fnd0DisclosedModelViewData& );

    friend class  Fnd0DisclosedModelViewDataDelegate;
    friend class  Fnd0DisclosedModelViewDataDispatch;
    friend class  Fnd0DisclosedModelViewDataGenImpl;
};

#include <Fnd0disclosure/libfnd0disclosure_undef.h>
#endif //   TEAMCENTER__FND0DISCLOSEDMODELVIEWDATA__HXX
