//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0DisclosedModelViewDataDelegate
    Filename:   Fnd0DisclosedModelViewDataDelegate.hxx
    Module:     Fnd0disclosure
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0DISCLOSEDMODELVIEWDATADELEGATE_HXX
#define TEAMCENTER__FND0DISCLOSEDMODELVIEWDATADELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Fnd0disclosure/Fnd0DisclosedModelViewData.hxx>

#include <Fnd0disclosure/libfnd0disclosure_exports.h>

namespace Teamcenter
{
    class Fnd0DisclosedModelViewDataDelegate;
}
namespace Teamcenter
{
    class Fnd0DisclosedModelViewDataImpl;
}
namespace Teamcenter
{
    class Fnd0DisclosedModelViewData;
}
namespace Teamcenter
{
    class Fnd0DisclosedModelViewDataGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  FND0DISCLOSURE_API Teamcenter_alias::Fnd0DisclosedModelViewDataDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0DisclosedModelViewDataDelegate instance
    static Fnd0DisclosedModelViewDataDelegate&  getInstance();

    //  Method to create the Fnd0DisclosedModelViewDataImpl pointer
    static Fnd0DisclosedModelViewDataImpl*  createImpl( Fnd0DisclosedModelViewData&  ifObj );

    //  Method to delete the Fnd0DisclosedModelViewDataImpl pointer
    static void deleteImpl( Fnd0DisclosedModelViewDataImpl*  impl );


    ///
    /// This is the getter for retrieving the recipe/permanent ID if its been created (and cached on the instance). Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param uid - Recipe/permanent ID
    /// @param isFirstTime - If Session Recovery Uid is yet to be set or does the object need to be serialized again?
    /// @return - Failure code
    ///
    int  fnd0AskSRUidBase(const Fnd0DisclosedModelViewData &ifObj,  std::string *uid, bool *isFirstTime ) const;


    ///
    /// Generates permanent ID/recipe. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param recipe - Permanent ID/recipe
    /// @return - Failure code.
    ///
    int  fnd0GenerateRecipeBase(const Fnd0DisclosedModelViewData &ifObj,  std::string *recipe );


    ///
    /// If Business Object supports recoverable ID. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param isPersistedRecipe - isPersistedRecipe param should be set to true if the recipe is limited to the user session and should be serialized to the database
    /// @param isRecoverableIDSupported - Returning true indicates support for recoverability/permanent IDs
    /// @return - Failure code.
    ///
    int  fnd0IsRecoverableBase(const Fnd0DisclosedModelViewData &ifObj,  bool *isPersistedRecipe, bool *isRecoverableIDSupported ) const;


    ///
    /// This is the setter for the recipe/permanent ID when it is created (to be cached on the instance). Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param uid - Rrecipe/permanent ID
    /// @return - Failure code.
    ///
    int  fnd0SetSRUidBase(const Fnd0DisclosedModelViewData &ifObj,  const std::string *uid );



protected:
    //  Pointer to the instance
    static Fnd0DisclosedModelViewDataDelegate*  m_pInstance;

    Fnd0DisclosedModelViewDataDelegate();
    virtual ~Fnd0DisclosedModelViewDataDelegate();
    static void setInstance( Fnd0DisclosedModelViewDataDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0DisclosedModelViewDataGenImpl;

};

#include <Fnd0disclosure/libfnd0disclosure_undef.h>
#endif  //  TEAMCENTER__FND0DISCLOSEDMODELVIEWDATADELEGATE_HXX
