//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0DisclosedViewList
    Filename:   Fnd0DisclosedViewList.hxx
    Module:     Fnd0disclosure
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0DISCLOSEDVIEWLIST__HXX
#define TEAMCENTER__FND0DISCLOSEDVIEWLIST__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <Fnd0disclosure/libfnd0disclosure_exports.h>

namespace Teamcenter
{
    class Fnd0DisclosedViewList;
}
namespace Teamcenter
{
    class Fnd0DisclosedViewListImpl;
}
namespace Teamcenter
{
    class Fnd0DisclosedViewListDelegate;
}
namespace Teamcenter
{
    class Fnd0DisclosedViewListDispatch;
}
namespace Teamcenter
{
    class Fnd0DisclosedViewListGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0DISCLOSURE_API  Teamcenter::Fnd0DisclosedViewList
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0DisclosedViewList();

    /**
     * Destructor
     */
    virtual ~Fnd0DisclosedViewList();

private:
    //  Getter method for the Implementation Object
    Fnd0DisclosedViewListImpl*  getFnd0DisclosedViewListImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0DisclosedViewListImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0DisclosedViewListImpl*  m_fnd0disclosedviewlistImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0DisclosedViewList - desc for Fnd0DisclosedViewList parameter
     */
    Fnd0DisclosedViewList( const Fnd0DisclosedViewList& );
    Fnd0DisclosedViewList& operator=( const Fnd0DisclosedViewList& );

    friend class  Fnd0DisclosedViewListDelegate;
    friend class  Fnd0DisclosedViewListDispatch;
    friend class  Fnd0DisclosedViewListGenImpl;
};

#include <Fnd0disclosure/libfnd0disclosure_undef.h>
#endif //   TEAMCENTER__FND0DISCLOSEDVIEWLIST__HXX
