//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0DisclosingObject
    Filename:   Fnd0DisclosingObject.hxx
    Module:     Fnd0disclosure
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0DISCLOSINGOBJECT__HXX
#define TEAMCENTER__FND0DISCLOSINGOBJECT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <Fnd0disclosure/libfnd0disclosure_exports.h>

namespace Teamcenter
{
    class Fnd0DisclosingObject;
}
namespace Teamcenter
{
    class Fnd0DisclosingObjectImpl;
}
namespace Teamcenter
{
    class Fnd0DisclosingObjectDelegate;
}
namespace Teamcenter
{
    class Fnd0DisclosingObjectDispatch;
}
namespace Teamcenter
{
    class Fnd0DisclosingObjectGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0DISCLOSURE_API  Teamcenter::Fnd0DisclosingObject
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0DisclosingObject();

    /**
     * Destructor
     */
    virtual ~Fnd0DisclosingObject();

private:
    //  Getter method for the Implementation Object
    Fnd0DisclosingObjectImpl*  getFnd0DisclosingObjectImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0DisclosingObjectImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0DisclosingObjectImpl*  m_fnd0disclosingobjectImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0DisclosingObject - desc for Fnd0DisclosingObject parameter
     */
    Fnd0DisclosingObject( const Fnd0DisclosingObject& );
    Fnd0DisclosingObject& operator=( const Fnd0DisclosingObject& );

    friend class  Fnd0DisclosingObjectDelegate;
    friend class  Fnd0DisclosingObjectDispatch;
    friend class  Fnd0DisclosingObjectGenImpl;
};

#include <Fnd0disclosure/libfnd0disclosure_undef.h>
#endif //   TEAMCENTER__FND0DISCLOSINGOBJECT__HXX
