//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ModelViewPalette
    Filename:   Fnd0ModelViewPalette.hxx
    Module:     Fnd0disclosure
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0MODELVIEWPALETTE__HXX
#define TEAMCENTER__FND0MODELVIEWPALETTE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <Fnd0disclosure/libfnd0disclosure_exports.h>

namespace Teamcenter
{
    class Fnd0ModelViewPalette;
}
namespace Teamcenter
{
    class Fnd0ModelViewPaletteImpl;
}
namespace Teamcenter
{
    class Fnd0ModelViewPaletteDelegate;
}
namespace Teamcenter
{
    class Fnd0ModelViewPaletteDispatch;
}
namespace Teamcenter
{
    class Fnd0ModelViewPaletteGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0DISCLOSURE_API  Teamcenter::Fnd0ModelViewPalette
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0ModelViewPalette();

    /**
     * Destructor
     */
    virtual ~Fnd0ModelViewPalette();

private:
    //  Getter method for the Implementation Object
    Fnd0ModelViewPaletteImpl*  getFnd0ModelViewPaletteImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0ModelViewPaletteImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0ModelViewPaletteImpl*  m_fnd0modelviewpaletteImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0ModelViewPalette - desc for Fnd0ModelViewPalette parameter
     */
    Fnd0ModelViewPalette( const Fnd0ModelViewPalette& );
    Fnd0ModelViewPalette& operator=( const Fnd0ModelViewPalette& );

    friend class  Fnd0ModelViewPaletteDelegate;
    friend class  Fnd0ModelViewPaletteDispatch;
    friend class  Fnd0ModelViewPaletteGenImpl;
};

#include <Fnd0disclosure/libfnd0disclosure_undef.h>
#endif //   TEAMCENTER__FND0MODELVIEWPALETTE__HXX
