//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ModelViewProxy
    Filename:   Fnd0ModelViewProxy.hxx
    Module:     Fnd0disclosure
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0MODELVIEWPROXY__HXX
#define TEAMCENTER__FND0MODELVIEWPROXY__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <Fnd0disclosure/libfnd0disclosure_exports.h>

namespace Teamcenter
{
    class Fnd0ModelViewProxy;
}
namespace Teamcenter
{
    class Fnd0ModelViewProxyImpl;
}
namespace Teamcenter
{
    class Fnd0ModelViewProxyDelegate;
}
namespace Teamcenter
{
    class Fnd0ModelViewProxyDispatch;
}
namespace Teamcenter
{
    class Fnd0ModelViewProxyGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0DISCLOSURE_API  Teamcenter::Fnd0ModelViewProxy
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a String Property
    /// @version Teamcenter 10.1.6
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ThumbNailFmsTicket( std::string &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0ModelViewProxy();

    /**
     * Destructor
     */
    virtual ~Fnd0ModelViewProxy();

private:
    //  Getter method for the Implementation Object
    Fnd0ModelViewProxyImpl*  getFnd0ModelViewProxyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0ModelViewProxyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0ModelViewProxyImpl*  m_fnd0modelviewproxyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0ModelViewProxy - desc for Fnd0ModelViewProxy parameter
     */
    Fnd0ModelViewProxy( const Fnd0ModelViewProxy& );
    Fnd0ModelViewProxy& operator=( const Fnd0ModelViewProxy& );

    friend class  Fnd0ModelViewProxyDelegate;
    friend class  Fnd0ModelViewProxyDispatch;
    friend class  Fnd0ModelViewProxyGenImpl;
};

#include <Fnd0disclosure/libfnd0disclosure_undef.h>
#endif //   TEAMCENTER__FND0MODELVIEWPROXY__HXX
