//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  Fnd0disclosure

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libFnd0disclosure

#if !defined(LIBFND0DISCLOSURE) && !defined(IPLIB)
#   error IPLIB or LIBFND0DISCLOSURE is not defined
#endif

/* Handwritten code should use FND0DISCLOSURE_API, not FND0DISCLOSUREEXPORT */

#define FND0DISCLOSURE_API FND0DISCLOSUREEXPORT

#if IPLIB==libFnd0disclosure || defined(LIBFND0DISCLOSURE)
#   if defined(__lint)
#       define FND0DISCLOSUREEXPORT       __export(Fnd0disclosure)
#       define FND0DISCLOSUREGLOBAL       extern __global(Fnd0disclosure)
#       define FND0DISCLOSUREPRIVATE      extern __private(Fnd0disclosure)
#   elif defined(_WIN32)
#       define FND0DISCLOSUREEXPORT       __declspec(dllexport)
#       define FND0DISCLOSUREGLOBAL       extern __declspec(dllexport)
#       define FND0DISCLOSUREPRIVATE      extern
#   else
#       define FND0DISCLOSUREEXPORT
#       define FND0DISCLOSUREGLOBAL       extern
#       define FND0DISCLOSUREPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define FND0DISCLOSUREEXPORT       __export(Fnd0disclosure)
#       define FND0DISCLOSUREGLOBAL       extern __global(Fnd0disclosure)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define FND0DISCLOSUREEXPORT      __declspec(dllimport)
#       define FND0DISCLOSUREGLOBAL       extern __declspec(dllimport)
#   else
#       define FND0DISCLOSUREEXPORT
#       define FND0DISCLOSUREGLOBAL       extern
#   endif
#endif
