//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0AbstractMarkupSpace
    Filename:   Fnd0AbstractMarkupSpace.hxx
    Module:     Fnd0editcontext
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0ABSTRACTMARKUPSPACE__HXX
#define TEAMCENTER__FND0ABSTRACTMARKUPSPACE__HXX

#include <common/tc_deprecation_macros.h>
#include <Fnd0editcontext/Fnd0EditContext.hxx>

#include <Fnd0editcontext/libfnd0editcontext_exports.h>

namespace Teamcenter
{
    class Fnd0AbstractMarkupSpace;
}
namespace Teamcenter
{
    class Fnd0AbstractMarkupSpaceImpl;
}
namespace Teamcenter
{
    class Fnd0AbstractMarkupSpaceDelegate;
}
namespace Teamcenter
{
    class Fnd0AbstractMarkupSpaceDispatch;
}
namespace Teamcenter
{
    class Fnd0AbstractMarkupSpaceGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0EDITCONTEXT_API  Teamcenter::Fnd0AbstractMarkupSpace
     : public  ::Teamcenter::Fnd0EditContext
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0AbstractMarkupSpace();

    /**
     * Destructor
     */
    virtual ~Fnd0AbstractMarkupSpace();

private:
    //  Getter method for the Implementation Object
    Fnd0AbstractMarkupSpaceImpl*  getFnd0AbstractMarkupSpaceImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0AbstractMarkupSpaceImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0AbstractMarkupSpaceImpl*  m_fnd0abstractmarkupspaceImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0AbstractMarkupSpace - desc for Fnd0AbstractMarkupSpace parameter
     */
    Fnd0AbstractMarkupSpace( const Fnd0AbstractMarkupSpace& );
    Fnd0AbstractMarkupSpace& operator=( const Fnd0AbstractMarkupSpace& );

    friend class  Fnd0AbstractMarkupSpaceDelegate;
    friend class  Fnd0AbstractMarkupSpaceDispatch;
    friend class  Fnd0AbstractMarkupSpaceGenImpl;
};

#include <Fnd0editcontext/libfnd0editcontext_undef.h>
#endif //   TEAMCENTER__FND0ABSTRACTMARKUPSPACE__HXX
