//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0EditContext
    Filename:   Fnd0EditContext.hxx
    Module:     Fnd0editcontext
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0EDITCONTEXT__HXX
#define TEAMCENTER__FND0EDITCONTEXT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <Fnd0editcontext/libfnd0editcontext_exports.h>

namespace Teamcenter
{
    class Fnd0EditContext;
}
namespace Teamcenter
{
    class Fnd0EditContextImpl;
}
namespace Teamcenter
{
    class Fnd0EditContextDelegate;
}
namespace Teamcenter
{
    class Fnd0EditContextDispatch;
}
namespace Teamcenter
{
    class Fnd0EditContextGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0EDITCONTEXT_API  Teamcenter::Fnd0EditContext
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0EditContext();

    /**
     * Destructor
     */
    virtual ~Fnd0EditContext();

private:
    //  Getter method for the Implementation Object
    Fnd0EditContextImpl*  getFnd0EditContextImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0EditContextImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0EditContextImpl*  m_fnd0editcontextImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0EditContext - desc for Fnd0EditContext parameter
     */
    Fnd0EditContext( const Fnd0EditContext& );
    Fnd0EditContext& operator=( const Fnd0EditContext& );

    friend class  Fnd0EditContextDelegate;
    friend class  Fnd0EditContextDispatch;
    friend class  Fnd0EditContextGenImpl;
};

#include <Fnd0editcontext/libfnd0editcontext_undef.h>
#endif //   TEAMCENTER__FND0EDITCONTEXT__HXX
