//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0EditContextDelegate
    Filename:   Fnd0EditContextDelegate.hxx
    Module:     Fnd0editcontext
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0EDITCONTEXTDELEGATE_HXX
#define TEAMCENTER__FND0EDITCONTEXTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Fnd0editcontext/Fnd0EditContext.hxx>

#include <Fnd0editcontext/libfnd0editcontext_exports.h>

namespace Teamcenter
{
    class Fnd0EditContextDelegate;
}
namespace Teamcenter
{
    class Fnd0EditContextImpl;
}
namespace Teamcenter
{
    class Fnd0EditContext;
}
namespace Teamcenter
{
    class Fnd0EditContextGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  FND0EDITCONTEXT_API Teamcenter_alias::Fnd0EditContextDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0EditContextDelegate instance
    static Fnd0EditContextDelegate&  getInstance();

    //  Method to create the Fnd0EditContextImpl pointer
    static Fnd0EditContextImpl*  createImpl( Fnd0EditContext&  ifObj );

    //  Method to delete the Fnd0EditContextImpl pointer
    static void deleteImpl( Fnd0EditContextImpl*  impl );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Fnd0EditContext &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Fnd0EditContext &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// finalize operation input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  finalizeSaveAsInputBase(const Fnd0EditContext &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// Deletes the instance.
    /// @version Teamcenter 11.1
    /// @return - Failure code.
    ///
    int  fnd0DeleteBase(const Fnd0EditContext &ifObj  );


    ///
    /// Generic saveAsPost operation.
    /// @version Teamcenter 8.1
    /// @param pSavAsInput - Input argument as SaveAsInput object.
    /// @param vecDeepCopyData - vector deepcopy data
    /// @return - Return integer value.
    ///
    int  saveAsPostBase(const Fnd0EditContext &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static Fnd0EditContextDelegate*  m_pInstance;

    Fnd0EditContextDelegate();
    virtual ~Fnd0EditContextDelegate();
    static void setInstance( Fnd0EditContextDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0EditContextGenImpl;

};

#include <Fnd0editcontext/libfnd0editcontext_undef.h>
#endif  //  TEAMCENTER__FND0EDITCONTEXTDELEGATE_HXX
