//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0EmailPollSessionDigest
    Filename:   Fnd0EmailPollSessionDigest.hxx
    Module:     Fnd0emailpolling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0EMAILPOLLSESSIONDIGEST__HXX
#define TEAMCENTER__FND0EMAILPOLLSESSIONDIGEST__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <Fnd0emailpolling/libfnd0emailpolling_exports.h>

namespace Teamcenter
{
    class Fnd0EmailPollSessionDigest;
}
namespace Teamcenter
{
    class Fnd0EmailPollSessionDigestImpl;
}
namespace Teamcenter
{
    class Fnd0EmailPollSessionDigestDelegate;
}
namespace Teamcenter
{
    class Fnd0EmailPollSessionDigestDispatch;
}
namespace Teamcenter
{
    class Fnd0EmailPollSessionDigestGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0EMAILPOLLING_API  Teamcenter::Fnd0EmailPollSessionDigest
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0EmailResponseRecords( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0EmailPollSessionDigest();

    /**
     * Destructor
     */
    virtual ~Fnd0EmailPollSessionDigest();

private:
    //  Getter method for the Implementation Object
    Fnd0EmailPollSessionDigestImpl*  getFnd0EmailPollSessionDigestImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0EmailPollSessionDigestImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0EmailPollSessionDigestImpl*  m_fnd0emailpollsessiondigestImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0EmailPollSessionDigest - desc for Fnd0EmailPollSessionDigest parameter
     */
    Fnd0EmailPollSessionDigest( const Fnd0EmailPollSessionDigest& );
    Fnd0EmailPollSessionDigest& operator=( const Fnd0EmailPollSessionDigest& );

    friend class  Fnd0EmailPollSessionDigestDelegate;
    friend class  Fnd0EmailPollSessionDigestDispatch;
    friend class  Fnd0EmailPollSessionDigestGenImpl;
};

#include <Fnd0emailpolling/libfnd0emailpolling_undef.h>
#endif //   TEAMCENTER__FND0EMAILPOLLSESSIONDIGEST__HXX
