//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0EmailPollingConfig
    Filename:   Fnd0EmailPollingConfig.hxx
    Module:     Fnd0emailpolling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0EMAILPOLLINGCONFIG__HXX
#define TEAMCENTER__FND0EMAILPOLLINGCONFIG__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <Fnd0emailpolling/libfnd0emailpolling_exports.h>

namespace Teamcenter
{
    class Fnd0EmailPollingConfig;
}
namespace Teamcenter
{
    class Fnd0EmailPollingConfigImpl;
}
namespace Teamcenter
{
    class Fnd0EmailPollingConfigDelegate;
}
namespace Teamcenter
{
    class Fnd0EmailPollingConfigDispatch;
}
namespace Teamcenter
{
    class Fnd0EmailPollingConfigGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0EMAILPOLLING_API  Teamcenter::Fnd0EmailPollingConfig
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0PollingUserPassword( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0PollingUserPassword( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0EmailPollingConfig();

    /**
     * Destructor
     */
    virtual ~Fnd0EmailPollingConfig();

private:
    //  Getter method for the Implementation Object
    Fnd0EmailPollingConfigImpl*  getFnd0EmailPollingConfigImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0EmailPollingConfigImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0EmailPollingConfigImpl*  m_fnd0emailpollingconfigImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0EmailPollingConfig - desc for Fnd0EmailPollingConfig parameter
     */
    Fnd0EmailPollingConfig( const Fnd0EmailPollingConfig& );
    Fnd0EmailPollingConfig& operator=( const Fnd0EmailPollingConfig& );

    friend class  Fnd0EmailPollingConfigDelegate;
    friend class  Fnd0EmailPollingConfigDispatch;
    friend class  Fnd0EmailPollingConfigGenImpl;
};

#include <Fnd0emailpolling/libfnd0emailpolling_undef.h>
#endif //   TEAMCENTER__FND0EMAILPOLLINGCONFIG__HXX
