//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0EmailPollingConfigDelegate
    Filename:   Fnd0EmailPollingConfigDelegate.hxx
    Module:     Fnd0emailpolling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0EMAILPOLLINGCONFIGDELEGATE_HXX
#define TEAMCENTER__FND0EMAILPOLLINGCONFIGDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Fnd0emailpolling/Fnd0EmailPollingConfig.hxx>

#include <Fnd0emailpolling/libfnd0emailpolling_exports.h>

namespace Teamcenter
{
    class Fnd0EmailPollingConfigDelegate;
}
namespace Teamcenter
{
    class Fnd0EmailPollingConfigImpl;
}
namespace Teamcenter
{
    class Fnd0EmailPollingConfig;
}
namespace Teamcenter
{
    class Fnd0EmailPollingConfigGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  FND0EMAILPOLLING_API Teamcenter_alias::Fnd0EmailPollingConfigDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0EmailPollingConfigDelegate instance
    static Fnd0EmailPollingConfigDelegate&  getInstance();

    //  Method to create the Fnd0EmailPollingConfigImpl pointer
    static Fnd0EmailPollingConfigImpl*  createImpl( Fnd0EmailPollingConfig&  ifObj );

    //  Method to delete the Fnd0EmailPollingConfigImpl pointer
    static void deleteImpl( Fnd0EmailPollingConfigImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0PollingUserPasswordBase(const Fnd0EmailPollingConfig &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0PollingUserPasswordBase(Fnd0EmailPollingConfig &ifObj,  const std::string &value, bool isNull );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Fnd0EmailPollingConfig &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Fnd0EmailPollingConfig &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// validate saveas input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  validateSaveAsInputBase(const Fnd0EmailPollingConfig &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static Fnd0EmailPollingConfigDelegate*  m_pInstance;

    Fnd0EmailPollingConfigDelegate();
    virtual ~Fnd0EmailPollingConfigDelegate();
    static void setInstance( Fnd0EmailPollingConfigDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0EmailPollingConfigGenImpl;

};

#include <Fnd0emailpolling/libfnd0emailpolling_undef.h>
#endif  //  TEAMCENTER__FND0EMAILPOLLINGCONFIGDELEGATE_HXX
