//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0AlignedDesign
    Filename:   Fnd0AlignedDesign.hxx
    Module:     Fnd0entcba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0ALIGNEDDESIGN__HXX
#define TEAMCENTER__FND0ALIGNEDDESIGN__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <Fnd0entcba/libfnd0entcba_exports.h>

namespace Teamcenter
{
    class Fnd0AlignedDesign;
}
namespace Teamcenter
{
    class Fnd0AlignedDesignImpl;
}
namespace Teamcenter
{
    class Fnd0AlignedDesignDelegate;
}
namespace Teamcenter
{
    class Fnd0AlignedDesignDispatch;
}
namespace Teamcenter
{
    class Fnd0AlignedDesignGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0ENTCBA_API  Teamcenter::Fnd0AlignedDesign
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0AlignedDesign();

    /**
     * Destructor
     */
    virtual ~Fnd0AlignedDesign();

private:
    //  Getter method for the Implementation Object
    Fnd0AlignedDesignImpl*  getFnd0AlignedDesignImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0AlignedDesignImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0AlignedDesignImpl*  m_fnd0aligneddesignImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0AlignedDesign - desc for Fnd0AlignedDesign parameter
     */
    Fnd0AlignedDesign( const Fnd0AlignedDesign& );
    Fnd0AlignedDesign& operator=( const Fnd0AlignedDesign& );

    friend class  Fnd0AlignedDesignDelegate;
    friend class  Fnd0AlignedDesignDispatch;
    friend class  Fnd0AlignedDesignGenImpl;
};

#include <Fnd0entcba/libfnd0entcba_undef.h>
#endif //   TEAMCENTER__FND0ALIGNEDDESIGN__HXX
