//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0AlignedDesignDelegate
    Filename:   Fnd0AlignedDesignDelegate.hxx
    Module:     Fnd0entcba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0ALIGNEDDESIGNDELEGATE_HXX
#define TEAMCENTER__FND0ALIGNEDDESIGNDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Fnd0entcba/Fnd0AlignedDesign.hxx>

#include <Fnd0entcba/libfnd0entcba_exports.h>

namespace Teamcenter
{
    class Fnd0AlignedDesignDelegate;
}
namespace Teamcenter
{
    class Fnd0AlignedDesignImpl;
}
namespace Teamcenter
{
    class Fnd0AlignedDesign;
}
namespace Teamcenter
{
    class Fnd0AlignedDesignGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  FND0ENTCBA_API Teamcenter_alias::Fnd0AlignedDesignDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0AlignedDesignDelegate instance
    static Fnd0AlignedDesignDelegate&  getInstance();

    //  Method to create the Fnd0AlignedDesignImpl pointer
    static Fnd0AlignedDesignImpl*  createImpl( Fnd0AlignedDesign&  ifObj );

    //  Method to delete the Fnd0AlignedDesignImpl pointer
    static void deleteImpl( Fnd0AlignedDesignImpl*  impl );


    ///
    /// This is the getter for retrieving the recipe/permanent ID if its been created (and cached on the instance). Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param uid - Recipe/permanent ID
    /// @param isFirstTime - If Session Recovery Uid is yet to be set or does the object need to be serialized again?
    /// @return - Failure code
    ///
    int  fnd0AskSRUidBase(const Fnd0AlignedDesign &ifObj,  std::string *uid, bool *isFirstTime ) const;


    ///
    /// Generates permanent ID/recipe. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param recipe - Permanent ID/recipe
    /// @return - Failure code.
    ///
    int  fnd0GenerateRecipeBase(const Fnd0AlignedDesign &ifObj,  std::string *recipe );


    ///
    /// If Business Object supports recoverable ID. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param isPersistedRecipe - isPersistedRecipe param should be set to true if the recipe is limited to the user session and should be serialized to the database
    /// @param isRecoverableIDSupported - Returning true indicates support for recoverability/permanent IDs
    /// @return - Failure code.
    ///
    int  fnd0IsRecoverableBase(const Fnd0AlignedDesign &ifObj,  bool *isPersistedRecipe, bool *isRecoverableIDSupported ) const;


    ///
    /// This is the setter for the recipe/permanent ID when it is created (to be cached on the instance). Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param uid - Rrecipe/permanent ID
    /// @return - Failure code.
    ///
    int  fnd0SetSRUidBase(const Fnd0AlignedDesign &ifObj,  const std::string *uid );



protected:
    //  Pointer to the instance
    static Fnd0AlignedDesignDelegate*  m_pInstance;

    Fnd0AlignedDesignDelegate();
    virtual ~Fnd0AlignedDesignDelegate();
    static void setInstance( Fnd0AlignedDesignDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0AlignedDesignGenImpl;

};

#include <Fnd0entcba/libfnd0entcba_undef.h>
#endif  //  TEAMCENTER__FND0ALIGNEDDESIGNDELEGATE_HXX
