//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0AlignedDesignsProvider
    Filename:   Fnd0AlignedDesignsProvider.hxx
    Module:     Fnd0entcba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0ALIGNEDDESIGNSPROVIDER__HXX
#define TEAMCENTER__FND0ALIGNEDDESIGNSPROVIDER__HXX

#include <common/tc_deprecation_macros.h>
#include <tc/Fnd0BaseProvider.hxx>

#include <Fnd0entcba/libfnd0entcba_exports.h>

namespace Teamcenter
{
    class Fnd0AlignedDesignsProvider;
}
namespace Teamcenter
{
    class Fnd0AlignedDesignsProviderImpl;
}
namespace Teamcenter
{
    class Fnd0AlignedDesignsProviderDelegate;
}
namespace Teamcenter
{
    class Fnd0AlignedDesignsProviderDispatch;
}
namespace Teamcenter
{
    class Fnd0AlignedDesignsProviderGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0ENTCBA_API  Teamcenter::Fnd0AlignedDesignsProvider
     : public  ::Teamcenter::Fnd0BaseProvider
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0AlignedDesignsProvider();

    /**
     * Destructor
     */
    virtual ~Fnd0AlignedDesignsProvider();

private:
    //  Getter method for the Implementation Object
    Fnd0AlignedDesignsProviderImpl*  getFnd0AlignedDesignsProviderImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0AlignedDesignsProviderImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0AlignedDesignsProviderImpl*  m_fnd0aligneddesignsproviderImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0AlignedDesignsProvider - desc for Fnd0AlignedDesignsProvider parameter
     */
    Fnd0AlignedDesignsProvider( const Fnd0AlignedDesignsProvider& );
    Fnd0AlignedDesignsProvider& operator=( const Fnd0AlignedDesignsProvider& );

    friend class  Fnd0AlignedDesignsProviderDelegate;
    friend class  Fnd0AlignedDesignsProviderDispatch;
    friend class  Fnd0AlignedDesignsProviderGenImpl;
};

#include <Fnd0entcba/libfnd0entcba_undef.h>
#endif //   TEAMCENTER__FND0ALIGNEDDESIGNSPROVIDER__HXX
