//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0AlignedPart
    Filename:   Fnd0AlignedPart.hxx
    Module:     Fnd0entcba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0ALIGNEDPART__HXX
#define TEAMCENTER__FND0ALIGNEDPART__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <Fnd0entcba/libfnd0entcba_exports.h>

namespace Teamcenter
{
    class Fnd0AlignedPart;
}
namespace Teamcenter
{
    class Fnd0AlignedPartImpl;
}
namespace Teamcenter
{
    class Fnd0AlignedPartDelegate;
}
namespace Teamcenter
{
    class Fnd0AlignedPartDispatch;
}
namespace Teamcenter
{
    class Fnd0AlignedPartGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0ENTCBA_API  Teamcenter::Fnd0AlignedPart
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0AlignedPart();

    /**
     * Destructor
     */
    virtual ~Fnd0AlignedPart();

private:
    //  Getter method for the Implementation Object
    Fnd0AlignedPartImpl*  getFnd0AlignedPartImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0AlignedPartImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0AlignedPartImpl*  m_fnd0alignedpartImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0AlignedPart - desc for Fnd0AlignedPart parameter
     */
    Fnd0AlignedPart( const Fnd0AlignedPart& );
    Fnd0AlignedPart& operator=( const Fnd0AlignedPart& );

    friend class  Fnd0AlignedPartDelegate;
    friend class  Fnd0AlignedPartDispatch;
    friend class  Fnd0AlignedPartGenImpl;
};

#include <Fnd0entcba/libfnd0entcba_undef.h>
#endif //   TEAMCENTER__FND0ALIGNEDPART__HXX
