//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0AlignedPartDelegate
    Filename:   Fnd0AlignedPartDelegate.hxx
    Module:     Fnd0entcba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0ALIGNEDPARTDELEGATE_HXX
#define TEAMCENTER__FND0ALIGNEDPARTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Fnd0entcba/Fnd0AlignedPart.hxx>

#include <Fnd0entcba/libfnd0entcba_exports.h>

namespace Teamcenter
{
    class Fnd0AlignedPartDelegate;
}
namespace Teamcenter
{
    class Fnd0AlignedPartImpl;
}
namespace Teamcenter
{
    class Fnd0AlignedPart;
}
namespace Teamcenter
{
    class Fnd0AlignedPartGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  FND0ENTCBA_API Teamcenter_alias::Fnd0AlignedPartDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0AlignedPartDelegate instance
    static Fnd0AlignedPartDelegate&  getInstance();

    //  Method to create the Fnd0AlignedPartImpl pointer
    static Fnd0AlignedPartImpl*  createImpl( Fnd0AlignedPart&  ifObj );

    //  Method to delete the Fnd0AlignedPartImpl pointer
    static void deleteImpl( Fnd0AlignedPartImpl*  impl );


    ///
    /// This is the getter for retrieving the recipe/permanent ID if its been created (and cached on the instance). Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param uid - Recipe/permanent ID
    /// @param isFirstTime - If Session Recovery Uid is yet to be set or does the object need to be serialized again?
    /// @return - Failure code
    ///
    int  fnd0AskSRUidBase(const Fnd0AlignedPart &ifObj,  std::string *uid, bool *isFirstTime ) const;


    ///
    /// Generates permanent ID/recipe. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param recipe - Permanent ID/recipe
    /// @return - Failure code.
    ///
    int  fnd0GenerateRecipeBase(const Fnd0AlignedPart &ifObj,  std::string *recipe );


    ///
    /// If Business Object supports recoverable ID. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param isPersistedRecipe - isPersistedRecipe param should be set to true if the recipe is limited to the user session and should be serialized to the database
    /// @param isRecoverableIDSupported - Returning true indicates support for recoverability/permanent IDs
    /// @return - Failure code.
    ///
    int  fnd0IsRecoverableBase(const Fnd0AlignedPart &ifObj,  bool *isPersistedRecipe, bool *isRecoverableIDSupported ) const;


    ///
    /// This is the setter for the recipe/permanent ID when it is created (to be cached on the instance). Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param uid - Rrecipe/permanent ID
    /// @return - Failure code.
    ///
    int  fnd0SetSRUidBase(const Fnd0AlignedPart &ifObj,  const std::string *uid );



protected:
    //  Pointer to the instance
    static Fnd0AlignedPartDelegate*  m_pInstance;

    Fnd0AlignedPartDelegate();
    virtual ~Fnd0AlignedPartDelegate();
    static void setInstance( Fnd0AlignedPartDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0AlignedPartGenImpl;

};

#include <Fnd0entcba/libfnd0entcba_undef.h>
#endif  //  TEAMCENTER__FND0ALIGNEDPARTDELEGATE_HXX
