//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0AlignedPartsProvider
    Filename:   Fnd0AlignedPartsProvider.hxx
    Module:     Fnd0entcba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0ALIGNEDPARTSPROVIDER__HXX
#define TEAMCENTER__FND0ALIGNEDPARTSPROVIDER__HXX

#include <common/tc_deprecation_macros.h>
#include <tc/Fnd0BaseProvider.hxx>

#include <Fnd0entcba/libfnd0entcba_exports.h>

namespace Teamcenter
{
    class Fnd0AlignedPartsProvider;
}
namespace Teamcenter
{
    class Fnd0AlignedPartsProviderImpl;
}
namespace Teamcenter
{
    class Fnd0AlignedPartsProviderDelegate;
}
namespace Teamcenter
{
    class Fnd0AlignedPartsProviderDispatch;
}
namespace Teamcenter
{
    class Fnd0AlignedPartsProviderGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0ENTCBA_API  Teamcenter::Fnd0AlignedPartsProvider
     : public  ::Teamcenter::Fnd0BaseProvider
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0AlignedPartsProvider();

    /**
     * Destructor
     */
    virtual ~Fnd0AlignedPartsProvider();

private:
    //  Getter method for the Implementation Object
    Fnd0AlignedPartsProviderImpl*  getFnd0AlignedPartsProviderImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0AlignedPartsProviderImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0AlignedPartsProviderImpl*  m_fnd0alignedpartsproviderImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0AlignedPartsProvider - desc for Fnd0AlignedPartsProvider parameter
     */
    Fnd0AlignedPartsProvider( const Fnd0AlignedPartsProvider& );
    Fnd0AlignedPartsProvider& operator=( const Fnd0AlignedPartsProvider& );

    friend class  Fnd0AlignedPartsProviderDelegate;
    friend class  Fnd0AlignedPartsProviderDispatch;
    friend class  Fnd0AlignedPartsProviderGenImpl;
};

#include <Fnd0entcba/libfnd0entcba_undef.h>
#endif //   TEAMCENTER__FND0ALIGNEDPARTSPROVIDER__HXX
