//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  Fnd0entcba

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libFnd0entcba

#if !defined(LIBFND0ENTCBA) && !defined(IPLIB)
#   error IPLIB or LIBFND0ENTCBA is not defined
#endif

/* Handwritten code should use FND0ENTCBA_API, not FND0ENTCBAEXPORT */

#define FND0ENTCBA_API FND0ENTCBAEXPORT

#if IPLIB==libFnd0entcba || defined(LIBFND0ENTCBA)
#   if defined(__lint)
#       define FND0ENTCBAEXPORT       __export(Fnd0entcba)
#       define FND0ENTCBAGLOBAL       extern __global(Fnd0entcba)
#       define FND0ENTCBAPRIVATE      extern __private(Fnd0entcba)
#   elif defined(_WIN32)
#       define FND0ENTCBAEXPORT       __declspec(dllexport)
#       define FND0ENTCBAGLOBAL       extern __declspec(dllexport)
#       define FND0ENTCBAPRIVATE      extern
#   else
#       define FND0ENTCBAEXPORT
#       define FND0ENTCBAGLOBAL       extern
#       define FND0ENTCBAPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define FND0ENTCBAEXPORT       __export(Fnd0entcba)
#       define FND0ENTCBAGLOBAL       extern __global(Fnd0entcba)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define FND0ENTCBAEXPORT      __declspec(dllimport)
#       define FND0ENTCBAGLOBAL       extern __declspec(dllimport)
#   else
#       define FND0ENTCBAEXPORT
#       define FND0ENTCBAGLOBAL       extern
#   endif
#endif
