//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0AlgebraicFormulaDelegate
    Filename:   Fnd0AlgebraicFormulaDelegate.hxx
    Module:     Fnd0formulamgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0ALGEBRAICFORMULADELEGATE_HXX
#define TEAMCENTER__FND0ALGEBRAICFORMULADELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Fnd0formulamgmt/Fnd0AlgebraicFormula.hxx>

#include <Fnd0formulamgmt/libfnd0formulamgmt_exports.h>

namespace Teamcenter
{
    class Fnd0AlgebraicFormulaDelegate;
}
namespace Teamcenter
{
    class Fnd0AlgebraicFormulaImpl;
}
namespace Teamcenter
{
    class Fnd0AlgebraicFormula;
}
namespace Teamcenter
{
    class Fnd0AlgebraicFormulaGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  FND0FORMULAMGMT_API Teamcenter_alias::Fnd0AlgebraicFormulaDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0AlgebraicFormulaDelegate instance
    static Fnd0AlgebraicFormulaDelegate&  getInstance();

    //  Method to create the Fnd0AlgebraicFormulaImpl pointer
    static Fnd0AlgebraicFormulaImpl*  createImpl( Fnd0AlgebraicFormula&  ifObj );

    //  Method to delete the Fnd0AlgebraicFormulaImpl pointer
    static void deleteImpl( Fnd0AlgebraicFormulaImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ASTExpressionBase(const Fnd0AlgebraicFormula &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ASTInvExpressionBase(const Fnd0AlgebraicFormula &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 9.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ConstNamesBase(const Fnd0AlgebraicFormula &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ExpressionBase(const Fnd0AlgebraicFormula &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0InvExpressionBase(const Fnd0AlgebraicFormula &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0NameBase(const Fnd0AlgebraicFormula &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 9.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0VariableNamesBase(const Fnd0AlgebraicFormula &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0ASTExpressionBase(Fnd0AlgebraicFormula &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0ASTInvExpressionBase(Fnd0AlgebraicFormula &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 9.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0ConstNamesBase(Fnd0AlgebraicFormula &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0ExpressionBase(Fnd0AlgebraicFormula &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0InvExpressionBase(Fnd0AlgebraicFormula &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0NameBase(Fnd0AlgebraicFormula &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 9.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0VariableNamesBase(Fnd0AlgebraicFormula &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// Compute the algebraic formula
    /// @version Teamcenter 9.1
    /// @param constValues - List of constant values
    /// @param variableValues - List of variable values
    /// @param computedResult - Computed result
    /// @return - Status. Return 0 if successful
    ///
    int  fnd0ComputeBase(const Fnd0AlgebraicFormula &ifObj,  const std::vector< std::string > &constValues, const std::vector< std::string > &variableValues, std::string &computedResult );


    ///
    /// Compute the algebraic formula
    /// @version Teamcenter 9.1
    /// @param constValues - Vector of constant values
    /// @param variableGrpValues - Vector of variable group values
    /// @param grpCount - Group count
    /// @param computedGrpResults - Vector of computed group results
    /// @return - Status. Return 0 if successful.
    ///
    int  fnd0ComputeBase(const Fnd0AlgebraicFormula &ifObj,  const std::vector< std::string > *constValues, const std::vector< std::string > *variableGrpValues, int grpCount, std::vector< std::string > *computedGrpResults );


    ///
    /// Compute the inverse-expression
    /// @version Teamcenter 9.1
    /// @param constValues - List of constant values
    /// @param variableValues - List of variable values
    /// @param computedResult - Computed result
    /// @return - Status. Return 0 if successful
    ///
    int  fnd0InverseComputeBase(const Fnd0AlgebraicFormula &ifObj,  const std::vector< std::string > &constValues, const std::vector< std::string > &variableValues, std::string &computedResult );


    ///
    /// Replace the contants with values
    /// @version Teamcenter 9.1
    /// @param constValues - Vector of constant values
    /// @param replacedExpression - Replaced expression
    /// @return - 0 if successful
    ///
    int  fnd0ReplaceConstantsBase(const Fnd0AlgebraicFormula &ifObj,  const std::vector< std::string > *constValues, std::string *replacedExpression );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Fnd0AlgebraicFormula &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Fnd0AlgebraicFormulaDelegate*  m_pInstance;

    Fnd0AlgebraicFormulaDelegate();
    virtual ~Fnd0AlgebraicFormulaDelegate();
    static void setInstance( Fnd0AlgebraicFormulaDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0AlgebraicFormulaGenImpl;

};

#include <Fnd0formulamgmt/libfnd0formulamgmt_undef.h>
#endif  //  TEAMCENTER__FND0ALGEBRAICFORMULADELEGATE_HXX
