//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0FormulaConversion
    Filename:   Fnd0FormulaConversion.hxx
    Module:     Fnd0formulamgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0FORMULACONVERSION__HXX
#define TEAMCENTER__FND0FORMULACONVERSION__HXX

#include <unidefs.h>
#include <vector>
#include <string>
#include <common/tc_deprecation_macros.h>
#include <Fnd0formulamgmt/Fnd0GenericConversionRule.hxx>

#include <Fnd0formulamgmt/libfnd0formulamgmt_exports.h>

namespace Teamcenter
{
    class Fnd0FormulaConversion;
}
namespace Teamcenter
{
    class Fnd0FormulaConversionImpl;
}
namespace Teamcenter
{
    class Fnd0FormulaConversionDelegate;
}
namespace Teamcenter
{
    class Fnd0FormulaConversionDispatch;
}
namespace Teamcenter
{
    class Fnd0FormulaConversionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0FORMULAMGMT_API  Teamcenter::Fnd0FormulaConversion
     : public  ::Teamcenter::Fnd0GenericConversionRule
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0AlgebraicFormula( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 9.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ConstValues( std::vector< std::string > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0Expression( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0AlgebraicFormula( const tag_t &value, bool isNull=false );

    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 9.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0ConstValues( const std::vector< std::string > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0FormulaConversion();

    /**
     * Destructor
     */
    virtual ~Fnd0FormulaConversion();

private:
    //  Getter method for the Implementation Object
    Fnd0FormulaConversionImpl*  getFnd0FormulaConversionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0FormulaConversionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0FormulaConversionImpl*  m_fnd0formulaconversionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0FormulaConversion - desc for Fnd0FormulaConversion parameter
     */
    Fnd0FormulaConversion( const Fnd0FormulaConversion& );
    Fnd0FormulaConversion& operator=( const Fnd0FormulaConversion& );

    friend class  Fnd0FormulaConversionDelegate;
    friend class  Fnd0FormulaConversionDispatch;
    friend class  Fnd0FormulaConversionGenImpl;
};

#include <Fnd0formulamgmt/libfnd0formulamgmt_undef.h>
#endif //   TEAMCENTER__FND0FORMULACONVERSION__HXX
