//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0FormulaConversionDelegate
    Filename:   Fnd0FormulaConversionDelegate.hxx
    Module:     Fnd0formulamgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0FORMULACONVERSIONDELEGATE_HXX
#define TEAMCENTER__FND0FORMULACONVERSIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Fnd0formulamgmt/Fnd0FormulaConversion.hxx>

#include <Fnd0formulamgmt/libfnd0formulamgmt_exports.h>

namespace Teamcenter
{
    class Fnd0FormulaConversionDelegate;
}
namespace Teamcenter
{
    class Fnd0FormulaConversionImpl;
}
namespace Teamcenter
{
    class Fnd0FormulaConversion;
}
namespace Teamcenter
{
    class Fnd0FormulaConversionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  FND0FORMULAMGMT_API Teamcenter_alias::Fnd0FormulaConversionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0FormulaConversionDelegate instance
    static Fnd0FormulaConversionDelegate&  getInstance();

    //  Method to create the Fnd0FormulaConversionImpl pointer
    static Fnd0FormulaConversionImpl*  createImpl( Fnd0FormulaConversion&  ifObj );

    //  Method to delete the Fnd0FormulaConversionImpl pointer
    static void deleteImpl( Fnd0FormulaConversionImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0AlgebraicFormulaBase(const Fnd0FormulaConversion &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 9.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ConstValuesBase(const Fnd0FormulaConversion &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ExpressionBase(const Fnd0FormulaConversion &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0AlgebraicFormulaBase(Fnd0FormulaConversion &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 9.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0ConstValuesBase(Fnd0FormulaConversion &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// Compute the conversion rule
    /// @version Teamcenter 9.1
    /// @param variableValues - List of variable values
    /// @param computedResult - Computed result
    /// @return - Status. Return 0 if successful
    ///
    int  fnd0ComputeBase(const Fnd0FormulaConversion &ifObj,  const std::vector< std::string > &variableValues, std::string &computedResult );


    ///
    /// Compute the conversion rule
    /// @version Teamcenter 9.1
    /// @param variableGrpValues - Vector of variable group values
    /// @param grpCount - Group count
    /// @param computedGrpResults - Vector of computed group results
    /// @return - Status. Return 0 if successful
    ///
    int  fnd0ComputeBase(const Fnd0FormulaConversion &ifObj,  const std::vector< std::string > *variableGrpValues, int grpCount, std::vector< std::string > *computedGrpResults );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Fnd0FormulaConversion &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Fnd0FormulaConversionDelegate*  m_pInstance;

    Fnd0FormulaConversionDelegate();
    virtual ~Fnd0FormulaConversionDelegate();
    static void setInstance( Fnd0FormulaConversionDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0FormulaConversionGenImpl;

};

#include <Fnd0formulamgmt/libfnd0formulamgmt_undef.h>
#endif  //  TEAMCENTER__FND0FORMULACONVERSIONDELEGATE_HXX
