//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0GenericConversionRule
    Filename:   Fnd0GenericConversionRule.hxx
    Module:     Fnd0formulamgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0GENERICCONVERSIONRULE__HXX
#define TEAMCENTER__FND0GENERICCONVERSIONRULE__HXX

#include <vector>
#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <Fnd0formulamgmt/libfnd0formulamgmt_exports.h>

namespace Teamcenter
{
    class Fnd0GenericConversionRule;
}
namespace Teamcenter
{
    class Fnd0GenericConversionRuleImpl;
}
namespace Teamcenter
{
    class Fnd0GenericConversionRuleDelegate;
}
namespace Teamcenter
{
    class Fnd0GenericConversionRuleDispatch;
}
namespace Teamcenter
{
    class Fnd0GenericConversionRuleGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0FORMULAMGMT_API  Teamcenter::Fnd0GenericConversionRule
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0Description( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0Name( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0Description( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0Name( const std::string &value, bool isNull=false );

    ///
    /// Compute the conversion rule
    /// @version Teamcenter 9.1
    /// @param variableValues - List of variable values
    /// @param computedResult - Computed result
    /// @return - Status. Return 0 if successful
    ///
    int  fnd0Compute( const std::vector< std::string > &variableValues, std::string &computedResult );

    ///
    /// Compute the conversion rule
    /// @version Teamcenter 9.1
    /// @param variableGrpValues - Vector of variable group values
    /// @param grpCount - Group count
    /// @param computedGrpResults - Vector of computed group results
    /// @return - Status. Return 0 if successful
    ///
    int  fnd0Compute( const std::vector< std::string > *variableGrpValues, int grpCount, std::vector< std::string > *computedGrpResults );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0GenericConversionRule();

    /**
     * Destructor
     */
    virtual ~Fnd0GenericConversionRule();

private:
    //  Getter method for the Implementation Object
    Fnd0GenericConversionRuleImpl*  getFnd0GenericConversionRuleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0GenericConversionRuleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0GenericConversionRuleImpl*  m_fnd0genericconversionruleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0GenericConversionRule - desc for Fnd0GenericConversionRule parameter
     */
    Fnd0GenericConversionRule( const Fnd0GenericConversionRule& );
    Fnd0GenericConversionRule& operator=( const Fnd0GenericConversionRule& );

    friend class  Fnd0GenericConversionRuleDelegate;
    friend class  Fnd0GenericConversionRuleDispatch;
    friend class  Fnd0GenericConversionRuleGenImpl;
};

#include <Fnd0formulamgmt/libfnd0formulamgmt_undef.h>
#endif //   TEAMCENTER__FND0GENERICCONVERSIONRULE__HXX
