//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0GenericConversionRuleDelegate
    Filename:   Fnd0GenericConversionRuleDelegate.hxx
    Module:     Fnd0formulamgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0GENERICCONVERSIONRULEDELEGATE_HXX
#define TEAMCENTER__FND0GENERICCONVERSIONRULEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Fnd0formulamgmt/Fnd0GenericConversionRule.hxx>

#include <Fnd0formulamgmt/libfnd0formulamgmt_exports.h>

namespace Teamcenter
{
    class Fnd0GenericConversionRuleDelegate;
}
namespace Teamcenter
{
    class Fnd0GenericConversionRuleImpl;
}
namespace Teamcenter
{
    class Fnd0GenericConversionRule;
}
namespace Teamcenter
{
    class Fnd0GenericConversionRuleGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  FND0FORMULAMGMT_API Teamcenter_alias::Fnd0GenericConversionRuleDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0GenericConversionRuleDelegate instance
    static Fnd0GenericConversionRuleDelegate&  getInstance();

    //  Method to create the Fnd0GenericConversionRuleImpl pointer
    static Fnd0GenericConversionRuleImpl*  createImpl( Fnd0GenericConversionRule&  ifObj );

    //  Method to delete the Fnd0GenericConversionRuleImpl pointer
    static void deleteImpl( Fnd0GenericConversionRuleImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0DescriptionBase(const Fnd0GenericConversionRule &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0NameBase(const Fnd0GenericConversionRule &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0DescriptionBase(Fnd0GenericConversionRule &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0NameBase(Fnd0GenericConversionRule &ifObj,  const std::string &value, bool isNull );


    ///
    /// Compute the conversion rule
    /// @version Teamcenter 9.1
    /// @param variableValues - List of variable values
    /// @param computedResult - Computed result
    /// @return - Status. Return 0 if successful
    ///
    int  fnd0ComputeBase(const Fnd0GenericConversionRule &ifObj,  const std::vector< std::string > &variableValues, std::string &computedResult );


    ///
    /// Compute the conversion rule
    /// @version Teamcenter 9.1
    /// @param variableGrpValues - Vector of variable group values
    /// @param grpCount - Group count
    /// @param computedGrpResults - Vector of computed group results
    /// @return - Status. Return 0 if successful
    ///
    int  fnd0ComputeBase(const Fnd0GenericConversionRule &ifObj,  const std::vector< std::string > *variableGrpValues, int grpCount, std::vector< std::string > *computedGrpResults );



protected:
    //  Pointer to the instance
    static Fnd0GenericConversionRuleDelegate*  m_pInstance;

    Fnd0GenericConversionRuleDelegate();
    virtual ~Fnd0GenericConversionRuleDelegate();
    static void setInstance( Fnd0GenericConversionRuleDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0GenericConversionRuleGenImpl;

};

#include <Fnd0formulamgmt/libfnd0formulamgmt_undef.h>
#endif  //  TEAMCENTER__FND0GENERICCONVERSIONRULEDELEGATE_HXX
