//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0RangeConversion
    Filename:   Fnd0RangeConversion.hxx
    Module:     Fnd0formulamgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0RANGECONVERSION__HXX
#define TEAMCENTER__FND0RANGECONVERSION__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <Fnd0formulamgmt/Fnd0RecordConversion.hxx>

#include <Fnd0formulamgmt/libfnd0formulamgmt_exports.h>

namespace Teamcenter
{
    class Fnd0RangeConversion;
}
namespace Teamcenter
{
    class Fnd0RangeConversionImpl;
}
namespace Teamcenter
{
    class Fnd0RangeConversionDelegate;
}
namespace Teamcenter
{
    class Fnd0RangeConversionDispatch;
}
namespace Teamcenter
{
    class Fnd0RangeConversionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0FORMULAMGMT_API  Teamcenter::Fnd0RangeConversion
     : public  ::Teamcenter::Fnd0RecordConversion
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0MaxValue( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0MinValue( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0MaxValue( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0MinValue( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0RangeConversion();

    /**
     * Destructor
     */
    virtual ~Fnd0RangeConversion();

private:
    //  Getter method for the Implementation Object
    Fnd0RangeConversionImpl*  getFnd0RangeConversionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0RangeConversionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0RangeConversionImpl*  m_fnd0rangeconversionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0RangeConversion - desc for Fnd0RangeConversion parameter
     */
    Fnd0RangeConversion( const Fnd0RangeConversion& );
    Fnd0RangeConversion& operator=( const Fnd0RangeConversion& );

    friend class  Fnd0RangeConversionDelegate;
    friend class  Fnd0RangeConversionDispatch;
    friend class  Fnd0RangeConversionGenImpl;
};

#include <Fnd0formulamgmt/libfnd0formulamgmt_undef.h>
#endif //   TEAMCENTER__FND0RANGECONVERSION__HXX
