//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0RangeConversionDelegate
    Filename:   Fnd0RangeConversionDelegate.hxx
    Module:     Fnd0formulamgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0RANGECONVERSIONDELEGATE_HXX
#define TEAMCENTER__FND0RANGECONVERSIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Fnd0formulamgmt/Fnd0RangeConversion.hxx>

#include <Fnd0formulamgmt/libfnd0formulamgmt_exports.h>

namespace Teamcenter
{
    class Fnd0RangeConversionDelegate;
}
namespace Teamcenter
{
    class Fnd0RangeConversionImpl;
}
namespace Teamcenter
{
    class Fnd0RangeConversion;
}
namespace Teamcenter
{
    class Fnd0RangeConversionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  FND0FORMULAMGMT_API Teamcenter_alias::Fnd0RangeConversionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0RangeConversionDelegate instance
    static Fnd0RangeConversionDelegate&  getInstance();

    //  Method to create the Fnd0RangeConversionImpl pointer
    static Fnd0RangeConversionImpl*  createImpl( Fnd0RangeConversion&  ifObj );

    //  Method to delete the Fnd0RangeConversionImpl pointer
    static void deleteImpl( Fnd0RangeConversionImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0MaxValueBase(const Fnd0RangeConversion &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0MinValueBase(const Fnd0RangeConversion &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0MaxValueBase(Fnd0RangeConversion &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0MinValueBase(Fnd0RangeConversion &ifObj,  const std::string &value, bool isNull );


    ///
    /// Check if the input value can match the record conversion
    /// @version Teamcenter 9.1
    /// @param inputValue - Input value
    /// @param isFound - Flag to identify if the input value can match the record conversion
    /// @return - Status. Return 0 if succssful.
    ///
    int  fnd0FindBase(const Fnd0RangeConversion &ifObj,  const std::string &inputValue, bool &isFound );



protected:
    //  Pointer to the instance
    static Fnd0RangeConversionDelegate*  m_pInstance;

    Fnd0RangeConversionDelegate();
    virtual ~Fnd0RangeConversionDelegate();
    static void setInstance( Fnd0RangeConversionDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0RangeConversionGenImpl;

};

#include <Fnd0formulamgmt/libfnd0formulamgmt_undef.h>
#endif  //  TEAMCENTER__FND0RANGECONVERSIONDELEGATE_HXX
