//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0RecordColConversion
    Filename:   Fnd0RecordColConversion.hxx
    Module:     Fnd0formulamgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0RECORDCOLCONVERSION__HXX
#define TEAMCENTER__FND0RECORDCOLCONVERSION__HXX

#include <string>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <Fnd0formulamgmt/Fnd0GenericConversionRule.hxx>

#include <Fnd0formulamgmt/libfnd0formulamgmt_exports.h>

namespace Teamcenter
{
    class Fnd0RecordColConversion;
}
namespace Teamcenter
{
    class Fnd0RecordColConversionImpl;
}
namespace Teamcenter
{
    class Fnd0RecordColConversionDelegate;
}
namespace Teamcenter
{
    class Fnd0RecordColConversionDispatch;
}
namespace Teamcenter
{
    class Fnd0RecordColConversionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0FORMULAMGMT_API  Teamcenter::Fnd0RecordColConversion
     : public  ::Teamcenter::Fnd0GenericConversionRule
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0DefaultValue( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0RecordConversions( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0WithInterpolation( bool &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0DefaultValue( const std::string &value, bool isNull=false );

    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 9.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0RecordConversions( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );

    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0WithInterpolation( bool value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0RecordColConversion();

    /**
     * Destructor
     */
    virtual ~Fnd0RecordColConversion();

private:
    //  Getter method for the Implementation Object
    Fnd0RecordColConversionImpl*  getFnd0RecordColConversionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0RecordColConversionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0RecordColConversionImpl*  m_fnd0recordcolconversionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0RecordColConversion - desc for Fnd0RecordColConversion parameter
     */
    Fnd0RecordColConversion( const Fnd0RecordColConversion& );
    Fnd0RecordColConversion& operator=( const Fnd0RecordColConversion& );

    friend class  Fnd0RecordColConversionDelegate;
    friend class  Fnd0RecordColConversionDispatch;
    friend class  Fnd0RecordColConversionGenImpl;
};

#include <Fnd0formulamgmt/libfnd0formulamgmt_undef.h>
#endif //   TEAMCENTER__FND0RECORDCOLCONVERSION__HXX
