//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0RecordColConversionDelegate
    Filename:   Fnd0RecordColConversionDelegate.hxx
    Module:     Fnd0formulamgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0RECORDCOLCONVERSIONDELEGATE_HXX
#define TEAMCENTER__FND0RECORDCOLCONVERSIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Fnd0formulamgmt/Fnd0RecordColConversion.hxx>

#include <Fnd0formulamgmt/libfnd0formulamgmt_exports.h>

namespace Teamcenter
{
    class Fnd0RecordColConversionDelegate;
}
namespace Teamcenter
{
    class Fnd0RecordColConversionImpl;
}
namespace Teamcenter
{
    class Fnd0RecordColConversion;
}
namespace Teamcenter
{
    class Fnd0RecordColConversionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  FND0FORMULAMGMT_API Teamcenter_alias::Fnd0RecordColConversionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0RecordColConversionDelegate instance
    static Fnd0RecordColConversionDelegate&  getInstance();

    //  Method to create the Fnd0RecordColConversionImpl pointer
    static Fnd0RecordColConversionImpl*  createImpl( Fnd0RecordColConversion&  ifObj );

    //  Method to delete the Fnd0RecordColConversionImpl pointer
    static void deleteImpl( Fnd0RecordColConversionImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0DefaultValueBase(const Fnd0RecordColConversion &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0RecordConversionsBase(const Fnd0RecordColConversion &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0WithInterpolationBase(const Fnd0RecordColConversion &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0DefaultValueBase(Fnd0RecordColConversion &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 9.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0RecordConversionsBase(Fnd0RecordColConversion &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0WithInterpolationBase(Fnd0RecordColConversion &ifObj,  bool value, bool isNull );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Fnd0RecordColConversion &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Compute the conversion rule
    /// @version Teamcenter 9.1
    /// @param variableValues - List of variable values
    /// @param computedResult - Computed result
    /// @return - Status. Return 0 if successful
    ///
    int  fnd0ComputeBase(const Fnd0RecordColConversion &ifObj,  const std::vector< std::string > &variableValues, std::string &computedResult );


    ///
    /// Compute the conversion rule
    /// @version Teamcenter 9.1
    /// @param variableGrpValues - Vector of variable group values
    /// @param grpCount - Group count
    /// @param computedGrpResults - Vector of computed group results
    /// @return - Status. Return 0 if successful
    ///
    int  fnd0ComputeBase(const Fnd0RecordColConversion &ifObj,  const std::vector< std::string > *variableGrpValues, int grpCount, std::vector< std::string > *computedGrpResults );



protected:
    //  Pointer to the instance
    static Fnd0RecordColConversionDelegate*  m_pInstance;

    Fnd0RecordColConversionDelegate();
    virtual ~Fnd0RecordColConversionDelegate();
    static void setInstance( Fnd0RecordColConversionDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0RecordColConversionGenImpl;

};

#include <Fnd0formulamgmt/libfnd0formulamgmt_undef.h>
#endif  //  TEAMCENTER__FND0RECORDCOLCONVERSIONDELEGATE_HXX
