//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0RecordConversion
    Filename:   Fnd0RecordConversion.hxx
    Module:     Fnd0formulamgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0RECORDCONVERSION__HXX
#define TEAMCENTER__FND0RECORDCONVERSION__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <Fnd0formulamgmt/libfnd0formulamgmt_exports.h>

namespace Teamcenter
{
    class Fnd0RecordConversion;
}
namespace Teamcenter
{
    class Fnd0RecordConversionImpl;
}
namespace Teamcenter
{
    class Fnd0RecordConversionDelegate;
}
namespace Teamcenter
{
    class Fnd0RecordConversionDispatch;
}
namespace Teamcenter
{
    class Fnd0RecordConversionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0FORMULAMGMT_API  Teamcenter::Fnd0RecordConversion
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0OutputValue( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0OutputValue( const std::string &value, bool isNull=false );

    ///
    /// Check if the input value can match the record conversion
    /// @version Teamcenter 9.1
    /// @param inputValue - Input value
    /// @param isFound - Flag to identify if the input value can match the record conversion
    /// @return - Status. Return 0 if succssful.
    ///
    int  fnd0Find( const std::string &inputValue, bool &isFound );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0RecordConversion();

    /**
     * Destructor
     */
    virtual ~Fnd0RecordConversion();

private:
    //  Getter method for the Implementation Object
    Fnd0RecordConversionImpl*  getFnd0RecordConversionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0RecordConversionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0RecordConversionImpl*  m_fnd0recordconversionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0RecordConversion - desc for Fnd0RecordConversion parameter
     */
    Fnd0RecordConversion( const Fnd0RecordConversion& );
    Fnd0RecordConversion& operator=( const Fnd0RecordConversion& );

    friend class  Fnd0RecordConversionDelegate;
    friend class  Fnd0RecordConversionDispatch;
    friend class  Fnd0RecordConversionGenImpl;
};

#include <Fnd0formulamgmt/libfnd0formulamgmt_undef.h>
#endif //   TEAMCENTER__FND0RECORDCONVERSION__HXX
