//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0RecordConversionDelegate
    Filename:   Fnd0RecordConversionDelegate.hxx
    Module:     Fnd0formulamgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0RECORDCONVERSIONDELEGATE_HXX
#define TEAMCENTER__FND0RECORDCONVERSIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Fnd0formulamgmt/Fnd0RecordConversion.hxx>

#include <Fnd0formulamgmt/libfnd0formulamgmt_exports.h>

namespace Teamcenter
{
    class Fnd0RecordConversionDelegate;
}
namespace Teamcenter
{
    class Fnd0RecordConversionImpl;
}
namespace Teamcenter
{
    class Fnd0RecordConversion;
}
namespace Teamcenter
{
    class Fnd0RecordConversionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  FND0FORMULAMGMT_API Teamcenter_alias::Fnd0RecordConversionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0RecordConversionDelegate instance
    static Fnd0RecordConversionDelegate&  getInstance();

    //  Method to create the Fnd0RecordConversionImpl pointer
    static Fnd0RecordConversionImpl*  createImpl( Fnd0RecordConversion&  ifObj );

    //  Method to delete the Fnd0RecordConversionImpl pointer
    static void deleteImpl( Fnd0RecordConversionImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0OutputValueBase(const Fnd0RecordConversion &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0OutputValueBase(Fnd0RecordConversion &ifObj,  const std::string &value, bool isNull );


    ///
    /// Check if the input value can match the record conversion
    /// @version Teamcenter 9.1
    /// @param inputValue - Input value
    /// @param isFound - Flag to identify if the input value can match the record conversion
    /// @return - Status. Return 0 if succssful.
    ///
    int  fnd0FindBase(const Fnd0RecordConversion &ifObj,  const std::string &inputValue, bool &isFound );



protected:
    //  Pointer to the instance
    static Fnd0RecordConversionDelegate*  m_pInstance;

    Fnd0RecordConversionDelegate();
    virtual ~Fnd0RecordConversionDelegate();
    static void setInstance( Fnd0RecordConversionDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0RecordConversionGenImpl;

};

#include <Fnd0formulamgmt/libfnd0formulamgmt_undef.h>
#endif  //  TEAMCENTER__FND0RECORDCONVERSIONDELEGATE_HXX
