//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ValueConversion
    Filename:   Fnd0ValueConversion.hxx
    Module:     Fnd0formulamgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0VALUECONVERSION__HXX
#define TEAMCENTER__FND0VALUECONVERSION__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <Fnd0formulamgmt/Fnd0RecordConversion.hxx>

#include <Fnd0formulamgmt/libfnd0formulamgmt_exports.h>

namespace Teamcenter
{
    class Fnd0ValueConversion;
}
namespace Teamcenter
{
    class Fnd0ValueConversionImpl;
}
namespace Teamcenter
{
    class Fnd0ValueConversionDelegate;
}
namespace Teamcenter
{
    class Fnd0ValueConversionDispatch;
}
namespace Teamcenter
{
    class Fnd0ValueConversionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0FORMULAMGMT_API  Teamcenter::Fnd0ValueConversion
     : public  ::Teamcenter::Fnd0RecordConversion
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0InputValue( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0InputValue( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0ValueConversion();

    /**
     * Destructor
     */
    virtual ~Fnd0ValueConversion();

private:
    //  Getter method for the Implementation Object
    Fnd0ValueConversionImpl*  getFnd0ValueConversionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0ValueConversionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0ValueConversionImpl*  m_fnd0valueconversionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0ValueConversion - desc for Fnd0ValueConversion parameter
     */
    Fnd0ValueConversion( const Fnd0ValueConversion& );
    Fnd0ValueConversion& operator=( const Fnd0ValueConversion& );

    friend class  Fnd0ValueConversionDelegate;
    friend class  Fnd0ValueConversionDispatch;
    friend class  Fnd0ValueConversionGenImpl;
};

#include <Fnd0formulamgmt/libfnd0formulamgmt_undef.h>
#endif //   TEAMCENTER__FND0VALUECONVERSION__HXX
