//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ValueConversionDelegate
    Filename:   Fnd0ValueConversionDelegate.hxx
    Module:     Fnd0formulamgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0VALUECONVERSIONDELEGATE_HXX
#define TEAMCENTER__FND0VALUECONVERSIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Fnd0formulamgmt/Fnd0ValueConversion.hxx>

#include <Fnd0formulamgmt/libfnd0formulamgmt_exports.h>

namespace Teamcenter
{
    class Fnd0ValueConversionDelegate;
}
namespace Teamcenter
{
    class Fnd0ValueConversionImpl;
}
namespace Teamcenter
{
    class Fnd0ValueConversion;
}
namespace Teamcenter
{
    class Fnd0ValueConversionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  FND0FORMULAMGMT_API Teamcenter_alias::Fnd0ValueConversionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0ValueConversionDelegate instance
    static Fnd0ValueConversionDelegate&  getInstance();

    //  Method to create the Fnd0ValueConversionImpl pointer
    static Fnd0ValueConversionImpl*  createImpl( Fnd0ValueConversion&  ifObj );

    //  Method to delete the Fnd0ValueConversionImpl pointer
    static void deleteImpl( Fnd0ValueConversionImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0InputValueBase(const Fnd0ValueConversion &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0InputValueBase(Fnd0ValueConversion &ifObj,  const std::string &value, bool isNull );


    ///
    /// Check if the input value can match the record conversion
    /// @version Teamcenter 9.1
    /// @param inputValue - Input value
    /// @param isFound - Flag to identify if the input value can match the record conversion
    /// @return - Status. Return 0 if succssful.
    ///
    int  fnd0FindBase(const Fnd0ValueConversion &ifObj,  const std::string &inputValue, bool &isFound );



protected:
    //  Pointer to the instance
    static Fnd0ValueConversionDelegate*  m_pInstance;

    Fnd0ValueConversionDelegate();
    virtual ~Fnd0ValueConversionDelegate();
    static void setInstance( Fnd0ValueConversionDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0ValueConversionGenImpl;

};

#include <Fnd0formulamgmt/libfnd0formulamgmt_undef.h>
#endif  //  TEAMCENTER__FND0VALUECONVERSIONDELEGATE_HXX
