//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0MMVCursor
    Filename:   Fnd0MMVCursor.hxx
    Module:     Fnd0mmv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0MMVCURSOR__HXX
#define TEAMCENTER__FND0MMVCURSOR__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <Fnd0mmv/libfnd0mmv_exports.h>

namespace Teamcenter
{
    class Fnd0MMVCursor;
}
namespace Teamcenter
{
    class Fnd0MMVCursorImpl;
}
namespace Teamcenter
{
    class Fnd0MMVCursorDelegate;
}
namespace Teamcenter
{
    class Fnd0MMVCursorDispatch;
}
namespace Teamcenter
{
    class Fnd0MMVCursorGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0MMV_API  Teamcenter::Fnd0MMVCursor
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0MMVCursor();

    /**
     * Destructor
     */
    virtual ~Fnd0MMVCursor();

private:
    //  Getter method for the Implementation Object
    Fnd0MMVCursorImpl*  getFnd0MMVCursorImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0MMVCursorImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0MMVCursorImpl*  m_fnd0mmvcursorImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0MMVCursor - desc for Fnd0MMVCursor parameter
     */
    Fnd0MMVCursor( const Fnd0MMVCursor& );
    Fnd0MMVCursor& operator=( const Fnd0MMVCursor& );

    friend class  Fnd0MMVCursorDelegate;
    friend class  Fnd0MMVCursorDispatch;
    friend class  Fnd0MMVCursorGenImpl;
};

#include <Fnd0mmv/libfnd0mmv_undef.h>
#endif //   TEAMCENTER__FND0MMVCURSOR__HXX
