//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  Fnd0mmv

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libFnd0mmv

#if !defined(LIBFND0MMV) && !defined(IPLIB)
#   error IPLIB or LIBFND0MMV is not defined
#endif

/* Handwritten code should use FND0MMV_API, not FND0MMVEXPORT */

#define FND0MMV_API FND0MMVEXPORT

#if IPLIB==libFnd0mmv || defined(LIBFND0MMV)
#   if defined(__lint)
#       define FND0MMVEXPORT       __export(Fnd0mmv)
#       define FND0MMVGLOBAL       extern __global(Fnd0mmv)
#       define FND0MMVPRIVATE      extern __private(Fnd0mmv)
#   elif defined(_WIN32)
#       define FND0MMVEXPORT       __declspec(dllexport)
#       define FND0MMVGLOBAL       extern __declspec(dllexport)
#       define FND0MMVPRIVATE      extern
#   else
#       define FND0MMVEXPORT
#       define FND0MMVGLOBAL       extern
#       define FND0MMVPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define FND0MMVEXPORT       __export(Fnd0mmv)
#       define FND0MMVGLOBAL       extern __global(Fnd0mmv)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define FND0MMVEXPORT      __declspec(dllimport)
#       define FND0MMVGLOBAL       extern __declspec(dllimport)
#   else
#       define FND0MMVEXPORT
#       define FND0MMVGLOBAL       extern
#   endif
#endif
