//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0Diagram
    Filename:   Fnd0Diagram.hxx
    Module:     Fnd0nweditor
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0DIAGRAM__HXX
#define TEAMCENTER__FND0DIAGRAM__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <Fnd0nweditor/libfnd0nweditor_exports.h>

namespace Teamcenter
{
    class Fnd0Diagram;
}
namespace Teamcenter
{
    class Fnd0DiagramImpl;
}
namespace Teamcenter
{
    class Fnd0DiagramDelegate;
}
namespace Teamcenter
{
    class Fnd0DiagramDispatch;
}
namespace Teamcenter
{
    class Fnd0DiagramGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0NWEDITOR_API  Teamcenter::Fnd0Diagram
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0Diagram();

    /**
     * Destructor
     */
    virtual ~Fnd0Diagram();

private:
    //  Getter method for the Implementation Object
    Fnd0DiagramImpl*  getFnd0DiagramImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0DiagramImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0DiagramImpl*  m_fnd0diagramImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0Diagram - desc for Fnd0Diagram parameter
     */
    Fnd0Diagram( const Fnd0Diagram& );
    Fnd0Diagram& operator=( const Fnd0Diagram& );

    friend class  Fnd0DiagramDelegate;
    friend class  Fnd0DiagramDispatch;
    friend class  Fnd0DiagramGenImpl;
};

#include <Fnd0nweditor/libfnd0nweditor_undef.h>
#endif //   TEAMCENTER__FND0DIAGRAM__HXX
