//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0DiagramRevision
    Filename:   Fnd0DiagramRevision.hxx
    Module:     Fnd0nweditor
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0DIAGRAMREVISION__HXX
#define TEAMCENTER__FND0DIAGRAMREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <Fnd0nweditor/libfnd0nweditor_exports.h>

namespace Teamcenter
{
    class Fnd0DiagramRevision;
}
namespace Teamcenter
{
    class Fnd0DiagramRevisionImpl;
}
namespace Teamcenter
{
    class Fnd0DiagramRevisionDelegate;
}
namespace Teamcenter
{
    class Fnd0DiagramRevisionDispatch;
}
namespace Teamcenter
{
    class Fnd0DiagramRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0NWEDITOR_API  Teamcenter::Fnd0DiagramRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0DiagramRevision();

    /**
     * Destructor
     */
    virtual ~Fnd0DiagramRevision();

private:
    //  Getter method for the Implementation Object
    Fnd0DiagramRevisionImpl*  getFnd0DiagramRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0DiagramRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0DiagramRevisionImpl*  m_fnd0diagramrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0DiagramRevision - desc for Fnd0DiagramRevision parameter
     */
    Fnd0DiagramRevision( const Fnd0DiagramRevision& );
    Fnd0DiagramRevision& operator=( const Fnd0DiagramRevision& );

    friend class  Fnd0DiagramRevisionDelegate;
    friend class  Fnd0DiagramRevisionDispatch;
    friend class  Fnd0DiagramRevisionGenImpl;
};

#include <Fnd0nweditor/libfnd0nweditor_undef.h>
#endif //   TEAMCENTER__FND0DIAGRAMREVISION__HXX
