//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0DiagramRules
    Filename:   Fnd0DiagramRules.hxx
    Module:     Fnd0nweditor
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0DIAGRAMRULES__HXX
#define TEAMCENTER__FND0DIAGRAMRULES__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <Fnd0nweditor/libfnd0nweditor_exports.h>

namespace Teamcenter
{
    class Fnd0DiagramRules;
}
namespace Teamcenter
{
    class Fnd0DiagramRulesImpl;
}
namespace Teamcenter
{
    class Fnd0DiagramRulesDelegate;
}
namespace Teamcenter
{
    class Fnd0DiagramRulesDispatch;
}
namespace Teamcenter
{
    class Fnd0DiagramRulesGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0NWEDITOR_API  Teamcenter::Fnd0DiagramRules
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0DiagramRules();

    /**
     * Destructor
     */
    virtual ~Fnd0DiagramRules();

private:
    //  Getter method for the Implementation Object
    Fnd0DiagramRulesImpl*  getFnd0DiagramRulesImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0DiagramRulesImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0DiagramRulesImpl*  m_fnd0diagramrulesImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0DiagramRules - desc for Fnd0DiagramRules parameter
     */
    Fnd0DiagramRules( const Fnd0DiagramRules& );
    Fnd0DiagramRules& operator=( const Fnd0DiagramRules& );

    friend class  Fnd0DiagramRulesDelegate;
    friend class  Fnd0DiagramRulesDispatch;
    friend class  Fnd0DiagramRulesGenImpl;
};

#include <Fnd0nweditor/libfnd0nweditor_undef.h>
#endif //   TEAMCENTER__FND0DIAGRAMRULES__HXX
