//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0DiagramSnapshot
    Filename:   Fnd0DiagramSnapshot.hxx
    Module:     Fnd0nweditor
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0DIAGRAMSNAPSHOT__HXX
#define TEAMCENTER__FND0DIAGRAMSNAPSHOT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <Fnd0nweditor/libfnd0nweditor_exports.h>

namespace Teamcenter
{
    class Fnd0DiagramSnapshot;
}
namespace Teamcenter
{
    class Fnd0DiagramSnapshotImpl;
}
namespace Teamcenter
{
    class Fnd0DiagramSnapshotDelegate;
}
namespace Teamcenter
{
    class Fnd0DiagramSnapshotDispatch;
}
namespace Teamcenter
{
    class Fnd0DiagramSnapshotGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0NWEDITOR_API  Teamcenter::Fnd0DiagramSnapshot
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0DiagramSnapshot();

    /**
     * Destructor
     */
    virtual ~Fnd0DiagramSnapshot();

private:
    //  Getter method for the Implementation Object
    Fnd0DiagramSnapshotImpl*  getFnd0DiagramSnapshotImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0DiagramSnapshotImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0DiagramSnapshotImpl*  m_fnd0diagramsnapshotImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0DiagramSnapshot - desc for Fnd0DiagramSnapshot parameter
     */
    Fnd0DiagramSnapshot( const Fnd0DiagramSnapshot& );
    Fnd0DiagramSnapshot& operator=( const Fnd0DiagramSnapshot& );

    friend class  Fnd0DiagramSnapshotDelegate;
    friend class  Fnd0DiagramSnapshotDispatch;
    friend class  Fnd0DiagramSnapshotGenImpl;
};

#include <Fnd0nweditor/libfnd0nweditor_undef.h>
#endif //   TEAMCENTER__FND0DIAGRAMSNAPSHOT__HXX
