//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ShapeRelation
    Filename:   Fnd0ShapeRelation.hxx
    Module:     Fnd0nweditor
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0SHAPERELATION__HXX
#define TEAMCENTER__FND0SHAPERELATION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <Fnd0nweditor/libfnd0nweditor_exports.h>

namespace Teamcenter
{
    class Fnd0ShapeRelation;
}
namespace Teamcenter
{
    class Fnd0ShapeRelationImpl;
}
namespace Teamcenter
{
    class Fnd0ShapeRelationDelegate;
}
namespace Teamcenter
{
    class Fnd0ShapeRelationDispatch;
}
namespace Teamcenter
{
    class Fnd0ShapeRelationGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0NWEDITOR_API  Teamcenter::Fnd0ShapeRelation
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0ShapeRelation();

    /**
     * Destructor
     */
    virtual ~Fnd0ShapeRelation();

private:
    //  Getter method for the Implementation Object
    Fnd0ShapeRelationImpl*  getFnd0ShapeRelationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0ShapeRelationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0ShapeRelationImpl*  m_fnd0shaperelationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0ShapeRelation - desc for Fnd0ShapeRelation parameter
     */
    Fnd0ShapeRelation( const Fnd0ShapeRelation& );
    Fnd0ShapeRelation& operator=( const Fnd0ShapeRelation& );

    friend class  Fnd0ShapeRelationDelegate;
    friend class  Fnd0ShapeRelationDispatch;
    friend class  Fnd0ShapeRelationGenImpl;
};

#include <Fnd0nweditor/libfnd0nweditor_undef.h>
#endif //   TEAMCENTER__FND0SHAPERELATION__HXX
