//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0VisioTmpl
    Filename:   Fnd0VisioTmpl.hxx
    Module:     Fnd0nweditor
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0VISIOTMPL__HXX
#define TEAMCENTER__FND0VISIOTMPL__HXX

#include <common/tc_deprecation_macros.h>
#include <Fnd0nweditor/Fnd0DiagramTmpl.hxx>

#include <Fnd0nweditor/libfnd0nweditor_exports.h>

namespace Teamcenter
{
    class Fnd0VisioTmpl;
}
namespace Teamcenter
{
    class Fnd0VisioTmplImpl;
}
namespace Teamcenter
{
    class Fnd0VisioTmplDelegate;
}
namespace Teamcenter
{
    class Fnd0VisioTmplDispatch;
}
namespace Teamcenter
{
    class Fnd0VisioTmplGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0NWEDITOR_API  Teamcenter::Fnd0VisioTmpl
     : public  ::Teamcenter::Fnd0DiagramTmpl
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0VisioTmpl();

    /**
     * Destructor
     */
    virtual ~Fnd0VisioTmpl();

private:
    //  Getter method for the Implementation Object
    Fnd0VisioTmplImpl*  getFnd0VisioTmplImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0VisioTmplImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0VisioTmplImpl*  m_fnd0visiotmplImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0VisioTmpl - desc for Fnd0VisioTmpl parameter
     */
    Fnd0VisioTmpl( const Fnd0VisioTmpl& );
    Fnd0VisioTmpl& operator=( const Fnd0VisioTmpl& );

    friend class  Fnd0VisioTmplDelegate;
    friend class  Fnd0VisioTmplDispatch;
    friend class  Fnd0VisioTmplGenImpl;
};

#include <Fnd0nweditor/libfnd0nweditor_undef.h>
#endif //   TEAMCENTER__FND0VISIOTMPL__HXX
