//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ProfilerDelegate
    Filename:   Fnd0ProfilerDelegate.hxx
    Module:     Fnd0profiler
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0PROFILERDELEGATE_HXX
#define TEAMCENTER__FND0PROFILERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Fnd0profiler/Fnd0Profiler.hxx>

#include <Fnd0profiler/libfnd0profiler_exports.h>

namespace Teamcenter
{
    class Fnd0ProfilerDelegate;
}
namespace Teamcenter
{
    class Fnd0ProfilerImpl;
}
namespace Teamcenter
{
    class Fnd0Profiler;
}
namespace Teamcenter
{
    class Fnd0ProfilerGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  FND0PROFILER_API Teamcenter_alias::Fnd0ProfilerDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0ProfilerDelegate instance
    static Fnd0ProfilerDelegate&  getInstance();

    //  Method to create the Fnd0ProfilerImpl pointer
    static Fnd0ProfilerImpl*  createImpl( Fnd0Profiler&  ifObj );

    //  Method to delete the Fnd0ProfilerImpl pointer
    static void deleteImpl( Fnd0ProfilerImpl*  impl );


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0cpu_timeBase(const Fnd0Profiler &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0db_timeBase(const Fnd0Profiler &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0process_memory_usageBase(const Fnd0Profiler &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0server_request_idBase(const Fnd0Profiler &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0server_request_nameBase(const Fnd0Profiler &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0sm_memory_usageBase(const Fnd0Profiler &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0sql_countBase(const Fnd0Profiler &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0wall_clock_timeBase(const Fnd0Profiler &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Setter for a Double Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0cpu_timeBase(Fnd0Profiler &ifObj,  double value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0db_timeBase(Fnd0Profiler &ifObj,  double value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0process_memory_usageBase(Fnd0Profiler &ifObj,  double value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0server_request_idBase(Fnd0Profiler &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0server_request_nameBase(Fnd0Profiler &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0sm_memory_usageBase(Fnd0Profiler &ifObj,  double value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0sql_countBase(Fnd0Profiler &ifObj,  int value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0wall_clock_timeBase(Fnd0Profiler &ifObj,  double value, bool isNull );



protected:
    //  Pointer to the instance
    static Fnd0ProfilerDelegate*  m_pInstance;

    Fnd0ProfilerDelegate();
    virtual ~Fnd0ProfilerDelegate();
    static void setInstance( Fnd0ProfilerDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0ProfilerGenImpl;

};

#include <Fnd0profiler/libfnd0profiler_undef.h>
#endif  //  TEAMCENTER__FND0PROFILERDELEGATE_HXX
