//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  Fnd0profiler

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libFnd0profiler

#if !defined(LIBFND0PROFILER) && !defined(IPLIB)
#   error IPLIB or LIBFND0PROFILER is not defined
#endif

/* Handwritten code should use FND0PROFILER_API, not FND0PROFILEREXPORT */

#define FND0PROFILER_API FND0PROFILEREXPORT

#if IPLIB==libFnd0profiler || defined(LIBFND0PROFILER)
#   if defined(__lint)
#       define FND0PROFILEREXPORT       __export(Fnd0profiler)
#       define FND0PROFILERGLOBAL       extern __global(Fnd0profiler)
#       define FND0PROFILERPRIVATE      extern __private(Fnd0profiler)
#   elif defined(_WIN32)
#       define FND0PROFILEREXPORT       __declspec(dllexport)
#       define FND0PROFILERGLOBAL       extern __declspec(dllexport)
#       define FND0PROFILERPRIVATE      extern
#   else
#       define FND0PROFILEREXPORT
#       define FND0PROFILERGLOBAL       extern
#       define FND0PROFILERPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define FND0PROFILEREXPORT       __export(Fnd0profiler)
#       define FND0PROFILERGLOBAL       extern __global(Fnd0profiler)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define FND0PROFILEREXPORT      __declspec(dllimport)
#       define FND0PROFILERGLOBAL       extern __declspec(dllimport)
#   else
#       define FND0PROFILEREXPORT
#       define FND0PROFILERGLOBAL       extern
#   endif
#endif
