//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0PropertyRenderer
    Filename:   Fnd0PropertyRenderer.hxx
    Module:     Fnd0propertyrenderer
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0PROPERTYRENDERER__HXX
#define TEAMCENTER__FND0PROPERTYRENDERER__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <Fnd0propertyrenderer/libfnd0propertyrenderer_exports.h>

namespace Teamcenter
{
    class Fnd0PropertyRenderer;
}
namespace Teamcenter
{
    class Fnd0PropertyRendererImpl;
}
namespace Teamcenter
{
    class Fnd0PropertyRendererDelegate;
}
namespace Teamcenter
{
    class Fnd0PropertyRendererDispatch;
}
namespace Teamcenter
{
    class Fnd0PropertyRendererGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0PROPERTYRENDERER_API  Teamcenter::Fnd0PropertyRenderer
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0pr_desc( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0pr_name( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0pr_script( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0pr_desc( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0pr_name( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0pr_script( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0PropertyRenderer();

    /**
     * Destructor
     */
    virtual ~Fnd0PropertyRenderer();

private:
    //  Getter method for the Implementation Object
    Fnd0PropertyRendererImpl*  getFnd0PropertyRendererImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0PropertyRendererImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0PropertyRendererImpl*  m_fnd0propertyrendererImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0PropertyRenderer - desc for Fnd0PropertyRenderer parameter
     */
    Fnd0PropertyRenderer( const Fnd0PropertyRenderer& );
    Fnd0PropertyRenderer& operator=( const Fnd0PropertyRenderer& );

    friend class  Fnd0PropertyRendererDelegate;
    friend class  Fnd0PropertyRendererDispatch;
    friend class  Fnd0PropertyRendererGenImpl;
};

#include <Fnd0propertyrenderer/libfnd0propertyrenderer_undef.h>
#endif //   TEAMCENTER__FND0PROPERTYRENDERER__HXX
