//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0PropertyRendererAttach
    Filename:   Fnd0PropertyRendererAttach.hxx
    Module:     Fnd0propertyrenderer
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0PROPERTYRENDERERATTACH__HXX
#define TEAMCENTER__FND0PROPERTYRENDERERATTACH__HXX

#include <unidefs.h>
#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <Fnd0propertyrenderer/libfnd0propertyrenderer_exports.h>

namespace Teamcenter
{
    class Fnd0PropertyRendererAttach;
}
namespace Teamcenter
{
    class Fnd0PropertyRendererAttachImpl;
}
namespace Teamcenter
{
    class Fnd0PropertyRendererAttachDelegate;
}
namespace Teamcenter
{
    class Fnd0PropertyRendererAttachDispatch;
}
namespace Teamcenter
{
    class Fnd0PropertyRendererAttachGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0PROPERTYRENDERER_API  Teamcenter::Fnd0PropertyRendererAttach
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0condition( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0pr_name( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0property_name( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0type_name( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0condition( const tag_t &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0pr_name( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0property_name( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0type_name( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0PropertyRendererAttach();

    /**
     * Destructor
     */
    virtual ~Fnd0PropertyRendererAttach();

private:
    //  Getter method for the Implementation Object
    Fnd0PropertyRendererAttachImpl*  getFnd0PropertyRendererAttachImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0PropertyRendererAttachImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0PropertyRendererAttachImpl*  m_fnd0propertyrendererattachImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0PropertyRendererAttach - desc for Fnd0PropertyRendererAttach parameter
     */
    Fnd0PropertyRendererAttach( const Fnd0PropertyRendererAttach& );
    Fnd0PropertyRendererAttach& operator=( const Fnd0PropertyRendererAttach& );

    friend class  Fnd0PropertyRendererAttachDelegate;
    friend class  Fnd0PropertyRendererAttachDispatch;
    friend class  Fnd0PropertyRendererAttachGenImpl;
};

#include <Fnd0propertyrenderer/libfnd0propertyrenderer_undef.h>
#endif //   TEAMCENTER__FND0PROPERTYRENDERERATTACH__HXX
