//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0PropertyRendererAttachDelegate
    Filename:   Fnd0PropertyRendererAttachDelegate.hxx
    Module:     Fnd0propertyrenderer
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0PROPERTYRENDERERATTACHDELEGATE_HXX
#define TEAMCENTER__FND0PROPERTYRENDERERATTACHDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Fnd0propertyrenderer/Fnd0PropertyRendererAttach.hxx>

#include <Fnd0propertyrenderer/libfnd0propertyrenderer_exports.h>

namespace Teamcenter
{
    class Fnd0PropertyRendererAttachDelegate;
}
namespace Teamcenter
{
    class Fnd0PropertyRendererAttachImpl;
}
namespace Teamcenter
{
    class Fnd0PropertyRendererAttach;
}
namespace Teamcenter
{
    class Fnd0PropertyRendererAttachGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  FND0PROPERTYRENDERER_API Teamcenter_alias::Fnd0PropertyRendererAttachDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0PropertyRendererAttachDelegate instance
    static Fnd0PropertyRendererAttachDelegate&  getInstance();

    //  Method to create the Fnd0PropertyRendererAttachImpl pointer
    static Fnd0PropertyRendererAttachImpl*  createImpl( Fnd0PropertyRendererAttach&  ifObj );

    //  Method to delete the Fnd0PropertyRendererAttachImpl pointer
    static void deleteImpl( Fnd0PropertyRendererAttachImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0conditionBase(const Fnd0PropertyRendererAttach &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0pr_nameBase(const Fnd0PropertyRendererAttach &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0property_nameBase(const Fnd0PropertyRendererAttach &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0type_nameBase(const Fnd0PropertyRendererAttach &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0conditionBase(Fnd0PropertyRendererAttach &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0pr_nameBase(Fnd0PropertyRendererAttach &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0property_nameBase(Fnd0PropertyRendererAttach &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0type_nameBase(Fnd0PropertyRendererAttach &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static Fnd0PropertyRendererAttachDelegate*  m_pInstance;

    Fnd0PropertyRendererAttachDelegate();
    virtual ~Fnd0PropertyRendererAttachDelegate();
    static void setInstance( Fnd0PropertyRendererAttachDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0PropertyRendererAttachGenImpl;

};

#include <Fnd0propertyrenderer/libfnd0propertyrenderer_undef.h>
#endif  //  TEAMCENTER__FND0PROPERTYRENDERERATTACHDELEGATE_HXX
