//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0PropertyRendererDelegate
    Filename:   Fnd0PropertyRendererDelegate.hxx
    Module:     Fnd0propertyrenderer
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0PROPERTYRENDERERDELEGATE_HXX
#define TEAMCENTER__FND0PROPERTYRENDERERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Fnd0propertyrenderer/Fnd0PropertyRenderer.hxx>

#include <Fnd0propertyrenderer/libfnd0propertyrenderer_exports.h>

namespace Teamcenter
{
    class Fnd0PropertyRendererDelegate;
}
namespace Teamcenter
{
    class Fnd0PropertyRendererImpl;
}
namespace Teamcenter
{
    class Fnd0PropertyRenderer;
}
namespace Teamcenter
{
    class Fnd0PropertyRendererGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  FND0PROPERTYRENDERER_API Teamcenter_alias::Fnd0PropertyRendererDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0PropertyRendererDelegate instance
    static Fnd0PropertyRendererDelegate&  getInstance();

    //  Method to create the Fnd0PropertyRendererImpl pointer
    static Fnd0PropertyRendererImpl*  createImpl( Fnd0PropertyRenderer&  ifObj );

    //  Method to delete the Fnd0PropertyRendererImpl pointer
    static void deleteImpl( Fnd0PropertyRendererImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0pr_descBase(const Fnd0PropertyRenderer &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0pr_nameBase(const Fnd0PropertyRenderer &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0pr_scriptBase(const Fnd0PropertyRenderer &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0pr_descBase(Fnd0PropertyRenderer &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0pr_nameBase(Fnd0PropertyRenderer &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0pr_scriptBase(Fnd0PropertyRenderer &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static Fnd0PropertyRendererDelegate*  m_pInstance;

    Fnd0PropertyRendererDelegate();
    virtual ~Fnd0PropertyRendererDelegate();
    static void setInstance( Fnd0PropertyRendererDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0PropertyRendererGenImpl;

};

#include <Fnd0propertyrenderer/libfnd0propertyrenderer_undef.h>
#endif  //  TEAMCENTER__FND0PROPERTYRENDERERDELEGATE_HXX
