//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  Fnd0propertyrenderer

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libFnd0propertyrenderer

#if !defined(LIBFND0PROPERTYRENDERER) && !defined(IPLIB)
#   error IPLIB or LIBFND0PROPERTYRENDERER is not defined
#endif

/* Handwritten code should use FND0PROPERTYRENDERER_API, not FND0PROPERTYRENDEREREXPORT */

#define FND0PROPERTYRENDERER_API FND0PROPERTYRENDEREREXPORT

#if IPLIB==libFnd0propertyrenderer || defined(LIBFND0PROPERTYRENDERER)
#   if defined(__lint)
#       define FND0PROPERTYRENDEREREXPORT       __export(Fnd0propertyrenderer)
#       define FND0PROPERTYRENDERERGLOBAL       extern __global(Fnd0propertyrenderer)
#       define FND0PROPERTYRENDERERPRIVATE      extern __private(Fnd0propertyrenderer)
#   elif defined(_WIN32)
#       define FND0PROPERTYRENDEREREXPORT       __declspec(dllexport)
#       define FND0PROPERTYRENDERERGLOBAL       extern __declspec(dllexport)
#       define FND0PROPERTYRENDERERPRIVATE      extern
#   else
#       define FND0PROPERTYRENDEREREXPORT
#       define FND0PROPERTYRENDERERGLOBAL       extern
#       define FND0PROPERTYRENDERERPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define FND0PROPERTYRENDEREREXPORT       __export(Fnd0propertyrenderer)
#       define FND0PROPERTYRENDERERGLOBAL       extern __global(Fnd0propertyrenderer)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define FND0PROPERTYRENDEREREXPORT      __declspec(dllimport)
#       define FND0PROPERTYRENDERERGLOBAL       extern __declspec(dllimport)
#   else
#       define FND0PROPERTYRENDEREREXPORT
#       define FND0PROPERTYRENDERERGLOBAL       extern
#   endif
#endif
