//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0Qualification
    Filename:   Fnd0Qualification.hxx
    Module:     Fnd0qualification
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0QUALIFICATION__HXX
#define TEAMCENTER__FND0QUALIFICATION__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <Fnd0qualification/libfnd0qualification_exports.h>

namespace Teamcenter
{
    class Fnd0Qualification;
}
namespace Teamcenter
{
    class Fnd0QualificationImpl;
}
namespace Teamcenter
{
    class Fnd0QualificationDelegate;
}
namespace Teamcenter
{
    class Fnd0QualificationDispatch;
}
namespace Teamcenter
{
    class Fnd0QualificationGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0QUALIFICATION_API  Teamcenter::Fnd0Qualification
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0IsExpiryDateRequired( bool &value, bool &isNull ) const;

    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 10.1.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0Levels( std::vector< std::string > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10.1.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0IsExpiryDateRequired( bool value, bool isNull=false );

    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 10.1.2
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0Levels( const std::vector< std::string > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0Qualification();

    /**
     * Destructor
     */
    virtual ~Fnd0Qualification();

private:
    //  Getter method for the Implementation Object
    Fnd0QualificationImpl*  getFnd0QualificationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0QualificationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0QualificationImpl*  m_fnd0qualificationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0Qualification - desc for Fnd0Qualification parameter
     */
    Fnd0Qualification( const Fnd0Qualification& );
    Fnd0Qualification& operator=( const Fnd0Qualification& );

    friend class  Fnd0QualificationDelegate;
    friend class  Fnd0QualificationDispatch;
    friend class  Fnd0QualificationGenImpl;
};

#include <Fnd0qualification/libfnd0qualification_undef.h>
#endif //   TEAMCENTER__FND0QUALIFICATION__HXX
