//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0QualificationDelegate
    Filename:   Fnd0QualificationDelegate.hxx
    Module:     Fnd0qualification
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0QUALIFICATIONDELEGATE_HXX
#define TEAMCENTER__FND0QUALIFICATIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Fnd0qualification/Fnd0Qualification.hxx>

#include <Fnd0qualification/libfnd0qualification_exports.h>

namespace Teamcenter
{
    class Fnd0QualificationDelegate;
}
namespace Teamcenter
{
    class Fnd0QualificationImpl;
}
namespace Teamcenter
{
    class Fnd0Qualification;
}
namespace Teamcenter
{
    class Fnd0QualificationGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  FND0QUALIFICATION_API Teamcenter_alias::Fnd0QualificationDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0QualificationDelegate instance
    static Fnd0QualificationDelegate&  getInstance();

    //  Method to create the Fnd0QualificationImpl pointer
    static Fnd0QualificationImpl*  createImpl( Fnd0Qualification&  ifObj );

    //  Method to delete the Fnd0QualificationImpl pointer
    static void deleteImpl( Fnd0QualificationImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0IsExpiryDateRequiredBase(const Fnd0Qualification &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 10.1.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0LevelsBase(const Fnd0Qualification &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10.1.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0IsExpiryDateRequiredBase(Fnd0Qualification &ifObj,  bool value, bool isNull );


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 10.1.2
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0LevelsBase(Fnd0Qualification &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );



protected:
    //  Pointer to the instance
    static Fnd0QualificationDelegate*  m_pInstance;

    Fnd0QualificationDelegate();
    virtual ~Fnd0QualificationDelegate();
    static void setInstance( Fnd0QualificationDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0QualificationGenImpl;

};

#include <Fnd0qualification/libfnd0qualification_undef.h>
#endif  //  TEAMCENTER__FND0QUALIFICATIONDELEGATE_HXX
