//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ReqdQual
    Filename:   Fnd0ReqdQual.hxx
    Module:     Fnd0qualification
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0REQDQUAL__HXX
#define TEAMCENTER__FND0REQDQUAL__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <Fnd0qualification/libfnd0qualification_exports.h>

namespace Teamcenter
{
    class Fnd0ReqdQual;
}
namespace Teamcenter
{
    class Fnd0ReqdQualImpl;
}
namespace Teamcenter
{
    class Fnd0ReqdQualDelegate;
}
namespace Teamcenter
{
    class Fnd0ReqdQualDispatch;
}
namespace Teamcenter
{
    class Fnd0ReqdQualGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0QUALIFICATION_API  Teamcenter::Fnd0ReqdQual
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0LevelReqd( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0LevelReqd( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0ReqdQual();

    /**
     * Destructor
     */
    virtual ~Fnd0ReqdQual();

private:
    //  Getter method for the Implementation Object
    Fnd0ReqdQualImpl*  getFnd0ReqdQualImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0ReqdQualImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0ReqdQualImpl*  m_fnd0reqdqualImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0ReqdQual - desc for Fnd0ReqdQual parameter
     */
    Fnd0ReqdQual( const Fnd0ReqdQual& );
    Fnd0ReqdQual& operator=( const Fnd0ReqdQual& );

    friend class  Fnd0ReqdQualDelegate;
    friend class  Fnd0ReqdQualDispatch;
    friend class  Fnd0ReqdQualGenImpl;
};

#include <Fnd0qualification/libfnd0qualification_undef.h>
#endif //   TEAMCENTER__FND0REQDQUAL__HXX
