//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0UserHasQual
    Filename:   Fnd0UserHasQual.hxx
    Module:     Fnd0qualification
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0USERHASQUAL__HXX
#define TEAMCENTER__FND0USERHASQUAL__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <Fnd0qualification/libfnd0qualification_exports.h>

namespace Teamcenter
{
    class Fnd0UserHasQual;
}
namespace Teamcenter
{
    class Fnd0UserHasQualImpl;
}
namespace Teamcenter
{
    class Fnd0UserHasQualDelegate;
}
namespace Teamcenter
{
    class Fnd0UserHasQualDispatch;
}
namespace Teamcenter
{
    class Fnd0UserHasQualGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0QUALIFICATION_API  Teamcenter::Fnd0UserHasQual
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Date Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0QualAchievedDate( date_t &value, bool &isNull ) const;

    ///
    /// Getter for a Date Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0QualExpirationDate( date_t &value, bool &isNull ) const;

    ///
    /// Setter for a Date Property
    /// @version Teamcenter 10.1.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0QualAchievedDate( const date_t &value, bool isNull=false );

    ///
    /// Setter for a Date Property
    /// @version Teamcenter 10.1.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0QualExpirationDate( const date_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0UserHasQual();

    /**
     * Destructor
     */
    virtual ~Fnd0UserHasQual();

private:
    //  Getter method for the Implementation Object
    Fnd0UserHasQualImpl*  getFnd0UserHasQualImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0UserHasQualImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0UserHasQualImpl*  m_fnd0userhasqualImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0UserHasQual - desc for Fnd0UserHasQual parameter
     */
    Fnd0UserHasQual( const Fnd0UserHasQual& );
    Fnd0UserHasQual& operator=( const Fnd0UserHasQual& );

    friend class  Fnd0UserHasQualDelegate;
    friend class  Fnd0UserHasQualDispatch;
    friend class  Fnd0UserHasQualGenImpl;
};

#include <Fnd0qualification/libfnd0qualification_undef.h>
#endif //   TEAMCENTER__FND0USERHASQUAL__HXX
