//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lbr0ActionDefinition
    Filename:   Lbr0ActionDefinition.hxx
    Module:     Lbr0librarymgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LIBRARYMGMT__LBR0ACTIONDEFINITION__HXX
#define TEAMCENTER__LIBRARYMGMT__LBR0ACTIONDEFINITION__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <Lbr0librarymgmt/Lbr0SpecificationElement.hxx>

#include <Lbr0librarymgmt/liblbr0librarymgmt_exports.h>

namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0ActionDefinition;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0ActionDefinitionImpl;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0ActionDefinitionDelegate;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0ActionDefinitionDispatch;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0ActionDefinitionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LBR0LIBRARYMGMT_API  Teamcenter::LibraryMgmt::Lbr0ActionDefinition
     : public  ::Teamcenter::LibraryMgmt::Lbr0SpecificationElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getLbr0SelectionRules( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLbr0Quantity( int value, bool isNull=false );

    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 10.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setLbr0SelectionRules( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lbr0ActionDefinition();

    /**
     * Destructor
     */
    virtual ~Lbr0ActionDefinition();

private:
    //  Getter method for the Implementation Object
    Lbr0ActionDefinitionImpl*  getLbr0ActionDefinitionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLbr0ActionDefinitionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lbr0ActionDefinitionImpl*  m_lbr0actiondefinitionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lbr0ActionDefinition - desc for Lbr0ActionDefinition parameter
     */
    Lbr0ActionDefinition( const Lbr0ActionDefinition& );
    Lbr0ActionDefinition& operator=( const Lbr0ActionDefinition& );

    friend class  Lbr0ActionDefinitionDelegate;
    friend class  Lbr0ActionDefinitionDispatch;
    friend class  Lbr0ActionDefinitionGenImpl;
};

#include <Lbr0librarymgmt/liblbr0librarymgmt_undef.h>
#endif //   TEAMCENTER__LIBRARYMGMT__LBR0ACTIONDEFINITION__HXX
