//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lbr0ActionDefinitionDelegate
    Filename:   Lbr0ActionDefinitionDelegate.hxx
    Module:     Lbr0librarymgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LIBRARYMGMT__LBR0ACTIONDEFINITIONDELEGATE_HXX
#define TEAMCENTER__LIBRARYMGMT__LBR0ACTIONDEFINITIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Lbr0librarymgmt/Lbr0ActionDefinition.hxx>

#include <Lbr0librarymgmt/liblbr0librarymgmt_exports.h>

namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0ActionDefinitionDelegate;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0ActionDefinitionImpl;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0ActionDefinition;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0ActionDefinitionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  LBR0LIBRARYMGMT_API Teamcenter_alias::LibraryMgmt::Lbr0ActionDefinitionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Lbr0ActionDefinitionDelegate instance
    static Lbr0ActionDefinitionDelegate&  getInstance();

    //  Method to create the Lbr0ActionDefinitionImpl pointer
    static Lbr0ActionDefinitionImpl*  createImpl( Lbr0ActionDefinition&  ifObj );

    //  Method to delete the Lbr0ActionDefinitionImpl pointer
    static void deleteImpl( Lbr0ActionDefinitionImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getLbr0SelectionRulesBase(const Lbr0ActionDefinition &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLbr0QuantityBase(Lbr0ActionDefinition &ifObj,  int value, bool isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 10.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setLbr0SelectionRulesBase(Lbr0ActionDefinition &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Lbr0ActionDefinition &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Lbr0ActionDefinition &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Lbr0ActionDefinition &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Lbr0ActionDefinitionDelegate*  m_pInstance;

    Lbr0ActionDefinitionDelegate();
    virtual ~Lbr0ActionDefinitionDelegate();
    static void setInstance( Lbr0ActionDefinitionDelegate*  instance );


private:
    friend class  ::Teamcenter::LibraryMgmt::Lbr0ActionDefinitionGenImpl;

};

#include <Lbr0librarymgmt/liblbr0librarymgmt_undef.h>
#endif  //  TEAMCENTER__LIBRARYMGMT__LBR0ACTIONDEFINITIONDELEGATE_HXX
