//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lbr0ApplicationDataDelegate
    Filename:   Lbr0ApplicationDataDelegate.hxx
    Module:     Lbr0librarymgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LIBRARYMGMT__LBR0APPLICATIONDATADELEGATE_HXX
#define TEAMCENTER__LIBRARYMGMT__LBR0APPLICATIONDATADELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Lbr0librarymgmt/Lbr0ApplicationData.hxx>

#include <Lbr0librarymgmt/liblbr0librarymgmt_exports.h>

namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0ApplicationDataDelegate;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0ApplicationDataImpl;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0ApplicationData;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0ApplicationDataGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  LBR0LIBRARYMGMT_API Teamcenter_alias::LibraryMgmt::Lbr0ApplicationDataDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Lbr0ApplicationDataDelegate instance
    static Lbr0ApplicationDataDelegate&  getInstance();

    //  Method to create the Lbr0ApplicationDataImpl pointer
    static Lbr0ApplicationDataImpl*  createImpl( Lbr0ApplicationData&  ifObj );

    //  Method to delete the Lbr0ApplicationDataImpl pointer
    static void deleteImpl( Lbr0ApplicationDataImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLbr0IsGlobalBase(const Lbr0ApplicationData &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getLbr0NamesBase(const Lbr0ApplicationData &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLbr0UsageBase(const Lbr0ApplicationData &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getLbr0ValuesBase(const Lbr0ApplicationData &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLbr0IsGlobalBase(Lbr0ApplicationData &ifObj,  bool value, bool isNull );


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 10.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setLbr0NamesBase(Lbr0ApplicationData &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLbr0UsageBase(Lbr0ApplicationData &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 10.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setLbr0ValuesBase(Lbr0ApplicationData &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Lbr0ApplicationData &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Lbr0ApplicationData &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Lbr0ApplicationData &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Lbr0ApplicationDataDelegate*  m_pInstance;

    Lbr0ApplicationDataDelegate();
    virtual ~Lbr0ApplicationDataDelegate();
    static void setInstance( Lbr0ApplicationDataDelegate*  instance );


private:
    friend class  ::Teamcenter::LibraryMgmt::Lbr0ApplicationDataGenImpl;

};

#include <Lbr0librarymgmt/liblbr0librarymgmt_undef.h>
#endif  //  TEAMCENTER__LIBRARYMGMT__LBR0APPLICATIONDATADELEGATE_HXX
