//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lbr0AssociatedLibrary
    Filename:   Lbr0AssociatedLibrary.hxx
    Module:     Lbr0librarymgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LIBRARYMGMT__LBR0ASSOCIATEDLIBRARY__HXX
#define TEAMCENTER__LIBRARYMGMT__LBR0ASSOCIATEDLIBRARY__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <Lbr0librarymgmt/liblbr0librarymgmt_exports.h>

namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0AssociatedLibrary;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0AssociatedLibraryImpl;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0AssociatedLibraryDelegate;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0AssociatedLibraryDispatch;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0AssociatedLibraryGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LBR0LIBRARYMGMT_API  Teamcenter::LibraryMgmt::Lbr0AssociatedLibrary
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lbr0AssociatedLibrary();

    /**
     * Destructor
     */
    virtual ~Lbr0AssociatedLibrary();

private:
    //  Getter method for the Implementation Object
    Lbr0AssociatedLibraryImpl*  getLbr0AssociatedLibraryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLbr0AssociatedLibraryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lbr0AssociatedLibraryImpl*  m_lbr0associatedlibraryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lbr0AssociatedLibrary - desc for Lbr0AssociatedLibrary parameter
     */
    Lbr0AssociatedLibrary( const Lbr0AssociatedLibrary& );
    Lbr0AssociatedLibrary& operator=( const Lbr0AssociatedLibrary& );

    friend class  Lbr0AssociatedLibraryDelegate;
    friend class  Lbr0AssociatedLibraryDispatch;
    friend class  Lbr0AssociatedLibraryGenImpl;
};

#include <Lbr0librarymgmt/liblbr0librarymgmt_undef.h>
#endif //   TEAMCENTER__LIBRARYMGMT__LBR0ASSOCIATEDLIBRARY__HXX
