//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lbr0AssociatedLibraryDelegate
    Filename:   Lbr0AssociatedLibraryDelegate.hxx
    Module:     Lbr0librarymgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LIBRARYMGMT__LBR0ASSOCIATEDLIBRARYDELEGATE_HXX
#define TEAMCENTER__LIBRARYMGMT__LBR0ASSOCIATEDLIBRARYDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Lbr0librarymgmt/Lbr0AssociatedLibrary.hxx>

#include <Lbr0librarymgmt/liblbr0librarymgmt_exports.h>

namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0AssociatedLibraryDelegate;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0AssociatedLibraryImpl;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0AssociatedLibrary;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0AssociatedLibraryGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  LBR0LIBRARYMGMT_API Teamcenter_alias::LibraryMgmt::Lbr0AssociatedLibraryDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Lbr0AssociatedLibraryDelegate instance
    static Lbr0AssociatedLibraryDelegate&  getInstance();

    //  Method to create the Lbr0AssociatedLibraryImpl pointer
    static Lbr0AssociatedLibraryImpl*  createImpl( Lbr0AssociatedLibrary&  ifObj );

    //  Method to delete the Lbr0AssociatedLibraryImpl pointer
    static void deleteImpl( Lbr0AssociatedLibraryImpl*  impl );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Lbr0AssociatedLibrary &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Lbr0AssociatedLibrary &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Lbr0AssociatedLibraryDelegate*  m_pInstance;

    Lbr0AssociatedLibraryDelegate();
    virtual ~Lbr0AssociatedLibraryDelegate();
    static void setInstance( Lbr0AssociatedLibraryDelegate*  instance );


private:
    friend class  ::Teamcenter::LibraryMgmt::Lbr0AssociatedLibraryGenImpl;

};

#include <Lbr0librarymgmt/liblbr0librarymgmt_undef.h>
#endif  //  TEAMCENTER__LIBRARYMGMT__LBR0ASSOCIATEDLIBRARYDELEGATE_HXX
