//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lbr0ClsMembershipRule
    Filename:   Lbr0ClsMembershipRule.hxx
    Module:     Lbr0librarymgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LIBRARYMGMT__LBR0CLSMEMBERSHIPRULE__HXX
#define TEAMCENTER__LIBRARYMGMT__LBR0CLSMEMBERSHIPRULE__HXX

#include <vector>
#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <Lbr0librarymgmt/Lbr0MembershipRule.hxx>

#include <Lbr0librarymgmt/liblbr0librarymgmt_exports.h>

namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0ClsMembershipRule;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0ClsMembershipRuleImpl;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0ClsMembershipRuleDelegate;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0ClsMembershipRuleDispatch;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0ClsMembershipRuleGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LBR0LIBRARYMGMT_API  Teamcenter::LibraryMgmt::Lbr0ClsMembershipRule
     : public  ::Teamcenter::LibraryMgmt::Lbr0MembershipRule
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 11.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setLbr0AttributeNames( const std::vector< std::string > &values, const std::vector< int > *isNull=0 );

    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 11.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setLbr0ExpressionValues( const std::vector< std::string > &values, const std::vector< int > *isNull=0 );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLbr0SourceNode( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lbr0ClsMembershipRule();

    /**
     * Destructor
     */
    virtual ~Lbr0ClsMembershipRule();

private:
    //  Getter method for the Implementation Object
    Lbr0ClsMembershipRuleImpl*  getLbr0ClsMembershipRuleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLbr0ClsMembershipRuleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lbr0ClsMembershipRuleImpl*  m_lbr0clsmembershipruleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lbr0ClsMembershipRule - desc for Lbr0ClsMembershipRule parameter
     */
    Lbr0ClsMembershipRule( const Lbr0ClsMembershipRule& );
    Lbr0ClsMembershipRule& operator=( const Lbr0ClsMembershipRule& );

    friend class  Lbr0ClsMembershipRuleDelegate;
    friend class  Lbr0ClsMembershipRuleDispatch;
    friend class  Lbr0ClsMembershipRuleGenImpl;
};

#include <Lbr0librarymgmt/liblbr0librarymgmt_undef.h>
#endif //   TEAMCENTER__LIBRARYMGMT__LBR0CLSMEMBERSHIPRULE__HXX
