//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lbr0ClsMembershipRuleDelegate
    Filename:   Lbr0ClsMembershipRuleDelegate.hxx
    Module:     Lbr0librarymgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LIBRARYMGMT__LBR0CLSMEMBERSHIPRULEDELEGATE_HXX
#define TEAMCENTER__LIBRARYMGMT__LBR0CLSMEMBERSHIPRULEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Lbr0librarymgmt/Lbr0ClsMembershipRule.hxx>

#include <Lbr0librarymgmt/liblbr0librarymgmt_exports.h>

namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0ClsMembershipRuleDelegate;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0ClsMembershipRuleImpl;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0ClsMembershipRule;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0ClsMembershipRuleGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  LBR0LIBRARYMGMT_API Teamcenter_alias::LibraryMgmt::Lbr0ClsMembershipRuleDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Lbr0ClsMembershipRuleDelegate instance
    static Lbr0ClsMembershipRuleDelegate&  getInstance();

    //  Method to create the Lbr0ClsMembershipRuleImpl pointer
    static Lbr0ClsMembershipRuleImpl*  createImpl( Lbr0ClsMembershipRule&  ifObj );

    //  Method to delete the Lbr0ClsMembershipRuleImpl pointer
    static void deleteImpl( Lbr0ClsMembershipRuleImpl*  impl );


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 11.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setLbr0AttributeNamesBase(Lbr0ClsMembershipRule &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 11.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setLbr0ExpressionValuesBase(Lbr0ClsMembershipRule &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLbr0SourceNodeBase(Lbr0ClsMembershipRule &ifObj,  const tag_t &value, bool isNull );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Lbr0ClsMembershipRule &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Lbr0ClsMembershipRule &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Lbr0ClsMembershipRule &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Lbr0ClsMembershipRuleDelegate*  m_pInstance;

    Lbr0ClsMembershipRuleDelegate();
    virtual ~Lbr0ClsMembershipRuleDelegate();
    static void setInstance( Lbr0ClsMembershipRuleDelegate*  instance );


private:
    friend class  ::Teamcenter::LibraryMgmt::Lbr0ClsMembershipRuleGenImpl;

};

#include <Lbr0librarymgmt/liblbr0librarymgmt_undef.h>
#endif  //  TEAMCENTER__LIBRARYMGMT__LBR0CLSMEMBERSHIPRULEDELEGATE_HXX
