//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lbr0GeneralOptions
    Filename:   Lbr0GeneralOptions.hxx
    Module:     Lbr0librarymgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LIBRARYMGMT__LBR0GENERALOPTIONS__HXX
#define TEAMCENTER__LIBRARYMGMT__LBR0GENERALOPTIONS__HXX

#include <common/tc_deprecation_macros.h>
#include <Lbr0librarymgmt/Lbr0LibraryConfiguration.hxx>

#include <Lbr0librarymgmt/liblbr0librarymgmt_exports.h>

namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0GeneralOptions;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0GeneralOptionsImpl;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0GeneralOptionsDelegate;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0GeneralOptionsDispatch;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0GeneralOptionsGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LBR0LIBRARYMGMT_API  Teamcenter::LibraryMgmt::Lbr0GeneralOptions
     : public  ::Teamcenter::LibraryMgmt::Lbr0LibraryConfiguration
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lbr0GeneralOptions();

    /**
     * Destructor
     */
    virtual ~Lbr0GeneralOptions();

private:
    //  Getter method for the Implementation Object
    Lbr0GeneralOptionsImpl*  getLbr0GeneralOptionsImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLbr0GeneralOptionsImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lbr0GeneralOptionsImpl*  m_lbr0generaloptionsImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lbr0GeneralOptions - desc for Lbr0GeneralOptions parameter
     */
    Lbr0GeneralOptions( const Lbr0GeneralOptions& );
    Lbr0GeneralOptions& operator=( const Lbr0GeneralOptions& );

    friend class  Lbr0GeneralOptionsDelegate;
    friend class  Lbr0GeneralOptionsDispatch;
    friend class  Lbr0GeneralOptionsGenImpl;
};

#include <Lbr0librarymgmt/liblbr0librarymgmt_undef.h>
#endif //   TEAMCENTER__LIBRARYMGMT__LBR0GENERALOPTIONS__HXX
