//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lbr0Hierarchy
    Filename:   Lbr0Hierarchy.hxx
    Module:     Lbr0librarymgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LIBRARYMGMT__LBR0HIERARCHY__HXX
#define TEAMCENTER__LIBRARYMGMT__LBR0HIERARCHY__HXX

#include <common/tc_deprecation_macros.h>
#include <Cls0classification/Cls0HierarchyView.hxx>

#include <Lbr0librarymgmt/liblbr0librarymgmt_exports.h>

namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0Hierarchy;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0HierarchyImpl;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0HierarchyDelegate;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0HierarchyDispatch;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0HierarchyGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LBR0LIBRARYMGMT_API  Teamcenter::LibraryMgmt::Lbr0Hierarchy
     : public  ::Teamcenter::Classification::Cls0HierarchyView
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lbr0Hierarchy();

    /**
     * Destructor
     */
    virtual ~Lbr0Hierarchy();

private:
    //  Getter method for the Implementation Object
    Lbr0HierarchyImpl*  getLbr0HierarchyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLbr0HierarchyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lbr0HierarchyImpl*  m_lbr0hierarchyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lbr0Hierarchy - desc for Lbr0Hierarchy parameter
     */
    Lbr0Hierarchy( const Lbr0Hierarchy& );
    Lbr0Hierarchy& operator=( const Lbr0Hierarchy& );

    friend class  Lbr0HierarchyDelegate;
    friend class  Lbr0HierarchyDispatch;
    friend class  Lbr0HierarchyGenImpl;
};

#include <Lbr0librarymgmt/liblbr0librarymgmt_undef.h>
#endif //   TEAMCENTER__LIBRARYMGMT__LBR0HIERARCHY__HXX
