//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lbr0HierarchyScheme
    Filename:   Lbr0HierarchyScheme.hxx
    Module:     Lbr0librarymgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LIBRARYMGMT__LBR0HIERARCHYSCHEME__HXX
#define TEAMCENTER__LIBRARYMGMT__LBR0HIERARCHYSCHEME__HXX

#include <common/tc_deprecation_macros.h>
#include <ptn0partition/Ptn0PartitionScheme.hxx>

#include <Lbr0librarymgmt/liblbr0librarymgmt_exports.h>

namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0HierarchyScheme;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0HierarchySchemeImpl;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0HierarchySchemeDelegate;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0HierarchySchemeDispatch;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0HierarchySchemeGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LBR0LIBRARYMGMT_API  Teamcenter::LibraryMgmt::Lbr0HierarchyScheme
     : public  ::Teamcenter::Partition::Ptn0PartitionScheme
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lbr0HierarchyScheme();

    /**
     * Destructor
     */
    virtual ~Lbr0HierarchyScheme();

private:
    //  Getter method for the Implementation Object
    Lbr0HierarchySchemeImpl*  getLbr0HierarchySchemeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLbr0HierarchySchemeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lbr0HierarchySchemeImpl*  m_lbr0hierarchyschemeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lbr0HierarchyScheme - desc for Lbr0HierarchyScheme parameter
     */
    Lbr0HierarchyScheme( const Lbr0HierarchyScheme& );
    Lbr0HierarchyScheme& operator=( const Lbr0HierarchyScheme& );

    friend class  Lbr0HierarchySchemeDelegate;
    friend class  Lbr0HierarchySchemeDispatch;
    friend class  Lbr0HierarchySchemeGenImpl;
};

#include <Lbr0librarymgmt/liblbr0librarymgmt_undef.h>
#endif //   TEAMCENTER__LIBRARYMGMT__LBR0HIERARCHYSCHEME__HXX
