//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lbr0HierarchySchemeDelegate
    Filename:   Lbr0HierarchySchemeDelegate.hxx
    Module:     Lbr0librarymgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LIBRARYMGMT__LBR0HIERARCHYSCHEMEDELEGATE_HXX
#define TEAMCENTER__LIBRARYMGMT__LBR0HIERARCHYSCHEMEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Lbr0librarymgmt/Lbr0HierarchyScheme.hxx>

#include <Lbr0librarymgmt/liblbr0librarymgmt_exports.h>

namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0HierarchySchemeDelegate;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0HierarchySchemeImpl;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0HierarchyScheme;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0HierarchySchemeGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  LBR0LIBRARYMGMT_API Teamcenter_alias::LibraryMgmt::Lbr0HierarchySchemeDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Lbr0HierarchySchemeDelegate instance
    static Lbr0HierarchySchemeDelegate&  getInstance();

    //  Method to create the Lbr0HierarchySchemeImpl pointer
    static Lbr0HierarchySchemeImpl*  createImpl( Lbr0HierarchyScheme&  ifObj );

    //  Method to delete the Lbr0HierarchySchemeImpl pointer
    static void deleteImpl( Lbr0HierarchySchemeImpl*  impl );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Lbr0HierarchyScheme &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Lbr0HierarchyScheme &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// finalize operation input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  finalizeSaveAsInputBase(const Lbr0HierarchyScheme &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Lbr0HierarchyScheme &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// validate saveas input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  validateSaveAsInputBase(const Lbr0HierarchyScheme &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static Lbr0HierarchySchemeDelegate*  m_pInstance;

    Lbr0HierarchySchemeDelegate();
    virtual ~Lbr0HierarchySchemeDelegate();
    static void setInstance( Lbr0HierarchySchemeDelegate*  instance );


private:
    friend class  ::Teamcenter::LibraryMgmt::Lbr0HierarchySchemeGenImpl;

};

#include <Lbr0librarymgmt/liblbr0librarymgmt_undef.h>
#endif  //  TEAMCENTER__LIBRARYMGMT__LBR0HIERARCHYSCHEMEDELEGATE_HXX
