//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lbr0Library
    Filename:   Lbr0Library.hxx
    Module:     Lbr0librarymgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LIBRARYMGMT__LBR0LIBRARY__HXX
#define TEAMCENTER__LIBRARYMGMT__LBR0LIBRARY__HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0ApplicationModel.hxx>

#include <Lbr0librarymgmt/liblbr0librarymgmt_exports.h>

namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0Library;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0LibraryImpl;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0LibraryDelegate;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0LibraryDispatch;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0LibraryGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LBR0LIBRARYMGMT_API  Teamcenter::LibraryMgmt::Lbr0Library
     : public  ::Teamcenter::AppModel::Mdl0ApplicationModel
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lbr0Library();

    /**
     * Destructor
     */
    virtual ~Lbr0Library();

private:
    //  Getter method for the Implementation Object
    Lbr0LibraryImpl*  getLbr0LibraryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLbr0LibraryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lbr0LibraryImpl*  m_lbr0libraryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lbr0Library - desc for Lbr0Library parameter
     */
    Lbr0Library( const Lbr0Library& );
    Lbr0Library& operator=( const Lbr0Library& );

    friend class  Lbr0LibraryDelegate;
    friend class  Lbr0LibraryDispatch;
    friend class  Lbr0LibraryGenImpl;
};

#include <Lbr0librarymgmt/liblbr0librarymgmt_undef.h>
#endif //   TEAMCENTER__LIBRARYMGMT__LBR0LIBRARY__HXX
