//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lbr0LibraryConfiguration
    Filename:   Lbr0LibraryConfiguration.hxx
    Module:     Lbr0librarymgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LIBRARYMGMT__LBR0LIBRARYCONFIGURATION__HXX
#define TEAMCENTER__LIBRARYMGMT__LBR0LIBRARYCONFIGURATION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <Lbr0librarymgmt/liblbr0librarymgmt_exports.h>

namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0LibraryConfiguration;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0LibraryConfigurationImpl;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0LibraryConfigurationDelegate;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0LibraryConfigurationDispatch;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0LibraryConfigurationGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LBR0LIBRARYMGMT_API  Teamcenter::LibraryMgmt::Lbr0LibraryConfiguration
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lbr0LibraryConfiguration();

    /**
     * Destructor
     */
    virtual ~Lbr0LibraryConfiguration();

private:
    //  Getter method for the Implementation Object
    Lbr0LibraryConfigurationImpl*  getLbr0LibraryConfigurationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLbr0LibraryConfigurationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lbr0LibraryConfigurationImpl*  m_lbr0libraryconfigurationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lbr0LibraryConfiguration - desc for Lbr0LibraryConfiguration parameter
     */
    Lbr0LibraryConfiguration( const Lbr0LibraryConfiguration& );
    Lbr0LibraryConfiguration& operator=( const Lbr0LibraryConfiguration& );

    friend class  Lbr0LibraryConfigurationDelegate;
    friend class  Lbr0LibraryConfigurationDispatch;
    friend class  Lbr0LibraryConfigurationGenImpl;
};

#include <Lbr0librarymgmt/liblbr0librarymgmt_undef.h>
#endif //   TEAMCENTER__LIBRARYMGMT__LBR0LIBRARYCONFIGURATION__HXX
