//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lbr0LibraryElementsProvider
    Filename:   Lbr0LibraryElementsProvider.hxx
    Module:     Lbr0librarymgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LIBRARYMGMT__LBR0LIBRARYELEMENTSPROVIDER__HXX
#define TEAMCENTER__LIBRARYMGMT__LBR0LIBRARYELEMENTSPROVIDER__HXX

#include <common/tc_deprecation_macros.h>
#include <tc/Fnd0BaseProvider.hxx>

#include <Lbr0librarymgmt/liblbr0librarymgmt_exports.h>

namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0LibraryElementsProvider;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0LibraryElementsProviderImpl;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0LibraryElementsProviderDelegate;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0LibraryElementsProviderDispatch;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0LibraryElementsProviderGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LBR0LIBRARYMGMT_API  Teamcenter::LibraryMgmt::Lbr0LibraryElementsProvider
     : public  ::Teamcenter::Fnd0BaseProvider
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lbr0LibraryElementsProvider();

    /**
     * Destructor
     */
    virtual ~Lbr0LibraryElementsProvider();

private:
    //  Getter method for the Implementation Object
    Lbr0LibraryElementsProviderImpl*  getLbr0LibraryElementsProviderImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLbr0LibraryElementsProviderImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lbr0LibraryElementsProviderImpl*  m_lbr0libraryelementsproviderImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lbr0LibraryElementsProvider - desc for Lbr0LibraryElementsProvider parameter
     */
    Lbr0LibraryElementsProvider( const Lbr0LibraryElementsProvider& );
    Lbr0LibraryElementsProvider& operator=( const Lbr0LibraryElementsProvider& );

    friend class  Lbr0LibraryElementsProviderDelegate;
    friend class  Lbr0LibraryElementsProviderDispatch;
    friend class  Lbr0LibraryElementsProviderGenImpl;
};

#include <Lbr0librarymgmt/liblbr0librarymgmt_undef.h>
#endif //   TEAMCENTER__LIBRARYMGMT__LBR0LIBRARYELEMENTSPROVIDER__HXX
