//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lbr0LibrarySpecification
    Filename:   Lbr0LibrarySpecification.hxx
    Module:     Lbr0librarymgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LBR0LIBRARYSPECIFICATION__HXX
#define TEAMCENTER__LBR0LIBRARYSPECIFICATION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <Lbr0librarymgmt/liblbr0librarymgmt_exports.h>

namespace Teamcenter
{
    class Lbr0LibrarySpecification;
}
namespace Teamcenter
{
    class Lbr0LibrarySpecificationImpl;
}
namespace Teamcenter
{
    class Lbr0LibrarySpecificationDelegate;
}
namespace Teamcenter
{
    class Lbr0LibrarySpecificationDispatch;
}
namespace Teamcenter
{
    class Lbr0LibrarySpecificationGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LBR0LIBRARYMGMT_API  Teamcenter::Lbr0LibrarySpecification
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lbr0LibrarySpecification();

    /**
     * Destructor
     */
    virtual ~Lbr0LibrarySpecification();

private:
    //  Getter method for the Implementation Object
    Lbr0LibrarySpecificationImpl*  getLbr0LibrarySpecificationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLbr0LibrarySpecificationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lbr0LibrarySpecificationImpl*  m_lbr0libraryspecificationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lbr0LibrarySpecification - desc for Lbr0LibrarySpecification parameter
     */
    Lbr0LibrarySpecification( const Lbr0LibrarySpecification& );
    Lbr0LibrarySpecification& operator=( const Lbr0LibrarySpecification& );

    friend class  Lbr0LibrarySpecificationDelegate;
    friend class  Lbr0LibrarySpecificationDispatch;
    friend class  Lbr0LibrarySpecificationGenImpl;
};

#include <Lbr0librarymgmt/liblbr0librarymgmt_undef.h>
#endif //   TEAMCENTER__LBR0LIBRARYSPECIFICATION__HXX
