//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lbr0LibraryWorkflows
    Filename:   Lbr0LibraryWorkflows.hxx
    Module:     Lbr0librarymgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LIBRARYMGMT__LBR0LIBRARYWORKFLOWS__HXX
#define TEAMCENTER__LIBRARYMGMT__LBR0LIBRARYWORKFLOWS__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <Lbr0librarymgmt/Lbr0LibraryConfiguration.hxx>

#include <Lbr0librarymgmt/liblbr0librarymgmt_exports.h>

namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0LibraryWorkflows;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0LibraryWorkflowsImpl;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0LibraryWorkflowsDelegate;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0LibraryWorkflowsDispatch;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0LibraryWorkflowsGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LBR0LIBRARYMGMT_API  Teamcenter::LibraryMgmt::Lbr0LibraryWorkflows
     : public  ::Teamcenter::LibraryMgmt::Lbr0LibraryConfiguration
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLbr0WorkflowName( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lbr0LibraryWorkflows();

    /**
     * Destructor
     */
    virtual ~Lbr0LibraryWorkflows();

private:
    //  Getter method for the Implementation Object
    Lbr0LibraryWorkflowsImpl*  getLbr0LibraryWorkflowsImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLbr0LibraryWorkflowsImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lbr0LibraryWorkflowsImpl*  m_lbr0libraryworkflowsImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lbr0LibraryWorkflows - desc for Lbr0LibraryWorkflows parameter
     */
    Lbr0LibraryWorkflows( const Lbr0LibraryWorkflows& );
    Lbr0LibraryWorkflows& operator=( const Lbr0LibraryWorkflows& );

    friend class  Lbr0LibraryWorkflowsDelegate;
    friend class  Lbr0LibraryWorkflowsDispatch;
    friend class  Lbr0LibraryWorkflowsGenImpl;
};

#include <Lbr0librarymgmt/liblbr0librarymgmt_undef.h>
#endif //   TEAMCENTER__LIBRARYMGMT__LBR0LIBRARYWORKFLOWS__HXX
