//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lbr0LibraryWorkflowsDelegate
    Filename:   Lbr0LibraryWorkflowsDelegate.hxx
    Module:     Lbr0librarymgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LIBRARYMGMT__LBR0LIBRARYWORKFLOWSDELEGATE_HXX
#define TEAMCENTER__LIBRARYMGMT__LBR0LIBRARYWORKFLOWSDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Lbr0librarymgmt/Lbr0LibraryWorkflows.hxx>

#include <Lbr0librarymgmt/liblbr0librarymgmt_exports.h>

namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0LibraryWorkflowsDelegate;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0LibraryWorkflowsImpl;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0LibraryWorkflows;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0LibraryWorkflowsGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  LBR0LIBRARYMGMT_API Teamcenter_alias::LibraryMgmt::Lbr0LibraryWorkflowsDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Lbr0LibraryWorkflowsDelegate instance
    static Lbr0LibraryWorkflowsDelegate&  getInstance();

    //  Method to create the Lbr0LibraryWorkflowsImpl pointer
    static Lbr0LibraryWorkflowsImpl*  createImpl( Lbr0LibraryWorkflows&  ifObj );

    //  Method to delete the Lbr0LibraryWorkflowsImpl pointer
    static void deleteImpl( Lbr0LibraryWorkflowsImpl*  impl );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLbr0WorkflowNameBase(Lbr0LibraryWorkflows &ifObj,  const std::string &value, bool isNull );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Lbr0LibraryWorkflows &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Lbr0LibraryWorkflows &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Lbr0LibraryWorkflows &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Lbr0LibraryWorkflowsDelegate*  m_pInstance;

    Lbr0LibraryWorkflowsDelegate();
    virtual ~Lbr0LibraryWorkflowsDelegate();
    static void setInstance( Lbr0LibraryWorkflowsDelegate*  instance );


private:
    friend class  ::Teamcenter::LibraryMgmt::Lbr0LibraryWorkflowsGenImpl;

};

#include <Lbr0librarymgmt/liblbr0librarymgmt_undef.h>
#endif  //  TEAMCENTER__LIBRARYMGMT__LBR0LIBRARYWORKFLOWSDELEGATE_HXX
