//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lbr0MembershipRuleDelegate
    Filename:   Lbr0MembershipRuleDelegate.hxx
    Module:     Lbr0librarymgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LIBRARYMGMT__LBR0MEMBERSHIPRULEDELEGATE_HXX
#define TEAMCENTER__LIBRARYMGMT__LBR0MEMBERSHIPRULEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Lbr0librarymgmt/Lbr0MembershipRule.hxx>

#include <Lbr0librarymgmt/liblbr0librarymgmt_exports.h>

namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0MembershipRuleDelegate;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0MembershipRuleImpl;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0MembershipRule;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0MembershipRuleGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  LBR0LIBRARYMGMT_API Teamcenter_alias::LibraryMgmt::Lbr0MembershipRuleDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Lbr0MembershipRuleDelegate instance
    static Lbr0MembershipRuleDelegate&  getInstance();

    //  Method to create the Lbr0MembershipRuleImpl pointer
    static Lbr0MembershipRuleImpl*  createImpl( Lbr0MembershipRule&  ifObj );

    //  Method to delete the Lbr0MembershipRuleImpl pointer
    static void deleteImpl( Lbr0MembershipRuleImpl*  impl );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLbr0HierarchyNodeBase(Lbr0MembershipRule &ifObj,  const tag_t &value, bool isNull );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Lbr0MembershipRule &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Lbr0MembershipRule &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Lbr0MembershipRule &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Lbr0MembershipRuleDelegate*  m_pInstance;

    Lbr0MembershipRuleDelegate();
    virtual ~Lbr0MembershipRuleDelegate();
    static void setInstance( Lbr0MembershipRuleDelegate*  instance );


private:
    friend class  ::Teamcenter::LibraryMgmt::Lbr0MembershipRuleGenImpl;

};

#include <Lbr0librarymgmt/liblbr0librarymgmt_undef.h>
#endif  //  TEAMCENTER__LIBRARYMGMT__LBR0MEMBERSHIPRULEDELEGATE_HXX
