//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lbr0Representation
    Filename:   Lbr0Representation.hxx
    Module:     Lbr0librarymgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LIBRARYMGMT__LBR0REPRESENTATION__HXX
#define TEAMCENTER__LIBRARYMGMT__LBR0REPRESENTATION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <Lbr0librarymgmt/liblbr0librarymgmt_exports.h>

namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0Representation;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0RepresentationImpl;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0RepresentationDelegate;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0RepresentationDispatch;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0RepresentationGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LBR0LIBRARYMGMT_API  Teamcenter::LibraryMgmt::Lbr0Representation
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lbr0Representation();

    /**
     * Destructor
     */
    virtual ~Lbr0Representation();

private:
    //  Getter method for the Implementation Object
    Lbr0RepresentationImpl*  getLbr0RepresentationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLbr0RepresentationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lbr0RepresentationImpl*  m_lbr0representationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lbr0Representation - desc for Lbr0Representation parameter
     */
    Lbr0Representation( const Lbr0Representation& );
    Lbr0Representation& operator=( const Lbr0Representation& );

    friend class  Lbr0RepresentationDelegate;
    friend class  Lbr0RepresentationDispatch;
    friend class  Lbr0RepresentationGenImpl;
};

#include <Lbr0librarymgmt/liblbr0librarymgmt_undef.h>
#endif //   TEAMCENTER__LIBRARYMGMT__LBR0REPRESENTATION__HXX
