//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lbr0SpecificationElementDelegate
    Filename:   Lbr0SpecificationElementDelegate.hxx
    Module:     Lbr0librarymgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LIBRARYMGMT__LBR0SPECIFICATIONELEMENTDELEGATE_HXX
#define TEAMCENTER__LIBRARYMGMT__LBR0SPECIFICATIONELEMENTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Lbr0librarymgmt/Lbr0SpecificationElement.hxx>

#include <Lbr0librarymgmt/liblbr0librarymgmt_exports.h>

namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0SpecificationElementDelegate;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0SpecificationElementImpl;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0SpecificationElement;
    }
}
namespace Teamcenter
{
    namespace LibraryMgmt
    {
        class Lbr0SpecificationElementGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  LBR0LIBRARYMGMT_API Teamcenter_alias::LibraryMgmt::Lbr0SpecificationElementDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Lbr0SpecificationElementDelegate instance
    static Lbr0SpecificationElementDelegate&  getInstance();

    //  Method to create the Lbr0SpecificationElementImpl pointer
    static Lbr0SpecificationElementImpl*  createImpl( Lbr0SpecificationElement&  ifObj );

    //  Method to delete the Lbr0SpecificationElementImpl pointer
    static void deleteImpl( Lbr0SpecificationElementImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLbr0SpecificationBase(const Lbr0SpecificationElement &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLbr0DescriptionBase(Lbr0SpecificationElement &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLbr0ElementIdBase(Lbr0SpecificationElement &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLbr0IsActiveBase(Lbr0SpecificationElement &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLbr0NameBase(Lbr0SpecificationElement &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLbr0SpecificationBase(Lbr0SpecificationElement &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Lbr0SpecificationElement &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @param isLockForDelete - A boolean to indicate if object(s) are to be locked for deletion
    /// @param allowRelock - A boolean to indicate if object(s) can be relocked, which will discard all unsaved changes, if already locked by the same user
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0LockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd, const bool isLockForDelete, const bool allowRelock );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0RefreshBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0UnlockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Lbr0SpecificationElement &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Lbr0SpecificationElementDelegate*  m_pInstance;

    Lbr0SpecificationElementDelegate();
    virtual ~Lbr0SpecificationElementDelegate();
    static void setInstance( Lbr0SpecificationElementDelegate*  instance );


private:
    friend class  ::Teamcenter::LibraryMgmt::Lbr0SpecificationElementGenImpl;

};

#include <Lbr0librarymgmt/liblbr0librarymgmt_undef.h>
#endif  //  TEAMCENTER__LIBRARYMGMT__LBR0SPECIFICATIONELEMENTDELEGATE_HXX
