//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  Les0lisesm

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libLes0lisesm

#if !defined(LIBLES0LISESM) && !defined(IPLIB)
#   error IPLIB or LIBLES0LISESM is not defined
#endif

/* Handwritten code should use LES0LISESM_API, not LES0LISESMEXPORT */

#define LES0LISESM_API LES0LISESMEXPORT

#if IPLIB==libLes0lisesm || defined(LIBLES0LISESM)
#   if defined(__lint)
#       define LES0LISESMEXPORT       __export(Les0lisesm)
#       define LES0LISESMGLOBAL       extern __global(Les0lisesm)
#       define LES0LISESMPRIVATE      extern __private(Les0lisesm)
#   elif defined(_WIN32)
#       define LES0LISESMEXPORT       __declspec(dllexport)
#       define LES0LISESMGLOBAL       extern __declspec(dllexport)
#       define LES0LISESMPRIVATE      extern
#   else
#       define LES0LISESMEXPORT
#       define LES0LISESMGLOBAL       extern
#       define LES0LISESMPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define LES0LISESMEXPORT       __export(Les0lisesm)
#       define LES0LISESMGLOBAL       extern __global(Les0lisesm)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define LES0LISESMEXPORT      __declspec(dllimport)
#       define LES0LISESMGLOBAL       extern __declspec(dllimport)
#   else
#       define LES0LISESMEXPORT
#       define LES0LISESMGLOBAL       extern
#   endif
#endif
