//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lgt0BvrContainer
    Filename:   Lgt0BvrContainer.hxx
    Module:     Lgt0logistics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LGT0BVRCONTAINER__HXX
#define TEAMCENTER__LGT0BVRCONTAINER__HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrResource.hxx>

#include <Lgt0logistics/liblgt0logistics_exports.h>

namespace Teamcenter
{
    class Lgt0BvrContainer;
}
namespace Teamcenter
{
    class Lgt0BvrContainerImpl;
}
namespace Teamcenter
{
    class Lgt0BvrContainerDelegate;
}
namespace Teamcenter
{
    class Lgt0BvrContainerDispatch;
}
namespace Teamcenter
{
    class Lgt0BvrContainerGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LGT0LOGISTICS_API  Teamcenter::Lgt0BvrContainer
     : public  ::Teamcenter::Mfg0BvrResource
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLgt0PartsPerContainer( int &value, bool &isNull ) const;

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 10.1.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLgt0PartsPerContainer( int value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lgt0BvrContainer();

    /**
     * Destructor
     */
    virtual ~Lgt0BvrContainer();

private:
    //  Getter method for the Implementation Object
    Lgt0BvrContainerImpl*  getLgt0BvrContainerImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLgt0BvrContainerImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lgt0BvrContainerImpl*  m_lgt0bvrcontainerImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lgt0BvrContainer - desc for Lgt0BvrContainer parameter
     */
    Lgt0BvrContainer( const Lgt0BvrContainer& );
    Lgt0BvrContainer& operator=( const Lgt0BvrContainer& );

    friend class  Lgt0BvrContainerDelegate;
    friend class  Lgt0BvrContainerDispatch;
    friend class  Lgt0BvrContainerGenImpl;
};

#include <Lgt0logistics/liblgt0logistics_undef.h>
#endif //   TEAMCENTER__LGT0BVRCONTAINER__HXX
