//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lgt0BvrContainerDelegate
    Filename:   Lgt0BvrContainerDelegate.hxx
    Module:     Lgt0logistics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LGT0BVRCONTAINERDELEGATE_HXX
#define TEAMCENTER__LGT0BVRCONTAINERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Lgt0logistics/Lgt0BvrContainer.hxx>

#include <Lgt0logistics/liblgt0logistics_exports.h>

namespace Teamcenter
{
    class Lgt0BvrContainerDelegate;
}
namespace Teamcenter
{
    class Lgt0BvrContainerImpl;
}
namespace Teamcenter
{
    class Lgt0BvrContainer;
}
namespace Teamcenter
{
    class Lgt0BvrContainerGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  LGT0LOGISTICS_API Teamcenter_alias::Lgt0BvrContainerDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Lgt0BvrContainerDelegate instance
    static Lgt0BvrContainerDelegate&  getInstance();

    //  Method to create the Lgt0BvrContainerImpl pointer
    static Lgt0BvrContainerImpl*  createImpl( Lgt0BvrContainer&  ifObj );

    //  Method to delete the Lgt0BvrContainerImpl pointer
    static void deleteImpl( Lgt0BvrContainerImpl*  impl );


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLgt0PartsPerContainerBase(const Lgt0BvrContainer &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 10.1.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLgt0PartsPerContainerBase(Lgt0BvrContainer &ifObj,  int value, bool isNull );



protected:
    //  Pointer to the instance
    static Lgt0BvrContainerDelegate*  m_pInstance;

    Lgt0BvrContainerDelegate();
    virtual ~Lgt0BvrContainerDelegate();
    static void setInstance( Lgt0BvrContainerDelegate*  instance );


private:
    friend class  ::Teamcenter::Lgt0BvrContainerGenImpl;

};

#include <Lgt0logistics/liblgt0logistics_undef.h>
#endif  //  TEAMCENTER__LGT0BVRCONTAINERDELEGATE_HXX
