//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lgt0BvrInbdSupChain
    Filename:   Lgt0BvrInbdSupChain.hxx
    Module:     Lgt0logistics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LGT0BVRINBDSUPCHAIN__HXX
#define TEAMCENTER__LGT0BVRINBDSUPCHAIN__HXX

#include <common/tc_deprecation_macros.h>
#include <Lgt0logistics/Lgt0BvrSupplyChain.hxx>

#include <Lgt0logistics/liblgt0logistics_exports.h>

namespace Teamcenter
{
    class Lgt0BvrInbdSupChain;
}
namespace Teamcenter
{
    class Lgt0BvrInbdSupChainImpl;
}
namespace Teamcenter
{
    class Lgt0BvrInbdSupChainDelegate;
}
namespace Teamcenter
{
    class Lgt0BvrInbdSupChainDispatch;
}
namespace Teamcenter
{
    class Lgt0BvrInbdSupChainGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LGT0LOGISTICS_API  Teamcenter::Lgt0BvrInbdSupChain
     : public  ::Teamcenter::Lgt0BvrSupplyChain
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lgt0BvrInbdSupChain();

    /**
     * Destructor
     */
    virtual ~Lgt0BvrInbdSupChain();

private:
    //  Getter method for the Implementation Object
    Lgt0BvrInbdSupChainImpl*  getLgt0BvrInbdSupChainImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLgt0BvrInbdSupChainImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lgt0BvrInbdSupChainImpl*  m_lgt0bvrinbdsupchainImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lgt0BvrInbdSupChain - desc for Lgt0BvrInbdSupChain parameter
     */
    Lgt0BvrInbdSupChain( const Lgt0BvrInbdSupChain& );
    Lgt0BvrInbdSupChain& operator=( const Lgt0BvrInbdSupChain& );

    friend class  Lgt0BvrInbdSupChainDelegate;
    friend class  Lgt0BvrInbdSupChainDispatch;
    friend class  Lgt0BvrInbdSupChainGenImpl;
};

#include <Lgt0logistics/liblgt0logistics_undef.h>
#endif //   TEAMCENTER__LGT0BVRINBDSUPCHAIN__HXX
