//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lgt0BvrInplSupChain
    Filename:   Lgt0BvrInplSupChain.hxx
    Module:     Lgt0logistics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LGT0BVRINPLSUPCHAIN__HXX
#define TEAMCENTER__LGT0BVRINPLSUPCHAIN__HXX

#include <common/tc_deprecation_macros.h>
#include <Lgt0logistics/Lgt0BvrSupplyChain.hxx>

#include <Lgt0logistics/liblgt0logistics_exports.h>

namespace Teamcenter
{
    class Lgt0BvrInplSupChain;
}
namespace Teamcenter
{
    class Lgt0BvrInplSupChainImpl;
}
namespace Teamcenter
{
    class Lgt0BvrInplSupChainDelegate;
}
namespace Teamcenter
{
    class Lgt0BvrInplSupChainDispatch;
}
namespace Teamcenter
{
    class Lgt0BvrInplSupChainGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LGT0LOGISTICS_API  Teamcenter::Lgt0BvrInplSupChain
     : public  ::Teamcenter::Lgt0BvrSupplyChain
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lgt0BvrInplSupChain();

    /**
     * Destructor
     */
    virtual ~Lgt0BvrInplSupChain();

private:
    //  Getter method for the Implementation Object
    Lgt0BvrInplSupChainImpl*  getLgt0BvrInplSupChainImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLgt0BvrInplSupChainImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lgt0BvrInplSupChainImpl*  m_lgt0bvrinplsupchainImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lgt0BvrInplSupChain - desc for Lgt0BvrInplSupChain parameter
     */
    Lgt0BvrInplSupChain( const Lgt0BvrInplSupChain& );
    Lgt0BvrInplSupChain& operator=( const Lgt0BvrInplSupChain& );

    friend class  Lgt0BvrInplSupChainDelegate;
    friend class  Lgt0BvrInplSupChainDispatch;
    friend class  Lgt0BvrInplSupChainGenImpl;
};

#include <Lgt0logistics/liblgt0logistics_undef.h>
#endif //   TEAMCENTER__LGT0BVRINPLSUPCHAIN__HXX
