//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lgt0BvrLogisticArea
    Filename:   Lgt0BvrLogisticArea.hxx
    Module:     Lgt0logistics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LGT0BVRLOGISTICAREA__HXX
#define TEAMCENTER__LGT0BVRLOGISTICAREA__HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrWorkarea.hxx>

#include <Lgt0logistics/liblgt0logistics_exports.h>

namespace Teamcenter
{
    class Lgt0BvrLogisticArea;
}
namespace Teamcenter
{
    class Lgt0BvrLogisticAreaImpl;
}
namespace Teamcenter
{
    class Lgt0BvrLogisticAreaDelegate;
}
namespace Teamcenter
{
    class Lgt0BvrLogisticAreaDispatch;
}
namespace Teamcenter
{
    class Lgt0BvrLogisticAreaGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LGT0LOGISTICS_API  Teamcenter::Lgt0BvrLogisticArea
     : public  ::Teamcenter::Mfg0BvrWorkarea
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lgt0BvrLogisticArea();

    /**
     * Destructor
     */
    virtual ~Lgt0BvrLogisticArea();

private:
    //  Getter method for the Implementation Object
    Lgt0BvrLogisticAreaImpl*  getLgt0BvrLogisticAreaImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLgt0BvrLogisticAreaImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lgt0BvrLogisticAreaImpl*  m_lgt0bvrlogisticareaImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lgt0BvrLogisticArea - desc for Lgt0BvrLogisticArea parameter
     */
    Lgt0BvrLogisticArea( const Lgt0BvrLogisticArea& );
    Lgt0BvrLogisticArea& operator=( const Lgt0BvrLogisticArea& );

    friend class  Lgt0BvrLogisticAreaDelegate;
    friend class  Lgt0BvrLogisticAreaDispatch;
    friend class  Lgt0BvrLogisticAreaGenImpl;
};

#include <Lgt0logistics/liblgt0logistics_undef.h>
#endif //   TEAMCENTER__LGT0BVRLOGISTICAREA__HXX
