//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lgt0BvrLogisticFldr
    Filename:   Lgt0BvrLogisticFldr.hxx
    Module:     Lgt0logistics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LGT0BVRLOGISTICFLDR__HXX
#define TEAMCENTER__LGT0BVRLOGISTICFLDR__HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrProcess.hxx>

#include <Lgt0logistics/liblgt0logistics_exports.h>

namespace Teamcenter
{
    class Lgt0BvrLogisticFldr;
}
namespace Teamcenter
{
    class Lgt0BvrLogisticFldrImpl;
}
namespace Teamcenter
{
    class Lgt0BvrLogisticFldrDelegate;
}
namespace Teamcenter
{
    class Lgt0BvrLogisticFldrDispatch;
}
namespace Teamcenter
{
    class Lgt0BvrLogisticFldrGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LGT0LOGISTICS_API  Teamcenter::Lgt0BvrLogisticFldr
     : public  ::Teamcenter::Mfg0BvrProcess
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lgt0BvrLogisticFldr();

    /**
     * Destructor
     */
    virtual ~Lgt0BvrLogisticFldr();

private:
    //  Getter method for the Implementation Object
    Lgt0BvrLogisticFldrImpl*  getLgt0BvrLogisticFldrImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLgt0BvrLogisticFldrImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lgt0BvrLogisticFldrImpl*  m_lgt0bvrlogisticfldrImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lgt0BvrLogisticFldr - desc for Lgt0BvrLogisticFldr parameter
     */
    Lgt0BvrLogisticFldr( const Lgt0BvrLogisticFldr& );
    Lgt0BvrLogisticFldr& operator=( const Lgt0BvrLogisticFldr& );

    friend class  Lgt0BvrLogisticFldrDelegate;
    friend class  Lgt0BvrLogisticFldrDispatch;
    friend class  Lgt0BvrLogisticFldrGenImpl;
};

#include <Lgt0logistics/liblgt0logistics_undef.h>
#endif //   TEAMCENTER__LGT0BVRLOGISTICFLDR__HXX
