//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lgt0BvrLogisticOp
    Filename:   Lgt0BvrLogisticOp.hxx
    Module:     Lgt0logistics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LGT0BVRLOGISTICOP__HXX
#define TEAMCENTER__LGT0BVRLOGISTICOP__HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrOperation.hxx>

#include <Lgt0logistics/liblgt0logistics_exports.h>

namespace Teamcenter
{
    class Lgt0BvrLogisticOp;
}
namespace Teamcenter
{
    class Lgt0BvrLogisticOpImpl;
}
namespace Teamcenter
{
    class Lgt0BvrLogisticOpDelegate;
}
namespace Teamcenter
{
    class Lgt0BvrLogisticOpDispatch;
}
namespace Teamcenter
{
    class Lgt0BvrLogisticOpGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LGT0LOGISTICS_API  Teamcenter::Lgt0BvrLogisticOp
     : public  ::Teamcenter::Mfg0BvrOperation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lgt0BvrLogisticOp();

    /**
     * Destructor
     */
    virtual ~Lgt0BvrLogisticOp();

private:
    //  Getter method for the Implementation Object
    Lgt0BvrLogisticOpImpl*  getLgt0BvrLogisticOpImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLgt0BvrLogisticOpImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lgt0BvrLogisticOpImpl*  m_lgt0bvrlogisticopImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lgt0BvrLogisticOp - desc for Lgt0BvrLogisticOp parameter
     */
    Lgt0BvrLogisticOp( const Lgt0BvrLogisticOp& );
    Lgt0BvrLogisticOp& operator=( const Lgt0BvrLogisticOp& );

    friend class  Lgt0BvrLogisticOpDelegate;
    friend class  Lgt0BvrLogisticOpDispatch;
    friend class  Lgt0BvrLogisticOpGenImpl;
};

#include <Lgt0logistics/liblgt0logistics_undef.h>
#endif //   TEAMCENTER__LGT0BVRLOGISTICOP__HXX
