//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lgt0BvrLogisticPr
    Filename:   Lgt0BvrLogisticPr.hxx
    Module:     Lgt0logistics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LGT0BVRLOGISTICPR__HXX
#define TEAMCENTER__LGT0BVRLOGISTICPR__HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrProcess.hxx>

#include <Lgt0logistics/liblgt0logistics_exports.h>

namespace Teamcenter
{
    class Lgt0BvrLogisticPr;
}
namespace Teamcenter
{
    class Lgt0BvrLogisticPrImpl;
}
namespace Teamcenter
{
    class Lgt0BvrLogisticPrDelegate;
}
namespace Teamcenter
{
    class Lgt0BvrLogisticPrDispatch;
}
namespace Teamcenter
{
    class Lgt0BvrLogisticPrGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LGT0LOGISTICS_API  Teamcenter::Lgt0BvrLogisticPr
     : public  ::Teamcenter::Mfg0BvrProcess
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lgt0BvrLogisticPr();

    /**
     * Destructor
     */
    virtual ~Lgt0BvrLogisticPr();

private:
    //  Getter method for the Implementation Object
    Lgt0BvrLogisticPrImpl*  getLgt0BvrLogisticPrImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLgt0BvrLogisticPrImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lgt0BvrLogisticPrImpl*  m_lgt0bvrlogisticprImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lgt0BvrLogisticPr - desc for Lgt0BvrLogisticPr parameter
     */
    Lgt0BvrLogisticPr( const Lgt0BvrLogisticPr& );
    Lgt0BvrLogisticPr& operator=( const Lgt0BvrLogisticPr& );

    friend class  Lgt0BvrLogisticPrDelegate;
    friend class  Lgt0BvrLogisticPrDispatch;
    friend class  Lgt0BvrLogisticPrGenImpl;
};

#include <Lgt0logistics/liblgt0logistics_undef.h>
#endif //   TEAMCENTER__LGT0BVRLOGISTICPR__HXX
