//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lgt0BvrPartFamProc
    Filename:   Lgt0BvrPartFamProc.hxx
    Module:     Lgt0logistics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LGT0BVRPARTFAMPROC__HXX
#define TEAMCENTER__LGT0BVRPARTFAMPROC__HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrProcess.hxx>

#include <Lgt0logistics/liblgt0logistics_exports.h>

namespace Teamcenter
{
    class Lgt0BvrPartFamProc;
}
namespace Teamcenter
{
    class Lgt0BvrPartFamProcImpl;
}
namespace Teamcenter
{
    class Lgt0BvrPartFamProcDelegate;
}
namespace Teamcenter
{
    class Lgt0BvrPartFamProcDispatch;
}
namespace Teamcenter
{
    class Lgt0BvrPartFamProcGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LGT0LOGISTICS_API  Teamcenter::Lgt0BvrPartFamProc
     : public  ::Teamcenter::Mfg0BvrProcess
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 10.1.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLgt0ProductionQuantity( double &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lgt0BvrPartFamProc();

    /**
     * Destructor
     */
    virtual ~Lgt0BvrPartFamProc();

private:
    //  Getter method for the Implementation Object
    Lgt0BvrPartFamProcImpl*  getLgt0BvrPartFamProcImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLgt0BvrPartFamProcImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lgt0BvrPartFamProcImpl*  m_lgt0bvrpartfamprocImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lgt0BvrPartFamProc - desc for Lgt0BvrPartFamProc parameter
     */
    Lgt0BvrPartFamProc( const Lgt0BvrPartFamProc& );
    Lgt0BvrPartFamProc& operator=( const Lgt0BvrPartFamProc& );

    friend class  Lgt0BvrPartFamProcDelegate;
    friend class  Lgt0BvrPartFamProcDispatch;
    friend class  Lgt0BvrPartFamProcGenImpl;
};

#include <Lgt0logistics/liblgt0logistics_undef.h>
#endif //   TEAMCENTER__LGT0BVRPARTFAMPROC__HXX
