//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lgt0BvrProvisionPr
    Filename:   Lgt0BvrProvisionPr.hxx
    Module:     Lgt0logistics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LGT0BVRPROVISIONPR__HXX
#define TEAMCENTER__LGT0BVRPROVISIONPR__HXX

#include <common/tc_deprecation_macros.h>
#include <Lgt0logistics/Lgt0BvrStorePr.hxx>

#include <Lgt0logistics/liblgt0logistics_exports.h>

namespace Teamcenter
{
    class Lgt0BvrProvisionPr;
}
namespace Teamcenter
{
    class Lgt0BvrProvisionPrImpl;
}
namespace Teamcenter
{
    class Lgt0BvrProvisionPrDelegate;
}
namespace Teamcenter
{
    class Lgt0BvrProvisionPrDispatch;
}
namespace Teamcenter
{
    class Lgt0BvrProvisionPrGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LGT0LOGISTICS_API  Teamcenter::Lgt0BvrProvisionPr
     : public  ::Teamcenter::Lgt0BvrStorePr
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lgt0BvrProvisionPr();

    /**
     * Destructor
     */
    virtual ~Lgt0BvrProvisionPr();

private:
    //  Getter method for the Implementation Object
    Lgt0BvrProvisionPrImpl*  getLgt0BvrProvisionPrImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLgt0BvrProvisionPrImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lgt0BvrProvisionPrImpl*  m_lgt0bvrprovisionprImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lgt0BvrProvisionPr - desc for Lgt0BvrProvisionPr parameter
     */
    Lgt0BvrProvisionPr( const Lgt0BvrProvisionPr& );
    Lgt0BvrProvisionPr& operator=( const Lgt0BvrProvisionPr& );

    friend class  Lgt0BvrProvisionPrDelegate;
    friend class  Lgt0BvrProvisionPrDispatch;
    friend class  Lgt0BvrProvisionPrGenImpl;
};

#include <Lgt0logistics/liblgt0logistics_undef.h>
#endif //   TEAMCENTER__LGT0BVRPROVISIONPR__HXX
