//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lgt0BvrStorePr
    Filename:   Lgt0BvrStorePr.hxx
    Module:     Lgt0logistics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LGT0BVRSTOREPR__HXX
#define TEAMCENTER__LGT0BVRSTOREPR__HXX

#include <common/tc_deprecation_macros.h>
#include <Lgt0logistics/Lgt0BvrLogisticPr.hxx>

#include <Lgt0logistics/liblgt0logistics_exports.h>

namespace Teamcenter
{
    class Lgt0BvrStorePr;
}
namespace Teamcenter
{
    class Lgt0BvrStorePrImpl;
}
namespace Teamcenter
{
    class Lgt0BvrStorePrDelegate;
}
namespace Teamcenter
{
    class Lgt0BvrStorePrDispatch;
}
namespace Teamcenter
{
    class Lgt0BvrStorePrGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LGT0LOGISTICS_API  Teamcenter::Lgt0BvrStorePr
     : public  ::Teamcenter::Lgt0BvrLogisticPr
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lgt0BvrStorePr();

    /**
     * Destructor
     */
    virtual ~Lgt0BvrStorePr();

private:
    //  Getter method for the Implementation Object
    Lgt0BvrStorePrImpl*  getLgt0BvrStorePrImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLgt0BvrStorePrImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lgt0BvrStorePrImpl*  m_lgt0bvrstoreprImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lgt0BvrStorePr - desc for Lgt0BvrStorePr parameter
     */
    Lgt0BvrStorePr( const Lgt0BvrStorePr& );
    Lgt0BvrStorePr& operator=( const Lgt0BvrStorePr& );

    friend class  Lgt0BvrStorePrDelegate;
    friend class  Lgt0BvrStorePrDispatch;
    friend class  Lgt0BvrStorePrGenImpl;
};

#include <Lgt0logistics/liblgt0logistics_undef.h>
#endif //   TEAMCENTER__LGT0BVRSTOREPR__HXX
