//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lgt0BvrSupplyChain
    Filename:   Lgt0BvrSupplyChain.hxx
    Module:     Lgt0logistics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LGT0BVRSUPPLYCHAIN__HXX
#define TEAMCENTER__LGT0BVRSUPPLYCHAIN__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrProcess.hxx>

#include <Lgt0logistics/liblgt0logistics_exports.h>

namespace Teamcenter
{
    class Lgt0BvrSupplyChain;
}
namespace Teamcenter
{
    class Lgt0BvrSupplyChainImpl;
}
namespace Teamcenter
{
    class Lgt0BvrSupplyChainDelegate;
}
namespace Teamcenter
{
    class Lgt0BvrSupplyChainDispatch;
}
namespace Teamcenter
{
    class Lgt0BvrSupplyChainGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LGT0LOGISTICS_API  Teamcenter::Lgt0BvrSupplyChain
     : public  ::Teamcenter::Mfg0BvrProcess
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLgt0ContainerName( std::string &value, bool &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLgt0PartsPerContainer( int &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lgt0BvrSupplyChain();

    /**
     * Destructor
     */
    virtual ~Lgt0BvrSupplyChain();

private:
    //  Getter method for the Implementation Object
    Lgt0BvrSupplyChainImpl*  getLgt0BvrSupplyChainImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLgt0BvrSupplyChainImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lgt0BvrSupplyChainImpl*  m_lgt0bvrsupplychainImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lgt0BvrSupplyChain - desc for Lgt0BvrSupplyChain parameter
     */
    Lgt0BvrSupplyChain( const Lgt0BvrSupplyChain& );
    Lgt0BvrSupplyChain& operator=( const Lgt0BvrSupplyChain& );

    friend class  Lgt0BvrSupplyChainDelegate;
    friend class  Lgt0BvrSupplyChainDispatch;
    friend class  Lgt0BvrSupplyChainGenImpl;
};

#include <Lgt0logistics/liblgt0logistics_undef.h>
#endif //   TEAMCENTER__LGT0BVRSUPPLYCHAIN__HXX
