//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lgt0BvrSupplyChainDelegate
    Filename:   Lgt0BvrSupplyChainDelegate.hxx
    Module:     Lgt0logistics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LGT0BVRSUPPLYCHAINDELEGATE_HXX
#define TEAMCENTER__LGT0BVRSUPPLYCHAINDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Lgt0logistics/Lgt0BvrSupplyChain.hxx>

#include <Lgt0logistics/liblgt0logistics_exports.h>

namespace Teamcenter
{
    class Lgt0BvrSupplyChainDelegate;
}
namespace Teamcenter
{
    class Lgt0BvrSupplyChainImpl;
}
namespace Teamcenter
{
    class Lgt0BvrSupplyChain;
}
namespace Teamcenter
{
    class Lgt0BvrSupplyChainGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  LGT0LOGISTICS_API Teamcenter_alias::Lgt0BvrSupplyChainDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Lgt0BvrSupplyChainDelegate instance
    static Lgt0BvrSupplyChainDelegate&  getInstance();

    //  Method to create the Lgt0BvrSupplyChainImpl pointer
    static Lgt0BvrSupplyChainImpl*  createImpl( Lgt0BvrSupplyChain&  ifObj );

    //  Method to delete the Lgt0BvrSupplyChainImpl pointer
    static void deleteImpl( Lgt0BvrSupplyChainImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLgt0ContainerNameBase(const Lgt0BvrSupplyChain &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLgt0PartsPerContainerBase(const Lgt0BvrSupplyChain &ifObj,  int &value, bool &isNull ) const;



protected:
    //  Pointer to the instance
    static Lgt0BvrSupplyChainDelegate*  m_pInstance;

    Lgt0BvrSupplyChainDelegate();
    virtual ~Lgt0BvrSupplyChainDelegate();
    static void setInstance( Lgt0BvrSupplyChainDelegate*  instance );


private:
    friend class  ::Teamcenter::Lgt0BvrSupplyChainGenImpl;

};

#include <Lgt0logistics/liblgt0logistics_undef.h>
#endif  //  TEAMCENTER__LGT0BVRSUPPLYCHAINDELEGATE_HXX
