//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lgt0BvrSupplyChainLib
    Filename:   Lgt0BvrSupplyChainLib.hxx
    Module:     Lgt0logistics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LGT0BVRSUPPLYCHAINLIB__HXX
#define TEAMCENTER__LGT0BVRSUPPLYCHAINLIB__HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrProductBOP.hxx>

#include <Lgt0logistics/liblgt0logistics_exports.h>

namespace Teamcenter
{
    class Lgt0BvrSupplyChainLib;
}
namespace Teamcenter
{
    class Lgt0BvrSupplyChainLibImpl;
}
namespace Teamcenter
{
    class Lgt0BvrSupplyChainLibDelegate;
}
namespace Teamcenter
{
    class Lgt0BvrSupplyChainLibDispatch;
}
namespace Teamcenter
{
    class Lgt0BvrSupplyChainLibGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LGT0LOGISTICS_API  Teamcenter::Lgt0BvrSupplyChainLib
     : public  ::Teamcenter::Mfg0BvrProductBOP
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lgt0BvrSupplyChainLib();

    /**
     * Destructor
     */
    virtual ~Lgt0BvrSupplyChainLib();

private:
    //  Getter method for the Implementation Object
    Lgt0BvrSupplyChainLibImpl*  getLgt0BvrSupplyChainLibImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLgt0BvrSupplyChainLibImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lgt0BvrSupplyChainLibImpl*  m_lgt0bvrsupplychainlibImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lgt0BvrSupplyChainLib - desc for Lgt0BvrSupplyChainLib parameter
     */
    Lgt0BvrSupplyChainLib( const Lgt0BvrSupplyChainLib& );
    Lgt0BvrSupplyChainLib& operator=( const Lgt0BvrSupplyChainLib& );

    friend class  Lgt0BvrSupplyChainLibDelegate;
    friend class  Lgt0BvrSupplyChainLibDispatch;
    friend class  Lgt0BvrSupplyChainLibGenImpl;
};

#include <Lgt0logistics/liblgt0logistics_undef.h>
#endif //   TEAMCENTER__LGT0BVRSUPPLYCHAINLIB__HXX
