//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lgt0BvrSupplyChainPartition
    Filename:   Lgt0BvrSupplyChainPartition.hxx
    Module:     Lgt0logistics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LGT0BVRSUPPLYCHAINPARTITION__HXX
#define TEAMCENTER__LGT0BVRSUPPLYCHAINPARTITION__HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrProductBOP.hxx>

#include <Lgt0logistics/liblgt0logistics_exports.h>

namespace Teamcenter
{
    class Lgt0BvrSupplyChainPartition;
}
namespace Teamcenter
{
    class Lgt0BvrSupplyChainPartitionImpl;
}
namespace Teamcenter
{
    class Lgt0BvrSupplyChainPartitionDelegate;
}
namespace Teamcenter
{
    class Lgt0BvrSupplyChainPartitionDispatch;
}
namespace Teamcenter
{
    class Lgt0BvrSupplyChainPartitionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LGT0LOGISTICS_API  Teamcenter::Lgt0BvrSupplyChainPartition
     : public  ::Teamcenter::Mfg0BvrProductBOP
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lgt0BvrSupplyChainPartition();

    /**
     * Destructor
     */
    virtual ~Lgt0BvrSupplyChainPartition();

private:
    //  Getter method for the Implementation Object
    Lgt0BvrSupplyChainPartitionImpl*  getLgt0BvrSupplyChainPartitionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLgt0BvrSupplyChainPartitionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lgt0BvrSupplyChainPartitionImpl*  m_lgt0bvrsupplychainpartitionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lgt0BvrSupplyChainPartition - desc for Lgt0BvrSupplyChainPartition parameter
     */
    Lgt0BvrSupplyChainPartition( const Lgt0BvrSupplyChainPartition& );
    Lgt0BvrSupplyChainPartition& operator=( const Lgt0BvrSupplyChainPartition& );

    friend class  Lgt0BvrSupplyChainPartitionDelegate;
    friend class  Lgt0BvrSupplyChainPartitionDispatch;
    friend class  Lgt0BvrSupplyChainPartitionGenImpl;
};

#include <Lgt0logistics/liblgt0logistics_undef.h>
#endif //   TEAMCENTER__LGT0BVRSUPPLYCHAINPARTITION__HXX
