//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lgt0BvrVehicle
    Filename:   Lgt0BvrVehicle.hxx
    Module:     Lgt0logistics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LGT0BVRVEHICLE__HXX
#define TEAMCENTER__LGT0BVRVEHICLE__HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrResource.hxx>

#include <Lgt0logistics/liblgt0logistics_exports.h>

namespace Teamcenter
{
    class Lgt0BvrVehicle;
}
namespace Teamcenter
{
    class Lgt0BvrVehicleImpl;
}
namespace Teamcenter
{
    class Lgt0BvrVehicleDelegate;
}
namespace Teamcenter
{
    class Lgt0BvrVehicleDispatch;
}
namespace Teamcenter
{
    class Lgt0BvrVehicleGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LGT0LOGISTICS_API  Teamcenter::Lgt0BvrVehicle
     : public  ::Teamcenter::Mfg0BvrResource
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lgt0BvrVehicle();

    /**
     * Destructor
     */
    virtual ~Lgt0BvrVehicle();

private:
    //  Getter method for the Implementation Object
    Lgt0BvrVehicleImpl*  getLgt0BvrVehicleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLgt0BvrVehicleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lgt0BvrVehicleImpl*  m_lgt0bvrvehicleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lgt0BvrVehicle - desc for Lgt0BvrVehicle parameter
     */
    Lgt0BvrVehicle( const Lgt0BvrVehicle& );
    Lgt0BvrVehicle& operator=( const Lgt0BvrVehicle& );

    friend class  Lgt0BvrVehicleDelegate;
    friend class  Lgt0BvrVehicleDispatch;
    friend class  Lgt0BvrVehicleGenImpl;
};

#include <Lgt0logistics/liblgt0logistics_undef.h>
#endif //   TEAMCENTER__LGT0BVRVEHICLE__HXX
