//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lgt0LogisticBOPRevision
    Filename:   Lgt0LogisticBOPRevision.hxx
    Module:     Lgt0logistics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LGT0LOGISTICBOPREVISION__HXX
#define TEAMCENTER__LGT0LOGISTICBOPREVISION__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0MEPlantBOPRevision.hxx>

#include <Lgt0logistics/liblgt0logistics_exports.h>

namespace Teamcenter
{
    class Lgt0LogisticBOPRevision;
}
namespace Teamcenter
{
    class Lgt0LogisticBOPRevisionImpl;
}
namespace Teamcenter
{
    class Lgt0LogisticBOPRevisionDelegate;
}
namespace Teamcenter
{
    class Lgt0LogisticBOPRevisionDispatch;
}
namespace Teamcenter
{
    class Lgt0LogisticBOPRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LGT0LOGISTICS_API  Teamcenter::Lgt0LogisticBOPRevision
     : public  ::Teamcenter::Mfg0MEPlantBOPRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLgt0PlantName( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLgt0PlantName( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lgt0LogisticBOPRevision();

    /**
     * Destructor
     */
    virtual ~Lgt0LogisticBOPRevision();

private:
    //  Getter method for the Implementation Object
    Lgt0LogisticBOPRevisionImpl*  getLgt0LogisticBOPRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLgt0LogisticBOPRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lgt0LogisticBOPRevisionImpl*  m_lgt0logisticboprevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lgt0LogisticBOPRevision - desc for Lgt0LogisticBOPRevision parameter
     */
    Lgt0LogisticBOPRevision( const Lgt0LogisticBOPRevision& );
    Lgt0LogisticBOPRevision& operator=( const Lgt0LogisticBOPRevision& );

    friend class  Lgt0LogisticBOPRevisionDelegate;
    friend class  Lgt0LogisticBOPRevisionDispatch;
    friend class  Lgt0LogisticBOPRevisionGenImpl;
};

#include <Lgt0logistics/liblgt0logistics_undef.h>
#endif //   TEAMCENTER__LGT0LOGISTICBOPREVISION__HXX
