//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lgt0PartFamProcRevision
    Filename:   Lgt0PartFamProcRevision.hxx
    Module:     Lgt0logistics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LGT0PARTFAMPROCREVISION__HXX
#define TEAMCENTER__LGT0PARTFAMPROCREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <me/MEProcessRevision.hxx>

#include <Lgt0logistics/liblgt0logistics_exports.h>

namespace Teamcenter
{
    class Lgt0PartFamProcRevision;
}
namespace Teamcenter
{
    class Lgt0PartFamProcRevisionImpl;
}
namespace Teamcenter
{
    class Lgt0PartFamProcRevisionDelegate;
}
namespace Teamcenter
{
    class Lgt0PartFamProcRevisionDispatch;
}
namespace Teamcenter
{
    class Lgt0PartFamProcRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LGT0LOGISTICS_API  Teamcenter::Lgt0PartFamProcRevision
     : public  ::Teamcenter::MEProcessRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLgt0CalculatedColorVariants( int &value, bool &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLgt0CalculatedTechVariants( int &value, bool &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLgt0CalculatedTotalVariants( int &value, bool &isNull ) const;

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 10.1.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLgt0CalculatedColorVariants( int value, bool isNull=false );

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 10.1.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLgt0CalculatedTechVariants( int value, bool isNull=false );

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 10.1.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLgt0CalculatedTotalVariants( int value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lgt0PartFamProcRevision();

    /**
     * Destructor
     */
    virtual ~Lgt0PartFamProcRevision();

private:
    //  Getter method for the Implementation Object
    Lgt0PartFamProcRevisionImpl*  getLgt0PartFamProcRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLgt0PartFamProcRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lgt0PartFamProcRevisionImpl*  m_lgt0partfamprocrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lgt0PartFamProcRevision - desc for Lgt0PartFamProcRevision parameter
     */
    Lgt0PartFamProcRevision( const Lgt0PartFamProcRevision& );
    Lgt0PartFamProcRevision& operator=( const Lgt0PartFamProcRevision& );

    friend class  Lgt0PartFamProcRevisionDelegate;
    friend class  Lgt0PartFamProcRevisionDispatch;
    friend class  Lgt0PartFamProcRevisionGenImpl;
};

#include <Lgt0logistics/liblgt0logistics_undef.h>
#endif //   TEAMCENTER__LGT0PARTFAMPROCREVISION__HXX
