//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lgt0PartFamProcRevisionDelegate
    Filename:   Lgt0PartFamProcRevisionDelegate.hxx
    Module:     Lgt0logistics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LGT0PARTFAMPROCREVISIONDELEGATE_HXX
#define TEAMCENTER__LGT0PARTFAMPROCREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Lgt0logistics/Lgt0PartFamProcRevision.hxx>

#include <Lgt0logistics/liblgt0logistics_exports.h>

namespace Teamcenter
{
    class Lgt0PartFamProcRevisionDelegate;
}
namespace Teamcenter
{
    class Lgt0PartFamProcRevisionImpl;
}
namespace Teamcenter
{
    class Lgt0PartFamProcRevision;
}
namespace Teamcenter
{
    class Lgt0PartFamProcRevisionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  LGT0LOGISTICS_API Teamcenter_alias::Lgt0PartFamProcRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Lgt0PartFamProcRevisionDelegate instance
    static Lgt0PartFamProcRevisionDelegate&  getInstance();

    //  Method to create the Lgt0PartFamProcRevisionImpl pointer
    static Lgt0PartFamProcRevisionImpl*  createImpl( Lgt0PartFamProcRevision&  ifObj );

    //  Method to delete the Lgt0PartFamProcRevisionImpl pointer
    static void deleteImpl( Lgt0PartFamProcRevisionImpl*  impl );


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLgt0CalculatedColorVariantsBase(const Lgt0PartFamProcRevision &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLgt0CalculatedTechVariantsBase(const Lgt0PartFamProcRevision &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLgt0CalculatedTotalVariantsBase(const Lgt0PartFamProcRevision &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 10.1.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLgt0CalculatedColorVariantsBase(Lgt0PartFamProcRevision &ifObj,  int value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 10.1.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLgt0CalculatedTechVariantsBase(Lgt0PartFamProcRevision &ifObj,  int value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 10.1.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLgt0CalculatedTotalVariantsBase(Lgt0PartFamProcRevision &ifObj,  int value, bool isNull );



protected:
    //  Pointer to the instance
    static Lgt0PartFamProcRevisionDelegate*  m_pInstance;

    Lgt0PartFamProcRevisionDelegate();
    virtual ~Lgt0PartFamProcRevisionDelegate();
    static void setInstance( Lgt0PartFamProcRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::Lgt0PartFamProcRevisionGenImpl;

};

#include <Lgt0logistics/liblgt0logistics_undef.h>
#endif  //  TEAMCENTER__LGT0PARTFAMPROCREVISIONDELEGATE_HXX
