//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lgt0SupplyChainRevision
    Filename:   Lgt0SupplyChainRevision.hxx
    Module:     Lgt0logistics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LGT0SUPPLYCHAINREVISION__HXX
#define TEAMCENTER__LGT0SUPPLYCHAINREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <me/MEProcessRevision.hxx>

#include <Lgt0logistics/liblgt0logistics_exports.h>

namespace Teamcenter
{
    class Lgt0SupplyChainRevision;
}
namespace Teamcenter
{
    class Lgt0SupplyChainRevisionImpl;
}
namespace Teamcenter
{
    class Lgt0SupplyChainRevisionDelegate;
}
namespace Teamcenter
{
    class Lgt0SupplyChainRevisionDispatch;
}
namespace Teamcenter
{
    class Lgt0SupplyChainRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LGT0LOGISTICS_API  Teamcenter::Lgt0SupplyChainRevision
     : public  ::Teamcenter::MEProcessRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lgt0SupplyChainRevision();

    /**
     * Destructor
     */
    virtual ~Lgt0SupplyChainRevision();

private:
    //  Getter method for the Implementation Object
    Lgt0SupplyChainRevisionImpl*  getLgt0SupplyChainRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLgt0SupplyChainRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lgt0SupplyChainRevisionImpl*  m_lgt0supplychainrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lgt0SupplyChainRevision - desc for Lgt0SupplyChainRevision parameter
     */
    Lgt0SupplyChainRevision( const Lgt0SupplyChainRevision& );
    Lgt0SupplyChainRevision& operator=( const Lgt0SupplyChainRevision& );

    friend class  Lgt0SupplyChainRevisionDelegate;
    friend class  Lgt0SupplyChainRevisionDispatch;
    friend class  Lgt0SupplyChainRevisionGenImpl;
};

#include <Lgt0logistics/liblgt0logistics_undef.h>
#endif //   TEAMCENTER__LGT0SUPPLYCHAINREVISION__HXX
