//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  Lgt0logistics

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libLgt0logistics

#if !defined(LIBLGT0LOGISTICS) && !defined(IPLIB)
#   error IPLIB or LIBLGT0LOGISTICS is not defined
#endif

/* Handwritten code should use LGT0LOGISTICS_API, not LGT0LOGISTICSEXPORT */

#define LGT0LOGISTICS_API LGT0LOGISTICSEXPORT

#if IPLIB==libLgt0logistics || defined(LIBLGT0LOGISTICS)
#   if defined(__lint)
#       define LGT0LOGISTICSEXPORT       __export(Lgt0logistics)
#       define LGT0LOGISTICSGLOBAL       extern __global(Lgt0logistics)
#       define LGT0LOGISTICSPRIVATE      extern __private(Lgt0logistics)
#   elif defined(_WIN32)
#       define LGT0LOGISTICSEXPORT       __declspec(dllexport)
#       define LGT0LOGISTICSGLOBAL       extern __declspec(dllexport)
#       define LGT0LOGISTICSPRIVATE      extern
#   else
#       define LGT0LOGISTICSEXPORT
#       define LGT0LOGISTICSGLOBAL       extern
#       define LGT0LOGISTICSPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define LGT0LOGISTICSEXPORT       __export(Lgt0logistics)
#       define LGT0LOGISTICSGLOBAL       extern __global(Lgt0logistics)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define LGT0LOGISTICSEXPORT      __declspec(dllimport)
#       define LGT0LOGISTICSGLOBAL       extern __declspec(dllimport)
#   else
#       define LGT0LOGISTICSEXPORT
#       define LGT0LOGISTICSGLOBAL       extern
#   endif
#endif
