//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lis0CatalogWriter
    Filename:   Lis0CatalogWriter.hxx
    Module:     Lis0lisfmwrk
    @BMIDE autogenerated
==================================================================================================*/

#ifndef LIS0LISFMWRK__LIS0CATALOGWRITER__HXX
#define LIS0LISFMWRK__LIS0CATALOGWRITER__HXX

#include <common/tc_deprecation_macros.h>
#include <Lis0lisfmwrk/Lis0ResourceWriter.hxx>

#include <Lis0lisfmwrk/liblis0lisfmwrk_exports.h>

namespace lis0lisfmwrk
{
    class Lis0CatalogWriter;
}
namespace lis0lisfmwrk
{
    class Lis0CatalogWriterImpl;
}
namespace lis0lisfmwrk
{
    class Lis0CatalogWriterDelegate;
}
namespace lis0lisfmwrk
{
    class Lis0CatalogWriterDispatch;
}
namespace lis0lisfmwrk
{
    class Lis0CatalogWriterGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LIS0LISFMWRK_API  lis0lisfmwrk::Lis0CatalogWriter
     : public  ::lis0lisfmwrk::Lis0ResourceWriter
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lis0CatalogWriter();

    /**
     * Destructor
     */
    virtual ~Lis0CatalogWriter();

private:
    //  Getter method for the Implementation Object
    Lis0CatalogWriterImpl*  getLis0CatalogWriterImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLis0CatalogWriterImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lis0CatalogWriterImpl*  m_lis0catalogwriterImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lis0CatalogWriter - desc for Lis0CatalogWriter parameter
     */
    Lis0CatalogWriter( const Lis0CatalogWriter& );
    Lis0CatalogWriter& operator=( const Lis0CatalogWriter& );

    friend class  Lis0CatalogWriterDelegate;
    friend class  Lis0CatalogWriterDispatch;
    friend class  Lis0CatalogWriterGenImpl;
};

#include <Lis0lisfmwrk/liblis0lisfmwrk_undef.h>
#endif //   LIS0LISFMWRK__LIS0CATALOGWRITER__HXX
