//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lis0CatalogWriterDelegate
    Filename:   Lis0CatalogWriterDelegate.hxx
    Module:     Lis0lisfmwrk
    @BMIDE autogenerated
==================================================================================================*/

#ifndef LIS0LISFMWRK__LIS0CATALOGWRITERDELEGATE_HXX
#define LIS0LISFMWRK__LIS0CATALOGWRITERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Lis0lisfmwrk/Lis0CatalogWriter.hxx>

#include <Lis0lisfmwrk/liblis0lisfmwrk_exports.h>

namespace lis0lisfmwrk
{
    class Lis0CatalogWriterDelegate;
}
namespace lis0lisfmwrk
{
    class Lis0CatalogWriterImpl;
}
namespace lis0lisfmwrk
{
    class Lis0CatalogWriter;
}
namespace lis0lisfmwrk
{
    class Lis0CatalogWriterGenImpl;
}

namespace lis0lisfmwrk_alias = ::lis0lisfmwrk;


class  LIS0LISFMWRK_API lis0lisfmwrk_alias::Lis0CatalogWriterDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Lis0CatalogWriterDelegate instance
    static Lis0CatalogWriterDelegate&  getInstance();

    //  Method to create the Lis0CatalogWriterImpl pointer
    static Lis0CatalogWriterImpl*  createImpl( Lis0CatalogWriter&  ifObj );

    //  Method to delete the Lis0CatalogWriterImpl pointer
    static void deleteImpl( Lis0CatalogWriterImpl*  impl );


    ///
    /// Validate if it is supported to write based on the input resource instance
    /// @version Teamcenter 10.1.4
    /// @param resourceTag - Resource instance
    /// @param canWrite - Flag to indicate if it is supported to write based on the input resource instance
    /// @return - Error code. If successful, return 0.
    ///
    int  lis0IsWritableBase(const Lis0CatalogWriter &ifObj,  tag_t resourceTag, bool *canWrite ) const;



protected:
    //  Pointer to the instance
    static Lis0CatalogWriterDelegate*  m_pInstance;

    Lis0CatalogWriterDelegate();
    virtual ~Lis0CatalogWriterDelegate();
    static void setInstance( Lis0CatalogWriterDelegate*  instance );


private:
    friend class  ::lis0lisfmwrk::Lis0CatalogWriterGenImpl;

};

#include <Lis0lisfmwrk/liblis0lisfmwrk_undef.h>
#endif  //  LIS0LISFMWRK__LIS0CATALOGWRITERDELEGATE_HXX
