//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lis0CompactRDFWriter
    Filename:   Lis0CompactRDFWriter.hxx
    Module:     Lis0lisfmwrk
    @BMIDE autogenerated
==================================================================================================*/

#ifndef LIS0LISFMWRK__LIS0COMPACTRDFWRITER__HXX
#define LIS0LISFMWRK__LIS0COMPACTRDFWRITER__HXX

#include <common/tc_deprecation_macros.h>
#include <Lis0lisfmwrk/Lis0ResourceWriter.hxx>

#include <Lis0lisfmwrk/liblis0lisfmwrk_exports.h>

namespace lis0lisfmwrk
{
    class Lis0CompactRDFWriter;
}
namespace lis0lisfmwrk
{
    class Lis0CompactRDFWriterImpl;
}
namespace lis0lisfmwrk
{
    class Lis0CompactRDFWriterDelegate;
}
namespace lis0lisfmwrk
{
    class Lis0CompactRDFWriterDispatch;
}
namespace lis0lisfmwrk
{
    class Lis0CompactRDFWriterGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LIS0LISFMWRK_API  lis0lisfmwrk::Lis0CompactRDFWriter
     : public  ::lis0lisfmwrk::Lis0ResourceWriter
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lis0CompactRDFWriter();

    /**
     * Destructor
     */
    virtual ~Lis0CompactRDFWriter();

private:
    //  Getter method for the Implementation Object
    Lis0CompactRDFWriterImpl*  getLis0CompactRDFWriterImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLis0CompactRDFWriterImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lis0CompactRDFWriterImpl*  m_lis0compactrdfwriterImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lis0CompactRDFWriter - desc for Lis0CompactRDFWriter parameter
     */
    Lis0CompactRDFWriter( const Lis0CompactRDFWriter& );
    Lis0CompactRDFWriter& operator=( const Lis0CompactRDFWriter& );

    friend class  Lis0CompactRDFWriterDelegate;
    friend class  Lis0CompactRDFWriterDispatch;
    friend class  Lis0CompactRDFWriterGenImpl;
};

#include <Lis0lisfmwrk/liblis0lisfmwrk_undef.h>
#endif //   LIS0LISFMWRK__LIS0COMPACTRDFWRITER__HXX
