//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lis0CompactRDFWriterDelegate
    Filename:   Lis0CompactRDFWriterDelegate.hxx
    Module:     Lis0lisfmwrk
    @BMIDE autogenerated
==================================================================================================*/

#ifndef LIS0LISFMWRK__LIS0COMPACTRDFWRITERDELEGATE_HXX
#define LIS0LISFMWRK__LIS0COMPACTRDFWRITERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Lis0lisfmwrk/Lis0CompactRDFWriter.hxx>

#include <Lis0lisfmwrk/liblis0lisfmwrk_exports.h>

namespace lis0lisfmwrk
{
    class Lis0CompactRDFWriterDelegate;
}
namespace lis0lisfmwrk
{
    class Lis0CompactRDFWriterImpl;
}
namespace lis0lisfmwrk
{
    class Lis0CompactRDFWriter;
}
namespace lis0lisfmwrk
{
    class Lis0CompactRDFWriterGenImpl;
}

namespace lis0lisfmwrk_alias = ::lis0lisfmwrk;


class  LIS0LISFMWRK_API lis0lisfmwrk_alias::Lis0CompactRDFWriterDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Lis0CompactRDFWriterDelegate instance
    static Lis0CompactRDFWriterDelegate&  getInstance();

    //  Method to create the Lis0CompactRDFWriterImpl pointer
    static Lis0CompactRDFWriterImpl*  createImpl( Lis0CompactRDFWriter&  ifObj );

    //  Method to delete the Lis0CompactRDFWriterImpl pointer
    static void deleteImpl( Lis0CompactRDFWriterImpl*  impl );


    ///
    /// Validate if it is supported to write based on the input resource instance
    /// @version Teamcenter 10.1.4
    /// @param resourceTag - Resource instance
    /// @param canWrite - Flag to indicate if it is supported to write based on the input resource instance
    /// @return - Error code. If successful, return 0.
    ///
    int  lis0IsWritableBase(const Lis0CompactRDFWriter &ifObj,  tag_t resourceTag, bool *canWrite ) const;



protected:
    //  Pointer to the instance
    static Lis0CompactRDFWriterDelegate*  m_pInstance;

    Lis0CompactRDFWriterDelegate();
    virtual ~Lis0CompactRDFWriterDelegate();
    static void setInstance( Lis0CompactRDFWriterDelegate*  instance );


private:
    friend class  ::lis0lisfmwrk::Lis0CompactRDFWriterGenImpl;

};

#include <Lis0lisfmwrk/liblis0lisfmwrk_undef.h>
#endif  //  LIS0LISFMWRK__LIS0COMPACTRDFWRITERDELEGATE_HXX
