//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lis0DelegatedDialogs
    Filename:   Lis0DelegatedDialogs.hxx
    Module:     Lis0lisfmwrk
    @BMIDE autogenerated
==================================================================================================*/

#ifndef LIS0LISFMWRK__LIS0DELEGATEDDIALOGS__HXX
#define LIS0LISFMWRK__LIS0DELEGATEDDIALOGS__HXX

#include <unidefs.h>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <Lis0lisfmwrk/liblis0lisfmwrk_exports.h>

namespace lis0lisfmwrk
{
    class Lis0DelegatedDialogs;
}
namespace lis0lisfmwrk
{
    class Lis0DelegatedDialogsImpl;
}
namespace lis0lisfmwrk
{
    class Lis0DelegatedDialogsDelegate;
}
namespace lis0lisfmwrk
{
    class Lis0DelegatedDialogsDispatch;
}
namespace lis0lisfmwrk
{
    class Lis0DelegatedDialogsGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LIS0LISFMWRK_API  lis0lisfmwrk::Lis0DelegatedDialogs
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// 
    /// @version Teamcenter 10.1.6
    /// @param serviceProvider - Service Provider Tag
    /// @param delegatedDialogsList - Delegated Dialogs List
    /// @return - 
    ///
    int  lis0GetDelegatedDialogs( tag_t serviceProvider, std::vector< tag_t > *delegatedDialogsList );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lis0DelegatedDialogs();

    /**
     * Destructor
     */
    virtual ~Lis0DelegatedDialogs();

private:
    //  Getter method for the Implementation Object
    Lis0DelegatedDialogsImpl*  getLis0DelegatedDialogsImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLis0DelegatedDialogsImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lis0DelegatedDialogsImpl*  m_lis0delegateddialogsImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lis0DelegatedDialogs - desc for Lis0DelegatedDialogs parameter
     */
    Lis0DelegatedDialogs( const Lis0DelegatedDialogs& );
    Lis0DelegatedDialogs& operator=( const Lis0DelegatedDialogs& );

    friend class  Lis0DelegatedDialogsDelegate;
    friend class  Lis0DelegatedDialogsDispatch;
    friend class  Lis0DelegatedDialogsGenImpl;
};

#include <Lis0lisfmwrk/liblis0lisfmwrk_undef.h>
#endif //   LIS0LISFMWRK__LIS0DELEGATEDDIALOGS__HXX
