//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lis0FactoryService
    Filename:   Lis0FactoryService.hxx
    Module:     Lis0lisfmwrk
    @BMIDE autogenerated
==================================================================================================*/

#ifndef LIS0LISFMWRK__LIS0FACTORYSERVICE__HXX
#define LIS0LISFMWRK__LIS0FACTORYSERVICE__HXX

#include <unidefs.h>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <Lis0lisfmwrk/liblis0lisfmwrk_exports.h>

namespace lis0lisfmwrk
{
    class Lis0FactoryService;
}
namespace lis0lisfmwrk
{
    class Lis0FactoryServiceImpl;
}
namespace lis0lisfmwrk
{
    class Lis0FactoryServiceDelegate;
}
namespace lis0lisfmwrk
{
    class Lis0FactoryServiceDispatch;
}
namespace lis0lisfmwrk
{
    class Lis0FactoryServiceGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LIS0LISFMWRK_API  lis0lisfmwrk::Lis0FactoryService
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// 
    /// @version Teamcenter 10.1.6
    /// @param serviceProvider - Service Provider Tag
    /// @param factoryServicesList - Service Factory List
    /// @return - 
    ///
    int  lis0GetFactoryService( tag_t serviceProvider, std::vector< tag_t > *factoryServicesList );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lis0FactoryService();

    /**
     * Destructor
     */
    virtual ~Lis0FactoryService();

private:
    //  Getter method for the Implementation Object
    Lis0FactoryServiceImpl*  getLis0FactoryServiceImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLis0FactoryServiceImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lis0FactoryServiceImpl*  m_lis0factoryserviceImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lis0FactoryService - desc for Lis0FactoryService parameter
     */
    Lis0FactoryService( const Lis0FactoryService& );
    Lis0FactoryService& operator=( const Lis0FactoryService& );

    friend class  Lis0FactoryServiceDelegate;
    friend class  Lis0FactoryServiceDispatch;
    friend class  Lis0FactoryServiceGenImpl;
};

#include <Lis0lisfmwrk/liblis0lisfmwrk_undef.h>
#endif //   LIS0LISFMWRK__LIS0FACTORYSERVICE__HXX
