//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lis0HttpFormAuthentication
    Filename:   Lis0HttpFormAuthentication.hxx
    Module:     Lis0lisfmwrk
    @BMIDE autogenerated
==================================================================================================*/

#ifndef LIS0LISFMWRK__LIS0HTTPFORMAUTHENTICATION__HXX
#define LIS0LISFMWRK__LIS0HTTPFORMAUTHENTICATION__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <Lis0lisfmwrk/liblis0lisfmwrk_exports.h>

namespace lis0lisfmwrk
{
    class Lis0HttpFormAuthentication;
}
namespace lis0lisfmwrk
{
    class Lis0HttpFormAuthenticationImpl;
}
namespace lis0lisfmwrk
{
    class Lis0HttpFormAuthenticationDelegate;
}
namespace lis0lisfmwrk
{
    class Lis0HttpFormAuthenticationDispatch;
}
namespace lis0lisfmwrk
{
    class Lis0HttpFormAuthenticationGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LIS0LISFMWRK_API  lis0lisfmwrk::Lis0HttpFormAuthentication
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0userCookie( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLis0userCookie( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lis0HttpFormAuthentication();

    /**
     * Destructor
     */
    virtual ~Lis0HttpFormAuthentication();

private:
    //  Getter method for the Implementation Object
    Lis0HttpFormAuthenticationImpl*  getLis0HttpFormAuthenticationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLis0HttpFormAuthenticationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lis0HttpFormAuthenticationImpl*  m_lis0httpformauthenticationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lis0HttpFormAuthentication - desc for Lis0HttpFormAuthentication parameter
     */
    Lis0HttpFormAuthentication( const Lis0HttpFormAuthentication& );
    Lis0HttpFormAuthentication& operator=( const Lis0HttpFormAuthentication& );

    friend class  Lis0HttpFormAuthenticationDelegate;
    friend class  Lis0HttpFormAuthenticationDispatch;
    friend class  Lis0HttpFormAuthenticationGenImpl;
};

#include <Lis0lisfmwrk/liblis0lisfmwrk_undef.h>
#endif //   LIS0LISFMWRK__LIS0HTTPFORMAUTHENTICATION__HXX
