//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lis0HttpFormAuthenticationDelegate
    Filename:   Lis0HttpFormAuthenticationDelegate.hxx
    Module:     Lis0lisfmwrk
    @BMIDE autogenerated
==================================================================================================*/

#ifndef LIS0LISFMWRK__LIS0HTTPFORMAUTHENTICATIONDELEGATE_HXX
#define LIS0LISFMWRK__LIS0HTTPFORMAUTHENTICATIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Lis0lisfmwrk/Lis0HttpFormAuthentication.hxx>

#include <Lis0lisfmwrk/liblis0lisfmwrk_exports.h>

namespace lis0lisfmwrk
{
    class Lis0HttpFormAuthenticationDelegate;
}
namespace lis0lisfmwrk
{
    class Lis0HttpFormAuthenticationImpl;
}
namespace lis0lisfmwrk
{
    class Lis0HttpFormAuthentication;
}
namespace lis0lisfmwrk
{
    class Lis0HttpFormAuthenticationGenImpl;
}

namespace lis0lisfmwrk_alias = ::lis0lisfmwrk;


class  LIS0LISFMWRK_API lis0lisfmwrk_alias::Lis0HttpFormAuthenticationDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Lis0HttpFormAuthenticationDelegate instance
    static Lis0HttpFormAuthenticationDelegate&  getInstance();

    //  Method to create the Lis0HttpFormAuthenticationImpl pointer
    static Lis0HttpFormAuthenticationImpl*  createImpl( Lis0HttpFormAuthentication&  ifObj );

    //  Method to delete the Lis0HttpFormAuthenticationImpl pointer
    static void deleteImpl( Lis0HttpFormAuthenticationImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0userCookieBase(const Lis0HttpFormAuthentication &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLis0userCookieBase(Lis0HttpFormAuthentication &ifObj,  const std::string &value, bool isNull );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Lis0HttpFormAuthentication &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Lis0HttpFormAuthenticationDelegate*  m_pInstance;

    Lis0HttpFormAuthenticationDelegate();
    virtual ~Lis0HttpFormAuthenticationDelegate();
    static void setInstance( Lis0HttpFormAuthenticationDelegate*  instance );


private:
    friend class  ::lis0lisfmwrk::Lis0HttpFormAuthenticationGenImpl;

};

#include <Lis0lisfmwrk/liblis0lisfmwrk_undef.h>
#endif  //  LIS0LISFMWRK__LIS0HTTPFORMAUTHENTICATIONDELEGATE_HXX
