//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lis0JsonWriter
    Filename:   Lis0JsonWriter.hxx
    Module:     Lis0lisfmwrk
    @BMIDE autogenerated
==================================================================================================*/

#ifndef LIS0LISFMWRK__LIS0JSONWRITER__HXX
#define LIS0LISFMWRK__LIS0JSONWRITER__HXX

#include <common/tc_deprecation_macros.h>
#include <Lis0lisfmwrk/Lis0MediaWriter.hxx>

#include <Lis0lisfmwrk/liblis0lisfmwrk_exports.h>

namespace lis0lisfmwrk
{
    class Lis0JsonWriter;
}
namespace lis0lisfmwrk
{
    class Lis0JsonWriterImpl;
}
namespace lis0lisfmwrk
{
    class Lis0JsonWriterDelegate;
}
namespace lis0lisfmwrk
{
    class Lis0JsonWriterDispatch;
}
namespace lis0lisfmwrk
{
    class Lis0JsonWriterGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LIS0LISFMWRK_API  lis0lisfmwrk::Lis0JsonWriter
     : public  ::lis0lisfmwrk::Lis0MediaWriter
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lis0JsonWriter();

    /**
     * Destructor
     */
    virtual ~Lis0JsonWriter();

private:
    //  Getter method for the Implementation Object
    Lis0JsonWriterImpl*  getLis0JsonWriterImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLis0JsonWriterImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lis0JsonWriterImpl*  m_lis0jsonwriterImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lis0JsonWriter - desc for Lis0JsonWriter parameter
     */
    Lis0JsonWriter( const Lis0JsonWriter& );
    Lis0JsonWriter& operator=( const Lis0JsonWriter& );

    friend class  Lis0JsonWriterDelegate;
    friend class  Lis0JsonWriterDispatch;
    friend class  Lis0JsonWriterGenImpl;
};

#include <Lis0lisfmwrk/liblis0lisfmwrk_undef.h>
#endif //   LIS0LISFMWRK__LIS0JSONWRITER__HXX
