//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lis0JsonWriterDelegate
    Filename:   Lis0JsonWriterDelegate.hxx
    Module:     Lis0lisfmwrk
    @BMIDE autogenerated
==================================================================================================*/

#ifndef LIS0LISFMWRK__LIS0JSONWRITERDELEGATE_HXX
#define LIS0LISFMWRK__LIS0JSONWRITERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Lis0lisfmwrk/Lis0JsonWriter.hxx>

#include <Lis0lisfmwrk/liblis0lisfmwrk_exports.h>

namespace lis0lisfmwrk
{
    class Lis0JsonWriterDelegate;
}
namespace lis0lisfmwrk
{
    class Lis0JsonWriterImpl;
}
namespace lis0lisfmwrk
{
    class Lis0JsonWriter;
}
namespace lis0lisfmwrk
{
    class Lis0JsonWriterGenImpl;
}

namespace lis0lisfmwrk_alias = ::lis0lisfmwrk;


class  LIS0LISFMWRK_API lis0lisfmwrk_alias::Lis0JsonWriterDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Lis0JsonWriterDelegate instance
    static Lis0JsonWriterDelegate&  getInstance();

    //  Method to create the Lis0JsonWriterImpl pointer
    static Lis0JsonWriterImpl*  createImpl( Lis0JsonWriter&  ifObj );

    //  Method to delete the Lis0JsonWriterImpl pointer
    static void deleteImpl( Lis0JsonWriterImpl*  impl );


    ///
    /// read the document
    /// @version Teamcenter 10.1.4
    /// @param mediaType - media type
    /// @param document - document
    /// @param resourceModel - resource model
    /// @return - Return error codes
    ///
    int  lis0ReadFromBase(const Lis0JsonWriter &ifObj,  const std::string *mediaType, const std::string *document, lis0lisfmwrk::AbstractResource **resourceModel ) const;


    ///
    /// write the document with the input media type
    /// @version Teamcenter 10.1.4
    /// @param mediaType - media type
    /// @param model - resource model
    /// @param document - writting document
    /// @return - Return error codes
    ///
    int  lis0WriteToBase(const Lis0JsonWriter &ifObj,  const std::string *mediaType, const lis0lisfmwrk::AbstractResource *model, std::string *document ) const;



protected:
    //  Pointer to the instance
    static Lis0JsonWriterDelegate*  m_pInstance;

    Lis0JsonWriterDelegate();
    virtual ~Lis0JsonWriterDelegate();
    static void setInstance( Lis0JsonWriterDelegate*  instance );


private:
    friend class  ::lis0lisfmwrk::Lis0JsonWriterGenImpl;

};

#include <Lis0lisfmwrk/liblis0lisfmwrk_undef.h>
#endif  //  LIS0LISFMWRK__LIS0JSONWRITERDELEGATE_HXX
