//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lis0Link
    Filename:   Lis0Link.hxx
    Module:     Lis0lisfmwrk
    @BMIDE autogenerated
==================================================================================================*/

#ifndef LIS0LISFMWRK__LIS0LINK__HXX
#define LIS0LISFMWRK__LIS0LINK__HXX

#include <string>
#include <Lis0lisfmwrk/Lis0ServiceDef.hxx>
#include <common/tc_deprecation_macros.h>
#include <form/Form.hxx>

#include <Lis0lisfmwrk/liblis0lisfmwrk_exports.h>

namespace lis0lisfmwrk
{
    class Lis0Link;
}
namespace lis0lisfmwrk
{
    class Lis0LinkImpl;
}
namespace lis0lisfmwrk
{
    class Lis0LinkDelegate;
}
namespace lis0lisfmwrk
{
    class Lis0LinkDispatch;
}
namespace lis0lisfmwrk
{
    class Lis0LinkGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LIS0LISFMWRK_API  lis0lisfmwrk::Lis0Link
     : public  ::Teamcenter::Form
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0accessibility( int &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0previewUrl( std::string &value, bool &isNull ) const;

    ///
    /// 
    /// @version Teamcenter 10.1.2
    /// @param linkURL - URL to indicate the resource link
    /// @param resourceInfo - Remote resource information
    /// @return - 
    ///
    int  lis0getResource( const std::string *linkURL, ResourceInfo *resourceInfo );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lis0Link();

    /**
     * Destructor
     */
    virtual ~Lis0Link();

private:
    //  Getter method for the Implementation Object
    Lis0LinkImpl*  getLis0LinkImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLis0LinkImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lis0LinkImpl*  m_lis0linkImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lis0Link - desc for Lis0Link parameter
     */
    Lis0Link( const Lis0Link& );
    Lis0Link& operator=( const Lis0Link& );

    friend class  Lis0LinkDelegate;
    friend class  Lis0LinkDispatch;
    friend class  Lis0LinkGenImpl;
};

#include <Lis0lisfmwrk/liblis0lisfmwrk_undef.h>
#endif //   LIS0LISFMWRK__LIS0LINK__HXX
