//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lis0LinkDelegate
    Filename:   Lis0LinkDelegate.hxx
    Module:     Lis0lisfmwrk
    @BMIDE autogenerated
==================================================================================================*/

#ifndef LIS0LISFMWRK__LIS0LINKDELEGATE_HXX
#define LIS0LISFMWRK__LIS0LINKDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Lis0lisfmwrk/Lis0Link.hxx>

#include <Lis0lisfmwrk/liblis0lisfmwrk_exports.h>

namespace lis0lisfmwrk
{
    class Lis0LinkDelegate;
}
namespace lis0lisfmwrk
{
    class Lis0LinkImpl;
}
namespace lis0lisfmwrk
{
    class Lis0Link;
}
namespace lis0lisfmwrk
{
    class Lis0LinkGenImpl;
}

namespace lis0lisfmwrk_alias = ::lis0lisfmwrk;


class  LIS0LISFMWRK_API lis0lisfmwrk_alias::Lis0LinkDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Lis0LinkDelegate instance
    static Lis0LinkDelegate&  getInstance();

    //  Method to create the Lis0LinkImpl pointer
    static Lis0LinkImpl*  createImpl( Lis0Link&  ifObj );

    //  Method to delete the Lis0LinkImpl pointer
    static void deleteImpl( Lis0LinkImpl*  impl );


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0accessibilityBase(const Lis0Link &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0previewUrlBase(const Lis0Link &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// 
    /// @version Teamcenter 10.1.2
    /// @param linkURL - URL to indicate the resource link
    /// @param resourceInfo - Remote resource information
    /// @return - 
    ///
    int  lis0getResourceBase(const Lis0Link &ifObj,  const std::string *linkURL, ResourceInfo *resourceInfo );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Lis0Link &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Lis0LinkDelegate*  m_pInstance;

    Lis0LinkDelegate();
    virtual ~Lis0LinkDelegate();
    static void setInstance( Lis0LinkDelegate*  instance );


private:
    friend class  ::lis0lisfmwrk::Lis0LinkGenImpl;

};

#include <Lis0lisfmwrk/liblis0lisfmwrk_undef.h>
#endif  //  LIS0LISFMWRK__LIS0LINKDELEGATE_HXX
