//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lis0MediaWriterDelegate
    Filename:   Lis0MediaWriterDelegate.hxx
    Module:     Lis0lisfmwrk
    @BMIDE autogenerated
==================================================================================================*/

#ifndef LIS0LISFMWRK__LIS0MEDIAWRITERDELEGATE_HXX
#define LIS0LISFMWRK__LIS0MEDIAWRITERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Lis0lisfmwrk/Lis0MediaWriter.hxx>

#include <Lis0lisfmwrk/liblis0lisfmwrk_exports.h>

namespace lis0lisfmwrk
{
    class Lis0MediaWriterDelegate;
}
namespace lis0lisfmwrk
{
    class Lis0MediaWriterImpl;
}
namespace lis0lisfmwrk
{
    class Lis0MediaWriter;
}
namespace lis0lisfmwrk
{
    class Lis0MediaWriterGenImpl;
}

namespace lis0lisfmwrk_alias = ::lis0lisfmwrk;


class  LIS0LISFMWRK_API lis0lisfmwrk_alias::Lis0MediaWriterDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Lis0MediaWriterDelegate instance
    static Lis0MediaWriterDelegate&  getInstance();

    //  Method to create the Lis0MediaWriterImpl pointer
    static Lis0MediaWriterImpl*  createImpl( Lis0MediaWriter&  ifObj );

    //  Method to delete the Lis0MediaWriterImpl pointer
    static void deleteImpl( Lis0MediaWriterImpl*  impl );


    ///
    /// check if the required media types can be supported when reading
    /// @version Teamcenter 10.1.4
    /// @param requiredMediaType - required media type
    /// @param result - Is readable
    /// @return - Return error codes
    ///
    int  lis0IsReadableBase(const Lis0MediaWriter &ifObj,  const std::string *requiredMediaType, bool *result ) const;


    ///
    /// check if the required media types can be supported when writting
    /// @version Teamcenter 10.1.4
    /// @param requiredMediaType - required media type
    /// @param result - is writable
    /// @return - Return error codes
    ///
    int  lis0IsWritableBase(const Lis0MediaWriter &ifObj,  const std::string *requiredMediaType, bool *result ) const;


    ///
    /// read the document
    /// @version Teamcenter 10.1.4
    /// @param mediaType - media type
    /// @param document - document
    /// @param resourceModel - resource model
    /// @return - Return error codes
    ///
    int  lis0ReadFromBase(const Lis0MediaWriter &ifObj,  const std::string *mediaType, const std::string *document, lis0lisfmwrk::AbstractResource **resourceModel ) const;


    ///
    /// write the document with the input media type
    /// @version Teamcenter 10.1.4
    /// @param mediaType - media type
    /// @param model - resource model
    /// @param document - writting document
    /// @return - Return error codes
    ///
    int  lis0WriteToBase(const Lis0MediaWriter &ifObj,  const std::string *mediaType, const lis0lisfmwrk::AbstractResource *model, std::string *document ) const;



protected:
    //  Pointer to the instance
    static Lis0MediaWriterDelegate*  m_pInstance;

    Lis0MediaWriterDelegate();
    virtual ~Lis0MediaWriterDelegate();
    static void setInstance( Lis0MediaWriterDelegate*  instance );


private:
    friend class  ::lis0lisfmwrk::Lis0MediaWriterGenImpl;

};

#include <Lis0lisfmwrk/liblis0lisfmwrk_undef.h>
#endif  //  LIS0LISFMWRK__LIS0MEDIAWRITERDELEGATE_HXX
