//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lis0OAuthAuthentication
    Filename:   Lis0OAuthAuthentication.hxx
    Module:     Lis0lisfmwrk
    @BMIDE autogenerated
==================================================================================================*/

#ifndef LIS0LISFMWRK__LIS0OAUTHAUTHENTICATION__HXX
#define LIS0LISFMWRK__LIS0OAUTHAUTHENTICATION__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <Lis0lisfmwrk/liblis0lisfmwrk_exports.h>

namespace lis0lisfmwrk
{
    class Lis0OAuthAuthentication;
}
namespace lis0lisfmwrk
{
    class Lis0OAuthAuthenticationImpl;
}
namespace lis0lisfmwrk
{
    class Lis0OAuthAuthenticationDelegate;
}
namespace lis0lisfmwrk
{
    class Lis0OAuthAuthenticationDispatch;
}
namespace lis0lisfmwrk
{
    class Lis0OAuthAuthenticationGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LIS0LISFMWRK_API  lis0lisfmwrk::Lis0OAuthAuthentication
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0userOAuthToken( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0userOAuthTokenSecret( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLis0userOAuthToken( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLis0userOAuthTokenSecret( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lis0OAuthAuthentication();

    /**
     * Destructor
     */
    virtual ~Lis0OAuthAuthentication();

private:
    //  Getter method for the Implementation Object
    Lis0OAuthAuthenticationImpl*  getLis0OAuthAuthenticationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLis0OAuthAuthenticationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lis0OAuthAuthenticationImpl*  m_lis0oauthauthenticationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lis0OAuthAuthentication - desc for Lis0OAuthAuthentication parameter
     */
    Lis0OAuthAuthentication( const Lis0OAuthAuthentication& );
    Lis0OAuthAuthentication& operator=( const Lis0OAuthAuthentication& );

    friend class  Lis0OAuthAuthenticationDelegate;
    friend class  Lis0OAuthAuthenticationDispatch;
    friend class  Lis0OAuthAuthenticationGenImpl;
};

#include <Lis0lisfmwrk/liblis0lisfmwrk_undef.h>
#endif //   LIS0LISFMWRK__LIS0OAUTHAUTHENTICATION__HXX
