//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lis0OAuthAuthenticationDelegate
    Filename:   Lis0OAuthAuthenticationDelegate.hxx
    Module:     Lis0lisfmwrk
    @BMIDE autogenerated
==================================================================================================*/

#ifndef LIS0LISFMWRK__LIS0OAUTHAUTHENTICATIONDELEGATE_HXX
#define LIS0LISFMWRK__LIS0OAUTHAUTHENTICATIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Lis0lisfmwrk/Lis0OAuthAuthentication.hxx>

#include <Lis0lisfmwrk/liblis0lisfmwrk_exports.h>

namespace lis0lisfmwrk
{
    class Lis0OAuthAuthenticationDelegate;
}
namespace lis0lisfmwrk
{
    class Lis0OAuthAuthenticationImpl;
}
namespace lis0lisfmwrk
{
    class Lis0OAuthAuthentication;
}
namespace lis0lisfmwrk
{
    class Lis0OAuthAuthenticationGenImpl;
}

namespace lis0lisfmwrk_alias = ::lis0lisfmwrk;


class  LIS0LISFMWRK_API lis0lisfmwrk_alias::Lis0OAuthAuthenticationDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Lis0OAuthAuthenticationDelegate instance
    static Lis0OAuthAuthenticationDelegate&  getInstance();

    //  Method to create the Lis0OAuthAuthenticationImpl pointer
    static Lis0OAuthAuthenticationImpl*  createImpl( Lis0OAuthAuthentication&  ifObj );

    //  Method to delete the Lis0OAuthAuthenticationImpl pointer
    static void deleteImpl( Lis0OAuthAuthenticationImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0userOAuthTokenBase(const Lis0OAuthAuthentication &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0userOAuthTokenSecretBase(const Lis0OAuthAuthentication &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLis0userOAuthTokenBase(Lis0OAuthAuthentication &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLis0userOAuthTokenSecretBase(Lis0OAuthAuthentication &ifObj,  const std::string &value, bool isNull );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Lis0OAuthAuthentication &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Lis0OAuthAuthenticationDelegate*  m_pInstance;

    Lis0OAuthAuthenticationDelegate();
    virtual ~Lis0OAuthAuthenticationDelegate();
    static void setInstance( Lis0OAuthAuthenticationDelegate*  instance );


private:
    friend class  ::lis0lisfmwrk::Lis0OAuthAuthenticationGenImpl;

};

#include <Lis0lisfmwrk/liblis0lisfmwrk_undef.h>
#endif  //  LIS0LISFMWRK__LIS0OAUTHAUTHENTICATIONDELEGATE_HXX
