//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lis0OAuthUserTokens
    Filename:   Lis0OAuthUserTokens.hxx
    Module:     Lis0lisfmwrk
    @BMIDE autogenerated
==================================================================================================*/

#ifndef LIS0LISFMWRK__LIS0OAUTHUSERTOKENS__HXX
#define LIS0LISFMWRK__LIS0OAUTHUSERTOKENS__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <Lis0lisfmwrk/liblis0lisfmwrk_exports.h>

namespace lis0lisfmwrk
{
    class Lis0OAuthUserTokens;
}
namespace lis0lisfmwrk
{
    class Lis0OAuthUserTokensImpl;
}
namespace lis0lisfmwrk
{
    class Lis0OAuthUserTokensDelegate;
}
namespace lis0lisfmwrk
{
    class Lis0OAuthUserTokensDispatch;
}
namespace lis0lisfmwrk
{
    class Lis0OAuthUserTokensGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LIS0LISFMWRK_API  lis0lisfmwrk::Lis0OAuthUserTokens
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Saves access tokens and clears request tokens
    /// @version Teamcenter 11.2.1
    /// @param site - site tag
    /// @param accessToken - Access Token
    /// @param accessTokenSecret - Access Token Secret
    /// @return - 
    ///
    int  lis0SaveAccessTokens( tag_t site, char *accessToken, char *accessTokenSecret );

    ///
    /// Saves request tokens and clears access tokens
    /// @version Teamcenter 11.2.1
    /// @param site - site tag
    /// @param requestToken - Request Token
    /// @param requestTokenSecret - Request Token Secret
    /// @return - 
    ///
    int  lis0SaveRequestToken( tag_t site, char *requestToken, char *requestTokenSecret );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lis0OAuthUserTokens();

    /**
     * Destructor
     */
    virtual ~Lis0OAuthUserTokens();

private:
    //  Getter method for the Implementation Object
    Lis0OAuthUserTokensImpl*  getLis0OAuthUserTokensImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLis0OAuthUserTokensImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lis0OAuthUserTokensImpl*  m_lis0oauthusertokensImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lis0OAuthUserTokens - desc for Lis0OAuthUserTokens parameter
     */
    Lis0OAuthUserTokens( const Lis0OAuthUserTokens& );
    Lis0OAuthUserTokens& operator=( const Lis0OAuthUserTokens& );

    friend class  Lis0OAuthUserTokensDelegate;
    friend class  Lis0OAuthUserTokensDispatch;
    friend class  Lis0OAuthUserTokensGenImpl;
};

#include <Lis0lisfmwrk/liblis0lisfmwrk_undef.h>
#endif //   LIS0LISFMWRK__LIS0OAUTHUSERTOKENS__HXX
