//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lis0OAuthUserTokensDelegate
    Filename:   Lis0OAuthUserTokensDelegate.hxx
    Module:     Lis0lisfmwrk
    @BMIDE autogenerated
==================================================================================================*/

#ifndef LIS0LISFMWRK__LIS0OAUTHUSERTOKENSDELEGATE_HXX
#define LIS0LISFMWRK__LIS0OAUTHUSERTOKENSDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Lis0lisfmwrk/Lis0OAuthUserTokens.hxx>

#include <Lis0lisfmwrk/liblis0lisfmwrk_exports.h>

namespace lis0lisfmwrk
{
    class Lis0OAuthUserTokensDelegate;
}
namespace lis0lisfmwrk
{
    class Lis0OAuthUserTokensImpl;
}
namespace lis0lisfmwrk
{
    class Lis0OAuthUserTokens;
}
namespace lis0lisfmwrk
{
    class Lis0OAuthUserTokensGenImpl;
}

namespace lis0lisfmwrk_alias = ::lis0lisfmwrk;


class  LIS0LISFMWRK_API lis0lisfmwrk_alias::Lis0OAuthUserTokensDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Lis0OAuthUserTokensDelegate instance
    static Lis0OAuthUserTokensDelegate&  getInstance();

    //  Method to create the Lis0OAuthUserTokensImpl pointer
    static Lis0OAuthUserTokensImpl*  createImpl( Lis0OAuthUserTokens&  ifObj );

    //  Method to delete the Lis0OAuthUserTokensImpl pointer
    static void deleteImpl( Lis0OAuthUserTokensImpl*  impl );


    ///
    /// Saves access tokens and clears request tokens
    /// @version Teamcenter 11.2.1
    /// @param site - site tag
    /// @param accessToken - Access Token
    /// @param accessTokenSecret - Access Token Secret
    /// @return - 
    ///
    int  lis0SaveAccessTokensBase(const Lis0OAuthUserTokens &ifObj,  tag_t site, char *accessToken, char *accessTokenSecret );


    ///
    /// Saves request tokens and clears access tokens
    /// @version Teamcenter 11.2.1
    /// @param site - site tag
    /// @param requestToken - Request Token
    /// @param requestTokenSecret - Request Token Secret
    /// @return - 
    ///
    int  lis0SaveRequestTokenBase(const Lis0OAuthUserTokens &ifObj,  tag_t site, char *requestToken, char *requestTokenSecret );



protected:
    //  Pointer to the instance
    static Lis0OAuthUserTokensDelegate*  m_pInstance;

    Lis0OAuthUserTokensDelegate();
    virtual ~Lis0OAuthUserTokensDelegate();
    static void setInstance( Lis0OAuthUserTokensDelegate*  instance );


private:
    friend class  ::lis0lisfmwrk::Lis0OAuthUserTokensGenImpl;

};

#include <Lis0lisfmwrk/liblis0lisfmwrk_undef.h>
#endif  //  LIS0LISFMWRK__LIS0OAUTHUSERTOKENSDELEGATE_HXX
