//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lis0Protocol
    Filename:   Lis0Protocol.hxx
    Module:     Lis0lisfmwrk
    @BMIDE autogenerated
==================================================================================================*/

#ifndef LIS0LISFMWRK__LIS0PROTOCOL__HXX
#define LIS0LISFMWRK__LIS0PROTOCOL__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <Lis0lisfmwrk/Lis0Resource.hxx>

#include <Lis0lisfmwrk/liblis0lisfmwrk_exports.h>

namespace lis0lisfmwrk
{
    class Lis0Protocol;
}
namespace lis0lisfmwrk
{
    class Lis0ProtocolImpl;
}
namespace lis0lisfmwrk
{
    class Lis0ProtocolDelegate;
}
namespace lis0lisfmwrk
{
    class Lis0ProtocolDispatch;
}
namespace lis0lisfmwrk
{
    class Lis0ProtocolGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LIS0LISFMWRK_API  lis0lisfmwrk::Lis0Protocol
     : public  ::lis0lisfmwrk::Lis0Resource
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0protocolVersion( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLis0protocolVersion( const std::string &value, bool isNull=false );

    ///
    /// This opertaion will get the LIS object details
    /// @version Teamcenter 10.1.4
    /// @return - It will return failure OR success code
    ///
    int  lis0GetLISDescription(  ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lis0Protocol();

    /**
     * Destructor
     */
    virtual ~Lis0Protocol();

private:
    //  Getter method for the Implementation Object
    Lis0ProtocolImpl*  getLis0ProtocolImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLis0ProtocolImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lis0ProtocolImpl*  m_lis0protocolImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lis0Protocol - desc for Lis0Protocol parameter
     */
    Lis0Protocol( const Lis0Protocol& );
    Lis0Protocol& operator=( const Lis0Protocol& );

    friend class  Lis0ProtocolDelegate;
    friend class  Lis0ProtocolDispatch;
    friend class  Lis0ProtocolGenImpl;
};

#include <Lis0lisfmwrk/liblis0lisfmwrk_undef.h>
#endif //   LIS0LISFMWRK__LIS0PROTOCOL__HXX
