//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lis0ProtocolDelegate
    Filename:   Lis0ProtocolDelegate.hxx
    Module:     Lis0lisfmwrk
    @BMIDE autogenerated
==================================================================================================*/

#ifndef LIS0LISFMWRK__LIS0PROTOCOLDELEGATE_HXX
#define LIS0LISFMWRK__LIS0PROTOCOLDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Lis0lisfmwrk/Lis0Protocol.hxx>

#include <Lis0lisfmwrk/liblis0lisfmwrk_exports.h>

namespace lis0lisfmwrk
{
    class Lis0ProtocolDelegate;
}
namespace lis0lisfmwrk
{
    class Lis0ProtocolImpl;
}
namespace lis0lisfmwrk
{
    class Lis0Protocol;
}
namespace lis0lisfmwrk
{
    class Lis0ProtocolGenImpl;
}

namespace lis0lisfmwrk_alias = ::lis0lisfmwrk;


class  LIS0LISFMWRK_API lis0lisfmwrk_alias::Lis0ProtocolDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Lis0ProtocolDelegate instance
    static Lis0ProtocolDelegate&  getInstance();

    //  Method to create the Lis0ProtocolImpl pointer
    static Lis0ProtocolImpl*  createImpl( Lis0Protocol&  ifObj );

    //  Method to delete the Lis0ProtocolImpl pointer
    static void deleteImpl( Lis0ProtocolImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0protocolVersionBase(const Lis0Protocol &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLis0protocolVersionBase(Lis0Protocol &ifObj,  const std::string &value, bool isNull );


    ///
    /// This opertaion will get the LIS object details
    /// @version Teamcenter 10.1.4
    /// @return - It will return failure OR success code
    ///
    int  lis0GetLISDescriptionBase(const Lis0Protocol &ifObj  ) const;



protected:
    //  Pointer to the instance
    static Lis0ProtocolDelegate*  m_pInstance;

    Lis0ProtocolDelegate();
    virtual ~Lis0ProtocolDelegate();
    static void setInstance( Lis0ProtocolDelegate*  instance );


private:
    friend class  ::lis0lisfmwrk::Lis0ProtocolGenImpl;

};

#include <Lis0lisfmwrk/liblis0lisfmwrk_undef.h>
#endif  //  LIS0LISFMWRK__LIS0PROTOCOLDELEGATE_HXX
