//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lis0ProtocolWriter
    Filename:   Lis0ProtocolWriter.hxx
    Module:     Lis0lisfmwrk
    @BMIDE autogenerated
==================================================================================================*/

#ifndef LIS0LISFMWRK__LIS0PROTOCOLWRITER__HXX
#define LIS0LISFMWRK__LIS0PROTOCOLWRITER__HXX

#include <common/tc_deprecation_macros.h>
#include <Lis0lisfmwrk/Lis0ResourceWriter.hxx>

#include <Lis0lisfmwrk/liblis0lisfmwrk_exports.h>

namespace lis0lisfmwrk
{
    class Lis0ProtocolWriter;
}
namespace lis0lisfmwrk
{
    class Lis0ProtocolWriterImpl;
}
namespace lis0lisfmwrk
{
    class Lis0ProtocolWriterDelegate;
}
namespace lis0lisfmwrk
{
    class Lis0ProtocolWriterDispatch;
}
namespace lis0lisfmwrk
{
    class Lis0ProtocolWriterGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LIS0LISFMWRK_API  lis0lisfmwrk::Lis0ProtocolWriter
     : public  ::lis0lisfmwrk::Lis0ResourceWriter
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lis0ProtocolWriter();

    /**
     * Destructor
     */
    virtual ~Lis0ProtocolWriter();

private:
    //  Getter method for the Implementation Object
    Lis0ProtocolWriterImpl*  getLis0ProtocolWriterImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLis0ProtocolWriterImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lis0ProtocolWriterImpl*  m_lis0protocolwriterImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lis0ProtocolWriter - desc for Lis0ProtocolWriter parameter
     */
    Lis0ProtocolWriter( const Lis0ProtocolWriter& );
    Lis0ProtocolWriter& operator=( const Lis0ProtocolWriter& );

    friend class  Lis0ProtocolWriterDelegate;
    friend class  Lis0ProtocolWriterDispatch;
    friend class  Lis0ProtocolWriterGenImpl;
};

#include <Lis0lisfmwrk/liblis0lisfmwrk_undef.h>
#endif //   LIS0LISFMWRK__LIS0PROTOCOLWRITER__HXX
