//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lis0ProtocolWriterDelegate
    Filename:   Lis0ProtocolWriterDelegate.hxx
    Module:     Lis0lisfmwrk
    @BMIDE autogenerated
==================================================================================================*/

#ifndef LIS0LISFMWRK__LIS0PROTOCOLWRITERDELEGATE_HXX
#define LIS0LISFMWRK__LIS0PROTOCOLWRITERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Lis0lisfmwrk/Lis0ProtocolWriter.hxx>

#include <Lis0lisfmwrk/liblis0lisfmwrk_exports.h>

namespace lis0lisfmwrk
{
    class Lis0ProtocolWriterDelegate;
}
namespace lis0lisfmwrk
{
    class Lis0ProtocolWriterImpl;
}
namespace lis0lisfmwrk
{
    class Lis0ProtocolWriter;
}
namespace lis0lisfmwrk
{
    class Lis0ProtocolWriterGenImpl;
}

namespace lis0lisfmwrk_alias = ::lis0lisfmwrk;


class  LIS0LISFMWRK_API lis0lisfmwrk_alias::Lis0ProtocolWriterDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Lis0ProtocolWriterDelegate instance
    static Lis0ProtocolWriterDelegate&  getInstance();

    //  Method to create the Lis0ProtocolWriterImpl pointer
    static Lis0ProtocolWriterImpl*  createImpl( Lis0ProtocolWriter&  ifObj );

    //  Method to delete the Lis0ProtocolWriterImpl pointer
    static void deleteImpl( Lis0ProtocolWriterImpl*  impl );


    ///
    /// Validate if it is supported to write based on the input resource instance
    /// @version Teamcenter 10.1.4
    /// @param resourceTag - Resource instance
    /// @param canWrite - Flag to indicate if it is supported to write based on the input resource instance
    /// @return - Error code. If successful, return 0.
    ///
    int  lis0IsWritableBase(const Lis0ProtocolWriter &ifObj,  tag_t resourceTag, bool *canWrite ) const;



protected:
    //  Pointer to the instance
    static Lis0ProtocolWriterDelegate*  m_pInstance;

    Lis0ProtocolWriterDelegate();
    virtual ~Lis0ProtocolWriterDelegate();
    static void setInstance( Lis0ProtocolWriterDelegate*  instance );


private:
    friend class  ::lis0lisfmwrk::Lis0ProtocolWriterGenImpl;

};

#include <Lis0lisfmwrk/liblis0lisfmwrk_undef.h>
#endif  //  LIS0LISFMWRK__LIS0PROTOCOLWRITERDELEGATE_HXX
