//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lis0ProviderCatalogDelegate
    Filename:   Lis0ProviderCatalogDelegate.hxx
    Module:     Lis0lisfmwrk
    @BMIDE autogenerated
==================================================================================================*/

#ifndef LIS0LISFMWRK__LIS0PROVIDERCATALOGDELEGATE_HXX
#define LIS0LISFMWRK__LIS0PROVIDERCATALOGDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Lis0lisfmwrk/Lis0ProviderCatalog.hxx>

#include <Lis0lisfmwrk/liblis0lisfmwrk_exports.h>

namespace lis0lisfmwrk
{
    class Lis0ProviderCatalogDelegate;
}
namespace lis0lisfmwrk
{
    class Lis0ProviderCatalogImpl;
}
namespace lis0lisfmwrk
{
    class Lis0ProviderCatalog;
}
namespace lis0lisfmwrk
{
    class Lis0ProviderCatalogGenImpl;
}

namespace lis0lisfmwrk_alias = ::lis0lisfmwrk;


class  LIS0LISFMWRK_API lis0lisfmwrk_alias::Lis0ProviderCatalogDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Lis0ProviderCatalogDelegate instance
    static Lis0ProviderCatalogDelegate&  getInstance();

    //  Method to create the Lis0ProviderCatalogImpl pointer
    static Lis0ProviderCatalogImpl*  createImpl( Lis0ProviderCatalog&  ifObj );

    //  Method to delete the Lis0ProviderCatalogImpl pointer
    static void deleteImpl( Lis0ProviderCatalogImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0catalogSpecVersionBase(const Lis0ProviderCatalog &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0domainNamespaceBase(const Lis0ProviderCatalog &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0domainNamespacePrefixBase(const Lis0ProviderCatalog &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1.4
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0excludedTypesBase(const Lis0ProviderCatalog &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1.4
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0includedTypesBase(const Lis0ProviderCatalog &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0protocolBase(const Lis0ProviderCatalog &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0publisherBase(const Lis0ProviderCatalog &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLis0catalogSpecVersionBase(Lis0ProviderCatalog &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLis0domainNamespaceBase(Lis0ProviderCatalog &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLis0domainNamespacePrefixBase(Lis0ProviderCatalog &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 10.1.4
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setLis0excludedTypesBase(Lis0ProviderCatalog &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 10.1.4
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setLis0includedTypesBase(Lis0ProviderCatalog &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10.1.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLis0protocolBase(Lis0ProviderCatalog &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLis0publisherBase(Lis0ProviderCatalog &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static Lis0ProviderCatalogDelegate*  m_pInstance;

    Lis0ProviderCatalogDelegate();
    virtual ~Lis0ProviderCatalogDelegate();
    static void setInstance( Lis0ProviderCatalogDelegate*  instance );


private:
    friend class  ::lis0lisfmwrk::Lis0ProviderCatalogGenImpl;

};

#include <Lis0lisfmwrk/liblis0lisfmwrk_undef.h>
#endif  //  LIS0LISFMWRK__LIS0PROVIDERCATALOGDELEGATE_HXX
