//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lis0ProviderWriter
    Filename:   Lis0ProviderWriter.hxx
    Module:     Lis0lisfmwrk
    @BMIDE autogenerated
==================================================================================================*/

#ifndef LIS0LISFMWRK__LIS0PROVIDERWRITER__HXX
#define LIS0LISFMWRK__LIS0PROVIDERWRITER__HXX

#include <common/tc_deprecation_macros.h>
#include <Lis0lisfmwrk/Lis0ResourceWriter.hxx>

#include <Lis0lisfmwrk/liblis0lisfmwrk_exports.h>

namespace lis0lisfmwrk
{
    class Lis0ProviderWriter;
}
namespace lis0lisfmwrk
{
    class Lis0ProviderWriterImpl;
}
namespace lis0lisfmwrk
{
    class Lis0ProviderWriterDelegate;
}
namespace lis0lisfmwrk
{
    class Lis0ProviderWriterDispatch;
}
namespace lis0lisfmwrk
{
    class Lis0ProviderWriterGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LIS0LISFMWRK_API  lis0lisfmwrk::Lis0ProviderWriter
     : public  ::lis0lisfmwrk::Lis0ResourceWriter
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lis0ProviderWriter();

    /**
     * Destructor
     */
    virtual ~Lis0ProviderWriter();

private:
    //  Getter method for the Implementation Object
    Lis0ProviderWriterImpl*  getLis0ProviderWriterImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLis0ProviderWriterImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lis0ProviderWriterImpl*  m_lis0providerwriterImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lis0ProviderWriter - desc for Lis0ProviderWriter parameter
     */
    Lis0ProviderWriter( const Lis0ProviderWriter& );
    Lis0ProviderWriter& operator=( const Lis0ProviderWriter& );

    friend class  Lis0ProviderWriterDelegate;
    friend class  Lis0ProviderWriterDispatch;
    friend class  Lis0ProviderWriterGenImpl;
};

#include <Lis0lisfmwrk/liblis0lisfmwrk_undef.h>
#endif //   LIS0LISFMWRK__LIS0PROVIDERWRITER__HXX
