//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lis0ProviderWriterDelegate
    Filename:   Lis0ProviderWriterDelegate.hxx
    Module:     Lis0lisfmwrk
    @BMIDE autogenerated
==================================================================================================*/

#ifndef LIS0LISFMWRK__LIS0PROVIDERWRITERDELEGATE_HXX
#define LIS0LISFMWRK__LIS0PROVIDERWRITERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Lis0lisfmwrk/Lis0ProviderWriter.hxx>

#include <Lis0lisfmwrk/liblis0lisfmwrk_exports.h>

namespace lis0lisfmwrk
{
    class Lis0ProviderWriterDelegate;
}
namespace lis0lisfmwrk
{
    class Lis0ProviderWriterImpl;
}
namespace lis0lisfmwrk
{
    class Lis0ProviderWriter;
}
namespace lis0lisfmwrk
{
    class Lis0ProviderWriterGenImpl;
}

namespace lis0lisfmwrk_alias = ::lis0lisfmwrk;


class  LIS0LISFMWRK_API lis0lisfmwrk_alias::Lis0ProviderWriterDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Lis0ProviderWriterDelegate instance
    static Lis0ProviderWriterDelegate&  getInstance();

    //  Method to create the Lis0ProviderWriterImpl pointer
    static Lis0ProviderWriterImpl*  createImpl( Lis0ProviderWriter&  ifObj );

    //  Method to delete the Lis0ProviderWriterImpl pointer
    static void deleteImpl( Lis0ProviderWriterImpl*  impl );


    ///
    /// Validate if it is supported to write based on the input resource instance
    /// @version Teamcenter 10.1.4
    /// @param resourceTag - Resource instance
    /// @param canWrite - Flag to indicate if it is supported to write based on the input resource instance
    /// @return - Error code. If successful, return 0.
    ///
    int  lis0IsWritableBase(const Lis0ProviderWriter &ifObj,  tag_t resourceTag, bool *canWrite ) const;



protected:
    //  Pointer to the instance
    static Lis0ProviderWriterDelegate*  m_pInstance;

    Lis0ProviderWriterDelegate();
    virtual ~Lis0ProviderWriterDelegate();
    static void setInstance( Lis0ProviderWriterDelegate*  instance );


private:
    friend class  ::lis0lisfmwrk::Lis0ProviderWriterGenImpl;

};

#include <Lis0lisfmwrk/liblis0lisfmwrk_undef.h>
#endif  //  LIS0LISFMWRK__LIS0PROVIDERWRITERDELEGATE_HXX
