//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lis0RelnSemanticsDynamicLOVDelegate
    Filename:   Lis0RelnSemanticsDynamicLOVDelegate.hxx
    Module:     Lis0lisfmwrk
    @BMIDE autogenerated
==================================================================================================*/

#ifndef LIS0LISFMWRK__LIS0RELNSEMANTICSDYNAMICLOVDELEGATE_HXX
#define LIS0LISFMWRK__LIS0RELNSEMANTICSDYNAMICLOVDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Lis0lisfmwrk/Lis0RelnSemanticsDynamicLOV.hxx>

#include <Lis0lisfmwrk/liblis0lisfmwrk_exports.h>

namespace lis0lisfmwrk
{
    class Lis0RelnSemanticsDynamicLOVDelegate;
}
namespace lis0lisfmwrk
{
    class Lis0RelnSemanticsDynamicLOVImpl;
}
namespace lis0lisfmwrk
{
    class Lis0RelnSemanticsDynamicLOV;
}
namespace lis0lisfmwrk
{
    class Lis0RelnSemanticsDynamicLOVGenImpl;
}

namespace lis0lisfmwrk_alias = ::lis0lisfmwrk;


class  LIS0LISFMWRK_API lis0lisfmwrk_alias::Lis0RelnSemanticsDynamicLOVDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Lis0RelnSemanticsDynamicLOVDelegate instance
    static Lis0RelnSemanticsDynamicLOVDelegate&  getInstance();

    //  Method to create the Lis0RelnSemanticsDynamicLOVImpl pointer
    static Lis0RelnSemanticsDynamicLOVImpl*  createImpl( Lis0RelnSemanticsDynamicLOV&  ifObj );

    //  Method to delete the Lis0RelnSemanticsDynamicLOVImpl pointer
    static void deleteImpl( Lis0RelnSemanticsDynamicLOVImpl*  impl );


    ///
    /// Returns List Of Values based on Dynamic LOV definition and user search criteria.
    /// @version Teamcenter 10
    /// @param operationInputTag - Operation Input containing the modified values.
    /// @param propertyName - Name of the selected property.
    /// @param searchString - User entered search string.
    /// @param sortByProp - Property to use for sorting.
    /// @param sortOrder - order for sorting (0=Ascending, 1=Descending).
    /// @param nResults - Number of returned results.
    /// @param results - Returned Values for LOV.
    /// @return - Zero (0) if everything is alright otherwise the error code.
    ///
    int  fnd0askLOVValuesBase(const Lis0RelnSemanticsDynamicLOV &ifObj,  const tag_t operationInputTag, const std::string *propertyName, const std::string *searchString, const char *sortByProp, const int sortOrder, int *nResults, tag_t **results ) const;


    ///
    /// Returns true if the input value is valid for the Dynamic LOV.
    /// @version Teamcenter 10
    /// @param operationInput - Operation Input containing the modified values.
    /// @param propertyName - Name of the selected property.
    /// @param value - Value to validate.
    /// @param verdict - true if value is valid.
    /// @return - Zero (0) if everything is alright otherwise the error code.
    ///
    int  fnd0isValueValidBase(const Lis0RelnSemanticsDynamicLOV &ifObj,  const tag_t operationInput, const std::string *propertyName, const tag_t value, bool *verdict ) const;



protected:
    //  Pointer to the instance
    static Lis0RelnSemanticsDynamicLOVDelegate*  m_pInstance;

    Lis0RelnSemanticsDynamicLOVDelegate();
    virtual ~Lis0RelnSemanticsDynamicLOVDelegate();
    static void setInstance( Lis0RelnSemanticsDynamicLOVDelegate*  instance );


private:
    friend class  ::lis0lisfmwrk::Lis0RelnSemanticsDynamicLOVGenImpl;

};

#include <Lis0lisfmwrk/liblis0lisfmwrk_undef.h>
#endif  //  LIS0LISFMWRK__LIS0RELNSEMANTICSDYNAMICLOVDELEGATE_HXX
