//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lis0ResourceAttrHelperDelegate
    Filename:   Lis0ResourceAttrHelperDelegate.hxx
    Module:     Lis0lisfmwrk
    @BMIDE autogenerated
==================================================================================================*/

#ifndef LIS0LISFMWRK__LIS0RESOURCEATTRHELPERDELEGATE_HXX
#define LIS0LISFMWRK__LIS0RESOURCEATTRHELPERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Lis0lisfmwrk/Lis0ResourceAttrHelper.hxx>

#include <Lis0lisfmwrk/liblis0lisfmwrk_exports.h>

namespace lis0lisfmwrk
{
    class Lis0ResourceAttrHelperDelegate;
}
namespace lis0lisfmwrk
{
    class Lis0ResourceAttrHelperImpl;
}
namespace lis0lisfmwrk
{
    class Lis0ResourceAttrHelper;
}
namespace lis0lisfmwrk
{
    class Lis0ResourceAttrHelperGenImpl;
}

namespace lis0lisfmwrk_alias = ::lis0lisfmwrk;


class  LIS0LISFMWRK_API lis0lisfmwrk_alias::Lis0ResourceAttrHelperDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Lis0ResourceAttrHelperDelegate instance
    static Lis0ResourceAttrHelperDelegate&  getInstance();

    //  Method to create the Lis0ResourceAttrHelperImpl pointer
    static Lis0ResourceAttrHelperImpl*  createImpl( Lis0ResourceAttrHelper&  ifObj );

    //  Method to delete the Lis0ResourceAttrHelperImpl pointer
    static void deleteImpl( Lis0ResourceAttrHelperImpl*  impl );


    ///
    /// collect the attributes of resource shape
    /// @version Teamcenter 10.1.4
    /// @param objTag - BO object
    /// @param boAttrMap - map holds the BO attributes
    /// @param relationMap - holds the relation attributes of Bo
    /// @param statusMap - hold the status of attributes
    /// @param compoundAttrsMap - holds the compund attributes of Bo
    /// @return - integer
    ///
    int  lis0collectAttributesBase(const Lis0ResourceAttrHelper &ifObj,  tag_t objTag, lis0lisfmwrk::Lis0ResourceShapeAttributes **boAttrMap, lis0lisfmwrk::Lis0ResourceShapeAttributes **relationMap, lis0lisfmwrk::Lis0ResourceShapeAttributes **statusMap, lis0lisfmwrk::Lis0ResourceShapeAttributes **compoundAttrsMap ) const;


    ///
    /// Collects the resource shape attributes
    /// @version Teamcenter 11.2.3
    /// @param catalogIdentifier - Catalog Identifier
    /// @param resourceObjectType - Resource Object Type Tag
    /// @param resourceShapeAttributes - Structure that holds resource shape attributes
    /// @param relationMap - holds the relation attributes of Business object
    /// @return - returns ITK_ok on success, respective error on failure
    ///
    int  lis0collectSemanticAttributesBase(const Lis0ResourceAttrHelper &ifObj,  const std::string &catalogIdentifier, const tag_t &resourceObjectType, lis0lisfmwrk::Lis0ResourceShapeAttributes **resourceShapeAttributes, lis0lisfmwrk::Lis0ResourceShapeAttributes **relationMap ) const;


    ///
    /// true/false return depending on the tag supported or not
    /// @version Teamcenter 10.1.4
    /// @param typeTag - checks the tag is in supported list or not
    /// @param isSupported - check the supported type is in supportes list or not
    /// @return - integer
    ///
    int  lis0isSuppportedTypeBase(const Lis0ResourceAttrHelper &ifObj,  tag_t typeTag, bool *isSupported ) const;


    ///
    /// update
    /// @version Teamcenter 10.1.4
    /// @param objTag - holds the object
    /// @param boAttrMap - BOattributes
    /// @param resourceModel - abstractResourceModel
    /// @return - integer
    ///
    int  lis0updateBOAttributesBase(const Lis0ResourceAttrHelper &ifObj,  tag_t objTag, lis0lisfmwrk::Lis0ResourceShapeAttributes *boAttrMap, lis0lisfmwrk::AbstractResource *resourceModel ) const;


    ///
    /// compoundAttributes
    /// @version Teamcenter 10.1.4
    /// @param objTag - Bo object
    /// @param compoundAttributesMap - holds the compund attributes of BO
    /// @param resourceModel - attribute of BO object
    /// @return - integer
    ///
    int  lis0updateCompundAttributesBase(const Lis0ResourceAttrHelper &ifObj,  tag_t objTag, lis0lisfmwrk::Lis0ResourceShapeAttributes *compoundAttributesMap, lis0lisfmwrk::AbstractResource *resourceModel ) const;


    ///
    /// Relation
    /// @version Teamcenter 10.1.4
    /// @param objTag - BO object
    /// @param relationMap - holds the relation attribute
    /// @param resourceModel - BO Attribute
    /// @return - integer
    ///
    int  lis0updateRelationsBase(const Lis0ResourceAttrHelper &ifObj,  tag_t objTag, lis0lisfmwrk::Lis0ResourceShapeAttributes *relationMap, lis0lisfmwrk::AbstractResource *resourceModel ) const;


    ///
    /// status
    /// @version Teamcenter 10.1.4
    /// @param objTag - BO object
    /// @param statusMap - holds the updated status
    /// @param resourceModel - holds the resource model attribute
    /// @return - integer
    ///
    int  lis0updateStatusBase(const Lis0ResourceAttrHelper &ifObj,  tag_t objTag, lis0lisfmwrk::Lis0ResourceShapeAttributes *statusMap, lis0lisfmwrk::AbstractResource *resourceModel ) const;



protected:
    //  Pointer to the instance
    static Lis0ResourceAttrHelperDelegate*  m_pInstance;

    Lis0ResourceAttrHelperDelegate();
    virtual ~Lis0ResourceAttrHelperDelegate();
    static void setInstance( Lis0ResourceAttrHelperDelegate*  instance );


private:
    friend class  ::lis0lisfmwrk::Lis0ResourceAttrHelperGenImpl;

};

#include <Lis0lisfmwrk/liblis0lisfmwrk_undef.h>
#endif  //  LIS0LISFMWRK__LIS0RESOURCEATTRHELPERDELEGATE_HXX
