//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lis0ResourceDelegate
    Filename:   Lis0ResourceDelegate.hxx
    Module:     Lis0lisfmwrk
    @BMIDE autogenerated
==================================================================================================*/

#ifndef LIS0LISFMWRK__LIS0RESOURCEDELEGATE_HXX
#define LIS0LISFMWRK__LIS0RESOURCEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Lis0lisfmwrk/Lis0Resource.hxx>

#include <Lis0lisfmwrk/liblis0lisfmwrk_exports.h>

namespace lis0lisfmwrk
{
    class Lis0ResourceDelegate;
}
namespace lis0lisfmwrk
{
    class Lis0ResourceImpl;
}
namespace lis0lisfmwrk
{
    class Lis0Resource;
}
namespace lis0lisfmwrk
{
    class Lis0ResourceGenImpl;
}

namespace lis0lisfmwrk_alias = ::lis0lisfmwrk;


class  LIS0LISFMWRK_API lis0lisfmwrk_alias::Lis0ResourceDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Lis0ResourceDelegate instance
    static Lis0ResourceDelegate&  getInstance();

    //  Method to create the Lis0ResourceImpl pointer
    static Lis0ResourceImpl*  createImpl( Lis0Resource&  ifObj );

    //  Method to delete the Lis0ResourceImpl pointer
    static void deleteImpl( Lis0ResourceImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0createReleaseBase(const Lis0Resource &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0descriptionBase(const Lis0Resource &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0nameBase(const Lis0Resource &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0titleBase(const Lis0Resource &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0urlIdBase(const Lis0Resource &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10.1.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLis0createReleaseBase(Lis0Resource &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLis0descriptionBase(Lis0Resource &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLis0nameBase(Lis0Resource &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLis0titleBase(Lis0Resource &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLis0urlIdBase(Lis0Resource &ifObj,  const std::string &value, bool isNull );


    ///
    /// Get the LIs resource obejct based on resource type and url Id
    /// @version Teamcenter 10.1.4
    /// @param resourceType - resource type to find
    /// @param srcUrlId - resource URL id given the input request URL
    /// @param srcObjTag - LIs resource object tag as output argument
    /// @return - it will return failue OR success code
    ///
    int  lis0GetLISObjectBase(const Lis0Resource &ifObj,  const std::string *resourceType, const std::string *srcUrlId, tag_t *srcObjTag ) const;



protected:
    //  Pointer to the instance
    static Lis0ResourceDelegate*  m_pInstance;

    Lis0ResourceDelegate();
    virtual ~Lis0ResourceDelegate();
    static void setInstance( Lis0ResourceDelegate*  instance );


private:
    friend class  ::lis0lisfmwrk::Lis0ResourceGenImpl;

};

#include <Lis0lisfmwrk/liblis0lisfmwrk_undef.h>
#endif  //  LIS0LISFMWRK__LIS0RESOURCEDELEGATE_HXX
