//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lis0ResourceShapeWriter
    Filename:   Lis0ResourceShapeWriter.hxx
    Module:     Lis0lisfmwrk
    @BMIDE autogenerated
==================================================================================================*/

#ifndef LIS0LISFMWRK__LIS0RESOURCESHAPEWRITER__HXX
#define LIS0LISFMWRK__LIS0RESOURCESHAPEWRITER__HXX

#include <common/tc_deprecation_macros.h>
#include <Lis0lisfmwrk/Lis0ResourceWriter.hxx>

#include <Lis0lisfmwrk/liblis0lisfmwrk_exports.h>

namespace lis0lisfmwrk
{
    class Lis0ResourceShapeWriter;
}
namespace lis0lisfmwrk
{
    class Lis0ResourceShapeWriterImpl;
}
namespace lis0lisfmwrk
{
    class Lis0ResourceShapeWriterDelegate;
}
namespace lis0lisfmwrk
{
    class Lis0ResourceShapeWriterDispatch;
}
namespace lis0lisfmwrk
{
    class Lis0ResourceShapeWriterGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LIS0LISFMWRK_API  lis0lisfmwrk::Lis0ResourceShapeWriter
     : public  ::lis0lisfmwrk::Lis0ResourceWriter
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lis0ResourceShapeWriter();

    /**
     * Destructor
     */
    virtual ~Lis0ResourceShapeWriter();

private:
    //  Getter method for the Implementation Object
    Lis0ResourceShapeWriterImpl*  getLis0ResourceShapeWriterImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLis0ResourceShapeWriterImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lis0ResourceShapeWriterImpl*  m_lis0resourceshapewriterImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lis0ResourceShapeWriter - desc for Lis0ResourceShapeWriter parameter
     */
    Lis0ResourceShapeWriter( const Lis0ResourceShapeWriter& );
    Lis0ResourceShapeWriter& operator=( const Lis0ResourceShapeWriter& );

    friend class  Lis0ResourceShapeWriterDelegate;
    friend class  Lis0ResourceShapeWriterDispatch;
    friend class  Lis0ResourceShapeWriterGenImpl;
};

#include <Lis0lisfmwrk/liblis0lisfmwrk_undef.h>
#endif //   LIS0LISFMWRK__LIS0RESOURCESHAPEWRITER__HXX
