//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lis0ResourceShapeWriterDelegate
    Filename:   Lis0ResourceShapeWriterDelegate.hxx
    Module:     Lis0lisfmwrk
    @BMIDE autogenerated
==================================================================================================*/

#ifndef LIS0LISFMWRK__LIS0RESOURCESHAPEWRITERDELEGATE_HXX
#define LIS0LISFMWRK__LIS0RESOURCESHAPEWRITERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Lis0lisfmwrk/Lis0ResourceShapeWriter.hxx>

#include <Lis0lisfmwrk/liblis0lisfmwrk_exports.h>

namespace lis0lisfmwrk
{
    class Lis0ResourceShapeWriterDelegate;
}
namespace lis0lisfmwrk
{
    class Lis0ResourceShapeWriterImpl;
}
namespace lis0lisfmwrk
{
    class Lis0ResourceShapeWriter;
}
namespace lis0lisfmwrk
{
    class Lis0ResourceShapeWriterGenImpl;
}

namespace lis0lisfmwrk_alias = ::lis0lisfmwrk;


class  LIS0LISFMWRK_API lis0lisfmwrk_alias::Lis0ResourceShapeWriterDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Lis0ResourceShapeWriterDelegate instance
    static Lis0ResourceShapeWriterDelegate&  getInstance();

    //  Method to create the Lis0ResourceShapeWriterImpl pointer
    static Lis0ResourceShapeWriterImpl*  createImpl( Lis0ResourceShapeWriter&  ifObj );

    //  Method to delete the Lis0ResourceShapeWriterImpl pointer
    static void deleteImpl( Lis0ResourceShapeWriterImpl*  impl );


    ///
    /// Validate if it is supported to write based on the input resource instance
    /// @version Teamcenter 10.1.4
    /// @param resourceTag - Resource instance
    /// @param canWrite - Flag to indicate if it is supported to write based on the input resource instance
    /// @return - Error code. If successful, return 0.
    ///
    int  lis0IsWritableBase(const Lis0ResourceShapeWriter &ifObj,  tag_t resourceTag, bool *canWrite ) const;



protected:
    //  Pointer to the instance
    static Lis0ResourceShapeWriterDelegate*  m_pInstance;

    Lis0ResourceShapeWriterDelegate();
    virtual ~Lis0ResourceShapeWriterDelegate();
    static void setInstance( Lis0ResourceShapeWriterDelegate*  instance );


private:
    friend class  ::lis0lisfmwrk::Lis0ResourceShapeWriterGenImpl;

};

#include <Lis0lisfmwrk/liblis0lisfmwrk_undef.h>
#endif  //  LIS0LISFMWRK__LIS0RESOURCESHAPEWRITERDELEGATE_HXX
