//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lis0Service
    Filename:   Lis0Service.hxx
    Module:     Lis0lisfmwrk
    @BMIDE autogenerated
==================================================================================================*/

#ifndef LIS0LISFMWRK__LIS0SERVICE__HXX
#define LIS0LISFMWRK__LIS0SERVICE__HXX

#include <string>
#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <Lis0lisfmwrk/Lis0Resource.hxx>

#include <Lis0lisfmwrk/liblis0lisfmwrk_exports.h>

namespace lis0lisfmwrk
{
    class Lis0Service;
}
namespace lis0lisfmwrk
{
    class Lis0ServiceImpl;
}
namespace lis0lisfmwrk
{
    class Lis0ServiceDelegate;
}
namespace lis0lisfmwrk
{
    class Lis0ServiceDispatch;
}
namespace lis0lisfmwrk
{
    class Lis0ServiceGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LIS0LISFMWRK_API  lis0lisfmwrk::Lis0Service
     : public  ::lis0lisfmwrk::Lis0Resource
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0opName( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0provider( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0resourceType( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0serviceType( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0specVersion( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLis0opName( const std::string &value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10.1.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLis0provider( const tag_t &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLis0resourceType( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLis0serviceType( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLis0specVersion( const std::string &value, bool isNull=false );

    ///
    /// This opertaion gets the LIS resource object details
    /// @version Teamcenter 10.1.4
    /// @return - It will return success OR failure code
    ///
    int  lis0GetLISDescription(  );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lis0Service();

    /**
     * Destructor
     */
    virtual ~Lis0Service();

private:
    //  Getter method for the Implementation Object
    Lis0ServiceImpl*  getLis0ServiceImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLis0ServiceImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lis0ServiceImpl*  m_lis0serviceImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lis0Service - desc for Lis0Service parameter
     */
    Lis0Service( const Lis0Service& );
    Lis0Service& operator=( const Lis0Service& );

    friend class  Lis0ServiceDelegate;
    friend class  Lis0ServiceDispatch;
    friend class  Lis0ServiceGenImpl;
};

#include <Lis0lisfmwrk/liblis0lisfmwrk_undef.h>
#endif //   LIS0LISFMWRK__LIS0SERVICE__HXX
