//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lis0ServiceDialog
    Filename:   Lis0ServiceDialog.hxx
    Module:     Lis0lisfmwrk
    @BMIDE autogenerated
==================================================================================================*/

#ifndef LIS0LISFMWRK__LIS0SERVICEDIALOG__HXX
#define LIS0LISFMWRK__LIS0SERVICEDIALOG__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <Lis0lisfmwrk/Lis0Service.hxx>

#include <Lis0lisfmwrk/liblis0lisfmwrk_exports.h>

namespace lis0lisfmwrk
{
    class Lis0ServiceDialog;
}
namespace lis0lisfmwrk
{
    class Lis0ServiceDialogImpl;
}
namespace lis0lisfmwrk
{
    class Lis0ServiceDialogDelegate;
}
namespace lis0lisfmwrk
{
    class Lis0ServiceDialogDispatch;
}
namespace lis0lisfmwrk
{
    class Lis0ServiceDialogGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LIS0LISFMWRK_API  lis0lisfmwrk::Lis0ServiceDialog
     : public  ::lis0lisfmwrk::Lis0Service
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0dialogURI( std::string &value, bool &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1.4
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0hintHeight( int &value, bool &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1.4
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0hintWidth( int &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLis0dialogURI( const std::string &value, bool isNull=false );

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 10.1.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLis0hintHeight( int value, bool isNull=false );

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 10.1.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLis0hintWidth( int value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lis0ServiceDialog();

    /**
     * Destructor
     */
    virtual ~Lis0ServiceDialog();

private:
    //  Getter method for the Implementation Object
    Lis0ServiceDialogImpl*  getLis0ServiceDialogImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLis0ServiceDialogImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lis0ServiceDialogImpl*  m_lis0servicedialogImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lis0ServiceDialog - desc for Lis0ServiceDialog parameter
     */
    Lis0ServiceDialog( const Lis0ServiceDialog& );
    Lis0ServiceDialog& operator=( const Lis0ServiceDialog& );

    friend class  Lis0ServiceDialogDelegate;
    friend class  Lis0ServiceDialogDispatch;
    friend class  Lis0ServiceDialogGenImpl;
};

#include <Lis0lisfmwrk/liblis0lisfmwrk_undef.h>
#endif //   LIS0LISFMWRK__LIS0SERVICEDIALOG__HXX
