//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lis0ServiceDialogDelegate
    Filename:   Lis0ServiceDialogDelegate.hxx
    Module:     Lis0lisfmwrk
    @BMIDE autogenerated
==================================================================================================*/

#ifndef LIS0LISFMWRK__LIS0SERVICEDIALOGDELEGATE_HXX
#define LIS0LISFMWRK__LIS0SERVICEDIALOGDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Lis0lisfmwrk/Lis0ServiceDialog.hxx>

#include <Lis0lisfmwrk/liblis0lisfmwrk_exports.h>

namespace lis0lisfmwrk
{
    class Lis0ServiceDialogDelegate;
}
namespace lis0lisfmwrk
{
    class Lis0ServiceDialogImpl;
}
namespace lis0lisfmwrk
{
    class Lis0ServiceDialog;
}
namespace lis0lisfmwrk
{
    class Lis0ServiceDialogGenImpl;
}

namespace lis0lisfmwrk_alias = ::lis0lisfmwrk;


class  LIS0LISFMWRK_API lis0lisfmwrk_alias::Lis0ServiceDialogDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Lis0ServiceDialogDelegate instance
    static Lis0ServiceDialogDelegate&  getInstance();

    //  Method to create the Lis0ServiceDialogImpl pointer
    static Lis0ServiceDialogImpl*  createImpl( Lis0ServiceDialog&  ifObj );

    //  Method to delete the Lis0ServiceDialogImpl pointer
    static void deleteImpl( Lis0ServiceDialogImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0dialogURIBase(const Lis0ServiceDialog &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1.4
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0hintHeightBase(const Lis0ServiceDialog &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1.4
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0hintWidthBase(const Lis0ServiceDialog &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLis0dialogURIBase(Lis0ServiceDialog &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 10.1.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLis0hintHeightBase(Lis0ServiceDialog &ifObj,  int value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 10.1.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLis0hintWidthBase(Lis0ServiceDialog &ifObj,  int value, bool isNull );



protected:
    //  Pointer to the instance
    static Lis0ServiceDialogDelegate*  m_pInstance;

    Lis0ServiceDialogDelegate();
    virtual ~Lis0ServiceDialogDelegate();
    static void setInstance( Lis0ServiceDialogDelegate*  instance );


private:
    friend class  ::lis0lisfmwrk::Lis0ServiceDialogGenImpl;

};

#include <Lis0lisfmwrk/liblis0lisfmwrk_undef.h>
#endif  //  LIS0LISFMWRK__LIS0SERVICEDIALOGDELEGATE_HXX
