//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lis0ServiceFactory
    Filename:   Lis0ServiceFactory.hxx
    Module:     Lis0lisfmwrk
    @BMIDE autogenerated
==================================================================================================*/

#ifndef LIS0LISFMWRK__LIS0SERVICEFACTORY__HXX
#define LIS0LISFMWRK__LIS0SERVICEFACTORY__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <Lis0lisfmwrk/Lis0Service.hxx>

#include <Lis0lisfmwrk/liblis0lisfmwrk_exports.h>

namespace lis0lisfmwrk
{
    class Lis0ServiceFactory;
}
namespace lis0lisfmwrk
{
    class Lis0ServiceFactoryImpl;
}
namespace lis0lisfmwrk
{
    class Lis0ServiceFactoryDelegate;
}
namespace lis0lisfmwrk
{
    class Lis0ServiceFactoryDispatch;
}
namespace lis0lisfmwrk
{
    class Lis0ServiceFactoryGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LIS0LISFMWRK_API  lis0lisfmwrk::Lis0ServiceFactory
     : public  ::lis0lisfmwrk::Lis0Service
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0factoryURI( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0resourceShape( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLis0factoryURI( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLis0resourceShape( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lis0ServiceFactory();

    /**
     * Destructor
     */
    virtual ~Lis0ServiceFactory();

private:
    //  Getter method for the Implementation Object
    Lis0ServiceFactoryImpl*  getLis0ServiceFactoryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLis0ServiceFactoryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lis0ServiceFactoryImpl*  m_lis0servicefactoryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lis0ServiceFactory - desc for Lis0ServiceFactory parameter
     */
    Lis0ServiceFactory( const Lis0ServiceFactory& );
    Lis0ServiceFactory& operator=( const Lis0ServiceFactory& );

    friend class  Lis0ServiceFactoryDelegate;
    friend class  Lis0ServiceFactoryDispatch;
    friend class  Lis0ServiceFactoryGenImpl;
};

#include <Lis0lisfmwrk/liblis0lisfmwrk_undef.h>
#endif //   LIS0LISFMWRK__LIS0SERVICEFACTORY__HXX
