//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lis0ServiceFactoryDelegate
    Filename:   Lis0ServiceFactoryDelegate.hxx
    Module:     Lis0lisfmwrk
    @BMIDE autogenerated
==================================================================================================*/

#ifndef LIS0LISFMWRK__LIS0SERVICEFACTORYDELEGATE_HXX
#define LIS0LISFMWRK__LIS0SERVICEFACTORYDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Lis0lisfmwrk/Lis0ServiceFactory.hxx>

#include <Lis0lisfmwrk/liblis0lisfmwrk_exports.h>

namespace lis0lisfmwrk
{
    class Lis0ServiceFactoryDelegate;
}
namespace lis0lisfmwrk
{
    class Lis0ServiceFactoryImpl;
}
namespace lis0lisfmwrk
{
    class Lis0ServiceFactory;
}
namespace lis0lisfmwrk
{
    class Lis0ServiceFactoryGenImpl;
}

namespace lis0lisfmwrk_alias = ::lis0lisfmwrk;


class  LIS0LISFMWRK_API lis0lisfmwrk_alias::Lis0ServiceFactoryDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Lis0ServiceFactoryDelegate instance
    static Lis0ServiceFactoryDelegate&  getInstance();

    //  Method to create the Lis0ServiceFactoryImpl pointer
    static Lis0ServiceFactoryImpl*  createImpl( Lis0ServiceFactory&  ifObj );

    //  Method to delete the Lis0ServiceFactoryImpl pointer
    static void deleteImpl( Lis0ServiceFactoryImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0factoryURIBase(const Lis0ServiceFactory &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0resourceShapeBase(const Lis0ServiceFactory &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLis0factoryURIBase(Lis0ServiceFactory &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLis0resourceShapeBase(Lis0ServiceFactory &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static Lis0ServiceFactoryDelegate*  m_pInstance;

    Lis0ServiceFactoryDelegate();
    virtual ~Lis0ServiceFactoryDelegate();
    static void setInstance( Lis0ServiceFactoryDelegate*  instance );


private:
    friend class  ::lis0lisfmwrk::Lis0ServiceFactoryGenImpl;

};

#include <Lis0lisfmwrk/liblis0lisfmwrk_undef.h>
#endif  //  LIS0LISFMWRK__LIS0SERVICEFACTORYDELEGATE_HXX
