//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lis0ServiceProvider
    Filename:   Lis0ServiceProvider.hxx
    Module:     Lis0lisfmwrk
    @BMIDE autogenerated
==================================================================================================*/

#ifndef LIS0LISFMWRK__LIS0SERVICEPROVIDER__HXX
#define LIS0LISFMWRK__LIS0SERVICEPROVIDER__HXX

#include <string>
#include <Lis0lisfmwrk/Lis0ServiceDef.hxx>
#include <Lis0lisfmwrk/LisfmwrkUtils.hxx>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <Lis0lisfmwrk/liblis0lisfmwrk_exports.h>

namespace lis0lisfmwrk
{
    class Lis0ServiceProvider;
}
namespace lis0lisfmwrk
{
    class Lis0ServiceProviderImpl;
}
namespace lis0lisfmwrk
{
    class Lis0ServiceProviderDelegate;
}
namespace lis0lisfmwrk
{
    class Lis0ServiceProviderDispatch;
}
namespace lis0lisfmwrk
{
    class Lis0ServiceProviderGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LIS0LISFMWRK_API  lis0lisfmwrk::Lis0ServiceProvider
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0accessibility( int &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLis0url( const std::string &value, bool isNull=false );

    ///
    /// Get all provider service list
    /// @version Teamcenter 10.1.2
    /// @param providerURL - URL to indicate the service provider
    /// @param responseInfo - Output of the parse http response
    /// @return - Return the status as Integer
    ///
    int  lis0getProviderServices( const std::string *providerURL, ServiceResponseInfo *responseInfo );

    ///
    /// 
    /// @version Teamcenter 11.3
    /// @param providerURL - URL to indicate the service provider
    /// @param responseInfo - Output of the parse http response
    /// @return - 
    ///
    int  lis0getProviderServices( const std::string *providerURL, ServiceResponseInfoExtend *responseInfo );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lis0ServiceProvider();

    /**
     * Destructor
     */
    virtual ~Lis0ServiceProvider();

private:
    //  Getter method for the Implementation Object
    Lis0ServiceProviderImpl*  getLis0ServiceProviderImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLis0ServiceProviderImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lis0ServiceProviderImpl*  m_lis0serviceproviderImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lis0ServiceProvider - desc for Lis0ServiceProvider parameter
     */
    Lis0ServiceProvider( const Lis0ServiceProvider& );
    Lis0ServiceProvider& operator=( const Lis0ServiceProvider& );

    friend class  Lis0ServiceProviderDelegate;
    friend class  Lis0ServiceProviderDispatch;
    friend class  Lis0ServiceProviderGenImpl;
};

#include <Lis0lisfmwrk/liblis0lisfmwrk_undef.h>
#endif //   LIS0LISFMWRK__LIS0SERVICEPROVIDER__HXX
