//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lis0ServiceProviderDelegate
    Filename:   Lis0ServiceProviderDelegate.hxx
    Module:     Lis0lisfmwrk
    @BMIDE autogenerated
==================================================================================================*/

#ifndef LIS0LISFMWRK__LIS0SERVICEPROVIDERDELEGATE_HXX
#define LIS0LISFMWRK__LIS0SERVICEPROVIDERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Lis0lisfmwrk/Lis0ServiceProvider.hxx>

#include <Lis0lisfmwrk/liblis0lisfmwrk_exports.h>

namespace lis0lisfmwrk
{
    class Lis0ServiceProviderDelegate;
}
namespace lis0lisfmwrk
{
    class Lis0ServiceProviderImpl;
}
namespace lis0lisfmwrk
{
    class Lis0ServiceProvider;
}
namespace lis0lisfmwrk
{
    class Lis0ServiceProviderGenImpl;
}

namespace lis0lisfmwrk_alias = ::lis0lisfmwrk;


class  LIS0LISFMWRK_API lis0lisfmwrk_alias::Lis0ServiceProviderDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Lis0ServiceProviderDelegate instance
    static Lis0ServiceProviderDelegate&  getInstance();

    //  Method to create the Lis0ServiceProviderImpl pointer
    static Lis0ServiceProviderImpl*  createImpl( Lis0ServiceProvider&  ifObj );

    //  Method to delete the Lis0ServiceProviderImpl pointer
    static void deleteImpl( Lis0ServiceProviderImpl*  impl );


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0accessibilityBase(const Lis0ServiceProvider &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLis0urlBase(Lis0ServiceProvider &ifObj,  const std::string &value, bool isNull );


    ///
    /// Get all provider service list
    /// @version Teamcenter 10.1.2
    /// @param providerURL - URL to indicate the service provider
    /// @param responseInfo - Output of the parse http response
    /// @return - Return the status as Integer
    ///
    int  lis0getProviderServicesBase(const Lis0ServiceProvider &ifObj,  const std::string *providerURL, ServiceResponseInfo *responseInfo );


    ///
    /// 
    /// @version Teamcenter 11.3
    /// @param providerURL - URL to indicate the service provider
    /// @param responseInfo - Output of the parse http response
    /// @return - 
    ///
    int  lis0getProviderServicesBase(const Lis0ServiceProvider &ifObj,  const std::string *providerURL, ServiceResponseInfoExtend *responseInfo );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Lis0ServiceProvider &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Lis0ServiceProviderDelegate*  m_pInstance;

    Lis0ServiceProviderDelegate();
    virtual ~Lis0ServiceProviderDelegate();
    static void setInstance( Lis0ServiceProviderDelegate*  instance );


private:
    friend class  ::lis0lisfmwrk::Lis0ServiceProviderGenImpl;

};

#include <Lis0lisfmwrk/liblis0lisfmwrk_undef.h>
#endif  //  LIS0LISFMWRK__LIS0SERVICEPROVIDERDELEGATE_HXX
