//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lis0Site
    Filename:   Lis0Site.hxx
    Module:     Lis0lisfmwrk
    @BMIDE autogenerated
==================================================================================================*/

#ifndef LIS0LISFMWRK__LIS0SITE__HXX
#define LIS0LISFMWRK__LIS0SITE__HXX

#include <Lis0lisfmwrk/Lis0ServiceDef.hxx>
#include <vector>
#include <unidefs.h>
#include <Lis0lisfmwrk/LisfmwrkUtils.hxx>
#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <Lis0lisfmwrk/liblis0lisfmwrk_exports.h>

namespace lis0lisfmwrk
{
    class Lis0Site;
}
namespace lis0lisfmwrk
{
    class Lis0SiteImpl;
}
namespace lis0lisfmwrk
{
    class Lis0SiteDelegate;
}
namespace lis0lisfmwrk
{
    class Lis0SiteDispatch;
}
namespace lis0lisfmwrk
{
    class Lis0SiteGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LIS0LISFMWRK_API  lis0lisfmwrk::Lis0Site
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0accessibility( int &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0associatedProviders( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0availableProviders( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLis0url( const std::string &value, bool isNull=false );

    ///
    /// Get all remote service provider list
    /// @version Teamcenter 10.1.2
    /// @param catalogInfo - Service provider catalog infomation
    /// @param providers - Remote service provider vector
    /// @return - Return the status as Integer
    ///
    int  lis0getRemoteServiceProviders( const ServiceProviderCatalogInfo *catalogInfo, std::vector< tag_t > *providers );

    ///
    /// 
    /// @version Teamcenter 11.3
    /// @param catalogInfo - Output of catalog from rootservices
    /// @param providers - list of provider from catalog
    /// @return - 
    ///
    int  lis0getRemoteServiceProviders( ServiceProviderCatalogInfoExtend *catalogInfo, std::vector< tag_t > *providers );

    ///
    /// Get all service provider catalog list
    /// @version Teamcenter 10.1.2
    /// @param rootServiceURL - URL to indicate the root service
    /// @param responseInfo - Output of the parse http response
    /// @return - Return the status as Integer
    ///
    int  lis0getServiceProviderCatalogs( const std::string *rootServiceURL, RootServiceResponseInfo *responseInfo );

    ///
    /// 
    /// @version Teamcenter 11.3
    /// @param rootServiceURL - rootServiceURL
    /// @param responseInfo - response of root services request
    /// @return - 
    ///
    int  lis0getServiceProviderCatalogs( std::string *rootServiceURL, RootServiceResponseExtend *responseInfo );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lis0Site();

    /**
     * Destructor
     */
    virtual ~Lis0Site();

private:
    //  Getter method for the Implementation Object
    Lis0SiteImpl*  getLis0SiteImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLis0SiteImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lis0SiteImpl*  m_lis0siteImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lis0Site - desc for Lis0Site parameter
     */
    Lis0Site( const Lis0Site& );
    Lis0Site& operator=( const Lis0Site& );

    friend class  Lis0SiteDelegate;
    friend class  Lis0SiteDispatch;
    friend class  Lis0SiteGenImpl;
};

#include <Lis0lisfmwrk/liblis0lisfmwrk_undef.h>
#endif //   LIS0LISFMWRK__LIS0SITE__HXX
