//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lis0SiteDelegate
    Filename:   Lis0SiteDelegate.hxx
    Module:     Lis0lisfmwrk
    @BMIDE autogenerated
==================================================================================================*/

#ifndef LIS0LISFMWRK__LIS0SITEDELEGATE_HXX
#define LIS0LISFMWRK__LIS0SITEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Lis0lisfmwrk/Lis0Site.hxx>

#include <Lis0lisfmwrk/liblis0lisfmwrk_exports.h>

namespace lis0lisfmwrk
{
    class Lis0SiteDelegate;
}
namespace lis0lisfmwrk
{
    class Lis0SiteImpl;
}
namespace lis0lisfmwrk
{
    class Lis0Site;
}
namespace lis0lisfmwrk
{
    class Lis0SiteGenImpl;
}

namespace lis0lisfmwrk_alias = ::lis0lisfmwrk;


class  LIS0LISFMWRK_API lis0lisfmwrk_alias::Lis0SiteDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Lis0SiteDelegate instance
    static Lis0SiteDelegate&  getInstance();

    //  Method to create the Lis0SiteImpl pointer
    static Lis0SiteImpl*  createImpl( Lis0Site&  ifObj );

    //  Method to delete the Lis0SiteImpl pointer
    static void deleteImpl( Lis0SiteImpl*  impl );


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0accessibilityBase(const Lis0Site &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0associatedProvidersBase(const Lis0Site &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0availableProvidersBase(const Lis0Site &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLis0urlBase(Lis0Site &ifObj,  const std::string &value, bool isNull );


    ///
    /// Get all remote service provider list
    /// @version Teamcenter 10.1.2
    /// @param catalogInfo - Service provider catalog infomation
    /// @param providers - Remote service provider vector
    /// @return - Return the status as Integer
    ///
    int  lis0getRemoteServiceProvidersBase(const Lis0Site &ifObj,  const ServiceProviderCatalogInfo *catalogInfo, std::vector< tag_t > *providers );


    ///
    /// 
    /// @version Teamcenter 11.3
    /// @param catalogInfo - Output of catalog from rootservices
    /// @param providers - list of provider from catalog
    /// @return - 
    ///
    int  lis0getRemoteServiceProvidersBase(const Lis0Site &ifObj,  ServiceProviderCatalogInfoExtend *catalogInfo, std::vector< tag_t > *providers );


    ///
    /// Get all service provider catalog list
    /// @version Teamcenter 10.1.2
    /// @param rootServiceURL - URL to indicate the root service
    /// @param responseInfo - Output of the parse http response
    /// @return - Return the status as Integer
    ///
    int  lis0getServiceProviderCatalogsBase(const Lis0Site &ifObj,  const std::string *rootServiceURL, RootServiceResponseInfo *responseInfo );


    ///
    /// 
    /// @version Teamcenter 11.3
    /// @param rootServiceURL - rootServiceURL
    /// @param responseInfo - response of root services request
    /// @return - 
    ///
    int  lis0getServiceProviderCatalogsBase(const Lis0Site &ifObj,  std::string *rootServiceURL, RootServiceResponseExtend *responseInfo );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Lis0Site &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Lis0Site &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Lis0SiteDelegate*  m_pInstance;

    Lis0SiteDelegate();
    virtual ~Lis0SiteDelegate();
    static void setInstance( Lis0SiteDelegate*  instance );


private:
    friend class  ::lis0lisfmwrk::Lis0SiteGenImpl;

};

#include <Lis0lisfmwrk/liblis0lisfmwrk_undef.h>
#endif  //  LIS0LISFMWRK__LIS0SITEDELEGATE_HXX
