//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Lis0TcProvider
    Filename:   Lis0TcProvider.hxx
    Module:     Lis0lisfmwrk
    @BMIDE autogenerated
==================================================================================================*/

#ifndef LIS0LISFMWRK__LIS0TCPROVIDER__HXX
#define LIS0LISFMWRK__LIS0TCPROVIDER__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <Lis0lisfmwrk/Lis0Resource.hxx>

#include <Lis0lisfmwrk/liblis0lisfmwrk_exports.h>

namespace lis0lisfmwrk
{
    class Lis0TcProvider;
}
namespace lis0lisfmwrk
{
    class Lis0TcProviderImpl;
}
namespace lis0lisfmwrk
{
    class Lis0TcProviderDelegate;
}
namespace lis0lisfmwrk
{
    class Lis0TcProviderDispatch;
}
namespace lis0lisfmwrk
{
    class Lis0TcProviderGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LIS0LISFMWRK_API  lis0lisfmwrk::Lis0TcProvider
     : public  ::lis0lisfmwrk::Lis0Resource
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLis0catalog( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10.1.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLis0catalog( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Lis0TcProvider();

    /**
     * Destructor
     */
    virtual ~Lis0TcProvider();

private:
    //  Getter method for the Implementation Object
    Lis0TcProviderImpl*  getLis0TcProviderImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLis0TcProviderImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Lis0TcProviderImpl*  m_lis0tcproviderImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Lis0TcProvider - desc for Lis0TcProvider parameter
     */
    Lis0TcProvider( const Lis0TcProvider& );
    Lis0TcProvider& operator=( const Lis0TcProvider& );

    friend class  Lis0TcProviderDelegate;
    friend class  Lis0TcProviderDispatch;
    friend class  Lis0TcProviderGenImpl;
};

#include <Lis0lisfmwrk/liblis0lisfmwrk_undef.h>
#endif //   LIS0LISFMWRK__LIS0TCPROVIDER__HXX
