/*
    Copyright 2020 Siemens Digital Industries Software
    ==================================================
    Copyright 2014.
    Siemens Product Lifecycle Management Software Inc.
    All Rights Reserved.
    ==================================================
    Copyright 2020 Siemens Digital Industries Software
*/

/**
    @file

    This file implements Lifecycle Interoperability Services Framework (LIS0LISFMWRK) services extended resource.

*/

#ifndef LIS0LISFMWRK_IRESOURCE_HXX
#define LIS0LISFMWRK_IRESOURCE_HXX

#include <string>

#include <Lis0lisfmwrk/libLis0lisfmwrk_exports.h>

/**
    @defgroup LIS0LISFMWRK Lifecycle Interoperability Services Framework IResource class
    @ingroup TC 

    This class provides interface to IExtendedResource and AbstractResource. 
    @{
*/

namespace lis0lisfmwrk
{
    class IResource;
}

class LIS0LISFMWRK_API lis0lisfmwrk::IResource
{
public:

    /** Constructor */
    IResource();

    /** Destructor */
    virtual ~IResource();
     
    /**
    * Sets rdf:about value
    * @param [in] about About string to be set on the resource
    * @returns void
    */
    virtual void setAbout( const std::string& about ) = 0;

    /**
    * Retrieves the rdf:about value set on the resource.
    * @returns The rdf::string set on the resource
    */
    virtual std::string getAbout() = 0;

private:

};

/** @} */

#include <Lis0lisfmwrk/libLis0lisfmwrk_undef.h>
#endif
