//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  Lrm0lisrm

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libLrm0lisrm

#if !defined(LIBLRM0LISRM) && !defined(IPLIB)
#   error IPLIB or LIBLRM0LISRM is not defined
#endif

/* Handwritten code should use LRM0LISRM_API, not LRM0LISRMEXPORT */

#define LRM0LISRM_API LRM0LISRMEXPORT

#if IPLIB==libLrm0lisrm || defined(LIBLRM0LISRM)
#   if defined(__lint)
#       define LRM0LISRMEXPORT       __export(Lrm0lisrm)
#       define LRM0LISRMGLOBAL       extern __global(Lrm0lisrm)
#       define LRM0LISRMPRIVATE      extern __private(Lrm0lisrm)
#   elif defined(_WIN32)
#       define LRM0LISRMEXPORT       __declspec(dllexport)
#       define LRM0LISRMGLOBAL       extern __declspec(dllexport)
#       define LRM0LISRMPRIVATE      extern
#   else
#       define LRM0LISRMEXPORT
#       define LRM0LISRMGLOBAL       extern
#       define LRM0LISRMPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define LRM0LISRMEXPORT       __export(Lrm0lisrm)
#       define LRM0LISRMGLOBAL       extern __global(Lrm0lisrm)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define LRM0LISRMEXPORT      __declspec(dllimport)
#       define LRM0LISRMGLOBAL       extern __declspec(dllimport)
#   else
#       define LRM0LISRMEXPORT
#       define LRM0LISRMGLOBAL       extern
#   endif
#endif
