//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, GDELine
    Filename:   GDELineExt.hxx
    Module:     Mci0mfgcharacteristicsbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef MCI0__MCI0MFGCHARACTERISTICS__GDELINE__HXX
#define MCI0__MCI0MFGCHARACTERISTICS__GDELINE__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <metaframework/BusinessObjectExtender.hxx>
#include <metaframework/BusinessObjectExtenderRef.hxx>
#include <metaframework/BusinessObjectExtenderRegistry.hxx>

#include <Mci0mfgcharacteristicsbvr/libmci0mfgcharacteristicsbvr_exports.h>

namespace mci0
{
    namespace mci0mfgcharacteristics
    {
        class GDELine;
    }
}
namespace mci0
{
    namespace mci0mfgcharacteristics
    {
        class GDELineImpl;
    }
}
namespace mci0
{
    namespace mci0mfgcharacteristics
    {
        class GDELineDelegate;
    }
}
namespace mci0
{
    namespace mci0mfgcharacteristics
    {
        class GDELineDispatch;
    }
}
namespace mci0
{
    namespace mci0mfgcharacteristics
    {
        class GDELineGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MCI0MFGCHARACTERISTICSBVR_API  mci0::mci0mfgcharacteristics::GDELine
     : public  ::Teamcenter::BusinessObjectExtender
{
public:

    /**
     * Constructor
     */
    GDELine( tag_t  objTag );
    /**
     * Get the Extender Registry
     * @return - return Extender Registry
     */
    static ::Teamcenter::BusinessObjectExtenderRegistry< mci0::mci0mfgcharacteristics::GDELine >&  extenderRegistry();

    /**
     * Get the Extender Interface Name
     * @return - return desc for getExtenderInterfaceName
     */
    static const std::string&  getExtenderInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMci0KeyCharacteristics( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMci0KeyCharacteristics( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );


    /**
     * Destructor
     */
    virtual ~GDELine();

private:
    //  Getter method for the Implementation Object
    GDELineImpl*  getGDELineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setGDELineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    GDELineImpl*  m_gdelineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param GDELine - desc for GDELine parameter
     */
    GDELine( const GDELine& );
    GDELine& operator=( const GDELine& );

    friend class  GDELineDelegate;
    friend class  GDELineDispatch;
    friend class  GDELineGenImpl;
};

#include <Mci0mfgcharacteristicsbvr/libmci0mfgcharacteristicsbvr_undef.h>
#endif //   MCI0__MCI0MFGCHARACTERISTICS__GDELINE__HXX
