//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mci0BvrBopPMI
    Filename:   Mci0BvrBopPMI.hxx
    Module:     Mci0mfgcharacteristicsbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef MCI0MFGCHARACTERISTICS__MCI0BVRBOPPMI__HXX
#define MCI0MFGCHARACTERISTICS__MCI0BVRBOPPMI__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <me/GDEBOPLine.hxx>

#include <Mci0mfgcharacteristicsbvr/libmci0mfgcharacteristicsbvr_exports.h>

namespace mci0mfgcharacteristics
{
    class Mci0BvrBopPMI;
}
namespace mci0mfgcharacteristics
{
    class Mci0BvrBopPMIImpl;
}
namespace mci0mfgcharacteristics
{
    class Mci0BvrBopPMIDelegate;
}
namespace mci0mfgcharacteristics
{
    class Mci0BvrBopPMIDispatch;
}
namespace mci0mfgcharacteristics
{
    class Mci0BvrBopPMIGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MCI0MFGCHARACTERISTICSBVR_API  mci0mfgcharacteristics::Mci0BvrBopPMI
     : public  ::Teamcenter::GDEBOPLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMci0Criticality( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMci0Frequency( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMci0InspectionProcedure( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMci0MeasurementMethod( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMci0Responsible( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMci0Criticality( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMci0Frequency( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMci0InspectionProcedure( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMci0MeasurementMethod( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMci0Responsible( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mci0BvrBopPMI();

    /**
     * Destructor
     */
    virtual ~Mci0BvrBopPMI();

private:
    //  Getter method for the Implementation Object
    Mci0BvrBopPMIImpl*  getMci0BvrBopPMIImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMci0BvrBopPMIImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mci0BvrBopPMIImpl*  m_mci0bvrboppmiImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mci0BvrBopPMI - desc for Mci0BvrBopPMI parameter
     */
    Mci0BvrBopPMI( const Mci0BvrBopPMI& );
    Mci0BvrBopPMI& operator=( const Mci0BvrBopPMI& );

    friend class  Mci0BvrBopPMIDelegate;
    friend class  Mci0BvrBopPMIDispatch;
    friend class  Mci0BvrBopPMIGenImpl;
};

#include <Mci0mfgcharacteristicsbvr/libmci0mfgcharacteristicsbvr_undef.h>
#endif //   MCI0MFGCHARACTERISTICS__MCI0BVRBOPPMI__HXX
