//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mci0BvrBopPMIDelegate
    Filename:   Mci0BvrBopPMIDelegate.hxx
    Module:     Mci0mfgcharacteristicsbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef MCI0MFGCHARACTERISTICS__MCI0BVRBOPPMIDELEGATE_HXX
#define MCI0MFGCHARACTERISTICS__MCI0BVRBOPPMIDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Mci0mfgcharacteristicsbvr/Mci0BvrBopPMI.hxx>

#include <Mci0mfgcharacteristicsbvr/libmci0mfgcharacteristicsbvr_exports.h>

namespace mci0mfgcharacteristics
{
    class Mci0BvrBopPMIDelegate;
}
namespace mci0mfgcharacteristics
{
    class Mci0BvrBopPMIImpl;
}
namespace mci0mfgcharacteristics
{
    class Mci0BvrBopPMI;
}
namespace mci0mfgcharacteristics
{
    class Mci0BvrBopPMIGenImpl;
}

namespace mci0mfgcharacteristics_alias = ::mci0mfgcharacteristics;


class  MCI0MFGCHARACTERISTICSBVR_API mci0mfgcharacteristics_alias::Mci0BvrBopPMIDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mci0BvrBopPMIDelegate instance
    static Mci0BvrBopPMIDelegate&  getInstance();

    //  Method to create the Mci0BvrBopPMIImpl pointer
    static Mci0BvrBopPMIImpl*  createImpl( Mci0BvrBopPMI&  ifObj );

    //  Method to delete the Mci0BvrBopPMIImpl pointer
    static void deleteImpl( Mci0BvrBopPMIImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMci0CriticalityBase(const Mci0BvrBopPMI &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMci0FrequencyBase(const Mci0BvrBopPMI &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMci0InspectionProcedureBase(const Mci0BvrBopPMI &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMci0MeasurementMethodBase(const Mci0BvrBopPMI &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMci0ResponsibleBase(const Mci0BvrBopPMI &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMci0CriticalityBase(Mci0BvrBopPMI &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMci0FrequencyBase(Mci0BvrBopPMI &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMci0InspectionProcedureBase(Mci0BvrBopPMI &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMci0MeasurementMethodBase(Mci0BvrBopPMI &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMci0ResponsibleBase(Mci0BvrBopPMI &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static Mci0BvrBopPMIDelegate*  m_pInstance;

    Mci0BvrBopPMIDelegate();
    virtual ~Mci0BvrBopPMIDelegate();
    static void setInstance( Mci0BvrBopPMIDelegate*  instance );


private:
    friend class  ::mci0mfgcharacteristics::Mci0BvrBopPMIGenImpl;

};

#include <Mci0mfgcharacteristicsbvr/libmci0mfgcharacteristicsbvr_undef.h>
#endif  //  MCI0MFGCHARACTERISTICS__MCI0BVRBOPPMIDELEGATE_HXX
