//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mci0PMI
    Filename:   Mci0PMI.hxx
    Module:     Mci0mfgcharacteristicsbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef MCI0MFGCHARACTERISTICS__MCI0PMI__HXX
#define MCI0MFGCHARACTERISTICS__MCI0PMI__HXX

#include <common/tc_deprecation_macros.h>
#include <mesbvr/Mes0MEDCD.hxx>

#include <Mci0mfgcharacteristicsbvr/libmci0mfgcharacteristicsbvr_exports.h>

namespace mci0mfgcharacteristics
{
    class Mci0PMI;
}
namespace mci0mfgcharacteristics
{
    class Mci0PMIImpl;
}
namespace mci0mfgcharacteristics
{
    class Mci0PMIDelegate;
}
namespace mci0mfgcharacteristics
{
    class Mci0PMIDispatch;
}
namespace mci0mfgcharacteristics
{
    class Mci0PMIGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MCI0MFGCHARACTERISTICSBVR_API  mci0mfgcharacteristics::Mci0PMI
     : public  ::CMTMES::Mes0MEDCD
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mci0PMI();

    /**
     * Destructor
     */
    virtual ~Mci0PMI();

private:
    //  Getter method for the Implementation Object
    Mci0PMIImpl*  getMci0PMIImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMci0PMIImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mci0PMIImpl*  m_mci0pmiImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mci0PMI - desc for Mci0PMI parameter
     */
    Mci0PMI( const Mci0PMI& );
    Mci0PMI& operator=( const Mci0PMI& );

    friend class  Mci0PMIDelegate;
    friend class  Mci0PMIDispatch;
    friend class  Mci0PMIGenImpl;
};

#include <Mci0mfgcharacteristicsbvr/libmci0mfgcharacteristicsbvr_undef.h>
#endif //   MCI0MFGCHARACTERISTICS__MCI0PMI__HXX
