//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdc0ConditionalElementGroup
    Filename:   Mdc0ConditionalElementGroup.hxx
    Module:     Mdc0mdc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MDCONNECTIVITY__MDC0CONDITIONALELEMENTGROUP__HXX
#define TEAMCENTER__MDCONNECTIVITY__MDC0CONDITIONALELEMENTGROUP__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0ConditionalElement.hxx>

#include <Mdc0mdc/libmdc0mdc_exports.h>

namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0ConditionalElementGroup;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0ConditionalElementGroupImpl;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0ConditionalElementGroupDelegate;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0ConditionalElementGroupDispatch;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0ConditionalElementGroupGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDC0MDC_API  Teamcenter::mdconnectivity::Mdc0ConditionalElementGroup
     : public  ::Teamcenter::AppModel::Mdl0ConditionalElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 11.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMdc0OrderedElementGroups( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdc0ConditionalElementGroup();

    /**
     * Destructor
     */
    virtual ~Mdc0ConditionalElementGroup();

private:
    //  Getter method for the Implementation Object
    Mdc0ConditionalElementGroupImpl*  getMdc0ConditionalElementGroupImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdc0ConditionalElementGroupImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdc0ConditionalElementGroupImpl*  m_mdc0conditionalelementgroupImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdc0ConditionalElementGroup - desc for Mdc0ConditionalElementGroup parameter
     */
    Mdc0ConditionalElementGroup( const Mdc0ConditionalElementGroup& );
    Mdc0ConditionalElementGroup& operator=( const Mdc0ConditionalElementGroup& );

    friend class  Mdc0ConditionalElementGroupDelegate;
    friend class  Mdc0ConditionalElementGroupDispatch;
    friend class  Mdc0ConditionalElementGroupGenImpl;
};

#include <Mdc0mdc/libmdc0mdc_undef.h>
#endif //   TEAMCENTER__MDCONNECTIVITY__MDC0CONDITIONALELEMENTGROUP__HXX
