//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdc0ConditionalElementGroupDelegate
    Filename:   Mdc0ConditionalElementGroupDelegate.hxx
    Module:     Mdc0mdc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MDCONNECTIVITY__MDC0CONDITIONALELEMENTGROUPDELEGATE_HXX
#define TEAMCENTER__MDCONNECTIVITY__MDC0CONDITIONALELEMENTGROUPDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Mdc0mdc/Mdc0ConditionalElementGroup.hxx>

#include <Mdc0mdc/libmdc0mdc_exports.h>

namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0ConditionalElementGroupDelegate;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0ConditionalElementGroupImpl;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0ConditionalElementGroup;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0ConditionalElementGroupGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MDC0MDC_API Teamcenter_alias::mdconnectivity::Mdc0ConditionalElementGroupDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mdc0ConditionalElementGroupDelegate instance
    static Mdc0ConditionalElementGroupDelegate&  getInstance();

    //  Method to create the Mdc0ConditionalElementGroupImpl pointer
    static Mdc0ConditionalElementGroupImpl*  createImpl( Mdc0ConditionalElementGroup&  ifObj );

    //  Method to delete the Mdc0ConditionalElementGroupImpl pointer
    static void deleteImpl( Mdc0ConditionalElementGroupImpl*  impl );


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 11.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMdc0OrderedElementGroupsBase(Mdc0ConditionalElementGroup &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Mdc0ConditionalElementGroup &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be created
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0FinalizeCreateInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static Mdc0ConditionalElementGroupDelegate*  m_pInstance;

    Mdc0ConditionalElementGroupDelegate();
    virtual ~Mdc0ConditionalElementGroupDelegate();
    static void setInstance( Mdc0ConditionalElementGroupDelegate*  instance );


private:
    friend class  ::Teamcenter::mdconnectivity::Mdc0ConditionalElementGroupGenImpl;

};

#include <Mdc0mdc/libmdc0mdc_undef.h>
#endif  //  TEAMCENTER__MDCONNECTIVITY__MDC0CONDITIONALELEMENTGROUPDELEGATE_HXX
