//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdc0ConnectionElement
    Filename:   Mdc0ConnectionElement.hxx
    Module:     Mdc0mdc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MDCONNECTIVITY__MDC0CONNECTIONELEMENT__HXX
#define TEAMCENTER__MDCONNECTIVITY__MDC0CONNECTIONELEMENT__HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0ConditionalElement.hxx>

#include <Mdc0mdc/libmdc0mdc_exports.h>

namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0ConnectionElement;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0ConnectionElementImpl;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0ConnectionElementDelegate;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0ConnectionElementDispatch;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0ConnectionElementGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDC0MDC_API  Teamcenter::mdconnectivity::Mdc0ConnectionElement
     : public  ::Teamcenter::AppModel::Mdl0ConditionalElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdc0ConnectionElement();

    /**
     * Destructor
     */
    virtual ~Mdc0ConnectionElement();

private:
    //  Getter method for the Implementation Object
    Mdc0ConnectionElementImpl*  getMdc0ConnectionElementImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdc0ConnectionElementImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdc0ConnectionElementImpl*  m_mdc0connectionelementImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdc0ConnectionElement - desc for Mdc0ConnectionElement parameter
     */
    Mdc0ConnectionElement( const Mdc0ConnectionElement& );
    Mdc0ConnectionElement& operator=( const Mdc0ConnectionElement& );

    friend class  Mdc0ConnectionElementDelegate;
    friend class  Mdc0ConnectionElementDispatch;
    friend class  Mdc0ConnectionElementGenImpl;
};

#include <Mdc0mdc/libmdc0mdc_undef.h>
#endif //   TEAMCENTER__MDCONNECTIVITY__MDC0CONNECTIONELEMENT__HXX
