//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdc0ConnectionElementDelegate
    Filename:   Mdc0ConnectionElementDelegate.hxx
    Module:     Mdc0mdc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MDCONNECTIVITY__MDC0CONNECTIONELEMENTDELEGATE_HXX
#define TEAMCENTER__MDCONNECTIVITY__MDC0CONNECTIONELEMENTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Mdc0mdc/Mdc0ConnectionElement.hxx>

#include <Mdc0mdc/libmdc0mdc_exports.h>

namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0ConnectionElementDelegate;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0ConnectionElementImpl;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0ConnectionElement;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0ConnectionElementGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MDC0MDC_API Teamcenter_alias::mdconnectivity::Mdc0ConnectionElementDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mdc0ConnectionElementDelegate instance
    static Mdc0ConnectionElementDelegate&  getInstance();

    //  Method to create the Mdc0ConnectionElementImpl pointer
    static Mdc0ConnectionElementImpl*  createImpl( Mdc0ConnectionElement&  ifObj );

    //  Method to delete the Mdc0ConnectionElementImpl pointer
    static void deleteImpl( Mdc0ConnectionElementImpl*  impl );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Mdc0ConnectionElement &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be created
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0FinalizeCreateInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be created
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0ValidateCreateInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Mdc0ConnectionElement &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Mdc0ConnectionElementDelegate*  m_pInstance;

    Mdc0ConnectionElementDelegate();
    virtual ~Mdc0ConnectionElementDelegate();
    static void setInstance( Mdc0ConnectionElementDelegate*  instance );


private:
    friend class  ::Teamcenter::mdconnectivity::Mdc0ConnectionElementGenImpl;

};

#include <Mdc0mdc/libmdc0mdc_undef.h>
#endif  //  TEAMCENTER__MDCONNECTIVITY__MDC0CONNECTIONELEMENTDELEGATE_HXX
