//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdc0Fulfilment
    Filename:   Mdc0Fulfilment.hxx
    Module:     Mdc0mdc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MDCONNECTIVITY__MDC0FULFILMENT__HXX
#define TEAMCENTER__MDCONNECTIVITY__MDC0FULFILMENT__HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0ManagedAttrGroup.hxx>

#include <Mdc0mdc/libmdc0mdc_exports.h>

namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0Fulfilment;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0FulfilmentImpl;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0FulfilmentDelegate;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0FulfilmentDispatch;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0FulfilmentGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDC0MDC_API  Teamcenter::mdconnectivity::Mdc0Fulfilment
     : public  ::Teamcenter::AppModel::Mdl0ManagedAttrGroup
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdc0Fulfilment();

    /**
     * Destructor
     */
    virtual ~Mdc0Fulfilment();

private:
    //  Getter method for the Implementation Object
    Mdc0FulfilmentImpl*  getMdc0FulfilmentImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdc0FulfilmentImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdc0FulfilmentImpl*  m_mdc0fulfilmentImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdc0Fulfilment - desc for Mdc0Fulfilment parameter
     */
    Mdc0Fulfilment( const Mdc0Fulfilment& );
    Mdc0Fulfilment& operator=( const Mdc0Fulfilment& );

    friend class  Mdc0FulfilmentDelegate;
    friend class  Mdc0FulfilmentDispatch;
    friend class  Mdc0FulfilmentGenImpl;
};

#include <Mdc0mdc/libmdc0mdc_undef.h>
#endif //   TEAMCENTER__MDCONNECTIVITY__MDC0FULFILMENT__HXX
