//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdc0ModelToModelLink
    Filename:   Mdc0ModelToModelLink.hxx
    Module:     Mdc0mdc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MDCONNECTIVITY__MDC0MODELTOMODELLINK__HXX
#define TEAMCENTER__MDCONNECTIVITY__MDC0MODELTOMODELLINK__HXX

#include <common/tc_deprecation_macros.h>
#include <aps0apscore/Mdl0CopyStableRelation.hxx>

#include <Mdc0mdc/libmdc0mdc_exports.h>

namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0ModelToModelLink;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0ModelToModelLinkImpl;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0ModelToModelLinkDelegate;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0ModelToModelLinkDispatch;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0ModelToModelLinkGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDC0MDC_API  Teamcenter::mdconnectivity::Mdc0ModelToModelLink
     : public  ::Teamcenter::AppModel::Mdl0CopyStableRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdc0ModelToModelLink();

    /**
     * Destructor
     */
    virtual ~Mdc0ModelToModelLink();

private:
    //  Getter method for the Implementation Object
    Mdc0ModelToModelLinkImpl*  getMdc0ModelToModelLinkImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdc0ModelToModelLinkImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdc0ModelToModelLinkImpl*  m_mdc0modeltomodellinkImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdc0ModelToModelLink - desc for Mdc0ModelToModelLink parameter
     */
    Mdc0ModelToModelLink( const Mdc0ModelToModelLink& );
    Mdc0ModelToModelLink& operator=( const Mdc0ModelToModelLink& );

    friend class  Mdc0ModelToModelLinkDelegate;
    friend class  Mdc0ModelToModelLinkDispatch;
    friend class  Mdc0ModelToModelLinkGenImpl;
};

#include <Mdc0mdc/libmdc0mdc_undef.h>
#endif //   TEAMCENTER__MDCONNECTIVITY__MDC0MODELTOMODELLINK__HXX
