//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdc0Need
    Filename:   Mdc0Need.hxx
    Module:     Mdc0mdc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MDCONNECTIVITY__MDC0NEED__HXX
#define TEAMCENTER__MDCONNECTIVITY__MDC0NEED__HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0AttributeGroup.hxx>

#include <Mdc0mdc/libmdc0mdc_exports.h>

namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0Need;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0NeedImpl;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0NeedDelegate;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0NeedDispatch;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0NeedGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDC0MDC_API  Teamcenter::mdconnectivity::Mdc0Need
     : public  ::Teamcenter::AppModel::Mdl0AttributeGroup
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdc0Need();

    /**
     * Destructor
     */
    virtual ~Mdc0Need();

private:
    //  Getter method for the Implementation Object
    Mdc0NeedImpl*  getMdc0NeedImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdc0NeedImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdc0NeedImpl*  m_mdc0needImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdc0Need - desc for Mdc0Need parameter
     */
    Mdc0Need( const Mdc0Need& );
    Mdc0Need& operator=( const Mdc0Need& );

    friend class  Mdc0NeedDelegate;
    friend class  Mdc0NeedDispatch;
    friend class  Mdc0NeedGenImpl;
};

#include <Mdc0mdc/libmdc0mdc_undef.h>
#endif //   TEAMCENTER__MDCONNECTIVITY__MDC0NEED__HXX
