//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdc0OrderedElementGroup
    Filename:   Mdc0OrderedElementGroup.hxx
    Module:     Mdc0mdc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MDCONNECTIVITY__MDC0ORDEREDELEMENTGROUP__HXX
#define TEAMCENTER__MDCONNECTIVITY__MDC0ORDEREDELEMENTGROUP__HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0ModelArtifact.hxx>

#include <Mdc0mdc/libmdc0mdc_exports.h>

namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0OrderedElementGroup;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0OrderedElementGroupImpl;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0OrderedElementGroupDelegate;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0OrderedElementGroupDispatch;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0OrderedElementGroupGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDC0MDC_API  Teamcenter::mdconnectivity::Mdc0OrderedElementGroup
     : public  ::Teamcenter::AppModel::Mdl0ModelArtifact
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdc0OrderedElementGroup();

    /**
     * Destructor
     */
    virtual ~Mdc0OrderedElementGroup();

private:
    //  Getter method for the Implementation Object
    Mdc0OrderedElementGroupImpl*  getMdc0OrderedElementGroupImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdc0OrderedElementGroupImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdc0OrderedElementGroupImpl*  m_mdc0orderedelementgroupImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdc0OrderedElementGroup - desc for Mdc0OrderedElementGroup parameter
     */
    Mdc0OrderedElementGroup( const Mdc0OrderedElementGroup& );
    Mdc0OrderedElementGroup& operator=( const Mdc0OrderedElementGroup& );

    friend class  Mdc0OrderedElementGroupDelegate;
    friend class  Mdc0OrderedElementGroupDispatch;
    friend class  Mdc0OrderedElementGroupGenImpl;
};

#include <Mdc0mdc/libmdc0mdc_undef.h>
#endif //   TEAMCENTER__MDCONNECTIVITY__MDC0ORDEREDELEMENTGROUP__HXX
