//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdc0OrderedElementGroupDelegate
    Filename:   Mdc0OrderedElementGroupDelegate.hxx
    Module:     Mdc0mdc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MDCONNECTIVITY__MDC0ORDEREDELEMENTGROUPDELEGATE_HXX
#define TEAMCENTER__MDCONNECTIVITY__MDC0ORDEREDELEMENTGROUPDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Mdc0mdc/Mdc0OrderedElementGroup.hxx>

#include <Mdc0mdc/libmdc0mdc_exports.h>

namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0OrderedElementGroupDelegate;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0OrderedElementGroupImpl;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0OrderedElementGroup;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0OrderedElementGroupGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MDC0MDC_API Teamcenter_alias::mdconnectivity::Mdc0OrderedElementGroupDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mdc0OrderedElementGroupDelegate instance
    static Mdc0OrderedElementGroupDelegate&  getInstance();

    //  Method to create the Mdc0OrderedElementGroupImpl pointer
    static Mdc0OrderedElementGroupImpl*  createImpl( Mdc0OrderedElementGroup&  ifObj );

    //  Method to delete the Mdc0OrderedElementGroupImpl pointer
    static void deleteImpl( Mdc0OrderedElementGroupImpl*  impl );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Mdc0OrderedElementGroup &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Mdc0OrderedElementGroup &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0CreatePostBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be created
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0FinalizeCreateInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be created
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0ValidateCreateInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Mdc0OrderedElementGroup &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Mdc0OrderedElementGroupDelegate*  m_pInstance;

    Mdc0OrderedElementGroupDelegate();
    virtual ~Mdc0OrderedElementGroupDelegate();
    static void setInstance( Mdc0OrderedElementGroupDelegate*  instance );


private:
    friend class  ::Teamcenter::mdconnectivity::Mdc0OrderedElementGroupGenImpl;

};

#include <Mdc0mdc/libmdc0mdc_undef.h>
#endif  //  TEAMCENTER__MDCONNECTIVITY__MDC0ORDEREDELEMENTGROUPDELEGATE_HXX
