//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdc0PortArtifact
    Filename:   Mdc0PortArtifact.hxx
    Module:     Mdc0mdc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MDCONNECTIVITY__MDC0PORTARTIFACT__HXX
#define TEAMCENTER__MDCONNECTIVITY__MDC0PORTARTIFACT__HXX

#include <common/tc_deprecation_macros.h>
#include <rlz0realization/Rlz0GDEArtifact.hxx>

#include <Mdc0mdc/libmdc0mdc_exports.h>

namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0PortArtifact;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0PortArtifactImpl;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0PortArtifactDelegate;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0PortArtifactDispatch;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0PortArtifactGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDC0MDC_API  Teamcenter::mdconnectivity::Mdc0PortArtifact
     : public  ::Teamcenter::Realization::Rlz0GDEArtifact
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdc0PortArtifact();

    /**
     * Destructor
     */
    virtual ~Mdc0PortArtifact();

private:
    //  Getter method for the Implementation Object
    Mdc0PortArtifactImpl*  getMdc0PortArtifactImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdc0PortArtifactImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdc0PortArtifactImpl*  m_mdc0portartifactImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdc0PortArtifact - desc for Mdc0PortArtifact parameter
     */
    Mdc0PortArtifact( const Mdc0PortArtifact& );
    Mdc0PortArtifact& operator=( const Mdc0PortArtifact& );

    friend class  Mdc0PortArtifactDelegate;
    friend class  Mdc0PortArtifactDispatch;
    friend class  Mdc0PortArtifactGenImpl;
};

#include <Mdc0mdc/libmdc0mdc_undef.h>
#endif //   TEAMCENTER__MDCONNECTIVITY__MDC0PORTARTIFACT__HXX
