//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdc0RelationMap
    Filename:   Mdc0RelationMap.hxx
    Module:     Mdc0mdc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MDCONNECTIVITY__MDC0RELATIONMAP__HXX
#define TEAMCENTER__MDCONNECTIVITY__MDC0RELATIONMAP__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <Mdc0mdc/libmdc0mdc_exports.h>

namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0RelationMap;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0RelationMapImpl;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0RelationMapDelegate;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0RelationMapDispatch;
    }
}
namespace Teamcenter
{
    namespace mdconnectivity
    {
        class Mdc0RelationMapGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDC0MDC_API  Teamcenter::mdconnectivity::Mdc0RelationMap
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdc0RelationMap();

    /**
     * Destructor
     */
    virtual ~Mdc0RelationMap();

private:
    //  Getter method for the Implementation Object
    Mdc0RelationMapImpl*  getMdc0RelationMapImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdc0RelationMapImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdc0RelationMapImpl*  m_mdc0relationmapImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdc0RelationMap - desc for Mdc0RelationMap parameter
     */
    Mdc0RelationMap( const Mdc0RelationMap& );
    Mdc0RelationMap& operator=( const Mdc0RelationMap& );

    friend class  Mdc0RelationMapDelegate;
    friend class  Mdc0RelationMapDispatch;
    friend class  Mdc0RelationMapGenImpl;
};

#include <Mdc0mdc/libmdc0mdc_undef.h>
#endif //   TEAMCENTER__MDCONNECTIVITY__MDC0RELATIONMAP__HXX
