//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdo0MDInstance
    Filename:   Mdo0MDInstance.hxx
    Module:     Mdo0Mdo
    @BMIDE autogenerated
==================================================================================================*/

#ifndef MDO__MDO0MDINSTANCE__HXX
#define MDO__MDO0MDINSTANCE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <Mdo0Mdo/libmdo0mdo_exports.h>

namespace mdo
{
    class Mdo0MDInstance;
}
namespace mdo
{
    class Mdo0MDInstanceImpl;
}
namespace mdo
{
    class Mdo0MDInstanceDelegate;
}
namespace mdo
{
    class Mdo0MDInstanceDispatch;
}
namespace mdo
{
    class Mdo0MDInstanceGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDO0MDO_API  mdo::Mdo0MDInstance
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdo0MDInstance();

    /**
     * Destructor
     */
    virtual ~Mdo0MDInstance();

private:
    //  Getter method for the Implementation Object
    Mdo0MDInstanceImpl*  getMdo0MDInstanceImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdo0MDInstanceImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdo0MDInstanceImpl*  m_mdo0mdinstanceImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdo0MDInstance - desc for Mdo0MDInstance parameter
     */
    Mdo0MDInstance( const Mdo0MDInstance& );
    Mdo0MDInstance& operator=( const Mdo0MDInstance& );

    friend class  Mdo0MDInstanceDelegate;
    friend class  Mdo0MDInstanceDispatch;
    friend class  Mdo0MDInstanceGenImpl;
};

#include <Mdo0Mdo/libmdo0mdo_undef.h>
#endif //   MDO__MDO0MDINSTANCE__HXX
