//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdo0MDThread
    Filename:   Mdo0MDThread.hxx
    Module:     Mdo0Mdo
    @BMIDE autogenerated
==================================================================================================*/

#ifndef MDO__MDO0MDTHREAD__HXX
#define MDO__MDO0MDTHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <Mdo0Mdo/libmdo0mdo_exports.h>

namespace mdo
{
    class Mdo0MDThread;
}
namespace mdo
{
    class Mdo0MDThreadImpl;
}
namespace mdo
{
    class Mdo0MDThreadDelegate;
}
namespace mdo
{
    class Mdo0MDThreadDispatch;
}
namespace mdo
{
    class Mdo0MDThreadGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDO0MDO_API  mdo::Mdo0MDThread
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdo0MDThread();

    /**
     * Destructor
     */
    virtual ~Mdo0MDThread();

private:
    //  Getter method for the Implementation Object
    Mdo0MDThreadImpl*  getMdo0MDThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdo0MDThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdo0MDThreadImpl*  m_mdo0mdthreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdo0MDThread - desc for Mdo0MDThread parameter
     */
    Mdo0MDThread( const Mdo0MDThread& );
    Mdo0MDThread& operator=( const Mdo0MDThread& );

    friend class  Mdo0MDThreadDelegate;
    friend class  Mdo0MDThreadDispatch;
    friend class  Mdo0MDThreadGenImpl;
};

#include <Mdo0Mdo/libmdo0mdo_undef.h>
#endif //   MDO__MDO0MDTHREAD__HXX
