//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mem0MemoryBlockDelegate
    Filename:   Mem0MemoryBlockDelegate.hxx
    Module:     Mem0memmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__MEM0MEMORYBLOCKDELEGATE_HXX
#define CCDM__MEM0MEMORYBLOCKDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Mem0memmgt/Mem0MemoryBlock.hxx>

#include <Mem0memmgt/libmem0memmgt_exports.h>

namespace ccdm
{
    class Mem0MemoryBlockDelegate;
}
namespace ccdm
{
    class Mem0MemoryBlockImpl;
}
namespace ccdm
{
    class Mem0MemoryBlock;
}
namespace ccdm
{
    class Mem0MemoryBlockGenImpl;
}

namespace ccdm_alias = ::ccdm;


class  MEM0MEMMGT_API ccdm_alias::Mem0MemoryBlockDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mem0MemoryBlockDelegate instance
    static Mem0MemoryBlockDelegate&  getInstance();

    //  Method to create the Mem0MemoryBlockImpl pointer
    static Mem0MemoryBlockImpl*  createImpl( Mem0MemoryBlock&  ifObj );

    //  Method to delete the Mem0MemoryBlockImpl pointer
    static void deleteImpl( Mem0MemoryBlockImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMem0BlockNameBase(const Mem0MemoryBlock &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMem0HeaderObjectBase(const Mem0MemoryBlock &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMem0MemoryBlocksBase(const Mem0MemoryBlock &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMem0MemoryRecordsBase(const Mem0MemoryBlock &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMem0StartAddressBase(const Mem0MemoryBlock &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMem0TrailerObjectBase(const Mem0MemoryBlock &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMem0BlockNameBase(Mem0MemoryBlock &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMem0HeaderObjectBase(Mem0MemoryBlock &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 9.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMem0MemoryBlocksBase(Mem0MemoryBlock &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 9.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMem0MemoryRecordsBase(Mem0MemoryBlock &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMem0StartAddressBase(Mem0MemoryBlock &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMem0TrailerObjectBase(Mem0MemoryBlock &ifObj,  const tag_t &value, bool isNull );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Mem0MemoryBlock &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Mem0MemoryBlockDelegate*  m_pInstance;

    Mem0MemoryBlockDelegate();
    virtual ~Mem0MemoryBlockDelegate();
    static void setInstance( Mem0MemoryBlockDelegate*  instance );


private:
    friend class  ::ccdm::Mem0MemoryBlockGenImpl;

};

#include <Mem0memmgt/libmem0memmgt_undef.h>
#endif  //  CCDM__MEM0MEMORYBLOCKDELEGATE_HXX
