//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mem0MemoryContentDelegate
    Filename:   Mem0MemoryContentDelegate.hxx
    Module:     Mem0memmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__MEM0MEMORYCONTENTDELEGATE_HXX
#define CCDM__MEM0MEMORYCONTENTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Mem0memmgt/Mem0MemoryContent.hxx>

#include <Mem0memmgt/libmem0memmgt_exports.h>

namespace ccdm
{
    class Mem0MemoryContentDelegate;
}
namespace ccdm
{
    class Mem0MemoryContentImpl;
}
namespace ccdm
{
    class Mem0MemoryContent;
}
namespace ccdm
{
    class Mem0MemoryContentGenImpl;
}

namespace ccdm_alias = ::ccdm;


class  MEM0MEMMGT_API ccdm_alias::Mem0MemoryContentDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mem0MemoryContentDelegate instance
    static Mem0MemoryContentDelegate&  getInstance();

    //  Method to create the Mem0MemoryContentImpl pointer
    static Mem0MemoryContentImpl*  createImpl( Mem0MemoryContent&  ifObj );

    //  Method to delete the Mem0MemoryContentImpl pointer
    static void deleteImpl( Mem0MemoryContentImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMem0MemoryBlocksBase(const Mem0MemoryContent &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMem0MemoryRecordsBase(const Mem0MemoryContent &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 9.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMem0MemoryBlocksBase(Mem0MemoryContent &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 9.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMem0MemoryRecordsBase(Mem0MemoryContent &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );



protected:
    //  Pointer to the instance
    static Mem0MemoryContentDelegate*  m_pInstance;

    Mem0MemoryContentDelegate();
    virtual ~Mem0MemoryContentDelegate();
    static void setInstance( Mem0MemoryContentDelegate*  instance );


private:
    friend class  ::ccdm::Mem0MemoryContentGenImpl;

};

#include <Mem0memmgt/libmem0memmgt_undef.h>
#endif  //  CCDM__MEM0MEMORYCONTENTDELEGATE_HXX
