//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mem0MemoryLayout
    Filename:   Mem0MemoryLayout.hxx
    Module:     Mem0memmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__MEM0MEMORYLAYOUT__HXX
#define CCDM__MEM0MEMORYLAYOUT__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <Mem0memmgt/libmem0memmgt_exports.h>

namespace ccdm
{
    class Mem0MemoryLayout;
}
namespace ccdm
{
    class Mem0MemoryLayoutImpl;
}
namespace ccdm
{
    class Mem0MemoryLayoutDelegate;
}
namespace ccdm
{
    class Mem0MemoryLayoutDispatch;
}
namespace ccdm
{
    class Mem0MemoryLayoutGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MEM0MEMMGT_API  ccdm::Mem0MemoryLayout
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMem0Attribute( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMem0MemoryType( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMem0PrgType( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMem0Attribute( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMem0MemoryType( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMem0PrgType( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mem0MemoryLayout();

    /**
     * Destructor
     */
    virtual ~Mem0MemoryLayout();

private:
    //  Getter method for the Implementation Object
    Mem0MemoryLayoutImpl*  getMem0MemoryLayoutImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMem0MemoryLayoutImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mem0MemoryLayoutImpl*  m_mem0memorylayoutImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mem0MemoryLayout - desc for Mem0MemoryLayout parameter
     */
    Mem0MemoryLayout( const Mem0MemoryLayout& );
    Mem0MemoryLayout& operator=( const Mem0MemoryLayout& );

    friend class  Mem0MemoryLayoutDelegate;
    friend class  Mem0MemoryLayoutDispatch;
    friend class  Mem0MemoryLayoutGenImpl;
};

#include <Mem0memmgt/libmem0memmgt_undef.h>
#endif //   CCDM__MEM0MEMORYLAYOUT__HXX
