//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mem0MemoryLayoutDelegate
    Filename:   Mem0MemoryLayoutDelegate.hxx
    Module:     Mem0memmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__MEM0MEMORYLAYOUTDELEGATE_HXX
#define CCDM__MEM0MEMORYLAYOUTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Mem0memmgt/Mem0MemoryLayout.hxx>

#include <Mem0memmgt/libmem0memmgt_exports.h>

namespace ccdm
{
    class Mem0MemoryLayoutDelegate;
}
namespace ccdm
{
    class Mem0MemoryLayoutImpl;
}
namespace ccdm
{
    class Mem0MemoryLayout;
}
namespace ccdm
{
    class Mem0MemoryLayoutGenImpl;
}

namespace ccdm_alias = ::ccdm;


class  MEM0MEMMGT_API ccdm_alias::Mem0MemoryLayoutDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mem0MemoryLayoutDelegate instance
    static Mem0MemoryLayoutDelegate&  getInstance();

    //  Method to create the Mem0MemoryLayoutImpl pointer
    static Mem0MemoryLayoutImpl*  createImpl( Mem0MemoryLayout&  ifObj );

    //  Method to delete the Mem0MemoryLayoutImpl pointer
    static void deleteImpl( Mem0MemoryLayoutImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMem0AttributeBase(const Mem0MemoryLayout &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMem0MemoryTypeBase(const Mem0MemoryLayout &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMem0PrgTypeBase(const Mem0MemoryLayout &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMem0AttributeBase(Mem0MemoryLayout &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMem0MemoryTypeBase(Mem0MemoryLayout &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMem0PrgTypeBase(Mem0MemoryLayout &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static Mem0MemoryLayoutDelegate*  m_pInstance;

    Mem0MemoryLayoutDelegate();
    virtual ~Mem0MemoryLayoutDelegate();
    static void setInstance( Mem0MemoryLayoutDelegate*  instance );


private:
    friend class  ::ccdm::Mem0MemoryLayoutGenImpl;

};

#include <Mem0memmgt/libmem0memmgt_undef.h>
#endif  //  CCDM__MEM0MEMORYLAYOUTDELEGATE_HXX
