//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mem0MemoryLayoutRevision
    Filename:   Mem0MemoryLayoutRevision.hxx
    Module:     Mem0memmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__MEM0MEMORYLAYOUTREVISION__HXX
#define CCDM__MEM0MEMORYLAYOUTREVISION__HXX

#include <unidefs.h>
#include <vector>
#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <Mem0memmgt/libmem0memmgt_exports.h>

namespace ccdm
{
    class Mem0MemoryLayoutRevision;
}
namespace ccdm
{
    class Mem0MemoryLayoutRevisionImpl;
}
namespace ccdm
{
    class Mem0MemoryLayoutRevisionDelegate;
}
namespace ccdm
{
    class Mem0MemoryLayoutRevisionDispatch;
}
namespace ccdm
{
    class Mem0MemoryLayoutRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MEM0MEMMGT_API  ccdm::Mem0MemoryLayoutRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMem0HeaderObject( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMem0MemoryContent( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 9.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMem0MirroredOffset( std::vector< std::string > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMem0Size( int &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMem0StartAddress( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMem0TrailerObject( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMem0HeaderObject( const tag_t &value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMem0MemoryContent( const tag_t &value, bool isNull=false );

    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 9.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMem0MirroredOffset( const std::vector< std::string > &values, const std::vector< int > *isNull=0 );

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMem0Size( int value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMem0StartAddress( const std::string &value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMem0TrailerObject( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mem0MemoryLayoutRevision();

    /**
     * Destructor
     */
    virtual ~Mem0MemoryLayoutRevision();

private:
    //  Getter method for the Implementation Object
    Mem0MemoryLayoutRevisionImpl*  getMem0MemoryLayoutRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMem0MemoryLayoutRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mem0MemoryLayoutRevisionImpl*  m_mem0memorylayoutrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mem0MemoryLayoutRevision - desc for Mem0MemoryLayoutRevision parameter
     */
    Mem0MemoryLayoutRevision( const Mem0MemoryLayoutRevision& );
    Mem0MemoryLayoutRevision& operator=( const Mem0MemoryLayoutRevision& );

    friend class  Mem0MemoryLayoutRevisionDelegate;
    friend class  Mem0MemoryLayoutRevisionDispatch;
    friend class  Mem0MemoryLayoutRevisionGenImpl;
};

#include <Mem0memmgt/libmem0memmgt_undef.h>
#endif //   CCDM__MEM0MEMORYLAYOUTREVISION__HXX
