//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mem0MemoryLayoutRevisionDelegate
    Filename:   Mem0MemoryLayoutRevisionDelegate.hxx
    Module:     Mem0memmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__MEM0MEMORYLAYOUTREVISIONDELEGATE_HXX
#define CCDM__MEM0MEMORYLAYOUTREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Mem0memmgt/Mem0MemoryLayoutRevision.hxx>

#include <Mem0memmgt/libmem0memmgt_exports.h>

namespace ccdm
{
    class Mem0MemoryLayoutRevisionDelegate;
}
namespace ccdm
{
    class Mem0MemoryLayoutRevisionImpl;
}
namespace ccdm
{
    class Mem0MemoryLayoutRevision;
}
namespace ccdm
{
    class Mem0MemoryLayoutRevisionGenImpl;
}

namespace ccdm_alias = ::ccdm;


class  MEM0MEMMGT_API ccdm_alias::Mem0MemoryLayoutRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mem0MemoryLayoutRevisionDelegate instance
    static Mem0MemoryLayoutRevisionDelegate&  getInstance();

    //  Method to create the Mem0MemoryLayoutRevisionImpl pointer
    static Mem0MemoryLayoutRevisionImpl*  createImpl( Mem0MemoryLayoutRevision&  ifObj );

    //  Method to delete the Mem0MemoryLayoutRevisionImpl pointer
    static void deleteImpl( Mem0MemoryLayoutRevisionImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMem0HeaderObjectBase(const Mem0MemoryLayoutRevision &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMem0MemoryContentBase(const Mem0MemoryLayoutRevision &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 9.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMem0MirroredOffsetBase(const Mem0MemoryLayoutRevision &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMem0SizeBase(const Mem0MemoryLayoutRevision &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMem0StartAddressBase(const Mem0MemoryLayoutRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMem0TrailerObjectBase(const Mem0MemoryLayoutRevision &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMem0HeaderObjectBase(Mem0MemoryLayoutRevision &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMem0MemoryContentBase(Mem0MemoryLayoutRevision &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 9.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMem0MirroredOffsetBase(Mem0MemoryLayoutRevision &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMem0SizeBase(Mem0MemoryLayoutRevision &ifObj,  int value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMem0StartAddressBase(Mem0MemoryLayoutRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMem0TrailerObjectBase(Mem0MemoryLayoutRevision &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Generic revisePost operation.
    /// @version Teamcenter 10.1
    /// @param pReviseInput - Input ReviseInput object.
    /// @param vecDeepCopyData - Vector of deep copy data.
    /// @return - Returns an integer value.
    ///
    int  revisePostBase(const Mem0MemoryLayoutRevision &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// Generic saveAsPost operation.
    /// @version Teamcenter 8.1
    /// @param pSavAsInput - Input argument as SaveAsInput object.
    /// @param vecDeepCopyData - vector deepcopy data
    /// @return - Return integer value.
    ///
    int  saveAsPostBase(const Mem0MemoryLayoutRevision &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Mem0MemoryLayoutRevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Validate revise input.
    /// @version Teamcenter 10.1
    /// @param pReviseInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - Returns an int.
    ///
    int  validateReviseInputBase(const Mem0MemoryLayoutRevision &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// validate saveas input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  validateSaveAsInputBase(const Mem0MemoryLayoutRevision &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static Mem0MemoryLayoutRevisionDelegate*  m_pInstance;

    Mem0MemoryLayoutRevisionDelegate();
    virtual ~Mem0MemoryLayoutRevisionDelegate();
    static void setInstance( Mem0MemoryLayoutRevisionDelegate*  instance );


private:
    friend class  ::ccdm::Mem0MemoryLayoutRevisionGenImpl;

};

#include <Mem0memmgt/libmem0memmgt_undef.h>
#endif  //  CCDM__MEM0MEMORYLAYOUTREVISIONDELEGATE_HXX
