//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mem0MemoryRecord
    Filename:   Mem0MemoryRecord.hxx
    Module:     Mem0memmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__MEM0MEMORYRECORD__HXX
#define CCDM__MEM0MEMORYRECORD__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <Mem0memmgt/libmem0memmgt_exports.h>

namespace ccdm
{
    class Mem0MemoryRecord;
}
namespace ccdm
{
    class Mem0MemoryRecordImpl;
}
namespace ccdm
{
    class Mem0MemoryRecordDelegate;
}
namespace ccdm
{
    class Mem0MemoryRecordDispatch;
}
namespace ccdm
{
    class Mem0MemoryRecordGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MEM0MEMMGT_API  ccdm::Mem0MemoryRecord
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMem0OffsetAddr( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMem0OffsetAddr( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mem0MemoryRecord();

    /**
     * Destructor
     */
    virtual ~Mem0MemoryRecord();

private:
    //  Getter method for the Implementation Object
    Mem0MemoryRecordImpl*  getMem0MemoryRecordImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMem0MemoryRecordImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mem0MemoryRecordImpl*  m_mem0memoryrecordImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mem0MemoryRecord - desc for Mem0MemoryRecord parameter
     */
    Mem0MemoryRecord( const Mem0MemoryRecord& );
    Mem0MemoryRecord& operator=( const Mem0MemoryRecord& );

    friend class  Mem0MemoryRecordDelegate;
    friend class  Mem0MemoryRecordDispatch;
    friend class  Mem0MemoryRecordGenImpl;
};

#include <Mem0memmgt/libmem0memmgt_undef.h>
#endif //   CCDM__MEM0MEMORYRECORD__HXX
