//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mem0MemoryRecordDelegate
    Filename:   Mem0MemoryRecordDelegate.hxx
    Module:     Mem0memmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__MEM0MEMORYRECORDDELEGATE_HXX
#define CCDM__MEM0MEMORYRECORDDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Mem0memmgt/Mem0MemoryRecord.hxx>

#include <Mem0memmgt/libmem0memmgt_exports.h>

namespace ccdm
{
    class Mem0MemoryRecordDelegate;
}
namespace ccdm
{
    class Mem0MemoryRecordImpl;
}
namespace ccdm
{
    class Mem0MemoryRecord;
}
namespace ccdm
{
    class Mem0MemoryRecordGenImpl;
}

namespace ccdm_alias = ::ccdm;


class  MEM0MEMMGT_API ccdm_alias::Mem0MemoryRecordDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mem0MemoryRecordDelegate instance
    static Mem0MemoryRecordDelegate&  getInstance();

    //  Method to create the Mem0MemoryRecordImpl pointer
    static Mem0MemoryRecordImpl*  createImpl( Mem0MemoryRecord&  ifObj );

    //  Method to delete the Mem0MemoryRecordImpl pointer
    static void deleteImpl( Mem0MemoryRecordImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMem0OffsetAddrBase(const Mem0MemoryRecord &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMem0OffsetAddrBase(Mem0MemoryRecord &ifObj,  const std::string &value, bool isNull );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Mem0MemoryRecord &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Mem0MemoryRecordDelegate*  m_pInstance;

    Mem0MemoryRecordDelegate();
    virtual ~Mem0MemoryRecordDelegate();
    static void setInstance( Mem0MemoryRecordDelegate*  instance );


private:
    friend class  ::ccdm::Mem0MemoryRecordGenImpl;

};

#include <Mem0memmgt/libmem0memmgt_undef.h>
#endif  //  CCDM__MEM0MEMORYRECORDDELEGATE_HXX
