//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Osl0CMResourceAttrHelper
    Filename:   Osl0CMResourceAttrHelper.hxx
    Module:     Osl0lisoslc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef OSL0LISOSLC__OSL0CMRESOURCEATTRHELPER__HXX
#define OSL0LISOSLC__OSL0CMRESOURCEATTRHELPER__HXX

#include <common/tc_deprecation_macros.h>
#include <Osl0lisoslc/Osl0ResourceAttrHelper.hxx>

#include <Osl0lisoslc/libosl0lisoslc_exports.h>

namespace osl0lisoslc
{
    class Osl0CMResourceAttrHelper;
}
namespace osl0lisoslc
{
    class Osl0CMResourceAttrHelperImpl;
}
namespace osl0lisoslc
{
    class Osl0CMResourceAttrHelperDelegate;
}
namespace osl0lisoslc
{
    class Osl0CMResourceAttrHelperDispatch;
}
namespace osl0lisoslc
{
    class Osl0CMResourceAttrHelperGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  OSL0LISOSLC_API  osl0lisoslc::Osl0CMResourceAttrHelper
     : public  ::osl0lisoslc::Osl0ResourceAttrHelper
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Osl0CMResourceAttrHelper();

    /**
     * Destructor
     */
    virtual ~Osl0CMResourceAttrHelper();

private:
    //  Getter method for the Implementation Object
    Osl0CMResourceAttrHelperImpl*  getOsl0CMResourceAttrHelperImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setOsl0CMResourceAttrHelperImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Osl0CMResourceAttrHelperImpl*  m_osl0cmresourceattrhelperImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Osl0CMResourceAttrHelper - desc for Osl0CMResourceAttrHelper parameter
     */
    Osl0CMResourceAttrHelper( const Osl0CMResourceAttrHelper& );
    Osl0CMResourceAttrHelper& operator=( const Osl0CMResourceAttrHelper& );

    friend class  Osl0CMResourceAttrHelperDelegate;
    friend class  Osl0CMResourceAttrHelperDispatch;
    friend class  Osl0CMResourceAttrHelperGenImpl;
};

#include <Osl0lisoslc/libosl0lisoslc_undef.h>
#endif //   OSL0LISOSLC__OSL0CMRESOURCEATTRHELPER__HXX
