//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Osl0CMResourceAttrHelperDelegate
    Filename:   Osl0CMResourceAttrHelperDelegate.hxx
    Module:     Osl0lisoslc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef OSL0LISOSLC__OSL0CMRESOURCEATTRHELPERDELEGATE_HXX
#define OSL0LISOSLC__OSL0CMRESOURCEATTRHELPERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Osl0lisoslc/Osl0CMResourceAttrHelper.hxx>

#include <Osl0lisoslc/libosl0lisoslc_exports.h>

namespace osl0lisoslc
{
    class Osl0CMResourceAttrHelperDelegate;
}
namespace osl0lisoslc
{
    class Osl0CMResourceAttrHelperImpl;
}
namespace osl0lisoslc
{
    class Osl0CMResourceAttrHelper;
}
namespace osl0lisoslc
{
    class Osl0CMResourceAttrHelperGenImpl;
}

namespace osl0lisoslc_alias = ::osl0lisoslc;


class  OSL0LISOSLC_API osl0lisoslc_alias::Osl0CMResourceAttrHelperDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Osl0CMResourceAttrHelperDelegate instance
    static Osl0CMResourceAttrHelperDelegate&  getInstance();

    //  Method to create the Osl0CMResourceAttrHelperImpl pointer
    static Osl0CMResourceAttrHelperImpl*  createImpl( Osl0CMResourceAttrHelper&  ifObj );

    //  Method to delete the Osl0CMResourceAttrHelperImpl pointer
    static void deleteImpl( Osl0CMResourceAttrHelperImpl*  impl );


    ///
    /// collect the attributes of resource shape
    /// @version Teamcenter 10.1.4
    /// @param objTag - BO object
    /// @param boAttrMap - map holds the BO attributes
    /// @param relationMap - holds the relation attributes of Bo
    /// @param statusMap - hold the status of attributes
    /// @param compoundAttrsMap - holds the compund attributes of Bo
    /// @return - integer
    ///
    int  lis0collectAttributesBase(const Osl0CMResourceAttrHelper &ifObj,  tag_t objTag, lis0lisfmwrk::Lis0ResourceShapeAttributes **boAttrMap, lis0lisfmwrk::Lis0ResourceShapeAttributes **relationMap, lis0lisfmwrk::Lis0ResourceShapeAttributes **statusMap, lis0lisfmwrk::Lis0ResourceShapeAttributes **compoundAttrsMap ) const;


    ///
    /// Collects the resource shape attributes
    /// @version Teamcenter 11.2.3
    /// @param catalogIdentifier - Catalog Identifier
    /// @param resourceObjectType - Resource Object Type Tag
    /// @param resourceShapeAttributes - Structure that holds resource shape attributes
    /// @param relationMap - holds the relation attributes of Business object
    /// @return - returns ITK_ok on success, respective error on failure
    ///
    int  lis0collectSemanticAttributesBase(const Osl0CMResourceAttrHelper &ifObj,  const std::string &catalogIdentifier, const tag_t &resourceObjectType, lis0lisfmwrk::Lis0ResourceShapeAttributes **resourceShapeAttributes, lis0lisfmwrk::Lis0ResourceShapeAttributes **relationMap ) const;


    ///
    /// true/false return depending on the tag supported or not
    /// @version Teamcenter 10.1.4
    /// @param typeTag - checks the tag is in supported list or not
    /// @param isSupported - check the supported type is in supportes list or not
    /// @return - integer
    ///
    int  lis0isSuppportedTypeBase(const Osl0CMResourceAttrHelper &ifObj,  tag_t typeTag, bool *isSupported ) const;


    ///
    /// update
    /// @version Teamcenter 10.1.4
    /// @param objTag - holds the object
    /// @param boAttrMap - BOattributes
    /// @param resourceModel - abstractResourceModel
    /// @return - integer
    ///
    int  lis0updateBOAttributesBase(const Osl0CMResourceAttrHelper &ifObj,  tag_t objTag, lis0lisfmwrk::Lis0ResourceShapeAttributes *boAttrMap, lis0lisfmwrk::AbstractResource *resourceModel ) const;


    ///
    /// compoundAttributes
    /// @version Teamcenter 10.1.4
    /// @param objTag - Bo object
    /// @param compoundAttributesMap - holds the compund attributes of BO
    /// @param resourceModel - attribute of BO object
    /// @return - integer
    ///
    int  lis0updateCompundAttributesBase(const Osl0CMResourceAttrHelper &ifObj,  tag_t objTag, lis0lisfmwrk::Lis0ResourceShapeAttributes *compoundAttributesMap, lis0lisfmwrk::AbstractResource *resourceModel ) const;


    ///
    /// Relation
    /// @version Teamcenter 10.1.4
    /// @param objTag - BO object
    /// @param relationMap - holds the relation attribute
    /// @param resourceModel - BO Attribute
    /// @return - integer
    ///
    int  lis0updateRelationsBase(const Osl0CMResourceAttrHelper &ifObj,  tag_t objTag, lis0lisfmwrk::Lis0ResourceShapeAttributes *relationMap, lis0lisfmwrk::AbstractResource *resourceModel ) const;


    ///
    /// status
    /// @version Teamcenter 10.1.4
    /// @param objTag - BO object
    /// @param statusMap - holds the updated status
    /// @param resourceModel - holds the resource model attribute
    /// @return - integer
    ///
    int  lis0updateStatusBase(const Osl0CMResourceAttrHelper &ifObj,  tag_t objTag, lis0lisfmwrk::Lis0ResourceShapeAttributes *statusMap, lis0lisfmwrk::AbstractResource *resourceModel ) const;



protected:
    //  Pointer to the instance
    static Osl0CMResourceAttrHelperDelegate*  m_pInstance;

    Osl0CMResourceAttrHelperDelegate();
    virtual ~Osl0CMResourceAttrHelperDelegate();
    static void setInstance( Osl0CMResourceAttrHelperDelegate*  instance );


private:
    friend class  ::osl0lisoslc::Osl0CMResourceAttrHelperGenImpl;

};

#include <Osl0lisoslc/libosl0lisoslc_undef.h>
#endif  //  OSL0LISOSLC__OSL0CMRESOURCEATTRHELPERDELEGATE_HXX
