//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Osl0CatalogWriter
    Filename:   Osl0CatalogWriter.hxx
    Module:     Osl0lisoslc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef OSL0LISOSLC__OSL0CATALOGWRITER__HXX
#define OSL0LISOSLC__OSL0CATALOGWRITER__HXX

#include <common/tc_deprecation_macros.h>
#include <Lis0lisfmwrk/Lis0CatalogWriter.hxx>

#include <Osl0lisoslc/libosl0lisoslc_exports.h>

namespace osl0lisoslc
{
    class Osl0CatalogWriter;
}
namespace osl0lisoslc
{
    class Osl0CatalogWriterImpl;
}
namespace osl0lisoslc
{
    class Osl0CatalogWriterDelegate;
}
namespace osl0lisoslc
{
    class Osl0CatalogWriterDispatch;
}
namespace osl0lisoslc
{
    class Osl0CatalogWriterGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  OSL0LISOSLC_API  osl0lisoslc::Osl0CatalogWriter
     : public  ::lis0lisfmwrk::Lis0CatalogWriter
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Osl0CatalogWriter();

    /**
     * Destructor
     */
    virtual ~Osl0CatalogWriter();

private:
    //  Getter method for the Implementation Object
    Osl0CatalogWriterImpl*  getOsl0CatalogWriterImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setOsl0CatalogWriterImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Osl0CatalogWriterImpl*  m_osl0catalogwriterImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Osl0CatalogWriter - desc for Osl0CatalogWriter parameter
     */
    Osl0CatalogWriter( const Osl0CatalogWriter& );
    Osl0CatalogWriter& operator=( const Osl0CatalogWriter& );

    friend class  Osl0CatalogWriterDelegate;
    friend class  Osl0CatalogWriterDispatch;
    friend class  Osl0CatalogWriterGenImpl;
};

#include <Osl0lisoslc/libosl0lisoslc_undef.h>
#endif //   OSL0LISOSLC__OSL0CATALOGWRITER__HXX
