//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Osl0CompactRDFWriter
    Filename:   Osl0CompactRDFWriter.hxx
    Module:     Osl0lisoslc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef OSL0LISOSLC__OSL0COMPACTRDFWRITER__HXX
#define OSL0LISOSLC__OSL0COMPACTRDFWRITER__HXX

#include <common/tc_deprecation_macros.h>
#include <Lis0lisfmwrk/Lis0CompactRDFWriter.hxx>

#include <Osl0lisoslc/libosl0lisoslc_exports.h>

namespace osl0lisoslc
{
    class Osl0CompactRDFWriter;
}
namespace osl0lisoslc
{
    class Osl0CompactRDFWriterImpl;
}
namespace osl0lisoslc
{
    class Osl0CompactRDFWriterDelegate;
}
namespace osl0lisoslc
{
    class Osl0CompactRDFWriterDispatch;
}
namespace osl0lisoslc
{
    class Osl0CompactRDFWriterGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  OSL0LISOSLC_API  osl0lisoslc::Osl0CompactRDFWriter
     : public  ::lis0lisfmwrk::Lis0CompactRDFWriter
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Osl0CompactRDFWriter();

    /**
     * Destructor
     */
    virtual ~Osl0CompactRDFWriter();

private:
    //  Getter method for the Implementation Object
    Osl0CompactRDFWriterImpl*  getOsl0CompactRDFWriterImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setOsl0CompactRDFWriterImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Osl0CompactRDFWriterImpl*  m_osl0compactrdfwriterImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Osl0CompactRDFWriter - desc for Osl0CompactRDFWriter parameter
     */
    Osl0CompactRDFWriter( const Osl0CompactRDFWriter& );
    Osl0CompactRDFWriter& operator=( const Osl0CompactRDFWriter& );

    friend class  Osl0CompactRDFWriterDelegate;
    friend class  Osl0CompactRDFWriterDispatch;
    friend class  Osl0CompactRDFWriterGenImpl;
};

#include <Osl0lisoslc/libosl0lisoslc_undef.h>
#endif //   OSL0LISOSLC__OSL0COMPACTRDFWRITER__HXX
