//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Osl0CompactRDFWriterDelegate
    Filename:   Osl0CompactRDFWriterDelegate.hxx
    Module:     Osl0lisoslc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef OSL0LISOSLC__OSL0COMPACTRDFWRITERDELEGATE_HXX
#define OSL0LISOSLC__OSL0COMPACTRDFWRITERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Osl0lisoslc/Osl0CompactRDFWriter.hxx>

#include <Osl0lisoslc/libosl0lisoslc_exports.h>

namespace osl0lisoslc
{
    class Osl0CompactRDFWriterDelegate;
}
namespace osl0lisoslc
{
    class Osl0CompactRDFWriterImpl;
}
namespace osl0lisoslc
{
    class Osl0CompactRDFWriter;
}
namespace osl0lisoslc
{
    class Osl0CompactRDFWriterGenImpl;
}

namespace osl0lisoslc_alias = ::osl0lisoslc;


class  OSL0LISOSLC_API osl0lisoslc_alias::Osl0CompactRDFWriterDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Osl0CompactRDFWriterDelegate instance
    static Osl0CompactRDFWriterDelegate&  getInstance();

    //  Method to create the Osl0CompactRDFWriterImpl pointer
    static Osl0CompactRDFWriterImpl*  createImpl( Osl0CompactRDFWriter&  ifObj );

    //  Method to delete the Osl0CompactRDFWriterImpl pointer
    static void deleteImpl( Osl0CompactRDFWriterImpl*  impl );


    ///
    /// Create a resource model based on the input resource instance
    /// @version Teamcenter 10.1.4
    /// @param resourceTag - Resource instance
    /// @param inputTag - extra tag or parameter to pass
    /// @param resourceModel - populate the resource model
    /// @return - Error code. If successful, return 0.
    ///
    int  lis0CreateResourceModelBase(const Osl0CompactRDFWriter &ifObj,  tag_t resourceTag, tag_t inputTag, lis0lisfmwrk::AbstractResource **resourceModel ) const;


    ///
    /// Validate if it is supported to write based on the input resource instance
    /// @version Teamcenter 10.1.4
    /// @param resourceTag - Resource instance
    /// @param canWrite - Flag to indicate if it is supported to write based on the input resource instance
    /// @return - Error code. If successful, return 0.
    ///
    int  lis0IsWritableBase(const Osl0CompactRDFWriter &ifObj,  tag_t resourceTag, bool *canWrite ) const;



protected:
    //  Pointer to the instance
    static Osl0CompactRDFWriterDelegate*  m_pInstance;

    Osl0CompactRDFWriterDelegate();
    virtual ~Osl0CompactRDFWriterDelegate();
    static void setInstance( Osl0CompactRDFWriterDelegate*  instance );


private:
    friend class  ::osl0lisoslc::Osl0CompactRDFWriterGenImpl;

};

#include <Osl0lisoslc/libosl0lisoslc_undef.h>
#endif  //  OSL0LISOSLC__OSL0COMPACTRDFWRITERDELEGATE_HXX
