//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Osl0Link
    Filename:   Osl0Link.hxx
    Module:     Osl0lisoslc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef OSL0LISOSLC__OSL0LINK__HXX
#define OSL0LISOSLC__OSL0LINK__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <Lis0lisfmwrk/Lis0Link.hxx>

#include <Osl0lisoslc/libosl0lisoslc_exports.h>

namespace osl0lisoslc
{
    class Osl0Link;
}
namespace osl0lisoslc
{
    class Osl0LinkImpl;
}
namespace osl0lisoslc
{
    class Osl0LinkDelegate;
}
namespace osl0lisoslc
{
    class Osl0LinkDispatch;
}
namespace osl0lisoslc
{
    class Osl0LinkGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  OSL0LISOSLC_API  osl0lisoslc::Osl0Link
     : public  ::lis0lisfmwrk::Lis0Link
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getOsl0largePreviewUrl( std::string &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Osl0Link();

    /**
     * Destructor
     */
    virtual ~Osl0Link();

private:
    //  Getter method for the Implementation Object
    Osl0LinkImpl*  getOsl0LinkImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setOsl0LinkImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Osl0LinkImpl*  m_osl0linkImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Osl0Link - desc for Osl0Link parameter
     */
    Osl0Link( const Osl0Link& );
    Osl0Link& operator=( const Osl0Link& );

    friend class  Osl0LinkDelegate;
    friend class  Osl0LinkDispatch;
    friend class  Osl0LinkGenImpl;
};

#include <Osl0lisoslc/libosl0lisoslc_undef.h>
#endif //   OSL0LISOSLC__OSL0LINK__HXX
