//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Osl0LinkDelegate
    Filename:   Osl0LinkDelegate.hxx
    Module:     Osl0lisoslc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef OSL0LISOSLC__OSL0LINKDELEGATE_HXX
#define OSL0LISOSLC__OSL0LINKDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Osl0lisoslc/Osl0Link.hxx>

#include <Osl0lisoslc/libosl0lisoslc_exports.h>

namespace osl0lisoslc
{
    class Osl0LinkDelegate;
}
namespace osl0lisoslc
{
    class Osl0LinkImpl;
}
namespace osl0lisoslc
{
    class Osl0Link;
}
namespace osl0lisoslc
{
    class Osl0LinkGenImpl;
}

namespace osl0lisoslc_alias = ::osl0lisoslc;


class  OSL0LISOSLC_API osl0lisoslc_alias::Osl0LinkDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Osl0LinkDelegate instance
    static Osl0LinkDelegate&  getInstance();

    //  Method to create the Osl0LinkImpl pointer
    static Osl0LinkImpl*  createImpl( Osl0Link&  ifObj );

    //  Method to delete the Osl0LinkImpl pointer
    static void deleteImpl( Osl0LinkImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getOsl0largePreviewUrlBase(const Osl0Link &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// 
    /// @version Teamcenter 10.1.2
    /// @param linkURL - URL to indicate the resource link
    /// @param resourceInfo - Remote resource information
    /// @return - 
    ///
    int  lis0getResourceBase(const Osl0Link &ifObj,  const std::string *linkURL, ResourceInfo *resourceInfo );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Osl0Link &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Osl0LinkDelegate*  m_pInstance;

    Osl0LinkDelegate();
    virtual ~Osl0LinkDelegate();
    static void setInstance( Osl0LinkDelegate*  instance );


private:
    friend class  ::osl0lisoslc::Osl0LinkGenImpl;

};

#include <Osl0lisoslc/libosl0lisoslc_undef.h>
#endif  //  OSL0LISOSLC__OSL0LINKDELEGATE_HXX
