//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Osl0ProtocolWriter
    Filename:   Osl0ProtocolWriter.hxx
    Module:     Osl0lisoslc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef OSL0LISOSLC__OSL0PROTOCOLWRITER__HXX
#define OSL0LISOSLC__OSL0PROTOCOLWRITER__HXX

#include <common/tc_deprecation_macros.h>
#include <Lis0lisfmwrk/Lis0ProtocolWriter.hxx>

#include <Osl0lisoslc/libosl0lisoslc_exports.h>

namespace osl0lisoslc
{
    class Osl0ProtocolWriter;
}
namespace osl0lisoslc
{
    class Osl0ProtocolWriterImpl;
}
namespace osl0lisoslc
{
    class Osl0ProtocolWriterDelegate;
}
namespace osl0lisoslc
{
    class Osl0ProtocolWriterDispatch;
}
namespace osl0lisoslc
{
    class Osl0ProtocolWriterGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  OSL0LISOSLC_API  osl0lisoslc::Osl0ProtocolWriter
     : public  ::lis0lisfmwrk::Lis0ProtocolWriter
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Osl0ProtocolWriter();

    /**
     * Destructor
     */
    virtual ~Osl0ProtocolWriter();

private:
    //  Getter method for the Implementation Object
    Osl0ProtocolWriterImpl*  getOsl0ProtocolWriterImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setOsl0ProtocolWriterImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Osl0ProtocolWriterImpl*  m_osl0protocolwriterImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Osl0ProtocolWriter - desc for Osl0ProtocolWriter parameter
     */
    Osl0ProtocolWriter( const Osl0ProtocolWriter& );
    Osl0ProtocolWriter& operator=( const Osl0ProtocolWriter& );

    friend class  Osl0ProtocolWriterDelegate;
    friend class  Osl0ProtocolWriterDispatch;
    friend class  Osl0ProtocolWriterGenImpl;
};

#include <Osl0lisoslc/libosl0lisoslc_undef.h>
#endif //   OSL0LISOSLC__OSL0PROTOCOLWRITER__HXX
