//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Osl0ProtocolWriterDelegate
    Filename:   Osl0ProtocolWriterDelegate.hxx
    Module:     Osl0lisoslc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef OSL0LISOSLC__OSL0PROTOCOLWRITERDELEGATE_HXX
#define OSL0LISOSLC__OSL0PROTOCOLWRITERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Osl0lisoslc/Osl0ProtocolWriter.hxx>

#include <Osl0lisoslc/libosl0lisoslc_exports.h>

namespace osl0lisoslc
{
    class Osl0ProtocolWriterDelegate;
}
namespace osl0lisoslc
{
    class Osl0ProtocolWriterImpl;
}
namespace osl0lisoslc
{
    class Osl0ProtocolWriter;
}
namespace osl0lisoslc
{
    class Osl0ProtocolWriterGenImpl;
}

namespace osl0lisoslc_alias = ::osl0lisoslc;


class  OSL0LISOSLC_API osl0lisoslc_alias::Osl0ProtocolWriterDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Osl0ProtocolWriterDelegate instance
    static Osl0ProtocolWriterDelegate&  getInstance();

    //  Method to create the Osl0ProtocolWriterImpl pointer
    static Osl0ProtocolWriterImpl*  createImpl( Osl0ProtocolWriter&  ifObj );

    //  Method to delete the Osl0ProtocolWriterImpl pointer
    static void deleteImpl( Osl0ProtocolWriterImpl*  impl );


    ///
    /// Create a resource model based on the input resource instance
    /// @version Teamcenter 10.1.4
    /// @param resourceTag - Resource instance
    /// @param inputTag - extra tag or parameter to pass
    /// @param resourceModel - populate the resource model
    /// @return - Error code. If successful, return 0.
    ///
    int  lis0CreateResourceModelBase(const Osl0ProtocolWriter &ifObj,  tag_t resourceTag, tag_t inputTag, lis0lisfmwrk::AbstractResource **resourceModel ) const;


    ///
    /// Validate if it is supported to write based on the input resource instance
    /// @version Teamcenter 10.1.4
    /// @param resourceTag - Resource instance
    /// @param canWrite - Flag to indicate if it is supported to write based on the input resource instance
    /// @return - Error code. If successful, return 0.
    ///
    int  lis0IsWritableBase(const Osl0ProtocolWriter &ifObj,  tag_t resourceTag, bool *canWrite ) const;



protected:
    //  Pointer to the instance
    static Osl0ProtocolWriterDelegate*  m_pInstance;

    Osl0ProtocolWriterDelegate();
    virtual ~Osl0ProtocolWriterDelegate();
    static void setInstance( Osl0ProtocolWriterDelegate*  instance );


private:
    friend class  ::osl0lisoslc::Osl0ProtocolWriterGenImpl;

};

#include <Osl0lisoslc/libosl0lisoslc_undef.h>
#endif  //  OSL0LISOSLC__OSL0PROTOCOLWRITERDELEGATE_HXX
