//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Osl0ProviderWriter
    Filename:   Osl0ProviderWriter.hxx
    Module:     Osl0lisoslc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef OSL0LISOSLC__OSL0PROVIDERWRITER__HXX
#define OSL0LISOSLC__OSL0PROVIDERWRITER__HXX

#include <common/tc_deprecation_macros.h>
#include <Lis0lisfmwrk/Lis0ProviderWriter.hxx>

#include <Osl0lisoslc/libosl0lisoslc_exports.h>

namespace osl0lisoslc
{
    class Osl0ProviderWriter;
}
namespace osl0lisoslc
{
    class Osl0ProviderWriterImpl;
}
namespace osl0lisoslc
{
    class Osl0ProviderWriterDelegate;
}
namespace osl0lisoslc
{
    class Osl0ProviderWriterDispatch;
}
namespace osl0lisoslc
{
    class Osl0ProviderWriterGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  OSL0LISOSLC_API  osl0lisoslc::Osl0ProviderWriter
     : public  ::lis0lisfmwrk::Lis0ProviderWriter
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Osl0ProviderWriter();

    /**
     * Destructor
     */
    virtual ~Osl0ProviderWriter();

private:
    //  Getter method for the Implementation Object
    Osl0ProviderWriterImpl*  getOsl0ProviderWriterImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setOsl0ProviderWriterImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Osl0ProviderWriterImpl*  m_osl0providerwriterImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Osl0ProviderWriter - desc for Osl0ProviderWriter parameter
     */
    Osl0ProviderWriter( const Osl0ProviderWriter& );
    Osl0ProviderWriter& operator=( const Osl0ProviderWriter& );

    friend class  Osl0ProviderWriterDelegate;
    friend class  Osl0ProviderWriterDispatch;
    friend class  Osl0ProviderWriterGenImpl;
};

#include <Osl0lisoslc/libosl0lisoslc_undef.h>
#endif //   OSL0LISOSLC__OSL0PROVIDERWRITER__HXX
