//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Osl0ResourceAttrHelper
    Filename:   Osl0ResourceAttrHelper.hxx
    Module:     Osl0lisoslc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef OSL0LISOSLC__OSL0RESOURCEATTRHELPER__HXX
#define OSL0LISOSLC__OSL0RESOURCEATTRHELPER__HXX

#include <common/tc_deprecation_macros.h>
#include <Lis0lisfmwrk/Lis0ResourceAttrHelper.hxx>

#include <Osl0lisoslc/libosl0lisoslc_exports.h>

namespace osl0lisoslc
{
    class Osl0ResourceAttrHelper;
}
namespace osl0lisoslc
{
    class Osl0ResourceAttrHelperImpl;
}
namespace osl0lisoslc
{
    class Osl0ResourceAttrHelperDelegate;
}
namespace osl0lisoslc
{
    class Osl0ResourceAttrHelperDispatch;
}
namespace osl0lisoslc
{
    class Osl0ResourceAttrHelperGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  OSL0LISOSLC_API  osl0lisoslc::Osl0ResourceAttrHelper
     : public  ::lis0lisfmwrk::Lis0ResourceAttrHelper
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Osl0ResourceAttrHelper();

    /**
     * Destructor
     */
    virtual ~Osl0ResourceAttrHelper();

private:
    //  Getter method for the Implementation Object
    Osl0ResourceAttrHelperImpl*  getOsl0ResourceAttrHelperImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setOsl0ResourceAttrHelperImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Osl0ResourceAttrHelperImpl*  m_osl0resourceattrhelperImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Osl0ResourceAttrHelper - desc for Osl0ResourceAttrHelper parameter
     */
    Osl0ResourceAttrHelper( const Osl0ResourceAttrHelper& );
    Osl0ResourceAttrHelper& operator=( const Osl0ResourceAttrHelper& );

    friend class  Osl0ResourceAttrHelperDelegate;
    friend class  Osl0ResourceAttrHelperDispatch;
    friend class  Osl0ResourceAttrHelperGenImpl;
};

#include <Osl0lisoslc/libosl0lisoslc_undef.h>
#endif //   OSL0LISOSLC__OSL0RESOURCEATTRHELPER__HXX
