//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Osl0ResourceShapeWriter
    Filename:   Osl0ResourceShapeWriter.hxx
    Module:     Osl0lisoslc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef OSL0LISOSLC__OSL0RESOURCESHAPEWRITER__HXX
#define OSL0LISOSLC__OSL0RESOURCESHAPEWRITER__HXX

#include <common/tc_deprecation_macros.h>
#include <Lis0lisfmwrk/Lis0ResourceShapeWriter.hxx>

#include <Osl0lisoslc/libosl0lisoslc_exports.h>

namespace osl0lisoslc
{
    class Osl0ResourceShapeWriter;
}
namespace osl0lisoslc
{
    class Osl0ResourceShapeWriterImpl;
}
namespace osl0lisoslc
{
    class Osl0ResourceShapeWriterDelegate;
}
namespace osl0lisoslc
{
    class Osl0ResourceShapeWriterDispatch;
}
namespace osl0lisoslc
{
    class Osl0ResourceShapeWriterGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  OSL0LISOSLC_API  osl0lisoslc::Osl0ResourceShapeWriter
     : public  ::lis0lisfmwrk::Lis0ResourceShapeWriter
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Osl0ResourceShapeWriter();

    /**
     * Destructor
     */
    virtual ~Osl0ResourceShapeWriter();

private:
    //  Getter method for the Implementation Object
    Osl0ResourceShapeWriterImpl*  getOsl0ResourceShapeWriterImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setOsl0ResourceShapeWriterImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Osl0ResourceShapeWriterImpl*  m_osl0resourceshapewriterImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Osl0ResourceShapeWriter - desc for Osl0ResourceShapeWriter parameter
     */
    Osl0ResourceShapeWriter( const Osl0ResourceShapeWriter& );
    Osl0ResourceShapeWriter& operator=( const Osl0ResourceShapeWriter& );

    friend class  Osl0ResourceShapeWriterDelegate;
    friend class  Osl0ResourceShapeWriterDispatch;
    friend class  Osl0ResourceShapeWriterGenImpl;
};

#include <Osl0lisoslc/libosl0lisoslc_undef.h>
#endif //   OSL0LISOSLC__OSL0RESOURCESHAPEWRITER__HXX
