//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Osl0ServiceProvider
    Filename:   Osl0ServiceProvider.hxx
    Module:     Osl0lisoslc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef OSL0LISOSLC__OSL0SERVICEPROVIDER__HXX
#define OSL0LISOSLC__OSL0SERVICEPROVIDER__HXX

#include <common/tc_deprecation_macros.h>
#include <Lis0lisfmwrk/Lis0ServiceProvider.hxx>

#include <Osl0lisoslc/libosl0lisoslc_exports.h>

namespace osl0lisoslc
{
    class Osl0ServiceProvider;
}
namespace osl0lisoslc
{
    class Osl0ServiceProviderImpl;
}
namespace osl0lisoslc
{
    class Osl0ServiceProviderDelegate;
}
namespace osl0lisoslc
{
    class Osl0ServiceProviderDispatch;
}
namespace osl0lisoslc
{
    class Osl0ServiceProviderGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  OSL0LISOSLC_API  osl0lisoslc::Osl0ServiceProvider
     : public  ::lis0lisfmwrk::Lis0ServiceProvider
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Osl0ServiceProvider();

    /**
     * Destructor
     */
    virtual ~Osl0ServiceProvider();

private:
    //  Getter method for the Implementation Object
    Osl0ServiceProviderImpl*  getOsl0ServiceProviderImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setOsl0ServiceProviderImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Osl0ServiceProviderImpl*  m_osl0serviceproviderImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Osl0ServiceProvider - desc for Osl0ServiceProvider parameter
     */
    Osl0ServiceProvider( const Osl0ServiceProvider& );
    Osl0ServiceProvider& operator=( const Osl0ServiceProvider& );

    friend class  Osl0ServiceProviderDelegate;
    friend class  Osl0ServiceProviderDispatch;
    friend class  Osl0ServiceProviderGenImpl;
};

#include <Osl0lisoslc/libosl0lisoslc_undef.h>
#endif //   OSL0LISOSLC__OSL0SERVICEPROVIDER__HXX
