//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Osl0ServiceProviderDelegate
    Filename:   Osl0ServiceProviderDelegate.hxx
    Module:     Osl0lisoslc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef OSL0LISOSLC__OSL0SERVICEPROVIDERDELEGATE_HXX
#define OSL0LISOSLC__OSL0SERVICEPROVIDERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Osl0lisoslc/Osl0ServiceProvider.hxx>

#include <Osl0lisoslc/libosl0lisoslc_exports.h>

namespace osl0lisoslc
{
    class Osl0ServiceProviderDelegate;
}
namespace osl0lisoslc
{
    class Osl0ServiceProviderImpl;
}
namespace osl0lisoslc
{
    class Osl0ServiceProvider;
}
namespace osl0lisoslc
{
    class Osl0ServiceProviderGenImpl;
}

namespace osl0lisoslc_alias = ::osl0lisoslc;


class  OSL0LISOSLC_API osl0lisoslc_alias::Osl0ServiceProviderDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Osl0ServiceProviderDelegate instance
    static Osl0ServiceProviderDelegate&  getInstance();

    //  Method to create the Osl0ServiceProviderImpl pointer
    static Osl0ServiceProviderImpl*  createImpl( Osl0ServiceProvider&  ifObj );

    //  Method to delete the Osl0ServiceProviderImpl pointer
    static void deleteImpl( Osl0ServiceProviderImpl*  impl );


    ///
    /// Get all provider service list
    /// @version Teamcenter 10.1.2
    /// @param providerURL - URL to indicate the service provider
    /// @param responseInfo - Output of the parse http response
    /// @return - Return the status as Integer
    ///
    int  lis0getProviderServicesBase(const Osl0ServiceProvider &ifObj,  const std::string *providerURL, ServiceResponseInfo *responseInfo );


    ///
    /// 
    /// @version Teamcenter 11.3
    /// @param providerURL - URL to indicate the service provider
    /// @param responseInfo - Output of the parse http response
    /// @return - 
    ///
    int  lis0getProviderServicesBase(const Osl0ServiceProvider &ifObj,  const std::string *providerURL, ServiceResponseInfoExtend *responseInfo );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Osl0ServiceProvider &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Osl0ServiceProviderDelegate*  m_pInstance;

    Osl0ServiceProviderDelegate();
    virtual ~Osl0ServiceProviderDelegate();
    static void setInstance( Osl0ServiceProviderDelegate*  instance );


private:
    friend class  ::osl0lisoslc::Osl0ServiceProviderGenImpl;

};

#include <Osl0lisoslc/libosl0lisoslc_undef.h>
#endif  //  OSL0LISOSLC__OSL0SERVICEPROVIDERDELEGATE_HXX
