//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Osl0Site
    Filename:   Osl0Site.hxx
    Module:     Osl0lisoslc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef OSL0LISOSLC__OSL0SITE__HXX
#define OSL0LISOSLC__OSL0SITE__HXX

#include <common/tc_deprecation_macros.h>
#include <Lis0lisfmwrk/Lis0Site.hxx>

#include <Osl0lisoslc/libosl0lisoslc_exports.h>

namespace osl0lisoslc
{
    class Osl0Site;
}
namespace osl0lisoslc
{
    class Osl0SiteImpl;
}
namespace osl0lisoslc
{
    class Osl0SiteDelegate;
}
namespace osl0lisoslc
{
    class Osl0SiteDispatch;
}
namespace osl0lisoslc
{
    class Osl0SiteGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  OSL0LISOSLC_API  osl0lisoslc::Osl0Site
     : public  ::lis0lisfmwrk::Lis0Site
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Osl0Site();

    /**
     * Destructor
     */
    virtual ~Osl0Site();

private:
    //  Getter method for the Implementation Object
    Osl0SiteImpl*  getOsl0SiteImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setOsl0SiteImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Osl0SiteImpl*  m_osl0siteImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Osl0Site - desc for Osl0Site parameter
     */
    Osl0Site( const Osl0Site& );
    Osl0Site& operator=( const Osl0Site& );

    friend class  Osl0SiteDelegate;
    friend class  Osl0SiteDispatch;
    friend class  Osl0SiteGenImpl;
};

#include <Osl0lisoslc/libosl0lisoslc_undef.h>
#endif //   OSL0LISOSLC__OSL0SITE__HXX
