//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Osl0SiteDelegate
    Filename:   Osl0SiteDelegate.hxx
    Module:     Osl0lisoslc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef OSL0LISOSLC__OSL0SITEDELEGATE_HXX
#define OSL0LISOSLC__OSL0SITEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Osl0lisoslc/Osl0Site.hxx>

#include <Osl0lisoslc/libosl0lisoslc_exports.h>

namespace osl0lisoslc
{
    class Osl0SiteDelegate;
}
namespace osl0lisoslc
{
    class Osl0SiteImpl;
}
namespace osl0lisoslc
{
    class Osl0Site;
}
namespace osl0lisoslc
{
    class Osl0SiteGenImpl;
}

namespace osl0lisoslc_alias = ::osl0lisoslc;


class  OSL0LISOSLC_API osl0lisoslc_alias::Osl0SiteDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Osl0SiteDelegate instance
    static Osl0SiteDelegate&  getInstance();

    //  Method to create the Osl0SiteImpl pointer
    static Osl0SiteImpl*  createImpl( Osl0Site&  ifObj );

    //  Method to delete the Osl0SiteImpl pointer
    static void deleteImpl( Osl0SiteImpl*  impl );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Osl0Site &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Get all remote service provider list
    /// @version Teamcenter 10.1.2
    /// @param catalogInfo - Service provider catalog infomation
    /// @param providers - Remote service provider vector
    /// @return - Return the status as Integer
    ///
    int  lis0getRemoteServiceProvidersBase(const Osl0Site &ifObj,  const ServiceProviderCatalogInfo *catalogInfo, std::vector< tag_t > *providers );


    ///
    /// 
    /// @version Teamcenter 11.3
    /// @param catalogInfo - Output of catalog from rootservices
    /// @param providers - list of provider from catalog
    /// @return - 
    ///
    int  lis0getRemoteServiceProvidersBase(const Osl0Site &ifObj,  ServiceProviderCatalogInfoExtend *catalogInfo, std::vector< tag_t > *providers );


    ///
    /// Get all service provider catalog list
    /// @version Teamcenter 10.1.2
    /// @param rootServiceURL - URL to indicate the root service
    /// @param responseInfo - Output of the parse http response
    /// @return - Return the status as Integer
    ///
    int  lis0getServiceProviderCatalogsBase(const Osl0Site &ifObj,  const std::string *rootServiceURL, RootServiceResponseInfo *responseInfo );


    ///
    /// 
    /// @version Teamcenter 11.3
    /// @param rootServiceURL - rootServiceURL
    /// @param responseInfo - response of root services request
    /// @return - 
    ///
    int  lis0getServiceProviderCatalogsBase(const Osl0Site &ifObj,  std::string *rootServiceURL, RootServiceResponseExtend *responseInfo );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Osl0Site &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Osl0SiteDelegate*  m_pInstance;

    Osl0SiteDelegate();
    virtual ~Osl0SiteDelegate();
    static void setInstance( Osl0SiteDelegate*  instance );


private:
    friend class  ::osl0lisoslc::Osl0SiteGenImpl;

};

#include <Osl0lisoslc/libosl0lisoslc_undef.h>
#endif  //  OSL0LISOSLC__OSL0SITEDELEGATE_HXX
