//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Pdg0Admissibility
    Filename:   Pdg0Admissibility.hxx
    Module:     Pdg0ptndesigngdlines
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PDG0PTNDESIGNGDLINES__PDG0ADMISSIBILITY__HXX
#define TEAMCENTER__PDG0PTNDESIGNGDLINES__PDG0ADMISSIBILITY__HXX

#include <common/tc_deprecation_macros.h>
#include <Cfg0configurator/Cfg0AbsAdmissibility.hxx>

#include <Pdg0ptndesigngdlines/libpdg0ptndesigngdlines_exports.h>

namespace Teamcenter
{
    namespace Pdg0ptndesigngdlines
    {
        class Pdg0Admissibility;
    }
}
namespace Teamcenter
{
    namespace Pdg0ptndesigngdlines
    {
        class Pdg0AdmissibilityImpl;
    }
}
namespace Teamcenter
{
    namespace Pdg0ptndesigngdlines
    {
        class Pdg0AdmissibilityDelegate;
    }
}
namespace Teamcenter
{
    namespace Pdg0ptndesigngdlines
    {
        class Pdg0AdmissibilityDispatch;
    }
}
namespace Teamcenter
{
    namespace Pdg0ptndesigngdlines
    {
        class Pdg0AdmissibilityGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PDG0PTNDESIGNGDLINES_API  Teamcenter::Pdg0ptndesigngdlines::Pdg0Admissibility
     : public  ::Teamcenter::Cfg0configurator::Cfg0AbsAdmissibility
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Pdg0Admissibility();

    /**
     * Destructor
     */
    virtual ~Pdg0Admissibility();

private:
    //  Getter method for the Implementation Object
    Pdg0AdmissibilityImpl*  getPdg0AdmissibilityImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPdg0AdmissibilityImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Pdg0AdmissibilityImpl*  m_pdg0admissibilityImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Pdg0Admissibility - desc for Pdg0Admissibility parameter
     */
    Pdg0Admissibility( const Pdg0Admissibility& );
    Pdg0Admissibility& operator=( const Pdg0Admissibility& );

    friend class  Pdg0AdmissibilityDelegate;
    friend class  Pdg0AdmissibilityDispatch;
    friend class  Pdg0AdmissibilityGenImpl;
};

#include <Pdg0ptndesigngdlines/libpdg0ptndesigngdlines_undef.h>
#endif //   TEAMCENTER__PDG0PTNDESIGNGDLINES__PDG0ADMISSIBILITY__HXX
