//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Pdg0AdmissibilityDelegate
    Filename:   Pdg0AdmissibilityDelegate.hxx
    Module:     Pdg0ptndesigngdlines
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PDG0PTNDESIGNGDLINES__PDG0ADMISSIBILITYDELEGATE_HXX
#define TEAMCENTER__PDG0PTNDESIGNGDLINES__PDG0ADMISSIBILITYDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Pdg0ptndesigngdlines/Pdg0Admissibility.hxx>

#include <Pdg0ptndesigngdlines/libpdg0ptndesigngdlines_exports.h>

namespace Teamcenter
{
    namespace Pdg0ptndesigngdlines
    {
        class Pdg0AdmissibilityDelegate;
    }
}
namespace Teamcenter
{
    namespace Pdg0ptndesigngdlines
    {
        class Pdg0AdmissibilityImpl;
    }
}
namespace Teamcenter
{
    namespace Pdg0ptndesigngdlines
    {
        class Pdg0Admissibility;
    }
}
namespace Teamcenter
{
    namespace Pdg0ptndesigngdlines
    {
        class Pdg0AdmissibilityGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  PDG0PTNDESIGNGDLINES_API Teamcenter_alias::Pdg0ptndesigngdlines::Pdg0AdmissibilityDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Pdg0AdmissibilityDelegate instance
    static Pdg0AdmissibilityDelegate&  getInstance();

    //  Method to create the Pdg0AdmissibilityImpl pointer
    static Pdg0AdmissibilityImpl*  createImpl( Pdg0Admissibility&  ifObj );

    //  Method to delete the Pdg0AdmissibilityImpl pointer
    static void deleteImpl( Pdg0AdmissibilityImpl*  impl );


    ///
    /// Operation to update the admissibility state and revise admissibility if needed.
    /// @version Teamcenter 10.1.3
    /// @param admissibilityState - input admissibilitystate
    /// @param context - The input context for which admissibility is to be updated
    /// @param outputAdmissibility - newly created/ updated admissibility object
    /// @param objectsToDelete - Output paramter to return the objects to be deleted when admissibility state to be updated is empty.
    /// @return - Returns iFail.
    ///
    int  cfg0UpdateAdmissibilityBase(const Pdg0Admissibility &ifObj,  const std::string *admissibilityState, const ::Teamcenter::POM_object *context, tag_t *outputAdmissibility, std::vector< tag_t > *objectsToDelete );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Pdg0Admissibility &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Pdg0Admissibility &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Pdg0AdmissibilityDelegate*  m_pInstance;

    Pdg0AdmissibilityDelegate();
    virtual ~Pdg0AdmissibilityDelegate();
    static void setInstance( Pdg0AdmissibilityDelegate*  instance );


private:
    friend class  ::Teamcenter::Pdg0ptndesigngdlines::Pdg0AdmissibilityGenImpl;

};

#include <Pdg0ptndesigngdlines/libpdg0ptndesigngdlines_undef.h>
#endif  //  TEAMCENTER__PDG0PTNDESIGNGDLINES__PDG0ADMISSIBILITYDELEGATE_HXX
