//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Pmi0PMIAuthoringRel
    Filename:   Pmi0PMIAuthoringRel.hxx
    Module:     Pmi0pmi
    @BMIDE autogenerated
==================================================================================================*/

#ifndef PMI__PMI0PMIAUTHORINGREL__HXX
#define PMI__PMI0PMIAUTHORINGREL__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <Pmi0pmi/libpmi0pmi_exports.h>

namespace pmi
{
    class Pmi0PMIAuthoringRel;
}
namespace pmi
{
    class Pmi0PMIAuthoringRelImpl;
}
namespace pmi
{
    class Pmi0PMIAuthoringRelDelegate;
}
namespace pmi
{
    class Pmi0PMIAuthoringRelDispatch;
}
namespace pmi
{
    class Pmi0PMIAuthoringRelGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PMI0PMI_API  pmi::Pmi0PMIAuthoringRel
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Pmi0PMIAuthoringRel();

    /**
     * Destructor
     */
    virtual ~Pmi0PMIAuthoringRel();

private:
    //  Getter method for the Implementation Object
    Pmi0PMIAuthoringRelImpl*  getPmi0PMIAuthoringRelImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPmi0PMIAuthoringRelImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Pmi0PMIAuthoringRelImpl*  m_pmi0pmiauthoringrelImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Pmi0PMIAuthoringRel - desc for Pmi0PMIAuthoringRel parameter
     */
    Pmi0PMIAuthoringRel( const Pmi0PMIAuthoringRel& );
    Pmi0PMIAuthoringRel& operator=( const Pmi0PMIAuthoringRel& );

    friend class  Pmi0PMIAuthoringRelDelegate;
    friend class  Pmi0PMIAuthoringRelDispatch;
    friend class  Pmi0PMIAuthoringRelGenImpl;
};

#include <Pmi0pmi/libpmi0pmi_undef.h>
#endif //   PMI__PMI0PMIAUTHORINGREL__HXX
