//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Pmi0PMIDefinitionRel
    Filename:   Pmi0PMIDefinitionRel.hxx
    Module:     Pmi0pmi
    @BMIDE autogenerated
==================================================================================================*/

#ifndef PMI__PMI0PMIDEFINITIONREL__HXX
#define PMI__PMI0PMIDEFINITIONREL__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <Pmi0pmi/libpmi0pmi_exports.h>

namespace pmi
{
    class Pmi0PMIDefinitionRel;
}
namespace pmi
{
    class Pmi0PMIDefinitionRelImpl;
}
namespace pmi
{
    class Pmi0PMIDefinitionRelDelegate;
}
namespace pmi
{
    class Pmi0PMIDefinitionRelDispatch;
}
namespace pmi
{
    class Pmi0PMIDefinitionRelGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PMI0PMI_API  pmi::Pmi0PMIDefinitionRel
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Pmi0PMIDefinitionRel();

    /**
     * Destructor
     */
    virtual ~Pmi0PMIDefinitionRel();

private:
    //  Getter method for the Implementation Object
    Pmi0PMIDefinitionRelImpl*  getPmi0PMIDefinitionRelImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPmi0PMIDefinitionRelImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Pmi0PMIDefinitionRelImpl*  m_pmi0pmidefinitionrelImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Pmi0PMIDefinitionRel - desc for Pmi0PMIDefinitionRel parameter
     */
    Pmi0PMIDefinitionRel( const Pmi0PMIDefinitionRel& );
    Pmi0PMIDefinitionRel& operator=( const Pmi0PMIDefinitionRel& );

    friend class  Pmi0PMIDefinitionRelDelegate;
    friend class  Pmi0PMIDefinitionRelDispatch;
    friend class  Pmi0PMIDefinitionRelGenImpl;
};

#include <Pmi0pmi/libpmi0pmi_undef.h>
#endif //   PMI__PMI0PMIDEFINITIONREL__HXX
