//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PnM0Penetration
    Filename:   PnM0Penetration.hxx
    Module:     PnM0penetration
    @BMIDE autogenerated
==================================================================================================*/

#ifndef PENETRATIONMGMT__PNM0PENETRATION__HXX
#define PENETRATIONMGMT__PNM0PENETRATION__HXX

#include <common/tc_deprecation_macros.h>
#include <issuemgmt/IssueReport.hxx>

#include <PnM0penetration/libpnm0penetration_exports.h>

namespace penetrationmgmt
{
    class PnM0Penetration;
}
namespace penetrationmgmt
{
    class PnM0PenetrationImpl;
}
namespace penetrationmgmt
{
    class PnM0PenetrationDelegate;
}
namespace penetrationmgmt
{
    class PnM0PenetrationDispatch;
}
namespace penetrationmgmt
{
    class PnM0PenetrationGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PNM0PENETRATION_API  penetrationmgmt::PnM0Penetration
     : public  ::Teamcenter::issuemgmt::IssueReport
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PnM0Penetration();

    /**
     * Destructor
     */
    virtual ~PnM0Penetration();

private:
    //  Getter method for the Implementation Object
    PnM0PenetrationImpl*  getPnM0PenetrationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPnM0PenetrationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PnM0PenetrationImpl*  m_pnm0penetrationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PnM0Penetration - desc for PnM0Penetration parameter
     */
    PnM0Penetration( const PnM0Penetration& );
    PnM0Penetration& operator=( const PnM0Penetration& );

    friend class  PnM0PenetrationDelegate;
    friend class  PnM0PenetrationDispatch;
    friend class  PnM0PenetrationGenImpl;
};

#include <PnM0penetration/libpnm0penetration_undef.h>
#endif //   PENETRATIONMGMT__PNM0PENETRATION__HXX
