//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PnM0PenetrationRevisionDelegate
    Filename:   PnM0PenetrationRevisionDelegate.hxx
    Module:     PnM0penetration
    @BMIDE autogenerated
==================================================================================================*/

#ifndef PENETRATIONMGMT__PNM0PENETRATIONREVISIONDELEGATE_HXX
#define PENETRATIONMGMT__PNM0PENETRATIONREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <PnM0penetration/PnM0PenetrationRevision.hxx>

#include <PnM0penetration/libpnm0penetration_exports.h>

namespace penetrationmgmt
{
    class PnM0PenetrationRevisionDelegate;
}
namespace penetrationmgmt
{
    class PnM0PenetrationRevisionImpl;
}
namespace penetrationmgmt
{
    class PnM0PenetrationRevision;
}
namespace penetrationmgmt
{
    class PnM0PenetrationRevisionGenImpl;
}

namespace penetrationmgmt_alias = ::penetrationmgmt;


class  PNM0PENETRATION_API penetrationmgmt_alias::PnM0PenetrationRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PnM0PenetrationRevisionDelegate instance
    static PnM0PenetrationRevisionDelegate&  getInstance();

    //  Method to create the PnM0PenetrationRevisionImpl pointer
    static PnM0PenetrationRevisionImpl*  createImpl( PnM0PenetrationRevision&  ifObj );

    //  Method to delete the PnM0PenetrationRevisionImpl pointer
    static void deleteImpl( PnM0PenetrationRevisionImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPnm0Compensation_typeBase(const PnM0PenetrationRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPnm0Cut_across_erection_brkBase(const PnM0PenetrationRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPnm0Hole_cut_directionBase(const PnM0PenetrationRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPnm0Hole_cut_face_handleBase(const PnM0PenetrationRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPnm0Hole_cut_feature_handleBase(const PnM0PenetrationRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPnm0Hole_cut_statusBase(const PnM0PenetrationRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPnm0Hole_cut_typeBase(const PnM0PenetrationRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPnm0Penetration_typeBase(const PnM0PenetrationRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPnm0Routing_segment_handleBase(const PnM0PenetrationRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPnm0Spill_coaming_requiredBase(const PnM0PenetrationRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPnm0Structural_mfg_statusBase(const PnM0PenetrationRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPnm0Compensation_typeBase(PnM0PenetrationRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPnm0Cut_across_erection_brkBase(PnM0PenetrationRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPnm0Hole_cut_directionBase(PnM0PenetrationRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPnm0Hole_cut_face_handleBase(PnM0PenetrationRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPnm0Hole_cut_feature_handleBase(PnM0PenetrationRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPnm0Hole_cut_statusBase(PnM0PenetrationRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPnm0Hole_cut_typeBase(PnM0PenetrationRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPnm0Penetration_typeBase(PnM0PenetrationRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPnm0Routing_segment_handleBase(PnM0PenetrationRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPnm0Spill_coaming_requiredBase(PnM0PenetrationRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPnm0Structural_mfg_statusBase(PnM0PenetrationRevision &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static PnM0PenetrationRevisionDelegate*  m_pInstance;

    PnM0PenetrationRevisionDelegate();
    virtual ~PnM0PenetrationRevisionDelegate();
    static void setInstance( PnM0PenetrationRevisionDelegate*  instance );


private:
    friend class  ::penetrationmgmt::PnM0PenetrationRevisionGenImpl;

};

#include <PnM0penetration/libpnm0penetration_undef.h>
#endif  //  PENETRATIONMGMT__PNM0PENETRATIONREVISIONDELEGATE_HXX
