//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//e
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Qc0CharacteristicsGroup
    Filename:   Qc0CharacteristicsGroup.hxx
    Module:     Qc0qualitybase
    @BMIDE autogenerated
==================================================================================================*/

#ifndef QC0QUALITYCENTERBASE__QC0CHARACTERISTICSGROUP__HXX
#define QC0QUALITYCENTERBASE__QC0CHARACTERISTICSGROUP__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <Qc0qualitybase/libqc0qualitybase_exports.h>

namespace qc0qualitycenterbase
{
    class Qc0CharacteristicsGroup;
}
namespace qc0qualitycenterbase
{
    class Qc0CharacteristicsGroupImpl;
}
namespace qc0qualitycenterbase
{
    class Qc0CharacteristicsGroupDelegate;
}
namespace qc0qualitycenterbase
{
    class Qc0CharacteristicsGroupDispatch;
}
namespace qc0qualitycenterbase
{
    class Qc0CharacteristicsGroupGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  QC0QUALITYBASE_API  qc0qualitycenterbase::Qc0CharacteristicsGroup
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.6
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getQc0SpecificationList( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Qc0CharacteristicsGroup();

    /**
     * Destructor
     */
    virtual ~Qc0CharacteristicsGroup();

private:
    //  Getter method for the Implementation Object
    Qc0CharacteristicsGroupImpl*  getQc0CharacteristicsGroupImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setQc0CharacteristicsGroupImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Qc0CharacteristicsGroupImpl*  m_qc0characteristicsgroupImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Qc0CharacteristicsGroup - desc for Qc0CharacteristicsGroup parameter
     */
    Qc0CharacteristicsGroup( const Qc0CharacteristicsGroup& );
    Qc0CharacteristicsGroup& operator=( const Qc0CharacteristicsGroup& );

    friend class  Qc0CharacteristicsGroupDelegate;
    friend class  Qc0CharacteristicsGroupDispatch;
    friend class  Qc0CharacteristicsGroupGenImpl;
};

#include <Qc0qualitybase/libqc0qualitybase_undef.h>
#endif //   QC0QUALITYCENTERBASE__QC0CHARACTERISTICSGROUP__HXX
