//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//e
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Qc0Failure
    Filename:   Qc0Failure.hxx
    Module:     Qc0qualitybase
    @BMIDE autogenerated
==================================================================================================*/

#ifndef QC0QUALITYCENTERBASE__QC0FAILURE__HXX
#define QC0QUALITYCENTERBASE__QC0FAILURE__HXX

#include <vector>
#include <string>
#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <Qc0qualitybase/Qc0MasterQualityObject.hxx>

#include <Qc0qualitybase/libqc0qualitybase_exports.h>

namespace qc0qualitycenterbase
{
    class Qc0Failure;
}
namespace qc0qualitycenterbase
{
    class Qc0FailureImpl;
}
namespace qc0qualitycenterbase
{
    class Qc0FailureDelegate;
}
namespace qc0qualitycenterbase
{
    class Qc0FailureDispatch;
}
namespace qc0qualitycenterbase
{
    class Qc0FailureGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  QC0QUALITYBASE_API  qc0qualitycenterbase::Qc0Failure
     : public  ::qc0qualitycenterbase::Qc0MasterQualityObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.6
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getQc0FailureList( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.6
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getQc0FailurePath( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.6
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setQc0ParentFailure( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Qc0Failure();

    /**
     * Destructor
     */
    virtual ~Qc0Failure();

private:
    //  Getter method for the Implementation Object
    Qc0FailureImpl*  getQc0FailureImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setQc0FailureImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Qc0FailureImpl*  m_qc0failureImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Qc0Failure - desc for Qc0Failure parameter
     */
    Qc0Failure( const Qc0Failure& );
    Qc0Failure& operator=( const Qc0Failure& );

    friend class  Qc0FailureDelegate;
    friend class  Qc0FailureDispatch;
    friend class  Qc0FailureGenImpl;
};

#include <Qc0qualitybase/libqc0qualitybase_undef.h>
#endif //   QC0QUALITYCENTERBASE__QC0FAILURE__HXX
