//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//e
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Qc0FailureDelegate
    Filename:   Qc0FailureDelegate.hxx
    Module:     Qc0qualitybase
    @BMIDE autogenerated
==================================================================================================*/

#ifndef QC0QUALITYCENTERBASE__QC0FAILUREDELEGATE_HXX
#define QC0QUALITYCENTERBASE__QC0FAILUREDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Qc0qualitybase/Qc0Failure.hxx>

#include <Qc0qualitybase/libqc0qualitybase_exports.h>

namespace qc0qualitycenterbase
{
    class Qc0FailureDelegate;
}
namespace qc0qualitycenterbase
{
    class Qc0FailureImpl;
}
namespace qc0qualitycenterbase
{
    class Qc0Failure;
}
namespace qc0qualitycenterbase
{
    class Qc0FailureGenImpl;
}

namespace qc0qualitycenterbase_alias = ::qc0qualitycenterbase;


class  QC0QUALITYBASE_API qc0qualitycenterbase_alias::Qc0FailureDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Qc0FailureDelegate instance
    static Qc0FailureDelegate&  getInstance();

    //  Method to create the Qc0FailureImpl pointer
    static Qc0FailureImpl*  createImpl( Qc0Failure&  ifObj );

    //  Method to delete the Qc0FailureImpl pointer
    static void deleteImpl( Qc0FailureImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.6
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getQc0FailureListBase(const Qc0Failure &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.6
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getQc0FailurePathBase(const Qc0Failure &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.6
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setQc0ParentFailureBase(Qc0Failure &ifObj,  const tag_t &value, bool isNull );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Qc0Failure &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Deletes the instance.
    /// @version Teamcenter 11.1
    /// @return - Failure code.
    ///
    int  fnd0DeleteBase(const Qc0Failure &ifObj  );


    ///
    /// Generic revisePost operation.
    /// @version Teamcenter 10.1
    /// @param pReviseInput - Input ReviseInput object.
    /// @param vecDeepCopyData - Vector of deep copy data.
    /// @return - Returns an integer value.
    ///
    int  revisePostBase(const Qc0Failure &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// Generic saveAsPost operation.
    /// @version Teamcenter 8.1
    /// @param pSavAsInput - Input argument as SaveAsInput object.
    /// @param vecDeepCopyData - vector deepcopy data
    /// @return - Return integer value.
    ///
    int  saveAsPostBase(const Qc0Failure &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Qc0Failure &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Validate revise input.
    /// @version Teamcenter 10.1
    /// @param pReviseInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - Returns an int.
    ///
    int  validateReviseInputBase(const Qc0Failure &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.6
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getQc0BasedOnSpecificationsBase(const Qc0Failure &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;



protected:
    //  Pointer to the instance
    static Qc0FailureDelegate*  m_pInstance;

    Qc0FailureDelegate();
    virtual ~Qc0FailureDelegate();
    static void setInstance( Qc0FailureDelegate*  instance );


private:
    friend class  ::qc0qualitycenterbase::Qc0FailureGenImpl;

};

#include <Qc0qualitybase/libqc0qualitybase_undef.h>
#endif  //  QC0QUALITYCENTERBASE__QC0FAILUREDELEGATE_HXX
