//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//e
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Qc0MasterQualityObject
    Filename:   Qc0MasterQualityObject.hxx
    Module:     Qc0qualitybase
    @BMIDE autogenerated
==================================================================================================*/

#ifndef QC0QUALITYCENTERBASE__QC0MASTERQUALITYOBJECT__HXX
#define QC0QUALITYCENTERBASE__QC0MASTERQUALITYOBJECT__HXX

#include <metaframework/ReviseInput.hxx>
#include <metaframework/DeepCopyData.hxx>
#include <unidefs.h>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <Qc0qualitybase/libqc0qualitybase_exports.h>

namespace qc0qualitycenterbase
{
    class Qc0MasterQualityObject;
}
namespace qc0qualitycenterbase
{
    class Qc0MasterQualityObjectImpl;
}
namespace qc0qualitycenterbase
{
    class Qc0MasterQualityObjectDelegate;
}
namespace qc0qualitycenterbase
{
    class Qc0MasterQualityObjectDispatch;
}
namespace qc0qualitycenterbase
{
    class Qc0MasterQualityObjectGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  QC0QUALITYBASE_API  qc0qualitycenterbase::Qc0MasterQualityObject
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.6
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getQc0BasedOnSpecifications( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Finalize operation input.
    /// @version Teamcenter 11.6
    /// @param pReviseInput - Desc
    /// @param vecDeepCopyData - Desc
    /// @return - Returns an int.
    ///
    int  finalizeReviseInput( ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );

    ///
    /// Revise operation.
    /// @version Teamcenter 11.6
    /// @param pReviseInput - Desc
    /// @param vecDeepCopyData - Desc
    /// @param newObjTag - Desc
    /// @return - Returns an int.
    ///
    int  revise( ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData, tag_t *newObjTag );

    ///
    /// Generic revisePost operation.
    /// @version Teamcenter 11.6
    /// @param pReviseInput - Desc
    /// @param vecDeepCopyData - Desc
    /// @return - Returns an int.
    ///
    int  revisePost( ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );

    ///
    /// Set properties from revise input.
    /// @version Teamcenter 11.6
    /// @param pReviseInput - Desc
    /// @return - Returns an int.
    ///
    int  setPropertiesFromReviseInput( ::Teamcenter::ReviseInput *pReviseInput );

    ///
    /// Validate revise input.
    /// @version Teamcenter 11.6
    /// @param pReviseInput - Desc
    /// @param vecDeepCopyData - Desc
    /// @return - Returns an int.
    ///
    int  validateReviseInput( ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Qc0MasterQualityObject();

    /**
     * Destructor
     */
    virtual ~Qc0MasterQualityObject();

private:
    //  Getter method for the Implementation Object
    Qc0MasterQualityObjectImpl*  getQc0MasterQualityObjectImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setQc0MasterQualityObjectImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Qc0MasterQualityObjectImpl*  m_qc0masterqualityobjectImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Qc0MasterQualityObject - desc for Qc0MasterQualityObject parameter
     */
    Qc0MasterQualityObject( const Qc0MasterQualityObject& );
    Qc0MasterQualityObject& operator=( const Qc0MasterQualityObject& );

    friend class  Qc0MasterQualityObjectDelegate;
    friend class  Qc0MasterQualityObjectDispatch;
    friend class  Qc0MasterQualityObjectGenImpl;
};

#include <Qc0qualitybase/libqc0qualitybase_undef.h>
#endif //   QC0QUALITYCENTERBASE__QC0MASTERQUALITYOBJECT__HXX
