//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//e
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Qc0MasterQualityObjectDelegate
    Filename:   Qc0MasterQualityObjectDelegate.hxx
    Module:     Qc0qualitybase
    @BMIDE autogenerated
==================================================================================================*/

#ifndef QC0QUALITYCENTERBASE__QC0MASTERQUALITYOBJECTDELEGATE_HXX
#define QC0QUALITYCENTERBASE__QC0MASTERQUALITYOBJECTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Qc0qualitybase/Qc0MasterQualityObject.hxx>

#include <Qc0qualitybase/libqc0qualitybase_exports.h>

namespace qc0qualitycenterbase
{
    class Qc0MasterQualityObjectDelegate;
}
namespace qc0qualitycenterbase
{
    class Qc0MasterQualityObjectImpl;
}
namespace qc0qualitycenterbase
{
    class Qc0MasterQualityObject;
}
namespace qc0qualitycenterbase
{
    class Qc0MasterQualityObjectGenImpl;
}

namespace qc0qualitycenterbase_alias = ::qc0qualitycenterbase;


class  QC0QUALITYBASE_API qc0qualitycenterbase_alias::Qc0MasterQualityObjectDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Qc0MasterQualityObjectDelegate instance
    static Qc0MasterQualityObjectDelegate&  getInstance();

    //  Method to create the Qc0MasterQualityObjectImpl pointer
    static Qc0MasterQualityObjectImpl*  createImpl( Qc0MasterQualityObject&  ifObj );

    //  Method to delete the Qc0MasterQualityObjectImpl pointer
    static void deleteImpl( Qc0MasterQualityObjectImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.6
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getQc0BasedOnSpecificationsBase(const Qc0MasterQualityObject &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Finalize operation input.
    /// @version Teamcenter 11.6
    /// @param pReviseInput - Desc
    /// @param vecDeepCopyData - Desc
    /// @return - Returns an int.
    ///
    int  finalizeReviseInputBase(const Qc0MasterQualityObject &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// Revise operation.
    /// @version Teamcenter 11.6
    /// @param pReviseInput - Desc
    /// @param vecDeepCopyData - Desc
    /// @param newObjTag - Desc
    /// @return - Returns an int.
    ///
    int  reviseBase(const Qc0MasterQualityObject &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData, tag_t *newObjTag );


    ///
    /// Generic revisePost operation.
    /// @version Teamcenter 11.6
    /// @param pReviseInput - Desc
    /// @param vecDeepCopyData - Desc
    /// @return - Returns an int.
    ///
    int  revisePostBase(const Qc0MasterQualityObject &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// Set properties from revise input.
    /// @version Teamcenter 11.6
    /// @param pReviseInput - Desc
    /// @return - Returns an int.
    ///
    int  setPropertiesFromReviseInputBase(const Qc0MasterQualityObject &ifObj,  ::Teamcenter::ReviseInput *pReviseInput );


    ///
    /// Validate revise input.
    /// @version Teamcenter 11.6
    /// @param pReviseInput - Desc
    /// @param vecDeepCopyData - Desc
    /// @return - Returns an int.
    ///
    int  validateReviseInputBase(const Qc0MasterQualityObject &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Qc0MasterQualityObject &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Qc0MasterQualityObject &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// finalize operation input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  finalizeSaveAsInputBase(const Qc0MasterQualityObject &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// Generic saveAsPost operation.
    /// @version Teamcenter 8.1
    /// @param pSavAsInput - Input argument as SaveAsInput object.
    /// @param vecDeepCopyData - vector deepcopy data
    /// @return - Return integer value.
    ///
    int  saveAsPostBase(const Qc0MasterQualityObject &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Qc0MasterQualityObject &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// validate saveas input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  validateSaveAsInputBase(const Qc0MasterQualityObject &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static Qc0MasterQualityObjectDelegate*  m_pInstance;

    Qc0MasterQualityObjectDelegate();
    virtual ~Qc0MasterQualityObjectDelegate();
    static void setInstance( Qc0MasterQualityObjectDelegate*  instance );


private:
    friend class  ::qc0qualitycenterbase::Qc0MasterQualityObjectGenImpl;

};

#include <Qc0qualitybase/libqc0qualitybase_undef.h>
#endif  //  QC0QUALITYCENTERBASE__QC0MASTERQUALITYOBJECTDELEGATE_HXX
