//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//e
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Qc0VisualCharSpec
    Filename:   Qc0VisualCharSpec.hxx
    Module:     Qc0qualitybase
    @BMIDE autogenerated
==================================================================================================*/

#ifndef QC0QUALITYCENTERBASE__QC0VISUALCHARSPEC__HXX
#define QC0QUALITYCENTERBASE__QC0VISUALCHARSPEC__HXX

#include <common/tc_deprecation_macros.h>
#include <Qc0qualitybase/Qc0MasterCharSpec.hxx>

#include <Qc0qualitybase/libqc0qualitybase_exports.h>

namespace qc0qualitycenterbase
{
    class Qc0VisualCharSpec;
}
namespace qc0qualitycenterbase
{
    class Qc0VisualCharSpecImpl;
}
namespace qc0qualitycenterbase
{
    class Qc0VisualCharSpecDelegate;
}
namespace qc0qualitycenterbase
{
    class Qc0VisualCharSpecDispatch;
}
namespace qc0qualitycenterbase
{
    class Qc0VisualCharSpecGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  QC0QUALITYBASE_API  qc0qualitycenterbase::Qc0VisualCharSpec
     : public  ::qc0qualitycenterbase::Qc0MasterCharSpec
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Qc0VisualCharSpec();

    /**
     * Destructor
     */
    virtual ~Qc0VisualCharSpec();

private:
    //  Getter method for the Implementation Object
    Qc0VisualCharSpecImpl*  getQc0VisualCharSpecImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setQc0VisualCharSpecImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Qc0VisualCharSpecImpl*  m_qc0visualcharspecImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Qc0VisualCharSpec - desc for Qc0VisualCharSpec parameter
     */
    Qc0VisualCharSpec( const Qc0VisualCharSpec& );
    Qc0VisualCharSpec& operator=( const Qc0VisualCharSpec& );

    friend class  Qc0VisualCharSpecDelegate;
    friend class  Qc0VisualCharSpecDispatch;
    friend class  Qc0VisualCharSpecGenImpl;
};

#include <Qc0qualitybase/libqc0qualitybase_undef.h>
#endif //   QC0QUALITYCENTERBASE__QC0VISUALCHARSPEC__HXX
