//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Smc0VarConfigurableObject
    Filename:   Smc0VarConfigurableObject.hxx
    Module:     Smc0psmcfgsupport
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SMC0VARCONFIGURABLEOBJECT__HXX
#define TEAMCENTER__SMC0VARCONFIGURABLEOBJECT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <Smc0psmcfgsupport/libsmc0psmcfgsupport_exports.h>

namespace Teamcenter
{
    class Smc0VarConfigurableObject;
}
namespace Teamcenter
{
    class Smc0VarConfigurableObjectImpl;
}
namespace Teamcenter
{
    class Smc0VarConfigurableObjectDelegate;
}
namespace Teamcenter
{
    class Smc0VarConfigurableObjectDispatch;
}
namespace Teamcenter
{
    class Smc0VarConfigurableObjectGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SMC0PSMCFGSUPPORT_API  Teamcenter::Smc0VarConfigurableObject
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Smc0VarConfigurableObject();

    /**
     * Destructor
     */
    virtual ~Smc0VarConfigurableObject();

private:
    //  Getter method for the Implementation Object
    Smc0VarConfigurableObjectImpl*  getSmc0VarConfigurableObjectImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSmc0VarConfigurableObjectImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Smc0VarConfigurableObjectImpl*  m_smc0varconfigurableobjectImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Smc0VarConfigurableObject - desc for Smc0VarConfigurableObject parameter
     */
    Smc0VarConfigurableObject( const Smc0VarConfigurableObject& );
    Smc0VarConfigurableObject& operator=( const Smc0VarConfigurableObject& );

    friend class  Smc0VarConfigurableObjectDelegate;
    friend class  Smc0VarConfigurableObjectDispatch;
    friend class  Smc0VarConfigurableObjectGenImpl;
};

#include <Smc0psmcfgsupport/libsmc0psmcfgsupport_undef.h>
#endif //   TEAMCENTER__SMC0VARCONFIGURABLEOBJECT__HXX
