//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Smc0VarConfigurableObjectDelegate
    Filename:   Smc0VarConfigurableObjectDelegate.hxx
    Module:     Smc0psmcfgsupport
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SMC0VARCONFIGURABLEOBJECTDELEGATE_HXX
#define TEAMCENTER__SMC0VARCONFIGURABLEOBJECTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Smc0psmcfgsupport/Smc0VarConfigurableObject.hxx>

#include <Smc0psmcfgsupport/libsmc0psmcfgsupport_exports.h>

namespace Teamcenter
{
    class Smc0VarConfigurableObjectDelegate;
}
namespace Teamcenter
{
    class Smc0VarConfigurableObjectImpl;
}
namespace Teamcenter
{
    class Smc0VarConfigurableObject;
}
namespace Teamcenter
{
    class Smc0VarConfigurableObjectGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  SMC0PSMCFGSUPPORT_API Teamcenter_alias::Smc0VarConfigurableObjectDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Smc0VarConfigurableObjectDelegate instance
    static Smc0VarConfigurableObjectDelegate&  getInstance();

    //  Method to create the Smc0VarConfigurableObjectImpl pointer
    static Smc0VarConfigurableObjectImpl*  createImpl( Smc0VarConfigurableObject&  ifObj );

    //  Method to delete the Smc0VarConfigurableObjectImpl pointer
    static void deleteImpl( Smc0VarConfigurableObjectImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static Smc0VarConfigurableObjectDelegate*  m_pInstance;

    Smc0VarConfigurableObjectDelegate();
    virtual ~Smc0VarConfigurableObjectDelegate();
    static void setInstance( Smc0VarConfigurableObjectDelegate*  instance );


private:
    friend class  ::Teamcenter::Smc0VarConfigurableObjectGenImpl;

};

#include <Smc0psmcfgsupport/libsmc0psmcfgsupport_undef.h>
#endif  //  TEAMCENTER__SMC0VARCONFIGURABLEOBJECTDELEGATE_HXX
