//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Smd0LogicalElement
    Filename:   Smd0LogicalElement.hxx
    Module:     Smd0sysmodeling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef SMD0SYSTEMMODELING__SMD0LOGICALELEMENT__HXX
#define SMD0SYSTEMMODELING__SMD0LOGICALELEMENT__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <Smd0sysmodeling/Smd0ModelElement.hxx>

#include <Smd0sysmodeling/libsmd0sysmodeling_exports.h>

namespace smd0systemmodeling
{
    class Smd0LogicalElement;
}
namespace smd0systemmodeling
{
    class Smd0LogicalElementImpl;
}
namespace smd0systemmodeling
{
    class Smd0LogicalElementDelegate;
}
namespace smd0systemmodeling
{
    class Smd0LogicalElementDispatch;
}
namespace smd0systemmodeling
{
    class Smd0LogicalElementGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SMD0SYSMODELING_API  smd0systemmodeling::Smd0LogicalElement
     : public  ::smd0systemmodeling::Smd0ModelElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.2.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getSmd0AttachedPorts( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Smd0LogicalElement();

    /**
     * Destructor
     */
    virtual ~Smd0LogicalElement();

private:
    //  Getter method for the Implementation Object
    Smd0LogicalElementImpl*  getSmd0LogicalElementImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSmd0LogicalElementImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Smd0LogicalElementImpl*  m_smd0logicalelementImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Smd0LogicalElement - desc for Smd0LogicalElement parameter
     */
    Smd0LogicalElement( const Smd0LogicalElement& );
    Smd0LogicalElement& operator=( const Smd0LogicalElement& );

    friend class  Smd0LogicalElementDelegate;
    friend class  Smd0LogicalElementDispatch;
    friend class  Smd0LogicalElementGenImpl;
};

#include <Smd0sysmodeling/libsmd0sysmodeling_undef.h>
#endif //   SMD0SYSTEMMODELING__SMD0LOGICALELEMENT__HXX
