//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Smd0LogicalElementDelegate
    Filename:   Smd0LogicalElementDelegate.hxx
    Module:     Smd0sysmodeling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef SMD0SYSTEMMODELING__SMD0LOGICALELEMENTDELEGATE_HXX
#define SMD0SYSTEMMODELING__SMD0LOGICALELEMENTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Smd0sysmodeling/Smd0LogicalElement.hxx>

#include <Smd0sysmodeling/libsmd0sysmodeling_exports.h>

namespace smd0systemmodeling
{
    class Smd0LogicalElementDelegate;
}
namespace smd0systemmodeling
{
    class Smd0LogicalElementImpl;
}
namespace smd0systemmodeling
{
    class Smd0LogicalElement;
}
namespace smd0systemmodeling
{
    class Smd0LogicalElementGenImpl;
}

namespace smd0systemmodeling_alias = ::smd0systemmodeling;


class  SMD0SYSMODELING_API smd0systemmodeling_alias::Smd0LogicalElementDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Smd0LogicalElementDelegate instance
    static Smd0LogicalElementDelegate&  getInstance();

    //  Method to create the Smd0LogicalElementImpl pointer
    static Smd0LogicalElementImpl*  createImpl( Smd0LogicalElement&  ifObj );

    //  Method to delete the Smd0LogicalElementImpl pointer
    static void deleteImpl( Smd0LogicalElementImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.2.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getSmd0AttachedPortsBase(const Smd0LogicalElement &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;



protected:
    //  Pointer to the instance
    static Smd0LogicalElementDelegate*  m_pInstance;

    Smd0LogicalElementDelegate();
    virtual ~Smd0LogicalElementDelegate();
    static void setInstance( Smd0LogicalElementDelegate*  instance );


private:
    friend class  ::smd0systemmodeling::Smd0LogicalElementGenImpl;

};

#include <Smd0sysmodeling/libsmd0sysmodeling_undef.h>
#endif  //  SMD0SYSTEMMODELING__SMD0LOGICALELEMENTDELEGATE_HXX
