//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Smd0Model
    Filename:   Smd0Model.hxx
    Module:     Smd0sysmodeling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef SMD0SYSTEMMODELING__SMD0MODEL__HXX
#define SMD0SYSTEMMODELING__SMD0MODEL__HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0ApplicationModel.hxx>

#include <Smd0sysmodeling/libsmd0sysmodeling_exports.h>

namespace smd0systemmodeling
{
    class Smd0Model;
}
namespace smd0systemmodeling
{
    class Smd0ModelImpl;
}
namespace smd0systemmodeling
{
    class Smd0ModelDelegate;
}
namespace smd0systemmodeling
{
    class Smd0ModelDispatch;
}
namespace smd0systemmodeling
{
    class Smd0ModelGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SMD0SYSMODELING_API  smd0systemmodeling::Smd0Model
     : public  ::Teamcenter::AppModel::Mdl0ApplicationModel
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Smd0Model();

    /**
     * Destructor
     */
    virtual ~Smd0Model();

private:
    //  Getter method for the Implementation Object
    Smd0ModelImpl*  getSmd0ModelImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSmd0ModelImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Smd0ModelImpl*  m_smd0modelImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Smd0Model - desc for Smd0Model parameter
     */
    Smd0Model( const Smd0Model& );
    Smd0Model& operator=( const Smd0Model& );

    friend class  Smd0ModelDelegate;
    friend class  Smd0ModelDispatch;
    friend class  Smd0ModelGenImpl;
};

#include <Smd0sysmodeling/libsmd0sysmodeling_undef.h>
#endif //   SMD0SYSTEMMODELING__SMD0MODEL__HXX
