//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Smd0ModelElement
    Filename:   Smd0ModelElement.hxx
    Module:     Smd0sysmodeling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef SMD0SYSTEMMODELING__SMD0MODELELEMENT__HXX
#define SMD0SYSTEMMODELING__SMD0MODELELEMENT__HXX

#include <common/tc_deprecation_macros.h>
#include <rlz0realization/Rlz0RealizedItem.hxx>

#include <Smd0sysmodeling/libsmd0sysmodeling_exports.h>

namespace smd0systemmodeling
{
    class Smd0ModelElement;
}
namespace smd0systemmodeling
{
    class Smd0ModelElementImpl;
}
namespace smd0systemmodeling
{
    class Smd0ModelElementDelegate;
}
namespace smd0systemmodeling
{
    class Smd0ModelElementDispatch;
}
namespace smd0systemmodeling
{
    class Smd0ModelElementGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SMD0SYSMODELING_API  smd0systemmodeling::Smd0ModelElement
     : public  ::Teamcenter::Realization::Rlz0RealizedItem
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Smd0ModelElement();

    /**
     * Destructor
     */
    virtual ~Smd0ModelElement();

private:
    //  Getter method for the Implementation Object
    Smd0ModelElementImpl*  getSmd0ModelElementImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSmd0ModelElementImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Smd0ModelElementImpl*  m_smd0modelelementImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Smd0ModelElement - desc for Smd0ModelElement parameter
     */
    Smd0ModelElement( const Smd0ModelElement& );
    Smd0ModelElement& operator=( const Smd0ModelElement& );

    friend class  Smd0ModelElementDelegate;
    friend class  Smd0ModelElementDispatch;
    friend class  Smd0ModelElementGenImpl;
};

#include <Smd0sysmodeling/libsmd0sysmodeling_undef.h>
#endif //   SMD0SYSTEMMODELING__SMD0MODELELEMENT__HXX
