//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  Smd0sysmodeling

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libSmd0sysmodeling

#if !defined(LIBSMD0SYSMODELING) && !defined(IPLIB)
#   error IPLIB or LIBSMD0SYSMODELING is not defined
#endif

/* Handwritten code should use SMD0SYSMODELING_API, not SMD0SYSMODELINGEXPORT */

#define SMD0SYSMODELING_API SMD0SYSMODELINGEXPORT

#if IPLIB==libSmd0sysmodeling || defined(LIBSMD0SYSMODELING)
#   if defined(__lint)
#       define SMD0SYSMODELINGEXPORT       __export(Smd0sysmodeling)
#       define SMD0SYSMODELINGGLOBAL       extern __global(Smd0sysmodeling)
#       define SMD0SYSMODELINGPRIVATE      extern __private(Smd0sysmodeling)
#   elif defined(_WIN32)
#       define SMD0SYSMODELINGEXPORT       __declspec(dllexport)
#       define SMD0SYSMODELINGGLOBAL       extern __declspec(dllexport)
#       define SMD0SYSMODELINGPRIVATE      extern
#   else
#       define SMD0SYSMODELINGEXPORT
#       define SMD0SYSMODELINGGLOBAL       extern
#       define SMD0SYSMODELINGPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define SMD0SYSMODELINGEXPORT       __export(Smd0sysmodeling)
#       define SMD0SYSMODELINGGLOBAL       extern __global(Smd0sysmodeling)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define SMD0SYSMODELINGEXPORT      __declspec(dllimport)
#       define SMD0SYSMODELINGGLOBAL       extern __declspec(dllimport)
#   else
#       define SMD0SYSMODELINGEXPORT
#       define SMD0SYSMODELINGGLOBAL       extern
#   endif
#endif
