//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ssm0AbstractSynthesis
    Filename:   Ssm0AbstractSynthesis.hxx
    Module:     Ssm0systemsynthesismodeling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef SSM0SYSTEMSYNTHESISMODELING__SSM0ABSTRACTSYNTHESIS__HXX
#define SSM0SYSTEMSYNTHESISMODELING__SSM0ABSTRACTSYNTHESIS__HXX

#include <metaframework/ReviseInput.hxx>
#include <metaframework/DeepCopyData.hxx>
#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_exports.h>

namespace ssm0systemsynthesismodeling
{
    class Ssm0AbstractSynthesis;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0AbstractSynthesisImpl;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0AbstractSynthesisDelegate;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0AbstractSynthesisDispatch;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0AbstractSynthesisGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SSM0SYSTEMSYNTHESISMODELING_API  ssm0systemsynthesismodeling::Ssm0AbstractSynthesis
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Finalize Revise Input Operation
    /// @version Teamcenter 11.2
    /// @param pReviseInput - Revise input
    /// @param vecDeepCopyData - Deep Copy Data Vector
    /// @return - Failure Code
    ///
    int  finalizeReviseInput( ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );

    ///
    /// Ssm0AbstractSynthesis Revise Operation
    /// @version Teamcenter 11.2
    /// @param pReviseInput - Revise Input
    /// @param vecDeepCopyData - Deep Copy Data Vactor
    /// @param newObjTag - New Object tag
    /// @return - Failure Code
    ///
    int  revise( ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData, tag_t *newObjTag );

    ///
    /// Reivse post operation
    /// @version Teamcenter 11.2
    /// @param pReviseInput - Revise Input Descriptor
    /// @param vecDeepCopyData - Deep Copy Data Vector
    /// @return - Failure Code
    ///
    int  revisePost( ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );

    ///
    /// Set properties from revise input Operation
    /// @version Teamcenter 11.2
    /// @param pReviseInput - Revise Input Descriptor
    /// @return - Failure code
    ///
    int  setPropertiesFromReviseInput( ::Teamcenter::ReviseInput *pReviseInput );

    ///
    /// Validate Revise Input Operation
    /// @version Teamcenter 11.2
    /// @param pReviseInput - Revise Input Descriptor
    /// @param vecDeepCopyData - Deep Copy Data Vector
    /// @return - Failure Code
    ///
    int  validateReviseInput( ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ssm0AbstractSynthesis();

    /**
     * Destructor
     */
    virtual ~Ssm0AbstractSynthesis();

private:
    //  Getter method for the Implementation Object
    Ssm0AbstractSynthesisImpl*  getSsm0AbstractSynthesisImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSsm0AbstractSynthesisImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ssm0AbstractSynthesisImpl*  m_ssm0abstractsynthesisImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ssm0AbstractSynthesis - desc for Ssm0AbstractSynthesis parameter
     */
    Ssm0AbstractSynthesis( const Ssm0AbstractSynthesis& );
    Ssm0AbstractSynthesis& operator=( const Ssm0AbstractSynthesis& );

    friend class  Ssm0AbstractSynthesisDelegate;
    friend class  Ssm0AbstractSynthesisDispatch;
    friend class  Ssm0AbstractSynthesisGenImpl;
};

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_undef.h>
#endif //   SSM0SYSTEMSYNTHESISMODELING__SSM0ABSTRACTSYNTHESIS__HXX
