//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ssm0AbstractTemplate
    Filename:   Ssm0AbstractTemplate.hxx
    Module:     Ssm0systemsynthesismodeling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef SSM0SYSTEMSYNTHESISMODELING__SSM0ABSTRACTTEMPLATE__HXX
#define SSM0SYSTEMSYNTHESISMODELING__SSM0ABSTRACTTEMPLATE__HXX

#include <common/tc_deprecation_macros.h>
#include <Ssm0systemsynthesismodeling/Ssm0AbstractSynthesis.hxx>

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_exports.h>

namespace ssm0systemsynthesismodeling
{
    class Ssm0AbstractTemplate;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0AbstractTemplateImpl;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0AbstractTemplateDelegate;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0AbstractTemplateDispatch;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0AbstractTemplateGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SSM0SYSTEMSYNTHESISMODELING_API  ssm0systemsynthesismodeling::Ssm0AbstractTemplate
     : public  ::ssm0systemsynthesismodeling::Ssm0AbstractSynthesis
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ssm0AbstractTemplate();

    /**
     * Destructor
     */
    virtual ~Ssm0AbstractTemplate();

private:
    //  Getter method for the Implementation Object
    Ssm0AbstractTemplateImpl*  getSsm0AbstractTemplateImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSsm0AbstractTemplateImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ssm0AbstractTemplateImpl*  m_ssm0abstracttemplateImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ssm0AbstractTemplate - desc for Ssm0AbstractTemplate parameter
     */
    Ssm0AbstractTemplate( const Ssm0AbstractTemplate& );
    Ssm0AbstractTemplate& operator=( const Ssm0AbstractTemplate& );

    friend class  Ssm0AbstractTemplateDelegate;
    friend class  Ssm0AbstractTemplateDispatch;
    friend class  Ssm0AbstractTemplateGenImpl;
};

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_undef.h>
#endif //   SSM0SYSTEMSYNTHESISMODELING__SSM0ABSTRACTTEMPLATE__HXX
