//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ssm0AbstractTemplateDelegate
    Filename:   Ssm0AbstractTemplateDelegate.hxx
    Module:     Ssm0systemsynthesismodeling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef SSM0SYSTEMSYNTHESISMODELING__SSM0ABSTRACTTEMPLATEDELEGATE_HXX
#define SSM0SYSTEMSYNTHESISMODELING__SSM0ABSTRACTTEMPLATEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Ssm0systemsynthesismodeling/Ssm0AbstractTemplate.hxx>

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_exports.h>

namespace ssm0systemsynthesismodeling
{
    class Ssm0AbstractTemplateDelegate;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0AbstractTemplateImpl;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0AbstractTemplate;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0AbstractTemplateGenImpl;
}

namespace ssm0systemsynthesismodeling_alias = ::ssm0systemsynthesismodeling;


class  SSM0SYSTEMSYNTHESISMODELING_API ssm0systemsynthesismodeling_alias::Ssm0AbstractTemplateDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Ssm0AbstractTemplateDelegate instance
    static Ssm0AbstractTemplateDelegate&  getInstance();

    //  Method to create the Ssm0AbstractTemplateImpl pointer
    static Ssm0AbstractTemplateImpl*  createImpl( Ssm0AbstractTemplate&  ifObj );

    //  Method to delete the Ssm0AbstractTemplateImpl pointer
    static void deleteImpl( Ssm0AbstractTemplateImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Ssm0AbstractTemplate &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Ssm0AbstractTemplateDelegate*  m_pInstance;

    Ssm0AbstractTemplateDelegate();
    virtual ~Ssm0AbstractTemplateDelegate();
    static void setInstance( Ssm0AbstractTemplateDelegate*  instance );


private:
    friend class  ::ssm0systemsynthesismodeling::Ssm0AbstractTemplateGenImpl;

};

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_undef.h>
#endif  //  SSM0SYSTEMSYNTHESISMODELING__SSM0ABSTRACTTEMPLATEDELEGATE_HXX
