//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ssm0SimApp
    Filename:   Ssm0SimApp.hxx
    Module:     Ssm0systemsynthesismodeling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef SSM0SYSTEMSYNTHESISMODELING__SSM0SIMAPP__HXX
#define SSM0SYSTEMSYNTHESISMODELING__SSM0SIMAPP__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <Ssm0systemsynthesismodeling/Ssm0AbstractSynthesis.hxx>

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_exports.h>

namespace ssm0systemsynthesismodeling
{
    class Ssm0SimApp;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimAppImpl;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimAppDelegate;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimAppDispatch;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimAppGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SSM0SYSTEMSYNTHESISMODELING_API  ssm0systemsynthesismodeling::Ssm0SimApp
     : public  ::ssm0systemsynthesismodeling::Ssm0AbstractSynthesis
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.2.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSsm0Url( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ssm0SimApp();

    /**
     * Destructor
     */
    virtual ~Ssm0SimApp();

private:
    //  Getter method for the Implementation Object
    Ssm0SimAppImpl*  getSsm0SimAppImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSsm0SimAppImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ssm0SimAppImpl*  m_ssm0simappImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ssm0SimApp - desc for Ssm0SimApp parameter
     */
    Ssm0SimApp( const Ssm0SimApp& );
    Ssm0SimApp& operator=( const Ssm0SimApp& );

    friend class  Ssm0SimAppDelegate;
    friend class  Ssm0SimAppDispatch;
    friend class  Ssm0SimAppGenImpl;
};

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_undef.h>
#endif //   SSM0SYSTEMSYNTHESISMODELING__SSM0SIMAPP__HXX
