//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ssm0SimAppDelegate
    Filename:   Ssm0SimAppDelegate.hxx
    Module:     Ssm0systemsynthesismodeling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef SSM0SYSTEMSYNTHESISMODELING__SSM0SIMAPPDELEGATE_HXX
#define SSM0SYSTEMSYNTHESISMODELING__SSM0SIMAPPDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Ssm0systemsynthesismodeling/Ssm0SimApp.hxx>

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_exports.h>

namespace ssm0systemsynthesismodeling
{
    class Ssm0SimAppDelegate;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimAppImpl;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimApp;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimAppGenImpl;
}

namespace ssm0systemsynthesismodeling_alias = ::ssm0systemsynthesismodeling;


class  SSM0SYSTEMSYNTHESISMODELING_API ssm0systemsynthesismodeling_alias::Ssm0SimAppDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Ssm0SimAppDelegate instance
    static Ssm0SimAppDelegate&  getInstance();

    //  Method to create the Ssm0SimAppImpl pointer
    static Ssm0SimAppImpl*  createImpl( Ssm0SimApp&  ifObj );

    //  Method to delete the Ssm0SimAppImpl pointer
    static void deleteImpl( Ssm0SimAppImpl*  impl );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.2.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSsm0UrlBase(Ssm0SimApp &ifObj,  const std::string &value, bool isNull );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Ssm0SimApp &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Ssm0SimAppDelegate*  m_pInstance;

    Ssm0SimAppDelegate();
    virtual ~Ssm0SimAppDelegate();
    static void setInstance( Ssm0SimAppDelegate*  instance );


private:
    friend class  ::ssm0systemsynthesismodeling::Ssm0SimAppGenImpl;

};

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_undef.h>
#endif  //  SSM0SYSTEMSYNTHESISMODELING__SSM0SIMAPPDELEGATE_HXX
