//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ssm0SimBaseArchDataset
    Filename:   Ssm0SimBaseArchDataset.hxx
    Module:     Ssm0systemsynthesismodeling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef SSM0SYSTEMSYNTHESISMODELING__SSM0SIMBASEARCHDATASET__HXX
#define SSM0SYSTEMSYNTHESISMODELING__SSM0SIMBASEARCHDATASET__HXX

#include <common/tc_deprecation_macros.h>
#include <ae/Dataset.hxx>

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_exports.h>

namespace ssm0systemsynthesismodeling
{
    class Ssm0SimBaseArchDataset;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimBaseArchDatasetImpl;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimBaseArchDatasetDelegate;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimBaseArchDatasetDispatch;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimBaseArchDatasetGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SSM0SYSTEMSYNTHESISMODELING_API  ssm0systemsynthesismodeling::Ssm0SimBaseArchDataset
     : public  ::Teamcenter::Dataset
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ssm0SimBaseArchDataset();

    /**
     * Destructor
     */
    virtual ~Ssm0SimBaseArchDataset();

private:
    //  Getter method for the Implementation Object
    Ssm0SimBaseArchDatasetImpl*  getSsm0SimBaseArchDatasetImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSsm0SimBaseArchDatasetImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ssm0SimBaseArchDatasetImpl*  m_ssm0simbasearchdatasetImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ssm0SimBaseArchDataset - desc for Ssm0SimBaseArchDataset parameter
     */
    Ssm0SimBaseArchDataset( const Ssm0SimBaseArchDataset& );
    Ssm0SimBaseArchDataset& operator=( const Ssm0SimBaseArchDataset& );

    friend class  Ssm0SimBaseArchDatasetDelegate;
    friend class  Ssm0SimBaseArchDatasetDispatch;
    friend class  Ssm0SimBaseArchDatasetGenImpl;
};

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_undef.h>
#endif //   SSM0SYSTEMSYNTHESISMODELING__SSM0SIMBASEARCHDATASET__HXX
