//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ssm0SimBaseArchitecture
    Filename:   Ssm0SimBaseArchitecture.hxx
    Module:     Ssm0systemsynthesismodeling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef SSM0SYSTEMSYNTHESISMODELING__SSM0SIMBASEARCHITECTURE__HXX
#define SSM0SYSTEMSYNTHESISMODELING__SSM0SIMBASEARCHITECTURE__HXX

#include <common/tc_deprecation_macros.h>
#include <Ssm0systemsynthesismodeling/Ssm0AbstractSynthesis.hxx>

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_exports.h>

namespace ssm0systemsynthesismodeling
{
    class Ssm0SimBaseArchitecture;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimBaseArchitectureImpl;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimBaseArchitectureDelegate;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimBaseArchitectureDispatch;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimBaseArchitectureGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SSM0SYSTEMSYNTHESISMODELING_API  ssm0systemsynthesismodeling::Ssm0SimBaseArchitecture
     : public  ::ssm0systemsynthesismodeling::Ssm0AbstractSynthesis
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ssm0SimBaseArchitecture();

    /**
     * Destructor
     */
    virtual ~Ssm0SimBaseArchitecture();

private:
    //  Getter method for the Implementation Object
    Ssm0SimBaseArchitectureImpl*  getSsm0SimBaseArchitectureImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSsm0SimBaseArchitectureImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ssm0SimBaseArchitectureImpl*  m_ssm0simbasearchitectureImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ssm0SimBaseArchitecture - desc for Ssm0SimBaseArchitecture parameter
     */
    Ssm0SimBaseArchitecture( const Ssm0SimBaseArchitecture& );
    Ssm0SimBaseArchitecture& operator=( const Ssm0SimBaseArchitecture& );

    friend class  Ssm0SimBaseArchitectureDelegate;
    friend class  Ssm0SimBaseArchitectureDispatch;
    friend class  Ssm0SimBaseArchitectureGenImpl;
};

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_undef.h>
#endif //   SSM0SYSTEMSYNTHESISMODELING__SSM0SIMBASEARCHITECTURE__HXX
