//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ssm0SimDictionaryDataset
    Filename:   Ssm0SimDictionaryDataset.hxx
    Module:     Ssm0systemsynthesismodeling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef SSM0SYSTEMSYNTHESISMODELING__SSM0SIMDICTIONARYDATASET__HXX
#define SSM0SYSTEMSYNTHESISMODELING__SSM0SIMDICTIONARYDATASET__HXX

#include <common/tc_deprecation_macros.h>
#include <ae/Dataset.hxx>

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_exports.h>

namespace ssm0systemsynthesismodeling
{
    class Ssm0SimDictionaryDataset;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimDictionaryDatasetImpl;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimDictionaryDatasetDelegate;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimDictionaryDatasetDispatch;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimDictionaryDatasetGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SSM0SYSTEMSYNTHESISMODELING_API  ssm0systemsynthesismodeling::Ssm0SimDictionaryDataset
     : public  ::Teamcenter::Dataset
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ssm0SimDictionaryDataset();

    /**
     * Destructor
     */
    virtual ~Ssm0SimDictionaryDataset();

private:
    //  Getter method for the Implementation Object
    Ssm0SimDictionaryDatasetImpl*  getSsm0SimDictionaryDatasetImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSsm0SimDictionaryDatasetImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ssm0SimDictionaryDatasetImpl*  m_ssm0simdictionarydatasetImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ssm0SimDictionaryDataset - desc for Ssm0SimDictionaryDataset parameter
     */
    Ssm0SimDictionaryDataset( const Ssm0SimDictionaryDataset& );
    Ssm0SimDictionaryDataset& operator=( const Ssm0SimDictionaryDataset& );

    friend class  Ssm0SimDictionaryDatasetDelegate;
    friend class  Ssm0SimDictionaryDatasetDispatch;
    friend class  Ssm0SimDictionaryDatasetGenImpl;
};

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_undef.h>
#endif //   SSM0SYSTEMSYNTHESISMODELING__SSM0SIMDICTIONARYDATASET__HXX
