//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ssm0SimModel
    Filename:   Ssm0SimModel.hxx
    Module:     Ssm0systemsynthesismodeling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef SSM0SYSTEMSYNTHESISMODELING__SSM0SIMMODEL__HXX
#define SSM0SYSTEMSYNTHESISMODELING__SSM0SIMMODEL__HXX

#include <common/tc_deprecation_macros.h>
#include <Ssm0systemsynthesismodeling/Ssm0AbstractSynthesis.hxx>

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_exports.h>

namespace ssm0systemsynthesismodeling
{
    class Ssm0SimModel;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimModelImpl;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimModelDelegate;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimModelDispatch;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimModelGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SSM0SYSTEMSYNTHESISMODELING_API  ssm0systemsynthesismodeling::Ssm0SimModel
     : public  ::ssm0systemsynthesismodeling::Ssm0AbstractSynthesis
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ssm0SimModel();

    /**
     * Destructor
     */
    virtual ~Ssm0SimModel();

private:
    //  Getter method for the Implementation Object
    Ssm0SimModelImpl*  getSsm0SimModelImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSsm0SimModelImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ssm0SimModelImpl*  m_ssm0simmodelImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ssm0SimModel - desc for Ssm0SimModel parameter
     */
    Ssm0SimModel( const Ssm0SimModel& );
    Ssm0SimModel& operator=( const Ssm0SimModel& );

    friend class  Ssm0SimModelDelegate;
    friend class  Ssm0SimModelDispatch;
    friend class  Ssm0SimModelGenImpl;
};

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_undef.h>
#endif //   SSM0SYSTEMSYNTHESISMODELING__SSM0SIMMODEL__HXX
