//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ssm0SimModelContainer
    Filename:   Ssm0SimModelContainer.hxx
    Module:     Ssm0systemsynthesismodeling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef SSM0SYSTEMSYNTHESISMODELING__SSM0SIMMODELCONTAINER__HXX
#define SSM0SYSTEMSYNTHESISMODELING__SSM0SIMMODELCONTAINER__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <Ssm0systemsynthesismodeling/Ssm0AbstractSynthesis.hxx>

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_exports.h>

namespace ssm0systemsynthesismodeling
{
    class Ssm0SimModelContainer;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimModelContainerImpl;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimModelContainerDelegate;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimModelContainerDispatch;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimModelContainerGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SSM0SYSTEMSYNTHESISMODELING_API  ssm0systemsynthesismodeling::Ssm0SimModelContainer
     : public  ::ssm0systemsynthesismodeling::Ssm0AbstractSynthesis
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.2.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getSsm0SimModels( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ssm0SimModelContainer();

    /**
     * Destructor
     */
    virtual ~Ssm0SimModelContainer();

private:
    //  Getter method for the Implementation Object
    Ssm0SimModelContainerImpl*  getSsm0SimModelContainerImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSsm0SimModelContainerImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ssm0SimModelContainerImpl*  m_ssm0simmodelcontainerImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ssm0SimModelContainer - desc for Ssm0SimModelContainer parameter
     */
    Ssm0SimModelContainer( const Ssm0SimModelContainer& );
    Ssm0SimModelContainer& operator=( const Ssm0SimModelContainer& );

    friend class  Ssm0SimModelContainerDelegate;
    friend class  Ssm0SimModelContainerDispatch;
    friend class  Ssm0SimModelContainerGenImpl;
};

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_undef.h>
#endif //   SSM0SYSTEMSYNTHESISMODELING__SSM0SIMMODELCONTAINER__HXX
