//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ssm0SimModelContainerDelegate
    Filename:   Ssm0SimModelContainerDelegate.hxx
    Module:     Ssm0systemsynthesismodeling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef SSM0SYSTEMSYNTHESISMODELING__SSM0SIMMODELCONTAINERDELEGATE_HXX
#define SSM0SYSTEMSYNTHESISMODELING__SSM0SIMMODELCONTAINERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Ssm0systemsynthesismodeling/Ssm0SimModelContainer.hxx>

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_exports.h>

namespace ssm0systemsynthesismodeling
{
    class Ssm0SimModelContainerDelegate;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimModelContainerImpl;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimModelContainer;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimModelContainerGenImpl;
}

namespace ssm0systemsynthesismodeling_alias = ::ssm0systemsynthesismodeling;


class  SSM0SYSTEMSYNTHESISMODELING_API ssm0systemsynthesismodeling_alias::Ssm0SimModelContainerDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Ssm0SimModelContainerDelegate instance
    static Ssm0SimModelContainerDelegate&  getInstance();

    //  Method to create the Ssm0SimModelContainerImpl pointer
    static Ssm0SimModelContainerImpl*  createImpl( Ssm0SimModelContainer&  ifObj );

    //  Method to delete the Ssm0SimModelContainerImpl pointer
    static void deleteImpl( Ssm0SimModelContainerImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.2.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getSsm0SimModelsBase(const Ssm0SimModelContainer &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Generic revisePost operation.
    /// @version Teamcenter 10.1
    /// @param pReviseInput - Input ReviseInput object.
    /// @param vecDeepCopyData - Vector of deep copy data.
    /// @return - Returns an integer value.
    ///
    int  revisePostBase(const Ssm0SimModelContainer &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// Generic saveAsPost operation.
    /// @version Teamcenter 8.1
    /// @param pSavAsInput - Input argument as SaveAsInput object.
    /// @param vecDeepCopyData - vector deepcopy data
    /// @return - Return integer value.
    ///
    int  saveAsPostBase(const Ssm0SimModelContainer &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static Ssm0SimModelContainerDelegate*  m_pInstance;

    Ssm0SimModelContainerDelegate();
    virtual ~Ssm0SimModelContainerDelegate();
    static void setInstance( Ssm0SimModelContainerDelegate*  instance );


private:
    friend class  ::ssm0systemsynthesismodeling::Ssm0SimModelContainerGenImpl;

};

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_undef.h>
#endif  //  SSM0SYSTEMSYNTHESISMODELING__SSM0SIMMODELCONTAINERDELEGATE_HXX
