//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ssm0SimModelDataset
    Filename:   Ssm0SimModelDataset.hxx
    Module:     Ssm0systemsynthesismodeling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef SSM0SYSTEMSYNTHESISMODELING__SSM0SIMMODELDATASET__HXX
#define SSM0SYSTEMSYNTHESISMODELING__SSM0SIMMODELDATASET__HXX

#include <common/tc_deprecation_macros.h>
#include <ae/Dataset.hxx>

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_exports.h>

namespace ssm0systemsynthesismodeling
{
    class Ssm0SimModelDataset;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimModelDatasetImpl;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimModelDatasetDelegate;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimModelDatasetDispatch;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimModelDatasetGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SSM0SYSTEMSYNTHESISMODELING_API  ssm0systemsynthesismodeling::Ssm0SimModelDataset
     : public  ::Teamcenter::Dataset
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ssm0SimModelDataset();

    /**
     * Destructor
     */
    virtual ~Ssm0SimModelDataset();

private:
    //  Getter method for the Implementation Object
    Ssm0SimModelDatasetImpl*  getSsm0SimModelDatasetImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSsm0SimModelDatasetImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ssm0SimModelDatasetImpl*  m_ssm0simmodeldatasetImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ssm0SimModelDataset - desc for Ssm0SimModelDataset parameter
     */
    Ssm0SimModelDataset( const Ssm0SimModelDataset& );
    Ssm0SimModelDataset& operator=( const Ssm0SimModelDataset& );

    friend class  Ssm0SimModelDatasetDelegate;
    friend class  Ssm0SimModelDatasetDispatch;
    friend class  Ssm0SimModelDatasetGenImpl;
};

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_undef.h>
#endif //   SSM0SYSTEMSYNTHESISMODELING__SSM0SIMMODELDATASET__HXX
