//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ssm0SimModelDatasetDelegate
    Filename:   Ssm0SimModelDatasetDelegate.hxx
    Module:     Ssm0systemsynthesismodeling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef SSM0SYSTEMSYNTHESISMODELING__SSM0SIMMODELDATASETDELEGATE_HXX
#define SSM0SYSTEMSYNTHESISMODELING__SSM0SIMMODELDATASETDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Ssm0systemsynthesismodeling/Ssm0SimModelDataset.hxx>

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_exports.h>

namespace ssm0systemsynthesismodeling
{
    class Ssm0SimModelDatasetDelegate;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimModelDatasetImpl;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimModelDataset;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimModelDatasetGenImpl;
}

namespace ssm0systemsynthesismodeling_alias = ::ssm0systemsynthesismodeling;


class  SSM0SYSTEMSYNTHESISMODELING_API ssm0systemsynthesismodeling_alias::Ssm0SimModelDatasetDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Ssm0SimModelDatasetDelegate instance
    static Ssm0SimModelDatasetDelegate&  getInstance();

    //  Method to create the Ssm0SimModelDatasetImpl pointer
    static Ssm0SimModelDatasetImpl*  createImpl( Ssm0SimModelDataset&  ifObj );

    //  Method to delete the Ssm0SimModelDatasetImpl pointer
    static void deleteImpl( Ssm0SimModelDatasetImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static Ssm0SimModelDatasetDelegate*  m_pInstance;

    Ssm0SimModelDatasetDelegate();
    virtual ~Ssm0SimModelDatasetDelegate();
    static void setInstance( Ssm0SimModelDatasetDelegate*  instance );


private:
    friend class  ::ssm0systemsynthesismodeling::Ssm0SimModelDatasetGenImpl;

};

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_undef.h>
#endif  //  SSM0SYSTEMSYNTHESISMODELING__SSM0SIMMODELDATASETDELEGATE_HXX
