//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ssm0SimModelDelegate
    Filename:   Ssm0SimModelDelegate.hxx
    Module:     Ssm0systemsynthesismodeling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef SSM0SYSTEMSYNTHESISMODELING__SSM0SIMMODELDELEGATE_HXX
#define SSM0SYSTEMSYNTHESISMODELING__SSM0SIMMODELDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Ssm0systemsynthesismodeling/Ssm0SimModel.hxx>

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_exports.h>

namespace ssm0systemsynthesismodeling
{
    class Ssm0SimModelDelegate;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimModelImpl;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimModel;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimModelGenImpl;
}

namespace ssm0systemsynthesismodeling_alias = ::ssm0systemsynthesismodeling;


class  SSM0SYSTEMSYNTHESISMODELING_API ssm0systemsynthesismodeling_alias::Ssm0SimModelDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Ssm0SimModelDelegate instance
    static Ssm0SimModelDelegate&  getInstance();

    //  Method to create the Ssm0SimModelImpl pointer
    static Ssm0SimModelImpl*  createImpl( Ssm0SimModel&  ifObj );

    //  Method to delete the Ssm0SimModelImpl pointer
    static void deleteImpl( Ssm0SimModelImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Ssm0SimModel &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Ssm0SimModelDelegate*  m_pInstance;

    Ssm0SimModelDelegate();
    virtual ~Ssm0SimModelDelegate();
    static void setInstance( Ssm0SimModelDelegate*  instance );


private:
    friend class  ::ssm0systemsynthesismodeling::Ssm0SimModelGenImpl;

};

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_undef.h>
#endif  //  SSM0SYSTEMSYNTHESISMODELING__SSM0SIMMODELDELEGATE_HXX
