//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ssm0SimProjectDataset
    Filename:   Ssm0SimProjectDataset.hxx
    Module:     Ssm0systemsynthesismodeling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef SSM0SYSTEMSYNTHESISMODELING__SSM0SIMPROJECTDATASET__HXX
#define SSM0SYSTEMSYNTHESISMODELING__SSM0SIMPROJECTDATASET__HXX

#include <common/tc_deprecation_macros.h>
#include <ae/Dataset.hxx>

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_exports.h>

namespace ssm0systemsynthesismodeling
{
    class Ssm0SimProjectDataset;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimProjectDatasetImpl;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimProjectDatasetDelegate;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimProjectDatasetDispatch;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimProjectDatasetGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SSM0SYSTEMSYNTHESISMODELING_API  ssm0systemsynthesismodeling::Ssm0SimProjectDataset
     : public  ::Teamcenter::Dataset
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ssm0SimProjectDataset();

    /**
     * Destructor
     */
    virtual ~Ssm0SimProjectDataset();

private:
    //  Getter method for the Implementation Object
    Ssm0SimProjectDatasetImpl*  getSsm0SimProjectDatasetImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSsm0SimProjectDatasetImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ssm0SimProjectDatasetImpl*  m_ssm0simprojectdatasetImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ssm0SimProjectDataset - desc for Ssm0SimProjectDataset parameter
     */
    Ssm0SimProjectDataset( const Ssm0SimProjectDataset& );
    Ssm0SimProjectDataset& operator=( const Ssm0SimProjectDataset& );

    friend class  Ssm0SimProjectDatasetDelegate;
    friend class  Ssm0SimProjectDatasetDispatch;
    friend class  Ssm0SimProjectDatasetGenImpl;
};

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_undef.h>
#endif //   SSM0SYSTEMSYNTHESISMODELING__SSM0SIMPROJECTDATASET__HXX
