//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ssm0SimRealizationTemplate
    Filename:   Ssm0SimRealizationTemplate.hxx
    Module:     Ssm0systemsynthesismodeling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef SSM0SYSTEMSYNTHESISMODELING__SSM0SIMREALIZATIONTEMPLATE__HXX
#define SSM0SYSTEMSYNTHESISMODELING__SSM0SIMREALIZATIONTEMPLATE__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <Ssm0systemsynthesismodeling/Ssm0AbstractTemplate.hxx>

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_exports.h>

namespace ssm0systemsynthesismodeling
{
    class Ssm0SimRealizationTemplate;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimRealizationTemplateImpl;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimRealizationTemplateDelegate;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimRealizationTemplateDispatch;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimRealizationTemplateGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SSM0SYSTEMSYNTHESISMODELING_API  ssm0systemsynthesismodeling::Ssm0SimRealizationTemplate
     : public  ::ssm0systemsynthesismodeling::Ssm0AbstractTemplate
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.2.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getSsm0Models( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ssm0SimRealizationTemplate();

    /**
     * Destructor
     */
    virtual ~Ssm0SimRealizationTemplate();

private:
    //  Getter method for the Implementation Object
    Ssm0SimRealizationTemplateImpl*  getSsm0SimRealizationTemplateImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSsm0SimRealizationTemplateImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ssm0SimRealizationTemplateImpl*  m_ssm0simrealizationtemplateImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ssm0SimRealizationTemplate - desc for Ssm0SimRealizationTemplate parameter
     */
    Ssm0SimRealizationTemplate( const Ssm0SimRealizationTemplate& );
    Ssm0SimRealizationTemplate& operator=( const Ssm0SimRealizationTemplate& );

    friend class  Ssm0SimRealizationTemplateDelegate;
    friend class  Ssm0SimRealizationTemplateDispatch;
    friend class  Ssm0SimRealizationTemplateGenImpl;
};

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_undef.h>
#endif //   SSM0SYSTEMSYNTHESISMODELING__SSM0SIMREALIZATIONTEMPLATE__HXX
