//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ssm0SimStudy
    Filename:   Ssm0SimStudy.hxx
    Module:     Ssm0systemsynthesismodeling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef SSM0SYSTEMSYNTHESISMODELING__SSM0SIMSTUDY__HXX
#define SSM0SYSTEMSYNTHESISMODELING__SSM0SIMSTUDY__HXX

#include <common/tc_deprecation_macros.h>
#include <Ssm0systemsynthesismodeling/Ssm0AbstractSynthesis.hxx>

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_exports.h>

namespace ssm0systemsynthesismodeling
{
    class Ssm0SimStudy;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimStudyImpl;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimStudyDelegate;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimStudyDispatch;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimStudyGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SSM0SYSTEMSYNTHESISMODELING_API  ssm0systemsynthesismodeling::Ssm0SimStudy
     : public  ::ssm0systemsynthesismodeling::Ssm0AbstractSynthesis
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ssm0SimStudy();

    /**
     * Destructor
     */
    virtual ~Ssm0SimStudy();

private:
    //  Getter method for the Implementation Object
    Ssm0SimStudyImpl*  getSsm0SimStudyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSsm0SimStudyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ssm0SimStudyImpl*  m_ssm0simstudyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ssm0SimStudy - desc for Ssm0SimStudy parameter
     */
    Ssm0SimStudy( const Ssm0SimStudy& );
    Ssm0SimStudy& operator=( const Ssm0SimStudy& );

    friend class  Ssm0SimStudyDelegate;
    friend class  Ssm0SimStudyDispatch;
    friend class  Ssm0SimStudyGenImpl;
};

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_undef.h>
#endif //   SSM0SYSTEMSYNTHESISMODELING__SSM0SIMSTUDY__HXX
