//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ssm0SimStudyDelegate
    Filename:   Ssm0SimStudyDelegate.hxx
    Module:     Ssm0systemsynthesismodeling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef SSM0SYSTEMSYNTHESISMODELING__SSM0SIMSTUDYDELEGATE_HXX
#define SSM0SYSTEMSYNTHESISMODELING__SSM0SIMSTUDYDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Ssm0systemsynthesismodeling/Ssm0SimStudy.hxx>

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_exports.h>

namespace ssm0systemsynthesismodeling
{
    class Ssm0SimStudyDelegate;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimStudyImpl;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimStudy;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimStudyGenImpl;
}

namespace ssm0systemsynthesismodeling_alias = ::ssm0systemsynthesismodeling;


class  SSM0SYSTEMSYNTHESISMODELING_API ssm0systemsynthesismodeling_alias::Ssm0SimStudyDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Ssm0SimStudyDelegate instance
    static Ssm0SimStudyDelegate&  getInstance();

    //  Method to create the Ssm0SimStudyImpl pointer
    static Ssm0SimStudyImpl*  createImpl( Ssm0SimStudy&  ifObj );

    //  Method to delete the Ssm0SimStudyImpl pointer
    static void deleteImpl( Ssm0SimStudyImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Ssm0SimStudy &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Ssm0SimStudyDelegate*  m_pInstance;

    Ssm0SimStudyDelegate();
    virtual ~Ssm0SimStudyDelegate();
    static void setInstance( Ssm0SimStudyDelegate*  instance );


private:
    friend class  ::ssm0systemsynthesismodeling::Ssm0SimStudyGenImpl;

};

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_undef.h>
#endif  //  SSM0SYSTEMSYNTHESISMODELING__SSM0SIMSTUDYDELEGATE_HXX
