//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ssm0SimTemplateContainer
    Filename:   Ssm0SimTemplateContainer.hxx
    Module:     Ssm0systemsynthesismodeling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef SSM0SYSTEMSYNTHESISMODELING__SSM0SIMTEMPLATECONTAINER__HXX
#define SSM0SYSTEMSYNTHESISMODELING__SSM0SIMTEMPLATECONTAINER__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <Ssm0systemsynthesismodeling/Ssm0AbstractSynthesis.hxx>

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_exports.h>

namespace ssm0systemsynthesismodeling
{
    class Ssm0SimTemplateContainer;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimTemplateContainerImpl;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimTemplateContainerDelegate;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimTemplateContainerDispatch;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimTemplateContainerGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SSM0SYSTEMSYNTHESISMODELING_API  ssm0systemsynthesismodeling::Ssm0SimTemplateContainer
     : public  ::ssm0systemsynthesismodeling::Ssm0AbstractSynthesis
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.2.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getSsm0Templates( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ssm0SimTemplateContainer();

    /**
     * Destructor
     */
    virtual ~Ssm0SimTemplateContainer();

private:
    //  Getter method for the Implementation Object
    Ssm0SimTemplateContainerImpl*  getSsm0SimTemplateContainerImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSsm0SimTemplateContainerImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ssm0SimTemplateContainerImpl*  m_ssm0simtemplatecontainerImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ssm0SimTemplateContainer - desc for Ssm0SimTemplateContainer parameter
     */
    Ssm0SimTemplateContainer( const Ssm0SimTemplateContainer& );
    Ssm0SimTemplateContainer& operator=( const Ssm0SimTemplateContainer& );

    friend class  Ssm0SimTemplateContainerDelegate;
    friend class  Ssm0SimTemplateContainerDispatch;
    friend class  Ssm0SimTemplateContainerGenImpl;
};

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_undef.h>
#endif //   SSM0SYSTEMSYNTHESISMODELING__SSM0SIMTEMPLATECONTAINER__HXX
