//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ssm0SimTemplateContainerDelegate
    Filename:   Ssm0SimTemplateContainerDelegate.hxx
    Module:     Ssm0systemsynthesismodeling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef SSM0SYSTEMSYNTHESISMODELING__SSM0SIMTEMPLATECONTAINERDELEGATE_HXX
#define SSM0SYSTEMSYNTHESISMODELING__SSM0SIMTEMPLATECONTAINERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <Ssm0systemsynthesismodeling/Ssm0SimTemplateContainer.hxx>

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_exports.h>

namespace ssm0systemsynthesismodeling
{
    class Ssm0SimTemplateContainerDelegate;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimTemplateContainerImpl;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimTemplateContainer;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimTemplateContainerGenImpl;
}

namespace ssm0systemsynthesismodeling_alias = ::ssm0systemsynthesismodeling;


class  SSM0SYSTEMSYNTHESISMODELING_API ssm0systemsynthesismodeling_alias::Ssm0SimTemplateContainerDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Ssm0SimTemplateContainerDelegate instance
    static Ssm0SimTemplateContainerDelegate&  getInstance();

    //  Method to create the Ssm0SimTemplateContainerImpl pointer
    static Ssm0SimTemplateContainerImpl*  createImpl( Ssm0SimTemplateContainer&  ifObj );

    //  Method to delete the Ssm0SimTemplateContainerImpl pointer
    static void deleteImpl( Ssm0SimTemplateContainerImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.2.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getSsm0TemplatesBase(const Ssm0SimTemplateContainer &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Generic revisePost operation.
    /// @version Teamcenter 10.1
    /// @param pReviseInput - Input ReviseInput object.
    /// @param vecDeepCopyData - Vector of deep copy data.
    /// @return - Returns an integer value.
    ///
    int  revisePostBase(const Ssm0SimTemplateContainer &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// Generic saveAsPost operation.
    /// @version Teamcenter 8.1
    /// @param pSavAsInput - Input argument as SaveAsInput object.
    /// @param vecDeepCopyData - vector deepcopy data
    /// @return - Return integer value.
    ///
    int  saveAsPostBase(const Ssm0SimTemplateContainer &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static Ssm0SimTemplateContainerDelegate*  m_pInstance;

    Ssm0SimTemplateContainerDelegate();
    virtual ~Ssm0SimTemplateContainerDelegate();
    static void setInstance( Ssm0SimTemplateContainerDelegate*  instance );


private:
    friend class  ::ssm0systemsynthesismodeling::Ssm0SimTemplateContainerGenImpl;

};

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_undef.h>
#endif  //  SSM0SYSTEMSYNTHESISMODELING__SSM0SIMTEMPLATECONTAINERDELEGATE_HXX
