//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ssm0SimTemplateDataset
    Filename:   Ssm0SimTemplateDataset.hxx
    Module:     Ssm0systemsynthesismodeling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef SSM0SYSTEMSYNTHESISMODELING__SSM0SIMTEMPLATEDATASET__HXX
#define SSM0SYSTEMSYNTHESISMODELING__SSM0SIMTEMPLATEDATASET__HXX

#include <common/tc_deprecation_macros.h>
#include <ae/Dataset.hxx>

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_exports.h>

namespace ssm0systemsynthesismodeling
{
    class Ssm0SimTemplateDataset;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimTemplateDatasetImpl;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimTemplateDatasetDelegate;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimTemplateDatasetDispatch;
}
namespace ssm0systemsynthesismodeling
{
    class Ssm0SimTemplateDatasetGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SSM0SYSTEMSYNTHESISMODELING_API  ssm0systemsynthesismodeling::Ssm0SimTemplateDataset
     : public  ::Teamcenter::Dataset
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ssm0SimTemplateDataset();

    /**
     * Destructor
     */
    virtual ~Ssm0SimTemplateDataset();

private:
    //  Getter method for the Implementation Object
    Ssm0SimTemplateDatasetImpl*  getSsm0SimTemplateDatasetImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSsm0SimTemplateDatasetImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ssm0SimTemplateDatasetImpl*  m_ssm0simtemplatedatasetImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ssm0SimTemplateDataset - desc for Ssm0SimTemplateDataset parameter
     */
    Ssm0SimTemplateDataset( const Ssm0SimTemplateDataset& );
    Ssm0SimTemplateDataset& operator=( const Ssm0SimTemplateDataset& );

    friend class  Ssm0SimTemplateDatasetDelegate;
    friend class  Ssm0SimTemplateDatasetDispatch;
    friend class  Ssm0SimTemplateDatasetGenImpl;
};

#include <Ssm0systemsynthesismodeling/libssm0systemsynthesismodeling_undef.h>
#endif //   SSM0SYSTEMSYNTHESISMODELING__SSM0SIMTEMPLATEDATASET__HXX
