//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Val1ValResult
    Filename:   Val1ValResult.hxx
    Module:     Val1cfgvalidation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef VAL1CFGVALIDATION__VAL1VALRESULT__HXX
#define VAL1CFGVALIDATION__VAL1VALRESULT__HXX

#include <common/tc_deprecation_macros.h>
#include <validation/ValidationResult.hxx>

#include <Val1cfgvalidation/libval1cfgvalidation_exports.h>

namespace val1cfgvalidation
{
    class Val1ValResult;
}
namespace val1cfgvalidation
{
    class Val1ValResultImpl;
}
namespace val1cfgvalidation
{
    class Val1ValResultDelegate;
}
namespace val1cfgvalidation
{
    class Val1ValResultDispatch;
}
namespace val1cfgvalidation
{
    class Val1ValResultGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VAL1CFGVALIDATION_API  val1cfgvalidation::Val1ValResult
     : public  ::Teamcenter::ValidationResult
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Val1ValResult();

    /**
     * Destructor
     */
    virtual ~Val1ValResult();

private:
    //  Getter method for the Implementation Object
    Val1ValResultImpl*  getVal1ValResultImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setVal1ValResultImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Val1ValResultImpl*  m_val1valresultImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Val1ValResult - desc for Val1ValResult parameter
     */
    Val1ValResult( const Val1ValResult& );
    Val1ValResult& operator=( const Val1ValResult& );

    friend class  Val1ValResultDelegate;
    friend class  Val1ValResultDispatch;
    friend class  Val1ValResultGenImpl;
};

#include <Val1cfgvalidation/libval1cfgvalidation_undef.h>
#endif //   VAL1CFGVALIDATION__VAL1VALRESULT__HXX
