//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Adc0ChangeNotice
    Filename:   Adc0ChangeNotice.hxx
    Module:     adschangemanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ADSCHANGEMANAGEMENT__ADC0CHANGENOTICE__HXX
#define TEAMCENTER__ADSCHANGEMANAGEMENT__ADC0CHANGENOTICE__HXX

#include <common/tc_deprecation_macros.h>
#include <cm/ChangeNotice.hxx>

#include <adschangemanagement/libadschangemanagement_exports.h>

namespace Teamcenter
{
    namespace adschangemanagement
    {
        class Adc0ChangeNotice;
    }
}
namespace Teamcenter
{
    namespace adschangemanagement
    {
        class Adc0ChangeNoticeImpl;
    }
}
namespace Teamcenter
{
    namespace adschangemanagement
    {
        class Adc0ChangeNoticeDelegate;
    }
}
namespace Teamcenter
{
    namespace adschangemanagement
    {
        class Adc0ChangeNoticeDispatch;
    }
}
namespace Teamcenter
{
    namespace adschangemanagement
    {
        class Adc0ChangeNoticeGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ADSCHANGEMANAGEMENT_API  Teamcenter::adschangemanagement::Adc0ChangeNotice
     : public  ::Teamcenter::ChangeNotice
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Adc0ChangeNotice();

    /**
     * Destructor
     */
    virtual ~Adc0ChangeNotice();

private:
    //  Getter method for the Implementation Object
    Adc0ChangeNoticeImpl*  getAdc0ChangeNoticeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAdc0ChangeNoticeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Adc0ChangeNoticeImpl*  m_adc0changenoticeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Adc0ChangeNotice - desc for Adc0ChangeNotice parameter
     */
    Adc0ChangeNotice( const Adc0ChangeNotice& );
    Adc0ChangeNotice& operator=( const Adc0ChangeNotice& );

    friend class  Adc0ChangeNoticeDelegate;
    friend class  Adc0ChangeNoticeDispatch;
    friend class  Adc0ChangeNoticeGenImpl;
};

#include <adschangemanagement/libadschangemanagement_undef.h>
#endif //   TEAMCENTER__ADSCHANGEMANAGEMENT__ADC0CHANGENOTICE__HXX
