//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Adc0ChangeNoticeRevision
    Filename:   Adc0ChangeNoticeRevision.hxx
    Module:     adschangemanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ADSCHANGEMANAGEMENT__ADC0CHANGENOTICEREVISION__HXX
#define TEAMCENTER__ADSCHANGEMANAGEMENT__ADC0CHANGENOTICEREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <cm/ChangeNoticeRevision.hxx>

#include <adschangemanagement/libadschangemanagement_exports.h>

namespace Teamcenter
{
    namespace adschangemanagement
    {
        class Adc0ChangeNoticeRevision;
    }
}
namespace Teamcenter
{
    namespace adschangemanagement
    {
        class Adc0ChangeNoticeRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace adschangemanagement
    {
        class Adc0ChangeNoticeRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace adschangemanagement
    {
        class Adc0ChangeNoticeRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace adschangemanagement
    {
        class Adc0ChangeNoticeRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ADSCHANGEMANAGEMENT_API  Teamcenter::adschangemanagement::Adc0ChangeNoticeRevision
     : public  ::Teamcenter::ChangeNoticeRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Adc0ChangeNoticeRevision();

    /**
     * Destructor
     */
    virtual ~Adc0ChangeNoticeRevision();

private:
    //  Getter method for the Implementation Object
    Adc0ChangeNoticeRevisionImpl*  getAdc0ChangeNoticeRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAdc0ChangeNoticeRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Adc0ChangeNoticeRevisionImpl*  m_adc0changenoticerevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Adc0ChangeNoticeRevision - desc for Adc0ChangeNoticeRevision parameter
     */
    Adc0ChangeNoticeRevision( const Adc0ChangeNoticeRevision& );
    Adc0ChangeNoticeRevision& operator=( const Adc0ChangeNoticeRevision& );

    friend class  Adc0ChangeNoticeRevisionDelegate;
    friend class  Adc0ChangeNoticeRevisionDispatch;
    friend class  Adc0ChangeNoticeRevisionGenImpl;
};

#include <adschangemanagement/libadschangemanagement_undef.h>
#endif //   TEAMCENTER__ADSCHANGEMANAGEMENT__ADC0CHANGENOTICEREVISION__HXX
