//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Adc0ChangeRqstRevision
    Filename:   Adc0ChangeRqstRevision.hxx
    Module:     adschangemanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ADSCHANGEMANAGEMENT__ADC0CHANGERQSTREVISION__HXX
#define TEAMCENTER__ADSCHANGEMANAGEMENT__ADC0CHANGERQSTREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <adschangemanagement/Adc0GnChangeRqstRevision.hxx>

#include <adschangemanagement/libadschangemanagement_exports.h>

namespace Teamcenter
{
    namespace adschangemanagement
    {
        class Adc0ChangeRqstRevision;
    }
}
namespace Teamcenter
{
    namespace adschangemanagement
    {
        class Adc0ChangeRqstRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace adschangemanagement
    {
        class Adc0ChangeRqstRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace adschangemanagement
    {
        class Adc0ChangeRqstRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace adschangemanagement
    {
        class Adc0ChangeRqstRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ADSCHANGEMANAGEMENT_API  Teamcenter::adschangemanagement::Adc0ChangeRqstRevision
     : public  ::Teamcenter::adschangemanagement::Adc0GnChangeRqstRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Adc0ChangeRqstRevision();

    /**
     * Destructor
     */
    virtual ~Adc0ChangeRqstRevision();

private:
    //  Getter method for the Implementation Object
    Adc0ChangeRqstRevisionImpl*  getAdc0ChangeRqstRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAdc0ChangeRqstRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Adc0ChangeRqstRevisionImpl*  m_adc0changerqstrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Adc0ChangeRqstRevision - desc for Adc0ChangeRqstRevision parameter
     */
    Adc0ChangeRqstRevision( const Adc0ChangeRqstRevision& );
    Adc0ChangeRqstRevision& operator=( const Adc0ChangeRqstRevision& );

    friend class  Adc0ChangeRqstRevisionDelegate;
    friend class  Adc0ChangeRqstRevisionDispatch;
    friend class  Adc0ChangeRqstRevisionGenImpl;
};

#include <adschangemanagement/libadschangemanagement_undef.h>
#endif //   TEAMCENTER__ADSCHANGEMANAGEMENT__ADC0CHANGERQSTREVISION__HXX
