//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Adc0DevRqstRevision
    Filename:   Adc0DevRqstRevision.hxx
    Module:     adschangemanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ADSCHANGEMANAGEMENT__ADC0DEVRQSTREVISION__HXX
#define TEAMCENTER__ADSCHANGEMANAGEMENT__ADC0DEVRQSTREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <cm/ChangeRequestRevision.hxx>

#include <adschangemanagement/libadschangemanagement_exports.h>

namespace Teamcenter
{
    namespace adschangemanagement
    {
        class Adc0DevRqstRevision;
    }
}
namespace Teamcenter
{
    namespace adschangemanagement
    {
        class Adc0DevRqstRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace adschangemanagement
    {
        class Adc0DevRqstRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace adschangemanagement
    {
        class Adc0DevRqstRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace adschangemanagement
    {
        class Adc0DevRqstRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ADSCHANGEMANAGEMENT_API  Teamcenter::adschangemanagement::Adc0DevRqstRevision
     : public  ::Teamcenter::ChangeRequestRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Adc0DevRqstRevision();

    /**
     * Destructor
     */
    virtual ~Adc0DevRqstRevision();

private:
    //  Getter method for the Implementation Object
    Adc0DevRqstRevisionImpl*  getAdc0DevRqstRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAdc0DevRqstRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Adc0DevRqstRevisionImpl*  m_adc0devrqstrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Adc0DevRqstRevision - desc for Adc0DevRqstRevision parameter
     */
    Adc0DevRqstRevision( const Adc0DevRqstRevision& );
    Adc0DevRqstRevision& operator=( const Adc0DevRqstRevision& );

    friend class  Adc0DevRqstRevisionDelegate;
    friend class  Adc0DevRqstRevisionDispatch;
    friend class  Adc0DevRqstRevisionGenImpl;
};

#include <adschangemanagement/libadschangemanagement_undef.h>
#endif //   TEAMCENTER__ADSCHANGEMANAGEMENT__ADC0DEVRQSTREVISION__HXX
