//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Adc0GnChangeRqst
    Filename:   Adc0GnChangeRqst.hxx
    Module:     adschangemanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ADSCHANGEMANAGEMENT__ADC0GNCHANGERQST__HXX
#define TEAMCENTER__ADSCHANGEMANAGEMENT__ADC0GNCHANGERQST__HXX

#include <common/tc_deprecation_macros.h>
#include <cm/ChangeRequest.hxx>

#include <adschangemanagement/libadschangemanagement_exports.h>

namespace Teamcenter
{
    namespace adschangemanagement
    {
        class Adc0GnChangeRqst;
    }
}
namespace Teamcenter
{
    namespace adschangemanagement
    {
        class Adc0GnChangeRqstImpl;
    }
}
namespace Teamcenter
{
    namespace adschangemanagement
    {
        class Adc0GnChangeRqstDelegate;
    }
}
namespace Teamcenter
{
    namespace adschangemanagement
    {
        class Adc0GnChangeRqstDispatch;
    }
}
namespace Teamcenter
{
    namespace adschangemanagement
    {
        class Adc0GnChangeRqstGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ADSCHANGEMANAGEMENT_API  Teamcenter::adschangemanagement::Adc0GnChangeRqst
     : public  ::Teamcenter::ChangeRequest
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Adc0GnChangeRqst();

    /**
     * Destructor
     */
    virtual ~Adc0GnChangeRqst();

private:
    //  Getter method for the Implementation Object
    Adc0GnChangeRqstImpl*  getAdc0GnChangeRqstImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAdc0GnChangeRqstImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Adc0GnChangeRqstImpl*  m_adc0gnchangerqstImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Adc0GnChangeRqst - desc for Adc0GnChangeRqst parameter
     */
    Adc0GnChangeRqst( const Adc0GnChangeRqst& );
    Adc0GnChangeRqst& operator=( const Adc0GnChangeRqst& );

    friend class  Adc0GnChangeRqstDelegate;
    friend class  Adc0GnChangeRqstDispatch;
    friend class  Adc0GnChangeRqstGenImpl;
};

#include <adschangemanagement/libadschangemanagement_undef.h>
#endif //   TEAMCENTER__ADSCHANGEMANAGEMENT__ADC0GNCHANGERQST__HXX
