//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Adc0GnChangeRqstRevision
    Filename:   Adc0GnChangeRqstRevision.hxx
    Module:     adschangemanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ADSCHANGEMANAGEMENT__ADC0GNCHANGERQSTREVISION__HXX
#define TEAMCENTER__ADSCHANGEMANAGEMENT__ADC0GNCHANGERQSTREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <cm/ChangeRequestRevision.hxx>

#include <adschangemanagement/libadschangemanagement_exports.h>

namespace Teamcenter
{
    namespace adschangemanagement
    {
        class Adc0GnChangeRqstRevision;
    }
}
namespace Teamcenter
{
    namespace adschangemanagement
    {
        class Adc0GnChangeRqstRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace adschangemanagement
    {
        class Adc0GnChangeRqstRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace adschangemanagement
    {
        class Adc0GnChangeRqstRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace adschangemanagement
    {
        class Adc0GnChangeRqstRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ADSCHANGEMANAGEMENT_API  Teamcenter::adschangemanagement::Adc0GnChangeRqstRevision
     : public  ::Teamcenter::ChangeRequestRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Adc0GnChangeRqstRevision();

    /**
     * Destructor
     */
    virtual ~Adc0GnChangeRqstRevision();

private:
    //  Getter method for the Implementation Object
    Adc0GnChangeRqstRevisionImpl*  getAdc0GnChangeRqstRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAdc0GnChangeRqstRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Adc0GnChangeRqstRevisionImpl*  m_adc0gnchangerqstrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Adc0GnChangeRqstRevision - desc for Adc0GnChangeRqstRevision parameter
     */
    Adc0GnChangeRqstRevision( const Adc0GnChangeRqstRevision& );
    Adc0GnChangeRqstRevision& operator=( const Adc0GnChangeRqstRevision& );

    friend class  Adc0GnChangeRqstRevisionDelegate;
    friend class  Adc0GnChangeRqstRevisionDispatch;
    friend class  Adc0GnChangeRqstRevisionGenImpl;
};

#include <adschangemanagement/libadschangemanagement_undef.h>
#endif //   TEAMCENTER__ADSCHANGEMANAGEMENT__ADC0GNCHANGERQSTREVISION__HXX
