//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Adc0Task
    Filename:   Adc0Task.hxx
    Module:     adschangemanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ADSCHANGEMANAGEMENT__ADC0TASK__HXX
#define TEAMCENTER__ADSCHANGEMANAGEMENT__ADC0TASK__HXX

#include <common/tc_deprecation_macros.h>
#include <schmgt/ScheduleTask.hxx>

#include <adschangemanagement/libadschangemanagement_exports.h>

namespace Teamcenter
{
    namespace adschangemanagement
    {
        class Adc0Task;
    }
}
namespace Teamcenter
{
    namespace adschangemanagement
    {
        class Adc0TaskImpl;
    }
}
namespace Teamcenter
{
    namespace adschangemanagement
    {
        class Adc0TaskDelegate;
    }
}
namespace Teamcenter
{
    namespace adschangemanagement
    {
        class Adc0TaskDispatch;
    }
}
namespace Teamcenter
{
    namespace adschangemanagement
    {
        class Adc0TaskGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ADSCHANGEMANAGEMENT_API  Teamcenter::adschangemanagement::Adc0Task
     : public  ::Teamcenter::ScheduleTask
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Adc0Task();

    /**
     * Destructor
     */
    virtual ~Adc0Task();

private:
    //  Getter method for the Implementation Object
    Adc0TaskImpl*  getAdc0TaskImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAdc0TaskImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Adc0TaskImpl*  m_adc0taskImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Adc0Task - desc for Adc0Task parameter
     */
    Adc0Task( const Adc0Task& );
    Adc0Task& operator=( const Adc0Task& );

    friend class  Adc0TaskDelegate;
    friend class  Adc0TaskDispatch;
    friend class  Adc0TaskGenImpl;
};

#include <adschangemanagement/libadschangemanagement_undef.h>
#endif //   TEAMCENTER__ADSCHANGEMANAGEMENT__ADC0TASK__HXX
