//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  adschangemanagement

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libadschangemanagement

#if !defined(LIBADSCHANGEMANAGEMENT) && !defined(IPLIB)
#   error IPLIB or LIBADSCHANGEMANAGEMENT is not defined
#endif

/* Handwritten code should use ADSCHANGEMANAGEMENT_API, not ADSCHANGEMANAGEMENTEXPORT */

#define ADSCHANGEMANAGEMENT_API ADSCHANGEMANAGEMENTEXPORT

#if IPLIB==libadschangemanagement || defined(LIBADSCHANGEMANAGEMENT)
#   if defined(__lint)
#       define ADSCHANGEMANAGEMENTEXPORT       __export(adschangemanagement)
#       define ADSCHANGEMANAGEMENTGLOBAL       extern __global(adschangemanagement)
#       define ADSCHANGEMANAGEMENTPRIVATE      extern __private(adschangemanagement)
#   elif defined(_WIN32)
#       define ADSCHANGEMANAGEMENTEXPORT       __declspec(dllexport)
#       define ADSCHANGEMANAGEMENTGLOBAL       extern __declspec(dllexport)
#       define ADSCHANGEMANAGEMENTPRIVATE      extern
#   else
#       define ADSCHANGEMANAGEMENTEXPORT
#       define ADSCHANGEMANAGEMENTGLOBAL       extern
#       define ADSCHANGEMANAGEMENTPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define ADSCHANGEMANAGEMENTEXPORT       __export(adschangemanagement)
#       define ADSCHANGEMANAGEMENTGLOBAL       extern __global(adschangemanagement)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define ADSCHANGEMANAGEMENTEXPORT      __declspec(dllimport)
#       define ADSCHANGEMANAGEMENTGLOBAL       extern __declspec(dllimport)
#   else
#       define ADSCHANGEMANAGEMENTEXPORT
#       define ADSCHANGEMANAGEMENTGLOBAL       extern
#   endif
#endif
