//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ADSDesignDelegate
    Filename:   ADSDesignDelegate.hxx
    Module:     adsfoundation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ADSFOUNDATION__ADSDESIGNDELEGATE_HXX
#define TEAMCENTER__ADSFOUNDATION__ADSDESIGNDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <adsfoundation/ADSDesign.hxx>

#include <adsfoundation/libadsfoundation_exports.h>

namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADSDesignDelegate;
    }
}
namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADSDesignImpl;
    }
}
namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADSDesign;
    }
}
namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADSDesignGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  ADSFOUNDATION_API Teamcenter_alias::adsfoundation::ADSDesignDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ADSDesignDelegate instance
    static ADSDesignDelegate&  getInstance();

    //  Method to create the ADSDesignImpl pointer
    static ADSDesignImpl*  createImpl( ADSDesign&  ifObj );

    //  Method to delete the ADSDesignImpl pointer
    static void deleteImpl( ADSDesignImpl*  impl );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAdssource_doc_categoryBase(ADSDesign &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAdssource_tdoc_categoryBase(ADSDesign &ifObj,  const std::string &value, bool isNull );


    ///
    /// dummy_for_adsdesign
    /// @version Tc 8
    /// @return - dummy_for_adsdesign
    ///
    int  dummy_for_adsdesignBase(const ADSDesign &ifObj  );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const ADSDesign &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const ADSDesign &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static ADSDesignDelegate*  m_pInstance;

    ADSDesignDelegate();
    virtual ~ADSDesignDelegate();
    static void setInstance( ADSDesignDelegate*  instance );


private:
    friend class  ::Teamcenter::adsfoundation::ADSDesignGenImpl;

};

#include <adsfoundation/libadsfoundation_undef.h>
#endif  //  TEAMCENTER__ADSFOUNDATION__ADSDESIGNDELEGATE_HXX
