//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ADSDrawing
    Filename:   ADSDrawing.hxx
    Module:     adsfoundation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ADSFOUNDATION__ADSDRAWING__HXX
#define TEAMCENTER__ADSFOUNDATION__ADSDRAWING__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/Drawing.hxx>

#include <adsfoundation/libadsfoundation_exports.h>

namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADSDrawing;
    }
}
namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADSDrawingImpl;
    }
}
namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADSDrawingDelegate;
    }
}
namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADSDrawingDispatch;
    }
}
namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADSDrawingGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ADSFOUNDATION_API  Teamcenter::adsfoundation::ADSDrawing
     : public  ::Teamcenter::Drawing
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAdssource_doc_category( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAdssource_tdoc_category( const std::string &value, bool isNull=false );

    ///
    /// dummy_for_adsDrawing
    /// @version Tc 8
    /// @return - dummy_for_adsDrawing
    ///
    int  dummy_for_adsDrawing(  );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ADSDrawing();

    /**
     * Destructor
     */
    virtual ~ADSDrawing();

private:
    //  Getter method for the Implementation Object
    ADSDrawingImpl*  getADSDrawingImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setADSDrawingImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ADSDrawingImpl*  m_adsdrawingImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ADSDrawing - desc for ADSDrawing parameter
     */
    ADSDrawing( const ADSDrawing& );
    ADSDrawing& operator=( const ADSDrawing& );

    friend class  ADSDrawingDelegate;
    friend class  ADSDrawingDispatch;
    friend class  ADSDrawingGenImpl;
};

#include <adsfoundation/libadsfoundation_undef.h>
#endif //   TEAMCENTER__ADSFOUNDATION__ADSDRAWING__HXX
