//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ADSDrawingDelegate
    Filename:   ADSDrawingDelegate.hxx
    Module:     adsfoundation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ADSFOUNDATION__ADSDRAWINGDELEGATE_HXX
#define TEAMCENTER__ADSFOUNDATION__ADSDRAWINGDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <adsfoundation/ADSDrawing.hxx>

#include <adsfoundation/libadsfoundation_exports.h>

namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADSDrawingDelegate;
    }
}
namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADSDrawingImpl;
    }
}
namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADSDrawing;
    }
}
namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADSDrawingGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  ADSFOUNDATION_API Teamcenter_alias::adsfoundation::ADSDrawingDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ADSDrawingDelegate instance
    static ADSDrawingDelegate&  getInstance();

    //  Method to create the ADSDrawingImpl pointer
    static ADSDrawingImpl*  createImpl( ADSDrawing&  ifObj );

    //  Method to delete the ADSDrawingImpl pointer
    static void deleteImpl( ADSDrawingImpl*  impl );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAdssource_doc_categoryBase(ADSDrawing &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAdssource_tdoc_categoryBase(ADSDrawing &ifObj,  const std::string &value, bool isNull );


    ///
    /// dummy_for_adsDrawing
    /// @version Tc 8
    /// @return - dummy_for_adsDrawing
    ///
    int  dummy_for_adsDrawingBase(const ADSDrawing &ifObj  );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const ADSDrawing &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const ADSDrawing &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static ADSDrawingDelegate*  m_pInstance;

    ADSDrawingDelegate();
    virtual ~ADSDrawingDelegate();
    static void setInstance( ADSDrawingDelegate*  instance );


private:
    friend class  ::Teamcenter::adsfoundation::ADSDrawingGenImpl;

};

#include <adsfoundation/libadsfoundation_undef.h>
#endif  //  TEAMCENTER__ADSFOUNDATION__ADSDRAWINGDELEGATE_HXX
