//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ADSPart
    Filename:   ADSPart.hxx
    Module:     adsfoundation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ADSFOUNDATION__ADSPART__HXX
#define TEAMCENTER__ADSFOUNDATION__ADSPART__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/Part.hxx>

#include <adsfoundation/libadsfoundation_exports.h>

namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADSPart;
    }
}
namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADSPartImpl;
    }
}
namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADSPartDelegate;
    }
}
namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADSPartDispatch;
    }
}
namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADSPartGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ADSFOUNDATION_API  Teamcenter::adsfoundation::ADSPart
     : public  ::Teamcenter::Part
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAdssource_doc_category( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAdssource_tdoc_category( const std::string &value, bool isNull=false );

    ///
    /// dummy_for_adspart
    /// @version Tc 8
    /// @return - dummy_for_adspart
    ///
    int  dummy_for_adspart(  );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ADSPart();

    /**
     * Destructor
     */
    virtual ~ADSPart();

private:
    //  Getter method for the Implementation Object
    ADSPartImpl*  getADSPartImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setADSPartImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ADSPartImpl*  m_adspartImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ADSPart - desc for ADSPart parameter
     */
    ADSPart( const ADSPart& );
    ADSPart& operator=( const ADSPart& );

    friend class  ADSPartDelegate;
    friend class  ADSPartDispatch;
    friend class  ADSPartGenImpl;
};

#include <adsfoundation/libadsfoundation_undef.h>
#endif //   TEAMCENTER__ADSFOUNDATION__ADSPART__HXX
