//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ADSPartDelegate
    Filename:   ADSPartDelegate.hxx
    Module:     adsfoundation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ADSFOUNDATION__ADSPARTDELEGATE_HXX
#define TEAMCENTER__ADSFOUNDATION__ADSPARTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <adsfoundation/ADSPart.hxx>

#include <adsfoundation/libadsfoundation_exports.h>

namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADSPartDelegate;
    }
}
namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADSPartImpl;
    }
}
namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADSPart;
    }
}
namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADSPartGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  ADSFOUNDATION_API Teamcenter_alias::adsfoundation::ADSPartDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ADSPartDelegate instance
    static ADSPartDelegate&  getInstance();

    //  Method to create the ADSPartImpl pointer
    static ADSPartImpl*  createImpl( ADSPart&  ifObj );

    //  Method to delete the ADSPartImpl pointer
    static void deleteImpl( ADSPartImpl*  impl );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAdssource_doc_categoryBase(ADSPart &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAdssource_tdoc_categoryBase(ADSPart &ifObj,  const std::string &value, bool isNull );


    ///
    /// dummy_for_adspart
    /// @version Tc 8
    /// @return - dummy_for_adspart
    ///
    int  dummy_for_adspartBase(const ADSPart &ifObj  );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const ADSPart &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const ADSPart &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static ADSPartDelegate*  m_pInstance;

    ADSPartDelegate();
    virtual ~ADSPartDelegate();
    static void setInstance( ADSPartDelegate*  instance );


private:
    friend class  ::Teamcenter::adsfoundation::ADSPartGenImpl;

};

#include <adsfoundation/libadsfoundation_undef.h>
#endif  //  TEAMCENTER__ADSFOUNDATION__ADSPARTDELEGATE_HXX
