//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ADSTechDocument
    Filename:   ADSTechDocument.hxx
    Module:     adsfoundation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ADSFOUNDATION__ADSTECHDOCUMENT__HXX
#define TEAMCENTER__ADSFOUNDATION__ADSTECHDOCUMENT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Document.hxx>

#include <adsfoundation/libadsfoundation_exports.h>

namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADSTechDocument;
    }
}
namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADSTechDocumentImpl;
    }
}
namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADSTechDocumentDelegate;
    }
}
namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADSTechDocumentDispatch;
    }
}
namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADSTechDocumentGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ADSFOUNDATION_API  Teamcenter::adsfoundation::ADSTechDocument
     : public  ::Teamcenter::Document
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// dummy_for_ads_tech_document
    /// @version Tc 8
    /// @return - dummy_for_ads_tech_document
    ///
    int  dummy_for_adstech_document(  );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ADSTechDocument();

    /**
     * Destructor
     */
    virtual ~ADSTechDocument();

private:
    //  Getter method for the Implementation Object
    ADSTechDocumentImpl*  getADSTechDocumentImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setADSTechDocumentImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ADSTechDocumentImpl*  m_adstechdocumentImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ADSTechDocument - desc for ADSTechDocument parameter
     */
    ADSTechDocument( const ADSTechDocument& );
    ADSTechDocument& operator=( const ADSTechDocument& );

    friend class  ADSTechDocumentDelegate;
    friend class  ADSTechDocumentDispatch;
    friend class  ADSTechDocumentGenImpl;
};

#include <adsfoundation/libadsfoundation_undef.h>
#endif //   TEAMCENTER__ADSFOUNDATION__ADSTECHDOCUMENT__HXX
