//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ADSTechDocumentDelegate
    Filename:   ADSTechDocumentDelegate.hxx
    Module:     adsfoundation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ADSFOUNDATION__ADSTECHDOCUMENTDELEGATE_HXX
#define TEAMCENTER__ADSFOUNDATION__ADSTECHDOCUMENTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <adsfoundation/ADSTechDocument.hxx>

#include <adsfoundation/libadsfoundation_exports.h>

namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADSTechDocumentDelegate;
    }
}
namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADSTechDocumentImpl;
    }
}
namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADSTechDocument;
    }
}
namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADSTechDocumentGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  ADSFOUNDATION_API Teamcenter_alias::adsfoundation::ADSTechDocumentDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ADSTechDocumentDelegate instance
    static ADSTechDocumentDelegate&  getInstance();

    //  Method to create the ADSTechDocumentImpl pointer
    static ADSTechDocumentImpl*  createImpl( ADSTechDocument&  ifObj );

    //  Method to delete the ADSTechDocumentImpl pointer
    static void deleteImpl( ADSTechDocumentImpl*  impl );


    ///
    /// dummy_for_ads_tech_document
    /// @version Tc 8
    /// @return - dummy_for_ads_tech_document
    ///
    int  dummy_for_adstech_documentBase(const ADSTechDocument &ifObj  );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const ADSTechDocument &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static ADSTechDocumentDelegate*  m_pInstance;

    ADSTechDocumentDelegate();
    virtual ~ADSTechDocumentDelegate();
    static void setInstance( ADSTechDocumentDelegate*  instance );


private:
    friend class  ::Teamcenter::adsfoundation::ADSTechDocumentGenImpl;

};

#include <adsfoundation/libadsfoundation_undef.h>
#endif  //  TEAMCENTER__ADSFOUNDATION__ADSTECHDOCUMENTDELEGATE_HXX
