//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ADS_Lists_PartRevisions
    Filename:   ADS_Lists_PartRevisions.hxx
    Module:     adsfoundation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ADSFOUNDATION__ADS_LISTS_PARTREVISIONS__HXX
#define TEAMCENTER__ADSFOUNDATION__ADS_LISTS_PARTREVISIONS__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <adsfoundation/libadsfoundation_exports.h>

namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADS_Lists_PartRevisions;
    }
}
namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADS_Lists_PartRevisionsImpl;
    }
}
namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADS_Lists_PartRevisionsDelegate;
    }
}
namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADS_Lists_PartRevisionsDispatch;
    }
}
namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADS_Lists_PartRevisionsGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ADSFOUNDATION_API  Teamcenter::adsfoundation::ADS_Lists_PartRevisions
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 8.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getAds0notenumber( std::vector< std::string > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 8.2
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setAds0notenumber( const std::vector< std::string > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ADS_Lists_PartRevisions();

    /**
     * Destructor
     */
    virtual ~ADS_Lists_PartRevisions();

private:
    //  Getter method for the Implementation Object
    ADS_Lists_PartRevisionsImpl*  getADS_Lists_PartRevisionsImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setADS_Lists_PartRevisionsImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ADS_Lists_PartRevisionsImpl*  m_ads_lists_partrevisionsImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ADS_Lists_PartRevisions - desc for ADS_Lists_PartRevisions parameter
     */
    ADS_Lists_PartRevisions( const ADS_Lists_PartRevisions& );
    ADS_Lists_PartRevisions& operator=( const ADS_Lists_PartRevisions& );

    friend class  ADS_Lists_PartRevisionsDelegate;
    friend class  ADS_Lists_PartRevisionsDispatch;
    friend class  ADS_Lists_PartRevisionsGenImpl;
};

#include <adsfoundation/libadsfoundation_undef.h>
#endif //   TEAMCENTER__ADSFOUNDATION__ADS_LISTS_PARTREVISIONS__HXX
