//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ADS_Lists_PartsDelegate
    Filename:   ADS_Lists_PartsDelegate.hxx
    Module:     adsfoundation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ADSFOUNDATION__ADS_LISTS_PARTSDELEGATE_HXX
#define TEAMCENTER__ADSFOUNDATION__ADS_LISTS_PARTSDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <adsfoundation/ADS_Lists_Parts.hxx>

#include <adsfoundation/libadsfoundation_exports.h>

namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADS_Lists_PartsDelegate;
    }
}
namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADS_Lists_PartsImpl;
    }
}
namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADS_Lists_Parts;
    }
}
namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADS_Lists_PartsGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  ADSFOUNDATION_API Teamcenter_alias::adsfoundation::ADS_Lists_PartsDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ADS_Lists_PartsDelegate instance
    static ADS_Lists_PartsDelegate&  getInstance();

    //  Method to create the ADS_Lists_PartsImpl pointer
    static ADS_Lists_PartsImpl*  createImpl( ADS_Lists_Parts&  ifObj );

    //  Method to delete the ADS_Lists_PartsImpl pointer
    static void deleteImpl( ADS_Lists_PartsImpl*  impl );


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 8.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getAds0notenumberBase(const ADS_Lists_Parts &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 8.2
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setAds0notenumberBase(ADS_Lists_Parts &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );



protected:
    //  Pointer to the instance
    static ADS_Lists_PartsDelegate*  m_pInstance;

    ADS_Lists_PartsDelegate();
    virtual ~ADS_Lists_PartsDelegate();
    static void setInstance( ADS_Lists_PartsDelegate*  instance );


private:
    friend class  ::Teamcenter::adsfoundation::ADS_Lists_PartsGenImpl;

};

#include <adsfoundation/libadsfoundation_undef.h>
#endif  //  TEAMCENTER__ADSFOUNDATION__ADS_LISTS_PARTSDELEGATE_HXX
