//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ads0StdNote
    Filename:   Ads0StdNote.hxx
    Module:     adsfoundation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ADSFOUNDATION__ADS0STDNOTE__HXX
#define TEAMCENTER__ADSFOUNDATION__ADS0STDNOTE__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <req/Fnd0ParamReqment.hxx>

#include <adsfoundation/libadsfoundation_exports.h>

namespace Teamcenter
{
    namespace adsfoundation
    {
        class Ads0StdNote;
    }
}
namespace Teamcenter
{
    namespace adsfoundation
    {
        class Ads0StdNoteImpl;
    }
}
namespace Teamcenter
{
    namespace adsfoundation
    {
        class Ads0StdNoteDelegate;
    }
}
namespace Teamcenter
{
    namespace adsfoundation
    {
        class Ads0StdNoteDispatch;
    }
}
namespace Teamcenter
{
    namespace adsfoundation
    {
        class Ads0StdNoteGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ADSFOUNDATION_API  Teamcenter::adsfoundation::Ads0StdNote
     : public  ::Teamcenter::Fnd0ParamReqment
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAds0stdnotecategory( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAds0stdnotecategory( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ads0StdNote();

    /**
     * Destructor
     */
    virtual ~Ads0StdNote();

private:
    //  Getter method for the Implementation Object
    Ads0StdNoteImpl*  getAds0StdNoteImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAds0StdNoteImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ads0StdNoteImpl*  m_ads0stdnoteImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ads0StdNote - desc for Ads0StdNote parameter
     */
    Ads0StdNote( const Ads0StdNote& );
    Ads0StdNote& operator=( const Ads0StdNote& );

    friend class  Ads0StdNoteDelegate;
    friend class  Ads0StdNoteDispatch;
    friend class  Ads0StdNoteGenImpl;
};

#include <adsfoundation/libadsfoundation_undef.h>
#endif //   TEAMCENTER__ADSFOUNDATION__ADS0STDNOTE__HXX
