//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ADSDrawingDispatch
    Filename:   ADSDrawingDispatch.hxx
    Module:     adsfoundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ADSFOUNDATION__ADSDRAWINGDISPATCH_HXX
#define TEAMCENTER__ADSFOUNDATION__ADSDRAWINGDISPATCH_HXX

#include <vector>
#include <adsfoundation/ADSDrawing.hxx>
#include <adsfoundation/ADSDrawingDelegate.hxx>
#include <foundationdispatch/DrawingDispatch.hxx>
#include <adsfoundationdispatch/initializeadsfoundation.hxx>

#include <adsfoundationdispatch/libadsfoundationdispatch_exports.h>

namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADSDrawingDispatch;
    }
}
namespace Teamcenter
{
    namespace adsfoundation
    {
        class ADSDrawingDelegate;
    }
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  ADSFOUNDATIONDISPATCH_API  Teamcenter::adsfoundation::ADSDrawingDispatch
    : public  Teamcenter::adsfoundation::ADSDrawingDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ADSDrawingDispatch instance
    static ADSDrawingDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static ADSDrawingDispatch*  m_dispatch;

    //  Default Constructor
    ADSDrawingDispatch();

    //  Default Destructor
    virtual ~ADSDrawingDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a ADSDrawingDispatch
    ADSDrawingDispatch( const ADSDrawingDispatch& );

    //  Assignment operator
    ADSDrawingDispatch&  operator = ( const ADSDrawingDispatch& );

    //  friend
    friend void   ::Teamcenter::adsfoundation::initializeadsfoundationInternal();
    friend void   ::Teamcenter::adsfoundation::initializeadsfoundationExtenders();
    friend class  Teamcenter::adsfoundation::ADSDrawingDelegate;
};

#include <adsfoundationdispatch/libadsfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__ADSFOUNDATION__ADSDRAWINGDISPATCH_HXX
