//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  adsfoundationdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libadsfoundationdispatch

#if !defined(LIBADSFOUNDATIONDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBADSFOUNDATIONDISPATCH is not defined
#endif

/* Handwritten code should use ADSFOUNDATIONDISPATCH_API, not ADSFOUNDATIONDISPATCHEXPORT */

#define ADSFOUNDATIONDISPATCH_API ADSFOUNDATIONDISPATCHEXPORT

#if IPLIB==libadsfoundationdispatch || defined(LIBADSFOUNDATIONDISPATCH)
#   if defined(__lint)
#       define ADSFOUNDATIONDISPATCHEXPORT       __export(adsfoundationdispatch)
#       define ADSFOUNDATIONDISPATCHGLOBAL       extern __global(adsfoundationdispatch)
#       define ADSFOUNDATIONDISPATCHPRIVATE      extern __private(adsfoundationdispatch)
#   elif defined(_WIN32)
#       define ADSFOUNDATIONDISPATCHEXPORT       __declspec(dllexport)
#       define ADSFOUNDATIONDISPATCHGLOBAL       extern __declspec(dllexport)
#       define ADSFOUNDATIONDISPATCHPRIVATE      extern
#   else
#       define ADSFOUNDATIONDISPATCHEXPORT
#       define ADSFOUNDATIONDISPATCHGLOBAL       extern
#       define ADSFOUNDATIONDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define ADSFOUNDATIONDISPATCHEXPORT       __export(adsfoundationdispatch)
#       define ADSFOUNDATIONDISPATCHGLOBAL       extern __global(adsfoundationdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define ADSFOUNDATIONDISPATCHEXPORT      __declspec(dllimport)
#       define ADSFOUNDATIONDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define ADSFOUNDATIONDISPATCHEXPORT
#       define ADSFOUNDATIONDISPATCHGLOBAL       extern
#   endif
#endif
