//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DatasetType
    Filename:   DatasetType.hxx
    Module:     ae
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__DATASETTYPE__HXX
#define TEAMCENTER__DATASETTYPE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <ae/libae_exports.h>

namespace Teamcenter
{
    class DatasetType;
}
namespace Teamcenter
{
    class DatasetTypeImpl;
}
namespace Teamcenter
{
    class DatasetTypeDelegate;
}
namespace Teamcenter
{
    class DatasetTypeDispatch;
}
namespace Teamcenter
{
    class DatasetTypeGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  AE_API  Teamcenter::DatasetType
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    DatasetType();

    /**
     * Destructor
     */
    virtual ~DatasetType();

private:
    //  Getter method for the Implementation Object
    DatasetTypeImpl*  getDatasetTypeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDatasetTypeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DatasetTypeImpl*  m_datasettypeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param DatasetType - desc for DatasetType parameter
     */
    DatasetType( const DatasetType& );
    DatasetType& operator=( const DatasetType& );

    friend class  DatasetTypeDelegate;
    friend class  DatasetTypeDispatch;
    friend class  DatasetTypeGenImpl;
};

#include <ae/libae_undef.h>
#endif //   TEAMCENTER__DATASETTYPE__HXX
