//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DatasetTypeDelegate
    Filename:   DatasetTypeDelegate.hxx
    Module:     ae
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__DATASETTYPEDELEGATE_HXX
#define TEAMCENTER__DATASETTYPEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ae/DatasetType.hxx>

#include <ae/libae_exports.h>

namespace Teamcenter
{
    class DatasetTypeDelegate;
}
namespace Teamcenter
{
    class DatasetTypeImpl;
}
namespace Teamcenter
{
    class DatasetType;
}
namespace Teamcenter
{
    class DatasetTypeGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  AE_API Teamcenter_alias::DatasetTypeDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the DatasetTypeDelegate instance
    static DatasetTypeDelegate&  getInstance();

    //  Method to create the DatasetTypeImpl pointer
    static DatasetTypeImpl*  createImpl( DatasetType&  ifObj );

    //  Method to delete the DatasetTypeImpl pointer
    static void deleteImpl( DatasetTypeImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @param isLockForDelete - A boolean to indicate if object(s) are to be locked for deletion
    /// @param allowRelock - A boolean to indicate if object(s) can be relocked, which will discard all unsaved changes, if already locked by the same user
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0LockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd, const bool isLockForDelete, const bool allowRelock );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0RefreshBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0UnlockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static DatasetTypeDelegate*  m_pInstance;

    DatasetTypeDelegate();
    virtual ~DatasetTypeDelegate();
    static void setInstance( DatasetTypeDelegate*  instance );


private:
    friend class  ::Teamcenter::DatasetTypeGenImpl;

};

#include <ae/libae_undef.h>
#endif  //  TEAMCENTER__DATASETTYPEDELEGATE_HXX
