//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0BMIDEDeployArchive
    Filename:   Fnd0BMIDEDeployArchive.hxx
    Module:     ae
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0BMIDEDEPLOYARCHIVE__HXX
#define TEAMCENTER__FND0BMIDEDEPLOYARCHIVE__HXX

#include <common/tc_deprecation_macros.h>
#include <ae/Dataset.hxx>

#include <ae/libae_exports.h>

namespace Teamcenter
{
    class Fnd0BMIDEDeployArchive;
}
namespace Teamcenter
{
    class Fnd0BMIDEDeployArchiveImpl;
}
namespace Teamcenter
{
    class Fnd0BMIDEDeployArchiveDelegate;
}
namespace Teamcenter
{
    class Fnd0BMIDEDeployArchiveDispatch;
}
namespace Teamcenter
{
    class Fnd0BMIDEDeployArchiveGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  AE_API  Teamcenter::Fnd0BMIDEDeployArchive
     : public  ::Teamcenter::Dataset
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0BMIDEDeployArchive();

    /**
     * Destructor
     */
    virtual ~Fnd0BMIDEDeployArchive();

private:
    //  Getter method for the Implementation Object
    Fnd0BMIDEDeployArchiveImpl*  getFnd0BMIDEDeployArchiveImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0BMIDEDeployArchiveImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0BMIDEDeployArchiveImpl*  m_fnd0bmidedeployarchiveImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0BMIDEDeployArchive - desc for Fnd0BMIDEDeployArchive parameter
     */
    Fnd0BMIDEDeployArchive( const Fnd0BMIDEDeployArchive& );
    Fnd0BMIDEDeployArchive& operator=( const Fnd0BMIDEDeployArchive& );

    friend class  Fnd0BMIDEDeployArchiveDelegate;
    friend class  Fnd0BMIDEDeployArchiveDispatch;
    friend class  Fnd0BMIDEDeployArchiveGenImpl;
};

#include <ae/libae_undef.h>
#endif //   TEAMCENTER__FND0BMIDEDEPLOYARCHIVE__HXX
