//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, NamedRevisionAnchor
    Filename:   NamedRevisionAnchor.hxx
    Module:     ae
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__NAMEDREVISIONANCHOR__HXX
#define TEAMCENTER__NAMEDREVISIONANCHOR__HXX

#include <common/tc_deprecation_macros.h>
#include <ae/RevisionAnchor.hxx>

#include <ae/libae_exports.h>

namespace Teamcenter
{
    class NamedRevisionAnchor;
}
namespace Teamcenter
{
    class NamedRevisionAnchorImpl;
}
namespace Teamcenter
{
    class NamedRevisionAnchorDelegate;
}
namespace Teamcenter
{
    class NamedRevisionAnchorDispatch;
}
namespace Teamcenter
{
    class NamedRevisionAnchorGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  AE_API  Teamcenter::NamedRevisionAnchor
     : public  ::Teamcenter::RevisionAnchor
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    NamedRevisionAnchor();

    /**
     * Destructor
     */
    virtual ~NamedRevisionAnchor();

private:
    //  Getter method for the Implementation Object
    NamedRevisionAnchorImpl*  getNamedRevisionAnchorImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setNamedRevisionAnchorImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    NamedRevisionAnchorImpl*  m_namedrevisionanchorImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param NamedRevisionAnchor - desc for NamedRevisionAnchor parameter
     */
    NamedRevisionAnchor( const NamedRevisionAnchor& );
    NamedRevisionAnchor& operator=( const NamedRevisionAnchor& );

    friend class  NamedRevisionAnchorDelegate;
    friend class  NamedRevisionAnchorDispatch;
    friend class  NamedRevisionAnchorGenImpl;
};

#include <ae/libae_undef.h>
#endif //   TEAMCENTER__NAMEDREVISIONANCHOR__HXX
