//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RevisionAnchor
    Filename:   RevisionAnchor.hxx
    Module:     ae
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REVISIONANCHOR__HXX
#define TEAMCENTER__REVISIONANCHOR__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <ae/libae_exports.h>

namespace Teamcenter
{
    class RevisionAnchor;
}
namespace Teamcenter
{
    class RevisionAnchorImpl;
}
namespace Teamcenter
{
    class RevisionAnchorDelegate;
}
namespace Teamcenter
{
    class RevisionAnchorDispatch;
}
namespace Teamcenter
{
    class RevisionAnchorGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  AE_API  Teamcenter::RevisionAnchor
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    RevisionAnchor();

    /**
     * Destructor
     */
    virtual ~RevisionAnchor();

private:
    //  Getter method for the Implementation Object
    RevisionAnchorImpl*  getRevisionAnchorImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRevisionAnchorImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    RevisionAnchorImpl*  m_revisionanchorImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param RevisionAnchor - desc for RevisionAnchor parameter
     */
    RevisionAnchor( const RevisionAnchor& );
    RevisionAnchor& operator=( const RevisionAnchor& );

    friend class  RevisionAnchorDelegate;
    friend class  RevisionAnchorDispatch;
    friend class  RevisionAnchorGenImpl;
};

#include <ae/libae_undef.h>
#endif //   TEAMCENTER__REVISIONANCHOR__HXX
