//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RevisionAnchorDelegate
    Filename:   RevisionAnchorDelegate.hxx
    Module:     ae
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REVISIONANCHORDELEGATE_HXX
#define TEAMCENTER__REVISIONANCHORDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ae/RevisionAnchor.hxx>

#include <ae/libae_exports.h>

namespace Teamcenter
{
    class RevisionAnchorDelegate;
}
namespace Teamcenter
{
    class RevisionAnchorImpl;
}
namespace Teamcenter
{
    class RevisionAnchor;
}
namespace Teamcenter
{
    class RevisionAnchorGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  AE_API Teamcenter_alias::RevisionAnchorDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the RevisionAnchorDelegate instance
    static RevisionAnchorDelegate&  getInstance();

    //  Method to create the RevisionAnchorImpl pointer
    static RevisionAnchorImpl*  createImpl( RevisionAnchor&  ifObj );

    //  Method to delete the RevisionAnchorImpl pointer
    static void deleteImpl( RevisionAnchorImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be created
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0FinalizeCreateInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.3
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0FinalizeSaveAsInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be created
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0SetPropertiesFromCreateInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const RevisionAnchor &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// finalize operation input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  finalizeSaveAsInputBase(const RevisionAnchor &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const RevisionAnchor &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static RevisionAnchorDelegate*  m_pInstance;

    RevisionAnchorDelegate();
    virtual ~RevisionAnchorDelegate();
    static void setInstance( RevisionAnchorDelegate*  instance );


private:
    friend class  ::Teamcenter::RevisionAnchorGenImpl;

};

#include <ae/libae_undef.h>
#endif  //  TEAMCENTER__REVISIONANCHORDELEGATE_HXX
