//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Tool
    Filename:   Tool.hxx
    Module:     ae
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TOOL__HXX
#define TEAMCENTER__TOOL__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <ae/libae_exports.h>

namespace Teamcenter
{
    class Tool;
}
namespace Teamcenter
{
    class ToolImpl;
}
namespace Teamcenter
{
    class ToolDelegate;
}
namespace Teamcenter
{
    class ToolDispatch;
}
namespace Teamcenter
{
    class ToolGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  AE_API  Teamcenter::Tool
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Tool();

    /**
     * Destructor
     */
    virtual ~Tool();

private:
    //  Getter method for the Implementation Object
    ToolImpl*  getToolImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setToolImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ToolImpl*  m_toolImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Tool - desc for Tool parameter
     */
    Tool( const Tool& );
    Tool& operator=( const Tool& );

    friend class  ToolDelegate;
    friend class  ToolDispatch;
    friend class  ToolGenImpl;
};

#include <ae/libae_undef.h>
#endif //   TEAMCENTER__TOOL__HXX
