//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ToolDelegate
    Filename:   ToolDelegate.hxx
    Module:     ae
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TOOLDELEGATE_HXX
#define TEAMCENTER__TOOLDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ae/Tool.hxx>

#include <ae/libae_exports.h>

namespace Teamcenter
{
    class ToolDelegate;
}
namespace Teamcenter
{
    class ToolImpl;
}
namespace Teamcenter
{
    class Tool;
}
namespace Teamcenter
{
    class ToolGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  AE_API Teamcenter_alias::ToolDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ToolDelegate instance
    static ToolDelegate&  getInstance();

    //  Method to create the ToolImpl pointer
    static ToolImpl*  createImpl( Tool&  ifObj );

    //  Method to delete the ToolImpl pointer
    static void deleteImpl( ToolImpl*  impl );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Tool &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const Tool &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static ToolDelegate*  m_pInstance;

    ToolDelegate();
    virtual ~ToolDelegate();
    static void setInstance( ToolDelegate*  instance );


private:
    friend class  ::Teamcenter::ToolGenImpl;

};

#include <ae/libae_undef.h>
#endif  //  TEAMCENTER__TOOLDELEGATE_HXX
