//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  ae

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libae

#if !defined(LIBAE) && !defined(IPLIB)
#   error IPLIB or LIBAE is not defined
#endif

/* Handwritten code should use AE_API, not AEEXPORT */

#define AE_API AEEXPORT

#if IPLIB==libae || defined(LIBAE)
#   if defined(__lint)
#       define AEEXPORT       __export(ae)
#       define AEGLOBAL       extern __global(ae)
#       define AEPRIVATE      extern __private(ae)
#   elif defined(_WIN32)
#       define AEEXPORT       __declspec(dllexport)
#       define AEGLOBAL       extern __declspec(dllexport)
#       define AEPRIVATE      extern
#   else
#       define AEEXPORT
#       define AEGLOBAL       extern
#       define AEPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define AEEXPORT       __export(ae)
#       define AEGLOBAL       extern __global(ae)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define AEEXPORT      __declspec(dllimport)
#       define AEGLOBAL       extern __declspec(dllimport)
#   else
#       define AEEXPORT
#       define AEGLOBAL       extern
#   endif
#endif
