//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AppInterface
    Filename:   AppInterface.hxx
    Module:     ai
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPINTERFACE__HXX
#define TEAMCENTER__APPINTERFACE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <ai/libai_exports.h>

namespace Teamcenter
{
    class AppInterface;
}
namespace Teamcenter
{
    class AppInterfaceImpl;
}
namespace Teamcenter
{
    class AppInterfaceDelegate;
}
namespace Teamcenter
{
    class AppInterfaceDispatch;
}
namespace Teamcenter
{
    class AppInterfaceGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  AI_API  Teamcenter::AppInterface
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AppInterface();

    /**
     * Destructor
     */
    virtual ~AppInterface();

private:
    //  Getter method for the Implementation Object
    AppInterfaceImpl*  getAppInterfaceImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAppInterfaceImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AppInterfaceImpl*  m_appinterfaceImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AppInterface - desc for AppInterface parameter
     */
    AppInterface( const AppInterface& );
    AppInterface& operator=( const AppInterface& );

    friend class  AppInterfaceDelegate;
    friend class  AppInterfaceDispatch;
    friend class  AppInterfaceGenImpl;
};

#include <ai/libai_undef.h>
#endif //   TEAMCENTER__APPINTERFACE__HXX
