//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AppInterfaceDelegate
    Filename:   AppInterfaceDelegate.hxx
    Module:     ai
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPINTERFACEDELEGATE_HXX
#define TEAMCENTER__APPINTERFACEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ai/AppInterface.hxx>

#include <ai/libai_exports.h>

namespace Teamcenter
{
    class AppInterfaceDelegate;
}
namespace Teamcenter
{
    class AppInterfaceImpl;
}
namespace Teamcenter
{
    class AppInterface;
}
namespace Teamcenter
{
    class AppInterfaceGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  AI_API Teamcenter_alias::AppInterfaceDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the AppInterfaceDelegate instance
    static AppInterfaceDelegate&  getInstance();

    //  Method to create the AppInterfaceImpl pointer
    static AppInterfaceImpl*  createImpl( AppInterface&  ifObj );

    //  Method to delete the AppInterfaceImpl pointer
    static void deleteImpl( AppInterfaceImpl*  impl );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const AppInterface &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const AppInterface &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static AppInterfaceDelegate*  m_pInstance;

    AppInterfaceDelegate();
    virtual ~AppInterfaceDelegate();
    static void setInstance( AppInterfaceDelegate*  instance );


private:
    friend class  ::Teamcenter::AppInterfaceGenImpl;

};

#include <ai/libai_undef.h>
#endif  //  TEAMCENTER__APPINTERFACEDELEGATE_HXX
