//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AppInterfaceType
    Filename:   AppInterfaceType.hxx
    Module:     ai
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPINTERFACETYPE__HXX
#define TEAMCENTER__APPINTERFACETYPE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <ai/libai_exports.h>

namespace Teamcenter
{
    class AppInterfaceType;
}
namespace Teamcenter
{
    class AppInterfaceTypeImpl;
}
namespace Teamcenter
{
    class AppInterfaceTypeDelegate;
}
namespace Teamcenter
{
    class AppInterfaceTypeDispatch;
}
namespace Teamcenter
{
    class AppInterfaceTypeGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  AI_API  Teamcenter::AppInterfaceType
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AppInterfaceType();

    /**
     * Destructor
     */
    virtual ~AppInterfaceType();

private:
    //  Getter method for the Implementation Object
    AppInterfaceTypeImpl*  getAppInterfaceTypeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAppInterfaceTypeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AppInterfaceTypeImpl*  m_appinterfacetypeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AppInterfaceType - desc for AppInterfaceType parameter
     */
    AppInterfaceType( const AppInterfaceType& );
    AppInterfaceType& operator=( const AppInterfaceType& );

    friend class  AppInterfaceTypeDelegate;
    friend class  AppInterfaceTypeDispatch;
    friend class  AppInterfaceTypeGenImpl;
};

#include <ai/libai_undef.h>
#endif //   TEAMCENTER__APPINTERFACETYPE__HXX
