//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AppInterfaceTypeDelegate
    Filename:   AppInterfaceTypeDelegate.hxx
    Module:     ai
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPINTERFACETYPEDELEGATE_HXX
#define TEAMCENTER__APPINTERFACETYPEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ai/AppInterfaceType.hxx>

#include <ai/libai_exports.h>

namespace Teamcenter
{
    class AppInterfaceTypeDelegate;
}
namespace Teamcenter
{
    class AppInterfaceTypeImpl;
}
namespace Teamcenter
{
    class AppInterfaceType;
}
namespace Teamcenter
{
    class AppInterfaceTypeGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  AI_API Teamcenter_alias::AppInterfaceTypeDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the AppInterfaceTypeDelegate instance
    static AppInterfaceTypeDelegate&  getInstance();

    //  Method to create the AppInterfaceTypeImpl pointer
    static AppInterfaceTypeImpl*  createImpl( AppInterfaceType&  ifObj );

    //  Method to delete the AppInterfaceTypeImpl pointer
    static void deleteImpl( AppInterfaceTypeImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static AppInterfaceTypeDelegate*  m_pInstance;

    AppInterfaceTypeDelegate();
    virtual ~AppInterfaceTypeDelegate();
    static void setInstance( AppInterfaceTypeDelegate*  instance );


private:
    friend class  ::Teamcenter::AppInterfaceTypeGenImpl;

};

#include <ai/libai_undef.h>
#endif  //  TEAMCENTER__APPINTERFACETYPEDELEGATE_HXX
