//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, IDCLine
    Filename:   IDCLine.hxx
    Module:     ai
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IDCLINE__HXX
#define TEAMCENTER__IDCLINE__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <ai/libai_exports.h>

namespace Teamcenter
{
    class IDCLine;
}
namespace Teamcenter
{
    class IDCLineImpl;
}
namespace Teamcenter
{
    class IDCLineDelegate;
}
namespace Teamcenter
{
    class IDCLineDispatch;
}
namespace Teamcenter
{
    class IDCLineGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  AI_API  Teamcenter::IDCLine
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    IDCLine();

    /**
     * Destructor
     */
    virtual ~IDCLine();

private:
    //  Getter method for the Implementation Object
    IDCLineImpl*  getIDCLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setIDCLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    IDCLineImpl*  m_idclineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param IDCLine - desc for IDCLine parameter
     */
    IDCLine( const IDCLine& );
    IDCLine& operator=( const IDCLine& );

    friend class  IDCLineDelegate;
    friend class  IDCLineDispatch;
    friend class  IDCLineGenImpl;
};

#include <ai/libai_undef.h>
#endif //   TEAMCENTER__IDCLINE__HXX
