//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, IDCWindow
    Filename:   IDCWindow.hxx
    Module:     ai
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IDCWINDOW__HXX
#define TEAMCENTER__IDCWINDOW__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <ai/libai_exports.h>

namespace Teamcenter
{
    class IDCWindow;
}
namespace Teamcenter
{
    class IDCWindowImpl;
}
namespace Teamcenter
{
    class IDCWindowDelegate;
}
namespace Teamcenter
{
    class IDCWindowDispatch;
}
namespace Teamcenter
{
    class IDCWindowGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  AI_API  Teamcenter::IDCWindow
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    IDCWindow();

    /**
     * Destructor
     */
    virtual ~IDCWindow();

private:
    //  Getter method for the Implementation Object
    IDCWindowImpl*  getIDCWindowImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setIDCWindowImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    IDCWindowImpl*  m_idcwindowImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param IDCWindow - desc for IDCWindow parameter
     */
    IDCWindow( const IDCWindow& );
    IDCWindow& operator=( const IDCWindow& );

    friend class  IDCWindowDelegate;
    friend class  IDCWindowDispatch;
    friend class  IDCWindowGenImpl;
};

#include <ai/libai_undef.h>
#endif //   TEAMCENTER__IDCWINDOW__HXX
