//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, IDCWindowDelegate
    Filename:   IDCWindowDelegate.hxx
    Module:     ai
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IDCWINDOWDELEGATE_HXX
#define TEAMCENTER__IDCWINDOWDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ai/IDCWindow.hxx>

#include <ai/libai_exports.h>

namespace Teamcenter
{
    class IDCWindowDelegate;
}
namespace Teamcenter
{
    class IDCWindowImpl;
}
namespace Teamcenter
{
    class IDCWindow;
}
namespace Teamcenter
{
    class IDCWindowGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  AI_API Teamcenter_alias::IDCWindowDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the IDCWindowDelegate instance
    static IDCWindowDelegate&  getInstance();

    //  Method to create the IDCWindowImpl pointer
    static IDCWindowImpl*  createImpl( IDCWindow&  ifObj );

    //  Method to delete the IDCWindowImpl pointer
    static void deleteImpl( IDCWindowImpl*  impl );



protected:
    //  Pointer to the instance
    static IDCWindowDelegate*  m_pInstance;

    IDCWindowDelegate();
    virtual ~IDCWindowDelegate();
    static void setInstance( IDCWindowDelegate*  instance );


private:
    friend class  ::Teamcenter::IDCWindowGenImpl;

};

#include <ai/libai_undef.h>
#endif  //  TEAMCENTER__IDCWINDOWDELEGATE_HXX
