//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MasterRecord
    Filename:   MasterRecord.hxx
    Module:     ai
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MASTERRECORD__HXX
#define TEAMCENTER__MASTERRECORD__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <ai/libai_exports.h>

namespace Teamcenter
{
    class MasterRecord;
}
namespace Teamcenter
{
    class MasterRecordImpl;
}
namespace Teamcenter
{
    class MasterRecordDelegate;
}
namespace Teamcenter
{
    class MasterRecordDispatch;
}
namespace Teamcenter
{
    class MasterRecordGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  AI_API  Teamcenter::MasterRecord
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    MasterRecord();

    /**
     * Destructor
     */
    virtual ~MasterRecord();

private:
    //  Getter method for the Implementation Object
    MasterRecordImpl*  getMasterRecordImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMasterRecordImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    MasterRecordImpl*  m_masterrecordImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param MasterRecord - desc for MasterRecord parameter
     */
    MasterRecord( const MasterRecord& );
    MasterRecord& operator=( const MasterRecord& );

    friend class  MasterRecordDelegate;
    friend class  MasterRecordDispatch;
    friend class  MasterRecordGenImpl;
};

#include <ai/libai_undef.h>
#endif //   TEAMCENTER__MASTERRECORD__HXX
