//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MasterRecordDelegate
    Filename:   MasterRecordDelegate.hxx
    Module:     ai
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MASTERRECORDDELEGATE_HXX
#define TEAMCENTER__MASTERRECORDDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ai/MasterRecord.hxx>

#include <ai/libai_exports.h>

namespace Teamcenter
{
    class MasterRecordDelegate;
}
namespace Teamcenter
{
    class MasterRecordImpl;
}
namespace Teamcenter
{
    class MasterRecord;
}
namespace Teamcenter
{
    class MasterRecordGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  AI_API Teamcenter_alias::MasterRecordDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the MasterRecordDelegate instance
    static MasterRecordDelegate&  getInstance();

    //  Method to create the MasterRecordImpl pointer
    static MasterRecordImpl*  createImpl( MasterRecord&  ifObj );

    //  Method to delete the MasterRecordImpl pointer
    static void deleteImpl( MasterRecordImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static MasterRecordDelegate*  m_pInstance;

    MasterRecordDelegate();
    virtual ~MasterRecordDelegate();
    static void setInstance( MasterRecordDelegate*  instance );


private:
    friend class  ::Teamcenter::MasterRecordGenImpl;

};

#include <ai/libai_undef.h>
#endif  //  TEAMCENTER__MASTERRECORDDELEGATE_HXX
