//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RecordObject
    Filename:   RecordObject.hxx
    Module:     ai
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__RECORDOBJECT__HXX
#define TEAMCENTER__RECORDOBJECT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <ai/libai_exports.h>

namespace Teamcenter
{
    class RecordObject;
}
namespace Teamcenter
{
    class RecordObjectImpl;
}
namespace Teamcenter
{
    class RecordObjectDelegate;
}
namespace Teamcenter
{
    class RecordObjectDispatch;
}
namespace Teamcenter
{
    class RecordObjectGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  AI_API  Teamcenter::RecordObject
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    RecordObject();

    /**
     * Destructor
     */
    virtual ~RecordObject();

private:
    //  Getter method for the Implementation Object
    RecordObjectImpl*  getRecordObjectImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRecordObjectImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    RecordObjectImpl*  m_recordobjectImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param RecordObject - desc for RecordObject parameter
     */
    RecordObject( const RecordObject& );
    RecordObject& operator=( const RecordObject& );

    friend class  RecordObjectDelegate;
    friend class  RecordObjectDispatch;
    friend class  RecordObjectGenImpl;
};

#include <ai/libai_undef.h>
#endif //   TEAMCENTER__RECORDOBJECT__HXX
