//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RecordObjectDelegate
    Filename:   RecordObjectDelegate.hxx
    Module:     ai
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__RECORDOBJECTDELEGATE_HXX
#define TEAMCENTER__RECORDOBJECTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ai/RecordObject.hxx>

#include <ai/libai_exports.h>

namespace Teamcenter
{
    class RecordObjectDelegate;
}
namespace Teamcenter
{
    class RecordObjectImpl;
}
namespace Teamcenter
{
    class RecordObject;
}
namespace Teamcenter
{
    class RecordObjectGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  AI_API Teamcenter_alias::RecordObjectDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the RecordObjectDelegate instance
    static RecordObjectDelegate&  getInstance();

    //  Method to create the RecordObjectImpl pointer
    static RecordObjectImpl*  createImpl( RecordObject&  ifObj );

    //  Method to delete the RecordObjectImpl pointer
    static void deleteImpl( RecordObjectImpl*  impl );



protected:
    //  Pointer to the instance
    static RecordObjectDelegate*  m_pInstance;

    RecordObjectDelegate();
    virtual ~RecordObjectDelegate();
    static void setInstance( RecordObjectDelegate*  instance );


private:
    friend class  ::Teamcenter::RecordObjectGenImpl;

};

#include <ai/libai_undef.h>
#endif  //  TEAMCENTER__RECORDOBJECTDELEGATE_HXX
