//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RequestObject
    Filename:   RequestObject.hxx
    Module:     ai
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REQUESTOBJECT__HXX
#define TEAMCENTER__REQUESTOBJECT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <ai/libai_exports.h>

namespace Teamcenter
{
    class RequestObject;
}
namespace Teamcenter
{
    class RequestObjectImpl;
}
namespace Teamcenter
{
    class RequestObjectDelegate;
}
namespace Teamcenter
{
    class RequestObjectDispatch;
}
namespace Teamcenter
{
    class RequestObjectGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  AI_API  Teamcenter::RequestObject
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    RequestObject();

    /**
     * Destructor
     */
    virtual ~RequestObject();

private:
    //  Getter method for the Implementation Object
    RequestObjectImpl*  getRequestObjectImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRequestObjectImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    RequestObjectImpl*  m_requestobjectImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param RequestObject - desc for RequestObject parameter
     */
    RequestObject( const RequestObject& );
    RequestObject& operator=( const RequestObject& );

    friend class  RequestObjectDelegate;
    friend class  RequestObjectDispatch;
    friend class  RequestObjectGenImpl;
};

#include <ai/libai_undef.h>
#endif //   TEAMCENTER__REQUESTOBJECT__HXX
