//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RequestObjectDelegate
    Filename:   RequestObjectDelegate.hxx
    Module:     ai
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REQUESTOBJECTDELEGATE_HXX
#define TEAMCENTER__REQUESTOBJECTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ai/RequestObject.hxx>

#include <ai/libai_exports.h>

namespace Teamcenter
{
    class RequestObjectDelegate;
}
namespace Teamcenter
{
    class RequestObjectImpl;
}
namespace Teamcenter
{
    class RequestObject;
}
namespace Teamcenter
{
    class RequestObjectGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  AI_API Teamcenter_alias::RequestObjectDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the RequestObjectDelegate instance
    static RequestObjectDelegate&  getInstance();

    //  Method to create the RequestObjectImpl pointer
    static RequestObjectImpl*  createImpl( RequestObject&  ifObj );

    //  Method to delete the RequestObjectImpl pointer
    static void deleteImpl( RequestObjectImpl*  impl );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const RequestObject &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static RequestObjectDelegate*  m_pInstance;

    RequestObjectDelegate();
    virtual ~RequestObjectDelegate();
    static void setInstance( RequestObjectDelegate*  instance );


private:
    friend class  ::Teamcenter::RequestObjectGenImpl;

};

#include <ai/libai_undef.h>
#endif  //  TEAMCENTER__REQUESTOBJECTDELEGATE_HXX
