//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  appmodeldispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libappmodeldispatch

#if !defined(LIBAPPMODELDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBAPPMODELDISPATCH is not defined
#endif

/* Handwritten code should use APPMODELDISPATCH_API, not APPMODELDISPATCHEXPORT */

#define APPMODELDISPATCH_API APPMODELDISPATCHEXPORT

#if IPLIB==libappmodeldispatch || defined(LIBAPPMODELDISPATCH)
#   if defined(__lint)
#       define APPMODELDISPATCHEXPORT       __export(appmodeldispatch)
#       define APPMODELDISPATCHGLOBAL       extern __global(appmodeldispatch)
#       define APPMODELDISPATCHPRIVATE      extern __private(appmodeldispatch)
#   elif defined(_WIN32)
#       define APPMODELDISPATCHEXPORT       __declspec(dllexport)
#       define APPMODELDISPATCHGLOBAL       extern __declspec(dllexport)
#       define APPMODELDISPATCHPRIVATE      extern
#   else
#       define APPMODELDISPATCHEXPORT
#       define APPMODELDISPATCHGLOBAL       extern
#       define APPMODELDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define APPMODELDISPATCHEXPORT       __export(appmodeldispatch)
#       define APPMODELDISPATCHGLOBAL       extern __global(appmodeldispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define APPMODELDISPATCHEXPORT      __declspec(dllimport)
#       define APPMODELDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define APPMODELDISPATCHEXPORT
#       define APPMODELDISPATCHGLOBAL       extern
#   endif
#endif
