//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Appearance
    Filename:   Appearance.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPEARANCE__HXX
#define TEAMCENTER__APPEARANCE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class Appearance;
}
namespace Teamcenter
{
    class AppearanceImpl;
}
namespace Teamcenter
{
    class AppearanceDelegate;
}
namespace Teamcenter
{
    class AppearanceDispatch;
}
namespace Teamcenter
{
    class AppearanceGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::Appearance
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Appearance();

    /**
     * Destructor
     */
    virtual ~Appearance();

private:
    //  Getter method for the Implementation Object
    AppearanceImpl*  getAppearanceImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAppearanceImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AppearanceImpl*  m_appearanceImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Appearance - desc for Appearance parameter
     */
    Appearance( const Appearance& );
    Appearance& operator=( const Appearance& );

    friend class  AppearanceDelegate;
    friend class  AppearanceDispatch;
    friend class  AppearanceGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__APPEARANCE__HXX
