//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AppearanceAttr
    Filename:   AppearanceAttr.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPEARANCEATTR__HXX
#define TEAMCENTER__APPEARANCEATTR__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class AppearanceAttr;
}
namespace Teamcenter
{
    class AppearanceAttrImpl;
}
namespace Teamcenter
{
    class AppearanceAttrDelegate;
}
namespace Teamcenter
{
    class AppearanceAttrDispatch;
}
namespace Teamcenter
{
    class AppearanceAttrGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::AppearanceAttr
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AppearanceAttr();

    /**
     * Destructor
     */
    virtual ~AppearanceAttr();

private:
    //  Getter method for the Implementation Object
    AppearanceAttrImpl*  getAppearanceAttrImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAppearanceAttrImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AppearanceAttrImpl*  m_appearanceattrImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AppearanceAttr - desc for AppearanceAttr parameter
     */
    AppearanceAttr( const AppearanceAttr& );
    AppearanceAttr& operator=( const AppearanceAttr& );

    friend class  AppearanceAttrDelegate;
    friend class  AppearanceAttrDispatch;
    friend class  AppearanceAttrGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__APPEARANCEATTR__HXX
