//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AppearanceAttrDefinition
    Filename:   AppearanceAttrDefinition.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPEARANCEATTRDEFINITION__HXX
#define TEAMCENTER__APPEARANCEATTRDEFINITION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class AppearanceAttrDefinition;
}
namespace Teamcenter
{
    class AppearanceAttrDefinitionImpl;
}
namespace Teamcenter
{
    class AppearanceAttrDefinitionDelegate;
}
namespace Teamcenter
{
    class AppearanceAttrDefinitionDispatch;
}
namespace Teamcenter
{
    class AppearanceAttrDefinitionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::AppearanceAttrDefinition
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AppearanceAttrDefinition();

    /**
     * Destructor
     */
    virtual ~AppearanceAttrDefinition();

private:
    //  Getter method for the Implementation Object
    AppearanceAttrDefinitionImpl*  getAppearanceAttrDefinitionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAppearanceAttrDefinitionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AppearanceAttrDefinitionImpl*  m_appearanceattrdefinitionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AppearanceAttrDefinition - desc for AppearanceAttrDefinition parameter
     */
    AppearanceAttrDefinition( const AppearanceAttrDefinition& );
    AppearanceAttrDefinition& operator=( const AppearanceAttrDefinition& );

    friend class  AppearanceAttrDefinitionDelegate;
    friend class  AppearanceAttrDefinitionDispatch;
    friend class  AppearanceAttrDefinitionGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__APPEARANCEATTRDEFINITION__HXX
