//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AppearanceAttrMapping
    Filename:   AppearanceAttrMapping.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPEARANCEATTRMAPPING__HXX
#define TEAMCENTER__APPEARANCEATTRMAPPING__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class AppearanceAttrMapping;
}
namespace Teamcenter
{
    class AppearanceAttrMappingImpl;
}
namespace Teamcenter
{
    class AppearanceAttrMappingDelegate;
}
namespace Teamcenter
{
    class AppearanceAttrMappingDispatch;
}
namespace Teamcenter
{
    class AppearanceAttrMappingGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::AppearanceAttrMapping
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AppearanceAttrMapping();

    /**
     * Destructor
     */
    virtual ~AppearanceAttrMapping();

private:
    //  Getter method for the Implementation Object
    AppearanceAttrMappingImpl*  getAppearanceAttrMappingImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAppearanceAttrMappingImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AppearanceAttrMappingImpl*  m_appearanceattrmappingImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AppearanceAttrMapping - desc for AppearanceAttrMapping parameter
     */
    AppearanceAttrMapping( const AppearanceAttrMapping& );
    AppearanceAttrMapping& operator=( const AppearanceAttrMapping& );

    friend class  AppearanceAttrMappingDelegate;
    friend class  AppearanceAttrMappingDispatch;
    friend class  AppearanceAttrMappingGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__APPEARANCEATTRMAPPING__HXX
