//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AppearanceAttrMappingDelegate
    Filename:   AppearanceAttrMappingDelegate.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPEARANCEATTRMAPPINGDELEGATE_HXX
#define TEAMCENTER__APPEARANCEATTRMAPPINGDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <appr/AppearanceAttrMapping.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class AppearanceAttrMappingDelegate;
}
namespace Teamcenter
{
    class AppearanceAttrMappingImpl;
}
namespace Teamcenter
{
    class AppearanceAttrMapping;
}
namespace Teamcenter
{
    class AppearanceAttrMappingGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  APPR_API Teamcenter_alias::AppearanceAttrMappingDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the AppearanceAttrMappingDelegate instance
    static AppearanceAttrMappingDelegate&  getInstance();

    //  Method to create the AppearanceAttrMappingImpl pointer
    static AppearanceAttrMappingImpl*  createImpl( AppearanceAttrMapping&  ifObj );

    //  Method to delete the AppearanceAttrMappingImpl pointer
    static void deleteImpl( AppearanceAttrMappingImpl*  impl );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const AppearanceAttrMapping &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const AppearanceAttrMapping &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static AppearanceAttrMappingDelegate*  m_pInstance;

    AppearanceAttrMappingDelegate();
    virtual ~AppearanceAttrMappingDelegate();
    static void setInstance( AppearanceAttrMappingDelegate*  instance );


private:
    friend class  ::Teamcenter::AppearanceAttrMappingGenImpl;

};

#include <appr/libappr_undef.h>
#endif  //  TEAMCENTER__APPEARANCEATTRMAPPINGDELEGATE_HXX
