//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AppearanceCheckerPkg
    Filename:   AppearanceCheckerPkg.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPEARANCECHECKERPKG__HXX
#define TEAMCENTER__APPEARANCECHECKERPKG__HXX

#include <common/tc_deprecation_macros.h>
#include <appr/ApprUpdChangePkg.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class AppearanceCheckerPkg;
}
namespace Teamcenter
{
    class AppearanceCheckerPkgImpl;
}
namespace Teamcenter
{
    class AppearanceCheckerPkgDelegate;
}
namespace Teamcenter
{
    class AppearanceCheckerPkgDispatch;
}
namespace Teamcenter
{
    class AppearanceCheckerPkgGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::AppearanceCheckerPkg
     : public  ::Teamcenter::ApprUpdChangePkg
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AppearanceCheckerPkg();

    /**
     * Destructor
     */
    virtual ~AppearanceCheckerPkg();

private:
    //  Getter method for the Implementation Object
    AppearanceCheckerPkgImpl*  getAppearanceCheckerPkgImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAppearanceCheckerPkgImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AppearanceCheckerPkgImpl*  m_appearancecheckerpkgImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AppearanceCheckerPkg - desc for AppearanceCheckerPkg parameter
     */
    AppearanceCheckerPkg( const AppearanceCheckerPkg& );
    AppearanceCheckerPkg& operator=( const AppearanceCheckerPkg& );

    friend class  AppearanceCheckerPkgDelegate;
    friend class  AppearanceCheckerPkgDispatch;
    friend class  AppearanceCheckerPkgGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__APPEARANCECHECKERPKG__HXX
