//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AppearanceConfigContext
    Filename:   AppearanceConfigContext.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPEARANCECONFIGCONTEXT__HXX
#define TEAMCENTER__APPEARANCECONFIGCONTEXT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class AppearanceConfigContext;
}
namespace Teamcenter
{
    class AppearanceConfigContextImpl;
}
namespace Teamcenter
{
    class AppearanceConfigContextDelegate;
}
namespace Teamcenter
{
    class AppearanceConfigContextDispatch;
}
namespace Teamcenter
{
    class AppearanceConfigContextGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::AppearanceConfigContext
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AppearanceConfigContext();

    /**
     * Destructor
     */
    virtual ~AppearanceConfigContext();

private:
    //  Getter method for the Implementation Object
    AppearanceConfigContextImpl*  getAppearanceConfigContextImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAppearanceConfigContextImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AppearanceConfigContextImpl*  m_appearanceconfigcontextImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AppearanceConfigContext - desc for AppearanceConfigContext parameter
     */
    AppearanceConfigContext( const AppearanceConfigContext& );
    AppearanceConfigContext& operator=( const AppearanceConfigContext& );

    friend class  AppearanceConfigContextDelegate;
    friend class  AppearanceConfigContextDispatch;
    friend class  AppearanceConfigContextGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__APPEARANCECONFIGCONTEXT__HXX
