//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AppearanceConfigContextDelegate
    Filename:   AppearanceConfigContextDelegate.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPEARANCECONFIGCONTEXTDELEGATE_HXX
#define TEAMCENTER__APPEARANCECONFIGCONTEXTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <appr/AppearanceConfigContext.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class AppearanceConfigContextDelegate;
}
namespace Teamcenter
{
    class AppearanceConfigContextImpl;
}
namespace Teamcenter
{
    class AppearanceConfigContext;
}
namespace Teamcenter
{
    class AppearanceConfigContextGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  APPR_API Teamcenter_alias::AppearanceConfigContextDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the AppearanceConfigContextDelegate instance
    static AppearanceConfigContextDelegate&  getInstance();

    //  Method to create the AppearanceConfigContextImpl pointer
    static AppearanceConfigContextImpl*  createImpl( AppearanceConfigContext&  ifObj );

    //  Method to delete the AppearanceConfigContextImpl pointer
    static void deleteImpl( AppearanceConfigContextImpl*  impl );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const AppearanceConfigContext &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static AppearanceConfigContextDelegate*  m_pInstance;

    AppearanceConfigContextDelegate();
    virtual ~AppearanceConfigContextDelegate();
    static void setInstance( AppearanceConfigContextDelegate*  instance );


private:
    friend class  ::Teamcenter::AppearanceConfigContextGenImpl;

};

#include <appr/libappr_undef.h>
#endif  //  TEAMCENTER__APPEARANCECONFIGCONTEXTDELEGATE_HXX
