//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AppearanceRoot
    Filename:   AppearanceRoot.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPEARANCEROOT__HXX
#define TEAMCENTER__APPEARANCEROOT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class AppearanceRoot;
}
namespace Teamcenter
{
    class AppearanceRootImpl;
}
namespace Teamcenter
{
    class AppearanceRootDelegate;
}
namespace Teamcenter
{
    class AppearanceRootDispatch;
}
namespace Teamcenter
{
    class AppearanceRootGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::AppearanceRoot
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AppearanceRoot();

    /**
     * Destructor
     */
    virtual ~AppearanceRoot();

private:
    //  Getter method for the Implementation Object
    AppearanceRootImpl*  getAppearanceRootImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAppearanceRootImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AppearanceRootImpl*  m_appearancerootImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AppearanceRoot - desc for AppearanceRoot parameter
     */
    AppearanceRoot( const AppearanceRoot& );
    AppearanceRoot& operator=( const AppearanceRoot& );

    friend class  AppearanceRootDelegate;
    friend class  AppearanceRootDispatch;
    friend class  AppearanceRootGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__APPEARANCEROOT__HXX
