//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AppearanceRootDelegate
    Filename:   AppearanceRootDelegate.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPEARANCEROOTDELEGATE_HXX
#define TEAMCENTER__APPEARANCEROOTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <appr/AppearanceRoot.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class AppearanceRootDelegate;
}
namespace Teamcenter
{
    class AppearanceRootImpl;
}
namespace Teamcenter
{
    class AppearanceRoot;
}
namespace Teamcenter
{
    class AppearanceRootGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  APPR_API Teamcenter_alias::AppearanceRootDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the AppearanceRootDelegate instance
    static AppearanceRootDelegate&  getInstance();

    //  Method to create the AppearanceRootImpl pointer
    static AppearanceRootImpl*  createImpl( AppearanceRoot&  ifObj );

    //  Method to delete the AppearanceRootImpl pointer
    static void deleteImpl( AppearanceRootImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const AppearanceRoot &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static AppearanceRootDelegate*  m_pInstance;

    AppearanceRootDelegate();
    virtual ~AppearanceRootDelegate();
    static void setInstance( AppearanceRootDelegate*  instance );


private:
    friend class  ::Teamcenter::AppearanceRootGenImpl;

};

#include <appr/libappr_undef.h>
#endif  //  TEAMCENTER__APPEARANCEROOTDELEGATE_HXX
