//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AppearanceTrackedItemInfo
    Filename:   AppearanceTrackedItemInfo.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPEARANCETRACKEDITEMINFO__HXX
#define TEAMCENTER__APPEARANCETRACKEDITEMINFO__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class AppearanceTrackedItemInfo;
}
namespace Teamcenter
{
    class AppearanceTrackedItemInfoImpl;
}
namespace Teamcenter
{
    class AppearanceTrackedItemInfoDelegate;
}
namespace Teamcenter
{
    class AppearanceTrackedItemInfoDispatch;
}
namespace Teamcenter
{
    class AppearanceTrackedItemInfoGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::AppearanceTrackedItemInfo
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AppearanceTrackedItemInfo();

    /**
     * Destructor
     */
    virtual ~AppearanceTrackedItemInfo();

private:
    //  Getter method for the Implementation Object
    AppearanceTrackedItemInfoImpl*  getAppearanceTrackedItemInfoImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAppearanceTrackedItemInfoImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AppearanceTrackedItemInfoImpl*  m_appearancetrackediteminfoImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AppearanceTrackedItemInfo - desc for AppearanceTrackedItemInfo parameter
     */
    AppearanceTrackedItemInfo( const AppearanceTrackedItemInfo& );
    AppearanceTrackedItemInfo& operator=( const AppearanceTrackedItemInfo& );

    friend class  AppearanceTrackedItemInfoDelegate;
    friend class  AppearanceTrackedItemInfoDispatch;
    friend class  AppearanceTrackedItemInfoGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__APPEARANCETRACKEDITEMINFO__HXX
