//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprHistoryDateEntry
    Filename:   ApprHistoryDateEntry.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRHISTORYDATEENTRY__HXX
#define TEAMCENTER__APPRHISTORYDATEENTRY__HXX

#include <common/tc_deprecation_macros.h>
#include <appr/ApprHistoryEntry.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class ApprHistoryDateEntry;
}
namespace Teamcenter
{
    class ApprHistoryDateEntryImpl;
}
namespace Teamcenter
{
    class ApprHistoryDateEntryDelegate;
}
namespace Teamcenter
{
    class ApprHistoryDateEntryDispatch;
}
namespace Teamcenter
{
    class ApprHistoryDateEntryGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::ApprHistoryDateEntry
     : public  ::Teamcenter::ApprHistoryEntry
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ApprHistoryDateEntry();

    /**
     * Destructor
     */
    virtual ~ApprHistoryDateEntry();

private:
    //  Getter method for the Implementation Object
    ApprHistoryDateEntryImpl*  getApprHistoryDateEntryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setApprHistoryDateEntryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ApprHistoryDateEntryImpl*  m_apprhistorydateentryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ApprHistoryDateEntry - desc for ApprHistoryDateEntry parameter
     */
    ApprHistoryDateEntry( const ApprHistoryDateEntry& );
    ApprHistoryDateEntry& operator=( const ApprHistoryDateEntry& );

    friend class  ApprHistoryDateEntryDelegate;
    friend class  ApprHistoryDateEntryDispatch;
    friend class  ApprHistoryDateEntryGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__APPRHISTORYDATEENTRY__HXX
