//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprHistoryEntry
    Filename:   ApprHistoryEntry.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRHISTORYENTRY__HXX
#define TEAMCENTER__APPRHISTORYENTRY__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class ApprHistoryEntry;
}
namespace Teamcenter
{
    class ApprHistoryEntryImpl;
}
namespace Teamcenter
{
    class ApprHistoryEntryDelegate;
}
namespace Teamcenter
{
    class ApprHistoryEntryDispatch;
}
namespace Teamcenter
{
    class ApprHistoryEntryGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::ApprHistoryEntry
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ApprHistoryEntry();

    /**
     * Destructor
     */
    virtual ~ApprHistoryEntry();

private:
    //  Getter method for the Implementation Object
    ApprHistoryEntryImpl*  getApprHistoryEntryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setApprHistoryEntryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ApprHistoryEntryImpl*  m_apprhistoryentryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ApprHistoryEntry - desc for ApprHistoryEntry parameter
     */
    ApprHistoryEntry( const ApprHistoryEntry& );
    ApprHistoryEntry& operator=( const ApprHistoryEntry& );

    friend class  ApprHistoryEntryDelegate;
    friend class  ApprHistoryEntryDispatch;
    friend class  ApprHistoryEntryGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__APPRHISTORYENTRY__HXX
