//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprHistoryUnitNoEntry
    Filename:   ApprHistoryUnitNoEntry.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRHISTORYUNITNOENTRY__HXX
#define TEAMCENTER__APPRHISTORYUNITNOENTRY__HXX

#include <common/tc_deprecation_macros.h>
#include <appr/ApprHistoryEntry.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class ApprHistoryUnitNoEntry;
}
namespace Teamcenter
{
    class ApprHistoryUnitNoEntryImpl;
}
namespace Teamcenter
{
    class ApprHistoryUnitNoEntryDelegate;
}
namespace Teamcenter
{
    class ApprHistoryUnitNoEntryDispatch;
}
namespace Teamcenter
{
    class ApprHistoryUnitNoEntryGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::ApprHistoryUnitNoEntry
     : public  ::Teamcenter::ApprHistoryEntry
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ApprHistoryUnitNoEntry();

    /**
     * Destructor
     */
    virtual ~ApprHistoryUnitNoEntry();

private:
    //  Getter method for the Implementation Object
    ApprHistoryUnitNoEntryImpl*  getApprHistoryUnitNoEntryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setApprHistoryUnitNoEntryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ApprHistoryUnitNoEntryImpl*  m_apprhistoryunitnoentryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ApprHistoryUnitNoEntry - desc for ApprHistoryUnitNoEntry parameter
     */
    ApprHistoryUnitNoEntry( const ApprHistoryUnitNoEntry& );
    ApprHistoryUnitNoEntry& operator=( const ApprHistoryUnitNoEntry& );

    friend class  ApprHistoryUnitNoEntryDelegate;
    friend class  ApprHistoryUnitNoEntryDispatch;
    friend class  ApprHistoryUnitNoEntryGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__APPRHISTORYUNITNOENTRY__HXX
