//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprItemRevOrder
    Filename:   ApprItemRevOrder.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRITEMREVORDER__HXX
#define TEAMCENTER__APPRITEMREVORDER__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class ApprItemRevOrder;
}
namespace Teamcenter
{
    class ApprItemRevOrderImpl;
}
namespace Teamcenter
{
    class ApprItemRevOrderDelegate;
}
namespace Teamcenter
{
    class ApprItemRevOrderDispatch;
}
namespace Teamcenter
{
    class ApprItemRevOrderGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::ApprItemRevOrder
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ApprItemRevOrder();

    /**
     * Destructor
     */
    virtual ~ApprItemRevOrder();

private:
    //  Getter method for the Implementation Object
    ApprItemRevOrderImpl*  getApprItemRevOrderImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setApprItemRevOrderImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ApprItemRevOrderImpl*  m_appritemrevorderImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ApprItemRevOrder - desc for ApprItemRevOrder parameter
     */
    ApprItemRevOrder( const ApprItemRevOrder& );
    ApprItemRevOrder& operator=( const ApprItemRevOrder& );

    friend class  ApprItemRevOrderDelegate;
    friend class  ApprItemRevOrderDispatch;
    friend class  ApprItemRevOrderGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__APPRITEMREVORDER__HXX
