//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprItemRevOrderDelegate
    Filename:   ApprItemRevOrderDelegate.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRITEMREVORDERDELEGATE_HXX
#define TEAMCENTER__APPRITEMREVORDERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <appr/ApprItemRevOrder.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class ApprItemRevOrderDelegate;
}
namespace Teamcenter
{
    class ApprItemRevOrderImpl;
}
namespace Teamcenter
{
    class ApprItemRevOrder;
}
namespace Teamcenter
{
    class ApprItemRevOrderGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  APPR_API Teamcenter_alias::ApprItemRevOrderDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ApprItemRevOrderDelegate instance
    static ApprItemRevOrderDelegate&  getInstance();

    //  Method to create the ApprItemRevOrderImpl pointer
    static ApprItemRevOrderImpl*  createImpl( ApprItemRevOrder&  ifObj );

    //  Method to delete the ApprItemRevOrderImpl pointer
    static void deleteImpl( ApprItemRevOrderImpl*  impl );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const ApprItemRevOrder &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const ApprItemRevOrder &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static ApprItemRevOrderDelegate*  m_pInstance;

    ApprItemRevOrderDelegate();
    virtual ~ApprItemRevOrderDelegate();
    static void setInstance( ApprItemRevOrderDelegate*  instance );


private:
    friend class  ::Teamcenter::ApprItemRevOrderGenImpl;

};

#include <appr/libappr_undef.h>
#endif  //  TEAMCENTER__APPRITEMREVORDERDELEGATE_HXX
