//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprQueryAudit
    Filename:   ApprQueryAudit.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRQUERYAUDIT__HXX
#define TEAMCENTER__APPRQUERYAUDIT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class ApprQueryAudit;
}
namespace Teamcenter
{
    class ApprQueryAuditImpl;
}
namespace Teamcenter
{
    class ApprQueryAuditDelegate;
}
namespace Teamcenter
{
    class ApprQueryAuditDispatch;
}
namespace Teamcenter
{
    class ApprQueryAuditGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::ApprQueryAudit
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ApprQueryAudit();

    /**
     * Destructor
     */
    virtual ~ApprQueryAudit();

private:
    //  Getter method for the Implementation Object
    ApprQueryAuditImpl*  getApprQueryAuditImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setApprQueryAuditImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ApprQueryAuditImpl*  m_apprqueryauditImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ApprQueryAudit - desc for ApprQueryAudit parameter
     */
    ApprQueryAudit( const ApprQueryAudit& );
    ApprQueryAudit& operator=( const ApprQueryAudit& );

    friend class  ApprQueryAuditDelegate;
    friend class  ApprQueryAuditDispatch;
    friend class  ApprQueryAuditGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__APPRQUERYAUDIT__HXX
