//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprQueryAuditPkg
    Filename:   ApprQueryAuditPkg.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRQUERYAUDITPKG__HXX
#define TEAMCENTER__APPRQUERYAUDITPKG__HXX

#include <common/tc_deprecation_macros.h>
#include <appr/ApprUpdChangePkg.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class ApprQueryAuditPkg;
}
namespace Teamcenter
{
    class ApprQueryAuditPkgImpl;
}
namespace Teamcenter
{
    class ApprQueryAuditPkgDelegate;
}
namespace Teamcenter
{
    class ApprQueryAuditPkgDispatch;
}
namespace Teamcenter
{
    class ApprQueryAuditPkgGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::ApprQueryAuditPkg
     : public  ::Teamcenter::ApprUpdChangePkg
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ApprQueryAuditPkg();

    /**
     * Destructor
     */
    virtual ~ApprQueryAuditPkg();

private:
    //  Getter method for the Implementation Object
    ApprQueryAuditPkgImpl*  getApprQueryAuditPkgImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setApprQueryAuditPkgImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ApprQueryAuditPkgImpl*  m_apprqueryauditpkgImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ApprQueryAuditPkg - desc for ApprQueryAuditPkg parameter
     */
    ApprQueryAuditPkg( const ApprQueryAuditPkg& );
    ApprQueryAuditPkg& operator=( const ApprQueryAuditPkg& );

    friend class  ApprQueryAuditPkgDelegate;
    friend class  ApprQueryAuditPkgDispatch;
    friend class  ApprQueryAuditPkgGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__APPRQUERYAUDITPKG__HXX
