//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprRevRelation
    Filename:   ApprRevRelation.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRREVRELATION__HXX
#define TEAMCENTER__APPRREVRELATION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class ApprRevRelation;
}
namespace Teamcenter
{
    class ApprRevRelationImpl;
}
namespace Teamcenter
{
    class ApprRevRelationDelegate;
}
namespace Teamcenter
{
    class ApprRevRelationDispatch;
}
namespace Teamcenter
{
    class ApprRevRelationGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::ApprRevRelation
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ApprRevRelation();

    /**
     * Destructor
     */
    virtual ~ApprRevRelation();

private:
    //  Getter method for the Implementation Object
    ApprRevRelationImpl*  getApprRevRelationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setApprRevRelationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ApprRevRelationImpl*  m_apprrevrelationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ApprRevRelation - desc for ApprRevRelation parameter
     */
    ApprRevRelation( const ApprRevRelation& );
    ApprRevRelation& operator=( const ApprRevRelation& );

    friend class  ApprRevRelationDelegate;
    friend class  ApprRevRelationDispatch;
    friend class  ApprRevRelationGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__APPRREVRELATION__HXX
