//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprRevRelationDateEff
    Filename:   ApprRevRelationDateEff.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRREVRELATIONDATEEFF__HXX
#define TEAMCENTER__APPRREVRELATIONDATEEFF__HXX

#include <common/tc_deprecation_macros.h>
#include <appr/ApprRevRelation.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class ApprRevRelationDateEff;
}
namespace Teamcenter
{
    class ApprRevRelationDateEffImpl;
}
namespace Teamcenter
{
    class ApprRevRelationDateEffDelegate;
}
namespace Teamcenter
{
    class ApprRevRelationDateEffDispatch;
}
namespace Teamcenter
{
    class ApprRevRelationDateEffGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::ApprRevRelationDateEff
     : public  ::Teamcenter::ApprRevRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ApprRevRelationDateEff();

    /**
     * Destructor
     */
    virtual ~ApprRevRelationDateEff();

private:
    //  Getter method for the Implementation Object
    ApprRevRelationDateEffImpl*  getApprRevRelationDateEffImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setApprRevRelationDateEffImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ApprRevRelationDateEffImpl*  m_apprrevrelationdateeffImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ApprRevRelationDateEff - desc for ApprRevRelationDateEff parameter
     */
    ApprRevRelationDateEff( const ApprRevRelationDateEff& );
    ApprRevRelationDateEff& operator=( const ApprRevRelationDateEff& );

    friend class  ApprRevRelationDateEffDelegate;
    friend class  ApprRevRelationDateEffDispatch;
    friend class  ApprRevRelationDateEffGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__APPRREVRELATIONDATEEFF__HXX
