//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprRevRelationDelegate
    Filename:   ApprRevRelationDelegate.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRREVRELATIONDELEGATE_HXX
#define TEAMCENTER__APPRREVRELATIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <appr/ApprRevRelation.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class ApprRevRelationDelegate;
}
namespace Teamcenter
{
    class ApprRevRelationImpl;
}
namespace Teamcenter
{
    class ApprRevRelation;
}
namespace Teamcenter
{
    class ApprRevRelationGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  APPR_API Teamcenter_alias::ApprRevRelationDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ApprRevRelationDelegate instance
    static ApprRevRelationDelegate&  getInstance();

    //  Method to create the ApprRevRelationImpl pointer
    static ApprRevRelationImpl*  createImpl( ApprRevRelation&  ifObj );

    //  Method to delete the ApprRevRelationImpl pointer
    static void deleteImpl( ApprRevRelationImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @param isLockForDelete - A boolean to indicate if object(s) are to be locked for deletion
    /// @param allowRelock - A boolean to indicate if object(s) can be relocked, which will discard all unsaved changes, if already locked by the same user
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0LockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd, const bool isLockForDelete, const bool allowRelock );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0RefreshBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0UnlockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const ApprRevRelation &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static ApprRevRelationDelegate*  m_pInstance;

    ApprRevRelationDelegate();
    virtual ~ApprRevRelationDelegate();
    static void setInstance( ApprRevRelationDelegate*  instance );


private:
    friend class  ::Teamcenter::ApprRevRelationGenImpl;

};

#include <appr/libappr_undef.h>
#endif  //  TEAMCENTER__APPRREVRELATIONDELEGATE_HXX
