//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprRevRelationUnitEff
    Filename:   ApprRevRelationUnitEff.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRREVRELATIONUNITEFF__HXX
#define TEAMCENTER__APPRREVRELATIONUNITEFF__HXX

#include <common/tc_deprecation_macros.h>
#include <appr/ApprRevRelation.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class ApprRevRelationUnitEff;
}
namespace Teamcenter
{
    class ApprRevRelationUnitEffImpl;
}
namespace Teamcenter
{
    class ApprRevRelationUnitEffDelegate;
}
namespace Teamcenter
{
    class ApprRevRelationUnitEffDispatch;
}
namespace Teamcenter
{
    class ApprRevRelationUnitEffGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::ApprRevRelationUnitEff
     : public  ::Teamcenter::ApprRevRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ApprRevRelationUnitEff();

    /**
     * Destructor
     */
    virtual ~ApprRevRelationUnitEff();

private:
    //  Getter method for the Implementation Object
    ApprRevRelationUnitEffImpl*  getApprRevRelationUnitEffImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setApprRevRelationUnitEffImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ApprRevRelationUnitEffImpl*  m_apprrevrelationuniteffImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ApprRevRelationUnitEff - desc for ApprRevRelationUnitEff parameter
     */
    ApprRevRelationUnitEff( const ApprRevRelationUnitEff& );
    ApprRevRelationUnitEff& operator=( const ApprRevRelationUnitEff& );

    friend class  ApprRevRelationUnitEffDelegate;
    friend class  ApprRevRelationUnitEffDispatch;
    friend class  ApprRevRelationUnitEffGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__APPRREVRELATIONUNITEFF__HXX
