//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprSetRootStatusPkg
    Filename:   ApprSetRootStatusPkg.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRSETROOTSTATUSPKG__HXX
#define TEAMCENTER__APPRSETROOTSTATUSPKG__HXX

#include <common/tc_deprecation_macros.h>
#include <appr/ApprUpdChangePkg.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class ApprSetRootStatusPkg;
}
namespace Teamcenter
{
    class ApprSetRootStatusPkgImpl;
}
namespace Teamcenter
{
    class ApprSetRootStatusPkgDelegate;
}
namespace Teamcenter
{
    class ApprSetRootStatusPkgDispatch;
}
namespace Teamcenter
{
    class ApprSetRootStatusPkgGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::ApprSetRootStatusPkg
     : public  ::Teamcenter::ApprUpdChangePkg
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ApprSetRootStatusPkg();

    /**
     * Destructor
     */
    virtual ~ApprSetRootStatusPkg();

private:
    //  Getter method for the Implementation Object
    ApprSetRootStatusPkgImpl*  getApprSetRootStatusPkgImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setApprSetRootStatusPkgImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ApprSetRootStatusPkgImpl*  m_apprsetrootstatuspkgImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ApprSetRootStatusPkg - desc for ApprSetRootStatusPkg parameter
     */
    ApprSetRootStatusPkg( const ApprSetRootStatusPkg& );
    ApprSetRootStatusPkg& operator=( const ApprSetRootStatusPkg& );

    friend class  ApprSetRootStatusPkgDelegate;
    friend class  ApprSetRootStatusPkgDispatch;
    friend class  ApprSetRootStatusPkgGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__APPRSETROOTSTATUSPKG__HXX
