//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprSpatialUpdatePkg
    Filename:   ApprSpatialUpdatePkg.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRSPATIALUPDATEPKG__HXX
#define TEAMCENTER__APPRSPATIALUPDATEPKG__HXX

#include <common/tc_deprecation_macros.h>
#include <appr/ApprUpdChangePkg.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class ApprSpatialUpdatePkg;
}
namespace Teamcenter
{
    class ApprSpatialUpdatePkgImpl;
}
namespace Teamcenter
{
    class ApprSpatialUpdatePkgDelegate;
}
namespace Teamcenter
{
    class ApprSpatialUpdatePkgDispatch;
}
namespace Teamcenter
{
    class ApprSpatialUpdatePkgGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::ApprSpatialUpdatePkg
     : public  ::Teamcenter::ApprUpdChangePkg
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ApprSpatialUpdatePkg();

    /**
     * Destructor
     */
    virtual ~ApprSpatialUpdatePkg();

private:
    //  Getter method for the Implementation Object
    ApprSpatialUpdatePkgImpl*  getApprSpatialUpdatePkgImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setApprSpatialUpdatePkgImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ApprSpatialUpdatePkgImpl*  m_apprspatialupdatepkgImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ApprSpatialUpdatePkg - desc for ApprSpatialUpdatePkg parameter
     */
    ApprSpatialUpdatePkg( const ApprSpatialUpdatePkg& );
    ApprSpatialUpdatePkg& operator=( const ApprSpatialUpdatePkg& );

    friend class  ApprSpatialUpdatePkgDelegate;
    friend class  ApprSpatialUpdatePkgDispatch;
    friend class  ApprSpatialUpdatePkgGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__APPRSPATIALUPDATEPKG__HXX
