//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprUpdBootstrapPkg
    Filename:   ApprUpdBootstrapPkg.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRUPDBOOTSTRAPPKG__HXX
#define TEAMCENTER__APPRUPDBOOTSTRAPPKG__HXX

#include <common/tc_deprecation_macros.h>
#include <appr/ApprUpdChangePkg.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class ApprUpdBootstrapPkg;
}
namespace Teamcenter
{
    class ApprUpdBootstrapPkgImpl;
}
namespace Teamcenter
{
    class ApprUpdBootstrapPkgDelegate;
}
namespace Teamcenter
{
    class ApprUpdBootstrapPkgDispatch;
}
namespace Teamcenter
{
    class ApprUpdBootstrapPkgGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::ApprUpdBootstrapPkg
     : public  ::Teamcenter::ApprUpdChangePkg
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ApprUpdBootstrapPkg();

    /**
     * Destructor
     */
    virtual ~ApprUpdBootstrapPkg();

private:
    //  Getter method for the Implementation Object
    ApprUpdBootstrapPkgImpl*  getApprUpdBootstrapPkgImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setApprUpdBootstrapPkgImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ApprUpdBootstrapPkgImpl*  m_apprupdbootstrappkgImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ApprUpdBootstrapPkg - desc for ApprUpdBootstrapPkg parameter
     */
    ApprUpdBootstrapPkg( const ApprUpdBootstrapPkg& );
    ApprUpdBootstrapPkg& operator=( const ApprUpdBootstrapPkg& );

    friend class  ApprUpdBootstrapPkgDelegate;
    friend class  ApprUpdBootstrapPkgDispatch;
    friend class  ApprUpdBootstrapPkgGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__APPRUPDBOOTSTRAPPKG__HXX
