//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprUpdByApprRootEffPkg
    Filename:   ApprUpdByApprRootEffPkg.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRUPDBYAPPRROOTEFFPKG__HXX
#define TEAMCENTER__APPRUPDBYAPPRROOTEFFPKG__HXX

#include <common/tc_deprecation_macros.h>
#include <appr/ApprUpdByApprRootPkg.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class ApprUpdByApprRootEffPkg;
}
namespace Teamcenter
{
    class ApprUpdByApprRootEffPkgImpl;
}
namespace Teamcenter
{
    class ApprUpdByApprRootEffPkgDelegate;
}
namespace Teamcenter
{
    class ApprUpdByApprRootEffPkgDispatch;
}
namespace Teamcenter
{
    class ApprUpdByApprRootEffPkgGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::ApprUpdByApprRootEffPkg
     : public  ::Teamcenter::ApprUpdByApprRootPkg
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ApprUpdByApprRootEffPkg();

    /**
     * Destructor
     */
    virtual ~ApprUpdByApprRootEffPkg();

private:
    //  Getter method for the Implementation Object
    ApprUpdByApprRootEffPkgImpl*  getApprUpdByApprRootEffPkgImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setApprUpdByApprRootEffPkgImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ApprUpdByApprRootEffPkgImpl*  m_apprupdbyapprrooteffpkgImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ApprUpdByApprRootEffPkg - desc for ApprUpdByApprRootEffPkg parameter
     */
    ApprUpdByApprRootEffPkg( const ApprUpdByApprRootEffPkg& );
    ApprUpdByApprRootEffPkg& operator=( const ApprUpdByApprRootEffPkg& );

    friend class  ApprUpdByApprRootEffPkgDelegate;
    friend class  ApprUpdByApprRootEffPkgDispatch;
    friend class  ApprUpdByApprRootEffPkgGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__APPRUPDBYAPPRROOTEFFPKG__HXX
