//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprUpdByApprRootPkg
    Filename:   ApprUpdByApprRootPkg.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRUPDBYAPPRROOTPKG__HXX
#define TEAMCENTER__APPRUPDBYAPPRROOTPKG__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class ApprUpdByApprRootPkg;
}
namespace Teamcenter
{
    class ApprUpdByApprRootPkgImpl;
}
namespace Teamcenter
{
    class ApprUpdByApprRootPkgDelegate;
}
namespace Teamcenter
{
    class ApprUpdByApprRootPkgDispatch;
}
namespace Teamcenter
{
    class ApprUpdByApprRootPkgGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::ApprUpdByApprRootPkg
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ApprUpdByApprRootPkg();

    /**
     * Destructor
     */
    virtual ~ApprUpdByApprRootPkg();

private:
    //  Getter method for the Implementation Object
    ApprUpdByApprRootPkgImpl*  getApprUpdByApprRootPkgImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setApprUpdByApprRootPkgImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ApprUpdByApprRootPkgImpl*  m_apprupdbyapprrootpkgImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ApprUpdByApprRootPkg - desc for ApprUpdByApprRootPkg parameter
     */
    ApprUpdByApprRootPkg( const ApprUpdByApprRootPkg& );
    ApprUpdByApprRootPkg& operator=( const ApprUpdByApprRootPkg& );

    friend class  ApprUpdByApprRootPkgDelegate;
    friend class  ApprUpdByApprRootPkgDispatch;
    friend class  ApprUpdByApprRootPkgGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__APPRUPDBYAPPRROOTPKG__HXX
