//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprUpdByApprRootRevPkg
    Filename:   ApprUpdByApprRootRevPkg.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRUPDBYAPPRROOTREVPKG__HXX
#define TEAMCENTER__APPRUPDBYAPPRROOTREVPKG__HXX

#include <common/tc_deprecation_macros.h>
#include <appr/ApprUpdByApprRootPkg.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class ApprUpdByApprRootRevPkg;
}
namespace Teamcenter
{
    class ApprUpdByApprRootRevPkgImpl;
}
namespace Teamcenter
{
    class ApprUpdByApprRootRevPkgDelegate;
}
namespace Teamcenter
{
    class ApprUpdByApprRootRevPkgDispatch;
}
namespace Teamcenter
{
    class ApprUpdByApprRootRevPkgGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::ApprUpdByApprRootRevPkg
     : public  ::Teamcenter::ApprUpdByApprRootPkg
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ApprUpdByApprRootRevPkg();

    /**
     * Destructor
     */
    virtual ~ApprUpdByApprRootRevPkg();

private:
    //  Getter method for the Implementation Object
    ApprUpdByApprRootRevPkgImpl*  getApprUpdByApprRootRevPkgImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setApprUpdByApprRootRevPkgImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ApprUpdByApprRootRevPkgImpl*  m_apprupdbyapprrootrevpkgImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ApprUpdByApprRootRevPkg - desc for ApprUpdByApprRootRevPkg parameter
     */
    ApprUpdByApprRootRevPkg( const ApprUpdByApprRootRevPkg& );
    ApprUpdByApprRootRevPkg& operator=( const ApprUpdByApprRootRevPkg& );

    friend class  ApprUpdByApprRootRevPkgDelegate;
    friend class  ApprUpdByApprRootRevPkgDispatch;
    friend class  ApprUpdByApprRootRevPkgGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__APPRUPDBYAPPRROOTREVPKG__HXX
