//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprUpdChangePkg
    Filename:   ApprUpdChangePkg.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRUPDCHANGEPKG__HXX
#define TEAMCENTER__APPRUPDCHANGEPKG__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class ApprUpdChangePkg;
}
namespace Teamcenter
{
    class ApprUpdChangePkgImpl;
}
namespace Teamcenter
{
    class ApprUpdChangePkgDelegate;
}
namespace Teamcenter
{
    class ApprUpdChangePkgDispatch;
}
namespace Teamcenter
{
    class ApprUpdChangePkgGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::ApprUpdChangePkg
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ApprUpdChangePkg();

    /**
     * Destructor
     */
    virtual ~ApprUpdChangePkg();

private:
    //  Getter method for the Implementation Object
    ApprUpdChangePkgImpl*  getApprUpdChangePkgImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setApprUpdChangePkgImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ApprUpdChangePkgImpl*  m_apprupdchangepkgImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ApprUpdChangePkg - desc for ApprUpdChangePkg parameter
     */
    ApprUpdChangePkg( const ApprUpdChangePkg& );
    ApprUpdChangePkg& operator=( const ApprUpdChangePkg& );

    friend class  ApprUpdChangePkgDelegate;
    friend class  ApprUpdChangePkgDispatch;
    friend class  ApprUpdChangePkgGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__APPRUPDCHANGEPKG__HXX
