//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprUpdChangedEffPkg
    Filename:   ApprUpdChangedEffPkg.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRUPDCHANGEDEFFPKG__HXX
#define TEAMCENTER__APPRUPDCHANGEDEFFPKG__HXX

#include <common/tc_deprecation_macros.h>
#include <appr/ApprUpdChangePkg.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class ApprUpdChangedEffPkg;
}
namespace Teamcenter
{
    class ApprUpdChangedEffPkgImpl;
}
namespace Teamcenter
{
    class ApprUpdChangedEffPkgDelegate;
}
namespace Teamcenter
{
    class ApprUpdChangedEffPkgDispatch;
}
namespace Teamcenter
{
    class ApprUpdChangedEffPkgGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::ApprUpdChangedEffPkg
     : public  ::Teamcenter::ApprUpdChangePkg
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ApprUpdChangedEffPkg();

    /**
     * Destructor
     */
    virtual ~ApprUpdChangedEffPkg();

private:
    //  Getter method for the Implementation Object
    ApprUpdChangedEffPkgImpl*  getApprUpdChangedEffPkgImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setApprUpdChangedEffPkgImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ApprUpdChangedEffPkgImpl*  m_apprupdchangedeffpkgImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ApprUpdChangedEffPkg - desc for ApprUpdChangedEffPkg parameter
     */
    ApprUpdChangedEffPkg( const ApprUpdChangedEffPkg& );
    ApprUpdChangedEffPkg& operator=( const ApprUpdChangedEffPkg& );

    friend class  ApprUpdChangedEffPkgDelegate;
    friend class  ApprUpdChangedEffPkgDispatch;
    friend class  ApprUpdChangedEffPkgGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__APPRUPDCHANGEDEFFPKG__HXX
