//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprUpdChangedRevsPkg
    Filename:   ApprUpdChangedRevsPkg.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRUPDCHANGEDREVSPKG__HXX
#define TEAMCENTER__APPRUPDCHANGEDREVSPKG__HXX

#include <common/tc_deprecation_macros.h>
#include <appr/ApprUpdStructureChangePkg.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class ApprUpdChangedRevsPkg;
}
namespace Teamcenter
{
    class ApprUpdChangedRevsPkgImpl;
}
namespace Teamcenter
{
    class ApprUpdChangedRevsPkgDelegate;
}
namespace Teamcenter
{
    class ApprUpdChangedRevsPkgDispatch;
}
namespace Teamcenter
{
    class ApprUpdChangedRevsPkgGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::ApprUpdChangedRevsPkg
     : public  ::Teamcenter::ApprUpdStructureChangePkg
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ApprUpdChangedRevsPkg();

    /**
     * Destructor
     */
    virtual ~ApprUpdChangedRevsPkg();

private:
    //  Getter method for the Implementation Object
    ApprUpdChangedRevsPkgImpl*  getApprUpdChangedRevsPkgImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setApprUpdChangedRevsPkgImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ApprUpdChangedRevsPkgImpl*  m_apprupdchangedrevspkgImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ApprUpdChangedRevsPkg - desc for ApprUpdChangedRevsPkg parameter
     */
    ApprUpdChangedRevsPkg( const ApprUpdChangedRevsPkg& );
    ApprUpdChangedRevsPkg& operator=( const ApprUpdChangedRevsPkg& );

    friend class  ApprUpdChangedRevsPkgDelegate;
    friend class  ApprUpdChangedRevsPkgDispatch;
    friend class  ApprUpdChangedRevsPkgGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__APPRUPDCHANGEDREVSPKG__HXX
