//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprUpdImportedRevsPkg
    Filename:   ApprUpdImportedRevsPkg.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRUPDIMPORTEDREVSPKG__HXX
#define TEAMCENTER__APPRUPDIMPORTEDREVSPKG__HXX

#include <common/tc_deprecation_macros.h>
#include <appr/ApprUpdChangedRevsPkg.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class ApprUpdImportedRevsPkg;
}
namespace Teamcenter
{
    class ApprUpdImportedRevsPkgImpl;
}
namespace Teamcenter
{
    class ApprUpdImportedRevsPkgDelegate;
}
namespace Teamcenter
{
    class ApprUpdImportedRevsPkgDispatch;
}
namespace Teamcenter
{
    class ApprUpdImportedRevsPkgGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::ApprUpdImportedRevsPkg
     : public  ::Teamcenter::ApprUpdChangedRevsPkg
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ApprUpdImportedRevsPkg();

    /**
     * Destructor
     */
    virtual ~ApprUpdImportedRevsPkg();

private:
    //  Getter method for the Implementation Object
    ApprUpdImportedRevsPkgImpl*  getApprUpdImportedRevsPkgImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setApprUpdImportedRevsPkgImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ApprUpdImportedRevsPkgImpl*  m_apprupdimportedrevspkgImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ApprUpdImportedRevsPkg - desc for ApprUpdImportedRevsPkg parameter
     */
    ApprUpdImportedRevsPkg( const ApprUpdImportedRevsPkg& );
    ApprUpdImportedRevsPkg& operator=( const ApprUpdImportedRevsPkg& );

    friend class  ApprUpdImportedRevsPkgDelegate;
    friend class  ApprUpdImportedRevsPkgDispatch;
    friend class  ApprUpdImportedRevsPkgGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__APPRUPDIMPORTEDREVSPKG__HXX
