//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprUpdIncrChangePkg
    Filename:   ApprUpdIncrChangePkg.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRUPDINCRCHANGEPKG__HXX
#define TEAMCENTER__APPRUPDINCRCHANGEPKG__HXX

#include <common/tc_deprecation_macros.h>
#include <appr/ApprUpdStructureChangePkg.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class ApprUpdIncrChangePkg;
}
namespace Teamcenter
{
    class ApprUpdIncrChangePkgImpl;
}
namespace Teamcenter
{
    class ApprUpdIncrChangePkgDelegate;
}
namespace Teamcenter
{
    class ApprUpdIncrChangePkgDispatch;
}
namespace Teamcenter
{
    class ApprUpdIncrChangePkgGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::ApprUpdIncrChangePkg
     : public  ::Teamcenter::ApprUpdStructureChangePkg
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ApprUpdIncrChangePkg();

    /**
     * Destructor
     */
    virtual ~ApprUpdIncrChangePkg();

private:
    //  Getter method for the Implementation Object
    ApprUpdIncrChangePkgImpl*  getApprUpdIncrChangePkgImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setApprUpdIncrChangePkgImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ApprUpdIncrChangePkgImpl*  m_apprupdincrchangepkgImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ApprUpdIncrChangePkg - desc for ApprUpdIncrChangePkg parameter
     */
    ApprUpdIncrChangePkg( const ApprUpdIncrChangePkg& );
    ApprUpdIncrChangePkg& operator=( const ApprUpdIncrChangePkg& );

    friend class  ApprUpdIncrChangePkgDelegate;
    friend class  ApprUpdIncrChangePkgDispatch;
    friend class  ApprUpdIncrChangePkgGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__APPRUPDINCRCHANGEPKG__HXX
