//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprUpdPreReleasedRevsPkg
    Filename:   ApprUpdPreReleasedRevsPkg.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRUPDPRERELEASEDREVSPKG__HXX
#define TEAMCENTER__APPRUPDPRERELEASEDREVSPKG__HXX

#include <common/tc_deprecation_macros.h>
#include <appr/ApprUpdChangedRevsPkg.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class ApprUpdPreReleasedRevsPkg;
}
namespace Teamcenter
{
    class ApprUpdPreReleasedRevsPkgImpl;
}
namespace Teamcenter
{
    class ApprUpdPreReleasedRevsPkgDelegate;
}
namespace Teamcenter
{
    class ApprUpdPreReleasedRevsPkgDispatch;
}
namespace Teamcenter
{
    class ApprUpdPreReleasedRevsPkgGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::ApprUpdPreReleasedRevsPkg
     : public  ::Teamcenter::ApprUpdChangedRevsPkg
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ApprUpdPreReleasedRevsPkg();

    /**
     * Destructor
     */
    virtual ~ApprUpdPreReleasedRevsPkg();

private:
    //  Getter method for the Implementation Object
    ApprUpdPreReleasedRevsPkgImpl*  getApprUpdPreReleasedRevsPkgImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setApprUpdPreReleasedRevsPkgImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ApprUpdPreReleasedRevsPkgImpl*  m_apprupdprereleasedrevspkgImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ApprUpdPreReleasedRevsPkg - desc for ApprUpdPreReleasedRevsPkg parameter
     */
    ApprUpdPreReleasedRevsPkg( const ApprUpdPreReleasedRevsPkg& );
    ApprUpdPreReleasedRevsPkg& operator=( const ApprUpdPreReleasedRevsPkg& );

    friend class  ApprUpdPreReleasedRevsPkgDelegate;
    friend class  ApprUpdPreReleasedRevsPkgDispatch;
    friend class  ApprUpdPreReleasedRevsPkgGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__APPRUPDPRERELEASEDREVSPKG__HXX
