//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprUpdRevViewImpactsRoot
    Filename:   ApprUpdRevViewImpactsRoot.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRUPDREVVIEWIMPACTSROOT__HXX
#define TEAMCENTER__APPRUPDREVVIEWIMPACTSROOT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class ApprUpdRevViewImpactsRoot;
}
namespace Teamcenter
{
    class ApprUpdRevViewImpactsRootImpl;
}
namespace Teamcenter
{
    class ApprUpdRevViewImpactsRootDelegate;
}
namespace Teamcenter
{
    class ApprUpdRevViewImpactsRootDispatch;
}
namespace Teamcenter
{
    class ApprUpdRevViewImpactsRootGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::ApprUpdRevViewImpactsRoot
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ApprUpdRevViewImpactsRoot();

    /**
     * Destructor
     */
    virtual ~ApprUpdRevViewImpactsRoot();

private:
    //  Getter method for the Implementation Object
    ApprUpdRevViewImpactsRootImpl*  getApprUpdRevViewImpactsRootImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setApprUpdRevViewImpactsRootImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ApprUpdRevViewImpactsRootImpl*  m_apprupdrevviewimpactsrootImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ApprUpdRevViewImpactsRoot - desc for ApprUpdRevViewImpactsRoot parameter
     */
    ApprUpdRevViewImpactsRoot( const ApprUpdRevViewImpactsRoot& );
    ApprUpdRevViewImpactsRoot& operator=( const ApprUpdRevViewImpactsRoot& );

    friend class  ApprUpdRevViewImpactsRootDelegate;
    friend class  ApprUpdRevViewImpactsRootDispatch;
    friend class  ApprUpdRevViewImpactsRootGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__APPRUPDREVVIEWIMPACTSROOT__HXX
