//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprUpdWorkingPkg
    Filename:   ApprUpdWorkingPkg.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRUPDWORKINGPKG__HXX
#define TEAMCENTER__APPRUPDWORKINGPKG__HXX

#include <common/tc_deprecation_macros.h>
#include <appr/ApprUpdChangePkg.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class ApprUpdWorkingPkg;
}
namespace Teamcenter
{
    class ApprUpdWorkingPkgImpl;
}
namespace Teamcenter
{
    class ApprUpdWorkingPkgDelegate;
}
namespace Teamcenter
{
    class ApprUpdWorkingPkgDispatch;
}
namespace Teamcenter
{
    class ApprUpdWorkingPkgGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::ApprUpdWorkingPkg
     : public  ::Teamcenter::ApprUpdChangePkg
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ApprUpdWorkingPkg();

    /**
     * Destructor
     */
    virtual ~ApprUpdWorkingPkg();

private:
    //  Getter method for the Implementation Object
    ApprUpdWorkingPkgImpl*  getApprUpdWorkingPkgImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setApprUpdWorkingPkgImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ApprUpdWorkingPkgImpl*  m_apprupdworkingpkgImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ApprUpdWorkingPkg - desc for ApprUpdWorkingPkg parameter
     */
    ApprUpdWorkingPkg( const ApprUpdWorkingPkg& );
    ApprUpdWorkingPkg& operator=( const ApprUpdWorkingPkg& );

    friend class  ApprUpdWorkingPkgDelegate;
    friend class  ApprUpdWorkingPkgDispatch;
    friend class  ApprUpdWorkingPkgGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__APPRUPDWORKINGPKG__HXX
