//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprUpdaterAuditRecord
    Filename:   ApprUpdaterAuditRecord.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRUPDATERAUDITRECORD__HXX
#define TEAMCENTER__APPRUPDATERAUDITRECORD__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class ApprUpdaterAuditRecord;
}
namespace Teamcenter
{
    class ApprUpdaterAuditRecordImpl;
}
namespace Teamcenter
{
    class ApprUpdaterAuditRecordDelegate;
}
namespace Teamcenter
{
    class ApprUpdaterAuditRecordDispatch;
}
namespace Teamcenter
{
    class ApprUpdaterAuditRecordGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::ApprUpdaterAuditRecord
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ApprUpdaterAuditRecord();

    /**
     * Destructor
     */
    virtual ~ApprUpdaterAuditRecord();

private:
    //  Getter method for the Implementation Object
    ApprUpdaterAuditRecordImpl*  getApprUpdaterAuditRecordImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setApprUpdaterAuditRecordImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ApprUpdaterAuditRecordImpl*  m_apprupdaterauditrecordImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ApprUpdaterAuditRecord - desc for ApprUpdaterAuditRecord parameter
     */
    ApprUpdaterAuditRecord( const ApprUpdaterAuditRecord& );
    ApprUpdaterAuditRecord& operator=( const ApprUpdaterAuditRecord& );

    friend class  ApprUpdaterAuditRecordDelegate;
    friend class  ApprUpdaterAuditRecordDispatch;
    friend class  ApprUpdaterAuditRecordGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__APPRUPDATERAUDITRECORD__HXX
