//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprUpdaterBgActivity
    Filename:   ApprUpdaterBgActivity.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRUPDATERBGACTIVITY__HXX
#define TEAMCENTER__APPRUPDATERBGACTIVITY__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class ApprUpdaterBgActivity;
}
namespace Teamcenter
{
    class ApprUpdaterBgActivityImpl;
}
namespace Teamcenter
{
    class ApprUpdaterBgActivityDelegate;
}
namespace Teamcenter
{
    class ApprUpdaterBgActivityDispatch;
}
namespace Teamcenter
{
    class ApprUpdaterBgActivityGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::ApprUpdaterBgActivity
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ApprUpdaterBgActivity();

    /**
     * Destructor
     */
    virtual ~ApprUpdaterBgActivity();

private:
    //  Getter method for the Implementation Object
    ApprUpdaterBgActivityImpl*  getApprUpdaterBgActivityImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setApprUpdaterBgActivityImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ApprUpdaterBgActivityImpl*  m_apprupdaterbgactivityImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ApprUpdaterBgActivity - desc for ApprUpdaterBgActivity parameter
     */
    ApprUpdaterBgActivity( const ApprUpdaterBgActivity& );
    ApprUpdaterBgActivity& operator=( const ApprUpdaterBgActivity& );

    friend class  ApprUpdaterBgActivityDelegate;
    friend class  ApprUpdaterBgActivityDispatch;
    friend class  ApprUpdaterBgActivityGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__APPRUPDATERBGACTIVITY__HXX
