//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprUpdaterCronEntry
    Filename:   ApprUpdaterCronEntry.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRUPDATERCRONENTRY__HXX
#define TEAMCENTER__APPRUPDATERCRONENTRY__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class ApprUpdaterCronEntry;
}
namespace Teamcenter
{
    class ApprUpdaterCronEntryImpl;
}
namespace Teamcenter
{
    class ApprUpdaterCronEntryDelegate;
}
namespace Teamcenter
{
    class ApprUpdaterCronEntryDispatch;
}
namespace Teamcenter
{
    class ApprUpdaterCronEntryGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::ApprUpdaterCronEntry
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ApprUpdaterCronEntry();

    /**
     * Destructor
     */
    virtual ~ApprUpdaterCronEntry();

private:
    //  Getter method for the Implementation Object
    ApprUpdaterCronEntryImpl*  getApprUpdaterCronEntryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setApprUpdaterCronEntryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ApprUpdaterCronEntryImpl*  m_apprupdatercronentryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ApprUpdaterCronEntry - desc for ApprUpdaterCronEntry parameter
     */
    ApprUpdaterCronEntry( const ApprUpdaterCronEntry& );
    ApprUpdaterCronEntry& operator=( const ApprUpdaterCronEntry& );

    friend class  ApprUpdaterCronEntryDelegate;
    friend class  ApprUpdaterCronEntryDispatch;
    friend class  ApprUpdaterCronEntryGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__APPRUPDATERCRONENTRY__HXX
