//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprUpdaterEmail
    Filename:   ApprUpdaterEmail.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRUPDATEREMAIL__HXX
#define TEAMCENTER__APPRUPDATEREMAIL__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class ApprUpdaterEmail;
}
namespace Teamcenter
{
    class ApprUpdaterEmailImpl;
}
namespace Teamcenter
{
    class ApprUpdaterEmailDelegate;
}
namespace Teamcenter
{
    class ApprUpdaterEmailDispatch;
}
namespace Teamcenter
{
    class ApprUpdaterEmailGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::ApprUpdaterEmail
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ApprUpdaterEmail();

    /**
     * Destructor
     */
    virtual ~ApprUpdaterEmail();

private:
    //  Getter method for the Implementation Object
    ApprUpdaterEmailImpl*  getApprUpdaterEmailImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setApprUpdaterEmailImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ApprUpdaterEmailImpl*  m_apprupdateremailImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ApprUpdaterEmail - desc for ApprUpdaterEmail parameter
     */
    ApprUpdaterEmail( const ApprUpdaterEmail& );
    ApprUpdaterEmail& operator=( const ApprUpdaterEmail& );

    friend class  ApprUpdaterEmailDelegate;
    friend class  ApprUpdaterEmailDispatch;
    friend class  ApprUpdaterEmailGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__APPRUPDATEREMAIL__HXX
