//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ArroApprsHistoryEntry
    Filename:   ArroApprsHistoryEntry.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ARROAPPRSHISTORYENTRY__HXX
#define TEAMCENTER__ARROAPPRSHISTORYENTRY__HXX

#include <common/tc_deprecation_macros.h>
#include <appr/ArroHistoryEntry.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class ArroApprsHistoryEntry;
}
namespace Teamcenter
{
    class ArroApprsHistoryEntryImpl;
}
namespace Teamcenter
{
    class ArroApprsHistoryEntryDelegate;
}
namespace Teamcenter
{
    class ArroApprsHistoryEntryDispatch;
}
namespace Teamcenter
{
    class ArroApprsHistoryEntryGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::ArroApprsHistoryEntry
     : public  ::Teamcenter::ArroHistoryEntry
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ArroApprsHistoryEntry();

    /**
     * Destructor
     */
    virtual ~ArroApprsHistoryEntry();

private:
    //  Getter method for the Implementation Object
    ArroApprsHistoryEntryImpl*  getArroApprsHistoryEntryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setArroApprsHistoryEntryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ArroApprsHistoryEntryImpl*  m_arroapprshistoryentryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ArroApprsHistoryEntry - desc for ArroApprsHistoryEntry parameter
     */
    ArroApprsHistoryEntry( const ArroApprsHistoryEntry& );
    ArroApprsHistoryEntry& operator=( const ArroApprsHistoryEntry& );

    friend class  ArroApprsHistoryEntryDelegate;
    friend class  ArroApprsHistoryEntryDispatch;
    friend class  ArroApprsHistoryEntryGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__ARROAPPRSHISTORYENTRY__HXX
