//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ArroDateEffsHistoryEntry
    Filename:   ArroDateEffsHistoryEntry.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ARRODATEEFFSHISTORYENTRY__HXX
#define TEAMCENTER__ARRODATEEFFSHISTORYENTRY__HXX

#include <common/tc_deprecation_macros.h>
#include <appr/ArroHistoryEntry.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class ArroDateEffsHistoryEntry;
}
namespace Teamcenter
{
    class ArroDateEffsHistoryEntryImpl;
}
namespace Teamcenter
{
    class ArroDateEffsHistoryEntryDelegate;
}
namespace Teamcenter
{
    class ArroDateEffsHistoryEntryDispatch;
}
namespace Teamcenter
{
    class ArroDateEffsHistoryEntryGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::ArroDateEffsHistoryEntry
     : public  ::Teamcenter::ArroHistoryEntry
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ArroDateEffsHistoryEntry();

    /**
     * Destructor
     */
    virtual ~ArroDateEffsHistoryEntry();

private:
    //  Getter method for the Implementation Object
    ArroDateEffsHistoryEntryImpl*  getArroDateEffsHistoryEntryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setArroDateEffsHistoryEntryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ArroDateEffsHistoryEntryImpl*  m_arrodateeffshistoryentryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ArroDateEffsHistoryEntry - desc for ArroDateEffsHistoryEntry parameter
     */
    ArroDateEffsHistoryEntry( const ArroDateEffsHistoryEntry& );
    ArroDateEffsHistoryEntry& operator=( const ArroDateEffsHistoryEntry& );

    friend class  ArroDateEffsHistoryEntryDelegate;
    friend class  ArroDateEffsHistoryEntryDispatch;
    friend class  ArroDateEffsHistoryEntryGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__ARRODATEEFFSHISTORYENTRY__HXX
