//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ArroHistoryEntry
    Filename:   ArroHistoryEntry.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ARROHISTORYENTRY__HXX
#define TEAMCENTER__ARROHISTORYENTRY__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class ArroHistoryEntry;
}
namespace Teamcenter
{
    class ArroHistoryEntryImpl;
}
namespace Teamcenter
{
    class ArroHistoryEntryDelegate;
}
namespace Teamcenter
{
    class ArroHistoryEntryDispatch;
}
namespace Teamcenter
{
    class ArroHistoryEntryGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::ArroHistoryEntry
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ArroHistoryEntry();

    /**
     * Destructor
     */
    virtual ~ArroHistoryEntry();

private:
    //  Getter method for the Implementation Object
    ArroHistoryEntryImpl*  getArroHistoryEntryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setArroHistoryEntryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ArroHistoryEntryImpl*  m_arrohistoryentryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ArroHistoryEntry - desc for ArroHistoryEntry parameter
     */
    ArroHistoryEntry( const ArroHistoryEntry& );
    ArroHistoryEntry& operator=( const ArroHistoryEntry& );

    friend class  ArroHistoryEntryDelegate;
    friend class  ArroHistoryEntryDispatch;
    friend class  ArroHistoryEntryGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__ARROHISTORYENTRY__HXX
