//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ArroIncrChgRevsHistoryEntry
    Filename:   ArroIncrChgRevsHistoryEntry.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ARROINCRCHGREVSHISTORYENTRY__HXX
#define TEAMCENTER__ARROINCRCHGREVSHISTORYENTRY__HXX

#include <common/tc_deprecation_macros.h>
#include <appr/ArroHistoryEntry.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class ArroIncrChgRevsHistoryEntry;
}
namespace Teamcenter
{
    class ArroIncrChgRevsHistoryEntryImpl;
}
namespace Teamcenter
{
    class ArroIncrChgRevsHistoryEntryDelegate;
}
namespace Teamcenter
{
    class ArroIncrChgRevsHistoryEntryDispatch;
}
namespace Teamcenter
{
    class ArroIncrChgRevsHistoryEntryGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::ArroIncrChgRevsHistoryEntry
     : public  ::Teamcenter::ArroHistoryEntry
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ArroIncrChgRevsHistoryEntry();

    /**
     * Destructor
     */
    virtual ~ArroIncrChgRevsHistoryEntry();

private:
    //  Getter method for the Implementation Object
    ArroIncrChgRevsHistoryEntryImpl*  getArroIncrChgRevsHistoryEntryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setArroIncrChgRevsHistoryEntryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ArroIncrChgRevsHistoryEntryImpl*  m_arroincrchgrevshistoryentryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ArroIncrChgRevsHistoryEntry - desc for ArroIncrChgRevsHistoryEntry parameter
     */
    ArroIncrChgRevsHistoryEntry( const ArroIncrChgRevsHistoryEntry& );
    ArroIncrChgRevsHistoryEntry& operator=( const ArroIncrChgRevsHistoryEntry& );

    friend class  ArroIncrChgRevsHistoryEntryDelegate;
    friend class  ArroIncrChgRevsHistoryEntryDispatch;
    friend class  ArroIncrChgRevsHistoryEntryGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__ARROINCRCHGREVSHISTORYENTRY__HXX
