//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ArroUnitEffsHistoryEntry
    Filename:   ArroUnitEffsHistoryEntry.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ARROUNITEFFSHISTORYENTRY__HXX
#define TEAMCENTER__ARROUNITEFFSHISTORYENTRY__HXX

#include <common/tc_deprecation_macros.h>
#include <appr/ArroHistoryEntry.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class ArroUnitEffsHistoryEntry;
}
namespace Teamcenter
{
    class ArroUnitEffsHistoryEntryImpl;
}
namespace Teamcenter
{
    class ArroUnitEffsHistoryEntryDelegate;
}
namespace Teamcenter
{
    class ArroUnitEffsHistoryEntryDispatch;
}
namespace Teamcenter
{
    class ArroUnitEffsHistoryEntryGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::ArroUnitEffsHistoryEntry
     : public  ::Teamcenter::ArroHistoryEntry
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ArroUnitEffsHistoryEntry();

    /**
     * Destructor
     */
    virtual ~ArroUnitEffsHistoryEntry();

private:
    //  Getter method for the Implementation Object
    ArroUnitEffsHistoryEntryImpl*  getArroUnitEffsHistoryEntryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setArroUnitEffsHistoryEntryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ArroUnitEffsHistoryEntryImpl*  m_arrouniteffshistoryentryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ArroUnitEffsHistoryEntry - desc for ArroUnitEffsHistoryEntry parameter
     */
    ArroUnitEffsHistoryEntry( const ArroUnitEffsHistoryEntry& );
    ArroUnitEffsHistoryEntry& operator=( const ArroUnitEffsHistoryEntry& );

    friend class  ArroUnitEffsHistoryEntryDelegate;
    friend class  ArroUnitEffsHistoryEntryDispatch;
    friend class  ArroUnitEffsHistoryEntryGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__ARROUNITEFFSHISTORYENTRY__HXX
