//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ArroValidRevsHistoryEntry
    Filename:   ArroValidRevsHistoryEntry.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ARROVALIDREVSHISTORYENTRY__HXX
#define TEAMCENTER__ARROVALIDREVSHISTORYENTRY__HXX

#include <common/tc_deprecation_macros.h>
#include <appr/ArroHistoryEntry.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class ArroValidRevsHistoryEntry;
}
namespace Teamcenter
{
    class ArroValidRevsHistoryEntryImpl;
}
namespace Teamcenter
{
    class ArroValidRevsHistoryEntryDelegate;
}
namespace Teamcenter
{
    class ArroValidRevsHistoryEntryDispatch;
}
namespace Teamcenter
{
    class ArroValidRevsHistoryEntryGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::ArroValidRevsHistoryEntry
     : public  ::Teamcenter::ArroHistoryEntry
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ArroValidRevsHistoryEntry();

    /**
     * Destructor
     */
    virtual ~ArroValidRevsHistoryEntry();

private:
    //  Getter method for the Implementation Object
    ArroValidRevsHistoryEntryImpl*  getArroValidRevsHistoryEntryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setArroValidRevsHistoryEntryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ArroValidRevsHistoryEntryImpl*  m_arrovalidrevshistoryentryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ArroValidRevsHistoryEntry - desc for ArroValidRevsHistoryEntry parameter
     */
    ArroValidRevsHistoryEntry( const ArroValidRevsHistoryEntry& );
    ArroValidRevsHistoryEntry& operator=( const ArroValidRevsHistoryEntry& );

    friend class  ArroValidRevsHistoryEntryDelegate;
    friend class  ArroValidRevsHistoryEntryDispatch;
    friend class  ArroValidRevsHistoryEntryGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__ARROVALIDREVSHISTORYENTRY__HXX
