//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AurvirForIncrChange
    Filename:   AurvirForIncrChange.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__AURVIRFORINCRCHANGE__HXX
#define TEAMCENTER__AURVIRFORINCRCHANGE__HXX

#include <common/tc_deprecation_macros.h>
#include <appr/ApprUpdRevViewImpactsRoot.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class AurvirForIncrChange;
}
namespace Teamcenter
{
    class AurvirForIncrChangeImpl;
}
namespace Teamcenter
{
    class AurvirForIncrChangeDelegate;
}
namespace Teamcenter
{
    class AurvirForIncrChangeDispatch;
}
namespace Teamcenter
{
    class AurvirForIncrChangeGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::AurvirForIncrChange
     : public  ::Teamcenter::ApprUpdRevViewImpactsRoot
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AurvirForIncrChange();

    /**
     * Destructor
     */
    virtual ~AurvirForIncrChange();

private:
    //  Getter method for the Implementation Object
    AurvirForIncrChangeImpl*  getAurvirForIncrChangeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAurvirForIncrChangeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AurvirForIncrChangeImpl*  m_aurvirforincrchangeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AurvirForIncrChange - desc for AurvirForIncrChange parameter
     */
    AurvirForIncrChange( const AurvirForIncrChange& );
    AurvirForIncrChange& operator=( const AurvirForIncrChange& );

    friend class  AurvirForIncrChangeDelegate;
    friend class  AurvirForIncrChangeDispatch;
    friend class  AurvirForIncrChangeGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__AURVIRFORINCRCHANGE__HXX
