//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RemoteAppearance
    Filename:   RemoteAppearance.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REMOTEAPPEARANCE__HXX
#define TEAMCENTER__REMOTEAPPEARANCE__HXX

#include <common/tc_deprecation_macros.h>
#include <appr/Appearance.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class RemoteAppearance;
}
namespace Teamcenter
{
    class RemoteAppearanceImpl;
}
namespace Teamcenter
{
    class RemoteAppearanceDelegate;
}
namespace Teamcenter
{
    class RemoteAppearanceDispatch;
}
namespace Teamcenter
{
    class RemoteAppearanceGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::RemoteAppearance
     : public  ::Teamcenter::Appearance
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    RemoteAppearance();

    /**
     * Destructor
     */
    virtual ~RemoteAppearance();

private:
    //  Getter method for the Implementation Object
    RemoteAppearanceImpl*  getRemoteAppearanceImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRemoteAppearanceImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    RemoteAppearanceImpl*  m_remoteappearanceImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param RemoteAppearance - desc for RemoteAppearance parameter
     */
    RemoteAppearance( const RemoteAppearance& );
    RemoteAppearance& operator=( const RemoteAppearance& );

    friend class  RemoteAppearanceDelegate;
    friend class  RemoteAppearanceDispatch;
    friend class  RemoteAppearanceGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__REMOTEAPPEARANCE__HXX
