//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RemoteAppearanceDelegate
    Filename:   RemoteAppearanceDelegate.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REMOTEAPPEARANCEDELEGATE_HXX
#define TEAMCENTER__REMOTEAPPEARANCEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <appr/RemoteAppearance.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class RemoteAppearanceDelegate;
}
namespace Teamcenter
{
    class RemoteAppearanceImpl;
}
namespace Teamcenter
{
    class RemoteAppearance;
}
namespace Teamcenter
{
    class RemoteAppearanceGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  APPR_API Teamcenter_alias::RemoteAppearanceDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the RemoteAppearanceDelegate instance
    static RemoteAppearanceDelegate&  getInstance();

    //  Method to create the RemoteAppearanceImpl pointer
    static RemoteAppearanceImpl*  createImpl( RemoteAppearance&  ifObj );

    //  Method to delete the RemoteAppearanceImpl pointer
    static void deleteImpl( RemoteAppearanceImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const RemoteAppearance &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static RemoteAppearanceDelegate*  m_pInstance;

    RemoteAppearanceDelegate();
    virtual ~RemoteAppearanceDelegate();
    static void setInstance( RemoteAppearanceDelegate*  instance );


private:
    friend class  ::Teamcenter::RemoteAppearanceGenImpl;

};

#include <appr/libappr_undef.h>
#endif  //  TEAMCENTER__REMOTEAPPEARANCEDELEGATE_HXX
