//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RemoteAppearanceRoot
    Filename:   RemoteAppearanceRoot.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REMOTEAPPEARANCEROOT__HXX
#define TEAMCENTER__REMOTEAPPEARANCEROOT__HXX

#include <common/tc_deprecation_macros.h>
#include <appr/AppearanceRoot.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class RemoteAppearanceRoot;
}
namespace Teamcenter
{
    class RemoteAppearanceRootImpl;
}
namespace Teamcenter
{
    class RemoteAppearanceRootDelegate;
}
namespace Teamcenter
{
    class RemoteAppearanceRootDispatch;
}
namespace Teamcenter
{
    class RemoteAppearanceRootGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APPR_API  Teamcenter::RemoteAppearanceRoot
     : public  ::Teamcenter::AppearanceRoot
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    RemoteAppearanceRoot();

    /**
     * Destructor
     */
    virtual ~RemoteAppearanceRoot();

private:
    //  Getter method for the Implementation Object
    RemoteAppearanceRootImpl*  getRemoteAppearanceRootImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRemoteAppearanceRootImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    RemoteAppearanceRootImpl*  m_remoteappearancerootImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param RemoteAppearanceRoot - desc for RemoteAppearanceRoot parameter
     */
    RemoteAppearanceRoot( const RemoteAppearanceRoot& );
    RemoteAppearanceRoot& operator=( const RemoteAppearanceRoot& );

    friend class  RemoteAppearanceRootDelegate;
    friend class  RemoteAppearanceRootDispatch;
    friend class  RemoteAppearanceRootGenImpl;
};

#include <appr/libappr_undef.h>
#endif //   TEAMCENTER__REMOTEAPPEARANCEROOT__HXX
