//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RemoteAppearanceRootDelegate
    Filename:   RemoteAppearanceRootDelegate.hxx
    Module:     appr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REMOTEAPPEARANCEROOTDELEGATE_HXX
#define TEAMCENTER__REMOTEAPPEARANCEROOTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <appr/RemoteAppearanceRoot.hxx>

#include <appr/libappr_exports.h>

namespace Teamcenter
{
    class RemoteAppearanceRootDelegate;
}
namespace Teamcenter
{
    class RemoteAppearanceRootImpl;
}
namespace Teamcenter
{
    class RemoteAppearanceRoot;
}
namespace Teamcenter
{
    class RemoteAppearanceRootGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  APPR_API Teamcenter_alias::RemoteAppearanceRootDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the RemoteAppearanceRootDelegate instance
    static RemoteAppearanceRootDelegate&  getInstance();

    //  Method to create the RemoteAppearanceRootImpl pointer
    static RemoteAppearanceRootImpl*  createImpl( RemoteAppearanceRoot&  ifObj );

    //  Method to delete the RemoteAppearanceRootImpl pointer
    static void deleteImpl( RemoteAppearanceRootImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const RemoteAppearanceRoot &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static RemoteAppearanceRootDelegate*  m_pInstance;

    RemoteAppearanceRootDelegate();
    virtual ~RemoteAppearanceRootDelegate();
    static void setInstance( RemoteAppearanceRootDelegate*  instance );


private:
    friend class  ::Teamcenter::RemoteAppearanceRootGenImpl;

};

#include <appr/libappr_undef.h>
#endif  //  TEAMCENTER__REMOTEAPPEARANCEROOTDELEGATE_HXX
