//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  appr

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libappr

#if !defined(LIBAPPR) && !defined(IPLIB)
#   error IPLIB or LIBAPPR is not defined
#endif

/* Handwritten code should use APPR_API, not APPREXPORT */

#define APPR_API APPREXPORT

#if IPLIB==libappr || defined(LIBAPPR)
#   if defined(__lint)
#       define APPREXPORT       __export(appr)
#       define APPRGLOBAL       extern __global(appr)
#       define APPRPRIVATE      extern __private(appr)
#   elif defined(_WIN32)
#       define APPREXPORT       __declspec(dllexport)
#       define APPRGLOBAL       extern __declspec(dllexport)
#       define APPRPRIVATE      extern
#   else
#       define APPREXPORT
#       define APPRGLOBAL       extern
#       define APPRPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define APPREXPORT       __export(appr)
#       define APPRGLOBAL       extern __global(appr)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define APPREXPORT      __declspec(dllimport)
#       define APPRGLOBAL       extern __declspec(dllimport)
#   else
#       define APPREXPORT
#       define APPRGLOBAL       extern
#   endif
#endif
