//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Aps0AbstractPlantInc
    Filename:   Aps0AbstractPlantInc.hxx
    Module:     aps0apscore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APS0ABSTRACTPLANTINC__HXX
#define TEAMCENTER__APS0ABSTRACTPLANTINC__HXX

#include <metaframework/ReviseInput.hxx>
#include <metaframework/DeepCopyData.hxx>
#include <unidefs.h>
#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <aps0apscore/libaps0apscore_exports.h>

namespace Teamcenter
{
    class Aps0AbstractPlantInc;
}
namespace Teamcenter
{
    class Aps0AbstractPlantIncImpl;
}
namespace Teamcenter
{
    class Aps0AbstractPlantIncDelegate;
}
namespace Teamcenter
{
    class Aps0AbstractPlantIncDispatch;
}
namespace Teamcenter
{
    class Aps0AbstractPlantIncGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APS0APSCORE_API  Teamcenter::Aps0AbstractPlantInc
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAps0EffectivityFormula( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAps0EffectivityFormula( const std::string &value, bool isNull=false );

    ///
    /// 
    /// @version Teamcenter 11.4
    /// @param pReviseInput - pReviseInput
    /// @param vecDeepCopyData - vecDeepCopyData
    /// @return - Failure Code
    ///
    int  finalizeReviseInput( ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );

    ///
    /// 
    /// @version Teamcenter 11.4
    /// @param pReviseInput - pReviseInput
    /// @param vecDeepCopyData - vecDeepCopyData
    /// @param newObjTag - newObjTag
    /// @return - Failure Code
    ///
    int  revise( ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData, tag_t *newObjTag );

    ///
    /// 
    /// @version Teamcenter 11.4
    /// @param pReviseInput - pReviseInput
    /// @param vecDeepCopyData - vecDeepCopyData
    /// @return - Failure Code
    ///
    int  revisePost( ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );

    ///
    /// 
    /// @version Teamcenter 11.4
    /// @param pReviseInput - pReviseInput
    /// @return - Failure Code
    ///
    int  setPropertiesFromReviseInput( ::Teamcenter::ReviseInput *pReviseInput );

    ///
    /// 
    /// @version Teamcenter 11.4
    /// @param pReviseInput - pReviseInput
    /// @param vecDeepCopyData - vecDeepCopyData
    /// @return - Failure Code
    ///
    int  validateReviseInput( ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Aps0AbstractPlantInc();

    /**
     * Destructor
     */
    virtual ~Aps0AbstractPlantInc();

private:
    //  Getter method for the Implementation Object
    Aps0AbstractPlantIncImpl*  getAps0AbstractPlantIncImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAps0AbstractPlantIncImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Aps0AbstractPlantIncImpl*  m_aps0abstractplantincImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Aps0AbstractPlantInc - desc for Aps0AbstractPlantInc parameter
     */
    Aps0AbstractPlantInc( const Aps0AbstractPlantInc& );
    Aps0AbstractPlantInc& operator=( const Aps0AbstractPlantInc& );

    friend class  Aps0AbstractPlantIncDelegate;
    friend class  Aps0AbstractPlantIncDispatch;
    friend class  Aps0AbstractPlantIncGenImpl;
};

#include <aps0apscore/libaps0apscore_undef.h>
#endif //   TEAMCENTER__APS0ABSTRACTPLANTINC__HXX
