//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Aps0AbstractPlantIncDelegate
    Filename:   Aps0AbstractPlantIncDelegate.hxx
    Module:     aps0apscore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APS0ABSTRACTPLANTINCDELEGATE_HXX
#define TEAMCENTER__APS0ABSTRACTPLANTINCDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <aps0apscore/Aps0AbstractPlantInc.hxx>

#include <aps0apscore/libaps0apscore_exports.h>

namespace Teamcenter
{
    class Aps0AbstractPlantIncDelegate;
}
namespace Teamcenter
{
    class Aps0AbstractPlantIncImpl;
}
namespace Teamcenter
{
    class Aps0AbstractPlantInc;
}
namespace Teamcenter
{
    class Aps0AbstractPlantIncGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  APS0APSCORE_API Teamcenter_alias::Aps0AbstractPlantIncDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Aps0AbstractPlantIncDelegate instance
    static Aps0AbstractPlantIncDelegate&  getInstance();

    //  Method to create the Aps0AbstractPlantIncImpl pointer
    static Aps0AbstractPlantIncImpl*  createImpl( Aps0AbstractPlantInc&  ifObj );

    //  Method to delete the Aps0AbstractPlantIncImpl pointer
    static void deleteImpl( Aps0AbstractPlantIncImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAps0EffectivityFormulaBase(const Aps0AbstractPlantInc &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAps0EffectivityFormulaBase(Aps0AbstractPlantInc &ifObj,  const std::string &value, bool isNull );


    ///
    /// 
    /// @version Teamcenter 11.4
    /// @param pReviseInput - pReviseInput
    /// @param vecDeepCopyData - vecDeepCopyData
    /// @return - Failure Code
    ///
    int  finalizeReviseInputBase(const Aps0AbstractPlantInc &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// 
    /// @version Teamcenter 11.4
    /// @param pReviseInput - pReviseInput
    /// @param vecDeepCopyData - vecDeepCopyData
    /// @param newObjTag - newObjTag
    /// @return - Failure Code
    ///
    int  reviseBase(const Aps0AbstractPlantInc &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData, tag_t *newObjTag );


    ///
    /// 
    /// @version Teamcenter 11.4
    /// @param pReviseInput - pReviseInput
    /// @param vecDeepCopyData - vecDeepCopyData
    /// @return - Failure Code
    ///
    int  revisePostBase(const Aps0AbstractPlantInc &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// 
    /// @version Teamcenter 11.4
    /// @param pReviseInput - pReviseInput
    /// @return - Failure Code
    ///
    int  setPropertiesFromReviseInputBase(const Aps0AbstractPlantInc &ifObj,  ::Teamcenter::ReviseInput *pReviseInput );


    ///
    /// 
    /// @version Teamcenter 11.4
    /// @param pReviseInput - pReviseInput
    /// @param vecDeepCopyData - vecDeepCopyData
    /// @return - Failure Code
    ///
    int  validateReviseInputBase(const Aps0AbstractPlantInc &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Aps0AbstractPlantInc &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// finalize operation input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  finalizeSaveAsInputBase(const Aps0AbstractPlantInc &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Aps0AbstractPlantInc &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Aps0AbstractPlantIncDelegate*  m_pInstance;

    Aps0AbstractPlantIncDelegate();
    virtual ~Aps0AbstractPlantIncDelegate();
    static void setInstance( Aps0AbstractPlantIncDelegate*  instance );


private:
    friend class  ::Teamcenter::Aps0AbstractPlantIncGenImpl;

};

#include <aps0apscore/libaps0apscore_undef.h>
#endif  //  TEAMCENTER__APS0ABSTRACTPLANTINCDELEGATE_HXX
