//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Aps0AttachAttrGroup
    Filename:   Aps0AttachAttrGroup.hxx
    Module:     aps0apscore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APS0ATTACHATTRGROUP__HXX
#define TEAMCENTER__APS0ATTACHATTRGROUP__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <aps0apscore/libaps0apscore_exports.h>

namespace Teamcenter
{
    class Aps0AttachAttrGroup;
}
namespace Teamcenter
{
    class Aps0AttachAttrGroupImpl;
}
namespace Teamcenter
{
    class Aps0AttachAttrGroupDelegate;
}
namespace Teamcenter
{
    class Aps0AttachAttrGroupDispatch;
}
namespace Teamcenter
{
    class Aps0AttachAttrGroupGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APS0APSCORE_API  Teamcenter::Aps0AttachAttrGroup
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Aps0AttachAttrGroup();

    /**
     * Destructor
     */
    virtual ~Aps0AttachAttrGroup();

private:
    //  Getter method for the Implementation Object
    Aps0AttachAttrGroupImpl*  getAps0AttachAttrGroupImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAps0AttachAttrGroupImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Aps0AttachAttrGroupImpl*  m_aps0attachattrgroupImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Aps0AttachAttrGroup - desc for Aps0AttachAttrGroup parameter
     */
    Aps0AttachAttrGroup( const Aps0AttachAttrGroup& );
    Aps0AttachAttrGroup& operator=( const Aps0AttachAttrGroup& );

    friend class  Aps0AttachAttrGroupDelegate;
    friend class  Aps0AttachAttrGroupDispatch;
    friend class  Aps0AttachAttrGroupGenImpl;
};

#include <aps0apscore/libaps0apscore_undef.h>
#endif //   TEAMCENTER__APS0ATTACHATTRGROUP__HXX
