//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Aps0AttachAttrGroupDelegate
    Filename:   Aps0AttachAttrGroupDelegate.hxx
    Module:     aps0apscore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APS0ATTACHATTRGROUPDELEGATE_HXX
#define TEAMCENTER__APS0ATTACHATTRGROUPDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <aps0apscore/Aps0AttachAttrGroup.hxx>

#include <aps0apscore/libaps0apscore_exports.h>

namespace Teamcenter
{
    class Aps0AttachAttrGroupDelegate;
}
namespace Teamcenter
{
    class Aps0AttachAttrGroupImpl;
}
namespace Teamcenter
{
    class Aps0AttachAttrGroup;
}
namespace Teamcenter
{
    class Aps0AttachAttrGroupGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  APS0APSCORE_API Teamcenter_alias::Aps0AttachAttrGroupDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Aps0AttachAttrGroupDelegate instance
    static Aps0AttachAttrGroupDelegate&  getInstance();

    //  Method to create the Aps0AttachAttrGroupImpl pointer
    static Aps0AttachAttrGroupImpl*  createImpl( Aps0AttachAttrGroup&  ifObj );

    //  Method to delete the Aps0AttachAttrGroupImpl pointer
    static void deleteImpl( Aps0AttachAttrGroupImpl*  impl );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Aps0AttachAttrGroup &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Aps0AttachAttrGroup &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// This operation returns the Copy Stable Last Modified Date for the secondary object.
    /// @version Teamcenter 11.2
    /// @param copyStableLmd - The Copy Stable Lmd of the secondary data on the relation.
    /// @param isNull - True if the value of lmd or lsd is  not set on the secondary object
    /// @return - 
    ///
    int  fnd0AskCopyStableLmdBase(const Aps0AttachAttrGroup &ifObj,  date_t *copyStableLmd, bool *isNull ) const;


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Aps0AttachAttrGroup &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Aps0AttachAttrGroupDelegate*  m_pInstance;

    Aps0AttachAttrGroupDelegate();
    virtual ~Aps0AttachAttrGroupDelegate();
    static void setInstance( Aps0AttachAttrGroupDelegate*  instance );


private:
    friend class  ::Teamcenter::Aps0AttachAttrGroupGenImpl;

};

#include <aps0apscore/libaps0apscore_undef.h>
#endif  //  TEAMCENTER__APS0ATTACHATTRGROUPDELEGATE_HXX
