//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Aps0AttributeGroup
    Filename:   Aps0AttributeGroup.hxx
    Module:     aps0apscore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APS0ATTRIBUTEGROUP__HXX
#define TEAMCENTER__APS0ATTRIBUTEGROUP__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <aps0apscore/libaps0apscore_exports.h>

namespace Teamcenter
{
    class Aps0AttributeGroup;
}
namespace Teamcenter
{
    class Aps0AttributeGroupImpl;
}
namespace Teamcenter
{
    class Aps0AttributeGroupDelegate;
}
namespace Teamcenter
{
    class Aps0AttributeGroupDispatch;
}
namespace Teamcenter
{
    class Aps0AttributeGroupGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APS0APSCORE_API  Teamcenter::Aps0AttributeGroup
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Aps0AttributeGroup();

    /**
     * Destructor
     */
    virtual ~Aps0AttributeGroup();

private:
    //  Getter method for the Implementation Object
    Aps0AttributeGroupImpl*  getAps0AttributeGroupImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAps0AttributeGroupImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Aps0AttributeGroupImpl*  m_aps0attributegroupImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Aps0AttributeGroup - desc for Aps0AttributeGroup parameter
     */
    Aps0AttributeGroup( const Aps0AttributeGroup& );
    Aps0AttributeGroup& operator=( const Aps0AttributeGroup& );

    friend class  Aps0AttributeGroupDelegate;
    friend class  Aps0AttributeGroupDispatch;
    friend class  Aps0AttributeGroupGenImpl;
};

#include <aps0apscore/libaps0apscore_undef.h>
#endif //   TEAMCENTER__APS0ATTRIBUTEGROUP__HXX
