//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Aps0AttributeGroupDelegate
    Filename:   Aps0AttributeGroupDelegate.hxx
    Module:     aps0apscore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APS0ATTRIBUTEGROUPDELEGATE_HXX
#define TEAMCENTER__APS0ATTRIBUTEGROUPDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <aps0apscore/Aps0AttributeGroup.hxx>

#include <aps0apscore/libaps0apscore_exports.h>

namespace Teamcenter
{
    class Aps0AttributeGroupDelegate;
}
namespace Teamcenter
{
    class Aps0AttributeGroupImpl;
}
namespace Teamcenter
{
    class Aps0AttributeGroup;
}
namespace Teamcenter
{
    class Aps0AttributeGroupGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  APS0APSCORE_API Teamcenter_alias::Aps0AttributeGroupDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Aps0AttributeGroupDelegate instance
    static Aps0AttributeGroupDelegate&  getInstance();

    //  Method to create the Aps0AttributeGroupImpl pointer
    static Aps0AttributeGroupImpl*  createImpl( Aps0AttributeGroup&  ifObj );

    //  Method to delete the Aps0AttributeGroupImpl pointer
    static void deleteImpl( Aps0AttributeGroupImpl*  impl );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Aps0AttributeGroup &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// perform deep copy
    /// @version Teamcenter 9
    /// @param pOperationInput - desc
    /// @param vecDeepCopyData - deep copy data
    /// @return - returns an int
    ///
    int  performDeepCopyBase(const Aps0AttributeGroup &ifObj,  ::Teamcenter::OperationInput *pOperationInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// setproperties from saveas input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @return - returns an int
    ///
    int  setPropertiesFromSaveAsInputBase(const Aps0AttributeGroup &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Aps0AttributeGroup &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Aps0AttributeGroupDelegate*  m_pInstance;

    Aps0AttributeGroupDelegate();
    virtual ~Aps0AttributeGroupDelegate();
    static void setInstance( Aps0AttributeGroupDelegate*  instance );


private:
    friend class  ::Teamcenter::Aps0AttributeGroupGenImpl;

};

#include <aps0apscore/libaps0apscore_undef.h>
#endif  //  TEAMCENTER__APS0ATTRIBUTEGROUPDELEGATE_HXX
