//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Aps0EffectivityExprBlock
    Filename:   Aps0EffectivityExprBlock.hxx
    Module:     aps0apscore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APS0EFFECTIVITYEXPRBLOCK__HXX
#define TEAMCENTER__APS0EFFECTIVITYEXPRBLOCK__HXX

#include <common/tc_deprecation_macros.h>
#include <fnd0booleansolve/Fnd0EffectivityExprBlock.hxx>

#include <aps0apscore/libaps0apscore_exports.h>

namespace Teamcenter
{
    class Aps0EffectivityExprBlock;
}
namespace Teamcenter
{
    class Aps0EffectivityExprBlockImpl;
}
namespace Teamcenter
{
    class Aps0EffectivityExprBlockDelegate;
}
namespace Teamcenter
{
    class Aps0EffectivityExprBlockDispatch;
}
namespace Teamcenter
{
    class Aps0EffectivityExprBlockGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APS0APSCORE_API  Teamcenter::Aps0EffectivityExprBlock
     : public  ::Teamcenter::Fnd0EffectivityExprBlock
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Aps0EffectivityExprBlock();

    /**
     * Destructor
     */
    virtual ~Aps0EffectivityExprBlock();

private:
    //  Getter method for the Implementation Object
    Aps0EffectivityExprBlockImpl*  getAps0EffectivityExprBlockImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAps0EffectivityExprBlockImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Aps0EffectivityExprBlockImpl*  m_aps0effectivityexprblockImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Aps0EffectivityExprBlock - desc for Aps0EffectivityExprBlock parameter
     */
    Aps0EffectivityExprBlock( const Aps0EffectivityExprBlock& );
    Aps0EffectivityExprBlock& operator=( const Aps0EffectivityExprBlock& );

    friend class  Aps0EffectivityExprBlockDelegate;
    friend class  Aps0EffectivityExprBlockDispatch;
    friend class  Aps0EffectivityExprBlockGenImpl;
};

#include <aps0apscore/libaps0apscore_undef.h>
#endif //   TEAMCENTER__APS0EFFECTIVITYEXPRBLOCK__HXX
