//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Aps0MagThread
    Filename:   Aps0MagThread.hxx
    Module:     aps0apscore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APS0MAGTHREAD__HXX
#define TEAMCENTER__APS0MAGTHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Fnd0WSOThread.hxx>

#include <aps0apscore/libaps0apscore_exports.h>

namespace Teamcenter
{
    class Aps0MagThread;
}
namespace Teamcenter
{
    class Aps0MagThreadImpl;
}
namespace Teamcenter
{
    class Aps0MagThreadDelegate;
}
namespace Teamcenter
{
    class Aps0MagThreadDispatch;
}
namespace Teamcenter
{
    class Aps0MagThreadGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APS0APSCORE_API  Teamcenter::Aps0MagThread
     : public  ::Teamcenter::Fnd0WSOThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Aps0MagThread();

    /**
     * Destructor
     */
    virtual ~Aps0MagThread();

private:
    //  Getter method for the Implementation Object
    Aps0MagThreadImpl*  getAps0MagThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAps0MagThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Aps0MagThreadImpl*  m_aps0magthreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Aps0MagThread - desc for Aps0MagThread parameter
     */
    Aps0MagThread( const Aps0MagThread& );
    Aps0MagThread& operator=( const Aps0MagThread& );

    friend class  Aps0MagThreadDelegate;
    friend class  Aps0MagThreadDispatch;
    friend class  Aps0MagThreadGenImpl;
};

#include <aps0apscore/libaps0apscore_undef.h>
#endif //   TEAMCENTER__APS0MAGTHREAD__HXX
