//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Aps0ManagedAttributeGroup
    Filename:   Aps0ManagedAttributeGroup.hxx
    Module:     aps0apscore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APS0MANAGEDATTRIBUTEGROUP__HXX
#define TEAMCENTER__APS0MANAGEDATTRIBUTEGROUP__HXX

#include <metaframework/ReviseInput.hxx>
#include <metaframework/DeepCopyData.hxx>
#include <unidefs.h>
#include <string>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <aps0apscore/Aps0AttributeGroup.hxx>

#include <aps0apscore/libaps0apscore_exports.h>

namespace Teamcenter
{
    class Aps0ManagedAttributeGroup;
}
namespace Teamcenter
{
    class Aps0ManagedAttributeGroupImpl;
}
namespace Teamcenter
{
    class Aps0ManagedAttributeGroupDelegate;
}
namespace Teamcenter
{
    class Aps0ManagedAttributeGroupDispatch;
}
namespace Teamcenter
{
    class Aps0ManagedAttributeGroupGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APS0APSCORE_API  Teamcenter::Aps0ManagedAttributeGroup
     : public  ::Teamcenter::Aps0AttributeGroup
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAps0allowed_eff_formula( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAps0allowed_var_formula( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAps0effectivity_formula( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAps0is_revisable( bool &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAps0IsConfigured( bool &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.2.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getAps0sibling_revisions( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAps0variant_formula( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.2.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAps0effectivity_formula( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.2.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAps0variant_formula( const std::string &value, bool isNull=false );

    ///
    /// 
    /// @version Teamcenter 11.2.3
    /// @param pReviseInput - pReviseInput
    /// @param vecDeepCopyData - vecDeepCopyData
    /// @return - 
    ///
    int  finalizeReviseInput( ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );

    ///
    /// 
    /// @version Teamcenter 11.2.3
    /// @param pReviseInput - pReviseInput
    /// @param vecDeepCopyData - vecDeepCopyData
    /// @param newObjTag - newObjTag
    /// @return - 
    ///
    int  revise( ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData, tag_t *newObjTag );

    ///
    /// 
    /// @version Teamcenter 11.2.3
    /// @param pReviseInput - pReviseInput
    /// @param vecDeepCopyData - vecDeepCopyData
    /// @return - 
    ///
    int  revisePost( ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );

    ///
    /// 
    /// @version Teamcenter 11.2.3
    /// @param pReviseInput - pReviseInput
    /// @return - 
    ///
    int  setPropertiesFromReviseInput( ::Teamcenter::ReviseInput *pReviseInput );

    ///
    /// 
    /// @version Teamcenter 11.2.3
    /// @param pReviseInput - pReviseInput
    /// @param vecDeepCopyData - vecDeepCopyData
    /// @return - 
    ///
    int  validateReviseInput( ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Aps0ManagedAttributeGroup();

    /**
     * Destructor
     */
    virtual ~Aps0ManagedAttributeGroup();

private:
    //  Getter method for the Implementation Object
    Aps0ManagedAttributeGroupImpl*  getAps0ManagedAttributeGroupImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAps0ManagedAttributeGroupImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Aps0ManagedAttributeGroupImpl*  m_aps0managedattributegroupImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Aps0ManagedAttributeGroup - desc for Aps0ManagedAttributeGroup parameter
     */
    Aps0ManagedAttributeGroup( const Aps0ManagedAttributeGroup& );
    Aps0ManagedAttributeGroup& operator=( const Aps0ManagedAttributeGroup& );

    friend class  Aps0ManagedAttributeGroupDelegate;
    friend class  Aps0ManagedAttributeGroupDispatch;
    friend class  Aps0ManagedAttributeGroupGenImpl;
};

#include <aps0apscore/libaps0apscore_undef.h>
#endif //   TEAMCENTER__APS0MANAGEDATTRIBUTEGROUP__HXX
