//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Aps0ManagedAttributeGroupDelegate
    Filename:   Aps0ManagedAttributeGroupDelegate.hxx
    Module:     aps0apscore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APS0MANAGEDATTRIBUTEGROUPDELEGATE_HXX
#define TEAMCENTER__APS0MANAGEDATTRIBUTEGROUPDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <aps0apscore/Aps0ManagedAttributeGroup.hxx>

#include <aps0apscore/libaps0apscore_exports.h>

namespace Teamcenter
{
    class Aps0ManagedAttributeGroupDelegate;
}
namespace Teamcenter
{
    class Aps0ManagedAttributeGroupImpl;
}
namespace Teamcenter
{
    class Aps0ManagedAttributeGroup;
}
namespace Teamcenter
{
    class Aps0ManagedAttributeGroupGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  APS0APSCORE_API Teamcenter_alias::Aps0ManagedAttributeGroupDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Aps0ManagedAttributeGroupDelegate instance
    static Aps0ManagedAttributeGroupDelegate&  getInstance();

    //  Method to create the Aps0ManagedAttributeGroupImpl pointer
    static Aps0ManagedAttributeGroupImpl*  createImpl( Aps0ManagedAttributeGroup&  ifObj );

    //  Method to delete the Aps0ManagedAttributeGroupImpl pointer
    static void deleteImpl( Aps0ManagedAttributeGroupImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAps0allowed_eff_formulaBase(const Aps0ManagedAttributeGroup &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAps0allowed_var_formulaBase(const Aps0ManagedAttributeGroup &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAps0effectivity_formulaBase(const Aps0ManagedAttributeGroup &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAps0is_revisableBase(const Aps0ManagedAttributeGroup &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAps0IsConfiguredBase(const Aps0ManagedAttributeGroup &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.2.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getAps0sibling_revisionsBase(const Aps0ManagedAttributeGroup &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAps0variant_formulaBase(const Aps0ManagedAttributeGroup &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.2.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAps0effectivity_formulaBase(Aps0ManagedAttributeGroup &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.2.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAps0variant_formulaBase(Aps0ManagedAttributeGroup &ifObj,  const std::string &value, bool isNull );


    ///
    /// 
    /// @version Teamcenter 11.2.3
    /// @param pReviseInput - pReviseInput
    /// @param vecDeepCopyData - vecDeepCopyData
    /// @return - 
    ///
    int  finalizeReviseInputBase(const Aps0ManagedAttributeGroup &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// 
    /// @version Teamcenter 11.2.3
    /// @param pReviseInput - pReviseInput
    /// @param vecDeepCopyData - vecDeepCopyData
    /// @param newObjTag - newObjTag
    /// @return - 
    ///
    int  reviseBase(const Aps0ManagedAttributeGroup &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData, tag_t *newObjTag );


    ///
    /// 
    /// @version Teamcenter 11.2.3
    /// @param pReviseInput - pReviseInput
    /// @param vecDeepCopyData - vecDeepCopyData
    /// @return - 
    ///
    int  revisePostBase(const Aps0ManagedAttributeGroup &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// 
    /// @version Teamcenter 11.2.3
    /// @param pReviseInput - pReviseInput
    /// @return - 
    ///
    int  setPropertiesFromReviseInputBase(const Aps0ManagedAttributeGroup &ifObj,  ::Teamcenter::ReviseInput *pReviseInput );


    ///
    /// 
    /// @version Teamcenter 11.2.3
    /// @param pReviseInput - pReviseInput
    /// @param vecDeepCopyData - vecDeepCopyData
    /// @return - 
    ///
    int  validateReviseInputBase(const Aps0ManagedAttributeGroup &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Aps0ManagedAttributeGroup &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Aps0ManagedAttributeGroup &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// finalize operation input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  finalizeSaveAsInputBase(const Aps0ManagedAttributeGroup &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// perform deep copy
    /// @version Teamcenter 9
    /// @param pOperationInput - desc
    /// @param vecDeepCopyData - deep copy data
    /// @return - returns an int
    ///
    int  performDeepCopyBase(const Aps0ManagedAttributeGroup &ifObj,  ::Teamcenter::OperationInput *pOperationInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// setproperties from saveas input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @return - returns an int
    ///
    int  setPropertiesFromSaveAsInputBase(const Aps0ManagedAttributeGroup &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Aps0ManagedAttributeGroup &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// validate saveas input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  validateSaveAsInputBase(const Aps0ManagedAttributeGroup &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static Aps0ManagedAttributeGroupDelegate*  m_pInstance;

    Aps0ManagedAttributeGroupDelegate();
    virtual ~Aps0ManagedAttributeGroupDelegate();
    static void setInstance( Aps0ManagedAttributeGroupDelegate*  instance );


private:
    friend class  ::Teamcenter::Aps0ManagedAttributeGroupGenImpl;

};

#include <aps0apscore/libaps0apscore_undef.h>
#endif  //  TEAMCENTER__APS0MANAGEDATTRIBUTEGROUPDELEGATE_HXX
