//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Aps0PlantLocation
    Filename:   Aps0PlantLocation.hxx
    Module:     aps0apscore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef APS0APSCORE__APS0PLANTLOCATION__HXX
#define APS0APSCORE__APS0PLANTLOCATION__HXX

#include <common/tc_deprecation_macros.h>
#include <tc/CompanyLocation.hxx>

#include <aps0apscore/libaps0apscore_exports.h>

namespace aps0apscore
{
    class Aps0PlantLocation;
}
namespace aps0apscore
{
    class Aps0PlantLocationImpl;
}
namespace aps0apscore
{
    class Aps0PlantLocationDelegate;
}
namespace aps0apscore
{
    class Aps0PlantLocationDispatch;
}
namespace aps0apscore
{
    class Aps0PlantLocationGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APS0APSCORE_API  aps0apscore::Aps0PlantLocation
     : public  ::Teamcenter::CompanyLocation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Aps0PlantLocation();

    /**
     * Destructor
     */
    virtual ~Aps0PlantLocation();

private:
    //  Getter method for the Implementation Object
    Aps0PlantLocationImpl*  getAps0PlantLocationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAps0PlantLocationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Aps0PlantLocationImpl*  m_aps0plantlocationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Aps0PlantLocation - desc for Aps0PlantLocation parameter
     */
    Aps0PlantLocation( const Aps0PlantLocation& );
    Aps0PlantLocation& operator=( const Aps0PlantLocation& );

    friend class  Aps0PlantLocationDelegate;
    friend class  Aps0PlantLocationDispatch;
    friend class  Aps0PlantLocationGenImpl;
};

#include <aps0apscore/libaps0apscore_undef.h>
#endif //   APS0APSCORE__APS0PLANTLOCATION__HXX
