//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Aps0VariantExprBlock
    Filename:   Aps0VariantExprBlock.hxx
    Module:     aps0apscore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APS0VARIANTEXPRBLOCK__HXX
#define TEAMCENTER__APS0VARIANTEXPRBLOCK__HXX

#include <common/tc_deprecation_macros.h>
#include <fnd0booleansolve/Fnd0VariantExprBlock.hxx>

#include <aps0apscore/libaps0apscore_exports.h>

namespace Teamcenter
{
    class Aps0VariantExprBlock;
}
namespace Teamcenter
{
    class Aps0VariantExprBlockImpl;
}
namespace Teamcenter
{
    class Aps0VariantExprBlockDelegate;
}
namespace Teamcenter
{
    class Aps0VariantExprBlockDispatch;
}
namespace Teamcenter
{
    class Aps0VariantExprBlockGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APS0APSCORE_API  Teamcenter::Aps0VariantExprBlock
     : public  ::Teamcenter::Fnd0VariantExprBlock
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Aps0VariantExprBlock();

    /**
     * Destructor
     */
    virtual ~Aps0VariantExprBlock();

private:
    //  Getter method for the Implementation Object
    Aps0VariantExprBlockImpl*  getAps0VariantExprBlockImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAps0VariantExprBlockImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Aps0VariantExprBlockImpl*  m_aps0variantexprblockImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Aps0VariantExprBlock - desc for Aps0VariantExprBlock parameter
     */
    Aps0VariantExprBlock( const Aps0VariantExprBlock& );
    Aps0VariantExprBlock& operator=( const Aps0VariantExprBlock& );

    friend class  Aps0VariantExprBlockDelegate;
    friend class  Aps0VariantExprBlockDispatch;
    friend class  Aps0VariantExprBlockGenImpl;
};

#include <aps0apscore/libaps0apscore_undef.h>
#endif //   TEAMCENTER__APS0VARIANTEXPRBLOCK__HXX
