//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0CopyStableRelation
    Filename:   Mdl0CopyStableRelation.hxx
    Module:     aps0apscore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0COPYSTABLERELATION__HXX
#define TEAMCENTER__APPMODEL__MDL0COPYSTABLERELATION__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <aps0apscore/libaps0apscore_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0CopyStableRelation;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0CopyStableRelationImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0CopyStableRelationDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0CopyStableRelationDispatch;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0CopyStableRelationGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  APS0APSCORE_API  Teamcenter::AppModel::Mdl0CopyStableRelation
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Date Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0secondary_revision_lmd( date_t &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0sync_secondary_revision( bool &value, bool &isNull ) const;

    ///
    /// Setter for a Date Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0secondary_revision_lmd( const date_t &value, bool isNull=false );

    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0sync_secondary_revision( bool value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdl0CopyStableRelation();

    /**
     * Destructor
     */
    virtual ~Mdl0CopyStableRelation();

private:
    //  Getter method for the Implementation Object
    Mdl0CopyStableRelationImpl*  getMdl0CopyStableRelationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdl0CopyStableRelationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdl0CopyStableRelationImpl*  m_mdl0copystablerelationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdl0CopyStableRelation - desc for Mdl0CopyStableRelation parameter
     */
    Mdl0CopyStableRelation( const Mdl0CopyStableRelation& );
    Mdl0CopyStableRelation& operator=( const Mdl0CopyStableRelation& );

    friend class  Mdl0CopyStableRelationDelegate;
    friend class  Mdl0CopyStableRelationDispatch;
    friend class  Mdl0CopyStableRelationGenImpl;
};

#include <aps0apscore/libaps0apscore_undef.h>
#endif //   TEAMCENTER__APPMODEL__MDL0COPYSTABLERELATION__HXX
