//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0CopyStableRelationDelegate
    Filename:   Mdl0CopyStableRelationDelegate.hxx
    Module:     aps0apscore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0COPYSTABLERELATIONDELEGATE_HXX
#define TEAMCENTER__APPMODEL__MDL0COPYSTABLERELATIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <aps0apscore/Mdl0CopyStableRelation.hxx>

#include <aps0apscore/libaps0apscore_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0CopyStableRelationDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0CopyStableRelationImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0CopyStableRelation;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0CopyStableRelationGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  APS0APSCORE_API Teamcenter_alias::AppModel::Mdl0CopyStableRelationDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mdl0CopyStableRelationDelegate instance
    static Mdl0CopyStableRelationDelegate&  getInstance();

    //  Method to create the Mdl0CopyStableRelationImpl pointer
    static Mdl0CopyStableRelationImpl*  createImpl( Mdl0CopyStableRelation&  ifObj );

    //  Method to delete the Mdl0CopyStableRelationImpl pointer
    static void deleteImpl( Mdl0CopyStableRelationImpl*  impl );


    ///
    /// Getter for a Date Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0secondary_revision_lmdBase(const Mdl0CopyStableRelation &ifObj,  date_t &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0sync_secondary_revisionBase(const Mdl0CopyStableRelation &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Setter for a Date Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0secondary_revision_lmdBase(Mdl0CopyStableRelation &ifObj,  const date_t &value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0sync_secondary_revisionBase(Mdl0CopyStableRelation &ifObj,  bool value, bool isNull );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Mdl0CopyStableRelation &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Mdl0CopyStableRelation &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// This operation returns the Copy Stable Last Modified Date for the secondary object.
    /// @version Teamcenter 11.2
    /// @param copyStableLmd - The Copy Stable Lmd of the secondary data on the relation.
    /// @param isNull - True if the value of lmd or lsd is  not set on the secondary object
    /// @return - 
    ///
    int  fnd0AskCopyStableLmdBase(const Mdl0CopyStableRelation &ifObj,  date_t *copyStableLmd, bool *isNull ) const;


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0CreatePostBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be created
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0FinalizeCreateInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be created
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0ValidateCreateInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Mdl0CopyStableRelation &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Mdl0CopyStableRelationDelegate*  m_pInstance;

    Mdl0CopyStableRelationDelegate();
    virtual ~Mdl0CopyStableRelationDelegate();
    static void setInstance( Mdl0CopyStableRelationDelegate*  instance );


private:
    friend class  ::Teamcenter::AppModel::Mdl0CopyStableRelationGenImpl;

};

#include <aps0apscore/libaps0apscore_undef.h>
#endif  //  TEAMCENTER__APPMODEL__MDL0COPYSTABLERELATIONDELEGATE_HXX
