//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  aps0apscoredispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libaps0apscoredispatch

#if !defined(LIBAPS0APSCOREDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBAPS0APSCOREDISPATCH is not defined
#endif

/* Handwritten code should use APS0APSCOREDISPATCH_API, not APS0APSCOREDISPATCHEXPORT */

#define APS0APSCOREDISPATCH_API APS0APSCOREDISPATCHEXPORT

#if IPLIB==libaps0apscoredispatch || defined(LIBAPS0APSCOREDISPATCH)
#   if defined(__lint)
#       define APS0APSCOREDISPATCHEXPORT       __export(aps0apscoredispatch)
#       define APS0APSCOREDISPATCHGLOBAL       extern __global(aps0apscoredispatch)
#       define APS0APSCOREDISPATCHPRIVATE      extern __private(aps0apscoredispatch)
#   elif defined(_WIN32)
#       define APS0APSCOREDISPATCHEXPORT       __declspec(dllexport)
#       define APS0APSCOREDISPATCHGLOBAL       extern __declspec(dllexport)
#       define APS0APSCOREDISPATCHPRIVATE      extern
#   else
#       define APS0APSCOREDISPATCHEXPORT
#       define APS0APSCOREDISPATCHGLOBAL       extern
#       define APS0APSCOREDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define APS0APSCOREDISPATCHEXPORT       __export(aps0apscoredispatch)
#       define APS0APSCOREDISPATCHGLOBAL       extern __global(aps0apscoredispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define APS0APSCOREDISPATCHEXPORT      __declspec(dllimport)
#       define APS0APSCOREDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define APS0APSCOREDISPATCHEXPORT
#       define APS0APSCOREDISPATCHGLOBAL       extern
#   endif
#endif
