//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, FileTOC
    Filename:   FileTOC.hxx
    Module:     archive
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FILETOC__HXX
#define TEAMCENTER__FILETOC__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <archive/libarchive_exports.h>

namespace Teamcenter
{
    class FileTOC;
}
namespace Teamcenter
{
    class FileTOCImpl;
}
namespace Teamcenter
{
    class FileTOCDelegate;
}
namespace Teamcenter
{
    class FileTOCDispatch;
}
namespace Teamcenter
{
    class FileTOCGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ARCHIVE_API  Teamcenter::FileTOC
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    FileTOC();

    /**
     * Destructor
     */
    virtual ~FileTOC();

private:
    //  Getter method for the Implementation Object
    FileTOCImpl*  getFileTOCImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFileTOCImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    FileTOCImpl*  m_filetocImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param FileTOC - desc for FileTOC parameter
     */
    FileTOC( const FileTOC& );
    FileTOC& operator=( const FileTOC& );

    friend class  FileTOCDelegate;
    friend class  FileTOCDispatch;
    friend class  FileTOCGenImpl;
};

#include <archive/libarchive_undef.h>
#endif //   TEAMCENTER__FILETOC__HXX
