//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, FileTOCDelegate
    Filename:   FileTOCDelegate.hxx
    Module:     archive
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FILETOCDELEGATE_HXX
#define TEAMCENTER__FILETOCDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <archive/FileTOC.hxx>

#include <archive/libarchive_exports.h>

namespace Teamcenter
{
    class FileTOCDelegate;
}
namespace Teamcenter
{
    class FileTOCImpl;
}
namespace Teamcenter
{
    class FileTOC;
}
namespace Teamcenter
{
    class FileTOCGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  ARCHIVE_API Teamcenter_alias::FileTOCDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the FileTOCDelegate instance
    static FileTOCDelegate&  getInstance();

    //  Method to create the FileTOCImpl pointer
    static FileTOCImpl*  createImpl( FileTOC&  ifObj );

    //  Method to delete the FileTOCImpl pointer
    static void deleteImpl( FileTOCImpl*  impl );



protected:
    //  Pointer to the instance
    static FileTOCDelegate*  m_pInstance;

    FileTOCDelegate();
    virtual ~FileTOCDelegate();
    static void setInstance( FileTOCDelegate*  instance );


private:
    friend class  ::Teamcenter::FileTOCGenImpl;

};

#include <archive/libarchive_undef.h>
#endif  //  TEAMCENTER__FILETOCDELEGATE_HXX
