//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MediaTOC
    Filename:   MediaTOC.hxx
    Module:     archive
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MEDIATOC__HXX
#define TEAMCENTER__MEDIATOC__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <archive/libarchive_exports.h>

namespace Teamcenter
{
    class MediaTOC;
}
namespace Teamcenter
{
    class MediaTOCImpl;
}
namespace Teamcenter
{
    class MediaTOCDelegate;
}
namespace Teamcenter
{
    class MediaTOCDispatch;
}
namespace Teamcenter
{
    class MediaTOCGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ARCHIVE_API  Teamcenter::MediaTOC
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    MediaTOC();

    /**
     * Destructor
     */
    virtual ~MediaTOC();

private:
    //  Getter method for the Implementation Object
    MediaTOCImpl*  getMediaTOCImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMediaTOCImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    MediaTOCImpl*  m_mediatocImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param MediaTOC - desc for MediaTOC parameter
     */
    MediaTOC( const MediaTOC& );
    MediaTOC& operator=( const MediaTOC& );

    friend class  MediaTOCDelegate;
    friend class  MediaTOCDispatch;
    friend class  MediaTOCGenImpl;
};

#include <archive/libarchive_undef.h>
#endif //   TEAMCENTER__MEDIATOC__HXX
