//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MediaTOCDelegate
    Filename:   MediaTOCDelegate.hxx
    Module:     archive
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MEDIATOCDELEGATE_HXX
#define TEAMCENTER__MEDIATOCDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <archive/MediaTOC.hxx>

#include <archive/libarchive_exports.h>

namespace Teamcenter
{
    class MediaTOCDelegate;
}
namespace Teamcenter
{
    class MediaTOCImpl;
}
namespace Teamcenter
{
    class MediaTOC;
}
namespace Teamcenter
{
    class MediaTOCGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  ARCHIVE_API Teamcenter_alias::MediaTOCDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the MediaTOCDelegate instance
    static MediaTOCDelegate&  getInstance();

    //  Method to create the MediaTOCImpl pointer
    static MediaTOCImpl*  createImpl( MediaTOC&  ifObj );

    //  Method to delete the MediaTOCImpl pointer
    static void deleteImpl( MediaTOCImpl*  impl );



protected:
    //  Pointer to the instance
    static MediaTOCDelegate*  m_pInstance;

    MediaTOCDelegate();
    virtual ~MediaTOCDelegate();
    static void setInstance( MediaTOCDelegate*  instance );


private:
    friend class  ::Teamcenter::MediaTOCGenImpl;

};

#include <archive/libarchive_undef.h>
#endif  //  TEAMCENTER__MEDIATOCDELEGATE_HXX
