//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TransferPending
    Filename:   TransferPending.hxx
    Module:     archive
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TRANSFERPENDING__HXX
#define TEAMCENTER__TRANSFERPENDING__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <archive/libarchive_exports.h>

namespace Teamcenter
{
    class TransferPending;
}
namespace Teamcenter
{
    class TransferPendingImpl;
}
namespace Teamcenter
{
    class TransferPendingDelegate;
}
namespace Teamcenter
{
    class TransferPendingDispatch;
}
namespace Teamcenter
{
    class TransferPendingGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ARCHIVE_API  Teamcenter::TransferPending
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    TransferPending();

    /**
     * Destructor
     */
    virtual ~TransferPending();

private:
    //  Getter method for the Implementation Object
    TransferPendingImpl*  getTransferPendingImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTransferPendingImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    TransferPendingImpl*  m_transferpendingImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param TransferPending - desc for TransferPending parameter
     */
    TransferPending( const TransferPending& );
    TransferPending& operator=( const TransferPending& );

    friend class  TransferPendingDelegate;
    friend class  TransferPendingDispatch;
    friend class  TransferPendingGenImpl;
};

#include <archive/libarchive_undef.h>
#endif //   TEAMCENTER__TRANSFERPENDING__HXX
