//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TransferPendingDelegate
    Filename:   TransferPendingDelegate.hxx
    Module:     archive
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TRANSFERPENDINGDELEGATE_HXX
#define TEAMCENTER__TRANSFERPENDINGDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <archive/TransferPending.hxx>

#include <archive/libarchive_exports.h>

namespace Teamcenter
{
    class TransferPendingDelegate;
}
namespace Teamcenter
{
    class TransferPendingImpl;
}
namespace Teamcenter
{
    class TransferPending;
}
namespace Teamcenter
{
    class TransferPendingGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  ARCHIVE_API Teamcenter_alias::TransferPendingDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the TransferPendingDelegate instance
    static TransferPendingDelegate&  getInstance();

    //  Method to create the TransferPendingImpl pointer
    static TransferPendingImpl*  createImpl( TransferPending&  ifObj );

    //  Method to delete the TransferPendingImpl pointer
    static void deleteImpl( TransferPendingImpl*  impl );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const TransferPending &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static TransferPendingDelegate*  m_pInstance;

    TransferPendingDelegate();
    virtual ~TransferPendingDelegate();
    static void setInstance( TransferPendingDelegate*  instance );


private:
    friend class  ::Teamcenter::TransferPendingGenImpl;

};

#include <archive/libarchive_undef.h>
#endif  //  TEAMCENTER__TRANSFERPENDINGDELEGATE_HXX
