//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  archive

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libarchive

#if !defined(LIBARCHIVE) && !defined(IPLIB)
#   error IPLIB or LIBARCHIVE is not defined
#endif

/* Handwritten code should use ARCHIVE_API, not ARCHIVEEXPORT */

#define ARCHIVE_API ARCHIVEEXPORT

#if IPLIB==libarchive || defined(LIBARCHIVE)
#   if defined(__lint)
#       define ARCHIVEEXPORT       __export(archive)
#       define ARCHIVEGLOBAL       extern __global(archive)
#       define ARCHIVEPRIVATE      extern __private(archive)
#   elif defined(_WIN32)
#       define ARCHIVEEXPORT       __declspec(dllexport)
#       define ARCHIVEGLOBAL       extern __declspec(dllexport)
#       define ARCHIVEPRIVATE      extern
#   else
#       define ARCHIVEEXPORT
#       define ARCHIVEGLOBAL       extern
#       define ARCHIVEPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define ARCHIVEEXPORT       __export(archive)
#       define ARCHIVEGLOBAL       extern __global(archive)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define ARCHIVEEXPORT      __declspec(dllimport)
#       define ARCHIVEGLOBAL       extern __declspec(dllimport)
#   else
#       define ARCHIVEEXPORT
#       define ARCHIVEGLOBAL       extern
#   endif
#endif
