//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AsBuiltBOMLine
    Filename:   AsBuiltBOMLine.hxx
    Module:     asbuilt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ASBUILT__ASBUILTBOMLINE__HXX
#define TEAMCENTER__ASBUILT__ASBUILTBOMLINE__HXX

#include <common/tc_deprecation_macros.h>
#include <mrocore/PhysicalBOMLine.hxx>

#include <asbuilt/libasbuilt_exports.h>

namespace Teamcenter
{
    namespace asbuilt
    {
        class AsBuiltBOMLine;
    }
}
namespace Teamcenter
{
    namespace asbuilt
    {
        class AsBuiltBOMLineImpl;
    }
}
namespace Teamcenter
{
    namespace asbuilt
    {
        class AsBuiltBOMLineDelegate;
    }
}
namespace Teamcenter
{
    namespace asbuilt
    {
        class AsBuiltBOMLineDispatch;
    }
}
namespace Teamcenter
{
    namespace asbuilt
    {
        class AsBuiltBOMLineGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ASBUILT_API  Teamcenter::asbuilt::AsBuiltBOMLine
     : public  ::Teamcenter::mrocore::PhysicalBOMLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AsBuiltBOMLine();

    /**
     * Destructor
     */
    virtual ~AsBuiltBOMLine();

private:
    //  Getter method for the Implementation Object
    AsBuiltBOMLineImpl*  getAsBuiltBOMLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAsBuiltBOMLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AsBuiltBOMLineImpl*  m_asbuiltbomlineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AsBuiltBOMLine - desc for AsBuiltBOMLine parameter
     */
    AsBuiltBOMLine( const AsBuiltBOMLine& );
    AsBuiltBOMLine& operator=( const AsBuiltBOMLine& );

    friend class  AsBuiltBOMLineDelegate;
    friend class  AsBuiltBOMLineDispatch;
    friend class  AsBuiltBOMLineGenImpl;
};

#include <asbuilt/libasbuilt_undef.h>
#endif //   TEAMCENTER__ASBUILT__ASBUILTBOMLINE__HXX
