//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AsBuiltBOMLineDelegate
    Filename:   AsBuiltBOMLineDelegate.hxx
    Module:     asbuilt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ASBUILT__ASBUILTBOMLINEDELEGATE_HXX
#define TEAMCENTER__ASBUILT__ASBUILTBOMLINEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <asbuilt/AsBuiltBOMLine.hxx>

#include <asbuilt/libasbuilt_exports.h>

namespace Teamcenter
{
    namespace asbuilt
    {
        class AsBuiltBOMLineDelegate;
    }
}
namespace Teamcenter
{
    namespace asbuilt
    {
        class AsBuiltBOMLineImpl;
    }
}
namespace Teamcenter
{
    namespace asbuilt
    {
        class AsBuiltBOMLine;
    }
}
namespace Teamcenter
{
    namespace asbuilt
    {
        class AsBuiltBOMLineGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  ASBUILT_API Teamcenter_alias::asbuilt::AsBuiltBOMLineDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the AsBuiltBOMLineDelegate instance
    static AsBuiltBOMLineDelegate&  getInstance();

    //  Method to create the AsBuiltBOMLineImpl pointer
    static AsBuiltBOMLineImpl*  createImpl( AsBuiltBOMLine&  ifObj );

    //  Method to delete the AsBuiltBOMLineImpl pointer
    static void deleteImpl( AsBuiltBOMLineImpl*  impl );


    ///
    /// This is the getter for retrieving the recipe/permanent ID if its been created (and cached on the instance). Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param uid - Recipe/permanent ID
    /// @param isFirstTime - If Session Recovery Uid is yet to be set or does the object need to be serialized again?
    /// @return - Failure code
    ///
    int  fnd0AskSRUidBase(const AsBuiltBOMLine &ifObj,  std::string *uid, bool *isFirstTime ) const;


    ///
    /// Generates permanent ID/recipe. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param recipe - Permanent ID/recipe
    /// @return - Failure code.
    ///
    int  fnd0GenerateRecipeBase(const AsBuiltBOMLine &ifObj,  std::string *recipe );


    ///
    /// If Business Object supports recoverable ID. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param isPersistedRecipe - isPersistedRecipe param should be set to true if the recipe is limited to the user session and should be serialized to the database
    /// @param isRecoverableIDSupported - Returning true indicates support for recoverability/permanent IDs
    /// @return - Failure code.
    ///
    int  fnd0IsRecoverableBase(const AsBuiltBOMLine &ifObj,  bool *isPersistedRecipe, bool *isRecoverableIDSupported ) const;


    ///
    /// This is the setter for the recipe/permanent ID when it is created (to be cached on the instance). Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param uid - Rrecipe/permanent ID
    /// @return - Failure code.
    ///
    int  fnd0SetSRUidBase(const AsBuiltBOMLine &ifObj,  const std::string *uid );



protected:
    //  Pointer to the instance
    static AsBuiltBOMLineDelegate*  m_pInstance;

    AsBuiltBOMLineDelegate();
    virtual ~AsBuiltBOMLineDelegate();
    static void setInstance( AsBuiltBOMLineDelegate*  instance );


private:
    friend class  ::Teamcenter::asbuilt::AsBuiltBOMLineGenImpl;

};

#include <asbuilt/libasbuilt_undef.h>
#endif  //  TEAMCENTER__ASBUILT__ASBUILTBOMLINEDELEGATE_HXX
