//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AsBuiltStructure
    Filename:   AsBuiltStructure.hxx
    Module:     asbuilt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ASBUILT__ASBUILTSTRUCTURE__HXX
#define TEAMCENTER__ASBUILT__ASBUILTSTRUCTURE__HXX

#include <common/tc_deprecation_macros.h>
#include <mrocore/PhysicalStructure.hxx>

#include <asbuilt/libasbuilt_exports.h>

namespace Teamcenter
{
    namespace asbuilt
    {
        class AsBuiltStructure;
    }
}
namespace Teamcenter
{
    namespace asbuilt
    {
        class AsBuiltStructureImpl;
    }
}
namespace Teamcenter
{
    namespace asbuilt
    {
        class AsBuiltStructureDelegate;
    }
}
namespace Teamcenter
{
    namespace asbuilt
    {
        class AsBuiltStructureDispatch;
    }
}
namespace Teamcenter
{
    namespace asbuilt
    {
        class AsBuiltStructureGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ASBUILT_API  Teamcenter::asbuilt::AsBuiltStructure
     : public  ::Teamcenter::mrocore::PhysicalStructure
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AsBuiltStructure();

    /**
     * Destructor
     */
    virtual ~AsBuiltStructure();

private:
    //  Getter method for the Implementation Object
    AsBuiltStructureImpl*  getAsBuiltStructureImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAsBuiltStructureImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AsBuiltStructureImpl*  m_asbuiltstructureImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AsBuiltStructure - desc for AsBuiltStructure parameter
     */
    AsBuiltStructure( const AsBuiltStructure& );
    AsBuiltStructure& operator=( const AsBuiltStructure& );

    friend class  AsBuiltStructureDelegate;
    friend class  AsBuiltStructureDispatch;
    friend class  AsBuiltStructureGenImpl;
};

#include <asbuilt/libasbuilt_undef.h>
#endif //   TEAMCENTER__ASBUILT__ASBUILTSTRUCTURE__HXX
