//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  asbuilt

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libasbuilt

#if !defined(LIBASBUILT) && !defined(IPLIB)
#   error IPLIB or LIBASBUILT is not defined
#endif

/* Handwritten code should use ASBUILT_API, not ASBUILTEXPORT */

#define ASBUILT_API ASBUILTEXPORT

#if IPLIB==libasbuilt || defined(LIBASBUILT)
#   if defined(__lint)
#       define ASBUILTEXPORT       __export(asbuilt)
#       define ASBUILTGLOBAL       extern __global(asbuilt)
#       define ASBUILTPRIVATE      extern __private(asbuilt)
#   elif defined(_WIN32)
#       define ASBUILTEXPORT       __declspec(dllexport)
#       define ASBUILTGLOBAL       extern __declspec(dllexport)
#       define ASBUILTPRIVATE      extern
#   else
#       define ASBUILTEXPORT
#       define ASBUILTGLOBAL       extern
#       define ASBUILTPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define ASBUILTEXPORT       __export(asbuilt)
#       define ASBUILTGLOBAL       extern __global(asbuilt)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define ASBUILTEXPORT      __declspec(dllimport)
#       define ASBUILTGLOBAL       extern __declspec(dllimport)
#   else
#       define ASBUILTEXPORT
#       define ASBUILTGLOBAL       extern
#   endif
#endif
