//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  asbuiltdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libasbuiltdispatch

#if !defined(LIBASBUILTDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBASBUILTDISPATCH is not defined
#endif

/* Handwritten code should use ASBUILTDISPATCH_API, not ASBUILTDISPATCHEXPORT */

#define ASBUILTDISPATCH_API ASBUILTDISPATCHEXPORT

#if IPLIB==libasbuiltdispatch || defined(LIBASBUILTDISPATCH)
#   if defined(__lint)
#       define ASBUILTDISPATCHEXPORT       __export(asbuiltdispatch)
#       define ASBUILTDISPATCHGLOBAL       extern __global(asbuiltdispatch)
#       define ASBUILTDISPATCHPRIVATE      extern __private(asbuiltdispatch)
#   elif defined(_WIN32)
#       define ASBUILTDISPATCHEXPORT       __declspec(dllexport)
#       define ASBUILTDISPATCHGLOBAL       extern __declspec(dllexport)
#       define ASBUILTDISPATCHPRIVATE      extern
#   else
#       define ASBUILTDISPATCHEXPORT
#       define ASBUILTDISPATCHGLOBAL       extern
#       define ASBUILTDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define ASBUILTDISPATCHEXPORT       __export(asbuiltdispatch)
#       define ASBUILTDISPATCHGLOBAL       extern __global(asbuiltdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define ASBUILTDISPATCHEXPORT      __declspec(dllimport)
#       define ASBUILTDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define ASBUILTDISPATCHEXPORT
#       define ASBUILTDISPATCHGLOBAL       extern
#   endif
#endif
