//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AsMaintainedBOMLine
    Filename:   AsMaintainedBOMLine.hxx
    Module:     asmaintained
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ASMAINTAINED__ASMAINTAINEDBOMLINE__HXX
#define TEAMCENTER__ASMAINTAINED__ASMAINTAINEDBOMLINE__HXX

#include <common/tc_deprecation_macros.h>
#include <mrocore/PhysicalBOMLine.hxx>

#include <asmaintained/libasmaintained_exports.h>

namespace Teamcenter
{
    namespace asmaintained
    {
        class AsMaintainedBOMLine;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class AsMaintainedBOMLineImpl;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class AsMaintainedBOMLineDelegate;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class AsMaintainedBOMLineDispatch;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class AsMaintainedBOMLineGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ASMAINTAINED_API  Teamcenter::asmaintained::AsMaintainedBOMLine
     : public  ::Teamcenter::mrocore::PhysicalBOMLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AsMaintainedBOMLine();

    /**
     * Destructor
     */
    virtual ~AsMaintainedBOMLine();

private:
    //  Getter method for the Implementation Object
    AsMaintainedBOMLineImpl*  getAsMaintainedBOMLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAsMaintainedBOMLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AsMaintainedBOMLineImpl*  m_asmaintainedbomlineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AsMaintainedBOMLine - desc for AsMaintainedBOMLine parameter
     */
    AsMaintainedBOMLine( const AsMaintainedBOMLine& );
    AsMaintainedBOMLine& operator=( const AsMaintainedBOMLine& );

    friend class  AsMaintainedBOMLineDelegate;
    friend class  AsMaintainedBOMLineDispatch;
    friend class  AsMaintainedBOMLineGenImpl;
};

#include <asmaintained/libasmaintained_undef.h>
#endif //   TEAMCENTER__ASMAINTAINED__ASMAINTAINEDBOMLINE__HXX
