//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AsMaintainedRevisionRule
    Filename:   AsMaintainedRevisionRule.hxx
    Module:     asmaintained
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ASMAINTAINED__ASMAINTAINEDREVISIONRULE__HXX
#define TEAMCENTER__ASMAINTAINED__ASMAINTAINEDREVISIONRULE__HXX

#include <common/tc_deprecation_macros.h>
#include <mrocore/MroRevisionRule.hxx>

#include <asmaintained/libasmaintained_exports.h>

namespace Teamcenter
{
    namespace asmaintained
    {
        class AsMaintainedRevisionRule;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class AsMaintainedRevisionRuleImpl;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class AsMaintainedRevisionRuleDelegate;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class AsMaintainedRevisionRuleDispatch;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class AsMaintainedRevisionRuleGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ASMAINTAINED_API  Teamcenter::asmaintained::AsMaintainedRevisionRule
     : public  ::Teamcenter::mrocore::MroRevisionRule
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AsMaintainedRevisionRule();

    /**
     * Destructor
     */
    virtual ~AsMaintainedRevisionRule();

private:
    //  Getter method for the Implementation Object
    AsMaintainedRevisionRuleImpl*  getAsMaintainedRevisionRuleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAsMaintainedRevisionRuleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AsMaintainedRevisionRuleImpl*  m_asmaintainedrevisionruleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AsMaintainedRevisionRule - desc for AsMaintainedRevisionRule parameter
     */
    AsMaintainedRevisionRule( const AsMaintainedRevisionRule& );
    AsMaintainedRevisionRule& operator=( const AsMaintainedRevisionRule& );

    friend class  AsMaintainedRevisionRuleDelegate;
    friend class  AsMaintainedRevisionRuleDispatch;
    friend class  AsMaintainedRevisionRuleGenImpl;
};

#include <asmaintained/libasmaintained_undef.h>
#endif //   TEAMCENTER__ASMAINTAINED__ASMAINTAINEDREVISIONRULE__HXX
