//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AsMaintainedStructure
    Filename:   AsMaintainedStructure.hxx
    Module:     asmaintained
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ASMAINTAINED__ASMAINTAINEDSTRUCTURE__HXX
#define TEAMCENTER__ASMAINTAINED__ASMAINTAINEDSTRUCTURE__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <mrocore/PhysicalStructure.hxx>

#include <asmaintained/libasmaintained_exports.h>

namespace Teamcenter
{
    namespace asmaintained
    {
        class AsMaintainedStructure;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class AsMaintainedStructureImpl;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class AsMaintainedStructureDelegate;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class AsMaintainedStructureDispatch;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class AsMaintainedStructureGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ASMAINTAINED_API  Teamcenter::asmaintained::AsMaintainedStructure
     : public  ::Teamcenter::mrocore::PhysicalStructure
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIsInstalled( bool &value, bool &isNull ) const;

    ///
    /// Getter for a Date Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getUnInstallationTime( date_t &value, bool &isNull ) const;

    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 8.0.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIsInstalled( bool value, bool isNull=false );

    ///
    /// Setter for a Date Property
    /// @version Teamcenter 8.0.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setUnInstallationTime( const date_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AsMaintainedStructure();

    /**
     * Destructor
     */
    virtual ~AsMaintainedStructure();

private:
    //  Getter method for the Implementation Object
    AsMaintainedStructureImpl*  getAsMaintainedStructureImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAsMaintainedStructureImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AsMaintainedStructureImpl*  m_asmaintainedstructureImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AsMaintainedStructure - desc for AsMaintainedStructure parameter
     */
    AsMaintainedStructure( const AsMaintainedStructure& );
    AsMaintainedStructure& operator=( const AsMaintainedStructure& );

    friend class  AsMaintainedStructureDelegate;
    friend class  AsMaintainedStructureDispatch;
    friend class  AsMaintainedStructureGenImpl;
};

#include <asmaintained/libasmaintained_undef.h>
#endif //   TEAMCENTER__ASMAINTAINED__ASMAINTAINEDSTRUCTURE__HXX
