//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AsMaintainedStructureData
    Filename:   AsMaintainedStructureData.hxx
    Module:     asmaintained
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ASMAINTAINED__ASMAINTAINEDSTRUCTUREDATA__HXX
#define TEAMCENTER__ASMAINTAINED__ASMAINTAINEDSTRUCTUREDATA__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <asmaintained/libasmaintained_exports.h>

namespace Teamcenter
{
    namespace asmaintained
    {
        class AsMaintainedStructureData;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class AsMaintainedStructureDataImpl;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class AsMaintainedStructureDataDelegate;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class AsMaintainedStructureDataDispatch;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class AsMaintainedStructureDataGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ASMAINTAINED_API  Teamcenter::asmaintained::AsMaintainedStructureData
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AsMaintainedStructureData();

    /**
     * Destructor
     */
    virtual ~AsMaintainedStructureData();

private:
    //  Getter method for the Implementation Object
    AsMaintainedStructureDataImpl*  getAsMaintainedStructureDataImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAsMaintainedStructureDataImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AsMaintainedStructureDataImpl*  m_asmaintainedstructuredataImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AsMaintainedStructureData - desc for AsMaintainedStructureData parameter
     */
    AsMaintainedStructureData( const AsMaintainedStructureData& );
    AsMaintainedStructureData& operator=( const AsMaintainedStructureData& );

    friend class  AsMaintainedStructureDataDelegate;
    friend class  AsMaintainedStructureDataDispatch;
    friend class  AsMaintainedStructureDataGenImpl;
};

#include <asmaintained/libasmaintained_undef.h>
#endif //   TEAMCENTER__ASMAINTAINED__ASMAINTAINEDSTRUCTUREDATA__HXX
