//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AsMaintainedStructureDelegate
    Filename:   AsMaintainedStructureDelegate.hxx
    Module:     asmaintained
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ASMAINTAINED__ASMAINTAINEDSTRUCTUREDELEGATE_HXX
#define TEAMCENTER__ASMAINTAINED__ASMAINTAINEDSTRUCTUREDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <asmaintained/AsMaintainedStructure.hxx>

#include <asmaintained/libasmaintained_exports.h>

namespace Teamcenter
{
    namespace asmaintained
    {
        class AsMaintainedStructureDelegate;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class AsMaintainedStructureImpl;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class AsMaintainedStructure;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class AsMaintainedStructureGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  ASMAINTAINED_API Teamcenter_alias::asmaintained::AsMaintainedStructureDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the AsMaintainedStructureDelegate instance
    static AsMaintainedStructureDelegate&  getInstance();

    //  Method to create the AsMaintainedStructureImpl pointer
    static AsMaintainedStructureImpl*  createImpl( AsMaintainedStructure&  ifObj );

    //  Method to delete the AsMaintainedStructureImpl pointer
    static void deleteImpl( AsMaintainedStructureImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIsInstalledBase(const AsMaintainedStructure &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Date Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getUnInstallationTimeBase(const AsMaintainedStructure &ifObj,  date_t &value, bool &isNull ) const;


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 8.0.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIsInstalledBase(AsMaintainedStructure &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Date Property
    /// @version Teamcenter 8.0.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setUnInstallationTimeBase(AsMaintainedStructure &ifObj,  const date_t &value, bool isNull );



protected:
    //  Pointer to the instance
    static AsMaintainedStructureDelegate*  m_pInstance;

    AsMaintainedStructureDelegate();
    virtual ~AsMaintainedStructureDelegate();
    static void setInstance( AsMaintainedStructureDelegate*  instance );


private:
    friend class  ::Teamcenter::asmaintained::AsMaintainedStructureGenImpl;

};

#include <asmaintained/libasmaintained_undef.h>
#endif  //  TEAMCENTER__ASMAINTAINED__ASMAINTAINEDSTRUCTUREDELEGATE_HXX
