//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AssetContains
    Filename:   AssetContains.hxx
    Module:     asmaintained
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ASMAINTAINED__ASSETCONTAINS__HXX
#define TEAMCENTER__ASMAINTAINED__ASSETCONTAINS__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <asmaintained/libasmaintained_exports.h>

namespace Teamcenter
{
    namespace asmaintained
    {
        class AssetContains;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class AssetContainsImpl;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class AssetContainsDelegate;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class AssetContainsDispatch;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class AssetContainsGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ASMAINTAINED_API  Teamcenter::asmaintained::AssetContains
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AssetContains();

    /**
     * Destructor
     */
    virtual ~AssetContains();

private:
    //  Getter method for the Implementation Object
    AssetContainsImpl*  getAssetContainsImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAssetContainsImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AssetContainsImpl*  m_assetcontainsImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AssetContains - desc for AssetContains parameter
     */
    AssetContains( const AssetContains& );
    AssetContains& operator=( const AssetContains& );

    friend class  AssetContainsDelegate;
    friend class  AssetContainsDispatch;
    friend class  AssetContainsGenImpl;
};

#include <asmaintained/libasmaintained_undef.h>
#endif //   TEAMCENTER__ASMAINTAINED__ASSETCONTAINS__HXX
