//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AssetGroup
    Filename:   AssetGroup.hxx
    Module:     asmaintained
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ASMAINTAINED__ASSETGROUP__HXX
#define TEAMCENTER__ASMAINTAINED__ASSETGROUP__HXX

#include <common/tc_deprecation_macros.h>
#include <mrocore/HierarchicalWSO.hxx>

#include <asmaintained/libasmaintained_exports.h>

namespace Teamcenter
{
    namespace asmaintained
    {
        class AssetGroup;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class AssetGroupImpl;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class AssetGroupDelegate;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class AssetGroupDispatch;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class AssetGroupGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ASMAINTAINED_API  Teamcenter::asmaintained::AssetGroup
     : public  ::Teamcenter::mrocore::HierarchicalWSO
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AssetGroup();

    /**
     * Destructor
     */
    virtual ~AssetGroup();

private:
    //  Getter method for the Implementation Object
    AssetGroupImpl*  getAssetGroupImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAssetGroupImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AssetGroupImpl*  m_assetgroupImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AssetGroup - desc for AssetGroup parameter
     */
    AssetGroup( const AssetGroup& );
    AssetGroup& operator=( const AssetGroup& );

    friend class  AssetGroupDelegate;
    friend class  AssetGroupDispatch;
    friend class  AssetGroupGenImpl;
};

#include <asmaintained/libasmaintained_undef.h>
#endif //   TEAMCENTER__ASMAINTAINED__ASSETGROUP__HXX
