//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AssetGroupDelegate
    Filename:   AssetGroupDelegate.hxx
    Module:     asmaintained
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ASMAINTAINED__ASSETGROUPDELEGATE_HXX
#define TEAMCENTER__ASMAINTAINED__ASSETGROUPDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <asmaintained/AssetGroup.hxx>

#include <asmaintained/libasmaintained_exports.h>

namespace Teamcenter
{
    namespace asmaintained
    {
        class AssetGroupDelegate;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class AssetGroupImpl;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class AssetGroup;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class AssetGroupGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  ASMAINTAINED_API Teamcenter_alias::asmaintained::AssetGroupDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the AssetGroupDelegate instance
    static AssetGroupDelegate&  getInstance();

    //  Method to create the AssetGroupImpl pointer
    static AssetGroupImpl*  createImpl( AssetGroup&  ifObj );

    //  Method to delete the AssetGroupImpl pointer
    static void deleteImpl( AssetGroupImpl*  impl );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const AssetGroup &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static AssetGroupDelegate*  m_pInstance;

    AssetGroupDelegate();
    virtual ~AssetGroupDelegate();
    static void setInstance( AssetGroupDelegate*  instance );


private:
    friend class  ::Teamcenter::asmaintained::AssetGroupGenImpl;

};

#include <asmaintained/libasmaintained_undef.h>
#endif  //  TEAMCENTER__ASMAINTAINED__ASSETGROUPDELEGATE_HXX
