//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DispApplicabilityData
    Filename:   DispApplicabilityData.hxx
    Module:     asmaintained
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ASMAINTAINED__DISPAPPLICABILITYDATA__HXX
#define TEAMCENTER__ASMAINTAINED__DISPAPPLICABILITYDATA__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <asmaintained/libasmaintained_exports.h>

namespace Teamcenter
{
    namespace asmaintained
    {
        class DispApplicabilityData;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class DispApplicabilityDataImpl;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class DispApplicabilityDataDelegate;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class DispApplicabilityDataDispatch;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class DispApplicabilityDataGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ASMAINTAINED_API  Teamcenter::asmaintained::DispApplicabilityData
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    DispApplicabilityData();

    /**
     * Destructor
     */
    virtual ~DispApplicabilityData();

private:
    //  Getter method for the Implementation Object
    DispApplicabilityDataImpl*  getDispApplicabilityDataImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDispApplicabilityDataImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DispApplicabilityDataImpl*  m_dispapplicabilitydataImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param DispApplicabilityData - desc for DispApplicabilityData parameter
     */
    DispApplicabilityData( const DispApplicabilityData& );
    DispApplicabilityData& operator=( const DispApplicabilityData& );

    friend class  DispApplicabilityDataDelegate;
    friend class  DispApplicabilityDataDispatch;
    friend class  DispApplicabilityDataGenImpl;
};

#include <asmaintained/libasmaintained_undef.h>
#endif //   TEAMCENTER__ASMAINTAINED__DISPAPPLICABILITYDATA__HXX
