//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DispositionApplicability
    Filename:   DispositionApplicability.hxx
    Module:     asmaintained
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ASMAINTAINED__DISPOSITIONAPPLICABILITY__HXX
#define TEAMCENTER__ASMAINTAINED__DISPOSITIONAPPLICABILITY__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <asmaintained/libasmaintained_exports.h>

namespace Teamcenter
{
    namespace asmaintained
    {
        class DispositionApplicability;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class DispositionApplicabilityImpl;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class DispositionApplicabilityDelegate;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class DispositionApplicabilityDispatch;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class DispositionApplicabilityGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ASMAINTAINED_API  Teamcenter::asmaintained::DispositionApplicability
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    DispositionApplicability();

    /**
     * Destructor
     */
    virtual ~DispositionApplicability();

private:
    //  Getter method for the Implementation Object
    DispositionApplicabilityImpl*  getDispositionApplicabilityImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDispositionApplicabilityImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DispositionApplicabilityImpl*  m_dispositionapplicabilityImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param DispositionApplicability - desc for DispositionApplicability parameter
     */
    DispositionApplicability( const DispositionApplicability& );
    DispositionApplicability& operator=( const DispositionApplicability& );

    friend class  DispositionApplicabilityDelegate;
    friend class  DispositionApplicabilityDispatch;
    friend class  DispositionApplicabilityGenImpl;
};

#include <asmaintained/libasmaintained_undef.h>
#endif //   TEAMCENTER__ASMAINTAINED__DISPOSITIONAPPLICABILITY__HXX
