//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DispositionType
    Filename:   DispositionType.hxx
    Module:     asmaintained
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ASMAINTAINED__DISPOSITIONTYPE__HXX
#define TEAMCENTER__ASMAINTAINED__DISPOSITIONTYPE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <asmaintained/libasmaintained_exports.h>

namespace Teamcenter
{
    namespace asmaintained
    {
        class DispositionType;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class DispositionTypeImpl;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class DispositionTypeDelegate;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class DispositionTypeDispatch;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class DispositionTypeGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ASMAINTAINED_API  Teamcenter::asmaintained::DispositionType
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    DispositionType();

    /**
     * Destructor
     */
    virtual ~DispositionType();

private:
    //  Getter method for the Implementation Object
    DispositionTypeImpl*  getDispositionTypeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDispositionTypeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DispositionTypeImpl*  m_dispositiontypeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param DispositionType - desc for DispositionType parameter
     */
    DispositionType( const DispositionType& );
    DispositionType& operator=( const DispositionType& );

    friend class  DispositionTypeDelegate;
    friend class  DispositionTypeDispatch;
    friend class  DispositionTypeGenImpl;
};

#include <asmaintained/libasmaintained_undef.h>
#endif //   TEAMCENTER__ASMAINTAINED__DISPOSITIONTYPE__HXX
