//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MroDateEntry
    Filename:   MroDateEntry.hxx
    Module:     asmaintained
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ASMAINTAINED__MRODATEENTRY__HXX
#define TEAMCENTER__ASMAINTAINED__MRODATEENTRY__HXX

#include <common/tc_deprecation_macros.h>
#include <asmaintained/MroRuleEntry.hxx>

#include <asmaintained/libasmaintained_exports.h>

namespace Teamcenter
{
    namespace asmaintained
    {
        class MroDateEntry;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class MroDateEntryImpl;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class MroDateEntryDelegate;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class MroDateEntryDispatch;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class MroDateEntryGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ASMAINTAINED_API  Teamcenter::asmaintained::MroDateEntry
     : public  ::Teamcenter::asmaintained::MroRuleEntry
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    MroDateEntry();

    /**
     * Destructor
     */
    virtual ~MroDateEntry();

private:
    //  Getter method for the Implementation Object
    MroDateEntryImpl*  getMroDateEntryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMroDateEntryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    MroDateEntryImpl*  m_mrodateentryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param MroDateEntry - desc for MroDateEntry parameter
     */
    MroDateEntry( const MroDateEntry& );
    MroDateEntry& operator=( const MroDateEntry& );

    friend class  MroDateEntryDelegate;
    friend class  MroDateEntryDispatch;
    friend class  MroDateEntryGenImpl;
};

#include <asmaintained/libasmaintained_undef.h>
#endif //   TEAMCENTER__ASMAINTAINED__MRODATEENTRY__HXX
