//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MroRuleEntry
    Filename:   MroRuleEntry.hxx
    Module:     asmaintained
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ASMAINTAINED__MRORULEENTRY__HXX
#define TEAMCENTER__ASMAINTAINED__MRORULEENTRY__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <asmaintained/libasmaintained_exports.h>

namespace Teamcenter
{
    namespace asmaintained
    {
        class MroRuleEntry;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class MroRuleEntryImpl;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class MroRuleEntryDelegate;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class MroRuleEntryDispatch;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class MroRuleEntryGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ASMAINTAINED_API  Teamcenter::asmaintained::MroRuleEntry
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    MroRuleEntry();

    /**
     * Destructor
     */
    virtual ~MroRuleEntry();

private:
    //  Getter method for the Implementation Object
    MroRuleEntryImpl*  getMroRuleEntryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMroRuleEntryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    MroRuleEntryImpl*  m_mroruleentryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param MroRuleEntry - desc for MroRuleEntry parameter
     */
    MroRuleEntry( const MroRuleEntry& );
    MroRuleEntry& operator=( const MroRuleEntry& );

    friend class  MroRuleEntryDelegate;
    friend class  MroRuleEntryDispatch;
    friend class  MroRuleEntryGenImpl;
};

#include <asmaintained/libasmaintained_undef.h>
#endif //   TEAMCENTER__ASMAINTAINED__MRORULEENTRY__HXX
