//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MroServiceabilityEntry
    Filename:   MroServiceabilityEntry.hxx
    Module:     asmaintained
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ASMAINTAINED__MROSERVICEABILITYENTRY__HXX
#define TEAMCENTER__ASMAINTAINED__MROSERVICEABILITYENTRY__HXX

#include <common/tc_deprecation_macros.h>
#include <asmaintained/MroRuleEntry.hxx>

#include <asmaintained/libasmaintained_exports.h>

namespace Teamcenter
{
    namespace asmaintained
    {
        class MroServiceabilityEntry;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class MroServiceabilityEntryImpl;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class MroServiceabilityEntryDelegate;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class MroServiceabilityEntryDispatch;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class MroServiceabilityEntryGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ASMAINTAINED_API  Teamcenter::asmaintained::MroServiceabilityEntry
     : public  ::Teamcenter::asmaintained::MroRuleEntry
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    MroServiceabilityEntry();

    /**
     * Destructor
     */
    virtual ~MroServiceabilityEntry();

private:
    //  Getter method for the Implementation Object
    MroServiceabilityEntryImpl*  getMroServiceabilityEntryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMroServiceabilityEntryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    MroServiceabilityEntryImpl*  m_mroserviceabilityentryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param MroServiceabilityEntry - desc for MroServiceabilityEntry parameter
     */
    MroServiceabilityEntry( const MroServiceabilityEntry& );
    MroServiceabilityEntry& operator=( const MroServiceabilityEntry& );

    friend class  MroServiceabilityEntryDelegate;
    friend class  MroServiceabilityEntryDispatch;
    friend class  MroServiceabilityEntryGenImpl;
};

#include <asmaintained/libasmaintained_undef.h>
#endif //   TEAMCENTER__ASMAINTAINED__MROSERVICEABILITYENTRY__HXX
