//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MroStatusEntry
    Filename:   MroStatusEntry.hxx
    Module:     asmaintained
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ASMAINTAINED__MROSTATUSENTRY__HXX
#define TEAMCENTER__ASMAINTAINED__MROSTATUSENTRY__HXX

#include <common/tc_deprecation_macros.h>
#include <asmaintained/MroRuleEntry.hxx>

#include <asmaintained/libasmaintained_exports.h>

namespace Teamcenter
{
    namespace asmaintained
    {
        class MroStatusEntry;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class MroStatusEntryImpl;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class MroStatusEntryDelegate;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class MroStatusEntryDispatch;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class MroStatusEntryGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ASMAINTAINED_API  Teamcenter::asmaintained::MroStatusEntry
     : public  ::Teamcenter::asmaintained::MroRuleEntry
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    MroStatusEntry();

    /**
     * Destructor
     */
    virtual ~MroStatusEntry();

private:
    //  Getter method for the Implementation Object
    MroStatusEntryImpl*  getMroStatusEntryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMroStatusEntryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    MroStatusEntryImpl*  m_mrostatusentryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param MroStatusEntry - desc for MroStatusEntry parameter
     */
    MroStatusEntry( const MroStatusEntry& );
    MroStatusEntry& operator=( const MroStatusEntry& );

    friend class  MroStatusEntryDelegate;
    friend class  MroStatusEntryDispatch;
    friend class  MroStatusEntryGenImpl;
};

#include <asmaintained/libasmaintained_undef.h>
#endif //   TEAMCENTER__ASMAINTAINED__MROSTATUSENTRY__HXX
