//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PhysLocationUsageData
    Filename:   PhysLocationUsageData.hxx
    Module:     asmaintained
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ASMAINTAINED__PHYSLOCATIONUSAGEDATA__HXX
#define TEAMCENTER__ASMAINTAINED__PHYSLOCATIONUSAGEDATA__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <asmaintained/libasmaintained_exports.h>

namespace Teamcenter
{
    namespace asmaintained
    {
        class PhysLocationUsageData;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class PhysLocationUsageDataImpl;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class PhysLocationUsageDataDelegate;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class PhysLocationUsageDataDispatch;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class PhysLocationUsageDataGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ASMAINTAINED_API  Teamcenter::asmaintained::PhysLocationUsageData
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PhysLocationUsageData();

    /**
     * Destructor
     */
    virtual ~PhysLocationUsageData();

private:
    //  Getter method for the Implementation Object
    PhysLocationUsageDataImpl*  getPhysLocationUsageDataImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPhysLocationUsageDataImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PhysLocationUsageDataImpl*  m_physlocationusagedataImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PhysLocationUsageData - desc for PhysLocationUsageData parameter
     */
    PhysLocationUsageData( const PhysLocationUsageData& );
    PhysLocationUsageData& operator=( const PhysLocationUsageData& );

    friend class  PhysLocationUsageDataDelegate;
    friend class  PhysLocationUsageDataDispatch;
    friend class  PhysLocationUsageDataGenImpl;
};

#include <asmaintained/libasmaintained_undef.h>
#endif //   TEAMCENTER__ASMAINTAINED__PHYSLOCATIONUSAGEDATA__HXX
