//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PhysicalLocation
    Filename:   PhysicalLocation.hxx
    Module:     asmaintained
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ASMAINTAINED__PHYSICALLOCATION__HXX
#define TEAMCENTER__ASMAINTAINED__PHYSICALLOCATION__HXX

#include <common/tc_deprecation_macros.h>
#include <mrocore/PhysicalElement.hxx>

#include <asmaintained/libasmaintained_exports.h>

namespace Teamcenter
{
    namespace asmaintained
    {
        class PhysicalLocation;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class PhysicalLocationImpl;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class PhysicalLocationDelegate;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class PhysicalLocationDispatch;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class PhysicalLocationGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ASMAINTAINED_API  Teamcenter::asmaintained::PhysicalLocation
     : public  ::Teamcenter::mrocore::PhysicalElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PhysicalLocation();

    /**
     * Destructor
     */
    virtual ~PhysicalLocation();

private:
    //  Getter method for the Implementation Object
    PhysicalLocationImpl*  getPhysicalLocationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPhysicalLocationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PhysicalLocationImpl*  m_physicallocationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PhysicalLocation - desc for PhysicalLocation parameter
     */
    PhysicalLocation( const PhysicalLocation& );
    PhysicalLocation& operator=( const PhysicalLocation& );

    friend class  PhysicalLocationDelegate;
    friend class  PhysicalLocationDispatch;
    friend class  PhysicalLocationGenImpl;
};

#include <asmaintained/libasmaintained_undef.h>
#endif //   TEAMCENTER__ASMAINTAINED__PHYSICALLOCATION__HXX
