//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PhysicalLocationBOMLineDelegate
    Filename:   PhysicalLocationBOMLineDelegate.hxx
    Module:     asmaintained
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ASMAINTAINED__PHYSICALLOCATIONBOMLINEDELEGATE_HXX
#define TEAMCENTER__ASMAINTAINED__PHYSICALLOCATIONBOMLINEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <asmaintained/PhysicalLocationBOMLine.hxx>

#include <asmaintained/libasmaintained_exports.h>

namespace Teamcenter
{
    namespace asmaintained
    {
        class PhysicalLocationBOMLineDelegate;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class PhysicalLocationBOMLineImpl;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class PhysicalLocationBOMLine;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class PhysicalLocationBOMLineGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  ASMAINTAINED_API Teamcenter_alias::asmaintained::PhysicalLocationBOMLineDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PhysicalLocationBOMLineDelegate instance
    static PhysicalLocationBOMLineDelegate&  getInstance();

    //  Method to create the PhysicalLocationBOMLineImpl pointer
    static PhysicalLocationBOMLineImpl*  createImpl( PhysicalLocationBOMLine&  ifObj );

    //  Method to delete the PhysicalLocationBOMLineImpl pointer
    static void deleteImpl( PhysicalLocationBOMLineImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPlbl_company_cityBase(const PhysicalLocationBOMLine &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPlbl_company_countryBase(const PhysicalLocationBOMLine &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPlbl_company_postal_codeBase(const PhysicalLocationBOMLine &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPlbl_company_regionBase(const PhysicalLocationBOMLine &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPlbl_company_state_provinceBase(const PhysicalLocationBOMLine &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPlbl_company_streetBase(const PhysicalLocationBOMLine &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPlbl_company_urlBase(const PhysicalLocationBOMLine &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPlbl_location_descriptionBase(const PhysicalLocationBOMLine &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPlbl_location_nameBase(const PhysicalLocationBOMLine &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPlbl_location_typeBase(const PhysicalLocationBOMLine &ifObj,  std::string &value, bool &isNull ) const;



protected:
    //  Pointer to the instance
    static PhysicalLocationBOMLineDelegate*  m_pInstance;

    PhysicalLocationBOMLineDelegate();
    virtual ~PhysicalLocationBOMLineDelegate();
    static void setInstance( PhysicalLocationBOMLineDelegate*  instance );


private:
    friend class  ::Teamcenter::asmaintained::PhysicalLocationBOMLineGenImpl;

};

#include <asmaintained/libasmaintained_undef.h>
#endif  //  TEAMCENTER__ASMAINTAINED__PHYSICALLOCATIONBOMLINEDELEGATE_HXX
