//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PhysicalLocationDelegate
    Filename:   PhysicalLocationDelegate.hxx
    Module:     asmaintained
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ASMAINTAINED__PHYSICALLOCATIONDELEGATE_HXX
#define TEAMCENTER__ASMAINTAINED__PHYSICALLOCATIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <asmaintained/PhysicalLocation.hxx>

#include <asmaintained/libasmaintained_exports.h>

namespace Teamcenter
{
    namespace asmaintained
    {
        class PhysicalLocationDelegate;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class PhysicalLocationImpl;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class PhysicalLocation;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class PhysicalLocationGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  ASMAINTAINED_API Teamcenter_alias::asmaintained::PhysicalLocationDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PhysicalLocationDelegate instance
    static PhysicalLocationDelegate&  getInstance();

    //  Method to create the PhysicalLocationImpl pointer
    static PhysicalLocationImpl*  createImpl( PhysicalLocation&  ifObj );

    //  Method to delete the PhysicalLocationImpl pointer
    static void deleteImpl( PhysicalLocationImpl*  impl );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const PhysicalLocation &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static PhysicalLocationDelegate*  m_pInstance;

    PhysicalLocationDelegate();
    virtual ~PhysicalLocationDelegate();
    static void setInstance( PhysicalLocationDelegate*  instance );


private:
    friend class  ::Teamcenter::asmaintained::PhysicalLocationGenImpl;

};

#include <asmaintained/libasmaintained_undef.h>
#endif  //  TEAMCENTER__ASMAINTAINED__PHYSICALLOCATIONDELEGATE_HXX
