//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PhysicalLocationDetails
    Filename:   PhysicalLocationDetails.hxx
    Module:     asmaintained
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ASMAINTAINED__PHYSICALLOCATIONDETAILS__HXX
#define TEAMCENTER__ASMAINTAINED__PHYSICALLOCATIONDETAILS__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <asmaintained/libasmaintained_exports.h>

namespace Teamcenter
{
    namespace asmaintained
    {
        class PhysicalLocationDetails;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class PhysicalLocationDetailsImpl;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class PhysicalLocationDetailsDelegate;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class PhysicalLocationDetailsDispatch;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class PhysicalLocationDetailsGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ASMAINTAINED_API  Teamcenter::asmaintained::PhysicalLocationDetails
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PhysicalLocationDetails();

    /**
     * Destructor
     */
    virtual ~PhysicalLocationDetails();

private:
    //  Getter method for the Implementation Object
    PhysicalLocationDetailsImpl*  getPhysicalLocationDetailsImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPhysicalLocationDetailsImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PhysicalLocationDetailsImpl*  m_physicallocationdetailsImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PhysicalLocationDetails - desc for PhysicalLocationDetails parameter
     */
    PhysicalLocationDetails( const PhysicalLocationDetails& );
    PhysicalLocationDetails& operator=( const PhysicalLocationDetails& );

    friend class  PhysicalLocationDetailsDelegate;
    friend class  PhysicalLocationDetailsDispatch;
    friend class  PhysicalLocationDetailsGenImpl;
};

#include <asmaintained/libasmaintained_undef.h>
#endif //   TEAMCENTER__ASMAINTAINED__PHYSICALLOCATIONDETAILS__HXX
