//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PhysicalLocationRevision
    Filename:   PhysicalLocationRevision.hxx
    Module:     asmaintained
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ASMAINTAINED__PHYSICALLOCATIONREVISION__HXX
#define TEAMCENTER__ASMAINTAINED__PHYSICALLOCATIONREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <mrocore/PhysicalElementRevision.hxx>

#include <asmaintained/libasmaintained_exports.h>

namespace Teamcenter
{
    namespace asmaintained
    {
        class PhysicalLocationRevision;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class PhysicalLocationRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class PhysicalLocationRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class PhysicalLocationRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class PhysicalLocationRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ASMAINTAINED_API  Teamcenter::asmaintained::PhysicalLocationRevision
     : public  ::Teamcenter::mrocore::PhysicalElementRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PhysicalLocationRevision();

    /**
     * Destructor
     */
    virtual ~PhysicalLocationRevision();

private:
    //  Getter method for the Implementation Object
    PhysicalLocationRevisionImpl*  getPhysicalLocationRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPhysicalLocationRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PhysicalLocationRevisionImpl*  m_physicallocationrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PhysicalLocationRevision - desc for PhysicalLocationRevision parameter
     */
    PhysicalLocationRevision( const PhysicalLocationRevision& );
    PhysicalLocationRevision& operator=( const PhysicalLocationRevision& );

    friend class  PhysicalLocationRevisionDelegate;
    friend class  PhysicalLocationRevisionDispatch;
    friend class  PhysicalLocationRevisionGenImpl;
};

#include <asmaintained/libasmaintained_undef.h>
#endif //   TEAMCENTER__ASMAINTAINED__PHYSICALLOCATIONREVISION__HXX
