//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PhysicalLocationUsage
    Filename:   PhysicalLocationUsage.hxx
    Module:     asmaintained
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ASMAINTAINED__PHYSICALLOCATIONUSAGE__HXX
#define TEAMCENTER__ASMAINTAINED__PHYSICALLOCATIONUSAGE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <asmaintained/libasmaintained_exports.h>

namespace Teamcenter
{
    namespace asmaintained
    {
        class PhysicalLocationUsage;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class PhysicalLocationUsageImpl;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class PhysicalLocationUsageDelegate;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class PhysicalLocationUsageDispatch;
    }
}
namespace Teamcenter
{
    namespace asmaintained
    {
        class PhysicalLocationUsageGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ASMAINTAINED_API  Teamcenter::asmaintained::PhysicalLocationUsage
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PhysicalLocationUsage();

    /**
     * Destructor
     */
    virtual ~PhysicalLocationUsage();

private:
    //  Getter method for the Implementation Object
    PhysicalLocationUsageImpl*  getPhysicalLocationUsageImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPhysicalLocationUsageImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PhysicalLocationUsageImpl*  m_physicallocationusageImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PhysicalLocationUsage - desc for PhysicalLocationUsage parameter
     */
    PhysicalLocationUsage( const PhysicalLocationUsage& );
    PhysicalLocationUsage& operator=( const PhysicalLocationUsage& );

    friend class  PhysicalLocationUsageDelegate;
    friend class  PhysicalLocationUsageDispatch;
    friend class  PhysicalLocationUsageGenImpl;
};

#include <asmaintained/libasmaintained_undef.h>
#endif //   TEAMCENTER__ASMAINTAINED__PHYSICALLOCATIONUSAGE__HXX
