//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  asmaintaineddispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libasmaintaineddispatch

#if !defined(LIBASMAINTAINEDDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBASMAINTAINEDDISPATCH is not defined
#endif

/* Handwritten code should use ASMAINTAINEDDISPATCH_API, not ASMAINTAINEDDISPATCHEXPORT */

#define ASMAINTAINEDDISPATCH_API ASMAINTAINEDDISPATCHEXPORT

#if IPLIB==libasmaintaineddispatch || defined(LIBASMAINTAINEDDISPATCH)
#   if defined(__lint)
#       define ASMAINTAINEDDISPATCHEXPORT       __export(asmaintaineddispatch)
#       define ASMAINTAINEDDISPATCHGLOBAL       extern __global(asmaintaineddispatch)
#       define ASMAINTAINEDDISPATCHPRIVATE      extern __private(asmaintaineddispatch)
#   elif defined(_WIN32)
#       define ASMAINTAINEDDISPATCHEXPORT       __declspec(dllexport)
#       define ASMAINTAINEDDISPATCHGLOBAL       extern __declspec(dllexport)
#       define ASMAINTAINEDDISPATCHPRIVATE      extern
#   else
#       define ASMAINTAINEDDISPATCHEXPORT
#       define ASMAINTAINEDDISPATCHGLOBAL       extern
#       define ASMAINTAINEDDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define ASMAINTAINEDDISPATCHEXPORT       __export(asmaintaineddispatch)
#       define ASMAINTAINEDDISPATCHGLOBAL       extern __global(asmaintaineddispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define ASMAINTAINEDDISPATCHEXPORT      __declspec(dllimport)
#       define ASMAINTAINEDDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define ASMAINTAINEDDISPATCHEXPORT
#       define ASMAINTAINEDDISPATCHGLOBAL       extern
#   endif
#endif
