//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  asp0aspectdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libasp0aspectdispatch

#if !defined(LIBASP0ASPECTDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBASP0ASPECTDISPATCH is not defined
#endif

/* Handwritten code should use ASP0ASPECTDISPATCH_API, not ASP0ASPECTDISPATCHEXPORT */

#define ASP0ASPECTDISPATCH_API ASP0ASPECTDISPATCHEXPORT

#if IPLIB==libasp0aspectdispatch || defined(LIBASP0ASPECTDISPATCH)
#   if defined(__lint)
#       define ASP0ASPECTDISPATCHEXPORT       __export(asp0aspectdispatch)
#       define ASP0ASPECTDISPATCHGLOBAL       extern __global(asp0aspectdispatch)
#       define ASP0ASPECTDISPATCHPRIVATE      extern __private(asp0aspectdispatch)
#   elif defined(_WIN32)
#       define ASP0ASPECTDISPATCHEXPORT       __declspec(dllexport)
#       define ASP0ASPECTDISPATCHGLOBAL       extern __declspec(dllexport)
#       define ASP0ASPECTDISPATCHPRIVATE      extern
#   else
#       define ASP0ASPECTDISPATCHEXPORT
#       define ASP0ASPECTDISPATCHGLOBAL       extern
#       define ASP0ASPECTDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define ASP0ASPECTDISPATCHEXPORT       __export(asp0aspectdispatch)
#       define ASP0ASPECTDISPATCHGLOBAL       extern __global(asp0aspectdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define ASP0ASPECTDISPATCHEXPORT      __declspec(dllimport)
#       define ASP0ASPECTDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define ASP0ASPECTDISPATCHEXPORT
#       define ASP0ASPECTDISPATCHGLOBAL       extern
#   endif
#endif
