//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Bhv0BranchComment
    Filename:   Bhv0BranchComment.hxx
    Module:     bhv0branchfoundation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef BHV0BRANCHFOUNDATION__BHV0BRANCHCOMMENT__HXX
#define BHV0BRANCHFOUNDATION__BHV0BRANCHCOMMENT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <bhv0branchfoundation/libbhv0branchfoundation_exports.h>

namespace bhv0branchfoundation
{
    class Bhv0BranchComment;
}
namespace bhv0branchfoundation
{
    class Bhv0BranchCommentImpl;
}
namespace bhv0branchfoundation
{
    class Bhv0BranchCommentDelegate;
}
namespace bhv0branchfoundation
{
    class Bhv0BranchCommentDispatch;
}
namespace bhv0branchfoundation
{
    class Bhv0BranchCommentGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BHV0BRANCHFOUNDATION_API  bhv0branchfoundation::Bhv0BranchComment
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Bhv0BranchComment();

    /**
     * Destructor
     */
    virtual ~Bhv0BranchComment();

private:
    //  Getter method for the Implementation Object
    Bhv0BranchCommentImpl*  getBhv0BranchCommentImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBhv0BranchCommentImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Bhv0BranchCommentImpl*  m_bhv0branchcommentImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Bhv0BranchComment - desc for Bhv0BranchComment parameter
     */
    Bhv0BranchComment( const Bhv0BranchComment& );
    Bhv0BranchComment& operator=( const Bhv0BranchComment& );

    friend class  Bhv0BranchCommentDelegate;
    friend class  Bhv0BranchCommentDispatch;
    friend class  Bhv0BranchCommentGenImpl;
};

#include <bhv0branchfoundation/libbhv0branchfoundation_undef.h>
#endif //   BHV0BRANCHFOUNDATION__BHV0BRANCHCOMMENT__HXX
