//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Bhv0ModelCollection
    Filename:   Bhv0ModelCollection.hxx
    Module:     bhv0branchfoundation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef BHV0BRANCHFOUNDATION__BHV0MODELCOLLECTION__HXX
#define BHV0BRANCHFOUNDATION__BHV0MODELCOLLECTION__HXX

#include <common/tc_deprecation_macros.h>
#include <cfm/Fnd0Branch.hxx>

#include <bhv0branchfoundation/libbhv0branchfoundation_exports.h>

namespace bhv0branchfoundation
{
    class Bhv0ModelCollection;
}
namespace bhv0branchfoundation
{
    class Bhv0ModelCollectionImpl;
}
namespace bhv0branchfoundation
{
    class Bhv0ModelCollectionDelegate;
}
namespace bhv0branchfoundation
{
    class Bhv0ModelCollectionDispatch;
}
namespace bhv0branchfoundation
{
    class Bhv0ModelCollectionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BHV0BRANCHFOUNDATION_API  bhv0branchfoundation::Bhv0ModelCollection
     : public  ::Teamcenter::Fnd0Branch
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Bhv0ModelCollection();

    /**
     * Destructor
     */
    virtual ~Bhv0ModelCollection();

private:
    //  Getter method for the Implementation Object
    Bhv0ModelCollectionImpl*  getBhv0ModelCollectionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBhv0ModelCollectionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Bhv0ModelCollectionImpl*  m_bhv0modelcollectionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Bhv0ModelCollection - desc for Bhv0ModelCollection parameter
     */
    Bhv0ModelCollection( const Bhv0ModelCollection& );
    Bhv0ModelCollection& operator=( const Bhv0ModelCollection& );

    friend class  Bhv0ModelCollectionDelegate;
    friend class  Bhv0ModelCollectionDispatch;
    friend class  Bhv0ModelCollectionGenImpl;
};

#include <bhv0branchfoundation/libbhv0branchfoundation_undef.h>
#endif //   BHV0BRANCHFOUNDATION__BHV0MODELCOLLECTION__HXX
