//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Bhv0SCMExternalData
    Filename:   Bhv0SCMExternalData.hxx
    Module:     bhv0branchfoundation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef BHV0BRANCHFOUNDATION__BHV0SCMEXTERNALDATA__HXX
#define BHV0BRANCHFOUNDATION__BHV0SCMEXTERNALDATA__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <bhv0branchfoundation/libbhv0branchfoundation_exports.h>

namespace bhv0branchfoundation
{
    class Bhv0SCMExternalData;
}
namespace bhv0branchfoundation
{
    class Bhv0SCMExternalDataImpl;
}
namespace bhv0branchfoundation
{
    class Bhv0SCMExternalDataDelegate;
}
namespace bhv0branchfoundation
{
    class Bhv0SCMExternalDataDispatch;
}
namespace bhv0branchfoundation
{
    class Bhv0SCMExternalDataGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BHV0BRANCHFOUNDATION_API  bhv0branchfoundation::Bhv0SCMExternalData
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 12.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getBhv0RelativeDataObjects( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Bhv0SCMExternalData();

    /**
     * Destructor
     */
    virtual ~Bhv0SCMExternalData();

private:
    //  Getter method for the Implementation Object
    Bhv0SCMExternalDataImpl*  getBhv0SCMExternalDataImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBhv0SCMExternalDataImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Bhv0SCMExternalDataImpl*  m_bhv0scmexternaldataImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Bhv0SCMExternalData - desc for Bhv0SCMExternalData parameter
     */
    Bhv0SCMExternalData( const Bhv0SCMExternalData& );
    Bhv0SCMExternalData& operator=( const Bhv0SCMExternalData& );

    friend class  Bhv0SCMExternalDataDelegate;
    friend class  Bhv0SCMExternalDataDispatch;
    friend class  Bhv0SCMExternalDataGenImpl;
};

#include <bhv0branchfoundation/libbhv0branchfoundation_undef.h>
#endif //   BHV0BRANCHFOUNDATION__BHV0SCMEXTERNALDATA__HXX
