//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BMOperation
    Filename:   BMOperation.hxx
    Module:     bmf
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BMOPERATION__HXX
#define TEAMCENTER__BMOPERATION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/BusinessRule.hxx>

#include <bmf/libbmf_exports.h>

namespace Teamcenter
{
    class BMOperation;
}
namespace Teamcenter
{
    class BMOperationImpl;
}
namespace Teamcenter
{
    class BMOperationDelegate;
}
namespace Teamcenter
{
    class BMOperationDispatch;
}
namespace Teamcenter
{
    class BMOperationGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BMF_API  Teamcenter::BMOperation
     : public  ::Teamcenter::BusinessRule
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    BMOperation();

    /**
     * Destructor
     */
    virtual ~BMOperation();

private:
    //  Getter method for the Implementation Object
    BMOperationImpl*  getBMOperationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBMOperationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    BMOperationImpl*  m_bmoperationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param BMOperation - desc for BMOperation parameter
     */
    BMOperation( const BMOperation& );
    BMOperation& operator=( const BMOperation& );

    friend class  BMOperationDelegate;
    friend class  BMOperationDispatch;
    friend class  BMOperationGenImpl;
};

#include <bmf/libbmf_undef.h>
#endif //   TEAMCENTER__BMOPERATION__HXX
