//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BMOperationDelegate
    Filename:   BMOperationDelegate.hxx
    Module:     bmf
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BMOPERATIONDELEGATE_HXX
#define TEAMCENTER__BMOPERATIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <bmf/BMOperation.hxx>

#include <bmf/libbmf_exports.h>

namespace Teamcenter
{
    class BMOperationDelegate;
}
namespace Teamcenter
{
    class BMOperationImpl;
}
namespace Teamcenter
{
    class BMOperation;
}
namespace Teamcenter
{
    class BMOperationGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  BMF_API Teamcenter_alias::BMOperationDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the BMOperationDelegate instance
    static BMOperationDelegate&  getInstance();

    //  Method to create the BMOperationImpl pointer
    static BMOperationImpl*  createImpl( BMOperation&  ifObj );

    //  Method to delete the BMOperationImpl pointer
    static void deleteImpl( BMOperationImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static BMOperationDelegate*  m_pInstance;

    BMOperationDelegate();
    virtual ~BMOperationDelegate();
    static void setInstance( BMOperationDelegate*  instance );


private:
    friend class  ::Teamcenter::BMOperationGenImpl;

};

#include <bmf/libbmf_undef.h>
#endif  //  TEAMCENTER__BMOPERATIONDELEGATE_HXX
