//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Extension
    Filename:   Extension.hxx
    Module:     bmf
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EXTENSION__HXX
#define TEAMCENTER__EXTENSION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/BusinessRule.hxx>

#include <bmf/libbmf_exports.h>

namespace Teamcenter
{
    class Extension;
}
namespace Teamcenter
{
    class ExtensionImpl;
}
namespace Teamcenter
{
    class ExtensionDelegate;
}
namespace Teamcenter
{
    class ExtensionDispatch;
}
namespace Teamcenter
{
    class ExtensionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BMF_API  Teamcenter::Extension
     : public  ::Teamcenter::BusinessRule
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Extension();

    /**
     * Destructor
     */
    virtual ~Extension();

private:
    //  Getter method for the Implementation Object
    ExtensionImpl*  getExtensionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setExtensionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ExtensionImpl*  m_extensionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Extension - desc for Extension parameter
     */
    Extension( const Extension& );
    Extension& operator=( const Extension& );

    friend class  ExtensionDelegate;
    friend class  ExtensionDispatch;
    friend class  ExtensionGenImpl;
};

#include <bmf/libbmf_undef.h>
#endif //   TEAMCENTER__EXTENSION__HXX
