//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ExtensionDelegate
    Filename:   ExtensionDelegate.hxx
    Module:     bmf
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EXTENSIONDELEGATE_HXX
#define TEAMCENTER__EXTENSIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <bmf/Extension.hxx>

#include <bmf/libbmf_exports.h>

namespace Teamcenter
{
    class ExtensionDelegate;
}
namespace Teamcenter
{
    class ExtensionImpl;
}
namespace Teamcenter
{
    class Extension;
}
namespace Teamcenter
{
    class ExtensionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  BMF_API Teamcenter_alias::ExtensionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ExtensionDelegate instance
    static ExtensionDelegate&  getInstance();

    //  Method to create the ExtensionImpl pointer
    static ExtensionImpl*  createImpl( Extension&  ifObj );

    //  Method to delete the ExtensionImpl pointer
    static void deleteImpl( ExtensionImpl*  impl );



protected:
    //  Pointer to the instance
    static ExtensionDelegate*  m_pInstance;

    ExtensionDelegate();
    virtual ~ExtensionDelegate();
    static void setInstance( ExtensionDelegate*  instance );


private:
    friend class  ::Teamcenter::ExtensionGenImpl;

};

#include <bmf/libbmf_undef.h>
#endif  //  TEAMCENTER__EXTENSIONDELEGATE_HXX
