//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ExtensionDescriptor
    Filename:   ExtensionDescriptor.hxx
    Module:     bmf
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EXTENSIONDESCRIPTOR__HXX
#define TEAMCENTER__EXTENSIONDESCRIPTOR__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/BusinessRule.hxx>

#include <bmf/libbmf_exports.h>

namespace Teamcenter
{
    class ExtensionDescriptor;
}
namespace Teamcenter
{
    class ExtensionDescriptorImpl;
}
namespace Teamcenter
{
    class ExtensionDescriptorDelegate;
}
namespace Teamcenter
{
    class ExtensionDescriptorDispatch;
}
namespace Teamcenter
{
    class ExtensionDescriptorGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BMF_API  Teamcenter::ExtensionDescriptor
     : public  ::Teamcenter::BusinessRule
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ExtensionDescriptor();

    /**
     * Destructor
     */
    virtual ~ExtensionDescriptor();

private:
    //  Getter method for the Implementation Object
    ExtensionDescriptorImpl*  getExtensionDescriptorImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setExtensionDescriptorImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ExtensionDescriptorImpl*  m_extensiondescriptorImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ExtensionDescriptor - desc for ExtensionDescriptor parameter
     */
    ExtensionDescriptor( const ExtensionDescriptor& );
    ExtensionDescriptor& operator=( const ExtensionDescriptor& );

    friend class  ExtensionDescriptorDelegate;
    friend class  ExtensionDescriptorDispatch;
    friend class  ExtensionDescriptorGenImpl;
};

#include <bmf/libbmf_undef.h>
#endif //   TEAMCENTER__EXTENSIONDESCRIPTOR__HXX
