//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ExtensionPoint
    Filename:   ExtensionPoint.hxx
    Module:     bmf
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EXTENSIONPOINT__HXX
#define TEAMCENTER__EXTENSIONPOINT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/BusinessRule.hxx>

#include <bmf/libbmf_exports.h>

namespace Teamcenter
{
    class ExtensionPoint;
}
namespace Teamcenter
{
    class ExtensionPointImpl;
}
namespace Teamcenter
{
    class ExtensionPointDelegate;
}
namespace Teamcenter
{
    class ExtensionPointDispatch;
}
namespace Teamcenter
{
    class ExtensionPointGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BMF_API  Teamcenter::ExtensionPoint
     : public  ::Teamcenter::BusinessRule
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ExtensionPoint();

    /**
     * Destructor
     */
    virtual ~ExtensionPoint();

private:
    //  Getter method for the Implementation Object
    ExtensionPointImpl*  getExtensionPointImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setExtensionPointImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ExtensionPointImpl*  m_extensionpointImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ExtensionPoint - desc for ExtensionPoint parameter
     */
    ExtensionPoint( const ExtensionPoint& );
    ExtensionPoint& operator=( const ExtensionPoint& );

    friend class  ExtensionPointDelegate;
    friend class  ExtensionPointDispatch;
    friend class  ExtensionPointGenImpl;
};

#include <bmf/libbmf_undef.h>
#endif //   TEAMCENTER__EXTENSIONPOINT__HXX
