//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ExtensionPointDelegate
    Filename:   ExtensionPointDelegate.hxx
    Module:     bmf
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EXTENSIONPOINTDELEGATE_HXX
#define TEAMCENTER__EXTENSIONPOINTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <bmf/ExtensionPoint.hxx>

#include <bmf/libbmf_exports.h>

namespace Teamcenter
{
    class ExtensionPointDelegate;
}
namespace Teamcenter
{
    class ExtensionPointImpl;
}
namespace Teamcenter
{
    class ExtensionPoint;
}
namespace Teamcenter
{
    class ExtensionPointGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  BMF_API Teamcenter_alias::ExtensionPointDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ExtensionPointDelegate instance
    static ExtensionPointDelegate&  getInstance();

    //  Method to create the ExtensionPointImpl pointer
    static ExtensionPointImpl*  createImpl( ExtensionPoint&  ifObj );

    //  Method to delete the ExtensionPointImpl pointer
    static void deleteImpl( ExtensionPointImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static ExtensionPointDelegate*  m_pInstance;

    ExtensionPointDelegate();
    virtual ~ExtensionPointDelegate();
    static void setInstance( ExtensionPointDelegate*  instance );


private:
    friend class  ::Teamcenter::ExtensionPointGenImpl;

};

#include <bmf/libbmf_undef.h>
#endif  //  TEAMCENTER__EXTENSIONPOINTDELEGATE_HXX
