//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PropertyBMOperation
    Filename:   PropertyBMOperation.hxx
    Module:     bmf
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROPERTYBMOPERATION__HXX
#define TEAMCENTER__PROPERTYBMOPERATION__HXX

#include <common/tc_deprecation_macros.h>
#include <bmf/BMOperation.hxx>

#include <bmf/libbmf_exports.h>

namespace Teamcenter
{
    class PropertyBMOperation;
}
namespace Teamcenter
{
    class PropertyBMOperationImpl;
}
namespace Teamcenter
{
    class PropertyBMOperationDelegate;
}
namespace Teamcenter
{
    class PropertyBMOperationDispatch;
}
namespace Teamcenter
{
    class PropertyBMOperationGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BMF_API  Teamcenter::PropertyBMOperation
     : public  ::Teamcenter::BMOperation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PropertyBMOperation();

    /**
     * Destructor
     */
    virtual ~PropertyBMOperation();

private:
    //  Getter method for the Implementation Object
    PropertyBMOperationImpl*  getPropertyBMOperationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPropertyBMOperationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PropertyBMOperationImpl*  m_propertybmoperationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PropertyBMOperation - desc for PropertyBMOperation parameter
     */
    PropertyBMOperation( const PropertyBMOperation& );
    PropertyBMOperation& operator=( const PropertyBMOperation& );

    friend class  PropertyBMOperationDelegate;
    friend class  PropertyBMOperationDispatch;
    friend class  PropertyBMOperationGenImpl;
};

#include <bmf/libbmf_undef.h>
#endif //   TEAMCENTER__PROPERTYBMOPERATION__HXX
