//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TypeBMOperation
    Filename:   TypeBMOperation.hxx
    Module:     bmf
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TYPEBMOPERATION__HXX
#define TEAMCENTER__TYPEBMOPERATION__HXX

#include <common/tc_deprecation_macros.h>
#include <bmf/BMOperation.hxx>

#include <bmf/libbmf_exports.h>

namespace Teamcenter
{
    class TypeBMOperation;
}
namespace Teamcenter
{
    class TypeBMOperationImpl;
}
namespace Teamcenter
{
    class TypeBMOperationDelegate;
}
namespace Teamcenter
{
    class TypeBMOperationDispatch;
}
namespace Teamcenter
{
    class TypeBMOperationGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BMF_API  Teamcenter::TypeBMOperation
     : public  ::Teamcenter::BMOperation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    TypeBMOperation();

    /**
     * Destructor
     */
    virtual ~TypeBMOperation();

private:
    //  Getter method for the Implementation Object
    TypeBMOperationImpl*  getTypeBMOperationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTypeBMOperationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    TypeBMOperationImpl*  m_typebmoperationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param TypeBMOperation - desc for TypeBMOperation parameter
     */
    TypeBMOperation( const TypeBMOperation& );
    TypeBMOperation& operator=( const TypeBMOperation& );

    friend class  TypeBMOperationDelegate;
    friend class  TypeBMOperationDispatch;
    friend class  TypeBMOperationGenImpl;
};

#include <bmf/libbmf_undef.h>
#endif //   TEAMCENTER__TYPEBMOPERATION__HXX
