//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  bmf

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libbmf

#if !defined(LIBBMF) && !defined(IPLIB)
#   error IPLIB or LIBBMF is not defined
#endif

/* Handwritten code should use BMF_API, not BMFEXPORT */

#define BMF_API BMFEXPORT

#if IPLIB==libbmf || defined(LIBBMF)
#   if defined(__lint)
#       define BMFEXPORT       __export(bmf)
#       define BMFGLOBAL       extern __global(bmf)
#       define BMFPRIVATE      extern __private(bmf)
#   elif defined(_WIN32)
#       define BMFEXPORT       __declspec(dllexport)
#       define BMFGLOBAL       extern __declspec(dllexport)
#       define BMFPRIVATE      extern
#   else
#       define BMFEXPORT
#       define BMFGLOBAL       extern
#       define BMFPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define BMFEXPORT       __export(bmf)
#       define BMFGLOBAL       extern __global(bmf)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define BMFEXPORT      __declspec(dllimport)
#       define BMFGLOBAL       extern __declspec(dllimport)
#   else
#       define BMFEXPORT
#       define BMFGLOBAL       extern
#   endif
#endif
