//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BOMDerivedDefault
    Filename:   BOMDerivedDefault.hxx
    Module:     bom
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOMDERIVEDDEFAULT__HXX
#define TEAMCENTER__BOMDERIVEDDEFAULT__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <bom/libbom_exports.h>

namespace Teamcenter
{
    class BOMDerivedDefault;
}
namespace Teamcenter
{
    class BOMDerivedDefaultImpl;
}
namespace Teamcenter
{
    class BOMDerivedDefaultDelegate;
}
namespace Teamcenter
{
    class BOMDerivedDefaultDispatch;
}
namespace Teamcenter
{
    class BOMDerivedDefaultGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BOM_API  Teamcenter::BOMDerivedDefault
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    BOMDerivedDefault();

    /**
     * Destructor
     */
    virtual ~BOMDerivedDefault();

private:
    //  Getter method for the Implementation Object
    BOMDerivedDefaultImpl*  getBOMDerivedDefaultImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBOMDerivedDefaultImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    BOMDerivedDefaultImpl*  m_bomderiveddefaultImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param BOMDerivedDefault - desc for BOMDerivedDefault parameter
     */
    BOMDerivedDefault( const BOMDerivedDefault& );
    BOMDerivedDefault& operator=( const BOMDerivedDefault& );

    friend class  BOMDerivedDefaultDelegate;
    friend class  BOMDerivedDefaultDispatch;
    friend class  BOMDerivedDefaultGenImpl;
};

#include <bom/libbom_undef.h>
#endif //   TEAMCENTER__BOMDERIVEDDEFAULT__HXX
