//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BOMFixedDefault
    Filename:   BOMFixedDefault.hxx
    Module:     bom
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOMFIXEDDEFAULT__HXX
#define TEAMCENTER__BOMFIXEDDEFAULT__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <bom/libbom_exports.h>

namespace Teamcenter
{
    class BOMFixedDefault;
}
namespace Teamcenter
{
    class BOMFixedDefaultImpl;
}
namespace Teamcenter
{
    class BOMFixedDefaultDelegate;
}
namespace Teamcenter
{
    class BOMFixedDefaultDispatch;
}
namespace Teamcenter
{
    class BOMFixedDefaultGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BOM_API  Teamcenter::BOMFixedDefault
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    BOMFixedDefault();

    /**
     * Destructor
     */
    virtual ~BOMFixedDefault();

private:
    //  Getter method for the Implementation Object
    BOMFixedDefaultImpl*  getBOMFixedDefaultImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBOMFixedDefaultImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    BOMFixedDefaultImpl*  m_bomfixeddefaultImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param BOMFixedDefault - desc for BOMFixedDefault parameter
     */
    BOMFixedDefault( const BOMFixedDefault& );
    BOMFixedDefault& operator=( const BOMFixedDefault& );

    friend class  BOMFixedDefaultDelegate;
    friend class  BOMFixedDefaultDispatch;
    friend class  BOMFixedDefaultGenImpl;
};

#include <bom/libbom_undef.h>
#endif //   TEAMCENTER__BOMFIXEDDEFAULT__HXX
