//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BOMOption
    Filename:   BOMOption.hxx
    Module:     bom
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOMOPTION__HXX
#define TEAMCENTER__BOMOPTION__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <bom/libbom_exports.h>

namespace Teamcenter
{
    class BOMOption;
}
namespace Teamcenter
{
    class BOMOptionImpl;
}
namespace Teamcenter
{
    class BOMOptionDelegate;
}
namespace Teamcenter
{
    class BOMOptionDispatch;
}
namespace Teamcenter
{
    class BOMOptionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BOM_API  Teamcenter::BOMOption
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    BOMOption();

    /**
     * Destructor
     */
    virtual ~BOMOption();

private:
    //  Getter method for the Implementation Object
    BOMOptionImpl*  getBOMOptionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBOMOptionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    BOMOptionImpl*  m_bomoptionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param BOMOption - desc for BOMOption parameter
     */
    BOMOption( const BOMOption& );
    BOMOption& operator=( const BOMOption& );

    friend class  BOMOptionDelegate;
    friend class  BOMOptionDispatch;
    friend class  BOMOptionGenImpl;
};

#include <bom/libbom_undef.h>
#endif //   TEAMCENTER__BOMOPTION__HXX
