//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BOMOptionIndexExpr
    Filename:   BOMOptionIndexExpr.hxx
    Module:     bom
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOMOPTIONINDEXEXPR__HXX
#define TEAMCENTER__BOMOPTIONINDEXEXPR__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <bom/libbom_exports.h>

namespace Teamcenter
{
    class BOMOptionIndexExpr;
}
namespace Teamcenter
{
    class BOMOptionIndexExprImpl;
}
namespace Teamcenter
{
    class BOMOptionIndexExprDelegate;
}
namespace Teamcenter
{
    class BOMOptionIndexExprDispatch;
}
namespace Teamcenter
{
    class BOMOptionIndexExprGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BOM_API  Teamcenter::BOMOptionIndexExpr
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    BOMOptionIndexExpr();

    /**
     * Destructor
     */
    virtual ~BOMOptionIndexExpr();

private:
    //  Getter method for the Implementation Object
    BOMOptionIndexExprImpl*  getBOMOptionIndexExprImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBOMOptionIndexExprImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    BOMOptionIndexExprImpl*  m_bomoptionindexexprImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param BOMOptionIndexExpr - desc for BOMOptionIndexExpr parameter
     */
    BOMOptionIndexExpr( const BOMOptionIndexExpr& );
    BOMOptionIndexExpr& operator=( const BOMOptionIndexExpr& );

    friend class  BOMOptionIndexExprDelegate;
    friend class  BOMOptionIndexExprDispatch;
    friend class  BOMOptionIndexExprGenImpl;
};

#include <bom/libbom_undef.h>
#endif //   TEAMCENTER__BOMOPTIONINDEXEXPR__HXX
