//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BOMRuleCheck
    Filename:   BOMRuleCheck.hxx
    Module:     bom
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOMRULECHECK__HXX
#define TEAMCENTER__BOMRULECHECK__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <bom/libbom_exports.h>

namespace Teamcenter
{
    class BOMRuleCheck;
}
namespace Teamcenter
{
    class BOMRuleCheckImpl;
}
namespace Teamcenter
{
    class BOMRuleCheckDelegate;
}
namespace Teamcenter
{
    class BOMRuleCheckDispatch;
}
namespace Teamcenter
{
    class BOMRuleCheckGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BOM_API  Teamcenter::BOMRuleCheck
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    BOMRuleCheck();

    /**
     * Destructor
     */
    virtual ~BOMRuleCheck();

private:
    //  Getter method for the Implementation Object
    BOMRuleCheckImpl*  getBOMRuleCheckImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBOMRuleCheckImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    BOMRuleCheckImpl*  m_bomrulecheckImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param BOMRuleCheck - desc for BOMRuleCheck parameter
     */
    BOMRuleCheck( const BOMRuleCheck& );
    BOMRuleCheck& operator=( const BOMRuleCheck& );

    friend class  BOMRuleCheckDelegate;
    friend class  BOMRuleCheckDispatch;
    friend class  BOMRuleCheckGenImpl;
};

#include <bom/libbom_undef.h>
#endif //   TEAMCENTER__BOMRULECHECK__HXX
