//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BOMVariantExprBlock
    Filename:   BOMVariantExprBlock.hxx
    Module:     bom
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOMVARIANTEXPRBLOCK__HXX
#define TEAMCENTER__BOMVARIANTEXPRBLOCK__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <bom/libbom_exports.h>

namespace Teamcenter
{
    class BOMVariantExprBlock;
}
namespace Teamcenter
{
    class BOMVariantExprBlockImpl;
}
namespace Teamcenter
{
    class BOMVariantExprBlockDelegate;
}
namespace Teamcenter
{
    class BOMVariantExprBlockDispatch;
}
namespace Teamcenter
{
    class BOMVariantExprBlockGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BOM_API  Teamcenter::BOMVariantExprBlock
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    BOMVariantExprBlock();

    /**
     * Destructor
     */
    virtual ~BOMVariantExprBlock();

private:
    //  Getter method for the Implementation Object
    BOMVariantExprBlockImpl*  getBOMVariantExprBlockImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBOMVariantExprBlockImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    BOMVariantExprBlockImpl*  m_bomvariantexprblockImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param BOMVariantExprBlock - desc for BOMVariantExprBlock parameter
     */
    BOMVariantExprBlock( const BOMVariantExprBlock& );
    BOMVariantExprBlock& operator=( const BOMVariantExprBlock& );

    friend class  BOMVariantExprBlockDelegate;
    friend class  BOMVariantExprBlockDispatch;
    friend class  BOMVariantExprBlockGenImpl;
};

#include <bom/libbom_undef.h>
#endif //   TEAMCENTER__BOMVARIANTEXPRBLOCK__HXX
