//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BOMVariantRule
    Filename:   BOMVariantRule.hxx
    Module:     bom
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOMVARIANTRULE__HXX
#define TEAMCENTER__BOMVARIANTRULE__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <bom/libbom_exports.h>

namespace Teamcenter
{
    class BOMVariantRule;
}
namespace Teamcenter
{
    class BOMVariantRuleImpl;
}
namespace Teamcenter
{
    class BOMVariantRuleDelegate;
}
namespace Teamcenter
{
    class BOMVariantRuleDispatch;
}
namespace Teamcenter
{
    class BOMVariantRuleGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BOM_API  Teamcenter::BOMVariantRule
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    BOMVariantRule();

    /**
     * Destructor
     */
    virtual ~BOMVariantRule();

private:
    //  Getter method for the Implementation Object
    BOMVariantRuleImpl*  getBOMVariantRuleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBOMVariantRuleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    BOMVariantRuleImpl*  m_bomvariantruleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param BOMVariantRule - desc for BOMVariantRule parameter
     */
    BOMVariantRule( const BOMVariantRule& );
    BOMVariantRule& operator=( const BOMVariantRule& );

    friend class  BOMVariantRuleDelegate;
    friend class  BOMVariantRuleDispatch;
    friend class  BOMVariantRuleGenImpl;
};

#include <bom/libbom_undef.h>
#endif //   TEAMCENTER__BOMVARIANTRULE__HXX
