//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BOMWindowDelegate
    Filename:   BOMWindowDelegate.hxx
    Module:     bom
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOMWINDOWDELEGATE_HXX
#define TEAMCENTER__BOMWINDOWDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <bom/BOMWindow.hxx>

#include <bom/libbom_exports.h>

namespace Teamcenter
{
    class BOMWindowDelegate;
}
namespace Teamcenter
{
    class BOMWindowImpl;
}
namespace Teamcenter
{
    class BOMWindow;
}
namespace Teamcenter
{
    class BOMWindowGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  BOM_API Teamcenter_alias::BOMWindowDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the BOMWindowDelegate instance
    static BOMWindowDelegate&  getInstance();

    //  Method to create the BOMWindowImpl pointer
    static BOMWindowImpl*  createImpl( BOMWindow&  ifObj );

    //  Method to delete the BOMWindowImpl pointer
    static void deleteImpl( BOMWindowImpl*  impl );


    ///
    /// Getter for a ClosureRule Tag Property that indicates applied ClosureRule on the window.
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - always returns ITK_ok
    ///
    int  getFnd0appliedClosureRuleBase(const BOMWindow &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0bw_in_cv_cfg_to_load_mdBase(const BOMWindow &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0bw_in_markup_modeBase(const BOMWindow &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0bw_is_mono_modeBase(const BOMWindow &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0bwVariantRuleModeBase(const BOMWindow &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0IsOccTypeFilterAppliedBase(const BOMWindow &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ShareCountBase(const BOMWindow &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0show_gcs_cpsBase(const BOMWindow &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0show_uncnf_occ_effBase(const BOMWindow &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0bw_in_cv_cfg_to_load_mdBase(BOMWindow &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 8.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0bw_in_markup_modeBase(BOMWindow &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0bw_is_mono_modeBase(BOMWindow &ifObj,  bool value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0bwVariantRuleModeBase(BOMWindow &ifObj,  int value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0IsOccTypeFilterAppliedBase(BOMWindow &ifObj,  bool value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0ShareCountBase(BOMWindow &ifObj,  int value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0show_gcs_cpsBase(BOMWindow &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0show_uncnf_occ_effBase(BOMWindow &ifObj,  bool value, bool isNull );


    ///
    /// Business operation for the post expand action
    /// @version Teamcenter 10.1
    /// @param inputLines - input child lines
    /// @param unconfiguredLines - unconfigured child lines
    /// @return - Status
    ///
    int  fnd0PostExpandBase(const BOMWindow &ifObj,  const std::vector< tag_t > *inputLines, std::vector< tag_t > *unconfiguredLines );



protected:
    //  Pointer to the instance
    static BOMWindowDelegate*  m_pInstance;

    BOMWindowDelegate();
    virtual ~BOMWindowDelegate();
    static void setInstance( BOMWindowDelegate*  instance );


private:
    friend class  ::Teamcenter::BOMWindowGenImpl;

};

#include <bom/libbom_undef.h>
#endif  //  TEAMCENTER__BOMWINDOWDELEGATE_HXX
