//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CloneStructureCADDependencyData
    Filename:   CloneStructureCADDependencyData.hxx
    Module:     bom
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CLONESTRUCTURECADDEPENDENCYDATA__HXX
#define TEAMCENTER__CLONESTRUCTURECADDEPENDENCYDATA__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/OperationInput.hxx>

#include <bom/libbom_exports.h>

namespace Teamcenter
{
    class CloneStructureCADDependencyData;
}
namespace Teamcenter
{
    class CloneStructureCADDependencyDataImpl;
}
namespace Teamcenter
{
    class CloneStructureCADDependencyDataDelegate;
}
namespace Teamcenter
{
    class CloneStructureCADDependencyDataDispatch;
}
namespace Teamcenter
{
    class CloneStructureCADDependencyDataGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BOM_API  Teamcenter::CloneStructureCADDependencyData
     : public  ::Teamcenter::OperationInput
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CloneStructureCADDependencyData();

    /**
     * Destructor
     */
    virtual ~CloneStructureCADDependencyData();

private:
    //  Getter method for the Implementation Object
    CloneStructureCADDependencyDataImpl*  getCloneStructureCADDependencyDataImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCloneStructureCADDependencyDataImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CloneStructureCADDependencyDataImpl*  m_clonestructurecaddependencydataImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CloneStructureCADDependencyData - desc for CloneStructureCADDependencyData parameter
     */
    CloneStructureCADDependencyData( const CloneStructureCADDependencyData& );
    CloneStructureCADDependencyData& operator=( const CloneStructureCADDependencyData& );

    friend class  CloneStructureCADDependencyDataDelegate;
    friend class  CloneStructureCADDependencyDataDispatch;
    friend class  CloneStructureCADDependencyDataGenImpl;
};

#include <bom/libbom_undef.h>
#endif //   TEAMCENTER__CLONESTRUCTURECADDEPENDENCYDATA__HXX
