//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CloneStructureTopLineData
    Filename:   CloneStructureTopLineData.hxx
    Module:     bom
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CLONESTRUCTURETOPLINEDATA__HXX
#define TEAMCENTER__CLONESTRUCTURETOPLINEDATA__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/OperationInput.hxx>

#include <bom/libbom_exports.h>

namespace Teamcenter
{
    class CloneStructureTopLineData;
}
namespace Teamcenter
{
    class CloneStructureTopLineDataImpl;
}
namespace Teamcenter
{
    class CloneStructureTopLineDataDelegate;
}
namespace Teamcenter
{
    class CloneStructureTopLineDataDispatch;
}
namespace Teamcenter
{
    class CloneStructureTopLineDataGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BOM_API  Teamcenter::CloneStructureTopLineData
     : public  ::Teamcenter::OperationInput
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CloneStructureTopLineData();

    /**
     * Destructor
     */
    virtual ~CloneStructureTopLineData();

private:
    //  Getter method for the Implementation Object
    CloneStructureTopLineDataImpl*  getCloneStructureTopLineDataImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCloneStructureTopLineDataImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CloneStructureTopLineDataImpl*  m_clonestructuretoplinedataImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CloneStructureTopLineData - desc for CloneStructureTopLineData parameter
     */
    CloneStructureTopLineData( const CloneStructureTopLineData& );
    CloneStructureTopLineData& operator=( const CloneStructureTopLineData& );

    friend class  CloneStructureTopLineDataDelegate;
    friend class  CloneStructureTopLineDataDispatch;
    friend class  CloneStructureTopLineDataGenImpl;
};

#include <bom/libbom_undef.h>
#endif //   TEAMCENTER__CLONESTRUCTURETOPLINEDATA__HXX
