//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0AbstractProxyLine
    Filename:   Fnd0AbstractProxyLine.hxx
    Module:     bom
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0ABSTRACTPROXYLINE__HXX
#define TEAMCENTER__FND0ABSTRACTPROXYLINE__HXX

#include <common/tc_deprecation_macros.h>
#include <bom/BOMLine.hxx>

#include <bom/libbom_exports.h>

namespace Teamcenter
{
    class Fnd0AbstractProxyLine;
}
namespace Teamcenter
{
    class Fnd0AbstractProxyLineImpl;
}
namespace Teamcenter
{
    class Fnd0AbstractProxyLineDelegate;
}
namespace Teamcenter
{
    class Fnd0AbstractProxyLineDispatch;
}
namespace Teamcenter
{
    class Fnd0AbstractProxyLineGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BOM_API  Teamcenter::Fnd0AbstractProxyLine
     : public  ::Teamcenter::BOMLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0AbstractProxyLine();

    /**
     * Destructor
     */
    virtual ~Fnd0AbstractProxyLine();

private:
    //  Getter method for the Implementation Object
    Fnd0AbstractProxyLineImpl*  getFnd0AbstractProxyLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0AbstractProxyLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0AbstractProxyLineImpl*  m_fnd0abstractproxylineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0AbstractProxyLine - desc for Fnd0AbstractProxyLine parameter
     */
    Fnd0AbstractProxyLine( const Fnd0AbstractProxyLine& );
    Fnd0AbstractProxyLine& operator=( const Fnd0AbstractProxyLine& );

    friend class  Fnd0AbstractProxyLineDelegate;
    friend class  Fnd0AbstractProxyLineDispatch;
    friend class  Fnd0AbstractProxyLineGenImpl;
};

#include <bom/libbom_undef.h>
#endif //   TEAMCENTER__FND0ABSTRACTPROXYLINE__HXX
