//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0AbstractProxyLineDelegate
    Filename:   Fnd0AbstractProxyLineDelegate.hxx
    Module:     bom
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0ABSTRACTPROXYLINEDELEGATE_HXX
#define TEAMCENTER__FND0ABSTRACTPROXYLINEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <bom/Fnd0AbstractProxyLine.hxx>

#include <bom/libbom_exports.h>

namespace Teamcenter
{
    class Fnd0AbstractProxyLineDelegate;
}
namespace Teamcenter
{
    class Fnd0AbstractProxyLineImpl;
}
namespace Teamcenter
{
    class Fnd0AbstractProxyLine;
}
namespace Teamcenter
{
    class Fnd0AbstractProxyLineGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  BOM_API Teamcenter_alias::Fnd0AbstractProxyLineDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0AbstractProxyLineDelegate instance
    static Fnd0AbstractProxyLineDelegate&  getInstance();

    //  Method to delete the Fnd0AbstractProxyLineImpl pointer
    static void deleteImpl( Fnd0AbstractProxyLineImpl*  impl );


    ///
    /// Generates permanent ID/recipe. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param recipe - Permanent ID/recipe
    /// @return - Failure code.
    ///
    int  fnd0GenerateRecipeBase(const Fnd0AbstractProxyLine &ifObj,  std::string *recipe );



protected:
    //  Pointer to the instance
    static Fnd0AbstractProxyLineDelegate*  m_pInstance;

    Fnd0AbstractProxyLineDelegate();
    virtual ~Fnd0AbstractProxyLineDelegate();
    static void setInstance( Fnd0AbstractProxyLineDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0AbstractProxyLineGenImpl;

};

#include <bom/libbom_undef.h>
#endif  //  TEAMCENTER__FND0ABSTRACTPROXYLINEDELEGATE_HXX
