//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ProxyAlignedLine
    Filename:   Fnd0ProxyAlignedLine.hxx
    Module:     bom
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0PROXYALIGNEDLINE__HXX
#define TEAMCENTER__FND0PROXYALIGNEDLINE__HXX

#include <common/tc_deprecation_macros.h>
#include <bom/Fnd0AbstractProxyLine.hxx>

#include <bom/libbom_exports.h>

namespace Teamcenter
{
    class Fnd0ProxyAlignedLine;
}
namespace Teamcenter
{
    class Fnd0ProxyAlignedLineImpl;
}
namespace Teamcenter
{
    class Fnd0ProxyAlignedLineDelegate;
}
namespace Teamcenter
{
    class Fnd0ProxyAlignedLineDispatch;
}
namespace Teamcenter
{
    class Fnd0ProxyAlignedLineGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BOM_API  Teamcenter::Fnd0ProxyAlignedLine
     : public  ::Teamcenter::Fnd0AbstractProxyLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0ProxyAlignedLine();

    /**
     * Destructor
     */
    virtual ~Fnd0ProxyAlignedLine();

private:
    //  Getter method for the Implementation Object
    Fnd0ProxyAlignedLineImpl*  getFnd0ProxyAlignedLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0ProxyAlignedLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0ProxyAlignedLineImpl*  m_fnd0proxyalignedlineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0ProxyAlignedLine - desc for Fnd0ProxyAlignedLine parameter
     */
    Fnd0ProxyAlignedLine( const Fnd0ProxyAlignedLine& );
    Fnd0ProxyAlignedLine& operator=( const Fnd0ProxyAlignedLine& );

    friend class  Fnd0ProxyAlignedLineDelegate;
    friend class  Fnd0ProxyAlignedLineDispatch;
    friend class  Fnd0ProxyAlignedLineGenImpl;
};

#include <bom/libbom_undef.h>
#endif //   TEAMCENTER__FND0PROXYALIGNEDLINE__HXX
