//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, GDELine
    Filename:   GDELine.hxx
    Module:     bom
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__GDELINE__HXX
#define TEAMCENTER__GDELINE__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <bom/BOMLine.hxx>

#include <bom/libbom_exports.h>

namespace Teamcenter
{
    class GDELine;
}
namespace Teamcenter
{
    class GDELineImpl;
}
namespace Teamcenter
{
    class GDELineDelegate;
}
namespace Teamcenter
{
    class GDELineDispatch;
}
namespace Teamcenter
{
    class GDELineGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BOM_API  Teamcenter::GDELine
     : public  ::Teamcenter::BOMLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0_bl_direction( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0bl_gde_name( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0_bl_direction( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0bl_gde_name( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    GDELine();

    /**
     * Destructor
     */
    virtual ~GDELine();

private:
    //  Getter method for the Implementation Object
    GDELineImpl*  getGDELineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setGDELineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    GDELineImpl*  m_gdelineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param GDELine - desc for GDELine parameter
     */
    GDELine( const GDELine& );
    GDELine& operator=( const GDELine& );

    friend class  GDELineDelegate;
    friend class  GDELineDispatch;
    friend class  GDELineGenImpl;
};

#include <bom/libbom_undef.h>
#endif //   TEAMCENTER__GDELINE__HXX
