//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, GDELineDelegate
    Filename:   GDELineDelegate.hxx
    Module:     bom
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__GDELINEDELEGATE_HXX
#define TEAMCENTER__GDELINEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <bom/GDELine.hxx>

#include <bom/libbom_exports.h>

namespace Teamcenter
{
    class GDELineDelegate;
}
namespace Teamcenter
{
    class GDELineImpl;
}
namespace Teamcenter
{
    class GDELine;
}
namespace Teamcenter
{
    class GDELineGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  BOM_API Teamcenter_alias::GDELineDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the GDELineDelegate instance
    static GDELineDelegate&  getInstance();

    //  Method to create the GDELineImpl pointer
    static GDELineImpl*  createImpl( GDELine&  ifObj );

    //  Method to delete the GDELineImpl pointer
    static void deleteImpl( GDELineImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0_bl_directionBase(const GDELine &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0bl_gde_nameBase(const GDELine &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0_bl_directionBase(GDELine &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0bl_gde_nameBase(GDELine &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static GDELineDelegate*  m_pInstance;

    GDELineDelegate();
    virtual ~GDELineDelegate();
    static void setInstance( GDELineDelegate*  instance );


private:
    friend class  ::Teamcenter::GDELineGenImpl;

};

#include <bom/libbom_undef.h>
#endif  //  TEAMCENTER__GDELINEDELEGATE_HXX
