//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, GDELinkLine
    Filename:   GDELinkLine.hxx
    Module:     bom
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__GDELINKLINE__HXX
#define TEAMCENTER__GDELINKLINE__HXX

#include <common/tc_deprecation_macros.h>
#include <bom/GDELine.hxx>

#include <bom/libbom_exports.h>

namespace Teamcenter
{
    class GDELinkLine;
}
namespace Teamcenter
{
    class GDELinkLineImpl;
}
namespace Teamcenter
{
    class GDELinkLineDelegate;
}
namespace Teamcenter
{
    class GDELinkLineDispatch;
}
namespace Teamcenter
{
    class GDELinkLineGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BOM_API  Teamcenter::GDELinkLine
     : public  ::Teamcenter::GDELine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    GDELinkLine();

    /**
     * Destructor
     */
    virtual ~GDELinkLine();

private:
    //  Getter method for the Implementation Object
    GDELinkLineImpl*  getGDELinkLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setGDELinkLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    GDELinkLineImpl*  m_gdelinklineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param GDELinkLine - desc for GDELinkLine parameter
     */
    GDELinkLine( const GDELinkLine& );
    GDELinkLine& operator=( const GDELinkLine& );

    friend class  GDELinkLineDelegate;
    friend class  GDELinkLineDispatch;
    friend class  GDELinkLineGenImpl;
};

#include <bom/libbom_undef.h>
#endif //   TEAMCENTER__GDELINKLINE__HXX
