//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ImanItemLineDelegate
    Filename:   ImanItemLineDelegate.hxx
    Module:     bom
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IMANITEMLINEDELEGATE_HXX
#define TEAMCENTER__IMANITEMLINEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <bom/ImanItemLine.hxx>

#include <bom/libbom_exports.h>

namespace Teamcenter
{
    class ImanItemLineDelegate;
}
namespace Teamcenter
{
    class ImanItemLineImpl;
}
namespace Teamcenter
{
    class ImanItemLine;
}
namespace Teamcenter
{
    class ImanItemLineGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  BOM_API Teamcenter_alias::ImanItemLineDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ImanItemLineDelegate instance
    static ImanItemLineDelegate&  getInstance();

    //  Method to create the ImanItemLineImpl pointer
    static ImanItemLineImpl*  createImpl( ImanItemLine&  ifObj );

    //  Method to delete the ImanItemLineImpl pointer
    static void deleteImpl( ImanItemLineImpl*  impl );


    ///
    /// Add a substitute
    /// @version Teamcenter 13.1
    /// @param itemOrRevision - Tag of the Item or item revision to add as substitute
    /// @param bomView - Tag of the BOM View to add as substitute
    /// @param newLine - Tag of the new substitute ImanItemLine
    /// @return - 
    ///
    int  fnd0AddSubstituteBase(const ImanItemLine &ifObj,  tag_t itemOrRevision, tag_t bomView, tag_t *newLine );


    ///
    /// The Operation returns configured revision tag based on the custom configuration user has implemented.
    /// @version Teamcenter 9
    /// @param occthread_tag - Occurrenece Thread Tag
    /// @param item_tag - Item Tag
    /// @param bvr_tag - BVR Tag
    /// @param itmrev_tag - Item Revision Tag
    /// @deprecated #Teamcenter::ImanItemLine::fnd0getCustomConfiguredIrf deprecated in Teamcenter 9.1
    /// @return - Returns Tag of configured Item Revision.
    ///
    TC_DEPRECATED_WITH_DEPRECATION_INFO("Teamcenter 9.1","Teamcenter::ImanItemLine::fnd0getCustomConfiguredIrf","need to modify parameters")
    int  fnd0getCustomConfiguredIrfBase(const ImanItemLine &ifObj,  const tag_t &occthread_tag, const tag_t &item_tag, const tag_t &bvr_tag, tag_t *itmrev_tag );


    ///
    /// The Operation returns configured revision tag based on the custom configuration user has implemented.
    /// @version Teamcenter 9.1
    /// @param bomLineTag - BOMLine Tag
    /// @param itemRevTag - Item Revision Tag
    /// @return - Returns Tag of configured Item Revision.
    ///
    int  fnd0getCustomConfiguredIrfBase(const ImanItemLine &ifObj,  const tag_t *bomLineTag, tag_t *itemRevTag );


    ///
    /// Prefer a substitute
    /// @version Teamcenter 13.1
    /// @param isTemporary - True if the parent BVR cannot be modified
    /// @return - 
    ///
    int  fnd0PreferSubstituteBase(const ImanItemLine &ifObj,  bool *isTemporary );



protected:
    //  Pointer to the instance
    static ImanItemLineDelegate*  m_pInstance;

    ImanItemLineDelegate();
    virtual ~ImanItemLineDelegate();
    static void setInstance( ImanItemLineDelegate*  instance );


private:
    friend class  ::Teamcenter::ImanItemLineGenImpl;

};

#include <bom/libbom_undef.h>
#endif  //  TEAMCENTER__IMANITEMLINEDELEGATE_HXX
