//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Snapshot
    Filename:   Snapshot.hxx
    Module:     bom
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SNAPSHOT__HXX
#define TEAMCENTER__SNAPSHOT__HXX

#include <common/tc_deprecation_macros.h>
#include <tc/Folder.hxx>

#include <bom/libbom_exports.h>

namespace Teamcenter
{
    class Snapshot;
}
namespace Teamcenter
{
    class SnapshotImpl;
}
namespace Teamcenter
{
    class SnapshotDelegate;
}
namespace Teamcenter
{
    class SnapshotDispatch;
}
namespace Teamcenter
{
    class SnapshotGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BOM_API  Teamcenter::Snapshot
     : public  ::Teamcenter::Folder
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Snapshot();

    /**
     * Destructor
     */
    virtual ~Snapshot();

private:
    //  Getter method for the Implementation Object
    SnapshotImpl*  getSnapshotImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSnapshotImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SnapshotImpl*  m_snapshotImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Snapshot - desc for Snapshot parameter
     */
    Snapshot( const Snapshot& );
    Snapshot& operator=( const Snapshot& );

    friend class  SnapshotDelegate;
    friend class  SnapshotDispatch;
    friend class  SnapshotGenImpl;
};

#include <bom/libbom_undef.h>
#endif //   TEAMCENTER__SNAPSHOT__HXX
