//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  bom

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libbom

#if !defined(LIBBOM) && !defined(IPLIB)
#   error IPLIB or LIBBOM is not defined
#endif

/* Handwritten code should use BOM_API, not BOMEXPORT */

#define BOM_API BOMEXPORT

#if IPLIB==libbom || defined(LIBBOM)
#   if defined(__lint)
#       define BOMEXPORT       __export(bom)
#       define BOMGLOBAL       extern __global(bom)
#       define BOMPRIVATE      extern __private(bom)
#   elif defined(_WIN32)
#       define BOMEXPORT       __declspec(dllexport)
#       define BOMGLOBAL       extern __declspec(dllexport)
#       define BOMPRIVATE      extern
#   else
#       define BOMEXPORT
#       define BOMGLOBAL       extern
#       define BOMPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define BOMEXPORT       __export(bom)
#       define BOMGLOBAL       extern __global(bom)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define BOMEXPORT      __declspec(dllimport)
#       define BOMGLOBAL       extern __declspec(dllimport)
#   else
#       define BOMEXPORT
#       define BOMGLOBAL       extern
#   endif
#endif
