//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPBrandAssetRevisionDelegate
    Filename:   CPBrandAssetRevisionDelegate.hxx
    Module:     brndmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BRNDMGMT__CPBRANDASSETREVISIONDELEGATE_HXX
#define TEAMCENTER__BRNDMGMT__CPBRANDASSETREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <brndmgmt/CPBrandAssetRevision.hxx>

#include <brndmgmt/libbrndmgmt_exports.h>

namespace Teamcenter
{
    namespace BRNDMGMT
    {
        class CPBrandAssetRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace BRNDMGMT
    {
        class CPBrandAssetRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace BRNDMGMT
    {
        class CPBrandAssetRevision;
    }
}
namespace Teamcenter
{
    namespace BRNDMGMT
    {
        class CPBrandAssetRevisionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  BRNDMGMT_API Teamcenter_alias::BRNDMGMT::CPBrandAssetRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CPBrandAssetRevisionDelegate instance
    static CPBrandAssetRevisionDelegate&  getInstance();

    //  Method to create the CPBrandAssetRevisionImpl pointer
    static CPBrandAssetRevisionImpl*  createImpl( CPBrandAssetRevision&  ifObj );

    //  Method to delete the CPBrandAssetRevisionImpl pointer
    static void deleteImpl( CPBrandAssetRevisionImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAsset_typeBase(const CPBrandAssetRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBrand_categoryBase(const CPBrandAssetRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getBrm0CP_artworksBase(const CPBrandAssetRevision &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getBrm0CP_copyBase(const CPBrandAssetRevision &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getBrm0CP_copy_elementsBase(const CPBrandAssetRevision &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getBrm0CP_graphic_elementsBase(const CPBrandAssetRevision &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getClassificationBase(const CPBrandAssetRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCP_brand_equitiesBase(const CPBrandAssetRevision &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getInternal_competitorBase(const CPBrandAssetRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getUsageBase(const CPBrandAssetRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAsset_typeBase(CPBrandAssetRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setBrand_categoryBase(CPBrandAssetRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setClassificationBase(CPBrandAssetRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setInternal_competitorBase(CPBrandAssetRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setUsageBase(CPBrandAssetRevision &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static CPBrandAssetRevisionDelegate*  m_pInstance;

    CPBrandAssetRevisionDelegate();
    virtual ~CPBrandAssetRevisionDelegate();
    static void setInstance( CPBrandAssetRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::BRNDMGMT::CPBrandAssetRevisionGenImpl;

};

#include <brndmgmt/libbrndmgmt_undef.h>
#endif  //  TEAMCENTER__BRNDMGMT__CPBRANDASSETREVISIONDELEGATE_HXX
