//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPBrandEquity
    Filename:   CPBrandEquity.hxx
    Module:     brndmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BRNDMGMT__CPBRANDEQUITY__HXX
#define TEAMCENTER__BRNDMGMT__CPBRANDEQUITY__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <brndmgmt/libbrndmgmt_exports.h>

namespace Teamcenter
{
    namespace BRNDMGMT
    {
        class CPBrandEquity;
    }
}
namespace Teamcenter
{
    namespace BRNDMGMT
    {
        class CPBrandEquityImpl;
    }
}
namespace Teamcenter
{
    namespace BRNDMGMT
    {
        class CPBrandEquityDelegate;
    }
}
namespace Teamcenter
{
    namespace BRNDMGMT
    {
        class CPBrandEquityDispatch;
    }
}
namespace Teamcenter
{
    namespace BRNDMGMT
    {
        class CPBrandEquityGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BRNDMGMT_API  Teamcenter::BRNDMGMT::CPBrandEquity
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBrand_category( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBrand_type( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setBrand_category( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setBrand_type( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CPBrandEquity();

    /**
     * Destructor
     */
    virtual ~CPBrandEquity();

private:
    //  Getter method for the Implementation Object
    CPBrandEquityImpl*  getCPBrandEquityImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCPBrandEquityImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CPBrandEquityImpl*  m_cpbrandequityImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CPBrandEquity - desc for CPBrandEquity parameter
     */
    CPBrandEquity( const CPBrandEquity& );
    CPBrandEquity& operator=( const CPBrandEquity& );

    friend class  CPBrandEquityDelegate;
    friend class  CPBrandEquityDispatch;
    friend class  CPBrandEquityGenImpl;
};

#include <brndmgmt/libbrndmgmt_undef.h>
#endif //   TEAMCENTER__BRNDMGMT__CPBRANDEQUITY__HXX
