//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPBrandEquityDelegate
    Filename:   CPBrandEquityDelegate.hxx
    Module:     brndmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BRNDMGMT__CPBRANDEQUITYDELEGATE_HXX
#define TEAMCENTER__BRNDMGMT__CPBRANDEQUITYDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <brndmgmt/CPBrandEquity.hxx>

#include <brndmgmt/libbrndmgmt_exports.h>

namespace Teamcenter
{
    namespace BRNDMGMT
    {
        class CPBrandEquityDelegate;
    }
}
namespace Teamcenter
{
    namespace BRNDMGMT
    {
        class CPBrandEquityImpl;
    }
}
namespace Teamcenter
{
    namespace BRNDMGMT
    {
        class CPBrandEquity;
    }
}
namespace Teamcenter
{
    namespace BRNDMGMT
    {
        class CPBrandEquityGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  BRNDMGMT_API Teamcenter_alias::BRNDMGMT::CPBrandEquityDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CPBrandEquityDelegate instance
    static CPBrandEquityDelegate&  getInstance();

    //  Method to create the CPBrandEquityImpl pointer
    static CPBrandEquityImpl*  createImpl( CPBrandEquity&  ifObj );

    //  Method to delete the CPBrandEquityImpl pointer
    static void deleteImpl( CPBrandEquityImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBrand_categoryBase(const CPBrandEquity &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBrand_typeBase(const CPBrandEquity &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setBrand_categoryBase(CPBrandEquity &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setBrand_typeBase(CPBrandEquity &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static CPBrandEquityDelegate*  m_pInstance;

    CPBrandEquityDelegate();
    virtual ~CPBrandEquityDelegate();
    static void setInstance( CPBrandEquityDelegate*  instance );


private:
    friend class  ::Teamcenter::BRNDMGMT::CPBrandEquityGenImpl;

};

#include <brndmgmt/libbrndmgmt_undef.h>
#endif  //  TEAMCENTER__BRNDMGMT__CPBRANDEQUITYDELEGATE_HXX
