//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPBrandEquityRevision
    Filename:   CPBrandEquityRevision.hxx
    Module:     brndmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BRNDMGMT__CPBRANDEQUITYREVISION__HXX
#define TEAMCENTER__BRNDMGMT__CPBRANDEQUITYREVISION__HXX

#include <string>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <brndmgmt/libbrndmgmt_exports.h>

namespace Teamcenter
{
    namespace BRNDMGMT
    {
        class CPBrandEquityRevision;
    }
}
namespace Teamcenter
{
    namespace BRNDMGMT
    {
        class CPBrandEquityRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace BRNDMGMT
    {
        class CPBrandEquityRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace BRNDMGMT
    {
        class CPBrandEquityRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace BRNDMGMT
    {
        class CPBrandEquityRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  BRNDMGMT_API  Teamcenter::BRNDMGMT::CPBrandEquityRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getChannel( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCompany( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCP_theme_boards( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getInternal_competitor( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getScope( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getTarget_market( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValue_proposition( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setChannel( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCompany( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setInternal_competitor( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setScope( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setTarget_market( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValue_proposition( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CPBrandEquityRevision();

    /**
     * Destructor
     */
    virtual ~CPBrandEquityRevision();

private:
    //  Getter method for the Implementation Object
    CPBrandEquityRevisionImpl*  getCPBrandEquityRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCPBrandEquityRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CPBrandEquityRevisionImpl*  m_cpbrandequityrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CPBrandEquityRevision - desc for CPBrandEquityRevision parameter
     */
    CPBrandEquityRevision( const CPBrandEquityRevision& );
    CPBrandEquityRevision& operator=( const CPBrandEquityRevision& );

    friend class  CPBrandEquityRevisionDelegate;
    friend class  CPBrandEquityRevisionDispatch;
    friend class  CPBrandEquityRevisionGenImpl;
};

#include <brndmgmt/libbrndmgmt_undef.h>
#endif //   TEAMCENTER__BRNDMGMT__CPBRANDEQUITYREVISION__HXX
