//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPBrandEquityRevisionDelegate
    Filename:   CPBrandEquityRevisionDelegate.hxx
    Module:     brndmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BRNDMGMT__CPBRANDEQUITYREVISIONDELEGATE_HXX
#define TEAMCENTER__BRNDMGMT__CPBRANDEQUITYREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <brndmgmt/CPBrandEquityRevision.hxx>

#include <brndmgmt/libbrndmgmt_exports.h>

namespace Teamcenter
{
    namespace BRNDMGMT
    {
        class CPBrandEquityRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace BRNDMGMT
    {
        class CPBrandEquityRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace BRNDMGMT
    {
        class CPBrandEquityRevision;
    }
}
namespace Teamcenter
{
    namespace BRNDMGMT
    {
        class CPBrandEquityRevisionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  BRNDMGMT_API Teamcenter_alias::BRNDMGMT::CPBrandEquityRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CPBrandEquityRevisionDelegate instance
    static CPBrandEquityRevisionDelegate&  getInstance();

    //  Method to create the CPBrandEquityRevisionImpl pointer
    static CPBrandEquityRevisionImpl*  createImpl( CPBrandEquityRevision&  ifObj );

    //  Method to delete the CPBrandEquityRevisionImpl pointer
    static void deleteImpl( CPBrandEquityRevisionImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getChannelBase(const CPBrandEquityRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCompanyBase(const CPBrandEquityRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCP_theme_boardsBase(const CPBrandEquityRevision &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getInternal_competitorBase(const CPBrandEquityRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getScopeBase(const CPBrandEquityRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getTarget_marketBase(const CPBrandEquityRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValue_propositionBase(const CPBrandEquityRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setChannelBase(CPBrandEquityRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCompanyBase(CPBrandEquityRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setInternal_competitorBase(CPBrandEquityRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setScopeBase(CPBrandEquityRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setTarget_marketBase(CPBrandEquityRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValue_propositionBase(CPBrandEquityRevision &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static CPBrandEquityRevisionDelegate*  m_pInstance;

    CPBrandEquityRevisionDelegate();
    virtual ~CPBrandEquityRevisionDelegate();
    static void setInstance( CPBrandEquityRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::BRNDMGMT::CPBrandEquityRevisionGenImpl;

};

#include <brndmgmt/libbrndmgmt_undef.h>
#endif  //  TEAMCENTER__BRNDMGMT__CPBRANDEQUITYREVISIONDELEGATE_HXX
