//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  brndmgmt

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libbrndmgmt

#if !defined(LIBBRNDMGMT) && !defined(IPLIB)
#   error IPLIB or LIBBRNDMGMT is not defined
#endif

/* Handwritten code should use BRNDMGMT_API, not BRNDMGMTEXPORT */

#define BRNDMGMT_API BRNDMGMTEXPORT

#if IPLIB==libbrndmgmt || defined(LIBBRNDMGMT)
#   if defined(__lint)
#       define BRNDMGMTEXPORT       __export(brndmgmt)
#       define BRNDMGMTGLOBAL       extern __global(brndmgmt)
#       define BRNDMGMTPRIVATE      extern __private(brndmgmt)
#   elif defined(_WIN32)
#       define BRNDMGMTEXPORT       __declspec(dllexport)
#       define BRNDMGMTGLOBAL       extern __declspec(dllexport)
#       define BRNDMGMTPRIVATE      extern
#   else
#       define BRNDMGMTEXPORT
#       define BRNDMGMTGLOBAL       extern
#       define BRNDMGMTPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define BRNDMGMTEXPORT       __export(brndmgmt)
#       define BRNDMGMTGLOBAL       extern __global(brndmgmt)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define BRNDMGMTEXPORT      __declspec(dllimport)
#       define BRNDMGMTGLOBAL       extern __declspec(dllimport)
#   else
#       define BRNDMGMTEXPORT
#       define BRNDMGMTGLOBAL       extern
#   endif
#endif
