//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  brndmgmtdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libbrndmgmtdispatch

#if !defined(LIBBRNDMGMTDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBBRNDMGMTDISPATCH is not defined
#endif

/* Handwritten code should use BRNDMGMTDISPATCH_API, not BRNDMGMTDISPATCHEXPORT */

#define BRNDMGMTDISPATCH_API BRNDMGMTDISPATCHEXPORT

#if IPLIB==libbrndmgmtdispatch || defined(LIBBRNDMGMTDISPATCH)
#   if defined(__lint)
#       define BRNDMGMTDISPATCHEXPORT       __export(brndmgmtdispatch)
#       define BRNDMGMTDISPATCHGLOBAL       extern __global(brndmgmtdispatch)
#       define BRNDMGMTDISPATCHPRIVATE      extern __private(brndmgmtdispatch)
#   elif defined(_WIN32)
#       define BRNDMGMTDISPATCHEXPORT       __declspec(dllexport)
#       define BRNDMGMTDISPATCHGLOBAL       extern __declspec(dllexport)
#       define BRNDMGMTDISPATCHPRIVATE      extern
#   else
#       define BRNDMGMTDISPATCHEXPORT
#       define BRNDMGMTDISPATCHGLOBAL       extern
#       define BRNDMGMTDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define BRNDMGMTDISPATCHEXPORT       __export(brndmgmtdispatch)
#       define BRNDMGMTDISPATCHGLOBAL       extern __global(brndmgmtdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define BRNDMGMTDISPATCHEXPORT      __declspec(dllimport)
#       define BRNDMGMTDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define BRNDMGMTDISPATCHEXPORT
#       define BRNDMGMTDISPATCHGLOBAL       extern
#   endif
#endif
