//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAEAnalysis
    Filename:   CAEAnalysis.hxx
    Module:     cae
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CAEANALYSIS__HXX
#define TEAMCENTER__CAEANALYSIS__HXX

#include <common/tc_deprecation_macros.h>
#include <cae/CAEItem.hxx>

#include <cae/libcae_exports.h>

namespace Teamcenter
{
    class CAEAnalysis;
}
namespace Teamcenter
{
    class CAEAnalysisImpl;
}
namespace Teamcenter
{
    class CAEAnalysisDelegate;
}
namespace Teamcenter
{
    class CAEAnalysisDispatch;
}
namespace Teamcenter
{
    class CAEAnalysisGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CAE_API  Teamcenter::CAEAnalysis
     : public  ::Teamcenter::CAEItem
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CAEAnalysis();

    /**
     * Destructor
     */
    virtual ~CAEAnalysis();

private:
    //  Getter method for the Implementation Object
    CAEAnalysisImpl*  getCAEAnalysisImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCAEAnalysisImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CAEAnalysisImpl*  m_caeanalysisImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CAEAnalysis - desc for CAEAnalysis parameter
     */
    CAEAnalysis( const CAEAnalysis& );
    CAEAnalysis& operator=( const CAEAnalysis& );

    friend class  CAEAnalysisDelegate;
    friend class  CAEAnalysisDispatch;
    friend class  CAEAnalysisGenImpl;
};

#include <cae/libcae_undef.h>
#endif //   TEAMCENTER__CAEANALYSIS__HXX
