//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAEAnalysisDelegate
    Filename:   CAEAnalysisDelegate.hxx
    Module:     cae
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CAEANALYSISDELEGATE_HXX
#define TEAMCENTER__CAEANALYSISDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cae/CAEAnalysis.hxx>

#include <cae/libcae_exports.h>

namespace Teamcenter
{
    class CAEAnalysisDelegate;
}
namespace Teamcenter
{
    class CAEAnalysisImpl;
}
namespace Teamcenter
{
    class CAEAnalysis;
}
namespace Teamcenter
{
    class CAEAnalysisGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CAE_API Teamcenter_alias::CAEAnalysisDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CAEAnalysisDelegate instance
    static CAEAnalysisDelegate&  getInstance();

    //  Method to create the CAEAnalysisImpl pointer
    static CAEAnalysisImpl*  createImpl( CAEAnalysis&  ifObj );

    //  Method to delete the CAEAnalysisImpl pointer
    static void deleteImpl( CAEAnalysisImpl*  impl );



protected:
    //  Pointer to the instance
    static CAEAnalysisDelegate*  m_pInstance;

    CAEAnalysisDelegate();
    virtual ~CAEAnalysisDelegate();
    static void setInstance( CAEAnalysisDelegate*  instance );


private:
    friend class  ::Teamcenter::CAEAnalysisGenImpl;

};

#include <cae/libcae_undef.h>
#endif  //  TEAMCENTER__CAEANALYSISDELEGATE_HXX
