//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAEAnalysisRevision
    Filename:   CAEAnalysisRevision.hxx
    Module:     cae
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CAEANALYSISREVISION__HXX
#define TEAMCENTER__CAEANALYSISREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <cae/CAEItemRevision.hxx>

#include <cae/libcae_exports.h>

namespace Teamcenter
{
    class CAEAnalysisRevision;
}
namespace Teamcenter
{
    class CAEAnalysisRevisionImpl;
}
namespace Teamcenter
{
    class CAEAnalysisRevisionDelegate;
}
namespace Teamcenter
{
    class CAEAnalysisRevisionDispatch;
}
namespace Teamcenter
{
    class CAEAnalysisRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CAE_API  Teamcenter::CAEAnalysisRevision
     : public  ::Teamcenter::CAEItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CAEAnalysisRevision();

    /**
     * Destructor
     */
    virtual ~CAEAnalysisRevision();

private:
    //  Getter method for the Implementation Object
    CAEAnalysisRevisionImpl*  getCAEAnalysisRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCAEAnalysisRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CAEAnalysisRevisionImpl*  m_caeanalysisrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CAEAnalysisRevision - desc for CAEAnalysisRevision parameter
     */
    CAEAnalysisRevision( const CAEAnalysisRevision& );
    CAEAnalysisRevision& operator=( const CAEAnalysisRevision& );

    friend class  CAEAnalysisRevisionDelegate;
    friend class  CAEAnalysisRevisionDispatch;
    friend class  CAEAnalysisRevisionGenImpl;
};

#include <cae/libcae_undef.h>
#endif //   TEAMCENTER__CAEANALYSISREVISION__HXX
