//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAEAttachmentWindow
    Filename:   CAEAttachmentWindow.hxx
    Module:     cae
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CAEATTACHMENTWINDOW__HXX
#define TEAMCENTER__CAEATTACHMENTWINDOW__HXX

#include <common/tc_deprecation_macros.h>
#include <me/CfgAttachmentWindow.hxx>

#include <cae/libcae_exports.h>

namespace Teamcenter
{
    class CAEAttachmentWindow;
}
namespace Teamcenter
{
    class CAEAttachmentWindowImpl;
}
namespace Teamcenter
{
    class CAEAttachmentWindowDelegate;
}
namespace Teamcenter
{
    class CAEAttachmentWindowDispatch;
}
namespace Teamcenter
{
    class CAEAttachmentWindowGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CAE_API  Teamcenter::CAEAttachmentWindow
     : public  ::Teamcenter::CfgAttachmentWindow
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CAEAttachmentWindow();

    /**
     * Destructor
     */
    virtual ~CAEAttachmentWindow();

private:
    //  Getter method for the Implementation Object
    CAEAttachmentWindowImpl*  getCAEAttachmentWindowImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCAEAttachmentWindowImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CAEAttachmentWindowImpl*  m_caeattachmentwindowImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CAEAttachmentWindow - desc for CAEAttachmentWindow parameter
     */
    CAEAttachmentWindow( const CAEAttachmentWindow& );
    CAEAttachmentWindow& operator=( const CAEAttachmentWindow& );

    friend class  CAEAttachmentWindowDelegate;
    friend class  CAEAttachmentWindowDispatch;
    friend class  CAEAttachmentWindowGenImpl;
};

#include <cae/libcae_undef.h>
#endif //   TEAMCENTER__CAEATTACHMENTWINDOW__HXX
