//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAEBCItem
    Filename:   CAEBCItem.hxx
    Module:     cae
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CAEBCITEM__HXX
#define TEAMCENTER__CAEBCITEM__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <cae/libcae_exports.h>

namespace Teamcenter
{
    class CAEBCItem;
}
namespace Teamcenter
{
    class CAEBCItemImpl;
}
namespace Teamcenter
{
    class CAEBCItemDelegate;
}
namespace Teamcenter
{
    class CAEBCItemDispatch;
}
namespace Teamcenter
{
    class CAEBCItemGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CAE_API  Teamcenter::CAEBCItem
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CAEBCItem();

    /**
     * Destructor
     */
    virtual ~CAEBCItem();

private:
    //  Getter method for the Implementation Object
    CAEBCItemImpl*  getCAEBCItemImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCAEBCItemImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CAEBCItemImpl*  m_caebcitemImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CAEBCItem - desc for CAEBCItem parameter
     */
    CAEBCItem( const CAEBCItem& );
    CAEBCItem& operator=( const CAEBCItem& );

    friend class  CAEBCItemDelegate;
    friend class  CAEBCItemDispatch;
    friend class  CAEBCItemGenImpl;
};

#include <cae/libcae_undef.h>
#endif //   TEAMCENTER__CAEBCITEM__HXX
