//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAEBCItemRevision
    Filename:   CAEBCItemRevision.hxx
    Module:     cae
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CAEBCITEMREVISION__HXX
#define TEAMCENTER__CAEBCITEMREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <cae/libcae_exports.h>

namespace Teamcenter
{
    class CAEBCItemRevision;
}
namespace Teamcenter
{
    class CAEBCItemRevisionImpl;
}
namespace Teamcenter
{
    class CAEBCItemRevisionDelegate;
}
namespace Teamcenter
{
    class CAEBCItemRevisionDispatch;
}
namespace Teamcenter
{
    class CAEBCItemRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CAE_API  Teamcenter::CAEBCItemRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CAEBCItemRevision();

    /**
     * Destructor
     */
    virtual ~CAEBCItemRevision();

private:
    //  Getter method for the Implementation Object
    CAEBCItemRevisionImpl*  getCAEBCItemRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCAEBCItemRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CAEBCItemRevisionImpl*  m_caebcitemrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CAEBCItemRevision - desc for CAEBCItemRevision parameter
     */
    CAEBCItemRevision( const CAEBCItemRevision& );
    CAEBCItemRevision& operator=( const CAEBCItemRevision& );

    friend class  CAEBCItemRevisionDelegate;
    friend class  CAEBCItemRevisionDispatch;
    friend class  CAEBCItemRevisionGenImpl;
};

#include <cae/libcae_undef.h>
#endif //   TEAMCENTER__CAEBCITEMREVISION__HXX
