//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAEBCItemRevisionDelegate
    Filename:   CAEBCItemRevisionDelegate.hxx
    Module:     cae
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CAEBCITEMREVISIONDELEGATE_HXX
#define TEAMCENTER__CAEBCITEMREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cae/CAEBCItemRevision.hxx>

#include <cae/libcae_exports.h>

namespace Teamcenter
{
    class CAEBCItemRevisionDelegate;
}
namespace Teamcenter
{
    class CAEBCItemRevisionImpl;
}
namespace Teamcenter
{
    class CAEBCItemRevision;
}
namespace Teamcenter
{
    class CAEBCItemRevisionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CAE_API Teamcenter_alias::CAEBCItemRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CAEBCItemRevisionDelegate instance
    static CAEBCItemRevisionDelegate&  getInstance();

    //  Method to create the CAEBCItemRevisionImpl pointer
    static CAEBCItemRevisionImpl*  createImpl( CAEBCItemRevision&  ifObj );

    //  Method to delete the CAEBCItemRevisionImpl pointer
    static void deleteImpl( CAEBCItemRevisionImpl*  impl );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const CAEBCItemRevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const CAEBCItemRevision &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static CAEBCItemRevisionDelegate*  m_pInstance;

    CAEBCItemRevisionDelegate();
    virtual ~CAEBCItemRevisionDelegate();
    static void setInstance( CAEBCItemRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::CAEBCItemRevisionGenImpl;

};

#include <cae/libcae_undef.h>
#endif  //  TEAMCENTER__CAEBCITEMREVISIONDELEGATE_HXX
