//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAEConnItemRevision
    Filename:   CAEConnItemRevision.hxx
    Module:     cae
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CAECONNITEMREVISION__HXX
#define TEAMCENTER__CAECONNITEMREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <cae/libcae_exports.h>

namespace Teamcenter
{
    class CAEConnItemRevision;
}
namespace Teamcenter
{
    class CAEConnItemRevisionImpl;
}
namespace Teamcenter
{
    class CAEConnItemRevisionDelegate;
}
namespace Teamcenter
{
    class CAEConnItemRevisionDispatch;
}
namespace Teamcenter
{
    class CAEConnItemRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CAE_API  Teamcenter::CAEConnItemRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CAEConnItemRevision();

    /**
     * Destructor
     */
    virtual ~CAEConnItemRevision();

private:
    //  Getter method for the Implementation Object
    CAEConnItemRevisionImpl*  getCAEConnItemRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCAEConnItemRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CAEConnItemRevisionImpl*  m_caeconnitemrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CAEConnItemRevision - desc for CAEConnItemRevision parameter
     */
    CAEConnItemRevision( const CAEConnItemRevision& );
    CAEConnItemRevision& operator=( const CAEConnItemRevision& );

    friend class  CAEConnItemRevisionDelegate;
    friend class  CAEConnItemRevisionDispatch;
    friend class  CAEConnItemRevisionGenImpl;
};

#include <cae/libcae_undef.h>
#endif //   TEAMCENTER__CAECONNITEMREVISION__HXX
