//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAEConnItemRevisionDelegate
    Filename:   CAEConnItemRevisionDelegate.hxx
    Module:     cae
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CAECONNITEMREVISIONDELEGATE_HXX
#define TEAMCENTER__CAECONNITEMREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cae/CAEConnItemRevision.hxx>

#include <cae/libcae_exports.h>

namespace Teamcenter
{
    class CAEConnItemRevisionDelegate;
}
namespace Teamcenter
{
    class CAEConnItemRevisionImpl;
}
namespace Teamcenter
{
    class CAEConnItemRevision;
}
namespace Teamcenter
{
    class CAEConnItemRevisionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CAE_API Teamcenter_alias::CAEConnItemRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CAEConnItemRevisionDelegate instance
    static CAEConnItemRevisionDelegate&  getInstance();

    //  Method to create the CAEConnItemRevisionImpl pointer
    static CAEConnItemRevisionImpl*  createImpl( CAEConnItemRevision&  ifObj );

    //  Method to delete the CAEConnItemRevisionImpl pointer
    static void deleteImpl( CAEConnItemRevisionImpl*  impl );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const CAEConnItemRevision &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static CAEConnItemRevisionDelegate*  m_pInstance;

    CAEConnItemRevisionDelegate();
    virtual ~CAEConnItemRevisionDelegate();
    static void setInstance( CAEConnItemRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::CAEConnItemRevisionGenImpl;

};

#include <cae/libcae_undef.h>
#endif  //  TEAMCENTER__CAECONNITEMREVISIONDELEGATE_HXX
