//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAEGeometry
    Filename:   CAEGeometry.hxx
    Module:     cae
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CAEGEOMETRY__HXX
#define TEAMCENTER__CAEGEOMETRY__HXX

#include <common/tc_deprecation_macros.h>
#include <cae/CAEItem.hxx>

#include <cae/libcae_exports.h>

namespace Teamcenter
{
    class CAEGeometry;
}
namespace Teamcenter
{
    class CAEGeometryImpl;
}
namespace Teamcenter
{
    class CAEGeometryDelegate;
}
namespace Teamcenter
{
    class CAEGeometryDispatch;
}
namespace Teamcenter
{
    class CAEGeometryGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CAE_API  Teamcenter::CAEGeometry
     : public  ::Teamcenter::CAEItem
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CAEGeometry();

    /**
     * Destructor
     */
    virtual ~CAEGeometry();

private:
    //  Getter method for the Implementation Object
    CAEGeometryImpl*  getCAEGeometryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCAEGeometryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CAEGeometryImpl*  m_caegeometryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CAEGeometry - desc for CAEGeometry parameter
     */
    CAEGeometry( const CAEGeometry& );
    CAEGeometry& operator=( const CAEGeometry& );

    friend class  CAEGeometryDelegate;
    friend class  CAEGeometryDispatch;
    friend class  CAEGeometryGenImpl;
};

#include <cae/libcae_undef.h>
#endif //   TEAMCENTER__CAEGEOMETRY__HXX
