//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAEGeometryDelegate
    Filename:   CAEGeometryDelegate.hxx
    Module:     cae
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CAEGEOMETRYDELEGATE_HXX
#define TEAMCENTER__CAEGEOMETRYDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cae/CAEGeometry.hxx>

#include <cae/libcae_exports.h>

namespace Teamcenter
{
    class CAEGeometryDelegate;
}
namespace Teamcenter
{
    class CAEGeometryImpl;
}
namespace Teamcenter
{
    class CAEGeometry;
}
namespace Teamcenter
{
    class CAEGeometryGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CAE_API Teamcenter_alias::CAEGeometryDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CAEGeometryDelegate instance
    static CAEGeometryDelegate&  getInstance();

    //  Method to create the CAEGeometryImpl pointer
    static CAEGeometryImpl*  createImpl( CAEGeometry&  ifObj );

    //  Method to delete the CAEGeometryImpl pointer
    static void deleteImpl( CAEGeometryImpl*  impl );



protected:
    //  Pointer to the instance
    static CAEGeometryDelegate*  m_pInstance;

    CAEGeometryDelegate();
    virtual ~CAEGeometryDelegate();
    static void setInstance( CAEGeometryDelegate*  instance );


private:
    friend class  ::Teamcenter::CAEGeometryGenImpl;

};

#include <cae/libcae_undef.h>
#endif  //  TEAMCENTER__CAEGEOMETRYDELEGATE_HXX
