//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAEGeometryRevision
    Filename:   CAEGeometryRevision.hxx
    Module:     cae
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CAEGEOMETRYREVISION__HXX
#define TEAMCENTER__CAEGEOMETRYREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <cae/CAEItemRevision.hxx>

#include <cae/libcae_exports.h>

namespace Teamcenter
{
    class CAEGeometryRevision;
}
namespace Teamcenter
{
    class CAEGeometryRevisionImpl;
}
namespace Teamcenter
{
    class CAEGeometryRevisionDelegate;
}
namespace Teamcenter
{
    class CAEGeometryRevisionDispatch;
}
namespace Teamcenter
{
    class CAEGeometryRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CAE_API  Teamcenter::CAEGeometryRevision
     : public  ::Teamcenter::CAEItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CAEGeometryRevision();

    /**
     * Destructor
     */
    virtual ~CAEGeometryRevision();

private:
    //  Getter method for the Implementation Object
    CAEGeometryRevisionImpl*  getCAEGeometryRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCAEGeometryRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CAEGeometryRevisionImpl*  m_caegeometryrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CAEGeometryRevision - desc for CAEGeometryRevision parameter
     */
    CAEGeometryRevision( const CAEGeometryRevision& );
    CAEGeometryRevision& operator=( const CAEGeometryRevision& );

    friend class  CAEGeometryRevisionDelegate;
    friend class  CAEGeometryRevisionDispatch;
    friend class  CAEGeometryRevisionGenImpl;
};

#include <cae/libcae_undef.h>
#endif //   TEAMCENTER__CAEGEOMETRYREVISION__HXX
