//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAEItem
    Filename:   CAEItem.hxx
    Module:     cae
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CAEITEM__HXX
#define TEAMCENTER__CAEITEM__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <cae/libcae_exports.h>

namespace Teamcenter
{
    class CAEItem;
}
namespace Teamcenter
{
    class CAEItemImpl;
}
namespace Teamcenter
{
    class CAEItemDelegate;
}
namespace Teamcenter
{
    class CAEItemDispatch;
}
namespace Teamcenter
{
    class CAEItemGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CAE_API  Teamcenter::CAEItem
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CAEItem();

    /**
     * Destructor
     */
    virtual ~CAEItem();

private:
    //  Getter method for the Implementation Object
    CAEItemImpl*  getCAEItemImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCAEItemImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CAEItemImpl*  m_caeitemImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CAEItem - desc for CAEItem parameter
     */
    CAEItem( const CAEItem& );
    CAEItem& operator=( const CAEItem& );

    friend class  CAEItemDelegate;
    friend class  CAEItemDispatch;
    friend class  CAEItemGenImpl;
};

#include <cae/libcae_undef.h>
#endif //   TEAMCENTER__CAEITEM__HXX
