//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAEItemRevision
    Filename:   CAEItemRevision.hxx
    Module:     cae
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CAEITEMREVISION__HXX
#define TEAMCENTER__CAEITEMREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <cae/libcae_exports.h>

namespace Teamcenter
{
    class CAEItemRevision;
}
namespace Teamcenter
{
    class CAEItemRevisionImpl;
}
namespace Teamcenter
{
    class CAEItemRevisionDelegate;
}
namespace Teamcenter
{
    class CAEItemRevisionDispatch;
}
namespace Teamcenter
{
    class CAEItemRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CAE_API  Teamcenter::CAEItemRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CAEItemRevision();

    /**
     * Destructor
     */
    virtual ~CAEItemRevision();

private:
    //  Getter method for the Implementation Object
    CAEItemRevisionImpl*  getCAEItemRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCAEItemRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CAEItemRevisionImpl*  m_caeitemrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CAEItemRevision - desc for CAEItemRevision parameter
     */
    CAEItemRevision( const CAEItemRevision& );
    CAEItemRevision& operator=( const CAEItemRevision& );

    friend class  CAEItemRevisionDelegate;
    friend class  CAEItemRevisionDispatch;
    friend class  CAEItemRevisionGenImpl;
};

#include <cae/libcae_undef.h>
#endif //   TEAMCENTER__CAEITEMREVISION__HXX
