//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAEItemRevisionDelegate
    Filename:   CAEItemRevisionDelegate.hxx
    Module:     cae
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CAEITEMREVISIONDELEGATE_HXX
#define TEAMCENTER__CAEITEMREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cae/CAEItemRevision.hxx>

#include <cae/libcae_exports.h>

namespace Teamcenter
{
    class CAEItemRevisionDelegate;
}
namespace Teamcenter
{
    class CAEItemRevisionImpl;
}
namespace Teamcenter
{
    class CAEItemRevision;
}
namespace Teamcenter
{
    class CAEItemRevisionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CAE_API Teamcenter_alias::CAEItemRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CAEItemRevisionDelegate instance
    static CAEItemRevisionDelegate&  getInstance();

    //  Method to create the CAEItemRevisionImpl pointer
    static CAEItemRevisionImpl*  createImpl( CAEItemRevision&  ifObj );

    //  Method to delete the CAEItemRevisionImpl pointer
    static void deleteImpl( CAEItemRevisionImpl*  impl );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const CAEItemRevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Generic saveAsPost operation.
    /// @version Teamcenter 8.1
    /// @param pSavAsInput - Input argument as SaveAsInput object.
    /// @param vecDeepCopyData - vector deepcopy data
    /// @return - Return integer value.
    ///
    int  saveAsPostBase(const CAEItemRevision &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static CAEItemRevisionDelegate*  m_pInstance;

    CAEItemRevisionDelegate();
    virtual ~CAEItemRevisionDelegate();
    static void setInstance( CAEItemRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::CAEItemRevisionGenImpl;

};

#include <cae/libcae_undef.h>
#endif  //  TEAMCENTER__CAEITEMREVISIONDELEGATE_HXX
