//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAELoadItem
    Filename:   CAELoadItem.hxx
    Module:     cae
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CAELOADITEM__HXX
#define TEAMCENTER__CAELOADITEM__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <cae/libcae_exports.h>

namespace Teamcenter
{
    class CAELoadItem;
}
namespace Teamcenter
{
    class CAELoadItemImpl;
}
namespace Teamcenter
{
    class CAELoadItemDelegate;
}
namespace Teamcenter
{
    class CAELoadItemDispatch;
}
namespace Teamcenter
{
    class CAELoadItemGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CAE_API  Teamcenter::CAELoadItem
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CAELoadItem();

    /**
     * Destructor
     */
    virtual ~CAELoadItem();

private:
    //  Getter method for the Implementation Object
    CAELoadItemImpl*  getCAELoadItemImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCAELoadItemImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CAELoadItemImpl*  m_caeloaditemImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CAELoadItem - desc for CAELoadItem parameter
     */
    CAELoadItem( const CAELoadItem& );
    CAELoadItem& operator=( const CAELoadItem& );

    friend class  CAELoadItemDelegate;
    friend class  CAELoadItemDispatch;
    friend class  CAELoadItemGenImpl;
};

#include <cae/libcae_undef.h>
#endif //   TEAMCENTER__CAELOADITEM__HXX
