//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAELoadItemRevision
    Filename:   CAELoadItemRevision.hxx
    Module:     cae
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CAELOADITEMREVISION__HXX
#define TEAMCENTER__CAELOADITEMREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <cae/libcae_exports.h>

namespace Teamcenter
{
    class CAELoadItemRevision;
}
namespace Teamcenter
{
    class CAELoadItemRevisionImpl;
}
namespace Teamcenter
{
    class CAELoadItemRevisionDelegate;
}
namespace Teamcenter
{
    class CAELoadItemRevisionDispatch;
}
namespace Teamcenter
{
    class CAELoadItemRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CAE_API  Teamcenter::CAELoadItemRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CAELoadItemRevision();

    /**
     * Destructor
     */
    virtual ~CAELoadItemRevision();

private:
    //  Getter method for the Implementation Object
    CAELoadItemRevisionImpl*  getCAELoadItemRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCAELoadItemRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CAELoadItemRevisionImpl*  m_caeloaditemrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CAELoadItemRevision - desc for CAELoadItemRevision parameter
     */
    CAELoadItemRevision( const CAELoadItemRevision& );
    CAELoadItemRevision& operator=( const CAELoadItemRevision& );

    friend class  CAELoadItemRevisionDelegate;
    friend class  CAELoadItemRevisionDispatch;
    friend class  CAELoadItemRevisionGenImpl;
};

#include <cae/libcae_undef.h>
#endif //   TEAMCENTER__CAELOADITEMREVISION__HXX
