//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAELoadItemRevisionDelegate
    Filename:   CAELoadItemRevisionDelegate.hxx
    Module:     cae
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CAELOADITEMREVISIONDELEGATE_HXX
#define TEAMCENTER__CAELOADITEMREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cae/CAELoadItemRevision.hxx>

#include <cae/libcae_exports.h>

namespace Teamcenter
{
    class CAELoadItemRevisionDelegate;
}
namespace Teamcenter
{
    class CAELoadItemRevisionImpl;
}
namespace Teamcenter
{
    class CAELoadItemRevision;
}
namespace Teamcenter
{
    class CAELoadItemRevisionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CAE_API Teamcenter_alias::CAELoadItemRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CAELoadItemRevisionDelegate instance
    static CAELoadItemRevisionDelegate&  getInstance();

    //  Method to create the CAELoadItemRevisionImpl pointer
    static CAELoadItemRevisionImpl*  createImpl( CAELoadItemRevision&  ifObj );

    //  Method to delete the CAELoadItemRevisionImpl pointer
    static void deleteImpl( CAELoadItemRevisionImpl*  impl );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const CAELoadItemRevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const CAELoadItemRevision &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static CAELoadItemRevisionDelegate*  m_pInstance;

    CAELoadItemRevisionDelegate();
    virtual ~CAELoadItemRevisionDelegate();
    static void setInstance( CAELoadItemRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::CAELoadItemRevisionGenImpl;

};

#include <cae/libcae_undef.h>
#endif  //  TEAMCENTER__CAELOADITEMREVISIONDELEGATE_HXX
