//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAEModel
    Filename:   CAEModel.hxx
    Module:     cae
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CAEMODEL__HXX
#define TEAMCENTER__CAEMODEL__HXX

#include <common/tc_deprecation_macros.h>
#include <cae/CAEItem.hxx>

#include <cae/libcae_exports.h>

namespace Teamcenter
{
    class CAEModel;
}
namespace Teamcenter
{
    class CAEModelImpl;
}
namespace Teamcenter
{
    class CAEModelDelegate;
}
namespace Teamcenter
{
    class CAEModelDispatch;
}
namespace Teamcenter
{
    class CAEModelGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CAE_API  Teamcenter::CAEModel
     : public  ::Teamcenter::CAEItem
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CAEModel();

    /**
     * Destructor
     */
    virtual ~CAEModel();

private:
    //  Getter method for the Implementation Object
    CAEModelImpl*  getCAEModelImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCAEModelImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CAEModelImpl*  m_caemodelImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CAEModel - desc for CAEModel parameter
     */
    CAEModel( const CAEModel& );
    CAEModel& operator=( const CAEModel& );

    friend class  CAEModelDelegate;
    friend class  CAEModelDispatch;
    friend class  CAEModelGenImpl;
};

#include <cae/libcae_undef.h>
#endif //   TEAMCENTER__CAEMODEL__HXX
