//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAEModelDelegate
    Filename:   CAEModelDelegate.hxx
    Module:     cae
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CAEMODELDELEGATE_HXX
#define TEAMCENTER__CAEMODELDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cae/CAEModel.hxx>

#include <cae/libcae_exports.h>

namespace Teamcenter
{
    class CAEModelDelegate;
}
namespace Teamcenter
{
    class CAEModelImpl;
}
namespace Teamcenter
{
    class CAEModel;
}
namespace Teamcenter
{
    class CAEModelGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CAE_API Teamcenter_alias::CAEModelDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CAEModelDelegate instance
    static CAEModelDelegate&  getInstance();

    //  Method to create the CAEModelImpl pointer
    static CAEModelImpl*  createImpl( CAEModel&  ifObj );

    //  Method to delete the CAEModelImpl pointer
    static void deleteImpl( CAEModelImpl*  impl );



protected:
    //  Pointer to the instance
    static CAEModelDelegate*  m_pInstance;

    CAEModelDelegate();
    virtual ~CAEModelDelegate();
    static void setInstance( CAEModelDelegate*  instance );


private:
    friend class  ::Teamcenter::CAEModelGenImpl;

};

#include <cae/libcae_undef.h>
#endif  //  TEAMCENTER__CAEMODELDELEGATE_HXX
