//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAEModelRevision
    Filename:   CAEModelRevision.hxx
    Module:     cae
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CAEMODELREVISION__HXX
#define TEAMCENTER__CAEMODELREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <cae/CAEItemRevision.hxx>

#include <cae/libcae_exports.h>

namespace Teamcenter
{
    class CAEModelRevision;
}
namespace Teamcenter
{
    class CAEModelRevisionImpl;
}
namespace Teamcenter
{
    class CAEModelRevisionDelegate;
}
namespace Teamcenter
{
    class CAEModelRevisionDispatch;
}
namespace Teamcenter
{
    class CAEModelRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CAE_API  Teamcenter::CAEModelRevision
     : public  ::Teamcenter::CAEItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CAEModelRevision();

    /**
     * Destructor
     */
    virtual ~CAEModelRevision();

private:
    //  Getter method for the Implementation Object
    CAEModelRevisionImpl*  getCAEModelRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCAEModelRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CAEModelRevisionImpl*  m_caemodelrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CAEModelRevision - desc for CAEModelRevision parameter
     */
    CAEModelRevision( const CAEModelRevision& );
    CAEModelRevision& operator=( const CAEModelRevision& );

    friend class  CAEModelRevisionDelegate;
    friend class  CAEModelRevisionDispatch;
    friend class  CAEModelRevisionGenImpl;
};

#include <cae/libcae_undef.h>
#endif //   TEAMCENTER__CAEMODELREVISION__HXX
