//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAEResult
    Filename:   CAEResult.hxx
    Module:     cae
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CAERESULT__HXX
#define TEAMCENTER__CAERESULT__HXX

#include <common/tc_deprecation_macros.h>
#include <cae/CAEItem.hxx>

#include <cae/libcae_exports.h>

namespace Teamcenter
{
    class CAEResult;
}
namespace Teamcenter
{
    class CAEResultImpl;
}
namespace Teamcenter
{
    class CAEResultDelegate;
}
namespace Teamcenter
{
    class CAEResultDispatch;
}
namespace Teamcenter
{
    class CAEResultGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CAE_API  Teamcenter::CAEResult
     : public  ::Teamcenter::CAEItem
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CAEResult();

    /**
     * Destructor
     */
    virtual ~CAEResult();

private:
    //  Getter method for the Implementation Object
    CAEResultImpl*  getCAEResultImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCAEResultImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CAEResultImpl*  m_caeresultImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CAEResult - desc for CAEResult parameter
     */
    CAEResult( const CAEResult& );
    CAEResult& operator=( const CAEResult& );

    friend class  CAEResultDelegate;
    friend class  CAEResultDispatch;
    friend class  CAEResultGenImpl;
};

#include <cae/libcae_undef.h>
#endif //   TEAMCENTER__CAERESULT__HXX
