//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAEResultRevision
    Filename:   CAEResultRevision.hxx
    Module:     cae
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CAERESULTREVISION__HXX
#define TEAMCENTER__CAERESULTREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <cae/CAEItemRevision.hxx>

#include <cae/libcae_exports.h>

namespace Teamcenter
{
    class CAEResultRevision;
}
namespace Teamcenter
{
    class CAEResultRevisionImpl;
}
namespace Teamcenter
{
    class CAEResultRevisionDelegate;
}
namespace Teamcenter
{
    class CAEResultRevisionDispatch;
}
namespace Teamcenter
{
    class CAEResultRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CAE_API  Teamcenter::CAEResultRevision
     : public  ::Teamcenter::CAEItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CAEResultRevision();

    /**
     * Destructor
     */
    virtual ~CAEResultRevision();

private:
    //  Getter method for the Implementation Object
    CAEResultRevisionImpl*  getCAEResultRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCAEResultRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CAEResultRevisionImpl*  m_caeresultrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CAEResultRevision - desc for CAEResultRevision parameter
     */
    CAEResultRevision( const CAEResultRevision& );
    CAEResultRevision& operator=( const CAEResultRevision& );

    friend class  CAEResultRevisionDelegate;
    friend class  CAEResultRevisionDispatch;
    friend class  CAEResultRevisionGenImpl;
};

#include <cae/libcae_undef.h>
#endif //   TEAMCENTER__CAERESULTREVISION__HXX
