//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, StructureMap
    Filename:   StructureMap.hxx
    Module:     cae
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__STRUCTUREMAP__HXX
#define TEAMCENTER__STRUCTUREMAP__HXX

#include <common/tc_deprecation_macros.h>
#include <cae/CAEItem.hxx>

#include <cae/libcae_exports.h>

namespace Teamcenter
{
    class StructureMap;
}
namespace Teamcenter
{
    class StructureMapImpl;
}
namespace Teamcenter
{
    class StructureMapDelegate;
}
namespace Teamcenter
{
    class StructureMapDispatch;
}
namespace Teamcenter
{
    class StructureMapGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CAE_API  Teamcenter::StructureMap
     : public  ::Teamcenter::CAEItem
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    StructureMap();

    /**
     * Destructor
     */
    virtual ~StructureMap();

private:
    //  Getter method for the Implementation Object
    StructureMapImpl*  getStructureMapImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setStructureMapImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    StructureMapImpl*  m_structuremapImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param StructureMap - desc for StructureMap parameter
     */
    StructureMap( const StructureMap& );
    StructureMap& operator=( const StructureMap& );

    friend class  StructureMapDelegate;
    friend class  StructureMapDispatch;
    friend class  StructureMapGenImpl;
};

#include <cae/libcae_undef.h>
#endif //   TEAMCENTER__STRUCTUREMAP__HXX
