//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  cae

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libcae

#if !defined(LIBCAE) && !defined(IPLIB)
#   error IPLIB or LIBCAE is not defined
#endif

/* Handwritten code should use CAE_API, not CAEEXPORT */

#define CAE_API CAEEXPORT

#if IPLIB==libcae || defined(LIBCAE)
#   if defined(__lint)
#       define CAEEXPORT       __export(cae)
#       define CAEGLOBAL       extern __global(cae)
#       define CAEPRIVATE      extern __private(cae)
#   elif defined(_WIN32)
#       define CAEEXPORT       __declspec(dllexport)
#       define CAEGLOBAL       extern __declspec(dllexport)
#       define CAEPRIVATE      extern
#   else
#       define CAEEXPORT
#       define CAEGLOBAL       extern
#       define CAEPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CAEEXPORT       __export(cae)
#       define CAEGLOBAL       extern __global(cae)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CAEEXPORT      __declspec(dllimport)
#       define CAEGLOBAL       extern __declspec(dllimport)
#   else
#       define CAEEXPORT
#       define CAEGLOBAL       extern
#   endif
#endif
