//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAE0ConfigDispatch
    Filename:   CAE0ConfigDispatch.hxx
    Module:     caedispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CAE__CAE0CONFIGDISPATCH_HXX
#define CAE__CAE0CONFIGDISPATCH_HXX

#include <vector>
#include <CAE0SimulationProcessManagement/CAE0Config.hxx>
#include <CAE0SimulationProcessManagement/CAE0ConfigDelegate.hxx>
#include <foundationdispatch/CAEItemDispatch.hxx>
#include <caedispatch/initializecae.hxx>

#include <caedispatch/libcaedispatch_exports.h>

namespace cae
{
    class CAE0ConfigDispatch;
}
namespace cae
{
    class CAE0ConfigDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  CAEDISPATCH_API  cae::CAE0ConfigDispatch
    : public  cae::CAE0ConfigDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CAE0ConfigDispatch instance
    static CAE0ConfigDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static CAE0ConfigDispatch*  m_dispatch;

    //  Default Constructor
    CAE0ConfigDispatch();

    //  Default Destructor
    virtual ~CAE0ConfigDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a CAE0ConfigDispatch
    CAE0ConfigDispatch( const CAE0ConfigDispatch& );

    //  Assignment operator
    CAE0ConfigDispatch&  operator = ( const CAE0ConfigDispatch& );

    //  friend
    friend void   ::cae::initializecaeInternal();
    friend void   ::cae::initializecaeExtenders();
    friend class  cae::CAE0ConfigDelegate;
};

#include <caedispatch/libcaedispatch_undef.h>
#endif  //  CAE__CAE0CONFIGDISPATCH_HXX
