//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAE0ConfigRevisionDispatch
    Filename:   CAE0ConfigRevisionDispatch.hxx
    Module:     caedispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CAE__CAE0CONFIGREVISIONDISPATCH_HXX
#define CAE__CAE0CONFIGREVISIONDISPATCH_HXX

#include <vector>
#include <CAE0SimulationProcessManagement/CAE0ConfigRevision.hxx>
#include <CAE0SimulationProcessManagement/CAE0ConfigRevisionDelegate.hxx>
#include <foundationdispatch/CAEItemRevisionDispatch.hxx>
#include <caedispatch/initializecae.hxx>

#include <caedispatch/libcaedispatch_exports.h>

namespace cae
{
    class CAE0ConfigRevisionDispatch;
}
namespace cae
{
    class CAE0ConfigRevisionDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  CAEDISPATCH_API  cae::CAE0ConfigRevisionDispatch
    : public  cae::CAE0ConfigRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CAE0ConfigRevisionDispatch instance
    static CAE0ConfigRevisionDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static CAE0ConfigRevisionDispatch*  m_dispatch;

    //  Default Constructor
    CAE0ConfigRevisionDispatch();

    //  Default Destructor
    virtual ~CAE0ConfigRevisionDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a CAE0ConfigRevisionDispatch
    CAE0ConfigRevisionDispatch( const CAE0ConfigRevisionDispatch& );

    //  Assignment operator
    CAE0ConfigRevisionDispatch&  operator = ( const CAE0ConfigRevisionDispatch& );

    //  friend
    friend void   ::cae::initializecaeInternal();
    friend void   ::cae::initializecaeExtenders();
    friend class  cae::CAE0ConfigRevisionDelegate;
};

#include <caedispatch/libcaedispatch_undef.h>
#endif  //  CAE__CAE0CONFIGREVISIONDISPATCH_HXX
