//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  caedispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libcaedispatch

#if !defined(LIBCAEDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBCAEDISPATCH is not defined
#endif

/* Handwritten code should use CAEDISPATCH_API, not CAEDISPATCHEXPORT */

#define CAEDISPATCH_API CAEDISPATCHEXPORT

#if IPLIB==libcaedispatch || defined(LIBCAEDISPATCH)
#   if defined(__lint)
#       define CAEDISPATCHEXPORT       __export(caedispatch)
#       define CAEDISPATCHGLOBAL       extern __global(caedispatch)
#       define CAEDISPATCHPRIVATE      extern __private(caedispatch)
#   elif defined(_WIN32)
#       define CAEDISPATCHEXPORT       __declspec(dllexport)
#       define CAEDISPATCHGLOBAL       extern __declspec(dllexport)
#       define CAEDISPATCHPRIVATE      extern
#   else
#       define CAEDISPATCHEXPORT
#       define CAEDISPATCHGLOBAL       extern
#       define CAEDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CAEDISPATCHEXPORT       __export(caedispatch)
#       define CAEDISPATCHGLOBAL       extern __global(caedispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CAEDISPATCHEXPORT      __declspec(dllimport)
#       define CAEDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define CAEDISPATCHEXPORT
#       define CAEDISPATCHGLOBAL       extern
#   endif
#endif
