//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ACTLineDelegate
    Filename:   ACTLineDelegate.hxx
    Module:     cba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CBA__ACTLINEDELEGATE_HXX
#define TEAMCENTER__CBA__ACTLINEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cba/ACTLine.hxx>

#include <cba/libcba_exports.h>

namespace Teamcenter
{
    namespace cba
    {
        class ACTLineDelegate;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class ACTLineImpl;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class ACTLine;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class ACTLineGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CBA_API Teamcenter_alias::cba::ACTLineDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ACTLineDelegate instance
    static ACTLineDelegate&  getInstance();

    //  Method to create the ACTLineImpl pointer
    static ACTLineImpl*  createImpl( ACTLine&  ifObj );

    //  Method to delete the ACTLineImpl pointer
    static void deleteImpl( ACTLineImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0_alignedMathOccsBase(const ACTLine &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0_categoryBase(const ACTLine &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0_componentAlphaQuantityBase(const ACTLine &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0_loaVersionNumberBase(const ACTLine &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0_usageAddress00Base(const ACTLine &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0_usageAddress03Base(const ACTLine &ifObj,  std::string &value, bool &isNull ) const;



protected:
    //  Pointer to the instance
    static ACTLineDelegate*  m_pInstance;

    ACTLineDelegate();
    virtual ~ACTLineDelegate();
    static void setInstance( ACTLineDelegate*  instance );


private:
    friend class  ::Teamcenter::cba::ACTLineGenImpl;

};

#include <cba/libcba_undef.h>
#endif  //  TEAMCENTER__CBA__ACTLINEDELEGATE_HXX
