//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cba0ApprSearchCrtPMMQuery
    Filename:   Cba0ApprSearchCrtPMMQuery.hxx
    Module:     cba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CBA__CBA0APPRSEARCHCRTPMMQUERY__HXX
#define TEAMCENTER__CBA__CBA0APPRSEARCHCRTPMMQUERY__HXX

#include <vector>
#include <string>
#include <common/tc_deprecation_macros.h>
#include <rdv/ApprSearchCriteria.hxx>

#include <cba/libcba_exports.h>

namespace Teamcenter
{
    namespace cba
    {
        class Cba0ApprSearchCrtPMMQuery;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0ApprSearchCrtPMMQueryImpl;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0ApprSearchCrtPMMQueryDelegate;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0ApprSearchCrtPMMQueryDispatch;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0ApprSearchCrtPMMQueryGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CBA_API  Teamcenter::cba::Cba0ApprSearchCrtPMMQuery
     : public  ::Teamcenter::ApprSearchCriteria
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 10.1.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0entries( std::vector< std::string > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0table_name( std::string &value, bool &isNull ) const;

    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 10.1.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0values( std::vector< std::string > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cba0ApprSearchCrtPMMQuery();

    /**
     * Destructor
     */
    virtual ~Cba0ApprSearchCrtPMMQuery();

private:
    //  Getter method for the Implementation Object
    Cba0ApprSearchCrtPMMQueryImpl*  getCba0ApprSearchCrtPMMQueryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCba0ApprSearchCrtPMMQueryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cba0ApprSearchCrtPMMQueryImpl*  m_cba0apprsearchcrtpmmqueryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cba0ApprSearchCrtPMMQuery - desc for Cba0ApprSearchCrtPMMQuery parameter
     */
    Cba0ApprSearchCrtPMMQuery( const Cba0ApprSearchCrtPMMQuery& );
    Cba0ApprSearchCrtPMMQuery& operator=( const Cba0ApprSearchCrtPMMQuery& );

    friend class  Cba0ApprSearchCrtPMMQueryDelegate;
    friend class  Cba0ApprSearchCrtPMMQueryDispatch;
    friend class  Cba0ApprSearchCrtPMMQueryGenImpl;
};

#include <cba/libcba_undef.h>
#endif //   TEAMCENTER__CBA__CBA0APPRSEARCHCRTPMMQUERY__HXX
