//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cba0LOAProcurementProxy
    Filename:   Cba0LOAProcurementProxy.hxx
    Module:     cba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CBA__CBA0LOAPROCUREMENTPROXY__HXX
#define TEAMCENTER__CBA__CBA0LOAPROCUREMENTPROXY__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <cba/Cba0ProcurementProxy.hxx>

#include <cba/libcba_exports.h>

namespace Teamcenter
{
    namespace cba
    {
        class Cba0LOAProcurementProxy;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0LOAProcurementProxyImpl;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0LOAProcurementProxyDelegate;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0LOAProcurementProxyDispatch;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0LOAProcurementProxyGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CBA_API  Teamcenter::cba::Cba0LOAProcurementProxy
     : public  ::Teamcenter::cba::Cba0ProcurementProxy
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0RpsRpdByGroupId( std::string &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cba0LOAProcurementProxy();

    /**
     * Destructor
     */
    virtual ~Cba0LOAProcurementProxy();

private:
    //  Getter method for the Implementation Object
    Cba0LOAProcurementProxyImpl*  getCba0LOAProcurementProxyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCba0LOAProcurementProxyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cba0LOAProcurementProxyImpl*  m_cba0loaprocurementproxyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cba0LOAProcurementProxy - desc for Cba0LOAProcurementProxy parameter
     */
    Cba0LOAProcurementProxy( const Cba0LOAProcurementProxy& );
    Cba0LOAProcurementProxy& operator=( const Cba0LOAProcurementProxy& );

    friend class  Cba0LOAProcurementProxyDelegate;
    friend class  Cba0LOAProcurementProxyDispatch;
    friend class  Cba0LOAProcurementProxyGenImpl;
};

#include <cba/libcba_undef.h>
#endif //   TEAMCENTER__CBA__CBA0LOAPROCUREMENTPROXY__HXX
