//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cba0LOAProxy
    Filename:   Cba0LOAProxy.hxx
    Module:     cba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CBA__CBA0LOAPROXY__HXX
#define TEAMCENTER__CBA__CBA0LOAPROXY__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <cba/Cba0PersistentProxy.hxx>

#include <cba/libcba_exports.h>

namespace Teamcenter
{
    namespace cba
    {
        class Cba0LOAProxy;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0LOAProxyImpl;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0LOAProxyDelegate;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0LOAProxyDispatch;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0LOAProxyGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CBA_API  Teamcenter::cba::Cba0LOAProxy
     : public  ::Teamcenter::cba::Cba0PersistentProxy
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0_ComponentQuantity( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0ComponentUsageAddress00( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0ComponentUsageAddress03( std::string &value, bool &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0LOA_LEVEL_ULineOfAssembly( int &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0RpsRpdByGroupId( std::string &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cba0LOAProxy();

    /**
     * Destructor
     */
    virtual ~Cba0LOAProxy();

private:
    //  Getter method for the Implementation Object
    Cba0LOAProxyImpl*  getCba0LOAProxyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCba0LOAProxyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cba0LOAProxyImpl*  m_cba0loaproxyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cba0LOAProxy - desc for Cba0LOAProxy parameter
     */
    Cba0LOAProxy( const Cba0LOAProxy& );
    Cba0LOAProxy& operator=( const Cba0LOAProxy& );

    friend class  Cba0LOAProxyDelegate;
    friend class  Cba0LOAProxyDispatch;
    friend class  Cba0LOAProxyGenImpl;
};

#include <cba/libcba_undef.h>
#endif //   TEAMCENTER__CBA__CBA0LOAPROXY__HXX
