//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cba0LOAProxyDelegate
    Filename:   Cba0LOAProxyDelegate.hxx
    Module:     cba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CBA__CBA0LOAPROXYDELEGATE_HXX
#define TEAMCENTER__CBA__CBA0LOAPROXYDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cba/Cba0LOAProxy.hxx>

#include <cba/libcba_exports.h>

namespace Teamcenter
{
    namespace cba
    {
        class Cba0LOAProxyDelegate;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0LOAProxyImpl;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0LOAProxy;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0LOAProxyGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CBA_API Teamcenter_alias::cba::Cba0LOAProxyDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cba0LOAProxyDelegate instance
    static Cba0LOAProxyDelegate&  getInstance();

    //  Method to create the Cba0LOAProxyImpl pointer
    static Cba0LOAProxyImpl*  createImpl( Cba0LOAProxy&  ifObj );

    //  Method to delete the Cba0LOAProxyImpl pointer
    static void deleteImpl( Cba0LOAProxyImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0_ComponentQuantityBase(const Cba0LOAProxy &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0ComponentUsageAddress00Base(const Cba0LOAProxy &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0ComponentUsageAddress03Base(const Cba0LOAProxy &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0LOA_LEVEL_ULineOfAssemblyBase(const Cba0LOAProxy &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0RpsRpdByGroupIdBase(const Cba0LOAProxy &ifObj,  std::string &value, bool &isNull ) const;



protected:
    //  Pointer to the instance
    static Cba0LOAProxyDelegate*  m_pInstance;

    Cba0LOAProxyDelegate();
    virtual ~Cba0LOAProxyDelegate();
    static void setInstance( Cba0LOAProxyDelegate*  instance );


private:
    friend class  ::Teamcenter::cba::Cba0LOAProxyGenImpl;

};

#include <cba/libcba_undef.h>
#endif  //  TEAMCENTER__CBA__CBA0LOAPROXYDELEGATE_HXX
