//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cba0LOFProcurementProxy
    Filename:   Cba0LOFProcurementProxy.hxx
    Module:     cba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CBA__CBA0LOFPROCUREMENTPROXY__HXX
#define TEAMCENTER__CBA__CBA0LOFPROCUREMENTPROXY__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <cba/Cba0ProcurementProxy.hxx>

#include <cba/libcba_exports.h>

namespace Teamcenter
{
    namespace cba
    {
        class Cba0LOFProcurementProxy;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0LOFProcurementProxyImpl;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0LOFProcurementProxyDelegate;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0LOFProcurementProxyDispatch;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0LOFProcurementProxyGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CBA_API  Teamcenter::cba::Cba0LOFProcurementProxy
     : public  ::Teamcenter::cba::Cba0ProcurementProxy
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0RpsRpdByGroupId( std::string &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cba0LOFProcurementProxy();

    /**
     * Destructor
     */
    virtual ~Cba0LOFProcurementProxy();

private:
    //  Getter method for the Implementation Object
    Cba0LOFProcurementProxyImpl*  getCba0LOFProcurementProxyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCba0LOFProcurementProxyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cba0LOFProcurementProxyImpl*  m_cba0lofprocurementproxyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cba0LOFProcurementProxy - desc for Cba0LOFProcurementProxy parameter
     */
    Cba0LOFProcurementProxy( const Cba0LOFProcurementProxy& );
    Cba0LOFProcurementProxy& operator=( const Cba0LOFProcurementProxy& );

    friend class  Cba0LOFProcurementProxyDelegate;
    friend class  Cba0LOFProcurementProxyDispatch;
    friend class  Cba0LOFProcurementProxyGenImpl;
};

#include <cba/libcba_undef.h>
#endif //   TEAMCENTER__CBA__CBA0LOFPROCUREMENTPROXY__HXX
