//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cba0LOFProxy
    Filename:   Cba0LOFProxy.hxx
    Module:     cba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CBA__CBA0LOFPROXY__HXX
#define TEAMCENTER__CBA__CBA0LOFPROXY__HXX

#include <common/tc_deprecation_macros.h>
#include <cba/Cba0PersistentProxy.hxx>

#include <cba/libcba_exports.h>

namespace Teamcenter
{
    namespace cba
    {
        class Cba0LOFProxy;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0LOFProxyImpl;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0LOFProxyDelegate;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0LOFProxyDispatch;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0LOFProxyGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CBA_API  Teamcenter::cba::Cba0LOFProxy
     : public  ::Teamcenter::cba::Cba0PersistentProxy
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cba0LOFProxy();

    /**
     * Destructor
     */
    virtual ~Cba0LOFProxy();

private:
    //  Getter method for the Implementation Object
    Cba0LOFProxyImpl*  getCba0LOFProxyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCba0LOFProxyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cba0LOFProxyImpl*  m_cba0lofproxyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cba0LOFProxy - desc for Cba0LOFProxy parameter
     */
    Cba0LOFProxy( const Cba0LOFProxy& );
    Cba0LOFProxy& operator=( const Cba0LOFProxy& );

    friend class  Cba0LOFProxyDelegate;
    friend class  Cba0LOFProxyDispatch;
    friend class  Cba0LOFProxyGenImpl;
};

#include <cba/libcba_undef.h>
#endif //   TEAMCENTER__CBA__CBA0LOFPROXY__HXX
