//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cba0LOUProcurementProxy
    Filename:   Cba0LOUProcurementProxy.hxx
    Module:     cba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CBA__CBA0LOUPROCUREMENTPROXY__HXX
#define TEAMCENTER__CBA__CBA0LOUPROCUREMENTPROXY__HXX

#include <common/tc_deprecation_macros.h>
#include <cba/Cba0ProcurementProxy.hxx>

#include <cba/libcba_exports.h>

namespace Teamcenter
{
    namespace cba
    {
        class Cba0LOUProcurementProxy;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0LOUProcurementProxyImpl;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0LOUProcurementProxyDelegate;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0LOUProcurementProxyDispatch;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0LOUProcurementProxyGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CBA_API  Teamcenter::cba::Cba0LOUProcurementProxy
     : public  ::Teamcenter::cba::Cba0ProcurementProxy
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cba0LOUProcurementProxy();

    /**
     * Destructor
     */
    virtual ~Cba0LOUProcurementProxy();

private:
    //  Getter method for the Implementation Object
    Cba0LOUProcurementProxyImpl*  getCba0LOUProcurementProxyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCba0LOUProcurementProxyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cba0LOUProcurementProxyImpl*  m_cba0louprocurementproxyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cba0LOUProcurementProxy - desc for Cba0LOUProcurementProxy parameter
     */
    Cba0LOUProcurementProxy( const Cba0LOUProcurementProxy& );
    Cba0LOUProcurementProxy& operator=( const Cba0LOUProcurementProxy& );

    friend class  Cba0LOUProcurementProxyDelegate;
    friend class  Cba0LOUProcurementProxyDispatch;
    friend class  Cba0LOUProcurementProxyGenImpl;
};

#include <cba/libcba_undef.h>
#endif //   TEAMCENTER__CBA__CBA0LOUPROCUREMENTPROXY__HXX
