//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cba0LOUProxy
    Filename:   Cba0LOUProxy.hxx
    Module:     cba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CBA__CBA0LOUPROXY__HXX
#define TEAMCENTER__CBA__CBA0LOUPROXY__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <cba/Cba0PersistentProxy.hxx>

#include <cba/libcba_exports.h>

namespace Teamcenter
{
    namespace cba
    {
        class Cba0LOUProxy;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0LOUProxyImpl;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0LOUProxyDelegate;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0LOUProxyDispatch;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0LOUProxyGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CBA_API  Teamcenter::cba::Cba0LOUProxy
     : public  ::Teamcenter::cba::Cba0PersistentProxy
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0_PartID( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0_Quantity( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0RpsRpdByGroupId( std::string &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cba0LOUProxy();

    /**
     * Destructor
     */
    virtual ~Cba0LOUProxy();

private:
    //  Getter method for the Implementation Object
    Cba0LOUProxyImpl*  getCba0LOUProxyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCba0LOUProxyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cba0LOUProxyImpl*  m_cba0louproxyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cba0LOUProxy - desc for Cba0LOUProxy parameter
     */
    Cba0LOUProxy( const Cba0LOUProxy& );
    Cba0LOUProxy& operator=( const Cba0LOUProxy& );

    friend class  Cba0LOUProxyDelegate;
    friend class  Cba0LOUProxyDispatch;
    friend class  Cba0LOUProxyGenImpl;
};

#include <cba/libcba_undef.h>
#endif //   TEAMCENTER__CBA__CBA0LOUPROXY__HXX
