//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cba0PMMObjectList
    Filename:   Cba0PMMObjectList.hxx
    Module:     cba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CBA__CBA0PMMOBJECTLIST__HXX
#define TEAMCENTER__CBA__CBA0PMMOBJECTLIST__HXX

#include <vector>
#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <cba/libcba_exports.h>

namespace Teamcenter
{
    namespace cba
    {
        class Cba0PMMObjectList;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0PMMObjectListImpl;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0PMMObjectListDelegate;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0PMMObjectListDispatch;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0PMMObjectListGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CBA_API  Teamcenter::cba::Cba0PMMObjectList
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 10.1.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0object_list( std::vector< std::string > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0object_type( std::string &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cba0PMMObjectList();

    /**
     * Destructor
     */
    virtual ~Cba0PMMObjectList();

private:
    //  Getter method for the Implementation Object
    Cba0PMMObjectListImpl*  getCba0PMMObjectListImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCba0PMMObjectListImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cba0PMMObjectListImpl*  m_cba0pmmobjectlistImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cba0PMMObjectList - desc for Cba0PMMObjectList parameter
     */
    Cba0PMMObjectList( const Cba0PMMObjectList& );
    Cba0PMMObjectList& operator=( const Cba0PMMObjectList& );

    friend class  Cba0PMMObjectListDelegate;
    friend class  Cba0PMMObjectListDispatch;
    friend class  Cba0PMMObjectListGenImpl;
};

#include <cba/libcba_undef.h>
#endif //   TEAMCENTER__CBA__CBA0PMMOBJECTLIST__HXX
