//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cba0PMMObjectListDelegate
    Filename:   Cba0PMMObjectListDelegate.hxx
    Module:     cba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CBA__CBA0PMMOBJECTLISTDELEGATE_HXX
#define TEAMCENTER__CBA__CBA0PMMOBJECTLISTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cba/Cba0PMMObjectList.hxx>

#include <cba/libcba_exports.h>

namespace Teamcenter
{
    namespace cba
    {
        class Cba0PMMObjectListDelegate;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0PMMObjectListImpl;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0PMMObjectList;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0PMMObjectListGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CBA_API Teamcenter_alias::cba::Cba0PMMObjectListDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cba0PMMObjectListDelegate instance
    static Cba0PMMObjectListDelegate&  getInstance();

    //  Method to create the Cba0PMMObjectListImpl pointer
    static Cba0PMMObjectListImpl*  createImpl( Cba0PMMObjectList&  ifObj );

    //  Method to delete the Cba0PMMObjectListImpl pointer
    static void deleteImpl( Cba0PMMObjectListImpl*  impl );


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 10.1.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0object_listBase(const Cba0PMMObjectList &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0object_typeBase(const Cba0PMMObjectList &ifObj,  std::string &value, bool &isNull ) const;



protected:
    //  Pointer to the instance
    static Cba0PMMObjectListDelegate*  m_pInstance;

    Cba0PMMObjectListDelegate();
    virtual ~Cba0PMMObjectListDelegate();
    static void setInstance( Cba0PMMObjectListDelegate*  instance );


private:
    friend class  ::Teamcenter::cba::Cba0PMMObjectListGenImpl;

};

#include <cba/libcba_undef.h>
#endif  //  TEAMCENTER__CBA__CBA0PMMOBJECTLISTDELEGATE_HXX
