//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cba0PMMObjectListSlctState
    Filename:   Cba0PMMObjectListSlctState.hxx
    Module:     cba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CBA__CBA0PMMOBJECTLISTSLCTSTATE__HXX
#define TEAMCENTER__CBA__CBA0PMMOBJECTLISTSLCTSTATE__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <cba/libcba_exports.h>

namespace Teamcenter
{
    namespace cba
    {
        class Cba0PMMObjectListSlctState;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0PMMObjectListSlctStateImpl;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0PMMObjectListSlctStateDelegate;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0PMMObjectListSlctStateDispatch;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0PMMObjectListSlctStateGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CBA_API  Teamcenter::cba::Cba0PMMObjectListSlctState
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0selected_list( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0unselected_list( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cba0PMMObjectListSlctState();

    /**
     * Destructor
     */
    virtual ~Cba0PMMObjectListSlctState();

private:
    //  Getter method for the Implementation Object
    Cba0PMMObjectListSlctStateImpl*  getCba0PMMObjectListSlctStateImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCba0PMMObjectListSlctStateImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cba0PMMObjectListSlctStateImpl*  m_cba0pmmobjectlistslctstateImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cba0PMMObjectListSlctState - desc for Cba0PMMObjectListSlctState parameter
     */
    Cba0PMMObjectListSlctState( const Cba0PMMObjectListSlctState& );
    Cba0PMMObjectListSlctState& operator=( const Cba0PMMObjectListSlctState& );

    friend class  Cba0PMMObjectListSlctStateDelegate;
    friend class  Cba0PMMObjectListSlctStateDispatch;
    friend class  Cba0PMMObjectListSlctStateGenImpl;
};

#include <cba/libcba_undef.h>
#endif //   TEAMCENTER__CBA__CBA0PMMOBJECTLISTSLCTSTATE__HXX
