//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cba0PMMRecipeContainer
    Filename:   Cba0PMMRecipeContainer.hxx
    Module:     cba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CBA__CBA0PMMRECIPECONTAINER__HXX
#define TEAMCENTER__CBA__CBA0PMMRECIPECONTAINER__HXX

#include <common/tc_deprecation_macros.h>
#include <cfm/Fnd0RecipeContainer.hxx>

#include <cba/libcba_exports.h>

namespace Teamcenter
{
    namespace cba
    {
        class Cba0PMMRecipeContainer;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0PMMRecipeContainerImpl;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0PMMRecipeContainerDelegate;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0PMMRecipeContainerDispatch;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0PMMRecipeContainerGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CBA_API  Teamcenter::cba::Cba0PMMRecipeContainer
     : public  ::Teamcenter::Fnd0RecipeContainer
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cba0PMMRecipeContainer();

    /**
     * Destructor
     */
    virtual ~Cba0PMMRecipeContainer();

private:
    //  Getter method for the Implementation Object
    Cba0PMMRecipeContainerImpl*  getCba0PMMRecipeContainerImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCba0PMMRecipeContainerImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cba0PMMRecipeContainerImpl*  m_cba0pmmrecipecontainerImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cba0PMMRecipeContainer - desc for Cba0PMMRecipeContainer parameter
     */
    Cba0PMMRecipeContainer( const Cba0PMMRecipeContainer& );
    Cba0PMMRecipeContainer& operator=( const Cba0PMMRecipeContainer& );

    friend class  Cba0PMMRecipeContainerDelegate;
    friend class  Cba0PMMRecipeContainerDispatch;
    friend class  Cba0PMMRecipeContainerGenImpl;
};

#include <cba/libcba_undef.h>
#endif //   TEAMCENTER__CBA__CBA0PMMRECIPECONTAINER__HXX
