//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cba0PMMStructureContext
    Filename:   Cba0PMMStructureContext.hxx
    Module:     cba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CBA__CBA0PMMSTRUCTURECONTEXT__HXX
#define TEAMCENTER__CBA__CBA0PMMSTRUCTURECONTEXT__HXX

#include <string>
#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <collabctx/VisStructureContext.hxx>

#include <cba/libcba_exports.h>

namespace Teamcenter
{
    namespace cba
    {
        class Cba0PMMStructureContext;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0PMMStructureContextImpl;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0PMMStructureContextDelegate;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0PMMStructureContextDispatch;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0PMMStructureContextGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CBA_API  Teamcenter::cba::Cba0PMMStructureContext
     : public  ::Teamcenter::VisStructureContext
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0context_name( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0plmxml_file( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0pmm_service_name( std::string &value, bool &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0snapshot_type( int &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cba0PMMStructureContext();

    /**
     * Destructor
     */
    virtual ~Cba0PMMStructureContext();

private:
    //  Getter method for the Implementation Object
    Cba0PMMStructureContextImpl*  getCba0PMMStructureContextImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCba0PMMStructureContextImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cba0PMMStructureContextImpl*  m_cba0pmmstructurecontextImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cba0PMMStructureContext - desc for Cba0PMMStructureContext parameter
     */
    Cba0PMMStructureContext( const Cba0PMMStructureContext& );
    Cba0PMMStructureContext& operator=( const Cba0PMMStructureContext& );

    friend class  Cba0PMMStructureContextDelegate;
    friend class  Cba0PMMStructureContextDispatch;
    friend class  Cba0PMMStructureContextGenImpl;
};

#include <cba/libcba_undef.h>
#endif //   TEAMCENTER__CBA__CBA0PMMSTRUCTURECONTEXT__HXX
