//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cba0PMMStructureContextDelegate
    Filename:   Cba0PMMStructureContextDelegate.hxx
    Module:     cba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CBA__CBA0PMMSTRUCTURECONTEXTDELEGATE_HXX
#define TEAMCENTER__CBA__CBA0PMMSTRUCTURECONTEXTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cba/Cba0PMMStructureContext.hxx>

#include <cba/libcba_exports.h>

namespace Teamcenter
{
    namespace cba
    {
        class Cba0PMMStructureContextDelegate;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0PMMStructureContextImpl;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0PMMStructureContext;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0PMMStructureContextGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CBA_API Teamcenter_alias::cba::Cba0PMMStructureContextDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cba0PMMStructureContextDelegate instance
    static Cba0PMMStructureContextDelegate&  getInstance();

    //  Method to create the Cba0PMMStructureContextImpl pointer
    static Cba0PMMStructureContextImpl*  createImpl( Cba0PMMStructureContext&  ifObj );

    //  Method to delete the Cba0PMMStructureContextImpl pointer
    static void deleteImpl( Cba0PMMStructureContextImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0context_nameBase(const Cba0PMMStructureContext &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0plmxml_fileBase(const Cba0PMMStructureContext &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0pmm_service_nameBase(const Cba0PMMStructureContext &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0snapshot_typeBase(const Cba0PMMStructureContext &ifObj,  int &value, bool &isNull ) const;



protected:
    //  Pointer to the instance
    static Cba0PMMStructureContextDelegate*  m_pInstance;

    Cba0PMMStructureContextDelegate();
    virtual ~Cba0PMMStructureContextDelegate();
    static void setInstance( Cba0PMMStructureContextDelegate*  instance );


private:
    friend class  ::Teamcenter::cba::Cba0PMMStructureContextGenImpl;

};

#include <cba/libcba_undef.h>
#endif  //  TEAMCENTER__CBA__CBA0PMMSTRUCTURECONTEXTDELEGATE_HXX
