//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cba0PartProcurementProxy
    Filename:   Cba0PartProcurementProxy.hxx
    Module:     cba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CBA__CBA0PARTPROCUREMENTPROXY__HXX
#define TEAMCENTER__CBA__CBA0PARTPROCUREMENTPROXY__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <cba/Cba0ProcurementProxy.hxx>

#include <cba/libcba_exports.h>

namespace Teamcenter
{
    namespace cba
    {
        class Cba0PartProcurementProxy;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0PartProcurementProxyImpl;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0PartProcurementProxyDelegate;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0PartProcurementProxyDispatch;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0PartProcurementProxyGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CBA_API  Teamcenter::cba::Cba0PartProcurementProxy
     : public  ::Teamcenter::cba::Cba0ProcurementProxy
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0RpsRpdByGroupId( std::string &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cba0PartProcurementProxy();

    /**
     * Destructor
     */
    virtual ~Cba0PartProcurementProxy();

private:
    //  Getter method for the Implementation Object
    Cba0PartProcurementProxyImpl*  getCba0PartProcurementProxyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCba0PartProcurementProxyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cba0PartProcurementProxyImpl*  m_cba0partprocurementproxyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cba0PartProcurementProxy - desc for Cba0PartProcurementProxy parameter
     */
    Cba0PartProcurementProxy( const Cba0PartProcurementProxy& );
    Cba0PartProcurementProxy& operator=( const Cba0PartProcurementProxy& );

    friend class  Cba0PartProcurementProxyDelegate;
    friend class  Cba0PartProcurementProxyDispatch;
    friend class  Cba0PartProcurementProxyGenImpl;
};

#include <cba/libcba_undef.h>
#endif //   TEAMCENTER__CBA__CBA0PARTPROCUREMENTPROXY__HXX
