//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cba0PartProxyDelegate
    Filename:   Cba0PartProxyDelegate.hxx
    Module:     cba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CBA__CBA0PARTPROXYDELEGATE_HXX
#define TEAMCENTER__CBA__CBA0PARTPROXYDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cba/Cba0PartProxy.hxx>

#include <cba/libcba_exports.h>

namespace Teamcenter
{
    namespace cba
    {
        class Cba0PartProxyDelegate;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0PartProxyImpl;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0PartProxy;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0PartProxyGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CBA_API Teamcenter_alias::cba::Cba0PartProxyDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cba0PartProxyDelegate instance
    static Cba0PartProxyDelegate&  getInstance();

    //  Method to create the Cba0PartProxyImpl pointer
    static Cba0PartProxyImpl*  createImpl( Cba0PartProxy&  ifObj );

    //  Method to delete the Cba0PartProxyImpl pointer
    static void deleteImpl( Cba0PartProxyImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0_AuthorizationStateBase(const Cba0PartProxy &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Date Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0_EffectiveInDateBase(const Cba0PartProxy &ifObj,  date_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0_EffectiveInPointBase(const Cba0PartProxy &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Date Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0_EffectiveOutDateBase(const Cba0PartProxy &ifObj,  date_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0_EffectiveOutPointBase(const Cba0PartProxy &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0MadeFromPartBase(const Cba0PartProxy &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0PartFinishBase(const Cba0PartProxy &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0PartIdentifierBase(const Cba0PartProxy &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0RpsRpdByGroupIdBase(const Cba0PartProxy &ifObj,  std::string &value, bool &isNull ) const;



protected:
    //  Pointer to the instance
    static Cba0PartProxyDelegate*  m_pInstance;

    Cba0PartProxyDelegate();
    virtual ~Cba0PartProxyDelegate();
    static void setInstance( Cba0PartProxyDelegate*  instance );


private:
    friend class  ::Teamcenter::cba::Cba0PartProxyGenImpl;

};

#include <cba/libcba_undef.h>
#endif  //  TEAMCENTER__CBA__CBA0PARTPROXYDELEGATE_HXX
