//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cba0PersistentProxy
    Filename:   Cba0PersistentProxy.hxx
    Module:     cba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CBA__CBA0PERSISTENTPROXY__HXX
#define TEAMCENTER__CBA__CBA0PERSISTENTPROXY__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/Fnd0AbstractPersistentProxy.hxx>

#include <cba/libcba_exports.h>

namespace Teamcenter
{
    namespace cba
    {
        class Cba0PersistentProxy;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0PersistentProxyImpl;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0PersistentProxyDelegate;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0PersistentProxyDispatch;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0PersistentProxyGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CBA_API  Teamcenter::cba::Cba0PersistentProxy
     : public  ::Teamcenter::Fnd0AbstractPersistentProxy
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0ConsistencyStamp( int &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0DispName( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0PMMObjectID( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0VersionNum( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCba0PMMObjectID( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cba0PersistentProxy();

    /**
     * Destructor
     */
    virtual ~Cba0PersistentProxy();

private:
    //  Getter method for the Implementation Object
    Cba0PersistentProxyImpl*  getCba0PersistentProxyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCba0PersistentProxyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cba0PersistentProxyImpl*  m_cba0persistentproxyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cba0PersistentProxy - desc for Cba0PersistentProxy parameter
     */
    Cba0PersistentProxy( const Cba0PersistentProxy& );
    Cba0PersistentProxy& operator=( const Cba0PersistentProxy& );

    friend class  Cba0PersistentProxyDelegate;
    friend class  Cba0PersistentProxyDispatch;
    friend class  Cba0PersistentProxyGenImpl;
};

#include <cba/libcba_undef.h>
#endif //   TEAMCENTER__CBA__CBA0PERSISTENTPROXY__HXX
