//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cba0PersistentProxyDelegate
    Filename:   Cba0PersistentProxyDelegate.hxx
    Module:     cba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CBA__CBA0PERSISTENTPROXYDELEGATE_HXX
#define TEAMCENTER__CBA__CBA0PERSISTENTPROXYDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cba/Cba0PersistentProxy.hxx>

#include <cba/libcba_exports.h>

namespace Teamcenter
{
    namespace cba
    {
        class Cba0PersistentProxyDelegate;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0PersistentProxyImpl;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0PersistentProxy;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0PersistentProxyGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CBA_API Teamcenter_alias::cba::Cba0PersistentProxyDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cba0PersistentProxyDelegate instance
    static Cba0PersistentProxyDelegate&  getInstance();

    //  Method to create the Cba0PersistentProxyImpl pointer
    static Cba0PersistentProxyImpl*  createImpl( Cba0PersistentProxy&  ifObj );

    //  Method to delete the Cba0PersistentProxyImpl pointer
    static void deleteImpl( Cba0PersistentProxyImpl*  impl );


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0ConsistencyStampBase(const Cba0PersistentProxy &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0DispNameBase(const Cba0PersistentProxy &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0PMMObjectIDBase(const Cba0PersistentProxy &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0VersionNumBase(const Cba0PersistentProxy &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCba0PMMObjectIDBase(Cba0PersistentProxy &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static Cba0PersistentProxyDelegate*  m_pInstance;

    Cba0PersistentProxyDelegate();
    virtual ~Cba0PersistentProxyDelegate();
    static void setInstance( Cba0PersistentProxyDelegate*  instance );


private:
    friend class  ::Teamcenter::cba::Cba0PersistentProxyGenImpl;

};

#include <cba/libcba_undef.h>
#endif  //  TEAMCENTER__CBA__CBA0PERSISTENTPROXYDELEGATE_HXX
