//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cba0ProcurementProxy
    Filename:   Cba0ProcurementProxy.hxx
    Module:     cba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CBA__CBA0PROCUREMENTPROXY__HXX
#define TEAMCENTER__CBA__CBA0PROCUREMENTPROXY__HXX

#include <common/tc_deprecation_macros.h>
#include <cba/Cba0PersistentProxy.hxx>

#include <cba/libcba_exports.h>

namespace Teamcenter
{
    namespace cba
    {
        class Cba0ProcurementProxy;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0ProcurementProxyImpl;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0ProcurementProxyDelegate;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0ProcurementProxyDispatch;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0ProcurementProxyGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CBA_API  Teamcenter::cba::Cba0ProcurementProxy
     : public  ::Teamcenter::cba::Cba0PersistentProxy
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cba0ProcurementProxy();

    /**
     * Destructor
     */
    virtual ~Cba0ProcurementProxy();

private:
    //  Getter method for the Implementation Object
    Cba0ProcurementProxyImpl*  getCba0ProcurementProxyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCba0ProcurementProxyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cba0ProcurementProxyImpl*  m_cba0procurementproxyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cba0ProcurementProxy - desc for Cba0ProcurementProxy parameter
     */
    Cba0ProcurementProxy( const Cba0ProcurementProxy& );
    Cba0ProcurementProxy& operator=( const Cba0ProcurementProxy& );

    friend class  Cba0ProcurementProxyDelegate;
    friend class  Cba0ProcurementProxyDispatch;
    friend class  Cba0ProcurementProxyGenImpl;
};

#include <cba/libcba_undef.h>
#endif //   TEAMCENTER__CBA__CBA0PROCUREMENTPROXY__HXX
