//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cba0SGUProxy
    Filename:   Cba0SGUProxy.hxx
    Module:     cba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CBA__CBA0SGUPROXY__HXX
#define TEAMCENTER__CBA__CBA0SGUPROXY__HXX

#include <common/tc_deprecation_macros.h>
#include <cba/Cba0PersistentProxy.hxx>

#include <cba/libcba_exports.h>

namespace Teamcenter
{
    namespace cba
    {
        class Cba0SGUProxy;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0SGUProxyImpl;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0SGUProxyDelegate;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0SGUProxyDispatch;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0SGUProxyGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CBA_API  Teamcenter::cba::Cba0SGUProxy
     : public  ::Teamcenter::cba::Cba0PersistentProxy
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cba0SGUProxy();

    /**
     * Destructor
     */
    virtual ~Cba0SGUProxy();

private:
    //  Getter method for the Implementation Object
    Cba0SGUProxyImpl*  getCba0SGUProxyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCba0SGUProxyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cba0SGUProxyImpl*  m_cba0sguproxyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cba0SGUProxy - desc for Cba0SGUProxy parameter
     */
    Cba0SGUProxy( const Cba0SGUProxy& );
    Cba0SGUProxy& operator=( const Cba0SGUProxy& );

    friend class  Cba0SGUProxyDelegate;
    friend class  Cba0SGUProxyDispatch;
    friend class  Cba0SGUProxyGenImpl;
};

#include <cba/libcba_undef.h>
#endif //   TEAMCENTER__CBA__CBA0SGUPROXY__HXX
