//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cba0SolutionProcProxy
    Filename:   Cba0SolutionProcProxy.hxx
    Module:     cba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CBA__CBA0SOLUTIONPROCPROXY__HXX
#define TEAMCENTER__CBA__CBA0SOLUTIONPROCPROXY__HXX

#include <common/tc_deprecation_macros.h>
#include <cba/Cba0ProcurementProxy.hxx>

#include <cba/libcba_exports.h>

namespace Teamcenter
{
    namespace cba
    {
        class Cba0SolutionProcProxy;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0SolutionProcProxyImpl;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0SolutionProcProxyDelegate;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0SolutionProcProxyDispatch;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0SolutionProcProxyGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CBA_API  Teamcenter::cba::Cba0SolutionProcProxy
     : public  ::Teamcenter::cba::Cba0ProcurementProxy
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cba0SolutionProcProxy();

    /**
     * Destructor
     */
    virtual ~Cba0SolutionProcProxy();

private:
    //  Getter method for the Implementation Object
    Cba0SolutionProcProxyImpl*  getCba0SolutionProcProxyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCba0SolutionProcProxyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cba0SolutionProcProxyImpl*  m_cba0solutionprocproxyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cba0SolutionProcProxy - desc for Cba0SolutionProcProxy parameter
     */
    Cba0SolutionProcProxy( const Cba0SolutionProcProxy& );
    Cba0SolutionProcProxy& operator=( const Cba0SolutionProcProxy& );

    friend class  Cba0SolutionProcProxyDelegate;
    friend class  Cba0SolutionProcProxyDispatch;
    friend class  Cba0SolutionProcProxyGenImpl;
};

#include <cba/libcba_undef.h>
#endif //   TEAMCENTER__CBA__CBA0SOLUTIONPROCPROXY__HXX
