//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cba0SolutionProxy
    Filename:   Cba0SolutionProxy.hxx
    Module:     cba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CBA__CBA0SOLUTIONPROXY__HXX
#define TEAMCENTER__CBA__CBA0SOLUTIONPROXY__HXX

#include <common/tc_deprecation_macros.h>
#include <cba/Cba0PersistentProxy.hxx>

#include <cba/libcba_exports.h>

namespace Teamcenter
{
    namespace cba
    {
        class Cba0SolutionProxy;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0SolutionProxyImpl;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0SolutionProxyDelegate;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0SolutionProxyDispatch;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class Cba0SolutionProxyGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CBA_API  Teamcenter::cba::Cba0SolutionProxy
     : public  ::Teamcenter::cba::Cba0PersistentProxy
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cba0SolutionProxy();

    /**
     * Destructor
     */
    virtual ~Cba0SolutionProxy();

private:
    //  Getter method for the Implementation Object
    Cba0SolutionProxyImpl*  getCba0SolutionProxyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCba0SolutionProxyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cba0SolutionProxyImpl*  m_cba0solutionproxyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cba0SolutionProxy - desc for Cba0SolutionProxy parameter
     */
    Cba0SolutionProxy( const Cba0SolutionProxy& );
    Cba0SolutionProxy& operator=( const Cba0SolutionProxy& );

    friend class  Cba0SolutionProxyDelegate;
    friend class  Cba0SolutionProxyDispatch;
    friend class  Cba0SolutionProxyGenImpl;
};

#include <cba/libcba_undef.h>
#endif //   TEAMCENTER__CBA__CBA0SOLUTIONPROXY__HXX
