//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DesignProxy
    Filename:   DesignProxy.hxx
    Module:     cba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CBA__DESIGNPROXY__HXX
#define TEAMCENTER__CBA__DESIGNPROXY__HXX

#include <common/tc_deprecation_macros.h>
#include <cba/TcUsageProxy.hxx>

#include <cba/libcba_exports.h>

namespace Teamcenter
{
    namespace cba
    {
        class DesignProxy;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class DesignProxyImpl;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class DesignProxyDelegate;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class DesignProxyDispatch;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class DesignProxyGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CBA_API  Teamcenter::cba::DesignProxy
     : public  ::Teamcenter::cba::TcUsageProxy
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    DesignProxy();

    /**
     * Destructor
     */
    virtual ~DesignProxy();

private:
    //  Getter method for the Implementation Object
    DesignProxyImpl*  getDesignProxyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDesignProxyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DesignProxyImpl*  m_designproxyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param DesignProxy - desc for DesignProxy parameter
     */
    DesignProxy( const DesignProxy& );
    DesignProxy& operator=( const DesignProxy& );

    friend class  DesignProxyDelegate;
    friend class  DesignProxyDispatch;
    friend class  DesignProxyGenImpl;
};

#include <cba/libcba_undef.h>
#endif //   TEAMCENTER__CBA__DESIGNPROXY__HXX
