//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DrawingProxy
    Filename:   DrawingProxy.hxx
    Module:     cba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CBA__DRAWINGPROXY__HXX
#define TEAMCENTER__CBA__DRAWINGPROXY__HXX

#include <common/tc_deprecation_macros.h>
#include <cba/TcUsageProxy.hxx>

#include <cba/libcba_exports.h>

namespace Teamcenter
{
    namespace cba
    {
        class DrawingProxy;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class DrawingProxyImpl;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class DrawingProxyDelegate;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class DrawingProxyDispatch;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class DrawingProxyGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CBA_API  Teamcenter::cba::DrawingProxy
     : public  ::Teamcenter::cba::TcUsageProxy
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    DrawingProxy();

    /**
     * Destructor
     */
    virtual ~DrawingProxy();

private:
    //  Getter method for the Implementation Object
    DrawingProxyImpl*  getDrawingProxyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDrawingProxyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DrawingProxyImpl*  m_drawingproxyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param DrawingProxy - desc for DrawingProxy parameter
     */
    DrawingProxy( const DrawingProxy& );
    DrawingProxy& operator=( const DrawingProxy& );

    friend class  DrawingProxyDelegate;
    friend class  DrawingProxyDispatch;
    friend class  DrawingProxyGenImpl;
};

#include <cba/libcba_undef.h>
#endif //   TEAMCENTER__CBA__DRAWINGPROXY__HXX
