//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DrawingSheetProxy
    Filename:   DrawingSheetProxy.hxx
    Module:     cba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CBA__DRAWINGSHEETPROXY__HXX
#define TEAMCENTER__CBA__DRAWINGSHEETPROXY__HXX

#include <common/tc_deprecation_macros.h>
#include <cba/TcUsageProxy.hxx>

#include <cba/libcba_exports.h>

namespace Teamcenter
{
    namespace cba
    {
        class DrawingSheetProxy;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class DrawingSheetProxyImpl;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class DrawingSheetProxyDelegate;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class DrawingSheetProxyDispatch;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class DrawingSheetProxyGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CBA_API  Teamcenter::cba::DrawingSheetProxy
     : public  ::Teamcenter::cba::TcUsageProxy
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    DrawingSheetProxy();

    /**
     * Destructor
     */
    virtual ~DrawingSheetProxy();

private:
    //  Getter method for the Implementation Object
    DrawingSheetProxyImpl*  getDrawingSheetProxyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDrawingSheetProxyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DrawingSheetProxyImpl*  m_drawingsheetproxyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param DrawingSheetProxy - desc for DrawingSheetProxy parameter
     */
    DrawingSheetProxy( const DrawingSheetProxy& );
    DrawingSheetProxy& operator=( const DrawingSheetProxy& );

    friend class  DrawingSheetProxyDelegate;
    friend class  DrawingSheetProxyDispatch;
    friend class  DrawingSheetProxyGenImpl;
};

#include <cba/libcba_undef.h>
#endif //   TEAMCENTER__CBA__DRAWINGSHEETPROXY__HXX
