//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MUGProxy
    Filename:   MUGProxy.hxx
    Module:     cba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CBA__MUGPROXY__HXX
#define TEAMCENTER__CBA__MUGPROXY__HXX

#include <common/tc_deprecation_macros.h>
#include <cba/TcUsageProxy.hxx>

#include <cba/libcba_exports.h>

namespace Teamcenter
{
    namespace cba
    {
        class MUGProxy;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class MUGProxyImpl;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class MUGProxyDelegate;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class MUGProxyDispatch;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class MUGProxyGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CBA_API  Teamcenter::cba::MUGProxy
     : public  ::Teamcenter::cba::TcUsageProxy
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    MUGProxy();

    /**
     * Destructor
     */
    virtual ~MUGProxy();

private:
    //  Getter method for the Implementation Object
    MUGProxyImpl*  getMUGProxyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMUGProxyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    MUGProxyImpl*  m_mugproxyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param MUGProxy - desc for MUGProxy parameter
     */
    MUGProxy( const MUGProxy& );
    MUGProxy& operator=( const MUGProxy& );

    friend class  MUGProxyDelegate;
    friend class  MUGProxyDispatch;
    friend class  MUGProxyGenImpl;
};

#include <cba/libcba_undef.h>
#endif //   TEAMCENTER__CBA__MUGPROXY__HXX
