//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PartApplicationProxy
    Filename:   PartApplicationProxy.hxx
    Module:     cba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CBA__PARTAPPLICATIONPROXY__HXX
#define TEAMCENTER__CBA__PARTAPPLICATIONPROXY__HXX

#include <common/tc_deprecation_macros.h>
#include <cba/TcUsageProxy.hxx>

#include <cba/libcba_exports.h>

namespace Teamcenter
{
    namespace cba
    {
        class PartApplicationProxy;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class PartApplicationProxyImpl;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class PartApplicationProxyDelegate;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class PartApplicationProxyDispatch;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class PartApplicationProxyGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CBA_API  Teamcenter::cba::PartApplicationProxy
     : public  ::Teamcenter::cba::TcUsageProxy
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PartApplicationProxy();

    /**
     * Destructor
     */
    virtual ~PartApplicationProxy();

private:
    //  Getter method for the Implementation Object
    PartApplicationProxyImpl*  getPartApplicationProxyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPartApplicationProxyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PartApplicationProxyImpl*  m_partapplicationproxyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PartApplicationProxy - desc for PartApplicationProxy parameter
     */
    PartApplicationProxy( const PartApplicationProxy& );
    PartApplicationProxy& operator=( const PartApplicationProxy& );

    friend class  PartApplicationProxyDelegate;
    friend class  PartApplicationProxyDispatch;
    friend class  PartApplicationProxyGenImpl;
};

#include <cba/libcba_undef.h>
#endif //   TEAMCENTER__CBA__PARTAPPLICATIONPROXY__HXX
