//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PartOccThread
    Filename:   PartOccThread.hxx
    Module:     cba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CBA__PARTOCCTHREAD__HXX
#define TEAMCENTER__CBA__PARTOCCTHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <cba/libcba_exports.h>

namespace Teamcenter
{
    namespace cba
    {
        class PartOccThread;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class PartOccThreadImpl;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class PartOccThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class PartOccThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class PartOccThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CBA_API  Teamcenter::cba::PartOccThread
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PartOccThread();

    /**
     * Destructor
     */
    virtual ~PartOccThread();

private:
    //  Getter method for the Implementation Object
    PartOccThreadImpl*  getPartOccThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPartOccThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PartOccThreadImpl*  m_partoccthreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PartOccThread - desc for PartOccThread parameter
     */
    PartOccThread( const PartOccThread& );
    PartOccThread& operator=( const PartOccThread& );

    friend class  PartOccThreadDelegate;
    friend class  PartOccThreadDispatch;
    friend class  PartOccThreadGenImpl;
};

#include <cba/libcba_undef.h>
#endif //   TEAMCENTER__CBA__PARTOCCTHREAD__HXX
