//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PartToPartOccThreadProxy
    Filename:   PartToPartOccThreadProxy.hxx
    Module:     cba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CBA__PARTTOPARTOCCTHREADPROXY__HXX
#define TEAMCENTER__CBA__PARTTOPARTOCCTHREADPROXY__HXX

#include <common/tc_deprecation_macros.h>
#include <cba/TcUsageProxy.hxx>

#include <cba/libcba_exports.h>

namespace Teamcenter
{
    namespace cba
    {
        class PartToPartOccThreadProxy;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class PartToPartOccThreadProxyImpl;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class PartToPartOccThreadProxyDelegate;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class PartToPartOccThreadProxyDispatch;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class PartToPartOccThreadProxyGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CBA_API  Teamcenter::cba::PartToPartOccThreadProxy
     : public  ::Teamcenter::cba::TcUsageProxy
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PartToPartOccThreadProxy();

    /**
     * Destructor
     */
    virtual ~PartToPartOccThreadProxy();

private:
    //  Getter method for the Implementation Object
    PartToPartOccThreadProxyImpl*  getPartToPartOccThreadProxyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPartToPartOccThreadProxyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PartToPartOccThreadProxyImpl*  m_parttopartoccthreadproxyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PartToPartOccThreadProxy - desc for PartToPartOccThreadProxy parameter
     */
    PartToPartOccThreadProxy( const PartToPartOccThreadProxy& );
    PartToPartOccThreadProxy& operator=( const PartToPartOccThreadProxy& );

    friend class  PartToPartOccThreadProxyDelegate;
    friend class  PartToPartOccThreadProxyDispatch;
    friend class  PartToPartOccThreadProxyGenImpl;
};

#include <cba/libcba_undef.h>
#endif //   TEAMCENTER__CBA__PARTTOPARTOCCTHREADPROXY__HXX
