//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PartToPartProxy
    Filename:   PartToPartProxy.hxx
    Module:     cba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CBA__PARTTOPARTPROXY__HXX
#define TEAMCENTER__CBA__PARTTOPARTPROXY__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <cba/TcUsageProxy.hxx>

#include <cba/libcba_exports.h>

namespace Teamcenter
{
    namespace cba
    {
        class PartToPartProxy;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class PartToPartProxyImpl;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class PartToPartProxyDelegate;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class PartToPartProxyDispatch;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class PartToPartProxyGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CBA_API  Teamcenter::cba::PartToPartProxy
     : public  ::Teamcenter::cba::TcUsageProxy
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCba0ConsistencyStamp( std::string &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PartToPartProxy();

    /**
     * Destructor
     */
    virtual ~PartToPartProxy();

private:
    //  Getter method for the Implementation Object
    PartToPartProxyImpl*  getPartToPartProxyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPartToPartProxyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PartToPartProxyImpl*  m_parttopartproxyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PartToPartProxy - desc for PartToPartProxy parameter
     */
    PartToPartProxy( const PartToPartProxy& );
    PartToPartProxy& operator=( const PartToPartProxy& );

    friend class  PartToPartProxyDelegate;
    friend class  PartToPartProxyDispatch;
    friend class  PartToPartProxyGenImpl;
};

#include <cba/libcba_undef.h>
#endif //   TEAMCENTER__CBA__PARTTOPARTPROXY__HXX
