//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PositionDesignatorProxy
    Filename:   PositionDesignatorProxy.hxx
    Module:     cba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CBA__POSITIONDESIGNATORPROXY__HXX
#define TEAMCENTER__CBA__POSITIONDESIGNATORPROXY__HXX

#include <common/tc_deprecation_macros.h>
#include <cba/TcUsageProxy.hxx>

#include <cba/libcba_exports.h>

namespace Teamcenter
{
    namespace cba
    {
        class PositionDesignatorProxy;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class PositionDesignatorProxyImpl;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class PositionDesignatorProxyDelegate;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class PositionDesignatorProxyDispatch;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class PositionDesignatorProxyGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CBA_API  Teamcenter::cba::PositionDesignatorProxy
     : public  ::Teamcenter::cba::TcUsageProxy
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PositionDesignatorProxy();

    /**
     * Destructor
     */
    virtual ~PositionDesignatorProxy();

private:
    //  Getter method for the Implementation Object
    PositionDesignatorProxyImpl*  getPositionDesignatorProxyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPositionDesignatorProxyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PositionDesignatorProxyImpl*  m_positiondesignatorproxyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PositionDesignatorProxy - desc for PositionDesignatorProxy parameter
     */
    PositionDesignatorProxy( const PositionDesignatorProxy& );
    PositionDesignatorProxy& operator=( const PositionDesignatorProxy& );

    friend class  PositionDesignatorProxyDelegate;
    friend class  PositionDesignatorProxyDispatch;
    friend class  PositionDesignatorProxyGenImpl;
};

#include <cba/libcba_undef.h>
#endif //   TEAMCENTER__CBA__POSITIONDESIGNATORPROXY__HXX
