//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SubUsageProxy
    Filename:   SubUsageProxy.hxx
    Module:     cba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CBA__SUBUSAGEPROXY__HXX
#define TEAMCENTER__CBA__SUBUSAGEPROXY__HXX

#include <common/tc_deprecation_macros.h>
#include <cba/TcUsageProxy.hxx>

#include <cba/libcba_exports.h>

namespace Teamcenter
{
    namespace cba
    {
        class SubUsageProxy;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class SubUsageProxyImpl;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class SubUsageProxyDelegate;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class SubUsageProxyDispatch;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class SubUsageProxyGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CBA_API  Teamcenter::cba::SubUsageProxy
     : public  ::Teamcenter::cba::TcUsageProxy
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SubUsageProxy();

    /**
     * Destructor
     */
    virtual ~SubUsageProxy();

private:
    //  Getter method for the Implementation Object
    SubUsageProxyImpl*  getSubUsageProxyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSubUsageProxyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SubUsageProxyImpl*  m_subusageproxyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SubUsageProxy - desc for SubUsageProxy parameter
     */
    SubUsageProxy( const SubUsageProxy& );
    SubUsageProxy& operator=( const SubUsageProxy& );

    friend class  SubUsageProxyDelegate;
    friend class  SubUsageProxyDispatch;
    friend class  SubUsageProxyGenImpl;
};

#include <cba/libcba_undef.h>
#endif //   TEAMCENTER__CBA__SUBUSAGEPROXY__HXX
