//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TcUsagePartOcc
    Filename:   TcUsagePartOcc.hxx
    Module:     cba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CBA__TCUSAGEPARTOCC__HXX
#define TEAMCENTER__CBA__TCUSAGEPARTOCC__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <cba/libcba_exports.h>

namespace Teamcenter
{
    namespace cba
    {
        class TcUsagePartOcc;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class TcUsagePartOccImpl;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class TcUsagePartOccDelegate;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class TcUsagePartOccDispatch;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class TcUsagePartOccGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CBA_API  Teamcenter::cba::TcUsagePartOcc
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    TcUsagePartOcc();

    /**
     * Destructor
     */
    virtual ~TcUsagePartOcc();

private:
    //  Getter method for the Implementation Object
    TcUsagePartOccImpl*  getTcUsagePartOccImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTcUsagePartOccImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    TcUsagePartOccImpl*  m_tcusagepartoccImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param TcUsagePartOcc - desc for TcUsagePartOcc parameter
     */
    TcUsagePartOcc( const TcUsagePartOcc& );
    TcUsagePartOcc& operator=( const TcUsagePartOcc& );

    friend class  TcUsagePartOccDelegate;
    friend class  TcUsagePartOccDispatch;
    friend class  TcUsagePartOccGenImpl;
};

#include <cba/libcba_undef.h>
#endif //   TEAMCENTER__CBA__TCUSAGEPARTOCC__HXX
