//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TcUsageProxy
    Filename:   TcUsageProxy.hxx
    Module:     cba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CBA__TCUSAGEPROXY__HXX
#define TEAMCENTER__CBA__TCUSAGEPROXY__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <cba/libcba_exports.h>

namespace Teamcenter
{
    namespace cba
    {
        class TcUsageProxy;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class TcUsageProxyImpl;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class TcUsageProxyDelegate;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class TcUsageProxyDispatch;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class TcUsageProxyGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CBA_API  Teamcenter::cba::TcUsageProxy
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    TcUsageProxy();

    /**
     * Destructor
     */
    virtual ~TcUsageProxy();

private:
    //  Getter method for the Implementation Object
    TcUsageProxyImpl*  getTcUsageProxyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTcUsageProxyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    TcUsageProxyImpl*  m_tcusageproxyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param TcUsageProxy - desc for TcUsageProxy parameter
     */
    TcUsageProxy( const TcUsageProxy& );
    TcUsageProxy& operator=( const TcUsageProxy& );

    friend class  TcUsageProxyDelegate;
    friend class  TcUsageProxyDispatch;
    friend class  TcUsageProxyGenImpl;
};

#include <cba/libcba_undef.h>
#endif //   TEAMCENTER__CBA__TCUSAGEPROXY__HXX
