//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, UsageAddressProxy
    Filename:   UsageAddressProxy.hxx
    Module:     cba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CBA__USAGEADDRESSPROXY__HXX
#define TEAMCENTER__CBA__USAGEADDRESSPROXY__HXX

#include <common/tc_deprecation_macros.h>
#include <cba/TcUsageProxy.hxx>

#include <cba/libcba_exports.h>

namespace Teamcenter
{
    namespace cba
    {
        class UsageAddressProxy;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class UsageAddressProxyImpl;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class UsageAddressProxyDelegate;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class UsageAddressProxyDispatch;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class UsageAddressProxyGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CBA_API  Teamcenter::cba::UsageAddressProxy
     : public  ::Teamcenter::cba::TcUsageProxy
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    UsageAddressProxy();

    /**
     * Destructor
     */
    virtual ~UsageAddressProxy();

private:
    //  Getter method for the Implementation Object
    UsageAddressProxyImpl*  getUsageAddressProxyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setUsageAddressProxyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    UsageAddressProxyImpl*  m_usageaddressproxyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param UsageAddressProxy - desc for UsageAddressProxy parameter
     */
    UsageAddressProxy( const UsageAddressProxy& );
    UsageAddressProxy& operator=( const UsageAddressProxy& );

    friend class  UsageAddressProxyDelegate;
    friend class  UsageAddressProxyDispatch;
    friend class  UsageAddressProxyGenImpl;
};

#include <cba/libcba_undef.h>
#endif //   TEAMCENTER__CBA__USAGEADDRESSPROXY__HXX
