//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, UsageConfigurationContext
    Filename:   UsageConfigurationContext.hxx
    Module:     cba
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CBA__USAGECONFIGURATIONCONTEXT__HXX
#define TEAMCENTER__CBA__USAGECONFIGURATIONCONTEXT__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <cba/libcba_exports.h>

namespace Teamcenter
{
    namespace cba
    {
        class UsageConfigurationContext;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class UsageConfigurationContextImpl;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class UsageConfigurationContextDelegate;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class UsageConfigurationContextDispatch;
    }
}
namespace Teamcenter
{
    namespace cba
    {
        class UsageConfigurationContextGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CBA_API  Teamcenter::cba::UsageConfigurationContext
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    UsageConfigurationContext();

    /**
     * Destructor
     */
    virtual ~UsageConfigurationContext();

private:
    //  Getter method for the Implementation Object
    UsageConfigurationContextImpl*  getUsageConfigurationContextImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setUsageConfigurationContextImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    UsageConfigurationContextImpl*  m_usageconfigurationcontextImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param UsageConfigurationContext - desc for UsageConfigurationContext parameter
     */
    UsageConfigurationContext( const UsageConfigurationContext& );
    UsageConfigurationContext& operator=( const UsageConfigurationContext& );

    friend class  UsageConfigurationContextDelegate;
    friend class  UsageConfigurationContextDispatch;
    friend class  UsageConfigurationContextGenImpl;
};

#include <cba/libcba_undef.h>
#endif //   TEAMCENTER__CBA__USAGECONFIGURATIONCONTEXT__HXX
