//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  cba

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libcba

#if !defined(LIBCBA) && !defined(IPLIB)
#   error IPLIB or LIBCBA is not defined
#endif

/* Handwritten code should use CBA_API, not CBAEXPORT */

#define CBA_API CBAEXPORT

#if IPLIB==libcba || defined(LIBCBA)
#   if defined(__lint)
#       define CBAEXPORT       __export(cba)
#       define CBAGLOBAL       extern __global(cba)
#       define CBAPRIVATE      extern __private(cba)
#   elif defined(_WIN32)
#       define CBAEXPORT       __declspec(dllexport)
#       define CBAGLOBAL       extern __declspec(dllexport)
#       define CBAPRIVATE      extern
#   else
#       define CBAEXPORT
#       define CBAGLOBAL       extern
#       define CBAPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CBAEXPORT       __export(cba)
#       define CBAGLOBAL       extern __global(cba)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CBAEXPORT      __declspec(dllimport)
#       define CBAGLOBAL       extern __declspec(dllimport)
#   else
#       define CBAEXPORT
#       define CBAGLOBAL       extern
#   endif
#endif
