//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  cbadispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libcbadispatch

#if !defined(LIBCBADISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBCBADISPATCH is not defined
#endif

/* Handwritten code should use CBADISPATCH_API, not CBADISPATCHEXPORT */

#define CBADISPATCH_API CBADISPATCHEXPORT

#if IPLIB==libcbadispatch || defined(LIBCBADISPATCH)
#   if defined(__lint)
#       define CBADISPATCHEXPORT       __export(cbadispatch)
#       define CBADISPATCHGLOBAL       extern __global(cbadispatch)
#       define CBADISPATCHPRIVATE      extern __private(cbadispatch)
#   elif defined(_WIN32)
#       define CBADISPATCHEXPORT       __declspec(dllexport)
#       define CBADISPATCHGLOBAL       extern __declspec(dllexport)
#       define CBADISPATCHPRIVATE      extern
#   else
#       define CBADISPATCHEXPORT
#       define CBADISPATCHGLOBAL       extern
#       define CBADISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CBADISPATCHEXPORT       __export(cbadispatch)
#       define CBADISPATCHGLOBAL       extern __global(cbadispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CBADISPATCHEXPORT      __declspec(dllimport)
#       define CBADISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define CBADISPATCHEXPORT
#       define CBADISPATCHGLOBAL       extern
#   endif
#endif
