//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BitDefDelegate
    Filename:   BitDefDelegate.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__BITDEFDELEGATE_HXX
#define CCDM__BITDEFDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ccdm/BitDef.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class BitDefDelegate;
}
namespace ccdm
{
    class BitDefImpl;
}
namespace ccdm
{
    class BitDef;
}
namespace ccdm
{
    class BitDefGenImpl;
}

namespace ccdm_alias = ::ccdm;


class  CCDM_API ccdm_alias::BitDefDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the BitDefDelegate instance
    static BitDefDelegate&  getInstance();

    //  Method to create the BitDefImpl pointer
    static BitDefImpl*  createImpl( BitDef&  ifObj );

    //  Method to delete the BitDefImpl pointer
    static void deleteImpl( BitDefImpl*  impl );


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBitBase(const BitDef &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getByteBase(const BitDef &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMeaningOf0Base(const BitDef &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMeaningOf1Base(const BitDef &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getNameBase(const BitDef &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setBitBase(BitDef &ifObj,  int value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setByteBase(BitDef &ifObj,  int value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMeaningOf0Base(BitDef &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMeaningOf1Base(BitDef &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setNameBase(BitDef &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static BitDefDelegate*  m_pInstance;

    BitDefDelegate();
    virtual ~BitDefDelegate();
    static void setInstance( BitDefDelegate*  instance );


private:
    friend class  ::ccdm::BitDefGenImpl;

};

#include <ccdm/libccdm_undef.h>
#endif  //  CCDM__BITDEFDELEGATE_HXX
