//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BitValue
    Filename:   BitValue.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__BITVALUE__HXX
#define CCDM__BITVALUE__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class BitValue;
}
namespace ccdm
{
    class BitValueImpl;
}
namespace ccdm
{
    class BitValueDelegate;
}
namespace ccdm
{
    class BitValueDispatch;
}
namespace ccdm
{
    class BitValueGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CCDM_API  ccdm::BitValue
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDefinition( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValue( bool &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDefinition( const tag_t &value, bool isNull=false );

    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValue( bool value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    BitValue();

    /**
     * Destructor
     */
    virtual ~BitValue();

private:
    //  Getter method for the Implementation Object
    BitValueImpl*  getBitValueImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBitValueImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    BitValueImpl*  m_bitvalueImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param BitValue - desc for BitValue parameter
     */
    BitValue( const BitValue& );
    BitValue& operator=( const BitValue& );

    friend class  BitValueDelegate;
    friend class  BitValueDispatch;
    friend class  BitValueGenImpl;
};

#include <ccdm/libccdm_undef.h>
#endif //   CCDM__BITVALUE__HXX
