//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BitValueDelegate
    Filename:   BitValueDelegate.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__BITVALUEDELEGATE_HXX
#define CCDM__BITVALUEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ccdm/BitValue.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class BitValueDelegate;
}
namespace ccdm
{
    class BitValueImpl;
}
namespace ccdm
{
    class BitValue;
}
namespace ccdm
{
    class BitValueGenImpl;
}

namespace ccdm_alias = ::ccdm;


class  CCDM_API ccdm_alias::BitValueDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the BitValueDelegate instance
    static BitValueDelegate&  getInstance();

    //  Method to create the BitValueImpl pointer
    static BitValueImpl*  createImpl( BitValue&  ifObj );

    //  Method to delete the BitValueImpl pointer
    static void deleteImpl( BitValueImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDefinitionBase(const BitValue &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValueBase(const BitValue &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDefinitionBase(BitValue &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValueBase(BitValue &ifObj,  bool value, bool isNull );



protected:
    //  Pointer to the instance
    static BitValueDelegate*  m_pInstance;

    BitValueDelegate();
    virtual ~BitValueDelegate();
    static void setInstance( BitValueDelegate*  instance );


private:
    friend class  ::ccdm::BitValueGenImpl;

};

#include <ccdm/libccdm_undef.h>
#endif  //  CCDM__BITVALUEDELEGATE_HXX
