//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CalParmRevisionDelegate
    Filename:   CalParmRevisionDelegate.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__CALPARMREVISIONDELEGATE_HXX
#define CCDM__CALPARMREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ccdm/CalParmRevision.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class CalParmRevisionDelegate;
}
namespace ccdm
{
    class CalParmRevisionImpl;
}
namespace ccdm
{
    class CalParmRevision;
}
namespace ccdm
{
    class CalParmRevisionGenImpl;
}

namespace ccdm_alias = ::ccdm;


class  CCDM_API ccdm_alias::CalParmRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CalParmRevisionDelegate instance
    static CalParmRevisionDelegate&  getInstance();

    //  Method to create the CalParmRevisionImpl pointer
    static CalParmRevisionImpl*  createImpl( CalParmRevision&  ifObj );

    //  Method to delete the CalParmRevisionImpl pointer
    static void deleteImpl( CalParmRevisionImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCommentBase(const CalParmRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getControlEngineerBase(const CalParmRevision &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getParmDescriptorBase(const CalParmRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSpecialistBase(const CalParmRevision &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getUserDataBase(const CalParmRevision &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCommentBase(CalParmRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setControlEngineerBase(CalParmRevision &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setParmDescriptorBase(CalParmRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSpecialistBase(CalParmRevision &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setUserDataBase(CalParmRevision &ifObj,  const tag_t &value, bool isNull );



protected:
    //  Pointer to the instance
    static CalParmRevisionDelegate*  m_pInstance;

    CalParmRevisionDelegate();
    virtual ~CalParmRevisionDelegate();
    static void setInstance( CalParmRevisionDelegate*  instance );


private:
    friend class  ::ccdm::CalParmRevisionGenImpl;

};

#include <ccdm/libccdm_undef.h>
#endif  //  CCDM__CALPARMREVISIONDELEGATE_HXX
