//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ccd0ConvOverrideRecord
    Filename:   Ccd0ConvOverrideRecord.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__CCD0CONVOVERRIDERECORD__HXX
#define CCDM__CCD0CONVOVERRIDERECORD__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <ccdm/Ccd0ParmDefOverrideRecord.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class Ccd0ConvOverrideRecord;
}
namespace ccdm
{
    class Ccd0ConvOverrideRecordImpl;
}
namespace ccdm
{
    class Ccd0ConvOverrideRecordDelegate;
}
namespace ccdm
{
    class Ccd0ConvOverrideRecordDispatch;
}
namespace ccdm
{
    class Ccd0ConvOverrideRecordGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CCDM_API  ccdm::Ccd0ConvOverrideRecord
     : public  ::ccdm::Ccd0ParmDefOverrideRecord
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCcd0ConversionRule( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCcd0ConversionRule( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ccd0ConvOverrideRecord();

    /**
     * Destructor
     */
    virtual ~Ccd0ConvOverrideRecord();

private:
    //  Getter method for the Implementation Object
    Ccd0ConvOverrideRecordImpl*  getCcd0ConvOverrideRecordImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCcd0ConvOverrideRecordImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ccd0ConvOverrideRecordImpl*  m_ccd0convoverriderecordImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ccd0ConvOverrideRecord - desc for Ccd0ConvOverrideRecord parameter
     */
    Ccd0ConvOverrideRecord( const Ccd0ConvOverrideRecord& );
    Ccd0ConvOverrideRecord& operator=( const Ccd0ConvOverrideRecord& );

    friend class  Ccd0ConvOverrideRecordDelegate;
    friend class  Ccd0ConvOverrideRecordDispatch;
    friend class  Ccd0ConvOverrideRecordGenImpl;
};

#include <ccdm/libccdm_undef.h>
#endif //   CCDM__CCD0CONVOVERRIDERECORD__HXX
