//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ccd0ConvOverrideRecordDelegate
    Filename:   Ccd0ConvOverrideRecordDelegate.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__CCD0CONVOVERRIDERECORDDELEGATE_HXX
#define CCDM__CCD0CONVOVERRIDERECORDDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ccdm/Ccd0ConvOverrideRecord.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class Ccd0ConvOverrideRecordDelegate;
}
namespace ccdm
{
    class Ccd0ConvOverrideRecordImpl;
}
namespace ccdm
{
    class Ccd0ConvOverrideRecord;
}
namespace ccdm
{
    class Ccd0ConvOverrideRecordGenImpl;
}

namespace ccdm_alias = ::ccdm;


class  CCDM_API ccdm_alias::Ccd0ConvOverrideRecordDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Ccd0ConvOverrideRecordDelegate instance
    static Ccd0ConvOverrideRecordDelegate&  getInstance();

    //  Method to create the Ccd0ConvOverrideRecordImpl pointer
    static Ccd0ConvOverrideRecordImpl*  createImpl( Ccd0ConvOverrideRecord&  ifObj );

    //  Method to delete the Ccd0ConvOverrideRecordImpl pointer
    static void deleteImpl( Ccd0ConvOverrideRecordImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCcd0ConversionRuleBase(const Ccd0ConvOverrideRecord &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCcd0ConversionRuleBase(Ccd0ConvOverrideRecord &ifObj,  const tag_t &value, bool isNull );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Ccd0ConvOverrideRecord &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Ccd0ConvOverrideRecordDelegate*  m_pInstance;

    Ccd0ConvOverrideRecordDelegate();
    virtual ~Ccd0ConvOverrideRecordDelegate();
    static void setInstance( Ccd0ConvOverrideRecordDelegate*  instance );


private:
    friend class  ::ccdm::Ccd0ConvOverrideRecordGenImpl;

};

#include <ccdm/libccdm_undef.h>
#endif  //  CCDM__CCD0CONVOVERRIDERECORDDELEGATE_HXX
