//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ccd0MemoryContent
    Filename:   Ccd0MemoryContent.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__CCD0MEMORYCONTENT__HXX
#define CCDM__CCD0MEMORYCONTENT__HXX

#include <common/tc_deprecation_macros.h>
#include <Mem0memmgt/Mem0MemoryContent.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class Ccd0MemoryContent;
}
namespace ccdm
{
    class Ccd0MemoryContentImpl;
}
namespace ccdm
{
    class Ccd0MemoryContentDelegate;
}
namespace ccdm
{
    class Ccd0MemoryContentDispatch;
}
namespace ccdm
{
    class Ccd0MemoryContentGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CCDM_API  ccdm::Ccd0MemoryContent
     : public  ::ccdm::Mem0MemoryContent
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ccd0MemoryContent();

    /**
     * Destructor
     */
    virtual ~Ccd0MemoryContent();

private:
    //  Getter method for the Implementation Object
    Ccd0MemoryContentImpl*  getCcd0MemoryContentImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCcd0MemoryContentImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ccd0MemoryContentImpl*  m_ccd0memorycontentImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ccd0MemoryContent - desc for Ccd0MemoryContent parameter
     */
    Ccd0MemoryContent( const Ccd0MemoryContent& );
    Ccd0MemoryContent& operator=( const Ccd0MemoryContent& );

    friend class  Ccd0MemoryContentDelegate;
    friend class  Ccd0MemoryContentDispatch;
    friend class  Ccd0MemoryContentGenImpl;
};

#include <ccdm/libccdm_undef.h>
#endif //   CCDM__CCD0MEMORYCONTENT__HXX
