//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ccd0MemoryLayout
    Filename:   Ccd0MemoryLayout.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__CCD0MEMORYLAYOUT__HXX
#define CCDM__CCD0MEMORYLAYOUT__HXX

#include <common/tc_deprecation_macros.h>
#include <Mem0memmgt/Mem0MemoryLayout.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class Ccd0MemoryLayout;
}
namespace ccdm
{
    class Ccd0MemoryLayoutImpl;
}
namespace ccdm
{
    class Ccd0MemoryLayoutDelegate;
}
namespace ccdm
{
    class Ccd0MemoryLayoutDispatch;
}
namespace ccdm
{
    class Ccd0MemoryLayoutGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CCDM_API  ccdm::Ccd0MemoryLayout
     : public  ::ccdm::Mem0MemoryLayout
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ccd0MemoryLayout();

    /**
     * Destructor
     */
    virtual ~Ccd0MemoryLayout();

private:
    //  Getter method for the Implementation Object
    Ccd0MemoryLayoutImpl*  getCcd0MemoryLayoutImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCcd0MemoryLayoutImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ccd0MemoryLayoutImpl*  m_ccd0memorylayoutImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ccd0MemoryLayout - desc for Ccd0MemoryLayout parameter
     */
    Ccd0MemoryLayout( const Ccd0MemoryLayout& );
    Ccd0MemoryLayout& operator=( const Ccd0MemoryLayout& );

    friend class  Ccd0MemoryLayoutDelegate;
    friend class  Ccd0MemoryLayoutDispatch;
    friend class  Ccd0MemoryLayoutGenImpl;
};

#include <ccdm/libccdm_undef.h>
#endif //   CCDM__CCD0MEMORYLAYOUT__HXX
