//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ccd0MemoryLayoutRevision
    Filename:   Ccd0MemoryLayoutRevision.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__CCD0MEMORYLAYOUTREVISION__HXX
#define CCDM__CCD0MEMORYLAYOUTREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <Mem0memmgt/Mem0MemoryLayoutRevision.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class Ccd0MemoryLayoutRevision;
}
namespace ccdm
{
    class Ccd0MemoryLayoutRevisionImpl;
}
namespace ccdm
{
    class Ccd0MemoryLayoutRevisionDelegate;
}
namespace ccdm
{
    class Ccd0MemoryLayoutRevisionDispatch;
}
namespace ccdm
{
    class Ccd0MemoryLayoutRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CCDM_API  ccdm::Ccd0MemoryLayoutRevision
     : public  ::ccdm::Mem0MemoryLayoutRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ccd0MemoryLayoutRevision();

    /**
     * Destructor
     */
    virtual ~Ccd0MemoryLayoutRevision();

private:
    //  Getter method for the Implementation Object
    Ccd0MemoryLayoutRevisionImpl*  getCcd0MemoryLayoutRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCcd0MemoryLayoutRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ccd0MemoryLayoutRevisionImpl*  m_ccd0memorylayoutrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ccd0MemoryLayoutRevision - desc for Ccd0MemoryLayoutRevision parameter
     */
    Ccd0MemoryLayoutRevision( const Ccd0MemoryLayoutRevision& );
    Ccd0MemoryLayoutRevision& operator=( const Ccd0MemoryLayoutRevision& );

    friend class  Ccd0MemoryLayoutRevisionDelegate;
    friend class  Ccd0MemoryLayoutRevisionDispatch;
    friend class  Ccd0MemoryLayoutRevisionGenImpl;
};

#include <ccdm/libccdm_undef.h>
#endif //   CCDM__CCD0MEMORYLAYOUTREVISION__HXX
