//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ccd0MemoryOverrideRecord
    Filename:   Ccd0MemoryOverrideRecord.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__CCD0MEMORYOVERRIDERECORD__HXX
#define CCDM__CCD0MEMORYOVERRIDERECORD__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <ccdm/Ccd0ParmDefOverrideRecord.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class Ccd0MemoryOverrideRecord;
}
namespace ccdm
{
    class Ccd0MemoryOverrideRecordImpl;
}
namespace ccdm
{
    class Ccd0MemoryOverrideRecordDelegate;
}
namespace ccdm
{
    class Ccd0MemoryOverrideRecordDispatch;
}
namespace ccdm
{
    class Ccd0MemoryOverrideRecordGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CCDM_API  ccdm::Ccd0MemoryOverrideRecord
     : public  ::ccdm::Ccd0ParmDefOverrideRecord
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCcd0OffsetAddr( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCcd0OffsetAddr( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ccd0MemoryOverrideRecord();

    /**
     * Destructor
     */
    virtual ~Ccd0MemoryOverrideRecord();

private:
    //  Getter method for the Implementation Object
    Ccd0MemoryOverrideRecordImpl*  getCcd0MemoryOverrideRecordImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCcd0MemoryOverrideRecordImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ccd0MemoryOverrideRecordImpl*  m_ccd0memoryoverriderecordImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ccd0MemoryOverrideRecord - desc for Ccd0MemoryOverrideRecord parameter
     */
    Ccd0MemoryOverrideRecord( const Ccd0MemoryOverrideRecord& );
    Ccd0MemoryOverrideRecord& operator=( const Ccd0MemoryOverrideRecord& );

    friend class  Ccd0MemoryOverrideRecordDelegate;
    friend class  Ccd0MemoryOverrideRecordDispatch;
    friend class  Ccd0MemoryOverrideRecordGenImpl;
};

#include <ccdm/libccdm_undef.h>
#endif //   CCDM__CCD0MEMORYOVERRIDERECORD__HXX
