//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ccd0OverrideContRevision
    Filename:   Ccd0OverrideContRevision.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__CCD0OVERRIDECONTREVISION__HXX
#define CCDM__CCD0OVERRIDECONTREVISION__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class Ccd0OverrideContRevision;
}
namespace ccdm
{
    class Ccd0OverrideContRevisionImpl;
}
namespace ccdm
{
    class Ccd0OverrideContRevisionDelegate;
}
namespace ccdm
{
    class Ccd0OverrideContRevisionDispatch;
}
namespace ccdm
{
    class Ccd0OverrideContRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CCDM_API  ccdm::Ccd0OverrideContRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCcd0OverrideRecords( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 9.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setCcd0OverrideRecords( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ccd0OverrideContRevision();

    /**
     * Destructor
     */
    virtual ~Ccd0OverrideContRevision();

private:
    //  Getter method for the Implementation Object
    Ccd0OverrideContRevisionImpl*  getCcd0OverrideContRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCcd0OverrideContRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ccd0OverrideContRevisionImpl*  m_ccd0overridecontrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ccd0OverrideContRevision - desc for Ccd0OverrideContRevision parameter
     */
    Ccd0OverrideContRevision( const Ccd0OverrideContRevision& );
    Ccd0OverrideContRevision& operator=( const Ccd0OverrideContRevision& );

    friend class  Ccd0OverrideContRevisionDelegate;
    friend class  Ccd0OverrideContRevisionDispatch;
    friend class  Ccd0OverrideContRevisionGenImpl;
};

#include <ccdm/libccdm_undef.h>
#endif //   CCDM__CCD0OVERRIDECONTREVISION__HXX
