//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ccd0OverrideContRevisionDelegate
    Filename:   Ccd0OverrideContRevisionDelegate.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__CCD0OVERRIDECONTREVISIONDELEGATE_HXX
#define CCDM__CCD0OVERRIDECONTREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ccdm/Ccd0OverrideContRevision.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class Ccd0OverrideContRevisionDelegate;
}
namespace ccdm
{
    class Ccd0OverrideContRevisionImpl;
}
namespace ccdm
{
    class Ccd0OverrideContRevision;
}
namespace ccdm
{
    class Ccd0OverrideContRevisionGenImpl;
}

namespace ccdm_alias = ::ccdm;


class  CCDM_API ccdm_alias::Ccd0OverrideContRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Ccd0OverrideContRevisionDelegate instance
    static Ccd0OverrideContRevisionDelegate&  getInstance();

    //  Method to create the Ccd0OverrideContRevisionImpl pointer
    static Ccd0OverrideContRevisionImpl*  createImpl( Ccd0OverrideContRevision&  ifObj );

    //  Method to delete the Ccd0OverrideContRevisionImpl pointer
    static void deleteImpl( Ccd0OverrideContRevisionImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCcd0OverrideRecordsBase(const Ccd0OverrideContRevision &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 9.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setCcd0OverrideRecordsBase(Ccd0OverrideContRevision &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Ccd0OverrideContRevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Generic revisePost operation.
    /// @version Teamcenter 10.1
    /// @param pReviseInput - Input ReviseInput object.
    /// @param vecDeepCopyData - Vector of deep copy data.
    /// @return - Returns an integer value.
    ///
    int  revisePostBase(const Ccd0OverrideContRevision &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// Generic saveAsPost operation.
    /// @version Teamcenter 8.1
    /// @param pSavAsInput - Input argument as SaveAsInput object.
    /// @param vecDeepCopyData - vector deepcopy data
    /// @return - Return integer value.
    ///
    int  saveAsPostBase(const Ccd0OverrideContRevision &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Ccd0OverrideContRevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Validate revise input.
    /// @version Teamcenter 10.1
    /// @param pReviseInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - Returns an int.
    ///
    int  validateReviseInputBase(const Ccd0OverrideContRevision &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// validate saveas input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  validateSaveAsInputBase(const Ccd0OverrideContRevision &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static Ccd0OverrideContRevisionDelegate*  m_pInstance;

    Ccd0OverrideContRevisionDelegate();
    virtual ~Ccd0OverrideContRevisionDelegate();
    static void setInstance( Ccd0OverrideContRevisionDelegate*  instance );


private:
    friend class  ::ccdm::Ccd0OverrideContRevisionGenImpl;

};

#include <ccdm/libccdm_undef.h>
#endif  //  CCDM__CCD0OVERRIDECONTREVISIONDELEGATE_HXX
