//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ccd0ParmDefOverrideRecord
    Filename:   Ccd0ParmDefOverrideRecord.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__CCD0PARMDEFOVERRIDERECORD__HXX
#define CCDM__CCD0PARMDEFOVERRIDERECORD__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class Ccd0ParmDefOverrideRecord;
}
namespace ccdm
{
    class Ccd0ParmDefOverrideRecordImpl;
}
namespace ccdm
{
    class Ccd0ParmDefOverrideRecordDelegate;
}
namespace ccdm
{
    class Ccd0ParmDefOverrideRecordDispatch;
}
namespace ccdm
{
    class Ccd0ParmDefOverrideRecordGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CCDM_API  ccdm::Ccd0ParmDefOverrideRecord
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCcd0ParmDefRev( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCcd0ParmDefRev( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ccd0ParmDefOverrideRecord();

    /**
     * Destructor
     */
    virtual ~Ccd0ParmDefOverrideRecord();

private:
    //  Getter method for the Implementation Object
    Ccd0ParmDefOverrideRecordImpl*  getCcd0ParmDefOverrideRecordImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCcd0ParmDefOverrideRecordImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ccd0ParmDefOverrideRecordImpl*  m_ccd0parmdefoverriderecordImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ccd0ParmDefOverrideRecord - desc for Ccd0ParmDefOverrideRecord parameter
     */
    Ccd0ParmDefOverrideRecord( const Ccd0ParmDefOverrideRecord& );
    Ccd0ParmDefOverrideRecord& operator=( const Ccd0ParmDefOverrideRecord& );

    friend class  Ccd0ParmDefOverrideRecordDelegate;
    friend class  Ccd0ParmDefOverrideRecordDispatch;
    friend class  Ccd0ParmDefOverrideRecordGenImpl;
};

#include <ccdm/libccdm_undef.h>
#endif //   CCDM__CCD0PARMDEFOVERRIDERECORD__HXX
