//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ccd0ParmFileDelegate
    Filename:   Ccd0ParmFileDelegate.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__CCD0PARMFILEDELEGATE_HXX
#define CCDM__CCD0PARMFILEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ccdm/Ccd0ParmFile.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class Ccd0ParmFileDelegate;
}
namespace ccdm
{
    class Ccd0ParmFileImpl;
}
namespace ccdm
{
    class Ccd0ParmFile;
}
namespace ccdm
{
    class Ccd0ParmFileGenImpl;
}

namespace ccdm_alias = ::ccdm;


class  CCDM_API ccdm_alias::Ccd0ParmFileDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Ccd0ParmFileDelegate instance
    static Ccd0ParmFileDelegate&  getInstance();

    //  Method to create the Ccd0ParmFileImpl pointer
    static Ccd0ParmFileImpl*  createImpl( Ccd0ParmFile&  ifObj );

    //  Method to delete the Ccd0ParmFileImpl pointer
    static void deleteImpl( Ccd0ParmFileImpl*  impl );


    ///
    /// Generates file for Dictionary sharing
    /// @version Teamcenter 9.1
    /// @param parmDictionaryData - Input data for Dictionary sharing
    /// @param fileNamePrefix - Returns status as int
    /// @param exportFileOutput - Output of generate file
    /// @return - Returns status as int
    ///
    int  ccd0generateFileBase(const Ccd0ParmFile &ifObj,  ParmDictionaySharingExpData *parmDictionaryData, std::string *fileNamePrefix, ExportFileOutput *exportFileOutput );


    ///
    /// Generates flash file
    /// @version Teamcenter 9.1
    /// @param parmFlashData - Data for flash file generation
    /// @param fileNamePrefix - File name prefix
    /// @param exportFileOutput - Output of generate file
    /// @return - Returns status as int
    ///
    int  ccd0generateFileBase(const Ccd0ParmFile &ifObj,  ParmFlashGenerationExpData *parmFlashData, std::string *fileNamePrefix, ExportFileOutput *exportFileOutput );


    ///
    /// Generates file for value sharing
    /// @version Teamcenter 9.1
    /// @param parmValueData - Input data for Value sharing
    /// @param fileNamePrefix - File name prefix
    /// @param exportFileOutput - Output of generate file
    /// @return - Returns status as int
    ///
    int  ccd0generateFileBase(const Ccd0ParmFile &ifObj,  ParmValueSharingExpData *parmValueData, std::string *fileNamePrefix, ExportFileOutput *exportFileOutput );


    ///
    /// Method to parse the specified parameter data file (A2L, CDF etc).
    /// @version Teamcenter 9.1
    /// @param vecFilesToParse - Vector of input files to parse
    /// @param importOutput - Output of the parsed files along with the errors if any.
    /// @return - Status code
    ///
    int  ccd0ParseBase(const Ccd0ParmFile &ifObj,  std::vector< std::string > *vecFilesToParse, DictionaryParseOutput *importOutput );



protected:
    //  Pointer to the instance
    static Ccd0ParmFileDelegate*  m_pInstance;

    Ccd0ParmFileDelegate();
    virtual ~Ccd0ParmFileDelegate();
    static void setInstance( Ccd0ParmFileDelegate*  instance );


private:
    friend class  ::ccdm::Ccd0ParmFileGenImpl;

};

#include <ccdm/libccdm_undef.h>
#endif  //  CCDM__CCD0PARMFILEDELEGATE_HXX
