//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ccd0ParmMemBlock
    Filename:   Ccd0ParmMemBlock.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__CCD0PARMMEMBLOCK__HXX
#define CCDM__CCD0PARMMEMBLOCK__HXX

#include <common/tc_deprecation_macros.h>
#include <Mem0memmgt/Mem0MemoryBlock.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class Ccd0ParmMemBlock;
}
namespace ccdm
{
    class Ccd0ParmMemBlockImpl;
}
namespace ccdm
{
    class Ccd0ParmMemBlockDelegate;
}
namespace ccdm
{
    class Ccd0ParmMemBlockDispatch;
}
namespace ccdm
{
    class Ccd0ParmMemBlockGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CCDM_API  ccdm::Ccd0ParmMemBlock
     : public  ::ccdm::Mem0MemoryBlock
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ccd0ParmMemBlock();

    /**
     * Destructor
     */
    virtual ~Ccd0ParmMemBlock();

private:
    //  Getter method for the Implementation Object
    Ccd0ParmMemBlockImpl*  getCcd0ParmMemBlockImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCcd0ParmMemBlockImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ccd0ParmMemBlockImpl*  m_ccd0parmmemblockImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ccd0ParmMemBlock - desc for Ccd0ParmMemBlock parameter
     */
    Ccd0ParmMemBlock( const Ccd0ParmMemBlock& );
    Ccd0ParmMemBlock& operator=( const Ccd0ParmMemBlock& );

    friend class  Ccd0ParmMemBlockDelegate;
    friend class  Ccd0ParmMemBlockDispatch;
    friend class  Ccd0ParmMemBlockGenImpl;
};

#include <ccdm/libccdm_undef.h>
#endif //   CCDM__CCD0PARMMEMBLOCK__HXX
