//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ccd0ParmMemRecord
    Filename:   Ccd0ParmMemRecord.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__CCD0PARMMEMRECORD__HXX
#define CCDM__CCD0PARMMEMRECORD__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <Mem0memmgt/Mem0MemoryRecord.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class Ccd0ParmMemRecord;
}
namespace ccdm
{
    class Ccd0ParmMemRecordImpl;
}
namespace ccdm
{
    class Ccd0ParmMemRecordDelegate;
}
namespace ccdm
{
    class Ccd0ParmMemRecordDispatch;
}
namespace ccdm
{
    class Ccd0ParmMemRecordGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CCDM_API  ccdm::Ccd0ParmMemRecord
     : public  ::ccdm::Mem0MemoryRecord
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCcd0ParmDefRevision( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCcd0ParmDefRevision( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ccd0ParmMemRecord();

    /**
     * Destructor
     */
    virtual ~Ccd0ParmMemRecord();

private:
    //  Getter method for the Implementation Object
    Ccd0ParmMemRecordImpl*  getCcd0ParmMemRecordImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCcd0ParmMemRecordImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ccd0ParmMemRecordImpl*  m_ccd0parmmemrecordImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ccd0ParmMemRecord - desc for Ccd0ParmMemRecord parameter
     */
    Ccd0ParmMemRecord( const Ccd0ParmMemRecord& );
    Ccd0ParmMemRecord& operator=( const Ccd0ParmMemRecord& );

    friend class  Ccd0ParmMemRecordDelegate;
    friend class  Ccd0ParmMemRecordDispatch;
    friend class  Ccd0ParmMemRecordGenImpl;
};

#include <ccdm/libccdm_undef.h>
#endif //   CCDM__CCD0PARMMEMRECORD__HXX
