//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ccd0ParmMemRecordDelegate
    Filename:   Ccd0ParmMemRecordDelegate.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__CCD0PARMMEMRECORDDELEGATE_HXX
#define CCDM__CCD0PARMMEMRECORDDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ccdm/Ccd0ParmMemRecord.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class Ccd0ParmMemRecordDelegate;
}
namespace ccdm
{
    class Ccd0ParmMemRecordImpl;
}
namespace ccdm
{
    class Ccd0ParmMemRecord;
}
namespace ccdm
{
    class Ccd0ParmMemRecordGenImpl;
}

namespace ccdm_alias = ::ccdm;


class  CCDM_API ccdm_alias::Ccd0ParmMemRecordDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Ccd0ParmMemRecordDelegate instance
    static Ccd0ParmMemRecordDelegate&  getInstance();

    //  Method to create the Ccd0ParmMemRecordImpl pointer
    static Ccd0ParmMemRecordImpl*  createImpl( Ccd0ParmMemRecord&  ifObj );

    //  Method to delete the Ccd0ParmMemRecordImpl pointer
    static void deleteImpl( Ccd0ParmMemRecordImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCcd0ParmDefRevisionBase(const Ccd0ParmMemRecord &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCcd0ParmDefRevisionBase(Ccd0ParmMemRecord &ifObj,  const tag_t &value, bool isNull );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Ccd0ParmMemRecord &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Ccd0ParmMemRecordDelegate*  m_pInstance;

    Ccd0ParmMemRecordDelegate();
    virtual ~Ccd0ParmMemRecordDelegate();
    static void setInstance( Ccd0ParmMemRecordDelegate*  instance );


private:
    friend class  ::ccdm::Ccd0ParmMemRecordGenImpl;

};

#include <ccdm/libccdm_undef.h>
#endif  //  CCDM__CCD0PARMMEMRECORDDELEGATE_HXX
