//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ParmDefBitDef
    Filename:   ParmDefBitDef.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__PARMDEFBITDEF__HXX
#define CCDM__PARMDEFBITDEF__HXX

#include <common/tc_deprecation_macros.h>
#include <ccdm/ParmDef.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class ParmDefBitDef;
}
namespace ccdm
{
    class ParmDefBitDefImpl;
}
namespace ccdm
{
    class ParmDefBitDefDelegate;
}
namespace ccdm
{
    class ParmDefBitDefDispatch;
}
namespace ccdm
{
    class ParmDefBitDefGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CCDM_API  ccdm::ParmDefBitDef
     : public  ::ccdm::ParmDef
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ParmDefBitDef();

    /**
     * Destructor
     */
    virtual ~ParmDefBitDef();

private:
    //  Getter method for the Implementation Object
    ParmDefBitDefImpl*  getParmDefBitDefImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setParmDefBitDefImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ParmDefBitDefImpl*  m_parmdefbitdefImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ParmDefBitDef - desc for ParmDefBitDef parameter
     */
    ParmDefBitDef( const ParmDefBitDef& );
    ParmDefBitDef& operator=( const ParmDefBitDef& );

    friend class  ParmDefBitDefDelegate;
    friend class  ParmDefBitDefDispatch;
    friend class  ParmDefBitDefGenImpl;
};

#include <ccdm/libccdm_undef.h>
#endif //   CCDM__PARMDEFBITDEF__HXX
