//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ParmDefBitDefRevisionDelegate
    Filename:   ParmDefBitDefRevisionDelegate.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__PARMDEFBITDEFREVISIONDELEGATE_HXX
#define CCDM__PARMDEFBITDEFREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ccdm/ParmDefBitDefRevision.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class ParmDefBitDefRevisionDelegate;
}
namespace ccdm
{
    class ParmDefBitDefRevisionImpl;
}
namespace ccdm
{
    class ParmDefBitDefRevision;
}
namespace ccdm
{
    class ParmDefBitDefRevisionGenImpl;
}

namespace ccdm_alias = ::ccdm;


class  CCDM_API ccdm_alias::ParmDefBitDefRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ParmDefBitDefRevisionDelegate instance
    static ParmDefBitDefRevisionDelegate&  getInstance();

    //  Method to create the ParmDefBitDefRevisionImpl pointer
    static ParmDefBitDefRevisionImpl*  createImpl( ParmDefBitDefRevision&  ifObj );

    //  Method to delete the ParmDefBitDefRevisionImpl pointer
    static void deleteImpl( ParmDefBitDefRevisionImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getBitDefBase(const ParmDefBitDefRevision &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setBitDefBase(ParmDefBitDefRevision &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const ParmDefBitDefRevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Generic revisePost operation.
    /// @version Teamcenter 10.1
    /// @param pReviseInput - Input ReviseInput object.
    /// @param vecDeepCopyData - Vector of deep copy data.
    /// @return - Returns an integer value.
    ///
    int  revisePostBase(const ParmDefBitDefRevision &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// Generic saveAsPost operation.
    /// @version Teamcenter 8.1
    /// @param pSavAsInput - Input argument as SaveAsInput object.
    /// @param vecDeepCopyData - vector deepcopy data
    /// @return - Return integer value.
    ///
    int  saveAsPostBase(const ParmDefBitDefRevision &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const ParmDefBitDefRevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Validate revise input.
    /// @version Teamcenter 10.1
    /// @param pReviseInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - Returns an int.
    ///
    int  validateReviseInputBase(const ParmDefBitDefRevision &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// validate saveas input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  validateSaveAsInputBase(const ParmDefBitDefRevision &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSizeBase(ParmDefBitDefRevision &ifObj,  int value, bool isNull );



protected:
    //  Pointer to the instance
    static ParmDefBitDefRevisionDelegate*  m_pInstance;

    ParmDefBitDefRevisionDelegate();
    virtual ~ParmDefBitDefRevisionDelegate();
    static void setInstance( ParmDefBitDefRevisionDelegate*  instance );


private:
    friend class  ::ccdm::ParmDefBitDefRevisionGenImpl;

};

#include <ccdm/libccdm_undef.h>
#endif  //  CCDM__PARMDEFBITDEFREVISIONDELEGATE_HXX
