//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ParmDefDate
    Filename:   ParmDefDate.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__PARMDEFDATE__HXX
#define CCDM__PARMDEFDATE__HXX

#include <common/tc_deprecation_macros.h>
#include <ccdm/ParmDef.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class ParmDefDate;
}
namespace ccdm
{
    class ParmDefDateImpl;
}
namespace ccdm
{
    class ParmDefDateDelegate;
}
namespace ccdm
{
    class ParmDefDateDispatch;
}
namespace ccdm
{
    class ParmDefDateGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CCDM_API  ccdm::ParmDefDate
     : public  ::ccdm::ParmDef
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ParmDefDate();

    /**
     * Destructor
     */
    virtual ~ParmDefDate();

private:
    //  Getter method for the Implementation Object
    ParmDefDateImpl*  getParmDefDateImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setParmDefDateImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ParmDefDateImpl*  m_parmdefdateImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ParmDefDate - desc for ParmDefDate parameter
     */
    ParmDefDate( const ParmDefDate& );
    ParmDefDate& operator=( const ParmDefDate& );

    friend class  ParmDefDateDelegate;
    friend class  ParmDefDateDispatch;
    friend class  ParmDefDateGenImpl;
};

#include <ccdm/libccdm_undef.h>
#endif //   CCDM__PARMDEFDATE__HXX
