//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ParmDefDbl
    Filename:   ParmDefDbl.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__PARMDEFDBL__HXX
#define CCDM__PARMDEFDBL__HXX

#include <common/tc_deprecation_macros.h>
#include <ccdm/ParmDef.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class ParmDefDbl;
}
namespace ccdm
{
    class ParmDefDblImpl;
}
namespace ccdm
{
    class ParmDefDblDelegate;
}
namespace ccdm
{
    class ParmDefDblDispatch;
}
namespace ccdm
{
    class ParmDefDblGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CCDM_API  ccdm::ParmDefDbl
     : public  ::ccdm::ParmDef
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ParmDefDbl();

    /**
     * Destructor
     */
    virtual ~ParmDefDbl();

private:
    //  Getter method for the Implementation Object
    ParmDefDblImpl*  getParmDefDblImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setParmDefDblImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ParmDefDblImpl*  m_parmdefdblImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ParmDefDbl - desc for ParmDefDbl parameter
     */
    ParmDefDbl( const ParmDefDbl& );
    ParmDefDbl& operator=( const ParmDefDbl& );

    friend class  ParmDefDblDelegate;
    friend class  ParmDefDblDispatch;
    friend class  ParmDefDblGenImpl;
};

#include <ccdm/libccdm_undef.h>
#endif //   CCDM__PARMDEFDBL__HXX
