//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ParmDefDelegate
    Filename:   ParmDefDelegate.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__PARMDEFDELEGATE_HXX
#define CCDM__PARMDEFDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ccdm/ParmDef.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class ParmDefDelegate;
}
namespace ccdm
{
    class ParmDefImpl;
}
namespace ccdm
{
    class ParmDef;
}
namespace ccdm
{
    class ParmDefGenImpl;
}

namespace ccdm_alias = ::ccdm;


class  CCDM_API ccdm_alias::ParmDefDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ParmDefDelegate instance
    static ParmDefDelegate&  getInstance();

    //  Method to create the ParmDefImpl pointer
    static ParmDefImpl*  createImpl( ParmDef&  ifObj );

    //  Method to delete the ParmDefImpl pointer
    static void deleteImpl( ParmDefImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAdditionalDataBase(const ParmDef &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCommentBase(const ParmDef &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getParmTypeBase(const ParmDef &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAdditionalDataBase(ParmDef &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCommentBase(ParmDef &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setParmTypeBase(ParmDef &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static ParmDefDelegate*  m_pInstance;

    ParmDefDelegate();
    virtual ~ParmDefDelegate();
    static void setInstance( ParmDefDelegate*  instance );


private:
    friend class  ::ccdm::ParmDefGenImpl;

};

#include <ccdm/libccdm_undef.h>
#endif  //  CCDM__PARMDEFDELEGATE_HXX
