//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ParmDefInt
    Filename:   ParmDefInt.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__PARMDEFINT__HXX
#define CCDM__PARMDEFINT__HXX

#include <common/tc_deprecation_macros.h>
#include <ccdm/ParmDef.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class ParmDefInt;
}
namespace ccdm
{
    class ParmDefIntImpl;
}
namespace ccdm
{
    class ParmDefIntDelegate;
}
namespace ccdm
{
    class ParmDefIntDispatch;
}
namespace ccdm
{
    class ParmDefIntGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CCDM_API  ccdm::ParmDefInt
     : public  ::ccdm::ParmDef
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ParmDefInt();

    /**
     * Destructor
     */
    virtual ~ParmDefInt();

private:
    //  Getter method for the Implementation Object
    ParmDefIntImpl*  getParmDefIntImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setParmDefIntImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ParmDefIntImpl*  m_parmdefintImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ParmDefInt - desc for ParmDefInt parameter
     */
    ParmDefInt( const ParmDefInt& );
    ParmDefInt& operator=( const ParmDefInt& );

    friend class  ParmDefIntDelegate;
    friend class  ParmDefIntDispatch;
    friend class  ParmDefIntGenImpl;
};

#include <ccdm/libccdm_undef.h>
#endif //   CCDM__PARMDEFINT__HXX
