//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ParmDefIntRevisionDelegate
    Filename:   ParmDefIntRevisionDelegate.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__PARMDEFINTREVISIONDELEGATE_HXX
#define CCDM__PARMDEFINTREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ccdm/ParmDefIntRevision.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class ParmDefIntRevisionDelegate;
}
namespace ccdm
{
    class ParmDefIntRevisionImpl;
}
namespace ccdm
{
    class ParmDefIntRevision;
}
namespace ccdm
{
    class ParmDefIntRevisionGenImpl;
}

namespace ccdm_alias = ::ccdm;


class  CCDM_API ccdm_alias::ParmDefIntRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ParmDefIntRevisionDelegate instance
    static ParmDefIntRevisionDelegate&  getInstance();

    //  Method to create the ParmDefIntRevisionImpl pointer
    static ParmDefIntRevisionImpl*  createImpl( ParmDefIntRevision&  ifObj );

    //  Method to delete the ParmDefIntRevisionImpl pointer
    static void deleteImpl( ParmDefIntRevisionImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getInitialValuesBase(const ParmDefIntRevision &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIsSignedBase(const ParmDefIntRevision &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMaxValuesBase(const ParmDefIntRevision &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMinValuesBase(const ParmDefIntRevision &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getResolution_denominatorBase(const ParmDefIntRevision &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getResolution_numeratorBase(const ParmDefIntRevision &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getTableDefinitionBase(const ParmDefIntRevision &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setInitialValuesBase(ParmDefIntRevision &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIsSignedBase(ParmDefIntRevision &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMaxValuesBase(ParmDefIntRevision &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMinValuesBase(ParmDefIntRevision &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setResolution_denominatorBase(ParmDefIntRevision &ifObj,  int value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setResolution_numeratorBase(ParmDefIntRevision &ifObj,  int value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setTableDefinitionBase(ParmDefIntRevision &ifObj,  const tag_t &value, bool isNull );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const ParmDefIntRevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Generic revisePost operation.
    /// @version Teamcenter 10.1
    /// @param pReviseInput - Input ReviseInput object.
    /// @param vecDeepCopyData - Vector of deep copy data.
    /// @return - Returns an integer value.
    ///
    int  revisePostBase(const ParmDefIntRevision &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// Generic saveAsPost operation.
    /// @version Teamcenter 8.1
    /// @param pSavAsInput - Input argument as SaveAsInput object.
    /// @param vecDeepCopyData - vector deepcopy data
    /// @return - Return integer value.
    ///
    int  saveAsPostBase(const ParmDefIntRevision &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const ParmDefIntRevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const ParmDefIntRevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Validate revise input.
    /// @version Teamcenter 10.1
    /// @param pReviseInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - Returns an int.
    ///
    int  validateReviseInputBase(const ParmDefIntRevision &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// validate saveas input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  validateSaveAsInputBase(const ParmDefIntRevision &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static ParmDefIntRevisionDelegate*  m_pInstance;

    ParmDefIntRevisionDelegate();
    virtual ~ParmDefIntRevisionDelegate();
    static void setInstance( ParmDefIntRevisionDelegate*  instance );


private:
    friend class  ::ccdm::ParmDefIntRevisionGenImpl;

};

#include <ccdm/libccdm_undef.h>
#endif  //  CCDM__PARMDEFINTREVISIONDELEGATE_HXX
