//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ParmDefSED
    Filename:   ParmDefSED.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__PARMDEFSED__HXX
#define CCDM__PARMDEFSED__HXX

#include <common/tc_deprecation_macros.h>
#include <ccdm/ParmDef.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class ParmDefSED;
}
namespace ccdm
{
    class ParmDefSEDImpl;
}
namespace ccdm
{
    class ParmDefSEDDelegate;
}
namespace ccdm
{
    class ParmDefSEDDispatch;
}
namespace ccdm
{
    class ParmDefSEDGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CCDM_API  ccdm::ParmDefSED
     : public  ::ccdm::ParmDef
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ParmDefSED();

    /**
     * Destructor
     */
    virtual ~ParmDefSED();

private:
    //  Getter method for the Implementation Object
    ParmDefSEDImpl*  getParmDefSEDImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setParmDefSEDImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ParmDefSEDImpl*  m_parmdefsedImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ParmDefSED - desc for ParmDefSED parameter
     */
    ParmDefSED( const ParmDefSED& );
    ParmDefSED& operator=( const ParmDefSED& );

    friend class  ParmDefSEDDelegate;
    friend class  ParmDefSEDDispatch;
    friend class  ParmDefSEDGenImpl;
};

#include <ccdm/libccdm_undef.h>
#endif //   CCDM__PARMDEFSED__HXX
