//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ParmDefSEDRevision
    Filename:   ParmDefSEDRevision.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__PARMDEFSEDREVISION__HXX
#define CCDM__PARMDEFSEDREVISION__HXX

#include <string>
#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <ccdm/ParmDefRevision.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class ParmDefSEDRevision;
}
namespace ccdm
{
    class ParmDefSEDRevisionImpl;
}
namespace ccdm
{
    class ParmDefSEDRevisionDelegate;
}
namespace ccdm
{
    class ParmDefSEDRevisionDispatch;
}
namespace ccdm
{
    class ParmDefSEDRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CCDM_API  ccdm::ParmDefSEDRevision
     : public  ::ccdm::ParmDefRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getInitialValue( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getTableDefinition( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValidValues( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setInitialValue( const std::string &value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setTableDefinition( const tag_t &value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValidValues( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ParmDefSEDRevision();

    /**
     * Destructor
     */
    virtual ~ParmDefSEDRevision();

private:
    //  Getter method for the Implementation Object
    ParmDefSEDRevisionImpl*  getParmDefSEDRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setParmDefSEDRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ParmDefSEDRevisionImpl*  m_parmdefsedrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ParmDefSEDRevision - desc for ParmDefSEDRevision parameter
     */
    ParmDefSEDRevision( const ParmDefSEDRevision& );
    ParmDefSEDRevision& operator=( const ParmDefSEDRevision& );

    friend class  ParmDefSEDRevisionDelegate;
    friend class  ParmDefSEDRevisionDispatch;
    friend class  ParmDefSEDRevisionGenImpl;
};

#include <ccdm/libccdm_undef.h>
#endif //   CCDM__PARMDEFSEDREVISION__HXX
