//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ParmDefStr
    Filename:   ParmDefStr.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__PARMDEFSTR__HXX
#define CCDM__PARMDEFSTR__HXX

#include <common/tc_deprecation_macros.h>
#include <ccdm/ParmDef.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class ParmDefStr;
}
namespace ccdm
{
    class ParmDefStrImpl;
}
namespace ccdm
{
    class ParmDefStrDelegate;
}
namespace ccdm
{
    class ParmDefStrDispatch;
}
namespace ccdm
{
    class ParmDefStrGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CCDM_API  ccdm::ParmDefStr
     : public  ::ccdm::ParmDef
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ParmDefStr();

    /**
     * Destructor
     */
    virtual ~ParmDefStr();

private:
    //  Getter method for the Implementation Object
    ParmDefStrImpl*  getParmDefStrImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setParmDefStrImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ParmDefStrImpl*  m_parmdefstrImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ParmDefStr - desc for ParmDefStr parameter
     */
    ParmDefStr( const ParmDefStr& );
    ParmDefStr& operator=( const ParmDefStr& );

    friend class  ParmDefStrDelegate;
    friend class  ParmDefStrDispatch;
    friend class  ParmDefStrGenImpl;
};

#include <ccdm/libccdm_undef.h>
#endif //   CCDM__PARMDEFSTR__HXX
