//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ParmGrpDef
    Filename:   ParmGrpDef.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__PARMGRPDEF__HXX
#define CCDM__PARMGRPDEF__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <rdv/Architecture.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class ParmGrpDef;
}
namespace ccdm
{
    class ParmGrpDefImpl;
}
namespace ccdm
{
    class ParmGrpDefDelegate;
}
namespace ccdm
{
    class ParmGrpDefDispatch;
}
namespace ccdm
{
    class ParmGrpDefGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CCDM_API  ccdm::ParmGrpDef
     : public  ::Teamcenter::Architecture
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRepresents( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setRepresents( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ParmGrpDef();

    /**
     * Destructor
     */
    virtual ~ParmGrpDef();

private:
    //  Getter method for the Implementation Object
    ParmGrpDefImpl*  getParmGrpDefImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setParmGrpDefImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ParmGrpDefImpl*  m_parmgrpdefImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ParmGrpDef - desc for ParmGrpDef parameter
     */
    ParmGrpDef( const ParmGrpDef& );
    ParmGrpDef& operator=( const ParmGrpDef& );

    friend class  ParmGrpDefDelegate;
    friend class  ParmGrpDefDispatch;
    friend class  ParmGrpDefGenImpl;
};

#include <ccdm/libccdm_undef.h>
#endif //   CCDM__PARMGRPDEF__HXX
