//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ParmGrpDefDelegate
    Filename:   ParmGrpDefDelegate.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__PARMGRPDEFDELEGATE_HXX
#define CCDM__PARMGRPDEFDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ccdm/ParmGrpDef.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class ParmGrpDefDelegate;
}
namespace ccdm
{
    class ParmGrpDefImpl;
}
namespace ccdm
{
    class ParmGrpDef;
}
namespace ccdm
{
    class ParmGrpDefGenImpl;
}

namespace ccdm_alias = ::ccdm;


class  CCDM_API ccdm_alias::ParmGrpDefDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ParmGrpDefDelegate instance
    static ParmGrpDefDelegate&  getInstance();

    //  Method to create the ParmGrpDefImpl pointer
    static ParmGrpDefImpl*  createImpl( ParmGrpDef&  ifObj );

    //  Method to delete the ParmGrpDefImpl pointer
    static void deleteImpl( ParmGrpDefImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRepresentsBase(const ParmGrpDef &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setRepresentsBase(ParmGrpDef &ifObj,  const std::string &value, bool isNull );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const ParmGrpDef &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// validate saveas input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  validateSaveAsInputBase(const ParmGrpDef &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static ParmGrpDefDelegate*  m_pInstance;

    ParmGrpDefDelegate();
    virtual ~ParmGrpDefDelegate();
    static void setInstance( ParmGrpDefDelegate*  instance );


private:
    friend class  ::ccdm::ParmGrpDefGenImpl;

};

#include <ccdm/libccdm_undef.h>
#endif  //  CCDM__PARMGRPDEFDELEGATE_HXX
