//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ParmGrpDefRevision
    Filename:   ParmGrpDefRevision.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__PARMGRPDEFREVISION__HXX
#define CCDM__PARMGRPDEFREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <ccdm/CalParmRevision.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class ParmGrpDefRevision;
}
namespace ccdm
{
    class ParmGrpDefRevisionImpl;
}
namespace ccdm
{
    class ParmGrpDefRevisionDelegate;
}
namespace ccdm
{
    class ParmGrpDefRevisionDispatch;
}
namespace ccdm
{
    class ParmGrpDefRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CCDM_API  ccdm::ParmGrpDefRevision
     : public  ::ccdm::CalParmRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ParmGrpDefRevision();

    /**
     * Destructor
     */
    virtual ~ParmGrpDefRevision();

private:
    //  Getter method for the Implementation Object
    ParmGrpDefRevisionImpl*  getParmGrpDefRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setParmGrpDefRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ParmGrpDefRevisionImpl*  m_parmgrpdefrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ParmGrpDefRevision - desc for ParmGrpDefRevision parameter
     */
    ParmGrpDefRevision( const ParmGrpDefRevision& );
    ParmGrpDefRevision& operator=( const ParmGrpDefRevision& );

    friend class  ParmGrpDefRevisionDelegate;
    friend class  ParmGrpDefRevisionDispatch;
    friend class  ParmGrpDefRevisionGenImpl;
};

#include <ccdm/libccdm_undef.h>
#endif //   CCDM__PARMGRPDEFREVISION__HXX
