//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ParmGrpVal
    Filename:   ParmGrpVal.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__PARMGRPVAL__HXX
#define CCDM__PARMGRPVAL__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class ParmGrpVal;
}
namespace ccdm
{
    class ParmGrpValImpl;
}
namespace ccdm
{
    class ParmGrpValDelegate;
}
namespace ccdm
{
    class ParmGrpValDispatch;
}
namespace ccdm
{
    class ParmGrpValGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CCDM_API  ccdm::ParmGrpVal
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ParmGrpVal();

    /**
     * Destructor
     */
    virtual ~ParmGrpVal();

private:
    //  Getter method for the Implementation Object
    ParmGrpValImpl*  getParmGrpValImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setParmGrpValImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ParmGrpValImpl*  m_parmgrpvalImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ParmGrpVal - desc for ParmGrpVal parameter
     */
    ParmGrpVal( const ParmGrpVal& );
    ParmGrpVal& operator=( const ParmGrpVal& );

    friend class  ParmGrpValDelegate;
    friend class  ParmGrpValDispatch;
    friend class  ParmGrpValGenImpl;
};

#include <ccdm/libccdm_undef.h>
#endif //   CCDM__PARMGRPVAL__HXX
