//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ParmGrpValRevision
    Filename:   ParmGrpValRevision.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__PARMGRPVALREVISION__HXX
#define CCDM__PARMGRPVALREVISION__HXX

#include <unidefs.h>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class ParmGrpValRevision;
}
namespace ccdm
{
    class ParmGrpValRevisionImpl;
}
namespace ccdm
{
    class ParmGrpValRevisionDelegate;
}
namespace ccdm
{
    class ParmGrpValRevisionDispatch;
}
namespace ccdm
{
    class ParmGrpValRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CCDM_API  ccdm::ParmGrpValRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMasterDefRev( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getParmValues( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMasterDefRev( const tag_t &value, bool isNull=false );

    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setParmValues( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ParmGrpValRevision();

    /**
     * Destructor
     */
    virtual ~ParmGrpValRevision();

private:
    //  Getter method for the Implementation Object
    ParmGrpValRevisionImpl*  getParmGrpValRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setParmGrpValRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ParmGrpValRevisionImpl*  m_parmgrpvalrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ParmGrpValRevision - desc for ParmGrpValRevision parameter
     */
    ParmGrpValRevision( const ParmGrpValRevision& );
    ParmGrpValRevision& operator=( const ParmGrpValRevision& );

    friend class  ParmGrpValRevisionDelegate;
    friend class  ParmGrpValRevisionDispatch;
    friend class  ParmGrpValRevisionGenImpl;
};

#include <ccdm/libccdm_undef.h>
#endif //   CCDM__PARMGRPVALREVISION__HXX
