//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ParmGrpValRevisionDelegate
    Filename:   ParmGrpValRevisionDelegate.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__PARMGRPVALREVISIONDELEGATE_HXX
#define CCDM__PARMGRPVALREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ccdm/ParmGrpValRevision.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class ParmGrpValRevisionDelegate;
}
namespace ccdm
{
    class ParmGrpValRevisionImpl;
}
namespace ccdm
{
    class ParmGrpValRevision;
}
namespace ccdm
{
    class ParmGrpValRevisionGenImpl;
}

namespace ccdm_alias = ::ccdm;


class  CCDM_API ccdm_alias::ParmGrpValRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ParmGrpValRevisionDelegate instance
    static ParmGrpValRevisionDelegate&  getInstance();

    //  Method to create the ParmGrpValRevisionImpl pointer
    static ParmGrpValRevisionImpl*  createImpl( ParmGrpValRevision&  ifObj );

    //  Method to delete the ParmGrpValRevisionImpl pointer
    static void deleteImpl( ParmGrpValRevisionImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMasterDefRevBase(const ParmGrpValRevision &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getParmValuesBase(const ParmGrpValRevision &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMasterDefRevBase(ParmGrpValRevision &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setParmValuesBase(ParmGrpValRevision &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Generic revisePost operation.
    /// @version Teamcenter 10.1
    /// @param pReviseInput - Input ReviseInput object.
    /// @param vecDeepCopyData - Vector of deep copy data.
    /// @return - Returns an integer value.
    ///
    int  revisePostBase(const ParmGrpValRevision &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// Generic saveAsPost operation.
    /// @version Teamcenter 8.1
    /// @param pSavAsInput - Input argument as SaveAsInput object.
    /// @param vecDeepCopyData - vector deepcopy data
    /// @return - Return integer value.
    ///
    int  saveAsPostBase(const ParmGrpValRevision &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const ParmGrpValRevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Validate revise input.
    /// @version Teamcenter 10.1
    /// @param pReviseInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - Returns an int.
    ///
    int  validateReviseInputBase(const ParmGrpValRevision &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// validate saveas input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  validateSaveAsInputBase(const ParmGrpValRevision &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static ParmGrpValRevisionDelegate*  m_pInstance;

    ParmGrpValRevisionDelegate();
    virtual ~ParmGrpValRevisionDelegate();
    static void setInstance( ParmGrpValRevisionDelegate*  instance );


private:
    friend class  ::ccdm::ParmGrpValRevisionGenImpl;

};

#include <ccdm/libccdm_undef.h>
#endif  //  CCDM__PARMGRPVALREVISIONDELEGATE_HXX
