//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ParmVal
    Filename:   ParmVal.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__PARMVAL__HXX
#define CCDM__PARMVAL__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class ParmVal;
}
namespace ccdm
{
    class ParmValImpl;
}
namespace ccdm
{
    class ParmValDelegate;
}
namespace ccdm
{
    class ParmValDispatch;
}
namespace ccdm
{
    class ParmValGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CCDM_API  ccdm::ParmVal
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMasterParmDefRev( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMasterParmDefRev( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ParmVal();

    /**
     * Destructor
     */
    virtual ~ParmVal();

private:
    //  Getter method for the Implementation Object
    ParmValImpl*  getParmValImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setParmValImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ParmValImpl*  m_parmvalImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ParmVal - desc for ParmVal parameter
     */
    ParmVal( const ParmVal& );
    ParmVal& operator=( const ParmVal& );

    friend class  ParmValDelegate;
    friend class  ParmValDispatch;
    friend class  ParmValGenImpl;
};

#include <ccdm/libccdm_undef.h>
#endif //   CCDM__PARMVAL__HXX
