//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ParmValBCD
    Filename:   ParmValBCD.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__PARMVALBCD__HXX
#define CCDM__PARMVALBCD__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <ccdm/ParmVal.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class ParmValBCD;
}
namespace ccdm
{
    class ParmValBCDImpl;
}
namespace ccdm
{
    class ParmValBCDDelegate;
}
namespace ccdm
{
    class ParmValBCDDispatch;
}
namespace ccdm
{
    class ParmValBCDGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CCDM_API  ccdm::ParmValBCD
     : public  ::ccdm::ParmVal
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValues( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValues( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ParmValBCD();

    /**
     * Destructor
     */
    virtual ~ParmValBCD();

private:
    //  Getter method for the Implementation Object
    ParmValBCDImpl*  getParmValBCDImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setParmValBCDImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ParmValBCDImpl*  m_parmvalbcdImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ParmValBCD - desc for ParmValBCD parameter
     */
    ParmValBCD( const ParmValBCD& );
    ParmValBCD& operator=( const ParmValBCD& );

    friend class  ParmValBCDDelegate;
    friend class  ParmValBCDDispatch;
    friend class  ParmValBCDGenImpl;
};

#include <ccdm/libccdm_undef.h>
#endif //   CCDM__PARMVALBCD__HXX
