//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ParmValBCDDelegate
    Filename:   ParmValBCDDelegate.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__PARMVALBCDDELEGATE_HXX
#define CCDM__PARMVALBCDDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ccdm/ParmValBCD.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class ParmValBCDDelegate;
}
namespace ccdm
{
    class ParmValBCDImpl;
}
namespace ccdm
{
    class ParmValBCD;
}
namespace ccdm
{
    class ParmValBCDGenImpl;
}

namespace ccdm_alias = ::ccdm;


class  CCDM_API ccdm_alias::ParmValBCDDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ParmValBCDDelegate instance
    static ParmValBCDDelegate&  getInstance();

    //  Method to create the ParmValBCDImpl pointer
    static ParmValBCDImpl*  createImpl( ParmValBCD&  ifObj );

    //  Method to delete the ParmValBCDImpl pointer
    static void deleteImpl( ParmValBCDImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValuesBase(const ParmValBCD &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValuesBase(ParmValBCD &ifObj,  const tag_t &value, bool isNull );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const ParmValBCD &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static ParmValBCDDelegate*  m_pInstance;

    ParmValBCDDelegate();
    virtual ~ParmValBCDDelegate();
    static void setInstance( ParmValBCDDelegate*  instance );


private:
    friend class  ::ccdm::ParmValBCDGenImpl;

};

#include <ccdm/libccdm_undef.h>
#endif  //  CCDM__PARMVALBCDDELEGATE_HXX
