//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ParmValBitDef
    Filename:   ParmValBitDef.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__PARMVALBITDEF__HXX
#define CCDM__PARMVALBITDEF__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <ccdm/ParmVal.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class ParmValBitDef;
}
namespace ccdm
{
    class ParmValBitDefImpl;
}
namespace ccdm
{
    class ParmValBitDefDelegate;
}
namespace ccdm
{
    class ParmValBitDefDispatch;
}
namespace ccdm
{
    class ParmValBitDefGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CCDM_API  ccdm::ParmValBitDef
     : public  ::ccdm::ParmVal
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getValues( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setValues( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ParmValBitDef();

    /**
     * Destructor
     */
    virtual ~ParmValBitDef();

private:
    //  Getter method for the Implementation Object
    ParmValBitDefImpl*  getParmValBitDefImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setParmValBitDefImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ParmValBitDefImpl*  m_parmvalbitdefImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ParmValBitDef - desc for ParmValBitDef parameter
     */
    ParmValBitDef( const ParmValBitDef& );
    ParmValBitDef& operator=( const ParmValBitDef& );

    friend class  ParmValBitDefDelegate;
    friend class  ParmValBitDefDispatch;
    friend class  ParmValBitDefGenImpl;
};

#include <ccdm/libccdm_undef.h>
#endif //   CCDM__PARMVALBITDEF__HXX
