//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ParmValBitDefDelegate
    Filename:   ParmValBitDefDelegate.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__PARMVALBITDEFDELEGATE_HXX
#define CCDM__PARMVALBITDEFDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ccdm/ParmValBitDef.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class ParmValBitDefDelegate;
}
namespace ccdm
{
    class ParmValBitDefImpl;
}
namespace ccdm
{
    class ParmValBitDef;
}
namespace ccdm
{
    class ParmValBitDefGenImpl;
}

namespace ccdm_alias = ::ccdm;


class  CCDM_API ccdm_alias::ParmValBitDefDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ParmValBitDefDelegate instance
    static ParmValBitDefDelegate&  getInstance();

    //  Method to create the ParmValBitDefImpl pointer
    static ParmValBitDefImpl*  createImpl( ParmValBitDef&  ifObj );

    //  Method to delete the ParmValBitDefImpl pointer
    static void deleteImpl( ParmValBitDefImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getValuesBase(const ParmValBitDef &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setValuesBase(ParmValBitDef &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const ParmValBitDef &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static ParmValBitDefDelegate*  m_pInstance;

    ParmValBitDefDelegate();
    virtual ~ParmValBitDefDelegate();
    static void setInstance( ParmValBitDefDelegate*  instance );


private:
    friend class  ::ccdm::ParmValBitDefGenImpl;

};

#include <ccdm/libccdm_undef.h>
#endif  //  CCDM__PARMVALBITDEFDELEGATE_HXX
