//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ParmValBoolDelegate
    Filename:   ParmValBoolDelegate.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__PARMVALBOOLDELEGATE_HXX
#define CCDM__PARMVALBOOLDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ccdm/ParmValBool.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class ParmValBoolDelegate;
}
namespace ccdm
{
    class ParmValBoolImpl;
}
namespace ccdm
{
    class ParmValBool;
}
namespace ccdm
{
    class ParmValBoolGenImpl;
}

namespace ccdm_alias = ::ccdm;


class  CCDM_API ccdm_alias::ParmValBoolDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ParmValBoolDelegate instance
    static ParmValBoolDelegate&  getInstance();

    //  Method to create the ParmValBoolImpl pointer
    static ParmValBoolImpl*  createImpl( ParmValBool&  ifObj );

    //  Method to delete the ParmValBoolImpl pointer
    static void deleteImpl( ParmValBoolImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValuesBase(const ParmValBool &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValuesBase(ParmValBool &ifObj,  const tag_t &value, bool isNull );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const ParmValBool &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static ParmValBoolDelegate*  m_pInstance;

    ParmValBoolDelegate();
    virtual ~ParmValBoolDelegate();
    static void setInstance( ParmValBoolDelegate*  instance );


private:
    friend class  ::ccdm::ParmValBoolGenImpl;

};

#include <ccdm/libccdm_undef.h>
#endif  //  CCDM__PARMVALBOOLDELEGATE_HXX
