//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ParmValDateDelegate
    Filename:   ParmValDateDelegate.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__PARMVALDATEDELEGATE_HXX
#define CCDM__PARMVALDATEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ccdm/ParmValDate.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class ParmValDateDelegate;
}
namespace ccdm
{
    class ParmValDateImpl;
}
namespace ccdm
{
    class ParmValDate;
}
namespace ccdm
{
    class ParmValDateGenImpl;
}

namespace ccdm_alias = ::ccdm;


class  CCDM_API ccdm_alias::ParmValDateDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ParmValDateDelegate instance
    static ParmValDateDelegate&  getInstance();

    //  Method to create the ParmValDateImpl pointer
    static ParmValDateImpl*  createImpl( ParmValDate&  ifObj );

    //  Method to delete the ParmValDateImpl pointer
    static void deleteImpl( ParmValDateImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValuesBase(const ParmValDate &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValuesBase(ParmValDate &ifObj,  const tag_t &value, bool isNull );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const ParmValDate &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static ParmValDateDelegate*  m_pInstance;

    ParmValDateDelegate();
    virtual ~ParmValDateDelegate();
    static void setInstance( ParmValDateDelegate*  instance );


private:
    friend class  ::ccdm::ParmValDateGenImpl;

};

#include <ccdm/libccdm_undef.h>
#endif  //  CCDM__PARMVALDATEDELEGATE_HXX
