//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ParmValDbl
    Filename:   ParmValDbl.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__PARMVALDBL__HXX
#define CCDM__PARMVALDBL__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <ccdm/ParmVal.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class ParmValDbl;
}
namespace ccdm
{
    class ParmValDblImpl;
}
namespace ccdm
{
    class ParmValDblDelegate;
}
namespace ccdm
{
    class ParmValDblDispatch;
}
namespace ccdm
{
    class ParmValDblGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CCDM_API  ccdm::ParmValDbl
     : public  ::ccdm::ParmVal
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValues( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValues( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ParmValDbl();

    /**
     * Destructor
     */
    virtual ~ParmValDbl();

private:
    //  Getter method for the Implementation Object
    ParmValDblImpl*  getParmValDblImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setParmValDblImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ParmValDblImpl*  m_parmvaldblImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ParmValDbl - desc for ParmValDbl parameter
     */
    ParmValDbl( const ParmValDbl& );
    ParmValDbl& operator=( const ParmValDbl& );

    friend class  ParmValDblDelegate;
    friend class  ParmValDblDispatch;
    friend class  ParmValDblGenImpl;
};

#include <ccdm/libccdm_undef.h>
#endif //   CCDM__PARMVALDBL__HXX
