//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ParmValDblDelegate
    Filename:   ParmValDblDelegate.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__PARMVALDBLDELEGATE_HXX
#define CCDM__PARMVALDBLDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ccdm/ParmValDbl.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class ParmValDblDelegate;
}
namespace ccdm
{
    class ParmValDblImpl;
}
namespace ccdm
{
    class ParmValDbl;
}
namespace ccdm
{
    class ParmValDblGenImpl;
}

namespace ccdm_alias = ::ccdm;


class  CCDM_API ccdm_alias::ParmValDblDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ParmValDblDelegate instance
    static ParmValDblDelegate&  getInstance();

    //  Method to create the ParmValDblImpl pointer
    static ParmValDblImpl*  createImpl( ParmValDbl&  ifObj );

    //  Method to delete the ParmValDblImpl pointer
    static void deleteImpl( ParmValDblImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValuesBase(const ParmValDbl &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValuesBase(ParmValDbl &ifObj,  const tag_t &value, bool isNull );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const ParmValDbl &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static ParmValDblDelegate*  m_pInstance;

    ParmValDblDelegate();
    virtual ~ParmValDblDelegate();
    static void setInstance( ParmValDblDelegate*  instance );


private:
    friend class  ::ccdm::ParmValDblGenImpl;

};

#include <ccdm/libccdm_undef.h>
#endif  //  CCDM__PARMVALDBLDELEGATE_HXX
