//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ParmValDelegate
    Filename:   ParmValDelegate.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__PARMVALDELEGATE_HXX
#define CCDM__PARMVALDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ccdm/ParmVal.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class ParmValDelegate;
}
namespace ccdm
{
    class ParmValImpl;
}
namespace ccdm
{
    class ParmVal;
}
namespace ccdm
{
    class ParmValGenImpl;
}

namespace ccdm_alias = ::ccdm;


class  CCDM_API ccdm_alias::ParmValDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ParmValDelegate instance
    static ParmValDelegate&  getInstance();

    //  Method to create the ParmValImpl pointer
    static ParmValImpl*  createImpl( ParmVal&  ifObj );

    //  Method to delete the ParmValImpl pointer
    static void deleteImpl( ParmValImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMasterParmDefRevBase(const ParmVal &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMasterParmDefRevBase(ParmVal &ifObj,  const tag_t &value, bool isNull );



protected:
    //  Pointer to the instance
    static ParmValDelegate*  m_pInstance;

    ParmValDelegate();
    virtual ~ParmValDelegate();
    static void setInstance( ParmValDelegate*  instance );


private:
    friend class  ::ccdm::ParmValGenImpl;

};

#include <ccdm/libccdm_undef.h>
#endif  //  CCDM__PARMVALDELEGATE_HXX
