//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ParmValHex
    Filename:   ParmValHex.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__PARMVALHEX__HXX
#define CCDM__PARMVALHEX__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <ccdm/ParmVal.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class ParmValHex;
}
namespace ccdm
{
    class ParmValHexImpl;
}
namespace ccdm
{
    class ParmValHexDelegate;
}
namespace ccdm
{
    class ParmValHexDispatch;
}
namespace ccdm
{
    class ParmValHexGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CCDM_API  ccdm::ParmValHex
     : public  ::ccdm::ParmVal
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValues( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValues( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ParmValHex();

    /**
     * Destructor
     */
    virtual ~ParmValHex();

private:
    //  Getter method for the Implementation Object
    ParmValHexImpl*  getParmValHexImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setParmValHexImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ParmValHexImpl*  m_parmvalhexImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ParmValHex - desc for ParmValHex parameter
     */
    ParmValHex( const ParmValHex& );
    ParmValHex& operator=( const ParmValHex& );

    friend class  ParmValHexDelegate;
    friend class  ParmValHexDispatch;
    friend class  ParmValHexGenImpl;
};

#include <ccdm/libccdm_undef.h>
#endif //   CCDM__PARMVALHEX__HXX
