//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ParmValHexDelegate
    Filename:   ParmValHexDelegate.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__PARMVALHEXDELEGATE_HXX
#define CCDM__PARMVALHEXDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ccdm/ParmValHex.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class ParmValHexDelegate;
}
namespace ccdm
{
    class ParmValHexImpl;
}
namespace ccdm
{
    class ParmValHex;
}
namespace ccdm
{
    class ParmValHexGenImpl;
}

namespace ccdm_alias = ::ccdm;


class  CCDM_API ccdm_alias::ParmValHexDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ParmValHexDelegate instance
    static ParmValHexDelegate&  getInstance();

    //  Method to create the ParmValHexImpl pointer
    static ParmValHexImpl*  createImpl( ParmValHex&  ifObj );

    //  Method to delete the ParmValHexImpl pointer
    static void deleteImpl( ParmValHexImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValuesBase(const ParmValHex &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValuesBase(ParmValHex &ifObj,  const tag_t &value, bool isNull );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const ParmValHex &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static ParmValHexDelegate*  m_pInstance;

    ParmValHexDelegate();
    virtual ~ParmValHexDelegate();
    static void setInstance( ParmValHexDelegate*  instance );


private:
    friend class  ::ccdm::ParmValHexGenImpl;

};

#include <ccdm/libccdm_undef.h>
#endif  //  CCDM__PARMVALHEXDELEGATE_HXX
