//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ParmValIntDelegate
    Filename:   ParmValIntDelegate.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__PARMVALINTDELEGATE_HXX
#define CCDM__PARMVALINTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ccdm/ParmValInt.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class ParmValIntDelegate;
}
namespace ccdm
{
    class ParmValIntImpl;
}
namespace ccdm
{
    class ParmValInt;
}
namespace ccdm
{
    class ParmValIntGenImpl;
}

namespace ccdm_alias = ::ccdm;


class  CCDM_API ccdm_alias::ParmValIntDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ParmValIntDelegate instance
    static ParmValIntDelegate&  getInstance();

    //  Method to create the ParmValIntImpl pointer
    static ParmValIntImpl*  createImpl( ParmValInt&  ifObj );

    //  Method to delete the ParmValIntImpl pointer
    static void deleteImpl( ParmValIntImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValuesBase(const ParmValInt &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValuesBase(ParmValInt &ifObj,  const tag_t &value, bool isNull );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const ParmValInt &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static ParmValIntDelegate*  m_pInstance;

    ParmValIntDelegate();
    virtual ~ParmValIntDelegate();
    static void setInstance( ParmValIntDelegate*  instance );


private:
    friend class  ::ccdm::ParmValIntGenImpl;

};

#include <ccdm/libccdm_undef.h>
#endif  //  CCDM__PARMVALINTDELEGATE_HXX
