//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ParmValSED
    Filename:   ParmValSED.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__PARMVALSED__HXX
#define CCDM__PARMVALSED__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <ccdm/ParmVal.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class ParmValSED;
}
namespace ccdm
{
    class ParmValSEDImpl;
}
namespace ccdm
{
    class ParmValSEDDelegate;
}
namespace ccdm
{
    class ParmValSEDDispatch;
}
namespace ccdm
{
    class ParmValSEDGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CCDM_API  ccdm::ParmValSED
     : public  ::ccdm::ParmVal
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValue( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValue( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ParmValSED();

    /**
     * Destructor
     */
    virtual ~ParmValSED();

private:
    //  Getter method for the Implementation Object
    ParmValSEDImpl*  getParmValSEDImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setParmValSEDImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ParmValSEDImpl*  m_parmvalsedImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ParmValSED - desc for ParmValSED parameter
     */
    ParmValSED( const ParmValSED& );
    ParmValSED& operator=( const ParmValSED& );

    friend class  ParmValSEDDelegate;
    friend class  ParmValSEDDispatch;
    friend class  ParmValSEDGenImpl;
};

#include <ccdm/libccdm_undef.h>
#endif //   CCDM__PARMVALSED__HXX
