//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ParmValSEDDelegate
    Filename:   ParmValSEDDelegate.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__PARMVALSEDDELEGATE_HXX
#define CCDM__PARMVALSEDDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ccdm/ParmValSED.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class ParmValSEDDelegate;
}
namespace ccdm
{
    class ParmValSEDImpl;
}
namespace ccdm
{
    class ParmValSED;
}
namespace ccdm
{
    class ParmValSEDGenImpl;
}

namespace ccdm_alias = ::ccdm;


class  CCDM_API ccdm_alias::ParmValSEDDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ParmValSEDDelegate instance
    static ParmValSEDDelegate&  getInstance();

    //  Method to create the ParmValSEDImpl pointer
    static ParmValSEDImpl*  createImpl( ParmValSED&  ifObj );

    //  Method to delete the ParmValSEDImpl pointer
    static void deleteImpl( ParmValSEDImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValueBase(const ParmValSED &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValueBase(ParmValSED &ifObj,  const std::string &value, bool isNull );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const ParmValSED &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static ParmValSEDDelegate*  m_pInstance;

    ParmValSEDDelegate();
    virtual ~ParmValSEDDelegate();
    static void setInstance( ParmValSEDDelegate*  instance );


private:
    friend class  ::ccdm::ParmValSEDGenImpl;

};

#include <ccdm/libccdm_undef.h>
#endif  //  CCDM__PARMVALSEDDELEGATE_HXX
