//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ParmValStrDelegate
    Filename:   ParmValStrDelegate.hxx
    Module:     ccdm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CCDM__PARMVALSTRDELEGATE_HXX
#define CCDM__PARMVALSTRDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ccdm/ParmValStr.hxx>

#include <ccdm/libccdm_exports.h>

namespace ccdm
{
    class ParmValStrDelegate;
}
namespace ccdm
{
    class ParmValStrImpl;
}
namespace ccdm
{
    class ParmValStr;
}
namespace ccdm
{
    class ParmValStrGenImpl;
}

namespace ccdm_alias = ::ccdm;


class  CCDM_API ccdm_alias::ParmValStrDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ParmValStrDelegate instance
    static ParmValStrDelegate&  getInstance();

    //  Method to create the ParmValStrImpl pointer
    static ParmValStrImpl*  createImpl( ParmValStr&  ifObj );

    //  Method to delete the ParmValStrImpl pointer
    static void deleteImpl( ParmValStrImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValuesBase(const ParmValStr &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValuesBase(ParmValStr &ifObj,  const tag_t &value, bool isNull );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const ParmValStr &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static ParmValStrDelegate*  m_pInstance;

    ParmValStrDelegate();
    virtual ~ParmValStrDelegate();
    static void setInstance( ParmValStrDelegate*  instance );


private:
    friend class  ::ccdm::ParmValStrGenImpl;

};

#include <ccdm/libccdm_undef.h>
#endif  //  CCDM__PARMVALSTRDELEGATE_HXX
