//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  ccdm

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libccdm

#if !defined(LIBCCDM) && !defined(IPLIB)
#   error IPLIB or LIBCCDM is not defined
#endif

/* Handwritten code should use CCDM_API, not CCDMEXPORT */

#define CCDM_API CCDMEXPORT

#if IPLIB==libccdm || defined(LIBCCDM)
#   if defined(__lint)
#       define CCDMEXPORT       __export(ccdm)
#       define CCDMGLOBAL       extern __global(ccdm)
#       define CCDMPRIVATE      extern __private(ccdm)
#   elif defined(_WIN32)
#       define CCDMEXPORT       __declspec(dllexport)
#       define CCDMGLOBAL       extern __declspec(dllexport)
#       define CCDMPRIVATE      extern
#   else
#       define CCDMEXPORT
#       define CCDMGLOBAL       extern
#       define CCDMPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CCDMEXPORT       __export(ccdm)
#       define CCDMGLOBAL       extern __global(ccdm)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CCDMEXPORT      __declspec(dllimport)
#       define CCDMGLOBAL       extern __declspec(dllimport)
#   else
#       define CCDMEXPORT
#       define CCDMGLOBAL       extern
#   endif
#endif
