//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  ccdmdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libccdmdispatch

#if !defined(LIBCCDMDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBCCDMDISPATCH is not defined
#endif

/* Handwritten code should use CCDMDISPATCH_API, not CCDMDISPATCHEXPORT */

#define CCDMDISPATCH_API CCDMDISPATCHEXPORT

#if IPLIB==libccdmdispatch || defined(LIBCCDMDISPATCH)
#   if defined(__lint)
#       define CCDMDISPATCHEXPORT       __export(ccdmdispatch)
#       define CCDMDISPATCHGLOBAL       extern __global(ccdmdispatch)
#       define CCDMDISPATCHPRIVATE      extern __private(ccdmdispatch)
#   elif defined(_WIN32)
#       define CCDMDISPATCHEXPORT       __declspec(dllexport)
#       define CCDMDISPATCHGLOBAL       extern __declspec(dllexport)
#       define CCDMDISPATCHPRIVATE      extern
#   else
#       define CCDMDISPATCHEXPORT
#       define CCDMDISPATCHGLOBAL       extern
#       define CCDMDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CCDMDISPATCHEXPORT       __export(ccdmdispatch)
#       define CCDMDISPATCHGLOBAL       extern __global(ccdmdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CCDMDISPATCHEXPORT      __declspec(dllimport)
#       define CCDMDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define CCDMDISPATCHEXPORT
#       define CCDMDISPATCHGLOBAL       extern
#   endif
#endif
