//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cdm0Contract
    Filename:   Cdm0Contract.hxx
    Module:     cdm0contractmanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CDM0CONTRACTMANAGEMENT__CDM0CONTRACT__HXX
#define CDM0CONTRACTMANAGEMENT__CDM0CONTRACT__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/Document.hxx>

#include <cdm0contractmanagement/libcdm0contractmanagement_exports.h>

namespace cdm0contractmanagement
{
    class Cdm0Contract;
}
namespace cdm0contractmanagement
{
    class Cdm0ContractImpl;
}
namespace cdm0contractmanagement
{
    class Cdm0ContractDelegate;
}
namespace cdm0contractmanagement
{
    class Cdm0ContractDispatch;
}
namespace cdm0contractmanagement
{
    class Cdm0ContractGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CDM0CONTRACTMANAGEMENT_API  cdm0contractmanagement::Cdm0Contract
     : public  ::Teamcenter::Document
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0ContractCategory( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCdm0ContractCategory( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cdm0Contract();

    /**
     * Destructor
     */
    virtual ~Cdm0Contract();

private:
    //  Getter method for the Implementation Object
    Cdm0ContractImpl*  getCdm0ContractImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCdm0ContractImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cdm0ContractImpl*  m_cdm0contractImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cdm0Contract - desc for Cdm0Contract parameter
     */
    Cdm0Contract( const Cdm0Contract& );
    Cdm0Contract& operator=( const Cdm0Contract& );

    friend class  Cdm0ContractDelegate;
    friend class  Cdm0ContractDispatch;
    friend class  Cdm0ContractGenImpl;
};

#include <cdm0contractmanagement/libcdm0contractmanagement_undef.h>
#endif //   CDM0CONTRACTMANAGEMENT__CDM0CONTRACT__HXX
