//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cdm0ContractDelegate
    Filename:   Cdm0ContractDelegate.hxx
    Module:     cdm0contractmanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CDM0CONTRACTMANAGEMENT__CDM0CONTRACTDELEGATE_HXX
#define CDM0CONTRACTMANAGEMENT__CDM0CONTRACTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cdm0contractmanagement/Cdm0Contract.hxx>

#include <cdm0contractmanagement/libcdm0contractmanagement_exports.h>

namespace cdm0contractmanagement
{
    class Cdm0ContractDelegate;
}
namespace cdm0contractmanagement
{
    class Cdm0ContractImpl;
}
namespace cdm0contractmanagement
{
    class Cdm0Contract;
}
namespace cdm0contractmanagement
{
    class Cdm0ContractGenImpl;
}

namespace cdm0contractmanagement_alias = ::cdm0contractmanagement;


class  CDM0CONTRACTMANAGEMENT_API cdm0contractmanagement_alias::Cdm0ContractDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cdm0ContractDelegate instance
    static Cdm0ContractDelegate&  getInstance();

    //  Method to create the Cdm0ContractImpl pointer
    static Cdm0ContractImpl*  createImpl( Cdm0Contract&  ifObj );

    //  Method to delete the Cdm0ContractImpl pointer
    static void deleteImpl( Cdm0ContractImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0ContractCategoryBase(const Cdm0Contract &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCdm0ContractCategoryBase(Cdm0Contract &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static Cdm0ContractDelegate*  m_pInstance;

    Cdm0ContractDelegate();
    virtual ~Cdm0ContractDelegate();
    static void setInstance( Cdm0ContractDelegate*  instance );


private:
    friend class  ::cdm0contractmanagement::Cdm0ContractGenImpl;

};

#include <cdm0contractmanagement/libcdm0contractmanagement_undef.h>
#endif  //  CDM0CONTRACTMANAGEMENT__CDM0CONTRACTDELEGATE_HXX
