//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cdm0Corspondence
    Filename:   Cdm0Corspondence.hxx
    Module:     cdm0contractmanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CDM0CONTRACTMANAGEMENT__CDM0CORSPONDENCE__HXX
#define CDM0CONTRACTMANAGEMENT__CDM0CORSPONDENCE__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/Document.hxx>

#include <cdm0contractmanagement/libcdm0contractmanagement_exports.h>

namespace cdm0contractmanagement
{
    class Cdm0Corspondence;
}
namespace cdm0contractmanagement
{
    class Cdm0CorspondenceImpl;
}
namespace cdm0contractmanagement
{
    class Cdm0CorspondenceDelegate;
}
namespace cdm0contractmanagement
{
    class Cdm0CorspondenceDispatch;
}
namespace cdm0contractmanagement
{
    class Cdm0CorspondenceGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CDM0CONTRACTMANAGEMENT_API  cdm0contractmanagement::Cdm0Corspondence
     : public  ::Teamcenter::Document
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0CorrespDocCategory( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCdm0CorrespDocCategory( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cdm0Corspondence();

    /**
     * Destructor
     */
    virtual ~Cdm0Corspondence();

private:
    //  Getter method for the Implementation Object
    Cdm0CorspondenceImpl*  getCdm0CorspondenceImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCdm0CorspondenceImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cdm0CorspondenceImpl*  m_cdm0corspondenceImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cdm0Corspondence - desc for Cdm0Corspondence parameter
     */
    Cdm0Corspondence( const Cdm0Corspondence& );
    Cdm0Corspondence& operator=( const Cdm0Corspondence& );

    friend class  Cdm0CorspondenceDelegate;
    friend class  Cdm0CorspondenceDispatch;
    friend class  Cdm0CorspondenceGenImpl;
};

#include <cdm0contractmanagement/libcdm0contractmanagement_undef.h>
#endif //   CDM0CONTRACTMANAGEMENT__CDM0CORSPONDENCE__HXX
