//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cdm0CorspondenceDelegate
    Filename:   Cdm0CorspondenceDelegate.hxx
    Module:     cdm0contractmanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CDM0CONTRACTMANAGEMENT__CDM0CORSPONDENCEDELEGATE_HXX
#define CDM0CONTRACTMANAGEMENT__CDM0CORSPONDENCEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cdm0contractmanagement/Cdm0Corspondence.hxx>

#include <cdm0contractmanagement/libcdm0contractmanagement_exports.h>

namespace cdm0contractmanagement
{
    class Cdm0CorspondenceDelegate;
}
namespace cdm0contractmanagement
{
    class Cdm0CorspondenceImpl;
}
namespace cdm0contractmanagement
{
    class Cdm0Corspondence;
}
namespace cdm0contractmanagement
{
    class Cdm0CorspondenceGenImpl;
}

namespace cdm0contractmanagement_alias = ::cdm0contractmanagement;


class  CDM0CONTRACTMANAGEMENT_API cdm0contractmanagement_alias::Cdm0CorspondenceDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cdm0CorspondenceDelegate instance
    static Cdm0CorspondenceDelegate&  getInstance();

    //  Method to create the Cdm0CorspondenceImpl pointer
    static Cdm0CorspondenceImpl*  createImpl( Cdm0Corspondence&  ifObj );

    //  Method to delete the Cdm0CorspondenceImpl pointer
    static void deleteImpl( Cdm0CorspondenceImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0CorrespDocCategoryBase(const Cdm0Corspondence &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCdm0CorrespDocCategoryBase(Cdm0Corspondence &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static Cdm0CorspondenceDelegate*  m_pInstance;

    Cdm0CorspondenceDelegate();
    virtual ~Cdm0CorspondenceDelegate();
    static void setInstance( Cdm0CorspondenceDelegate*  instance );


private:
    friend class  ::cdm0contractmanagement::Cdm0CorspondenceGenImpl;

};

#include <cdm0contractmanagement/libcdm0contractmanagement_undef.h>
#endif  //  CDM0CONTRACTMANAGEMENT__CDM0CORSPONDENCEDELEGATE_HXX
