//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cdm0CorspondenceRevisionDelegate
    Filename:   Cdm0CorspondenceRevisionDelegate.hxx
    Module:     cdm0contractmanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CDM0CONTRACTMANAGEMENT__CDM0CORSPONDENCEREVISIONDELEGATE_HXX
#define CDM0CONTRACTMANAGEMENT__CDM0CORSPONDENCEREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cdm0contractmanagement/Cdm0CorspondenceRevision.hxx>

#include <cdm0contractmanagement/libcdm0contractmanagement_exports.h>

namespace cdm0contractmanagement
{
    class Cdm0CorspondenceRevisionDelegate;
}
namespace cdm0contractmanagement
{
    class Cdm0CorspondenceRevisionImpl;
}
namespace cdm0contractmanagement
{
    class Cdm0CorspondenceRevision;
}
namespace cdm0contractmanagement
{
    class Cdm0CorspondenceRevisionGenImpl;
}

namespace cdm0contractmanagement_alias = ::cdm0contractmanagement;


class  CDM0CONTRACTMANAGEMENT_API cdm0contractmanagement_alias::Cdm0CorspondenceRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cdm0CorspondenceRevisionDelegate instance
    static Cdm0CorspondenceRevisionDelegate&  getInstance();

    //  Method to create the Cdm0CorspondenceRevisionImpl pointer
    static Cdm0CorspondenceRevisionImpl*  createImpl( Cdm0CorspondenceRevision&  ifObj );

    //  Method to delete the Cdm0CorspondenceRevisionImpl pointer
    static void deleteImpl( Cdm0CorspondenceRevisionImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0CategoryBase(const Cdm0CorspondenceRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0CorrespondenceDirectionBase(const Cdm0CorspondenceRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0CorrespondHasSubmittalBase(const Cdm0CorspondenceRevision &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0PriorityBase(const Cdm0CorspondenceRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0ReceivedOrgNameBase(const Cdm0CorspondenceRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Date Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0ReceivedorSentDateBase(const Cdm0CorspondenceRevision &ifObj,  date_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0ReferencesBase(const Cdm0CorspondenceRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Date Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0ReplyRequestedDateBase(const Cdm0CorspondenceRevision &ifObj,  date_t &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0ReplyRequiredBase(const Cdm0CorspondenceRevision &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0ResponsiblePartyBase(const Cdm0CorspondenceRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCdm0CategoryBase(Cdm0CorspondenceRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCdm0CorrespondenceDirectionBase(Cdm0CorspondenceRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCdm0PriorityBase(Cdm0CorspondenceRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCdm0ReceivedOrgNameBase(Cdm0CorspondenceRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Date Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCdm0ReceivedorSentDateBase(Cdm0CorspondenceRevision &ifObj,  const date_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCdm0ReferencesBase(Cdm0CorspondenceRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Date Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCdm0ReplyRequestedDateBase(Cdm0CorspondenceRevision &ifObj,  const date_t &value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCdm0ReplyRequiredBase(Cdm0CorspondenceRevision &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCdm0ResponsiblePartyBase(Cdm0CorspondenceRevision &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static Cdm0CorspondenceRevisionDelegate*  m_pInstance;

    Cdm0CorspondenceRevisionDelegate();
    virtual ~Cdm0CorspondenceRevisionDelegate();
    static void setInstance( Cdm0CorspondenceRevisionDelegate*  instance );


private:
    friend class  ::cdm0contractmanagement::Cdm0CorspondenceRevisionGenImpl;

};

#include <cdm0contractmanagement/libcdm0contractmanagement_undef.h>
#endif  //  CDM0CONTRACTMANAGEMENT__CDM0CORSPONDENCEREVISIONDELEGATE_HXX
