//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cdm0DIDDelegate
    Filename:   Cdm0DIDDelegate.hxx
    Module:     cdm0contractmanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CDM0CONTRACTMANAGEMENT__CDM0DIDDELEGATE_HXX
#define CDM0CONTRACTMANAGEMENT__CDM0DIDDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cdm0contractmanagement/Cdm0DID.hxx>

#include <cdm0contractmanagement/libcdm0contractmanagement_exports.h>

namespace cdm0contractmanagement
{
    class Cdm0DIDDelegate;
}
namespace cdm0contractmanagement
{
    class Cdm0DIDImpl;
}
namespace cdm0contractmanagement
{
    class Cdm0DID;
}
namespace cdm0contractmanagement
{
    class Cdm0DIDGenImpl;
}

namespace cdm0contractmanagement_alias = ::cdm0contractmanagement;


class  CDM0CONTRACTMANAGEMENT_API cdm0contractmanagement_alias::Cdm0DIDDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cdm0DIDDelegate instance
    static Cdm0DIDDelegate&  getInstance();

    //  Method to create the Cdm0DIDImpl pointer
    static Cdm0DIDImpl*  createImpl( Cdm0DID&  ifObj );

    //  Method to delete the Cdm0DIDImpl pointer
    static void deleteImpl( Cdm0DIDImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0DIDDocCategoryBase(const Cdm0DID &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0ProgramPhasesBase(const Cdm0DID &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCdm0DIDDocCategoryBase(Cdm0DID &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCdm0ProgramPhasesBase(Cdm0DID &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static Cdm0DIDDelegate*  m_pInstance;

    Cdm0DIDDelegate();
    virtual ~Cdm0DIDDelegate();
    static void setInstance( Cdm0DIDDelegate*  instance );


private:
    friend class  ::cdm0contractmanagement::Cdm0DIDGenImpl;

};

#include <cdm0contractmanagement/libcdm0contractmanagement_undef.h>
#endif  //  CDM0CONTRACTMANAGEMENT__CDM0DIDDELEGATE_HXX
