//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cdm0DIDRevision
    Filename:   Cdm0DIDRevision.hxx
    Module:     cdm0contractmanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CDM0CONTRACTMANAGEMENT__CDM0DIDREVISION__HXX
#define CDM0CONTRACTMANAGEMENT__CDM0DIDREVISION__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/DocumentRevision.hxx>

#include <cdm0contractmanagement/libcdm0contractmanagement_exports.h>

namespace cdm0contractmanagement
{
    class Cdm0DIDRevision;
}
namespace cdm0contractmanagement
{
    class Cdm0DIDRevisionImpl;
}
namespace cdm0contractmanagement
{
    class Cdm0DIDRevisionDelegate;
}
namespace cdm0contractmanagement
{
    class Cdm0DIDRevisionDispatch;
}
namespace cdm0contractmanagement
{
    class Cdm0DIDRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CDM0CONTRACTMANAGEMENT_API  cdm0contractmanagement::Cdm0DIDRevision
     : public  ::Teamcenter::DocumentRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0DIDHasDataReqItem( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cdm0DIDRevision();

    /**
     * Destructor
     */
    virtual ~Cdm0DIDRevision();

private:
    //  Getter method for the Implementation Object
    Cdm0DIDRevisionImpl*  getCdm0DIDRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCdm0DIDRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cdm0DIDRevisionImpl*  m_cdm0didrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cdm0DIDRevision - desc for Cdm0DIDRevision parameter
     */
    Cdm0DIDRevision( const Cdm0DIDRevision& );
    Cdm0DIDRevision& operator=( const Cdm0DIDRevision& );

    friend class  Cdm0DIDRevisionDelegate;
    friend class  Cdm0DIDRevisionDispatch;
    friend class  Cdm0DIDRevisionGenImpl;
};

#include <cdm0contractmanagement/libcdm0contractmanagement_undef.h>
#endif //   CDM0CONTRACTMANAGEMENT__CDM0DIDREVISION__HXX
