//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cdm0DIDRevisionDelegate
    Filename:   Cdm0DIDRevisionDelegate.hxx
    Module:     cdm0contractmanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CDM0CONTRACTMANAGEMENT__CDM0DIDREVISIONDELEGATE_HXX
#define CDM0CONTRACTMANAGEMENT__CDM0DIDREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cdm0contractmanagement/Cdm0DIDRevision.hxx>

#include <cdm0contractmanagement/libcdm0contractmanagement_exports.h>

namespace cdm0contractmanagement
{
    class Cdm0DIDRevisionDelegate;
}
namespace cdm0contractmanagement
{
    class Cdm0DIDRevisionImpl;
}
namespace cdm0contractmanagement
{
    class Cdm0DIDRevision;
}
namespace cdm0contractmanagement
{
    class Cdm0DIDRevisionGenImpl;
}

namespace cdm0contractmanagement_alias = ::cdm0contractmanagement;


class  CDM0CONTRACTMANAGEMENT_API cdm0contractmanagement_alias::Cdm0DIDRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cdm0DIDRevisionDelegate instance
    static Cdm0DIDRevisionDelegate&  getInstance();

    //  Method to create the Cdm0DIDRevisionImpl pointer
    static Cdm0DIDRevisionImpl*  createImpl( Cdm0DIDRevision&  ifObj );

    //  Method to delete the Cdm0DIDRevisionImpl pointer
    static void deleteImpl( Cdm0DIDRevisionImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0DIDHasDataReqItemBase(const Cdm0DIDRevision &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;



protected:
    //  Pointer to the instance
    static Cdm0DIDRevisionDelegate*  m_pInstance;

    Cdm0DIDRevisionDelegate();
    virtual ~Cdm0DIDRevisionDelegate();
    static void setInstance( Cdm0DIDRevisionDelegate*  instance );


private:
    friend class  ::cdm0contractmanagement::Cdm0DIDRevisionGenImpl;

};

#include <cdm0contractmanagement/libcdm0contractmanagement_undef.h>
#endif  //  CDM0CONTRACTMANAGEMENT__CDM0DIDREVISIONDELEGATE_HXX
