//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cdm0DataReqItem
    Filename:   Cdm0DataReqItem.hxx
    Module:     cdm0contractmanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CDM0CONTRACTMANAGEMENT__CDM0DATAREQITEM__HXX
#define CDM0CONTRACTMANAGEMENT__CDM0DATAREQITEM__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <cdm0contractmanagement/libcdm0contractmanagement_exports.h>

namespace cdm0contractmanagement
{
    class Cdm0DataReqItem;
}
namespace cdm0contractmanagement
{
    class Cdm0DataReqItemImpl;
}
namespace cdm0contractmanagement
{
    class Cdm0DataReqItemDelegate;
}
namespace cdm0contractmanagement
{
    class Cdm0DataReqItemDispatch;
}
namespace cdm0contractmanagement
{
    class Cdm0DataReqItemGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CDM0CONTRACTMANAGEMENT_API  cdm0contractmanagement::Cdm0DataReqItem
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0ContractLineItemNumber( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0ContractReference( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0ProvideRecContractDel( bool &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0ReferenceCitation( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCdm0ContractLineItemNumber( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCdm0ContractReference( const std::string &value, bool isNull=false );

    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCdm0ProvideRecContractDel( bool value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCdm0ReferenceCitation( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cdm0DataReqItem();

    /**
     * Destructor
     */
    virtual ~Cdm0DataReqItem();

private:
    //  Getter method for the Implementation Object
    Cdm0DataReqItemImpl*  getCdm0DataReqItemImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCdm0DataReqItemImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cdm0DataReqItemImpl*  m_cdm0datareqitemImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cdm0DataReqItem - desc for Cdm0DataReqItem parameter
     */
    Cdm0DataReqItem( const Cdm0DataReqItem& );
    Cdm0DataReqItem& operator=( const Cdm0DataReqItem& );

    friend class  Cdm0DataReqItemDelegate;
    friend class  Cdm0DataReqItemDispatch;
    friend class  Cdm0DataReqItemGenImpl;
};

#include <cdm0contractmanagement/libcdm0contractmanagement_undef.h>
#endif //   CDM0CONTRACTMANAGEMENT__CDM0DATAREQITEM__HXX
