//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cdm0EventsTable
    Filename:   Cdm0EventsTable.hxx
    Module:     cdm0contractmanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CDM0CONTRACTMANAGEMENT__CDM0EVENTSTABLE__HXX
#define CDM0CONTRACTMANAGEMENT__CDM0EVENTSTABLE__HXX

#include <unidefs.h>
#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <cdm0contractmanagement/libcdm0contractmanagement_exports.h>

namespace cdm0contractmanagement
{
    class Cdm0EventsTable;
}
namespace cdm0contractmanagement
{
    class Cdm0EventsTableImpl;
}
namespace cdm0contractmanagement
{
    class Cdm0EventsTableDelegate;
}
namespace cdm0contractmanagement
{
    class Cdm0EventsTableDispatch;
}
namespace cdm0contractmanagement
{
    class Cdm0EventsTableGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CDM0CONTRACTMANAGEMENT_API  cdm0contractmanagement::Cdm0EventsTable
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Date Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0EndDate( date_t &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0EventName( std::string &value, bool &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0OffSet( int &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0Recurrence( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Date Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0RecurrenceEndDate( date_t &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0RelativeTo( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Date Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0StartDate( date_t &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIs_modifiable( bool &value, bool &isNull ) const;

    ///
    /// Setter for a Date Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCdm0EndDate( const date_t &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCdm0EventName( const std::string &value, bool isNull=false );

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCdm0OffSet( int value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCdm0Recurrence( const std::string &value, bool isNull=false );

    ///
    /// Setter for a Date Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCdm0RecurrenceEndDate( const date_t &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCdm0RelativeTo( const std::string &value, bool isNull=false );

    ///
    /// Setter for a Date Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCdm0StartDate( const date_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cdm0EventsTable();

    /**
     * Destructor
     */
    virtual ~Cdm0EventsTable();

private:
    //  Getter method for the Implementation Object
    Cdm0EventsTableImpl*  getCdm0EventsTableImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCdm0EventsTableImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cdm0EventsTableImpl*  m_cdm0eventstableImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cdm0EventsTable - desc for Cdm0EventsTable parameter
     */
    Cdm0EventsTable( const Cdm0EventsTable& );
    Cdm0EventsTable& operator=( const Cdm0EventsTable& );

    friend class  Cdm0EventsTableDelegate;
    friend class  Cdm0EventsTableDispatch;
    friend class  Cdm0EventsTableGenImpl;
};

#include <cdm0contractmanagement/libcdm0contractmanagement_undef.h>
#endif //   CDM0CONTRACTMANAGEMENT__CDM0EVENTSTABLE__HXX
