//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cdm0ListOfScheduledTasks
    Filename:   Cdm0ListOfScheduledTasks.hxx
    Module:     cdm0contractmanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CDM0CONTRACTMANAGEMENT__CDM0LISTOFSCHEDULEDTASKS__HXX
#define CDM0CONTRACTMANAGEMENT__CDM0LISTOFSCHEDULEDTASKS__HXX

#include <common/tc_deprecation_macros.h>
#include <lov/Fnd0ListOfValuesDynamic.hxx>

#include <cdm0contractmanagement/libcdm0contractmanagement_exports.h>

namespace cdm0contractmanagement
{
    class Cdm0ListOfScheduledTasks;
}
namespace cdm0contractmanagement
{
    class Cdm0ListOfScheduledTasksImpl;
}
namespace cdm0contractmanagement
{
    class Cdm0ListOfScheduledTasksDelegate;
}
namespace cdm0contractmanagement
{
    class Cdm0ListOfScheduledTasksDispatch;
}
namespace cdm0contractmanagement
{
    class Cdm0ListOfScheduledTasksGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CDM0CONTRACTMANAGEMENT_API  cdm0contractmanagement::Cdm0ListOfScheduledTasks
     : public  ::Teamcenter::Fnd0ListOfValuesDynamic
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cdm0ListOfScheduledTasks();

    /**
     * Destructor
     */
    virtual ~Cdm0ListOfScheduledTasks();

private:
    //  Getter method for the Implementation Object
    Cdm0ListOfScheduledTasksImpl*  getCdm0ListOfScheduledTasksImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCdm0ListOfScheduledTasksImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cdm0ListOfScheduledTasksImpl*  m_cdm0listofscheduledtasksImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cdm0ListOfScheduledTasks - desc for Cdm0ListOfScheduledTasks parameter
     */
    Cdm0ListOfScheduledTasks( const Cdm0ListOfScheduledTasks& );
    Cdm0ListOfScheduledTasks& operator=( const Cdm0ListOfScheduledTasks& );

    friend class  Cdm0ListOfScheduledTasksDelegate;
    friend class  Cdm0ListOfScheduledTasksDispatch;
    friend class  Cdm0ListOfScheduledTasksGenImpl;
};

#include <cdm0contractmanagement/libcdm0contractmanagement_undef.h>
#endif //   CDM0CONTRACTMANAGEMENT__CDM0LISTOFSCHEDULEDTASKS__HXX
