//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cdm0ListOfScheduledTasksDelegate
    Filename:   Cdm0ListOfScheduledTasksDelegate.hxx
    Module:     cdm0contractmanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CDM0CONTRACTMANAGEMENT__CDM0LISTOFSCHEDULEDTASKSDELEGATE_HXX
#define CDM0CONTRACTMANAGEMENT__CDM0LISTOFSCHEDULEDTASKSDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cdm0contractmanagement/Cdm0ListOfScheduledTasks.hxx>

#include <cdm0contractmanagement/libcdm0contractmanagement_exports.h>

namespace cdm0contractmanagement
{
    class Cdm0ListOfScheduledTasksDelegate;
}
namespace cdm0contractmanagement
{
    class Cdm0ListOfScheduledTasksImpl;
}
namespace cdm0contractmanagement
{
    class Cdm0ListOfScheduledTasks;
}
namespace cdm0contractmanagement
{
    class Cdm0ListOfScheduledTasksGenImpl;
}

namespace cdm0contractmanagement_alias = ::cdm0contractmanagement;


class  CDM0CONTRACTMANAGEMENT_API cdm0contractmanagement_alias::Cdm0ListOfScheduledTasksDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cdm0ListOfScheduledTasksDelegate instance
    static Cdm0ListOfScheduledTasksDelegate&  getInstance();

    //  Method to create the Cdm0ListOfScheduledTasksImpl pointer
    static Cdm0ListOfScheduledTasksImpl*  createImpl( Cdm0ListOfScheduledTasks&  ifObj );

    //  Method to delete the Cdm0ListOfScheduledTasksImpl pointer
    static void deleteImpl( Cdm0ListOfScheduledTasksImpl*  impl );


    ///
    /// Returns List Of Values based on Dynamic LOV definition and user search criteria.
    /// @version Teamcenter 10
    /// @param operationInputTag - Operation Input containing the modified values.
    /// @param propertyName - Name of the selected property.
    /// @param searchString - User entered search string.
    /// @param sortByProp - Property to use for sorting.
    /// @param sortOrder - order for sorting (0=Ascending, 1=Descending).
    /// @param nResults - Number of returned results.
    /// @param results - Returned Values for LOV.
    /// @return - Zero (0) if everything is alright otherwise the error code.
    ///
    int  fnd0askLOVValuesBase(const Cdm0ListOfScheduledTasks &ifObj,  const tag_t operationInputTag, const std::string *propertyName, const std::string *searchString, const char *sortByProp, const int sortOrder, int *nResults, tag_t **results ) const;


    ///
    /// Returns true if the input value is valid for the Dynamic LOV.
    /// @version Teamcenter 10
    /// @param operationInput - Operation Input containing the modified values.
    /// @param propertyName - Name of the selected property.
    /// @param value - Value to validate.
    /// @param verdict - true if value is valid.
    /// @return - Zero (0) if everything is alright otherwise the error code.
    ///
    int  fnd0isValueValidBase(const Cdm0ListOfScheduledTasks &ifObj,  const tag_t operationInput, const std::string *propertyName, const tag_t value, bool *verdict ) const;



protected:
    //  Pointer to the instance
    static Cdm0ListOfScheduledTasksDelegate*  m_pInstance;

    Cdm0ListOfScheduledTasksDelegate();
    virtual ~Cdm0ListOfScheduledTasksDelegate();
    static void setInstance( Cdm0ListOfScheduledTasksDelegate*  instance );


private:
    friend class  ::cdm0contractmanagement::Cdm0ListOfScheduledTasksGenImpl;

};

#include <cdm0contractmanagement/libcdm0contractmanagement_undef.h>
#endif  //  CDM0CONTRACTMANAGEMENT__CDM0LISTOFSCHEDULEDTASKSDELEGATE_HXX
