//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cdm0Submittal
    Filename:   Cdm0Submittal.hxx
    Module:     cdm0contractmanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CDM0CONTRACTMANAGEMENT__CDM0SUBMITTAL__HXX
#define CDM0CONTRACTMANAGEMENT__CDM0SUBMITTAL__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/Document.hxx>

#include <cdm0contractmanagement/libcdm0contractmanagement_exports.h>

namespace cdm0contractmanagement
{
    class Cdm0Submittal;
}
namespace cdm0contractmanagement
{
    class Cdm0SubmittalImpl;
}
namespace cdm0contractmanagement
{
    class Cdm0SubmittalDelegate;
}
namespace cdm0contractmanagement
{
    class Cdm0SubmittalDispatch;
}
namespace cdm0contractmanagement
{
    class Cdm0SubmittalGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CDM0CONTRACTMANAGEMENT_API  cdm0contractmanagement::Cdm0Submittal
     : public  ::Teamcenter::Document
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0SubmittalStatus( std::string &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cdm0Submittal();

    /**
     * Destructor
     */
    virtual ~Cdm0Submittal();

private:
    //  Getter method for the Implementation Object
    Cdm0SubmittalImpl*  getCdm0SubmittalImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCdm0SubmittalImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cdm0SubmittalImpl*  m_cdm0submittalImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cdm0Submittal - desc for Cdm0Submittal parameter
     */
    Cdm0Submittal( const Cdm0Submittal& );
    Cdm0Submittal& operator=( const Cdm0Submittal& );

    friend class  Cdm0SubmittalDelegate;
    friend class  Cdm0SubmittalDispatch;
    friend class  Cdm0SubmittalGenImpl;
};

#include <cdm0contractmanagement/libcdm0contractmanagement_undef.h>
#endif //   CDM0CONTRACTMANAGEMENT__CDM0SUBMITTAL__HXX
