//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cdm0SubmittalRevisionDelegate
    Filename:   Cdm0SubmittalRevisionDelegate.hxx
    Module:     cdm0contractmanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CDM0CONTRACTMANAGEMENT__CDM0SUBMITTALREVISIONDELEGATE_HXX
#define CDM0CONTRACTMANAGEMENT__CDM0SUBMITTALREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cdm0contractmanagement/Cdm0SubmittalRevision.hxx>

#include <cdm0contractmanagement/libcdm0contractmanagement_exports.h>

namespace cdm0contractmanagement
{
    class Cdm0SubmittalRevisionDelegate;
}
namespace cdm0contractmanagement
{
    class Cdm0SubmittalRevisionImpl;
}
namespace cdm0contractmanagement
{
    class Cdm0SubmittalRevision;
}
namespace cdm0contractmanagement
{
    class Cdm0SubmittalRevisionGenImpl;
}

namespace cdm0contractmanagement_alias = ::cdm0contractmanagement;


class  CDM0CONTRACTMANAGEMENT_API cdm0contractmanagement_alias::Cdm0SubmittalRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cdm0SubmittalRevisionDelegate instance
    static Cdm0SubmittalRevisionDelegate&  getInstance();

    //  Method to create the Cdm0SubmittalRevisionImpl pointer
    static Cdm0SubmittalRevisionImpl*  createImpl( Cdm0SubmittalRevision&  ifObj );

    //  Method to delete the Cdm0SubmittalRevisionImpl pointer
    static void deleteImpl( Cdm0SubmittalRevisionImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0DispositionBase(const Cdm0SubmittalRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Date Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0DispositionDateBase(const Cdm0SubmittalRevision &ifObj,  date_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0DRLItemTypeBase(const Cdm0SubmittalRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0OfficePriRespBase(const Cdm0SubmittalRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Date Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0ReceivedDateBase(const Cdm0SubmittalRevision &ifObj,  date_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0ResubmitCommentsBase(const Cdm0SubmittalRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Date Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0ResubmitDueDateBase(const Cdm0SubmittalRevision &ifObj,  date_t &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0ResubmitRequiredBase(const Cdm0SubmittalRevision &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0ShippingDocumentNameBase(const Cdm0SubmittalRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0SubmitalHasDataReqItemBase(const Cdm0SubmittalRevision &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Date Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0SubmitDueDateBase(const Cdm0SubmittalRevision &ifObj,  date_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCdm0SubmittalMaturityBase(const Cdm0SubmittalRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCdm0DispositionBase(Cdm0SubmittalRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Date Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCdm0DispositionDateBase(Cdm0SubmittalRevision &ifObj,  const date_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCdm0DRLItemTypeBase(Cdm0SubmittalRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCdm0OfficePriRespBase(Cdm0SubmittalRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Date Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCdm0ReceivedDateBase(Cdm0SubmittalRevision &ifObj,  const date_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCdm0ResubmitCommentsBase(Cdm0SubmittalRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Date Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCdm0ResubmitDueDateBase(Cdm0SubmittalRevision &ifObj,  const date_t &value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCdm0ResubmitRequiredBase(Cdm0SubmittalRevision &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCdm0ShippingDocumentNameBase(Cdm0SubmittalRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Date Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCdm0SubmitDueDateBase(Cdm0SubmittalRevision &ifObj,  const date_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCdm0SubmittalMaturityBase(Cdm0SubmittalRevision &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static Cdm0SubmittalRevisionDelegate*  m_pInstance;

    Cdm0SubmittalRevisionDelegate();
    virtual ~Cdm0SubmittalRevisionDelegate();
    static void setInstance( Cdm0SubmittalRevisionDelegate*  instance );


private:
    friend class  ::cdm0contractmanagement::Cdm0SubmittalRevisionGenImpl;

};

#include <cdm0contractmanagement/libcdm0contractmanagement_undef.h>
#endif  //  CDM0CONTRACTMANAGEMENT__CDM0SUBMITTALREVISIONDELEGATE_HXX
