//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  cdm0contractmanagement

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libcdm0contractmanagement

#if !defined(LIBCDM0CONTRACTMANAGEMENT) && !defined(IPLIB)
#   error IPLIB or LIBCDM0CONTRACTMANAGEMENT is not defined
#endif

/* Handwritten code should use CDM0CONTRACTMANAGEMENT_API, not CDM0CONTRACTMANAGEMENTEXPORT */

#define CDM0CONTRACTMANAGEMENT_API CDM0CONTRACTMANAGEMENTEXPORT

#if IPLIB==libcdm0contractmanagement || defined(LIBCDM0CONTRACTMANAGEMENT)
#   if defined(__lint)
#       define CDM0CONTRACTMANAGEMENTEXPORT       __export(cdm0contractmanagement)
#       define CDM0CONTRACTMANAGEMENTGLOBAL       extern __global(cdm0contractmanagement)
#       define CDM0CONTRACTMANAGEMENTPRIVATE      extern __private(cdm0contractmanagement)
#   elif defined(_WIN32)
#       define CDM0CONTRACTMANAGEMENTEXPORT       __declspec(dllexport)
#       define CDM0CONTRACTMANAGEMENTGLOBAL       extern __declspec(dllexport)
#       define CDM0CONTRACTMANAGEMENTPRIVATE      extern
#   else
#       define CDM0CONTRACTMANAGEMENTEXPORT
#       define CDM0CONTRACTMANAGEMENTGLOBAL       extern
#       define CDM0CONTRACTMANAGEMENTPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CDM0CONTRACTMANAGEMENTEXPORT       __export(cdm0contractmanagement)
#       define CDM0CONTRACTMANAGEMENTGLOBAL       extern __global(cdm0contractmanagement)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CDM0CONTRACTMANAGEMENTEXPORT      __declspec(dllimport)
#       define CDM0CONTRACTMANAGEMENTGLOBAL       extern __declspec(dllimport)
#   else
#       define CDM0CONTRACTMANAGEMENTEXPORT
#       define CDM0CONTRACTMANAGEMENTGLOBAL       extern
#   endif
#endif
