//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ConditionDelegate
    Filename:   ConditionDelegate.hxx
    Module:     ce
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONDITIONDELEGATE_HXX
#define TEAMCENTER__CONDITIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ce/Condition.hxx>

#include <ce/libce_exports.h>

namespace Teamcenter
{
    class ConditionDelegate;
}
namespace Teamcenter
{
    class ConditionImpl;
}
namespace Teamcenter
{
    class Condition;
}
namespace Teamcenter
{
    class ConditionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CE_API Teamcenter_alias::ConditionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ConditionDelegate instance
    static ConditionDelegate&  getInstance();

    //  Method to create the ConditionImpl pointer
    static ConditionImpl*  createImpl( Condition&  ifObj );

    //  Method to delete the ConditionImpl pointer
    static void deleteImpl( ConditionImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCondition_descBase(const Condition &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCondition_nameBase(const Condition &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getExpressionBase(const Condition &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Tc 8
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getParametersBase(const Condition &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSecure_flagBase(const Condition &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCondition_descBase(Condition &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCondition_nameBase(Condition &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setExpressionBase(Condition &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Tc 8
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setParametersBase(Condition &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSecure_flagBase(Condition &ifObj,  bool value, bool isNull );



protected:
    //  Pointer to the instance
    static ConditionDelegate*  m_pInstance;

    ConditionDelegate();
    virtual ~ConditionDelegate();
    static void setInstance( ConditionDelegate*  instance );


private:
    friend class  ::Teamcenter::ConditionGenImpl;

};

#include <ce/libce_undef.h>
#endif  //  TEAMCENTER__CONDITIONDELEGATE_HXX
