//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ConditionParameter
    Filename:   ConditionParameter.hxx
    Module:     ce
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONDITIONPARAMETER__HXX
#define TEAMCENTER__CONDITIONPARAMETER__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <ce/libce_exports.h>

namespace Teamcenter
{
    class ConditionParameter;
}
namespace Teamcenter
{
    class ConditionParameterImpl;
}
namespace Teamcenter
{
    class ConditionParameterDelegate;
}
namespace Teamcenter
{
    class ConditionParameterDispatch;
}
namespace Teamcenter
{
    class ConditionParameterGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CE_API  Teamcenter::ConditionParameter
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getParameter_name( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getParameter_type( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setParameter_name( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setParameter_type( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ConditionParameter();

    /**
     * Destructor
     */
    virtual ~ConditionParameter();

private:
    //  Getter method for the Implementation Object
    ConditionParameterImpl*  getConditionParameterImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setConditionParameterImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ConditionParameterImpl*  m_conditionparameterImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ConditionParameter - desc for ConditionParameter parameter
     */
    ConditionParameter( const ConditionParameter& );
    ConditionParameter& operator=( const ConditionParameter& );

    friend class  ConditionParameterDelegate;
    friend class  ConditionParameterDispatch;
    friend class  ConditionParameterGenImpl;
};

#include <ce/libce_undef.h>
#endif //   TEAMCENTER__CONDITIONPARAMETER__HXX
