//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ConditionParameterDelegate
    Filename:   ConditionParameterDelegate.hxx
    Module:     ce
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONDITIONPARAMETERDELEGATE_HXX
#define TEAMCENTER__CONDITIONPARAMETERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ce/ConditionParameter.hxx>

#include <ce/libce_exports.h>

namespace Teamcenter
{
    class ConditionParameterDelegate;
}
namespace Teamcenter
{
    class ConditionParameterImpl;
}
namespace Teamcenter
{
    class ConditionParameter;
}
namespace Teamcenter
{
    class ConditionParameterGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CE_API Teamcenter_alias::ConditionParameterDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ConditionParameterDelegate instance
    static ConditionParameterDelegate&  getInstance();

    //  Method to create the ConditionParameterImpl pointer
    static ConditionParameterImpl*  createImpl( ConditionParameter&  ifObj );

    //  Method to delete the ConditionParameterImpl pointer
    static void deleteImpl( ConditionParameterImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getParameter_nameBase(const ConditionParameter &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getParameter_typeBase(const ConditionParameter &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setParameter_nameBase(ConditionParameter &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setParameter_typeBase(ConditionParameter &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static ConditionParameterDelegate*  m_pInstance;

    ConditionParameterDelegate();
    virtual ~ConditionParameterDelegate();
    static void setInstance( ConditionParameterDelegate*  instance );


private:
    friend class  ::Teamcenter::ConditionParameterGenImpl;

};

#include <ce/libce_undef.h>
#endif  //  TEAMCENTER__CONDITIONPARAMETERDELEGATE_HXX
