//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ConditionHelperDelegate
    Filename:   Fnd0ConditionHelperDelegate.hxx
    Module:     ce
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0CONDITIONHELPERDELEGATE_HXX
#define TEAMCENTER__FND0CONDITIONHELPERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ce/Fnd0ConditionHelper.hxx>

#include <ce/libce_exports.h>

namespace Teamcenter
{
    class Fnd0ConditionHelperDelegate;
}
namespace Teamcenter
{
    class Fnd0ConditionHelperImpl;
}
namespace Teamcenter
{
    class Fnd0ConditionHelper;
}
namespace Teamcenter
{
    class Fnd0ConditionHelperGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CE_API Teamcenter_alias::Fnd0ConditionHelperDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0ConditionHelperDelegate instance
    static Fnd0ConditionHelperDelegate&  getInstance();

    //  Method to create the Fnd0ConditionHelperImpl pointer
    static Fnd0ConditionHelperImpl*  createImpl( Fnd0ConditionHelper&  ifObj );

    //  Method to delete the Fnd0ConditionHelperImpl pointer
    static void deleteImpl( Fnd0ConditionHelperImpl*  impl );


    ///
    /// 
    /// @version Teamcenter 12.4
    /// @param object - Selected object
    /// @param refPropName - TypeRef Property Name
    /// @param refPropName2 - Property name on the TypeRef object whose value is to be retrieved
    /// @param refPropValue - Property Value on the type ref object corresponding to refPropName2
    /// @return - 
    ///
    int  fnd0getPropValueOnRefObjBase(const Fnd0ConditionHelper &ifObj,  tag_t object, std::string &refPropName, std::string &refPropName2, std::string &refPropValue );


    ///
    /// Is the date null?
    /// @version Teamcenter 9.1
    /// @param date - The date to check
    /// @param isNull - Is the date null?
    /// @return - ITK_OK
    ///
    int  fnd0isNullDateBase(const Fnd0ConditionHelper &ifObj,  const date_t date, bool *isNull );


    ///
    /// Operation to verify whether a group is a sub-group of another Group.
    /// @version Teamcenter 11.2
    /// @param group - group object
    /// @param parentGroupName - The parent group name.
    /// @param result - True if the group is the sub group of a group identified by parentGroupName
    /// @return - ITK_ok if no error else error code
    ///
    int  fnd0isSubGroupOfBase(const Fnd0ConditionHelper &ifObj,  const tag_t group, const std::string &parentGroupName, bool *result );


    ///
    /// Operation to verify if an object type matches another type or its subtypes.
    /// @version Teamcenter 11.2
    /// @param target - Input object Tag. It can be either WorkspaceObject Tag or its Type Tag.
    /// @param parentTypeName - The parent type name.
    /// @param result - True if the type of target is same as or subtype of type identified by parentTypeName.
    /// @return - ITK_ok if no error else error code.
    ///
    int  fnd0isSubTypeOfBase(const Fnd0ConditionHelper &ifObj,  tag_t target, const std::string &parentTypeName, bool *result );


    ///
    /// checks if input value is present in the given preference.
    /// @version Teamcenter 10.1
    /// @param prefName - Preference name
    /// @param prefValue - preference value
    /// @param isMatched - True, If input values matches with preference value.
    /// @return - ITK_OK
    ///
    int  fnd0isValuePresentInPrefBase(const Fnd0ConditionHelper &ifObj,  std::string &prefName, std::string &prefValue, bool *isMatched );


    ///
    /// Sets the date to the current date and time
    /// @version Teamcenter 9.1
    /// @param now - The current date time
    /// @return - ITK_OK
    ///
    int  fnd0NowBase(const Fnd0ConditionHelper &ifObj,  date_t *now );



protected:
    //  Pointer to the instance
    static Fnd0ConditionHelperDelegate*  m_pInstance;

    Fnd0ConditionHelperDelegate();
    virtual ~Fnd0ConditionHelperDelegate();
    static void setInstance( Fnd0ConditionHelperDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0ConditionHelperGenImpl;

};

#include <ce/libce_undef.h>
#endif  //  TEAMCENTER__FND0CONDITIONHELPERDELEGATE_HXX
