//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, UserSessionDelegate
    Filename:   UserSessionDelegate.hxx
    Module:     ce
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__USERSESSIONDELEGATE_HXX
#define TEAMCENTER__USERSESSIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ce/UserSession.hxx>

#include <ce/libce_exports.h>

namespace Teamcenter
{
    class UserSessionDelegate;
}
namespace Teamcenter
{
    class UserSessionImpl;
}
namespace Teamcenter
{
    class UserSession;
}
namespace Teamcenter
{
    class UserSessionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CE_API Teamcenter_alias::UserSessionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the UserSessionDelegate instance
    static UserSessionDelegate&  getInstance();

    //  Method to create the UserSessionImpl pointer
    static UserSessionImpl*  createImpl( UserSession&  ifObj );

    //  Method to delete the UserSessionImpl pointer
    static void deleteImpl( UserSessionImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0bypassflagBase(const UserSession &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0displayruleBase(const UserSession &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0displayTypesBase(const UserSession &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0groupmemberBase(const UserSession &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0isTrueConditionsBase(const UserSession &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0localeBase(const UserSession &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0LocalVolumeBase(const UserSession &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0LocationCodeBase(const UserSession &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0organizationBase(const UserSession &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.6
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ShowGDPRBase(const UserSession &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// The operation returns classic multisite active session status.
    /// @version Teamcenter 10
    /// @param isActive - Returns an integer based classic multisite session status.
    /// @return - Returns an integer based classic multisite session status.
    ///
    int  fnd0getClassMultisiteSessionStatusBase(const UserSession &ifObj,  int *isActive );


    ///
    /// This operation returns the full group name of the current login user, including all the sub-groups.
    /// @version Teamcenter 8.2
    /// @param gname - A string representing the group name
    /// @return - Return a string representing the group name
    ///
    int  fnd0getGroupNameBase(const UserSession &ifObj,  std::string &gname );


    ///
    /// The operation returns PIE active session status.
    /// @version Teamcenter 10
    /// @param isActive - An integer representing PIE session
    /// @return - Returns an integer based PIE session status.
    ///
    int  fnd0getPIESessionStatusBase(const UserSession &ifObj,  int *isActive );


    ///
    /// isInProjListORSessionProject
    /// @version Teamcenter 9
    /// @param object - object
    /// @param projectName - ProjectName
    /// @param output - output
    /// @return - int
    ///
    int  fnd0isInProjListORSessionProjectBase(const UserSession &ifObj,  const tag_t &object, std::string &projectName, bool *output );


    ///
    /// isOwningORSessionProject
    /// @version Teamcenter 9
    /// @param object - object
    /// @param projectName - ProjectName
    /// @param output - output
    /// @return - int
    ///
    int  fnd0isOwningORSessionProjectBase(const UserSession &ifObj,  const tag_t &object, std::string &projectName, bool *output );


    ///
    /// The operation returns the license level of the login user.
    /// @version Teamcenter 8.0.1
    /// @param level - An integer representing the license level
    /// @return - Returns an integer representing the license level.
    ///
    int  getLicenseLevelBase(const UserSession &ifObj,  int *level );


    ///
    /// The operation returns TIE active session status.
    /// @version Teamcenter 8.1
    /// @param isActive - An integer representing TIE session
    /// @return - Returns an integer based TIE session status.
    ///
    int  getTIESessionStatusBase(const UserSession &ifObj,  int *isActive );



protected:
    //  Pointer to the instance
    static UserSessionDelegate*  m_pInstance;

    UserSessionDelegate();
    virtual ~UserSessionDelegate();
    static void setInstance( UserSessionDelegate*  instance );


private:
    friend class  ::Teamcenter::UserSessionGenImpl;

};

#include <ce/libce_undef.h>
#endif  //  TEAMCENTER__USERSESSIONDELEGATE_HXX
