//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  ce

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libce

#if !defined(LIBCE) && !defined(IPLIB)
#   error IPLIB or LIBCE is not defined
#endif

/* Handwritten code should use CE_API, not CEEXPORT */

#define CE_API CEEXPORT

#if IPLIB==libce || defined(LIBCE)
#   if defined(__lint)
#       define CEEXPORT       __export(ce)
#       define CEGLOBAL       extern __global(ce)
#       define CEPRIVATE      extern __private(ce)
#   elif defined(_WIN32)
#       define CEEXPORT       __declspec(dllexport)
#       define CEGLOBAL       extern __declspec(dllexport)
#       define CEPRIVATE      extern
#   else
#       define CEEXPORT
#       define CEGLOBAL       extern
#       define CEPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CEEXPORT       __export(ce)
#       define CEGLOBAL       extern __global(ce)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CEEXPORT      __declspec(dllimport)
#       define CEGLOBAL       extern __declspec(dllimport)
#   else
#       define CEEXPORT
#       define CEGLOBAL       extern
#   endif
#endif
