//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CFMDateEntry
    Filename:   CFMDateEntry.hxx
    Module:     cfm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFMDATEENTRY__HXX
#define TEAMCENTER__CFMDATEENTRY__HXX

#include <common/tc_deprecation_macros.h>
#include <cfm/CFMRuleEntry.hxx>

#include <cfm/libcfm_exports.h>

namespace Teamcenter
{
    class CFMDateEntry;
}
namespace Teamcenter
{
    class CFMDateEntryImpl;
}
namespace Teamcenter
{
    class CFMDateEntryDelegate;
}
namespace Teamcenter
{
    class CFMDateEntryDispatch;
}
namespace Teamcenter
{
    class CFMDateEntryGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFM_API  Teamcenter::CFMDateEntry
     : public  ::Teamcenter::CFMRuleEntry
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CFMDateEntry();

    /**
     * Destructor
     */
    virtual ~CFMDateEntry();

private:
    //  Getter method for the Implementation Object
    CFMDateEntryImpl*  getCFMDateEntryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCFMDateEntryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CFMDateEntryImpl*  m_cfmdateentryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CFMDateEntry - desc for CFMDateEntry parameter
     */
    CFMDateEntry( const CFMDateEntry& );
    CFMDateEntry& operator=( const CFMDateEntry& );

    friend class  CFMDateEntryDelegate;
    friend class  CFMDateEntryDispatch;
    friend class  CFMDateEntryGenImpl;
};

#include <cfm/libcfm_undef.h>
#endif //   TEAMCENTER__CFMDATEENTRY__HXX
