//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CFMEndItemEntry
    Filename:   CFMEndItemEntry.hxx
    Module:     cfm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFMENDITEMENTRY__HXX
#define TEAMCENTER__CFMENDITEMENTRY__HXX

#include <common/tc_deprecation_macros.h>
#include <cfm/CFMRuleEntry.hxx>

#include <cfm/libcfm_exports.h>

namespace Teamcenter
{
    class CFMEndItemEntry;
}
namespace Teamcenter
{
    class CFMEndItemEntryImpl;
}
namespace Teamcenter
{
    class CFMEndItemEntryDelegate;
}
namespace Teamcenter
{
    class CFMEndItemEntryDispatch;
}
namespace Teamcenter
{
    class CFMEndItemEntryGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFM_API  Teamcenter::CFMEndItemEntry
     : public  ::Teamcenter::CFMRuleEntry
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CFMEndItemEntry();

    /**
     * Destructor
     */
    virtual ~CFMEndItemEntry();

private:
    //  Getter method for the Implementation Object
    CFMEndItemEntryImpl*  getCFMEndItemEntryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCFMEndItemEntryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CFMEndItemEntryImpl*  m_cfmenditementryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CFMEndItemEntry - desc for CFMEndItemEntry parameter
     */
    CFMEndItemEntry( const CFMEndItemEntry& );
    CFMEndItemEntry& operator=( const CFMEndItemEntry& );

    friend class  CFMEndItemEntryDelegate;
    friend class  CFMEndItemEntryDispatch;
    friend class  CFMEndItemEntryGenImpl;
};

#include <cfm/libcfm_undef.h>
#endif //   TEAMCENTER__CFMENDITEMENTRY__HXX
