//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CFMGroupEntry
    Filename:   CFMGroupEntry.hxx
    Module:     cfm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFMGROUPENTRY__HXX
#define TEAMCENTER__CFMGROUPENTRY__HXX

#include <common/tc_deprecation_macros.h>
#include <cfm/CFMRuleEntry.hxx>

#include <cfm/libcfm_exports.h>

namespace Teamcenter
{
    class CFMGroupEntry;
}
namespace Teamcenter
{
    class CFMGroupEntryImpl;
}
namespace Teamcenter
{
    class CFMGroupEntryDelegate;
}
namespace Teamcenter
{
    class CFMGroupEntryDispatch;
}
namespace Teamcenter
{
    class CFMGroupEntryGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFM_API  Teamcenter::CFMGroupEntry
     : public  ::Teamcenter::CFMRuleEntry
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CFMGroupEntry();

    /**
     * Destructor
     */
    virtual ~CFMGroupEntry();

private:
    //  Getter method for the Implementation Object
    CFMGroupEntryImpl*  getCFMGroupEntryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCFMGroupEntryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CFMGroupEntryImpl*  m_cfmgroupentryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CFMGroupEntry - desc for CFMGroupEntry parameter
     */
    CFMGroupEntry( const CFMGroupEntry& );
    CFMGroupEntry& operator=( const CFMGroupEntry& );

    friend class  CFMGroupEntryDelegate;
    friend class  CFMGroupEntryDispatch;
    friend class  CFMGroupEntryGenImpl;
};

#include <cfm/libcfm_undef.h>
#endif //   TEAMCENTER__CFMGROUPENTRY__HXX
