//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CFMGroupEntryDelegate
    Filename:   CFMGroupEntryDelegate.hxx
    Module:     cfm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFMGROUPENTRYDELEGATE_HXX
#define TEAMCENTER__CFMGROUPENTRYDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cfm/CFMGroupEntry.hxx>

#include <cfm/libcfm_exports.h>

namespace Teamcenter
{
    class CFMGroupEntryDelegate;
}
namespace Teamcenter
{
    class CFMGroupEntryImpl;
}
namespace Teamcenter
{
    class CFMGroupEntry;
}
namespace Teamcenter
{
    class CFMGroupEntryGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CFM_API Teamcenter_alias::CFMGroupEntryDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CFMGroupEntryDelegate instance
    static CFMGroupEntryDelegate&  getInstance();

    //  Method to create the CFMGroupEntryImpl pointer
    static CFMGroupEntryImpl*  createImpl( CFMGroupEntry&  ifObj );

    //  Method to delete the CFMGroupEntryImpl pointer
    static void deleteImpl( CFMGroupEntryImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @param isLockForDelete - A boolean to indicate if object(s) are to be locked for deletion
    /// @param allowRelock - A boolean to indicate if object(s) can be relocked, which will discard all unsaved changes, if already locked by the same user
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0LockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd, const bool isLockForDelete, const bool allowRelock );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0RefreshBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0UnlockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static CFMGroupEntryDelegate*  m_pInstance;

    CFMGroupEntryDelegate();
    virtual ~CFMGroupEntryDelegate();
    static void setInstance( CFMGroupEntryDelegate*  instance );


private:
    friend class  ::Teamcenter::CFMGroupEntryGenImpl;

};

#include <cfm/libcfm_undef.h>
#endif  //  TEAMCENTER__CFMGROUPENTRYDELEGATE_HXX
