//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CFMGroupItemTypeEntry
    Filename:   CFMGroupItemTypeEntry.hxx
    Module:     cfm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFMGROUPITEMTYPEENTRY__HXX
#define TEAMCENTER__CFMGROUPITEMTYPEENTRY__HXX

#include <common/tc_deprecation_macros.h>
#include <cfm/CFMRuleEntry.hxx>

#include <cfm/libcfm_exports.h>

namespace Teamcenter
{
    class CFMGroupItemTypeEntry;
}
namespace Teamcenter
{
    class CFMGroupItemTypeEntryImpl;
}
namespace Teamcenter
{
    class CFMGroupItemTypeEntryDelegate;
}
namespace Teamcenter
{
    class CFMGroupItemTypeEntryDispatch;
}
namespace Teamcenter
{
    class CFMGroupItemTypeEntryGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFM_API  Teamcenter::CFMGroupItemTypeEntry
     : public  ::Teamcenter::CFMRuleEntry
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CFMGroupItemTypeEntry();

    /**
     * Destructor
     */
    virtual ~CFMGroupItemTypeEntry();

private:
    //  Getter method for the Implementation Object
    CFMGroupItemTypeEntryImpl*  getCFMGroupItemTypeEntryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCFMGroupItemTypeEntryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CFMGroupItemTypeEntryImpl*  m_cfmgroupitemtypeentryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CFMGroupItemTypeEntry - desc for CFMGroupItemTypeEntry parameter
     */
    CFMGroupItemTypeEntry( const CFMGroupItemTypeEntry& );
    CFMGroupItemTypeEntry& operator=( const CFMGroupItemTypeEntry& );

    friend class  CFMGroupItemTypeEntryDelegate;
    friend class  CFMGroupItemTypeEntryDispatch;
    friend class  CFMGroupItemTypeEntryGenImpl;
};

#include <cfm/libcfm_undef.h>
#endif //   TEAMCENTER__CFMGROUPITEMTYPEENTRY__HXX
