//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CFMLatestEntry
    Filename:   CFMLatestEntry.hxx
    Module:     cfm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFMLATESTENTRY__HXX
#define TEAMCENTER__CFMLATESTENTRY__HXX

#include <common/tc_deprecation_macros.h>
#include <cfm/CFMRuleEntry.hxx>

#include <cfm/libcfm_exports.h>

namespace Teamcenter
{
    class CFMLatestEntry;
}
namespace Teamcenter
{
    class CFMLatestEntryImpl;
}
namespace Teamcenter
{
    class CFMLatestEntryDelegate;
}
namespace Teamcenter
{
    class CFMLatestEntryDispatch;
}
namespace Teamcenter
{
    class CFMLatestEntryGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFM_API  Teamcenter::CFMLatestEntry
     : public  ::Teamcenter::CFMRuleEntry
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CFMLatestEntry();

    /**
     * Destructor
     */
    virtual ~CFMLatestEntry();

private:
    //  Getter method for the Implementation Object
    CFMLatestEntryImpl*  getCFMLatestEntryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCFMLatestEntryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CFMLatestEntryImpl*  m_cfmlatestentryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CFMLatestEntry - desc for CFMLatestEntry parameter
     */
    CFMLatestEntry( const CFMLatestEntry& );
    CFMLatestEntry& operator=( const CFMLatestEntry& );

    friend class  CFMLatestEntryDelegate;
    friend class  CFMLatestEntryDispatch;
    friend class  CFMLatestEntryGenImpl;
};

#include <cfm/libcfm_undef.h>
#endif //   TEAMCENTER__CFMLATESTENTRY__HXX
