//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CFMOverrideEntry
    Filename:   CFMOverrideEntry.hxx
    Module:     cfm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFMOVERRIDEENTRY__HXX
#define TEAMCENTER__CFMOVERRIDEENTRY__HXX

#include <common/tc_deprecation_macros.h>
#include <cfm/CFMRuleEntry.hxx>

#include <cfm/libcfm_exports.h>

namespace Teamcenter
{
    class CFMOverrideEntry;
}
namespace Teamcenter
{
    class CFMOverrideEntryImpl;
}
namespace Teamcenter
{
    class CFMOverrideEntryDelegate;
}
namespace Teamcenter
{
    class CFMOverrideEntryDispatch;
}
namespace Teamcenter
{
    class CFMOverrideEntryGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFM_API  Teamcenter::CFMOverrideEntry
     : public  ::Teamcenter::CFMRuleEntry
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CFMOverrideEntry();

    /**
     * Destructor
     */
    virtual ~CFMOverrideEntry();

private:
    //  Getter method for the Implementation Object
    CFMOverrideEntryImpl*  getCFMOverrideEntryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCFMOverrideEntryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CFMOverrideEntryImpl*  m_cfmoverrideentryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CFMOverrideEntry - desc for CFMOverrideEntry parameter
     */
    CFMOverrideEntry( const CFMOverrideEntry& );
    CFMOverrideEntry& operator=( const CFMOverrideEntry& );

    friend class  CFMOverrideEntryDelegate;
    friend class  CFMOverrideEntryDispatch;
    friend class  CFMOverrideEntryGenImpl;
};

#include <cfm/libcfm_undef.h>
#endif //   TEAMCENTER__CFMOVERRIDEENTRY__HXX
