//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CFMOverrideEntryDelegate
    Filename:   CFMOverrideEntryDelegate.hxx
    Module:     cfm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFMOVERRIDEENTRYDELEGATE_HXX
#define TEAMCENTER__CFMOVERRIDEENTRYDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cfm/CFMOverrideEntry.hxx>

#include <cfm/libcfm_exports.h>

namespace Teamcenter
{
    class CFMOverrideEntryDelegate;
}
namespace Teamcenter
{
    class CFMOverrideEntryImpl;
}
namespace Teamcenter
{
    class CFMOverrideEntry;
}
namespace Teamcenter
{
    class CFMOverrideEntryGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CFM_API Teamcenter_alias::CFMOverrideEntryDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CFMOverrideEntryDelegate instance
    static CFMOverrideEntryDelegate&  getInstance();

    //  Method to create the CFMOverrideEntryImpl pointer
    static CFMOverrideEntryImpl*  createImpl( CFMOverrideEntry&  ifObj );

    //  Method to delete the CFMOverrideEntryImpl pointer
    static void deleteImpl( CFMOverrideEntryImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @param isLockForDelete - A boolean to indicate if object(s) are to be locked for deletion
    /// @param allowRelock - A boolean to indicate if object(s) can be relocked, which will discard all unsaved changes, if already locked by the same user
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0LockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd, const bool isLockForDelete, const bool allowRelock );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0RefreshBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0UnlockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static CFMOverrideEntryDelegate*  m_pInstance;

    CFMOverrideEntryDelegate();
    virtual ~CFMOverrideEntryDelegate();
    static void setInstance( CFMOverrideEntryDelegate*  instance );


private:
    friend class  ::Teamcenter::CFMOverrideEntryGenImpl;

};

#include <cfm/libcfm_undef.h>
#endif  //  TEAMCENTER__CFMOVERRIDEENTRYDELEGATE_HXX
