//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CFMPreciseEntry
    Filename:   CFMPreciseEntry.hxx
    Module:     cfm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFMPRECISEENTRY__HXX
#define TEAMCENTER__CFMPRECISEENTRY__HXX

#include <common/tc_deprecation_macros.h>
#include <cfm/CFMRuleEntry.hxx>

#include <cfm/libcfm_exports.h>

namespace Teamcenter
{
    class CFMPreciseEntry;
}
namespace Teamcenter
{
    class CFMPreciseEntryImpl;
}
namespace Teamcenter
{
    class CFMPreciseEntryDelegate;
}
namespace Teamcenter
{
    class CFMPreciseEntryDispatch;
}
namespace Teamcenter
{
    class CFMPreciseEntryGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFM_API  Teamcenter::CFMPreciseEntry
     : public  ::Teamcenter::CFMRuleEntry
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CFMPreciseEntry();

    /**
     * Destructor
     */
    virtual ~CFMPreciseEntry();

private:
    //  Getter method for the Implementation Object
    CFMPreciseEntryImpl*  getCFMPreciseEntryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCFMPreciseEntryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CFMPreciseEntryImpl*  m_cfmpreciseentryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CFMPreciseEntry - desc for CFMPreciseEntry parameter
     */
    CFMPreciseEntry( const CFMPreciseEntry& );
    CFMPreciseEntry& operator=( const CFMPreciseEntry& );

    friend class  CFMPreciseEntryDelegate;
    friend class  CFMPreciseEntryDispatch;
    friend class  CFMPreciseEntryGenImpl;
};

#include <cfm/libcfm_undef.h>
#endif //   TEAMCENTER__CFMPRECISEENTRY__HXX
