//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CFMRuleEntry
    Filename:   CFMRuleEntry.hxx
    Module:     cfm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFMRULEENTRY__HXX
#define TEAMCENTER__CFMRULEENTRY__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <cfm/libcfm_exports.h>

namespace Teamcenter
{
    class CFMRuleEntry;
}
namespace Teamcenter
{
    class CFMRuleEntryImpl;
}
namespace Teamcenter
{
    class CFMRuleEntryDelegate;
}
namespace Teamcenter
{
    class CFMRuleEntryDispatch;
}
namespace Teamcenter
{
    class CFMRuleEntryGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFM_API  Teamcenter::CFMRuleEntry
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CFMRuleEntry();

    /**
     * Destructor
     */
    virtual ~CFMRuleEntry();

private:
    //  Getter method for the Implementation Object
    CFMRuleEntryImpl*  getCFMRuleEntryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCFMRuleEntryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CFMRuleEntryImpl*  m_cfmruleentryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CFMRuleEntry - desc for CFMRuleEntry parameter
     */
    CFMRuleEntry( const CFMRuleEntry& );
    CFMRuleEntry& operator=( const CFMRuleEntry& );

    friend class  CFMRuleEntryDelegate;
    friend class  CFMRuleEntryDispatch;
    friend class  CFMRuleEntryGenImpl;
};

#include <cfm/libcfm_undef.h>
#endif //   TEAMCENTER__CFMRULEENTRY__HXX
