//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CFMStatusEntry
    Filename:   CFMStatusEntry.hxx
    Module:     cfm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFMSTATUSENTRY__HXX
#define TEAMCENTER__CFMSTATUSENTRY__HXX

#include <common/tc_deprecation_macros.h>
#include <cfm/CFMRuleEntry.hxx>

#include <cfm/libcfm_exports.h>

namespace Teamcenter
{
    class CFMStatusEntry;
}
namespace Teamcenter
{
    class CFMStatusEntryImpl;
}
namespace Teamcenter
{
    class CFMStatusEntryDelegate;
}
namespace Teamcenter
{
    class CFMStatusEntryDispatch;
}
namespace Teamcenter
{
    class CFMStatusEntryGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFM_API  Teamcenter::CFMStatusEntry
     : public  ::Teamcenter::CFMRuleEntry
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CFMStatusEntry();

    /**
     * Destructor
     */
    virtual ~CFMStatusEntry();

private:
    //  Getter method for the Implementation Object
    CFMStatusEntryImpl*  getCFMStatusEntryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCFMStatusEntryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CFMStatusEntryImpl*  m_cfmstatusentryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CFMStatusEntry - desc for CFMStatusEntry parameter
     */
    CFMStatusEntry( const CFMStatusEntry& );
    CFMStatusEntry& operator=( const CFMStatusEntry& );

    friend class  CFMStatusEntryDelegate;
    friend class  CFMStatusEntryDispatch;
    friend class  CFMStatusEntryGenImpl;
};

#include <cfm/libcfm_undef.h>
#endif //   TEAMCENTER__CFMSTATUSENTRY__HXX
