//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CFMUnitNoEntry
    Filename:   CFMUnitNoEntry.hxx
    Module:     cfm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFMUNITNOENTRY__HXX
#define TEAMCENTER__CFMUNITNOENTRY__HXX

#include <common/tc_deprecation_macros.h>
#include <cfm/CFMRuleEntry.hxx>

#include <cfm/libcfm_exports.h>

namespace Teamcenter
{
    class CFMUnitNoEntry;
}
namespace Teamcenter
{
    class CFMUnitNoEntryImpl;
}
namespace Teamcenter
{
    class CFMUnitNoEntryDelegate;
}
namespace Teamcenter
{
    class CFMUnitNoEntryDispatch;
}
namespace Teamcenter
{
    class CFMUnitNoEntryGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFM_API  Teamcenter::CFMUnitNoEntry
     : public  ::Teamcenter::CFMRuleEntry
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CFMUnitNoEntry();

    /**
     * Destructor
     */
    virtual ~CFMUnitNoEntry();

private:
    //  Getter method for the Implementation Object
    CFMUnitNoEntryImpl*  getCFMUnitNoEntryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCFMUnitNoEntryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CFMUnitNoEntryImpl*  m_cfmunitnoentryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CFMUnitNoEntry - desc for CFMUnitNoEntry parameter
     */
    CFMUnitNoEntry( const CFMUnitNoEntry& );
    CFMUnitNoEntry& operator=( const CFMUnitNoEntry& );

    friend class  CFMUnitNoEntryDelegate;
    friend class  CFMUnitNoEntryDispatch;
    friend class  CFMUnitNoEntryGenImpl;
};

#include <cfm/libcfm_undef.h>
#endif //   TEAMCENTER__CFMUNITNOENTRY__HXX
