//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CFMWorkingEntry
    Filename:   CFMWorkingEntry.hxx
    Module:     cfm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFMWORKINGENTRY__HXX
#define TEAMCENTER__CFMWORKINGENTRY__HXX

#include <common/tc_deprecation_macros.h>
#include <cfm/CFMRuleEntry.hxx>

#include <cfm/libcfm_exports.h>

namespace Teamcenter
{
    class CFMWorkingEntry;
}
namespace Teamcenter
{
    class CFMWorkingEntryImpl;
}
namespace Teamcenter
{
    class CFMWorkingEntryDelegate;
}
namespace Teamcenter
{
    class CFMWorkingEntryDispatch;
}
namespace Teamcenter
{
    class CFMWorkingEntryGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFM_API  Teamcenter::CFMWorkingEntry
     : public  ::Teamcenter::CFMRuleEntry
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CFMWorkingEntry();

    /**
     * Destructor
     */
    virtual ~CFMWorkingEntry();

private:
    //  Getter method for the Implementation Object
    CFMWorkingEntryImpl*  getCFMWorkingEntryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCFMWorkingEntryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CFMWorkingEntryImpl*  m_cfmworkingentryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CFMWorkingEntry - desc for CFMWorkingEntry parameter
     */
    CFMWorkingEntry( const CFMWorkingEntry& );
    CFMWorkingEntry& operator=( const CFMWorkingEntry& );

    friend class  CFMWorkingEntryDelegate;
    friend class  CFMWorkingEntryDispatch;
    friend class  CFMWorkingEntryGenImpl;
};

#include <cfm/libcfm_undef.h>
#endif //   TEAMCENTER__CFMWORKINGENTRY__HXX
