//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CFM_date_info
    Filename:   CFM_date_info.hxx
    Module:     cfm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFM_DATE_INFO__HXX
#define TEAMCENTER__CFM_DATE_INFO__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <cfm/libcfm_exports.h>

namespace Teamcenter
{
    class CFM_date_info;
}
namespace Teamcenter
{
    class CFM_date_infoImpl;
}
namespace Teamcenter
{
    class CFM_date_infoDelegate;
}
namespace Teamcenter
{
    class CFM_date_infoDispatch;
}
namespace Teamcenter
{
    class CFM_date_infoGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFM_API  Teamcenter::CFM_date_info
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CFM_date_info();

    /**
     * Destructor
     */
    virtual ~CFM_date_info();

private:
    //  Getter method for the Implementation Object
    CFM_date_infoImpl*  getCFM_date_infoImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCFM_date_infoImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CFM_date_infoImpl*  m_cfm_date_infoImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CFM_date_info - desc for CFM_date_info parameter
     */
    CFM_date_info( const CFM_date_info& );
    CFM_date_info& operator=( const CFM_date_info& );

    friend class  CFM_date_infoDelegate;
    friend class  CFM_date_infoDispatch;
    friend class  CFM_date_infoGenImpl;
};

#include <cfm/libcfm_undef.h>
#endif //   TEAMCENTER__CFM_DATE_INFO__HXX
