//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CFM_date_infoDelegate
    Filename:   CFM_date_infoDelegate.hxx
    Module:     cfm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFM_DATE_INFODELEGATE_HXX
#define TEAMCENTER__CFM_DATE_INFODELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cfm/CFM_date_info.hxx>

#include <cfm/libcfm_exports.h>

namespace Teamcenter
{
    class CFM_date_infoDelegate;
}
namespace Teamcenter
{
    class CFM_date_infoImpl;
}
namespace Teamcenter
{
    class CFM_date_info;
}
namespace Teamcenter
{
    class CFM_date_infoGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CFM_API Teamcenter_alias::CFM_date_infoDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CFM_date_infoDelegate instance
    static CFM_date_infoDelegate&  getInstance();

    //  Method to create the CFM_date_infoImpl pointer
    static CFM_date_infoImpl*  createImpl( CFM_date_info&  ifObj );

    //  Method to delete the CFM_date_infoImpl pointer
    static void deleteImpl( CFM_date_infoImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @param isLockForDelete - A boolean to indicate if object(s) are to be locked for deletion
    /// @param allowRelock - A boolean to indicate if object(s) can be relocked, which will discard all unsaved changes, if already locked by the same user
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0LockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd, const bool isLockForDelete, const bool allowRelock );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0RefreshBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0UnlockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static CFM_date_infoDelegate*  m_pInstance;

    CFM_date_infoDelegate();
    virtual ~CFM_date_infoDelegate();
    static void setInstance( CFM_date_infoDelegate*  instance );


private:
    friend class  ::Teamcenter::CFM_date_infoGenImpl;

};

#include <cfm/libcfm_undef.h>
#endif  //  TEAMCENTER__CFM_DATE_INFODELEGATE_HXX
