//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0AbsBranchRelation
    Filename:   Fnd0AbsBranchRelation.hxx
    Module:     cfm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0ABSBRANCHRELATION__HXX
#define TEAMCENTER__FND0ABSBRANCHRELATION__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <cfm/libcfm_exports.h>

namespace Teamcenter
{
    class Fnd0AbsBranchRelation;
}
namespace Teamcenter
{
    class Fnd0AbsBranchRelationImpl;
}
namespace Teamcenter
{
    class Fnd0AbsBranchRelationDelegate;
}
namespace Teamcenter
{
    class Fnd0AbsBranchRelationDispatch;
}
namespace Teamcenter
{
    class Fnd0AbsBranchRelationGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFM_API  Teamcenter::Fnd0AbsBranchRelation
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Setter for a Date Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0EndDate( const date_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0AbsBranchRelation();

    /**
     * Destructor
     */
    virtual ~Fnd0AbsBranchRelation();

private:
    //  Getter method for the Implementation Object
    Fnd0AbsBranchRelationImpl*  getFnd0AbsBranchRelationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0AbsBranchRelationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0AbsBranchRelationImpl*  m_fnd0absbranchrelationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0AbsBranchRelation - desc for Fnd0AbsBranchRelation parameter
     */
    Fnd0AbsBranchRelation( const Fnd0AbsBranchRelation& );
    Fnd0AbsBranchRelation& operator=( const Fnd0AbsBranchRelation& );

    friend class  Fnd0AbsBranchRelationDelegate;
    friend class  Fnd0AbsBranchRelationDispatch;
    friend class  Fnd0AbsBranchRelationGenImpl;
};

#include <cfm/libcfm_undef.h>
#endif //   TEAMCENTER__FND0ABSBRANCHRELATION__HXX
