//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0Branch
    Filename:   Fnd0Branch.hxx
    Module:     cfm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0BRANCH__HXX
#define TEAMCENTER__FND0BRANCH__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <cfm/libcfm_exports.h>

namespace Teamcenter
{
    class Fnd0Branch;
}
namespace Teamcenter
{
    class Fnd0BranchImpl;
}
namespace Teamcenter
{
    class Fnd0BranchDelegate;
}
namespace Teamcenter
{
    class Fnd0BranchDispatch;
}
namespace Teamcenter
{
    class Fnd0BranchGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFM_API  Teamcenter::Fnd0Branch
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0Branch();

    /**
     * Destructor
     */
    virtual ~Fnd0Branch();

private:
    //  Getter method for the Implementation Object
    Fnd0BranchImpl*  getFnd0BranchImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0BranchImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0BranchImpl*  m_fnd0branchImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0Branch - desc for Fnd0Branch parameter
     */
    Fnd0Branch( const Fnd0Branch& );
    Fnd0Branch& operator=( const Fnd0Branch& );

    friend class  Fnd0BranchDelegate;
    friend class  Fnd0BranchDispatch;
    friend class  Fnd0BranchGenImpl;
};

#include <cfm/libcfm_undef.h>
#endif //   TEAMCENTER__FND0BRANCH__HXX
