//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0BranchContent
    Filename:   Fnd0BranchContent.hxx
    Module:     cfm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0BRANCHCONTENT__HXX
#define TEAMCENTER__FND0BRANCHCONTENT__HXX

#include <common/tc_deprecation_macros.h>
#include <cfm/Fnd0AbsBranchRelation.hxx>

#include <cfm/libcfm_exports.h>

namespace Teamcenter
{
    class Fnd0BranchContent;
}
namespace Teamcenter
{
    class Fnd0BranchContentImpl;
}
namespace Teamcenter
{
    class Fnd0BranchContentDelegate;
}
namespace Teamcenter
{
    class Fnd0BranchContentDispatch;
}
namespace Teamcenter
{
    class Fnd0BranchContentGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFM_API  Teamcenter::Fnd0BranchContent
     : public  ::Teamcenter::Fnd0AbsBranchRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0BranchContent();

    /**
     * Destructor
     */
    virtual ~Fnd0BranchContent();

private:
    //  Getter method for the Implementation Object
    Fnd0BranchContentImpl*  getFnd0BranchContentImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0BranchContentImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0BranchContentImpl*  m_fnd0branchcontentImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0BranchContent - desc for Fnd0BranchContent parameter
     */
    Fnd0BranchContent( const Fnd0BranchContent& );
    Fnd0BranchContent& operator=( const Fnd0BranchContent& );

    friend class  Fnd0BranchContentDelegate;
    friend class  Fnd0BranchContentDispatch;
    friend class  Fnd0BranchContentGenImpl;
};

#include <cfm/libcfm_undef.h>
#endif //   TEAMCENTER__FND0BRANCHCONTENT__HXX
