//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0CFMBranchEntry
    Filename:   Fnd0CFMBranchEntry.hxx
    Module:     cfm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0CFMBRANCHENTRY__HXX
#define TEAMCENTER__FND0CFMBRANCHENTRY__HXX

#include <common/tc_deprecation_macros.h>
#include <cfm/CFMRuleEntry.hxx>

#include <cfm/libcfm_exports.h>

namespace Teamcenter
{
    class Fnd0CFMBranchEntry;
}
namespace Teamcenter
{
    class Fnd0CFMBranchEntryImpl;
}
namespace Teamcenter
{
    class Fnd0CFMBranchEntryDelegate;
}
namespace Teamcenter
{
    class Fnd0CFMBranchEntryDispatch;
}
namespace Teamcenter
{
    class Fnd0CFMBranchEntryGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFM_API  Teamcenter::Fnd0CFMBranchEntry
     : public  ::Teamcenter::CFMRuleEntry
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0CFMBranchEntry();

    /**
     * Destructor
     */
    virtual ~Fnd0CFMBranchEntry();

private:
    //  Getter method for the Implementation Object
    Fnd0CFMBranchEntryImpl*  getFnd0CFMBranchEntryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0CFMBranchEntryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0CFMBranchEntryImpl*  m_fnd0cfmbranchentryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0CFMBranchEntry - desc for Fnd0CFMBranchEntry parameter
     */
    Fnd0CFMBranchEntry( const Fnd0CFMBranchEntry& );
    Fnd0CFMBranchEntry& operator=( const Fnd0CFMBranchEntry& );

    friend class  Fnd0CFMBranchEntryDelegate;
    friend class  Fnd0CFMBranchEntryDispatch;
    friend class  Fnd0CFMBranchEntryGenImpl;
};

#include <cfm/libcfm_undef.h>
#endif //   TEAMCENTER__FND0CFMBRANCHENTRY__HXX
