//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0Cparam
    Filename:   Fnd0Cparam.hxx
    Module:     cfm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0CPARAM__HXX
#define TEAMCENTER__FND0CPARAM__HXX

#include <unidefs.h>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <cfm/libcfm_exports.h>

namespace Teamcenter
{
    class Fnd0Cparam;
}
namespace Teamcenter
{
    class Fnd0CparamImpl;
}
namespace Teamcenter
{
    class Fnd0CparamDelegate;
}
namespace Teamcenter
{
    class Fnd0CparamDispatch;
}
namespace Teamcenter
{
    class Fnd0CparamGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFM_API  Teamcenter::Fnd0Cparam
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ReusableCparam( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0Scopes( std::vector< std::string > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0Cparam();

    /**
     * Destructor
     */
    virtual ~Fnd0Cparam();

private:
    //  Getter method for the Implementation Object
    Fnd0CparamImpl*  getFnd0CparamImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0CparamImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0CparamImpl*  m_fnd0cparamImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0Cparam - desc for Fnd0Cparam parameter
     */
    Fnd0Cparam( const Fnd0Cparam& );
    Fnd0Cparam& operator=( const Fnd0Cparam& );

    friend class  Fnd0CparamDelegate;
    friend class  Fnd0CparamDispatch;
    friend class  Fnd0CparamGenImpl;
};

#include <cfm/libcfm_undef.h>
#endif //   TEAMCENTER__FND0CPARAM__HXX
