//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0CparamDelegate
    Filename:   Fnd0CparamDelegate.hxx
    Module:     cfm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0CPARAMDELEGATE_HXX
#define TEAMCENTER__FND0CPARAMDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cfm/Fnd0Cparam.hxx>

#include <cfm/libcfm_exports.h>

namespace Teamcenter
{
    class Fnd0CparamDelegate;
}
namespace Teamcenter
{
    class Fnd0CparamImpl;
}
namespace Teamcenter
{
    class Fnd0Cparam;
}
namespace Teamcenter
{
    class Fnd0CparamGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CFM_API Teamcenter_alias::Fnd0CparamDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0CparamDelegate instance
    static Fnd0CparamDelegate&  getInstance();

    //  Method to create the Fnd0CparamImpl pointer
    static Fnd0CparamImpl*  createImpl( Fnd0Cparam&  ifObj );

    //  Method to delete the Fnd0CparamImpl pointer
    static void deleteImpl( Fnd0CparamImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ReusableCparamBase(const Fnd0Cparam &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ScopesBase(const Fnd0Cparam &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const Fnd0Cparam &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Fnd0Cparam &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Fnd0CparamDelegate*  m_pInstance;

    Fnd0CparamDelegate();
    virtual ~Fnd0CparamDelegate();
    static void setInstance( Fnd0CparamDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0CparamGenImpl;

};

#include <cfm/libcfm_undef.h>
#endif  //  TEAMCENTER__FND0CPARAMDELEGATE_HXX
