//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0RecipeContainer
    Filename:   Fnd0RecipeContainer.hxx
    Module:     cfm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0RECIPECONTAINER__HXX
#define TEAMCENTER__FND0RECIPECONTAINER__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <cfm/libcfm_exports.h>

namespace Teamcenter
{
    class Fnd0RecipeContainer;
}
namespace Teamcenter
{
    class Fnd0RecipeContainerImpl;
}
namespace Teamcenter
{
    class Fnd0RecipeContainerDelegate;
}
namespace Teamcenter
{
    class Fnd0RecipeContainerDispatch;
}
namespace Teamcenter
{
    class Fnd0RecipeContainerGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFM_API  Teamcenter::Fnd0RecipeContainer
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0configuration_context( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0search_recipe( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0configuration_context( const tag_t &value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0search_recipe( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0RecipeContainer();

    /**
     * Destructor
     */
    virtual ~Fnd0RecipeContainer();

private:
    //  Getter method for the Implementation Object
    Fnd0RecipeContainerImpl*  getFnd0RecipeContainerImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0RecipeContainerImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0RecipeContainerImpl*  m_fnd0recipecontainerImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0RecipeContainer - desc for Fnd0RecipeContainer parameter
     */
    Fnd0RecipeContainer( const Fnd0RecipeContainer& );
    Fnd0RecipeContainer& operator=( const Fnd0RecipeContainer& );

    friend class  Fnd0RecipeContainerDelegate;
    friend class  Fnd0RecipeContainerDispatch;
    friend class  Fnd0RecipeContainerGenImpl;
};

#include <cfm/libcfm_undef.h>
#endif //   TEAMCENTER__FND0RECIPECONTAINER__HXX
