//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0RecipeContainerDelegate
    Filename:   Fnd0RecipeContainerDelegate.hxx
    Module:     cfm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0RECIPECONTAINERDELEGATE_HXX
#define TEAMCENTER__FND0RECIPECONTAINERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cfm/Fnd0RecipeContainer.hxx>

#include <cfm/libcfm_exports.h>

namespace Teamcenter
{
    class Fnd0RecipeContainerDelegate;
}
namespace Teamcenter
{
    class Fnd0RecipeContainerImpl;
}
namespace Teamcenter
{
    class Fnd0RecipeContainer;
}
namespace Teamcenter
{
    class Fnd0RecipeContainerGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CFM_API Teamcenter_alias::Fnd0RecipeContainerDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0RecipeContainerDelegate instance
    static Fnd0RecipeContainerDelegate&  getInstance();

    //  Method to create the Fnd0RecipeContainerImpl pointer
    static Fnd0RecipeContainerImpl*  createImpl( Fnd0RecipeContainer&  ifObj );

    //  Method to delete the Fnd0RecipeContainerImpl pointer
    static void deleteImpl( Fnd0RecipeContainerImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0configuration_contextBase(const Fnd0RecipeContainer &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0search_recipeBase(const Fnd0RecipeContainer &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0configuration_contextBase(Fnd0RecipeContainer &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0search_recipeBase(Fnd0RecipeContainer &ifObj,  const tag_t &value, bool isNull );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @param isLockForDelete - A boolean to indicate if object(s) are to be locked for deletion
    /// @param allowRelock - A boolean to indicate if object(s) can be relocked, which will discard all unsaved changes, if already locked by the same user
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0LockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd, const bool isLockForDelete, const bool allowRelock );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0RefreshBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0UnlockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// Generic saveAsPost operation.
    /// @version Teamcenter 8.1
    /// @param pSavAsInput - Input argument as SaveAsInput object.
    /// @param vecDeepCopyData - vector deepcopy data
    /// @return - Return integer value.
    ///
    int  saveAsPostBase(const Fnd0RecipeContainer &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static Fnd0RecipeContainerDelegate*  m_pInstance;

    Fnd0RecipeContainerDelegate();
    virtual ~Fnd0RecipeContainerDelegate();
    static void setInstance( Fnd0RecipeContainerDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0RecipeContainerGenImpl;

};

#include <cfm/libcfm_undef.h>
#endif  //  TEAMCENTER__FND0RECIPECONTAINERDELEGATE_HXX
