//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Intent
    Filename:   Intent.hxx
    Module:     cfm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__INTENT__HXX
#define TEAMCENTER__INTENT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <cfm/libcfm_exports.h>

namespace Teamcenter
{
    class Intent;
}
namespace Teamcenter
{
    class IntentImpl;
}
namespace Teamcenter
{
    class IntentDelegate;
}
namespace Teamcenter
{
    class IntentDispatch;
}
namespace Teamcenter
{
    class IntentGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFM_API  Teamcenter::Intent
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Intent();

    /**
     * Destructor
     */
    virtual ~Intent();

private:
    //  Getter method for the Implementation Object
    IntentImpl*  getIntentImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setIntentImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    IntentImpl*  m_intentImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Intent - desc for Intent parameter
     */
    Intent( const Intent& );
    Intent& operator=( const Intent& );

    friend class  IntentDelegate;
    friend class  IntentDispatch;
    friend class  IntentGenImpl;
};

#include <cfm/libcfm_undef.h>
#endif //   TEAMCENTER__INTENT__HXX
