//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RevisionRule
    Filename:   RevisionRule.hxx
    Module:     cfm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REVISIONRULE__HXX
#define TEAMCENTER__REVISIONRULE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <cfm/libcfm_exports.h>

namespace Teamcenter
{
    class RevisionRule;
}
namespace Teamcenter
{
    class RevisionRuleImpl;
}
namespace Teamcenter
{
    class RevisionRuleDelegate;
}
namespace Teamcenter
{
    class RevisionRuleDispatch;
}
namespace Teamcenter
{
    class RevisionRuleGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CFM_API  Teamcenter::RevisionRule
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    RevisionRule();

    /**
     * Destructor
     */
    virtual ~RevisionRule();

private:
    //  Getter method for the Implementation Object
    RevisionRuleImpl*  getRevisionRuleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRevisionRuleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    RevisionRuleImpl*  m_revisionruleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param RevisionRule - desc for RevisionRule parameter
     */
    RevisionRule( const RevisionRule& );
    RevisionRule& operator=( const RevisionRule& );

    friend class  RevisionRuleDelegate;
    friend class  RevisionRuleDispatch;
    friend class  RevisionRuleGenImpl;
};

#include <cfm/libcfm_undef.h>
#endif //   TEAMCENTER__REVISIONRULE__HXX
