//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RevisionRuleDelegate
    Filename:   RevisionRuleDelegate.hxx
    Module:     cfm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REVISIONRULEDELEGATE_HXX
#define TEAMCENTER__REVISIONRULEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cfm/RevisionRule.hxx>

#include <cfm/libcfm_exports.h>

namespace Teamcenter
{
    class RevisionRuleDelegate;
}
namespace Teamcenter
{
    class RevisionRuleImpl;
}
namespace Teamcenter
{
    class RevisionRule;
}
namespace Teamcenter
{
    class RevisionRuleGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CFM_API Teamcenter_alias::RevisionRuleDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the RevisionRuleDelegate instance
    static RevisionRuleDelegate&  getInstance();

    //  Method to create the RevisionRuleImpl pointer
    static RevisionRuleImpl*  createImpl( RevisionRule&  ifObj );

    //  Method to delete the RevisionRuleImpl pointer
    static void deleteImpl( RevisionRuleImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @param isLockForDelete - A boolean to indicate if object(s) are to be locked for deletion
    /// @param allowRelock - A boolean to indicate if object(s) can be relocked, which will discard all unsaved changes, if already locked by the same user
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0LockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd, const bool isLockForDelete, const bool allowRelock );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0RefreshBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0UnlockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const RevisionRule &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getObject_nameBase(const RevisionRule &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setObject_nameBase(RevisionRule &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static RevisionRuleDelegate*  m_pInstance;

    RevisionRuleDelegate();
    virtual ~RevisionRuleDelegate();
    static void setInstance( RevisionRuleDelegate*  instance );


private:
    friend class  ::Teamcenter::RevisionRuleGenImpl;

};

#include <cfm/libcfm_undef.h>
#endif  //  TEAMCENTER__REVISIONRULEDELEGATE_HXX
