//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  classificationdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libclassificationdispatch

#if !defined(LIBCLASSIFICATIONDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBCLASSIFICATIONDISPATCH is not defined
#endif

/* Handwritten code should use CLASSIFICATIONDISPATCH_API, not CLASSIFICATIONDISPATCHEXPORT */

#define CLASSIFICATIONDISPATCH_API CLASSIFICATIONDISPATCHEXPORT

#if IPLIB==libclassificationdispatch || defined(LIBCLASSIFICATIONDISPATCH)
#   if defined(__lint)
#       define CLASSIFICATIONDISPATCHEXPORT       __export(classificationdispatch)
#       define CLASSIFICATIONDISPATCHGLOBAL       extern __global(classificationdispatch)
#       define CLASSIFICATIONDISPATCHPRIVATE      extern __private(classificationdispatch)
#   elif defined(_WIN32)
#       define CLASSIFICATIONDISPATCHEXPORT       __declspec(dllexport)
#       define CLASSIFICATIONDISPATCHGLOBAL       extern __declspec(dllexport)
#       define CLASSIFICATIONDISPATCHPRIVATE      extern
#   else
#       define CLASSIFICATIONDISPATCHEXPORT
#       define CLASSIFICATIONDISPATCHGLOBAL       extern
#       define CLASSIFICATIONDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CLASSIFICATIONDISPATCHEXPORT       __export(classificationdispatch)
#       define CLASSIFICATIONDISPATCHGLOBAL       extern __global(classificationdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CLASSIFICATIONDISPATCHEXPORT      __declspec(dllimport)
#       define CLASSIFICATIONDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define CLASSIFICATIONDISPATCHEXPORT
#       define CLASSIFICATIONDISPATCHGLOBAL       extern
#   endif
#endif
