//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  clr1colorruledispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libclr1colorruledispatch

#if !defined(LIBCLR1COLORRULEDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBCLR1COLORRULEDISPATCH is not defined
#endif

/* Handwritten code should use CLR1COLORRULEDISPATCH_API, not CLR1COLORRULEDISPATCHEXPORT */

#define CLR1COLORRULEDISPATCH_API CLR1COLORRULEDISPATCHEXPORT

#if IPLIB==libclr1colorruledispatch || defined(LIBCLR1COLORRULEDISPATCH)
#   if defined(__lint)
#       define CLR1COLORRULEDISPATCHEXPORT       __export(clr1colorruledispatch)
#       define CLR1COLORRULEDISPATCHGLOBAL       extern __global(clr1colorruledispatch)
#       define CLR1COLORRULEDISPATCHPRIVATE      extern __private(clr1colorruledispatch)
#   elif defined(_WIN32)
#       define CLR1COLORRULEDISPATCHEXPORT       __declspec(dllexport)
#       define CLR1COLORRULEDISPATCHGLOBAL       extern __declspec(dllexport)
#       define CLR1COLORRULEDISPATCHPRIVATE      extern
#   else
#       define CLR1COLORRULEDISPATCHEXPORT
#       define CLR1COLORRULEDISPATCHGLOBAL       extern
#       define CLR1COLORRULEDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CLR1COLORRULEDISPATCHEXPORT       __export(clr1colorruledispatch)
#       define CLR1COLORRULEDISPATCHGLOBAL       extern __global(clr1colorruledispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CLR1COLORRULEDISPATCHEXPORT      __declspec(dllimport)
#       define CLR1COLORRULEDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define CLR1COLORRULEDISPATCHEXPORT
#       define CLR1COLORRULEDISPATCHGLOBAL       extern
#   endif
#endif
