//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Analyst
    Filename:   Analyst.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ANALYST__HXX
#define TEAMCENTER__ANALYST__HXX

#include <common/tc_deprecation_macros.h>
#include <epm/Participant.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class Analyst;
}
namespace Teamcenter
{
    class AnalystImpl;
}
namespace Teamcenter
{
    class AnalystDelegate;
}
namespace Teamcenter
{
    class AnalystDispatch;
}
namespace Teamcenter
{
    class AnalystGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CM_API  Teamcenter::Analyst
     : public  ::Teamcenter::Participant
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Analyst();

    /**
     * Destructor
     */
    virtual ~Analyst();

private:
    //  Getter method for the Implementation Object
    AnalystImpl*  getAnalystImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAnalystImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AnalystImpl*  m_analystImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Analyst - desc for Analyst parameter
     */
    Analyst( const Analyst& );
    Analyst& operator=( const Analyst& );

    friend class  AnalystDelegate;
    friend class  AnalystDispatch;
    friend class  AnalystGenImpl;
};

#include <cm/libcm_undef.h>
#endif //   TEAMCENTER__ANALYST__HXX
