//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AnalystDelegate
    Filename:   AnalystDelegate.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ANALYSTDELEGATE_HXX
#define TEAMCENTER__ANALYSTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cm/Analyst.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class AnalystDelegate;
}
namespace Teamcenter
{
    class AnalystImpl;
}
namespace Teamcenter
{
    class Analyst;
}
namespace Teamcenter
{
    class AnalystGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CM_API Teamcenter_alias::AnalystDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the AnalystDelegate instance
    static AnalystDelegate&  getInstance();

    //  Method to create the AnalystImpl pointer
    static AnalystImpl*  createImpl( Analyst&  ifObj );

    //  Method to delete the AnalystImpl pointer
    static void deleteImpl( AnalystImpl*  impl );


    ///
    /// This operation determines if the participant is assignable.
    /// @version Tc 8
    /// @param user - A user tag
    /// @param object - An object tag
    /// @param assignable - A pointer to a boolean whose value, when returned, is the result of the evaluation
    /// @return - An ifail integer
    ///
    int  isAssignableBase(const Analyst &ifObj,  tag_t user, tag_t object, bool *assignable );



protected:
    //  Pointer to the instance
    static AnalystDelegate*  m_pInstance;

    AnalystDelegate();
    virtual ~AnalystDelegate();
    static void setInstance( AnalystDelegate*  instance );


private:
    friend class  ::Teamcenter::AnalystGenImpl;

};

#include <cm/libcm_undef.h>
#endif  //  TEAMCENTER__ANALYSTDELEGATE_HXX
