//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BOMEditDelegate
    Filename:   BOMEditDelegate.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOMEDITDELEGATE_HXX
#define TEAMCENTER__BOMEDITDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cm/BOMEdit.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class BOMEditDelegate;
}
namespace Teamcenter
{
    class BOMEditImpl;
}
namespace Teamcenter
{
    class BOMEdit;
}
namespace Teamcenter
{
    class BOMEditGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CM_API Teamcenter_alias::BOMEditDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the BOMEditDelegate instance
    static BOMEditDelegate&  getInstance();

    //  Method to create the BOMEditImpl pointer
    static BOMEditImpl*  createImpl( BOMEdit&  ifObj );

    //  Method to delete the BOMEditImpl pointer
    static void deleteImpl( BOMEditImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCMCustomObjTagBase(const BOMEdit &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCMOccurenceTagBase(const BOMEdit &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCMCustomObjTagBase(BOMEdit &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCMOccurenceTagBase(BOMEdit &ifObj,  const tag_t &value, bool isNull );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static BOMEditDelegate*  m_pInstance;

    BOMEditDelegate();
    virtual ~BOMEditDelegate();
    static void setInstance( BOMEditDelegate*  instance );


private:
    friend class  ::Teamcenter::BOMEditGenImpl;

};

#include <cm/libcm_undef.h>
#endif  //  TEAMCENTER__BOMEDITDELEGATE_HXX
