//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BOMSupersedure
    Filename:   BOMSupersedure.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOMSUPERSEDURE__HXX
#define TEAMCENTER__BOMSUPERSEDURE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class BOMSupersedure;
}
namespace Teamcenter
{
    class BOMSupersedureImpl;
}
namespace Teamcenter
{
    class BOMSupersedureDelegate;
}
namespace Teamcenter
{
    class BOMSupersedureDispatch;
}
namespace Teamcenter
{
    class BOMSupersedureGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CM_API  Teamcenter::BOMSupersedure
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    BOMSupersedure();

    /**
     * Destructor
     */
    virtual ~BOMSupersedure();

private:
    //  Getter method for the Implementation Object
    BOMSupersedureImpl*  getBOMSupersedureImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBOMSupersedureImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    BOMSupersedureImpl*  m_bomsupersedureImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param BOMSupersedure - desc for BOMSupersedure parameter
     */
    BOMSupersedure( const BOMSupersedure& );
    BOMSupersedure& operator=( const BOMSupersedure& );

    friend class  BOMSupersedureDelegate;
    friend class  BOMSupersedureDispatch;
    friend class  BOMSupersedureGenImpl;
};

#include <cm/libcm_undef.h>
#endif //   TEAMCENTER__BOMSUPERSEDURE__HXX
