//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BOMSupersedureDelegate
    Filename:   BOMSupersedureDelegate.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOMSUPERSEDUREDELEGATE_HXX
#define TEAMCENTER__BOMSUPERSEDUREDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cm/BOMSupersedure.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class BOMSupersedureDelegate;
}
namespace Teamcenter
{
    class BOMSupersedureImpl;
}
namespace Teamcenter
{
    class BOMSupersedure;
}
namespace Teamcenter
{
    class BOMSupersedureGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CM_API Teamcenter_alias::BOMSupersedureDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the BOMSupersedureDelegate instance
    static BOMSupersedureDelegate&  getInstance();

    //  Method to create the BOMSupersedureImpl pointer
    static BOMSupersedureImpl*  createImpl( BOMSupersedure&  ifObj );

    //  Method to delete the BOMSupersedureImpl pointer
    static void deleteImpl( BOMSupersedureImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static BOMSupersedureDelegate*  m_pInstance;

    BOMSupersedureDelegate();
    virtual ~BOMSupersedureDelegate();
    static void setInstance( BOMSupersedureDelegate*  instance );


private:
    friend class  ::Teamcenter::BOMSupersedureGenImpl;

};

#include <cm/libcm_undef.h>
#endif  //  TEAMCENTER__BOMSUPERSEDUREDELEGATE_HXX
