//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CMHasImpactedItem
    Filename:   CMHasImpactedItem.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CMHASIMPACTEDITEM__HXX
#define TEAMCENTER__CMHASIMPACTEDITEM__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <cm/CMRelation.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class CMHasImpactedItem;
}
namespace Teamcenter
{
    class CMHasImpactedItemImpl;
}
namespace Teamcenter
{
    class CMHasImpactedItemDelegate;
}
namespace Teamcenter
{
    class CMHasImpactedItemDispatch;
}
namespace Teamcenter
{
    class CMHasImpactedItemGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CM_API  Teamcenter::CMHasImpactedItem
     : public  ::Teamcenter::CMRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCm0IncorporationStatus( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CMHasImpactedItem();

    /**
     * Destructor
     */
    virtual ~CMHasImpactedItem();

private:
    //  Getter method for the Implementation Object
    CMHasImpactedItemImpl*  getCMHasImpactedItemImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCMHasImpactedItemImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CMHasImpactedItemImpl*  m_cmhasimpacteditemImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CMHasImpactedItem - desc for CMHasImpactedItem parameter
     */
    CMHasImpactedItem( const CMHasImpactedItem& );
    CMHasImpactedItem& operator=( const CMHasImpactedItem& );

    friend class  CMHasImpactedItemDelegate;
    friend class  CMHasImpactedItemDispatch;
    friend class  CMHasImpactedItemGenImpl;
};

#include <cm/libcm_undef.h>
#endif //   TEAMCENTER__CMHASIMPACTEDITEM__HXX
