//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CMHasProblemItem
    Filename:   CMHasProblemItem.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CMHASPROBLEMITEM__HXX
#define TEAMCENTER__CMHASPROBLEMITEM__HXX

#include <common/tc_deprecation_macros.h>
#include <cm/CMRelation.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class CMHasProblemItem;
}
namespace Teamcenter
{
    class CMHasProblemItemImpl;
}
namespace Teamcenter
{
    class CMHasProblemItemDelegate;
}
namespace Teamcenter
{
    class CMHasProblemItemDispatch;
}
namespace Teamcenter
{
    class CMHasProblemItemGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CM_API  Teamcenter::CMHasProblemItem
     : public  ::Teamcenter::CMRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CMHasProblemItem();

    /**
     * Destructor
     */
    virtual ~CMHasProblemItem();

private:
    //  Getter method for the Implementation Object
    CMHasProblemItemImpl*  getCMHasProblemItemImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCMHasProblemItemImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CMHasProblemItemImpl*  m_cmhasproblemitemImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CMHasProblemItem - desc for CMHasProblemItem parameter
     */
    CMHasProblemItem( const CMHasProblemItem& );
    CMHasProblemItem& operator=( const CMHasProblemItem& );

    friend class  CMHasProblemItemDelegate;
    friend class  CMHasProblemItemDispatch;
    friend class  CMHasProblemItemGenImpl;
};

#include <cm/libcm_undef.h>
#endif //   TEAMCENTER__CMHASPROBLEMITEM__HXX
