//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CMHasSolutionItem
    Filename:   CMHasSolutionItem.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CMHASSOLUTIONITEM__HXX
#define TEAMCENTER__CMHASSOLUTIONITEM__HXX

#include <common/tc_deprecation_macros.h>
#include <cm/CMRelation.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class CMHasSolutionItem;
}
namespace Teamcenter
{
    class CMHasSolutionItemImpl;
}
namespace Teamcenter
{
    class CMHasSolutionItemDelegate;
}
namespace Teamcenter
{
    class CMHasSolutionItemDispatch;
}
namespace Teamcenter
{
    class CMHasSolutionItemGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CM_API  Teamcenter::CMHasSolutionItem
     : public  ::Teamcenter::CMRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CMHasSolutionItem();

    /**
     * Destructor
     */
    virtual ~CMHasSolutionItem();

private:
    //  Getter method for the Implementation Object
    CMHasSolutionItemImpl*  getCMHasSolutionItemImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCMHasSolutionItemImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CMHasSolutionItemImpl*  m_cmhassolutionitemImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CMHasSolutionItem - desc for CMHasSolutionItem parameter
     */
    CMHasSolutionItem( const CMHasSolutionItem& );
    CMHasSolutionItem& operator=( const CMHasSolutionItem& );

    friend class  CMHasSolutionItemDelegate;
    friend class  CMHasSolutionItemDispatch;
    friend class  CMHasSolutionItemGenImpl;
};

#include <cm/libcm_undef.h>
#endif //   TEAMCENTER__CMHASSOLUTIONITEM__HXX
