//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CMHasWorkBreakdown
    Filename:   CMHasWorkBreakdown.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CMHASWORKBREAKDOWN__HXX
#define TEAMCENTER__CMHASWORKBREAKDOWN__HXX

#include <common/tc_deprecation_macros.h>
#include <cm/CMRelation.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class CMHasWorkBreakdown;
}
namespace Teamcenter
{
    class CMHasWorkBreakdownImpl;
}
namespace Teamcenter
{
    class CMHasWorkBreakdownDelegate;
}
namespace Teamcenter
{
    class CMHasWorkBreakdownDispatch;
}
namespace Teamcenter
{
    class CMHasWorkBreakdownGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CM_API  Teamcenter::CMHasWorkBreakdown
     : public  ::Teamcenter::CMRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CMHasWorkBreakdown();

    /**
     * Destructor
     */
    virtual ~CMHasWorkBreakdown();

private:
    //  Getter method for the Implementation Object
    CMHasWorkBreakdownImpl*  getCMHasWorkBreakdownImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCMHasWorkBreakdownImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CMHasWorkBreakdownImpl*  m_cmhasworkbreakdownImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CMHasWorkBreakdown - desc for CMHasWorkBreakdown parameter
     */
    CMHasWorkBreakdown( const CMHasWorkBreakdown& );
    CMHasWorkBreakdown& operator=( const CMHasWorkBreakdown& );

    friend class  CMHasWorkBreakdownDelegate;
    friend class  CMHasWorkBreakdownDispatch;
    friend class  CMHasWorkBreakdownGenImpl;
};

#include <cm/libcm_undef.h>
#endif //   TEAMCENTER__CMHASWORKBREAKDOWN__HXX
