//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CMImplements
    Filename:   CMImplements.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CMIMPLEMENTS__HXX
#define TEAMCENTER__CMIMPLEMENTS__HXX

#include <common/tc_deprecation_macros.h>
#include <cm/CMRelation.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class CMImplements;
}
namespace Teamcenter
{
    class CMImplementsImpl;
}
namespace Teamcenter
{
    class CMImplementsDelegate;
}
namespace Teamcenter
{
    class CMImplementsDispatch;
}
namespace Teamcenter
{
    class CMImplementsGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CM_API  Teamcenter::CMImplements
     : public  ::Teamcenter::CMRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CMImplements();

    /**
     * Destructor
     */
    virtual ~CMImplements();

private:
    //  Getter method for the Implementation Object
    CMImplementsImpl*  getCMImplementsImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCMImplementsImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CMImplementsImpl*  m_cmimplementsImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CMImplements - desc for CMImplements parameter
     */
    CMImplements( const CMImplements& );
    CMImplements& operator=( const CMImplements& );

    friend class  CMImplementsDelegate;
    friend class  CMImplementsDispatch;
    friend class  CMImplementsGenImpl;
};

#include <cm/libcm_undef.h>
#endif //   TEAMCENTER__CMIMPLEMENTS__HXX
