//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CMImplementsDelegate
    Filename:   CMImplementsDelegate.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CMIMPLEMENTSDELEGATE_HXX
#define TEAMCENTER__CMIMPLEMENTSDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cm/CMImplements.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class CMImplementsDelegate;
}
namespace Teamcenter
{
    class CMImplementsImpl;
}
namespace Teamcenter
{
    class CMImplements;
}
namespace Teamcenter
{
    class CMImplementsGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CM_API Teamcenter_alias::CMImplementsDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CMImplementsDelegate instance
    static CMImplementsDelegate&  getInstance();

    //  Method to create the CMImplementsImpl pointer
    static CMImplementsImpl*  createImpl( CMImplements&  ifObj );

    //  Method to delete the CMImplementsImpl pointer
    static void deleteImpl( CMImplementsImpl*  impl );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const CMImplements &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static CMImplementsDelegate*  m_pInstance;

    CMImplementsDelegate();
    virtual ~CMImplementsDelegate();
    static void setInstance( CMImplementsDelegate*  instance );


private:
    friend class  ::Teamcenter::CMImplementsGenImpl;

};

#include <cm/libcm_undef.h>
#endif  //  TEAMCENTER__CMIMPLEMENTSDELEGATE_HXX
