//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CMReferences
    Filename:   CMReferences.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CMREFERENCES__HXX
#define TEAMCENTER__CMREFERENCES__HXX

#include <common/tc_deprecation_macros.h>
#include <cm/CMRelation.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class CMReferences;
}
namespace Teamcenter
{
    class CMReferencesImpl;
}
namespace Teamcenter
{
    class CMReferencesDelegate;
}
namespace Teamcenter
{
    class CMReferencesDispatch;
}
namespace Teamcenter
{
    class CMReferencesGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CM_API  Teamcenter::CMReferences
     : public  ::Teamcenter::CMRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CMReferences();

    /**
     * Destructor
     */
    virtual ~CMReferences();

private:
    //  Getter method for the Implementation Object
    CMReferencesImpl*  getCMReferencesImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCMReferencesImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CMReferencesImpl*  m_cmreferencesImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CMReferences - desc for CMReferences parameter
     */
    CMReferences( const CMReferences& );
    CMReferences& operator=( const CMReferences& );

    friend class  CMReferencesDelegate;
    friend class  CMReferencesDispatch;
    friend class  CMReferencesGenImpl;
};

#include <cm/libcm_undef.h>
#endif //   TEAMCENTER__CMREFERENCES__HXX
