//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CMReferencesDelegate
    Filename:   CMReferencesDelegate.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CMREFERENCESDELEGATE_HXX
#define TEAMCENTER__CMREFERENCESDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cm/CMReferences.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class CMReferencesDelegate;
}
namespace Teamcenter
{
    class CMReferencesImpl;
}
namespace Teamcenter
{
    class CMReferences;
}
namespace Teamcenter
{
    class CMReferencesGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CM_API Teamcenter_alias::CMReferencesDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CMReferencesDelegate instance
    static CMReferencesDelegate&  getInstance();

    //  Method to create the CMReferencesImpl pointer
    static CMReferencesImpl*  createImpl( CMReferences&  ifObj );

    //  Method to delete the CMReferencesImpl pointer
    static void deleteImpl( CMReferencesImpl*  impl );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const CMReferences &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static CMReferencesDelegate*  m_pInstance;

    CMReferencesDelegate();
    virtual ~CMReferencesDelegate();
    static void setInstance( CMReferencesDelegate*  instance );


private:
    friend class  ::Teamcenter::CMReferencesGenImpl;

};

#include <cm/libcm_undef.h>
#endif  //  TEAMCENTER__CMREFERENCESDELEGATE_HXX
