//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CMRelation
    Filename:   CMRelation.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CMRELATION__HXX
#define TEAMCENTER__CMRELATION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class CMRelation;
}
namespace Teamcenter
{
    class CMRelationImpl;
}
namespace Teamcenter
{
    class CMRelationDelegate;
}
namespace Teamcenter
{
    class CMRelationDispatch;
}
namespace Teamcenter
{
    class CMRelationGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CM_API  Teamcenter::CMRelation
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CMRelation();

    /**
     * Destructor
     */
    virtual ~CMRelation();

private:
    //  Getter method for the Implementation Object
    CMRelationImpl*  getCMRelationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCMRelationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CMRelationImpl*  m_cmrelationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CMRelation - desc for CMRelation parameter
     */
    CMRelation( const CMRelation& );
    CMRelation& operator=( const CMRelation& );

    friend class  CMRelationDelegate;
    friend class  CMRelationDispatch;
    friend class  CMRelationGenImpl;
};

#include <cm/libcm_undef.h>
#endif //   TEAMCENTER__CMRELATION__HXX
