//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CMRelationDelegate
    Filename:   CMRelationDelegate.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CMRELATIONDELEGATE_HXX
#define TEAMCENTER__CMRELATIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cm/CMRelation.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class CMRelationDelegate;
}
namespace Teamcenter
{
    class CMRelationImpl;
}
namespace Teamcenter
{
    class CMRelation;
}
namespace Teamcenter
{
    class CMRelationGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CM_API Teamcenter_alias::CMRelationDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CMRelationDelegate instance
    static CMRelationDelegate&  getInstance();

    //  Method to create the CMRelationImpl pointer
    static CMRelationImpl*  createImpl( CMRelation&  ifObj );

    //  Method to delete the CMRelationImpl pointer
    static void deleteImpl( CMRelationImpl*  impl );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const CMRelation &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static CMRelationDelegate*  m_pInstance;

    CMRelationDelegate();
    virtual ~CMRelationDelegate();
    static void setInstance( CMRelationDelegate*  instance );


private:
    friend class  ::Teamcenter::CMRelationGenImpl;

};

#include <cm/libcm_undef.h>
#endif  //  TEAMCENTER__CMRELATIONDELEGATE_HXX
