//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CMSolutionToImpacted
    Filename:   CMSolutionToImpacted.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CMSOLUTIONTOIMPACTED__HXX
#define TEAMCENTER__CMSOLUTIONTOIMPACTED__HXX

#include <common/tc_deprecation_macros.h>
#include <cm/CMRelation.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class CMSolutionToImpacted;
}
namespace Teamcenter
{
    class CMSolutionToImpactedImpl;
}
namespace Teamcenter
{
    class CMSolutionToImpactedDelegate;
}
namespace Teamcenter
{
    class CMSolutionToImpactedDispatch;
}
namespace Teamcenter
{
    class CMSolutionToImpactedGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CM_API  Teamcenter::CMSolutionToImpacted
     : public  ::Teamcenter::CMRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CMSolutionToImpacted();

    /**
     * Destructor
     */
    virtual ~CMSolutionToImpacted();

private:
    //  Getter method for the Implementation Object
    CMSolutionToImpactedImpl*  getCMSolutionToImpactedImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCMSolutionToImpactedImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CMSolutionToImpactedImpl*  m_cmsolutiontoimpactedImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CMSolutionToImpacted - desc for CMSolutionToImpacted parameter
     */
    CMSolutionToImpacted( const CMSolutionToImpacted& );
    CMSolutionToImpacted& operator=( const CMSolutionToImpacted& );

    friend class  CMSolutionToImpactedDelegate;
    friend class  CMSolutionToImpactedDispatch;
    friend class  CMSolutionToImpactedGenImpl;
};

#include <cm/libcm_undef.h>
#endif //   TEAMCENTER__CMSOLUTIONTOIMPACTED__HXX
