//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ChangeImplementationBoard
    Filename:   ChangeImplementationBoard.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CHANGEIMPLEMENTATIONBOARD__HXX
#define TEAMCENTER__CHANGEIMPLEMENTATIONBOARD__HXX

#include <common/tc_deprecation_macros.h>
#include <epm/Participant.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class ChangeImplementationBoard;
}
namespace Teamcenter
{
    class ChangeImplementationBoardImpl;
}
namespace Teamcenter
{
    class ChangeImplementationBoardDelegate;
}
namespace Teamcenter
{
    class ChangeImplementationBoardDispatch;
}
namespace Teamcenter
{
    class ChangeImplementationBoardGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CM_API  Teamcenter::ChangeImplementationBoard
     : public  ::Teamcenter::Participant
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ChangeImplementationBoard();

    /**
     * Destructor
     */
    virtual ~ChangeImplementationBoard();

private:
    //  Getter method for the Implementation Object
    ChangeImplementationBoardImpl*  getChangeImplementationBoardImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setChangeImplementationBoardImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ChangeImplementationBoardImpl*  m_changeimplementationboardImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ChangeImplementationBoard - desc for ChangeImplementationBoard parameter
     */
    ChangeImplementationBoard( const ChangeImplementationBoard& );
    ChangeImplementationBoard& operator=( const ChangeImplementationBoard& );

    friend class  ChangeImplementationBoardDelegate;
    friend class  ChangeImplementationBoardDispatch;
    friend class  ChangeImplementationBoardGenImpl;
};

#include <cm/libcm_undef.h>
#endif //   TEAMCENTER__CHANGEIMPLEMENTATIONBOARD__HXX
