//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ChangeImplementationBoardDelegate
    Filename:   ChangeImplementationBoardDelegate.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CHANGEIMPLEMENTATIONBOARDDELEGATE_HXX
#define TEAMCENTER__CHANGEIMPLEMENTATIONBOARDDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cm/ChangeImplementationBoard.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class ChangeImplementationBoardDelegate;
}
namespace Teamcenter
{
    class ChangeImplementationBoardImpl;
}
namespace Teamcenter
{
    class ChangeImplementationBoard;
}
namespace Teamcenter
{
    class ChangeImplementationBoardGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CM_API Teamcenter_alias::ChangeImplementationBoardDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ChangeImplementationBoardDelegate instance
    static ChangeImplementationBoardDelegate&  getInstance();

    //  Method to create the ChangeImplementationBoardImpl pointer
    static ChangeImplementationBoardImpl*  createImpl( ChangeImplementationBoard&  ifObj );

    //  Method to delete the ChangeImplementationBoardImpl pointer
    static void deleteImpl( ChangeImplementationBoardImpl*  impl );


    ///
    /// This operation determines if the participant is assignable.
    /// @version Tc 8
    /// @param user - A user tag
    /// @param object - An object tag
    /// @param assignable - A pointer to a boolean whose value, when returned, is the result of the evaluation
    /// @return - An ifail integer
    ///
    int  isAssignableBase(const ChangeImplementationBoard &ifObj,  tag_t user, tag_t object, bool *assignable );



protected:
    //  Pointer to the instance
    static ChangeImplementationBoardDelegate*  m_pInstance;

    ChangeImplementationBoardDelegate();
    virtual ~ChangeImplementationBoardDelegate();
    static void setInstance( ChangeImplementationBoardDelegate*  instance );


private:
    friend class  ::Teamcenter::ChangeImplementationBoardGenImpl;

};

#include <cm/libcm_undef.h>
#endif  //  TEAMCENTER__CHANGEIMPLEMENTATIONBOARDDELEGATE_HXX
