//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ChangeItem
    Filename:   ChangeItem.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CHANGEITEM__HXX
#define TEAMCENTER__CHANGEITEM__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class ChangeItem;
}
namespace Teamcenter
{
    class ChangeItemImpl;
}
namespace Teamcenter
{
    class ChangeItemDelegate;
}
namespace Teamcenter
{
    class ChangeItemDispatch;
}
namespace Teamcenter
{
    class ChangeItemGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CM_API  Teamcenter::ChangeItem
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ChangeItem();

    /**
     * Destructor
     */
    virtual ~ChangeItem();

private:
    //  Getter method for the Implementation Object
    ChangeItemImpl*  getChangeItemImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setChangeItemImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ChangeItemImpl*  m_changeitemImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ChangeItem - desc for ChangeItem parameter
     */
    ChangeItem( const ChangeItem& );
    ChangeItem& operator=( const ChangeItem& );

    friend class  ChangeItemDelegate;
    friend class  ChangeItemDispatch;
    friend class  ChangeItemGenImpl;
};

#include <cm/libcm_undef.h>
#endif //   TEAMCENTER__CHANGEITEM__HXX
