//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ChangeItemRevision
    Filename:   ChangeItemRevision.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CHANGEITEMREVISION__HXX
#define TEAMCENTER__CHANGEITEMREVISION__HXX

#include <vector>
#include <metaframework/BulkInput.hxx>
#include <metaframework/BulkData.hxx>
#include <string>
#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class ChangeItemRevision;
}
namespace Teamcenter
{
    class ChangeItemRevisionImpl;
}
namespace Teamcenter
{
    class ChangeItemRevisionDelegate;
}
namespace Teamcenter
{
    class ChangeItemRevisionDispatch;
}
namespace Teamcenter
{
    class ChangeItemRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CM_API  Teamcenter::ChangeItemRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 11.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCm0DerivableTypes( std::vector< std::string > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCMClosure( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCMClosureComments( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Date Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCMClosureDate( date_t &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCMDisposition( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCMDispositionComments( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Date Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCMDispositionDate( date_t &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCMMaturity( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCMClosure( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCMClosureComments( const std::string &value, bool isNull=false );

    ///
    /// Setter for a Date Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCMClosureDate( const date_t &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCMDisposition( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCMDispositionComments( const std::string &value, bool isNull=false );

    ///
    /// Setter for a Date Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCMDispositionDate( const date_t &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCMMaturity( const std::string &value, bool isNull=false );

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.5
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCm0ChangeContributors( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Derives selected change management item_revs to a new change management item and item_rev. Process includes optional propagation of objects related to selected item_revs and relation properties based on deep copy rules,&nbsp;&nbsp;&nbsp;&nbsp;propagation of object properties from selected item_revs based on business object constant CopyFromOriginal and relation of selected item_revs to the new item_rev.
    /// @version Teamcenter 12.3
    /// @param deriveInput - A vector of data that contains reference information to the object to be dervied.
    /// @param bulkData - A data structure to store objects and other information relevant for set-based operation.
    /// @return - Returns an integer representing success or failure of the operation.
    ///
    static int  cm0DeriveChange( std::vector<  ::Teamcenter::BulkInput* > *deriveInput, ::Teamcenter::BulkData *bulkData );

    ///
    /// This operation returns the full group name of the specified participant.
    /// @version Teamcenter 8.2
    /// @param participantType - A string representing the specified participant type
    /// @param groupName - A string representing the group name of the specified participant
    /// @return - Returns an integer representing success or failure of the operation
    ///
    int  cm0getParticipantGroupName( std::string &participantType, std::string &groupName );

    ///
    /// This operation returns the role name of the specified participant type.
    /// @version Teamcenter 8.2
    /// @param participantType - A string representing the participant type
    /// @param roleName - A string representing the role name of the specified participant.
    /// @return - Returns an integer representing success or failure of the operation.
    ///
    int  cm0getParticipantRoleName( std::string &participantType, std::string &roleName );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ChangeItemRevision();

    /**
     * Destructor
     */
    virtual ~ChangeItemRevision();

private:
    //  Getter method for the Implementation Object
    ChangeItemRevisionImpl*  getChangeItemRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setChangeItemRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ChangeItemRevisionImpl*  m_changeitemrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ChangeItemRevision - desc for ChangeItemRevision parameter
     */
    ChangeItemRevision( const ChangeItemRevision& );
    ChangeItemRevision& operator=( const ChangeItemRevision& );

    friend class  ChangeItemRevisionDelegate;
    friend class  ChangeItemRevisionDispatch;
    friend class  ChangeItemRevisionGenImpl;
};

#include <cm/libcm_undef.h>
#endif //   TEAMCENTER__CHANGEITEMREVISION__HXX
