//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ChangeItemRevisionDelegate
    Filename:   ChangeItemRevisionDelegate.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CHANGEITEMREVISIONDELEGATE_HXX
#define TEAMCENTER__CHANGEITEMREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cm/ChangeItemRevision.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class ChangeItemRevisionDelegate;
}
namespace Teamcenter
{
    class ChangeItemRevisionImpl;
}
namespace Teamcenter
{
    class ChangeItemRevision;
}
namespace Teamcenter
{
    class ChangeItemRevisionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CM_API Teamcenter_alias::ChangeItemRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ChangeItemRevisionDelegate instance
    static ChangeItemRevisionDelegate&  getInstance();

    //  Method to create the ChangeItemRevisionImpl pointer
    static ChangeItemRevisionImpl*  createImpl( ChangeItemRevision&  ifObj );

    //  Method to delete the ChangeItemRevisionImpl pointer
    static void deleteImpl( ChangeItemRevisionImpl*  impl );


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 11.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCm0DerivableTypesBase(const ChangeItemRevision &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCMClosureBase(const ChangeItemRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCMClosureCommentsBase(const ChangeItemRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Date Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCMClosureDateBase(const ChangeItemRevision &ifObj,  date_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCMDispositionBase(const ChangeItemRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCMDispositionCommentsBase(const ChangeItemRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Date Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCMDispositionDateBase(const ChangeItemRevision &ifObj,  date_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCMMaturityBase(const ChangeItemRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCMClosureBase(ChangeItemRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCMClosureCommentsBase(ChangeItemRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Date Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCMClosureDateBase(ChangeItemRevision &ifObj,  const date_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCMDispositionBase(ChangeItemRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCMDispositionCommentsBase(ChangeItemRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Date Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCMDispositionDateBase(ChangeItemRevision &ifObj,  const date_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCMMaturityBase(ChangeItemRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.5
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCm0ChangeContributorsBase(const ChangeItemRevision &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Derives selected change management item_revs to a new change management item and item_rev. Process includes optional propagation of objects related to selected item_revs and relation properties based on deep copy rules,&nbsp;&nbsp;&nbsp;&nbsp;propagation of object properties from selected item_revs based on business object constant CopyFromOriginal and relation of selected item_revs to the new item_rev.
    /// @version Teamcenter 12.3
    /// @param deriveInput - A vector of data that contains reference information to the object to be dervied.
    /// @param bulkData - A data structure to store objects and other information relevant for set-based operation.
    /// @return - Returns an integer representing success or failure of the operation.
    ///
    int  cm0DeriveChangeBase( std::vector<  ::Teamcenter::BulkInput* > *deriveInput, ::Teamcenter::BulkData *bulkData );


    ///
    /// This operation returns the full group name of the specified participant.
    /// @version Teamcenter 8.2
    /// @param participantType - A string representing the specified participant type
    /// @param groupName - A string representing the group name of the specified participant
    /// @return - Returns an integer representing success or failure of the operation
    ///
    int  cm0getParticipantGroupNameBase(const ChangeItemRevision &ifObj,  std::string &participantType, std::string &groupName );


    ///
    /// This operation returns the role name of the specified participant type.
    /// @version Teamcenter 8.2
    /// @param participantType - A string representing the participant type
    /// @param roleName - A string representing the role name of the specified participant.
    /// @return - Returns an integer representing success or failure of the operation.
    ///
    int  cm0getParticipantRoleNameBase(const ChangeItemRevision &ifObj,  std::string &participantType, std::string &roleName );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0CreatePostBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be created
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0ValidateCreateInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const ChangeItemRevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Generic saveAsPost operation.
    /// @version Teamcenter 8.1
    /// @param pSavAsInput - Input argument as SaveAsInput object.
    /// @param vecDeepCopyData - vector deepcopy data
    /// @return - Return integer value.
    ///
    int  saveAsPostBase(const ChangeItemRevision &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static ChangeItemRevisionDelegate*  m_pInstance;

    ChangeItemRevisionDelegate();
    virtual ~ChangeItemRevisionDelegate();
    static void setInstance( ChangeItemRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::ChangeItemRevisionGenImpl;

};

#include <cm/libcm_undef.h>
#endif  //  TEAMCENTER__CHANGEITEMREVISIONDELEGATE_HXX
