//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ChangeNotice
    Filename:   ChangeNotice.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CHANGENOTICE__HXX
#define TEAMCENTER__CHANGENOTICE__HXX

#include <common/tc_deprecation_macros.h>
#include <cm/GnChangeNotice.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class ChangeNotice;
}
namespace Teamcenter
{
    class ChangeNoticeImpl;
}
namespace Teamcenter
{
    class ChangeNoticeDelegate;
}
namespace Teamcenter
{
    class ChangeNoticeDispatch;
}
namespace Teamcenter
{
    class ChangeNoticeGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CM_API  Teamcenter::ChangeNotice
     : public  ::Teamcenter::GnChangeNotice
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ChangeNotice();

    /**
     * Destructor
     */
    virtual ~ChangeNotice();

private:
    //  Getter method for the Implementation Object
    ChangeNoticeImpl*  getChangeNoticeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setChangeNoticeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ChangeNoticeImpl*  m_changenoticeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ChangeNotice - desc for ChangeNotice parameter
     */
    ChangeNotice( const ChangeNotice& );
    ChangeNotice& operator=( const ChangeNotice& );

    friend class  ChangeNoticeDelegate;
    friend class  ChangeNoticeDispatch;
    friend class  ChangeNoticeGenImpl;
};

#include <cm/libcm_undef.h>
#endif //   TEAMCENTER__CHANGENOTICE__HXX
