//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ChangeNoticeRevisionDelegate
    Filename:   ChangeNoticeRevisionDelegate.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CHANGENOTICEREVISIONDELEGATE_HXX
#define TEAMCENTER__CHANGENOTICEREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cm/ChangeNoticeRevision.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class ChangeNoticeRevisionDelegate;
}
namespace Teamcenter
{
    class ChangeNoticeRevisionImpl;
}
namespace Teamcenter
{
    class ChangeNoticeRevision;
}
namespace Teamcenter
{
    class ChangeNoticeRevisionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CM_API Teamcenter_alias::ChangeNoticeRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ChangeNoticeRevisionDelegate instance
    static ChangeNoticeRevisionDelegate&  getInstance();

    //  Method to create the ChangeNoticeRevisionImpl pointer
    static ChangeNoticeRevisionImpl*  createImpl( ChangeNoticeRevision&  ifObj );

    //  Method to delete the ChangeNoticeRevisionImpl pointer
    static void deleteImpl( ChangeNoticeRevisionImpl*  impl );


    ///
    /// Getter for a Date Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCMDateOfCustApprovalBase(const ChangeNoticeRevision &ifObj,  date_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCMImplPriorityBase(const ChangeNoticeRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCMIsCustApprovalRequiredBase(const ChangeNoticeRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCMSpecialInstructionBase(const ChangeNoticeRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCMStatusOfCustApprovalBase(const ChangeNoticeRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a Date Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCMDateOfCustApprovalBase(ChangeNoticeRevision &ifObj,  const date_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCMImplPriorityBase(ChangeNoticeRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCMIsCustApprovalRequiredBase(ChangeNoticeRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCMSpecialInstructionBase(ChangeNoticeRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCMStatusOfCustApprovalBase(ChangeNoticeRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const ChangeNoticeRevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0CreatePostBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static ChangeNoticeRevisionDelegate*  m_pInstance;

    ChangeNoticeRevisionDelegate();
    virtual ~ChangeNoticeRevisionDelegate();
    static void setInstance( ChangeNoticeRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::ChangeNoticeRevisionGenImpl;

};

#include <cm/libcm_undef.h>
#endif  //  TEAMCENTER__CHANGENOTICEREVISIONDELEGATE_HXX
