//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ChangeRequest
    Filename:   ChangeRequest.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CHANGEREQUEST__HXX
#define TEAMCENTER__CHANGEREQUEST__HXX

#include <common/tc_deprecation_macros.h>
#include <cm/GnChangeRequest.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class ChangeRequest;
}
namespace Teamcenter
{
    class ChangeRequestImpl;
}
namespace Teamcenter
{
    class ChangeRequestDelegate;
}
namespace Teamcenter
{
    class ChangeRequestDispatch;
}
namespace Teamcenter
{
    class ChangeRequestGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CM_API  Teamcenter::ChangeRequest
     : public  ::Teamcenter::GnChangeRequest
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ChangeRequest();

    /**
     * Destructor
     */
    virtual ~ChangeRequest();

private:
    //  Getter method for the Implementation Object
    ChangeRequestImpl*  getChangeRequestImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setChangeRequestImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ChangeRequestImpl*  m_changerequestImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ChangeRequest - desc for ChangeRequest parameter
     */
    ChangeRequest( const ChangeRequest& );
    ChangeRequest& operator=( const ChangeRequest& );

    friend class  ChangeRequestDelegate;
    friend class  ChangeRequestDispatch;
    friend class  ChangeRequestGenImpl;
};

#include <cm/libcm_undef.h>
#endif //   TEAMCENTER__CHANGEREQUEST__HXX
