//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ChangeRequestRevisionDelegate
    Filename:   ChangeRequestRevisionDelegate.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CHANGEREQUESTREVISIONDELEGATE_HXX
#define TEAMCENTER__CHANGEREQUESTREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cm/ChangeRequestRevision.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class ChangeRequestRevisionDelegate;
}
namespace Teamcenter
{
    class ChangeRequestRevisionImpl;
}
namespace Teamcenter
{
    class ChangeRequestRevision;
}
namespace Teamcenter
{
    class ChangeRequestRevisionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CM_API Teamcenter_alias::ChangeRequestRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ChangeRequestRevisionDelegate instance
    static ChangeRequestRevisionDelegate&  getInstance();

    //  Method to create the ChangeRequestRevisionImpl pointer
    static ChangeRequestRevisionImpl*  createImpl( ChangeRequestRevision&  ifObj );

    //  Method to delete the ChangeRequestRevisionImpl pointer
    static void deleteImpl( ChangeRequestRevisionImpl*  impl );


    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCMNonrecurringCostBase(const ChangeRequestRevision &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCMProposedSolutionBase(const ChangeRequestRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCMReasonBase(const ChangeRequestRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCMRecurringCostBase(const ChangeRequestRevision &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCMTechnicalRecommendationBase(const ChangeRequestRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCMTechnicalReviewBase(const ChangeRequestRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Date Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCMTechRecommDateBase(const ChangeRequestRevision &ifObj,  date_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCMTechReviewPriorityBase(const ChangeRequestRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCMTestResultsAttachedBase(const ChangeRequestRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCMTimingFactorsBase(const ChangeRequestRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCMNonrecurringCostBase(ChangeRequestRevision &ifObj,  double value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCMProposedSolutionBase(ChangeRequestRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCMReasonBase(ChangeRequestRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCMRecurringCostBase(ChangeRequestRevision &ifObj,  double value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCMTechnicalRecommendationBase(ChangeRequestRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCMTechnicalReviewBase(ChangeRequestRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Date Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCMTechRecommDateBase(ChangeRequestRevision &ifObj,  const date_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCMTechReviewPriorityBase(ChangeRequestRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCMTestResultsAttachedBase(ChangeRequestRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCMTimingFactorsBase(ChangeRequestRevision &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static ChangeRequestRevisionDelegate*  m_pInstance;

    ChangeRequestRevisionDelegate();
    virtual ~ChangeRequestRevisionDelegate();
    static void setInstance( ChangeRequestRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::ChangeRequestRevisionGenImpl;

};

#include <cm/libcm_undef.h>
#endif  //  TEAMCENTER__CHANGEREQUESTREVISIONDELEGATE_HXX
