//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ChangeReviewBoard
    Filename:   ChangeReviewBoard.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CHANGEREVIEWBOARD__HXX
#define TEAMCENTER__CHANGEREVIEWBOARD__HXX

#include <common/tc_deprecation_macros.h>
#include <epm/Participant.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class ChangeReviewBoard;
}
namespace Teamcenter
{
    class ChangeReviewBoardImpl;
}
namespace Teamcenter
{
    class ChangeReviewBoardDelegate;
}
namespace Teamcenter
{
    class ChangeReviewBoardDispatch;
}
namespace Teamcenter
{
    class ChangeReviewBoardGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CM_API  Teamcenter::ChangeReviewBoard
     : public  ::Teamcenter::Participant
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ChangeReviewBoard();

    /**
     * Destructor
     */
    virtual ~ChangeReviewBoard();

private:
    //  Getter method for the Implementation Object
    ChangeReviewBoardImpl*  getChangeReviewBoardImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setChangeReviewBoardImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ChangeReviewBoardImpl*  m_changereviewboardImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ChangeReviewBoard - desc for ChangeReviewBoard parameter
     */
    ChangeReviewBoard( const ChangeReviewBoard& );
    ChangeReviewBoard& operator=( const ChangeReviewBoard& );

    friend class  ChangeReviewBoardDelegate;
    friend class  ChangeReviewBoardDispatch;
    friend class  ChangeReviewBoardGenImpl;
};

#include <cm/libcm_undef.h>
#endif //   TEAMCENTER__CHANGEREVIEWBOARD__HXX
