//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ChangeReviewBoardDelegate
    Filename:   ChangeReviewBoardDelegate.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CHANGEREVIEWBOARDDELEGATE_HXX
#define TEAMCENTER__CHANGEREVIEWBOARDDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cm/ChangeReviewBoard.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class ChangeReviewBoardDelegate;
}
namespace Teamcenter
{
    class ChangeReviewBoardImpl;
}
namespace Teamcenter
{
    class ChangeReviewBoard;
}
namespace Teamcenter
{
    class ChangeReviewBoardGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CM_API Teamcenter_alias::ChangeReviewBoardDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ChangeReviewBoardDelegate instance
    static ChangeReviewBoardDelegate&  getInstance();

    //  Method to create the ChangeReviewBoardImpl pointer
    static ChangeReviewBoardImpl*  createImpl( ChangeReviewBoard&  ifObj );

    //  Method to delete the ChangeReviewBoardImpl pointer
    static void deleteImpl( ChangeReviewBoardImpl*  impl );


    ///
    /// This operation determines if the participant is assignable.
    /// @version Tc 8
    /// @param user - A user tag
    /// @param object - An object tag
    /// @param assignable - A pointer to a boolean whose value, when returned, is the result of the evaluation
    /// @return - An ifail integer
    ///
    int  isAssignableBase(const ChangeReviewBoard &ifObj,  tag_t user, tag_t object, bool *assignable );



protected:
    //  Pointer to the instance
    static ChangeReviewBoardDelegate*  m_pInstance;

    ChangeReviewBoardDelegate();
    virtual ~ChangeReviewBoardDelegate();
    static void setInstance( ChangeReviewBoardDelegate*  instance );


private:
    friend class  ::Teamcenter::ChangeReviewBoardGenImpl;

};

#include <cm/libcm_undef.h>
#endif  //  TEAMCENTER__CHANGEREVIEWBOARDDELEGATE_HXX
