//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ChangeSpecialist1Delegate
    Filename:   ChangeSpecialist1Delegate.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CHANGESPECIALIST1DELEGATE_HXX
#define TEAMCENTER__CHANGESPECIALIST1DELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cm/ChangeSpecialist1.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class ChangeSpecialist1Delegate;
}
namespace Teamcenter
{
    class ChangeSpecialist1Impl;
}
namespace Teamcenter
{
    class ChangeSpecialist1;
}
namespace Teamcenter
{
    class ChangeSpecialist1GenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CM_API Teamcenter_alias::ChangeSpecialist1Delegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ChangeSpecialist1Delegate instance
    static ChangeSpecialist1Delegate&  getInstance();

    //  Method to create the ChangeSpecialist1Impl pointer
    static ChangeSpecialist1Impl*  createImpl( ChangeSpecialist1&  ifObj );

    //  Method to delete the ChangeSpecialist1Impl pointer
    static void deleteImpl( ChangeSpecialist1Impl*  impl );


    ///
    /// This operation determines if the participant is assignable.
    /// @version Tc 8
    /// @param user - A user tag
    /// @param object - An object tag
    /// @param assignable - A pointer to a boolean whose value, when returned, is the result of the evaluation
    /// @return - An ifail integer
    ///
    int  isAssignableBase(const ChangeSpecialist1 &ifObj,  tag_t user, tag_t object, bool *assignable );



protected:
    //  Pointer to the instance
    static ChangeSpecialist1Delegate*  m_pInstance;

    ChangeSpecialist1Delegate();
    virtual ~ChangeSpecialist1Delegate();
    static void setInstance( ChangeSpecialist1Delegate*  instance );


private:
    friend class  ::Teamcenter::ChangeSpecialist1GenImpl;

};

#include <cm/libcm_undef.h>
#endif  //  TEAMCENTER__CHANGESPECIALIST1DELEGATE_HXX
