//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ChangeSpecialist2Delegate
    Filename:   ChangeSpecialist2Delegate.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CHANGESPECIALIST2DELEGATE_HXX
#define TEAMCENTER__CHANGESPECIALIST2DELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cm/ChangeSpecialist2.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class ChangeSpecialist2Delegate;
}
namespace Teamcenter
{
    class ChangeSpecialist2Impl;
}
namespace Teamcenter
{
    class ChangeSpecialist2;
}
namespace Teamcenter
{
    class ChangeSpecialist2GenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CM_API Teamcenter_alias::ChangeSpecialist2Delegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ChangeSpecialist2Delegate instance
    static ChangeSpecialist2Delegate&  getInstance();

    //  Method to create the ChangeSpecialist2Impl pointer
    static ChangeSpecialist2Impl*  createImpl( ChangeSpecialist2&  ifObj );

    //  Method to delete the ChangeSpecialist2Impl pointer
    static void deleteImpl( ChangeSpecialist2Impl*  impl );


    ///
    /// This operation determines if the participant is assignable.
    /// @version Tc 8
    /// @param user - A user tag
    /// @param object - An object tag
    /// @param assignable - A pointer to a boolean whose value, when returned, is the result of the evaluation
    /// @return - An ifail integer
    ///
    int  isAssignableBase(const ChangeSpecialist2 &ifObj,  tag_t user, tag_t object, bool *assignable );



protected:
    //  Pointer to the instance
    static ChangeSpecialist2Delegate*  m_pInstance;

    ChangeSpecialist2Delegate();
    virtual ~ChangeSpecialist2Delegate();
    static void setInstance( ChangeSpecialist2Delegate*  instance );


private:
    friend class  ::Teamcenter::ChangeSpecialist2GenImpl;

};

#include <cm/libcm_undef.h>
#endif  //  TEAMCENTER__CHANGESPECIALIST2DELEGATE_HXX
