//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ChangeSpecialist3Delegate
    Filename:   ChangeSpecialist3Delegate.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CHANGESPECIALIST3DELEGATE_HXX
#define TEAMCENTER__CHANGESPECIALIST3DELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cm/ChangeSpecialist3.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class ChangeSpecialist3Delegate;
}
namespace Teamcenter
{
    class ChangeSpecialist3Impl;
}
namespace Teamcenter
{
    class ChangeSpecialist3;
}
namespace Teamcenter
{
    class ChangeSpecialist3GenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CM_API Teamcenter_alias::ChangeSpecialist3Delegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ChangeSpecialist3Delegate instance
    static ChangeSpecialist3Delegate&  getInstance();

    //  Method to create the ChangeSpecialist3Impl pointer
    static ChangeSpecialist3Impl*  createImpl( ChangeSpecialist3&  ifObj );

    //  Method to delete the ChangeSpecialist3Impl pointer
    static void deleteImpl( ChangeSpecialist3Impl*  impl );


    ///
    /// This operation determines if the participant is assignable.
    /// @version Tc 8
    /// @param user - A user tag
    /// @param object - An object tag
    /// @param assignable - A pointer to a boolean whose value, when returned, is the result of the evaluation
    /// @return - An ifail integer
    ///
    int  isAssignableBase(const ChangeSpecialist3 &ifObj,  tag_t user, tag_t object, bool *assignable );



protected:
    //  Pointer to the instance
    static ChangeSpecialist3Delegate*  m_pInstance;

    ChangeSpecialist3Delegate();
    virtual ~ChangeSpecialist3Delegate();
    static void setInstance( ChangeSpecialist3Delegate*  instance );


private:
    friend class  ::Teamcenter::ChangeSpecialist3GenImpl;

};

#include <cm/libcm_undef.h>
#endif  //  TEAMCENTER__CHANGESPECIALIST3DELEGATE_HXX
