//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cm0ActionItemRevision
    Filename:   Cm0ActionItemRevision.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CM0ACTIONITEMREVISION__HXX
#define TEAMCENTER__CM0ACTIONITEMREVISION__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <cm/ProblemReportRevision.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class Cm0ActionItemRevision;
}
namespace Teamcenter
{
    class Cm0ActionItemRevisionImpl;
}
namespace Teamcenter
{
    class Cm0ActionItemRevisionDelegate;
}
namespace Teamcenter
{
    class Cm0ActionItemRevisionDispatch;
}
namespace Teamcenter
{
    class Cm0ActionItemRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CM_API  Teamcenter::Cm0ActionItemRevision
     : public  ::Teamcenter::ProblemReportRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCm0RaisedByAudit( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 10.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setCm0RaisedByAudit( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cm0ActionItemRevision();

    /**
     * Destructor
     */
    virtual ~Cm0ActionItemRevision();

private:
    //  Getter method for the Implementation Object
    Cm0ActionItemRevisionImpl*  getCm0ActionItemRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCm0ActionItemRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cm0ActionItemRevisionImpl*  m_cm0actionitemrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cm0ActionItemRevision - desc for Cm0ActionItemRevision parameter
     */
    Cm0ActionItemRevision( const Cm0ActionItemRevision& );
    Cm0ActionItemRevision& operator=( const Cm0ActionItemRevision& );

    friend class  Cm0ActionItemRevisionDelegate;
    friend class  Cm0ActionItemRevisionDispatch;
    friend class  Cm0ActionItemRevisionGenImpl;
};

#include <cm/libcm_undef.h>
#endif //   TEAMCENTER__CM0ACTIONITEMREVISION__HXX
