//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cm0ActionItemRevisionDelegate
    Filename:   Cm0ActionItemRevisionDelegate.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CM0ACTIONITEMREVISIONDELEGATE_HXX
#define TEAMCENTER__CM0ACTIONITEMREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cm/Cm0ActionItemRevision.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class Cm0ActionItemRevisionDelegate;
}
namespace Teamcenter
{
    class Cm0ActionItemRevisionImpl;
}
namespace Teamcenter
{
    class Cm0ActionItemRevision;
}
namespace Teamcenter
{
    class Cm0ActionItemRevisionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CM_API Teamcenter_alias::Cm0ActionItemRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cm0ActionItemRevisionDelegate instance
    static Cm0ActionItemRevisionDelegate&  getInstance();

    //  Method to create the Cm0ActionItemRevisionImpl pointer
    static Cm0ActionItemRevisionImpl*  createImpl( Cm0ActionItemRevision&  ifObj );

    //  Method to delete the Cm0ActionItemRevisionImpl pointer
    static void deleteImpl( Cm0ActionItemRevisionImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCm0RaisedByAuditBase(const Cm0ActionItemRevision &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 10.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setCm0RaisedByAuditBase(Cm0ActionItemRevision &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );



protected:
    //  Pointer to the instance
    static Cm0ActionItemRevisionDelegate*  m_pInstance;

    Cm0ActionItemRevisionDelegate();
    virtual ~Cm0ActionItemRevisionDelegate();
    static void setInstance( Cm0ActionItemRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::Cm0ActionItemRevisionGenImpl;

};

#include <cm/libcm_undef.h>
#endif  //  TEAMCENTER__CM0ACTIONITEMREVISIONDELEGATE_HXX
