//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cm0ChangeContributors
    Filename:   Cm0ChangeContributors.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CM0CHANGECONTRIBUTORS__HXX
#define TEAMCENTER__CM0CHANGECONTRIBUTORS__HXX

#include <common/tc_deprecation_macros.h>
#include <epm/Participant.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class Cm0ChangeContributors;
}
namespace Teamcenter
{
    class Cm0ChangeContributorsImpl;
}
namespace Teamcenter
{
    class Cm0ChangeContributorsDelegate;
}
namespace Teamcenter
{
    class Cm0ChangeContributorsDispatch;
}
namespace Teamcenter
{
    class Cm0ChangeContributorsGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CM_API  Teamcenter::Cm0ChangeContributors
     : public  ::Teamcenter::Participant
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cm0ChangeContributors();

    /**
     * Destructor
     */
    virtual ~Cm0ChangeContributors();

private:
    //  Getter method for the Implementation Object
    Cm0ChangeContributorsImpl*  getCm0ChangeContributorsImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCm0ChangeContributorsImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cm0ChangeContributorsImpl*  m_cm0changecontributorsImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cm0ChangeContributors - desc for Cm0ChangeContributors parameter
     */
    Cm0ChangeContributors( const Cm0ChangeContributors& );
    Cm0ChangeContributors& operator=( const Cm0ChangeContributors& );

    friend class  Cm0ChangeContributorsDelegate;
    friend class  Cm0ChangeContributorsDispatch;
    friend class  Cm0ChangeContributorsGenImpl;
};

#include <cm/libcm_undef.h>
#endif //   TEAMCENTER__CM0CHANGECONTRIBUTORS__HXX
