//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cm0ChangeContributorsDelegate
    Filename:   Cm0ChangeContributorsDelegate.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CM0CHANGECONTRIBUTORSDELEGATE_HXX
#define TEAMCENTER__CM0CHANGECONTRIBUTORSDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cm/Cm0ChangeContributors.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class Cm0ChangeContributorsDelegate;
}
namespace Teamcenter
{
    class Cm0ChangeContributorsImpl;
}
namespace Teamcenter
{
    class Cm0ChangeContributors;
}
namespace Teamcenter
{
    class Cm0ChangeContributorsGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CM_API Teamcenter_alias::Cm0ChangeContributorsDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cm0ChangeContributorsDelegate instance
    static Cm0ChangeContributorsDelegate&  getInstance();

    //  Method to create the Cm0ChangeContributorsImpl pointer
    static Cm0ChangeContributorsImpl*  createImpl( Cm0ChangeContributors&  ifObj );

    //  Method to delete the Cm0ChangeContributorsImpl pointer
    static void deleteImpl( Cm0ChangeContributorsImpl*  impl );


    ///
    /// This operation determines if the participant is assignable.
    /// @version Tc 8
    /// @param user - A user tag
    /// @param object - An object tag
    /// @param assignable - A pointer to a boolean whose value, when returned, is the result of the evaluation
    /// @return - An ifail integer
    ///
    int  isAssignableBase(const Cm0ChangeContributors &ifObj,  tag_t user, tag_t object, bool *assignable );



protected:
    //  Pointer to the instance
    static Cm0ChangeContributorsDelegate*  m_pInstance;

    Cm0ChangeContributorsDelegate();
    virtual ~Cm0ChangeContributorsDelegate();
    static void setInstance( Cm0ChangeContributorsDelegate*  instance );


private:
    friend class  ::Teamcenter::Cm0ChangeContributorsGenImpl;

};

#include <cm/libcm_undef.h>
#endif  //  TEAMCENTER__CM0CHANGECONTRIBUTORSDELEGATE_HXX
