//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cm0EffectivityExprBlock
    Filename:   Cm0EffectivityExprBlock.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CM0EFFECTIVITYEXPRBLOCK__HXX
#define TEAMCENTER__CM0EFFECTIVITYEXPRBLOCK__HXX

#include <common/tc_deprecation_macros.h>
#include <fnd0booleansolve/Fnd0EffectivityExprBlock.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class Cm0EffectivityExprBlock;
}
namespace Teamcenter
{
    class Cm0EffectivityExprBlockImpl;
}
namespace Teamcenter
{
    class Cm0EffectivityExprBlockDelegate;
}
namespace Teamcenter
{
    class Cm0EffectivityExprBlockDispatch;
}
namespace Teamcenter
{
    class Cm0EffectivityExprBlockGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CM_API  Teamcenter::Cm0EffectivityExprBlock
     : public  ::Teamcenter::Fnd0EffectivityExprBlock
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cm0EffectivityExprBlock();

    /**
     * Destructor
     */
    virtual ~Cm0EffectivityExprBlock();

private:
    //  Getter method for the Implementation Object
    Cm0EffectivityExprBlockImpl*  getCm0EffectivityExprBlockImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCm0EffectivityExprBlockImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cm0EffectivityExprBlockImpl*  m_cm0effectivityexprblockImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cm0EffectivityExprBlock - desc for Cm0EffectivityExprBlock parameter
     */
    Cm0EffectivityExprBlock( const Cm0EffectivityExprBlock& );
    Cm0EffectivityExprBlock& operator=( const Cm0EffectivityExprBlock& );

    friend class  Cm0EffectivityExprBlockDelegate;
    friend class  Cm0EffectivityExprBlockDispatch;
    friend class  Cm0EffectivityExprBlockGenImpl;
};

#include <cm/libcm_undef.h>
#endif //   TEAMCENTER__CM0EFFECTIVITYEXPRBLOCK__HXX
