//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cm0GlobalChangeContextsLOVDelegate
    Filename:   Cm0GlobalChangeContextsLOVDelegate.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CM__CM0GLOBALCHANGECONTEXTSLOVDELEGATE_HXX
#define TEAMCENTER__CM__CM0GLOBALCHANGECONTEXTSLOVDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cm/Cm0GlobalChangeContextsLOV.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    namespace CM
    {
        class Cm0GlobalChangeContextsLOVDelegate;
    }
}
namespace Teamcenter
{
    namespace CM
    {
        class Cm0GlobalChangeContextsLOVImpl;
    }
}
namespace Teamcenter
{
    namespace CM
    {
        class Cm0GlobalChangeContextsLOV;
    }
}
namespace Teamcenter
{
    namespace CM
    {
        class Cm0GlobalChangeContextsLOVGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CM_API Teamcenter_alias::CM::Cm0GlobalChangeContextsLOVDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cm0GlobalChangeContextsLOVDelegate instance
    static Cm0GlobalChangeContextsLOVDelegate&  getInstance();

    //  Method to create the Cm0GlobalChangeContextsLOVImpl pointer
    static Cm0GlobalChangeContextsLOVImpl*  createImpl( Cm0GlobalChangeContextsLOV&  ifObj );

    //  Method to delete the Cm0GlobalChangeContextsLOVImpl pointer
    static void deleteImpl( Cm0GlobalChangeContextsLOVImpl*  impl );


    ///
    /// Returns List Of Values based on Dynamic LOV definition and user search criteria.
    /// @version Teamcenter 10
    /// @param operationInputTag - Operation Input containing the modified values.
    /// @param propertyName - Name of the selected property.
    /// @param searchString - User entered search string.
    /// @param sortByProp - Property to use for sorting.
    /// @param sortOrder - order for sorting (0=Ascending, 1=Descending).
    /// @param nResults - Number of returned results.
    /// @param results - Returned Values for LOV.
    /// @return - Zero (0) if everything is alright otherwise the error code.
    ///
    int  fnd0askLOVValuesBase(const Cm0GlobalChangeContextsLOV &ifObj,  const tag_t operationInputTag, const std::string *propertyName, const std::string *searchString, const char *sortByProp, const int sortOrder, int *nResults, tag_t **results ) const;



protected:
    //  Pointer to the instance
    static Cm0GlobalChangeContextsLOVDelegate*  m_pInstance;

    Cm0GlobalChangeContextsLOVDelegate();
    virtual ~Cm0GlobalChangeContextsLOVDelegate();
    static void setInstance( Cm0GlobalChangeContextsLOVDelegate*  instance );


private:
    friend class  ::Teamcenter::CM::Cm0GlobalChangeContextsLOVGenImpl;

};

#include <cm/libcm_undef.h>
#endif  //  TEAMCENTER__CM__CM0GLOBALCHANGECONTEXTSLOVDELEGATE_HXX
