//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cm0GnWorkOrder
    Filename:   Cm0GnWorkOrder.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CM0GNWORKORDER__HXX
#define TEAMCENTER__CM0GNWORKORDER__HXX

#include <common/tc_deprecation_macros.h>
#include <cm/ChangeItem.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class Cm0GnWorkOrder;
}
namespace Teamcenter
{
    class Cm0GnWorkOrderImpl;
}
namespace Teamcenter
{
    class Cm0GnWorkOrderDelegate;
}
namespace Teamcenter
{
    class Cm0GnWorkOrderDispatch;
}
namespace Teamcenter
{
    class Cm0GnWorkOrderGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CM_API  Teamcenter::Cm0GnWorkOrder
     : public  ::Teamcenter::ChangeItem
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cm0GnWorkOrder();

    /**
     * Destructor
     */
    virtual ~Cm0GnWorkOrder();

private:
    //  Getter method for the Implementation Object
    Cm0GnWorkOrderImpl*  getCm0GnWorkOrderImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCm0GnWorkOrderImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cm0GnWorkOrderImpl*  m_cm0gnworkorderImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cm0GnWorkOrder - desc for Cm0GnWorkOrder parameter
     */
    Cm0GnWorkOrder( const Cm0GnWorkOrder& );
    Cm0GnWorkOrder& operator=( const Cm0GnWorkOrder& );

    friend class  Cm0GnWorkOrderDelegate;
    friend class  Cm0GnWorkOrderDispatch;
    friend class  Cm0GnWorkOrderGenImpl;
};

#include <cm/libcm_undef.h>
#endif //   TEAMCENTER__CM0GNWORKORDER__HXX
