//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cm0GnWorkOrderRevision
    Filename:   Cm0GnWorkOrderRevision.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CM0GNWORKORDERREVISION__HXX
#define TEAMCENTER__CM0GNWORKORDERREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <cm/ChangeItemRevision.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class Cm0GnWorkOrderRevision;
}
namespace Teamcenter
{
    class Cm0GnWorkOrderRevisionImpl;
}
namespace Teamcenter
{
    class Cm0GnWorkOrderRevisionDelegate;
}
namespace Teamcenter
{
    class Cm0GnWorkOrderRevisionDispatch;
}
namespace Teamcenter
{
    class Cm0GnWorkOrderRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CM_API  Teamcenter::Cm0GnWorkOrderRevision
     : public  ::Teamcenter::ChangeItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cm0GnWorkOrderRevision();

    /**
     * Destructor
     */
    virtual ~Cm0GnWorkOrderRevision();

private:
    //  Getter method for the Implementation Object
    Cm0GnWorkOrderRevisionImpl*  getCm0GnWorkOrderRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCm0GnWorkOrderRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cm0GnWorkOrderRevisionImpl*  m_cm0gnworkorderrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cm0GnWorkOrderRevision - desc for Cm0GnWorkOrderRevision parameter
     */
    Cm0GnWorkOrderRevision( const Cm0GnWorkOrderRevision& );
    Cm0GnWorkOrderRevision& operator=( const Cm0GnWorkOrderRevision& );

    friend class  Cm0GnWorkOrderRevisionDelegate;
    friend class  Cm0GnWorkOrderRevisionDispatch;
    friend class  Cm0GnWorkOrderRevisionGenImpl;
};

#include <cm/libcm_undef.h>
#endif //   TEAMCENTER__CM0GNWORKORDERREVISION__HXX
