//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cm0HasProposal
    Filename:   Cm0HasProposal.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CM0HASPROPOSAL__HXX
#define TEAMCENTER__CM0HASPROPOSAL__HXX

#include <common/tc_deprecation_macros.h>
#include <cm/CMRelation.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class Cm0HasProposal;
}
namespace Teamcenter
{
    class Cm0HasProposalImpl;
}
namespace Teamcenter
{
    class Cm0HasProposalDelegate;
}
namespace Teamcenter
{
    class Cm0HasProposalDispatch;
}
namespace Teamcenter
{
    class Cm0HasProposalGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CM_API  Teamcenter::Cm0HasProposal
     : public  ::Teamcenter::CMRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cm0HasProposal();

    /**
     * Destructor
     */
    virtual ~Cm0HasProposal();

private:
    //  Getter method for the Implementation Object
    Cm0HasProposalImpl*  getCm0HasProposalImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCm0HasProposalImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cm0HasProposalImpl*  m_cm0hasproposalImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cm0HasProposal - desc for Cm0HasProposal parameter
     */
    Cm0HasProposal( const Cm0HasProposal& );
    Cm0HasProposal& operator=( const Cm0HasProposal& );

    friend class  Cm0HasProposalDelegate;
    friend class  Cm0HasProposalDispatch;
    friend class  Cm0HasProposalGenImpl;
};

#include <cm/libcm_undef.h>
#endif //   TEAMCENTER__CM0HASPROPOSAL__HXX
