//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cm0ProposedImpactedObjectDelegate
    Filename:   Cm0ProposedImpactedObjectDelegate.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CM__CM0PROPOSEDIMPACTEDOBJECTDELEGATE_HXX
#define TEAMCENTER__CM__CM0PROPOSEDIMPACTEDOBJECTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cm/Cm0ProposedImpactedObject.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    namespace CM
    {
        class Cm0ProposedImpactedObjectDelegate;
    }
}
namespace Teamcenter
{
    namespace CM
    {
        class Cm0ProposedImpactedObjectImpl;
    }
}
namespace Teamcenter
{
    namespace CM
    {
        class Cm0ProposedImpactedObject;
    }
}
namespace Teamcenter
{
    namespace CM
    {
        class Cm0ProposedImpactedObjectGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CM_API Teamcenter_alias::CM::Cm0ProposedImpactedObjectDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cm0ProposedImpactedObjectDelegate instance
    static Cm0ProposedImpactedObjectDelegate&  getInstance();

    //  Method to create the Cm0ProposedImpactedObjectImpl pointer
    static Cm0ProposedImpactedObjectImpl*  createImpl( Cm0ProposedImpactedObject&  ifObj );

    //  Method to delete the Cm0ProposedImpactedObjectImpl pointer
    static void deleteImpl( Cm0ProposedImpactedObjectImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 12.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCm0ChildrenBase(const Cm0ProposedImpactedObject &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCm0HasChildrenBase(const Cm0ProposedImpactedObject &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCm0IsAlreadyImpactedBase(const Cm0ProposedImpactedObject &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCm0ProblemObjectBase(const Cm0ProposedImpactedObject &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCm0ProposedImpactedObjectBase(const Cm0ProposedImpactedObject &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCm0ProposedImpactedObjNameBase(const Cm0ProposedImpactedObject &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCm0ProposedImpactedTypeBase(const Cm0ProposedImpactedObject &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCm0RelationBase(const Cm0ProposedImpactedObject &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCm0SourceObjectBase(const Cm0ProposedImpactedObject &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCm0SourceObjectTypeBase(const Cm0ProposedImpactedObject &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 12.2
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setCm0ChildrenBase(Cm0ProposedImpactedObject &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 12.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCm0HasChildrenBase(Cm0ProposedImpactedObject &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 12.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCm0IsAlreadyImpactedBase(Cm0ProposedImpactedObject &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 12.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCm0ProblemObjectBase(Cm0ProposedImpactedObject &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 12.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCm0ProposedImpactedObjectBase(Cm0ProposedImpactedObject &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 12.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCm0ProposedImpactedObjNameBase(Cm0ProposedImpactedObject &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 12.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCm0ProposedImpactedTypeBase(Cm0ProposedImpactedObject &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 12.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCm0RelationBase(Cm0ProposedImpactedObject &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 12.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCm0SourceObjectBase(Cm0ProposedImpactedObject &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 12.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCm0SourceObjectTypeBase(Cm0ProposedImpactedObject &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static Cm0ProposedImpactedObjectDelegate*  m_pInstance;

    Cm0ProposedImpactedObjectDelegate();
    virtual ~Cm0ProposedImpactedObjectDelegate();
    static void setInstance( Cm0ProposedImpactedObjectDelegate*  instance );


private:
    friend class  ::Teamcenter::CM::Cm0ProposedImpactedObjectGenImpl;

};

#include <cm/libcm_undef.h>
#endif  //  TEAMCENTER__CM__CM0PROPOSEDIMPACTEDOBJECTDELEGATE_HXX
