//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cm0RemovedLine
    Filename:   Cm0RemovedLine.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CM0REMOVEDLINE__HXX
#define TEAMCENTER__CM0REMOVEDLINE__HXX

#include <common/tc_deprecation_macros.h>
#include <bom/Fnd0AbstractProxyLine.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class Cm0RemovedLine;
}
namespace Teamcenter
{
    class Cm0RemovedLineImpl;
}
namespace Teamcenter
{
    class Cm0RemovedLineDelegate;
}
namespace Teamcenter
{
    class Cm0RemovedLineDispatch;
}
namespace Teamcenter
{
    class Cm0RemovedLineGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CM_API  Teamcenter::Cm0RemovedLine
     : public  ::Teamcenter::Fnd0AbstractProxyLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cm0RemovedLine();

    /**
     * Destructor
     */
    virtual ~Cm0RemovedLine();

private:
    //  Getter method for the Implementation Object
    Cm0RemovedLineImpl*  getCm0RemovedLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCm0RemovedLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cm0RemovedLineImpl*  m_cm0removedlineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cm0RemovedLine - desc for Cm0RemovedLine parameter
     */
    Cm0RemovedLine( const Cm0RemovedLine& );
    Cm0RemovedLine& operator=( const Cm0RemovedLine& );

    friend class  Cm0RemovedLineDelegate;
    friend class  Cm0RemovedLineDispatch;
    friend class  Cm0RemovedLineGenImpl;
};

#include <cm/libcm_undef.h>
#endif //   TEAMCENTER__CM0REMOVEDLINE__HXX
