//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, GnChangeNotice
    Filename:   GnChangeNotice.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__GNCHANGENOTICE__HXX
#define TEAMCENTER__GNCHANGENOTICE__HXX

#include <common/tc_deprecation_macros.h>
#include <cm/ChangeItem.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class GnChangeNotice;
}
namespace Teamcenter
{
    class GnChangeNoticeImpl;
}
namespace Teamcenter
{
    class GnChangeNoticeDelegate;
}
namespace Teamcenter
{
    class GnChangeNoticeDispatch;
}
namespace Teamcenter
{
    class GnChangeNoticeGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CM_API  Teamcenter::GnChangeNotice
     : public  ::Teamcenter::ChangeItem
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    GnChangeNotice();

    /**
     * Destructor
     */
    virtual ~GnChangeNotice();

private:
    //  Getter method for the Implementation Object
    GnChangeNoticeImpl*  getGnChangeNoticeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setGnChangeNoticeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    GnChangeNoticeImpl*  m_gnchangenoticeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param GnChangeNotice - desc for GnChangeNotice parameter
     */
    GnChangeNotice( const GnChangeNotice& );
    GnChangeNotice& operator=( const GnChangeNotice& );

    friend class  GnChangeNoticeDelegate;
    friend class  GnChangeNoticeDispatch;
    friend class  GnChangeNoticeGenImpl;
};

#include <cm/libcm_undef.h>
#endif //   TEAMCENTER__GNCHANGENOTICE__HXX
