//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, GnChangeNoticeDelegate
    Filename:   GnChangeNoticeDelegate.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__GNCHANGENOTICEDELEGATE_HXX
#define TEAMCENTER__GNCHANGENOTICEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cm/GnChangeNotice.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class GnChangeNoticeDelegate;
}
namespace Teamcenter
{
    class GnChangeNoticeImpl;
}
namespace Teamcenter
{
    class GnChangeNotice;
}
namespace Teamcenter
{
    class GnChangeNoticeGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CM_API Teamcenter_alias::GnChangeNoticeDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the GnChangeNoticeDelegate instance
    static GnChangeNoticeDelegate&  getInstance();

    //  Method to create the GnChangeNoticeImpl pointer
    static GnChangeNoticeImpl*  createImpl( GnChangeNotice&  ifObj );

    //  Method to delete the GnChangeNoticeImpl pointer
    static void deleteImpl( GnChangeNoticeImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be created
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0ValidateCreateInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const GnChangeNotice &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static GnChangeNoticeDelegate*  m_pInstance;

    GnChangeNoticeDelegate();
    virtual ~GnChangeNoticeDelegate();
    static void setInstance( GnChangeNoticeDelegate*  instance );


private:
    friend class  ::Teamcenter::GnChangeNoticeGenImpl;

};

#include <cm/libcm_undef.h>
#endif  //  TEAMCENTER__GNCHANGENOTICEDELEGATE_HXX
