//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, GnChangeNoticeRevision
    Filename:   GnChangeNoticeRevision.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__GNCHANGENOTICEREVISION__HXX
#define TEAMCENTER__GNCHANGENOTICEREVISION__HXX

#include <string>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <cm/ChangeItemRevision.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class GnChangeNoticeRevision;
}
namespace Teamcenter
{
    class GnChangeNoticeRevisionImpl;
}
namespace Teamcenter
{
    class GnChangeNoticeRevisionDelegate;
}
namespace Teamcenter
{
    class GnChangeNoticeRevisionDispatch;
}
namespace Teamcenter
{
    class GnChangeNoticeRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CM_API  Teamcenter::GnChangeNoticeRevision
     : public  ::Teamcenter::ChangeItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.6
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCm0EffectivityFormula( std::string &value, bool &isNull ) const;

    ///
    /// Getter for Property Display Value
    /// @version Teamcenter 11.6
    /// @param values - Parameter value
    /// @return - Status. 0 if successful
    ///
    int  getCm0EffectivityFormulaDisplayableValues( std::vector< std::string > &values );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    GnChangeNoticeRevision();

    /**
     * Destructor
     */
    virtual ~GnChangeNoticeRevision();

private:
    //  Getter method for the Implementation Object
    GnChangeNoticeRevisionImpl*  getGnChangeNoticeRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setGnChangeNoticeRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    GnChangeNoticeRevisionImpl*  m_gnchangenoticerevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param GnChangeNoticeRevision - desc for GnChangeNoticeRevision parameter
     */
    GnChangeNoticeRevision( const GnChangeNoticeRevision& );
    GnChangeNoticeRevision& operator=( const GnChangeNoticeRevision& );

    friend class  GnChangeNoticeRevisionDelegate;
    friend class  GnChangeNoticeRevisionDispatch;
    friend class  GnChangeNoticeRevisionGenImpl;
};

#include <cm/libcm_undef.h>
#endif //   TEAMCENTER__GNCHANGENOTICEREVISION__HXX
