//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, GnChangeNoticeRevisionDelegate
    Filename:   GnChangeNoticeRevisionDelegate.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__GNCHANGENOTICEREVISIONDELEGATE_HXX
#define TEAMCENTER__GNCHANGENOTICEREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cm/GnChangeNoticeRevision.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class GnChangeNoticeRevisionDelegate;
}
namespace Teamcenter
{
    class GnChangeNoticeRevisionImpl;
}
namespace Teamcenter
{
    class GnChangeNoticeRevision;
}
namespace Teamcenter
{
    class GnChangeNoticeRevisionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CM_API Teamcenter_alias::GnChangeNoticeRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the GnChangeNoticeRevisionDelegate instance
    static GnChangeNoticeRevisionDelegate&  getInstance();

    //  Method to create the GnChangeNoticeRevisionImpl pointer
    static GnChangeNoticeRevisionImpl*  createImpl( GnChangeNoticeRevision&  ifObj );

    //  Method to delete the GnChangeNoticeRevisionImpl pointer
    static void deleteImpl( GnChangeNoticeRevisionImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.6
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCm0EffectivityFormulaBase(const GnChangeNoticeRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for Property Display Value
    /// @version Teamcenter 11.6
    /// @param values - Parameter value
    /// @return - Status. 0 if successful
    ///
    int  getCm0EffectivityFormulaDisplayableValuesBase(GnChangeNoticeRevision &ifObj,  std::vector< std::string > &values );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const GnChangeNoticeRevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0CreatePostBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static GnChangeNoticeRevisionDelegate*  m_pInstance;

    GnChangeNoticeRevisionDelegate();
    virtual ~GnChangeNoticeRevisionDelegate();
    static void setInstance( GnChangeNoticeRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::GnChangeNoticeRevisionGenImpl;

};

#include <cm/libcm_undef.h>
#endif  //  TEAMCENTER__GNCHANGENOTICEREVISIONDELEGATE_HXX
