//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, GnChangeRequest
    Filename:   GnChangeRequest.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__GNCHANGEREQUEST__HXX
#define TEAMCENTER__GNCHANGEREQUEST__HXX

#include <common/tc_deprecation_macros.h>
#include <cm/ChangeItem.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class GnChangeRequest;
}
namespace Teamcenter
{
    class GnChangeRequestImpl;
}
namespace Teamcenter
{
    class GnChangeRequestDelegate;
}
namespace Teamcenter
{
    class GnChangeRequestDispatch;
}
namespace Teamcenter
{
    class GnChangeRequestGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CM_API  Teamcenter::GnChangeRequest
     : public  ::Teamcenter::ChangeItem
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    GnChangeRequest();

    /**
     * Destructor
     */
    virtual ~GnChangeRequest();

private:
    //  Getter method for the Implementation Object
    GnChangeRequestImpl*  getGnChangeRequestImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setGnChangeRequestImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    GnChangeRequestImpl*  m_gnchangerequestImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param GnChangeRequest - desc for GnChangeRequest parameter
     */
    GnChangeRequest( const GnChangeRequest& );
    GnChangeRequest& operator=( const GnChangeRequest& );

    friend class  GnChangeRequestDelegate;
    friend class  GnChangeRequestDispatch;
    friend class  GnChangeRequestGenImpl;
};

#include <cm/libcm_undef.h>
#endif //   TEAMCENTER__GNCHANGEREQUEST__HXX
