//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, GnChangeRequestDelegate
    Filename:   GnChangeRequestDelegate.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__GNCHANGEREQUESTDELEGATE_HXX
#define TEAMCENTER__GNCHANGEREQUESTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cm/GnChangeRequest.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class GnChangeRequestDelegate;
}
namespace Teamcenter
{
    class GnChangeRequestImpl;
}
namespace Teamcenter
{
    class GnChangeRequest;
}
namespace Teamcenter
{
    class GnChangeRequestGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CM_API Teamcenter_alias::GnChangeRequestDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the GnChangeRequestDelegate instance
    static GnChangeRequestDelegate&  getInstance();

    //  Method to create the GnChangeRequestImpl pointer
    static GnChangeRequestImpl*  createImpl( GnChangeRequest&  ifObj );

    //  Method to delete the GnChangeRequestImpl pointer
    static void deleteImpl( GnChangeRequestImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be created
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0ValidateCreateInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const GnChangeRequest &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static GnChangeRequestDelegate*  m_pInstance;

    GnChangeRequestDelegate();
    virtual ~GnChangeRequestDelegate();
    static void setInstance( GnChangeRequestDelegate*  instance );


private:
    friend class  ::Teamcenter::GnChangeRequestGenImpl;

};

#include <cm/libcm_undef.h>
#endif  //  TEAMCENTER__GNCHANGEREQUESTDELEGATE_HXX
