//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, GnChangeRequestRevision
    Filename:   GnChangeRequestRevision.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__GNCHANGEREQUESTREVISION__HXX
#define TEAMCENTER__GNCHANGEREQUESTREVISION__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <cm/ChangeItemRevision.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class GnChangeRequestRevision;
}
namespace Teamcenter
{
    class GnChangeRequestRevisionImpl;
}
namespace Teamcenter
{
    class GnChangeRequestRevisionDelegate;
}
namespace Teamcenter
{
    class GnChangeRequestRevisionDispatch;
}
namespace Teamcenter
{
    class GnChangeRequestRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CM_API  Teamcenter::GnChangeRequestRevision
     : public  ::Teamcenter::ChangeItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCMIsFastTrack( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCMIsFastTrack( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    GnChangeRequestRevision();

    /**
     * Destructor
     */
    virtual ~GnChangeRequestRevision();

private:
    //  Getter method for the Implementation Object
    GnChangeRequestRevisionImpl*  getGnChangeRequestRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setGnChangeRequestRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    GnChangeRequestRevisionImpl*  m_gnchangerequestrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param GnChangeRequestRevision - desc for GnChangeRequestRevision parameter
     */
    GnChangeRequestRevision( const GnChangeRequestRevision& );
    GnChangeRequestRevision& operator=( const GnChangeRequestRevision& );

    friend class  GnChangeRequestRevisionDelegate;
    friend class  GnChangeRequestRevisionDispatch;
    friend class  GnChangeRequestRevisionGenImpl;
};

#include <cm/libcm_undef.h>
#endif //   TEAMCENTER__GNCHANGEREQUESTREVISION__HXX
