//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, GnChangeRequestRevisionDelegate
    Filename:   GnChangeRequestRevisionDelegate.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__GNCHANGEREQUESTREVISIONDELEGATE_HXX
#define TEAMCENTER__GNCHANGEREQUESTREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cm/GnChangeRequestRevision.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class GnChangeRequestRevisionDelegate;
}
namespace Teamcenter
{
    class GnChangeRequestRevisionImpl;
}
namespace Teamcenter
{
    class GnChangeRequestRevision;
}
namespace Teamcenter
{
    class GnChangeRequestRevisionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CM_API Teamcenter_alias::GnChangeRequestRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the GnChangeRequestRevisionDelegate instance
    static GnChangeRequestRevisionDelegate&  getInstance();

    //  Method to create the GnChangeRequestRevisionImpl pointer
    static GnChangeRequestRevisionImpl*  createImpl( GnChangeRequestRevision&  ifObj );

    //  Method to delete the GnChangeRequestRevisionImpl pointer
    static void deleteImpl( GnChangeRequestRevisionImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCMIsFastTrackBase(const GnChangeRequestRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCMIsFastTrackBase(GnChangeRequestRevision &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static GnChangeRequestRevisionDelegate*  m_pInstance;

    GnChangeRequestRevisionDelegate();
    virtual ~GnChangeRequestRevisionDelegate();
    static void setInstance( GnChangeRequestRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::GnChangeRequestRevisionGenImpl;

};

#include <cm/libcm_undef.h>
#endif  //  TEAMCENTER__GNCHANGEREQUESTREVISIONDELEGATE_HXX
