//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, GnProblemReport
    Filename:   GnProblemReport.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__GNPROBLEMREPORT__HXX
#define TEAMCENTER__GNPROBLEMREPORT__HXX

#include <common/tc_deprecation_macros.h>
#include <cm/ChangeItem.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class GnProblemReport;
}
namespace Teamcenter
{
    class GnProblemReportImpl;
}
namespace Teamcenter
{
    class GnProblemReportDelegate;
}
namespace Teamcenter
{
    class GnProblemReportDispatch;
}
namespace Teamcenter
{
    class GnProblemReportGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CM_API  Teamcenter::GnProblemReport
     : public  ::Teamcenter::ChangeItem
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    GnProblemReport();

    /**
     * Destructor
     */
    virtual ~GnProblemReport();

private:
    //  Getter method for the Implementation Object
    GnProblemReportImpl*  getGnProblemReportImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setGnProblemReportImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    GnProblemReportImpl*  m_gnproblemreportImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param GnProblemReport - desc for GnProblemReport parameter
     */
    GnProblemReport( const GnProblemReport& );
    GnProblemReport& operator=( const GnProblemReport& );

    friend class  GnProblemReportDelegate;
    friend class  GnProblemReportDispatch;
    friend class  GnProblemReportGenImpl;
};

#include <cm/libcm_undef.h>
#endif //   TEAMCENTER__GNPROBLEMREPORT__HXX
