//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, GnProblemReportRevision
    Filename:   GnProblemReportRevision.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__GNPROBLEMREPORTREVISION__HXX
#define TEAMCENTER__GNPROBLEMREPORTREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <cm/ChangeItemRevision.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class GnProblemReportRevision;
}
namespace Teamcenter
{
    class GnProblemReportRevisionImpl;
}
namespace Teamcenter
{
    class GnProblemReportRevisionDelegate;
}
namespace Teamcenter
{
    class GnProblemReportRevisionDispatch;
}
namespace Teamcenter
{
    class GnProblemReportRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CM_API  Teamcenter::GnProblemReportRevision
     : public  ::Teamcenter::ChangeItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    GnProblemReportRevision();

    /**
     * Destructor
     */
    virtual ~GnProblemReportRevision();

private:
    //  Getter method for the Implementation Object
    GnProblemReportRevisionImpl*  getGnProblemReportRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setGnProblemReportRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    GnProblemReportRevisionImpl*  m_gnproblemreportrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param GnProblemReportRevision - desc for GnProblemReportRevision parameter
     */
    GnProblemReportRevision( const GnProblemReportRevision& );
    GnProblemReportRevision& operator=( const GnProblemReportRevision& );

    friend class  GnProblemReportRevisionDelegate;
    friend class  GnProblemReportRevisionDispatch;
    friend class  GnProblemReportRevisionGenImpl;
};

#include <cm/libcm_undef.h>
#endif //   TEAMCENTER__GNPROBLEMREPORTREVISION__HXX
