//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ItemRevisionDelegate
    Filename:   ItemRevisionDelegateExt.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CM0__TEAMCENTER__CM__ITEMREVISIONDELEGATE_HXX
#define CM0__TEAMCENTER__CM__ITEMREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cm/ItemRevisionExt.hxx>

#include <cm/libcm_exports.h>

namespace cm0
{
    namespace Teamcenter
    {
        namespace CM
        {
            class ItemRevisionDelegate;
        }
    }
}
namespace cm0
{
    namespace Teamcenter
    {
        namespace CM
        {
            class ItemRevisionImpl;
        }
    }
}
namespace cm0
{
    namespace Teamcenter
    {
        namespace CM
        {
            class ItemRevision;
        }
    }
}
namespace cm0
{
    namespace Teamcenter
    {
        namespace CM
        {
            class ItemRevisionGenImpl;
        }
    }
}

namespace cm0_alias = ::cm0;


class  CM_API cm0_alias::Teamcenter::CM::ItemRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ItemRevisionDelegate instance
    static ItemRevisionDelegate&  getInstance();

    //  Method to create the ItemRevisionImpl pointer
    static ItemRevisionImpl*  createImpl( ItemRevision&  ifObj );

    //  Method to delete the ItemRevisionImpl pointer
    static void deleteImpl( ItemRevisionImpl*  impl );


    ///
    /// This operation takes the objects to process and returns probable impacted items as output.
    /// @version Teamcenter 12.2
    /// @param changeItemRevision - Change Item Revision
    /// @param relatedObjectsToProcess - Related objects to be processed
    /// @param extraOptionsToConsider - Extra options to consider while calculating impacted objects.
    /// @param probableImpactedItems - Probable Impacted Items
    /// @return - Returns vector of probable impacted items.
    ///
    int  cm0GetImpactedObjectsBase(const ItemRevision &ifObj,  const tag_t &changeItemRevision, std::vector< tag_t > &relatedObjectsToProcess, const std::map< std::string,std::string > &extraOptionsToConsider, std::vector< tag_t > &probableImpactedItems );



protected:
    //  Pointer to the instance
    static ItemRevisionDelegate*  m_pInstance;

    ItemRevisionDelegate();
    virtual ~ItemRevisionDelegate();
    static void setInstance( ItemRevisionDelegate*  instance );


private:
    friend class  ::cm0::Teamcenter::CM::ItemRevisionGenImpl;

};

#include <cm/libcm_undef.h>
#endif  //  CM0__TEAMCENTER__CM__ITEMREVISIONDELEGATE_HXX
