//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ItemRevision
    Filename:   ItemRevisionExt.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CM0__TEAMCENTER__CM__ITEMREVISION__HXX
#define CM0__TEAMCENTER__CM__ITEMREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <cm/WorkspaceObjectExt.hxx>
#include <metaframework/BusinessObjectExtenderRef.hxx>
#include <metaframework/BusinessObjectExtenderRegistry.hxx>

#include <cm/libcm_exports.h>

namespace cm0
{
    namespace Teamcenter
    {
        namespace CM
        {
            class ItemRevision;
        }
    }
}
namespace cm0
{
    namespace Teamcenter
    {
        namespace CM
        {
            class ItemRevisionImpl;
        }
    }
}
namespace cm0
{
    namespace Teamcenter
    {
        namespace CM
        {
            class ItemRevisionDelegate;
        }
    }
}
namespace cm0
{
    namespace Teamcenter
    {
        namespace CM
        {
            class ItemRevisionDispatch;
        }
    }
}
namespace cm0
{
    namespace Teamcenter
    {
        namespace CM
        {
            class ItemRevisionGenImpl;
        }
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CM_API  cm0::Teamcenter::CM::ItemRevision
     : public  ::cm0::Teamcenter::CM::WorkspaceObject
{
public:

    /**
     * Constructor
     */
    ItemRevision( tag_t  objTag );
    /**
     * Get the Extender Registry
     * @return - return Extender Registry
     */
    static ::Teamcenter::BusinessObjectExtenderRegistry< cm0::Teamcenter::CM::ItemRevision >&  extenderRegistry();

    /**
     * Get the Extender Interface Name
     * @return - return desc for getExtenderInterfaceName
     */
    static const std::string&  getExtenderInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );


    /**
     * Destructor
     */
    virtual ~ItemRevision();

private:
    //  Getter method for the Implementation Object
    ItemRevisionImpl*  getItemRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setItemRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ItemRevisionImpl*  m_itemrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ItemRevision - desc for ItemRevision parameter
     */
    ItemRevision( const ItemRevision& );
    ItemRevision& operator=( const ItemRevision& );

    friend class  ItemRevisionDelegate;
    friend class  ItemRevisionDispatch;
    friend class  ItemRevisionGenImpl;
    friend class  ItemRevisionImpl;
};

#include <cm/libcm_undef.h>
#endif //   CM0__TEAMCENTER__CM__ITEMREVISION__HXX
