//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ProblemReport
    Filename:   ProblemReport.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROBLEMREPORT__HXX
#define TEAMCENTER__PROBLEMREPORT__HXX

#include <common/tc_deprecation_macros.h>
#include <cm/GnProblemReport.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class ProblemReport;
}
namespace Teamcenter
{
    class ProblemReportImpl;
}
namespace Teamcenter
{
    class ProblemReportDelegate;
}
namespace Teamcenter
{
    class ProblemReportDispatch;
}
namespace Teamcenter
{
    class ProblemReportGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CM_API  Teamcenter::ProblemReport
     : public  ::Teamcenter::GnProblemReport
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ProblemReport();

    /**
     * Destructor
     */
    virtual ~ProblemReport();

private:
    //  Getter method for the Implementation Object
    ProblemReportImpl*  getProblemReportImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setProblemReportImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ProblemReportImpl*  m_problemreportImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ProblemReport - desc for ProblemReport parameter
     */
    ProblemReport( const ProblemReport& );
    ProblemReport& operator=( const ProblemReport& );

    friend class  ProblemReportDelegate;
    friend class  ProblemReportDispatch;
    friend class  ProblemReportGenImpl;
};

#include <cm/libcm_undef.h>
#endif //   TEAMCENTER__PROBLEMREPORT__HXX
