//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ProblemReportRevisionDelegate
    Filename:   ProblemReportRevisionDelegate.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROBLEMREPORTREVISIONDELEGATE_HXX
#define TEAMCENTER__PROBLEMREPORTREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cm/ProblemReportRevision.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class ProblemReportRevisionDelegate;
}
namespace Teamcenter
{
    class ProblemReportRevisionImpl;
}
namespace Teamcenter
{
    class ProblemReportRevision;
}
namespace Teamcenter
{
    class ProblemReportRevisionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CM_API Teamcenter_alias::ProblemReportRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ProblemReportRevisionDelegate instance
    static ProblemReportRevisionDelegate&  getInstance();

    //  Method to create the ProblemReportRevisionImpl pointer
    static ProblemReportRevisionImpl*  createImpl( ProblemReportRevision&  ifObj );

    //  Method to delete the ProblemReportRevisionImpl pointer
    static void deleteImpl( ProblemReportRevisionImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCMEnvironmentDescriptionBase(const ProblemReportRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCMRamificationBase(const ProblemReportRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCMSequenceOfEventsBase(const ProblemReportRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCMSeverityRatingBase(const ProblemReportRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCMTechReviewPriorityBase(const ProblemReportRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCMVerificationBase(const ProblemReportRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCMEnvironmentDescriptionBase(ProblemReportRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCMRamificationBase(ProblemReportRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCMSequenceOfEventsBase(ProblemReportRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCMSeverityRatingBase(ProblemReportRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCMTechReviewPriorityBase(ProblemReportRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCMVerificationBase(ProblemReportRevision &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static ProblemReportRevisionDelegate*  m_pInstance;

    ProblemReportRevisionDelegate();
    virtual ~ProblemReportRevisionDelegate();
    static void setInstance( ProblemReportRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::ProblemReportRevisionGenImpl;

};

#include <cm/libcm_undef.h>
#endif  //  TEAMCENTER__PROBLEMREPORTREVISIONDELEGATE_HXX
