//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Requestor
    Filename:   Requestor.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REQUESTOR__HXX
#define TEAMCENTER__REQUESTOR__HXX

#include <common/tc_deprecation_macros.h>
#include <epm/Participant.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class Requestor;
}
namespace Teamcenter
{
    class RequestorImpl;
}
namespace Teamcenter
{
    class RequestorDelegate;
}
namespace Teamcenter
{
    class RequestorDispatch;
}
namespace Teamcenter
{
    class RequestorGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CM_API  Teamcenter::Requestor
     : public  ::Teamcenter::Participant
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Requestor();

    /**
     * Destructor
     */
    virtual ~Requestor();

private:
    //  Getter method for the Implementation Object
    RequestorImpl*  getRequestorImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRequestorImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    RequestorImpl*  m_requestorImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Requestor - desc for Requestor parameter
     */
    Requestor( const Requestor& );
    Requestor& operator=( const Requestor& );

    friend class  RequestorDelegate;
    friend class  RequestorDispatch;
    friend class  RequestorGenImpl;
};

#include <cm/libcm_undef.h>
#endif //   TEAMCENTER__REQUESTOR__HXX
