//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RequestorDelegate
    Filename:   RequestorDelegate.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REQUESTORDELEGATE_HXX
#define TEAMCENTER__REQUESTORDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cm/Requestor.hxx>

#include <cm/libcm_exports.h>

namespace Teamcenter
{
    class RequestorDelegate;
}
namespace Teamcenter
{
    class RequestorImpl;
}
namespace Teamcenter
{
    class Requestor;
}
namespace Teamcenter
{
    class RequestorGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CM_API Teamcenter_alias::RequestorDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the RequestorDelegate instance
    static RequestorDelegate&  getInstance();

    //  Method to create the RequestorImpl pointer
    static RequestorImpl*  createImpl( Requestor&  ifObj );

    //  Method to delete the RequestorImpl pointer
    static void deleteImpl( RequestorImpl*  impl );


    ///
    /// This operation determines if the participant is assignable.
    /// @version Tc 8
    /// @param user - A user tag
    /// @param object - An object tag
    /// @param assignable - A pointer to a boolean whose value, when returned, is the result of the evaluation
    /// @return - An ifail integer
    ///
    int  isAssignableBase(const Requestor &ifObj,  tag_t user, tag_t object, bool *assignable );



protected:
    //  Pointer to the instance
    static RequestorDelegate*  m_pInstance;

    RequestorDelegate();
    virtual ~RequestorDelegate();
    static void setInstance( RequestorDelegate*  instance );


private:
    friend class  ::Teamcenter::RequestorGenImpl;

};

#include <cm/libcm_undef.h>
#endif  //  TEAMCENTER__REQUESTORDELEGATE_HXX
