//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, UserSessionDelegate
    Filename:   UserSessionDelegateExt.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CM0__TEAMCENTER__CM__USERSESSIONDELEGATE_HXX
#define CM0__TEAMCENTER__CM__USERSESSIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cm/UserSessionExt.hxx>

#include <cm/libcm_exports.h>

namespace cm0
{
    namespace Teamcenter
    {
        namespace CM
        {
            class UserSessionDelegate;
        }
    }
}
namespace cm0
{
    namespace Teamcenter
    {
        namespace CM
        {
            class UserSessionImpl;
        }
    }
}
namespace cm0
{
    namespace Teamcenter
    {
        namespace CM
        {
            class UserSession;
        }
    }
}
namespace cm0
{
    namespace Teamcenter
    {
        namespace CM
        {
            class UserSessionGenImpl;
        }
    }
}

namespace cm0_alias = ::cm0;


class  CM_API cm0_alias::Teamcenter::CM::UserSessionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the UserSessionDelegate instance
    static UserSessionDelegate&  getInstance();

    //  Method to create the UserSessionImpl pointer
    static UserSessionImpl*  createImpl( UserSession&  ifObj );

    //  Method to delete the UserSessionImpl pointer
    static void deleteImpl( UserSessionImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCm0GlobalChangeContextBase(const UserSession &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.5
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCm0GlobalChangeContextBase(UserSession &ifObj,  const tag_t &value, bool isNull );



protected:
    //  Pointer to the instance
    static UserSessionDelegate*  m_pInstance;

    UserSessionDelegate();
    virtual ~UserSessionDelegate();
    static void setInstance( UserSessionDelegate*  instance );


private:
    friend class  ::cm0::Teamcenter::CM::UserSessionGenImpl;

};

#include <cm/libcm_undef.h>
#endif  //  CM0__TEAMCENTER__CM__USERSESSIONDELEGATE_HXX
