//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, WorkspaceObjectDelegate
    Filename:   WorkspaceObjectDelegateExt.hxx
    Module:     cm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CM0__TEAMCENTER__CM__WORKSPACEOBJECTDELEGATE_HXX
#define CM0__TEAMCENTER__CM__WORKSPACEOBJECTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cm/WorkspaceObjectExt.hxx>

#include <cm/libcm_exports.h>

namespace cm0
{
    namespace Teamcenter
    {
        namespace CM
        {
            class WorkspaceObjectDelegate;
        }
    }
}
namespace cm0
{
    namespace Teamcenter
    {
        namespace CM
        {
            class WorkspaceObjectImpl;
        }
    }
}
namespace cm0
{
    namespace Teamcenter
    {
        namespace CM
        {
            class WorkspaceObject;
        }
    }
}
namespace cm0
{
    namespace Teamcenter
    {
        namespace CM
        {
            class WorkspaceObjectGenImpl;
        }
    }
}

namespace cm0_alias = ::cm0;


class  CM_API cm0_alias::Teamcenter::CM::WorkspaceObjectDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the WorkspaceObjectDelegate instance
    static WorkspaceObjectDelegate&  getInstance();

    //  Method to create the WorkspaceObjectImpl pointer
    static WorkspaceObjectImpl*  createImpl( WorkspaceObject&  ifObj );

    //  Method to delete the WorkspaceObjectImpl pointer
    static void deleteImpl( WorkspaceObjectImpl*  impl );


    ///
    /// This operation takes the objects to process and returns probable impacted items as output.
    /// @version Teamcenter 12.2
    /// @param changeItemRevision - Change Item Revision
    /// @param relatedObjectsToProcess - Related objects to be processed
    /// @param extraOptionsToConsider - Extra options to consider while calculating impacted objects.
    /// @param probableImpactedItems - Probable Impacted Items
    /// @return - Returns vector of probable impacted items.
    ///
    int  cm0GetImpactedObjectsBase(const WorkspaceObject &ifObj,  const tag_t &changeItemRevision, std::vector< tag_t > &relatedObjectsToProcess, const std::map< std::string,std::string > &extraOptionsToConsider, std::vector< tag_t > &probableImpactedItems );



protected:
    //  Pointer to the instance
    static WorkspaceObjectDelegate*  m_pInstance;

    WorkspaceObjectDelegate();
    virtual ~WorkspaceObjectDelegate();
    static void setInstance( WorkspaceObjectDelegate*  instance );


private:
    friend class  ::cm0::Teamcenter::CM::WorkspaceObjectGenImpl;

};

#include <cm/libcm_undef.h>
#endif  //  CM0__TEAMCENTER__CM__WORKSPACEOBJECTDELEGATE_HXX
