//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AnalystDispatch
    Filename:   AnalystDispatch.hxx
    Module:     cmdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ANALYSTDISPATCH_HXX
#define TEAMCENTER__ANALYSTDISPATCH_HXX

#include <vector>
#include <cm/Analyst.hxx>
#include <cm/AnalystDelegate.hxx>
#include <foundationdispatch/ParticipantDispatch.hxx>
#include <cmdispatch/initializecm.hxx>

#include <cmdispatch/libcmdispatch_exports.h>

namespace Teamcenter
{
    class AnalystDispatch;
}
namespace Teamcenter
{
    class AnalystDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  CMDISPATCH_API  Teamcenter::AnalystDispatch
    : public  Teamcenter::AnalystDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the AnalystDispatch instance
    static AnalystDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static AnalystDispatch*  m_dispatch;

    //  Default Constructor
    AnalystDispatch();

    //  Default Destructor
    virtual ~AnalystDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a AnalystDispatch
    AnalystDispatch( const AnalystDispatch& );

    //  Assignment operator
    AnalystDispatch&  operator = ( const AnalystDispatch& );

    //  friend
    friend void   ::Teamcenter::CM::initializecmInternal();
    friend void   ::Teamcenter::CM::initializecmExtenders();
    friend class  Teamcenter::AnalystDelegate;
};

#include <cmdispatch/libcmdispatch_undef.h>
#endif  //  TEAMCENTER__ANALYSTDISPATCH_HXX
