//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ChangeRequestDispatch
    Filename:   ChangeRequestDispatch.hxx
    Module:     cmdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CHANGEREQUESTDISPATCH_HXX
#define TEAMCENTER__CHANGEREQUESTDISPATCH_HXX

#include <vector>
#include <cm/ChangeRequest.hxx>
#include <cm/ChangeRequestDelegate.hxx>
#include <cmdispatch/GnChangeRequestDispatch.hxx>
#include <cmdispatch/initializecm.hxx>

#include <cmdispatch/libcmdispatch_exports.h>

namespace Teamcenter
{
    class ChangeRequestDispatch;
}
namespace Teamcenter
{
    class ChangeRequestDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  CMDISPATCH_API  Teamcenter::ChangeRequestDispatch
    : public  Teamcenter::ChangeRequestDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ChangeRequestDispatch instance
    static ChangeRequestDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static ChangeRequestDispatch*  m_dispatch;

    //  Default Constructor
    ChangeRequestDispatch();

    //  Default Destructor
    virtual ~ChangeRequestDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a ChangeRequestDispatch
    ChangeRequestDispatch( const ChangeRequestDispatch& );

    //  Assignment operator
    ChangeRequestDispatch&  operator = ( const ChangeRequestDispatch& );

    //  friend
    friend void   ::Teamcenter::CM::initializecmInternal();
    friend void   ::Teamcenter::CM::initializecmExtenders();
    friend class  Teamcenter::ChangeRequestDelegate;
};

#include <cmdispatch/libcmdispatch_undef.h>
#endif  //  TEAMCENTER__CHANGEREQUESTDISPATCH_HXX
