//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RequestorDispatch
    Filename:   RequestorDispatch.hxx
    Module:     cmdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REQUESTORDISPATCH_HXX
#define TEAMCENTER__REQUESTORDISPATCH_HXX

#include <vector>
#include <cm/Requestor.hxx>
#include <cm/RequestorDelegate.hxx>
#include <foundationdispatch/ParticipantDispatch.hxx>
#include <cmdispatch/initializecm.hxx>

#include <cmdispatch/libcmdispatch_exports.h>

namespace Teamcenter
{
    class RequestorDispatch;
}
namespace Teamcenter
{
    class RequestorDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  CMDISPATCH_API  Teamcenter::RequestorDispatch
    : public  Teamcenter::RequestorDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the RequestorDispatch instance
    static RequestorDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static RequestorDispatch*  m_dispatch;

    //  Default Constructor
    RequestorDispatch();

    //  Default Destructor
    virtual ~RequestorDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a RequestorDispatch
    RequestorDispatch( const RequestorDispatch& );

    //  Assignment operator
    RequestorDispatch&  operator = ( const RequestorDispatch& );

    //  friend
    friend void   ::Teamcenter::CM::initializecmInternal();
    friend void   ::Teamcenter::CM::initializecmExtenders();
    friend class  Teamcenter::RequestorDelegate;
};

#include <cmdispatch/libcmdispatch_undef.h>
#endif  //  TEAMCENTER__REQUESTORDISPATCH_HXX
