//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, UserSessionDispatch
    Filename:   UserSessionDispatchExt.hxx
    Module:     cmdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CM0__TEAMCENTER__CM__USERSESSIONDISPATCH_HXX
#define CM0__TEAMCENTER__CM__USERSESSIONDISPATCH_HXX

#include <vector>
#include <cm/UserSessionExt.hxx>
#include <cm/UserSessionDelegateExt.hxx>
#include <cmdispatch/initializecm.hxx>
#include <extensionframework/OperationDispatcher.hxx>
#include <metaframework/OperationObjectBatch.hxx>
#include <metaframework/PostActionInternalHandler.hxx>
#include <metaframework/ManageBulkData.hxx>

#include <cmdispatch/libcmdispatch_exports.h>

namespace cm0
{
    namespace Teamcenter
    {
        namespace CM
        {
            class UserSessionDispatch;
        }
    }
}
namespace cm0
{
    namespace Teamcenter
    {
        namespace CM
        {
            class UserSessionDelegate;
        }
    }
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  CMDISPATCH_API  cm0::Teamcenter::CM::UserSessionDispatch
    : public  cm0::Teamcenter::CM::UserSessionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the UserSessionDispatch instance
    static UserSessionDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static UserSessionDispatch*  m_dispatch;

    //  Default Constructor
    UserSessionDispatch();

    //  Default Destructor
    virtual ~UserSessionDispatch();

    //  Constructor Method
    static ::Teamcenter::BusinessObjectExtender*  constructor( tag_t objTag );

    //  Copy Constructor for a UserSessionDispatch
    UserSessionDispatch( const UserSessionDispatch& );

    //  Assignment operator
    UserSessionDispatch&  operator = ( const UserSessionDispatch& );

    //  friend
    friend void   ::Teamcenter::CM::initializecmInternal();
    friend void   ::Teamcenter::CM::initializecmExtenders();
    friend class  cm0::Teamcenter::CM::UserSessionDelegate;
};

#include <cmdispatch/libcmdispatch_undef.h>
#endif  //  CM0__TEAMCENTER__CM__USERSESSIONDISPATCH_HXX
