//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, WorkspaceObjectDispatch
    Filename:   WorkspaceObjectDispatchExt.hxx
    Module:     cmdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CM0__TEAMCENTER__CM__WORKSPACEOBJECTDISPATCH_HXX
#define CM0__TEAMCENTER__CM__WORKSPACEOBJECTDISPATCH_HXX

#include <vector>
#include <cm/WorkspaceObjectExt.hxx>
#include <cm/WorkspaceObjectDelegateExt.hxx>
#include <cmdispatch/initializecm.hxx>
#include <extensionframework/OperationDispatcher.hxx>
#include <metaframework/OperationObjectBatch.hxx>
#include <metaframework/PostActionInternalHandler.hxx>
#include <metaframework/ManageBulkData.hxx>

#include <cmdispatch/libcmdispatch_exports.h>

namespace cm0
{
    namespace Teamcenter
    {
        namespace CM
        {
            class WorkspaceObjectDispatch;
        }
    }
}
namespace cm0
{
    namespace Teamcenter
    {
        namespace CM
        {
            class WorkspaceObjectDelegate;
        }
    }
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  CMDISPATCH_API  cm0::Teamcenter::CM::WorkspaceObjectDispatch
    : public  cm0::Teamcenter::CM::WorkspaceObjectDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the WorkspaceObjectDispatch instance
    static WorkspaceObjectDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static WorkspaceObjectDispatch*  m_dispatch;

    //  Default Constructor
    WorkspaceObjectDispatch();

    //  Default Destructor
    virtual ~WorkspaceObjectDispatch();

    //  Constructor Method
    static ::Teamcenter::BusinessObjectExtender*  constructor( tag_t objTag );

    //  Copy Constructor for a WorkspaceObjectDispatch
    WorkspaceObjectDispatch( const WorkspaceObjectDispatch& );

    //  Assignment operator
    WorkspaceObjectDispatch&  operator = ( const WorkspaceObjectDispatch& );

    //  friend
    friend void   ::Teamcenter::CM::initializecmInternal();
    friend void   ::Teamcenter::CM::initializecmExtenders();
    friend class  cm0::Teamcenter::CM::WorkspaceObjectDelegate;
};

#include <cmdispatch/libcmdispatch_undef.h>
#endif  //  CM0__TEAMCENTER__CM__WORKSPACEOBJECTDISPATCH_HXX
