//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  cmdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libcmdispatch

#if !defined(LIBCMDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBCMDISPATCH is not defined
#endif

/* Handwritten code should use CMDISPATCH_API, not CMDISPATCHEXPORT */

#define CMDISPATCH_API CMDISPATCHEXPORT

#if IPLIB==libcmdispatch || defined(LIBCMDISPATCH)
#   if defined(__lint)
#       define CMDISPATCHEXPORT       __export(cmdispatch)
#       define CMDISPATCHGLOBAL       extern __global(cmdispatch)
#       define CMDISPATCHPRIVATE      extern __private(cmdispatch)
#   elif defined(_WIN32)
#       define CMDISPATCHEXPORT       __declspec(dllexport)
#       define CMDISPATCHGLOBAL       extern __declspec(dllexport)
#       define CMDISPATCHPRIVATE      extern
#   else
#       define CMDISPATCHEXPORT
#       define CMDISPATCHGLOBAL       extern
#       define CMDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CMDISPATCHEXPORT       __export(cmdispatch)
#       define CMDISPATCHGLOBAL       extern __global(cmdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CMDISPATCHEXPORT      __declspec(dllimport)
#       define CMDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define CMDISPATCHEXPORT
#       define CMDISPATCHGLOBAL       extern
#   endif
#endif
