//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  cmtmesdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libcmtmesdispatch

#if !defined(LIBCMTMESDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBCMTMESDISPATCH is not defined
#endif

/* Handwritten code should use CMTMESDISPATCH_API, not CMTMESDISPATCHEXPORT */

#define CMTMESDISPATCH_API CMTMESDISPATCHEXPORT

#if IPLIB==libcmtmesdispatch || defined(LIBCMTMESDISPATCH)
#   if defined(__lint)
#       define CMTMESDISPATCHEXPORT       __export(cmtmesdispatch)
#       define CMTMESDISPATCHGLOBAL       extern __global(cmtmesdispatch)
#       define CMTMESDISPATCHPRIVATE      extern __private(cmtmesdispatch)
#   elif defined(_WIN32)
#       define CMTMESDISPATCHEXPORT       __declspec(dllexport)
#       define CMTMESDISPATCHGLOBAL       extern __declspec(dllexport)
#       define CMTMESDISPATCHPRIVATE      extern
#   else
#       define CMTMESDISPATCHEXPORT
#       define CMTMESDISPATCHGLOBAL       extern
#       define CMTMESDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CMTMESDISPATCHEXPORT       __export(cmtmesdispatch)
#       define CMTMESDISPATCHGLOBAL       extern __global(cmtmesdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CMTMESDISPATCHEXPORT      __declspec(dllimport)
#       define CMTMESDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define CMTMESDISPATCHEXPORT
#       define CMTMESDISPATCHGLOBAL       extern
#   endif
#endif
