//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CCObject
    Filename:   CCObject.hxx
    Module:     collabctx
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CCOBJECT__HXX
#define TEAMCENTER__CCOBJECT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <collabctx/libcollabctx_exports.h>

namespace Teamcenter
{
    class CCObject;
}
namespace Teamcenter
{
    class CCObjectImpl;
}
namespace Teamcenter
{
    class CCObjectDelegate;
}
namespace Teamcenter
{
    class CCObjectDispatch;
}
namespace Teamcenter
{
    class CCObjectGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  COLLABCTX_API  Teamcenter::CCObject
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CCObject();

    /**
     * Destructor
     */
    virtual ~CCObject();

private:
    //  Getter method for the Implementation Object
    CCObjectImpl*  getCCObjectImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCCObjectImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CCObjectImpl*  m_ccobjectImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CCObject - desc for CCObject parameter
     */
    CCObject( const CCObject& );
    CCObject& operator=( const CCObject& );

    friend class  CCObjectDelegate;
    friend class  CCObjectDispatch;
    friend class  CCObjectGenImpl;
};

#include <collabctx/libcollabctx_undef.h>
#endif //   TEAMCENTER__CCOBJECT__HXX
