//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ConfigurationContext
    Filename:   ConfigurationContext.hxx
    Module:     collabctx
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONFIGURATIONCONTEXT__HXX
#define TEAMCENTER__CONFIGURATIONCONTEXT__HXX

#include <unidefs.h>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <collabctx/libcollabctx_exports.h>

namespace Teamcenter
{
    class ConfigurationContext;
}
namespace Teamcenter
{
    class ConfigurationContextImpl;
}
namespace Teamcenter
{
    class ConfigurationContextDelegate;
}
namespace Teamcenter
{
    class ConfigurationContextDispatch;
}
namespace Teamcenter
{
    class ConfigurationContextGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  COLLABCTX_API  Teamcenter::ConfigurationContext
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getActive_arrangement( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getVariant_rules( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setActive_arrangement( const tag_t &value, bool isNull=false );

    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 10.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setVariant_rules( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ConfigurationContext();

    /**
     * Destructor
     */
    virtual ~ConfigurationContext();

private:
    //  Getter method for the Implementation Object
    ConfigurationContextImpl*  getConfigurationContextImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setConfigurationContextImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ConfigurationContextImpl*  m_configurationcontextImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ConfigurationContext - desc for ConfigurationContext parameter
     */
    ConfigurationContext( const ConfigurationContext& );
    ConfigurationContext& operator=( const ConfigurationContext& );

    friend class  ConfigurationContextDelegate;
    friend class  ConfigurationContextDispatch;
    friend class  ConfigurationContextGenImpl;
};

#include <collabctx/libcollabctx_undef.h>
#endif //   TEAMCENTER__CONFIGURATIONCONTEXT__HXX
