//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ConfigurationContextDelegate
    Filename:   ConfigurationContextDelegate.hxx
    Module:     collabctx
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONFIGURATIONCONTEXTDELEGATE_HXX
#define TEAMCENTER__CONFIGURATIONCONTEXTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <collabctx/ConfigurationContext.hxx>

#include <collabctx/libcollabctx_exports.h>

namespace Teamcenter
{
    class ConfigurationContextDelegate;
}
namespace Teamcenter
{
    class ConfigurationContextImpl;
}
namespace Teamcenter
{
    class ConfigurationContext;
}
namespace Teamcenter
{
    class ConfigurationContextGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  COLLABCTX_API Teamcenter_alias::ConfigurationContextDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ConfigurationContextDelegate instance
    static ConfigurationContextDelegate&  getInstance();

    //  Method to create the ConfigurationContextImpl pointer
    static ConfigurationContextImpl*  createImpl( ConfigurationContext&  ifObj );

    //  Method to delete the ConfigurationContextImpl pointer
    static void deleteImpl( ConfigurationContextImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getActive_arrangementBase(const ConfigurationContext &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getVariant_rulesBase(const ConfigurationContext &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setActive_arrangementBase(ConfigurationContext &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 10.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setVariant_rulesBase(ConfigurationContext &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const ConfigurationContext &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static ConfigurationContextDelegate*  m_pInstance;

    ConfigurationContextDelegate();
    virtual ~ConfigurationContextDelegate();
    static void setInstance( ConfigurationContextDelegate*  instance );


private:
    friend class  ::Teamcenter::ConfigurationContextGenImpl;

};

#include <collabctx/libcollabctx_undef.h>
#endif  //  TEAMCENTER__CONFIGURATIONCONTEXTDELEGATE_HXX
