//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PrivateContext
    Filename:   PrivateContext.hxx
    Module:     collabctx
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PRIVATECONTEXT__HXX
#define TEAMCENTER__PRIVATECONTEXT__HXX

#include <common/tc_deprecation_macros.h>
#include <collabctx/StructureContext.hxx>

#include <collabctx/libcollabctx_exports.h>

namespace Teamcenter
{
    class PrivateContext;
}
namespace Teamcenter
{
    class PrivateContextImpl;
}
namespace Teamcenter
{
    class PrivateContextDelegate;
}
namespace Teamcenter
{
    class PrivateContextDispatch;
}
namespace Teamcenter
{
    class PrivateContextGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  COLLABCTX_API  Teamcenter::PrivateContext
     : public  ::Teamcenter::StructureContext
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PrivateContext();

    /**
     * Destructor
     */
    virtual ~PrivateContext();

private:
    //  Getter method for the Implementation Object
    PrivateContextImpl*  getPrivateContextImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPrivateContextImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PrivateContextImpl*  m_privatecontextImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PrivateContext - desc for PrivateContext parameter
     */
    PrivateContext( const PrivateContext& );
    PrivateContext& operator=( const PrivateContext& );

    friend class  PrivateContextDelegate;
    friend class  PrivateContextDispatch;
    friend class  PrivateContextGenImpl;
};

#include <collabctx/libcollabctx_undef.h>
#endif //   TEAMCENTER__PRIVATECONTEXT__HXX
