//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SCTypeData
    Filename:   SCTypeData.hxx
    Module:     collabctx
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SCTYPEDATA__HXX
#define TEAMCENTER__SCTYPEDATA__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <collabctx/libcollabctx_exports.h>

namespace Teamcenter
{
    class SCTypeData;
}
namespace Teamcenter
{
    class SCTypeDataImpl;
}
namespace Teamcenter
{
    class SCTypeDataDelegate;
}
namespace Teamcenter
{
    class SCTypeDataDispatch;
}
namespace Teamcenter
{
    class SCTypeDataGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  COLLABCTX_API  Teamcenter::SCTypeData
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SCTypeData();

    /**
     * Destructor
     */
    virtual ~SCTypeData();

private:
    //  Getter method for the Implementation Object
    SCTypeDataImpl*  getSCTypeDataImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSCTypeDataImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SCTypeDataImpl*  m_sctypedataImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SCTypeData - desc for SCTypeData parameter
     */
    SCTypeData( const SCTypeData& );
    SCTypeData& operator=( const SCTypeData& );

    friend class  SCTypeDataDelegate;
    friend class  SCTypeDataDispatch;
    friend class  SCTypeDataGenImpl;
};

#include <collabctx/libcollabctx_undef.h>
#endif //   TEAMCENTER__SCTYPEDATA__HXX
