//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, StructureContext
    Filename:   StructureContext.hxx
    Module:     collabctx
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__STRUCTURECONTEXT__HXX
#define TEAMCENTER__STRUCTURECONTEXT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <collabctx/libcollabctx_exports.h>

namespace Teamcenter
{
    class StructureContext;
}
namespace Teamcenter
{
    class StructureContextImpl;
}
namespace Teamcenter
{
    class StructureContextDelegate;
}
namespace Teamcenter
{
    class StructureContextDispatch;
}
namespace Teamcenter
{
    class StructureContextGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  COLLABCTX_API  Teamcenter::StructureContext
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    StructureContext();

    /**
     * Destructor
     */
    virtual ~StructureContext();

private:
    //  Getter method for the Implementation Object
    StructureContextImpl*  getStructureContextImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setStructureContextImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    StructureContextImpl*  m_structurecontextImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param StructureContext - desc for StructureContext parameter
     */
    StructureContext( const StructureContext& );
    StructureContext& operator=( const StructureContext& );

    friend class  StructureContextDelegate;
    friend class  StructureContextDispatch;
    friend class  StructureContextGenImpl;
};

#include <collabctx/libcollabctx_undef.h>
#endif //   TEAMCENTER__STRUCTURECONTEXT__HXX
