//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, StructureContextDelegate
    Filename:   StructureContextDelegate.hxx
    Module:     collabctx
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__STRUCTURECONTEXTDELEGATE_HXX
#define TEAMCENTER__STRUCTURECONTEXTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <collabctx/StructureContext.hxx>

#include <collabctx/libcollabctx_exports.h>

namespace Teamcenter
{
    class StructureContextDelegate;
}
namespace Teamcenter
{
    class StructureContextImpl;
}
namespace Teamcenter
{
    class StructureContext;
}
namespace Teamcenter
{
    class StructureContextGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  COLLABCTX_API Teamcenter_alias::StructureContextDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the StructureContextDelegate instance
    static StructureContextDelegate&  getInstance();

    //  Method to create the StructureContextImpl pointer
    static StructureContextImpl*  createImpl( StructureContext&  ifObj );

    //  Method to delete the StructureContextImpl pointer
    static void deleteImpl( StructureContextImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static StructureContextDelegate*  m_pInstance;

    StructureContextDelegate();
    virtual ~StructureContextDelegate();
    static void setInstance( StructureContextDelegate*  instance );


private:
    friend class  ::Teamcenter::StructureContextGenImpl;

};

#include <collabctx/libcollabctx_undef.h>
#endif  //  TEAMCENTER__STRUCTURECONTEXTDELEGATE_HXX
