//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, VisStructureContextDelegate
    Filename:   VisStructureContextDelegate.hxx
    Module:     collabctx
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VISSTRUCTURECONTEXTDELEGATE_HXX
#define TEAMCENTER__VISSTRUCTURECONTEXTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <collabctx/VisStructureContext.hxx>

#include <collabctx/libcollabctx_exports.h>

namespace Teamcenter
{
    class VisStructureContextDelegate;
}
namespace Teamcenter
{
    class VisStructureContextImpl;
}
namespace Teamcenter
{
    class VisStructureContext;
}
namespace Teamcenter
{
    class VisStructureContextGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  COLLABCTX_API Teamcenter_alias::VisStructureContextDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the VisStructureContextDelegate instance
    static VisStructureContextDelegate&  getInstance();

    //  Method to create the VisStructureContextImpl pointer
    static VisStructureContextImpl*  createImpl( VisStructureContext&  ifObj );

    //  Method to delete the VisStructureContextImpl pointer
    static void deleteImpl( VisStructureContextImpl*  impl );


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 8.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0bg_occurrencesBase(const VisStructureContext &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0searchRecipeBase(const VisStructureContext &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 8.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0sel_bg_occurrencesBase(const VisStructureContext &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 8.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0sel_target_occurrencesBase(const VisStructureContext &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 8.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0target_occurrencesBase(const VisStructureContext &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Tc 8
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getOccurrence_listBase(const VisStructureContext &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getStatic_structure_fileBase(const VisStructureContext &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 12.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0searchRecipeBase(VisStructureContext &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for an string Array Property
    /// @version Tc 8
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setOccurrence_listBase(VisStructureContext &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setStatic_structure_fileBase(VisStructureContext &ifObj,  const tag_t &value, bool isNull );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static VisStructureContextDelegate*  m_pInstance;

    VisStructureContextDelegate();
    virtual ~VisStructureContextDelegate();
    static void setInstance( VisStructureContextDelegate*  instance );


private:
    friend class  ::Teamcenter::VisStructureContextGenImpl;

};

#include <collabctx/libcollabctx_undef.h>
#endif  //  TEAMCENTER__VISSTRUCTURECONTEXTDELEGATE_HXX
