//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  collabctx

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libcollabctx

#if !defined(LIBCOLLABCTX) && !defined(IPLIB)
#   error IPLIB or LIBCOLLABCTX is not defined
#endif

/* Handwritten code should use COLLABCTX_API, not COLLABCTXEXPORT */

#define COLLABCTX_API COLLABCTXEXPORT

#if IPLIB==libcollabctx || defined(LIBCOLLABCTX)
#   if defined(__lint)
#       define COLLABCTXEXPORT       __export(collabctx)
#       define COLLABCTXGLOBAL       extern __global(collabctx)
#       define COLLABCTXPRIVATE      extern __private(collabctx)
#   elif defined(_WIN32)
#       define COLLABCTXEXPORT       __declspec(dllexport)
#       define COLLABCTXGLOBAL       extern __declspec(dllexport)
#       define COLLABCTXPRIVATE      extern
#   else
#       define COLLABCTXEXPORT
#       define COLLABCTXGLOBAL       extern
#       define COLLABCTXPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define COLLABCTXEXPORT       __export(collabctx)
#       define COLLABCTXGLOBAL       extern __global(collabctx)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define COLLABCTXEXPORT      __declspec(dllimport)
#       define COLLABCTXGLOBAL       extern __declspec(dllimport)
#   else
#       define COLLABCTXEXPORT
#       define COLLABCTXGLOBAL       extern
#   endif
#endif
