//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CondValAgent
    Filename:   CondValAgent.hxx
    Module:     condvalidation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONDVALAGENT__HXX
#define TEAMCENTER__CONDVALAGENT__HXX

#include <common/tc_deprecation_macros.h>
#include <validation/ValidationAgent.hxx>

#include <condvalidation/libcondvalidation_exports.h>

namespace Teamcenter
{
    class CondValAgent;
}
namespace Teamcenter
{
    class CondValAgentImpl;
}
namespace Teamcenter
{
    class CondValAgentDelegate;
}
namespace Teamcenter
{
    class CondValAgentDispatch;
}
namespace Teamcenter
{
    class CondValAgentGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONDVALIDATION_API  Teamcenter::CondValAgent
     : public  ::Teamcenter::ValidationAgent
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CondValAgent();

    /**
     * Destructor
     */
    virtual ~CondValAgent();

private:
    //  Getter method for the Implementation Object
    CondValAgentImpl*  getCondValAgentImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCondValAgentImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CondValAgentImpl*  m_condvalagentImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CondValAgent - desc for CondValAgent parameter
     */
    CondValAgent( const CondValAgent& );
    CondValAgent& operator=( const CondValAgent& );

    friend class  CondValAgentDelegate;
    friend class  CondValAgentDispatch;
    friend class  CondValAgentGenImpl;
};

#include <condvalidation/libcondvalidation_undef.h>
#endif //   TEAMCENTER__CONDVALAGENT__HXX
