//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CondValAgentDelegate
    Filename:   CondValAgentDelegate.hxx
    Module:     condvalidation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONDVALAGENTDELEGATE_HXX
#define TEAMCENTER__CONDVALAGENTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <condvalidation/CondValAgent.hxx>

#include <condvalidation/libcondvalidation_exports.h>

namespace Teamcenter
{
    class CondValAgentDelegate;
}
namespace Teamcenter
{
    class CondValAgentImpl;
}
namespace Teamcenter
{
    class CondValAgent;
}
namespace Teamcenter
{
    class CondValAgentGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CONDVALIDATION_API Teamcenter_alias::CondValAgentDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CondValAgentDelegate instance
    static CondValAgentDelegate&  getInstance();

    //  Method to create the CondValAgentImpl pointer
    static CondValAgentImpl*  createImpl( CondValAgent&  ifObj );

    //  Method to delete the CondValAgentImpl pointer
    static void deleteImpl( CondValAgentImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static CondValAgentDelegate*  m_pInstance;

    CondValAgentDelegate();
    virtual ~CondValAgentDelegate();
    static void setInstance( CondValAgentDelegate*  instance );


private:
    friend class  ::Teamcenter::CondValAgentGenImpl;

};

#include <condvalidation/libcondvalidation_undef.h>
#endif  //  TEAMCENTER__CONDVALAGENTDELEGATE_HXX
