//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CondValData
    Filename:   CondValData.hxx
    Module:     condvalidation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONDVALDATA__HXX
#define TEAMCENTER__CONDVALDATA__HXX

#include <common/tc_deprecation_macros.h>
#include <validation/ValData.hxx>

#include <condvalidation/libcondvalidation_exports.h>

namespace Teamcenter
{
    class CondValData;
}
namespace Teamcenter
{
    class CondValDataImpl;
}
namespace Teamcenter
{
    class CondValDataDelegate;
}
namespace Teamcenter
{
    class CondValDataDispatch;
}
namespace Teamcenter
{
    class CondValDataGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONDVALIDATION_API  Teamcenter::CondValData
     : public  ::Teamcenter::ValData
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CondValData();

    /**
     * Destructor
     */
    virtual ~CondValData();

private:
    //  Getter method for the Implementation Object
    CondValDataImpl*  getCondValDataImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCondValDataImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CondValDataImpl*  m_condvaldataImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CondValData - desc for CondValData parameter
     */
    CondValData( const CondValData& );
    CondValData& operator=( const CondValData& );

    friend class  CondValDataDelegate;
    friend class  CondValDataDispatch;
    friend class  CondValDataGenImpl;
};

#include <condvalidation/libcondvalidation_undef.h>
#endif //   TEAMCENTER__CONDVALDATA__HXX
