//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CondValDataRevision
    Filename:   CondValDataRevision.hxx
    Module:     condvalidation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONDVALDATAREVISION__HXX
#define TEAMCENTER__CONDVALDATAREVISION__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <validation/ValDataRevision.hxx>

#include <condvalidation/libcondvalidation_exports.h>

namespace Teamcenter
{
    class CondValDataRevision;
}
namespace Teamcenter
{
    class CondValDataRevisionImpl;
}
namespace Teamcenter
{
    class CondValDataRevisionDelegate;
}
namespace Teamcenter
{
    class CondValDataRevisionDispatch;
}
namespace Teamcenter
{
    class CondValDataRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONDVALIDATION_API  Teamcenter::CondValDataRevision
     : public  ::Teamcenter::ValDataRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getVerificationRules( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 8.2
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setVerificationRules( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CondValDataRevision();

    /**
     * Destructor
     */
    virtual ~CondValDataRevision();

private:
    //  Getter method for the Implementation Object
    CondValDataRevisionImpl*  getCondValDataRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCondValDataRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CondValDataRevisionImpl*  m_condvaldatarevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CondValDataRevision - desc for CondValDataRevision parameter
     */
    CondValDataRevision( const CondValDataRevision& );
    CondValDataRevision& operator=( const CondValDataRevision& );

    friend class  CondValDataRevisionDelegate;
    friend class  CondValDataRevisionDispatch;
    friend class  CondValDataRevisionGenImpl;
};

#include <condvalidation/libcondvalidation_undef.h>
#endif //   TEAMCENTER__CONDVALDATAREVISION__HXX
