//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CondValDataRevisionDelegate
    Filename:   CondValDataRevisionDelegate.hxx
    Module:     condvalidation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONDVALDATAREVISIONDELEGATE_HXX
#define TEAMCENTER__CONDVALDATAREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <condvalidation/CondValDataRevision.hxx>

#include <condvalidation/libcondvalidation_exports.h>

namespace Teamcenter
{
    class CondValDataRevisionDelegate;
}
namespace Teamcenter
{
    class CondValDataRevisionImpl;
}
namespace Teamcenter
{
    class CondValDataRevision;
}
namespace Teamcenter
{
    class CondValDataRevisionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CONDVALIDATION_API Teamcenter_alias::CondValDataRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CondValDataRevisionDelegate instance
    static CondValDataRevisionDelegate&  getInstance();

    //  Method to create the CondValDataRevisionImpl pointer
    static CondValDataRevisionImpl*  createImpl( CondValDataRevision&  ifObj );

    //  Method to delete the CondValDataRevisionImpl pointer
    static void deleteImpl( CondValDataRevisionImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getVerificationRulesBase(const CondValDataRevision &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 8.2
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setVerificationRulesBase(CondValDataRevision &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static CondValDataRevisionDelegate*  m_pInstance;

    CondValDataRevisionDelegate();
    virtual ~CondValDataRevisionDelegate();
    static void setInstance( CondValDataRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::CondValDataRevisionGenImpl;

};

#include <condvalidation/libcondvalidation_undef.h>
#endif  //  TEAMCENTER__CONDVALDATAREVISIONDELEGATE_HXX
