//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  condvalidation

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libcondvalidation

#if !defined(LIBCONDVALIDATION) && !defined(IPLIB)
#   error IPLIB or LIBCONDVALIDATION is not defined
#endif

/* Handwritten code should use CONDVALIDATION_API, not CONDVALIDATIONEXPORT */

#define CONDVALIDATION_API CONDVALIDATIONEXPORT

#if IPLIB==libcondvalidation || defined(LIBCONDVALIDATION)
#   if defined(__lint)
#       define CONDVALIDATIONEXPORT       __export(condvalidation)
#       define CONDVALIDATIONGLOBAL       extern __global(condvalidation)
#       define CONDVALIDATIONPRIVATE      extern __private(condvalidation)
#   elif defined(_WIN32)
#       define CONDVALIDATIONEXPORT       __declspec(dllexport)
#       define CONDVALIDATIONGLOBAL       extern __declspec(dllexport)
#       define CONDVALIDATIONPRIVATE      extern
#   else
#       define CONDVALIDATIONEXPORT
#       define CONDVALIDATIONGLOBAL       extern
#       define CONDVALIDATIONPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CONDVALIDATIONEXPORT       __export(condvalidation)
#       define CONDVALIDATIONGLOBAL       extern __global(condvalidation)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CONDVALIDATIONEXPORT      __declspec(dllimport)
#       define CONDVALIDATIONGLOBAL       extern __declspec(dllimport)
#   else
#       define CONDVALIDATIONEXPORT
#       define CONDVALIDATIONGLOBAL       extern
#   endif
#endif
