//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Constant
    Filename:   Constant.hxx
    Module:     constants
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONSTANT__HXX
#define TEAMCENTER__CONSTANT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <constants/libconstants_exports.h>

namespace Teamcenter
{
    class Constant;
}
namespace Teamcenter
{
    class ConstantImpl;
}
namespace Teamcenter
{
    class ConstantDelegate;
}
namespace Teamcenter
{
    class ConstantDispatch;
}
namespace Teamcenter
{
    class ConstantGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONSTANTS_API  Teamcenter::Constant
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Constant();

    /**
     * Destructor
     */
    virtual ~Constant();

private:
    //  Getter method for the Implementation Object
    ConstantImpl*  getConstantImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setConstantImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ConstantImpl*  m_constantImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Constant - desc for Constant parameter
     */
    Constant( const Constant& );
    Constant& operator=( const Constant& );

    friend class  ConstantDelegate;
    friend class  ConstantDispatch;
    friend class  ConstantGenImpl;
};

#include <constants/libconstants_undef.h>
#endif //   TEAMCENTER__CONSTANT__HXX
