//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ConstantAttach
    Filename:   ConstantAttach.hxx
    Module:     constants
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONSTANTATTACH__HXX
#define TEAMCENTER__CONSTANTATTACH__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <constants/libconstants_exports.h>

namespace Teamcenter
{
    class ConstantAttach;
}
namespace Teamcenter
{
    class ConstantAttachImpl;
}
namespace Teamcenter
{
    class ConstantAttachDelegate;
}
namespace Teamcenter
{
    class ConstantAttachDispatch;
}
namespace Teamcenter
{
    class ConstantAttachGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONSTANTS_API  Teamcenter::ConstantAttach
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ConstantAttach();

    /**
     * Destructor
     */
    virtual ~ConstantAttach();

private:
    //  Getter method for the Implementation Object
    ConstantAttachImpl*  getConstantAttachImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setConstantAttachImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ConstantAttachImpl*  m_constantattachImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ConstantAttach - desc for ConstantAttach parameter
     */
    ConstantAttach( const ConstantAttach& );
    ConstantAttach& operator=( const ConstantAttach& );

    friend class  ConstantAttachDelegate;
    friend class  ConstantAttachDispatch;
    friend class  ConstantAttachGenImpl;
};

#include <constants/libconstants_undef.h>
#endif //   TEAMCENTER__CONSTANTATTACH__HXX
