//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ConstantChoice
    Filename:   ConstantChoice.hxx
    Module:     constants
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONSTANTCHOICE__HXX
#define TEAMCENTER__CONSTANTCHOICE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <constants/libconstants_exports.h>

namespace Teamcenter
{
    class ConstantChoice;
}
namespace Teamcenter
{
    class ConstantChoiceImpl;
}
namespace Teamcenter
{
    class ConstantChoiceDelegate;
}
namespace Teamcenter
{
    class ConstantChoiceDispatch;
}
namespace Teamcenter
{
    class ConstantChoiceGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONSTANTS_API  Teamcenter::ConstantChoice
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ConstantChoice();

    /**
     * Destructor
     */
    virtual ~ConstantChoice();

private:
    //  Getter method for the Implementation Object
    ConstantChoiceImpl*  getConstantChoiceImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setConstantChoiceImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ConstantChoiceImpl*  m_constantchoiceImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ConstantChoice - desc for ConstantChoice parameter
     */
    ConstantChoice( const ConstantChoice& );
    ConstantChoice& operator=( const ConstantChoice& );

    friend class  ConstantChoiceDelegate;
    friend class  ConstantChoiceDispatch;
    friend class  ConstantChoiceGenImpl;
};

#include <constants/libconstants_undef.h>
#endif //   TEAMCENTER__CONSTANTCHOICE__HXX
