//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, GlobalConstant
    Filename:   GlobalConstant.hxx
    Module:     constants
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__GLOBALCONSTANT__HXX
#define TEAMCENTER__GLOBALCONSTANT__HXX

#include <common/tc_deprecation_macros.h>
#include <constants/Constant.hxx>

#include <constants/libconstants_exports.h>

namespace Teamcenter
{
    class GlobalConstant;
}
namespace Teamcenter
{
    class GlobalConstantImpl;
}
namespace Teamcenter
{
    class GlobalConstantDelegate;
}
namespace Teamcenter
{
    class GlobalConstantDispatch;
}
namespace Teamcenter
{
    class GlobalConstantGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONSTANTS_API  Teamcenter::GlobalConstant
     : public  ::Teamcenter::Constant
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    GlobalConstant();

    /**
     * Destructor
     */
    virtual ~GlobalConstant();

private:
    //  Getter method for the Implementation Object
    GlobalConstantImpl*  getGlobalConstantImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setGlobalConstantImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    GlobalConstantImpl*  m_globalconstantImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param GlobalConstant - desc for GlobalConstant parameter
     */
    GlobalConstant( const GlobalConstant& );
    GlobalConstant& operator=( const GlobalConstant& );

    friend class  GlobalConstantDelegate;
    friend class  GlobalConstantDispatch;
    friend class  GlobalConstantGenImpl;
};

#include <constants/libconstants_undef.h>
#endif //   TEAMCENTER__GLOBALCONSTANT__HXX
