//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, GlobalConstantAttach
    Filename:   GlobalConstantAttach.hxx
    Module:     constants
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__GLOBALCONSTANTATTACH__HXX
#define TEAMCENTER__GLOBALCONSTANTATTACH__HXX

#include <common/tc_deprecation_macros.h>
#include <constants/ConstantAttach.hxx>

#include <constants/libconstants_exports.h>

namespace Teamcenter
{
    class GlobalConstantAttach;
}
namespace Teamcenter
{
    class GlobalConstantAttachImpl;
}
namespace Teamcenter
{
    class GlobalConstantAttachDelegate;
}
namespace Teamcenter
{
    class GlobalConstantAttachDispatch;
}
namespace Teamcenter
{
    class GlobalConstantAttachGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONSTANTS_API  Teamcenter::GlobalConstantAttach
     : public  ::Teamcenter::ConstantAttach
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    GlobalConstantAttach();

    /**
     * Destructor
     */
    virtual ~GlobalConstantAttach();

private:
    //  Getter method for the Implementation Object
    GlobalConstantAttachImpl*  getGlobalConstantAttachImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setGlobalConstantAttachImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    GlobalConstantAttachImpl*  m_globalconstantattachImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param GlobalConstantAttach - desc for GlobalConstantAttach parameter
     */
    GlobalConstantAttach( const GlobalConstantAttach& );
    GlobalConstantAttach& operator=( const GlobalConstantAttach& );

    friend class  GlobalConstantAttachDelegate;
    friend class  GlobalConstantAttachDispatch;
    friend class  GlobalConstantAttachGenImpl;
};

#include <constants/libconstants_undef.h>
#endif //   TEAMCENTER__GLOBALCONSTANTATTACH__HXX
