//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, GlobalConstantAttachDelegate
    Filename:   GlobalConstantAttachDelegate.hxx
    Module:     constants
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__GLOBALCONSTANTATTACHDELEGATE_HXX
#define TEAMCENTER__GLOBALCONSTANTATTACHDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <constants/GlobalConstantAttach.hxx>

#include <constants/libconstants_exports.h>

namespace Teamcenter
{
    class GlobalConstantAttachDelegate;
}
namespace Teamcenter
{
    class GlobalConstantAttachImpl;
}
namespace Teamcenter
{
    class GlobalConstantAttach;
}
namespace Teamcenter
{
    class GlobalConstantAttachGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CONSTANTS_API Teamcenter_alias::GlobalConstantAttachDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the GlobalConstantAttachDelegate instance
    static GlobalConstantAttachDelegate&  getInstance();

    //  Method to create the GlobalConstantAttachImpl pointer
    static GlobalConstantAttachImpl*  createImpl( GlobalConstantAttach&  ifObj );

    //  Method to delete the GlobalConstantAttachImpl pointer
    static void deleteImpl( GlobalConstantAttachImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static GlobalConstantAttachDelegate*  m_pInstance;

    GlobalConstantAttachDelegate();
    virtual ~GlobalConstantAttachDelegate();
    static void setInstance( GlobalConstantAttachDelegate*  instance );


private:
    friend class  ::Teamcenter::GlobalConstantAttachGenImpl;

};

#include <constants/libconstants_undef.h>
#endif  //  TEAMCENTER__GLOBALCONSTANTATTACHDELEGATE_HXX
