//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, GlobalConstantDelegate
    Filename:   GlobalConstantDelegate.hxx
    Module:     constants
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__GLOBALCONSTANTDELEGATE_HXX
#define TEAMCENTER__GLOBALCONSTANTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <constants/GlobalConstant.hxx>

#include <constants/libconstants_exports.h>

namespace Teamcenter
{
    class GlobalConstantDelegate;
}
namespace Teamcenter
{
    class GlobalConstantImpl;
}
namespace Teamcenter
{
    class GlobalConstant;
}
namespace Teamcenter
{
    class GlobalConstantGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CONSTANTS_API Teamcenter_alias::GlobalConstantDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the GlobalConstantDelegate instance
    static GlobalConstantDelegate&  getInstance();

    //  Method to create the GlobalConstantImpl pointer
    static GlobalConstantImpl*  createImpl( GlobalConstant&  ifObj );

    //  Method to delete the GlobalConstantImpl pointer
    static void deleteImpl( GlobalConstantImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static GlobalConstantDelegate*  m_pInstance;

    GlobalConstantDelegate();
    virtual ~GlobalConstantDelegate();
    static void setInstance( GlobalConstantDelegate*  instance );


private:
    friend class  ::Teamcenter::GlobalConstantGenImpl;

};

#include <constants/libconstants_undef.h>
#endif  //  TEAMCENTER__GLOBALCONSTANTDELEGATE_HXX
