//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PropertyConstant
    Filename:   PropertyConstant.hxx
    Module:     constants
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROPERTYCONSTANT__HXX
#define TEAMCENTER__PROPERTYCONSTANT__HXX

#include <common/tc_deprecation_macros.h>
#include <constants/Constant.hxx>

#include <constants/libconstants_exports.h>

namespace Teamcenter
{
    class PropertyConstant;
}
namespace Teamcenter
{
    class PropertyConstantImpl;
}
namespace Teamcenter
{
    class PropertyConstantDelegate;
}
namespace Teamcenter
{
    class PropertyConstantDispatch;
}
namespace Teamcenter
{
    class PropertyConstantGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONSTANTS_API  Teamcenter::PropertyConstant
     : public  ::Teamcenter::Constant
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PropertyConstant();

    /**
     * Destructor
     */
    virtual ~PropertyConstant();

private:
    //  Getter method for the Implementation Object
    PropertyConstantImpl*  getPropertyConstantImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPropertyConstantImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PropertyConstantImpl*  m_propertyconstantImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PropertyConstant - desc for PropertyConstant parameter
     */
    PropertyConstant( const PropertyConstant& );
    PropertyConstant& operator=( const PropertyConstant& );

    friend class  PropertyConstantDelegate;
    friend class  PropertyConstantDispatch;
    friend class  PropertyConstantGenImpl;
};

#include <constants/libconstants_undef.h>
#endif //   TEAMCENTER__PROPERTYCONSTANT__HXX
