//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PropertyConstantAttach
    Filename:   PropertyConstantAttach.hxx
    Module:     constants
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROPERTYCONSTANTATTACH__HXX
#define TEAMCENTER__PROPERTYCONSTANTATTACH__HXX

#include <common/tc_deprecation_macros.h>
#include <constants/ConstantAttach.hxx>

#include <constants/libconstants_exports.h>

namespace Teamcenter
{
    class PropertyConstantAttach;
}
namespace Teamcenter
{
    class PropertyConstantAttachImpl;
}
namespace Teamcenter
{
    class PropertyConstantAttachDelegate;
}
namespace Teamcenter
{
    class PropertyConstantAttachDispatch;
}
namespace Teamcenter
{
    class PropertyConstantAttachGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONSTANTS_API  Teamcenter::PropertyConstantAttach
     : public  ::Teamcenter::ConstantAttach
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PropertyConstantAttach();

    /**
     * Destructor
     */
    virtual ~PropertyConstantAttach();

private:
    //  Getter method for the Implementation Object
    PropertyConstantAttachImpl*  getPropertyConstantAttachImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPropertyConstantAttachImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PropertyConstantAttachImpl*  m_propertyconstantattachImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PropertyConstantAttach - desc for PropertyConstantAttach parameter
     */
    PropertyConstantAttach( const PropertyConstantAttach& );
    PropertyConstantAttach& operator=( const PropertyConstantAttach& );

    friend class  PropertyConstantAttachDelegate;
    friend class  PropertyConstantAttachDispatch;
    friend class  PropertyConstantAttachGenImpl;
};

#include <constants/libconstants_undef.h>
#endif //   TEAMCENTER__PROPERTYCONSTANTATTACH__HXX
