//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PropertyConstantAttachDelegate
    Filename:   PropertyConstantAttachDelegate.hxx
    Module:     constants
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROPERTYCONSTANTATTACHDELEGATE_HXX
#define TEAMCENTER__PROPERTYCONSTANTATTACHDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <constants/PropertyConstantAttach.hxx>

#include <constants/libconstants_exports.h>

namespace Teamcenter
{
    class PropertyConstantAttachDelegate;
}
namespace Teamcenter
{
    class PropertyConstantAttachImpl;
}
namespace Teamcenter
{
    class PropertyConstantAttach;
}
namespace Teamcenter
{
    class PropertyConstantAttachGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CONSTANTS_API Teamcenter_alias::PropertyConstantAttachDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PropertyConstantAttachDelegate instance
    static PropertyConstantAttachDelegate&  getInstance();

    //  Method to create the PropertyConstantAttachImpl pointer
    static PropertyConstantAttachImpl*  createImpl( PropertyConstantAttach&  ifObj );

    //  Method to delete the PropertyConstantAttachImpl pointer
    static void deleteImpl( PropertyConstantAttachImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static PropertyConstantAttachDelegate*  m_pInstance;

    PropertyConstantAttachDelegate();
    virtual ~PropertyConstantAttachDelegate();
    static void setInstance( PropertyConstantAttachDelegate*  instance );


private:
    friend class  ::Teamcenter::PropertyConstantAttachGenImpl;

};

#include <constants/libconstants_undef.h>
#endif  //  TEAMCENTER__PROPERTYCONSTANTATTACHDELEGATE_HXX
