//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PropertyConstantDelegate
    Filename:   PropertyConstantDelegate.hxx
    Module:     constants
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROPERTYCONSTANTDELEGATE_HXX
#define TEAMCENTER__PROPERTYCONSTANTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <constants/PropertyConstant.hxx>

#include <constants/libconstants_exports.h>

namespace Teamcenter
{
    class PropertyConstantDelegate;
}
namespace Teamcenter
{
    class PropertyConstantImpl;
}
namespace Teamcenter
{
    class PropertyConstant;
}
namespace Teamcenter
{
    class PropertyConstantGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CONSTANTS_API Teamcenter_alias::PropertyConstantDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PropertyConstantDelegate instance
    static PropertyConstantDelegate&  getInstance();

    //  Method to create the PropertyConstantImpl pointer
    static PropertyConstantImpl*  createImpl( PropertyConstant&  ifObj );

    //  Method to delete the PropertyConstantImpl pointer
    static void deleteImpl( PropertyConstantImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static PropertyConstantDelegate*  m_pInstance;

    PropertyConstantDelegate();
    virtual ~PropertyConstantDelegate();
    static void setInstance( PropertyConstantDelegate*  instance );


private:
    friend class  ::Teamcenter::PropertyConstantGenImpl;

};

#include <constants/libconstants_undef.h>
#endif  //  TEAMCENTER__PROPERTYCONSTANTDELEGATE_HXX
