//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TypeConstant
    Filename:   TypeConstant.hxx
    Module:     constants
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TYPECONSTANT__HXX
#define TEAMCENTER__TYPECONSTANT__HXX

#include <common/tc_deprecation_macros.h>
#include <constants/Constant.hxx>

#include <constants/libconstants_exports.h>

namespace Teamcenter
{
    class TypeConstant;
}
namespace Teamcenter
{
    class TypeConstantImpl;
}
namespace Teamcenter
{
    class TypeConstantDelegate;
}
namespace Teamcenter
{
    class TypeConstantDispatch;
}
namespace Teamcenter
{
    class TypeConstantGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONSTANTS_API  Teamcenter::TypeConstant
     : public  ::Teamcenter::Constant
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    TypeConstant();

    /**
     * Destructor
     */
    virtual ~TypeConstant();

private:
    //  Getter method for the Implementation Object
    TypeConstantImpl*  getTypeConstantImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTypeConstantImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    TypeConstantImpl*  m_typeconstantImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param TypeConstant - desc for TypeConstant parameter
     */
    TypeConstant( const TypeConstant& );
    TypeConstant& operator=( const TypeConstant& );

    friend class  TypeConstantDelegate;
    friend class  TypeConstantDispatch;
    friend class  TypeConstantGenImpl;
};

#include <constants/libconstants_undef.h>
#endif //   TEAMCENTER__TYPECONSTANT__HXX
