//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TypeConstantAttach
    Filename:   TypeConstantAttach.hxx
    Module:     constants
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TYPECONSTANTATTACH__HXX
#define TEAMCENTER__TYPECONSTANTATTACH__HXX

#include <common/tc_deprecation_macros.h>
#include <constants/ConstantAttach.hxx>

#include <constants/libconstants_exports.h>

namespace Teamcenter
{
    class TypeConstantAttach;
}
namespace Teamcenter
{
    class TypeConstantAttachImpl;
}
namespace Teamcenter
{
    class TypeConstantAttachDelegate;
}
namespace Teamcenter
{
    class TypeConstantAttachDispatch;
}
namespace Teamcenter
{
    class TypeConstantAttachGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONSTANTS_API  Teamcenter::TypeConstantAttach
     : public  ::Teamcenter::ConstantAttach
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    TypeConstantAttach();

    /**
     * Destructor
     */
    virtual ~TypeConstantAttach();

private:
    //  Getter method for the Implementation Object
    TypeConstantAttachImpl*  getTypeConstantAttachImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTypeConstantAttachImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    TypeConstantAttachImpl*  m_typeconstantattachImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param TypeConstantAttach - desc for TypeConstantAttach parameter
     */
    TypeConstantAttach( const TypeConstantAttach& );
    TypeConstantAttach& operator=( const TypeConstantAttach& );

    friend class  TypeConstantAttachDelegate;
    friend class  TypeConstantAttachDispatch;
    friend class  TypeConstantAttachGenImpl;
};

#include <constants/libconstants_undef.h>
#endif //   TEAMCENTER__TYPECONSTANTATTACH__HXX
