//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TypeConstantAttachDelegate
    Filename:   TypeConstantAttachDelegate.hxx
    Module:     constants
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TYPECONSTANTATTACHDELEGATE_HXX
#define TEAMCENTER__TYPECONSTANTATTACHDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <constants/TypeConstantAttach.hxx>

#include <constants/libconstants_exports.h>

namespace Teamcenter
{
    class TypeConstantAttachDelegate;
}
namespace Teamcenter
{
    class TypeConstantAttachImpl;
}
namespace Teamcenter
{
    class TypeConstantAttach;
}
namespace Teamcenter
{
    class TypeConstantAttachGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CONSTANTS_API Teamcenter_alias::TypeConstantAttachDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the TypeConstantAttachDelegate instance
    static TypeConstantAttachDelegate&  getInstance();

    //  Method to create the TypeConstantAttachImpl pointer
    static TypeConstantAttachImpl*  createImpl( TypeConstantAttach&  ifObj );

    //  Method to delete the TypeConstantAttachImpl pointer
    static void deleteImpl( TypeConstantAttachImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static TypeConstantAttachDelegate*  m_pInstance;

    TypeConstantAttachDelegate();
    virtual ~TypeConstantAttachDelegate();
    static void setInstance( TypeConstantAttachDelegate*  instance );


private:
    friend class  ::Teamcenter::TypeConstantAttachGenImpl;

};

#include <constants/libconstants_undef.h>
#endif  //  TEAMCENTER__TYPECONSTANTATTACHDELEGATE_HXX
