//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TypeConstantDelegate
    Filename:   TypeConstantDelegate.hxx
    Module:     constants
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TYPECONSTANTDELEGATE_HXX
#define TEAMCENTER__TYPECONSTANTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <constants/TypeConstant.hxx>

#include <constants/libconstants_exports.h>

namespace Teamcenter
{
    class TypeConstantDelegate;
}
namespace Teamcenter
{
    class TypeConstantImpl;
}
namespace Teamcenter
{
    class TypeConstant;
}
namespace Teamcenter
{
    class TypeConstantGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CONSTANTS_API Teamcenter_alias::TypeConstantDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the TypeConstantDelegate instance
    static TypeConstantDelegate&  getInstance();

    //  Method to create the TypeConstantImpl pointer
    static TypeConstantImpl*  createImpl( TypeConstant&  ifObj );

    //  Method to delete the TypeConstantImpl pointer
    static void deleteImpl( TypeConstantImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static TypeConstantDelegate*  m_pInstance;

    TypeConstantDelegate();
    virtual ~TypeConstantDelegate();
    static void setInstance( TypeConstantDelegate*  instance );


private:
    friend class  ::Teamcenter::TypeConstantGenImpl;

};

#include <constants/libconstants_undef.h>
#endif  //  TEAMCENTER__TYPECONSTANTDELEGATE_HXX
