//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  constants

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libconstants

#if !defined(LIBCONSTANTS) && !defined(IPLIB)
#   error IPLIB or LIBCONSTANTS is not defined
#endif

/* Handwritten code should use CONSTANTS_API, not CONSTANTSEXPORT */

#define CONSTANTS_API CONSTANTSEXPORT

#if IPLIB==libconstants || defined(LIBCONSTANTS)
#   if defined(__lint)
#       define CONSTANTSEXPORT       __export(constants)
#       define CONSTANTSGLOBAL       extern __global(constants)
#       define CONSTANTSPRIVATE      extern __private(constants)
#   elif defined(_WIN32)
#       define CONSTANTSEXPORT       __declspec(dllexport)
#       define CONSTANTSGLOBAL       extern __declspec(dllexport)
#       define CONSTANTSPRIVATE      extern
#   else
#       define CONSTANTSEXPORT
#       define CONSTANTSGLOBAL       extern
#       define CONSTANTSPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CONSTANTSEXPORT       __export(constants)
#       define CONSTANTSGLOBAL       extern __global(constants)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CONSTANTSEXPORT      __declspec(dllimport)
#       define CONSTANTSGLOBAL       extern __declspec(dllimport)
#   else
#       define CONSTANTSEXPORT
#       define CONSTANTSGLOBAL       extern
#   endif
#endif
