//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DCt_GraphicPriority
    Filename:   DCt_GraphicPriority.hxx
    Module:     contmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__DCT_GRAPHICPRIORITY__HXX
#define TEAMCENTER__DCT_GRAPHICPRIORITY__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <contmgmt/libcontmgmt_exports.h>

namespace Teamcenter
{
    class DCt_GraphicPriority;
}
namespace Teamcenter
{
    class DCt_GraphicPriorityImpl;
}
namespace Teamcenter
{
    class DCt_GraphicPriorityDelegate;
}
namespace Teamcenter
{
    class DCt_GraphicPriorityDispatch;
}
namespace Teamcenter
{
    class DCt_GraphicPriorityGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONTMGMT_API  Teamcenter::DCt_GraphicPriority
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    DCt_GraphicPriority();

    /**
     * Destructor
     */
    virtual ~DCt_GraphicPriority();

private:
    //  Getter method for the Implementation Object
    DCt_GraphicPriorityImpl*  getDCt_GraphicPriorityImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDCt_GraphicPriorityImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DCt_GraphicPriorityImpl*  m_dct_graphicpriorityImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param DCt_GraphicPriority - desc for DCt_GraphicPriority parameter
     */
    DCt_GraphicPriority( const DCt_GraphicPriority& );
    DCt_GraphicPriority& operator=( const DCt_GraphicPriority& );

    friend class  DCt_GraphicPriorityDelegate;
    friend class  DCt_GraphicPriorityDispatch;
    friend class  DCt_GraphicPriorityGenImpl;
};

#include <contmgmt/libcontmgmt_undef.h>
#endif //   TEAMCENTER__DCT_GRAPHICPRIORITY__HXX
