//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DCt_GraphicPriorityDelegate
    Filename:   DCt_GraphicPriorityDelegate.hxx
    Module:     contmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__DCT_GRAPHICPRIORITYDELEGATE_HXX
#define TEAMCENTER__DCT_GRAPHICPRIORITYDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <contmgmt/DCt_GraphicPriority.hxx>

#include <contmgmt/libcontmgmt_exports.h>

namespace Teamcenter
{
    class DCt_GraphicPriorityDelegate;
}
namespace Teamcenter
{
    class DCt_GraphicPriorityImpl;
}
namespace Teamcenter
{
    class DCt_GraphicPriority;
}
namespace Teamcenter
{
    class DCt_GraphicPriorityGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CONTMGMT_API Teamcenter_alias::DCt_GraphicPriorityDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the DCt_GraphicPriorityDelegate instance
    static DCt_GraphicPriorityDelegate&  getInstance();

    //  Method to create the DCt_GraphicPriorityImpl pointer
    static DCt_GraphicPriorityImpl*  createImpl( DCt_GraphicPriority&  ifObj );

    //  Method to delete the DCt_GraphicPriorityImpl pointer
    static void deleteImpl( DCt_GraphicPriorityImpl*  impl );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const DCt_GraphicPriority &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static DCt_GraphicPriorityDelegate*  m_pInstance;

    DCt_GraphicPriorityDelegate();
    virtual ~DCt_GraphicPriorityDelegate();
    static void setInstance( DCt_GraphicPriorityDelegate*  instance );


private:
    friend class  ::Teamcenter::DCt_GraphicPriorityGenImpl;

};

#include <contmgmt/libcontmgmt_undef.h>
#endif  //  TEAMCENTER__DCT_GRAPHICPRIORITYDELEGATE_HXX
