//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DCt_Language
    Filename:   DCt_Language.hxx
    Module:     contmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__DCT_LANGUAGE__HXX
#define TEAMCENTER__DCT_LANGUAGE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <contmgmt/libcontmgmt_exports.h>

namespace Teamcenter
{
    class DCt_Language;
}
namespace Teamcenter
{
    class DCt_LanguageImpl;
}
namespace Teamcenter
{
    class DCt_LanguageDelegate;
}
namespace Teamcenter
{
    class DCt_LanguageDispatch;
}
namespace Teamcenter
{
    class DCt_LanguageGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONTMGMT_API  Teamcenter::DCt_Language
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    DCt_Language();

    /**
     * Destructor
     */
    virtual ~DCt_Language();

private:
    //  Getter method for the Implementation Object
    DCt_LanguageImpl*  getDCt_LanguageImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDCt_LanguageImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DCt_LanguageImpl*  m_dct_languageImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param DCt_Language - desc for DCt_Language parameter
     */
    DCt_Language( const DCt_Language& );
    DCt_Language& operator=( const DCt_Language& );

    friend class  DCt_LanguageDelegate;
    friend class  DCt_LanguageDispatch;
    friend class  DCt_LanguageGenImpl;
};

#include <contmgmt/libcontmgmt_undef.h>
#endif //   TEAMCENTER__DCT_LANGUAGE__HXX
