//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DCt_LanguageDelegate
    Filename:   DCt_LanguageDelegate.hxx
    Module:     contmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__DCT_LANGUAGEDELEGATE_HXX
#define TEAMCENTER__DCT_LANGUAGEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <contmgmt/DCt_Language.hxx>

#include <contmgmt/libcontmgmt_exports.h>

namespace Teamcenter
{
    class DCt_LanguageDelegate;
}
namespace Teamcenter
{
    class DCt_LanguageImpl;
}
namespace Teamcenter
{
    class DCt_Language;
}
namespace Teamcenter
{
    class DCt_LanguageGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CONTMGMT_API Teamcenter_alias::DCt_LanguageDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the DCt_LanguageDelegate instance
    static DCt_LanguageDelegate&  getInstance();

    //  Method to create the DCt_LanguageImpl pointer
    static DCt_LanguageImpl*  createImpl( DCt_Language&  ifObj );

    //  Method to delete the DCt_LanguageImpl pointer
    static void deleteImpl( DCt_LanguageImpl*  impl );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const DCt_Language &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static DCt_LanguageDelegate*  m_pInstance;

    DCt_LanguageDelegate();
    virtual ~DCt_LanguageDelegate();
    static void setInstance( DCt_LanguageDelegate*  instance );


private:
    friend class  ::Teamcenter::DCt_LanguageGenImpl;

};

#include <contmgmt/libcontmgmt_undef.h>
#endif  //  TEAMCENTER__DCT_LANGUAGEDELEGATE_HXX
