//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, GraphicOptionRevision
    Filename:   GraphicOptionRevision.hxx
    Module:     contmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__GRAPHICOPTIONREVISION__HXX
#define TEAMCENTER__GRAPHICOPTIONREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <contmgmt/libcontmgmt_exports.h>

namespace Teamcenter
{
    class GraphicOptionRevision;
}
namespace Teamcenter
{
    class GraphicOptionRevisionImpl;
}
namespace Teamcenter
{
    class GraphicOptionRevisionDelegate;
}
namespace Teamcenter
{
    class GraphicOptionRevisionDispatch;
}
namespace Teamcenter
{
    class GraphicOptionRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONTMGMT_API  Teamcenter::GraphicOptionRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    GraphicOptionRevision();

    /**
     * Destructor
     */
    virtual ~GraphicOptionRevision();

private:
    //  Getter method for the Implementation Object
    GraphicOptionRevisionImpl*  getGraphicOptionRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setGraphicOptionRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    GraphicOptionRevisionImpl*  m_graphicoptionrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param GraphicOptionRevision - desc for GraphicOptionRevision parameter
     */
    GraphicOptionRevision( const GraphicOptionRevision& );
    GraphicOptionRevision& operator=( const GraphicOptionRevision& );

    friend class  GraphicOptionRevisionDelegate;
    friend class  GraphicOptionRevisionDispatch;
    friend class  GraphicOptionRevisionGenImpl;
};

#include <contmgmt/libcontmgmt_undef.h>
#endif //   TEAMCENTER__GRAPHICOPTIONREVISION__HXX
