//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, GraphicRevision
    Filename:   GraphicRevision.hxx
    Module:     contmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__GRAPHICREVISION__HXX
#define TEAMCENTER__GRAPHICREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <req/SpecElementRevision.hxx>

#include <contmgmt/libcontmgmt_exports.h>

namespace Teamcenter
{
    class GraphicRevision;
}
namespace Teamcenter
{
    class GraphicRevisionImpl;
}
namespace Teamcenter
{
    class GraphicRevisionDelegate;
}
namespace Teamcenter
{
    class GraphicRevisionDispatch;
}
namespace Teamcenter
{
    class GraphicRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONTMGMT_API  Teamcenter::GraphicRevision
     : public  ::Teamcenter::SpecElementRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    GraphicRevision();

    /**
     * Destructor
     */
    virtual ~GraphicRevision();

private:
    //  Getter method for the Implementation Object
    GraphicRevisionImpl*  getGraphicRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setGraphicRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    GraphicRevisionImpl*  m_graphicrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param GraphicRevision - desc for GraphicRevision parameter
     */
    GraphicRevision( const GraphicRevision& );
    GraphicRevision& operator=( const GraphicRevision& );

    friend class  GraphicRevisionDelegate;
    friend class  GraphicRevisionDispatch;
    friend class  GraphicRevisionGenImpl;
};

#include <contmgmt/libcontmgmt_undef.h>
#endif //   TEAMCENTER__GRAPHICREVISION__HXX
