//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, GraphicRevisionDelegate
    Filename:   GraphicRevisionDelegate.hxx
    Module:     contmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__GRAPHICREVISIONDELEGATE_HXX
#define TEAMCENTER__GRAPHICREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <contmgmt/GraphicRevision.hxx>

#include <contmgmt/libcontmgmt_exports.h>

namespace Teamcenter
{
    class GraphicRevisionDelegate;
}
namespace Teamcenter
{
    class GraphicRevisionImpl;
}
namespace Teamcenter
{
    class GraphicRevision;
}
namespace Teamcenter
{
    class GraphicRevisionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CONTMGMT_API Teamcenter_alias::GraphicRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the GraphicRevisionDelegate instance
    static GraphicRevisionDelegate&  getInstance();

    //  Method to create the GraphicRevisionImpl pointer
    static GraphicRevisionImpl*  createImpl( GraphicRevision&  ifObj );

    //  Method to delete the GraphicRevisionImpl pointer
    static void deleteImpl( GraphicRevisionImpl*  impl );



protected:
    //  Pointer to the instance
    static GraphicRevisionDelegate*  m_pInstance;

    GraphicRevisionDelegate();
    virtual ~GraphicRevisionDelegate();
    static void setInstance( GraphicRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::GraphicRevisionGenImpl;

};

#include <contmgmt/libcontmgmt_undef.h>
#endif  //  TEAMCENTER__GRAPHICREVISIONDELEGATE_HXX
