//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TranslationOrderRevision
    Filename:   TranslationOrderRevision.hxx
    Module:     contmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TRANSLATIONORDERREVISION__HXX
#define TEAMCENTER__TRANSLATIONORDERREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <contmgmt/libcontmgmt_exports.h>

namespace Teamcenter
{
    class TranslationOrderRevision;
}
namespace Teamcenter
{
    class TranslationOrderRevisionImpl;
}
namespace Teamcenter
{
    class TranslationOrderRevisionDelegate;
}
namespace Teamcenter
{
    class TranslationOrderRevisionDispatch;
}
namespace Teamcenter
{
    class TranslationOrderRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONTMGMT_API  Teamcenter::TranslationOrderRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    TranslationOrderRevision();

    /**
     * Destructor
     */
    virtual ~TranslationOrderRevision();

private:
    //  Getter method for the Implementation Object
    TranslationOrderRevisionImpl*  getTranslationOrderRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTranslationOrderRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    TranslationOrderRevisionImpl*  m_translationorderrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param TranslationOrderRevision - desc for TranslationOrderRevision parameter
     */
    TranslationOrderRevision( const TranslationOrderRevision& );
    TranslationOrderRevision& operator=( const TranslationOrderRevision& );

    friend class  TranslationOrderRevisionDelegate;
    friend class  TranslationOrderRevisionDispatch;
    friend class  TranslationOrderRevisionGenImpl;
};

#include <contmgmt/libcontmgmt_undef.h>
#endif //   TEAMCENTER__TRANSLATIONORDERREVISION__HXX
