//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TranslationOrderRevisionDelegate
    Filename:   TranslationOrderRevisionDelegate.hxx
    Module:     contmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TRANSLATIONORDERREVISIONDELEGATE_HXX
#define TEAMCENTER__TRANSLATIONORDERREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <contmgmt/TranslationOrderRevision.hxx>

#include <contmgmt/libcontmgmt_exports.h>

namespace Teamcenter
{
    class TranslationOrderRevisionDelegate;
}
namespace Teamcenter
{
    class TranslationOrderRevisionImpl;
}
namespace Teamcenter
{
    class TranslationOrderRevision;
}
namespace Teamcenter
{
    class TranslationOrderRevisionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CONTMGMT_API Teamcenter_alias::TranslationOrderRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the TranslationOrderRevisionDelegate instance
    static TranslationOrderRevisionDelegate&  getInstance();

    //  Method to create the TranslationOrderRevisionImpl pointer
    static TranslationOrderRevisionImpl*  createImpl( TranslationOrderRevision&  ifObj );

    //  Method to delete the TranslationOrderRevisionImpl pointer
    static void deleteImpl( TranslationOrderRevisionImpl*  impl );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const TranslationOrderRevision &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static TranslationOrderRevisionDelegate*  m_pInstance;

    TranslationOrderRevisionDelegate();
    virtual ~TranslationOrderRevisionDelegate();
    static void setInstance( TranslationOrderRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::TranslationOrderRevisionGenImpl;

};

#include <contmgmt/libcontmgmt_undef.h>
#endif  //  TEAMCENTER__TRANSLATIONORDERREVISIONDELEGATE_HXX
