//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TranslatnDelvryRevision
    Filename:   TranslatnDelvryRevision.hxx
    Module:     contmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TRANSLATNDELVRYREVISION__HXX
#define TEAMCENTER__TRANSLATNDELVRYREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <contmgmt/libcontmgmt_exports.h>

namespace Teamcenter
{
    class TranslatnDelvryRevision;
}
namespace Teamcenter
{
    class TranslatnDelvryRevisionImpl;
}
namespace Teamcenter
{
    class TranslatnDelvryRevisionDelegate;
}
namespace Teamcenter
{
    class TranslatnDelvryRevisionDispatch;
}
namespace Teamcenter
{
    class TranslatnDelvryRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONTMGMT_API  Teamcenter::TranslatnDelvryRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    TranslatnDelvryRevision();

    /**
     * Destructor
     */
    virtual ~TranslatnDelvryRevision();

private:
    //  Getter method for the Implementation Object
    TranslatnDelvryRevisionImpl*  getTranslatnDelvryRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTranslatnDelvryRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    TranslatnDelvryRevisionImpl*  m_translatndelvryrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param TranslatnDelvryRevision - desc for TranslatnDelvryRevision parameter
     */
    TranslatnDelvryRevision( const TranslatnDelvryRevision& );
    TranslatnDelvryRevision& operator=( const TranslatnDelvryRevision& );

    friend class  TranslatnDelvryRevisionDelegate;
    friend class  TranslatnDelvryRevisionDispatch;
    friend class  TranslatnDelvryRevisionGenImpl;
};

#include <contmgmt/libcontmgmt_undef.h>
#endif //   TEAMCENTER__TRANSLATNDELVRYREVISION__HXX
