//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TransltnOffice
    Filename:   TransltnOffice.hxx
    Module:     contmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TRANSLTNOFFICE__HXX
#define TEAMCENTER__TRANSLTNOFFICE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <contmgmt/libcontmgmt_exports.h>

namespace Teamcenter
{
    class TransltnOffice;
}
namespace Teamcenter
{
    class TransltnOfficeImpl;
}
namespace Teamcenter
{
    class TransltnOfficeDelegate;
}
namespace Teamcenter
{
    class TransltnOfficeDispatch;
}
namespace Teamcenter
{
    class TransltnOfficeGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONTMGMT_API  Teamcenter::TransltnOffice
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    TransltnOffice();

    /**
     * Destructor
     */
    virtual ~TransltnOffice();

private:
    //  Getter method for the Implementation Object
    TransltnOfficeImpl*  getTransltnOfficeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTransltnOfficeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    TransltnOfficeImpl*  m_transltnofficeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param TransltnOffice - desc for TransltnOffice parameter
     */
    TransltnOffice( const TransltnOffice& );
    TransltnOffice& operator=( const TransltnOffice& );

    friend class  TransltnOfficeDelegate;
    friend class  TransltnOfficeDispatch;
    friend class  TransltnOfficeGenImpl;
};

#include <contmgmt/libcontmgmt_undef.h>
#endif //   TEAMCENTER__TRANSLTNOFFICE__HXX
