//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TransltnOfficeDelegate
    Filename:   TransltnOfficeDelegate.hxx
    Module:     contmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TRANSLTNOFFICEDELEGATE_HXX
#define TEAMCENTER__TRANSLTNOFFICEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <contmgmt/TransltnOffice.hxx>

#include <contmgmt/libcontmgmt_exports.h>

namespace Teamcenter
{
    class TransltnOfficeDelegate;
}
namespace Teamcenter
{
    class TransltnOfficeImpl;
}
namespace Teamcenter
{
    class TransltnOffice;
}
namespace Teamcenter
{
    class TransltnOfficeGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CONTMGMT_API Teamcenter_alias::TransltnOfficeDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the TransltnOfficeDelegate instance
    static TransltnOfficeDelegate&  getInstance();

    //  Method to create the TransltnOfficeImpl pointer
    static TransltnOfficeImpl*  createImpl( TransltnOffice&  ifObj );

    //  Method to delete the TransltnOfficeImpl pointer
    static void deleteImpl( TransltnOfficeImpl*  impl );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const TransltnOffice &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static TransltnOfficeDelegate*  m_pInstance;

    TransltnOfficeDelegate();
    virtual ~TransltnOfficeDelegate();
    static void setInstance( TransltnOfficeDelegate*  instance );


private:
    friend class  ::Teamcenter::TransltnOfficeGenImpl;

};

#include <contmgmt/libcontmgmt_undef.h>
#endif  //  TEAMCENTER__TRANSLTNOFFICEDELEGATE_HXX
