//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TransltnOfficeRevision
    Filename:   TransltnOfficeRevision.hxx
    Module:     contmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TRANSLTNOFFICEREVISION__HXX
#define TEAMCENTER__TRANSLTNOFFICEREVISION__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <contmgmt/libcontmgmt_exports.h>

namespace Teamcenter
{
    class TransltnOfficeRevision;
}
namespace Teamcenter
{
    class TransltnOfficeRevisionImpl;
}
namespace Teamcenter
{
    class TransltnOfficeRevisionDelegate;
}
namespace Teamcenter
{
    class TransltnOfficeRevisionDispatch;
}
namespace Teamcenter
{
    class TransltnOfficeRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONTMGMT_API  Teamcenter::TransltnOfficeRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getEmailInbox( std::string &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    TransltnOfficeRevision();

    /**
     * Destructor
     */
    virtual ~TransltnOfficeRevision();

private:
    //  Getter method for the Implementation Object
    TransltnOfficeRevisionImpl*  getTransltnOfficeRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTransltnOfficeRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    TransltnOfficeRevisionImpl*  m_transltnofficerevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param TransltnOfficeRevision - desc for TransltnOfficeRevision parameter
     */
    TransltnOfficeRevision( const TransltnOfficeRevision& );
    TransltnOfficeRevision& operator=( const TransltnOfficeRevision& );

    friend class  TransltnOfficeRevisionDelegate;
    friend class  TransltnOfficeRevisionDispatch;
    friend class  TransltnOfficeRevisionGenImpl;
};

#include <contmgmt/libcontmgmt_undef.h>
#endif //   TEAMCENTER__TRANSLTNOFFICEREVISION__HXX
