//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ctm0BOMLine
    Filename:   Ctm0BOMLine.hxx
    Module:     contmgmtbase
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONTMGMTBASE__CTM0BOMLINE__HXX
#define TEAMCENTER__CONTMGMTBASE__CTM0BOMLINE__HXX

#include <contmgmtbase/DCt_XmlAttrMap.hxx>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <bom/ImanItemLine.hxx>

#include <contmgmtbase/libcontmgmtbase_exports.h>

namespace Teamcenter
{
    namespace contmgmtbase
    {
        class Ctm0BOMLine;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class Ctm0BOMLineImpl;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class Ctm0BOMLineDelegate;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class Ctm0BOMLineDispatch;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class Ctm0BOMLineGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONTMGMTBASE_API  Teamcenter::contmgmtbase::Ctm0BOMLine
     : public  ::Teamcenter::ImanItemLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Maps Compose Attributes
    /// @version Teamcenter 9
    /// @param attributeMap - XML Attribute Map Object
    /// @param functions - Vector Of Functions
    /// @param domDocument - DOM Document
    /// @return - Returns error code
    ///
    int  ctm0ComposeMapAttributes( ::Teamcenter::contmgmtbase::DCt_XmlAttrMap *attributeMap, std::vector< int > *functions, void **domDocument );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ctm0BOMLine();

    /**
     * Destructor
     */
    virtual ~Ctm0BOMLine();

private:
    //  Getter method for the Implementation Object
    Ctm0BOMLineImpl*  getCtm0BOMLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCtm0BOMLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ctm0BOMLineImpl*  m_ctm0bomlineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ctm0BOMLine - desc for Ctm0BOMLine parameter
     */
    Ctm0BOMLine( const Ctm0BOMLine& );
    Ctm0BOMLine& operator=( const Ctm0BOMLine& );

    friend class  Ctm0BOMLineDelegate;
    friend class  Ctm0BOMLineDispatch;
    friend class  Ctm0BOMLineGenImpl;
};

#include <contmgmtbase/libcontmgmtbase_undef.h>
#endif //   TEAMCENTER__CONTMGMTBASE__CTM0BOMLINE__HXX
