//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ctm0BOMWindow
    Filename:   Ctm0BOMWindow.hxx
    Module:     contmgmtbase
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONTMGMTBASE__CTM0BOMWINDOW__HXX
#define TEAMCENTER__CONTMGMTBASE__CTM0BOMWINDOW__HXX

#include <common/tc_deprecation_macros.h>
#include <bom/BOMWindow.hxx>

#include <contmgmtbase/libcontmgmtbase_exports.h>

namespace Teamcenter
{
    namespace contmgmtbase
    {
        class Ctm0BOMWindow;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class Ctm0BOMWindowImpl;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class Ctm0BOMWindowDelegate;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class Ctm0BOMWindowDispatch;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class Ctm0BOMWindowGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONTMGMTBASE_API  Teamcenter::contmgmtbase::Ctm0BOMWindow
     : public  ::Teamcenter::BOMWindow
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ctm0BOMWindow();

    /**
     * Destructor
     */
    virtual ~Ctm0BOMWindow();

private:
    //  Getter method for the Implementation Object
    Ctm0BOMWindowImpl*  getCtm0BOMWindowImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCtm0BOMWindowImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ctm0BOMWindowImpl*  m_ctm0bomwindowImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ctm0BOMWindow - desc for Ctm0BOMWindow parameter
     */
    Ctm0BOMWindow( const Ctm0BOMWindow& );
    Ctm0BOMWindow& operator=( const Ctm0BOMWindow& );

    friend class  Ctm0BOMWindowDelegate;
    friend class  Ctm0BOMWindowDispatch;
    friend class  Ctm0BOMWindowGenImpl;
};

#include <contmgmtbase/libcontmgmtbase_undef.h>
#endif //   TEAMCENTER__CONTMGMTBASE__CTM0BOMWINDOW__HXX
