//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ctm0SNSNode
    Filename:   Ctm0SNSNode.hxx
    Module:     contmgmtbase
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONTMGMTBASE__CTM0SNSNODE__HXX
#define TEAMCENTER__CONTMGMTBASE__CTM0SNSNODE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <contmgmtbase/libcontmgmtbase_exports.h>

namespace Teamcenter
{
    namespace contmgmtbase
    {
        class Ctm0SNSNode;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class Ctm0SNSNodeImpl;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class Ctm0SNSNodeDelegate;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class Ctm0SNSNodeDispatch;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class Ctm0SNSNodeGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONTMGMTBASE_API  Teamcenter::contmgmtbase::Ctm0SNSNode
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ctm0SNSNode();

    /**
     * Destructor
     */
    virtual ~Ctm0SNSNode();

private:
    //  Getter method for the Implementation Object
    Ctm0SNSNodeImpl*  getCtm0SNSNodeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCtm0SNSNodeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ctm0SNSNodeImpl*  m_ctm0snsnodeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ctm0SNSNode - desc for Ctm0SNSNode parameter
     */
    Ctm0SNSNode( const Ctm0SNSNode& );
    Ctm0SNSNode& operator=( const Ctm0SNSNode& );

    friend class  Ctm0SNSNodeDelegate;
    friend class  Ctm0SNSNodeDispatch;
    friend class  Ctm0SNSNodeGenImpl;
};

#include <contmgmtbase/libcontmgmtbase_undef.h>
#endif //   TEAMCENTER__CONTMGMTBASE__CTM0SNSNODE__HXX
