//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DC_Admin
    Filename:   DC_Admin.hxx
    Module:     contmgmtbase
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONTMGMTBASE__DC_ADMIN__HXX
#define TEAMCENTER__CONTMGMTBASE__DC_ADMIN__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <contmgmtbase/libcontmgmtbase_exports.h>

namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_Admin;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_AdminImpl;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_AdminDelegate;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_AdminDispatch;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_AdminGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONTMGMTBASE_API  Teamcenter::contmgmtbase::DC_Admin
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    DC_Admin();

    /**
     * Destructor
     */
    virtual ~DC_Admin();

private:
    //  Getter method for the Implementation Object
    DC_AdminImpl*  getDC_AdminImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDC_AdminImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DC_AdminImpl*  m_dc_adminImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param DC_Admin - desc for DC_Admin parameter
     */
    DC_Admin( const DC_Admin& );
    DC_Admin& operator=( const DC_Admin& );

    friend class  DC_AdminDelegate;
    friend class  DC_AdminDispatch;
    friend class  DC_AdminGenImpl;
};

#include <contmgmtbase/libcontmgmtbase_undef.h>
#endif //   TEAMCENTER__CONTMGMTBASE__DC_ADMIN__HXX
