//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DC_ComposedDoc
    Filename:   DC_ComposedDoc.hxx
    Module:     contmgmtbase
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONTMGMTBASE__DC_COMPOSEDDOC__HXX
#define TEAMCENTER__CONTMGMTBASE__DC_COMPOSEDDOC__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Document.hxx>

#include <contmgmtbase/libcontmgmtbase_exports.h>

namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_ComposedDoc;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_ComposedDocImpl;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_ComposedDocDelegate;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_ComposedDocDispatch;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_ComposedDocGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONTMGMTBASE_API  Teamcenter::contmgmtbase::DC_ComposedDoc
     : public  ::Teamcenter::Document
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    DC_ComposedDoc();

    /**
     * Destructor
     */
    virtual ~DC_ComposedDoc();

private:
    //  Getter method for the Implementation Object
    DC_ComposedDocImpl*  getDC_ComposedDocImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDC_ComposedDocImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DC_ComposedDocImpl*  m_dc_composeddocImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param DC_ComposedDoc - desc for DC_ComposedDoc parameter
     */
    DC_ComposedDoc( const DC_ComposedDoc& );
    DC_ComposedDoc& operator=( const DC_ComposedDoc& );

    friend class  DC_ComposedDocDelegate;
    friend class  DC_ComposedDocDispatch;
    friend class  DC_ComposedDocGenImpl;
};

#include <contmgmtbase/libcontmgmtbase_undef.h>
#endif //   TEAMCENTER__CONTMGMTBASE__DC_COMPOSEDDOC__HXX
