//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DC_ComposedDocRevision
    Filename:   DC_ComposedDocRevision.hxx
    Module:     contmgmtbase
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONTMGMTBASE__DC_COMPOSEDDOCREVISION__HXX
#define TEAMCENTER__CONTMGMTBASE__DC_COMPOSEDDOCREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/DocumentRevision.hxx>

#include <contmgmtbase/libcontmgmtbase_exports.h>

namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_ComposedDocRevision;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_ComposedDocRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_ComposedDocRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_ComposedDocRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_ComposedDocRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONTMGMTBASE_API  Teamcenter::contmgmtbase::DC_ComposedDocRevision
     : public  ::Teamcenter::DocumentRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    DC_ComposedDocRevision();

    /**
     * Destructor
     */
    virtual ~DC_ComposedDocRevision();

private:
    //  Getter method for the Implementation Object
    DC_ComposedDocRevisionImpl*  getDC_ComposedDocRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDC_ComposedDocRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DC_ComposedDocRevisionImpl*  m_dc_composeddocrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param DC_ComposedDocRevision - desc for DC_ComposedDocRevision parameter
     */
    DC_ComposedDocRevision( const DC_ComposedDocRevision& );
    DC_ComposedDocRevision& operator=( const DC_ComposedDocRevision& );

    friend class  DC_ComposedDocRevisionDelegate;
    friend class  DC_ComposedDocRevisionDispatch;
    friend class  DC_ComposedDocRevisionGenImpl;
};

#include <contmgmtbase/libcontmgmtbase_undef.h>
#endif //   TEAMCENTER__CONTMGMTBASE__DC_COMPOSEDDOCREVISION__HXX
