//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DC_ExtEntAdmin
    Filename:   DC_ExtEntAdmin.hxx
    Module:     contmgmtbase
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONTMGMTBASE__DC_EXTENTADMIN__HXX
#define TEAMCENTER__CONTMGMTBASE__DC_EXTENTADMIN__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <contmgmtbase/libcontmgmtbase_exports.h>

namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_ExtEntAdmin;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_ExtEntAdminImpl;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_ExtEntAdminDelegate;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_ExtEntAdminDispatch;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_ExtEntAdminGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONTMGMTBASE_API  Teamcenter::contmgmtbase::DC_ExtEntAdmin
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    DC_ExtEntAdmin();

    /**
     * Destructor
     */
    virtual ~DC_ExtEntAdmin();

private:
    //  Getter method for the Implementation Object
    DC_ExtEntAdminImpl*  getDC_ExtEntAdminImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDC_ExtEntAdminImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DC_ExtEntAdminImpl*  m_dc_extentadminImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param DC_ExtEntAdmin - desc for DC_ExtEntAdmin parameter
     */
    DC_ExtEntAdmin( const DC_ExtEntAdmin& );
    DC_ExtEntAdmin& operator=( const DC_ExtEntAdmin& );

    friend class  DC_ExtEntAdminDelegate;
    friend class  DC_ExtEntAdminDispatch;
    friend class  DC_ExtEntAdminGenImpl;
};

#include <contmgmtbase/libcontmgmtbase_undef.h>
#endif //   TEAMCENTER__CONTMGMTBASE__DC_EXTENTADMIN__HXX
