//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DC_GrphcAttrMap
    Filename:   DC_GrphcAttrMap.hxx
    Module:     contmgmtbase
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONTMGMTBASE__DC_GRPHCATTRMAP__HXX
#define TEAMCENTER__CONTMGMTBASE__DC_GRPHCATTRMAP__HXX

#include <common/tc_deprecation_macros.h>
#include <contmgmtbase/DC_Admin.hxx>

#include <contmgmtbase/libcontmgmtbase_exports.h>

namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_GrphcAttrMap;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_GrphcAttrMapImpl;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_GrphcAttrMapDelegate;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_GrphcAttrMapDispatch;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_GrphcAttrMapGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONTMGMTBASE_API  Teamcenter::contmgmtbase::DC_GrphcAttrMap
     : public  ::Teamcenter::contmgmtbase::DC_Admin
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    DC_GrphcAttrMap();

    /**
     * Destructor
     */
    virtual ~DC_GrphcAttrMap();

private:
    //  Getter method for the Implementation Object
    DC_GrphcAttrMapImpl*  getDC_GrphcAttrMapImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDC_GrphcAttrMapImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DC_GrphcAttrMapImpl*  m_dc_grphcattrmapImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param DC_GrphcAttrMap - desc for DC_GrphcAttrMap parameter
     */
    DC_GrphcAttrMap( const DC_GrphcAttrMap& );
    DC_GrphcAttrMap& operator=( const DC_GrphcAttrMap& );

    friend class  DC_GrphcAttrMapDelegate;
    friend class  DC_GrphcAttrMapDispatch;
    friend class  DC_GrphcAttrMapGenImpl;
};

#include <contmgmtbase/libcontmgmtbase_undef.h>
#endif //   TEAMCENTER__CONTMGMTBASE__DC_GRPHCATTRMAP__HXX
