//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DC_ProcedureRevision
    Filename:   DC_ProcedureRevision.hxx
    Module:     contmgmtbase
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONTMGMTBASE__DC_PROCEDUREREVISION__HXX
#define TEAMCENTER__CONTMGMTBASE__DC_PROCEDUREREVISION__HXX

#include <unidefs.h>
#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <contmgmtbase/libcontmgmtbase_exports.h>

namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_ProcedureRevision;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_ProcedureRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_ProcedureRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_ProcedureRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_ProcedureRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONTMGMTBASE_API  Teamcenter::contmgmtbase::DC_ProcedureRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Executes a procedure on the topic and dom document
    /// @version Teamcenter 9
    /// @param itemRevision - Topic or Publication Revision
    /// @param tempPath - The path of the temp directory
    /// @param xmlAttrMap - Xml Attribute Map
    /// @param domDocument - Dom Document
    /// @return - Error code
    ///
    int  ctm0ExecuteProcedure( tag_t *itemRevision, std::string *tempPath, tag_t *xmlAttrMap, void **domDocument );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    DC_ProcedureRevision();

    /**
     * Destructor
     */
    virtual ~DC_ProcedureRevision();

private:
    //  Getter method for the Implementation Object
    DC_ProcedureRevisionImpl*  getDC_ProcedureRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDC_ProcedureRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DC_ProcedureRevisionImpl*  m_dc_procedurerevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param DC_ProcedureRevision - desc for DC_ProcedureRevision parameter
     */
    DC_ProcedureRevision( const DC_ProcedureRevision& );
    DC_ProcedureRevision& operator=( const DC_ProcedureRevision& );

    friend class  DC_ProcedureRevisionDelegate;
    friend class  DC_ProcedureRevisionDispatch;
    friend class  DC_ProcedureRevisionGenImpl;
};

#include <contmgmtbase/libcontmgmtbase_undef.h>
#endif //   TEAMCENTER__CONTMGMTBASE__DC_PROCEDUREREVISION__HXX
