//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DC_ProcedureRevisionDelegate
    Filename:   DC_ProcedureRevisionDelegate.hxx
    Module:     contmgmtbase
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONTMGMTBASE__DC_PROCEDUREREVISIONDELEGATE_HXX
#define TEAMCENTER__CONTMGMTBASE__DC_PROCEDUREREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <contmgmtbase/DC_ProcedureRevision.hxx>

#include <contmgmtbase/libcontmgmtbase_exports.h>

namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_ProcedureRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_ProcedureRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_ProcedureRevision;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_ProcedureRevisionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CONTMGMTBASE_API Teamcenter_alias::contmgmtbase::DC_ProcedureRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the DC_ProcedureRevisionDelegate instance
    static DC_ProcedureRevisionDelegate&  getInstance();

    //  Method to create the DC_ProcedureRevisionImpl pointer
    static DC_ProcedureRevisionImpl*  createImpl( DC_ProcedureRevision&  ifObj );

    //  Method to delete the DC_ProcedureRevisionImpl pointer
    static void deleteImpl( DC_ProcedureRevisionImpl*  impl );


    ///
    /// Executes a procedure on the topic and dom document
    /// @version Teamcenter 9
    /// @param itemRevision - Topic or Publication Revision
    /// @param tempPath - The path of the temp directory
    /// @param xmlAttrMap - Xml Attribute Map
    /// @param domDocument - Dom Document
    /// @return - Error code
    ///
    int  ctm0ExecuteProcedureBase(const DC_ProcedureRevision &ifObj,  tag_t *itemRevision, std::string *tempPath, tag_t *xmlAttrMap, void **domDocument );



protected:
    //  Pointer to the instance
    static DC_ProcedureRevisionDelegate*  m_pInstance;

    DC_ProcedureRevisionDelegate();
    virtual ~DC_ProcedureRevisionDelegate();
    static void setInstance( DC_ProcedureRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::contmgmtbase::DC_ProcedureRevisionGenImpl;

};

#include <contmgmtbase/libcontmgmtbase_undef.h>
#endif  //  TEAMCENTER__CONTMGMTBASE__DC_PROCEDUREREVISIONDELEGATE_HXX
