//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DC_PubType
    Filename:   DC_PubType.hxx
    Module:     contmgmtbase
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONTMGMTBASE__DC_PUBTYPE__HXX
#define TEAMCENTER__CONTMGMTBASE__DC_PUBTYPE__HXX

#include <common/tc_deprecation_macros.h>
#include <contmgmtbase/DC_TopicType.hxx>

#include <contmgmtbase/libcontmgmtbase_exports.h>

namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_PubType;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_PubTypeImpl;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_PubTypeDelegate;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_PubTypeDispatch;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_PubTypeGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONTMGMTBASE_API  Teamcenter::contmgmtbase::DC_PubType
     : public  ::Teamcenter::contmgmtbase::DC_TopicType
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    DC_PubType();

    /**
     * Destructor
     */
    virtual ~DC_PubType();

private:
    //  Getter method for the Implementation Object
    DC_PubTypeImpl*  getDC_PubTypeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDC_PubTypeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DC_PubTypeImpl*  m_dc_pubtypeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param DC_PubType - desc for DC_PubType parameter
     */
    DC_PubType( const DC_PubType& );
    DC_PubType& operator=( const DC_PubType& );

    friend class  DC_PubTypeDelegate;
    friend class  DC_PubTypeDispatch;
    friend class  DC_PubTypeGenImpl;
};

#include <contmgmtbase/libcontmgmtbase_undef.h>
#endif //   TEAMCENTER__CONTMGMTBASE__DC_PUBTYPE__HXX
