//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DC_Publication
    Filename:   DC_Publication.hxx
    Module:     contmgmtbase
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONTMGMTBASE__DC_PUBLICATION__HXX
#define TEAMCENTER__CONTMGMTBASE__DC_PUBLICATION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Document.hxx>

#include <contmgmtbase/libcontmgmtbase_exports.h>

namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_Publication;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_PublicationImpl;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_PublicationDelegate;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_PublicationDispatch;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_PublicationGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONTMGMTBASE_API  Teamcenter::contmgmtbase::DC_Publication
     : public  ::Teamcenter::Document
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    DC_Publication();

    /**
     * Destructor
     */
    virtual ~DC_Publication();

private:
    //  Getter method for the Implementation Object
    DC_PublicationImpl*  getDC_PublicationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDC_PublicationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DC_PublicationImpl*  m_dc_publicationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param DC_Publication - desc for DC_Publication parameter
     */
    DC_Publication( const DC_Publication& );
    DC_Publication& operator=( const DC_Publication& );

    friend class  DC_PublicationDelegate;
    friend class  DC_PublicationDispatch;
    friend class  DC_PublicationGenImpl;
};

#include <contmgmtbase/libcontmgmtbase_undef.h>
#endif //   TEAMCENTER__CONTMGMTBASE__DC_PUBLICATION__HXX
