//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DC_PublicationRevision
    Filename:   DC_PublicationRevision.hxx
    Module:     contmgmtbase
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONTMGMTBASE__DC_PUBLICATIONREVISION__HXX
#define TEAMCENTER__CONTMGMTBASE__DC_PUBLICATIONREVISION__HXX

#include <vector>
#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/DocumentRevision.hxx>

#include <contmgmtbase/libcontmgmtbase_exports.h>

namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_PublicationRevision;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_PublicationRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_PublicationRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_PublicationRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_PublicationRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONTMGMTBASE_API  Teamcenter::contmgmtbase::DC_PublicationRevision
     : public  ::Teamcenter::DocumentRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCtm0VersionNumber( std::string &value, bool &isNull ) const;

    ///
    /// Maps Decompose Attributes
    /// @version Teamcenter 9
    /// @param functions - Vector Of Functions
    /// @param domDocument - DOM Document
    /// @param domChanged - Flag set if the DOM document was changed during decompose.
    /// @return - Returns error code
    ///
    int  ctm0DecomposeMapAttributesBase( std::vector< int > *functions, void **domDocument, bool &domChanged );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    DC_PublicationRevision();

    /**
     * Destructor
     */
    virtual ~DC_PublicationRevision();

private:
    //  Getter method for the Implementation Object
    DC_PublicationRevisionImpl*  getDC_PublicationRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDC_PublicationRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DC_PublicationRevisionImpl*  m_dc_publicationrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param DC_PublicationRevision - desc for DC_PublicationRevision parameter
     */
    DC_PublicationRevision( const DC_PublicationRevision& );
    DC_PublicationRevision& operator=( const DC_PublicationRevision& );

    friend class  DC_PublicationRevisionDelegate;
    friend class  DC_PublicationRevisionDispatch;
    friend class  DC_PublicationRevisionGenImpl;
};

#include <contmgmtbase/libcontmgmtbase_undef.h>
#endif //   TEAMCENTER__CONTMGMTBASE__DC_PUBLICATIONREVISION__HXX
