//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DC_PublicationRevisionDelegate
    Filename:   DC_PublicationRevisionDelegate.hxx
    Module:     contmgmtbase
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONTMGMTBASE__DC_PUBLICATIONREVISIONDELEGATE_HXX
#define TEAMCENTER__CONTMGMTBASE__DC_PUBLICATIONREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <contmgmtbase/DC_PublicationRevision.hxx>

#include <contmgmtbase/libcontmgmtbase_exports.h>

namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_PublicationRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_PublicationRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_PublicationRevision;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_PublicationRevisionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CONTMGMTBASE_API Teamcenter_alias::contmgmtbase::DC_PublicationRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the DC_PublicationRevisionDelegate instance
    static DC_PublicationRevisionDelegate&  getInstance();

    //  Method to create the DC_PublicationRevisionImpl pointer
    static DC_PublicationRevisionImpl*  createImpl( DC_PublicationRevision&  ifObj );

    //  Method to delete the DC_PublicationRevisionImpl pointer
    static void deleteImpl( DC_PublicationRevisionImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCtm0VersionNumberBase(const DC_PublicationRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Maps Decompose Attributes
    /// @version Teamcenter 9
    /// @param functions - Vector Of Functions
    /// @param domDocument - DOM Document
    /// @param domChanged - Flag set if the DOM document was changed during decompose.
    /// @return - Returns error code
    ///
    int  ctm0DecomposeMapAttributesBaseBase(const DC_PublicationRevision &ifObj,  std::vector< int > *functions, void **domDocument, bool &domChanged );



protected:
    //  Pointer to the instance
    static DC_PublicationRevisionDelegate*  m_pInstance;

    DC_PublicationRevisionDelegate();
    virtual ~DC_PublicationRevisionDelegate();
    static void setInstance( DC_PublicationRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::contmgmtbase::DC_PublicationRevisionGenImpl;

};

#include <contmgmtbase/libcontmgmtbase_undef.h>
#endif  //  TEAMCENTER__CONTMGMTBASE__DC_PUBLICATIONREVISIONDELEGATE_HXX
