//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DC_RefTopicType
    Filename:   DC_RefTopicType.hxx
    Module:     contmgmtbase
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONTMGMTBASE__DC_REFTOPICTYPE__HXX
#define TEAMCENTER__CONTMGMTBASE__DC_REFTOPICTYPE__HXX

#include <common/tc_deprecation_macros.h>
#include <contmgmtbase/DC_TopicType.hxx>

#include <contmgmtbase/libcontmgmtbase_exports.h>

namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_RefTopicType;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_RefTopicTypeImpl;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_RefTopicTypeDelegate;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_RefTopicTypeDispatch;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_RefTopicTypeGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONTMGMTBASE_API  Teamcenter::contmgmtbase::DC_RefTopicType
     : public  ::Teamcenter::contmgmtbase::DC_TopicType
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    DC_RefTopicType();

    /**
     * Destructor
     */
    virtual ~DC_RefTopicType();

private:
    //  Getter method for the Implementation Object
    DC_RefTopicTypeImpl*  getDC_RefTopicTypeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDC_RefTopicTypeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DC_RefTopicTypeImpl*  m_dc_reftopictypeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param DC_RefTopicType - desc for DC_RefTopicType parameter
     */
    DC_RefTopicType( const DC_RefTopicType& );
    DC_RefTopicType& operator=( const DC_RefTopicType& );

    friend class  DC_RefTopicTypeDelegate;
    friend class  DC_RefTopicTypeDispatch;
    friend class  DC_RefTopicTypeGenImpl;
};

#include <contmgmtbase/libcontmgmtbase_undef.h>
#endif //   TEAMCENTER__CONTMGMTBASE__DC_REFTOPICTYPE__HXX
