//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DC_ReviewerDoc
    Filename:   DC_ReviewerDoc.hxx
    Module:     contmgmtbase
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONTMGMTBASE__DC_REVIEWERDOC__HXX
#define TEAMCENTER__CONTMGMTBASE__DC_REVIEWERDOC__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Document.hxx>

#include <contmgmtbase/libcontmgmtbase_exports.h>

namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_ReviewerDoc;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_ReviewerDocImpl;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_ReviewerDocDelegate;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_ReviewerDocDispatch;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_ReviewerDocGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONTMGMTBASE_API  Teamcenter::contmgmtbase::DC_ReviewerDoc
     : public  ::Teamcenter::Document
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    DC_ReviewerDoc();

    /**
     * Destructor
     */
    virtual ~DC_ReviewerDoc();

private:
    //  Getter method for the Implementation Object
    DC_ReviewerDocImpl*  getDC_ReviewerDocImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDC_ReviewerDocImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DC_ReviewerDocImpl*  m_dc_reviewerdocImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param DC_ReviewerDoc - desc for DC_ReviewerDoc parameter
     */
    DC_ReviewerDoc( const DC_ReviewerDoc& );
    DC_ReviewerDoc& operator=( const DC_ReviewerDoc& );

    friend class  DC_ReviewerDocDelegate;
    friend class  DC_ReviewerDocDispatch;
    friend class  DC_ReviewerDocGenImpl;
};

#include <contmgmtbase/libcontmgmtbase_undef.h>
#endif //   TEAMCENTER__CONTMGMTBASE__DC_REVIEWERDOC__HXX
