//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DC_ReviewerDocRevision
    Filename:   DC_ReviewerDocRevision.hxx
    Module:     contmgmtbase
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONTMGMTBASE__DC_REVIEWERDOCREVISION__HXX
#define TEAMCENTER__CONTMGMTBASE__DC_REVIEWERDOCREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/DocumentRevision.hxx>

#include <contmgmtbase/libcontmgmtbase_exports.h>

namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_ReviewerDocRevision;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_ReviewerDocRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_ReviewerDocRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_ReviewerDocRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_ReviewerDocRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONTMGMTBASE_API  Teamcenter::contmgmtbase::DC_ReviewerDocRevision
     : public  ::Teamcenter::DocumentRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    DC_ReviewerDocRevision();

    /**
     * Destructor
     */
    virtual ~DC_ReviewerDocRevision();

private:
    //  Getter method for the Implementation Object
    DC_ReviewerDocRevisionImpl*  getDC_ReviewerDocRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDC_ReviewerDocRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DC_ReviewerDocRevisionImpl*  m_dc_reviewerdocrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param DC_ReviewerDocRevision - desc for DC_ReviewerDocRevision parameter
     */
    DC_ReviewerDocRevision( const DC_ReviewerDocRevision& );
    DC_ReviewerDocRevision& operator=( const DC_ReviewerDocRevision& );

    friend class  DC_ReviewerDocRevisionDelegate;
    friend class  DC_ReviewerDocRevisionDispatch;
    friend class  DC_ReviewerDocRevisionGenImpl;
};

#include <contmgmtbase/libcontmgmtbase_undef.h>
#endif //   TEAMCENTER__CONTMGMTBASE__DC_REVIEWERDOCREVISION__HXX
