//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DC_Topic
    Filename:   DC_Topic.hxx
    Module:     contmgmtbase
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONTMGMTBASE__DC_TOPIC__HXX
#define TEAMCENTER__CONTMGMTBASE__DC_TOPIC__HXX

#include <common/tc_deprecation_macros.h>
#include <req/SpecElement.hxx>

#include <contmgmtbase/libcontmgmtbase_exports.h>

namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_Topic;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_TopicImpl;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_TopicDelegate;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_TopicDispatch;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_TopicGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONTMGMTBASE_API  Teamcenter::contmgmtbase::DC_Topic
     : public  ::Teamcenter::SpecElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    DC_Topic();

    /**
     * Destructor
     */
    virtual ~DC_Topic();

private:
    //  Getter method for the Implementation Object
    DC_TopicImpl*  getDC_TopicImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDC_TopicImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DC_TopicImpl*  m_dc_topicImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param DC_Topic - desc for DC_Topic parameter
     */
    DC_Topic( const DC_Topic& );
    DC_Topic& operator=( const DC_Topic& );

    friend class  DC_TopicDelegate;
    friend class  DC_TopicDispatch;
    friend class  DC_TopicGenImpl;
};

#include <contmgmtbase/libcontmgmtbase_undef.h>
#endif //   TEAMCENTER__CONTMGMTBASE__DC_TOPIC__HXX
