//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DC_TopicRevision
    Filename:   DC_TopicRevision.hxx
    Module:     contmgmtbase
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONTMGMTBASE__DC_TOPICREVISION__HXX
#define TEAMCENTER__CONTMGMTBASE__DC_TOPICREVISION__HXX

#include <string>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <req/SpecElementRevision.hxx>

#include <contmgmtbase/libcontmgmtbase_exports.h>

namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_TopicRevision;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_TopicRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_TopicRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_TopicRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_TopicRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONTMGMTBASE_API  Teamcenter::contmgmtbase::DC_TopicRevision
     : public  ::Teamcenter::SpecElementRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCtm0VersionNumber( std::string &value, bool &isNull ) const;

    ///
    /// This operation is primary used by s1000d to convert the sgml content to xml. It does nothing in base content management.
    /// @version Teamcenter 9
    /// @param inFileName - The name of the file to be converted.
    /// @param outFileName - The name of the converted file name
    /// @return - error code
    ///
    int  ctm0ConvertContent( const std::string *inFileName, std::string *outFileName );

    ///
    /// This operation is used by s1000d to convert the xpath on the attribute map
    /// @version Teamcenter 9
    /// @param xamPath - xamPath from xml attribute map
    /// @return - Error code
    ///
    int  ctm0ConvertXAMPath( std::string &xamPath );

    ///
    /// Maps decomposed attributes
    /// @version Teamcenter 9
    /// @param functions - Vector Of Functions
    /// @param domDocument - DOM Document
    /// @param domChanged - Flag set if the DOM document was changed during decompose.
    /// @return - Returns error code
    ///
    int  ctm0DecomposeMapAttributes( std::vector< int > *functions, void **domDocument, bool &domChanged );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    DC_TopicRevision();

    /**
     * Destructor
     */
    virtual ~DC_TopicRevision();

private:
    //  Getter method for the Implementation Object
    DC_TopicRevisionImpl*  getDC_TopicRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDC_TopicRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DC_TopicRevisionImpl*  m_dc_topicrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param DC_TopicRevision - desc for DC_TopicRevision parameter
     */
    DC_TopicRevision( const DC_TopicRevision& );
    DC_TopicRevision& operator=( const DC_TopicRevision& );

    friend class  DC_TopicRevisionDelegate;
    friend class  DC_TopicRevisionDispatch;
    friend class  DC_TopicRevisionGenImpl;
};

#include <contmgmtbase/libcontmgmtbase_undef.h>
#endif //   TEAMCENTER__CONTMGMTBASE__DC_TOPICREVISION__HXX
