//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DC_TopicRevisionDelegate
    Filename:   DC_TopicRevisionDelegate.hxx
    Module:     contmgmtbase
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONTMGMTBASE__DC_TOPICREVISIONDELEGATE_HXX
#define TEAMCENTER__CONTMGMTBASE__DC_TOPICREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <contmgmtbase/DC_TopicRevision.hxx>

#include <contmgmtbase/libcontmgmtbase_exports.h>

namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_TopicRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_TopicRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_TopicRevision;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_TopicRevisionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CONTMGMTBASE_API Teamcenter_alias::contmgmtbase::DC_TopicRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the DC_TopicRevisionDelegate instance
    static DC_TopicRevisionDelegate&  getInstance();

    //  Method to create the DC_TopicRevisionImpl pointer
    static DC_TopicRevisionImpl*  createImpl( DC_TopicRevision&  ifObj );

    //  Method to delete the DC_TopicRevisionImpl pointer
    static void deleteImpl( DC_TopicRevisionImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCtm0VersionNumberBase(const DC_TopicRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// This operation is primary used by s1000d to convert the sgml content to xml. It does nothing in base content management.
    /// @version Teamcenter 9
    /// @param inFileName - The name of the file to be converted.
    /// @param outFileName - The name of the converted file name
    /// @return - error code
    ///
    int  ctm0ConvertContentBase(const DC_TopicRevision &ifObj,  const std::string *inFileName, std::string *outFileName );


    ///
    /// This operation is used by s1000d to convert the xpath on the attribute map
    /// @version Teamcenter 9
    /// @param xamPath - xamPath from xml attribute map
    /// @return - Error code
    ///
    int  ctm0ConvertXAMPathBase(const DC_TopicRevision &ifObj,  std::string &xamPath );


    ///
    /// Maps decomposed attributes
    /// @version Teamcenter 9
    /// @param functions - Vector Of Functions
    /// @param domDocument - DOM Document
    /// @param domChanged - Flag set if the DOM document was changed during decompose.
    /// @return - Returns error code
    ///
    int  ctm0DecomposeMapAttributesBase(const DC_TopicRevision &ifObj,  std::vector< int > *functions, void **domDocument, bool &domChanged );



protected:
    //  Pointer to the instance
    static DC_TopicRevisionDelegate*  m_pInstance;

    DC_TopicRevisionDelegate();
    virtual ~DC_TopicRevisionDelegate();
    static void setInstance( DC_TopicRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::contmgmtbase::DC_TopicRevisionGenImpl;

};

#include <contmgmtbase/libcontmgmtbase_undef.h>
#endif  //  TEAMCENTER__CONTMGMTBASE__DC_TOPICREVISIONDELEGATE_HXX
