//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DC_TopicType
    Filename:   DC_TopicType.hxx
    Module:     contmgmtbase
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONTMGMTBASE__DC_TOPICTYPE__HXX
#define TEAMCENTER__CONTMGMTBASE__DC_TOPICTYPE__HXX

#include <common/tc_deprecation_macros.h>
#include <contmgmtbase/DC_Admin.hxx>

#include <contmgmtbase/libcontmgmtbase_exports.h>

namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_TopicType;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_TopicTypeImpl;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_TopicTypeDelegate;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_TopicTypeDispatch;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_TopicTypeGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONTMGMTBASE_API  Teamcenter::contmgmtbase::DC_TopicType
     : public  ::Teamcenter::contmgmtbase::DC_Admin
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    DC_TopicType();

    /**
     * Destructor
     */
    virtual ~DC_TopicType();

private:
    //  Getter method for the Implementation Object
    DC_TopicTypeImpl*  getDC_TopicTypeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDC_TopicTypeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DC_TopicTypeImpl*  m_dc_topictypeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param DC_TopicType - desc for DC_TopicType parameter
     */
    DC_TopicType( const DC_TopicType& );
    DC_TopicType& operator=( const DC_TopicType& );

    friend class  DC_TopicTypeDelegate;
    friend class  DC_TopicTypeDispatch;
    friend class  DC_TopicTypeGenImpl;
};

#include <contmgmtbase/libcontmgmtbase_undef.h>
#endif //   TEAMCENTER__CONTMGMTBASE__DC_TOPICTYPE__HXX
