//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DC_TransfPolicy
    Filename:   DC_TransfPolicy.hxx
    Module:     contmgmtbase
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONTMGMTBASE__DC_TRANSFPOLICY__HXX
#define TEAMCENTER__CONTMGMTBASE__DC_TRANSFPOLICY__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <contmgmtbase/DC_Admin.hxx>

#include <contmgmtbase/libcontmgmtbase_exports.h>

namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_TransfPolicy;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_TransfPolicyImpl;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_TransfPolicyDelegate;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_TransfPolicyDispatch;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_TransfPolicyGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONTMGMTBASE_API  Teamcenter::contmgmtbase::DC_TransfPolicy
     : public  ::Teamcenter::contmgmtbase::DC_Admin
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// transforms the input xml using an xslt
    /// @version Teamcenter 9
    /// @param userAction - user action code
    /// @param toolName - name of the tool
    /// @param inputXMLFileName - name of the xml file to be transformed
    /// @param outputXMLFileName - Name of the output xml file
    /// @return - error code
    ///
    int  ctm0Transform( const int userAction, const std::string *toolName, const std::string *inputXMLFileName, std::string *outputXMLFileName );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    DC_TransfPolicy();

    /**
     * Destructor
     */
    virtual ~DC_TransfPolicy();

private:
    //  Getter method for the Implementation Object
    DC_TransfPolicyImpl*  getDC_TransfPolicyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDC_TransfPolicyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DC_TransfPolicyImpl*  m_dc_transfpolicyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param DC_TransfPolicy - desc for DC_TransfPolicy parameter
     */
    DC_TransfPolicy( const DC_TransfPolicy& );
    DC_TransfPolicy& operator=( const DC_TransfPolicy& );

    friend class  DC_TransfPolicyDelegate;
    friend class  DC_TransfPolicyDispatch;
    friend class  DC_TransfPolicyGenImpl;
};

#include <contmgmtbase/libcontmgmtbase_undef.h>
#endif //   TEAMCENTER__CONTMGMTBASE__DC_TRANSFPOLICY__HXX
