//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DC_TransfPolicyDelegate
    Filename:   DC_TransfPolicyDelegate.hxx
    Module:     contmgmtbase
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONTMGMTBASE__DC_TRANSFPOLICYDELEGATE_HXX
#define TEAMCENTER__CONTMGMTBASE__DC_TRANSFPOLICYDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <contmgmtbase/DC_TransfPolicy.hxx>

#include <contmgmtbase/libcontmgmtbase_exports.h>

namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_TransfPolicyDelegate;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_TransfPolicyImpl;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_TransfPolicy;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DC_TransfPolicyGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CONTMGMTBASE_API Teamcenter_alias::contmgmtbase::DC_TransfPolicyDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the DC_TransfPolicyDelegate instance
    static DC_TransfPolicyDelegate&  getInstance();

    //  Method to create the DC_TransfPolicyImpl pointer
    static DC_TransfPolicyImpl*  createImpl( DC_TransfPolicy&  ifObj );

    //  Method to delete the DC_TransfPolicyImpl pointer
    static void deleteImpl( DC_TransfPolicyImpl*  impl );


    ///
    /// transforms the input xml using an xslt
    /// @version Teamcenter 9
    /// @param userAction - user action code
    /// @param toolName - name of the tool
    /// @param inputXMLFileName - name of the xml file to be transformed
    /// @param outputXMLFileName - Name of the output xml file
    /// @return - error code
    ///
    int  ctm0TransformBase(const DC_TransfPolicy &ifObj,  const int userAction, const std::string *toolName, const std::string *inputXMLFileName, std::string *outputXMLFileName );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const DC_TransfPolicy &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static DC_TransfPolicyDelegate*  m_pInstance;

    DC_TransfPolicyDelegate();
    virtual ~DC_TransfPolicyDelegate();
    static void setInstance( DC_TransfPolicyDelegate*  instance );


private:
    friend class  ::Teamcenter::contmgmtbase::DC_TransfPolicyGenImpl;

};

#include <contmgmtbase/libcontmgmtbase_undef.h>
#endif  //  TEAMCENTER__CONTMGMTBASE__DC_TRANSFPOLICYDELEGATE_HXX
