//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DCt_ItemRevision
    Filename:   DCt_ItemRevision.hxx
    Module:     contmgmtbase
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONTMGMTBASE__DCT_ITEMREVISION__HXX
#define TEAMCENTER__CONTMGMTBASE__DCT_ITEMREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <contmgmtbase/libcontmgmtbase_exports.h>

namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DCt_ItemRevision;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DCt_ItemRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DCt_ItemRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DCt_ItemRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DCt_ItemRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONTMGMTBASE_API  Teamcenter::contmgmtbase::DCt_ItemRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    DCt_ItemRevision();

    /**
     * Destructor
     */
    virtual ~DCt_ItemRevision();

private:
    //  Getter method for the Implementation Object
    DCt_ItemRevisionImpl*  getDCt_ItemRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDCt_ItemRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DCt_ItemRevisionImpl*  m_dct_itemrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param DCt_ItemRevision - desc for DCt_ItemRevision parameter
     */
    DCt_ItemRevision( const DCt_ItemRevision& );
    DCt_ItemRevision& operator=( const DCt_ItemRevision& );

    friend class  DCt_ItemRevisionDelegate;
    friend class  DCt_ItemRevisionDispatch;
    friend class  DCt_ItemRevisionGenImpl;
};

#include <contmgmtbase/libcontmgmtbase_undef.h>
#endif //   TEAMCENTER__CONTMGMTBASE__DCT_ITEMREVISION__HXX
