//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DCt_TranslationRevision
    Filename:   DCt_TranslationRevision.hxx
    Module:     contmgmtbase
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONTMGMTBASE__DCT_TRANSLATIONREVISION__HXX
#define TEAMCENTER__CONTMGMTBASE__DCT_TRANSLATIONREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <contmgmtbase/DCt_ItemRevision.hxx>

#include <contmgmtbase/libcontmgmtbase_exports.h>

namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DCt_TranslationRevision;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DCt_TranslationRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DCt_TranslationRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DCt_TranslationRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DCt_TranslationRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONTMGMTBASE_API  Teamcenter::contmgmtbase::DCt_TranslationRevision
     : public  ::Teamcenter::contmgmtbase::DCt_ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    DCt_TranslationRevision();

    /**
     * Destructor
     */
    virtual ~DCt_TranslationRevision();

private:
    //  Getter method for the Implementation Object
    DCt_TranslationRevisionImpl*  getDCt_TranslationRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDCt_TranslationRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DCt_TranslationRevisionImpl*  m_dct_translationrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param DCt_TranslationRevision - desc for DCt_TranslationRevision parameter
     */
    DCt_TranslationRevision( const DCt_TranslationRevision& );
    DCt_TranslationRevision& operator=( const DCt_TranslationRevision& );

    friend class  DCt_TranslationRevisionDelegate;
    friend class  DCt_TranslationRevisionDispatch;
    friend class  DCt_TranslationRevisionGenImpl;
};

#include <contmgmtbase/libcontmgmtbase_undef.h>
#endif //   TEAMCENTER__CONTMGMTBASE__DCT_TRANSLATIONREVISION__HXX
