//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DCt_XmlAttrMap
    Filename:   DCt_XmlAttrMap.hxx
    Module:     contmgmtbase
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONTMGMTBASE__DCT_XMLATTRMAP__HXX
#define TEAMCENTER__CONTMGMTBASE__DCT_XMLATTRMAP__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <contmgmtbase/DC_Admin.hxx>

#include <contmgmtbase/libcontmgmtbase_exports.h>

namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DCt_XmlAttrMap;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DCt_XmlAttrMapImpl;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DCt_XmlAttrMapDelegate;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DCt_XmlAttrMapDispatch;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DCt_XmlAttrMapGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONTMGMTBASE_API  Teamcenter::contmgmtbase::DCt_XmlAttrMap
     : public  ::Teamcenter::contmgmtbase::DC_Admin
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Gets the DOMNode value
    /// @version Teamcenter 9
    /// @param elementRoot - The element root of the document
    /// @param xamPath - The path of the node to be set
    /// @param nodeValue - The value of the node
    /// @param targetNode - DOMNode found in xamPath
    /// @return - Error code and value
    ///
    int  ctm0GetDOMNode( void *elementRoot, std::string *xamPath, std::string *nodeValue, void **targetNode );

    ///
    /// Sets the DOMNode to the value
    /// @version Teamcenter 9
    /// @param elementRoot - The element root of the document
    /// @param xamPath - The path of the node to be set
    /// @param nodeValue - The value to set the node
    /// @param targetNode - DOMNode found in xamPath
    /// @return - Error code and target Node
    ///
    int  ctm0SetDOMNode( void *elementRoot, std::string *xamPath, std::string *nodeValue, void **targetNode );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    DCt_XmlAttrMap();

    /**
     * Destructor
     */
    virtual ~DCt_XmlAttrMap();

private:
    //  Getter method for the Implementation Object
    DCt_XmlAttrMapImpl*  getDCt_XmlAttrMapImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDCt_XmlAttrMapImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DCt_XmlAttrMapImpl*  m_dct_xmlattrmapImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param DCt_XmlAttrMap - desc for DCt_XmlAttrMap parameter
     */
    DCt_XmlAttrMap( const DCt_XmlAttrMap& );
    DCt_XmlAttrMap& operator=( const DCt_XmlAttrMap& );

    friend class  DCt_XmlAttrMapDelegate;
    friend class  DCt_XmlAttrMapDispatch;
    friend class  DCt_XmlAttrMapGenImpl;
};

#include <contmgmtbase/libcontmgmtbase_undef.h>
#endif //   TEAMCENTER__CONTMGMTBASE__DCT_XMLATTRMAP__HXX
