//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DCt_XmlAttrMapDelegate
    Filename:   DCt_XmlAttrMapDelegate.hxx
    Module:     contmgmtbase
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONTMGMTBASE__DCT_XMLATTRMAPDELEGATE_HXX
#define TEAMCENTER__CONTMGMTBASE__DCT_XMLATTRMAPDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <contmgmtbase/DCt_XmlAttrMap.hxx>

#include <contmgmtbase/libcontmgmtbase_exports.h>

namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DCt_XmlAttrMapDelegate;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DCt_XmlAttrMapImpl;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DCt_XmlAttrMap;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DCt_XmlAttrMapGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CONTMGMTBASE_API Teamcenter_alias::contmgmtbase::DCt_XmlAttrMapDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the DCt_XmlAttrMapDelegate instance
    static DCt_XmlAttrMapDelegate&  getInstance();

    //  Method to create the DCt_XmlAttrMapImpl pointer
    static DCt_XmlAttrMapImpl*  createImpl( DCt_XmlAttrMap&  ifObj );

    //  Method to delete the DCt_XmlAttrMapImpl pointer
    static void deleteImpl( DCt_XmlAttrMapImpl*  impl );


    ///
    /// Gets the DOMNode value
    /// @version Teamcenter 9
    /// @param elementRoot - The element root of the document
    /// @param xamPath - The path of the node to be set
    /// @param nodeValue - The value of the node
    /// @param targetNode - DOMNode found in xamPath
    /// @return - Error code and value
    ///
    int  ctm0GetDOMNodeBase(const DCt_XmlAttrMap &ifObj,  void *elementRoot, std::string *xamPath, std::string *nodeValue, void **targetNode );


    ///
    /// Sets the DOMNode to the value
    /// @version Teamcenter 9
    /// @param elementRoot - The element root of the document
    /// @param xamPath - The path of the node to be set
    /// @param nodeValue - The value to set the node
    /// @param targetNode - DOMNode found in xamPath
    /// @return - Error code and target Node
    ///
    int  ctm0SetDOMNodeBase(const DCt_XmlAttrMap &ifObj,  void *elementRoot, std::string *xamPath, std::string *nodeValue, void **targetNode );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const DCt_XmlAttrMap &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static DCt_XmlAttrMapDelegate*  m_pInstance;

    DCt_XmlAttrMapDelegate();
    virtual ~DCt_XmlAttrMapDelegate();
    static void setInstance( DCt_XmlAttrMapDelegate*  instance );


private:
    friend class  ::Teamcenter::contmgmtbase::DCt_XmlAttrMapGenImpl;

};

#include <contmgmtbase/libcontmgmtbase_undef.h>
#endif  //  TEAMCENTER__CONTMGMTBASE__DCT_XMLATTRMAPDELEGATE_HXX
