//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DCt_XmlAttrMapTbl
    Filename:   DCt_XmlAttrMapTbl.hxx
    Module:     contmgmtbase
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONTMGMTBASE__DCT_XMLATTRMAPTBL__HXX
#define TEAMCENTER__CONTMGMTBASE__DCT_XMLATTRMAPTBL__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <contmgmtbase/libcontmgmtbase_exports.h>

namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DCt_XmlAttrMapTbl;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DCt_XmlAttrMapTblImpl;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DCt_XmlAttrMapTblDelegate;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DCt_XmlAttrMapTblDispatch;
    }
}
namespace Teamcenter
{
    namespace contmgmtbase
    {
        class DCt_XmlAttrMapTblGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONTMGMTBASE_API  Teamcenter::contmgmtbase::DCt_XmlAttrMapTbl
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    DCt_XmlAttrMapTbl();

    /**
     * Destructor
     */
    virtual ~DCt_XmlAttrMapTbl();

private:
    //  Getter method for the Implementation Object
    DCt_XmlAttrMapTblImpl*  getDCt_XmlAttrMapTblImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDCt_XmlAttrMapTblImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DCt_XmlAttrMapTblImpl*  m_dct_xmlattrmaptblImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param DCt_XmlAttrMapTbl - desc for DCt_XmlAttrMapTbl parameter
     */
    DCt_XmlAttrMapTbl( const DCt_XmlAttrMapTbl& );
    DCt_XmlAttrMapTbl& operator=( const DCt_XmlAttrMapTbl& );

    friend class  DCt_XmlAttrMapTblDelegate;
    friend class  DCt_XmlAttrMapTblDispatch;
    friend class  DCt_XmlAttrMapTblGenImpl;
};

#include <contmgmtbase/libcontmgmtbase_undef.h>
#endif //   TEAMCENTER__CONTMGMTBASE__DCT_XMLATTRMAPTBL__HXX
