//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  contmgmtbase

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libcontmgmtbase

#if !defined(LIBCONTMGMTBASE) && !defined(IPLIB)
#   error IPLIB or LIBCONTMGMTBASE is not defined
#endif

/* Handwritten code should use CONTMGMTBASE_API, not CONTMGMTBASEEXPORT */

#define CONTMGMTBASE_API CONTMGMTBASEEXPORT

#if IPLIB==libcontmgmtbase || defined(LIBCONTMGMTBASE)
#   if defined(__lint)
#       define CONTMGMTBASEEXPORT       __export(contmgmtbase)
#       define CONTMGMTBASEGLOBAL       extern __global(contmgmtbase)
#       define CONTMGMTBASEPRIVATE      extern __private(contmgmtbase)
#   elif defined(_WIN32)
#       define CONTMGMTBASEEXPORT       __declspec(dllexport)
#       define CONTMGMTBASEGLOBAL       extern __declspec(dllexport)
#       define CONTMGMTBASEPRIVATE      extern
#   else
#       define CONTMGMTBASEEXPORT
#       define CONTMGMTBASEGLOBAL       extern
#       define CONTMGMTBASEPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CONTMGMTBASEEXPORT       __export(contmgmtbase)
#       define CONTMGMTBASEGLOBAL       extern __global(contmgmtbase)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CONTMGMTBASEEXPORT      __declspec(dllimport)
#       define CONTMGMTBASEGLOBAL       extern __declspec(dllimport)
#   else
#       define CONTMGMTBASEEXPORT
#       define CONTMGMTBASEGLOBAL       extern
#   endif
#endif
