//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  contmgmtbasedispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libcontmgmtbasedispatch

#if !defined(LIBCONTMGMTBASEDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBCONTMGMTBASEDISPATCH is not defined
#endif

/* Handwritten code should use CONTMGMTBASEDISPATCH_API, not CONTMGMTBASEDISPATCHEXPORT */

#define CONTMGMTBASEDISPATCH_API CONTMGMTBASEDISPATCHEXPORT

#if IPLIB==libcontmgmtbasedispatch || defined(LIBCONTMGMTBASEDISPATCH)
#   if defined(__lint)
#       define CONTMGMTBASEDISPATCHEXPORT       __export(contmgmtbasedispatch)
#       define CONTMGMTBASEDISPATCHGLOBAL       extern __global(contmgmtbasedispatch)
#       define CONTMGMTBASEDISPATCHPRIVATE      extern __private(contmgmtbasedispatch)
#   elif defined(_WIN32)
#       define CONTMGMTBASEDISPATCHEXPORT       __declspec(dllexport)
#       define CONTMGMTBASEDISPATCHGLOBAL       extern __declspec(dllexport)
#       define CONTMGMTBASEDISPATCHPRIVATE      extern
#   else
#       define CONTMGMTBASEDISPATCHEXPORT
#       define CONTMGMTBASEDISPATCHGLOBAL       extern
#       define CONTMGMTBASEDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CONTMGMTBASEDISPATCHEXPORT       __export(contmgmtbasedispatch)
#       define CONTMGMTBASEDISPATCHGLOBAL       extern __global(contmgmtbasedispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CONTMGMTBASEDISPATCHEXPORT      __declspec(dllimport)
#       define CONTMGMTBASEDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define CONTMGMTBASEDISPATCHEXPORT
#       define CONTMGMTBASEDISPATCHGLOBAL       extern
#   endif
#endif
