//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  contmgmts1000d

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libcontmgmts1000d

#if !defined(LIBCONTMGMTS1000D) && !defined(IPLIB)
#   error IPLIB or LIBCONTMGMTS1000D is not defined
#endif

/* Handwritten code should use CONTMGMTS1000D_API, not CONTMGMTS1000DEXPORT */

#define CONTMGMTS1000D_API CONTMGMTS1000DEXPORT

#if IPLIB==libcontmgmts1000d || defined(LIBCONTMGMTS1000D)
#   if defined(__lint)
#       define CONTMGMTS1000DEXPORT       __export(contmgmts1000d)
#       define CONTMGMTS1000DGLOBAL       extern __global(contmgmts1000d)
#       define CONTMGMTS1000DPRIVATE      extern __private(contmgmts1000d)
#   elif defined(_WIN32)
#       define CONTMGMTS1000DEXPORT       __declspec(dllexport)
#       define CONTMGMTS1000DGLOBAL       extern __declspec(dllexport)
#       define CONTMGMTS1000DPRIVATE      extern
#   else
#       define CONTMGMTS1000DEXPORT
#       define CONTMGMTS1000DGLOBAL       extern
#       define CONTMGMTS1000DPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CONTMGMTS1000DEXPORT       __export(contmgmts1000d)
#       define CONTMGMTS1000DGLOBAL       extern __global(contmgmts1000d)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CONTMGMTS1000DEXPORT      __declspec(dllimport)
#       define CONTMGMTS1000DGLOBAL       extern __declspec(dllimport)
#   else
#       define CONTMGMTS1000DEXPORT
#       define CONTMGMTS1000DGLOBAL       extern
#   endif
#endif
