//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Civ0SCOEntry
    Filename:   Civ0SCOEntry.hxx
    Module:     contmgmts1000d40
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CONTMGMTS1000D40__CIV0SCOENTRY__HXX
#define CONTMGMTS1000D40__CIV0SCOENTRY__HXX

#include <common/tc_deprecation_macros.h>
#include <contmgmtbase/DC_Topic.hxx>

#include <contmgmts1000d40/libcontmgmts1000d40_exports.h>

namespace contmgmts1000d40
{
    class Civ0SCOEntry;
}
namespace contmgmts1000d40
{
    class Civ0SCOEntryImpl;
}
namespace contmgmts1000d40
{
    class Civ0SCOEntryDelegate;
}
namespace contmgmts1000d40
{
    class Civ0SCOEntryDispatch;
}
namespace contmgmts1000d40
{
    class Civ0SCOEntryGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONTMGMTS1000D40_API  contmgmts1000d40::Civ0SCOEntry
     : public  ::Teamcenter::contmgmtbase::DC_Topic
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Civ0SCOEntry();

    /**
     * Destructor
     */
    virtual ~Civ0SCOEntry();

private:
    //  Getter method for the Implementation Object
    Civ0SCOEntryImpl*  getCiv0SCOEntryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCiv0SCOEntryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Civ0SCOEntryImpl*  m_civ0scoentryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Civ0SCOEntry - desc for Civ0SCOEntry parameter
     */
    Civ0SCOEntry( const Civ0SCOEntry& );
    Civ0SCOEntry& operator=( const Civ0SCOEntry& );

    friend class  Civ0SCOEntryDelegate;
    friend class  Civ0SCOEntryDispatch;
    friend class  Civ0SCOEntryGenImpl;
};

#include <contmgmts1000d40/libcontmgmts1000d40_undef.h>
#endif //   CONTMGMTS1000D40__CIV0SCOENTRY__HXX
