//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Civ0UpdateFile
    Filename:   Civ0UpdateFile.hxx
    Module:     contmgmts1000d40
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CONTMGMTS1000D40__CIV0UPDATEFILE__HXX
#define CONTMGMTS1000D40__CIV0UPDATEFILE__HXX

#include <common/tc_deprecation_macros.h>
#include <contmgmtbase/DC_Topic.hxx>

#include <contmgmts1000d40/libcontmgmts1000d40_exports.h>

namespace contmgmts1000d40
{
    class Civ0UpdateFile;
}
namespace contmgmts1000d40
{
    class Civ0UpdateFileImpl;
}
namespace contmgmts1000d40
{
    class Civ0UpdateFileDelegate;
}
namespace contmgmts1000d40
{
    class Civ0UpdateFileDispatch;
}
namespace contmgmts1000d40
{
    class Civ0UpdateFileGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CONTMGMTS1000D40_API  contmgmts1000d40::Civ0UpdateFile
     : public  ::Teamcenter::contmgmtbase::DC_Topic
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Civ0UpdateFile();

    /**
     * Destructor
     */
    virtual ~Civ0UpdateFile();

private:
    //  Getter method for the Implementation Object
    Civ0UpdateFileImpl*  getCiv0UpdateFileImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCiv0UpdateFileImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Civ0UpdateFileImpl*  m_civ0updatefileImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Civ0UpdateFile - desc for Civ0UpdateFile parameter
     */
    Civ0UpdateFile( const Civ0UpdateFile& );
    Civ0UpdateFile& operator=( const Civ0UpdateFile& );

    friend class  Civ0UpdateFileDelegate;
    friend class  Civ0UpdateFileDispatch;
    friend class  Civ0UpdateFileGenImpl;
};

#include <contmgmts1000d40/libcontmgmts1000d40_undef.h>
#endif //   CONTMGMTS1000D40__CIV0UPDATEFILE__HXX
