//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  contmgmts1000d40dispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libcontmgmts1000d40dispatch

#if !defined(LIBCONTMGMTS1000D40DISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBCONTMGMTS1000D40DISPATCH is not defined
#endif

/* Handwritten code should use CONTMGMTS1000D40DISPATCH_API, not CONTMGMTS1000D40DISPATCHEXPORT */

#define CONTMGMTS1000D40DISPATCH_API CONTMGMTS1000D40DISPATCHEXPORT

#if IPLIB==libcontmgmts1000d40dispatch || defined(LIBCONTMGMTS1000D40DISPATCH)
#   if defined(__lint)
#       define CONTMGMTS1000D40DISPATCHEXPORT       __export(contmgmts1000d40dispatch)
#       define CONTMGMTS1000D40DISPATCHGLOBAL       extern __global(contmgmts1000d40dispatch)
#       define CONTMGMTS1000D40DISPATCHPRIVATE      extern __private(contmgmts1000d40dispatch)
#   elif defined(_WIN32)
#       define CONTMGMTS1000D40DISPATCHEXPORT       __declspec(dllexport)
#       define CONTMGMTS1000D40DISPATCHGLOBAL       extern __declspec(dllexport)
#       define CONTMGMTS1000D40DISPATCHPRIVATE      extern
#   else
#       define CONTMGMTS1000D40DISPATCHEXPORT
#       define CONTMGMTS1000D40DISPATCHGLOBAL       extern
#       define CONTMGMTS1000D40DISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CONTMGMTS1000D40DISPATCHEXPORT       __export(contmgmts1000d40dispatch)
#       define CONTMGMTS1000D40DISPATCHGLOBAL       extern __global(contmgmts1000d40dispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CONTMGMTS1000D40DISPATCHEXPORT      __declspec(dllimport)
#       define CONTMGMTS1000D40DISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define CONTMGMTS1000D40DISPATCHEXPORT
#       define CONTMGMTS1000D40DISPATCHGLOBAL       extern
#   endif
#endif
