//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPBriefRevision
    Filename:   CPBriefRevision.hxx
    Module:     cp
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPBRIEFREVISION__HXX
#define TEAMCENTER__CPBRIEFREVISION__HXX

#include <unidefs.h>
#include <string>
#include <common/tc_deprecation_macros.h>
#include <req/RequirementSpec_0_Revi_alt0.hxx>

#include <cp/libcp_exports.h>

namespace Teamcenter
{
    class CPBriefRevision;
}
namespace Teamcenter
{
    class CPBriefRevisionImpl;
}
namespace Teamcenter
{
    class CPBriefRevisionDelegate;
}
namespace Teamcenter
{
    class CPBriefRevisionDispatch;
}
namespace Teamcenter
{
    class CPBriefRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CP_API  Teamcenter::CPBriefRevision
     : public  ::Teamcenter::RequirementSpec_0_Revi_alt0
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Date Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getInitiative_target_date( date_t &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getProduct_category( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getTarget_market( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a Date Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setInitiative_target_date( const date_t &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setProduct_category( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setTarget_market( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CPBriefRevision();

    /**
     * Destructor
     */
    virtual ~CPBriefRevision();

private:
    //  Getter method for the Implementation Object
    CPBriefRevisionImpl*  getCPBriefRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCPBriefRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CPBriefRevisionImpl*  m_cpbriefrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CPBriefRevision - desc for CPBriefRevision parameter
     */
    CPBriefRevision( const CPBriefRevision& );
    CPBriefRevision& operator=( const CPBriefRevision& );

    friend class  CPBriefRevisionDelegate;
    friend class  CPBriefRevisionDispatch;
    friend class  CPBriefRevisionGenImpl;
};

#include <cp/libcp_undef.h>
#endif //   TEAMCENTER__CPBRIEFREVISION__HXX
