//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPBriefRevisionDelegate
    Filename:   CPBriefRevisionDelegate.hxx
    Module:     cp
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPBRIEFREVISIONDELEGATE_HXX
#define TEAMCENTER__CPBRIEFREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cp/CPBriefRevision.hxx>

#include <cp/libcp_exports.h>

namespace Teamcenter
{
    class CPBriefRevisionDelegate;
}
namespace Teamcenter
{
    class CPBriefRevisionImpl;
}
namespace Teamcenter
{
    class CPBriefRevision;
}
namespace Teamcenter
{
    class CPBriefRevisionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CP_API Teamcenter_alias::CPBriefRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CPBriefRevisionDelegate instance
    static CPBriefRevisionDelegate&  getInstance();

    //  Method to create the CPBriefRevisionImpl pointer
    static CPBriefRevisionImpl*  createImpl( CPBriefRevision&  ifObj );

    //  Method to delete the CPBriefRevisionImpl pointer
    static void deleteImpl( CPBriefRevisionImpl*  impl );


    ///
    /// Getter for a Date Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getInitiative_target_dateBase(const CPBriefRevision &ifObj,  date_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getProduct_categoryBase(const CPBriefRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getTarget_marketBase(const CPBriefRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a Date Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setInitiative_target_dateBase(CPBriefRevision &ifObj,  const date_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setProduct_categoryBase(CPBriefRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setTarget_marketBase(CPBriefRevision &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static CPBriefRevisionDelegate*  m_pInstance;

    CPBriefRevisionDelegate();
    virtual ~CPBriefRevisionDelegate();
    static void setInstance( CPBriefRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::CPBriefRevisionGenImpl;

};

#include <cp/libcp_undef.h>
#endif  //  TEAMCENTER__CPBRIEFREVISIONDELEGATE_HXX
