//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPMarketingBriefRevision
    Filename:   CPMarketingBriefRevision.hxx
    Module:     cp
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPMARKETINGBRIEFREVISION__HXX
#define TEAMCENTER__CPMARKETINGBRIEFREVISION__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <cp/CPBriefRevision.hxx>

#include <cp/libcp_exports.h>

namespace Teamcenter
{
    class CPMarketingBriefRevision;
}
namespace Teamcenter
{
    class CPMarketingBriefRevisionImpl;
}
namespace Teamcenter
{
    class CPMarketingBriefRevisionDelegate;
}
namespace Teamcenter
{
    class CPMarketingBriefRevisionDispatch;
}
namespace Teamcenter
{
    class CPMarketingBriefRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CP_API  Teamcenter::CPMarketingBriefRevision
     : public  ::Teamcenter::CPBriefRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCompetition( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCurrency( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPrimary_contact_person( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRegion( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getTarget_cost( double &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCompetition( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCurrency( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPrimary_contact_person( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setRegion( const std::string &value, bool isNull=false );

    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setTarget_cost( double value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CPMarketingBriefRevision();

    /**
     * Destructor
     */
    virtual ~CPMarketingBriefRevision();

private:
    //  Getter method for the Implementation Object
    CPMarketingBriefRevisionImpl*  getCPMarketingBriefRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCPMarketingBriefRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CPMarketingBriefRevisionImpl*  m_cpmarketingbriefrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CPMarketingBriefRevision - desc for CPMarketingBriefRevision parameter
     */
    CPMarketingBriefRevision( const CPMarketingBriefRevision& );
    CPMarketingBriefRevision& operator=( const CPMarketingBriefRevision& );

    friend class  CPMarketingBriefRevisionDelegate;
    friend class  CPMarketingBriefRevisionDispatch;
    friend class  CPMarketingBriefRevisionGenImpl;
};

#include <cp/libcp_undef.h>
#endif //   TEAMCENTER__CPMARKETINGBRIEFREVISION__HXX
