//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPMarketingBriefRevisionDelegate
    Filename:   CPMarketingBriefRevisionDelegate.hxx
    Module:     cp
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPMARKETINGBRIEFREVISIONDELEGATE_HXX
#define TEAMCENTER__CPMARKETINGBRIEFREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cp/CPMarketingBriefRevision.hxx>

#include <cp/libcp_exports.h>

namespace Teamcenter
{
    class CPMarketingBriefRevisionDelegate;
}
namespace Teamcenter
{
    class CPMarketingBriefRevisionImpl;
}
namespace Teamcenter
{
    class CPMarketingBriefRevision;
}
namespace Teamcenter
{
    class CPMarketingBriefRevisionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CP_API Teamcenter_alias::CPMarketingBriefRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CPMarketingBriefRevisionDelegate instance
    static CPMarketingBriefRevisionDelegate&  getInstance();

    //  Method to create the CPMarketingBriefRevisionImpl pointer
    static CPMarketingBriefRevisionImpl*  createImpl( CPMarketingBriefRevision&  ifObj );

    //  Method to delete the CPMarketingBriefRevisionImpl pointer
    static void deleteImpl( CPMarketingBriefRevisionImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCompetitionBase(const CPMarketingBriefRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCurrencyBase(const CPMarketingBriefRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPrimary_contact_personBase(const CPMarketingBriefRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRegionBase(const CPMarketingBriefRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getTarget_costBase(const CPMarketingBriefRevision &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCompetitionBase(CPMarketingBriefRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCurrencyBase(CPMarketingBriefRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPrimary_contact_personBase(CPMarketingBriefRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setRegionBase(CPMarketingBriefRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setTarget_costBase(CPMarketingBriefRevision &ifObj,  double value, bool isNull );



protected:
    //  Pointer to the instance
    static CPMarketingBriefRevisionDelegate*  m_pInstance;

    CPMarketingBriefRevisionDelegate();
    virtual ~CPMarketingBriefRevisionDelegate();
    static void setInstance( CPMarketingBriefRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::CPMarketingBriefRevisionGenImpl;

};

#include <cp/libcp_undef.h>
#endif  //  TEAMCENTER__CPMARKETINGBRIEFREVISIONDELEGATE_HXX
