//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPThemeBoardRevision
    Filename:   CPThemeBoardRevision.hxx
    Module:     cp
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPTHEMEBOARDREVISION__HXX
#define TEAMCENTER__CPTHEMEBOARDREVISION__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/DocumentRevision.hxx>

#include <cp/libcp_exports.h>

namespace Teamcenter
{
    class CPThemeBoardRevision;
}
namespace Teamcenter
{
    class CPThemeBoardRevisionImpl;
}
namespace Teamcenter
{
    class CPThemeBoardRevisionDelegate;
}
namespace Teamcenter
{
    class CPThemeBoardRevisionDispatch;
}
namespace Teamcenter
{
    class CPThemeBoardRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CP_API  Teamcenter::CPThemeBoardRevision
     : public  ::Teamcenter::DocumentRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCP_marketing_briefs( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CPThemeBoardRevision();

    /**
     * Destructor
     */
    virtual ~CPThemeBoardRevision();

private:
    //  Getter method for the Implementation Object
    CPThemeBoardRevisionImpl*  getCPThemeBoardRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCPThemeBoardRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CPThemeBoardRevisionImpl*  m_cpthemeboardrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CPThemeBoardRevision - desc for CPThemeBoardRevision parameter
     */
    CPThemeBoardRevision( const CPThemeBoardRevision& );
    CPThemeBoardRevision& operator=( const CPThemeBoardRevision& );

    friend class  CPThemeBoardRevisionDelegate;
    friend class  CPThemeBoardRevisionDispatch;
    friend class  CPThemeBoardRevisionGenImpl;
};

#include <cp/libcp_undef.h>
#endif //   TEAMCENTER__CPTHEMEBOARDREVISION__HXX
