//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  cp

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libcp

#if !defined(LIBCP) && !defined(IPLIB)
#   error IPLIB or LIBCP is not defined
#endif

/* Handwritten code should use CP_API, not CPEXPORT */

#define CP_API CPEXPORT

#if IPLIB==libcp || defined(LIBCP)
#   if defined(__lint)
#       define CPEXPORT       __export(cp)
#       define CPGLOBAL       extern __global(cp)
#       define CPPRIVATE      extern __private(cp)
#   elif defined(_WIN32)
#       define CPEXPORT       __declspec(dllexport)
#       define CPGLOBAL       extern __declspec(dllexport)
#       define CPPRIVATE      extern
#   else
#       define CPEXPORT
#       define CPGLOBAL       extern
#       define CPPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CPEXPORT       __export(cp)
#       define CPGLOBAL       extern __global(cp)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CPEXPORT      __declspec(dllimport)
#       define CPGLOBAL       extern __declspec(dllimport)
#   else
#       define CPEXPORT
#       define CPGLOBAL       extern
#   endif
#endif
