//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cpd0ArcFilletWeld
    Filename:   Cpd0ArcFilletWeld.hxx
    Module:     cpd0cd
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPD__CPD0ARCFILLETWELD__HXX
#define TEAMCENTER__CPD__CPD0ARCFILLETWELD__HXX

#include <common/tc_deprecation_macros.h>
#include <cpd0cd/Cpd0ArcWeld.hxx>

#include <cpd0cd/libcpd0cd_exports.h>

namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ArcFilletWeld;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ArcFilletWeldImpl;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ArcFilletWeldDelegate;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ArcFilletWeldDispatch;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ArcFilletWeldGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CPD0CD_API  Teamcenter::Cpd::Cpd0ArcFilletWeld
     : public  ::Teamcenter::Cpd::Cpd0ArcWeld
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cpd0ArcFilletWeld();

    /**
     * Destructor
     */
    virtual ~Cpd0ArcFilletWeld();

private:
    //  Getter method for the Implementation Object
    Cpd0ArcFilletWeldImpl*  getCpd0ArcFilletWeldImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCpd0ArcFilletWeldImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cpd0ArcFilletWeldImpl*  m_cpd0arcfilletweldImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cpd0ArcFilletWeld - desc for Cpd0ArcFilletWeld parameter
     */
    Cpd0ArcFilletWeld( const Cpd0ArcFilletWeld& );
    Cpd0ArcFilletWeld& operator=( const Cpd0ArcFilletWeld& );

    friend class  Cpd0ArcFilletWeldDelegate;
    friend class  Cpd0ArcFilletWeldDispatch;
    friend class  Cpd0ArcFilletWeldGenImpl;
};

#include <cpd0cd/libcpd0cd_undef.h>
#endif //   TEAMCENTER__CPD__CPD0ARCFILLETWELD__HXX
