//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cpd0ArcGrooveWeld
    Filename:   Cpd0ArcGrooveWeld.hxx
    Module:     cpd0cd
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPD__CPD0ARCGROOVEWELD__HXX
#define TEAMCENTER__CPD__CPD0ARCGROOVEWELD__HXX

#include <common/tc_deprecation_macros.h>
#include <cpd0cd/Cpd0ArcWeld.hxx>

#include <cpd0cd/libcpd0cd_exports.h>

namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ArcGrooveWeld;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ArcGrooveWeldImpl;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ArcGrooveWeldDelegate;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ArcGrooveWeldDispatch;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ArcGrooveWeldGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CPD0CD_API  Teamcenter::Cpd::Cpd0ArcGrooveWeld
     : public  ::Teamcenter::Cpd::Cpd0ArcWeld
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cpd0ArcGrooveWeld();

    /**
     * Destructor
     */
    virtual ~Cpd0ArcGrooveWeld();

private:
    //  Getter method for the Implementation Object
    Cpd0ArcGrooveWeldImpl*  getCpd0ArcGrooveWeldImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCpd0ArcGrooveWeldImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cpd0ArcGrooveWeldImpl*  m_cpd0arcgrooveweldImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cpd0ArcGrooveWeld - desc for Cpd0ArcGrooveWeld parameter
     */
    Cpd0ArcGrooveWeld( const Cpd0ArcGrooveWeld& );
    Cpd0ArcGrooveWeld& operator=( const Cpd0ArcGrooveWeld& );

    friend class  Cpd0ArcGrooveWeldDelegate;
    friend class  Cpd0ArcGrooveWeldDispatch;
    friend class  Cpd0ArcGrooveWeldGenImpl;
};

#include <cpd0cd/libcpd0cd_undef.h>
#endif //   TEAMCENTER__CPD__CPD0ARCGROOVEWELD__HXX
