//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cpd0ArcWeld
    Filename:   Cpd0ArcWeld.hxx
    Module:     cpd0cd
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPD__CPD0ARCWELD__HXX
#define TEAMCENTER__CPD__CPD0ARCWELD__HXX

#include <common/tc_deprecation_macros.h>
#include <cpd0cd/Cpd0ContinuousJoin.hxx>

#include <cpd0cd/libcpd0cd_exports.h>

namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ArcWeld;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ArcWeldImpl;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ArcWeldDelegate;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ArcWeldDispatch;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ArcWeldGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CPD0CD_API  Teamcenter::Cpd::Cpd0ArcWeld
     : public  ::Teamcenter::Cpd::Cpd0ContinuousJoin
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cpd0ArcWeld();

    /**
     * Destructor
     */
    virtual ~Cpd0ArcWeld();

private:
    //  Getter method for the Implementation Object
    Cpd0ArcWeldImpl*  getCpd0ArcWeldImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCpd0ArcWeldImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cpd0ArcWeldImpl*  m_cpd0arcweldImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cpd0ArcWeld - desc for Cpd0ArcWeld parameter
     */
    Cpd0ArcWeld( const Cpd0ArcWeld& );
    Cpd0ArcWeld& operator=( const Cpd0ArcWeld& );

    friend class  Cpd0ArcWeldDelegate;
    friend class  Cpd0ArcWeldDispatch;
    friend class  Cpd0ArcWeldGenImpl;
};

#include <cpd0cd/libcpd0cd_undef.h>
#endif //   TEAMCENTER__CPD__CPD0ARCWELD__HXX
