//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cpd0CollaborativeDesign
    Filename:   Cpd0CollaborativeDesign.hxx
    Module:     cpd0cd
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPD__CPD0COLLABORATIVEDESIGN__HXX
#define TEAMCENTER__CPD__CPD0COLLABORATIVEDESIGN__HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0ApplicationModel.hxx>

#include <cpd0cd/libcpd0cd_exports.h>

namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0CollaborativeDesign;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0CollaborativeDesignImpl;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0CollaborativeDesignDelegate;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0CollaborativeDesignDispatch;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0CollaborativeDesignGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CPD0CD_API  Teamcenter::Cpd::Cpd0CollaborativeDesign
     : public  ::Teamcenter::AppModel::Mdl0ApplicationModel
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cpd0CollaborativeDesign();

    /**
     * Destructor
     */
    virtual ~Cpd0CollaborativeDesign();

private:
    //  Getter method for the Implementation Object
    Cpd0CollaborativeDesignImpl*  getCpd0CollaborativeDesignImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCpd0CollaborativeDesignImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cpd0CollaborativeDesignImpl*  m_cpd0collaborativedesignImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cpd0CollaborativeDesign - desc for Cpd0CollaborativeDesign parameter
     */
    Cpd0CollaborativeDesign( const Cpd0CollaborativeDesign& );
    Cpd0CollaborativeDesign& operator=( const Cpd0CollaborativeDesign& );

    friend class  Cpd0CollaborativeDesignDelegate;
    friend class  Cpd0CollaborativeDesignDispatch;
    friend class  Cpd0CollaborativeDesignGenImpl;
};

#include <cpd0cd/libcpd0cd_undef.h>
#endif //   TEAMCENTER__CPD__CPD0COLLABORATIVEDESIGN__HXX
