//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cpd0ConnectedElement
    Filename:   Cpd0ConnectedElement.hxx
    Module:     cpd0cd
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPD__CPD0CONNECTEDELEMENT__HXX
#define TEAMCENTER__CPD__CPD0CONNECTEDELEMENT__HXX

#include <common/tc_deprecation_macros.h>
#include <aps0apscore/Mdl0CopyStableRelation.hxx>

#include <cpd0cd/libcpd0cd_exports.h>

namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ConnectedElement;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ConnectedElementImpl;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ConnectedElementDelegate;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ConnectedElementDispatch;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ConnectedElementGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CPD0CD_API  Teamcenter::Cpd::Cpd0ConnectedElement
     : public  ::Teamcenter::AppModel::Mdl0CopyStableRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cpd0ConnectedElement();

    /**
     * Destructor
     */
    virtual ~Cpd0ConnectedElement();

private:
    //  Getter method for the Implementation Object
    Cpd0ConnectedElementImpl*  getCpd0ConnectedElementImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCpd0ConnectedElementImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cpd0ConnectedElementImpl*  m_cpd0connectedelementImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cpd0ConnectedElement - desc for Cpd0ConnectedElement parameter
     */
    Cpd0ConnectedElement( const Cpd0ConnectedElement& );
    Cpd0ConnectedElement& operator=( const Cpd0ConnectedElement& );

    friend class  Cpd0ConnectedElementDelegate;
    friend class  Cpd0ConnectedElementDispatch;
    friend class  Cpd0ConnectedElementGenImpl;
};

#include <cpd0cd/libcpd0cd_undef.h>
#endif //   TEAMCENTER__CPD__CPD0CONNECTEDELEMENT__HXX
