//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cpd0ContinuousJoin
    Filename:   Cpd0ContinuousJoin.hxx
    Module:     cpd0cd
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPD__CPD0CONTINUOUSJOIN__HXX
#define TEAMCENTER__CPD__CPD0CONTINUOUSJOIN__HXX

#include <common/tc_deprecation_macros.h>
#include <cpd0cd/Cpd0DesignFeature.hxx>

#include <cpd0cd/libcpd0cd_exports.h>

namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ContinuousJoin;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ContinuousJoinImpl;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ContinuousJoinDelegate;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ContinuousJoinDispatch;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ContinuousJoinGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CPD0CD_API  Teamcenter::Cpd::Cpd0ContinuousJoin
     : public  ::Teamcenter::Cpd::Cpd0DesignFeature
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cpd0ContinuousJoin();

    /**
     * Destructor
     */
    virtual ~Cpd0ContinuousJoin();

private:
    //  Getter method for the Implementation Object
    Cpd0ContinuousJoinImpl*  getCpd0ContinuousJoinImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCpd0ContinuousJoinImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cpd0ContinuousJoinImpl*  m_cpd0continuousjoinImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cpd0ContinuousJoin - desc for Cpd0ContinuousJoin parameter
     */
    Cpd0ContinuousJoin( const Cpd0ContinuousJoin& );
    Cpd0ContinuousJoin& operator=( const Cpd0ContinuousJoin& );

    friend class  Cpd0ContinuousJoinDelegate;
    friend class  Cpd0ContinuousJoinDispatch;
    friend class  Cpd0ContinuousJoinGenImpl;
};

#include <cpd0cd/libcpd0cd_undef.h>
#endif //   TEAMCENTER__CPD__CPD0CONTINUOUSJOIN__HXX
