//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cpd0ControlModel
    Filename:   Cpd0ControlModel.hxx
    Module:     cpd0cd
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPD__CPD0CONTROLMODEL__HXX
#define TEAMCENTER__CPD__CPD0CONTROLMODEL__HXX

#include <common/tc_deprecation_macros.h>
#include <aps0apscore/Mdl0CopyStableRelation.hxx>

#include <cpd0cd/libcpd0cd_exports.h>

namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ControlModel;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ControlModelImpl;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ControlModelDelegate;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ControlModelDispatch;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ControlModelGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CPD0CD_API  Teamcenter::Cpd::Cpd0ControlModel
     : public  ::Teamcenter::AppModel::Mdl0CopyStableRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cpd0ControlModel();

    /**
     * Destructor
     */
    virtual ~Cpd0ControlModel();

private:
    //  Getter method for the Implementation Object
    Cpd0ControlModelImpl*  getCpd0ControlModelImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCpd0ControlModelImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cpd0ControlModelImpl*  m_cpd0controlmodelImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cpd0ControlModel - desc for Cpd0ControlModel parameter
     */
    Cpd0ControlModel( const Cpd0ControlModel& );
    Cpd0ControlModel& operator=( const Cpd0ControlModel& );

    friend class  Cpd0ControlModelDelegate;
    friend class  Cpd0ControlModelDispatch;
    friend class  Cpd0ControlModelGenImpl;
};

#include <cpd0cd/libcpd0cd_undef.h>
#endif //   TEAMCENTER__CPD__CPD0CONTROLMODEL__HXX
