//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cpd0DatumDelegate
    Filename:   Cpd0DatumDelegate.hxx
    Module:     cpd0cd
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPD__CPD0DATUMDELEGATE_HXX
#define TEAMCENTER__CPD__CPD0DATUMDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cpd0cd/Cpd0Datum.hxx>

#include <cpd0cd/libcpd0cd_exports.h>

namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0DatumDelegate;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0DatumImpl;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0Datum;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0DatumGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CPD0CD_API Teamcenter_alias::Cpd::Cpd0DatumDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cpd0DatumDelegate instance
    static Cpd0DatumDelegate&  getInstance();

    //  Method to create the Cpd0DatumImpl pointer
    static Cpd0DatumImpl*  createImpl( Cpd0Datum&  ifObj );

    //  Method to delete the Cpd0DatumImpl pointer
    static void deleteImpl( Cpd0DatumImpl*  impl );


    ///
    /// Getter for a Double Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCpd0positionBase(const Cpd0Datum &ifObj,  std::vector< double > &values, std::vector< int > &isNull ) const;


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Cpd0Datum &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static Cpd0DatumDelegate*  m_pInstance;

    Cpd0DatumDelegate();
    virtual ~Cpd0DatumDelegate();
    static void setInstance( Cpd0DatumDelegate*  instance );


private:
    friend class  ::Teamcenter::Cpd::Cpd0DatumGenImpl;

};

#include <cpd0cd/libcpd0cd_undef.h>
#endif  //  TEAMCENTER__CPD__CPD0DATUMDELEGATE_HXX
