//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cpd0DesignControlElement
    Filename:   Cpd0DesignControlElement.hxx
    Module:     cpd0cd
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPD__CPD0DESIGNCONTROLELEMENT__HXX
#define TEAMCENTER__CPD__CPD0DESIGNCONTROLELEMENT__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <mdl0modelgeometry/Mdl0PositionedModelElement.hxx>

#include <cpd0cd/libcpd0cd_exports.h>

namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0DesignControlElement;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0DesignControlElementImpl;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0DesignControlElementDelegate;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0DesignControlElementDispatch;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0DesignControlElementGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CPD0CD_API  Teamcenter::Cpd::Cpd0DesignControlElement
     : public  ::Teamcenter::AppModel::Mdl0PositionedModelElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCpd0design_control_id( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCpd0design_control_id( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cpd0DesignControlElement();

    /**
     * Destructor
     */
    virtual ~Cpd0DesignControlElement();

private:
    //  Getter method for the Implementation Object
    Cpd0DesignControlElementImpl*  getCpd0DesignControlElementImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCpd0DesignControlElementImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cpd0DesignControlElementImpl*  m_cpd0designcontrolelementImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cpd0DesignControlElement - desc for Cpd0DesignControlElement parameter
     */
    Cpd0DesignControlElement( const Cpd0DesignControlElement& );
    Cpd0DesignControlElement& operator=( const Cpd0DesignControlElement& );

    friend class  Cpd0DesignControlElementDelegate;
    friend class  Cpd0DesignControlElementDispatch;
    friend class  Cpd0DesignControlElementGenImpl;
};

#include <cpd0cd/libcpd0cd_undef.h>
#endif //   TEAMCENTER__CPD__CPD0DESIGNCONTROLELEMENT__HXX
