//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cpd0DesignElementDelegate
    Filename:   Cpd0DesignElementDelegate.hxx
    Module:     cpd0cd
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPD__CPD0DESIGNELEMENTDELEGATE_HXX
#define TEAMCENTER__CPD__CPD0DESIGNELEMENTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cpd0cd/Cpd0DesignElement.hxx>

#include <cpd0cd/libcpd0cd_exports.h>

namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0DesignElementDelegate;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0DesignElementImpl;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0DesignElement;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0DesignElementGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CPD0CD_API Teamcenter_alias::Cpd::Cpd0DesignElementDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cpd0DesignElementDelegate instance
    static Cpd0DesignElementDelegate&  getInstance();

    //  Method to create the Cpd0DesignElementImpl pointer
    static Cpd0DesignElementImpl*  createImpl( Cpd0DesignElement&  ifObj );

    //  Method to delete the Cpd0DesignElementImpl pointer
    static void deleteImpl( Cpd0DesignElementImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCpd0source_frozenBase(const Cpd0DesignElement &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCpd0source_not_latestBase(const Cpd0DesignElement &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCpd0structure_requires_syncBase(const Cpd0DesignElement &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCpd0subordinatesBase(const Cpd0DesignElement &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCpd0thumbnail_dsBase(const Cpd0DesignElement &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCpd0where_partitionedBase(const Cpd0DesignElement &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;



protected:
    //  Pointer to the instance
    static Cpd0DesignElementDelegate*  m_pInstance;

    Cpd0DesignElementDelegate();
    virtual ~Cpd0DesignElementDelegate();
    static void setInstance( Cpd0DesignElementDelegate*  instance );


private:
    friend class  ::Teamcenter::Cpd::Cpd0DesignElementGenImpl;

};

#include <cpd0cd/libcpd0cd_undef.h>
#endif  //  TEAMCENTER__CPD__CPD0DESIGNELEMENTDELEGATE_HXX
