//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cpd0DesignFeature
    Filename:   Cpd0DesignFeature.hxx
    Module:     cpd0cd
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPD__CPD0DESIGNFEATURE__HXX
#define TEAMCENTER__CPD__CPD0DESIGNFEATURE__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <mdl0modelgeometry/Mdl0PositionedModelElement.hxx>

#include <cpd0cd/libcpd0cd_exports.h>

namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0DesignFeature;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0DesignFeatureImpl;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0DesignFeatureDelegate;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0DesignFeatureDispatch;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0DesignFeatureGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CPD0CD_API  Teamcenter::Cpd::Cpd0DesignFeature
     : public  ::Teamcenter::AppModel::Mdl0PositionedModelElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCpd0design_feature_id( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCpd0design_feature_id( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cpd0DesignFeature();

    /**
     * Destructor
     */
    virtual ~Cpd0DesignFeature();

private:
    //  Getter method for the Implementation Object
    Cpd0DesignFeatureImpl*  getCpd0DesignFeatureImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCpd0DesignFeatureImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cpd0DesignFeatureImpl*  m_cpd0designfeatureImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cpd0DesignFeature - desc for Cpd0DesignFeature parameter
     */
    Cpd0DesignFeature( const Cpd0DesignFeature& );
    Cpd0DesignFeature& operator=( const Cpd0DesignFeature& );

    friend class  Cpd0DesignFeatureDelegate;
    friend class  Cpd0DesignFeatureDispatch;
    friend class  Cpd0DesignFeatureGenImpl;
};

#include <cpd0cd/libcpd0cd_undef.h>
#endif //   TEAMCENTER__CPD__CPD0DESIGNFEATURE__HXX
