//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cpd0DiscreteJoin
    Filename:   Cpd0DiscreteJoin.hxx
    Module:     cpd0cd
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPD__CPD0DISCRETEJOIN__HXX
#define TEAMCENTER__CPD__CPD0DISCRETEJOIN__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <cpd0cd/Cpd0DesignFeature.hxx>

#include <cpd0cd/libcpd0cd_exports.h>

namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0DiscreteJoin;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0DiscreteJoinImpl;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0DiscreteJoinDelegate;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0DiscreteJoinDispatch;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0DiscreteJoinGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CPD0CD_API  Teamcenter::Cpd::Cpd0DiscreteJoin
     : public  ::Teamcenter::Cpd::Cpd0DesignFeature
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Double Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCpd0position( std::vector< double > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cpd0DiscreteJoin();

    /**
     * Destructor
     */
    virtual ~Cpd0DiscreteJoin();

private:
    //  Getter method for the Implementation Object
    Cpd0DiscreteJoinImpl*  getCpd0DiscreteJoinImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCpd0DiscreteJoinImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cpd0DiscreteJoinImpl*  m_cpd0discretejoinImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cpd0DiscreteJoin - desc for Cpd0DiscreteJoin parameter
     */
    Cpd0DiscreteJoin( const Cpd0DiscreteJoin& );
    Cpd0DiscreteJoin& operator=( const Cpd0DiscreteJoin& );

    friend class  Cpd0DiscreteJoinDelegate;
    friend class  Cpd0DiscreteJoinDispatch;
    friend class  Cpd0DiscreteJoinGenImpl;
};

#include <cpd0cd/libcpd0cd_undef.h>
#endif //   TEAMCENTER__CPD__CPD0DISCRETEJOIN__HXX
