//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cpd0InfoInContext
    Filename:   Cpd0InfoInContext.hxx
    Module:     cpd0cd
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPD__CPD0INFOINCONTEXT__HXX
#define TEAMCENTER__CPD__CPD0INFOINCONTEXT__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0AttributeGroup.hxx>

#include <cpd0cd/libcpd0cd_exports.h>

namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0InfoInContext;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0InfoInContextImpl;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0InfoInContextDelegate;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0InfoInContextDispatch;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0InfoInContextGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CPD0CD_API  Teamcenter::Cpd::Cpd0InfoInContext
     : public  ::Teamcenter::AppModel::Mdl0AttributeGroup
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCpd0FindNum( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cpd0InfoInContext();

    /**
     * Destructor
     */
    virtual ~Cpd0InfoInContext();

private:
    //  Getter method for the Implementation Object
    Cpd0InfoInContextImpl*  getCpd0InfoInContextImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCpd0InfoInContextImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cpd0InfoInContextImpl*  m_cpd0infoincontextImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cpd0InfoInContext - desc for Cpd0InfoInContext parameter
     */
    Cpd0InfoInContext( const Cpd0InfoInContext& );
    Cpd0InfoInContext& operator=( const Cpd0InfoInContext& );

    friend class  Cpd0InfoInContextDelegate;
    friend class  Cpd0InfoInContextDispatch;
    friend class  Cpd0InfoInContextGenImpl;
};

#include <cpd0cd/libcpd0cd_undef.h>
#endif //   TEAMCENTER__CPD__CPD0INFOINCONTEXT__HXX
