//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cpd0ShapeDesign
    Filename:   Cpd0ShapeDesign.hxx
    Module:     cpd0cd
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPD__CPD0SHAPEDESIGN__HXX
#define TEAMCENTER__CPD__CPD0SHAPEDESIGN__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/Design.hxx>

#include <cpd0cd/libcpd0cd_exports.h>

namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ShapeDesign;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ShapeDesignImpl;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ShapeDesignDelegate;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ShapeDesignDispatch;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ShapeDesignGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CPD0CD_API  Teamcenter::Cpd::Cpd0ShapeDesign
     : public  ::Teamcenter::Design
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCpd0delegate( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCpd0delegate( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cpd0ShapeDesign();

    /**
     * Destructor
     */
    virtual ~Cpd0ShapeDesign();

private:
    //  Getter method for the Implementation Object
    Cpd0ShapeDesignImpl*  getCpd0ShapeDesignImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCpd0ShapeDesignImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cpd0ShapeDesignImpl*  m_cpd0shapedesignImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cpd0ShapeDesign - desc for Cpd0ShapeDesign parameter
     */
    Cpd0ShapeDesign( const Cpd0ShapeDesign& );
    Cpd0ShapeDesign& operator=( const Cpd0ShapeDesign& );

    friend class  Cpd0ShapeDesignDelegate;
    friend class  Cpd0ShapeDesignDispatch;
    friend class  Cpd0ShapeDesignGenImpl;
};

#include <cpd0cd/libcpd0cd_undef.h>
#endif //   TEAMCENTER__CPD__CPD0SHAPEDESIGN__HXX
