//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cpd0ShapeDesignDelegate
    Filename:   Cpd0ShapeDesignDelegate.hxx
    Module:     cpd0cd
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPD__CPD0SHAPEDESIGNDELEGATE_HXX
#define TEAMCENTER__CPD__CPD0SHAPEDESIGNDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cpd0cd/Cpd0ShapeDesign.hxx>

#include <cpd0cd/libcpd0cd_exports.h>

namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ShapeDesignDelegate;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ShapeDesignImpl;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ShapeDesign;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ShapeDesignGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CPD0CD_API Teamcenter_alias::Cpd::Cpd0ShapeDesignDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cpd0ShapeDesignDelegate instance
    static Cpd0ShapeDesignDelegate&  getInstance();

    //  Method to create the Cpd0ShapeDesignImpl pointer
    static Cpd0ShapeDesignImpl*  createImpl( Cpd0ShapeDesign&  ifObj );

    //  Method to delete the Cpd0ShapeDesignImpl pointer
    static void deleteImpl( Cpd0ShapeDesignImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCpd0delegateBase(const Cpd0ShapeDesign &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCpd0delegateBase(Cpd0ShapeDesign &ifObj,  const tag_t &value, bool isNull );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Cpd0ShapeDesign &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Cpd0ShapeDesign &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0CreatePostBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be created
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0FinalizeCreateInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static Cpd0ShapeDesignDelegate*  m_pInstance;

    Cpd0ShapeDesignDelegate();
    virtual ~Cpd0ShapeDesignDelegate();
    static void setInstance( Cpd0ShapeDesignDelegate*  instance );


private:
    friend class  ::Teamcenter::Cpd::Cpd0ShapeDesignGenImpl;

};

#include <cpd0cd/libcpd0cd_undef.h>
#endif  //  TEAMCENTER__CPD__CPD0SHAPEDESIGNDELEGATE_HXX
