//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cpd0ShapeDesignRevision
    Filename:   Cpd0ShapeDesignRevision.hxx
    Module:     cpd0cd
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPD__CPD0SHAPEDESIGNREVISION__HXX
#define TEAMCENTER__CPD__CPD0SHAPEDESIGNREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Design_0_Revision_alt.hxx>

#include <cpd0cd/libcpd0cd_exports.h>

namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ShapeDesignRevision;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ShapeDesignRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ShapeDesignRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ShapeDesignRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ShapeDesignRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CPD0CD_API  Teamcenter::Cpd::Cpd0ShapeDesignRevision
     : public  ::Teamcenter::Design_0_Revision_alt
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cpd0ShapeDesignRevision();

    /**
     * Destructor
     */
    virtual ~Cpd0ShapeDesignRevision();

private:
    //  Getter method for the Implementation Object
    Cpd0ShapeDesignRevisionImpl*  getCpd0ShapeDesignRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCpd0ShapeDesignRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cpd0ShapeDesignRevisionImpl*  m_cpd0shapedesignrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cpd0ShapeDesignRevision - desc for Cpd0ShapeDesignRevision parameter
     */
    Cpd0ShapeDesignRevision( const Cpd0ShapeDesignRevision& );
    Cpd0ShapeDesignRevision& operator=( const Cpd0ShapeDesignRevision& );

    friend class  Cpd0ShapeDesignRevisionDelegate;
    friend class  Cpd0ShapeDesignRevisionDispatch;
    friend class  Cpd0ShapeDesignRevisionGenImpl;
};

#include <cpd0cd/libcpd0cd_undef.h>
#endif //   TEAMCENTER__CPD__CPD0SHAPEDESIGNREVISION__HXX
