//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cpd0ShapeDesignRevisionDelegate
    Filename:   Cpd0ShapeDesignRevisionDelegate.hxx
    Module:     cpd0cd
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPD__CPD0SHAPEDESIGNREVISIONDELEGATE_HXX
#define TEAMCENTER__CPD__CPD0SHAPEDESIGNREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cpd0cd/Cpd0ShapeDesignRevision.hxx>

#include <cpd0cd/libcpd0cd_exports.h>

namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ShapeDesignRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ShapeDesignRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ShapeDesignRevision;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ShapeDesignRevisionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CPD0CD_API Teamcenter_alias::Cpd::Cpd0ShapeDesignRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cpd0ShapeDesignRevisionDelegate instance
    static Cpd0ShapeDesignRevisionDelegate&  getInstance();

    //  Method to create the Cpd0ShapeDesignRevisionImpl pointer
    static Cpd0ShapeDesignRevisionImpl*  createImpl( Cpd0ShapeDesignRevision&  ifObj );

    //  Method to delete the Cpd0ShapeDesignRevisionImpl pointer
    static void deleteImpl( Cpd0ShapeDesignRevisionImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.3
    /// @param inputs - A vector of data that contains reference information to the objects to be revised
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0RevisePostBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// Generic revisePost operation.
    /// @version Teamcenter 10.1
    /// @param pReviseInput - Input ReviseInput object.
    /// @param vecDeepCopyData - Vector of deep copy data.
    /// @return - Returns an integer value.
    ///
    int  revisePostBase(const Cpd0ShapeDesignRevision &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static Cpd0ShapeDesignRevisionDelegate*  m_pInstance;

    Cpd0ShapeDesignRevisionDelegate();
    virtual ~Cpd0ShapeDesignRevisionDelegate();
    static void setInstance( Cpd0ShapeDesignRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::Cpd::Cpd0ShapeDesignRevisionGenImpl;

};

#include <cpd0cd/libcpd0cd_undef.h>
#endif  //  TEAMCENTER__CPD__CPD0SHAPEDESIGNREVISIONDELEGATE_HXX
