//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cpd0SubsetDefaults
    Filename:   Cpd0SubsetDefaults.hxx
    Module:     cpd0cd
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPD__CPD0SUBSETDEFAULTS__HXX
#define TEAMCENTER__CPD__CPD0SUBSETDEFAULTS__HXX

#include <common/tc_deprecation_macros.h>
#include <ptn0partition/Ptn0SubsetDefaults.hxx>

#include <cpd0cd/libcpd0cd_exports.h>

namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0SubsetDefaults;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0SubsetDefaultsImpl;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0SubsetDefaultsDelegate;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0SubsetDefaultsDispatch;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0SubsetDefaultsGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CPD0CD_API  Teamcenter::Cpd::Cpd0SubsetDefaults
     : public  ::Teamcenter::Partition::Ptn0SubsetDefaults
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cpd0SubsetDefaults();

    /**
     * Destructor
     */
    virtual ~Cpd0SubsetDefaults();

private:
    //  Getter method for the Implementation Object
    Cpd0SubsetDefaultsImpl*  getCpd0SubsetDefaultsImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCpd0SubsetDefaultsImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cpd0SubsetDefaultsImpl*  m_cpd0subsetdefaultsImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cpd0SubsetDefaults - desc for Cpd0SubsetDefaults parameter
     */
    Cpd0SubsetDefaults( const Cpd0SubsetDefaults& );
    Cpd0SubsetDefaults& operator=( const Cpd0SubsetDefaults& );

    friend class  Cpd0SubsetDefaultsDelegate;
    friend class  Cpd0SubsetDefaultsDispatch;
    friend class  Cpd0SubsetDefaultsGenImpl;
};

#include <cpd0cd/libcpd0cd_undef.h>
#endif //   TEAMCENTER__CPD__CPD0SUBSETDEFAULTS__HXX
