//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cpd0AbsSubsetItm
    Filename:   Cpd0AbsSubsetItm.hxx
    Module:     cpd0workset
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPD__CPD0ABSSUBSETITM__HXX
#define TEAMCENTER__CPD__CPD0ABSSUBSETITM__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <cpd0workset/libcpd0workset_exports.h>

namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0AbsSubsetItm;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0AbsSubsetItmImpl;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0AbsSubsetItmDelegate;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0AbsSubsetItmDispatch;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0AbsSubsetItmGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CPD0WORKSET_API  Teamcenter::Cpd::Cpd0AbsSubsetItm
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cpd0AbsSubsetItm();

    /**
     * Destructor
     */
    virtual ~Cpd0AbsSubsetItm();

private:
    //  Getter method for the Implementation Object
    Cpd0AbsSubsetItmImpl*  getCpd0AbsSubsetItmImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCpd0AbsSubsetItmImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cpd0AbsSubsetItmImpl*  m_cpd0abssubsetitmImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cpd0AbsSubsetItm - desc for Cpd0AbsSubsetItm parameter
     */
    Cpd0AbsSubsetItm( const Cpd0AbsSubsetItm& );
    Cpd0AbsSubsetItm& operator=( const Cpd0AbsSubsetItm& );

    friend class  Cpd0AbsSubsetItmDelegate;
    friend class  Cpd0AbsSubsetItmDispatch;
    friend class  Cpd0AbsSubsetItmGenImpl;
};

#include <cpd0workset/libcpd0workset_undef.h>
#endif //   TEAMCENTER__CPD__CPD0ABSSUBSETITM__HXX
