//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cpd0AbsSubsetItmRevision
    Filename:   Cpd0AbsSubsetItmRevision.hxx
    Module:     cpd0workset
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPD__CPD0ABSSUBSETITMREVISION__HXX
#define TEAMCENTER__CPD__CPD0ABSSUBSETITMREVISION__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <cpd0workset/libcpd0workset_exports.h>

namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0AbsSubsetItmRevision;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0AbsSubsetItmRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0AbsSubsetItmRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0AbsSubsetItmRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0AbsSubsetItmRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CPD0WORKSET_API  Teamcenter::Cpd::Cpd0AbsSubsetItmRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCpd0ConfiguredSourceObject( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCpd0instance( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCpd0ReportInWhereUsed( bool &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCpd0source_object( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 11.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCpd0ReportInWhereUsed( bool value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.2.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCpd0source_object( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cpd0AbsSubsetItmRevision();

    /**
     * Destructor
     */
    virtual ~Cpd0AbsSubsetItmRevision();

private:
    //  Getter method for the Implementation Object
    Cpd0AbsSubsetItmRevisionImpl*  getCpd0AbsSubsetItmRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCpd0AbsSubsetItmRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cpd0AbsSubsetItmRevisionImpl*  m_cpd0abssubsetitmrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cpd0AbsSubsetItmRevision - desc for Cpd0AbsSubsetItmRevision parameter
     */
    Cpd0AbsSubsetItmRevision( const Cpd0AbsSubsetItmRevision& );
    Cpd0AbsSubsetItmRevision& operator=( const Cpd0AbsSubsetItmRevision& );

    friend class  Cpd0AbsSubsetItmRevisionDelegate;
    friend class  Cpd0AbsSubsetItmRevisionDispatch;
    friend class  Cpd0AbsSubsetItmRevisionGenImpl;
};

#include <cpd0workset/libcpd0workset_undef.h>
#endif //   TEAMCENTER__CPD__CPD0ABSSUBSETITMREVISION__HXX
