//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cpd0AbsSubsetItmRevisionDelegate
    Filename:   Cpd0AbsSubsetItmRevisionDelegate.hxx
    Module:     cpd0workset
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPD__CPD0ABSSUBSETITMREVISIONDELEGATE_HXX
#define TEAMCENTER__CPD__CPD0ABSSUBSETITMREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cpd0workset/Cpd0AbsSubsetItmRevision.hxx>

#include <cpd0workset/libcpd0workset_exports.h>

namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0AbsSubsetItmRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0AbsSubsetItmRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0AbsSubsetItmRevision;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0AbsSubsetItmRevisionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CPD0WORKSET_API Teamcenter_alias::Cpd::Cpd0AbsSubsetItmRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cpd0AbsSubsetItmRevisionDelegate instance
    static Cpd0AbsSubsetItmRevisionDelegate&  getInstance();

    //  Method to create the Cpd0AbsSubsetItmRevisionImpl pointer
    static Cpd0AbsSubsetItmRevisionImpl*  createImpl( Cpd0AbsSubsetItmRevision&  ifObj );

    //  Method to delete the Cpd0AbsSubsetItmRevisionImpl pointer
    static void deleteImpl( Cpd0AbsSubsetItmRevisionImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCpd0ConfiguredSourceObjectBase(const Cpd0AbsSubsetItmRevision &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCpd0instanceBase(const Cpd0AbsSubsetItmRevision &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCpd0ReportInWhereUsedBase(const Cpd0AbsSubsetItmRevision &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCpd0source_objectBase(const Cpd0AbsSubsetItmRevision &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 11.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCpd0ReportInWhereUsedBase(Cpd0AbsSubsetItmRevision &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.2.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCpd0source_objectBase(Cpd0AbsSubsetItmRevision &ifObj,  const tag_t &value, bool isNull );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Cpd0AbsSubsetItmRevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @param isLockForDelete - A boolean to indicate if object(s) are to be locked for deletion
    /// @param allowRelock - A boolean to indicate if object(s) can be relocked, which will discard all unsaved changes, if already locked by the same user
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0LockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd, const bool isLockForDelete, const bool allowRelock );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0RefreshBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0UnlockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static Cpd0AbsSubsetItmRevisionDelegate*  m_pInstance;

    Cpd0AbsSubsetItmRevisionDelegate();
    virtual ~Cpd0AbsSubsetItmRevisionDelegate();
    static void setInstance( Cpd0AbsSubsetItmRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::Cpd::Cpd0AbsSubsetItmRevisionGenImpl;

};

#include <cpd0workset/libcpd0workset_undef.h>
#endif  //  TEAMCENTER__CPD__CPD0ABSSUBSETITMREVISIONDELEGATE_HXX
