//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cpd0ClearanceCalculation
    Filename:   Cpd0ClearanceCalculation.hxx
    Module:     cpd0workset
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPD__CPD0CLEARANCECALCULATION__HXX
#define TEAMCENTER__CPD__CPD0CLEARANCECALCULATION__HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0SubsetDefinition.hxx>

#include <cpd0workset/libcpd0workset_exports.h>

namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ClearanceCalculation;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ClearanceCalculationImpl;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ClearanceCalculationDelegate;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ClearanceCalculationDispatch;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0ClearanceCalculationGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CPD0WORKSET_API  Teamcenter::Cpd::Cpd0ClearanceCalculation
     : public  ::Teamcenter::AppModel::Mdl0SubsetDefinition
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cpd0ClearanceCalculation();

    /**
     * Destructor
     */
    virtual ~Cpd0ClearanceCalculation();

private:
    //  Getter method for the Implementation Object
    Cpd0ClearanceCalculationImpl*  getCpd0ClearanceCalculationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCpd0ClearanceCalculationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cpd0ClearanceCalculationImpl*  m_cpd0clearancecalculationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cpd0ClearanceCalculation - desc for Cpd0ClearanceCalculation parameter
     */
    Cpd0ClearanceCalculation( const Cpd0ClearanceCalculation& );
    Cpd0ClearanceCalculation& operator=( const Cpd0ClearanceCalculation& );

    friend class  Cpd0ClearanceCalculationDelegate;
    friend class  Cpd0ClearanceCalculationDispatch;
    friend class  Cpd0ClearanceCalculationGenImpl;
};

#include <cpd0workset/libcpd0workset_undef.h>
#endif //   TEAMCENTER__CPD__CPD0CLEARANCECALCULATION__HXX
