//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cpd0DesignSubsetInstance
    Filename:   Cpd0DesignSubsetInstance.hxx
    Module:     cpd0workset
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPD__CPD0DESIGNSUBSETINSTANCE__HXX
#define TEAMCENTER__CPD__CPD0DESIGNSUBSETINSTANCE__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <rlz0realization/Rlz0ModelRealization.hxx>

#include <cpd0workset/libcpd0workset_exports.h>

namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0DesignSubsetInstance;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0DesignSubsetInstanceImpl;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0DesignSubsetInstanceDelegate;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0DesignSubsetInstanceDispatch;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0DesignSubsetInstanceGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CPD0WORKSET_API  Teamcenter::Cpd::Cpd0DesignSubsetInstance
     : public  ::Teamcenter::Realization::Rlz0ModelRealization
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCpd0ContainsHistoricalData( bool &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCpd0reuse_element( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCpd0search_criteria( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCpd0reuse_element( const tag_t &value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCpd0search_criteria( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cpd0DesignSubsetInstance();

    /**
     * Destructor
     */
    virtual ~Cpd0DesignSubsetInstance();

private:
    //  Getter method for the Implementation Object
    Cpd0DesignSubsetInstanceImpl*  getCpd0DesignSubsetInstanceImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCpd0DesignSubsetInstanceImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cpd0DesignSubsetInstanceImpl*  m_cpd0designsubsetinstanceImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cpd0DesignSubsetInstance - desc for Cpd0DesignSubsetInstance parameter
     */
    Cpd0DesignSubsetInstance( const Cpd0DesignSubsetInstance& );
    Cpd0DesignSubsetInstance& operator=( const Cpd0DesignSubsetInstance& );

    friend class  Cpd0DesignSubsetInstanceDelegate;
    friend class  Cpd0DesignSubsetInstanceDispatch;
    friend class  Cpd0DesignSubsetInstanceGenImpl;
};

#include <cpd0workset/libcpd0workset_undef.h>
#endif //   TEAMCENTER__CPD__CPD0DESIGNSUBSETINSTANCE__HXX
