//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cpd0StructureExpandCursor
    Filename:   Cpd0StructureExpandCursor.hxx
    Module:     cpd0workset
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPD__CPD0STRUCTUREEXPANDCURSOR__HXX
#define TEAMCENTER__CPD__CPD0STRUCTUREEXPANDCURSOR__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <cpd0workset/libcpd0workset_exports.h>

namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0StructureExpandCursor;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0StructureExpandCursorImpl;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0StructureExpandCursorDelegate;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0StructureExpandCursorDispatch;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0StructureExpandCursorGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CPD0WORKSET_API  Teamcenter::Cpd::Cpd0StructureExpandCursor
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cpd0StructureExpandCursor();

    /**
     * Destructor
     */
    virtual ~Cpd0StructureExpandCursor();

private:
    //  Getter method for the Implementation Object
    Cpd0StructureExpandCursorImpl*  getCpd0StructureExpandCursorImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCpd0StructureExpandCursorImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cpd0StructureExpandCursorImpl*  m_cpd0structureexpandcursorImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cpd0StructureExpandCursor - desc for Cpd0StructureExpandCursor parameter
     */
    Cpd0StructureExpandCursor( const Cpd0StructureExpandCursor& );
    Cpd0StructureExpandCursor& operator=( const Cpd0StructureExpandCursor& );

    friend class  Cpd0StructureExpandCursorDelegate;
    friend class  Cpd0StructureExpandCursorDispatch;
    friend class  Cpd0StructureExpandCursorGenImpl;
};

#include <cpd0workset/libcpd0workset_undef.h>
#endif //   TEAMCENTER__CPD__CPD0STRUCTUREEXPANDCURSOR__HXX
