//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cpd0SubsetItem
    Filename:   Cpd0SubsetItem.hxx
    Module:     cpd0workset
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPD__CPD0SUBSETITEM__HXX
#define TEAMCENTER__CPD__CPD0SUBSETITEM__HXX

#include <common/tc_deprecation_macros.h>
#include <cpd0workset/Cpd0AbsSubsetItm.hxx>

#include <cpd0workset/libcpd0workset_exports.h>

namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0SubsetItem;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0SubsetItemImpl;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0SubsetItemDelegate;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0SubsetItemDispatch;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0SubsetItemGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CPD0WORKSET_API  Teamcenter::Cpd::Cpd0SubsetItem
     : public  ::Teamcenter::Cpd::Cpd0AbsSubsetItm
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cpd0SubsetItem();

    /**
     * Destructor
     */
    virtual ~Cpd0SubsetItem();

private:
    //  Getter method for the Implementation Object
    Cpd0SubsetItemImpl*  getCpd0SubsetItemImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCpd0SubsetItemImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cpd0SubsetItemImpl*  m_cpd0subsetitemImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cpd0SubsetItem - desc for Cpd0SubsetItem parameter
     */
    Cpd0SubsetItem( const Cpd0SubsetItem& );
    Cpd0SubsetItem& operator=( const Cpd0SubsetItem& );

    friend class  Cpd0SubsetItemDelegate;
    friend class  Cpd0SubsetItemDispatch;
    friend class  Cpd0SubsetItemGenImpl;
};

#include <cpd0workset/libcpd0workset_undef.h>
#endif //   TEAMCENTER__CPD__CPD0SUBSETITEM__HXX
