//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cpd0SubsetItemInstanceDelegate
    Filename:   Cpd0SubsetItemInstanceDelegate.hxx
    Module:     cpd0workset
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPD__CPD0SUBSETITEMINSTANCEDELEGATE_HXX
#define TEAMCENTER__CPD__CPD0SUBSETITEMINSTANCEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cpd0workset/Cpd0SubsetItemInstance.hxx>

#include <cpd0workset/libcpd0workset_exports.h>

namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0SubsetItemInstanceDelegate;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0SubsetItemInstanceImpl;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0SubsetItemInstance;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0SubsetItemInstanceGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CPD0WORKSET_API Teamcenter_alias::Cpd::Cpd0SubsetItemInstanceDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cpd0SubsetItemInstanceDelegate instance
    static Cpd0SubsetItemInstanceDelegate&  getInstance();

    //  Method to create the Cpd0SubsetItemInstanceImpl pointer
    static Cpd0SubsetItemInstanceImpl*  createImpl( Cpd0SubsetItemInstance&  ifObj );

    //  Method to delete the Cpd0SubsetItemInstanceImpl pointer
    static void deleteImpl( Cpd0SubsetItemInstanceImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCpd0ContainsHistoricalDataBase(const Cpd0SubsetItemInstance &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCpd0reuse_elementBase(const Cpd0SubsetItemInstance &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCpd0search_criteriaBase(const Cpd0SubsetItemInstance &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.2.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCpd0reuse_elementBase(Cpd0SubsetItemInstance &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.2.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCpd0search_criteriaBase(Cpd0SubsetItemInstance &ifObj,  const tag_t &value, bool isNull );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @param isLockForDelete - A boolean to indicate if object(s) are to be locked for deletion
    /// @param allowRelock - A boolean to indicate if object(s) can be relocked, which will discard all unsaved changes, if already locked by the same user
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0LockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd, const bool isLockForDelete, const bool allowRelock );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0RefreshBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0UnlockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static Cpd0SubsetItemInstanceDelegate*  m_pInstance;

    Cpd0SubsetItemInstanceDelegate();
    virtual ~Cpd0SubsetItemInstanceDelegate();
    static void setInstance( Cpd0SubsetItemInstanceDelegate*  instance );


private:
    friend class  ::Teamcenter::Cpd::Cpd0SubsetItemInstanceGenImpl;

};

#include <cpd0workset/libcpd0workset_undef.h>
#endif  //  TEAMCENTER__CPD__CPD0SUBSETITEMINSTANCEDELEGATE_HXX
