//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cpd0SubsetItemLine
    Filename:   Cpd0SubsetItemLine.hxx
    Module:     cpd0workset
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPD__CPD0SUBSETITEMLINE__HXX
#define TEAMCENTER__CPD__CPD0SUBSETITEMLINE__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <bom/ImanItemLine.hxx>

#include <cpd0workset/libcpd0workset_exports.h>

namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0SubsetItemLine;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0SubsetItemLineImpl;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0SubsetItemLineDelegate;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0SubsetItemLineDispatch;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0SubsetItemLineGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CPD0WORKSET_API  Teamcenter::Cpd::Cpd0SubsetItemLine
     : public  ::Teamcenter::ImanItemLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCpd0UserAddedChildren( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cpd0SubsetItemLine();

    /**
     * Destructor
     */
    virtual ~Cpd0SubsetItemLine();

private:
    //  Getter method for the Implementation Object
    Cpd0SubsetItemLineImpl*  getCpd0SubsetItemLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCpd0SubsetItemLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cpd0SubsetItemLineImpl*  m_cpd0subsetitemlineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cpd0SubsetItemLine - desc for Cpd0SubsetItemLine parameter
     */
    Cpd0SubsetItemLine( const Cpd0SubsetItemLine& );
    Cpd0SubsetItemLine& operator=( const Cpd0SubsetItemLine& );

    friend class  Cpd0SubsetItemLineDelegate;
    friend class  Cpd0SubsetItemLineDispatch;
    friend class  Cpd0SubsetItemLineGenImpl;
};

#include <cpd0workset/libcpd0workset_undef.h>
#endif //   TEAMCENTER__CPD__CPD0SUBSETITEMLINE__HXX
