//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cpd0SubsetItemRevision
    Filename:   Cpd0SubsetItemRevision.hxx
    Module:     cpd0workset
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPD__CPD0SUBSETITEMREVISION__HXX
#define TEAMCENTER__CPD__CPD0SUBSETITEMREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <cpd0workset/Cpd0AbsSubsetItmRevision.hxx>

#include <cpd0workset/libcpd0workset_exports.h>

namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0SubsetItemRevision;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0SubsetItemRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0SubsetItemRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0SubsetItemRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0SubsetItemRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CPD0WORKSET_API  Teamcenter::Cpd::Cpd0SubsetItemRevision
     : public  ::Teamcenter::Cpd::Cpd0AbsSubsetItmRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cpd0SubsetItemRevision();

    /**
     * Destructor
     */
    virtual ~Cpd0SubsetItemRevision();

private:
    //  Getter method for the Implementation Object
    Cpd0SubsetItemRevisionImpl*  getCpd0SubsetItemRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCpd0SubsetItemRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cpd0SubsetItemRevisionImpl*  m_cpd0subsetitemrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cpd0SubsetItemRevision - desc for Cpd0SubsetItemRevision parameter
     */
    Cpd0SubsetItemRevision( const Cpd0SubsetItemRevision& );
    Cpd0SubsetItemRevision& operator=( const Cpd0SubsetItemRevision& );

    friend class  Cpd0SubsetItemRevisionDelegate;
    friend class  Cpd0SubsetItemRevisionDispatch;
    friend class  Cpd0SubsetItemRevisionGenImpl;
};

#include <cpd0workset/libcpd0workset_undef.h>
#endif //   TEAMCENTER__CPD__CPD0SUBSETITEMREVISION__HXX
