//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cpd0SubsetLine
    Filename:   Cpd0SubsetLine.hxx
    Module:     cpd0workset
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPD__CPD0SUBSETLINE__HXX
#define TEAMCENTER__CPD__CPD0SUBSETLINE__HXX

#include <string>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <bom/BOMLine.hxx>

#include <cpd0workset/libcpd0workset_exports.h>

namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0SubsetLine;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0SubsetLineImpl;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0SubsetLineDelegate;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0SubsetLineDispatch;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0SubsetLineGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CPD0WORKSET_API  Teamcenter::Cpd::Cpd0SubsetLine
     : public  ::Teamcenter::BOMLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Returns the clone stable ID for the associated DesignSubsetElement.
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCpd0cs_id( std::string &value, bool &isNull ) const;

    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 11.5
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCpd0MatchingClearanceCalcs( std::vector< std::string > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cpd0SubsetLine();

    /**
     * Destructor
     */
    virtual ~Cpd0SubsetLine();

private:
    //  Getter method for the Implementation Object
    Cpd0SubsetLineImpl*  getCpd0SubsetLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCpd0SubsetLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cpd0SubsetLineImpl*  m_cpd0subsetlineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cpd0SubsetLine - desc for Cpd0SubsetLine parameter
     */
    Cpd0SubsetLine( const Cpd0SubsetLine& );
    Cpd0SubsetLine& operator=( const Cpd0SubsetLine& );

    friend class  Cpd0SubsetLineDelegate;
    friend class  Cpd0SubsetLineDispatch;
    friend class  Cpd0SubsetLineGenImpl;
};

#include <cpd0workset/libcpd0workset_undef.h>
#endif //   TEAMCENTER__CPD__CPD0SUBSETLINE__HXX
