//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cpd0SubsetLineDelegate
    Filename:   Cpd0SubsetLineDelegate.hxx
    Module:     cpd0workset
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPD__CPD0SUBSETLINEDELEGATE_HXX
#define TEAMCENTER__CPD__CPD0SUBSETLINEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cpd0workset/Cpd0SubsetLine.hxx>

#include <cpd0workset/libcpd0workset_exports.h>

namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0SubsetLineDelegate;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0SubsetLineImpl;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0SubsetLine;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0SubsetLineGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CPD0WORKSET_API Teamcenter_alias::Cpd::Cpd0SubsetLineDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cpd0SubsetLineDelegate instance
    static Cpd0SubsetLineDelegate&  getInstance();

    //  Method to create the Cpd0SubsetLineImpl pointer
    static Cpd0SubsetLineImpl*  createImpl( Cpd0SubsetLine&  ifObj );

    //  Method to delete the Cpd0SubsetLineImpl pointer
    static void deleteImpl( Cpd0SubsetLineImpl*  impl );


    ///
    /// Returns the clone stable ID for the associated DesignSubsetElement.
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCpd0cs_idBase(const Cpd0SubsetLine &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 11.5
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCpd0MatchingClearanceCalcsBase(const Cpd0SubsetLine &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;



protected:
    //  Pointer to the instance
    static Cpd0SubsetLineDelegate*  m_pInstance;

    Cpd0SubsetLineDelegate();
    virtual ~Cpd0SubsetLineDelegate();
    static void setInstance( Cpd0SubsetLineDelegate*  instance );


private:
    friend class  ::Teamcenter::Cpd::Cpd0SubsetLineGenImpl;

};

#include <cpd0workset/libcpd0workset_undef.h>
#endif  //  TEAMCENTER__CPD__CPD0SUBSETLINEDELEGATE_HXX
