//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cpd0Workset
    Filename:   Cpd0Workset.hxx
    Module:     cpd0workset
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPD__CPD0WORKSET__HXX
#define TEAMCENTER__CPD__CPD0WORKSET__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <cpd0workset/libcpd0workset_exports.h>

namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0Workset;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0WorksetImpl;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0WorksetDelegate;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0WorksetDispatch;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0WorksetGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CPD0WORKSET_API  Teamcenter::Cpd::Cpd0Workset
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cpd0Workset();

    /**
     * Destructor
     */
    virtual ~Cpd0Workset();

private:
    //  Getter method for the Implementation Object
    Cpd0WorksetImpl*  getCpd0WorksetImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCpd0WorksetImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cpd0WorksetImpl*  m_cpd0worksetImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cpd0Workset - desc for Cpd0Workset parameter
     */
    Cpd0Workset( const Cpd0Workset& );
    Cpd0Workset& operator=( const Cpd0Workset& );

    friend class  Cpd0WorksetDelegate;
    friend class  Cpd0WorksetDispatch;
    friend class  Cpd0WorksetGenImpl;
};

#include <cpd0workset/libcpd0workset_undef.h>
#endif //   TEAMCENTER__CPD__CPD0WORKSET__HXX
