//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cpd0WorksetLine
    Filename:   Cpd0WorksetLine.hxx
    Module:     cpd0workset
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPD__CPD0WORKSETLINE__HXX
#define TEAMCENTER__CPD__CPD0WORKSETLINE__HXX

#include <common/tc_deprecation_macros.h>
#include <bom/ImanItemLine.hxx>

#include <cpd0workset/libcpd0workset_exports.h>

namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0WorksetLine;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0WorksetLineImpl;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0WorksetLineDelegate;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0WorksetLineDispatch;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0WorksetLineGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CPD0WORKSET_API  Teamcenter::Cpd::Cpd0WorksetLine
     : public  ::Teamcenter::ImanItemLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCpd0areSubsetsVisible( bool &value, bool &isNull ) const;

    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCpd0areSubsetsVisible( bool value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cpd0WorksetLine();

    /**
     * Destructor
     */
    virtual ~Cpd0WorksetLine();

private:
    //  Getter method for the Implementation Object
    Cpd0WorksetLineImpl*  getCpd0WorksetLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCpd0WorksetLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cpd0WorksetLineImpl*  m_cpd0worksetlineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cpd0WorksetLine - desc for Cpd0WorksetLine parameter
     */
    Cpd0WorksetLine( const Cpd0WorksetLine& );
    Cpd0WorksetLine& operator=( const Cpd0WorksetLine& );

    friend class  Cpd0WorksetLineDelegate;
    friend class  Cpd0WorksetLineDispatch;
    friend class  Cpd0WorksetLineGenImpl;
};

#include <cpd0workset/libcpd0workset_undef.h>
#endif //   TEAMCENTER__CPD__CPD0WORKSETLINE__HXX
