//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cpd0WorksetModel
    Filename:   Cpd0WorksetModel.hxx
    Module:     cpd0workset
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPD__CPD0WORKSETMODEL__HXX
#define TEAMCENTER__CPD__CPD0WORKSETMODEL__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <cpd0workset/libcpd0workset_exports.h>

namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0WorksetModel;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0WorksetModelImpl;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0WorksetModelDelegate;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0WorksetModelDispatch;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0WorksetModelGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CPD0WORKSET_API  Teamcenter::Cpd::Cpd0WorksetModel
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCpd0bvr( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCpd0bvr( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cpd0WorksetModel();

    /**
     * Destructor
     */
    virtual ~Cpd0WorksetModel();

private:
    //  Getter method for the Implementation Object
    Cpd0WorksetModelImpl*  getCpd0WorksetModelImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCpd0WorksetModelImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cpd0WorksetModelImpl*  m_cpd0worksetmodelImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cpd0WorksetModel - desc for Cpd0WorksetModel parameter
     */
    Cpd0WorksetModel( const Cpd0WorksetModel& );
    Cpd0WorksetModel& operator=( const Cpd0WorksetModel& );

    friend class  Cpd0WorksetModelDelegate;
    friend class  Cpd0WorksetModelDispatch;
    friend class  Cpd0WorksetModelGenImpl;
};

#include <cpd0workset/libcpd0workset_undef.h>
#endif //   TEAMCENTER__CPD__CPD0WORKSETMODEL__HXX
