//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cpd0WorksetModelDelegate
    Filename:   Cpd0WorksetModelDelegate.hxx
    Module:     cpd0workset
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPD__CPD0WORKSETMODELDELEGATE_HXX
#define TEAMCENTER__CPD__CPD0WORKSETMODELDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cpd0workset/Cpd0WorksetModel.hxx>

#include <cpd0workset/libcpd0workset_exports.h>

namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0WorksetModelDelegate;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0WorksetModelImpl;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0WorksetModel;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0WorksetModelGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CPD0WORKSET_API Teamcenter_alias::Cpd::Cpd0WorksetModelDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cpd0WorksetModelDelegate instance
    static Cpd0WorksetModelDelegate&  getInstance();

    //  Method to create the Cpd0WorksetModelImpl pointer
    static Cpd0WorksetModelImpl*  createImpl( Cpd0WorksetModel&  ifObj );

    //  Method to delete the Cpd0WorksetModelImpl pointer
    static void deleteImpl( Cpd0WorksetModelImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCpd0bvrBase(const Cpd0WorksetModel &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCpd0bvrBase(Cpd0WorksetModel &ifObj,  const tag_t &value, bool isNull );



protected:
    //  Pointer to the instance
    static Cpd0WorksetModelDelegate*  m_pInstance;

    Cpd0WorksetModelDelegate();
    virtual ~Cpd0WorksetModelDelegate();
    static void setInstance( Cpd0WorksetModelDelegate*  instance );


private:
    friend class  ::Teamcenter::Cpd::Cpd0WorksetModelGenImpl;

};

#include <cpd0workset/libcpd0workset_undef.h>
#endif  //  TEAMCENTER__CPD__CPD0WORKSETMODELDELEGATE_HXX
