//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cpd0WorksetRevision
    Filename:   Cpd0WorksetRevision.hxx
    Module:     cpd0workset
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPD__CPD0WORKSETREVISION__HXX
#define TEAMCENTER__CPD__CPD0WORKSETREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <cpd0workset/libcpd0workset_exports.h>

namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0WorksetRevision;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0WorksetRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0WorksetRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0WorksetRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0WorksetRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CPD0WORKSET_API  Teamcenter::Cpd::Cpd0WorksetRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Cpd0WorksetRevision();

    /**
     * Destructor
     */
    virtual ~Cpd0WorksetRevision();

private:
    //  Getter method for the Implementation Object
    Cpd0WorksetRevisionImpl*  getCpd0WorksetRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCpd0WorksetRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Cpd0WorksetRevisionImpl*  m_cpd0worksetrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Cpd0WorksetRevision - desc for Cpd0WorksetRevision parameter
     */
    Cpd0WorksetRevision( const Cpd0WorksetRevision& );
    Cpd0WorksetRevision& operator=( const Cpd0WorksetRevision& );

    friend class  Cpd0WorksetRevisionDelegate;
    friend class  Cpd0WorksetRevisionDispatch;
    friend class  Cpd0WorksetRevisionGenImpl;
};

#include <cpd0workset/libcpd0workset_undef.h>
#endif //   TEAMCENTER__CPD__CPD0WORKSETREVISION__HXX
