//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Cpd0WorksetRevisionDelegate
    Filename:   Cpd0WorksetRevisionDelegate.hxx
    Module:     cpd0workset
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPD__CPD0WORKSETREVISIONDELEGATE_HXX
#define TEAMCENTER__CPD__CPD0WORKSETREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cpd0workset/Cpd0WorksetRevision.hxx>

#include <cpd0workset/libcpd0workset_exports.h>

namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0WorksetRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0WorksetRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0WorksetRevision;
    }
}
namespace Teamcenter
{
    namespace Cpd
    {
        class Cpd0WorksetRevisionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CPD0WORKSET_API Teamcenter_alias::Cpd::Cpd0WorksetRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Cpd0WorksetRevisionDelegate instance
    static Cpd0WorksetRevisionDelegate&  getInstance();

    //  Method to create the Cpd0WorksetRevisionImpl pointer
    static Cpd0WorksetRevisionImpl*  createImpl( Cpd0WorksetRevision&  ifObj );

    //  Method to delete the Cpd0WorksetRevisionImpl pointer
    static void deleteImpl( Cpd0WorksetRevisionImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.3
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0PerformDeepCopyBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// perform deep copy
    /// @version Teamcenter 9
    /// @param pOperationInput - desc
    /// @param vecDeepCopyData - deep copy data
    /// @return - returns an int
    ///
    int  performDeepCopyBase(const Cpd0WorksetRevision &ifObj,  ::Teamcenter::OperationInput *pOperationInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static Cpd0WorksetRevisionDelegate*  m_pInstance;

    Cpd0WorksetRevisionDelegate();
    virtual ~Cpd0WorksetRevisionDelegate();
    static void setInstance( Cpd0WorksetRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::Cpd::Cpd0WorksetRevisionGenImpl;

};

#include <cpd0workset/libcpd0workset_undef.h>
#endif  //  TEAMCENTER__CPD__CPD0WORKSETREVISIONDELEGATE_HXX
