//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  cpddispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libcpddispatch

#if !defined(LIBCPDDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBCPDDISPATCH is not defined
#endif

/* Handwritten code should use CPDDISPATCH_API, not CPDDISPATCHEXPORT */

#define CPDDISPATCH_API CPDDISPATCHEXPORT

#if IPLIB==libcpddispatch || defined(LIBCPDDISPATCH)
#   if defined(__lint)
#       define CPDDISPATCHEXPORT       __export(cpddispatch)
#       define CPDDISPATCHGLOBAL       extern __global(cpddispatch)
#       define CPDDISPATCHPRIVATE      extern __private(cpddispatch)
#   elif defined(_WIN32)
#       define CPDDISPATCHEXPORT       __declspec(dllexport)
#       define CPDDISPATCHGLOBAL       extern __declspec(dllexport)
#       define CPDDISPATCHPRIVATE      extern
#   else
#       define CPDDISPATCHEXPORT
#       define CPDDISPATCHGLOBAL       extern
#       define CPDDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CPDDISPATCHEXPORT       __export(cpddispatch)
#       define CPDDISPATCHGLOBAL       extern __global(cpddispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CPDDISPATCHEXPORT      __declspec(dllimport)
#       define CPDDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define CPDDISPATCHEXPORT
#       define CPDDISPATCHGLOBAL       extern
#   endif
#endif
