//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPGRawMaterialRevisionDelegate
    Filename:   CPGRawMaterialRevisionDelegate.hxx
    Module:     cpgmaterials
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CPGMATERIALS__CPGRAWMATERIALREVISIONDELEGATE_HXX
#define TEAMCENTER__CPGMATERIALS__CPGRAWMATERIALREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cpgmaterials/CPGRawMaterialRevision.hxx>

#include <cpgmaterials/libcpgmaterials_exports.h>

namespace Teamcenter
{
    namespace CPGMATERIALS
    {
        class CPGRawMaterialRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace CPGMATERIALS
    {
        class CPGRawMaterialRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace CPGMATERIALS
    {
        class CPGRawMaterialRevision;
    }
}
namespace Teamcenter
{
    namespace CPGMATERIALS
    {
        class CPGRawMaterialRevisionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  CPGMATERIALS_API Teamcenter_alias::CPGMATERIALS::CPGRawMaterialRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CPGRawMaterialRevisionDelegate instance
    static CPGRawMaterialRevisionDelegate&  getInstance();

    //  Method to create the CPGRawMaterialRevisionImpl pointer
    static CPGRawMaterialRevisionImpl*  createImpl( CPGRawMaterialRevision&  ifObj );

    //  Method to delete the CPGRawMaterialRevisionImpl pointer
    static void deleteImpl( CPGRawMaterialRevisionImpl*  impl );


    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBoiling_pointBase(const CPGRawMaterialRevision &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCAS_nameBase(const CPGRawMaterialRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCAS_name_alternativeBase(const CPGRawMaterialRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCAS_numberBase(const CPGRawMaterialRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCAS_number_alternativeBase(const CPGRawMaterialRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCatalog_numberBase(const CPGRawMaterialRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getColor_indexBase(const CPGRawMaterialRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCostBase(const CPGRawMaterialRevision &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getEC_nameBase(const CPGRawMaterialRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getEC_numberBase(const CPGRawMaterialRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getExperimental_idBase(const CPGRawMaterialRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Date Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getExpiry_dateBase(const CPGRawMaterialRevision &ifObj,  date_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFeedstock_originBase(const CPGRawMaterialRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFlash_pointBase(const CPGRawMaterialRevision &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getINCI_name_ECBase(const CPGRawMaterialRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getINCI_name_JapanBase(const CPGRawMaterialRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getINCI_name_USBase(const CPGRawMaterialRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIUPAC_nameBase(const CPGRawMaterialRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getJapan_tricodeBase(const CPGRawMaterialRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getKosherBase(const CPGRawMaterialRevision &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMaterial_characteristicBase(const CPGRawMaterialRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMaterial_functionBase(const CPGRawMaterialRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMax_ingredient_levelBase(const CPGRawMaterialRevision &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMolecular_formulaBase(const CPGRawMaterialRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMolecular_structureBase(const CPGRawMaterialRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMolecular_weightBase(const CPGRawMaterialRevision &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getNFPA_HFR_ratingBase(const CPGRawMaterialRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getOil_water_ratioBase(const CPGRawMaterialRevision &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPH_valueBase(const CPGRawMaterialRevision &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getProduct_numberBase(const CPGRawMaterialRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getProjected_volumeBase(const CPGRawMaterialRevision &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getR_s_phrases_internalBase(const CPGRawMaterialRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getR_s_phrases_manufacturerBase(const CPGRawMaterialRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getREACH_numberBase(const CPGRawMaterialRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRegulatory_restrictionsBase(const CPGRawMaterialRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getShelf_lifeBase(const CPGRawMaterialRevision &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSpecific_gravityBase(const CPGRawMaterialRevision &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getStateBase(const CPGRawMaterialRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getStorage_and_handlingBase(const CPGRawMaterialRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSupplier_transportBase(const CPGRawMaterialRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getTrade_nameBase(const CPGRawMaterialRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getTransport_informationBase(const CPGRawMaterialRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getTSCA_bans_restrictionsBase(const CPGRawMaterialRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getVapor_pressureBase(const CPGRawMaterialRevision &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getWater_solubilityBase(const CPGRawMaterialRevision &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setBoiling_pointBase(CPGRawMaterialRevision &ifObj,  double value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCAS_nameBase(CPGRawMaterialRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCAS_name_alternativeBase(CPGRawMaterialRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCAS_numberBase(CPGRawMaterialRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCAS_number_alternativeBase(CPGRawMaterialRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCatalog_numberBase(CPGRawMaterialRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setColor_indexBase(CPGRawMaterialRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCostBase(CPGRawMaterialRevision &ifObj,  double value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setEC_nameBase(CPGRawMaterialRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setEC_numberBase(CPGRawMaterialRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setExperimental_idBase(CPGRawMaterialRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Date Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setExpiry_dateBase(CPGRawMaterialRevision &ifObj,  const date_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFeedstock_originBase(CPGRawMaterialRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFlash_pointBase(CPGRawMaterialRevision &ifObj,  double value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setINCI_name_ECBase(CPGRawMaterialRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setINCI_name_JapanBase(CPGRawMaterialRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setINCI_name_USBase(CPGRawMaterialRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIUPAC_nameBase(CPGRawMaterialRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setJapan_tricodeBase(CPGRawMaterialRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setKosherBase(CPGRawMaterialRevision &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMaterial_characteristicBase(CPGRawMaterialRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMaterial_functionBase(CPGRawMaterialRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMax_ingredient_levelBase(CPGRawMaterialRevision &ifObj,  double value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMolecular_formulaBase(CPGRawMaterialRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMolecular_structureBase(CPGRawMaterialRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMolecular_weightBase(CPGRawMaterialRevision &ifObj,  double value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setNFPA_HFR_ratingBase(CPGRawMaterialRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setOil_water_ratioBase(CPGRawMaterialRevision &ifObj,  double value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPH_valueBase(CPGRawMaterialRevision &ifObj,  double value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setProduct_numberBase(CPGRawMaterialRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setProjected_volumeBase(CPGRawMaterialRevision &ifObj,  double value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setR_s_phrases_internalBase(CPGRawMaterialRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setR_s_phrases_manufacturerBase(CPGRawMaterialRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setREACH_numberBase(CPGRawMaterialRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setRegulatory_restrictionsBase(CPGRawMaterialRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setShelf_lifeBase(CPGRawMaterialRevision &ifObj,  int value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSpecific_gravityBase(CPGRawMaterialRevision &ifObj,  double value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setStateBase(CPGRawMaterialRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setStorage_and_handlingBase(CPGRawMaterialRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSupplier_transportBase(CPGRawMaterialRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setTrade_nameBase(CPGRawMaterialRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setTransport_informationBase(CPGRawMaterialRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setTSCA_bans_restrictionsBase(CPGRawMaterialRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setVapor_pressureBase(CPGRawMaterialRevision &ifObj,  double value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setWater_solubilityBase(CPGRawMaterialRevision &ifObj,  double value, bool isNull );



protected:
    //  Pointer to the instance
    static CPGRawMaterialRevisionDelegate*  m_pInstance;

    CPGRawMaterialRevisionDelegate();
    virtual ~CPGRawMaterialRevisionDelegate();
    static void setInstance( CPGRawMaterialRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::CPGMATERIALS::CPGRawMaterialRevisionGenImpl;

};

#include <cpgmaterials/libcpgmaterials_undef.h>
#endif  //  TEAMCENTER__CPGMATERIALS__CPGRAWMATERIALREVISIONDELEGATE_HXX
