//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  cpgmaterials

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libcpgmaterials

#if !defined(LIBCPGMATERIALS) && !defined(IPLIB)
#   error IPLIB or LIBCPGMATERIALS is not defined
#endif

/* Handwritten code should use CPGMATERIALS_API, not CPGMATERIALSEXPORT */

#define CPGMATERIALS_API CPGMATERIALSEXPORT

#if IPLIB==libcpgmaterials || defined(LIBCPGMATERIALS)
#   if defined(__lint)
#       define CPGMATERIALSEXPORT       __export(cpgmaterials)
#       define CPGMATERIALSGLOBAL       extern __global(cpgmaterials)
#       define CPGMATERIALSPRIVATE      extern __private(cpgmaterials)
#   elif defined(_WIN32)
#       define CPGMATERIALSEXPORT       __declspec(dllexport)
#       define CPGMATERIALSGLOBAL       extern __declspec(dllexport)
#       define CPGMATERIALSPRIVATE      extern
#   else
#       define CPGMATERIALSEXPORT
#       define CPGMATERIALSGLOBAL       extern
#       define CPGMATERIALSPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CPGMATERIALSEXPORT       __export(cpgmaterials)
#       define CPGMATERIALSGLOBAL       extern __global(cpgmaterials)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CPGMATERIALSEXPORT      __declspec(dllimport)
#       define CPGMATERIALSGLOBAL       extern __declspec(dllimport)
#   else
#       define CPGMATERIALSEXPORT
#       define CPGMATERIALSGLOBAL       extern
#   endif
#endif
