//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  cpgmaterialsdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libcpgmaterialsdispatch

#if !defined(LIBCPGMATERIALSDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBCPGMATERIALSDISPATCH is not defined
#endif

/* Handwritten code should use CPGMATERIALSDISPATCH_API, not CPGMATERIALSDISPATCHEXPORT */

#define CPGMATERIALSDISPATCH_API CPGMATERIALSDISPATCHEXPORT

#if IPLIB==libcpgmaterialsdispatch || defined(LIBCPGMATERIALSDISPATCH)
#   if defined(__lint)
#       define CPGMATERIALSDISPATCHEXPORT       __export(cpgmaterialsdispatch)
#       define CPGMATERIALSDISPATCHGLOBAL       extern __global(cpgmaterialsdispatch)
#       define CPGMATERIALSDISPATCHPRIVATE      extern __private(cpgmaterialsdispatch)
#   elif defined(_WIN32)
#       define CPGMATERIALSDISPATCHEXPORT       __declspec(dllexport)
#       define CPGMATERIALSDISPATCHGLOBAL       extern __declspec(dllexport)
#       define CPGMATERIALSDISPATCHPRIVATE      extern
#   else
#       define CPGMATERIALSDISPATCHEXPORT
#       define CPGMATERIALSDISPATCHGLOBAL       extern
#       define CPGMATERIALSDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CPGMATERIALSDISPATCHEXPORT       __export(cpgmaterialsdispatch)
#       define CPGMATERIALSDISPATCHGLOBAL       extern __global(cpgmaterialsdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CPGMATERIALSDISPATCHEXPORT      __declspec(dllimport)
#       define CPGMATERIALSDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define CPGMATERIALSDISPATCHEXPORT
#       define CPGMATERIALSDISPATCHGLOBAL       extern
#   endif
#endif
