//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, POM_data_manager
    Filename:   POM_data_manager.hxx
    Module:     cxpom
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__POM_DATA_MANAGER__HXX
#define TEAMCENTER__POM_DATA_MANAGER__HXX

#include <common/tc_deprecation_macros.h>
#include <cxpom/POM_system_class.hxx>

#include <cxpom/libcxpom_exports.h>

namespace Teamcenter
{
    class POM_data_manager;
}
namespace Teamcenter
{
    class POM_data_managerImpl;
}
namespace Teamcenter
{
    class POM_data_managerDelegate;
}
namespace Teamcenter
{
    class POM_data_managerDispatch;
}
namespace Teamcenter
{
    class POM_data_managerGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CXPOM_API  Teamcenter::POM_data_manager
     : public  ::Teamcenter::POM_system_class
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    POM_data_manager();

    /**
     * Destructor
     */
    virtual ~POM_data_manager();

private:
    //  Getter method for the Implementation Object
    POM_data_managerImpl*  getPOM_data_managerImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPOM_data_managerImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    POM_data_managerImpl*  m_pom_data_managerImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param POM_data_manager - desc for POM_data_manager parameter
     */
    POM_data_manager( const POM_data_manager& );
    POM_data_manager& operator=( const POM_data_manager& );

    friend class  POM_data_managerDelegate;
    friend class  POM_data_managerDispatch;
    friend class  POM_data_managerGenImpl;
};

#include <cxpom/libcxpom_undef.h>
#endif //   TEAMCENTER__POM_DATA_MANAGER__HXX
