//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, POM_imc
    Filename:   POM_imc.hxx
    Module:     cxpom
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__POM_IMC__HXX
#define TEAMCENTER__POM_IMC__HXX

#include <unidefs.h>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <cxpom/POM_data_manager.hxx>

#include <cxpom/libcxpom_exports.h>

namespace Teamcenter
{
    class POM_imc;
}
namespace Teamcenter
{
    class POM_imcImpl;
}
namespace Teamcenter
{
    class POM_imcDelegate;
}
namespace Teamcenter
{
    class POM_imcDispatch;
}
namespace Teamcenter
{
    class POM_imcGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CXPOM_API  Teamcenter::POM_imc
     : public  ::Teamcenter::POM_data_manager
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0LicenseServer( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0OrganizationAuditLogs( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0LicenseServer( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    POM_imc();

    /**
     * Destructor
     */
    virtual ~POM_imc();

private:
    //  Getter method for the Implementation Object
    POM_imcImpl*  getPOM_imcImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPOM_imcImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    POM_imcImpl*  m_pom_imcImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param POM_imc - desc for POM_imc parameter
     */
    POM_imc( const POM_imc& );
    POM_imc& operator=( const POM_imc& );

    friend class  POM_imcDelegate;
    friend class  POM_imcDispatch;
    friend class  POM_imcGenImpl;
};

#include <cxpom/libcxpom_undef.h>
#endif //   TEAMCENTER__POM_IMC__HXX
