//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, POM_imcDelegate
    Filename:   POM_imcDelegate.hxx
    Module:     cxpom
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__POM_IMCDELEGATE_HXX
#define TEAMCENTER__POM_IMCDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <cxpom/POM_imc.hxx>

#include <cxpom/libcxpom_exports.h>

namespace Teamcenter
{
    class POM_imcDelegate;
}
namespace Teamcenter
{
    class POM_imcImpl;
}
namespace Teamcenter
{
    class POM_imc;
}
namespace Teamcenter
{
    class POM_imcGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  CXPOM_API Teamcenter_alias::POM_imcDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the POM_imcDelegate instance
    static POM_imcDelegate&  getInstance();

    //  Method to create the POM_imcImpl pointer
    static POM_imcImpl*  createImpl( POM_imc&  ifObj );

    //  Method to delete the POM_imcImpl pointer
    static void deleteImpl( POM_imcImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0LicenseServerBase(const POM_imc &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0OrganizationAuditLogsBase(const POM_imc &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0LicenseServerBase(POM_imc &ifObj,  const tag_t &value, bool isNull );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static POM_imcDelegate*  m_pInstance;

    POM_imcDelegate();
    virtual ~POM_imcDelegate();
    static void setInstance( POM_imcDelegate*  instance );


private:
    friend class  ::Teamcenter::POM_imcGenImpl;

};

#include <cxpom/libcxpom_undef.h>
#endif  //  TEAMCENTER__POM_IMCDELEGATE_HXX
