//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, POM_system_class
    Filename:   POM_system_class.hxx
    Module:     cxpom
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__POM_SYSTEM_CLASS__HXX
#define TEAMCENTER__POM_SYSTEM_CLASS__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <cxpom/libcxpom_exports.h>

namespace Teamcenter
{
    class POM_system_class;
}
namespace Teamcenter
{
    class POM_system_classImpl;
}
namespace Teamcenter
{
    class POM_system_classDelegate;
}
namespace Teamcenter
{
    class POM_system_classDispatch;
}
namespace Teamcenter
{
    class POM_system_classGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  CXPOM_API  Teamcenter::POM_system_class
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    POM_system_class();

    /**
     * Destructor
     */
    virtual ~POM_system_class();

private:
    //  Getter method for the Implementation Object
    POM_system_classImpl*  getPOM_system_classImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPOM_system_classImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    POM_system_classImpl*  m_pom_system_classImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param POM_system_class - desc for POM_system_class parameter
     */
    POM_system_class( const POM_system_class& );
    POM_system_class& operator=( const POM_system_class& );

    friend class  POM_system_classDelegate;
    friend class  POM_system_classDispatch;
    friend class  POM_system_classGenImpl;
};

#include <cxpom/libcxpom_undef.h>
#endif //   TEAMCENTER__POM_SYSTEM_CLASS__HXX
