//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  cxpom

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libcxpom

#if !defined(LIBCXPOM) && !defined(IPLIB)
#   error IPLIB or LIBCXPOM is not defined
#endif

/* Handwritten code should use CXPOM_API, not CXPOMEXPORT */

#define CXPOM_API CXPOMEXPORT

#if IPLIB==libcxpom || defined(LIBCXPOM)
#   if defined(__lint)
#       define CXPOMEXPORT       __export(cxpom)
#       define CXPOMGLOBAL       extern __global(cxpom)
#       define CXPOMPRIVATE      extern __private(cxpom)
#   elif defined(_WIN32)
#       define CXPOMEXPORT       __declspec(dllexport)
#       define CXPOMGLOBAL       extern __declspec(dllexport)
#       define CXPOMPRIVATE      extern
#   else
#       define CXPOMEXPORT
#       define CXPOMGLOBAL       extern
#       define CXPOMPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CXPOMEXPORT       __export(cxpom)
#       define CXPOMGLOBAL       extern __global(cxpom)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CXPOMEXPORT      __declspec(dllimport)
#       define CXPOMGLOBAL       extern __declspec(dllimport)
#   else
#       define CXPOMEXPORT
#       define CXPOMGLOBAL       extern
#   endif
#endif
