//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DerivedObjDelegate
    Filename:   DerivedObjDelegate.hxx
    Module:     docmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__DERIVEDOBJDELEGATE_HXX
#define TEAMCENTER__DERIVEDOBJDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <docmgt/DerivedObj.hxx>

#include <docmgt/libdocmgt_exports.h>

namespace Teamcenter
{
    class DerivedObjDelegate;
}
namespace Teamcenter
{
    class DerivedObjImpl;
}
namespace Teamcenter
{
    class DerivedObj;
}
namespace Teamcenter
{
    class DerivedObjGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  DOCMGT_API Teamcenter_alias::DerivedObjDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the DerivedObjDelegate instance
    static DerivedObjDelegate&  getInstance();

    //  Method to create the DerivedObjImpl pointer
    static DerivedObjImpl*  createImpl( DerivedObj&  ifObj );

    //  Method to delete the DerivedObjImpl pointer
    static void deleteImpl( DerivedObjImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDefining_irdcBase(const DerivedObj &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDer_dataset_type_nameBase(const DerivedObj &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDer_requiredBase(const DerivedObj &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getItem_revision_relationBase(const DerivedObj &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDefining_irdcBase(DerivedObj &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDer_dataset_type_nameBase(DerivedObj &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDer_requiredBase(DerivedObj &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setItem_revision_relationBase(DerivedObj &ifObj,  const tag_t &value, bool isNull );



protected:
    //  Pointer to the instance
    static DerivedObjDelegate*  m_pInstance;

    DerivedObjDelegate();
    virtual ~DerivedObjDelegate();
    static void setInstance( DerivedObjDelegate*  instance );


private:
    friend class  ::Teamcenter::DerivedObjGenImpl;

};

#include <docmgt/libdocmgt_undef.h>
#endif  //  TEAMCENTER__DERIVEDOBJDELEGATE_HXX
