//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DispatcherServiceArgumentDelegate
    Filename:   DispatcherServiceArgumentDelegate.hxx
    Module:     docmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__DISPATCHERSERVICEARGUMENTDELEGATE_HXX
#define TEAMCENTER__DISPATCHERSERVICEARGUMENTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <docmgt/DispatcherServiceArgument.hxx>

#include <docmgt/libdocmgt_exports.h>

namespace Teamcenter
{
    class DispatcherServiceArgumentDelegate;
}
namespace Teamcenter
{
    class DispatcherServiceArgumentImpl;
}
namespace Teamcenter
{
    class DispatcherServiceArgument;
}
namespace Teamcenter
{
    class DispatcherServiceArgumentGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  DOCMGT_API Teamcenter_alias::DispatcherServiceArgumentDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the DispatcherServiceArgumentDelegate instance
    static DispatcherServiceArgumentDelegate&  getInstance();

    //  Method to create the DispatcherServiceArgumentImpl pointer
    static DispatcherServiceArgumentImpl*  createImpl( DispatcherServiceArgument&  ifObj );

    //  Method to delete the DispatcherServiceArgumentImpl pointer
    static void deleteImpl( DispatcherServiceArgumentImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getArgument_nameBase(const DispatcherServiceArgument &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDefault_valueBase(const DispatcherServiceArgument &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDefining_dspsvcconfigBase(const DispatcherServiceArgument &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getInterface_typeBase(const DispatcherServiceArgument &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getKeyBase(const DispatcherServiceArgument &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setArgument_nameBase(DispatcherServiceArgument &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDefault_valueBase(DispatcherServiceArgument &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDefining_dspsvcconfigBase(DispatcherServiceArgument &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setInterface_typeBase(DispatcherServiceArgument &ifObj,  int value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setKeyBase(DispatcherServiceArgument &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static DispatcherServiceArgumentDelegate*  m_pInstance;

    DispatcherServiceArgumentDelegate();
    virtual ~DispatcherServiceArgumentDelegate();
    static void setInstance( DispatcherServiceArgumentDelegate*  instance );


private:
    friend class  ::Teamcenter::DispatcherServiceArgumentGenImpl;

};

#include <docmgt/libdocmgt_undef.h>
#endif  //  TEAMCENTER__DISPATCHERSERVICEARGUMENTDELEGATE_HXX
