//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DispatcherServiceConfigDelegate
    Filename:   DispatcherServiceConfigDelegate.hxx
    Module:     docmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__DISPATCHERSERVICECONFIGDELEGATE_HXX
#define TEAMCENTER__DISPATCHERSERVICECONFIGDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <docmgt/DispatcherServiceConfig.hxx>

#include <docmgt/libdocmgt_exports.h>

namespace Teamcenter
{
    class DispatcherServiceConfigDelegate;
}
namespace Teamcenter
{
    class DispatcherServiceConfigImpl;
}
namespace Teamcenter
{
    class DispatcherServiceConfig;
}
namespace Teamcenter
{
    class DispatcherServiceConfigGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  DOCMGT_API Teamcenter_alias::DispatcherServiceConfigDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the DispatcherServiceConfigDelegate instance
    static DispatcherServiceConfigDelegate&  getInstance();

    //  Method to create the DispatcherServiceConfigImpl pointer
    static DispatcherServiceConfigImpl*  createImpl( DispatcherServiceConfig&  ifObj );

    //  Method to delete the DispatcherServiceConfigImpl pointer
    static void deleteImpl( DispatcherServiceConfigImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDer_dataset_named_refBase(const DispatcherServiceConfig &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDer_dataset_type_nameBase(const DispatcherServiceConfig &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDer_from_dataset_relationBase(const DispatcherServiceConfig &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Tc 8
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getDispatcher_svc_argumentsBase(const DispatcherServiceConfig &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDispatcher_svc_availableBase(const DispatcherServiceConfig &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDispatcher_svc_display_nameBase(const DispatcherServiceConfig &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDispatcher_svc_nameBase(const DispatcherServiceConfig &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getItem_revision_relationBase(const DispatcherServiceConfig &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPriorityBase(const DispatcherServiceConfig &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getProvider_display_nameBase(const DispatcherServiceConfig &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getProvider_nameBase(const DispatcherServiceConfig &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSort_orderBase(const DispatcherServiceConfig &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSrc_dataset_named_refBase(const DispatcherServiceConfig &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSrc_dataset_type_nameBase(const DispatcherServiceConfig &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDer_dataset_named_refBase(DispatcherServiceConfig &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDer_dataset_type_nameBase(DispatcherServiceConfig &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDer_from_dataset_relationBase(DispatcherServiceConfig &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Tc 8
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setDispatcher_svc_argumentsBase(DispatcherServiceConfig &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDispatcher_svc_availableBase(DispatcherServiceConfig &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDispatcher_svc_display_nameBase(DispatcherServiceConfig &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDispatcher_svc_nameBase(DispatcherServiceConfig &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setItem_revision_relationBase(DispatcherServiceConfig &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPriorityBase(DispatcherServiceConfig &ifObj,  int value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setProvider_display_nameBase(DispatcherServiceConfig &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setProvider_nameBase(DispatcherServiceConfig &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSort_orderBase(DispatcherServiceConfig &ifObj,  int value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSrc_dataset_named_refBase(DispatcherServiceConfig &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSrc_dataset_type_nameBase(DispatcherServiceConfig &ifObj,  const tag_t &value, bool isNull );



protected:
    //  Pointer to the instance
    static DispatcherServiceConfigDelegate*  m_pInstance;

    DispatcherServiceConfigDelegate();
    virtual ~DispatcherServiceConfigDelegate();
    static void setInstance( DispatcherServiceConfigDelegate*  instance );


private:
    friend class  ::Teamcenter::DispatcherServiceConfigGenImpl;

};

#include <docmgt/libdocmgt_undef.h>
#endif  //  TEAMCENTER__DISPATCHERSERVICECONFIGDELEGATE_HXX
