//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0AttrExchangeConfig
    Filename:   Fnd0AttrExchangeConfig.hxx
    Module:     docmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0ATTREXCHANGECONFIG__HXX
#define TEAMCENTER__FND0ATTREXCHANGECONFIG__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <docmgt/libdocmgt_exports.h>

namespace Teamcenter
{
    class Fnd0AttrExchangeConfig;
}
namespace Teamcenter
{
    class Fnd0AttrExchangeConfigImpl;
}
namespace Teamcenter
{
    class Fnd0AttrExchangeConfigDelegate;
}
namespace Teamcenter
{
    class Fnd0AttrExchangeConfigDispatch;
}
namespace Teamcenter
{
    class Fnd0AttrExchangeConfigGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  DOCMGT_API  Teamcenter::Fnd0AttrExchangeConfig
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 13.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ExchangeDirection( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 13.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0Inherited( bool &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 13.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0IsWritable( bool &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 13.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0TargetPPDisplayName( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 13.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0ExchangeDirection( const std::string &value, bool isNull=false );

    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 13.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0IsWritable( bool value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0AttrExchangeConfig();

    /**
     * Destructor
     */
    virtual ~Fnd0AttrExchangeConfig();

private:
    //  Getter method for the Implementation Object
    Fnd0AttrExchangeConfigImpl*  getFnd0AttrExchangeConfigImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0AttrExchangeConfigImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0AttrExchangeConfigImpl*  m_fnd0attrexchangeconfigImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0AttrExchangeConfig - desc for Fnd0AttrExchangeConfig parameter
     */
    Fnd0AttrExchangeConfig( const Fnd0AttrExchangeConfig& );
    Fnd0AttrExchangeConfig& operator=( const Fnd0AttrExchangeConfig& );

    friend class  Fnd0AttrExchangeConfigDelegate;
    friend class  Fnd0AttrExchangeConfigDispatch;
    friend class  Fnd0AttrExchangeConfigGenImpl;
};

#include <docmgt/libdocmgt_undef.h>
#endif //   TEAMCENTER__FND0ATTREXCHANGECONFIG__HXX
