//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0AttrExchangeConfigDelegate
    Filename:   Fnd0AttrExchangeConfigDelegate.hxx
    Module:     docmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0ATTREXCHANGECONFIGDELEGATE_HXX
#define TEAMCENTER__FND0ATTREXCHANGECONFIGDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <docmgt/Fnd0AttrExchangeConfig.hxx>

#include <docmgt/libdocmgt_exports.h>

namespace Teamcenter
{
    class Fnd0AttrExchangeConfigDelegate;
}
namespace Teamcenter
{
    class Fnd0AttrExchangeConfigImpl;
}
namespace Teamcenter
{
    class Fnd0AttrExchangeConfig;
}
namespace Teamcenter
{
    class Fnd0AttrExchangeConfigGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  DOCMGT_API Teamcenter_alias::Fnd0AttrExchangeConfigDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0AttrExchangeConfigDelegate instance
    static Fnd0AttrExchangeConfigDelegate&  getInstance();

    //  Method to create the Fnd0AttrExchangeConfigImpl pointer
    static Fnd0AttrExchangeConfigImpl*  createImpl( Fnd0AttrExchangeConfig&  ifObj );

    //  Method to delete the Fnd0AttrExchangeConfigImpl pointer
    static void deleteImpl( Fnd0AttrExchangeConfigImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 13.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ExchangeDirectionBase(const Fnd0AttrExchangeConfig &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 13.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0InheritedBase(const Fnd0AttrExchangeConfig &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 13.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0IsWritableBase(const Fnd0AttrExchangeConfig &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 13.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0TargetPPDisplayNameBase(const Fnd0AttrExchangeConfig &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 13.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0ExchangeDirectionBase(Fnd0AttrExchangeConfig &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 13.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0IsWritableBase(Fnd0AttrExchangeConfig &ifObj,  bool value, bool isNull );



protected:
    //  Pointer to the instance
    static Fnd0AttrExchangeConfigDelegate*  m_pInstance;

    Fnd0AttrExchangeConfigDelegate();
    virtual ~Fnd0AttrExchangeConfigDelegate();
    static void setInstance( Fnd0AttrExchangeConfigDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0AttrExchangeConfigGenImpl;

};

#include <docmgt/libdocmgt_undef.h>
#endif  //  TEAMCENTER__FND0ATTREXCHANGECONFIGDELEGATE_HXX
