//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0LogicalObjectLOVBO
    Filename:   Fnd0LogicalObjectLOVBO.hxx
    Module:     docmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0LOGICALOBJECTLOVBO__HXX
#define TEAMCENTER__FND0LOGICALOBJECTLOVBO__HXX

#include <common/tc_deprecation_macros.h>
#include <lov/Fnd0ListOfValuesDynamic.hxx>

#include <docmgt/libdocmgt_exports.h>

namespace Teamcenter
{
    class Fnd0LogicalObjectLOVBO;
}
namespace Teamcenter
{
    class Fnd0LogicalObjectLOVBOImpl;
}
namespace Teamcenter
{
    class Fnd0LogicalObjectLOVBODelegate;
}
namespace Teamcenter
{
    class Fnd0LogicalObjectLOVBODispatch;
}
namespace Teamcenter
{
    class Fnd0LogicalObjectLOVBOGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  DOCMGT_API  Teamcenter::Fnd0LogicalObjectLOVBO
     : public  ::Teamcenter::Fnd0ListOfValuesDynamic
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0LogicalObjectLOVBO();

    /**
     * Destructor
     */
    virtual ~Fnd0LogicalObjectLOVBO();

private:
    //  Getter method for the Implementation Object
    Fnd0LogicalObjectLOVBOImpl*  getFnd0LogicalObjectLOVBOImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0LogicalObjectLOVBOImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0LogicalObjectLOVBOImpl*  m_fnd0logicalobjectlovboImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0LogicalObjectLOVBO - desc for Fnd0LogicalObjectLOVBO parameter
     */
    Fnd0LogicalObjectLOVBO( const Fnd0LogicalObjectLOVBO& );
    Fnd0LogicalObjectLOVBO& operator=( const Fnd0LogicalObjectLOVBO& );

    friend class  Fnd0LogicalObjectLOVBODelegate;
    friend class  Fnd0LogicalObjectLOVBODispatch;
    friend class  Fnd0LogicalObjectLOVBOGenImpl;
};

#include <docmgt/libdocmgt_undef.h>
#endif //   TEAMCENTER__FND0LOGICALOBJECTLOVBO__HXX
