//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0LogicalObjectLOVBODelegate
    Filename:   Fnd0LogicalObjectLOVBODelegate.hxx
    Module:     docmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0LOGICALOBJECTLOVBODELEGATE_HXX
#define TEAMCENTER__FND0LOGICALOBJECTLOVBODELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <docmgt/Fnd0LogicalObjectLOVBO.hxx>

#include <docmgt/libdocmgt_exports.h>

namespace Teamcenter
{
    class Fnd0LogicalObjectLOVBODelegate;
}
namespace Teamcenter
{
    class Fnd0LogicalObjectLOVBOImpl;
}
namespace Teamcenter
{
    class Fnd0LogicalObjectLOVBO;
}
namespace Teamcenter
{
    class Fnd0LogicalObjectLOVBOGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  DOCMGT_API Teamcenter_alias::Fnd0LogicalObjectLOVBODelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0LogicalObjectLOVBODelegate instance
    static Fnd0LogicalObjectLOVBODelegate&  getInstance();

    //  Method to create the Fnd0LogicalObjectLOVBOImpl pointer
    static Fnd0LogicalObjectLOVBOImpl*  createImpl( Fnd0LogicalObjectLOVBO&  ifObj );

    //  Method to delete the Fnd0LogicalObjectLOVBOImpl pointer
    static void deleteImpl( Fnd0LogicalObjectLOVBOImpl*  impl );


    ///
    /// Returns List Of Values based on Dynamic LOV definition and user search criteria.
    /// @version Teamcenter 10
    /// @param operationInputTag - Operation Input containing the modified values.
    /// @param propertyName - Name of the selected property.
    /// @param searchString - User entered search string.
    /// @param sortByProp - Property to use for sorting.
    /// @param sortOrder - order for sorting (0=Ascending, 1=Descending).
    /// @param nResults - Number of returned results.
    /// @param results - Returned Values for LOV.
    /// @return - Zero (0) if everything is alright otherwise the error code.
    ///
    int  fnd0askLOVValuesBase(const Fnd0LogicalObjectLOVBO &ifObj,  const tag_t operationInputTag, const std::string *propertyName, const std::string *searchString, const char *sortByProp, const int sortOrder, int *nResults, tag_t **results ) const;



protected:
    //  Pointer to the instance
    static Fnd0LogicalObjectLOVBODelegate*  m_pInstance;

    Fnd0LogicalObjectLOVBODelegate();
    virtual ~Fnd0LogicalObjectLOVBODelegate();
    static void setInstance( Fnd0LogicalObjectLOVBODelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0LogicalObjectLOVBOGenImpl;

};

#include <docmgt/libdocmgt_undef.h>
#endif  //  TEAMCENTER__FND0LOGICALOBJECTLOVBODELEGATE_HXX
