//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, IRDCDerNaming
    Filename:   IRDCDerNaming.hxx
    Module:     docmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IRDCDERNAMING__HXX
#define TEAMCENTER__IRDCDERNAMING__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <docmgt/IRDCNaming.hxx>

#include <docmgt/libdocmgt_exports.h>

namespace Teamcenter
{
    class IRDCDerNaming;
}
namespace Teamcenter
{
    class IRDCDerNamingImpl;
}
namespace Teamcenter
{
    class IRDCDerNamingDelegate;
}
namespace Teamcenter
{
    class IRDCDerNamingDispatch;
}
namespace Teamcenter
{
    class IRDCDerNamingGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  DOCMGT_API  Teamcenter::IRDCDerNaming
     : public  ::Teamcenter::IRDCNaming
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDer_ds_name( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDer_ds_name( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    IRDCDerNaming();

    /**
     * Destructor
     */
    virtual ~IRDCDerNaming();

private:
    //  Getter method for the Implementation Object
    IRDCDerNamingImpl*  getIRDCDerNamingImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setIRDCDerNamingImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    IRDCDerNamingImpl*  m_irdcdernamingImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param IRDCDerNaming - desc for IRDCDerNaming parameter
     */
    IRDCDerNaming( const IRDCDerNaming& );
    IRDCDerNaming& operator=( const IRDCDerNaming& );

    friend class  IRDCDerNamingDelegate;
    friend class  IRDCDerNamingDispatch;
    friend class  IRDCDerNamingGenImpl;
};

#include <docmgt/libdocmgt_undef.h>
#endif //   TEAMCENTER__IRDCDERNAMING__HXX
