//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, IRDCDerNamingDelegate
    Filename:   IRDCDerNamingDelegate.hxx
    Module:     docmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IRDCDERNAMINGDELEGATE_HXX
#define TEAMCENTER__IRDCDERNAMINGDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <docmgt/IRDCDerNaming.hxx>

#include <docmgt/libdocmgt_exports.h>

namespace Teamcenter
{
    class IRDCDerNamingDelegate;
}
namespace Teamcenter
{
    class IRDCDerNamingImpl;
}
namespace Teamcenter
{
    class IRDCDerNaming;
}
namespace Teamcenter
{
    class IRDCDerNamingGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  DOCMGT_API Teamcenter_alias::IRDCDerNamingDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the IRDCDerNamingDelegate instance
    static IRDCDerNamingDelegate&  getInstance();

    //  Method to create the IRDCDerNamingImpl pointer
    static IRDCDerNamingImpl*  createImpl( IRDCDerNaming&  ifObj );

    //  Method to delete the IRDCDerNamingImpl pointer
    static void deleteImpl( IRDCDerNamingImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDer_ds_nameBase(const IRDCDerNaming &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDer_ds_nameBase(IRDCDerNaming &ifObj,  const tag_t &value, bool isNull );



protected:
    //  Pointer to the instance
    static IRDCDerNamingDelegate*  m_pInstance;

    IRDCDerNamingDelegate();
    virtual ~IRDCDerNamingDelegate();
    static void setInstance( IRDCDerNamingDelegate*  instance );


private:
    friend class  ::Teamcenter::IRDCDerNamingGenImpl;

};

#include <docmgt/libdocmgt_undef.h>
#endif  //  TEAMCENTER__IRDCDERNAMINGDELEGATE_HXX
