//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PrefixPropertyDelegate
    Filename:   PrefixPropertyDelegate.hxx
    Module:     docmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PREFIXPROPERTYDELEGATE_HXX
#define TEAMCENTER__PREFIXPROPERTYDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <docmgt/PrefixProperty.hxx>

#include <docmgt/libdocmgt_exports.h>

namespace Teamcenter
{
    class PrefixPropertyDelegate;
}
namespace Teamcenter
{
    class PrefixPropertyImpl;
}
namespace Teamcenter
{
    class PrefixProperty;
}
namespace Teamcenter
{
    class PrefixPropertyGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  DOCMGT_API Teamcenter_alias::PrefixPropertyDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PrefixPropertyDelegate instance
    static PrefixPropertyDelegate&  getInstance();

    //  Method to create the PrefixPropertyImpl pointer
    static PrefixPropertyImpl*  createImpl( PrefixProperty&  ifObj );

    //  Method to delete the PrefixPropertyImpl pointer
    static void deleteImpl( PrefixPropertyImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDefining_system_stampBase(const PrefixProperty &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPrefixBase(const PrefixProperty &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getStamp_propertyBase(const PrefixProperty &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDefining_system_stampBase(PrefixProperty &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPrefixBase(PrefixProperty &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setStamp_propertyBase(PrefixProperty &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static PrefixPropertyDelegate*  m_pInstance;

    PrefixPropertyDelegate();
    virtual ~PrefixPropertyDelegate();
    static void setInstance( PrefixPropertyDelegate*  instance );


private:
    friend class  ::Teamcenter::PrefixPropertyGenImpl;

};

#include <docmgt/libdocmgt_undef.h>
#endif  //  TEAMCENTER__PREFIXPROPERTYDELEGATE_HXX
