//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PrintConfigurationDelegate
    Filename:   PrintConfigurationDelegate.hxx
    Module:     docmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PRINTCONFIGURATIONDELEGATE_HXX
#define TEAMCENTER__PRINTCONFIGURATIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <docmgt/PrintConfiguration.hxx>

#include <docmgt/libdocmgt_exports.h>

namespace Teamcenter
{
    class PrintConfigurationDelegate;
}
namespace Teamcenter
{
    class PrintConfigurationImpl;
}
namespace Teamcenter
{
    class PrintConfiguration;
}
namespace Teamcenter
{
    class PrintConfigurationGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  DOCMGT_API Teamcenter_alias::PrintConfigurationDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PrintConfigurationDelegate instance
    static PrintConfigurationDelegate&  getInstance();

    //  Method to create the PrintConfigurationImpl pointer
    static PrintConfigurationImpl*  createImpl( PrintConfiguration&  ifObj );

    //  Method to delete the PrintConfigurationImpl pointer
    static void deleteImpl( PrintConfigurationImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getDispatcher_svc_argumentsBase(const PrintConfiguration &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDispatcher_svc_display_nameBase(const PrintConfiguration &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDispatcher_svc_nameBase(const PrintConfiguration &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getPaper_sizesBase(const PrintConfiguration &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPrinter_nameBase(const PrintConfiguration &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getProvider_display_nameBase(const PrintConfiguration &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getProvider_nameBase(const PrintConfiguration &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getSupp_dataset_typesBase(const PrintConfiguration &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getSupp_mk_appsBase(const PrintConfiguration &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSupport_stampBase(const PrintConfiguration &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setDispatcher_svc_argumentsBase(PrintConfiguration &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDispatcher_svc_display_nameBase(PrintConfiguration &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDispatcher_svc_nameBase(PrintConfiguration &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 8.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setPaper_sizesBase(PrintConfiguration &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPrinter_nameBase(PrintConfiguration &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setProvider_display_nameBase(PrintConfiguration &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setProvider_nameBase(PrintConfiguration &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setSupp_dataset_typesBase(PrintConfiguration &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setSupp_mk_appsBase(PrintConfiguration &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSupport_stampBase(PrintConfiguration &ifObj,  bool value, bool isNull );



protected:
    //  Pointer to the instance
    static PrintConfigurationDelegate*  m_pInstance;

    PrintConfigurationDelegate();
    virtual ~PrintConfigurationDelegate();
    static void setInstance( PrintConfigurationDelegate*  instance );


private:
    friend class  ::Teamcenter::PrintConfigurationGenImpl;

};

#include <docmgt/libdocmgt_undef.h>
#endif  //  TEAMCENTER__PRINTCONFIGURATIONDELEGATE_HXX
