//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SourceObj
    Filename:   SourceObj.hxx
    Module:     docmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SOURCEOBJ__HXX
#define TEAMCENTER__SOURCEOBJ__HXX

#include <string>
#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <docmgt/libdocmgt_exports.h>

namespace Teamcenter
{
    class SourceObj;
}
namespace Teamcenter
{
    class SourceObjImpl;
}
namespace Teamcenter
{
    class SourceObjDelegate;
}
namespace Teamcenter
{
    class SourceObjDispatch;
}
namespace Teamcenter
{
    class SourceObjGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  DOCMGT_API  Teamcenter::SourceObj
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDefining_irdc( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getItem_revision_relation( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSrc_dataset_type_name( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDefining_irdc( const std::string &value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setItem_revision_relation( const tag_t &value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSrc_dataset_type_name( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SourceObj();

    /**
     * Destructor
     */
    virtual ~SourceObj();

private:
    //  Getter method for the Implementation Object
    SourceObjImpl*  getSourceObjImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSourceObjImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SourceObjImpl*  m_sourceobjImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SourceObj - desc for SourceObj parameter
     */
    SourceObj( const SourceObj& );
    SourceObj& operator=( const SourceObj& );

    friend class  SourceObjDelegate;
    friend class  SourceObjDispatch;
    friend class  SourceObjGenImpl;
};

#include <docmgt/libdocmgt_undef.h>
#endif //   TEAMCENTER__SOURCEOBJ__HXX
