//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SourceObjDelegate
    Filename:   SourceObjDelegate.hxx
    Module:     docmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SOURCEOBJDELEGATE_HXX
#define TEAMCENTER__SOURCEOBJDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <docmgt/SourceObj.hxx>

#include <docmgt/libdocmgt_exports.h>

namespace Teamcenter
{
    class SourceObjDelegate;
}
namespace Teamcenter
{
    class SourceObjImpl;
}
namespace Teamcenter
{
    class SourceObj;
}
namespace Teamcenter
{
    class SourceObjGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  DOCMGT_API Teamcenter_alias::SourceObjDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SourceObjDelegate instance
    static SourceObjDelegate&  getInstance();

    //  Method to create the SourceObjImpl pointer
    static SourceObjImpl*  createImpl( SourceObj&  ifObj );

    //  Method to delete the SourceObjImpl pointer
    static void deleteImpl( SourceObjImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDefining_irdcBase(const SourceObj &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getItem_revision_relationBase(const SourceObj &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSrc_dataset_type_nameBase(const SourceObj &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDefining_irdcBase(SourceObj &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setItem_revision_relationBase(SourceObj &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSrc_dataset_type_nameBase(SourceObj &ifObj,  const tag_t &value, bool isNull );



protected:
    //  Pointer to the instance
    static SourceObjDelegate*  m_pInstance;

    SourceObjDelegate();
    virtual ~SourceObjDelegate();
    static void setInstance( SourceObjDelegate*  instance );


private:
    friend class  ::Teamcenter::SourceObjGenImpl;

};

#include <docmgt/libdocmgt_undef.h>
#endif  //  TEAMCENTER__SOURCEOBJDELEGATE_HXX
