//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SystemStampConfigurationDelegate
    Filename:   SystemStampConfigurationDelegate.hxx
    Module:     docmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SYSTEMSTAMPCONFIGURATIONDELEGATE_HXX
#define TEAMCENTER__SYSTEMSTAMPCONFIGURATIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <docmgt/SystemStampConfiguration.hxx>

#include <docmgt/libdocmgt_exports.h>

namespace Teamcenter
{
    class SystemStampConfigurationDelegate;
}
namespace Teamcenter
{
    class SystemStampConfigurationImpl;
}
namespace Teamcenter
{
    class SystemStampConfiguration;
}
namespace Teamcenter
{
    class SystemStampConfigurationGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  DOCMGT_API Teamcenter_alias::SystemStampConfigurationDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SystemStampConfigurationDelegate instance
    static SystemStampConfigurationDelegate&  getInstance();

    //  Method to create the SystemStampConfigurationImpl pointer
    static SystemStampConfigurationImpl*  createImpl( SystemStampConfiguration&  ifObj );

    //  Method to delete the SystemStampConfigurationImpl pointer
    static void deleteImpl( SystemStampConfigurationImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getApplies_toBase(const SystemStampConfiguration &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBus_objBase(const SystemStampConfiguration &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getInclude_dateBase(const SystemStampConfiguration &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getInclude_user_nameBase(const SystemStampConfiguration &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMds_template_nameBase(const SystemStampConfiguration &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getPropertiesBase(const SystemStampConfiguration &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getUser_stampBase(const SystemStampConfiguration &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getWater_markBase(const SystemStampConfiguration &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setApplies_toBase(SystemStampConfiguration &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setBus_objBase(SystemStampConfiguration &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setInclude_dateBase(SystemStampConfiguration &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setInclude_user_nameBase(SystemStampConfiguration &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMds_template_nameBase(SystemStampConfiguration &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setPropertiesBase(SystemStampConfiguration &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setUser_stampBase(SystemStampConfiguration &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setWater_markBase(SystemStampConfiguration &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static SystemStampConfigurationDelegate*  m_pInstance;

    SystemStampConfigurationDelegate();
    virtual ~SystemStampConfigurationDelegate();
    static void setInstance( SystemStampConfigurationDelegate*  instance );


private:
    friend class  ::Teamcenter::SystemStampConfigurationGenImpl;

};

#include <docmgt/libdocmgt_undef.h>
#endif  //  TEAMCENTER__SYSTEMSTAMPCONFIGURATIONDELEGATE_HXX
