//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  docmgt

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libdocmgt

#if !defined(LIBDOCMGT) && !defined(IPLIB)
#   error IPLIB or LIBDOCMGT is not defined
#endif

/* Handwritten code should use DOCMGT_API, not DOCMGTEXPORT */

#define DOCMGT_API DOCMGTEXPORT

#if IPLIB==libdocmgt || defined(LIBDOCMGT)
#   if defined(__lint)
#       define DOCMGTEXPORT       __export(docmgt)
#       define DOCMGTGLOBAL       extern __global(docmgt)
#       define DOCMGTPRIVATE      extern __private(docmgt)
#   elif defined(_WIN32)
#       define DOCMGTEXPORT       __declspec(dllexport)
#       define DOCMGTGLOBAL       extern __declspec(dllexport)
#       define DOCMGTPRIVATE      extern
#   else
#       define DOCMGTEXPORT
#       define DOCMGTGLOBAL       extern
#       define DOCMGTPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define DOCMGTEXPORT       __export(docmgt)
#       define DOCMGTGLOBAL       extern __global(docmgt)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define DOCMGTEXPORT      __declspec(dllimport)
#       define DOCMGTGLOBAL       extern __declspec(dllimport)
#   else
#       define DOCMGTEXPORT
#       define DOCMGTGLOBAL       extern
#   endif
#endif
