//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BomChange
    Filename:   BomChange.hxx
    Module:     ecm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOMCHANGE__HXX
#define TEAMCENTER__BOMCHANGE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <ecm/libecm_exports.h>

namespace Teamcenter
{
    class BomChange;
}
namespace Teamcenter
{
    class BomChangeImpl;
}
namespace Teamcenter
{
    class BomChangeDelegate;
}
namespace Teamcenter
{
    class BomChangeDispatch;
}
namespace Teamcenter
{
    class BomChangeGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ECM_API  Teamcenter::BomChange
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    BomChange();

    /**
     * Destructor
     */
    virtual ~BomChange();

private:
    //  Getter method for the Implementation Object
    BomChangeImpl*  getBomChangeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBomChangeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    BomChangeImpl*  m_bomchangeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param BomChange - desc for BomChange parameter
     */
    BomChange( const BomChange& );
    BomChange& operator=( const BomChange& );

    friend class  BomChangeDelegate;
    friend class  BomChangeDispatch;
    friend class  BomChangeGenImpl;
};

#include <ecm/libecm_undef.h>
#endif //   TEAMCENTER__BOMCHANGE__HXX
