//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BomChangeDelegate
    Filename:   BomChangeDelegate.hxx
    Module:     ecm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOMCHANGEDELEGATE_HXX
#define TEAMCENTER__BOMCHANGEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ecm/BomChange.hxx>

#include <ecm/libecm_exports.h>

namespace Teamcenter
{
    class BomChangeDelegate;
}
namespace Teamcenter
{
    class BomChangeImpl;
}
namespace Teamcenter
{
    class BomChange;
}
namespace Teamcenter
{
    class BomChangeGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  ECM_API Teamcenter_alias::BomChangeDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the BomChangeDelegate instance
    static BomChangeDelegate&  getInstance();

    //  Method to create the BomChangeImpl pointer
    static BomChangeImpl*  createImpl( BomChange&  ifObj );

    //  Method to delete the BomChangeImpl pointer
    static void deleteImpl( BomChangeImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static BomChangeDelegate*  m_pInstance;

    BomChangeDelegate();
    virtual ~BomChangeDelegate();
    static void setInstance( BomChangeDelegate*  instance );


private:
    friend class  ::Teamcenter::BomChangeGenImpl;

};

#include <ecm/libecm_undef.h>
#endif  //  TEAMCENTER__BOMCHANGEDELEGATE_HXX
