//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ChangeTypeData
    Filename:   ChangeTypeData.hxx
    Module:     ecm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CHANGETYPEDATA__HXX
#define TEAMCENTER__CHANGETYPEDATA__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <ecm/libecm_exports.h>

namespace Teamcenter
{
    class ChangeTypeData;
}
namespace Teamcenter
{
    class ChangeTypeDataImpl;
}
namespace Teamcenter
{
    class ChangeTypeDataDelegate;
}
namespace Teamcenter
{
    class ChangeTypeDataDispatch;
}
namespace Teamcenter
{
    class ChangeTypeDataGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ECM_API  Teamcenter::ChangeTypeData
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ChangeTypeData();

    /**
     * Destructor
     */
    virtual ~ChangeTypeData();

private:
    //  Getter method for the Implementation Object
    ChangeTypeDataImpl*  getChangeTypeDataImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setChangeTypeDataImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ChangeTypeDataImpl*  m_changetypedataImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ChangeTypeData - desc for ChangeTypeData parameter
     */
    ChangeTypeData( const ChangeTypeData& );
    ChangeTypeData& operator=( const ChangeTypeData& );

    friend class  ChangeTypeDataDelegate;
    friend class  ChangeTypeDataDispatch;
    friend class  ChangeTypeDataGenImpl;
};

#include <ecm/libecm_undef.h>
#endif //   TEAMCENTER__CHANGETYPEDATA__HXX
