//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, IncrementalChangeElement
    Filename:   IncrementalChangeElement.hxx
    Module:     ecm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__INCREMENTALCHANGEELEMENT__HXX
#define TEAMCENTER__INCREMENTALCHANGEELEMENT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <ecm/libecm_exports.h>

namespace Teamcenter
{
    class IncrementalChangeElement;
}
namespace Teamcenter
{
    class IncrementalChangeElementImpl;
}
namespace Teamcenter
{
    class IncrementalChangeElementDelegate;
}
namespace Teamcenter
{
    class IncrementalChangeElementDispatch;
}
namespace Teamcenter
{
    class IncrementalChangeElementGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ECM_API  Teamcenter::IncrementalChangeElement
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    IncrementalChangeElement();

    /**
     * Destructor
     */
    virtual ~IncrementalChangeElement();

private:
    //  Getter method for the Implementation Object
    IncrementalChangeElementImpl*  getIncrementalChangeElementImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setIncrementalChangeElementImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    IncrementalChangeElementImpl*  m_incrementalchangeelementImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param IncrementalChangeElement - desc for IncrementalChangeElement parameter
     */
    IncrementalChangeElement( const IncrementalChangeElement& );
    IncrementalChangeElement& operator=( const IncrementalChangeElement& );

    friend class  IncrementalChangeElementDelegate;
    friend class  IncrementalChangeElementDispatch;
    friend class  IncrementalChangeElementGenImpl;
};

#include <ecm/libecm_undef.h>
#endif //   TEAMCENTER__INCREMENTALCHANGEELEMENT__HXX
