//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, IncrementalChangeElementDelegate
    Filename:   IncrementalChangeElementDelegate.hxx
    Module:     ecm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__INCREMENTALCHANGEELEMENTDELEGATE_HXX
#define TEAMCENTER__INCREMENTALCHANGEELEMENTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ecm/IncrementalChangeElement.hxx>

#include <ecm/libecm_exports.h>

namespace Teamcenter
{
    class IncrementalChangeElementDelegate;
}
namespace Teamcenter
{
    class IncrementalChangeElementImpl;
}
namespace Teamcenter
{
    class IncrementalChangeElement;
}
namespace Teamcenter
{
    class IncrementalChangeElementGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  ECM_API Teamcenter_alias::IncrementalChangeElementDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the IncrementalChangeElementDelegate instance
    static IncrementalChangeElementDelegate&  getInstance();

    //  Method to create the IncrementalChangeElementImpl pointer
    static IncrementalChangeElementImpl*  createImpl( IncrementalChangeElement&  ifObj );

    //  Method to delete the IncrementalChangeElementImpl pointer
    static void deleteImpl( IncrementalChangeElementImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const IncrementalChangeElement &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static IncrementalChangeElementDelegate*  m_pInstance;

    IncrementalChangeElementDelegate();
    virtual ~IncrementalChangeElementDelegate();
    static void setInstance( IncrementalChangeElementDelegate*  instance );


private:
    friend class  ::Teamcenter::IncrementalChangeElementGenImpl;

};

#include <ecm/libecm_undef.h>
#endif  //  TEAMCENTER__INCREMENTALCHANGEELEMENTDELEGATE_HXX
