//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Supercedure
    Filename:   Supercedure.hxx
    Module:     ecm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SUPERCEDURE__HXX
#define TEAMCENTER__SUPERCEDURE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <ecm/libecm_exports.h>

namespace Teamcenter
{
    class Supercedure;
}
namespace Teamcenter
{
    class SupercedureImpl;
}
namespace Teamcenter
{
    class SupercedureDelegate;
}
namespace Teamcenter
{
    class SupercedureDispatch;
}
namespace Teamcenter
{
    class SupercedureGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ECM_API  Teamcenter::Supercedure
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Supercedure();

    /**
     * Destructor
     */
    virtual ~Supercedure();

private:
    //  Getter method for the Implementation Object
    SupercedureImpl*  getSupercedureImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSupercedureImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SupercedureImpl*  m_supercedureImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Supercedure - desc for Supercedure parameter
     */
    Supercedure( const Supercedure& );
    Supercedure& operator=( const Supercedure& );

    friend class  SupercedureDelegate;
    friend class  SupercedureDispatch;
    friend class  SupercedureGenImpl;
};

#include <ecm/libecm_undef.h>
#endif //   TEAMCENTER__SUPERCEDURE__HXX
