//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EDACCABaseRevision
    Filename:   EDACCABaseRevision.hxx
    Module:     eda
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EDACCABASEREVISION__HXX
#define TEAMCENTER__EDACCABASEREVISION__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <eda/libeda_exports.h>

namespace Teamcenter
{
    class EDACCABaseRevision;
}
namespace Teamcenter
{
    class EDACCABaseRevisionImpl;
}
namespace Teamcenter
{
    class EDACCABaseRevisionDelegate;
}
namespace Teamcenter
{
    class EDACCABaseRevisionDispatch;
}
namespace Teamcenter
{
    class EDACCABaseRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EDA_API  Teamcenter::EDACCABaseRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getEda0PercentPlaced( std::string &value, bool &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getEda0UnplacedComps( int &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    EDACCABaseRevision();

    /**
     * Destructor
     */
    virtual ~EDACCABaseRevision();

private:
    //  Getter method for the Implementation Object
    EDACCABaseRevisionImpl*  getEDACCABaseRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setEDACCABaseRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    EDACCABaseRevisionImpl*  m_edaccabaserevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param EDACCABaseRevision - desc for EDACCABaseRevision parameter
     */
    EDACCABaseRevision( const EDACCABaseRevision& );
    EDACCABaseRevision& operator=( const EDACCABaseRevision& );

    friend class  EDACCABaseRevisionDelegate;
    friend class  EDACCABaseRevisionDispatch;
    friend class  EDACCABaseRevisionGenImpl;
};

#include <eda/libeda_undef.h>
#endif //   TEAMCENTER__EDACCABASEREVISION__HXX
