//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EDACCABaseRevisionDelegate
    Filename:   EDACCABaseRevisionDelegate.hxx
    Module:     eda
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EDACCABASEREVISIONDELEGATE_HXX
#define TEAMCENTER__EDACCABASEREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <eda/EDACCABaseRevision.hxx>

#include <eda/libeda_exports.h>

namespace Teamcenter
{
    class EDACCABaseRevisionDelegate;
}
namespace Teamcenter
{
    class EDACCABaseRevisionImpl;
}
namespace Teamcenter
{
    class EDACCABaseRevision;
}
namespace Teamcenter
{
    class EDACCABaseRevisionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  EDA_API Teamcenter_alias::EDACCABaseRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the EDACCABaseRevisionDelegate instance
    static EDACCABaseRevisionDelegate&  getInstance();

    //  Method to create the EDACCABaseRevisionImpl pointer
    static EDACCABaseRevisionImpl*  createImpl( EDACCABaseRevision&  ifObj );

    //  Method to delete the EDACCABaseRevisionImpl pointer
    static void deleteImpl( EDACCABaseRevisionImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getEda0PercentPlacedBase(const EDACCABaseRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getEda0UnplacedCompsBase(const EDACCABaseRevision &ifObj,  int &value, bool &isNull ) const;



protected:
    //  Pointer to the instance
    static EDACCABaseRevisionDelegate*  m_pInstance;

    EDACCABaseRevisionDelegate();
    virtual ~EDACCABaseRevisionDelegate();
    static void setInstance( EDACCABaseRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::EDACCABaseRevisionGenImpl;

};

#include <eda/libeda_undef.h>
#endif  //  TEAMCENTER__EDACCABASEREVISIONDELEGATE_HXX
