//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EDADerivedDataConfig
    Filename:   EDADerivedDataConfig.hxx
    Module:     eda
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EDADERIVEDDATACONFIG__HXX
#define TEAMCENTER__EDADERIVEDDATACONFIG__HXX

#include <vector>
#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <eda/libeda_exports.h>

namespace Teamcenter
{
    class EDADerivedDataConfig;
}
namespace Teamcenter
{
    class EDADerivedDataConfigImpl;
}
namespace Teamcenter
{
    class EDADerivedDataConfigDelegate;
}
namespace Teamcenter
{
    class EDADerivedDataConfigDispatch;
}
namespace Teamcenter
{
    class EDADerivedDataConfigGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EDA_API  Teamcenter::EDADerivedDataConfig
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Tc 8
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getDerived_dataset_defs( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Tc 8
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getDerived_item_defs( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDescription( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getName( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Array Property
    /// @version Tc 8
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setDerived_dataset_defs( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );

    ///
    /// Setter for a Tag Array Property
    /// @version Tc 8
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setDerived_item_defs( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDescription( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setName( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    EDADerivedDataConfig();

    /**
     * Destructor
     */
    virtual ~EDADerivedDataConfig();

private:
    //  Getter method for the Implementation Object
    EDADerivedDataConfigImpl*  getEDADerivedDataConfigImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setEDADerivedDataConfigImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    EDADerivedDataConfigImpl*  m_edaderiveddataconfigImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param EDADerivedDataConfig - desc for EDADerivedDataConfig parameter
     */
    EDADerivedDataConfig( const EDADerivedDataConfig& );
    EDADerivedDataConfig& operator=( const EDADerivedDataConfig& );

    friend class  EDADerivedDataConfigDelegate;
    friend class  EDADerivedDataConfigDispatch;
    friend class  EDADerivedDataConfigGenImpl;
};

#include <eda/libeda_undef.h>
#endif //   TEAMCENTER__EDADERIVEDDATACONFIG__HXX
