//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EDADerivedDataConfigDelegate
    Filename:   EDADerivedDataConfigDelegate.hxx
    Module:     eda
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EDADERIVEDDATACONFIGDELEGATE_HXX
#define TEAMCENTER__EDADERIVEDDATACONFIGDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <eda/EDADerivedDataConfig.hxx>

#include <eda/libeda_exports.h>

namespace Teamcenter
{
    class EDADerivedDataConfigDelegate;
}
namespace Teamcenter
{
    class EDADerivedDataConfigImpl;
}
namespace Teamcenter
{
    class EDADerivedDataConfig;
}
namespace Teamcenter
{
    class EDADerivedDataConfigGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  EDA_API Teamcenter_alias::EDADerivedDataConfigDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the EDADerivedDataConfigDelegate instance
    static EDADerivedDataConfigDelegate&  getInstance();

    //  Method to create the EDADerivedDataConfigImpl pointer
    static EDADerivedDataConfigImpl*  createImpl( EDADerivedDataConfig&  ifObj );

    //  Method to delete the EDADerivedDataConfigImpl pointer
    static void deleteImpl( EDADerivedDataConfigImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Tc 8
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getDerived_dataset_defsBase(const EDADerivedDataConfig &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Tc 8
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getDerived_item_defsBase(const EDADerivedDataConfig &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDescriptionBase(const EDADerivedDataConfig &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getNameBase(const EDADerivedDataConfig &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Tc 8
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setDerived_dataset_defsBase(EDADerivedDataConfig &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Tc 8
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setDerived_item_defsBase(EDADerivedDataConfig &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDescriptionBase(EDADerivedDataConfig &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setNameBase(EDADerivedDataConfig &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static EDADerivedDataConfigDelegate*  m_pInstance;

    EDADerivedDataConfigDelegate();
    virtual ~EDADerivedDataConfigDelegate();
    static void setInstance( EDADerivedDataConfigDelegate*  instance );


private:
    friend class  ::Teamcenter::EDADerivedDataConfigGenImpl;

};

#include <eda/libeda_undef.h>
#endif  //  TEAMCENTER__EDADERIVEDDATACONFIGDELEGATE_HXX
