//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EDADerivedDatasetConfigDefDelegate
    Filename:   EDADerivedDatasetConfigDefDelegate.hxx
    Module:     eda
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EDADERIVEDDATASETCONFIGDEFDELEGATE_HXX
#define TEAMCENTER__EDADERIVEDDATASETCONFIGDEFDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <eda/EDADerivedDatasetConfigDef.hxx>

#include <eda/libeda_exports.h>

namespace Teamcenter
{
    class EDADerivedDatasetConfigDefDelegate;
}
namespace Teamcenter
{
    class EDADerivedDatasetConfigDefImpl;
}
namespace Teamcenter
{
    class EDADerivedDatasetConfigDef;
}
namespace Teamcenter
{
    class EDADerivedDatasetConfigDefGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  EDA_API Teamcenter_alias::EDADerivedDatasetConfigDefDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the EDADerivedDatasetConfigDefDelegate instance
    static EDADerivedDatasetConfigDefDelegate&  getInstance();

    //  Method to create the EDADerivedDatasetConfigDefImpl pointer
    static EDADerivedDatasetConfigDefImpl*  createImpl( EDADerivedDatasetConfigDef&  ifObj );

    //  Method to delete the EDADerivedDatasetConfigDefImpl pointer
    static void deleteImpl( EDADerivedDatasetConfigDefImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCallback_nameBase(const EDADerivedDatasetConfigDef &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getContextBase(const EDADerivedDatasetConfigDef &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDataset_typeBase(const EDADerivedDatasetConfigDef &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getNameBase(const EDADerivedDatasetConfigDef &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getParent_typeBase(const EDADerivedDatasetConfigDef &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPath_nameBase(const EDADerivedDatasetConfigDef &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPostfixBase(const EDADerivedDatasetConfigDef &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPrefixBase(const EDADerivedDatasetConfigDef &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getReference_typeBase(const EDADerivedDatasetConfigDef &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRelation_typeBase(const EDADerivedDatasetConfigDef &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCallback_nameBase(EDADerivedDatasetConfigDef &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setContextBase(EDADerivedDatasetConfigDef &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDataset_typeBase(EDADerivedDatasetConfigDef &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setNameBase(EDADerivedDatasetConfigDef &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setParent_typeBase(EDADerivedDatasetConfigDef &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPath_nameBase(EDADerivedDatasetConfigDef &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPostfixBase(EDADerivedDatasetConfigDef &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPrefixBase(EDADerivedDatasetConfigDef &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setReference_typeBase(EDADerivedDatasetConfigDef &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setRelation_typeBase(EDADerivedDatasetConfigDef &ifObj,  const tag_t &value, bool isNull );



protected:
    //  Pointer to the instance
    static EDADerivedDatasetConfigDefDelegate*  m_pInstance;

    EDADerivedDatasetConfigDefDelegate();
    virtual ~EDADerivedDatasetConfigDefDelegate();
    static void setInstance( EDADerivedDatasetConfigDefDelegate*  instance );


private:
    friend class  ::Teamcenter::EDADerivedDatasetConfigDefGenImpl;

};

#include <eda/libeda_undef.h>
#endif  //  TEAMCENTER__EDADERIVEDDATASETCONFIGDEFDELEGATE_HXX
