//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EDADerivedItemConfigDefDelegate
    Filename:   EDADerivedItemConfigDefDelegate.hxx
    Module:     eda
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EDADERIVEDITEMCONFIGDEFDELEGATE_HXX
#define TEAMCENTER__EDADERIVEDITEMCONFIGDEFDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <eda/EDADerivedItemConfigDef.hxx>

#include <eda/libeda_exports.h>

namespace Teamcenter
{
    class EDADerivedItemConfigDefDelegate;
}
namespace Teamcenter
{
    class EDADerivedItemConfigDefImpl;
}
namespace Teamcenter
{
    class EDADerivedItemConfigDef;
}
namespace Teamcenter
{
    class EDADerivedItemConfigDefGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  EDA_API Teamcenter_alias::EDADerivedItemConfigDefDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the EDADerivedItemConfigDefDelegate instance
    static EDADerivedItemConfigDefDelegate&  getInstance();

    //  Method to create the EDADerivedItemConfigDefImpl pointer
    static EDADerivedItemConfigDefImpl*  createImpl( EDADerivedItemConfigDef&  ifObj );

    //  Method to delete the EDADerivedItemConfigDefImpl pointer
    static void deleteImpl( EDADerivedItemConfigDefImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAdd_to_bomBase(const EDADerivedItemConfigDef &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getContextBase(const EDADerivedItemConfigDef &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getItem_typeBase(const EDADerivedItemConfigDef &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getNameBase(const EDADerivedItemConfigDef &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getParent_typeBase(const EDADerivedItemConfigDef &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPostfixBase(const EDADerivedItemConfigDef &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPrefixBase(const EDADerivedItemConfigDef &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRelation_typeBase(const EDADerivedItemConfigDef &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Boolean Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAdd_to_bomBase(EDADerivedItemConfigDef &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setContextBase(EDADerivedItemConfigDef &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setItem_typeBase(EDADerivedItemConfigDef &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setNameBase(EDADerivedItemConfigDef &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setParent_typeBase(EDADerivedItemConfigDef &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPostfixBase(EDADerivedItemConfigDef &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPrefixBase(EDADerivedItemConfigDef &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setRelation_typeBase(EDADerivedItemConfigDef &ifObj,  const tag_t &value, bool isNull );



protected:
    //  Pointer to the instance
    static EDADerivedItemConfigDefDelegate*  m_pInstance;

    EDADerivedItemConfigDefDelegate();
    virtual ~EDADerivedItemConfigDefDelegate();
    static void setInstance( EDADerivedItemConfigDefDelegate*  instance );


private:
    friend class  ::Teamcenter::EDADerivedItemConfigDefGenImpl;

};

#include <eda/libeda_undef.h>
#endif  //  TEAMCENTER__EDADERIVEDITEMCONFIGDEFDELEGATE_HXX
