//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Eda0DesignInfo
    Filename:   Eda0DesignInfo.hxx
    Module:     eda
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EDA0DESIGNINFO__HXX
#define TEAMCENTER__EDA0DESIGNINFO__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <eda/libeda_exports.h>

namespace Teamcenter
{
    class Eda0DesignInfo;
}
namespace Teamcenter
{
    class Eda0DesignInfoImpl;
}
namespace Teamcenter
{
    class Eda0DesignInfoDelegate;
}
namespace Teamcenter
{
    class Eda0DesignInfoDispatch;
}
namespace Teamcenter
{
    class Eda0DesignInfoGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EDA_API  Teamcenter::Eda0DesignInfo
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getEda0PercentPlaced( std::string &value, bool &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getEda0UnplacedComps( int &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Eda0DesignInfo();

    /**
     * Destructor
     */
    virtual ~Eda0DesignInfo();

private:
    //  Getter method for the Implementation Object
    Eda0DesignInfoImpl*  getEda0DesignInfoImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setEda0DesignInfoImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Eda0DesignInfoImpl*  m_eda0designinfoImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Eda0DesignInfo - desc for Eda0DesignInfo parameter
     */
    Eda0DesignInfo( const Eda0DesignInfo& );
    Eda0DesignInfo& operator=( const Eda0DesignInfo& );

    friend class  Eda0DesignInfoDelegate;
    friend class  Eda0DesignInfoDispatch;
    friend class  Eda0DesignInfoGenImpl;
};

#include <eda/libeda_undef.h>
#endif //   TEAMCENTER__EDA0DESIGNINFO__HXX
