//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Eda0EDMDCollaboration
    Filename:   Eda0EDMDCollaboration.hxx
    Module:     eda
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EDA0EDMDCOLLABORATION__HXX
#define TEAMCENTER__EDA0EDMDCOLLABORATION__HXX

#include <common/tc_deprecation_macros.h>
#include <collabctx/CCObject.hxx>

#include <eda/libeda_exports.h>

namespace Teamcenter
{
    class Eda0EDMDCollaboration;
}
namespace Teamcenter
{
    class Eda0EDMDCollaborationImpl;
}
namespace Teamcenter
{
    class Eda0EDMDCollaborationDelegate;
}
namespace Teamcenter
{
    class Eda0EDMDCollaborationDispatch;
}
namespace Teamcenter
{
    class Eda0EDMDCollaborationGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EDA_API  Teamcenter::Eda0EDMDCollaboration
     : public  ::Teamcenter::CCObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Eda0EDMDCollaboration();

    /**
     * Destructor
     */
    virtual ~Eda0EDMDCollaboration();

private:
    //  Getter method for the Implementation Object
    Eda0EDMDCollaborationImpl*  getEda0EDMDCollaborationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setEda0EDMDCollaborationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Eda0EDMDCollaborationImpl*  m_eda0edmdcollaborationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Eda0EDMDCollaboration - desc for Eda0EDMDCollaboration parameter
     */
    Eda0EDMDCollaboration( const Eda0EDMDCollaboration& );
    Eda0EDMDCollaboration& operator=( const Eda0EDMDCollaboration& );

    friend class  Eda0EDMDCollaborationDelegate;
    friend class  Eda0EDMDCollaborationDispatch;
    friend class  Eda0EDMDCollaborationGenImpl;
};

#include <eda/libeda_undef.h>
#endif //   TEAMCENTER__EDA0EDMDCOLLABORATION__HXX
