//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Eda0MentorDesignInfo
    Filename:   Eda0MentorDesignInfo.hxx
    Module:     eda
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EDA0MENTORDESIGNINFO__HXX
#define TEAMCENTER__EDA0MENTORDESIGNINFO__HXX

#include <common/tc_deprecation_macros.h>
#include <eda/Eda0DesignInfo.hxx>

#include <eda/libeda_exports.h>

namespace Teamcenter
{
    class Eda0MentorDesignInfo;
}
namespace Teamcenter
{
    class Eda0MentorDesignInfoImpl;
}
namespace Teamcenter
{
    class Eda0MentorDesignInfoDelegate;
}
namespace Teamcenter
{
    class Eda0MentorDesignInfoDispatch;
}
namespace Teamcenter
{
    class Eda0MentorDesignInfoGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EDA_API  Teamcenter::Eda0MentorDesignInfo
     : public  ::Teamcenter::Eda0DesignInfo
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Eda0MentorDesignInfo();

    /**
     * Destructor
     */
    virtual ~Eda0MentorDesignInfo();

private:
    //  Getter method for the Implementation Object
    Eda0MentorDesignInfoImpl*  getEda0MentorDesignInfoImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setEda0MentorDesignInfoImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Eda0MentorDesignInfoImpl*  m_eda0mentordesigninfoImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Eda0MentorDesignInfo - desc for Eda0MentorDesignInfo parameter
     */
    Eda0MentorDesignInfo( const Eda0MentorDesignInfo& );
    Eda0MentorDesignInfo& operator=( const Eda0MentorDesignInfo& );

    friend class  Eda0MentorDesignInfoDelegate;
    friend class  Eda0MentorDesignInfoDispatch;
    friend class  Eda0MentorDesignInfoGenImpl;
};

#include <eda/libeda_undef.h>
#endif //   TEAMCENTER__EDA0MENTORDESIGNINFO__HXX
