//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ItemRevisionDelegate
    Filename:   ItemRevisionDelegateExt.hxx
    Module:     eda
    @BMIDE autogenerated
==================================================================================================*/

#ifndef EDA0__TEAMCENTER__ITEMREVISIONDELEGATE_HXX
#define EDA0__TEAMCENTER__ITEMREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <eda/ItemRevisionExt.hxx>

#include <eda/libeda_exports.h>

namespace eda0
{
    namespace Teamcenter
    {
        class ItemRevisionDelegate;
    }
}
namespace eda0
{
    namespace Teamcenter
    {
        class ItemRevisionImpl;
    }
}
namespace eda0
{
    namespace Teamcenter
    {
        class ItemRevision;
    }
}
namespace eda0
{
    namespace Teamcenter
    {
        class ItemRevisionGenImpl;
    }
}

namespace eda0_alias = ::eda0;


class  EDA_API eda0_alias::Teamcenter::ItemRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ItemRevisionDelegate instance
    static ItemRevisionDelegate&  getInstance();

    //  Method to create the ItemRevisionImpl pointer
    static ItemRevisionImpl*  createImpl( ItemRevision&  ifObj );

    //  Method to delete the ItemRevisionImpl pointer
    static void deleteImpl( ItemRevisionImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 12.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getEda0CollaborationBase(const ItemRevision &ifObj,  tag_t &value, bool &isNull ) const;



protected:
    //  Pointer to the instance
    static ItemRevisionDelegate*  m_pInstance;

    ItemRevisionDelegate();
    virtual ~ItemRevisionDelegate();
    static void setInstance( ItemRevisionDelegate*  instance );


private:
    friend class  ::eda0::Teamcenter::ItemRevisionGenImpl;

};

#include <eda/libeda_undef.h>
#endif  //  EDA0__TEAMCENTER__ITEMREVISIONDELEGATE_HXX
