//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ItemRevision
    Filename:   ItemRevisionExt.hxx
    Module:     eda
    @BMIDE autogenerated
==================================================================================================*/

#ifndef EDA0__TEAMCENTER__ITEMREVISION__HXX
#define EDA0__TEAMCENTER__ITEMREVISION__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <metaframework/BusinessObjectExtender.hxx>
#include <metaframework/BusinessObjectExtenderRef.hxx>
#include <metaframework/BusinessObjectExtenderRegistry.hxx>

#include <eda/libeda_exports.h>

namespace eda0
{
    namespace Teamcenter
    {
        class ItemRevision;
    }
}
namespace eda0
{
    namespace Teamcenter
    {
        class ItemRevisionImpl;
    }
}
namespace eda0
{
    namespace Teamcenter
    {
        class ItemRevisionDelegate;
    }
}
namespace eda0
{
    namespace Teamcenter
    {
        class ItemRevisionDispatch;
    }
}
namespace eda0
{
    namespace Teamcenter
    {
        class ItemRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EDA_API  eda0::Teamcenter::ItemRevision
     : public  ::Teamcenter::BusinessObjectExtender
{
public:

    /**
     * Constructor
     */
    ItemRevision( tag_t  objTag );
    /**
     * Get the Extender Registry
     * @return - return Extender Registry
     */
    static ::Teamcenter::BusinessObjectExtenderRegistry< eda0::Teamcenter::ItemRevision >&  extenderRegistry();

    /**
     * Get the Extender Interface Name
     * @return - return desc for getExtenderInterfaceName
     */
    static const std::string&  getExtenderInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 12.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getEda0Collaboration( tag_t &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );


    /**
     * Destructor
     */
    virtual ~ItemRevision();

private:
    //  Getter method for the Implementation Object
    ItemRevisionImpl*  getItemRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setItemRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ItemRevisionImpl*  m_itemrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ItemRevision - desc for ItemRevision parameter
     */
    ItemRevision( const ItemRevision& );
    ItemRevision& operator=( const ItemRevision& );

    friend class  ItemRevisionDelegate;
    friend class  ItemRevisionDispatch;
    friend class  ItemRevisionGenImpl;
    friend class  ItemRevisionImpl;
};

#include <eda/libeda_undef.h>
#endif //   EDA0__TEAMCENTER__ITEMREVISION__HXX
