//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  eda

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libeda

#if !defined(LIBEDA) && !defined(IPLIB)
#   error IPLIB or LIBEDA is not defined
#endif

/* Handwritten code should use EDA_API, not EDAEXPORT */

#define EDA_API EDAEXPORT

#if IPLIB==libeda || defined(LIBEDA)
#   if defined(__lint)
#       define EDAEXPORT       __export(eda)
#       define EDAGLOBAL       extern __global(eda)
#       define EDAPRIVATE      extern __private(eda)
#   elif defined(_WIN32)
#       define EDAEXPORT       __declspec(dllexport)
#       define EDAGLOBAL       extern __declspec(dllexport)
#       define EDAPRIVATE      extern
#   else
#       define EDAEXPORT
#       define EDAGLOBAL       extern
#       define EDAPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define EDAEXPORT       __export(eda)
#       define EDAGLOBAL       extern __global(eda)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define EDAEXPORT      __declspec(dllimport)
#       define EDAGLOBAL       extern __declspec(dllimport)
#   else
#       define EDAEXPORT
#       define EDAGLOBAL       extern
#   endif
#endif
