//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ItemRevisionDispatch
    Filename:   ItemRevisionDispatchExt.hxx
    Module:     edaserverdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef EDA0__TEAMCENTER__ITEMREVISIONDISPATCH_HXX
#define EDA0__TEAMCENTER__ITEMREVISIONDISPATCH_HXX

#include <vector>
#include <eda/ItemRevisionExt.hxx>
#include <eda/ItemRevisionDelegateExt.hxx>
#include <edaserverdispatch/initializeedaserver.hxx>
#include <extensionframework/OperationDispatcher.hxx>
#include <metaframework/OperationObjectBatch.hxx>
#include <metaframework/PostActionInternalHandler.hxx>
#include <metaframework/ManageBulkData.hxx>

#include <edaserverdispatch/libedaserverdispatch_exports.h>

namespace eda0
{
    namespace Teamcenter
    {
        class ItemRevisionDispatch;
    }
}
namespace eda0
{
    namespace Teamcenter
    {
        class ItemRevisionDelegate;
    }
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  EDASERVERDISPATCH_API  eda0::Teamcenter::ItemRevisionDispatch
    : public  eda0::Teamcenter::ItemRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ItemRevisionDispatch instance
    static ItemRevisionDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static ItemRevisionDispatch*  m_dispatch;

    //  Default Constructor
    ItemRevisionDispatch();

    //  Default Destructor
    virtual ~ItemRevisionDispatch();

    //  Constructor Method
    static ::Teamcenter::BusinessObjectExtender*  constructor( tag_t objTag );

    //  Copy Constructor for a ItemRevisionDispatch
    ItemRevisionDispatch( const ItemRevisionDispatch& );

    //  Assignment operator
    ItemRevisionDispatch&  operator = ( const ItemRevisionDispatch& );

    //  friend
    friend void   ::Teamcenter::initializeedaserverInternal();
    friend void   ::Teamcenter::initializeedaserverExtenders();
    friend class  eda0::Teamcenter::ItemRevisionDelegate;
};

#include <edaserverdispatch/libedaserverdispatch_undef.h>
#endif  //  EDA0__TEAMCENTER__ITEMREVISIONDISPATCH_HXX
