//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  edaserverdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libedaserverdispatch

#if !defined(LIBEDASERVERDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBEDASERVERDISPATCH is not defined
#endif

/* Handwritten code should use EDASERVERDISPATCH_API, not EDASERVERDISPATCHEXPORT */

#define EDASERVERDISPATCH_API EDASERVERDISPATCHEXPORT

#if IPLIB==libedaserverdispatch || defined(LIBEDASERVERDISPATCH)
#   if defined(__lint)
#       define EDASERVERDISPATCHEXPORT       __export(edaserverdispatch)
#       define EDASERVERDISPATCHGLOBAL       extern __global(edaserverdispatch)
#       define EDASERVERDISPATCHPRIVATE      extern __private(edaserverdispatch)
#   elif defined(_WIN32)
#       define EDASERVERDISPATCHEXPORT       __declspec(dllexport)
#       define EDASERVERDISPATCHGLOBAL       extern __declspec(dllexport)
#       define EDASERVERDISPATCHPRIVATE      extern
#   else
#       define EDASERVERDISPATCHEXPORT
#       define EDASERVERDISPATCHGLOBAL       extern
#       define EDASERVERDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define EDASERVERDISPATCHEXPORT       __export(edaserverdispatch)
#       define EDASERVERDISPATCHGLOBAL       extern __global(edaserverdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define EDASERVERDISPATCHEXPORT      __declspec(dllimport)
#       define EDASERVERDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define EDASERVERDISPATCHEXPORT
#       define EDASERVERDISPATCHGLOBAL       extern
#   endif
#endif
