//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Authentication
    Filename:   Authentication.hxx
    Module:     eint
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__AUTHENTICATION__HXX
#define TEAMCENTER__AUTHENTICATION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <eint/libeint_exports.h>

namespace Teamcenter
{
    class Authentication;
}
namespace Teamcenter
{
    class AuthenticationImpl;
}
namespace Teamcenter
{
    class AuthenticationDelegate;
}
namespace Teamcenter
{
    class AuthenticationDispatch;
}
namespace Teamcenter
{
    class AuthenticationGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EINT_API  Teamcenter::Authentication
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Authentication();

    /**
     * Destructor
     */
    virtual ~Authentication();

private:
    //  Getter method for the Implementation Object
    AuthenticationImpl*  getAuthenticationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAuthenticationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AuthenticationImpl*  m_authenticationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Authentication - desc for Authentication parameter
     */
    Authentication( const Authentication& );
    Authentication& operator=( const Authentication& );

    friend class  AuthenticationDelegate;
    friend class  AuthenticationDispatch;
    friend class  AuthenticationGenImpl;
};

#include <eint/libeint_undef.h>
#endif //   TEAMCENTER__AUTHENTICATION__HXX
