//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AuthenticationDelegate
    Filename:   AuthenticationDelegate.hxx
    Module:     eint
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__AUTHENTICATIONDELEGATE_HXX
#define TEAMCENTER__AUTHENTICATIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <eint/Authentication.hxx>

#include <eint/libeint_exports.h>

namespace Teamcenter
{
    class AuthenticationDelegate;
}
namespace Teamcenter
{
    class AuthenticationImpl;
}
namespace Teamcenter
{
    class Authentication;
}
namespace Teamcenter
{
    class AuthenticationGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  EINT_API Teamcenter_alias::AuthenticationDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the AuthenticationDelegate instance
    static AuthenticationDelegate&  getInstance();

    //  Method to create the AuthenticationImpl pointer
    static AuthenticationImpl*  createImpl( Authentication&  ifObj );

    //  Method to delete the AuthenticationImpl pointer
    static void deleteImpl( AuthenticationImpl*  impl );



protected:
    //  Pointer to the instance
    static AuthenticationDelegate*  m_pInstance;

    AuthenticationDelegate();
    virtual ~AuthenticationDelegate();
    static void setInstance( AuthenticationDelegate*  instance );


private:
    friend class  ::Teamcenter::AuthenticationGenImpl;

};

#include <eint/libeint_undef.h>
#endif  //  TEAMCENTER__AUTHENTICATIONDELEGATE_HXX
