//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ExternalAttribute
    Filename:   ExternalAttribute.hxx
    Module:     eint
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EXTERNALATTRIBUTE__HXX
#define TEAMCENTER__EXTERNALATTRIBUTE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <eint/libeint_exports.h>

namespace Teamcenter
{
    class ExternalAttribute;
}
namespace Teamcenter
{
    class ExternalAttributeImpl;
}
namespace Teamcenter
{
    class ExternalAttributeDelegate;
}
namespace Teamcenter
{
    class ExternalAttributeDispatch;
}
namespace Teamcenter
{
    class ExternalAttributeGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EINT_API  Teamcenter::ExternalAttribute
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ExternalAttribute();

    /**
     * Destructor
     */
    virtual ~ExternalAttribute();

private:
    //  Getter method for the Implementation Object
    ExternalAttributeImpl*  getExternalAttributeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setExternalAttributeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ExternalAttributeImpl*  m_externalattributeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ExternalAttribute - desc for ExternalAttribute parameter
     */
    ExternalAttribute( const ExternalAttribute& );
    ExternalAttribute& operator=( const ExternalAttribute& );

    friend class  ExternalAttributeDelegate;
    friend class  ExternalAttributeDispatch;
    friend class  ExternalAttributeGenImpl;
};

#include <eint/libeint_undef.h>
#endif //   TEAMCENTER__EXTERNALATTRIBUTE__HXX
