//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ExternalDataSource
    Filename:   ExternalDataSource.hxx
    Module:     eint
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EXTERNALDATASOURCE__HXX
#define TEAMCENTER__EXTERNALDATASOURCE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <eint/libeint_exports.h>

namespace Teamcenter
{
    class ExternalDataSource;
}
namespace Teamcenter
{
    class ExternalDataSourceImpl;
}
namespace Teamcenter
{
    class ExternalDataSourceDelegate;
}
namespace Teamcenter
{
    class ExternalDataSourceDispatch;
}
namespace Teamcenter
{
    class ExternalDataSourceGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EINT_API  Teamcenter::ExternalDataSource
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ExternalDataSource();

    /**
     * Destructor
     */
    virtual ~ExternalDataSource();

private:
    //  Getter method for the Implementation Object
    ExternalDataSourceImpl*  getExternalDataSourceImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setExternalDataSourceImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ExternalDataSourceImpl*  m_externaldatasourceImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ExternalDataSource - desc for ExternalDataSource parameter
     */
    ExternalDataSource( const ExternalDataSource& );
    ExternalDataSource& operator=( const ExternalDataSource& );

    friend class  ExternalDataSourceDelegate;
    friend class  ExternalDataSourceDispatch;
    friend class  ExternalDataSourceGenImpl;
};

#include <eint/libeint_undef.h>
#endif //   TEAMCENTER__EXTERNALDATASOURCE__HXX
