//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ExternalDataSourceDelegate
    Filename:   ExternalDataSourceDelegate.hxx
    Module:     eint
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EXTERNALDATASOURCEDELEGATE_HXX
#define TEAMCENTER__EXTERNALDATASOURCEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <eint/ExternalDataSource.hxx>

#include <eint/libeint_exports.h>

namespace Teamcenter
{
    class ExternalDataSourceDelegate;
}
namespace Teamcenter
{
    class ExternalDataSourceImpl;
}
namespace Teamcenter
{
    class ExternalDataSource;
}
namespace Teamcenter
{
    class ExternalDataSourceGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  EINT_API Teamcenter_alias::ExternalDataSourceDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ExternalDataSourceDelegate instance
    static ExternalDataSourceDelegate&  getInstance();

    //  Method to create the ExternalDataSourceImpl pointer
    static ExternalDataSourceImpl*  createImpl( ExternalDataSource&  ifObj );

    //  Method to delete the ExternalDataSourceImpl pointer
    static void deleteImpl( ExternalDataSourceImpl*  impl );



protected:
    //  Pointer to the instance
    static ExternalDataSourceDelegate*  m_pInstance;

    ExternalDataSourceDelegate();
    virtual ~ExternalDataSourceDelegate();
    static void setInstance( ExternalDataSourceDelegate*  instance );


private:
    friend class  ::Teamcenter::ExternalDataSourceGenImpl;

};

#include <eint/libeint_undef.h>
#endif  //  TEAMCENTER__EXTERNALDATASOURCEDELEGATE_HXX
