//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MappedProperty
    Filename:   MappedProperty.hxx
    Module:     eint
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MAPPEDPROPERTY__HXX
#define TEAMCENTER__MAPPEDPROPERTY__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <eint/libeint_exports.h>

namespace Teamcenter
{
    class MappedProperty;
}
namespace Teamcenter
{
    class MappedPropertyImpl;
}
namespace Teamcenter
{
    class MappedPropertyDelegate;
}
namespace Teamcenter
{
    class MappedPropertyDispatch;
}
namespace Teamcenter
{
    class MappedPropertyGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EINT_API  Teamcenter::MappedProperty
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    MappedProperty();

    /**
     * Destructor
     */
    virtual ~MappedProperty();

private:
    //  Getter method for the Implementation Object
    MappedPropertyImpl*  getMappedPropertyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMappedPropertyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    MappedPropertyImpl*  m_mappedpropertyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param MappedProperty - desc for MappedProperty parameter
     */
    MappedProperty( const MappedProperty& );
    MappedProperty& operator=( const MappedProperty& );

    friend class  MappedPropertyDelegate;
    friend class  MappedPropertyDispatch;
    friend class  MappedPropertyGenImpl;
};

#include <eint/libeint_undef.h>
#endif //   TEAMCENTER__MAPPEDPROPERTY__HXX
