//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ObjectMapping
    Filename:   ObjectMapping.hxx
    Module:     eint
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__OBJECTMAPPING__HXX
#define TEAMCENTER__OBJECTMAPPING__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <eint/libeint_exports.h>

namespace Teamcenter
{
    class ObjectMapping;
}
namespace Teamcenter
{
    class ObjectMappingImpl;
}
namespace Teamcenter
{
    class ObjectMappingDelegate;
}
namespace Teamcenter
{
    class ObjectMappingDispatch;
}
namespace Teamcenter
{
    class ObjectMappingGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EINT_API  Teamcenter::ObjectMapping
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ObjectMapping();

    /**
     * Destructor
     */
    virtual ~ObjectMapping();

private:
    //  Getter method for the Implementation Object
    ObjectMappingImpl*  getObjectMappingImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setObjectMappingImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ObjectMappingImpl*  m_objectmappingImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ObjectMapping - desc for ObjectMapping parameter
     */
    ObjectMapping( const ObjectMapping& );
    ObjectMapping& operator=( const ObjectMapping& );

    friend class  ObjectMappingDelegate;
    friend class  ObjectMappingDispatch;
    friend class  ObjectMappingGenImpl;
};

#include <eint/libeint_undef.h>
#endif //   TEAMCENTER__OBJECTMAPPING__HXX
