//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ObjectMappingDelegate
    Filename:   ObjectMappingDelegate.hxx
    Module:     eint
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__OBJECTMAPPINGDELEGATE_HXX
#define TEAMCENTER__OBJECTMAPPINGDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <eint/ObjectMapping.hxx>

#include <eint/libeint_exports.h>

namespace Teamcenter
{
    class ObjectMappingDelegate;
}
namespace Teamcenter
{
    class ObjectMappingImpl;
}
namespace Teamcenter
{
    class ObjectMapping;
}
namespace Teamcenter
{
    class ObjectMappingGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  EINT_API Teamcenter_alias::ObjectMappingDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ObjectMappingDelegate instance
    static ObjectMappingDelegate&  getInstance();

    //  Method to create the ObjectMappingImpl pointer
    static ObjectMappingImpl*  createImpl( ObjectMapping&  ifObj );

    //  Method to delete the ObjectMappingImpl pointer
    static void deleteImpl( ObjectMappingImpl*  impl );



protected:
    //  Pointer to the instance
    static ObjectMappingDelegate*  m_pInstance;

    ObjectMappingDelegate();
    virtual ~ObjectMappingDelegate();
    static void setInstance( ObjectMappingDelegate*  instance );


private:
    friend class  ::Teamcenter::ObjectMappingGenImpl;

};

#include <eint/libeint_undef.h>
#endif  //  TEAMCENTER__OBJECTMAPPINGDELEGATE_HXX
