//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  eint

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libeint

#if !defined(LIBEINT) && !defined(IPLIB)
#   error IPLIB or LIBEINT is not defined
#endif

/* Handwritten code should use EINT_API, not EINTEXPORT */

#define EINT_API EINTEXPORT

#if IPLIB==libeint || defined(LIBEINT)
#   if defined(__lint)
#       define EINTEXPORT       __export(eint)
#       define EINTGLOBAL       extern __global(eint)
#       define EINTPRIVATE      extern __private(eint)
#   elif defined(_WIN32)
#       define EINTEXPORT       __declspec(dllexport)
#       define EINTGLOBAL       extern __declspec(dllexport)
#       define EINTPRIVATE      extern
#   else
#       define EINTEXPORT
#       define EINTGLOBAL       extern
#       define EINTPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define EINTEXPORT       __export(eint)
#       define EINTGLOBAL       extern __global(eint)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define EINTEXPORT      __declspec(dllimport)
#       define EINTGLOBAL       extern __declspec(dllimport)
#   else
#       define EINTEXPORT
#       define EINTGLOBAL       extern
#   endif
#endif
