//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EPMAcknowledgeTask
    Filename:   EPMAcknowledgeTask.hxx
    Module:     epm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EPMACKNOWLEDGETASK__HXX
#define TEAMCENTER__EPMACKNOWLEDGETASK__HXX

#include <common/tc_deprecation_macros.h>
#include <epm/EPMTask.hxx>

#include <epm/libepm_exports.h>

namespace Teamcenter
{
    class EPMAcknowledgeTask;
}
namespace Teamcenter
{
    class EPMAcknowledgeTaskImpl;
}
namespace Teamcenter
{
    class EPMAcknowledgeTaskDelegate;
}
namespace Teamcenter
{
    class EPMAcknowledgeTaskDispatch;
}
namespace Teamcenter
{
    class EPMAcknowledgeTaskGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EPM_API  Teamcenter::EPMAcknowledgeTask
     : public  ::Teamcenter::EPMTask
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    EPMAcknowledgeTask();

    /**
     * Destructor
     */
    virtual ~EPMAcknowledgeTask();

private:
    //  Getter method for the Implementation Object
    EPMAcknowledgeTaskImpl*  getEPMAcknowledgeTaskImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setEPMAcknowledgeTaskImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    EPMAcknowledgeTaskImpl*  m_epmacknowledgetaskImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param EPMAcknowledgeTask - desc for EPMAcknowledgeTask parameter
     */
    EPMAcknowledgeTask( const EPMAcknowledgeTask& );
    EPMAcknowledgeTask& operator=( const EPMAcknowledgeTask& );

    friend class  EPMAcknowledgeTaskDelegate;
    friend class  EPMAcknowledgeTaskDispatch;
    friend class  EPMAcknowledgeTaskGenImpl;
};

#include <epm/libepm_undef.h>
#endif //   TEAMCENTER__EPMACKNOWLEDGETASK__HXX
