//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EPMAcknowledgeTaskTemplate
    Filename:   EPMAcknowledgeTaskTemplate.hxx
    Module:     epm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EPMACKNOWLEDGETASKTEMPLATE__HXX
#define TEAMCENTER__EPMACKNOWLEDGETASKTEMPLATE__HXX

#include <common/tc_deprecation_macros.h>
#include <epm/EPMTaskTemplate.hxx>

#include <epm/libepm_exports.h>

namespace Teamcenter
{
    class EPMAcknowledgeTaskTemplate;
}
namespace Teamcenter
{
    class EPMAcknowledgeTaskTemplateImpl;
}
namespace Teamcenter
{
    class EPMAcknowledgeTaskTemplateDelegate;
}
namespace Teamcenter
{
    class EPMAcknowledgeTaskTemplateDispatch;
}
namespace Teamcenter
{
    class EPMAcknowledgeTaskTemplateGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EPM_API  Teamcenter::EPMAcknowledgeTaskTemplate
     : public  ::Teamcenter::EPMTaskTemplate
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    EPMAcknowledgeTaskTemplate();

    /**
     * Destructor
     */
    virtual ~EPMAcknowledgeTaskTemplate();

private:
    //  Getter method for the Implementation Object
    EPMAcknowledgeTaskTemplateImpl*  getEPMAcknowledgeTaskTemplateImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setEPMAcknowledgeTaskTemplateImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    EPMAcknowledgeTaskTemplateImpl*  m_epmacknowledgetasktemplateImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param EPMAcknowledgeTaskTemplate - desc for EPMAcknowledgeTaskTemplate parameter
     */
    EPMAcknowledgeTaskTemplate( const EPMAcknowledgeTaskTemplate& );
    EPMAcknowledgeTaskTemplate& operator=( const EPMAcknowledgeTaskTemplate& );

    friend class  EPMAcknowledgeTaskTemplateDelegate;
    friend class  EPMAcknowledgeTaskTemplateDispatch;
    friend class  EPMAcknowledgeTaskTemplateGenImpl;
};

#include <epm/libepm_undef.h>
#endif //   TEAMCENTER__EPMACKNOWLEDGETASKTEMPLATE__HXX
