//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EPMAction
    Filename:   EPMAction.hxx
    Module:     epm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EPMACTION__HXX
#define TEAMCENTER__EPMACTION__HXX

#include <vector>
#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <epm/libepm_exports.h>

namespace Teamcenter
{
    class EPMAction;
}
namespace Teamcenter
{
    class EPMActionImpl;
}
namespace Teamcenter
{
    class EPMActionDelegate;
}
namespace Teamcenter
{
    class EPMActionDispatch;
}
namespace Teamcenter
{
    class EPMActionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EPM_API  Teamcenter::EPMAction
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getAction_handlers( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAction_type( int &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getRules( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getTasktemplate( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 10.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setAction_handlers( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAction_type( int value, bool isNull=false );

    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 10.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setRules( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    EPMAction();

    /**
     * Destructor
     */
    virtual ~EPMAction();

private:
    //  Getter method for the Implementation Object
    EPMActionImpl*  getEPMActionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setEPMActionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    EPMActionImpl*  m_epmactionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param EPMAction - desc for EPMAction parameter
     */
    EPMAction( const EPMAction& );
    EPMAction& operator=( const EPMAction& );

    friend class  EPMActionDelegate;
    friend class  EPMActionDispatch;
    friend class  EPMActionGenImpl;
};

#include <epm/libepm_undef.h>
#endif //   TEAMCENTER__EPMACTION__HXX
