//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EPMAddStatusTask
    Filename:   EPMAddStatusTask.hxx
    Module:     epm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EPMADDSTATUSTASK__HXX
#define TEAMCENTER__EPMADDSTATUSTASK__HXX

#include <common/tc_deprecation_macros.h>
#include <epm/EPMTask.hxx>

#include <epm/libepm_exports.h>

namespace Teamcenter
{
    class EPMAddStatusTask;
}
namespace Teamcenter
{
    class EPMAddStatusTaskImpl;
}
namespace Teamcenter
{
    class EPMAddStatusTaskDelegate;
}
namespace Teamcenter
{
    class EPMAddStatusTaskDispatch;
}
namespace Teamcenter
{
    class EPMAddStatusTaskGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EPM_API  Teamcenter::EPMAddStatusTask
     : public  ::Teamcenter::EPMTask
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    EPMAddStatusTask();

    /**
     * Destructor
     */
    virtual ~EPMAddStatusTask();

private:
    //  Getter method for the Implementation Object
    EPMAddStatusTaskImpl*  getEPMAddStatusTaskImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setEPMAddStatusTaskImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    EPMAddStatusTaskImpl*  m_epmaddstatustaskImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param EPMAddStatusTask - desc for EPMAddStatusTask parameter
     */
    EPMAddStatusTask( const EPMAddStatusTask& );
    EPMAddStatusTask& operator=( const EPMAddStatusTask& );

    friend class  EPMAddStatusTaskDelegate;
    friend class  EPMAddStatusTaskDispatch;
    friend class  EPMAddStatusTaskGenImpl;
};

#include <epm/libepm_undef.h>
#endif //   TEAMCENTER__EPMADDSTATUSTASK__HXX
