//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EPMAddStatusTaskTemplate
    Filename:   EPMAddStatusTaskTemplate.hxx
    Module:     epm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EPMADDSTATUSTASKTEMPLATE__HXX
#define TEAMCENTER__EPMADDSTATUSTASKTEMPLATE__HXX

#include <common/tc_deprecation_macros.h>
#include <epm/EPMTaskTemplate.hxx>

#include <epm/libepm_exports.h>

namespace Teamcenter
{
    class EPMAddStatusTaskTemplate;
}
namespace Teamcenter
{
    class EPMAddStatusTaskTemplateImpl;
}
namespace Teamcenter
{
    class EPMAddStatusTaskTemplateDelegate;
}
namespace Teamcenter
{
    class EPMAddStatusTaskTemplateDispatch;
}
namespace Teamcenter
{
    class EPMAddStatusTaskTemplateGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EPM_API  Teamcenter::EPMAddStatusTaskTemplate
     : public  ::Teamcenter::EPMTaskTemplate
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    EPMAddStatusTaskTemplate();

    /**
     * Destructor
     */
    virtual ~EPMAddStatusTaskTemplate();

private:
    //  Getter method for the Implementation Object
    EPMAddStatusTaskTemplateImpl*  getEPMAddStatusTaskTemplateImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setEPMAddStatusTaskTemplateImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    EPMAddStatusTaskTemplateImpl*  m_epmaddstatustasktemplateImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param EPMAddStatusTaskTemplate - desc for EPMAddStatusTaskTemplate parameter
     */
    EPMAddStatusTaskTemplate( const EPMAddStatusTaskTemplate& );
    EPMAddStatusTaskTemplate& operator=( const EPMAddStatusTaskTemplate& );

    friend class  EPMAddStatusTaskTemplateDelegate;
    friend class  EPMAddStatusTaskTemplateDispatch;
    friend class  EPMAddStatusTaskTemplateGenImpl;
};

#include <epm/libepm_undef.h>
#endif //   TEAMCENTER__EPMADDSTATUSTASKTEMPLATE__HXX
