//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EPMAssignmentList
    Filename:   EPMAssignmentList.hxx
    Module:     epm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EPMASSIGNMENTLIST__HXX
#define TEAMCENTER__EPMASSIGNMENTLIST__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <epm/libepm_exports.h>

namespace Teamcenter
{
    class EPMAssignmentList;
}
namespace Teamcenter
{
    class EPMAssignmentListImpl;
}
namespace Teamcenter
{
    class EPMAssignmentListDelegate;
}
namespace Teamcenter
{
    class EPMAssignmentListDispatch;
}
namespace Teamcenter
{
    class EPMAssignmentListGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EPM_API  Teamcenter::EPMAssignmentList
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    EPMAssignmentList();

    /**
     * Destructor
     */
    virtual ~EPMAssignmentList();

private:
    //  Getter method for the Implementation Object
    EPMAssignmentListImpl*  getEPMAssignmentListImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setEPMAssignmentListImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    EPMAssignmentListImpl*  m_epmassignmentlistImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param EPMAssignmentList - desc for EPMAssignmentList parameter
     */
    EPMAssignmentList( const EPMAssignmentList& );
    EPMAssignmentList& operator=( const EPMAssignmentList& );

    friend class  EPMAssignmentListDelegate;
    friend class  EPMAssignmentListDispatch;
    friend class  EPMAssignmentListGenImpl;
};

#include <epm/libepm_undef.h>
#endif //   TEAMCENTER__EPMASSIGNMENTLIST__HXX
