//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EPMAssignmentListDelegate
    Filename:   EPMAssignmentListDelegate.hxx
    Module:     epm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EPMASSIGNMENTLISTDELEGATE_HXX
#define TEAMCENTER__EPMASSIGNMENTLISTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <epm/EPMAssignmentList.hxx>

#include <epm/libepm_exports.h>

namespace Teamcenter
{
    class EPMAssignmentListDelegate;
}
namespace Teamcenter
{
    class EPMAssignmentListImpl;
}
namespace Teamcenter
{
    class EPMAssignmentList;
}
namespace Teamcenter
{
    class EPMAssignmentListGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  EPM_API Teamcenter_alias::EPMAssignmentListDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the EPMAssignmentListDelegate instance
    static EPMAssignmentListDelegate&  getInstance();

    //  Method to create the EPMAssignmentListImpl pointer
    static EPMAssignmentListImpl*  createImpl( EPMAssignmentList&  ifObj );

    //  Method to delete the EPMAssignmentListImpl pointer
    static void deleteImpl( EPMAssignmentListImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const EPMAssignmentList &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const EPMAssignmentList &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static EPMAssignmentListDelegate*  m_pInstance;

    EPMAssignmentListDelegate();
    virtual ~EPMAssignmentListDelegate();
    static void setInstance( EPMAssignmentListDelegate*  instance );


private:
    friend class  ::Teamcenter::EPMAssignmentListGenImpl;

};

#include <epm/libepm_undef.h>
#endif  //  TEAMCENTER__EPMASSIGNMENTLISTDELEGATE_HXX
