//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EPMBRHandler
    Filename:   EPMBRHandler.hxx
    Module:     epm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EPMBRHANDLER__HXX
#define TEAMCENTER__EPMBRHANDLER__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <epm/EPMHandler.hxx>

#include <epm/libepm_exports.h>

namespace Teamcenter
{
    class EPMBRHandler;
}
namespace Teamcenter
{
    class EPMBRHandlerImpl;
}
namespace Teamcenter
{
    class EPMBRHandlerDelegate;
}
namespace Teamcenter
{
    class EPMBRHandlerDispatch;
}
namespace Teamcenter
{
    class EPMBRHandlerGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EPM_API  Teamcenter::EPMBRHandler
     : public  ::Teamcenter::EPMHandler
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getNegated( bool &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getOverride( bool &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getParent_rule( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setNegated( bool value, bool isNull=false );

    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setOverride( bool value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    EPMBRHandler();

    /**
     * Destructor
     */
    virtual ~EPMBRHandler();

private:
    //  Getter method for the Implementation Object
    EPMBRHandlerImpl*  getEPMBRHandlerImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setEPMBRHandlerImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    EPMBRHandlerImpl*  m_epmbrhandlerImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param EPMBRHandler - desc for EPMBRHandler parameter
     */
    EPMBRHandler( const EPMBRHandler& );
    EPMBRHandler& operator=( const EPMBRHandler& );

    friend class  EPMBRHandlerDelegate;
    friend class  EPMBRHandlerDispatch;
    friend class  EPMBRHandlerGenImpl;
};

#include <epm/libepm_undef.h>
#endif //   TEAMCENTER__EPMBRHANDLER__HXX
