//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EPMBRHandlerDelegate
    Filename:   EPMBRHandlerDelegate.hxx
    Module:     epm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EPMBRHANDLERDELEGATE_HXX
#define TEAMCENTER__EPMBRHANDLERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <epm/EPMBRHandler.hxx>

#include <epm/libepm_exports.h>

namespace Teamcenter
{
    class EPMBRHandlerDelegate;
}
namespace Teamcenter
{
    class EPMBRHandlerImpl;
}
namespace Teamcenter
{
    class EPMBRHandler;
}
namespace Teamcenter
{
    class EPMBRHandlerGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  EPM_API Teamcenter_alias::EPMBRHandlerDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the EPMBRHandlerDelegate instance
    static EPMBRHandlerDelegate&  getInstance();

    //  Method to create the EPMBRHandlerImpl pointer
    static EPMBRHandlerImpl*  createImpl( EPMBRHandler&  ifObj );

    //  Method to delete the EPMBRHandlerImpl pointer
    static void deleteImpl( EPMBRHandlerImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getNegatedBase(const EPMBRHandler &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getOverrideBase(const EPMBRHandler &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getParent_ruleBase(const EPMBRHandler &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setNegatedBase(EPMBRHandler &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setOverrideBase(EPMBRHandler &ifObj,  bool value, bool isNull );



protected:
    //  Pointer to the instance
    static EPMBRHandlerDelegate*  m_pInstance;

    EPMBRHandlerDelegate();
    virtual ~EPMBRHandlerDelegate();
    static void setInstance( EPMBRHandlerDelegate*  instance );


private:
    friend class  ::Teamcenter::EPMBRHandlerGenImpl;

};

#include <epm/libepm_undef.h>
#endif  //  TEAMCENTER__EPMBRHANDLERDELEGATE_HXX
