//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EPMBusinessRule
    Filename:   EPMBusinessRule.hxx
    Module:     epm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EPMBUSINESSRULE__HXX
#define TEAMCENTER__EPMBUSINESSRULE__HXX

#include <unidefs.h>
#include <string>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <epm/libepm_exports.h>

namespace Teamcenter
{
    class EPMBusinessRule;
}
namespace Teamcenter
{
    class EPMBusinessRuleImpl;
}
namespace Teamcenter
{
    class EPMBusinessRuleDelegate;
}
namespace Teamcenter
{
    class EPMBusinessRuleDispatch;
}
namespace Teamcenter
{
    class EPMBusinessRuleGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EPM_API  Teamcenter::EPMBusinessRule
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAction( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getNext_rule( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getObject_name( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getParent_tasktemplate( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getQuorum( int &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getRule_handlers( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setObject_name( const std::string &value, bool isNull=false );

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setQuorum( int value, bool isNull=false );

    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 10.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setRule_handlers( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    EPMBusinessRule();

    /**
     * Destructor
     */
    virtual ~EPMBusinessRule();

private:
    //  Getter method for the Implementation Object
    EPMBusinessRuleImpl*  getEPMBusinessRuleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setEPMBusinessRuleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    EPMBusinessRuleImpl*  m_epmbusinessruleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param EPMBusinessRule - desc for EPMBusinessRule parameter
     */
    EPMBusinessRule( const EPMBusinessRule& );
    EPMBusinessRule& operator=( const EPMBusinessRule& );

    friend class  EPMBusinessRuleDelegate;
    friend class  EPMBusinessRuleDispatch;
    friend class  EPMBusinessRuleGenImpl;
};

#include <epm/libepm_undef.h>
#endif //   TEAMCENTER__EPMBUSINESSRULE__HXX
