//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EPMConditionTask
    Filename:   EPMConditionTask.hxx
    Module:     epm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EPMCONDITIONTASK__HXX
#define TEAMCENTER__EPMCONDITIONTASK__HXX

#include <common/tc_deprecation_macros.h>
#include <epm/EPMTask.hxx>

#include <epm/libepm_exports.h>

namespace Teamcenter
{
    class EPMConditionTask;
}
namespace Teamcenter
{
    class EPMConditionTaskImpl;
}
namespace Teamcenter
{
    class EPMConditionTaskDelegate;
}
namespace Teamcenter
{
    class EPMConditionTaskDispatch;
}
namespace Teamcenter
{
    class EPMConditionTaskGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EPM_API  Teamcenter::EPMConditionTask
     : public  ::Teamcenter::EPMTask
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    EPMConditionTask();

    /**
     * Destructor
     */
    virtual ~EPMConditionTask();

private:
    //  Getter method for the Implementation Object
    EPMConditionTaskImpl*  getEPMConditionTaskImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setEPMConditionTaskImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    EPMConditionTaskImpl*  m_epmconditiontaskImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param EPMConditionTask - desc for EPMConditionTask parameter
     */
    EPMConditionTask( const EPMConditionTask& );
    EPMConditionTask& operator=( const EPMConditionTask& );

    friend class  EPMConditionTaskDelegate;
    friend class  EPMConditionTaskDispatch;
    friend class  EPMConditionTaskGenImpl;
};

#include <epm/libepm_undef.h>
#endif //   TEAMCENTER__EPMCONDITIONTASK__HXX
