//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EPMConditionTaskTemplate
    Filename:   EPMConditionTaskTemplate.hxx
    Module:     epm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EPMCONDITIONTASKTEMPLATE__HXX
#define TEAMCENTER__EPMCONDITIONTASKTEMPLATE__HXX

#include <common/tc_deprecation_macros.h>
#include <epm/EPMTaskTemplate.hxx>

#include <epm/libepm_exports.h>

namespace Teamcenter
{
    class EPMConditionTaskTemplate;
}
namespace Teamcenter
{
    class EPMConditionTaskTemplateImpl;
}
namespace Teamcenter
{
    class EPMConditionTaskTemplateDelegate;
}
namespace Teamcenter
{
    class EPMConditionTaskTemplateDispatch;
}
namespace Teamcenter
{
    class EPMConditionTaskTemplateGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EPM_API  Teamcenter::EPMConditionTaskTemplate
     : public  ::Teamcenter::EPMTaskTemplate
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    EPMConditionTaskTemplate();

    /**
     * Destructor
     */
    virtual ~EPMConditionTaskTemplate();

private:
    //  Getter method for the Implementation Object
    EPMConditionTaskTemplateImpl*  getEPMConditionTaskTemplateImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setEPMConditionTaskTemplateImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    EPMConditionTaskTemplateImpl*  m_epmconditiontasktemplateImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param EPMConditionTaskTemplate - desc for EPMConditionTaskTemplate parameter
     */
    EPMConditionTaskTemplate( const EPMConditionTaskTemplate& );
    EPMConditionTaskTemplate& operator=( const EPMConditionTaskTemplate& );

    friend class  EPMConditionTaskTemplateDelegate;
    friend class  EPMConditionTaskTemplateDispatch;
    friend class  EPMConditionTaskTemplateGenImpl;
};

#include <epm/libepm_undef.h>
#endif //   TEAMCENTER__EPMCONDITIONTASKTEMPLATE__HXX
