//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EPMDoTask
    Filename:   EPMDoTask.hxx
    Module:     epm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EPMDOTASK__HXX
#define TEAMCENTER__EPMDOTASK__HXX

#include <common/tc_deprecation_macros.h>
#include <epm/EPMTask.hxx>

#include <epm/libepm_exports.h>

namespace Teamcenter
{
    class EPMDoTask;
}
namespace Teamcenter
{
    class EPMDoTaskImpl;
}
namespace Teamcenter
{
    class EPMDoTaskDelegate;
}
namespace Teamcenter
{
    class EPMDoTaskDispatch;
}
namespace Teamcenter
{
    class EPMDoTaskGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EPM_API  Teamcenter::EPMDoTask
     : public  ::Teamcenter::EPMTask
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    EPMDoTask();

    /**
     * Destructor
     */
    virtual ~EPMDoTask();

private:
    //  Getter method for the Implementation Object
    EPMDoTaskImpl*  getEPMDoTaskImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setEPMDoTaskImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    EPMDoTaskImpl*  m_epmdotaskImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param EPMDoTask - desc for EPMDoTask parameter
     */
    EPMDoTask( const EPMDoTask& );
    EPMDoTask& operator=( const EPMDoTask& );

    friend class  EPMDoTaskDelegate;
    friend class  EPMDoTaskDispatch;
    friend class  EPMDoTaskGenImpl;
};

#include <epm/libepm_undef.h>
#endif //   TEAMCENTER__EPMDOTASK__HXX
