//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EPMDoTaskTemplate
    Filename:   EPMDoTaskTemplate.hxx
    Module:     epm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EPMDOTASKTEMPLATE__HXX
#define TEAMCENTER__EPMDOTASKTEMPLATE__HXX

#include <common/tc_deprecation_macros.h>
#include <epm/EPMTaskTemplate.hxx>

#include <epm/libepm_exports.h>

namespace Teamcenter
{
    class EPMDoTaskTemplate;
}
namespace Teamcenter
{
    class EPMDoTaskTemplateImpl;
}
namespace Teamcenter
{
    class EPMDoTaskTemplateDelegate;
}
namespace Teamcenter
{
    class EPMDoTaskTemplateDispatch;
}
namespace Teamcenter
{
    class EPMDoTaskTemplateGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EPM_API  Teamcenter::EPMDoTaskTemplate
     : public  ::Teamcenter::EPMTaskTemplate
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    EPMDoTaskTemplate();

    /**
     * Destructor
     */
    virtual ~EPMDoTaskTemplate();

private:
    //  Getter method for the Implementation Object
    EPMDoTaskTemplateImpl*  getEPMDoTaskTemplateImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setEPMDoTaskTemplateImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    EPMDoTaskTemplateImpl*  m_epmdotasktemplateImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param EPMDoTaskTemplate - desc for EPMDoTaskTemplate parameter
     */
    EPMDoTaskTemplate( const EPMDoTaskTemplate& );
    EPMDoTaskTemplate& operator=( const EPMDoTaskTemplate& );

    friend class  EPMDoTaskTemplateDelegate;
    friend class  EPMDoTaskTemplateDispatch;
    friend class  EPMDoTaskTemplateGenImpl;
};

#include <epm/libepm_undef.h>
#endif //   TEAMCENTER__EPMDOTASKTEMPLATE__HXX
