//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EPMJob
    Filename:   EPMJob.hxx
    Module:     epm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EPMJOB__HXX
#define TEAMCENTER__EPMJOB__HXX

#include <vector>
#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <epm/libepm_exports.h>

namespace Teamcenter
{
    class EPMJob;
}
namespace Teamcenter
{
    class EPMJobImpl;
}
namespace Teamcenter
{
    class EPMJobDelegate;
}
namespace Teamcenter
{
    class EPMJobDispatch;
}
namespace Teamcenter
{
    class EPMJobGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EPM_API  Teamcenter::EPMJob
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getAll_tasks( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a Date Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDue_date_project( date_t &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getEpm_parentprocess( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 13.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ErrorTasks( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 13.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0Late( bool &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIs_parallel_process( bool &value, bool &isNull ) const;

    ///
    /// Getter for a Date Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getProcess_due_date( date_t &value, bool &isNull ) const;

    ///
    /// Setter for a Date Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDue_date_project( const date_t &value, bool isNull=false );

    ///
    /// Setter for a Date Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setProcess_due_date( const date_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    EPMJob();

    /**
     * Destructor
     */
    virtual ~EPMJob();

private:
    //  Getter method for the Implementation Object
    EPMJobImpl*  getEPMJobImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setEPMJobImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    EPMJobImpl*  m_epmjobImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param EPMJob - desc for EPMJob parameter
     */
    EPMJob( const EPMJob& );
    EPMJob& operator=( const EPMJob& );

    friend class  EPMJobDelegate;
    friend class  EPMJobDispatch;
    friend class  EPMJobGenImpl;
};

#include <epm/libepm_undef.h>
#endif //   TEAMCENTER__EPMJOB__HXX
