//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EPMNotifyTask
    Filename:   EPMNotifyTask.hxx
    Module:     epm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EPMNOTIFYTASK__HXX
#define TEAMCENTER__EPMNOTIFYTASK__HXX

#include <common/tc_deprecation_macros.h>
#include <epm/EPMTask.hxx>

#include <epm/libepm_exports.h>

namespace Teamcenter
{
    class EPMNotifyTask;
}
namespace Teamcenter
{
    class EPMNotifyTaskImpl;
}
namespace Teamcenter
{
    class EPMNotifyTaskDelegate;
}
namespace Teamcenter
{
    class EPMNotifyTaskDispatch;
}
namespace Teamcenter
{
    class EPMNotifyTaskGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EPM_API  Teamcenter::EPMNotifyTask
     : public  ::Teamcenter::EPMTask
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    EPMNotifyTask();

    /**
     * Destructor
     */
    virtual ~EPMNotifyTask();

private:
    //  Getter method for the Implementation Object
    EPMNotifyTaskImpl*  getEPMNotifyTaskImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setEPMNotifyTaskImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    EPMNotifyTaskImpl*  m_epmnotifytaskImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param EPMNotifyTask - desc for EPMNotifyTask parameter
     */
    EPMNotifyTask( const EPMNotifyTask& );
    EPMNotifyTask& operator=( const EPMNotifyTask& );

    friend class  EPMNotifyTaskDelegate;
    friend class  EPMNotifyTaskDispatch;
    friend class  EPMNotifyTaskGenImpl;
};

#include <epm/libepm_undef.h>
#endif //   TEAMCENTER__EPMNOTIFYTASK__HXX
