//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EPMOrTask
    Filename:   EPMOrTask.hxx
    Module:     epm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EPMORTASK__HXX
#define TEAMCENTER__EPMORTASK__HXX

#include <common/tc_deprecation_macros.h>
#include <epm/EPMTask.hxx>

#include <epm/libepm_exports.h>

namespace Teamcenter
{
    class EPMOrTask;
}
namespace Teamcenter
{
    class EPMOrTaskImpl;
}
namespace Teamcenter
{
    class EPMOrTaskDelegate;
}
namespace Teamcenter
{
    class EPMOrTaskDispatch;
}
namespace Teamcenter
{
    class EPMOrTaskGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EPM_API  Teamcenter::EPMOrTask
     : public  ::Teamcenter::EPMTask
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    EPMOrTask();

    /**
     * Destructor
     */
    virtual ~EPMOrTask();

private:
    //  Getter method for the Implementation Object
    EPMOrTaskImpl*  getEPMOrTaskImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setEPMOrTaskImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    EPMOrTaskImpl*  m_epmortaskImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param EPMOrTask - desc for EPMOrTask parameter
     */
    EPMOrTask( const EPMOrTask& );
    EPMOrTask& operator=( const EPMOrTask& );

    friend class  EPMOrTaskDelegate;
    friend class  EPMOrTaskDispatch;
    friend class  EPMOrTaskGenImpl;
};

#include <epm/libepm_undef.h>
#endif //   TEAMCENTER__EPMORTASK__HXX
