//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EPMOrTaskTemplate
    Filename:   EPMOrTaskTemplate.hxx
    Module:     epm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EPMORTASKTEMPLATE__HXX
#define TEAMCENTER__EPMORTASKTEMPLATE__HXX

#include <common/tc_deprecation_macros.h>
#include <epm/EPMTaskTemplate.hxx>

#include <epm/libepm_exports.h>

namespace Teamcenter
{
    class EPMOrTaskTemplate;
}
namespace Teamcenter
{
    class EPMOrTaskTemplateImpl;
}
namespace Teamcenter
{
    class EPMOrTaskTemplateDelegate;
}
namespace Teamcenter
{
    class EPMOrTaskTemplateDispatch;
}
namespace Teamcenter
{
    class EPMOrTaskTemplateGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EPM_API  Teamcenter::EPMOrTaskTemplate
     : public  ::Teamcenter::EPMTaskTemplate
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    EPMOrTaskTemplate();

    /**
     * Destructor
     */
    virtual ~EPMOrTaskTemplate();

private:
    //  Getter method for the Implementation Object
    EPMOrTaskTemplateImpl*  getEPMOrTaskTemplateImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setEPMOrTaskTemplateImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    EPMOrTaskTemplateImpl*  m_epmortasktemplateImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param EPMOrTaskTemplate - desc for EPMOrTaskTemplate parameter
     */
    EPMOrTaskTemplate( const EPMOrTaskTemplate& );
    EPMOrTaskTemplate& operator=( const EPMOrTaskTemplate& );

    friend class  EPMOrTaskTemplateDelegate;
    friend class  EPMOrTaskTemplateDispatch;
    friend class  EPMOrTaskTemplateGenImpl;
};

#include <epm/libepm_undef.h>
#endif //   TEAMCENTER__EPMORTASKTEMPLATE__HXX
