//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EPMPerformSignoffTask
    Filename:   EPMPerformSignoffTask.hxx
    Module:     epm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EPMPERFORMSIGNOFFTASK__HXX
#define TEAMCENTER__EPMPERFORMSIGNOFFTASK__HXX

#include <common/tc_deprecation_macros.h>
#include <epm/EPMTask.hxx>

#include <epm/libepm_exports.h>

namespace Teamcenter
{
    class EPMPerformSignoffTask;
}
namespace Teamcenter
{
    class EPMPerformSignoffTaskImpl;
}
namespace Teamcenter
{
    class EPMPerformSignoffTaskDelegate;
}
namespace Teamcenter
{
    class EPMPerformSignoffTaskDispatch;
}
namespace Teamcenter
{
    class EPMPerformSignoffTaskGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EPM_API  Teamcenter::EPMPerformSignoffTask
     : public  ::Teamcenter::EPMTask
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    EPMPerformSignoffTask();

    /**
     * Destructor
     */
    virtual ~EPMPerformSignoffTask();

private:
    //  Getter method for the Implementation Object
    EPMPerformSignoffTaskImpl*  getEPMPerformSignoffTaskImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setEPMPerformSignoffTaskImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    EPMPerformSignoffTaskImpl*  m_epmperformsignofftaskImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param EPMPerformSignoffTask - desc for EPMPerformSignoffTask parameter
     */
    EPMPerformSignoffTask( const EPMPerformSignoffTask& );
    EPMPerformSignoffTask& operator=( const EPMPerformSignoffTask& );

    friend class  EPMPerformSignoffTaskDelegate;
    friend class  EPMPerformSignoffTaskDispatch;
    friend class  EPMPerformSignoffTaskGenImpl;
};

#include <epm/libepm_undef.h>
#endif //   TEAMCENTER__EPMPERFORMSIGNOFFTASK__HXX
