//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EPMPerformSignoffTaskTemplateDelegate
    Filename:   EPMPerformSignoffTaskTemplateDelegate.hxx
    Module:     epm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EPMPERFORMSIGNOFFTASKTEMPLATEDELEGATE_HXX
#define TEAMCENTER__EPMPERFORMSIGNOFFTASKTEMPLATEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <epm/EPMPerformSignoffTaskTemplate.hxx>

#include <epm/libepm_exports.h>

namespace Teamcenter
{
    class EPMPerformSignoffTaskTemplateDelegate;
}
namespace Teamcenter
{
    class EPMPerformSignoffTaskTemplateImpl;
}
namespace Teamcenter
{
    class EPMPerformSignoffTaskTemplate;
}
namespace Teamcenter
{
    class EPMPerformSignoffTaskTemplateGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  EPM_API Teamcenter_alias::EPMPerformSignoffTaskTemplateDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the EPMPerformSignoffTaskTemplateDelegate instance
    static EPMPerformSignoffTaskTemplateDelegate&  getInstance();

    //  Method to create the EPMPerformSignoffTaskTemplateImpl pointer
    static EPMPerformSignoffTaskTemplateImpl*  createImpl( EPMPerformSignoffTaskTemplate&  ifObj );

    //  Method to delete the EPMPerformSignoffTaskTemplateImpl pointer
    static void deleteImpl( EPMPerformSignoffTaskTemplateImpl*  impl );


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getReview_task_quorumBase(const EPMPerformSignoffTaskTemplate &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getSignoff_profilesBase(const EPMPerformSignoffTaskTemplate &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setReview_task_quorumBase(EPMPerformSignoffTaskTemplate &ifObj,  int value, bool isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 10.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setSignoff_profilesBase(EPMPerformSignoffTaskTemplate &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );



protected:
    //  Pointer to the instance
    static EPMPerformSignoffTaskTemplateDelegate*  m_pInstance;

    EPMPerformSignoffTaskTemplateDelegate();
    virtual ~EPMPerformSignoffTaskTemplateDelegate();
    static void setInstance( EPMPerformSignoffTaskTemplateDelegate*  instance );


private:
    friend class  ::Teamcenter::EPMPerformSignoffTaskTemplateGenImpl;

};

#include <epm/libepm_undef.h>
#endif  //  TEAMCENTER__EPMPERFORMSIGNOFFTASKTEMPLATEDELEGATE_HXX
