//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EPMResourceList
    Filename:   EPMResourceList.hxx
    Module:     epm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EPMRESOURCELIST__HXX
#define TEAMCENTER__EPMRESOURCELIST__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <epm/libepm_exports.h>

namespace Teamcenter
{
    class EPMResourceList;
}
namespace Teamcenter
{
    class EPMResourceListImpl;
}
namespace Teamcenter
{
    class EPMResourceListDelegate;
}
namespace Teamcenter
{
    class EPMResourceListDispatch;
}
namespace Teamcenter
{
    class EPMResourceListGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EPM_API  Teamcenter::EPMResourceList
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    EPMResourceList();

    /**
     * Destructor
     */
    virtual ~EPMResourceList();

private:
    //  Getter method for the Implementation Object
    EPMResourceListImpl*  getEPMResourceListImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setEPMResourceListImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    EPMResourceListImpl*  m_epmresourcelistImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param EPMResourceList - desc for EPMResourceList parameter
     */
    EPMResourceList( const EPMResourceList& );
    EPMResourceList& operator=( const EPMResourceList& );

    friend class  EPMResourceListDelegate;
    friend class  EPMResourceListDispatch;
    friend class  EPMResourceListGenImpl;
};

#include <epm/libepm_undef.h>
#endif //   TEAMCENTER__EPMRESOURCELIST__HXX
