//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EPMReviewTask
    Filename:   EPMReviewTask.hxx
    Module:     epm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EPMREVIEWTASK__HXX
#define TEAMCENTER__EPMREVIEWTASK__HXX

#include <common/tc_deprecation_macros.h>
#include <epm/EPMTask.hxx>

#include <epm/libepm_exports.h>

namespace Teamcenter
{
    class EPMReviewTask;
}
namespace Teamcenter
{
    class EPMReviewTaskImpl;
}
namespace Teamcenter
{
    class EPMReviewTaskDelegate;
}
namespace Teamcenter
{
    class EPMReviewTaskDispatch;
}
namespace Teamcenter
{
    class EPMReviewTaskGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EPM_API  Teamcenter::EPMReviewTask
     : public  ::Teamcenter::EPMTask
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    EPMReviewTask();

    /**
     * Destructor
     */
    virtual ~EPMReviewTask();

private:
    //  Getter method for the Implementation Object
    EPMReviewTaskImpl*  getEPMReviewTaskImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setEPMReviewTaskImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    EPMReviewTaskImpl*  m_epmreviewtaskImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param EPMReviewTask - desc for EPMReviewTask parameter
     */
    EPMReviewTask( const EPMReviewTask& );
    EPMReviewTask& operator=( const EPMReviewTask& );

    friend class  EPMReviewTaskDelegate;
    friend class  EPMReviewTaskDispatch;
    friend class  EPMReviewTaskGenImpl;
};

#include <epm/libepm_undef.h>
#endif //   TEAMCENTER__EPMREVIEWTASK__HXX
