//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EPMReviewTaskTemplate
    Filename:   EPMReviewTaskTemplate.hxx
    Module:     epm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EPMREVIEWTASKTEMPLATE__HXX
#define TEAMCENTER__EPMREVIEWTASKTEMPLATE__HXX

#include <common/tc_deprecation_macros.h>
#include <epm/EPMTaskTemplate.hxx>

#include <epm/libepm_exports.h>

namespace Teamcenter
{
    class EPMReviewTaskTemplate;
}
namespace Teamcenter
{
    class EPMReviewTaskTemplateImpl;
}
namespace Teamcenter
{
    class EPMReviewTaskTemplateDelegate;
}
namespace Teamcenter
{
    class EPMReviewTaskTemplateDispatch;
}
namespace Teamcenter
{
    class EPMReviewTaskTemplateGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EPM_API  Teamcenter::EPMReviewTaskTemplate
     : public  ::Teamcenter::EPMTaskTemplate
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    EPMReviewTaskTemplate();

    /**
     * Destructor
     */
    virtual ~EPMReviewTaskTemplate();

private:
    //  Getter method for the Implementation Object
    EPMReviewTaskTemplateImpl*  getEPMReviewTaskTemplateImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setEPMReviewTaskTemplateImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    EPMReviewTaskTemplateImpl*  m_epmreviewtasktemplateImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param EPMReviewTaskTemplate - desc for EPMReviewTaskTemplate parameter
     */
    EPMReviewTaskTemplate( const EPMReviewTaskTemplate& );
    EPMReviewTaskTemplate& operator=( const EPMReviewTaskTemplate& );

    friend class  EPMReviewTaskTemplateDelegate;
    friend class  EPMReviewTaskTemplateDispatch;
    friend class  EPMReviewTaskTemplateGenImpl;
};

#include <epm/libepm_undef.h>
#endif //   TEAMCENTER__EPMREVIEWTASKTEMPLATE__HXX
