//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EPMRouteTask
    Filename:   EPMRouteTask.hxx
    Module:     epm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EPMROUTETASK__HXX
#define TEAMCENTER__EPMROUTETASK__HXX

#include <common/tc_deprecation_macros.h>
#include <epm/EPMTask.hxx>

#include <epm/libepm_exports.h>

namespace Teamcenter
{
    class EPMRouteTask;
}
namespace Teamcenter
{
    class EPMRouteTaskImpl;
}
namespace Teamcenter
{
    class EPMRouteTaskDelegate;
}
namespace Teamcenter
{
    class EPMRouteTaskDispatch;
}
namespace Teamcenter
{
    class EPMRouteTaskGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EPM_API  Teamcenter::EPMRouteTask
     : public  ::Teamcenter::EPMTask
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    EPMRouteTask();

    /**
     * Destructor
     */
    virtual ~EPMRouteTask();

private:
    //  Getter method for the Implementation Object
    EPMRouteTaskImpl*  getEPMRouteTaskImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setEPMRouteTaskImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    EPMRouteTaskImpl*  m_epmroutetaskImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param EPMRouteTask - desc for EPMRouteTask parameter
     */
    EPMRouteTask( const EPMRouteTask& );
    EPMRouteTask& operator=( const EPMRouteTask& );

    friend class  EPMRouteTaskDelegate;
    friend class  EPMRouteTaskDispatch;
    friend class  EPMRouteTaskGenImpl;
};

#include <epm/libepm_undef.h>
#endif //   TEAMCENTER__EPMROUTETASK__HXX
