//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EPMRouteTaskTemplate
    Filename:   EPMRouteTaskTemplate.hxx
    Module:     epm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EPMROUTETASKTEMPLATE__HXX
#define TEAMCENTER__EPMROUTETASKTEMPLATE__HXX

#include <common/tc_deprecation_macros.h>
#include <epm/EPMTaskTemplate.hxx>

#include <epm/libepm_exports.h>

namespace Teamcenter
{
    class EPMRouteTaskTemplate;
}
namespace Teamcenter
{
    class EPMRouteTaskTemplateImpl;
}
namespace Teamcenter
{
    class EPMRouteTaskTemplateDelegate;
}
namespace Teamcenter
{
    class EPMRouteTaskTemplateDispatch;
}
namespace Teamcenter
{
    class EPMRouteTaskTemplateGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EPM_API  Teamcenter::EPMRouteTaskTemplate
     : public  ::Teamcenter::EPMTaskTemplate
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    EPMRouteTaskTemplate();

    /**
     * Destructor
     */
    virtual ~EPMRouteTaskTemplate();

private:
    //  Getter method for the Implementation Object
    EPMRouteTaskTemplateImpl*  getEPMRouteTaskTemplateImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setEPMRouteTaskTemplateImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    EPMRouteTaskTemplateImpl*  m_epmroutetasktemplateImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param EPMRouteTaskTemplate - desc for EPMRouteTaskTemplate parameter
     */
    EPMRouteTaskTemplate( const EPMRouteTaskTemplate& );
    EPMRouteTaskTemplate& operator=( const EPMRouteTaskTemplate& );

    friend class  EPMRouteTaskTemplateDelegate;
    friend class  EPMRouteTaskTemplateDispatch;
    friend class  EPMRouteTaskTemplateGenImpl;
};

#include <epm/libepm_undef.h>
#endif //   TEAMCENTER__EPMROUTETASKTEMPLATE__HXX
