//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EPMSelectSignoffTask
    Filename:   EPMSelectSignoffTask.hxx
    Module:     epm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EPMSELECTSIGNOFFTASK__HXX
#define TEAMCENTER__EPMSELECTSIGNOFFTASK__HXX

#include <common/tc_deprecation_macros.h>
#include <epm/EPMTask.hxx>

#include <epm/libepm_exports.h>

namespace Teamcenter
{
    class EPMSelectSignoffTask;
}
namespace Teamcenter
{
    class EPMSelectSignoffTaskImpl;
}
namespace Teamcenter
{
    class EPMSelectSignoffTaskDelegate;
}
namespace Teamcenter
{
    class EPMSelectSignoffTaskDispatch;
}
namespace Teamcenter
{
    class EPMSelectSignoffTaskGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EPM_API  Teamcenter::EPMSelectSignoffTask
     : public  ::Teamcenter::EPMTask
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    EPMSelectSignoffTask();

    /**
     * Destructor
     */
    virtual ~EPMSelectSignoffTask();

private:
    //  Getter method for the Implementation Object
    EPMSelectSignoffTaskImpl*  getEPMSelectSignoffTaskImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setEPMSelectSignoffTaskImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    EPMSelectSignoffTaskImpl*  m_epmselectsignofftaskImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param EPMSelectSignoffTask - desc for EPMSelectSignoffTask parameter
     */
    EPMSelectSignoffTask( const EPMSelectSignoffTask& );
    EPMSelectSignoffTask& operator=( const EPMSelectSignoffTask& );

    friend class  EPMSelectSignoffTaskDelegate;
    friend class  EPMSelectSignoffTaskDispatch;
    friend class  EPMSelectSignoffTaskGenImpl;
};

#include <epm/libepm_undef.h>
#endif //   TEAMCENTER__EPMSELECTSIGNOFFTASK__HXX
