//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EPMSelectSignoffTaskTemplate
    Filename:   EPMSelectSignoffTaskTemplate.hxx
    Module:     epm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EPMSELECTSIGNOFFTASKTEMPLATE__HXX
#define TEAMCENTER__EPMSELECTSIGNOFFTASKTEMPLATE__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <epm/EPMTaskTemplate.hxx>

#include <epm/libepm_exports.h>

namespace Teamcenter
{
    class EPMSelectSignoffTaskTemplate;
}
namespace Teamcenter
{
    class EPMSelectSignoffTaskTemplateImpl;
}
namespace Teamcenter
{
    class EPMSelectSignoffTaskTemplateDelegate;
}
namespace Teamcenter
{
    class EPMSelectSignoffTaskTemplateDispatch;
}
namespace Teamcenter
{
    class EPMSelectSignoffTaskTemplateGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EPM_API  Teamcenter::EPMSelectSignoffTaskTemplate
     : public  ::Teamcenter::EPMTaskTemplate
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getReview_task_quorum( int &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getSignoff_profiles( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setReview_task_quorum( int value, bool isNull=false );

    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 10.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setSignoff_profiles( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    EPMSelectSignoffTaskTemplate();

    /**
     * Destructor
     */
    virtual ~EPMSelectSignoffTaskTemplate();

private:
    //  Getter method for the Implementation Object
    EPMSelectSignoffTaskTemplateImpl*  getEPMSelectSignoffTaskTemplateImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setEPMSelectSignoffTaskTemplateImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    EPMSelectSignoffTaskTemplateImpl*  m_epmselectsignofftasktemplateImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param EPMSelectSignoffTaskTemplate - desc for EPMSelectSignoffTaskTemplate parameter
     */
    EPMSelectSignoffTaskTemplate( const EPMSelectSignoffTaskTemplate& );
    EPMSelectSignoffTaskTemplate& operator=( const EPMSelectSignoffTaskTemplate& );

    friend class  EPMSelectSignoffTaskTemplateDelegate;
    friend class  EPMSelectSignoffTaskTemplateDispatch;
    friend class  EPMSelectSignoffTaskTemplateGenImpl;
};

#include <epm/libepm_undef.h>
#endif //   TEAMCENTER__EPMSELECTSIGNOFFTASKTEMPLATE__HXX
