//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EPMSelectSignoffTaskTemplateDelegate
    Filename:   EPMSelectSignoffTaskTemplateDelegate.hxx
    Module:     epm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EPMSELECTSIGNOFFTASKTEMPLATEDELEGATE_HXX
#define TEAMCENTER__EPMSELECTSIGNOFFTASKTEMPLATEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <epm/EPMSelectSignoffTaskTemplate.hxx>

#include <epm/libepm_exports.h>

namespace Teamcenter
{
    class EPMSelectSignoffTaskTemplateDelegate;
}
namespace Teamcenter
{
    class EPMSelectSignoffTaskTemplateImpl;
}
namespace Teamcenter
{
    class EPMSelectSignoffTaskTemplate;
}
namespace Teamcenter
{
    class EPMSelectSignoffTaskTemplateGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  EPM_API Teamcenter_alias::EPMSelectSignoffTaskTemplateDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the EPMSelectSignoffTaskTemplateDelegate instance
    static EPMSelectSignoffTaskTemplateDelegate&  getInstance();

    //  Method to create the EPMSelectSignoffTaskTemplateImpl pointer
    static EPMSelectSignoffTaskTemplateImpl*  createImpl( EPMSelectSignoffTaskTemplate&  ifObj );

    //  Method to delete the EPMSelectSignoffTaskTemplateImpl pointer
    static void deleteImpl( EPMSelectSignoffTaskTemplateImpl*  impl );


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getReview_task_quorumBase(const EPMSelectSignoffTaskTemplate &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getSignoff_profilesBase(const EPMSelectSignoffTaskTemplate &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setReview_task_quorumBase(EPMSelectSignoffTaskTemplate &ifObj,  int value, bool isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 10.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setSignoff_profilesBase(EPMSelectSignoffTaskTemplate &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getParent_predecessorBase(const EPMSelectSignoffTaskTemplate &ifObj,  bool &value, bool &isNull ) const;



protected:
    //  Pointer to the instance
    static EPMSelectSignoffTaskTemplateDelegate*  m_pInstance;

    EPMSelectSignoffTaskTemplateDelegate();
    virtual ~EPMSelectSignoffTaskTemplateDelegate();
    static void setInstance( EPMSelectSignoffTaskTemplateDelegate*  instance );


private:
    friend class  ::Teamcenter::EPMSelectSignoffTaskTemplateGenImpl;

};

#include <epm/libepm_undef.h>
#endif  //  TEAMCENTER__EPMSELECTSIGNOFFTASKTEMPLATEDELEGATE_HXX
