//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EPMSignoffProfileDelegate
    Filename:   EPMSignoffProfileDelegate.hxx
    Module:     epm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EPMSIGNOFFPROFILEDELEGATE_HXX
#define TEAMCENTER__EPMSIGNOFFPROFILEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <epm/EPMSignoffProfile.hxx>

#include <epm/libepm_exports.h>

namespace Teamcenter
{
    class EPMSignoffProfileDelegate;
}
namespace Teamcenter
{
    class EPMSignoffProfileImpl;
}
namespace Teamcenter
{
    class EPMSignoffProfile;
}
namespace Teamcenter
{
    class EPMSignoffProfileGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  EPM_API Teamcenter_alias::EPMSignoffProfileDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the EPMSignoffProfileDelegate instance
    static EPMSignoffProfileDelegate&  getInstance();

    //  Method to create the EPMSignoffProfileImpl pointer
    static EPMSignoffProfileImpl*  createImpl( EPMSignoffProfile&  ifObj );

    //  Method to delete the EPMSignoffProfileImpl pointer
    static void deleteImpl( EPMSignoffProfileImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAllow_subgroupsBase(const EPMSignoffProfile &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getGroupBase(const EPMSignoffProfile &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getGroup_nameBase(const EPMSignoffProfile &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getNumber_of_signoffsBase(const EPMSignoffProfile &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRoleBase(const EPMSignoffProfile &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRole_nameBase(const EPMSignoffProfile &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSignoff_quorumBase(const EPMSignoffProfile &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAllow_subgroupsBase(EPMSignoffProfile &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setGroupBase(EPMSignoffProfile &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setNumber_of_signoffsBase(EPMSignoffProfile &ifObj,  int value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setRoleBase(EPMSignoffProfile &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSignoff_quorumBase(EPMSignoffProfile &ifObj,  int value, bool isNull );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getObject_stringBase(const EPMSignoffProfile &ifObj,  std::string &value, bool &isNull ) const;



protected:
    //  Pointer to the instance
    static EPMSignoffProfileDelegate*  m_pInstance;

    EPMSignoffProfileDelegate();
    virtual ~EPMSignoffProfileDelegate();
    static void setInstance( EPMSignoffProfileDelegate*  instance );


private:
    friend class  ::Teamcenter::EPMSignoffProfileGenImpl;

};

#include <epm/libepm_undef.h>
#endif  //  TEAMCENTER__EPMSIGNOFFPROFILEDELEGATE_HXX
