//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EPMValidateTask
    Filename:   EPMValidateTask.hxx
    Module:     epm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EPMVALIDATETASK__HXX
#define TEAMCENTER__EPMVALIDATETASK__HXX

#include <common/tc_deprecation_macros.h>
#include <epm/EPMTask.hxx>

#include <epm/libepm_exports.h>

namespace Teamcenter
{
    class EPMValidateTask;
}
namespace Teamcenter
{
    class EPMValidateTaskImpl;
}
namespace Teamcenter
{
    class EPMValidateTaskDelegate;
}
namespace Teamcenter
{
    class EPMValidateTaskDispatch;
}
namespace Teamcenter
{
    class EPMValidateTaskGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EPM_API  Teamcenter::EPMValidateTask
     : public  ::Teamcenter::EPMTask
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    EPMValidateTask();

    /**
     * Destructor
     */
    virtual ~EPMValidateTask();

private:
    //  Getter method for the Implementation Object
    EPMValidateTaskImpl*  getEPMValidateTaskImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setEPMValidateTaskImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    EPMValidateTaskImpl*  m_epmvalidatetaskImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param EPMValidateTask - desc for EPMValidateTask parameter
     */
    EPMValidateTask( const EPMValidateTask& );
    EPMValidateTask& operator=( const EPMValidateTask& );

    friend class  EPMValidateTaskDelegate;
    friend class  EPMValidateTaskDispatch;
    friend class  EPMValidateTaskGenImpl;
};

#include <epm/libepm_undef.h>
#endif //   TEAMCENTER__EPMVALIDATETASK__HXX
