//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EPMValidateTaskTemplate
    Filename:   EPMValidateTaskTemplate.hxx
    Module:     epm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EPMVALIDATETASKTEMPLATE__HXX
#define TEAMCENTER__EPMVALIDATETASKTEMPLATE__HXX

#include <common/tc_deprecation_macros.h>
#include <epm/EPMTaskTemplate.hxx>

#include <epm/libepm_exports.h>

namespace Teamcenter
{
    class EPMValidateTaskTemplate;
}
namespace Teamcenter
{
    class EPMValidateTaskTemplateImpl;
}
namespace Teamcenter
{
    class EPMValidateTaskTemplateDelegate;
}
namespace Teamcenter
{
    class EPMValidateTaskTemplateDispatch;
}
namespace Teamcenter
{
    class EPMValidateTaskTemplateGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EPM_API  Teamcenter::EPMValidateTaskTemplate
     : public  ::Teamcenter::EPMTaskTemplate
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    EPMValidateTaskTemplate();

    /**
     * Destructor
     */
    virtual ~EPMValidateTaskTemplate();

private:
    //  Getter method for the Implementation Object
    EPMValidateTaskTemplateImpl*  getEPMValidateTaskTemplateImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setEPMValidateTaskTemplateImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    EPMValidateTaskTemplateImpl*  m_epmvalidatetasktemplateImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param EPMValidateTaskTemplate - desc for EPMValidateTaskTemplate parameter
     */
    EPMValidateTaskTemplate( const EPMValidateTaskTemplate& );
    EPMValidateTaskTemplate& operator=( const EPMValidateTaskTemplate& );

    friend class  EPMValidateTaskTemplateDelegate;
    friend class  EPMValidateTaskTemplateDispatch;
    friend class  EPMValidateTaskTemplateGenImpl;
};

#include <epm/libepm_undef.h>
#endif //   TEAMCENTER__EPMVALIDATETASKTEMPLATE__HXX
