//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0EPMTaskProxyLink
    Filename:   Fnd0EPMTaskProxyLink.hxx
    Module:     epm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0EPMTASKPROXYLINK__HXX
#define TEAMCENTER__FND0EPMTASKPROXYLINK__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <wproxy/ProxyLink.hxx>

#include <epm/libepm_exports.h>

namespace Teamcenter
{
    class Fnd0EPMTaskProxyLink;
}
namespace Teamcenter
{
    class Fnd0EPMTaskProxyLinkImpl;
}
namespace Teamcenter
{
    class Fnd0EPMTaskProxyLinkDelegate;
}
namespace Teamcenter
{
    class Fnd0EPMTaskProxyLinkDispatch;
}
namespace Teamcenter
{
    class Fnd0EPMTaskProxyLinkGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EPM_API  Teamcenter::Fnd0EPMTaskProxyLink
     : public  ::Teamcenter::ProxyLink
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Setter for a Date Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0DueDate( const date_t &value, bool isNull=false );

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0State( int value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0EPMTaskProxyLink();

    /**
     * Destructor
     */
    virtual ~Fnd0EPMTaskProxyLink();

private:
    //  Getter method for the Implementation Object
    Fnd0EPMTaskProxyLinkImpl*  getFnd0EPMTaskProxyLinkImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0EPMTaskProxyLinkImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0EPMTaskProxyLinkImpl*  m_fnd0epmtaskproxylinkImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0EPMTaskProxyLink - desc for Fnd0EPMTaskProxyLink parameter
     */
    Fnd0EPMTaskProxyLink( const Fnd0EPMTaskProxyLink& );
    Fnd0EPMTaskProxyLink& operator=( const Fnd0EPMTaskProxyLink& );

    friend class  Fnd0EPMTaskProxyLinkDelegate;
    friend class  Fnd0EPMTaskProxyLinkDispatch;
    friend class  Fnd0EPMTaskProxyLinkGenImpl;
};

#include <epm/libepm_undef.h>
#endif //   TEAMCENTER__FND0EPMTASKPROXYLINK__HXX
