//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0TaskPathNamesLOVDelegate
    Filename:   Fnd0TaskPathNamesLOVDelegate.hxx
    Module:     epm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0TASKPATHNAMESLOVDELEGATE_HXX
#define TEAMCENTER__FND0TASKPATHNAMESLOVDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <epm/Fnd0TaskPathNamesLOV.hxx>

#include <epm/libepm_exports.h>

namespace Teamcenter
{
    class Fnd0TaskPathNamesLOVDelegate;
}
namespace Teamcenter
{
    class Fnd0TaskPathNamesLOVImpl;
}
namespace Teamcenter
{
    class Fnd0TaskPathNamesLOV;
}
namespace Teamcenter
{
    class Fnd0TaskPathNamesLOVGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  EPM_API Teamcenter_alias::Fnd0TaskPathNamesLOVDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0TaskPathNamesLOVDelegate instance
    static Fnd0TaskPathNamesLOVDelegate&  getInstance();

    //  Method to create the Fnd0TaskPathNamesLOVImpl pointer
    static Fnd0TaskPathNamesLOVImpl*  createImpl( Fnd0TaskPathNamesLOV&  ifObj );

    //  Method to delete the Fnd0TaskPathNamesLOVImpl pointer
    static void deleteImpl( Fnd0TaskPathNamesLOVImpl*  impl );


    ///
    /// Returns List Of Values based on Dynamic LOV definition and user search criteria.
    /// @version Teamcenter 10
    /// @param operationInputTag - Operation Input containing the modified values.
    /// @param propertyName - Name of the selected property.
    /// @param searchString - User entered search string.
    /// @param sortByProp - Property to use for sorting.
    /// @param sortOrder - order for sorting (0=Ascending, 1=Descending).
    /// @param nResults - Number of returned results.
    /// @param results - Returned Values for LOV.
    /// @return - Zero (0) if everything is alright otherwise the error code.
    ///
    int  fnd0askLOVValuesBase(const Fnd0TaskPathNamesLOV &ifObj,  const tag_t operationInputTag, const std::string *propertyName, const std::string *searchString, const char *sortByProp, const int sortOrder, int *nResults, tag_t **results ) const;


    ///
    /// Returns true if the input value is valid for the Dynamic LOV.
    /// @version Teamcenter 10
    /// @param operationInputTag - Operation Input containing the modified values.
    /// @param propertyName - Name of the selected property.
    /// @param value - Value to validate.
    /// @param verdict - true if value is valid.
    /// @return - Zero (0) if everything is alright otherwise the error code.
    ///
    int  fnd0isValueValidBase(const Fnd0TaskPathNamesLOV &ifObj,  const tag_t operationInputTag, const std::string *propertyName, const std::string *value, bool *verdict ) const;



protected:
    //  Pointer to the instance
    static Fnd0TaskPathNamesLOVDelegate*  m_pInstance;

    Fnd0TaskPathNamesLOVDelegate();
    virtual ~Fnd0TaskPathNamesLOVDelegate();
    static void setInstance( Fnd0TaskPathNamesLOVDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0TaskPathNamesLOVGenImpl;

};

#include <epm/libepm_undef.h>
#endif  //  TEAMCENTER__FND0TASKPATHNAMESLOVDELEGATE_HXX
