//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ParticipantDelegate
    Filename:   ParticipantDelegate.hxx
    Module:     epm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PARTICIPANTDELEGATE_HXX
#define TEAMCENTER__PARTICIPANTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <epm/Participant.hxx>

#include <epm/libepm_exports.h>

namespace Teamcenter
{
    class ParticipantDelegate;
}
namespace Teamcenter
{
    class ParticipantImpl;
}
namespace Teamcenter
{
    class Participant;
}
namespace Teamcenter
{
    class ParticipantGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  EPM_API Teamcenter_alias::ParticipantDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ParticipantDelegate instance
    static ParticipantDelegate&  getInstance();

    //  Method to create the ParticipantImpl pointer
    static ParticipantImpl*  createImpl( Participant&  ifObj );

    //  Method to delete the ParticipantImpl pointer
    static void deleteImpl( ParticipantImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAssigneeBase(const Participant &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0AssigneeGroupBase(const Participant &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for Property Display Value
    /// @version Teamcenter 11.2
    /// @param values - Parameter value
    /// @return - Status. 0 if successful
    ///
    int  getFnd0AssigneeGroupDisplayableValuesBase(Participant &ifObj,  std::vector< std::string > &values );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0AssigneeGroupRoleBase(const Participant &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0AssigneeRoleBase(const Participant &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for Property Display Value
    /// @version Teamcenter 11.2
    /// @param values - Parameter value
    /// @return - Status. 0 if successful
    ///
    int  getFnd0AssigneeRoleDisplayableValuesBase(Participant &ifObj,  std::vector< std::string > &values );


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAssigneeBase(Participant &ifObj,  const tag_t &value, bool isNull );


    ///
    /// This operation determines if the participant is assignable.
    /// @version Tc 8
    /// @param user - A user tag
    /// @param object - An object tag
    /// @param assignable - A pointer to a boolean whose value, when returned, is the result of the evaluation
    /// @return - An ifail integer
    ///
    int  isAssignableBase(const Participant &ifObj,  tag_t user, tag_t object, bool *assignable );



protected:
    //  Pointer to the instance
    static ParticipantDelegate*  m_pInstance;

    ParticipantDelegate();
    virtual ~ParticipantDelegate();
    static void setInstance( ParticipantDelegate*  instance );


private:
    friend class  ::Teamcenter::ParticipantGenImpl;

};

#include <epm/libepm_undef.h>
#endif  //  TEAMCENTER__PARTICIPANTDELEGATE_HXX
