//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ProposedResponsibleParty
    Filename:   ProposedResponsibleParty.hxx
    Module:     epm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROPOSEDRESPONSIBLEPARTY__HXX
#define TEAMCENTER__PROPOSEDRESPONSIBLEPARTY__HXX

#include <common/tc_deprecation_macros.h>
#include <epm/Participant.hxx>

#include <epm/libepm_exports.h>

namespace Teamcenter
{
    class ProposedResponsibleParty;
}
namespace Teamcenter
{
    class ProposedResponsiblePartyImpl;
}
namespace Teamcenter
{
    class ProposedResponsiblePartyDelegate;
}
namespace Teamcenter
{
    class ProposedResponsiblePartyDispatch;
}
namespace Teamcenter
{
    class ProposedResponsiblePartyGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EPM_API  Teamcenter::ProposedResponsibleParty
     : public  ::Teamcenter::Participant
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ProposedResponsibleParty();

    /**
     * Destructor
     */
    virtual ~ProposedResponsibleParty();

private:
    //  Getter method for the Implementation Object
    ProposedResponsiblePartyImpl*  getProposedResponsiblePartyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setProposedResponsiblePartyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ProposedResponsiblePartyImpl*  m_proposedresponsiblepartyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ProposedResponsibleParty - desc for ProposedResponsibleParty parameter
     */
    ProposedResponsibleParty( const ProposedResponsibleParty& );
    ProposedResponsibleParty& operator=( const ProposedResponsibleParty& );

    friend class  ProposedResponsiblePartyDelegate;
    friend class  ProposedResponsiblePartyDispatch;
    friend class  ProposedResponsiblePartyGenImpl;
};

#include <epm/libepm_undef.h>
#endif //   TEAMCENTER__PROPOSEDRESPONSIBLEPARTY__HXX
