//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ProposedReviewer
    Filename:   ProposedReviewer.hxx
    Module:     epm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROPOSEDREVIEWER__HXX
#define TEAMCENTER__PROPOSEDREVIEWER__HXX

#include <common/tc_deprecation_macros.h>
#include <epm/Participant.hxx>

#include <epm/libepm_exports.h>

namespace Teamcenter
{
    class ProposedReviewer;
}
namespace Teamcenter
{
    class ProposedReviewerImpl;
}
namespace Teamcenter
{
    class ProposedReviewerDelegate;
}
namespace Teamcenter
{
    class ProposedReviewerDispatch;
}
namespace Teamcenter
{
    class ProposedReviewerGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EPM_API  Teamcenter::ProposedReviewer
     : public  ::Teamcenter::Participant
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ProposedReviewer();

    /**
     * Destructor
     */
    virtual ~ProposedReviewer();

private:
    //  Getter method for the Implementation Object
    ProposedReviewerImpl*  getProposedReviewerImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setProposedReviewerImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ProposedReviewerImpl*  m_proposedreviewerImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ProposedReviewer - desc for ProposedReviewer parameter
     */
    ProposedReviewer( const ProposedReviewer& );
    ProposedReviewer& operator=( const ProposedReviewer& );

    friend class  ProposedReviewerDelegate;
    friend class  ProposedReviewerDispatch;
    friend class  ProposedReviewerGenImpl;
};

#include <epm/libepm_undef.h>
#endif //   TEAMCENTER__PROPOSEDREVIEWER__HXX
