//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ResourcePool
    Filename:   ResourcePool.hxx
    Module:     epm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__RESOURCEPOOL__HXX
#define TEAMCENTER__RESOURCEPOOL__HXX

#include <common/tc_deprecation_macros.h>
#include <cxpom/POM_system_class.hxx>

#include <epm/libepm_exports.h>

namespace Teamcenter
{
    class ResourcePool;
}
namespace Teamcenter
{
    class ResourcePoolImpl;
}
namespace Teamcenter
{
    class ResourcePoolDelegate;
}
namespace Teamcenter
{
    class ResourcePoolDispatch;
}
namespace Teamcenter
{
    class ResourcePoolGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EPM_API  Teamcenter::ResourcePool
     : public  ::Teamcenter::POM_system_class
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Boolean Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAll_members( bool &value, bool &isNull ) const;

    ///
    /// Setter for a Boolean Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAll_members( bool value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ResourcePool();

    /**
     * Destructor
     */
    virtual ~ResourcePool();

private:
    //  Getter method for the Implementation Object
    ResourcePoolImpl*  getResourcePoolImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setResourcePoolImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ResourcePoolImpl*  m_resourcepoolImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ResourcePool - desc for ResourcePool parameter
     */
    ResourcePool( const ResourcePool& );
    ResourcePool& operator=( const ResourcePool& );

    friend class  ResourcePoolDelegate;
    friend class  ResourcePoolDispatch;
    friend class  ResourcePoolGenImpl;
};

#include <epm/libepm_undef.h>
#endif //   TEAMCENTER__RESOURCEPOOL__HXX
