//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ResourcePoolDelegate
    Filename:   ResourcePoolDelegate.hxx
    Module:     epm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__RESOURCEPOOLDELEGATE_HXX
#define TEAMCENTER__RESOURCEPOOLDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <epm/ResourcePool.hxx>

#include <epm/libepm_exports.h>

namespace Teamcenter
{
    class ResourcePoolDelegate;
}
namespace Teamcenter
{
    class ResourcePoolImpl;
}
namespace Teamcenter
{
    class ResourcePool;
}
namespace Teamcenter
{
    class ResourcePoolGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  EPM_API Teamcenter_alias::ResourcePoolDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ResourcePoolDelegate instance
    static ResourcePoolDelegate&  getInstance();

    //  Method to create the ResourcePoolImpl pointer
    static ResourcePoolImpl*  createImpl( ResourcePool&  ifObj );

    //  Method to delete the ResourcePoolImpl pointer
    static void deleteImpl( ResourcePoolImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAll_membersBase(const ResourcePool &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Setter for a Boolean Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAll_membersBase(ResourcePool &ifObj,  bool value, bool isNull );



protected:
    //  Pointer to the instance
    static ResourcePoolDelegate*  m_pInstance;

    ResourcePoolDelegate();
    virtual ~ResourcePoolDelegate();
    static void setInstance( ResourcePoolDelegate*  instance );


private:
    friend class  ::Teamcenter::ResourcePoolGenImpl;

};

#include <epm/libepm_undef.h>
#endif  //  TEAMCENTER__RESOURCEPOOLDELEGATE_HXX
