//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TaskInbox
    Filename:   TaskInbox.hxx
    Module:     epm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TASKINBOX__HXX
#define TEAMCENTER__TASKINBOX__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tc/Folder.hxx>

#include <epm/libepm_exports.h>

namespace Teamcenter
{
    class TaskInbox;
}
namespace Teamcenter
{
    class TaskInboxImpl;
}
namespace Teamcenter
{
    class TaskInboxDelegate;
}
namespace Teamcenter
{
    class TaskInboxDispatch;
}
namespace Teamcenter
{
    class TaskInboxGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EPM_API  Teamcenter::TaskInbox
     : public  ::Teamcenter::Folder
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ScheduleTasks( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0SubscriptionMessage( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getNew_tasks_count( int &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getNew_tasks_flag( bool &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    TaskInbox();

    /**
     * Destructor
     */
    virtual ~TaskInbox();

private:
    //  Getter method for the Implementation Object
    TaskInboxImpl*  getTaskInboxImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTaskInboxImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    TaskInboxImpl*  m_taskinboxImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param TaskInbox - desc for TaskInbox parameter
     */
    TaskInbox( const TaskInbox& );
    TaskInbox& operator=( const TaskInbox& );

    friend class  TaskInboxDelegate;
    friend class  TaskInboxDispatch;
    friend class  TaskInboxGenImpl;
};

#include <epm/libepm_undef.h>
#endif //   TEAMCENTER__TASKINBOX__HXX
