//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TaskType
    Filename:   TaskType.hxx
    Module:     epm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TASKTYPE__HXX
#define TEAMCENTER__TASKTYPE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <epm/libepm_exports.h>

namespace Teamcenter
{
    class TaskType;
}
namespace Teamcenter
{
    class TaskTypeImpl;
}
namespace Teamcenter
{
    class TaskTypeDelegate;
}
namespace Teamcenter
{
    class TaskTypeDispatch;
}
namespace Teamcenter
{
    class TaskTypeGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EPM_API  Teamcenter::TaskType
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    TaskType();

    /**
     * Destructor
     */
    virtual ~TaskType();

private:
    //  Getter method for the Implementation Object
    TaskTypeImpl*  getTaskTypeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTaskTypeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    TaskTypeImpl*  m_tasktypeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param TaskType - desc for TaskType parameter
     */
    TaskType( const TaskType& );
    TaskType& operator=( const TaskType& );

    friend class  TaskTypeDelegate;
    friend class  TaskTypeDispatch;
    friend class  TaskTypeGenImpl;
};

#include <epm/libepm_undef.h>
#endif //   TEAMCENTER__TASKTYPE__HXX
