//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CallbackFunction
    Filename:   CallbackFunction.hxx
    Module:     extensionframework
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CALLBACKFUNCTION__HXX
#define TEAMCENTER__CALLBACKFUNCTION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <extensionframework/libextensionframework_exports.h>

namespace Teamcenter
{
    class CallbackFunction;
}
namespace Teamcenter
{
    class CallbackFunctionImpl;
}
namespace Teamcenter
{
    class CallbackFunctionDelegate;
}
namespace Teamcenter
{
    class CallbackFunctionDispatch;
}
namespace Teamcenter
{
    class CallbackFunctionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  EXTENSIONFRAMEWORK_API  Teamcenter::CallbackFunction
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CallbackFunction();

    /**
     * Destructor
     */
    virtual ~CallbackFunction();

private:
    //  Getter method for the Implementation Object
    CallbackFunctionImpl*  getCallbackFunctionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCallbackFunctionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CallbackFunctionImpl*  m_callbackfunctionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CallbackFunction - desc for CallbackFunction parameter
     */
    CallbackFunction( const CallbackFunction& );
    CallbackFunction& operator=( const CallbackFunction& );

    friend class  CallbackFunctionDelegate;
    friend class  CallbackFunctionDispatch;
    friend class  CallbackFunctionGenImpl;
};

#include <extensionframework/libextensionframework_undef.h>
#endif //   TEAMCENTER__CALLBACKFUNCTION__HXX
