//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CallbackFunctionDelegate
    Filename:   CallbackFunctionDelegate.hxx
    Module:     extensionframework
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CALLBACKFUNCTIONDELEGATE_HXX
#define TEAMCENTER__CALLBACKFUNCTIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <extensionframework/CallbackFunction.hxx>

#include <extensionframework/libextensionframework_exports.h>

namespace Teamcenter
{
    class CallbackFunctionDelegate;
}
namespace Teamcenter
{
    class CallbackFunctionImpl;
}
namespace Teamcenter
{
    class CallbackFunction;
}
namespace Teamcenter
{
    class CallbackFunctionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  EXTENSIONFRAMEWORK_API Teamcenter_alias::CallbackFunctionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CallbackFunctionDelegate instance
    static CallbackFunctionDelegate&  getInstance();

    //  Method to create the CallbackFunctionImpl pointer
    static CallbackFunctionImpl*  createImpl( CallbackFunction&  ifObj );

    //  Method to delete the CallbackFunctionImpl pointer
    static void deleteImpl( CallbackFunctionImpl*  impl );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const CallbackFunction &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static CallbackFunctionDelegate*  m_pInstance;

    CallbackFunctionDelegate();
    virtual ~CallbackFunctionDelegate();
    static void setInstance( CallbackFunctionDelegate*  instance );


private:
    friend class  ::Teamcenter::CallbackFunctionGenImpl;

};

#include <extensionframework/libextensionframework_undef.h>
#endif  //  TEAMCENTER__CALLBACKFUNCTIONDELEGATE_HXX
