/*==================================================================================================

                    Copyright (c) 2007 UGS
                             Unpublished - All rights reserved

====================================================================================================
File description:

    Filename: getDateArrayOperationDispatcher.hxx
    Module  : extensionframework

    This is the root interface class of the getDateArrayOperationDispatcher. It contains of all the generic methods
    for getDateArrayOperationDispatcher that can be reused by the derived classes.

====================================================================================================
   Date      Name                    Description of Change
$HISTORY$
==================================================================================================*/
#ifndef getDateArrayOperationDispatcher_HXX
#define getDateArrayOperationDispatcher_HXX

#include <extensionframework/PropOperationDispatcher.hxx>
#include <extensionframework/libextensionframework_exports.h>

namespace Teamcenter
{
    class getDateArrayOperationDispatcher;
    class PropOperationDispatcher;
}

class EXTENSIONFRAMEWORK_API Teamcenter::getDateArrayOperationDispatcher : public Teamcenter::PropOperationDispatcher
{
    public:
        getDateArrayOperationDispatcher();
        virtual ~getDateArrayOperationDispatcher();
        static OperationDispatcher *constructor();

        void executePreConditions( METHOD_message_t &  msg,  va_list  args ) const;
        void executePreActions( METHOD_message_t &  msg,  va_list  args ) const;
        void executePostActions( METHOD_message_t &  msg,  va_list  args ) const;

        void getDateArrayPreConditions( const Teamcenter::BusinessObject* obj, std::vector<date_t>& dateValues, std::vector<int>& isNullValues ) const;
        void getDateArrayPreActions( const Teamcenter::BusinessObject* obj, std::vector<date_t>& dateValues, std::vector<int>& isNullValues ) const;
        void getDateArrayBaseAction( const Teamcenter::BusinessObject* obj, std::vector<date_t>& dateValues, std::vector<int>& isNullValues ) const;
        void getDateArrayPostActions( const Teamcenter::BusinessObject* obj, std::vector<date_t>& dateValues, std::vector<int>& isNullValues ) const;

        // Project 011450 changes
        void getDateArrayPreConditions( METHOD_message_t*  msgData, int* num, date_t** value, logical** isNull ) const;
        void getDateArrayPreActions( METHOD_message_t*  msgData, int* num, date_t** value, logical** isNull ) const;
        void getDateArrayBaseAction( METHOD_message_t*  msgData, int* num, date_t** value, logical** isNull ) const;
        void getDateArrayPostActions( METHOD_message_t*  msgData, int* num, date_t** value, logical** isNull ) const;

        void getDateArray( const Teamcenter::BusinessObject* obj, std::vector<date_t>& dateValues, std::vector<int>& isNullValues ) const;

        void execute( Teamcenter::BusinessObject* obj,  std::vector<void*>&  args ) const;
        void execute( tag_t objTag, va_list  args ) const;
        void execute( Teamcenter::BusinessObject* obj,  va_list  args  ) const;


        //Fix compiler warnings that were hiding virtual functions
        using Teamcenter::OperationDispatcher::executePreConditions;
        using Teamcenter::OperationDispatcher::executePreActions;
        using Teamcenter::OperationDispatcher::executePostActions;

};

#include <extensionframework/libextensionframework_undef.h>
#endif //getDateArrayOperationDispatcher_HXX
