/*==================================================================================================

                    Copyright (c) 2007 UGS
                             Unpublished - All rights reserved

====================================================================================================
File description:

    Filename: getLogicalArrayOperationDispatcher.hxx
    Module  : extensionframework

    This is the root interface class of the getLogicalArrayOperationDispatcher. It contains of all the generic methods
    for getLogicalArrayOperationDispatcher that can be reused by the derived classes.

====================================================================================================
   Date      Name                    Description of Change
$HISTORY$
==================================================================================================*/
#ifndef getLogicalArrayOperationDispatcher_HXX
#define getLogicalArrayOperationDispatcher_HXX

#include <extensionframework/PropOperationDispatcher.hxx>
#include <extensionframework/libextensionframework_exports.h>

namespace Teamcenter
{
    class getLogicalArrayOperationDispatcher;
    class PropOperationDispatcher;
}

class EXTENSIONFRAMEWORK_API Teamcenter::getLogicalArrayOperationDispatcher : public Teamcenter::PropOperationDispatcher
{
    public:
        getLogicalArrayOperationDispatcher();
        virtual ~getLogicalArrayOperationDispatcher();
        static OperationDispatcher *constructor();

        void executePreConditions( METHOD_message_t &  msg,  va_list  args ) const;
        void executePreActions( METHOD_message_t &  msg,  va_list  args ) const;
        void executePostActions( METHOD_message_t &  msg,  va_list  args ) const;

        void getLogicalArrayPreConditions( const Teamcenter::BusinessObject* obj, std::vector<int>& boolValues, std::vector<int>& isNullValues ) const;
        void getLogicalArrayPreActions( const Teamcenter::BusinessObject* obj, std::vector<int>& boolValues, std::vector<int>& isNullValues ) const;
        void getLogicalArrayBaseAction( const Teamcenter::BusinessObject* obj, std::vector<int>& boolValues, std::vector<int>& isNullValues ) const;
        void getLogicalArrayPostActions( const Teamcenter::BusinessObject* obj, std::vector<int>& boolValues, std::vector<int>& isNullValues ) const;

        // Project 011450 changes
        void getLogicalArrayPreConditions( METHOD_message_t*  msgData, int* num, logical** value, logical** isNull ) const;
        void getLogicalArrayPreActions( METHOD_message_t*  msgData, int* num, logical** value, logical** isNull ) const;
        void getLogicalArrayBaseAction( METHOD_message_t*  msgData, int* num, logical** value, logical** isNull ) const;
        void getLogicalArrayPostActions( METHOD_message_t*  msgData, int* num, logical** value, logical** isNull ) const;

        void getLogicalArray( const Teamcenter::BusinessObject* obj, std::vector<int>& boolValues, std::vector<int>& isNullValues ) const;

        void execute( Teamcenter::BusinessObject* obj,  std::vector<void*>&  args ) const;
        void execute( tag_t objTag, va_list  args ) const;
        void execute( Teamcenter::BusinessObject* obj,  va_list  args  ) const;


        //Fix compiler warnings that were hiding virtual functions
        using Teamcenter::OperationDispatcher::executePreConditions;
        using Teamcenter::OperationDispatcher::executePreActions;
        using Teamcenter::OperationDispatcher::executePostActions;

};

#include <extensionframework/libextensionframework_undef.h>
#endif //getLogicalArrayOperationDispatcher_HXX
