/*==================================================================================================

                    Copyright (c) 2007 UGS
                             Unpublished - All rights reserved

====================================================================================================
File description:

    Filename: getStringArrayOperationDispatcher.hxx
    Module  : extensionframework

    This is the root interface class of the getStringArrayOperationDispatcher. It contains of all the generic methods
    for getStringArrayOperationDispatcher that can be reused by the derived classes.

====================================================================================================
   Date      Name                    Description of Change
$HISTORY$
==================================================================================================*/
#ifndef getStringArrayOperationDispatcher_HXX
#define getStringArrayOperationDispatcher_HXX

#include <extensionframework/PropOperationDispatcher.hxx>
#include <extensionframework/libextensionframework_exports.h>

namespace Teamcenter
{
    class getStringArrayOperationDispatcher;
    class PropOperationDispatcher;
}

class EXTENSIONFRAMEWORK_API Teamcenter::getStringArrayOperationDispatcher : public Teamcenter::PropOperationDispatcher
{
    public:
        getStringArrayOperationDispatcher();
        virtual ~getStringArrayOperationDispatcher();
        static OperationDispatcher *constructor();

        void executePreConditions( METHOD_message_t &  msg,  va_list  args ) const;
        void executePreActions( METHOD_message_t &  msg,  va_list  args ) const;
        void executePostActions( METHOD_message_t &  msg,  va_list  args ) const;

        void getStringArrayPreConditions( const Teamcenter::BusinessObject* obj, std::vector<std::string>& stringValues, std::vector<int>& isNullValues ) const;
        void getStringArrayPreActions( const Teamcenter::BusinessObject* obj, std::vector<std::string>& stringValues, std::vector<int>& isNullValues ) const;
        void getStringArrayBaseAction( const Teamcenter::BusinessObject* obj, std::vector<std::string>& stringValues, std::vector<int>& isNullValues ) const;
        void getStringArrayPostActions( const Teamcenter::BusinessObject* obj, std::vector<std::string>& stringValues, std::vector<int>& isNullValues ) const;

        // Project 011450 changes
        void getStringArrayPreConditions( METHOD_message_t*  msgData, int* num, char*** value, logical** isNull ) const;
        void getStringArrayPreActions( METHOD_message_t*  msgData, int* num, char*** value, logical** isNull ) const;
        void getStringArrayBaseAction( METHOD_message_t*  msgData, int* num, char*** value, logical** isNull ) const;
        void getStringArrayPostActions( METHOD_message_t*  msgData, int* num, char*** value, logical** isNull ) const;

        void getStringArray( const Teamcenter::BusinessObject* obj, std::vector<std::string>& stringValues, std::vector<int>& isNullValues ) const;

        void execute( Teamcenter::BusinessObject* obj,  std::vector<void*>&  args ) const;
        void execute( tag_t objTag, va_list  args ) const;
        void execute( Teamcenter::BusinessObject* obj,  va_list  args  ) const;


        //Fix compiler warnings that were hiding virtual functions
        using Teamcenter::OperationDispatcher::executePreConditions;
        using Teamcenter::OperationDispatcher::executePreActions;
        using Teamcenter::OperationDispatcher::executePostActions;

};

#include <extensionframework/libextensionframework_undef.h>
#endif //getStringArrayOperationDispatcher_HXX
