/*==================================================================================================

                    Copyright (c) 2007 UGS
                             Unpublished - All rights reserved

====================================================================================================
File description:

    Filename: getStringOperationDispatcher.hxx
    Module  : extensionframework

    This is the root interface class of the getStringOperationDispatcher. It contains of all the generic methods
    for getStringOperationDispatcher that can be reused by the derived classes.

====================================================================================================
   Date      Name                    Description of Change
$HISTORY$
==================================================================================================*/
#ifndef getStringOperationDispatcher_HXX
#define getStringOperationDispatcher_HXX

#include <extensionframework/PropOperationDispatcher.hxx>
#include <extensionframework/libextensionframework_exports.h>

namespace Teamcenter
{
    class getStringOperationDispatcher;
    class PropOperationDispatcher;
}

class EXTENSIONFRAMEWORK_API Teamcenter::getStringOperationDispatcher : public Teamcenter::PropOperationDispatcher
{
    public:
        getStringOperationDispatcher();
        virtual ~getStringOperationDispatcher();
        static OperationDispatcher *constructor();

        void executePreConditions( METHOD_message_t &  msg,  va_list  args ) const;
        void executePreActions( METHOD_message_t &  msg,  va_list  args ) const;
        void executePostActions( METHOD_message_t &  msg,  va_list  args ) const;

        void getStringPreConditions( const Teamcenter::BusinessObject* obj, std::string& value, bool& isNull ) const;
        void getStringPreActions( const Teamcenter::BusinessObject* obj, std::string& value, bool& isNull ) const;
        void getStringBaseAction( const Teamcenter::BusinessObject* obj, std::string& value, bool& isNull ) const;
        void getStringPostActions( const Teamcenter::BusinessObject* obj, std::string& value, bool& isNull ) const;

        // Project 011450 changes
        void getStringPreConditions( METHOD_message_t*  msgData, char** value, logical* isNull ) const;
        void getStringPreActions( METHOD_message_t*  msgData, char** value, logical* isNull ) const;
        void getStringBaseAction( METHOD_message_t*  msgData, char** value, logical* isNull ) const;
        void getStringPostActions( METHOD_message_t*  msgData, char** value, logical* isNull ) const;

        void getString( const Teamcenter::BusinessObject* obj, std::string& value, bool& isNull ) const;

        void execute( Teamcenter::BusinessObject* obj,  std::vector<void*>&  args ) const;
        void execute( tag_t objTag, va_list  args ) const;
        void execute( Teamcenter::BusinessObject* obj,  va_list  args  ) const;


        //Fix compiler warnings that were hiding virtual functions
        using Teamcenter::OperationDispatcher::executePreConditions;
        using Teamcenter::OperationDispatcher::executePreActions;
        using Teamcenter::OperationDispatcher::executePostActions;

};

#include <extensionframework/libextensionframework_undef.h>
#endif //getStringOperationDispatcher_HXX
