/*==================================================================================================

                    Copyright (c) 2007 UGS
                             Unpublished - All rights reserved

====================================================================================================
File description:

    Filename: getTagOperationDispatcher.hxx
    Module  : extensionframework

    This is the root interface class of the getTagOperationDispatcher. It contains of all the generic methods
    for getTagOperationDispatcher that can be reused by the derived classes.

====================================================================================================
   Date      Name                    Description of Change
$HISTORY$
==================================================================================================*/
#ifndef getTagOperationDispatcher_HXX
#define getTagOperationDispatcher_HXX

#include <extensionframework/PropOperationDispatcher.hxx>
#include <extensionframework/libextensionframework_exports.h>

namespace Teamcenter
{
    class getTagOperationDispatcher;
    class PropOperationDispatcher;
}

class EXTENSIONFRAMEWORK_API Teamcenter::getTagOperationDispatcher : public Teamcenter::PropOperationDispatcher
{
    public:
        getTagOperationDispatcher();
        virtual ~getTagOperationDispatcher();
        static OperationDispatcher *constructor();

        void executePreConditions( METHOD_message_t &  msg,  va_list  args ) const;
        void executePreActions( METHOD_message_t &  msg,  va_list  args ) const;
        void executePostActions( METHOD_message_t &  msg,  va_list  args ) const;

        void getTagPreConditions( const Teamcenter::BusinessObject* obj, tag_t& tagValue, bool& isNull ) const;
        void getTagPreActions( const Teamcenter::BusinessObject* obj, tag_t& tagValue, bool& isNull ) const;
        void getTagBaseAction( const Teamcenter::BusinessObject* obj, tag_t& tagValue, bool& isNull ) const;
        void getTagPostActions( const Teamcenter::BusinessObject* obj, tag_t& tagValue, bool& isNull ) const;

        // Project 011450 changes
        void getTagPreConditions( METHOD_message_t*  msgData, tag_t* value, logical* isNull ) const;
        void getTagPreActions( METHOD_message_t*  msgData, tag_t* value, logical* isNull ) const;
        void getTagBaseAction( METHOD_message_t*  msgData, tag_t* value, logical* isNull ) const;
        void getTagPostActions( METHOD_message_t*  msgData, tag_t* value, logical* isNull ) const;

        void getTag( const Teamcenter::BusinessObject* obj, tag_t& tagValue, bool& isNull ) const;

        void execute( Teamcenter::BusinessObject* obj,  std::vector<void*>&  args ) const;
        void execute( tag_t objTag, va_list  args ) const;
        void execute( Teamcenter::BusinessObject* obj,  va_list  args  ) const;


        //Fix compiler warnings that were hiding virtual functions
        using Teamcenter::OperationDispatcher::executePreConditions;
        using Teamcenter::OperationDispatcher::executePreActions;
        using Teamcenter::OperationDispatcher::executePostActions;

};

#include <extensionframework/libextensionframework_undef.h>
#endif //getTagOperationDispatcher_HXX
