//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  extensionframework

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libextensionframework

#if !defined(LIBEXTENSIONFRAMEWORK) && !defined(IPLIB)
#   error IPLIB or LIBEXTENSIONFRAMEWORK is not defined
#endif

/* Handwritten code should use EXTENSIONFRAMEWORK_API, not EXTENSIONFRAMEWORKEXPORT */

#define EXTENSIONFRAMEWORK_API EXTENSIONFRAMEWORKEXPORT

#if IPLIB==libextensionframework || defined(LIBEXTENSIONFRAMEWORK)
#   if defined(__lint)
#       define EXTENSIONFRAMEWORKEXPORT       __export(extensionframework)
#       define EXTENSIONFRAMEWORKGLOBAL       extern __global(extensionframework)
#       define EXTENSIONFRAMEWORKPRIVATE      extern __private(extensionframework)
#   elif defined(_WIN32)
#       define EXTENSIONFRAMEWORKEXPORT       __declspec(dllexport)
#       define EXTENSIONFRAMEWORKGLOBAL       extern __declspec(dllexport)
#       define EXTENSIONFRAMEWORKPRIVATE      extern
#   else
#       define EXTENSIONFRAMEWORKEXPORT
#       define EXTENSIONFRAMEWORKGLOBAL       extern
#       define EXTENSIONFRAMEWORKPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define EXTENSIONFRAMEWORKEXPORT       __export(extensionframework)
#       define EXTENSIONFRAMEWORKGLOBAL       extern __global(extensionframework)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define EXTENSIONFRAMEWORKEXPORT      __declspec(dllimport)
#       define EXTENSIONFRAMEWORKGLOBAL       extern __declspec(dllimport)
#   else
#       define EXTENSIONFRAMEWORKEXPORT
#       define EXTENSIONFRAMEWORKGLOBAL       extern
#   endif
#endif
