/*==================================================================================================

Copyright (c) 2007 UGS
Unpublished - All rights reserved

====================================================================================================
File description:

Filename: setCharArrayOperationDispatcher.hxx
Module  : extensionframework

This is the root interface class of the setCharArrayOperationDispatcher. It contains of all the generic methods
for setCharArrayOperationDispatcher that can be reused by the derived classes.

====================================================================================================
Date      Name                    Description of Change
$HISTORY$
==================================================================================================*/
#ifndef setCharArrayOperationDispatcher_HXX
#define setCharArrayOperationDispatcher_HXX

#include <extensionframework/PropOperationDispatcher.hxx>
#include <extensionframework/libextensionframework_exports.h>

namespace Teamcenter
{
    class setCharArrayOperationDispatcher;
    class PropOperationDispatcher;
}

class EXTENSIONFRAMEWORK_API Teamcenter::setCharArrayOperationDispatcher : public Teamcenter::PropOperationDispatcher
{
public:
    setCharArrayOperationDispatcher();
    virtual ~setCharArrayOperationDispatcher();
    static OperationDispatcher *constructor();

    void executePreConditions( METHOD_message_t &  msg,  va_list  args ) const;
    void executePreActions( METHOD_message_t &  msg,  va_list  args ) const;
    void executePostActions( METHOD_message_t &  msg,  va_list  args ) const;

    void setCharArrayPreConditions( Teamcenter::BusinessObject* obj, const std::vector<char>& charValues,  const std::vector<int>* isNullVals ) const;
    void setCharArrayPreActions( Teamcenter::BusinessObject* obj, const std::vector<char>& charValues,  const std::vector<int>* isNullVals  ) const;
    void setCharArrayBaseAction( Teamcenter::BusinessObject* obj, const std::vector<char>& charValues,  const std::vector<int>* isNullVals  ) const;
    void setCharArrayPostActions( Teamcenter::BusinessObject* obj, const std::vector<char>& charValues,  const std::vector<int>* isNullVals  ) const;

    // Project 011450 changes
    void setCharArrayPreConditions( METHOD_message_t* msgData, int num, const char* charValues,  const logical* isNullVals ) const;
    void setCharArrayPreActions( METHOD_message_t* msgData, int num, const char* charValues,  const logical* isNullVals ) const;
    void setCharArrayPostActions( METHOD_message_t* msgData, int num, const char* charValues,  const logical* isNullVals ) const;
    void setCharArrayBaseAction( METHOD_message_t* msgData, int num, const char* charValues,  const logical* isNullVals ) const;


    void setCharArray( Teamcenter::BusinessObject* obj, const std::vector<char>& charValues,  const std::vector<int>* isNullVals  ) const;

    void execute(Teamcenter::BusinessObject* obj,  std::vector<void*>&  args ) const;
    void execute( tag_t objTag, va_list  args ) const;
    void execute( Teamcenter::BusinessObject* obj,  va_list  args  ) const;


    //Fix compiler warnings that were hiding virtual functions
    using Teamcenter::OperationDispatcher::executePreConditions;
    using Teamcenter::OperationDispatcher::executePreActions;
    using Teamcenter::OperationDispatcher::executePostActions;

};

#include <extensionframework/libextensionframework_undef.h>
#endif //setCharArrayOperationDispatcher_HXX
