/*==================================================================================================

                    Copyright (c) 2007 UGS
                             Unpublished - All rights reserved

====================================================================================================
File description:

    Filename: setDoubleOperationDispatcher.hxx
    Module  : extensionframework

    This is the root interface class of the setDoubleOperationDispatcher. It contains of all the generic methods
    for setDoubleOperationDispatcher that can be reused by the derived classes.

====================================================================================================
   Date      Name                    Description of Change
$HISTORY$
==================================================================================================*/
#ifndef setDoubleOperationDispatcher_HXX
#define setDoubleOperationDispatcher_HXX

#include <extensionframework/PropOperationDispatcher.hxx>
#include <extensionframework/libextensionframework_exports.h>

namespace Teamcenter
{
    class setDoubleOperationDispatcher;
    class PropOperationDispatcher;
}

class EXTENSIONFRAMEWORK_API Teamcenter::setDoubleOperationDispatcher : public Teamcenter::PropOperationDispatcher
{
    public:
        setDoubleOperationDispatcher();
        virtual ~setDoubleOperationDispatcher();
        static OperationDispatcher *constructor();

    void executePreConditions( METHOD_message_t &  msg,  va_list  args ) const;
    void executePreActions( METHOD_message_t &  msg,  va_list  args ) const;
    void executePostActions( METHOD_message_t &  msg,  va_list  args ) const;

    void setDoublePreConditions( Teamcenter::BusinessObject* obj, const double doubleValue, const bool isNull ) const;
    void setDoublePreActions( Teamcenter::BusinessObject* obj, const double doubleValue, const bool isNull ) const;
    void setDoubleBaseAction( Teamcenter::BusinessObject* obj, const double doubleValue, const bool isNull ) const;
    void setDoublePostActions( Teamcenter::BusinessObject* obj, const double doubleValue, const bool isNull ) const;

    // Project 011450 changes
    void setDoublePreConditions( METHOD_message_t* msgData, const double doubleValue, const logical isNull ) const;
    void setDoublePreActions( METHOD_message_t* msgData, const double doubleValue, const logical isNull ) const;
    void setDoublePostActions( METHOD_message_t* msgData, const double doubleValue, const logical isNull ) const;
    void setDoubleBaseAction( METHOD_message_t* msgData, const double doubleValue, const logical isNull ) const;


    void setDouble( Teamcenter::BusinessObject* obj, const double doubleValue, const bool isNull ) const;

    void execute(Teamcenter::BusinessObject* obj,  std::vector<void*>&  args ) const;
    void execute( tag_t objTag, va_list  args ) const;
    void execute( Teamcenter::BusinessObject* obj,  va_list  args  ) const;


    //Fix compiler warnings that were hiding virtual functions
    using Teamcenter::OperationDispatcher::executePreConditions;
    using Teamcenter::OperationDispatcher::executePreActions;
    using Teamcenter::OperationDispatcher::executePostActions;

};

#include <extensionframework/libextensionframework_undef.h>
#endif //setDoubleOperationDispatcher_HXX
