/*==================================================================================================

Copyright (c) 2007 UGS
Unpublished - All rights reserved

====================================================================================================
File description:

Filename: setIntArrayOperationDispatcher.hxx
Module  : extensionframework

This is the root interface class of the setIntArrayOperationDispatcher. It contains of all the generic methods
for setIntArrayOperationDispatcher that can be reused by the derived classes.

====================================================================================================
Date      Name                    Description of Change
$HISTORY$
==================================================================================================*/
#ifndef setIntArrayOperationDispatcher_HXX
#define setIntArrayOperationDispatcher_HXX

#include <extensionframework/PropOperationDispatcher.hxx>
#include <extensionframework/libextensionframework_exports.h>

namespace Teamcenter
{
    class setIntArrayOperationDispatcher;
    class PropOperationDispatcher;
}

class EXTENSIONFRAMEWORK_API Teamcenter::setIntArrayOperationDispatcher : public Teamcenter::PropOperationDispatcher
{
public:
    setIntArrayOperationDispatcher();
    virtual ~setIntArrayOperationDispatcher();
    static OperationDispatcher *constructor();

    void executePreConditions( METHOD_message_t &  msg,  va_list  args ) const;
    void executePreActions( METHOD_message_t &  msg,  va_list  args ) const;
    void executePostActions( METHOD_message_t &  msg,  va_list  args ) const;

    void setIntArrayPreConditions( Teamcenter::BusinessObject* obj, const std::vector<int>& intValues,  const std::vector<int>* isNullVals ) const;
    void setIntArrayPreActions( Teamcenter::BusinessObject* obj, const std::vector<int>& intValues,  const std::vector<int>* isNullVals  ) const;
    void setIntArrayBaseAction( Teamcenter::BusinessObject* obj, const std::vector<int>& intValues,  const std::vector<int>* isNullVals  ) const;
    void setIntArrayPostActions( Teamcenter::BusinessObject* obj, const std::vector<int>& intValues,  const std::vector<int>* isNullVals  ) const;

    // Project 011450 changes
    void setIntArrayPreConditions( METHOD_message_t* msgData, int num, const int* intValues,  const logical* isNullVals ) const;
    void setIntArrayPreActions( METHOD_message_t* msgData, int num, const int* intValues,  const logical* isNullVals ) const;
    void setIntArrayPostActions( METHOD_message_t* msgData, int num, const int* intValues,  const logical* isNullVals ) const;
    void setIntArrayBaseAction( METHOD_message_t* msgData, int num, const int* intValues,  const logical* isNullVals ) const;

    void setIntArray( Teamcenter::BusinessObject* obj, const std::vector<int>& intValues,  const std::vector<int>* isNullVals  ) const;

    void execute(Teamcenter::BusinessObject* obj,  std::vector<void*>&  args ) const;
    void execute( tag_t objTag, va_list  args ) const;
    void execute( Teamcenter::BusinessObject* obj,  va_list  args  ) const;


    //Fix compiler warnings that were hiding virtual functions
    using Teamcenter::OperationDispatcher::executePreConditions;
    using Teamcenter::OperationDispatcher::executePreActions;
    using Teamcenter::OperationDispatcher::executePostActions;

};

#include <extensionframework/libextensionframework_undef.h>
#endif //setIntArrayOperationDispatcher_HXX
