/*==================================================================================================

Copyright (c) 2007 UGS
Unpublished - All rights reserved

====================================================================================================
File description:

Filename: setStringOperationDispatcher.hxx
Module  : extensionframework

This is the root interface class of the setStringOperationDispatcher. It contains of all the generic methods
for setStringOperationDispatcher that can be reused by the derived classes.

====================================================================================================
   Date      Name                    Description of Change
22-Oct-2008     Krzysztof Blaszczyk     Parameter value made const reference in setStringPreConditions(), StringPreActions(), setStringPostActions() and setString()
$HISTORY$
==================================================================================================*/
#ifndef setStringOperationDispatcher_HXX
#define setStringOperationDispatcher_HXX

#include <extensionframework/PropOperationDispatcher.hxx>
#include <extensionframework/libextensionframework_exports.h>

namespace Teamcenter
{
    class setStringOperationDispatcher;
    class PropOperationDispatcher;
}

class EXTENSIONFRAMEWORK_API Teamcenter::setStringOperationDispatcher : public Teamcenter::PropOperationDispatcher
{
public:
    setStringOperationDispatcher();
    virtual ~setStringOperationDispatcher();
    static OperationDispatcher *constructor();

    void executePreConditions( METHOD_message_t &  msg,  va_list  args ) const;
    void executePreActions( METHOD_message_t &  msg,  va_list  args ) const;
    void executePostActions( METHOD_message_t &  msg,  va_list  args ) const;

    void setStringPreConditions( Teamcenter::BusinessObject* obj, const std::string& value, const bool isNull ) const;
    void setStringPreActions( Teamcenter::BusinessObject* obj, const std::string& value, const bool isNull ) const;
    void setStringBaseAction( Teamcenter::BusinessObject* obj, const std::string& value, const bool isNull ) const;
    void setStringPostActions( Teamcenter::BusinessObject* obj, const std::string& value, const bool isNull ) const;

    // Project 011450 changes
    void setStringPreConditions( METHOD_message_t* msgData, const char* value, const logical isNull ) const;
    void setStringPreActions( METHOD_message_t* msgData, const char* value, const logical isNull ) const;
    void setStringPostActions( METHOD_message_t* msgData, const char* value, const logical isNull ) const;
    void setStringBaseAction( METHOD_message_t* msgData, const char* value, const logical isNull ) const;

    void setString( Teamcenter::BusinessObject* obj, const std::string& value, const bool isNull ) const;

    void execute( Teamcenter::BusinessObject* obj, std::vector<void*>& args ) const;
    void execute( tag_t objTag, va_list args ) const;
    void execute( Teamcenter::BusinessObject* obj, va_list  args ) const;


    //Fix compiler warnings that were hiding virtual functions
    using Teamcenter::OperationDispatcher::execute;
    using Teamcenter::OperationDispatcher::executePreConditions;
    using Teamcenter::OperationDispatcher::executePreActions;
    using Teamcenter::OperationDispatcher::executePostActions;

};

#include <extensionframework/libextensionframework_undef.h>
#endif //setStringOperationDispatcher_HXX
