/*==================================================================================================

Copyright (c) 2007 UGS
Unpublished - All rights reserved

====================================================================================================
File description:

Filename: setTagArrayOperationDispatcher.hxx
Module  : extensionframework

This is the root interface class of the setTagArrayOperationDispatcher. It contains of all the generic methods
for setTagArrayOperationDispatcher that can be reused by the derived classes.

====================================================================================================
Date      Name                    Description of Change
$HISTORY$
==================================================================================================*/
#ifndef setTagArrayOperationDispatcher_HXX
#define setTagArrayOperationDispatcher_HXX

#include <extensionframework/PropOperationDispatcher.hxx>
#include <extensionframework/libextensionframework_exports.h>

namespace Teamcenter
{
    class setTagArrayOperationDispatcher;
    class PropOperationDispatcher;
}

class EXTENSIONFRAMEWORK_API Teamcenter::setTagArrayOperationDispatcher : public Teamcenter::PropOperationDispatcher
{
public:
    setTagArrayOperationDispatcher();
    virtual ~setTagArrayOperationDispatcher();
    static OperationDispatcher *constructor();

    void executePreConditions( METHOD_message_t &  msg,  va_list  args ) const;
    void executePreActions( METHOD_message_t &  msg,  va_list  args ) const;
    void executePostActions( METHOD_message_t &  msg,  va_list  args ) const;

    void setTagArrayPreConditions( Teamcenter::BusinessObject* obj, const std::vector<tag_t>& tagValues,  const std::vector<int>* isNullVals ) const;
    void setTagArrayPreActions( Teamcenter::BusinessObject* obj, const std::vector<tag_t>& tagValues,  const std::vector<int>* isNullVals  ) const;
    void setTagArrayBaseAction( Teamcenter::BusinessObject* obj, const std::vector<tag_t>& tagValues,  const std::vector<int>* isNullVals  ) const;
    void setTagArrayPostActions( Teamcenter::BusinessObject* obj, const std::vector<tag_t>& tagValues,  const std::vector<int>* isNullVals  ) const;

    // Project 011450 changes
    void setTagArrayPreConditions( METHOD_message_t* msgData, int num, const tag_t* tagValues,  const logical* isNullVals ) const;
    void setTagArrayPreActions( METHOD_message_t* msgData, int num, const tag_t* tagValues,  const logical* isNullVals ) const;
    void setTagArrayPostActions( METHOD_message_t* msgData, int num, const tag_t* tagValues,  const logical* isNullVals ) const;
    void setTagArrayBaseAction( METHOD_message_t* msgData, int num, const tag_t* tagValues,  const logical* isNullVals ) const;

    void setTagArray( Teamcenter::BusinessObject* obj, const std::vector<tag_t>& tagValues,  const std::vector<int>* isNullVals  ) const;

    void execute(Teamcenter::BusinessObject* obj,  std::vector<void*>&  args ) const;
    void execute( tag_t objTag, va_list  args ) const;
    void execute( Teamcenter::BusinessObject* obj,  va_list  args  ) const;


    //Fix compiler warnings that were hiding virtual functions
    using Teamcenter::OperationDispatcher::executePreConditions;
    using Teamcenter::OperationDispatcher::executePreActions;
    using Teamcenter::OperationDispatcher::executePostActions;

};

#include <extensionframework/libextensionframework_undef.h>
#endif //setTagArrayOperationDispatcher_HXX
