/*==================================================================================================

                                  Copyright (c) 2004 UGS
                             Unpublished - All rights reserved

====================================================================================================
File description:

    Filename: ResultCheck.hxx
    Module  : fclasses

    @file
    A temporary object to which ifail results can be assigned.
    If, once such has been assigned, the result turns out to be a failure,
    the class will throw an IFail.

    Intended usage:

        ResultStatus ok;
        try
        {
            ok = callSomeFunction();
            ok = callSomeOtherFunction(); // note: no need to check func results ;)
            ...
        }
        catch ( IFail& ifail )
        {
            // handle
        }
==================================================================================================

*/

#ifndef FCLASSES_RESULT_CHECK_HXX_INCLUDED
#define FCLASSES_RESULT_CHECK_HXX_INCLUDED

#include <common/tc_deprecation_macros.h>

/* @deprecated #fclasses/ResultCheck.hxx deprecated in Teamcenter 9.0. Use #base_utils/ResultCheck.hxx instead.
   <br/>The new format of inclusion is #include <base_utils/ResultCheck.hxx> instead of #include <fclasses/ResultCheck.hxx>.
*/
#define TC_include_fclasses_ResultCheck_hxx_deprecated 
TC_DEPRECATED_PREPROCESSOR( "9.0", TC_include_fclasses_ResultCheck_hxx_deprecated, "base_utils/ResultCheck.hxx" ) 
TC_include_fclasses_ResultCheck_hxx_deprecated // use the deprecated macro so that the compiler issues the deprecation warning

#include <base_utils/ResultCheck.hxx> // forward include the new file location

#endif // FCLASSES_RESULT_CHECK_HXX_INCLUDED
