//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0AbsActionItem
    Filename:   Fnd0AbsActionItem.hxx
    Module:     fnd0absactionitem
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0ABSACTIONITEM__HXX
#define TEAMCENTER__FND0ABSACTIONITEM__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <fnd0absactionitem/libfnd0absactionitem_exports.h>

namespace Teamcenter
{
    class Fnd0AbsActionItem;
}
namespace Teamcenter
{
    class Fnd0AbsActionItemImpl;
}
namespace Teamcenter
{
    class Fnd0AbsActionItemDelegate;
}
namespace Teamcenter
{
    class Fnd0AbsActionItemDispatch;
}
namespace Teamcenter
{
    class Fnd0AbsActionItemGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0ABSACTIONITEM_API  Teamcenter::Fnd0AbsActionItem
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0AbsActionItem();

    /**
     * Destructor
     */
    virtual ~Fnd0AbsActionItem();

private:
    //  Getter method for the Implementation Object
    Fnd0AbsActionItemImpl*  getFnd0AbsActionItemImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0AbsActionItemImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0AbsActionItemImpl*  m_fnd0absactionitemImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0AbsActionItem - desc for Fnd0AbsActionItem parameter
     */
    Fnd0AbsActionItem( const Fnd0AbsActionItem& );
    Fnd0AbsActionItem& operator=( const Fnd0AbsActionItem& );

    friend class  Fnd0AbsActionItemDelegate;
    friend class  Fnd0AbsActionItemDispatch;
    friend class  Fnd0AbsActionItemGenImpl;
};

#include <fnd0absactionitem/libfnd0absactionitem_undef.h>
#endif //   TEAMCENTER__FND0ABSACTIONITEM__HXX
