//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ConfigurationCNF
    Filename:   ConfigurationCNF.hxx
    Module:     fnd0booleansolve
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONFIGURATIONCNF__HXX
#define TEAMCENTER__CONFIGURATIONCNF__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <fnd0booleansolve/libfnd0booleansolve_exports.h>

namespace Teamcenter
{
    class ConfigurationCNF;
}
namespace Teamcenter
{
    class ConfigurationCNFImpl;
}
namespace Teamcenter
{
    class ConfigurationCNFDelegate;
}
namespace Teamcenter
{
    class ConfigurationCNFDispatch;
}
namespace Teamcenter
{
    class ConfigurationCNFGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0BOOLEANSOLVE_API  Teamcenter::ConfigurationCNF
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getClause_count( int &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getClause_literals( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for an Integer Array Property
    /// @version Teamcenter 8.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getClauseIDs( std::vector< int > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFingerprint( int &value, bool &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSequence( int &value, bool &isNull ) const;

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setClause_count( int value, bool isNull=false );

    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 8.3
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setClause_literals( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );

    ///
    /// Setter for an Integer Array Property
    /// @version Teamcenter 8.3
    /// @param values - Values to be set for the paramter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setClauseIDs( const std::vector< int > &values, const std::vector< int > *isNull=0 );

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFingerprint( int value, bool isNull=false );

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSequence( int value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ConfigurationCNF();

    /**
     * Destructor
     */
    virtual ~ConfigurationCNF();

private:
    //  Getter method for the Implementation Object
    ConfigurationCNFImpl*  getConfigurationCNFImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setConfigurationCNFImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ConfigurationCNFImpl*  m_configurationcnfImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ConfigurationCNF - desc for ConfigurationCNF parameter
     */
    ConfigurationCNF( const ConfigurationCNF& );
    ConfigurationCNF& operator=( const ConfigurationCNF& );

    friend class  ConfigurationCNFDelegate;
    friend class  ConfigurationCNFDispatch;
    friend class  ConfigurationCNFGenImpl;
};

#include <fnd0booleansolve/libfnd0booleansolve_undef.h>
#endif //   TEAMCENTER__CONFIGURATIONCNF__HXX
