//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ConfigurationCNFDelegate
    Filename:   ConfigurationCNFDelegate.hxx
    Module:     fnd0booleansolve
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONFIGURATIONCNFDELEGATE_HXX
#define TEAMCENTER__CONFIGURATIONCNFDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <fnd0booleansolve/ConfigurationCNF.hxx>

#include <fnd0booleansolve/libfnd0booleansolve_exports.h>

namespace Teamcenter
{
    class ConfigurationCNFDelegate;
}
namespace Teamcenter
{
    class ConfigurationCNFImpl;
}
namespace Teamcenter
{
    class ConfigurationCNF;
}
namespace Teamcenter
{
    class ConfigurationCNFGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  FND0BOOLEANSOLVE_API Teamcenter_alias::ConfigurationCNFDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ConfigurationCNFDelegate instance
    static ConfigurationCNFDelegate&  getInstance();

    //  Method to create the ConfigurationCNFImpl pointer
    static ConfigurationCNFImpl*  createImpl( ConfigurationCNF&  ifObj );

    //  Method to delete the ConfigurationCNFImpl pointer
    static void deleteImpl( ConfigurationCNFImpl*  impl );


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getClause_countBase(const ConfigurationCNF &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getClause_literalsBase(const ConfigurationCNF &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for an Integer Array Property
    /// @version Teamcenter 8.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getClauseIDsBase(const ConfigurationCNF &ifObj,  std::vector< int > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFingerprintBase(const ConfigurationCNF &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSequenceBase(const ConfigurationCNF &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setClause_countBase(ConfigurationCNF &ifObj,  int value, bool isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 8.3
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setClause_literalsBase(ConfigurationCNF &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for an Integer Array Property
    /// @version Teamcenter 8.3
    /// @param values - Values to be set for the paramter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setClauseIDsBase(ConfigurationCNF &ifObj,  const std::vector< int > &values, const std::vector< int > *isNull );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFingerprintBase(ConfigurationCNF &ifObj,  int value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSequenceBase(ConfigurationCNF &ifObj,  int value, bool isNull );



protected:
    //  Pointer to the instance
    static ConfigurationCNFDelegate*  m_pInstance;

    ConfigurationCNFDelegate();
    virtual ~ConfigurationCNFDelegate();
    static void setInstance( ConfigurationCNFDelegate*  instance );


private:
    friend class  ::Teamcenter::ConfigurationCNFGenImpl;

};

#include <fnd0booleansolve/libfnd0booleansolve_undef.h>
#endif  //  TEAMCENTER__CONFIGURATIONCNFDELEGATE_HXX
