//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ConfigurationExprLiteral
    Filename:   ConfigurationExprLiteral.hxx
    Module:     fnd0booleansolve
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONFIGURATIONEXPRLITERAL__HXX
#define TEAMCENTER__CONFIGURATIONEXPRLITERAL__HXX

#include <unidefs.h>
#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <fnd0booleansolve/libfnd0booleansolve_exports.h>

namespace Teamcenter
{
    class ConfigurationExprLiteral;
}
namespace Teamcenter
{
    class ConfigurationExprLiteralImpl;
}
namespace Teamcenter
{
    class ConfigurationExprLiteralDelegate;
}
namespace Teamcenter
{
    class ConfigurationExprLiteralDispatch;
}
namespace Teamcenter
{
    class ConfigurationExprLiteralGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0BOOLEANSOLVE_API  Teamcenter::ConfigurationExprLiteral
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFamily( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getOperator( int &value, bool &isNull ) const;

    ///
    /// Getter for a Date Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValue_date( date_t &value, bool &isNull ) const;

    ///
    /// Getter for a Double Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValue_numeric( double &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValue_text( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFamily( const tag_t &value, bool isNull=false );

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setOperator( int value, bool isNull=false );

    ///
    /// Setter for a Date Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValue_date( const date_t &value, bool isNull=false );

    ///
    /// Setter for a Double Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValue_numeric( double value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValue_text( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ConfigurationExprLiteral();

    /**
     * Destructor
     */
    virtual ~ConfigurationExprLiteral();

private:
    //  Getter method for the Implementation Object
    ConfigurationExprLiteralImpl*  getConfigurationExprLiteralImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setConfigurationExprLiteralImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ConfigurationExprLiteralImpl*  m_configurationexprliteralImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ConfigurationExprLiteral - desc for ConfigurationExprLiteral parameter
     */
    ConfigurationExprLiteral( const ConfigurationExprLiteral& );
    ConfigurationExprLiteral& operator=( const ConfigurationExprLiteral& );

    friend class  ConfigurationExprLiteralDelegate;
    friend class  ConfigurationExprLiteralDispatch;
    friend class  ConfigurationExprLiteralGenImpl;
};

#include <fnd0booleansolve/libfnd0booleansolve_undef.h>
#endif //   TEAMCENTER__CONFIGURATIONEXPRLITERAL__HXX
