//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ConfigurationExprLiteralDelegate
    Filename:   ConfigurationExprLiteralDelegate.hxx
    Module:     fnd0booleansolve
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONFIGURATIONEXPRLITERALDELEGATE_HXX
#define TEAMCENTER__CONFIGURATIONEXPRLITERALDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <fnd0booleansolve/ConfigurationExprLiteral.hxx>

#include <fnd0booleansolve/libfnd0booleansolve_exports.h>

namespace Teamcenter
{
    class ConfigurationExprLiteralDelegate;
}
namespace Teamcenter
{
    class ConfigurationExprLiteralImpl;
}
namespace Teamcenter
{
    class ConfigurationExprLiteral;
}
namespace Teamcenter
{
    class ConfigurationExprLiteralGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  FND0BOOLEANSOLVE_API Teamcenter_alias::ConfigurationExprLiteralDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ConfigurationExprLiteralDelegate instance
    static ConfigurationExprLiteralDelegate&  getInstance();

    //  Method to create the ConfigurationExprLiteralImpl pointer
    static ConfigurationExprLiteralImpl*  createImpl( ConfigurationExprLiteral&  ifObj );

    //  Method to delete the ConfigurationExprLiteralImpl pointer
    static void deleteImpl( ConfigurationExprLiteralImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFamilyBase(const ConfigurationExprLiteral &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getOperatorBase(const ConfigurationExprLiteral &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a Date Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValue_dateBase(const ConfigurationExprLiteral &ifObj,  date_t &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValue_numericBase(const ConfigurationExprLiteral &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValue_textBase(const ConfigurationExprLiteral &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFamilyBase(ConfigurationExprLiteral &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setOperatorBase(ConfigurationExprLiteral &ifObj,  int value, bool isNull );


    ///
    /// Setter for a Date Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValue_dateBase(ConfigurationExprLiteral &ifObj,  const date_t &value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValue_numericBase(ConfigurationExprLiteral &ifObj,  double value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValue_textBase(ConfigurationExprLiteral &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static ConfigurationExprLiteralDelegate*  m_pInstance;

    ConfigurationExprLiteralDelegate();
    virtual ~ConfigurationExprLiteralDelegate();
    static void setInstance( ConfigurationExprLiteralDelegate*  instance );


private:
    friend class  ::Teamcenter::ConfigurationExprLiteralGenImpl;

};

#include <fnd0booleansolve/libfnd0booleansolve_undef.h>
#endif  //  TEAMCENTER__CONFIGURATIONEXPRLITERALDELEGATE_HXX
