//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0EffectivityCritValidatnDelegate
    Filename:   Fnd0EffectivityCritValidatnDelegate.hxx
    Module:     fnd0booleansolve
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0EFFECTIVITYCRITVALIDATNDELEGATE_HXX
#define TEAMCENTER__FND0EFFECTIVITYCRITVALIDATNDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <fnd0booleansolve/Fnd0EffectivityCritValidatn.hxx>

#include <fnd0booleansolve/libfnd0booleansolve_exports.h>

namespace Teamcenter
{
    class Fnd0EffectivityCritValidatnDelegate;
}
namespace Teamcenter
{
    class Fnd0EffectivityCritValidatnImpl;
}
namespace Teamcenter
{
    class Fnd0EffectivityCritValidatn;
}
namespace Teamcenter
{
    class Fnd0EffectivityCritValidatnGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  FND0BOOLEANSOLVE_API Teamcenter_alias::Fnd0EffectivityCritValidatnDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0EffectivityCritValidatnDelegate instance
    static Fnd0EffectivityCritValidatnDelegate&  getInstance();

    //  Method to create the Fnd0EffectivityCritValidatnImpl pointer
    static Fnd0EffectivityCritValidatnImpl*  createImpl( Fnd0EffectivityCritValidatn&  ifObj );

    //  Method to delete the Fnd0EffectivityCritValidatnImpl pointer
    static void deleteImpl( Fnd0EffectivityCritValidatnImpl*  impl );


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0applied_defaultsBase(const Fnd0EffectivityCritValidatn &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0applied_to_exprBase(const Fnd0EffectivityCritValidatn &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0completeBase(const Fnd0EffectivityCritValidatn &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0is_partial_defaultBase(const Fnd0EffectivityCritValidatn &ifObj,  std::vector< int > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0product_nameBase(const Fnd0EffectivityCritValidatn &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0product_namespaceBase(const Fnd0EffectivityCritValidatn &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0restrictive_conditionsBase(const Fnd0EffectivityCritValidatn &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0unset_familiesBase(const Fnd0EffectivityCritValidatn &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0validBase(const Fnd0EffectivityCritValidatn &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0validation_errorsBase(const Fnd0EffectivityCritValidatn &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0validation_resultBase(const Fnd0EffectivityCritValidatn &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0violated_rulesBase(const Fnd0EffectivityCritValidatn &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 9
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0applied_defaultsBase(Fnd0EffectivityCritValidatn &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 9
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0applied_to_exprBase(Fnd0EffectivityCritValidatn &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0completeBase(Fnd0EffectivityCritValidatn &ifObj,  bool value, bool isNull );


    ///
    /// Setter for an Integer Array Property
    /// @version Teamcenter 9
    /// @param values - Values to be set for the paramter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0is_partial_defaultBase(Fnd0EffectivityCritValidatn &ifObj,  const std::vector< int > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0product_nameBase(Fnd0EffectivityCritValidatn &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0product_namespaceBase(Fnd0EffectivityCritValidatn &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 9
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0restrictive_conditionsBase(Fnd0EffectivityCritValidatn &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0unset_familiesBase(Fnd0EffectivityCritValidatn &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0validBase(Fnd0EffectivityCritValidatn &ifObj,  bool value, bool isNull );


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 9
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0validation_errorsBase(Fnd0EffectivityCritValidatn &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0validation_resultBase(Fnd0EffectivityCritValidatn &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 9
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0violated_rulesBase(Fnd0EffectivityCritValidatn &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );



protected:
    //  Pointer to the instance
    static Fnd0EffectivityCritValidatnDelegate*  m_pInstance;

    Fnd0EffectivityCritValidatnDelegate();
    virtual ~Fnd0EffectivityCritValidatnDelegate();
    static void setInstance( Fnd0EffectivityCritValidatnDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0EffectivityCritValidatnGenImpl;

};

#include <fnd0booleansolve/libfnd0booleansolve_undef.h>
#endif  //  TEAMCENTER__FND0EFFECTIVITYCRITVALIDATNDELEGATE_HXX
