//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0EffectivityCriteriaExpr
    Filename:   Fnd0EffectivityCriteriaExpr.hxx
    Module:     fnd0booleansolve
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0EFFECTIVITYCRITERIAEXPR__HXX
#define TEAMCENTER__FND0EFFECTIVITYCRITERIAEXPR__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <fnd0booleansolve/Fnd0EffectivityExpression.hxx>

#include <fnd0booleansolve/libfnd0booleansolve_exports.h>

namespace Teamcenter
{
    class Fnd0EffectivityCriteriaExpr;
}
namespace Teamcenter
{
    class Fnd0EffectivityCriteriaExprImpl;
}
namespace Teamcenter
{
    class Fnd0EffectivityCriteriaExprDelegate;
}
namespace Teamcenter
{
    class Fnd0EffectivityCriteriaExprDispatch;
}
namespace Teamcenter
{
    class Fnd0EffectivityCriteriaExprGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0BOOLEANSOLVE_API  Teamcenter::Fnd0EffectivityCriteriaExpr
     : public  ::Teamcenter::Fnd0EffectivityExpression
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0solve_type( int &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0validation_records( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0solve_type( int value, bool isNull=false );

    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0validation_records( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0EffectivityCriteriaExpr();

    /**
     * Destructor
     */
    virtual ~Fnd0EffectivityCriteriaExpr();

private:
    //  Getter method for the Implementation Object
    Fnd0EffectivityCriteriaExprImpl*  getFnd0EffectivityCriteriaExprImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0EffectivityCriteriaExprImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0EffectivityCriteriaExprImpl*  m_fnd0effectivitycriteriaexprImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0EffectivityCriteriaExpr - desc for Fnd0EffectivityCriteriaExpr parameter
     */
    Fnd0EffectivityCriteriaExpr( const Fnd0EffectivityCriteriaExpr& );
    Fnd0EffectivityCriteriaExpr& operator=( const Fnd0EffectivityCriteriaExpr& );

    friend class  Fnd0EffectivityCriteriaExprDelegate;
    friend class  Fnd0EffectivityCriteriaExprDispatch;
    friend class  Fnd0EffectivityCriteriaExprGenImpl;
};

#include <fnd0booleansolve/libfnd0booleansolve_undef.h>
#endif //   TEAMCENTER__FND0EFFECTIVITYCRITERIAEXPR__HXX
