//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0EffectivityCriteriaExprDelegate
    Filename:   Fnd0EffectivityCriteriaExprDelegate.hxx
    Module:     fnd0booleansolve
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0EFFECTIVITYCRITERIAEXPRDELEGATE_HXX
#define TEAMCENTER__FND0EFFECTIVITYCRITERIAEXPRDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <fnd0booleansolve/Fnd0EffectivityCriteriaExpr.hxx>

#include <fnd0booleansolve/libfnd0booleansolve_exports.h>

namespace Teamcenter
{
    class Fnd0EffectivityCriteriaExprDelegate;
}
namespace Teamcenter
{
    class Fnd0EffectivityCriteriaExprImpl;
}
namespace Teamcenter
{
    class Fnd0EffectivityCriteriaExpr;
}
namespace Teamcenter
{
    class Fnd0EffectivityCriteriaExprGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  FND0BOOLEANSOLVE_API Teamcenter_alias::Fnd0EffectivityCriteriaExprDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0EffectivityCriteriaExprDelegate instance
    static Fnd0EffectivityCriteriaExprDelegate&  getInstance();

    //  Method to create the Fnd0EffectivityCriteriaExprImpl pointer
    static Fnd0EffectivityCriteriaExprImpl*  createImpl( Fnd0EffectivityCriteriaExpr&  ifObj );

    //  Method to delete the Fnd0EffectivityCriteriaExprImpl pointer
    static void deleteImpl( Fnd0EffectivityCriteriaExprImpl*  impl );


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0solve_typeBase(const Fnd0EffectivityCriteriaExpr &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0validation_recordsBase(const Fnd0EffectivityCriteriaExpr &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0solve_typeBase(Fnd0EffectivityCriteriaExpr &ifObj,  int value, bool isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0validation_recordsBase(Fnd0EffectivityCriteriaExpr &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );



protected:
    //  Pointer to the instance
    static Fnd0EffectivityCriteriaExprDelegate*  m_pInstance;

    Fnd0EffectivityCriteriaExprDelegate();
    virtual ~Fnd0EffectivityCriteriaExprDelegate();
    static void setInstance( Fnd0EffectivityCriteriaExprDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0EffectivityCriteriaExprGenImpl;

};

#include <fnd0booleansolve/libfnd0booleansolve_undef.h>
#endif  //  TEAMCENTER__FND0EFFECTIVITYCRITERIAEXPRDELEGATE_HXX
