//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0EffectivityExprBlockDelegate
    Filename:   Fnd0EffectivityExprBlockDelegate.hxx
    Module:     fnd0booleansolve
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0EFFECTIVITYEXPRBLOCKDELEGATE_HXX
#define TEAMCENTER__FND0EFFECTIVITYEXPRBLOCKDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <fnd0booleansolve/Fnd0EffectivityExprBlock.hxx>

#include <fnd0booleansolve/libfnd0booleansolve_exports.h>

namespace Teamcenter
{
    class Fnd0EffectivityExprBlockDelegate;
}
namespace Teamcenter
{
    class Fnd0EffectivityExprBlockImpl;
}
namespace Teamcenter
{
    class Fnd0EffectivityExprBlock;
}
namespace Teamcenter
{
    class Fnd0EffectivityExprBlockGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  FND0BOOLEANSOLVE_API Teamcenter_alias::Fnd0EffectivityExprBlockDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0EffectivityExprBlockDelegate instance
    static Fnd0EffectivityExprBlockDelegate&  getInstance();

    //  Method to create the Fnd0EffectivityExprBlockImpl pointer
    static Fnd0EffectivityExprBlockImpl*  createImpl( Fnd0EffectivityExprBlock&  ifObj );

    //  Method to delete the Fnd0EffectivityExprBlockImpl pointer
    static void deleteImpl( Fnd0EffectivityExprBlockImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0affectedObjectBase(const Fnd0EffectivityExprBlock &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0expressionsBase(const Fnd0EffectivityExprBlock &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0expressionsBase(Fnd0EffectivityExprBlock &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static Fnd0EffectivityExprBlockDelegate*  m_pInstance;

    Fnd0EffectivityExprBlockDelegate();
    virtual ~Fnd0EffectivityExprBlockDelegate();
    static void setInstance( Fnd0EffectivityExprBlockDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0EffectivityExprBlockGenImpl;

};

#include <fnd0booleansolve/libfnd0booleansolve_undef.h>
#endif  //  TEAMCENTER__FND0EFFECTIVITYEXPRBLOCKDELEGATE_HXX
