//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0EffectivityExpressionDelegate
    Filename:   Fnd0EffectivityExpressionDelegate.hxx
    Module:     fnd0booleansolve
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0EFFECTIVITYEXPRESSIONDELEGATE_HXX
#define TEAMCENTER__FND0EFFECTIVITYEXPRESSIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <fnd0booleansolve/Fnd0EffectivityExpression.hxx>

#include <fnd0booleansolve/libfnd0booleansolve_exports.h>

namespace Teamcenter
{
    class Fnd0EffectivityExpressionDelegate;
}
namespace Teamcenter
{
    class Fnd0EffectivityExpressionImpl;
}
namespace Teamcenter
{
    class Fnd0EffectivityExpression;
}
namespace Teamcenter
{
    class Fnd0EffectivityExpressionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  FND0BOOLEANSOLVE_API Teamcenter_alias::Fnd0EffectivityExpressionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0EffectivityExpressionDelegate instance
    static Fnd0EffectivityExpressionDelegate&  getInstance();

    //  Method to create the Fnd0EffectivityExpressionImpl pointer
    static Fnd0EffectivityExpressionImpl*  createImpl( Fnd0EffectivityExpression&  ifObj );

    //  Method to delete the Fnd0EffectivityExpressionImpl pointer
    static void deleteImpl( Fnd0EffectivityExpressionImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0cnfsBase(const Fnd0EffectivityExpression &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0formulaBase(const Fnd0EffectivityExpression &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0formula_stateBase(const Fnd0EffectivityExpression &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0operatorBase(const Fnd0EffectivityExpression &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0product_nameBase(const Fnd0EffectivityExpression &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0product_namespaceBase(const Fnd0EffectivityExpression &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Fnd0EffectivityExpression &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Fnd0EffectivityExpression &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Fnd0EffectivityExpressionDelegate*  m_pInstance;

    Fnd0EffectivityExpressionDelegate();
    virtual ~Fnd0EffectivityExpressionDelegate();
    static void setInstance( Fnd0EffectivityExpressionDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0EffectivityExpressionGenImpl;

};

#include <fnd0booleansolve/libfnd0booleansolve_undef.h>
#endif  //  TEAMCENTER__FND0EFFECTIVITYEXPRESSIONDELEGATE_HXX
