//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ScopedCNF
    Filename:   Fnd0ScopedCNF.hxx
    Module:     fnd0booleansolve
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0SCOPEDCNF__HXX
#define TEAMCENTER__FND0SCOPEDCNF__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <fnd0booleansolve/libfnd0booleansolve_exports.h>

namespace Teamcenter
{
    class Fnd0ScopedCNF;
}
namespace Teamcenter
{
    class Fnd0ScopedCNFImpl;
}
namespace Teamcenter
{
    class Fnd0ScopedCNFDelegate;
}
namespace Teamcenter
{
    class Fnd0ScopedCNFDispatch;
}
namespace Teamcenter
{
    class Fnd0ScopedCNFGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0BOOLEANSOLVE_API  Teamcenter::Fnd0ScopedCNF
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0ScopedCNF();

    /**
     * Destructor
     */
    virtual ~Fnd0ScopedCNF();

private:
    //  Getter method for the Implementation Object
    Fnd0ScopedCNFImpl*  getFnd0ScopedCNFImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0ScopedCNFImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0ScopedCNFImpl*  m_fnd0scopedcnfImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0ScopedCNF - desc for Fnd0ScopedCNF parameter
     */
    Fnd0ScopedCNF( const Fnd0ScopedCNF& );
    Fnd0ScopedCNF& operator=( const Fnd0ScopedCNF& );

    friend class  Fnd0ScopedCNFDelegate;
    friend class  Fnd0ScopedCNFDispatch;
    friend class  Fnd0ScopedCNFGenImpl;
};

#include <fnd0booleansolve/libfnd0booleansolve_undef.h>
#endif //   TEAMCENTER__FND0SCOPEDCNF__HXX
