//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0VariantExprBlock
    Filename:   Fnd0VariantExprBlock.hxx
    Module:     fnd0booleansolve
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0VARIANTEXPRBLOCK__HXX
#define TEAMCENTER__FND0VARIANTEXPRBLOCK__HXX

#include <unidefs.h>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <fnd0booleansolve/libfnd0booleansolve_exports.h>

namespace Teamcenter
{
    class Fnd0VariantExprBlock;
}
namespace Teamcenter
{
    class Fnd0VariantExprBlockImpl;
}
namespace Teamcenter
{
    class Fnd0VariantExprBlockDelegate;
}
namespace Teamcenter
{
    class Fnd0VariantExprBlockDispatch;
}
namespace Teamcenter
{
    class Fnd0VariantExprBlockGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0BOOLEANSOLVE_API  Teamcenter::Fnd0VariantExprBlock
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0affectedObject( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0expressions( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0expressions( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0VariantExprBlock();

    /**
     * Destructor
     */
    virtual ~Fnd0VariantExprBlock();

private:
    //  Getter method for the Implementation Object
    Fnd0VariantExprBlockImpl*  getFnd0VariantExprBlockImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0VariantExprBlockImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0VariantExprBlockImpl*  m_fnd0variantexprblockImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0VariantExprBlock - desc for Fnd0VariantExprBlock parameter
     */
    Fnd0VariantExprBlock( const Fnd0VariantExprBlock& );
    Fnd0VariantExprBlock& operator=( const Fnd0VariantExprBlock& );

    friend class  Fnd0VariantExprBlockDelegate;
    friend class  Fnd0VariantExprBlockDispatch;
    friend class  Fnd0VariantExprBlockGenImpl;
};

#include <fnd0booleansolve/libfnd0booleansolve_undef.h>
#endif //   TEAMCENTER__FND0VARIANTEXPRBLOCK__HXX
