//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0VariantExprBlockDelegate
    Filename:   Fnd0VariantExprBlockDelegate.hxx
    Module:     fnd0booleansolve
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0VARIANTEXPRBLOCKDELEGATE_HXX
#define TEAMCENTER__FND0VARIANTEXPRBLOCKDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <fnd0booleansolve/Fnd0VariantExprBlock.hxx>

#include <fnd0booleansolve/libfnd0booleansolve_exports.h>

namespace Teamcenter
{
    class Fnd0VariantExprBlockDelegate;
}
namespace Teamcenter
{
    class Fnd0VariantExprBlockImpl;
}
namespace Teamcenter
{
    class Fnd0VariantExprBlock;
}
namespace Teamcenter
{
    class Fnd0VariantExprBlockGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  FND0BOOLEANSOLVE_API Teamcenter_alias::Fnd0VariantExprBlockDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0VariantExprBlockDelegate instance
    static Fnd0VariantExprBlockDelegate&  getInstance();

    //  Method to create the Fnd0VariantExprBlockImpl pointer
    static Fnd0VariantExprBlockImpl*  createImpl( Fnd0VariantExprBlock&  ifObj );

    //  Method to delete the Fnd0VariantExprBlockImpl pointer
    static void deleteImpl( Fnd0VariantExprBlockImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0affectedObjectBase(const Fnd0VariantExprBlock &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0expressionsBase(const Fnd0VariantExprBlock &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0expressionsBase(Fnd0VariantExprBlock &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );



protected:
    //  Pointer to the instance
    static Fnd0VariantExprBlockDelegate*  m_pInstance;

    Fnd0VariantExprBlockDelegate();
    virtual ~Fnd0VariantExprBlockDelegate();
    static void setInstance( Fnd0VariantExprBlockDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0VariantExprBlockGenImpl;

};

#include <fnd0booleansolve/libfnd0booleansolve_undef.h>
#endif  //  TEAMCENTER__FND0VARIANTEXPRBLOCKDELEGATE_HXX
