//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0VariantExpression
    Filename:   Fnd0VariantExpression.hxx
    Module:     fnd0booleansolve
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0VARIANTEXPRESSION__HXX
#define TEAMCENTER__FND0VARIANTEXPRESSION__HXX

#include <vector>
#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <fnd0booleansolve/libfnd0booleansolve_exports.h>

namespace Teamcenter
{
    class Fnd0VariantExpression;
}
namespace Teamcenter
{
    class Fnd0VariantExpressionImpl;
}
namespace Teamcenter
{
    class Fnd0VariantExpressionDelegate;
}
namespace Teamcenter
{
    class Fnd0VariantExpressionDispatch;
}
namespace Teamcenter
{
    class Fnd0VariantExpressionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FND0BOOLEANSOLVE_API  Teamcenter::Fnd0VariantExpression
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0cnfs( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0formula( std::string &value, bool &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0formula_state( int &value, bool &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0operator( int &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0product_name( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0product_namespace( std::string &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0VariantExpression();

    /**
     * Destructor
     */
    virtual ~Fnd0VariantExpression();

private:
    //  Getter method for the Implementation Object
    Fnd0VariantExpressionImpl*  getFnd0VariantExpressionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0VariantExpressionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0VariantExpressionImpl*  m_fnd0variantexpressionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0VariantExpression - desc for Fnd0VariantExpression parameter
     */
    Fnd0VariantExpression( const Fnd0VariantExpression& );
    Fnd0VariantExpression& operator=( const Fnd0VariantExpression& );

    friend class  Fnd0VariantExpressionDelegate;
    friend class  Fnd0VariantExpressionDispatch;
    friend class  Fnd0VariantExpressionGenImpl;
};

#include <fnd0booleansolve/libfnd0booleansolve_undef.h>
#endif //   TEAMCENTER__FND0VARIANTEXPRESSION__HXX
