//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0VariantExpressionDelegate
    Filename:   Fnd0VariantExpressionDelegate.hxx
    Module:     fnd0booleansolve
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0VARIANTEXPRESSIONDELEGATE_HXX
#define TEAMCENTER__FND0VARIANTEXPRESSIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <fnd0booleansolve/Fnd0VariantExpression.hxx>

#include <fnd0booleansolve/libfnd0booleansolve_exports.h>

namespace Teamcenter
{
    class Fnd0VariantExpressionDelegate;
}
namespace Teamcenter
{
    class Fnd0VariantExpressionImpl;
}
namespace Teamcenter
{
    class Fnd0VariantExpression;
}
namespace Teamcenter
{
    class Fnd0VariantExpressionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  FND0BOOLEANSOLVE_API Teamcenter_alias::Fnd0VariantExpressionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0VariantExpressionDelegate instance
    static Fnd0VariantExpressionDelegate&  getInstance();

    //  Method to create the Fnd0VariantExpressionImpl pointer
    static Fnd0VariantExpressionImpl*  createImpl( Fnd0VariantExpression&  ifObj );

    //  Method to delete the Fnd0VariantExpressionImpl pointer
    static void deleteImpl( Fnd0VariantExpressionImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0cnfsBase(const Fnd0VariantExpression &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0formulaBase(const Fnd0VariantExpression &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0formula_stateBase(const Fnd0VariantExpression &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0operatorBase(const Fnd0VariantExpression &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0product_nameBase(const Fnd0VariantExpression &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0product_namespaceBase(const Fnd0VariantExpression &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Fnd0VariantExpression &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Fnd0VariantExpression &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Fnd0VariantExpressionDelegate*  m_pInstance;

    Fnd0VariantExpressionDelegate();
    virtual ~Fnd0VariantExpressionDelegate();
    static void setInstance( Fnd0VariantExpressionDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0VariantExpressionGenImpl;

};

#include <fnd0booleansolve/libfnd0booleansolve_undef.h>
#endif  //  TEAMCENTER__FND0VARIANTEXPRESSIONDELEGATE_HXX
