//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  fnd0booleansolve

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libfnd0booleansolve

#if !defined(LIBFND0BOOLEANSOLVE) && !defined(IPLIB)
#   error IPLIB or LIBFND0BOOLEANSOLVE is not defined
#endif

/* Handwritten code should use FND0BOOLEANSOLVE_API, not FND0BOOLEANSOLVEEXPORT */

#define FND0BOOLEANSOLVE_API FND0BOOLEANSOLVEEXPORT

#if IPLIB==libfnd0booleansolve || defined(LIBFND0BOOLEANSOLVE)
#   if defined(__lint)
#       define FND0BOOLEANSOLVEEXPORT       __export(fnd0booleansolve)
#       define FND0BOOLEANSOLVEGLOBAL       extern __global(fnd0booleansolve)
#       define FND0BOOLEANSOLVEPRIVATE      extern __private(fnd0booleansolve)
#   elif defined(_WIN32)
#       define FND0BOOLEANSOLVEEXPORT       __declspec(dllexport)
#       define FND0BOOLEANSOLVEGLOBAL       extern __declspec(dllexport)
#       define FND0BOOLEANSOLVEPRIVATE      extern
#   else
#       define FND0BOOLEANSOLVEEXPORT
#       define FND0BOOLEANSOLVEGLOBAL       extern
#       define FND0BOOLEANSOLVEPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define FND0BOOLEANSOLVEEXPORT       __export(fnd0booleansolve)
#       define FND0BOOLEANSOLVEGLOBAL       extern __global(fnd0booleansolve)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define FND0BOOLEANSOLVEEXPORT      __declspec(dllimport)
#       define FND0BOOLEANSOLVEGLOBAL       extern __declspec(dllimport)
#   else
#       define FND0BOOLEANSOLVEEXPORT
#       define FND0BOOLEANSOLVEGLOBAL       extern
#   endif
#endif
