//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  fnshmgmtdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libfnshmgmtdispatch

#if !defined(LIBFNSHMGMTDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBFNSHMGMTDISPATCH is not defined
#endif

/* Handwritten code should use FNSHMGMTDISPATCH_API, not FNSHMGMTDISPATCHEXPORT */

#define FNSHMGMTDISPATCH_API FNSHMGMTDISPATCHEXPORT

#if IPLIB==libfnshmgmtdispatch || defined(LIBFNSHMGMTDISPATCH)
#   if defined(__lint)
#       define FNSHMGMTDISPATCHEXPORT       __export(fnshmgmtdispatch)
#       define FNSHMGMTDISPATCHGLOBAL       extern __global(fnshmgmtdispatch)
#       define FNSHMGMTDISPATCHPRIVATE      extern __private(fnshmgmtdispatch)
#   elif defined(_WIN32)
#       define FNSHMGMTDISPATCHEXPORT       __declspec(dllexport)
#       define FNSHMGMTDISPATCHGLOBAL       extern __declspec(dllexport)
#       define FNSHMGMTDISPATCHPRIVATE      extern
#   else
#       define FNSHMGMTDISPATCHEXPORT
#       define FNSHMGMTDISPATCHGLOBAL       extern
#       define FNSHMGMTDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define FNSHMGMTDISPATCHEXPORT       __export(fnshmgmtdispatch)
#       define FNSHMGMTDISPATCHGLOBAL       extern __global(fnshmgmtdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define FNSHMGMTDISPATCHEXPORT      __declspec(dllimport)
#       define FNSHMGMTDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define FNSHMGMTDISPATCHEXPORT
#       define FNSHMGMTDISPATCHGLOBAL       extern
#   endif
#endif
