//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Form
    Filename:   Form.hxx
    Module:     form
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FORM__HXX
#define TEAMCENTER__FORM__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <form/libform_exports.h>

namespace Teamcenter
{
    class Form;
}
namespace Teamcenter
{
    class FormImpl;
}
namespace Teamcenter
{
    class FormDelegate;
}
namespace Teamcenter
{
    class FormDispatch;
}
namespace Teamcenter
{
    class FormGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FORM_API  Teamcenter::Form
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Form();

    /**
     * Destructor
     */
    virtual ~Form();

private:
    //  Getter method for the Implementation Object
    FormImpl*  getFormImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFormImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    FormImpl*  m_formImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Form - desc for Form parameter
     */
    Form( const Form& );
    Form& operator=( const Form& );

    friend class  FormDelegate;
    friend class  FormDispatch;
    friend class  FormGenImpl;
};

#include <form/libform_undef.h>
#endif //   TEAMCENTER__FORM__HXX
