//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  form

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libform

#if !defined(LIBFORM) && !defined(IPLIB)
#   error IPLIB or LIBFORM is not defined
#endif

/* Handwritten code should use FORM_API, not FORMEXPORT */

#define FORM_API FORMEXPORT

#if IPLIB==libform || defined(LIBFORM)
#   if defined(__lint)
#       define FORMEXPORT       __export(form)
#       define FORMGLOBAL       extern __global(form)
#       define FORMPRIVATE      extern __private(form)
#   elif defined(_WIN32)
#       define FORMEXPORT       __declspec(dllexport)
#       define FORMGLOBAL       extern __declspec(dllexport)
#       define FORMPRIVATE      extern
#   else
#       define FORMEXPORT
#       define FORMGLOBAL       extern
#       define FORMPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define FORMEXPORT       __export(form)
#       define FORMGLOBAL       extern __global(form)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define FORMEXPORT      __declspec(dllimport)
#       define FORMGLOBAL       extern __declspec(dllimport)
#   else
#       define FORMEXPORT
#       define FORMGLOBAL       extern
#   endif
#endif
