//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AllocationDataDispatch
    Filename:   AllocationDataDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ALLOCATIONDATADISPATCH_HXX
#define TEAMCENTER__ALLOCATIONDATADISPATCH_HXX

#include <vector>
#include <mechatronics/AllocationData.hxx>
#include <mechatronics/AllocationDataDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class AllocationDataDispatch;
}
namespace Teamcenter
{
    class AllocationDataDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::AllocationDataDispatch
    : public  Teamcenter::AllocationDataDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the AllocationDataDispatch instance
    static AllocationDataDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static AllocationDataDispatch*  m_dispatch;

    //  Default Constructor
    AllocationDataDispatch();

    //  Default Destructor
    virtual ~AllocationDataDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a AllocationDataDispatch
    AllocationDataDispatch( const AllocationDataDispatch& );

    //  Assignment operator
    AllocationDataDispatch&  operator = ( const AllocationDataDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::AllocationDataDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__ALLOCATIONDATADISPATCH_HXX
