//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AllocationDispatch
    Filename:   AllocationDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ALLOCATIONDISPATCH_HXX
#define TEAMCENTER__ALLOCATIONDISPATCH_HXX

#include <vector>
#include <mechatronics/Allocation.hxx>
#include <mechatronics/AllocationDelegate.hxx>
#include <foundationdispatch/ManagedRelationDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class AllocationDispatch;
}
namespace Teamcenter
{
    class AllocationDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::AllocationDispatch
    : public  Teamcenter::AllocationDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the AllocationDispatch instance
    static AllocationDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static AllocationDispatch*  m_dispatch;

    //  Default Constructor
    AllocationDispatch();

    //  Default Destructor
    virtual ~AllocationDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a AllocationDispatch
    AllocationDispatch( const AllocationDispatch& );

    //  Assignment operator
    AllocationDispatch&  operator = ( const AllocationDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::AllocationDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__ALLOCATIONDISPATCH_HXX
