//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AllocationLineDispatch
    Filename:   AllocationLineDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ALLOCATIONLINEDISPATCH_HXX
#define TEAMCENTER__ALLOCATIONLINEDISPATCH_HXX

#include <vector>
#include <mechatronics/AllocationLine.hxx>
#include <mechatronics/AllocationLineDelegate.hxx>
#include <foundationdispatch/RuntimeBusinessObjectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class AllocationLineDispatch;
}
namespace Teamcenter
{
    class AllocationLineDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::AllocationLineDispatch
    : public  Teamcenter::AllocationLineDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the AllocationLineDispatch instance
    static AllocationLineDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static AllocationLineDispatch*  m_dispatch;

    //  Default Constructor
    AllocationLineDispatch();

    //  Default Destructor
    virtual ~AllocationLineDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a AllocationLineDispatch
    AllocationLineDispatch( const AllocationLineDispatch& );

    //  Assignment operator
    AllocationLineDispatch&  operator = ( const AllocationLineDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::AllocationLineDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__ALLOCATIONLINEDISPATCH_HXX
