//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AllocationMapDispatch
    Filename:   AllocationMapDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ALLOCATIONMAPDISPATCH_HXX
#define TEAMCENTER__ALLOCATIONMAPDISPATCH_HXX

#include <vector>
#include <mechatronics/AllocationMap.hxx>
#include <mechatronics/AllocationMapDelegate.hxx>
#include <foundationdispatch/ItemDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class AllocationMapDispatch;
}
namespace Teamcenter
{
    class AllocationMapDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::AllocationMapDispatch
    : public  Teamcenter::AllocationMapDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the AllocationMapDispatch instance
    static AllocationMapDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static AllocationMapDispatch*  m_dispatch;

    //  Default Constructor
    AllocationMapDispatch();

    //  Default Destructor
    virtual ~AllocationMapDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a AllocationMapDispatch
    AllocationMapDispatch( const AllocationMapDispatch& );

    //  Assignment operator
    AllocationMapDispatch&  operator = ( const AllocationMapDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::AllocationMapDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__ALLOCATIONMAPDISPATCH_HXX
