//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AllocationMapRevisionDispatch
    Filename:   AllocationMapRevisionDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ALLOCATIONMAPREVISIONDISPATCH_HXX
#define TEAMCENTER__ALLOCATIONMAPREVISIONDISPATCH_HXX

#include <vector>
#include <mechatronics/AllocationMapRevision.hxx>
#include <mechatronics/AllocationMapRevisionDelegate.hxx>
#include <foundationdispatch/ItemRevisionDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class AllocationMapRevisionDispatch;
}
namespace Teamcenter
{
    class AllocationMapRevisionDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::AllocationMapRevisionDispatch
    : public  Teamcenter::AllocationMapRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the AllocationMapRevisionDispatch instance
    static AllocationMapRevisionDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static AllocationMapRevisionDispatch*  m_dispatch;

    //  Default Constructor
    AllocationMapRevisionDispatch();

    //  Default Destructor
    virtual ~AllocationMapRevisionDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a AllocationMapRevisionDispatch
    AllocationMapRevisionDispatch( const AllocationMapRevisionDispatch& );

    //  Assignment operator
    AllocationMapRevisionDispatch&  operator = ( const AllocationMapRevisionDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::AllocationMapRevisionDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__ALLOCATIONMAPREVISIONDISPATCH_HXX
