//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AllocationWindowDispatch
    Filename:   AllocationWindowDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ALLOCATIONWINDOWDISPATCH_HXX
#define TEAMCENTER__ALLOCATIONWINDOWDISPATCH_HXX

#include <vector>
#include <mechatronics/AllocationWindow.hxx>
#include <mechatronics/AllocationWindowDelegate.hxx>
#include <foundationdispatch/RuntimeBusinessObjectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class AllocationWindowDispatch;
}
namespace Teamcenter
{
    class AllocationWindowDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::AllocationWindowDispatch
    : public  Teamcenter::AllocationWindowDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the AllocationWindowDispatch instance
    static AllocationWindowDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static AllocationWindowDispatch*  m_dispatch;

    //  Default Constructor
    AllocationWindowDispatch();

    //  Default Destructor
    virtual ~AllocationWindowDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a AllocationWindowDispatch
    AllocationWindowDispatch( const AllocationWindowDispatch& );

    //  Assignment operator
    AllocationWindowDispatch&  operator = ( const AllocationWindowDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::AllocationWindowDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__ALLOCATIONWINDOWDISPATCH_HXX
