//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AppearanceDispatch
    Filename:   AppearanceDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPEARANCEDISPATCH_HXX
#define TEAMCENTER__APPEARANCEDISPATCH_HXX

#include <vector>
#include <appr/Appearance.hxx>
#include <appr/AppearanceDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class AppearanceDispatch;
}
namespace Teamcenter
{
    class AppearanceDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::AppearanceDispatch
    : public  Teamcenter::AppearanceDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the AppearanceDispatch instance
    static AppearanceDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static AppearanceDispatch*  m_dispatch;

    //  Default Constructor
    AppearanceDispatch();

    //  Default Destructor
    virtual ~AppearanceDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a AppearanceDispatch
    AppearanceDispatch( const AppearanceDispatch& );

    //  Assignment operator
    AppearanceDispatch&  operator = ( const AppearanceDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::AppearanceDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__APPEARANCEDISPATCH_HXX
