//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ArchitectureDispatch
    Filename:   ArchitectureDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ARCHITECTUREDISPATCH_HXX
#define TEAMCENTER__ARCHITECTUREDISPATCH_HXX

#include <vector>
#include <rdv/Architecture.hxx>
#include <rdv/ArchitectureDelegate.hxx>
#include <foundationdispatch/ItemDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class ArchitectureDispatch;
}
namespace Teamcenter
{
    class ArchitectureDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::ArchitectureDispatch
    : public  Teamcenter::ArchitectureDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ArchitectureDispatch instance
    static ArchitectureDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static ArchitectureDispatch*  m_dispatch;

    //  Default Constructor
    ArchitectureDispatch();

    //  Default Destructor
    virtual ~ArchitectureDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a ArchitectureDispatch
    ArchitectureDispatch( const ArchitectureDispatch& );

    //  Assignment operator
    ArchitectureDispatch&  operator = ( const ArchitectureDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::ArchitectureDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__ARCHITECTUREDISPATCH_HXX
