//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ArchitectureRevisionDispatch
    Filename:   ArchitectureRevisionDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ARCHITECTUREREVISIONDISPATCH_HXX
#define TEAMCENTER__ARCHITECTUREREVISIONDISPATCH_HXX

#include <vector>
#include <rdv/ArchitectureRevision.hxx>
#include <rdv/ArchitectureRevisionDelegate.hxx>
#include <foundationdispatch/ItemRevisionDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class ArchitectureRevisionDispatch;
}
namespace Teamcenter
{
    class ArchitectureRevisionDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::ArchitectureRevisionDispatch
    : public  Teamcenter::ArchitectureRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ArchitectureRevisionDispatch instance
    static ArchitectureRevisionDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static ArchitectureRevisionDispatch*  m_dispatch;

    //  Default Constructor
    ArchitectureRevisionDispatch();

    //  Default Destructor
    virtual ~ArchitectureRevisionDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a ArchitectureRevisionDispatch
    ArchitectureRevisionDispatch( const ArchitectureRevisionDispatch& );

    //  Assignment operator
    ArchitectureRevisionDispatch&  operator = ( const ArchitectureRevisionDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::ArchitectureRevisionDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__ARCHITECTUREREVISIONDISPATCH_HXX
