//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AuthenticationDispatch
    Filename:   AuthenticationDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__AUTHENTICATIONDISPATCH_HXX
#define TEAMCENTER__AUTHENTICATIONDISPATCH_HXX

#include <vector>
#include <eint/Authentication.hxx>
#include <eint/AuthenticationDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class AuthenticationDispatch;
}
namespace Teamcenter
{
    class AuthenticationDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::AuthenticationDispatch
    : public  Teamcenter::AuthenticationDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the AuthenticationDispatch instance
    static AuthenticationDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static AuthenticationDispatch*  m_dispatch;

    //  Default Constructor
    AuthenticationDispatch();

    //  Default Destructor
    virtual ~AuthenticationDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a AuthenticationDispatch
    AuthenticationDispatch( const AuthenticationDispatch& );

    //  Assignment operator
    AuthenticationDispatch&  operator = ( const AuthenticationDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::AuthenticationDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__AUTHENTICATIONDISPATCH_HXX
