//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AuthorizationRuleDispatch
    Filename:   AuthorizationRuleDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__AUTHORIZATIONRULEDISPATCH_HXX
#define TEAMCENTER__AUTHORIZATIONRULEDISPATCH_HXX

#include <vector>
#include <tccore/AuthorizationRule.hxx>
#include <tccore/AuthorizationRuleDelegate.hxx>
#include <foundationdispatch/BusinessRuleDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class AuthorizationRuleDispatch;
}
namespace Teamcenter
{
    class AuthorizationRuleDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::AuthorizationRuleDispatch
    : public  Teamcenter::AuthorizationRuleDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the AuthorizationRuleDispatch instance
    static AuthorizationRuleDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static AuthorizationRuleDispatch*  m_dispatch;

    //  Default Constructor
    AuthorizationRuleDispatch();

    //  Default Destructor
    virtual ~AuthorizationRuleDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a AuthorizationRuleDispatch
    AuthorizationRuleDispatch( const AuthorizationRuleDispatch& );

    //  Assignment operator
    AuthorizationRuleDispatch&  operator = ( const AuthorizationRuleDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::AuthorizationRuleDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__AUTHORIZATIONRULEDISPATCH_HXX
