//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BOMWindowDispatch
    Filename:   BOMWindowDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOMWINDOWDISPATCH_HXX
#define TEAMCENTER__BOMWINDOWDISPATCH_HXX

#include <vector>
#include <bom/BOMWindow.hxx>
#include <bom/BOMWindowDelegate.hxx>
#include <foundationdispatch/RuntimeBusinessObjectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class BOMWindowDispatch;
}
namespace Teamcenter
{
    class BOMWindowDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::BOMWindowDispatch
    : public  Teamcenter::BOMWindowDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the BOMWindowDispatch instance
    static BOMWindowDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static BOMWindowDispatch*  m_dispatch;

    //  Default Constructor
    BOMWindowDispatch();

    //  Default Destructor
    virtual ~BOMWindowDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a BOMWindowDispatch
    BOMWindowDispatch( const BOMWindowDispatch& );

    //  Assignment operator
    BOMWindowDispatch&  operator = ( const BOMWindowDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::BOMWindowDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__BOMWINDOWDISPATCH_HXX
