//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BOPWindowDispatch
    Filename:   BOPWindowDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOPWINDOWDISPATCH_HXX
#define TEAMCENTER__BOPWINDOWDISPATCH_HXX

#include <vector>
#include <me/BOPWindow.hxx>
#include <me/BOPWindowDelegate.hxx>
#include <foundationdispatch/BOMWindowDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class BOPWindowDispatch;
}
namespace Teamcenter
{
    class BOPWindowDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::BOPWindowDispatch
    : public  Teamcenter::BOPWindowDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the BOPWindowDispatch instance
    static BOPWindowDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static BOPWindowDispatch*  m_dispatch;

    //  Default Constructor
    BOPWindowDispatch();

    //  Default Destructor
    virtual ~BOPWindowDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a BOPWindowDispatch
    BOPWindowDispatch( const BOPWindowDispatch& );

    //  Assignment operator
    BOPWindowDispatch&  operator = ( const BOPWindowDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::BOPWindowDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__BOPWINDOWDISPATCH_HXX
