//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BOSWindowDispatch
    Filename:   BOSWindowDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOSWINDOWDISPATCH_HXX
#define TEAMCENTER__BOSWINDOWDISPATCH_HXX

#include <vector>
#include <me/BOSWindow.hxx>
#include <me/BOSWindowDelegate.hxx>
#include <foundationdispatch/BOPWindowDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class BOSWindowDispatch;
}
namespace Teamcenter
{
    class BOSWindowDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::BOSWindowDispatch
    : public  Teamcenter::BOSWindowDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the BOSWindowDispatch instance
    static BOSWindowDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static BOSWindowDispatch*  m_dispatch;

    //  Default Constructor
    BOSWindowDispatch();

    //  Default Destructor
    virtual ~BOSWindowDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a BOSWindowDispatch
    BOSWindowDispatch( const BOSWindowDispatch& );

    //  Assignment operator
    BOSWindowDispatch&  operator = ( const BOSWindowDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::BOSWindowDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__BOSWINDOWDISPATCH_HXX
