//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BomChangeDispatch
    Filename:   BomChangeDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOMCHANGEDISPATCH_HXX
#define TEAMCENTER__BOMCHANGEDISPATCH_HXX

#include <vector>
#include <ecm/BomChange.hxx>
#include <ecm/BomChangeDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class BomChangeDispatch;
}
namespace Teamcenter
{
    class BomChangeDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::BomChangeDispatch
    : public  Teamcenter::BomChangeDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the BomChangeDispatch instance
    static BomChangeDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static BomChangeDispatch*  m_dispatch;

    //  Default Constructor
    BomChangeDispatch();

    //  Default Destructor
    virtual ~BomChangeDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a BomChangeDispatch
    BomChangeDispatch( const BomChangeDispatch& );

    //  Assignment operator
    BomChangeDispatch&  operator = ( const BomChangeDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::BomChangeDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__BOMCHANGEDISPATCH_HXX
