//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BoundingBoxDispatch
    Filename:   BoundingBoxDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOUNDINGBOXDISPATCH_HXX
#define TEAMCENTER__BOUNDINGBOXDISPATCH_HXX

#include <vector>
#include <qsearch/BoundingBox.hxx>
#include <qsearch/BoundingBoxDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class BoundingBoxDispatch;
}
namespace Teamcenter
{
    class BoundingBoxDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::BoundingBoxDispatch
    : public  Teamcenter::BoundingBoxDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the BoundingBoxDispatch instance
    static BoundingBoxDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static BoundingBoxDispatch*  m_dispatch;

    //  Default Constructor
    BoundingBoxDispatch();

    //  Default Destructor
    virtual ~BoundingBoxDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a BoundingBoxDispatch
    BoundingBoxDispatch( const BoundingBoxDispatch& );

    //  Assignment operator
    BoundingBoxDispatch&  operator = ( const BoundingBoxDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::BoundingBoxDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__BOUNDINGBOXDISPATCH_HXX
