//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BulkCopyInputDispatch
    Filename:   BulkCopyInputDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BULKCOPYINPUTDISPATCH_HXX
#define TEAMCENTER__BULKCOPYINPUTDISPATCH_HXX

#include <vector>
#include <metaframework/BulkCopyInput.hxx>
#include <metaframework/BulkCopyInputDelegate.hxx>
#include <foundationdispatch/BulkInputDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class BulkCopyInputDispatch;
}
namespace Teamcenter
{
    class BulkCopyInputDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::BulkCopyInputDispatch
    : public  Teamcenter::BulkCopyInputDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the BulkCopyInputDispatch instance
    static BulkCopyInputDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static BulkCopyInputDispatch*  m_dispatch;

    //  Default Constructor
    BulkCopyInputDispatch();

    //  Default Destructor
    virtual ~BulkCopyInputDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a BulkCopyInputDispatch
    BulkCopyInputDispatch( const BulkCopyInputDispatch& );

    //  Assignment operator
    BulkCopyInputDispatch&  operator = ( const BulkCopyInputDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::BulkCopyInputDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__BULKCOPYINPUTDISPATCH_HXX
