//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BulkInputDispatch
    Filename:   BulkInputDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BULKINPUTDISPATCH_HXX
#define TEAMCENTER__BULKINPUTDISPATCH_HXX

#include <vector>
#include <metaframework/BulkInput.hxx>
#include <metaframework/BulkInputDelegate.hxx>
#include <foundationdispatch/OperationInputDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class BulkInputDispatch;
}
namespace Teamcenter
{
    class BulkInputDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::BulkInputDispatch
    : public  Teamcenter::BulkInputDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the BulkInputDispatch instance
    static BulkInputDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static BulkInputDispatch*  m_dispatch;

    //  Default Constructor
    BulkInputDispatch();

    //  Default Destructor
    virtual ~BulkInputDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a BulkInputDispatch
    BulkInputDispatch( const BulkInputDispatch& );

    //  Assignment operator
    BulkInputDispatch&  operator = ( const BulkInputDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::BulkInputDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__BULKINPUTDISPATCH_HXX
