//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BulkSaveInputDispatch
    Filename:   BulkSaveInputDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BULKSAVEINPUTDISPATCH_HXX
#define TEAMCENTER__BULKSAVEINPUTDISPATCH_HXX

#include <vector>
#include <metaframework/BulkSaveInput.hxx>
#include <metaframework/BulkSaveInputDelegate.hxx>
#include <foundationdispatch/BulkInputDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class BulkSaveInputDispatch;
}
namespace Teamcenter
{
    class BulkSaveInputDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::BulkSaveInputDispatch
    : public  Teamcenter::BulkSaveInputDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the BulkSaveInputDispatch instance
    static BulkSaveInputDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static BulkSaveInputDispatch*  m_dispatch;

    //  Default Constructor
    BulkSaveInputDispatch();

    //  Default Destructor
    virtual ~BulkSaveInputDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a BulkSaveInputDispatch
    BulkSaveInputDispatch( const BulkSaveInputDispatch& );

    //  Assignment operator
    BulkSaveInputDispatch&  operator = ( const BulkSaveInputDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::BulkSaveInputDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__BULKSAVEINPUTDISPATCH_HXX
