//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BusinessContextDispatch
    Filename:   BusinessContextDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BUSINESSCONTEXTDISPATCH_HXX
#define TEAMCENTER__BUSINESSCONTEXTDISPATCH_HXX

#include <vector>
#include <rbf/BusinessContext.hxx>
#include <rbf/BusinessContextDelegate.hxx>
#include <foundationdispatch/BusinessElementDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class BusinessContextDispatch;
}
namespace Teamcenter
{
    class BusinessContextDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::BusinessContextDispatch
    : public  Teamcenter::BusinessContextDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the BusinessContextDispatch instance
    static BusinessContextDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static BusinessContextDispatch*  m_dispatch;

    //  Default Constructor
    BusinessContextDispatch();

    //  Default Destructor
    virtual ~BusinessContextDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a BusinessContextDispatch
    BusinessContextDispatch( const BusinessContextDispatch& );

    //  Assignment operator
    BusinessContextDispatch&  operator = ( const BusinessContextDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::BusinessContextDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__BUSINESSCONTEXTDISPATCH_HXX
