//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BusinessElementDispatch
    Filename:   BusinessElementDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BUSINESSELEMENTDISPATCH_HXX
#define TEAMCENTER__BUSINESSELEMENTDISPATCH_HXX

#include <vector>
#include <rbf/BusinessElement.hxx>
#include <rbf/BusinessElementDelegate.hxx>
#include <foundationdispatch/BusinessRuleDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class BusinessElementDispatch;
}
namespace Teamcenter
{
    class BusinessElementDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::BusinessElementDispatch
    : public  Teamcenter::BusinessElementDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the BusinessElementDispatch instance
    static BusinessElementDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static BusinessElementDispatch*  m_dispatch;

    //  Default Constructor
    BusinessElementDispatch();

    //  Default Destructor
    virtual ~BusinessElementDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a BusinessElementDispatch
    BusinessElementDispatch( const BusinessElementDispatch& );

    //  Assignment operator
    BusinessElementDispatch&  operator = ( const BusinessElementDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::BusinessElementDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__BUSINESSELEMENTDISPATCH_HXX
