//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BusinessObjectDispatch
    Filename:   BusinessObjectDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BUSINESSOBJECTDISPATCH_HXX
#define TEAMCENTER__BUSINESSOBJECTDISPATCH_HXX

#include <vector>
#include <metaframework/BusinessObject.hxx>
#include <metaframework/BusinessObjectDelegate.hxx>
#include <metaframework/RootObjectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>
#include <extensionframework/OperationDispatcher.hxx>
#include <metaframework/OperationObjectBatch.hxx>
#include <metaframework/PostActionInternalHandler.hxx>
#include <metaframework/ManageBulkData.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class BusinessObjectDispatch;
}
namespace Teamcenter
{
    class BusinessObjectDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::BusinessObjectDispatch
    : public  Teamcenter::BusinessObjectDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the BusinessObjectDispatch instance
    static BusinessObjectDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static BusinessObjectDispatch*  m_dispatch;

    //  Default Constructor
    BusinessObjectDispatch();

    //  Default Destructor
    virtual ~BusinessObjectDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a BusinessObjectDispatch
    BusinessObjectDispatch( const BusinessObjectDispatch& );

    //  Assignment operator
    BusinessObjectDispatch&  operator = ( const BusinessObjectDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::BusinessObjectDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__BUSINESSOBJECTDISPATCH_HXX
