//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BusinessObjectInterfaceDispatch
    Filename:   BusinessObjectInterfaceDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BUSINESSOBJECTINTERFACEDISPATCH_HXX
#define TEAMCENTER__BUSINESSOBJECTINTERFACEDISPATCH_HXX

#include <vector>
#include <meta/BusinessObjectInterface.hxx>
#include <meta/BusinessObjectInterfaceDelegate.hxx>
#include <foundationdispatch/MetaInterfaceDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class BusinessObjectInterfaceDispatch;
}
namespace Teamcenter
{
    class BusinessObjectInterfaceDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::BusinessObjectInterfaceDispatch
    : public  Teamcenter::BusinessObjectInterfaceDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the BusinessObjectInterfaceDispatch instance
    static BusinessObjectInterfaceDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static BusinessObjectInterfaceDispatch*  m_dispatch;

    //  Default Constructor
    BusinessObjectInterfaceDispatch();

    //  Default Destructor
    virtual ~BusinessObjectInterfaceDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a BusinessObjectInterfaceDispatch
    BusinessObjectInterfaceDispatch( const BusinessObjectInterfaceDispatch& );

    //  Assignment operator
    BusinessObjectInterfaceDispatch&  operator = ( const BusinessObjectInterfaceDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::BusinessObjectInterfaceDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__BUSINESSOBJECTINTERFACEDISPATCH_HXX
