//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BusinessRuleDispatch
    Filename:   BusinessRuleDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BUSINESSRULEDISPATCH_HXX
#define TEAMCENTER__BUSINESSRULEDISPATCH_HXX

#include <vector>
#include <tccore/BusinessRule.hxx>
#include <tccore/BusinessRuleDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class BusinessRuleDispatch;
}
namespace Teamcenter
{
    class BusinessRuleDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::BusinessRuleDispatch
    : public  Teamcenter::BusinessRuleDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the BusinessRuleDispatch instance
    static BusinessRuleDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static BusinessRuleDispatch*  m_dispatch;

    //  Default Constructor
    BusinessRuleDispatch();

    //  Default Destructor
    virtual ~BusinessRuleDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a BusinessRuleDispatch
    BusinessRuleDispatch( const BusinessRuleDispatch& );

    //  Assignment operator
    BusinessRuleDispatch&  operator = ( const BusinessRuleDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::BusinessRuleDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__BUSINESSRULEDISPATCH_HXX
