//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAEAnalysisDispatch
    Filename:   CAEAnalysisDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CAEANALYSISDISPATCH_HXX
#define TEAMCENTER__CAEANALYSISDISPATCH_HXX

#include <vector>
#include <cae/CAEAnalysis.hxx>
#include <cae/CAEAnalysisDelegate.hxx>
#include <foundationdispatch/CAEItemDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class CAEAnalysisDispatch;
}
namespace Teamcenter
{
    class CAEAnalysisDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::CAEAnalysisDispatch
    : public  Teamcenter::CAEAnalysisDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CAEAnalysisDispatch instance
    static CAEAnalysisDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static CAEAnalysisDispatch*  m_dispatch;

    //  Default Constructor
    CAEAnalysisDispatch();

    //  Default Destructor
    virtual ~CAEAnalysisDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a CAEAnalysisDispatch
    CAEAnalysisDispatch( const CAEAnalysisDispatch& );

    //  Assignment operator
    CAEAnalysisDispatch&  operator = ( const CAEAnalysisDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::CAEAnalysisDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__CAEANALYSISDISPATCH_HXX
