//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAEConnItemDispatch
    Filename:   CAEConnItemDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CAECONNITEMDISPATCH_HXX
#define TEAMCENTER__CAECONNITEMDISPATCH_HXX

#include <vector>
#include <cae/CAEConnItem.hxx>
#include <cae/CAEConnItemDelegate.hxx>
#include <foundationdispatch/ItemDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class CAEConnItemDispatch;
}
namespace Teamcenter
{
    class CAEConnItemDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::CAEConnItemDispatch
    : public  Teamcenter::CAEConnItemDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CAEConnItemDispatch instance
    static CAEConnItemDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static CAEConnItemDispatch*  m_dispatch;

    //  Default Constructor
    CAEConnItemDispatch();

    //  Default Destructor
    virtual ~CAEConnItemDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a CAEConnItemDispatch
    CAEConnItemDispatch( const CAEConnItemDispatch& );

    //  Assignment operator
    CAEConnItemDispatch&  operator = ( const CAEConnItemDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::CAEConnItemDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__CAECONNITEMDISPATCH_HXX
