//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAEGeometryDispatch
    Filename:   CAEGeometryDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CAEGEOMETRYDISPATCH_HXX
#define TEAMCENTER__CAEGEOMETRYDISPATCH_HXX

#include <vector>
#include <cae/CAEGeometry.hxx>
#include <cae/CAEGeometryDelegate.hxx>
#include <foundationdispatch/CAEItemDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class CAEGeometryDispatch;
}
namespace Teamcenter
{
    class CAEGeometryDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::CAEGeometryDispatch
    : public  Teamcenter::CAEGeometryDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CAEGeometryDispatch instance
    static CAEGeometryDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static CAEGeometryDispatch*  m_dispatch;

    //  Default Constructor
    CAEGeometryDispatch();

    //  Default Destructor
    virtual ~CAEGeometryDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a CAEGeometryDispatch
    CAEGeometryDispatch( const CAEGeometryDispatch& );

    //  Assignment operator
    CAEGeometryDispatch&  operator = ( const CAEGeometryDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::CAEGeometryDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__CAEGEOMETRYDISPATCH_HXX
