//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAEGeometryRevisionDispatch
    Filename:   CAEGeometryRevisionDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CAEGEOMETRYREVISIONDISPATCH_HXX
#define TEAMCENTER__CAEGEOMETRYREVISIONDISPATCH_HXX

#include <vector>
#include <cae/CAEGeometryRevision.hxx>
#include <cae/CAEGeometryRevisionDelegate.hxx>
#include <foundationdispatch/CAEItemRevisionDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class CAEGeometryRevisionDispatch;
}
namespace Teamcenter
{
    class CAEGeometryRevisionDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::CAEGeometryRevisionDispatch
    : public  Teamcenter::CAEGeometryRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CAEGeometryRevisionDispatch instance
    static CAEGeometryRevisionDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static CAEGeometryRevisionDispatch*  m_dispatch;

    //  Default Constructor
    CAEGeometryRevisionDispatch();

    //  Default Destructor
    virtual ~CAEGeometryRevisionDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a CAEGeometryRevisionDispatch
    CAEGeometryRevisionDispatch( const CAEGeometryRevisionDispatch& );

    //  Assignment operator
    CAEGeometryRevisionDispatch&  operator = ( const CAEGeometryRevisionDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::CAEGeometryRevisionDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__CAEGEOMETRYREVISIONDISPATCH_HXX
