//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAEItemDispatch
    Filename:   CAEItemDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CAEITEMDISPATCH_HXX
#define TEAMCENTER__CAEITEMDISPATCH_HXX

#include <vector>
#include <cae/CAEItem.hxx>
#include <cae/CAEItemDelegate.hxx>
#include <foundationdispatch/ItemDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class CAEItemDispatch;
}
namespace Teamcenter
{
    class CAEItemDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::CAEItemDispatch
    : public  Teamcenter::CAEItemDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CAEItemDispatch instance
    static CAEItemDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static CAEItemDispatch*  m_dispatch;

    //  Default Constructor
    CAEItemDispatch();

    //  Default Destructor
    virtual ~CAEItemDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a CAEItemDispatch
    CAEItemDispatch( const CAEItemDispatch& );

    //  Assignment operator
    CAEItemDispatch&  operator = ( const CAEItemDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::CAEItemDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__CAEITEMDISPATCH_HXX
