//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAELoadItemDispatch
    Filename:   CAELoadItemDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CAELOADITEMDISPATCH_HXX
#define TEAMCENTER__CAELOADITEMDISPATCH_HXX

#include <vector>
#include <cae/CAELoadItem.hxx>
#include <cae/CAELoadItemDelegate.hxx>
#include <foundationdispatch/ItemDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class CAELoadItemDispatch;
}
namespace Teamcenter
{
    class CAELoadItemDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::CAELoadItemDispatch
    : public  Teamcenter::CAELoadItemDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CAELoadItemDispatch instance
    static CAELoadItemDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static CAELoadItemDispatch*  m_dispatch;

    //  Default Constructor
    CAELoadItemDispatch();

    //  Default Destructor
    virtual ~CAELoadItemDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a CAELoadItemDispatch
    CAELoadItemDispatch( const CAELoadItemDispatch& );

    //  Assignment operator
    CAELoadItemDispatch&  operator = ( const CAELoadItemDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::CAELoadItemDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__CAELOADITEMDISPATCH_HXX
