//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAEModelDispatch
    Filename:   CAEModelDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CAEMODELDISPATCH_HXX
#define TEAMCENTER__CAEMODELDISPATCH_HXX

#include <vector>
#include <cae/CAEModel.hxx>
#include <cae/CAEModelDelegate.hxx>
#include <foundationdispatch/CAEItemDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class CAEModelDispatch;
}
namespace Teamcenter
{
    class CAEModelDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::CAEModelDispatch
    : public  Teamcenter::CAEModelDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CAEModelDispatch instance
    static CAEModelDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static CAEModelDispatch*  m_dispatch;

    //  Default Constructor
    CAEModelDispatch();

    //  Default Destructor
    virtual ~CAEModelDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a CAEModelDispatch
    CAEModelDispatch( const CAEModelDispatch& );

    //  Assignment operator
    CAEModelDispatch&  operator = ( const CAEModelDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::CAEModelDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__CAEMODELDISPATCH_HXX
