//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAEModelRevisionDispatch
    Filename:   CAEModelRevisionDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CAEMODELREVISIONDISPATCH_HXX
#define TEAMCENTER__CAEMODELREVISIONDISPATCH_HXX

#include <vector>
#include <cae/CAEModelRevision.hxx>
#include <cae/CAEModelRevisionDelegate.hxx>
#include <foundationdispatch/CAEItemRevisionDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class CAEModelRevisionDispatch;
}
namespace Teamcenter
{
    class CAEModelRevisionDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::CAEModelRevisionDispatch
    : public  Teamcenter::CAEModelRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CAEModelRevisionDispatch instance
    static CAEModelRevisionDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static CAEModelRevisionDispatch*  m_dispatch;

    //  Default Constructor
    CAEModelRevisionDispatch();

    //  Default Destructor
    virtual ~CAEModelRevisionDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a CAEModelRevisionDispatch
    CAEModelRevisionDispatch( const CAEModelRevisionDispatch& );

    //  Assignment operator
    CAEModelRevisionDispatch&  operator = ( const CAEModelRevisionDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::CAEModelRevisionDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__CAEMODELREVISIONDISPATCH_HXX
