//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CAEResultDispatch
    Filename:   CAEResultDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CAERESULTDISPATCH_HXX
#define TEAMCENTER__CAERESULTDISPATCH_HXX

#include <vector>
#include <cae/CAEResult.hxx>
#include <cae/CAEResultDelegate.hxx>
#include <foundationdispatch/CAEItemDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class CAEResultDispatch;
}
namespace Teamcenter
{
    class CAEResultDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::CAEResultDispatch
    : public  Teamcenter::CAEResultDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CAEResultDispatch instance
    static CAEResultDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static CAEResultDispatch*  m_dispatch;

    //  Default Constructor
    CAEResultDispatch();

    //  Default Destructor
    virtual ~CAEResultDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a CAEResultDispatch
    CAEResultDispatch( const CAEResultDispatch& );

    //  Assignment operator
    CAEResultDispatch&  operator = ( const CAEResultDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::CAEResultDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__CAERESULTDISPATCH_HXX
