//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CallbackFunctionDispatch
    Filename:   CallbackFunctionDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CALLBACKFUNCTIONDISPATCH_HXX
#define TEAMCENTER__CALLBACKFUNCTIONDISPATCH_HXX

#include <vector>
#include <extensionframework/CallbackFunction.hxx>
#include <extensionframework/CallbackFunctionDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class CallbackFunctionDispatch;
}
namespace Teamcenter
{
    class CallbackFunctionDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::CallbackFunctionDispatch
    : public  Teamcenter::CallbackFunctionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CallbackFunctionDispatch instance
    static CallbackFunctionDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static CallbackFunctionDispatch*  m_dispatch;

    //  Default Constructor
    CallbackFunctionDispatch();

    //  Default Destructor
    virtual ~CallbackFunctionDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a CallbackFunctionDispatch
    CallbackFunctionDispatch( const CallbackFunctionDispatch& );

    //  Assignment operator
    CallbackFunctionDispatch&  operator = ( const CallbackFunctionDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::CallbackFunctionDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__CALLBACKFUNCTIONDISPATCH_HXX
