//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ClientDataMasterDispatch
    Filename:   ClientDataMasterDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CLIENTDATAMASTERDISPATCH_HXX
#define TEAMCENTER__CLIENTDATAMASTERDISPATCH_HXX

#include <vector>
#include <ps/ClientDataMaster.hxx>
#include <ps/ClientDataMasterDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class ClientDataMasterDispatch;
}
namespace Teamcenter
{
    class ClientDataMasterDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::ClientDataMasterDispatch
    : public  Teamcenter::ClientDataMasterDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ClientDataMasterDispatch instance
    static ClientDataMasterDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static ClientDataMasterDispatch*  m_dispatch;

    //  Default Constructor
    ClientDataMasterDispatch();

    //  Default Destructor
    virtual ~ClientDataMasterDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a ClientDataMasterDispatch
    ClientDataMasterDispatch( const ClientDataMasterDispatch& );

    //  Assignment operator
    ClientDataMasterDispatch&  operator = ( const ClientDataMasterDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::ClientDataMasterDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__CLIENTDATAMASTERDISPATCH_HXX
