//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ClosureRuleDispatch
    Filename:   ClosureRuleDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CLOSURERULEDISPATCH_HXX
#define TEAMCENTER__CLOSURERULEDISPATCH_HXX

#include <vector>
#include <pie/ClosureRule.hxx>
#include <pie/ClosureRuleDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class ClosureRuleDispatch;
}
namespace Teamcenter
{
    class ClosureRuleDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::ClosureRuleDispatch
    : public  Teamcenter::ClosureRuleDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ClosureRuleDispatch instance
    static ClosureRuleDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static ClosureRuleDispatch*  m_dispatch;

    //  Default Constructor
    ClosureRuleDispatch();

    //  Default Destructor
    virtual ~ClosureRuleDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a ClosureRuleDispatch
    ClosureRuleDispatch( const ClosureRuleDispatch& );

    //  Assignment operator
    ClosureRuleDispatch&  operator = ( const ClosureRuleDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::ClosureRuleDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__CLOSURERULEDISPATCH_HXX
