//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ComponentRelationDispatch
    Filename:   ComponentRelationDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__COMPONENTRELATIONDISPATCH_HXX
#define TEAMCENTER__COMPONENTRELATIONDISPATCH_HXX

#include <vector>
#include <ps/ComponentRelation.hxx>
#include <ps/ComponentRelationDelegate.hxx>
#include <foundationdispatch/ImanRelationDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class ComponentRelationDispatch;
}
namespace Teamcenter
{
    class ComponentRelationDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::ComponentRelationDispatch
    : public  Teamcenter::ComponentRelationDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ComponentRelationDispatch instance
    static ComponentRelationDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static ComponentRelationDispatch*  m_dispatch;

    //  Default Constructor
    ComponentRelationDispatch();

    //  Default Destructor
    virtual ~ComponentRelationDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a ComponentRelationDispatch
    ComponentRelationDispatch( const ComponentRelationDispatch& );

    //  Assignment operator
    ComponentRelationDispatch&  operator = ( const ComponentRelationDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::ComponentRelationDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__COMPONENTRELATIONDISPATCH_HXX
