//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CondValDataDispatch
    Filename:   CondValDataDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONDVALDATADISPATCH_HXX
#define TEAMCENTER__CONDVALDATADISPATCH_HXX

#include <vector>
#include <condvalidation/CondValData.hxx>
#include <condvalidation/CondValDataDelegate.hxx>
#include <foundationdispatch/ValDataDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class CondValDataDispatch;
}
namespace Teamcenter
{
    class CondValDataDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::CondValDataDispatch
    : public  Teamcenter::CondValDataDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CondValDataDispatch instance
    static CondValDataDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static CondValDataDispatch*  m_dispatch;

    //  Default Constructor
    CondValDataDispatch();

    //  Default Destructor
    virtual ~CondValDataDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a CondValDataDispatch
    CondValDataDispatch( const CondValDataDispatch& );

    //  Assignment operator
    CondValDataDispatch&  operator = ( const CondValDataDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::CondValDataDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__CONDVALDATADISPATCH_HXX
