//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ConditionDispatch
    Filename:   ConditionDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONDITIONDISPATCH_HXX
#define TEAMCENTER__CONDITIONDISPATCH_HXX

#include <vector>
#include <ce/Condition.hxx>
#include <ce/ConditionDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class ConditionDispatch;
}
namespace Teamcenter
{
    class ConditionDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::ConditionDispatch
    : public  Teamcenter::ConditionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ConditionDispatch instance
    static ConditionDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static ConditionDispatch*  m_dispatch;

    //  Default Constructor
    ConditionDispatch();

    //  Default Destructor
    virtual ~ConditionDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a ConditionDispatch
    ConditionDispatch( const ConditionDispatch& );

    //  Assignment operator
    ConditionDispatch&  operator = ( const ConditionDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::ConditionDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__CONDITIONDISPATCH_HXX
