//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ConfigurationContextDispatch
    Filename:   ConfigurationContextDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONFIGURATIONCONTEXTDISPATCH_HXX
#define TEAMCENTER__CONFIGURATIONCONTEXTDISPATCH_HXX

#include <vector>
#include <collabctx/ConfigurationContext.hxx>
#include <collabctx/ConfigurationContextDelegate.hxx>
#include <foundationdispatch/WorkspaceObjectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class ConfigurationContextDispatch;
}
namespace Teamcenter
{
    class ConfigurationContextDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::ConfigurationContextDispatch
    : public  Teamcenter::ConfigurationContextDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ConfigurationContextDispatch instance
    static ConfigurationContextDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static ConfigurationContextDispatch*  m_dispatch;

    //  Default Constructor
    ConfigurationContextDispatch();

    //  Default Destructor
    virtual ~ConfigurationContextDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a ConfigurationContextDispatch
    ConfigurationContextDispatch( const ConfigurationContextDispatch& );

    //  Assignment operator
    ConfigurationContextDispatch&  operator = ( const ConfigurationContextDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::ConfigurationContextDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__CONFIGURATIONCONTEXTDISPATCH_HXX
