//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ConstantDispatch
    Filename:   ConstantDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONSTANTDISPATCH_HXX
#define TEAMCENTER__CONSTANTDISPATCH_HXX

#include <vector>
#include <constants/Constant.hxx>
#include <constants/ConstantDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class ConstantDispatch;
}
namespace Teamcenter
{
    class ConstantDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::ConstantDispatch
    : public  Teamcenter::ConstantDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ConstantDispatch instance
    static ConstantDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static ConstantDispatch*  m_dispatch;

    //  Default Constructor
    ConstantDispatch();

    //  Default Destructor
    virtual ~ConstantDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a ConstantDispatch
    ConstantDispatch( const ConstantDispatch& );

    //  Assignment operator
    ConstantDispatch&  operator = ( const ConstantDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::ConstantDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__CONSTANTDISPATCH_HXX
