//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CostValueDispatch
    Filename:   CostValueDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__COSTVALUEDISPATCH_HXX
#define TEAMCENTER__COSTVALUEDISPATCH_HXX

#include <vector>
#include <schmgt/CostValue.hxx>
#include <schmgt/CostValueDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class CostValueDispatch;
}
namespace Teamcenter
{
    class CostValueDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::CostValueDispatch
    : public  Teamcenter::CostValueDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CostValueDispatch instance
    static CostValueDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static CostValueDispatch*  m_dispatch;

    //  Default Constructor
    CostValueDispatch();

    //  Default Destructor
    virtual ~CostValueDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a CostValueDispatch
    CostValueDispatch( const CostValueDispatch& );

    //  Assignment operator
    CostValueDispatch&  operator = ( const CostValueDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::CostValueDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__COSTVALUEDISPATCH_HXX
