//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DataTypeDispatch
    Filename:   DataTypeDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__DATATYPEDISPATCH_HXX
#define TEAMCENTER__DATATYPEDISPATCH_HXX

#include <vector>
#include <meta/DataType.hxx>
#include <meta/DataTypeDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class DataTypeDispatch;
}
namespace Teamcenter
{
    class DataTypeDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::DataTypeDispatch
    : public  Teamcenter::DataTypeDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the DataTypeDispatch instance
    static DataTypeDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static DataTypeDispatch*  m_dispatch;

    //  Default Constructor
    DataTypeDispatch();

    //  Default Destructor
    virtual ~DataTypeDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a DataTypeDispatch
    DataTypeDispatch( const DataTypeDispatch& );

    //  Assignment operator
    DataTypeDispatch&  operator = ( const DataTypeDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::DataTypeDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__DATATYPEDISPATCH_HXX
