//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DataTypeRefDispatch
    Filename:   DataTypeRefDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__DATATYPEREFDISPATCH_HXX
#define TEAMCENTER__DATATYPEREFDISPATCH_HXX

#include <vector>
#include <meta/DataTypeRef.hxx>
#include <meta/DataTypeRefDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class DataTypeRefDispatch;
}
namespace Teamcenter
{
    class DataTypeRefDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::DataTypeRefDispatch
    : public  Teamcenter::DataTypeRefDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the DataTypeRefDispatch instance
    static DataTypeRefDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static DataTypeRefDispatch*  m_dispatch;

    //  Default Constructor
    DataTypeRefDispatch();

    //  Default Destructor
    virtual ~DataTypeRefDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a DataTypeRefDispatch
    DataTypeRefDispatch( const DataTypeRefDispatch& );

    //  Assignment operator
    DataTypeRefDispatch&  operator = ( const DataTypeRefDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::DataTypeRefDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__DATATYPEREFDISPATCH_HXX
