//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DatasetDispatch
    Filename:   DatasetDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__DATASETDISPATCH_HXX
#define TEAMCENTER__DATASETDISPATCH_HXX

#include <vector>
#include <ae/Dataset.hxx>
#include <ae/DatasetDelegate.hxx>
#include <foundationdispatch/WorkspaceObjectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class DatasetDispatch;
}
namespace Teamcenter
{
    class DatasetDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::DatasetDispatch
    : public  Teamcenter::DatasetDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the DatasetDispatch instance
    static DatasetDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static DatasetDispatch*  m_dispatch;

    //  Default Constructor
    DatasetDispatch();

    //  Default Destructor
    virtual ~DatasetDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a DatasetDispatch
    DatasetDispatch( const DatasetDispatch& );

    //  Assignment operator
    DatasetDispatch&  operator = ( const DatasetDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::DatasetDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__DATASETDISPATCH_HXX
