//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DatasetTypeDispatch
    Filename:   DatasetTypeDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__DATASETTYPEDISPATCH_HXX
#define TEAMCENTER__DATASETTYPEDISPATCH_HXX

#include <vector>
#include <ae/DatasetType.hxx>
#include <ae/DatasetTypeDelegate.hxx>
#include <foundationdispatch/POM_application_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class DatasetTypeDispatch;
}
namespace Teamcenter
{
    class DatasetTypeDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::DatasetTypeDispatch
    : public  Teamcenter::DatasetTypeDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the DatasetTypeDispatch instance
    static DatasetTypeDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static DatasetTypeDispatch*  m_dispatch;

    //  Default Constructor
    DatasetTypeDispatch();

    //  Default Destructor
    virtual ~DatasetTypeDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a DatasetTypeDispatch
    DatasetTypeDispatch( const DatasetTypeDispatch& );

    //  Assignment operator
    DatasetTypeDispatch&  operator = ( const DatasetTypeDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::DatasetTypeDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__DATASETTYPEDISPATCH_HXX
