//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DecisionTableDispatch
    Filename:   DecisionTableDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__DECISIONTABLEDISPATCH_HXX
#define TEAMCENTER__DECISIONTABLEDISPATCH_HXX

#include <vector>
#include <rbf/DecisionTable.hxx>
#include <rbf/DecisionTableDelegate.hxx>
#include <foundationdispatch/AppExtensionRuleTypeDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class DecisionTableDispatch;
}
namespace Teamcenter
{
    class DecisionTableDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::DecisionTableDispatch
    : public  Teamcenter::DecisionTableDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the DecisionTableDispatch instance
    static DecisionTableDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static DecisionTableDispatch*  m_dispatch;

    //  Default Constructor
    DecisionTableDispatch();

    //  Default Destructor
    virtual ~DecisionTableDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a DecisionTableDispatch
    DecisionTableDispatch( const DecisionTableDispatch& );

    //  Assignment operator
    DecisionTableDispatch&  operator = ( const DecisionTableDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::DecisionTableDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__DECISIONTABLEDISPATCH_HXX
