//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DeepCopyRuleDispatch
    Filename:   DeepCopyRuleDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__DEEPCOPYRULEDISPATCH_HXX
#define TEAMCENTER__DEEPCOPYRULEDISPATCH_HXX

#include <vector>
#include <tccore/DeepCopyRule.hxx>
#include <tccore/DeepCopyRuleDelegate.hxx>
#include <foundationdispatch/BusinessRuleDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class DeepCopyRuleDispatch;
}
namespace Teamcenter
{
    class DeepCopyRuleDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::DeepCopyRuleDispatch
    : public  Teamcenter::DeepCopyRuleDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the DeepCopyRuleDispatch instance
    static DeepCopyRuleDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static DeepCopyRuleDispatch*  m_dispatch;

    //  Default Constructor
    DeepCopyRuleDispatch();

    //  Default Destructor
    virtual ~DeepCopyRuleDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a DeepCopyRuleDispatch
    DeepCopyRuleDispatch( const DeepCopyRuleDispatch& );

    //  Assignment operator
    DeepCopyRuleDispatch&  operator = ( const DeepCopyRuleDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::DeepCopyRuleDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__DEEPCOPYRULEDISPATCH_HXX
