//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DerivedObjDispatch
    Filename:   DerivedObjDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__DERIVEDOBJDISPATCH_HXX
#define TEAMCENTER__DERIVEDOBJDISPATCH_HXX

#include <vector>
#include <docmgt/DerivedObj.hxx>
#include <docmgt/DerivedObjDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class DerivedObjDispatch;
}
namespace Teamcenter
{
    class DerivedObjDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::DerivedObjDispatch
    : public  Teamcenter::DerivedObjDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the DerivedObjDispatch instance
    static DerivedObjDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static DerivedObjDispatch*  m_dispatch;

    //  Default Constructor
    DerivedObjDispatch();

    //  Default Destructor
    virtual ~DerivedObjDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a DerivedObjDispatch
    DerivedObjDispatch( const DerivedObjDispatch& );

    //  Assignment operator
    DerivedObjDispatch&  operator = ( const DerivedObjDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::DerivedObjDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__DERIVEDOBJDISPATCH_HXX
