//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DisciplineDispatch
    Filename:   DisciplineDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__DISCIPLINEDISPATCH_HXX
#define TEAMCENTER__DISCIPLINEDISPATCH_HXX

#include <vector>
#include <sa/Discipline.hxx>
#include <sa/DisciplineDelegate.hxx>
#include <foundationdispatch/POM_system_classDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class DisciplineDispatch;
}
namespace Teamcenter
{
    class DisciplineDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::DisciplineDispatch
    : public  Teamcenter::DisciplineDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the DisciplineDispatch instance
    static DisciplineDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static DisciplineDispatch*  m_dispatch;

    //  Default Constructor
    DisciplineDispatch();

    //  Default Destructor
    virtual ~DisciplineDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a DisciplineDispatch
    DisciplineDispatch( const DisciplineDispatch& );

    //  Assignment operator
    DisciplineDispatch&  operator = ( const DisciplineDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::DisciplineDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__DISCIPLINEDISPATCH_HXX
