//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DocumentDispatch
    Filename:   DocumentDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__DOCUMENTDISPATCH_HXX
#define TEAMCENTER__DOCUMENTDISPATCH_HXX

#include <vector>
#include <tccore/Document.hxx>
#include <tccore/DocumentDelegate.hxx>
#include <foundationdispatch/ItemDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class DocumentDispatch;
}
namespace Teamcenter
{
    class DocumentDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::DocumentDispatch
    : public  Teamcenter::DocumentDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the DocumentDispatch instance
    static DocumentDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static DocumentDispatch*  m_dispatch;

    //  Default Constructor
    DocumentDispatch();

    //  Default Destructor
    virtual ~DocumentDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a DocumentDispatch
    DocumentDispatch( const DocumentDispatch& );

    //  Assignment operator
    DocumentDispatch&  operator = ( const DocumentDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::DocumentDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__DOCUMENTDISPATCH_HXX
