//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DocumentRevisionDispatch
    Filename:   DocumentRevisionDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__DOCUMENTREVISIONDISPATCH_HXX
#define TEAMCENTER__DOCUMENTREVISIONDISPATCH_HXX

#include <vector>
#include <tccore/DocumentRevision.hxx>
#include <tccore/DocumentRevisionDelegate.hxx>
#include <foundationdispatch/ItemRevisionDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class DocumentRevisionDispatch;
}
namespace Teamcenter
{
    class DocumentRevisionDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::DocumentRevisionDispatch
    : public  Teamcenter::DocumentRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the DocumentRevisionDispatch instance
    static DocumentRevisionDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static DocumentRevisionDispatch*  m_dispatch;

    //  Default Constructor
    DocumentRevisionDispatch();

    //  Default Destructor
    virtual ~DocumentRevisionDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a DocumentRevisionDispatch
    DocumentRevisionDispatch( const DocumentRevisionDispatch& );

    //  Assignment operator
    DocumentRevisionDispatch&  operator = ( const DocumentRevisionDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::DocumentRevisionDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__DOCUMENTREVISIONDISPATCH_HXX
