//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DrawingDispatch
    Filename:   DrawingDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__DRAWINGDISPATCH_HXX
#define TEAMCENTER__DRAWINGDISPATCH_HXX

#include <vector>
#include <tccore/Drawing.hxx>
#include <tccore/DrawingDelegate.hxx>
#include <foundationdispatch/ItemDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class DrawingDispatch;
}
namespace Teamcenter
{
    class DrawingDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::DrawingDispatch
    : public  Teamcenter::DrawingDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the DrawingDispatch instance
    static DrawingDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static DrawingDispatch*  m_dispatch;

    //  Default Constructor
    DrawingDispatch();

    //  Default Destructor
    virtual ~DrawingDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a DrawingDispatch
    DrawingDispatch( const DrawingDispatch& );

    //  Assignment operator
    DrawingDispatch&  operator = ( const DrawingDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::DrawingDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__DRAWINGDISPATCH_HXX
