//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EffectivityDispatch
    Filename:   EffectivityDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EFFECTIVITYDISPATCH_HXX
#define TEAMCENTER__EFFECTIVITYDISPATCH_HXX

#include <vector>
#include <tccore/Effectivity.hxx>
#include <tccore/EffectivityDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class EffectivityDispatch;
}
namespace Teamcenter
{
    class EffectivityDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::EffectivityDispatch
    : public  Teamcenter::EffectivityDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the EffectivityDispatch instance
    static EffectivityDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static EffectivityDispatch*  m_dispatch;

    //  Default Constructor
    EffectivityDispatch();

    //  Default Destructor
    virtual ~EffectivityDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a EffectivityDispatch
    EffectivityDispatch( const EffectivityDispatch& );

    //  Assignment operator
    EffectivityDispatch&  operator = ( const EffectivityDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::EffectivityDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__EFFECTIVITYDISPATCH_HXX
