//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EffectivityModeDispatch
    Filename:   EffectivityModeDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EFFECTIVITYMODEDISPATCH_HXX
#define TEAMCENTER__EFFECTIVITYMODEDISPATCH_HXX

#include <vector>
#include <tccore/EffectivityMode.hxx>
#include <tccore/EffectivityModeDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class EffectivityModeDispatch;
}
namespace Teamcenter
{
    class EffectivityModeDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::EffectivityModeDispatch
    : public  Teamcenter::EffectivityModeDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the EffectivityModeDispatch instance
    static EffectivityModeDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static EffectivityModeDispatch*  m_dispatch;

    //  Default Constructor
    EffectivityModeDispatch();

    //  Default Destructor
    virtual ~EffectivityModeDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a EffectivityModeDispatch
    EffectivityModeDispatch( const EffectivityModeDispatch& );

    //  Assignment operator
    EffectivityModeDispatch&  operator = ( const EffectivityModeDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::EffectivityModeDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__EFFECTIVITYMODEDISPATCH_HXX
