//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EncryptionKeyDispatch
    Filename:   EncryptionKeyDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ENCRYPTIONKEYDISPATCH_HXX
#define TEAMCENTER__ENCRYPTIONKEYDISPATCH_HXX

#include <vector>
#include <sa/EncryptionKey.hxx>
#include <sa/EncryptionKeyDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class EncryptionKeyDispatch;
}
namespace Teamcenter
{
    class EncryptionKeyDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::EncryptionKeyDispatch
    : public  Teamcenter::EncryptionKeyDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the EncryptionKeyDispatch instance
    static EncryptionKeyDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static EncryptionKeyDispatch*  m_dispatch;

    //  Default Constructor
    EncryptionKeyDispatch();

    //  Default Destructor
    virtual ~EncryptionKeyDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a EncryptionKeyDispatch
    EncryptionKeyDispatch( const EncryptionKeyDispatch& );

    //  Assignment operator
    EncryptionKeyDispatch&  operator = ( const EncryptionKeyDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::EncryptionKeyDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__ENCRYPTIONKEYDISPATCH_HXX
