//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EnvelopeDispatch
    Filename:   EnvelopeDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ENVELOPEDISPATCH_HXX
#define TEAMCENTER__ENVELOPEDISPATCH_HXX

#include <vector>
#include <tc/Envelope.hxx>
#include <tc/EnvelopeDelegate.hxx>
#include <foundationdispatch/FolderDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class EnvelopeDispatch;
}
namespace Teamcenter
{
    class EnvelopeDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::EnvelopeDispatch
    : public  Teamcenter::EnvelopeDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the EnvelopeDispatch instance
    static EnvelopeDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static EnvelopeDispatch*  m_dispatch;

    //  Default Constructor
    EnvelopeDispatch();

    //  Default Destructor
    virtual ~EnvelopeDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a EnvelopeDispatch
    EnvelopeDispatch( const EnvelopeDispatch& );

    //  Assignment operator
    EnvelopeDispatch&  operator = ( const EnvelopeDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::EnvelopeDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__ENVELOPEDISPATCH_HXX
