//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EventTypeMappingDispatch
    Filename:   EventTypeMappingDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EVENTTYPEMAPPINGDISPATCH_HXX
#define TEAMCENTER__EVENTTYPEMAPPINGDISPATCH_HXX

#include <vector>
#include <sub_mgr/EventTypeMapping.hxx>
#include <sub_mgr/EventTypeMappingDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class EventTypeMappingDispatch;
}
namespace Teamcenter
{
    class EventTypeMappingDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::EventTypeMappingDispatch
    : public  Teamcenter::EventTypeMappingDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the EventTypeMappingDispatch instance
    static EventTypeMappingDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static EventTypeMappingDispatch*  m_dispatch;

    //  Default Constructor
    EventTypeMappingDispatch();

    //  Default Destructor
    virtual ~EventTypeMappingDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a EventTypeMappingDispatch
    EventTypeMappingDispatch( const EventTypeMappingDispatch& );

    //  Assignment operator
    EventTypeMappingDispatch&  operator = ( const EventTypeMappingDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::EventTypeMappingDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__EVENTTYPEMAPPINGDISPATCH_HXX
