//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ExtensionDescriptorDispatch
    Filename:   ExtensionDescriptorDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EXTENSIONDESCRIPTORDISPATCH_HXX
#define TEAMCENTER__EXTENSIONDESCRIPTORDISPATCH_HXX

#include <vector>
#include <bmf/ExtensionDescriptor.hxx>
#include <bmf/ExtensionDescriptorDelegate.hxx>
#include <foundationdispatch/BusinessRuleDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class ExtensionDescriptorDispatch;
}
namespace Teamcenter
{
    class ExtensionDescriptorDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::ExtensionDescriptorDispatch
    : public  Teamcenter::ExtensionDescriptorDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ExtensionDescriptorDispatch instance
    static ExtensionDescriptorDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static ExtensionDescriptorDispatch*  m_dispatch;

    //  Default Constructor
    ExtensionDescriptorDispatch();

    //  Default Destructor
    virtual ~ExtensionDescriptorDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a ExtensionDescriptorDispatch
    ExtensionDescriptorDispatch( const ExtensionDescriptorDispatch& );

    //  Assignment operator
    ExtensionDescriptorDispatch&  operator = ( const ExtensionDescriptorDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::ExtensionDescriptorDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__EXTENSIONDESCRIPTORDISPATCH_HXX
