//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ExtensionDispatch
    Filename:   ExtensionDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EXTENSIONDISPATCH_HXX
#define TEAMCENTER__EXTENSIONDISPATCH_HXX

#include <vector>
#include <bmf/Extension.hxx>
#include <bmf/ExtensionDelegate.hxx>
#include <foundationdispatch/BusinessRuleDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class ExtensionDispatch;
}
namespace Teamcenter
{
    class ExtensionDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::ExtensionDispatch
    : public  Teamcenter::ExtensionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ExtensionDispatch instance
    static ExtensionDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static ExtensionDispatch*  m_dispatch;

    //  Default Constructor
    ExtensionDispatch();

    //  Default Destructor
    virtual ~ExtensionDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a ExtensionDispatch
    ExtensionDispatch( const ExtensionDispatch& );

    //  Assignment operator
    ExtensionDispatch&  operator = ( const ExtensionDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::ExtensionDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__EXTENSIONDISPATCH_HXX
