//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ExtensionPointDispatch
    Filename:   ExtensionPointDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EXTENSIONPOINTDISPATCH_HXX
#define TEAMCENTER__EXTENSIONPOINTDISPATCH_HXX

#include <vector>
#include <bmf/ExtensionPoint.hxx>
#include <bmf/ExtensionPointDelegate.hxx>
#include <foundationdispatch/BusinessRuleDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class ExtensionPointDispatch;
}
namespace Teamcenter
{
    class ExtensionPointDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::ExtensionPointDispatch
    : public  Teamcenter::ExtensionPointDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ExtensionPointDispatch instance
    static ExtensionPointDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static ExtensionPointDispatch*  m_dispatch;

    //  Default Constructor
    ExtensionPointDispatch();

    //  Default Destructor
    virtual ~ExtensionPointDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a ExtensionPointDispatch
    ExtensionPointDispatch( const ExtensionPointDispatch& );

    //  Assignment operator
    ExtensionPointDispatch&  operator = ( const ExtensionPointDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::ExtensionPointDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__EXTENSIONPOINTDISPATCH_HXX
