//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ExternalAttributeDispatch
    Filename:   ExternalAttributeDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EXTERNALATTRIBUTEDISPATCH_HXX
#define TEAMCENTER__EXTERNALATTRIBUTEDISPATCH_HXX

#include <vector>
#include <eint/ExternalAttribute.hxx>
#include <eint/ExternalAttributeDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class ExternalAttributeDispatch;
}
namespace Teamcenter
{
    class ExternalAttributeDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::ExternalAttributeDispatch
    : public  Teamcenter::ExternalAttributeDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ExternalAttributeDispatch instance
    static ExternalAttributeDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static ExternalAttributeDispatch*  m_dispatch;

    //  Default Constructor
    ExternalAttributeDispatch();

    //  Default Destructor
    virtual ~ExternalAttributeDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a ExternalAttributeDispatch
    ExternalAttributeDispatch( const ExternalAttributeDispatch& );

    //  Assignment operator
    ExternalAttributeDispatch&  operator = ( const ExternalAttributeDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::ExternalAttributeDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__EXTERNALATTRIBUTEDISPATCH_HXX
