//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ExternalDataSourceDispatch
    Filename:   ExternalDataSourceDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EXTERNALDATASOURCEDISPATCH_HXX
#define TEAMCENTER__EXTERNALDATASOURCEDISPATCH_HXX

#include <vector>
#include <eint/ExternalDataSource.hxx>
#include <eint/ExternalDataSourceDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class ExternalDataSourceDispatch;
}
namespace Teamcenter
{
    class ExternalDataSourceDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::ExternalDataSourceDispatch
    : public  Teamcenter::ExternalDataSourceDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ExternalDataSourceDispatch instance
    static ExternalDataSourceDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static ExternalDataSourceDispatch*  m_dispatch;

    //  Default Constructor
    ExternalDataSourceDispatch();

    //  Default Destructor
    virtual ~ExternalDataSourceDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a ExternalDataSourceDispatch
    ExternalDataSourceDispatch( const ExternalDataSourceDispatch& );

    //  Assignment operator
    ExternalDataSourceDispatch&  operator = ( const ExternalDataSourceDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::ExternalDataSourceDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__EXTERNALDATASOURCEDISPATCH_HXX
