//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ExternalDataTypeDispatch
    Filename:   ExternalDataTypeDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EXTERNALDATATYPEDISPATCH_HXX
#define TEAMCENTER__EXTERNALDATATYPEDISPATCH_HXX

#include <vector>
#include <meta/ExternalDataType.hxx>
#include <meta/ExternalDataTypeDelegate.hxx>
#include <foundationdispatch/DataTypeDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class ExternalDataTypeDispatch;
}
namespace Teamcenter
{
    class ExternalDataTypeDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::ExternalDataTypeDispatch
    : public  Teamcenter::ExternalDataTypeDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ExternalDataTypeDispatch instance
    static ExternalDataTypeDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static ExternalDataTypeDispatch*  m_dispatch;

    //  Default Constructor
    ExternalDataTypeDispatch();

    //  Default Destructor
    virtual ~ExternalDataTypeDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a ExternalDataTypeDispatch
    ExternalDataTypeDispatch( const ExternalDataTypeDispatch& );

    //  Assignment operator
    ExternalDataTypeDispatch&  operator = ( const ExternalDataTypeDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::ExternalDataTypeDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__EXTERNALDATATYPEDISPATCH_HXX
