//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, FileTOCDispatch
    Filename:   FileTOCDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FILETOCDISPATCH_HXX
#define TEAMCENTER__FILETOCDISPATCH_HXX

#include <vector>
#include <archive/FileTOC.hxx>
#include <archive/FileTOCDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class FileTOCDispatch;
}
namespace Teamcenter
{
    class FileTOCDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::FileTOCDispatch
    : public  Teamcenter::FileTOCDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the FileTOCDispatch instance
    static FileTOCDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static FileTOCDispatch*  m_dispatch;

    //  Default Constructor
    FileTOCDispatch();

    //  Default Destructor
    virtual ~FileTOCDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a FileTOCDispatch
    FileTOCDispatch( const FileTOCDispatch& );

    //  Assignment operator
    FileTOCDispatch&  operator = ( const FileTOCDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::FileTOCDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__FILETOCDISPATCH_HXX
