//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, FilterDispatch
    Filename:   FilterDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FILTERDISPATCH_HXX
#define TEAMCENTER__FILTERDISPATCH_HXX

#include <vector>
#include <pie/Filter.hxx>
#include <pie/FilterDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class FilterDispatch;
}
namespace Teamcenter
{
    class FilterDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::FilterDispatch
    : public  Teamcenter::FilterDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the FilterDispatch instance
    static FilterDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static FilterDispatch*  m_dispatch;

    //  Default Constructor
    FilterDispatch();

    //  Default Destructor
    virtual ~FilterDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a FilterDispatch
    FilterDispatch( const FilterDispatch& );

    //  Assignment operator
    FilterDispatch&  operator = ( const FilterDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::FilterDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__FILTERDISPATCH_HXX
