//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, FolderDispatch
    Filename:   FolderDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FOLDERDISPATCH_HXX
#define TEAMCENTER__FOLDERDISPATCH_HXX

#include <vector>
#include <tc/Folder.hxx>
#include <tc/FolderDelegate.hxx>
#include <foundationdispatch/WorkspaceObjectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class FolderDispatch;
}
namespace Teamcenter
{
    class FolderDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::FolderDispatch
    : public  Teamcenter::FolderDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the FolderDispatch instance
    static FolderDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static FolderDispatch*  m_dispatch;

    //  Default Constructor
    FolderDispatch();

    //  Default Destructor
    virtual ~FolderDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a FolderDispatch
    FolderDispatch( const FolderDispatch& );

    //  Assignment operator
    FolderDispatch&  operator = ( const FolderDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::FolderDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__FOLDERDISPATCH_HXX
