//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, FullTextDispatch
    Filename:   FullTextDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FULLTEXTDISPATCH_HXX
#define TEAMCENTER__FULLTEXTDISPATCH_HXX

#include <vector>
#include <req/FullText.hxx>
#include <req/FullTextDelegate.hxx>
#include <foundationdispatch/DatasetDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class FullTextDispatch;
}
namespace Teamcenter
{
    class FullTextDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::FullTextDispatch
    : public  Teamcenter::FullTextDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the FullTextDispatch instance
    static FullTextDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static FullTextDispatch*  m_dispatch;

    //  Default Constructor
    FullTextDispatch();

    //  Default Destructor
    virtual ~FullTextDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a FullTextDispatch
    FullTextDispatch( const FullTextDispatch& );

    //  Assignment operator
    FullTextDispatch&  operator = ( const FullTextDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::FullTextDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__FULLTEXTDISPATCH_HXX
