//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, GDELineDispatch
    Filename:   GDELineDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__GDELINEDISPATCH_HXX
#define TEAMCENTER__GDELINEDISPATCH_HXX

#include <vector>
#include <bom/GDELine.hxx>
#include <bom/GDELineDelegate.hxx>
#include <foundationdispatch/BOMLineDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class GDELineDispatch;
}
namespace Teamcenter
{
    class GDELineDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::GDELineDispatch
    : public  Teamcenter::GDELineDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the GDELineDispatch instance
    static GDELineDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static GDELineDispatch*  m_dispatch;

    //  Default Constructor
    GDELineDispatch();

    //  Default Destructor
    virtual ~GDELineDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a GDELineDispatch
    GDELineDispatch( const GDELineDispatch& );

    //  Assignment operator
    GDELineDispatch&  operator = ( const GDELineDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::GDELineDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__GDELINEDISPATCH_HXX
