//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, GlobalConstantDispatch
    Filename:   GlobalConstantDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__GLOBALCONSTANTDISPATCH_HXX
#define TEAMCENTER__GLOBALCONSTANTDISPATCH_HXX

#include <vector>
#include <constants/GlobalConstant.hxx>
#include <constants/GlobalConstantDelegate.hxx>
#include <foundationdispatch/ConstantDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class GlobalConstantDispatch;
}
namespace Teamcenter
{
    class GlobalConstantDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::GlobalConstantDispatch
    : public  Teamcenter::GlobalConstantDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the GlobalConstantDispatch instance
    static GlobalConstantDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static GlobalConstantDispatch*  m_dispatch;

    //  Default Constructor
    GlobalConstantDispatch();

    //  Default Destructor
    virtual ~GlobalConstantDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a GlobalConstantDispatch
    GlobalConstantDispatch( const GlobalConstantDispatch& );

    //  Assignment operator
    GlobalConstantDispatch&  operator = ( const GlobalConstantDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::GlobalConstantDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__GLOBALCONSTANTDISPATCH_HXX
