//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, GraphicOptionRevisionDispatch
    Filename:   GraphicOptionRevisionDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__GRAPHICOPTIONREVISIONDISPATCH_HXX
#define TEAMCENTER__GRAPHICOPTIONREVISIONDISPATCH_HXX

#include <vector>
#include <contmgmt/GraphicOptionRevision.hxx>
#include <contmgmt/GraphicOptionRevisionDelegate.hxx>
#include <foundationdispatch/ItemRevisionDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class GraphicOptionRevisionDispatch;
}
namespace Teamcenter
{
    class GraphicOptionRevisionDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::GraphicOptionRevisionDispatch
    : public  Teamcenter::GraphicOptionRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the GraphicOptionRevisionDispatch instance
    static GraphicOptionRevisionDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static GraphicOptionRevisionDispatch*  m_dispatch;

    //  Default Constructor
    GraphicOptionRevisionDispatch();

    //  Default Destructor
    virtual ~GraphicOptionRevisionDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a GraphicOptionRevisionDispatch
    GraphicOptionRevisionDispatch( const GraphicOptionRevisionDispatch& );

    //  Assignment operator
    GraphicOptionRevisionDispatch&  operator = ( const GraphicOptionRevisionDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::GraphicOptionRevisionDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__GRAPHICOPTIONREVISIONDISPATCH_HXX
