//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, GraphicRevisionDispatch
    Filename:   GraphicRevisionDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__GRAPHICREVISIONDISPATCH_HXX
#define TEAMCENTER__GRAPHICREVISIONDISPATCH_HXX

#include <vector>
#include <contmgmt/GraphicRevision.hxx>
#include <contmgmt/GraphicRevisionDelegate.hxx>
#include <foundationdispatch/SpecElementRevisionDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class GraphicRevisionDispatch;
}
namespace Teamcenter
{
    class GraphicRevisionDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::GraphicRevisionDispatch
    : public  Teamcenter::GraphicRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the GraphicRevisionDispatch instance
    static GraphicRevisionDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static GraphicRevisionDispatch*  m_dispatch;

    //  Default Constructor
    GraphicRevisionDispatch();

    //  Default Destructor
    virtual ~GraphicRevisionDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a GraphicRevisionDispatch
    GraphicRevisionDispatch( const GraphicRevisionDispatch& );

    //  Assignment operator
    GraphicRevisionDispatch&  operator = ( const GraphicRevisionDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::GraphicRevisionDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__GRAPHICREVISIONDISPATCH_HXX
