//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, GroupDispatch
    Filename:   GroupDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__GROUPDISPATCH_HXX
#define TEAMCENTER__GROUPDISPATCH_HXX

#include <vector>
#include <sa/Group.hxx>
#include <sa/GroupDelegate.hxx>
#include <foundationdispatch/POM_groupDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class GroupDispatch;
}
namespace Teamcenter
{
    class GroupDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::GroupDispatch
    : public  Teamcenter::GroupDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the GroupDispatch instance
    static GroupDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static GroupDispatch*  m_dispatch;

    //  Default Constructor
    GroupDispatch();

    //  Default Destructor
    virtual ~GroupDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a GroupDispatch
    GroupDispatch( const GroupDispatch& );

    //  Assignment operator
    GroupDispatch&  operator = ( const GroupDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::GroupDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__GROUPDISPATCH_HXX
