//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, HSM_PolicyDispatch
    Filename:   HSM_PolicyDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__HSM_POLICYDISPATCH_HXX
#define TEAMCENTER__HSM_POLICYDISPATCH_HXX

#include <vector>
#include <sa/HSM_Policy.hxx>
#include <sa/HSM_PolicyDelegate.hxx>
#include <foundationdispatch/Migration_PolicyDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class HSM_PolicyDispatch;
}
namespace Teamcenter
{
    class HSM_PolicyDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::HSM_PolicyDispatch
    : public  Teamcenter::HSM_PolicyDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the HSM_PolicyDispatch instance
    static HSM_PolicyDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static HSM_PolicyDispatch*  m_dispatch;

    //  Default Constructor
    HSM_PolicyDispatch();

    //  Default Destructor
    virtual ~HSM_PolicyDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a HSM_PolicyDispatch
    HSM_PolicyDispatch( const HSM_PolicyDispatch& );

    //  Assignment operator
    HSM_PolicyDispatch&  operator = ( const HSM_PolicyDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::HSM_PolicyDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__HSM_POLICYDISPATCH_HXX
