//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, IDCWindowDispatch
    Filename:   IDCWindowDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IDCWINDOWDISPATCH_HXX
#define TEAMCENTER__IDCWINDOWDISPATCH_HXX

#include <vector>
#include <ai/IDCWindow.hxx>
#include <ai/IDCWindowDelegate.hxx>
#include <foundationdispatch/RuntimeBusinessObjectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class IDCWindowDispatch;
}
namespace Teamcenter
{
    class IDCWindowDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::IDCWindowDispatch
    : public  Teamcenter::IDCWindowDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the IDCWindowDispatch instance
    static IDCWindowDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static IDCWindowDispatch*  m_dispatch;

    //  Default Constructor
    IDCWindowDispatch();

    //  Default Destructor
    virtual ~IDCWindowDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a IDCWindowDispatch
    IDCWindowDispatch( const IDCWindowDispatch& );

    //  Assignment operator
    IDCWindowDispatch&  operator = ( const IDCWindowDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::IDCWindowDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__IDCWINDOWDISPATCH_HXX
