//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, IRDCDispatch
    Filename:   IRDCDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IRDCDISPATCH_HXX
#define TEAMCENTER__IRDCDISPATCH_HXX

#include <vector>
#include <docmgt/IRDC.hxx>
#include <docmgt/IRDCDelegate.hxx>
#include <foundationdispatch/BusinessElementDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class IRDCDispatch;
}
namespace Teamcenter
{
    class IRDCDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::IRDCDispatch
    : public  Teamcenter::IRDCDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the IRDCDispatch instance
    static IRDCDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static IRDCDispatch*  m_dispatch;

    //  Default Constructor
    IRDCDispatch();

    //  Default Destructor
    virtual ~IRDCDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a IRDCDispatch
    IRDCDispatch( const IRDCDispatch& );

    //  Assignment operator
    IRDCDispatch&  operator = ( const IRDCDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::IRDCDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__IRDCDISPATCH_HXX
