//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, IRDCNamingDispatch
    Filename:   IRDCNamingDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IRDCNAMINGDISPATCH_HXX
#define TEAMCENTER__IRDCNAMINGDISPATCH_HXX

#include <vector>
#include <docmgt/IRDCNaming.hxx>
#include <docmgt/IRDCNamingDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class IRDCNamingDispatch;
}
namespace Teamcenter
{
    class IRDCNamingDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::IRDCNamingDispatch
    : public  Teamcenter::IRDCNamingDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the IRDCNamingDispatch instance
    static IRDCNamingDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static IRDCNamingDispatch*  m_dispatch;

    //  Default Constructor
    IRDCNamingDispatch();

    //  Default Destructor
    virtual ~IRDCNamingDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a IRDCNamingDispatch
    IRDCNamingDispatch( const IRDCNamingDispatch& );

    //  Assignment operator
    IRDCNamingDispatch&  operator = ( const IRDCNamingDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::IRDCNamingDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__IRDCNAMINGDISPATCH_HXX
