//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, IRDCRenderDispatch
    Filename:   IRDCRenderDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IRDCRENDERDISPATCH_HXX
#define TEAMCENTER__IRDCRENDERDISPATCH_HXX

#include <vector>
#include <docmgt/IRDCRender.hxx>
#include <docmgt/IRDCRenderDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class IRDCRenderDispatch;
}
namespace Teamcenter
{
    class IRDCRenderDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::IRDCRenderDispatch
    : public  Teamcenter::IRDCRenderDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the IRDCRenderDispatch instance
    static IRDCRenderDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static IRDCRenderDispatch*  m_dispatch;

    //  Default Constructor
    IRDCRenderDispatch();

    //  Default Destructor
    virtual ~IRDCRenderDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a IRDCRenderDispatch
    IRDCRenderDispatch( const IRDCRenderDispatch& );

    //  Assignment operator
    IRDCRenderDispatch&  operator = ( const IRDCRenderDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::IRDCRenderDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__IRDCRENDERDISPATCH_HXX
