//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, IdentifierDispatch
    Filename:   IdentifierDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IDENTIFIERDISPATCH_HXX
#define TEAMCENTER__IDENTIFIERDISPATCH_HXX

#include <vector>
#include <tccore/Identifier.hxx>
#include <tccore/IdentifierDelegate.hxx>
#include <foundationdispatch/WorkspaceObjectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class IdentifierDispatch;
}
namespace Teamcenter
{
    class IdentifierDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::IdentifierDispatch
    : public  Teamcenter::IdentifierDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the IdentifierDispatch instance
    static IdentifierDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static IdentifierDispatch*  m_dispatch;

    //  Default Constructor
    IdentifierDispatch();

    //  Default Destructor
    virtual ~IdentifierDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a IdentifierDispatch
    IdentifierDispatch( const IdentifierDispatch& );

    //  Assignment operator
    IdentifierDispatch&  operator = ( const IdentifierDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::IdentifierDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__IDENTIFIERDISPATCH_HXX
