//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, IntentDispatch
    Filename:   IntentDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__INTENTDISPATCH_HXX
#define TEAMCENTER__INTENTDISPATCH_HXX

#include <vector>
#include <cfm/Intent.hxx>
#include <cfm/IntentDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class IntentDispatch;
}
namespace Teamcenter
{
    class IntentDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::IntentDispatch
    : public  Teamcenter::IntentDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the IntentDispatch instance
    static IntentDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static IntentDispatch*  m_dispatch;

    //  Default Constructor
    IntentDispatch();

    //  Default Destructor
    virtual ~IntentDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a IntentDispatch
    IntentDispatch( const IntentDispatch& );

    //  Assignment operator
    IntentDispatch&  operator = ( const IntentDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::IntentDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__INTENTDISPATCH_HXX
