//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ItemDispatch
    Filename:   ItemDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ITEMDISPATCH_HXX
#define TEAMCENTER__ITEMDISPATCH_HXX

#include <vector>
#include <tccore/Item.hxx>
#include <tccore/ItemDelegate.hxx>
#include <foundationdispatch/WorkspaceObjectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class ItemDispatch;
}
namespace Teamcenter
{
    class ItemDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::ItemDispatch
    : public  Teamcenter::ItemDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ItemDispatch instance
    static ItemDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static ItemDispatch*  m_dispatch;

    //  Default Constructor
    ItemDispatch();

    //  Default Destructor
    virtual ~ItemDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a ItemDispatch
    ItemDispatch( const ItemDispatch& );

    //  Assignment operator
    ItemDispatch&  operator = ( const ItemDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::ItemDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__ITEMDISPATCH_HXX
