//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, LibraryDispatch
    Filename:   LibraryDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LIBRARYDISPATCH_HXX
#define TEAMCENTER__LIBRARYDISPATCH_HXX

#include <vector>
#include <meta/Library.hxx>
#include <meta/LibraryDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class LibraryDispatch;
}
namespace Teamcenter
{
    class LibraryDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::LibraryDispatch
    : public  Teamcenter::LibraryDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the LibraryDispatch instance
    static LibraryDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static LibraryDispatch*  m_dispatch;

    //  Default Constructor
    LibraryDispatch();

    //  Default Destructor
    virtual ~LibraryDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a LibraryDispatch
    LibraryDispatch( const LibraryDispatch& );

    //  Assignment operator
    LibraryDispatch&  operator = ( const LibraryDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::LibraryDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__LIBRARYDISPATCH_HXX
