//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, LineOfUsageDispatch
    Filename:   LineOfUsageDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LINEOFUSAGEDISPATCH_HXX
#define TEAMCENTER__LINEOFUSAGEDISPATCH_HXX

#include <vector>
#include <rdv/LineOfUsage.hxx>
#include <rdv/LineOfUsageDelegate.hxx>
#include <foundationdispatch/RuntimeBusinessObjectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class LineOfUsageDispatch;
}
namespace Teamcenter
{
    class LineOfUsageDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::LineOfUsageDispatch
    : public  Teamcenter::LineOfUsageDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the LineOfUsageDispatch instance
    static LineOfUsageDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static LineOfUsageDispatch*  m_dispatch;

    //  Default Constructor
    LineOfUsageDispatch();

    //  Default Destructor
    virtual ~LineOfUsageDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a LineOfUsageDispatch
    LineOfUsageDispatch( const LineOfUsageDispatch& );

    //  Assignment operator
    LineOfUsageDispatch&  operator = ( const LineOfUsageDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::LineOfUsageDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__LINEOFUSAGEDISPATCH_HXX
