//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MEProcessDispatch
    Filename:   MEProcessDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MEPROCESSDISPATCH_HXX
#define TEAMCENTER__MEPROCESSDISPATCH_HXX

#include <vector>
#include <me/MEProcess.hxx>
#include <me/MEProcessDelegate.hxx>
#include <foundationdispatch/ItemDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class MEProcessDispatch;
}
namespace Teamcenter
{
    class MEProcessDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::MEProcessDispatch
    : public  Teamcenter::MEProcessDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the MEProcessDispatch instance
    static MEProcessDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static MEProcessDispatch*  m_dispatch;

    //  Default Constructor
    MEProcessDispatch();

    //  Default Destructor
    virtual ~MEProcessDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a MEProcessDispatch
    MEProcessDispatch( const MEProcessDispatch& );

    //  Assignment operator
    MEProcessDispatch&  operator = ( const MEProcessDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::MEProcessDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__MEPROCESSDISPATCH_HXX
