//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MasterRecordDispatch
    Filename:   MasterRecordDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MASTERRECORDDISPATCH_HXX
#define TEAMCENTER__MASTERRECORDDISPATCH_HXX

#include <vector>
#include <ai/MasterRecord.hxx>
#include <ai/MasterRecordDelegate.hxx>
#include <foundationdispatch/POM_application_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class MasterRecordDispatch;
}
namespace Teamcenter
{
    class MasterRecordDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::MasterRecordDispatch
    : public  Teamcenter::MasterRecordDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the MasterRecordDispatch instance
    static MasterRecordDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static MasterRecordDispatch*  m_dispatch;

    //  Default Constructor
    MasterRecordDispatch();

    //  Default Destructor
    virtual ~MasterRecordDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a MasterRecordDispatch
    MasterRecordDispatch( const MasterRecordDispatch& );

    //  Assignment operator
    MasterRecordDispatch&  operator = ( const MasterRecordDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::MasterRecordDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__MASTERRECORDDISPATCH_HXX
