//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MediaTOCDispatch
    Filename:   MediaTOCDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MEDIATOCDISPATCH_HXX
#define TEAMCENTER__MEDIATOCDISPATCH_HXX

#include <vector>
#include <archive/MediaTOC.hxx>
#include <archive/MediaTOCDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class MediaTOCDispatch;
}
namespace Teamcenter
{
    class MediaTOCDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::MediaTOCDispatch
    : public  Teamcenter::MediaTOCDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the MediaTOCDispatch instance
    static MediaTOCDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static MediaTOCDispatch*  m_dispatch;

    //  Default Constructor
    MediaTOCDispatch();

    //  Default Destructor
    virtual ~MediaTOCDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a MediaTOCDispatch
    MediaTOCDispatch( const MediaTOCDispatch& );

    //  Assignment operator
    MediaTOCDispatch&  operator = ( const MediaTOCDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::MediaTOCDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__MEDIATOCDISPATCH_HXX
