//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ModelReqDispatch
    Filename:   ModelReqDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MODELREQDISPATCH_HXX
#define TEAMCENTER__MODELREQDISPATCH_HXX

#include <vector>
#include <validation/ModelReq.hxx>
#include <validation/ModelReqDelegate.hxx>
#include <foundationdispatch/RequirementDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class ModelReqDispatch;
}
namespace Teamcenter
{
    class ModelReqDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::ModelReqDispatch
    : public  Teamcenter::ModelReqDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ModelReqDispatch instance
    static ModelReqDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static ModelReqDispatch*  m_dispatch;

    //  Default Constructor
    ModelReqDispatch();

    //  Default Destructor
    virtual ~ModelReqDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a ModelReqDispatch
    ModelReqDispatch( const ModelReqDispatch& );

    //  Assignment operator
    ModelReqDispatch&  operator = ( const ModelReqDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::ModelReqDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__MODELREQDISPATCH_HXX
