//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, NXAgentDispatch
    Filename:   NXAgentDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__NXAGENTDISPATCH_HXX
#define TEAMCENTER__NXAGENTDISPATCH_HXX

#include <vector>
#include <validation/NXAgent.hxx>
#include <validation/NXAgentDelegate.hxx>
#include <foundationdispatch/ValToolAgentDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class NXAgentDispatch;
}
namespace Teamcenter
{
    class NXAgentDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::NXAgentDispatch
    : public  Teamcenter::NXAgentDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the NXAgentDispatch instance
    static NXAgentDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static NXAgentDispatch*  m_dispatch;

    //  Default Constructor
    NXAgentDispatch();

    //  Default Destructor
    virtual ~NXAgentDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a NXAgentDispatch
    NXAgentDispatch( const NXAgentDispatch& );

    //  Assignment operator
    NXAgentDispatch&  operator = ( const NXAgentDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::NXAgentDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__NXAGENTDISPATCH_HXX
