//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, NXRDDVDispatch
    Filename:   NXRDDVDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__NXRDDVDISPATCH_HXX
#define TEAMCENTER__NXRDDVDISPATCH_HXX

#include <vector>
#include <validation/NXRDDV.hxx>
#include <validation/NXRDDVDelegate.hxx>
#include <foundationdispatch/NXAgentDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class NXRDDVDispatch;
}
namespace Teamcenter
{
    class NXRDDVDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::NXRDDVDispatch
    : public  Teamcenter::NXRDDVDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the NXRDDVDispatch instance
    static NXRDDVDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static NXRDDVDispatch*  m_dispatch;

    //  Default Constructor
    NXRDDVDispatch();

    //  Default Destructor
    virtual ~NXRDDVDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a NXRDDVDispatch
    NXRDDVDispatch( const NXRDDVDispatch& );

    //  Assignment operator
    NXRDDVDispatch&  operator = ( const NXRDDVDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::NXRDDVDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__NXRDDVDISPATCH_HXX
