//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ObjectMappingDispatch
    Filename:   ObjectMappingDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__OBJECTMAPPINGDISPATCH_HXX
#define TEAMCENTER__OBJECTMAPPINGDISPATCH_HXX

#include <vector>
#include <eint/ObjectMapping.hxx>
#include <eint/ObjectMappingDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class ObjectMappingDispatch;
}
namespace Teamcenter
{
    class ObjectMappingDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::ObjectMappingDispatch
    : public  Teamcenter::ObjectMappingDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ObjectMappingDispatch instance
    static ObjectMappingDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static ObjectMappingDispatch*  m_dispatch;

    //  Default Constructor
    ObjectMappingDispatch();

    //  Default Destructor
    virtual ~ObjectMappingDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a ObjectMappingDispatch
    ObjectMappingDispatch( const ObjectMappingDispatch& );

    //  Assignment operator
    ObjectMappingDispatch&  operator = ( const ObjectMappingDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::ObjectMappingDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__OBJECTMAPPINGDISPATCH_HXX
