//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, OperationDispatch
    Filename:   OperationDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__OPERATIONDISPATCH_HXX
#define TEAMCENTER__OPERATIONDISPATCH_HXX

#include <vector>
#include <meta/Operation.hxx>
#include <meta/OperationDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class OperationDispatch;
}
namespace Teamcenter
{
    class OperationDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::OperationDispatch
    : public  Teamcenter::OperationDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the OperationDispatch instance
    static OperationDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static OperationDispatch*  m_dispatch;

    //  Default Constructor
    OperationDispatch();

    //  Default Destructor
    virtual ~OperationDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a OperationDispatch
    OperationDispatch( const OperationDispatch& );

    //  Assignment operator
    OperationDispatch&  operator = ( const OperationDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::OperationDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__OPERATIONDISPATCH_HXX
