//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, OperationInputDispatch
    Filename:   OperationInputDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__OPERATIONINPUTDISPATCH_HXX
#define TEAMCENTER__OPERATIONINPUTDISPATCH_HXX

#include <vector>
#include <metaframework/OperationInput.hxx>
#include <metaframework/OperationInputDelegate.hxx>
#include <metaframework/RootObjectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>
#include <extensionframework/OperationDispatcher.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class OperationInputDispatch;
}
namespace Teamcenter
{
    class OperationInputDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::OperationInputDispatch
    : public  Teamcenter::OperationInputDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the OperationInputDispatch instance
    static OperationInputDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static OperationInputDispatch*  m_dispatch;

    //  Default Constructor
    OperationInputDispatch();

    //  Default Destructor
    virtual ~OperationInputDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a OperationInputDispatch
    OperationInputDispatch( const OperationInputDispatch& );

    //  Assignment operator
    OperationInputDispatch&  operator = ( const OperationInputDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::OperationInputDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__OPERATIONINPUTDISPATCH_HXX
