//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PSConnectionDispatch
    Filename:   PSConnectionDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PSCONNECTIONDISPATCH_HXX
#define TEAMCENTER__PSCONNECTIONDISPATCH_HXX

#include <vector>
#include <mechatronics/PSConnection.hxx>
#include <mechatronics/PSConnectionDelegate.hxx>
#include <foundationdispatch/ItemDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class PSConnectionDispatch;
}
namespace Teamcenter
{
    class PSConnectionDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::PSConnectionDispatch
    : public  Teamcenter::PSConnectionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PSConnectionDispatch instance
    static PSConnectionDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static PSConnectionDispatch*  m_dispatch;

    //  Default Constructor
    PSConnectionDispatch();

    //  Default Destructor
    virtual ~PSConnectionDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a PSConnectionDispatch
    PSConnectionDispatch( const PSConnectionDispatch& );

    //  Assignment operator
    PSConnectionDispatch&  operator = ( const PSConnectionDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::PSConnectionDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__PSCONNECTIONDISPATCH_HXX
