//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PSSignalDispatch
    Filename:   PSSignalDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PSSIGNALDISPATCH_HXX
#define TEAMCENTER__PSSIGNALDISPATCH_HXX

#include <vector>
#include <mechatronics/PSSignal.hxx>
#include <mechatronics/PSSignalDelegate.hxx>
#include <foundationdispatch/ItemDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class PSSignalDispatch;
}
namespace Teamcenter
{
    class PSSignalDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::PSSignalDispatch
    : public  Teamcenter::PSSignalDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PSSignalDispatch instance
    static PSSignalDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static PSSignalDispatch*  m_dispatch;

    //  Default Constructor
    PSSignalDispatch();

    //  Default Destructor
    virtual ~PSSignalDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a PSSignalDispatch
    PSSignalDispatch( const PSSignalDispatch& );

    //  Assignment operator
    PSSignalDispatch&  operator = ( const PSSignalDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::PSSignalDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__PSSIGNALDISPATCH_HXX
