//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PSSignalRevisionDispatch
    Filename:   PSSignalRevisionDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PSSIGNALREVISIONDISPATCH_HXX
#define TEAMCENTER__PSSIGNALREVISIONDISPATCH_HXX

#include <vector>
#include <mechatronics/PSSignalRevision.hxx>
#include <mechatronics/PSSignalRevisionDelegate.hxx>
#include <foundationdispatch/ItemRevisionDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class PSSignalRevisionDispatch;
}
namespace Teamcenter
{
    class PSSignalRevisionDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::PSSignalRevisionDispatch
    : public  Teamcenter::PSSignalRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PSSignalRevisionDispatch instance
    static PSSignalRevisionDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static PSSignalRevisionDispatch*  m_dispatch;

    //  Default Constructor
    PSSignalRevisionDispatch();

    //  Default Destructor
    virtual ~PSSignalRevisionDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a PSSignalRevisionDispatch
    PSSignalRevisionDispatch( const PSSignalRevisionDispatch& );

    //  Assignment operator
    PSSignalRevisionDispatch&  operator = ( const PSSignalRevisionDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::PSSignalRevisionDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__PSSIGNALREVISIONDISPATCH_HXX
