//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PSSignalValueDispatch
    Filename:   PSSignalValueDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PSSIGNALVALUEDISPATCH_HXX
#define TEAMCENTER__PSSIGNALVALUEDISPATCH_HXX

#include <vector>
#include <mechatronics/PSSignalValue.hxx>
#include <mechatronics/PSSignalValueDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class PSSignalValueDispatch;
}
namespace Teamcenter
{
    class PSSignalValueDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::PSSignalValueDispatch
    : public  Teamcenter::PSSignalValueDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PSSignalValueDispatch instance
    static PSSignalValueDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static PSSignalValueDispatch*  m_dispatch;

    //  Default Constructor
    PSSignalValueDispatch();

    //  Default Destructor
    virtual ~PSSignalValueDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a PSSignalValueDispatch
    PSSignalValueDispatch( const PSSignalValueDispatch& );

    //  Assignment operator
    PSSignalValueDispatch&  operator = ( const PSSignalValueDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::PSSignalValueDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__PSSIGNALVALUEDISPATCH_HXX
