//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PSXformDispatch
    Filename:   PSXformDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PSXFORMDISPATCH_HXX
#define TEAMCENTER__PSXFORMDISPATCH_HXX

#include <vector>
#include <ps/PSXform.hxx>
#include <ps/PSXformDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class PSXformDispatch;
}
namespace Teamcenter
{
    class PSXformDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::PSXformDispatch
    : public  Teamcenter::PSXformDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PSXformDispatch instance
    static PSXformDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static PSXformDispatch*  m_dispatch;

    //  Default Constructor
    PSXformDispatch();

    //  Default Destructor
    virtual ~PSXformDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a PSXformDispatch
    PSXformDispatch( const PSXformDispatch& );

    //  Assignment operator
    PSXformDispatch&  operator = ( const PSXformDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::PSXformDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__PSXFORMDISPATCH_HXX
