//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ParagraphDispatch
    Filename:   ParagraphDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PARAGRAPHDISPATCH_HXX
#define TEAMCENTER__PARAGRAPHDISPATCH_HXX

#include <vector>
#include <req/Paragraph.hxx>
#include <req/ParagraphDelegate.hxx>
#include <foundationdispatch/SpecElementDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class ParagraphDispatch;
}
namespace Teamcenter
{
    class ParagraphDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::ParagraphDispatch
    : public  Teamcenter::ParagraphDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ParagraphDispatch instance
    static ParagraphDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static ParagraphDispatch*  m_dispatch;

    //  Default Constructor
    ParagraphDispatch();

    //  Default Destructor
    virtual ~ParagraphDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a ParagraphDispatch
    ParagraphDispatch( const ParagraphDispatch& );

    //  Assignment operator
    ParagraphDispatch&  operator = ( const ParagraphDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::ParagraphDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__PARAGRAPHDISPATCH_HXX
