//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ParticipantDispatch
    Filename:   ParticipantDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PARTICIPANTDISPATCH_HXX
#define TEAMCENTER__PARTICIPANTDISPATCH_HXX

#include <vector>
#include <epm/Participant.hxx>
#include <epm/ParticipantDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class ParticipantDispatch;
}
namespace Teamcenter
{
    class ParticipantDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::ParticipantDispatch
    : public  Teamcenter::ParticipantDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ParticipantDispatch instance
    static ParticipantDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static ParticipantDispatch*  m_dispatch;

    //  Default Constructor
    ParticipantDispatch();

    //  Default Destructor
    virtual ~ParticipantDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a ParticipantDispatch
    ParticipantDispatch( const ParticipantDispatch& );

    //  Assignment operator
    ParticipantDispatch&  operator = ( const ParticipantDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::ParticipantDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__PARTICIPANTDISPATCH_HXX
