//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PersonDispatch
    Filename:   PersonDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PERSONDISPATCH_HXX
#define TEAMCENTER__PERSONDISPATCH_HXX

#include <vector>
#include <sa/Person.hxx>
#include <sa/PersonDelegate.hxx>
#include <foundationdispatch/POM_application_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class PersonDispatch;
}
namespace Teamcenter
{
    class PersonDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::PersonDispatch
    : public  Teamcenter::PersonDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PersonDispatch instance
    static PersonDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static PersonDispatch*  m_dispatch;

    //  Default Constructor
    PersonDispatch();

    //  Default Destructor
    virtual ~PersonDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a PersonDispatch
    PersonDispatch( const PersonDispatch& );

    //  Assignment operator
    PersonDispatch&  operator = ( const PersonDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::PersonDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__PERSONDISPATCH_HXX
