//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PrintConfigurationDispatch
    Filename:   PrintConfigurationDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PRINTCONFIGURATIONDISPATCH_HXX
#define TEAMCENTER__PRINTCONFIGURATIONDISPATCH_HXX

#include <vector>
#include <docmgt/PrintConfiguration.hxx>
#include <docmgt/PrintConfigurationDelegate.hxx>
#include <foundationdispatch/BusinessElementDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class PrintConfigurationDispatch;
}
namespace Teamcenter
{
    class PrintConfigurationDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::PrintConfigurationDispatch
    : public  Teamcenter::PrintConfigurationDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PrintConfigurationDispatch instance
    static PrintConfigurationDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static PrintConfigurationDispatch*  m_dispatch;

    //  Default Constructor
    PrintConfigurationDispatch();

    //  Default Destructor
    virtual ~PrintConfigurationDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a PrintConfigurationDispatch
    PrintConfigurationDispatch( const PrintConfigurationDispatch& );

    //  Assignment operator
    PrintConfigurationDispatch&  operator = ( const PrintConfigurationDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::PrintConfigurationDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__PRINTCONFIGURATIONDISPATCH_HXX
