//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PrivateContextDispatch
    Filename:   PrivateContextDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PRIVATECONTEXTDISPATCH_HXX
#define TEAMCENTER__PRIVATECONTEXTDISPATCH_HXX

#include <vector>
#include <collabctx/PrivateContext.hxx>
#include <collabctx/PrivateContextDelegate.hxx>
#include <foundationdispatch/StructureContextDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class PrivateContextDispatch;
}
namespace Teamcenter
{
    class PrivateContextDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::PrivateContextDispatch
    : public  Teamcenter::PrivateContextDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PrivateContextDispatch instance
    static PrivateContextDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static PrivateContextDispatch*  m_dispatch;

    //  Default Constructor
    PrivateContextDispatch();

    //  Default Destructor
    virtual ~PrivateContextDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a PrivateContextDispatch
    PrivateContextDispatch( const PrivateContextDispatch& );

    //  Assignment operator
    PrivateContextDispatch&  operator = ( const PrivateContextDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::PrivateContextDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__PRIVATECONTEXTDISPATCH_HXX
