//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ProgressDataDispatch
    Filename:   ProgressDataDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROGRESSDATADISPATCH_HXX
#define TEAMCENTER__PROGRESSDATADISPATCH_HXX

#include <vector>
#include <tccore/ProgressData.hxx>
#include <tccore/ProgressDataDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class ProgressDataDispatch;
}
namespace Teamcenter
{
    class ProgressDataDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::ProgressDataDispatch
    : public  Teamcenter::ProgressDataDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ProgressDataDispatch instance
    static ProgressDataDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static ProgressDataDispatch*  m_dispatch;

    //  Default Constructor
    ProgressDataDispatch();

    //  Default Destructor
    virtual ~ProgressDataDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a ProgressDataDispatch
    ProgressDataDispatch( const ProgressDataDispatch& );

    //  Assignment operator
    ProgressDataDispatch&  operator = ( const ProgressDataDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::ProgressDataDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__PROGRESSDATADISPATCH_HXX
