//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ProjectTeamDispatch
    Filename:   ProjectTeamDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROJECTTEAMDISPATCH_HXX
#define TEAMCENTER__PROJECTTEAMDISPATCH_HXX

#include <vector>
#include <tccore/ProjectTeam.hxx>
#include <tccore/ProjectTeamDelegate.hxx>
#include <foundationdispatch/GroupDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class ProjectTeamDispatch;
}
namespace Teamcenter
{
    class ProjectTeamDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::ProjectTeamDispatch
    : public  Teamcenter::ProjectTeamDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ProjectTeamDispatch instance
    static ProjectTeamDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static ProjectTeamDispatch*  m_dispatch;

    //  Default Constructor
    ProjectTeamDispatch();

    //  Default Destructor
    virtual ~ProjectTeamDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a ProjectTeamDispatch
    ProjectTeamDispatch( const ProjectTeamDispatch& );

    //  Assignment operator
    ProjectTeamDispatch&  operator = ( const ProjectTeamDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::ProjectTeamDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__PROJECTTEAMDISPATCH_HXX
