//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PropRuleDispatch
    Filename:   PropRuleDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROPRULEDISPATCH_HXX
#define TEAMCENTER__PROPRULEDISPATCH_HXX

#include <vector>
#include <property/PropRule.hxx>
#include <property/PropRuleDelegate.hxx>
#include <foundationdispatch/BusinessRuleDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class PropRuleDispatch;
}
namespace Teamcenter
{
    class PropRuleDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::PropRuleDispatch
    : public  Teamcenter::PropRuleDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PropRuleDispatch instance
    static PropRuleDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static PropRuleDispatch*  m_dispatch;

    //  Default Constructor
    PropRuleDispatch();

    //  Default Destructor
    virtual ~PropRuleDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a PropRuleDispatch
    PropRuleDispatch( const PropRuleDispatch& );

    //  Assignment operator
    PropRuleDispatch&  operator = ( const PropRuleDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::PropRuleDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__PROPRULEDISPATCH_HXX
