//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PropertyConstantDispatch
    Filename:   PropertyConstantDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROPERTYCONSTANTDISPATCH_HXX
#define TEAMCENTER__PROPERTYCONSTANTDISPATCH_HXX

#include <vector>
#include <constants/PropertyConstant.hxx>
#include <constants/PropertyConstantDelegate.hxx>
#include <foundationdispatch/ConstantDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class PropertyConstantDispatch;
}
namespace Teamcenter
{
    class PropertyConstantDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::PropertyConstantDispatch
    : public  Teamcenter::PropertyConstantDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PropertyConstantDispatch instance
    static PropertyConstantDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static PropertyConstantDispatch*  m_dispatch;

    //  Default Constructor
    PropertyConstantDispatch();

    //  Default Destructor
    virtual ~PropertyConstantDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a PropertyConstantDispatch
    PropertyConstantDispatch( const PropertyConstantDispatch& );

    //  Assignment operator
    PropertyConstantDispatch&  operator = ( const PropertyConstantDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::PropertyConstantDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__PROPERTYCONSTANTDISPATCH_HXX
