//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PropertyInfoDispatch
    Filename:   PropertyInfoDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROPERTYINFODISPATCH_HXX
#define TEAMCENTER__PROPERTYINFODISPATCH_HXX

#include <vector>
#include <property/PropertyInfo.hxx>
#include <property/PropertyInfoDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class PropertyInfoDispatch;
}
namespace Teamcenter
{
    class PropertyInfoDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::PropertyInfoDispatch
    : public  Teamcenter::PropertyInfoDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PropertyInfoDispatch instance
    static PropertyInfoDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static PropertyInfoDispatch*  m_dispatch;

    //  Default Constructor
    PropertyInfoDispatch();

    //  Default Destructor
    virtual ~PropertyInfoDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a PropertyInfoDispatch
    PropertyInfoDispatch( const PropertyInfoDispatch& );

    //  Assignment operator
    PropertyInfoDispatch&  operator = ( const PropertyInfoDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::PropertyInfoDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__PROPERTYINFODISPATCH_HXX
