//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PropertyOperationDispatch
    Filename:   PropertyOperationDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROPERTYOPERATIONDISPATCH_HXX
#define TEAMCENTER__PROPERTYOPERATIONDISPATCH_HXX

#include <vector>
#include <meta/PropertyOperation.hxx>
#include <meta/PropertyOperationDelegate.hxx>
#include <foundationdispatch/OperationDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class PropertyOperationDispatch;
}
namespace Teamcenter
{
    class PropertyOperationDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::PropertyOperationDispatch
    : public  Teamcenter::PropertyOperationDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PropertyOperationDispatch instance
    static PropertyOperationDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static PropertyOperationDispatch*  m_dispatch;

    //  Default Constructor
    PropertyOperationDispatch();

    //  Default Destructor
    virtual ~PropertyOperationDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a PropertyOperationDispatch
    PropertyOperationDispatch( const PropertyOperationDispatch& );

    //  Assignment operator
    PropertyOperationDispatch&  operator = ( const PropertyOperationDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::PropertyOperationDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__PROPERTYOPERATIONDISPATCH_HXX
