//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ProposedReviewerDispatch
    Filename:   ProposedReviewerDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROPOSEDREVIEWERDISPATCH_HXX
#define TEAMCENTER__PROPOSEDREVIEWERDISPATCH_HXX

#include <vector>
#include <epm/ProposedReviewer.hxx>
#include <epm/ProposedReviewerDelegate.hxx>
#include <foundationdispatch/ParticipantDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class ProposedReviewerDispatch;
}
namespace Teamcenter
{
    class ProposedReviewerDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::ProposedReviewerDispatch
    : public  Teamcenter::ProposedReviewerDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ProposedReviewerDispatch instance
    static ProposedReviewerDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static ProposedReviewerDispatch*  m_dispatch;

    //  Default Constructor
    ProposedReviewerDispatch();

    //  Default Destructor
    virtual ~ProposedReviewerDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a ProposedReviewerDispatch
    ProposedReviewerDispatch( const ProposedReviewerDispatch& );

    //  Assignment operator
    ProposedReviewerDispatch&  operator = ( const ProposedReviewerDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::ProposedReviewerDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__PROPOSEDREVIEWERDISPATCH_HXX
