//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PseudoFolderDispatch
    Filename:   PseudoFolderDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PSEUDOFOLDERDISPATCH_HXX
#define TEAMCENTER__PSEUDOFOLDERDISPATCH_HXX

#include <vector>
#include <tccore/PseudoFolder.hxx>
#include <tccore/PseudoFolderDelegate.hxx>
#include <foundationdispatch/RuntimeBusinessObjectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class PseudoFolderDispatch;
}
namespace Teamcenter
{
    class PseudoFolderDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::PseudoFolderDispatch
    : public  Teamcenter::PseudoFolderDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PseudoFolderDispatch instance
    static PseudoFolderDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static PseudoFolderDispatch*  m_dispatch;

    //  Default Constructor
    PseudoFolderDispatch();

    //  Default Destructor
    virtual ~PseudoFolderDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a PseudoFolderDispatch
    PseudoFolderDispatch( const PseudoFolderDispatch& );

    //  Assignment operator
    PseudoFolderDispatch&  operator = ( const PseudoFolderDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::PseudoFolderDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__PSEUDOFOLDERDISPATCH_HXX
