//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PublishedObjectDispatch
    Filename:   PublishedObjectDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PUBLISHEDOBJECTDISPATCH_HXX
#define TEAMCENTER__PUBLISHEDOBJECTDISPATCH_HXX

#include <vector>
#include <publication/PublishedObject.hxx>
#include <publication/PublishedObjectDelegate.hxx>
#include <foundationdispatch/RuntimeBusinessObjectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class PublishedObjectDispatch;
}
namespace Teamcenter
{
    class PublishedObjectDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::PublishedObjectDispatch
    : public  Teamcenter::PublishedObjectDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PublishedObjectDispatch instance
    static PublishedObjectDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static PublishedObjectDispatch*  m_dispatch;

    //  Default Constructor
    PublishedObjectDispatch();

    //  Default Destructor
    virtual ~PublishedObjectDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a PublishedObjectDispatch
    PublishedObjectDispatch( const PublishedObjectDispatch& );

    //  Assignment operator
    PublishedObjectDispatch&  operator = ( const PublishedObjectDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::PublishedObjectDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__PUBLISHEDOBJECTDISPATCH_HXX
