//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RBFCellDispatch
    Filename:   RBFCellDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__RBFCELLDISPATCH_HXX
#define TEAMCENTER__RBFCELLDISPATCH_HXX

#include <vector>
#include <rbf/RBFCell.hxx>
#include <rbf/RBFCellDelegate.hxx>
#include <foundationdispatch/BusinessElementDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class RBFCellDispatch;
}
namespace Teamcenter
{
    class RBFCellDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::RBFCellDispatch
    : public  Teamcenter::RBFCellDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the RBFCellDispatch instance
    static RBFCellDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static RBFCellDispatch*  m_dispatch;

    //  Default Constructor
    RBFCellDispatch();

    //  Default Destructor
    virtual ~RBFCellDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a RBFCellDispatch
    RBFCellDispatch( const RBFCellDispatch& );

    //  Assignment operator
    RBFCellDispatch&  operator = ( const RBFCellDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::RBFCellDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__RBFCELLDISPATCH_HXX
