//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RBFExpressionDispatch
    Filename:   RBFExpressionDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__RBFEXPRESSIONDISPATCH_HXX
#define TEAMCENTER__RBFEXPRESSIONDISPATCH_HXX

#include <vector>
#include <rbf/RBFExpression.hxx>
#include <rbf/RBFExpressionDelegate.hxx>
#include <foundationdispatch/RBFParamDefDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class RBFExpressionDispatch;
}
namespace Teamcenter
{
    class RBFExpressionDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::RBFExpressionDispatch
    : public  Teamcenter::RBFExpressionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the RBFExpressionDispatch instance
    static RBFExpressionDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static RBFExpressionDispatch*  m_dispatch;

    //  Default Constructor
    RBFExpressionDispatch();

    //  Default Destructor
    virtual ~RBFExpressionDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a RBFExpressionDispatch
    RBFExpressionDispatch( const RBFExpressionDispatch& );

    //  Assignment operator
    RBFExpressionDispatch&  operator = ( const RBFExpressionDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::RBFExpressionDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__RBFEXPRESSIONDISPATCH_HXX
