//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RBFInputDispatch
    Filename:   RBFInputDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__RBFINPUTDISPATCH_HXX
#define TEAMCENTER__RBFINPUTDISPATCH_HXX

#include <vector>
#include <rbf/RBFInput.hxx>
#include <rbf/RBFInputDelegate.hxx>
#include <foundationdispatch/RBFExpressionDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class RBFInputDispatch;
}
namespace Teamcenter
{
    class RBFInputDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::RBFInputDispatch
    : public  Teamcenter::RBFInputDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the RBFInputDispatch instance
    static RBFInputDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static RBFInputDispatch*  m_dispatch;

    //  Default Constructor
    RBFInputDispatch();

    //  Default Destructor
    virtual ~RBFInputDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a RBFInputDispatch
    RBFInputDispatch( const RBFInputDispatch& );

    //  Assignment operator
    RBFInputDispatch&  operator = ( const RBFInputDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::RBFInputDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__RBFINPUTDISPATCH_HXX
