//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RBFOutputDispatch
    Filename:   RBFOutputDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__RBFOUTPUTDISPATCH_HXX
#define TEAMCENTER__RBFOUTPUTDISPATCH_HXX

#include <vector>
#include <rbf/RBFOutput.hxx>
#include <rbf/RBFOutputDelegate.hxx>
#include <foundationdispatch/RBFParamDefDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class RBFOutputDispatch;
}
namespace Teamcenter
{
    class RBFOutputDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::RBFOutputDispatch
    : public  Teamcenter::RBFOutputDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the RBFOutputDispatch instance
    static RBFOutputDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static RBFOutputDispatch*  m_dispatch;

    //  Default Constructor
    RBFOutputDispatch();

    //  Default Destructor
    virtual ~RBFOutputDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a RBFOutputDispatch
    RBFOutputDispatch( const RBFOutputDispatch& );

    //  Assignment operator
    RBFOutputDispatch&  operator = ( const RBFOutputDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::RBFOutputDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__RBFOUTPUTDISPATCH_HXX
