//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RangeDispatch
    Filename:   RangeDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__RANGEDISPATCH_HXX
#define TEAMCENTER__RANGEDISPATCH_HXX

#include <vector>
#include <sa/Range.hxx>
#include <sa/RangeDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class RangeDispatch;
}
namespace Teamcenter
{
    class RangeDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::RangeDispatch
    : public  Teamcenter::RangeDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the RangeDispatch instance
    static RangeDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static RangeDispatch*  m_dispatch;

    //  Default Constructor
    RangeDispatch();

    //  Default Destructor
    virtual ~RangeDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a RangeDispatch
    RangeDispatch( const RangeDispatch& );

    //  Assignment operator
    RangeDispatch&  operator = ( const RangeDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::RangeDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__RANGEDISPATCH_HXX
