//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RecordObjectDispatch
    Filename:   RecordObjectDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__RECORDOBJECTDISPATCH_HXX
#define TEAMCENTER__RECORDOBJECTDISPATCH_HXX

#include <vector>
#include <ai/RecordObject.hxx>
#include <ai/RecordObjectDelegate.hxx>
#include <foundationdispatch/POM_application_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class RecordObjectDispatch;
}
namespace Teamcenter
{
    class RecordObjectDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::RecordObjectDispatch
    : public  Teamcenter::RecordObjectDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the RecordObjectDispatch instance
    static RecordObjectDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static RecordObjectDispatch*  m_dispatch;

    //  Default Constructor
    RecordObjectDispatch();

    //  Default Destructor
    virtual ~RecordObjectDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a RecordObjectDispatch
    RecordObjectDispatch( const RecordObjectDispatch& );

    //  Assignment operator
    RecordObjectDispatch&  operator = ( const RecordObjectDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::RecordObjectDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__RECORDOBJECTDISPATCH_HXX
