//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ReleaseDispatch
    Filename:   ReleaseDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__RELEASEDISPATCH_HXX
#define TEAMCENTER__RELEASEDISPATCH_HXX

#include <vector>
#include <meta/Release.hxx>
#include <meta/ReleaseDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class ReleaseDispatch;
}
namespace Teamcenter
{
    class ReleaseDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::ReleaseDispatch
    : public  Teamcenter::ReleaseDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ReleaseDispatch instance
    static ReleaseDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static ReleaseDispatch*  m_dispatch;

    //  Default Constructor
    ReleaseDispatch();

    //  Default Destructor
    virtual ~ReleaseDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a ReleaseDispatch
    ReleaseDispatch( const ReleaseDispatch& );

    //  Assignment operator
    ReleaseDispatch&  operator = ( const ReleaseDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::ReleaseDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__RELEASEDISPATCH_HXX
