//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RemoteObjectDispatch
    Filename:   RemoteObjectDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REMOTEOBJECTDISPATCH_HXX
#define TEAMCENTER__REMOTEOBJECTDISPATCH_HXX

#include <vector>
#include <publication/RemoteObject.hxx>
#include <publication/RemoteObjectDelegate.hxx>
#include <foundationdispatch/RuntimeBusinessObjectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class RemoteObjectDispatch;
}
namespace Teamcenter
{
    class RemoteObjectDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::RemoteObjectDispatch
    : public  Teamcenter::RemoteObjectDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the RemoteObjectDispatch instance
    static RemoteObjectDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static RemoteObjectDispatch*  m_dispatch;

    //  Default Constructor
    RemoteObjectDispatch();

    //  Default Destructor
    virtual ~RemoteObjectDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a RemoteObjectDispatch
    RemoteObjectDispatch( const RemoteObjectDispatch& );

    //  Assignment operator
    RemoteObjectDispatch&  operator = ( const RemoteObjectDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::RemoteObjectDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__REMOTEOBJECTDISPATCH_HXX
