//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RequestObjectDispatch
    Filename:   RequestObjectDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REQUESTOBJECTDISPATCH_HXX
#define TEAMCENTER__REQUESTOBJECTDISPATCH_HXX

#include <vector>
#include <ai/RequestObject.hxx>
#include <ai/RequestObjectDelegate.hxx>
#include <foundationdispatch/WorkspaceObjectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class RequestObjectDispatch;
}
namespace Teamcenter
{
    class RequestObjectDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::RequestObjectDispatch
    : public  Teamcenter::RequestObjectDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the RequestObjectDispatch instance
    static RequestObjectDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static RequestObjectDispatch*  m_dispatch;

    //  Default Constructor
    RequestObjectDispatch();

    //  Default Destructor
    virtual ~RequestObjectDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a RequestObjectDispatch
    RequestObjectDispatch( const RequestObjectDispatch& );

    //  Assignment operator
    RequestObjectDispatch&  operator = ( const RequestObjectDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::RequestObjectDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__REQUESTOBJECTDISPATCH_HXX
