//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RequirementDispatch
    Filename:   RequirementDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REQUIREMENTDISPATCH_HXX
#define TEAMCENTER__REQUIREMENTDISPATCH_HXX

#include <vector>
#include <req/Requirement.hxx>
#include <req/RequirementDelegate.hxx>
#include <foundationdispatch/SpecElementDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class RequirementDispatch;
}
namespace Teamcenter
{
    class RequirementDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::RequirementDispatch
    : public  Teamcenter::RequirementDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the RequirementDispatch instance
    static RequirementDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static RequirementDispatch*  m_dispatch;

    //  Default Constructor
    RequirementDispatch();

    //  Default Destructor
    virtual ~RequirementDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a RequirementDispatch
    RequirementDispatch( const RequirementDispatch& );

    //  Assignment operator
    RequirementDispatch&  operator = ( const RequirementDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::RequirementDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__REQUIREMENTDISPATCH_HXX
