//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ReservationDispatch
    Filename:   ReservationDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__RESERVATIONDISPATCH_HXX
#define TEAMCENTER__RESERVATIONDISPATCH_HXX

#include <vector>
#include <res/Reservation.hxx>
#include <res/ReservationDelegate.hxx>
#include <foundationdispatch/WorkspaceObjectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class ReservationDispatch;
}
namespace Teamcenter
{
    class ReservationDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::ReservationDispatch
    : public  Teamcenter::ReservationDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ReservationDispatch instance
    static ReservationDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static ReservationDispatch*  m_dispatch;

    //  Default Constructor
    ReservationDispatch();

    //  Default Destructor
    virtual ~ReservationDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a ReservationDispatch
    ReservationDispatch( const ReservationDispatch& );

    //  Assignment operator
    ReservationDispatch&  operator = ( const ReservationDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::ReservationDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__RESERVATIONDISPATCH_HXX
