//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ResourcePoolDispatch
    Filename:   ResourcePoolDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__RESOURCEPOOLDISPATCH_HXX
#define TEAMCENTER__RESOURCEPOOLDISPATCH_HXX

#include <vector>
#include <epm/ResourcePool.hxx>
#include <epm/ResourcePoolDelegate.hxx>
#include <foundationdispatch/POM_system_classDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class ResourcePoolDispatch;
}
namespace Teamcenter
{
    class ResourcePoolDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::ResourcePoolDispatch
    : public  Teamcenter::ResourcePoolDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ResourcePoolDispatch instance
    static ResourcePoolDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static ResourcePoolDispatch*  m_dispatch;

    //  Default Constructor
    ResourcePoolDispatch();

    //  Default Destructor
    virtual ~ResourcePoolDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a ResourcePoolDispatch
    ResourcePoolDispatch( const ResourcePoolDispatch& );

    //  Assignment operator
    ResourcePoolDispatch&  operator = ( const ResourcePoolDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::ResourcePoolDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__RESOURCEPOOLDISPATCH_HXX
