//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RevisionRuleDispatch
    Filename:   RevisionRuleDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REVISIONRULEDISPATCH_HXX
#define TEAMCENTER__REVISIONRULEDISPATCH_HXX

#include <vector>
#include <cfm/RevisionRule.hxx>
#include <cfm/RevisionRuleDelegate.hxx>
#include <foundationdispatch/WorkspaceObjectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class RevisionRuleDispatch;
}
namespace Teamcenter
{
    class RevisionRuleDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::RevisionRuleDispatch
    : public  Teamcenter::RevisionRuleDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the RevisionRuleDispatch instance
    static RevisionRuleDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static RevisionRuleDispatch*  m_dispatch;

    //  Default Constructor
    RevisionRuleDispatch();

    //  Default Destructor
    virtual ~RevisionRuleDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a RevisionRuleDispatch
    RevisionRuleDispatch( const RevisionRuleDispatch& );

    //  Assignment operator
    RevisionRuleDispatch&  operator = ( const RevisionRuleDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::RevisionRuleDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__REVISIONRULEDISPATCH_HXX
