//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RoleDispatch
    Filename:   RoleDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ROLEDISPATCH_HXX
#define TEAMCENTER__ROLEDISPATCH_HXX

#include <vector>
#include <sa/Role.hxx>
#include <sa/RoleDelegate.hxx>
#include <foundationdispatch/POM_application_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class RoleDispatch;
}
namespace Teamcenter
{
    class RoleDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::RoleDispatch
    : public  Teamcenter::RoleDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the RoleDispatch instance
    static RoleDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static RoleDispatch*  m_dispatch;

    //  Default Constructor
    RoleDispatch();

    //  Default Destructor
    virtual ~RoleDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a RoleDispatch
    RoleDispatch( const RoleDispatch& );

    //  Assignment operator
    RoleDispatch&  operator = ( const RoleDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::RoleDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__ROLEDISPATCH_HXX
