//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RouteCurveDispatch
    Filename:   RouteCurveDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ROUTECURVEDISPATCH_HXX
#define TEAMCENTER__ROUTECURVEDISPATCH_HXX

#include <vector>
#include <mechatronics/RouteCurve.hxx>
#include <mechatronics/RouteCurveDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class RouteCurveDispatch;
}
namespace Teamcenter
{
    class RouteCurveDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::RouteCurveDispatch
    : public  Teamcenter::RouteCurveDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the RouteCurveDispatch instance
    static RouteCurveDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static RouteCurveDispatch*  m_dispatch;

    //  Default Constructor
    RouteCurveDispatch();

    //  Default Destructor
    virtual ~RouteCurveDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a RouteCurveDispatch
    RouteCurveDispatch( const RouteCurveDispatch& );

    //  Assignment operator
    RouteCurveDispatch&  operator = ( const RouteCurveDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::RouteCurveDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__ROUTECURVEDISPATCH_HXX
