//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RouteDisplayDispatch
    Filename:   RouteDisplayDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ROUTEDISPLAYDISPATCH_HXX
#define TEAMCENTER__ROUTEDISPLAYDISPATCH_HXX

#include <vector>
#include <mechatronics/RouteDisplay.hxx>
#include <mechatronics/RouteDisplayDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class RouteDisplayDispatch;
}
namespace Teamcenter
{
    class RouteDisplayDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::RouteDisplayDispatch
    : public  Teamcenter::RouteDisplayDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the RouteDisplayDispatch instance
    static RouteDisplayDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static RouteDisplayDispatch*  m_dispatch;

    //  Default Constructor
    RouteDisplayDispatch();

    //  Default Destructor
    virtual ~RouteDisplayDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a RouteDisplayDispatch
    RouteDisplayDispatch( const RouteDisplayDispatch& );

    //  Assignment operator
    RouteDisplayDispatch&  operator = ( const RouteDisplayDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::RouteDisplayDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__ROUTEDISPLAYDISPATCH_HXX
