//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RouteLocationDispatch
    Filename:   RouteLocationDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ROUTELOCATIONDISPATCH_HXX
#define TEAMCENTER__ROUTELOCATIONDISPATCH_HXX

#include <vector>
#include <mechatronics/RouteLocation.hxx>
#include <mechatronics/RouteLocationDelegate.hxx>
#include <foundationdispatch/ItemDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class RouteLocationDispatch;
}
namespace Teamcenter
{
    class RouteLocationDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::RouteLocationDispatch
    : public  Teamcenter::RouteLocationDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the RouteLocationDispatch instance
    static RouteLocationDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static RouteLocationDispatch*  m_dispatch;

    //  Default Constructor
    RouteLocationDispatch();

    //  Default Destructor
    virtual ~RouteLocationDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a RouteLocationDispatch
    RouteLocationDispatch( const RouteLocationDispatch& );

    //  Assignment operator
    RouteLocationDispatch&  operator = ( const RouteLocationDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::RouteLocationDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__ROUTELOCATIONDISPATCH_HXX
