//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RouteLocationRevisionDispatch
    Filename:   RouteLocationRevisionDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ROUTELOCATIONREVISIONDISPATCH_HXX
#define TEAMCENTER__ROUTELOCATIONREVISIONDISPATCH_HXX

#include <vector>
#include <mechatronics/RouteLocationRevision.hxx>
#include <mechatronics/RouteLocationRevisionDelegate.hxx>
#include <foundationdispatch/ItemRevisionDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class RouteLocationRevisionDispatch;
}
namespace Teamcenter
{
    class RouteLocationRevisionDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::RouteLocationRevisionDispatch
    : public  Teamcenter::RouteLocationRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the RouteLocationRevisionDispatch instance
    static RouteLocationRevisionDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static RouteLocationRevisionDispatch*  m_dispatch;

    //  Default Constructor
    RouteLocationRevisionDispatch();

    //  Default Destructor
    virtual ~RouteLocationRevisionDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a RouteLocationRevisionDispatch
    RouteLocationRevisionDispatch( const RouteLocationRevisionDispatch& );

    //  Assignment operator
    RouteLocationRevisionDispatch&  operator = ( const RouteLocationRevisionDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::RouteLocationRevisionDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__ROUTELOCATIONREVISIONDISPATCH_HXX
