//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RouteNodeDispatch
    Filename:   RouteNodeDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ROUTENODEDISPATCH_HXX
#define TEAMCENTER__ROUTENODEDISPATCH_HXX

#include <vector>
#include <mechatronics/RouteNode.hxx>
#include <mechatronics/RouteNodeDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class RouteNodeDispatch;
}
namespace Teamcenter
{
    class RouteNodeDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::RouteNodeDispatch
    : public  Teamcenter::RouteNodeDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the RouteNodeDispatch instance
    static RouteNodeDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static RouteNodeDispatch*  m_dispatch;

    //  Default Constructor
    RouteNodeDispatch();

    //  Default Destructor
    virtual ~RouteNodeDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a RouteNodeDispatch
    RouteNodeDispatch( const RouteNodeDispatch& );

    //  Assignment operator
    RouteNodeDispatch&  operator = ( const RouteNodeDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::RouteNodeDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__ROUTENODEDISPATCH_HXX
