//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RoutePathDispatch
    Filename:   RoutePathDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ROUTEPATHDISPATCH_HXX
#define TEAMCENTER__ROUTEPATHDISPATCH_HXX

#include <vector>
#include <mechatronics/RoutePath.hxx>
#include <mechatronics/RoutePathDelegate.hxx>
#include <foundationdispatch/WorkspaceObjectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class RoutePathDispatch;
}
namespace Teamcenter
{
    class RoutePathDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::RoutePathDispatch
    : public  Teamcenter::RoutePathDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the RoutePathDispatch instance
    static RoutePathDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static RoutePathDispatch*  m_dispatch;

    //  Default Constructor
    RoutePathDispatch();

    //  Default Destructor
    virtual ~RoutePathDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a RoutePathDispatch
    RoutePathDispatch( const RoutePathDispatch& );

    //  Assignment operator
    RoutePathDispatch&  operator = ( const RoutePathDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::RoutePathDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__ROUTEPATHDISPATCH_HXX
