//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RouteSegmentDispatch
    Filename:   RouteSegmentDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ROUTESEGMENTDISPATCH_HXX
#define TEAMCENTER__ROUTESEGMENTDISPATCH_HXX

#include <vector>
#include <mechatronics/RouteSegment.hxx>
#include <mechatronics/RouteSegmentDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class RouteSegmentDispatch;
}
namespace Teamcenter
{
    class RouteSegmentDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::RouteSegmentDispatch
    : public  Teamcenter::RouteSegmentDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the RouteSegmentDispatch instance
    static RouteSegmentDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static RouteSegmentDispatch*  m_dispatch;

    //  Default Constructor
    RouteSegmentDispatch();

    //  Default Destructor
    virtual ~RouteSegmentDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a RouteSegmentDispatch
    RouteSegmentDispatch( const RouteSegmentDispatch& );

    //  Assignment operator
    RouteSegmentDispatch&  operator = ( const RouteSegmentDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::RouteSegmentDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__ROUTESEGMENTDISPATCH_HXX
