//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RuntimeBusinessObjectDispatch
    Filename:   RuntimeBusinessObjectDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__RUNTIMEBUSINESSOBJECTDISPATCH_HXX
#define TEAMCENTER__RUNTIMEBUSINESSOBJECTDISPATCH_HXX

#include <vector>
#include <metaframework/RuntimeBusinessObject.hxx>
#include <metaframework/RuntimeBusinessObjectDelegate.hxx>
#include <foundationdispatch/BusinessObjectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class RuntimeBusinessObjectDispatch;
}
namespace Teamcenter
{
    class RuntimeBusinessObjectDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::RuntimeBusinessObjectDispatch
    : public  Teamcenter::RuntimeBusinessObjectDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the RuntimeBusinessObjectDispatch instance
    static RuntimeBusinessObjectDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static RuntimeBusinessObjectDispatch*  m_dispatch;

    //  Default Constructor
    RuntimeBusinessObjectDispatch();

    //  Default Destructor
    virtual ~RuntimeBusinessObjectDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a RuntimeBusinessObjectDispatch
    RuntimeBusinessObjectDispatch( const RuntimeBusinessObjectDispatch& );

    //  Assignment operator
    RuntimeBusinessObjectDispatch&  operator = ( const RuntimeBusinessObjectDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::RuntimeBusinessObjectDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__RUNTIMEBUSINESSOBJECTDISPATCH_HXX
