//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ScheduleDispatch
    Filename:   ScheduleDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SCHEDULEDISPATCH_HXX
#define TEAMCENTER__SCHEDULEDISPATCH_HXX

#include <vector>
#include <schmgt/Schedule.hxx>
#include <schmgt/ScheduleDelegate.hxx>
#include <foundationdispatch/WorkspaceObjectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class ScheduleDispatch;
}
namespace Teamcenter
{
    class ScheduleDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::ScheduleDispatch
    : public  Teamcenter::ScheduleDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ScheduleDispatch instance
    static ScheduleDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static ScheduleDispatch*  m_dispatch;

    //  Default Constructor
    ScheduleDispatch();

    //  Default Destructor
    virtual ~ScheduleDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a ScheduleDispatch
    ScheduleDispatch( const ScheduleDispatch& );

    //  Assignment operator
    ScheduleDispatch&  operator = ( const ScheduleDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::ScheduleDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__SCHEDULEDISPATCH_HXX
