//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ScheduleTaskDispatch
    Filename:   ScheduleTaskDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SCHEDULETASKDISPATCH_HXX
#define TEAMCENTER__SCHEDULETASKDISPATCH_HXX

#include <vector>
#include <schmgt/ScheduleTask.hxx>
#include <schmgt/ScheduleTaskDelegate.hxx>
#include <foundationdispatch/WorkspaceObjectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class ScheduleTaskDispatch;
}
namespace Teamcenter
{
    class ScheduleTaskDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::ScheduleTaskDispatch
    : public  Teamcenter::ScheduleTaskDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ScheduleTaskDispatch instance
    static ScheduleTaskDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static ScheduleTaskDispatch*  m_dispatch;

    //  Default Constructor
    ScheduleTaskDispatch();

    //  Default Destructor
    virtual ~ScheduleTaskDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a ScheduleTaskDispatch
    ScheduleTaskDispatch( const ScheduleTaskDispatch& );

    //  Assignment operator
    ScheduleTaskDispatch&  operator = ( const ScheduleTaskDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::ScheduleTaskDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__SCHEDULETASKDISPATCH_HXX
