//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ServiceInterfaceDispatch
    Filename:   ServiceInterfaceDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEINTERFACEDISPATCH_HXX
#define TEAMCENTER__SERVICEINTERFACEDISPATCH_HXX

#include <vector>
#include <meta/ServiceInterface.hxx>
#include <meta/ServiceInterfaceDelegate.hxx>
#include <foundationdispatch/MetaInterfaceDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class ServiceInterfaceDispatch;
}
namespace Teamcenter
{
    class ServiceInterfaceDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::ServiceInterfaceDispatch
    : public  Teamcenter::ServiceInterfaceDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ServiceInterfaceDispatch instance
    static ServiceInterfaceDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static ServiceInterfaceDispatch*  m_dispatch;

    //  Default Constructor
    ServiceInterfaceDispatch();

    //  Default Destructor
    virtual ~ServiceInterfaceDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a ServiceInterfaceDispatch
    ServiceInterfaceDispatch( const ServiceInterfaceDispatch& );

    //  Assignment operator
    ServiceInterfaceDispatch&  operator = ( const ServiceInterfaceDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::ServiceInterfaceDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__SERVICEINTERFACEDISPATCH_HXX
