//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SignoffDispatch
    Filename:   SignoffDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SIGNOFFDISPATCH_HXX
#define TEAMCENTER__SIGNOFFDISPATCH_HXX

#include <vector>
#include <epm/Signoff.hxx>
#include <epm/SignoffDelegate.hxx>
#include <foundationdispatch/POM_application_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class SignoffDispatch;
}
namespace Teamcenter
{
    class SignoffDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::SignoffDispatch
    : public  Teamcenter::SignoffDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SignoffDispatch instance
    static SignoffDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static SignoffDispatch*  m_dispatch;

    //  Default Constructor
    SignoffDispatch();

    //  Default Destructor
    virtual ~SignoffDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a SignoffDispatch
    SignoffDispatch( const SignoffDispatch& );

    //  Assignment operator
    SignoffDispatch&  operator = ( const SignoffDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::SignoffDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__SIGNOFFDISPATCH_HXX
