//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SnapshotDispatch
    Filename:   SnapshotDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SNAPSHOTDISPATCH_HXX
#define TEAMCENTER__SNAPSHOTDISPATCH_HXX

#include <vector>
#include <bom/Snapshot.hxx>
#include <bom/SnapshotDelegate.hxx>
#include <foundationdispatch/FolderDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class SnapshotDispatch;
}
namespace Teamcenter
{
    class SnapshotDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::SnapshotDispatch
    : public  Teamcenter::SnapshotDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SnapshotDispatch instance
    static SnapshotDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static SnapshotDispatch*  m_dispatch;

    //  Default Constructor
    SnapshotDispatch();

    //  Default Destructor
    virtual ~SnapshotDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a SnapshotDispatch
    SnapshotDispatch( const SnapshotDispatch& );

    //  Assignment operator
    SnapshotDispatch&  operator = ( const SnapshotDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::SnapshotDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__SNAPSHOTDISPATCH_HXX
