//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SourceObjDispatch
    Filename:   SourceObjDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SOURCEOBJDISPATCH_HXX
#define TEAMCENTER__SOURCEOBJDISPATCH_HXX

#include <vector>
#include <docmgt/SourceObj.hxx>
#include <docmgt/SourceObjDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class SourceObjDispatch;
}
namespace Teamcenter
{
    class SourceObjDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::SourceObjDispatch
    : public  Teamcenter::SourceObjDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SourceObjDispatch instance
    static SourceObjDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static SourceObjDispatch*  m_dispatch;

    //  Default Constructor
    SourceObjDispatch();

    //  Default Destructor
    virtual ~SourceObjDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a SourceObjDispatch
    SourceObjDispatch( const SourceObjDispatch& );

    //  Assignment operator
    SourceObjDispatch&  operator = ( const SourceObjDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::SourceObjDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__SOURCEOBJDISPATCH_HXX
