//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, StorageMediaDispatch
    Filename:   StorageMediaDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__STORAGEMEDIADISPATCH_HXX
#define TEAMCENTER__STORAGEMEDIADISPATCH_HXX

#include <vector>
#include <sa/StorageMedia.hxx>
#include <sa/StorageMediaDelegate.hxx>
#include <foundationdispatch/POM_application_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class StorageMediaDispatch;
}
namespace Teamcenter
{
    class StorageMediaDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::StorageMediaDispatch
    : public  Teamcenter::StorageMediaDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the StorageMediaDispatch instance
    static StorageMediaDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static StorageMediaDispatch*  m_dispatch;

    //  Default Constructor
    StorageMediaDispatch();

    //  Default Destructor
    virtual ~StorageMediaDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a StorageMediaDispatch
    StorageMediaDispatch( const StorageMediaDispatch& );

    //  Assignment operator
    StorageMediaDispatch&  operator = ( const StorageMediaDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::StorageMediaDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__STORAGEMEDIADISPATCH_HXX
