//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, StructureContextDispatch
    Filename:   StructureContextDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__STRUCTURECONTEXTDISPATCH_HXX
#define TEAMCENTER__STRUCTURECONTEXTDISPATCH_HXX

#include <vector>
#include <collabctx/StructureContext.hxx>
#include <collabctx/StructureContextDelegate.hxx>
#include <foundationdispatch/WorkspaceObjectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class StructureContextDispatch;
}
namespace Teamcenter
{
    class StructureContextDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::StructureContextDispatch
    : public  Teamcenter::StructureContextDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the StructureContextDispatch instance
    static StructureContextDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static StructureContextDispatch*  m_dispatch;

    //  Default Constructor
    StructureContextDispatch();

    //  Default Destructor
    virtual ~StructureContextDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a StructureContextDispatch
    StructureContextDispatch( const StructureContextDispatch& );

    //  Assignment operator
    StructureContextDispatch&  operator = ( const StructureContextDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::StructureContextDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__STRUCTURECONTEXTDISPATCH_HXX
