//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SupercedureDispatch
    Filename:   SupercedureDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SUPERCEDUREDISPATCH_HXX
#define TEAMCENTER__SUPERCEDUREDISPATCH_HXX

#include <vector>
#include <ecm/Supercedure.hxx>
#include <ecm/SupercedureDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class SupercedureDispatch;
}
namespace Teamcenter
{
    class SupercedureDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::SupercedureDispatch
    : public  Teamcenter::SupercedureDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SupercedureDispatch instance
    static SupercedureDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static SupercedureDispatch*  m_dispatch;

    //  Default Constructor
    SupercedureDispatch();

    //  Default Destructor
    virtual ~SupercedureDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a SupercedureDispatch
    SupercedureDispatch( const SupercedureDispatch& );

    //  Assignment operator
    SupercedureDispatch&  operator = ( const SupercedureDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::SupercedureDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__SUPERCEDUREDISPATCH_HXX
