//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SystemStampConfigurationDispatch
    Filename:   SystemStampConfigurationDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SYSTEMSTAMPCONFIGURATIONDISPATCH_HXX
#define TEAMCENTER__SYSTEMSTAMPCONFIGURATIONDISPATCH_HXX

#include <vector>
#include <docmgt/SystemStampConfiguration.hxx>
#include <docmgt/SystemStampConfigurationDelegate.hxx>
#include <foundationdispatch/BusinessElementDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class SystemStampConfigurationDispatch;
}
namespace Teamcenter
{
    class SystemStampConfigurationDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::SystemStampConfigurationDispatch
    : public  Teamcenter::SystemStampConfigurationDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SystemStampConfigurationDispatch instance
    static SystemStampConfigurationDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static SystemStampConfigurationDispatch*  m_dispatch;

    //  Default Constructor
    SystemStampConfigurationDispatch();

    //  Default Destructor
    virtual ~SystemStampConfigurationDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a SystemStampConfigurationDispatch
    SystemStampConfigurationDispatch( const SystemStampConfigurationDispatch& );

    //  Assignment operator
    SystemStampConfigurationDispatch&  operator = ( const SystemStampConfigurationDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::SystemStampConfigurationDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__SYSTEMSTAMPCONFIGURATIONDISPATCH_HXX
