//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TableCellDispatch
    Filename:   TableCellDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TABLECELLDISPATCH_HXX
#define TEAMCENTER__TABLECELLDISPATCH_HXX

#include <vector>
#include <tccore/TableCell.hxx>
#include <tccore/TableCellDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class TableCellDispatch;
}
namespace Teamcenter
{
    class TableCellDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::TableCellDispatch
    : public  Teamcenter::TableCellDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the TableCellDispatch instance
    static TableCellDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static TableCellDispatch*  m_dispatch;

    //  Default Constructor
    TableCellDispatch();

    //  Default Destructor
    virtual ~TableCellDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a TableCellDispatch
    TableCellDispatch( const TableCellDispatch& );

    //  Assignment operator
    TableCellDispatch&  operator = ( const TableCellDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::TableCellDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__TABLECELLDISPATCH_HXX
