//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TableDispatch
    Filename:   TableDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TABLEDISPATCH_HXX
#define TEAMCENTER__TABLEDISPATCH_HXX

#include <vector>
#include <tccore/Table.hxx>
#include <tccore/TableDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class TableDispatch;
}
namespace Teamcenter
{
    class TableDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::TableDispatch
    : public  Teamcenter::TableDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the TableDispatch instance
    static TableDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static TableDispatch*  m_dispatch;

    //  Default Constructor
    TableDispatch();

    //  Default Destructor
    virtual ~TableDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a TableDispatch
    TableDispatch( const TableDispatch& );

    //  Assignment operator
    TableDispatch&  operator = ( const TableDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::TableDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__TABLEDISPATCH_HXX
