//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TaskDeliverableDispatch
    Filename:   TaskDeliverableDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TASKDELIVERABLEDISPATCH_HXX
#define TEAMCENTER__TASKDELIVERABLEDISPATCH_HXX

#include <vector>
#include <schmgt/TaskDeliverable.hxx>
#include <schmgt/TaskDeliverableDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class TaskDeliverableDispatch;
}
namespace Teamcenter
{
    class TaskDeliverableDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::TaskDeliverableDispatch
    : public  Teamcenter::TaskDeliverableDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the TaskDeliverableDispatch instance
    static TaskDeliverableDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static TaskDeliverableDispatch*  m_dispatch;

    //  Default Constructor
    TaskDeliverableDispatch();

    //  Default Destructor
    virtual ~TaskDeliverableDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a TaskDeliverableDispatch
    TaskDeliverableDispatch( const TaskDeliverableDispatch& );

    //  Assignment operator
    TaskDeliverableDispatch&  operator = ( const TaskDeliverableDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::TaskDeliverableDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__TASKDELIVERABLEDISPATCH_HXX
