//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TaskInboxDispatch
    Filename:   TaskInboxDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TASKINBOXDISPATCH_HXX
#define TEAMCENTER__TASKINBOXDISPATCH_HXX

#include <vector>
#include <epm/TaskInbox.hxx>
#include <epm/TaskInboxDelegate.hxx>
#include <foundationdispatch/FolderDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class TaskInboxDispatch;
}
namespace Teamcenter
{
    class TaskInboxDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::TaskInboxDispatch
    : public  Teamcenter::TaskInboxDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the TaskInboxDispatch instance
    static TaskInboxDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static TaskInboxDispatch*  m_dispatch;

    //  Default Constructor
    TaskInboxDispatch();

    //  Default Destructor
    virtual ~TaskInboxDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a TaskInboxDispatch
    TaskInboxDispatch( const TaskInboxDispatch& );

    //  Assignment operator
    TaskInboxDispatch&  operator = ( const TaskInboxDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::TaskInboxDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__TASKINBOXDISPATCH_HXX
