//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ToolDispatch
    Filename:   ToolDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TOOLDISPATCH_HXX
#define TEAMCENTER__TOOLDISPATCH_HXX

#include <vector>
#include <ae/Tool.hxx>
#include <ae/ToolDelegate.hxx>
#include <foundationdispatch/WorkspaceObjectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class ToolDispatch;
}
namespace Teamcenter
{
    class ToolDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::ToolDispatch
    : public  Teamcenter::ToolDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ToolDispatch instance
    static ToolDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static ToolDispatch*  m_dispatch;

    //  Default Constructor
    ToolDispatch();

    //  Default Destructor
    virtual ~ToolDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a ToolDispatch
    ToolDispatch( const ToolDispatch& );

    //  Assignment operator
    ToolDispatch&  operator = ( const ToolDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::ToolDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__TOOLDISPATCH_HXX
