//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TraceLinkDispatch
    Filename:   TraceLinkDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TRACELINKDISPATCH_HXX
#define TEAMCENTER__TRACELINKDISPATCH_HXX

#include <vector>
#include <mechatronics/TraceLink.hxx>
#include <mechatronics/TraceLinkDelegate.hxx>
#include <foundationdispatch/ManagedRelationDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class TraceLinkDispatch;
}
namespace Teamcenter
{
    class TraceLinkDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::TraceLinkDispatch
    : public  Teamcenter::TraceLinkDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the TraceLinkDispatch instance
    static TraceLinkDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static TraceLinkDispatch*  m_dispatch;

    //  Default Constructor
    TraceLinkDispatch();

    //  Default Destructor
    virtual ~TraceLinkDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a TraceLinkDispatch
    TraceLinkDispatch( const TraceLinkDispatch& );

    //  Assignment operator
    TraceLinkDispatch&  operator = ( const TraceLinkDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::TraceLinkDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__TRACELINKDISPATCH_HXX
