//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TransferModeDispatch
    Filename:   TransferModeDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TRANSFERMODEDISPATCH_HXX
#define TEAMCENTER__TRANSFERMODEDISPATCH_HXX

#include <vector>
#include <pie/TransferMode.hxx>
#include <pie/TransferModeDelegate.hxx>
#include <foundationdispatch/WorkspaceObjectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class TransferModeDispatch;
}
namespace Teamcenter
{
    class TransferModeDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::TransferModeDispatch
    : public  Teamcenter::TransferModeDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the TransferModeDispatch instance
    static TransferModeDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static TransferModeDispatch*  m_dispatch;

    //  Default Constructor
    TransferModeDispatch();

    //  Default Destructor
    virtual ~TransferModeDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a TransferModeDispatch
    TransferModeDispatch( const TransferModeDispatch& );

    //  Assignment operator
    TransferModeDispatch&  operator = ( const TransferModeDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::TransferModeDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__TRANSFERMODEDISPATCH_HXX
