//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TransferOptionSetDispatch
    Filename:   TransferOptionSetDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TRANSFEROPTIONSETDISPATCH_HXX
#define TEAMCENTER__TRANSFEROPTIONSETDISPATCH_HXX

#include <vector>
#include <pie/TransferOptionSet.hxx>
#include <pie/TransferOptionSetDelegate.hxx>
#include <foundationdispatch/WorkspaceObjectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class TransferOptionSetDispatch;
}
namespace Teamcenter
{
    class TransferOptionSetDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::TransferOptionSetDispatch
    : public  Teamcenter::TransferOptionSetDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the TransferOptionSetDispatch instance
    static TransferOptionSetDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static TransferOptionSetDispatch*  m_dispatch;

    //  Default Constructor
    TransferOptionSetDispatch();

    //  Default Destructor
    virtual ~TransferOptionSetDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a TransferOptionSetDispatch
    TransferOptionSetDispatch( const TransferOptionSetDispatch& );

    //  Assignment operator
    TransferOptionSetDispatch&  operator = ( const TransferOptionSetDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::TransferOptionSetDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__TRANSFEROPTIONSETDISPATCH_HXX
