//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, UserDispatch
    Filename:   UserDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__USERDISPATCH_HXX
#define TEAMCENTER__USERDISPATCH_HXX

#include <vector>
#include <sa/User.hxx>
#include <sa/UserDelegate.hxx>
#include <foundationdispatch/POM_userDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class UserDispatch;
}
namespace Teamcenter
{
    class UserDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::UserDispatch
    : public  Teamcenter::UserDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the UserDispatch instance
    static UserDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static UserDispatch*  m_dispatch;

    //  Default Constructor
    UserDispatch();

    //  Default Destructor
    virtual ~UserDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a UserDispatch
    UserDispatch( const UserDispatch& );

    //  Assignment operator
    UserDispatch&  operator = ( const UserDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::UserDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__USERDISPATCH_HXX
