//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, UserSessionDispatch
    Filename:   UserSessionDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__USERSESSIONDISPATCH_HXX
#define TEAMCENTER__USERSESSIONDISPATCH_HXX

#include <vector>
#include <ce/UserSession.hxx>
#include <ce/UserSessionDelegate.hxx>
#include <foundationdispatch/RuntimeBusinessObjectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class UserSessionDispatch;
}
namespace Teamcenter
{
    class UserSessionDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::UserSessionDispatch
    : public  Teamcenter::UserSessionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the UserSessionDispatch instance
    static UserSessionDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static UserSessionDispatch*  m_dispatch;

    //  Default Constructor
    UserSessionDispatch();

    //  Default Destructor
    virtual ~UserSessionDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a UserSessionDispatch
    UserSessionDispatch( const UserSessionDispatch& );

    //  Assignment operator
    UserSessionDispatch&  operator = ( const UserSessionDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::UserSessionDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__USERSESSIONDISPATCH_HXX
