//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, VM_PolicyDispatch
    Filename:   VM_PolicyDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VM_POLICYDISPATCH_HXX
#define TEAMCENTER__VM_POLICYDISPATCH_HXX

#include <vector>
#include <sa/VM_Policy.hxx>
#include <sa/VM_PolicyDelegate.hxx>
#include <foundationdispatch/Migration_PolicyDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class VM_PolicyDispatch;
}
namespace Teamcenter
{
    class VM_PolicyDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::VM_PolicyDispatch
    : public  Teamcenter::VM_PolicyDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the VM_PolicyDispatch instance
    static VM_PolicyDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static VM_PolicyDispatch*  m_dispatch;

    //  Default Constructor
    VM_PolicyDispatch();

    //  Default Destructor
    virtual ~VM_PolicyDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a VM_PolicyDispatch
    VM_PolicyDispatch( const VM_PolicyDispatch& );

    //  Assignment operator
    VM_PolicyDispatch&  operator = ( const VM_PolicyDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::VM_PolicyDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__VM_POLICYDISPATCH_HXX
