//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ValidationAgentDispatch
    Filename:   ValidationAgentDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VALIDATIONAGENTDISPATCH_HXX
#define TEAMCENTER__VALIDATIONAGENTDISPATCH_HXX

#include <vector>
#include <validation/ValidationAgent.hxx>
#include <validation/ValidationAgentDelegate.hxx>
#include <foundationdispatch/ItemDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class ValidationAgentDispatch;
}
namespace Teamcenter
{
    class ValidationAgentDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::ValidationAgentDispatch
    : public  Teamcenter::ValidationAgentDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ValidationAgentDispatch instance
    static ValidationAgentDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static ValidationAgentDispatch*  m_dispatch;

    //  Default Constructor
    ValidationAgentDispatch();

    //  Default Destructor
    virtual ~ValidationAgentDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a ValidationAgentDispatch
    ValidationAgentDispatch( const ValidationAgentDispatch& );

    //  Assignment operator
    ValidationAgentDispatch&  operator = ( const ValidationAgentDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::ValidationAgentDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__VALIDATIONAGENTDISPATCH_HXX
