//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ValidationDataDispatch
    Filename:   ValidationDataDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VALIDATIONDATADISPATCH_HXX
#define TEAMCENTER__VALIDATIONDATADISPATCH_HXX

#include <vector>
#include <validation/ValidationData.hxx>
#include <validation/ValidationDataDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class ValidationDataDispatch;
}
namespace Teamcenter
{
    class ValidationDataDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::ValidationDataDispatch
    : public  Teamcenter::ValidationDataDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ValidationDataDispatch instance
    static ValidationDataDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static ValidationDataDispatch*  m_dispatch;

    //  Default Constructor
    ValidationDataDispatch();

    //  Default Destructor
    virtual ~ValidationDataDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a ValidationDataDispatch
    ValidationDataDispatch( const ValidationDataDispatch& );

    //  Assignment operator
    ValidationDataDispatch&  operator = ( const ValidationDataDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::ValidationDataDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__VALIDATIONDATADISPATCH_HXX
