//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, VariantDispatch
    Filename:   VariantDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VARIANTDISPATCH_HXX
#define TEAMCENTER__VARIANTDISPATCH_HXX

#include <vector>
#include <ps/Variant.hxx>
#include <ps/VariantDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class VariantDispatch;
}
namespace Teamcenter
{
    class VariantDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::VariantDispatch
    : public  Teamcenter::VariantDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the VariantDispatch instance
    static VariantDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static VariantDispatch*  m_dispatch;

    //  Default Constructor
    VariantDispatch();

    //  Default Destructor
    virtual ~VariantDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a VariantDispatch
    VariantDispatch( const VariantDispatch& );

    //  Assignment operator
    VariantDispatch&  operator = ( const VariantDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::VariantDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__VARIANTDISPATCH_HXX
