//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, VariantRevisionDispatch
    Filename:   VariantRevisionDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VARIANTREVISIONDISPATCH_HXX
#define TEAMCENTER__VARIANTREVISIONDISPATCH_HXX

#include <vector>
#include <ps/VariantRevision.hxx>
#include <ps/VariantRevisionDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class VariantRevisionDispatch;
}
namespace Teamcenter
{
    class VariantRevisionDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::VariantRevisionDispatch
    : public  Teamcenter::VariantRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the VariantRevisionDispatch instance
    static VariantRevisionDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static VariantRevisionDispatch*  m_dispatch;

    //  Default Constructor
    VariantRevisionDispatch();

    //  Default Destructor
    virtual ~VariantRevisionDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a VariantRevisionDispatch
    VariantRevisionDispatch( const VariantRevisionDispatch& );

    //  Assignment operator
    VariantRevisionDispatch&  operator = ( const VariantRevisionDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::VariantRevisionDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__VARIANTREVISIONDISPATCH_HXX
