//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, VerificationRuleDispatch
    Filename:   VerificationRuleDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VERIFICATIONRULEDISPATCH_HXX
#define TEAMCENTER__VERIFICATIONRULEDISPATCH_HXX

#include <vector>
#include <functionality/VerificationRule.hxx>
#include <functionality/VerificationRuleDelegate.hxx>
#include <foundationdispatch/BusinessRuleDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class VerificationRuleDispatch;
}
namespace Teamcenter
{
    class VerificationRuleDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::VerificationRuleDispatch
    : public  Teamcenter::VerificationRuleDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the VerificationRuleDispatch instance
    static VerificationRuleDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static VerificationRuleDispatch*  m_dispatch;

    //  Default Constructor
    VerificationRuleDispatch();

    //  Default Destructor
    virtual ~VerificationRuleDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a VerificationRuleDispatch
    VerificationRuleDispatch( const VerificationRuleDispatch& );

    //  Assignment operator
    VerificationRuleDispatch&  operator = ( const VerificationRuleDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::VerificationRuleDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__VERIFICATIONRULEDISPATCH_HXX
