//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, VisStructureContextDispatch
    Filename:   VisStructureContextDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VISSTRUCTURECONTEXTDISPATCH_HXX
#define TEAMCENTER__VISSTRUCTURECONTEXTDISPATCH_HXX

#include <vector>
#include <collabctx/VisStructureContext.hxx>
#include <collabctx/VisStructureContextDelegate.hxx>
#include <foundationdispatch/StructureContextDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class VisStructureContextDispatch;
}
namespace Teamcenter
{
    class VisStructureContextDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::VisStructureContextDispatch
    : public  Teamcenter::VisStructureContextDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the VisStructureContextDispatch instance
    static VisStructureContextDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static VisStructureContextDispatch*  m_dispatch;

    //  Default Constructor
    VisStructureContextDispatch();

    //  Default Destructor
    virtual ~VisStructureContextDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a VisStructureContextDispatch
    VisStructureContextDispatch( const VisStructureContextDispatch& );

    //  Assignment operator
    VisStructureContextDispatch&  operator = ( const VisStructureContextDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::VisStructureContextDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__VISSTRUCTURECONTEXTDISPATCH_HXX
