//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, WeldPointDispatch
    Filename:   WeldPointDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__WELDPOINTDISPATCH_HXX
#define TEAMCENTER__WELDPOINTDISPATCH_HXX

#include <vector>
#include <mfgbvr/WeldPoint.hxx>
#include <mfgbvr/WeldPointDelegate.hxx>
#include <foundationdispatch/PSConnectionDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class WeldPointDispatch;
}
namespace Teamcenter
{
    class WeldPointDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::WeldPointDispatch
    : public  Teamcenter::WeldPointDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the WeldPointDispatch instance
    static WeldPointDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static WeldPointDispatch*  m_dispatch;

    //  Default Constructor
    WeldPointDispatch();

    //  Default Destructor
    virtual ~WeldPointDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a WeldPointDispatch
    WeldPointDispatch( const WeldPointDispatch& );

    //  Assignment operator
    WeldPointDispatch&  operator = ( const WeldPointDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::WeldPointDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__WELDPOINTDISPATCH_HXX
