//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, WolfObjectDispatch
    Filename:   WolfObjectDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__WOLFOBJECTDISPATCH_HXX
#define TEAMCENTER__WOLFOBJECTDISPATCH_HXX

#include <vector>
#include <wproxy/WolfObject.hxx>
#include <wproxy/WolfObjectDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class WolfObjectDispatch;
}
namespace Teamcenter
{
    class WolfObjectDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::WolfObjectDispatch
    : public  Teamcenter::WolfObjectDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the WolfObjectDispatch instance
    static WolfObjectDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static WolfObjectDispatch*  m_dispatch;

    //  Default Constructor
    WolfObjectDispatch();

    //  Default Destructor
    virtual ~WolfObjectDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a WolfObjectDispatch
    WolfObjectDispatch( const WolfObjectDispatch& );

    //  Assignment operator
    WolfObjectDispatch&  operator = ( const WolfObjectDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::WolfObjectDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__WOLFOBJECTDISPATCH_HXX
