//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, WorkspaceObjectDispatch
    Filename:   WorkspaceObjectDispatch.hxx
    Module:     foundationdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__WORKSPACEOBJECTDISPATCH_HXX
#define TEAMCENTER__WORKSPACEOBJECTDISPATCH_HXX

#include <vector>
#include <tccore/WorkspaceObject.hxx>
#include <tccore/WorkspaceObjectDelegate.hxx>
#include <foundationdispatch/POM_application_objectDispatch.hxx>
#include <foundationdispatch/initializefoundation.hxx>

#include <foundationdispatch/libfoundationdispatch_exports.h>

namespace Teamcenter
{
    class WorkspaceObjectDispatch;
}
namespace Teamcenter
{
    class WorkspaceObjectDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  FOUNDATIONDISPATCH_API  Teamcenter::WorkspaceObjectDispatch
    : public  Teamcenter::WorkspaceObjectDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the WorkspaceObjectDispatch instance
    static WorkspaceObjectDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static WorkspaceObjectDispatch*  m_dispatch;

    //  Default Constructor
    WorkspaceObjectDispatch();

    //  Default Destructor
    virtual ~WorkspaceObjectDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a WorkspaceObjectDispatch
    WorkspaceObjectDispatch( const WorkspaceObjectDispatch& );

    //  Assignment operator
    WorkspaceObjectDispatch&  operator = ( const WorkspaceObjectDispatch& );

    //  friend
    friend void   ::Teamcenter::initializefoundationInternal();
    friend void   ::Teamcenter::initializefoundationExtenders();
    friend class  Teamcenter::WorkspaceObjectDelegate;
};

#include <foundationdispatch/libfoundationdispatch_undef.h>
#endif  //  TEAMCENTER__WORKSPACEOBJECTDISPATCH_HXX
