//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  foundationdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libfoundationdispatch

#if !defined(LIBFOUNDATIONDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBFOUNDATIONDISPATCH is not defined
#endif

/* Handwritten code should use FOUNDATIONDISPATCH_API, not FOUNDATIONDISPATCHEXPORT */

#define FOUNDATIONDISPATCH_API FOUNDATIONDISPATCHEXPORT

#if IPLIB==libfoundationdispatch || defined(LIBFOUNDATIONDISPATCH)
#   if defined(__lint)
#       define FOUNDATIONDISPATCHEXPORT       __export(foundationdispatch)
#       define FOUNDATIONDISPATCHGLOBAL       extern __global(foundationdispatch)
#       define FOUNDATIONDISPATCHPRIVATE      extern __private(foundationdispatch)
#   elif defined(_WIN32)
#       define FOUNDATIONDISPATCHEXPORT       __declspec(dllexport)
#       define FOUNDATIONDISPATCHGLOBAL       extern __declspec(dllexport)
#       define FOUNDATIONDISPATCHPRIVATE      extern
#   else
#       define FOUNDATIONDISPATCHEXPORT
#       define FOUNDATIONDISPATCHGLOBAL       extern
#       define FOUNDATIONDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define FOUNDATIONDISPATCHEXPORT       __export(foundationdispatch)
#       define FOUNDATIONDISPATCHGLOBAL       extern __global(foundationdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define FOUNDATIONDISPATCHEXPORT      __declspec(dllimport)
#       define FOUNDATIONDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define FOUNDATIONDISPATCHEXPORT
#       define FOUNDATIONDISPATCHGLOBAL       extern
#   endif
#endif
