//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPFinishProduct
    Filename:   CPFinishProduct.hxx
    Module:     fpmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FPMGMT__CPFINISHPRODUCT__HXX
#define TEAMCENTER__FPMGMT__CPFINISHPRODUCT__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <fpmgmt/libfpmgmt_exports.h>

namespace Teamcenter
{
    namespace FPMGMT
    {
        class CPFinishProduct;
    }
}
namespace Teamcenter
{
    namespace FPMGMT
    {
        class CPFinishProductImpl;
    }
}
namespace Teamcenter
{
    namespace FPMGMT
    {
        class CPFinishProductDelegate;
    }
}
namespace Teamcenter
{
    namespace FPMGMT
    {
        class CPFinishProductDispatch;
    }
}
namespace Teamcenter
{
    namespace FPMGMT
    {
        class CPFinishProductGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FPMGMT_API  Teamcenter::FPMGMT::CPFinishProduct
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFinished_product_code( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFinished_product_code( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CPFinishProduct();

    /**
     * Destructor
     */
    virtual ~CPFinishProduct();

private:
    //  Getter method for the Implementation Object
    CPFinishProductImpl*  getCPFinishProductImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCPFinishProductImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CPFinishProductImpl*  m_cpfinishproductImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CPFinishProduct - desc for CPFinishProduct parameter
     */
    CPFinishProduct( const CPFinishProduct& );
    CPFinishProduct& operator=( const CPFinishProduct& );

    friend class  CPFinishProductDelegate;
    friend class  CPFinishProductDispatch;
    friend class  CPFinishProductGenImpl;
};

#include <fpmgmt/libfpmgmt_undef.h>
#endif //   TEAMCENTER__FPMGMT__CPFINISHPRODUCT__HXX
