//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPFinishProductDelegate
    Filename:   CPFinishProductDelegate.hxx
    Module:     fpmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FPMGMT__CPFINISHPRODUCTDELEGATE_HXX
#define TEAMCENTER__FPMGMT__CPFINISHPRODUCTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <fpmgmt/CPFinishProduct.hxx>

#include <fpmgmt/libfpmgmt_exports.h>

namespace Teamcenter
{
    namespace FPMGMT
    {
        class CPFinishProductDelegate;
    }
}
namespace Teamcenter
{
    namespace FPMGMT
    {
        class CPFinishProductImpl;
    }
}
namespace Teamcenter
{
    namespace FPMGMT
    {
        class CPFinishProduct;
    }
}
namespace Teamcenter
{
    namespace FPMGMT
    {
        class CPFinishProductGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  FPMGMT_API Teamcenter_alias::FPMGMT::CPFinishProductDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CPFinishProductDelegate instance
    static CPFinishProductDelegate&  getInstance();

    //  Method to create the CPFinishProductImpl pointer
    static CPFinishProductImpl*  createImpl( CPFinishProduct&  ifObj );

    //  Method to delete the CPFinishProductImpl pointer
    static void deleteImpl( CPFinishProductImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFinished_product_codeBase(const CPFinishProduct &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFinished_product_codeBase(CPFinishProduct &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static CPFinishProductDelegate*  m_pInstance;

    CPFinishProductDelegate();
    virtual ~CPFinishProductDelegate();
    static void setInstance( CPFinishProductDelegate*  instance );


private:
    friend class  ::Teamcenter::FPMGMT::CPFinishProductGenImpl;

};

#include <fpmgmt/libfpmgmt_undef.h>
#endif  //  TEAMCENTER__FPMGMT__CPFINISHPRODUCTDELEGATE_HXX
