//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPFinishProductRevisionDelegate
    Filename:   CPFinishProductRevisionDelegate.hxx
    Module:     fpmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FPMGMT__CPFINISHPRODUCTREVISIONDELEGATE_HXX
#define TEAMCENTER__FPMGMT__CPFINISHPRODUCTREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <fpmgmt/CPFinishProductRevision.hxx>

#include <fpmgmt/libfpmgmt_exports.h>

namespace Teamcenter
{
    namespace FPMGMT
    {
        class CPFinishProductRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace FPMGMT
    {
        class CPFinishProductRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace FPMGMT
    {
        class CPFinishProductRevision;
    }
}
namespace Teamcenter
{
    namespace FPMGMT
    {
        class CPFinishProductRevisionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  FPMGMT_API Teamcenter_alias::FPMGMT::CPFinishProductRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CPFinishProductRevisionDelegate instance
    static CPFinishProductRevisionDelegate&  getInstance();

    //  Method to create the CPFinishProductRevisionImpl pointer
    static CPFinishProductRevisionImpl*  createImpl( CPFinishProductRevision&  ifObj );

    //  Method to delete the CPFinishProductRevisionImpl pointer
    static void deleteImpl( CPFinishProductRevisionImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getChannelBase(const CPFinishProductRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCP_trade_itemBase(const CPFinishProductRevision &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCurrencyBase(const CPFinishProductRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDepthBase(const CPFinishProductRevision &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDimension_unitBase(const CPFinishProductRevision &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getGross_weightBase(const CPFinishProductRevision &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getHeightBase(const CPFinishProductRevision &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMarket_clearance_noBase(const CPFinishProductRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPriceBase(const CPFinishProductRevision &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getShelf_lifeBase(const CPFinishProductRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getStorage_conditionsBase(const CPFinishProductRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getWeight_unitBase(const CPFinishProductRevision &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getWidthBase(const CPFinishProductRevision &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setChannelBase(CPFinishProductRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCurrencyBase(CPFinishProductRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDepthBase(CPFinishProductRevision &ifObj,  double value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDimension_unitBase(CPFinishProductRevision &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setGross_weightBase(CPFinishProductRevision &ifObj,  double value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setHeightBase(CPFinishProductRevision &ifObj,  double value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMarket_clearance_noBase(CPFinishProductRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPriceBase(CPFinishProductRevision &ifObj,  double value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setShelf_lifeBase(CPFinishProductRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setStorage_conditionsBase(CPFinishProductRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setWeight_unitBase(CPFinishProductRevision &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setWidthBase(CPFinishProductRevision &ifObj,  double value, bool isNull );



protected:
    //  Pointer to the instance
    static CPFinishProductRevisionDelegate*  m_pInstance;

    CPFinishProductRevisionDelegate();
    virtual ~CPFinishProductRevisionDelegate();
    static void setInstance( CPFinishProductRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::FPMGMT::CPFinishProductRevisionGenImpl;

};

#include <fpmgmt/libfpmgmt_undef.h>
#endif  //  TEAMCENTER__FPMGMT__CPFINISHPRODUCTREVISIONDELEGATE_HXX
