//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPTradeItem
    Filename:   CPTradeItem.hxx
    Module:     fpmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FPMGMT__CPTRADEITEM__HXX
#define TEAMCENTER__FPMGMT__CPTRADEITEM__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <fpmgmt/libfpmgmt_exports.h>

namespace Teamcenter
{
    namespace FPMGMT
    {
        class CPTradeItem;
    }
}
namespace Teamcenter
{
    namespace FPMGMT
    {
        class CPTradeItemImpl;
    }
}
namespace Teamcenter
{
    namespace FPMGMT
    {
        class CPTradeItemDelegate;
    }
}
namespace Teamcenter
{
    namespace FPMGMT
    {
        class CPTradeItemDispatch;
    }
}
namespace Teamcenter
{
    namespace FPMGMT
    {
        class CPTradeItemGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FPMGMT_API  Teamcenter::FPMGMT::CPTradeItem
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getGtin( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setGtin( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CPTradeItem();

    /**
     * Destructor
     */
    virtual ~CPTradeItem();

private:
    //  Getter method for the Implementation Object
    CPTradeItemImpl*  getCPTradeItemImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCPTradeItemImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CPTradeItemImpl*  m_cptradeitemImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CPTradeItem - desc for CPTradeItem parameter
     */
    CPTradeItem( const CPTradeItem& );
    CPTradeItem& operator=( const CPTradeItem& );

    friend class  CPTradeItemDelegate;
    friend class  CPTradeItemDispatch;
    friend class  CPTradeItemGenImpl;
};

#include <fpmgmt/libfpmgmt_undef.h>
#endif //   TEAMCENTER__FPMGMT__CPTRADEITEM__HXX
