//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPTradeItemDelegate
    Filename:   CPTradeItemDelegate.hxx
    Module:     fpmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FPMGMT__CPTRADEITEMDELEGATE_HXX
#define TEAMCENTER__FPMGMT__CPTRADEITEMDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <fpmgmt/CPTradeItem.hxx>

#include <fpmgmt/libfpmgmt_exports.h>

namespace Teamcenter
{
    namespace FPMGMT
    {
        class CPTradeItemDelegate;
    }
}
namespace Teamcenter
{
    namespace FPMGMT
    {
        class CPTradeItemImpl;
    }
}
namespace Teamcenter
{
    namespace FPMGMT
    {
        class CPTradeItem;
    }
}
namespace Teamcenter
{
    namespace FPMGMT
    {
        class CPTradeItemGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  FPMGMT_API Teamcenter_alias::FPMGMT::CPTradeItemDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CPTradeItemDelegate instance
    static CPTradeItemDelegate&  getInstance();

    //  Method to create the CPTradeItemImpl pointer
    static CPTradeItemImpl*  createImpl( CPTradeItem&  ifObj );

    //  Method to delete the CPTradeItemImpl pointer
    static void deleteImpl( CPTradeItemImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getGtinBase(const CPTradeItem &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setGtinBase(CPTradeItem &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static CPTradeItemDelegate*  m_pInstance;

    CPTradeItemDelegate();
    virtual ~CPTradeItemDelegate();
    static void setInstance( CPTradeItemDelegate*  instance );


private:
    friend class  ::Teamcenter::FPMGMT::CPTradeItemGenImpl;

};

#include <fpmgmt/libfpmgmt_undef.h>
#endif  //  TEAMCENTER__FPMGMT__CPTRADEITEMDELEGATE_HXX
