//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPTradeItemRevision
    Filename:   CPTradeItemRevision.hxx
    Module:     fpmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FPMGMT__CPTRADEITEMREVISION__HXX
#define TEAMCENTER__FPMGMT__CPTRADEITEMREVISION__HXX

#include <string>
#include <vector>
#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <fpmgmt/libfpmgmt_exports.h>

namespace Teamcenter
{
    namespace FPMGMT
    {
        class CPTradeItemRevision;
    }
}
namespace Teamcenter
{
    namespace FPMGMT
    {
        class CPTradeItemRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace FPMGMT
    {
        class CPTradeItemRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace FPMGMT
    {
        class CPTradeItemRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace FPMGMT
    {
        class CPTradeItemRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FPMGMT_API  Teamcenter::FPMGMT::CPTradeItemRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBrand_name( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCP_finished_products( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getQty_layers_in_trade_item( int &value, bool &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getQty_trade_item_in_layer( int &value, bool &isNull ) const;

    ///
    /// Getter for a Date Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getReg_expiry_date( date_t &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getTarget_market( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getUnit_descriptor( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setBrand_name( const std::string &value, bool isNull=false );

    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setQty_layers_in_trade_item( int value, bool isNull=false );

    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setQty_trade_item_in_layer( int value, bool isNull=false );

    ///
    /// Setter for a Date Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setReg_expiry_date( const date_t &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setTarget_market( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setUnit_descriptor( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CPTradeItemRevision();

    /**
     * Destructor
     */
    virtual ~CPTradeItemRevision();

private:
    //  Getter method for the Implementation Object
    CPTradeItemRevisionImpl*  getCPTradeItemRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCPTradeItemRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CPTradeItemRevisionImpl*  m_cptradeitemrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CPTradeItemRevision - desc for CPTradeItemRevision parameter
     */
    CPTradeItemRevision( const CPTradeItemRevision& );
    CPTradeItemRevision& operator=( const CPTradeItemRevision& );

    friend class  CPTradeItemRevisionDelegate;
    friend class  CPTradeItemRevisionDispatch;
    friend class  CPTradeItemRevisionGenImpl;
};

#include <fpmgmt/libfpmgmt_undef.h>
#endif //   TEAMCENTER__FPMGMT__CPTRADEITEMREVISION__HXX
