//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPTradeItemRevisionDelegate
    Filename:   CPTradeItemRevisionDelegate.hxx
    Module:     fpmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FPMGMT__CPTRADEITEMREVISIONDELEGATE_HXX
#define TEAMCENTER__FPMGMT__CPTRADEITEMREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <fpmgmt/CPTradeItemRevision.hxx>

#include <fpmgmt/libfpmgmt_exports.h>

namespace Teamcenter
{
    namespace FPMGMT
    {
        class CPTradeItemRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace FPMGMT
    {
        class CPTradeItemRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace FPMGMT
    {
        class CPTradeItemRevision;
    }
}
namespace Teamcenter
{
    namespace FPMGMT
    {
        class CPTradeItemRevisionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  FPMGMT_API Teamcenter_alias::FPMGMT::CPTradeItemRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CPTradeItemRevisionDelegate instance
    static CPTradeItemRevisionDelegate&  getInstance();

    //  Method to create the CPTradeItemRevisionImpl pointer
    static CPTradeItemRevisionImpl*  createImpl( CPTradeItemRevision&  ifObj );

    //  Method to delete the CPTradeItemRevisionImpl pointer
    static void deleteImpl( CPTradeItemRevisionImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBrand_nameBase(const CPTradeItemRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCP_finished_productsBase(const CPTradeItemRevision &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getQty_layers_in_trade_itemBase(const CPTradeItemRevision &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getQty_trade_item_in_layerBase(const CPTradeItemRevision &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a Date Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getReg_expiry_dateBase(const CPTradeItemRevision &ifObj,  date_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getTarget_marketBase(const CPTradeItemRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getUnit_descriptorBase(const CPTradeItemRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setBrand_nameBase(CPTradeItemRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setQty_layers_in_trade_itemBase(CPTradeItemRevision &ifObj,  int value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setQty_trade_item_in_layerBase(CPTradeItemRevision &ifObj,  int value, bool isNull );


    ///
    /// Setter for a Date Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setReg_expiry_dateBase(CPTradeItemRevision &ifObj,  const date_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setTarget_marketBase(CPTradeItemRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setUnit_descriptorBase(CPTradeItemRevision &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static CPTradeItemRevisionDelegate*  m_pInstance;

    CPTradeItemRevisionDelegate();
    virtual ~CPTradeItemRevisionDelegate();
    static void setInstance( CPTradeItemRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::FPMGMT::CPTradeItemRevisionGenImpl;

};

#include <fpmgmt/libfpmgmt_undef.h>
#endif  //  TEAMCENTER__FPMGMT__CPTRADEITEMREVISIONDELEGATE_HXX
