//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  fpmgmt

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libfpmgmt

#if !defined(LIBFPMGMT) && !defined(IPLIB)
#   error IPLIB or LIBFPMGMT is not defined
#endif

/* Handwritten code should use FPMGMT_API, not FPMGMTEXPORT */

#define FPMGMT_API FPMGMTEXPORT

#if IPLIB==libfpmgmt || defined(LIBFPMGMT)
#   if defined(__lint)
#       define FPMGMTEXPORT       __export(fpmgmt)
#       define FPMGMTGLOBAL       extern __global(fpmgmt)
#       define FPMGMTPRIVATE      extern __private(fpmgmt)
#   elif defined(_WIN32)
#       define FPMGMTEXPORT       __declspec(dllexport)
#       define FPMGMTGLOBAL       extern __declspec(dllexport)
#       define FPMGMTPRIVATE      extern
#   else
#       define FPMGMTEXPORT
#       define FPMGMTGLOBAL       extern
#       define FPMGMTPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define FPMGMTEXPORT       __export(fpmgmt)
#       define FPMGMTGLOBAL       extern __global(fpmgmt)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define FPMGMTEXPORT      __declspec(dllimport)
#       define FPMGMTGLOBAL       extern __declspec(dllimport)
#   else
#       define FPMGMTEXPORT
#       define FPMGMTGLOBAL       extern
#   endif
#endif
