//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  fpmgmtdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libfpmgmtdispatch

#if !defined(LIBFPMGMTDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBFPMGMTDISPATCH is not defined
#endif

/* Handwritten code should use FPMGMTDISPATCH_API, not FPMGMTDISPATCHEXPORT */

#define FPMGMTDISPATCH_API FPMGMTDISPATCHEXPORT

#if IPLIB==libfpmgmtdispatch || defined(LIBFPMGMTDISPATCH)
#   if defined(__lint)
#       define FPMGMTDISPATCHEXPORT       __export(fpmgmtdispatch)
#       define FPMGMTDISPATCHGLOBAL       extern __global(fpmgmtdispatch)
#       define FPMGMTDISPATCHPRIVATE      extern __private(fpmgmtdispatch)
#   elif defined(_WIN32)
#       define FPMGMTDISPATCHEXPORT       __declspec(dllexport)
#       define FPMGMTDISPATCHGLOBAL       extern __declspec(dllexport)
#       define FPMGMTDISPATCHPRIVATE      extern
#   else
#       define FPMGMTDISPATCHEXPORT
#       define FPMGMTDISPATCHGLOBAL       extern
#       define FPMGMTDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define FPMGMTDISPATCHEXPORT       __export(fpmgmtdispatch)
#       define FPMGMTDISPATCHGLOBAL       extern __global(fpmgmtdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define FPMGMTDISPATCHEXPORT      __declspec(dllimport)
#       define FPMGMTDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define FPMGMTDISPATCHEXPORT
#       define FPMGMTDISPATCHGLOBAL       extern
#   endif
#endif
