//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fsh0Finish
    Filename:   Fsh0Finish.hxx
    Module:     fsh0fnshmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef FNSHMGMT__FSH0FINISH__HXX
#define FNSHMGMT__FSH0FINISH__HXX

#include <common/tc_deprecation_macros.h>
#include <req/Requirement.hxx>

#include <fsh0fnshmgmt/libfsh0fnshmgmt_exports.h>

namespace fnshmgmt
{
    class Fsh0Finish;
}
namespace fnshmgmt
{
    class Fsh0FinishImpl;
}
namespace fnshmgmt
{
    class Fsh0FinishDelegate;
}
namespace fnshmgmt
{
    class Fsh0FinishDispatch;
}
namespace fnshmgmt
{
    class Fsh0FinishGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FSH0FNSHMGMT_API  fnshmgmt::Fsh0Finish
     : public  ::Teamcenter::Requirement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fsh0Finish();

    /**
     * Destructor
     */
    virtual ~Fsh0Finish();

private:
    //  Getter method for the Implementation Object
    Fsh0FinishImpl*  getFsh0FinishImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFsh0FinishImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fsh0FinishImpl*  m_fsh0finishImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fsh0Finish - desc for Fsh0Finish parameter
     */
    Fsh0Finish( const Fsh0Finish& );
    Fsh0Finish& operator=( const Fsh0Finish& );

    friend class  Fsh0FinishDelegate;
    friend class  Fsh0FinishDispatch;
    friend class  Fsh0FinishGenImpl;
};

#include <fsh0fnshmgmt/libfsh0fnshmgmt_undef.h>
#endif //   FNSHMGMT__FSH0FINISH__HXX
