//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fsh0FinishGroup
    Filename:   Fsh0FinishGroup.hxx
    Module:     fsh0fnshmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef FNSHMGMT__FSH0FINISHGROUP__HXX
#define FNSHMGMT__FSH0FINISHGROUP__HXX

#include <common/tc_deprecation_macros.h>
#include <fsh0fnshmgmt/Fsh0Finish.hxx>

#include <fsh0fnshmgmt/libfsh0fnshmgmt_exports.h>

namespace fnshmgmt
{
    class Fsh0FinishGroup;
}
namespace fnshmgmt
{
    class Fsh0FinishGroupImpl;
}
namespace fnshmgmt
{
    class Fsh0FinishGroupDelegate;
}
namespace fnshmgmt
{
    class Fsh0FinishGroupDispatch;
}
namespace fnshmgmt
{
    class Fsh0FinishGroupGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FSH0FNSHMGMT_API  fnshmgmt::Fsh0FinishGroup
     : public  ::fnshmgmt::Fsh0Finish
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fsh0FinishGroup();

    /**
     * Destructor
     */
    virtual ~Fsh0FinishGroup();

private:
    //  Getter method for the Implementation Object
    Fsh0FinishGroupImpl*  getFsh0FinishGroupImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFsh0FinishGroupImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fsh0FinishGroupImpl*  m_fsh0finishgroupImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fsh0FinishGroup - desc for Fsh0FinishGroup parameter
     */
    Fsh0FinishGroup( const Fsh0FinishGroup& );
    Fsh0FinishGroup& operator=( const Fsh0FinishGroup& );

    friend class  Fsh0FinishGroupDelegate;
    friend class  Fsh0FinishGroupDispatch;
    friend class  Fsh0FinishGroupGenImpl;
};

#include <fsh0fnshmgmt/libfsh0fnshmgmt_undef.h>
#endif //   FNSHMGMT__FSH0FINISHGROUP__HXX
