//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fsh0FinishGroupRevision
    Filename:   Fsh0FinishGroupRevision.hxx
    Module:     fsh0fnshmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef FNSHMGMT__FSH0FINISHGROUPREVISION__HXX
#define FNSHMGMT__FSH0FINISHGROUPREVISION__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <fsh0fnshmgmt/Fsh0FinishRevision.hxx>

#include <fsh0fnshmgmt/libfsh0fnshmgmt_exports.h>

namespace fnshmgmt
{
    class Fsh0FinishGroupRevision;
}
namespace fnshmgmt
{
    class Fsh0FinishGroupRevisionImpl;
}
namespace fnshmgmt
{
    class Fsh0FinishGroupRevisionDelegate;
}
namespace fnshmgmt
{
    class Fsh0FinishGroupRevisionDispatch;
}
namespace fnshmgmt
{
    class Fsh0FinishGroupRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FSH0FNSHMGMT_API  fnshmgmt::Fsh0FinishGroupRevision
     : public  ::fnshmgmt::Fsh0FinishRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 10
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFsh0FinishItems( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fsh0FinishGroupRevision();

    /**
     * Destructor
     */
    virtual ~Fsh0FinishGroupRevision();

private:
    //  Getter method for the Implementation Object
    Fsh0FinishGroupRevisionImpl*  getFsh0FinishGroupRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFsh0FinishGroupRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fsh0FinishGroupRevisionImpl*  m_fsh0finishgrouprevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fsh0FinishGroupRevision - desc for Fsh0FinishGroupRevision parameter
     */
    Fsh0FinishGroupRevision( const Fsh0FinishGroupRevision& );
    Fsh0FinishGroupRevision& operator=( const Fsh0FinishGroupRevision& );

    friend class  Fsh0FinishGroupRevisionDelegate;
    friend class  Fsh0FinishGroupRevisionDispatch;
    friend class  Fsh0FinishGroupRevisionGenImpl;
};

#include <fsh0fnshmgmt/libfsh0fnshmgmt_undef.h>
#endif //   FNSHMGMT__FSH0FINISHGROUPREVISION__HXX
