//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fsh0FinishRevision
    Filename:   Fsh0FinishRevision.hxx
    Module:     fsh0fnshmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef FNSHMGMT__FSH0FINISHREVISION__HXX
#define FNSHMGMT__FSH0FINISHREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <req/Requirement_0_Revision_alt.hxx>

#include <fsh0fnshmgmt/libfsh0fnshmgmt_exports.h>

namespace fnshmgmt
{
    class Fsh0FinishRevision;
}
namespace fnshmgmt
{
    class Fsh0FinishRevisionImpl;
}
namespace fnshmgmt
{
    class Fsh0FinishRevisionDelegate;
}
namespace fnshmgmt
{
    class Fsh0FinishRevisionDispatch;
}
namespace fnshmgmt
{
    class Fsh0FinishRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FSH0FNSHMGMT_API  fnshmgmt::Fsh0FinishRevision
     : public  ::Teamcenter::Requirement_0_Revision_alt
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fsh0FinishRevision();

    /**
     * Destructor
     */
    virtual ~Fsh0FinishRevision();

private:
    //  Getter method for the Implementation Object
    Fsh0FinishRevisionImpl*  getFsh0FinishRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFsh0FinishRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fsh0FinishRevisionImpl*  m_fsh0finishrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fsh0FinishRevision - desc for Fsh0FinishRevision parameter
     */
    Fsh0FinishRevision( const Fsh0FinishRevision& );
    Fsh0FinishRevision& operator=( const Fsh0FinishRevision& );

    friend class  Fsh0FinishRevisionDelegate;
    friend class  Fsh0FinishRevisionDispatch;
    friend class  Fsh0FinishRevisionGenImpl;
};

#include <fsh0fnshmgmt/libfsh0fnshmgmt_undef.h>
#endif //   FNSHMGMT__FSH0FINISHREVISION__HXX
