//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ConditionSignature
    Filename:   ConditionSignature.hxx
    Module:     functionality
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONDITIONSIGNATURE__HXX
#define TEAMCENTER__CONDITIONSIGNATURE__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <functionality/libfunctionality_exports.h>

namespace Teamcenter
{
    class ConditionSignature;
}
namespace Teamcenter
{
    class ConditionSignatureImpl;
}
namespace Teamcenter
{
    class ConditionSignatureDelegate;
}
namespace Teamcenter
{
    class ConditionSignatureDispatch;
}
namespace Teamcenter
{
    class ConditionSignatureGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  FUNCTIONALITY_API  Teamcenter::ConditionSignature
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCondition_parameters( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setCondition_parameters( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ConditionSignature();

    /**
     * Destructor
     */
    virtual ~ConditionSignature();

private:
    //  Getter method for the Implementation Object
    ConditionSignatureImpl*  getConditionSignatureImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setConditionSignatureImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ConditionSignatureImpl*  m_conditionsignatureImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ConditionSignature - desc for ConditionSignature parameter
     */
    ConditionSignature( const ConditionSignature& );
    ConditionSignature& operator=( const ConditionSignature& );

    friend class  ConditionSignatureDelegate;
    friend class  ConditionSignatureDispatch;
    friend class  ConditionSignatureGenImpl;
};

#include <functionality/libfunctionality_undef.h>
#endif //   TEAMCENTER__CONDITIONSIGNATURE__HXX
