//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ConditionSignatureDelegate
    Filename:   ConditionSignatureDelegate.hxx
    Module:     functionality
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONDITIONSIGNATUREDELEGATE_HXX
#define TEAMCENTER__CONDITIONSIGNATUREDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <functionality/ConditionSignature.hxx>

#include <functionality/libfunctionality_exports.h>

namespace Teamcenter
{
    class ConditionSignatureDelegate;
}
namespace Teamcenter
{
    class ConditionSignatureImpl;
}
namespace Teamcenter
{
    class ConditionSignature;
}
namespace Teamcenter
{
    class ConditionSignatureGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  FUNCTIONALITY_API Teamcenter_alias::ConditionSignatureDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ConditionSignatureDelegate instance
    static ConditionSignatureDelegate&  getInstance();

    //  Method to create the ConditionSignatureImpl pointer
    static ConditionSignatureImpl*  createImpl( ConditionSignature&  ifObj );

    //  Method to delete the ConditionSignatureImpl pointer
    static void deleteImpl( ConditionSignatureImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCondition_parametersBase(const ConditionSignature &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setCondition_parametersBase(ConditionSignature &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );



protected:
    //  Pointer to the instance
    static ConditionSignatureDelegate*  m_pInstance;

    ConditionSignatureDelegate();
    virtual ~ConditionSignatureDelegate();
    static void setInstance( ConditionSignatureDelegate*  instance );


private:
    friend class  ::Teamcenter::ConditionSignatureGenImpl;

};

#include <functionality/libfunctionality_undef.h>
#endif  //  TEAMCENTER__CONDITIONSIGNATUREDELEGATE_HXX
