//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, FunctionalityRuleDelegate
    Filename:   FunctionalityRuleDelegate.hxx
    Module:     functionality
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FUNCTIONALITYRULEDELEGATE_HXX
#define TEAMCENTER__FUNCTIONALITYRULEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <functionality/FunctionalityRule.hxx>

#include <functionality/libfunctionality_exports.h>

namespace Teamcenter
{
    class FunctionalityRuleDelegate;
}
namespace Teamcenter
{
    class FunctionalityRuleImpl;
}
namespace Teamcenter
{
    class FunctionalityRule;
}
namespace Teamcenter
{
    class FunctionalityRuleGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  FUNCTIONALITY_API Teamcenter_alias::FunctionalityRuleDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the FunctionalityRuleDelegate instance
    static FunctionalityRuleDelegate&  getInstance();

    //  Method to create the FunctionalityRuleImpl pointer
    static FunctionalityRuleImpl*  createImpl( FunctionalityRule&  ifObj );

    //  Method to delete the FunctionalityRuleImpl pointer
    static void deleteImpl( FunctionalityRuleImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCondition_signaturesBase(const FunctionalityRule &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDisplay_nameBase(const FunctionalityRule &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getEnabledForVerificationRulesBase(const FunctionalityRule &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSubGroupLOVBase(const FunctionalityRule &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getType_scopeBase(const FunctionalityRule &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setCondition_signaturesBase(FunctionalityRule &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDisplay_nameBase(FunctionalityRule &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setEnabledForVerificationRulesBase(FunctionalityRule &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSubGroupLOVBase(FunctionalityRule &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 8.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setType_scopeBase(FunctionalityRule &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );



protected:
    //  Pointer to the instance
    static FunctionalityRuleDelegate*  m_pInstance;

    FunctionalityRuleDelegate();
    virtual ~FunctionalityRuleDelegate();
    static void setInstance( FunctionalityRuleDelegate*  instance );


private:
    friend class  ::Teamcenter::FunctionalityRuleGenImpl;

};

#include <functionality/libfunctionality_undef.h>
#endif  //  TEAMCENTER__FUNCTIONALITYRULEDELEGATE_HXX
