//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, VerificationRuleDelegate
    Filename:   VerificationRuleDelegate.hxx
    Module:     functionality
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VERIFICATIONRULEDELEGATE_HXX
#define TEAMCENTER__VERIFICATIONRULEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <functionality/VerificationRule.hxx>

#include <functionality/libfunctionality_exports.h>

namespace Teamcenter
{
    class VerificationRuleDelegate;
}
namespace Teamcenter
{
    class VerificationRuleImpl;
}
namespace Teamcenter
{
    class VerificationRule;
}
namespace Teamcenter
{
    class VerificationRuleGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  FUNCTIONALITY_API Teamcenter_alias::VerificationRuleDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the VerificationRuleDelegate instance
    static VerificationRuleDelegate&  getInstance();

    //  Method to create the VerificationRuleImpl pointer
    static VerificationRuleImpl*  createImpl( VerificationRule&  ifObj );

    //  Method to delete the VerificationRuleImpl pointer
    static void deleteImpl( VerificationRuleImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getContext_filterBase(const VerificationRule &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFunctionalityBase(const VerificationRule &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSubGroupBase(const VerificationRule &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getTypeBase(const VerificationRule &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setContext_filterBase(VerificationRule &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFunctionalityBase(VerificationRule &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSubGroupBase(VerificationRule &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setTypeBase(VerificationRule &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static VerificationRuleDelegate*  m_pInstance;

    VerificationRuleDelegate();
    virtual ~VerificationRuleDelegate();
    static void setInstance( VerificationRuleDelegate*  instance );


private:
    friend class  ::Teamcenter::VerificationRuleGenImpl;

};

#include <functionality/libfunctionality_undef.h>
#endif  //  TEAMCENTER__VERIFICATIONRULEDELEGATE_HXX
