//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0AdminGSIdentity
    Filename:   Fnd0AdminGSIdentity.hxx
    Module:     gms
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0ADMINGSIDENTITY__HXX
#define TEAMCENTER__FND0ADMINGSIDENTITY__HXX

#include <common/tc_deprecation_macros.h>
#include <gms/GSIdentity.hxx>

#include <gms/libgms_exports.h>

namespace Teamcenter
{
    class Fnd0AdminGSIdentity;
}
namespace Teamcenter
{
    class Fnd0AdminGSIdentityImpl;
}
namespace Teamcenter
{
    class Fnd0AdminGSIdentityDelegate;
}
namespace Teamcenter
{
    class Fnd0AdminGSIdentityDispatch;
}
namespace Teamcenter
{
    class Fnd0AdminGSIdentityGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  GMS_API  Teamcenter::Fnd0AdminGSIdentity
     : public  ::Teamcenter::GSIdentity
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0AdminGSIdentity();

    /**
     * Destructor
     */
    virtual ~Fnd0AdminGSIdentity();

private:
    //  Getter method for the Implementation Object
    Fnd0AdminGSIdentityImpl*  getFnd0AdminGSIdentityImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0AdminGSIdentityImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0AdminGSIdentityImpl*  m_fnd0admingsidentityImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0AdminGSIdentity - desc for Fnd0AdminGSIdentity parameter
     */
    Fnd0AdminGSIdentity( const Fnd0AdminGSIdentity& );
    Fnd0AdminGSIdentity& operator=( const Fnd0AdminGSIdentity& );

    friend class  Fnd0AdminGSIdentityDelegate;
    friend class  Fnd0AdminGSIdentityDispatch;
    friend class  Fnd0AdminGSIdentityGenImpl;
};

#include <gms/libgms_undef.h>
#endif //   TEAMCENTER__FND0ADMINGSIDENTITY__HXX
