//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, GSIdentity
    Filename:   GSIdentity.hxx
    Module:     gms
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__GSIDENTITY__HXX
#define TEAMCENTER__GSIDENTITY__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <gms/libgms_exports.h>

namespace Teamcenter
{
    class GSIdentity;
}
namespace Teamcenter
{
    class GSIdentityImpl;
}
namespace Teamcenter
{
    class GSIdentityDelegate;
}
namespace Teamcenter
{
    class GSIdentityDispatch;
}
namespace Teamcenter
{
    class GSIdentityGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  GMS_API  Teamcenter::GSIdentity
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    GSIdentity();

    /**
     * Destructor
     */
    virtual ~GSIdentity();

private:
    //  Getter method for the Implementation Object
    GSIdentityImpl*  getGSIdentityImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setGSIdentityImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    GSIdentityImpl*  m_gsidentityImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param GSIdentity - desc for GSIdentity parameter
     */
    GSIdentity( const GSIdentity& );
    GSIdentity& operator=( const GSIdentity& );

    friend class  GSIdentityDelegate;
    friend class  GSIdentityDispatch;
    friend class  GSIdentityGenImpl;
};

#include <gms/libgms_undef.h>
#endif //   TEAMCENTER__GSIDENTITY__HXX
