//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, GSIdentityDelegate
    Filename:   GSIdentityDelegate.hxx
    Module:     gms
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__GSIDENTITYDELEGATE_HXX
#define TEAMCENTER__GSIDENTITYDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <gms/GSIdentity.hxx>

#include <gms/libgms_exports.h>

namespace Teamcenter
{
    class GSIdentityDelegate;
}
namespace Teamcenter
{
    class GSIdentityImpl;
}
namespace Teamcenter
{
    class GSIdentity;
}
namespace Teamcenter
{
    class GSIdentityGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  GMS_API Teamcenter_alias::GSIdentityDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the GSIdentityDelegate instance
    static GSIdentityDelegate&  getInstance();

    //  Method to create the GSIdentityImpl pointer
    static GSIdentityImpl*  createImpl( GSIdentity&  ifObj );

    //  Method to delete the GSIdentityImpl pointer
    static void deleteImpl( GSIdentityImpl*  impl );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const GSIdentity &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static GSIdentityDelegate*  m_pInstance;

    GSIdentityDelegate();
    virtual ~GSIdentityDelegate();
    static void setInstance( GSIdentityDelegate*  instance );


private:
    friend class  ::Teamcenter::GSIdentityGenImpl;

};

#include <gms/libgms_undef.h>
#endif  //  TEAMCENTER__GSIDENTITYDELEGATE_HXX
