//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  gms

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libgms

#if !defined(LIBGMS) && !defined(IPLIB)
#   error IPLIB or LIBGMS is not defined
#endif

/* Handwritten code should use GMS_API, not GMSEXPORT */

#define GMS_API GMSEXPORT

#if IPLIB==libgms || defined(LIBGMS)
#   if defined(__lint)
#       define GMSEXPORT       __export(gms)
#       define GMSGLOBAL       extern __global(gms)
#       define GMSPRIVATE      extern __private(gms)
#   elif defined(_WIN32)
#       define GMSEXPORT       __declspec(dllexport)
#       define GMSGLOBAL       extern __declspec(dllexport)
#       define GMSPRIVATE      extern
#   else
#       define GMSEXPORT
#       define GMSGLOBAL       extern
#       define GMSPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define GMSEXPORT       __export(gms)
#       define GMSGLOBAL       extern __global(gms)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define GMSEXPORT      __declspec(dllimport)
#       define GMSGLOBAL       extern __declspec(dllimport)
#   else
#       define GMSEXPORT
#       define GMSGLOBAL       extern
#   endif
#endif
