//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ImanGRM
    Filename:   ImanGRM.hxx
    Module:     grm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IMANGRM__HXX
#define TEAMCENTER__IMANGRM__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/BusinessRule.hxx>

#include <grm/libgrm_exports.h>

namespace Teamcenter
{
    class ImanGRM;
}
namespace Teamcenter
{
    class ImanGRMImpl;
}
namespace Teamcenter
{
    class ImanGRMDelegate;
}
namespace Teamcenter
{
    class ImanGRMDispatch;
}
namespace Teamcenter
{
    class ImanGRMGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  GRM_API  Teamcenter::ImanGRM
     : public  ::Teamcenter::BusinessRule
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ImanGRM();

    /**
     * Destructor
     */
    virtual ~ImanGRM();

private:
    //  Getter method for the Implementation Object
    ImanGRMImpl*  getImanGRMImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setImanGRMImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ImanGRMImpl*  m_imangrmImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ImanGRM - desc for ImanGRM parameter
     */
    ImanGRM( const ImanGRM& );
    ImanGRM& operator=( const ImanGRM& );

    friend class  ImanGRMDelegate;
    friend class  ImanGRMDispatch;
    friend class  ImanGRMGenImpl;
};

#include <grm/libgrm_undef.h>
#endif //   TEAMCENTER__IMANGRM__HXX
