//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  grm

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libgrm

#if !defined(LIBGRM) && !defined(IPLIB)
#   error IPLIB or LIBGRM is not defined
#endif

/* Handwritten code should use GRM_API, not GRMEXPORT */

#define GRM_API GRMEXPORT

#if IPLIB==libgrm || defined(LIBGRM)
#   if defined(__lint)
#       define GRMEXPORT       __export(grm)
#       define GRMGLOBAL       extern __global(grm)
#       define GRMPRIVATE      extern __private(grm)
#   elif defined(_WIN32)
#       define GRMEXPORT       __declspec(dllexport)
#       define GRMGLOBAL       extern __declspec(dllexport)
#       define GRMPRIVATE      extern
#   else
#       define GRMEXPORT
#       define GRMGLOBAL       extern
#       define GRMPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define GRMEXPORT       __export(grm)
#       define GRMGLOBAL       extern __global(grm)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define GRMEXPORT      __declspec(dllimport)
#       define GRMGLOBAL       extern __declspec(dllimport)
#   else
#       define GRMEXPORT
#       define GRMGLOBAL       extern
#   endif
#endif
