//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ICSRuntimeAttr
    Filename:   ICSRuntimeAttr.hxx
    Module:     ics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ICSRUNTIMEATTR__HXX
#define TEAMCENTER__ICSRUNTIMEATTR__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <ics/libics_exports.h>

namespace Teamcenter
{
    class ICSRuntimeAttr;
}
namespace Teamcenter
{
    class ICSRuntimeAttrImpl;
}
namespace Teamcenter
{
    class ICSRuntimeAttrDelegate;
}
namespace Teamcenter
{
    class ICSRuntimeAttrDispatch;
}
namespace Teamcenter
{
    class ICSRuntimeAttrGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ICS_API  Teamcenter::ICSRuntimeAttr
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ICSRuntimeAttr();

    /**
     * Destructor
     */
    virtual ~ICSRuntimeAttr();

private:
    //  Getter method for the Implementation Object
    ICSRuntimeAttrImpl*  getICSRuntimeAttrImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setICSRuntimeAttrImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ICSRuntimeAttrImpl*  m_icsruntimeattrImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ICSRuntimeAttr - desc for ICSRuntimeAttr parameter
     */
    ICSRuntimeAttr( const ICSRuntimeAttr& );
    ICSRuntimeAttr& operator=( const ICSRuntimeAttr& );

    friend class  ICSRuntimeAttrDelegate;
    friend class  ICSRuntimeAttrDispatch;
    friend class  ICSRuntimeAttrGenImpl;
};

#include <ics/libics_undef.h>
#endif //   TEAMCENTER__ICSRUNTIMEATTR__HXX
