//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ICSRuntimeICOIdAttr
    Filename:   ICSRuntimeICOIdAttr.hxx
    Module:     ics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ICSRUNTIMEICOIDATTR__HXX
#define TEAMCENTER__ICSRUNTIMEICOIDATTR__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <ics/libics_exports.h>

namespace Teamcenter
{
    class ICSRuntimeICOIdAttr;
}
namespace Teamcenter
{
    class ICSRuntimeICOIdAttrImpl;
}
namespace Teamcenter
{
    class ICSRuntimeICOIdAttrDelegate;
}
namespace Teamcenter
{
    class ICSRuntimeICOIdAttrDispatch;
}
namespace Teamcenter
{
    class ICSRuntimeICOIdAttrGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ICS_API  Teamcenter::ICSRuntimeICOIdAttr
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ICSRuntimeICOIdAttr();

    /**
     * Destructor
     */
    virtual ~ICSRuntimeICOIdAttr();

private:
    //  Getter method for the Implementation Object
    ICSRuntimeICOIdAttrImpl*  getICSRuntimeICOIdAttrImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setICSRuntimeICOIdAttrImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ICSRuntimeICOIdAttrImpl*  m_icsruntimeicoidattrImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ICSRuntimeICOIdAttr - desc for ICSRuntimeICOIdAttr parameter
     */
    ICSRuntimeICOIdAttr( const ICSRuntimeICOIdAttr& );
    ICSRuntimeICOIdAttr& operator=( const ICSRuntimeICOIdAttr& );

    friend class  ICSRuntimeICOIdAttrDelegate;
    friend class  ICSRuntimeICOIdAttrDispatch;
    friend class  ICSRuntimeICOIdAttrGenImpl;
};

#include <ics/libics_undef.h>
#endif //   TEAMCENTER__ICSRUNTIMEICOIDATTR__HXX
