//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  ics

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libics

#if !defined(LIBICS) && !defined(IPLIB)
#   error IPLIB or LIBICS is not defined
#endif

/* Handwritten code should use ICS_API, not ICSEXPORT */

#define ICS_API ICSEXPORT

#if IPLIB==libics || defined(LIBICS)
#   if defined(__lint)
#       define ICSEXPORT       __export(ics)
#       define ICSGLOBAL       extern __global(ics)
#       define ICSPRIVATE      extern __private(ics)
#   elif defined(_WIN32)
#       define ICSEXPORT       __declspec(dllexport)
#       define ICSGLOBAL       extern __declspec(dllexport)
#       define ICSPRIVATE      extern
#   else
#       define ICSEXPORT
#       define ICSGLOBAL       extern
#       define ICSPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define ICSEXPORT       __export(ics)
#       define ICSGLOBAL       extern __global(ics)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define ICSEXPORT      __declspec(dllimport)
#       define ICSGLOBAL       extern __declspec(dllimport)
#   else
#       define ICSEXPORT
#       define ICSGLOBAL       extern
#   endif
#endif
