//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, IssueReport
    Filename:   IssueReport.hxx
    Module:     issuemgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ISSUEMGMT__ISSUEREPORT__HXX
#define TEAMCENTER__ISSUEMGMT__ISSUEREPORT__HXX

#include <common/tc_deprecation_macros.h>
#include <cm/ProblemReport.hxx>

#include <issuemgmt/libissuemgmt_exports.h>

namespace Teamcenter
{
    namespace issuemgmt
    {
        class IssueReport;
    }
}
namespace Teamcenter
{
    namespace issuemgmt
    {
        class IssueReportImpl;
    }
}
namespace Teamcenter
{
    namespace issuemgmt
    {
        class IssueReportDelegate;
    }
}
namespace Teamcenter
{
    namespace issuemgmt
    {
        class IssueReportDispatch;
    }
}
namespace Teamcenter
{
    namespace issuemgmt
    {
        class IssueReportGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ISSUEMGMT_API  Teamcenter::issuemgmt::IssueReport
     : public  ::Teamcenter::ProblemReport
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    IssueReport();

    /**
     * Destructor
     */
    virtual ~IssueReport();

private:
    //  Getter method for the Implementation Object
    IssueReportImpl*  getIssueReportImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setIssueReportImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    IssueReportImpl*  m_issuereportImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param IssueReport - desc for IssueReport parameter
     */
    IssueReport( const IssueReport& );
    IssueReport& operator=( const IssueReport& );

    friend class  IssueReportDelegate;
    friend class  IssueReportDispatch;
    friend class  IssueReportGenImpl;
};

#include <issuemgmt/libissuemgmt_undef.h>
#endif //   TEAMCENTER__ISSUEMGMT__ISSUEREPORT__HXX
