//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, IssueReportDelegate
    Filename:   IssueReportDelegate.hxx
    Module:     issuemgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ISSUEMGMT__ISSUEREPORTDELEGATE_HXX
#define TEAMCENTER__ISSUEMGMT__ISSUEREPORTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <issuemgmt/IssueReport.hxx>

#include <issuemgmt/libissuemgmt_exports.h>

namespace Teamcenter
{
    namespace issuemgmt
    {
        class IssueReportDelegate;
    }
}
namespace Teamcenter
{
    namespace issuemgmt
    {
        class IssueReportImpl;
    }
}
namespace Teamcenter
{
    namespace issuemgmt
    {
        class IssueReport;
    }
}
namespace Teamcenter
{
    namespace issuemgmt
    {
        class IssueReportGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  ISSUEMGMT_API Teamcenter_alias::issuemgmt::IssueReportDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the IssueReportDelegate instance
    static IssueReportDelegate&  getInstance();

    //  Method to create the IssueReportImpl pointer
    static IssueReportImpl*  createImpl( IssueReport&  ifObj );

    //  Method to delete the IssueReportImpl pointer
    static void deleteImpl( IssueReportImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getItem_idBase(const IssueReport &ifObj,  std::string &value, bool &isNull ) const;



protected:
    //  Pointer to the instance
    static IssueReportDelegate*  m_pInstance;

    IssueReportDelegate();
    virtual ~IssueReportDelegate();
    static void setInstance( IssueReportDelegate*  instance );


private:
    friend class  ::Teamcenter::issuemgmt::IssueReportGenImpl;

};

#include <issuemgmt/libissuemgmt_undef.h>
#endif  //  TEAMCENTER__ISSUEMGMT__ISSUEREPORTDELEGATE_HXX
