//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, IssueReportRevisionDelegate
    Filename:   IssueReportRevisionDelegate.hxx
    Module:     issuemgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ISSUEMGMT__ISSUEREPORTREVISIONDELEGATE_HXX
#define TEAMCENTER__ISSUEMGMT__ISSUEREPORTREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <issuemgmt/IssueReportRevision.hxx>

#include <issuemgmt/libissuemgmt_exports.h>

namespace Teamcenter
{
    namespace issuemgmt
    {
        class IssueReportRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace issuemgmt
    {
        class IssueReportRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace issuemgmt
    {
        class IssueReportRevision;
    }
}
namespace Teamcenter
{
    namespace issuemgmt
    {
        class IssueReportRevisionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  ISSUEMGMT_API Teamcenter_alias::issuemgmt::IssueReportRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the IssueReportRevisionDelegate instance
    static IssueReportRevisionDelegate&  getInstance();

    //  Method to create the IssueReportRevisionImpl pointer
    static IssueReportRevisionImpl*  createImpl( IssueReportRevision&  ifObj );

    //  Method to delete the IssueReportRevisionImpl pointer
    static void deleteImpl( IssueReportRevisionImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAssigned_userBase(const IssueReportRevision &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDesign_review_gateBase(const IssueReportRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Date Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDue_dateBase(const IssueReportRevision &ifObj,  date_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIsm0ClearanceDbIdBase(const IssueReportRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIsm0ClearanceIdBase(const IssueReportRevision &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIsm0marker_XBase(const IssueReportRevision &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIsm0marker_YBase(const IssueReportRevision &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIsm0marker_ZBase(const IssueReportRevision &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIsm0NonembeddedAppBase(const IssueReportRevision &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIsm0RacApplicationIdBase(const IssueReportRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIsm0RacPerspectiveIdBase(const IssueReportRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIsm0statusBase(const IssueReportRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIssue_categoryBase(const IssueReportRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAssigned_userBase(IssueReportRevision &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDesign_review_gateBase(IssueReportRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Date Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDue_dateBase(IssueReportRevision &ifObj,  const date_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIsm0ClearanceDbIdBase(IssueReportRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIsm0ClearanceIdBase(IssueReportRevision &ifObj,  int value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIsm0marker_XBase(IssueReportRevision &ifObj,  double value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIsm0marker_YBase(IssueReportRevision &ifObj,  double value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIsm0marker_ZBase(IssueReportRevision &ifObj,  double value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIsm0NonembeddedAppBase(IssueReportRevision &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIsm0RacApplicationIdBase(IssueReportRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIsm0RacPerspectiveIdBase(IssueReportRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIsm0statusBase(IssueReportRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIssue_categoryBase(IssueReportRevision &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static IssueReportRevisionDelegate*  m_pInstance;

    IssueReportRevisionDelegate();
    virtual ~IssueReportRevisionDelegate();
    static void setInstance( IssueReportRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::issuemgmt::IssueReportRevisionGenImpl;

};

#include <issuemgmt/libissuemgmt_undef.h>
#endif  //  TEAMCENTER__ISSUEMGMT__ISSUEREPORTREVISIONDELEGATE_HXX
