//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, IssueReviewRecord
    Filename:   IssueReviewRecord.hxx
    Module:     issuemgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ISSUEMGMT__ISSUEREVIEWRECORD__HXX
#define TEAMCENTER__ISSUEMGMT__ISSUEREVIEWRECORD__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <issuemgmt/libissuemgmt_exports.h>

namespace Teamcenter
{
    namespace issuemgmt
    {
        class IssueReviewRecord;
    }
}
namespace Teamcenter
{
    namespace issuemgmt
    {
        class IssueReviewRecordImpl;
    }
}
namespace Teamcenter
{
    namespace issuemgmt
    {
        class IssueReviewRecordDelegate;
    }
}
namespace Teamcenter
{
    namespace issuemgmt
    {
        class IssueReviewRecordDispatch;
    }
}
namespace Teamcenter
{
    namespace issuemgmt
    {
        class IssueReviewRecordGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ISSUEMGMT_API  Teamcenter::issuemgmt::IssueReviewRecord
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getComment( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getReview_decision( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getReviewer_id( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setComment( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setReview_decision( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setReviewer_id( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    IssueReviewRecord();

    /**
     * Destructor
     */
    virtual ~IssueReviewRecord();

private:
    //  Getter method for the Implementation Object
    IssueReviewRecordImpl*  getIssueReviewRecordImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setIssueReviewRecordImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    IssueReviewRecordImpl*  m_issuereviewrecordImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param IssueReviewRecord - desc for IssueReviewRecord parameter
     */
    IssueReviewRecord( const IssueReviewRecord& );
    IssueReviewRecord& operator=( const IssueReviewRecord& );

    friend class  IssueReviewRecordDelegate;
    friend class  IssueReviewRecordDispatch;
    friend class  IssueReviewRecordGenImpl;
};

#include <issuemgmt/libissuemgmt_undef.h>
#endif //   TEAMCENTER__ISSUEMGMT__ISSUEREVIEWRECORD__HXX
