//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, IssueReviewRecordDelegate
    Filename:   IssueReviewRecordDelegate.hxx
    Module:     issuemgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ISSUEMGMT__ISSUEREVIEWRECORDDELEGATE_HXX
#define TEAMCENTER__ISSUEMGMT__ISSUEREVIEWRECORDDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <issuemgmt/IssueReviewRecord.hxx>

#include <issuemgmt/libissuemgmt_exports.h>

namespace Teamcenter
{
    namespace issuemgmt
    {
        class IssueReviewRecordDelegate;
    }
}
namespace Teamcenter
{
    namespace issuemgmt
    {
        class IssueReviewRecordImpl;
    }
}
namespace Teamcenter
{
    namespace issuemgmt
    {
        class IssueReviewRecord;
    }
}
namespace Teamcenter
{
    namespace issuemgmt
    {
        class IssueReviewRecordGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  ISSUEMGMT_API Teamcenter_alias::issuemgmt::IssueReviewRecordDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the IssueReviewRecordDelegate instance
    static IssueReviewRecordDelegate&  getInstance();

    //  Method to create the IssueReviewRecordImpl pointer
    static IssueReviewRecordImpl*  createImpl( IssueReviewRecord&  ifObj );

    //  Method to delete the IssueReviewRecordImpl pointer
    static void deleteImpl( IssueReviewRecordImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCommentBase(const IssueReviewRecord &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getReview_decisionBase(const IssueReviewRecord &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getReviewer_idBase(const IssueReviewRecord &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCommentBase(IssueReviewRecord &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setReview_decisionBase(IssueReviewRecord &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setReviewer_idBase(IssueReviewRecord &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static IssueReviewRecordDelegate*  m_pInstance;

    IssueReviewRecordDelegate();
    virtual ~IssueReviewRecordDelegate();
    static void setInstance( IssueReviewRecordDelegate*  instance );


private:
    friend class  ::Teamcenter::issuemgmt::IssueReviewRecordGenImpl;

};

#include <issuemgmt/libissuemgmt_undef.h>
#endif  //  TEAMCENTER__ISSUEMGMT__ISSUEREVIEWRECORDDELEGATE_HXX
