//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  issuemgmtdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libissuemgmtdispatch

#if !defined(LIBISSUEMGMTDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBISSUEMGMTDISPATCH is not defined
#endif

/* Handwritten code should use ISSUEMGMTDISPATCH_API, not ISSUEMGMTDISPATCHEXPORT */

#define ISSUEMGMTDISPATCH_API ISSUEMGMTDISPATCHEXPORT

#if IPLIB==libissuemgmtdispatch || defined(LIBISSUEMGMTDISPATCH)
#   if defined(__lint)
#       define ISSUEMGMTDISPATCHEXPORT       __export(issuemgmtdispatch)
#       define ISSUEMGMTDISPATCHGLOBAL       extern __global(issuemgmtdispatch)
#       define ISSUEMGMTDISPATCHPRIVATE      extern __private(issuemgmtdispatch)
#   elif defined(_WIN32)
#       define ISSUEMGMTDISPATCHEXPORT       __declspec(dllexport)
#       define ISSUEMGMTDISPATCHGLOBAL       extern __declspec(dllexport)
#       define ISSUEMGMTDISPATCHPRIVATE      extern
#   else
#       define ISSUEMGMTDISPATCHEXPORT
#       define ISSUEMGMTDISPATCHGLOBAL       extern
#       define ISSUEMGMTDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define ISSUEMGMTDISPATCHEXPORT       __export(issuemgmtdispatch)
#       define ISSUEMGMTDISPATCHGLOBAL       extern __global(issuemgmtdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define ISSUEMGMTDISPATCHEXPORT      __declspec(dllimport)
#       define ISSUEMGMTDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define ISSUEMGMTDISPATCHEXPORT
#       define ISSUEMGMTDISPATCHGLOBAL       extern
#   endif
#endif
