//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  les0lisesmdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libles0lisesmdispatch

#if !defined(LIBLES0LISESMDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBLES0LISESMDISPATCH is not defined
#endif

/* Handwritten code should use LES0LISESMDISPATCH_API, not LES0LISESMDISPATCHEXPORT */

#define LES0LISESMDISPATCH_API LES0LISESMDISPATCHEXPORT

#if IPLIB==libles0lisesmdispatch || defined(LIBLES0LISESMDISPATCH)
#   if defined(__lint)
#       define LES0LISESMDISPATCHEXPORT       __export(les0lisesmdispatch)
#       define LES0LISESMDISPATCHGLOBAL       extern __global(les0lisesmdispatch)
#       define LES0LISESMDISPATCHPRIVATE      extern __private(les0lisesmdispatch)
#   elif defined(_WIN32)
#       define LES0LISESMDISPATCHEXPORT       __declspec(dllexport)
#       define LES0LISESMDISPATCHGLOBAL       extern __declspec(dllexport)
#       define LES0LISESMDISPATCHPRIVATE      extern
#   else
#       define LES0LISESMDISPATCHEXPORT
#       define LES0LISESMDISPATCHGLOBAL       extern
#       define LES0LISESMDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define LES0LISESMDISPATCHEXPORT       __export(les0lisesmdispatch)
#       define LES0LISESMDISPATCHGLOBAL       extern __global(les0lisesmdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define LES0LISESMDISPATCHEXPORT      __declspec(dllimport)
#       define LES0LISESMDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define LES0LISESMDISPATCHEXPORT
#       define LES0LISESMDISPATCHGLOBAL       extern
#   endif
#endif
