//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  lgt0logisticsdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            liblgt0logisticsdispatch

#if !defined(LIBLGT0LOGISTICSDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBLGT0LOGISTICSDISPATCH is not defined
#endif

/* Handwritten code should use LGT0LOGISTICSDISPATCH_API, not LGT0LOGISTICSDISPATCHEXPORT */

#define LGT0LOGISTICSDISPATCH_API LGT0LOGISTICSDISPATCHEXPORT

#if IPLIB==liblgt0logisticsdispatch || defined(LIBLGT0LOGISTICSDISPATCH)
#   if defined(__lint)
#       define LGT0LOGISTICSDISPATCHEXPORT       __export(lgt0logisticsdispatch)
#       define LGT0LOGISTICSDISPATCHGLOBAL       extern __global(lgt0logisticsdispatch)
#       define LGT0LOGISTICSDISPATCHPRIVATE      extern __private(lgt0logisticsdispatch)
#   elif defined(_WIN32)
#       define LGT0LOGISTICSDISPATCHEXPORT       __declspec(dllexport)
#       define LGT0LOGISTICSDISPATCHGLOBAL       extern __declspec(dllexport)
#       define LGT0LOGISTICSDISPATCHPRIVATE      extern
#   else
#       define LGT0LOGISTICSDISPATCHEXPORT
#       define LGT0LOGISTICSDISPATCHGLOBAL       extern
#       define LGT0LOGISTICSDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define LGT0LOGISTICSDISPATCHEXPORT       __export(lgt0logisticsdispatch)
#       define LGT0LOGISTICSDISPATCHGLOBAL       extern __global(lgt0logisticsdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define LGT0LOGISTICSDISPATCHEXPORT      __declspec(dllimport)
#       define LGT0LOGISTICSDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define LGT0LOGISTICSDISPATCHEXPORT
#       define LGT0LOGISTICSDISPATCHGLOBAL       extern
#   endif
#endif
