//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  librarymgmtdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            liblibrarymgmtdispatch

#if !defined(LIBLIBRARYMGMTDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBLIBRARYMGMTDISPATCH is not defined
#endif

/* Handwritten code should use LIBRARYMGMTDISPATCH_API, not LIBRARYMGMTDISPATCHEXPORT */

#define LIBRARYMGMTDISPATCH_API LIBRARYMGMTDISPATCHEXPORT

#if IPLIB==liblibrarymgmtdispatch || defined(LIBLIBRARYMGMTDISPATCH)
#   if defined(__lint)
#       define LIBRARYMGMTDISPATCHEXPORT       __export(librarymgmtdispatch)
#       define LIBRARYMGMTDISPATCHGLOBAL       extern __global(librarymgmtdispatch)
#       define LIBRARYMGMTDISPATCHPRIVATE      extern __private(librarymgmtdispatch)
#   elif defined(_WIN32)
#       define LIBRARYMGMTDISPATCHEXPORT       __declspec(dllexport)
#       define LIBRARYMGMTDISPATCHGLOBAL       extern __declspec(dllexport)
#       define LIBRARYMGMTDISPATCHPRIVATE      extern
#   else
#       define LIBRARYMGMTDISPATCHEXPORT
#       define LIBRARYMGMTDISPATCHGLOBAL       extern
#       define LIBRARYMGMTDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define LIBRARYMGMTDISPATCHEXPORT       __export(librarymgmtdispatch)
#       define LIBRARYMGMTDISPATCHGLOBAL       extern __global(librarymgmtdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define LIBRARYMGMTDISPATCHEXPORT      __declspec(dllimport)
#       define LIBRARYMGMTDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define LIBRARYMGMTDISPATCHEXPORT
#       define LIBRARYMGMTDISPATCHGLOBAL       extern
#   endif
#endif
