//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0GroupMemberLOV
    Filename:   Fnd0GroupMemberLOV.hxx
    Module:     lov
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0GROUPMEMBERLOV__HXX
#define TEAMCENTER__FND0GROUPMEMBERLOV__HXX

#include <common/tc_deprecation_macros.h>
#include <lov/Fnd0ListOfValuesDynamic.hxx>

#include <lov/liblov_exports.h>

namespace Teamcenter
{
    class Fnd0GroupMemberLOV;
}
namespace Teamcenter
{
    class Fnd0GroupMemberLOVImpl;
}
namespace Teamcenter
{
    class Fnd0GroupMemberLOVDelegate;
}
namespace Teamcenter
{
    class Fnd0GroupMemberLOVDispatch;
}
namespace Teamcenter
{
    class Fnd0GroupMemberLOVGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LOV_API  Teamcenter::Fnd0GroupMemberLOV
     : public  ::Teamcenter::Fnd0ListOfValuesDynamic
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0GroupMemberLOV();

    /**
     * Destructor
     */
    virtual ~Fnd0GroupMemberLOV();

private:
    //  Getter method for the Implementation Object
    Fnd0GroupMemberLOVImpl*  getFnd0GroupMemberLOVImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0GroupMemberLOVImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0GroupMemberLOVImpl*  m_fnd0groupmemberlovImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0GroupMemberLOV - desc for Fnd0GroupMemberLOV parameter
     */
    Fnd0GroupMemberLOV( const Fnd0GroupMemberLOV& );
    Fnd0GroupMemberLOV& operator=( const Fnd0GroupMemberLOV& );

    friend class  Fnd0GroupMemberLOVDelegate;
    friend class  Fnd0GroupMemberLOVDispatch;
    friend class  Fnd0GroupMemberLOVGenImpl;
};

#include <lov/liblov_undef.h>
#endif //   TEAMCENTER__FND0GROUPMEMBERLOV__HXX
