//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0LOVDictionaryEntry
    Filename:   Fnd0LOVDictionaryEntry.hxx
    Module:     lov
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0LOVDICTIONARYENTRY__HXX
#define TEAMCENTER__FND0LOVDICTIONARYENTRY__HXX

#include <string>
#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <lov/liblov_exports.h>

namespace Teamcenter
{
    class Fnd0LOVDictionaryEntry;
}
namespace Teamcenter
{
    class Fnd0LOVDictionaryEntryImpl;
}
namespace Teamcenter
{
    class Fnd0LOVDictionaryEntryDelegate;
}
namespace Teamcenter
{
    class Fnd0LOVDictionaryEntryDispatch;
}
namespace Teamcenter
{
    class Fnd0LOVDictionaryEntryGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LOV_API  Teamcenter::Fnd0LOVDictionaryEntry
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0entry( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0lov( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0entry( const std::string &value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0lov( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0LOVDictionaryEntry();

    /**
     * Destructor
     */
    virtual ~Fnd0LOVDictionaryEntry();

private:
    //  Getter method for the Implementation Object
    Fnd0LOVDictionaryEntryImpl*  getFnd0LOVDictionaryEntryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0LOVDictionaryEntryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0LOVDictionaryEntryImpl*  m_fnd0lovdictionaryentryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0LOVDictionaryEntry - desc for Fnd0LOVDictionaryEntry parameter
     */
    Fnd0LOVDictionaryEntry( const Fnd0LOVDictionaryEntry& );
    Fnd0LOVDictionaryEntry& operator=( const Fnd0LOVDictionaryEntry& );

    friend class  Fnd0LOVDictionaryEntryDelegate;
    friend class  Fnd0LOVDictionaryEntryDispatch;
    friend class  Fnd0LOVDictionaryEntryGenImpl;
};

#include <lov/liblov_undef.h>
#endif //   TEAMCENTER__FND0LOVDICTIONARYENTRY__HXX
