//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0LOVDictionaryEntryDelegate
    Filename:   Fnd0LOVDictionaryEntryDelegate.hxx
    Module:     lov
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0LOVDICTIONARYENTRYDELEGATE_HXX
#define TEAMCENTER__FND0LOVDICTIONARYENTRYDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <lov/Fnd0LOVDictionaryEntry.hxx>

#include <lov/liblov_exports.h>

namespace Teamcenter
{
    class Fnd0LOVDictionaryEntryDelegate;
}
namespace Teamcenter
{
    class Fnd0LOVDictionaryEntryImpl;
}
namespace Teamcenter
{
    class Fnd0LOVDictionaryEntry;
}
namespace Teamcenter
{
    class Fnd0LOVDictionaryEntryGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  LOV_API Teamcenter_alias::Fnd0LOVDictionaryEntryDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0LOVDictionaryEntryDelegate instance
    static Fnd0LOVDictionaryEntryDelegate&  getInstance();

    //  Method to create the Fnd0LOVDictionaryEntryImpl pointer
    static Fnd0LOVDictionaryEntryImpl*  createImpl( Fnd0LOVDictionaryEntry&  ifObj );

    //  Method to delete the Fnd0LOVDictionaryEntryImpl pointer
    static void deleteImpl( Fnd0LOVDictionaryEntryImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0entryBase(const Fnd0LOVDictionaryEntry &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0lovBase(const Fnd0LOVDictionaryEntry &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0entryBase(Fnd0LOVDictionaryEntry &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0lovBase(Fnd0LOVDictionaryEntry &ifObj,  const tag_t &value, bool isNull );



protected:
    //  Pointer to the instance
    static Fnd0LOVDictionaryEntryDelegate*  m_pInstance;

    Fnd0LOVDictionaryEntryDelegate();
    virtual ~Fnd0LOVDictionaryEntryDelegate();
    static void setInstance( Fnd0LOVDictionaryEntryDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0LOVDictionaryEntryGenImpl;

};

#include <lov/liblov_undef.h>
#endif  //  TEAMCENTER__FND0LOVDICTIONARYENTRYDELEGATE_HXX
