//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ListOfMembersLOVDelegate
    Filename:   Fnd0ListOfMembersLOVDelegate.hxx
    Module:     lov
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0LISTOFMEMBERSLOVDELEGATE_HXX
#define TEAMCENTER__FND0LISTOFMEMBERSLOVDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <lov/Fnd0ListOfMembersLOV.hxx>

#include <lov/liblov_exports.h>

namespace Teamcenter
{
    class Fnd0ListOfMembersLOVDelegate;
}
namespace Teamcenter
{
    class Fnd0ListOfMembersLOVImpl;
}
namespace Teamcenter
{
    class Fnd0ListOfMembersLOV;
}
namespace Teamcenter
{
    class Fnd0ListOfMembersLOVGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  LOV_API Teamcenter_alias::Fnd0ListOfMembersLOVDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0ListOfMembersLOVDelegate instance
    static Fnd0ListOfMembersLOVDelegate&  getInstance();

    //  Method to create the Fnd0ListOfMembersLOVImpl pointer
    static Fnd0ListOfMembersLOVImpl*  createImpl( Fnd0ListOfMembersLOV&  ifObj );

    //  Method to delete the Fnd0ListOfMembersLOVImpl pointer
    static void deleteImpl( Fnd0ListOfMembersLOVImpl*  impl );


    ///
    /// Returns List Of Values based on Dynamic LOV definition and user search criteria.
    /// @version Teamcenter 10
    /// @param operationInputTag - Operation Input containing the modified values.
    /// @param propertyName - Name of the selected property.
    /// @param searchString - User entered search string.
    /// @param sortByProp - Property to use for sorting.
    /// @param sortOrder - order for sorting (0=Ascending, 1=Descending).
    /// @param nResults - Number of returned results.
    /// @param results - Returned Values for LOV.
    /// @return - Zero (0) if everything is alright otherwise the error code.
    ///
    int  fnd0askLOVValuesBase(const Fnd0ListOfMembersLOV &ifObj,  const tag_t operationInputTag, const std::string *propertyName, const std::string *searchString, const char *sortByProp, const int sortOrder, int *nResults, tag_t **results ) const;


    ///
    /// Returns true if the input value is valid for the Dynamic LOV.
    /// @version Teamcenter 10
    /// @param operationInputTag - Operation Input containing the modified values.
    /// @param propertyName - Name of the selected property.
    /// @param value - Value to validate.
    /// @param verdict - true if value is valid.
    /// @return - Zero (0) if everything is alright otherwise the error code.
    ///
    int  fnd0isValueValidBase(const Fnd0ListOfMembersLOV &ifObj,  const tag_t operationInputTag, const std::string *propertyName, const std::string *value, bool *verdict ) const;



protected:
    //  Pointer to the instance
    static Fnd0ListOfMembersLOVDelegate*  m_pInstance;

    Fnd0ListOfMembersLOVDelegate();
    virtual ~Fnd0ListOfMembersLOVDelegate();
    static void setInstance( Fnd0ListOfMembersLOVDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0ListOfMembersLOVGenImpl;

};

#include <lov/liblov_undef.h>
#endif  //  TEAMCENTER__FND0LISTOFMEMBERSLOVDELEGATE_HXX
