//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ListOfRelRefPropsLOVDelegate
    Filename:   Fnd0ListOfRelRefPropsLOVDelegate.hxx
    Module:     lov
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0LISTOFRELREFPROPSLOVDELEGATE_HXX
#define TEAMCENTER__FND0LISTOFRELREFPROPSLOVDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <lov/Fnd0ListOfRelRefPropsLOV.hxx>

#include <lov/liblov_exports.h>

namespace Teamcenter
{
    class Fnd0ListOfRelRefPropsLOVDelegate;
}
namespace Teamcenter
{
    class Fnd0ListOfRelRefPropsLOVImpl;
}
namespace Teamcenter
{
    class Fnd0ListOfRelRefPropsLOV;
}
namespace Teamcenter
{
    class Fnd0ListOfRelRefPropsLOVGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  LOV_API Teamcenter_alias::Fnd0ListOfRelRefPropsLOVDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0ListOfRelRefPropsLOVDelegate instance
    static Fnd0ListOfRelRefPropsLOVDelegate&  getInstance();

    //  Method to create the Fnd0ListOfRelRefPropsLOVImpl pointer
    static Fnd0ListOfRelRefPropsLOVImpl*  createImpl( Fnd0ListOfRelRefPropsLOV&  ifObj );

    //  Method to delete the Fnd0ListOfRelRefPropsLOVImpl pointer
    static void deleteImpl( Fnd0ListOfRelRefPropsLOVImpl*  impl );


    ///
    /// Returns List Of Values based on Dynamic LOV definition and user search criteria.
    /// @version Teamcenter 10
    /// @param operationInputTag - Operation Input containing the modified values.
    /// @param propertyName - Name of the selected property.
    /// @param searchString - User entered search string.
    /// @param sortByProp - Property to use for sorting.
    /// @param sortOrder - order for sorting (0=Ascending, 1=Descending).
    /// @param nResults - Number of returned results.
    /// @param results - Returned Values for LOV.
    /// @return - Zero (0) if everything is alright otherwise the error code.
    ///
    int  fnd0askLOVValuesBase(const Fnd0ListOfRelRefPropsLOV &ifObj,  const tag_t operationInputTag, const std::string *propertyName, const std::string *searchString, const char *sortByProp, const int sortOrder, int *nResults, tag_t **results ) const;


    ///
    /// Returns true if the input value is valid for the Dynamic LOV.
    /// @version Teamcenter 10
    /// @param operationInputTag - Operation Input containing the modified values.
    /// @param propertyName - Name of the selected property.
    /// @param value - Value to validate.
    /// @param verdict - true if value is valid.
    /// @return - Zero (0) if everything is alright otherwise the error code.
    ///
    int  fnd0isValueValidBase(const Fnd0ListOfRelRefPropsLOV &ifObj,  const tag_t operationInputTag, const std::string *propertyName, const std::string *value, bool *verdict ) const;



protected:
    //  Pointer to the instance
    static Fnd0ListOfRelRefPropsLOVDelegate*  m_pInstance;

    Fnd0ListOfRelRefPropsLOVDelegate();
    virtual ~Fnd0ListOfRelRefPropsLOVDelegate();
    static void setInstance( Fnd0ListOfRelRefPropsLOVDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0ListOfRelRefPropsLOVGenImpl;

};

#include <lov/liblov_undef.h>
#endif  //  TEAMCENTER__FND0LISTOFRELREFPROPSLOVDELEGATE_HXX
