//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ListOfSourcePropsLOVDelegate
    Filename:   Fnd0ListOfSourcePropsLOVDelegate.hxx
    Module:     lov
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0LISTOFSOURCEPROPSLOVDELEGATE_HXX
#define TEAMCENTER__FND0LISTOFSOURCEPROPSLOVDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <lov/Fnd0ListOfSourcePropsLOV.hxx>

#include <lov/liblov_exports.h>

namespace Teamcenter
{
    class Fnd0ListOfSourcePropsLOVDelegate;
}
namespace Teamcenter
{
    class Fnd0ListOfSourcePropsLOVImpl;
}
namespace Teamcenter
{
    class Fnd0ListOfSourcePropsLOV;
}
namespace Teamcenter
{
    class Fnd0ListOfSourcePropsLOVGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  LOV_API Teamcenter_alias::Fnd0ListOfSourcePropsLOVDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0ListOfSourcePropsLOVDelegate instance
    static Fnd0ListOfSourcePropsLOVDelegate&  getInstance();

    //  Method to create the Fnd0ListOfSourcePropsLOVImpl pointer
    static Fnd0ListOfSourcePropsLOVImpl*  createImpl( Fnd0ListOfSourcePropsLOV&  ifObj );

    //  Method to delete the Fnd0ListOfSourcePropsLOVImpl pointer
    static void deleteImpl( Fnd0ListOfSourcePropsLOVImpl*  impl );


    ///
    /// Returns List Of Values based on Dynamic LOV definition and user search criteria.
    /// @version Teamcenter 10
    /// @param operationInputTag - Operation Input containing the modified values.
    /// @param propertyName - Name of the selected property.
    /// @param searchString - User entered search string.
    /// @param sortByProp - Property to use for sorting.
    /// @param sortOrder - order for sorting (0=Ascending, 1=Descending).
    /// @param nResults - Number of returned results.
    /// @param results - Returned Values for LOV.
    /// @return - Zero (0) if everything is alright otherwise the error code.
    ///
    int  fnd0askLOVValuesBase(const Fnd0ListOfSourcePropsLOV &ifObj,  const tag_t operationInputTag, const std::string *propertyName, const std::string *searchString, const char *sortByProp, const int sortOrder, int *nResults, tag_t **results ) const;


    ///
    /// Returns true if the input value is valid for the Dynamic LOV.
    /// @version Teamcenter 10
    /// @param operationInputTag - Operation Input containing the modified values.
    /// @param propertyName - Name of the selected property.
    /// @param value - Value to validate.
    /// @param verdict - true if value is valid.
    /// @return - Zero (0) if everything is alright otherwise the error code.
    ///
    int  fnd0isValueValidBase(const Fnd0ListOfSourcePropsLOV &ifObj,  const tag_t operationInputTag, const std::string *propertyName, const std::string *value, bool *verdict ) const;



protected:
    //  Pointer to the instance
    static Fnd0ListOfSourcePropsLOVDelegate*  m_pInstance;

    Fnd0ListOfSourcePropsLOVDelegate();
    virtual ~Fnd0ListOfSourcePropsLOVDelegate();
    static void setInstance( Fnd0ListOfSourcePropsLOVDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0ListOfSourcePropsLOVGenImpl;

};

#include <lov/liblov_undef.h>
#endif  //  TEAMCENTER__FND0LISTOFSOURCEPROPSLOVDELEGATE_HXX
