//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0NameValueDynLOV
    Filename:   Fnd0NameValueDynLOV.hxx
    Module:     lov
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0NAMEVALUEDYNLOV__HXX
#define TEAMCENTER__FND0NAMEVALUEDYNLOV__HXX

#include <common/tc_deprecation_macros.h>
#include <lov/Fnd0ListOfValuesDynamic.hxx>

#include <lov/liblov_exports.h>

namespace Teamcenter
{
    class Fnd0NameValueDynLOV;
}
namespace Teamcenter
{
    class Fnd0NameValueDynLOVImpl;
}
namespace Teamcenter
{
    class Fnd0NameValueDynLOVDelegate;
}
namespace Teamcenter
{
    class Fnd0NameValueDynLOVDispatch;
}
namespace Teamcenter
{
    class Fnd0NameValueDynLOVGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LOV_API  Teamcenter::Fnd0NameValueDynLOV
     : public  ::Teamcenter::Fnd0ListOfValuesDynamic
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0NameValueDynLOV();

    /**
     * Destructor
     */
    virtual ~Fnd0NameValueDynLOV();

private:
    //  Getter method for the Implementation Object
    Fnd0NameValueDynLOVImpl*  getFnd0NameValueDynLOVImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0NameValueDynLOVImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0NameValueDynLOVImpl*  m_fnd0namevaluedynlovImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0NameValueDynLOV - desc for Fnd0NameValueDynLOV parameter
     */
    Fnd0NameValueDynLOV( const Fnd0NameValueDynLOV& );
    Fnd0NameValueDynLOV& operator=( const Fnd0NameValueDynLOV& );

    friend class  Fnd0NameValueDynLOVDelegate;
    friend class  Fnd0NameValueDynLOVDispatch;
    friend class  Fnd0NameValueDynLOVGenImpl;
};

#include <lov/liblov_undef.h>
#endif //   TEAMCENTER__FND0NAMEVALUEDYNLOV__HXX
