//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0UserProjectsLOVDelegate
    Filename:   Fnd0UserProjectsLOVDelegate.hxx
    Module:     lov
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0USERPROJECTSLOVDELEGATE_HXX
#define TEAMCENTER__FND0USERPROJECTSLOVDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <lov/Fnd0UserProjectsLOV.hxx>

#include <lov/liblov_exports.h>

namespace Teamcenter
{
    class Fnd0UserProjectsLOVDelegate;
}
namespace Teamcenter
{
    class Fnd0UserProjectsLOVImpl;
}
namespace Teamcenter
{
    class Fnd0UserProjectsLOV;
}
namespace Teamcenter
{
    class Fnd0UserProjectsLOVGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  LOV_API Teamcenter_alias::Fnd0UserProjectsLOVDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0UserProjectsLOVDelegate instance
    static Fnd0UserProjectsLOVDelegate&  getInstance();

    //  Method to create the Fnd0UserProjectsLOVImpl pointer
    static Fnd0UserProjectsLOVImpl*  createImpl( Fnd0UserProjectsLOV&  ifObj );

    //  Method to delete the Fnd0UserProjectsLOVImpl pointer
    static void deleteImpl( Fnd0UserProjectsLOVImpl*  impl );


    ///
    /// Returns List Of Values based on Dynamic LOV definition and user search criteria.
    /// @version Teamcenter 10
    /// @param operationInputTag - Operation Input containing the modified values.
    /// @param propertyName - Name of the selected property.
    /// @param searchString - User entered search string.
    /// @param sortByProp - Property to use for sorting.
    /// @param sortOrder - order for sorting (0=Ascending, 1=Descending).
    /// @param nResults - Number of returned results.
    /// @param results - Returned Values for LOV.
    /// @return - Zero (0) if everything is alright otherwise the error code.
    ///
    int  fnd0askLOVValuesBase(const Fnd0UserProjectsLOV &ifObj,  const tag_t operationInputTag, const std::string *propertyName, const std::string *searchString, const char *sortByProp, const int sortOrder, int *nResults, tag_t **results ) const;



protected:
    //  Pointer to the instance
    static Fnd0UserProjectsLOVDelegate*  m_pInstance;

    Fnd0UserProjectsLOVDelegate();
    virtual ~Fnd0UserProjectsLOVDelegate();
    static void setInstance( Fnd0UserProjectsLOVDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0UserProjectsLOVGenImpl;

};

#include <lov/liblov_undef.h>
#endif  //  TEAMCENTER__FND0USERPROJECTSLOVDELEGATE_HXX
