//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0UserSettingsLov
    Filename:   Fnd0UserSettingsLov.hxx
    Module:     lov
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0USERSETTINGSLOV__HXX
#define TEAMCENTER__FND0USERSETTINGSLOV__HXX

#include <common/tc_deprecation_macros.h>
#include <lov/Fnd0ListOfValuesDynamic.hxx>

#include <lov/liblov_exports.h>

namespace Teamcenter
{
    class Fnd0UserSettingsLov;
}
namespace Teamcenter
{
    class Fnd0UserSettingsLovImpl;
}
namespace Teamcenter
{
    class Fnd0UserSettingsLovDelegate;
}
namespace Teamcenter
{
    class Fnd0UserSettingsLovDispatch;
}
namespace Teamcenter
{
    class Fnd0UserSettingsLovGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LOV_API  Teamcenter::Fnd0UserSettingsLov
     : public  ::Teamcenter::Fnd0ListOfValuesDynamic
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0UserSettingsLov();

    /**
     * Destructor
     */
    virtual ~Fnd0UserSettingsLov();

private:
    //  Getter method for the Implementation Object
    Fnd0UserSettingsLovImpl*  getFnd0UserSettingsLovImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0UserSettingsLovImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0UserSettingsLovImpl*  m_fnd0usersettingslovImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0UserSettingsLov - desc for Fnd0UserSettingsLov parameter
     */
    Fnd0UserSettingsLov( const Fnd0UserSettingsLov& );
    Fnd0UserSettingsLov& operator=( const Fnd0UserSettingsLov& );

    friend class  Fnd0UserSettingsLovDelegate;
    friend class  Fnd0UserSettingsLovDispatch;
    friend class  Fnd0UserSettingsLovGenImpl;
};

#include <lov/liblov_undef.h>
#endif //   TEAMCENTER__FND0USERSETTINGSLOV__HXX
