//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ListOfValues
    Filename:   ListOfValues.hxx
    Module:     lov
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LISTOFVALUES__HXX
#define TEAMCENTER__LISTOFVALUES__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <lov/liblov_exports.h>

namespace Teamcenter
{
    class ListOfValues;
}
namespace Teamcenter
{
    class ListOfValuesImpl;
}
namespace Teamcenter
{
    class ListOfValuesDelegate;
}
namespace Teamcenter
{
    class ListOfValuesDispatch;
}
namespace Teamcenter
{
    class ListOfValuesGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LOV_API  Teamcenter::ListOfValues
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ListOfValues();

    /**
     * Destructor
     */
    virtual ~ListOfValues();

private:
    //  Getter method for the Implementation Object
    ListOfValuesImpl*  getListOfValuesImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setListOfValuesImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ListOfValuesImpl*  m_listofvaluesImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ListOfValues - desc for ListOfValues parameter
     */
    ListOfValues( const ListOfValues& );
    ListOfValues& operator=( const ListOfValues& );

    friend class  ListOfValuesDelegate;
    friend class  ListOfValuesDispatch;
    friend class  ListOfValuesGenImpl;
};

#include <lov/liblov_undef.h>
#endif //   TEAMCENTER__LISTOFVALUES__HXX
