//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ListOfValuesChar
    Filename:   ListOfValuesChar.hxx
    Module:     lov
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LISTOFVALUESCHAR__HXX
#define TEAMCENTER__LISTOFVALUESCHAR__HXX

#include <common/tc_deprecation_macros.h>
#include <lov/ListOfValues.hxx>

#include <lov/liblov_exports.h>

namespace Teamcenter
{
    class ListOfValuesChar;
}
namespace Teamcenter
{
    class ListOfValuesCharImpl;
}
namespace Teamcenter
{
    class ListOfValuesCharDelegate;
}
namespace Teamcenter
{
    class ListOfValuesCharDispatch;
}
namespace Teamcenter
{
    class ListOfValuesCharGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LOV_API  Teamcenter::ListOfValuesChar
     : public  ::Teamcenter::ListOfValues
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ListOfValuesChar();

    /**
     * Destructor
     */
    virtual ~ListOfValuesChar();

private:
    //  Getter method for the Implementation Object
    ListOfValuesCharImpl*  getListOfValuesCharImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setListOfValuesCharImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ListOfValuesCharImpl*  m_listofvaluescharImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ListOfValuesChar - desc for ListOfValuesChar parameter
     */
    ListOfValuesChar( const ListOfValuesChar& );
    ListOfValuesChar& operator=( const ListOfValuesChar& );

    friend class  ListOfValuesCharDelegate;
    friend class  ListOfValuesCharDispatch;
    friend class  ListOfValuesCharGenImpl;
};

#include <lov/liblov_undef.h>
#endif //   TEAMCENTER__LISTOFVALUESCHAR__HXX
