//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ListOfValuesDate
    Filename:   ListOfValuesDate.hxx
    Module:     lov
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LISTOFVALUESDATE__HXX
#define TEAMCENTER__LISTOFVALUESDATE__HXX

#include <common/tc_deprecation_macros.h>
#include <lov/ListOfValues.hxx>

#include <lov/liblov_exports.h>

namespace Teamcenter
{
    class ListOfValuesDate;
}
namespace Teamcenter
{
    class ListOfValuesDateImpl;
}
namespace Teamcenter
{
    class ListOfValuesDateDelegate;
}
namespace Teamcenter
{
    class ListOfValuesDateDispatch;
}
namespace Teamcenter
{
    class ListOfValuesDateGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LOV_API  Teamcenter::ListOfValuesDate
     : public  ::Teamcenter::ListOfValues
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ListOfValuesDate();

    /**
     * Destructor
     */
    virtual ~ListOfValuesDate();

private:
    //  Getter method for the Implementation Object
    ListOfValuesDateImpl*  getListOfValuesDateImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setListOfValuesDateImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ListOfValuesDateImpl*  m_listofvaluesdateImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ListOfValuesDate - desc for ListOfValuesDate parameter
     */
    ListOfValuesDate( const ListOfValuesDate& );
    ListOfValuesDate& operator=( const ListOfValuesDate& );

    friend class  ListOfValuesDateDelegate;
    friend class  ListOfValuesDateDispatch;
    friend class  ListOfValuesDateGenImpl;
};

#include <lov/liblov_undef.h>
#endif //   TEAMCENTER__LISTOFVALUESDATE__HXX
