//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ListOfValuesDouble
    Filename:   ListOfValuesDouble.hxx
    Module:     lov
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LISTOFVALUESDOUBLE__HXX
#define TEAMCENTER__LISTOFVALUESDOUBLE__HXX

#include <common/tc_deprecation_macros.h>
#include <lov/ListOfValues.hxx>

#include <lov/liblov_exports.h>

namespace Teamcenter
{
    class ListOfValuesDouble;
}
namespace Teamcenter
{
    class ListOfValuesDoubleImpl;
}
namespace Teamcenter
{
    class ListOfValuesDoubleDelegate;
}
namespace Teamcenter
{
    class ListOfValuesDoubleDispatch;
}
namespace Teamcenter
{
    class ListOfValuesDoubleGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LOV_API  Teamcenter::ListOfValuesDouble
     : public  ::Teamcenter::ListOfValues
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ListOfValuesDouble();

    /**
     * Destructor
     */
    virtual ~ListOfValuesDouble();

private:
    //  Getter method for the Implementation Object
    ListOfValuesDoubleImpl*  getListOfValuesDoubleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setListOfValuesDoubleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ListOfValuesDoubleImpl*  m_listofvaluesdoubleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ListOfValuesDouble - desc for ListOfValuesDouble parameter
     */
    ListOfValuesDouble( const ListOfValuesDouble& );
    ListOfValuesDouble& operator=( const ListOfValuesDouble& );

    friend class  ListOfValuesDoubleDelegate;
    friend class  ListOfValuesDoubleDispatch;
    friend class  ListOfValuesDoubleGenImpl;
};

#include <lov/liblov_undef.h>
#endif //   TEAMCENTER__LISTOFVALUESDOUBLE__HXX
