//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ListOfValuesFilter
    Filename:   ListOfValuesFilter.hxx
    Module:     lov
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LISTOFVALUESFILTER__HXX
#define TEAMCENTER__LISTOFVALUESFILTER__HXX

#include <common/tc_deprecation_macros.h>
#include <lov/ListOfValues.hxx>

#include <lov/liblov_exports.h>

namespace Teamcenter
{
    class ListOfValuesFilter;
}
namespace Teamcenter
{
    class ListOfValuesFilterImpl;
}
namespace Teamcenter
{
    class ListOfValuesFilterDelegate;
}
namespace Teamcenter
{
    class ListOfValuesFilterDispatch;
}
namespace Teamcenter
{
    class ListOfValuesFilterGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LOV_API  Teamcenter::ListOfValuesFilter
     : public  ::Teamcenter::ListOfValues
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ListOfValuesFilter();

    /**
     * Destructor
     */
    virtual ~ListOfValuesFilter();

private:
    //  Getter method for the Implementation Object
    ListOfValuesFilterImpl*  getListOfValuesFilterImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setListOfValuesFilterImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ListOfValuesFilterImpl*  m_listofvaluesfilterImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ListOfValuesFilter - desc for ListOfValuesFilter parameter
     */
    ListOfValuesFilter( const ListOfValuesFilter& );
    ListOfValuesFilter& operator=( const ListOfValuesFilter& );

    friend class  ListOfValuesFilterDelegate;
    friend class  ListOfValuesFilterDispatch;
    friend class  ListOfValuesFilterGenImpl;
};

#include <lov/liblov_undef.h>
#endif //   TEAMCENTER__LISTOFVALUESFILTER__HXX
