//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ListOfValuesInteger
    Filename:   ListOfValuesInteger.hxx
    Module:     lov
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LISTOFVALUESINTEGER__HXX
#define TEAMCENTER__LISTOFVALUESINTEGER__HXX

#include <common/tc_deprecation_macros.h>
#include <lov/ListOfValues.hxx>

#include <lov/liblov_exports.h>

namespace Teamcenter
{
    class ListOfValuesInteger;
}
namespace Teamcenter
{
    class ListOfValuesIntegerImpl;
}
namespace Teamcenter
{
    class ListOfValuesIntegerDelegate;
}
namespace Teamcenter
{
    class ListOfValuesIntegerDispatch;
}
namespace Teamcenter
{
    class ListOfValuesIntegerGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LOV_API  Teamcenter::ListOfValuesInteger
     : public  ::Teamcenter::ListOfValues
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ListOfValuesInteger();

    /**
     * Destructor
     */
    virtual ~ListOfValuesInteger();

private:
    //  Getter method for the Implementation Object
    ListOfValuesIntegerImpl*  getListOfValuesIntegerImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setListOfValuesIntegerImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ListOfValuesIntegerImpl*  m_listofvaluesintegerImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ListOfValuesInteger - desc for ListOfValuesInteger parameter
     */
    ListOfValuesInteger( const ListOfValuesInteger& );
    ListOfValuesInteger& operator=( const ListOfValuesInteger& );

    friend class  ListOfValuesIntegerDelegate;
    friend class  ListOfValuesIntegerDispatch;
    friend class  ListOfValuesIntegerGenImpl;
};

#include <lov/liblov_undef.h>
#endif //   TEAMCENTER__LISTOFVALUESINTEGER__HXX
