//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ListOfValuesString
    Filename:   ListOfValuesString.hxx
    Module:     lov
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LISTOFVALUESSTRING__HXX
#define TEAMCENTER__LISTOFVALUESSTRING__HXX

#include <common/tc_deprecation_macros.h>
#include <lov/ListOfValues.hxx>

#include <lov/liblov_exports.h>

namespace Teamcenter
{
    class ListOfValuesString;
}
namespace Teamcenter
{
    class ListOfValuesStringImpl;
}
namespace Teamcenter
{
    class ListOfValuesStringDelegate;
}
namespace Teamcenter
{
    class ListOfValuesStringDispatch;
}
namespace Teamcenter
{
    class ListOfValuesStringGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LOV_API  Teamcenter::ListOfValuesString
     : public  ::Teamcenter::ListOfValues
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ListOfValuesString();

    /**
     * Destructor
     */
    virtual ~ListOfValuesString();

private:
    //  Getter method for the Implementation Object
    ListOfValuesStringImpl*  getListOfValuesStringImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setListOfValuesStringImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ListOfValuesStringImpl*  m_listofvaluesstringImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ListOfValuesString - desc for ListOfValuesString parameter
     */
    ListOfValuesString( const ListOfValuesString& );
    ListOfValuesString& operator=( const ListOfValuesString& );

    friend class  ListOfValuesStringDelegate;
    friend class  ListOfValuesStringDispatch;
    friend class  ListOfValuesStringGenImpl;
};

#include <lov/liblov_undef.h>
#endif //   TEAMCENTER__LISTOFVALUESSTRING__HXX
