//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ListOfValuesTag
    Filename:   ListOfValuesTag.hxx
    Module:     lov
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LISTOFVALUESTAG__HXX
#define TEAMCENTER__LISTOFVALUESTAG__HXX

#include <common/tc_deprecation_macros.h>
#include <lov/ListOfValues.hxx>

#include <lov/liblov_exports.h>

namespace Teamcenter
{
    class ListOfValuesTag;
}
namespace Teamcenter
{
    class ListOfValuesTagImpl;
}
namespace Teamcenter
{
    class ListOfValuesTagDelegate;
}
namespace Teamcenter
{
    class ListOfValuesTagDispatch;
}
namespace Teamcenter
{
    class ListOfValuesTagGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  LOV_API  Teamcenter::ListOfValuesTag
     : public  ::Teamcenter::ListOfValues
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ListOfValuesTag();

    /**
     * Destructor
     */
    virtual ~ListOfValuesTag();

private:
    //  Getter method for the Implementation Object
    ListOfValuesTagImpl*  getListOfValuesTagImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setListOfValuesTagImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ListOfValuesTagImpl*  m_listofvaluestagImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ListOfValuesTag - desc for ListOfValuesTag parameter
     */
    ListOfValuesTag( const ListOfValuesTag& );
    ListOfValuesTag& operator=( const ListOfValuesTag& );

    friend class  ListOfValuesTagDelegate;
    friend class  ListOfValuesTagDispatch;
    friend class  ListOfValuesTagGenImpl;
};

#include <lov/liblov_undef.h>
#endif //   TEAMCENTER__LISTOFVALUESTAG__HXX
