//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  lov

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            liblov

#if !defined(LIBLOV) && !defined(IPLIB)
#   error IPLIB or LIBLOV is not defined
#endif

/* Handwritten code should use LOV_API, not LOVEXPORT */

#define LOV_API LOVEXPORT

#if IPLIB==liblov || defined(LIBLOV)
#   if defined(__lint)
#       define LOVEXPORT       __export(lov)
#       define LOVGLOBAL       extern __global(lov)
#       define LOVPRIVATE      extern __private(lov)
#   elif defined(_WIN32)
#       define LOVEXPORT       __declspec(dllexport)
#       define LOVGLOBAL       extern __declspec(dllexport)
#       define LOVPRIVATE      extern
#   else
#       define LOVEXPORT
#       define LOVGLOBAL       extern
#       define LOVPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define LOVEXPORT       __export(lov)
#       define LOVGLOBAL       extern __global(lov)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define LOVEXPORT      __declspec(dllimport)
#       define LOVGLOBAL       extern __declspec(dllimport)
#   else
#       define LOVEXPORT
#       define LOVGLOBAL       extern
#   endif
#endif
