//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  lrm0lisrmdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            liblrm0lisrmdispatch

#if !defined(LIBLRM0LISRMDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBLRM0LISRMDISPATCH is not defined
#endif

/* Handwritten code should use LRM0LISRMDISPATCH_API, not LRM0LISRMDISPATCHEXPORT */

#define LRM0LISRMDISPATCH_API LRM0LISRMDISPATCHEXPORT

#if IPLIB==liblrm0lisrmdispatch || defined(LIBLRM0LISRMDISPATCH)
#   if defined(__lint)
#       define LRM0LISRMDISPATCHEXPORT       __export(lrm0lisrmdispatch)
#       define LRM0LISRMDISPATCHGLOBAL       extern __global(lrm0lisrmdispatch)
#       define LRM0LISRMDISPATCHPRIVATE      extern __private(lrm0lisrmdispatch)
#   elif defined(_WIN32)
#       define LRM0LISRMDISPATCHEXPORT       __declspec(dllexport)
#       define LRM0LISRMDISPATCHGLOBAL       extern __declspec(dllexport)
#       define LRM0LISRMDISPATCHPRIVATE      extern
#   else
#       define LRM0LISRMDISPATCHEXPORT
#       define LRM0LISRMDISPATCHGLOBAL       extern
#       define LRM0LISRMDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define LRM0LISRMDISPATCHEXPORT       __export(lrm0lisrmdispatch)
#       define LRM0LISRMDISPATCHGLOBAL       extern __global(lrm0lisrmdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define LRM0LISRMDISPATCHEXPORT      __declspec(dllimport)
#       define LRM0LISRMDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define LRM0LISRMDISPATCHEXPORT
#       define LRM0LISRMDISPATCHGLOBAL       extern
#   endif
#endif
