//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mat1InheritedParamDouble
    Filename:   Mat1InheritedParamDouble.hxx
    Module:     mat1materialmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef MATERIALMGMT__MAT1INHERITEDPARAMDOUBLE__HXX
#define MATERIALMGMT__MAT1INHERITEDPARAMDOUBLE__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <mat1materialmgmt/libmat1materialmgmt_exports.h>

namespace materialmgmt
{
    class Mat1InheritedParamDouble;
}
namespace materialmgmt
{
    class Mat1InheritedParamDoubleImpl;
}
namespace materialmgmt
{
    class Mat1InheritedParamDoubleDelegate;
}
namespace materialmgmt
{
    class Mat1InheritedParamDoubleDispatch;
}
namespace materialmgmt
{
    class Mat1InheritedParamDoubleGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MAT1MATERIALMGMT_API  materialmgmt::Mat1InheritedParamDouble
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 13.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMat1SessionUnit( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Double Property
    /// @version Teamcenter 13.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMat1SessionValue( double &value, bool &isNull ) const;

    ///
    /// Getter for a Double Property
    /// @version Teamcenter 13.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMat1SessionValueMax( double &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mat1InheritedParamDouble();

    /**
     * Destructor
     */
    virtual ~Mat1InheritedParamDouble();

private:
    //  Getter method for the Implementation Object
    Mat1InheritedParamDoubleImpl*  getMat1InheritedParamDoubleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMat1InheritedParamDoubleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mat1InheritedParamDoubleImpl*  m_mat1inheritedparamdoubleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mat1InheritedParamDouble - desc for Mat1InheritedParamDouble parameter
     */
    Mat1InheritedParamDouble( const Mat1InheritedParamDouble& );
    Mat1InheritedParamDouble& operator=( const Mat1InheritedParamDouble& );

    friend class  Mat1InheritedParamDoubleDelegate;
    friend class  Mat1InheritedParamDoubleDispatch;
    friend class  Mat1InheritedParamDoubleGenImpl;
};

#include <mat1materialmgmt/libmat1materialmgmt_undef.h>
#endif //   MATERIALMGMT__MAT1INHERITEDPARAMDOUBLE__HXX
