//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mat1InheritedParamDoubleDelegate
    Filename:   Mat1InheritedParamDoubleDelegate.hxx
    Module:     mat1materialmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef MATERIALMGMT__MAT1INHERITEDPARAMDOUBLEDELEGATE_HXX
#define MATERIALMGMT__MAT1INHERITEDPARAMDOUBLEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mat1materialmgmt/Mat1InheritedParamDouble.hxx>

#include <mat1materialmgmt/libmat1materialmgmt_exports.h>

namespace materialmgmt
{
    class Mat1InheritedParamDoubleDelegate;
}
namespace materialmgmt
{
    class Mat1InheritedParamDoubleImpl;
}
namespace materialmgmt
{
    class Mat1InheritedParamDouble;
}
namespace materialmgmt
{
    class Mat1InheritedParamDoubleGenImpl;
}

namespace materialmgmt_alias = ::materialmgmt;


class  MAT1MATERIALMGMT_API materialmgmt_alias::Mat1InheritedParamDoubleDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mat1InheritedParamDoubleDelegate instance
    static Mat1InheritedParamDoubleDelegate&  getInstance();

    //  Method to create the Mat1InheritedParamDoubleImpl pointer
    static Mat1InheritedParamDoubleImpl*  createImpl( Mat1InheritedParamDouble&  ifObj );

    //  Method to delete the Mat1InheritedParamDoubleImpl pointer
    static void deleteImpl( Mat1InheritedParamDoubleImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 13.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMat1SessionUnitBase(const Mat1InheritedParamDouble &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 13.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMat1SessionValueBase(const Mat1InheritedParamDouble &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 13.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMat1SessionValueMaxBase(const Mat1InheritedParamDouble &ifObj,  double &value, bool &isNull ) const;



protected:
    //  Pointer to the instance
    static Mat1InheritedParamDoubleDelegate*  m_pInstance;

    Mat1InheritedParamDoubleDelegate();
    virtual ~Mat1InheritedParamDoubleDelegate();
    static void setInstance( Mat1InheritedParamDoubleDelegate*  instance );


private:
    friend class  ::materialmgmt::Mat1InheritedParamDoubleGenImpl;

};

#include <mat1materialmgmt/libmat1materialmgmt_undef.h>
#endif  //  MATERIALMGMT__MAT1INHERITEDPARAMDOUBLEDELEGATE_HXX
