//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mat1InheritedParamSmrtTbl
    Filename:   Mat1InheritedParamSmrtTbl.hxx
    Module:     mat1materialmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef MATERIALMGMT__MAT1INHERITEDPARAMSMRTTBL__HXX
#define MATERIALMGMT__MAT1INHERITEDPARAMSMRTTBL__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <mat1materialmgmt/libmat1materialmgmt_exports.h>

namespace materialmgmt
{
    class Mat1InheritedParamSmrtTbl;
}
namespace materialmgmt
{
    class Mat1InheritedParamSmrtTblImpl;
}
namespace materialmgmt
{
    class Mat1InheritedParamSmrtTblDelegate;
}
namespace materialmgmt
{
    class Mat1InheritedParamSmrtTblDispatch;
}
namespace materialmgmt
{
    class Mat1InheritedParamSmrtTblGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MAT1MATERIALMGMT_API  materialmgmt::Mat1InheritedParamSmrtTbl
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 13.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMat1SessionUnitX( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 13.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMat1SessionUnitY( tag_t &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mat1InheritedParamSmrtTbl();

    /**
     * Destructor
     */
    virtual ~Mat1InheritedParamSmrtTbl();

private:
    //  Getter method for the Implementation Object
    Mat1InheritedParamSmrtTblImpl*  getMat1InheritedParamSmrtTblImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMat1InheritedParamSmrtTblImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mat1InheritedParamSmrtTblImpl*  m_mat1inheritedparamsmrttblImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mat1InheritedParamSmrtTbl - desc for Mat1InheritedParamSmrtTbl parameter
     */
    Mat1InheritedParamSmrtTbl( const Mat1InheritedParamSmrtTbl& );
    Mat1InheritedParamSmrtTbl& operator=( const Mat1InheritedParamSmrtTbl& );

    friend class  Mat1InheritedParamSmrtTblDelegate;
    friend class  Mat1InheritedParamSmrtTblDispatch;
    friend class  Mat1InheritedParamSmrtTblGenImpl;
};

#include <mat1materialmgmt/libmat1materialmgmt_undef.h>
#endif //   MATERIALMGMT__MAT1INHERITEDPARAMSMRTTBL__HXX
