//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mat1InheritedParamString
    Filename:   Mat1InheritedParamString.hxx
    Module:     mat1materialmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef MATERIALMGMT__MAT1INHERITEDPARAMSTRING__HXX
#define MATERIALMGMT__MAT1INHERITEDPARAMSTRING__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <mat1materialmgmt/libmat1materialmgmt_exports.h>

namespace materialmgmt
{
    class Mat1InheritedParamString;
}
namespace materialmgmt
{
    class Mat1InheritedParamStringImpl;
}
namespace materialmgmt
{
    class Mat1InheritedParamStringDelegate;
}
namespace materialmgmt
{
    class Mat1InheritedParamStringDispatch;
}
namespace materialmgmt
{
    class Mat1InheritedParamStringGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MAT1MATERIALMGMT_API  materialmgmt::Mat1InheritedParamString
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 13.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMat1SessionValue( std::string &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mat1InheritedParamString();

    /**
     * Destructor
     */
    virtual ~Mat1InheritedParamString();

private:
    //  Getter method for the Implementation Object
    Mat1InheritedParamStringImpl*  getMat1InheritedParamStringImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMat1InheritedParamStringImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mat1InheritedParamStringImpl*  m_mat1inheritedparamstringImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mat1InheritedParamString - desc for Mat1InheritedParamString parameter
     */
    Mat1InheritedParamString( const Mat1InheritedParamString& );
    Mat1InheritedParamString& operator=( const Mat1InheritedParamString& );

    friend class  Mat1InheritedParamStringDelegate;
    friend class  Mat1InheritedParamStringDispatch;
    friend class  Mat1InheritedParamStringGenImpl;
};

#include <mat1materialmgmt/libmat1materialmgmt_undef.h>
#endif //   MATERIALMGMT__MAT1INHERITEDPARAMSTRING__HXX
