//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mat1Material
    Filename:   Mat1Material.hxx
    Module:     mat1materialmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef MATERIALMGMT__MAT1MATERIAL__HXX
#define MATERIALMGMT__MAT1MATERIAL__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <mat1materialmgmt/libmat1materialmgmt_exports.h>

namespace materialmgmt
{
    class Mat1Material;
}
namespace materialmgmt
{
    class Mat1MaterialImpl;
}
namespace materialmgmt
{
    class Mat1MaterialDelegate;
}
namespace materialmgmt
{
    class Mat1MaterialDispatch;
}
namespace materialmgmt
{
    class Mat1MaterialGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MAT1MATERIALMGMT_API  materialmgmt::Mat1Material
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMat1cas_number( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMat1external_identifier( const std::string &value, bool isNull=false );

    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMat1non_library( bool value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMat1unique_identifier( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mat1Material();

    /**
     * Destructor
     */
    virtual ~Mat1Material();

private:
    //  Getter method for the Implementation Object
    Mat1MaterialImpl*  getMat1MaterialImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMat1MaterialImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mat1MaterialImpl*  m_mat1materialImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mat1Material - desc for Mat1Material parameter
     */
    Mat1Material( const Mat1Material& );
    Mat1Material& operator=( const Mat1Material& );

    friend class  Mat1MaterialDelegate;
    friend class  Mat1MaterialDispatch;
    friend class  Mat1MaterialGenImpl;
};

#include <mat1materialmgmt/libmat1materialmgmt_undef.h>
#endif //   MATERIALMGMT__MAT1MATERIAL__HXX
