//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mat1MaterialDelegate
    Filename:   Mat1MaterialDelegate.hxx
    Module:     mat1materialmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef MATERIALMGMT__MAT1MATERIALDELEGATE_HXX
#define MATERIALMGMT__MAT1MATERIALDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mat1materialmgmt/Mat1Material.hxx>

#include <mat1materialmgmt/libmat1materialmgmt_exports.h>

namespace materialmgmt
{
    class Mat1MaterialDelegate;
}
namespace materialmgmt
{
    class Mat1MaterialImpl;
}
namespace materialmgmt
{
    class Mat1Material;
}
namespace materialmgmt
{
    class Mat1MaterialGenImpl;
}

namespace materialmgmt_alias = ::materialmgmt;


class  MAT1MATERIALMGMT_API materialmgmt_alias::Mat1MaterialDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mat1MaterialDelegate instance
    static Mat1MaterialDelegate&  getInstance();

    //  Method to create the Mat1MaterialImpl pointer
    static Mat1MaterialImpl*  createImpl( Mat1Material&  ifObj );

    //  Method to delete the Mat1MaterialImpl pointer
    static void deleteImpl( Mat1MaterialImpl*  impl );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMat1cas_numberBase(Mat1Material &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMat1external_identifierBase(Mat1Material &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMat1non_libraryBase(Mat1Material &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMat1unique_identifierBase(Mat1Material &ifObj,  const std::string &value, bool isNull );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Mat1Material &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// validate saveas input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  validateSaveAsInputBase(const Mat1Material &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static Mat1MaterialDelegate*  m_pInstance;

    Mat1MaterialDelegate();
    virtual ~Mat1MaterialDelegate();
    static void setInstance( Mat1MaterialDelegate*  instance );


private:
    friend class  ::materialmgmt::Mat1MaterialGenImpl;

};

#include <mat1materialmgmt/libmat1materialmgmt_undef.h>
#endif  //  MATERIALMGMT__MAT1MATERIALDELEGATE_HXX
