//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mat1MaterialRevisionDelegate
    Filename:   Mat1MaterialRevisionDelegate.hxx
    Module:     mat1materialmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef MATERIALMGMT__MAT1MATERIALREVISIONDELEGATE_HXX
#define MATERIALMGMT__MAT1MATERIALREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mat1materialmgmt/Mat1MaterialRevision.hxx>

#include <mat1materialmgmt/libmat1materialmgmt_exports.h>

namespace materialmgmt
{
    class Mat1MaterialRevisionDelegate;
}
namespace materialmgmt
{
    class Mat1MaterialRevisionImpl;
}
namespace materialmgmt
{
    class Mat1MaterialRevision;
}
namespace materialmgmt
{
    class Mat1MaterialRevisionGenImpl;
}

namespace materialmgmt_alias = ::materialmgmt;


class  MAT1MATERIALMGMT_API materialmgmt_alias::Mat1MaterialRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mat1MaterialRevisionDelegate instance
    static Mat1MaterialRevisionDelegate&  getInstance();

    //  Method to create the Mat1MaterialRevisionImpl pointer
    static Mat1MaterialRevisionImpl*  createImpl( Mat1MaterialRevision&  ifObj );

    //  Method to delete the Mat1MaterialRevisionImpl pointer
    static void deleteImpl( Mat1MaterialRevisionImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMat1substance_detailsBase(const Mat1MaterialRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMat1substancesBase(const Mat1MaterialRevision &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMat1ExtendsMaterialBase(Mat1MaterialRevision &ifObj,  const tag_t &value, bool isNull );



protected:
    //  Pointer to the instance
    static Mat1MaterialRevisionDelegate*  m_pInstance;

    Mat1MaterialRevisionDelegate();
    virtual ~Mat1MaterialRevisionDelegate();
    static void setInstance( Mat1MaterialRevisionDelegate*  instance );


private:
    friend class  ::materialmgmt::Mat1MaterialRevisionGenImpl;

};

#include <mat1materialmgmt/libmat1materialmgmt_undef.h>
#endif  //  MATERIALMGMT__MAT1MATERIALREVISIONDELEGATE_HXX
