//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mat1ParameterDouble
    Filename:   Mat1ParameterDouble.hxx
    Module:     mat1materialmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef MATERIALMGMT__MAT1PARAMETERDOUBLE__HXX
#define MATERIALMGMT__MAT1PARAMETERDOUBLE__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <mat1materialmgmt/libmat1materialmgmt_exports.h>

namespace materialmgmt
{
    class Mat1ParameterDouble;
}
namespace materialmgmt
{
    class Mat1ParameterDoubleImpl;
}
namespace materialmgmt
{
    class Mat1ParameterDoubleDelegate;
}
namespace materialmgmt
{
    class Mat1ParameterDoubleDispatch;
}
namespace materialmgmt
{
    class Mat1ParameterDoubleGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MAT1MATERIALMGMT_API  materialmgmt::Mat1ParameterDouble
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 13.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMat1SessionUnit( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Double Property
    /// @version Teamcenter 13.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMat1SessionValue( double &value, bool &isNull ) const;

    ///
    /// Getter for a Double Property
    /// @version Teamcenter 13.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMat1SessionValueMax( double &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 13.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMat1SessionUnit( const tag_t &value, bool isNull=false );

    ///
    /// Setter for a Double Property
    /// @version Teamcenter 13.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMat1SessionValue( double value, bool isNull=false );

    ///
    /// Setter for a Double Property
    /// @version Teamcenter 13.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMat1SessionValueMax( double value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mat1ParameterDouble();

    /**
     * Destructor
     */
    virtual ~Mat1ParameterDouble();

private:
    //  Getter method for the Implementation Object
    Mat1ParameterDoubleImpl*  getMat1ParameterDoubleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMat1ParameterDoubleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mat1ParameterDoubleImpl*  m_mat1parameterdoubleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mat1ParameterDouble - desc for Mat1ParameterDouble parameter
     */
    Mat1ParameterDouble( const Mat1ParameterDouble& );
    Mat1ParameterDouble& operator=( const Mat1ParameterDouble& );

    friend class  Mat1ParameterDoubleDelegate;
    friend class  Mat1ParameterDoubleDispatch;
    friend class  Mat1ParameterDoubleGenImpl;
};

#include <mat1materialmgmt/libmat1materialmgmt_undef.h>
#endif //   MATERIALMGMT__MAT1PARAMETERDOUBLE__HXX
