//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mat1ParameterDoubleDelegate
    Filename:   Mat1ParameterDoubleDelegate.hxx
    Module:     mat1materialmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef MATERIALMGMT__MAT1PARAMETERDOUBLEDELEGATE_HXX
#define MATERIALMGMT__MAT1PARAMETERDOUBLEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mat1materialmgmt/Mat1ParameterDouble.hxx>

#include <mat1materialmgmt/libmat1materialmgmt_exports.h>

namespace materialmgmt
{
    class Mat1ParameterDoubleDelegate;
}
namespace materialmgmt
{
    class Mat1ParameterDoubleImpl;
}
namespace materialmgmt
{
    class Mat1ParameterDouble;
}
namespace materialmgmt
{
    class Mat1ParameterDoubleGenImpl;
}

namespace materialmgmt_alias = ::materialmgmt;


class  MAT1MATERIALMGMT_API materialmgmt_alias::Mat1ParameterDoubleDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mat1ParameterDoubleDelegate instance
    static Mat1ParameterDoubleDelegate&  getInstance();

    //  Method to create the Mat1ParameterDoubleImpl pointer
    static Mat1ParameterDoubleImpl*  createImpl( Mat1ParameterDouble&  ifObj );

    //  Method to delete the Mat1ParameterDoubleImpl pointer
    static void deleteImpl( Mat1ParameterDoubleImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 13.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMat1SessionUnitBase(const Mat1ParameterDouble &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 13.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMat1SessionValueBase(const Mat1ParameterDouble &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 13.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMat1SessionValueMaxBase(const Mat1ParameterDouble &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 13.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMat1SessionUnitBase(Mat1ParameterDouble &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Teamcenter 13.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMat1SessionValueBase(Mat1ParameterDouble &ifObj,  double value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Teamcenter 13.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMat1SessionValueMaxBase(Mat1ParameterDouble &ifObj,  double value, bool isNull );



protected:
    //  Pointer to the instance
    static Mat1ParameterDoubleDelegate*  m_pInstance;

    Mat1ParameterDoubleDelegate();
    virtual ~Mat1ParameterDoubleDelegate();
    static void setInstance( Mat1ParameterDoubleDelegate*  instance );


private:
    friend class  ::materialmgmt::Mat1ParameterDoubleGenImpl;

};

#include <mat1materialmgmt/libmat1materialmgmt_undef.h>
#endif  //  MATERIALMGMT__MAT1PARAMETERDOUBLEDELEGATE_HXX
