//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mat1ParameterSmartTable
    Filename:   Mat1ParameterSmartTable.hxx
    Module:     mat1materialmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef MATERIALMGMT__MAT1PARAMETERSMARTTABLE__HXX
#define MATERIALMGMT__MAT1PARAMETERSMARTTABLE__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <mat1materialmgmt/libmat1materialmgmt_exports.h>

namespace materialmgmt
{
    class Mat1ParameterSmartTable;
}
namespace materialmgmt
{
    class Mat1ParameterSmartTableImpl;
}
namespace materialmgmt
{
    class Mat1ParameterSmartTableDelegate;
}
namespace materialmgmt
{
    class Mat1ParameterSmartTableDispatch;
}
namespace materialmgmt
{
    class Mat1ParameterSmartTableGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MAT1MATERIALMGMT_API  materialmgmt::Mat1ParameterSmartTable
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 13.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMat1SessionUnitX( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 13.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMat1SessionUnitY( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 13.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMat1SessionUnitX( const tag_t &value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 13.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMat1SessionUnitY( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mat1ParameterSmartTable();

    /**
     * Destructor
     */
    virtual ~Mat1ParameterSmartTable();

private:
    //  Getter method for the Implementation Object
    Mat1ParameterSmartTableImpl*  getMat1ParameterSmartTableImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMat1ParameterSmartTableImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mat1ParameterSmartTableImpl*  m_mat1parametersmarttableImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mat1ParameterSmartTable - desc for Mat1ParameterSmartTable parameter
     */
    Mat1ParameterSmartTable( const Mat1ParameterSmartTable& );
    Mat1ParameterSmartTable& operator=( const Mat1ParameterSmartTable& );

    friend class  Mat1ParameterSmartTableDelegate;
    friend class  Mat1ParameterSmartTableDispatch;
    friend class  Mat1ParameterSmartTableGenImpl;
};

#include <mat1materialmgmt/libmat1materialmgmt_undef.h>
#endif //   MATERIALMGMT__MAT1PARAMETERSMARTTABLE__HXX
