//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mat1ParameterSmartTableDelegate
    Filename:   Mat1ParameterSmartTableDelegate.hxx
    Module:     mat1materialmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef MATERIALMGMT__MAT1PARAMETERSMARTTABLEDELEGATE_HXX
#define MATERIALMGMT__MAT1PARAMETERSMARTTABLEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mat1materialmgmt/Mat1ParameterSmartTable.hxx>

#include <mat1materialmgmt/libmat1materialmgmt_exports.h>

namespace materialmgmt
{
    class Mat1ParameterSmartTableDelegate;
}
namespace materialmgmt
{
    class Mat1ParameterSmartTableImpl;
}
namespace materialmgmt
{
    class Mat1ParameterSmartTable;
}
namespace materialmgmt
{
    class Mat1ParameterSmartTableGenImpl;
}

namespace materialmgmt_alias = ::materialmgmt;


class  MAT1MATERIALMGMT_API materialmgmt_alias::Mat1ParameterSmartTableDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mat1ParameterSmartTableDelegate instance
    static Mat1ParameterSmartTableDelegate&  getInstance();

    //  Method to create the Mat1ParameterSmartTableImpl pointer
    static Mat1ParameterSmartTableImpl*  createImpl( Mat1ParameterSmartTable&  ifObj );

    //  Method to delete the Mat1ParameterSmartTableImpl pointer
    static void deleteImpl( Mat1ParameterSmartTableImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 13.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMat1SessionUnitXBase(const Mat1ParameterSmartTable &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 13.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMat1SessionUnitYBase(const Mat1ParameterSmartTable &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 13.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMat1SessionUnitXBase(Mat1ParameterSmartTable &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 13.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMat1SessionUnitYBase(Mat1ParameterSmartTable &ifObj,  const tag_t &value, bool isNull );



protected:
    //  Pointer to the instance
    static Mat1ParameterSmartTableDelegate*  m_pInstance;

    Mat1ParameterSmartTableDelegate();
    virtual ~Mat1ParameterSmartTableDelegate();
    static void setInstance( Mat1ParameterSmartTableDelegate*  instance );


private:
    friend class  ::materialmgmt::Mat1ParameterSmartTableGenImpl;

};

#include <mat1materialmgmt/libmat1materialmgmt_undef.h>
#endif  //  MATERIALMGMT__MAT1PARAMETERSMARTTABLEDELEGATE_HXX
