//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mat1ParameterString
    Filename:   Mat1ParameterString.hxx
    Module:     mat1materialmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef MATERIALMGMT__MAT1PARAMETERSTRING__HXX
#define MATERIALMGMT__MAT1PARAMETERSTRING__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <mat1materialmgmt/libmat1materialmgmt_exports.h>

namespace materialmgmt
{
    class Mat1ParameterString;
}
namespace materialmgmt
{
    class Mat1ParameterStringImpl;
}
namespace materialmgmt
{
    class Mat1ParameterStringDelegate;
}
namespace materialmgmt
{
    class Mat1ParameterStringDispatch;
}
namespace materialmgmt
{
    class Mat1ParameterStringGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MAT1MATERIALMGMT_API  materialmgmt::Mat1ParameterString
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 13.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMat1SessionValue( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 13.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMat1SessionValue( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mat1ParameterString();

    /**
     * Destructor
     */
    virtual ~Mat1ParameterString();

private:
    //  Getter method for the Implementation Object
    Mat1ParameterStringImpl*  getMat1ParameterStringImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMat1ParameterStringImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mat1ParameterStringImpl*  m_mat1parameterstringImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mat1ParameterString - desc for Mat1ParameterString parameter
     */
    Mat1ParameterString( const Mat1ParameterString& );
    Mat1ParameterString& operator=( const Mat1ParameterString& );

    friend class  Mat1ParameterStringDelegate;
    friend class  Mat1ParameterStringDispatch;
    friend class  Mat1ParameterStringGenImpl;
};

#include <mat1materialmgmt/libmat1materialmgmt_undef.h>
#endif //   MATERIALMGMT__MAT1PARAMETERSTRING__HXX
