//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mat1ParameterStringDelegate
    Filename:   Mat1ParameterStringDelegate.hxx
    Module:     mat1materialmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef MATERIALMGMT__MAT1PARAMETERSTRINGDELEGATE_HXX
#define MATERIALMGMT__MAT1PARAMETERSTRINGDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mat1materialmgmt/Mat1ParameterString.hxx>

#include <mat1materialmgmt/libmat1materialmgmt_exports.h>

namespace materialmgmt
{
    class Mat1ParameterStringDelegate;
}
namespace materialmgmt
{
    class Mat1ParameterStringImpl;
}
namespace materialmgmt
{
    class Mat1ParameterString;
}
namespace materialmgmt
{
    class Mat1ParameterStringGenImpl;
}

namespace materialmgmt_alias = ::materialmgmt;


class  MAT1MATERIALMGMT_API materialmgmt_alias::Mat1ParameterStringDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mat1ParameterStringDelegate instance
    static Mat1ParameterStringDelegate&  getInstance();

    //  Method to create the Mat1ParameterStringImpl pointer
    static Mat1ParameterStringImpl*  createImpl( Mat1ParameterString&  ifObj );

    //  Method to delete the Mat1ParameterStringImpl pointer
    static void deleteImpl( Mat1ParameterStringImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 13.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMat1SessionValueBase(const Mat1ParameterString &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 13.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMat1SessionValueBase(Mat1ParameterString &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static Mat1ParameterStringDelegate*  m_pInstance;

    Mat1ParameterStringDelegate();
    virtual ~Mat1ParameterStringDelegate();
    static void setInstance( Mat1ParameterStringDelegate*  instance );


private:
    friend class  ::materialmgmt::Mat1ParameterStringGenImpl;

};

#include <mat1materialmgmt/libmat1materialmgmt_undef.h>
#endif  //  MATERIALMGMT__MAT1PARAMETERSTRINGDELEGATE_HXX
