//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mat1SmartCurve
    Filename:   Mat1SmartCurve.hxx
    Module:     mat1materialmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef MATERIALMGMT__MAT1SMARTCURVE__HXX
#define MATERIALMGMT__MAT1SMARTCURVE__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <mat1materialmgmt/libmat1materialmgmt_exports.h>

namespace materialmgmt
{
    class Mat1SmartCurve;
}
namespace materialmgmt
{
    class Mat1SmartCurveImpl;
}
namespace materialmgmt
{
    class Mat1SmartCurveDelegate;
}
namespace materialmgmt
{
    class Mat1SmartCurveDispatch;
}
namespace materialmgmt
{
    class Mat1SmartCurveGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MAT1MATERIALMGMT_API  materialmgmt::Mat1SmartCurve
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Double Array Property
    /// @version Teamcenter 13.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMat1SessionValueX( std::vector< double > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a Double Array Property
    /// @version Teamcenter 13.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMat1SessionValueY( std::vector< double > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for a Double Array Property
    /// @version Teamcenter 13.1
    /// @param values - Values to be set for the paramter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMat1SessionValueX( const std::vector< double > &values, const std::vector< int > *isNull=0 );

    ///
    /// Setter for a Double Array Property
    /// @version Teamcenter 13.1
    /// @param values - Values to be set for the paramter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMat1SessionValueY( const std::vector< double > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mat1SmartCurve();

    /**
     * Destructor
     */
    virtual ~Mat1SmartCurve();

private:
    //  Getter method for the Implementation Object
    Mat1SmartCurveImpl*  getMat1SmartCurveImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMat1SmartCurveImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mat1SmartCurveImpl*  m_mat1smartcurveImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mat1SmartCurve - desc for Mat1SmartCurve parameter
     */
    Mat1SmartCurve( const Mat1SmartCurve& );
    Mat1SmartCurve& operator=( const Mat1SmartCurve& );

    friend class  Mat1SmartCurveDelegate;
    friend class  Mat1SmartCurveDispatch;
    friend class  Mat1SmartCurveGenImpl;
};

#include <mat1materialmgmt/libmat1materialmgmt_undef.h>
#endif //   MATERIALMGMT__MAT1SMARTCURVE__HXX
