//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mat1SmartCurveDelegate
    Filename:   Mat1SmartCurveDelegate.hxx
    Module:     mat1materialmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef MATERIALMGMT__MAT1SMARTCURVEDELEGATE_HXX
#define MATERIALMGMT__MAT1SMARTCURVEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mat1materialmgmt/Mat1SmartCurve.hxx>

#include <mat1materialmgmt/libmat1materialmgmt_exports.h>

namespace materialmgmt
{
    class Mat1SmartCurveDelegate;
}
namespace materialmgmt
{
    class Mat1SmartCurveImpl;
}
namespace materialmgmt
{
    class Mat1SmartCurve;
}
namespace materialmgmt
{
    class Mat1SmartCurveGenImpl;
}

namespace materialmgmt_alias = ::materialmgmt;


class  MAT1MATERIALMGMT_API materialmgmt_alias::Mat1SmartCurveDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mat1SmartCurveDelegate instance
    static Mat1SmartCurveDelegate&  getInstance();

    //  Method to create the Mat1SmartCurveImpl pointer
    static Mat1SmartCurveImpl*  createImpl( Mat1SmartCurve&  ifObj );

    //  Method to delete the Mat1SmartCurveImpl pointer
    static void deleteImpl( Mat1SmartCurveImpl*  impl );


    ///
    /// Getter for a Double Array Property
    /// @version Teamcenter 13.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMat1SessionValueXBase(const Mat1SmartCurve &ifObj,  std::vector< double > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Double Array Property
    /// @version Teamcenter 13.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMat1SessionValueYBase(const Mat1SmartCurve &ifObj,  std::vector< double > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a Double Array Property
    /// @version Teamcenter 13.1
    /// @param values - Values to be set for the paramter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMat1SessionValueXBase(Mat1SmartCurve &ifObj,  const std::vector< double > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Double Array Property
    /// @version Teamcenter 13.1
    /// @param values - Values to be set for the paramter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMat1SessionValueYBase(Mat1SmartCurve &ifObj,  const std::vector< double > &values, const std::vector< int > *isNull );



protected:
    //  Pointer to the instance
    static Mat1SmartCurveDelegate*  m_pInstance;

    Mat1SmartCurveDelegate();
    virtual ~Mat1SmartCurveDelegate();
    static void setInstance( Mat1SmartCurveDelegate*  instance );


private:
    friend class  ::materialmgmt::Mat1SmartCurveGenImpl;

};

#include <mat1materialmgmt/libmat1materialmgmt_undef.h>
#endif  //  MATERIALMGMT__MAT1SMARTCURVEDELEGATE_HXX
