//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mat1UsesMaterial
    Filename:   Mat1UsesMaterial.hxx
    Module:     mat1materialmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef MATERIALMGMT__MAT1USESMATERIAL__HXX
#define MATERIALMGMT__MAT1USESMATERIAL__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <mat1materialmgmt/libmat1materialmgmt_exports.h>

namespace materialmgmt
{
    class Mat1UsesMaterial;
}
namespace materialmgmt
{
    class Mat1UsesMaterialImpl;
}
namespace materialmgmt
{
    class Mat1UsesMaterialDelegate;
}
namespace materialmgmt
{
    class Mat1UsesMaterialDispatch;
}
namespace materialmgmt
{
    class Mat1UsesMaterialGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MAT1MATERIALMGMT_API  materialmgmt::Mat1UsesMaterial
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMat1mass_in_grams( double &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mat1UsesMaterial();

    /**
     * Destructor
     */
    virtual ~Mat1UsesMaterial();

private:
    //  Getter method for the Implementation Object
    Mat1UsesMaterialImpl*  getMat1UsesMaterialImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMat1UsesMaterialImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mat1UsesMaterialImpl*  m_mat1usesmaterialImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mat1UsesMaterial - desc for Mat1UsesMaterial parameter
     */
    Mat1UsesMaterial( const Mat1UsesMaterial& );
    Mat1UsesMaterial& operator=( const Mat1UsesMaterial& );

    friend class  Mat1UsesMaterialDelegate;
    friend class  Mat1UsesMaterialDispatch;
    friend class  Mat1UsesMaterialGenImpl;
};

#include <mat1materialmgmt/libmat1materialmgmt_undef.h>
#endif //   MATERIALMGMT__MAT1USESMATERIAL__HXX
