//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mat1UsesMaterialDelegate
    Filename:   Mat1UsesMaterialDelegate.hxx
    Module:     mat1materialmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef MATERIALMGMT__MAT1USESMATERIALDELEGATE_HXX
#define MATERIALMGMT__MAT1USESMATERIALDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mat1materialmgmt/Mat1UsesMaterial.hxx>

#include <mat1materialmgmt/libmat1materialmgmt_exports.h>

namespace materialmgmt
{
    class Mat1UsesMaterialDelegate;
}
namespace materialmgmt
{
    class Mat1UsesMaterialImpl;
}
namespace materialmgmt
{
    class Mat1UsesMaterial;
}
namespace materialmgmt
{
    class Mat1UsesMaterialGenImpl;
}

namespace materialmgmt_alias = ::materialmgmt;


class  MAT1MATERIALMGMT_API materialmgmt_alias::Mat1UsesMaterialDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mat1UsesMaterialDelegate instance
    static Mat1UsesMaterialDelegate&  getInstance();

    //  Method to create the Mat1UsesMaterialImpl pointer
    static Mat1UsesMaterialImpl*  createImpl( Mat1UsesMaterial&  ifObj );

    //  Method to delete the Mat1UsesMaterialImpl pointer
    static void deleteImpl( Mat1UsesMaterialImpl*  impl );


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMat1mass_in_gramsBase(const Mat1UsesMaterial &ifObj,  double &value, bool &isNull ) const;


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Mat1UsesMaterial &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// validate saveas input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  validateSaveAsInputBase(const Mat1UsesMaterial &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static Mat1UsesMaterialDelegate*  m_pInstance;

    Mat1UsesMaterialDelegate();
    virtual ~Mat1UsesMaterialDelegate();
    static void setInstance( Mat1UsesMaterialDelegate*  instance );


private:
    friend class  ::materialmgmt::Mat1UsesMaterialGenImpl;

};

#include <mat1materialmgmt/libmat1materialmgmt_undef.h>
#endif  //  MATERIALMGMT__MAT1USESMATERIALDELEGATE_HXX
