//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mat1UsesMaterialForCoating
    Filename:   Mat1UsesMaterialForCoating.hxx
    Module:     mat1materialmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef MATERIALMGMT__MAT1USESMATERIALFORCOATING__HXX
#define MATERIALMGMT__MAT1USESMATERIALFORCOATING__HXX

#include <common/tc_deprecation_macros.h>
#include <mat1materialmgmt/Mat1UsesMaterial.hxx>

#include <mat1materialmgmt/libmat1materialmgmt_exports.h>

namespace materialmgmt
{
    class Mat1UsesMaterialForCoating;
}
namespace materialmgmt
{
    class Mat1UsesMaterialForCoatingImpl;
}
namespace materialmgmt
{
    class Mat1UsesMaterialForCoatingDelegate;
}
namespace materialmgmt
{
    class Mat1UsesMaterialForCoatingDispatch;
}
namespace materialmgmt
{
    class Mat1UsesMaterialForCoatingGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MAT1MATERIALMGMT_API  materialmgmt::Mat1UsesMaterialForCoating
     : public  ::materialmgmt::Mat1UsesMaterial
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mat1UsesMaterialForCoating();

    /**
     * Destructor
     */
    virtual ~Mat1UsesMaterialForCoating();

private:
    //  Getter method for the Implementation Object
    Mat1UsesMaterialForCoatingImpl*  getMat1UsesMaterialForCoatingImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMat1UsesMaterialForCoatingImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mat1UsesMaterialForCoatingImpl*  m_mat1usesmaterialforcoatingImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mat1UsesMaterialForCoating - desc for Mat1UsesMaterialForCoating parameter
     */
    Mat1UsesMaterialForCoating( const Mat1UsesMaterialForCoating& );
    Mat1UsesMaterialForCoating& operator=( const Mat1UsesMaterialForCoating& );

    friend class  Mat1UsesMaterialForCoatingDelegate;
    friend class  Mat1UsesMaterialForCoatingDispatch;
    friend class  Mat1UsesMaterialForCoatingGenImpl;
};

#include <mat1materialmgmt/libmat1materialmgmt_undef.h>
#endif //   MATERIALMGMT__MAT1USESMATERIALFORCOATING__HXX
