//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mat1UsesSubstance
    Filename:   Mat1UsesSubstance.hxx
    Module:     mat1materialmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef MATERIALMGMT__MAT1USESSUBSTANCE__HXX
#define MATERIALMGMT__MAT1USESSUBSTANCE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <mat1materialmgmt/libmat1materialmgmt_exports.h>

namespace materialmgmt
{
    class Mat1UsesSubstance;
}
namespace materialmgmt
{
    class Mat1UsesSubstanceImpl;
}
namespace materialmgmt
{
    class Mat1UsesSubstanceDelegate;
}
namespace materialmgmt
{
    class Mat1UsesSubstanceDispatch;
}
namespace materialmgmt
{
    class Mat1UsesSubstanceGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MAT1MATERIALMGMT_API  materialmgmt::Mat1UsesSubstance
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mat1UsesSubstance();

    /**
     * Destructor
     */
    virtual ~Mat1UsesSubstance();

private:
    //  Getter method for the Implementation Object
    Mat1UsesSubstanceImpl*  getMat1UsesSubstanceImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMat1UsesSubstanceImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mat1UsesSubstanceImpl*  m_mat1usessubstanceImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mat1UsesSubstance - desc for Mat1UsesSubstance parameter
     */
    Mat1UsesSubstance( const Mat1UsesSubstance& );
    Mat1UsesSubstance& operator=( const Mat1UsesSubstance& );

    friend class  Mat1UsesSubstanceDelegate;
    friend class  Mat1UsesSubstanceDispatch;
    friend class  Mat1UsesSubstanceGenImpl;
};

#include <mat1materialmgmt/libmat1materialmgmt_undef.h>
#endif //   MATERIALMGMT__MAT1USESSUBSTANCE__HXX
