//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mat1UsesSubstanceDelegate
    Filename:   Mat1UsesSubstanceDelegate.hxx
    Module:     mat1materialmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef MATERIALMGMT__MAT1USESSUBSTANCEDELEGATE_HXX
#define MATERIALMGMT__MAT1USESSUBSTANCEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mat1materialmgmt/Mat1UsesSubstance.hxx>

#include <mat1materialmgmt/libmat1materialmgmt_exports.h>

namespace materialmgmt
{
    class Mat1UsesSubstanceDelegate;
}
namespace materialmgmt
{
    class Mat1UsesSubstanceImpl;
}
namespace materialmgmt
{
    class Mat1UsesSubstance;
}
namespace materialmgmt
{
    class Mat1UsesSubstanceGenImpl;
}

namespace materialmgmt_alias = ::materialmgmt;


class  MAT1MATERIALMGMT_API materialmgmt_alias::Mat1UsesSubstanceDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mat1UsesSubstanceDelegate instance
    static Mat1UsesSubstanceDelegate&  getInstance();

    //  Method to create the Mat1UsesSubstanceImpl pointer
    static Mat1UsesSubstanceImpl*  createImpl( Mat1UsesSubstance&  ifObj );

    //  Method to delete the Mat1UsesSubstanceImpl pointer
    static void deleteImpl( Mat1UsesSubstanceImpl*  impl );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Mat1UsesSubstance &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// validate saveas input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  validateSaveAsInputBase(const Mat1UsesSubstance &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static Mat1UsesSubstanceDelegate*  m_pInstance;

    Mat1UsesSubstanceDelegate();
    virtual ~Mat1UsesSubstanceDelegate();
    static void setInstance( Mat1UsesSubstanceDelegate*  instance );


private:
    friend class  ::materialmgmt::Mat1UsesSubstanceGenImpl;

};

#include <mat1materialmgmt/libmat1materialmgmt_undef.h>
#endif  //  MATERIALMGMT__MAT1USESSUBSTANCEDELEGATE_HXX
