//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mat1ValidDerviedUnits
    Filename:   Mat1ValidDerviedUnits.hxx
    Module:     mat1materialmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef MATERIALMGMT__MAT1VALIDDERVIEDUNITS__HXX
#define MATERIALMGMT__MAT1VALIDDERVIEDUNITS__HXX

#include <common/tc_deprecation_macros.h>
#include <lov/Fnd0ListOfValuesDynamic.hxx>

#include <mat1materialmgmt/libmat1materialmgmt_exports.h>

namespace materialmgmt
{
    class Mat1ValidDerviedUnits;
}
namespace materialmgmt
{
    class Mat1ValidDerviedUnitsImpl;
}
namespace materialmgmt
{
    class Mat1ValidDerviedUnitsDelegate;
}
namespace materialmgmt
{
    class Mat1ValidDerviedUnitsDispatch;
}
namespace materialmgmt
{
    class Mat1ValidDerviedUnitsGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MAT1MATERIALMGMT_API  materialmgmt::Mat1ValidDerviedUnits
     : public  ::Teamcenter::Fnd0ListOfValuesDynamic
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mat1ValidDerviedUnits();

    /**
     * Destructor
     */
    virtual ~Mat1ValidDerviedUnits();

private:
    //  Getter method for the Implementation Object
    Mat1ValidDerviedUnitsImpl*  getMat1ValidDerviedUnitsImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMat1ValidDerviedUnitsImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mat1ValidDerviedUnitsImpl*  m_mat1validderviedunitsImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mat1ValidDerviedUnits - desc for Mat1ValidDerviedUnits parameter
     */
    Mat1ValidDerviedUnits( const Mat1ValidDerviedUnits& );
    Mat1ValidDerviedUnits& operator=( const Mat1ValidDerviedUnits& );

    friend class  Mat1ValidDerviedUnitsDelegate;
    friend class  Mat1ValidDerviedUnitsDispatch;
    friend class  Mat1ValidDerviedUnitsGenImpl;
};

#include <mat1materialmgmt/libmat1materialmgmt_undef.h>
#endif //   MATERIALMGMT__MAT1VALIDDERVIEDUNITS__HXX
