//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mat1ValidDerviedUnitsDelegate
    Filename:   Mat1ValidDerviedUnitsDelegate.hxx
    Module:     mat1materialmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef MATERIALMGMT__MAT1VALIDDERVIEDUNITSDELEGATE_HXX
#define MATERIALMGMT__MAT1VALIDDERVIEDUNITSDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mat1materialmgmt/Mat1ValidDerviedUnits.hxx>

#include <mat1materialmgmt/libmat1materialmgmt_exports.h>

namespace materialmgmt
{
    class Mat1ValidDerviedUnitsDelegate;
}
namespace materialmgmt
{
    class Mat1ValidDerviedUnitsImpl;
}
namespace materialmgmt
{
    class Mat1ValidDerviedUnits;
}
namespace materialmgmt
{
    class Mat1ValidDerviedUnitsGenImpl;
}

namespace materialmgmt_alias = ::materialmgmt;


class  MAT1MATERIALMGMT_API materialmgmt_alias::Mat1ValidDerviedUnitsDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mat1ValidDerviedUnitsDelegate instance
    static Mat1ValidDerviedUnitsDelegate&  getInstance();

    //  Method to create the Mat1ValidDerviedUnitsImpl pointer
    static Mat1ValidDerviedUnitsImpl*  createImpl( Mat1ValidDerviedUnits&  ifObj );

    //  Method to delete the Mat1ValidDerviedUnitsImpl pointer
    static void deleteImpl( Mat1ValidDerviedUnitsImpl*  impl );


    ///
    /// Returns List Of Values based on Dynamic LOV definition and user search criteria.
    /// @version Teamcenter 10
    /// @param operationInputTag - Operation Input containing the modified values.
    /// @param propertyName - Name of the selected property.
    /// @param searchString - User entered search string.
    /// @param sortByProp - Property to use for sorting.
    /// @param sortOrder - order for sorting (0=Ascending, 1=Descending).
    /// @param nResults - Number of returned results.
    /// @param results - Returned Values for LOV.
    /// @return - Zero (0) if everything is alright otherwise the error code.
    ///
    int  fnd0askLOVValuesBase(const Mat1ValidDerviedUnits &ifObj,  const tag_t operationInputTag, const std::string *propertyName, const std::string *searchString, const char *sortByProp, const int sortOrder, int *nResults, tag_t **results ) const;


    ///
    /// Returns true if the input value is valid for the Dynamic LOV.
    /// @version Teamcenter 10
    /// @param operationInput - Operation Input containing the modified values.
    /// @param propertyName - Name of the selected property.
    /// @param value - Value to validate.
    /// @param verdict - true if value is valid.
    /// @return - Zero (0) if everything is alright otherwise the error code.
    ///
    int  fnd0isValueValidBase(const Mat1ValidDerviedUnits &ifObj,  const tag_t operationInput, const std::string *propertyName, const tag_t value, bool *verdict ) const;



protected:
    //  Pointer to the instance
    static Mat1ValidDerviedUnitsDelegate*  m_pInstance;

    Mat1ValidDerviedUnitsDelegate();
    virtual ~Mat1ValidDerviedUnitsDelegate();
    static void setInstance( Mat1ValidDerviedUnitsDelegate*  instance );


private:
    friend class  ::materialmgmt::Mat1ValidDerviedUnitsGenImpl;

};

#include <mat1materialmgmt/libmat1materialmgmt_undef.h>
#endif  //  MATERIALMGMT__MAT1VALIDDERVIEDUNITSDELEGATE_HXX
