//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mat1ValidUnitAltNames
    Filename:   Mat1ValidUnitAltNames.hxx
    Module:     mat1materialmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef MATERIALMGMT__MAT1VALIDUNITALTNAMES__HXX
#define MATERIALMGMT__MAT1VALIDUNITALTNAMES__HXX

#include <common/tc_deprecation_macros.h>
#include <lov/Fnd0ListOfValuesDynamic.hxx>

#include <mat1materialmgmt/libmat1materialmgmt_exports.h>

namespace materialmgmt
{
    class Mat1ValidUnitAltNames;
}
namespace materialmgmt
{
    class Mat1ValidUnitAltNamesImpl;
}
namespace materialmgmt
{
    class Mat1ValidUnitAltNamesDelegate;
}
namespace materialmgmt
{
    class Mat1ValidUnitAltNamesDispatch;
}
namespace materialmgmt
{
    class Mat1ValidUnitAltNamesGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MAT1MATERIALMGMT_API  materialmgmt::Mat1ValidUnitAltNames
     : public  ::Teamcenter::Fnd0ListOfValuesDynamic
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mat1ValidUnitAltNames();

    /**
     * Destructor
     */
    virtual ~Mat1ValidUnitAltNames();

private:
    //  Getter method for the Implementation Object
    Mat1ValidUnitAltNamesImpl*  getMat1ValidUnitAltNamesImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMat1ValidUnitAltNamesImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mat1ValidUnitAltNamesImpl*  m_mat1validunitaltnamesImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mat1ValidUnitAltNames - desc for Mat1ValidUnitAltNames parameter
     */
    Mat1ValidUnitAltNames( const Mat1ValidUnitAltNames& );
    Mat1ValidUnitAltNames& operator=( const Mat1ValidUnitAltNames& );

    friend class  Mat1ValidUnitAltNamesDelegate;
    friend class  Mat1ValidUnitAltNamesDispatch;
    friend class  Mat1ValidUnitAltNamesGenImpl;
};

#include <mat1materialmgmt/libmat1materialmgmt_undef.h>
#endif //   MATERIALMGMT__MAT1VALIDUNITALTNAMES__HXX
