//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mat1ValidUnitAltNamesDelegate
    Filename:   Mat1ValidUnitAltNamesDelegate.hxx
    Module:     mat1materialmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef MATERIALMGMT__MAT1VALIDUNITALTNAMESDELEGATE_HXX
#define MATERIALMGMT__MAT1VALIDUNITALTNAMESDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mat1materialmgmt/Mat1ValidUnitAltNames.hxx>

#include <mat1materialmgmt/libmat1materialmgmt_exports.h>

namespace materialmgmt
{
    class Mat1ValidUnitAltNamesDelegate;
}
namespace materialmgmt
{
    class Mat1ValidUnitAltNamesImpl;
}
namespace materialmgmt
{
    class Mat1ValidUnitAltNames;
}
namespace materialmgmt
{
    class Mat1ValidUnitAltNamesGenImpl;
}

namespace materialmgmt_alias = ::materialmgmt;


class  MAT1MATERIALMGMT_API materialmgmt_alias::Mat1ValidUnitAltNamesDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mat1ValidUnitAltNamesDelegate instance
    static Mat1ValidUnitAltNamesDelegate&  getInstance();

    //  Method to create the Mat1ValidUnitAltNamesImpl pointer
    static Mat1ValidUnitAltNamesImpl*  createImpl( Mat1ValidUnitAltNames&  ifObj );

    //  Method to delete the Mat1ValidUnitAltNamesImpl pointer
    static void deleteImpl( Mat1ValidUnitAltNamesImpl*  impl );


    ///
    /// Returns List Of Values based on Dynamic LOV definition and user search criteria.
    /// @version Teamcenter 10
    /// @param operationInputTag - Operation Input containing the modified values.
    /// @param propertyName - Name of the selected property.
    /// @param searchString - User entered search string.
    /// @param sortByProp - Property to use for sorting.
    /// @param sortOrder - order for sorting (0=Ascending, 1=Descending).
    /// @param nResults - Number of returned results.
    /// @param results - Returned Values for LOV.
    /// @return - Zero (0) if everything is alright otherwise the error code.
    ///
    int  fnd0askLOVValuesBase(const Mat1ValidUnitAltNames &ifObj,  const tag_t operationInputTag, const std::string *propertyName, const std::string *searchString, const char *sortByProp, const int sortOrder, int *nResults, tag_t **results ) const;


    ///
    /// Returns true if the input value is valid for the Dynamic LOV.
    /// @version Teamcenter 10
    /// @param operationInput - Operation Input containing the modified values.
    /// @param propertyName - Name of the selected property.
    /// @param value - Value to validate.
    /// @param verdict - true if value is valid.
    /// @return - Zero (0) if everything is alright otherwise the error code.
    ///
    int  fnd0isValueValidBase(const Mat1ValidUnitAltNames &ifObj,  const tag_t operationInput, const std::string *propertyName, const tag_t value, bool *verdict ) const;



protected:
    //  Pointer to the instance
    static Mat1ValidUnitAltNamesDelegate*  m_pInstance;

    Mat1ValidUnitAltNamesDelegate();
    virtual ~Mat1ValidUnitAltNamesDelegate();
    static void setInstance( Mat1ValidUnitAltNamesDelegate*  instance );


private:
    friend class  ::materialmgmt::Mat1ValidUnitAltNamesGenImpl;

};

#include <mat1materialmgmt/libmat1materialmgmt_undef.h>
#endif  //  MATERIALMGMT__MAT1VALIDUNITALTNAMESDELEGATE_HXX
