//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  materialmgmtdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libmaterialmgmtdispatch

#if !defined(LIBMATERIALMGMTDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBMATERIALMGMTDISPATCH is not defined
#endif

/* Handwritten code should use MATERIALMGMTDISPATCH_API, not MATERIALMGMTDISPATCHEXPORT */

#define MATERIALMGMTDISPATCH_API MATERIALMGMTDISPATCHEXPORT

#if IPLIB==libmaterialmgmtdispatch || defined(LIBMATERIALMGMTDISPATCH)
#   if defined(__lint)
#       define MATERIALMGMTDISPATCHEXPORT       __export(materialmgmtdispatch)
#       define MATERIALMGMTDISPATCHGLOBAL       extern __global(materialmgmtdispatch)
#       define MATERIALMGMTDISPATCHPRIVATE      extern __private(materialmgmtdispatch)
#   elif defined(_WIN32)
#       define MATERIALMGMTDISPATCHEXPORT       __declspec(dllexport)
#       define MATERIALMGMTDISPATCHGLOBAL       extern __declspec(dllexport)
#       define MATERIALMGMTDISPATCHPRIVATE      extern
#   else
#       define MATERIALMGMTDISPATCHEXPORT
#       define MATERIALMGMTDISPATCHGLOBAL       extern
#       define MATERIALMGMTDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define MATERIALMGMTDISPATCHEXPORT       __export(materialmgmtdispatch)
#       define MATERIALMGMTDISPATCHGLOBAL       extern __global(materialmgmtdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define MATERIALMGMTDISPATCHEXPORT      __declspec(dllimport)
#       define MATERIALMGMTDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define MATERIALMGMTDISPATCHEXPORT
#       define MATERIALMGMTDISPATCHGLOBAL       extern
#   endif
#endif
