//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0ApplicationModel
    Filename:   Mdl0ApplicationModel.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0APPLICATIONMODEL__HXX
#define TEAMCENTER__APPMODEL__MDL0APPLICATIONMODEL__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ApplicationModel;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ApplicationModelImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ApplicationModelDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ApplicationModelDispatch;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ApplicationModelGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDL0MODEL_API  Teamcenter::AppModel::Mdl0ApplicationModel
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0allows_add_content( bool &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0allows_remove_content( bool &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0config_prod_namespace( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0config_product_name( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @deprecated Teamcenter::AppModel::Mdl0ApplicationModel::getMdl0HistorySyncStatus deprecated in Teamcenter 11.2.3
    /// @return - Status. 0 if successful
    ///
    TC_DEPRECATED_WITH_DEPRECATION_INFO("Teamcenter 11.2.3","Teamcenter::AppModel::Mdl0ApplicationModel::getMdl0HistorySyncStatus","This property is deprecated and will be removed from Teamcenter 13.0. From Teamcenter 11.2.3 history versions are always in sync. For the time being the in-sync value is always given.")
    int  getMdl0HistorySyncStatus( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.6
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0RunningProcessName( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0var_conf_prod_name( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0var_conf_prod_namespace( std::string &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdl0ApplicationModel();

    /**
     * Destructor
     */
    virtual ~Mdl0ApplicationModel();

private:
    //  Getter method for the Implementation Object
    Mdl0ApplicationModelImpl*  getMdl0ApplicationModelImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdl0ApplicationModelImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdl0ApplicationModelImpl*  m_mdl0applicationmodelImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdl0ApplicationModel - desc for Mdl0ApplicationModel parameter
     */
    Mdl0ApplicationModel( const Mdl0ApplicationModel& );
    Mdl0ApplicationModel& operator=( const Mdl0ApplicationModel& );

    friend class  Mdl0ApplicationModelDelegate;
    friend class  Mdl0ApplicationModelDispatch;
    friend class  Mdl0ApplicationModelGenImpl;
};

#include <mdl0model/libmdl0model_undef.h>
#endif //   TEAMCENTER__APPMODEL__MDL0APPLICATIONMODEL__HXX
