//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0ApplicationModelDelegate
    Filename:   Mdl0ApplicationModelDelegate.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0APPLICATIONMODELDELEGATE_HXX
#define TEAMCENTER__APPMODEL__MDL0APPLICATIONMODELDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0ApplicationModel.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ApplicationModelDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ApplicationModelImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ApplicationModel;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ApplicationModelGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MDL0MODEL_API Teamcenter_alias::AppModel::Mdl0ApplicationModelDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mdl0ApplicationModelDelegate instance
    static Mdl0ApplicationModelDelegate&  getInstance();

    //  Method to create the Mdl0ApplicationModelImpl pointer
    static Mdl0ApplicationModelImpl*  createImpl( Mdl0ApplicationModel&  ifObj );

    //  Method to delete the Mdl0ApplicationModelImpl pointer
    static void deleteImpl( Mdl0ApplicationModelImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0allows_add_contentBase(const Mdl0ApplicationModel &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0allows_remove_contentBase(const Mdl0ApplicationModel &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0config_prod_namespaceBase(const Mdl0ApplicationModel &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0config_product_nameBase(const Mdl0ApplicationModel &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @deprecated Teamcenter::AppModel::Mdl0ApplicationModel::getMdl0HistorySyncStatus deprecated in Teamcenter 11.2.3
    /// @return - Status. 0 if successful
    ///
    TC_DEPRECATED_WITH_DEPRECATION_INFO("Teamcenter 11.2.3","Teamcenter::AppModel::Mdl0ApplicationModel::getMdl0HistorySyncStatus","This property is deprecated and will be removed from Teamcenter 13.0. From Teamcenter 11.2.3 history versions are always in sync. For the time being the in-sync value is always given.")
    int  getMdl0HistorySyncStatusBase(const Mdl0ApplicationModel &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.6
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0RunningProcessNameBase(const Mdl0ApplicationModel &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0var_conf_prod_nameBase(const Mdl0ApplicationModel &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0var_conf_prod_namespaceBase(const Mdl0ApplicationModel &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Mdl0ApplicationModel &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// finalize operation input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  finalizeSaveAsInputBase(const Mdl0ApplicationModel &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.3
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0FinalizeSaveAsInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static Mdl0ApplicationModelDelegate*  m_pInstance;

    Mdl0ApplicationModelDelegate();
    virtual ~Mdl0ApplicationModelDelegate();
    static void setInstance( Mdl0ApplicationModelDelegate*  instance );


private:
    friend class  ::Teamcenter::AppModel::Mdl0ApplicationModelGenImpl;

};

#include <mdl0model/libmdl0model_undef.h>
#endif  //  TEAMCENTER__APPMODEL__MDL0APPLICATIONMODELDELEGATE_HXX
