//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0ApprSrchCrtOptionSet
    Filename:   Mdl0ApprSrchCrtOptionSet.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0APPRSRCHCRTOPTIONSET__HXX
#define TEAMCENTER__APPMODEL__MDL0APPRSRCHCRTOPTIONSET__HXX

#include <vector>
#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <rdv/ApprSearchCriteria.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ApprSrchCrtOptionSet;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ApprSrchCrtOptionSetImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ApprSrchCrtOptionSetDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ApprSrchCrtOptionSetDispatch;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ApprSrchCrtOptionSetGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDL0MODEL_API  Teamcenter::AppModel::Mdl0ApprSrchCrtOptionSet
     : public  ::Teamcenter::ApprSearchCriteria
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0optionNames( std::vector< std::string > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0optionSet( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0optionValues( std::vector< std::string > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 10.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0optionNames( const std::vector< std::string > &values, const std::vector< int > *isNull=0 );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0optionSet( const tag_t &value, bool isNull=false );

    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 10.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0optionValues( const std::vector< std::string > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdl0ApprSrchCrtOptionSet();

    /**
     * Destructor
     */
    virtual ~Mdl0ApprSrchCrtOptionSet();

private:
    //  Getter method for the Implementation Object
    Mdl0ApprSrchCrtOptionSetImpl*  getMdl0ApprSrchCrtOptionSetImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdl0ApprSrchCrtOptionSetImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdl0ApprSrchCrtOptionSetImpl*  m_mdl0apprsrchcrtoptionsetImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdl0ApprSrchCrtOptionSet - desc for Mdl0ApprSrchCrtOptionSet parameter
     */
    Mdl0ApprSrchCrtOptionSet( const Mdl0ApprSrchCrtOptionSet& );
    Mdl0ApprSrchCrtOptionSet& operator=( const Mdl0ApprSrchCrtOptionSet& );

    friend class  Mdl0ApprSrchCrtOptionSetDelegate;
    friend class  Mdl0ApprSrchCrtOptionSetDispatch;
    friend class  Mdl0ApprSrchCrtOptionSetGenImpl;
};

#include <mdl0model/libmdl0model_undef.h>
#endif //   TEAMCENTER__APPMODEL__MDL0APPRSRCHCRTOPTIONSET__HXX
