//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0ApprSrchCrtOptionSetDelegate
    Filename:   Mdl0ApprSrchCrtOptionSetDelegate.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0APPRSRCHCRTOPTIONSETDELEGATE_HXX
#define TEAMCENTER__APPMODEL__MDL0APPRSRCHCRTOPTIONSETDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0ApprSrchCrtOptionSet.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ApprSrchCrtOptionSetDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ApprSrchCrtOptionSetImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ApprSrchCrtOptionSet;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ApprSrchCrtOptionSetGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MDL0MODEL_API Teamcenter_alias::AppModel::Mdl0ApprSrchCrtOptionSetDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mdl0ApprSrchCrtOptionSetDelegate instance
    static Mdl0ApprSrchCrtOptionSetDelegate&  getInstance();

    //  Method to create the Mdl0ApprSrchCrtOptionSetImpl pointer
    static Mdl0ApprSrchCrtOptionSetImpl*  createImpl( Mdl0ApprSrchCrtOptionSet&  ifObj );

    //  Method to delete the Mdl0ApprSrchCrtOptionSetImpl pointer
    static void deleteImpl( Mdl0ApprSrchCrtOptionSetImpl*  impl );


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0optionNamesBase(const Mdl0ApprSrchCrtOptionSet &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0optionSetBase(const Mdl0ApprSrchCrtOptionSet &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0optionValuesBase(const Mdl0ApprSrchCrtOptionSet &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 10.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0optionNamesBase(Mdl0ApprSrchCrtOptionSet &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0optionSetBase(Mdl0ApprSrchCrtOptionSet &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 10.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0optionValuesBase(Mdl0ApprSrchCrtOptionSet &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );



protected:
    //  Pointer to the instance
    static Mdl0ApprSrchCrtOptionSetDelegate*  m_pInstance;

    Mdl0ApprSrchCrtOptionSetDelegate();
    virtual ~Mdl0ApprSrchCrtOptionSetDelegate();
    static void setInstance( Mdl0ApprSrchCrtOptionSetDelegate*  instance );


private:
    friend class  ::Teamcenter::AppModel::Mdl0ApprSrchCrtOptionSetGenImpl;

};

#include <mdl0model/libmdl0model_undef.h>
#endif  //  TEAMCENTER__APPMODEL__MDL0APPRSRCHCRTOPTIONSETDELEGATE_HXX
