//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0ApprSrchCrtType
    Filename:   Mdl0ApprSrchCrtType.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0APPRSRCHCRTTYPE__HXX
#define TEAMCENTER__APPMODEL__MDL0APPRSRCHCRTTYPE__HXX

#include <common/tc_deprecation_macros.h>
#include <rdv/ApprSearchCriteria.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ApprSrchCrtType;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ApprSrchCrtTypeImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ApprSrchCrtTypeDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ApprSrchCrtTypeDispatch;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ApprSrchCrtTypeGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDL0MODEL_API  Teamcenter::AppModel::Mdl0ApprSrchCrtType
     : public  ::Teamcenter::ApprSearchCriteria
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdl0ApprSrchCrtType();

    /**
     * Destructor
     */
    virtual ~Mdl0ApprSrchCrtType();

private:
    //  Getter method for the Implementation Object
    Mdl0ApprSrchCrtTypeImpl*  getMdl0ApprSrchCrtTypeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdl0ApprSrchCrtTypeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdl0ApprSrchCrtTypeImpl*  m_mdl0apprsrchcrttypeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdl0ApprSrchCrtType - desc for Mdl0ApprSrchCrtType parameter
     */
    Mdl0ApprSrchCrtType( const Mdl0ApprSrchCrtType& );
    Mdl0ApprSrchCrtType& operator=( const Mdl0ApprSrchCrtType& );

    friend class  Mdl0ApprSrchCrtTypeDelegate;
    friend class  Mdl0ApprSrchCrtTypeDispatch;
    friend class  Mdl0ApprSrchCrtTypeGenImpl;
};

#include <mdl0model/libmdl0model_undef.h>
#endif //   TEAMCENTER__APPMODEL__MDL0APPRSRCHCRTTYPE__HXX
