//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0ApprSrchGeomConstraint
    Filename:   Mdl0ApprSrchGeomConstraint.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0APPRSRCHGEOMCONSTRAINT__HXX
#define TEAMCENTER__APPMODEL__MDL0APPRSRCHGEOMCONSTRAINT__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <rdv/ApprSearchCriteria.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ApprSrchGeomConstraint;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ApprSrchGeomConstraintImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ApprSrchGeomConstraintDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ApprSrchGeomConstraintDispatch;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ApprSrchGeomConstraintGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDL0MODEL_API  Teamcenter::AppModel::Mdl0ApprSrchGeomConstraint
     : public  ::Teamcenter::ApprSearchCriteria
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0ProcessCtrlFlag( int &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0SourceCriteria( tag_t &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdl0ApprSrchGeomConstraint();

    /**
     * Destructor
     */
    virtual ~Mdl0ApprSrchGeomConstraint();

private:
    //  Getter method for the Implementation Object
    Mdl0ApprSrchGeomConstraintImpl*  getMdl0ApprSrchGeomConstraintImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdl0ApprSrchGeomConstraintImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdl0ApprSrchGeomConstraintImpl*  m_mdl0apprsrchgeomconstraintImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdl0ApprSrchGeomConstraint - desc for Mdl0ApprSrchGeomConstraint parameter
     */
    Mdl0ApprSrchGeomConstraint( const Mdl0ApprSrchGeomConstraint& );
    Mdl0ApprSrchGeomConstraint& operator=( const Mdl0ApprSrchGeomConstraint& );

    friend class  Mdl0ApprSrchGeomConstraintDelegate;
    friend class  Mdl0ApprSrchGeomConstraintDispatch;
    friend class  Mdl0ApprSrchGeomConstraintGenImpl;
};

#include <mdl0model/libmdl0model_undef.h>
#endif //   TEAMCENTER__APPMODEL__MDL0APPRSRCHGEOMCONSTRAINT__HXX
