//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0ApprSrchSlctContent
    Filename:   Mdl0ApprSrchSlctContent.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0APPRSRCHSLCTCONTENT__HXX
#define TEAMCENTER__APPMODEL__MDL0APPRSRCHSLCTCONTENT__HXX

#include <common/tc_deprecation_macros.h>
#include <rdv/ApprSearchCriteriaSlctState.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ApprSrchSlctContent;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ApprSrchSlctContentImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ApprSrchSlctContentDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ApprSrchSlctContentDispatch;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ApprSrchSlctContentGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDL0MODEL_API  Teamcenter::AppModel::Mdl0ApprSrchSlctContent
     : public  ::Teamcenter::ApprSearchCriteriaSlctState
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdl0ApprSrchSlctContent();

    /**
     * Destructor
     */
    virtual ~Mdl0ApprSrchSlctContent();

private:
    //  Getter method for the Implementation Object
    Mdl0ApprSrchSlctContentImpl*  getMdl0ApprSrchSlctContentImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdl0ApprSrchSlctContentImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdl0ApprSrchSlctContentImpl*  m_mdl0apprsrchslctcontentImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdl0ApprSrchSlctContent - desc for Mdl0ApprSrchSlctContent parameter
     */
    Mdl0ApprSrchSlctContent( const Mdl0ApprSrchSlctContent& );
    Mdl0ApprSrchSlctContent& operator=( const Mdl0ApprSrchSlctContent& );

    friend class  Mdl0ApprSrchSlctContentDelegate;
    friend class  Mdl0ApprSrchSlctContentDispatch;
    friend class  Mdl0ApprSrchSlctContentGenImpl;
};

#include <mdl0model/libmdl0model_undef.h>
#endif //   TEAMCENTER__APPMODEL__MDL0APPRSRCHSLCTCONTENT__HXX
