//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0AttributeGroup
    Filename:   Mdl0AttributeGroup.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0ATTRIBUTEGROUP__HXX
#define TEAMCENTER__APPMODEL__MDL0ATTRIBUTEGROUP__HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0ModelElement.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0AttributeGroup;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0AttributeGroupImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0AttributeGroupDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0AttributeGroupDispatch;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0AttributeGroupGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDL0MODEL_API  Teamcenter::AppModel::Mdl0AttributeGroup
     : public  ::Teamcenter::AppModel::Mdl0ModelElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdl0AttributeGroup();

    /**
     * Destructor
     */
    virtual ~Mdl0AttributeGroup();

private:
    //  Getter method for the Implementation Object
    Mdl0AttributeGroupImpl*  getMdl0AttributeGroupImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdl0AttributeGroupImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdl0AttributeGroupImpl*  m_mdl0attributegroupImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdl0AttributeGroup - desc for Mdl0AttributeGroup parameter
     */
    Mdl0AttributeGroup( const Mdl0AttributeGroup& );
    Mdl0AttributeGroup& operator=( const Mdl0AttributeGroup& );

    friend class  Mdl0AttributeGroupDelegate;
    friend class  Mdl0AttributeGroupDispatch;
    friend class  Mdl0AttributeGroupGenImpl;
};

#include <mdl0model/libmdl0model_undef.h>
#endif //   TEAMCENTER__APPMODEL__MDL0ATTRIBUTEGROUP__HXX
