//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0AttributeGroupDelegate
    Filename:   Mdl0AttributeGroupDelegate.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0ATTRIBUTEGROUPDELEGATE_HXX
#define TEAMCENTER__APPMODEL__MDL0ATTRIBUTEGROUPDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0AttributeGroup.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0AttributeGroupDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0AttributeGroupImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0AttributeGroup;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0AttributeGroupGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MDL0MODEL_API Teamcenter_alias::AppModel::Mdl0AttributeGroupDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mdl0AttributeGroupDelegate instance
    static Mdl0AttributeGroupDelegate&  getInstance();

    //  Method to create the Mdl0AttributeGroupImpl pointer
    static Mdl0AttributeGroupImpl*  createImpl( Mdl0AttributeGroup&  ifObj );

    //  Method to delete the Mdl0AttributeGroupImpl pointer
    static void deleteImpl( Mdl0AttributeGroupImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.3
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0PerformDeepCopyBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.3
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0SetPropertiesFromSaveAsInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// perform deep copy
    /// @version Teamcenter 9
    /// @param pOperationInput - desc
    /// @param vecDeepCopyData - deep copy data
    /// @return - returns an int
    ///
    int  performDeepCopyBase(const Mdl0AttributeGroup &ifObj,  ::Teamcenter::OperationInput *pOperationInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// setproperties from saveas input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @return - returns an int
    ///
    int  setPropertiesFromSaveAsInputBase(const Mdl0AttributeGroup &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput );



protected:
    //  Pointer to the instance
    static Mdl0AttributeGroupDelegate*  m_pInstance;

    Mdl0AttributeGroupDelegate();
    virtual ~Mdl0AttributeGroupDelegate();
    static void setInstance( Mdl0AttributeGroupDelegate*  instance );


private:
    friend class  ::Teamcenter::AppModel::Mdl0AttributeGroupGenImpl;

};

#include <mdl0model/libmdl0model_undef.h>
#endif  //  TEAMCENTER__APPMODEL__MDL0ATTRIBUTEGROUPDELEGATE_HXX
