//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0Baseline
    Filename:   Mdl0Baseline.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0BASELINE__HXX
#define TEAMCENTER__APPMODEL__MDL0BASELINE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0Baseline;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0BaselineImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0BaselineDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0BaselineDispatch;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0BaselineGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDL0MODEL_API  Teamcenter::AppModel::Mdl0Baseline
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdl0Baseline();

    /**
     * Destructor
     */
    virtual ~Mdl0Baseline();

private:
    //  Getter method for the Implementation Object
    Mdl0BaselineImpl*  getMdl0BaselineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdl0BaselineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdl0BaselineImpl*  m_mdl0baselineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdl0Baseline - desc for Mdl0Baseline parameter
     */
    Mdl0Baseline( const Mdl0Baseline& );
    Mdl0Baseline& operator=( const Mdl0Baseline& );

    friend class  Mdl0BaselineDelegate;
    friend class  Mdl0BaselineDispatch;
    friend class  Mdl0BaselineGenImpl;
};

#include <mdl0model/libmdl0model_undef.h>
#endif //   TEAMCENTER__APPMODEL__MDL0BASELINE__HXX
