//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0BaselineDefinition
    Filename:   Mdl0BaselineDefinition.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0BASELINEDEFINITION__HXX
#define TEAMCENTER__APPMODEL__MDL0BASELINEDEFINITION__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <cfm/Fnd0RecipeContainer.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0BaselineDefinition;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0BaselineDefinitionImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0BaselineDefinitionDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0BaselineDefinitionDispatch;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0BaselineDefinitionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDL0MODEL_API  Teamcenter::AppModel::Mdl0BaselineDefinition
     : public  ::Teamcenter::Fnd0RecipeContainer
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0ConfiguredModel( tag_t &value, bool &isNull ) const;

    ///
    /// Removes the snapshot date from a baseline definition, returning it to configuration by latest history.
    /// @version Teamcenter 11.1
    /// @return - ifail return code.
    ///
    int  mdl0DeleteSnapshotDate(  );

    ///
    /// The Baseline Definition is adopted by the given owning Baseline Revision.
    /// @version Teamcenter 11.1
    /// @param owner - Owning Baseline Revision which will adopt the Baseline Definition.
    /// @return - ifail return code.
    ///
    int  mdl0SetOwningBaselineRevision( tag_t owner );

    ///
    /// Sets the baseline definition to configure history at the specified date.
    /// @version Teamcenter 11.1
    /// @param date - Date for snapshot.
    /// @return - ifail return code.
    ///
    int  mdl0SetSnapshotDate( date_t date );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdl0BaselineDefinition();

    /**
     * Destructor
     */
    virtual ~Mdl0BaselineDefinition();

private:
    //  Getter method for the Implementation Object
    Mdl0BaselineDefinitionImpl*  getMdl0BaselineDefinitionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdl0BaselineDefinitionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdl0BaselineDefinitionImpl*  m_mdl0baselinedefinitionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdl0BaselineDefinition - desc for Mdl0BaselineDefinition parameter
     */
    Mdl0BaselineDefinition( const Mdl0BaselineDefinition& );
    Mdl0BaselineDefinition& operator=( const Mdl0BaselineDefinition& );

    friend class  Mdl0BaselineDefinitionDelegate;
    friend class  Mdl0BaselineDefinitionDispatch;
    friend class  Mdl0BaselineDefinitionGenImpl;
};

#include <mdl0model/libmdl0model_undef.h>
#endif //   TEAMCENTER__APPMODEL__MDL0BASELINEDEFINITION__HXX
