//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0BaselineDefinitionDelegate
    Filename:   Mdl0BaselineDefinitionDelegate.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0BASELINEDEFINITIONDELEGATE_HXX
#define TEAMCENTER__APPMODEL__MDL0BASELINEDEFINITIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0BaselineDefinition.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0BaselineDefinitionDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0BaselineDefinitionImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0BaselineDefinition;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0BaselineDefinitionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MDL0MODEL_API Teamcenter_alias::AppModel::Mdl0BaselineDefinitionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mdl0BaselineDefinitionDelegate instance
    static Mdl0BaselineDefinitionDelegate&  getInstance();

    //  Method to create the Mdl0BaselineDefinitionImpl pointer
    static Mdl0BaselineDefinitionImpl*  createImpl( Mdl0BaselineDefinition&  ifObj );

    //  Method to delete the Mdl0BaselineDefinitionImpl pointer
    static void deleteImpl( Mdl0BaselineDefinitionImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0ConfiguredModelBase(const Mdl0BaselineDefinition &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Removes the snapshot date from a baseline definition, returning it to configuration by latest history.
    /// @version Teamcenter 11.1
    /// @return - ifail return code.
    ///
    int  mdl0DeleteSnapshotDateBase(const Mdl0BaselineDefinition &ifObj  );


    ///
    /// The Baseline Definition is adopted by the given owning Baseline Revision.
    /// @version Teamcenter 11.1
    /// @param owner - Owning Baseline Revision which will adopt the Baseline Definition.
    /// @return - ifail return code.
    ///
    int  mdl0SetOwningBaselineRevisionBase(const Mdl0BaselineDefinition &ifObj,  tag_t owner );


    ///
    /// Sets the baseline definition to configure history at the specified date.
    /// @version Teamcenter 11.1
    /// @param date - Date for snapshot.
    /// @return - ifail return code.
    ///
    int  mdl0SetSnapshotDateBase(const Mdl0BaselineDefinition &ifObj,  date_t date );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Mdl0BaselineDefinition &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.3
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0SaveAsPostBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// Generic saveAsPost operation.
    /// @version Teamcenter 8.1
    /// @param pSavAsInput - Input argument as SaveAsInput object.
    /// @param vecDeepCopyData - vector deepcopy data
    /// @return - Return integer value.
    ///
    int  saveAsPostBase(const Mdl0BaselineDefinition &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static Mdl0BaselineDefinitionDelegate*  m_pInstance;

    Mdl0BaselineDefinitionDelegate();
    virtual ~Mdl0BaselineDefinitionDelegate();
    static void setInstance( Mdl0BaselineDefinitionDelegate*  instance );


private:
    friend class  ::Teamcenter::AppModel::Mdl0BaselineDefinitionGenImpl;

};

#include <mdl0model/libmdl0model_undef.h>
#endif  //  TEAMCENTER__APPMODEL__MDL0BASELINEDEFINITIONDELEGATE_HXX
