//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0BaselineRevision
    Filename:   Mdl0BaselineRevision.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0BASELINEREVISION__HXX
#define TEAMCENTER__APPMODEL__MDL0BASELINEREVISION__HXX

#include <unidefs.h>
#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0BaselineRevision;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0BaselineRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0BaselineRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0BaselineRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0BaselineRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDL0MODEL_API  Teamcenter::AppModel::Mdl0BaselineRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Date Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0SnapshotDate( date_t &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.5
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0Closure( const std::string &value, bool isNull=false );

    ///
    /// Removes the snapshot date from the baseline, returning it to configuration by latest history.
    /// @version Teamcenter 11.1
    /// @return - ifail error code.
    ///
    int  mdl0DeleteSnapshotDate(  );

    ///
    /// Sets the baseline to configure history at the specified date.
    /// @version Teamcenter 11.1
    /// @param date - Snapshot date.
    /// @return - ifail error code.
    ///
    int  mdl0SetSnapshotDate( date_t date );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdl0BaselineRevision();

    /**
     * Destructor
     */
    virtual ~Mdl0BaselineRevision();

private:
    //  Getter method for the Implementation Object
    Mdl0BaselineRevisionImpl*  getMdl0BaselineRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdl0BaselineRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdl0BaselineRevisionImpl*  m_mdl0baselinerevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdl0BaselineRevision - desc for Mdl0BaselineRevision parameter
     */
    Mdl0BaselineRevision( const Mdl0BaselineRevision& );
    Mdl0BaselineRevision& operator=( const Mdl0BaselineRevision& );

    friend class  Mdl0BaselineRevisionDelegate;
    friend class  Mdl0BaselineRevisionDispatch;
    friend class  Mdl0BaselineRevisionGenImpl;
};

#include <mdl0model/libmdl0model_undef.h>
#endif //   TEAMCENTER__APPMODEL__MDL0BASELINEREVISION__HXX
