//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0CompositeSearchDef
    Filename:   Mdl0CompositeSearchDef.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0COMPOSITESEARCHDEF__HXX
#define TEAMCENTER__APPMODEL__MDL0COMPOSITESEARCHDEF__HXX

#include <string>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0SearchDef.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0CompositeSearchDef;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0CompositeSearchDefImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0CompositeSearchDefDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0CompositeSearchDefDispatch;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0CompositeSearchDefGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDL0MODEL_API  Teamcenter::AppModel::Mdl0CompositeSearchDef
     : public  ::Teamcenter::AppModel::Mdl0SearchDef
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0CompositeSearchType( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0SearchDefinitions( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdl0CompositeSearchDef();

    /**
     * Destructor
     */
    virtual ~Mdl0CompositeSearchDef();

private:
    //  Getter method for the Implementation Object
    Mdl0CompositeSearchDefImpl*  getMdl0CompositeSearchDefImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdl0CompositeSearchDefImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdl0CompositeSearchDefImpl*  m_mdl0compositesearchdefImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdl0CompositeSearchDef - desc for Mdl0CompositeSearchDef parameter
     */
    Mdl0CompositeSearchDef( const Mdl0CompositeSearchDef& );
    Mdl0CompositeSearchDef& operator=( const Mdl0CompositeSearchDef& );

    friend class  Mdl0CompositeSearchDefDelegate;
    friend class  Mdl0CompositeSearchDefDispatch;
    friend class  Mdl0CompositeSearchDefGenImpl;
};

#include <mdl0model/libmdl0model_undef.h>
#endif //   TEAMCENTER__APPMODEL__MDL0COMPOSITESEARCHDEF__HXX
