//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0CompositeSearchDefDelegate
    Filename:   Mdl0CompositeSearchDefDelegate.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0COMPOSITESEARCHDEFDELEGATE_HXX
#define TEAMCENTER__APPMODEL__MDL0COMPOSITESEARCHDEFDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0CompositeSearchDef.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0CompositeSearchDefDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0CompositeSearchDefImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0CompositeSearchDef;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0CompositeSearchDefGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MDL0MODEL_API Teamcenter_alias::AppModel::Mdl0CompositeSearchDefDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mdl0CompositeSearchDefDelegate instance
    static Mdl0CompositeSearchDefDelegate&  getInstance();

    //  Method to create the Mdl0CompositeSearchDefImpl pointer
    static Mdl0CompositeSearchDefImpl*  createImpl( Mdl0CompositeSearchDef&  ifObj );

    //  Method to delete the Mdl0CompositeSearchDefImpl pointer
    static void deleteImpl( Mdl0CompositeSearchDefImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0CompositeSearchTypeBase(const Mdl0CompositeSearchDef &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0SearchDefinitionsBase(const Mdl0CompositeSearchDef &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Generates permanent ID/recipe. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param recipe - Permanent ID/recipe
    /// @return - Failure code.
    ///
    int  fnd0GenerateRecipeBase(const Mdl0CompositeSearchDef &ifObj,  std::string *recipe );



protected:
    //  Pointer to the instance
    static Mdl0CompositeSearchDefDelegate*  m_pInstance;

    Mdl0CompositeSearchDefDelegate();
    virtual ~Mdl0CompositeSearchDefDelegate();
    static void setInstance( Mdl0CompositeSearchDefDelegate*  instance );


private:
    friend class  ::Teamcenter::AppModel::Mdl0CompositeSearchDefGenImpl;

};

#include <mdl0model/libmdl0model_undef.h>
#endif  //  TEAMCENTER__APPMODEL__MDL0COMPOSITESEARCHDEFDELEGATE_HXX
