//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0ConditionalArtifact
    Filename:   Mdl0ConditionalArtifact.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0CONDITIONALARTIFACT__HXX
#define TEAMCENTER__APPMODEL__MDL0CONDITIONALARTIFACT__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0ModelArtifact.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ConditionalArtifact;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ConditionalArtifactImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ConditionalArtifactDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ConditionalArtifactDispatch;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ConditionalArtifactGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDL0MODEL_API  Teamcenter::AppModel::Mdl0ConditionalArtifact
     : public  ::Teamcenter::AppModel::Mdl0ModelArtifact
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0allowed_eff_formula( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0allowed_var_formula( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0effectivity_formula( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0IsConfigured( bool &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0variant_formula( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0effectivity_formula( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0variant_formula( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdl0ConditionalArtifact();

    /**
     * Destructor
     */
    virtual ~Mdl0ConditionalArtifact();

private:
    //  Getter method for the Implementation Object
    Mdl0ConditionalArtifactImpl*  getMdl0ConditionalArtifactImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdl0ConditionalArtifactImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdl0ConditionalArtifactImpl*  m_mdl0conditionalartifactImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdl0ConditionalArtifact - desc for Mdl0ConditionalArtifact parameter
     */
    Mdl0ConditionalArtifact( const Mdl0ConditionalArtifact& );
    Mdl0ConditionalArtifact& operator=( const Mdl0ConditionalArtifact& );

    friend class  Mdl0ConditionalArtifactDelegate;
    friend class  Mdl0ConditionalArtifactDispatch;
    friend class  Mdl0ConditionalArtifactGenImpl;
};

#include <mdl0model/libmdl0model_undef.h>
#endif //   TEAMCENTER__APPMODEL__MDL0CONDITIONALARTIFACT__HXX
