//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0ConditionalArtifactDelegate
    Filename:   Mdl0ConditionalArtifactDelegate.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0CONDITIONALARTIFACTDELEGATE_HXX
#define TEAMCENTER__APPMODEL__MDL0CONDITIONALARTIFACTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0ConditionalArtifact.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ConditionalArtifactDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ConditionalArtifactImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ConditionalArtifact;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ConditionalArtifactGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MDL0MODEL_API Teamcenter_alias::AppModel::Mdl0ConditionalArtifactDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mdl0ConditionalArtifactDelegate instance
    static Mdl0ConditionalArtifactDelegate&  getInstance();

    //  Method to create the Mdl0ConditionalArtifactImpl pointer
    static Mdl0ConditionalArtifactImpl*  createImpl( Mdl0ConditionalArtifact&  ifObj );

    //  Method to delete the Mdl0ConditionalArtifactImpl pointer
    static void deleteImpl( Mdl0ConditionalArtifactImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0allowed_eff_formulaBase(const Mdl0ConditionalArtifact &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0allowed_var_formulaBase(const Mdl0ConditionalArtifact &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0effectivity_formulaBase(const Mdl0ConditionalArtifact &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0IsConfiguredBase(const Mdl0ConditionalArtifact &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0variant_formulaBase(const Mdl0ConditionalArtifact &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0effectivity_formulaBase(Mdl0ConditionalArtifact &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0variant_formulaBase(Mdl0ConditionalArtifact &ifObj,  const std::string &value, bool isNull );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Mdl0ConditionalArtifact &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0CreatePostBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.3
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0SetPropertiesFromSaveAsInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// setproperties from saveas input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @return - returns an int
    ///
    int  setPropertiesFromSaveAsInputBase(const Mdl0ConditionalArtifact &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput );



protected:
    //  Pointer to the instance
    static Mdl0ConditionalArtifactDelegate*  m_pInstance;

    Mdl0ConditionalArtifactDelegate();
    virtual ~Mdl0ConditionalArtifactDelegate();
    static void setInstance( Mdl0ConditionalArtifactDelegate*  instance );


private:
    friend class  ::Teamcenter::AppModel::Mdl0ConditionalArtifactGenImpl;

};

#include <mdl0model/libmdl0model_undef.h>
#endif  //  TEAMCENTER__APPMODEL__MDL0CONDITIONALARTIFACTDELEGATE_HXX
