//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0ConditionalElementDelegate
    Filename:   Mdl0ConditionalElementDelegate.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0CONDITIONALELEMENTDELEGATE_HXX
#define TEAMCENTER__APPMODEL__MDL0CONDITIONALELEMENTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0ConditionalElement.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ConditionalElementDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ConditionalElementImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ConditionalElement;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ConditionalElementGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MDL0MODEL_API Teamcenter_alias::AppModel::Mdl0ConditionalElementDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mdl0ConditionalElementDelegate instance
    static Mdl0ConditionalElementDelegate&  getInstance();

    //  Method to create the Mdl0ConditionalElementImpl pointer
    static Mdl0ConditionalElementImpl*  createImpl( Mdl0ConditionalElement&  ifObj );

    //  Method to delete the Mdl0ConditionalElementImpl pointer
    static void deleteImpl( Mdl0ConditionalElementImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0allowed_eff_formulaBase(const Mdl0ConditionalElement &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0allowed_var_formulaBase(const Mdl0ConditionalElement &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0effectivity_formulaBase(const Mdl0ConditionalElement &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0is_revisableBase(const Mdl0ConditionalElement &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0IsConfiguredBase(const Mdl0ConditionalElement &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0sibling_revisionsBase(const Mdl0ConditionalElement &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0variant_formulaBase(const Mdl0ConditionalElement &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0effectivity_formulaBase(Mdl0ConditionalElement &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0variant_formulaBase(Mdl0ConditionalElement &ifObj,  const std::string &value, bool isNull );


    ///
    /// Finalize operation input.
    /// @version Teamcenter 10.1
    /// @param pReviseInput - Desc
    /// @param vecDeepCopyData - Desc
    /// @return - Returns an int.
    ///
    int  finalizeReviseInputBase(const Mdl0ConditionalElement &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.3
    /// @param inputs - A vector of data that contains reference information to the objects to be revised
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0FinalizeReviseInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.3
    /// @param inputs - A vector of data that contains reference information to the objects to be revised
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0ReviseBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.3
    /// @param inputs - A vector of data that contains reference information to the objects to be revised
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0RevisePostBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.3
    /// @param inputs - A vector of data that contains reference information to the objects to be revised
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0SetPropertiesFromReviseInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.3
    /// @param inputs - A vector of data that contains reference information to the objects to be revised
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0ValidateReviseInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// similar to finalizeSaveAsInputBase, this method allows for final changes to the revise descriptor before actually performing the revise
    /// @version Teamcenter 9
    /// @param pSavAsInput - saveAs input
    /// @param vecDeepCopyData - vector of deep copy data for revise
    /// @deprecated #Teamcenter::AppModel::Mdl0ConditionalElement::mdl0finalizeReviseInput deprecated in Teamcenter 11.2
    /// @return - SaveAsInput is updated
    ///
    TC_DEPRECATED_WITH_DEPRECATION_INFO("Teamcenter 11.2","Teamcenter::AppModel::Mdl0ConditionalElement::mdl0finalizeReviseInput","This operation is deprecated in Teamcenter 11.2 and will be removed in Teamcenter 13. Please use finalizeReviseInput operation instead.")
    int  mdl0finalizeReviseInputBase(const Mdl0ConditionalElement &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// major revise in CPD
    /// @version Teamcenter 9
    /// @param pReviseInput - saveAs descriptor
    /// @param vecDeepCopyData - list of deep copy datas
    /// @param newObjTag - resulting tag of revised object
    /// @deprecated #Teamcenter::AppModel::Mdl0ConditionalElement::mdl0Revise deprecated in Teamcenter 11.2
    /// @return - returns status
    ///
    TC_DEPRECATED_WITH_DEPRECATION_INFO("Teamcenter 11.2","Teamcenter::AppModel::Mdl0ConditionalElement::mdl0Revise","This operation is deprecated in Teamcenter 11.2 and will be removed in Teamcenter 13. Please use revise operation instead.")
    int  mdl0ReviseBase(const Mdl0ConditionalElement &ifObj,  ::Teamcenter::SaveAsInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData, tag_t *newObjTag );


    ///
    /// post for major revise in CPD
    /// @version Teamcenter 9
    /// @param pReviseInput - saveAs descriptor
    /// @param vecDeepCopyData - list of deep copy datas
    /// @deprecated #Teamcenter::AppModel::Mdl0ConditionalElement::mdl0RevisePost deprecated in Teamcenter 11.2
    /// @return - returns status
    ///
    TC_DEPRECATED_WITH_DEPRECATION_INFO("Teamcenter 11.2","Teamcenter::AppModel::Mdl0ConditionalElement::mdl0RevisePost","This operation is deprecated in Teamcenter 11.2 and will be removed in Teamcenter 13. Please use revisePost operation instead.")
    int  mdl0RevisePostBase(const Mdl0ConditionalElement &ifObj,  ::Teamcenter::SaveAsInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// operation for creating/setting values to shadow object during revise
    /// @version Teamcenter 11.1
    /// @param pReviseInput - Revise Input
    /// @param newShObjTag - new shadow object created during revise
    /// @return - error number
    ///
    int  mdl0ReviseShadowObjectBase(const Mdl0ConditionalElement &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, tag_t *newShObjTag );


    ///
    /// Revise operation.
    /// @version Teamcenter 10.1
    /// @param pReviseInput - Desc
    /// @param vecDeepCopyData - Desc
    /// @param newObjTag - Desc
    /// @return - Returns an int.
    ///
    int  reviseBase(const Mdl0ConditionalElement &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData, tag_t *newObjTag );


    ///
    /// Generic revisePost operation.
    /// @version Teamcenter 10.1
    /// @param pReviseInput - Desc
    /// @param vecDeepCopyData - Desc
    /// @return - Returns an int.
    ///
    int  revisePostBase(const Mdl0ConditionalElement &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// Set properties from revise input.
    /// @version Teamcenter 10.1
    /// @param pReviseInput - Desc
    /// @return - Returns an int.
    ///
    int  setPropertiesFromReviseInputBase(const Mdl0ConditionalElement &ifObj,  ::Teamcenter::ReviseInput *pReviseInput );


    ///
    /// Validate revise input.
    /// @version Teamcenter 10.1
    /// @param pReviseInput - Desc
    /// @param vecDeepCopyData - Desc
    /// @return - Returns an int.
    ///
    int  validateReviseInputBase(const Mdl0ConditionalElement &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Mdl0ConditionalElement &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Mdl0ConditionalElement &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// finalize operation input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  finalizeSaveAsInputBase(const Mdl0ConditionalElement &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0CreatePostBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be created
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0FinalizeCreateInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.3
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0FinalizeSaveAsInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.3
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0SetPropertiesFromSaveAsInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be created
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0ValidateCreateInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// setproperties from saveas input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @return - returns an int
    ///
    int  setPropertiesFromSaveAsInputBase(const Mdl0ConditionalElement &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Mdl0ConditionalElement &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Mdl0ConditionalElementDelegate*  m_pInstance;

    Mdl0ConditionalElementDelegate();
    virtual ~Mdl0ConditionalElementDelegate();
    static void setInstance( Mdl0ConditionalElementDelegate*  instance );


private:
    friend class  ::Teamcenter::AppModel::Mdl0ConditionalElementGenImpl;

};

#include <mdl0model/libmdl0model_undef.h>
#endif  //  TEAMCENTER__APPMODEL__MDL0CONDITIONALELEMENTDELEGATE_HXX
