//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0EffectivityExprBlock
    Filename:   Mdl0EffectivityExprBlock.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0EFFECTIVITYEXPRBLOCK__HXX
#define TEAMCENTER__APPMODEL__MDL0EFFECTIVITYEXPRBLOCK__HXX

#include <common/tc_deprecation_macros.h>
#include <fnd0booleansolve/Fnd0EffectivityExprBlock.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0EffectivityExprBlock;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0EffectivityExprBlockImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0EffectivityExprBlockDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0EffectivityExprBlockDispatch;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0EffectivityExprBlockGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDL0MODEL_API  Teamcenter::AppModel::Mdl0EffectivityExprBlock
     : public  ::Teamcenter::Fnd0EffectivityExprBlock
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdl0EffectivityExprBlock();

    /**
     * Destructor
     */
    virtual ~Mdl0EffectivityExprBlock();

private:
    //  Getter method for the Implementation Object
    Mdl0EffectivityExprBlockImpl*  getMdl0EffectivityExprBlockImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdl0EffectivityExprBlockImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdl0EffectivityExprBlockImpl*  m_mdl0effectivityexprblockImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdl0EffectivityExprBlock - desc for Mdl0EffectivityExprBlock parameter
     */
    Mdl0EffectivityExprBlock( const Mdl0EffectivityExprBlock& );
    Mdl0EffectivityExprBlock& operator=( const Mdl0EffectivityExprBlock& );

    friend class  Mdl0EffectivityExprBlockDelegate;
    friend class  Mdl0EffectivityExprBlockDispatch;
    friend class  Mdl0EffectivityExprBlockGenImpl;
};

#include <mdl0model/libmdl0model_undef.h>
#endif //   TEAMCENTER__APPMODEL__MDL0EFFECTIVITYEXPRBLOCK__HXX
