//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0EffectivityInModelDelegate
    Filename:   Mdl0EffectivityInModelDelegate.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0EFFECTIVITYINMODELDELEGATE_HXX
#define TEAMCENTER__APPMODEL__MDL0EFFECTIVITYINMODELDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0EffectivityInModel.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0EffectivityInModelDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0EffectivityInModelImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0EffectivityInModel;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0EffectivityInModelGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MDL0MODEL_API Teamcenter_alias::AppModel::Mdl0EffectivityInModelDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mdl0EffectivityInModelDelegate instance
    static Mdl0EffectivityInModelDelegate&  getInstance();

    //  Method to create the Mdl0EffectivityInModelImpl pointer
    static Mdl0EffectivityInModelImpl*  createImpl( Mdl0EffectivityInModel&  ifObj );

    //  Method to delete the Mdl0EffectivityInModelImpl pointer
    static void deleteImpl( Mdl0EffectivityInModelImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0configurator_URLBase(const Mdl0EffectivityInModel &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0descriptionBase(const Mdl0EffectivityInModel &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0modelBase(const Mdl0EffectivityInModel &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0nameBase(const Mdl0EffectivityInModel &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0product_nameBase(const Mdl0EffectivityInModel &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0product_namespaceBase(const Mdl0EffectivityInModel &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0configurator_URLBase(Mdl0EffectivityInModel &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0descriptionBase(Mdl0EffectivityInModel &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0modelBase(Mdl0EffectivityInModel &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0nameBase(Mdl0EffectivityInModel &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static Mdl0EffectivityInModelDelegate*  m_pInstance;

    Mdl0EffectivityInModelDelegate();
    virtual ~Mdl0EffectivityInModelDelegate();
    static void setInstance( Mdl0EffectivityInModelDelegate*  instance );


private:
    friend class  ::Teamcenter::AppModel::Mdl0EffectivityInModelGenImpl;

};

#include <mdl0model/libmdl0model_undef.h>
#endif  //  TEAMCENTER__APPMODEL__MDL0EFFECTIVITYINMODELDELEGATE_HXX
