//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0ElementThread
    Filename:   Mdl0ElementThread.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0ELEMENTTHREAD__HXX
#define TEAMCENTER__APPMODEL__MDL0ELEMENTTHREAD__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/Fnd0ObjectThread.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ElementThread;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ElementThreadImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ElementThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ElementThreadDispatch;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ElementThreadGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDL0MODEL_API  Teamcenter::AppModel::Mdl0ElementThread
     : public  ::Teamcenter::Fnd0ObjectThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0ConfiguredRevision( tag_t &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdl0ElementThread();

    /**
     * Destructor
     */
    virtual ~Mdl0ElementThread();

private:
    //  Getter method for the Implementation Object
    Mdl0ElementThreadImpl*  getMdl0ElementThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdl0ElementThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdl0ElementThreadImpl*  m_mdl0elementthreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdl0ElementThread - desc for Mdl0ElementThread parameter
     */
    Mdl0ElementThread( const Mdl0ElementThread& );
    Mdl0ElementThread& operator=( const Mdl0ElementThread& );

    friend class  Mdl0ElementThreadDelegate;
    friend class  Mdl0ElementThreadDispatch;
    friend class  Mdl0ElementThreadGenImpl;
};

#include <mdl0model/libmdl0model_undef.h>
#endif //   TEAMCENTER__APPMODEL__MDL0ELEMENTTHREAD__HXX
