//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0ElementThreadDelegate
    Filename:   Mdl0ElementThreadDelegate.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0ELEMENTTHREADDELEGATE_HXX
#define TEAMCENTER__APPMODEL__MDL0ELEMENTTHREADDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0ElementThread.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ElementThreadDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ElementThreadImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ElementThread;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ElementThreadGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MDL0MODEL_API Teamcenter_alias::AppModel::Mdl0ElementThreadDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mdl0ElementThreadDelegate instance
    static Mdl0ElementThreadDelegate&  getInstance();

    //  Method to create the Mdl0ElementThreadImpl pointer
    static Mdl0ElementThreadImpl*  createImpl( Mdl0ElementThread&  ifObj );

    //  Method to delete the Mdl0ElementThreadImpl pointer
    static void deleteImpl( Mdl0ElementThreadImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0ConfiguredRevisionBase(const Mdl0ElementThread &ifObj,  tag_t &value, bool &isNull ) const;



protected:
    //  Pointer to the instance
    static Mdl0ElementThreadDelegate*  m_pInstance;

    Mdl0ElementThreadDelegate();
    virtual ~Mdl0ElementThreadDelegate();
    static void setInstance( Mdl0ElementThreadDelegate*  instance );


private:
    friend class  ::Teamcenter::AppModel::Mdl0ElementThreadGenImpl;

};

#include <mdl0model/libmdl0model_undef.h>
#endif  //  TEAMCENTER__APPMODEL__MDL0ELEMENTTHREADDELEGATE_HXX
