//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0IncludeAll
    Filename:   Mdl0IncludeAll.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0INCLUDEALL__HXX
#define TEAMCENTER__APPMODEL__MDL0INCLUDEALL__HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0SearchDef.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0IncludeAll;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0IncludeAllImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0IncludeAllDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0IncludeAllDispatch;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0IncludeAllGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDL0MODEL_API  Teamcenter::AppModel::Mdl0IncludeAll
     : public  ::Teamcenter::AppModel::Mdl0SearchDef
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdl0IncludeAll();

    /**
     * Destructor
     */
    virtual ~Mdl0IncludeAll();

private:
    //  Getter method for the Implementation Object
    Mdl0IncludeAllImpl*  getMdl0IncludeAllImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdl0IncludeAllImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdl0IncludeAllImpl*  m_mdl0includeallImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdl0IncludeAll - desc for Mdl0IncludeAll parameter
     */
    Mdl0IncludeAll( const Mdl0IncludeAll& );
    Mdl0IncludeAll& operator=( const Mdl0IncludeAll& );

    friend class  Mdl0IncludeAllDelegate;
    friend class  Mdl0IncludeAllDispatch;
    friend class  Mdl0IncludeAllGenImpl;
};

#include <mdl0model/libmdl0model_undef.h>
#endif //   TEAMCENTER__APPMODEL__MDL0INCLUDEALL__HXX
