//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0ManagedAttrGroup
    Filename:   Mdl0ManagedAttrGroup.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0MANAGEDATTRGROUP__HXX
#define TEAMCENTER__APPMODEL__MDL0MANAGEDATTRGROUP__HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0ConditionalElement.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ManagedAttrGroup;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ManagedAttrGroupImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ManagedAttrGroupDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ManagedAttrGroupDispatch;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ManagedAttrGroupGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDL0MODEL_API  Teamcenter::AppModel::Mdl0ManagedAttrGroup
     : public  ::Teamcenter::AppModel::Mdl0ConditionalElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdl0ManagedAttrGroup();

    /**
     * Destructor
     */
    virtual ~Mdl0ManagedAttrGroup();

private:
    //  Getter method for the Implementation Object
    Mdl0ManagedAttrGroupImpl*  getMdl0ManagedAttrGroupImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdl0ManagedAttrGroupImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdl0ManagedAttrGroupImpl*  m_mdl0managedattrgroupImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdl0ManagedAttrGroup - desc for Mdl0ManagedAttrGroup parameter
     */
    Mdl0ManagedAttrGroup( const Mdl0ManagedAttrGroup& );
    Mdl0ManagedAttrGroup& operator=( const Mdl0ManagedAttrGroup& );

    friend class  Mdl0ManagedAttrGroupDelegate;
    friend class  Mdl0ManagedAttrGroupDispatch;
    friend class  Mdl0ManagedAttrGroupGenImpl;
};

#include <mdl0model/libmdl0model_undef.h>
#endif //   TEAMCENTER__APPMODEL__MDL0MANAGEDATTRGROUP__HXX
