//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0ModelArtifact
    Filename:   Mdl0ModelArtifact.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0MODELARTIFACT__HXX
#define TEAMCENTER__APPMODEL__MDL0MODELARTIFACT__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ModelArtifact;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ModelArtifactImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ModelArtifactDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ModelArtifactDispatch;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ModelArtifactGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDL0MODEL_API  Teamcenter::AppModel::Mdl0ModelArtifact
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0model_object( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0model_object( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdl0ModelArtifact();

    /**
     * Destructor
     */
    virtual ~Mdl0ModelArtifact();

private:
    //  Getter method for the Implementation Object
    Mdl0ModelArtifactImpl*  getMdl0ModelArtifactImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdl0ModelArtifactImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdl0ModelArtifactImpl*  m_mdl0modelartifactImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdl0ModelArtifact - desc for Mdl0ModelArtifact parameter
     */
    Mdl0ModelArtifact( const Mdl0ModelArtifact& );
    Mdl0ModelArtifact& operator=( const Mdl0ModelArtifact& );

    friend class  Mdl0ModelArtifactDelegate;
    friend class  Mdl0ModelArtifactDispatch;
    friend class  Mdl0ModelArtifactGenImpl;
};

#include <mdl0model/libmdl0model_undef.h>
#endif //   TEAMCENTER__APPMODEL__MDL0MODELARTIFACT__HXX
