//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0ModelArtifactDelegate
    Filename:   Mdl0ModelArtifactDelegate.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0MODELARTIFACTDELEGATE_HXX
#define TEAMCENTER__APPMODEL__MDL0MODELARTIFACTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0ModelArtifact.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ModelArtifactDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ModelArtifactImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ModelArtifact;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ModelArtifactGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MDL0MODEL_API Teamcenter_alias::AppModel::Mdl0ModelArtifactDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mdl0ModelArtifactDelegate instance
    static Mdl0ModelArtifactDelegate&  getInstance();

    //  Method to create the Mdl0ModelArtifactImpl pointer
    static Mdl0ModelArtifactImpl*  createImpl( Mdl0ModelArtifact&  ifObj );

    //  Method to delete the Mdl0ModelArtifactImpl pointer
    static void deleteImpl( Mdl0ModelArtifactImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0model_objectBase(const Mdl0ModelArtifact &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0model_objectBase(Mdl0ModelArtifact &ifObj,  const tag_t &value, bool isNull );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Mdl0ModelArtifact &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0CreatePostBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.3
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0SaveAsPostBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// Generic saveAsPost operation.
    /// @version Teamcenter 8.1
    /// @param pSavAsInput - Input argument as SaveAsInput object.
    /// @param vecDeepCopyData - vector deepcopy data
    /// @return - Return integer value.
    ///
    int  saveAsPostBase(const Mdl0ModelArtifact &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static Mdl0ModelArtifactDelegate*  m_pInstance;

    Mdl0ModelArtifactDelegate();
    virtual ~Mdl0ModelArtifactDelegate();
    static void setInstance( Mdl0ModelArtifactDelegate*  instance );


private:
    friend class  ::Teamcenter::AppModel::Mdl0ModelArtifactGenImpl;

};

#include <mdl0model/libmdl0model_undef.h>
#endif  //  TEAMCENTER__APPMODEL__MDL0MODELARTIFACTDELEGATE_HXX
