//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0ModelElement
    Filename:   Mdl0ModelElement.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0MODELELEMENT__HXX
#define TEAMCENTER__APPMODEL__MDL0MODELELEMENT__HXX

#include <vector>
#include <string>
#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ModelElement;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ModelElementImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ModelElementDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ModelElementDispatch;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ModelElementGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDL0MODEL_API  Teamcenter::AppModel::Mdl0ModelElement
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0AttributeGroups( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @deprecated Teamcenter::AppModel::Mdl0ModelElement::getMdl0HistorySyncStatus deprecated in Teamcenter 11.2.3
    /// @return - Status. 0 if successful
    ///
    TC_DEPRECATED_WITH_DEPRECATION_INFO("Teamcenter 11.2.3","Teamcenter::AppModel::Mdl0ModelElement::getMdl0HistorySyncStatus","This property is deprecated and will be removed from Teamcenter 13.0. From Teamcenter 11.2.3 history versions are always in sync. For the time being the in-sync value is always given.")
    int  getMdl0HistorySyncStatus( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0is_obsolete( bool &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0model_object( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0Override( int &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0pending_AttachAttrGroup( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 11.2.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0AttributeGroups( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );

    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0is_obsolete( bool value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0model_object( const tag_t &value, bool isNull=false );

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0Override( int value, bool isNull=false );

    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 9.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0pending_AttachAttrGroup( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );

    ///
    /// Verifies whether the operation is Inter Model Copy.
    /// @version Teamcenter 11.1
    /// @param chkInter - Returns whether condition check is valid for Inter Model Copy Output
    /// @return - 
    ///
    int  mdl0chkInterModel( bool *chkInter );

    ///
    /// Verifies whether the operation is Intra Model Copy.
    /// @version Teamcenter 11.1
    /// @param chkIntra - Returns whether condition check is valid for Intra Model Copy
    /// @return - 
    ///
    int  mdl0chkIntraModel( bool *chkIntra );

    ///
    /// Verifies whether the operation is M2M Instantiation.
    /// @version Teamcenter 11.1
    /// @param chkInstantiation - Returns whether condition check is valid for M2M Instantiation Operation
    /// @return - 
    ///
    int  mdl0chkModelInstantiation( bool *chkInstantiation );

    ///
    /// Verifies whether the operation is M2M Realization.
    /// @version Teamcenter 11.1
    /// @param chkRealization - Returns whether condition check is valid for M2M Realization Operation.
    /// @return - 
    ///
    int  mdl0chkModelRealization( bool *chkRealization );

    ///
    /// The operation <b>mdl0chkModelRlzOrInstantiation</b> checks for the operation type  <font face="courier" height="10">realization</font>,<font face="courier" height="10">cloning</font>,<font face="courier" height="10">instantiation</font> or <font face="courier" height="10">saveAs</font> to decide whether the <b>Mdl0OriginalGeometry</b> should be copied forward or not.If the operation type is realization or instantiation<font face="courier" height="10"> </font>then<font face="courier" height="10"> Mdl0OriginalGeometry</font> should not be copied forward.
    /// @version Teamcenter 11.1
    /// @param isCopyMOG - This parameter indicates whether the Mdl0OriginalGeometry should be copied forward or not.If the operation type is realization or instantiation isCopyMOG will be false.
    /// @return -  mdl0chkModelRlzOrInstantiation checks for the operation type  <font face="courier" height="10">realization</font>,<font face="courier" height="10">cloning</font>,<font face="courier" height="10">instantiation</font> or <font face="courier" height="10">saveAs</font> to decide whether the <b>Mdl0OriginalGeometry</b> should be copied forward or not.If the operation type is realization or instantiation then <font face="courier" height="10">isCopyMOG</font> will be false.
    ///
    int  mdl0chkModelRlzOrInstantiation( bool *isCopyMOG );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdl0ModelElement();

    /**
     * Destructor
     */
    virtual ~Mdl0ModelElement();

private:
    //  Getter method for the Implementation Object
    Mdl0ModelElementImpl*  getMdl0ModelElementImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdl0ModelElementImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdl0ModelElementImpl*  m_mdl0modelelementImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdl0ModelElement - desc for Mdl0ModelElement parameter
     */
    Mdl0ModelElement( const Mdl0ModelElement& );
    Mdl0ModelElement& operator=( const Mdl0ModelElement& );

    friend class  Mdl0ModelElementDelegate;
    friend class  Mdl0ModelElementDispatch;
    friend class  Mdl0ModelElementGenImpl;
};

#include <mdl0model/libmdl0model_undef.h>
#endif //   TEAMCENTER__APPMODEL__MDL0MODELELEMENT__HXX
