//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0ModelElementDelegate
    Filename:   Mdl0ModelElementDelegate.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0MODELELEMENTDELEGATE_HXX
#define TEAMCENTER__APPMODEL__MDL0MODELELEMENTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0ModelElement.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ModelElementDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ModelElementImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ModelElement;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ModelElementGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MDL0MODEL_API Teamcenter_alias::AppModel::Mdl0ModelElementDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mdl0ModelElementDelegate instance
    static Mdl0ModelElementDelegate&  getInstance();

    //  Method to create the Mdl0ModelElementImpl pointer
    static Mdl0ModelElementImpl*  createImpl( Mdl0ModelElement&  ifObj );

    //  Method to delete the Mdl0ModelElementImpl pointer
    static void deleteImpl( Mdl0ModelElementImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0AttributeGroupsBase(const Mdl0ModelElement &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @deprecated Teamcenter::AppModel::Mdl0ModelElement::getMdl0HistorySyncStatus deprecated in Teamcenter 11.2.3
    /// @return - Status. 0 if successful
    ///
    TC_DEPRECATED_WITH_DEPRECATION_INFO("Teamcenter 11.2.3","Teamcenter::AppModel::Mdl0ModelElement::getMdl0HistorySyncStatus","This property is deprecated and will be removed from Teamcenter 13.0. From Teamcenter 11.2.3 history versions are always in sync. For the time being the in-sync value is always given.")
    int  getMdl0HistorySyncStatusBase(const Mdl0ModelElement &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0is_obsoleteBase(const Mdl0ModelElement &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0model_objectBase(const Mdl0ModelElement &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0OverrideBase(const Mdl0ModelElement &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0pending_AttachAttrGroupBase(const Mdl0ModelElement &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 11.2.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0AttributeGroupsBase(Mdl0ModelElement &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0is_obsoleteBase(Mdl0ModelElement &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0model_objectBase(Mdl0ModelElement &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0OverrideBase(Mdl0ModelElement &ifObj,  int value, bool isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 9.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0pending_AttachAttrGroupBase(Mdl0ModelElement &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Verifies whether the operation is Inter Model Copy.
    /// @version Teamcenter 11.1
    /// @param chkInter - Returns whether condition check is valid for Inter Model Copy Output
    /// @return - 
    ///
    int  mdl0chkInterModelBase(const Mdl0ModelElement &ifObj,  bool *chkInter );


    ///
    /// Verifies whether the operation is Intra Model Copy.
    /// @version Teamcenter 11.1
    /// @param chkIntra - Returns whether condition check is valid for Intra Model Copy
    /// @return - 
    ///
    int  mdl0chkIntraModelBase(const Mdl0ModelElement &ifObj,  bool *chkIntra );


    ///
    /// Verifies whether the operation is M2M Instantiation.
    /// @version Teamcenter 11.1
    /// @param chkInstantiation - Returns whether condition check is valid for M2M Instantiation Operation
    /// @return - 
    ///
    int  mdl0chkModelInstantiationBase(const Mdl0ModelElement &ifObj,  bool *chkInstantiation );


    ///
    /// Verifies whether the operation is M2M Realization.
    /// @version Teamcenter 11.1
    /// @param chkRealization - Returns whether condition check is valid for M2M Realization Operation.
    /// @return - 
    ///
    int  mdl0chkModelRealizationBase(const Mdl0ModelElement &ifObj,  bool *chkRealization );


    ///
    /// The operation <b>mdl0chkModelRlzOrInstantiation</b> checks for the operation type  <font face="courier" height="10">realization</font>,<font face="courier" height="10">cloning</font>,<font face="courier" height="10">instantiation</font> or <font face="courier" height="10">saveAs</font> to decide whether the <b>Mdl0OriginalGeometry</b> should be copied forward or not.If the operation type is realization or instantiation<font face="courier" height="10"> </font>then<font face="courier" height="10"> Mdl0OriginalGeometry</font> should not be copied forward.
    /// @version Teamcenter 11.1
    /// @param isCopyMOG - This parameter indicates whether the Mdl0OriginalGeometry should be copied forward or not.If the operation type is realization or instantiation isCopyMOG will be false.
    /// @return -  mdl0chkModelRlzOrInstantiation checks for the operation type  <font face="courier" height="10">realization</font>,<font face="courier" height="10">cloning</font>,<font face="courier" height="10">instantiation</font> or <font face="courier" height="10">saveAs</font> to decide whether the <b>Mdl0OriginalGeometry</b> should be copied forward or not.If the operation type is realization or instantiation then <font face="courier" height="10">isCopyMOG</font> will be false.
    ///
    int  mdl0chkModelRlzOrInstantiationBase(const Mdl0ModelElement &ifObj,  bool *isCopyMOG );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Mdl0ModelElement &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// finalize operation input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  finalizeSaveAsInputBase(const Mdl0ModelElement &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0CreatePostBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.3
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0FinalizeSaveAsInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.3
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0SaveAsPostBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// Generic saveAsPost operation.
    /// @version Teamcenter 8.1
    /// @param pSavAsInput - Input argument as SaveAsInput object.
    /// @param vecDeepCopyData - vector deepcopy data
    /// @return - Return integer value.
    ///
    int  saveAsPostBase(const Mdl0ModelElement &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static Mdl0ModelElementDelegate*  m_pInstance;

    Mdl0ModelElementDelegate();
    virtual ~Mdl0ModelElementDelegate();
    static void setInstance( Mdl0ModelElementDelegate*  instance );


private:
    friend class  ::Teamcenter::AppModel::Mdl0ModelElementGenImpl;

};

#include <mdl0model/libmdl0model_undef.h>
#endif  //  TEAMCENTER__APPMODEL__MDL0MODELELEMENTDELEGATE_HXX
