//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0ModelProcessState
    Filename:   Mdl0ModelProcessState.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0MODELPROCESSSTATE__HXX
#define TEAMCENTER__APPMODEL__MDL0MODELPROCESSSTATE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ModelProcessState;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ModelProcessStateImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ModelProcessStateDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ModelProcessStateDispatch;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ModelProcessStateGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDL0MODEL_API  Teamcenter::AppModel::Mdl0ModelProcessState
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdl0ModelProcessState();

    /**
     * Destructor
     */
    virtual ~Mdl0ModelProcessState();

private:
    //  Getter method for the Implementation Object
    Mdl0ModelProcessStateImpl*  getMdl0ModelProcessStateImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdl0ModelProcessStateImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdl0ModelProcessStateImpl*  m_mdl0modelprocessstateImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdl0ModelProcessState - desc for Mdl0ModelProcessState parameter
     */
    Mdl0ModelProcessState( const Mdl0ModelProcessState& );
    Mdl0ModelProcessState& operator=( const Mdl0ModelProcessState& );

    friend class  Mdl0ModelProcessStateDelegate;
    friend class  Mdl0ModelProcessStateDispatch;
    friend class  Mdl0ModelProcessStateGenImpl;
};

#include <mdl0model/libmdl0model_undef.h>
#endif //   TEAMCENTER__APPMODEL__MDL0MODELPROCESSSTATE__HXX
