//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0ModelProcessStateDelegate
    Filename:   Mdl0ModelProcessStateDelegate.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0MODELPROCESSSTATEDELEGATE_HXX
#define TEAMCENTER__APPMODEL__MDL0MODELPROCESSSTATEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0ModelProcessState.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ModelProcessStateDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ModelProcessStateImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ModelProcessState;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ModelProcessStateGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MDL0MODEL_API Teamcenter_alias::AppModel::Mdl0ModelProcessStateDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mdl0ModelProcessStateDelegate instance
    static Mdl0ModelProcessStateDelegate&  getInstance();

    //  Method to create the Mdl0ModelProcessStateImpl pointer
    static Mdl0ModelProcessStateImpl*  createImpl( Mdl0ModelProcessState&  ifObj );

    //  Method to delete the Mdl0ModelProcessStateImpl pointer
    static void deleteImpl( Mdl0ModelProcessStateImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be created
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0ValidateCreateInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Mdl0ModelProcessState &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Mdl0ModelProcessStateDelegate*  m_pInstance;

    Mdl0ModelProcessStateDelegate();
    virtual ~Mdl0ModelProcessStateDelegate();
    static void setInstance( Mdl0ModelProcessStateDelegate*  instance );


private:
    friend class  ::Teamcenter::AppModel::Mdl0ModelProcessStateGenImpl;

};

#include <mdl0model/libmdl0model_undef.h>
#endif  //  TEAMCENTER__APPMODEL__MDL0MODELPROCESSSTATEDELEGATE_HXX
