//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0RefAppModelProvider
    Filename:   Mdl0RefAppModelProvider.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0REFAPPMODELPROVIDER__HXX
#define TEAMCENTER__APPMODEL__MDL0REFAPPMODELPROVIDER__HXX

#include <common/tc_deprecation_macros.h>
#include <tc/Fnd0BaseProvider.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0RefAppModelProvider;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0RefAppModelProviderImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0RefAppModelProviderDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0RefAppModelProviderDispatch;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0RefAppModelProviderGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDL0MODEL_API  Teamcenter::AppModel::Mdl0RefAppModelProvider
     : public  ::Teamcenter::Fnd0BaseProvider
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdl0RefAppModelProvider();

    /**
     * Destructor
     */
    virtual ~Mdl0RefAppModelProvider();

private:
    //  Getter method for the Implementation Object
    Mdl0RefAppModelProviderImpl*  getMdl0RefAppModelProviderImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdl0RefAppModelProviderImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdl0RefAppModelProviderImpl*  m_mdl0refappmodelproviderImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdl0RefAppModelProvider - desc for Mdl0RefAppModelProvider parameter
     */
    Mdl0RefAppModelProvider( const Mdl0RefAppModelProvider& );
    Mdl0RefAppModelProvider& operator=( const Mdl0RefAppModelProvider& );

    friend class  Mdl0RefAppModelProviderDelegate;
    friend class  Mdl0RefAppModelProviderDispatch;
    friend class  Mdl0RefAppModelProviderGenImpl;
};

#include <mdl0model/libmdl0model_undef.h>
#endif //   TEAMCENTER__APPMODEL__MDL0REFAPPMODELPROVIDER__HXX
