//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0SearchBoxZone
    Filename:   Mdl0SearchBoxZone.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0SEARCHBOXZONE__HXX
#define TEAMCENTER__APPMODEL__MDL0SEARCHBOXZONE__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0SearchDef.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchBoxZone;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchBoxZoneImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchBoxZoneDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchBoxZoneDispatch;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchBoxZoneGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDL0MODEL_API  Teamcenter::AppModel::Mdl0SearchBoxZone
     : public  ::Teamcenter::AppModel::Mdl0SearchDef
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Double Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0coordinates( std::vector< double > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0operator( int &value, bool &isNull ) const;

    ///
    /// Setter for a Double Array Property
    /// @version Teamcenter 9
    /// @param values - Values to be set for the paramter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0coordinates( const std::vector< double > &values, const std::vector< int > *isNull=0 );

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0operator( int value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdl0SearchBoxZone();

    /**
     * Destructor
     */
    virtual ~Mdl0SearchBoxZone();

private:
    //  Getter method for the Implementation Object
    Mdl0SearchBoxZoneImpl*  getMdl0SearchBoxZoneImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdl0SearchBoxZoneImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdl0SearchBoxZoneImpl*  m_mdl0searchboxzoneImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdl0SearchBoxZone - desc for Mdl0SearchBoxZone parameter
     */
    Mdl0SearchBoxZone( const Mdl0SearchBoxZone& );
    Mdl0SearchBoxZone& operator=( const Mdl0SearchBoxZone& );

    friend class  Mdl0SearchBoxZoneDelegate;
    friend class  Mdl0SearchBoxZoneDispatch;
    friend class  Mdl0SearchBoxZoneGenImpl;
};

#include <mdl0model/libmdl0model_undef.h>
#endif //   TEAMCENTER__APPMODEL__MDL0SEARCHBOXZONE__HXX
