//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0SearchClassification
    Filename:   Mdl0SearchClassification.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0SEARCHCLASSIFICATION__HXX
#define TEAMCENTER__APPMODEL__MDL0SEARCHCLASSIFICATION__HXX

#include <vector>
#include <string>
#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0SearchDef.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchClassification;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchClassificationImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchClassificationDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchClassificationDispatch;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchClassificationGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDL0MODEL_API  Teamcenter::AppModel::Mdl0SearchClassification
     : public  ::Teamcenter::AppModel::Mdl0SearchDef
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 11.5
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0ClsAttributeExpressions( std::vector< std::string > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 11.5
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0ClsAttributeIdList( std::vector< std::string > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0ClsClassId( std::string &value, bool &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0ClsOption( int &value, bool &isNull ) const;

    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 11.5
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0ClsAttributeExpressions( const std::vector< std::string > &values, const std::vector< int > *isNull=0 );

    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 11.5
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0ClsAttributeIdList( const std::vector< std::string > &values, const std::vector< int > *isNull=0 );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.5
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0ClsClassId( const std::string &value, bool isNull=false );

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 11.5
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0ClsOption( int value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdl0SearchClassification();

    /**
     * Destructor
     */
    virtual ~Mdl0SearchClassification();

private:
    //  Getter method for the Implementation Object
    Mdl0SearchClassificationImpl*  getMdl0SearchClassificationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdl0SearchClassificationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdl0SearchClassificationImpl*  m_mdl0searchclassificationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdl0SearchClassification - desc for Mdl0SearchClassification parameter
     */
    Mdl0SearchClassification( const Mdl0SearchClassification& );
    Mdl0SearchClassification& operator=( const Mdl0SearchClassification& );

    friend class  Mdl0SearchClassificationDelegate;
    friend class  Mdl0SearchClassificationDispatch;
    friend class  Mdl0SearchClassificationGenImpl;
};

#include <mdl0model/libmdl0model_undef.h>
#endif //   TEAMCENTER__APPMODEL__MDL0SEARCHCLASSIFICATION__HXX
