//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0SearchClassificationDelegate
    Filename:   Mdl0SearchClassificationDelegate.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0SEARCHCLASSIFICATIONDELEGATE_HXX
#define TEAMCENTER__APPMODEL__MDL0SEARCHCLASSIFICATIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0SearchClassification.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchClassificationDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchClassificationImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchClassification;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchClassificationGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MDL0MODEL_API Teamcenter_alias::AppModel::Mdl0SearchClassificationDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mdl0SearchClassificationDelegate instance
    static Mdl0SearchClassificationDelegate&  getInstance();

    //  Method to create the Mdl0SearchClassificationImpl pointer
    static Mdl0SearchClassificationImpl*  createImpl( Mdl0SearchClassification&  ifObj );

    //  Method to delete the Mdl0SearchClassificationImpl pointer
    static void deleteImpl( Mdl0SearchClassificationImpl*  impl );


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 11.5
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0ClsAttributeExpressionsBase(const Mdl0SearchClassification &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 11.5
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0ClsAttributeIdListBase(const Mdl0SearchClassification &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0ClsClassIdBase(const Mdl0SearchClassification &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0ClsOptionBase(const Mdl0SearchClassification &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 11.5
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0ClsAttributeExpressionsBase(Mdl0SearchClassification &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 11.5
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0ClsAttributeIdListBase(Mdl0SearchClassification &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.5
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0ClsClassIdBase(Mdl0SearchClassification &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 11.5
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0ClsOptionBase(Mdl0SearchClassification &ifObj,  int value, bool isNull );


    ///
    /// Generates permanent ID/recipe. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param recipe - Permanent ID/recipe
    /// @return - Failure code.
    ///
    int  fnd0GenerateRecipeBase(const Mdl0SearchClassification &ifObj,  std::string *recipe );



protected:
    //  Pointer to the instance
    static Mdl0SearchClassificationDelegate*  m_pInstance;

    Mdl0SearchClassificationDelegate();
    virtual ~Mdl0SearchClassificationDelegate();
    static void setInstance( Mdl0SearchClassificationDelegate*  instance );


private:
    friend class  ::Teamcenter::AppModel::Mdl0SearchClassificationGenImpl;

};

#include <mdl0model/libmdl0model_undef.h>
#endif  //  TEAMCENTER__APPMODEL__MDL0SEARCHCLASSIFICATIONDELEGATE_HXX
