//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0SearchCursor
    Filename:   Mdl0SearchCursor.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0SEARCHCURSOR__HXX
#define TEAMCENTER__APPMODEL__MDL0SEARCHCURSOR__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchCursor;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchCursorImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchCursorDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchCursorDispatch;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchCursorGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDL0MODEL_API  Teamcenter::AppModel::Mdl0SearchCursor
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdl0SearchCursor();

    /**
     * Destructor
     */
    virtual ~Mdl0SearchCursor();

private:
    //  Getter method for the Implementation Object
    Mdl0SearchCursorImpl*  getMdl0SearchCursorImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdl0SearchCursorImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdl0SearchCursorImpl*  m_mdl0searchcursorImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdl0SearchCursor - desc for Mdl0SearchCursor parameter
     */
    Mdl0SearchCursor( const Mdl0SearchCursor& );
    Mdl0SearchCursor& operator=( const Mdl0SearchCursor& );

    friend class  Mdl0SearchCursorDelegate;
    friend class  Mdl0SearchCursorDispatch;
    friend class  Mdl0SearchCursorGenImpl;
};

#include <mdl0model/libmdl0model_undef.h>
#endif //   TEAMCENTER__APPMODEL__MDL0SEARCHCURSOR__HXX
