//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0SearchGeomConstraint
    Filename:   Mdl0SearchGeomConstraint.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0SEARCHGEOMCONSTRAINT__HXX
#define TEAMCENTER__APPMODEL__MDL0SEARCHGEOMCONSTRAINT__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0SearchDef.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchGeomConstraint;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchGeomConstraintImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchGeomConstraintDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchGeomConstraintDispatch;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchGeomConstraintGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDL0MODEL_API  Teamcenter::AppModel::Mdl0SearchGeomConstraint
     : public  ::Teamcenter::AppModel::Mdl0SearchDef
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0ProcessCtrlFlag( int &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0SourceCriteria( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0ProcessCtrlFlag( int value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0SourceCriteria( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdl0SearchGeomConstraint();

    /**
     * Destructor
     */
    virtual ~Mdl0SearchGeomConstraint();

private:
    //  Getter method for the Implementation Object
    Mdl0SearchGeomConstraintImpl*  getMdl0SearchGeomConstraintImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdl0SearchGeomConstraintImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdl0SearchGeomConstraintImpl*  m_mdl0searchgeomconstraintImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdl0SearchGeomConstraint - desc for Mdl0SearchGeomConstraint parameter
     */
    Mdl0SearchGeomConstraint( const Mdl0SearchGeomConstraint& );
    Mdl0SearchGeomConstraint& operator=( const Mdl0SearchGeomConstraint& );

    friend class  Mdl0SearchGeomConstraintDelegate;
    friend class  Mdl0SearchGeomConstraintDispatch;
    friend class  Mdl0SearchGeomConstraintGenImpl;
};

#include <mdl0model/libmdl0model_undef.h>
#endif //   TEAMCENTER__APPMODEL__MDL0SEARCHGEOMCONSTRAINT__HXX
