//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0SearchGeomConstraintDelegate
    Filename:   Mdl0SearchGeomConstraintDelegate.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0SEARCHGEOMCONSTRAINTDELEGATE_HXX
#define TEAMCENTER__APPMODEL__MDL0SEARCHGEOMCONSTRAINTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0SearchGeomConstraint.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchGeomConstraintDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchGeomConstraintImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchGeomConstraint;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchGeomConstraintGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MDL0MODEL_API Teamcenter_alias::AppModel::Mdl0SearchGeomConstraintDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mdl0SearchGeomConstraintDelegate instance
    static Mdl0SearchGeomConstraintDelegate&  getInstance();

    //  Method to create the Mdl0SearchGeomConstraintImpl pointer
    static Mdl0SearchGeomConstraintImpl*  createImpl( Mdl0SearchGeomConstraint&  ifObj );

    //  Method to delete the Mdl0SearchGeomConstraintImpl pointer
    static void deleteImpl( Mdl0SearchGeomConstraintImpl*  impl );


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0ProcessCtrlFlagBase(const Mdl0SearchGeomConstraint &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0SourceCriteriaBase(const Mdl0SearchGeomConstraint &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0ProcessCtrlFlagBase(Mdl0SearchGeomConstraint &ifObj,  int value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0SourceCriteriaBase(Mdl0SearchGeomConstraint &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Generates permanent ID/recipe. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param recipe - Permanent ID/recipe
    /// @return - Failure code.
    ///
    int  fnd0GenerateRecipeBase(const Mdl0SearchGeomConstraint &ifObj,  std::string *recipe );



protected:
    //  Pointer to the instance
    static Mdl0SearchGeomConstraintDelegate*  m_pInstance;

    Mdl0SearchGeomConstraintDelegate();
    virtual ~Mdl0SearchGeomConstraintDelegate();
    static void setInstance( Mdl0SearchGeomConstraintDelegate*  instance );


private:
    friend class  ::Teamcenter::AppModel::Mdl0SearchGeomConstraintGenImpl;

};

#include <mdl0model/libmdl0model_undef.h>
#endif  //  TEAMCENTER__APPMODEL__MDL0SEARCHGEOMCONSTRAINTDELEGATE_HXX
