//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0SearchGroup
    Filename:   Mdl0SearchGroup.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0SEARCHGROUP__HXX
#define TEAMCENTER__APPMODEL__MDL0SEARCHGROUP__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0SearchDef.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchGroup;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchGroupImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchGroupDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchGroupDispatch;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchGroupGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDL0MODEL_API  Teamcenter::AppModel::Mdl0SearchGroup
     : public  ::Teamcenter::AppModel::Mdl0SearchDef
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0operator( int &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0searchdefs( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdl0SearchGroup();

    /**
     * Destructor
     */
    virtual ~Mdl0SearchGroup();

private:
    //  Getter method for the Implementation Object
    Mdl0SearchGroupImpl*  getMdl0SearchGroupImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdl0SearchGroupImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdl0SearchGroupImpl*  m_mdl0searchgroupImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdl0SearchGroup - desc for Mdl0SearchGroup parameter
     */
    Mdl0SearchGroup( const Mdl0SearchGroup& );
    Mdl0SearchGroup& operator=( const Mdl0SearchGroup& );

    friend class  Mdl0SearchGroupDelegate;
    friend class  Mdl0SearchGroupDispatch;
    friend class  Mdl0SearchGroupGenImpl;
};

#include <mdl0model/libmdl0model_undef.h>
#endif //   TEAMCENTER__APPMODEL__MDL0SEARCHGROUP__HXX
