//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0SearchGroupDelegate
    Filename:   Mdl0SearchGroupDelegate.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0SEARCHGROUPDELEGATE_HXX
#define TEAMCENTER__APPMODEL__MDL0SEARCHGROUPDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0SearchGroup.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchGroupDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchGroupImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchGroup;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchGroupGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MDL0MODEL_API Teamcenter_alias::AppModel::Mdl0SearchGroupDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mdl0SearchGroupDelegate instance
    static Mdl0SearchGroupDelegate&  getInstance();

    //  Method to create the Mdl0SearchGroupImpl pointer
    static Mdl0SearchGroupImpl*  createImpl( Mdl0SearchGroup&  ifObj );

    //  Method to delete the Mdl0SearchGroupImpl pointer
    static void deleteImpl( Mdl0SearchGroupImpl*  impl );


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0operatorBase(const Mdl0SearchGroup &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0searchdefsBase(const Mdl0SearchGroup &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Generates permanent ID/recipe. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param recipe - Permanent ID/recipe
    /// @return - Failure code.
    ///
    int  fnd0GenerateRecipeBase(const Mdl0SearchGroup &ifObj,  std::string *recipe );



protected:
    //  Pointer to the instance
    static Mdl0SearchGroupDelegate*  m_pInstance;

    Mdl0SearchGroupDelegate();
    virtual ~Mdl0SearchGroupDelegate();
    static void setInstance( Mdl0SearchGroupDelegate*  instance );


private:
    friend class  ::Teamcenter::AppModel::Mdl0SearchGroupGenImpl;

};

#include <mdl0model/libmdl0model_undef.h>
#endif  //  TEAMCENTER__APPMODEL__MDL0SEARCHGROUPDELEGATE_HXX
