//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0SearchOptionSetDelegate
    Filename:   Mdl0SearchOptionSetDelegate.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0SEARCHOPTIONSETDELEGATE_HXX
#define TEAMCENTER__APPMODEL__MDL0SEARCHOPTIONSETDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0SearchOptionSet.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchOptionSetDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchOptionSetImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchOptionSet;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchOptionSetGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MDL0MODEL_API Teamcenter_alias::AppModel::Mdl0SearchOptionSetDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mdl0SearchOptionSetDelegate instance
    static Mdl0SearchOptionSetDelegate&  getInstance();

    //  Method to create the Mdl0SearchOptionSetImpl pointer
    static Mdl0SearchOptionSetImpl*  createImpl( Mdl0SearchOptionSet&  ifObj );

    //  Method to delete the Mdl0SearchOptionSetImpl pointer
    static void deleteImpl( Mdl0SearchOptionSetImpl*  impl );


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0optionNamesBase(const Mdl0SearchOptionSet &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0optionSetBase(const Mdl0SearchOptionSet &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0optionValuesBase(const Mdl0SearchOptionSet &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 10.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0optionNamesBase(Mdl0SearchOptionSet &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0optionSetBase(Mdl0SearchOptionSet &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 10.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0optionValuesBase(Mdl0SearchOptionSet &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// Generates permanent ID/recipe. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param recipe - Permanent ID/recipe
    /// @return - Failure code.
    ///
    int  fnd0GenerateRecipeBase(const Mdl0SearchOptionSet &ifObj,  std::string *recipe );



protected:
    //  Pointer to the instance
    static Mdl0SearchOptionSetDelegate*  m_pInstance;

    Mdl0SearchOptionSetDelegate();
    virtual ~Mdl0SearchOptionSetDelegate();
    static void setInstance( Mdl0SearchOptionSetDelegate*  instance );


private:
    friend class  ::Teamcenter::AppModel::Mdl0SearchOptionSetGenImpl;

};

#include <mdl0model/libmdl0model_undef.h>
#endif  //  TEAMCENTER__APPMODEL__MDL0SEARCHOPTIONSETDELEGATE_HXX
