//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0SearchPlaneZoneDelegate
    Filename:   Mdl0SearchPlaneZoneDelegate.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0SEARCHPLANEZONEDELEGATE_HXX
#define TEAMCENTER__APPMODEL__MDL0SEARCHPLANEZONEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0SearchPlaneZone.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchPlaneZoneDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchPlaneZoneImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchPlaneZone;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchPlaneZoneGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MDL0MODEL_API Teamcenter_alias::AppModel::Mdl0SearchPlaneZoneDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mdl0SearchPlaneZoneDelegate instance
    static Mdl0SearchPlaneZoneDelegate&  getInstance();

    //  Method to create the Mdl0SearchPlaneZoneImpl pointer
    static Mdl0SearchPlaneZoneImpl*  createImpl( Mdl0SearchPlaneZone&  ifObj );

    //  Method to delete the Mdl0SearchPlaneZoneImpl pointer
    static void deleteImpl( Mdl0SearchPlaneZoneImpl*  impl );


    ///
    /// Getter for a Double Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0coordinatesBase(const Mdl0SearchPlaneZone &ifObj,  std::vector< double > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0operatorBase(const Mdl0SearchPlaneZone &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Setter for a Double Array Property
    /// @version Teamcenter 9
    /// @param values - Values to be set for the paramter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0coordinatesBase(Mdl0SearchPlaneZone &ifObj,  const std::vector< double > &values, const std::vector< int > *isNull );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0operatorBase(Mdl0SearchPlaneZone &ifObj,  int value, bool isNull );


    ///
    /// Generates permanent ID/recipe. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param recipe - Permanent ID/recipe
    /// @return - Failure code.
    ///
    int  fnd0GenerateRecipeBase(const Mdl0SearchPlaneZone &ifObj,  std::string *recipe );



protected:
    //  Pointer to the instance
    static Mdl0SearchPlaneZoneDelegate*  m_pInstance;

    Mdl0SearchPlaneZoneDelegate();
    virtual ~Mdl0SearchPlaneZoneDelegate();
    static void setInstance( Mdl0SearchPlaneZoneDelegate*  instance );


private:
    friend class  ::Teamcenter::AppModel::Mdl0SearchPlaneZoneGenImpl;

};

#include <mdl0model/libmdl0model_undef.h>
#endif  //  TEAMCENTER__APPMODEL__MDL0SEARCHPLANEZONEDELEGATE_HXX
