//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0SearchProximityDelegate
    Filename:   Mdl0SearchProximityDelegate.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0SEARCHPROXIMITYDELEGATE_HXX
#define TEAMCENTER__APPMODEL__MDL0SEARCHPROXIMITYDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0SearchProximity.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchProximityDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchProximityImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchProximity;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchProximityGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MDL0MODEL_API Teamcenter_alias::AppModel::Mdl0SearchProximityDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mdl0SearchProximityDelegate instance
    static Mdl0SearchProximityDelegate&  getInstance();

    //  Method to create the Mdl0SearchProximityImpl pointer
    static Mdl0SearchProximityImpl*  createImpl( Mdl0SearchProximity&  ifObj );

    //  Method to delete the Mdl0SearchProximityImpl pointer
    static void deleteImpl( Mdl0SearchProximityImpl*  impl );


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0distanceBase(const Mdl0SearchProximity &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0targetelementBase(const Mdl0SearchProximity &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Double Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0distanceBase(Mdl0SearchProximity &ifObj,  double value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0targetelementBase(Mdl0SearchProximity &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Generates permanent ID/recipe. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param recipe - Permanent ID/recipe
    /// @return - Failure code.
    ///
    int  fnd0GenerateRecipeBase(const Mdl0SearchProximity &ifObj,  std::string *recipe );



protected:
    //  Pointer to the instance
    static Mdl0SearchProximityDelegate*  m_pInstance;

    Mdl0SearchProximityDelegate();
    virtual ~Mdl0SearchProximityDelegate();
    static void setInstance( Mdl0SearchProximityDelegate*  instance );


private:
    friend class  ::Teamcenter::AppModel::Mdl0SearchProximityGenImpl;

};

#include <mdl0model/libmdl0model_undef.h>
#endif  //  TEAMCENTER__APPMODEL__MDL0SEARCHPROXIMITYDELEGATE_HXX
