//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0SearchResultTypeDelegate
    Filename:   Mdl0SearchResultTypeDelegate.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0SEARCHRESULTTYPEDELEGATE_HXX
#define TEAMCENTER__APPMODEL__MDL0SEARCHRESULTTYPEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0SearchResultType.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchResultTypeDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchResultTypeImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchResultType;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchResultTypeGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MDL0MODEL_API Teamcenter_alias::AppModel::Mdl0SearchResultTypeDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mdl0SearchResultTypeDelegate instance
    static Mdl0SearchResultTypeDelegate&  getInstance();

    //  Method to create the Mdl0SearchResultTypeImpl pointer
    static Mdl0SearchResultTypeImpl*  createImpl( Mdl0SearchResultType&  ifObj );

    //  Method to delete the Mdl0SearchResultTypeImpl pointer
    static void deleteImpl( Mdl0SearchResultTypeImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0DomainViewKeyBase(const Mdl0SearchResultType &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0searchTypesBase(const Mdl0SearchResultType &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.5
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0DomainViewKeyBase(Mdl0SearchResultType &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 9
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0searchTypesBase(Mdl0SearchResultType &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// Generates permanent ID/recipe. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param recipe - Permanent ID/recipe
    /// @return - Failure code.
    ///
    int  fnd0GenerateRecipeBase(const Mdl0SearchResultType &ifObj,  std::string *recipe );



protected:
    //  Pointer to the instance
    static Mdl0SearchResultTypeDelegate*  m_pInstance;

    Mdl0SearchResultTypeDelegate();
    virtual ~Mdl0SearchResultTypeDelegate();
    static void setInstance( Mdl0SearchResultTypeDelegate*  instance );


private:
    friend class  ::Teamcenter::AppModel::Mdl0SearchResultTypeGenImpl;

};

#include <mdl0model/libmdl0model_undef.h>
#endif  //  TEAMCENTER__APPMODEL__MDL0SEARCHRESULTTYPEDELEGATE_HXX
