//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0SearchSavedQueryDelegate
    Filename:   Mdl0SearchSavedQueryDelegate.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0SEARCHSAVEDQUERYDELEGATE_HXX
#define TEAMCENTER__APPMODEL__MDL0SEARCHSAVEDQUERYDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0SearchSavedQuery.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchSavedQueryDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchSavedQueryImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchSavedQuery;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchSavedQueryGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MDL0MODEL_API Teamcenter_alias::AppModel::Mdl0SearchSavedQueryDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mdl0SearchSavedQueryDelegate instance
    static Mdl0SearchSavedQueryDelegate&  getInstance();

    //  Method to create the Mdl0SearchSavedQueryImpl pointer
    static Mdl0SearchSavedQueryImpl*  createImpl( Mdl0SearchSavedQuery&  ifObj );

    //  Method to delete the Mdl0SearchSavedQueryImpl pointer
    static void deleteImpl( Mdl0SearchSavedQueryImpl*  impl );


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0entriesBase(const Mdl0SearchSavedQuery &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0queryBase(const Mdl0SearchSavedQuery &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0valuesBase(const Mdl0SearchSavedQuery &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 9
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0entriesBase(Mdl0SearchSavedQuery &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0queryBase(Mdl0SearchSavedQuery &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 9
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0valuesBase(Mdl0SearchSavedQuery &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// Generates permanent ID/recipe. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param recipe - Permanent ID/recipe
    /// @return - Failure code.
    ///
    int  fnd0GenerateRecipeBase(const Mdl0SearchSavedQuery &ifObj,  std::string *recipe );



protected:
    //  Pointer to the instance
    static Mdl0SearchSavedQueryDelegate*  m_pInstance;

    Mdl0SearchSavedQueryDelegate();
    virtual ~Mdl0SearchSavedQueryDelegate();
    static void setInstance( Mdl0SearchSavedQueryDelegate*  instance );


private:
    friend class  ::Teamcenter::AppModel::Mdl0SearchSavedQueryGenImpl;

};

#include <mdl0model/libmdl0model_undef.h>
#endif  //  TEAMCENTER__APPMODEL__MDL0SEARCHSAVEDQUERYDELEGATE_HXX
