//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0SearchSlctContentDelegate
    Filename:   Mdl0SearchSlctContentDelegate.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0SEARCHSLCTCONTENTDELEGATE_HXX
#define TEAMCENTER__APPMODEL__MDL0SEARCHSLCTCONTENTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0SearchSlctContent.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchSlctContentDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchSlctContentImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchSlctContent;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SearchSlctContentGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MDL0MODEL_API Teamcenter_alias::AppModel::Mdl0SearchSlctContentDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mdl0SearchSlctContentDelegate instance
    static Mdl0SearchSlctContentDelegate&  getInstance();

    //  Method to create the Mdl0SearchSlctContentImpl pointer
    static Mdl0SearchSlctContentImpl*  createImpl( Mdl0SearchSlctContent&  ifObj );

    //  Method to delete the Mdl0SearchSlctContentImpl pointer
    static void deleteImpl( Mdl0SearchSlctContentImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0selectedcontentsBase(const Mdl0SearchSlctContent &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0unselectedcontentsBase(const Mdl0SearchSlctContent &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0selectedcontentsBase(Mdl0SearchSlctContent &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0unselectedcontentsBase(Mdl0SearchSlctContent &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Generates permanent ID/recipe. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param recipe - Permanent ID/recipe
    /// @return - Failure code.
    ///
    int  fnd0GenerateRecipeBase(const Mdl0SearchSlctContent &ifObj,  std::string *recipe );



protected:
    //  Pointer to the instance
    static Mdl0SearchSlctContentDelegate*  m_pInstance;

    Mdl0SearchSlctContentDelegate();
    virtual ~Mdl0SearchSlctContentDelegate();
    static void setInstance( Mdl0SearchSlctContentDelegate*  instance );


private:
    friend class  ::Teamcenter::AppModel::Mdl0SearchSlctContentGenImpl;

};

#include <mdl0model/libmdl0model_undef.h>
#endif  //  TEAMCENTER__APPMODEL__MDL0SEARCHSLCTCONTENTDELEGATE_HXX
