//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0SubsetDefaults
    Filename:   Mdl0SubsetDefaults.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0SUBSETDEFAULTS__HXX
#define TEAMCENTER__APPMODEL__MDL0SUBSETDEFAULTS__HXX

#include <string>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0AttributeGroup.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SubsetDefaults;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SubsetDefaultsImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SubsetDefaultsDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SubsetDefaultsDispatch;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SubsetDefaultsGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDL0MODEL_API  Teamcenter::AppModel::Mdl0SubsetDefaults
     : public  ::Teamcenter::AppModel::Mdl0AttributeGroup
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0tgt_effectivity_formula( std::string &value, bool &isNull ) const;

    ///
    /// Getter for Property Display Value
    /// @version Teamcenter 11.2
    /// @param values - Parameter value
    /// @return - Status. 0 if successful
    ///
    int  getMdl0tgt_effectivity_formulaDisplayableValues( std::vector< std::string > &values );

    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0tgt_variant_formula( std::string &value, bool &isNull ) const;

    ///
    /// Getter for Property Display Value
    /// @version Teamcenter 11.2
    /// @param values - Parameter value
    /// @return - Status. 0 if successful
    ///
    int  getMdl0tgt_variant_formulaDisplayableValues( std::vector< std::string > &values );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0tgt_effectivity_formula( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0tgt_variant_formula( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdl0SubsetDefaults();

    /**
     * Destructor
     */
    virtual ~Mdl0SubsetDefaults();

private:
    //  Getter method for the Implementation Object
    Mdl0SubsetDefaultsImpl*  getMdl0SubsetDefaultsImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdl0SubsetDefaultsImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdl0SubsetDefaultsImpl*  m_mdl0subsetdefaultsImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdl0SubsetDefaults - desc for Mdl0SubsetDefaults parameter
     */
    Mdl0SubsetDefaults( const Mdl0SubsetDefaults& );
    Mdl0SubsetDefaults& operator=( const Mdl0SubsetDefaults& );

    friend class  Mdl0SubsetDefaultsDelegate;
    friend class  Mdl0SubsetDefaultsDispatch;
    friend class  Mdl0SubsetDefaultsGenImpl;
};

#include <mdl0model/libmdl0model_undef.h>
#endif //   TEAMCENTER__APPMODEL__MDL0SUBSETDEFAULTS__HXX
