//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0SubsetDefaultsDelegate
    Filename:   Mdl0SubsetDefaultsDelegate.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0SUBSETDEFAULTSDELEGATE_HXX
#define TEAMCENTER__APPMODEL__MDL0SUBSETDEFAULTSDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0SubsetDefaults.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SubsetDefaultsDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SubsetDefaultsImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SubsetDefaults;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SubsetDefaultsGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MDL0MODEL_API Teamcenter_alias::AppModel::Mdl0SubsetDefaultsDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mdl0SubsetDefaultsDelegate instance
    static Mdl0SubsetDefaultsDelegate&  getInstance();

    //  Method to create the Mdl0SubsetDefaultsImpl pointer
    static Mdl0SubsetDefaultsImpl*  createImpl( Mdl0SubsetDefaults&  ifObj );

    //  Method to delete the Mdl0SubsetDefaultsImpl pointer
    static void deleteImpl( Mdl0SubsetDefaultsImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0tgt_effectivity_formulaBase(const Mdl0SubsetDefaults &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for Property Display Value
    /// @version Teamcenter 11.2
    /// @param values - Parameter value
    /// @return - Status. 0 if successful
    ///
    int  getMdl0tgt_effectivity_formulaDisplayableValuesBase(Mdl0SubsetDefaults &ifObj,  std::vector< std::string > &values );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0tgt_variant_formulaBase(const Mdl0SubsetDefaults &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for Property Display Value
    /// @version Teamcenter 11.2
    /// @param values - Parameter value
    /// @return - Status. 0 if successful
    ///
    int  getMdl0tgt_variant_formulaDisplayableValuesBase(Mdl0SubsetDefaults &ifObj,  std::vector< std::string > &values );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0tgt_effectivity_formulaBase(Mdl0SubsetDefaults &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0tgt_variant_formulaBase(Mdl0SubsetDefaults &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static Mdl0SubsetDefaultsDelegate*  m_pInstance;

    Mdl0SubsetDefaultsDelegate();
    virtual ~Mdl0SubsetDefaultsDelegate();
    static void setInstance( Mdl0SubsetDefaultsDelegate*  instance );


private:
    friend class  ::Teamcenter::AppModel::Mdl0SubsetDefaultsGenImpl;

};

#include <mdl0model/libmdl0model_undef.h>
#endif  //  TEAMCENTER__APPMODEL__MDL0SUBSETDEFAULTSDELEGATE_HXX
