//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0SubsetDefinition
    Filename:   Mdl0SubsetDefinition.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0SUBSETDEFINITION__HXX
#define TEAMCENTER__APPMODEL__MDL0SUBSETDEFINITION__HXX

#include <unidefs.h>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <cfm/Fnd0RecipeContainer.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SubsetDefinition;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SubsetDefinitionImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SubsetDefinitionDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SubsetDefinitionDispatch;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SubsetDefinitionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDL0MODEL_API  Teamcenter::AppModel::Mdl0SubsetDefinition
     : public  ::Teamcenter::Fnd0RecipeContainer
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0ConfiguredModel( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0model_object( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0pending_AttachAttrGroup( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0model_object( const tag_t &value, bool isNull=false );

    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 10
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0pending_AttachAttrGroup( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdl0SubsetDefinition();

    /**
     * Destructor
     */
    virtual ~Mdl0SubsetDefinition();

private:
    //  Getter method for the Implementation Object
    Mdl0SubsetDefinitionImpl*  getMdl0SubsetDefinitionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdl0SubsetDefinitionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdl0SubsetDefinitionImpl*  m_mdl0subsetdefinitionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdl0SubsetDefinition - desc for Mdl0SubsetDefinition parameter
     */
    Mdl0SubsetDefinition( const Mdl0SubsetDefinition& );
    Mdl0SubsetDefinition& operator=( const Mdl0SubsetDefinition& );

    friend class  Mdl0SubsetDefinitionDelegate;
    friend class  Mdl0SubsetDefinitionDispatch;
    friend class  Mdl0SubsetDefinitionGenImpl;
};

#include <mdl0model/libmdl0model_undef.h>
#endif //   TEAMCENTER__APPMODEL__MDL0SUBSETDEFINITION__HXX
