//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0SubsetDefinitionDelegate
    Filename:   Mdl0SubsetDefinitionDelegate.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0SUBSETDEFINITIONDELEGATE_HXX
#define TEAMCENTER__APPMODEL__MDL0SUBSETDEFINITIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0SubsetDefinition.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SubsetDefinitionDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SubsetDefinitionImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SubsetDefinition;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0SubsetDefinitionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MDL0MODEL_API Teamcenter_alias::AppModel::Mdl0SubsetDefinitionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mdl0SubsetDefinitionDelegate instance
    static Mdl0SubsetDefinitionDelegate&  getInstance();

    //  Method to create the Mdl0SubsetDefinitionImpl pointer
    static Mdl0SubsetDefinitionImpl*  createImpl( Mdl0SubsetDefinition&  ifObj );

    //  Method to delete the Mdl0SubsetDefinitionImpl pointer
    static void deleteImpl( Mdl0SubsetDefinitionImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0ConfiguredModelBase(const Mdl0SubsetDefinition &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0model_objectBase(const Mdl0SubsetDefinition &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0pending_AttachAttrGroupBase(const Mdl0SubsetDefinition &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0model_objectBase(Mdl0SubsetDefinition &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 10
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0pending_AttachAttrGroupBase(Mdl0SubsetDefinition &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Mdl0SubsetDefinition &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Mdl0SubsetDefinition &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static Mdl0SubsetDefinitionDelegate*  m_pInstance;

    Mdl0SubsetDefinitionDelegate();
    virtual ~Mdl0SubsetDefinitionDelegate();
    static void setInstance( Mdl0SubsetDefinitionDelegate*  instance );


private:
    friend class  ::Teamcenter::AppModel::Mdl0SubsetDefinitionGenImpl;

};

#include <mdl0model/libmdl0model_undef.h>
#endif  //  TEAMCENTER__APPMODEL__MDL0SUBSETDEFINITIONDELEGATE_HXX
