//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0VariantExprBlock
    Filename:   Mdl0VariantExprBlock.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0VARIANTEXPRBLOCK__HXX
#define TEAMCENTER__APPMODEL__MDL0VARIANTEXPRBLOCK__HXX

#include <common/tc_deprecation_macros.h>
#include <fnd0booleansolve/Fnd0VariantExprBlock.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0VariantExprBlock;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0VariantExprBlockImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0VariantExprBlockDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0VariantExprBlockDispatch;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0VariantExprBlockGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDL0MODEL_API  Teamcenter::AppModel::Mdl0VariantExprBlock
     : public  ::Teamcenter::Fnd0VariantExprBlock
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdl0VariantExprBlock();

    /**
     * Destructor
     */
    virtual ~Mdl0VariantExprBlock();

private:
    //  Getter method for the Implementation Object
    Mdl0VariantExprBlockImpl*  getMdl0VariantExprBlockImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdl0VariantExprBlockImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdl0VariantExprBlockImpl*  m_mdl0variantexprblockImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdl0VariantExprBlock - desc for Mdl0VariantExprBlock parameter
     */
    Mdl0VariantExprBlock( const Mdl0VariantExprBlock& );
    Mdl0VariantExprBlock& operator=( const Mdl0VariantExprBlock& );

    friend class  Mdl0VariantExprBlockDelegate;
    friend class  Mdl0VariantExprBlockDispatch;
    friend class  Mdl0VariantExprBlockGenImpl;
};

#include <mdl0model/libmdl0model_undef.h>
#endif //   TEAMCENTER__APPMODEL__MDL0VARIANTEXPRBLOCK__HXX
