//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0VariationInModelDelegate
    Filename:   Mdl0VariationInModelDelegate.hxx
    Module:     mdl0model
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0VARIATIONINMODELDELEGATE_HXX
#define TEAMCENTER__APPMODEL__MDL0VARIATIONINMODELDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0VariationInModel.hxx>

#include <mdl0model/libmdl0model_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0VariationInModelDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0VariationInModelImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0VariationInModel;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0VariationInModelGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MDL0MODEL_API Teamcenter_alias::AppModel::Mdl0VariationInModelDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mdl0VariationInModelDelegate instance
    static Mdl0VariationInModelDelegate&  getInstance();

    //  Method to create the Mdl0VariationInModelImpl pointer
    static Mdl0VariationInModelImpl*  createImpl( Mdl0VariationInModel&  ifObj );

    //  Method to delete the Mdl0VariationInModelImpl pointer
    static void deleteImpl( Mdl0VariationInModelImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0configurator_URLBase(const Mdl0VariationInModel &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0descriptionBase(const Mdl0VariationInModel &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0modelBase(const Mdl0VariationInModel &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0nameBase(const Mdl0VariationInModel &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0product_nameBase(const Mdl0VariationInModel &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0product_namespaceBase(const Mdl0VariationInModel &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0configurator_URLBase(Mdl0VariationInModel &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0descriptionBase(Mdl0VariationInModel &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0modelBase(Mdl0VariationInModel &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0nameBase(Mdl0VariationInModel &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static Mdl0VariationInModelDelegate*  m_pInstance;

    Mdl0VariationInModelDelegate();
    virtual ~Mdl0VariationInModelDelegate();
    static void setInstance( Mdl0VariationInModelDelegate*  instance );


private:
    friend class  ::Teamcenter::AppModel::Mdl0VariationInModelGenImpl;

};

#include <mdl0model/libmdl0model_undef.h>
#endif  //  TEAMCENTER__APPMODEL__MDL0VARIATIONINMODELDELEGATE_HXX
