//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0DefaultGeometry
    Filename:   Mdl0DefaultGeometry.hxx
    Module:     mdl0modelgeometry
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0DEFAULTGEOMETRY__HXX
#define TEAMCENTER__APPMODEL__MDL0DEFAULTGEOMETRY__HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0modelgeometry/Mdl0PositionedGeometry.hxx>

#include <mdl0modelgeometry/libmdl0modelgeometry_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0DefaultGeometry;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0DefaultGeometryImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0DefaultGeometryDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0DefaultGeometryDispatch;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0DefaultGeometryGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDL0MODELGEOMETRY_API  Teamcenter::AppModel::Mdl0DefaultGeometry
     : public  ::Teamcenter::AppModel::Mdl0PositionedGeometry
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdl0DefaultGeometry();

    /**
     * Destructor
     */
    virtual ~Mdl0DefaultGeometry();

private:
    //  Getter method for the Implementation Object
    Mdl0DefaultGeometryImpl*  getMdl0DefaultGeometryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdl0DefaultGeometryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdl0DefaultGeometryImpl*  m_mdl0defaultgeometryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdl0DefaultGeometry - desc for Mdl0DefaultGeometry parameter
     */
    Mdl0DefaultGeometry( const Mdl0DefaultGeometry& );
    Mdl0DefaultGeometry& operator=( const Mdl0DefaultGeometry& );

    friend class  Mdl0DefaultGeometryDelegate;
    friend class  Mdl0DefaultGeometryDispatch;
    friend class  Mdl0DefaultGeometryGenImpl;
};

#include <mdl0modelgeometry/libmdl0modelgeometry_undef.h>
#endif //   TEAMCENTER__APPMODEL__MDL0DEFAULTGEOMETRY__HXX
