//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0GeomCnstrntCollection
    Filename:   Mdl0GeomCnstrntCollection.hxx
    Module:     mdl0modelgeometry
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0GEOMCNSTRNTCOLLECTION__HXX
#define TEAMCENTER__APPMODEL__MDL0GEOMCNSTRNTCOLLECTION__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0ModelElement.hxx>

#include <mdl0modelgeometry/libmdl0modelgeometry_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0GeomCnstrntCollection;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0GeomCnstrntCollectionImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0GeomCnstrntCollectionDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0GeomCnstrntCollectionDispatch;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0GeomCnstrntCollectionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDL0MODELGEOMETRY_API  Teamcenter::AppModel::Mdl0GeomCnstrntCollection
     : public  ::Teamcenter::AppModel::Mdl0ModelElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0BackgroundMembers( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0ForegroundMembers( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0TotalBackgroundMembers( int &value, bool &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0TotalForegroundMembers( int &value, bool &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0TotStubbedBackgroundMem( int &value, bool &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0TotStubbedForegroundMem( int &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdl0GeomCnstrntCollection();

    /**
     * Destructor
     */
    virtual ~Mdl0GeomCnstrntCollection();

private:
    //  Getter method for the Implementation Object
    Mdl0GeomCnstrntCollectionImpl*  getMdl0GeomCnstrntCollectionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdl0GeomCnstrntCollectionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdl0GeomCnstrntCollectionImpl*  m_mdl0geomcnstrntcollectionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdl0GeomCnstrntCollection - desc for Mdl0GeomCnstrntCollection parameter
     */
    Mdl0GeomCnstrntCollection( const Mdl0GeomCnstrntCollection& );
    Mdl0GeomCnstrntCollection& operator=( const Mdl0GeomCnstrntCollection& );

    friend class  Mdl0GeomCnstrntCollectionDelegate;
    friend class  Mdl0GeomCnstrntCollectionDispatch;
    friend class  Mdl0GeomCnstrntCollectionGenImpl;
};

#include <mdl0modelgeometry/libmdl0modelgeometry_undef.h>
#endif //   TEAMCENTER__APPMODEL__MDL0GEOMCNSTRNTCOLLECTION__HXX
