//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0GeomCnstrntCollectionDelegate
    Filename:   Mdl0GeomCnstrntCollectionDelegate.hxx
    Module:     mdl0modelgeometry
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0GEOMCNSTRNTCOLLECTIONDELEGATE_HXX
#define TEAMCENTER__APPMODEL__MDL0GEOMCNSTRNTCOLLECTIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0modelgeometry/Mdl0GeomCnstrntCollection.hxx>

#include <mdl0modelgeometry/libmdl0modelgeometry_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0GeomCnstrntCollectionDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0GeomCnstrntCollectionImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0GeomCnstrntCollection;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0GeomCnstrntCollectionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MDL0MODELGEOMETRY_API Teamcenter_alias::AppModel::Mdl0GeomCnstrntCollectionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mdl0GeomCnstrntCollectionDelegate instance
    static Mdl0GeomCnstrntCollectionDelegate&  getInstance();

    //  Method to create the Mdl0GeomCnstrntCollectionImpl pointer
    static Mdl0GeomCnstrntCollectionImpl*  createImpl( Mdl0GeomCnstrntCollection&  ifObj );

    //  Method to delete the Mdl0GeomCnstrntCollectionImpl pointer
    static void deleteImpl( Mdl0GeomCnstrntCollectionImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0BackgroundMembersBase(const Mdl0GeomCnstrntCollection &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0ForegroundMembersBase(const Mdl0GeomCnstrntCollection &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0TotalBackgroundMembersBase(const Mdl0GeomCnstrntCollection &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0TotalForegroundMembersBase(const Mdl0GeomCnstrntCollection &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0TotStubbedBackgroundMemBase(const Mdl0GeomCnstrntCollection &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0TotStubbedForegroundMemBase(const Mdl0GeomCnstrntCollection &ifObj,  int &value, bool &isNull ) const;



protected:
    //  Pointer to the instance
    static Mdl0GeomCnstrntCollectionDelegate*  m_pInstance;

    Mdl0GeomCnstrntCollectionDelegate();
    virtual ~Mdl0GeomCnstrntCollectionDelegate();
    static void setInstance( Mdl0GeomCnstrntCollectionDelegate*  instance );


private:
    friend class  ::Teamcenter::AppModel::Mdl0GeomCnstrntCollectionGenImpl;

};

#include <mdl0modelgeometry/libmdl0modelgeometry_undef.h>
#endif  //  TEAMCENTER__APPMODEL__MDL0GEOMCNSTRNTCOLLECTIONDELEGATE_HXX
