//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0GeomConnGroup
    Filename:   Mdl0GeomConnGroup.hxx
    Module:     mdl0modelgeometry
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0GEOMCONNGROUP__HXX
#define TEAMCENTER__APPMODEL__MDL0GEOMCONNGROUP__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0ModelElement.hxx>

#include <mdl0modelgeometry/libmdl0modelgeometry_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0GeomConnGroup;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0GeomConnGroupImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0GeomConnGroupDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0GeomConnGroupDispatch;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0GeomConnGroupGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDL0MODELGEOMETRY_API  Teamcenter::AppModel::Mdl0GeomConnGroup
     : public  ::Teamcenter::AppModel::Mdl0ModelElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0GroupLinks( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdl0GeomConnGroup();

    /**
     * Destructor
     */
    virtual ~Mdl0GeomConnGroup();

private:
    //  Getter method for the Implementation Object
    Mdl0GeomConnGroupImpl*  getMdl0GeomConnGroupImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdl0GeomConnGroupImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdl0GeomConnGroupImpl*  m_mdl0geomconngroupImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdl0GeomConnGroup - desc for Mdl0GeomConnGroup parameter
     */
    Mdl0GeomConnGroup( const Mdl0GeomConnGroup& );
    Mdl0GeomConnGroup& operator=( const Mdl0GeomConnGroup& );

    friend class  Mdl0GeomConnGroupDelegate;
    friend class  Mdl0GeomConnGroupDispatch;
    friend class  Mdl0GeomConnGroupGenImpl;
};

#include <mdl0modelgeometry/libmdl0modelgeometry_undef.h>
#endif //   TEAMCENTER__APPMODEL__MDL0GEOMCONNGROUP__HXX
