//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0GeomLink
    Filename:   Mdl0GeomLink.hxx
    Module:     mdl0modelgeometry
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0GEOMLINK__HXX
#define TEAMCENTER__APPMODEL__MDL0GEOMLINK__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <mdl0modelgeometry/libmdl0modelgeometry_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0GeomLink;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0GeomLinkImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0GeomLinkDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0GeomLinkDispatch;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0GeomLinkGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDL0MODELGEOMETRY_API  Teamcenter::AppModel::Mdl0GeomLink
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0GeomGroups( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0ValidationStatus( bool &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdl0GeomLink();

    /**
     * Destructor
     */
    virtual ~Mdl0GeomLink();

private:
    //  Getter method for the Implementation Object
    Mdl0GeomLinkImpl*  getMdl0GeomLinkImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdl0GeomLinkImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdl0GeomLinkImpl*  m_mdl0geomlinkImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdl0GeomLink - desc for Mdl0GeomLink parameter
     */
    Mdl0GeomLink( const Mdl0GeomLink& );
    Mdl0GeomLink& operator=( const Mdl0GeomLink& );

    friend class  Mdl0GeomLinkDelegate;
    friend class  Mdl0GeomLinkDispatch;
    friend class  Mdl0GeomLinkGenImpl;
};

#include <mdl0modelgeometry/libmdl0modelgeometry_undef.h>
#endif //   TEAMCENTER__APPMODEL__MDL0GEOMLINK__HXX
