//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0GeomLinkDelegate
    Filename:   Mdl0GeomLinkDelegate.hxx
    Module:     mdl0modelgeometry
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0GEOMLINKDELEGATE_HXX
#define TEAMCENTER__APPMODEL__MDL0GEOMLINKDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0modelgeometry/Mdl0GeomLink.hxx>

#include <mdl0modelgeometry/libmdl0modelgeometry_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0GeomLinkDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0GeomLinkImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0GeomLink;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0GeomLinkGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MDL0MODELGEOMETRY_API Teamcenter_alias::AppModel::Mdl0GeomLinkDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mdl0GeomLinkDelegate instance
    static Mdl0GeomLinkDelegate&  getInstance();

    //  Method to create the Mdl0GeomLinkImpl pointer
    static Mdl0GeomLinkImpl*  createImpl( Mdl0GeomLink&  ifObj );

    //  Method to delete the Mdl0GeomLinkImpl pointer
    static void deleteImpl( Mdl0GeomLinkImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0GeomGroupsBase(const Mdl0GeomLink &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0ValidationStatusBase(const Mdl0GeomLink &ifObj,  bool &value, bool &isNull ) const;



protected:
    //  Pointer to the instance
    static Mdl0GeomLinkDelegate*  m_pInstance;

    Mdl0GeomLinkDelegate();
    virtual ~Mdl0GeomLinkDelegate();
    static void setInstance( Mdl0GeomLinkDelegate*  instance );


private:
    friend class  ::Teamcenter::AppModel::Mdl0GeomLinkGenImpl;

};

#include <mdl0modelgeometry/libmdl0modelgeometry_undef.h>
#endif  //  TEAMCENTER__APPMODEL__MDL0GEOMLINKDELEGATE_HXX
