//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0PositionedGeometry
    Filename:   Mdl0PositionedGeometry.hxx
    Module:     mdl0modelgeometry
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0POSITIONEDGEOMETRY__HXX
#define TEAMCENTER__APPMODEL__MDL0POSITIONEDGEOMETRY__HXX

#include <vector>
#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0ModelArtifact.hxx>

#include <mdl0modelgeometry/libmdl0modelgeometry_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0PositionedGeometry;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0PositionedGeometryImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0PositionedGeometryDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0PositionedGeometryDispatch;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0PositionedGeometryGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDL0MODELGEOMETRY_API  Teamcenter::AppModel::Mdl0PositionedGeometry
     : public  ::Teamcenter::AppModel::Mdl0ModelArtifact
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Double Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0absolute_transform( std::vector< double > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a Double Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0bounding_box( std::vector< double > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0GeomLinks( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0jt_file( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Date Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0position_lmd( date_t &value, bool &isNull ) const;

    ///
    /// Getter for a Date Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0shape_lmd( date_t &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0ThumbnailDataset( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Double Array Property
    /// @version Teamcenter 9
    /// @param values - Values to be set for the paramter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0absolute_transform( const std::vector< double > &values, const std::vector< int > *isNull=0 );

    ///
    /// Setter for a Double Array Property
    /// @version Teamcenter 9
    /// @param values - Values to be set for the paramter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0bounding_box( const std::vector< double > &values, const std::vector< int > *isNull=0 );

    ///
    /// Setter for a Date Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0position_lmd( const date_t &value, bool isNull=false );

    ///
    /// Setter for a Date Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0shape_lmd( const date_t &value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0ThumbnailDataset( const tag_t &value, bool isNull=false );

    ///
    /// 
    /// @version Teamcenter 11.1
    /// @param isShapeOverridePresent - Boolean indicating shape override value corresponding to position model element.
    /// @return - 
    ///
    int  mdl0CheckShapeOverride( bool *isShapeOverridePresent );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdl0PositionedGeometry();

    /**
     * Destructor
     */
    virtual ~Mdl0PositionedGeometry();

private:
    //  Getter method for the Implementation Object
    Mdl0PositionedGeometryImpl*  getMdl0PositionedGeometryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdl0PositionedGeometryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdl0PositionedGeometryImpl*  m_mdl0positionedgeometryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdl0PositionedGeometry - desc for Mdl0PositionedGeometry parameter
     */
    Mdl0PositionedGeometry( const Mdl0PositionedGeometry& );
    Mdl0PositionedGeometry& operator=( const Mdl0PositionedGeometry& );

    friend class  Mdl0PositionedGeometryDelegate;
    friend class  Mdl0PositionedGeometryDispatch;
    friend class  Mdl0PositionedGeometryGenImpl;
};

#include <mdl0modelgeometry/libmdl0modelgeometry_undef.h>
#endif //   TEAMCENTER__APPMODEL__MDL0POSITIONEDGEOMETRY__HXX
