//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0PositionedGeometryDelegate
    Filename:   Mdl0PositionedGeometryDelegate.hxx
    Module:     mdl0modelgeometry
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0POSITIONEDGEOMETRYDELEGATE_HXX
#define TEAMCENTER__APPMODEL__MDL0POSITIONEDGEOMETRYDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0modelgeometry/Mdl0PositionedGeometry.hxx>

#include <mdl0modelgeometry/libmdl0modelgeometry_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0PositionedGeometryDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0PositionedGeometryImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0PositionedGeometry;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0PositionedGeometryGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MDL0MODELGEOMETRY_API Teamcenter_alias::AppModel::Mdl0PositionedGeometryDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mdl0PositionedGeometryDelegate instance
    static Mdl0PositionedGeometryDelegate&  getInstance();

    //  Method to create the Mdl0PositionedGeometryImpl pointer
    static Mdl0PositionedGeometryImpl*  createImpl( Mdl0PositionedGeometry&  ifObj );

    //  Method to delete the Mdl0PositionedGeometryImpl pointer
    static void deleteImpl( Mdl0PositionedGeometryImpl*  impl );


    ///
    /// Getter for a Double Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0absolute_transformBase(const Mdl0PositionedGeometry &ifObj,  std::vector< double > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Double Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0bounding_boxBase(const Mdl0PositionedGeometry &ifObj,  std::vector< double > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0GeomLinksBase(const Mdl0PositionedGeometry &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0jt_fileBase(const Mdl0PositionedGeometry &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Date Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0position_lmdBase(const Mdl0PositionedGeometry &ifObj,  date_t &value, bool &isNull ) const;


    ///
    /// Getter for a Date Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0shape_lmdBase(const Mdl0PositionedGeometry &ifObj,  date_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0ThumbnailDatasetBase(const Mdl0PositionedGeometry &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Double Array Property
    /// @version Teamcenter 9
    /// @param values - Values to be set for the paramter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0absolute_transformBase(Mdl0PositionedGeometry &ifObj,  const std::vector< double > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Double Array Property
    /// @version Teamcenter 9
    /// @param values - Values to be set for the paramter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0bounding_boxBase(Mdl0PositionedGeometry &ifObj,  const std::vector< double > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Date Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0position_lmdBase(Mdl0PositionedGeometry &ifObj,  const date_t &value, bool isNull );


    ///
    /// Setter for a Date Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0shape_lmdBase(Mdl0PositionedGeometry &ifObj,  const date_t &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0ThumbnailDatasetBase(Mdl0PositionedGeometry &ifObj,  const tag_t &value, bool isNull );


    ///
    /// 
    /// @version Teamcenter 11.1
    /// @param isShapeOverridePresent - Boolean indicating shape override value corresponding to position model element.
    /// @return - 
    ///
    int  mdl0CheckShapeOverrideBase(const Mdl0PositionedGeometry &ifObj,  bool *isShapeOverridePresent );



protected:
    //  Pointer to the instance
    static Mdl0PositionedGeometryDelegate*  m_pInstance;

    Mdl0PositionedGeometryDelegate();
    virtual ~Mdl0PositionedGeometryDelegate();
    static void setInstance( Mdl0PositionedGeometryDelegate*  instance );


private:
    friend class  ::Teamcenter::AppModel::Mdl0PositionedGeometryGenImpl;

};

#include <mdl0modelgeometry/libmdl0modelgeometry_undef.h>
#endif  //  TEAMCENTER__APPMODEL__MDL0POSITIONEDGEOMETRYDELEGATE_HXX
