//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0PositionedModelElementDelegate
    Filename:   Mdl0PositionedModelElementDelegate.hxx
    Module:     mdl0modelgeometry
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0POSITIONEDMODELELEMENTDELEGATE_HXX
#define TEAMCENTER__APPMODEL__MDL0POSITIONEDMODELELEMENTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0modelgeometry/Mdl0PositionedModelElement.hxx>

#include <mdl0modelgeometry/libmdl0modelgeometry_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0PositionedModelElementDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0PositionedModelElementImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0PositionedModelElement;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0PositionedModelElementGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MDL0MODELGEOMETRY_API Teamcenter_alias::AppModel::Mdl0PositionedModelElementDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mdl0PositionedModelElementDelegate instance
    static Mdl0PositionedModelElementDelegate&  getInstance();

    //  Method to create the Mdl0PositionedModelElementImpl pointer
    static Mdl0PositionedModelElementImpl*  createImpl( Mdl0PositionedModelElement&  ifObj );

    //  Method to delete the Mdl0PositionedModelElementImpl pointer
    static void deleteImpl( Mdl0PositionedModelElementImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0BackgroundInCollectionsBase(const Mdl0PositionedModelElement &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0ConstrainedInCollectionBase(const Mdl0PositionedModelElement &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0OverrideDatasetBase(const Mdl0PositionedModelElement &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0positioned_geometryBase(const Mdl0PositionedModelElement &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 11.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0BackgroundInCollectionsBase(Mdl0PositionedModelElement &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0ConstrainedInCollectionBase(Mdl0PositionedModelElement &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMdl0positioned_geometryBase(Mdl0PositionedModelElement &ifObj,  const tag_t &value, bool isNull );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Mdl0PositionedModelElement &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0CreatePostBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// post for major revise in CPD
    /// @version Teamcenter 9
    /// @param pReviseInput - saveAs descriptor
    /// @param vecDeepCopyData - list of deep copy datas
    /// @deprecated #Teamcenter::AppModel::Mdl0ConditionalElement::mdl0RevisePost deprecated in Teamcenter 11.2
    /// @return - returns status
    ///
    TC_DEPRECATED_WITH_DEPRECATION_INFO("Teamcenter 11.2","Teamcenter::AppModel::Mdl0ConditionalElement::mdl0RevisePost","This operation is deprecated in Teamcenter 11.2 and will be removed in Teamcenter 13. Please use revisePost operation instead.")
    int  mdl0RevisePostBase(const Mdl0PositionedModelElement &ifObj,  ::Teamcenter::SaveAsInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static Mdl0PositionedModelElementDelegate*  m_pInstance;

    Mdl0PositionedModelElementDelegate();
    virtual ~Mdl0PositionedModelElementDelegate();
    static void setInstance( Mdl0PositionedModelElementDelegate*  instance );


private:
    friend class  ::Teamcenter::AppModel::Mdl0PositionedModelElementGenImpl;

};

#include <mdl0modelgeometry/libmdl0modelgeometry_undef.h>
#endif  //  TEAMCENTER__APPMODEL__MDL0POSITIONEDMODELELEMENTDELEGATE_HXX
