//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0ReferenceGeometry
    Filename:   Mdl0ReferenceGeometry.hxx
    Module:     mdl0modelgeometry
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPMODEL__MDL0REFERENCEGEOMETRY__HXX
#define TEAMCENTER__APPMODEL__MDL0REFERENCEGEOMETRY__HXX

#include <common/tc_deprecation_macros.h>
#include <aps0apscore/Mdl0CopyStableRelation.hxx>

#include <mdl0modelgeometry/libmdl0modelgeometry_exports.h>

namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ReferenceGeometry;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ReferenceGeometryImpl;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ReferenceGeometryDelegate;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ReferenceGeometryDispatch;
    }
}
namespace Teamcenter
{
    namespace AppModel
    {
        class Mdl0ReferenceGeometryGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MDL0MODELGEOMETRY_API  Teamcenter::AppModel::Mdl0ReferenceGeometry
     : public  ::Teamcenter::AppModel::Mdl0CopyStableRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdl0ReferenceGeometry();

    /**
     * Destructor
     */
    virtual ~Mdl0ReferenceGeometry();

private:
    //  Getter method for the Implementation Object
    Mdl0ReferenceGeometryImpl*  getMdl0ReferenceGeometryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdl0ReferenceGeometryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdl0ReferenceGeometryImpl*  m_mdl0referencegeometryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdl0ReferenceGeometry - desc for Mdl0ReferenceGeometry parameter
     */
    Mdl0ReferenceGeometry( const Mdl0ReferenceGeometry& );
    Mdl0ReferenceGeometry& operator=( const Mdl0ReferenceGeometry& );

    friend class  Mdl0ReferenceGeometryDelegate;
    friend class  Mdl0ReferenceGeometryDispatch;
    friend class  Mdl0ReferenceGeometryGenImpl;
};

#include <mdl0modelgeometry/libmdl0modelgeometry_undef.h>
#endif //   TEAMCENTER__APPMODEL__MDL0REFERENCEGEOMETRY__HXX
