//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  mdodispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libmdodispatch

#if !defined(LIBMDODISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBMDODISPATCH is not defined
#endif

/* Handwritten code should use MDODISPATCH_API, not MDODISPATCHEXPORT */

#define MDODISPATCH_API MDODISPATCHEXPORT

#if IPLIB==libmdodispatch || defined(LIBMDODISPATCH)
#   if defined(__lint)
#       define MDODISPATCHEXPORT       __export(mdodispatch)
#       define MDODISPATCHGLOBAL       extern __global(mdodispatch)
#       define MDODISPATCHPRIVATE      extern __private(mdodispatch)
#   elif defined(_WIN32)
#       define MDODISPATCHEXPORT       __declspec(dllexport)
#       define MDODISPATCHGLOBAL       extern __declspec(dllexport)
#       define MDODISPATCHPRIVATE      extern
#   else
#       define MDODISPATCHEXPORT
#       define MDODISPATCHGLOBAL       extern
#       define MDODISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define MDODISPATCHEXPORT       __export(mdodispatch)
#       define MDODISPATCHGLOBAL       extern __global(mdodispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define MDODISPATCHEXPORT      __declspec(dllimport)
#       define MDODISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define MDODISPATCHEXPORT
#       define MDODISPATCHGLOBAL       extern
#   endif
#endif
