//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AppGroupBOPLine
    Filename:   AppGroupBOPLine.hxx
    Module:     me
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPGROUPBOPLINE__HXX
#define TEAMCENTER__APPGROUPBOPLINE__HXX

#include <common/tc_deprecation_macros.h>
#include <me/ImanItemBOPLine.hxx>

#include <me/libme_exports.h>

namespace Teamcenter
{
    class AppGroupBOPLine;
}
namespace Teamcenter
{
    class AppGroupBOPLineImpl;
}
namespace Teamcenter
{
    class AppGroupBOPLineDelegate;
}
namespace Teamcenter
{
    class AppGroupBOPLineDispatch;
}
namespace Teamcenter
{
    class AppGroupBOPLineGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ME_API  Teamcenter::AppGroupBOPLine
     : public  ::Teamcenter::ImanItemBOPLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AppGroupBOPLine();

    /**
     * Destructor
     */
    virtual ~AppGroupBOPLine();

private:
    //  Getter method for the Implementation Object
    AppGroupBOPLineImpl*  getAppGroupBOPLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAppGroupBOPLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AppGroupBOPLineImpl*  m_appgroupboplineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AppGroupBOPLine - desc for AppGroupBOPLine parameter
     */
    AppGroupBOPLine( const AppGroupBOPLine& );
    AppGroupBOPLine& operator=( const AppGroupBOPLine& );

    friend class  AppGroupBOPLineDelegate;
    friend class  AppGroupBOPLineDispatch;
    friend class  AppGroupBOPLineGenImpl;
};

#include <me/libme_undef.h>
#endif //   TEAMCENTER__APPGROUPBOPLINE__HXX
