//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BOPWindow
    Filename:   BOPWindow.hxx
    Module:     me
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOPWINDOW__HXX
#define TEAMCENTER__BOPWINDOW__HXX

#include <common/tc_deprecation_macros.h>
#include <bom/BOMWindow.hxx>

#include <me/libme_exports.h>

namespace Teamcenter
{
    class BOPWindow;
}
namespace Teamcenter
{
    class BOPWindowImpl;
}
namespace Teamcenter
{
    class BOPWindowDelegate;
}
namespace Teamcenter
{
    class BOPWindowDispatch;
}
namespace Teamcenter
{
    class BOPWindowGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ME_API  Teamcenter::BOPWindow
     : public  ::Teamcenter::BOMWindow
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getShow_unconfigured_assignment( bool &value, bool &isNull ) const;

    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setShow_unconfigured_assignment( bool value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    BOPWindow();

    /**
     * Destructor
     */
    virtual ~BOPWindow();

private:
    //  Getter method for the Implementation Object
    BOPWindowImpl*  getBOPWindowImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBOPWindowImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    BOPWindowImpl*  m_bopwindowImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param BOPWindow - desc for BOPWindow parameter
     */
    BOPWindow( const BOPWindow& );
    BOPWindow& operator=( const BOPWindow& );

    friend class  BOPWindowDelegate;
    friend class  BOPWindowDispatch;
    friend class  BOPWindowGenImpl;
};

#include <me/libme_undef.h>
#endif //   TEAMCENTER__BOPWINDOW__HXX
