//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BOPWindowDelegate
    Filename:   BOPWindowDelegate.hxx
    Module:     me
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOPWINDOWDELEGATE_HXX
#define TEAMCENTER__BOPWINDOWDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <me/BOPWindow.hxx>

#include <me/libme_exports.h>

namespace Teamcenter
{
    class BOPWindowDelegate;
}
namespace Teamcenter
{
    class BOPWindowImpl;
}
namespace Teamcenter
{
    class BOPWindow;
}
namespace Teamcenter
{
    class BOPWindowGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  ME_API Teamcenter_alias::BOPWindowDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the BOPWindowDelegate instance
    static BOPWindowDelegate&  getInstance();

    //  Method to create the BOPWindowImpl pointer
    static BOPWindowImpl*  createImpl( BOPWindow&  ifObj );

    //  Method to delete the BOPWindowImpl pointer
    static void deleteImpl( BOPWindowImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getShow_unconfigured_assignmentBase(const BOPWindow &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setShow_unconfigured_assignmentBase(BOPWindow &ifObj,  bool value, bool isNull );



protected:
    //  Pointer to the instance
    static BOPWindowDelegate*  m_pInstance;

    BOPWindowDelegate();
    virtual ~BOPWindowDelegate();
    static void setInstance( BOPWindowDelegate*  instance );


private:
    friend class  ::Teamcenter::BOPWindowGenImpl;

};

#include <me/libme_undef.h>
#endif  //  TEAMCENTER__BOPWINDOWDELEGATE_HXX
