//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BOSLine
    Filename:   BOSLine.hxx
    Module:     me
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOSLINE__HXX
#define TEAMCENTER__BOSLINE__HXX

#include <common/tc_deprecation_macros.h>
#include <me/ImanItemBOPLine.hxx>

#include <me/libme_exports.h>

namespace Teamcenter
{
    class BOSLine;
}
namespace Teamcenter
{
    class BOSLineImpl;
}
namespace Teamcenter
{
    class BOSLineDelegate;
}
namespace Teamcenter
{
    class BOSLineDispatch;
}
namespace Teamcenter
{
    class BOSLineGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ME_API  Teamcenter::BOSLine
     : public  ::Teamcenter::ImanItemBOPLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    BOSLine();

    /**
     * Destructor
     */
    virtual ~BOSLine();

private:
    //  Getter method for the Implementation Object
    BOSLineImpl*  getBOSLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBOSLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    BOSLineImpl*  m_boslineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param BOSLine - desc for BOSLine parameter
     */
    BOSLine( const BOSLine& );
    BOSLine& operator=( const BOSLine& );

    friend class  BOSLineDelegate;
    friend class  BOSLineDispatch;
    friend class  BOSLineGenImpl;
};

#include <me/libme_undef.h>
#endif //   TEAMCENTER__BOSLINE__HXX
