//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BOSWindow
    Filename:   BOSWindow.hxx
    Module:     me
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOSWINDOW__HXX
#define TEAMCENTER__BOSWINDOW__HXX

#include <common/tc_deprecation_macros.h>
#include <me/BOPWindow.hxx>

#include <me/libme_exports.h>

namespace Teamcenter
{
    class BOSWindow;
}
namespace Teamcenter
{
    class BOSWindowImpl;
}
namespace Teamcenter
{
    class BOSWindowDelegate;
}
namespace Teamcenter
{
    class BOSWindowDispatch;
}
namespace Teamcenter
{
    class BOSWindowGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ME_API  Teamcenter::BOSWindow
     : public  ::Teamcenter::BOPWindow
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    BOSWindow();

    /**
     * Destructor
     */
    virtual ~BOSWindow();

private:
    //  Getter method for the Implementation Object
    BOSWindowImpl*  getBOSWindowImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBOSWindowImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    BOSWindowImpl*  m_boswindowImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param BOSWindow - desc for BOSWindow parameter
     */
    BOSWindow( const BOSWindow& );
    BOSWindow& operator=( const BOSWindow& );

    friend class  BOSWindowDelegate;
    friend class  BOSWindowDispatch;
    friend class  BOSWindowGenImpl;
};

#include <me/libme_undef.h>
#endif //   TEAMCENTER__BOSWINDOW__HXX
