//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CfgActivityLine
    Filename:   CfgActivityLine.hxx
    Module:     me
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFGACTIVITYLINE__HXX
#define TEAMCENTER__CFGACTIVITYLINE__HXX

#include <unidefs.h>
#include <string>
#include <common/tc_deprecation_macros.h>
#include <me/CfgAttachmentLine.hxx>

#include <me/libme_exports.h>

namespace Teamcenter
{
    class CfgActivityLine;
}
namespace Teamcenter
{
    class CfgActivityLineImpl;
}
namespace Teamcenter
{
    class CfgActivityLineDelegate;
}
namespace Teamcenter
{
    class CfgActivityLineDispatch;
}
namespace Teamcenter
{
    class CfgActivityLineGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ME_API  Teamcenter::CfgActivityLine
     : public  ::Teamcenter::CfgAttachmentLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAl_activity_oper_bl( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAl_activity_oper_bl( const tag_t &value, bool isNull=false );

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAl_activity_time_system_category( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAl_activity_time_system_frequency( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAl_activity_time_system_unit_time( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAl_activity_time_system_category( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAl_activity_time_system_frequency( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAl_activity_time_system_unit_time( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CfgActivityLine();

    /**
     * Destructor
     */
    virtual ~CfgActivityLine();

private:
    //  Getter method for the Implementation Object
    CfgActivityLineImpl*  getCfgActivityLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfgActivityLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CfgActivityLineImpl*  m_cfgactivitylineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CfgActivityLine - desc for CfgActivityLine parameter
     */
    CfgActivityLine( const CfgActivityLine& );
    CfgActivityLine& operator=( const CfgActivityLine& );

    friend class  CfgActivityLineDelegate;
    friend class  CfgActivityLineDispatch;
    friend class  CfgActivityLineGenImpl;
};

#include <me/libme_undef.h>
#endif //   TEAMCENTER__CFGACTIVITYLINE__HXX
