//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CfgActivityLineDelegate
    Filename:   CfgActivityLineDelegate.hxx
    Module:     me
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFGACTIVITYLINEDELEGATE_HXX
#define TEAMCENTER__CFGACTIVITYLINEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <me/CfgActivityLine.hxx>

#include <me/libme_exports.h>

namespace Teamcenter
{
    class CfgActivityLineDelegate;
}
namespace Teamcenter
{
    class CfgActivityLineImpl;
}
namespace Teamcenter
{
    class CfgActivityLine;
}
namespace Teamcenter
{
    class CfgActivityLineGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  ME_API Teamcenter_alias::CfgActivityLineDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CfgActivityLineDelegate instance
    static CfgActivityLineDelegate&  getInstance();

    //  Method to create the CfgActivityLineImpl pointer
    static CfgActivityLineImpl*  createImpl( CfgActivityLine&  ifObj );

    //  Method to delete the CfgActivityLineImpl pointer
    static void deleteImpl( CfgActivityLineImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAl_activity_oper_blBase(const CfgActivityLine &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAl_activity_oper_blBase(CfgActivityLine &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAl_activity_time_system_categoryBase(const CfgActivityLine &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAl_activity_time_system_frequencyBase(const CfgActivityLine &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAl_activity_time_system_unit_timeBase(const CfgActivityLine &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAl_activity_time_system_categoryBase(CfgActivityLine &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAl_activity_time_system_frequencyBase(CfgActivityLine &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAl_activity_time_system_unit_timeBase(CfgActivityLine &ifObj,  const std::string &value, bool isNull );


    ///
    /// This is the getter for retrieving the recipe/permanent ID if its been created (and cached on the instance). Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param uid - Recipe/permanent ID
    /// @param isFirstTime - If Session Recovery Uid is yet to be set or does the object need to be serialized again?
    /// @return - Failure code
    ///
    int  fnd0AskSRUidBase(const CfgActivityLine &ifObj,  std::string *uid, bool *isFirstTime ) const;


    ///
    /// Generates permanent ID/recipe. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param recipe - Permanent ID/recipe
    /// @return - Failure code.
    ///
    int  fnd0GenerateRecipeBase(const CfgActivityLine &ifObj,  std::string *recipe );


    ///
    /// If Business Object supports recoverable ID. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param isPersistedRecipe - isPersistedRecipe param should be set to true if the recipe is limited to the user session and should be serialized to the database
    /// @param isRecoverableIDSupported - Returning true indicates support for recoverability/permanent IDs
    /// @return - Failure code.
    ///
    int  fnd0IsRecoverableBase(const CfgActivityLine &ifObj,  bool *isPersistedRecipe, bool *isRecoverableIDSupported ) const;


    ///
    /// This is the setter for the recipe/permanent ID when it is created (to be cached on the instance). Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param uid - Rrecipe/permanent ID
    /// @return - Failure code.
    ///
    int  fnd0SetSRUidBase(const CfgActivityLine &ifObj,  const std::string *uid );



protected:
    //  Pointer to the instance
    static CfgActivityLineDelegate*  m_pInstance;

    CfgActivityLineDelegate();
    virtual ~CfgActivityLineDelegate();
    static void setInstance( CfgActivityLineDelegate*  instance );


private:
    friend class  ::Teamcenter::CfgActivityLineGenImpl;

};

#include <me/libme_undef.h>
#endif  //  TEAMCENTER__CFGACTIVITYLINEDELEGATE_HXX
