//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CfgAttachmentLine
    Filename:   CfgAttachmentLine.hxx
    Module:     me
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFGATTACHMENTLINE__HXX
#define TEAMCENTER__CFGATTACHMENTLINE__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <me/MECfgLine.hxx>

#include <me/libme_exports.h>

namespace Teamcenter
{
    class CfgAttachmentLine;
}
namespace Teamcenter
{
    class CfgAttachmentLineImpl;
}
namespace Teamcenter
{
    class CfgAttachmentLineDelegate;
}
namespace Teamcenter
{
    class CfgAttachmentLineDispatch;
}
namespace Teamcenter
{
    class CfgAttachmentLineGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ME_API  Teamcenter::CfgAttachmentLine
     : public  ::Teamcenter::MECfgLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAl_context( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAl_context( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CfgAttachmentLine();

    /**
     * Destructor
     */
    virtual ~CfgAttachmentLine();

private:
    //  Getter method for the Implementation Object
    CfgAttachmentLineImpl*  getCfgAttachmentLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfgAttachmentLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CfgAttachmentLineImpl*  m_cfgattachmentlineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CfgAttachmentLine - desc for CfgAttachmentLine parameter
     */
    CfgAttachmentLine( const CfgAttachmentLine& );
    CfgAttachmentLine& operator=( const CfgAttachmentLine& );

    friend class  CfgAttachmentLineDelegate;
    friend class  CfgAttachmentLineDispatch;
    friend class  CfgAttachmentLineGenImpl;
};

#include <me/libme_undef.h>
#endif //   TEAMCENTER__CFGATTACHMENTLINE__HXX
