//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CfgAttachmentWindow
    Filename:   CfgAttachmentWindow.hxx
    Module:     me
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CFGATTACHMENTWINDOW__HXX
#define TEAMCENTER__CFGATTACHMENTWINDOW__HXX

#include <common/tc_deprecation_macros.h>
#include <me/MECfgWindow.hxx>

#include <me/libme_exports.h>

namespace Teamcenter
{
    class CfgAttachmentWindow;
}
namespace Teamcenter
{
    class CfgAttachmentWindowImpl;
}
namespace Teamcenter
{
    class CfgAttachmentWindowDelegate;
}
namespace Teamcenter
{
    class CfgAttachmentWindowDispatch;
}
namespace Teamcenter
{
    class CfgAttachmentWindowGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ME_API  Teamcenter::CfgAttachmentWindow
     : public  ::Teamcenter::MECfgWindow
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CfgAttachmentWindow();

    /**
     * Destructor
     */
    virtual ~CfgAttachmentWindow();

private:
    //  Getter method for the Implementation Object
    CfgAttachmentWindowImpl*  getCfgAttachmentWindowImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCfgAttachmentWindowImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CfgAttachmentWindowImpl*  m_cfgattachmentwindowImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CfgAttachmentWindow - desc for CfgAttachmentWindow parameter
     */
    CfgAttachmentWindow( const CfgAttachmentWindow& );
    CfgAttachmentWindow& operator=( const CfgAttachmentWindow& );

    friend class  CfgAttachmentWindowDelegate;
    friend class  CfgAttachmentWindowDispatch;
    friend class  CfgAttachmentWindowGenImpl;
};

#include <me/libme_undef.h>
#endif //   TEAMCENTER__CFGATTACHMENTWINDOW__HXX
