//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, GDEBOPLine
    Filename:   GDEBOPLine.hxx
    Module:     me
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__GDEBOPLINE__HXX
#define TEAMCENTER__GDEBOPLINE__HXX

#include <common/tc_deprecation_macros.h>
#include <bom/GDELine.hxx>

#include <me/libme_exports.h>

namespace Teamcenter
{
    class GDEBOPLine;
}
namespace Teamcenter
{
    class GDEBOPLineImpl;
}
namespace Teamcenter
{
    class GDEBOPLineDelegate;
}
namespace Teamcenter
{
    class GDEBOPLineDispatch;
}
namespace Teamcenter
{
    class GDEBOPLineGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ME_API  Teamcenter::GDEBOPLine
     : public  ::Teamcenter::GDELine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    GDEBOPLine();

    /**
     * Destructor
     */
    virtual ~GDEBOPLine();

private:
    //  Getter method for the Implementation Object
    GDEBOPLineImpl*  getGDEBOPLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setGDEBOPLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    GDEBOPLineImpl*  m_gdeboplineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param GDEBOPLine - desc for GDEBOPLine parameter
     */
    GDEBOPLine( const GDEBOPLine& );
    GDEBOPLine& operator=( const GDEBOPLine& );

    friend class  GDEBOPLineDelegate;
    friend class  GDEBOPLineDispatch;
    friend class  GDEBOPLineGenImpl;
};

#include <me/libme_undef.h>
#endif //   TEAMCENTER__GDEBOPLINE__HXX
