//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ImanItemBOPLine
    Filename:   ImanItemBOPLine.hxx
    Module:     me
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IMANITEMBOPLINE__HXX
#define TEAMCENTER__IMANITEMBOPLINE__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <bom/ImanItemLine.hxx>

#include <me/libme_exports.h>

namespace Teamcenter
{
    class ImanItemBOPLine;
}
namespace Teamcenter
{
    class ImanItemBOPLineImpl;
}
namespace Teamcenter
{
    class ImanItemBOPLineDelegate;
}
namespace Teamcenter
{
    class ImanItemBOPLineDispatch;
}
namespace Teamcenter
{
    class ImanItemBOPLineGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ME_API  Teamcenter::ImanItemBOPLine
     : public  ::Teamcenter::ImanItemLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBl_ebop_acc_check_results( int &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBl_me_ref_time_analysis( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0LinkState( int &value, bool &isNull ) const;

    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setBl_ebop_acc_check_results( int value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setBl_me_ref_time_analysis( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ImanItemBOPLine();

    /**
     * Destructor
     */
    virtual ~ImanItemBOPLine();

private:
    //  Getter method for the Implementation Object
    ImanItemBOPLineImpl*  getImanItemBOPLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setImanItemBOPLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ImanItemBOPLineImpl*  m_imanitemboplineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ImanItemBOPLine - desc for ImanItemBOPLine parameter
     */
    ImanItemBOPLine( const ImanItemBOPLine& );
    ImanItemBOPLine& operator=( const ImanItemBOPLine& );

    friend class  ImanItemBOPLineDelegate;
    friend class  ImanItemBOPLineDispatch;
    friend class  ImanItemBOPLineGenImpl;
};

#include <me/libme_undef.h>
#endif //   TEAMCENTER__IMANITEMBOPLINE__HXX
