//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ImanItemBOPLineDelegate
    Filename:   ImanItemBOPLineDelegate.hxx
    Module:     me
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IMANITEMBOPLINEDELEGATE_HXX
#define TEAMCENTER__IMANITEMBOPLINEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <me/ImanItemBOPLine.hxx>

#include <me/libme_exports.h>

namespace Teamcenter
{
    class ImanItemBOPLineDelegate;
}
namespace Teamcenter
{
    class ImanItemBOPLineImpl;
}
namespace Teamcenter
{
    class ImanItemBOPLine;
}
namespace Teamcenter
{
    class ImanItemBOPLineGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  ME_API Teamcenter_alias::ImanItemBOPLineDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ImanItemBOPLineDelegate instance
    static ImanItemBOPLineDelegate&  getInstance();

    //  Method to create the ImanItemBOPLineImpl pointer
    static ImanItemBOPLineImpl*  createImpl( ImanItemBOPLine&  ifObj );

    //  Method to delete the ImanItemBOPLineImpl pointer
    static void deleteImpl( ImanItemBOPLineImpl*  impl );


    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBl_ebop_acc_check_resultsBase(const ImanItemBOPLine &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBl_me_ref_time_analysisBase(const ImanItemBOPLine &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0LinkStateBase(const ImanItemBOPLine &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setBl_ebop_acc_check_resultsBase(ImanItemBOPLine &ifObj,  int value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setBl_me_ref_time_analysisBase(ImanItemBOPLine &ifObj,  const tag_t &value, bool isNull );



protected:
    //  Pointer to the instance
    static ImanItemBOPLineDelegate*  m_pInstance;

    ImanItemBOPLineDelegate();
    virtual ~ImanItemBOPLineDelegate();
    static void setInstance( ImanItemBOPLineDelegate*  instance );


private:
    friend class  ::Teamcenter::ImanItemBOPLineGenImpl;

};

#include <me/libme_undef.h>
#endif  //  TEAMCENTER__IMANITEMBOPLINEDELEGATE_HXX
