//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MEActivity
    Filename:   MEActivity.hxx
    Module:     me
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MEACTIVITY__HXX
#define TEAMCENTER__MEACTIVITY__HXX

#include <common/tc_deprecation_macros.h>
#include <tc/Folder.hxx>

#include <me/libme_exports.h>

namespace Teamcenter
{
    class MEActivity;
}
namespace Teamcenter
{
    class MEActivityImpl;
}
namespace Teamcenter
{
    class MEActivityDelegate;
}
namespace Teamcenter
{
    class MEActivityDispatch;
}
namespace Teamcenter
{
    class MEActivityGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ME_API  Teamcenter::MEActivity
     : public  ::Teamcenter::Folder
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getNc_tool_number( int &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    MEActivity();

    /**
     * Destructor
     */
    virtual ~MEActivity();

private:
    //  Getter method for the Implementation Object
    MEActivityImpl*  getMEActivityImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMEActivityImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    MEActivityImpl*  m_meactivityImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param MEActivity - desc for MEActivity parameter
     */
    MEActivity( const MEActivity& );
    MEActivity& operator=( const MEActivity& );

    friend class  MEActivityDelegate;
    friend class  MEActivityDispatch;
    friend class  MEActivityGenImpl;
};

#include <me/libme_undef.h>
#endif //   TEAMCENTER__MEACTIVITY__HXX
