//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MEActivityDelegate
    Filename:   MEActivityDelegate.hxx
    Module:     me
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MEACTIVITYDELEGATE_HXX
#define TEAMCENTER__MEACTIVITYDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <me/MEActivity.hxx>

#include <me/libme_exports.h>

namespace Teamcenter
{
    class MEActivityDelegate;
}
namespace Teamcenter
{
    class MEActivityImpl;
}
namespace Teamcenter
{
    class MEActivity;
}
namespace Teamcenter
{
    class MEActivityGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  ME_API Teamcenter_alias::MEActivityDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the MEActivityDelegate instance
    static MEActivityDelegate&  getInstance();

    //  Method to create the MEActivityImpl pointer
    static MEActivityImpl*  createImpl( MEActivity&  ifObj );

    //  Method to delete the MEActivityImpl pointer
    static void deleteImpl( MEActivityImpl*  impl );


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getNc_tool_numberBase(const MEActivity &ifObj,  int &value, bool &isNull ) const;


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const MEActivity &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const MEActivity &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const MEActivity &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static MEActivityDelegate*  m_pInstance;

    MEActivityDelegate();
    virtual ~MEActivityDelegate();
    static void setInstance( MEActivityDelegate*  instance );


private:
    friend class  ::Teamcenter::MEActivityGenImpl;

};

#include <me/libme_undef.h>
#endif  //  TEAMCENTER__MEACTIVITYDELEGATE_HXX
