//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MEAppearanceGroupLine
    Filename:   MEAppearanceGroupLine.hxx
    Module:     me
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MEAPPEARANCEGROUPLINE__HXX
#define TEAMCENTER__MEAPPEARANCEGROUPLINE__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <me/MEViewLine.hxx>

#include <me/libme_exports.h>

namespace Teamcenter
{
    class MEAppearanceGroupLine;
}
namespace Teamcenter
{
    class MEAppearanceGroupLineImpl;
}
namespace Teamcenter
{
    class MEAppearanceGroupLineDelegate;
}
namespace Teamcenter
{
    class MEAppearanceGroupLineDispatch;
}
namespace Teamcenter
{
    class MEAppearanceGroupLineGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ME_API  Teamcenter::MEAppearanceGroupLine
     : public  ::Teamcenter::MEViewLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0origin( tag_t &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    MEAppearanceGroupLine();

    /**
     * Destructor
     */
    virtual ~MEAppearanceGroupLine();

private:
    //  Getter method for the Implementation Object
    MEAppearanceGroupLineImpl*  getMEAppearanceGroupLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMEAppearanceGroupLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    MEAppearanceGroupLineImpl*  m_meappearancegrouplineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param MEAppearanceGroupLine - desc for MEAppearanceGroupLine parameter
     */
    MEAppearanceGroupLine( const MEAppearanceGroupLine& );
    MEAppearanceGroupLine& operator=( const MEAppearanceGroupLine& );

    friend class  MEAppearanceGroupLineDelegate;
    friend class  MEAppearanceGroupLineDispatch;
    friend class  MEAppearanceGroupLineGenImpl;
};

#include <me/libme_undef.h>
#endif //   TEAMCENTER__MEAPPEARANCEGROUPLINE__HXX
