//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MEAppearanceLine
    Filename:   MEAppearanceLine.hxx
    Module:     me
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MEAPPEARANCELINE__HXX
#define TEAMCENTER__MEAPPEARANCELINE__HXX

#include <common/tc_deprecation_macros.h>
#include <me/MEViewLine.hxx>

#include <me/libme_exports.h>

namespace Teamcenter
{
    class MEAppearanceLine;
}
namespace Teamcenter
{
    class MEAppearanceLineImpl;
}
namespace Teamcenter
{
    class MEAppearanceLineDelegate;
}
namespace Teamcenter
{
    class MEAppearanceLineDispatch;
}
namespace Teamcenter
{
    class MEAppearanceLineGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ME_API  Teamcenter::MEAppearanceLine
     : public  ::Teamcenter::MEViewLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    MEAppearanceLine();

    /**
     * Destructor
     */
    virtual ~MEAppearanceLine();

private:
    //  Getter method for the Implementation Object
    MEAppearanceLineImpl*  getMEAppearanceLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMEAppearanceLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    MEAppearanceLineImpl*  m_meappearancelineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param MEAppearanceLine - desc for MEAppearanceLine parameter
     */
    MEAppearanceLine( const MEAppearanceLine& );
    MEAppearanceLine& operator=( const MEAppearanceLine& );

    friend class  MEAppearanceLineDelegate;
    friend class  MEAppearanceLineDispatch;
    friend class  MEAppearanceLineGenImpl;
};

#include <me/libme_undef.h>
#endif //   TEAMCENTER__MEAPPEARANCELINE__HXX
