//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MEAssemblyWindow
    Filename:   MEAssemblyWindow.hxx
    Module:     me
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MEASSEMBLYWINDOW__HXX
#define TEAMCENTER__MEASSEMBLYWINDOW__HXX

#include <common/tc_deprecation_macros.h>
#include <me/MECfgWindow.hxx>

#include <me/libme_exports.h>

namespace Teamcenter
{
    class MEAssemblyWindow;
}
namespace Teamcenter
{
    class MEAssemblyWindowImpl;
}
namespace Teamcenter
{
    class MEAssemblyWindowDelegate;
}
namespace Teamcenter
{
    class MEAssemblyWindowDispatch;
}
namespace Teamcenter
{
    class MEAssemblyWindowGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ME_API  Teamcenter::MEAssemblyWindow
     : public  ::Teamcenter::MECfgWindow
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    MEAssemblyWindow();

    /**
     * Destructor
     */
    virtual ~MEAssemblyWindow();

private:
    //  Getter method for the Implementation Object
    MEAssemblyWindowImpl*  getMEAssemblyWindowImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMEAssemblyWindowImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    MEAssemblyWindowImpl*  m_meassemblywindowImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param MEAssemblyWindow - desc for MEAssemblyWindow parameter
     */
    MEAssemblyWindow( const MEAssemblyWindow& );
    MEAssemblyWindow& operator=( const MEAssemblyWindow& );

    friend class  MEAssemblyWindowDelegate;
    friend class  MEAssemblyWindowDispatch;
    friend class  MEAssemblyWindowGenImpl;
};

#include <me/libme_undef.h>
#endif //   TEAMCENTER__MEASSEMBLYWINDOW__HXX
