//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MECfgLine
    Filename:   MECfgLine.hxx
    Module:     me
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MECFGLINE__HXX
#define TEAMCENTER__MECFGLINE__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <me/libme_exports.h>

namespace Teamcenter
{
    class MECfgLine;
}
namespace Teamcenter
{
    class MECfgLineImpl;
}
namespace Teamcenter
{
    class MECfgLineDelegate;
}
namespace Teamcenter
{
    class MECfgLineDispatch;
}
namespace Teamcenter
{
    class MECfgLineGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ME_API  Teamcenter::MECfgLine
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    MECfgLine();

    /**
     * Destructor
     */
    virtual ~MECfgLine();

private:
    //  Getter method for the Implementation Object
    MECfgLineImpl*  getMECfgLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMECfgLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    MECfgLineImpl*  m_mecfglineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param MECfgLine - desc for MECfgLine parameter
     */
    MECfgLine( const MECfgLine& );
    MECfgLine& operator=( const MECfgLine& );

    friend class  MECfgLineDelegate;
    friend class  MECfgLineDispatch;
    friend class  MECfgLineGenImpl;
};

#include <me/libme_undef.h>
#endif //   TEAMCENTER__MECFGLINE__HXX
