//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MECfgWindow
    Filename:   MECfgWindow.hxx
    Module:     me
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MECFGWINDOW__HXX
#define TEAMCENTER__MECFGWINDOW__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <me/libme_exports.h>

namespace Teamcenter
{
    class MECfgWindow;
}
namespace Teamcenter
{
    class MECfgWindowImpl;
}
namespace Teamcenter
{
    class MECfgWindowDelegate;
}
namespace Teamcenter
{
    class MECfgWindowDispatch;
}
namespace Teamcenter
{
    class MECfgWindowGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ME_API  Teamcenter::MECfgWindow
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    MECfgWindow();

    /**
     * Destructor
     */
    virtual ~MECfgWindow();

private:
    //  Getter method for the Implementation Object
    MECfgWindowImpl*  getMECfgWindowImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMECfgWindowImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    MECfgWindowImpl*  m_mecfgwindowImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param MECfgWindow - desc for MECfgWindow parameter
     */
    MECfgWindow( const MECfgWindow& );
    MECfgWindow& operator=( const MECfgWindow& );

    friend class  MECfgWindowDelegate;
    friend class  MECfgWindowDispatch;
    friend class  MECfgWindowGenImpl;
};

#include <me/libme_undef.h>
#endif //   TEAMCENTER__MECFGWINDOW__HXX
