//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MENXObject
    Filename:   MENXObject.hxx
    Module:     me
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MENXOBJECT__HXX
#define TEAMCENTER__MENXOBJECT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccoreext/GeneralDesignElement.hxx>

#include <me/libme_exports.h>

namespace Teamcenter
{
    class MENXObject;
}
namespace Teamcenter
{
    class MENXObjectImpl;
}
namespace Teamcenter
{
    class MENXObjectDelegate;
}
namespace Teamcenter
{
    class MENXObjectDispatch;
}
namespace Teamcenter
{
    class MENXObjectGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ME_API  Teamcenter::MENXObject
     : public  ::Teamcenter::GeneralDesignElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    MENXObject();

    /**
     * Destructor
     */
    virtual ~MENXObject();

private:
    //  Getter method for the Implementation Object
    MENXObjectImpl*  getMENXObjectImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMENXObjectImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    MENXObjectImpl*  m_menxobjectImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param MENXObject - desc for MENXObject parameter
     */
    MENXObject( const MENXObject& );
    MENXObject& operator=( const MENXObject& );

    friend class  MENXObjectDelegate;
    friend class  MENXObjectDispatch;
    friend class  MENXObjectGenImpl;
};

#include <me/libme_undef.h>
#endif //   TEAMCENTER__MENXOBJECT__HXX
