//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MEOP
    Filename:   MEOP.hxx
    Module:     me
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MEOP__HXX
#define TEAMCENTER__MEOP__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <me/libme_exports.h>

namespace Teamcenter
{
    class MEOP;
}
namespace Teamcenter
{
    class MEOPImpl;
}
namespace Teamcenter
{
    class MEOPDelegate;
}
namespace Teamcenter
{
    class MEOPDispatch;
}
namespace Teamcenter
{
    class MEOPGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ME_API  Teamcenter::MEOP
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    MEOP();

    /**
     * Destructor
     */
    virtual ~MEOP();

private:
    //  Getter method for the Implementation Object
    MEOPImpl*  getMEOPImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMEOPImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    MEOPImpl*  m_meopImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param MEOP - desc for MEOP parameter
     */
    MEOP( const MEOP& );
    MEOP& operator=( const MEOP& );

    friend class  MEOPDelegate;
    friend class  MEOPDispatch;
    friend class  MEOPGenImpl;
};

#include <me/libme_undef.h>
#endif //   TEAMCENTER__MEOP__HXX
