//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MEOPDelegate
    Filename:   MEOPDelegate.hxx
    Module:     me
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MEOPDELEGATE_HXX
#define TEAMCENTER__MEOPDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <me/MEOP.hxx>

#include <me/libme_exports.h>

namespace Teamcenter
{
    class MEOPDelegate;
}
namespace Teamcenter
{
    class MEOPImpl;
}
namespace Teamcenter
{
    class MEOP;
}
namespace Teamcenter
{
    class MEOPGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  ME_API Teamcenter_alias::MEOPDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the MEOPDelegate instance
    static MEOPDelegate&  getInstance();

    //  Method to create the MEOPImpl pointer
    static MEOPImpl*  createImpl( MEOP&  ifObj );

    //  Method to delete the MEOPImpl pointer
    static void deleteImpl( MEOPImpl*  impl );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const MEOP &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static MEOPDelegate*  m_pInstance;

    MEOPDelegate();
    virtual ~MEOPDelegate();
    static void setInstance( MEOPDelegate*  instance );


private:
    friend class  ::Teamcenter::MEOPGenImpl;

};

#include <me/libme_undef.h>
#endif  //  TEAMCENTER__MEOPDELEGATE_HXX
