//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MEOPRevision
    Filename:   MEOPRevision.hxx
    Module:     me
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MEOPREVISION__HXX
#define TEAMCENTER__MEOPREVISION__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <me/libme_exports.h>

namespace Teamcenter
{
    class MEOPRevision;
}
namespace Teamcenter
{
    class MEOPRevisionImpl;
}
namespace Teamcenter
{
    class MEOPRevisionDelegate;
}
namespace Teamcenter
{
    class MEOPRevisionDispatch;
}
namespace Teamcenter
{
    class MEOPRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ME_API  Teamcenter::MEOPRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0ExecPositions( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 10.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0ExecPositions( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    MEOPRevision();

    /**
     * Destructor
     */
    virtual ~MEOPRevision();

private:
    //  Getter method for the Implementation Object
    MEOPRevisionImpl*  getMEOPRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMEOPRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    MEOPRevisionImpl*  m_meoprevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param MEOPRevision - desc for MEOPRevision parameter
     */
    MEOPRevision( const MEOPRevision& );
    MEOPRevision& operator=( const MEOPRevision& );

    friend class  MEOPRevisionDelegate;
    friend class  MEOPRevisionDispatch;
    friend class  MEOPRevisionGenImpl;
};

#include <me/libme_undef.h>
#endif //   TEAMCENTER__MEOPREVISION__HXX
