//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MEOPRevisionDelegate
    Filename:   MEOPRevisionDelegate.hxx
    Module:     me
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MEOPREVISIONDELEGATE_HXX
#define TEAMCENTER__MEOPREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <me/MEOPRevision.hxx>

#include <me/libme_exports.h>

namespace Teamcenter
{
    class MEOPRevisionDelegate;
}
namespace Teamcenter
{
    class MEOPRevisionImpl;
}
namespace Teamcenter
{
    class MEOPRevision;
}
namespace Teamcenter
{
    class MEOPRevisionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  ME_API Teamcenter_alias::MEOPRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the MEOPRevisionDelegate instance
    static MEOPRevisionDelegate&  getInstance();

    //  Method to create the MEOPRevisionImpl pointer
    static MEOPRevisionImpl*  createImpl( MEOPRevision&  ifObj );

    //  Method to delete the MEOPRevisionImpl pointer
    static void deleteImpl( MEOPRevisionImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0ExecPositionsBase(const MEOPRevision &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 10.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0ExecPositionsBase(MEOPRevision &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Generic revisePost operation.
    /// @version Teamcenter 10.1
    /// @param pReviseInput - Input ReviseInput object.
    /// @param vecDeepCopyData - Vector of deep copy data.
    /// @return - Returns an integer value.
    ///
    int  revisePostBase(const MEOPRevision &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const MEOPRevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Generic saveAsPost operation.
    /// @version Teamcenter 8.1
    /// @param pSavAsInput - Input argument as SaveAsInput object.
    /// @param vecDeepCopyData - vector deepcopy data
    /// @return - Return integer value.
    ///
    int  saveAsPostBase(const MEOPRevision &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static MEOPRevisionDelegate*  m_pInstance;

    MEOPRevisionDelegate();
    virtual ~MEOPRevisionDelegate();
    static void setInstance( MEOPRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::MEOPRevisionGenImpl;

};

#include <me/libme_undef.h>
#endif  //  TEAMCENTER__MEOPREVISIONDELEGATE_HXX
