//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MEOpTimeAnalysis
    Filename:   MEOpTimeAnalysis.hxx
    Module:     me
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MEOPTIMEANALYSIS__HXX
#define TEAMCENTER__MEOPTIMEANALYSIS__HXX

#include <common/tc_deprecation_macros.h>
#include <form/Form.hxx>

#include <me/libme_exports.h>

namespace Teamcenter
{
    class MEOpTimeAnalysis;
}
namespace Teamcenter
{
    class MEOpTimeAnalysisImpl;
}
namespace Teamcenter
{
    class MEOpTimeAnalysisDelegate;
}
namespace Teamcenter
{
    class MEOpTimeAnalysisDispatch;
}
namespace Teamcenter
{
    class MEOpTimeAnalysisGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ME_API  Teamcenter::MEOpTimeAnalysis
     : public  ::Teamcenter::Form
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Setter for a Double Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setEstimated_time( double value, bool isNull=false );

    ///
    /// Setter for a Double Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSimulated_time( double value, bool isNull=false );

    ///
    /// Setter for a Double Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAllocated_time( double value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    MEOpTimeAnalysis();

    /**
     * Destructor
     */
    virtual ~MEOpTimeAnalysis();

private:
    //  Getter method for the Implementation Object
    MEOpTimeAnalysisImpl*  getMEOpTimeAnalysisImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMEOpTimeAnalysisImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    MEOpTimeAnalysisImpl*  m_meoptimeanalysisImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param MEOpTimeAnalysis - desc for MEOpTimeAnalysis parameter
     */
    MEOpTimeAnalysis( const MEOpTimeAnalysis& );
    MEOpTimeAnalysis& operator=( const MEOpTimeAnalysis& );

    friend class  MEOpTimeAnalysisDelegate;
    friend class  MEOpTimeAnalysisDispatch;
    friend class  MEOpTimeAnalysisGenImpl;
};

#include <me/libme_undef.h>
#endif //   TEAMCENTER__MEOPTIMEANALYSIS__HXX
