//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MEOpTimeAnalysisDelegate
    Filename:   MEOpTimeAnalysisDelegate.hxx
    Module:     me
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MEOPTIMEANALYSISDELEGATE_HXX
#define TEAMCENTER__MEOPTIMEANALYSISDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <me/MEOpTimeAnalysis.hxx>

#include <me/libme_exports.h>

namespace Teamcenter
{
    class MEOpTimeAnalysisDelegate;
}
namespace Teamcenter
{
    class MEOpTimeAnalysisImpl;
}
namespace Teamcenter
{
    class MEOpTimeAnalysis;
}
namespace Teamcenter
{
    class MEOpTimeAnalysisGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  ME_API Teamcenter_alias::MEOpTimeAnalysisDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the MEOpTimeAnalysisDelegate instance
    static MEOpTimeAnalysisDelegate&  getInstance();

    //  Method to create the MEOpTimeAnalysisImpl pointer
    static MEOpTimeAnalysisImpl*  createImpl( MEOpTimeAnalysis&  ifObj );

    //  Method to delete the MEOpTimeAnalysisImpl pointer
    static void deleteImpl( MEOpTimeAnalysisImpl*  impl );


    ///
    /// Setter for a Double Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setEstimated_timeBase(MEOpTimeAnalysis &ifObj,  double value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSimulated_timeBase(MEOpTimeAnalysis &ifObj,  double value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAllocated_timeBase(MEOpTimeAnalysis &ifObj,  double value, bool isNull );



protected:
    //  Pointer to the instance
    static MEOpTimeAnalysisDelegate*  m_pInstance;

    MEOpTimeAnalysisDelegate();
    virtual ~MEOpTimeAnalysisDelegate();
    static void setInstance( MEOpTimeAnalysisDelegate*  instance );


private:
    friend class  ::Teamcenter::MEOpTimeAnalysisGenImpl;

};

#include <me/libme_undef.h>
#endif  //  TEAMCENTER__MEOPTIMEANALYSISDELEGATE_HXX
