//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MEProcess
    Filename:   MEProcess.hxx
    Module:     me
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MEPROCESS__HXX
#define TEAMCENTER__MEPROCESS__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <me/libme_exports.h>

namespace Teamcenter
{
    class MEProcess;
}
namespace Teamcenter
{
    class MEProcessImpl;
}
namespace Teamcenter
{
    class MEProcessDelegate;
}
namespace Teamcenter
{
    class MEProcessDispatch;
}
namespace Teamcenter
{
    class MEProcessGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ME_API  Teamcenter::MEProcess
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    MEProcess();

    /**
     * Destructor
     */
    virtual ~MEProcess();

private:
    //  Getter method for the Implementation Object
    MEProcessImpl*  getMEProcessImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMEProcessImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    MEProcessImpl*  m_meprocessImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param MEProcess - desc for MEProcess parameter
     */
    MEProcess( const MEProcess& );
    MEProcess& operator=( const MEProcess& );

    friend class  MEProcessDelegate;
    friend class  MEProcessDispatch;
    friend class  MEProcessGenImpl;
};

#include <me/libme_undef.h>
#endif //   TEAMCENTER__MEPROCESS__HXX
