//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MEProcessDelegate
    Filename:   MEProcessDelegate.hxx
    Module:     me
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MEPROCESSDELEGATE_HXX
#define TEAMCENTER__MEPROCESSDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <me/MEProcess.hxx>

#include <me/libme_exports.h>

namespace Teamcenter
{
    class MEProcessDelegate;
}
namespace Teamcenter
{
    class MEProcessImpl;
}
namespace Teamcenter
{
    class MEProcess;
}
namespace Teamcenter
{
    class MEProcessGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  ME_API Teamcenter_alias::MEProcessDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the MEProcessDelegate instance
    static MEProcessDelegate&  getInstance();

    //  Method to create the MEProcessImpl pointer
    static MEProcessImpl*  createImpl( MEProcess&  ifObj );

    //  Method to delete the MEProcessImpl pointer
    static void deleteImpl( MEProcessImpl*  impl );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const MEProcess &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static MEProcessDelegate*  m_pInstance;

    MEProcessDelegate();
    virtual ~MEProcessDelegate();
    static void setInstance( MEProcessDelegate*  instance );


private:
    friend class  ::Teamcenter::MEProcessGenImpl;

};

#include <me/libme_undef.h>
#endif  //  TEAMCENTER__MEPROCESSDELEGATE_HXX
