//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MEProcessRevision
    Filename:   MEProcessRevision.hxx
    Module:     me
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MEPROCESSREVISION__HXX
#define TEAMCENTER__MEPROCESSREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <me/libme_exports.h>

namespace Teamcenter
{
    class MEProcessRevision;
}
namespace Teamcenter
{
    class MEProcessRevisionImpl;
}
namespace Teamcenter
{
    class MEProcessRevisionDelegate;
}
namespace Teamcenter
{
    class MEProcessRevisionDispatch;
}
namespace Teamcenter
{
    class MEProcessRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ME_API  Teamcenter::MEProcessRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    MEProcessRevision();

    /**
     * Destructor
     */
    virtual ~MEProcessRevision();

private:
    //  Getter method for the Implementation Object
    MEProcessRevisionImpl*  getMEProcessRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMEProcessRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    MEProcessRevisionImpl*  m_meprocessrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param MEProcessRevision - desc for MEProcessRevision parameter
     */
    MEProcessRevision( const MEProcessRevision& );
    MEProcessRevision& operator=( const MEProcessRevision& );

    friend class  MEProcessRevisionDelegate;
    friend class  MEProcessRevisionDispatch;
    friend class  MEProcessRevisionGenImpl;
};

#include <me/libme_undef.h>
#endif //   TEAMCENTER__MEPROCESSREVISION__HXX
