//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MEProcessRevisionDelegate
    Filename:   MEProcessRevisionDelegate.hxx
    Module:     me
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MEPROCESSREVISIONDELEGATE_HXX
#define TEAMCENTER__MEPROCESSREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <me/MEProcessRevision.hxx>

#include <me/libme_exports.h>

namespace Teamcenter
{
    class MEProcessRevisionDelegate;
}
namespace Teamcenter
{
    class MEProcessRevisionImpl;
}
namespace Teamcenter
{
    class MEProcessRevision;
}
namespace Teamcenter
{
    class MEProcessRevisionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  ME_API Teamcenter_alias::MEProcessRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the MEProcessRevisionDelegate instance
    static MEProcessRevisionDelegate&  getInstance();

    //  Method to create the MEProcessRevisionImpl pointer
    static MEProcessRevisionImpl*  createImpl( MEProcessRevision&  ifObj );

    //  Method to delete the MEProcessRevisionImpl pointer
    static void deleteImpl( MEProcessRevisionImpl*  impl );


    ///
    /// Generic revisePost operation.
    /// @version Teamcenter 10.1
    /// @param pReviseInput - Input ReviseInput object.
    /// @param vecDeepCopyData - Vector of deep copy data.
    /// @return - Returns an integer value.
    ///
    int  revisePostBase(const MEProcessRevision &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const MEProcessRevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Generic saveAsPost operation.
    /// @version Teamcenter 8.1
    /// @param pSavAsInput - Input argument as SaveAsInput object.
    /// @param vecDeepCopyData - vector deepcopy data
    /// @return - Return integer value.
    ///
    int  saveAsPostBase(const MEProcessRevision &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static MEProcessRevisionDelegate*  m_pInstance;

    MEProcessRevisionDelegate();
    virtual ~MEProcessRevisionDelegate();
    static void setInstance( MEProcessRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::MEProcessRevisionGenImpl;

};

#include <me/libme_undef.h>
#endif  //  TEAMCENTER__MEPROCESSREVISIONDELEGATE_HXX
