//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MEProcessTimeAnalysis
    Filename:   MEProcessTimeAnalysis.hxx
    Module:     me
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MEPROCESSTIMEANALYSIS__HXX
#define TEAMCENTER__MEPROCESSTIMEANALYSIS__HXX

#include <common/tc_deprecation_macros.h>
#include <form/Form.hxx>

#include <me/libme_exports.h>

namespace Teamcenter
{
    class MEProcessTimeAnalysis;
}
namespace Teamcenter
{
    class MEProcessTimeAnalysisImpl;
}
namespace Teamcenter
{
    class MEProcessTimeAnalysisDelegate;
}
namespace Teamcenter
{
    class MEProcessTimeAnalysisDispatch;
}
namespace Teamcenter
{
    class MEProcessTimeAnalysisGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ME_API  Teamcenter::MEProcessTimeAnalysis
     : public  ::Teamcenter::Form
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Setter for a Double Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCycle_time( double value, bool isNull=false );

    ///
    /// Setter for a Double Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setEstimated_time( double value, bool isNull=false );

    ///
    /// Setter for a Double Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSimulated_time( double value, bool isNull=false );

    ///
    /// Setter for a Double Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAllocated_time( double value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    MEProcessTimeAnalysis();

    /**
     * Destructor
     */
    virtual ~MEProcessTimeAnalysis();

private:
    //  Getter method for the Implementation Object
    MEProcessTimeAnalysisImpl*  getMEProcessTimeAnalysisImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMEProcessTimeAnalysisImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    MEProcessTimeAnalysisImpl*  m_meprocesstimeanalysisImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param MEProcessTimeAnalysis - desc for MEProcessTimeAnalysis parameter
     */
    MEProcessTimeAnalysis( const MEProcessTimeAnalysis& );
    MEProcessTimeAnalysis& operator=( const MEProcessTimeAnalysis& );

    friend class  MEProcessTimeAnalysisDelegate;
    friend class  MEProcessTimeAnalysisDispatch;
    friend class  MEProcessTimeAnalysisGenImpl;
};

#include <me/libme_undef.h>
#endif //   TEAMCENTER__MEPROCESSTIMEANALYSIS__HXX
