//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MEProcessTimeAnalysisDelegate
    Filename:   MEProcessTimeAnalysisDelegate.hxx
    Module:     me
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MEPROCESSTIMEANALYSISDELEGATE_HXX
#define TEAMCENTER__MEPROCESSTIMEANALYSISDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <me/MEProcessTimeAnalysis.hxx>

#include <me/libme_exports.h>

namespace Teamcenter
{
    class MEProcessTimeAnalysisDelegate;
}
namespace Teamcenter
{
    class MEProcessTimeAnalysisImpl;
}
namespace Teamcenter
{
    class MEProcessTimeAnalysis;
}
namespace Teamcenter
{
    class MEProcessTimeAnalysisGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  ME_API Teamcenter_alias::MEProcessTimeAnalysisDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the MEProcessTimeAnalysisDelegate instance
    static MEProcessTimeAnalysisDelegate&  getInstance();

    //  Method to create the MEProcessTimeAnalysisImpl pointer
    static MEProcessTimeAnalysisImpl*  createImpl( MEProcessTimeAnalysis&  ifObj );

    //  Method to delete the MEProcessTimeAnalysisImpl pointer
    static void deleteImpl( MEProcessTimeAnalysisImpl*  impl );


    ///
    /// Setter for a Double Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCycle_timeBase(MEProcessTimeAnalysis &ifObj,  double value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setEstimated_timeBase(MEProcessTimeAnalysis &ifObj,  double value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSimulated_timeBase(MEProcessTimeAnalysis &ifObj,  double value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAllocated_timeBase(MEProcessTimeAnalysis &ifObj,  double value, bool isNull );



protected:
    //  Pointer to the instance
    static MEProcessTimeAnalysisDelegate*  m_pInstance;

    MEProcessTimeAnalysisDelegate();
    virtual ~MEProcessTimeAnalysisDelegate();
    static void setInstance( MEProcessTimeAnalysisDelegate*  instance );


private:
    friend class  ::Teamcenter::MEProcessTimeAnalysisGenImpl;

};

#include <me/libme_undef.h>
#endif  //  TEAMCENTER__MEPROCESSTIMEANALYSISDELEGATE_HXX
