//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MEViewLine
    Filename:   MEViewLine.hxx
    Module:     me
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MEVIEWLINE__HXX
#define TEAMCENTER__MEVIEWLINE__HXX

#include <common/tc_deprecation_macros.h>
#include <me/MECfgLine.hxx>

#include <me/libme_exports.h>

namespace Teamcenter
{
    class MEViewLine;
}
namespace Teamcenter
{
    class MEViewLineImpl;
}
namespace Teamcenter
{
    class MEViewLineDelegate;
}
namespace Teamcenter
{
    class MEViewLineDispatch;
}
namespace Teamcenter
{
    class MEViewLineGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ME_API  Teamcenter::MEViewLine
     : public  ::Teamcenter::MECfgLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    MEViewLine();

    /**
     * Destructor
     */
    virtual ~MEViewLine();

private:
    //  Getter method for the Implementation Object
    MEViewLineImpl*  getMEViewLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMEViewLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    MEViewLineImpl*  m_meviewlineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param MEViewLine - desc for MEViewLine parameter
     */
    MEViewLine( const MEViewLine& );
    MEViewLine& operator=( const MEViewLine& );

    friend class  MEViewLineDelegate;
    friend class  MEViewLineDispatch;
    friend class  MEViewLineGenImpl;
};

#include <me/libme_undef.h>
#endif //   TEAMCENTER__MEVIEWLINE__HXX
