//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MEWorkarea
    Filename:   MEWorkarea.hxx
    Module:     me
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MEWORKAREA__HXX
#define TEAMCENTER__MEWORKAREA__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <me/libme_exports.h>

namespace Teamcenter
{
    class MEWorkarea;
}
namespace Teamcenter
{
    class MEWorkareaImpl;
}
namespace Teamcenter
{
    class MEWorkareaDelegate;
}
namespace Teamcenter
{
    class MEWorkareaDispatch;
}
namespace Teamcenter
{
    class MEWorkareaGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ME_API  Teamcenter::MEWorkarea
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    MEWorkarea();

    /**
     * Destructor
     */
    virtual ~MEWorkarea();

private:
    //  Getter method for the Implementation Object
    MEWorkareaImpl*  getMEWorkareaImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMEWorkareaImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    MEWorkareaImpl*  m_meworkareaImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param MEWorkarea - desc for MEWorkarea parameter
     */
    MEWorkarea( const MEWorkarea& );
    MEWorkarea& operator=( const MEWorkarea& );

    friend class  MEWorkareaDelegate;
    friend class  MEWorkareaDispatch;
    friend class  MEWorkareaGenImpl;
};

#include <me/libme_undef.h>
#endif //   TEAMCENTER__MEWORKAREA__HXX
