//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MEWorkareaDelegate
    Filename:   MEWorkareaDelegate.hxx
    Module:     me
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MEWORKAREADELEGATE_HXX
#define TEAMCENTER__MEWORKAREADELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <me/MEWorkarea.hxx>

#include <me/libme_exports.h>

namespace Teamcenter
{
    class MEWorkareaDelegate;
}
namespace Teamcenter
{
    class MEWorkareaImpl;
}
namespace Teamcenter
{
    class MEWorkarea;
}
namespace Teamcenter
{
    class MEWorkareaGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  ME_API Teamcenter_alias::MEWorkareaDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the MEWorkareaDelegate instance
    static MEWorkareaDelegate&  getInstance();

    //  Method to create the MEWorkareaImpl pointer
    static MEWorkareaImpl*  createImpl( MEWorkarea&  ifObj );

    //  Method to delete the MEWorkareaImpl pointer
    static void deleteImpl( MEWorkareaImpl*  impl );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const MEWorkarea &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static MEWorkareaDelegate*  m_pInstance;

    MEWorkareaDelegate();
    virtual ~MEWorkareaDelegate();
    static void setInstance( MEWorkareaDelegate*  instance );


private:
    friend class  ::Teamcenter::MEWorkareaGenImpl;

};

#include <me/libme_undef.h>
#endif  //  TEAMCENTER__MEWORKAREADELEGATE_HXX
