//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MEWorkareaRevision
    Filename:   MEWorkareaRevision.hxx
    Module:     me
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MEWORKAREAREVISION__HXX
#define TEAMCENTER__MEWORKAREAREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <me/libme_exports.h>

namespace Teamcenter
{
    class MEWorkareaRevision;
}
namespace Teamcenter
{
    class MEWorkareaRevisionImpl;
}
namespace Teamcenter
{
    class MEWorkareaRevisionDelegate;
}
namespace Teamcenter
{
    class MEWorkareaRevisionDispatch;
}
namespace Teamcenter
{
    class MEWorkareaRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ME_API  Teamcenter::MEWorkareaRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    MEWorkareaRevision();

    /**
     * Destructor
     */
    virtual ~MEWorkareaRevision();

private:
    //  Getter method for the Implementation Object
    MEWorkareaRevisionImpl*  getMEWorkareaRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMEWorkareaRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    MEWorkareaRevisionImpl*  m_meworkarearevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param MEWorkareaRevision - desc for MEWorkareaRevision parameter
     */
    MEWorkareaRevision( const MEWorkareaRevision& );
    MEWorkareaRevision& operator=( const MEWorkareaRevision& );

    friend class  MEWorkareaRevisionDelegate;
    friend class  MEWorkareaRevisionDispatch;
    friend class  MEWorkareaRevisionGenImpl;
};

#include <me/libme_undef.h>
#endif //   TEAMCENTER__MEWORKAREAREVISION__HXX
