//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0MERobot
    Filename:   Mfg0MERobot.hxx
    Module:     me
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0MEROBOT__HXX
#define TEAMCENTER__MFG0MEROBOT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <me/libme_exports.h>

namespace Teamcenter
{
    class Mfg0MERobot;
}
namespace Teamcenter
{
    class Mfg0MERobotImpl;
}
namespace Teamcenter
{
    class Mfg0MERobotDelegate;
}
namespace Teamcenter
{
    class Mfg0MERobotDispatch;
}
namespace Teamcenter
{
    class Mfg0MERobotGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ME_API  Teamcenter::Mfg0MERobot
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0MERobot();

    /**
     * Destructor
     */
    virtual ~Mfg0MERobot();

private:
    //  Getter method for the Implementation Object
    Mfg0MERobotImpl*  getMfg0MERobotImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0MERobotImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0MERobotImpl*  m_mfg0merobotImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0MERobot - desc for Mfg0MERobot parameter
     */
    Mfg0MERobot( const Mfg0MERobot& );
    Mfg0MERobot& operator=( const Mfg0MERobot& );

    friend class  Mfg0MERobotDelegate;
    friend class  Mfg0MERobotDispatch;
    friend class  Mfg0MERobotGenImpl;
};

#include <me/libme_undef.h>
#endif //   TEAMCENTER__MFG0MEROBOT__HXX
