//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0MESensor
    Filename:   Mfg0MESensor.hxx
    Module:     me
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0MESENSOR__HXX
#define TEAMCENTER__MFG0MESENSOR__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <me/libme_exports.h>

namespace Teamcenter
{
    class Mfg0MESensor;
}
namespace Teamcenter
{
    class Mfg0MESensorImpl;
}
namespace Teamcenter
{
    class Mfg0MESensorDelegate;
}
namespace Teamcenter
{
    class Mfg0MESensorDispatch;
}
namespace Teamcenter
{
    class Mfg0MESensorGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ME_API  Teamcenter::Mfg0MESensor
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0MESensor();

    /**
     * Destructor
     */
    virtual ~Mfg0MESensor();

private:
    //  Getter method for the Implementation Object
    Mfg0MESensorImpl*  getMfg0MESensorImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0MESensorImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0MESensorImpl*  m_mfg0mesensorImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0MESensor - desc for Mfg0MESensor parameter
     */
    Mfg0MESensor( const Mfg0MESensor& );
    Mfg0MESensor& operator=( const Mfg0MESensor& );

    friend class  Mfg0MESensorDelegate;
    friend class  Mfg0MESensorDispatch;
    friend class  Mfg0MESensorGenImpl;
};

#include <me/libme_undef.h>
#endif //   TEAMCENTER__MFG0MESENSOR__HXX
