//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TCMPlmXml
    Filename:   TCMPlmXml.hxx
    Module:     me
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TCMPLMXML__HXX
#define TEAMCENTER__TCMPLMXML__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <me/libme_exports.h>

namespace Teamcenter
{
    class TCMPlmXml;
}
namespace Teamcenter
{
    class TCMPlmXmlImpl;
}
namespace Teamcenter
{
    class TCMPlmXmlDelegate;
}
namespace Teamcenter
{
    class TCMPlmXmlDispatch;
}
namespace Teamcenter
{
    class TCMPlmXmlGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  ME_API  Teamcenter::TCMPlmXml
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    TCMPlmXml();

    /**
     * Destructor
     */
    virtual ~TCMPlmXml();

private:
    //  Getter method for the Implementation Object
    TCMPlmXmlImpl*  getTCMPlmXmlImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTCMPlmXmlImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    TCMPlmXmlImpl*  m_tcmplmxmlImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param TCMPlmXml - desc for TCMPlmXml parameter
     */
    TCMPlmXml( const TCMPlmXml& );
    TCMPlmXml& operator=( const TCMPlmXml& );

    friend class  TCMPlmXmlDelegate;
    friend class  TCMPlmXmlDispatch;
    friend class  TCMPlmXmlGenImpl;
};

#include <me/libme_undef.h>
#endif //   TEAMCENTER__TCMPLMXML__HXX
