//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  me

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libme

#if !defined(LIBME) && !defined(IPLIB)
#   error IPLIB or LIBME is not defined
#endif

/* Handwritten code should use ME_API, not MEEXPORT */

#define ME_API MEEXPORT

#if IPLIB==libme || defined(LIBME)
#   if defined(__lint)
#       define MEEXPORT       __export(me)
#       define MEGLOBAL       extern __global(me)
#       define MEPRIVATE      extern __private(me)
#   elif defined(_WIN32)
#       define MEEXPORT       __declspec(dllexport)
#       define MEGLOBAL       extern __declspec(dllexport)
#       define MEPRIVATE      extern
#   else
#       define MEEXPORT
#       define MEGLOBAL       extern
#       define MEPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define MEEXPORT       __export(me)
#       define MEGLOBAL       extern __global(me)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define MEEXPORT      __declspec(dllimport)
#       define MEGLOBAL       extern __declspec(dllimport)
#   else
#       define MEEXPORT
#       define MEGLOBAL       extern
#   endif
#endif
