//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Allocation
    Filename:   Allocation.hxx
    Module:     mechatronics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ALLOCATION__HXX
#define TEAMCENTER__ALLOCATION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ManagedRelation.hxx>

#include <mechatronics/libmechatronics_exports.h>

namespace Teamcenter
{
    class Allocation;
}
namespace Teamcenter
{
    class AllocationImpl;
}
namespace Teamcenter
{
    class AllocationDelegate;
}
namespace Teamcenter
{
    class AllocationDispatch;
}
namespace Teamcenter
{
    class AllocationGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MECHATRONICS_API  Teamcenter::Allocation
     : public  ::Teamcenter::ManagedRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Allocation();

    /**
     * Destructor
     */
    virtual ~Allocation();

private:
    //  Getter method for the Implementation Object
    AllocationImpl*  getAllocationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAllocationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AllocationImpl*  m_allocationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Allocation - desc for Allocation parameter
     */
    Allocation( const Allocation& );
    Allocation& operator=( const Allocation& );

    friend class  AllocationDelegate;
    friend class  AllocationDispatch;
    friend class  AllocationGenImpl;
};

#include <mechatronics/libmechatronics_undef.h>
#endif //   TEAMCENTER__ALLOCATION__HXX
