//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AllocationData
    Filename:   AllocationData.hxx
    Module:     mechatronics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ALLOCATIONDATA__HXX
#define TEAMCENTER__ALLOCATIONDATA__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <mechatronics/libmechatronics_exports.h>

namespace Teamcenter
{
    class AllocationData;
}
namespace Teamcenter
{
    class AllocationDataImpl;
}
namespace Teamcenter
{
    class AllocationDataDelegate;
}
namespace Teamcenter
{
    class AllocationDataDispatch;
}
namespace Teamcenter
{
    class AllocationDataGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MECHATRONICS_API  Teamcenter::AllocationData
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AllocationData();

    /**
     * Destructor
     */
    virtual ~AllocationData();

private:
    //  Getter method for the Implementation Object
    AllocationDataImpl*  getAllocationDataImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAllocationDataImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AllocationDataImpl*  m_allocationdataImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AllocationData - desc for AllocationData parameter
     */
    AllocationData( const AllocationData& );
    AllocationData& operator=( const AllocationData& );

    friend class  AllocationDataDelegate;
    friend class  AllocationDataDispatch;
    friend class  AllocationDataGenImpl;
};

#include <mechatronics/libmechatronics_undef.h>
#endif //   TEAMCENTER__ALLOCATIONDATA__HXX
