//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AllocationLine
    Filename:   AllocationLine.hxx
    Module:     mechatronics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ALLOCATIONLINE__HXX
#define TEAMCENTER__ALLOCATIONLINE__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <mechatronics/libmechatronics_exports.h>

namespace Teamcenter
{
    class AllocationLine;
}
namespace Teamcenter
{
    class AllocationLineImpl;
}
namespace Teamcenter
{
    class AllocationLineDelegate;
}
namespace Teamcenter
{
    class AllocationLineDispatch;
}
namespace Teamcenter
{
    class AllocationLineGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MECHATRONICS_API  Teamcenter::AllocationLine
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AllocationLine();

    /**
     * Destructor
     */
    virtual ~AllocationLine();

private:
    //  Getter method for the Implementation Object
    AllocationLineImpl*  getAllocationLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAllocationLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AllocationLineImpl*  m_allocationlineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AllocationLine - desc for AllocationLine parameter
     */
    AllocationLine( const AllocationLine& );
    AllocationLine& operator=( const AllocationLine& );

    friend class  AllocationLineDelegate;
    friend class  AllocationLineDispatch;
    friend class  AllocationLineGenImpl;
};

#include <mechatronics/libmechatronics_undef.h>
#endif //   TEAMCENTER__ALLOCATIONLINE__HXX
