//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AllocationLineDelegate
    Filename:   AllocationLineDelegate.hxx
    Module:     mechatronics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ALLOCATIONLINEDELEGATE_HXX
#define TEAMCENTER__ALLOCATIONLINEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mechatronics/AllocationLine.hxx>

#include <mechatronics/libmechatronics_exports.h>

namespace Teamcenter
{
    class AllocationLineDelegate;
}
namespace Teamcenter
{
    class AllocationLineImpl;
}
namespace Teamcenter
{
    class AllocationLine;
}
namespace Teamcenter
{
    class AllocationLineGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  MECHATRONICS_API Teamcenter_alias::AllocationLineDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the AllocationLineDelegate instance
    static AllocationLineDelegate&  getInstance();

    //  Method to create the AllocationLineImpl pointer
    static AllocationLineImpl*  createImpl( AllocationLine&  ifObj );

    //  Method to delete the AllocationLineImpl pointer
    static void deleteImpl( AllocationLineImpl*  impl );



protected:
    //  Pointer to the instance
    static AllocationLineDelegate*  m_pInstance;

    AllocationLineDelegate();
    virtual ~AllocationLineDelegate();
    static void setInstance( AllocationLineDelegate*  instance );


private:
    friend class  ::Teamcenter::AllocationLineGenImpl;

};

#include <mechatronics/libmechatronics_undef.h>
#endif  //  TEAMCENTER__ALLOCATIONLINEDELEGATE_HXX
