//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AllocationMap
    Filename:   AllocationMap.hxx
    Module:     mechatronics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ALLOCATIONMAP__HXX
#define TEAMCENTER__ALLOCATIONMAP__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <mechatronics/libmechatronics_exports.h>

namespace Teamcenter
{
    class AllocationMap;
}
namespace Teamcenter
{
    class AllocationMapImpl;
}
namespace Teamcenter
{
    class AllocationMapDelegate;
}
namespace Teamcenter
{
    class AllocationMapDispatch;
}
namespace Teamcenter
{
    class AllocationMapGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MECHATRONICS_API  Teamcenter::AllocationMap
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AllocationMap();

    /**
     * Destructor
     */
    virtual ~AllocationMap();

private:
    //  Getter method for the Implementation Object
    AllocationMapImpl*  getAllocationMapImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAllocationMapImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AllocationMapImpl*  m_allocationmapImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AllocationMap - desc for AllocationMap parameter
     */
    AllocationMap( const AllocationMap& );
    AllocationMap& operator=( const AllocationMap& );

    friend class  AllocationMapDelegate;
    friend class  AllocationMapDispatch;
    friend class  AllocationMapGenImpl;
};

#include <mechatronics/libmechatronics_undef.h>
#endif //   TEAMCENTER__ALLOCATIONMAP__HXX
