//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AllocationMapDelegate
    Filename:   AllocationMapDelegate.hxx
    Module:     mechatronics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ALLOCATIONMAPDELEGATE_HXX
#define TEAMCENTER__ALLOCATIONMAPDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mechatronics/AllocationMap.hxx>

#include <mechatronics/libmechatronics_exports.h>

namespace Teamcenter
{
    class AllocationMapDelegate;
}
namespace Teamcenter
{
    class AllocationMapImpl;
}
namespace Teamcenter
{
    class AllocationMap;
}
namespace Teamcenter
{
    class AllocationMapGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  MECHATRONICS_API Teamcenter_alias::AllocationMapDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the AllocationMapDelegate instance
    static AllocationMapDelegate&  getInstance();

    //  Method to create the AllocationMapImpl pointer
    static AllocationMapImpl*  createImpl( AllocationMap&  ifObj );

    //  Method to delete the AllocationMapImpl pointer
    static void deleteImpl( AllocationMapImpl*  impl );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const AllocationMap &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const AllocationMap &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static AllocationMapDelegate*  m_pInstance;

    AllocationMapDelegate();
    virtual ~AllocationMapDelegate();
    static void setInstance( AllocationMapDelegate*  instance );


private:
    friend class  ::Teamcenter::AllocationMapGenImpl;

};

#include <mechatronics/libmechatronics_undef.h>
#endif  //  TEAMCENTER__ALLOCATIONMAPDELEGATE_HXX
