//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AllocationMapRevision
    Filename:   AllocationMapRevision.hxx
    Module:     mechatronics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ALLOCATIONMAPREVISION__HXX
#define TEAMCENTER__ALLOCATIONMAPREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <mechatronics/libmechatronics_exports.h>

namespace Teamcenter
{
    class AllocationMapRevision;
}
namespace Teamcenter
{
    class AllocationMapRevisionImpl;
}
namespace Teamcenter
{
    class AllocationMapRevisionDelegate;
}
namespace Teamcenter
{
    class AllocationMapRevisionDispatch;
}
namespace Teamcenter
{
    class AllocationMapRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MECHATRONICS_API  Teamcenter::AllocationMapRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AllocationMapRevision();

    /**
     * Destructor
     */
    virtual ~AllocationMapRevision();

private:
    //  Getter method for the Implementation Object
    AllocationMapRevisionImpl*  getAllocationMapRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAllocationMapRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AllocationMapRevisionImpl*  m_allocationmaprevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AllocationMapRevision - desc for AllocationMapRevision parameter
     */
    AllocationMapRevision( const AllocationMapRevision& );
    AllocationMapRevision& operator=( const AllocationMapRevision& );

    friend class  AllocationMapRevisionDelegate;
    friend class  AllocationMapRevisionDispatch;
    friend class  AllocationMapRevisionGenImpl;
};

#include <mechatronics/libmechatronics_undef.h>
#endif //   TEAMCENTER__ALLOCATIONMAPREVISION__HXX
