//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AllocationWindow
    Filename:   AllocationWindow.hxx
    Module:     mechatronics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ALLOCATIONWINDOW__HXX
#define TEAMCENTER__ALLOCATIONWINDOW__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <mechatronics/libmechatronics_exports.h>

namespace Teamcenter
{
    class AllocationWindow;
}
namespace Teamcenter
{
    class AllocationWindowImpl;
}
namespace Teamcenter
{
    class AllocationWindowDelegate;
}
namespace Teamcenter
{
    class AllocationWindowDispatch;
}
namespace Teamcenter
{
    class AllocationWindowGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MECHATRONICS_API  Teamcenter::AllocationWindow
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AllocationWindow();

    /**
     * Destructor
     */
    virtual ~AllocationWindow();

private:
    //  Getter method for the Implementation Object
    AllocationWindowImpl*  getAllocationWindowImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAllocationWindowImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AllocationWindowImpl*  m_allocationwindowImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AllocationWindow - desc for AllocationWindow parameter
     */
    AllocationWindow( const AllocationWindow& );
    AllocationWindow& operator=( const AllocationWindow& );

    friend class  AllocationWindowDelegate;
    friend class  AllocationWindowDispatch;
    friend class  AllocationWindowGenImpl;
};

#include <mechatronics/libmechatronics_undef.h>
#endif //   TEAMCENTER__ALLOCATIONWINDOW__HXX
