//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AllocationWindowDelegate
    Filename:   AllocationWindowDelegate.hxx
    Module:     mechatronics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ALLOCATIONWINDOWDELEGATE_HXX
#define TEAMCENTER__ALLOCATIONWINDOWDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mechatronics/AllocationWindow.hxx>

#include <mechatronics/libmechatronics_exports.h>

namespace Teamcenter
{
    class AllocationWindowDelegate;
}
namespace Teamcenter
{
    class AllocationWindowImpl;
}
namespace Teamcenter
{
    class AllocationWindow;
}
namespace Teamcenter
{
    class AllocationWindowGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  MECHATRONICS_API Teamcenter_alias::AllocationWindowDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the AllocationWindowDelegate instance
    static AllocationWindowDelegate&  getInstance();

    //  Method to create the AllocationWindowImpl pointer
    static AllocationWindowImpl*  createImpl( AllocationWindow&  ifObj );

    //  Method to delete the AllocationWindowImpl pointer
    static void deleteImpl( AllocationWindowImpl*  impl );



protected:
    //  Pointer to the instance
    static AllocationWindowDelegate*  m_pInstance;

    AllocationWindowDelegate();
    virtual ~AllocationWindowDelegate();
    static void setInstance( AllocationWindowDelegate*  instance );


private:
    friend class  ::Teamcenter::AllocationWindowGenImpl;

};

#include <mechatronics/libmechatronics_undef.h>
#endif  //  TEAMCENTER__ALLOCATIONWINDOWDELEGATE_HXX
