//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0PSInstance
    Filename:   Fnd0PSInstance.hxx
    Module:     mechatronics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0PSINSTANCE__HXX
#define TEAMCENTER__FND0PSINSTANCE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <mechatronics/libmechatronics_exports.h>

namespace Teamcenter
{
    class Fnd0PSInstance;
}
namespace Teamcenter
{
    class Fnd0PSInstanceImpl;
}
namespace Teamcenter
{
    class Fnd0PSInstanceDelegate;
}
namespace Teamcenter
{
    class Fnd0PSInstanceDispatch;
}
namespace Teamcenter
{
    class Fnd0PSInstanceGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MECHATRONICS_API  Teamcenter::Fnd0PSInstance
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0PSInstance();

    /**
     * Destructor
     */
    virtual ~Fnd0PSInstance();

private:
    //  Getter method for the Implementation Object
    Fnd0PSInstanceImpl*  getFnd0PSInstanceImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0PSInstanceImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0PSInstanceImpl*  m_fnd0psinstanceImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0PSInstance - desc for Fnd0PSInstance parameter
     */
    Fnd0PSInstance( const Fnd0PSInstance& );
    Fnd0PSInstance& operator=( const Fnd0PSInstance& );

    friend class  Fnd0PSInstanceDelegate;
    friend class  Fnd0PSInstanceDispatch;
    friend class  Fnd0PSInstanceGenImpl;
};

#include <mechatronics/libmechatronics_undef.h>
#endif //   TEAMCENTER__FND0PSINSTANCE__HXX
