//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PSConnection
    Filename:   PSConnection.hxx
    Module:     mechatronics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PSCONNECTION__HXX
#define TEAMCENTER__PSCONNECTION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <mechatronics/libmechatronics_exports.h>

namespace Teamcenter
{
    class PSConnection;
}
namespace Teamcenter
{
    class PSConnectionImpl;
}
namespace Teamcenter
{
    class PSConnectionDelegate;
}
namespace Teamcenter
{
    class PSConnectionDispatch;
}
namespace Teamcenter
{
    class PSConnectionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MECHATRONICS_API  Teamcenter::PSConnection
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PSConnection();

    /**
     * Destructor
     */
    virtual ~PSConnection();

private:
    //  Getter method for the Implementation Object
    PSConnectionImpl*  getPSConnectionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPSConnectionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PSConnectionImpl*  m_psconnectionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PSConnection - desc for PSConnection parameter
     */
    PSConnection( const PSConnection& );
    PSConnection& operator=( const PSConnection& );

    friend class  PSConnectionDelegate;
    friend class  PSConnectionDispatch;
    friend class  PSConnectionGenImpl;
};

#include <mechatronics/libmechatronics_undef.h>
#endif //   TEAMCENTER__PSCONNECTION__HXX
