//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PSConnectionDelegate
    Filename:   PSConnectionDelegate.hxx
    Module:     mechatronics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PSCONNECTIONDELEGATE_HXX
#define TEAMCENTER__PSCONNECTIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mechatronics/PSConnection.hxx>

#include <mechatronics/libmechatronics_exports.h>

namespace Teamcenter
{
    class PSConnectionDelegate;
}
namespace Teamcenter
{
    class PSConnectionImpl;
}
namespace Teamcenter
{
    class PSConnection;
}
namespace Teamcenter
{
    class PSConnectionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  MECHATRONICS_API Teamcenter_alias::PSConnectionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PSConnectionDelegate instance
    static PSConnectionDelegate&  getInstance();

    //  Method to create the PSConnectionImpl pointer
    static PSConnectionImpl*  createImpl( PSConnection&  ifObj );

    //  Method to delete the PSConnectionImpl pointer
    static void deleteImpl( PSConnectionImpl*  impl );



protected:
    //  Pointer to the instance
    static PSConnectionDelegate*  m_pInstance;

    PSConnectionDelegate();
    virtual ~PSConnectionDelegate();
    static void setInstance( PSConnectionDelegate*  instance );


private:
    friend class  ::Teamcenter::PSConnectionGenImpl;

};

#include <mechatronics/libmechatronics_undef.h>
#endif  //  TEAMCENTER__PSCONNECTIONDELEGATE_HXX
