//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PSConnectionRevision
    Filename:   PSConnectionRevision.hxx
    Module:     mechatronics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PSCONNECTIONREVISION__HXX
#define TEAMCENTER__PSCONNECTIONREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <mechatronics/libmechatronics_exports.h>

namespace Teamcenter
{
    class PSConnectionRevision;
}
namespace Teamcenter
{
    class PSConnectionRevisionImpl;
}
namespace Teamcenter
{
    class PSConnectionRevisionDelegate;
}
namespace Teamcenter
{
    class PSConnectionRevisionDispatch;
}
namespace Teamcenter
{
    class PSConnectionRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MECHATRONICS_API  Teamcenter::PSConnectionRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PSConnectionRevision();

    /**
     * Destructor
     */
    virtual ~PSConnectionRevision();

private:
    //  Getter method for the Implementation Object
    PSConnectionRevisionImpl*  getPSConnectionRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPSConnectionRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PSConnectionRevisionImpl*  m_psconnectionrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PSConnectionRevision - desc for PSConnectionRevision parameter
     */
    PSConnectionRevision( const PSConnectionRevision& );
    PSConnectionRevision& operator=( const PSConnectionRevision& );

    friend class  PSConnectionRevisionDelegate;
    friend class  PSConnectionRevisionDispatch;
    friend class  PSConnectionRevisionGenImpl;
};

#include <mechatronics/libmechatronics_undef.h>
#endif //   TEAMCENTER__PSCONNECTIONREVISION__HXX
