//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PSSignal
    Filename:   PSSignal.hxx
    Module:     mechatronics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PSSIGNAL__HXX
#define TEAMCENTER__PSSIGNAL__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <mechatronics/libmechatronics_exports.h>

namespace Teamcenter
{
    class PSSignal;
}
namespace Teamcenter
{
    class PSSignalImpl;
}
namespace Teamcenter
{
    class PSSignalDelegate;
}
namespace Teamcenter
{
    class PSSignalDispatch;
}
namespace Teamcenter
{
    class PSSignalGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MECHATRONICS_API  Teamcenter::PSSignal
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PSSignal();

    /**
     * Destructor
     */
    virtual ~PSSignal();

private:
    //  Getter method for the Implementation Object
    PSSignalImpl*  getPSSignalImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPSSignalImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PSSignalImpl*  m_pssignalImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PSSignal - desc for PSSignal parameter
     */
    PSSignal( const PSSignal& );
    PSSignal& operator=( const PSSignal& );

    friend class  PSSignalDelegate;
    friend class  PSSignalDispatch;
    friend class  PSSignalGenImpl;
};

#include <mechatronics/libmechatronics_undef.h>
#endif //   TEAMCENTER__PSSIGNAL__HXX
