//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PSSignalDelegate
    Filename:   PSSignalDelegate.hxx
    Module:     mechatronics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PSSIGNALDELEGATE_HXX
#define TEAMCENTER__PSSIGNALDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mechatronics/PSSignal.hxx>

#include <mechatronics/libmechatronics_exports.h>

namespace Teamcenter
{
    class PSSignalDelegate;
}
namespace Teamcenter
{
    class PSSignalImpl;
}
namespace Teamcenter
{
    class PSSignal;
}
namespace Teamcenter
{
    class PSSignalGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  MECHATRONICS_API Teamcenter_alias::PSSignalDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PSSignalDelegate instance
    static PSSignalDelegate&  getInstance();

    //  Method to create the PSSignalImpl pointer
    static PSSignalImpl*  createImpl( PSSignal&  ifObj );

    //  Method to delete the PSSignalImpl pointer
    static void deleteImpl( PSSignalImpl*  impl );



protected:
    //  Pointer to the instance
    static PSSignalDelegate*  m_pInstance;

    PSSignalDelegate();
    virtual ~PSSignalDelegate();
    static void setInstance( PSSignalDelegate*  instance );


private:
    friend class  ::Teamcenter::PSSignalGenImpl;

};

#include <mechatronics/libmechatronics_undef.h>
#endif  //  TEAMCENTER__PSSIGNALDELEGATE_HXX
