//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PSSignalRevision
    Filename:   PSSignalRevision.hxx
    Module:     mechatronics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PSSIGNALREVISION__HXX
#define TEAMCENTER__PSSIGNALREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <mechatronics/libmechatronics_exports.h>

namespace Teamcenter
{
    class PSSignalRevision;
}
namespace Teamcenter
{
    class PSSignalRevisionImpl;
}
namespace Teamcenter
{
    class PSSignalRevisionDelegate;
}
namespace Teamcenter
{
    class PSSignalRevisionDispatch;
}
namespace Teamcenter
{
    class PSSignalRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MECHATRONICS_API  Teamcenter::PSSignalRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PSSignalRevision();

    /**
     * Destructor
     */
    virtual ~PSSignalRevision();

private:
    //  Getter method for the Implementation Object
    PSSignalRevisionImpl*  getPSSignalRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPSSignalRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PSSignalRevisionImpl*  m_pssignalrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PSSignalRevision - desc for PSSignalRevision parameter
     */
    PSSignalRevision( const PSSignalRevision& );
    PSSignalRevision& operator=( const PSSignalRevision& );

    friend class  PSSignalRevisionDelegate;
    friend class  PSSignalRevisionDispatch;
    friend class  PSSignalRevisionGenImpl;
};

#include <mechatronics/libmechatronics_undef.h>
#endif //   TEAMCENTER__PSSIGNALREVISION__HXX
