//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PSSignalValue
    Filename:   PSSignalValue.hxx
    Module:     mechatronics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PSSIGNALVALUE__HXX
#define TEAMCENTER__PSSIGNALVALUE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <mechatronics/libmechatronics_exports.h>

namespace Teamcenter
{
    class PSSignalValue;
}
namespace Teamcenter
{
    class PSSignalValueImpl;
}
namespace Teamcenter
{
    class PSSignalValueDelegate;
}
namespace Teamcenter
{
    class PSSignalValueDispatch;
}
namespace Teamcenter
{
    class PSSignalValueGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MECHATRONICS_API  Teamcenter::PSSignalValue
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PSSignalValue();

    /**
     * Destructor
     */
    virtual ~PSSignalValue();

private:
    //  Getter method for the Implementation Object
    PSSignalValueImpl*  getPSSignalValueImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPSSignalValueImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PSSignalValueImpl*  m_pssignalvalueImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PSSignalValue - desc for PSSignalValue parameter
     */
    PSSignalValue( const PSSignalValue& );
    PSSignalValue& operator=( const PSSignalValue& );

    friend class  PSSignalValueDelegate;
    friend class  PSSignalValueDispatch;
    friend class  PSSignalValueGenImpl;
};

#include <mechatronics/libmechatronics_undef.h>
#endif //   TEAMCENTER__PSSIGNALVALUE__HXX
