//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RouteCurve
    Filename:   RouteCurve.hxx
    Module:     mechatronics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ROUTECURVE__HXX
#define TEAMCENTER__ROUTECURVE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <mechatronics/libmechatronics_exports.h>

namespace Teamcenter
{
    class RouteCurve;
}
namespace Teamcenter
{
    class RouteCurveImpl;
}
namespace Teamcenter
{
    class RouteCurveDelegate;
}
namespace Teamcenter
{
    class RouteCurveDispatch;
}
namespace Teamcenter
{
    class RouteCurveGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MECHATRONICS_API  Teamcenter::RouteCurve
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    RouteCurve();

    /**
     * Destructor
     */
    virtual ~RouteCurve();

private:
    //  Getter method for the Implementation Object
    RouteCurveImpl*  getRouteCurveImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRouteCurveImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    RouteCurveImpl*  m_routecurveImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param RouteCurve - desc for RouteCurve parameter
     */
    RouteCurve( const RouteCurve& );
    RouteCurve& operator=( const RouteCurve& );

    friend class  RouteCurveDelegate;
    friend class  RouteCurveDispatch;
    friend class  RouteCurveGenImpl;
};

#include <mechatronics/libmechatronics_undef.h>
#endif //   TEAMCENTER__ROUTECURVE__HXX
