//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RouteDisplay
    Filename:   RouteDisplay.hxx
    Module:     mechatronics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ROUTEDISPLAY__HXX
#define TEAMCENTER__ROUTEDISPLAY__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <mechatronics/libmechatronics_exports.h>

namespace Teamcenter
{
    class RouteDisplay;
}
namespace Teamcenter
{
    class RouteDisplayImpl;
}
namespace Teamcenter
{
    class RouteDisplayDelegate;
}
namespace Teamcenter
{
    class RouteDisplayDispatch;
}
namespace Teamcenter
{
    class RouteDisplayGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MECHATRONICS_API  Teamcenter::RouteDisplay
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    RouteDisplay();

    /**
     * Destructor
     */
    virtual ~RouteDisplay();

private:
    //  Getter method for the Implementation Object
    RouteDisplayImpl*  getRouteDisplayImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRouteDisplayImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    RouteDisplayImpl*  m_routedisplayImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param RouteDisplay - desc for RouteDisplay parameter
     */
    RouteDisplay( const RouteDisplay& );
    RouteDisplay& operator=( const RouteDisplay& );

    friend class  RouteDisplayDelegate;
    friend class  RouteDisplayDispatch;
    friend class  RouteDisplayGenImpl;
};

#include <mechatronics/libmechatronics_undef.h>
#endif //   TEAMCENTER__ROUTEDISPLAY__HXX
