//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RouteDisplayDelegate
    Filename:   RouteDisplayDelegate.hxx
    Module:     mechatronics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ROUTEDISPLAYDELEGATE_HXX
#define TEAMCENTER__ROUTEDISPLAYDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mechatronics/RouteDisplay.hxx>

#include <mechatronics/libmechatronics_exports.h>

namespace Teamcenter
{
    class RouteDisplayDelegate;
}
namespace Teamcenter
{
    class RouteDisplayImpl;
}
namespace Teamcenter
{
    class RouteDisplay;
}
namespace Teamcenter
{
    class RouteDisplayGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  MECHATRONICS_API Teamcenter_alias::RouteDisplayDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the RouteDisplayDelegate instance
    static RouteDisplayDelegate&  getInstance();

    //  Method to create the RouteDisplayImpl pointer
    static RouteDisplayImpl*  createImpl( RouteDisplay&  ifObj );

    //  Method to delete the RouteDisplayImpl pointer
    static void deleteImpl( RouteDisplayImpl*  impl );



protected:
    //  Pointer to the instance
    static RouteDisplayDelegate*  m_pInstance;

    RouteDisplayDelegate();
    virtual ~RouteDisplayDelegate();
    static void setInstance( RouteDisplayDelegate*  instance );


private:
    friend class  ::Teamcenter::RouteDisplayGenImpl;

};

#include <mechatronics/libmechatronics_undef.h>
#endif  //  TEAMCENTER__ROUTEDISPLAYDELEGATE_HXX
