//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RouteLocation
    Filename:   RouteLocation.hxx
    Module:     mechatronics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ROUTELOCATION__HXX
#define TEAMCENTER__ROUTELOCATION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <mechatronics/libmechatronics_exports.h>

namespace Teamcenter
{
    class RouteLocation;
}
namespace Teamcenter
{
    class RouteLocationImpl;
}
namespace Teamcenter
{
    class RouteLocationDelegate;
}
namespace Teamcenter
{
    class RouteLocationDispatch;
}
namespace Teamcenter
{
    class RouteLocationGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MECHATRONICS_API  Teamcenter::RouteLocation
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    RouteLocation();

    /**
     * Destructor
     */
    virtual ~RouteLocation();

private:
    //  Getter method for the Implementation Object
    RouteLocationImpl*  getRouteLocationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRouteLocationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    RouteLocationImpl*  m_routelocationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param RouteLocation - desc for RouteLocation parameter
     */
    RouteLocation( const RouteLocation& );
    RouteLocation& operator=( const RouteLocation& );

    friend class  RouteLocationDelegate;
    friend class  RouteLocationDispatch;
    friend class  RouteLocationGenImpl;
};

#include <mechatronics/libmechatronics_undef.h>
#endif //   TEAMCENTER__ROUTELOCATION__HXX
