//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RouteLocationDelegate
    Filename:   RouteLocationDelegate.hxx
    Module:     mechatronics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ROUTELOCATIONDELEGATE_HXX
#define TEAMCENTER__ROUTELOCATIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mechatronics/RouteLocation.hxx>

#include <mechatronics/libmechatronics_exports.h>

namespace Teamcenter
{
    class RouteLocationDelegate;
}
namespace Teamcenter
{
    class RouteLocationImpl;
}
namespace Teamcenter
{
    class RouteLocation;
}
namespace Teamcenter
{
    class RouteLocationGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  MECHATRONICS_API Teamcenter_alias::RouteLocationDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the RouteLocationDelegate instance
    static RouteLocationDelegate&  getInstance();

    //  Method to create the RouteLocationImpl pointer
    static RouteLocationImpl*  createImpl( RouteLocation&  ifObj );

    //  Method to delete the RouteLocationImpl pointer
    static void deleteImpl( RouteLocationImpl*  impl );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const RouteLocation &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static RouteLocationDelegate*  m_pInstance;

    RouteLocationDelegate();
    virtual ~RouteLocationDelegate();
    static void setInstance( RouteLocationDelegate*  instance );


private:
    friend class  ::Teamcenter::RouteLocationGenImpl;

};

#include <mechatronics/libmechatronics_undef.h>
#endif  //  TEAMCENTER__ROUTELOCATIONDELEGATE_HXX
