//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RouteLocationRevision
    Filename:   RouteLocationRevision.hxx
    Module:     mechatronics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ROUTELOCATIONREVISION__HXX
#define TEAMCENTER__ROUTELOCATIONREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <mechatronics/libmechatronics_exports.h>

namespace Teamcenter
{
    class RouteLocationRevision;
}
namespace Teamcenter
{
    class RouteLocationRevisionImpl;
}
namespace Teamcenter
{
    class RouteLocationRevisionDelegate;
}
namespace Teamcenter
{
    class RouteLocationRevisionDispatch;
}
namespace Teamcenter
{
    class RouteLocationRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MECHATRONICS_API  Teamcenter::RouteLocationRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    RouteLocationRevision();

    /**
     * Destructor
     */
    virtual ~RouteLocationRevision();

private:
    //  Getter method for the Implementation Object
    RouteLocationRevisionImpl*  getRouteLocationRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRouteLocationRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    RouteLocationRevisionImpl*  m_routelocationrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param RouteLocationRevision - desc for RouteLocationRevision parameter
     */
    RouteLocationRevision( const RouteLocationRevision& );
    RouteLocationRevision& operator=( const RouteLocationRevision& );

    friend class  RouteLocationRevisionDelegate;
    friend class  RouteLocationRevisionDispatch;
    friend class  RouteLocationRevisionGenImpl;
};

#include <mechatronics/libmechatronics_undef.h>
#endif //   TEAMCENTER__ROUTELOCATIONREVISION__HXX
