//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RouteLocationRevisionDelegate
    Filename:   RouteLocationRevisionDelegate.hxx
    Module:     mechatronics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ROUTELOCATIONREVISIONDELEGATE_HXX
#define TEAMCENTER__ROUTELOCATIONREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mechatronics/RouteLocationRevision.hxx>

#include <mechatronics/libmechatronics_exports.h>

namespace Teamcenter
{
    class RouteLocationRevisionDelegate;
}
namespace Teamcenter
{
    class RouteLocationRevisionImpl;
}
namespace Teamcenter
{
    class RouteLocationRevision;
}
namespace Teamcenter
{
    class RouteLocationRevisionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  MECHATRONICS_API Teamcenter_alias::RouteLocationRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the RouteLocationRevisionDelegate instance
    static RouteLocationRevisionDelegate&  getInstance();

    //  Method to create the RouteLocationRevisionImpl pointer
    static RouteLocationRevisionImpl*  createImpl( RouteLocationRevision&  ifObj );

    //  Method to delete the RouteLocationRevisionImpl pointer
    static void deleteImpl( RouteLocationRevisionImpl*  impl );



protected:
    //  Pointer to the instance
    static RouteLocationRevisionDelegate*  m_pInstance;

    RouteLocationRevisionDelegate();
    virtual ~RouteLocationRevisionDelegate();
    static void setInstance( RouteLocationRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::RouteLocationRevisionGenImpl;

};

#include <mechatronics/libmechatronics_undef.h>
#endif  //  TEAMCENTER__ROUTELOCATIONREVISIONDELEGATE_HXX
