//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RouteNode
    Filename:   RouteNode.hxx
    Module:     mechatronics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ROUTENODE__HXX
#define TEAMCENTER__ROUTENODE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <mechatronics/libmechatronics_exports.h>

namespace Teamcenter
{
    class RouteNode;
}
namespace Teamcenter
{
    class RouteNodeImpl;
}
namespace Teamcenter
{
    class RouteNodeDelegate;
}
namespace Teamcenter
{
    class RouteNodeDispatch;
}
namespace Teamcenter
{
    class RouteNodeGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MECHATRONICS_API  Teamcenter::RouteNode
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    RouteNode();

    /**
     * Destructor
     */
    virtual ~RouteNode();

private:
    //  Getter method for the Implementation Object
    RouteNodeImpl*  getRouteNodeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRouteNodeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    RouteNodeImpl*  m_routenodeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param RouteNode - desc for RouteNode parameter
     */
    RouteNode( const RouteNode& );
    RouteNode& operator=( const RouteNode& );

    friend class  RouteNodeDelegate;
    friend class  RouteNodeDispatch;
    friend class  RouteNodeGenImpl;
};

#include <mechatronics/libmechatronics_undef.h>
#endif //   TEAMCENTER__ROUTENODE__HXX
