//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RouteNodeDelegate
    Filename:   RouteNodeDelegate.hxx
    Module:     mechatronics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ROUTENODEDELEGATE_HXX
#define TEAMCENTER__ROUTENODEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mechatronics/RouteNode.hxx>

#include <mechatronics/libmechatronics_exports.h>

namespace Teamcenter
{
    class RouteNodeDelegate;
}
namespace Teamcenter
{
    class RouteNodeImpl;
}
namespace Teamcenter
{
    class RouteNode;
}
namespace Teamcenter
{
    class RouteNodeGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  MECHATRONICS_API Teamcenter_alias::RouteNodeDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the RouteNodeDelegate instance
    static RouteNodeDelegate&  getInstance();

    //  Method to create the RouteNodeImpl pointer
    static RouteNodeImpl*  createImpl( RouteNode&  ifObj );

    //  Method to delete the RouteNodeImpl pointer
    static void deleteImpl( RouteNodeImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @param isLockForDelete - A boolean to indicate if object(s) are to be locked for deletion
    /// @param allowRelock - A boolean to indicate if object(s) can be relocked, which will discard all unsaved changes, if already locked by the same user
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0LockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd, const bool isLockForDelete, const bool allowRelock );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0RefreshBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0UnlockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const RouteNode &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static RouteNodeDelegate*  m_pInstance;

    RouteNodeDelegate();
    virtual ~RouteNodeDelegate();
    static void setInstance( RouteNodeDelegate*  instance );


private:
    friend class  ::Teamcenter::RouteNodeGenImpl;

};

#include <mechatronics/libmechatronics_undef.h>
#endif  //  TEAMCENTER__ROUTENODEDELEGATE_HXX
