//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RoutePath
    Filename:   RoutePath.hxx
    Module:     mechatronics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ROUTEPATH__HXX
#define TEAMCENTER__ROUTEPATH__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <mechatronics/libmechatronics_exports.h>

namespace Teamcenter
{
    class RoutePath;
}
namespace Teamcenter
{
    class RoutePathImpl;
}
namespace Teamcenter
{
    class RoutePathDelegate;
}
namespace Teamcenter
{
    class RoutePathDispatch;
}
namespace Teamcenter
{
    class RoutePathGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MECHATRONICS_API  Teamcenter::RoutePath
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    RoutePath();

    /**
     * Destructor
     */
    virtual ~RoutePath();

private:
    //  Getter method for the Implementation Object
    RoutePathImpl*  getRoutePathImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRoutePathImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    RoutePathImpl*  m_routepathImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param RoutePath - desc for RoutePath parameter
     */
    RoutePath( const RoutePath& );
    RoutePath& operator=( const RoutePath& );

    friend class  RoutePathDelegate;
    friend class  RoutePathDispatch;
    friend class  RoutePathGenImpl;
};

#include <mechatronics/libmechatronics_undef.h>
#endif //   TEAMCENTER__ROUTEPATH__HXX
