//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RouteSegment
    Filename:   RouteSegment.hxx
    Module:     mechatronics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ROUTESEGMENT__HXX
#define TEAMCENTER__ROUTESEGMENT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <mechatronics/libmechatronics_exports.h>

namespace Teamcenter
{
    class RouteSegment;
}
namespace Teamcenter
{
    class RouteSegmentImpl;
}
namespace Teamcenter
{
    class RouteSegmentDelegate;
}
namespace Teamcenter
{
    class RouteSegmentDispatch;
}
namespace Teamcenter
{
    class RouteSegmentGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MECHATRONICS_API  Teamcenter::RouteSegment
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    RouteSegment();

    /**
     * Destructor
     */
    virtual ~RouteSegment();

private:
    //  Getter method for the Implementation Object
    RouteSegmentImpl*  getRouteSegmentImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRouteSegmentImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    RouteSegmentImpl*  m_routesegmentImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param RouteSegment - desc for RouteSegment parameter
     */
    RouteSegment( const RouteSegment& );
    RouteSegment& operator=( const RouteSegment& );

    friend class  RouteSegmentDelegate;
    friend class  RouteSegmentDispatch;
    friend class  RouteSegmentGenImpl;
};

#include <mechatronics/libmechatronics_undef.h>
#endif //   TEAMCENTER__ROUTESEGMENT__HXX
