//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SCMCompoundElement
    Filename:   SCMCompoundElement.hxx
    Module:     mechatronics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SCMCOMPOUNDELEMENT__HXX
#define TEAMCENTER__SCMCOMPOUNDELEMENT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <mechatronics/libmechatronics_exports.h>

namespace Teamcenter
{
    class SCMCompoundElement;
}
namespace Teamcenter
{
    class SCMCompoundElementImpl;
}
namespace Teamcenter
{
    class SCMCompoundElementDelegate;
}
namespace Teamcenter
{
    class SCMCompoundElementDispatch;
}
namespace Teamcenter
{
    class SCMCompoundElementGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MECHATRONICS_API  Teamcenter::SCMCompoundElement
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SCMCompoundElement();

    /**
     * Destructor
     */
    virtual ~SCMCompoundElement();

private:
    //  Getter method for the Implementation Object
    SCMCompoundElementImpl*  getSCMCompoundElementImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSCMCompoundElementImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SCMCompoundElementImpl*  m_scmcompoundelementImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SCMCompoundElement - desc for SCMCompoundElement parameter
     */
    SCMCompoundElement( const SCMCompoundElement& );
    SCMCompoundElement& operator=( const SCMCompoundElement& );

    friend class  SCMCompoundElementDelegate;
    friend class  SCMCompoundElementDispatch;
    friend class  SCMCompoundElementGenImpl;
};

#include <mechatronics/libmechatronics_undef.h>
#endif //   TEAMCENTER__SCMCOMPOUNDELEMENT__HXX
