//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SCMConfigContext
    Filename:   SCMConfigContext.hxx
    Module:     mechatronics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SCMCONFIGCONTEXT__HXX
#define TEAMCENTER__SCMCONFIGCONTEXT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <mechatronics/libmechatronics_exports.h>

namespace Teamcenter
{
    class SCMConfigContext;
}
namespace Teamcenter
{
    class SCMConfigContextImpl;
}
namespace Teamcenter
{
    class SCMConfigContextDelegate;
}
namespace Teamcenter
{
    class SCMConfigContextDispatch;
}
namespace Teamcenter
{
    class SCMConfigContextGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MECHATRONICS_API  Teamcenter::SCMConfigContext
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SCMConfigContext();

    /**
     * Destructor
     */
    virtual ~SCMConfigContext();

private:
    //  Getter method for the Implementation Object
    SCMConfigContextImpl*  getSCMConfigContextImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSCMConfigContextImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SCMConfigContextImpl*  m_scmconfigcontextImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SCMConfigContext - desc for SCMConfigContext parameter
     */
    SCMConfigContext( const SCMConfigContext& );
    SCMConfigContext& operator=( const SCMConfigContext& );

    friend class  SCMConfigContextDelegate;
    friend class  SCMConfigContextDispatch;
    friend class  SCMConfigContextGenImpl;
};

#include <mechatronics/libmechatronics_undef.h>
#endif //   TEAMCENTER__SCMCONFIGCONTEXT__HXX
