//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SCMConfigContextDelegate
    Filename:   SCMConfigContextDelegate.hxx
    Module:     mechatronics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SCMCONFIGCONTEXTDELEGATE_HXX
#define TEAMCENTER__SCMCONFIGCONTEXTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mechatronics/SCMConfigContext.hxx>

#include <mechatronics/libmechatronics_exports.h>

namespace Teamcenter
{
    class SCMConfigContextDelegate;
}
namespace Teamcenter
{
    class SCMConfigContextImpl;
}
namespace Teamcenter
{
    class SCMConfigContext;
}
namespace Teamcenter
{
    class SCMConfigContextGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  MECHATRONICS_API Teamcenter_alias::SCMConfigContextDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SCMConfigContextDelegate instance
    static SCMConfigContextDelegate&  getInstance();

    //  Method to create the SCMConfigContextImpl pointer
    static SCMConfigContextImpl*  createImpl( SCMConfigContext&  ifObj );

    //  Method to delete the SCMConfigContextImpl pointer
    static void deleteImpl( SCMConfigContextImpl*  impl );



protected:
    //  Pointer to the instance
    static SCMConfigContextDelegate*  m_pInstance;

    SCMConfigContextDelegate();
    virtual ~SCMConfigContextDelegate();
    static void setInstance( SCMConfigContextDelegate*  instance );


private:
    friend class  ::Teamcenter::SCMConfigContextGenImpl;

};

#include <mechatronics/libmechatronics_undef.h>
#endif  //  TEAMCENTER__SCMCONFIGCONTEXTDELEGATE_HXX
