//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SCMElement
    Filename:   SCMElement.hxx
    Module:     mechatronics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SCMELEMENT__HXX
#define TEAMCENTER__SCMELEMENT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <mechatronics/libmechatronics_exports.h>

namespace Teamcenter
{
    class SCMElement;
}
namespace Teamcenter
{
    class SCMElementImpl;
}
namespace Teamcenter
{
    class SCMElementDelegate;
}
namespace Teamcenter
{
    class SCMElementDispatch;
}
namespace Teamcenter
{
    class SCMElementGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MECHATRONICS_API  Teamcenter::SCMElement
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SCMElement();

    /**
     * Destructor
     */
    virtual ~SCMElement();

private:
    //  Getter method for the Implementation Object
    SCMElementImpl*  getSCMElementImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSCMElementImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SCMElementImpl*  m_scmelementImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SCMElement - desc for SCMElement parameter
     */
    SCMElement( const SCMElement& );
    SCMElement& operator=( const SCMElement& );

    friend class  SCMElementDelegate;
    friend class  SCMElementDispatch;
    friend class  SCMElementGenImpl;
};

#include <mechatronics/libmechatronics_undef.h>
#endif //   TEAMCENTER__SCMELEMENT__HXX
