//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SCMElementDelegate
    Filename:   SCMElementDelegate.hxx
    Module:     mechatronics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SCMELEMENTDELEGATE_HXX
#define TEAMCENTER__SCMELEMENTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mechatronics/SCMElement.hxx>

#include <mechatronics/libmechatronics_exports.h>

namespace Teamcenter
{
    class SCMElementDelegate;
}
namespace Teamcenter
{
    class SCMElementImpl;
}
namespace Teamcenter
{
    class SCMElement;
}
namespace Teamcenter
{
    class SCMElementGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  MECHATRONICS_API Teamcenter_alias::SCMElementDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SCMElementDelegate instance
    static SCMElementDelegate&  getInstance();

    //  Method to create the SCMElementImpl pointer
    static SCMElementImpl*  createImpl( SCMElement&  ifObj );

    //  Method to delete the SCMElementImpl pointer
    static void deleteImpl( SCMElementImpl*  impl );



protected:
    //  Pointer to the instance
    static SCMElementDelegate*  m_pInstance;

    SCMElementDelegate();
    virtual ~SCMElementDelegate();
    static void setInstance( SCMElementDelegate*  instance );


private:
    friend class  ::Teamcenter::SCMElementGenImpl;

};

#include <mechatronics/libmechatronics_undef.h>
#endif  //  TEAMCENTER__SCMELEMENTDELEGATE_HXX
