//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SCMServer
    Filename:   SCMServer.hxx
    Module:     mechatronics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SCMSERVER__HXX
#define TEAMCENTER__SCMSERVER__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <mechatronics/libmechatronics_exports.h>

namespace Teamcenter
{
    class SCMServer;
}
namespace Teamcenter
{
    class SCMServerImpl;
}
namespace Teamcenter
{
    class SCMServerDelegate;
}
namespace Teamcenter
{
    class SCMServerDispatch;
}
namespace Teamcenter
{
    class SCMServerGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MECHATRONICS_API  Teamcenter::SCMServer
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SCMServer();

    /**
     * Destructor
     */
    virtual ~SCMServer();

private:
    //  Getter method for the Implementation Object
    SCMServerImpl*  getSCMServerImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSCMServerImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SCMServerImpl*  m_scmserverImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SCMServer - desc for SCMServer parameter
     */
    SCMServer( const SCMServer& );
    SCMServer& operator=( const SCMServer& );

    friend class  SCMServerDelegate;
    friend class  SCMServerDispatch;
    friend class  SCMServerGenImpl;
};

#include <mechatronics/libmechatronics_undef.h>
#endif //   TEAMCENTER__SCMSERVER__HXX
