//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SCMServerDelegate
    Filename:   SCMServerDelegate.hxx
    Module:     mechatronics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SCMSERVERDELEGATE_HXX
#define TEAMCENTER__SCMSERVERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mechatronics/SCMServer.hxx>

#include <mechatronics/libmechatronics_exports.h>

namespace Teamcenter
{
    class SCMServerDelegate;
}
namespace Teamcenter
{
    class SCMServerImpl;
}
namespace Teamcenter
{
    class SCMServer;
}
namespace Teamcenter
{
    class SCMServerGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  MECHATRONICS_API Teamcenter_alias::SCMServerDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SCMServerDelegate instance
    static SCMServerDelegate&  getInstance();

    //  Method to create the SCMServerImpl pointer
    static SCMServerImpl*  createImpl( SCMServer&  ifObj );

    //  Method to delete the SCMServerImpl pointer
    static void deleteImpl( SCMServerImpl*  impl );



protected:
    //  Pointer to the instance
    static SCMServerDelegate*  m_pInstance;

    SCMServerDelegate();
    virtual ~SCMServerDelegate();
    static void setInstance( SCMServerDelegate*  instance );


private:
    friend class  ::Teamcenter::SCMServerGenImpl;

};

#include <mechatronics/libmechatronics_undef.h>
#endif  //  TEAMCENTER__SCMSERVERDELEGATE_HXX
