//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SCMVersionObject
    Filename:   SCMVersionObject.hxx
    Module:     mechatronics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SCMVERSIONOBJECT__HXX
#define TEAMCENTER__SCMVERSIONOBJECT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <mechatronics/libmechatronics_exports.h>

namespace Teamcenter
{
    class SCMVersionObject;
}
namespace Teamcenter
{
    class SCMVersionObjectImpl;
}
namespace Teamcenter
{
    class SCMVersionObjectDelegate;
}
namespace Teamcenter
{
    class SCMVersionObjectDispatch;
}
namespace Teamcenter
{
    class SCMVersionObjectGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MECHATRONICS_API  Teamcenter::SCMVersionObject
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SCMVersionObject();

    /**
     * Destructor
     */
    virtual ~SCMVersionObject();

private:
    //  Getter method for the Implementation Object
    SCMVersionObjectImpl*  getSCMVersionObjectImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSCMVersionObjectImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SCMVersionObjectImpl*  m_scmversionobjectImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SCMVersionObject - desc for SCMVersionObject parameter
     */
    SCMVersionObject( const SCMVersionObject& );
    SCMVersionObject& operator=( const SCMVersionObject& );

    friend class  SCMVersionObjectDelegate;
    friend class  SCMVersionObjectDispatch;
    friend class  SCMVersionObjectGenImpl;
};

#include <mechatronics/libmechatronics_undef.h>
#endif //   TEAMCENTER__SCMVERSIONOBJECT__HXX
