//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TraceLink
    Filename:   TraceLink.hxx
    Module:     mechatronics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TRACELINK__HXX
#define TEAMCENTER__TRACELINK__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ManagedRelation.hxx>

#include <mechatronics/libmechatronics_exports.h>

namespace Teamcenter
{
    class TraceLink;
}
namespace Teamcenter
{
    class TraceLinkImpl;
}
namespace Teamcenter
{
    class TraceLinkDelegate;
}
namespace Teamcenter
{
    class TraceLinkDispatch;
}
namespace Teamcenter
{
    class TraceLinkGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MECHATRONICS_API  Teamcenter::TraceLink
     : public  ::Teamcenter::ManagedRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    TraceLink();

    /**
     * Destructor
     */
    virtual ~TraceLink();

private:
    //  Getter method for the Implementation Object
    TraceLinkImpl*  getTraceLinkImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTraceLinkImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    TraceLinkImpl*  m_tracelinkImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param TraceLink - desc for TraceLink parameter
     */
    TraceLink( const TraceLink& );
    TraceLink& operator=( const TraceLink& );

    friend class  TraceLinkDelegate;
    friend class  TraceLinkDispatch;
    friend class  TraceLinkGenImpl;
};

#include <mechatronics/libmechatronics_undef.h>
#endif //   TEAMCENTER__TRACELINK__HXX
