//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TraceLinkDelegate
    Filename:   TraceLinkDelegate.hxx
    Module:     mechatronics
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TRACELINKDELEGATE_HXX
#define TEAMCENTER__TRACELINKDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mechatronics/TraceLink.hxx>

#include <mechatronics/libmechatronics_exports.h>

namespace Teamcenter
{
    class TraceLinkDelegate;
}
namespace Teamcenter
{
    class TraceLinkImpl;
}
namespace Teamcenter
{
    class TraceLink;
}
namespace Teamcenter
{
    class TraceLinkGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  MECHATRONICS_API Teamcenter_alias::TraceLinkDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the TraceLinkDelegate instance
    static TraceLinkDelegate&  getInstance();

    //  Method to create the TraceLinkImpl pointer
    static TraceLinkImpl*  createImpl( TraceLink&  ifObj );

    //  Method to delete the TraceLinkImpl pointer
    static void deleteImpl( TraceLinkImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const TraceLink &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const TraceLink &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const TraceLink &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static TraceLinkDelegate*  m_pInstance;

    TraceLinkDelegate();
    virtual ~TraceLinkDelegate();
    static void setInstance( TraceLinkDelegate*  instance );


private:
    friend class  ::Teamcenter::TraceLinkGenImpl;

};

#include <mechatronics/libmechatronics_undef.h>
#endif  //  TEAMCENTER__TRACELINKDELEGATE_HXX
