//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  mechatronics

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libmechatronics

#if !defined(LIBMECHATRONICS) && !defined(IPLIB)
#   error IPLIB or LIBMECHATRONICS is not defined
#endif

/* Handwritten code should use MECHATRONICS_API, not MECHATRONICSEXPORT */

#define MECHATRONICS_API MECHATRONICSEXPORT

#if IPLIB==libmechatronics || defined(LIBMECHATRONICS)
#   if defined(__lint)
#       define MECHATRONICSEXPORT       __export(mechatronics)
#       define MECHATRONICSGLOBAL       extern __global(mechatronics)
#       define MECHATRONICSPRIVATE      extern __private(mechatronics)
#   elif defined(_WIN32)
#       define MECHATRONICSEXPORT       __declspec(dllexport)
#       define MECHATRONICSGLOBAL       extern __declspec(dllexport)
#       define MECHATRONICSPRIVATE      extern
#   else
#       define MECHATRONICSEXPORT
#       define MECHATRONICSGLOBAL       extern
#       define MECHATRONICSPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define MECHATRONICSEXPORT       __export(mechatronics)
#       define MECHATRONICSGLOBAL       extern __global(mechatronics)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define MECHATRONICSEXPORT      __declspec(dllimport)
#       define MECHATRONICSGLOBAL       extern __declspec(dllimport)
#   else
#       define MECHATRONICSEXPORT
#       define MECHATRONICSGLOBAL       extern
#   endif
#endif
