//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mes0BvrDCD
    Filename:   Mes0BvrDCD.hxx
    Module:     mesbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CMTMES__MES0BVRDCD__HXX
#define CMTMES__MES0BVRDCD__HXX

#include <common/tc_deprecation_macros.h>
#include <me/GDEBOPLine.hxx>

#include <mesbvr/libmesbvr_exports.h>

namespace CMTMES
{
    class Mes0BvrDCD;
}
namespace CMTMES
{
    class Mes0BvrDCDImpl;
}
namespace CMTMES
{
    class Mes0BvrDCDDelegate;
}
namespace CMTMES
{
    class Mes0BvrDCDDispatch;
}
namespace CMTMES
{
    class Mes0BvrDCDGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MESBVR_API  CMTMES::Mes0BvrDCD
     : public  ::Teamcenter::GDEBOPLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mes0BvrDCD();

    /**
     * Destructor
     */
    virtual ~Mes0BvrDCD();

private:
    //  Getter method for the Implementation Object
    Mes0BvrDCDImpl*  getMes0BvrDCDImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMes0BvrDCDImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mes0BvrDCDImpl*  m_mes0bvrdcdImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mes0BvrDCD - desc for Mes0BvrDCD parameter
     */
    Mes0BvrDCD( const Mes0BvrDCD& );
    Mes0BvrDCD& operator=( const Mes0BvrDCD& );

    friend class  Mes0BvrDCDDelegate;
    friend class  Mes0BvrDCDDispatch;
    friend class  Mes0BvrDCDGenImpl;
};

#include <mesbvr/libmesbvr_undef.h>
#endif //   CMTMES__MES0BVRDCD__HXX
