//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mes0BvrPF
    Filename:   Mes0BvrPF.hxx
    Module:     mesbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CMTMES__MES0BVRPF__HXX
#define CMTMES__MES0BVRPF__HXX

#include <common/tc_deprecation_macros.h>
#include <me/GDEBOPLine.hxx>

#include <mesbvr/libmesbvr_exports.h>

namespace CMTMES
{
    class Mes0BvrPF;
}
namespace CMTMES
{
    class Mes0BvrPFImpl;
}
namespace CMTMES
{
    class Mes0BvrPFDelegate;
}
namespace CMTMES
{
    class Mes0BvrPFDispatch;
}
namespace CMTMES
{
    class Mes0BvrPFGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MESBVR_API  CMTMES::Mes0BvrPF
     : public  ::Teamcenter::GDEBOPLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mes0BvrPF();

    /**
     * Destructor
     */
    virtual ~Mes0BvrPF();

private:
    //  Getter method for the Implementation Object
    Mes0BvrPFImpl*  getMes0BvrPFImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMes0BvrPFImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mes0BvrPFImpl*  m_mes0bvrpfImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mes0BvrPF - desc for Mes0BvrPF parameter
     */
    Mes0BvrPF( const Mes0BvrPF& );
    Mes0BvrPF& operator=( const Mes0BvrPF& );

    friend class  Mes0BvrPFDelegate;
    friend class  Mes0BvrPFDispatch;
    friend class  Mes0BvrPFGenImpl;
};

#include <mesbvr/libmesbvr_undef.h>
#endif //   CMTMES__MES0BVRPF__HXX
