//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mes0BvrSTXElement
    Filename:   Mes0BvrSTXElement.hxx
    Module:     mesbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CMTMES__MES0BVRSTXELEMENT__HXX
#define CMTMES__MES0BVRSTXELEMENT__HXX

#include <vector>
#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <me/ImanItemBOPLine.hxx>

#include <mesbvr/libmesbvr_exports.h>

namespace CMTMES
{
    class Mes0BvrSTXElement;
}
namespace CMTMES
{
    class Mes0BvrSTXElementImpl;
}
namespace CMTMES
{
    class Mes0BvrSTXElementDelegate;
}
namespace CMTMES
{
    class Mes0BvrSTXElementDispatch;
}
namespace CMTMES
{
    class Mes0BvrSTXElementGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MESBVR_API  CMTMES::Mes0BvrSTXElement
     : public  ::Teamcenter::ImanItemBOPLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMes0DCDNodes( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMes0ObjectData( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMes0PFNodes( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mes0BvrSTXElement();

    /**
     * Destructor
     */
    virtual ~Mes0BvrSTXElement();

private:
    //  Getter method for the Implementation Object
    Mes0BvrSTXElementImpl*  getMes0BvrSTXElementImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMes0BvrSTXElementImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mes0BvrSTXElementImpl*  m_mes0bvrstxelementImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mes0BvrSTXElement - desc for Mes0BvrSTXElement parameter
     */
    Mes0BvrSTXElement( const Mes0BvrSTXElement& );
    Mes0BvrSTXElement& operator=( const Mes0BvrSTXElement& );

    friend class  Mes0BvrSTXElementDelegate;
    friend class  Mes0BvrSTXElementDispatch;
    friend class  Mes0BvrSTXElementGenImpl;
};

#include <mesbvr/libmesbvr_undef.h>
#endif //   CMTMES__MES0BVRSTXELEMENT__HXX
