//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mes0BvrSTXFolder
    Filename:   Mes0BvrSTXFolder.hxx
    Module:     mesbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CMTMES__MES0BVRSTXFOLDER__HXX
#define CMTMES__MES0BVRSTXFOLDER__HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrFolder.hxx>

#include <mesbvr/libmesbvr_exports.h>

namespace CMTMES
{
    class Mes0BvrSTXFolder;
}
namespace CMTMES
{
    class Mes0BvrSTXFolderImpl;
}
namespace CMTMES
{
    class Mes0BvrSTXFolderDelegate;
}
namespace CMTMES
{
    class Mes0BvrSTXFolderDispatch;
}
namespace CMTMES
{
    class Mes0BvrSTXFolderGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MESBVR_API  CMTMES::Mes0BvrSTXFolder
     : public  ::Teamcenter::Mfg0BvrFolder
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mes0BvrSTXFolder();

    /**
     * Destructor
     */
    virtual ~Mes0BvrSTXFolder();

private:
    //  Getter method for the Implementation Object
    Mes0BvrSTXFolderImpl*  getMes0BvrSTXFolderImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMes0BvrSTXFolderImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mes0BvrSTXFolderImpl*  m_mes0bvrstxfolderImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mes0BvrSTXFolder - desc for Mes0BvrSTXFolder parameter
     */
    Mes0BvrSTXFolder( const Mes0BvrSTXFolder& );
    Mes0BvrSTXFolder& operator=( const Mes0BvrSTXFolder& );

    friend class  Mes0BvrSTXFolderDelegate;
    friend class  Mes0BvrSTXFolderDispatch;
    friend class  Mes0BvrSTXFolderGenImpl;
};

#include <mesbvr/libmesbvr_undef.h>
#endif //   CMTMES__MES0BVRSTXFOLDER__HXX
