//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mes0BvrSTXLibrary
    Filename:   Mes0BvrSTXLibrary.hxx
    Module:     mesbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CMTMES__MES0BVRSTXLIBRARY__HXX
#define CMTMES__MES0BVRSTXLIBRARY__HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrLibrary.hxx>

#include <mesbvr/libmesbvr_exports.h>

namespace CMTMES
{
    class Mes0BvrSTXLibrary;
}
namespace CMTMES
{
    class Mes0BvrSTXLibraryImpl;
}
namespace CMTMES
{
    class Mes0BvrSTXLibraryDelegate;
}
namespace CMTMES
{
    class Mes0BvrSTXLibraryDispatch;
}
namespace CMTMES
{
    class Mes0BvrSTXLibraryGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MESBVR_API  CMTMES::Mes0BvrSTXLibrary
     : public  ::Teamcenter::Mfg0BvrLibrary
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mes0BvrSTXLibrary();

    /**
     * Destructor
     */
    virtual ~Mes0BvrSTXLibrary();

private:
    //  Getter method for the Implementation Object
    Mes0BvrSTXLibraryImpl*  getMes0BvrSTXLibraryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMes0BvrSTXLibraryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mes0BvrSTXLibraryImpl*  m_mes0bvrstxlibraryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mes0BvrSTXLibrary - desc for Mes0BvrSTXLibrary parameter
     */
    Mes0BvrSTXLibrary( const Mes0BvrSTXLibrary& );
    Mes0BvrSTXLibrary& operator=( const Mes0BvrSTXLibrary& );

    friend class  Mes0BvrSTXLibraryDelegate;
    friend class  Mes0BvrSTXLibraryDispatch;
    friend class  Mes0BvrSTXLibraryGenImpl;
};

#include <mesbvr/libmesbvr_undef.h>
#endif //   CMTMES__MES0BVRSTXLIBRARY__HXX
