//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mes0MEDCD
    Filename:   Mes0MEDCD.hxx
    Module:     mesbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CMTMES__MES0MEDCD__HXX
#define CMTMES__MES0MEDCD__HXX

#include <common/tc_deprecation_macros.h>
#include <tccoreext/GeneralDesignElement.hxx>

#include <mesbvr/libmesbvr_exports.h>

namespace CMTMES
{
    class Mes0MEDCD;
}
namespace CMTMES
{
    class Mes0MEDCDImpl;
}
namespace CMTMES
{
    class Mes0MEDCDDelegate;
}
namespace CMTMES
{
    class Mes0MEDCDDispatch;
}
namespace CMTMES
{
    class Mes0MEDCDGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MESBVR_API  CMTMES::Mes0MEDCD
     : public  ::Teamcenter::GeneralDesignElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mes0MEDCD();

    /**
     * Destructor
     */
    virtual ~Mes0MEDCD();

private:
    //  Getter method for the Implementation Object
    Mes0MEDCDImpl*  getMes0MEDCDImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMes0MEDCDImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mes0MEDCDImpl*  m_mes0medcdImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mes0MEDCD - desc for Mes0MEDCD parameter
     */
    Mes0MEDCD( const Mes0MEDCD& );
    Mes0MEDCD& operator=( const Mes0MEDCD& );

    friend class  Mes0MEDCDDelegate;
    friend class  Mes0MEDCDDispatch;
    friend class  Mes0MEDCDGenImpl;
};

#include <mesbvr/libmesbvr_undef.h>
#endif //   CMTMES__MES0MEDCD__HXX
