//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mes0MEPF
    Filename:   Mes0MEPF.hxx
    Module:     mesbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CMTMES__MES0MEPF__HXX
#define CMTMES__MES0MEPF__HXX

#include <common/tc_deprecation_macros.h>
#include <tccoreext/GeneralDesignElement.hxx>

#include <mesbvr/libmesbvr_exports.h>

namespace CMTMES
{
    class Mes0MEPF;
}
namespace CMTMES
{
    class Mes0MEPFImpl;
}
namespace CMTMES
{
    class Mes0MEPFDelegate;
}
namespace CMTMES
{
    class Mes0MEPFDispatch;
}
namespace CMTMES
{
    class Mes0MEPFGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MESBVR_API  CMTMES::Mes0MEPF
     : public  ::Teamcenter::GeneralDesignElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mes0MEPF();

    /**
     * Destructor
     */
    virtual ~Mes0MEPF();

private:
    //  Getter method for the Implementation Object
    Mes0MEPFImpl*  getMes0MEPFImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMes0MEPFImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mes0MEPFImpl*  m_mes0mepfImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mes0MEPF - desc for Mes0MEPF parameter
     */
    Mes0MEPF( const Mes0MEPF& );
    Mes0MEPF& operator=( const Mes0MEPF& );

    friend class  Mes0MEPFDelegate;
    friend class  Mes0MEPFDispatch;
    friend class  Mes0MEPFGenImpl;
};

#include <mesbvr/libmesbvr_undef.h>
#endif //   CMTMES__MES0MEPF__HXX
