//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mes0MESTXElement
    Filename:   Mes0MESTXElement.hxx
    Module:     mesbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CMTMES__MES0MESTXELEMENT__HXX
#define CMTMES__MES0MESTXELEMENT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <mesbvr/libmesbvr_exports.h>

namespace CMTMES
{
    class Mes0MESTXElement;
}
namespace CMTMES
{
    class Mes0MESTXElementImpl;
}
namespace CMTMES
{
    class Mes0MESTXElementDelegate;
}
namespace CMTMES
{
    class Mes0MESTXElementDispatch;
}
namespace CMTMES
{
    class Mes0MESTXElementGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MESBVR_API  CMTMES::Mes0MESTXElement
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mes0MESTXElement();

    /**
     * Destructor
     */
    virtual ~Mes0MESTXElement();

private:
    //  Getter method for the Implementation Object
    Mes0MESTXElementImpl*  getMes0MESTXElementImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMes0MESTXElementImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mes0MESTXElementImpl*  m_mes0mestxelementImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mes0MESTXElement - desc for Mes0MESTXElement parameter
     */
    Mes0MESTXElement( const Mes0MESTXElement& );
    Mes0MESTXElement& operator=( const Mes0MESTXElement& );

    friend class  Mes0MESTXElementDelegate;
    friend class  Mes0MESTXElementDispatch;
    friend class  Mes0MESTXElementGenImpl;
};

#include <mesbvr/libmesbvr_undef.h>
#endif //   CMTMES__MES0MESTXELEMENT__HXX
