//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mes0MESTXFolder
    Filename:   Mes0MESTXFolder.hxx
    Module:     mesbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CMTMES__MES0MESTXFOLDER__HXX
#define CMTMES__MES0MESTXFOLDER__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <mesbvr/libmesbvr_exports.h>

namespace CMTMES
{
    class Mes0MESTXFolder;
}
namespace CMTMES
{
    class Mes0MESTXFolderImpl;
}
namespace CMTMES
{
    class Mes0MESTXFolderDelegate;
}
namespace CMTMES
{
    class Mes0MESTXFolderDispatch;
}
namespace CMTMES
{
    class Mes0MESTXFolderGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MESBVR_API  CMTMES::Mes0MESTXFolder
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mes0MESTXFolder();

    /**
     * Destructor
     */
    virtual ~Mes0MESTXFolder();

private:
    //  Getter method for the Implementation Object
    Mes0MESTXFolderImpl*  getMes0MESTXFolderImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMes0MESTXFolderImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mes0MESTXFolderImpl*  m_mes0mestxfolderImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mes0MESTXFolder - desc for Mes0MESTXFolder parameter
     */
    Mes0MESTXFolder( const Mes0MESTXFolder& );
    Mes0MESTXFolder& operator=( const Mes0MESTXFolder& );

    friend class  Mes0MESTXFolderDelegate;
    friend class  Mes0MESTXFolderDispatch;
    friend class  Mes0MESTXFolderGenImpl;
};

#include <mesbvr/libmesbvr_undef.h>
#endif //   CMTMES__MES0MESTXFOLDER__HXX
