//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mes0MESTXLibrary
    Filename:   Mes0MESTXLibrary.hxx
    Module:     mesbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CMTMES__MES0MESTXLIBRARY__HXX
#define CMTMES__MES0MESTXLIBRARY__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <mesbvr/libmesbvr_exports.h>

namespace CMTMES
{
    class Mes0MESTXLibrary;
}
namespace CMTMES
{
    class Mes0MESTXLibraryImpl;
}
namespace CMTMES
{
    class Mes0MESTXLibraryDelegate;
}
namespace CMTMES
{
    class Mes0MESTXLibraryDispatch;
}
namespace CMTMES
{
    class Mes0MESTXLibraryGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MESBVR_API  CMTMES::Mes0MESTXLibrary
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mes0MESTXLibrary();

    /**
     * Destructor
     */
    virtual ~Mes0MESTXLibrary();

private:
    //  Getter method for the Implementation Object
    Mes0MESTXLibraryImpl*  getMes0MESTXLibraryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMes0MESTXLibraryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mes0MESTXLibraryImpl*  m_mes0mestxlibraryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mes0MESTXLibrary - desc for Mes0MESTXLibrary parameter
     */
    Mes0MESTXLibrary( const Mes0MESTXLibrary& );
    Mes0MESTXLibrary& operator=( const Mes0MESTXLibrary& );

    friend class  Mes0MESTXLibraryDelegate;
    friend class  Mes0MESTXLibraryDispatch;
    friend class  Mes0MESTXLibraryGenImpl;
};

#include <mesbvr/libmesbvr_undef.h>
#endif //   CMTMES__MES0MESTXLIBRARY__HXX
