//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mes0PDFReport
    Filename:   Mes0PDFReport.hxx
    Module:     mesbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CMTMES__MES0PDFREPORT__HXX
#define CMTMES__MES0PDFREPORT__HXX

#include <common/tc_deprecation_macros.h>
#include <ae/Dataset.hxx>

#include <mesbvr/libmesbvr_exports.h>

namespace CMTMES
{
    class Mes0PDFReport;
}
namespace CMTMES
{
    class Mes0PDFReportImpl;
}
namespace CMTMES
{
    class Mes0PDFReportDelegate;
}
namespace CMTMES
{
    class Mes0PDFReportDispatch;
}
namespace CMTMES
{
    class Mes0PDFReportGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MESBVR_API  CMTMES::Mes0PDFReport
     : public  ::Teamcenter::Dataset
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mes0PDFReport();

    /**
     * Destructor
     */
    virtual ~Mes0PDFReport();

private:
    //  Getter method for the Implementation Object
    Mes0PDFReportImpl*  getMes0PDFReportImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMes0PDFReportImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mes0PDFReportImpl*  m_mes0pdfreportImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mes0PDFReport - desc for Mes0PDFReport parameter
     */
    Mes0PDFReport( const Mes0PDFReport& );
    Mes0PDFReport& operator=( const Mes0PDFReport& );

    friend class  Mes0PDFReportDelegate;
    friend class  Mes0PDFReportDispatch;
    friend class  Mes0PDFReportGenImpl;
};

#include <mesbvr/libmesbvr_undef.h>
#endif //   CMTMES__MES0PDFREPORT__HXX
