//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mes0PDFReportTemplate
    Filename:   Mes0PDFReportTemplate.hxx
    Module:     mesbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef CMTMES__MES0PDFREPORTTEMPLATE__HXX
#define CMTMES__MES0PDFREPORTTEMPLATE__HXX

#include <common/tc_deprecation_macros.h>
#include <ae/Dataset.hxx>

#include <mesbvr/libmesbvr_exports.h>

namespace CMTMES
{
    class Mes0PDFReportTemplate;
}
namespace CMTMES
{
    class Mes0PDFReportTemplateImpl;
}
namespace CMTMES
{
    class Mes0PDFReportTemplateDelegate;
}
namespace CMTMES
{
    class Mes0PDFReportTemplateDispatch;
}
namespace CMTMES
{
    class Mes0PDFReportTemplateGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MESBVR_API  CMTMES::Mes0PDFReportTemplate
     : public  ::Teamcenter::Dataset
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mes0PDFReportTemplate();

    /**
     * Destructor
     */
    virtual ~Mes0PDFReportTemplate();

private:
    //  Getter method for the Implementation Object
    Mes0PDFReportTemplateImpl*  getMes0PDFReportTemplateImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMes0PDFReportTemplateImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mes0PDFReportTemplateImpl*  m_mes0pdfreporttemplateImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mes0PDFReportTemplate - desc for Mes0PDFReportTemplate parameter
     */
    Mes0PDFReportTemplate( const Mes0PDFReportTemplate& );
    Mes0PDFReportTemplate& operator=( const Mes0PDFReportTemplate& );

    friend class  Mes0PDFReportTemplateDelegate;
    friend class  Mes0PDFReportTemplateDispatch;
    friend class  Mes0PDFReportTemplateGenImpl;
};

#include <mesbvr/libmesbvr_undef.h>
#endif //   CMTMES__MES0PDFREPORTTEMPLATE__HXX
