//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  mesbvr

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libmesbvr

#if !defined(LIBMESBVR) && !defined(IPLIB)
#   error IPLIB or LIBMESBVR is not defined
#endif

/* Handwritten code should use MESBVR_API, not MESBVREXPORT */

#define MESBVR_API MESBVREXPORT

#if IPLIB==libmesbvr || defined(LIBMESBVR)
#   if defined(__lint)
#       define MESBVREXPORT       __export(mesbvr)
#       define MESBVRGLOBAL       extern __global(mesbvr)
#       define MESBVRPRIVATE      extern __private(mesbvr)
#   elif defined(_WIN32)
#       define MESBVREXPORT       __declspec(dllexport)
#       define MESBVRGLOBAL       extern __declspec(dllexport)
#       define MESBVRPRIVATE      extern
#   else
#       define MESBVREXPORT
#       define MESBVRGLOBAL       extern
#       define MESBVRPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define MESBVREXPORT       __export(mesbvr)
#       define MESBVRGLOBAL       extern __global(mesbvr)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define MESBVREXPORT      __declspec(dllimport)
#       define MESBVRGLOBAL       extern __declspec(dllimport)
#   else
#       define MESBVREXPORT
#       define MESBVRGLOBAL       extern
#   endif
#endif
