//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BusinessObjectInterface
    Filename:   BusinessObjectInterface.hxx
    Module:     meta
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BUSINESSOBJECTINTERFACE__HXX
#define TEAMCENTER__BUSINESSOBJECTINTERFACE__HXX

#include <common/tc_deprecation_macros.h>
#include <meta/MetaInterface.hxx>

#include <meta/libmeta_exports.h>

namespace Teamcenter
{
    class BusinessObjectInterface;
}
namespace Teamcenter
{
    class BusinessObjectInterfaceImpl;
}
namespace Teamcenter
{
    class BusinessObjectInterfaceDelegate;
}
namespace Teamcenter
{
    class BusinessObjectInterfaceDispatch;
}
namespace Teamcenter
{
    class BusinessObjectInterfaceGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  META_API  Teamcenter::BusinessObjectInterface
     : public  ::Teamcenter::MetaInterface
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    BusinessObjectInterface();

    /**
     * Destructor
     */
    virtual ~BusinessObjectInterface();

private:
    //  Getter method for the Implementation Object
    BusinessObjectInterfaceImpl*  getBusinessObjectInterfaceImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBusinessObjectInterfaceImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    BusinessObjectInterfaceImpl*  m_businessobjectinterfaceImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param BusinessObjectInterface - desc for BusinessObjectInterface parameter
     */
    BusinessObjectInterface( const BusinessObjectInterface& );
    BusinessObjectInterface& operator=( const BusinessObjectInterface& );

    friend class  BusinessObjectInterfaceDelegate;
    friend class  BusinessObjectInterfaceDispatch;
    friend class  BusinessObjectInterfaceGenImpl;
};

#include <meta/libmeta_undef.h>
#endif //   TEAMCENTER__BUSINESSOBJECTINTERFACE__HXX
