//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DataType
    Filename:   DataType.hxx
    Module:     meta
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__DATATYPE__HXX
#define TEAMCENTER__DATATYPE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <meta/libmeta_exports.h>

namespace Teamcenter
{
    class DataType;
}
namespace Teamcenter
{
    class DataTypeImpl;
}
namespace Teamcenter
{
    class DataTypeDelegate;
}
namespace Teamcenter
{
    class DataTypeDispatch;
}
namespace Teamcenter
{
    class DataTypeGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  META_API  Teamcenter::DataType
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    DataType();

    /**
     * Destructor
     */
    virtual ~DataType();

private:
    //  Getter method for the Implementation Object
    DataTypeImpl*  getDataTypeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDataTypeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DataTypeImpl*  m_datatypeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param DataType - desc for DataType parameter
     */
    DataType( const DataType& );
    DataType& operator=( const DataType& );

    friend class  DataTypeDelegate;
    friend class  DataTypeDispatch;
    friend class  DataTypeGenImpl;
};

#include <meta/libmeta_undef.h>
#endif //   TEAMCENTER__DATATYPE__HXX
