//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DataTypeRefDelegate
    Filename:   DataTypeRefDelegate.hxx
    Module:     meta
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__DATATYPEREFDELEGATE_HXX
#define TEAMCENTER__DATATYPEREFDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <meta/DataTypeRef.hxx>

#include <meta/libmeta_exports.h>

namespace Teamcenter
{
    class DataTypeRefDelegate;
}
namespace Teamcenter
{
    class DataTypeRefImpl;
}
namespace Teamcenter
{
    class DataTypeRef;
}
namespace Teamcenter
{
    class DataTypeRefGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  META_API Teamcenter_alias::DataTypeRefDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the DataTypeRefDelegate instance
    static DataTypeRefDelegate&  getInstance();

    //  Method to create the DataTypeRefImpl pointer
    static DataTypeRefImpl*  createImpl( DataTypeRef&  ifObj );

    //  Method to delete the DataTypeRefImpl pointer
    static void deleteImpl( DataTypeRefImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDataTypeBase(const DataTypeRef &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Tc 8
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getParamsBase(const DataTypeRef &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getQualifierBase(const DataTypeRef &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDataTypeBase(DataTypeRef &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Tc 8
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setParamsBase(DataTypeRef &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setQualifierBase(DataTypeRef &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static DataTypeRefDelegate*  m_pInstance;

    DataTypeRefDelegate();
    virtual ~DataTypeRefDelegate();
    static void setInstance( DataTypeRefDelegate*  instance );


private:
    friend class  ::Teamcenter::DataTypeRefGenImpl;

};

#include <meta/libmeta_undef.h>
#endif  //  TEAMCENTER__DATATYPEREFDELEGATE_HXX
