//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ExternalDataType
    Filename:   ExternalDataType.hxx
    Module:     meta
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EXTERNALDATATYPE__HXX
#define TEAMCENTER__EXTERNALDATATYPE__HXX

#include <common/tc_deprecation_macros.h>
#include <meta/DataType.hxx>

#include <meta/libmeta_exports.h>

namespace Teamcenter
{
    class ExternalDataType;
}
namespace Teamcenter
{
    class ExternalDataTypeImpl;
}
namespace Teamcenter
{
    class ExternalDataTypeDelegate;
}
namespace Teamcenter
{
    class ExternalDataTypeDispatch;
}
namespace Teamcenter
{
    class ExternalDataTypeGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  META_API  Teamcenter::ExternalDataType
     : public  ::Teamcenter::DataType
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ExternalDataType();

    /**
     * Destructor
     */
    virtual ~ExternalDataType();

private:
    //  Getter method for the Implementation Object
    ExternalDataTypeImpl*  getExternalDataTypeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setExternalDataTypeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ExternalDataTypeImpl*  m_externaldatatypeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ExternalDataType - desc for ExternalDataType parameter
     */
    ExternalDataType( const ExternalDataType& );
    ExternalDataType& operator=( const ExternalDataType& );

    friend class  ExternalDataTypeDelegate;
    friend class  ExternalDataTypeDispatch;
    friend class  ExternalDataTypeGenImpl;
};

#include <meta/libmeta_undef.h>
#endif //   TEAMCENTER__EXTERNALDATATYPE__HXX
