//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, InstalledTemplates
    Filename:   InstalledTemplates.hxx
    Module:     meta
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__INSTALLEDTEMPLATES__HXX
#define TEAMCENTER__INSTALLEDTEMPLATES__HXX

#include <string>
#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <meta/libmeta_exports.h>

namespace Teamcenter
{
    class InstalledTemplates;
}
namespace Teamcenter
{
    class InstalledTemplatesImpl;
}
namespace Teamcenter
{
    class InstalledTemplatesDelegate;
}
namespace Teamcenter
{
    class InstalledTemplatesDispatch;
}
namespace Teamcenter
{
    class InstalledTemplatesGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  META_API  Teamcenter::InstalledTemplates
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0FullDeployCS( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Date Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0LastFullDeployDate( date_t &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0LastOpsDeployClientID( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Date Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0LastOpsDeployDate( date_t &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0OpsDeployCS( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getName( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0FullDeployCS( const std::string &value, bool isNull=false );

    ///
    /// Setter for a Date Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0LastFullDeployDate( const date_t &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0LastOpsDeployClientID( const std::string &value, bool isNull=false );

    ///
    /// Setter for a Date Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0LastOpsDeployDate( const date_t &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0OpsDeployCS( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setName( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    InstalledTemplates();

    /**
     * Destructor
     */
    virtual ~InstalledTemplates();

private:
    //  Getter method for the Implementation Object
    InstalledTemplatesImpl*  getInstalledTemplatesImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setInstalledTemplatesImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    InstalledTemplatesImpl*  m_installedtemplatesImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param InstalledTemplates - desc for InstalledTemplates parameter
     */
    InstalledTemplates( const InstalledTemplates& );
    InstalledTemplates& operator=( const InstalledTemplates& );

    friend class  InstalledTemplatesDelegate;
    friend class  InstalledTemplatesDispatch;
    friend class  InstalledTemplatesGenImpl;
};

#include <meta/libmeta_undef.h>
#endif //   TEAMCENTER__INSTALLEDTEMPLATES__HXX
