//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, InstalledTemplatesDelegate
    Filename:   InstalledTemplatesDelegate.hxx
    Module:     meta
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__INSTALLEDTEMPLATESDELEGATE_HXX
#define TEAMCENTER__INSTALLEDTEMPLATESDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <meta/InstalledTemplates.hxx>

#include <meta/libmeta_exports.h>

namespace Teamcenter
{
    class InstalledTemplatesDelegate;
}
namespace Teamcenter
{
    class InstalledTemplatesImpl;
}
namespace Teamcenter
{
    class InstalledTemplates;
}
namespace Teamcenter
{
    class InstalledTemplatesGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  META_API Teamcenter_alias::InstalledTemplatesDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the InstalledTemplatesDelegate instance
    static InstalledTemplatesDelegate&  getInstance();

    //  Method to create the InstalledTemplatesImpl pointer
    static InstalledTemplatesImpl*  createImpl( InstalledTemplates&  ifObj );

    //  Method to delete the InstalledTemplatesImpl pointer
    static void deleteImpl( InstalledTemplatesImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0FullDeployCSBase(const InstalledTemplates &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Date Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0LastFullDeployDateBase(const InstalledTemplates &ifObj,  date_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0LastOpsDeployClientIDBase(const InstalledTemplates &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Date Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0LastOpsDeployDateBase(const InstalledTemplates &ifObj,  date_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0OpsDeployCSBase(const InstalledTemplates &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getNameBase(const InstalledTemplates &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0FullDeployCSBase(InstalledTemplates &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Date Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0LastFullDeployDateBase(InstalledTemplates &ifObj,  const date_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0LastOpsDeployClientIDBase(InstalledTemplates &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Date Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0LastOpsDeployDateBase(InstalledTemplates &ifObj,  const date_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0OpsDeployCSBase(InstalledTemplates &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setNameBase(InstalledTemplates &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static InstalledTemplatesDelegate*  m_pInstance;

    InstalledTemplatesDelegate();
    virtual ~InstalledTemplatesDelegate();
    static void setInstance( InstalledTemplatesDelegate*  instance );


private:
    friend class  ::Teamcenter::InstalledTemplatesGenImpl;

};

#include <meta/libmeta_undef.h>
#endif  //  TEAMCENTER__INSTALLEDTEMPLATESDELEGATE_HXX
