//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MetaEnum
    Filename:   MetaEnum.hxx
    Module:     meta
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__METAENUM__HXX
#define TEAMCENTER__METAENUM__HXX

#include <common/tc_deprecation_macros.h>
#include <meta/GeneratedDataType.hxx>

#include <meta/libmeta_exports.h>

namespace Teamcenter
{
    class MetaEnum;
}
namespace Teamcenter
{
    class MetaEnumImpl;
}
namespace Teamcenter
{
    class MetaEnumDelegate;
}
namespace Teamcenter
{
    class MetaEnumDispatch;
}
namespace Teamcenter
{
    class MetaEnumGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  META_API  Teamcenter::MetaEnum
     : public  ::Teamcenter::GeneratedDataType
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    MetaEnum();

    /**
     * Destructor
     */
    virtual ~MetaEnum();

private:
    //  Getter method for the Implementation Object
    MetaEnumImpl*  getMetaEnumImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMetaEnumImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    MetaEnumImpl*  m_metaenumImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param MetaEnum - desc for MetaEnum parameter
     */
    MetaEnum( const MetaEnum& );
    MetaEnum& operator=( const MetaEnum& );

    friend class  MetaEnumDelegate;
    friend class  MetaEnumDispatch;
    friend class  MetaEnumGenImpl;
};

#include <meta/libmeta_undef.h>
#endif //   TEAMCENTER__METAENUM__HXX
