//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MetaEnumLiteral
    Filename:   MetaEnumLiteral.hxx
    Module:     meta
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__METAENUMLITERAL__HXX
#define TEAMCENTER__METAENUMLITERAL__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <meta/libmeta_exports.h>

namespace Teamcenter
{
    class MetaEnumLiteral;
}
namespace Teamcenter
{
    class MetaEnumLiteralImpl;
}
namespace Teamcenter
{
    class MetaEnumLiteralDelegate;
}
namespace Teamcenter
{
    class MetaEnumLiteralDispatch;
}
namespace Teamcenter
{
    class MetaEnumLiteralGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  META_API  Teamcenter::MetaEnumLiteral
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    MetaEnumLiteral();

    /**
     * Destructor
     */
    virtual ~MetaEnumLiteral();

private:
    //  Getter method for the Implementation Object
    MetaEnumLiteralImpl*  getMetaEnumLiteralImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMetaEnumLiteralImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    MetaEnumLiteralImpl*  m_metaenumliteralImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param MetaEnumLiteral - desc for MetaEnumLiteral parameter
     */
    MetaEnumLiteral( const MetaEnumLiteral& );
    MetaEnumLiteral& operator=( const MetaEnumLiteral& );

    friend class  MetaEnumLiteralDelegate;
    friend class  MetaEnumLiteralDispatch;
    friend class  MetaEnumLiteralGenImpl;
};

#include <meta/libmeta_undef.h>
#endif //   TEAMCENTER__METAENUMLITERAL__HXX
