//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MetaException
    Filename:   MetaException.hxx
    Module:     meta
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__METAEXCEPTION__HXX
#define TEAMCENTER__METAEXCEPTION__HXX

#include <common/tc_deprecation_macros.h>
#include <meta/DataType.hxx>

#include <meta/libmeta_exports.h>

namespace Teamcenter
{
    class MetaException;
}
namespace Teamcenter
{
    class MetaExceptionImpl;
}
namespace Teamcenter
{
    class MetaExceptionDelegate;
}
namespace Teamcenter
{
    class MetaExceptionDispatch;
}
namespace Teamcenter
{
    class MetaExceptionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  META_API  Teamcenter::MetaException
     : public  ::Teamcenter::DataType
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    MetaException();

    /**
     * Destructor
     */
    virtual ~MetaException();

private:
    //  Getter method for the Implementation Object
    MetaExceptionImpl*  getMetaExceptionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMetaExceptionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    MetaExceptionImpl*  m_metaexceptionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param MetaException - desc for MetaException parameter
     */
    MetaException( const MetaException& );
    MetaException& operator=( const MetaException& );

    friend class  MetaExceptionDelegate;
    friend class  MetaExceptionDispatch;
    friend class  MetaExceptionGenImpl;
};

#include <meta/libmeta_undef.h>
#endif //   TEAMCENTER__METAEXCEPTION__HXX
