//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MetaInterface
    Filename:   MetaInterface.hxx
    Module:     meta
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__METAINTERFACE__HXX
#define TEAMCENTER__METAINTERFACE__HXX

#include <common/tc_deprecation_macros.h>
#include <meta/DataType.hxx>

#include <meta/libmeta_exports.h>

namespace Teamcenter
{
    class MetaInterface;
}
namespace Teamcenter
{
    class MetaInterfaceImpl;
}
namespace Teamcenter
{
    class MetaInterfaceDelegate;
}
namespace Teamcenter
{
    class MetaInterfaceDispatch;
}
namespace Teamcenter
{
    class MetaInterfaceGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  META_API  Teamcenter::MetaInterface
     : public  ::Teamcenter::DataType
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    MetaInterface();

    /**
     * Destructor
     */
    virtual ~MetaInterface();

private:
    //  Getter method for the Implementation Object
    MetaInterfaceImpl*  getMetaInterfaceImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMetaInterfaceImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    MetaInterfaceImpl*  m_metainterfaceImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param MetaInterface - desc for MetaInterface parameter
     */
    MetaInterface( const MetaInterface& );
    MetaInterface& operator=( const MetaInterface& );

    friend class  MetaInterfaceDelegate;
    friend class  MetaInterfaceDispatch;
    friend class  MetaInterfaceGenImpl;
};

#include <meta/libmeta_undef.h>
#endif //   TEAMCENTER__METAINTERFACE__HXX
