//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Operation
    Filename:   Operation.hxx
    Module:     meta
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__OPERATION__HXX
#define TEAMCENTER__OPERATION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <meta/libmeta_exports.h>

namespace Teamcenter
{
    class Operation;
}
namespace Teamcenter
{
    class OperationImpl;
}
namespace Teamcenter
{
    class OperationDelegate;
}
namespace Teamcenter
{
    class OperationDispatch;
}
namespace Teamcenter
{
    class OperationGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  META_API  Teamcenter::Operation
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Boolean Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIsPostActionAllowed( bool &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIsPreActionAllowed( bool &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIsPreConditionAllowed( bool &value, bool &isNull ) const;

    ///
    /// Setter for a Boolean Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIsPostActionAllowed( bool value, bool isNull=false );

    ///
    /// Setter for a Boolean Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIsPreActionAllowed( bool value, bool isNull=false );

    ///
    /// Setter for a Boolean Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIsPreConditionAllowed( bool value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Operation();

    /**
     * Destructor
     */
    virtual ~Operation();

private:
    //  Getter method for the Implementation Object
    OperationImpl*  getOperationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setOperationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    OperationImpl*  m_operationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Operation - desc for Operation parameter
     */
    Operation( const Operation& );
    Operation& operator=( const Operation& );

    friend class  OperationDelegate;
    friend class  OperationDispatch;
    friend class  OperationGenImpl;
};

#include <meta/libmeta_undef.h>
#endif //   TEAMCENTER__OPERATION__HXX
