//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, OperationAttach
    Filename:   OperationAttach.hxx
    Module:     meta
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__OPERATIONATTACH__HXX
#define TEAMCENTER__OPERATIONATTACH__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <meta/libmeta_exports.h>

namespace Teamcenter
{
    class OperationAttach;
}
namespace Teamcenter
{
    class OperationAttachImpl;
}
namespace Teamcenter
{
    class OperationAttachDelegate;
}
namespace Teamcenter
{
    class OperationAttachDispatch;
}
namespace Teamcenter
{
    class OperationAttachGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  META_API  Teamcenter::OperationAttach
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    OperationAttach();

    /**
     * Destructor
     */
    virtual ~OperationAttach();

private:
    //  Getter method for the Implementation Object
    OperationAttachImpl*  getOperationAttachImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setOperationAttachImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    OperationAttachImpl*  m_operationattachImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param OperationAttach - desc for OperationAttach parameter
     */
    OperationAttach( const OperationAttach& );
    OperationAttach& operator=( const OperationAttach& );

    friend class  OperationAttachDelegate;
    friend class  OperationAttachDispatch;
    friend class  OperationAttachGenImpl;
};

#include <meta/libmeta_undef.h>
#endif //   TEAMCENTER__OPERATIONATTACH__HXX
