//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, OperationDelegate
    Filename:   OperationDelegate.hxx
    Module:     meta
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__OPERATIONDELEGATE_HXX
#define TEAMCENTER__OPERATIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <meta/Operation.hxx>

#include <meta/libmeta_exports.h>

namespace Teamcenter
{
    class OperationDelegate;
}
namespace Teamcenter
{
    class OperationImpl;
}
namespace Teamcenter
{
    class Operation;
}
namespace Teamcenter
{
    class OperationGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  META_API Teamcenter_alias::OperationDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the OperationDelegate instance
    static OperationDelegate&  getInstance();

    //  Method to create the OperationImpl pointer
    static OperationImpl*  createImpl( Operation&  ifObj );

    //  Method to delete the OperationImpl pointer
    static void deleteImpl( OperationImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIsPostActionAllowedBase(const Operation &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIsPreActionAllowedBase(const Operation &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIsPreConditionAllowedBase(const Operation &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Setter for a Boolean Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIsPostActionAllowedBase(Operation &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIsPreActionAllowedBase(Operation &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIsPreConditionAllowedBase(Operation &ifObj,  bool value, bool isNull );



protected:
    //  Pointer to the instance
    static OperationDelegate*  m_pInstance;

    OperationDelegate();
    virtual ~OperationDelegate();
    static void setInstance( OperationDelegate*  instance );


private:
    friend class  ::Teamcenter::OperationGenImpl;

};

#include <meta/libmeta_undef.h>
#endif  //  TEAMCENTER__OPERATIONDELEGATE_HXX
