//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, OperationParameter
    Filename:   OperationParameter.hxx
    Module:     meta
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__OPERATIONPARAMETER__HXX
#define TEAMCENTER__OPERATIONPARAMETER__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <meta/libmeta_exports.h>

namespace Teamcenter
{
    class OperationParameter;
}
namespace Teamcenter
{
    class OperationParameterImpl;
}
namespace Teamcenter
{
    class OperationParameterDelegate;
}
namespace Teamcenter
{
    class OperationParameterDispatch;
}
namespace Teamcenter
{
    class OperationParameterGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  META_API  Teamcenter::OperationParameter
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    OperationParameter();

    /**
     * Destructor
     */
    virtual ~OperationParameter();

private:
    //  Getter method for the Implementation Object
    OperationParameterImpl*  getOperationParameterImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setOperationParameterImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    OperationParameterImpl*  m_operationparameterImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param OperationParameter - desc for OperationParameter parameter
     */
    OperationParameter( const OperationParameter& );
    OperationParameter& operator=( const OperationParameter& );

    friend class  OperationParameterDelegate;
    friend class  OperationParameterDispatch;
    friend class  OperationParameterGenImpl;
};

#include <meta/libmeta_undef.h>
#endif //   TEAMCENTER__OPERATIONPARAMETER__HXX
