//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, OperationTemplate
    Filename:   OperationTemplate.hxx
    Module:     meta
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__OPERATIONTEMPLATE__HXX
#define TEAMCENTER__OPERATIONTEMPLATE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <meta/libmeta_exports.h>

namespace Teamcenter
{
    class OperationTemplate;
}
namespace Teamcenter
{
    class OperationTemplateImpl;
}
namespace Teamcenter
{
    class OperationTemplateDelegate;
}
namespace Teamcenter
{
    class OperationTemplateDispatch;
}
namespace Teamcenter
{
    class OperationTemplateGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  META_API  Teamcenter::OperationTemplate
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    OperationTemplate();

    /**
     * Destructor
     */
    virtual ~OperationTemplate();

private:
    //  Getter method for the Implementation Object
    OperationTemplateImpl*  getOperationTemplateImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setOperationTemplateImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    OperationTemplateImpl*  m_operationtemplateImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param OperationTemplate - desc for OperationTemplate parameter
     */
    OperationTemplate( const OperationTemplate& );
    OperationTemplate& operator=( const OperationTemplate& );

    friend class  OperationTemplateDelegate;
    friend class  OperationTemplateDispatch;
    friend class  OperationTemplateGenImpl;
};

#include <meta/libmeta_undef.h>
#endif //   TEAMCENTER__OPERATIONTEMPLATE__HXX
