//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ParameterInfo
    Filename:   ParameterInfo.hxx
    Module:     meta
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PARAMETERINFO__HXX
#define TEAMCENTER__PARAMETERINFO__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <meta/libmeta_exports.h>

namespace Teamcenter
{
    class ParameterInfo;
}
namespace Teamcenter
{
    class ParameterInfoImpl;
}
namespace Teamcenter
{
    class ParameterInfoDelegate;
}
namespace Teamcenter
{
    class ParameterInfoDispatch;
}
namespace Teamcenter
{
    class ParameterInfoGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  META_API  Teamcenter::ParameterInfo
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ParameterInfo();

    /**
     * Destructor
     */
    virtual ~ParameterInfo();

private:
    //  Getter method for the Implementation Object
    ParameterInfoImpl*  getParameterInfoImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setParameterInfoImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ParameterInfoImpl*  m_parameterinfoImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ParameterInfo - desc for ParameterInfo parameter
     */
    ParameterInfo( const ParameterInfo& );
    ParameterInfo& operator=( const ParameterInfo& );

    friend class  ParameterInfoDelegate;
    friend class  ParameterInfoDispatch;
    friend class  ParameterInfoGenImpl;
};

#include <meta/libmeta_undef.h>
#endif //   TEAMCENTER__PARAMETERINFO__HXX
