//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PrimitiveDataType
    Filename:   PrimitiveDataType.hxx
    Module:     meta
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PRIMITIVEDATATYPE__HXX
#define TEAMCENTER__PRIMITIVEDATATYPE__HXX

#include <common/tc_deprecation_macros.h>
#include <meta/DataType.hxx>

#include <meta/libmeta_exports.h>

namespace Teamcenter
{
    class PrimitiveDataType;
}
namespace Teamcenter
{
    class PrimitiveDataTypeImpl;
}
namespace Teamcenter
{
    class PrimitiveDataTypeDelegate;
}
namespace Teamcenter
{
    class PrimitiveDataTypeDispatch;
}
namespace Teamcenter
{
    class PrimitiveDataTypeGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  META_API  Teamcenter::PrimitiveDataType
     : public  ::Teamcenter::DataType
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PrimitiveDataType();

    /**
     * Destructor
     */
    virtual ~PrimitiveDataType();

private:
    //  Getter method for the Implementation Object
    PrimitiveDataTypeImpl*  getPrimitiveDataTypeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPrimitiveDataTypeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PrimitiveDataTypeImpl*  m_primitivedatatypeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PrimitiveDataType - desc for PrimitiveDataType parameter
     */
    PrimitiveDataType( const PrimitiveDataType& );
    PrimitiveDataType& operator=( const PrimitiveDataType& );

    friend class  PrimitiveDataTypeDelegate;
    friend class  PrimitiveDataTypeDispatch;
    friend class  PrimitiveDataTypeGenImpl;
};

#include <meta/libmeta_undef.h>
#endif //   TEAMCENTER__PRIMITIVEDATATYPE__HXX
