//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PropertyOperation
    Filename:   PropertyOperation.hxx
    Module:     meta
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROPERTYOPERATION__HXX
#define TEAMCENTER__PROPERTYOPERATION__HXX

#include <common/tc_deprecation_macros.h>
#include <meta/Operation.hxx>

#include <meta/libmeta_exports.h>

namespace Teamcenter
{
    class PropertyOperation;
}
namespace Teamcenter
{
    class PropertyOperationImpl;
}
namespace Teamcenter
{
    class PropertyOperationDelegate;
}
namespace Teamcenter
{
    class PropertyOperationDispatch;
}
namespace Teamcenter
{
    class PropertyOperationGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  META_API  Teamcenter::PropertyOperation
     : public  ::Teamcenter::Operation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PropertyOperation();

    /**
     * Destructor
     */
    virtual ~PropertyOperation();

private:
    //  Getter method for the Implementation Object
    PropertyOperationImpl*  getPropertyOperationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPropertyOperationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PropertyOperationImpl*  m_propertyoperationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PropertyOperation - desc for PropertyOperation parameter
     */
    PropertyOperation( const PropertyOperation& );
    PropertyOperation& operator=( const PropertyOperation& );

    friend class  PropertyOperationDelegate;
    friend class  PropertyOperationDispatch;
    friend class  PropertyOperationGenImpl;
};

#include <meta/libmeta_undef.h>
#endif //   TEAMCENTER__PROPERTYOPERATION__HXX
