//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PropertyOperationDelegate
    Filename:   PropertyOperationDelegate.hxx
    Module:     meta
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROPERTYOPERATIONDELEGATE_HXX
#define TEAMCENTER__PROPERTYOPERATIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <meta/PropertyOperation.hxx>

#include <meta/libmeta_exports.h>

namespace Teamcenter
{
    class PropertyOperationDelegate;
}
namespace Teamcenter
{
    class PropertyOperationImpl;
}
namespace Teamcenter
{
    class PropertyOperation;
}
namespace Teamcenter
{
    class PropertyOperationGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  META_API Teamcenter_alias::PropertyOperationDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PropertyOperationDelegate instance
    static PropertyOperationDelegate&  getInstance();

    //  Method to create the PropertyOperationImpl pointer
    static PropertyOperationImpl*  createImpl( PropertyOperation&  ifObj );

    //  Method to delete the PropertyOperationImpl pointer
    static void deleteImpl( PropertyOperationImpl*  impl );



protected:
    //  Pointer to the instance
    static PropertyOperationDelegate*  m_pInstance;

    PropertyOperationDelegate();
    virtual ~PropertyOperationDelegate();
    static void setInstance( PropertyOperationDelegate*  instance );


private:
    friend class  ::Teamcenter::PropertyOperationGenImpl;

};

#include <meta/libmeta_undef.h>
#endif  //  TEAMCENTER__PROPERTYOPERATIONDELEGATE_HXX
