//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Release
    Filename:   Release.hxx
    Module:     meta
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__RELEASE__HXX
#define TEAMCENTER__RELEASE__HXX

#include <string>
#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <meta/libmeta_exports.h>

namespace Teamcenter
{
    class Release;
}
namespace Teamcenter
{
    class ReleaseImpl;
}
namespace Teamcenter
{
    class ReleaseDelegate;
}
namespace Teamcenter
{
    class ReleaseDispatch;
}
namespace Teamcenter
{
    class ReleaseGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  META_API  Teamcenter::Release
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDescription( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDisplayName( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getName( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPriorRelease( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getReleaseType( int &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getServiceVersion( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDescription( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDisplayName( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setName( const std::string &value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPriorRelease( const tag_t &value, bool isNull=false );

    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setReleaseType( int value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setServiceVersion( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Release();

    /**
     * Destructor
     */
    virtual ~Release();

private:
    //  Getter method for the Implementation Object
    ReleaseImpl*  getReleaseImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setReleaseImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ReleaseImpl*  m_releaseImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Release - desc for Release parameter
     */
    Release( const Release& );
    Release& operator=( const Release& );

    friend class  ReleaseDelegate;
    friend class  ReleaseDispatch;
    friend class  ReleaseGenImpl;
};

#include <meta/libmeta_undef.h>
#endif //   TEAMCENTER__RELEASE__HXX
