//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ReleaseDelegate
    Filename:   ReleaseDelegate.hxx
    Module:     meta
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__RELEASEDELEGATE_HXX
#define TEAMCENTER__RELEASEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <meta/Release.hxx>

#include <meta/libmeta_exports.h>

namespace Teamcenter
{
    class ReleaseDelegate;
}
namespace Teamcenter
{
    class ReleaseImpl;
}
namespace Teamcenter
{
    class Release;
}
namespace Teamcenter
{
    class ReleaseGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  META_API Teamcenter_alias::ReleaseDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ReleaseDelegate instance
    static ReleaseDelegate&  getInstance();

    //  Method to create the ReleaseImpl pointer
    static ReleaseImpl*  createImpl( Release&  ifObj );

    //  Method to delete the ReleaseImpl pointer
    static void deleteImpl( ReleaseImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDescriptionBase(const Release &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDisplayNameBase(const Release &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getNameBase(const Release &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPriorReleaseBase(const Release &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getReleaseTypeBase(const Release &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getServiceVersionBase(const Release &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDescriptionBase(Release &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDisplayNameBase(Release &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setNameBase(Release &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPriorReleaseBase(Release &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setReleaseTypeBase(Release &ifObj,  int value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setServiceVersionBase(Release &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static ReleaseDelegate*  m_pInstance;

    ReleaseDelegate();
    virtual ~ReleaseDelegate();
    static void setInstance( ReleaseDelegate*  instance );


private:
    friend class  ::Teamcenter::ReleaseGenImpl;

};

#include <meta/libmeta_undef.h>
#endif  //  TEAMCENTER__RELEASEDELEGATE_HXX
