//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ServiceInterface
    Filename:   ServiceInterface.hxx
    Module:     meta
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEINTERFACE__HXX
#define TEAMCENTER__SERVICEINTERFACE__HXX

#include <common/tc_deprecation_macros.h>
#include <meta/MetaInterface.hxx>

#include <meta/libmeta_exports.h>

namespace Teamcenter
{
    class ServiceInterface;
}
namespace Teamcenter
{
    class ServiceInterfaceImpl;
}
namespace Teamcenter
{
    class ServiceInterfaceDelegate;
}
namespace Teamcenter
{
    class ServiceInterfaceDispatch;
}
namespace Teamcenter
{
    class ServiceInterfaceGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  META_API  Teamcenter::ServiceInterface
     : public  ::Teamcenter::MetaInterface
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ServiceInterface();

    /**
     * Destructor
     */
    virtual ~ServiceInterface();

private:
    //  Getter method for the Implementation Object
    ServiceInterfaceImpl*  getServiceInterfaceImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setServiceInterfaceImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ServiceInterfaceImpl*  m_serviceinterfaceImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ServiceInterface - desc for ServiceInterface parameter
     */
    ServiceInterface( const ServiceInterface& );
    ServiceInterface& operator=( const ServiceInterface& );

    friend class  ServiceInterfaceDelegate;
    friend class  ServiceInterfaceDispatch;
    friend class  ServiceInterfaceGenImpl;
};

#include <meta/libmeta_undef.h>
#endif //   TEAMCENTER__SERVICEINTERFACE__HXX
