//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Struct
    Filename:   Struct.hxx
    Module:     meta
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__STRUCT__HXX
#define TEAMCENTER__STRUCT__HXX

#include <common/tc_deprecation_macros.h>
#include <meta/GeneratedDataType.hxx>

#include <meta/libmeta_exports.h>

namespace Teamcenter
{
    class Struct;
}
namespace Teamcenter
{
    class StructImpl;
}
namespace Teamcenter
{
    class StructDelegate;
}
namespace Teamcenter
{
    class StructDispatch;
}
namespace Teamcenter
{
    class StructGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  META_API  Teamcenter::Struct
     : public  ::Teamcenter::GeneratedDataType
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Struct();

    /**
     * Destructor
     */
    virtual ~Struct();

private:
    //  Getter method for the Implementation Object
    StructImpl*  getStructImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setStructImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    StructImpl*  m_structImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Struct - desc for Struct parameter
     */
    Struct( const Struct& );
    Struct& operator=( const Struct& );

    friend class  StructDelegate;
    friend class  StructDispatch;
    friend class  StructGenImpl;
};

#include <meta/libmeta_undef.h>
#endif //   TEAMCENTER__STRUCT__HXX
