//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, StructElement
    Filename:   StructElement.hxx
    Module:     meta
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__STRUCTELEMENT__HXX
#define TEAMCENTER__STRUCTELEMENT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <meta/libmeta_exports.h>

namespace Teamcenter
{
    class StructElement;
}
namespace Teamcenter
{
    class StructElementImpl;
}
namespace Teamcenter
{
    class StructElementDelegate;
}
namespace Teamcenter
{
    class StructElementDispatch;
}
namespace Teamcenter
{
    class StructElementGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  META_API  Teamcenter::StructElement
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    StructElement();

    /**
     * Destructor
     */
    virtual ~StructElement();

private:
    //  Getter method for the Implementation Object
    StructElementImpl*  getStructElementImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setStructElementImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    StructElementImpl*  m_structelementImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param StructElement - desc for StructElement parameter
     */
    StructElement( const StructElement& );
    StructElement& operator=( const StructElement& );

    friend class  StructElementDelegate;
    friend class  StructElementDispatch;
    friend class  StructElementGenImpl;
};

#include <meta/libmeta_undef.h>
#endif //   TEAMCENTER__STRUCTELEMENT__HXX
