//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TemplateDataType
    Filename:   TemplateDataType.hxx
    Module:     meta
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TEMPLATEDATATYPE__HXX
#define TEAMCENTER__TEMPLATEDATATYPE__HXX

#include <common/tc_deprecation_macros.h>
#include <meta/ExternalDataType.hxx>

#include <meta/libmeta_exports.h>

namespace Teamcenter
{
    class TemplateDataType;
}
namespace Teamcenter
{
    class TemplateDataTypeImpl;
}
namespace Teamcenter
{
    class TemplateDataTypeDelegate;
}
namespace Teamcenter
{
    class TemplateDataTypeDispatch;
}
namespace Teamcenter
{
    class TemplateDataTypeGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  META_API  Teamcenter::TemplateDataType
     : public  ::Teamcenter::ExternalDataType
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getNumberOfArguments( int &value, bool &isNull ) const;

    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setNumberOfArguments( int value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    TemplateDataType();

    /**
     * Destructor
     */
    virtual ~TemplateDataType();

private:
    //  Getter method for the Implementation Object
    TemplateDataTypeImpl*  getTemplateDataTypeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTemplateDataTypeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    TemplateDataTypeImpl*  m_templatedatatypeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param TemplateDataType - desc for TemplateDataType parameter
     */
    TemplateDataType( const TemplateDataType& );
    TemplateDataType& operator=( const TemplateDataType& );

    friend class  TemplateDataTypeDelegate;
    friend class  TemplateDataTypeDispatch;
    friend class  TemplateDataTypeGenImpl;
};

#include <meta/libmeta_undef.h>
#endif //   TEAMCENTER__TEMPLATEDATATYPE__HXX
