//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TemplateDataTypeDelegate
    Filename:   TemplateDataTypeDelegate.hxx
    Module:     meta
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TEMPLATEDATATYPEDELEGATE_HXX
#define TEAMCENTER__TEMPLATEDATATYPEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <meta/TemplateDataType.hxx>

#include <meta/libmeta_exports.h>

namespace Teamcenter
{
    class TemplateDataTypeDelegate;
}
namespace Teamcenter
{
    class TemplateDataTypeImpl;
}
namespace Teamcenter
{
    class TemplateDataType;
}
namespace Teamcenter
{
    class TemplateDataTypeGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  META_API Teamcenter_alias::TemplateDataTypeDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the TemplateDataTypeDelegate instance
    static TemplateDataTypeDelegate&  getInstance();

    //  Method to create the TemplateDataTypeImpl pointer
    static TemplateDataTypeImpl*  createImpl( TemplateDataType&  ifObj );

    //  Method to delete the TemplateDataTypeImpl pointer
    static void deleteImpl( TemplateDataTypeImpl*  impl );


    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getNumberOfArgumentsBase(const TemplateDataType &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setNumberOfArgumentsBase(TemplateDataType &ifObj,  int value, bool isNull );



protected:
    //  Pointer to the instance
    static TemplateDataTypeDelegate*  m_pInstance;

    TemplateDataTypeDelegate();
    virtual ~TemplateDataTypeDelegate();
    static void setInstance( TemplateDataTypeDelegate*  instance );


private:
    friend class  ::Teamcenter::TemplateDataTypeGenImpl;

};

#include <meta/libmeta_undef.h>
#endif  //  TEAMCENTER__TEMPLATEDATATYPEDELEGATE_HXX
