//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Typedef
    Filename:   Typedef.hxx
    Module:     meta
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TYPEDEF__HXX
#define TEAMCENTER__TYPEDEF__HXX

#include <common/tc_deprecation_macros.h>
#include <meta/GeneratedDataType.hxx>

#include <meta/libmeta_exports.h>

namespace Teamcenter
{
    class Typedef;
}
namespace Teamcenter
{
    class TypedefImpl;
}
namespace Teamcenter
{
    class TypedefDelegate;
}
namespace Teamcenter
{
    class TypedefDispatch;
}
namespace Teamcenter
{
    class TypedefGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  META_API  Teamcenter::Typedef
     : public  ::Teamcenter::GeneratedDataType
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Typedef();

    /**
     * Destructor
     */
    virtual ~Typedef();

private:
    //  Getter method for the Implementation Object
    TypedefImpl*  getTypedefImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTypedefImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    TypedefImpl*  m_typedefImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Typedef - desc for Typedef parameter
     */
    Typedef( const Typedef& );
    Typedef& operator=( const Typedef& );

    friend class  TypedefDelegate;
    friend class  TypedefDispatch;
    friend class  TypedefGenImpl;
};

#include <meta/libmeta_undef.h>
#endif //   TEAMCENTER__TYPEDEF__HXX
