//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  meta

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libmeta

#if !defined(LIBMETA) && !defined(IPLIB)
#   error IPLIB or LIBMETA is not defined
#endif

/* Handwritten code should use META_API, not METAEXPORT */

#define META_API METAEXPORT

#if IPLIB==libmeta || defined(LIBMETA)
#   if defined(__lint)
#       define METAEXPORT       __export(meta)
#       define METAGLOBAL       extern __global(meta)
#       define METAPRIVATE      extern __private(meta)
#   elif defined(_WIN32)
#       define METAEXPORT       __declspec(dllexport)
#       define METAGLOBAL       extern __declspec(dllexport)
#       define METAPRIVATE      extern
#   else
#       define METAEXPORT
#       define METAGLOBAL       extern
#       define METAPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define METAEXPORT       __export(meta)
#       define METAGLOBAL       extern __global(meta)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define METAEXPORT      __declspec(dllimport)
#       define METAGLOBAL       extern __declspec(dllimport)
#   else
#       define METAEXPORT
#       define METAGLOBAL       extern
#   endif
#endif
