//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BulkCopyInput
    Filename:   BulkCopyInput.hxx
    Module:     metaframework
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BULKCOPYINPUT__HXX
#define TEAMCENTER__BULKCOPYINPUT__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <metaframework/BulkInput.hxx>

#include <metaframework/libmetaframework_exports.h>

namespace Teamcenter
{
    class BulkCopyInput;
}
namespace Teamcenter
{
    class BulkCopyInputImpl;
}
namespace Teamcenter
{
    class BulkCopyInputDelegate;
}
namespace Teamcenter
{
    class BulkCopyInputDispatch;
}
namespace Teamcenter
{
    class BulkCopyInputGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  METAFRAMEWORK_API  Teamcenter::BulkCopyInput
     : public  ::Teamcenter::BulkInput
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// 
    /// @version Teamcenter 11.2.2
    /// @param newTargetObjectTag - The new Target object Tag
    /// @return - 
    ///
    int  fnd0GetNewTargetObjectTag( tag_t &newTargetObjectTag );

    ///
    /// 
    /// @version Teamcenter 11.2.2
    /// @param newTargetObjectTag - this is the Target Object Tag
    /// @return - 
    ///
    int  fnd0SetNewTargetObjectTag( tag_t newTargetObjectTag );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    BulkCopyInput();

    /**
     * Destructor
     */
    virtual ~BulkCopyInput();

private:
    //  Getter method for the Implementation Object
    BulkCopyInputImpl*  getBulkCopyInputImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBulkCopyInputImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    BulkCopyInputImpl*  m_bulkcopyinputImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param BulkCopyInput - desc for BulkCopyInput parameter
     */
    BulkCopyInput( const BulkCopyInput& );
    BulkCopyInput& operator=( const BulkCopyInput& );

    friend class  BulkCopyInputDelegate;
    friend class  BulkCopyInputDispatch;
    friend class  BulkCopyInputGenImpl;
};

#include <metaframework/libmetaframework_undef.h>
#endif //   TEAMCENTER__BULKCOPYINPUT__HXX
