//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BulkCopyInputDelegate
    Filename:   BulkCopyInputDelegate.hxx
    Module:     metaframework
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BULKCOPYINPUTDELEGATE_HXX
#define TEAMCENTER__BULKCOPYINPUTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/BulkCopyInput.hxx>

#include <metaframework/libmetaframework_exports.h>

namespace Teamcenter
{
    class BulkCopyInputDelegate;
}
namespace Teamcenter
{
    class BulkCopyInputImpl;
}
namespace Teamcenter
{
    class BulkCopyInput;
}
namespace Teamcenter
{
    class BulkCopyInputGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  METAFRAMEWORK_API Teamcenter_alias::BulkCopyInputDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the BulkCopyInputDelegate instance
    static BulkCopyInputDelegate&  getInstance();

    //  Method to create the BulkCopyInputImpl pointer
    static BulkCopyInputImpl*  createImpl( BulkCopyInput&  ifObj );

    //  Method to delete the BulkCopyInputImpl pointer
    static void deleteImpl( BulkCopyInputImpl*  impl );


    ///
    /// 
    /// @version Teamcenter 11.2.2
    /// @param newTargetObjectTag - The new Target object Tag
    /// @return - 
    ///
    int  fnd0GetNewTargetObjectTagBase(const BulkCopyInput &ifObj,  tag_t &newTargetObjectTag );


    ///
    /// 
    /// @version Teamcenter 11.2.2
    /// @param newTargetObjectTag - this is the Target Object Tag
    /// @return - 
    ///
    int  fnd0SetNewTargetObjectTagBase(const BulkCopyInput &ifObj,  tag_t newTargetObjectTag );


    ///
    /// Creates and returns copy of current BulkInput object.
    /// @version Teamcenter 11.2.3
    /// @param copyObject - copy of current BulkInput
    /// @return - 
    ///
    int  fnd0GetCopyBase(const BulkCopyInput &ifObj,  ::Teamcenter::BulkInput *&copyObject );



protected:
    //  Pointer to the instance
    static BulkCopyInputDelegate*  m_pInstance;

    BulkCopyInputDelegate();
    virtual ~BulkCopyInputDelegate();
    static void setInstance( BulkCopyInputDelegate*  instance );


private:
    friend class  ::Teamcenter::BulkCopyInputGenImpl;

};

#include <metaframework/libmetaframework_undef.h>
#endif  //  TEAMCENTER__BULKCOPYINPUTDELEGATE_HXX
