//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BulkInput
    Filename:   BulkInput.hxx
    Module:     metaframework
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BULKINPUT__HXX
#define TEAMCENTER__BULKINPUT__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <metaframework/OperationInput.hxx>

#include <metaframework/libmetaframework_exports.h>

namespace Teamcenter
{
    class BulkInput;
}
namespace Teamcenter
{
    class BulkInputImpl;
}
namespace Teamcenter
{
    class BulkInputDelegate;
}
namespace Teamcenter
{
    class BulkInputDispatch;
}
namespace Teamcenter
{
    class BulkInputGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  METAFRAMEWORK_API  Teamcenter::BulkInput
     : public  ::Teamcenter::OperationInput
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Creates and returns copy of current BulkInput object
    /// @version Teamcenter 11.2.2
    /// @param copyObject - copy of current BulkInput object
    /// @deprecated #Teamcenter::BulkInput::fnd0Copy deprecated in Teamcenter 11.2.3
    /// @return - 
    ///
    TC_DEPRECATED_WITH_DEPRECATION_INFO("Teamcenter 11.2.3","Teamcenter::BulkInput::fnd0Copy","Users have to use fnd0GetCopy instead of fnd0Copy")
    int  fnd0Copy( ::Teamcenter::BulkInput *copyObject );

    ///
    /// Creates and returns copy of current BulkInput object.
    /// @version Teamcenter 11.2.3
    /// @param copyObject - copy of current BulkInput
    /// @return - 
    ///
    int  fnd0GetCopy( ::Teamcenter::BulkInput *&copyObject );

    ///
    /// Operation to identify Type tag of input object represented by BulkInput
    /// @version Teamcenter 11.2.2
    /// @param typeTag - Type tag of input object represented by BulkInput
    /// @return - 
    ///
    int  fnd0GetType( tag_t *typeTag );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    BulkInput();

    /**
     * Destructor
     */
    virtual ~BulkInput();

private:
    //  Getter method for the Implementation Object
    BulkInputImpl*  getBulkInputImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBulkInputImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    BulkInputImpl*  m_bulkinputImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param BulkInput - desc for BulkInput parameter
     */
    BulkInput( const BulkInput& );
    BulkInput& operator=( const BulkInput& );

    friend class  BulkInputDelegate;
    friend class  BulkInputDispatch;
    friend class  BulkInputGenImpl;
};

#include <metaframework/libmetaframework_undef.h>
#endif //   TEAMCENTER__BULKINPUT__HXX
