//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BulkInputDelegate
    Filename:   BulkInputDelegate.hxx
    Module:     metaframework
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BULKINPUTDELEGATE_HXX
#define TEAMCENTER__BULKINPUTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/BulkInput.hxx>

#include <metaframework/libmetaframework_exports.h>

namespace Teamcenter
{
    class BulkInputDelegate;
}
namespace Teamcenter
{
    class BulkInputImpl;
}
namespace Teamcenter
{
    class BulkInput;
}
namespace Teamcenter
{
    class BulkInputGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  METAFRAMEWORK_API Teamcenter_alias::BulkInputDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the BulkInputDelegate instance
    static BulkInputDelegate&  getInstance();

    //  Method to create the BulkInputImpl pointer
    static BulkInputImpl*  createImpl( BulkInput&  ifObj );

    //  Method to delete the BulkInputImpl pointer
    static void deleteImpl( BulkInputImpl*  impl );


    ///
    /// Creates and returns copy of current BulkInput object
    /// @version Teamcenter 11.2.2
    /// @param copyObject - copy of current BulkInput object
    /// @deprecated #Teamcenter::BulkInput::fnd0Copy deprecated in Teamcenter 11.2.3
    /// @return - 
    ///
    TC_DEPRECATED_WITH_DEPRECATION_INFO("Teamcenter 11.2.3","Teamcenter::BulkInput::fnd0Copy","Users have to use fnd0GetCopy instead of fnd0Copy")
    int  fnd0CopyBase(const BulkInput &ifObj,  ::Teamcenter::BulkInput *copyObject );


    ///
    /// Creates and returns copy of current BulkInput object.
    /// @version Teamcenter 11.2.3
    /// @param copyObject - copy of current BulkInput
    /// @return - 
    ///
    int  fnd0GetCopyBase(const BulkInput &ifObj,  ::Teamcenter::BulkInput *&copyObject );


    ///
    /// Operation to identify Type tag of input object represented by BulkInput
    /// @version Teamcenter 11.2.2
    /// @param typeTag - Type tag of input object represented by BulkInput
    /// @return - 
    ///
    int  fnd0GetTypeBase(const BulkInput &ifObj,  tag_t *typeTag );



protected:
    //  Pointer to the instance
    static BulkInputDelegate*  m_pInstance;

    BulkInputDelegate();
    virtual ~BulkInputDelegate();
    static void setInstance( BulkInputDelegate*  instance );


private:
    friend class  ::Teamcenter::BulkInputGenImpl;

};

#include <metaframework/libmetaframework_undef.h>
#endif  //  TEAMCENTER__BULKINPUTDELEGATE_HXX
