//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BulkSaveInput
    Filename:   BulkSaveInput.hxx
    Module:     metaframework
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BULKSAVEINPUT__HXX
#define TEAMCENTER__BULKSAVEINPUT__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/BulkInput.hxx>

#include <metaframework/libmetaframework_exports.h>

namespace Teamcenter
{
    class BulkSaveInput;
}
namespace Teamcenter
{
    class BulkSaveInputImpl;
}
namespace Teamcenter
{
    class BulkSaveInputDelegate;
}
namespace Teamcenter
{
    class BulkSaveInputDispatch;
}
namespace Teamcenter
{
    class BulkSaveInputGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  METAFRAMEWORK_API  Teamcenter::BulkSaveInput
     : public  ::Teamcenter::BulkInput
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    BulkSaveInput();

    /**
     * Destructor
     */
    virtual ~BulkSaveInput();

private:
    //  Getter method for the Implementation Object
    BulkSaveInputImpl*  getBulkSaveInputImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBulkSaveInputImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    BulkSaveInputImpl*  m_bulksaveinputImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param BulkSaveInput - desc for BulkSaveInput parameter
     */
    BulkSaveInput( const BulkSaveInput& );
    BulkSaveInput& operator=( const BulkSaveInput& );

    friend class  BulkSaveInputDelegate;
    friend class  BulkSaveInputDispatch;
    friend class  BulkSaveInputGenImpl;
};

#include <metaframework/libmetaframework_undef.h>
#endif //   TEAMCENTER__BULKSAVEINPUT__HXX
