//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BulkSaveInputDelegate
    Filename:   BulkSaveInputDelegate.hxx
    Module:     metaframework
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BULKSAVEINPUTDELEGATE_HXX
#define TEAMCENTER__BULKSAVEINPUTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/BulkSaveInput.hxx>

#include <metaframework/libmetaframework_exports.h>

namespace Teamcenter
{
    class BulkSaveInputDelegate;
}
namespace Teamcenter
{
    class BulkSaveInputImpl;
}
namespace Teamcenter
{
    class BulkSaveInput;
}
namespace Teamcenter
{
    class BulkSaveInputGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  METAFRAMEWORK_API Teamcenter_alias::BulkSaveInputDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the BulkSaveInputDelegate instance
    static BulkSaveInputDelegate&  getInstance();

    //  Method to create the BulkSaveInputImpl pointer
    static BulkSaveInputImpl*  createImpl( BulkSaveInput&  ifObj );

    //  Method to delete the BulkSaveInputImpl pointer
    static void deleteImpl( BulkSaveInputImpl*  impl );


    ///
    /// Creates and returns copy of current BulkInput object
    /// @version Teamcenter 11.2.2
    /// @param copyObject - copy of current BulkInput object
    /// @deprecated #Teamcenter::BulkInput::fnd0Copy deprecated in Teamcenter 11.2.3
    /// @return - 
    ///
    TC_DEPRECATED_WITH_DEPRECATION_INFO("Teamcenter 11.2.3","Teamcenter::BulkInput::fnd0Copy","Users have to use fnd0GetCopy instead of fnd0Copy")
    int  fnd0CopyBase(const BulkSaveInput &ifObj,  ::Teamcenter::BulkInput *copyObject );


    ///
    /// Creates and returns copy of current BulkInput object.
    /// @version Teamcenter 11.2.3
    /// @param copyObject - copy of current BulkInput
    /// @return - 
    ///
    int  fnd0GetCopyBase(const BulkSaveInput &ifObj,  ::Teamcenter::BulkInput *&copyObject );



protected:
    //  Pointer to the instance
    static BulkSaveInputDelegate*  m_pInstance;

    BulkSaveInputDelegate();
    virtual ~BulkSaveInputDelegate();
    static void setInstance( BulkSaveInputDelegate*  instance );


private:
    friend class  ::Teamcenter::BulkSaveInputGenImpl;

};

#include <metaframework/libmetaframework_undef.h>
#endif  //  TEAMCENTER__BULKSAVEINPUTDELEGATE_HXX
