//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CreateInputDelegate
    Filename:   CreateInputDelegate.hxx
    Module:     metaframework
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CREATEINPUTDELEGATE_HXX
#define TEAMCENTER__CREATEINPUTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/CreateInput.hxx>

#include <metaframework/libmetaframework_exports.h>

namespace Teamcenter
{
    class CreateInputDelegate;
}
namespace Teamcenter
{
    class CreateInputImpl;
}
namespace Teamcenter
{
    class CreateInput;
}
namespace Teamcenter
{
    class CreateInputGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  METAFRAMEWORK_API Teamcenter_alias::CreateInputDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CreateInputDelegate instance
    static CreateInputDelegate&  getInstance();

    //  Method to create the CreateInputImpl pointer
    static CreateInputImpl*  createImpl( CreateInput&  ifObj );

    //  Method to delete the CreateInputImpl pointer
    static void deleteImpl( CreateInputImpl*  impl );


    ///
    /// gets the compound object tags
    /// @version Teamcenter 10
    /// @param compoundObjectName - compound object's name
    /// @param compoundObjectTags - compound object tags
    /// @return - exit status
    ///
    int  getCompoundObjectArrayTagsBase(const CreateInput &ifObj,  std::string &compoundObjectName, std::vector< tag_t > &compoundObjectTags );


    ///
    /// The method getCompoundObjectTag is used retrieve the tag of any newly-created object listed as a Compound property on the CreateInput Descriptor. Please note: the "revision" property of Item is treated as a compound property by the system despite the Compound column not appearing checked in BMIDE.
    /// @version Tc 8
    /// @param compoundObjectName - compound object's name
    /// @param compoundObjectTag - compound objects tag
    /// @return - exit status
    ///
    int  getCompoundObjectTagBase(const CreateInput &ifObj,  std::string &compoundObjectName, tag_t &compoundObjectTag );


    ///
    /// The method getCompoundObjectTags is used to retrieve all the child objects tags created during the creation of the main object. For example, this function will return tags of ItemRevision, Item Master Form, ItemRevision Master Form for the newly-created Item.
    /// @version Tc 8
    /// @param compoundObjectTags - vector of compound object tag_ts
    /// @return - exit status
    ///
    int  getCompoundObjectTagsBase(const CreateInput &ifObj,  std::vector< tag_t > &compoundObjectTags );


    ///
    /// sets the compound object tags on the map with CreateInput
    /// @version Teamcenter 10
    /// @param compoundObjectName - Name of the compound object
    /// @param compoundObjectTags - compound object tags
    /// @return - exit status
    ///
    int  setCompoundObjectArrayTagsBase(const CreateInput &ifObj,  std::string &compoundObjectName, std::vector< tag_t > &compoundObjectTags );


    ///
    /// sets the compound object tag on the map with CreateInput
    /// @version Tc 8
    /// @param compoundObjectName - Name of the compound object
    /// @param compoundObjectTag - compound object's tag
    /// @return - exit status
    ///
    int  setCompoundObjectTagBase(const CreateInput &ifObj,  std::string &compoundObjectName, tag_t compoundObjectTag );



protected:
    //  Pointer to the instance
    static CreateInputDelegate*  m_pInstance;

    CreateInputDelegate();
    virtual ~CreateInputDelegate();
    static void setInstance( CreateInputDelegate*  instance );


private:
    friend class  ::Teamcenter::CreateInputGenImpl;

};

#include <metaframework/libmetaframework_undef.h>
#endif  //  TEAMCENTER__CREATEINPUTDELEGATE_HXX
