//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DeepCopyData
    Filename:   DeepCopyData.hxx
    Module:     metaframework
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__DEEPCOPYDATA__HXX
#define TEAMCENTER__DEEPCOPYDATA__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/OperationInput.hxx>

#include <metaframework/libmetaframework_exports.h>

namespace Teamcenter
{
    class DeepCopyData;
}
namespace Teamcenter
{
    class DeepCopyDataImpl;
}
namespace Teamcenter
{
    class DeepCopyDataDelegate;
}
namespace Teamcenter
{
    class DeepCopyDataDispatch;
}
namespace Teamcenter
{
    class DeepCopyDataGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  METAFRAMEWORK_API  Teamcenter::DeepCopyData
     : public  ::Teamcenter::OperationInput
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    DeepCopyData();

    /**
     * Destructor
     */
    virtual ~DeepCopyData();

private:
    //  Getter method for the Implementation Object
    DeepCopyDataImpl*  getDeepCopyDataImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDeepCopyDataImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DeepCopyDataImpl*  m_deepcopydataImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param DeepCopyData - desc for DeepCopyData parameter
     */
    DeepCopyData( const DeepCopyData& );
    DeepCopyData& operator=( const DeepCopyData& );

    friend class  DeepCopyDataDelegate;
    friend class  DeepCopyDataDispatch;
    friend class  DeepCopyDataGenImpl;
};

#include <metaframework/libmetaframework_undef.h>
#endif //   TEAMCENTER__DEEPCOPYDATA__HXX
