//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0CreateInput
    Filename:   Fnd0CreateInput.hxx
    Module:     metaframework
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0CREATEINPUT__HXX
#define TEAMCENTER__FND0CREATEINPUT__HXX

#include <metaframework/BusinessObject.hxx>
#include <common/tc_deprecation_macros.h>
#include <metaframework/BulkInput.hxx>

#include <metaframework/libmetaframework_exports.h>

namespace Teamcenter
{
    class Fnd0CreateInput;
}
namespace Teamcenter
{
    class Fnd0CreateInputImpl;
}
namespace Teamcenter
{
    class Fnd0CreateInputDelegate;
}
namespace Teamcenter
{
    class Fnd0CreateInputDispatch;
}
namespace Teamcenter
{
    class Fnd0CreateInputGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  METAFRAMEWORK_API  Teamcenter::Fnd0CreateInput
     : public  ::Teamcenter::BulkInput
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// 
    /// @version Teamcenter 11.4
    /// @param object - Get the corresponding business object
    /// @return - 
    ///
    int  fnd0GetObject( ::Teamcenter::BusinessObject *&object );

    ///
    /// 
    /// @version Teamcenter 11.4
    /// @param object - set the coresponding object
    /// @return - 
    ///
    int  fnd0SetObject( ::Teamcenter::BusinessObject *object );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0CreateInput();

    /**
     * Destructor
     */
    virtual ~Fnd0CreateInput();

private:
    //  Getter method for the Implementation Object
    Fnd0CreateInputImpl*  getFnd0CreateInputImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0CreateInputImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0CreateInputImpl*  m_fnd0createinputImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0CreateInput - desc for Fnd0CreateInput parameter
     */
    Fnd0CreateInput( const Fnd0CreateInput& );
    Fnd0CreateInput& operator=( const Fnd0CreateInput& );

    friend class  Fnd0CreateInputDelegate;
    friend class  Fnd0CreateInputDispatch;
    friend class  Fnd0CreateInputGenImpl;
};

#include <metaframework/libmetaframework_undef.h>
#endif //   TEAMCENTER__FND0CREATEINPUT__HXX
