//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0CreateInputDelegate
    Filename:   Fnd0CreateInputDelegate.hxx
    Module:     metaframework
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0CREATEINPUTDELEGATE_HXX
#define TEAMCENTER__FND0CREATEINPUTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/Fnd0CreateInput.hxx>

#include <metaframework/libmetaframework_exports.h>

namespace Teamcenter
{
    class Fnd0CreateInputDelegate;
}
namespace Teamcenter
{
    class Fnd0CreateInputImpl;
}
namespace Teamcenter
{
    class Fnd0CreateInput;
}
namespace Teamcenter
{
    class Fnd0CreateInputGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  METAFRAMEWORK_API Teamcenter_alias::Fnd0CreateInputDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0CreateInputDelegate instance
    static Fnd0CreateInputDelegate&  getInstance();

    //  Method to create the Fnd0CreateInputImpl pointer
    static Fnd0CreateInputImpl*  createImpl( Fnd0CreateInput&  ifObj );

    //  Method to delete the Fnd0CreateInputImpl pointer
    static void deleteImpl( Fnd0CreateInputImpl*  impl );


    ///
    /// 
    /// @version Teamcenter 11.4
    /// @param object - Get the corresponding business object
    /// @return - 
    ///
    int  fnd0GetObjectBase(const Fnd0CreateInput &ifObj,  ::Teamcenter::BusinessObject *&object );


    ///
    /// 
    /// @version Teamcenter 11.4
    /// @param object - set the coresponding object
    /// @return - 
    ///
    int  fnd0SetObjectBase(const Fnd0CreateInput &ifObj,  ::Teamcenter::BusinessObject *object );


    ///
    /// Creates and returns copy of current BulkInput object.
    /// @version Teamcenter 11.2.3
    /// @param copyObject - copy of current BulkInput
    /// @return - 
    ///
    int  fnd0GetCopyBase(const Fnd0CreateInput &ifObj,  ::Teamcenter::BulkInput *&copyObject );


    ///
    /// Operation to identify Type tag of input object represented by BulkInput
    /// @version Teamcenter 11.2.2
    /// @param typeTag - Type tag of input object represented by BulkInput
    /// @return - 
    ///
    int  fnd0GetTypeBase(const Fnd0CreateInput &ifObj,  tag_t *typeTag );



protected:
    //  Pointer to the instance
    static Fnd0CreateInputDelegate*  m_pInstance;

    Fnd0CreateInputDelegate();
    virtual ~Fnd0CreateInputDelegate();
    static void setInstance( Fnd0CreateInputDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0CreateInputGenImpl;

};

#include <metaframework/libmetaframework_undef.h>
#endif  //  TEAMCENTER__FND0CREATEINPUTDELEGATE_HXX
