//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0DeepCopyData
    Filename:   Fnd0DeepCopyData.hxx
    Module:     metaframework
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0DEEPCOPYDATA__HXX
#define TEAMCENTER__FND0DEEPCOPYDATA__HXX

#include <metaframework/DeepCopyData.hxx>
#include <common/tc_deprecation_macros.h>
#include <metaframework/BulkInput.hxx>

#include <metaframework/libmetaframework_exports.h>

namespace Teamcenter
{
    class Fnd0DeepCopyData;
}
namespace Teamcenter
{
    class Fnd0DeepCopyDataImpl;
}
namespace Teamcenter
{
    class Fnd0DeepCopyDataDelegate;
}
namespace Teamcenter
{
    class Fnd0DeepCopyDataDispatch;
}
namespace Teamcenter
{
    class Fnd0DeepCopyDataGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  METAFRAMEWORK_API  Teamcenter::Fnd0DeepCopyData
     : public  ::Teamcenter::BulkInput
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// 
    /// @version Teamcenter 11.4
    /// @param deepcopydatas - This is the corresponding deep copy data
    /// @return - 
    ///
    int  fnd0GetDeepCopyDataOutput( std::vector<  ::Teamcenter::DeepCopyData* > *deepcopydatas );

    ///
    /// 
    /// @version Teamcenter 11.4
    /// @param deepCopyData - This is the deep copy data
    /// @return - 
    ///
    int  fnd0SetDeepCopyDataOutput( std::vector<  ::Teamcenter::DeepCopyData* > *deepCopyData );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0DeepCopyData();

    /**
     * Destructor
     */
    virtual ~Fnd0DeepCopyData();

private:
    //  Getter method for the Implementation Object
    Fnd0DeepCopyDataImpl*  getFnd0DeepCopyDataImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0DeepCopyDataImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0DeepCopyDataImpl*  m_fnd0deepcopydataImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0DeepCopyData - desc for Fnd0DeepCopyData parameter
     */
    Fnd0DeepCopyData( const Fnd0DeepCopyData& );
    Fnd0DeepCopyData& operator=( const Fnd0DeepCopyData& );

    friend class  Fnd0DeepCopyDataDelegate;
    friend class  Fnd0DeepCopyDataDispatch;
    friend class  Fnd0DeepCopyDataGenImpl;
};

#include <metaframework/libmetaframework_undef.h>
#endif //   TEAMCENTER__FND0DEEPCOPYDATA__HXX
