//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0DeepCopyDataDelegate
    Filename:   Fnd0DeepCopyDataDelegate.hxx
    Module:     metaframework
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0DEEPCOPYDATADELEGATE_HXX
#define TEAMCENTER__FND0DEEPCOPYDATADELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/Fnd0DeepCopyData.hxx>

#include <metaframework/libmetaframework_exports.h>

namespace Teamcenter
{
    class Fnd0DeepCopyDataDelegate;
}
namespace Teamcenter
{
    class Fnd0DeepCopyDataImpl;
}
namespace Teamcenter
{
    class Fnd0DeepCopyData;
}
namespace Teamcenter
{
    class Fnd0DeepCopyDataGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  METAFRAMEWORK_API Teamcenter_alias::Fnd0DeepCopyDataDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0DeepCopyDataDelegate instance
    static Fnd0DeepCopyDataDelegate&  getInstance();

    //  Method to create the Fnd0DeepCopyDataImpl pointer
    static Fnd0DeepCopyDataImpl*  createImpl( Fnd0DeepCopyData&  ifObj );

    //  Method to delete the Fnd0DeepCopyDataImpl pointer
    static void deleteImpl( Fnd0DeepCopyDataImpl*  impl );


    ///
    /// 
    /// @version Teamcenter 11.4
    /// @param deepcopydatas - This is the corresponding deep copy data
    /// @return - 
    ///
    int  fnd0GetDeepCopyDataOutputBase(const Fnd0DeepCopyData &ifObj,  std::vector<  ::Teamcenter::DeepCopyData* > *deepcopydatas );


    ///
    /// 
    /// @version Teamcenter 11.4
    /// @param deepCopyData - This is the deep copy data
    /// @return - 
    ///
    int  fnd0SetDeepCopyDataOutputBase(const Fnd0DeepCopyData &ifObj,  std::vector<  ::Teamcenter::DeepCopyData* > *deepCopyData );


    ///
    /// Creates and returns copy of current BulkInput object.
    /// @version Teamcenter 11.2.3
    /// @param copyObject - copy of current BulkInput
    /// @return - 
    ///
    int  fnd0GetCopyBase(const Fnd0DeepCopyData &ifObj,  ::Teamcenter::BulkInput *&copyObject );



protected:
    //  Pointer to the instance
    static Fnd0DeepCopyDataDelegate*  m_pInstance;

    Fnd0DeepCopyDataDelegate();
    virtual ~Fnd0DeepCopyDataDelegate();
    static void setInstance( Fnd0DeepCopyDataDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0DeepCopyDataGenImpl;

};

#include <metaframework/libmetaframework_undef.h>
#endif  //  TEAMCENTER__FND0DEEPCOPYDATADELEGATE_HXX
