//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ReviseInput
    Filename:   ReviseInput.hxx
    Module:     metaframework
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REVISEINPUT__HXX
#define TEAMCENTER__REVISEINPUT__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/OperationInput.hxx>

#include <metaframework/libmetaframework_exports.h>

namespace Teamcenter
{
    class ReviseInput;
}
namespace Teamcenter
{
    class ReviseInputImpl;
}
namespace Teamcenter
{
    class ReviseInputDelegate;
}
namespace Teamcenter
{
    class ReviseInputDispatch;
}
namespace Teamcenter
{
    class ReviseInputGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  METAFRAMEWORK_API  Teamcenter::ReviseInput
     : public  ::Teamcenter::OperationInput
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ReviseInput();

    /**
     * Destructor
     */
    virtual ~ReviseInput();

private:
    //  Getter method for the Implementation Object
    ReviseInputImpl*  getReviseInputImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setReviseInputImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ReviseInputImpl*  m_reviseinputImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ReviseInput - desc for ReviseInput parameter
     */
    ReviseInput( const ReviseInput& );
    ReviseInput& operator=( const ReviseInput& );

    friend class  ReviseInputDelegate;
    friend class  ReviseInputDispatch;
    friend class  ReviseInputGenImpl;
};

#include <metaframework/libmetaframework_undef.h>
#endif //   TEAMCENTER__REVISEINPUT__HXX
