/*==================================================================================================

                    Copyright (c) 2007 UGS
                             Unpublished - All rights reserved

====================================================================================================
File description:

    Filename: RootObjectDispatch.hxx
    Module  : metaframework

    This is the top class of the business object dispatch class. All the pure virtual methods defined
    in BusinessObject must be implemented in this class. TcObject is the parent class of the class
    to ensure all the instances of dreived dispatch classes (from auto-generation) are managed by
    Teamcenter memory utility (new/delete).

====================================================================================================
   Date      Name                    Description of Change
17-Nov-2008  Krzysztof Blaszczyk     Added scope operator to friend class BusinessObjectRegistryImpl
$HISTORY$
==================================================================================================*/
#ifndef TEAMCENTER_ROOTOBJECTDISPATCH_HXX
#define TEAMCENTER_ROOTOBJECTDISPATCH_HXX
#include <metaframework/RootObject.hxx>

#include <metaframework/libmetaframework_exports.h>

namespace Teamcenter
{
    class RootObjectDispatch;
    class RootObjectImpl;
    class BusinessObjectRegistryImpl;
    class OperationDispatcher;
}

class METAFRAMEWORK_API Teamcenter::RootObjectDispatch :
    virtual public Teamcenter::RootObject
{
public:

    // static methods
    static int initializeClass();

protected:
    // initialization for object instantiation
    virtual void initialize(RootObjectImpl * impl = 0);

    // constructor
    RootObjectDispatch();
    // destructor
    virtual ~RootObjectDispatch();

private:

};
#include <metaframework/libmetaframework_undef.h>
#endif //TEAMCENTER_ROOTOBJECTDISPATCH_HXX
