//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RuntimeBusinessObject
    Filename:   RuntimeBusinessObject.hxx
    Module:     metaframework
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__RUNTIMEBUSINESSOBJECT__HXX
#define TEAMCENTER__RUNTIMEBUSINESSOBJECT__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/BusinessObject.hxx>

#include <metaframework/libmetaframework_exports.h>

namespace Teamcenter
{
    class RuntimeBusinessObject;
}
namespace Teamcenter
{
    class RuntimeBusinessObjectImpl;
}
namespace Teamcenter
{
    class RuntimeBusinessObjectDelegate;
}
namespace Teamcenter
{
    class RuntimeBusinessObjectDispatch;
}
namespace Teamcenter
{
    class RuntimeBusinessObjectGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  METAFRAMEWORK_API  Teamcenter::RuntimeBusinessObject
     : public  ::Teamcenter::BusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    RuntimeBusinessObject();

    /**
     * Destructor
     */
    virtual ~RuntimeBusinessObject();

private:
    //  Getter method for the Implementation Object
    RuntimeBusinessObjectImpl*  getRuntimeBusinessObjectImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRuntimeBusinessObjectImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    RuntimeBusinessObjectImpl*  m_runtimebusinessobjectImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param RuntimeBusinessObject - desc for RuntimeBusinessObject parameter
     */
    RuntimeBusinessObject( const RuntimeBusinessObject& );
    RuntimeBusinessObject& operator=( const RuntimeBusinessObject& );

    friend class  RuntimeBusinessObjectDelegate;
    friend class  RuntimeBusinessObjectDispatch;
    friend class  RuntimeBusinessObjectGenImpl;
};

#include <metaframework/libmetaframework_undef.h>
#endif //   TEAMCENTER__RUNTIMEBUSINESSOBJECT__HXX
