//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RuntimeBusinessObjectDelegate
    Filename:   RuntimeBusinessObjectDelegate.hxx
    Module:     metaframework
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__RUNTIMEBUSINESSOBJECTDELEGATE_HXX
#define TEAMCENTER__RUNTIMEBUSINESSOBJECTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <metaframework/libmetaframework_exports.h>

namespace Teamcenter
{
    class RuntimeBusinessObjectDelegate;
}
namespace Teamcenter
{
    class RuntimeBusinessObjectImpl;
}
namespace Teamcenter
{
    class RuntimeBusinessObject;
}
namespace Teamcenter
{
    class RuntimeBusinessObjectGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  METAFRAMEWORK_API Teamcenter_alias::RuntimeBusinessObjectDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the RuntimeBusinessObjectDelegate instance
    static RuntimeBusinessObjectDelegate&  getInstance();

    //  Method to create the RuntimeBusinessObjectImpl pointer
    static RuntimeBusinessObjectImpl*  createImpl( RuntimeBusinessObject&  ifObj );

    //  Method to delete the RuntimeBusinessObjectImpl pointer
    static void deleteImpl( RuntimeBusinessObjectImpl*  impl );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  createBase(const RuntimeBusinessObject &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const RuntimeBusinessObject &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const RuntimeBusinessObject &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const RuntimeBusinessObject &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const RuntimeBusinessObject &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static RuntimeBusinessObjectDelegate*  m_pInstance;

    RuntimeBusinessObjectDelegate();
    virtual ~RuntimeBusinessObjectDelegate();
    static void setInstance( RuntimeBusinessObjectDelegate*  instance );


private:
    friend class  ::Teamcenter::RuntimeBusinessObjectGenImpl;

};

#include <metaframework/libmetaframework_undef.h>
#endif  //  TEAMCENTER__RUNTIMEBUSINESSOBJECTDELEGATE_HXX
