//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SaveAsInput
    Filename:   SaveAsInput.hxx
    Module:     metaframework
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SAVEASINPUT__HXX
#define TEAMCENTER__SAVEASINPUT__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/OperationInput.hxx>

#include <metaframework/libmetaframework_exports.h>

namespace Teamcenter
{
    class SaveAsInput;
}
namespace Teamcenter
{
    class SaveAsInputImpl;
}
namespace Teamcenter
{
    class SaveAsInputDelegate;
}
namespace Teamcenter
{
    class SaveAsInputDispatch;
}
namespace Teamcenter
{
    class SaveAsInputGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  METAFRAMEWORK_API  Teamcenter::SaveAsInput
     : public  ::Teamcenter::OperationInput
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SaveAsInput();

    /**
     * Destructor
     */
    virtual ~SaveAsInput();

private:
    //  Getter method for the Implementation Object
    SaveAsInputImpl*  getSaveAsInputImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSaveAsInputImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SaveAsInputImpl*  m_saveasinputImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SaveAsInput - desc for SaveAsInput parameter
     */
    SaveAsInput( const SaveAsInput& );
    SaveAsInput& operator=( const SaveAsInput& );

    friend class  SaveAsInputDelegate;
    friend class  SaveAsInputDispatch;
    friend class  SaveAsInputGenImpl;
};

#include <metaframework/libmetaframework_undef.h>
#endif //   TEAMCENTER__SAVEASINPUT__HXX
