//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0ApprSchCriteriaEBOPAttr
    Filename:   Mfg0ApprSchCriteriaEBOPAttr.hxx
    Module:     mfg
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0APPRSCHCRITERIAEBOPATTR__HXX
#define TEAMCENTER__MFG0APPRSCHCRITERIAEBOPATTR__HXX

#include <string>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <rdv/ApprSearchCriteria.hxx>

#include <mfg/libmfg_exports.h>

namespace Teamcenter
{
    class Mfg0ApprSchCriteriaEBOPAttr;
}
namespace Teamcenter
{
    class Mfg0ApprSchCriteriaEBOPAttrImpl;
}
namespace Teamcenter
{
    class Mfg0ApprSchCriteriaEBOPAttrDelegate;
}
namespace Teamcenter
{
    class Mfg0ApprSchCriteriaEBOPAttrDispatch;
}
namespace Teamcenter
{
    class Mfg0ApprSchCriteriaEBOPAttrGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFG_API  Teamcenter::Mfg0ApprSchCriteriaEBOPAttr
     : public  ::Teamcenter::ApprSearchCriteria
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0type_name( std::string &value, bool &isNull ) const;

    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 10
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0logicaldesign_attrs( const std::vector< std::string > &values, const std::vector< int > *isNull=0 );

    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 10
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0logicaldesign_values( const std::vector< std::string > &values, const std::vector< int > *isNull=0 );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0type_name( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0ApprSchCriteriaEBOPAttr();

    /**
     * Destructor
     */
    virtual ~Mfg0ApprSchCriteriaEBOPAttr();

private:
    //  Getter method for the Implementation Object
    Mfg0ApprSchCriteriaEBOPAttrImpl*  getMfg0ApprSchCriteriaEBOPAttrImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0ApprSchCriteriaEBOPAttrImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0ApprSchCriteriaEBOPAttrImpl*  m_mfg0apprschcriteriaebopattrImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0ApprSchCriteriaEBOPAttr - desc for Mfg0ApprSchCriteriaEBOPAttr parameter
     */
    Mfg0ApprSchCriteriaEBOPAttr( const Mfg0ApprSchCriteriaEBOPAttr& );
    Mfg0ApprSchCriteriaEBOPAttr& operator=( const Mfg0ApprSchCriteriaEBOPAttr& );

    friend class  Mfg0ApprSchCriteriaEBOPAttrDelegate;
    friend class  Mfg0ApprSchCriteriaEBOPAttrDispatch;
    friend class  Mfg0ApprSchCriteriaEBOPAttrGenImpl;
};

#include <mfg/libmfg_undef.h>
#endif //   TEAMCENTER__MFG0APPRSCHCRITERIAEBOPATTR__HXX
