//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0AssociatedContainers
    Filename:   Mfg0AssociatedContainers.hxx
    Module:     mfg
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0ASSOCIATEDCONTAINERS__HXX
#define TEAMCENTER__MFG0ASSOCIATEDCONTAINERS__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <mfg/libmfg_exports.h>

namespace Teamcenter
{
    class Mfg0AssociatedContainers;
}
namespace Teamcenter
{
    class Mfg0AssociatedContainersImpl;
}
namespace Teamcenter
{
    class Mfg0AssociatedContainersDelegate;
}
namespace Teamcenter
{
    class Mfg0AssociatedContainersDispatch;
}
namespace Teamcenter
{
    class Mfg0AssociatedContainersGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFG_API  Teamcenter::Mfg0AssociatedContainers
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0AssociatedContainers();

    /**
     * Destructor
     */
    virtual ~Mfg0AssociatedContainers();

private:
    //  Getter method for the Implementation Object
    Mfg0AssociatedContainersImpl*  getMfg0AssociatedContainersImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0AssociatedContainersImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0AssociatedContainersImpl*  m_mfg0associatedcontainersImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0AssociatedContainers - desc for Mfg0AssociatedContainers parameter
     */
    Mfg0AssociatedContainers( const Mfg0AssociatedContainers& );
    Mfg0AssociatedContainers& operator=( const Mfg0AssociatedContainers& );

    friend class  Mfg0AssociatedContainersDelegate;
    friend class  Mfg0AssociatedContainersDispatch;
    friend class  Mfg0AssociatedContainersGenImpl;
};

#include <mfg/libmfg_undef.h>
#endif //   TEAMCENTER__MFG0ASSOCIATEDCONTAINERS__HXX
