//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0SearchCriteriaAttribute
    Filename:   Mfg0SearchCriteriaAttribute.hxx
    Module:     mfg
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0SEARCHCRITERIAATTRIBUTE__HXX
#define TEAMCENTER__MFG0SEARCHCRITERIAATTRIBUTE__HXX

#include <common/tc_deprecation_macros.h>
#include <rdv/ApprSearchCriteriaAttribute.hxx>

#include <mfg/libmfg_exports.h>

namespace Teamcenter
{
    class Mfg0SearchCriteriaAttribute;
}
namespace Teamcenter
{
    class Mfg0SearchCriteriaAttributeImpl;
}
namespace Teamcenter
{
    class Mfg0SearchCriteriaAttributeDelegate;
}
namespace Teamcenter
{
    class Mfg0SearchCriteriaAttributeDispatch;
}
namespace Teamcenter
{
    class Mfg0SearchCriteriaAttributeGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFG_API  Teamcenter::Mfg0SearchCriteriaAttribute
     : public  ::Teamcenter::ApprSearchCriteriaAttribute
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0SearchCriteriaAttribute();

    /**
     * Destructor
     */
    virtual ~Mfg0SearchCriteriaAttribute();

private:
    //  Getter method for the Implementation Object
    Mfg0SearchCriteriaAttributeImpl*  getMfg0SearchCriteriaAttributeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0SearchCriteriaAttributeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0SearchCriteriaAttributeImpl*  m_mfg0searchcriteriaattributeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0SearchCriteriaAttribute - desc for Mfg0SearchCriteriaAttribute parameter
     */
    Mfg0SearchCriteriaAttribute( const Mfg0SearchCriteriaAttribute& );
    Mfg0SearchCriteriaAttribute& operator=( const Mfg0SearchCriteriaAttribute& );

    friend class  Mfg0SearchCriteriaAttributeDelegate;
    friend class  Mfg0SearchCriteriaAttributeDispatch;
    friend class  Mfg0SearchCriteriaAttributeGenImpl;
};

#include <mfg/libmfg_undef.h>
#endif //   TEAMCENTER__MFG0SEARCHCRITERIAATTRIBUTE__HXX
