//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0SearchCriteriaGroup
    Filename:   Mfg0SearchCriteriaGroup.hxx
    Module:     mfg
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0SEARCHCRITERIAGROUP__HXX
#define TEAMCENTER__MFG0SEARCHCRITERIAGROUP__HXX

#include <common/tc_deprecation_macros.h>
#include <rdv/ApprSearchCriteriaGroup.hxx>

#include <mfg/libmfg_exports.h>

namespace Teamcenter
{
    class Mfg0SearchCriteriaGroup;
}
namespace Teamcenter
{
    class Mfg0SearchCriteriaGroupImpl;
}
namespace Teamcenter
{
    class Mfg0SearchCriteriaGroupDelegate;
}
namespace Teamcenter
{
    class Mfg0SearchCriteriaGroupDispatch;
}
namespace Teamcenter
{
    class Mfg0SearchCriteriaGroupGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFG_API  Teamcenter::Mfg0SearchCriteriaGroup
     : public  ::Teamcenter::ApprSearchCriteriaGroup
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0SearchCriteriaGroup();

    /**
     * Destructor
     */
    virtual ~Mfg0SearchCriteriaGroup();

private:
    //  Getter method for the Implementation Object
    Mfg0SearchCriteriaGroupImpl*  getMfg0SearchCriteriaGroupImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0SearchCriteriaGroupImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0SearchCriteriaGroupImpl*  m_mfg0searchcriteriagroupImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0SearchCriteriaGroup - desc for Mfg0SearchCriteriaGroup parameter
     */
    Mfg0SearchCriteriaGroup( const Mfg0SearchCriteriaGroup& );
    Mfg0SearchCriteriaGroup& operator=( const Mfg0SearchCriteriaGroup& );

    friend class  Mfg0SearchCriteriaGroupDelegate;
    friend class  Mfg0SearchCriteriaGroupDispatch;
    friend class  Mfg0SearchCriteriaGroupGenImpl;
};

#include <mfg/libmfg_undef.h>
#endif //   TEAMCENTER__MFG0SEARCHCRITERIAGROUP__HXX
