//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  mfg

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libmfg

#if !defined(LIBMFG) && !defined(IPLIB)
#   error IPLIB or LIBMFG is not defined
#endif

/* Handwritten code should use MFG_API, not MFGEXPORT */

#define MFG_API MFGEXPORT

#if IPLIB==libmfg || defined(LIBMFG)
#   if defined(__lint)
#       define MFGEXPORT       __export(mfg)
#       define MFGGLOBAL       extern __global(mfg)
#       define MFGPRIVATE      extern __private(mfg)
#   elif defined(_WIN32)
#       define MFGEXPORT       __declspec(dllexport)
#       define MFGGLOBAL       extern __declspec(dllexport)
#       define MFGPRIVATE      extern
#   else
#       define MFGEXPORT
#       define MFGGLOBAL       extern
#       define MFGPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define MFGEXPORT       __export(mfg)
#       define MFGGLOBAL       extern __global(mfg)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define MFGEXPORT      __declspec(dllimport)
#       define MFGGLOBAL       extern __declspec(dllimport)
#   else
#       define MFGEXPORT
#       define MFGGLOBAL       extern
#   endif
#endif
