//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MEProcessPartition
    Filename:   MEProcessPartition.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MEPROCESSPARTITION__HXX
#define TEAMCENTER__MEPROCESSPARTITION__HXX

#include <common/tc_deprecation_macros.h>
#include <ps/AppearanceGroup.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class MEProcessPartition;
}
namespace Teamcenter
{
    class MEProcessPartitionImpl;
}
namespace Teamcenter
{
    class MEProcessPartitionDelegate;
}
namespace Teamcenter
{
    class MEProcessPartitionDispatch;
}
namespace Teamcenter
{
    class MEProcessPartitionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::MEProcessPartition
     : public  ::Teamcenter::AppearanceGroup
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    MEProcessPartition();

    /**
     * Destructor
     */
    virtual ~MEProcessPartition();

private:
    //  Getter method for the Implementation Object
    MEProcessPartitionImpl*  getMEProcessPartitionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMEProcessPartitionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    MEProcessPartitionImpl*  m_meprocesspartitionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param MEProcessPartition - desc for MEProcessPartition parameter
     */
    MEProcessPartition( const MEProcessPartition& );
    MEProcessPartition& operator=( const MEProcessPartition& );

    friend class  MEProcessPartitionDelegate;
    friend class  MEProcessPartitionDispatch;
    friend class  MEProcessPartitionGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MEPROCESSPARTITION__HXX
