//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MEProcessPartitionDelegate
    Filename:   MEProcessPartitionDelegate.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MEPROCESSPARTITIONDELEGATE_HXX
#define TEAMCENTER__MEPROCESSPARTITIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/MEProcessPartition.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class MEProcessPartitionDelegate;
}
namespace Teamcenter
{
    class MEProcessPartitionImpl;
}
namespace Teamcenter
{
    class MEProcessPartition;
}
namespace Teamcenter
{
    class MEProcessPartitionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  MFGBVR_API Teamcenter_alias::MEProcessPartitionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the MEProcessPartitionDelegate instance
    static MEProcessPartitionDelegate&  getInstance();

    //  Method to create the MEProcessPartitionImpl pointer
    static MEProcessPartitionImpl*  createImpl( MEProcessPartition&  ifObj );

    //  Method to delete the MEProcessPartitionImpl pointer
    static void deleteImpl( MEProcessPartitionImpl*  impl );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const MEProcessPartition &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static MEProcessPartitionDelegate*  m_pInstance;

    MEProcessPartitionDelegate();
    virtual ~MEProcessPartitionDelegate();
    static void setInstance( MEProcessPartitionDelegate*  instance );


private:
    friend class  ::Teamcenter::MEProcessPartitionGenImpl;

};

#include <mfgbvr/libmfgbvr_undef.h>
#endif  //  TEAMCENTER__MEPROCESSPARTITIONDELEGATE_HXX
