//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MEProductBOP
    Filename:   MEProductBOP.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MEPRODUCTBOP__HXX
#define TEAMCENTER__MEPRODUCTBOP__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class MEProductBOP;
}
namespace Teamcenter
{
    class MEProductBOPImpl;
}
namespace Teamcenter
{
    class MEProductBOPDelegate;
}
namespace Teamcenter
{
    class MEProductBOPDispatch;
}
namespace Teamcenter
{
    class MEProductBOPGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::MEProductBOP
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0associated_context( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    MEProductBOP();

    /**
     * Destructor
     */
    virtual ~MEProductBOP();

private:
    //  Getter method for the Implementation Object
    MEProductBOPImpl*  getMEProductBOPImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMEProductBOPImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    MEProductBOPImpl*  m_meproductbopImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param MEProductBOP - desc for MEProductBOP parameter
     */
    MEProductBOP( const MEProductBOP& );
    MEProductBOP& operator=( const MEProductBOP& );

    friend class  MEProductBOPDelegate;
    friend class  MEProductBOPDispatch;
    friend class  MEProductBOPGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MEPRODUCTBOP__HXX
