//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrActivity
    Filename:   Mfg0BvrActivity.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRACTIVITY__HXX
#define TEAMCENTER__MFG0BVRACTIVITY__HXX

#include <common/tc_deprecation_macros.h>
#include <me/CfgActivityLine.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrActivity;
}
namespace Teamcenter
{
    class Mfg0BvrActivityImpl;
}
namespace Teamcenter
{
    class Mfg0BvrActivityDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrActivityDispatch;
}
namespace Teamcenter
{
    class Mfg0BvrActivityGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0BvrActivity
     : public  ::Teamcenter::CfgActivityLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0BvrActivity();

    /**
     * Destructor
     */
    virtual ~Mfg0BvrActivity();

private:
    //  Getter method for the Implementation Object
    Mfg0BvrActivityImpl*  getMfg0BvrActivityImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0BvrActivityImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0BvrActivityImpl*  m_mfg0bvractivityImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0BvrActivity - desc for Mfg0BvrActivity parameter
     */
    Mfg0BvrActivity( const Mfg0BvrActivity& );
    Mfg0BvrActivity& operator=( const Mfg0BvrActivity& );

    friend class  Mfg0BvrActivityDelegate;
    friend class  Mfg0BvrActivityDispatch;
    friend class  Mfg0BvrActivityGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0BVRACTIVITY__HXX
