//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrAlternativeScope
    Filename:   Mfg0BvrAlternativeScope.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRALTERNATIVESCOPE__HXX
#define TEAMCENTER__MFG0BVRALTERNATIVESCOPE__HXX

#include <common/tc_deprecation_macros.h>
#include <me/AppGroupBOPLine.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrAlternativeScope;
}
namespace Teamcenter
{
    class Mfg0BvrAlternativeScopeImpl;
}
namespace Teamcenter
{
    class Mfg0BvrAlternativeScopeDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrAlternativeScopeDispatch;
}
namespace Teamcenter
{
    class Mfg0BvrAlternativeScopeGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0BvrAlternativeScope
     : public  ::Teamcenter::AppGroupBOPLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0BvrAlternativeScope();

    /**
     * Destructor
     */
    virtual ~Mfg0BvrAlternativeScope();

private:
    //  Getter method for the Implementation Object
    Mfg0BvrAlternativeScopeImpl*  getMfg0BvrAlternativeScopeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0BvrAlternativeScopeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0BvrAlternativeScopeImpl*  m_mfg0bvralternativescopeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0BvrAlternativeScope - desc for Mfg0BvrAlternativeScope parameter
     */
    Mfg0BvrAlternativeScope( const Mfg0BvrAlternativeScope& );
    Mfg0BvrAlternativeScope& operator=( const Mfg0BvrAlternativeScope& );

    friend class  Mfg0BvrAlternativeScopeDelegate;
    friend class  Mfg0BvrAlternativeScopeDispatch;
    friend class  Mfg0BvrAlternativeScopeGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0BVRALTERNATIVESCOPE__HXX
