//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrBOPWorkarea
    Filename:   Mfg0BvrBOPWorkarea.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRBOPWORKAREA__HXX
#define TEAMCENTER__MFG0BVRBOPWORKAREA__HXX

#include <common/tc_deprecation_macros.h>
#include <me/ImanItemBOPLine.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrBOPWorkarea;
}
namespace Teamcenter
{
    class Mfg0BvrBOPWorkareaImpl;
}
namespace Teamcenter
{
    class Mfg0BvrBOPWorkareaDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrBOPWorkareaDispatch;
}
namespace Teamcenter
{
    class Mfg0BvrBOPWorkareaGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0BvrBOPWorkarea
     : public  ::Teamcenter::ImanItemBOPLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0BvrBOPWorkarea();

    /**
     * Destructor
     */
    virtual ~Mfg0BvrBOPWorkarea();

private:
    //  Getter method for the Implementation Object
    Mfg0BvrBOPWorkareaImpl*  getMfg0BvrBOPWorkareaImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0BvrBOPWorkareaImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0BvrBOPWorkareaImpl*  m_mfg0bvrbopworkareaImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0BvrBOPWorkarea - desc for Mfg0BvrBOPWorkarea parameter
     */
    Mfg0BvrBOPWorkarea( const Mfg0BvrBOPWorkarea& );
    Mfg0BvrBOPWorkarea& operator=( const Mfg0BvrBOPWorkarea& );

    friend class  Mfg0BvrBOPWorkareaDelegate;
    friend class  Mfg0BvrBOPWorkareaDispatch;
    friend class  Mfg0BvrBOPWorkareaGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0BVRBOPWORKAREA__HXX
