//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrBopManufacturingFeature
    Filename:   Mfg0BvrBopManufacturingFeature.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRBOPMANUFACTURINGFEATURE__HXX
#define TEAMCENTER__MFG0BVRBOPMANUFACTURINGFEATURE__HXX

#include <common/tc_deprecation_macros.h>
#include <me/ImanItemBOPLine.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrBopManufacturingFeature;
}
namespace Teamcenter
{
    class Mfg0BvrBopManufacturingFeatureImpl;
}
namespace Teamcenter
{
    class Mfg0BvrBopManufacturingFeatureDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrBopManufacturingFeatureDispatch;
}
namespace Teamcenter
{
    class Mfg0BvrBopManufacturingFeatureGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0BvrBopManufacturingFeature
     : public  ::Teamcenter::ImanItemBOPLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0BvrBopManufacturingFeature();

    /**
     * Destructor
     */
    virtual ~Mfg0BvrBopManufacturingFeature();

private:
    //  Getter method for the Implementation Object
    Mfg0BvrBopManufacturingFeatureImpl*  getMfg0BvrBopManufacturingFeatureImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0BvrBopManufacturingFeatureImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0BvrBopManufacturingFeatureImpl*  m_mfg0bvrbopmanufacturingfeatureImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0BvrBopManufacturingFeature - desc for Mfg0BvrBopManufacturingFeature parameter
     */
    Mfg0BvrBopManufacturingFeature( const Mfg0BvrBopManufacturingFeature& );
    Mfg0BvrBopManufacturingFeature& operator=( const Mfg0BvrBopManufacturingFeature& );

    friend class  Mfg0BvrBopManufacturingFeatureDelegate;
    friend class  Mfg0BvrBopManufacturingFeatureDispatch;
    friend class  Mfg0BvrBopManufacturingFeatureGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0BVRBOPMANUFACTURINGFEATURE__HXX
