//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrCompOPDelegate
    Filename:   Mfg0BvrCompOPDelegate.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRCOMPOPDELEGATE_HXX
#define TEAMCENTER__MFG0BVRCOMPOPDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrCompOP.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrCompOPDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrCompOPImpl;
}
namespace Teamcenter
{
    class Mfg0BvrCompOP;
}
namespace Teamcenter
{
    class Mfg0BvrCompOPGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  MFGBVR_API Teamcenter_alias::Mfg0BvrCompOPDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mfg0BvrCompOPDelegate instance
    static Mfg0BvrCompOPDelegate&  getInstance();

    //  Method to create the Mfg0BvrCompOPImpl pointer
    static Mfg0BvrCompOPImpl*  createImpl( Mfg0BvrCompOP&  ifObj );

    //  Method to delete the Mfg0BvrCompOPImpl pointer
    static void deleteImpl( Mfg0BvrCompOPImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0ExecPositionsBase(const Mfg0BvrCompOP &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 10.1.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0ExecPositionsBase(Mfg0BvrCompOP &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );



protected:
    //  Pointer to the instance
    static Mfg0BvrCompOPDelegate*  m_pInstance;

    Mfg0BvrCompOPDelegate();
    virtual ~Mfg0BvrCompOPDelegate();
    static void setInstance( Mfg0BvrCompOPDelegate*  instance );


private:
    friend class  ::Teamcenter::Mfg0BvrCompOPGenImpl;

};

#include <mfgbvr/libmfgbvr_undef.h>
#endif  //  TEAMCENTER__MFG0BVRCOMPOPDELEGATE_HXX
