//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrConstraint
    Filename:   Mfg0BvrConstraint.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRCONSTRAINT__HXX
#define TEAMCENTER__MFG0BVRCONSTRAINT__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrConstraint;
}
namespace Teamcenter
{
    class Mfg0BvrConstraintImpl;
}
namespace Teamcenter
{
    class Mfg0BvrConstraintDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrConstraintDispatch;
}
namespace Teamcenter
{
    class Mfg0BvrConstraintGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0BvrConstraint
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0properties_object( tag_t &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0BvrConstraint();

    /**
     * Destructor
     */
    virtual ~Mfg0BvrConstraint();

private:
    //  Getter method for the Implementation Object
    Mfg0BvrConstraintImpl*  getMfg0BvrConstraintImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0BvrConstraintImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0BvrConstraintImpl*  m_mfg0bvrconstraintImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0BvrConstraint - desc for Mfg0BvrConstraint parameter
     */
    Mfg0BvrConstraint( const Mfg0BvrConstraint& );
    Mfg0BvrConstraint& operator=( const Mfg0BvrConstraint& );

    friend class  Mfg0BvrConstraintDelegate;
    friend class  Mfg0BvrConstraintDispatch;
    friend class  Mfg0BvrConstraintGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0BVRCONSTRAINT__HXX
