//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrDatumDelegate
    Filename:   Mfg0BvrDatumDelegate.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRDATUMDELEGATE_HXX
#define TEAMCENTER__MFG0BVRDATUMDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrDatum.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrDatumDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrDatumImpl;
}
namespace Teamcenter
{
    class Mfg0BvrDatum;
}
namespace Teamcenter
{
    class Mfg0BvrDatumGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  MFGBVR_API Teamcenter_alias::Mfg0BvrDatumDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mfg0BvrDatumDelegate instance
    static Mfg0BvrDatumDelegate&  getInstance();

    //  Method to create the Mfg0BvrDatumImpl pointer
    static Mfg0BvrDatumImpl*  createImpl( Mfg0BvrDatum&  ifObj );

    //  Method to delete the Mfg0BvrDatumImpl pointer
    static void deleteImpl( Mfg0BvrDatumImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0cntrl_i_directionBase(const Mfg0BvrDatum &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0cntrl_j_directionBase(const Mfg0BvrDatum &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0cntrl_k_directionBase(const Mfg0BvrDatum &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0control_directionBase(const Mfg0BvrDatum &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0datum_typeBase(const Mfg0BvrDatum &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0datum_usage_typeBase(const Mfg0BvrDatum &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0cntrl_i_directionBase(Mfg0BvrDatum &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0cntrl_j_directionBase(Mfg0BvrDatum &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0cntrl_k_directionBase(Mfg0BvrDatum &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0control_directionBase(Mfg0BvrDatum &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0datum_typeBase(Mfg0BvrDatum &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0datum_usage_typeBase(Mfg0BvrDatum &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static Mfg0BvrDatumDelegate*  m_pInstance;

    Mfg0BvrDatumDelegate();
    virtual ~Mfg0BvrDatumDelegate();
    static void setInstance( Mfg0BvrDatumDelegate*  instance );


private:
    friend class  ::Teamcenter::Mfg0BvrDatumGenImpl;

};

#include <mfgbvr/libmfgbvr_undef.h>
#endif  //  TEAMCENTER__MFG0BVRDATUMDELEGATE_HXX
