//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrDynamicIPA
    Filename:   Mfg0BvrDynamicIPA.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRDYNAMICIPA__HXX
#define TEAMCENTER__MFG0BVRDYNAMICIPA__HXX

#include <common/tc_deprecation_macros.h>
#include <me/AppGroupBOPLine.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrDynamicIPA;
}
namespace Teamcenter
{
    class Mfg0BvrDynamicIPAImpl;
}
namespace Teamcenter
{
    class Mfg0BvrDynamicIPADelegate;
}
namespace Teamcenter
{
    class Mfg0BvrDynamicIPADispatch;
}
namespace Teamcenter
{
    class Mfg0BvrDynamicIPAGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0BvrDynamicIPA
     : public  ::Teamcenter::AppGroupBOPLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0BvrDynamicIPA();

    /**
     * Destructor
     */
    virtual ~Mfg0BvrDynamicIPA();

private:
    //  Getter method for the Implementation Object
    Mfg0BvrDynamicIPAImpl*  getMfg0BvrDynamicIPAImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0BvrDynamicIPAImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0BvrDynamicIPAImpl*  m_mfg0bvrdynamicipaImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0BvrDynamicIPA - desc for Mfg0BvrDynamicIPA parameter
     */
    Mfg0BvrDynamicIPA( const Mfg0BvrDynamicIPA& );
    Mfg0BvrDynamicIPA& operator=( const Mfg0BvrDynamicIPA& );

    friend class  Mfg0BvrDynamicIPADelegate;
    friend class  Mfg0BvrDynamicIPADispatch;
    friend class  Mfg0BvrDynamicIPAGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0BVRDYNAMICIPA__HXX
