//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrEBopContext
    Filename:   Mfg0BvrEBopContext.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVREBOPCONTEXT__HXX
#define TEAMCENTER__MFG0BVREBOPCONTEXT__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrProcessContext.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrEBopContext;
}
namespace Teamcenter
{
    class Mfg0BvrEBopContextImpl;
}
namespace Teamcenter
{
    class Mfg0BvrEBopContextDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrEBopContextDispatch;
}
namespace Teamcenter
{
    class Mfg0BvrEBopContextGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0BvrEBopContext
     : public  ::Teamcenter::Mfg0BvrProcessContext
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0partition_breakdowns( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0BvrEBopContext();

    /**
     * Destructor
     */
    virtual ~Mfg0BvrEBopContext();

private:
    //  Getter method for the Implementation Object
    Mfg0BvrEBopContextImpl*  getMfg0BvrEBopContextImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0BvrEBopContextImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0BvrEBopContextImpl*  m_mfg0bvrebopcontextImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0BvrEBopContext - desc for Mfg0BvrEBopContext parameter
     */
    Mfg0BvrEBopContext( const Mfg0BvrEBopContext& );
    Mfg0BvrEBopContext& operator=( const Mfg0BvrEBopContext& );

    friend class  Mfg0BvrEBopContextDelegate;
    friend class  Mfg0BvrEBopContextDispatch;
    friend class  Mfg0BvrEBopContextGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0BVREBOPCONTEXT__HXX
