//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrEquipment
    Filename:   Mfg0BvrEquipment.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVREQUIPMENT__HXX
#define TEAMCENTER__MFG0BVREQUIPMENT__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrResource.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrEquipment;
}
namespace Teamcenter
{
    class Mfg0BvrEquipmentImpl;
}
namespace Teamcenter
{
    class Mfg0BvrEquipmentDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrEquipmentDispatch;
}
namespace Teamcenter
{
    class Mfg0BvrEquipmentGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0BvrEquipment
     : public  ::Teamcenter::Mfg0BvrResource
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0used_by( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0BvrEquipment();

    /**
     * Destructor
     */
    virtual ~Mfg0BvrEquipment();

private:
    //  Getter method for the Implementation Object
    Mfg0BvrEquipmentImpl*  getMfg0BvrEquipmentImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0BvrEquipmentImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0BvrEquipmentImpl*  m_mfg0bvrequipmentImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0BvrEquipment - desc for Mfg0BvrEquipment parameter
     */
    Mfg0BvrEquipment( const Mfg0BvrEquipment& );
    Mfg0BvrEquipment& operator=( const Mfg0BvrEquipment& );

    friend class  Mfg0BvrEquipmentDelegate;
    friend class  Mfg0BvrEquipmentDispatch;
    friend class  Mfg0BvrEquipmentGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0BVREQUIPMENT__HXX
