//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrFlowDelegate
    Filename:   Mfg0BvrFlowDelegate.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRFLOWDELEGATE_HXX
#define TEAMCENTER__MFG0BVRFLOWDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrFlow.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrFlowDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrFlowImpl;
}
namespace Teamcenter
{
    class Mfg0BvrFlow;
}
namespace Teamcenter
{
    class Mfg0BvrFlowGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  MFGBVR_API Teamcenter_alias::Mfg0BvrFlowDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mfg0BvrFlowDelegate instance
    static Mfg0BvrFlowDelegate&  getInstance();

    //  Method to create the Mfg0BvrFlowImpl pointer
    static Mfg0BvrFlowImpl*  createImpl( Mfg0BvrFlow&  ifObj );

    //  Method to delete the Mfg0BvrFlowImpl pointer
    static void deleteImpl( Mfg0BvrFlowImpl*  impl );


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0delayBase(const Mfg0BvrFlow &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0implicitBase(const Mfg0BvrFlow &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0predecessorBase(const Mfg0BvrFlow &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0successorBase(const Mfg0BvrFlow &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Double Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0delayBase(Mfg0BvrFlow &ifObj,  double value, bool isNull );


    ///
    /// This is the getter for retrieving the recipe/permanent ID if its been created (and cached on the instance). Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param uid - Recipe/permanent ID
    /// @param isFirstTime - If Session Recovery Uid is yet to be set or does the object need to be serialized again?
    /// @return - Failure code
    ///
    int  fnd0AskSRUidBase(const Mfg0BvrFlow &ifObj,  std::string *uid, bool *isFirstTime ) const;


    ///
    /// Generates permanent ID/recipe. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param recipe - Permanent ID/recipe
    /// @return - Failure code.
    ///
    int  fnd0GenerateRecipeBase(const Mfg0BvrFlow &ifObj,  std::string *recipe );


    ///
    /// If Business Object supports recoverable ID. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param isPersistedRecipe - isPersistedRecipe param should be set to true if the recipe is limited to the user session and should be serialized to the database
    /// @param isRecoverableIDSupported - Returning true indicates support for recoverability/permanent IDs
    /// @return - Failure code.
    ///
    int  fnd0IsRecoverableBase(const Mfg0BvrFlow &ifObj,  bool *isPersistedRecipe, bool *isRecoverableIDSupported ) const;


    ///
    /// This is the setter for the recipe/permanent ID when it is created (to be cached on the instance). Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param uid - Rrecipe/permanent ID
    /// @return - Failure code.
    ///
    int  fnd0SetSRUidBase(const Mfg0BvrFlow &ifObj,  const std::string *uid );



protected:
    //  Pointer to the instance
    static Mfg0BvrFlowDelegate*  m_pInstance;

    Mfg0BvrFlowDelegate();
    virtual ~Mfg0BvrFlowDelegate();
    static void setInstance( Mfg0BvrFlowDelegate*  instance );


private:
    friend class  ::Teamcenter::Mfg0BvrFlowGenImpl;

};

#include <mfgbvr/libmfgbvr_undef.h>
#endif  //  TEAMCENTER__MFG0BVRFLOWDELEGATE_HXX
