//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrFolder
    Filename:   Mfg0BvrFolder.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRFOLDER__HXX
#define TEAMCENTER__MFG0BVRFOLDER__HXX

#include <vector>
#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <me/ImanItemBOPLine.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrFolder;
}
namespace Teamcenter
{
    class Mfg0BvrFolderImpl;
}
namespace Teamcenter
{
    class Mfg0BvrFolderDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrFolderDispatch;
}
namespace Teamcenter
{
    class Mfg0BvrFolderGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0BvrFolder
     : public  ::Teamcenter::ImanItemBOPLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0content( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0Parent( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0subFolders( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0BvrFolder();

    /**
     * Destructor
     */
    virtual ~Mfg0BvrFolder();

private:
    //  Getter method for the Implementation Object
    Mfg0BvrFolderImpl*  getMfg0BvrFolderImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0BvrFolderImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0BvrFolderImpl*  m_mfg0bvrfolderImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0BvrFolder - desc for Mfg0BvrFolder parameter
     */
    Mfg0BvrFolder( const Mfg0BvrFolder& );
    Mfg0BvrFolder& operator=( const Mfg0BvrFolder& );

    friend class  Mfg0BvrFolderDelegate;
    friend class  Mfg0BvrFolderDispatch;
    friend class  Mfg0BvrFolderGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0BVRFOLDER__HXX
