//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrFolderDelegate
    Filename:   Mfg0BvrFolderDelegate.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRFOLDERDELEGATE_HXX
#define TEAMCENTER__MFG0BVRFOLDERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrFolder.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrFolderDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrFolderImpl;
}
namespace Teamcenter
{
    class Mfg0BvrFolder;
}
namespace Teamcenter
{
    class Mfg0BvrFolderGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  MFGBVR_API Teamcenter_alias::Mfg0BvrFolderDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mfg0BvrFolderDelegate instance
    static Mfg0BvrFolderDelegate&  getInstance();

    //  Method to create the Mfg0BvrFolderImpl pointer
    static Mfg0BvrFolderImpl*  createImpl( Mfg0BvrFolder&  ifObj );

    //  Method to delete the Mfg0BvrFolderImpl pointer
    static void deleteImpl( Mfg0BvrFolderImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0contentBase(const Mfg0BvrFolder &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0ParentBase(const Mfg0BvrFolder &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0subFoldersBase(const Mfg0BvrFolder &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;



protected:
    //  Pointer to the instance
    static Mfg0BvrFolderDelegate*  m_pInstance;

    Mfg0BvrFolderDelegate();
    virtual ~Mfg0BvrFolderDelegate();
    static void setInstance( Mfg0BvrFolderDelegate*  instance );


private:
    friend class  ::Teamcenter::Mfg0BvrFolderGenImpl;

};

#include <mfgbvr/libmfgbvr_undef.h>
#endif  //  TEAMCENTER__MFG0BVRFOLDERDELEGATE_HXX
