//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrGenericBOP
    Filename:   Mfg0BvrGenericBOP.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRGENERICBOP__HXX
#define TEAMCENTER__MFG0BVRGENERICBOP__HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrEBopContext.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrGenericBOP;
}
namespace Teamcenter
{
    class Mfg0BvrGenericBOPImpl;
}
namespace Teamcenter
{
    class Mfg0BvrGenericBOPDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrGenericBOPDispatch;
}
namespace Teamcenter
{
    class Mfg0BvrGenericBOPGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0BvrGenericBOP
     : public  ::Teamcenter::Mfg0BvrEBopContext
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0BvrGenericBOP();

    /**
     * Destructor
     */
    virtual ~Mfg0BvrGenericBOP();

private:
    //  Getter method for the Implementation Object
    Mfg0BvrGenericBOPImpl*  getMfg0BvrGenericBOPImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0BvrGenericBOPImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0BvrGenericBOPImpl*  m_mfg0bvrgenericbopImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0BvrGenericBOP - desc for Mfg0BvrGenericBOP parameter
     */
    Mfg0BvrGenericBOP( const Mfg0BvrGenericBOP& );
    Mfg0BvrGenericBOP& operator=( const Mfg0BvrGenericBOP& );

    friend class  Mfg0BvrGenericBOPDelegate;
    friend class  Mfg0BvrGenericBOPDispatch;
    friend class  Mfg0BvrGenericBOPGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0BVRGENERICBOP__HXX
