//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrIPA
    Filename:   Mfg0BvrIPA.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRIPA__HXX
#define TEAMCENTER__MFG0BVRIPA__HXX

#include <common/tc_deprecation_macros.h>
#include <me/AppGroupBOPLine.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrIPA;
}
namespace Teamcenter
{
    class Mfg0BvrIPAImpl;
}
namespace Teamcenter
{
    class Mfg0BvrIPADelegate;
}
namespace Teamcenter
{
    class Mfg0BvrIPADispatch;
}
namespace Teamcenter
{
    class Mfg0BvrIPAGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0BvrIPA
     : public  ::Teamcenter::AppGroupBOPLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0BvrIPA();

    /**
     * Destructor
     */
    virtual ~Mfg0BvrIPA();

private:
    //  Getter method for the Implementation Object
    Mfg0BvrIPAImpl*  getMfg0BvrIPAImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0BvrIPAImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0BvrIPAImpl*  m_mfg0bvripaImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0BvrIPA - desc for Mfg0BvrIPA parameter
     */
    Mfg0BvrIPA( const Mfg0BvrIPA& );
    Mfg0BvrIPA& operator=( const Mfg0BvrIPA& );

    friend class  Mfg0BvrIPADelegate;
    friend class  Mfg0BvrIPADispatch;
    friend class  Mfg0BvrIPAGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0BVRIPA__HXX
