//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrLibrary
    Filename:   Mfg0BvrLibrary.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRLIBRARY__HXX
#define TEAMCENTER__MFG0BVRLIBRARY__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <me/ImanItemBOPLine.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrLibrary;
}
namespace Teamcenter
{
    class Mfg0BvrLibraryImpl;
}
namespace Teamcenter
{
    class Mfg0BvrLibraryDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrLibraryDispatch;
}
namespace Teamcenter
{
    class Mfg0BvrLibraryGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0BvrLibrary
     : public  ::Teamcenter::ImanItemBOPLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0RootFolders( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0BvrLibrary();

    /**
     * Destructor
     */
    virtual ~Mfg0BvrLibrary();

private:
    //  Getter method for the Implementation Object
    Mfg0BvrLibraryImpl*  getMfg0BvrLibraryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0BvrLibraryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0BvrLibraryImpl*  m_mfg0bvrlibraryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0BvrLibrary - desc for Mfg0BvrLibrary parameter
     */
    Mfg0BvrLibrary( const Mfg0BvrLibrary& );
    Mfg0BvrLibrary& operator=( const Mfg0BvrLibrary& );

    friend class  Mfg0BvrLibraryDelegate;
    friend class  Mfg0BvrLibraryDispatch;
    friend class  Mfg0BvrLibraryGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0BVRLIBRARY__HXX
