//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrLibraryDelegate
    Filename:   Mfg0BvrLibraryDelegate.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRLIBRARYDELEGATE_HXX
#define TEAMCENTER__MFG0BVRLIBRARYDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrLibrary.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrLibraryDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrLibraryImpl;
}
namespace Teamcenter
{
    class Mfg0BvrLibrary;
}
namespace Teamcenter
{
    class Mfg0BvrLibraryGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  MFGBVR_API Teamcenter_alias::Mfg0BvrLibraryDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mfg0BvrLibraryDelegate instance
    static Mfg0BvrLibraryDelegate&  getInstance();

    //  Method to create the Mfg0BvrLibraryImpl pointer
    static Mfg0BvrLibraryImpl*  createImpl( Mfg0BvrLibrary&  ifObj );

    //  Method to delete the Mfg0BvrLibraryImpl pointer
    static void deleteImpl( Mfg0BvrLibraryImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0RootFoldersBase(const Mfg0BvrLibrary &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;



protected:
    //  Pointer to the instance
    static Mfg0BvrLibraryDelegate*  m_pInstance;

    Mfg0BvrLibraryDelegate();
    virtual ~Mfg0BvrLibraryDelegate();
    static void setInstance( Mfg0BvrLibraryDelegate*  instance );


private:
    friend class  ::Teamcenter::Mfg0BvrLibraryGenImpl;

};

#include <mfgbvr/libmfgbvr_undef.h>
#endif  //  TEAMCENTER__MFG0BVRLIBRARYDELEGATE_HXX
