//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrLocalResourceLibrary
    Filename:   Mfg0BvrLocalResourceLibrary.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRLOCALRESOURCELIBRARY__HXX
#define TEAMCENTER__MFG0BVRLOCALRESOURCELIBRARY__HXX

#include <common/tc_deprecation_macros.h>
#include <bom/ImanItemLine.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrLocalResourceLibrary;
}
namespace Teamcenter
{
    class Mfg0BvrLocalResourceLibraryImpl;
}
namespace Teamcenter
{
    class Mfg0BvrLocalResourceLibraryDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrLocalResourceLibraryDispatch;
}
namespace Teamcenter
{
    class Mfg0BvrLocalResourceLibraryGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0BvrLocalResourceLibrary
     : public  ::Teamcenter::ImanItemLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0BvrLocalResourceLibrary();

    /**
     * Destructor
     */
    virtual ~Mfg0BvrLocalResourceLibrary();

private:
    //  Getter method for the Implementation Object
    Mfg0BvrLocalResourceLibraryImpl*  getMfg0BvrLocalResourceLibraryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0BvrLocalResourceLibraryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0BvrLocalResourceLibraryImpl*  m_mfg0bvrlocalresourcelibraryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0BvrLocalResourceLibrary - desc for Mfg0BvrLocalResourceLibrary parameter
     */
    Mfg0BvrLocalResourceLibrary( const Mfg0BvrLocalResourceLibrary& );
    Mfg0BvrLocalResourceLibrary& operator=( const Mfg0BvrLocalResourceLibrary& );

    friend class  Mfg0BvrLocalResourceLibraryDelegate;
    friend class  Mfg0BvrLocalResourceLibraryDispatch;
    friend class  Mfg0BvrLocalResourceLibraryGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0BVRLOCALRESOURCELIBRARY__HXX
