//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrLogicalAssignment
    Filename:   Mfg0BvrLogicalAssignment.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRLOGICALASSIGNMENT__HXX
#define TEAMCENTER__MFG0BVRLOGICALASSIGNMENT__HXX

#include <string>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0MELogicalAssignment.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrLogicalAssignment;
}
namespace Teamcenter
{
    class Mfg0BvrLogicalAssignmentImpl;
}
namespace Teamcenter
{
    class Mfg0BvrLogicalAssignmentDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrLogicalAssignmentDispatch;
}
namespace Teamcenter
{
    class Mfg0BvrLogicalAssignmentGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0BvrLogicalAssignment
     : public  ::Teamcenter::Mfg0MELogicalAssignment
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0assignment_description( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0assignment_name( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0assignment_type( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0criteria_representation( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0resolved_nodes( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0BvrLogicalAssignment();

    /**
     * Destructor
     */
    virtual ~Mfg0BvrLogicalAssignment();

private:
    //  Getter method for the Implementation Object
    Mfg0BvrLogicalAssignmentImpl*  getMfg0BvrLogicalAssignmentImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0BvrLogicalAssignmentImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0BvrLogicalAssignmentImpl*  m_mfg0bvrlogicalassignmentImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0BvrLogicalAssignment - desc for Mfg0BvrLogicalAssignment parameter
     */
    Mfg0BvrLogicalAssignment( const Mfg0BvrLogicalAssignment& );
    Mfg0BvrLogicalAssignment& operator=( const Mfg0BvrLogicalAssignment& );

    friend class  Mfg0BvrLogicalAssignmentDelegate;
    friend class  Mfg0BvrLogicalAssignmentDispatch;
    friend class  Mfg0BvrLogicalAssignmentGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0BVRLOGICALASSIGNMENT__HXX
