//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrLogicalAssignmentDelegate
    Filename:   Mfg0BvrLogicalAssignmentDelegate.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRLOGICALASSIGNMENTDELEGATE_HXX
#define TEAMCENTER__MFG0BVRLOGICALASSIGNMENTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrLogicalAssignment.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrLogicalAssignmentDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrLogicalAssignmentImpl;
}
namespace Teamcenter
{
    class Mfg0BvrLogicalAssignment;
}
namespace Teamcenter
{
    class Mfg0BvrLogicalAssignmentGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  MFGBVR_API Teamcenter_alias::Mfg0BvrLogicalAssignmentDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mfg0BvrLogicalAssignmentDelegate instance
    static Mfg0BvrLogicalAssignmentDelegate&  getInstance();

    //  Method to create the Mfg0BvrLogicalAssignmentImpl pointer
    static Mfg0BvrLogicalAssignmentImpl*  createImpl( Mfg0BvrLogicalAssignment&  ifObj );

    //  Method to delete the Mfg0BvrLogicalAssignmentImpl pointer
    static void deleteImpl( Mfg0BvrLogicalAssignmentImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0assignment_descriptionBase(const Mfg0BvrLogicalAssignment &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0assignment_nameBase(const Mfg0BvrLogicalAssignment &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0assignment_typeBase(const Mfg0BvrLogicalAssignment &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0criteria_representationBase(const Mfg0BvrLogicalAssignment &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0resolved_nodesBase(const Mfg0BvrLogicalAssignment &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Mfg0BvrLogicalAssignment &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Mfg0BvrLogicalAssignmentDelegate*  m_pInstance;

    Mfg0BvrLogicalAssignmentDelegate();
    virtual ~Mfg0BvrLogicalAssignmentDelegate();
    static void setInstance( Mfg0BvrLogicalAssignmentDelegate*  instance );


private:
    friend class  ::Teamcenter::Mfg0BvrLogicalAssignmentGenImpl;

};

#include <mfgbvr/libmfgbvr_undef.h>
#endif  //  TEAMCENTER__MFG0BVRLOGICALASSIGNMENTDELEGATE_HXX
