//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrManufacturingFeature
    Filename:   Mfg0BvrManufacturingFeature.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRMANUFACTURINGFEATURE__HXX
#define TEAMCENTER__MFG0BVRMANUFACTURINGFEATURE__HXX

#include <common/tc_deprecation_macros.h>
#include <bom/ImanItemLine.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrManufacturingFeature;
}
namespace Teamcenter
{
    class Mfg0BvrManufacturingFeatureImpl;
}
namespace Teamcenter
{
    class Mfg0BvrManufacturingFeatureDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrManufacturingFeatureDispatch;
}
namespace Teamcenter
{
    class Mfg0BvrManufacturingFeatureGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0BvrManufacturingFeature
     : public  ::Teamcenter::ImanItemLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0BvrManufacturingFeature();

    /**
     * Destructor
     */
    virtual ~Mfg0BvrManufacturingFeature();

private:
    //  Getter method for the Implementation Object
    Mfg0BvrManufacturingFeatureImpl*  getMfg0BvrManufacturingFeatureImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0BvrManufacturingFeatureImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0BvrManufacturingFeatureImpl*  m_mfg0bvrmanufacturingfeatureImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0BvrManufacturingFeature - desc for Mfg0BvrManufacturingFeature parameter
     */
    Mfg0BvrManufacturingFeature( const Mfg0BvrManufacturingFeature& );
    Mfg0BvrManufacturingFeature& operator=( const Mfg0BvrManufacturingFeature& );

    friend class  Mfg0BvrManufacturingFeatureDelegate;
    friend class  Mfg0BvrManufacturingFeatureDispatch;
    friend class  Mfg0BvrManufacturingFeatureGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0BVRMANUFACTURINGFEATURE__HXX
