//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrMaterial
    Filename:   Mfg0BvrMaterial.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRMATERIAL__HXX
#define TEAMCENTER__MFG0BVRMATERIAL__HXX

#include <common/tc_deprecation_macros.h>
#include <me/ImanItemBOPLine.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrMaterial;
}
namespace Teamcenter
{
    class Mfg0BvrMaterialImpl;
}
namespace Teamcenter
{
    class Mfg0BvrMaterialDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrMaterialDispatch;
}
namespace Teamcenter
{
    class Mfg0BvrMaterialGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0BvrMaterial
     : public  ::Teamcenter::ImanItemBOPLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0BvrMaterial();

    /**
     * Destructor
     */
    virtual ~Mfg0BvrMaterial();

private:
    //  Getter method for the Implementation Object
    Mfg0BvrMaterialImpl*  getMfg0BvrMaterialImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0BvrMaterialImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0BvrMaterialImpl*  m_mfg0bvrmaterialImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0BvrMaterial - desc for Mfg0BvrMaterial parameter
     */
    Mfg0BvrMaterial( const Mfg0BvrMaterial& );
    Mfg0BvrMaterial& operator=( const Mfg0BvrMaterial& );

    friend class  Mfg0BvrMaterialDelegate;
    friend class  Mfg0BvrMaterialDispatch;
    friend class  Mfg0BvrMaterialGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0BVRMATERIAL__HXX
