//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrPLC
    Filename:   Mfg0BvrPLC.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRPLC__HXX
#define TEAMCENTER__MFG0BVRPLC__HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrEquipment.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrPLC;
}
namespace Teamcenter
{
    class Mfg0BvrPLCImpl;
}
namespace Teamcenter
{
    class Mfg0BvrPLCDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrPLCDispatch;
}
namespace Teamcenter
{
    class Mfg0BvrPLCGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0BvrPLC
     : public  ::Teamcenter::Mfg0BvrEquipment
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0BvrPLC();

    /**
     * Destructor
     */
    virtual ~Mfg0BvrPLC();

private:
    //  Getter method for the Implementation Object
    Mfg0BvrPLCImpl*  getMfg0BvrPLCImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0BvrPLCImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0BvrPLCImpl*  m_mfg0bvrplcImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0BvrPLC - desc for Mfg0BvrPLC parameter
     */
    Mfg0BvrPLC( const Mfg0BvrPLC& );
    Mfg0BvrPLC& operator=( const Mfg0BvrPLC& );

    friend class  Mfg0BvrPLCDelegate;
    friend class  Mfg0BvrPLCDispatch;
    friend class  Mfg0BvrPLCGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0BVRPLC__HXX
