//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrPartitionDelegate
    Filename:   Mfg0BvrPartitionDelegate.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRPARTITIONDELEGATE_HXX
#define TEAMCENTER__MFG0BVRPARTITIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrPartition.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrPartitionDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrPartitionImpl;
}
namespace Teamcenter
{
    class Mfg0BvrPartition;
}
namespace Teamcenter
{
    class Mfg0BvrPartitionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  MFGBVR_API Teamcenter_alias::Mfg0BvrPartitionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mfg0BvrPartitionDelegate instance
    static Mfg0BvrPartitionDelegate&  getInstance();

    //  Method to create the Mfg0BvrPartitionImpl pointer
    static Mfg0BvrPartitionImpl*  createImpl( Mfg0BvrPartition&  ifObj );

    //  Method to delete the Mfg0BvrPartitionImpl pointer
    static void deleteImpl( Mfg0BvrPartitionImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0containerBase(const Mfg0BvrPartition &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0contentBase(const Mfg0BvrPartition &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0PositionDiagramBase(const Mfg0BvrPartition &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0sub_elementsBase(const Mfg0BvrPartition &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 10.1.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0PositionDiagramBase(Mfg0BvrPartition &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );



protected:
    //  Pointer to the instance
    static Mfg0BvrPartitionDelegate*  m_pInstance;

    Mfg0BvrPartitionDelegate();
    virtual ~Mfg0BvrPartitionDelegate();
    static void setInstance( Mfg0BvrPartitionDelegate*  instance );


private:
    friend class  ::Teamcenter::Mfg0BvrPartitionGenImpl;

};

#include <mfgbvr/libmfgbvr_undef.h>
#endif  //  TEAMCENTER__MFG0BVRPARTITIONDELEGATE_HXX
