//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrPlantBOPDelegate
    Filename:   Mfg0BvrPlantBOPDelegate.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRPLANTBOPDELEGATE_HXX
#define TEAMCENTER__MFG0BVRPLANTBOPDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrPlantBOP.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrPlantBOPDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrPlantBOPImpl;
}
namespace Teamcenter
{
    class Mfg0BvrPlantBOP;
}
namespace Teamcenter
{
    class Mfg0BvrPlantBOPGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  MFGBVR_API Teamcenter_alias::Mfg0BvrPlantBOPDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mfg0BvrPlantBOPDelegate instance
    static Mfg0BvrPlantBOPDelegate&  getInstance();

    //  Method to create the Mfg0BvrPlantBOPImpl pointer
    static Mfg0BvrPlantBOPImpl*  createImpl( Mfg0BvrPlantBOP&  ifObj );

    //  Method to delete the Mfg0BvrPlantBOPImpl pointer
    static void deleteImpl( Mfg0BvrPlantBOPImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0AllPositionDiagramsBase(const Mfg0BvrPlantBOP &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0appliedProdProgramsBase(const Mfg0BvrPlantBOP &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0associated_contextBase(const Mfg0BvrPlantBOP &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0productVariantsBase(const Mfg0BvrPlantBOP &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for an Integer Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0StationSizeBase(const Mfg0BvrPlantBOP &ifObj,  std::vector< int > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 10.1.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0AllPositionDiagramsBase(Mfg0BvrPlantBOP &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 10.1.2
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0appliedProdProgramsBase(Mfg0BvrPlantBOP &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 10.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0productVariantsBase(Mfg0BvrPlantBOP &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for an Integer Array Property
    /// @version Teamcenter 10.1
    /// @param values - Values to be set for the paramter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0StationSizeBase(Mfg0BvrPlantBOP &ifObj,  const std::vector< int > &values, const std::vector< int > *isNull );



protected:
    //  Pointer to the instance
    static Mfg0BvrPlantBOPDelegate*  m_pInstance;

    Mfg0BvrPlantBOPDelegate();
    virtual ~Mfg0BvrPlantBOPDelegate();
    static void setInstance( Mfg0BvrPlantBOPDelegate*  instance );


private:
    friend class  ::Teamcenter::Mfg0BvrPlantBOPGenImpl;

};

#include <mfgbvr/libmfgbvr_undef.h>
#endif  //  TEAMCENTER__MFG0BVRPLANTBOPDELEGATE_HXX
