//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrPlantEquipment
    Filename:   Mfg0BvrPlantEquipment.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRPLANTEQUIPMENT__HXX
#define TEAMCENTER__MFG0BVRPLANTEQUIPMENT__HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrPlantResource.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrPlantEquipment;
}
namespace Teamcenter
{
    class Mfg0BvrPlantEquipmentImpl;
}
namespace Teamcenter
{
    class Mfg0BvrPlantEquipmentDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrPlantEquipmentDispatch;
}
namespace Teamcenter
{
    class Mfg0BvrPlantEquipmentGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0BvrPlantEquipment
     : public  ::Teamcenter::Mfg0BvrPlantResource
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0BvrPlantEquipment();

    /**
     * Destructor
     */
    virtual ~Mfg0BvrPlantEquipment();

private:
    //  Getter method for the Implementation Object
    Mfg0BvrPlantEquipmentImpl*  getMfg0BvrPlantEquipmentImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0BvrPlantEquipmentImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0BvrPlantEquipmentImpl*  m_mfg0bvrplantequipmentImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0BvrPlantEquipment - desc for Mfg0BvrPlantEquipment parameter
     */
    Mfg0BvrPlantEquipment( const Mfg0BvrPlantEquipment& );
    Mfg0BvrPlantEquipment& operator=( const Mfg0BvrPlantEquipment& );

    friend class  Mfg0BvrPlantEquipmentDelegate;
    friend class  Mfg0BvrPlantEquipmentDispatch;
    friend class  Mfg0BvrPlantEquipmentGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0BVRPLANTEQUIPMENT__HXX
