//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrPlantPLC
    Filename:   Mfg0BvrPlantPLC.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRPLANTPLC__HXX
#define TEAMCENTER__MFG0BVRPLANTPLC__HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrPlantEquipment.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrPlantPLC;
}
namespace Teamcenter
{
    class Mfg0BvrPlantPLCImpl;
}
namespace Teamcenter
{
    class Mfg0BvrPlantPLCDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrPlantPLCDispatch;
}
namespace Teamcenter
{
    class Mfg0BvrPlantPLCGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0BvrPlantPLC
     : public  ::Teamcenter::Mfg0BvrPlantEquipment
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0BvrPlantPLC();

    /**
     * Destructor
     */
    virtual ~Mfg0BvrPlantPLC();

private:
    //  Getter method for the Implementation Object
    Mfg0BvrPlantPLCImpl*  getMfg0BvrPlantPLCImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0BvrPlantPLCImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0BvrPlantPLCImpl*  m_mfg0bvrplantplcImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0BvrPlantPLC - desc for Mfg0BvrPlantPLC parameter
     */
    Mfg0BvrPlantPLC( const Mfg0BvrPlantPLC& );
    Mfg0BvrPlantPLC& operator=( const Mfg0BvrPlantPLC& );

    friend class  Mfg0BvrPlantPLCDelegate;
    friend class  Mfg0BvrPlantPLCDispatch;
    friend class  Mfg0BvrPlantPLCGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0BVRPLANTPLC__HXX
