//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrPlantResource
    Filename:   Mfg0BvrPlantResource.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRPLANTRESOURCE__HXX
#define TEAMCENTER__MFG0BVRPLANTRESOURCE__HXX

#include <common/tc_deprecation_macros.h>
#include <bom/ImanItemLine.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrPlantResource;
}
namespace Teamcenter
{
    class Mfg0BvrPlantResourceImpl;
}
namespace Teamcenter
{
    class Mfg0BvrPlantResourceDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrPlantResourceDispatch;
}
namespace Teamcenter
{
    class Mfg0BvrPlantResourceGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0BvrPlantResource
     : public  ::Teamcenter::ImanItemLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0BvrPlantResource();

    /**
     * Destructor
     */
    virtual ~Mfg0BvrPlantResource();

private:
    //  Getter method for the Implementation Object
    Mfg0BvrPlantResourceImpl*  getMfg0BvrPlantResourceImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0BvrPlantResourceImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0BvrPlantResourceImpl*  m_mfg0bvrplantresourceImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0BvrPlantResource - desc for Mfg0BvrPlantResource parameter
     */
    Mfg0BvrPlantResource( const Mfg0BvrPlantResource& );
    Mfg0BvrPlantResource& operator=( const Mfg0BvrPlantResource& );

    friend class  Mfg0BvrPlantResourceDelegate;
    friend class  Mfg0BvrPlantResourceDispatch;
    friend class  Mfg0BvrPlantResourceGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0BVRPLANTRESOURCE__HXX
