//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrPlantRobot
    Filename:   Mfg0BvrPlantRobot.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRPLANTROBOT__HXX
#define TEAMCENTER__MFG0BVRPLANTROBOT__HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrPlantEquipment.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrPlantRobot;
}
namespace Teamcenter
{
    class Mfg0BvrPlantRobotImpl;
}
namespace Teamcenter
{
    class Mfg0BvrPlantRobotDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrPlantRobotDispatch;
}
namespace Teamcenter
{
    class Mfg0BvrPlantRobotGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0BvrPlantRobot
     : public  ::Teamcenter::Mfg0BvrPlantEquipment
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0BvrPlantRobot();

    /**
     * Destructor
     */
    virtual ~Mfg0BvrPlantRobot();

private:
    //  Getter method for the Implementation Object
    Mfg0BvrPlantRobotImpl*  getMfg0BvrPlantRobotImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0BvrPlantRobotImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0BvrPlantRobotImpl*  m_mfg0bvrplantrobotImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0BvrPlantRobot - desc for Mfg0BvrPlantRobot parameter
     */
    Mfg0BvrPlantRobot( const Mfg0BvrPlantRobot& );
    Mfg0BvrPlantRobot& operator=( const Mfg0BvrPlantRobot& );

    friend class  Mfg0BvrPlantRobotDelegate;
    friend class  Mfg0BvrPlantRobotDispatch;
    friend class  Mfg0BvrPlantRobotGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0BVRPLANTROBOT__HXX
