//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrPlantSensor
    Filename:   Mfg0BvrPlantSensor.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRPLANTSENSOR__HXX
#define TEAMCENTER__MFG0BVRPLANTSENSOR__HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrPlantEquipment.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrPlantSensor;
}
namespace Teamcenter
{
    class Mfg0BvrPlantSensorImpl;
}
namespace Teamcenter
{
    class Mfg0BvrPlantSensorDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrPlantSensorDispatch;
}
namespace Teamcenter
{
    class Mfg0BvrPlantSensorGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0BvrPlantSensor
     : public  ::Teamcenter::Mfg0BvrPlantEquipment
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0BvrPlantSensor();

    /**
     * Destructor
     */
    virtual ~Mfg0BvrPlantSensor();

private:
    //  Getter method for the Implementation Object
    Mfg0BvrPlantSensorImpl*  getMfg0BvrPlantSensorImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0BvrPlantSensorImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0BvrPlantSensorImpl*  m_mfg0bvrplantsensorImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0BvrPlantSensor - desc for Mfg0BvrPlantSensor parameter
     */
    Mfg0BvrPlantSensor( const Mfg0BvrPlantSensor& );
    Mfg0BvrPlantSensor& operator=( const Mfg0BvrPlantSensor& );

    friend class  Mfg0BvrPlantSensorDelegate;
    friend class  Mfg0BvrPlantSensorDispatch;
    friend class  Mfg0BvrPlantSensorGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0BVRPLANTSENSOR__HXX
