//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrPrecedenceConstraint
    Filename:   Mfg0BvrPrecedenceConstraint.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRPRECEDENCECONSTRAINT__HXX
#define TEAMCENTER__MFG0BVRPRECEDENCECONSTRAINT__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrConstraint.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrPrecedenceConstraint;
}
namespace Teamcenter
{
    class Mfg0BvrPrecedenceConstraintImpl;
}
namespace Teamcenter
{
    class Mfg0BvrPrecedenceConstraintDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrPrecedenceConstraintDispatch;
}
namespace Teamcenter
{
    class Mfg0BvrPrecedenceConstraintGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0BvrPrecedenceConstraint
     : public  ::Teamcenter::Mfg0BvrConstraint
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0implicit( bool &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0predecessor( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0successor( tag_t &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0BvrPrecedenceConstraint();

    /**
     * Destructor
     */
    virtual ~Mfg0BvrPrecedenceConstraint();

private:
    //  Getter method for the Implementation Object
    Mfg0BvrPrecedenceConstraintImpl*  getMfg0BvrPrecedenceConstraintImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0BvrPrecedenceConstraintImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0BvrPrecedenceConstraintImpl*  m_mfg0bvrprecedenceconstraintImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0BvrPrecedenceConstraint - desc for Mfg0BvrPrecedenceConstraint parameter
     */
    Mfg0BvrPrecedenceConstraint( const Mfg0BvrPrecedenceConstraint& );
    Mfg0BvrPrecedenceConstraint& operator=( const Mfg0BvrPrecedenceConstraint& );

    friend class  Mfg0BvrPrecedenceConstraintDelegate;
    friend class  Mfg0BvrPrecedenceConstraintDispatch;
    friend class  Mfg0BvrPrecedenceConstraintGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0BVRPRECEDENCECONSTRAINT__HXX
