//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrProcessContext
    Filename:   Mfg0BvrProcessContext.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRPROCESSCONTEXT__HXX
#define TEAMCENTER__MFG0BVRPROCESSCONTEXT__HXX

#include <common/tc_deprecation_macros.h>
#include <me/ImanItemBOPLine.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrProcessContext;
}
namespace Teamcenter
{
    class Mfg0BvrProcessContextImpl;
}
namespace Teamcenter
{
    class Mfg0BvrProcessContextDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrProcessContextDispatch;
}
namespace Teamcenter
{
    class Mfg0BvrProcessContextGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0BvrProcessContext
     : public  ::Teamcenter::ImanItemBOPLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0BvrProcessContext();

    /**
     * Destructor
     */
    virtual ~Mfg0BvrProcessContext();

private:
    //  Getter method for the Implementation Object
    Mfg0BvrProcessContextImpl*  getMfg0BvrProcessContextImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0BvrProcessContextImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0BvrProcessContextImpl*  m_mfg0bvrprocesscontextImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0BvrProcessContext - desc for Mfg0BvrProcessContext parameter
     */
    Mfg0BvrProcessContext( const Mfg0BvrProcessContext& );
    Mfg0BvrProcessContext& operator=( const Mfg0BvrProcessContext& );

    friend class  Mfg0BvrProcessContextDelegate;
    friend class  Mfg0BvrProcessContextDispatch;
    friend class  Mfg0BvrProcessContextGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0BVRPROCESSCONTEXT__HXX
