//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrProcessDelegate
    Filename:   Mfg0BvrProcessDelegate.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRPROCESSDELEGATE_HXX
#define TEAMCENTER__MFG0BVRPROCESSDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrProcess.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrProcessDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrProcessImpl;
}
namespace Teamcenter
{
    class Mfg0BvrProcess;
}
namespace Teamcenter
{
    class Mfg0BvrProcessGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  MFGBVR_API Teamcenter_alias::Mfg0BvrProcessDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mfg0BvrProcessDelegate instance
    static Mfg0BvrProcessDelegate&  getInstance();

    //  Method to create the Mfg0BvrProcessImpl pointer
    static Mfg0BvrProcessImpl*  createImpl( Mfg0BvrProcess&  ifObj );

    //  Method to delete the Mfg0BvrProcessImpl pointer
    static void deleteImpl( Mfg0BvrProcessImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0all_materialBase(const Mfg0BvrProcess &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0allocated_featureBase(const Mfg0BvrProcess &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0allocated_timeBase(const Mfg0BvrProcess &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0assigned_materialBase(const Mfg0BvrProcess &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0assigned_workareaBase(const Mfg0BvrProcess &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0calc_dur_start_timeBase(const Mfg0BvrProcess &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0calc_durationBase(const Mfg0BvrProcess &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0calc_start_timeBase(const Mfg0BvrProcess &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0consumed_materialBase(const Mfg0BvrProcess &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0containerBase(const Mfg0BvrProcess &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0has_originBase(const Mfg0BvrProcess &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0implementationsBase(const Mfg0BvrProcess &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0input_flowsBase(const Mfg0BvrProcess &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 13.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0input_scope_flowsBase(const Mfg0BvrProcess &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0ld_representationBase(const Mfg0BvrProcess &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0originBase(const Mfg0BvrProcess &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0other_materialBase(const Mfg0BvrProcess &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0output_flowsBase(const Mfg0BvrProcess &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 13.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0output_scope_flowsBase(const Mfg0BvrProcess &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0prec_const_predecessorsBase(const Mfg0BvrProcess &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0prec_const_successorsBase(const Mfg0BvrProcess &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0predecessorsBase(const Mfg0BvrProcess &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0processResourceBase(const Mfg0BvrProcess &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0sub_elementsBase(const Mfg0BvrProcess &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0successorsBase(const Mfg0BvrProcess &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0used_equipmentBase(const Mfg0BvrProcess &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a Double Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0allocated_timeBase(Mfg0BvrProcess &ifObj,  double value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0calc_start_timeBase(Mfg0BvrProcess &ifObj,  double value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10.1.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0processResourceBase(Mfg0BvrProcess &ifObj,  const tag_t &value, bool isNull );



protected:
    //  Pointer to the instance
    static Mfg0BvrProcessDelegate*  m_pInstance;

    Mfg0BvrProcessDelegate();
    virtual ~Mfg0BvrProcessDelegate();
    static void setInstance( Mfg0BvrProcessDelegate*  instance );


private:
    friend class  ::Teamcenter::Mfg0BvrProcessGenImpl;

};

#include <mfgbvr/libmfgbvr_undef.h>
#endif  //  TEAMCENTER__MFG0BVRPROCESSDELEGATE_HXX
