//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrProcessLine
    Filename:   Mfg0BvrProcessLine.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRPROCESSLINE__HXX
#define TEAMCENTER__MFG0BVRPROCESSLINE__HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrProcessArea.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrProcessLine;
}
namespace Teamcenter
{
    class Mfg0BvrProcessLineImpl;
}
namespace Teamcenter
{
    class Mfg0BvrProcessLineDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrProcessLineDispatch;
}
namespace Teamcenter
{
    class Mfg0BvrProcessLineGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0BvrProcessLine
     : public  ::Teamcenter::Mfg0BvrProcessArea
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0BvrProcessLine();

    /**
     * Destructor
     */
    virtual ~Mfg0BvrProcessLine();

private:
    //  Getter method for the Implementation Object
    Mfg0BvrProcessLineImpl*  getMfg0BvrProcessLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0BvrProcessLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0BvrProcessLineImpl*  m_mfg0bvrprocesslineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0BvrProcessLine - desc for Mfg0BvrProcessLine parameter
     */
    Mfg0BvrProcessLine( const Mfg0BvrProcessLine& );
    Mfg0BvrProcessLine& operator=( const Mfg0BvrProcessLine& );

    friend class  Mfg0BvrProcessLineDelegate;
    friend class  Mfg0BvrProcessLineDispatch;
    friend class  Mfg0BvrProcessLineGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0BVRPROCESSLINE__HXX
