//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrProcessPartition
    Filename:   Mfg0BvrProcessPartition.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRPROCESSPARTITION__HXX
#define TEAMCENTER__MFG0BVRPROCESSPARTITION__HXX

#include <unidefs.h>
#include <string>
#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrPartition.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrProcessPartition;
}
namespace Teamcenter
{
    class Mfg0BvrProcessPartitionImpl;
}
namespace Teamcenter
{
    class Mfg0BvrProcessPartitionDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrProcessPartitionDispatch;
}
namespace Teamcenter
{
    class Mfg0BvrProcessPartitionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0BvrProcessPartition
     : public  ::Teamcenter::Mfg0BvrPartition
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0context( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0ld_representation( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0origin( tag_t &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0BvrProcessPartition();

    /**
     * Destructor
     */
    virtual ~Mfg0BvrProcessPartition();

private:
    //  Getter method for the Implementation Object
    Mfg0BvrProcessPartitionImpl*  getMfg0BvrProcessPartitionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0BvrProcessPartitionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0BvrProcessPartitionImpl*  m_mfg0bvrprocesspartitionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0BvrProcessPartition - desc for Mfg0BvrProcessPartition parameter
     */
    Mfg0BvrProcessPartition( const Mfg0BvrProcessPartition& );
    Mfg0BvrProcessPartition& operator=( const Mfg0BvrProcessPartition& );

    friend class  Mfg0BvrProcessPartitionDelegate;
    friend class  Mfg0BvrProcessPartitionDispatch;
    friend class  Mfg0BvrProcessPartitionGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0BVRPROCESSPARTITION__HXX
