//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrProcessPartitionDelegate
    Filename:   Mfg0BvrProcessPartitionDelegate.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRPROCESSPARTITIONDELEGATE_HXX
#define TEAMCENTER__MFG0BVRPROCESSPARTITIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrProcessPartition.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrProcessPartitionDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrProcessPartitionImpl;
}
namespace Teamcenter
{
    class Mfg0BvrProcessPartition;
}
namespace Teamcenter
{
    class Mfg0BvrProcessPartitionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  MFGBVR_API Teamcenter_alias::Mfg0BvrProcessPartitionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mfg0BvrProcessPartitionDelegate instance
    static Mfg0BvrProcessPartitionDelegate&  getInstance();

    //  Method to create the Mfg0BvrProcessPartitionImpl pointer
    static Mfg0BvrProcessPartitionImpl*  createImpl( Mfg0BvrProcessPartition&  ifObj );

    //  Method to delete the Mfg0BvrProcessPartitionImpl pointer
    static void deleteImpl( Mfg0BvrProcessPartitionImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0contextBase(const Mfg0BvrProcessPartition &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0ld_representationBase(const Mfg0BvrProcessPartition &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0originBase(const Mfg0BvrProcessPartition &ifObj,  tag_t &value, bool &isNull ) const;



protected:
    //  Pointer to the instance
    static Mfg0BvrProcessPartitionDelegate*  m_pInstance;

    Mfg0BvrProcessPartitionDelegate();
    virtual ~Mfg0BvrProcessPartitionDelegate();
    static void setInstance( Mfg0BvrProcessPartitionDelegate*  instance );


private:
    friend class  ::Teamcenter::Mfg0BvrProcessPartitionGenImpl;

};

#include <mfgbvr/libmfgbvr_undef.h>
#endif  //  TEAMCENTER__MFG0BVRPROCESSPARTITIONDELEGATE_HXX
