//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrProcessResource
    Filename:   Mfg0BvrProcessResource.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRPROCESSRESOURCE__HXX
#define TEAMCENTER__MFG0BVRPROCESSRESOURCE__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrProcessArea.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrProcessResource;
}
namespace Teamcenter
{
    class Mfg0BvrProcessResourceImpl;
}
namespace Teamcenter
{
    class Mfg0BvrProcessResourceDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrProcessResourceDispatch;
}
namespace Teamcenter
{
    class Mfg0BvrProcessResourceGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0BvrProcessResource
     : public  ::Teamcenter::Mfg0BvrProcessArea
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0allocatedBOPLines( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a Double Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0utilization( double &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 10.1.2
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0allocatedBOPLines( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );

    ///
    /// Setter for a Double Property
    /// @version Teamcenter 10.1.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0utilization( double value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0BvrProcessResource();

    /**
     * Destructor
     */
    virtual ~Mfg0BvrProcessResource();

private:
    //  Getter method for the Implementation Object
    Mfg0BvrProcessResourceImpl*  getMfg0BvrProcessResourceImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0BvrProcessResourceImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0BvrProcessResourceImpl*  m_mfg0bvrprocessresourceImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0BvrProcessResource - desc for Mfg0BvrProcessResource parameter
     */
    Mfg0BvrProcessResource( const Mfg0BvrProcessResource& );
    Mfg0BvrProcessResource& operator=( const Mfg0BvrProcessResource& );

    friend class  Mfg0BvrProcessResourceDelegate;
    friend class  Mfg0BvrProcessResourceDispatch;
    friend class  Mfg0BvrProcessResourceGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0BVRPROCESSRESOURCE__HXX
