//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrProcessResourceDelegate
    Filename:   Mfg0BvrProcessResourceDelegate.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRPROCESSRESOURCEDELEGATE_HXX
#define TEAMCENTER__MFG0BVRPROCESSRESOURCEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrProcessResource.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrProcessResourceDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrProcessResourceImpl;
}
namespace Teamcenter
{
    class Mfg0BvrProcessResource;
}
namespace Teamcenter
{
    class Mfg0BvrProcessResourceGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  MFGBVR_API Teamcenter_alias::Mfg0BvrProcessResourceDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mfg0BvrProcessResourceDelegate instance
    static Mfg0BvrProcessResourceDelegate&  getInstance();

    //  Method to create the Mfg0BvrProcessResourceImpl pointer
    static Mfg0BvrProcessResourceImpl*  createImpl( Mfg0BvrProcessResource&  ifObj );

    //  Method to delete the Mfg0BvrProcessResourceImpl pointer
    static void deleteImpl( Mfg0BvrProcessResourceImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0allocatedBOPLinesBase(const Mfg0BvrProcessResource &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0utilizationBase(const Mfg0BvrProcessResource &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 10.1.2
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0allocatedBOPLinesBase(Mfg0BvrProcessResource &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Double Property
    /// @version Teamcenter 10.1.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0utilizationBase(Mfg0BvrProcessResource &ifObj,  double value, bool isNull );



protected:
    //  Pointer to the instance
    static Mfg0BvrProcessResourceDelegate*  m_pInstance;

    Mfg0BvrProcessResourceDelegate();
    virtual ~Mfg0BvrProcessResourceDelegate();
    static void setInstance( Mfg0BvrProcessResourceDelegate*  instance );


private:
    friend class  ::Teamcenter::Mfg0BvrProcessResourceGenImpl;

};

#include <mfgbvr/libmfgbvr_undef.h>
#endif  //  TEAMCENTER__MFG0BVRPROCESSRESOURCEDELEGATE_HXX
