//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrProcessStation
    Filename:   Mfg0BvrProcessStation.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRPROCESSSTATION__HXX
#define TEAMCENTER__MFG0BVRPROCESSSTATION__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrProcessArea.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrProcessStation;
}
namespace Teamcenter
{
    class Mfg0BvrProcessStationImpl;
}
namespace Teamcenter
{
    class Mfg0BvrProcessStationDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrProcessStationDispatch;
}
namespace Teamcenter
{
    class Mfg0BvrProcessStationGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0BvrProcessStation
     : public  ::Teamcenter::Mfg0BvrProcessArea
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0effectiveCycleTime( double &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0unassignedOperations( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for a Double Property
    /// @version Teamcenter 10.1.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0effectiveCycleTime( double value, bool isNull=false );

    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 10.1.2
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0unassignedOperations( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0BvrProcessStation();

    /**
     * Destructor
     */
    virtual ~Mfg0BvrProcessStation();

private:
    //  Getter method for the Implementation Object
    Mfg0BvrProcessStationImpl*  getMfg0BvrProcessStationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0BvrProcessStationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0BvrProcessStationImpl*  m_mfg0bvrprocessstationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0BvrProcessStation - desc for Mfg0BvrProcessStation parameter
     */
    Mfg0BvrProcessStation( const Mfg0BvrProcessStation& );
    Mfg0BvrProcessStation& operator=( const Mfg0BvrProcessStation& );

    friend class  Mfg0BvrProcessStationDelegate;
    friend class  Mfg0BvrProcessStationDispatch;
    friend class  Mfg0BvrProcessStationGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0BVRPROCESSSTATION__HXX
