//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrProcessStationDelegate
    Filename:   Mfg0BvrProcessStationDelegate.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRPROCESSSTATIONDELEGATE_HXX
#define TEAMCENTER__MFG0BVRPROCESSSTATIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrProcessStation.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrProcessStationDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrProcessStationImpl;
}
namespace Teamcenter
{
    class Mfg0BvrProcessStation;
}
namespace Teamcenter
{
    class Mfg0BvrProcessStationGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  MFGBVR_API Teamcenter_alias::Mfg0BvrProcessStationDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mfg0BvrProcessStationDelegate instance
    static Mfg0BvrProcessStationDelegate&  getInstance();

    //  Method to create the Mfg0BvrProcessStationImpl pointer
    static Mfg0BvrProcessStationImpl*  createImpl( Mfg0BvrProcessStation&  ifObj );

    //  Method to delete the Mfg0BvrProcessStationImpl pointer
    static void deleteImpl( Mfg0BvrProcessStationImpl*  impl );


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0effectiveCycleTimeBase(const Mfg0BvrProcessStation &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0unassignedOperationsBase(const Mfg0BvrProcessStation &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a Double Property
    /// @version Teamcenter 10.1.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0effectiveCycleTimeBase(Mfg0BvrProcessStation &ifObj,  double value, bool isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 10.1.2
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0unassignedOperationsBase(Mfg0BvrProcessStation &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );



protected:
    //  Pointer to the instance
    static Mfg0BvrProcessStationDelegate*  m_pInstance;

    Mfg0BvrProcessStationDelegate();
    virtual ~Mfg0BvrProcessStationDelegate();
    static void setInstance( Mfg0BvrProcessStationDelegate*  instance );


private:
    friend class  ::Teamcenter::Mfg0BvrProcessStationGenImpl;

};

#include <mfgbvr/libmfgbvr_undef.h>
#endif  //  TEAMCENTER__MFG0BVRPROCESSSTATIONDELEGATE_HXX
