//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrProdProgram
    Filename:   Mfg0BvrProdProgram.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRPRODPROGRAM__HXX
#define TEAMCENTER__MFG0BVRPRODPROGRAM__HXX

#include <unidefs.h>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <bom/ImanItemLine.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrProdProgram;
}
namespace Teamcenter
{
    class Mfg0BvrProdProgramImpl;
}
namespace Teamcenter
{
    class Mfg0BvrProdProgramDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrProdProgramDispatch;
}
namespace Teamcenter
{
    class Mfg0BvrProdProgramGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0BvrProdProgram
     : public  ::Teamcenter::ImanItemLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0prodProgramCollection( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0prodProgramDefinitions( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0BvrProdProgram();

    /**
     * Destructor
     */
    virtual ~Mfg0BvrProdProgram();

private:
    //  Getter method for the Implementation Object
    Mfg0BvrProdProgramImpl*  getMfg0BvrProdProgramImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0BvrProdProgramImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0BvrProdProgramImpl*  m_mfg0bvrprodprogramImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0BvrProdProgram - desc for Mfg0BvrProdProgram parameter
     */
    Mfg0BvrProdProgram( const Mfg0BvrProdProgram& );
    Mfg0BvrProdProgram& operator=( const Mfg0BvrProdProgram& );

    friend class  Mfg0BvrProdProgramDelegate;
    friend class  Mfg0BvrProdProgramDispatch;
    friend class  Mfg0BvrProdProgramGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0BVRPRODPROGRAM__HXX
