//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrProdProgramDef
    Filename:   Mfg0BvrProdProgramDef.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRPRODPROGRAMDEF__HXX
#define TEAMCENTER__MFG0BVRPRODPROGRAMDEF__HXX

#include <unidefs.h>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <bom/ImanItemLine.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrProdProgramDef;
}
namespace Teamcenter
{
    class Mfg0BvrProdProgramDefImpl;
}
namespace Teamcenter
{
    class Mfg0BvrProdProgramDefDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrProdProgramDefDispatch;
}
namespace Teamcenter
{
    class Mfg0BvrProdProgramDefGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0BvrProdProgramDef
     : public  ::Teamcenter::ImanItemLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0prodProgram( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0productVariants( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0BvrProdProgramDef();

    /**
     * Destructor
     */
    virtual ~Mfg0BvrProdProgramDef();

private:
    //  Getter method for the Implementation Object
    Mfg0BvrProdProgramDefImpl*  getMfg0BvrProdProgramDefImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0BvrProdProgramDefImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0BvrProdProgramDefImpl*  m_mfg0bvrprodprogramdefImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0BvrProdProgramDef - desc for Mfg0BvrProdProgramDef parameter
     */
    Mfg0BvrProdProgramDef( const Mfg0BvrProdProgramDef& );
    Mfg0BvrProdProgramDef& operator=( const Mfg0BvrProdProgramDef& );

    friend class  Mfg0BvrProdProgramDefDelegate;
    friend class  Mfg0BvrProdProgramDefDispatch;
    friend class  Mfg0BvrProdProgramDefGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0BVRPRODPROGRAMDEF__HXX
