//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrProductBOPDelegate
    Filename:   Mfg0BvrProductBOPDelegate.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRPRODUCTBOPDELEGATE_HXX
#define TEAMCENTER__MFG0BVRPRODUCTBOPDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrProductBOP.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrProductBOPDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrProductBOPImpl;
}
namespace Teamcenter
{
    class Mfg0BvrProductBOP;
}
namespace Teamcenter
{
    class Mfg0BvrProductBOPGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  MFGBVR_API Teamcenter_alias::Mfg0BvrProductBOPDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mfg0BvrProductBOPDelegate instance
    static Mfg0BvrProductBOPDelegate&  getInstance();

    //  Method to create the Mfg0BvrProductBOPImpl pointer
    static Mfg0BvrProductBOPImpl*  createImpl( Mfg0BvrProductBOP&  ifObj );

    //  Method to delete the Mfg0BvrProductBOPImpl pointer
    static void deleteImpl( Mfg0BvrProductBOPImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0AllPositionDiagramsBase(const Mfg0BvrProductBOP &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0associated_contextBase(const Mfg0BvrProductBOP &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0PositionDiagramBase(const Mfg0BvrProductBOP &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 10.1.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0AllPositionDiagramsBase(Mfg0BvrProductBOP &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10.1.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0PositionDiagramBase(Mfg0BvrProductBOP &ifObj,  const tag_t &value, bool isNull );



protected:
    //  Pointer to the instance
    static Mfg0BvrProductBOPDelegate*  m_pInstance;

    Mfg0BvrProductBOPDelegate();
    virtual ~Mfg0BvrProductBOPDelegate();
    static void setInstance( Mfg0BvrProductBOPDelegate*  instance );


private:
    friend class  ::Teamcenter::Mfg0BvrProductBOPGenImpl;

};

#include <mfgbvr/libmfgbvr_undef.h>
#endif  //  TEAMCENTER__MFG0BVRPRODUCTBOPDELEGATE_HXX
