//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrProductVariant
    Filename:   Mfg0BvrProductVariant.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRPRODUCTVARIANT__HXX
#define TEAMCENTER__MFG0BVRPRODUCTVARIANT__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <bom/ImanItemLine.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrProductVariant;
}
namespace Teamcenter
{
    class Mfg0BvrProductVariantImpl;
}
namespace Teamcenter
{
    class Mfg0BvrProductVariantDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrProductVariantDispatch;
}
namespace Teamcenter
{
    class Mfg0BvrProductVariantGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0BvrProductVariant
     : public  ::Teamcenter::ImanItemLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0productionRate( double &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0programDefinition( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0variantRule( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Double Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0productionRate( double value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0variantRule( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0BvrProductVariant();

    /**
     * Destructor
     */
    virtual ~Mfg0BvrProductVariant();

private:
    //  Getter method for the Implementation Object
    Mfg0BvrProductVariantImpl*  getMfg0BvrProductVariantImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0BvrProductVariantImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0BvrProductVariantImpl*  m_mfg0bvrproductvariantImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0BvrProductVariant - desc for Mfg0BvrProductVariant parameter
     */
    Mfg0BvrProductVariant( const Mfg0BvrProductVariant& );
    Mfg0BvrProductVariant& operator=( const Mfg0BvrProductVariant& );

    friend class  Mfg0BvrProductVariantDelegate;
    friend class  Mfg0BvrProductVariantDispatch;
    friend class  Mfg0BvrProductVariantGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0BVRPRODUCTVARIANT__HXX
