//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrProductVariantDelegate
    Filename:   Mfg0BvrProductVariantDelegate.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRPRODUCTVARIANTDELEGATE_HXX
#define TEAMCENTER__MFG0BVRPRODUCTVARIANTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrProductVariant.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrProductVariantDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrProductVariantImpl;
}
namespace Teamcenter
{
    class Mfg0BvrProductVariant;
}
namespace Teamcenter
{
    class Mfg0BvrProductVariantGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  MFGBVR_API Teamcenter_alias::Mfg0BvrProductVariantDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mfg0BvrProductVariantDelegate instance
    static Mfg0BvrProductVariantDelegate&  getInstance();

    //  Method to create the Mfg0BvrProductVariantImpl pointer
    static Mfg0BvrProductVariantImpl*  createImpl( Mfg0BvrProductVariant&  ifObj );

    //  Method to delete the Mfg0BvrProductVariantImpl pointer
    static void deleteImpl( Mfg0BvrProductVariantImpl*  impl );


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0productionRateBase(const Mfg0BvrProductVariant &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0programDefinitionBase(const Mfg0BvrProductVariant &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0variantRuleBase(const Mfg0BvrProductVariant &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Double Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0productionRateBase(Mfg0BvrProductVariant &ifObj,  double value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0variantRuleBase(Mfg0BvrProductVariant &ifObj,  const tag_t &value, bool isNull );



protected:
    //  Pointer to the instance
    static Mfg0BvrProductVariantDelegate*  m_pInstance;

    Mfg0BvrProductVariantDelegate();
    virtual ~Mfg0BvrProductVariantDelegate();
    static void setInstance( Mfg0BvrProductVariantDelegate*  instance );


private:
    friend class  ::Teamcenter::Mfg0BvrProductVariantGenImpl;

};

#include <mfgbvr/libmfgbvr_undef.h>
#endif  //  TEAMCENTER__MFG0BVRPRODUCTVARIANTDELEGATE_HXX
