//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrReferenceFrame
    Filename:   Mfg0BvrReferenceFrame.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRREFERENCEFRAME__HXX
#define TEAMCENTER__MFG0BVRREFERENCEFRAME__HXX

#include <common/tc_deprecation_macros.h>
#include <me/ImanItemBOPLine.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrReferenceFrame;
}
namespace Teamcenter
{
    class Mfg0BvrReferenceFrameImpl;
}
namespace Teamcenter
{
    class Mfg0BvrReferenceFrameDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrReferenceFrameDispatch;
}
namespace Teamcenter
{
    class Mfg0BvrReferenceFrameGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0BvrReferenceFrame
     : public  ::Teamcenter::ImanItemBOPLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0BvrReferenceFrame();

    /**
     * Destructor
     */
    virtual ~Mfg0BvrReferenceFrame();

private:
    //  Getter method for the Implementation Object
    Mfg0BvrReferenceFrameImpl*  getMfg0BvrReferenceFrameImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0BvrReferenceFrameImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0BvrReferenceFrameImpl*  m_mfg0bvrreferenceframeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0BvrReferenceFrame - desc for Mfg0BvrReferenceFrame parameter
     */
    Mfg0BvrReferenceFrame( const Mfg0BvrReferenceFrame& );
    Mfg0BvrReferenceFrame& operator=( const Mfg0BvrReferenceFrame& );

    friend class  Mfg0BvrReferenceFrameDelegate;
    friend class  Mfg0BvrReferenceFrameDispatch;
    friend class  Mfg0BvrReferenceFrameGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0BVRREFERENCEFRAME__HXX
