//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrResource
    Filename:   Mfg0BvrResource.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRRESOURCE__HXX
#define TEAMCENTER__MFG0BVRRESOURCE__HXX

#include <common/tc_deprecation_macros.h>
#include <me/ImanItemBOPLine.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrResource;
}
namespace Teamcenter
{
    class Mfg0BvrResourceImpl;
}
namespace Teamcenter
{
    class Mfg0BvrResourceDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrResourceDispatch;
}
namespace Teamcenter
{
    class Mfg0BvrResourceGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0BvrResource
     : public  ::Teamcenter::ImanItemBOPLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0BvrResource();

    /**
     * Destructor
     */
    virtual ~Mfg0BvrResource();

private:
    //  Getter method for the Implementation Object
    Mfg0BvrResourceImpl*  getMfg0BvrResourceImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0BvrResourceImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0BvrResourceImpl*  m_mfg0bvrresourceImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0BvrResource - desc for Mfg0BvrResource parameter
     */
    Mfg0BvrResource( const Mfg0BvrResource& );
    Mfg0BvrResource& operator=( const Mfg0BvrResource& );

    friend class  Mfg0BvrResourceDelegate;
    friend class  Mfg0BvrResourceDispatch;
    friend class  Mfg0BvrResourceGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0BVRRESOURCE__HXX
