//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrRobot
    Filename:   Mfg0BvrRobot.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRROBOT__HXX
#define TEAMCENTER__MFG0BVRROBOT__HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrEquipment.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrRobot;
}
namespace Teamcenter
{
    class Mfg0BvrRobotImpl;
}
namespace Teamcenter
{
    class Mfg0BvrRobotDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrRobotDispatch;
}
namespace Teamcenter
{
    class Mfg0BvrRobotGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0BvrRobot
     : public  ::Teamcenter::Mfg0BvrEquipment
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0BvrRobot();

    /**
     * Destructor
     */
    virtual ~Mfg0BvrRobot();

private:
    //  Getter method for the Implementation Object
    Mfg0BvrRobotImpl*  getMfg0BvrRobotImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0BvrRobotImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0BvrRobotImpl*  m_mfg0bvrrobotImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0BvrRobot - desc for Mfg0BvrRobot parameter
     */
    Mfg0BvrRobot( const Mfg0BvrRobot& );
    Mfg0BvrRobot& operator=( const Mfg0BvrRobot& );

    friend class  Mfg0BvrRobotDelegate;
    friend class  Mfg0BvrRobotDispatch;
    friend class  Mfg0BvrRobotGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0BVRROBOT__HXX
