//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrScopeFlow
    Filename:   Mfg0BvrScopeFlow.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRSCOPEFLOW__HXX
#define TEAMCENTER__MFG0BVRSCOPEFLOW__HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrFlow.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrScopeFlow;
}
namespace Teamcenter
{
    class Mfg0BvrScopeFlowImpl;
}
namespace Teamcenter
{
    class Mfg0BvrScopeFlowDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrScopeFlowDispatch;
}
namespace Teamcenter
{
    class Mfg0BvrScopeFlowGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0BvrScopeFlow
     : public  ::Teamcenter::Mfg0BvrFlow
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0BvrScopeFlow();

    /**
     * Destructor
     */
    virtual ~Mfg0BvrScopeFlow();

private:
    //  Getter method for the Implementation Object
    Mfg0BvrScopeFlowImpl*  getMfg0BvrScopeFlowImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0BvrScopeFlowImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0BvrScopeFlowImpl*  m_mfg0bvrscopeflowImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0BvrScopeFlow - desc for Mfg0BvrScopeFlow parameter
     */
    Mfg0BvrScopeFlow( const Mfg0BvrScopeFlow& );
    Mfg0BvrScopeFlow& operator=( const Mfg0BvrScopeFlow& );

    friend class  Mfg0BvrScopeFlowDelegate;
    friend class  Mfg0BvrScopeFlowDispatch;
    friend class  Mfg0BvrScopeFlowGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0BVRSCOPEFLOW__HXX
