//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrSensor
    Filename:   Mfg0BvrSensor.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRSENSOR__HXX
#define TEAMCENTER__MFG0BVRSENSOR__HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrEquipment.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrSensor;
}
namespace Teamcenter
{
    class Mfg0BvrSensorImpl;
}
namespace Teamcenter
{
    class Mfg0BvrSensorDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrSensorDispatch;
}
namespace Teamcenter
{
    class Mfg0BvrSensorGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0BvrSensor
     : public  ::Teamcenter::Mfg0BvrEquipment
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0BvrSensor();

    /**
     * Destructor
     */
    virtual ~Mfg0BvrSensor();

private:
    //  Getter method for the Implementation Object
    Mfg0BvrSensorImpl*  getMfg0BvrSensorImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0BvrSensorImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0BvrSensorImpl*  m_mfg0bvrsensorImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0BvrSensor - desc for Mfg0BvrSensor parameter
     */
    Mfg0BvrSensor( const Mfg0BvrSensor& );
    Mfg0BvrSensor& operator=( const Mfg0BvrSensor& );

    friend class  Mfg0BvrSensorDelegate;
    friend class  Mfg0BvrSensorDispatch;
    friend class  Mfg0BvrSensorGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0BVRSENSOR__HXX
