//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrSimStudy
    Filename:   Mfg0BvrSimStudy.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRSIMSTUDY__HXX
#define TEAMCENTER__MFG0BVRSIMSTUDY__HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrStudy.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrSimStudy;
}
namespace Teamcenter
{
    class Mfg0BvrSimStudyImpl;
}
namespace Teamcenter
{
    class Mfg0BvrSimStudyDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrSimStudyDispatch;
}
namespace Teamcenter
{
    class Mfg0BvrSimStudyGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0BvrSimStudy
     : public  ::Teamcenter::Mfg0BvrStudy
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0BvrSimStudy();

    /**
     * Destructor
     */
    virtual ~Mfg0BvrSimStudy();

private:
    //  Getter method for the Implementation Object
    Mfg0BvrSimStudyImpl*  getMfg0BvrSimStudyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0BvrSimStudyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0BvrSimStudyImpl*  m_mfg0bvrsimstudyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0BvrSimStudy - desc for Mfg0BvrSimStudy parameter
     */
    Mfg0BvrSimStudy( const Mfg0BvrSimStudy& );
    Mfg0BvrSimStudy& operator=( const Mfg0BvrSimStudy& );

    friend class  Mfg0BvrSimStudyDelegate;
    friend class  Mfg0BvrSimStudyDispatch;
    friend class  Mfg0BvrSimStudyGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0BVRSIMSTUDY__HXX
