//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrStep
    Filename:   Mfg0BvrStep.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRSTEP__HXX
#define TEAMCENTER__MFG0BVRSTEP__HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrOperation.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrStep;
}
namespace Teamcenter
{
    class Mfg0BvrStepImpl;
}
namespace Teamcenter
{
    class Mfg0BvrStepDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrStepDispatch;
}
namespace Teamcenter
{
    class Mfg0BvrStepGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0BvrStep
     : public  ::Teamcenter::Mfg0BvrOperation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0BvrStep();

    /**
     * Destructor
     */
    virtual ~Mfg0BvrStep();

private:
    //  Getter method for the Implementation Object
    Mfg0BvrStepImpl*  getMfg0BvrStepImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0BvrStepImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0BvrStepImpl*  m_mfg0bvrstepImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0BvrStep - desc for Mfg0BvrStep parameter
     */
    Mfg0BvrStep( const Mfg0BvrStep& );
    Mfg0BvrStep& operator=( const Mfg0BvrStep& );

    friend class  Mfg0BvrStepDelegate;
    friend class  Mfg0BvrStepDispatch;
    friend class  Mfg0BvrStepGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0BVRSTEP__HXX
