//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrStudy
    Filename:   Mfg0BvrStudy.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRSTUDY__HXX
#define TEAMCENTER__MFG0BVRSTUDY__HXX

#include <common/tc_deprecation_macros.h>
#include <me/ImanItemBOPLine.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrStudy;
}
namespace Teamcenter
{
    class Mfg0BvrStudyImpl;
}
namespace Teamcenter
{
    class Mfg0BvrStudyDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrStudyDispatch;
}
namespace Teamcenter
{
    class Mfg0BvrStudyGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0BvrStudy
     : public  ::Teamcenter::ImanItemBOPLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0BvrStudy();

    /**
     * Destructor
     */
    virtual ~Mfg0BvrStudy();

private:
    //  Getter method for the Implementation Object
    Mfg0BvrStudyImpl*  getMfg0BvrStudyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0BvrStudyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0BvrStudyImpl*  m_mfg0bvrstudyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0BvrStudy - desc for Mfg0BvrStudy parameter
     */
    Mfg0BvrStudy( const Mfg0BvrStudy& );
    Mfg0BvrStudy& operator=( const Mfg0BvrStudy& );

    friend class  Mfg0BvrStudyDelegate;
    friend class  Mfg0BvrStudyDispatch;
    friend class  Mfg0BvrStudyGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0BVRSTUDY__HXX
