//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrToolRequirement
    Filename:   Mfg0BvrToolRequirement.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRTOOLREQUIREMENT__HXX
#define TEAMCENTER__MFG0BVRTOOLREQUIREMENT__HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrLogicalAssignment.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrToolRequirement;
}
namespace Teamcenter
{
    class Mfg0BvrToolRequirementImpl;
}
namespace Teamcenter
{
    class Mfg0BvrToolRequirementDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrToolRequirementDispatch;
}
namespace Teamcenter
{
    class Mfg0BvrToolRequirementGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0BvrToolRequirement
     : public  ::Teamcenter::Mfg0BvrLogicalAssignment
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0BvrToolRequirement();

    /**
     * Destructor
     */
    virtual ~Mfg0BvrToolRequirement();

private:
    //  Getter method for the Implementation Object
    Mfg0BvrToolRequirementImpl*  getMfg0BvrToolRequirementImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0BvrToolRequirementImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0BvrToolRequirementImpl*  m_mfg0bvrtoolrequirementImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0BvrToolRequirement - desc for Mfg0BvrToolRequirement parameter
     */
    Mfg0BvrToolRequirement( const Mfg0BvrToolRequirement& );
    Mfg0BvrToolRequirement& operator=( const Mfg0BvrToolRequirement& );

    friend class  Mfg0BvrToolRequirementDelegate;
    friend class  Mfg0BvrToolRequirementDispatch;
    friend class  Mfg0BvrToolRequirementGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0BVRTOOLREQUIREMENT__HXX
