//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrToolRequirementDelegate
    Filename:   Mfg0BvrToolRequirementDelegate.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRTOOLREQUIREMENTDELEGATE_HXX
#define TEAMCENTER__MFG0BVRTOOLREQUIREMENTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrToolRequirement.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrToolRequirementDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrToolRequirementImpl;
}
namespace Teamcenter
{
    class Mfg0BvrToolRequirement;
}
namespace Teamcenter
{
    class Mfg0BvrToolRequirementGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  MFGBVR_API Teamcenter_alias::Mfg0BvrToolRequirementDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mfg0BvrToolRequirementDelegate instance
    static Mfg0BvrToolRequirementDelegate&  getInstance();

    //  Method to create the Mfg0BvrToolRequirementImpl pointer
    static Mfg0BvrToolRequirementImpl*  createImpl( Mfg0BvrToolRequirement&  ifObj );

    //  Method to delete the Mfg0BvrToolRequirementImpl pointer
    static void deleteImpl( Mfg0BvrToolRequirementImpl*  impl );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Mfg0BvrToolRequirement &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Mfg0BvrToolRequirement &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Mfg0BvrToolRequirementDelegate*  m_pInstance;

    Mfg0BvrToolRequirementDelegate();
    virtual ~Mfg0BvrToolRequirementDelegate();
    static void setInstance( Mfg0BvrToolRequirementDelegate*  instance );


private:
    friend class  ::Teamcenter::Mfg0BvrToolRequirementGenImpl;

};

#include <mfgbvr/libmfgbvr_undef.h>
#endif  //  TEAMCENTER__MFG0BVRTOOLREQUIREMENTDELEGATE_HXX
