//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0BvrWorkareaDelegate
    Filename:   Mfg0BvrWorkareaDelegate.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0BVRWORKAREADELEGATE_HXX
#define TEAMCENTER__MFG0BVRWORKAREADELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrWorkarea.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0BvrWorkareaDelegate;
}
namespace Teamcenter
{
    class Mfg0BvrWorkareaImpl;
}
namespace Teamcenter
{
    class Mfg0BvrWorkarea;
}
namespace Teamcenter
{
    class Mfg0BvrWorkareaGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  MFGBVR_API Teamcenter_alias::Mfg0BvrWorkareaDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mfg0BvrWorkareaDelegate instance
    static Mfg0BvrWorkareaDelegate&  getInstance();

    //  Method to create the Mfg0BvrWorkareaImpl pointer
    static Mfg0BvrWorkareaImpl*  createImpl( Mfg0BvrWorkarea&  ifObj );

    //  Method to delete the Mfg0BvrWorkareaImpl pointer
    static void deleteImpl( Mfg0BvrWorkareaImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0containerBase(const Mfg0BvrWorkarea &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0input_flowsBase(const Mfg0BvrWorkarea &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 13.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0LinkedPlantBOPLineBase(const Mfg0BvrWorkarea &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0output_flowsBase(const Mfg0BvrWorkarea &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0predecessorsBase(const Mfg0BvrWorkarea &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0sub_elementsBase(const Mfg0BvrWorkarea &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0successorsBase(const Mfg0BvrWorkarea &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 13.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0LinkedPlantBOPLineBase(Mfg0BvrWorkarea &ifObj,  const tag_t &value, bool isNull );



protected:
    //  Pointer to the instance
    static Mfg0BvrWorkareaDelegate*  m_pInstance;

    Mfg0BvrWorkareaDelegate();
    virtual ~Mfg0BvrWorkareaDelegate();
    static void setInstance( Mfg0BvrWorkareaDelegate*  instance );


private:
    friend class  ::Teamcenter::Mfg0BvrWorkareaGenImpl;

};

#include <mfgbvr/libmfgbvr_undef.h>
#endif  //  TEAMCENTER__MFG0BVRWORKAREADELEGATE_HXX
