//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0MEAlternativeScope
    Filename:   Mfg0MEAlternativeScope.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0MEALTERNATIVESCOPE__HXX
#define TEAMCENTER__MFG0MEALTERNATIVESCOPE__HXX

#include <common/tc_deprecation_macros.h>
#include <ps/AppearanceGroup.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0MEAlternativeScope;
}
namespace Teamcenter
{
    class Mfg0MEAlternativeScopeImpl;
}
namespace Teamcenter
{
    class Mfg0MEAlternativeScopeDelegate;
}
namespace Teamcenter
{
    class Mfg0MEAlternativeScopeDispatch;
}
namespace Teamcenter
{
    class Mfg0MEAlternativeScopeGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0MEAlternativeScope
     : public  ::Teamcenter::AppearanceGroup
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0MEAlternativeScope();

    /**
     * Destructor
     */
    virtual ~Mfg0MEAlternativeScope();

private:
    //  Getter method for the Implementation Object
    Mfg0MEAlternativeScopeImpl*  getMfg0MEAlternativeScopeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0MEAlternativeScopeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0MEAlternativeScopeImpl*  m_mfg0mealternativescopeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0MEAlternativeScope - desc for Mfg0MEAlternativeScope parameter
     */
    Mfg0MEAlternativeScope( const Mfg0MEAlternativeScope& );
    Mfg0MEAlternativeScope& operator=( const Mfg0MEAlternativeScope& );

    friend class  Mfg0MEAlternativeScopeDelegate;
    friend class  Mfg0MEAlternativeScopeDispatch;
    friend class  Mfg0MEAlternativeScopeGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0MEALTERNATIVESCOPE__HXX
