//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0MECompOP
    Filename:   Mfg0MECompOP.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0MECOMPOP__HXX
#define TEAMCENTER__MFG0MECOMPOP__HXX

#include <common/tc_deprecation_macros.h>
#include <me/MEProcess.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0MECompOP;
}
namespace Teamcenter
{
    class Mfg0MECompOPImpl;
}
namespace Teamcenter
{
    class Mfg0MECompOPDelegate;
}
namespace Teamcenter
{
    class Mfg0MECompOPDispatch;
}
namespace Teamcenter
{
    class Mfg0MECompOPGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0MECompOP
     : public  ::Teamcenter::MEProcess
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0MECompOP();

    /**
     * Destructor
     */
    virtual ~Mfg0MECompOP();

private:
    //  Getter method for the Implementation Object
    Mfg0MECompOPImpl*  getMfg0MECompOPImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0MECompOPImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0MECompOPImpl*  m_mfg0mecompopImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0MECompOP - desc for Mfg0MECompOP parameter
     */
    Mfg0MECompOP( const Mfg0MECompOP& );
    Mfg0MECompOP& operator=( const Mfg0MECompOP& );

    friend class  Mfg0MECompOPDelegate;
    friend class  Mfg0MECompOPDispatch;
    friend class  Mfg0MECompOPGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0MECOMPOP__HXX
