//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0MEConstraint
    Filename:   Mfg0MEConstraint.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0MECONSTRAINT__HXX
#define TEAMCENTER__MFG0MECONSTRAINT__HXX

#include <common/tc_deprecation_macros.h>
#include <form/Form.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0MEConstraint;
}
namespace Teamcenter
{
    class Mfg0MEConstraintImpl;
}
namespace Teamcenter
{
    class Mfg0MEConstraintDelegate;
}
namespace Teamcenter
{
    class Mfg0MEConstraintDispatch;
}
namespace Teamcenter
{
    class Mfg0MEConstraintGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0MEConstraint
     : public  ::Teamcenter::Form
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0MEConstraint();

    /**
     * Destructor
     */
    virtual ~Mfg0MEConstraint();

private:
    //  Getter method for the Implementation Object
    Mfg0MEConstraintImpl*  getMfg0MEConstraintImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0MEConstraintImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0MEConstraintImpl*  m_mfg0meconstraintImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0MEConstraint - desc for Mfg0MEConstraint parameter
     */
    Mfg0MEConstraint( const Mfg0MEConstraint& );
    Mfg0MEConstraint& operator=( const Mfg0MEConstraint& );

    friend class  Mfg0MEConstraintDelegate;
    friend class  Mfg0MEConstraintDispatch;
    friend class  Mfg0MEConstraintGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0MECONSTRAINT__HXX
