//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0MEDynamicIPA
    Filename:   Mfg0MEDynamicIPA.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0MEDYNAMICIPA__HXX
#define TEAMCENTER__MFG0MEDYNAMICIPA__HXX

#include <common/tc_deprecation_macros.h>
#include <ps/AppearanceGroup.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0MEDynamicIPA;
}
namespace Teamcenter
{
    class Mfg0MEDynamicIPAImpl;
}
namespace Teamcenter
{
    class Mfg0MEDynamicIPADelegate;
}
namespace Teamcenter
{
    class Mfg0MEDynamicIPADispatch;
}
namespace Teamcenter
{
    class Mfg0MEDynamicIPAGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0MEDynamicIPA
     : public  ::Teamcenter::AppearanceGroup
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0MEDynamicIPA();

    /**
     * Destructor
     */
    virtual ~Mfg0MEDynamicIPA();

private:
    //  Getter method for the Implementation Object
    Mfg0MEDynamicIPAImpl*  getMfg0MEDynamicIPAImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0MEDynamicIPAImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0MEDynamicIPAImpl*  m_mfg0medynamicipaImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0MEDynamicIPA - desc for Mfg0MEDynamicIPA parameter
     */
    Mfg0MEDynamicIPA( const Mfg0MEDynamicIPA& );
    Mfg0MEDynamicIPA& operator=( const Mfg0MEDynamicIPA& );

    friend class  Mfg0MEDynamicIPADelegate;
    friend class  Mfg0MEDynamicIPADispatch;
    friend class  Mfg0MEDynamicIPAGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0MEDYNAMICIPA__HXX
