//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0MELogicalAssignment
    Filename:   Mfg0MELogicalAssignment.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0MELOGICALASSIGNMENT__HXX
#define TEAMCENTER__MFG0MELOGICALASSIGNMENT__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0MELogicalAssignment;
}
namespace Teamcenter
{
    class Mfg0MELogicalAssignmentImpl;
}
namespace Teamcenter
{
    class Mfg0MELogicalAssignmentDelegate;
}
namespace Teamcenter
{
    class Mfg0MELogicalAssignmentDispatch;
}
namespace Teamcenter
{
    class Mfg0MELogicalAssignmentGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0MELogicalAssignment
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0description( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0name( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0description( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0name( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0MELogicalAssignment();

    /**
     * Destructor
     */
    virtual ~Mfg0MELogicalAssignment();

private:
    //  Getter method for the Implementation Object
    Mfg0MELogicalAssignmentImpl*  getMfg0MELogicalAssignmentImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0MELogicalAssignmentImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0MELogicalAssignmentImpl*  m_mfg0melogicalassignmentImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0MELogicalAssignment - desc for Mfg0MELogicalAssignment parameter
     */
    Mfg0MELogicalAssignment( const Mfg0MELogicalAssignment& );
    Mfg0MELogicalAssignment& operator=( const Mfg0MELogicalAssignment& );

    friend class  Mfg0MELogicalAssignmentDelegate;
    friend class  Mfg0MELogicalAssignmentDispatch;
    friend class  Mfg0MELogicalAssignmentGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0MELOGICALASSIGNMENT__HXX
