//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0MEMBOMRecipe
    Filename:   Mfg0MEMBOMRecipe.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0MEMBOMRECIPE__HXX
#define TEAMCENTER__MFG0MEMBOMRECIPE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0MEMBOMRecipe;
}
namespace Teamcenter
{
    class Mfg0MEMBOMRecipeImpl;
}
namespace Teamcenter
{
    class Mfg0MEMBOMRecipeDelegate;
}
namespace Teamcenter
{
    class Mfg0MEMBOMRecipeDispatch;
}
namespace Teamcenter
{
    class Mfg0MEMBOMRecipeGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0MEMBOMRecipe
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0MEMBOMRecipe();

    /**
     * Destructor
     */
    virtual ~Mfg0MEMBOMRecipe();

private:
    //  Getter method for the Implementation Object
    Mfg0MEMBOMRecipeImpl*  getMfg0MEMBOMRecipeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0MEMBOMRecipeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0MEMBOMRecipeImpl*  m_mfg0membomrecipeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0MEMBOMRecipe - desc for Mfg0MEMBOMRecipe parameter
     */
    Mfg0MEMBOMRecipe( const Mfg0MEMBOMRecipe& );
    Mfg0MEMBOMRecipe& operator=( const Mfg0MEMBOMRecipe& );

    friend class  Mfg0MEMBOMRecipeDelegate;
    friend class  Mfg0MEMBOMRecipeDispatch;
    friend class  Mfg0MEMBOMRecipeGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0MEMBOMRECIPE__HXX
