//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0MEPlantBOP
    Filename:   Mfg0MEPlantBOP.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0MEPLANTBOP__HXX
#define TEAMCENTER__MFG0MEPLANTBOP__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <me/MEProcess.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0MEPlantBOP;
}
namespace Teamcenter
{
    class Mfg0MEPlantBOPImpl;
}
namespace Teamcenter
{
    class Mfg0MEPlantBOPDelegate;
}
namespace Teamcenter
{
    class Mfg0MEPlantBOPDispatch;
}
namespace Teamcenter
{
    class Mfg0MEPlantBOPGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0MEPlantBOP
     : public  ::Teamcenter::MEProcess
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0associated_context( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0MEPlantBOP();

    /**
     * Destructor
     */
    virtual ~Mfg0MEPlantBOP();

private:
    //  Getter method for the Implementation Object
    Mfg0MEPlantBOPImpl*  getMfg0MEPlantBOPImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0MEPlantBOPImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0MEPlantBOPImpl*  m_mfg0meplantbopImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0MEPlantBOP - desc for Mfg0MEPlantBOP parameter
     */
    Mfg0MEPlantBOP( const Mfg0MEPlantBOP& );
    Mfg0MEPlantBOP& operator=( const Mfg0MEPlantBOP& );

    friend class  Mfg0MEPlantBOPDelegate;
    friend class  Mfg0MEPlantBOPDispatch;
    friend class  Mfg0MEPlantBOPGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0MEPLANTBOP__HXX
