//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0MEPlantBOPRevision
    Filename:   Mfg0MEPlantBOPRevision.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0MEPLANTBOPREVISION__HXX
#define TEAMCENTER__MFG0MEPLANTBOPREVISION__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0MEProcAreaRevision.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0MEPlantBOPRevision;
}
namespace Teamcenter
{
    class Mfg0MEPlantBOPRevisionImpl;
}
namespace Teamcenter
{
    class Mfg0MEPlantBOPRevisionDelegate;
}
namespace Teamcenter
{
    class Mfg0MEPlantBOPRevisionDispatch;
}
namespace Teamcenter
{
    class Mfg0MEPlantBOPRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0MEPlantBOPRevision
     : public  ::Teamcenter::Mfg0MEProcAreaRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an Integer Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0StationSize( std::vector< int > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for an Integer Array Property
    /// @version Teamcenter 10.1
    /// @param values - Values to be set for the paramter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0StationSize( const std::vector< int > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0MEPlantBOPRevision();

    /**
     * Destructor
     */
    virtual ~Mfg0MEPlantBOPRevision();

private:
    //  Getter method for the Implementation Object
    Mfg0MEPlantBOPRevisionImpl*  getMfg0MEPlantBOPRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0MEPlantBOPRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0MEPlantBOPRevisionImpl*  m_mfg0meplantboprevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0MEPlantBOPRevision - desc for Mfg0MEPlantBOPRevision parameter
     */
    Mfg0MEPlantBOPRevision( const Mfg0MEPlantBOPRevision& );
    Mfg0MEPlantBOPRevision& operator=( const Mfg0MEPlantBOPRevision& );

    friend class  Mfg0MEPlantBOPRevisionDelegate;
    friend class  Mfg0MEPlantBOPRevisionDispatch;
    friend class  Mfg0MEPlantBOPRevisionGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0MEPLANTBOPREVISION__HXX
