//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0MEPlantBOPRevisionDelegate
    Filename:   Mfg0MEPlantBOPRevisionDelegate.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0MEPLANTBOPREVISIONDELEGATE_HXX
#define TEAMCENTER__MFG0MEPLANTBOPREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0MEPlantBOPRevision.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0MEPlantBOPRevisionDelegate;
}
namespace Teamcenter
{
    class Mfg0MEPlantBOPRevisionImpl;
}
namespace Teamcenter
{
    class Mfg0MEPlantBOPRevision;
}
namespace Teamcenter
{
    class Mfg0MEPlantBOPRevisionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  MFGBVR_API Teamcenter_alias::Mfg0MEPlantBOPRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mfg0MEPlantBOPRevisionDelegate instance
    static Mfg0MEPlantBOPRevisionDelegate&  getInstance();

    //  Method to create the Mfg0MEPlantBOPRevisionImpl pointer
    static Mfg0MEPlantBOPRevisionImpl*  createImpl( Mfg0MEPlantBOPRevision&  ifObj );

    //  Method to delete the Mfg0MEPlantBOPRevisionImpl pointer
    static void deleteImpl( Mfg0MEPlantBOPRevisionImpl*  impl );


    ///
    /// Getter for an Integer Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0StationSizeBase(const Mfg0MEPlantBOPRevision &ifObj,  std::vector< int > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for an Integer Array Property
    /// @version Teamcenter 10.1
    /// @param values - Values to be set for the paramter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0StationSizeBase(Mfg0MEPlantBOPRevision &ifObj,  const std::vector< int > &values, const std::vector< int > *isNull );



protected:
    //  Pointer to the instance
    static Mfg0MEPlantBOPRevisionDelegate*  m_pInstance;

    Mfg0MEPlantBOPRevisionDelegate();
    virtual ~Mfg0MEPlantBOPRevisionDelegate();
    static void setInstance( Mfg0MEPlantBOPRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::Mfg0MEPlantBOPRevisionGenImpl;

};

#include <mfgbvr/libmfgbvr_undef.h>
#endif  //  TEAMCENTER__MFG0MEPLANTBOPREVISIONDELEGATE_HXX
