//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0MEPositionDiagramDelegate
    Filename:   Mfg0MEPositionDiagramDelegate.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0MEPOSITIONDIAGRAMDELEGATE_HXX
#define TEAMCENTER__MFG0MEPOSITIONDIAGRAMDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0MEPositionDiagram.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0MEPositionDiagramDelegate;
}
namespace Teamcenter
{
    class Mfg0MEPositionDiagramImpl;
}
namespace Teamcenter
{
    class Mfg0MEPositionDiagram;
}
namespace Teamcenter
{
    class Mfg0MEPositionDiagramGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  MFGBVR_API Teamcenter_alias::Mfg0MEPositionDiagramDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mfg0MEPositionDiagramDelegate instance
    static Mfg0MEPositionDiagramDelegate&  getInstance();

    //  Method to create the Mfg0MEPositionDiagramImpl pointer
    static Mfg0MEPositionDiagramImpl*  createImpl( Mfg0MEPositionDiagram&  ifObj );

    //  Method to delete the Mfg0MEPositionDiagramImpl pointer
    static void deleteImpl( Mfg0MEPositionDiagramImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0AcronymBase(const Mfg0MEPositionDiagram &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0DiagramPictureBase(const Mfg0MEPositionDiagram &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0ExecutionPositionsBase(const Mfg0MEPositionDiagram &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for an Integer Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0MatrixSizeBase(const Mfg0MEPositionDiagram &ifObj,  std::vector< int > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0AcronymBase(Mfg0MEPositionDiagram &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0DiagramPictureBase(Mfg0MEPositionDiagram &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 10.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0ExecutionPositionsBase(Mfg0MEPositionDiagram &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for an Integer Array Property
    /// @version Teamcenter 10.1
    /// @param values - Values to be set for the paramter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0MatrixSizeBase(Mfg0MEPositionDiagram &ifObj,  const std::vector< int > &values, const std::vector< int > *isNull );



protected:
    //  Pointer to the instance
    static Mfg0MEPositionDiagramDelegate*  m_pInstance;

    Mfg0MEPositionDiagramDelegate();
    virtual ~Mfg0MEPositionDiagramDelegate();
    static void setInstance( Mfg0MEPositionDiagramDelegate*  instance );


private:
    friend class  ::Teamcenter::Mfg0MEPositionDiagramGenImpl;

};

#include <mfgbvr/libmfgbvr_undef.h>
#endif  //  TEAMCENTER__MFG0MEPOSITIONDIAGRAMDELEGATE_HXX
