//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0MEPrecedenceCons
    Filename:   Mfg0MEPrecedenceCons.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0MEPRECEDENCECONS__HXX
#define TEAMCENTER__MFG0MEPRECEDENCECONS__HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0MEConstraint.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0MEPrecedenceCons;
}
namespace Teamcenter
{
    class Mfg0MEPrecedenceConsImpl;
}
namespace Teamcenter
{
    class Mfg0MEPrecedenceConsDelegate;
}
namespace Teamcenter
{
    class Mfg0MEPrecedenceConsDispatch;
}
namespace Teamcenter
{
    class Mfg0MEPrecedenceConsGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0MEPrecedenceCons
     : public  ::Teamcenter::Mfg0MEConstraint
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0MEPrecedenceCons();

    /**
     * Destructor
     */
    virtual ~Mfg0MEPrecedenceCons();

private:
    //  Getter method for the Implementation Object
    Mfg0MEPrecedenceConsImpl*  getMfg0MEPrecedenceConsImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0MEPrecedenceConsImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0MEPrecedenceConsImpl*  m_mfg0meprecedenceconsImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0MEPrecedenceCons - desc for Mfg0MEPrecedenceCons parameter
     */
    Mfg0MEPrecedenceCons( const Mfg0MEPrecedenceCons& );
    Mfg0MEPrecedenceCons& operator=( const Mfg0MEPrecedenceCons& );

    friend class  Mfg0MEPrecedenceConsDelegate;
    friend class  Mfg0MEPrecedenceConsDispatch;
    friend class  Mfg0MEPrecedenceConsGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0MEPRECEDENCECONS__HXX
