//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0MEProcAreaProdImageRel
    Filename:   Mfg0MEProcAreaProdImageRel.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0MEPROCAREAPRODIMAGEREL__HXX
#define TEAMCENTER__MFG0MEPROCAREAPRODIMAGEREL__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0MEProcAreaProdImageRel;
}
namespace Teamcenter
{
    class Mfg0MEProcAreaProdImageRelImpl;
}
namespace Teamcenter
{
    class Mfg0MEProcAreaProdImageRelDelegate;
}
namespace Teamcenter
{
    class Mfg0MEProcAreaProdImageRelDispatch;
}
namespace Teamcenter
{
    class Mfg0MEProcAreaProdImageRelGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0MEProcAreaProdImageRel
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0RelatedProductBOP( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0RelatedProductBOP( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0MEProcAreaProdImageRel();

    /**
     * Destructor
     */
    virtual ~Mfg0MEProcAreaProdImageRel();

private:
    //  Getter method for the Implementation Object
    Mfg0MEProcAreaProdImageRelImpl*  getMfg0MEProcAreaProdImageRelImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0MEProcAreaProdImageRelImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0MEProcAreaProdImageRelImpl*  m_mfg0meprocareaprodimagerelImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0MEProcAreaProdImageRel - desc for Mfg0MEProcAreaProdImageRel parameter
     */
    Mfg0MEProcAreaProdImageRel( const Mfg0MEProcAreaProdImageRel& );
    Mfg0MEProcAreaProdImageRel& operator=( const Mfg0MEProcAreaProdImageRel& );

    friend class  Mfg0MEProcAreaProdImageRelDelegate;
    friend class  Mfg0MEProcAreaProdImageRelDispatch;
    friend class  Mfg0MEProcAreaProdImageRelGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0MEPROCAREAPRODIMAGEREL__HXX
