//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0MEProcAreaRevision
    Filename:   Mfg0MEProcAreaRevision.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0MEPROCAREAREVISION__HXX
#define TEAMCENTER__MFG0MEPROCAREAREVISION__HXX

#include <vector>
#include <string>
#include <common/tc_deprecation_macros.h>
#include <me/MEProcessRevision.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0MEProcAreaRevision;
}
namespace Teamcenter
{
    class Mfg0MEProcAreaRevisionImpl;
}
namespace Teamcenter
{
    class Mfg0MEProcAreaRevisionDelegate;
}
namespace Teamcenter
{
    class Mfg0MEProcAreaRevisionDispatch;
}
namespace Teamcenter
{
    class Mfg0MEProcAreaRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0MEProcAreaRevision
     : public  ::Teamcenter::MEProcessRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an Integer Array Property
    /// @version Teamcenter 10.1.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0DefaultStationSize( std::vector< int > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0Direction( std::string &value, bool &isNull ) const;

    ///
    /// Setter for an Integer Array Property
    /// @version Teamcenter 10.1.1
    /// @param values - Values to be set for the paramter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0DefaultStationSize( const std::vector< int > &values, const std::vector< int > *isNull=0 );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0Direction( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0MEProcAreaRevision();

    /**
     * Destructor
     */
    virtual ~Mfg0MEProcAreaRevision();

private:
    //  Getter method for the Implementation Object
    Mfg0MEProcAreaRevisionImpl*  getMfg0MEProcAreaRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0MEProcAreaRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0MEProcAreaRevisionImpl*  m_mfg0meprocarearevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0MEProcAreaRevision - desc for Mfg0MEProcAreaRevision parameter
     */
    Mfg0MEProcAreaRevision( const Mfg0MEProcAreaRevision& );
    Mfg0MEProcAreaRevision& operator=( const Mfg0MEProcAreaRevision& );

    friend class  Mfg0MEProcAreaRevisionDelegate;
    friend class  Mfg0MEProcAreaRevisionDispatch;
    friend class  Mfg0MEProcAreaRevisionGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0MEPROCAREAREVISION__HXX
