//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0MEProcAreaRevisionDelegate
    Filename:   Mfg0MEProcAreaRevisionDelegate.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0MEPROCAREAREVISIONDELEGATE_HXX
#define TEAMCENTER__MFG0MEPROCAREAREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0MEProcAreaRevision.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0MEProcAreaRevisionDelegate;
}
namespace Teamcenter
{
    class Mfg0MEProcAreaRevisionImpl;
}
namespace Teamcenter
{
    class Mfg0MEProcAreaRevision;
}
namespace Teamcenter
{
    class Mfg0MEProcAreaRevisionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  MFGBVR_API Teamcenter_alias::Mfg0MEProcAreaRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mfg0MEProcAreaRevisionDelegate instance
    static Mfg0MEProcAreaRevisionDelegate&  getInstance();

    //  Method to create the Mfg0MEProcAreaRevisionImpl pointer
    static Mfg0MEProcAreaRevisionImpl*  createImpl( Mfg0MEProcAreaRevision&  ifObj );

    //  Method to delete the Mfg0MEProcAreaRevisionImpl pointer
    static void deleteImpl( Mfg0MEProcAreaRevisionImpl*  impl );


    ///
    /// Getter for an Integer Array Property
    /// @version Teamcenter 10.1.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0DefaultStationSizeBase(const Mfg0MEProcAreaRevision &ifObj,  std::vector< int > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMfg0DirectionBase(const Mfg0MEProcAreaRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for an Integer Array Property
    /// @version Teamcenter 10.1.1
    /// @param values - Values to be set for the paramter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0DefaultStationSizeBase(Mfg0MEProcAreaRevision &ifObj,  const std::vector< int > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMfg0DirectionBase(Mfg0MEProcAreaRevision &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static Mfg0MEProcAreaRevisionDelegate*  m_pInstance;

    Mfg0MEProcAreaRevisionDelegate();
    virtual ~Mfg0MEProcAreaRevisionDelegate();
    static void setInstance( Mfg0MEProcAreaRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::Mfg0MEProcAreaRevisionGenImpl;

};

#include <mfgbvr/libmfgbvr_undef.h>
#endif  //  TEAMCENTER__MFG0MEPROCAREAREVISIONDELEGATE_HXX
