//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0MESimStudy
    Filename:   Mfg0MESimStudy.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0MESIMSTUDY__HXX
#define TEAMCENTER__MFG0MESIMSTUDY__HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0MEStudy.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0MESimStudy;
}
namespace Teamcenter
{
    class Mfg0MESimStudyImpl;
}
namespace Teamcenter
{
    class Mfg0MESimStudyDelegate;
}
namespace Teamcenter
{
    class Mfg0MESimStudyDispatch;
}
namespace Teamcenter
{
    class Mfg0MESimStudyGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0MESimStudy
     : public  ::Teamcenter::Mfg0MEStudy
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0MESimStudy();

    /**
     * Destructor
     */
    virtual ~Mfg0MESimStudy();

private:
    //  Getter method for the Implementation Object
    Mfg0MESimStudyImpl*  getMfg0MESimStudyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0MESimStudyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0MESimStudyImpl*  m_mfg0mesimstudyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0MESimStudy - desc for Mfg0MESimStudy parameter
     */
    Mfg0MESimStudy( const Mfg0MESimStudy& );
    Mfg0MESimStudy& operator=( const Mfg0MESimStudy& );

    friend class  Mfg0MESimStudyDelegate;
    friend class  Mfg0MESimStudyDispatch;
    friend class  Mfg0MESimStudyGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0MESIMSTUDY__HXX
