//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0MEStep
    Filename:   Mfg0MEStep.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0MESTEP__HXX
#define TEAMCENTER__MFG0MESTEP__HXX

#include <common/tc_deprecation_macros.h>
#include <me/MEOP.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0MEStep;
}
namespace Teamcenter
{
    class Mfg0MEStepImpl;
}
namespace Teamcenter
{
    class Mfg0MEStepDelegate;
}
namespace Teamcenter
{
    class Mfg0MEStepDispatch;
}
namespace Teamcenter
{
    class Mfg0MEStepGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0MEStep
     : public  ::Teamcenter::MEOP
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0MEStep();

    /**
     * Destructor
     */
    virtual ~Mfg0MEStep();

private:
    //  Getter method for the Implementation Object
    Mfg0MEStepImpl*  getMfg0MEStepImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0MEStepImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0MEStepImpl*  m_mfg0mestepImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0MEStep - desc for Mfg0MEStep parameter
     */
    Mfg0MEStep( const Mfg0MEStep& );
    Mfg0MEStep& operator=( const Mfg0MEStep& );

    friend class  Mfg0MEStepDelegate;
    friend class  Mfg0MEStepDispatch;
    friend class  Mfg0MEStepGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0MESTEP__HXX
