//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0MEStudy
    Filename:   Mfg0MEStudy.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0MESTUDY__HXX
#define TEAMCENTER__MFG0MESTUDY__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0MEStudy;
}
namespace Teamcenter
{
    class Mfg0MEStudyImpl;
}
namespace Teamcenter
{
    class Mfg0MEStudyDelegate;
}
namespace Teamcenter
{
    class Mfg0MEStudyDispatch;
}
namespace Teamcenter
{
    class Mfg0MEStudyGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0MEStudy
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0MEStudy();

    /**
     * Destructor
     */
    virtual ~Mfg0MEStudy();

private:
    //  Getter method for the Implementation Object
    Mfg0MEStudyImpl*  getMfg0MEStudyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0MEStudyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0MEStudyImpl*  m_mfg0mestudyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0MEStudy - desc for Mfg0MEStudy parameter
     */
    Mfg0MEStudy( const Mfg0MEStudy& );
    Mfg0MEStudy& operator=( const Mfg0MEStudy& );

    friend class  Mfg0MEStudyDelegate;
    friend class  Mfg0MEStudyDispatch;
    friend class  Mfg0MEStudyGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0MESTUDY__HXX
