//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0MEStudyRevision
    Filename:   Mfg0MEStudyRevision.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0MESTUDYREVISION__HXX
#define TEAMCENTER__MFG0MESTUDYREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0MEStudyRevision;
}
namespace Teamcenter
{
    class Mfg0MEStudyRevisionImpl;
}
namespace Teamcenter
{
    class Mfg0MEStudyRevisionDelegate;
}
namespace Teamcenter
{
    class Mfg0MEStudyRevisionDispatch;
}
namespace Teamcenter
{
    class Mfg0MEStudyRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0MEStudyRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0MEStudyRevision();

    /**
     * Destructor
     */
    virtual ~Mfg0MEStudyRevision();

private:
    //  Getter method for the Implementation Object
    Mfg0MEStudyRevisionImpl*  getMfg0MEStudyRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0MEStudyRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0MEStudyRevisionImpl*  m_mfg0mestudyrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0MEStudyRevision - desc for Mfg0MEStudyRevision parameter
     */
    Mfg0MEStudyRevision( const Mfg0MEStudyRevision& );
    Mfg0MEStudyRevision& operator=( const Mfg0MEStudyRevision& );

    friend class  Mfg0MEStudyRevisionDelegate;
    friend class  Mfg0MEStudyRevisionDispatch;
    friend class  Mfg0MEStudyRevisionGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0MESTUDYREVISION__HXX
