//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0ProcResourceRevision
    Filename:   Mfg0ProcResourceRevision.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0PROCRESOURCEREVISION__HXX
#define TEAMCENTER__MFG0PROCRESOURCEREVISION__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0MEProcAreaRevision.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0ProcResourceRevision;
}
namespace Teamcenter
{
    class Mfg0ProcResourceRevisionImpl;
}
namespace Teamcenter
{
    class Mfg0ProcResourceRevisionDelegate;
}
namespace Teamcenter
{
    class Mfg0ProcResourceRevisionDispatch;
}
namespace Teamcenter
{
    class Mfg0ProcResourceRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::Mfg0ProcResourceRevision
     : public  ::Teamcenter::Mfg0MEProcAreaRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCapacity( double &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPosition( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a Double Property
    /// @version Teamcenter 10.1.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCapacity( double value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPosition( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mfg0ProcResourceRevision();

    /**
     * Destructor
     */
    virtual ~Mfg0ProcResourceRevision();

private:
    //  Getter method for the Implementation Object
    Mfg0ProcResourceRevisionImpl*  getMfg0ProcResourceRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMfg0ProcResourceRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mfg0ProcResourceRevisionImpl*  m_mfg0procresourcerevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mfg0ProcResourceRevision - desc for Mfg0ProcResourceRevision parameter
     */
    Mfg0ProcResourceRevision( const Mfg0ProcResourceRevision& );
    Mfg0ProcResourceRevision& operator=( const Mfg0ProcResourceRevision& );

    friend class  Mfg0ProcResourceRevisionDelegate;
    friend class  Mfg0ProcResourceRevisionDispatch;
    friend class  Mfg0ProcResourceRevisionGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__MFG0PROCRESOURCEREVISION__HXX
