//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mfg0ProcResourceRevisionDelegate
    Filename:   Mfg0ProcResourceRevisionDelegate.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MFG0PROCRESOURCEREVISIONDELEGATE_HXX
#define TEAMCENTER__MFG0PROCRESOURCEREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0ProcResourceRevision.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class Mfg0ProcResourceRevisionDelegate;
}
namespace Teamcenter
{
    class Mfg0ProcResourceRevisionImpl;
}
namespace Teamcenter
{
    class Mfg0ProcResourceRevision;
}
namespace Teamcenter
{
    class Mfg0ProcResourceRevisionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  MFGBVR_API Teamcenter_alias::Mfg0ProcResourceRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mfg0ProcResourceRevisionDelegate instance
    static Mfg0ProcResourceRevisionDelegate&  getInstance();

    //  Method to create the Mfg0ProcResourceRevisionImpl pointer
    static Mfg0ProcResourceRevisionImpl*  createImpl( Mfg0ProcResourceRevision&  ifObj );

    //  Method to delete the Mfg0ProcResourceRevisionImpl pointer
    static void deleteImpl( Mfg0ProcResourceRevisionImpl*  impl );


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCapacityBase(const Mfg0ProcResourceRevision &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPositionBase(const Mfg0ProcResourceRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a Double Property
    /// @version Teamcenter 10.1.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCapacityBase(Mfg0ProcResourceRevision &ifObj,  double value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPositionBase(Mfg0ProcResourceRevision &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static Mfg0ProcResourceRevisionDelegate*  m_pInstance;

    Mfg0ProcResourceRevisionDelegate();
    virtual ~Mfg0ProcResourceRevisionDelegate();
    static void setInstance( Mfg0ProcResourceRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::Mfg0ProcResourceRevisionGenImpl;

};

#include <mfgbvr/libmfgbvr_undef.h>
#endif  //  TEAMCENTER__MFG0PROCRESOURCEREVISIONDELEGATE_HXX
