//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, WeldPoint
    Filename:   WeldPoint.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__WELDPOINT__HXX
#define TEAMCENTER__WELDPOINT__HXX

#include <common/tc_deprecation_macros.h>
#include <mechatronics/PSConnection.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class WeldPoint;
}
namespace Teamcenter
{
    class WeldPointImpl;
}
namespace Teamcenter
{
    class WeldPointDelegate;
}
namespace Teamcenter
{
    class WeldPointDispatch;
}
namespace Teamcenter
{
    class WeldPointGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::WeldPoint
     : public  ::Teamcenter::PSConnection
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    WeldPoint();

    /**
     * Destructor
     */
    virtual ~WeldPoint();

private:
    //  Getter method for the Implementation Object
    WeldPointImpl*  getWeldPointImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setWeldPointImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    WeldPointImpl*  m_weldpointImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param WeldPoint - desc for WeldPoint parameter
     */
    WeldPoint( const WeldPoint& );
    WeldPoint& operator=( const WeldPoint& );

    friend class  WeldPointDelegate;
    friend class  WeldPointDispatch;
    friend class  WeldPointGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__WELDPOINT__HXX
