//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, WeldPointRevision
    Filename:   WeldPointRevision.hxx
    Module:     mfgbvr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__WELDPOINTREVISION__HXX
#define TEAMCENTER__WELDPOINTREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <mechatronics/PSConnectionRevision.hxx>

#include <mfgbvr/libmfgbvr_exports.h>

namespace Teamcenter
{
    class WeldPointRevision;
}
namespace Teamcenter
{
    class WeldPointRevisionImpl;
}
namespace Teamcenter
{
    class WeldPointRevisionDelegate;
}
namespace Teamcenter
{
    class WeldPointRevisionDispatch;
}
namespace Teamcenter
{
    class WeldPointRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MFGBVR_API  Teamcenter::WeldPointRevision
     : public  ::Teamcenter::PSConnectionRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    WeldPointRevision();

    /**
     * Destructor
     */
    virtual ~WeldPointRevision();

private:
    //  Getter method for the Implementation Object
    WeldPointRevisionImpl*  getWeldPointRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setWeldPointRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    WeldPointRevisionImpl*  m_weldpointrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param WeldPointRevision - desc for WeldPointRevision parameter
     */
    WeldPointRevision( const WeldPointRevision& );
    WeldPointRevision& operator=( const WeldPointRevision& );

    friend class  WeldPointRevisionDelegate;
    friend class  WeldPointRevisionDispatch;
    friend class  WeldPointRevisionGenImpl;
};

#include <mfgbvr/libmfgbvr_undef.h>
#endif //   TEAMCENTER__WELDPOINTREVISION__HXX
