//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AllowedDeviation
    Filename:   AllowedDeviation.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__ALLOWEDDEVIATION__HXX
#define TEAMCENTER__MROCORE__ALLOWEDDEVIATION__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class AllowedDeviation;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class AllowedDeviationImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class AllowedDeviationDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class AllowedDeviationDispatch;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class AllowedDeviationGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MROCORE_API  Teamcenter::mrocore::AllowedDeviation
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDeviationTag( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIsConsumed( bool &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDeviationTag( const tag_t &value, bool isNull=false );

    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 8.0.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIsConsumed( bool value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AllowedDeviation();

    /**
     * Destructor
     */
    virtual ~AllowedDeviation();

private:
    //  Getter method for the Implementation Object
    AllowedDeviationImpl*  getAllowedDeviationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAllowedDeviationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AllowedDeviationImpl*  m_alloweddeviationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AllowedDeviation - desc for AllowedDeviation parameter
     */
    AllowedDeviation( const AllowedDeviation& );
    AllowedDeviation& operator=( const AllowedDeviation& );

    friend class  AllowedDeviationDelegate;
    friend class  AllowedDeviationDispatch;
    friend class  AllowedDeviationGenImpl;
};

#include <mrocore/libmrocore_undef.h>
#endif //   TEAMCENTER__MROCORE__ALLOWEDDEVIATION__HXX
