//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AllowedDeviationData
    Filename:   AllowedDeviationData.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__ALLOWEDDEVIATIONDATA__HXX
#define TEAMCENTER__MROCORE__ALLOWEDDEVIATIONDATA__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class AllowedDeviationData;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class AllowedDeviationDataImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class AllowedDeviationDataDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class AllowedDeviationDataDispatch;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class AllowedDeviationDataGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MROCORE_API  Teamcenter::mrocore::AllowedDeviationData
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AllowedDeviationData();

    /**
     * Destructor
     */
    virtual ~AllowedDeviationData();

private:
    //  Getter method for the Implementation Object
    AllowedDeviationDataImpl*  getAllowedDeviationDataImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAllowedDeviationDataImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AllowedDeviationDataImpl*  m_alloweddeviationdataImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AllowedDeviationData - desc for AllowedDeviationData parameter
     */
    AllowedDeviationData( const AllowedDeviationData& );
    AllowedDeviationData& operator=( const AllowedDeviationData& );

    friend class  AllowedDeviationDataDelegate;
    friend class  AllowedDeviationDataDispatch;
    friend class  AllowedDeviationDataGenImpl;
};

#include <mrocore/libmrocore_undef.h>
#endif //   TEAMCENTER__MROCORE__ALLOWEDDEVIATIONDATA__HXX
