//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AllowedDeviationDelegate
    Filename:   AllowedDeviationDelegate.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__ALLOWEDDEVIATIONDELEGATE_HXX
#define TEAMCENTER__MROCORE__ALLOWEDDEVIATIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mrocore/AllowedDeviation.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class AllowedDeviationDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class AllowedDeviationImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class AllowedDeviation;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class AllowedDeviationGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MROCORE_API Teamcenter_alias::mrocore::AllowedDeviationDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the AllowedDeviationDelegate instance
    static AllowedDeviationDelegate&  getInstance();

    //  Method to create the AllowedDeviationImpl pointer
    static AllowedDeviationImpl*  createImpl( AllowedDeviation&  ifObj );

    //  Method to delete the AllowedDeviationImpl pointer
    static void deleteImpl( AllowedDeviationImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDeviationTagBase(const AllowedDeviation &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIsConsumedBase(const AllowedDeviation &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDeviationTagBase(AllowedDeviation &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 8.0.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIsConsumedBase(AllowedDeviation &ifObj,  bool value, bool isNull );



protected:
    //  Pointer to the instance
    static AllowedDeviationDelegate*  m_pInstance;

    AllowedDeviationDelegate();
    virtual ~AllowedDeviationDelegate();
    static void setInstance( AllowedDeviationDelegate*  instance );


private:
    friend class  ::Teamcenter::mrocore::AllowedDeviationGenImpl;

};

#include <mrocore/libmrocore_undef.h>
#endif  //  TEAMCENTER__MROCORE__ALLOWEDDEVIATIONDELEGATE_HXX
