//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CharacteristicDefinition
    Filename:   CharacteristicDefinition.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__CHARACTERISTICDEFINITION__HXX
#define TEAMCENTER__MROCORE__CHARACTERISTICDEFINITION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class CharacteristicDefinition;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class CharacteristicDefinitionImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class CharacteristicDefinitionDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class CharacteristicDefinitionDispatch;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class CharacteristicDefinitionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MROCORE_API  Teamcenter::mrocore::CharacteristicDefinition
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CharacteristicDefinition();

    /**
     * Destructor
     */
    virtual ~CharacteristicDefinition();

private:
    //  Getter method for the Implementation Object
    CharacteristicDefinitionImpl*  getCharacteristicDefinitionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCharacteristicDefinitionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CharacteristicDefinitionImpl*  m_characteristicdefinitionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CharacteristicDefinition - desc for CharacteristicDefinition parameter
     */
    CharacteristicDefinition( const CharacteristicDefinition& );
    CharacteristicDefinition& operator=( const CharacteristicDefinition& );

    friend class  CharacteristicDefinitionDelegate;
    friend class  CharacteristicDefinitionDispatch;
    friend class  CharacteristicDefinitionGenImpl;
};

#include <mrocore/libmrocore_undef.h>
#endif //   TEAMCENTER__MROCORE__CHARACTERISTICDEFINITION__HXX
