//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CharacteristicDefinitionDelegate
    Filename:   CharacteristicDefinitionDelegate.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__CHARACTERISTICDEFINITIONDELEGATE_HXX
#define TEAMCENTER__MROCORE__CHARACTERISTICDEFINITIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mrocore/CharacteristicDefinition.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class CharacteristicDefinitionDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class CharacteristicDefinitionImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class CharacteristicDefinition;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class CharacteristicDefinitionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MROCORE_API Teamcenter_alias::mrocore::CharacteristicDefinitionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CharacteristicDefinitionDelegate instance
    static CharacteristicDefinitionDelegate&  getInstance();

    //  Method to create the CharacteristicDefinitionImpl pointer
    static CharacteristicDefinitionImpl*  createImpl( CharacteristicDefinition&  ifObj );

    //  Method to delete the CharacteristicDefinitionImpl pointer
    static void deleteImpl( CharacteristicDefinitionImpl*  impl );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const CharacteristicDefinition &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static CharacteristicDefinitionDelegate*  m_pInstance;

    CharacteristicDefinitionDelegate();
    virtual ~CharacteristicDefinitionDelegate();
    static void setInstance( CharacteristicDefinitionDelegate*  instance );


private:
    friend class  ::Teamcenter::mrocore::CharacteristicDefinitionGenImpl;

};

#include <mrocore/libmrocore_undef.h>
#endif  //  TEAMCENTER__MROCORE__CHARACTERISTICDEFINITIONDELEGATE_HXX
