//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CharacteristicValue
    Filename:   CharacteristicValue.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__CHARACTERISTICVALUE__HXX
#define TEAMCENTER__MROCORE__CHARACTERISTICVALUE__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class CharacteristicValue;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class CharacteristicValueImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class CharacteristicValueDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class CharacteristicValueDispatch;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class CharacteristicValueGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MROCORE_API  Teamcenter::mrocore::CharacteristicValue
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSmr0ValueCapturedBy( std::string &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CharacteristicValue();

    /**
     * Destructor
     */
    virtual ~CharacteristicValue();

private:
    //  Getter method for the Implementation Object
    CharacteristicValueImpl*  getCharacteristicValueImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCharacteristicValueImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CharacteristicValueImpl*  m_characteristicvalueImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CharacteristicValue - desc for CharacteristicValue parameter
     */
    CharacteristicValue( const CharacteristicValue& );
    CharacteristicValue& operator=( const CharacteristicValue& );

    friend class  CharacteristicValueDelegate;
    friend class  CharacteristicValueDispatch;
    friend class  CharacteristicValueGenImpl;
};

#include <mrocore/libmrocore_undef.h>
#endif //   TEAMCENTER__MROCORE__CHARACTERISTICVALUE__HXX
