//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CharacteristicValueDelegate
    Filename:   CharacteristicValueDelegate.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__CHARACTERISTICVALUEDELEGATE_HXX
#define TEAMCENTER__MROCORE__CHARACTERISTICVALUEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mrocore/CharacteristicValue.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class CharacteristicValueDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class CharacteristicValueImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class CharacteristicValue;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class CharacteristicValueGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MROCORE_API Teamcenter_alias::mrocore::CharacteristicValueDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CharacteristicValueDelegate instance
    static CharacteristicValueDelegate&  getInstance();

    //  Method to create the CharacteristicValueImpl pointer
    static CharacteristicValueImpl*  createImpl( CharacteristicValue&  ifObj );

    //  Method to delete the CharacteristicValueImpl pointer
    static void deleteImpl( CharacteristicValueImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSmr0ValueCapturedByBase(const CharacteristicValue &ifObj,  std::string &value, bool &isNull ) const;



protected:
    //  Pointer to the instance
    static CharacteristicValueDelegate*  m_pInstance;

    CharacteristicValueDelegate();
    virtual ~CharacteristicValueDelegate();
    static void setInstance( CharacteristicValueDelegate*  instance );


private:
    friend class  ::Teamcenter::mrocore::CharacteristicValueGenImpl;

};

#include <mrocore/libmrocore_undef.h>
#endif  //  TEAMCENTER__MROCORE__CHARACTERISTICVALUEDELEGATE_HXX
