//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DateCharDefinition
    Filename:   DateCharDefinition.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__DATECHARDEFINITION__HXX
#define TEAMCENTER__MROCORE__DATECHARDEFINITION__HXX

#include <common/tc_deprecation_macros.h>
#include <mrocore/CharacteristicDefinition.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class DateCharDefinition;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class DateCharDefinitionImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class DateCharDefinitionDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class DateCharDefinitionDispatch;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class DateCharDefinitionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MROCORE_API  Teamcenter::mrocore::DateCharDefinition
     : public  ::Teamcenter::mrocore::CharacteristicDefinition
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    DateCharDefinition();

    /**
     * Destructor
     */
    virtual ~DateCharDefinition();

private:
    //  Getter method for the Implementation Object
    DateCharDefinitionImpl*  getDateCharDefinitionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDateCharDefinitionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DateCharDefinitionImpl*  m_datechardefinitionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param DateCharDefinition - desc for DateCharDefinition parameter
     */
    DateCharDefinition( const DateCharDefinition& );
    DateCharDefinition& operator=( const DateCharDefinition& );

    friend class  DateCharDefinitionDelegate;
    friend class  DateCharDefinitionDispatch;
    friend class  DateCharDefinitionGenImpl;
};

#include <mrocore/libmrocore_undef.h>
#endif //   TEAMCENTER__MROCORE__DATECHARDEFINITION__HXX
