//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, FaultCode
    Filename:   FaultCode.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__FAULTCODE__HXX
#define TEAMCENTER__MROCORE__FAULTCODE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class FaultCode;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class FaultCodeImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class FaultCodeDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class FaultCodeDispatch;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class FaultCodeGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MROCORE_API  Teamcenter::mrocore::FaultCode
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    FaultCode();

    /**
     * Destructor
     */
    virtual ~FaultCode();

private:
    //  Getter method for the Implementation Object
    FaultCodeImpl*  getFaultCodeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFaultCodeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    FaultCodeImpl*  m_faultcodeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param FaultCode - desc for FaultCode parameter
     */
    FaultCode( const FaultCode& );
    FaultCode& operator=( const FaultCode& );

    friend class  FaultCodeDelegate;
    friend class  FaultCodeDispatch;
    friend class  FaultCodeGenImpl;
};

#include <mrocore/libmrocore_undef.h>
#endif //   TEAMCENTER__MROCORE__FAULTCODE__HXX
