//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, FaultCodeDelegate
    Filename:   FaultCodeDelegate.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__FAULTCODEDELEGATE_HXX
#define TEAMCENTER__MROCORE__FAULTCODEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mrocore/FaultCode.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class FaultCodeDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class FaultCodeImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class FaultCode;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class FaultCodeGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MROCORE_API Teamcenter_alias::mrocore::FaultCodeDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the FaultCodeDelegate instance
    static FaultCodeDelegate&  getInstance();

    //  Method to create the FaultCodeImpl pointer
    static FaultCodeImpl*  createImpl( FaultCode&  ifObj );

    //  Method to delete the FaultCodeImpl pointer
    static void deleteImpl( FaultCodeImpl*  impl );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const FaultCode &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static FaultCodeDelegate*  m_pInstance;

    FaultCodeDelegate();
    virtual ~FaultCodeDelegate();
    static void setInstance( FaultCodeDelegate*  instance );


private:
    friend class  ::Teamcenter::mrocore::FaultCodeGenImpl;

};

#include <mrocore/libmrocore_undef.h>
#endif  //  TEAMCENTER__MROCORE__FAULTCODEDELEGATE_HXX
