//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, HWSOStructure
    Filename:   HWSOStructure.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__HWSOSTRUCTURE__HXX
#define TEAMCENTER__MROCORE__HWSOSTRUCTURE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class HWSOStructure;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class HWSOStructureImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class HWSOStructureDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class HWSOStructureDispatch;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class HWSOStructureGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MROCORE_API  Teamcenter::mrocore::HWSOStructure
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    HWSOStructure();

    /**
     * Destructor
     */
    virtual ~HWSOStructure();

private:
    //  Getter method for the Implementation Object
    HWSOStructureImpl*  getHWSOStructureImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setHWSOStructureImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    HWSOStructureImpl*  m_hwsostructureImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param HWSOStructure - desc for HWSOStructure parameter
     */
    HWSOStructure( const HWSOStructure& );
    HWSOStructure& operator=( const HWSOStructure& );

    friend class  HWSOStructureDelegate;
    friend class  HWSOStructureDispatch;
    friend class  HWSOStructureGenImpl;
};

#include <mrocore/libmrocore_undef.h>
#endif //   TEAMCENTER__MROCORE__HWSOSTRUCTURE__HXX
