//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, HWSOStructureDelegate
    Filename:   HWSOStructureDelegate.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__HWSOSTRUCTUREDELEGATE_HXX
#define TEAMCENTER__MROCORE__HWSOSTRUCTUREDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mrocore/HWSOStructure.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class HWSOStructureDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class HWSOStructureImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class HWSOStructure;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class HWSOStructureGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MROCORE_API Teamcenter_alias::mrocore::HWSOStructureDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the HWSOStructureDelegate instance
    static HWSOStructureDelegate&  getInstance();

    //  Method to create the HWSOStructureImpl pointer
    static HWSOStructureImpl*  createImpl( HWSOStructure&  ifObj );

    //  Method to delete the HWSOStructureImpl pointer
    static void deleteImpl( HWSOStructureImpl*  impl );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const HWSOStructure &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static HWSOStructureDelegate*  m_pInstance;

    HWSOStructureDelegate();
    virtual ~HWSOStructureDelegate();
    static void setInstance( HWSOStructureDelegate*  instance );


private:
    friend class  ::Teamcenter::mrocore::HWSOStructureGenImpl;

};

#include <mrocore/libmrocore_undef.h>
#endif  //  TEAMCENTER__MROCORE__HWSOSTRUCTUREDELEGATE_HXX
