//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, HierarchicalWSO
    Filename:   HierarchicalWSO.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__HIERARCHICALWSO__HXX
#define TEAMCENTER__MROCORE__HIERARCHICALWSO__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class HierarchicalWSO;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class HierarchicalWSOImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class HierarchicalWSODelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class HierarchicalWSODispatch;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class HierarchicalWSOGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MROCORE_API  Teamcenter::mrocore::HierarchicalWSO
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    HierarchicalWSO();

    /**
     * Destructor
     */
    virtual ~HierarchicalWSO();

private:
    //  Getter method for the Implementation Object
    HierarchicalWSOImpl*  getHierarchicalWSOImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setHierarchicalWSOImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    HierarchicalWSOImpl*  m_hierarchicalwsoImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param HierarchicalWSO - desc for HierarchicalWSO parameter
     */
    HierarchicalWSO( const HierarchicalWSO& );
    HierarchicalWSO& operator=( const HierarchicalWSO& );

    friend class  HierarchicalWSODelegate;
    friend class  HierarchicalWSODispatch;
    friend class  HierarchicalWSOGenImpl;
};

#include <mrocore/libmrocore_undef.h>
#endif //   TEAMCENTER__MROCORE__HIERARCHICALWSO__HXX
