//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, LifeCharDefinition
    Filename:   LifeCharDefinition.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__LIFECHARDEFINITION__HXX
#define TEAMCENTER__MROCORE__LIFECHARDEFINITION__HXX

#include <common/tc_deprecation_macros.h>
#include <mrocore/CharacteristicDefinition.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class LifeCharDefinition;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class LifeCharDefinitionImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class LifeCharDefinitionDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class LifeCharDefinitionDispatch;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class LifeCharDefinitionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MROCORE_API  Teamcenter::mrocore::LifeCharDefinition
     : public  ::Teamcenter::mrocore::CharacteristicDefinition
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    LifeCharDefinition();

    /**
     * Destructor
     */
    virtual ~LifeCharDefinition();

private:
    //  Getter method for the Implementation Object
    LifeCharDefinitionImpl*  getLifeCharDefinitionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLifeCharDefinitionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    LifeCharDefinitionImpl*  m_lifechardefinitionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param LifeCharDefinition - desc for LifeCharDefinition parameter
     */
    LifeCharDefinition( const LifeCharDefinition& );
    LifeCharDefinition& operator=( const LifeCharDefinition& );

    friend class  LifeCharDefinitionDelegate;
    friend class  LifeCharDefinitionDispatch;
    friend class  LifeCharDefinitionGenImpl;
};

#include <mrocore/libmrocore_undef.h>
#endif //   TEAMCENTER__MROCORE__LIFECHARDEFINITION__HXX
