//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, LogBook
    Filename:   LogBook.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__LOGBOOK__HXX
#define TEAMCENTER__MROCORE__LOGBOOK__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class LogBook;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class LogBookImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class LogBookDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class LogBookDispatch;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class LogBookGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MROCORE_API  Teamcenter::mrocore::LogBook
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    LogBook();

    /**
     * Destructor
     */
    virtual ~LogBook();

private:
    //  Getter method for the Implementation Object
    LogBookImpl*  getLogBookImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLogBookImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    LogBookImpl*  m_logbookImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param LogBook - desc for LogBook parameter
     */
    LogBook( const LogBook& );
    LogBook& operator=( const LogBook& );

    friend class  LogBookDelegate;
    friend class  LogBookDispatch;
    friend class  LogBookGenImpl;
};

#include <mrocore/libmrocore_undef.h>
#endif //   TEAMCENTER__MROCORE__LOGBOOK__HXX
