//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, LogBookDelegate
    Filename:   LogBookDelegate.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__LOGBOOKDELEGATE_HXX
#define TEAMCENTER__MROCORE__LOGBOOKDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mrocore/LogBook.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class LogBookDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class LogBookImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class LogBook;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class LogBookGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MROCORE_API Teamcenter_alias::mrocore::LogBookDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the LogBookDelegate instance
    static LogBookDelegate&  getInstance();

    //  Method to create the LogBookImpl pointer
    static LogBookImpl*  createImpl( LogBook&  ifObj );

    //  Method to delete the LogBookImpl pointer
    static void deleteImpl( LogBookImpl*  impl );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const LogBook &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static LogBookDelegate*  m_pInstance;

    LogBookDelegate();
    virtual ~LogBookDelegate();
    static void setInstance( LogBookDelegate*  instance );


private:
    friend class  ::Teamcenter::mrocore::LogBookGenImpl;

};

#include <mrocore/libmrocore_undef.h>
#endif  //  TEAMCENTER__MROCORE__LOGBOOKDELEGATE_HXX
