//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, LogEntry
    Filename:   LogEntry.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__LOGENTRY__HXX
#define TEAMCENTER__MROCORE__LOGENTRY__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class LogEntry;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class LogEntryImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class LogEntryDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class LogEntryDispatch;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class LogEntryGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MROCORE_API  Teamcenter::mrocore::LogEntry
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    LogEntry();

    /**
     * Destructor
     */
    virtual ~LogEntry();

private:
    //  Getter method for the Implementation Object
    LogEntryImpl*  getLogEntryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLogEntryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    LogEntryImpl*  m_logentryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param LogEntry - desc for LogEntry parameter
     */
    LogEntry( const LogEntry& );
    LogEntry& operator=( const LogEntry& );

    friend class  LogEntryDelegate;
    friend class  LogEntryDispatch;
    friend class  LogEntryGenImpl;
};

#include <mrocore/libmrocore_undef.h>
#endif //   TEAMCENTER__MROCORE__LOGENTRY__HXX
