//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, LogEntryValues
    Filename:   LogEntryValues.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__LOGENTRYVALUES__HXX
#define TEAMCENTER__MROCORE__LOGENTRYVALUES__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class LogEntryValues;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class LogEntryValuesImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class LogEntryValuesDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class LogEntryValuesDispatch;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class LogEntryValuesGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MROCORE_API  Teamcenter::mrocore::LogEntryValues
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    LogEntryValues();

    /**
     * Destructor
     */
    virtual ~LogEntryValues();

private:
    //  Getter method for the Implementation Object
    LogEntryValuesImpl*  getLogEntryValuesImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLogEntryValuesImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    LogEntryValuesImpl*  m_logentryvaluesImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param LogEntryValues - desc for LogEntryValues parameter
     */
    LogEntryValues( const LogEntryValues& );
    LogEntryValues& operator=( const LogEntryValues& );

    friend class  LogEntryValuesDelegate;
    friend class  LogEntryValuesDispatch;
    friend class  LogEntryValuesGenImpl;
};

#include <mrocore/libmrocore_undef.h>
#endif //   TEAMCENTER__MROCORE__LOGENTRYVALUES__HXX
