//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, LotDelegate
    Filename:   LotDelegate.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__LOTDELEGATE_HXX
#define TEAMCENTER__MROCORE__LOTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mrocore/Lot.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class LotDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class LotImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class Lot;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class LotGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MROCORE_API Teamcenter_alias::mrocore::LotDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the LotDelegate instance
    static LotDelegate&  getInstance();

    //  Method to create the LotImpl pointer
    static LotImpl*  createImpl( Lot&  ifObj );

    //  Method to delete the LotImpl pointer
    static void deleteImpl( LotImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDesignItemTagBase(const Lot &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Date Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getExpirationDateBase(const Lot &ifObj,  date_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLotNumberBase(const Lot &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLotSizeBase(const Lot &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLotUsageBase(const Lot &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getManufacturerOrgIdBase(const Lot &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDesignItemTagBase(Lot &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Date Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setExpirationDateBase(Lot &ifObj,  const date_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLotNumberBase(Lot &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLotSizeBase(Lot &ifObj,  int value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLotUsageBase(Lot &ifObj,  int value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setManufacturerOrgIdBase(Lot &ifObj,  const std::string &value, bool isNull );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Lot &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static LotDelegate*  m_pInstance;

    LotDelegate();
    virtual ~LotDelegate();
    static void setInstance( LotDelegate*  instance );


private:
    friend class  ::Teamcenter::mrocore::LotGenImpl;

};

#include <mrocore/libmrocore_undef.h>
#endif  //  TEAMCENTER__MROCORE__LOTDELEGATE_HXX
