//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MroBOMWindow
    Filename:   MroBOMWindow.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__MROBOMWINDOW__HXX
#define TEAMCENTER__MROCORE__MROBOMWINDOW__HXX

#include <common/tc_deprecation_macros.h>
#include <bom/BOMWindow.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class MroBOMWindow;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class MroBOMWindowImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class MroBOMWindowDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class MroBOMWindowDispatch;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class MroBOMWindowGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MROCORE_API  Teamcenter::mrocore::MroBOMWindow
     : public  ::Teamcenter::BOMWindow
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    MroBOMWindow();

    /**
     * Destructor
     */
    virtual ~MroBOMWindow();

private:
    //  Getter method for the Implementation Object
    MroBOMWindowImpl*  getMroBOMWindowImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMroBOMWindowImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    MroBOMWindowImpl*  m_mrobomwindowImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param MroBOMWindow - desc for MroBOMWindow parameter
     */
    MroBOMWindow( const MroBOMWindow& );
    MroBOMWindow& operator=( const MroBOMWindow& );

    friend class  MroBOMWindowDelegate;
    friend class  MroBOMWindowDispatch;
    friend class  MroBOMWindowGenImpl;
};

#include <mrocore/libmrocore_undef.h>
#endif //   TEAMCENTER__MROCORE__MROBOMWINDOW__HXX
