//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MroRevisionRule
    Filename:   MroRevisionRule.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__MROREVISIONRULE__HXX
#define TEAMCENTER__MROCORE__MROREVISIONRULE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class MroRevisionRule;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class MroRevisionRuleImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class MroRevisionRuleDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class MroRevisionRuleDispatch;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class MroRevisionRuleGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MROCORE_API  Teamcenter::mrocore::MroRevisionRule
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    MroRevisionRule();

    /**
     * Destructor
     */
    virtual ~MroRevisionRule();

private:
    //  Getter method for the Implementation Object
    MroRevisionRuleImpl*  getMroRevisionRuleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMroRevisionRuleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    MroRevisionRuleImpl*  m_mrorevisionruleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param MroRevisionRule - desc for MroRevisionRule parameter
     */
    MroRevisionRule( const MroRevisionRule& );
    MroRevisionRule& operator=( const MroRevisionRule& );

    friend class  MroRevisionRuleDelegate;
    friend class  MroRevisionRuleDispatch;
    friend class  MroRevisionRuleGenImpl;
};

#include <mrocore/libmrocore_undef.h>
#endif //   TEAMCENTER__MROCORE__MROREVISIONRULE__HXX
