//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, NeutralBOMLine
    Filename:   NeutralBOMLine.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__NEUTRALBOMLINE__HXX
#define TEAMCENTER__MROCORE__NEUTRALBOMLINE__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <bom/ImanItemLine.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class NeutralBOMLine;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class NeutralBOMLineImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class NeutralBOMLineDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class NeutralBOMLineDispatch;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class NeutralBOMLineGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MROCORE_API  Teamcenter::mrocore::NeutralBOMLine
     : public  ::Teamcenter::ImanItemLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPhbl_design_rev_id( std::string &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    NeutralBOMLine();

    /**
     * Destructor
     */
    virtual ~NeutralBOMLine();

private:
    //  Getter method for the Implementation Object
    NeutralBOMLineImpl*  getNeutralBOMLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setNeutralBOMLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    NeutralBOMLineImpl*  m_neutralbomlineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param NeutralBOMLine - desc for NeutralBOMLine parameter
     */
    NeutralBOMLine( const NeutralBOMLine& );
    NeutralBOMLine& operator=( const NeutralBOMLine& );

    friend class  NeutralBOMLineDelegate;
    friend class  NeutralBOMLineDispatch;
    friend class  NeutralBOMLineGenImpl;
};

#include <mrocore/libmrocore_undef.h>
#endif //   TEAMCENTER__MROCORE__NEUTRALBOMLINE__HXX
