//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, NeutralCharacteristics
    Filename:   NeutralCharacteristics.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__NEUTRALCHARACTERISTICS__HXX
#define TEAMCENTER__MROCORE__NEUTRALCHARACTERISTICS__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class NeutralCharacteristics;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class NeutralCharacteristicsImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class NeutralCharacteristicsDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class NeutralCharacteristicsDispatch;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class NeutralCharacteristicsGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MROCORE_API  Teamcenter::mrocore::NeutralCharacteristics
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    NeutralCharacteristics();

    /**
     * Destructor
     */
    virtual ~NeutralCharacteristics();

private:
    //  Getter method for the Implementation Object
    NeutralCharacteristicsImpl*  getNeutralCharacteristicsImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setNeutralCharacteristicsImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    NeutralCharacteristicsImpl*  m_neutralcharacteristicsImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param NeutralCharacteristics - desc for NeutralCharacteristics parameter
     */
    NeutralCharacteristics( const NeutralCharacteristics& );
    NeutralCharacteristics& operator=( const NeutralCharacteristics& );

    friend class  NeutralCharacteristicsDelegate;
    friend class  NeutralCharacteristicsDispatch;
    friend class  NeutralCharacteristicsGenImpl;
};

#include <mrocore/libmrocore_undef.h>
#endif //   TEAMCENTER__MROCORE__NEUTRALCHARACTERISTICS__HXX
