//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ObsCharDefinition
    Filename:   ObsCharDefinition.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__OBSCHARDEFINITION__HXX
#define TEAMCENTER__MROCORE__OBSCHARDEFINITION__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <mrocore/CharacteristicDefinition.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class ObsCharDefinition;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class ObsCharDefinitionImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class ObsCharDefinitionDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class ObsCharDefinitionDispatch;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class ObsCharDefinitionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MROCORE_API  Teamcenter::mrocore::ObsCharDefinition
     : public  ::Teamcenter::mrocore::CharacteristicDefinition
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 12.4
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getSmr0CharacteristicValues( std::vector< std::string > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 12.4
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setSmr0CharacteristicValues( const std::vector< std::string > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ObsCharDefinition();

    /**
     * Destructor
     */
    virtual ~ObsCharDefinition();

private:
    //  Getter method for the Implementation Object
    ObsCharDefinitionImpl*  getObsCharDefinitionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setObsCharDefinitionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ObsCharDefinitionImpl*  m_obschardefinitionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ObsCharDefinition - desc for ObsCharDefinition parameter
     */
    ObsCharDefinition( const ObsCharDefinition& );
    ObsCharDefinition& operator=( const ObsCharDefinition& );

    friend class  ObsCharDefinitionDelegate;
    friend class  ObsCharDefinitionDispatch;
    friend class  ObsCharDefinitionGenImpl;
};

#include <mrocore/libmrocore_undef.h>
#endif //   TEAMCENTER__MROCORE__OBSCHARDEFINITION__HXX
