//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ObsCharDefinitionDelegate
    Filename:   ObsCharDefinitionDelegate.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__OBSCHARDEFINITIONDELEGATE_HXX
#define TEAMCENTER__MROCORE__OBSCHARDEFINITIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mrocore/ObsCharDefinition.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class ObsCharDefinitionDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class ObsCharDefinitionImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class ObsCharDefinition;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class ObsCharDefinitionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MROCORE_API Teamcenter_alias::mrocore::ObsCharDefinitionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ObsCharDefinitionDelegate instance
    static ObsCharDefinitionDelegate&  getInstance();

    //  Method to create the ObsCharDefinitionImpl pointer
    static ObsCharDefinitionImpl*  createImpl( ObsCharDefinition&  ifObj );

    //  Method to delete the ObsCharDefinitionImpl pointer
    static void deleteImpl( ObsCharDefinitionImpl*  impl );


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 12.4
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getSmr0CharacteristicValuesBase(const ObsCharDefinition &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 12.4
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setSmr0CharacteristicValuesBase(ObsCharDefinition &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );



protected:
    //  Pointer to the instance
    static ObsCharDefinitionDelegate*  m_pInstance;

    ObsCharDefinitionDelegate();
    virtual ~ObsCharDefinitionDelegate();
    static void setInstance( ObsCharDefinitionDelegate*  instance );


private:
    friend class  ::Teamcenter::mrocore::ObsCharDefinitionGenImpl;

};

#include <mrocore/libmrocore_undef.h>
#endif  //  TEAMCENTER__MROCORE__OBSCHARDEFINITIONDELEGATE_HXX
