//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PartLogisticsForm
    Filename:   PartLogisticsForm.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__PARTLOGISTICSFORM__HXX
#define TEAMCENTER__MROCORE__PARTLOGISTICSFORM__HXX

#include <common/tc_deprecation_macros.h>
#include <form/Form.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class PartLogisticsForm;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PartLogisticsFormImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PartLogisticsFormDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PartLogisticsFormDispatch;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PartLogisticsFormGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MROCORE_API  Teamcenter::mrocore::PartLogisticsForm
     : public  ::Teamcenter::Form
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PartLogisticsForm();

    /**
     * Destructor
     */
    virtual ~PartLogisticsForm();

private:
    //  Getter method for the Implementation Object
    PartLogisticsFormImpl*  getPartLogisticsFormImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPartLogisticsFormImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PartLogisticsFormImpl*  m_partlogisticsformImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PartLogisticsForm - desc for PartLogisticsForm parameter
     */
    PartLogisticsForm( const PartLogisticsForm& );
    PartLogisticsForm& operator=( const PartLogisticsForm& );

    friend class  PartLogisticsFormDelegate;
    friend class  PartLogisticsFormDispatch;
    friend class  PartLogisticsFormGenImpl;
};

#include <mrocore/libmrocore_undef.h>
#endif //   TEAMCENTER__MROCORE__PARTLOGISTICSFORM__HXX
