//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PartLogisticsFormStorageDelegate
    Filename:   PartLogisticsFormStorageDelegate.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__PARTLOGISTICSFORMSTORAGEDELEGATE_HXX
#define TEAMCENTER__MROCORE__PARTLOGISTICSFORMSTORAGEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mrocore/PartLogisticsFormStorage.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class PartLogisticsFormStorageDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PartLogisticsFormStorageImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PartLogisticsFormStorage;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PartLogisticsFormStorageGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MROCORE_API Teamcenter_alias::mrocore::PartLogisticsFormStorageDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PartLogisticsFormStorageDelegate instance
    static PartLogisticsFormStorageDelegate&  getInstance();

    //  Method to create the PartLogisticsFormStorageImpl pointer
    static PartLogisticsFormStorageImpl*  createImpl( PartLogisticsFormStorage&  ifObj );

    //  Method to delete the PartLogisticsFormStorageImpl pointer
    static void deleteImpl( PartLogisticsFormStorageImpl*  impl );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIsConsumableBase(PartLogisticsFormStorage &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIsLotBase(PartLogisticsFormStorage &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIsRotableBase(PartLogisticsFormStorage &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIsSerializedBase(PartLogisticsFormStorage &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIsTraceableBase(PartLogisticsFormStorage &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLifeLimitedBase(PartLogisticsFormStorage &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPreserveQuantityBase(PartLogisticsFormStorage &ifObj,  bool value, bool isNull );



protected:
    //  Pointer to the instance
    static PartLogisticsFormStorageDelegate*  m_pInstance;

    PartLogisticsFormStorageDelegate();
    virtual ~PartLogisticsFormStorageDelegate();
    static void setInstance( PartLogisticsFormStorageDelegate*  instance );


private:
    friend class  ::Teamcenter::mrocore::PartLogisticsFormStorageGenImpl;

};

#include <mrocore/libmrocore_undef.h>
#endif  //  TEAMCENTER__MROCORE__PARTLOGISTICSFORMSTORAGEDELEGATE_HXX
