//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PhysicalBOMLine
    Filename:   PhysicalBOMLine.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__PHYSICALBOMLINE__HXX
#define TEAMCENTER__MROCORE__PHYSICALBOMLINE__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <bom/ImanItemLine.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalBOMLine;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalBOMLineImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalBOMLineDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalBOMLineDispatch;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalBOMLineGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MROCORE_API  Teamcenter::mrocore::PhysicalBOMLine
     : public  ::Teamcenter::ImanItemLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPhbl_design_rev_id( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPhbl_is_standalone( bool &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPhbl_installation_time( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PhysicalBOMLine();

    /**
     * Destructor
     */
    virtual ~PhysicalBOMLine();

private:
    //  Getter method for the Implementation Object
    PhysicalBOMLineImpl*  getPhysicalBOMLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPhysicalBOMLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PhysicalBOMLineImpl*  m_physicalbomlineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PhysicalBOMLine - desc for PhysicalBOMLine parameter
     */
    PhysicalBOMLine( const PhysicalBOMLine& );
    PhysicalBOMLine& operator=( const PhysicalBOMLine& );

    friend class  PhysicalBOMLineDelegate;
    friend class  PhysicalBOMLineDispatch;
    friend class  PhysicalBOMLineGenImpl;
};

#include <mrocore/libmrocore_undef.h>
#endif //   TEAMCENTER__MROCORE__PHYSICALBOMLINE__HXX
