//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PhysicalBOMLineDelegate
    Filename:   PhysicalBOMLineDelegate.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__PHYSICALBOMLINEDELEGATE_HXX
#define TEAMCENTER__MROCORE__PHYSICALBOMLINEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mrocore/PhysicalBOMLine.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalBOMLineDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalBOMLineImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalBOMLine;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalBOMLineGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MROCORE_API Teamcenter_alias::mrocore::PhysicalBOMLineDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PhysicalBOMLineDelegate instance
    static PhysicalBOMLineDelegate&  getInstance();

    //  Method to create the PhysicalBOMLineImpl pointer
    static PhysicalBOMLineImpl*  createImpl( PhysicalBOMLine&  ifObj );

    //  Method to delete the PhysicalBOMLineImpl pointer
    static void deleteImpl( PhysicalBOMLineImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPhbl_design_rev_idBase(const PhysicalBOMLine &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPhbl_is_standaloneBase(const PhysicalBOMLine &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPhbl_installation_timeBase(PhysicalBOMLine &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static PhysicalBOMLineDelegate*  m_pInstance;

    PhysicalBOMLineDelegate();
    virtual ~PhysicalBOMLineDelegate();
    static void setInstance( PhysicalBOMLineDelegate*  instance );


private:
    friend class  ::Teamcenter::mrocore::PhysicalBOMLineGenImpl;

};

#include <mrocore/libmrocore_undef.h>
#endif  //  TEAMCENTER__MROCORE__PHYSICALBOMLINEDELEGATE_HXX
