//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PhysicalCharacteristics
    Filename:   PhysicalCharacteristics.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__PHYSICALCHARACTERISTICS__HXX
#define TEAMCENTER__MROCORE__PHYSICALCHARACTERISTICS__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalCharacteristics;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalCharacteristicsImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalCharacteristicsDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalCharacteristicsDispatch;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalCharacteristicsGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MROCORE_API  Teamcenter::mrocore::PhysicalCharacteristics
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PhysicalCharacteristics();

    /**
     * Destructor
     */
    virtual ~PhysicalCharacteristics();

private:
    //  Getter method for the Implementation Object
    PhysicalCharacteristicsImpl*  getPhysicalCharacteristicsImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPhysicalCharacteristicsImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PhysicalCharacteristicsImpl*  m_physicalcharacteristicsImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PhysicalCharacteristics - desc for PhysicalCharacteristics parameter
     */
    PhysicalCharacteristics( const PhysicalCharacteristics& );
    PhysicalCharacteristics& operator=( const PhysicalCharacteristics& );

    friend class  PhysicalCharacteristicsDelegate;
    friend class  PhysicalCharacteristicsDispatch;
    friend class  PhysicalCharacteristicsGenImpl;
};

#include <mrocore/libmrocore_undef.h>
#endif //   TEAMCENTER__MROCORE__PHYSICALCHARACTERISTICS__HXX
