//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PhysicalContext
    Filename:   PhysicalContext.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__PHYSICALCONTEXT__HXX
#define TEAMCENTER__MROCORE__PHYSICALCONTEXT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalContext;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalContextImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalContextDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalContextDispatch;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalContextGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MROCORE_API  Teamcenter::mrocore::PhysicalContext
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PhysicalContext();

    /**
     * Destructor
     */
    virtual ~PhysicalContext();

private:
    //  Getter method for the Implementation Object
    PhysicalContextImpl*  getPhysicalContextImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPhysicalContextImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PhysicalContextImpl*  m_physicalcontextImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PhysicalContext - desc for PhysicalContext parameter
     */
    PhysicalContext( const PhysicalContext& );
    PhysicalContext& operator=( const PhysicalContext& );

    friend class  PhysicalContextDelegate;
    friend class  PhysicalContextDispatch;
    friend class  PhysicalContextGenImpl;
};

#include <mrocore/libmrocore_undef.h>
#endif //   TEAMCENTER__MROCORE__PHYSICALCONTEXT__HXX
