//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PhysicalContextDelegate
    Filename:   PhysicalContextDelegate.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__PHYSICALCONTEXTDELEGATE_HXX
#define TEAMCENTER__MROCORE__PHYSICALCONTEXTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mrocore/PhysicalContext.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalContextDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalContextImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalContext;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalContextGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MROCORE_API Teamcenter_alias::mrocore::PhysicalContextDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PhysicalContextDelegate instance
    static PhysicalContextDelegate&  getInstance();

    //  Method to create the PhysicalContextImpl pointer
    static PhysicalContextImpl*  createImpl( PhysicalContext&  ifObj );

    //  Method to delete the PhysicalContextImpl pointer
    static void deleteImpl( PhysicalContextImpl*  impl );



protected:
    //  Pointer to the instance
    static PhysicalContextDelegate*  m_pInstance;

    PhysicalContextDelegate();
    virtual ~PhysicalContextDelegate();
    static void setInstance( PhysicalContextDelegate*  instance );


private:
    friend class  ::Teamcenter::mrocore::PhysicalContextGenImpl;

};

#include <mrocore/libmrocore_undef.h>
#endif  //  TEAMCENTER__MROCORE__PHYSICALCONTEXTDELEGATE_HXX
