//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PhysicalElement
    Filename:   PhysicalElement.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__PHYSICALELEMENT__HXX
#define TEAMCENTER__MROCORE__PHYSICALELEMENT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalElement;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalElementImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalElementDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalElementDispatch;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalElementGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MROCORE_API  Teamcenter::mrocore::PhysicalElement
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRevisionCount( int &value, bool &isNull ) const;

    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setRevisionCount( int value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PhysicalElement();

    /**
     * Destructor
     */
    virtual ~PhysicalElement();

private:
    //  Getter method for the Implementation Object
    PhysicalElementImpl*  getPhysicalElementImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPhysicalElementImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PhysicalElementImpl*  m_physicalelementImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PhysicalElement - desc for PhysicalElement parameter
     */
    PhysicalElement( const PhysicalElement& );
    PhysicalElement& operator=( const PhysicalElement& );

    friend class  PhysicalElementDelegate;
    friend class  PhysicalElementDispatch;
    friend class  PhysicalElementGenImpl;
};

#include <mrocore/libmrocore_undef.h>
#endif //   TEAMCENTER__MROCORE__PHYSICALELEMENT__HXX
