//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PhysicalElementDelegate
    Filename:   PhysicalElementDelegate.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__PHYSICALELEMENTDELEGATE_HXX
#define TEAMCENTER__MROCORE__PHYSICALELEMENTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mrocore/PhysicalElement.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalElementDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalElementImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalElement;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalElementGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MROCORE_API Teamcenter_alias::mrocore::PhysicalElementDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PhysicalElementDelegate instance
    static PhysicalElementDelegate&  getInstance();

    //  Method to create the PhysicalElementImpl pointer
    static PhysicalElementImpl*  createImpl( PhysicalElement&  ifObj );

    //  Method to delete the PhysicalElementImpl pointer
    static void deleteImpl( PhysicalElementImpl*  impl );


    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRevisionCountBase(const PhysicalElement &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setRevisionCountBase(PhysicalElement &ifObj,  int value, bool isNull );



protected:
    //  Pointer to the instance
    static PhysicalElementDelegate*  m_pInstance;

    PhysicalElementDelegate();
    virtual ~PhysicalElementDelegate();
    static void setInstance( PhysicalElementDelegate*  instance );


private:
    friend class  ::Teamcenter::mrocore::PhysicalElementGenImpl;

};

#include <mrocore/libmrocore_undef.h>
#endif  //  TEAMCENTER__MROCORE__PHYSICALELEMENTDELEGATE_HXX
