//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PhysicalElementOwner
    Filename:   PhysicalElementOwner.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__PHYSICALELEMENTOWNER__HXX
#define TEAMCENTER__MROCORE__PHYSICALELEMENTOWNER__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalElementOwner;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalElementOwnerImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalElementOwnerDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalElementOwnerDispatch;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalElementOwnerGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MROCORE_API  Teamcenter::mrocore::PhysicalElementOwner
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PhysicalElementOwner();

    /**
     * Destructor
     */
    virtual ~PhysicalElementOwner();

private:
    //  Getter method for the Implementation Object
    PhysicalElementOwnerImpl*  getPhysicalElementOwnerImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPhysicalElementOwnerImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PhysicalElementOwnerImpl*  m_physicalelementownerImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PhysicalElementOwner - desc for PhysicalElementOwner parameter
     */
    PhysicalElementOwner( const PhysicalElementOwner& );
    PhysicalElementOwner& operator=( const PhysicalElementOwner& );

    friend class  PhysicalElementOwnerDelegate;
    friend class  PhysicalElementOwnerDispatch;
    friend class  PhysicalElementOwnerGenImpl;
};

#include <mrocore/libmrocore_undef.h>
#endif //   TEAMCENTER__MROCORE__PHYSICALELEMENTOWNER__HXX
