//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PhysicalElementRevision
    Filename:   PhysicalElementRevision.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__PHYSICALELEMENTREVISION__HXX
#define TEAMCENTER__MROCORE__PHYSICALELEMENTREVISION__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalElementRevision;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalElementRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalElementRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalElementRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalElementRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MROCORE_API  Teamcenter::mrocore::PhysicalElementRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Date Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getEffectiveFrom( date_t &value, bool &isNull ) const;

    ///
    /// Getter for a Date Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getEffectiveTo( date_t &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIsStandAlone( bool &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIsSuperseded( bool &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPreviousRevision( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Date Property
    /// @version Teamcenter 8.0.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setEffectiveFrom( const date_t &value, bool isNull=false );

    ///
    /// Setter for a Date Property
    /// @version Teamcenter 8.0.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setEffectiveTo( const date_t &value, bool isNull=false );

    ///
    /// Setter for a Boolean Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIsStandAlone( bool value, bool isNull=false );

    ///
    /// Setter for a Boolean Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIsSuperseded( bool value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.0.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPreviousRevision( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PhysicalElementRevision();

    /**
     * Destructor
     */
    virtual ~PhysicalElementRevision();

private:
    //  Getter method for the Implementation Object
    PhysicalElementRevisionImpl*  getPhysicalElementRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPhysicalElementRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PhysicalElementRevisionImpl*  m_physicalelementrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PhysicalElementRevision - desc for PhysicalElementRevision parameter
     */
    PhysicalElementRevision( const PhysicalElementRevision& );
    PhysicalElementRevision& operator=( const PhysicalElementRevision& );

    friend class  PhysicalElementRevisionDelegate;
    friend class  PhysicalElementRevisionDispatch;
    friend class  PhysicalElementRevisionGenImpl;
};

#include <mrocore/libmrocore_undef.h>
#endif //   TEAMCENTER__MROCORE__PHYSICALELEMENTREVISION__HXX
