//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PhysicalElementRevisionDelegate
    Filename:   PhysicalElementRevisionDelegate.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__PHYSICALELEMENTREVISIONDELEGATE_HXX
#define TEAMCENTER__MROCORE__PHYSICALELEMENTREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mrocore/PhysicalElementRevision.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalElementRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalElementRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalElementRevision;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalElementRevisionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MROCORE_API Teamcenter_alias::mrocore::PhysicalElementRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PhysicalElementRevisionDelegate instance
    static PhysicalElementRevisionDelegate&  getInstance();

    //  Method to create the PhysicalElementRevisionImpl pointer
    static PhysicalElementRevisionImpl*  createImpl( PhysicalElementRevision&  ifObj );

    //  Method to delete the PhysicalElementRevisionImpl pointer
    static void deleteImpl( PhysicalElementRevisionImpl*  impl );


    ///
    /// Getter for a Date Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getEffectiveFromBase(const PhysicalElementRevision &ifObj,  date_t &value, bool &isNull ) const;


    ///
    /// Getter for a Date Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getEffectiveToBase(const PhysicalElementRevision &ifObj,  date_t &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIsStandAloneBase(const PhysicalElementRevision &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIsSupersededBase(const PhysicalElementRevision &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPreviousRevisionBase(const PhysicalElementRevision &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Date Property
    /// @version Teamcenter 8.0.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setEffectiveFromBase(PhysicalElementRevision &ifObj,  const date_t &value, bool isNull );


    ///
    /// Setter for a Date Property
    /// @version Teamcenter 8.0.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setEffectiveToBase(PhysicalElementRevision &ifObj,  const date_t &value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIsStandAloneBase(PhysicalElementRevision &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIsSupersededBase(PhysicalElementRevision &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.0.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPreviousRevisionBase(PhysicalElementRevision &ifObj,  const tag_t &value, bool isNull );



protected:
    //  Pointer to the instance
    static PhysicalElementRevisionDelegate*  m_pInstance;

    PhysicalElementRevisionDelegate();
    virtual ~PhysicalElementRevisionDelegate();
    static void setInstance( PhysicalElementRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::mrocore::PhysicalElementRevisionGenImpl;

};

#include <mrocore/libmrocore_undef.h>
#endif  //  TEAMCENTER__MROCORE__PHYSICALELEMENTREVISIONDELEGATE_HXX
