//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PhysicalLogEntries
    Filename:   PhysicalLogEntries.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__PHYSICALLOGENTRIES__HXX
#define TEAMCENTER__MROCORE__PHYSICALLOGENTRIES__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalLogEntries;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalLogEntriesImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalLogEntriesDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalLogEntriesDispatch;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalLogEntriesGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MROCORE_API  Teamcenter::mrocore::PhysicalLogEntries
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PhysicalLogEntries();

    /**
     * Destructor
     */
    virtual ~PhysicalLogEntries();

private:
    //  Getter method for the Implementation Object
    PhysicalLogEntriesImpl*  getPhysicalLogEntriesImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPhysicalLogEntriesImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PhysicalLogEntriesImpl*  m_physicallogentriesImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PhysicalLogEntries - desc for PhysicalLogEntries parameter
     */
    PhysicalLogEntries( const PhysicalLogEntries& );
    PhysicalLogEntries& operator=( const PhysicalLogEntries& );

    friend class  PhysicalLogEntriesDelegate;
    friend class  PhysicalLogEntriesDispatch;
    friend class  PhysicalLogEntriesGenImpl;
};

#include <mrocore/libmrocore_undef.h>
#endif //   TEAMCENTER__MROCORE__PHYSICALLOGENTRIES__HXX
