//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PhysicalPartRevisionDelegate
    Filename:   PhysicalPartRevisionDelegate.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__PHYSICALPARTREVISIONDELEGATE_HXX
#define TEAMCENTER__MROCORE__PHYSICALPARTREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mrocore/PhysicalPartRevision.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalPartRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalPartRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalPartRevision;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalPartRevisionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MROCORE_API Teamcenter_alias::mrocore::PhysicalPartRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PhysicalPartRevisionDelegate instance
    static PhysicalPartRevisionDelegate&  getInstance();

    //  Method to create the PhysicalPartRevisionImpl pointer
    static PhysicalPartRevisionImpl*  createImpl( PhysicalPartRevision&  ifObj );

    //  Method to delete the PhysicalPartRevisionImpl pointer
    static void deleteImpl( PhysicalPartRevisionImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIsAsBuiltRevisionBase(const PhysicalPartRevision &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLotTagBase(const PhysicalPartRevision &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getManufacturerOrgIdBase(const PhysicalPartRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPartNumberBase(const PhysicalPartRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSerialNumberBase(const PhysicalPartRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a Boolean Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIsAsBuiltRevisionBase(PhysicalPartRevision &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLotTagBase(PhysicalPartRevision &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setManufacturerOrgIdBase(PhysicalPartRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPartNumberBase(PhysicalPartRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSerialNumberBase(PhysicalPartRevision &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static PhysicalPartRevisionDelegate*  m_pInstance;

    PhysicalPartRevisionDelegate();
    virtual ~PhysicalPartRevisionDelegate();
    static void setInstance( PhysicalPartRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::mrocore::PhysicalPartRevisionGenImpl;

};

#include <mrocore/libmrocore_undef.h>
#endif  //  TEAMCENTER__MROCORE__PHYSICALPARTREVISIONDELEGATE_HXX
