//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PhysicalRealization
    Filename:   PhysicalRealization.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__PHYSICALREALIZATION__HXX
#define TEAMCENTER__MROCORE__PHYSICALREALIZATION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalRealization;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalRealizationImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalRealizationDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalRealizationDispatch;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalRealizationGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MROCORE_API  Teamcenter::mrocore::PhysicalRealization
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PhysicalRealization();

    /**
     * Destructor
     */
    virtual ~PhysicalRealization();

private:
    //  Getter method for the Implementation Object
    PhysicalRealizationImpl*  getPhysicalRealizationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPhysicalRealizationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PhysicalRealizationImpl*  m_physicalrealizationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PhysicalRealization - desc for PhysicalRealization parameter
     */
    PhysicalRealization( const PhysicalRealization& );
    PhysicalRealization& operator=( const PhysicalRealization& );

    friend class  PhysicalRealizationDelegate;
    friend class  PhysicalRealizationDispatch;
    friend class  PhysicalRealizationGenImpl;
};

#include <mrocore/libmrocore_undef.h>
#endif //   TEAMCENTER__MROCORE__PHYSICALREALIZATION__HXX
