//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PhysicalStructureAlignment
    Filename:   PhysicalStructureAlignment.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__PHYSICALSTRUCTUREALIGNMENT__HXX
#define TEAMCENTER__MROCORE__PHYSICALSTRUCTUREALIGNMENT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalStructureAlignment;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalStructureAlignmentImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalStructureAlignmentDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalStructureAlignmentDispatch;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalStructureAlignmentGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MROCORE_API  Teamcenter::mrocore::PhysicalStructureAlignment
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PhysicalStructureAlignment();

    /**
     * Destructor
     */
    virtual ~PhysicalStructureAlignment();

private:
    //  Getter method for the Implementation Object
    PhysicalStructureAlignmentImpl*  getPhysicalStructureAlignmentImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPhysicalStructureAlignmentImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PhysicalStructureAlignmentImpl*  m_physicalstructurealignmentImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PhysicalStructureAlignment - desc for PhysicalStructureAlignment parameter
     */
    PhysicalStructureAlignment( const PhysicalStructureAlignment& );
    PhysicalStructureAlignment& operator=( const PhysicalStructureAlignment& );

    friend class  PhysicalStructureAlignmentDelegate;
    friend class  PhysicalStructureAlignmentDispatch;
    friend class  PhysicalStructureAlignmentGenImpl;
};

#include <mrocore/libmrocore_undef.h>
#endif //   TEAMCENTER__MROCORE__PHYSICALSTRUCTUREALIGNMENT__HXX
