//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PhysicalStructureDelegate
    Filename:   PhysicalStructureDelegate.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__PHYSICALSTRUCTUREDELEGATE_HXX
#define TEAMCENTER__MROCORE__PHYSICALSTRUCTUREDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mrocore/PhysicalStructure.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalStructureDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalStructureImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalStructure;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class PhysicalStructureGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MROCORE_API Teamcenter_alias::mrocore::PhysicalStructureDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PhysicalStructureDelegate instance
    static PhysicalStructureDelegate&  getInstance();

    //  Method to create the PhysicalStructureImpl pointer
    static PhysicalStructureImpl*  createImpl( PhysicalStructure&  ifObj );

    //  Method to delete the PhysicalStructureImpl pointer
    static void deleteImpl( PhysicalStructureImpl*  impl );


    ///
    /// Getter for a Date Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getInstallationTimeBase(const PhysicalStructure &ifObj,  date_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPartUsedIsBase(const PhysicalStructure &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getUsageNameBase(const PhysicalStructure &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a Date Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setInstallationTimeBase(PhysicalStructure &ifObj,  const date_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPartUsedIsBase(PhysicalStructure &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setUsageNameBase(PhysicalStructure &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static PhysicalStructureDelegate*  m_pInstance;

    PhysicalStructureDelegate();
    virtual ~PhysicalStructureDelegate();
    static void setInstance( PhysicalStructureDelegate*  instance );


private:
    friend class  ::Teamcenter::mrocore::PhysicalStructureGenImpl;

};

#include <mrocore/libmrocore_undef.h>
#endif  //  TEAMCENTER__MROCORE__PHYSICALSTRUCTUREDELEGATE_HXX
