//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SerialNumberGeneratorDelegate
    Filename:   SerialNumberGeneratorDelegate.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__SERIALNUMBERGENERATORDELEGATE_HXX
#define TEAMCENTER__MROCORE__SERIALNUMBERGENERATORDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mrocore/SerialNumberGenerator.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class SerialNumberGeneratorDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class SerialNumberGeneratorImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class SerialNumberGenerator;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class SerialNumberGeneratorGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MROCORE_API Teamcenter_alias::mrocore::SerialNumberGeneratorDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SerialNumberGeneratorDelegate instance
    static SerialNumberGeneratorDelegate&  getInstance();

    //  Method to create the SerialNumberGeneratorImpl pointer
    static SerialNumberGeneratorImpl*  createImpl( SerialNumberGenerator&  ifObj );

    //  Method to delete the SerialNumberGeneratorImpl pointer
    static void deleteImpl( SerialNumberGeneratorImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDesignItemTagBase(const SerialNumberGenerator &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIncrementBase(const SerialNumberGenerator &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIsActiveBase(const SerialNumberGenerator &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSeriesCharactersBase(const SerialNumberGenerator &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSeriesCurrentBase(const SerialNumberGenerator &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSeriesMaximumBase(const SerialNumberGenerator &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSeriesPrefixBase(const SerialNumberGenerator &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSeriesSuffixBase(const SerialNumberGenerator &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDesignItemTagBase(SerialNumberGenerator &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIncrementBase(SerialNumberGenerator &ifObj,  int value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIsActiveBase(SerialNumberGenerator &ifObj,  bool value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSeriesCharactersBase(SerialNumberGenerator &ifObj,  int value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSeriesCurrentBase(SerialNumberGenerator &ifObj,  int value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSeriesMaximumBase(SerialNumberGenerator &ifObj,  int value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSeriesPrefixBase(SerialNumberGenerator &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSeriesSuffixBase(SerialNumberGenerator &ifObj,  const std::string &value, bool isNull );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const SerialNumberGenerator &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static SerialNumberGeneratorDelegate*  m_pInstance;

    SerialNumberGeneratorDelegate();
    virtual ~SerialNumberGeneratorDelegate();
    static void setInstance( SerialNumberGeneratorDelegate*  instance );


private:
    friend class  ::Teamcenter::mrocore::SerialNumberGeneratorGenImpl;

};

#include <mrocore/libmrocore_undef.h>
#endif  //  TEAMCENTER__MROCORE__SERIALNUMBERGENERATORDELEGATE_HXX
