//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Smr0BoolCharDefinition
    Filename:   Smr0BoolCharDefinition.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__SMR0BOOLCHARDEFINITION__HXX
#define TEAMCENTER__MROCORE__SMR0BOOLCHARDEFINITION__HXX

#include <common/tc_deprecation_macros.h>
#include <mrocore/ObsCharDefinition.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class Smr0BoolCharDefinition;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class Smr0BoolCharDefinitionImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class Smr0BoolCharDefinitionDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class Smr0BoolCharDefinitionDispatch;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class Smr0BoolCharDefinitionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MROCORE_API  Teamcenter::mrocore::Smr0BoolCharDefinition
     : public  ::Teamcenter::mrocore::ObsCharDefinition
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Smr0BoolCharDefinition();

    /**
     * Destructor
     */
    virtual ~Smr0BoolCharDefinition();

private:
    //  Getter method for the Implementation Object
    Smr0BoolCharDefinitionImpl*  getSmr0BoolCharDefinitionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSmr0BoolCharDefinitionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Smr0BoolCharDefinitionImpl*  m_smr0boolchardefinitionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Smr0BoolCharDefinition - desc for Smr0BoolCharDefinition parameter
     */
    Smr0BoolCharDefinition( const Smr0BoolCharDefinition& );
    Smr0BoolCharDefinition& operator=( const Smr0BoolCharDefinition& );

    friend class  Smr0BoolCharDefinitionDelegate;
    friend class  Smr0BoolCharDefinitionDispatch;
    friend class  Smr0BoolCharDefinitionGenImpl;
};

#include <mrocore/libmrocore_undef.h>
#endif //   TEAMCENTER__MROCORE__SMR0BOOLCHARDEFINITION__HXX
