//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Smr0CapturesCharValue
    Filename:   Smr0CapturesCharValue.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__SMR0CAPTURESCHARVALUE__HXX
#define TEAMCENTER__MROCORE__SMR0CAPTURESCHARVALUE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class Smr0CapturesCharValue;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class Smr0CapturesCharValueImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class Smr0CapturesCharValueDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class Smr0CapturesCharValueDispatch;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class Smr0CapturesCharValueGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MROCORE_API  Teamcenter::mrocore::Smr0CapturesCharValue
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Smr0CapturesCharValue();

    /**
     * Destructor
     */
    virtual ~Smr0CapturesCharValue();

private:
    //  Getter method for the Implementation Object
    Smr0CapturesCharValueImpl*  getSmr0CapturesCharValueImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSmr0CapturesCharValueImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Smr0CapturesCharValueImpl*  m_smr0capturescharvalueImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Smr0CapturesCharValue - desc for Smr0CapturesCharValue parameter
     */
    Smr0CapturesCharValue( const Smr0CapturesCharValue& );
    Smr0CapturesCharValue& operator=( const Smr0CapturesCharValue& );

    friend class  Smr0CapturesCharValueDelegate;
    friend class  Smr0CapturesCharValueDispatch;
    friend class  Smr0CapturesCharValueGenImpl;
};

#include <mrocore/libmrocore_undef.h>
#endif //   TEAMCENTER__MROCORE__SMR0CAPTURESCHARVALUE__HXX
