//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Smr0PartFault
    Filename:   Smr0PartFault.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__SMR0PARTFAULT__HXX
#define TEAMCENTER__MROCORE__SMR0PARTFAULT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class Smr0PartFault;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class Smr0PartFaultImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class Smr0PartFaultDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class Smr0PartFaultDispatch;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class Smr0PartFaultGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MROCORE_API  Teamcenter::mrocore::Smr0PartFault
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Smr0PartFault();

    /**
     * Destructor
     */
    virtual ~Smr0PartFault();

private:
    //  Getter method for the Implementation Object
    Smr0PartFaultImpl*  getSmr0PartFaultImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSmr0PartFaultImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Smr0PartFaultImpl*  m_smr0partfaultImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Smr0PartFault - desc for Smr0PartFault parameter
     */
    Smr0PartFault( const Smr0PartFault& );
    Smr0PartFault& operator=( const Smr0PartFault& );

    friend class  Smr0PartFaultDelegate;
    friend class  Smr0PartFaultDispatch;
    friend class  Smr0PartFaultGenImpl;
};

#include <mrocore/libmrocore_undef.h>
#endif //   TEAMCENTER__MROCORE__SMR0PARTFAULT__HXX
