//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Smr0ProcessLogEntry
    Filename:   Smr0ProcessLogEntry.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__SMR0PROCESSLOGENTRY__HXX
#define TEAMCENTER__MROCORE__SMR0PROCESSLOGENTRY__HXX

#include <common/tc_deprecation_macros.h>
#include <mrocore/LogEntry.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class Smr0ProcessLogEntry;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class Smr0ProcessLogEntryImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class Smr0ProcessLogEntryDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class Smr0ProcessLogEntryDispatch;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class Smr0ProcessLogEntryGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MROCORE_API  Teamcenter::mrocore::Smr0ProcessLogEntry
     : public  ::Teamcenter::mrocore::LogEntry
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Smr0ProcessLogEntry();

    /**
     * Destructor
     */
    virtual ~Smr0ProcessLogEntry();

private:
    //  Getter method for the Implementation Object
    Smr0ProcessLogEntryImpl*  getSmr0ProcessLogEntryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSmr0ProcessLogEntryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Smr0ProcessLogEntryImpl*  m_smr0processlogentryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Smr0ProcessLogEntry - desc for Smr0ProcessLogEntry parameter
     */
    Smr0ProcessLogEntry( const Smr0ProcessLogEntry& );
    Smr0ProcessLogEntry& operator=( const Smr0ProcessLogEntry& );

    friend class  Smr0ProcessLogEntryDelegate;
    friend class  Smr0ProcessLogEntryDispatch;
    friend class  Smr0ProcessLogEntryGenImpl;
};

#include <mrocore/libmrocore_undef.h>
#endif //   TEAMCENTER__MROCORE__SMR0PROCESSLOGENTRY__HXX
