//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Smr0StringCharDefinition
    Filename:   Smr0StringCharDefinition.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__SMR0STRINGCHARDEFINITION__HXX
#define TEAMCENTER__MROCORE__SMR0STRINGCHARDEFINITION__HXX

#include <common/tc_deprecation_macros.h>
#include <mrocore/ObsCharDefinition.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class Smr0StringCharDefinition;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class Smr0StringCharDefinitionImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class Smr0StringCharDefinitionDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class Smr0StringCharDefinitionDispatch;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class Smr0StringCharDefinitionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MROCORE_API  Teamcenter::mrocore::Smr0StringCharDefinition
     : public  ::Teamcenter::mrocore::ObsCharDefinition
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Smr0StringCharDefinition();

    /**
     * Destructor
     */
    virtual ~Smr0StringCharDefinition();

private:
    //  Getter method for the Implementation Object
    Smr0StringCharDefinitionImpl*  getSmr0StringCharDefinitionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSmr0StringCharDefinitionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Smr0StringCharDefinitionImpl*  m_smr0stringchardefinitionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Smr0StringCharDefinition - desc for Smr0StringCharDefinition parameter
     */
    Smr0StringCharDefinition( const Smr0StringCharDefinition& );
    Smr0StringCharDefinition& operator=( const Smr0StringCharDefinition& );

    friend class  Smr0StringCharDefinitionDelegate;
    friend class  Smr0StringCharDefinitionDispatch;
    friend class  Smr0StringCharDefinitionGenImpl;
};

#include <mrocore/libmrocore_undef.h>
#endif //   TEAMCENTER__MROCORE__SMR0STRINGCHARDEFINITION__HXX
