//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Smr0Warning
    Filename:   Smr0Warning.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__SMR0WARNING__HXX
#define TEAMCENTER__MROCORE__SMR0WARNING__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class Smr0Warning;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class Smr0WarningImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class Smr0WarningDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class Smr0WarningDispatch;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class Smr0WarningGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  MROCORE_API  Teamcenter::mrocore::Smr0Warning
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Smr0Warning();

    /**
     * Destructor
     */
    virtual ~Smr0Warning();

private:
    //  Getter method for the Implementation Object
    Smr0WarningImpl*  getSmr0WarningImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSmr0WarningImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Smr0WarningImpl*  m_smr0warningImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Smr0Warning - desc for Smr0Warning parameter
     */
    Smr0Warning( const Smr0Warning& );
    Smr0Warning& operator=( const Smr0Warning& );

    friend class  Smr0WarningDelegate;
    friend class  Smr0WarningDispatch;
    friend class  Smr0WarningGenImpl;
};

#include <mrocore/libmrocore_undef.h>
#endif //   TEAMCENTER__MROCORE__SMR0WARNING__HXX
