//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, UtilizationDelegate
    Filename:   UtilizationDelegate.hxx
    Module:     mrocore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MROCORE__UTILIZATIONDELEGATE_HXX
#define TEAMCENTER__MROCORE__UTILIZATIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <mrocore/Utilization.hxx>

#include <mrocore/libmrocore_exports.h>

namespace Teamcenter
{
    namespace mrocore
    {
        class UtilizationDelegate;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class UtilizationImpl;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class Utilization;
    }
}
namespace Teamcenter
{
    namespace mrocore
    {
        class UtilizationGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  MROCORE_API Teamcenter_alias::mrocore::UtilizationDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the UtilizationDelegate instance
    static UtilizationDelegate&  getInstance();

    //  Method to create the UtilizationImpl pointer
    static UtilizationImpl*  createImpl( Utilization&  ifObj );

    //  Method to delete the UtilizationImpl pointer
    static void deleteImpl( UtilizationImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getUtil_char_definitionBase(const Utilization &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getUtil_characteristic_nameBase(const Utilization &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Date Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getUtil_from_dateBase(const Utilization &ifObj,  date_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getUtil_last_recorded_dateBase(const Utilization &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getUtil_last_valueBase(const Utilization &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getUtil_physical_partBase(const Utilization &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Date Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getUtil_till_dateBase(const Utilization &ifObj,  date_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getUtil_time_since_newBase(const Utilization &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getUtil_unitBase(const Utilization &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a Date Property
    /// @version Teamcenter 8.0.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setUtil_from_dateBase(Utilization &ifObj,  const date_t &value, bool isNull );


    ///
    /// Setter for a Date Property
    /// @version Teamcenter 8.0.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setUtil_till_dateBase(Utilization &ifObj,  const date_t &value, bool isNull );



protected:
    //  Pointer to the instance
    static UtilizationDelegate*  m_pInstance;

    UtilizationDelegate();
    virtual ~UtilizationDelegate();
    static void setInstance( UtilizationDelegate*  instance );


private:
    friend class  ::Teamcenter::mrocore::UtilizationGenImpl;

};

#include <mrocore/libmrocore_undef.h>
#endif  //  TEAMCENTER__MROCORE__UTILIZATIONDELEGATE_HXX
