//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  mrocore

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libmrocore

#if !defined(LIBMROCORE) && !defined(IPLIB)
#   error IPLIB or LIBMROCORE is not defined
#endif

/* Handwritten code should use MROCORE_API, not MROCOREEXPORT */

#define MROCORE_API MROCOREEXPORT

#if IPLIB==libmrocore || defined(LIBMROCORE)
#   if defined(__lint)
#       define MROCOREEXPORT       __export(mrocore)
#       define MROCOREGLOBAL       extern __global(mrocore)
#       define MROCOREPRIVATE      extern __private(mrocore)
#   elif defined(_WIN32)
#       define MROCOREEXPORT       __declspec(dllexport)
#       define MROCOREGLOBAL       extern __declspec(dllexport)
#       define MROCOREPRIVATE      extern
#   else
#       define MROCOREEXPORT
#       define MROCOREGLOBAL       extern
#       define MROCOREPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define MROCOREEXPORT       __export(mrocore)
#       define MROCOREGLOBAL       extern __global(mrocore)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define MROCOREEXPORT      __declspec(dllimport)
#       define MROCOREGLOBAL       extern __declspec(dllimport)
#   else
#       define MROCOREEXPORT
#       define MROCOREGLOBAL       extern
#   endif
#endif
