//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  mrocoredispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libmrocoredispatch

#if !defined(LIBMROCOREDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBMROCOREDISPATCH is not defined
#endif

/* Handwritten code should use MROCOREDISPATCH_API, not MROCOREDISPATCHEXPORT */

#define MROCOREDISPATCH_API MROCOREDISPATCHEXPORT

#if IPLIB==libmrocoredispatch || defined(LIBMROCOREDISPATCH)
#   if defined(__lint)
#       define MROCOREDISPATCHEXPORT       __export(mrocoredispatch)
#       define MROCOREDISPATCHGLOBAL       extern __global(mrocoredispatch)
#       define MROCOREDISPATCHPRIVATE      extern __private(mrocoredispatch)
#   elif defined(_WIN32)
#       define MROCOREDISPATCHEXPORT       __declspec(dllexport)
#       define MROCOREDISPATCHGLOBAL       extern __declspec(dllexport)
#       define MROCOREDISPATCHPRIVATE      extern
#   else
#       define MROCOREDISPATCHEXPORT
#       define MROCOREDISPATCHGLOBAL       extern
#       define MROCOREDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define MROCOREDISPATCHEXPORT       __export(mrocoredispatch)
#       define MROCOREDISPATCHGLOBAL       extern __global(mrocoredispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define MROCOREDISPATCHEXPORT      __declspec(dllimport)
#       define MROCOREDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define MROCOREDISPATCHEXPORT
#       define MROCOREDISPATCHGLOBAL       extern
#   endif
#endif
