//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ImanExportRecord
    Filename:   ImanExportRecord.hxx
    Module:     objio
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IMANEXPORTRECORD__HXX
#define TEAMCENTER__IMANEXPORTRECORD__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <objio/libobjio_exports.h>

namespace Teamcenter
{
    class ImanExportRecord;
}
namespace Teamcenter
{
    class ImanExportRecordImpl;
}
namespace Teamcenter
{
    class ImanExportRecordDelegate;
}
namespace Teamcenter
{
    class ImanExportRecordDispatch;
}
namespace Teamcenter
{
    class ImanExportRecordGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  OBJIO_API  Teamcenter::ImanExportRecord
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ImanExportRecord();

    /**
     * Destructor
     */
    virtual ~ImanExportRecord();

private:
    //  Getter method for the Implementation Object
    ImanExportRecordImpl*  getImanExportRecordImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setImanExportRecordImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ImanExportRecordImpl*  m_imanexportrecordImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ImanExportRecord - desc for ImanExportRecord parameter
     */
    ImanExportRecord( const ImanExportRecord& );
    ImanExportRecord& operator=( const ImanExportRecord& );

    friend class  ImanExportRecordDelegate;
    friend class  ImanExportRecordDispatch;
    friend class  ImanExportRecordGenImpl;
};

#include <objio/libobjio_undef.h>
#endif //   TEAMCENTER__IMANEXPORTRECORD__HXX
