//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ItemExportRecord
    Filename:   ItemExportRecord.hxx
    Module:     objio
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ITEMEXPORTRECORD__HXX
#define TEAMCENTER__ITEMEXPORTRECORD__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <objio/libobjio_exports.h>

namespace Teamcenter
{
    class ItemExportRecord;
}
namespace Teamcenter
{
    class ItemExportRecordImpl;
}
namespace Teamcenter
{
    class ItemExportRecordDelegate;
}
namespace Teamcenter
{
    class ItemExportRecordDispatch;
}
namespace Teamcenter
{
    class ItemExportRecordGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  OBJIO_API  Teamcenter::ItemExportRecord
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ItemExportRecord();

    /**
     * Destructor
     */
    virtual ~ItemExportRecord();

private:
    //  Getter method for the Implementation Object
    ItemExportRecordImpl*  getItemExportRecordImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setItemExportRecordImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ItemExportRecordImpl*  m_itemexportrecordImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ItemExportRecord - desc for ItemExportRecord parameter
     */
    ItemExportRecord( const ItemExportRecord& );
    ItemExportRecord& operator=( const ItemExportRecord& );

    friend class  ItemExportRecordDelegate;
    friend class  ItemExportRecordDispatch;
    friend class  ItemExportRecordGenImpl;
};

#include <objio/libobjio_undef.h>
#endif //   TEAMCENTER__ITEMEXPORTRECORD__HXX
