//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  objio

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libobjio

#if !defined(LIBOBJIO) && !defined(IPLIB)
#   error IPLIB or LIBOBJIO is not defined
#endif

/* Handwritten code should use OBJIO_API, not OBJIOEXPORT */

#define OBJIO_API OBJIOEXPORT

#if IPLIB==libobjio || defined(LIBOBJIO)
#   if defined(__lint)
#       define OBJIOEXPORT       __export(objio)
#       define OBJIOGLOBAL       extern __global(objio)
#       define OBJIOPRIVATE      extern __private(objio)
#   elif defined(_WIN32)
#       define OBJIOEXPORT       __declspec(dllexport)
#       define OBJIOGLOBAL       extern __declspec(dllexport)
#       define OBJIOPRIVATE      extern
#   else
#       define OBJIOEXPORT
#       define OBJIOGLOBAL       extern
#       define OBJIOPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define OBJIOEXPORT       __export(objio)
#       define OBJIOGLOBAL       extern __global(objio)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define OBJIOEXPORT      __declspec(dllimport)
#       define OBJIOGLOBAL       extern __declspec(dllimport)
#   else
#       define OBJIOEXPORT
#       define OBJIOGLOBAL       extern
#   endif
#endif
