//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  osl0lisoslcdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libosl0lisoslcdispatch

#if !defined(LIBOSL0LISOSLCDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBOSL0LISOSLCDISPATCH is not defined
#endif

/* Handwritten code should use OSL0LISOSLCDISPATCH_API, not OSL0LISOSLCDISPATCHEXPORT */

#define OSL0LISOSLCDISPATCH_API OSL0LISOSLCDISPATCHEXPORT

#if IPLIB==libosl0lisoslcdispatch || defined(LIBOSL0LISOSLCDISPATCH)
#   if defined(__lint)
#       define OSL0LISOSLCDISPATCHEXPORT       __export(osl0lisoslcdispatch)
#       define OSL0LISOSLCDISPATCHGLOBAL       extern __global(osl0lisoslcdispatch)
#       define OSL0LISOSLCDISPATCHPRIVATE      extern __private(osl0lisoslcdispatch)
#   elif defined(_WIN32)
#       define OSL0LISOSLCDISPATCHEXPORT       __declspec(dllexport)
#       define OSL0LISOSLCDISPATCHGLOBAL       extern __declspec(dllexport)
#       define OSL0LISOSLCDISPATCHPRIVATE      extern
#   else
#       define OSL0LISOSLCDISPATCHEXPORT
#       define OSL0LISOSLCDISPATCHGLOBAL       extern
#       define OSL0LISOSLCDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define OSL0LISOSLCDISPATCHEXPORT       __export(osl0lisoslcdispatch)
#       define OSL0LISOSLCDISPATCHGLOBAL       extern __global(osl0lisoslcdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define OSL0LISOSLCDISPATCHEXPORT      __declspec(dllimport)
#       define OSL0LISOSLCDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define OSL0LISOSLCDISPATCHEXPORT
#       define OSL0LISOSLCDISPATCHGLOBAL       extern
#   endif
#endif
