//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ptn0PartitionRealizationDispatch
    Filename:   Ptn0PartitionRealizationDispatch.hxx
    Module:     partitiondispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PARTITION__PTN0PARTITIONREALIZATIONDISPATCH_HXX
#define TEAMCENTER__PARTITION__PTN0PARTITIONREALIZATIONDISPATCH_HXX

#include <vector>
#include <ptn0partition/Ptn0PartitionRealization.hxx>
#include <ptn0partition/Ptn0PartitionRealizationDelegate.hxx>
#include <realizationdispatch/Rlz0ModelRealizationDispatch.hxx>
#include <partitiondispatch/initializepartition.hxx>

#include <partitiondispatch/libpartitiondispatch_exports.h>

namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionRealizationDispatch;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionRealizationDelegate;
    }
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  PARTITIONDISPATCH_API  Teamcenter::Partition::Ptn0PartitionRealizationDispatch
    : public  Teamcenter::Partition::Ptn0PartitionRealizationDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Ptn0PartitionRealizationDispatch instance
    static Ptn0PartitionRealizationDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static Ptn0PartitionRealizationDispatch*  m_dispatch;

    //  Default Constructor
    Ptn0PartitionRealizationDispatch();

    //  Default Destructor
    virtual ~Ptn0PartitionRealizationDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a Ptn0PartitionRealizationDispatch
    Ptn0PartitionRealizationDispatch( const Ptn0PartitionRealizationDispatch& );

    //  Assignment operator
    Ptn0PartitionRealizationDispatch&  operator = ( const Ptn0PartitionRealizationDispatch& );

    //  friend
    friend void   ::Teamcenter::Partition::initializepartitionInternal();
    friend void   ::Teamcenter::Partition::initializepartitionExtenders();
    friend class  Teamcenter::Partition::Ptn0PartitionRealizationDelegate;
};

#include <partitiondispatch/libpartitiondispatch_undef.h>
#endif  //  TEAMCENTER__PARTITION__PTN0PARTITIONREALIZATIONDISPATCH_HXX
