//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  partitiondispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libpartitiondispatch

#if !defined(LIBPARTITIONDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBPARTITIONDISPATCH is not defined
#endif

/* Handwritten code should use PARTITIONDISPATCH_API, not PARTITIONDISPATCHEXPORT */

#define PARTITIONDISPATCH_API PARTITIONDISPATCHEXPORT

#if IPLIB==libpartitiondispatch || defined(LIBPARTITIONDISPATCH)
#   if defined(__lint)
#       define PARTITIONDISPATCHEXPORT       __export(partitiondispatch)
#       define PARTITIONDISPATCHGLOBAL       extern __global(partitiondispatch)
#       define PARTITIONDISPATCHPRIVATE      extern __private(partitiondispatch)
#   elif defined(_WIN32)
#       define PARTITIONDISPATCHEXPORT       __declspec(dllexport)
#       define PARTITIONDISPATCHGLOBAL       extern __declspec(dllexport)
#       define PARTITIONDISPATCHPRIVATE      extern
#   else
#       define PARTITIONDISPATCHEXPORT
#       define PARTITIONDISPATCHGLOBAL       extern
#       define PARTITIONDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define PARTITIONDISPATCHEXPORT       __export(partitiondispatch)
#       define PARTITIONDISPATCHGLOBAL       extern __global(partitiondispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define PARTITIONDISPATCHEXPORT      __declspec(dllimport)
#       define PARTITIONDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define PARTITIONDISPATCHEXPORT
#       define PARTITIONDISPATCHGLOBAL       extern
#   endif
#endif
