//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ClosureRule
    Filename:   ClosureRule.hxx
    Module:     pie
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CLOSURERULE__HXX
#define TEAMCENTER__CLOSURERULE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <pie/libpie_exports.h>

namespace Teamcenter
{
    class ClosureRule;
}
namespace Teamcenter
{
    class ClosureRuleImpl;
}
namespace Teamcenter
{
    class ClosureRuleDelegate;
}
namespace Teamcenter
{
    class ClosureRuleDispatch;
}
namespace Teamcenter
{
    class ClosureRuleGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PIE_API  Teamcenter::ClosureRule
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ClosureRule();

    /**
     * Destructor
     */
    virtual ~ClosureRule();

private:
    //  Getter method for the Implementation Object
    ClosureRuleImpl*  getClosureRuleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setClosureRuleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ClosureRuleImpl*  m_closureruleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ClosureRule - desc for ClosureRule parameter
     */
    ClosureRule( const ClosureRule& );
    ClosureRule& operator=( const ClosureRule& );

    friend class  ClosureRuleDelegate;
    friend class  ClosureRuleDispatch;
    friend class  ClosureRuleGenImpl;
};

#include <pie/libpie_undef.h>
#endif //   TEAMCENTER__CLOSURERULE__HXX
