//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Filter
    Filename:   Filter.hxx
    Module:     pie
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FILTER__HXX
#define TEAMCENTER__FILTER__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <pie/libpie_exports.h>

namespace Teamcenter
{
    class Filter;
}
namespace Teamcenter
{
    class FilterImpl;
}
namespace Teamcenter
{
    class FilterDelegate;
}
namespace Teamcenter
{
    class FilterDispatch;
}
namespace Teamcenter
{
    class FilterGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PIE_API  Teamcenter::Filter
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Filter();

    /**
     * Destructor
     */
    virtual ~Filter();

private:
    //  Getter method for the Implementation Object
    FilterImpl*  getFilterImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFilterImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    FilterImpl*  m_filterImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Filter - desc for Filter parameter
     */
    Filter( const Filter& );
    Filter& operator=( const Filter& );

    friend class  FilterDelegate;
    friend class  FilterDispatch;
    friend class  FilterGenImpl;
};

#include <pie/libpie_undef.h>
#endif //   TEAMCENTER__FILTER__HXX
