//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, FilterDelegate
    Filename:   FilterDelegate.hxx
    Module:     pie
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FILTERDELEGATE_HXX
#define TEAMCENTER__FILTERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <pie/Filter.hxx>

#include <pie/libpie_exports.h>

namespace Teamcenter
{
    class FilterDelegate;
}
namespace Teamcenter
{
    class FilterImpl;
}
namespace Teamcenter
{
    class Filter;
}
namespace Teamcenter
{
    class FilterGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PIE_API Teamcenter_alias::FilterDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the FilterDelegate instance
    static FilterDelegate&  getInstance();

    //  Method to create the FilterImpl pointer
    static FilterImpl*  createImpl( Filter&  ifObj );

    //  Method to delete the FilterImpl pointer
    static void deleteImpl( FilterImpl*  impl );



protected:
    //  Pointer to the instance
    static FilterDelegate*  m_pInstance;

    FilterDelegate();
    virtual ~FilterDelegate();
    static void setInstance( FilterDelegate*  instance );


private:
    friend class  ::Teamcenter::FilterGenImpl;

};

#include <pie/libpie_undef.h>
#endif  //  TEAMCENTER__FILTERDELEGATE_HXX
