//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PIEActionRule
    Filename:   PIEActionRule.hxx
    Module:     pie
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PIEACTIONRULE__HXX
#define TEAMCENTER__PIEACTIONRULE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <pie/libpie_exports.h>

namespace Teamcenter
{
    class PIEActionRule;
}
namespace Teamcenter
{
    class PIEActionRuleImpl;
}
namespace Teamcenter
{
    class PIEActionRuleDelegate;
}
namespace Teamcenter
{
    class PIEActionRuleDispatch;
}
namespace Teamcenter
{
    class PIEActionRuleGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PIE_API  Teamcenter::PIEActionRule
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PIEActionRule();

    /**
     * Destructor
     */
    virtual ~PIEActionRule();

private:
    //  Getter method for the Implementation Object
    PIEActionRuleImpl*  getPIEActionRuleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPIEActionRuleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PIEActionRuleImpl*  m_pieactionruleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PIEActionRule - desc for PIEActionRule parameter
     */
    PIEActionRule( const PIEActionRule& );
    PIEActionRule& operator=( const PIEActionRule& );

    friend class  PIEActionRuleDelegate;
    friend class  PIEActionRuleDispatch;
    friend class  PIEActionRuleGenImpl;
};

#include <pie/libpie_undef.h>
#endif //   TEAMCENTER__PIEACTIONRULE__HXX
