//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PLMAppUID
    Filename:   PLMAppUID.hxx
    Module:     pie
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PLMAPPUID__HXX
#define TEAMCENTER__PLMAPPUID__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <pie/libpie_exports.h>

namespace Teamcenter
{
    class PLMAppUID;
}
namespace Teamcenter
{
    class PLMAppUIDImpl;
}
namespace Teamcenter
{
    class PLMAppUIDDelegate;
}
namespace Teamcenter
{
    class PLMAppUIDDispatch;
}
namespace Teamcenter
{
    class PLMAppUIDGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PIE_API  Teamcenter::PLMAppUID
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PLMAppUID();

    /**
     * Destructor
     */
    virtual ~PLMAppUID();

private:
    //  Getter method for the Implementation Object
    PLMAppUIDImpl*  getPLMAppUIDImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPLMAppUIDImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PLMAppUIDImpl*  m_plmappuidImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PLMAppUID - desc for PLMAppUID parameter
     */
    PLMAppUID( const PLMAppUID& );
    PLMAppUID& operator=( const PLMAppUID& );

    friend class  PLMAppUIDDelegate;
    friend class  PLMAppUIDDispatch;
    friend class  PLMAppUIDGenImpl;
};

#include <pie/libpie_undef.h>
#endif //   TEAMCENTER__PLMAPPUID__HXX
