//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PropertySet
    Filename:   PropertySet.hxx
    Module:     pie
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROPERTYSET__HXX
#define TEAMCENTER__PROPERTYSET__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <pie/libpie_exports.h>

namespace Teamcenter
{
    class PropertySet;
}
namespace Teamcenter
{
    class PropertySetImpl;
}
namespace Teamcenter
{
    class PropertySetDelegate;
}
namespace Teamcenter
{
    class PropertySetDispatch;
}
namespace Teamcenter
{
    class PropertySetGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PIE_API  Teamcenter::PropertySet
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PropertySet();

    /**
     * Destructor
     */
    virtual ~PropertySet();

private:
    //  Getter method for the Implementation Object
    PropertySetImpl*  getPropertySetImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPropertySetImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PropertySetImpl*  m_propertysetImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PropertySet - desc for PropertySet parameter
     */
    PropertySet( const PropertySet& );
    PropertySet& operator=( const PropertySet& );

    friend class  PropertySetDelegate;
    friend class  PropertySetDispatch;
    friend class  PropertySetGenImpl;
};

#include <pie/libpie_undef.h>
#endif //   TEAMCENTER__PROPERTYSET__HXX
