//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PropertySetDelegate
    Filename:   PropertySetDelegate.hxx
    Module:     pie
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROPERTYSETDELEGATE_HXX
#define TEAMCENTER__PROPERTYSETDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <pie/PropertySet.hxx>

#include <pie/libpie_exports.h>

namespace Teamcenter
{
    class PropertySetDelegate;
}
namespace Teamcenter
{
    class PropertySetImpl;
}
namespace Teamcenter
{
    class PropertySet;
}
namespace Teamcenter
{
    class PropertySetGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PIE_API Teamcenter_alias::PropertySetDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PropertySetDelegate instance
    static PropertySetDelegate&  getInstance();

    //  Method to create the PropertySetImpl pointer
    static PropertySetImpl*  createImpl( PropertySet&  ifObj );

    //  Method to delete the PropertySetImpl pointer
    static void deleteImpl( PropertySetImpl*  impl );



protected:
    //  Pointer to the instance
    static PropertySetDelegate*  m_pInstance;

    PropertySetDelegate();
    virtual ~PropertySetDelegate();
    static void setInstance( PropertySetDelegate*  instance );


private:
    friend class  ::Teamcenter::PropertySetGenImpl;

};

#include <pie/libpie_undef.h>
#endif  //  TEAMCENTER__PROPERTYSETDELEGATE_HXX
