//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TransferMode
    Filename:   TransferMode.hxx
    Module:     pie
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TRANSFERMODE__HXX
#define TEAMCENTER__TRANSFERMODE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <pie/libpie_exports.h>

namespace Teamcenter
{
    class TransferMode;
}
namespace Teamcenter
{
    class TransferModeImpl;
}
namespace Teamcenter
{
    class TransferModeDelegate;
}
namespace Teamcenter
{
    class TransferModeDispatch;
}
namespace Teamcenter
{
    class TransferModeGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PIE_API  Teamcenter::TransferMode
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    TransferMode();

    /**
     * Destructor
     */
    virtual ~TransferMode();

private:
    //  Getter method for the Implementation Object
    TransferModeImpl*  getTransferModeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTransferModeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    TransferModeImpl*  m_transfermodeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param TransferMode - desc for TransferMode parameter
     */
    TransferMode( const TransferMode& );
    TransferMode& operator=( const TransferMode& );

    friend class  TransferModeDelegate;
    friend class  TransferModeDispatch;
    friend class  TransferModeGenImpl;
};

#include <pie/libpie_undef.h>
#endif //   TEAMCENTER__TRANSFERMODE__HXX
