//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TransferModeDelegate
    Filename:   TransferModeDelegate.hxx
    Module:     pie
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TRANSFERMODEDELEGATE_HXX
#define TEAMCENTER__TRANSFERMODEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <pie/TransferMode.hxx>

#include <pie/libpie_exports.h>

namespace Teamcenter
{
    class TransferModeDelegate;
}
namespace Teamcenter
{
    class TransferModeImpl;
}
namespace Teamcenter
{
    class TransferMode;
}
namespace Teamcenter
{
    class TransferModeGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PIE_API Teamcenter_alias::TransferModeDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the TransferModeDelegate instance
    static TransferModeDelegate&  getInstance();

    //  Method to create the TransferModeImpl pointer
    static TransferModeImpl*  createImpl( TransferMode&  ifObj );

    //  Method to delete the TransferModeImpl pointer
    static void deleteImpl( TransferModeImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const TransferMode &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static TransferModeDelegate*  m_pInstance;

    TransferModeDelegate();
    virtual ~TransferModeDelegate();
    static void setInstance( TransferModeDelegate*  instance );


private:
    friend class  ::Teamcenter::TransferModeGenImpl;

};

#include <pie/libpie_undef.h>
#endif  //  TEAMCENTER__TRANSFERMODEDELEGATE_HXX
