//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TransferOptionSet
    Filename:   TransferOptionSet.hxx
    Module:     pie
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TRANSFEROPTIONSET__HXX
#define TEAMCENTER__TRANSFEROPTIONSET__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <pie/libpie_exports.h>

namespace Teamcenter
{
    class TransferOptionSet;
}
namespace Teamcenter
{
    class TransferOptionSetImpl;
}
namespace Teamcenter
{
    class TransferOptionSetDelegate;
}
namespace Teamcenter
{
    class TransferOptionSetDispatch;
}
namespace Teamcenter
{
    class TransferOptionSetGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PIE_API  Teamcenter::TransferOptionSet
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    TransferOptionSet();

    /**
     * Destructor
     */
    virtual ~TransferOptionSet();

private:
    //  Getter method for the Implementation Object
    TransferOptionSetImpl*  getTransferOptionSetImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTransferOptionSetImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    TransferOptionSetImpl*  m_transferoptionsetImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param TransferOptionSet - desc for TransferOptionSet parameter
     */
    TransferOptionSet( const TransferOptionSet& );
    TransferOptionSet& operator=( const TransferOptionSet& );

    friend class  TransferOptionSetDelegate;
    friend class  TransferOptionSetDispatch;
    friend class  TransferOptionSetGenImpl;
};

#include <pie/libpie_undef.h>
#endif //   TEAMCENTER__TRANSFEROPTIONSET__HXX
