//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TransferOptionSetDelegate
    Filename:   TransferOptionSetDelegate.hxx
    Module:     pie
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TRANSFEROPTIONSETDELEGATE_HXX
#define TEAMCENTER__TRANSFEROPTIONSETDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <pie/TransferOptionSet.hxx>

#include <pie/libpie_exports.h>

namespace Teamcenter
{
    class TransferOptionSetDelegate;
}
namespace Teamcenter
{
    class TransferOptionSetImpl;
}
namespace Teamcenter
{
    class TransferOptionSet;
}
namespace Teamcenter
{
    class TransferOptionSetGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PIE_API Teamcenter_alias::TransferOptionSetDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the TransferOptionSetDelegate instance
    static TransferOptionSetDelegate&  getInstance();

    //  Method to create the TransferOptionSetImpl pointer
    static TransferOptionSetImpl*  createImpl( TransferOptionSet&  ifObj );

    //  Method to delete the TransferOptionSetImpl pointer
    static void deleteImpl( TransferOptionSetImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const TransferOptionSet &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static TransferOptionSetDelegate*  m_pInstance;

    TransferOptionSetDelegate();
    virtual ~TransferOptionSetDelegate();
    static void setInstance( TransferOptionSetDelegate*  instance );


private:
    friend class  ::Teamcenter::TransferOptionSetGenImpl;

};

#include <pie/libpie_undef.h>
#endif  //  TEAMCENTER__TRANSFEROPTIONSETDELEGATE_HXX
