//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  pie

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libpie

#if !defined(LIBPIE) && !defined(IPLIB)
#   error IPLIB or LIBPIE is not defined
#endif

/* Handwritten code should use PIE_API, not PIEEXPORT */

#define PIE_API PIEEXPORT

#if IPLIB==libpie || defined(LIBPIE)
#   if defined(__lint)
#       define PIEEXPORT       __export(pie)
#       define PIEGLOBAL       extern __global(pie)
#       define PIEPRIVATE      extern __private(pie)
#   elif defined(_WIN32)
#       define PIEEXPORT       __declspec(dllexport)
#       define PIEGLOBAL       extern __declspec(dllexport)
#       define PIEPRIVATE      extern
#   else
#       define PIEEXPORT
#       define PIEGLOBAL       extern
#       define PIEPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define PIEEXPORT       __export(pie)
#       define PIEGLOBAL       extern __global(pie)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define PIEEXPORT      __declspec(dllimport)
#       define PIEGLOBAL       extern __declspec(dllimport)
#   else
#       define PIEEXPORT
#       define PIEGLOBAL       extern
#   endif
#endif
