//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPArtwork
    Filename:   CPArtwork.hxx
    Module:     pkgart
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PKGART__CPARTWORK__HXX
#define TEAMCENTER__PKGART__CPARTWORK__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/Document.hxx>

#include <pkgart/libpkgart_exports.h>

namespace Teamcenter
{
    namespace PKGART
    {
        class CPArtwork;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPArtworkImpl;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPArtworkDelegate;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPArtworkDispatch;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPArtworkGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PKGART_API  Teamcenter::PKGART::CPArtwork
     : public  ::Teamcenter::Document
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getArtwork_type( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setArtwork_type( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CPArtwork();

    /**
     * Destructor
     */
    virtual ~CPArtwork();

private:
    //  Getter method for the Implementation Object
    CPArtworkImpl*  getCPArtworkImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCPArtworkImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CPArtworkImpl*  m_cpartworkImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CPArtwork - desc for CPArtwork parameter
     */
    CPArtwork( const CPArtwork& );
    CPArtwork& operator=( const CPArtwork& );

    friend class  CPArtworkDelegate;
    friend class  CPArtworkDispatch;
    friend class  CPArtworkGenImpl;
};

#include <pkgart/libpkgart_undef.h>
#endif //   TEAMCENTER__PKGART__CPARTWORK__HXX
