//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPArtworkDelegate
    Filename:   CPArtworkDelegate.hxx
    Module:     pkgart
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PKGART__CPARTWORKDELEGATE_HXX
#define TEAMCENTER__PKGART__CPARTWORKDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <pkgart/CPArtwork.hxx>

#include <pkgart/libpkgart_exports.h>

namespace Teamcenter
{
    namespace PKGART
    {
        class CPArtworkDelegate;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPArtworkImpl;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPArtwork;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPArtworkGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  PKGART_API Teamcenter_alias::PKGART::CPArtworkDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CPArtworkDelegate instance
    static CPArtworkDelegate&  getInstance();

    //  Method to create the CPArtworkImpl pointer
    static CPArtworkImpl*  createImpl( CPArtwork&  ifObj );

    //  Method to delete the CPArtworkImpl pointer
    static void deleteImpl( CPArtworkImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getArtwork_typeBase(const CPArtwork &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setArtwork_typeBase(CPArtwork &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static CPArtworkDelegate*  m_pInstance;

    CPArtworkDelegate();
    virtual ~CPArtworkDelegate();
    static void setInstance( CPArtworkDelegate*  instance );


private:
    friend class  ::Teamcenter::PKGART::CPArtworkGenImpl;

};

#include <pkgart/libpkgart_undef.h>
#endif  //  TEAMCENTER__PKGART__CPARTWORKDELEGATE_HXX
