//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPCopyElementRevision
    Filename:   CPCopyElementRevision.hxx
    Module:     pkgart
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PKGART__CPCOPYELEMENTREVISION__HXX
#define TEAMCENTER__PKGART__CPCOPYELEMENTREVISION__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <req/SpecElementRevision.hxx>

#include <pkgart/libpkgart_exports.h>

namespace Teamcenter
{
    namespace PKGART
    {
        class CPCopyElementRevision;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPCopyElementRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPCopyElementRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPCopyElementRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPCopyElementRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PKGART_API  Teamcenter::PKGART::CPCopyElementRevision
     : public  ::Teamcenter::SpecElementRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCopy_element_type( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLanguage( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCopy_element_type( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLanguage( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CPCopyElementRevision();

    /**
     * Destructor
     */
    virtual ~CPCopyElementRevision();

private:
    //  Getter method for the Implementation Object
    CPCopyElementRevisionImpl*  getCPCopyElementRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCPCopyElementRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CPCopyElementRevisionImpl*  m_cpcopyelementrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CPCopyElementRevision - desc for CPCopyElementRevision parameter
     */
    CPCopyElementRevision( const CPCopyElementRevision& );
    CPCopyElementRevision& operator=( const CPCopyElementRevision& );

    friend class  CPCopyElementRevisionDelegate;
    friend class  CPCopyElementRevisionDispatch;
    friend class  CPCopyElementRevisionGenImpl;
};

#include <pkgart/libpkgart_undef.h>
#endif //   TEAMCENTER__PKGART__CPCOPYELEMENTREVISION__HXX
