//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPCopyElementRevisionDelegate
    Filename:   CPCopyElementRevisionDelegate.hxx
    Module:     pkgart
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PKGART__CPCOPYELEMENTREVISIONDELEGATE_HXX
#define TEAMCENTER__PKGART__CPCOPYELEMENTREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <pkgart/CPCopyElementRevision.hxx>

#include <pkgart/libpkgart_exports.h>

namespace Teamcenter
{
    namespace PKGART
    {
        class CPCopyElementRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPCopyElementRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPCopyElementRevision;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPCopyElementRevisionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  PKGART_API Teamcenter_alias::PKGART::CPCopyElementRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CPCopyElementRevisionDelegate instance
    static CPCopyElementRevisionDelegate&  getInstance();

    //  Method to create the CPCopyElementRevisionImpl pointer
    static CPCopyElementRevisionImpl*  createImpl( CPCopyElementRevision&  ifObj );

    //  Method to delete the CPCopyElementRevisionImpl pointer
    static void deleteImpl( CPCopyElementRevisionImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCopy_element_typeBase(const CPCopyElementRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLanguageBase(const CPCopyElementRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCopy_element_typeBase(CPCopyElementRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLanguageBase(CPCopyElementRevision &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static CPCopyElementRevisionDelegate*  m_pInstance;

    CPCopyElementRevisionDelegate();
    virtual ~CPCopyElementRevisionDelegate();
    static void setInstance( CPCopyElementRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::PKGART::CPCopyElementRevisionGenImpl;

};

#include <pkgart/libpkgart_undef.h>
#endif  //  TEAMCENTER__PKGART__CPCOPYELEMENTREVISIONDELEGATE_HXX
