//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPCopyRevisionDelegate
    Filename:   CPCopyRevisionDelegate.hxx
    Module:     pkgart
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PKGART__CPCOPYREVISIONDELEGATE_HXX
#define TEAMCENTER__PKGART__CPCOPYREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <pkgart/CPCopyRevision.hxx>

#include <pkgart/libpkgart_exports.h>

namespace Teamcenter
{
    namespace PKGART
    {
        class CPCopyRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPCopyRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPCopyRevision;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPCopyRevisionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  PKGART_API Teamcenter_alias::PKGART::CPCopyRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CPCopyRevisionDelegate instance
    static CPCopyRevisionDelegate&  getInstance();

    //  Method to create the CPCopyRevisionImpl pointer
    static CPCopyRevisionImpl*  createImpl( CPCopyRevision&  ifObj );

    //  Method to delete the CPCopyRevisionImpl pointer
    static void deleteImpl( CPCopyRevisionImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCopy_language_typeBase(const CPCopyRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCP_Has_Master_CopyBase(const CPCopyRevision &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLanguageBase(const CPCopyRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRegionBase(const CPCopyRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCopy_language_typeBase(CPCopyRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLanguageBase(CPCopyRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setRegionBase(CPCopyRevision &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static CPCopyRevisionDelegate*  m_pInstance;

    CPCopyRevisionDelegate();
    virtual ~CPCopyRevisionDelegate();
    static void setInstance( CPCopyRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::PKGART::CPCopyRevisionGenImpl;

};

#include <pkgart/libpkgart_undef.h>
#endif  //  TEAMCENTER__PKGART__CPCOPYREVISIONDELEGATE_HXX
