//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPDesignBrief
    Filename:   CPDesignBrief.hxx
    Module:     pkgart
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PKGART__CPDESIGNBRIEF__HXX
#define TEAMCENTER__PKGART__CPDESIGNBRIEF__HXX

#include <common/tc_deprecation_macros.h>
#include <req/RequirementSpec.hxx>

#include <pkgart/libpkgart_exports.h>

namespace Teamcenter
{
    namespace PKGART
    {
        class CPDesignBrief;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPDesignBriefImpl;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPDesignBriefDelegate;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPDesignBriefDispatch;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPDesignBriefGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PKGART_API  Teamcenter::PKGART::CPDesignBrief
     : public  ::Teamcenter::RequirementSpec
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CPDesignBrief();

    /**
     * Destructor
     */
    virtual ~CPDesignBrief();

private:
    //  Getter method for the Implementation Object
    CPDesignBriefImpl*  getCPDesignBriefImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCPDesignBriefImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CPDesignBriefImpl*  m_cpdesignbriefImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CPDesignBrief - desc for CPDesignBrief parameter
     */
    CPDesignBrief( const CPDesignBrief& );
    CPDesignBrief& operator=( const CPDesignBrief& );

    friend class  CPDesignBriefDelegate;
    friend class  CPDesignBriefDispatch;
    friend class  CPDesignBriefGenImpl;
};

#include <pkgart/libpkgart_undef.h>
#endif //   TEAMCENTER__PKGART__CPDESIGNBRIEF__HXX
