//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPDieLineRevisionDelegate
    Filename:   CPDieLineRevisionDelegate.hxx
    Module:     pkgart
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PKGART__CPDIELINEREVISIONDELEGATE_HXX
#define TEAMCENTER__PKGART__CPDIELINEREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <pkgart/CPDieLineRevision.hxx>

#include <pkgart/libpkgart_exports.h>

namespace Teamcenter
{
    namespace PKGART
    {
        class CPDieLineRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPDieLineRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPDieLineRevision;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPDieLineRevisionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  PKGART_API Teamcenter_alias::PKGART::CPDieLineRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CPDieLineRevisionDelegate instance
    static CPDieLineRevisionDelegate&  getInstance();

    //  Method to create the CPDieLineRevisionImpl pointer
    static CPDieLineRevisionImpl*  createImpl( CPDieLineRevision&  ifObj );

    //  Method to delete the CPDieLineRevisionImpl pointer
    static void deleteImpl( CPDieLineRevisionImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCP_package_itemsBase(const CPDieLineRevision &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDieline_lengthBase(const CPDieLineRevision &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getPka0CP_has_artworksBase(const CPDieLineRevision &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getUnit_of_measureBase(const CPDieLineRevision &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getWidthBase(const CPDieLineRevision &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDieline_lengthBase(CPDieLineRevision &ifObj,  double value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setUnit_of_measureBase(CPDieLineRevision &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setWidthBase(CPDieLineRevision &ifObj,  double value, bool isNull );



protected:
    //  Pointer to the instance
    static CPDieLineRevisionDelegate*  m_pInstance;

    CPDieLineRevisionDelegate();
    virtual ~CPDieLineRevisionDelegate();
    static void setInstance( CPDieLineRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::PKGART::CPDieLineRevisionGenImpl;

};

#include <pkgart/libpkgart_undef.h>
#endif  //  TEAMCENTER__PKGART__CPDIELINEREVISIONDELEGATE_HXX
