//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPGraphicElementRevision
    Filename:   CPGraphicElementRevision.hxx
    Module:     pkgart
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PKGART__CPGRAPHICELEMENTREVISION__HXX
#define TEAMCENTER__PKGART__CPGRAPHICELEMENTREVISION__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <req/SpecElementRevision.hxx>

#include <pkgart/libpkgart_exports.h>

namespace Teamcenter
{
    namespace PKGART
    {
        class CPGraphicElementRevision;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPGraphicElementRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPGraphicElementRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPGraphicElementRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPGraphicElementRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PKGART_API  Teamcenter::PKGART::CPGraphicElementRevision
     : public  ::Teamcenter::SpecElementRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getGraphic_element_type( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setGraphic_element_type( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CPGraphicElementRevision();

    /**
     * Destructor
     */
    virtual ~CPGraphicElementRevision();

private:
    //  Getter method for the Implementation Object
    CPGraphicElementRevisionImpl*  getCPGraphicElementRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCPGraphicElementRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CPGraphicElementRevisionImpl*  m_cpgraphicelementrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CPGraphicElementRevision - desc for CPGraphicElementRevision parameter
     */
    CPGraphicElementRevision( const CPGraphicElementRevision& );
    CPGraphicElementRevision& operator=( const CPGraphicElementRevision& );

    friend class  CPGraphicElementRevisionDelegate;
    friend class  CPGraphicElementRevisionDispatch;
    friend class  CPGraphicElementRevisionGenImpl;
};

#include <pkgart/libpkgart_undef.h>
#endif //   TEAMCENTER__PKGART__CPGRAPHICELEMENTREVISION__HXX
