//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPGraphicElementRevisionDelegate
    Filename:   CPGraphicElementRevisionDelegate.hxx
    Module:     pkgart
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PKGART__CPGRAPHICELEMENTREVISIONDELEGATE_HXX
#define TEAMCENTER__PKGART__CPGRAPHICELEMENTREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <pkgart/CPGraphicElementRevision.hxx>

#include <pkgart/libpkgart_exports.h>

namespace Teamcenter
{
    namespace PKGART
    {
        class CPGraphicElementRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPGraphicElementRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPGraphicElementRevision;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPGraphicElementRevisionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  PKGART_API Teamcenter_alias::PKGART::CPGraphicElementRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CPGraphicElementRevisionDelegate instance
    static CPGraphicElementRevisionDelegate&  getInstance();

    //  Method to create the CPGraphicElementRevisionImpl pointer
    static CPGraphicElementRevisionImpl*  createImpl( CPGraphicElementRevision&  ifObj );

    //  Method to delete the CPGraphicElementRevisionImpl pointer
    static void deleteImpl( CPGraphicElementRevisionImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getGraphic_element_typeBase(const CPGraphicElementRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setGraphic_element_typeBase(CPGraphicElementRevision &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static CPGraphicElementRevisionDelegate*  m_pInstance;

    CPGraphicElementRevisionDelegate();
    virtual ~CPGraphicElementRevisionDelegate();
    static void setInstance( CPGraphicElementRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::PKGART::CPGraphicElementRevisionGenImpl;

};

#include <pkgart/libpkgart_undef.h>
#endif  //  TEAMCENTER__PKGART__CPGRAPHICELEMENTREVISIONDELEGATE_HXX
