//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPPackageConceptRevision
    Filename:   CPPackageConceptRevision.hxx
    Module:     pkgart
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PKGART__CPPACKAGECONCEPTREVISION__HXX
#define TEAMCENTER__PKGART__CPPACKAGECONCEPTREVISION__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/DocumentRevision.hxx>

#include <pkgart/libpkgart_exports.h>

namespace Teamcenter
{
    namespace PKGART
    {
        class CPPackageConceptRevision;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPPackageConceptRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPPackageConceptRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPPackageConceptRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPPackageConceptRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PKGART_API  Teamcenter::PKGART::CPPackageConceptRevision
     : public  ::Teamcenter::DocumentRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCP_design_briefs( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCP_tech_briefs( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CPPackageConceptRevision();

    /**
     * Destructor
     */
    virtual ~CPPackageConceptRevision();

private:
    //  Getter method for the Implementation Object
    CPPackageConceptRevisionImpl*  getCPPackageConceptRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCPPackageConceptRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CPPackageConceptRevisionImpl*  m_cppackageconceptrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CPPackageConceptRevision - desc for CPPackageConceptRevision parameter
     */
    CPPackageConceptRevision( const CPPackageConceptRevision& );
    CPPackageConceptRevision& operator=( const CPPackageConceptRevision& );

    friend class  CPPackageConceptRevisionDelegate;
    friend class  CPPackageConceptRevisionDispatch;
    friend class  CPPackageConceptRevisionGenImpl;
};

#include <pkgart/libpkgart_undef.h>
#endif //   TEAMCENTER__PKGART__CPPACKAGECONCEPTREVISION__HXX
