//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPPackageConceptRevisionDelegate
    Filename:   CPPackageConceptRevisionDelegate.hxx
    Module:     pkgart
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PKGART__CPPACKAGECONCEPTREVISIONDELEGATE_HXX
#define TEAMCENTER__PKGART__CPPACKAGECONCEPTREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <pkgart/CPPackageConceptRevision.hxx>

#include <pkgart/libpkgart_exports.h>

namespace Teamcenter
{
    namespace PKGART
    {
        class CPPackageConceptRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPPackageConceptRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPPackageConceptRevision;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPPackageConceptRevisionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  PKGART_API Teamcenter_alias::PKGART::CPPackageConceptRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CPPackageConceptRevisionDelegate instance
    static CPPackageConceptRevisionDelegate&  getInstance();

    //  Method to create the CPPackageConceptRevisionImpl pointer
    static CPPackageConceptRevisionImpl*  createImpl( CPPackageConceptRevision&  ifObj );

    //  Method to delete the CPPackageConceptRevisionImpl pointer
    static void deleteImpl( CPPackageConceptRevisionImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCP_design_briefsBase(const CPPackageConceptRevision &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCP_tech_briefsBase(const CPPackageConceptRevision &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;



protected:
    //  Pointer to the instance
    static CPPackageConceptRevisionDelegate*  m_pInstance;

    CPPackageConceptRevisionDelegate();
    virtual ~CPPackageConceptRevisionDelegate();
    static void setInstance( CPPackageConceptRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::PKGART::CPPackageConceptRevisionGenImpl;

};

#include <pkgart/libpkgart_undef.h>
#endif  //  TEAMCENTER__PKGART__CPPACKAGECONCEPTREVISIONDELEGATE_HXX
