//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPPackageItem
    Filename:   CPPackageItem.hxx
    Module:     pkgart
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PKGART__CPPACKAGEITEM__HXX
#define TEAMCENTER__PKGART__CPPACKAGEITEM__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <pkgart/libpkgart_exports.h>

namespace Teamcenter
{
    namespace PKGART
    {
        class CPPackageItem;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPPackageItemImpl;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPPackageItemDelegate;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPPackageItemDispatch;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPPackageItemGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PKGART_API  Teamcenter::PKGART::CPPackageItem
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPackage_type( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPackage_type( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CPPackageItem();

    /**
     * Destructor
     */
    virtual ~CPPackageItem();

private:
    //  Getter method for the Implementation Object
    CPPackageItemImpl*  getCPPackageItemImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCPPackageItemImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CPPackageItemImpl*  m_cppackageitemImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CPPackageItem - desc for CPPackageItem parameter
     */
    CPPackageItem( const CPPackageItem& );
    CPPackageItem& operator=( const CPPackageItem& );

    friend class  CPPackageItemDelegate;
    friend class  CPPackageItemDispatch;
    friend class  CPPackageItemGenImpl;
};

#include <pkgart/libpkgart_undef.h>
#endif //   TEAMCENTER__PKGART__CPPACKAGEITEM__HXX
