//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPPackageItemDelegate
    Filename:   CPPackageItemDelegate.hxx
    Module:     pkgart
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PKGART__CPPACKAGEITEMDELEGATE_HXX
#define TEAMCENTER__PKGART__CPPACKAGEITEMDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <pkgart/CPPackageItem.hxx>

#include <pkgart/libpkgart_exports.h>

namespace Teamcenter
{
    namespace PKGART
    {
        class CPPackageItemDelegate;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPPackageItemImpl;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPPackageItem;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPPackageItemGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  PKGART_API Teamcenter_alias::PKGART::CPPackageItemDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CPPackageItemDelegate instance
    static CPPackageItemDelegate&  getInstance();

    //  Method to create the CPPackageItemImpl pointer
    static CPPackageItemImpl*  createImpl( CPPackageItem&  ifObj );

    //  Method to delete the CPPackageItemImpl pointer
    static void deleteImpl( CPPackageItemImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPackage_typeBase(const CPPackageItem &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPackage_typeBase(CPPackageItem &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static CPPackageItemDelegate*  m_pInstance;

    CPPackageItemDelegate();
    virtual ~CPPackageItemDelegate();
    static void setInstance( CPPackageItemDelegate*  instance );


private:
    friend class  ::Teamcenter::PKGART::CPPackageItemGenImpl;

};

#include <pkgart/libpkgart_undef.h>
#endif  //  TEAMCENTER__PKGART__CPPACKAGEITEMDELEGATE_HXX
