//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPPackageItemRevision
    Filename:   CPPackageItemRevision.hxx
    Module:     pkgart
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PKGART__CPPACKAGEITEMREVISION__HXX
#define TEAMCENTER__PKGART__CPPACKAGEITEMREVISION__HXX

#include <string>
#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <pkgart/libpkgart_exports.h>

namespace Teamcenter
{
    namespace PKGART
    {
        class CPPackageItemRevision;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPPackageItemRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPPackageItemRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPPackageItemRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPPackageItemRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PKGART_API  Teamcenter::PKGART::CPPackageItemRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCase_count( int &value, bool &isNull ) const;

    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCost( double &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCurrency( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDepth( double &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDimension_unit( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getGross_weight( double &value, bool &isNull ) const;

    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getHeight( double &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIs_lead_package( bool &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPackage_priority( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPackaging_level( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getShape( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getWeight_unit( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getWidth( double &value, bool &isNull ) const;

    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCase_count( int value, bool isNull=false );

    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCost( double value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCurrency( const std::string &value, bool isNull=false );

    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDepth( double value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDimension_unit( const tag_t &value, bool isNull=false );

    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setGross_weight( double value, bool isNull=false );

    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setHeight( double value, bool isNull=false );

    ///
    /// Setter for a Boolean Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIs_lead_package( bool value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPackage_priority( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPackaging_level( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setShape( const std::string &value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setWeight_unit( const tag_t &value, bool isNull=false );

    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setWidth( double value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CPPackageItemRevision();

    /**
     * Destructor
     */
    virtual ~CPPackageItemRevision();

private:
    //  Getter method for the Implementation Object
    CPPackageItemRevisionImpl*  getCPPackageItemRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCPPackageItemRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CPPackageItemRevisionImpl*  m_cppackageitemrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CPPackageItemRevision - desc for CPPackageItemRevision parameter
     */
    CPPackageItemRevision( const CPPackageItemRevision& );
    CPPackageItemRevision& operator=( const CPPackageItemRevision& );

    friend class  CPPackageItemRevisionDelegate;
    friend class  CPPackageItemRevisionDispatch;
    friend class  CPPackageItemRevisionGenImpl;
};

#include <pkgart/libpkgart_undef.h>
#endif //   TEAMCENTER__PKGART__CPPACKAGEITEMREVISION__HXX
