//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPPackageItemRevisionDelegate
    Filename:   CPPackageItemRevisionDelegate.hxx
    Module:     pkgart
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PKGART__CPPACKAGEITEMREVISIONDELEGATE_HXX
#define TEAMCENTER__PKGART__CPPACKAGEITEMREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <pkgart/CPPackageItemRevision.hxx>

#include <pkgart/libpkgart_exports.h>

namespace Teamcenter
{
    namespace PKGART
    {
        class CPPackageItemRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPPackageItemRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPPackageItemRevision;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPPackageItemRevisionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  PKGART_API Teamcenter_alias::PKGART::CPPackageItemRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CPPackageItemRevisionDelegate instance
    static CPPackageItemRevisionDelegate&  getInstance();

    //  Method to create the CPPackageItemRevisionImpl pointer
    static CPPackageItemRevisionImpl*  createImpl( CPPackageItemRevision&  ifObj );

    //  Method to delete the CPPackageItemRevisionImpl pointer
    static void deleteImpl( CPPackageItemRevisionImpl*  impl );


    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCase_countBase(const CPPackageItemRevision &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCostBase(const CPPackageItemRevision &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCurrencyBase(const CPPackageItemRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDepthBase(const CPPackageItemRevision &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDimension_unitBase(const CPPackageItemRevision &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getGross_weightBase(const CPPackageItemRevision &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getHeightBase(const CPPackageItemRevision &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIs_lead_packageBase(const CPPackageItemRevision &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPackage_priorityBase(const CPPackageItemRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPackaging_levelBase(const CPPackageItemRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getShapeBase(const CPPackageItemRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getWeight_unitBase(const CPPackageItemRevision &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getWidthBase(const CPPackageItemRevision &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCase_countBase(CPPackageItemRevision &ifObj,  int value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCostBase(CPPackageItemRevision &ifObj,  double value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCurrencyBase(CPPackageItemRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDepthBase(CPPackageItemRevision &ifObj,  double value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDimension_unitBase(CPPackageItemRevision &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setGross_weightBase(CPPackageItemRevision &ifObj,  double value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setHeightBase(CPPackageItemRevision &ifObj,  double value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIs_lead_packageBase(CPPackageItemRevision &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPackage_priorityBase(CPPackageItemRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPackaging_levelBase(CPPackageItemRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setShapeBase(CPPackageItemRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setWeight_unitBase(CPPackageItemRevision &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setWidthBase(CPPackageItemRevision &ifObj,  double value, bool isNull );



protected:
    //  Pointer to the instance
    static CPPackageItemRevisionDelegate*  m_pInstance;

    CPPackageItemRevisionDelegate();
    virtual ~CPPackageItemRevisionDelegate();
    static void setInstance( CPPackageItemRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::PKGART::CPPackageItemRevisionGenImpl;

};

#include <pkgart/libpkgart_undef.h>
#endif  //  TEAMCENTER__PKGART__CPPACKAGEITEMREVISIONDELEGATE_HXX
