//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPPackageRoughRevision
    Filename:   CPPackageRoughRevision.hxx
    Module:     pkgart
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PKGART__CPPACKAGEROUGHREVISION__HXX
#define TEAMCENTER__PKGART__CPPACKAGEROUGHREVISION__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/DocumentRevision.hxx>

#include <pkgart/libpkgart_exports.h>

namespace Teamcenter
{
    namespace PKGART
    {
        class CPPackageRoughRevision;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPPackageRoughRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPPackageRoughRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPPackageRoughRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPPackageRoughRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PKGART_API  Teamcenter::PKGART::CPPackageRoughRevision
     : public  ::Teamcenter::DocumentRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCP_design_briefs( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CPPackageRoughRevision();

    /**
     * Destructor
     */
    virtual ~CPPackageRoughRevision();

private:
    //  Getter method for the Implementation Object
    CPPackageRoughRevisionImpl*  getCPPackageRoughRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCPPackageRoughRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CPPackageRoughRevisionImpl*  m_cppackageroughrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CPPackageRoughRevision - desc for CPPackageRoughRevision parameter
     */
    CPPackageRoughRevision( const CPPackageRoughRevision& );
    CPPackageRoughRevision& operator=( const CPPackageRoughRevision& );

    friend class  CPPackageRoughRevisionDelegate;
    friend class  CPPackageRoughRevisionDispatch;
    friend class  CPPackageRoughRevisionGenImpl;
};

#include <pkgart/libpkgart_undef.h>
#endif //   TEAMCENTER__PKGART__CPPACKAGEROUGHREVISION__HXX
