//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPTechnicalBriefRevisionDelegate
    Filename:   CPTechnicalBriefRevisionDelegate.hxx
    Module:     pkgart
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PKGART__CPTECHNICALBRIEFREVISIONDELEGATE_HXX
#define TEAMCENTER__PKGART__CPTECHNICALBRIEFREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <pkgart/CPTechnicalBriefRevision.hxx>

#include <pkgart/libpkgart_exports.h>

namespace Teamcenter
{
    namespace PKGART
    {
        class CPTechnicalBriefRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPTechnicalBriefRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPTechnicalBriefRevision;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class CPTechnicalBriefRevisionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  PKGART_API Teamcenter_alias::PKGART::CPTechnicalBriefRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CPTechnicalBriefRevisionDelegate instance
    static CPTechnicalBriefRevisionDelegate&  getInstance();

    //  Method to create the CPTechnicalBriefRevisionImpl pointer
    static CPTechnicalBriefRevisionImpl*  createImpl( CPTechnicalBriefRevision&  ifObj );

    //  Method to delete the CPTechnicalBriefRevisionImpl pointer
    static void deleteImpl( CPTechnicalBriefRevisionImpl*  impl );


    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCase_countBase(const CPTechnicalBriefRevision &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCP_marketing_briefsBase(const CPTechnicalBriefRevision &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDepthBase(const CPTechnicalBriefRevision &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDimension_unitBase(const CPTechnicalBriefRevision &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getGross_weightBase(const CPTechnicalBriefRevision &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getHeightBase(const CPTechnicalBriefRevision &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getManufacturing_processBase(const CPTechnicalBriefRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPacking_instructionsBase(const CPTechnicalBriefRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPrinting_techniqueBase(const CPTechnicalBriefRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSubstrateBase(const CPTechnicalBriefRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getTests_to_performBase(const CPTechnicalBriefRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getWeight_unitBase(const CPTechnicalBriefRevision &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getWidthBase(const CPTechnicalBriefRevision &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCase_countBase(CPTechnicalBriefRevision &ifObj,  int value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDepthBase(CPTechnicalBriefRevision &ifObj,  double value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDimension_unitBase(CPTechnicalBriefRevision &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setGross_weightBase(CPTechnicalBriefRevision &ifObj,  double value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setHeightBase(CPTechnicalBriefRevision &ifObj,  double value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setManufacturing_processBase(CPTechnicalBriefRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPacking_instructionsBase(CPTechnicalBriefRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPrinting_techniqueBase(CPTechnicalBriefRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSubstrateBase(CPTechnicalBriefRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setTests_to_performBase(CPTechnicalBriefRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setWeight_unitBase(CPTechnicalBriefRevision &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setWidthBase(CPTechnicalBriefRevision &ifObj,  double value, bool isNull );



protected:
    //  Pointer to the instance
    static CPTechnicalBriefRevisionDelegate*  m_pInstance;

    CPTechnicalBriefRevisionDelegate();
    virtual ~CPTechnicalBriefRevisionDelegate();
    static void setInstance( CPTechnicalBriefRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::PKGART::CPTechnicalBriefRevisionGenImpl;

};

#include <pkgart/libpkgart_undef.h>
#endif  //  TEAMCENTER__PKGART__CPTECHNICALBRIEFREVISIONDELEGATE_HXX
