//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Pka0CopyAssetRevision
    Filename:   Pka0CopyAssetRevision.hxx
    Module:     pkgart
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PKGART__PKA0COPYASSETREVISION__HXX
#define TEAMCENTER__PKGART__PKA0COPYASSETREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <pkgart/Pka0DigitalAssetRevision.hxx>

#include <pkgart/libpkgart_exports.h>

namespace Teamcenter
{
    namespace PKGART
    {
        class Pka0CopyAssetRevision;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class Pka0CopyAssetRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class Pka0CopyAssetRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class Pka0CopyAssetRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class Pka0CopyAssetRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PKGART_API  Teamcenter::PKGART::Pka0CopyAssetRevision
     : public  ::Teamcenter::PKGART::Pka0DigitalAssetRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Pka0CopyAssetRevision();

    /**
     * Destructor
     */
    virtual ~Pka0CopyAssetRevision();

private:
    //  Getter method for the Implementation Object
    Pka0CopyAssetRevisionImpl*  getPka0CopyAssetRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPka0CopyAssetRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Pka0CopyAssetRevisionImpl*  m_pka0copyassetrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Pka0CopyAssetRevision - desc for Pka0CopyAssetRevision parameter
     */
    Pka0CopyAssetRevision( const Pka0CopyAssetRevision& );
    Pka0CopyAssetRevision& operator=( const Pka0CopyAssetRevision& );

    friend class  Pka0CopyAssetRevisionDelegate;
    friend class  Pka0CopyAssetRevisionDispatch;
    friend class  Pka0CopyAssetRevisionGenImpl;
};

#include <pkgart/libpkgart_undef.h>
#endif //   TEAMCENTER__PKGART__PKA0COPYASSETREVISION__HXX
