//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Pka0DigitalAssetRevision
    Filename:   Pka0DigitalAssetRevision.hxx
    Module:     pkgart
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PKGART__PKA0DIGITALASSETREVISION__HXX
#define TEAMCENTER__PKGART__PKA0DIGITALASSETREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/DocumentRevision.hxx>

#include <pkgart/libpkgart_exports.h>

namespace Teamcenter
{
    namespace PKGART
    {
        class Pka0DigitalAssetRevision;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class Pka0DigitalAssetRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class Pka0DigitalAssetRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class Pka0DigitalAssetRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class Pka0DigitalAssetRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PKGART_API  Teamcenter::PKGART::Pka0DigitalAssetRevision
     : public  ::Teamcenter::DocumentRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Pka0DigitalAssetRevision();

    /**
     * Destructor
     */
    virtual ~Pka0DigitalAssetRevision();

private:
    //  Getter method for the Implementation Object
    Pka0DigitalAssetRevisionImpl*  getPka0DigitalAssetRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPka0DigitalAssetRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Pka0DigitalAssetRevisionImpl*  m_pka0digitalassetrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Pka0DigitalAssetRevision - desc for Pka0DigitalAssetRevision parameter
     */
    Pka0DigitalAssetRevision( const Pka0DigitalAssetRevision& );
    Pka0DigitalAssetRevision& operator=( const Pka0DigitalAssetRevision& );

    friend class  Pka0DigitalAssetRevisionDelegate;
    friend class  Pka0DigitalAssetRevisionDispatch;
    friend class  Pka0DigitalAssetRevisionGenImpl;
};

#include <pkgart/libpkgart_undef.h>
#endif //   TEAMCENTER__PKGART__PKA0DIGITALASSETREVISION__HXX
