//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Pka0PartnerContactProvider
    Filename:   Pka0PartnerContactProvider.hxx
    Module:     pkgart
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PKGART__PKA0PARTNERCONTACTPROVIDER__HXX
#define TEAMCENTER__PKGART__PKA0PARTNERCONTACTPROVIDER__HXX

#include <common/tc_deprecation_macros.h>
#include <tc/Fnd0BaseProvider.hxx>

#include <pkgart/libpkgart_exports.h>

namespace Teamcenter
{
    namespace PKGART
    {
        class Pka0PartnerContactProvider;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class Pka0PartnerContactProviderImpl;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class Pka0PartnerContactProviderDelegate;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class Pka0PartnerContactProviderDispatch;
    }
}
namespace Teamcenter
{
    namespace PKGART
    {
        class Pka0PartnerContactProviderGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PKGART_API  Teamcenter::PKGART::Pka0PartnerContactProvider
     : public  ::Teamcenter::Fnd0BaseProvider
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Pka0PartnerContactProvider();

    /**
     * Destructor
     */
    virtual ~Pka0PartnerContactProvider();

private:
    //  Getter method for the Implementation Object
    Pka0PartnerContactProviderImpl*  getPka0PartnerContactProviderImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPka0PartnerContactProviderImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Pka0PartnerContactProviderImpl*  m_pka0partnercontactproviderImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Pka0PartnerContactProvider - desc for Pka0PartnerContactProvider parameter
     */
    Pka0PartnerContactProvider( const Pka0PartnerContactProvider& );
    Pka0PartnerContactProvider& operator=( const Pka0PartnerContactProvider& );

    friend class  Pka0PartnerContactProviderDelegate;
    friend class  Pka0PartnerContactProviderDispatch;
    friend class  Pka0PartnerContactProviderGenImpl;
};

#include <pkgart/libpkgart_undef.h>
#endif //   TEAMCENTER__PKGART__PKA0PARTNERCONTACTPROVIDER__HXX
