//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  pkgart

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libpkgart

#if !defined(LIBPKGART) && !defined(IPLIB)
#   error IPLIB or LIBPKGART is not defined
#endif

/* Handwritten code should use PKGART_API, not PKGARTEXPORT */

#define PKGART_API PKGARTEXPORT

#if IPLIB==libpkgart || defined(LIBPKGART)
#   if defined(__lint)
#       define PKGARTEXPORT       __export(pkgart)
#       define PKGARTGLOBAL       extern __global(pkgart)
#       define PKGARTPRIVATE      extern __private(pkgart)
#   elif defined(_WIN32)
#       define PKGARTEXPORT       __declspec(dllexport)
#       define PKGARTGLOBAL       extern __declspec(dllexport)
#       define PKGARTPRIVATE      extern
#   else
#       define PKGARTEXPORT
#       define PKGARTGLOBAL       extern
#       define PKGARTPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define PKGARTEXPORT       __export(pkgart)
#       define PKGARTGLOBAL       extern __global(pkgart)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define PKGARTEXPORT      __declspec(dllimport)
#       define PKGARTGLOBAL       extern __declspec(dllimport)
#   else
#       define PKGARTEXPORT
#       define PKGARTGLOBAL       extern
#   endif
#endif
