//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  pkgartdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libpkgartdispatch

#if !defined(LIBPKGARTDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBPKGARTDISPATCH is not defined
#endif

/* Handwritten code should use PKGARTDISPATCH_API, not PKGARTDISPATCHEXPORT */

#define PKGARTDISPATCH_API PKGARTDISPATCHEXPORT

#if IPLIB==libpkgartdispatch || defined(LIBPKGARTDISPATCH)
#   if defined(__lint)
#       define PKGARTDISPATCHEXPORT       __export(pkgartdispatch)
#       define PKGARTDISPATCHGLOBAL       extern __global(pkgartdispatch)
#       define PKGARTDISPATCHPRIVATE      extern __private(pkgartdispatch)
#   elif defined(_WIN32)
#       define PKGARTDISPATCHEXPORT       __declspec(dllexport)
#       define PKGARTDISPATCHGLOBAL       extern __declspec(dllexport)
#       define PKGARTDISPATCHPRIVATE      extern
#   else
#       define PKGARTDISPATCHEXPORT
#       define PKGARTDISPATCHGLOBAL       extern
#       define PKGARTDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define PKGARTDISPATCHEXPORT       __export(pkgartdispatch)
#       define PKGARTDISPATCHGLOBAL       extern __global(pkgartdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define PKGARTDISPATCHEXPORT      __declspec(dllimport)
#       define PKGARTDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define PKGARTDISPATCHEXPORT
#       define PKGARTDISPATCHGLOBAL       extern
#   endif
#endif
