//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  pkgmgmtdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libpkgmgmtdispatch

#if !defined(LIBPKGMGMTDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBPKGMGMTDISPATCH is not defined
#endif

/* Handwritten code should use PKGMGMTDISPATCH_API, not PKGMGMTDISPATCHEXPORT */

#define PKGMGMTDISPATCH_API PKGMGMTDISPATCHEXPORT

#if IPLIB==libpkgmgmtdispatch || defined(LIBPKGMGMTDISPATCH)
#   if defined(__lint)
#       define PKGMGMTDISPATCHEXPORT       __export(pkgmgmtdispatch)
#       define PKGMGMTDISPATCHGLOBAL       extern __global(pkgmgmtdispatch)
#       define PKGMGMTDISPATCHPRIVATE      extern __private(pkgmgmtdispatch)
#   elif defined(_WIN32)
#       define PKGMGMTDISPATCHEXPORT       __declspec(dllexport)
#       define PKGMGMTDISPATCHGLOBAL       extern __declspec(dllexport)
#       define PKGMGMTDISPATCHPRIVATE      extern
#   else
#       define PKGMGMTDISPATCHEXPORT
#       define PKGMGMTDISPATCHGLOBAL       extern
#       define PKGMGMTDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define PKGMGMTDISPATCHEXPORT       __export(pkgmgmtdispatch)
#       define PKGMGMTDISPATCHGLOBAL       extern __global(pkgmgmtdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define PKGMGMTDISPATCHEXPORT      __declspec(dllimport)
#       define PKGMGMTDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define PKGMGMTDISPATCHEXPORT
#       define PKGMGMTDISPATCHGLOBAL       extern
#   endif
#endif
