//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Plp0ProductLinePlan
    Filename:   Plp0ProductLinePlan.hxx
    Module:     plp0prodlineplan
    @BMIDE autogenerated
==================================================================================================*/

#ifndef PLP0PRODLINEPLAN__PLP0PRODUCTLINEPLAN__HXX
#define PLP0PRODLINEPLAN__PLP0PRODUCTLINEPLAN__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <plp0prodlineplan/libplp0prodlineplan_exports.h>

namespace plp0prodlineplan
{
    class Plp0ProductLinePlan;
}
namespace plp0prodlineplan
{
    class Plp0ProductLinePlanImpl;
}
namespace plp0prodlineplan
{
    class Plp0ProductLinePlanDelegate;
}
namespace plp0prodlineplan
{
    class Plp0ProductLinePlanDispatch;
}
namespace plp0prodlineplan
{
    class Plp0ProductLinePlanGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PLP0PRODLINEPLAN_API  plp0prodlineplan::Plp0ProductLinePlan
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getPlp0ProductLinePlanUsages( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Plp0ProductLinePlan();

    /**
     * Destructor
     */
    virtual ~Plp0ProductLinePlan();

private:
    //  Getter method for the Implementation Object
    Plp0ProductLinePlanImpl*  getPlp0ProductLinePlanImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPlp0ProductLinePlanImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Plp0ProductLinePlanImpl*  m_plp0productlineplanImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Plp0ProductLinePlan - desc for Plp0ProductLinePlan parameter
     */
    Plp0ProductLinePlan( const Plp0ProductLinePlan& );
    Plp0ProductLinePlan& operator=( const Plp0ProductLinePlan& );

    friend class  Plp0ProductLinePlanDelegate;
    friend class  Plp0ProductLinePlanDispatch;
    friend class  Plp0ProductLinePlanGenImpl;
};

#include <plp0prodlineplan/libplp0prodlineplan_undef.h>
#endif //   PLP0PRODLINEPLAN__PLP0PRODUCTLINEPLAN__HXX
