//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Plp0ProductLinePlanUsage
    Filename:   Plp0ProductLinePlanUsage.hxx
    Module:     plp0prodlineplan
    @BMIDE autogenerated
==================================================================================================*/

#ifndef PLP0PRODLINEPLAN__PLP0PRODUCTLINEPLANUSAGE__HXX
#define PLP0PRODLINEPLAN__PLP0PRODUCTLINEPLANUSAGE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <plp0prodlineplan/libplp0prodlineplan_exports.h>

namespace plp0prodlineplan
{
    class Plp0ProductLinePlanUsage;
}
namespace plp0prodlineplan
{
    class Plp0ProductLinePlanUsageImpl;
}
namespace plp0prodlineplan
{
    class Plp0ProductLinePlanUsageDelegate;
}
namespace plp0prodlineplan
{
    class Plp0ProductLinePlanUsageDispatch;
}
namespace plp0prodlineplan
{
    class Plp0ProductLinePlanUsageGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PLP0PRODLINEPLAN_API  plp0prodlineplan::Plp0ProductLinePlanUsage
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Plp0ProductLinePlanUsage();

    /**
     * Destructor
     */
    virtual ~Plp0ProductLinePlanUsage();

private:
    //  Getter method for the Implementation Object
    Plp0ProductLinePlanUsageImpl*  getPlp0ProductLinePlanUsageImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPlp0ProductLinePlanUsageImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Plp0ProductLinePlanUsageImpl*  m_plp0productlineplanusageImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Plp0ProductLinePlanUsage - desc for Plp0ProductLinePlanUsage parameter
     */
    Plp0ProductLinePlanUsage( const Plp0ProductLinePlanUsage& );
    Plp0ProductLinePlanUsage& operator=( const Plp0ProductLinePlanUsage& );

    friend class  Plp0ProductLinePlanUsageDelegate;
    friend class  Plp0ProductLinePlanUsageDispatch;
    friend class  Plp0ProductLinePlanUsageGenImpl;
};

#include <plp0prodlineplan/libplp0prodlineplan_undef.h>
#endif //   PLP0PRODLINEPLAN__PLP0PRODUCTLINEPLANUSAGE__HXX
