//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2019.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*=================================================================================================
File description:
   This file contains the definition for the ColumnInfo.


    Filename: ColumnInfo.hxx
    Module  : pmg0cpmgmt
==================================================================================================*/

#ifndef TEAMCENTER__PMG0CPMGMT__COLUMNINFO
#define TEAMCENTER__PMG0CPMGMT__COLUMNINFO

#include <base_utils/TcBaseTypes.hxx>
#include <pmg0cpmgmt/libpmg0cpmgmt_exports.h>

using namespace std;

namespace Teamcenter
{
    namespace Pmg0cpmgmt
    {
        class ColumnInfo;
    }
}

class PMG0CPMGMT_API Teamcenter::Pmg0cpmgmt::ColumnInfo
{
    public:

        ColumnInfo();
        ColumnInfo( string propInternalName, string propDisplayName, string typeName, int columnWidth, int groupingOrder, 
                           int sortingOrder, bool isAscending, bool isVisible );

        virtual ~ColumnInfo();

        string getPropInternalName () const;
        string getPropDisplayName  () const;
        string getTypeName         () const;
        int    getColumnWidth      () const;
        int    getGroupingOrder    () const;
        int    getSortingOrder     () const;
        bool   getIsAscending      () const;
        bool   getIsVisible        () const;
        
        int getColumnInfo( tag_t colOrderRel, tag_t colDef, ColumnInfo & colInfo );


    private:
        string  m_PropInternalName;
        string  m_PropDisplayName;
        string  m_TypeName;
        int     m_ColumnWidth;
        int     m_GroupingOrder;
        int     m_SortingOrder;
        bool    m_IsAscending;
        bool    m_IsVisible;
    

};

#include <pmg0cpmgmt/libpmg0cpmgmt_undef.h>
#endif // TEAMCENTER__PMG0CPMGMT__COLUMNINFO
