//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Pmg0AbstractSKURevision
    Filename:   Pmg0AbstractSKURevision.hxx
    Module:     pmg0cpmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef PMG0CPMGMT__PMG0ABSTRACTSKUREVISION__HXX
#define PMG0CPMGMT__PMG0ABSTRACTSKUREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <pmg0cpmgmt/libpmg0cpmgmt_exports.h>

namespace pmg0cpmgmt
{
    class Pmg0AbstractSKURevision;
}
namespace pmg0cpmgmt
{
    class Pmg0AbstractSKURevisionImpl;
}
namespace pmg0cpmgmt
{
    class Pmg0AbstractSKURevisionDelegate;
}
namespace pmg0cpmgmt
{
    class Pmg0AbstractSKURevisionDispatch;
}
namespace pmg0cpmgmt
{
    class Pmg0AbstractSKURevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PMG0CPMGMT_API  pmg0cpmgmt::Pmg0AbstractSKURevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Pmg0AbstractSKURevision();

    /**
     * Destructor
     */
    virtual ~Pmg0AbstractSKURevision();

private:
    //  Getter method for the Implementation Object
    Pmg0AbstractSKURevisionImpl*  getPmg0AbstractSKURevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPmg0AbstractSKURevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Pmg0AbstractSKURevisionImpl*  m_pmg0abstractskurevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Pmg0AbstractSKURevision - desc for Pmg0AbstractSKURevision parameter
     */
    Pmg0AbstractSKURevision( const Pmg0AbstractSKURevision& );
    Pmg0AbstractSKURevision& operator=( const Pmg0AbstractSKURevision& );

    friend class  Pmg0AbstractSKURevisionDelegate;
    friend class  Pmg0AbstractSKURevisionDispatch;
    friend class  Pmg0AbstractSKURevisionGenImpl;
};

#include <pmg0cpmgmt/libpmg0cpmgmt_undef.h>
#endif //   PMG0CPMGMT__PMG0ABSTRACTSKUREVISION__HXX
