//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Pmg0AbstractSKURevisionDelegate
    Filename:   Pmg0AbstractSKURevisionDelegate.hxx
    Module:     pmg0cpmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef PMG0CPMGMT__PMG0ABSTRACTSKUREVISIONDELEGATE_HXX
#define PMG0CPMGMT__PMG0ABSTRACTSKUREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <pmg0cpmgmt/Pmg0AbstractSKURevision.hxx>

#include <pmg0cpmgmt/libpmg0cpmgmt_exports.h>

namespace pmg0cpmgmt
{
    class Pmg0AbstractSKURevisionDelegate;
}
namespace pmg0cpmgmt
{
    class Pmg0AbstractSKURevisionImpl;
}
namespace pmg0cpmgmt
{
    class Pmg0AbstractSKURevision;
}
namespace pmg0cpmgmt
{
    class Pmg0AbstractSKURevisionGenImpl;
}

namespace pmg0cpmgmt_alias = ::pmg0cpmgmt;


class  PMG0CPMGMT_API pmg0cpmgmt_alias::Pmg0AbstractSKURevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Pmg0AbstractSKURevisionDelegate instance
    static Pmg0AbstractSKURevisionDelegate&  getInstance();

    //  Method to create the Pmg0AbstractSKURevisionImpl pointer
    static Pmg0AbstractSKURevisionImpl*  createImpl( Pmg0AbstractSKURevision&  ifObj );

    //  Method to delete the Pmg0AbstractSKURevisionImpl pointer
    static void deleteImpl( Pmg0AbstractSKURevisionImpl*  impl );


    ///
    /// Generic saveAsPost operation.
    /// @version Teamcenter 8.1
    /// @param pSavAsInput - Input argument as SaveAsInput object.
    /// @param vecDeepCopyData - vector deepcopy data
    /// @return - Return integer value.
    ///
    int  saveAsPostBase(const Pmg0AbstractSKURevision &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Pmg0AbstractSKURevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Validate revise input.
    /// @version Teamcenter 10.1
    /// @param pReviseInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - Returns an int.
    ///
    int  validateReviseInputBase(const Pmg0AbstractSKURevision &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// validate saveas input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  validateSaveAsInputBase(const Pmg0AbstractSKURevision &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static Pmg0AbstractSKURevisionDelegate*  m_pInstance;

    Pmg0AbstractSKURevisionDelegate();
    virtual ~Pmg0AbstractSKURevisionDelegate();
    static void setInstance( Pmg0AbstractSKURevisionDelegate*  instance );


private:
    friend class  ::pmg0cpmgmt::Pmg0AbstractSKURevisionGenImpl;

};

#include <pmg0cpmgmt/libpmg0cpmgmt_undef.h>
#endif  //  PMG0CPMGMT__PMG0ABSTRACTSKUREVISIONDELEGATE_HXX
