//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Pmg0DimensionsProvider
    Filename:   Pmg0DimensionsProvider.hxx
    Module:     pmg0cpmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PMG0CPMGMT__PMG0DIMENSIONSPROVIDER__HXX
#define TEAMCENTER__PMG0CPMGMT__PMG0DIMENSIONSPROVIDER__HXX

#include <common/tc_deprecation_macros.h>
#include <tc/Fnd0BaseProvider.hxx>

#include <pmg0cpmgmt/libpmg0cpmgmt_exports.h>

namespace Teamcenter
{
    namespace Pmg0cpmgmt
    {
        class Pmg0DimensionsProvider;
    }
}
namespace Teamcenter
{
    namespace Pmg0cpmgmt
    {
        class Pmg0DimensionsProviderImpl;
    }
}
namespace Teamcenter
{
    namespace Pmg0cpmgmt
    {
        class Pmg0DimensionsProviderDelegate;
    }
}
namespace Teamcenter
{
    namespace Pmg0cpmgmt
    {
        class Pmg0DimensionsProviderDispatch;
    }
}
namespace Teamcenter
{
    namespace Pmg0cpmgmt
    {
        class Pmg0DimensionsProviderGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PMG0CPMGMT_API  Teamcenter::Pmg0cpmgmt::Pmg0DimensionsProvider
     : public  ::Teamcenter::Fnd0BaseProvider
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Pmg0DimensionsProvider();

    /**
     * Destructor
     */
    virtual ~Pmg0DimensionsProvider();

private:
    //  Getter method for the Implementation Object
    Pmg0DimensionsProviderImpl*  getPmg0DimensionsProviderImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPmg0DimensionsProviderImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Pmg0DimensionsProviderImpl*  m_pmg0dimensionsproviderImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Pmg0DimensionsProvider - desc for Pmg0DimensionsProvider parameter
     */
    Pmg0DimensionsProvider( const Pmg0DimensionsProvider& );
    Pmg0DimensionsProvider& operator=( const Pmg0DimensionsProvider& );

    friend class  Pmg0DimensionsProviderDelegate;
    friend class  Pmg0DimensionsProviderDispatch;
    friend class  Pmg0DimensionsProviderGenImpl;
};

#include <pmg0cpmgmt/libpmg0cpmgmt_undef.h>
#endif //   TEAMCENTER__PMG0CPMGMT__PMG0DIMENSIONSPROVIDER__HXX
