//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Pmg0HighLevelSKURevision
    Filename:   Pmg0HighLevelSKURevision.hxx
    Module:     pmg0cpmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PMG0CPMGMT__PMG0HIGHLEVELSKUREVISION__HXX
#define TEAMCENTER__PMG0CPMGMT__PMG0HIGHLEVELSKUREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <pmg0cpmgmt/Pmg0AbstractSKURevision.hxx>

#include <pmg0cpmgmt/libpmg0cpmgmt_exports.h>

namespace Teamcenter
{
    namespace Pmg0cpmgmt
    {
        class Pmg0HighLevelSKURevision;
    }
}
namespace Teamcenter
{
    namespace Pmg0cpmgmt
    {
        class Pmg0HighLevelSKURevisionImpl;
    }
}
namespace Teamcenter
{
    namespace Pmg0cpmgmt
    {
        class Pmg0HighLevelSKURevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace Pmg0cpmgmt
    {
        class Pmg0HighLevelSKURevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace Pmg0cpmgmt
    {
        class Pmg0HighLevelSKURevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PMG0CPMGMT_API  Teamcenter::Pmg0cpmgmt::Pmg0HighLevelSKURevision
     : public  ::pmg0cpmgmt::Pmg0AbstractSKURevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Pmg0HighLevelSKURevision();

    /**
     * Destructor
     */
    virtual ~Pmg0HighLevelSKURevision();

private:
    //  Getter method for the Implementation Object
    Pmg0HighLevelSKURevisionImpl*  getPmg0HighLevelSKURevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPmg0HighLevelSKURevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Pmg0HighLevelSKURevisionImpl*  m_pmg0highlevelskurevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Pmg0HighLevelSKURevision - desc for Pmg0HighLevelSKURevision parameter
     */
    Pmg0HighLevelSKURevision( const Pmg0HighLevelSKURevision& );
    Pmg0HighLevelSKURevision& operator=( const Pmg0HighLevelSKURevision& );

    friend class  Pmg0HighLevelSKURevisionDelegate;
    friend class  Pmg0HighLevelSKURevisionDispatch;
    friend class  Pmg0HighLevelSKURevisionGenImpl;
};

#include <pmg0cpmgmt/libpmg0cpmgmt_undef.h>
#endif //   TEAMCENTER__PMG0CPMGMT__PMG0HIGHLEVELSKUREVISION__HXX
