//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Pmg0ItemSKUProvider
    Filename:   Pmg0ItemSKUProvider.hxx
    Module:     pmg0cpmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PMG0CPMGMT__PMG0ITEMSKUPROVIDER__HXX
#define TEAMCENTER__PMG0CPMGMT__PMG0ITEMSKUPROVIDER__HXX

#include <common/tc_deprecation_macros.h>
#include <tc/Fnd0BaseProvider.hxx>

#include <pmg0cpmgmt/libpmg0cpmgmt_exports.h>

namespace Teamcenter
{
    namespace Pmg0cpmgmt
    {
        class Pmg0ItemSKUProvider;
    }
}
namespace Teamcenter
{
    namespace Pmg0cpmgmt
    {
        class Pmg0ItemSKUProviderImpl;
    }
}
namespace Teamcenter
{
    namespace Pmg0cpmgmt
    {
        class Pmg0ItemSKUProviderDelegate;
    }
}
namespace Teamcenter
{
    namespace Pmg0cpmgmt
    {
        class Pmg0ItemSKUProviderDispatch;
    }
}
namespace Teamcenter
{
    namespace Pmg0cpmgmt
    {
        class Pmg0ItemSKUProviderGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PMG0CPMGMT_API  Teamcenter::Pmg0cpmgmt::Pmg0ItemSKUProvider
     : public  ::Teamcenter::Fnd0BaseProvider
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Pmg0ItemSKUProvider();

    /**
     * Destructor
     */
    virtual ~Pmg0ItemSKUProvider();

private:
    //  Getter method for the Implementation Object
    Pmg0ItemSKUProviderImpl*  getPmg0ItemSKUProviderImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPmg0ItemSKUProviderImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Pmg0ItemSKUProviderImpl*  m_pmg0itemskuproviderImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Pmg0ItemSKUProvider - desc for Pmg0ItemSKUProvider parameter
     */
    Pmg0ItemSKUProvider( const Pmg0ItemSKUProvider& );
    Pmg0ItemSKUProvider& operator=( const Pmg0ItemSKUProvider& );

    friend class  Pmg0ItemSKUProviderDelegate;
    friend class  Pmg0ItemSKUProviderDispatch;
    friend class  Pmg0ItemSKUProviderGenImpl;
};

#include <pmg0cpmgmt/libpmg0cpmgmt_undef.h>
#endif //   TEAMCENTER__PMG0CPMGMT__PMG0ITEMSKUPROVIDER__HXX
