//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Pmg0ItemSKURevision
    Filename:   Pmg0ItemSKURevision.hxx
    Module:     pmg0cpmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PMG0CPMGMT__PMG0ITEMSKUREVISION__HXX
#define TEAMCENTER__PMG0CPMGMT__PMG0ITEMSKUREVISION__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <pmg0cpmgmt/Pmg0AbstractSKURevision.hxx>

#include <pmg0cpmgmt/libpmg0cpmgmt_exports.h>

namespace Teamcenter
{
    namespace Pmg0cpmgmt
    {
        class Pmg0ItemSKURevision;
    }
}
namespace Teamcenter
{
    namespace Pmg0cpmgmt
    {
        class Pmg0ItemSKURevisionImpl;
    }
}
namespace Teamcenter
{
    namespace Pmg0cpmgmt
    {
        class Pmg0ItemSKURevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace Pmg0cpmgmt
    {
        class Pmg0ItemSKURevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace Pmg0cpmgmt
    {
        class Pmg0ItemSKURevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PMG0CPMGMT_API  Teamcenter::Pmg0cpmgmt::Pmg0ItemSKURevision
     : public  ::pmg0cpmgmt::Pmg0AbstractSKURevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPmg0DimensionPairs( std::string &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Pmg0ItemSKURevision();

    /**
     * Destructor
     */
    virtual ~Pmg0ItemSKURevision();

private:
    //  Getter method for the Implementation Object
    Pmg0ItemSKURevisionImpl*  getPmg0ItemSKURevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPmg0ItemSKURevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Pmg0ItemSKURevisionImpl*  m_pmg0itemskurevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Pmg0ItemSKURevision - desc for Pmg0ItemSKURevision parameter
     */
    Pmg0ItemSKURevision( const Pmg0ItemSKURevision& );
    Pmg0ItemSKURevision& operator=( const Pmg0ItemSKURevision& );

    friend class  Pmg0ItemSKURevisionDelegate;
    friend class  Pmg0ItemSKURevisionDispatch;
    friend class  Pmg0ItemSKURevisionGenImpl;
};

#include <pmg0cpmgmt/libpmg0cpmgmt_undef.h>
#endif //   TEAMCENTER__PMG0CPMGMT__PMG0ITEMSKUREVISION__HXX
