//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Pmg0ItemSKURevisionDelegate
    Filename:   Pmg0ItemSKURevisionDelegate.hxx
    Module:     pmg0cpmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PMG0CPMGMT__PMG0ITEMSKUREVISIONDELEGATE_HXX
#define TEAMCENTER__PMG0CPMGMT__PMG0ITEMSKUREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <pmg0cpmgmt/Pmg0ItemSKURevision.hxx>

#include <pmg0cpmgmt/libpmg0cpmgmt_exports.h>

namespace Teamcenter
{
    namespace Pmg0cpmgmt
    {
        class Pmg0ItemSKURevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace Pmg0cpmgmt
    {
        class Pmg0ItemSKURevisionImpl;
    }
}
namespace Teamcenter
{
    namespace Pmg0cpmgmt
    {
        class Pmg0ItemSKURevision;
    }
}
namespace Teamcenter
{
    namespace Pmg0cpmgmt
    {
        class Pmg0ItemSKURevisionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  PMG0CPMGMT_API Teamcenter_alias::Pmg0cpmgmt::Pmg0ItemSKURevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Pmg0ItemSKURevisionDelegate instance
    static Pmg0ItemSKURevisionDelegate&  getInstance();

    //  Method to create the Pmg0ItemSKURevisionImpl pointer
    static Pmg0ItemSKURevisionImpl*  createImpl( Pmg0ItemSKURevision&  ifObj );

    //  Method to delete the Pmg0ItemSKURevisionImpl pointer
    static void deleteImpl( Pmg0ItemSKURevisionImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPmg0DimensionPairsBase(const Pmg0ItemSKURevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Pmg0ItemSKURevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Generic revisePost operation.
    /// @version Teamcenter 10.1
    /// @param pReviseInput - Input ReviseInput object.
    /// @param vecDeepCopyData - Vector of deep copy data.
    /// @return - Returns an integer value.
    ///
    int  revisePostBase(const Pmg0ItemSKURevision &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Pmg0ItemSKURevision &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Pmg0ItemSKURevisionDelegate*  m_pInstance;

    Pmg0ItemSKURevisionDelegate();
    virtual ~Pmg0ItemSKURevisionDelegate();
    static void setInstance( Pmg0ItemSKURevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::Pmg0cpmgmt::Pmg0ItemSKURevisionGenImpl;

};

#include <pmg0cpmgmt/libpmg0cpmgmt_undef.h>
#endif  //  TEAMCENTER__PMG0CPMGMT__PMG0ITEMSKUREVISIONDELEGATE_HXX
