//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Pmg0ProdSaveAsSKUProvider
    Filename:   Pmg0ProdSaveAsSKUProvider.hxx
    Module:     pmg0cpmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef PMG0CPMGMT__PMG0PRODSAVEASSKUPROVIDER__HXX
#define PMG0CPMGMT__PMG0PRODSAVEASSKUPROVIDER__HXX

#include <common/tc_deprecation_macros.h>
#include <pmg0cpmgmt/Pmg0TableViewProvider.hxx>

#include <pmg0cpmgmt/libpmg0cpmgmt_exports.h>

namespace pmg0cpmgmt
{
    class Pmg0ProdSaveAsSKUProvider;
}
namespace pmg0cpmgmt
{
    class Pmg0ProdSaveAsSKUProviderImpl;
}
namespace pmg0cpmgmt
{
    class Pmg0ProdSaveAsSKUProviderDelegate;
}
namespace pmg0cpmgmt
{
    class Pmg0ProdSaveAsSKUProviderDispatch;
}
namespace pmg0cpmgmt
{
    class Pmg0ProdSaveAsSKUProviderGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PMG0CPMGMT_API  pmg0cpmgmt::Pmg0ProdSaveAsSKUProvider
     : public  ::pmg0cpmgmt::Pmg0TableViewProvider
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Pmg0ProdSaveAsSKUProvider();

    /**
     * Destructor
     */
    virtual ~Pmg0ProdSaveAsSKUProvider();

private:
    //  Getter method for the Implementation Object
    Pmg0ProdSaveAsSKUProviderImpl*  getPmg0ProdSaveAsSKUProviderImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPmg0ProdSaveAsSKUProviderImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Pmg0ProdSaveAsSKUProviderImpl*  m_pmg0prodsaveasskuproviderImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Pmg0ProdSaveAsSKUProvider - desc for Pmg0ProdSaveAsSKUProvider parameter
     */
    Pmg0ProdSaveAsSKUProvider( const Pmg0ProdSaveAsSKUProvider& );
    Pmg0ProdSaveAsSKUProvider& operator=( const Pmg0ProdSaveAsSKUProvider& );

    friend class  Pmg0ProdSaveAsSKUProviderDelegate;
    friend class  Pmg0ProdSaveAsSKUProviderDispatch;
    friend class  Pmg0ProdSaveAsSKUProviderGenImpl;
};

#include <pmg0cpmgmt/libpmg0cpmgmt_undef.h>
#endif //   PMG0CPMGMT__PMG0PRODSAVEASSKUPROVIDER__HXX
