//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Pmg0ProdSaveAsSKUProviderDelegate
    Filename:   Pmg0ProdSaveAsSKUProviderDelegate.hxx
    Module:     pmg0cpmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef PMG0CPMGMT__PMG0PRODSAVEASSKUPROVIDERDELEGATE_HXX
#define PMG0CPMGMT__PMG0PRODSAVEASSKUPROVIDERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <pmg0cpmgmt/Pmg0ProdSaveAsSKUProvider.hxx>

#include <pmg0cpmgmt/libpmg0cpmgmt_exports.h>

namespace pmg0cpmgmt
{
    class Pmg0ProdSaveAsSKUProviderDelegate;
}
namespace pmg0cpmgmt
{
    class Pmg0ProdSaveAsSKUProviderImpl;
}
namespace pmg0cpmgmt
{
    class Pmg0ProdSaveAsSKUProvider;
}
namespace pmg0cpmgmt
{
    class Pmg0ProdSaveAsSKUProviderGenImpl;
}

namespace pmg0cpmgmt_alias = ::pmg0cpmgmt;


class  PMG0CPMGMT_API pmg0cpmgmt_alias::Pmg0ProdSaveAsSKUProviderDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Pmg0ProdSaveAsSKUProviderDelegate instance
    static Pmg0ProdSaveAsSKUProviderDelegate&  getInstance();

    //  Method to create the Pmg0ProdSaveAsSKUProviderImpl pointer
    static Pmg0ProdSaveAsSKUProviderImpl*  createImpl( Pmg0ProdSaveAsSKUProvider&  ifObj );

    //  Method to delete the Pmg0ProdSaveAsSKUProviderImpl pointer
    static void deleteImpl( Pmg0ProdSaveAsSKUProviderImpl*  impl );


    ///
    /// This operation returns a structure containing search results, search filters for each search filter field based on the search results, and search filter categories.
    /// @version Teamcenter 9.1.2
    /// @param searchInput - The input to the search
    /// @param searchOutput - The output from the search.
    /// @return - Status. 0 if successful
    ///
    int  fnd0performSearchBase(const Pmg0ProdSaveAsSKUProvider &ifObj,  ::Teamcenter::OperationInput *searchInput, ::Teamcenter::OperationInput *searchOutput );


    ///
    /// 
    /// @version Teamcenter 12.2
    /// @param sourceBO - Defines the Source object for which object needs to be retrieved
    /// @param providerName - Defines the name of the provider
    /// @param tableColumns - Defines method to get logical columns of the table.
    /// @return - 
    ///
    int  pmg0GetTableColumnsBase(const Pmg0ProdSaveAsSKUProvider &ifObj,  tag_t &sourceBO, const std::string &providerName, std::vector<  ::Teamcenter::Pmg0cpmgmt::ColumnInfo > &tableColumns );


    ///
    /// Defines the method to retrieve logical view model properties.
    /// @version Teamcenter 12.2
    /// @param sourceBO - The source business object whose viewModel property should be retrieved.
    /// @param viewModelProperties - Defines the logical view model properties to be defined on source business object.
    /// @param modelObjProps - The model object properties to be returned
    /// @param logicalProps - The list of logical properties to be returned
    /// @return - Logical viewModel properties available on the Business Object.
    ///
    int  pmg0GetViewModelPropertiesBase(const Pmg0ProdSaveAsSKUProvider &ifObj,  const tag_t &sourceBO, std::vector<  ::Teamcenter::Pmg0cpmgmt::ViewModelProperty > &viewModelProperties, std::vector< std::string > &modelObjProps, std::vector< std::string > &logicalProps );



protected:
    //  Pointer to the instance
    static Pmg0ProdSaveAsSKUProviderDelegate*  m_pInstance;

    Pmg0ProdSaveAsSKUProviderDelegate();
    virtual ~Pmg0ProdSaveAsSKUProviderDelegate();
    static void setInstance( Pmg0ProdSaveAsSKUProviderDelegate*  instance );


private:
    friend class  ::pmg0cpmgmt::Pmg0ProdSaveAsSKUProviderGenImpl;

};

#include <pmg0cpmgmt/libpmg0cpmgmt_undef.h>
#endif  //  PMG0CPMGMT__PMG0PRODSAVEASSKUPROVIDERDELEGATE_HXX
