//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Pmg0TableViewProvider
    Filename:   Pmg0TableViewProvider.hxx
    Module:     pmg0cpmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef PMG0CPMGMT__PMG0TABLEVIEWPROVIDER__HXX
#define PMG0CPMGMT__PMG0TABLEVIEWPROVIDER__HXX

#include <unidefs.h>
#include <string>
#include <vector>
#include <pmg0cpmgmt/ColumnInfo.hxx>
#include <pmg0cpmgmt/ViewModelProperty.hxx>
#include <common/tc_deprecation_macros.h>
#include <tc/Fnd0BaseProvider.hxx>

#include <pmg0cpmgmt/libpmg0cpmgmt_exports.h>

namespace pmg0cpmgmt
{
    class Pmg0TableViewProvider;
}
namespace pmg0cpmgmt
{
    class Pmg0TableViewProviderImpl;
}
namespace pmg0cpmgmt
{
    class Pmg0TableViewProviderDelegate;
}
namespace pmg0cpmgmt
{
    class Pmg0TableViewProviderDispatch;
}
namespace pmg0cpmgmt
{
    class Pmg0TableViewProviderGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PMG0CPMGMT_API  pmg0cpmgmt::Pmg0TableViewProvider
     : public  ::Teamcenter::Fnd0BaseProvider
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// 
    /// @version Teamcenter 12.2
    /// @param sourceBO - Defines the Source object for which object needs to be retrieved
    /// @param providerName - Defines the name of the provider
    /// @param tableColumns - Defines method to get logical columns of the table.
    /// @return - 
    ///
    int  pmg0GetTableColumns( tag_t &sourceBO, const std::string &providerName, std::vector<  ::Teamcenter::Pmg0cpmgmt::ColumnInfo > &tableColumns );

    ///
    /// Defines the method to retrieve logical view model properties.
    /// @version Teamcenter 12.2
    /// @param sourceBO - The source business object whose viewModel property should be retrieved.
    /// @param viewModelProperties - Defines the logical view model properties to be defined on source business object.
    /// @param modelObjProps - The model object properties to be returned
    /// @param logicalProps - The list of logical properties to be returned
    /// @return - Logical viewModel properties available on the Business Object.
    ///
    int  pmg0GetViewModelProperties( const tag_t &sourceBO, std::vector<  ::Teamcenter::Pmg0cpmgmt::ViewModelProperty > &viewModelProperties, std::vector< std::string > &modelObjProps, std::vector< std::string > &logicalProps );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Pmg0TableViewProvider();

    /**
     * Destructor
     */
    virtual ~Pmg0TableViewProvider();

private:
    //  Getter method for the Implementation Object
    Pmg0TableViewProviderImpl*  getPmg0TableViewProviderImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPmg0TableViewProviderImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Pmg0TableViewProviderImpl*  m_pmg0tableviewproviderImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Pmg0TableViewProvider - desc for Pmg0TableViewProvider parameter
     */
    Pmg0TableViewProvider( const Pmg0TableViewProvider& );
    Pmg0TableViewProvider& operator=( const Pmg0TableViewProvider& );

    friend class  Pmg0TableViewProviderDelegate;
    friend class  Pmg0TableViewProviderDispatch;
    friend class  Pmg0TableViewProviderGenImpl;
};

#include <pmg0cpmgmt/libpmg0cpmgmt_undef.h>
#endif //   PMG0CPMGMT__PMG0TABLEVIEWPROVIDER__HXX
