//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Pmg0TableViewProviderDelegate
    Filename:   Pmg0TableViewProviderDelegate.hxx
    Module:     pmg0cpmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef PMG0CPMGMT__PMG0TABLEVIEWPROVIDERDELEGATE_HXX
#define PMG0CPMGMT__PMG0TABLEVIEWPROVIDERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <pmg0cpmgmt/Pmg0TableViewProvider.hxx>

#include <pmg0cpmgmt/libpmg0cpmgmt_exports.h>

namespace pmg0cpmgmt
{
    class Pmg0TableViewProviderDelegate;
}
namespace pmg0cpmgmt
{
    class Pmg0TableViewProviderImpl;
}
namespace pmg0cpmgmt
{
    class Pmg0TableViewProvider;
}
namespace pmg0cpmgmt
{
    class Pmg0TableViewProviderGenImpl;
}

namespace pmg0cpmgmt_alias = ::pmg0cpmgmt;


class  PMG0CPMGMT_API pmg0cpmgmt_alias::Pmg0TableViewProviderDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Pmg0TableViewProviderDelegate instance
    static Pmg0TableViewProviderDelegate&  getInstance();

    //  Method to create the Pmg0TableViewProviderImpl pointer
    static Pmg0TableViewProviderImpl*  createImpl( Pmg0TableViewProvider&  ifObj );

    //  Method to delete the Pmg0TableViewProviderImpl pointer
    static void deleteImpl( Pmg0TableViewProviderImpl*  impl );


    ///
    /// 
    /// @version Teamcenter 12.2
    /// @param sourceBO - Defines the Source object for which object needs to be retrieved
    /// @param providerName - Defines the name of the provider
    /// @param tableColumns - Defines method to get logical columns of the table.
    /// @return - 
    ///
    int  pmg0GetTableColumnsBase(const Pmg0TableViewProvider &ifObj,  tag_t &sourceBO, const std::string &providerName, std::vector<  ::Teamcenter::Pmg0cpmgmt::ColumnInfo > &tableColumns );


    ///
    /// Defines the method to retrieve logical view model properties.
    /// @version Teamcenter 12.2
    /// @param sourceBO - The source business object whose viewModel property should be retrieved.
    /// @param viewModelProperties - Defines the logical view model properties to be defined on source business object.
    /// @param modelObjProps - The model object properties to be returned
    /// @param logicalProps - The list of logical properties to be returned
    /// @return - Logical viewModel properties available on the Business Object.
    ///
    int  pmg0GetViewModelPropertiesBase(const Pmg0TableViewProvider &ifObj,  const tag_t &sourceBO, std::vector<  ::Teamcenter::Pmg0cpmgmt::ViewModelProperty > &viewModelProperties, std::vector< std::string > &modelObjProps, std::vector< std::string > &logicalProps );



protected:
    //  Pointer to the instance
    static Pmg0TableViewProviderDelegate*  m_pInstance;

    Pmg0TableViewProviderDelegate();
    virtual ~Pmg0TableViewProviderDelegate();
    static void setInstance( Pmg0TableViewProviderDelegate*  instance );


private:
    friend class  ::pmg0cpmgmt::Pmg0TableViewProviderGenImpl;

};

#include <pmg0cpmgmt/libpmg0cpmgmt_undef.h>
#endif  //  PMG0CPMGMT__PMG0TABLEVIEWPROVIDERDELEGATE_HXX
