//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2019.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*=================================================================================================
File description:
   This file contains the definition for the ViewModelProperty.


    Filename: ViewModelProperty.hxx
    Module  : pmg0cpmgmt
==================================================================================================*/

#ifndef TEAMCENTER__PMG0CPMGMT__VIEWMODELPROPERTY
#define TEAMCENTER__PMG0CPMGMT__VIEWMODELPROPERTY

#include <base_utils/SharedPtr.hxx>
#include <base_utils/TcBaseTypes.hxx>
#include <pmg0cpmgmt/libpmg0cpmgmt_exports.h>

using namespace std;

namespace Teamcenter
{
    namespace Pmg0cpmgmt
    {
        class ViewModelProperty;
    }
}

class PMG0CPMGMT_API Teamcenter::Pmg0cpmgmt::ViewModelProperty
{
    public:

        ViewModelProperty( string propIntName, string propDispName, string propDBVal, string propUIVal, string propDataType, 
                           bool isEditable, bool isModifiable, bool hasLOV, tag_t propParentBO, string lovValueProvider );
        virtual ~ViewModelProperty();


       string  getPropInternalName() const;
       string  getPropDisplayName () const;
       string  getPropDBValue     () const;
       string  getPropUIValue     () const;
       string  getPropDataType    () const;
       string  getLOVValueProvider() const;
       
       bool    getIsEditable      () const;
       bool    getIsModifiable    () const;
       bool    getHasLOV          () const;
       tag_t   getPropParentBO    () const;


    private:
        string m_PropInternalName;
        string m_PropDisplayName;
        string m_PropDBValue;
        string m_PropUIValue;
        string m_PropDataType;
        string m_LOVValueProvider;
        bool   m_IsEditable;
        bool   m_IsModifiable;
        bool   m_HasLOV;
        tag_t  m_PropParentBO;
    


};

#include <pmg0cpmgmt/libpmg0cpmgmt_undef.h>
#endif // TEAMCENTER__PMG0CPMGMT__VIEWMODELPROPERTY
