//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  pmidispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libpmidispatch

#if !defined(LIBPMIDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBPMIDISPATCH is not defined
#endif

/* Handwritten code should use PMIDISPATCH_API, not PMIDISPATCHEXPORT */

#define PMIDISPATCH_API PMIDISPATCHEXPORT

#if IPLIB==libpmidispatch || defined(LIBPMIDISPATCH)
#   if defined(__lint)
#       define PMIDISPATCHEXPORT       __export(pmidispatch)
#       define PMIDISPATCHGLOBAL       extern __global(pmidispatch)
#       define PMIDISPATCHPRIVATE      extern __private(pmidispatch)
#   elif defined(_WIN32)
#       define PMIDISPATCHEXPORT       __declspec(dllexport)
#       define PMIDISPATCHGLOBAL       extern __declspec(dllexport)
#       define PMIDISPATCHPRIVATE      extern
#   else
#       define PMIDISPATCHEXPORT
#       define PMIDISPATCHGLOBAL       extern
#       define PMIDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define PMIDISPATCHEXPORT       __export(pmidispatch)
#       define PMIDISPATCHGLOBAL       extern __global(pmidispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define PMIDISPATCHEXPORT      __declspec(dllimport)
#       define PMIDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define PMIDISPATCHEXPORT
#       define PMIDISPATCHGLOBAL       extern
#   endif
#endif
