//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Prg0AbsCriteria
    Filename:   Prg0AbsCriteria.hxx
    Module:     prg0programinfra
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROGRAMINFRA__PRG0PROGRAMINFRA__PRG0ABSCRITERIA__HXX
#define TEAMCENTER__PROGRAMINFRA__PRG0PROGRAMINFRA__PRG0ABSCRITERIA__HXX

#include <common/tc_deprecation_macros.h>
#include <fnd0absactionitem/Fnd0AbsActionItem.hxx>

#include <prg0programinfra/libprg0programinfra_exports.h>

namespace Teamcenter
{
    namespace ProgramInfra
    {
        namespace prg0programinfra
        {
            class Prg0AbsCriteria;
        }
    }
}
namespace Teamcenter
{
    namespace ProgramInfra
    {
        namespace prg0programinfra
        {
            class Prg0AbsCriteriaImpl;
        }
    }
}
namespace Teamcenter
{
    namespace ProgramInfra
    {
        namespace prg0programinfra
        {
            class Prg0AbsCriteriaDelegate;
        }
    }
}
namespace Teamcenter
{
    namespace ProgramInfra
    {
        namespace prg0programinfra
        {
            class Prg0AbsCriteriaDispatch;
        }
    }
}
namespace Teamcenter
{
    namespace ProgramInfra
    {
        namespace prg0programinfra
        {
            class Prg0AbsCriteriaGenImpl;
        }
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PRG0PROGRAMINFRA_API  Teamcenter::ProgramInfra::prg0programinfra::Prg0AbsCriteria
     : public  ::Teamcenter::Fnd0AbsActionItem
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Prg0AbsCriteria();

    /**
     * Destructor
     */
    virtual ~Prg0AbsCriteria();

private:
    //  Getter method for the Implementation Object
    Prg0AbsCriteriaImpl*  getPrg0AbsCriteriaImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPrg0AbsCriteriaImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Prg0AbsCriteriaImpl*  m_prg0abscriteriaImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Prg0AbsCriteria - desc for Prg0AbsCriteria parameter
     */
    Prg0AbsCriteria( const Prg0AbsCriteria& );
    Prg0AbsCriteria& operator=( const Prg0AbsCriteria& );

    friend class  Prg0AbsCriteriaDelegate;
    friend class  Prg0AbsCriteriaDispatch;
    friend class  Prg0AbsCriteriaGenImpl;
};

#include <prg0programinfra/libprg0programinfra_undef.h>
#endif //   TEAMCENTER__PROGRAMINFRA__PRG0PROGRAMINFRA__PRG0ABSCRITERIA__HXX
