//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Prg0AbsCriteriaDelegate
    Filename:   Prg0AbsCriteriaDelegate.hxx
    Module:     prg0programinfra
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROGRAMINFRA__PRG0PROGRAMINFRA__PRG0ABSCRITERIADELEGATE_HXX
#define TEAMCENTER__PROGRAMINFRA__PRG0PROGRAMINFRA__PRG0ABSCRITERIADELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <prg0programinfra/Prg0AbsCriteria.hxx>

#include <prg0programinfra/libprg0programinfra_exports.h>

namespace Teamcenter
{
    namespace ProgramInfra
    {
        namespace prg0programinfra
        {
            class Prg0AbsCriteriaDelegate;
        }
    }
}
namespace Teamcenter
{
    namespace ProgramInfra
    {
        namespace prg0programinfra
        {
            class Prg0AbsCriteriaImpl;
        }
    }
}
namespace Teamcenter
{
    namespace ProgramInfra
    {
        namespace prg0programinfra
        {
            class Prg0AbsCriteria;
        }
    }
}
namespace Teamcenter
{
    namespace ProgramInfra
    {
        namespace prg0programinfra
        {
            class Prg0AbsCriteriaGenImpl;
        }
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  PRG0PROGRAMINFRA_API Teamcenter_alias::ProgramInfra::prg0programinfra::Prg0AbsCriteriaDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Prg0AbsCriteriaDelegate instance
    static Prg0AbsCriteriaDelegate&  getInstance();

    //  Method to create the Prg0AbsCriteriaImpl pointer
    static Prg0AbsCriteriaImpl*  createImpl( Prg0AbsCriteria&  ifObj );

    //  Method to delete the Prg0AbsCriteriaImpl pointer
    static void deleteImpl( Prg0AbsCriteriaImpl*  impl );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Prg0AbsCriteria &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// finalize operation input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  finalizeSaveAsInputBase(const Prg0AbsCriteria &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// Generic saveAsPost operation.
    /// @version Teamcenter 8.1
    /// @param pSavAsInput - Input argument as SaveAsInput object.
    /// @param vecDeepCopyData - vector deepcopy data
    /// @return - Return integer value.
    ///
    int  saveAsPostBase(const Prg0AbsCriteria &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Prg0AbsCriteria &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Prg0AbsCriteriaDelegate*  m_pInstance;

    Prg0AbsCriteriaDelegate();
    virtual ~Prg0AbsCriteriaDelegate();
    static void setInstance( Prg0AbsCriteriaDelegate*  instance );


private:
    friend class  ::Teamcenter::ProgramInfra::prg0programinfra::Prg0AbsCriteriaGenImpl;

};

#include <prg0programinfra/libprg0programinfra_undef.h>
#endif  //  TEAMCENTER__PROGRAMINFRA__PRG0PROGRAMINFRA__PRG0ABSCRITERIADELEGATE_HXX
