//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Prg0AbsEventDelegate
    Filename:   Prg0AbsEventDelegate.hxx
    Module:     prg0programinfra
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROGRAMINFRA__PRG0PROGRAMINFRA__PRG0ABSEVENTDELEGATE_HXX
#define TEAMCENTER__PROGRAMINFRA__PRG0PROGRAMINFRA__PRG0ABSEVENTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <prg0programinfra/Prg0AbsEvent.hxx>

#include <prg0programinfra/libprg0programinfra_exports.h>

namespace Teamcenter
{
    namespace ProgramInfra
    {
        namespace prg0programinfra
        {
            class Prg0AbsEventDelegate;
        }
    }
}
namespace Teamcenter
{
    namespace ProgramInfra
    {
        namespace prg0programinfra
        {
            class Prg0AbsEventImpl;
        }
    }
}
namespace Teamcenter
{
    namespace ProgramInfra
    {
        namespace prg0programinfra
        {
            class Prg0AbsEvent;
        }
    }
}
namespace Teamcenter
{
    namespace ProgramInfra
    {
        namespace prg0programinfra
        {
            class Prg0AbsEventGenImpl;
        }
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  PRG0PROGRAMINFRA_API Teamcenter_alias::ProgramInfra::prg0programinfra::Prg0AbsEventDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Prg0AbsEventDelegate instance
    static Prg0AbsEventDelegate&  getInstance();

    //  Method to create the Prg0AbsEventImpl pointer
    static Prg0AbsEventImpl*  createImpl( Prg0AbsEvent&  ifObj );

    //  Method to delete the Prg0AbsEventImpl pointer
    static void deleteImpl( Prg0AbsEventImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.2.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getPrg0AssociatedCriteriaBase(const Prg0AbsEvent &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Prg0AbsEvent &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// finalize operation input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  finalizeSaveAsInputBase(const Prg0AbsEvent &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// Generic saveAsPost operation.
    /// @version Teamcenter 8.1
    /// @param pSavAsInput - Input argument as SaveAsInput object.
    /// @param vecDeepCopyData - vector deepcopy data
    /// @return - Return integer value.
    ///
    int  saveAsPostBase(const Prg0AbsEvent &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Prg0AbsEvent &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Prg0AbsEventDelegate*  m_pInstance;

    Prg0AbsEventDelegate();
    virtual ~Prg0AbsEventDelegate();
    static void setInstance( Prg0AbsEventDelegate*  instance );


private:
    friend class  ::Teamcenter::ProgramInfra::prg0programinfra::Prg0AbsEventGenImpl;

};

#include <prg0programinfra/libprg0programinfra_undef.h>
#endif  //  TEAMCENTER__PROGRAMINFRA__PRG0PROGRAMINFRA__PRG0ABSEVENTDELEGATE_HXX
