//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Prg0AbsPlan
    Filename:   Prg0AbsPlan.hxx
    Module:     prg0programinfra
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROGRAMINFRA__PRG0PROGRAMINFRA__PRG0ABSPLAN__HXX
#define TEAMCENTER__PROGRAMINFRA__PRG0PROGRAMINFRA__PRG0ABSPLAN__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <prg0programinfra/libprg0programinfra_exports.h>

namespace Teamcenter
{
    namespace ProgramInfra
    {
        namespace prg0programinfra
        {
            class Prg0AbsPlan;
        }
    }
}
namespace Teamcenter
{
    namespace ProgramInfra
    {
        namespace prg0programinfra
        {
            class Prg0AbsPlanImpl;
        }
    }
}
namespace Teamcenter
{
    namespace ProgramInfra
    {
        namespace prg0programinfra
        {
            class Prg0AbsPlanDelegate;
        }
    }
}
namespace Teamcenter
{
    namespace ProgramInfra
    {
        namespace prg0programinfra
        {
            class Prg0AbsPlanDispatch;
        }
    }
}
namespace Teamcenter
{
    namespace ProgramInfra
    {
        namespace prg0programinfra
        {
            class Prg0AbsPlanGenImpl;
        }
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PRG0PROGRAMINFRA_API  Teamcenter::ProgramInfra::prg0programinfra::Prg0AbsPlan
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.2.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPrg0AllowedChildTypes( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.2.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPrg0AllowsChildren( bool &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Prg0AbsPlan();

    /**
     * Destructor
     */
    virtual ~Prg0AbsPlan();

private:
    //  Getter method for the Implementation Object
    Prg0AbsPlanImpl*  getPrg0AbsPlanImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPrg0AbsPlanImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Prg0AbsPlanImpl*  m_prg0absplanImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Prg0AbsPlan - desc for Prg0AbsPlan parameter
     */
    Prg0AbsPlan( const Prg0AbsPlan& );
    Prg0AbsPlan& operator=( const Prg0AbsPlan& );

    friend class  Prg0AbsPlanDelegate;
    friend class  Prg0AbsPlanDispatch;
    friend class  Prg0AbsPlanGenImpl;
};

#include <prg0programinfra/libprg0programinfra_undef.h>
#endif //   TEAMCENTER__PROGRAMINFRA__PRG0PROGRAMINFRA__PRG0ABSPLAN__HXX
