//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Prg0AbsPlanDelegate
    Filename:   Prg0AbsPlanDelegate.hxx
    Module:     prg0programinfra
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROGRAMINFRA__PRG0PROGRAMINFRA__PRG0ABSPLANDELEGATE_HXX
#define TEAMCENTER__PROGRAMINFRA__PRG0PROGRAMINFRA__PRG0ABSPLANDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <prg0programinfra/Prg0AbsPlan.hxx>

#include <prg0programinfra/libprg0programinfra_exports.h>

namespace Teamcenter
{
    namespace ProgramInfra
    {
        namespace prg0programinfra
        {
            class Prg0AbsPlanDelegate;
        }
    }
}
namespace Teamcenter
{
    namespace ProgramInfra
    {
        namespace prg0programinfra
        {
            class Prg0AbsPlanImpl;
        }
    }
}
namespace Teamcenter
{
    namespace ProgramInfra
    {
        namespace prg0programinfra
        {
            class Prg0AbsPlan;
        }
    }
}
namespace Teamcenter
{
    namespace ProgramInfra
    {
        namespace prg0programinfra
        {
            class Prg0AbsPlanGenImpl;
        }
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  PRG0PROGRAMINFRA_API Teamcenter_alias::ProgramInfra::prg0programinfra::Prg0AbsPlanDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Prg0AbsPlanDelegate instance
    static Prg0AbsPlanDelegate&  getInstance();

    //  Method to create the Prg0AbsPlanImpl pointer
    static Prg0AbsPlanImpl*  createImpl( Prg0AbsPlan&  ifObj );

    //  Method to delete the Prg0AbsPlanImpl pointer
    static void deleteImpl( Prg0AbsPlanImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.2.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPrg0AllowedChildTypesBase(const Prg0AbsPlan &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.2.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPrg0AllowsChildrenBase(const Prg0AbsPlan &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Prg0AbsPlan &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// finalize operation input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  finalizeSaveAsInputBase(const Prg0AbsPlan &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// Generic saveAsPost operation.
    /// @version Teamcenter 8.1
    /// @param pSavAsInput - Input argument as SaveAsInput object.
    /// @param vecDeepCopyData - vector deepcopy data
    /// @return - Return integer value.
    ///
    int  saveAsPostBase(const Prg0AbsPlan &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Prg0AbsPlan &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Prg0AbsPlanDelegate*  m_pInstance;

    Prg0AbsPlanDelegate();
    virtual ~Prg0AbsPlanDelegate();
    static void setInstance( Prg0AbsPlanDelegate*  instance );


private:
    friend class  ::Teamcenter::ProgramInfra::prg0programinfra::Prg0AbsPlanGenImpl;

};

#include <prg0programinfra/libprg0programinfra_undef.h>
#endif  //  TEAMCENTER__PROGRAMINFRA__PRG0PROGRAMINFRA__PRG0ABSPLANDELEGATE_HXX
