//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Prg0AbsProgramPlan
    Filename:   Prg0AbsProgramPlan.hxx
    Module:     prg0programinfra
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROGRAMINFRA__PRG0PROGRAMINFRA__PRG0ABSPROGRAMPLAN__HXX
#define TEAMCENTER__PROGRAMINFRA__PRG0PROGRAMINFRA__PRG0ABSPROGRAMPLAN__HXX

#include <common/tc_deprecation_macros.h>
#include <prg0programinfra/Prg0AbsPlan.hxx>

#include <prg0programinfra/libprg0programinfra_exports.h>

namespace Teamcenter
{
    namespace ProgramInfra
    {
        namespace prg0programinfra
        {
            class Prg0AbsProgramPlan;
        }
    }
}
namespace Teamcenter
{
    namespace ProgramInfra
    {
        namespace prg0programinfra
        {
            class Prg0AbsProgramPlanImpl;
        }
    }
}
namespace Teamcenter
{
    namespace ProgramInfra
    {
        namespace prg0programinfra
        {
            class Prg0AbsProgramPlanDelegate;
        }
    }
}
namespace Teamcenter
{
    namespace ProgramInfra
    {
        namespace prg0programinfra
        {
            class Prg0AbsProgramPlanDispatch;
        }
    }
}
namespace Teamcenter
{
    namespace ProgramInfra
    {
        namespace prg0programinfra
        {
            class Prg0AbsProgramPlanGenImpl;
        }
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PRG0PROGRAMINFRA_API  Teamcenter::ProgramInfra::prg0programinfra::Prg0AbsProgramPlan
     : public  ::Teamcenter::ProgramInfra::prg0programinfra::Prg0AbsPlan
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Prg0AbsProgramPlan();

    /**
     * Destructor
     */
    virtual ~Prg0AbsProgramPlan();

private:
    //  Getter method for the Implementation Object
    Prg0AbsProgramPlanImpl*  getPrg0AbsProgramPlanImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPrg0AbsProgramPlanImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Prg0AbsProgramPlanImpl*  m_prg0absprogramplanImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Prg0AbsProgramPlan - desc for Prg0AbsProgramPlan parameter
     */
    Prg0AbsProgramPlan( const Prg0AbsProgramPlan& );
    Prg0AbsProgramPlan& operator=( const Prg0AbsProgramPlan& );

    friend class  Prg0AbsProgramPlanDelegate;
    friend class  Prg0AbsProgramPlanDispatch;
    friend class  Prg0AbsProgramPlanGenImpl;
};

#include <prg0programinfra/libprg0programinfra_undef.h>
#endif //   TEAMCENTER__PROGRAMINFRA__PRG0PROGRAMINFRA__PRG0ABSPROGRAMPLAN__HXX
