//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Prg0AbsProgramPlanDelegate
    Filename:   Prg0AbsProgramPlanDelegate.hxx
    Module:     prg0programinfra
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROGRAMINFRA__PRG0PROGRAMINFRA__PRG0ABSPROGRAMPLANDELEGATE_HXX
#define TEAMCENTER__PROGRAMINFRA__PRG0PROGRAMINFRA__PRG0ABSPROGRAMPLANDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <prg0programinfra/Prg0AbsProgramPlan.hxx>

#include <prg0programinfra/libprg0programinfra_exports.h>

namespace Teamcenter
{
    namespace ProgramInfra
    {
        namespace prg0programinfra
        {
            class Prg0AbsProgramPlanDelegate;
        }
    }
}
namespace Teamcenter
{
    namespace ProgramInfra
    {
        namespace prg0programinfra
        {
            class Prg0AbsProgramPlanImpl;
        }
    }
}
namespace Teamcenter
{
    namespace ProgramInfra
    {
        namespace prg0programinfra
        {
            class Prg0AbsProgramPlan;
        }
    }
}
namespace Teamcenter
{
    namespace ProgramInfra
    {
        namespace prg0programinfra
        {
            class Prg0AbsProgramPlanGenImpl;
        }
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  PRG0PROGRAMINFRA_API Teamcenter_alias::ProgramInfra::prg0programinfra::Prg0AbsProgramPlanDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Prg0AbsProgramPlanDelegate instance
    static Prg0AbsProgramPlanDelegate&  getInstance();

    //  Method to create the Prg0AbsProgramPlanImpl pointer
    static Prg0AbsProgramPlanImpl*  createImpl( Prg0AbsProgramPlan&  ifObj );

    //  Method to delete the Prg0AbsProgramPlanImpl pointer
    static void deleteImpl( Prg0AbsProgramPlanImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Prg0AbsProgramPlan &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Prg0AbsProgramPlanDelegate*  m_pInstance;

    Prg0AbsProgramPlanDelegate();
    virtual ~Prg0AbsProgramPlanDelegate();
    static void setInstance( Prg0AbsProgramPlanDelegate*  instance );


private:
    friend class  ::Teamcenter::ProgramInfra::prg0programinfra::Prg0AbsProgramPlanGenImpl;

};

#include <prg0programinfra/libprg0programinfra_undef.h>
#endif  //  TEAMCENTER__PROGRAMINFRA__PRG0PROGRAMINFRA__PRG0ABSPROGRAMPLANDELEGATE_HXX
