//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Prg0AttachmentDelegate
    Filename:   Prg0AttachmentDelegate.hxx
    Module:     prg0programinfra
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROGRAMINFRA__PRG0PROGRAMINFRA__PRG0ATTACHMENTDELEGATE_HXX
#define TEAMCENTER__PROGRAMINFRA__PRG0PROGRAMINFRA__PRG0ATTACHMENTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <prg0programinfra/Prg0Attachment.hxx>

#include <prg0programinfra/libprg0programinfra_exports.h>

namespace Teamcenter
{
    namespace ProgramInfra
    {
        namespace prg0programinfra
        {
            class Prg0AttachmentDelegate;
        }
    }
}
namespace Teamcenter
{
    namespace ProgramInfra
    {
        namespace prg0programinfra
        {
            class Prg0AttachmentImpl;
        }
    }
}
namespace Teamcenter
{
    namespace ProgramInfra
    {
        namespace prg0programinfra
        {
            class Prg0Attachment;
        }
    }
}
namespace Teamcenter
{
    namespace ProgramInfra
    {
        namespace prg0programinfra
        {
            class Prg0AttachmentGenImpl;
        }
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  PRG0PROGRAMINFRA_API Teamcenter_alias::ProgramInfra::prg0programinfra::Prg0AttachmentDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Prg0AttachmentDelegate instance
    static Prg0AttachmentDelegate&  getInstance();

    //  Method to create the Prg0AttachmentImpl pointer
    static Prg0AttachmentImpl*  createImpl( Prg0Attachment&  ifObj );

    //  Method to delete the Prg0AttachmentImpl pointer
    static void deleteImpl( Prg0AttachmentImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static Prg0AttachmentDelegate*  m_pInstance;

    Prg0AttachmentDelegate();
    virtual ~Prg0AttachmentDelegate();
    static void setInstance( Prg0AttachmentDelegate*  instance );


private:
    friend class  ::Teamcenter::ProgramInfra::prg0programinfra::Prg0AttachmentGenImpl;

};

#include <prg0programinfra/libprg0programinfra_undef.h>
#endif  //  TEAMCENTER__PROGRAMINFRA__PRG0PROGRAMINFRA__PRG0ATTACHMENTDELEGATE_HXX
