//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Prg0ProductContent
    Filename:   Prg0ProductContent.hxx
    Module:     prg0programinfra
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROGRAMINFRA__PRG0PROGRAMINFRA__PRG0PRODUCTCONTENT__HXX
#define TEAMCENTER__PROGRAMINFRA__PRG0PROGRAMINFRA__PRG0PRODUCTCONTENT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <prg0programinfra/libprg0programinfra_exports.h>

namespace Teamcenter
{
    namespace ProgramInfra
    {
        namespace prg0programinfra
        {
            class Prg0ProductContent;
        }
    }
}
namespace Teamcenter
{
    namespace ProgramInfra
    {
        namespace prg0programinfra
        {
            class Prg0ProductContentImpl;
        }
    }
}
namespace Teamcenter
{
    namespace ProgramInfra
    {
        namespace prg0programinfra
        {
            class Prg0ProductContentDelegate;
        }
    }
}
namespace Teamcenter
{
    namespace ProgramInfra
    {
        namespace prg0programinfra
        {
            class Prg0ProductContentDispatch;
        }
    }
}
namespace Teamcenter
{
    namespace ProgramInfra
    {
        namespace prg0programinfra
        {
            class Prg0ProductContentGenImpl;
        }
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PRG0PROGRAMINFRA_API  Teamcenter::ProgramInfra::prg0programinfra::Prg0ProductContent
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Prg0ProductContent();

    /**
     * Destructor
     */
    virtual ~Prg0ProductContent();

private:
    //  Getter method for the Implementation Object
    Prg0ProductContentImpl*  getPrg0ProductContentImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPrg0ProductContentImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Prg0ProductContentImpl*  m_prg0productcontentImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Prg0ProductContent - desc for Prg0ProductContent parameter
     */
    Prg0ProductContent( const Prg0ProductContent& );
    Prg0ProductContent& operator=( const Prg0ProductContent& );

    friend class  Prg0ProductContentDelegate;
    friend class  Prg0ProductContentDispatch;
    friend class  Prg0ProductContentGenImpl;
};

#include <prg0programinfra/libprg0programinfra_undef.h>
#endif //   TEAMCENTER__PROGRAMINFRA__PRG0PROGRAMINFRA__PRG0PRODUCTCONTENT__HXX
