//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Prg0TargetParentPlans
    Filename:   Prg0TargetParentPlans.hxx
    Module:     prg0programinfra
    @BMIDE autogenerated
==================================================================================================*/

#ifndef PRG0PROGRAMINFRA__PRG0TARGETPARENTPLANS__HXX
#define PRG0PROGRAMINFRA__PRG0TARGETPARENTPLANS__HXX

#include <common/tc_deprecation_macros.h>
#include <lov/Fnd0ListOfValuesDynamic.hxx>

#include <prg0programinfra/libprg0programinfra_exports.h>

namespace prg0programinfra
{
    class Prg0TargetParentPlans;
}
namespace prg0programinfra
{
    class Prg0TargetParentPlansImpl;
}
namespace prg0programinfra
{
    class Prg0TargetParentPlansDelegate;
}
namespace prg0programinfra
{
    class Prg0TargetParentPlansDispatch;
}
namespace prg0programinfra
{
    class Prg0TargetParentPlansGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PRG0PROGRAMINFRA_API  prg0programinfra::Prg0TargetParentPlans
     : public  ::Teamcenter::Fnd0ListOfValuesDynamic
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Prg0TargetParentPlans();

    /**
     * Destructor
     */
    virtual ~Prg0TargetParentPlans();

private:
    //  Getter method for the Implementation Object
    Prg0TargetParentPlansImpl*  getPrg0TargetParentPlansImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPrg0TargetParentPlansImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Prg0TargetParentPlansImpl*  m_prg0targetparentplansImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Prg0TargetParentPlans - desc for Prg0TargetParentPlans parameter
     */
    Prg0TargetParentPlans( const Prg0TargetParentPlans& );
    Prg0TargetParentPlans& operator=( const Prg0TargetParentPlans& );

    friend class  Prg0TargetParentPlansDelegate;
    friend class  Prg0TargetParentPlansDispatch;
    friend class  Prg0TargetParentPlansGenImpl;
};

#include <prg0programinfra/libprg0programinfra_undef.h>
#endif //   PRG0PROGRAMINFRA__PRG0TARGETPARENTPLANS__HXX
