//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  prg0programinfra

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libprg0programinfra

#if !defined(LIBPRG0PROGRAMINFRA) && !defined(IPLIB)
#   error IPLIB or LIBPRG0PROGRAMINFRA is not defined
#endif

/* Handwritten code should use PRG0PROGRAMINFRA_API, not PRG0PROGRAMINFRAEXPORT */

#define PRG0PROGRAMINFRA_API PRG0PROGRAMINFRAEXPORT

#if IPLIB==libprg0programinfra || defined(LIBPRG0PROGRAMINFRA)
#   if defined(__lint)
#       define PRG0PROGRAMINFRAEXPORT       __export(prg0programinfra)
#       define PRG0PROGRAMINFRAGLOBAL       extern __global(prg0programinfra)
#       define PRG0PROGRAMINFRAPRIVATE      extern __private(prg0programinfra)
#   elif defined(_WIN32)
#       define PRG0PROGRAMINFRAEXPORT       __declspec(dllexport)
#       define PRG0PROGRAMINFRAGLOBAL       extern __declspec(dllexport)
#       define PRG0PROGRAMINFRAPRIVATE      extern
#   else
#       define PRG0PROGRAMINFRAEXPORT
#       define PRG0PROGRAMINFRAGLOBAL       extern
#       define PRG0PROGRAMINFRAPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define PRG0PROGRAMINFRAEXPORT       __export(prg0programinfra)
#       define PRG0PROGRAMINFRAGLOBAL       extern __global(prg0programinfra)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define PRG0PROGRAMINFRAEXPORT      __declspec(dllimport)
#       define PRG0PROGRAMINFRAGLOBAL       extern __declspec(dllimport)
#   else
#       define PRG0PROGRAMINFRAEXPORT
#       define PRG0PROGRAMINFRAGLOBAL       extern
#   endif
#endif
