//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  prg0programinfradispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libprg0programinfradispatch

#if !defined(LIBPRG0PROGRAMINFRADISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBPRG0PROGRAMINFRADISPATCH is not defined
#endif

/* Handwritten code should use PRG0PROGRAMINFRADISPATCH_API, not PRG0PROGRAMINFRADISPATCHEXPORT */

#define PRG0PROGRAMINFRADISPATCH_API PRG0PROGRAMINFRADISPATCHEXPORT

#if IPLIB==libprg0programinfradispatch || defined(LIBPRG0PROGRAMINFRADISPATCH)
#   if defined(__lint)
#       define PRG0PROGRAMINFRADISPATCHEXPORT       __export(prg0programinfradispatch)
#       define PRG0PROGRAMINFRADISPATCHGLOBAL       extern __global(prg0programinfradispatch)
#       define PRG0PROGRAMINFRADISPATCHPRIVATE      extern __private(prg0programinfradispatch)
#   elif defined(_WIN32)
#       define PRG0PROGRAMINFRADISPATCHEXPORT       __declspec(dllexport)
#       define PRG0PROGRAMINFRADISPATCHGLOBAL       extern __declspec(dllexport)
#       define PRG0PROGRAMINFRADISPATCHPRIVATE      extern
#   else
#       define PRG0PROGRAMINFRADISPATCHEXPORT
#       define PRG0PROGRAMINFRADISPATCHGLOBAL       extern
#       define PRG0PROGRAMINFRADISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define PRG0PROGRAMINFRADISPATCHEXPORT       __export(prg0programinfradispatch)
#       define PRG0PROGRAMINFRADISPATCHGLOBAL       extern __global(prg0programinfradispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define PRG0PROGRAMINFRADISPATCHEXPORT      __declspec(dllimport)
#       define PRG0PROGRAMINFRADISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define PRG0PROGRAMINFRADISPATCHEXPORT
#       define PRG0PROGRAMINFRADISPATCHGLOBAL       extern
#   endif
#endif
