//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Prg0AbsPlan
    Filename:   Prg0AbsPlanExt.hxx
    Module:     prg1programplanningapp
    @BMIDE autogenerated
==================================================================================================*/

#ifndef PRG1__PRG1PROGRAMPLANNINGAPP__PRG0ABSPLAN__HXX
#define PRG1__PRG1PROGRAMPLANNINGAPP__PRG0ABSPLAN__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <metaframework/BusinessObjectExtender.hxx>
#include <metaframework/BusinessObjectExtenderRef.hxx>
#include <metaframework/BusinessObjectExtenderRegistry.hxx>

#include <prg1programplanningapp/libprg1programplanningapp_exports.h>

namespace prg1
{
    namespace Prg1ProgramPlanningApp
    {
        class Prg0AbsPlan;
    }
}
namespace prg1
{
    namespace Prg1ProgramPlanningApp
    {
        class Prg0AbsPlanImpl;
    }
}
namespace prg1
{
    namespace Prg1ProgramPlanningApp
    {
        class Prg0AbsPlanDelegate;
    }
}
namespace prg1
{
    namespace Prg1ProgramPlanningApp
    {
        class Prg0AbsPlanDispatch;
    }
}
namespace prg1
{
    namespace Prg1ProgramPlanningApp
    {
        class Prg0AbsPlanGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PRG1PROGRAMPLANNINGAPP_API  prg1::Prg1ProgramPlanningApp::Prg0AbsPlan
     : public  ::Teamcenter::BusinessObjectExtender
{
public:

    /**
     * Constructor
     */
    Prg0AbsPlan( tag_t  objTag );
    /**
     * Get the Extender Registry
     * @return - return Extender Registry
     */
    static ::Teamcenter::BusinessObjectExtenderRegistry< prg1::Prg1ProgramPlanningApp::Prg0AbsPlan >&  extenderRegistry();

    /**
     * Get the Extender Interface Name
     * @return - return desc for getExtenderInterfaceName
     */
    static const std::string&  getExtenderInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPrg1PlanFeature( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.5
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPrg1PlanFeature( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );


    /**
     * Destructor
     */
    virtual ~Prg0AbsPlan();

private:
    //  Getter method for the Implementation Object
    Prg0AbsPlanImpl*  getPrg0AbsPlanImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPrg0AbsPlanImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Prg0AbsPlanImpl*  m_prg0absplanImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Prg0AbsPlan - desc for Prg0AbsPlan parameter
     */
    Prg0AbsPlan( const Prg0AbsPlan& );
    Prg0AbsPlan& operator=( const Prg0AbsPlan& );

    friend class  Prg0AbsPlanDelegate;
    friend class  Prg0AbsPlanDispatch;
    friend class  Prg0AbsPlanGenImpl;
};

#include <prg1programplanningapp/libprg1programplanningapp_undef.h>
#endif //   PRG1__PRG1PROGRAMPLANNINGAPP__PRG0ABSPLAN__HXX
