//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Prg1AbsPtnBaseTargetElement
    Filename:   Prg1AbsPtnBaseTargetElement.hxx
    Module:     prg1programplanningapp
    @BMIDE autogenerated
==================================================================================================*/

#ifndef PRG1PROGRAMPLANNINGAPP__PRG1ABSPTNBASETARGETELEMENT__HXX
#define PRG1PROGRAMPLANNINGAPP__PRG1ABSPTNBASETARGETELEMENT__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tgm0targetmgmt/Tgm0AbsTargetElement.hxx>

#include <prg1programplanningapp/libprg1programplanningapp_exports.h>

namespace Prg1ProgramPlanningApp
{
    class Prg1AbsPtnBaseTargetElement;
}
namespace Prg1ProgramPlanningApp
{
    class Prg1AbsPtnBaseTargetElementImpl;
}
namespace Prg1ProgramPlanningApp
{
    class Prg1AbsPtnBaseTargetElementDelegate;
}
namespace Prg1ProgramPlanningApp
{
    class Prg1AbsPtnBaseTargetElementDispatch;
}
namespace Prg1ProgramPlanningApp
{
    class Prg1AbsPtnBaseTargetElementGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PRG1PROGRAMPLANNINGAPP_API  Prg1ProgramPlanningApp::Prg1AbsPtnBaseTargetElement
     : public  ::Teamcenter::Tgm0TargetMgmt::Tgm0AbsTargetElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPrg1Feature( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPrg1Model( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.5
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPrg1Feature( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Prg1AbsPtnBaseTargetElement();

    /**
     * Destructor
     */
    virtual ~Prg1AbsPtnBaseTargetElement();

private:
    //  Getter method for the Implementation Object
    Prg1AbsPtnBaseTargetElementImpl*  getPrg1AbsPtnBaseTargetElementImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPrg1AbsPtnBaseTargetElementImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Prg1AbsPtnBaseTargetElementImpl*  m_prg1absptnbasetargetelementImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Prg1AbsPtnBaseTargetElement - desc for Prg1AbsPtnBaseTargetElement parameter
     */
    Prg1AbsPtnBaseTargetElement( const Prg1AbsPtnBaseTargetElement& );
    Prg1AbsPtnBaseTargetElement& operator=( const Prg1AbsPtnBaseTargetElement& );

    friend class  Prg1AbsPtnBaseTargetElementDelegate;
    friend class  Prg1AbsPtnBaseTargetElementDispatch;
    friend class  Prg1AbsPtnBaseTargetElementGenImpl;
};

#include <prg1programplanningapp/libprg1programplanningapp_undef.h>
#endif //   PRG1PROGRAMPLANNINGAPP__PRG1ABSPTNBASETARGETELEMENT__HXX
