//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Prg1AbsReuseTargetElement
    Filename:   Prg1AbsReuseTargetElement.hxx
    Module:     prg1programplanningapp
    @BMIDE autogenerated
==================================================================================================*/

#ifndef PRG1PROGRAMPLANNINGAPP__PRG1ABSREUSETARGETELEMENT__HXX
#define PRG1PROGRAMPLANNINGAPP__PRG1ABSREUSETARGETELEMENT__HXX

#include <common/tc_deprecation_macros.h>
#include <prg1programplanningapp/Prg1AbsPtnBaseTargetElement.hxx>

#include <prg1programplanningapp/libprg1programplanningapp_exports.h>

namespace Prg1ProgramPlanningApp
{
    class Prg1AbsReuseTargetElement;
}
namespace Prg1ProgramPlanningApp
{
    class Prg1AbsReuseTargetElementImpl;
}
namespace Prg1ProgramPlanningApp
{
    class Prg1AbsReuseTargetElementDelegate;
}
namespace Prg1ProgramPlanningApp
{
    class Prg1AbsReuseTargetElementDispatch;
}
namespace Prg1ProgramPlanningApp
{
    class Prg1AbsReuseTargetElementGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PRG1PROGRAMPLANNINGAPP_API  Prg1ProgramPlanningApp::Prg1AbsReuseTargetElement
     : public  ::Prg1ProgramPlanningApp::Prg1AbsPtnBaseTargetElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Prg1AbsReuseTargetElement();

    /**
     * Destructor
     */
    virtual ~Prg1AbsReuseTargetElement();

private:
    //  Getter method for the Implementation Object
    Prg1AbsReuseTargetElementImpl*  getPrg1AbsReuseTargetElementImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPrg1AbsReuseTargetElementImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Prg1AbsReuseTargetElementImpl*  m_prg1absreusetargetelementImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Prg1AbsReuseTargetElement - desc for Prg1AbsReuseTargetElement parameter
     */
    Prg1AbsReuseTargetElement( const Prg1AbsReuseTargetElement& );
    Prg1AbsReuseTargetElement& operator=( const Prg1AbsReuseTargetElement& );

    friend class  Prg1AbsReuseTargetElementDelegate;
    friend class  Prg1AbsReuseTargetElementDispatch;
    friend class  Prg1AbsReuseTargetElementGenImpl;
};

#include <prg1programplanningapp/libprg1programplanningapp_undef.h>
#endif //   PRG1PROGRAMPLANNINGAPP__PRG1ABSREUSETARGETELEMENT__HXX
