//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Prg1AbsTakeRateTargtElement
    Filename:   Prg1AbsTakeRateTargtElement.hxx
    Module:     prg1programplanningapp
    @BMIDE autogenerated
==================================================================================================*/

#ifndef PRG1PROGRAMPLANNINGAPP__PRG1ABSTAKERATETARGTELEMENT__HXX
#define PRG1PROGRAMPLANNINGAPP__PRG1ABSTAKERATETARGTELEMENT__HXX

#include <common/tc_deprecation_macros.h>
#include <prg1programplanningapp/Prg1AbsPtnBaseTargetElement.hxx>

#include <prg1programplanningapp/libprg1programplanningapp_exports.h>

namespace Prg1ProgramPlanningApp
{
    class Prg1AbsTakeRateTargtElement;
}
namespace Prg1ProgramPlanningApp
{
    class Prg1AbsTakeRateTargtElementImpl;
}
namespace Prg1ProgramPlanningApp
{
    class Prg1AbsTakeRateTargtElementDelegate;
}
namespace Prg1ProgramPlanningApp
{
    class Prg1AbsTakeRateTargtElementDispatch;
}
namespace Prg1ProgramPlanningApp
{
    class Prg1AbsTakeRateTargtElementGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PRG1PROGRAMPLANNINGAPP_API  Prg1ProgramPlanningApp::Prg1AbsTakeRateTargtElement
     : public  ::Prg1ProgramPlanningApp::Prg1AbsPtnBaseTargetElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPrg1Goal( double &value, bool &isNull ) const;

    ///
    /// Getter for a Double Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPrg1Max( double &value, bool &isNull ) const;

    ///
    /// Getter for a Double Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPrg1Min( double &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Prg1AbsTakeRateTargtElement();

    /**
     * Destructor
     */
    virtual ~Prg1AbsTakeRateTargtElement();

private:
    //  Getter method for the Implementation Object
    Prg1AbsTakeRateTargtElementImpl*  getPrg1AbsTakeRateTargtElementImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPrg1AbsTakeRateTargtElementImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Prg1AbsTakeRateTargtElementImpl*  m_prg1abstakeratetargtelementImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Prg1AbsTakeRateTargtElement - desc for Prg1AbsTakeRateTargtElement parameter
     */
    Prg1AbsTakeRateTargtElement( const Prg1AbsTakeRateTargtElement& );
    Prg1AbsTakeRateTargtElement& operator=( const Prg1AbsTakeRateTargtElement& );

    friend class  Prg1AbsTakeRateTargtElementDelegate;
    friend class  Prg1AbsTakeRateTargtElementDispatch;
    friend class  Prg1AbsTakeRateTargtElementGenImpl;
};

#include <prg1programplanningapp/libprg1programplanningapp_undef.h>
#endif //   PRG1PROGRAMPLANNINGAPP__PRG1ABSTAKERATETARGTELEMENT__HXX
