//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Prg1AbsVolumeTargetElement
    Filename:   Prg1AbsVolumeTargetElement.hxx
    Module:     prg1programplanningapp
    @BMIDE autogenerated
==================================================================================================*/

#ifndef PRG1PROGRAMPLANNINGAPP__PRG1ABSVOLUMETARGETELEMENT__HXX
#define PRG1PROGRAMPLANNINGAPP__PRG1ABSVOLUMETARGETELEMENT__HXX

#include <common/tc_deprecation_macros.h>
#include <tgm0targetmgmt/Tgm0AbsTargetElement.hxx>

#include <prg1programplanningapp/libprg1programplanningapp_exports.h>

namespace Prg1ProgramPlanningApp
{
    class Prg1AbsVolumeTargetElement;
}
namespace Prg1ProgramPlanningApp
{
    class Prg1AbsVolumeTargetElementImpl;
}
namespace Prg1ProgramPlanningApp
{
    class Prg1AbsVolumeTargetElementDelegate;
}
namespace Prg1ProgramPlanningApp
{
    class Prg1AbsVolumeTargetElementDispatch;
}
namespace Prg1ProgramPlanningApp
{
    class Prg1AbsVolumeTargetElementGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PRG1PROGRAMPLANNINGAPP_API  Prg1ProgramPlanningApp::Prg1AbsVolumeTargetElement
     : public  ::Teamcenter::Tgm0TargetMgmt::Tgm0AbsTargetElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Prg1AbsVolumeTargetElement();

    /**
     * Destructor
     */
    virtual ~Prg1AbsVolumeTargetElement();

private:
    //  Getter method for the Implementation Object
    Prg1AbsVolumeTargetElementImpl*  getPrg1AbsVolumeTargetElementImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPrg1AbsVolumeTargetElementImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Prg1AbsVolumeTargetElementImpl*  m_prg1absvolumetargetelementImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Prg1AbsVolumeTargetElement - desc for Prg1AbsVolumeTargetElement parameter
     */
    Prg1AbsVolumeTargetElement( const Prg1AbsVolumeTargetElement& );
    Prg1AbsVolumeTargetElement& operator=( const Prg1AbsVolumeTargetElement& );

    friend class  Prg1AbsVolumeTargetElementDelegate;
    friend class  Prg1AbsVolumeTargetElementDispatch;
    friend class  Prg1AbsVolumeTargetElementGenImpl;
};

#include <prg1programplanningapp/libprg1programplanningapp_undef.h>
#endif //   PRG1PROGRAMPLANNINGAPP__PRG1ABSVOLUMETARGETELEMENT__HXX
