//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Prg1ConfiguratorContext
    Filename:   Prg1ConfiguratorContext.hxx
    Module:     prg1programplanningapp
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PRG1PROGRAMPLANNINGAPP__PRG1CONFIGURATORCONTEXT__HXX
#define TEAMCENTER__PRG1PROGRAMPLANNINGAPP__PRG1CONFIGURATORCONTEXT__HXX

#include <common/tc_deprecation_macros.h>
#include <aps0apscore/Mdl0CopyStableRelation.hxx>

#include <prg1programplanningapp/libprg1programplanningapp_exports.h>

namespace Teamcenter
{
    namespace Prg1ProgramPlanningApp
    {
        class Prg1ConfiguratorContext;
    }
}
namespace Teamcenter
{
    namespace Prg1ProgramPlanningApp
    {
        class Prg1ConfiguratorContextImpl;
    }
}
namespace Teamcenter
{
    namespace Prg1ProgramPlanningApp
    {
        class Prg1ConfiguratorContextDelegate;
    }
}
namespace Teamcenter
{
    namespace Prg1ProgramPlanningApp
    {
        class Prg1ConfiguratorContextDispatch;
    }
}
namespace Teamcenter
{
    namespace Prg1ProgramPlanningApp
    {
        class Prg1ConfiguratorContextGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PRG1PROGRAMPLANNINGAPP_API  Teamcenter::Prg1ProgramPlanningApp::Prg1ConfiguratorContext
     : public  ::Teamcenter::AppModel::Mdl0CopyStableRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Prg1ConfiguratorContext();

    /**
     * Destructor
     */
    virtual ~Prg1ConfiguratorContext();

private:
    //  Getter method for the Implementation Object
    Prg1ConfiguratorContextImpl*  getPrg1ConfiguratorContextImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPrg1ConfiguratorContextImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Prg1ConfiguratorContextImpl*  m_prg1configuratorcontextImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Prg1ConfiguratorContext - desc for Prg1ConfiguratorContext parameter
     */
    Prg1ConfiguratorContext( const Prg1ConfiguratorContext& );
    Prg1ConfiguratorContext& operator=( const Prg1ConfiguratorContext& );

    friend class  Prg1ConfiguratorContextDelegate;
    friend class  Prg1ConfiguratorContextDispatch;
    friend class  Prg1ConfiguratorContextGenImpl;
};

#include <prg1programplanningapp/libprg1programplanningapp_undef.h>
#endif //   TEAMCENTER__PRG1PROGRAMPLANNINGAPP__PRG1CONFIGURATORCONTEXT__HXX
