//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Prg1PartitionContext
    Filename:   Prg1PartitionContext.hxx
    Module:     prg1programplanningapp
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PRG1PROGRAMPLANNINGAPP__PRG1PARTITIONCONTEXT__HXX
#define TEAMCENTER__PRG1PROGRAMPLANNINGAPP__PRG1PARTITIONCONTEXT__HXX

#include <common/tc_deprecation_macros.h>
#include <aps0apscore/Mdl0CopyStableRelation.hxx>

#include <prg1programplanningapp/libprg1programplanningapp_exports.h>

namespace Teamcenter
{
    namespace Prg1ProgramPlanningApp
    {
        class Prg1PartitionContext;
    }
}
namespace Teamcenter
{
    namespace Prg1ProgramPlanningApp
    {
        class Prg1PartitionContextImpl;
    }
}
namespace Teamcenter
{
    namespace Prg1ProgramPlanningApp
    {
        class Prg1PartitionContextDelegate;
    }
}
namespace Teamcenter
{
    namespace Prg1ProgramPlanningApp
    {
        class Prg1PartitionContextDispatch;
    }
}
namespace Teamcenter
{
    namespace Prg1ProgramPlanningApp
    {
        class Prg1PartitionContextGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PRG1PROGRAMPLANNINGAPP_API  Teamcenter::Prg1ProgramPlanningApp::Prg1PartitionContext
     : public  ::Teamcenter::AppModel::Mdl0CopyStableRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Prg1PartitionContext();

    /**
     * Destructor
     */
    virtual ~Prg1PartitionContext();

private:
    //  Getter method for the Implementation Object
    Prg1PartitionContextImpl*  getPrg1PartitionContextImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPrg1PartitionContextImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Prg1PartitionContextImpl*  m_prg1partitioncontextImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Prg1PartitionContext - desc for Prg1PartitionContext parameter
     */
    Prg1PartitionContext( const Prg1PartitionContext& );
    Prg1PartitionContext& operator=( const Prg1PartitionContext& );

    friend class  Prg1PartitionContextDelegate;
    friend class  Prg1PartitionContextDispatch;
    friend class  Prg1PartitionContextGenImpl;
};

#include <prg1programplanningapp/libprg1programplanningapp_undef.h>
#endif //   TEAMCENTER__PRG1PROGRAMPLANNINGAPP__PRG1PARTITIONCONTEXT__HXX
