//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Tgm0AbsTargetElement
    Filename:   Tgm0AbsTargetElementExt.hxx
    Module:     prg1programplanningapp
    @BMIDE autogenerated
==================================================================================================*/

#ifndef PRG1__PRG1PROGRAMPLANNINGAPP__TGM0ABSTARGETELEMENT__HXX
#define PRG1__PRG1PROGRAMPLANNINGAPP__TGM0ABSTARGETELEMENT__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <metaframework/BusinessObjectExtender.hxx>
#include <metaframework/BusinessObjectExtenderRef.hxx>
#include <metaframework/BusinessObjectExtenderRegistry.hxx>

#include <prg1programplanningapp/libprg1programplanningapp_exports.h>

namespace prg1
{
    namespace Prg1ProgramPlanningApp
    {
        class Tgm0AbsTargetElement;
    }
}
namespace prg1
{
    namespace Prg1ProgramPlanningApp
    {
        class Tgm0AbsTargetElementImpl;
    }
}
namespace prg1
{
    namespace Prg1ProgramPlanningApp
    {
        class Tgm0AbsTargetElementDelegate;
    }
}
namespace prg1
{
    namespace Prg1ProgramPlanningApp
    {
        class Tgm0AbsTargetElementDispatch;
    }
}
namespace prg1
{
    namespace Prg1ProgramPlanningApp
    {
        class Tgm0AbsTargetElementGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PRG1PROGRAMPLANNINGAPP_API  prg1::Prg1ProgramPlanningApp::Tgm0AbsTargetElement
     : public  ::Teamcenter::BusinessObjectExtender
{
public:

    /**
     * Constructor
     */
    Tgm0AbsTargetElement( tag_t  objTag );
    /**
     * Get the Extender Registry
     * @return - return Extender Registry
     */
    static ::Teamcenter::BusinessObjectExtenderRegistry< prg1::Prg1ProgramPlanningApp::Tgm0AbsTargetElement >&  extenderRegistry();

    /**
     * Get the Extender Interface Name
     * @return - return desc for getExtenderInterfaceName
     */
    static const std::string&  getExtenderInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPrg1AttrDefRev( tag_t &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );


    /**
     * Destructor
     */
    virtual ~Tgm0AbsTargetElement();

private:
    //  Getter method for the Implementation Object
    Tgm0AbsTargetElementImpl*  getTgm0AbsTargetElementImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTgm0AbsTargetElementImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Tgm0AbsTargetElementImpl*  m_tgm0abstargetelementImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Tgm0AbsTargetElement - desc for Tgm0AbsTargetElement parameter
     */
    Tgm0AbsTargetElement( const Tgm0AbsTargetElement& );
    Tgm0AbsTargetElement& operator=( const Tgm0AbsTargetElement& );

    friend class  Tgm0AbsTargetElementDelegate;
    friend class  Tgm0AbsTargetElementDispatch;
    friend class  Tgm0AbsTargetElementGenImpl;
};

#include <prg1programplanningapp/libprg1programplanningapp_undef.h>
#endif //   PRG1__PRG1PROGRAMPLANNINGAPP__TGM0ABSTARGETELEMENT__HXX
