//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ProductVariant
    Filename:   ProductVariant.hxx
    Module:     productvariant
    @BMIDE autogenerated
==================================================================================================*/

#ifndef PRODUCTVARIANT__PRODUCTVARIANT__HXX
#define PRODUCTVARIANT__PRODUCTVARIANT__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <collabctx/CCObject.hxx>

#include <productvariant/libproductvariant_exports.h>

namespace productvariant
{
    class ProductVariant;
}
namespace productvariant
{
    class ProductVariantImpl;
}
namespace productvariant
{
    class ProductVariantDelegate;
}
namespace productvariant
{
    class ProductVariantDispatch;
}
namespace productvariant
{
    class ProductVariantGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PRODUCTVARIANT_API  productvariant::ProductVariant
     : public  ::Teamcenter::CCObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getProductCtxt( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setProductCtxt( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ProductVariant();

    /**
     * Destructor
     */
    virtual ~ProductVariant();

private:
    //  Getter method for the Implementation Object
    ProductVariantImpl*  getProductVariantImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setProductVariantImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ProductVariantImpl*  m_productvariantImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ProductVariant - desc for ProductVariant parameter
     */
    ProductVariant( const ProductVariant& );
    ProductVariant& operator=( const ProductVariant& );

    friend class  ProductVariantDelegate;
    friend class  ProductVariantDispatch;
    friend class  ProductVariantGenImpl;
};

#include <productvariant/libproductvariant_undef.h>
#endif //   PRODUCTVARIANT__PRODUCTVARIANT__HXX
