//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ProductVariantDelegate
    Filename:   ProductVariantDelegate.hxx
    Module:     productvariant
    @BMIDE autogenerated
==================================================================================================*/

#ifndef PRODUCTVARIANT__PRODUCTVARIANTDELEGATE_HXX
#define PRODUCTVARIANT__PRODUCTVARIANTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <productvariant/ProductVariant.hxx>

#include <productvariant/libproductvariant_exports.h>

namespace productvariant
{
    class ProductVariantDelegate;
}
namespace productvariant
{
    class ProductVariantImpl;
}
namespace productvariant
{
    class ProductVariant;
}
namespace productvariant
{
    class ProductVariantGenImpl;
}

namespace productvariant_alias = ::productvariant;


class  PRODUCTVARIANT_API productvariant_alias::ProductVariantDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ProductVariantDelegate instance
    static ProductVariantDelegate&  getInstance();

    //  Method to create the ProductVariantImpl pointer
    static ProductVariantImpl*  createImpl( ProductVariant&  ifObj );

    //  Method to delete the ProductVariantImpl pointer
    static void deleteImpl( ProductVariantImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getProductCtxtBase(const ProductVariant &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setProductCtxtBase(ProductVariant &ifObj,  const tag_t &value, bool isNull );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const ProductVariant &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static ProductVariantDelegate*  m_pInstance;

    ProductVariantDelegate();
    virtual ~ProductVariantDelegate();
    static void setInstance( ProductVariantDelegate*  instance );


private:
    friend class  ::productvariant::ProductVariantGenImpl;

};

#include <productvariant/libproductvariant_undef.h>
#endif  //  PRODUCTVARIANT__PRODUCTVARIANTDELEGATE_HXX
