//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ProductVariantIntent
    Filename:   ProductVariantIntent.hxx
    Module:     productvariant
    @BMIDE autogenerated
==================================================================================================*/

#ifndef PRODUCTVARIANT__PRODUCTVARIANTINTENT__HXX
#define PRODUCTVARIANT__PRODUCTVARIANTINTENT__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <collabctx/StructureContext.hxx>

#include <productvariant/libproductvariant_exports.h>

namespace productvariant
{
    class ProductVariantIntent;
}
namespace productvariant
{
    class ProductVariantIntentImpl;
}
namespace productvariant
{
    class ProductVariantIntentDelegate;
}
namespace productvariant
{
    class ProductVariantIntentDispatch;
}
namespace productvariant
{
    class ProductVariantIntentGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PRODUCTVARIANT_API  productvariant::ProductVariantIntent
     : public  ::Teamcenter::StructureContext
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getProduct_variant( tag_t &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ProductVariantIntent();

    /**
     * Destructor
     */
    virtual ~ProductVariantIntent();

private:
    //  Getter method for the Implementation Object
    ProductVariantIntentImpl*  getProductVariantIntentImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setProductVariantIntentImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ProductVariantIntentImpl*  m_productvariantintentImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ProductVariantIntent - desc for ProductVariantIntent parameter
     */
    ProductVariantIntent( const ProductVariantIntent& );
    ProductVariantIntent& operator=( const ProductVariantIntent& );

    friend class  ProductVariantIntentDelegate;
    friend class  ProductVariantIntentDispatch;
    friend class  ProductVariantIntentGenImpl;
};

#include <productvariant/libproductvariant_undef.h>
#endif //   PRODUCTVARIANT__PRODUCTVARIANTINTENT__HXX
