//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ProductVariantIntentDelegate
    Filename:   ProductVariantIntentDelegate.hxx
    Module:     productvariant
    @BMIDE autogenerated
==================================================================================================*/

#ifndef PRODUCTVARIANT__PRODUCTVARIANTINTENTDELEGATE_HXX
#define PRODUCTVARIANT__PRODUCTVARIANTINTENTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <productvariant/ProductVariantIntent.hxx>

#include <productvariant/libproductvariant_exports.h>

namespace productvariant
{
    class ProductVariantIntentDelegate;
}
namespace productvariant
{
    class ProductVariantIntentImpl;
}
namespace productvariant
{
    class ProductVariantIntent;
}
namespace productvariant
{
    class ProductVariantIntentGenImpl;
}

namespace productvariant_alias = ::productvariant;


class  PRODUCTVARIANT_API productvariant_alias::ProductVariantIntentDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ProductVariantIntentDelegate instance
    static ProductVariantIntentDelegate&  getInstance();

    //  Method to create the ProductVariantIntentImpl pointer
    static ProductVariantIntentImpl*  createImpl( ProductVariantIntent&  ifObj );

    //  Method to delete the ProductVariantIntentImpl pointer
    static void deleteImpl( ProductVariantIntentImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getProduct_variantBase(const ProductVariantIntent &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const ProductVariantIntent &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const ProductVariantIntent &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static ProductVariantIntentDelegate*  m_pInstance;

    ProductVariantIntentDelegate();
    virtual ~ProductVariantIntentDelegate();
    static void setInstance( ProductVariantIntentDelegate*  instance );


private:
    friend class  ::productvariant::ProductVariantIntentGenImpl;

};

#include <productvariant/libproductvariant_undef.h>
#endif  //  PRODUCTVARIANT__PRODUCTVARIANTINTENTDELEGATE_HXX
