//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  productvariant

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libproductvariant

#if !defined(LIBPRODUCTVARIANT) && !defined(IPLIB)
#   error IPLIB or LIBPRODUCTVARIANT is not defined
#endif

/* Handwritten code should use PRODUCTVARIANT_API, not PRODUCTVARIANTEXPORT */

#define PRODUCTVARIANT_API PRODUCTVARIANTEXPORT

#if IPLIB==libproductvariant || defined(LIBPRODUCTVARIANT)
#   if defined(__lint)
#       define PRODUCTVARIANTEXPORT       __export(productvariant)
#       define PRODUCTVARIANTGLOBAL       extern __global(productvariant)
#       define PRODUCTVARIANTPRIVATE      extern __private(productvariant)
#   elif defined(_WIN32)
#       define PRODUCTVARIANTEXPORT       __declspec(dllexport)
#       define PRODUCTVARIANTGLOBAL       extern __declspec(dllexport)
#       define PRODUCTVARIANTPRIVATE      extern
#   else
#       define PRODUCTVARIANTEXPORT
#       define PRODUCTVARIANTGLOBAL       extern
#       define PRODUCTVARIANTPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define PRODUCTVARIANTEXPORT       __export(productvariant)
#       define PRODUCTVARIANTGLOBAL       extern __global(productvariant)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define PRODUCTVARIANTEXPORT      __declspec(dllimport)
#       define PRODUCTVARIANTGLOBAL       extern __declspec(dllimport)
#   else
#       define PRODUCTVARIANTEXPORT
#       define PRODUCTVARIANTGLOBAL       extern
#   endif
#endif
