//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ProductVariantDispatch
    Filename:   ProductVariantDispatch.hxx
    Module:     productvariantdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef PRODUCTVARIANT__PRODUCTVARIANTDISPATCH_HXX
#define PRODUCTVARIANT__PRODUCTVARIANTDISPATCH_HXX

#include <vector>
#include <productvariant/ProductVariant.hxx>
#include <productvariant/ProductVariantDelegate.hxx>
#include <foundationdispatch/CCObjectDispatch.hxx>
#include <productvariantdispatch/initializeproductvariant.hxx>

#include <productvariantdispatch/libproductvariantdispatch_exports.h>

namespace productvariant
{
    class ProductVariantDispatch;
}
namespace productvariant
{
    class ProductVariantDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  PRODUCTVARIANTDISPATCH_API  productvariant::ProductVariantDispatch
    : public  productvariant::ProductVariantDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ProductVariantDispatch instance
    static ProductVariantDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static ProductVariantDispatch*  m_dispatch;

    //  Default Constructor
    ProductVariantDispatch();

    //  Default Destructor
    virtual ~ProductVariantDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a ProductVariantDispatch
    ProductVariantDispatch( const ProductVariantDispatch& );

    //  Assignment operator
    ProductVariantDispatch&  operator = ( const ProductVariantDispatch& );

    //  friend
    friend void   ::productvariant::initializeproductvariantInternal();
    friend void   ::productvariant::initializeproductvariantExtenders();
    friend class  productvariant::ProductVariantDelegate;
};

#include <productvariantdispatch/libproductvariantdispatch_undef.h>
#endif  //  PRODUCTVARIANT__PRODUCTVARIANTDISPATCH_HXX
