//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  productvariantdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libproductvariantdispatch

#if !defined(LIBPRODUCTVARIANTDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBPRODUCTVARIANTDISPATCH is not defined
#endif

/* Handwritten code should use PRODUCTVARIANTDISPATCH_API, not PRODUCTVARIANTDISPATCHEXPORT */

#define PRODUCTVARIANTDISPATCH_API PRODUCTVARIANTDISPATCHEXPORT

#if IPLIB==libproductvariantdispatch || defined(LIBPRODUCTVARIANTDISPATCH)
#   if defined(__lint)
#       define PRODUCTVARIANTDISPATCHEXPORT       __export(productvariantdispatch)
#       define PRODUCTVARIANTDISPATCHGLOBAL       extern __global(productvariantdispatch)
#       define PRODUCTVARIANTDISPATCHPRIVATE      extern __private(productvariantdispatch)
#   elif defined(_WIN32)
#       define PRODUCTVARIANTDISPATCHEXPORT       __declspec(dllexport)
#       define PRODUCTVARIANTDISPATCHGLOBAL       extern __declspec(dllexport)
#       define PRODUCTVARIANTDISPATCHPRIVATE      extern
#   else
#       define PRODUCTVARIANTDISPATCHEXPORT
#       define PRODUCTVARIANTDISPATCHGLOBAL       extern
#       define PRODUCTVARIANTDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define PRODUCTVARIANTDISPATCHEXPORT       __export(productvariantdispatch)
#       define PRODUCTVARIANTDISPATCHGLOBAL       extern __global(productvariantdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define PRODUCTVARIANTDISPATCHEXPORT      __declspec(dllimport)
#       define PRODUCTVARIANTDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define PRODUCTVARIANTDISPATCHEXPORT
#       define PRODUCTVARIANTDISPATCHGLOBAL       extern
#   endif
#endif
