//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CadAttrMappingDefPart
    Filename:   CadAttrMappingDefPart.hxx
    Module:     property
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CADATTRMAPPINGDEFPART__HXX
#define TEAMCENTER__CADATTRMAPPINGDEFPART__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <property/libproperty_exports.h>

namespace Teamcenter
{
    class CadAttrMappingDefPart;
}
namespace Teamcenter
{
    class CadAttrMappingDefPartImpl;
}
namespace Teamcenter
{
    class CadAttrMappingDefPartDelegate;
}
namespace Teamcenter
{
    class CadAttrMappingDefPartDispatch;
}
namespace Teamcenter
{
    class CadAttrMappingDefPartGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PROPERTY_API  Teamcenter::CadAttrMappingDefPart
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CadAttrMappingDefPart();

    /**
     * Destructor
     */
    virtual ~CadAttrMappingDefPart();

private:
    //  Getter method for the Implementation Object
    CadAttrMappingDefPartImpl*  getCadAttrMappingDefPartImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCadAttrMappingDefPartImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CadAttrMappingDefPartImpl*  m_cadattrmappingdefpartImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CadAttrMappingDefPart - desc for CadAttrMappingDefPart parameter
     */
    CadAttrMappingDefPart( const CadAttrMappingDefPart& );
    CadAttrMappingDefPart& operator=( const CadAttrMappingDefPart& );

    friend class  CadAttrMappingDefPartDelegate;
    friend class  CadAttrMappingDefPartDispatch;
    friend class  CadAttrMappingDefPartGenImpl;
};

#include <property/libproperty_undef.h>
#endif //   TEAMCENTER__CADATTRMAPPINGDEFPART__HXX
