//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CadAttrMappingDefPartProp
    Filename:   CadAttrMappingDefPartProp.hxx
    Module:     property
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CADATTRMAPPINGDEFPARTPROP__HXX
#define TEAMCENTER__CADATTRMAPPINGDEFPARTPROP__HXX

#include <common/tc_deprecation_macros.h>
#include <property/CadAttrMappingDefPart.hxx>

#include <property/libproperty_exports.h>

namespace Teamcenter
{
    class CadAttrMappingDefPartProp;
}
namespace Teamcenter
{
    class CadAttrMappingDefPartPropImpl;
}
namespace Teamcenter
{
    class CadAttrMappingDefPartPropDelegate;
}
namespace Teamcenter
{
    class CadAttrMappingDefPartPropDispatch;
}
namespace Teamcenter
{
    class CadAttrMappingDefPartPropGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PROPERTY_API  Teamcenter::CadAttrMappingDefPartProp
     : public  ::Teamcenter::CadAttrMappingDefPart
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CadAttrMappingDefPartProp();

    /**
     * Destructor
     */
    virtual ~CadAttrMappingDefPartProp();

private:
    //  Getter method for the Implementation Object
    CadAttrMappingDefPartPropImpl*  getCadAttrMappingDefPartPropImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCadAttrMappingDefPartPropImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CadAttrMappingDefPartPropImpl*  m_cadattrmappingdefpartpropImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CadAttrMappingDefPartProp - desc for CadAttrMappingDefPartProp parameter
     */
    CadAttrMappingDefPartProp( const CadAttrMappingDefPartProp& );
    CadAttrMappingDefPartProp& operator=( const CadAttrMappingDefPartProp& );

    friend class  CadAttrMappingDefPartPropDelegate;
    friend class  CadAttrMappingDefPartPropDispatch;
    friend class  CadAttrMappingDefPartPropGenImpl;
};

#include <property/libproperty_undef.h>
#endif //   TEAMCENTER__CADATTRMAPPINGDEFPARTPROP__HXX
