//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CadAttrMappingDefinition
    Filename:   CadAttrMappingDefinition.hxx
    Module:     property
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CADATTRMAPPINGDEFINITION__HXX
#define TEAMCENTER__CADATTRMAPPINGDEFINITION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <property/libproperty_exports.h>

namespace Teamcenter
{
    class CadAttrMappingDefinition;
}
namespace Teamcenter
{
    class CadAttrMappingDefinitionImpl;
}
namespace Teamcenter
{
    class CadAttrMappingDefinitionDelegate;
}
namespace Teamcenter
{
    class CadAttrMappingDefinitionDispatch;
}
namespace Teamcenter
{
    class CadAttrMappingDefinitionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PROPERTY_API  Teamcenter::CadAttrMappingDefinition
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Boolean Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIs_hard_coded( bool &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CadAttrMappingDefinition();

    /**
     * Destructor
     */
    virtual ~CadAttrMappingDefinition();

private:
    //  Getter method for the Implementation Object
    CadAttrMappingDefinitionImpl*  getCadAttrMappingDefinitionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCadAttrMappingDefinitionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CadAttrMappingDefinitionImpl*  m_cadattrmappingdefinitionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CadAttrMappingDefinition - desc for CadAttrMappingDefinition parameter
     */
    CadAttrMappingDefinition( const CadAttrMappingDefinition& );
    CadAttrMappingDefinition& operator=( const CadAttrMappingDefinition& );

    friend class  CadAttrMappingDefinitionDelegate;
    friend class  CadAttrMappingDefinitionDispatch;
    friend class  CadAttrMappingDefinitionGenImpl;
};

#include <property/libproperty_undef.h>
#endif //   TEAMCENTER__CADATTRMAPPINGDEFINITION__HXX
