//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CadAttrMappingDefinitionDelegate
    Filename:   CadAttrMappingDefinitionDelegate.hxx
    Module:     property
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CADATTRMAPPINGDEFINITIONDELEGATE_HXX
#define TEAMCENTER__CADATTRMAPPINGDEFINITIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <property/CadAttrMappingDefinition.hxx>

#include <property/libproperty_exports.h>

namespace Teamcenter
{
    class CadAttrMappingDefinitionDelegate;
}
namespace Teamcenter
{
    class CadAttrMappingDefinitionImpl;
}
namespace Teamcenter
{
    class CadAttrMappingDefinition;
}
namespace Teamcenter
{
    class CadAttrMappingDefinitionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PROPERTY_API Teamcenter_alias::CadAttrMappingDefinitionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CadAttrMappingDefinitionDelegate instance
    static CadAttrMappingDefinitionDelegate&  getInstance();

    //  Method to create the CadAttrMappingDefinitionImpl pointer
    static CadAttrMappingDefinitionImpl*  createImpl( CadAttrMappingDefinition&  ifObj );

    //  Method to delete the CadAttrMappingDefinitionImpl pointer
    static void deleteImpl( CadAttrMappingDefinitionImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIs_hard_codedBase(const CadAttrMappingDefinition &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static CadAttrMappingDefinitionDelegate*  m_pInstance;

    CadAttrMappingDefinitionDelegate();
    virtual ~CadAttrMappingDefinitionDelegate();
    static void setInstance( CadAttrMappingDefinitionDelegate*  instance );


private:
    friend class  ::Teamcenter::CadAttrMappingDefinitionGenImpl;

};

#include <property/libproperty_undef.h>
#endif  //  TEAMCENTER__CADATTRMAPPINGDEFINITIONDELEGATE_HXX
