//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ConcatenationRule
    Filename:   Fnd0ConcatenationRule.hxx
    Module:     property
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0CONCATENATIONRULE__HXX
#define TEAMCENTER__FND0CONCATENATIONRULE__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/BusinessRule.hxx>

#include <property/libproperty_exports.h>

namespace Teamcenter
{
    class Fnd0ConcatenationRule;
}
namespace Teamcenter
{
    class Fnd0ConcatenationRuleImpl;
}
namespace Teamcenter
{
    class Fnd0ConcatenationRuleDelegate;
}
namespace Teamcenter
{
    class Fnd0ConcatenationRuleDispatch;
}
namespace Teamcenter
{
    class Fnd0ConcatenationRuleGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PROPERTY_API  Teamcenter::Fnd0ConcatenationRule
     : public  ::Teamcenter::BusinessRule
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// This method generates the ID.
    /// @version Teamcenter 11.1
    /// @param idGeneratorBOTag - Tag of the object that holds the configuration information specified by the user.
    /// @param generatedId - Id that is generated.
    /// @return - 
    ///
    int  fnd0generateId( const tag_t idGeneratorBOTag, char **generatedId );

    ///
    /// This method would validate the incoming Id against the configured Naming Rule. A Naming Rule is optionally associated with this Concatenation Rule. If there is no Naming Rule associated, this method will return status indicating there is no Naming Rule.
    /// @version Teamcenter 11.1
    /// @param inputId - Input Id
    /// @param isValidId - Is Valid Id
    /// @return - Returns status as integer
    ///
    int  fnd0validateId( const char *inputId, bool *isValidId );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0ConcatenationRule();

    /**
     * Destructor
     */
    virtual ~Fnd0ConcatenationRule();

private:
    //  Getter method for the Implementation Object
    Fnd0ConcatenationRuleImpl*  getFnd0ConcatenationRuleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0ConcatenationRuleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0ConcatenationRuleImpl*  m_fnd0concatenationruleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0ConcatenationRule - desc for Fnd0ConcatenationRule parameter
     */
    Fnd0ConcatenationRule( const Fnd0ConcatenationRule& );
    Fnd0ConcatenationRule& operator=( const Fnd0ConcatenationRule& );

    friend class  Fnd0ConcatenationRuleDelegate;
    friend class  Fnd0ConcatenationRuleDispatch;
    friend class  Fnd0ConcatenationRuleGenImpl;
};

#include <property/libproperty_undef.h>
#endif //   TEAMCENTER__FND0CONCATENATIONRULE__HXX
