//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0IdGenerationRuleAttach
    Filename:   Fnd0IdGenerationRuleAttach.hxx
    Module:     property
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0IDGENERATIONRULEATTACH__HXX
#define TEAMCENTER__FND0IDGENERATIONRULEATTACH__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/BusinessRule.hxx>

#include <property/libproperty_exports.h>

namespace Teamcenter
{
    class Fnd0IdGenerationRuleAttach;
}
namespace Teamcenter
{
    class Fnd0IdGenerationRuleAttachImpl;
}
namespace Teamcenter
{
    class Fnd0IdGenerationRuleAttachDelegate;
}
namespace Teamcenter
{
    class Fnd0IdGenerationRuleAttachDispatch;
}
namespace Teamcenter
{
    class Fnd0IdGenerationRuleAttachGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PROPERTY_API  Teamcenter::Fnd0IdGenerationRuleAttach
     : public  ::Teamcenter::BusinessRule
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Find method
    /// @version Teamcenter 11.1
    /// @param typeName - Name of TcType
    /// @param propertyName - Property Name
    /// @param idGenerationRule - Id Generation Rule Tag
    /// @return - Returns status as integer
    ///
    int  fnd0find( const char *typeName, const char *propertyName, tag_t *idGenerationRule );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0IdGenerationRuleAttach();

    /**
     * Destructor
     */
    virtual ~Fnd0IdGenerationRuleAttach();

private:
    //  Getter method for the Implementation Object
    Fnd0IdGenerationRuleAttachImpl*  getFnd0IdGenerationRuleAttachImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0IdGenerationRuleAttachImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0IdGenerationRuleAttachImpl*  m_fnd0idgenerationruleattachImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0IdGenerationRuleAttach - desc for Fnd0IdGenerationRuleAttach parameter
     */
    Fnd0IdGenerationRuleAttach( const Fnd0IdGenerationRuleAttach& );
    Fnd0IdGenerationRuleAttach& operator=( const Fnd0IdGenerationRuleAttach& );

    friend class  Fnd0IdGenerationRuleAttachDelegate;
    friend class  Fnd0IdGenerationRuleAttachDispatch;
    friend class  Fnd0IdGenerationRuleAttachGenImpl;
};

#include <property/libproperty_undef.h>
#endif //   TEAMCENTER__FND0IDGENERATIONRULEATTACH__HXX
