//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0IdGenerationRuleDelegate
    Filename:   Fnd0IdGenerationRuleDelegate.hxx
    Module:     property
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0IDGENERATIONRULEDELEGATE_HXX
#define TEAMCENTER__FND0IDGENERATIONRULEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <property/Fnd0IdGenerationRule.hxx>

#include <property/libproperty_exports.h>

namespace Teamcenter
{
    class Fnd0IdGenerationRuleDelegate;
}
namespace Teamcenter
{
    class Fnd0IdGenerationRuleImpl;
}
namespace Teamcenter
{
    class Fnd0IdGenerationRule;
}
namespace Teamcenter
{
    class Fnd0IdGenerationRuleGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PROPERTY_API Teamcenter_alias::Fnd0IdGenerationRuleDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0IdGenerationRuleDelegate instance
    static Fnd0IdGenerationRuleDelegate&  getInstance();

    //  Method to create the Fnd0IdGenerationRuleImpl pointer
    static Fnd0IdGenerationRuleImpl*  createImpl( Fnd0IdGenerationRule&  ifObj );

    //  Method to delete the Fnd0IdGenerationRuleImpl pointer
    static void deleteImpl( Fnd0IdGenerationRuleImpl*  impl );


    ///
    /// This method gets the valid Concatenation Rule and calls generateId on it. It returns the generated ID.
    /// @version Teamcenter 11.1
    /// @param idGeneratorBOTag - Tag of the IdGenerator object that holds the configuration information specified by the user
    /// @param generatedId - ID that is generated
    /// @return - 
    ///
    int  fnd0generateIdBase(const Fnd0IdGenerationRule &ifObj,  const tag_t idGeneratorBOTag, char **generatedId );


    ///
    /// This method evaluates all Concatenation Rules available on this Id Generation Rule and returns a valid Concatenation Rule
    /// @version Teamcenter 11.1
    /// @param concatenationRule - Concatenation Rule object
    /// @return - returns status as integer
    ///
    int  fnd0getValidConcatenationRuleBase(const Fnd0IdGenerationRule &ifObj,  ::Teamcenter::Fnd0ConcatenationRule **concatenationRule );



protected:
    //  Pointer to the instance
    static Fnd0IdGenerationRuleDelegate*  m_pInstance;

    Fnd0IdGenerationRuleDelegate();
    virtual ~Fnd0IdGenerationRuleDelegate();
    static void setInstance( Fnd0IdGenerationRuleDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0IdGenerationRuleGenImpl;

};

#include <property/libproperty_undef.h>
#endif  //  TEAMCENTER__FND0IDGENERATIONRULEDELEGATE_HXX
