//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0IncludedLODescriptor
    Filename:   Fnd0IncludedLODescriptor.hxx
    Module:     property
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0INCLUDEDLODESCRIPTOR__HXX
#define TEAMCENTER__FND0INCLUDEDLODESCRIPTOR__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <property/Fnd0PropertyDescriptor.hxx>

#include <property/libproperty_exports.h>

namespace Teamcenter
{
    class Fnd0IncludedLODescriptor;
}
namespace Teamcenter
{
    class Fnd0IncludedLODescriptorImpl;
}
namespace Teamcenter
{
    class Fnd0IncludedLODescriptorDelegate;
}
namespace Teamcenter
{
    class Fnd0IncludedLODescriptorDispatch;
}
namespace Teamcenter
{
    class Fnd0IncludedLODescriptorGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PROPERTY_API  Teamcenter::Fnd0IncludedLODescriptor
     : public  ::Teamcenter::Fnd0PropertyDescriptor
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.6
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0NavigationPath( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.6
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0SourceLOName( std::string &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0IncludedLODescriptor();

    /**
     * Destructor
     */
    virtual ~Fnd0IncludedLODescriptor();

private:
    //  Getter method for the Implementation Object
    Fnd0IncludedLODescriptorImpl*  getFnd0IncludedLODescriptorImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0IncludedLODescriptorImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0IncludedLODescriptorImpl*  m_fnd0includedlodescriptorImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0IncludedLODescriptor - desc for Fnd0IncludedLODescriptor parameter
     */
    Fnd0IncludedLODescriptor( const Fnd0IncludedLODescriptor& );
    Fnd0IncludedLODescriptor& operator=( const Fnd0IncludedLODescriptor& );

    friend class  Fnd0IncludedLODescriptorDelegate;
    friend class  Fnd0IncludedLODescriptorDispatch;
    friend class  Fnd0IncludedLODescriptorGenImpl;
};

#include <property/libproperty_undef.h>
#endif //   TEAMCENTER__FND0INCLUDEDLODESCRIPTOR__HXX
