//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0LOCompoundPropDef
    Filename:   Fnd0LOCompoundPropDef.hxx
    Module:     property
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0LOCOMPOUNDPROPDEF__HXX
#define TEAMCENTER__FND0LOCOMPOUNDPROPDEF__HXX

#include <common/tc_deprecation_macros.h>
#include <property/ImanCompoundPropDef.hxx>

#include <property/libproperty_exports.h>

namespace Teamcenter
{
    class Fnd0LOCompoundPropDef;
}
namespace Teamcenter
{
    class Fnd0LOCompoundPropDefImpl;
}
namespace Teamcenter
{
    class Fnd0LOCompoundPropDefDelegate;
}
namespace Teamcenter
{
    class Fnd0LOCompoundPropDefDispatch;
}
namespace Teamcenter
{
    class Fnd0LOCompoundPropDefGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PROPERTY_API  Teamcenter::Fnd0LOCompoundPropDef
     : public  ::Teamcenter::ImanCompoundPropDef
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0LOCompoundPropDef();

    /**
     * Destructor
     */
    virtual ~Fnd0LOCompoundPropDef();

private:
    //  Getter method for the Implementation Object
    Fnd0LOCompoundPropDefImpl*  getFnd0LOCompoundPropDefImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0LOCompoundPropDefImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0LOCompoundPropDefImpl*  m_fnd0locompoundpropdefImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0LOCompoundPropDef - desc for Fnd0LOCompoundPropDef parameter
     */
    Fnd0LOCompoundPropDef( const Fnd0LOCompoundPropDef& );
    Fnd0LOCompoundPropDef& operator=( const Fnd0LOCompoundPropDef& );

    friend class  Fnd0LOCompoundPropDefDelegate;
    friend class  Fnd0LOCompoundPropDefDispatch;
    friend class  Fnd0LOCompoundPropDefGenImpl;
};

#include <property/libproperty_undef.h>
#endif //   TEAMCENTER__FND0LOCOMPOUNDPROPDEF__HXX
