//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0LOFilterCriteria
    Filename:   Fnd0LOFilterCriteria.hxx
    Module:     property
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0LOFILTERCRITERIA__HXX
#define TEAMCENTER__FND0LOFILTERCRITERIA__HXX

#include <string>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <property/libproperty_exports.h>

namespace Teamcenter
{
    class Fnd0LOFilterCriteria;
}
namespace Teamcenter
{
    class Fnd0LOFilterCriteriaImpl;
}
namespace Teamcenter
{
    class Fnd0LOFilterCriteriaDelegate;
}
namespace Teamcenter
{
    class Fnd0LOFilterCriteriaDispatch;
}
namespace Teamcenter
{
    class Fnd0LOFilterCriteriaGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PROPERTY_API  Teamcenter::Fnd0LOFilterCriteria
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0FilterCriteriaExpr( std::string &value, bool &isNull ) const;

    ///
    /// Getter for Property Display Value
    /// @version Teamcenter 12.2
    /// @param values - Parameter value
    /// @return - Status. 0 if successful
    ///
    int  getFnd0FilterCriteriaExprDisplayableValues( std::vector< std::string > &values );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0LOFilterCriteria();

    /**
     * Destructor
     */
    virtual ~Fnd0LOFilterCriteria();

private:
    //  Getter method for the Implementation Object
    Fnd0LOFilterCriteriaImpl*  getFnd0LOFilterCriteriaImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0LOFilterCriteriaImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0LOFilterCriteriaImpl*  m_fnd0lofiltercriteriaImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0LOFilterCriteria - desc for Fnd0LOFilterCriteria parameter
     */
    Fnd0LOFilterCriteria( const Fnd0LOFilterCriteria& );
    Fnd0LOFilterCriteria& operator=( const Fnd0LOFilterCriteria& );

    friend class  Fnd0LOFilterCriteriaDelegate;
    friend class  Fnd0LOFilterCriteriaDispatch;
    friend class  Fnd0LOFilterCriteriaGenImpl;
};

#include <property/libproperty_undef.h>
#endif //   TEAMCENTER__FND0LOFILTERCRITERIA__HXX
