//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0LOPropPresentations
    Filename:   Fnd0LOPropPresentations.hxx
    Module:     property
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0LOPROPPRESENTATIONS__HXX
#define TEAMCENTER__FND0LOPROPPRESENTATIONS__HXX

#include <vector>
#include <string>
#include <common/tc_deprecation_macros.h>
#include <property/Fnd0PropertyDescriptor.hxx>

#include <property/libproperty_exports.h>

namespace Teamcenter
{
    class Fnd0LOPropPresentations;
}
namespace Teamcenter
{
    class Fnd0LOPropPresentationsImpl;
}
namespace Teamcenter
{
    class Fnd0LOPropPresentationsDelegate;
}
namespace Teamcenter
{
    class Fnd0LOPropPresentationsDispatch;
}
namespace Teamcenter
{
    class Fnd0LOPropPresentationsGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PROPERTY_API  Teamcenter::Fnd0LOPropPresentations
     : public  ::Teamcenter::Fnd0PropertyDescriptor
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0GetMemberICOData( bool &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 12.4
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0IsWritable( bool &value, bool &isNull ) const;

    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 11.4
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0MemberProperties( std::vector< std::string > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0NavigationPath( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0PresentedPropID( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0PresentedPropMemberID( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0RootOrMemberID( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0SourceProperty( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0SourceTypeName( std::string &value, bool &isNull ) const;

    ///
    /// Getter for Property Display Value
    /// @version Teamcenter 11.4
    /// @param values - Parameter value
    /// @return - Status. 0 if successful
    ///
    int  getFnd0SourceTypeNameDisplayableValues( std::vector< std::string > &values );

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.5
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0TraversalSegments( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 11.5
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0GetMemberICOData( bool value, bool isNull=false );

    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 12.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0IsWritable( bool value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.5
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0PresentedPropID( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0LOPropPresentations();

    /**
     * Destructor
     */
    virtual ~Fnd0LOPropPresentations();

private:
    //  Getter method for the Implementation Object
    Fnd0LOPropPresentationsImpl*  getFnd0LOPropPresentationsImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0LOPropPresentationsImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0LOPropPresentationsImpl*  m_fnd0loproppresentationsImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0LOPropPresentations - desc for Fnd0LOPropPresentations parameter
     */
    Fnd0LOPropPresentations( const Fnd0LOPropPresentations& );
    Fnd0LOPropPresentations& operator=( const Fnd0LOPropPresentations& );

    friend class  Fnd0LOPropPresentationsDelegate;
    friend class  Fnd0LOPropPresentationsDispatch;
    friend class  Fnd0LOPropPresentationsGenImpl;
};

#include <property/libproperty_undef.h>
#endif //   TEAMCENTER__FND0LOPROPPRESENTATIONS__HXX
