//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0LOPropPresentationsDelegate
    Filename:   Fnd0LOPropPresentationsDelegate.hxx
    Module:     property
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0LOPROPPRESENTATIONSDELEGATE_HXX
#define TEAMCENTER__FND0LOPROPPRESENTATIONSDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <property/Fnd0LOPropPresentations.hxx>

#include <property/libproperty_exports.h>

namespace Teamcenter
{
    class Fnd0LOPropPresentationsDelegate;
}
namespace Teamcenter
{
    class Fnd0LOPropPresentationsImpl;
}
namespace Teamcenter
{
    class Fnd0LOPropPresentations;
}
namespace Teamcenter
{
    class Fnd0LOPropPresentationsGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PROPERTY_API Teamcenter_alias::Fnd0LOPropPresentationsDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0LOPropPresentationsDelegate instance
    static Fnd0LOPropPresentationsDelegate&  getInstance();

    //  Method to create the Fnd0LOPropPresentationsImpl pointer
    static Fnd0LOPropPresentationsImpl*  createImpl( Fnd0LOPropPresentations&  ifObj );

    //  Method to delete the Fnd0LOPropPresentationsImpl pointer
    static void deleteImpl( Fnd0LOPropPresentationsImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0GetMemberICODataBase(const Fnd0LOPropPresentations &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 12.4
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0IsWritableBase(const Fnd0LOPropPresentations &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 11.4
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0MemberPropertiesBase(const Fnd0LOPropPresentations &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0NavigationPathBase(const Fnd0LOPropPresentations &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0PresentedPropIDBase(const Fnd0LOPropPresentations &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0PresentedPropMemberIDBase(const Fnd0LOPropPresentations &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0RootOrMemberIDBase(const Fnd0LOPropPresentations &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0SourcePropertyBase(const Fnd0LOPropPresentations &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0SourceTypeNameBase(const Fnd0LOPropPresentations &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for Property Display Value
    /// @version Teamcenter 11.4
    /// @param values - Parameter value
    /// @return - Status. 0 if successful
    ///
    int  getFnd0SourceTypeNameDisplayableValuesBase(Fnd0LOPropPresentations &ifObj,  std::vector< std::string > &values );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.5
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0TraversalSegmentsBase(const Fnd0LOPropPresentations &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 11.5
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0GetMemberICODataBase(Fnd0LOPropPresentations &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 12.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0IsWritableBase(Fnd0LOPropPresentations &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.5
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0PresentedPropIDBase(Fnd0LOPropPresentations &ifObj,  const std::string &value, bool isNull );


    ///
    /// This is the getter for retrieving the recipe/permanent ID if its been created (and cached on the instance). Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param uid - Recipe/permanent ID
    /// @param isFirstTime - If Session Recovery Uid is yet to be set or does the object need to be serialized again?
    /// @return - Failure code
    ///
    int  fnd0AskSRUidBase(const Fnd0LOPropPresentations &ifObj,  std::string *uid, bool *isFirstTime ) const;


    ///
    /// Generates permanent ID/recipe. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param recipe - Permanent ID/recipe
    /// @return - Failure code.
    ///
    int  fnd0GenerateRecipeBase(const Fnd0LOPropPresentations &ifObj,  std::string *recipe );


    ///
    /// If Business Object supports recoverable ID. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param isPersistedRecipe - isPersistedRecipe param should be set to true if the recipe is limited to the user session and should be serialized to the database
    /// @param isRecoverableIDSupported - Returning true indicates support for recoverability/permanent IDs
    /// @return - Failure code.
    ///
    int  fnd0IsRecoverableBase(const Fnd0LOPropPresentations &ifObj,  bool *isPersistedRecipe, bool *isRecoverableIDSupported ) const;


    ///
    /// This is the setter for the recipe/permanent ID when it is created (to be cached on the instance). Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param uid - Rrecipe/permanent ID
    /// @return - Failure code.
    ///
    int  fnd0SetSRUidBase(const Fnd0LOPropPresentations &ifObj,  const std::string *uid );



protected:
    //  Pointer to the instance
    static Fnd0LOPropPresentationsDelegate*  m_pInstance;

    Fnd0LOPropPresentationsDelegate();
    virtual ~Fnd0LOPropPresentationsDelegate();
    static void setInstance( Fnd0LOPropPresentationsDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0LOPropPresentationsGenImpl;

};

#include <property/libproperty_undef.h>
#endif  //  TEAMCENTER__FND0LOPROPPRESENTATIONSDELEGATE_HXX
