//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0NameCounterGroups
    Filename:   Fnd0NameCounterGroups.hxx
    Module:     property
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0NAMECOUNTERGROUPS__HXX
#define TEAMCENTER__FND0NAMECOUNTERGROUPS__HXX

#include <vector>
#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <property/libproperty_exports.h>

namespace Teamcenter
{
    class Fnd0NameCounterGroups;
}
namespace Teamcenter
{
    class Fnd0NameCounterGroupsImpl;
}
namespace Teamcenter
{
    class Fnd0NameCounterGroupsDelegate;
}
namespace Teamcenter
{
    class Fnd0NameCounterGroupsDispatch;
}
namespace Teamcenter
{
    class Fnd0NameCounterGroupsGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PROPERTY_API  Teamcenter::Fnd0NameCounterGroups
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0CounterTags( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0DynamicPattern( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 11.2
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0CounterTags( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0DynamicPattern( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0NameCounterGroups();

    /**
     * Destructor
     */
    virtual ~Fnd0NameCounterGroups();

private:
    //  Getter method for the Implementation Object
    Fnd0NameCounterGroupsImpl*  getFnd0NameCounterGroupsImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0NameCounterGroupsImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0NameCounterGroupsImpl*  m_fnd0namecountergroupsImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0NameCounterGroups - desc for Fnd0NameCounterGroups parameter
     */
    Fnd0NameCounterGroups( const Fnd0NameCounterGroups& );
    Fnd0NameCounterGroups& operator=( const Fnd0NameCounterGroups& );

    friend class  Fnd0NameCounterGroupsDelegate;
    friend class  Fnd0NameCounterGroupsDispatch;
    friend class  Fnd0NameCounterGroupsGenImpl;
};

#include <property/libproperty_undef.h>
#endif //   TEAMCENTER__FND0NAMECOUNTERGROUPS__HXX
