//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0NameCounterGroupsDelegate
    Filename:   Fnd0NameCounterGroupsDelegate.hxx
    Module:     property
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0NAMECOUNTERGROUPSDELEGATE_HXX
#define TEAMCENTER__FND0NAMECOUNTERGROUPSDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <property/Fnd0NameCounterGroups.hxx>

#include <property/libproperty_exports.h>

namespace Teamcenter
{
    class Fnd0NameCounterGroupsDelegate;
}
namespace Teamcenter
{
    class Fnd0NameCounterGroupsImpl;
}
namespace Teamcenter
{
    class Fnd0NameCounterGroups;
}
namespace Teamcenter
{
    class Fnd0NameCounterGroupsGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PROPERTY_API Teamcenter_alias::Fnd0NameCounterGroupsDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0NameCounterGroupsDelegate instance
    static Fnd0NameCounterGroupsDelegate&  getInstance();

    //  Method to create the Fnd0NameCounterGroupsImpl pointer
    static Fnd0NameCounterGroupsImpl*  createImpl( Fnd0NameCounterGroups&  ifObj );

    //  Method to delete the Fnd0NameCounterGroupsImpl pointer
    static void deleteImpl( Fnd0NameCounterGroupsImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0CounterTagsBase(const Fnd0NameCounterGroups &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0DynamicPatternBase(const Fnd0NameCounterGroups &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 11.2
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0CounterTagsBase(Fnd0NameCounterGroups &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0DynamicPatternBase(Fnd0NameCounterGroups &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static Fnd0NameCounterGroupsDelegate*  m_pInstance;

    Fnd0NameCounterGroupsDelegate();
    virtual ~Fnd0NameCounterGroupsDelegate();
    static void setInstance( Fnd0NameCounterGroupsDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0NameCounterGroupsGenImpl;

};

#include <property/libproperty_undef.h>
#endif  //  TEAMCENTER__FND0NAMECOUNTERGROUPSDELEGATE_HXX
