//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0NameValue
    Filename:   Fnd0NameValue.hxx
    Module:     property
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0NAMEVALUE__HXX
#define TEAMCENTER__FND0NAMEVALUE__HXX

#include <common/tc_deprecation_macros.h>
#include <property/Fnd0TableRow.hxx>

#include <property/libproperty_exports.h>

namespace Teamcenter
{
    class Fnd0NameValue;
}
namespace Teamcenter
{
    class Fnd0NameValueImpl;
}
namespace Teamcenter
{
    class Fnd0NameValueDelegate;
}
namespace Teamcenter
{
    class Fnd0NameValueDispatch;
}
namespace Teamcenter
{
    class Fnd0NameValueGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PROPERTY_API  Teamcenter::Fnd0NameValue
     : public  ::Teamcenter::Fnd0TableRow
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0NameValue();

    /**
     * Destructor
     */
    virtual ~Fnd0NameValue();

private:
    //  Getter method for the Implementation Object
    Fnd0NameValueImpl*  getFnd0NameValueImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0NameValueImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0NameValueImpl*  m_fnd0namevalueImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0NameValue - desc for Fnd0NameValue parameter
     */
    Fnd0NameValue( const Fnd0NameValue& );
    Fnd0NameValue& operator=( const Fnd0NameValue& );

    friend class  Fnd0NameValueDelegate;
    friend class  Fnd0NameValueDispatch;
    friend class  Fnd0NameValueGenImpl;
};

#include <property/libproperty_undef.h>
#endif //   TEAMCENTER__FND0NAMEVALUE__HXX
