//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0PropertyDescriptor
    Filename:   Fnd0PropertyDescriptor.hxx
    Module:     property
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0PROPERTYDESCRIPTOR__HXX
#define TEAMCENTER__FND0PROPERTYDESCRIPTOR__HXX

#include <string>
#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <property/libproperty_exports.h>

namespace Teamcenter
{
    class Fnd0PropertyDescriptor;
}
namespace Teamcenter
{
    class Fnd0PropertyDescriptorImpl;
}
namespace Teamcenter
{
    class Fnd0PropertyDescriptorDelegate;
}
namespace Teamcenter
{
    class Fnd0PropertyDescriptorDispatch;
}
namespace Teamcenter
{
    class Fnd0PropertyDescriptorGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PROPERTY_API  Teamcenter::Fnd0PropertyDescriptor
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0Inherited( bool &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0OwningType( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0PropertyDefinition( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0PropertyDisplayName( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0PropertyName( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0PropertyType( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.5
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0PropertyDisplayName( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.5
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0PropertyName( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0PropertyDescriptor();

    /**
     * Destructor
     */
    virtual ~Fnd0PropertyDescriptor();

private:
    //  Getter method for the Implementation Object
    Fnd0PropertyDescriptorImpl*  getFnd0PropertyDescriptorImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0PropertyDescriptorImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0PropertyDescriptorImpl*  m_fnd0propertydescriptorImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0PropertyDescriptor - desc for Fnd0PropertyDescriptor parameter
     */
    Fnd0PropertyDescriptor( const Fnd0PropertyDescriptor& );
    Fnd0PropertyDescriptor& operator=( const Fnd0PropertyDescriptor& );

    friend class  Fnd0PropertyDescriptorDelegate;
    friend class  Fnd0PropertyDescriptorDispatch;
    friend class  Fnd0PropertyDescriptorGenImpl;
};

#include <property/libproperty_undef.h>
#endif //   TEAMCENTER__FND0PROPERTYDESCRIPTOR__HXX
