//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0PropertyDescriptorDelegate
    Filename:   Fnd0PropertyDescriptorDelegate.hxx
    Module:     property
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0PROPERTYDESCRIPTORDELEGATE_HXX
#define TEAMCENTER__FND0PROPERTYDESCRIPTORDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <property/Fnd0PropertyDescriptor.hxx>

#include <property/libproperty_exports.h>

namespace Teamcenter
{
    class Fnd0PropertyDescriptorDelegate;
}
namespace Teamcenter
{
    class Fnd0PropertyDescriptorImpl;
}
namespace Teamcenter
{
    class Fnd0PropertyDescriptor;
}
namespace Teamcenter
{
    class Fnd0PropertyDescriptorGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PROPERTY_API Teamcenter_alias::Fnd0PropertyDescriptorDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0PropertyDescriptorDelegate instance
    static Fnd0PropertyDescriptorDelegate&  getInstance();

    //  Method to create the Fnd0PropertyDescriptorImpl pointer
    static Fnd0PropertyDescriptorImpl*  createImpl( Fnd0PropertyDescriptor&  ifObj );

    //  Method to delete the Fnd0PropertyDescriptorImpl pointer
    static void deleteImpl( Fnd0PropertyDescriptorImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0InheritedBase(const Fnd0PropertyDescriptor &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0OwningTypeBase(const Fnd0PropertyDescriptor &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0PropertyDefinitionBase(const Fnd0PropertyDescriptor &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0PropertyDisplayNameBase(const Fnd0PropertyDescriptor &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0PropertyNameBase(const Fnd0PropertyDescriptor &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0PropertyTypeBase(const Fnd0PropertyDescriptor &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.5
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0PropertyDisplayNameBase(Fnd0PropertyDescriptor &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.5
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0PropertyNameBase(Fnd0PropertyDescriptor &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static Fnd0PropertyDescriptorDelegate*  m_pInstance;

    Fnd0PropertyDescriptorDelegate();
    virtual ~Fnd0PropertyDescriptorDelegate();
    static void setInstance( Fnd0PropertyDescriptorDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0PropertyDescriptorGenImpl;

};

#include <property/libproperty_undef.h>
#endif  //  TEAMCENTER__FND0PROPERTYDESCRIPTORDELEGATE_HXX
