//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0PropertyFormatter
    Filename:   Fnd0PropertyFormatter.hxx
    Module:     property
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0PROPERTYFORMATTER__HXX
#define TEAMCENTER__FND0PROPERTYFORMATTER__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <property/libproperty_exports.h>

namespace Teamcenter
{
    class Fnd0PropertyFormatter;
}
namespace Teamcenter
{
    class Fnd0PropertyFormatterImpl;
}
namespace Teamcenter
{
    class Fnd0PropertyFormatterDelegate;
}
namespace Teamcenter
{
    class Fnd0PropertyFormatterDispatch;
}
namespace Teamcenter
{
    class Fnd0PropertyFormatterGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PROPERTY_API  Teamcenter::Fnd0PropertyFormatter
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Operation for formatting a boolean value. This value will be formatted based on the format definition of this Property Formatter Business Object.
    /// @version Teamcenter 11.1
    /// @param value - The real value for boolean data type
    /// @param formattedValue - The formatted value
    /// @return - Status. 0 if successful
    ///
    int  fnd0format( bool value, std::string *formattedValue );

    ///
    /// Operation for formatting a double value. This value will be formatted based on the format definition of this Property Formatter Business Object.
    /// @version Teamcenter 11.1
    /// @param value - The real value for double data type
    /// @param formattedValue - The formatted value
    /// @return - Status. 0 if successful
    ///
    int  fnd0format( double value, std::string *formattedValue );

    ///
    /// Operation for formatting an integer value. This value will be formatted based on the format definition of this Property Formatter Business Object.
    /// @version Teamcenter 11.1
    /// @param value - The real value for integer data type
    /// @param formattedValue - The formatted value
    /// @return - Status. 0 if successful
    ///
    int  fnd0format( int value, std::string *formattedValue );

    ///
    /// Operation for formatting a string value. This value will be formatted based on the format definition of this Property Formatter Business Object.
    /// @version Teamcenter 11.1
    /// @param value - The real value for string data type
    /// @param formattedValue - The formatted value
    /// @return - Status. 0 if successful
    ///
    int  fnd0format( std::string *value, std::string *formattedValue );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0PropertyFormatter();

    /**
     * Destructor
     */
    virtual ~Fnd0PropertyFormatter();

private:
    //  Getter method for the Implementation Object
    Fnd0PropertyFormatterImpl*  getFnd0PropertyFormatterImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0PropertyFormatterImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0PropertyFormatterImpl*  m_fnd0propertyformatterImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0PropertyFormatter - desc for Fnd0PropertyFormatter parameter
     */
    Fnd0PropertyFormatter( const Fnd0PropertyFormatter& );
    Fnd0PropertyFormatter& operator=( const Fnd0PropertyFormatter& );

    friend class  Fnd0PropertyFormatterDelegate;
    friend class  Fnd0PropertyFormatterDispatch;
    friend class  Fnd0PropertyFormatterGenImpl;
};

#include <property/libproperty_undef.h>
#endif //   TEAMCENTER__FND0PROPERTYFORMATTER__HXX
