//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0PropertyFormatterDelegate
    Filename:   Fnd0PropertyFormatterDelegate.hxx
    Module:     property
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0PROPERTYFORMATTERDELEGATE_HXX
#define TEAMCENTER__FND0PROPERTYFORMATTERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <property/Fnd0PropertyFormatter.hxx>

#include <property/libproperty_exports.h>

namespace Teamcenter
{
    class Fnd0PropertyFormatterDelegate;
}
namespace Teamcenter
{
    class Fnd0PropertyFormatterImpl;
}
namespace Teamcenter
{
    class Fnd0PropertyFormatter;
}
namespace Teamcenter
{
    class Fnd0PropertyFormatterGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PROPERTY_API Teamcenter_alias::Fnd0PropertyFormatterDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0PropertyFormatterDelegate instance
    static Fnd0PropertyFormatterDelegate&  getInstance();

    //  Method to create the Fnd0PropertyFormatterImpl pointer
    static Fnd0PropertyFormatterImpl*  createImpl( Fnd0PropertyFormatter&  ifObj );

    //  Method to delete the Fnd0PropertyFormatterImpl pointer
    static void deleteImpl( Fnd0PropertyFormatterImpl*  impl );


    ///
    /// Operation for formatting a boolean value. This value will be formatted based on the format definition of this Property Formatter Business Object.
    /// @version Teamcenter 11.1
    /// @param value - The real value for boolean data type
    /// @param formattedValue - The formatted value
    /// @return - Status. 0 if successful
    ///
    int  fnd0formatBase(const Fnd0PropertyFormatter &ifObj,  bool value, std::string *formattedValue );


    ///
    /// Operation for formatting a double value. This value will be formatted based on the format definition of this Property Formatter Business Object.
    /// @version Teamcenter 11.1
    /// @param value - The real value for double data type
    /// @param formattedValue - The formatted value
    /// @return - Status. 0 if successful
    ///
    int  fnd0formatBase(const Fnd0PropertyFormatter &ifObj,  double value, std::string *formattedValue );


    ///
    /// Operation for formatting an integer value. This value will be formatted based on the format definition of this Property Formatter Business Object.
    /// @version Teamcenter 11.1
    /// @param value - The real value for integer data type
    /// @param formattedValue - The formatted value
    /// @return - Status. 0 if successful
    ///
    int  fnd0formatBase(const Fnd0PropertyFormatter &ifObj,  int value, std::string *formattedValue );


    ///
    /// Operation for formatting a string value. This value will be formatted based on the format definition of this Property Formatter Business Object.
    /// @version Teamcenter 11.1
    /// @param value - The real value for string data type
    /// @param formattedValue - The formatted value
    /// @return - Status. 0 if successful
    ///
    int  fnd0formatBase(const Fnd0PropertyFormatter &ifObj,  std::string *value, std::string *formattedValue );



protected:
    //  Pointer to the instance
    static Fnd0PropertyFormatterDelegate*  m_pInstance;

    Fnd0PropertyFormatterDelegate();
    virtual ~Fnd0PropertyFormatterDelegate();
    static void setInstance( Fnd0PropertyFormatterDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0PropertyFormatterGenImpl;

};

#include <property/libproperty_undef.h>
#endif  //  TEAMCENTER__FND0PROPERTYFORMATTERDELEGATE_HXX
