//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0TableRow
    Filename:   Fnd0TableRow.hxx
    Module:     property
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0TABLEROW__HXX
#define TEAMCENTER__FND0TABLEROW__HXX

#include <unidefs.h>
#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <property/libproperty_exports.h>

namespace Teamcenter
{
    class Fnd0TableRow;
}
namespace Teamcenter
{
    class Fnd0TableRowImpl;
}
namespace Teamcenter
{
    class Fnd0TableRowDelegate;
}
namespace Teamcenter
{
    class Fnd0TableRowDispatch;
}
namespace Teamcenter
{
    class Fnd0TableRowGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PROPERTY_API  Teamcenter::Fnd0TableRow
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIs_modifiable( bool &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0OwningObject( const tag_t &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0OwningPropName( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0TableRow();

    /**
     * Destructor
     */
    virtual ~Fnd0TableRow();

private:
    //  Getter method for the Implementation Object
    Fnd0TableRowImpl*  getFnd0TableRowImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0TableRowImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0TableRowImpl*  m_fnd0tablerowImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0TableRow - desc for Fnd0TableRow parameter
     */
    Fnd0TableRow( const Fnd0TableRow& );
    Fnd0TableRow& operator=( const Fnd0TableRow& );

    friend class  Fnd0TableRowDelegate;
    friend class  Fnd0TableRowDispatch;
    friend class  Fnd0TableRowGenImpl;
};

#include <property/libproperty_undef.h>
#endif //   TEAMCENTER__FND0TABLEROW__HXX
