//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0TraversalSegment
    Filename:   Fnd0TraversalSegment.hxx
    Module:     property
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0TRAVERSALSEGMENT__HXX
#define TEAMCENTER__FND0TRAVERSALSEGMENT__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <property/libproperty_exports.h>

namespace Teamcenter
{
    class Fnd0TraversalSegment;
}
namespace Teamcenter
{
    class Fnd0TraversalSegmentImpl;
}
namespace Teamcenter
{
    class Fnd0TraversalSegmentDelegate;
}
namespace Teamcenter
{
    class Fnd0TraversalSegmentDispatch;
}
namespace Teamcenter
{
    class Fnd0TraversalSegmentGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PROPERTY_API  Teamcenter::Fnd0TraversalSegment
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0DestinationCriteria( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0DestinationType( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0Direction( bool &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0PropertyType( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0RelationOrReference( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0SourceType( std::string &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0TraversalSegment();

    /**
     * Destructor
     */
    virtual ~Fnd0TraversalSegment();

private:
    //  Getter method for the Implementation Object
    Fnd0TraversalSegmentImpl*  getFnd0TraversalSegmentImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0TraversalSegmentImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0TraversalSegmentImpl*  m_fnd0traversalsegmentImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0TraversalSegment - desc for Fnd0TraversalSegment parameter
     */
    Fnd0TraversalSegment( const Fnd0TraversalSegment& );
    Fnd0TraversalSegment& operator=( const Fnd0TraversalSegment& );

    friend class  Fnd0TraversalSegmentDelegate;
    friend class  Fnd0TraversalSegmentDispatch;
    friend class  Fnd0TraversalSegmentGenImpl;
};

#include <property/libproperty_undef.h>
#endif //   TEAMCENTER__FND0TRAVERSALSEGMENT__HXX
