//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0TraversalSegmentDelegate
    Filename:   Fnd0TraversalSegmentDelegate.hxx
    Module:     property
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0TRAVERSALSEGMENTDELEGATE_HXX
#define TEAMCENTER__FND0TRAVERSALSEGMENTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <property/Fnd0TraversalSegment.hxx>

#include <property/libproperty_exports.h>

namespace Teamcenter
{
    class Fnd0TraversalSegmentDelegate;
}
namespace Teamcenter
{
    class Fnd0TraversalSegmentImpl;
}
namespace Teamcenter
{
    class Fnd0TraversalSegment;
}
namespace Teamcenter
{
    class Fnd0TraversalSegmentGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PROPERTY_API Teamcenter_alias::Fnd0TraversalSegmentDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0TraversalSegmentDelegate instance
    static Fnd0TraversalSegmentDelegate&  getInstance();

    //  Method to create the Fnd0TraversalSegmentImpl pointer
    static Fnd0TraversalSegmentImpl*  createImpl( Fnd0TraversalSegment&  ifObj );

    //  Method to delete the Fnd0TraversalSegmentImpl pointer
    static void deleteImpl( Fnd0TraversalSegmentImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0DestinationCriteriaBase(const Fnd0TraversalSegment &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0DestinationTypeBase(const Fnd0TraversalSegment &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0DirectionBase(const Fnd0TraversalSegment &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0PropertyTypeBase(const Fnd0TraversalSegment &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0RelationOrReferenceBase(const Fnd0TraversalSegment &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0SourceTypeBase(const Fnd0TraversalSegment &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// This is the getter for retrieving the recipe/permanent ID if its been created (and cached on the instance). Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param uid - Recipe/permanent ID
    /// @param isFirstTime - If Session Recovery Uid is yet to be set or does the object need to be serialized again?
    /// @return - Failure code
    ///
    int  fnd0AskSRUidBase(const Fnd0TraversalSegment &ifObj,  std::string *uid, bool *isFirstTime ) const;


    ///
    /// Generates permanent ID/recipe. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param recipe - Permanent ID/recipe
    /// @return - Failure code.
    ///
    int  fnd0GenerateRecipeBase(const Fnd0TraversalSegment &ifObj,  std::string *recipe );


    ///
    /// If Business Object supports recoverable ID. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param isPersistedRecipe - isPersistedRecipe param should be set to true if the recipe is limited to the user session and should be serialized to the database
    /// @param isRecoverableIDSupported - Returning true indicates support for recoverability/permanent IDs
    /// @return - Failure code.
    ///
    int  fnd0IsRecoverableBase(const Fnd0TraversalSegment &ifObj,  bool *isPersistedRecipe, bool *isRecoverableIDSupported ) const;


    ///
    /// This is the setter for the recipe/permanent ID when it is created (to be cached on the instance). Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param uid - Rrecipe/permanent ID
    /// @return - Failure code.
    ///
    int  fnd0SetSRUidBase(const Fnd0TraversalSegment &ifObj,  const std::string *uid );



protected:
    //  Pointer to the instance
    static Fnd0TraversalSegmentDelegate*  m_pInstance;

    Fnd0TraversalSegmentDelegate();
    virtual ~Fnd0TraversalSegmentDelegate();
    static void setInstance( Fnd0TraversalSegmentDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0TraversalSegmentGenImpl;

};

#include <property/libproperty_undef.h>
#endif  //  TEAMCENTER__FND0TRAVERSALSEGMENTDELEGATE_HXX
