//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ImanCompoundPropDef
    Filename:   ImanCompoundPropDef.hxx
    Module:     property
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IMANCOMPOUNDPROPDEF__HXX
#define TEAMCENTER__IMANCOMPOUNDPROPDEF__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/BusinessRule.hxx>

#include <property/libproperty_exports.h>

namespace Teamcenter
{
    class ImanCompoundPropDef;
}
namespace Teamcenter
{
    class ImanCompoundPropDefImpl;
}
namespace Teamcenter
{
    class ImanCompoundPropDefDelegate;
}
namespace Teamcenter
{
    class ImanCompoundPropDefDispatch;
}
namespace Teamcenter
{
    class ImanCompoundPropDefGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PROPERTY_API  Teamcenter::ImanCompoundPropDef
     : public  ::Teamcenter::BusinessRule
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ImanCompoundPropDef();

    /**
     * Destructor
     */
    virtual ~ImanCompoundPropDef();

private:
    //  Getter method for the Implementation Object
    ImanCompoundPropDefImpl*  getImanCompoundPropDefImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setImanCompoundPropDefImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ImanCompoundPropDefImpl*  m_imancompoundpropdefImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ImanCompoundPropDef - desc for ImanCompoundPropDef parameter
     */
    ImanCompoundPropDef( const ImanCompoundPropDef& );
    ImanCompoundPropDef& operator=( const ImanCompoundPropDef& );

    friend class  ImanCompoundPropDefDelegate;
    friend class  ImanCompoundPropDefDispatch;
    friend class  ImanCompoundPropDefGenImpl;
};

#include <property/libproperty_undef.h>
#endif //   TEAMCENTER__IMANCOMPOUNDPROPDEF__HXX
