//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, NameCounter
    Filename:   NameCounter.hxx
    Module:     property
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__NAMECOUNTER__HXX
#define TEAMCENTER__NAMECOUNTER__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <property/libproperty_exports.h>

namespace Teamcenter
{
    class NameCounter;
}
namespace Teamcenter
{
    class NameCounterImpl;
}
namespace Teamcenter
{
    class NameCounterDelegate;
}
namespace Teamcenter
{
    class NameCounterDispatch;
}
namespace Teamcenter
{
    class NameCounterGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PROPERTY_API  Teamcenter::NameCounter
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    NameCounter();

    /**
     * Destructor
     */
    virtual ~NameCounter();

private:
    //  Getter method for the Implementation Object
    NameCounterImpl*  getNameCounterImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setNameCounterImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    NameCounterImpl*  m_namecounterImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param NameCounter - desc for NameCounter parameter
     */
    NameCounter( const NameCounter& );
    NameCounter& operator=( const NameCounter& );

    friend class  NameCounterDelegate;
    friend class  NameCounterDispatch;
    friend class  NameCounterGenImpl;
};

#include <property/libproperty_undef.h>
#endif //   TEAMCENTER__NAMECOUNTER__HXX
