//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, NameField
    Filename:   NameField.hxx
    Module:     property
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__NAMEFIELD__HXX
#define TEAMCENTER__NAMEFIELD__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/BusinessRule.hxx>

#include <property/libproperty_exports.h>

namespace Teamcenter
{
    class NameField;
}
namespace Teamcenter
{
    class NameFieldImpl;
}
namespace Teamcenter
{
    class NameFieldDelegate;
}
namespace Teamcenter
{
    class NameFieldDispatch;
}
namespace Teamcenter
{
    class NameFieldGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PROPERTY_API  Teamcenter::NameField
     : public  ::Teamcenter::BusinessRule
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Boolean Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCondition_override( bool &value, bool &isNull ) const;

    ///
    /// Setter for a Boolean Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCondition_override( bool value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    NameField();

    /**
     * Destructor
     */
    virtual ~NameField();

private:
    //  Getter method for the Implementation Object
    NameFieldImpl*  getNameFieldImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setNameFieldImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    NameFieldImpl*  m_namefieldImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param NameField - desc for NameField parameter
     */
    NameField( const NameField& );
    NameField& operator=( const NameField& );

    friend class  NameFieldDelegate;
    friend class  NameFieldDispatch;
    friend class  NameFieldGenImpl;
};

#include <property/libproperty_undef.h>
#endif //   TEAMCENTER__NAMEFIELD__HXX
