//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, NameFieldDelegate
    Filename:   NameFieldDelegate.hxx
    Module:     property
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__NAMEFIELDDELEGATE_HXX
#define TEAMCENTER__NAMEFIELDDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <property/NameField.hxx>

#include <property/libproperty_exports.h>

namespace Teamcenter
{
    class NameFieldDelegate;
}
namespace Teamcenter
{
    class NameFieldImpl;
}
namespace Teamcenter
{
    class NameField;
}
namespace Teamcenter
{
    class NameFieldGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PROPERTY_API Teamcenter_alias::NameFieldDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the NameFieldDelegate instance
    static NameFieldDelegate&  getInstance();

    //  Method to create the NameFieldImpl pointer
    static NameFieldImpl*  createImpl( NameField&  ifObj );

    //  Method to delete the NameFieldImpl pointer
    static void deleteImpl( NameFieldImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCondition_overrideBase(const NameField &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Setter for a Boolean Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCondition_overrideBase(NameField &ifObj,  bool value, bool isNull );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static NameFieldDelegate*  m_pInstance;

    NameFieldDelegate();
    virtual ~NameFieldDelegate();
    static void setInstance( NameFieldDelegate*  instance );


private:
    friend class  ::Teamcenter::NameFieldGenImpl;

};

#include <property/libproperty_undef.h>
#endif  //  TEAMCENTER__NAMEFIELDDELEGATE_HXX
