//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, NameRule
    Filename:   NameRule.hxx
    Module:     property
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__NAMERULE__HXX
#define TEAMCENTER__NAMERULE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/BusinessRule.hxx>

#include <property/libproperty_exports.h>

namespace Teamcenter
{
    class NameRule;
}
namespace Teamcenter
{
    class NameRuleImpl;
}
namespace Teamcenter
{
    class NameRuleDelegate;
}
namespace Teamcenter
{
    class NameRuleDispatch;
}
namespace Teamcenter
{
    class NameRuleGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PROPERTY_API  Teamcenter::NameRule
     : public  ::Teamcenter::BusinessRule
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    NameRule();

    /**
     * Destructor
     */
    virtual ~NameRule();

private:
    //  Getter method for the Implementation Object
    NameRuleImpl*  getNameRuleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setNameRuleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    NameRuleImpl*  m_nameruleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param NameRule - desc for NameRule parameter
     */
    NameRule( const NameRule& );
    NameRule& operator=( const NameRule& );

    friend class  NameRuleDelegate;
    friend class  NameRuleDispatch;
    friend class  NameRuleGenImpl;
};

#include <property/libproperty_undef.h>
#endif //   TEAMCENTER__NAMERULE__HXX
