//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, NameRulePattern
    Filename:   NameRulePattern.hxx
    Module:     property
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__NAMERULEPATTERN__HXX
#define TEAMCENTER__NAMERULEPATTERN__HXX

#include <vector>
#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <property/libproperty_exports.h>

namespace Teamcenter
{
    class NameRulePattern;
}
namespace Teamcenter
{
    class NameRulePatternImpl;
}
namespace Teamcenter
{
    class NameRulePatternDelegate;
}
namespace Teamcenter
{
    class NameRulePatternDispatch;
}
namespace Teamcenter
{
    class NameRulePatternGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PROPERTY_API  Teamcenter::NameRulePattern
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Boolean Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAutogen( bool &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Tc 8
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCounter_tags( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPattern( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPattern_desc( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a Boolean Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAutogen( bool value, bool isNull=false );

    ///
    /// Setter for a Tag Array Property
    /// @version Tc 8
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setCounter_tags( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPattern( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPattern_desc( const std::string &value, bool isNull=false );

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0CounterGroupTags( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 11.2
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0CounterGroupTags( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    NameRulePattern();

    /**
     * Destructor
     */
    virtual ~NameRulePattern();

private:
    //  Getter method for the Implementation Object
    NameRulePatternImpl*  getNameRulePatternImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setNameRulePatternImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    NameRulePatternImpl*  m_namerulepatternImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param NameRulePattern - desc for NameRulePattern parameter
     */
    NameRulePattern( const NameRulePattern& );
    NameRulePattern& operator=( const NameRulePattern& );

    friend class  NameRulePatternDelegate;
    friend class  NameRulePatternDispatch;
    friend class  NameRulePatternGenImpl;
};

#include <property/libproperty_undef.h>
#endif //   TEAMCENTER__NAMERULEPATTERN__HXX
