//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, NameRulePatternDelegate
    Filename:   NameRulePatternDelegate.hxx
    Module:     property
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__NAMERULEPATTERNDELEGATE_HXX
#define TEAMCENTER__NAMERULEPATTERNDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <property/NameRulePattern.hxx>

#include <property/libproperty_exports.h>

namespace Teamcenter
{
    class NameRulePatternDelegate;
}
namespace Teamcenter
{
    class NameRulePatternImpl;
}
namespace Teamcenter
{
    class NameRulePattern;
}
namespace Teamcenter
{
    class NameRulePatternGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PROPERTY_API Teamcenter_alias::NameRulePatternDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the NameRulePatternDelegate instance
    static NameRulePatternDelegate&  getInstance();

    //  Method to create the NameRulePatternImpl pointer
    static NameRulePatternImpl*  createImpl( NameRulePattern&  ifObj );

    //  Method to delete the NameRulePatternImpl pointer
    static void deleteImpl( NameRulePatternImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAutogenBase(const NameRulePattern &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Tc 8
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCounter_tagsBase(const NameRulePattern &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPatternBase(const NameRulePattern &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPattern_descBase(const NameRulePattern &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a Boolean Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAutogenBase(NameRulePattern &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Tc 8
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setCounter_tagsBase(NameRulePattern &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPatternBase(NameRulePattern &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPattern_descBase(NameRulePattern &ifObj,  const std::string &value, bool isNull );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0CounterGroupTagsBase(const NameRulePattern &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 11.2
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0CounterGroupTagsBase(NameRulePattern &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );



protected:
    //  Pointer to the instance
    static NameRulePatternDelegate*  m_pInstance;

    NameRulePatternDelegate();
    virtual ~NameRulePatternDelegate();
    static void setInstance( NameRulePatternDelegate*  instance );


private:
    friend class  ::Teamcenter::NameRulePatternGenImpl;

};

#include <property/libproperty_undef.h>
#endif  //  TEAMCENTER__NAMERULEPATTERNDELEGATE_HXX
