//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, NextIdFieldDelegate
    Filename:   NextIdFieldDelegate.hxx
    Module:     property
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__NEXTIDFIELDDELEGATE_HXX
#define TEAMCENTER__NEXTIDFIELDDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <property/NextIdField.hxx>

#include <property/libproperty_exports.h>

namespace Teamcenter
{
    class NextIdFieldDelegate;
}
namespace Teamcenter
{
    class NextIdFieldImpl;
}
namespace Teamcenter
{
    class NextIdField;
}
namespace Teamcenter
{
    class NextIdFieldGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PROPERTY_API Teamcenter_alias::NextIdFieldDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the NextIdFieldDelegate instance
    static NextIdFieldDelegate&  getInstance();

    //  Method to create the NextIdFieldImpl pointer
    static NextIdFieldImpl*  createImpl( NextIdField&  ifObj );

    //  Method to delete the NextIdFieldImpl pointer
    static void deleteImpl( NextIdFieldImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getName_field_tagBase(const NextIdField &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getNext_idBase(const NextIdField &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setName_field_tagBase(NextIdField &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setNext_idBase(NextIdField &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static NextIdFieldDelegate*  m_pInstance;

    NextIdFieldDelegate();
    virtual ~NextIdFieldDelegate();
    static void setInstance( NextIdFieldDelegate*  instance );


private:
    friend class  ::Teamcenter::NextIdFieldGenImpl;

};

#include <property/libproperty_undef.h>
#endif  //  TEAMCENTER__NEXTIDFIELDDELEGATE_HXX
