//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PropRule
    Filename:   PropRule.hxx
    Module:     property
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROPRULE__HXX
#define TEAMCENTER__PROPRULE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/BusinessRule.hxx>

#include <property/libproperty_exports.h>

namespace Teamcenter
{
    class PropRule;
}
namespace Teamcenter
{
    class PropRuleImpl;
}
namespace Teamcenter
{
    class PropRuleDelegate;
}
namespace Teamcenter
{
    class PropRuleDispatch;
}
namespace Teamcenter
{
    class PropRuleGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PROPERTY_API  Teamcenter::PropRule
     : public  ::Teamcenter::BusinessRule
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PropRule();

    /**
     * Destructor
     */
    virtual ~PropRule();

private:
    //  Getter method for the Implementation Object
    PropRuleImpl*  getPropRuleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPropRuleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PropRuleImpl*  m_propruleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PropRule - desc for PropRule parameter
     */
    PropRule( const PropRule& );
    PropRule& operator=( const PropRule& );

    friend class  PropRuleDelegate;
    friend class  PropRuleDispatch;
    friend class  PropRuleGenImpl;
};

#include <property/libproperty_undef.h>
#endif //   TEAMCENTER__PROPRULE__HXX
