//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PropRuleDelegate
    Filename:   PropRuleDelegate.hxx
    Module:     property
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROPRULEDELEGATE_HXX
#define TEAMCENTER__PROPRULEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <property/PropRule.hxx>

#include <property/libproperty_exports.h>

namespace Teamcenter
{
    class PropRuleDelegate;
}
namespace Teamcenter
{
    class PropRuleImpl;
}
namespace Teamcenter
{
    class PropRule;
}
namespace Teamcenter
{
    class PropRuleGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PROPERTY_API Teamcenter_alias::PropRuleDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PropRuleDelegate instance
    static PropRuleDelegate&  getInstance();

    //  Method to create the PropRuleImpl pointer
    static PropRuleImpl*  createImpl( PropRule&  ifObj );

    //  Method to delete the PropRuleImpl pointer
    static void deleteImpl( PropRuleImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static PropRuleDelegate*  m_pInstance;

    PropRuleDelegate();
    virtual ~PropRuleDelegate();
    static void setInstance( PropRuleDelegate*  instance );


private:
    friend class  ::Teamcenter::PropRuleGenImpl;

};

#include <property/libproperty_undef.h>
#endif  //  TEAMCENTER__PROPRULEDELEGATE_HXX
