//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PropertyInfoDelegate
    Filename:   PropertyInfoDelegate.hxx
    Module:     property
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROPERTYINFODELEGATE_HXX
#define TEAMCENTER__PROPERTYINFODELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <property/PropertyInfo.hxx>

#include <property/libproperty_exports.h>

namespace Teamcenter
{
    class PropertyInfoDelegate;
}
namespace Teamcenter
{
    class PropertyInfoImpl;
}
namespace Teamcenter
{
    class PropertyInfo;
}
namespace Teamcenter
{
    class PropertyInfoGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PROPERTY_API Teamcenter_alias::PropertyInfoDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PropertyInfoDelegate instance
    static PropertyInfoDelegate&  getInstance();

    //  Method to create the PropertyInfoImpl pointer
    static PropertyInfoImpl*  createImpl( PropertyInfo&  ifObj );

    //  Method to delete the PropertyInfoImpl pointer
    static void deleteImpl( PropertyInfoImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBusiness_objectBase(const PropertyInfo &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getProperty_nameBase(const PropertyInfo &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setBusiness_objectBase(PropertyInfo &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setProperty_nameBase(PropertyInfo &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static PropertyInfoDelegate*  m_pInstance;

    PropertyInfoDelegate();
    virtual ~PropertyInfoDelegate();
    static void setInstance( PropertyInfoDelegate*  instance );


private:
    friend class  ::Teamcenter::PropertyInfoGenImpl;

};

#include <property/libproperty_undef.h>
#endif  //  TEAMCENTER__PROPERTYINFODELEGATE_HXX
