//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RevNextIdFieldDelegate
    Filename:   RevNextIdFieldDelegate.hxx
    Module:     property
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REVNEXTIDFIELDDELEGATE_HXX
#define TEAMCENTER__REVNEXTIDFIELDDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <property/RevNextIdField.hxx>

#include <property/libproperty_exports.h>

namespace Teamcenter
{
    class RevNextIdFieldDelegate;
}
namespace Teamcenter
{
    class RevNextIdFieldImpl;
}
namespace Teamcenter
{
    class RevNextIdField;
}
namespace Teamcenter
{
    class RevNextIdFieldGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PROPERTY_API Teamcenter_alias::RevNextIdFieldDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the RevNextIdFieldDelegate instance
    static RevNextIdFieldDelegate&  getInstance();

    //  Method to create the RevNextIdFieldImpl pointer
    static RevNextIdFieldImpl*  createImpl( RevNextIdField&  ifObj );

    //  Method to delete the RevNextIdFieldImpl pointer
    static void deleteImpl( RevNextIdFieldImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getInit_next_idBase(const RevNextIdField &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRev_name_field_tagBase(const RevNextIdField &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSec_next_idBase(const RevNextIdField &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSuppl_next_idBase(const RevNextIdField &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setInit_next_idBase(RevNextIdField &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setRev_name_field_tagBase(RevNextIdField &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSec_next_idBase(RevNextIdField &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSuppl_next_idBase(RevNextIdField &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static RevNextIdFieldDelegate*  m_pInstance;

    RevNextIdFieldDelegate();
    virtual ~RevNextIdFieldDelegate();
    static void setInstance( RevNextIdFieldDelegate*  instance );


private:
    friend class  ::Teamcenter::RevNextIdFieldGenImpl;

};

#include <property/libproperty_undef.h>
#endif  //  TEAMCENTER__REVNEXTIDFIELDDELEGATE_HXX
