//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RevisionNameRule
    Filename:   RevisionNameRule.hxx
    Module:     property
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REVISIONNAMERULE__HXX
#define TEAMCENTER__REVISIONNAMERULE__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/BusinessRule.hxx>

#include <property/libproperty_exports.h>

namespace Teamcenter
{
    class RevisionNameRule;
}
namespace Teamcenter
{
    class RevisionNameRuleImpl;
}
namespace Teamcenter
{
    class RevisionNameRuleDelegate;
}
namespace Teamcenter
{
    class RevisionNameRuleDispatch;
}
namespace Teamcenter
{
    class RevisionNameRuleGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PROPERTY_API  Teamcenter::RevisionNameRule
     : public  ::Teamcenter::BusinessRule
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Boolean Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getExclude_skip_letters( bool &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getInit_rev_desc( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getInit_rev_start( std::string &value, bool &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getInit_rev_type( int &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRule_name( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSec_rev_desc( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSec_rev_start( std::string &value, bool &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSec_rev_type( int &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSuppl_rev_desc( std::string &value, bool &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSuppl_rev_format( int &value, bool &isNull ) const;

    ///
    /// Setter for a Boolean Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setExclude_skip_letters( bool value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setInit_rev_desc( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setInit_rev_start( const std::string &value, bool isNull=false );

    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setInit_rev_type( int value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setRule_name( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSec_rev_desc( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSec_rev_start( const std::string &value, bool isNull=false );

    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSec_rev_type( int value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSuppl_rev_desc( const std::string &value, bool isNull=false );

    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSuppl_rev_format( int value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    RevisionNameRule();

    /**
     * Destructor
     */
    virtual ~RevisionNameRule();

private:
    //  Getter method for the Implementation Object
    RevisionNameRuleImpl*  getRevisionNameRuleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRevisionNameRuleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    RevisionNameRuleImpl*  m_revisionnameruleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param RevisionNameRule - desc for RevisionNameRule parameter
     */
    RevisionNameRule( const RevisionNameRule& );
    RevisionNameRule& operator=( const RevisionNameRule& );

    friend class  RevisionNameRuleDelegate;
    friend class  RevisionNameRuleDispatch;
    friend class  RevisionNameRuleGenImpl;
};

#include <property/libproperty_undef.h>
#endif //   TEAMCENTER__REVISIONNAMERULE__HXX
