//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RevisionNameRuleAttach
    Filename:   RevisionNameRuleAttach.hxx
    Module:     property
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REVISIONNAMERULEATTACH__HXX
#define TEAMCENTER__REVISIONNAMERULEATTACH__HXX

#include <unidefs.h>
#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/BusinessRule.hxx>

#include <property/libproperty_exports.h>

namespace Teamcenter
{
    class RevisionNameRuleAttach;
}
namespace Teamcenter
{
    class RevisionNameRuleAttachImpl;
}
namespace Teamcenter
{
    class RevisionNameRuleAttachDelegate;
}
namespace Teamcenter
{
    class RevisionNameRuleAttachDispatch;
}
namespace Teamcenter
{
    class RevisionNameRuleAttachGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PROPERTY_API  Teamcenter::RevisionNameRuleAttach
     : public  ::Teamcenter::BusinessRule
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCase( int &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRev_rule_tag( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getType_name( std::string &value, bool &isNull ) const;

    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCase( int value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setRev_rule_tag( const tag_t &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setType_name( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    RevisionNameRuleAttach();

    /**
     * Destructor
     */
    virtual ~RevisionNameRuleAttach();

private:
    //  Getter method for the Implementation Object
    RevisionNameRuleAttachImpl*  getRevisionNameRuleAttachImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRevisionNameRuleAttachImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    RevisionNameRuleAttachImpl*  m_revisionnameruleattachImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param RevisionNameRuleAttach - desc for RevisionNameRuleAttach parameter
     */
    RevisionNameRuleAttach( const RevisionNameRuleAttach& );
    RevisionNameRuleAttach& operator=( const RevisionNameRuleAttach& );

    friend class  RevisionNameRuleAttachDelegate;
    friend class  RevisionNameRuleAttachDispatch;
    friend class  RevisionNameRuleAttachGenImpl;
};

#include <property/libproperty_undef.h>
#endif //   TEAMCENTER__REVISIONNAMERULEATTACH__HXX
