//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RevisionNameRuleAttachDelegate
    Filename:   RevisionNameRuleAttachDelegate.hxx
    Module:     property
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REVISIONNAMERULEATTACHDELEGATE_HXX
#define TEAMCENTER__REVISIONNAMERULEATTACHDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <property/RevisionNameRuleAttach.hxx>

#include <property/libproperty_exports.h>

namespace Teamcenter
{
    class RevisionNameRuleAttachDelegate;
}
namespace Teamcenter
{
    class RevisionNameRuleAttachImpl;
}
namespace Teamcenter
{
    class RevisionNameRuleAttach;
}
namespace Teamcenter
{
    class RevisionNameRuleAttachGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PROPERTY_API Teamcenter_alias::RevisionNameRuleAttachDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the RevisionNameRuleAttachDelegate instance
    static RevisionNameRuleAttachDelegate&  getInstance();

    //  Method to create the RevisionNameRuleAttachImpl pointer
    static RevisionNameRuleAttachImpl*  createImpl( RevisionNameRuleAttach&  ifObj );

    //  Method to delete the RevisionNameRuleAttachImpl pointer
    static void deleteImpl( RevisionNameRuleAttachImpl*  impl );


    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCaseBase(const RevisionNameRuleAttach &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRev_rule_tagBase(const RevisionNameRuleAttach &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getType_nameBase(const RevisionNameRuleAttach &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCaseBase(RevisionNameRuleAttach &ifObj,  int value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setRev_rule_tagBase(RevisionNameRuleAttach &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setType_nameBase(RevisionNameRuleAttach &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static RevisionNameRuleAttachDelegate*  m_pInstance;

    RevisionNameRuleAttachDelegate();
    virtual ~RevisionNameRuleAttachDelegate();
    static void setInstance( RevisionNameRuleAttachDelegate*  instance );


private:
    friend class  ::Teamcenter::RevisionNameRuleAttachGenImpl;

};

#include <property/libproperty_undef.h>
#endif  //  TEAMCENTER__REVISIONNAMERULEATTACHDELEGATE_HXX
