//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  property

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libproperty

#if !defined(LIBPROPERTY) && !defined(IPLIB)
#   error IPLIB or LIBPROPERTY is not defined
#endif

/* Handwritten code should use PROPERTY_API, not PROPERTYEXPORT */

#define PROPERTY_API PROPERTYEXPORT

#if IPLIB==libproperty || defined(LIBPROPERTY)
#   if defined(__lint)
#       define PROPERTYEXPORT       __export(property)
#       define PROPERTYGLOBAL       extern __global(property)
#       define PROPERTYPRIVATE      extern __private(property)
#   elif defined(_WIN32)
#       define PROPERTYEXPORT       __declspec(dllexport)
#       define PROPERTYGLOBAL       extern __declspec(dllexport)
#       define PROPERTYPRIVATE      extern
#   else
#       define PROPERTYEXPORT
#       define PROPERTYGLOBAL       extern
#       define PROPERTYPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define PROPERTYEXPORT       __export(property)
#       define PROPERTYGLOBAL       extern __global(property)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define PROPERTYEXPORT      __declspec(dllimport)
#       define PROPERTYGLOBAL       extern __declspec(dllimport)
#   else
#       define PROPERTYEXPORT
#       define PROPERTYGLOBAL       extern
#   endif
#endif
