//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AbsOccArchRef
    Filename:   AbsOccArchRef.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ABSOCCARCHREF__HXX
#define TEAMCENTER__ABSOCCARCHREF__HXX

#include <common/tc_deprecation_macros.h>
#include <ps/AbsOccData.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class AbsOccArchRef;
}
namespace Teamcenter
{
    class AbsOccArchRefImpl;
}
namespace Teamcenter
{
    class AbsOccArchRefDelegate;
}
namespace Teamcenter
{
    class AbsOccArchRefDispatch;
}
namespace Teamcenter
{
    class AbsOccArchRefGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::AbsOccArchRef
     : public  ::Teamcenter::AbsOccData
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AbsOccArchRef();

    /**
     * Destructor
     */
    virtual ~AbsOccArchRef();

private:
    //  Getter method for the Implementation Object
    AbsOccArchRefImpl*  getAbsOccArchRefImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAbsOccArchRefImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AbsOccArchRefImpl*  m_absoccarchrefImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AbsOccArchRef - desc for AbsOccArchRef parameter
     */
    AbsOccArchRef( const AbsOccArchRef& );
    AbsOccArchRef& operator=( const AbsOccArchRef& );

    friend class  AbsOccArchRefDelegate;
    friend class  AbsOccArchRefDispatch;
    friend class  AbsOccArchRefGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__ABSOCCARCHREF__HXX
