//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AbsOccArchRefDelegate
    Filename:   AbsOccArchRefDelegate.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ABSOCCARCHREFDELEGATE_HXX
#define TEAMCENTER__ABSOCCARCHREFDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ps/AbsOccArchRef.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class AbsOccArchRefDelegate;
}
namespace Teamcenter
{
    class AbsOccArchRefImpl;
}
namespace Teamcenter
{
    class AbsOccArchRef;
}
namespace Teamcenter
{
    class AbsOccArchRefGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PS_API Teamcenter_alias::AbsOccArchRefDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the AbsOccArchRefDelegate instance
    static AbsOccArchRefDelegate&  getInstance();

    //  Method to create the AbsOccArchRefImpl pointer
    static AbsOccArchRefImpl*  createImpl( AbsOccArchRef&  ifObj );

    //  Method to delete the AbsOccArchRefImpl pointer
    static void deleteImpl( AbsOccArchRefImpl*  impl );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const AbsOccArchRef &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const AbsOccArchRef &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static AbsOccArchRefDelegate*  m_pInstance;

    AbsOccArchRefDelegate();
    virtual ~AbsOccArchRefDelegate();
    static void setInstance( AbsOccArchRefDelegate*  instance );


private:
    friend class  ::Teamcenter::AbsOccArchRefGenImpl;

};

#include <ps/libps_undef.h>
#endif  //  TEAMCENTER__ABSOCCARCHREFDELEGATE_HXX
