//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AbsOccChildItem
    Filename:   AbsOccChildItem.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ABSOCCCHILDITEM__HXX
#define TEAMCENTER__ABSOCCCHILDITEM__HXX

#include <common/tc_deprecation_macros.h>
#include <ps/AbsOccData.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class AbsOccChildItem;
}
namespace Teamcenter
{
    class AbsOccChildItemImpl;
}
namespace Teamcenter
{
    class AbsOccChildItemDelegate;
}
namespace Teamcenter
{
    class AbsOccChildItemDispatch;
}
namespace Teamcenter
{
    class AbsOccChildItemGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::AbsOccChildItem
     : public  ::Teamcenter::AbsOccData
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AbsOccChildItem();

    /**
     * Destructor
     */
    virtual ~AbsOccChildItem();

private:
    //  Getter method for the Implementation Object
    AbsOccChildItemImpl*  getAbsOccChildItemImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAbsOccChildItemImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AbsOccChildItemImpl*  m_absoccchilditemImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AbsOccChildItem - desc for AbsOccChildItem parameter
     */
    AbsOccChildItem( const AbsOccChildItem& );
    AbsOccChildItem& operator=( const AbsOccChildItem& );

    friend class  AbsOccChildItemDelegate;
    friend class  AbsOccChildItemDispatch;
    friend class  AbsOccChildItemGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__ABSOCCCHILDITEM__HXX
