//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AbsOccData
    Filename:   AbsOccData.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ABSOCCDATA__HXX
#define TEAMCENTER__ABSOCCDATA__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class AbsOccData;
}
namespace Teamcenter
{
    class AbsOccDataImpl;
}
namespace Teamcenter
{
    class AbsOccDataDelegate;
}
namespace Teamcenter
{
    class AbsOccDataDispatch;
}
namespace Teamcenter
{
    class AbsOccDataGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::AbsOccData
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AbsOccData();

    /**
     * Destructor
     */
    virtual ~AbsOccData();

private:
    //  Getter method for the Implementation Object
    AbsOccDataImpl*  getAbsOccDataImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAbsOccDataImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AbsOccDataImpl*  m_absoccdataImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AbsOccData - desc for AbsOccData parameter
     */
    AbsOccData( const AbsOccData& );
    AbsOccData& operator=( const AbsOccData& );

    friend class  AbsOccDataDelegate;
    friend class  AbsOccDataDispatch;
    friend class  AbsOccDataGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__ABSOCCDATA__HXX
