//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AbsOccDataQualifier
    Filename:   AbsOccDataQualifier.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ABSOCCDATAQUALIFIER__HXX
#define TEAMCENTER__ABSOCCDATAQUALIFIER__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class AbsOccDataQualifier;
}
namespace Teamcenter
{
    class AbsOccDataQualifierImpl;
}
namespace Teamcenter
{
    class AbsOccDataQualifierDelegate;
}
namespace Teamcenter
{
    class AbsOccDataQualifierDispatch;
}
namespace Teamcenter
{
    class AbsOccDataQualifierGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::AbsOccDataQualifier
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AbsOccDataQualifier();

    /**
     * Destructor
     */
    virtual ~AbsOccDataQualifier();

private:
    //  Getter method for the Implementation Object
    AbsOccDataQualifierImpl*  getAbsOccDataQualifierImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAbsOccDataQualifierImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AbsOccDataQualifierImpl*  m_absoccdataqualifierImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AbsOccDataQualifier - desc for AbsOccDataQualifier parameter
     */
    AbsOccDataQualifier( const AbsOccDataQualifier& );
    AbsOccDataQualifier& operator=( const AbsOccDataQualifier& );

    friend class  AbsOccDataQualifierDelegate;
    friend class  AbsOccDataQualifierDispatch;
    friend class  AbsOccDataQualifierGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__ABSOCCDATAQUALIFIER__HXX
