//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AbsOccFlags
    Filename:   AbsOccFlags.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ABSOCCFLAGS__HXX
#define TEAMCENTER__ABSOCCFLAGS__HXX

#include <common/tc_deprecation_macros.h>
#include <ps/AbsOccData.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class AbsOccFlags;
}
namespace Teamcenter
{
    class AbsOccFlagsImpl;
}
namespace Teamcenter
{
    class AbsOccFlagsDelegate;
}
namespace Teamcenter
{
    class AbsOccFlagsDispatch;
}
namespace Teamcenter
{
    class AbsOccFlagsGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::AbsOccFlags
     : public  ::Teamcenter::AbsOccData
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AbsOccFlags();

    /**
     * Destructor
     */
    virtual ~AbsOccFlags();

private:
    //  Getter method for the Implementation Object
    AbsOccFlagsImpl*  getAbsOccFlagsImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAbsOccFlagsImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AbsOccFlagsImpl*  m_absoccflagsImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AbsOccFlags - desc for AbsOccFlags parameter
     */
    AbsOccFlags( const AbsOccFlags& );
    AbsOccFlags& operator=( const AbsOccFlags& );

    friend class  AbsOccFlagsDelegate;
    friend class  AbsOccFlagsDispatch;
    friend class  AbsOccFlagsGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__ABSOCCFLAGS__HXX
