//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AbsOccGdeObject
    Filename:   AbsOccGdeObject.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ABSOCCGDEOBJECT__HXX
#define TEAMCENTER__ABSOCCGDEOBJECT__HXX

#include <common/tc_deprecation_macros.h>
#include <ps/AbsOccData.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class AbsOccGdeObject;
}
namespace Teamcenter
{
    class AbsOccGdeObjectImpl;
}
namespace Teamcenter
{
    class AbsOccGdeObjectDelegate;
}
namespace Teamcenter
{
    class AbsOccGdeObjectDispatch;
}
namespace Teamcenter
{
    class AbsOccGdeObjectGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::AbsOccGdeObject
     : public  ::Teamcenter::AbsOccData
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AbsOccGdeObject();

    /**
     * Destructor
     */
    virtual ~AbsOccGdeObject();

private:
    //  Getter method for the Implementation Object
    AbsOccGdeObjectImpl*  getAbsOccGdeObjectImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAbsOccGdeObjectImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AbsOccGdeObjectImpl*  m_absoccgdeobjectImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AbsOccGdeObject - desc for AbsOccGdeObject parameter
     */
    AbsOccGdeObject( const AbsOccGdeObject& );
    AbsOccGdeObject& operator=( const AbsOccGdeObject& );

    friend class  AbsOccGdeObjectDelegate;
    friend class  AbsOccGdeObjectDispatch;
    friend class  AbsOccGdeObjectGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__ABSOCCGDEOBJECT__HXX
