//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AbsOccGrmAnchor
    Filename:   AbsOccGrmAnchor.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ABSOCCGRMANCHOR__HXX
#define TEAMCENTER__ABSOCCGRMANCHOR__HXX

#include <common/tc_deprecation_macros.h>
#include <ps/AbsOccData.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class AbsOccGrmAnchor;
}
namespace Teamcenter
{
    class AbsOccGrmAnchorImpl;
}
namespace Teamcenter
{
    class AbsOccGrmAnchorDelegate;
}
namespace Teamcenter
{
    class AbsOccGrmAnchorDispatch;
}
namespace Teamcenter
{
    class AbsOccGrmAnchorGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::AbsOccGrmAnchor
     : public  ::Teamcenter::AbsOccData
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AbsOccGrmAnchor();

    /**
     * Destructor
     */
    virtual ~AbsOccGrmAnchor();

private:
    //  Getter method for the Implementation Object
    AbsOccGrmAnchorImpl*  getAbsOccGrmAnchorImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAbsOccGrmAnchorImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AbsOccGrmAnchorImpl*  m_absoccgrmanchorImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AbsOccGrmAnchor - desc for AbsOccGrmAnchor parameter
     */
    AbsOccGrmAnchor( const AbsOccGrmAnchor& );
    AbsOccGrmAnchor& operator=( const AbsOccGrmAnchor& );

    friend class  AbsOccGrmAnchorDelegate;
    friend class  AbsOccGrmAnchorDispatch;
    friend class  AbsOccGrmAnchorGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__ABSOCCGRMANCHOR__HXX
