//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AbsOccInstanceNo
    Filename:   AbsOccInstanceNo.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ABSOCCINSTANCENO__HXX
#define TEAMCENTER__ABSOCCINSTANCENO__HXX

#include <common/tc_deprecation_macros.h>
#include <ps/AbsOccData.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class AbsOccInstanceNo;
}
namespace Teamcenter
{
    class AbsOccInstanceNoImpl;
}
namespace Teamcenter
{
    class AbsOccInstanceNoDelegate;
}
namespace Teamcenter
{
    class AbsOccInstanceNoDispatch;
}
namespace Teamcenter
{
    class AbsOccInstanceNoGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::AbsOccInstanceNo
     : public  ::Teamcenter::AbsOccData
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AbsOccInstanceNo();

    /**
     * Destructor
     */
    virtual ~AbsOccInstanceNo();

private:
    //  Getter method for the Implementation Object
    AbsOccInstanceNoImpl*  getAbsOccInstanceNoImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAbsOccInstanceNoImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AbsOccInstanceNoImpl*  m_absoccinstancenoImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AbsOccInstanceNo - desc for AbsOccInstanceNo parameter
     */
    AbsOccInstanceNo( const AbsOccInstanceNo& );
    AbsOccInstanceNo& operator=( const AbsOccInstanceNo& );

    friend class  AbsOccInstanceNoDelegate;
    friend class  AbsOccInstanceNoDispatch;
    friend class  AbsOccInstanceNoGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__ABSOCCINSTANCENO__HXX
