//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AbsOccName
    Filename:   AbsOccName.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ABSOCCNAME__HXX
#define TEAMCENTER__ABSOCCNAME__HXX

#include <common/tc_deprecation_macros.h>
#include <ps/AbsOccData.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class AbsOccName;
}
namespace Teamcenter
{
    class AbsOccNameImpl;
}
namespace Teamcenter
{
    class AbsOccNameDelegate;
}
namespace Teamcenter
{
    class AbsOccNameDispatch;
}
namespace Teamcenter
{
    class AbsOccNameGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::AbsOccName
     : public  ::Teamcenter::AbsOccData
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AbsOccName();

    /**
     * Destructor
     */
    virtual ~AbsOccName();

private:
    //  Getter method for the Implementation Object
    AbsOccNameImpl*  getAbsOccNameImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAbsOccNameImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AbsOccNameImpl*  m_absoccnameImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AbsOccName - desc for AbsOccName parameter
     */
    AbsOccName( const AbsOccName& );
    AbsOccName& operator=( const AbsOccName& );

    friend class  AbsOccNameDelegate;
    friend class  AbsOccNameDispatch;
    friend class  AbsOccNameGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__ABSOCCNAME__HXX
