//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AbsOccNote
    Filename:   AbsOccNote.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ABSOCCNOTE__HXX
#define TEAMCENTER__ABSOCCNOTE__HXX

#include <common/tc_deprecation_macros.h>
#include <ps/AbsOccData.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class AbsOccNote;
}
namespace Teamcenter
{
    class AbsOccNoteImpl;
}
namespace Teamcenter
{
    class AbsOccNoteDelegate;
}
namespace Teamcenter
{
    class AbsOccNoteDispatch;
}
namespace Teamcenter
{
    class AbsOccNoteGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::AbsOccNote
     : public  ::Teamcenter::AbsOccData
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AbsOccNote();

    /**
     * Destructor
     */
    virtual ~AbsOccNote();

private:
    //  Getter method for the Implementation Object
    AbsOccNoteImpl*  getAbsOccNoteImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAbsOccNoteImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AbsOccNoteImpl*  m_absoccnoteImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AbsOccNote - desc for AbsOccNote parameter
     */
    AbsOccNote( const AbsOccNote& );
    AbsOccNote& operator=( const AbsOccNote& );

    friend class  AbsOccNoteDelegate;
    friend class  AbsOccNoteDispatch;
    friend class  AbsOccNoteGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__ABSOCCNOTE__HXX
