//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AbsOccPosRef
    Filename:   AbsOccPosRef.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ABSOCCPOSREF__HXX
#define TEAMCENTER__ABSOCCPOSREF__HXX

#include <common/tc_deprecation_macros.h>
#include <ps/AbsOccData.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class AbsOccPosRef;
}
namespace Teamcenter
{
    class AbsOccPosRefImpl;
}
namespace Teamcenter
{
    class AbsOccPosRefDelegate;
}
namespace Teamcenter
{
    class AbsOccPosRefDispatch;
}
namespace Teamcenter
{
    class AbsOccPosRefGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::AbsOccPosRef
     : public  ::Teamcenter::AbsOccData
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AbsOccPosRef();

    /**
     * Destructor
     */
    virtual ~AbsOccPosRef();

private:
    //  Getter method for the Implementation Object
    AbsOccPosRefImpl*  getAbsOccPosRefImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAbsOccPosRefImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AbsOccPosRefImpl*  m_absoccposrefImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AbsOccPosRef - desc for AbsOccPosRef parameter
     */
    AbsOccPosRef( const AbsOccPosRef& );
    AbsOccPosRef& operator=( const AbsOccPosRef& );

    friend class  AbsOccPosRefDelegate;
    friend class  AbsOccPosRefDispatch;
    friend class  AbsOccPosRefGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__ABSOCCPOSREF__HXX
