//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AbsOccQuantity
    Filename:   AbsOccQuantity.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ABSOCCQUANTITY__HXX
#define TEAMCENTER__ABSOCCQUANTITY__HXX

#include <common/tc_deprecation_macros.h>
#include <ps/AbsOccData.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class AbsOccQuantity;
}
namespace Teamcenter
{
    class AbsOccQuantityImpl;
}
namespace Teamcenter
{
    class AbsOccQuantityDelegate;
}
namespace Teamcenter
{
    class AbsOccQuantityDispatch;
}
namespace Teamcenter
{
    class AbsOccQuantityGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::AbsOccQuantity
     : public  ::Teamcenter::AbsOccData
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AbsOccQuantity();

    /**
     * Destructor
     */
    virtual ~AbsOccQuantity();

private:
    //  Getter method for the Implementation Object
    AbsOccQuantityImpl*  getAbsOccQuantityImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAbsOccQuantityImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AbsOccQuantityImpl*  m_absoccquantityImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AbsOccQuantity - desc for AbsOccQuantity parameter
     */
    AbsOccQuantity( const AbsOccQuantity& );
    AbsOccQuantity& operator=( const AbsOccQuantity& );

    friend class  AbsOccQuantityDelegate;
    friend class  AbsOccQuantityDispatch;
    friend class  AbsOccQuantityGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__ABSOCCQUANTITY__HXX
