//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AbsOccSeqNo
    Filename:   AbsOccSeqNo.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ABSOCCSEQNO__HXX
#define TEAMCENTER__ABSOCCSEQNO__HXX

#include <common/tc_deprecation_macros.h>
#include <ps/AbsOccData.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class AbsOccSeqNo;
}
namespace Teamcenter
{
    class AbsOccSeqNoImpl;
}
namespace Teamcenter
{
    class AbsOccSeqNoDelegate;
}
namespace Teamcenter
{
    class AbsOccSeqNoDispatch;
}
namespace Teamcenter
{
    class AbsOccSeqNoGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::AbsOccSeqNo
     : public  ::Teamcenter::AbsOccData
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AbsOccSeqNo();

    /**
     * Destructor
     */
    virtual ~AbsOccSeqNo();

private:
    //  Getter method for the Implementation Object
    AbsOccSeqNoImpl*  getAbsOccSeqNoImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAbsOccSeqNoImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AbsOccSeqNoImpl*  m_absoccseqnoImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AbsOccSeqNo - desc for AbsOccSeqNo parameter
     */
    AbsOccSeqNo( const AbsOccSeqNo& );
    AbsOccSeqNo& operator=( const AbsOccSeqNo& );

    friend class  AbsOccSeqNoDelegate;
    friend class  AbsOccSeqNoDispatch;
    friend class  AbsOccSeqNoGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__ABSOCCSEQNO__HXX
