//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AbsOccSource
    Filename:   AbsOccSource.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ABSOCCSOURCE__HXX
#define TEAMCENTER__ABSOCCSOURCE__HXX

#include <common/tc_deprecation_macros.h>
#include <ps/AbsOccData.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class AbsOccSource;
}
namespace Teamcenter
{
    class AbsOccSourceImpl;
}
namespace Teamcenter
{
    class AbsOccSourceDelegate;
}
namespace Teamcenter
{
    class AbsOccSourceDispatch;
}
namespace Teamcenter
{
    class AbsOccSourceGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::AbsOccSource
     : public  ::Teamcenter::AbsOccData
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AbsOccSource();

    /**
     * Destructor
     */
    virtual ~AbsOccSource();

private:
    //  Getter method for the Implementation Object
    AbsOccSourceImpl*  getAbsOccSourceImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAbsOccSourceImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AbsOccSourceImpl*  m_absoccsourceImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AbsOccSource - desc for AbsOccSource parameter
     */
    AbsOccSource( const AbsOccSource& );
    AbsOccSource& operator=( const AbsOccSource& );

    friend class  AbsOccSourceDelegate;
    friend class  AbsOccSourceDispatch;
    friend class  AbsOccSourceGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__ABSOCCSOURCE__HXX
