//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AbsOccType
    Filename:   AbsOccType.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ABSOCCTYPE__HXX
#define TEAMCENTER__ABSOCCTYPE__HXX

#include <common/tc_deprecation_macros.h>
#include <ps/AbsOccData.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class AbsOccType;
}
namespace Teamcenter
{
    class AbsOccTypeImpl;
}
namespace Teamcenter
{
    class AbsOccTypeDelegate;
}
namespace Teamcenter
{
    class AbsOccTypeDispatch;
}
namespace Teamcenter
{
    class AbsOccTypeGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::AbsOccType
     : public  ::Teamcenter::AbsOccData
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AbsOccType();

    /**
     * Destructor
     */
    virtual ~AbsOccType();

private:
    //  Getter method for the Implementation Object
    AbsOccTypeImpl*  getAbsOccTypeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAbsOccTypeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AbsOccTypeImpl*  m_absocctypeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AbsOccType - desc for AbsOccType parameter
     */
    AbsOccType( const AbsOccType& );
    AbsOccType& operator=( const AbsOccType& );

    friend class  AbsOccTypeDelegate;
    friend class  AbsOccTypeDispatch;
    friend class  AbsOccTypeGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__ABSOCCTYPE__HXX
