//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AbsOccUCC
    Filename:   AbsOccUCC.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ABSOCCUCC__HXX
#define TEAMCENTER__ABSOCCUCC__HXX

#include <common/tc_deprecation_macros.h>
#include <ps/AbsOccData.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class AbsOccUCC;
}
namespace Teamcenter
{
    class AbsOccUCCImpl;
}
namespace Teamcenter
{
    class AbsOccUCCDelegate;
}
namespace Teamcenter
{
    class AbsOccUCCDispatch;
}
namespace Teamcenter
{
    class AbsOccUCCGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::AbsOccUCC
     : public  ::Teamcenter::AbsOccData
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AbsOccUCC();

    /**
     * Destructor
     */
    virtual ~AbsOccUCC();

private:
    //  Getter method for the Implementation Object
    AbsOccUCCImpl*  getAbsOccUCCImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAbsOccUCCImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AbsOccUCCImpl*  m_absoccuccImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AbsOccUCC - desc for AbsOccUCC parameter
     */
    AbsOccUCC( const AbsOccUCC& );
    AbsOccUCC& operator=( const AbsOccUCC& );

    friend class  AbsOccUCCDelegate;
    friend class  AbsOccUCCDispatch;
    friend class  AbsOccUCCGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__ABSOCCUCC__HXX
