//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AbsOccUCCDelegate
    Filename:   AbsOccUCCDelegate.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ABSOCCUCCDELEGATE_HXX
#define TEAMCENTER__ABSOCCUCCDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ps/AbsOccUCC.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class AbsOccUCCDelegate;
}
namespace Teamcenter
{
    class AbsOccUCCImpl;
}
namespace Teamcenter
{
    class AbsOccUCC;
}
namespace Teamcenter
{
    class AbsOccUCCGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PS_API Teamcenter_alias::AbsOccUCCDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the AbsOccUCCDelegate instance
    static AbsOccUCCDelegate&  getInstance();

    //  Method to create the AbsOccUCCImpl pointer
    static AbsOccUCCImpl*  createImpl( AbsOccUCC&  ifObj );

    //  Method to delete the AbsOccUCCImpl pointer
    static void deleteImpl( AbsOccUCCImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @param isLockForDelete - A boolean to indicate if object(s) are to be locked for deletion
    /// @param allowRelock - A boolean to indicate if object(s) can be relocked, which will discard all unsaved changes, if already locked by the same user
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0LockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd, const bool isLockForDelete, const bool allowRelock );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0RefreshBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0UnlockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const AbsOccUCC &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static AbsOccUCCDelegate*  m_pInstance;

    AbsOccUCCDelegate();
    virtual ~AbsOccUCCDelegate();
    static void setInstance( AbsOccUCCDelegate*  instance );


private:
    friend class  ::Teamcenter::AbsOccUCCGenImpl;

};

#include <ps/libps_undef.h>
#endif  //  TEAMCENTER__ABSOCCUCCDELEGATE_HXX
