//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AbsOccUOM
    Filename:   AbsOccUOM.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ABSOCCUOM__HXX
#define TEAMCENTER__ABSOCCUOM__HXX

#include <common/tc_deprecation_macros.h>
#include <ps/AbsOccData.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class AbsOccUOM;
}
namespace Teamcenter
{
    class AbsOccUOMImpl;
}
namespace Teamcenter
{
    class AbsOccUOMDelegate;
}
namespace Teamcenter
{
    class AbsOccUOMDispatch;
}
namespace Teamcenter
{
    class AbsOccUOMGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::AbsOccUOM
     : public  ::Teamcenter::AbsOccData
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AbsOccUOM();

    /**
     * Destructor
     */
    virtual ~AbsOccUOM();

private:
    //  Getter method for the Implementation Object
    AbsOccUOMImpl*  getAbsOccUOMImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAbsOccUOMImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AbsOccUOMImpl*  m_absoccuomImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AbsOccUOM - desc for AbsOccUOM parameter
     */
    AbsOccUOM( const AbsOccUOM& );
    AbsOccUOM& operator=( const AbsOccUOM& );

    friend class  AbsOccUOMDelegate;
    friend class  AbsOccUOMDispatch;
    friend class  AbsOccUOMGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__ABSOCCUOM__HXX
