//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AbsOccUsgPartID
    Filename:   AbsOccUsgPartID.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ABSOCCUSGPARTID__HXX
#define TEAMCENTER__ABSOCCUSGPARTID__HXX

#include <common/tc_deprecation_macros.h>
#include <ps/AbsOccData.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class AbsOccUsgPartID;
}
namespace Teamcenter
{
    class AbsOccUsgPartIDImpl;
}
namespace Teamcenter
{
    class AbsOccUsgPartIDDelegate;
}
namespace Teamcenter
{
    class AbsOccUsgPartIDDispatch;
}
namespace Teamcenter
{
    class AbsOccUsgPartIDGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::AbsOccUsgPartID
     : public  ::Teamcenter::AbsOccData
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AbsOccUsgPartID();

    /**
     * Destructor
     */
    virtual ~AbsOccUsgPartID();

private:
    //  Getter method for the Implementation Object
    AbsOccUsgPartIDImpl*  getAbsOccUsgPartIDImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAbsOccUsgPartIDImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AbsOccUsgPartIDImpl*  m_absoccusgpartidImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AbsOccUsgPartID - desc for AbsOccUsgPartID parameter
     */
    AbsOccUsgPartID( const AbsOccUsgPartID& );
    AbsOccUsgPartID& operator=( const AbsOccUsgPartID& );

    friend class  AbsOccUsgPartIDDelegate;
    friend class  AbsOccUsgPartIDDispatch;
    friend class  AbsOccUsgPartIDGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__ABSOCCUSGPARTID__HXX
