//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AbsOccUsgProduct
    Filename:   AbsOccUsgProduct.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ABSOCCUSGPRODUCT__HXX
#define TEAMCENTER__ABSOCCUSGPRODUCT__HXX

#include <common/tc_deprecation_macros.h>
#include <ps/AbsOccData.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class AbsOccUsgProduct;
}
namespace Teamcenter
{
    class AbsOccUsgProductImpl;
}
namespace Teamcenter
{
    class AbsOccUsgProductDelegate;
}
namespace Teamcenter
{
    class AbsOccUsgProductDispatch;
}
namespace Teamcenter
{
    class AbsOccUsgProductGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::AbsOccUsgProduct
     : public  ::Teamcenter::AbsOccData
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AbsOccUsgProduct();

    /**
     * Destructor
     */
    virtual ~AbsOccUsgProduct();

private:
    //  Getter method for the Implementation Object
    AbsOccUsgProductImpl*  getAbsOccUsgProductImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAbsOccUsgProductImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AbsOccUsgProductImpl*  m_absoccusgproductImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AbsOccUsgProduct - desc for AbsOccUsgProduct parameter
     */
    AbsOccUsgProduct( const AbsOccUsgProduct& );
    AbsOccUsgProduct& operator=( const AbsOccUsgProduct& );

    friend class  AbsOccUsgProductDelegate;
    friend class  AbsOccUsgProductDispatch;
    friend class  AbsOccUsgProductGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__ABSOCCUSGPRODUCT__HXX
