//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AbsOccVariantCondition
    Filename:   AbsOccVariantCondition.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ABSOCCVARIANTCONDITION__HXX
#define TEAMCENTER__ABSOCCVARIANTCONDITION__HXX

#include <common/tc_deprecation_macros.h>
#include <ps/AbsOccData.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class AbsOccVariantCondition;
}
namespace Teamcenter
{
    class AbsOccVariantConditionImpl;
}
namespace Teamcenter
{
    class AbsOccVariantConditionDelegate;
}
namespace Teamcenter
{
    class AbsOccVariantConditionDispatch;
}
namespace Teamcenter
{
    class AbsOccVariantConditionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::AbsOccVariantCondition
     : public  ::Teamcenter::AbsOccData
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AbsOccVariantCondition();

    /**
     * Destructor
     */
    virtual ~AbsOccVariantCondition();

private:
    //  Getter method for the Implementation Object
    AbsOccVariantConditionImpl*  getAbsOccVariantConditionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAbsOccVariantConditionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AbsOccVariantConditionImpl*  m_absoccvariantconditionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AbsOccVariantCondition - desc for AbsOccVariantCondition parameter
     */
    AbsOccVariantCondition( const AbsOccVariantCondition& );
    AbsOccVariantCondition& operator=( const AbsOccVariantCondition& );

    friend class  AbsOccVariantConditionDelegate;
    friend class  AbsOccVariantConditionDispatch;
    friend class  AbsOccVariantConditionGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__ABSOCCVARIANTCONDITION__HXX
