//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AbsOccXform
    Filename:   AbsOccXform.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ABSOCCXFORM__HXX
#define TEAMCENTER__ABSOCCXFORM__HXX

#include <common/tc_deprecation_macros.h>
#include <ps/AbsOccData.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class AbsOccXform;
}
namespace Teamcenter
{
    class AbsOccXformImpl;
}
namespace Teamcenter
{
    class AbsOccXformDelegate;
}
namespace Teamcenter
{
    class AbsOccXformDispatch;
}
namespace Teamcenter
{
    class AbsOccXformGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::AbsOccXform
     : public  ::Teamcenter::AbsOccData
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AbsOccXform();

    /**
     * Destructor
     */
    virtual ~AbsOccXform();

private:
    //  Getter method for the Implementation Object
    AbsOccXformImpl*  getAbsOccXformImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAbsOccXformImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AbsOccXformImpl*  m_absoccxformImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AbsOccXform - desc for AbsOccXform parameter
     */
    AbsOccXform( const AbsOccXform& );
    AbsOccXform& operator=( const AbsOccXform& );

    friend class  AbsOccXformDelegate;
    friend class  AbsOccXformDispatch;
    friend class  AbsOccXformGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__ABSOCCXFORM__HXX
