//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AbsOccurrence
    Filename:   AbsOccurrence.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ABSOCCURRENCE__HXX
#define TEAMCENTER__ABSOCCURRENCE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class AbsOccurrence;
}
namespace Teamcenter
{
    class AbsOccurrenceImpl;
}
namespace Teamcenter
{
    class AbsOccurrenceDelegate;
}
namespace Teamcenter
{
    class AbsOccurrenceDispatch;
}
namespace Teamcenter
{
    class AbsOccurrenceGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::AbsOccurrence
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AbsOccurrence();

    /**
     * Destructor
     */
    virtual ~AbsOccurrence();

private:
    //  Getter method for the Implementation Object
    AbsOccurrenceImpl*  getAbsOccurrenceImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAbsOccurrenceImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AbsOccurrenceImpl*  m_absoccurrenceImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AbsOccurrence - desc for AbsOccurrence parameter
     */
    AbsOccurrence( const AbsOccurrence& );
    AbsOccurrence& operator=( const AbsOccurrence& );

    friend class  AbsOccurrenceDelegate;
    friend class  AbsOccurrenceDispatch;
    friend class  AbsOccurrenceGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__ABSOCCURRENCE__HXX
