//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AbsOccurrenceDelegate
    Filename:   AbsOccurrenceDelegate.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ABSOCCURRENCEDELEGATE_HXX
#define TEAMCENTER__ABSOCCURRENCEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ps/AbsOccurrence.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class AbsOccurrenceDelegate;
}
namespace Teamcenter
{
    class AbsOccurrenceImpl;
}
namespace Teamcenter
{
    class AbsOccurrence;
}
namespace Teamcenter
{
    class AbsOccurrenceGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PS_API Teamcenter_alias::AbsOccurrenceDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the AbsOccurrenceDelegate instance
    static AbsOccurrenceDelegate&  getInstance();

    //  Method to create the AbsOccurrenceImpl pointer
    static AbsOccurrenceImpl*  createImpl( AbsOccurrence&  ifObj );

    //  Method to delete the AbsOccurrenceImpl pointer
    static void deleteImpl( AbsOccurrenceImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const AbsOccurrence &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static AbsOccurrenceDelegate*  m_pInstance;

    AbsOccurrenceDelegate();
    virtual ~AbsOccurrenceDelegate();
    static void setInstance( AbsOccurrenceDelegate*  instance );


private:
    friend class  ::Teamcenter::AbsOccurrenceGenImpl;

};

#include <ps/libps_undef.h>
#endif  //  TEAMCENTER__ABSOCCURRENCEDELEGATE_HXX
