//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AppearanceGroup
    Filename:   AppearanceGroup.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPEARANCEGROUP__HXX
#define TEAMCENTER__APPEARANCEGROUP__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class AppearanceGroup;
}
namespace Teamcenter
{
    class AppearanceGroupImpl;
}
namespace Teamcenter
{
    class AppearanceGroupDelegate;
}
namespace Teamcenter
{
    class AppearanceGroupDispatch;
}
namespace Teamcenter
{
    class AppearanceGroupGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::AppearanceGroup
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AppearanceGroup();

    /**
     * Destructor
     */
    virtual ~AppearanceGroup();

private:
    //  Getter method for the Implementation Object
    AppearanceGroupImpl*  getAppearanceGroupImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAppearanceGroupImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AppearanceGroupImpl*  m_appearancegroupImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AppearanceGroup - desc for AppearanceGroup parameter
     */
    AppearanceGroup( const AppearanceGroup& );
    AppearanceGroup& operator=( const AppearanceGroup& );

    friend class  AppearanceGroupDelegate;
    friend class  AppearanceGroupDispatch;
    friend class  AppearanceGroupGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__APPEARANCEGROUP__HXX
