//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AppearanceGroupDelegate
    Filename:   AppearanceGroupDelegate.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPEARANCEGROUPDELEGATE_HXX
#define TEAMCENTER__APPEARANCEGROUPDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ps/AppearanceGroup.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class AppearanceGroupDelegate;
}
namespace Teamcenter
{
    class AppearanceGroupImpl;
}
namespace Teamcenter
{
    class AppearanceGroup;
}
namespace Teamcenter
{
    class AppearanceGroupGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PS_API Teamcenter_alias::AppearanceGroupDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the AppearanceGroupDelegate instance
    static AppearanceGroupDelegate&  getInstance();

    //  Method to create the AppearanceGroupImpl pointer
    static AppearanceGroupImpl*  createImpl( AppearanceGroup&  ifObj );

    //  Method to delete the AppearanceGroupImpl pointer
    static void deleteImpl( AppearanceGroupImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static AppearanceGroupDelegate*  m_pInstance;

    AppearanceGroupDelegate();
    virtual ~AppearanceGroupDelegate();
    static void setInstance( AppearanceGroupDelegate*  instance );


private:
    friend class  ::Teamcenter::AppearanceGroupGenImpl;

};

#include <ps/libps_undef.h>
#endif  //  TEAMCENTER__APPEARANCEGROUPDELEGATE_HXX
