//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AssemblyArrangement
    Filename:   AssemblyArrangement.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ASSEMBLYARRANGEMENT__HXX
#define TEAMCENTER__ASSEMBLYARRANGEMENT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class AssemblyArrangement;
}
namespace Teamcenter
{
    class AssemblyArrangementImpl;
}
namespace Teamcenter
{
    class AssemblyArrangementDelegate;
}
namespace Teamcenter
{
    class AssemblyArrangementDispatch;
}
namespace Teamcenter
{
    class AssemblyArrangementGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::AssemblyArrangement
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AssemblyArrangement();

    /**
     * Destructor
     */
    virtual ~AssemblyArrangement();

private:
    //  Getter method for the Implementation Object
    AssemblyArrangementImpl*  getAssemblyArrangementImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAssemblyArrangementImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AssemblyArrangementImpl*  m_assemblyarrangementImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AssemblyArrangement - desc for AssemblyArrangement parameter
     */
    AssemblyArrangement( const AssemblyArrangement& );
    AssemblyArrangement& operator=( const AssemblyArrangement& );

    friend class  AssemblyArrangementDelegate;
    friend class  AssemblyArrangementDispatch;
    friend class  AssemblyArrangementGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__ASSEMBLYARRANGEMENT__HXX
