//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AssemblyArrangementAnchor
    Filename:   AssemblyArrangementAnchor.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ASSEMBLYARRANGEMENTANCHOR__HXX
#define TEAMCENTER__ASSEMBLYARRANGEMENTANCHOR__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class AssemblyArrangementAnchor;
}
namespace Teamcenter
{
    class AssemblyArrangementAnchorImpl;
}
namespace Teamcenter
{
    class AssemblyArrangementAnchorDelegate;
}
namespace Teamcenter
{
    class AssemblyArrangementAnchorDispatch;
}
namespace Teamcenter
{
    class AssemblyArrangementAnchorGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::AssemblyArrangementAnchor
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AssemblyArrangementAnchor();

    /**
     * Destructor
     */
    virtual ~AssemblyArrangementAnchor();

private:
    //  Getter method for the Implementation Object
    AssemblyArrangementAnchorImpl*  getAssemblyArrangementAnchorImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAssemblyArrangementAnchorImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AssemblyArrangementAnchorImpl*  m_assemblyarrangementanchorImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AssemblyArrangementAnchor - desc for AssemblyArrangementAnchor parameter
     */
    AssemblyArrangementAnchor( const AssemblyArrangementAnchor& );
    AssemblyArrangementAnchor& operator=( const AssemblyArrangementAnchor& );

    friend class  AssemblyArrangementAnchorDelegate;
    friend class  AssemblyArrangementAnchorDispatch;
    friend class  AssemblyArrangementAnchorGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__ASSEMBLYARRANGEMENTANCHOR__HXX
