//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AssemblyArrangementDelegate
    Filename:   AssemblyArrangementDelegate.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ASSEMBLYARRANGEMENTDELEGATE_HXX
#define TEAMCENTER__ASSEMBLYARRANGEMENTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ps/AssemblyArrangement.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class AssemblyArrangementDelegate;
}
namespace Teamcenter
{
    class AssemblyArrangementImpl;
}
namespace Teamcenter
{
    class AssemblyArrangement;
}
namespace Teamcenter
{
    class AssemblyArrangementGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PS_API Teamcenter_alias::AssemblyArrangementDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the AssemblyArrangementDelegate instance
    static AssemblyArrangementDelegate&  getInstance();

    //  Method to create the AssemblyArrangementImpl pointer
    static AssemblyArrangementImpl*  createImpl( AssemblyArrangement&  ifObj );

    //  Method to delete the AssemblyArrangementImpl pointer
    static void deleteImpl( AssemblyArrangementImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const AssemblyArrangement &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const AssemblyArrangement &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static AssemblyArrangementDelegate*  m_pInstance;

    AssemblyArrangementDelegate();
    virtual ~AssemblyArrangementDelegate();
    static void setInstance( AssemblyArrangementDelegate*  instance );


private:
    friend class  ::Teamcenter::AssemblyArrangementGenImpl;

};

#include <ps/libps_undef.h>
#endif  //  TEAMCENTER__ASSEMBLYARRANGEMENTDELEGATE_HXX
