//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ClientDataMaster
    Filename:   ClientDataMaster.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CLIENTDATAMASTER__HXX
#define TEAMCENTER__CLIENTDATAMASTER__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class ClientDataMaster;
}
namespace Teamcenter
{
    class ClientDataMasterImpl;
}
namespace Teamcenter
{
    class ClientDataMasterDelegate;
}
namespace Teamcenter
{
    class ClientDataMasterDispatch;
}
namespace Teamcenter
{
    class ClientDataMasterGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::ClientDataMaster
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ClientDataMaster();

    /**
     * Destructor
     */
    virtual ~ClientDataMaster();

private:
    //  Getter method for the Implementation Object
    ClientDataMasterImpl*  getClientDataMasterImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setClientDataMasterImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ClientDataMasterImpl*  m_clientdatamasterImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ClientDataMaster - desc for ClientDataMaster parameter
     */
    ClientDataMaster( const ClientDataMaster& );
    ClientDataMaster& operator=( const ClientDataMaster& );

    friend class  ClientDataMasterDelegate;
    friend class  ClientDataMasterDispatch;
    friend class  ClientDataMasterGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__CLIENTDATAMASTER__HXX
