//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ComponentRelation
    Filename:   ComponentRelation.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__COMPONENTRELATION__HXX
#define TEAMCENTER__COMPONENTRELATION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class ComponentRelation;
}
namespace Teamcenter
{
    class ComponentRelationImpl;
}
namespace Teamcenter
{
    class ComponentRelationDelegate;
}
namespace Teamcenter
{
    class ComponentRelationDispatch;
}
namespace Teamcenter
{
    class ComponentRelationGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::ComponentRelation
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ComponentRelation();

    /**
     * Destructor
     */
    virtual ~ComponentRelation();

private:
    //  Getter method for the Implementation Object
    ComponentRelationImpl*  getComponentRelationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setComponentRelationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ComponentRelationImpl*  m_componentrelationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ComponentRelation - desc for ComponentRelation parameter
     */
    ComponentRelation( const ComponentRelation& );
    ComponentRelation& operator=( const ComponentRelation& );

    friend class  ComponentRelationDelegate;
    friend class  ComponentRelationDispatch;
    friend class  ComponentRelationGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__COMPONENTRELATION__HXX
