//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0AbsAlternateGroup
    Filename:   Fnd0AbsAlternateGroup.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0ABSALTERNATEGROUP__HXX
#define TEAMCENTER__FND0ABSALTERNATEGROUP__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <ps/Fnd0AbsInterchangeableGrp.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class Fnd0AbsAlternateGroup;
}
namespace Teamcenter
{
    class Fnd0AbsAlternateGroupImpl;
}
namespace Teamcenter
{
    class Fnd0AbsAlternateGroupDelegate;
}
namespace Teamcenter
{
    class Fnd0AbsAlternateGroupDispatch;
}
namespace Teamcenter
{
    class Fnd0AbsAlternateGroupGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::Fnd0AbsAlternateGroup
     : public  ::Teamcenter::Fnd0AbsInterchangeableGrp
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.6
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0AlternateItemList( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.6
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0SourceItemList( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 11.6
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0AlternateItemList( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );

    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 11.6
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0SourceItemList( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0AbsAlternateGroup();

    /**
     * Destructor
     */
    virtual ~Fnd0AbsAlternateGroup();

private:
    //  Getter method for the Implementation Object
    Fnd0AbsAlternateGroupImpl*  getFnd0AbsAlternateGroupImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0AbsAlternateGroupImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0AbsAlternateGroupImpl*  m_fnd0absalternategroupImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0AbsAlternateGroup - desc for Fnd0AbsAlternateGroup parameter
     */
    Fnd0AbsAlternateGroup( const Fnd0AbsAlternateGroup& );
    Fnd0AbsAlternateGroup& operator=( const Fnd0AbsAlternateGroup& );

    friend class  Fnd0AbsAlternateGroupDelegate;
    friend class  Fnd0AbsAlternateGroupDispatch;
    friend class  Fnd0AbsAlternateGroupGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__FND0ABSALTERNATEGROUP__HXX
