//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0AbsAlternateGroupDelegate
    Filename:   Fnd0AbsAlternateGroupDelegate.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0ABSALTERNATEGROUPDELEGATE_HXX
#define TEAMCENTER__FND0ABSALTERNATEGROUPDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ps/Fnd0AbsAlternateGroup.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class Fnd0AbsAlternateGroupDelegate;
}
namespace Teamcenter
{
    class Fnd0AbsAlternateGroupImpl;
}
namespace Teamcenter
{
    class Fnd0AbsAlternateGroup;
}
namespace Teamcenter
{
    class Fnd0AbsAlternateGroupGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PS_API Teamcenter_alias::Fnd0AbsAlternateGroupDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0AbsAlternateGroupDelegate instance
    static Fnd0AbsAlternateGroupDelegate&  getInstance();

    //  Method to create the Fnd0AbsAlternateGroupImpl pointer
    static Fnd0AbsAlternateGroupImpl*  createImpl( Fnd0AbsAlternateGroup&  ifObj );

    //  Method to delete the Fnd0AbsAlternateGroupImpl pointer
    static void deleteImpl( Fnd0AbsAlternateGroupImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.6
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0AlternateItemListBase(const Fnd0AbsAlternateGroup &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.6
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0SourceItemListBase(const Fnd0AbsAlternateGroup &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 11.6
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0AlternateItemListBase(Fnd0AbsAlternateGroup &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 11.6
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0SourceItemListBase(Fnd0AbsAlternateGroup &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );



protected:
    //  Pointer to the instance
    static Fnd0AbsAlternateGroupDelegate*  m_pInstance;

    Fnd0AbsAlternateGroupDelegate();
    virtual ~Fnd0AbsAlternateGroupDelegate();
    static void setInstance( Fnd0AbsAlternateGroupDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0AbsAlternateGroupGenImpl;

};

#include <ps/libps_undef.h>
#endif  //  TEAMCENTER__FND0ABSALTERNATEGROUPDELEGATE_HXX
