//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0AbsInterchangeableGrp
    Filename:   Fnd0AbsInterchangeableGrp.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0ABSINTERCHANGEABLEGRP__HXX
#define TEAMCENTER__FND0ABSINTERCHANGEABLEGRP__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class Fnd0AbsInterchangeableGrp;
}
namespace Teamcenter
{
    class Fnd0AbsInterchangeableGrpImpl;
}
namespace Teamcenter
{
    class Fnd0AbsInterchangeableGrpDelegate;
}
namespace Teamcenter
{
    class Fnd0AbsInterchangeableGrpDispatch;
}
namespace Teamcenter
{
    class Fnd0AbsInterchangeableGrpGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::Fnd0AbsInterchangeableGrp
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.6
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0id( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.6
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0id( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0AbsInterchangeableGrp();

    /**
     * Destructor
     */
    virtual ~Fnd0AbsInterchangeableGrp();

private:
    //  Getter method for the Implementation Object
    Fnd0AbsInterchangeableGrpImpl*  getFnd0AbsInterchangeableGrpImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0AbsInterchangeableGrpImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0AbsInterchangeableGrpImpl*  m_fnd0absinterchangeablegrpImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0AbsInterchangeableGrp - desc for Fnd0AbsInterchangeableGrp parameter
     */
    Fnd0AbsInterchangeableGrp( const Fnd0AbsInterchangeableGrp& );
    Fnd0AbsInterchangeableGrp& operator=( const Fnd0AbsInterchangeableGrp& );

    friend class  Fnd0AbsInterchangeableGrpDelegate;
    friend class  Fnd0AbsInterchangeableGrpDispatch;
    friend class  Fnd0AbsInterchangeableGrpGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__FND0ABSINTERCHANGEABLEGRP__HXX
