//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0AbsSubstituteGroup
    Filename:   Fnd0AbsSubstituteGroup.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0ABSSUBSTITUTEGROUP__HXX
#define TEAMCENTER__FND0ABSSUBSTITUTEGROUP__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <ps/Fnd0AbsInterchangeableGrp.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class Fnd0AbsSubstituteGroup;
}
namespace Teamcenter
{
    class Fnd0AbsSubstituteGroupImpl;
}
namespace Teamcenter
{
    class Fnd0AbsSubstituteGroupDelegate;
}
namespace Teamcenter
{
    class Fnd0AbsSubstituteGroupDispatch;
}
namespace Teamcenter
{
    class Fnd0AbsSubstituteGroupGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::Fnd0AbsSubstituteGroup
     : public  ::Teamcenter::Fnd0AbsInterchangeableGrp
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.6
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0substituteList( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 11.6
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0substituteList( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0AbsSubstituteGroup();

    /**
     * Destructor
     */
    virtual ~Fnd0AbsSubstituteGroup();

private:
    //  Getter method for the Implementation Object
    Fnd0AbsSubstituteGroupImpl*  getFnd0AbsSubstituteGroupImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0AbsSubstituteGroupImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0AbsSubstituteGroupImpl*  m_fnd0abssubstitutegroupImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0AbsSubstituteGroup - desc for Fnd0AbsSubstituteGroup parameter
     */
    Fnd0AbsSubstituteGroup( const Fnd0AbsSubstituteGroup& );
    Fnd0AbsSubstituteGroup& operator=( const Fnd0AbsSubstituteGroup& );

    friend class  Fnd0AbsSubstituteGroupDelegate;
    friend class  Fnd0AbsSubstituteGroupDispatch;
    friend class  Fnd0AbsSubstituteGroupGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__FND0ABSSUBSTITUTEGROUP__HXX
