//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0AbsSubstituteGroupDelegate
    Filename:   Fnd0AbsSubstituteGroupDelegate.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0ABSSUBSTITUTEGROUPDELEGATE_HXX
#define TEAMCENTER__FND0ABSSUBSTITUTEGROUPDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ps/Fnd0AbsSubstituteGroup.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class Fnd0AbsSubstituteGroupDelegate;
}
namespace Teamcenter
{
    class Fnd0AbsSubstituteGroupImpl;
}
namespace Teamcenter
{
    class Fnd0AbsSubstituteGroup;
}
namespace Teamcenter
{
    class Fnd0AbsSubstituteGroupGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PS_API Teamcenter_alias::Fnd0AbsSubstituteGroupDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0AbsSubstituteGroupDelegate instance
    static Fnd0AbsSubstituteGroupDelegate&  getInstance();

    //  Method to create the Fnd0AbsSubstituteGroupImpl pointer
    static Fnd0AbsSubstituteGroupImpl*  createImpl( Fnd0AbsSubstituteGroup&  ifObj );

    //  Method to delete the Fnd0AbsSubstituteGroupImpl pointer
    static void deleteImpl( Fnd0AbsSubstituteGroupImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.6
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0substituteListBase(const Fnd0AbsSubstituteGroup &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 11.6
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0substituteListBase(Fnd0AbsSubstituteGroup &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Generic saveAsPost operation.
    /// @version Teamcenter 8.1
    /// @param pSavAsInput - Input argument as SaveAsInput object.
    /// @param vecDeepCopyData - vector deepcopy data
    /// @return - Return integer value.
    ///
    int  saveAsPostBase(const Fnd0AbsSubstituteGroup &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static Fnd0AbsSubstituteGroupDelegate*  m_pInstance;

    Fnd0AbsSubstituteGroupDelegate();
    virtual ~Fnd0AbsSubstituteGroupDelegate();
    static void setInstance( Fnd0AbsSubstituteGroupDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0AbsSubstituteGroupGenImpl;

};

#include <ps/libps_undef.h>
#endif  //  TEAMCENTER__FND0ABSSUBSTITUTEGROUPDELEGATE_HXX
