//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0AbstractOcc
    Filename:   Fnd0AbstractOcc.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0ABSTRACTOCC__HXX
#define TEAMCENTER__FND0ABSTRACTOCC__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Fnd0WSOThread.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class Fnd0AbstractOcc;
}
namespace Teamcenter
{
    class Fnd0AbstractOccImpl;
}
namespace Teamcenter
{
    class Fnd0AbstractOccDelegate;
}
namespace Teamcenter
{
    class Fnd0AbstractOccDispatch;
}
namespace Teamcenter
{
    class Fnd0AbstractOccGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::Fnd0AbstractOcc
     : public  ::Teamcenter::Fnd0WSOThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0AbstractOcc();

    /**
     * Destructor
     */
    virtual ~Fnd0AbstractOcc();

private:
    //  Getter method for the Implementation Object
    Fnd0AbstractOccImpl*  getFnd0AbstractOccImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0AbstractOccImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0AbstractOccImpl*  m_fnd0abstractoccImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0AbstractOcc - desc for Fnd0AbstractOcc parameter
     */
    Fnd0AbstractOcc( const Fnd0AbstractOcc& );
    Fnd0AbstractOcc& operator=( const Fnd0AbstractOcc& );

    friend class  Fnd0AbstractOccDelegate;
    friend class  Fnd0AbstractOccDispatch;
    friend class  Fnd0AbstractOccGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__FND0ABSTRACTOCC__HXX
