//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0AbstractOccRevision
    Filename:   Fnd0AbstractOccRevision.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0ABSTRACTOCCREVISION__HXX
#define TEAMCENTER__FND0ABSTRACTOCCREVISION__HXX

#include <metaframework/ReviseInput.hxx>
#include <metaframework/DeepCopyData.hxx>
#include <metaframework/BulkInput.hxx>
#include <metaframework/BulkData.hxx>
#include <unidefs.h>
#include <string>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class Fnd0AbstractOccRevision;
}
namespace Teamcenter
{
    class Fnd0AbstractOccRevisionImpl;
}
namespace Teamcenter
{
    class Fnd0AbstractOccRevisionDelegate;
}
namespace Teamcenter
{
    class Fnd0AbstractOccRevisionDispatch;
}
namespace Teamcenter
{
    class Fnd0AbstractOccRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::Fnd0AbstractOccRevision
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 13.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0EffectivityFormula( std::string &value, bool &isNull ) const;

    ///
    /// Getter for Property Display Value
    /// @version Teamcenter 13.1
    /// @param values - Parameter value
    /// @return - Status. 0 if successful
    ///
    int  getFnd0EffectivityFormulaDisplayableValues( std::vector< std::string > &values );

    ///
    /// Operation to get PSOccurrence from Fnd0AbstractOccRevision
    /// @version Teamcenter 12.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0PsOcc( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 13.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0EffectivityFormula( const std::string &value, bool isNull=false );

    ///
    /// Operation to set PSOccurrence on Fnd0AbstractOccRevision
    /// @version Teamcenter 12.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0PsOcc( const tag_t &value, bool isNull=false );

    ///
    /// Finalize Revise Input Operation
    /// @version Teamcenter 12.2
    /// @param pReviseInput - Revise input
    /// @param vecDeepCopyData - Deep Copy Data Vector
    /// @return - Failure Code
    ///
    int  finalizeReviseInput( ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );

    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 12.2
    /// @param inputs - A vector of data that contains reference information to the objects to be revised
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    static int  fnd0FinalizeReviseInput( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );

    ///
    /// Operation to replace the child item or item revision and child BOMView for Fnd0AbstractOccRevision.
    /// @version Teamcenter 12.4
    /// @param childItemOrItemRev - The child item or item revision that you want to replace with.
    /// @param childBomView - The Child BOM View that you want to replace with.
    /// @return - 
    ///
    int  fnd0ReplaceOccurrence( tag_t childItemOrItemRev, tag_t childBomView );

    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 12.2
    /// @param inputs - A vector of data that contains reference information to the objects to be revised
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    static int  fnd0Revise( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );

    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 12.2
    /// @param inputs - A vector of data that contains reference information to the objects to be revised
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    static int  fnd0RevisePost( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );

    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 12.2
    /// @param inputs - A vector of data that contains reference information to the objects to be revised
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    static int  fnd0SetPropertiesFromReviseInput( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );

    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 12.2
    /// @param inputs - A vector of data that contains reference information to the objects to be revised
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    static int  fnd0ValidateReviseInput( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );

    ///
    /// Fnd0AbstractOccRevision Revise Operation
    /// @version Teamcenter 12.2
    /// @param pReviseInput - Revise Input
    /// @param vecDeepCopyData - Deep Copy Data Vactor
    /// @param newObjTag - New Object tag
    /// @return - Failure Code
    ///
    int  revise( ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData, tag_t *newObjTag );

    ///
    /// Reivse post operation
    /// @version Teamcenter 12.2
    /// @param pReviseInput - Revise Input Descriptor
    /// @param vecDeepCopyData - Deep Copy Data Vector
    /// @return - Failure Code
    ///
    int  revisePost( ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );

    ///
    /// Set properties from revise input Operation
    /// @version Teamcenter 12.2
    /// @param pReviseInput - Revise Input Descriptor
    /// @return - Failure code
    ///
    int  setPropertiesFromReviseInput( ::Teamcenter::ReviseInput *pReviseInput );

    ///
    /// Validate Revise Input Operation
    /// @version Teamcenter 12.2
    /// @param pReviseInput - Revise Input Descriptor
    /// @param vecDeepCopyData - Deep Copy Data Vector
    /// @return - Failure Code
    ///
    int  validateReviseInput( ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0AbstractOccRevision();

    /**
     * Destructor
     */
    virtual ~Fnd0AbstractOccRevision();

private:
    //  Getter method for the Implementation Object
    Fnd0AbstractOccRevisionImpl*  getFnd0AbstractOccRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0AbstractOccRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0AbstractOccRevisionImpl*  m_fnd0abstractoccrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0AbstractOccRevision - desc for Fnd0AbstractOccRevision parameter
     */
    Fnd0AbstractOccRevision( const Fnd0AbstractOccRevision& );
    Fnd0AbstractOccRevision& operator=( const Fnd0AbstractOccRevision& );

    friend class  Fnd0AbstractOccRevisionDelegate;
    friend class  Fnd0AbstractOccRevisionDispatch;
    friend class  Fnd0AbstractOccRevisionGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__FND0ABSTRACTOCCREVISION__HXX
