//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0CloneData
    Filename:   Fnd0CloneData.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0CLONEDATA__HXX
#define TEAMCENTER__FND0CLONEDATA__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Fnd0ProductSessionData.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class Fnd0CloneData;
}
namespace Teamcenter
{
    class Fnd0CloneDataImpl;
}
namespace Teamcenter
{
    class Fnd0CloneDataDelegate;
}
namespace Teamcenter
{
    class Fnd0CloneDataDispatch;
}
namespace Teamcenter
{
    class Fnd0CloneDataGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::Fnd0CloneData
     : public  ::Teamcenter::Fnd0ProductSessionData
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0CloneData();

    /**
     * Destructor
     */
    virtual ~Fnd0CloneData();

private:
    //  Getter method for the Implementation Object
    Fnd0CloneDataImpl*  getFnd0CloneDataImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0CloneDataImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0CloneDataImpl*  m_fnd0clonedataImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0CloneData - desc for Fnd0CloneData parameter
     */
    Fnd0CloneData( const Fnd0CloneData& );
    Fnd0CloneData& operator=( const Fnd0CloneData& );

    friend class  Fnd0CloneDataDelegate;
    friend class  Fnd0CloneDataDispatch;
    friend class  Fnd0CloneDataGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__FND0CLONEDATA__HXX
