//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0CloneDataDelegate
    Filename:   Fnd0CloneDataDelegate.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0CLONEDATADELEGATE_HXX
#define TEAMCENTER__FND0CLONEDATADELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ps/Fnd0CloneData.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class Fnd0CloneDataDelegate;
}
namespace Teamcenter
{
    class Fnd0CloneDataImpl;
}
namespace Teamcenter
{
    class Fnd0CloneData;
}
namespace Teamcenter
{
    class Fnd0CloneDataGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PS_API Teamcenter_alias::Fnd0CloneDataDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0CloneDataDelegate instance
    static Fnd0CloneDataDelegate&  getInstance();

    //  Method to create the Fnd0CloneDataImpl pointer
    static Fnd0CloneDataImpl*  createImpl( Fnd0CloneData&  ifObj );

    //  Method to delete the Fnd0CloneDataImpl pointer
    static void deleteImpl( Fnd0CloneDataImpl*  impl );


    ///
    /// Create the clone of the Fnd0ProductSessionData object. Every subclass of the Fnd0ProductSessionData has to implement this operation.
    /// @version Teamcenter 12.2
    /// @param clonedObject - The cloned Object tag.
    /// @return - 
    ///
    int  fnd0CloneBase(const Fnd0CloneData &ifObj,  tag_t *clonedObject );



protected:
    //  Pointer to the instance
    static Fnd0CloneDataDelegate*  m_pInstance;

    Fnd0CloneDataDelegate();
    virtual ~Fnd0CloneDataDelegate();
    static void setInstance( Fnd0CloneDataDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0CloneDataGenImpl;

};

#include <ps/libps_undef.h>
#endif  //  TEAMCENTER__FND0CLONEDATADELEGATE_HXX
