//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ConfigContext
    Filename:   Fnd0ConfigContext.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0CONFIGCONTEXT__HXX
#define TEAMCENTER__FND0CONFIGCONTEXT__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class Fnd0ConfigContext;
}
namespace Teamcenter
{
    class Fnd0ConfigContextImpl;
}
namespace Teamcenter
{
    class Fnd0ConfigContextDelegate;
}
namespace Teamcenter
{
    class Fnd0ConfigContextDispatch;
}
namespace Teamcenter
{
    class Fnd0ConfigContextGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::Fnd0ConfigContext
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 12.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRevision_rule( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 12.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setRevision_rule( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0ConfigContext();

    /**
     * Destructor
     */
    virtual ~Fnd0ConfigContext();

private:
    //  Getter method for the Implementation Object
    Fnd0ConfigContextImpl*  getFnd0ConfigContextImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0ConfigContextImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0ConfigContextImpl*  m_fnd0configcontextImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0ConfigContext - desc for Fnd0ConfigContext parameter
     */
    Fnd0ConfigContext( const Fnd0ConfigContext& );
    Fnd0ConfigContext& operator=( const Fnd0ConfigContext& );

    friend class  Fnd0ConfigContextDelegate;
    friend class  Fnd0ConfigContextDispatch;
    friend class  Fnd0ConfigContextGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__FND0CONFIGCONTEXT__HXX
