//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ConfigContextDelegate
    Filename:   Fnd0ConfigContextDelegate.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0CONFIGCONTEXTDELEGATE_HXX
#define TEAMCENTER__FND0CONFIGCONTEXTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ps/Fnd0ConfigContext.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class Fnd0ConfigContextDelegate;
}
namespace Teamcenter
{
    class Fnd0ConfigContextImpl;
}
namespace Teamcenter
{
    class Fnd0ConfigContext;
}
namespace Teamcenter
{
    class Fnd0ConfigContextGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PS_API Teamcenter_alias::Fnd0ConfigContextDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0ConfigContextDelegate instance
    static Fnd0ConfigContextDelegate&  getInstance();

    //  Method to create the Fnd0ConfigContextImpl pointer
    static Fnd0ConfigContextImpl*  createImpl( Fnd0ConfigContext&  ifObj );

    //  Method to delete the Fnd0ConfigContextImpl pointer
    static void deleteImpl( Fnd0ConfigContextImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 12.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRevision_ruleBase(const Fnd0ConfigContext &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 12.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setRevision_ruleBase(Fnd0ConfigContext &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Deletes the instance.
    /// @version Teamcenter 11.1
    /// @return - Failure code.
    ///
    int  fnd0DeleteBase(const Fnd0ConfigContext &ifObj  );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const Fnd0ConfigContext &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Fnd0ConfigContext &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Fnd0ConfigContextDelegate*  m_pInstance;

    Fnd0ConfigContextDelegate();
    virtual ~Fnd0ConfigContextDelegate();
    static void setInstance( Fnd0ConfigContextDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0ConfigContextGenImpl;

};

#include <ps/libps_undef.h>
#endif  //  TEAMCENTER__FND0CONFIGCONTEXTDELEGATE_HXX
