//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0MUImpactedParents
    Filename:   Fnd0MUImpactedParents.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0MUIMPACTEDPARENTS__HXX
#define TEAMCENTER__FND0MUIMPACTEDPARENTS__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class Fnd0MUImpactedParents;
}
namespace Teamcenter
{
    class Fnd0MUImpactedParentsImpl;
}
namespace Teamcenter
{
    class Fnd0MUImpactedParentsDelegate;
}
namespace Teamcenter
{
    class Fnd0MUImpactedParentsDispatch;
}
namespace Teamcenter
{
    class Fnd0MUImpactedParentsGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::Fnd0MUImpactedParents
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 11.6
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0AllowedActions( std::vector< std::string > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0MUImpactedParents();

    /**
     * Destructor
     */
    virtual ~Fnd0MUImpactedParents();

private:
    //  Getter method for the Implementation Object
    Fnd0MUImpactedParentsImpl*  getFnd0MUImpactedParentsImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0MUImpactedParentsImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0MUImpactedParentsImpl*  m_fnd0muimpactedparentsImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0MUImpactedParents - desc for Fnd0MUImpactedParents parameter
     */
    Fnd0MUImpactedParents( const Fnd0MUImpactedParents& );
    Fnd0MUImpactedParents& operator=( const Fnd0MUImpactedParents& );

    friend class  Fnd0MUImpactedParentsDelegate;
    friend class  Fnd0MUImpactedParentsDispatch;
    friend class  Fnd0MUImpactedParentsGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__FND0MUIMPACTEDPARENTS__HXX
