//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0MUImpactedParentsDelegate
    Filename:   Fnd0MUImpactedParentsDelegate.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0MUIMPACTEDPARENTSDELEGATE_HXX
#define TEAMCENTER__FND0MUIMPACTEDPARENTSDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ps/Fnd0MUImpactedParents.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class Fnd0MUImpactedParentsDelegate;
}
namespace Teamcenter
{
    class Fnd0MUImpactedParentsImpl;
}
namespace Teamcenter
{
    class Fnd0MUImpactedParents;
}
namespace Teamcenter
{
    class Fnd0MUImpactedParentsGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PS_API Teamcenter_alias::Fnd0MUImpactedParentsDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0MUImpactedParentsDelegate instance
    static Fnd0MUImpactedParentsDelegate&  getInstance();

    //  Method to create the Fnd0MUImpactedParentsImpl pointer
    static Fnd0MUImpactedParentsImpl*  createImpl( Fnd0MUImpactedParents&  ifObj );

    //  Method to delete the Fnd0MUImpactedParentsImpl pointer
    static void deleteImpl( Fnd0MUImpactedParentsImpl*  impl );


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 11.6
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0AllowedActionsBase(const Fnd0MUImpactedParents &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// This is the getter for retrieving the recipe/permanent ID if its been created (and cached on the instance). Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param uid - Recipe/permanent ID
    /// @param isFirstTime - If Session Recovery Uid is yet to be set or does the object need to be serialized again?
    /// @return - Failure code
    ///
    int  fnd0AskSRUidBase(const Fnd0MUImpactedParents &ifObj,  std::string *uid, bool *isFirstTime ) const;


    ///
    /// Generates permanent ID/recipe. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param recipe - Permanent ID/recipe
    /// @return - Failure code.
    ///
    int  fnd0GenerateRecipeBase(const Fnd0MUImpactedParents &ifObj,  std::string *recipe );


    ///
    /// If Business Object supports recoverable ID. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param isPersistedRecipe - isPersistedRecipe param should be set to true if the recipe is limited to the user session and should be serialized to the database
    /// @param isRecoverableIDSupported - Returning true indicates support for recoverability/permanent IDs
    /// @return - Failure code.
    ///
    int  fnd0IsRecoverableBase(const Fnd0MUImpactedParents &ifObj,  bool *isPersistedRecipe, bool *isRecoverableIDSupported ) const;


    ///
    /// This is the setter for the recipe/permanent ID when it is created (to be cached on the instance). Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param uid - Rrecipe/permanent ID
    /// @return - Failure code.
    ///
    int  fnd0SetSRUidBase(const Fnd0MUImpactedParents &ifObj,  const std::string *uid );



protected:
    //  Pointer to the instance
    static Fnd0MUImpactedParentsDelegate*  m_pInstance;

    Fnd0MUImpactedParentsDelegate();
    virtual ~Fnd0MUImpactedParentsDelegate();
    static void setInstance( Fnd0MUImpactedParentsDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0MUImpactedParentsGenImpl;

};

#include <ps/libps_undef.h>
#endif  //  TEAMCENTER__FND0MUIMPACTEDPARENTSDELEGATE_HXX
