//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0MarkupChange
    Filename:   Fnd0MarkupChange.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0MARKUPCHANGE__HXX
#define TEAMCENTER__FND0MARKUPCHANGE__HXX

#include <string>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class Fnd0MarkupChange;
}
namespace Teamcenter
{
    class Fnd0MarkupChangeImpl;
}
namespace Teamcenter
{
    class Fnd0MarkupChangeDelegate;
}
namespace Teamcenter
{
    class Fnd0MarkupChangeDispatch;
}
namespace Teamcenter
{
    class Fnd0MarkupChangeGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::Fnd0MarkupChange
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBl_line_name( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBl_occ_type( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBl_pack_count( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBl_quantity( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBl_sequence_no( std::string &value, bool &isNull ) const;

    ///
    /// Getter for Property Display Value
    /// @version Teamcenter 11.5
    /// @param values - Parameter value
    /// @return - Status. 0 if successful
    ///
    int  getFnd0markup_typeDisplayableValues( std::vector< std::string > &values );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.7
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setBl_occ_type( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.7
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setBl_pack_count( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.7
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setBl_quantity( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.7
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setBl_sequence_no( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0MarkupChange();

    /**
     * Destructor
     */
    virtual ~Fnd0MarkupChange();

private:
    //  Getter method for the Implementation Object
    Fnd0MarkupChangeImpl*  getFnd0MarkupChangeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0MarkupChangeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0MarkupChangeImpl*  m_fnd0markupchangeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0MarkupChange - desc for Fnd0MarkupChange parameter
     */
    Fnd0MarkupChange( const Fnd0MarkupChange& );
    Fnd0MarkupChange& operator=( const Fnd0MarkupChange& );

    friend class  Fnd0MarkupChangeDelegate;
    friend class  Fnd0MarkupChangeDispatch;
    friend class  Fnd0MarkupChangeGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__FND0MARKUPCHANGE__HXX
