//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0MarkupChangeDelegate
    Filename:   Fnd0MarkupChangeDelegate.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0MARKUPCHANGEDELEGATE_HXX
#define TEAMCENTER__FND0MARKUPCHANGEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ps/Fnd0MarkupChange.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class Fnd0MarkupChangeDelegate;
}
namespace Teamcenter
{
    class Fnd0MarkupChangeImpl;
}
namespace Teamcenter
{
    class Fnd0MarkupChange;
}
namespace Teamcenter
{
    class Fnd0MarkupChangeGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PS_API Teamcenter_alias::Fnd0MarkupChangeDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0MarkupChangeDelegate instance
    static Fnd0MarkupChangeDelegate&  getInstance();

    //  Method to create the Fnd0MarkupChangeImpl pointer
    static Fnd0MarkupChangeImpl*  createImpl( Fnd0MarkupChange&  ifObj );

    //  Method to delete the Fnd0MarkupChangeImpl pointer
    static void deleteImpl( Fnd0MarkupChangeImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBl_line_nameBase(const Fnd0MarkupChange &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBl_occ_typeBase(const Fnd0MarkupChange &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBl_pack_countBase(const Fnd0MarkupChange &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBl_quantityBase(const Fnd0MarkupChange &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBl_sequence_noBase(const Fnd0MarkupChange &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for Property Display Value
    /// @version Teamcenter 11.5
    /// @param values - Parameter value
    /// @return - Status. 0 if successful
    ///
    int  getFnd0markup_typeDisplayableValuesBase(Fnd0MarkupChange &ifObj,  std::vector< std::string > &values );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.7
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setBl_occ_typeBase(Fnd0MarkupChange &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.7
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setBl_pack_countBase(Fnd0MarkupChange &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.7
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setBl_quantityBase(Fnd0MarkupChange &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.7
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setBl_sequence_noBase(Fnd0MarkupChange &ifObj,  const std::string &value, bool isNull );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getObject_stringBase(const Fnd0MarkupChange &ifObj,  std::string &value, bool &isNull ) const;



protected:
    //  Pointer to the instance
    static Fnd0MarkupChangeDelegate*  m_pInstance;

    Fnd0MarkupChangeDelegate();
    virtual ~Fnd0MarkupChangeDelegate();
    static void setInstance( Fnd0MarkupChangeDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0MarkupChangeGenImpl;

};

#include <ps/libps_undef.h>
#endif  //  TEAMCENTER__FND0MARKUPCHANGEDELEGATE_HXX
