//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0MarkupDelegate
    Filename:   Fnd0MarkupDelegate.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0MARKUPDELEGATE_HXX
#define TEAMCENTER__FND0MARKUPDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ps/Fnd0Markup.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class Fnd0MarkupDelegate;
}
namespace Teamcenter
{
    class Fnd0MarkupImpl;
}
namespace Teamcenter
{
    class Fnd0Markup;
}
namespace Teamcenter
{
    class Fnd0MarkupGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PS_API Teamcenter_alias::Fnd0MarkupDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0MarkupDelegate instance
    static Fnd0MarkupDelegate&  getInstance();

    //  Method to create the Fnd0MarkupImpl pointer
    static Fnd0MarkupImpl*  createImpl( Fnd0Markup&  ifObj );

    //  Method to delete the Fnd0MarkupImpl pointer
    static void deleteImpl( Fnd0MarkupImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0activeBase(const Fnd0Markup &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0changesBase(const Fnd0Markup &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0loadedBase(const Fnd0Markup &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0markup_statusBase(const Fnd0Markup &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 8.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0activeBase(Fnd0Markup &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 8.2
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0changesBase(Fnd0Markup &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 8.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0loadedBase(Fnd0Markup &ifObj,  bool value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 8.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0markup_statusBase(Fnd0Markup &ifObj,  int value, bool isNull );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static Fnd0MarkupDelegate*  m_pInstance;

    Fnd0MarkupDelegate();
    virtual ~Fnd0MarkupDelegate();
    static void setInstance( Fnd0MarkupDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0MarkupGenImpl;

};

#include <ps/libps_undef.h>
#endif  //  TEAMCENTER__FND0MARKUPDELEGATE_HXX
