//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0OccEffValueDelegate
    Filename:   Fnd0OccEffValueDelegate.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0OCCEFFVALUEDELEGATE_HXX
#define TEAMCENTER__FND0OCCEFFVALUEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ps/Fnd0OccEffValue.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class Fnd0OccEffValueDelegate;
}
namespace Teamcenter
{
    class Fnd0OccEffValueImpl;
}
namespace Teamcenter
{
    class Fnd0OccEffValue;
}
namespace Teamcenter
{
    class Fnd0OccEffValueGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PS_API Teamcenter_alias::Fnd0OccEffValueDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0OccEffValueDelegate instance
    static Fnd0OccEffValueDelegate&  getInstance();

    //  Method to create the Fnd0OccEffValueImpl pointer
    static Fnd0OccEffValueImpl*  createImpl( Fnd0OccEffValue&  ifObj );

    //  Method to delete the Fnd0OccEffValueImpl pointer
    static void deleteImpl( Fnd0OccEffValueImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0BeforeEffBase(const Fnd0OccEffValue &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0EffProposalBase(const Fnd0OccEffValue &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0IsOverrideBase(const Fnd0OccEffValue &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0OccThreadBase(const Fnd0OccEffValue &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0OwningCutbackBase(const Fnd0OccEffValue &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0PrimaryEffBase(const Fnd0OccEffValue &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0StatusStrBase(const Fnd0OccEffValue &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.2.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0BeforeEffBase(Fnd0OccEffValue &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.2.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0EffProposalBase(Fnd0OccEffValue &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 11.2.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0IsOverrideBase(Fnd0OccEffValue &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.2.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0OccThreadBase(Fnd0OccEffValue &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.2.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0OwningCutbackBase(Fnd0OccEffValue &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.2.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0PrimaryEffBase(Fnd0OccEffValue &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.2.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0StatusStrBase(Fnd0OccEffValue &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static Fnd0OccEffValueDelegate*  m_pInstance;

    Fnd0OccEffValueDelegate();
    virtual ~Fnd0OccEffValueDelegate();
    static void setInstance( Fnd0OccEffValueDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0OccEffValueGenImpl;

};

#include <ps/libps_undef.h>
#endif  //  TEAMCENTER__FND0OCCEFFVALUEDELEGATE_HXX
