//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0WhereConfiguredProvider
    Filename:   Fnd0WhereConfiguredProvider.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0WHERECONFIGUREDPROVIDER__HXX
#define TEAMCENTER__FND0WHERECONFIGUREDPROVIDER__HXX

#include <common/tc_deprecation_macros.h>
#include <tc/Fnd0BaseProvider.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class Fnd0WhereConfiguredProvider;
}
namespace Teamcenter
{
    class Fnd0WhereConfiguredProviderImpl;
}
namespace Teamcenter
{
    class Fnd0WhereConfiguredProviderDelegate;
}
namespace Teamcenter
{
    class Fnd0WhereConfiguredProviderDispatch;
}
namespace Teamcenter
{
    class Fnd0WhereConfiguredProviderGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::Fnd0WhereConfiguredProvider
     : public  ::Teamcenter::Fnd0BaseProvider
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0WhereConfiguredProvider();

    /**
     * Destructor
     */
    virtual ~Fnd0WhereConfiguredProvider();

private:
    //  Getter method for the Implementation Object
    Fnd0WhereConfiguredProviderImpl*  getFnd0WhereConfiguredProviderImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0WhereConfiguredProviderImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0WhereConfiguredProviderImpl*  m_fnd0whereconfiguredproviderImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0WhereConfiguredProvider - desc for Fnd0WhereConfiguredProvider parameter
     */
    Fnd0WhereConfiguredProvider( const Fnd0WhereConfiguredProvider& );
    Fnd0WhereConfiguredProvider& operator=( const Fnd0WhereConfiguredProvider& );

    friend class  Fnd0WhereConfiguredProviderDelegate;
    friend class  Fnd0WhereConfiguredProviderDispatch;
    friend class  Fnd0WhereConfiguredProviderGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__FND0WHERECONFIGUREDPROVIDER__HXX
