//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MEAppearancePathNode
    Filename:   MEAppearancePathNode.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MEAPPEARANCEPATHNODE__HXX
#define TEAMCENTER__MEAPPEARANCEPATHNODE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class MEAppearancePathNode;
}
namespace Teamcenter
{
    class MEAppearancePathNodeImpl;
}
namespace Teamcenter
{
    class MEAppearancePathNodeDelegate;
}
namespace Teamcenter
{
    class MEAppearancePathNodeDispatch;
}
namespace Teamcenter
{
    class MEAppearancePathNodeGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::MEAppearancePathNode
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    MEAppearancePathNode();

    /**
     * Destructor
     */
    virtual ~MEAppearancePathNode();

private:
    //  Getter method for the Implementation Object
    MEAppearancePathNodeImpl*  getMEAppearancePathNodeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMEAppearancePathNodeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    MEAppearancePathNodeImpl*  m_meappearancepathnodeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param MEAppearancePathNode - desc for MEAppearancePathNode parameter
     */
    MEAppearancePathNode( const MEAppearancePathNode& );
    MEAppearancePathNode& operator=( const MEAppearancePathNode& );

    friend class  MEAppearancePathNodeDelegate;
    friend class  MEAppearancePathNodeDispatch;
    friend class  MEAppearancePathNodeGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__MEAPPEARANCEPATHNODE__HXX
