//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MEAppearancePathNodeDelegate
    Filename:   MEAppearancePathNodeDelegate.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MEAPPEARANCEPATHNODEDELEGATE_HXX
#define TEAMCENTER__MEAPPEARANCEPATHNODEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ps/MEAppearancePathNode.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class MEAppearancePathNodeDelegate;
}
namespace Teamcenter
{
    class MEAppearancePathNodeImpl;
}
namespace Teamcenter
{
    class MEAppearancePathNode;
}
namespace Teamcenter
{
    class MEAppearancePathNodeGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PS_API Teamcenter_alias::MEAppearancePathNodeDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the MEAppearancePathNodeDelegate instance
    static MEAppearancePathNodeDelegate&  getInstance();

    //  Method to create the MEAppearancePathNodeImpl pointer
    static MEAppearancePathNodeImpl*  createImpl( MEAppearancePathNode&  ifObj );

    //  Method to delete the MEAppearancePathNodeImpl pointer
    static void deleteImpl( MEAppearancePathNodeImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static MEAppearancePathNodeDelegate*  m_pInstance;

    MEAppearancePathNodeDelegate();
    virtual ~MEAppearancePathNodeDelegate();
    static void setInstance( MEAppearancePathNodeDelegate*  instance );


private:
    friend class  ::Teamcenter::MEAppearancePathNodeGenImpl;

};

#include <ps/libps_undef.h>
#endif  //  TEAMCENTER__MEAPPEARANCEPATHNODEDELEGATE_HXX
