//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MEAppearancePathRoot
    Filename:   MEAppearancePathRoot.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MEAPPEARANCEPATHROOT__HXX
#define TEAMCENTER__MEAPPEARANCEPATHROOT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class MEAppearancePathRoot;
}
namespace Teamcenter
{
    class MEAppearancePathRootImpl;
}
namespace Teamcenter
{
    class MEAppearancePathRootDelegate;
}
namespace Teamcenter
{
    class MEAppearancePathRootDispatch;
}
namespace Teamcenter
{
    class MEAppearancePathRootGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::MEAppearancePathRoot
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    MEAppearancePathRoot();

    /**
     * Destructor
     */
    virtual ~MEAppearancePathRoot();

private:
    //  Getter method for the Implementation Object
    MEAppearancePathRootImpl*  getMEAppearancePathRootImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMEAppearancePathRootImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    MEAppearancePathRootImpl*  m_meappearancepathrootImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param MEAppearancePathRoot - desc for MEAppearancePathRoot parameter
     */
    MEAppearancePathRoot( const MEAppearancePathRoot& );
    MEAppearancePathRoot& operator=( const MEAppearancePathRoot& );

    friend class  MEAppearancePathRootDelegate;
    friend class  MEAppearancePathRootDispatch;
    friend class  MEAppearancePathRootGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__MEAPPEARANCEPATHROOT__HXX
