//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, MEAppearancePathRootDelegate
    Filename:   MEAppearancePathRootDelegate.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MEAPPEARANCEPATHROOTDELEGATE_HXX
#define TEAMCENTER__MEAPPEARANCEPATHROOTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ps/MEAppearancePathRoot.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class MEAppearancePathRootDelegate;
}
namespace Teamcenter
{
    class MEAppearancePathRootImpl;
}
namespace Teamcenter
{
    class MEAppearancePathRoot;
}
namespace Teamcenter
{
    class MEAppearancePathRootGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PS_API Teamcenter_alias::MEAppearancePathRootDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the MEAppearancePathRootDelegate instance
    static MEAppearancePathRootDelegate&  getInstance();

    //  Method to create the MEAppearancePathRootImpl pointer
    static MEAppearancePathRootImpl*  createImpl( MEAppearancePathRoot&  ifObj );

    //  Method to delete the MEAppearancePathRootImpl pointer
    static void deleteImpl( MEAppearancePathRootImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be created
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0FinalizeCreateInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.3
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0FinalizeSaveAsInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const MEAppearancePathRoot &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// finalize operation input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  finalizeSaveAsInputBase(const MEAppearancePathRoot &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static MEAppearancePathRootDelegate*  m_pInstance;

    MEAppearancePathRootDelegate();
    virtual ~MEAppearancePathRootDelegate();
    static void setInstance( MEAppearancePathRootDelegate*  instance );


private:
    friend class  ::Teamcenter::MEAppearancePathRootGenImpl;

};

#include <ps/libps_undef.h>
#endif  //  TEAMCENTER__MEAPPEARANCEPATHROOTDELEGATE_HXX
