//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, NoteType
    Filename:   NoteType.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__NOTETYPE__HXX
#define TEAMCENTER__NOTETYPE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class NoteType;
}
namespace Teamcenter
{
    class NoteTypeImpl;
}
namespace Teamcenter
{
    class NoteTypeDelegate;
}
namespace Teamcenter
{
    class NoteTypeDispatch;
}
namespace Teamcenter
{
    class NoteTypeGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::NoteType
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    NoteType();

    /**
     * Destructor
     */
    virtual ~NoteType();

private:
    //  Getter method for the Implementation Object
    NoteTypeImpl*  getNoteTypeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setNoteTypeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    NoteTypeImpl*  m_notetypeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param NoteType - desc for NoteType parameter
     */
    NoteType( const NoteType& );
    NoteType& operator=( const NoteType& );

    friend class  NoteTypeDelegate;
    friend class  NoteTypeDispatch;
    friend class  NoteTypeGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__NOTETYPE__HXX
