//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PSAlternateList
    Filename:   PSAlternateList.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PSALTERNATELIST__HXX
#define TEAMCENTER__PSALTERNATELIST__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class PSAlternateList;
}
namespace Teamcenter
{
    class PSAlternateListImpl;
}
namespace Teamcenter
{
    class PSAlternateListDelegate;
}
namespace Teamcenter
{
    class PSAlternateListDispatch;
}
namespace Teamcenter
{
    class PSAlternateListGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::PSAlternateList
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PSAlternateList();

    /**
     * Destructor
     */
    virtual ~PSAlternateList();

private:
    //  Getter method for the Implementation Object
    PSAlternateListImpl*  getPSAlternateListImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPSAlternateListImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PSAlternateListImpl*  m_psalternatelistImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PSAlternateList - desc for PSAlternateList parameter
     */
    PSAlternateList( const PSAlternateList& );
    PSAlternateList& operator=( const PSAlternateList& );

    friend class  PSAlternateListDelegate;
    friend class  PSAlternateListDispatch;
    friend class  PSAlternateListGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__PSALTERNATELIST__HXX
