//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PSAlternateListDelegate
    Filename:   PSAlternateListDelegate.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PSALTERNATELISTDELEGATE_HXX
#define TEAMCENTER__PSALTERNATELISTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ps/PSAlternateList.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class PSAlternateListDelegate;
}
namespace Teamcenter
{
    class PSAlternateListImpl;
}
namespace Teamcenter
{
    class PSAlternateList;
}
namespace Teamcenter
{
    class PSAlternateListGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PS_API Teamcenter_alias::PSAlternateListDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PSAlternateListDelegate instance
    static PSAlternateListDelegate&  getInstance();

    //  Method to create the PSAlternateListImpl pointer
    static PSAlternateListImpl*  createImpl( PSAlternateList&  ifObj );

    //  Method to delete the PSAlternateListImpl pointer
    static void deleteImpl( PSAlternateListImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @param isLockForDelete - A boolean to indicate if object(s) are to be locked for deletion
    /// @param allowRelock - A boolean to indicate if object(s) can be relocked, which will discard all unsaved changes, if already locked by the same user
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0LockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd, const bool isLockForDelete, const bool allowRelock );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0RefreshBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0UnlockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const PSAlternateList &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static PSAlternateListDelegate*  m_pInstance;

    PSAlternateListDelegate();
    virtual ~PSAlternateListDelegate();
    static void setInstance( PSAlternateListDelegate*  instance );


private:
    friend class  ::Teamcenter::PSAlternateListGenImpl;

};

#include <ps/libps_undef.h>
#endif  //  TEAMCENTER__PSALTERNATELISTDELEGATE_HXX
