//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PSAlternateSet
    Filename:   PSAlternateSet.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PSALTERNATESET__HXX
#define TEAMCENTER__PSALTERNATESET__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class PSAlternateSet;
}
namespace Teamcenter
{
    class PSAlternateSetImpl;
}
namespace Teamcenter
{
    class PSAlternateSetDelegate;
}
namespace Teamcenter
{
    class PSAlternateSetDispatch;
}
namespace Teamcenter
{
    class PSAlternateSetGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::PSAlternateSet
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PSAlternateSet();

    /**
     * Destructor
     */
    virtual ~PSAlternateSet();

private:
    //  Getter method for the Implementation Object
    PSAlternateSetImpl*  getPSAlternateSetImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPSAlternateSetImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PSAlternateSetImpl*  m_psalternatesetImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PSAlternateSet - desc for PSAlternateSet parameter
     */
    PSAlternateSet( const PSAlternateSet& );
    PSAlternateSet& operator=( const PSAlternateSet& );

    friend class  PSAlternateSetDelegate;
    friend class  PSAlternateSetDispatch;
    friend class  PSAlternateSetGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__PSALTERNATESET__HXX
