//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PSBOMView
    Filename:   PSBOMView.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PSBOMVIEW__HXX
#define TEAMCENTER__PSBOMVIEW__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class PSBOMView;
}
namespace Teamcenter
{
    class PSBOMViewImpl;
}
namespace Teamcenter
{
    class PSBOMViewDelegate;
}
namespace Teamcenter
{
    class PSBOMViewDispatch;
}
namespace Teamcenter
{
    class PSBOMViewGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::PSBOMView
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PSBOMView();

    /**
     * Destructor
     */
    virtual ~PSBOMView();

private:
    //  Getter method for the Implementation Object
    PSBOMViewImpl*  getPSBOMViewImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPSBOMViewImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PSBOMViewImpl*  m_psbomviewImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PSBOMView - desc for PSBOMView parameter
     */
    PSBOMView( const PSBOMView& );
    PSBOMView& operator=( const PSBOMView& );

    friend class  PSBOMViewDelegate;
    friend class  PSBOMViewDispatch;
    friend class  PSBOMViewGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__PSBOMVIEW__HXX
