//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PSBOMViewDelegate
    Filename:   PSBOMViewDelegate.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PSBOMVIEWDELEGATE_HXX
#define TEAMCENTER__PSBOMVIEWDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ps/PSBOMView.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class PSBOMViewDelegate;
}
namespace Teamcenter
{
    class PSBOMViewImpl;
}
namespace Teamcenter
{
    class PSBOMView;
}
namespace Teamcenter
{
    class PSBOMViewGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PS_API Teamcenter_alias::PSBOMViewDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PSBOMViewDelegate instance
    static PSBOMViewDelegate&  getInstance();

    //  Method to create the PSBOMViewImpl pointer
    static PSBOMViewImpl*  createImpl( PSBOMView&  ifObj );

    //  Method to delete the PSBOMViewImpl pointer
    static void deleteImpl( PSBOMViewImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const PSBOMView &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const PSBOMView &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const PSBOMView &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static PSBOMViewDelegate*  m_pInstance;

    PSBOMViewDelegate();
    virtual ~PSBOMViewDelegate();
    static void setInstance( PSBOMViewDelegate*  instance );


private:
    friend class  ::Teamcenter::PSBOMViewGenImpl;

};

#include <ps/libps_undef.h>
#endif  //  TEAMCENTER__PSBOMVIEWDELEGATE_HXX
