//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PSBOMViewRevision
    Filename:   PSBOMViewRevision.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PSBOMVIEWREVISION__HXX
#define TEAMCENTER__PSBOMVIEWREVISION__HXX

#include <unidefs.h>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class PSBOMViewRevision;
}
namespace Teamcenter
{
    class PSBOMViewRevisionImpl;
}
namespace Teamcenter
{
    class PSBOMViewRevisionDelegate;
}
namespace Teamcenter
{
    class PSBOMViewRevisionDispatch;
}
namespace Teamcenter
{
    class PSBOMViewRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::PSBOMViewRevision
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.6
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0SubstituteGroups( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Removes a PSOccurrence.
    /// @version Teamcenter 10.1
    /// @param occTag - PSOccurrence tag
    /// @return - int
    ///
    int  fnd0RemoveOccurrence( tag_t occTag );

    ///
    /// replace a Occurrence.
    /// @version Teamcenter 10.1
    /// @param occTag - PSOccurrence tag
    /// @param childItem - tag to childitem
    /// @param childBomView - tag to childbomview
    /// @return - int
    ///
    int  fnd0ReplaceOccurrence( tag_t occTag, tag_t childItem, tag_t childBomView );

    ///
    /// Saves the PSBOMViewRevision
    /// @version Teamcenter 10.1
    /// @return - int
    ///
    int  fnd0Save(  );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PSBOMViewRevision();

    /**
     * Destructor
     */
    virtual ~PSBOMViewRevision();

private:
    //  Getter method for the Implementation Object
    PSBOMViewRevisionImpl*  getPSBOMViewRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPSBOMViewRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PSBOMViewRevisionImpl*  m_psbomviewrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PSBOMViewRevision - desc for PSBOMViewRevision parameter
     */
    PSBOMViewRevision( const PSBOMViewRevision& );
    PSBOMViewRevision& operator=( const PSBOMViewRevision& );

    friend class  PSBOMViewRevisionDelegate;
    friend class  PSBOMViewRevisionDispatch;
    friend class  PSBOMViewRevisionGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__PSBOMVIEWREVISION__HXX
