//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PSBOMViewRevisionDelegate
    Filename:   PSBOMViewRevisionDelegate.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PSBOMVIEWREVISIONDELEGATE_HXX
#define TEAMCENTER__PSBOMVIEWREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ps/PSBOMViewRevision.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class PSBOMViewRevisionDelegate;
}
namespace Teamcenter
{
    class PSBOMViewRevisionImpl;
}
namespace Teamcenter
{
    class PSBOMViewRevision;
}
namespace Teamcenter
{
    class PSBOMViewRevisionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PS_API Teamcenter_alias::PSBOMViewRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PSBOMViewRevisionDelegate instance
    static PSBOMViewRevisionDelegate&  getInstance();

    //  Method to create the PSBOMViewRevisionImpl pointer
    static PSBOMViewRevisionImpl*  createImpl( PSBOMViewRevision&  ifObj );

    //  Method to delete the PSBOMViewRevisionImpl pointer
    static void deleteImpl( PSBOMViewRevisionImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.6
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0SubstituteGroupsBase(const PSBOMViewRevision &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Removes a PSOccurrence.
    /// @version Teamcenter 10.1
    /// @param occTag - PSOccurrence tag
    /// @return - int
    ///
    int  fnd0RemoveOccurrenceBase(const PSBOMViewRevision &ifObj,  tag_t occTag );


    ///
    /// replace a Occurrence.
    /// @version Teamcenter 10.1
    /// @param occTag - PSOccurrence tag
    /// @param childItem - tag to childitem
    /// @param childBomView - tag to childbomview
    /// @return - int
    ///
    int  fnd0ReplaceOccurrenceBase(const PSBOMViewRevision &ifObj,  tag_t occTag, tag_t childItem, tag_t childBomView );


    ///
    /// Saves the PSBOMViewRevision
    /// @version Teamcenter 10.1
    /// @return - int
    ///
    int  fnd0SaveBase(const PSBOMViewRevision &ifObj  );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @param isLockForDelete - A boolean to indicate if object(s) are to be locked for deletion
    /// @param allowRelock - A boolean to indicate if object(s) can be relocked, which will discard all unsaved changes, if already locked by the same user
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0LockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd, const bool isLockForDelete, const bool allowRelock );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0RefreshBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0UnlockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const PSBOMViewRevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const PSBOMViewRevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const PSBOMViewRevision &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static PSBOMViewRevisionDelegate*  m_pInstance;

    PSBOMViewRevisionDelegate();
    virtual ~PSBOMViewRevisionDelegate();
    static void setInstance( PSBOMViewRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::PSBOMViewRevisionGenImpl;

};

#include <ps/libps_undef.h>
#endif  //  TEAMCENTER__PSBOMVIEWREVISIONDELEGATE_HXX
