//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PSOccurrence
    Filename:   PSOccurrence.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PSOCCURRENCE__HXX
#define TEAMCENTER__PSOCCURRENCE__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class PSOccurrence;
}
namespace Teamcenter
{
    class PSOccurrenceImpl;
}
namespace Teamcenter
{
    class PSOccurrenceDelegate;
}
namespace Teamcenter
{
    class PSOccurrenceDispatch;
}
namespace Teamcenter
{
    class PSOccurrenceGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::PSOccurrence
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.6
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0SubstituteGrpList( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 11.6
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0SubstituteGrpList( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PSOccurrence();

    /**
     * Destructor
     */
    virtual ~PSOccurrence();

private:
    //  Getter method for the Implementation Object
    PSOccurrenceImpl*  getPSOccurrenceImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPSOccurrenceImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PSOccurrenceImpl*  m_psoccurrenceImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PSOccurrence - desc for PSOccurrence parameter
     */
    PSOccurrence( const PSOccurrence& );
    PSOccurrence& operator=( const PSOccurrence& );

    friend class  PSOccurrenceDelegate;
    friend class  PSOccurrenceDispatch;
    friend class  PSOccurrenceGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__PSOCCURRENCE__HXX
