//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PSOccurrenceNotes
    Filename:   PSOccurrenceNotes.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PSOCCURRENCENOTES__HXX
#define TEAMCENTER__PSOCCURRENCENOTES__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class PSOccurrenceNotes;
}
namespace Teamcenter
{
    class PSOccurrenceNotesImpl;
}
namespace Teamcenter
{
    class PSOccurrenceNotesDelegate;
}
namespace Teamcenter
{
    class PSOccurrenceNotesDispatch;
}
namespace Teamcenter
{
    class PSOccurrenceNotesGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::PSOccurrenceNotes
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PSOccurrenceNotes();

    /**
     * Destructor
     */
    virtual ~PSOccurrenceNotes();

private:
    //  Getter method for the Implementation Object
    PSOccurrenceNotesImpl*  getPSOccurrenceNotesImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPSOccurrenceNotesImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PSOccurrenceNotesImpl*  m_psoccurrencenotesImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PSOccurrenceNotes - desc for PSOccurrenceNotes parameter
     */
    PSOccurrenceNotes( const PSOccurrenceNotes& );
    PSOccurrenceNotes& operator=( const PSOccurrenceNotes& );

    friend class  PSOccurrenceNotesDelegate;
    friend class  PSOccurrenceNotesDispatch;
    friend class  PSOccurrenceNotesGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__PSOCCURRENCENOTES__HXX
