//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PSOccurrenceThread
    Filename:   PSOccurrenceThread.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PSOCCURRENCETHREAD__HXX
#define TEAMCENTER__PSOCCURRENCETHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class PSOccurrenceThread;
}
namespace Teamcenter
{
    class PSOccurrenceThreadImpl;
}
namespace Teamcenter
{
    class PSOccurrenceThreadDelegate;
}
namespace Teamcenter
{
    class PSOccurrenceThreadDispatch;
}
namespace Teamcenter
{
    class PSOccurrenceThreadGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::PSOccurrenceThread
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PSOccurrenceThread();

    /**
     * Destructor
     */
    virtual ~PSOccurrenceThread();

private:
    //  Getter method for the Implementation Object
    PSOccurrenceThreadImpl*  getPSOccurrenceThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPSOccurrenceThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PSOccurrenceThreadImpl*  m_psoccurrencethreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PSOccurrenceThread - desc for PSOccurrenceThread parameter
     */
    PSOccurrenceThread( const PSOccurrenceThread& );
    PSOccurrenceThread& operator=( const PSOccurrenceThread& );

    friend class  PSOccurrenceThreadDelegate;
    friend class  PSOccurrenceThreadDispatch;
    friend class  PSOccurrenceThreadGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__PSOCCURRENCETHREAD__HXX
