//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PSOccurrenceType
    Filename:   PSOccurrenceType.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PSOCCURRENCETYPE__HXX
#define TEAMCENTER__PSOCCURRENCETYPE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class PSOccurrenceType;
}
namespace Teamcenter
{
    class PSOccurrenceTypeImpl;
}
namespace Teamcenter
{
    class PSOccurrenceTypeDelegate;
}
namespace Teamcenter
{
    class PSOccurrenceTypeDispatch;
}
namespace Teamcenter
{
    class PSOccurrenceTypeGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::PSOccurrenceType
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PSOccurrenceType();

    /**
     * Destructor
     */
    virtual ~PSOccurrenceType();

private:
    //  Getter method for the Implementation Object
    PSOccurrenceTypeImpl*  getPSOccurrenceTypeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPSOccurrenceTypeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PSOccurrenceTypeImpl*  m_psoccurrencetypeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PSOccurrenceType - desc for PSOccurrenceType parameter
     */
    PSOccurrenceType( const PSOccurrenceType& );
    PSOccurrenceType& operator=( const PSOccurrenceType& );

    friend class  PSOccurrenceTypeDelegate;
    friend class  PSOccurrenceTypeDispatch;
    friend class  PSOccurrenceTypeGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__PSOCCURRENCETYPE__HXX
