//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PSOption
    Filename:   PSOption.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PSOPTION__HXX
#define TEAMCENTER__PSOPTION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class PSOption;
}
namespace Teamcenter
{
    class PSOptionImpl;
}
namespace Teamcenter
{
    class PSOptionDelegate;
}
namespace Teamcenter
{
    class PSOptionDispatch;
}
namespace Teamcenter
{
    class PSOptionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::PSOption
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PSOption();

    /**
     * Destructor
     */
    virtual ~PSOption();

private:
    //  Getter method for the Implementation Object
    PSOptionImpl*  getPSOptionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPSOptionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PSOptionImpl*  m_psoptionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PSOption - desc for PSOption parameter
     */
    PSOption( const PSOption& );
    PSOption& operator=( const PSOption& );

    friend class  PSOptionDelegate;
    friend class  PSOptionDispatch;
    friend class  PSOptionGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__PSOPTION__HXX
