//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PSOptionalItemList
    Filename:   PSOptionalItemList.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PSOPTIONALITEMLIST__HXX
#define TEAMCENTER__PSOPTIONALITEMLIST__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class PSOptionalItemList;
}
namespace Teamcenter
{
    class PSOptionalItemListImpl;
}
namespace Teamcenter
{
    class PSOptionalItemListDelegate;
}
namespace Teamcenter
{
    class PSOptionalItemListDispatch;
}
namespace Teamcenter
{
    class PSOptionalItemListGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::PSOptionalItemList
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PSOptionalItemList();

    /**
     * Destructor
     */
    virtual ~PSOptionalItemList();

private:
    //  Getter method for the Implementation Object
    PSOptionalItemListImpl*  getPSOptionalItemListImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPSOptionalItemListImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PSOptionalItemListImpl*  m_psoptionalitemlistImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PSOptionalItemList - desc for PSOptionalItemList parameter
     */
    PSOptionalItemList( const PSOptionalItemList& );
    PSOptionalItemList& operator=( const PSOptionalItemList& );

    friend class  PSOptionalItemListDelegate;
    friend class  PSOptionalItemListDispatch;
    friend class  PSOptionalItemListGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__PSOPTIONALITEMLIST__HXX
