//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PSViewType
    Filename:   PSViewType.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PSVIEWTYPE__HXX
#define TEAMCENTER__PSVIEWTYPE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class PSViewType;
}
namespace Teamcenter
{
    class PSViewTypeImpl;
}
namespace Teamcenter
{
    class PSViewTypeDelegate;
}
namespace Teamcenter
{
    class PSViewTypeDispatch;
}
namespace Teamcenter
{
    class PSViewTypeGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::PSViewType
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PSViewType();

    /**
     * Destructor
     */
    virtual ~PSViewType();

private:
    //  Getter method for the Implementation Object
    PSViewTypeImpl*  getPSViewTypeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPSViewTypeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PSViewTypeImpl*  m_psviewtypeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PSViewType - desc for PSViewType parameter
     */
    PSViewType( const PSViewType& );
    PSViewType& operator=( const PSViewType& );

    friend class  PSViewTypeDelegate;
    friend class  PSViewTypeDispatch;
    friend class  PSViewTypeGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__PSVIEWTYPE__HXX
