//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PSXform
    Filename:   PSXform.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PSXFORM__HXX
#define TEAMCENTER__PSXFORM__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class PSXform;
}
namespace Teamcenter
{
    class PSXformImpl;
}
namespace Teamcenter
{
    class PSXformDelegate;
}
namespace Teamcenter
{
    class PSXformDispatch;
}
namespace Teamcenter
{
    class PSXformGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::PSXform
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PSXform();

    /**
     * Destructor
     */
    virtual ~PSXform();

private:
    //  Getter method for the Implementation Object
    PSXformImpl*  getPSXformImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPSXformImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PSXformImpl*  m_psxformImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PSXform - desc for PSXform parameter
     */
    PSXform( const PSXform& );
    PSXform& operator=( const PSXform& );

    friend class  PSXformDelegate;
    friend class  PSXformDispatch;
    friend class  PSXformGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__PSXFORM__HXX
