//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PSXformDelegate
    Filename:   PSXformDelegate.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PSXFORMDELEGATE_HXX
#define TEAMCENTER__PSXFORMDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ps/PSXform.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class PSXformDelegate;
}
namespace Teamcenter
{
    class PSXformImpl;
}
namespace Teamcenter
{
    class PSXform;
}
namespace Teamcenter
{
    class PSXformGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PS_API Teamcenter_alias::PSXformDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PSXformDelegate instance
    static PSXformDelegate&  getInstance();

    //  Method to create the PSXformImpl pointer
    static PSXformImpl*  createImpl( PSXform&  ifObj );

    //  Method to delete the PSXformImpl pointer
    static void deleteImpl( PSXformImpl*  impl );



protected:
    //  Pointer to the instance
    static PSXformDelegate*  m_pInstance;

    PSXformDelegate();
    virtual ~PSXformDelegate();
    static void setInstance( PSXformDelegate*  instance );


private:
    friend class  ::Teamcenter::PSXformGenImpl;

};

#include <ps/libps_undef.h>
#endif  //  TEAMCENTER__PSXFORMDELEGATE_HXX
