//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PublishLink
    Filename:   PublishLink.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PUBLISHLINK__HXX
#define TEAMCENTER__PUBLISHLINK__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ManagedRelation.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class PublishLink;
}
namespace Teamcenter
{
    class PublishLinkImpl;
}
namespace Teamcenter
{
    class PublishLinkDelegate;
}
namespace Teamcenter
{
    class PublishLinkDispatch;
}
namespace Teamcenter
{
    class PublishLinkGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::PublishLink
     : public  ::Teamcenter::ManagedRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PublishLink();

    /**
     * Destructor
     */
    virtual ~PublishLink();

private:
    //  Getter method for the Implementation Object
    PublishLinkImpl*  getPublishLinkImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPublishLinkImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PublishLinkImpl*  m_publishlinkImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PublishLink - desc for PublishLink parameter
     */
    PublishLink( const PublishLink& );
    PublishLink& operator=( const PublishLink& );

    friend class  PublishLinkDelegate;
    friend class  PublishLinkDispatch;
    friend class  PublishLinkGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__PUBLISHLINK__HXX
