//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PublishLinkDelegate
    Filename:   PublishLinkDelegate.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PUBLISHLINKDELEGATE_HXX
#define TEAMCENTER__PUBLISHLINKDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ps/PublishLink.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class PublishLinkDelegate;
}
namespace Teamcenter
{
    class PublishLinkImpl;
}
namespace Teamcenter
{
    class PublishLink;
}
namespace Teamcenter
{
    class PublishLinkGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PS_API Teamcenter_alias::PublishLinkDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PublishLinkDelegate instance
    static PublishLinkDelegate&  getInstance();

    //  Method to create the PublishLinkImpl pointer
    static PublishLinkImpl*  createImpl( PublishLink&  ifObj );

    //  Method to delete the PublishLinkImpl pointer
    static void deleteImpl( PublishLinkImpl*  impl );


    ///
    /// This operation deletes inputs objects in bulk. It either deletes none of the input objects or deletes all the input objects. It doesn't support partial deletion.
    /// @version Teamcenter 11.6
    /// @param inputs - A vector of data that contains reference to the object to be deleted.
    /// @param bd - A data structure to store objects and other information relevant for set-based operation.
    /// @return - Returns ITK_ok on Success. Otherwise, returns the specific error code.
    ///
    int  fnd0BulkDeleteBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const PublishLink &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const PublishLink &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static PublishLinkDelegate*  m_pInstance;

    PublishLinkDelegate();
    virtual ~PublishLinkDelegate();
    static void setInstance( PublishLinkDelegate*  instance );


private:
    friend class  ::Teamcenter::PublishLinkGenImpl;

};

#include <ps/libps_undef.h>
#endif  //  TEAMCENTER__PUBLISHLINKDELEGATE_HXX
