//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RollupTemplate
    Filename:   RollupTemplate.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ROLLUPTEMPLATE__HXX
#define TEAMCENTER__ROLLUPTEMPLATE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class RollupTemplate;
}
namespace Teamcenter
{
    class RollupTemplateImpl;
}
namespace Teamcenter
{
    class RollupTemplateDelegate;
}
namespace Teamcenter
{
    class RollupTemplateDispatch;
}
namespace Teamcenter
{
    class RollupTemplateGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::RollupTemplate
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    RollupTemplate();

    /**
     * Destructor
     */
    virtual ~RollupTemplate();

private:
    //  Getter method for the Implementation Object
    RollupTemplateImpl*  getRollupTemplateImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRollupTemplateImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    RollupTemplateImpl*  m_rolluptemplateImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param RollupTemplate - desc for RollupTemplate parameter
     */
    RollupTemplate( const RollupTemplate& );
    RollupTemplate& operator=( const RollupTemplate& );

    friend class  RollupTemplateDelegate;
    friend class  RollupTemplateDispatch;
    friend class  RollupTemplateGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__ROLLUPTEMPLATE__HXX
