//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RollupTemplateCofMass
    Filename:   RollupTemplateCofMass.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ROLLUPTEMPLATECOFMASS__HXX
#define TEAMCENTER__ROLLUPTEMPLATECOFMASS__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class RollupTemplateCofMass;
}
namespace Teamcenter
{
    class RollupTemplateCofMassImpl;
}
namespace Teamcenter
{
    class RollupTemplateCofMassDelegate;
}
namespace Teamcenter
{
    class RollupTemplateCofMassDispatch;
}
namespace Teamcenter
{
    class RollupTemplateCofMassGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::RollupTemplateCofMass
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    RollupTemplateCofMass();

    /**
     * Destructor
     */
    virtual ~RollupTemplateCofMass();

private:
    //  Getter method for the Implementation Object
    RollupTemplateCofMassImpl*  getRollupTemplateCofMassImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRollupTemplateCofMassImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    RollupTemplateCofMassImpl*  m_rolluptemplatecofmassImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param RollupTemplateCofMass - desc for RollupTemplateCofMass parameter
     */
    RollupTemplateCofMass( const RollupTemplateCofMass& );
    RollupTemplateCofMass& operator=( const RollupTemplateCofMass& );

    friend class  RollupTemplateCofMassDelegate;
    friend class  RollupTemplateCofMassDispatch;
    friend class  RollupTemplateCofMassGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__ROLLUPTEMPLATECOFMASS__HXX
