//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RollupTemplateInertia
    Filename:   RollupTemplateInertia.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ROLLUPTEMPLATEINERTIA__HXX
#define TEAMCENTER__ROLLUPTEMPLATEINERTIA__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class RollupTemplateInertia;
}
namespace Teamcenter
{
    class RollupTemplateInertiaImpl;
}
namespace Teamcenter
{
    class RollupTemplateInertiaDelegate;
}
namespace Teamcenter
{
    class RollupTemplateInertiaDispatch;
}
namespace Teamcenter
{
    class RollupTemplateInertiaGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::RollupTemplateInertia
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    RollupTemplateInertia();

    /**
     * Destructor
     */
    virtual ~RollupTemplateInertia();

private:
    //  Getter method for the Implementation Object
    RollupTemplateInertiaImpl*  getRollupTemplateInertiaImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRollupTemplateInertiaImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    RollupTemplateInertiaImpl*  m_rolluptemplateinertiaImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param RollupTemplateInertia - desc for RollupTemplateInertia parameter
     */
    RollupTemplateInertia( const RollupTemplateInertia& );
    RollupTemplateInertia& operator=( const RollupTemplateInertia& );

    friend class  RollupTemplateInertiaDelegate;
    friend class  RollupTemplateInertiaDispatch;
    friend class  RollupTemplateInertiaGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__ROLLUPTEMPLATEINERTIA__HXX
