//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RollupTemplateInertiaDelegate
    Filename:   RollupTemplateInertiaDelegate.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ROLLUPTEMPLATEINERTIADELEGATE_HXX
#define TEAMCENTER__ROLLUPTEMPLATEINERTIADELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ps/RollupTemplateInertia.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class RollupTemplateInertiaDelegate;
}
namespace Teamcenter
{
    class RollupTemplateInertiaImpl;
}
namespace Teamcenter
{
    class RollupTemplateInertia;
}
namespace Teamcenter
{
    class RollupTemplateInertiaGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PS_API Teamcenter_alias::RollupTemplateInertiaDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the RollupTemplateInertiaDelegate instance
    static RollupTemplateInertiaDelegate&  getInstance();

    //  Method to create the RollupTemplateInertiaImpl pointer
    static RollupTemplateInertiaImpl*  createImpl( RollupTemplateInertia&  ifObj );

    //  Method to delete the RollupTemplateInertiaImpl pointer
    static void deleteImpl( RollupTemplateInertiaImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static RollupTemplateInertiaDelegate*  m_pInstance;

    RollupTemplateInertiaDelegate();
    virtual ~RollupTemplateInertiaDelegate();
    static void setInstance( RollupTemplateInertiaDelegate*  instance );


private:
    friend class  ::Teamcenter::RollupTemplateInertiaGenImpl;

};

#include <ps/libps_undef.h>
#endif  //  TEAMCENTER__ROLLUPTEMPLATEINERTIADELEGATE_HXX
