//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RollupTemplateReference
    Filename:   RollupTemplateReference.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ROLLUPTEMPLATEREFERENCE__HXX
#define TEAMCENTER__ROLLUPTEMPLATEREFERENCE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class RollupTemplateReference;
}
namespace Teamcenter
{
    class RollupTemplateReferenceImpl;
}
namespace Teamcenter
{
    class RollupTemplateReferenceDelegate;
}
namespace Teamcenter
{
    class RollupTemplateReferenceDispatch;
}
namespace Teamcenter
{
    class RollupTemplateReferenceGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::RollupTemplateReference
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    RollupTemplateReference();

    /**
     * Destructor
     */
    virtual ~RollupTemplateReference();

private:
    //  Getter method for the Implementation Object
    RollupTemplateReferenceImpl*  getRollupTemplateReferenceImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRollupTemplateReferenceImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    RollupTemplateReferenceImpl*  m_rolluptemplatereferenceImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param RollupTemplateReference - desc for RollupTemplateReference parameter
     */
    RollupTemplateReference( const RollupTemplateReference& );
    RollupTemplateReference& operator=( const RollupTemplateReference& );

    friend class  RollupTemplateReferenceDelegate;
    friend class  RollupTemplateReferenceDispatch;
    friend class  RollupTemplateReferenceGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__ROLLUPTEMPLATEREFERENCE__HXX
