//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RollupTemplateSum
    Filename:   RollupTemplateSum.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ROLLUPTEMPLATESUM__HXX
#define TEAMCENTER__ROLLUPTEMPLATESUM__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class RollupTemplateSum;
}
namespace Teamcenter
{
    class RollupTemplateSumImpl;
}
namespace Teamcenter
{
    class RollupTemplateSumDelegate;
}
namespace Teamcenter
{
    class RollupTemplateSumDispatch;
}
namespace Teamcenter
{
    class RollupTemplateSumGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::RollupTemplateSum
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    RollupTemplateSum();

    /**
     * Destructor
     */
    virtual ~RollupTemplateSum();

private:
    //  Getter method for the Implementation Object
    RollupTemplateSumImpl*  getRollupTemplateSumImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRollupTemplateSumImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    RollupTemplateSumImpl*  m_rolluptemplatesumImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param RollupTemplateSum - desc for RollupTemplateSum parameter
     */
    RollupTemplateSum( const RollupTemplateSum& );
    RollupTemplateSum& operator=( const RollupTemplateSum& );

    friend class  RollupTemplateSumDelegate;
    friend class  RollupTemplateSumDispatch;
    friend class  RollupTemplateSumGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__ROLLUPTEMPLATESUM__HXX
