//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RollupTemplateSumDelegate
    Filename:   RollupTemplateSumDelegate.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ROLLUPTEMPLATESUMDELEGATE_HXX
#define TEAMCENTER__ROLLUPTEMPLATESUMDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ps/RollupTemplateSum.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class RollupTemplateSumDelegate;
}
namespace Teamcenter
{
    class RollupTemplateSumImpl;
}
namespace Teamcenter
{
    class RollupTemplateSum;
}
namespace Teamcenter
{
    class RollupTemplateSumGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PS_API Teamcenter_alias::RollupTemplateSumDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the RollupTemplateSumDelegate instance
    static RollupTemplateSumDelegate&  getInstance();

    //  Method to create the RollupTemplateSumImpl pointer
    static RollupTemplateSumImpl*  createImpl( RollupTemplateSum&  ifObj );

    //  Method to delete the RollupTemplateSumImpl pointer
    static void deleteImpl( RollupTemplateSumImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static RollupTemplateSumDelegate*  m_pInstance;

    RollupTemplateSumDelegate();
    virtual ~RollupTemplateSumDelegate();
    static void setInstance( RollupTemplateSumDelegate*  instance );


private:
    friend class  ::Teamcenter::RollupTemplateSumGenImpl;

};

#include <ps/libps_undef.h>
#endif  //  TEAMCENTER__ROLLUPTEMPLATESUMDELEGATE_HXX
