//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, StoredOptionSet
    Filename:   StoredOptionSet.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__STOREDOPTIONSET__HXX
#define TEAMCENTER__STOREDOPTIONSET__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class StoredOptionSet;
}
namespace Teamcenter
{
    class StoredOptionSetImpl;
}
namespace Teamcenter
{
    class StoredOptionSetDelegate;
}
namespace Teamcenter
{
    class StoredOptionSetDispatch;
}
namespace Teamcenter
{
    class StoredOptionSetGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::StoredOptionSet
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    StoredOptionSet();

    /**
     * Destructor
     */
    virtual ~StoredOptionSet();

private:
    //  Getter method for the Implementation Object
    StoredOptionSetImpl*  getStoredOptionSetImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setStoredOptionSetImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    StoredOptionSetImpl*  m_storedoptionsetImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param StoredOptionSet - desc for StoredOptionSet parameter
     */
    StoredOptionSet( const StoredOptionSet& );
    StoredOptionSet& operator=( const StoredOptionSet& );

    friend class  StoredOptionSetDelegate;
    friend class  StoredOptionSetDispatch;
    friend class  StoredOptionSetGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__STOREDOPTIONSET__HXX
