//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, StoredOptionValue
    Filename:   StoredOptionValue.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__STOREDOPTIONVALUE__HXX
#define TEAMCENTER__STOREDOPTIONVALUE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class StoredOptionValue;
}
namespace Teamcenter
{
    class StoredOptionValueImpl;
}
namespace Teamcenter
{
    class StoredOptionValueDelegate;
}
namespace Teamcenter
{
    class StoredOptionValueDispatch;
}
namespace Teamcenter
{
    class StoredOptionValueGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::StoredOptionValue
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    StoredOptionValue();

    /**
     * Destructor
     */
    virtual ~StoredOptionValue();

private:
    //  Getter method for the Implementation Object
    StoredOptionValueImpl*  getStoredOptionValueImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setStoredOptionValueImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    StoredOptionValueImpl*  m_storedoptionvalueImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param StoredOptionValue - desc for StoredOptionValue parameter
     */
    StoredOptionValue( const StoredOptionValue& );
    StoredOptionValue& operator=( const StoredOptionValue& );

    friend class  StoredOptionValueDelegate;
    friend class  StoredOptionValueDispatch;
    friend class  StoredOptionValueGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__STOREDOPTIONVALUE__HXX
