//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, VariantExpression
    Filename:   VariantExpression.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VARIANTEXPRESSION__HXX
#define TEAMCENTER__VARIANTEXPRESSION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class VariantExpression;
}
namespace Teamcenter
{
    class VariantExpressionImpl;
}
namespace Teamcenter
{
    class VariantExpressionDelegate;
}
namespace Teamcenter
{
    class VariantExpressionDispatch;
}
namespace Teamcenter
{
    class VariantExpressionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::VariantExpression
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    VariantExpression();

    /**
     * Destructor
     */
    virtual ~VariantExpression();

private:
    //  Getter method for the Implementation Object
    VariantExpressionImpl*  getVariantExpressionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setVariantExpressionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    VariantExpressionImpl*  m_variantexpressionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param VariantExpression - desc for VariantExpression parameter
     */
    VariantExpression( const VariantExpression& );
    VariantExpression& operator=( const VariantExpression& );

    friend class  VariantExpressionDelegate;
    friend class  VariantExpressionDispatch;
    friend class  VariantExpressionGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__VARIANTEXPRESSION__HXX
