//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, VariantExpressionBlock
    Filename:   VariantExpressionBlock.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VARIANTEXPRESSIONBLOCK__HXX
#define TEAMCENTER__VARIANTEXPRESSIONBLOCK__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class VariantExpressionBlock;
}
namespace Teamcenter
{
    class VariantExpressionBlockImpl;
}
namespace Teamcenter
{
    class VariantExpressionBlockDelegate;
}
namespace Teamcenter
{
    class VariantExpressionBlockDispatch;
}
namespace Teamcenter
{
    class VariantExpressionBlockGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::VariantExpressionBlock
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    VariantExpressionBlock();

    /**
     * Destructor
     */
    virtual ~VariantExpressionBlock();

private:
    //  Getter method for the Implementation Object
    VariantExpressionBlockImpl*  getVariantExpressionBlockImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setVariantExpressionBlockImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    VariantExpressionBlockImpl*  m_variantexpressionblockImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param VariantExpressionBlock - desc for VariantExpressionBlock parameter
     */
    VariantExpressionBlock( const VariantExpressionBlock& );
    VariantExpressionBlock& operator=( const VariantExpressionBlock& );

    friend class  VariantExpressionBlockDelegate;
    friend class  VariantExpressionBlockDispatch;
    friend class  VariantExpressionBlockGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__VARIANTEXPRESSIONBLOCK__HXX
