//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, VariantExpressionBlockDelegate
    Filename:   VariantExpressionBlockDelegate.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VARIANTEXPRESSIONBLOCKDELEGATE_HXX
#define TEAMCENTER__VARIANTEXPRESSIONBLOCKDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ps/VariantExpressionBlock.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class VariantExpressionBlockDelegate;
}
namespace Teamcenter
{
    class VariantExpressionBlockImpl;
}
namespace Teamcenter
{
    class VariantExpressionBlock;
}
namespace Teamcenter
{
    class VariantExpressionBlockGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PS_API Teamcenter_alias::VariantExpressionBlockDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the VariantExpressionBlockDelegate instance
    static VariantExpressionBlockDelegate&  getInstance();

    //  Method to create the VariantExpressionBlockImpl pointer
    static VariantExpressionBlockImpl*  createImpl( VariantExpressionBlock&  ifObj );

    //  Method to delete the VariantExpressionBlockImpl pointer
    static void deleteImpl( VariantExpressionBlockImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const VariantExpressionBlock &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static VariantExpressionBlockDelegate*  m_pInstance;

    VariantExpressionBlockDelegate();
    virtual ~VariantExpressionBlockDelegate();
    static void setInstance( VariantExpressionBlockDelegate*  instance );


private:
    friend class  ::Teamcenter::VariantExpressionBlockGenImpl;

};

#include <ps/libps_undef.h>
#endif  //  TEAMCENTER__VARIANTEXPRESSIONBLOCKDELEGATE_HXX
