//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, VariantExpressionDelegate
    Filename:   VariantExpressionDelegate.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VARIANTEXPRESSIONDELEGATE_HXX
#define TEAMCENTER__VARIANTEXPRESSIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ps/VariantExpression.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class VariantExpressionDelegate;
}
namespace Teamcenter
{
    class VariantExpressionImpl;
}
namespace Teamcenter
{
    class VariantExpression;
}
namespace Teamcenter
{
    class VariantExpressionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PS_API Teamcenter_alias::VariantExpressionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the VariantExpressionDelegate instance
    static VariantExpressionDelegate&  getInstance();

    //  Method to create the VariantExpressionImpl pointer
    static VariantExpressionImpl*  createImpl( VariantExpression&  ifObj );

    //  Method to delete the VariantExpressionImpl pointer
    static void deleteImpl( VariantExpressionImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const VariantExpression &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const VariantExpression &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static VariantExpressionDelegate*  m_pInstance;

    VariantExpressionDelegate();
    virtual ~VariantExpressionDelegate();
    static void setInstance( VariantExpressionDelegate*  instance );


private:
    friend class  ::Teamcenter::VariantExpressionGenImpl;

};

#include <ps/libps_undef.h>
#endif  //  TEAMCENTER__VARIANTEXPRESSIONDELEGATE_HXX
