//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, VariantExpressionEditor
    Filename:   VariantExpressionEditor.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VARIANTEXPRESSIONEDITOR__HXX
#define TEAMCENTER__VARIANTEXPRESSIONEDITOR__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class VariantExpressionEditor;
}
namespace Teamcenter
{
    class VariantExpressionEditorImpl;
}
namespace Teamcenter
{
    class VariantExpressionEditorDelegate;
}
namespace Teamcenter
{
    class VariantExpressionEditorDispatch;
}
namespace Teamcenter
{
    class VariantExpressionEditorGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::VariantExpressionEditor
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    VariantExpressionEditor();

    /**
     * Destructor
     */
    virtual ~VariantExpressionEditor();

private:
    //  Getter method for the Implementation Object
    VariantExpressionEditorImpl*  getVariantExpressionEditorImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setVariantExpressionEditorImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    VariantExpressionEditorImpl*  m_variantexpressioneditorImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param VariantExpressionEditor - desc for VariantExpressionEditor parameter
     */
    VariantExpressionEditor( const VariantExpressionEditor& );
    VariantExpressionEditor& operator=( const VariantExpressionEditor& );

    friend class  VariantExpressionEditorDelegate;
    friend class  VariantExpressionEditorDispatch;
    friend class  VariantExpressionEditorGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__VARIANTEXPRESSIONEDITOR__HXX
