//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, VariantRevision
    Filename:   VariantRevision.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VARIANTREVISION__HXX
#define TEAMCENTER__VARIANTREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class VariantRevision;
}
namespace Teamcenter
{
    class VariantRevisionImpl;
}
namespace Teamcenter
{
    class VariantRevisionDelegate;
}
namespace Teamcenter
{
    class VariantRevisionDispatch;
}
namespace Teamcenter
{
    class VariantRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::VariantRevision
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    VariantRevision();

    /**
     * Destructor
     */
    virtual ~VariantRevision();

private:
    //  Getter method for the Implementation Object
    VariantRevisionImpl*  getVariantRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setVariantRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    VariantRevisionImpl*  m_variantrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param VariantRevision - desc for VariantRevision parameter
     */
    VariantRevision( const VariantRevision& );
    VariantRevision& operator=( const VariantRevision& );

    friend class  VariantRevisionDelegate;
    friend class  VariantRevisionDispatch;
    friend class  VariantRevisionGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__VARIANTREVISION__HXX
