//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, VariantRevisionDelegate
    Filename:   VariantRevisionDelegate.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VARIANTREVISIONDELEGATE_HXX
#define TEAMCENTER__VARIANTREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ps/VariantRevision.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class VariantRevisionDelegate;
}
namespace Teamcenter
{
    class VariantRevisionImpl;
}
namespace Teamcenter
{
    class VariantRevision;
}
namespace Teamcenter
{
    class VariantRevisionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PS_API Teamcenter_alias::VariantRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the VariantRevisionDelegate instance
    static VariantRevisionDelegate&  getInstance();

    //  Method to create the VariantRevisionImpl pointer
    static VariantRevisionImpl*  createImpl( VariantRevision&  ifObj );

    //  Method to delete the VariantRevisionImpl pointer
    static void deleteImpl( VariantRevisionImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const VariantRevision &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static VariantRevisionDelegate*  m_pInstance;

    VariantRevisionDelegate();
    virtual ~VariantRevisionDelegate();
    static void setInstance( VariantRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::VariantRevisionGenImpl;

};

#include <ps/libps_undef.h>
#endif  //  TEAMCENTER__VARIANTREVISIONDELEGATE_HXX
