//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, VariantRule
    Filename:   VariantRule.hxx
    Module:     ps
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VARIANTRULE__HXX
#define TEAMCENTER__VARIANTRULE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <ps/libps_exports.h>

namespace Teamcenter
{
    class VariantRule;
}
namespace Teamcenter
{
    class VariantRuleImpl;
}
namespace Teamcenter
{
    class VariantRuleDelegate;
}
namespace Teamcenter
{
    class VariantRuleDispatch;
}
namespace Teamcenter
{
    class VariantRuleGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PS_API  Teamcenter::VariantRule
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    VariantRule();

    /**
     * Destructor
     */
    virtual ~VariantRule();

private:
    //  Getter method for the Implementation Object
    VariantRuleImpl*  getVariantRuleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setVariantRuleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    VariantRuleImpl*  m_variantruleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param VariantRule - desc for VariantRule parameter
     */
    VariantRule( const VariantRule& );
    VariantRule& operator=( const VariantRule& );

    friend class  VariantRuleDelegate;
    friend class  VariantRuleDispatch;
    friend class  VariantRuleGenImpl;
};

#include <ps/libps_undef.h>
#endif //   TEAMCENTER__VARIANTRULE__HXX
