//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  ps

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libps

#if !defined(LIBPS) && !defined(IPLIB)
#   error IPLIB or LIBPS is not defined
#endif

/* Handwritten code should use PS_API, not PSEXPORT */

#define PS_API PSEXPORT

#if IPLIB==libps || defined(LIBPS)
#   if defined(__lint)
#       define PSEXPORT       __export(ps)
#       define PSGLOBAL       extern __global(ps)
#       define PSPRIVATE      extern __private(ps)
#   elif defined(_WIN32)
#       define PSEXPORT       __declspec(dllexport)
#       define PSGLOBAL       extern __declspec(dllexport)
#       define PSPRIVATE      extern
#   else
#       define PSEXPORT
#       define PSGLOBAL       extern
#       define PSPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define PSEXPORT       __export(ps)
#       define PSGLOBAL       extern __global(ps)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define PSEXPORT      __declspec(dllimport)
#       define PSGLOBAL       extern __declspec(dllimport)
#   else
#       define PSEXPORT
#       define PSGLOBAL       extern
#   endif
#endif
