//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ptn0ApprSrchPartition
    Filename:   Ptn0ApprSrchPartition.hxx
    Module:     ptn0partition
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PARTITION__PTN0APPRSRCHPARTITION__HXX
#define TEAMCENTER__PARTITION__PTN0APPRSRCHPARTITION__HXX

#include <common/tc_deprecation_macros.h>
#include <rdv/ApprSearchCriteria.hxx>

#include <ptn0partition/libptn0partition_exports.h>

namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0ApprSrchPartition;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0ApprSrchPartitionImpl;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0ApprSrchPartitionDelegate;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0ApprSrchPartitionDispatch;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0ApprSrchPartitionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PTN0PARTITION_API  Teamcenter::Partition::Ptn0ApprSrchPartition
     : public  ::Teamcenter::ApprSearchCriteria
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPtn0include_children( bool &value, bool &isNull ) const;

    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPtn0include_children( bool value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ptn0ApprSrchPartition();

    /**
     * Destructor
     */
    virtual ~Ptn0ApprSrchPartition();

private:
    //  Getter method for the Implementation Object
    Ptn0ApprSrchPartitionImpl*  getPtn0ApprSrchPartitionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPtn0ApprSrchPartitionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ptn0ApprSrchPartitionImpl*  m_ptn0apprsrchpartitionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ptn0ApprSrchPartition - desc for Ptn0ApprSrchPartition parameter
     */
    Ptn0ApprSrchPartition( const Ptn0ApprSrchPartition& );
    Ptn0ApprSrchPartition& operator=( const Ptn0ApprSrchPartition& );

    friend class  Ptn0ApprSrchPartitionDelegate;
    friend class  Ptn0ApprSrchPartitionDispatch;
    friend class  Ptn0ApprSrchPartitionGenImpl;
};

#include <ptn0partition/libptn0partition_undef.h>
#endif //   TEAMCENTER__PARTITION__PTN0APPRSRCHPARTITION__HXX
