//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ptn0ChildParentLink
    Filename:   Ptn0ChildParentLink.hxx
    Module:     ptn0partition
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PARTITION__PTN0CHILDPARENTLINK__HXX
#define TEAMCENTER__PARTITION__PTN0CHILDPARENTLINK__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <ptn0partition/Ptn0PartitionLink.hxx>

#include <ptn0partition/libptn0partition_exports.h>

namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0ChildParentLink;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0ChildParentLinkImpl;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0ChildParentLinkDelegate;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0ChildParentLinkDispatch;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0ChildParentLinkGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PTN0PARTITION_API  Teamcenter::Partition::Ptn0ChildParentLink
     : public  ::Teamcenter::Partition::Ptn0PartitionLink
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPtn0child_partition( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPtn0child_partition( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ptn0ChildParentLink();

    /**
     * Destructor
     */
    virtual ~Ptn0ChildParentLink();

private:
    //  Getter method for the Implementation Object
    Ptn0ChildParentLinkImpl*  getPtn0ChildParentLinkImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPtn0ChildParentLinkImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ptn0ChildParentLinkImpl*  m_ptn0childparentlinkImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ptn0ChildParentLink - desc for Ptn0ChildParentLink parameter
     */
    Ptn0ChildParentLink( const Ptn0ChildParentLink& );
    Ptn0ChildParentLink& operator=( const Ptn0ChildParentLink& );

    friend class  Ptn0ChildParentLinkDelegate;
    friend class  Ptn0ChildParentLinkDispatch;
    friend class  Ptn0ChildParentLinkGenImpl;
};

#include <ptn0partition/libptn0partition_undef.h>
#endif //   TEAMCENTER__PARTITION__PTN0CHILDPARENTLINK__HXX
