//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ptn0ChildParentLinkDelegate
    Filename:   Ptn0ChildParentLinkDelegate.hxx
    Module:     ptn0partition
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PARTITION__PTN0CHILDPARENTLINKDELEGATE_HXX
#define TEAMCENTER__PARTITION__PTN0CHILDPARENTLINKDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ptn0partition/Ptn0ChildParentLink.hxx>

#include <ptn0partition/libptn0partition_exports.h>

namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0ChildParentLinkDelegate;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0ChildParentLinkImpl;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0ChildParentLink;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0ChildParentLinkGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  PTN0PARTITION_API Teamcenter_alias::Partition::Ptn0ChildParentLinkDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Ptn0ChildParentLinkDelegate instance
    static Ptn0ChildParentLinkDelegate&  getInstance();

    //  Method to create the Ptn0ChildParentLinkImpl pointer
    static Ptn0ChildParentLinkImpl*  createImpl( Ptn0ChildParentLink&  ifObj );

    //  Method to delete the Ptn0ChildParentLinkImpl pointer
    static void deleteImpl( Ptn0ChildParentLinkImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPtn0child_partitionBase(const Ptn0ChildParentLink &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPtn0child_partitionBase(Ptn0ChildParentLink &ifObj,  const tag_t &value, bool isNull );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static Ptn0ChildParentLinkDelegate*  m_pInstance;

    Ptn0ChildParentLinkDelegate();
    virtual ~Ptn0ChildParentLinkDelegate();
    static void setInstance( Ptn0ChildParentLinkDelegate*  instance );


private:
    friend class  ::Teamcenter::Partition::Ptn0ChildParentLinkGenImpl;

};

#include <ptn0partition/libptn0partition_undef.h>
#endif  //  TEAMCENTER__PARTITION__PTN0CHILDPARENTLINKDELEGATE_HXX
