//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ptn0Membership
    Filename:   Ptn0Membership.hxx
    Module:     ptn0partition
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PARTITION__PTN0MEMBERSHIP__HXX
#define TEAMCENTER__PARTITION__PTN0MEMBERSHIP__HXX

#include <unidefs.h>
#include <string>
#include <common/tc_deprecation_macros.h>
#include <ptn0partition/Ptn0PartitionLink.hxx>

#include <ptn0partition/libptn0partition_exports.h>

namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0Membership;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0MembershipImpl;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0MembershipDelegate;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0MembershipDispatch;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0MembershipGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PTN0PARTITION_API  Teamcenter::Partition::Ptn0Membership
     : public  ::Teamcenter::Partition::Ptn0PartitionLink
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPtn0is_partition_owned( bool &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPtn0partition_member( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPtn0reference_designator( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPtn0is_partition_owned( bool value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPtn0partition_member( const tag_t &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPtn0reference_designator( const std::string &value, bool isNull=false );

    ///
    /// ptn0isOwningMembership
    /// @version Teamcenter 9
    /// @param isOwning - output parameter to indicate whether the Design Component owns membership
    /// @return - ptn0isOwningMembership
    ///
    int  ptn0isOwningMembership( bool *isOwning );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ptn0Membership();

    /**
     * Destructor
     */
    virtual ~Ptn0Membership();

private:
    //  Getter method for the Implementation Object
    Ptn0MembershipImpl*  getPtn0MembershipImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPtn0MembershipImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ptn0MembershipImpl*  m_ptn0membershipImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ptn0Membership - desc for Ptn0Membership parameter
     */
    Ptn0Membership( const Ptn0Membership& );
    Ptn0Membership& operator=( const Ptn0Membership& );

    friend class  Ptn0MembershipDelegate;
    friend class  Ptn0MembershipDispatch;
    friend class  Ptn0MembershipGenImpl;
};

#include <ptn0partition/libptn0partition_undef.h>
#endif //   TEAMCENTER__PARTITION__PTN0MEMBERSHIP__HXX
