//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ptn0MembershipDelegate
    Filename:   Ptn0MembershipDelegate.hxx
    Module:     ptn0partition
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PARTITION__PTN0MEMBERSHIPDELEGATE_HXX
#define TEAMCENTER__PARTITION__PTN0MEMBERSHIPDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ptn0partition/Ptn0Membership.hxx>

#include <ptn0partition/libptn0partition_exports.h>

namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0MembershipDelegate;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0MembershipImpl;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0Membership;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0MembershipGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  PTN0PARTITION_API Teamcenter_alias::Partition::Ptn0MembershipDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Ptn0MembershipDelegate instance
    static Ptn0MembershipDelegate&  getInstance();

    //  Method to create the Ptn0MembershipImpl pointer
    static Ptn0MembershipImpl*  createImpl( Ptn0Membership&  ifObj );

    //  Method to delete the Ptn0MembershipImpl pointer
    static void deleteImpl( Ptn0MembershipImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPtn0is_partition_ownedBase(const Ptn0Membership &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPtn0partition_memberBase(const Ptn0Membership &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPtn0reference_designatorBase(const Ptn0Membership &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPtn0is_partition_ownedBase(Ptn0Membership &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPtn0partition_memberBase(Ptn0Membership &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPtn0reference_designatorBase(Ptn0Membership &ifObj,  const std::string &value, bool isNull );


    ///
    /// ptn0isOwningMembership
    /// @version Teamcenter 9
    /// @param isOwning - output parameter to indicate whether the Design Component owns membership
    /// @return - ptn0isOwningMembership
    ///
    int  ptn0isOwningMembershipBase(const Ptn0Membership &ifObj,  bool *isOwning );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Ptn0Membership &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0CreatePostBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static Ptn0MembershipDelegate*  m_pInstance;

    Ptn0MembershipDelegate();
    virtual ~Ptn0MembershipDelegate();
    static void setInstance( Ptn0MembershipDelegate*  instance );


private:
    friend class  ::Teamcenter::Partition::Ptn0MembershipGenImpl;

};

#include <ptn0partition/libptn0partition_undef.h>
#endif  //  TEAMCENTER__PARTITION__PTN0MEMBERSHIPDELEGATE_HXX
