//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ptn0MembershipLine
    Filename:   Ptn0MembershipLine.hxx
    Module:     ptn0partition
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PARTITION__PTN0MEMBERSHIPLINE__HXX
#define TEAMCENTER__PARTITION__PTN0MEMBERSHIPLINE__HXX

#include <common/tc_deprecation_macros.h>
#include <bom/Fnd0AbstractProxyLine.hxx>

#include <ptn0partition/libptn0partition_exports.h>

namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0MembershipLine;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0MembershipLineImpl;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0MembershipLineDelegate;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0MembershipLineDispatch;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0MembershipLineGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PTN0PARTITION_API  Teamcenter::Partition::Ptn0MembershipLine
     : public  ::Teamcenter::Fnd0AbstractProxyLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ptn0MembershipLine();

    /**
     * Destructor
     */
    virtual ~Ptn0MembershipLine();

private:
    //  Getter method for the Implementation Object
    Ptn0MembershipLineImpl*  getPtn0MembershipLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPtn0MembershipLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ptn0MembershipLineImpl*  m_ptn0membershiplineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ptn0MembershipLine - desc for Ptn0MembershipLine parameter
     */
    Ptn0MembershipLine( const Ptn0MembershipLine& );
    Ptn0MembershipLine& operator=( const Ptn0MembershipLine& );

    friend class  Ptn0MembershipLineDelegate;
    friend class  Ptn0MembershipLineDispatch;
    friend class  Ptn0MembershipLineGenImpl;
};

#include <ptn0partition/libptn0partition_undef.h>
#endif //   TEAMCENTER__PARTITION__PTN0MEMBERSHIPLINE__HXX
