//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ptn0MembershipLineDelegate
    Filename:   Ptn0MembershipLineDelegate.hxx
    Module:     ptn0partition
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PARTITION__PTN0MEMBERSHIPLINEDELEGATE_HXX
#define TEAMCENTER__PARTITION__PTN0MEMBERSHIPLINEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ptn0partition/Ptn0MembershipLine.hxx>

#include <ptn0partition/libptn0partition_exports.h>

namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0MembershipLineDelegate;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0MembershipLineImpl;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0MembershipLine;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0MembershipLineGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  PTN0PARTITION_API Teamcenter_alias::Partition::Ptn0MembershipLineDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Ptn0MembershipLineDelegate instance
    static Ptn0MembershipLineDelegate&  getInstance();

    //  Method to create the Ptn0MembershipLineImpl pointer
    static Ptn0MembershipLineImpl*  createImpl( Ptn0MembershipLine&  ifObj );

    //  Method to delete the Ptn0MembershipLineImpl pointer
    static void deleteImpl( Ptn0MembershipLineImpl*  impl );


    ///
    /// Expands a set of BOM Lines from the same BOM Window, each to one level. The order of the returned child BOM Lines is not guaranteed.The parameter expansionCriteria is a set of bitwise or-ed flags controlling the expansion behavior, see Expansion Criteria Flags.
    /// @version Teamcenter 12.2
    /// @param bulkInput - Bulk Input containing the input parent BOMLines that need to be expanded.
    /// @param bd - Bulk Data required for bulk processiong of the inputs.
    /// @param expansionCriteria - Contains bit flags controlling expansion behavior. Refer to the section #Expansion_Criteria.
    /// @param occurenceThreads - Occurrence thread tags used in filter by occurrence threads.
    /// @param occurenceThreadParents - BOMLine tags of parent BOMLine for each occurrence thread, used in filter by occurrence threads.
    /// @param parentLinesToChildLinesMap - Map containing keys as the parent input lines and values as their respective children.
    /// @param errorMap - Map of all the errors during the expansion of the Parent Lines.
    /// @return - 
    ///
    int  fnd0ExpandLinesBase( std::vector<  ::Teamcenter::BulkInput* > *bulkInput, ::Teamcenter::BulkData *bd, int expansionCriteria, std::vector< tag_t > *occurenceThreads, std::vector< tag_t > *occurenceThreadParents, std::map< tag_t,std::vector< tag_t > > *parentLinesToChildLinesMap,  ::Teamcenter::ErrorMap *errorMap );


    ///
    /// Generates permanent ID/recipe. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param recipe - Permanent ID/recipe
    /// @return - Failure code.
    ///
    int  fnd0GenerateRecipeBase(const Ptn0MembershipLine &ifObj,  std::string *recipe );



protected:
    //  Pointer to the instance
    static Ptn0MembershipLineDelegate*  m_pInstance;

    Ptn0MembershipLineDelegate();
    virtual ~Ptn0MembershipLineDelegate();
    static void setInstance( Ptn0MembershipLineDelegate*  instance );


private:
    friend class  ::Teamcenter::Partition::Ptn0MembershipLineGenImpl;

};

#include <ptn0partition/libptn0partition_undef.h>
#endif  //  TEAMCENTER__PARTITION__PTN0MEMBERSHIPLINEDELEGATE_HXX
