//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ptn0PSPartitionContainer
    Filename:   Ptn0PSPartitionContainer.hxx
    Module:     ptn0partition
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PARTITION__PTN0PSPARTITIONCONTAINER__HXX
#define TEAMCENTER__PARTITION__PTN0PSPARTITIONCONTAINER__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <ptn0partition/libptn0partition_exports.h>

namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PSPartitionContainer;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PSPartitionContainerImpl;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PSPartitionContainerDelegate;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PSPartitionContainerDispatch;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PSPartitionContainerGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PTN0PARTITION_API  Teamcenter::Partition::Ptn0PSPartitionContainer
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ptn0PSPartitionContainer();

    /**
     * Destructor
     */
    virtual ~Ptn0PSPartitionContainer();

private:
    //  Getter method for the Implementation Object
    Ptn0PSPartitionContainerImpl*  getPtn0PSPartitionContainerImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPtn0PSPartitionContainerImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ptn0PSPartitionContainerImpl*  m_ptn0pspartitioncontainerImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ptn0PSPartitionContainer - desc for Ptn0PSPartitionContainer parameter
     */
    Ptn0PSPartitionContainer( const Ptn0PSPartitionContainer& );
    Ptn0PSPartitionContainer& operator=( const Ptn0PSPartitionContainer& );

    friend class  Ptn0PSPartitionContainerDelegate;
    friend class  Ptn0PSPartitionContainerDispatch;
    friend class  Ptn0PSPartitionContainerGenImpl;
};

#include <ptn0partition/libptn0partition_undef.h>
#endif //   TEAMCENTER__PARTITION__PTN0PSPARTITIONCONTAINER__HXX
