//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ptn0PartitionDelegate
    Filename:   Ptn0PartitionDelegate.hxx
    Module:     ptn0partition
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PARTITION__PTN0PARTITIONDELEGATE_HXX
#define TEAMCENTER__PARTITION__PTN0PARTITIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ptn0partition/Ptn0Partition.hxx>

#include <ptn0partition/libptn0partition_exports.h>

namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionDelegate;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionImpl;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0Partition;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  PTN0PARTITION_API Teamcenter_alias::Partition::Ptn0PartitionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Ptn0PartitionDelegate instance
    static Ptn0PartitionDelegate&  getInstance();

    //  Method to create the Ptn0PartitionImpl pointer
    static Ptn0PartitionImpl*  createImpl( Ptn0Partition&  ifObj );

    //  Method to delete the Ptn0PartitionImpl pointer
    static void deleteImpl( Ptn0PartitionImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPtn0allows_add_contentBase(const Ptn0Partition &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPtn0allows_remove_contentBase(const Ptn0Partition &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10.1.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPtn0IsActiveBase(const Ptn0Partition &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getPtn0membership_objectsBase(const Ptn0Partition &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPtn0partition_idBase(const Ptn0Partition &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPtn0partition_recipeBase(const Ptn0Partition &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPtn0partition_scheme_typeBase(const Ptn0Partition &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getPtn0reference_designatorsBase(const Ptn0Partition &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPtn0scheme_objectBase(const Ptn0Partition &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPtn0source_objectBase(const Ptn0Partition &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPtn0source_partitionBase(const Ptn0Partition &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10.1.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPtn0IsActiveBase(Ptn0Partition &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a string Property; Once partition_id is set for a Partition object, it is advised not to change it. Otherwise it may lead to data consistency issues
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPtn0partition_idBase(Ptn0Partition &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPtn0partition_recipeBase(Ptn0Partition &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPtn0partition_scheme_typeBase(Ptn0Partition &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 9
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setPtn0reference_designatorsBase(Ptn0Partition &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPtn0source_objectBase(Ptn0Partition &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Get child partitions for this partition
    /// @version Teamcenter 9
    /// @param configurationContext - configuration context
    /// @param childPartitions - vector of child partitions
    /// @return - Zero if success otherwise the error code.
    ///
    int  ptn0getChildrenBase(const Ptn0Partition &ifObj,  const tag_t &configurationContext, std::vector< tag_t > &childPartitions );


    ///
    /// Get members of this partition
    /// @version Teamcenter 9
    /// @param configurationContext - configuration context
    /// @param members - vector of partition members
    /// @param contentPersistenceMode - 1-STATIC, 2-DYNAMIC, 3-return both STATIC and DYNAMIC members
    /// @return - zero if success or error code
    ///
    int  ptn0getMembersBase(const Ptn0Partition &ifObj,  const tag_t &configurationContext, std::vector< tag_t > &members, const int contentPersistenceMode );


    ///
    /// Get parent partitions for this partition
    /// @version Teamcenter 9
    /// @param configurationContext - configuration context
    /// @param parentPartitions - Vector of parent partitions
    /// @return - zero if success or error code
    ///
    int  ptn0getParentsBase(const Ptn0Partition &ifObj,  const tag_t &configurationContext, std::vector< tag_t > &parentPartitions );


    ///
    /// (re)generates static memberships for dynamic members of this partition
    /// @version Teamcenter 9
    /// @param configurationContext - Input configuration context
    /// @return - zero if success or error code
    ///
    int  ptn0persistDynamicMembersBase(const Ptn0Partition &ifObj,  const tag_t &configurationContext );


    ///
    /// Update children of Source and Target parent partition for MOVE / REPLACE operation code.
    /// @version Teamcenter 10.1.3
    /// @param children - vector of child partition tags for operation specified in actionCode
    /// @param actionCode - 0-MOVE_REPARENTING_PARTITION, 1-REPLACE_REPARENTING_PARTITION
    /// @param targetParent - Target parent partition used for operation specified in actionCode
    /// @param failedChildren - Vector of children failed while executing operation specified in actionCode
    /// @param errorCodes - Vector of error codes corresponding to failed children
    /// @param errorMessages - Vector of error messages corresponding to failed children
    /// @return - zero if success or error code.
    ///
    int  ptn0reparentPartitionBase(const Ptn0Partition &ifObj,  const std::vector< tag_t > &children, const int actionCode, const tag_t targetParent, std::vector< tag_t > &failedChildren, std::vector< int > &errorCodes, std::vector< std::string > &errorMessages );


    ///
    /// updates children of this partition according to action code ( ADD, REPLACE, REMOVE )
    /// @version Teamcenter 9
    /// @param children - vector of child tags
    /// @param actionCode - 0-ADD, 1-REPLACE, 2-REMOVE
    /// @param failedChildren - Vector of children failed to add, replace or remove
    /// @return - zero if success or error code
    ///
    int  ptn0updateChildrenBase(const Ptn0Partition &ifObj,  const std::vector< tag_t > &children, const int actionCode, std::vector< tag_t > &failedChildren );


    ///
    /// Modify members of this partition
    /// @version Teamcenter 9
    /// @param members - vector of members to add,replace or remove t/from this partition
    /// @param actionCode - 1-ADD, 2- REPLACE, 3-REMOVE
    /// @param contentPersistenceMode - 1- STATIC; 2 - DYNAMIC
    /// @param configurationContext - Input configuration context for dynamic members update
    /// @param failedMembers - Vector of members failed to update on a target partition
    /// @param errorCode - Vector of error codes corresponding to failed members
    /// @return - zero if success or error code
    ///
    int  ptn0updateMembersBase(const Ptn0Partition &ifObj,  const std::vector< tag_t > &members, const int actionCode, const int contentPersistenceMode, const tag_t &configurationContext, std::vector< tag_t > &failedMembers, std::vector< int > &errorCode );


    ///
    /// Update parents of this partition per action code: add,replace or remove
    /// @version Teamcenter 9
    /// @param parents - vector of parent tags to update
    /// @param actionCode - 0-ADD, 1-REPLACE, 2-REMOVE
    /// @param failedParents - Vector of parents failed to add, remove or replace
    /// @return - zero for success or error code
    ///
    int  ptn0updateParentsBase(const Ptn0Partition &ifObj,  const std::vector< tag_t > &parents, const int actionCode, std::vector< tag_t > &failedParents );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Ptn0Partition &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Finalize operation input.
    /// @version Teamcenter 10.1
    /// @param pReviseInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns n int.
    ///
    int  finalizeReviseInputBase(const Ptn0Partition &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// finalize operation input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  finalizeSaveAsInputBase(const Ptn0Partition &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be created
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0FinalizeCreateInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.3
    /// @param inputs - A vector of data that contains reference information to the objects to be revised
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0FinalizeReviseInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.3
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0FinalizeSaveAsInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.3
    /// @param inputs - A vector of data that contains reference information to the objects to be revised
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0RevisePostBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be created
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0ValidateCreateInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.3
    /// @param inputs - A vector of data that contains reference information to the objects to be revised
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0ValidateReviseInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.3
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0ValidateSaveAsInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// similar to finalizeSaveAsInputBase, this method allows for final changes to the revise descriptor before actually performing the revise
    /// @version Teamcenter 9
    /// @param pSavAsInput - saveAs input
    /// @param vecDeepCopyData - vector of deep copy data for revise
    /// @deprecated #Teamcenter::AppModel::Mdl0ConditionalElement::mdl0finalizeReviseInput deprecated in Teamcenter 11.2
    /// @return - SaveAsInput is updated
    ///
    TC_DEPRECATED_WITH_DEPRECATION_INFO("Teamcenter 11.2","Teamcenter::AppModel::Mdl0ConditionalElement::mdl0finalizeReviseInput","This operation is deprecated in Teamcenter 11.2 and will be removed in Teamcenter 13. Please use finalizeReviseInput operation instead.")
    int  mdl0finalizeReviseInputBase(const Ptn0Partition &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// major revise in CPD
    /// @version Teamcenter 9
    /// @param pReviseInput - saveAs descriptor
    /// @param vecDeepCopyData - list of deep copy datas
    /// @param newObjTag - resulting tag of revised object
    /// @deprecated #Teamcenter::AppModel::Mdl0ConditionalElement::mdl0Revise deprecated in Teamcenter 11.2
    /// @return - returns status
    ///
    TC_DEPRECATED_WITH_DEPRECATION_INFO("Teamcenter 11.2","Teamcenter::AppModel::Mdl0ConditionalElement::mdl0Revise","This operation is deprecated in Teamcenter 11.2 and will be removed in Teamcenter 13. Please use revise operation instead.")
    int  mdl0ReviseBase(const Ptn0Partition &ifObj,  ::Teamcenter::SaveAsInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData, tag_t *newObjTag );


    ///
    /// post for major revise in CPD
    /// @version Teamcenter 9
    /// @param pReviseInput - saveAs descriptor
    /// @param vecDeepCopyData - list of deep copy datas
    /// @deprecated #Teamcenter::AppModel::Mdl0ConditionalElement::mdl0RevisePost deprecated in Teamcenter 11.2
    /// @return - returns status
    ///
    TC_DEPRECATED_WITH_DEPRECATION_INFO("Teamcenter 11.2","Teamcenter::AppModel::Mdl0ConditionalElement::mdl0RevisePost","This operation is deprecated in Teamcenter 11.2 and will be removed in Teamcenter 13. Please use revisePost operation instead.")
    int  mdl0RevisePostBase(const Ptn0Partition &ifObj,  ::Teamcenter::SaveAsInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// Generic revisePost operation.
    /// @version Teamcenter 10.1
    /// @param pReviseInput - Input ReviseInput object.
    /// @param vecDeepCopyData - Vector of deep copy data.
    /// @return - Returns an integer value.
    ///
    int  revisePostBase(const Ptn0Partition &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Ptn0Partition &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Validate revise input.
    /// @version Teamcenter 10.1
    /// @param pReviseInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - Returns an int.
    ///
    int  validateReviseInputBase(const Ptn0Partition &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// validate saveas input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  validateSaveAsInputBase(const Ptn0Partition &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static Ptn0PartitionDelegate*  m_pInstance;

    Ptn0PartitionDelegate();
    virtual ~Ptn0PartitionDelegate();
    static void setInstance( Ptn0PartitionDelegate*  instance );


private:
    friend class  ::Teamcenter::Partition::Ptn0PartitionGenImpl;

};

#include <ptn0partition/libptn0partition_undef.h>
#endif  //  TEAMCENTER__PARTITION__PTN0PARTITIONDELEGATE_HXX
