//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ptn0PartitionItem
    Filename:   Ptn0PartitionItem.hxx
    Module:     ptn0partition
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PARTITION__PTN0PARTITIONITEM__HXX
#define TEAMCENTER__PARTITION__PTN0PARTITIONITEM__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <ptn0partition/libptn0partition_exports.h>

namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionItem;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionItemImpl;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionItemDelegate;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionItemDispatch;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionItemGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PTN0PARTITION_API  Teamcenter::Partition::Ptn0PartitionItem
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ptn0PartitionItem();

    /**
     * Destructor
     */
    virtual ~Ptn0PartitionItem();

private:
    //  Getter method for the Implementation Object
    Ptn0PartitionItemImpl*  getPtn0PartitionItemImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPtn0PartitionItemImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ptn0PartitionItemImpl*  m_ptn0partitionitemImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ptn0PartitionItem - desc for Ptn0PartitionItem parameter
     */
    Ptn0PartitionItem( const Ptn0PartitionItem& );
    Ptn0PartitionItem& operator=( const Ptn0PartitionItem& );

    friend class  Ptn0PartitionItemDelegate;
    friend class  Ptn0PartitionItemDispatch;
    friend class  Ptn0PartitionItemGenImpl;
};

#include <ptn0partition/libptn0partition_undef.h>
#endif //   TEAMCENTER__PARTITION__PTN0PARTITIONITEM__HXX
