//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ptn0PartitionLine
    Filename:   Ptn0PartitionLine.hxx
    Module:     ptn0partition
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PARTITION__PTN0PARTITIONLINE__HXX
#define TEAMCENTER__PARTITION__PTN0PARTITIONLINE__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <bom/BOMLine.hxx>

#include <ptn0partition/libptn0partition_exports.h>

namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionLine;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionLineImpl;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionLineDelegate;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionLineDispatch;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionLineGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PTN0PARTITION_API  Teamcenter::Partition::Ptn0PartitionLine
     : public  ::Teamcenter::BOMLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 13.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPtn0ChildPartitionCount( int &value, bool &isNull ) const;

    ///
    /// Returns the BOMLines that are members of the Partition.
    /// @version Teamcenter 13.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getPtn0Members( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ptn0PartitionLine();

    /**
     * Destructor
     */
    virtual ~Ptn0PartitionLine();

private:
    //  Getter method for the Implementation Object
    Ptn0PartitionLineImpl*  getPtn0PartitionLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPtn0PartitionLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ptn0PartitionLineImpl*  m_ptn0partitionlineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ptn0PartitionLine - desc for Ptn0PartitionLine parameter
     */
    Ptn0PartitionLine( const Ptn0PartitionLine& );
    Ptn0PartitionLine& operator=( const Ptn0PartitionLine& );

    friend class  Ptn0PartitionLineDelegate;
    friend class  Ptn0PartitionLineDispatch;
    friend class  Ptn0PartitionLineGenImpl;
};

#include <ptn0partition/libptn0partition_undef.h>
#endif //   TEAMCENTER__PARTITION__PTN0PARTITIONLINE__HXX
