//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ptn0PartitionMapping
    Filename:   Ptn0PartitionMapping.hxx
    Module:     ptn0partition
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PARTITION__PTN0PARTITIONMAPPING__HXX
#define TEAMCENTER__PARTITION__PTN0PARTITIONMAPPING__HXX

#include <common/tc_deprecation_macros.h>
#include <ptn0partition/Ptn0PartitionLink.hxx>

#include <ptn0partition/libptn0partition_exports.h>

namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionMapping;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionMappingImpl;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionMappingDelegate;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionMappingDispatch;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionMappingGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PTN0PARTITION_API  Teamcenter::Partition::Ptn0PartitionMapping
     : public  ::Teamcenter::Partition::Ptn0PartitionLink
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ptn0PartitionMapping();

    /**
     * Destructor
     */
    virtual ~Ptn0PartitionMapping();

private:
    //  Getter method for the Implementation Object
    Ptn0PartitionMappingImpl*  getPtn0PartitionMappingImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPtn0PartitionMappingImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ptn0PartitionMappingImpl*  m_ptn0partitionmappingImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ptn0PartitionMapping - desc for Ptn0PartitionMapping parameter
     */
    Ptn0PartitionMapping( const Ptn0PartitionMapping& );
    Ptn0PartitionMapping& operator=( const Ptn0PartitionMapping& );

    friend class  Ptn0PartitionMappingDelegate;
    friend class  Ptn0PartitionMappingDispatch;
    friend class  Ptn0PartitionMappingGenImpl;
};

#include <ptn0partition/libptn0partition_undef.h>
#endif //   TEAMCENTER__PARTITION__PTN0PARTITIONMAPPING__HXX
