//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ptn0PartitionMappingDelegate
    Filename:   Ptn0PartitionMappingDelegate.hxx
    Module:     ptn0partition
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PARTITION__PTN0PARTITIONMAPPINGDELEGATE_HXX
#define TEAMCENTER__PARTITION__PTN0PARTITIONMAPPINGDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ptn0partition/Ptn0PartitionMapping.hxx>

#include <ptn0partition/libptn0partition_exports.h>

namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionMappingDelegate;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionMappingImpl;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionMapping;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionMappingGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  PTN0PARTITION_API Teamcenter_alias::Partition::Ptn0PartitionMappingDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Ptn0PartitionMappingDelegate instance
    static Ptn0PartitionMappingDelegate&  getInstance();

    //  Method to create the Ptn0PartitionMappingImpl pointer
    static Ptn0PartitionMappingImpl*  createImpl( Ptn0PartitionMapping&  ifObj );

    //  Method to delete the Ptn0PartitionMappingImpl pointer
    static void deleteImpl( Ptn0PartitionMappingImpl*  impl );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Ptn0PartitionMapping &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Ptn0PartitionMappingDelegate*  m_pInstance;

    Ptn0PartitionMappingDelegate();
    virtual ~Ptn0PartitionMappingDelegate();
    static void setInstance( Ptn0PartitionMappingDelegate*  instance );


private:
    friend class  ::Teamcenter::Partition::Ptn0PartitionMappingGenImpl;

};

#include <ptn0partition/libptn0partition_undef.h>
#endif  //  TEAMCENTER__PARTITION__PTN0PARTITIONMAPPINGDELEGATE_HXX
