//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ptn0PartitionRealization
    Filename:   Ptn0PartitionRealization.hxx
    Module:     ptn0partition
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PARTITION__PTN0PARTITIONREALIZATION__HXX
#define TEAMCENTER__PARTITION__PTN0PARTITIONREALIZATION__HXX

#include <common/tc_deprecation_macros.h>
#include <rlz0realization/Rlz0ModelRealization.hxx>

#include <ptn0partition/libptn0partition_exports.h>

namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionRealization;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionRealizationImpl;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionRealizationDelegate;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionRealizationDispatch;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionRealizationGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PTN0PARTITION_API  Teamcenter::Partition::Ptn0PartitionRealization
     : public  ::Teamcenter::Realization::Rlz0ModelRealization
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ptn0PartitionRealization();

    /**
     * Destructor
     */
    virtual ~Ptn0PartitionRealization();

private:
    //  Getter method for the Implementation Object
    Ptn0PartitionRealizationImpl*  getPtn0PartitionRealizationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPtn0PartitionRealizationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ptn0PartitionRealizationImpl*  m_ptn0partitionrealizationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ptn0PartitionRealization - desc for Ptn0PartitionRealization parameter
     */
    Ptn0PartitionRealization( const Ptn0PartitionRealization& );
    Ptn0PartitionRealization& operator=( const Ptn0PartitionRealization& );

    friend class  Ptn0PartitionRealizationDelegate;
    friend class  Ptn0PartitionRealizationDispatch;
    friend class  Ptn0PartitionRealizationGenImpl;
};

#include <ptn0partition/libptn0partition_undef.h>
#endif //   TEAMCENTER__PARTITION__PTN0PARTITIONREALIZATION__HXX
