//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ptn0PartitionScheme
    Filename:   Ptn0PartitionScheme.hxx
    Module:     ptn0partition
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PARTITION__PTN0PARTITIONSCHEME__HXX
#define TEAMCENTER__PARTITION__PTN0PARTITIONSCHEME__HXX

#include <unidefs.h>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0ModelElement.hxx>

#include <ptn0partition/libptn0partition_exports.h>

namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionScheme;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionSchemeImpl;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionSchemeDelegate;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionSchemeDispatch;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionSchemeGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PTN0PARTITION_API  Teamcenter::Partition::Ptn0PartitionScheme
     : public  ::Teamcenter::AppModel::Mdl0ModelElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPtn0allows_add_content( bool &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getPtn0supported_partn_types( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setPtn0supported_partn_types( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );

    ///
    /// Get top level partitions under this scheme
    /// @version Teamcenter 9
    /// @param configurationContext - configuration context
    /// @param partitions - returns partitions without parent partitions
    /// @return - zero if success or error code
    ///
    int  ptn0getTopLevelPartitions( const tag_t &configurationContext, std::vector< tag_t > &partitions );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ptn0PartitionScheme();

    /**
     * Destructor
     */
    virtual ~Ptn0PartitionScheme();

private:
    //  Getter method for the Implementation Object
    Ptn0PartitionSchemeImpl*  getPtn0PartitionSchemeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPtn0PartitionSchemeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ptn0PartitionSchemeImpl*  m_ptn0partitionschemeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ptn0PartitionScheme - desc for Ptn0PartitionScheme parameter
     */
    Ptn0PartitionScheme( const Ptn0PartitionScheme& );
    Ptn0PartitionScheme& operator=( const Ptn0PartitionScheme& );

    friend class  Ptn0PartitionSchemeDelegate;
    friend class  Ptn0PartitionSchemeDispatch;
    friend class  Ptn0PartitionSchemeGenImpl;
};

#include <ptn0partition/libptn0partition_undef.h>
#endif //   TEAMCENTER__PARTITION__PTN0PARTITIONSCHEME__HXX
