//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ptn0PartitionSchemeDelegate
    Filename:   Ptn0PartitionSchemeDelegate.hxx
    Module:     ptn0partition
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PARTITION__PTN0PARTITIONSCHEMEDELEGATE_HXX
#define TEAMCENTER__PARTITION__PTN0PARTITIONSCHEMEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ptn0partition/Ptn0PartitionScheme.hxx>

#include <ptn0partition/libptn0partition_exports.h>

namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionSchemeDelegate;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionSchemeImpl;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionScheme;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionSchemeGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  PTN0PARTITION_API Teamcenter_alias::Partition::Ptn0PartitionSchemeDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Ptn0PartitionSchemeDelegate instance
    static Ptn0PartitionSchemeDelegate&  getInstance();

    //  Method to create the Ptn0PartitionSchemeImpl pointer
    static Ptn0PartitionSchemeImpl*  createImpl( Ptn0PartitionScheme&  ifObj );

    //  Method to delete the Ptn0PartitionSchemeImpl pointer
    static void deleteImpl( Ptn0PartitionSchemeImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPtn0allows_add_contentBase(const Ptn0PartitionScheme &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getPtn0supported_partn_typesBase(const Ptn0PartitionScheme &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setPtn0supported_partn_typesBase(Ptn0PartitionScheme &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Get top level partitions under this scheme
    /// @version Teamcenter 9
    /// @param configurationContext - configuration context
    /// @param partitions - returns partitions without parent partitions
    /// @return - zero if success or error code
    ///
    int  ptn0getTopLevelPartitionsBase(const Ptn0PartitionScheme &ifObj,  const tag_t &configurationContext, std::vector< tag_t > &partitions );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Ptn0PartitionScheme &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be created
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0FinalizeCreateInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be created
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0ValidateCreateInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Ptn0PartitionScheme &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Ptn0PartitionSchemeDelegate*  m_pInstance;

    Ptn0PartitionSchemeDelegate();
    virtual ~Ptn0PartitionSchemeDelegate();
    static void setInstance( Ptn0PartitionSchemeDelegate*  instance );


private:
    friend class  ::Teamcenter::Partition::Ptn0PartitionSchemeGenImpl;

};

#include <ptn0partition/libptn0partition_undef.h>
#endif  //  TEAMCENTER__PARTITION__PTN0PARTITIONSCHEMEDELEGATE_HXX
