//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ptn0PartitionSchemeLine
    Filename:   Ptn0PartitionSchemeLine.hxx
    Module:     ptn0partition
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PARTITION__PTN0PARTITIONSCHEMELINE__HXX
#define TEAMCENTER__PARTITION__PTN0PARTITIONSCHEMELINE__HXX

#include <common/tc_deprecation_macros.h>
#include <bom/Fnd0AbstractProxyLine.hxx>

#include <ptn0partition/libptn0partition_exports.h>

namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionSchemeLine;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionSchemeLineImpl;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionSchemeLineDelegate;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionSchemeLineDispatch;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionSchemeLineGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PTN0PARTITION_API  Teamcenter::Partition::Ptn0PartitionSchemeLine
     : public  ::Teamcenter::Fnd0AbstractProxyLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ptn0PartitionSchemeLine();

    /**
     * Destructor
     */
    virtual ~Ptn0PartitionSchemeLine();

private:
    //  Getter method for the Implementation Object
    Ptn0PartitionSchemeLineImpl*  getPtn0PartitionSchemeLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPtn0PartitionSchemeLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ptn0PartitionSchemeLineImpl*  m_ptn0partitionschemelineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ptn0PartitionSchemeLine - desc for Ptn0PartitionSchemeLine parameter
     */
    Ptn0PartitionSchemeLine( const Ptn0PartitionSchemeLine& );
    Ptn0PartitionSchemeLine& operator=( const Ptn0PartitionSchemeLine& );

    friend class  Ptn0PartitionSchemeLineDelegate;
    friend class  Ptn0PartitionSchemeLineDispatch;
    friend class  Ptn0PartitionSchemeLineGenImpl;
};

#include <ptn0partition/libptn0partition_undef.h>
#endif //   TEAMCENTER__PARTITION__PTN0PARTITIONSCHEMELINE__HXX
