//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ptn0ProductArchModel
    Filename:   Ptn0ProductArchModel.hxx
    Module:     ptn0partition
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PARTITION__PTN0PRODUCTARCHMODEL__HXX
#define TEAMCENTER__PARTITION__PTN0PRODUCTARCHMODEL__HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0ApplicationModel.hxx>

#include <ptn0partition/libptn0partition_exports.h>

namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0ProductArchModel;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0ProductArchModelImpl;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0ProductArchModelDelegate;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0ProductArchModelDispatch;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0ProductArchModelGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PTN0PARTITION_API  Teamcenter::Partition::Ptn0ProductArchModel
     : public  ::Teamcenter::AppModel::Mdl0ApplicationModel
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ptn0ProductArchModel();

    /**
     * Destructor
     */
    virtual ~Ptn0ProductArchModel();

private:
    //  Getter method for the Implementation Object
    Ptn0ProductArchModelImpl*  getPtn0ProductArchModelImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPtn0ProductArchModelImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ptn0ProductArchModelImpl*  m_ptn0productarchmodelImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ptn0ProductArchModel - desc for Ptn0ProductArchModel parameter
     */
    Ptn0ProductArchModel( const Ptn0ProductArchModel& );
    Ptn0ProductArchModel& operator=( const Ptn0ProductArchModel& );

    friend class  Ptn0ProductArchModelDelegate;
    friend class  Ptn0ProductArchModelDispatch;
    friend class  Ptn0ProductArchModelGenImpl;
};

#include <ptn0partition/libptn0partition_undef.h>
#endif //   TEAMCENTER__PARTITION__PTN0PRODUCTARCHMODEL__HXX
