//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ptn0ProductArchModelDelegate
    Filename:   Ptn0ProductArchModelDelegate.hxx
    Module:     ptn0partition
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PARTITION__PTN0PRODUCTARCHMODELDELEGATE_HXX
#define TEAMCENTER__PARTITION__PTN0PRODUCTARCHMODELDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ptn0partition/Ptn0ProductArchModel.hxx>

#include <ptn0partition/libptn0partition_exports.h>

namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0ProductArchModelDelegate;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0ProductArchModelImpl;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0ProductArchModel;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0ProductArchModelGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  PTN0PARTITION_API Teamcenter_alias::Partition::Ptn0ProductArchModelDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Ptn0ProductArchModelDelegate instance
    static Ptn0ProductArchModelDelegate&  getInstance();

    //  Method to create the Ptn0ProductArchModelImpl pointer
    static Ptn0ProductArchModelImpl*  createImpl( Ptn0ProductArchModel&  ifObj );

    //  Method to delete the Ptn0ProductArchModelImpl pointer
    static void deleteImpl( Ptn0ProductArchModelImpl*  impl );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Ptn0ProductArchModel &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// finalize operation input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  finalizeSaveAsInputBase(const Ptn0ProductArchModel &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.3
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0FinalizeSaveAsInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static Ptn0ProductArchModelDelegate*  m_pInstance;

    Ptn0ProductArchModelDelegate();
    virtual ~Ptn0ProductArchModelDelegate();
    static void setInstance( Ptn0ProductArchModelDelegate*  instance );


private:
    friend class  ::Teamcenter::Partition::Ptn0ProductArchModelGenImpl;

};

#include <ptn0partition/libptn0partition_undef.h>
#endif  //  TEAMCENTER__PARTITION__PTN0PRODUCTARCHMODELDELEGATE_HXX
