//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ptn0SearchPartition
    Filename:   Ptn0SearchPartition.hxx
    Module:     ptn0partition
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PARTITION__PTN0SEARCHPARTITION__HXX
#define TEAMCENTER__PARTITION__PTN0SEARCHPARTITION__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0SearchDef.hxx>

#include <ptn0partition/libptn0partition_exports.h>

namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0SearchPartition;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0SearchPartitionImpl;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0SearchPartitionDelegate;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0SearchPartitionDispatch;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0SearchPartitionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PTN0PARTITION_API  Teamcenter::Partition::Ptn0SearchPartition
     : public  ::Teamcenter::AppModel::Mdl0SearchDef
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPtn0partition_obj_criteria( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPtn0partition_rev_criteria( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPtn0traverse_children( bool &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPtn0partition_obj_criteria( const tag_t &value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPtn0partition_rev_criteria( const tag_t &value, bool isNull=false );

    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPtn0traverse_children( bool value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ptn0SearchPartition();

    /**
     * Destructor
     */
    virtual ~Ptn0SearchPartition();

private:
    //  Getter method for the Implementation Object
    Ptn0SearchPartitionImpl*  getPtn0SearchPartitionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPtn0SearchPartitionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ptn0SearchPartitionImpl*  m_ptn0searchpartitionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ptn0SearchPartition - desc for Ptn0SearchPartition parameter
     */
    Ptn0SearchPartition( const Ptn0SearchPartition& );
    Ptn0SearchPartition& operator=( const Ptn0SearchPartition& );

    friend class  Ptn0SearchPartitionDelegate;
    friend class  Ptn0SearchPartitionDispatch;
    friend class  Ptn0SearchPartitionGenImpl;
};

#include <ptn0partition/libptn0partition_undef.h>
#endif //   TEAMCENTER__PARTITION__PTN0SEARCHPARTITION__HXX
