//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ptn0SearchPartitionDelegate
    Filename:   Ptn0SearchPartitionDelegate.hxx
    Module:     ptn0partition
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PARTITION__PTN0SEARCHPARTITIONDELEGATE_HXX
#define TEAMCENTER__PARTITION__PTN0SEARCHPARTITIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ptn0partition/Ptn0SearchPartition.hxx>

#include <ptn0partition/libptn0partition_exports.h>

namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0SearchPartitionDelegate;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0SearchPartitionImpl;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0SearchPartition;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0SearchPartitionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  PTN0PARTITION_API Teamcenter_alias::Partition::Ptn0SearchPartitionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Ptn0SearchPartitionDelegate instance
    static Ptn0SearchPartitionDelegate&  getInstance();

    //  Method to create the Ptn0SearchPartitionImpl pointer
    static Ptn0SearchPartitionImpl*  createImpl( Ptn0SearchPartition&  ifObj );

    //  Method to delete the Ptn0SearchPartitionImpl pointer
    static void deleteImpl( Ptn0SearchPartitionImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPtn0partition_obj_criteriaBase(const Ptn0SearchPartition &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPtn0partition_rev_criteriaBase(const Ptn0SearchPartition &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPtn0traverse_childrenBase(const Ptn0SearchPartition &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPtn0partition_obj_criteriaBase(Ptn0SearchPartition &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPtn0partition_rev_criteriaBase(Ptn0SearchPartition &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPtn0traverse_childrenBase(Ptn0SearchPartition &ifObj,  bool value, bool isNull );


    ///
    /// Generates permanent ID/recipe. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param recipe - Permanent ID/recipe
    /// @return - Failure code.
    ///
    int  fnd0GenerateRecipeBase(const Ptn0SearchPartition &ifObj,  std::string *recipe );



protected:
    //  Pointer to the instance
    static Ptn0SearchPartitionDelegate*  m_pInstance;

    Ptn0SearchPartitionDelegate();
    virtual ~Ptn0SearchPartitionDelegate();
    static void setInstance( Ptn0SearchPartitionDelegate*  instance );


private:
    friend class  ::Teamcenter::Partition::Ptn0SearchPartitionGenImpl;

};

#include <ptn0partition/libptn0partition_undef.h>
#endif  //  TEAMCENTER__PARTITION__PTN0SEARCHPARTITIONDELEGATE_HXX
