//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ptn0SearchUnassigned
    Filename:   Ptn0SearchUnassigned.hxx
    Module:     ptn0partition
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PARTITION__PTN0SEARCHUNASSIGNED__HXX
#define TEAMCENTER__PARTITION__PTN0SEARCHUNASSIGNED__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0SearchDef.hxx>

#include <ptn0partition/libptn0partition_exports.h>

namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0SearchUnassigned;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0SearchUnassignedImpl;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0SearchUnassignedDelegate;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0SearchUnassignedDispatch;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0SearchUnassignedGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PTN0PARTITION_API  Teamcenter::Partition::Ptn0SearchUnassigned
     : public  ::Teamcenter::AppModel::Mdl0SearchDef
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getPtn0PartitionSchemeNames( std::vector< std::string > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 9
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setPtn0PartitionSchemeNames( const std::vector< std::string > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ptn0SearchUnassigned();

    /**
     * Destructor
     */
    virtual ~Ptn0SearchUnassigned();

private:
    //  Getter method for the Implementation Object
    Ptn0SearchUnassignedImpl*  getPtn0SearchUnassignedImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPtn0SearchUnassignedImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ptn0SearchUnassignedImpl*  m_ptn0searchunassignedImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ptn0SearchUnassigned - desc for Ptn0SearchUnassigned parameter
     */
    Ptn0SearchUnassigned( const Ptn0SearchUnassigned& );
    Ptn0SearchUnassigned& operator=( const Ptn0SearchUnassigned& );

    friend class  Ptn0SearchUnassignedDelegate;
    friend class  Ptn0SearchUnassignedDispatch;
    friend class  Ptn0SearchUnassignedGenImpl;
};

#include <ptn0partition/libptn0partition_undef.h>
#endif //   TEAMCENTER__PARTITION__PTN0SEARCHUNASSIGNED__HXX
