//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ptn0SearchUnassignedDelegate
    Filename:   Ptn0SearchUnassignedDelegate.hxx
    Module:     ptn0partition
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PARTITION__PTN0SEARCHUNASSIGNEDDELEGATE_HXX
#define TEAMCENTER__PARTITION__PTN0SEARCHUNASSIGNEDDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ptn0partition/Ptn0SearchUnassigned.hxx>

#include <ptn0partition/libptn0partition_exports.h>

namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0SearchUnassignedDelegate;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0SearchUnassignedImpl;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0SearchUnassigned;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0SearchUnassignedGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  PTN0PARTITION_API Teamcenter_alias::Partition::Ptn0SearchUnassignedDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Ptn0SearchUnassignedDelegate instance
    static Ptn0SearchUnassignedDelegate&  getInstance();

    //  Method to create the Ptn0SearchUnassignedImpl pointer
    static Ptn0SearchUnassignedImpl*  createImpl( Ptn0SearchUnassigned&  ifObj );

    //  Method to delete the Ptn0SearchUnassignedImpl pointer
    static void deleteImpl( Ptn0SearchUnassignedImpl*  impl );


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getPtn0PartitionSchemeNamesBase(const Ptn0SearchUnassigned &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 9
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setPtn0PartitionSchemeNamesBase(Ptn0SearchUnassigned &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// Generates permanent ID/recipe. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param recipe - Permanent ID/recipe
    /// @return - Failure code.
    ///
    int  fnd0GenerateRecipeBase(const Ptn0SearchUnassigned &ifObj,  std::string *recipe );



protected:
    //  Pointer to the instance
    static Ptn0SearchUnassignedDelegate*  m_pInstance;

    Ptn0SearchUnassignedDelegate();
    virtual ~Ptn0SearchUnassignedDelegate();
    static void setInstance( Ptn0SearchUnassignedDelegate*  instance );


private:
    friend class  ::Teamcenter::Partition::Ptn0SearchUnassignedGenImpl;

};

#include <ptn0partition/libptn0partition_undef.h>
#endif  //  TEAMCENTER__PARTITION__PTN0SEARCHUNASSIGNEDDELEGATE_HXX
