//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ptn0SubsetDefaultsDelegate
    Filename:   Ptn0SubsetDefaultsDelegate.hxx
    Module:     ptn0partition
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PARTITION__PTN0SUBSETDEFAULTSDELEGATE_HXX
#define TEAMCENTER__PARTITION__PTN0SUBSETDEFAULTSDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ptn0partition/Ptn0SubsetDefaults.hxx>

#include <ptn0partition/libptn0partition_exports.h>

namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0SubsetDefaultsDelegate;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0SubsetDefaultsImpl;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0SubsetDefaults;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0SubsetDefaultsGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  PTN0PARTITION_API Teamcenter_alias::Partition::Ptn0SubsetDefaultsDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Ptn0SubsetDefaultsDelegate instance
    static Ptn0SubsetDefaultsDelegate&  getInstance();

    //  Method to create the Ptn0SubsetDefaultsImpl pointer
    static Ptn0SubsetDefaultsImpl*  createImpl( Ptn0SubsetDefaults&  ifObj );

    //  Method to delete the Ptn0SubsetDefaultsImpl pointer
    static void deleteImpl( Ptn0SubsetDefaultsImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getPtn0partition_definitionsBase(const Ptn0SubsetDefaults &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getPtn0partition_idsBase(const Ptn0SubsetDefaults &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getPtn0partition_scheme_typesBase(const Ptn0SubsetDefaults &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getPtn0tgt_partitionsBase(const Ptn0SubsetDefaults &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPtn0viewed_partition_schemeBase(const Ptn0SubsetDefaults &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPtn0viewed_ptn_scheme_typeBase(const Ptn0SubsetDefaults &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setPtn0partition_definitionsBase(Ptn0SubsetDefaults &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 9
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setPtn0partition_idsBase(Ptn0SubsetDefaults &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setPtn0partition_scheme_typesBase(Ptn0SubsetDefaults &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setPtn0tgt_partitionsBase(Ptn0SubsetDefaults &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPtn0viewed_partition_schemeBase(Ptn0SubsetDefaults &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPtn0viewed_ptn_scheme_typeBase(Ptn0SubsetDefaults &ifObj,  const tag_t &value, bool isNull );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Ptn0SubsetDefaults &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Ptn0SubsetDefaultsDelegate*  m_pInstance;

    Ptn0SubsetDefaultsDelegate();
    virtual ~Ptn0SubsetDefaultsDelegate();
    static void setInstance( Ptn0SubsetDefaultsDelegate*  instance );


private:
    friend class  ::Teamcenter::Partition::Ptn0SubsetDefaultsGenImpl;

};

#include <ptn0partition/libptn0partition_undef.h>
#endif  //  TEAMCENTER__PARTITION__PTN0SUBSETDEFAULTSDELEGATE_HXX
