//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ptn0PartitionTemplateModel
    Filename:   Ptn0PartitionTemplateModel.hxx
    Module:     ptn0partitiontemplate
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PARTITION__PTN0PARTITIONTEMPLATEMODEL__HXX
#define TEAMCENTER__PARTITION__PTN0PARTITIONTEMPLATEMODEL__HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0ApplicationModel.hxx>

#include <ptn0partitiontemplate/libptn0partitiontemplate_exports.h>

namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionTemplateModel;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionTemplateModelImpl;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionTemplateModelDelegate;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionTemplateModelDispatch;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionTemplateModelGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PTN0PARTITIONTEMPLATE_API  Teamcenter::Partition::Ptn0PartitionTemplateModel
     : public  ::Teamcenter::AppModel::Mdl0ApplicationModel
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Ptn0PartitionTemplateModel();

    /**
     * Destructor
     */
    virtual ~Ptn0PartitionTemplateModel();

private:
    //  Getter method for the Implementation Object
    Ptn0PartitionTemplateModelImpl*  getPtn0PartitionTemplateModelImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPtn0PartitionTemplateModelImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Ptn0PartitionTemplateModelImpl*  m_ptn0partitiontemplatemodelImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Ptn0PartitionTemplateModel - desc for Ptn0PartitionTemplateModel parameter
     */
    Ptn0PartitionTemplateModel( const Ptn0PartitionTemplateModel& );
    Ptn0PartitionTemplateModel& operator=( const Ptn0PartitionTemplateModel& );

    friend class  Ptn0PartitionTemplateModelDelegate;
    friend class  Ptn0PartitionTemplateModelDispatch;
    friend class  Ptn0PartitionTemplateModelGenImpl;
};

#include <ptn0partitiontemplate/libptn0partitiontemplate_undef.h>
#endif //   TEAMCENTER__PARTITION__PTN0PARTITIONTEMPLATEMODEL__HXX
