//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Ptn0PartitionTemplateModelDelegate
    Filename:   Ptn0PartitionTemplateModelDelegate.hxx
    Module:     ptn0partitiontemplate
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PARTITION__PTN0PARTITIONTEMPLATEMODELDELEGATE_HXX
#define TEAMCENTER__PARTITION__PTN0PARTITIONTEMPLATEMODELDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <ptn0partitiontemplate/Ptn0PartitionTemplateModel.hxx>

#include <ptn0partitiontemplate/libptn0partitiontemplate_exports.h>

namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionTemplateModelDelegate;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionTemplateModelImpl;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionTemplateModel;
    }
}
namespace Teamcenter
{
    namespace Partition
    {
        class Ptn0PartitionTemplateModelGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  PTN0PARTITIONTEMPLATE_API Teamcenter_alias::Partition::Ptn0PartitionTemplateModelDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Ptn0PartitionTemplateModelDelegate instance
    static Ptn0PartitionTemplateModelDelegate&  getInstance();

    //  Method to create the Ptn0PartitionTemplateModelImpl pointer
    static Ptn0PartitionTemplateModelImpl*  createImpl( Ptn0PartitionTemplateModel&  ifObj );

    //  Method to delete the Ptn0PartitionTemplateModelImpl pointer
    static void deleteImpl( Ptn0PartitionTemplateModelImpl*  impl );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Ptn0PartitionTemplateModel &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// finalize operation input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  finalizeSaveAsInputBase(const Ptn0PartitionTemplateModel &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.3
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0FinalizeSaveAsInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static Ptn0PartitionTemplateModelDelegate*  m_pInstance;

    Ptn0PartitionTemplateModelDelegate();
    virtual ~Ptn0PartitionTemplateModelDelegate();
    static void setInstance( Ptn0PartitionTemplateModelDelegate*  instance );


private:
    friend class  ::Teamcenter::Partition::Ptn0PartitionTemplateModelGenImpl;

};

#include <ptn0partitiontemplate/libptn0partitiontemplate_undef.h>
#endif  //  TEAMCENTER__PARTITION__PTN0PARTITIONTEMPLATEMODELDELEGATE_HXX
