//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ItemIdRecord
    Filename:   ItemIdRecord.hxx
    Module:     publication
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ITEMIDRECORD__HXX
#define TEAMCENTER__ITEMIDRECORD__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <publication/libpublication_exports.h>

namespace Teamcenter
{
    class ItemIdRecord;
}
namespace Teamcenter
{
    class ItemIdRecordImpl;
}
namespace Teamcenter
{
    class ItemIdRecordDelegate;
}
namespace Teamcenter
{
    class ItemIdRecordDispatch;
}
namespace Teamcenter
{
    class ItemIdRecordGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PUBLICATION_API  Teamcenter::ItemIdRecord
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ItemIdRecord();

    /**
     * Destructor
     */
    virtual ~ItemIdRecord();

private:
    //  Getter method for the Implementation Object
    ItemIdRecordImpl*  getItemIdRecordImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setItemIdRecordImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ItemIdRecordImpl*  m_itemidrecordImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ItemIdRecord - desc for ItemIdRecord parameter
     */
    ItemIdRecord( const ItemIdRecord& );
    ItemIdRecord& operator=( const ItemIdRecord& );

    friend class  ItemIdRecordDelegate;
    friend class  ItemIdRecordDispatch;
    friend class  ItemIdRecordGenImpl;
};

#include <publication/libpublication_undef.h>
#endif //   TEAMCENTER__ITEMIDRECORD__HXX
