//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PublicationAuditRecord
    Filename:   PublicationAuditRecord.hxx
    Module:     publication
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PUBLICATIONAUDITRECORD__HXX
#define TEAMCENTER__PUBLICATIONAUDITRECORD__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <publication/libpublication_exports.h>

namespace Teamcenter
{
    class PublicationAuditRecord;
}
namespace Teamcenter
{
    class PublicationAuditRecordImpl;
}
namespace Teamcenter
{
    class PublicationAuditRecordDelegate;
}
namespace Teamcenter
{
    class PublicationAuditRecordDispatch;
}
namespace Teamcenter
{
    class PublicationAuditRecordGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PUBLICATION_API  Teamcenter::PublicationAuditRecord
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PublicationAuditRecord();

    /**
     * Destructor
     */
    virtual ~PublicationAuditRecord();

private:
    //  Getter method for the Implementation Object
    PublicationAuditRecordImpl*  getPublicationAuditRecordImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPublicationAuditRecordImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PublicationAuditRecordImpl*  m_publicationauditrecordImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PublicationAuditRecord - desc for PublicationAuditRecord parameter
     */
    PublicationAuditRecord( const PublicationAuditRecord& );
    PublicationAuditRecord& operator=( const PublicationAuditRecord& );

    friend class  PublicationAuditRecordDelegate;
    friend class  PublicationAuditRecordDispatch;
    friend class  PublicationAuditRecordGenImpl;
};

#include <publication/libpublication_undef.h>
#endif //   TEAMCENTER__PUBLICATIONAUDITRECORD__HXX
