//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PublicationRecord
    Filename:   PublicationRecord.hxx
    Module:     publication
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PUBLICATIONRECORD__HXX
#define TEAMCENTER__PUBLICATIONRECORD__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <publication/libpublication_exports.h>

namespace Teamcenter
{
    class PublicationRecord;
}
namespace Teamcenter
{
    class PublicationRecordImpl;
}
namespace Teamcenter
{
    class PublicationRecordDelegate;
}
namespace Teamcenter
{
    class PublicationRecordDispatch;
}
namespace Teamcenter
{
    class PublicationRecordGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PUBLICATION_API  Teamcenter::PublicationRecord
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PublicationRecord();

    /**
     * Destructor
     */
    virtual ~PublicationRecord();

private:
    //  Getter method for the Implementation Object
    PublicationRecordImpl*  getPublicationRecordImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPublicationRecordImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PublicationRecordImpl*  m_publicationrecordImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PublicationRecord - desc for PublicationRecord parameter
     */
    PublicationRecord( const PublicationRecord& );
    PublicationRecord& operator=( const PublicationRecord& );

    friend class  PublicationRecordDelegate;
    friend class  PublicationRecordDispatch;
    friend class  PublicationRecordGenImpl;
};

#include <publication/libpublication_undef.h>
#endif //   TEAMCENTER__PUBLICATIONRECORD__HXX
