//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PublishedObject
    Filename:   PublishedObject.hxx
    Module:     publication
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PUBLISHEDOBJECT__HXX
#define TEAMCENTER__PUBLISHEDOBJECT__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <publication/libpublication_exports.h>

namespace Teamcenter
{
    class PublishedObject;
}
namespace Teamcenter
{
    class PublishedObjectImpl;
}
namespace Teamcenter
{
    class PublishedObjectDelegate;
}
namespace Teamcenter
{
    class PublishedObjectDispatch;
}
namespace Teamcenter
{
    class PublishedObjectGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PUBLICATION_API  Teamcenter::PublishedObject
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PublishedObject();

    /**
     * Destructor
     */
    virtual ~PublishedObject();

private:
    //  Getter method for the Implementation Object
    PublishedObjectImpl*  getPublishedObjectImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPublishedObjectImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PublishedObjectImpl*  m_publishedobjectImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PublishedObject - desc for PublishedObject parameter
     */
    PublishedObject( const PublishedObject& );
    PublishedObject& operator=( const PublishedObject& );

    friend class  PublishedObjectDelegate;
    friend class  PublishedObjectDispatch;
    friend class  PublishedObjectGenImpl;
};

#include <publication/libpublication_undef.h>
#endif //   TEAMCENTER__PUBLISHEDOBJECT__HXX
