//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PublishedObjectDelegate
    Filename:   PublishedObjectDelegate.hxx
    Module:     publication
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PUBLISHEDOBJECTDELEGATE_HXX
#define TEAMCENTER__PUBLISHEDOBJECTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <publication/PublishedObject.hxx>

#include <publication/libpublication_exports.h>

namespace Teamcenter
{
    class PublishedObjectDelegate;
}
namespace Teamcenter
{
    class PublishedObjectImpl;
}
namespace Teamcenter
{
    class PublishedObject;
}
namespace Teamcenter
{
    class PublishedObjectGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PUBLICATION_API Teamcenter_alias::PublishedObjectDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PublishedObjectDelegate instance
    static PublishedObjectDelegate&  getInstance();

    //  Method to create the PublishedObjectImpl pointer
    static PublishedObjectImpl*  createImpl( PublishedObject&  ifObj );

    //  Method to delete the PublishedObjectImpl pointer
    static void deleteImpl( PublishedObjectImpl*  impl );



protected:
    //  Pointer to the instance
    static PublishedObjectDelegate*  m_pInstance;

    PublishedObjectDelegate();
    virtual ~PublishedObjectDelegate();
    static void setInstance( PublishedObjectDelegate*  instance );


private:
    friend class  ::Teamcenter::PublishedObjectGenImpl;

};

#include <publication/libpublication_undef.h>
#endif  //  TEAMCENTER__PUBLISHEDOBJECTDELEGATE_HXX
