//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RemoteBOMLine
    Filename:   RemoteBOMLine.hxx
    Module:     publication
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REMOTEBOMLINE__HXX
#define TEAMCENTER__REMOTEBOMLINE__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <publication/libpublication_exports.h>

namespace Teamcenter
{
    class RemoteBOMLine;
}
namespace Teamcenter
{
    class RemoteBOMLineImpl;
}
namespace Teamcenter
{
    class RemoteBOMLineDelegate;
}
namespace Teamcenter
{
    class RemoteBOMLineDispatch;
}
namespace Teamcenter
{
    class RemoteBOMLineGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PUBLICATION_API  Teamcenter::RemoteBOMLine
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    RemoteBOMLine();

    /**
     * Destructor
     */
    virtual ~RemoteBOMLine();

private:
    //  Getter method for the Implementation Object
    RemoteBOMLineImpl*  getRemoteBOMLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRemoteBOMLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    RemoteBOMLineImpl*  m_remotebomlineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param RemoteBOMLine - desc for RemoteBOMLine parameter
     */
    RemoteBOMLine( const RemoteBOMLine& );
    RemoteBOMLine& operator=( const RemoteBOMLine& );

    friend class  RemoteBOMLineDelegate;
    friend class  RemoteBOMLineDispatch;
    friend class  RemoteBOMLineGenImpl;
};

#include <publication/libpublication_undef.h>
#endif //   TEAMCENTER__REMOTEBOMLINE__HXX
