//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RemoteObject
    Filename:   RemoteObject.hxx
    Module:     publication
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REMOTEOBJECT__HXX
#define TEAMCENTER__REMOTEOBJECT__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <publication/libpublication_exports.h>

namespace Teamcenter
{
    class RemoteObject;
}
namespace Teamcenter
{
    class RemoteObjectImpl;
}
namespace Teamcenter
{
    class RemoteObjectDelegate;
}
namespace Teamcenter
{
    class RemoteObjectDispatch;
}
namespace Teamcenter
{
    class RemoteObjectGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  PUBLICATION_API  Teamcenter::RemoteObject
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    RemoteObject();

    /**
     * Destructor
     */
    virtual ~RemoteObject();

private:
    //  Getter method for the Implementation Object
    RemoteObjectImpl*  getRemoteObjectImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRemoteObjectImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    RemoteObjectImpl*  m_remoteobjectImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param RemoteObject - desc for RemoteObject parameter
     */
    RemoteObject( const RemoteObject& );
    RemoteObject& operator=( const RemoteObject& );

    friend class  RemoteObjectDelegate;
    friend class  RemoteObjectDispatch;
    friend class  RemoteObjectGenImpl;
};

#include <publication/libpublication_undef.h>
#endif //   TEAMCENTER__REMOTEOBJECT__HXX
