//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RemoteObjectDelegate
    Filename:   RemoteObjectDelegate.hxx
    Module:     publication
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REMOTEOBJECTDELEGATE_HXX
#define TEAMCENTER__REMOTEOBJECTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <publication/RemoteObject.hxx>

#include <publication/libpublication_exports.h>

namespace Teamcenter
{
    class RemoteObjectDelegate;
}
namespace Teamcenter
{
    class RemoteObjectImpl;
}
namespace Teamcenter
{
    class RemoteObject;
}
namespace Teamcenter
{
    class RemoteObjectGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  PUBLICATION_API Teamcenter_alias::RemoteObjectDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the RemoteObjectDelegate instance
    static RemoteObjectDelegate&  getInstance();

    //  Method to create the RemoteObjectImpl pointer
    static RemoteObjectImpl*  createImpl( RemoteObject&  ifObj );

    //  Method to delete the RemoteObjectImpl pointer
    static void deleteImpl( RemoteObjectImpl*  impl );



protected:
    //  Pointer to the instance
    static RemoteObjectDelegate*  m_pInstance;

    RemoteObjectDelegate();
    virtual ~RemoteObjectDelegate();
    static void setInstance( RemoteObjectDelegate*  instance );


private:
    friend class  ::Teamcenter::RemoteObjectGenImpl;

};

#include <publication/libpublication_undef.h>
#endif  //  TEAMCENTER__REMOTEOBJECTDELEGATE_HXX
