//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  publication

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libpublication

#if !defined(LIBPUBLICATION) && !defined(IPLIB)
#   error IPLIB or LIBPUBLICATION is not defined
#endif

/* Handwritten code should use PUBLICATION_API, not PUBLICATIONEXPORT */

#define PUBLICATION_API PUBLICATIONEXPORT

#if IPLIB==libpublication || defined(LIBPUBLICATION)
#   if defined(__lint)
#       define PUBLICATIONEXPORT       __export(publication)
#       define PUBLICATIONGLOBAL       extern __global(publication)
#       define PUBLICATIONPRIVATE      extern __private(publication)
#   elif defined(_WIN32)
#       define PUBLICATIONEXPORT       __declspec(dllexport)
#       define PUBLICATIONGLOBAL       extern __declspec(dllexport)
#       define PUBLICATIONPRIVATE      extern
#   else
#       define PUBLICATIONEXPORT
#       define PUBLICATIONGLOBAL       extern
#       define PUBLICATIONPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define PUBLICATIONEXPORT       __export(publication)
#       define PUBLICATIONGLOBAL       extern __global(publication)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define PUBLICATIONEXPORT      __declspec(dllimport)
#       define PUBLICATIONGLOBAL       extern __declspec(dllimport)
#   else
#       define PUBLICATIONEXPORT
#       define PUBLICATIONGLOBAL       extern
#   endif
#endif
