//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CrfQuerySource
    Filename:   CrfQuerySource.hxx
    Module:     qry
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CRFQUERYSOURCE__HXX
#define TEAMCENTER__CRFQUERYSOURCE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <qry/libqry_exports.h>

namespace Teamcenter
{
    class CrfQuerySource;
}
namespace Teamcenter
{
    class CrfQuerySourceImpl;
}
namespace Teamcenter
{
    class CrfQuerySourceDelegate;
}
namespace Teamcenter
{
    class CrfQuerySourceDispatch;
}
namespace Teamcenter
{
    class CrfQuerySourceGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  QRY_API  Teamcenter::CrfQuerySource
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CrfQuerySource();

    /**
     * Destructor
     */
    virtual ~CrfQuerySource();

private:
    //  Getter method for the Implementation Object
    CrfQuerySourceImpl*  getCrfQuerySourceImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCrfQuerySourceImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CrfQuerySourceImpl*  m_crfquerysourceImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CrfQuerySource - desc for CrfQuerySource parameter
     */
    CrfQuerySource( const CrfQuerySource& );
    CrfQuerySource& operator=( const CrfQuerySource& );

    friend class  CrfQuerySourceDelegate;
    friend class  CrfQuerySourceDispatch;
    friend class  CrfQuerySourceGenImpl;
};

#include <qry/libqry_undef.h>
#endif //   TEAMCENTER__CRFQUERYSOURCE__HXX
