//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0QueryFolder
    Filename:   Fnd0QueryFolder.hxx
    Module:     qry
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0QUERYFOLDER__HXX
#define TEAMCENTER__FND0QUERYFOLDER__HXX

#include <vector>
#include <string>
#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <qry/libqry_exports.h>

namespace Teamcenter
{
    class Fnd0QueryFolder;
}
namespace Teamcenter
{
    class Fnd0QueryFolderImpl;
}
namespace Teamcenter
{
    class Fnd0QueryFolderDelegate;
}
namespace Teamcenter
{
    class Fnd0QueryFolderDispatch;
}
namespace Teamcenter
{
    class Fnd0QueryFolderGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  QRY_API  Teamcenter::Fnd0QueryFolder
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0contents( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0name( std::string &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0QueryFolder();

    /**
     * Destructor
     */
    virtual ~Fnd0QueryFolder();

private:
    //  Getter method for the Implementation Object
    Fnd0QueryFolderImpl*  getFnd0QueryFolderImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0QueryFolderImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0QueryFolderImpl*  m_fnd0queryfolderImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0QueryFolder - desc for Fnd0QueryFolder parameter
     */
    Fnd0QueryFolder( const Fnd0QueryFolder& );
    Fnd0QueryFolder& operator=( const Fnd0QueryFolder& );

    friend class  Fnd0QueryFolderDelegate;
    friend class  Fnd0QueryFolderDispatch;
    friend class  Fnd0QueryFolderGenImpl;
};

#include <qry/libqry_undef.h>
#endif //   TEAMCENTER__FND0QUERYFOLDER__HXX
