//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0QueryFolderDelegate
    Filename:   Fnd0QueryFolderDelegate.hxx
    Module:     qry
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0QUERYFOLDERDELEGATE_HXX
#define TEAMCENTER__FND0QUERYFOLDERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <qry/Fnd0QueryFolder.hxx>

#include <qry/libqry_exports.h>

namespace Teamcenter
{
    class Fnd0QueryFolderDelegate;
}
namespace Teamcenter
{
    class Fnd0QueryFolderImpl;
}
namespace Teamcenter
{
    class Fnd0QueryFolder;
}
namespace Teamcenter
{
    class Fnd0QueryFolderGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  QRY_API Teamcenter_alias::Fnd0QueryFolderDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0QueryFolderDelegate instance
    static Fnd0QueryFolderDelegate&  getInstance();

    //  Method to create the Fnd0QueryFolderImpl pointer
    static Fnd0QueryFolderImpl*  createImpl( Fnd0QueryFolder&  ifObj );

    //  Method to delete the Fnd0QueryFolderImpl pointer
    static void deleteImpl( Fnd0QueryFolderImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0contentsBase(const Fnd0QueryFolder &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0nameBase(const Fnd0QueryFolder &ifObj,  std::string &value, bool &isNull ) const;



protected:
    //  Pointer to the instance
    static Fnd0QueryFolderDelegate*  m_pInstance;

    Fnd0QueryFolderDelegate();
    virtual ~Fnd0QueryFolderDelegate();
    static void setInstance( Fnd0QueryFolderDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0QueryFolderGenImpl;

};

#include <qry/libqry_undef.h>
#endif  //  TEAMCENTER__FND0QUERYFOLDERDELEGATE_HXX
