//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ReportProvider
    Filename:   Fnd0ReportProvider.hxx
    Module:     qry
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0REPORTPROVIDER__HXX
#define TEAMCENTER__FND0REPORTPROVIDER__HXX

#include <common/tc_deprecation_macros.h>
#include <tc/Fnd0BaseProvider.hxx>

#include <qry/libqry_exports.h>

namespace Teamcenter
{
    class Fnd0ReportProvider;
}
namespace Teamcenter
{
    class Fnd0ReportProviderImpl;
}
namespace Teamcenter
{
    class Fnd0ReportProviderDelegate;
}
namespace Teamcenter
{
    class Fnd0ReportProviderDispatch;
}
namespace Teamcenter
{
    class Fnd0ReportProviderGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  QRY_API  Teamcenter::Fnd0ReportProvider
     : public  ::Teamcenter::Fnd0BaseProvider
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0ReportProvider();

    /**
     * Destructor
     */
    virtual ~Fnd0ReportProvider();

private:
    //  Getter method for the Implementation Object
    Fnd0ReportProviderImpl*  getFnd0ReportProviderImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0ReportProviderImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0ReportProviderImpl*  m_fnd0reportproviderImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0ReportProvider - desc for Fnd0ReportProvider parameter
     */
    Fnd0ReportProvider( const Fnd0ReportProvider& );
    Fnd0ReportProvider& operator=( const Fnd0ReportProvider& );

    friend class  Fnd0ReportProviderDelegate;
    friend class  Fnd0ReportProviderDispatch;
    friend class  Fnd0ReportProviderGenImpl;
};

#include <qry/libqry_undef.h>
#endif //   TEAMCENTER__FND0REPORTPROVIDER__HXX
