//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ReportProviderDelegate
    Filename:   Fnd0ReportProviderDelegate.hxx
    Module:     qry
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0REPORTPROVIDERDELEGATE_HXX
#define TEAMCENTER__FND0REPORTPROVIDERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <qry/Fnd0ReportProvider.hxx>

#include <qry/libqry_exports.h>

namespace Teamcenter
{
    class Fnd0ReportProviderDelegate;
}
namespace Teamcenter
{
    class Fnd0ReportProviderImpl;
}
namespace Teamcenter
{
    class Fnd0ReportProvider;
}
namespace Teamcenter
{
    class Fnd0ReportProviderGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  QRY_API Teamcenter_alias::Fnd0ReportProviderDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0ReportProviderDelegate instance
    static Fnd0ReportProviderDelegate&  getInstance();

    //  Method to create the Fnd0ReportProviderImpl pointer
    static Fnd0ReportProviderImpl*  createImpl( Fnd0ReportProvider&  ifObj );

    //  Method to delete the Fnd0ReportProviderImpl pointer
    static void deleteImpl( Fnd0ReportProviderImpl*  impl );


    ///
    /// This operation returns a structure containing search results, search filters for each search filter field based on the search results, and search filter categories.
    /// @version Teamcenter 9.1.2
    /// @param searchInput - The input to the search
    /// @param searchOutput - The output from the search.
    /// @return - Status. 0 if successful
    ///
    int  fnd0performSearchBase(const Fnd0ReportProvider &ifObj,  ::Teamcenter::OperationInput *searchInput, ::Teamcenter::OperationInput *searchOutput );



protected:
    //  Pointer to the instance
    static Fnd0ReportProviderDelegate*  m_pInstance;

    Fnd0ReportProviderDelegate();
    virtual ~Fnd0ReportProviderDelegate();
    static void setInstance( Fnd0ReportProviderDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0ReportProviderGenImpl;

};

#include <qry/libqry_undef.h>
#endif  //  TEAMCENTER__FND0REPORTPROVIDERDELEGATE_HXX
