//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ImanPFF
    Filename:   ImanPFF.hxx
    Module:     qry
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IMANPFF__HXX
#define TEAMCENTER__IMANPFF__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <qry/libqry_exports.h>

namespace Teamcenter
{
    class ImanPFF;
}
namespace Teamcenter
{
    class ImanPFFImpl;
}
namespace Teamcenter
{
    class ImanPFFDelegate;
}
namespace Teamcenter
{
    class ImanPFFDispatch;
}
namespace Teamcenter
{
    class ImanPFFGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  QRY_API  Teamcenter::ImanPFF
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ImanPFF();

    /**
     * Destructor
     */
    virtual ~ImanPFF();

private:
    //  Getter method for the Implementation Object
    ImanPFFImpl*  getImanPFFImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setImanPFFImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ImanPFFImpl*  m_imanpffImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ImanPFF - desc for ImanPFF parameter
     */
    ImanPFF( const ImanPFF& );
    ImanPFF& operator=( const ImanPFF& );

    friend class  ImanPFFDelegate;
    friend class  ImanPFFDispatch;
    friend class  ImanPFFGenImpl;
};

#include <qry/libqry_undef.h>
#endif //   TEAMCENTER__IMANPFF__HXX
