//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ImanQuery
    Filename:   ImanQuery.hxx
    Module:     qry
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IMANQUERY__HXX
#define TEAMCENTER__IMANQUERY__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <qry/libqry_exports.h>

namespace Teamcenter
{
    class ImanQuery;
}
namespace Teamcenter
{
    class ImanQueryImpl;
}
namespace Teamcenter
{
    class ImanQueryDelegate;
}
namespace Teamcenter
{
    class ImanQueryDispatch;
}
namespace Teamcenter
{
    class ImanQueryGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  QRY_API  Teamcenter::ImanQuery
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ImanQuery();

    /**
     * Destructor
     */
    virtual ~ImanQuery();

private:
    //  Getter method for the Implementation Object
    ImanQueryImpl*  getImanQueryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setImanQueryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ImanQueryImpl*  m_imanqueryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ImanQuery - desc for ImanQuery parameter
     */
    ImanQuery( const ImanQuery& );
    ImanQuery& operator=( const ImanQuery& );

    friend class  ImanQueryDelegate;
    friend class  ImanQueryDispatch;
    friend class  ImanQueryGenImpl;
};

#include <qry/libqry_undef.h>
#endif //   TEAMCENTER__IMANQUERY__HXX
