//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ReportDefinition
    Filename:   ReportDefinition.hxx
    Module:     qry
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REPORTDEFINITION__HXX
#define TEAMCENTER__REPORTDEFINITION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <qry/libqry_exports.h>

namespace Teamcenter
{
    class ReportDefinition;
}
namespace Teamcenter
{
    class ReportDefinitionImpl;
}
namespace Teamcenter
{
    class ReportDefinitionDelegate;
}
namespace Teamcenter
{
    class ReportDefinitionDispatch;
}
namespace Teamcenter
{
    class ReportDefinitionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  QRY_API  Teamcenter::ReportDefinition
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ReportDefinition();

    /**
     * Destructor
     */
    virtual ~ReportDefinition();

private:
    //  Getter method for the Implementation Object
    ReportDefinitionImpl*  getReportDefinitionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setReportDefinitionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ReportDefinitionImpl*  m_reportdefinitionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ReportDefinition - desc for ReportDefinition parameter
     */
    ReportDefinition( const ReportDefinition& );
    ReportDefinition& operator=( const ReportDefinition& );

    friend class  ReportDefinitionDelegate;
    friend class  ReportDefinitionDispatch;
    friend class  ReportDefinitionGenImpl;
};

#include <qry/libqry_undef.h>
#endif //   TEAMCENTER__REPORTDEFINITION__HXX
