//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ReportDesign
    Filename:   ReportDesign.hxx
    Module:     qry
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REPORTDESIGN__HXX
#define TEAMCENTER__REPORTDESIGN__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <qry/libqry_exports.h>

namespace Teamcenter
{
    class ReportDesign;
}
namespace Teamcenter
{
    class ReportDesignImpl;
}
namespace Teamcenter
{
    class ReportDesignDelegate;
}
namespace Teamcenter
{
    class ReportDesignDispatch;
}
namespace Teamcenter
{
    class ReportDesignGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  QRY_API  Teamcenter::ReportDesign
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ReportDesign();

    /**
     * Destructor
     */
    virtual ~ReportDesign();

private:
    //  Getter method for the Implementation Object
    ReportDesignImpl*  getReportDesignImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setReportDesignImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ReportDesignImpl*  m_reportdesignImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ReportDesign - desc for ReportDesign parameter
     */
    ReportDesign( const ReportDesign& );
    ReportDesign& operator=( const ReportDesign& );

    friend class  ReportDesignDelegate;
    friend class  ReportDesignDispatch;
    friend class  ReportDesignGenImpl;
};

#include <qry/libqry_undef.h>
#endif //   TEAMCENTER__REPORTDESIGN__HXX
