//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SavedQueryCriteria
    Filename:   SavedQueryCriteria.hxx
    Module:     qry
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SAVEDQUERYCRITERIA__HXX
#define TEAMCENTER__SAVEDQUERYCRITERIA__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <qry/libqry_exports.h>

namespace Teamcenter
{
    class SavedQueryCriteria;
}
namespace Teamcenter
{
    class SavedQueryCriteriaImpl;
}
namespace Teamcenter
{
    class SavedQueryCriteriaDelegate;
}
namespace Teamcenter
{
    class SavedQueryCriteriaDispatch;
}
namespace Teamcenter
{
    class SavedQueryCriteriaGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  QRY_API  Teamcenter::SavedQueryCriteria
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SavedQueryCriteria();

    /**
     * Destructor
     */
    virtual ~SavedQueryCriteria();

private:
    //  Getter method for the Implementation Object
    SavedQueryCriteriaImpl*  getSavedQueryCriteriaImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSavedQueryCriteriaImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SavedQueryCriteriaImpl*  m_savedquerycriteriaImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SavedQueryCriteria - desc for SavedQueryCriteria parameter
     */
    SavedQueryCriteria( const SavedQueryCriteria& );
    SavedQueryCriteria& operator=( const SavedQueryCriteria& );

    friend class  SavedQueryCriteriaDelegate;
    friend class  SavedQueryCriteriaDispatch;
    friend class  SavedQueryCriteriaGenImpl;
};

#include <qry/libqry_undef.h>
#endif //   TEAMCENTER__SAVEDQUERYCRITERIA__HXX
