//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  qry

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libqry

#if !defined(LIBQRY) && !defined(IPLIB)
#   error IPLIB or LIBQRY is not defined
#endif

/* Handwritten code should use QRY_API, not QRYEXPORT */

#define QRY_API QRYEXPORT

#if IPLIB==libqry || defined(LIBQRY)
#   if defined(__lint)
#       define QRYEXPORT       __export(qry)
#       define QRYGLOBAL       extern __global(qry)
#       define QRYPRIVATE      extern __private(qry)
#   elif defined(_WIN32)
#       define QRYEXPORT       __declspec(dllexport)
#       define QRYGLOBAL       extern __declspec(dllexport)
#       define QRYPRIVATE      extern
#   else
#       define QRYEXPORT
#       define QRYGLOBAL       extern
#       define QRYPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define QRYEXPORT       __export(qry)
#       define QRYGLOBAL       extern __global(qry)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define QRYEXPORT      __declspec(dllimport)
#       define QRYGLOBAL       extern __declspec(dllimport)
#   else
#       define QRYEXPORT
#       define QRYGLOBAL       extern
#   endif
#endif
