//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BoundingMultiBox
    Filename:   BoundingMultiBox.hxx
    Module:     qsearch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BOUNDINGMULTIBOX__HXX
#define TEAMCENTER__BOUNDINGMULTIBOX__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <qsearch/libqsearch_exports.h>

namespace Teamcenter
{
    class BoundingMultiBox;
}
namespace Teamcenter
{
    class BoundingMultiBoxImpl;
}
namespace Teamcenter
{
    class BoundingMultiBoxDelegate;
}
namespace Teamcenter
{
    class BoundingMultiBoxDispatch;
}
namespace Teamcenter
{
    class BoundingMultiBoxGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  QSEARCH_API  Teamcenter::BoundingMultiBox
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    BoundingMultiBox();

    /**
     * Destructor
     */
    virtual ~BoundingMultiBox();

private:
    //  Getter method for the Implementation Object
    BoundingMultiBoxImpl*  getBoundingMultiBoxImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBoundingMultiBoxImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    BoundingMultiBoxImpl*  m_boundingmultiboxImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param BoundingMultiBox - desc for BoundingMultiBox parameter
     */
    BoundingMultiBox( const BoundingMultiBox& );
    BoundingMultiBox& operator=( const BoundingMultiBox& );

    friend class  BoundingMultiBoxDelegate;
    friend class  BoundingMultiBoxDispatch;
    friend class  BoundingMultiBoxGenImpl;
};

#include <qsearch/libqsearch_undef.h>
#endif //   TEAMCENTER__BOUNDINGMULTIBOX__HXX
