//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, QSearchIndex
    Filename:   QSearchIndex.hxx
    Module:     qsearch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__QSEARCHINDEX__HXX
#define TEAMCENTER__QSEARCHINDEX__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <qsearch/libqsearch_exports.h>

namespace Teamcenter
{
    class QSearchIndex;
}
namespace Teamcenter
{
    class QSearchIndexImpl;
}
namespace Teamcenter
{
    class QSearchIndexDelegate;
}
namespace Teamcenter
{
    class QSearchIndexDispatch;
}
namespace Teamcenter
{
    class QSearchIndexGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  QSEARCH_API  Teamcenter::QSearchIndex
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    QSearchIndex();

    /**
     * Destructor
     */
    virtual ~QSearchIndex();

private:
    //  Getter method for the Implementation Object
    QSearchIndexImpl*  getQSearchIndexImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setQSearchIndexImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    QSearchIndexImpl*  m_qsearchindexImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param QSearchIndex - desc for QSearchIndex parameter
     */
    QSearchIndex( const QSearchIndex& );
    QSearchIndex& operator=( const QSearchIndex& );

    friend class  QSearchIndexDelegate;
    friend class  QSearchIndexDispatch;
    friend class  QSearchIndexGenImpl;
};

#include <qsearch/libqsearch_undef.h>
#endif //   TEAMCENTER__QSEARCHINDEX__HXX
