//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, QSearchIndexUpdateEntry
    Filename:   QSearchIndexUpdateEntry.hxx
    Module:     qsearch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__QSEARCHINDEXUPDATEENTRY__HXX
#define TEAMCENTER__QSEARCHINDEXUPDATEENTRY__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <qsearch/libqsearch_exports.h>

namespace Teamcenter
{
    class QSearchIndexUpdateEntry;
}
namespace Teamcenter
{
    class QSearchIndexUpdateEntryImpl;
}
namespace Teamcenter
{
    class QSearchIndexUpdateEntryDelegate;
}
namespace Teamcenter
{
    class QSearchIndexUpdateEntryDispatch;
}
namespace Teamcenter
{
    class QSearchIndexUpdateEntryGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  QSEARCH_API  Teamcenter::QSearchIndexUpdateEntry
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    QSearchIndexUpdateEntry();

    /**
     * Destructor
     */
    virtual ~QSearchIndexUpdateEntry();

private:
    //  Getter method for the Implementation Object
    QSearchIndexUpdateEntryImpl*  getQSearchIndexUpdateEntryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setQSearchIndexUpdateEntryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    QSearchIndexUpdateEntryImpl*  m_qsearchindexupdateentryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param QSearchIndexUpdateEntry - desc for QSearchIndexUpdateEntry parameter
     */
    QSearchIndexUpdateEntry( const QSearchIndexUpdateEntry& );
    QSearchIndexUpdateEntry& operator=( const QSearchIndexUpdateEntry& );

    friend class  QSearchIndexUpdateEntryDelegate;
    friend class  QSearchIndexUpdateEntryDispatch;
    friend class  QSearchIndexUpdateEntryGenImpl;
};

#include <qsearch/libqsearch_undef.h>
#endif //   TEAMCENTER__QSEARCHINDEXUPDATEENTRY__HXX
