//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SearchCursor
    Filename:   SearchCursor.hxx
    Module:     qsearch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SEARCHCURSOR__HXX
#define TEAMCENTER__SEARCHCURSOR__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <qsearch/libqsearch_exports.h>

namespace Teamcenter
{
    class SearchCursor;
}
namespace Teamcenter
{
    class SearchCursorImpl;
}
namespace Teamcenter
{
    class SearchCursorDelegate;
}
namespace Teamcenter
{
    class SearchCursorDispatch;
}
namespace Teamcenter
{
    class SearchCursorGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  QSEARCH_API  Teamcenter::SearchCursor
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SearchCursor();

    /**
     * Destructor
     */
    virtual ~SearchCursor();

private:
    //  Getter method for the Implementation Object
    SearchCursorImpl*  getSearchCursorImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSearchCursorImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SearchCursorImpl*  m_searchcursorImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SearchCursor - desc for SearchCursor parameter
     */
    SearchCursor( const SearchCursor& );
    SearchCursor& operator=( const SearchCursor& );

    friend class  SearchCursorDelegate;
    friend class  SearchCursorDispatch;
    friend class  SearchCursorGenImpl;
};

#include <qsearch/libqsearch_undef.h>
#endif //   TEAMCENTER__SEARCHCURSOR__HXX
