//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  qsearch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libqsearch

#if !defined(LIBQSEARCH) && !defined(IPLIB)
#   error IPLIB or LIBQSEARCH is not defined
#endif

/* Handwritten code should use QSEARCH_API, not QSEARCHEXPORT */

#define QSEARCH_API QSEARCHEXPORT

#if IPLIB==libqsearch || defined(LIBQSEARCH)
#   if defined(__lint)
#       define QSEARCHEXPORT       __export(qsearch)
#       define QSEARCHGLOBAL       extern __global(qsearch)
#       define QSEARCHPRIVATE      extern __private(qsearch)
#   elif defined(_WIN32)
#       define QSEARCHEXPORT       __declspec(dllexport)
#       define QSEARCHGLOBAL       extern __declspec(dllexport)
#       define QSEARCHPRIVATE      extern
#   else
#       define QSEARCHEXPORT
#       define QSEARCHGLOBAL       extern
#       define QSEARCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define QSEARCHEXPORT       __export(qsearch)
#       define QSEARCHGLOBAL       extern __global(qsearch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define QSEARCHEXPORT      __declspec(dllimport)
#       define QSEARCHGLOBAL       extern __declspec(dllimport)
#   else
#       define QSEARCHEXPORT
#       define QSEARCHGLOBAL       extern
#   endif
#endif
