//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AppExtensionPoint
    Filename:   AppExtensionPoint.hxx
    Module:     rbf
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPEXTENSIONPOINT__HXX
#define TEAMCENTER__APPEXTENSIONPOINT__HXX

#include <common/tc_deprecation_macros.h>
#include <rbf/BusinessElement.hxx>

#include <rbf/librbf_exports.h>

namespace Teamcenter
{
    class AppExtensionPoint;
}
namespace Teamcenter
{
    class AppExtensionPointImpl;
}
namespace Teamcenter
{
    class AppExtensionPointDelegate;
}
namespace Teamcenter
{
    class AppExtensionPointDispatch;
}
namespace Teamcenter
{
    class AppExtensionPointGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RBF_API  Teamcenter::AppExtensionPoint
     : public  ::Teamcenter::BusinessElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AppExtensionPoint();

    /**
     * Destructor
     */
    virtual ~AppExtensionPoint();

private:
    //  Getter method for the Implementation Object
    AppExtensionPointImpl*  getAppExtensionPointImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAppExtensionPointImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AppExtensionPointImpl*  m_appextensionpointImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AppExtensionPoint - desc for AppExtensionPoint parameter
     */
    AppExtensionPoint( const AppExtensionPoint& );
    AppExtensionPoint& operator=( const AppExtensionPoint& );

    friend class  AppExtensionPointDelegate;
    friend class  AppExtensionPointDispatch;
    friend class  AppExtensionPointGenImpl;
};

#include <rbf/librbf_undef.h>
#endif //   TEAMCENTER__APPEXTENSIONPOINT__HXX
