//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AppExtensionRule
    Filename:   AppExtensionRule.hxx
    Module:     rbf
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPEXTENSIONRULE__HXX
#define TEAMCENTER__APPEXTENSIONRULE__HXX

#include <common/tc_deprecation_macros.h>
#include <rbf/BusinessElement.hxx>

#include <rbf/librbf_exports.h>

namespace Teamcenter
{
    class AppExtensionRule;
}
namespace Teamcenter
{
    class AppExtensionRuleImpl;
}
namespace Teamcenter
{
    class AppExtensionRuleDelegate;
}
namespace Teamcenter
{
    class AppExtensionRuleDispatch;
}
namespace Teamcenter
{
    class AppExtensionRuleGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RBF_API  Teamcenter::AppExtensionRule
     : public  ::Teamcenter::BusinessElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AppExtensionRule();

    /**
     * Destructor
     */
    virtual ~AppExtensionRule();

private:
    //  Getter method for the Implementation Object
    AppExtensionRuleImpl*  getAppExtensionRuleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAppExtensionRuleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AppExtensionRuleImpl*  m_appextensionruleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AppExtensionRule - desc for AppExtensionRule parameter
     */
    AppExtensionRule( const AppExtensionRule& );
    AppExtensionRule& operator=( const AppExtensionRule& );

    friend class  AppExtensionRuleDelegate;
    friend class  AppExtensionRuleDispatch;
    friend class  AppExtensionRuleGenImpl;
};

#include <rbf/librbf_undef.h>
#endif //   TEAMCENTER__APPEXTENSIONRULE__HXX
