//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AppExtensionRuleType
    Filename:   AppExtensionRuleType.hxx
    Module:     rbf
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPEXTENSIONRULETYPE__HXX
#define TEAMCENTER__APPEXTENSIONRULETYPE__HXX

#include <common/tc_deprecation_macros.h>
#include <rbf/BusinessElement.hxx>

#include <rbf/librbf_exports.h>

namespace Teamcenter
{
    class AppExtensionRuleType;
}
namespace Teamcenter
{
    class AppExtensionRuleTypeImpl;
}
namespace Teamcenter
{
    class AppExtensionRuleTypeDelegate;
}
namespace Teamcenter
{
    class AppExtensionRuleTypeDispatch;
}
namespace Teamcenter
{
    class AppExtensionRuleTypeGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RBF_API  Teamcenter::AppExtensionRuleType
     : public  ::Teamcenter::BusinessElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AppExtensionRuleType();

    /**
     * Destructor
     */
    virtual ~AppExtensionRuleType();

private:
    //  Getter method for the Implementation Object
    AppExtensionRuleTypeImpl*  getAppExtensionRuleTypeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAppExtensionRuleTypeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AppExtensionRuleTypeImpl*  m_appextensionruletypeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AppExtensionRuleType - desc for AppExtensionRuleType parameter
     */
    AppExtensionRuleType( const AppExtensionRuleType& );
    AppExtensionRuleType& operator=( const AppExtensionRuleType& );

    friend class  AppExtensionRuleTypeDelegate;
    friend class  AppExtensionRuleTypeDispatch;
    friend class  AppExtensionRuleTypeGenImpl;
};

#include <rbf/librbf_undef.h>
#endif //   TEAMCENTER__APPEXTENSIONRULETYPE__HXX
