//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BusinessContext
    Filename:   BusinessContext.hxx
    Module:     rbf
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BUSINESSCONTEXT__HXX
#define TEAMCENTER__BUSINESSCONTEXT__HXX

#include <common/tc_deprecation_macros.h>
#include <rbf/BusinessElement.hxx>

#include <rbf/librbf_exports.h>

namespace Teamcenter
{
    class BusinessContext;
}
namespace Teamcenter
{
    class BusinessContextImpl;
}
namespace Teamcenter
{
    class BusinessContextDelegate;
}
namespace Teamcenter
{
    class BusinessContextDispatch;
}
namespace Teamcenter
{
    class BusinessContextGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RBF_API  Teamcenter::BusinessContext
     : public  ::Teamcenter::BusinessElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    BusinessContext();

    /**
     * Destructor
     */
    virtual ~BusinessContext();

private:
    //  Getter method for the Implementation Object
    BusinessContextImpl*  getBusinessContextImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBusinessContextImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    BusinessContextImpl*  m_businesscontextImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param BusinessContext - desc for BusinessContext parameter
     */
    BusinessContext( const BusinessContext& );
    BusinessContext& operator=( const BusinessContext& );

    friend class  BusinessContextDelegate;
    friend class  BusinessContextDispatch;
    friend class  BusinessContextGenImpl;
};

#include <rbf/librbf_undef.h>
#endif //   TEAMCENTER__BUSINESSCONTEXT__HXX
