//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BusinessElement
    Filename:   BusinessElement.hxx
    Module:     rbf
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BUSINESSELEMENT__HXX
#define TEAMCENTER__BUSINESSELEMENT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/BusinessRule.hxx>

#include <rbf/librbf_exports.h>

namespace Teamcenter
{
    class BusinessElement;
}
namespace Teamcenter
{
    class BusinessElementImpl;
}
namespace Teamcenter
{
    class BusinessElementDelegate;
}
namespace Teamcenter
{
    class BusinessElementDispatch;
}
namespace Teamcenter
{
    class BusinessElementGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RBF_API  Teamcenter::BusinessElement
     : public  ::Teamcenter::BusinessRule
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    BusinessElement();

    /**
     * Destructor
     */
    virtual ~BusinessElement();

private:
    //  Getter method for the Implementation Object
    BusinessElementImpl*  getBusinessElementImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBusinessElementImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    BusinessElementImpl*  m_businesselementImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param BusinessElement - desc for BusinessElement parameter
     */
    BusinessElement( const BusinessElement& );
    BusinessElement& operator=( const BusinessElement& );

    friend class  BusinessElementDelegate;
    friend class  BusinessElementDispatch;
    friend class  BusinessElementGenImpl;
};

#include <rbf/librbf_undef.h>
#endif //   TEAMCENTER__BUSINESSELEMENT__HXX
