//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DecisionTable
    Filename:   DecisionTable.hxx
    Module:     rbf
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__DECISIONTABLE__HXX
#define TEAMCENTER__DECISIONTABLE__HXX

#include <common/tc_deprecation_macros.h>
#include <rbf/AppExtensionRuleType.hxx>

#include <rbf/librbf_exports.h>

namespace Teamcenter
{
    class DecisionTable;
}
namespace Teamcenter
{
    class DecisionTableImpl;
}
namespace Teamcenter
{
    class DecisionTableDelegate;
}
namespace Teamcenter
{
    class DecisionTableDispatch;
}
namespace Teamcenter
{
    class DecisionTableGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RBF_API  Teamcenter::DecisionTable
     : public  ::Teamcenter::AppExtensionRuleType
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    DecisionTable();

    /**
     * Destructor
     */
    virtual ~DecisionTable();

private:
    //  Getter method for the Implementation Object
    DecisionTableImpl*  getDecisionTableImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDecisionTableImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DecisionTableImpl*  m_decisiontableImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param DecisionTable - desc for DecisionTable parameter
     */
    DecisionTable( const DecisionTable& );
    DecisionTable& operator=( const DecisionTable& );

    friend class  DecisionTableDelegate;
    friend class  DecisionTableDispatch;
    friend class  DecisionTableGenImpl;
};

#include <rbf/librbf_undef.h>
#endif //   TEAMCENTER__DECISIONTABLE__HXX
