//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RBFCell
    Filename:   RBFCell.hxx
    Module:     rbf
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__RBFCELL__HXX
#define TEAMCENTER__RBFCELL__HXX

#include <common/tc_deprecation_macros.h>
#include <rbf/BusinessElement.hxx>

#include <rbf/librbf_exports.h>

namespace Teamcenter
{
    class RBFCell;
}
namespace Teamcenter
{
    class RBFCellImpl;
}
namespace Teamcenter
{
    class RBFCellDelegate;
}
namespace Teamcenter
{
    class RBFCellDispatch;
}
namespace Teamcenter
{
    class RBFCellGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RBF_API  Teamcenter::RBFCell
     : public  ::Teamcenter::BusinessElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    RBFCell();

    /**
     * Destructor
     */
    virtual ~RBFCell();

private:
    //  Getter method for the Implementation Object
    RBFCellImpl*  getRBFCellImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRBFCellImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    RBFCellImpl*  m_rbfcellImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param RBFCell - desc for RBFCell parameter
     */
    RBFCell( const RBFCell& );
    RBFCell& operator=( const RBFCell& );

    friend class  RBFCellDelegate;
    friend class  RBFCellDispatch;
    friend class  RBFCellGenImpl;
};

#include <rbf/librbf_undef.h>
#endif //   TEAMCENTER__RBFCELL__HXX
