//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RBFExpression
    Filename:   RBFExpression.hxx
    Module:     rbf
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__RBFEXPRESSION__HXX
#define TEAMCENTER__RBFEXPRESSION__HXX

#include <common/tc_deprecation_macros.h>
#include <rbf/RBFParamDef.hxx>

#include <rbf/librbf_exports.h>

namespace Teamcenter
{
    class RBFExpression;
}
namespace Teamcenter
{
    class RBFExpressionImpl;
}
namespace Teamcenter
{
    class RBFExpressionDelegate;
}
namespace Teamcenter
{
    class RBFExpressionDispatch;
}
namespace Teamcenter
{
    class RBFExpressionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RBF_API  Teamcenter::RBFExpression
     : public  ::Teamcenter::RBFParamDef
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    RBFExpression();

    /**
     * Destructor
     */
    virtual ~RBFExpression();

private:
    //  Getter method for the Implementation Object
    RBFExpressionImpl*  getRBFExpressionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRBFExpressionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    RBFExpressionImpl*  m_rbfexpressionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param RBFExpression - desc for RBFExpression parameter
     */
    RBFExpression( const RBFExpression& );
    RBFExpression& operator=( const RBFExpression& );

    friend class  RBFExpressionDelegate;
    friend class  RBFExpressionDispatch;
    friend class  RBFExpressionGenImpl;
};

#include <rbf/librbf_undef.h>
#endif //   TEAMCENTER__RBFEXPRESSION__HXX
