//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RBFInput
    Filename:   RBFInput.hxx
    Module:     rbf
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__RBFINPUT__HXX
#define TEAMCENTER__RBFINPUT__HXX

#include <common/tc_deprecation_macros.h>
#include <rbf/RBFExpression.hxx>

#include <rbf/librbf_exports.h>

namespace Teamcenter
{
    class RBFInput;
}
namespace Teamcenter
{
    class RBFInputImpl;
}
namespace Teamcenter
{
    class RBFInputDelegate;
}
namespace Teamcenter
{
    class RBFInputDispatch;
}
namespace Teamcenter
{
    class RBFInputGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RBF_API  Teamcenter::RBFInput
     : public  ::Teamcenter::RBFExpression
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    RBFInput();

    /**
     * Destructor
     */
    virtual ~RBFInput();

private:
    //  Getter method for the Implementation Object
    RBFInputImpl*  getRBFInputImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRBFInputImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    RBFInputImpl*  m_rbfinputImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param RBFInput - desc for RBFInput parameter
     */
    RBFInput( const RBFInput& );
    RBFInput& operator=( const RBFInput& );

    friend class  RBFInputDelegate;
    friend class  RBFInputDispatch;
    friend class  RBFInputGenImpl;
};

#include <rbf/librbf_undef.h>
#endif //   TEAMCENTER__RBFINPUT__HXX
