//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RBFOutput
    Filename:   RBFOutput.hxx
    Module:     rbf
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__RBFOUTPUT__HXX
#define TEAMCENTER__RBFOUTPUT__HXX

#include <common/tc_deprecation_macros.h>
#include <rbf/RBFParamDef.hxx>

#include <rbf/librbf_exports.h>

namespace Teamcenter
{
    class RBFOutput;
}
namespace Teamcenter
{
    class RBFOutputImpl;
}
namespace Teamcenter
{
    class RBFOutputDelegate;
}
namespace Teamcenter
{
    class RBFOutputDispatch;
}
namespace Teamcenter
{
    class RBFOutputGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RBF_API  Teamcenter::RBFOutput
     : public  ::Teamcenter::RBFParamDef
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    RBFOutput();

    /**
     * Destructor
     */
    virtual ~RBFOutput();

private:
    //  Getter method for the Implementation Object
    RBFOutputImpl*  getRBFOutputImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRBFOutputImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    RBFOutputImpl*  m_rbfoutputImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param RBFOutput - desc for RBFOutput parameter
     */
    RBFOutput( const RBFOutput& );
    RBFOutput& operator=( const RBFOutput& );

    friend class  RBFOutputDelegate;
    friend class  RBFOutputDispatch;
    friend class  RBFOutputGenImpl;
};

#include <rbf/librbf_undef.h>
#endif //   TEAMCENTER__RBFOUTPUT__HXX
