//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RBFParamDef
    Filename:   RBFParamDef.hxx
    Module:     rbf
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__RBFPARAMDEF__HXX
#define TEAMCENTER__RBFPARAMDEF__HXX

#include <common/tc_deprecation_macros.h>
#include <rbf/BusinessElement.hxx>

#include <rbf/librbf_exports.h>

namespace Teamcenter
{
    class RBFParamDef;
}
namespace Teamcenter
{
    class RBFParamDefImpl;
}
namespace Teamcenter
{
    class RBFParamDefDelegate;
}
namespace Teamcenter
{
    class RBFParamDefDispatch;
}
namespace Teamcenter
{
    class RBFParamDefGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RBF_API  Teamcenter::RBFParamDef
     : public  ::Teamcenter::BusinessElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    RBFParamDef();

    /**
     * Destructor
     */
    virtual ~RBFParamDef();

private:
    //  Getter method for the Implementation Object
    RBFParamDefImpl*  getRBFParamDefImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRBFParamDefImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    RBFParamDefImpl*  m_rbfparamdefImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param RBFParamDef - desc for RBFParamDef parameter
     */
    RBFParamDef( const RBFParamDef& );
    RBFParamDef& operator=( const RBFParamDef& );

    friend class  RBFParamDefDelegate;
    friend class  RBFParamDefDispatch;
    friend class  RBFParamDefGenImpl;
};

#include <rbf/librbf_undef.h>
#endif //   TEAMCENTER__RBFPARAMDEF__HXX
