//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RBFRow
    Filename:   RBFRow.hxx
    Module:     rbf
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__RBFROW__HXX
#define TEAMCENTER__RBFROW__HXX

#include <common/tc_deprecation_macros.h>
#include <rbf/BusinessElement.hxx>

#include <rbf/librbf_exports.h>

namespace Teamcenter
{
    class RBFRow;
}
namespace Teamcenter
{
    class RBFRowImpl;
}
namespace Teamcenter
{
    class RBFRowDelegate;
}
namespace Teamcenter
{
    class RBFRowDispatch;
}
namespace Teamcenter
{
    class RBFRowGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RBF_API  Teamcenter::RBFRow
     : public  ::Teamcenter::BusinessElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    RBFRow();

    /**
     * Destructor
     */
    virtual ~RBFRow();

private:
    //  Getter method for the Implementation Object
    RBFRowImpl*  getRBFRowImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRBFRowImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    RBFRowImpl*  m_rbfrowImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param RBFRow - desc for RBFRow parameter
     */
    RBFRow( const RBFRow& );
    RBFRow& operator=( const RBFRow& );

    friend class  RBFRowDelegate;
    friend class  RBFRowDispatch;
    friend class  RBFRowGenImpl;
};

#include <rbf/librbf_undef.h>
#endif //   TEAMCENTER__RBFROW__HXX
