//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RBFTableColumn
    Filename:   RBFTableColumn.hxx
    Module:     rbf
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__RBFTABLECOLUMN__HXX
#define TEAMCENTER__RBFTABLECOLUMN__HXX

#include <common/tc_deprecation_macros.h>
#include <rbf/RBFExpression.hxx>

#include <rbf/librbf_exports.h>

namespace Teamcenter
{
    class RBFTableColumn;
}
namespace Teamcenter
{
    class RBFTableColumnImpl;
}
namespace Teamcenter
{
    class RBFTableColumnDelegate;
}
namespace Teamcenter
{
    class RBFTableColumnDispatch;
}
namespace Teamcenter
{
    class RBFTableColumnGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RBF_API  Teamcenter::RBFTableColumn
     : public  ::Teamcenter::RBFExpression
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    RBFTableColumn();

    /**
     * Destructor
     */
    virtual ~RBFTableColumn();

private:
    //  Getter method for the Implementation Object
    RBFTableColumnImpl*  getRBFTableColumnImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRBFTableColumnImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    RBFTableColumnImpl*  m_rbftablecolumnImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param RBFTableColumn - desc for RBFTableColumn parameter
     */
    RBFTableColumn( const RBFTableColumn& );
    RBFTableColumn& operator=( const RBFTableColumn& );

    friend class  RBFTableColumnDelegate;
    friend class  RBFTableColumnDispatch;
    friend class  RBFTableColumnGenImpl;
};

#include <rbf/librbf_undef.h>
#endif //   TEAMCENTER__RBFTABLECOLUMN__HXX
