//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  rbf

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            librbf

#if !defined(LIBRBF) && !defined(IPLIB)
#   error IPLIB or LIBRBF is not defined
#endif

/* Handwritten code should use RBF_API, not RBFEXPORT */

#define RBF_API RBFEXPORT

#if IPLIB==librbf || defined(LIBRBF)
#   if defined(__lint)
#       define RBFEXPORT       __export(rbf)
#       define RBFGLOBAL       extern __global(rbf)
#       define RBFPRIVATE      extern __private(rbf)
#   elif defined(_WIN32)
#       define RBFEXPORT       __declspec(dllexport)
#       define RBFGLOBAL       extern __declspec(dllexport)
#       define RBFPRIVATE      extern
#   else
#       define RBFEXPORT
#       define RBFGLOBAL       extern
#       define RBFPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define RBFEXPORT       __export(rbf)
#       define RBFGLOBAL       extern __global(rbf)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define RBFEXPORT      __declspec(dllimport)
#       define RBFGLOBAL       extern __declspec(dllimport)
#   else
#       define RBFEXPORT
#       define RBFGLOBAL       extern
#   endif
#endif
