//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprSearchCriteriaAttribute
    Filename:   ApprSearchCriteriaAttribute.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRSEARCHCRITERIAATTRIBUTE__HXX
#define TEAMCENTER__APPRSEARCHCRITERIAATTRIBUTE__HXX

#include <common/tc_deprecation_macros.h>
#include <rdv/ApprSearchCriteria.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class ApprSearchCriteriaAttribute;
}
namespace Teamcenter
{
    class ApprSearchCriteriaAttributeImpl;
}
namespace Teamcenter
{
    class ApprSearchCriteriaAttributeDelegate;
}
namespace Teamcenter
{
    class ApprSearchCriteriaAttributeDispatch;
}
namespace Teamcenter
{
    class ApprSearchCriteriaAttributeGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RDV_API  Teamcenter::ApprSearchCriteriaAttribute
     : public  ::Teamcenter::ApprSearchCriteria
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ApprSearchCriteriaAttribute();

    /**
     * Destructor
     */
    virtual ~ApprSearchCriteriaAttribute();

private:
    //  Getter method for the Implementation Object
    ApprSearchCriteriaAttributeImpl*  getApprSearchCriteriaAttributeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setApprSearchCriteriaAttributeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ApprSearchCriteriaAttributeImpl*  m_apprsearchcriteriaattributeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ApprSearchCriteriaAttribute - desc for ApprSearchCriteriaAttribute parameter
     */
    ApprSearchCriteriaAttribute( const ApprSearchCriteriaAttribute& );
    ApprSearchCriteriaAttribute& operator=( const ApprSearchCriteriaAttribute& );

    friend class  ApprSearchCriteriaAttributeDelegate;
    friend class  ApprSearchCriteriaAttributeDispatch;
    friend class  ApprSearchCriteriaAttributeGenImpl;
};

#include <rdv/librdv_undef.h>
#endif //   TEAMCENTER__APPRSEARCHCRITERIAATTRIBUTE__HXX
