//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprSearchCriteriaBoxZone
    Filename:   ApprSearchCriteriaBoxZone.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRSEARCHCRITERIABOXZONE__HXX
#define TEAMCENTER__APPRSEARCHCRITERIABOXZONE__HXX

#include <common/tc_deprecation_macros.h>
#include <rdv/ApprSearchCriteria.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class ApprSearchCriteriaBoxZone;
}
namespace Teamcenter
{
    class ApprSearchCriteriaBoxZoneImpl;
}
namespace Teamcenter
{
    class ApprSearchCriteriaBoxZoneDelegate;
}
namespace Teamcenter
{
    class ApprSearchCriteriaBoxZoneDispatch;
}
namespace Teamcenter
{
    class ApprSearchCriteriaBoxZoneGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RDV_API  Teamcenter::ApprSearchCriteriaBoxZone
     : public  ::Teamcenter::ApprSearchCriteria
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ApprSearchCriteriaBoxZone();

    /**
     * Destructor
     */
    virtual ~ApprSearchCriteriaBoxZone();

private:
    //  Getter method for the Implementation Object
    ApprSearchCriteriaBoxZoneImpl*  getApprSearchCriteriaBoxZoneImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setApprSearchCriteriaBoxZoneImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ApprSearchCriteriaBoxZoneImpl*  m_apprsearchcriteriaboxzoneImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ApprSearchCriteriaBoxZone - desc for ApprSearchCriteriaBoxZone parameter
     */
    ApprSearchCriteriaBoxZone( const ApprSearchCriteriaBoxZone& );
    ApprSearchCriteriaBoxZone& operator=( const ApprSearchCriteriaBoxZone& );

    friend class  ApprSearchCriteriaBoxZoneDelegate;
    friend class  ApprSearchCriteriaBoxZoneDispatch;
    friend class  ApprSearchCriteriaBoxZoneGenImpl;
};

#include <rdv/librdv_undef.h>
#endif //   TEAMCENTER__APPRSEARCHCRITERIABOXZONE__HXX
