//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprSearchCriteriaDelegate
    Filename:   ApprSearchCriteriaDelegate.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRSEARCHCRITERIADELEGATE_HXX
#define TEAMCENTER__APPRSEARCHCRITERIADELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <rdv/ApprSearchCriteria.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class ApprSearchCriteriaDelegate;
}
namespace Teamcenter
{
    class ApprSearchCriteriaImpl;
}
namespace Teamcenter
{
    class ApprSearchCriteria;
}
namespace Teamcenter
{
    class ApprSearchCriteriaGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  RDV_API Teamcenter_alias::ApprSearchCriteriaDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ApprSearchCriteriaDelegate instance
    static ApprSearchCriteriaDelegate&  getInstance();

    //  Method to create the ApprSearchCriteriaImpl pointer
    static ApprSearchCriteriaImpl*  createImpl( ApprSearchCriteria&  ifObj );

    //  Method to delete the ApprSearchCriteriaImpl pointer
    static void deleteImpl( ApprSearchCriteriaImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0_tso_flagBase(const ApprSearchCriteria &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ReturnTypeBase(const ApprSearchCriteria &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0RootTypeBase(const ApprSearchCriteria &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0TraversalKeyBase(const ApprSearchCriteria &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0_tso_flagBase(ApprSearchCriteria &ifObj,  bool value, bool isNull );



protected:
    //  Pointer to the instance
    static ApprSearchCriteriaDelegate*  m_pInstance;

    ApprSearchCriteriaDelegate();
    virtual ~ApprSearchCriteriaDelegate();
    static void setInstance( ApprSearchCriteriaDelegate*  instance );


private:
    friend class  ::Teamcenter::ApprSearchCriteriaGenImpl;

};

#include <rdv/librdv_undef.h>
#endif  //  TEAMCENTER__APPRSEARCHCRITERIADELEGATE_HXX
