//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprSearchCriteriaGroup
    Filename:   ApprSearchCriteriaGroup.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRSEARCHCRITERIAGROUP__HXX
#define TEAMCENTER__APPRSEARCHCRITERIAGROUP__HXX

#include <common/tc_deprecation_macros.h>
#include <rdv/ApprSearchCriteria.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class ApprSearchCriteriaGroup;
}
namespace Teamcenter
{
    class ApprSearchCriteriaGroupImpl;
}
namespace Teamcenter
{
    class ApprSearchCriteriaGroupDelegate;
}
namespace Teamcenter
{
    class ApprSearchCriteriaGroupDispatch;
}
namespace Teamcenter
{
    class ApprSearchCriteriaGroupGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RDV_API  Teamcenter::ApprSearchCriteriaGroup
     : public  ::Teamcenter::ApprSearchCriteria
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ApprSearchCriteriaGroup();

    /**
     * Destructor
     */
    virtual ~ApprSearchCriteriaGroup();

private:
    //  Getter method for the Implementation Object
    ApprSearchCriteriaGroupImpl*  getApprSearchCriteriaGroupImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setApprSearchCriteriaGroupImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ApprSearchCriteriaGroupImpl*  m_apprsearchcriteriagroupImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ApprSearchCriteriaGroup - desc for ApprSearchCriteriaGroup parameter
     */
    ApprSearchCriteriaGroup( const ApprSearchCriteriaGroup& );
    ApprSearchCriteriaGroup& operator=( const ApprSearchCriteriaGroup& );

    friend class  ApprSearchCriteriaGroupDelegate;
    friend class  ApprSearchCriteriaGroupDispatch;
    friend class  ApprSearchCriteriaGroupGenImpl;
};

#include <rdv/librdv_undef.h>
#endif //   TEAMCENTER__APPRSEARCHCRITERIAGROUP__HXX
