//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprSearchCriteriaInClass
    Filename:   ApprSearchCriteriaInClass.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRSEARCHCRITERIAINCLASS__HXX
#define TEAMCENTER__APPRSEARCHCRITERIAINCLASS__HXX

#include <common/tc_deprecation_macros.h>
#include <rdv/ApprSearchCriteria.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class ApprSearchCriteriaInClass;
}
namespace Teamcenter
{
    class ApprSearchCriteriaInClassImpl;
}
namespace Teamcenter
{
    class ApprSearchCriteriaInClassDelegate;
}
namespace Teamcenter
{
    class ApprSearchCriteriaInClassDispatch;
}
namespace Teamcenter
{
    class ApprSearchCriteriaInClassGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RDV_API  Teamcenter::ApprSearchCriteriaInClass
     : public  ::Teamcenter::ApprSearchCriteria
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ApprSearchCriteriaInClass();

    /**
     * Destructor
     */
    virtual ~ApprSearchCriteriaInClass();

private:
    //  Getter method for the Implementation Object
    ApprSearchCriteriaInClassImpl*  getApprSearchCriteriaInClassImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setApprSearchCriteriaInClassImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ApprSearchCriteriaInClassImpl*  m_apprsearchcriteriainclassImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ApprSearchCriteriaInClass - desc for ApprSearchCriteriaInClass parameter
     */
    ApprSearchCriteriaInClass( const ApprSearchCriteriaInClass& );
    ApprSearchCriteriaInClass& operator=( const ApprSearchCriteriaInClass& );

    friend class  ApprSearchCriteriaInClassDelegate;
    friend class  ApprSearchCriteriaInClassDispatch;
    friend class  ApprSearchCriteriaInClassGenImpl;
};

#include <rdv/librdv_undef.h>
#endif //   TEAMCENTER__APPRSEARCHCRITERIAINCLASS__HXX
