//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprSearchCriteriaMapAttr
    Filename:   ApprSearchCriteriaMapAttr.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRSEARCHCRITERIAMAPATTR__HXX
#define TEAMCENTER__APPRSEARCHCRITERIAMAPATTR__HXX

#include <common/tc_deprecation_macros.h>
#include <rdv/ApprSearchCriteria.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class ApprSearchCriteriaMapAttr;
}
namespace Teamcenter
{
    class ApprSearchCriteriaMapAttrImpl;
}
namespace Teamcenter
{
    class ApprSearchCriteriaMapAttrDelegate;
}
namespace Teamcenter
{
    class ApprSearchCriteriaMapAttrDispatch;
}
namespace Teamcenter
{
    class ApprSearchCriteriaMapAttrGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RDV_API  Teamcenter::ApprSearchCriteriaMapAttr
     : public  ::Teamcenter::ApprSearchCriteria
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ApprSearchCriteriaMapAttr();

    /**
     * Destructor
     */
    virtual ~ApprSearchCriteriaMapAttr();

private:
    //  Getter method for the Implementation Object
    ApprSearchCriteriaMapAttrImpl*  getApprSearchCriteriaMapAttrImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setApprSearchCriteriaMapAttrImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ApprSearchCriteriaMapAttrImpl*  m_apprsearchcriteriamapattrImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ApprSearchCriteriaMapAttr - desc for ApprSearchCriteriaMapAttr parameter
     */
    ApprSearchCriteriaMapAttr( const ApprSearchCriteriaMapAttr& );
    ApprSearchCriteriaMapAttr& operator=( const ApprSearchCriteriaMapAttr& );

    friend class  ApprSearchCriteriaMapAttrDelegate;
    friend class  ApprSearchCriteriaMapAttrDispatch;
    friend class  ApprSearchCriteriaMapAttrGenImpl;
};

#include <rdv/librdv_undef.h>
#endif //   TEAMCENTER__APPRSEARCHCRITERIAMAPATTR__HXX
