//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprSearchCriteriaNamedZone
    Filename:   ApprSearchCriteriaNamedZone.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRSEARCHCRITERIANAMEDZONE__HXX
#define TEAMCENTER__APPRSEARCHCRITERIANAMEDZONE__HXX

#include <common/tc_deprecation_macros.h>
#include <rdv/ApprSearchCriteria.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class ApprSearchCriteriaNamedZone;
}
namespace Teamcenter
{
    class ApprSearchCriteriaNamedZoneImpl;
}
namespace Teamcenter
{
    class ApprSearchCriteriaNamedZoneDelegate;
}
namespace Teamcenter
{
    class ApprSearchCriteriaNamedZoneDispatch;
}
namespace Teamcenter
{
    class ApprSearchCriteriaNamedZoneGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RDV_API  Teamcenter::ApprSearchCriteriaNamedZone
     : public  ::Teamcenter::ApprSearchCriteria
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ApprSearchCriteriaNamedZone();

    /**
     * Destructor
     */
    virtual ~ApprSearchCriteriaNamedZone();

private:
    //  Getter method for the Implementation Object
    ApprSearchCriteriaNamedZoneImpl*  getApprSearchCriteriaNamedZoneImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setApprSearchCriteriaNamedZoneImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ApprSearchCriteriaNamedZoneImpl*  m_apprsearchcriterianamedzoneImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ApprSearchCriteriaNamedZone - desc for ApprSearchCriteriaNamedZone parameter
     */
    ApprSearchCriteriaNamedZone( const ApprSearchCriteriaNamedZone& );
    ApprSearchCriteriaNamedZone& operator=( const ApprSearchCriteriaNamedZone& );

    friend class  ApprSearchCriteriaNamedZoneDelegate;
    friend class  ApprSearchCriteriaNamedZoneDispatch;
    friend class  ApprSearchCriteriaNamedZoneGenImpl;
};

#include <rdv/librdv_undef.h>
#endif //   TEAMCENTER__APPRSEARCHCRITERIANAMEDZONE__HXX
