//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprSearchCriteriaPlaneZone
    Filename:   ApprSearchCriteriaPlaneZone.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRSEARCHCRITERIAPLANEZONE__HXX
#define TEAMCENTER__APPRSEARCHCRITERIAPLANEZONE__HXX

#include <common/tc_deprecation_macros.h>
#include <rdv/ApprSearchCriteria.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class ApprSearchCriteriaPlaneZone;
}
namespace Teamcenter
{
    class ApprSearchCriteriaPlaneZoneImpl;
}
namespace Teamcenter
{
    class ApprSearchCriteriaPlaneZoneDelegate;
}
namespace Teamcenter
{
    class ApprSearchCriteriaPlaneZoneDispatch;
}
namespace Teamcenter
{
    class ApprSearchCriteriaPlaneZoneGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RDV_API  Teamcenter::ApprSearchCriteriaPlaneZone
     : public  ::Teamcenter::ApprSearchCriteria
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ApprSearchCriteriaPlaneZone();

    /**
     * Destructor
     */
    virtual ~ApprSearchCriteriaPlaneZone();

private:
    //  Getter method for the Implementation Object
    ApprSearchCriteriaPlaneZoneImpl*  getApprSearchCriteriaPlaneZoneImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setApprSearchCriteriaPlaneZoneImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ApprSearchCriteriaPlaneZoneImpl*  m_apprsearchcriteriaplanezoneImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ApprSearchCriteriaPlaneZone - desc for ApprSearchCriteriaPlaneZone parameter
     */
    ApprSearchCriteriaPlaneZone( const ApprSearchCriteriaPlaneZone& );
    ApprSearchCriteriaPlaneZone& operator=( const ApprSearchCriteriaPlaneZone& );

    friend class  ApprSearchCriteriaPlaneZoneDelegate;
    friend class  ApprSearchCriteriaPlaneZoneDispatch;
    friend class  ApprSearchCriteriaPlaneZoneGenImpl;
};

#include <rdv/librdv_undef.h>
#endif //   TEAMCENTER__APPRSEARCHCRITERIAPLANEZONE__HXX
