//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprSearchCriteriaProximity
    Filename:   ApprSearchCriteriaProximity.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRSEARCHCRITERIAPROXIMITY__HXX
#define TEAMCENTER__APPRSEARCHCRITERIAPROXIMITY__HXX

#include <common/tc_deprecation_macros.h>
#include <rdv/ApprSearchCriteria.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class ApprSearchCriteriaProximity;
}
namespace Teamcenter
{
    class ApprSearchCriteriaProximityImpl;
}
namespace Teamcenter
{
    class ApprSearchCriteriaProximityDelegate;
}
namespace Teamcenter
{
    class ApprSearchCriteriaProximityDispatch;
}
namespace Teamcenter
{
    class ApprSearchCriteriaProximityGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RDV_API  Teamcenter::ApprSearchCriteriaProximity
     : public  ::Teamcenter::ApprSearchCriteria
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ApprSearchCriteriaProximity();

    /**
     * Destructor
     */
    virtual ~ApprSearchCriteriaProximity();

private:
    //  Getter method for the Implementation Object
    ApprSearchCriteriaProximityImpl*  getApprSearchCriteriaProximityImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setApprSearchCriteriaProximityImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ApprSearchCriteriaProximityImpl*  m_apprsearchcriteriaproximityImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ApprSearchCriteriaProximity - desc for ApprSearchCriteriaProximity parameter
     */
    ApprSearchCriteriaProximity( const ApprSearchCriteriaProximity& );
    ApprSearchCriteriaProximity& operator=( const ApprSearchCriteriaProximity& );

    friend class  ApprSearchCriteriaProximityDelegate;
    friend class  ApprSearchCriteriaProximityDispatch;
    friend class  ApprSearchCriteriaProximityGenImpl;
};

#include <rdv/librdv_undef.h>
#endif //   TEAMCENTER__APPRSEARCHCRITERIAPROXIMITY__HXX
