//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprSearchCriteriaSavedQry
    Filename:   ApprSearchCriteriaSavedQry.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRSEARCHCRITERIASAVEDQRY__HXX
#define TEAMCENTER__APPRSEARCHCRITERIASAVEDQRY__HXX

#include <common/tc_deprecation_macros.h>
#include <rdv/ApprSearchCriteria.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class ApprSearchCriteriaSavedQry;
}
namespace Teamcenter
{
    class ApprSearchCriteriaSavedQryImpl;
}
namespace Teamcenter
{
    class ApprSearchCriteriaSavedQryDelegate;
}
namespace Teamcenter
{
    class ApprSearchCriteriaSavedQryDispatch;
}
namespace Teamcenter
{
    class ApprSearchCriteriaSavedQryGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RDV_API  Teamcenter::ApprSearchCriteriaSavedQry
     : public  ::Teamcenter::ApprSearchCriteria
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ApprSearchCriteriaSavedQry();

    /**
     * Destructor
     */
    virtual ~ApprSearchCriteriaSavedQry();

private:
    //  Getter method for the Implementation Object
    ApprSearchCriteriaSavedQryImpl*  getApprSearchCriteriaSavedQryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setApprSearchCriteriaSavedQryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ApprSearchCriteriaSavedQryImpl*  m_apprsearchcriteriasavedqryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ApprSearchCriteriaSavedQry - desc for ApprSearchCriteriaSavedQry parameter
     */
    ApprSearchCriteriaSavedQry( const ApprSearchCriteriaSavedQry& );
    ApprSearchCriteriaSavedQry& operator=( const ApprSearchCriteriaSavedQry& );

    friend class  ApprSearchCriteriaSavedQryDelegate;
    friend class  ApprSearchCriteriaSavedQryDispatch;
    friend class  ApprSearchCriteriaSavedQryGenImpl;
};

#include <rdv/librdv_undef.h>
#endif //   TEAMCENTER__APPRSEARCHCRITERIASAVEDQRY__HXX
