//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprSearchCriteriaSlctState
    Filename:   ApprSearchCriteriaSlctState.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRSEARCHCRITERIASLCTSTATE__HXX
#define TEAMCENTER__APPRSEARCHCRITERIASLCTSTATE__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <rdv/ApprSearchCriteria.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class ApprSearchCriteriaSlctState;
}
namespace Teamcenter
{
    class ApprSearchCriteriaSlctStateImpl;
}
namespace Teamcenter
{
    class ApprSearchCriteriaSlctStateDelegate;
}
namespace Teamcenter
{
    class ApprSearchCriteriaSlctStateDispatch;
}
namespace Teamcenter
{
    class ApprSearchCriteriaSlctStateGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RDV_API  Teamcenter::ApprSearchCriteriaSlctState
     : public  ::Teamcenter::ApprSearchCriteria
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 8.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0selected_occ_list( std::vector< std::string > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 8.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0unselected_occ_list( std::vector< std::string > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 8.3
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0selected_occ_list( const std::vector< std::string > &values, const std::vector< int > *isNull=0 );

    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 8.3
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0unselected_occ_list( const std::vector< std::string > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ApprSearchCriteriaSlctState();

    /**
     * Destructor
     */
    virtual ~ApprSearchCriteriaSlctState();

private:
    //  Getter method for the Implementation Object
    ApprSearchCriteriaSlctStateImpl*  getApprSearchCriteriaSlctStateImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setApprSearchCriteriaSlctStateImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ApprSearchCriteriaSlctStateImpl*  m_apprsearchcriteriaslctstateImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ApprSearchCriteriaSlctState - desc for ApprSearchCriteriaSlctState parameter
     */
    ApprSearchCriteriaSlctState( const ApprSearchCriteriaSlctState& );
    ApprSearchCriteriaSlctState& operator=( const ApprSearchCriteriaSlctState& );

    friend class  ApprSearchCriteriaSlctStateDelegate;
    friend class  ApprSearchCriteriaSlctStateDispatch;
    friend class  ApprSearchCriteriaSlctStateGenImpl;
};

#include <rdv/librdv_undef.h>
#endif //   TEAMCENTER__APPRSEARCHCRITERIASLCTSTATE__HXX
