//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ApprSearchCriteriaSlctStateDelegate
    Filename:   ApprSearchCriteriaSlctStateDelegate.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__APPRSEARCHCRITERIASLCTSTATEDELEGATE_HXX
#define TEAMCENTER__APPRSEARCHCRITERIASLCTSTATEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <rdv/ApprSearchCriteriaSlctState.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class ApprSearchCriteriaSlctStateDelegate;
}
namespace Teamcenter
{
    class ApprSearchCriteriaSlctStateImpl;
}
namespace Teamcenter
{
    class ApprSearchCriteriaSlctState;
}
namespace Teamcenter
{
    class ApprSearchCriteriaSlctStateGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  RDV_API Teamcenter_alias::ApprSearchCriteriaSlctStateDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ApprSearchCriteriaSlctStateDelegate instance
    static ApprSearchCriteriaSlctStateDelegate&  getInstance();

    //  Method to create the ApprSearchCriteriaSlctStateImpl pointer
    static ApprSearchCriteriaSlctStateImpl*  createImpl( ApprSearchCriteriaSlctState&  ifObj );

    //  Method to delete the ApprSearchCriteriaSlctStateImpl pointer
    static void deleteImpl( ApprSearchCriteriaSlctStateImpl*  impl );


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 8.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0selected_occ_listBase(const ApprSearchCriteriaSlctState &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 8.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0unselected_occ_listBase(const ApprSearchCriteriaSlctState &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 8.3
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0selected_occ_listBase(ApprSearchCriteriaSlctState &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 8.3
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0unselected_occ_listBase(ApprSearchCriteriaSlctState &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );



protected:
    //  Pointer to the instance
    static ApprSearchCriteriaSlctStateDelegate*  m_pInstance;

    ApprSearchCriteriaSlctStateDelegate();
    virtual ~ApprSearchCriteriaSlctStateDelegate();
    static void setInstance( ApprSearchCriteriaSlctStateDelegate*  instance );


private:
    friend class  ::Teamcenter::ApprSearchCriteriaSlctStateGenImpl;

};

#include <rdv/librdv_undef.h>
#endif  //  TEAMCENTER__APPRSEARCHCRITERIASLCTSTATEDELEGATE_HXX
