//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Architecture
    Filename:   Architecture.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ARCHITECTURE__HXX
#define TEAMCENTER__ARCHITECTURE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class Architecture;
}
namespace Teamcenter
{
    class ArchitectureImpl;
}
namespace Teamcenter
{
    class ArchitectureDelegate;
}
namespace Teamcenter
{
    class ArchitectureDispatch;
}
namespace Teamcenter
{
    class ArchitectureGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RDV_API  Teamcenter::Architecture
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Architecture();

    /**
     * Destructor
     */
    virtual ~Architecture();

private:
    //  Getter method for the Implementation Object
    ArchitectureImpl*  getArchitectureImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setArchitectureImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ArchitectureImpl*  m_architectureImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Architecture - desc for Architecture parameter
     */
    Architecture( const Architecture& );
    Architecture& operator=( const Architecture& );

    friend class  ArchitectureDelegate;
    friend class  ArchitectureDispatch;
    friend class  ArchitectureGenImpl;
};

#include <rdv/librdv_undef.h>
#endif //   TEAMCENTER__ARCHITECTURE__HXX
