//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ArchitectureDelegate
    Filename:   ArchitectureDelegate.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ARCHITECTUREDELEGATE_HXX
#define TEAMCENTER__ARCHITECTUREDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <rdv/Architecture.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class ArchitectureDelegate;
}
namespace Teamcenter
{
    class ArchitectureImpl;
}
namespace Teamcenter
{
    class Architecture;
}
namespace Teamcenter
{
    class ArchitectureGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  RDV_API Teamcenter_alias::ArchitectureDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ArchitectureDelegate instance
    static ArchitectureDelegate&  getInstance();

    //  Method to create the ArchitectureImpl pointer
    static ArchitectureImpl*  createImpl( Architecture&  ifObj );

    //  Method to delete the ArchitectureImpl pointer
    static void deleteImpl( ArchitectureImpl*  impl );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Architecture &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// finalize operation input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  finalizeSaveAsInputBase(const Architecture &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// Generic saveAsPost operation.
    /// @version Teamcenter 8.1
    /// @param pSavAsInput - Input argument as SaveAsInput object.
    /// @param vecDeepCopyData - vector deepcopy data
    /// @return - Return integer value.
    ///
    int  saveAsPostBase(const Architecture &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const Architecture &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Architecture &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static ArchitectureDelegate*  m_pInstance;

    ArchitectureDelegate();
    virtual ~ArchitectureDelegate();
    static void setInstance( ArchitectureDelegate*  instance );


private:
    friend class  ::Teamcenter::ArchitectureGenImpl;

};

#include <rdv/librdv_undef.h>
#endif  //  TEAMCENTER__ARCHITECTUREDELEGATE_HXX
