//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ArchitectureRevision
    Filename:   ArchitectureRevision.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ARCHITECTUREREVISION__HXX
#define TEAMCENTER__ARCHITECTUREREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class ArchitectureRevision;
}
namespace Teamcenter
{
    class ArchitectureRevisionImpl;
}
namespace Teamcenter
{
    class ArchitectureRevisionDelegate;
}
namespace Teamcenter
{
    class ArchitectureRevisionDispatch;
}
namespace Teamcenter
{
    class ArchitectureRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RDV_API  Teamcenter::ArchitectureRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ArchitectureRevision();

    /**
     * Destructor
     */
    virtual ~ArchitectureRevision();

private:
    //  Getter method for the Implementation Object
    ArchitectureRevisionImpl*  getArchitectureRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setArchitectureRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ArchitectureRevisionImpl*  m_architecturerevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ArchitectureRevision - desc for ArchitectureRevision parameter
     */
    ArchitectureRevision( const ArchitectureRevision& );
    ArchitectureRevision& operator=( const ArchitectureRevision& );

    friend class  ArchitectureRevisionDelegate;
    friend class  ArchitectureRevisionDispatch;
    friend class  ArchitectureRevisionGenImpl;
};

#include <rdv/librdv_undef.h>
#endif //   TEAMCENTER__ARCHITECTUREREVISION__HXX
