//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AuditLine
    Filename:   AuditLine.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__AUDITLINE__HXX
#define TEAMCENTER__AUDITLINE__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class AuditLine;
}
namespace Teamcenter
{
    class AuditLineImpl;
}
namespace Teamcenter
{
    class AuditLineDelegate;
}
namespace Teamcenter
{
    class AuditLineDispatch;
}
namespace Teamcenter
{
    class AuditLineGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RDV_API  Teamcenter::AuditLine
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AuditLine();

    /**
     * Destructor
     */
    virtual ~AuditLine();

private:
    //  Getter method for the Implementation Object
    AuditLineImpl*  getAuditLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAuditLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AuditLineImpl*  m_auditlineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AuditLine - desc for AuditLine parameter
     */
    AuditLine( const AuditLine& );
    AuditLine& operator=( const AuditLine& );

    friend class  AuditLineDelegate;
    friend class  AuditLineDispatch;
    friend class  AuditLineGenImpl;
};

#include <rdv/librdv_undef.h>
#endif //   TEAMCENTER__AUDITLINE__HXX
