//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AuditReport
    Filename:   AuditReport.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__AUDITREPORT__HXX
#define TEAMCENTER__AUDITREPORT__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class AuditReport;
}
namespace Teamcenter
{
    class AuditReportImpl;
}
namespace Teamcenter
{
    class AuditReportDelegate;
}
namespace Teamcenter
{
    class AuditReportDispatch;
}
namespace Teamcenter
{
    class AuditReportGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RDV_API  Teamcenter::AuditReport
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AuditReport();

    /**
     * Destructor
     */
    virtual ~AuditReport();

private:
    //  Getter method for the Implementation Object
    AuditReportImpl*  getAuditReportImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAuditReportImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AuditReportImpl*  m_auditreportImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AuditReport - desc for AuditReport parameter
     */
    AuditReport( const AuditReport& );
    AuditReport& operator=( const AuditReport& );

    friend class  AuditReportDelegate;
    friend class  AuditReportDispatch;
    friend class  AuditReportGenImpl;
};

#include <rdv/librdv_undef.h>
#endif //   TEAMCENTER__AUDITREPORT__HXX
