//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0AppSession
    Filename:   Fnd0AppSession.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0APPSESSION__HXX
#define TEAMCENTER__FND0APPSESSION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class Fnd0AppSession;
}
namespace Teamcenter
{
    class Fnd0AppSessionImpl;
}
namespace Teamcenter
{
    class Fnd0AppSessionDelegate;
}
namespace Teamcenter
{
    class Fnd0AppSessionDispatch;
}
namespace Teamcenter
{
    class Fnd0AppSessionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RDV_API  Teamcenter::Fnd0AppSession
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 12.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0AllowReadShare( bool &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 12.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0AllowWriteShare( bool &value, bool &isNull ) const;

    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 12.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0AllowReadShare( bool value, bool isNull=false );

    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 12.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0AllowWriteShare( bool value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0AppSession();

    /**
     * Destructor
     */
    virtual ~Fnd0AppSession();

private:
    //  Getter method for the Implementation Object
    Fnd0AppSessionImpl*  getFnd0AppSessionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0AppSessionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0AppSessionImpl*  m_fnd0appsessionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0AppSession - desc for Fnd0AppSession parameter
     */
    Fnd0AppSession( const Fnd0AppSession& );
    Fnd0AppSession& operator=( const Fnd0AppSession& );

    friend class  Fnd0AppSessionDelegate;
    friend class  Fnd0AppSessionDispatch;
    friend class  Fnd0AppSessionGenImpl;
};

#include <rdv/librdv_undef.h>
#endif //   TEAMCENTER__FND0APPSESSION__HXX
