//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0AppSessionDelegate
    Filename:   Fnd0AppSessionDelegate.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0APPSESSIONDELEGATE_HXX
#define TEAMCENTER__FND0APPSESSIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <rdv/Fnd0AppSession.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class Fnd0AppSessionDelegate;
}
namespace Teamcenter
{
    class Fnd0AppSessionImpl;
}
namespace Teamcenter
{
    class Fnd0AppSession;
}
namespace Teamcenter
{
    class Fnd0AppSessionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  RDV_API Teamcenter_alias::Fnd0AppSessionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0AppSessionDelegate instance
    static Fnd0AppSessionDelegate&  getInstance();

    //  Method to create the Fnd0AppSessionImpl pointer
    static Fnd0AppSessionImpl*  createImpl( Fnd0AppSession&  ifObj );

    //  Method to delete the Fnd0AppSessionImpl pointer
    static void deleteImpl( Fnd0AppSessionImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 12.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0AllowReadShareBase(const Fnd0AppSession &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 12.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0AllowWriteShareBase(const Fnd0AppSession &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 12.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0AllowReadShareBase(Fnd0AppSession &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 12.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0AllowWriteShareBase(Fnd0AppSession &ifObj,  bool value, bool isNull );


    ///
    /// This operation deletes inputs objects in bulk. It either deletes none of the input objects or deletes all the input objects. It doesn't support partial deletion.
    /// @version Teamcenter 11.6
    /// @param inputs - A vector of data that contains reference to the object to be deleted.
    /// @param bd - A data structure to store objects and other information relevant for set-based operation.
    /// @return - Returns ITK_ok on Success. Otherwise, returns the specific error code.
    ///
    int  fnd0BulkDeleteBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Fnd0AppSession &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// setproperties from saveas input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @return - returns an int
    ///
    int  setPropertiesFromSaveAsInputBase(const Fnd0AppSession &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput );



protected:
    //  Pointer to the instance
    static Fnd0AppSessionDelegate*  m_pInstance;

    Fnd0AppSessionDelegate();
    virtual ~Fnd0AppSessionDelegate();
    static void setInstance( Fnd0AppSessionDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0AppSessionGenImpl;

};

#include <rdv/librdv_undef.h>
#endif  //  TEAMCENTER__FND0APPSESSIONDELEGATE_HXX
