//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ApprSchCriteriaFormAttrDelegate
    Filename:   Fnd0ApprSchCriteriaFormAttrDelegate.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0APPRSCHCRITERIAFORMATTRDELEGATE_HXX
#define TEAMCENTER__FND0APPRSCHCRITERIAFORMATTRDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <rdv/Fnd0ApprSchCriteriaFormAttr.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class Fnd0ApprSchCriteriaFormAttrDelegate;
}
namespace Teamcenter
{
    class Fnd0ApprSchCriteriaFormAttrImpl;
}
namespace Teamcenter
{
    class Fnd0ApprSchCriteriaFormAttr;
}
namespace Teamcenter
{
    class Fnd0ApprSchCriteriaFormAttrGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  RDV_API Teamcenter_alias::Fnd0ApprSchCriteriaFormAttrDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0ApprSchCriteriaFormAttrDelegate instance
    static Fnd0ApprSchCriteriaFormAttrDelegate&  getInstance();

    //  Method to create the Fnd0ApprSchCriteriaFormAttrImpl pointer
    static Fnd0ApprSchCriteriaFormAttrImpl*  createImpl( Fnd0ApprSchCriteriaFormAttr&  ifObj );

    //  Method to delete the Fnd0ApprSchCriteriaFormAttrImpl pointer
    static void deleteImpl( Fnd0ApprSchCriteriaFormAttrImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0form_typeBase(const Fnd0ApprSchCriteriaFormAttr &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0logical_oprBase(const Fnd0ApprSchCriteriaFormAttr &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0math_oprBase(const Fnd0ApprSchCriteriaFormAttr &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0object_stringBase(const Fnd0ApprSchCriteriaFormAttr &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0parent_typeBase(const Fnd0ApprSchCriteriaFormAttr &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0prop_nameBase(const Fnd0ApprSchCriteriaFormAttr &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0prop_typeBase(const Fnd0ApprSchCriteriaFormAttr &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0relation_typeBase(const Fnd0ApprSchCriteriaFormAttr &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 10
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0valueBase(const Fnd0ApprSchCriteriaFormAttr &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0form_typeBase(Fnd0ApprSchCriteriaFormAttr &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0logical_oprBase(Fnd0ApprSchCriteriaFormAttr &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0math_oprBase(Fnd0ApprSchCriteriaFormAttr &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0parent_typeBase(Fnd0ApprSchCriteriaFormAttr &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0prop_nameBase(Fnd0ApprSchCriteriaFormAttr &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0prop_typeBase(Fnd0ApprSchCriteriaFormAttr &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0relation_typeBase(Fnd0ApprSchCriteriaFormAttr &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 10
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0valueBase(Fnd0ApprSchCriteriaFormAttr &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );



protected:
    //  Pointer to the instance
    static Fnd0ApprSchCriteriaFormAttrDelegate*  m_pInstance;

    Fnd0ApprSchCriteriaFormAttrDelegate();
    virtual ~Fnd0ApprSchCriteriaFormAttrDelegate();
    static void setInstance( Fnd0ApprSchCriteriaFormAttrDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0ApprSchCriteriaFormAttrGenImpl;

};

#include <rdv/librdv_undef.h>
#endif  //  TEAMCENTER__FND0APPRSCHCRITERIAFORMATTRDELEGATE_HXX
