//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ApprSchCriteriaScpAttr
    Filename:   Fnd0ApprSchCriteriaScpAttr.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0APPRSCHCRITERIASCPATTR__HXX
#define TEAMCENTER__FND0APPRSCHCRITERIASCPATTR__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <rdv/ApprSearchCriteria.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class Fnd0ApprSchCriteriaScpAttr;
}
namespace Teamcenter
{
    class Fnd0ApprSchCriteriaScpAttrImpl;
}
namespace Teamcenter
{
    class Fnd0ApprSchCriteriaScpAttrDelegate;
}
namespace Teamcenter
{
    class Fnd0ApprSchCriteriaScpAttrDispatch;
}
namespace Teamcenter
{
    class Fnd0ApprSchCriteriaScpAttrGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RDV_API  Teamcenter::Fnd0ApprSchCriteriaScpAttr
     : public  ::Teamcenter::ApprSearchCriteria
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 10
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0occ_list( std::vector< std::string > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 10
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0occ_list( const std::vector< std::string > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0ApprSchCriteriaScpAttr();

    /**
     * Destructor
     */
    virtual ~Fnd0ApprSchCriteriaScpAttr();

private:
    //  Getter method for the Implementation Object
    Fnd0ApprSchCriteriaScpAttrImpl*  getFnd0ApprSchCriteriaScpAttrImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0ApprSchCriteriaScpAttrImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0ApprSchCriteriaScpAttrImpl*  m_fnd0apprschcriteriascpattrImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0ApprSchCriteriaScpAttr - desc for Fnd0ApprSchCriteriaScpAttr parameter
     */
    Fnd0ApprSchCriteriaScpAttr( const Fnd0ApprSchCriteriaScpAttr& );
    Fnd0ApprSchCriteriaScpAttr& operator=( const Fnd0ApprSchCriteriaScpAttr& );

    friend class  Fnd0ApprSchCriteriaScpAttrDelegate;
    friend class  Fnd0ApprSchCriteriaScpAttrDispatch;
    friend class  Fnd0ApprSchCriteriaScpAttrGenImpl;
};

#include <rdv/librdv_undef.h>
#endif //   TEAMCENTER__FND0APPRSCHCRITERIASCPATTR__HXX
