//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0BomLineSearchCriteria
    Filename:   Fnd0BomLineSearchCriteria.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0BOMLINESEARCHCRITERIA__HXX
#define TEAMCENTER__FND0BOMLINESEARCHCRITERIA__HXX

#include <common/tc_deprecation_macros.h>
#include <rdv/ApprSearchCriteria.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class Fnd0BomLineSearchCriteria;
}
namespace Teamcenter
{
    class Fnd0BomLineSearchCriteriaImpl;
}
namespace Teamcenter
{
    class Fnd0BomLineSearchCriteriaDelegate;
}
namespace Teamcenter
{
    class Fnd0BomLineSearchCriteriaDispatch;
}
namespace Teamcenter
{
    class Fnd0BomLineSearchCriteriaGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RDV_API  Teamcenter::Fnd0BomLineSearchCriteria
     : public  ::Teamcenter::ApprSearchCriteria
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0BomLineSearchCriteria();

    /**
     * Destructor
     */
    virtual ~Fnd0BomLineSearchCriteria();

private:
    //  Getter method for the Implementation Object
    Fnd0BomLineSearchCriteriaImpl*  getFnd0BomLineSearchCriteriaImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0BomLineSearchCriteriaImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0BomLineSearchCriteriaImpl*  m_fnd0bomlinesearchcriteriaImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0BomLineSearchCriteria - desc for Fnd0BomLineSearchCriteria parameter
     */
    Fnd0BomLineSearchCriteria( const Fnd0BomLineSearchCriteria& );
    Fnd0BomLineSearchCriteria& operator=( const Fnd0BomLineSearchCriteria& );

    friend class  Fnd0BomLineSearchCriteriaDelegate;
    friend class  Fnd0BomLineSearchCriteriaDispatch;
    friend class  Fnd0BomLineSearchCriteriaGenImpl;
};

#include <rdv/librdv_undef.h>
#endif //   TEAMCENTER__FND0BOMLINESEARCHCRITERIA__HXX
