//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0FilterRecipe
    Filename:   Fnd0FilterRecipe.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0FILTERRECIPE__HXX
#define TEAMCENTER__FND0FILTERRECIPE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Fnd0ProductSessionData.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class Fnd0FilterRecipe;
}
namespace Teamcenter
{
    class Fnd0FilterRecipeImpl;
}
namespace Teamcenter
{
    class Fnd0FilterRecipeDelegate;
}
namespace Teamcenter
{
    class Fnd0FilterRecipeDispatch;
}
namespace Teamcenter
{
    class Fnd0FilterRecipeGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RDV_API  Teamcenter::Fnd0FilterRecipe
     : public  ::Teamcenter::Fnd0ProductSessionData
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0FilterRecipe();

    /**
     * Destructor
     */
    virtual ~Fnd0FilterRecipe();

private:
    //  Getter method for the Implementation Object
    Fnd0FilterRecipeImpl*  getFnd0FilterRecipeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0FilterRecipeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0FilterRecipeImpl*  m_fnd0filterrecipeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0FilterRecipe - desc for Fnd0FilterRecipe parameter
     */
    Fnd0FilterRecipe( const Fnd0FilterRecipe& );
    Fnd0FilterRecipe& operator=( const Fnd0FilterRecipe& );

    friend class  Fnd0FilterRecipeDelegate;
    friend class  Fnd0FilterRecipeDispatch;
    friend class  Fnd0FilterRecipeGenImpl;
};

#include <rdv/librdv_undef.h>
#endif //   TEAMCENTER__FND0FILTERRECIPE__HXX
