//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ProxyBOMLine
    Filename:   Fnd0ProxyBOMLine.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0PROXYBOMLINE__HXX
#define TEAMCENTER__FND0PROXYBOMLINE__HXX

#include <common/tc_deprecation_macros.h>
#include <bom/Fnd0AbstractProxyLine.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class Fnd0ProxyBOMLine;
}
namespace Teamcenter
{
    class Fnd0ProxyBOMLineImpl;
}
namespace Teamcenter
{
    class Fnd0ProxyBOMLineDelegate;
}
namespace Teamcenter
{
    class Fnd0ProxyBOMLineDispatch;
}
namespace Teamcenter
{
    class Fnd0ProxyBOMLineGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RDV_API  Teamcenter::Fnd0ProxyBOMLine
     : public  ::Teamcenter::Fnd0AbstractProxyLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0ProxyBOMLine();

    /**
     * Destructor
     */
    virtual ~Fnd0ProxyBOMLine();

private:
    //  Getter method for the Implementation Object
    Fnd0ProxyBOMLineImpl*  getFnd0ProxyBOMLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0ProxyBOMLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0ProxyBOMLineImpl*  m_fnd0proxybomlineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0ProxyBOMLine - desc for Fnd0ProxyBOMLine parameter
     */
    Fnd0ProxyBOMLine( const Fnd0ProxyBOMLine& );
    Fnd0ProxyBOMLine& operator=( const Fnd0ProxyBOMLine& );

    friend class  Fnd0ProxyBOMLineDelegate;
    friend class  Fnd0ProxyBOMLineDispatch;
    friend class  Fnd0ProxyBOMLineGenImpl;
};

#include <rdv/librdv_undef.h>
#endif //   TEAMCENTER__FND0PROXYBOMLINE__HXX
