//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0StructureContext
    Filename:   Fnd0StructureContext.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0STRUCTURECONTEXT__HXX
#define TEAMCENTER__FND0STRUCTURECONTEXT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Fnd0ProductSessionData.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class Fnd0StructureContext;
}
namespace Teamcenter
{
    class Fnd0StructureContextImpl;
}
namespace Teamcenter
{
    class Fnd0StructureContextDelegate;
}
namespace Teamcenter
{
    class Fnd0StructureContextDispatch;
}
namespace Teamcenter
{
    class Fnd0StructureContextGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RDV_API  Teamcenter::Fnd0StructureContext
     : public  ::Teamcenter::Fnd0ProductSessionData
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0StructureContext();

    /**
     * Destructor
     */
    virtual ~Fnd0StructureContext();

private:
    //  Getter method for the Implementation Object
    Fnd0StructureContextImpl*  getFnd0StructureContextImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0StructureContextImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0StructureContextImpl*  m_fnd0structurecontextImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0StructureContext - desc for Fnd0StructureContext parameter
     */
    Fnd0StructureContext( const Fnd0StructureContext& );
    Fnd0StructureContext& operator=( const Fnd0StructureContext& );

    friend class  Fnd0StructureContextDelegate;
    friend class  Fnd0StructureContextDispatch;
    friend class  Fnd0StructureContextGenImpl;
};

#include <rdv/librdv_undef.h>
#endif //   TEAMCENTER__FND0STRUCTURECONTEXT__HXX
