//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0SubsetLine
    Filename:   Fnd0SubsetLine.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0SUBSETLINE__HXX
#define TEAMCENTER__FND0SUBSETLINE__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <bom/Fnd0AbstractProxyLine.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class Fnd0SubsetLine;
}
namespace Teamcenter
{
    class Fnd0SubsetLineImpl;
}
namespace Teamcenter
{
    class Fnd0SubsetLineDelegate;
}
namespace Teamcenter
{
    class Fnd0SubsetLineDispatch;
}
namespace Teamcenter
{
    class Fnd0SubsetLineGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RDV_API  Teamcenter::Fnd0SubsetLine
     : public  ::Teamcenter::Fnd0AbstractProxyLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0subsetSourceWindow( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 12.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0subsetSourceWindow( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0SubsetLine();

    /**
     * Destructor
     */
    virtual ~Fnd0SubsetLine();

private:
    //  Getter method for the Implementation Object
    Fnd0SubsetLineImpl*  getFnd0SubsetLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0SubsetLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0SubsetLineImpl*  m_fnd0subsetlineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0SubsetLine - desc for Fnd0SubsetLine parameter
     */
    Fnd0SubsetLine( const Fnd0SubsetLine& );
    Fnd0SubsetLine& operator=( const Fnd0SubsetLine& );

    friend class  Fnd0SubsetLineDelegate;
    friend class  Fnd0SubsetLineDispatch;
    friend class  Fnd0SubsetLineGenImpl;
};

#include <rdv/librdv_undef.h>
#endif //   TEAMCENTER__FND0SUBSETLINE__HXX
