//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0SubsetLineDelegate
    Filename:   Fnd0SubsetLineDelegate.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0SUBSETLINEDELEGATE_HXX
#define TEAMCENTER__FND0SUBSETLINEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <rdv/Fnd0SubsetLine.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class Fnd0SubsetLineDelegate;
}
namespace Teamcenter
{
    class Fnd0SubsetLineImpl;
}
namespace Teamcenter
{
    class Fnd0SubsetLine;
}
namespace Teamcenter
{
    class Fnd0SubsetLineGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  RDV_API Teamcenter_alias::Fnd0SubsetLineDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0SubsetLineDelegate instance
    static Fnd0SubsetLineDelegate&  getInstance();

    //  Method to create the Fnd0SubsetLineImpl pointer
    static Fnd0SubsetLineImpl*  createImpl( Fnd0SubsetLine&  ifObj );

    //  Method to delete the Fnd0SubsetLineImpl pointer
    static void deleteImpl( Fnd0SubsetLineImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 12.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0subsetSourceWindowBase(const Fnd0SubsetLine &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 12.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0subsetSourceWindowBase(Fnd0SubsetLine &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Generates permanent ID/recipe. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param recipe - Permanent ID/recipe
    /// @return - Failure code.
    ///
    int  fnd0GenerateRecipeBase(const Fnd0SubsetLine &ifObj,  std::string *recipe );



protected:
    //  Pointer to the instance
    static Fnd0SubsetLineDelegate*  m_pInstance;

    Fnd0SubsetLineDelegate();
    virtual ~Fnd0SubsetLineDelegate();
    static void setInstance( Fnd0SubsetLineDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0SubsetLineGenImpl;

};

#include <rdv/librdv_undef.h>
#endif  //  TEAMCENTER__FND0SUBSETLINEDELEGATE_HXX
