//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0TempAppSession
    Filename:   Fnd0TempAppSession.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0TEMPAPPSESSION__HXX
#define TEAMCENTER__FND0TEMPAPPSESSION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class Fnd0TempAppSession;
}
namespace Teamcenter
{
    class Fnd0TempAppSessionImpl;
}
namespace Teamcenter
{
    class Fnd0TempAppSessionDelegate;
}
namespace Teamcenter
{
    class Fnd0TempAppSessionDispatch;
}
namespace Teamcenter
{
    class Fnd0TempAppSessionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RDV_API  Teamcenter::Fnd0TempAppSession
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0TempAppSession();

    /**
     * Destructor
     */
    virtual ~Fnd0TempAppSession();

private:
    //  Getter method for the Implementation Object
    Fnd0TempAppSessionImpl*  getFnd0TempAppSessionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0TempAppSessionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0TempAppSessionImpl*  m_fnd0tempappsessionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0TempAppSession - desc for Fnd0TempAppSession parameter
     */
    Fnd0TempAppSession( const Fnd0TempAppSession& );
    Fnd0TempAppSession& operator=( const Fnd0TempAppSession& );

    friend class  Fnd0TempAppSessionDelegate;
    friend class  Fnd0TempAppSessionDispatch;
    friend class  Fnd0TempAppSessionGenImpl;
};

#include <rdv/librdv_undef.h>
#endif //   TEAMCENTER__FND0TEMPAPPSESSION__HXX
