//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0TempAppSessionDelegate
    Filename:   Fnd0TempAppSessionDelegate.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0TEMPAPPSESSIONDELEGATE_HXX
#define TEAMCENTER__FND0TEMPAPPSESSIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <rdv/Fnd0TempAppSession.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class Fnd0TempAppSessionDelegate;
}
namespace Teamcenter
{
    class Fnd0TempAppSessionImpl;
}
namespace Teamcenter
{
    class Fnd0TempAppSession;
}
namespace Teamcenter
{
    class Fnd0TempAppSessionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  RDV_API Teamcenter_alias::Fnd0TempAppSessionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0TempAppSessionDelegate instance
    static Fnd0TempAppSessionDelegate&  getInstance();

    //  Method to create the Fnd0TempAppSessionImpl pointer
    static Fnd0TempAppSessionImpl*  createImpl( Fnd0TempAppSession&  ifObj );

    //  Method to delete the Fnd0TempAppSessionImpl pointer
    static void deleteImpl( Fnd0TempAppSessionImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be created
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0FinalizeCreateInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation deletes inputs objects in bulk. It either deletes none of the input objects or deletes all the input objects. It doesn't support partial deletion.
    /// @version Teamcenter 11.6
    /// @param inputs - A vector of data that contains reference to the object to be deleted.
    /// @param bd - A data structure to store objects and other information relevant for set-based operation.
    /// @return - Returns ITK_ok on Success. Otherwise, returns the specific error code.
    ///
    int  fnd0BulkDeleteBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Fnd0TempAppSession &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Fnd0TempAppSession &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Fnd0TempAppSessionDelegate*  m_pInstance;

    Fnd0TempAppSessionDelegate();
    virtual ~Fnd0TempAppSessionDelegate();
    static void setInstance( Fnd0TempAppSessionDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0TempAppSessionGenImpl;

};

#include <rdv/librdv_undef.h>
#endif  //  TEAMCENTER__FND0TEMPAPPSESSIONDELEGATE_HXX
