//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0Workset
    Filename:   Fnd0Workset.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0WORKSET__HXX
#define TEAMCENTER__FND0WORKSET__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class Fnd0Workset;
}
namespace Teamcenter
{
    class Fnd0WorksetImpl;
}
namespace Teamcenter
{
    class Fnd0WorksetDelegate;
}
namespace Teamcenter
{
    class Fnd0WorksetDispatch;
}
namespace Teamcenter
{
    class Fnd0WorksetGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RDV_API  Teamcenter::Fnd0Workset
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0Workset();

    /**
     * Destructor
     */
    virtual ~Fnd0Workset();

private:
    //  Getter method for the Implementation Object
    Fnd0WorksetImpl*  getFnd0WorksetImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0WorksetImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0WorksetImpl*  m_fnd0worksetImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0Workset - desc for Fnd0Workset parameter
     */
    Fnd0Workset( const Fnd0Workset& );
    Fnd0Workset& operator=( const Fnd0Workset& );

    friend class  Fnd0WorksetDelegate;
    friend class  Fnd0WorksetDispatch;
    friend class  Fnd0WorksetGenImpl;
};

#include <rdv/librdv_undef.h>
#endif //   TEAMCENTER__FND0WORKSET__HXX
