//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0WorksetLine
    Filename:   Fnd0WorksetLine.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0WORKSETLINE__HXX
#define TEAMCENTER__FND0WORKSETLINE__HXX

#include <common/tc_deprecation_macros.h>
#include <bom/ImanItemLine.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class Fnd0WorksetLine;
}
namespace Teamcenter
{
    class Fnd0WorksetLineImpl;
}
namespace Teamcenter
{
    class Fnd0WorksetLineDelegate;
}
namespace Teamcenter
{
    class Fnd0WorksetLineDispatch;
}
namespace Teamcenter
{
    class Fnd0WorksetLineGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RDV_API  Teamcenter::Fnd0WorksetLine
     : public  ::Teamcenter::ImanItemLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0WorksetLine();

    /**
     * Destructor
     */
    virtual ~Fnd0WorksetLine();

private:
    //  Getter method for the Implementation Object
    Fnd0WorksetLineImpl*  getFnd0WorksetLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0WorksetLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0WorksetLineImpl*  m_fnd0worksetlineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0WorksetLine - desc for Fnd0WorksetLine parameter
     */
    Fnd0WorksetLine( const Fnd0WorksetLine& );
    Fnd0WorksetLine& operator=( const Fnd0WorksetLine& );

    friend class  Fnd0WorksetLineDelegate;
    friend class  Fnd0WorksetLineDispatch;
    friend class  Fnd0WorksetLineGenImpl;
};

#include <rdv/librdv_undef.h>
#endif //   TEAMCENTER__FND0WORKSETLINE__HXX
