//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0WorksetRevision
    Filename:   Fnd0WorksetRevision.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0WORKSETREVISION__HXX
#define TEAMCENTER__FND0WORKSETREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class Fnd0WorksetRevision;
}
namespace Teamcenter
{
    class Fnd0WorksetRevisionImpl;
}
namespace Teamcenter
{
    class Fnd0WorksetRevisionDelegate;
}
namespace Teamcenter
{
    class Fnd0WorksetRevisionDispatch;
}
namespace Teamcenter
{
    class Fnd0WorksetRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RDV_API  Teamcenter::Fnd0WorksetRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0WorksetRevision();

    /**
     * Destructor
     */
    virtual ~Fnd0WorksetRevision();

private:
    //  Getter method for the Implementation Object
    Fnd0WorksetRevisionImpl*  getFnd0WorksetRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0WorksetRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0WorksetRevisionImpl*  m_fnd0worksetrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0WorksetRevision - desc for Fnd0WorksetRevision parameter
     */
    Fnd0WorksetRevision( const Fnd0WorksetRevision& );
    Fnd0WorksetRevision& operator=( const Fnd0WorksetRevision& );

    friend class  Fnd0WorksetRevisionDelegate;
    friend class  Fnd0WorksetRevisionDispatch;
    friend class  Fnd0WorksetRevisionGenImpl;
};

#include <rdv/librdv_undef.h>
#endif //   TEAMCENTER__FND0WORKSETREVISION__HXX
