//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, LineOfUsage
    Filename:   LineOfUsage.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LINEOFUSAGE__HXX
#define TEAMCENTER__LINEOFUSAGE__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class LineOfUsage;
}
namespace Teamcenter
{
    class LineOfUsageImpl;
}
namespace Teamcenter
{
    class LineOfUsageDelegate;
}
namespace Teamcenter
{
    class LineOfUsageDispatch;
}
namespace Teamcenter
{
    class LineOfUsageGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RDV_API  Teamcenter::LineOfUsage
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    LineOfUsage();

    /**
     * Destructor
     */
    virtual ~LineOfUsage();

private:
    //  Getter method for the Implementation Object
    LineOfUsageImpl*  getLineOfUsageImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLineOfUsageImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    LineOfUsageImpl*  m_lineofusageImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param LineOfUsage - desc for LineOfUsage parameter
     */
    LineOfUsage( const LineOfUsage& );
    LineOfUsage& operator=( const LineOfUsage& );

    friend class  LineOfUsageDelegate;
    friend class  LineOfUsageDispatch;
    friend class  LineOfUsageGenImpl;
};

#include <rdv/librdv_undef.h>
#endif //   TEAMCENTER__LINEOFUSAGE__HXX
