//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0ApprCompositeSearch
    Filename:   Mdl0ApprCompositeSearch.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MDL0APPRCOMPOSITESEARCH__HXX
#define TEAMCENTER__MDL0APPRCOMPOSITESEARCH__HXX

#include <vector>
#include <string>
#include <common/tc_deprecation_macros.h>
#include <rdv/ApprSearchCriteria.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class Mdl0ApprCompositeSearch;
}
namespace Teamcenter
{
    class Mdl0ApprCompositeSearchImpl;
}
namespace Teamcenter
{
    class Mdl0ApprCompositeSearchDelegate;
}
namespace Teamcenter
{
    class Mdl0ApprCompositeSearchDispatch;
}
namespace Teamcenter
{
    class Mdl0ApprCompositeSearchGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RDV_API  Teamcenter::Mdl0ApprCompositeSearch
     : public  ::Teamcenter::ApprSearchCriteria
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0CompositeSearchCriteria( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0CompositeSearchType( std::string &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdl0ApprCompositeSearch();

    /**
     * Destructor
     */
    virtual ~Mdl0ApprCompositeSearch();

private:
    //  Getter method for the Implementation Object
    Mdl0ApprCompositeSearchImpl*  getMdl0ApprCompositeSearchImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdl0ApprCompositeSearchImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdl0ApprCompositeSearchImpl*  m_mdl0apprcompositesearchImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdl0ApprCompositeSearch - desc for Mdl0ApprCompositeSearch parameter
     */
    Mdl0ApprCompositeSearch( const Mdl0ApprCompositeSearch& );
    Mdl0ApprCompositeSearch& operator=( const Mdl0ApprCompositeSearch& );

    friend class  Mdl0ApprCompositeSearchDelegate;
    friend class  Mdl0ApprCompositeSearchDispatch;
    friend class  Mdl0ApprCompositeSearchGenImpl;
};

#include <rdv/librdv_undef.h>
#endif //   TEAMCENTER__MDL0APPRCOMPOSITESEARCH__HXX
