//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0ApprCompositeSearchDelegate
    Filename:   Mdl0ApprCompositeSearchDelegate.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MDL0APPRCOMPOSITESEARCHDELEGATE_HXX
#define TEAMCENTER__MDL0APPRCOMPOSITESEARCHDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <rdv/Mdl0ApprCompositeSearch.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class Mdl0ApprCompositeSearchDelegate;
}
namespace Teamcenter
{
    class Mdl0ApprCompositeSearchImpl;
}
namespace Teamcenter
{
    class Mdl0ApprCompositeSearch;
}
namespace Teamcenter
{
    class Mdl0ApprCompositeSearchGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  RDV_API Teamcenter_alias::Mdl0ApprCompositeSearchDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Mdl0ApprCompositeSearchDelegate instance
    static Mdl0ApprCompositeSearchDelegate&  getInstance();

    //  Method to create the Mdl0ApprCompositeSearchImpl pointer
    static Mdl0ApprCompositeSearchImpl*  createImpl( Mdl0ApprCompositeSearch&  ifObj );

    //  Method to delete the Mdl0ApprCompositeSearchImpl pointer
    static void deleteImpl( Mdl0ApprCompositeSearchImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0CompositeSearchCriteriaBase(const Mdl0ApprCompositeSearch &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMdl0CompositeSearchTypeBase(const Mdl0ApprCompositeSearch &ifObj,  std::string &value, bool &isNull ) const;



protected:
    //  Pointer to the instance
    static Mdl0ApprCompositeSearchDelegate*  m_pInstance;

    Mdl0ApprCompositeSearchDelegate();
    virtual ~Mdl0ApprCompositeSearchDelegate();
    static void setInstance( Mdl0ApprCompositeSearchDelegate*  instance );


private:
    friend class  ::Teamcenter::Mdl0ApprCompositeSearchGenImpl;

};

#include <rdv/librdv_undef.h>
#endif  //  TEAMCENTER__MDL0APPRCOMPOSITESEARCHDELEGATE_HXX
