//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Mdl0ApprSrchCrtClosure
    Filename:   Mdl0ApprSrchCrtClosure.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MDL0APPRSRCHCRTCLOSURE__HXX
#define TEAMCENTER__MDL0APPRSRCHCRTCLOSURE__HXX

#include <common/tc_deprecation_macros.h>
#include <rdv/ApprSearchCriteria.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class Mdl0ApprSrchCrtClosure;
}
namespace Teamcenter
{
    class Mdl0ApprSrchCrtClosureImpl;
}
namespace Teamcenter
{
    class Mdl0ApprSrchCrtClosureDelegate;
}
namespace Teamcenter
{
    class Mdl0ApprSrchCrtClosureDispatch;
}
namespace Teamcenter
{
    class Mdl0ApprSrchCrtClosureGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RDV_API  Teamcenter::Mdl0ApprSrchCrtClosure
     : public  ::Teamcenter::ApprSearchCriteria
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Mdl0ApprSrchCrtClosure();

    /**
     * Destructor
     */
    virtual ~Mdl0ApprSrchCrtClosure();

private:
    //  Getter method for the Implementation Object
    Mdl0ApprSrchCrtClosureImpl*  getMdl0ApprSrchCrtClosureImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMdl0ApprSrchCrtClosureImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Mdl0ApprSrchCrtClosureImpl*  m_mdl0apprsrchcrtclosureImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Mdl0ApprSrchCrtClosure - desc for Mdl0ApprSrchCrtClosure parameter
     */
    Mdl0ApprSrchCrtClosure( const Mdl0ApprSrchCrtClosure& );
    Mdl0ApprSrchCrtClosure& operator=( const Mdl0ApprSrchCrtClosure& );

    friend class  Mdl0ApprSrchCrtClosureDelegate;
    friend class  Mdl0ApprSrchCrtClosureDispatch;
    friend class  Mdl0ApprSrchCrtClosureGenImpl;
};

#include <rdv/librdv_undef.h>
#endif //   TEAMCENTER__MDL0APPRSRCHCRTCLOSURE__HXX
