//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, NamedVariantExpression
    Filename:   NamedVariantExpression.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__NAMEDVARIANTEXPRESSION__HXX
#define TEAMCENTER__NAMEDVARIANTEXPRESSION__HXX

#include <common/tc_deprecation_macros.h>
#include <ps/VariantExpression.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class NamedVariantExpression;
}
namespace Teamcenter
{
    class NamedVariantExpressionImpl;
}
namespace Teamcenter
{
    class NamedVariantExpressionDelegate;
}
namespace Teamcenter
{
    class NamedVariantExpressionDispatch;
}
namespace Teamcenter
{
    class NamedVariantExpressionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RDV_API  Teamcenter::NamedVariantExpression
     : public  ::Teamcenter::VariantExpression
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    NamedVariantExpression();

    /**
     * Destructor
     */
    virtual ~NamedVariantExpression();

private:
    //  Getter method for the Implementation Object
    NamedVariantExpressionImpl*  getNamedVariantExpressionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setNamedVariantExpressionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    NamedVariantExpressionImpl*  m_namedvariantexpressionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param NamedVariantExpression - desc for NamedVariantExpression parameter
     */
    NamedVariantExpression( const NamedVariantExpression& );
    NamedVariantExpression& operator=( const NamedVariantExpression& );

    friend class  NamedVariantExpressionDelegate;
    friend class  NamedVariantExpressionDispatch;
    friend class  NamedVariantExpressionGenImpl;
};

#include <rdv/librdv_undef.h>
#endif //   TEAMCENTER__NAMEDVARIANTEXPRESSION__HXX
