//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, NamedVariantExpressionDelegate
    Filename:   NamedVariantExpressionDelegate.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__NAMEDVARIANTEXPRESSIONDELEGATE_HXX
#define TEAMCENTER__NAMEDVARIANTEXPRESSIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <rdv/NamedVariantExpression.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class NamedVariantExpressionDelegate;
}
namespace Teamcenter
{
    class NamedVariantExpressionImpl;
}
namespace Teamcenter
{
    class NamedVariantExpression;
}
namespace Teamcenter
{
    class NamedVariantExpressionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  RDV_API Teamcenter_alias::NamedVariantExpressionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the NamedVariantExpressionDelegate instance
    static NamedVariantExpressionDelegate&  getInstance();

    //  Method to create the NamedVariantExpressionImpl pointer
    static NamedVariantExpressionImpl*  createImpl( NamedVariantExpression&  ifObj );

    //  Method to delete the NamedVariantExpressionImpl pointer
    static void deleteImpl( NamedVariantExpressionImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const NamedVariantExpression &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const NamedVariantExpression &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static NamedVariantExpressionDelegate*  m_pInstance;

    NamedVariantExpressionDelegate();
    virtual ~NamedVariantExpressionDelegate();
    static void setInstance( NamedVariantExpressionDelegate*  instance );


private:
    friend class  ::Teamcenter::NamedVariantExpressionGenImpl;

};

#include <rdv/librdv_undef.h>
#endif  //  TEAMCENTER__NAMEDVARIANTEXPRESSIONDELEGATE_HXX
