//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, OccurrenceAuditLine
    Filename:   OccurrenceAuditLine.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__OCCURRENCEAUDITLINE__HXX
#define TEAMCENTER__OCCURRENCEAUDITLINE__HXX

#include <common/tc_deprecation_macros.h>
#include <rdv/AuditLine.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class OccurrenceAuditLine;
}
namespace Teamcenter
{
    class OccurrenceAuditLineImpl;
}
namespace Teamcenter
{
    class OccurrenceAuditLineDelegate;
}
namespace Teamcenter
{
    class OccurrenceAuditLineDispatch;
}
namespace Teamcenter
{
    class OccurrenceAuditLineGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RDV_API  Teamcenter::OccurrenceAuditLine
     : public  ::Teamcenter::AuditLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    OccurrenceAuditLine();

    /**
     * Destructor
     */
    virtual ~OccurrenceAuditLine();

private:
    //  Getter method for the Implementation Object
    OccurrenceAuditLineImpl*  getOccurrenceAuditLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setOccurrenceAuditLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    OccurrenceAuditLineImpl*  m_occurrenceauditlineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param OccurrenceAuditLine - desc for OccurrenceAuditLine parameter
     */
    OccurrenceAuditLine( const OccurrenceAuditLine& );
    OccurrenceAuditLine& operator=( const OccurrenceAuditLine& );

    friend class  OccurrenceAuditLineDelegate;
    friend class  OccurrenceAuditLineDispatch;
    friend class  OccurrenceAuditLineGenImpl;
};

#include <rdv/librdv_undef.h>
#endif //   TEAMCENTER__OCCURRENCEAUDITLINE__HXX
