//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RDVAutoNVE
    Filename:   RDVAutoNVE.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__RDVAUTONVE__HXX
#define TEAMCENTER__RDVAUTONVE__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class RDVAutoNVE;
}
namespace Teamcenter
{
    class RDVAutoNVEImpl;
}
namespace Teamcenter
{
    class RDVAutoNVEDelegate;
}
namespace Teamcenter
{
    class RDVAutoNVEDispatch;
}
namespace Teamcenter
{
    class RDVAutoNVEGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RDV_API  Teamcenter::RDVAutoNVE
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    RDVAutoNVE();

    /**
     * Destructor
     */
    virtual ~RDVAutoNVE();

private:
    //  Getter method for the Implementation Object
    RDVAutoNVEImpl*  getRDVAutoNVEImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRDVAutoNVEImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    RDVAutoNVEImpl*  m_rdvautonveImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param RDVAutoNVE - desc for RDVAutoNVE parameter
     */
    RDVAutoNVE( const RDVAutoNVE& );
    RDVAutoNVE& operator=( const RDVAutoNVE& );

    friend class  RDVAutoNVEDelegate;
    friend class  RDVAutoNVEDispatch;
    friend class  RDVAutoNVEGenImpl;
};

#include <rdv/librdv_undef.h>
#endif //   TEAMCENTER__RDVAUTONVE__HXX
