//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SearchStructureContext
    Filename:   SearchStructureContext.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SEARCHSTRUCTURECONTEXT__HXX
#define TEAMCENTER__SEARCHSTRUCTURECONTEXT__HXX

#include <string>
#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <collabctx/VisStructureContext.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class SearchStructureContext;
}
namespace Teamcenter
{
    class SearchStructureContextImpl;
}
namespace Teamcenter
{
    class SearchStructureContextDelegate;
}
namespace Teamcenter
{
    class SearchStructureContextDispatch;
}
namespace Teamcenter
{
    class SearchStructureContextGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RDV_API  Teamcenter::SearchStructureContext
     : public  ::Teamcenter::VisStructureContext
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0isResultStored( bool &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0scopeNames( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0shared( bool &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0topline( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0isResultStored( bool value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0scopeNames( const std::string &value, bool isNull=false );

    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0shared( bool value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SearchStructureContext();

    /**
     * Destructor
     */
    virtual ~SearchStructureContext();

private:
    //  Getter method for the Implementation Object
    SearchStructureContextImpl*  getSearchStructureContextImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSearchStructureContextImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SearchStructureContextImpl*  m_searchstructurecontextImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SearchStructureContext - desc for SearchStructureContext parameter
     */
    SearchStructureContext( const SearchStructureContext& );
    SearchStructureContext& operator=( const SearchStructureContext& );

    friend class  SearchStructureContextDelegate;
    friend class  SearchStructureContextDispatch;
    friend class  SearchStructureContextGenImpl;
};

#include <rdv/librdv_undef.h>
#endif //   TEAMCENTER__SEARCHSTRUCTURECONTEXT__HXX
