//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SearchStructureContextDelegate
    Filename:   SearchStructureContextDelegate.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SEARCHSTRUCTURECONTEXTDELEGATE_HXX
#define TEAMCENTER__SEARCHSTRUCTURECONTEXTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <rdv/SearchStructureContext.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class SearchStructureContextDelegate;
}
namespace Teamcenter
{
    class SearchStructureContextImpl;
}
namespace Teamcenter
{
    class SearchStructureContext;
}
namespace Teamcenter
{
    class SearchStructureContextGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  RDV_API Teamcenter_alias::SearchStructureContextDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SearchStructureContextDelegate instance
    static SearchStructureContextDelegate&  getInstance();

    //  Method to create the SearchStructureContextImpl pointer
    static SearchStructureContextImpl*  createImpl( SearchStructureContext&  ifObj );

    //  Method to delete the SearchStructureContextImpl pointer
    static void deleteImpl( SearchStructureContextImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0isResultStoredBase(const SearchStructureContext &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0scopeNamesBase(const SearchStructureContext &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0sharedBase(const SearchStructureContext &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0toplineBase(const SearchStructureContext &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0isResultStoredBase(SearchStructureContext &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0scopeNamesBase(SearchStructureContext &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0sharedBase(SearchStructureContext &ifObj,  bool value, bool isNull );



protected:
    //  Pointer to the instance
    static SearchStructureContextDelegate*  m_pInstance;

    SearchStructureContextDelegate();
    virtual ~SearchStructureContextDelegate();
    static void setInstance( SearchStructureContextDelegate*  instance );


private:
    friend class  ::Teamcenter::SearchStructureContextGenImpl;

};

#include <rdv/librdv_undef.h>
#endif  //  TEAMCENTER__SEARCHSTRUCTURECONTEXTDELEGATE_HXX
