//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, UsageAuditLine
    Filename:   UsageAuditLine.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__USAGEAUDITLINE__HXX
#define TEAMCENTER__USAGEAUDITLINE__HXX

#include <common/tc_deprecation_macros.h>
#include <rdv/AuditLine.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class UsageAuditLine;
}
namespace Teamcenter
{
    class UsageAuditLineImpl;
}
namespace Teamcenter
{
    class UsageAuditLineDelegate;
}
namespace Teamcenter
{
    class UsageAuditLineDispatch;
}
namespace Teamcenter
{
    class UsageAuditLineGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RDV_API  Teamcenter::UsageAuditLine
     : public  ::Teamcenter::AuditLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    UsageAuditLine();

    /**
     * Destructor
     */
    virtual ~UsageAuditLine();

private:
    //  Getter method for the Implementation Object
    UsageAuditLineImpl*  getUsageAuditLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setUsageAuditLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    UsageAuditLineImpl*  m_usageauditlineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param UsageAuditLine - desc for UsageAuditLine parameter
     */
    UsageAuditLine( const UsageAuditLine& );
    UsageAuditLine& operator=( const UsageAuditLine& );

    friend class  UsageAuditLineDelegate;
    friend class  UsageAuditLineDispatch;
    friend class  UsageAuditLineGenImpl;
};

#include <rdv/librdv_undef.h>
#endif //   TEAMCENTER__USAGEAUDITLINE__HXX
