//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, UsageOption
    Filename:   UsageOption.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__USAGEOPTION__HXX
#define TEAMCENTER__USAGEOPTION__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class UsageOption;
}
namespace Teamcenter
{
    class UsageOptionImpl;
}
namespace Teamcenter
{
    class UsageOptionDelegate;
}
namespace Teamcenter
{
    class UsageOptionDispatch;
}
namespace Teamcenter
{
    class UsageOptionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RDV_API  Teamcenter::UsageOption
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    UsageOption();

    /**
     * Destructor
     */
    virtual ~UsageOption();

private:
    //  Getter method for the Implementation Object
    UsageOptionImpl*  getUsageOptionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setUsageOptionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    UsageOptionImpl*  m_usageoptionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param UsageOption - desc for UsageOption parameter
     */
    UsageOption( const UsageOption& );
    UsageOption& operator=( const UsageOption& );

    friend class  UsageOptionDelegate;
    friend class  UsageOptionDispatch;
    friend class  UsageOptionGenImpl;
};

#include <rdv/librdv_undef.h>
#endif //   TEAMCENTER__USAGEOPTION__HXX
