//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, UsagePartNumber
    Filename:   UsagePartNumber.hxx
    Module:     rdv
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__USAGEPARTNUMBER__HXX
#define TEAMCENTER__USAGEPARTNUMBER__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <rdv/librdv_exports.h>

namespace Teamcenter
{
    class UsagePartNumber;
}
namespace Teamcenter
{
    class UsagePartNumberImpl;
}
namespace Teamcenter
{
    class UsagePartNumberDelegate;
}
namespace Teamcenter
{
    class UsagePartNumberDispatch;
}
namespace Teamcenter
{
    class UsagePartNumberGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RDV_API  Teamcenter::UsagePartNumber
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    UsagePartNumber();

    /**
     * Destructor
     */
    virtual ~UsagePartNumber();

private:
    //  Getter method for the Implementation Object
    UsagePartNumberImpl*  getUsagePartNumberImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setUsagePartNumberImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    UsagePartNumberImpl*  m_usagepartnumberImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param UsagePartNumber - desc for UsagePartNumber parameter
     */
    UsagePartNumber( const UsagePartNumber& );
    UsagePartNumber& operator=( const UsagePartNumber& );

    friend class  UsagePartNumberDelegate;
    friend class  UsagePartNumberDispatch;
    friend class  UsagePartNumberGenImpl;
};

#include <rdv/librdv_undef.h>
#endif //   TEAMCENTER__USAGEPARTNUMBER__HXX
