//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  rdv

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            librdv

#if !defined(LIBRDV) && !defined(IPLIB)
#   error IPLIB or LIBRDV is not defined
#endif

/* Handwritten code should use RDV_API, not RDVEXPORT */

#define RDV_API RDVEXPORT

#if IPLIB==librdv || defined(LIBRDV)
#   if defined(__lint)
#       define RDVEXPORT       __export(rdv)
#       define RDVGLOBAL       extern __global(rdv)
#       define RDVPRIVATE      extern __private(rdv)
#   elif defined(_WIN32)
#       define RDVEXPORT       __declspec(dllexport)
#       define RDVGLOBAL       extern __declspec(dllexport)
#       define RDVPRIVATE      extern
#   else
#       define RDVEXPORT
#       define RDVGLOBAL       extern
#       define RDVPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define RDVEXPORT       __export(rdv)
#       define RDVGLOBAL       extern __global(rdv)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define RDVEXPORT      __declspec(dllimport)
#       define RDVGLOBAL       extern __declspec(dllimport)
#   else
#       define RDVEXPORT
#       define RDVGLOBAL       extern
#   endif
#endif
