//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  realizationdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            librealizationdispatch

#if !defined(LIBREALIZATIONDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBREALIZATIONDISPATCH is not defined
#endif

/* Handwritten code should use REALIZATIONDISPATCH_API, not REALIZATIONDISPATCHEXPORT */

#define REALIZATIONDISPATCH_API REALIZATIONDISPATCHEXPORT

#if IPLIB==librealizationdispatch || defined(LIBREALIZATIONDISPATCH)
#   if defined(__lint)
#       define REALIZATIONDISPATCHEXPORT       __export(realizationdispatch)
#       define REALIZATIONDISPATCHGLOBAL       extern __global(realizationdispatch)
#       define REALIZATIONDISPATCHPRIVATE      extern __private(realizationdispatch)
#   elif defined(_WIN32)
#       define REALIZATIONDISPATCHEXPORT       __declspec(dllexport)
#       define REALIZATIONDISPATCHGLOBAL       extern __declspec(dllexport)
#       define REALIZATIONDISPATCHPRIVATE      extern
#   else
#       define REALIZATIONDISPATCHEXPORT
#       define REALIZATIONDISPATCHGLOBAL       extern
#       define REALIZATIONDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define REALIZATIONDISPATCHEXPORT       __export(realizationdispatch)
#       define REALIZATIONDISPATCHGLOBAL       extern __global(realizationdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define REALIZATIONDISPATCHEXPORT      __declspec(dllimport)
#       define REALIZATIONDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define REALIZATIONDISPATCHEXPORT
#       define REALIZATIONDISPATCHGLOBAL       extern
#   endif
#endif
