//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ExportTemplate
    Filename:   ExportTemplate.hxx
    Module:     req
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EXPORTTEMPLATE__HXX
#define TEAMCENTER__EXPORTTEMPLATE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <req/libreq_exports.h>

namespace Teamcenter
{
    class ExportTemplate;
}
namespace Teamcenter
{
    class ExportTemplateImpl;
}
namespace Teamcenter
{
    class ExportTemplateDelegate;
}
namespace Teamcenter
{
    class ExportTemplateDispatch;
}
namespace Teamcenter
{
    class ExportTemplateGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  REQ_API  Teamcenter::ExportTemplate
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ExportTemplate();

    /**
     * Destructor
     */
    virtual ~ExportTemplate();

private:
    //  Getter method for the Implementation Object
    ExportTemplateImpl*  getExportTemplateImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setExportTemplateImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ExportTemplateImpl*  m_exporttemplateImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ExportTemplate - desc for ExportTemplate parameter
     */
    ExportTemplate( const ExportTemplate& );
    ExportTemplate& operator=( const ExportTemplate& );

    friend class  ExportTemplateDelegate;
    friend class  ExportTemplateDispatch;
    friend class  ExportTemplateGenImpl;
};

#include <req/libreq_undef.h>
#endif //   TEAMCENTER__EXPORTTEMPLATE__HXX
