//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ExportTemplateDelegate
    Filename:   ExportTemplateDelegate.hxx
    Module:     req
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EXPORTTEMPLATEDELEGATE_HXX
#define TEAMCENTER__EXPORTTEMPLATEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <req/ExportTemplate.hxx>

#include <req/libreq_exports.h>

namespace Teamcenter
{
    class ExportTemplateDelegate;
}
namespace Teamcenter
{
    class ExportTemplateImpl;
}
namespace Teamcenter
{
    class ExportTemplate;
}
namespace Teamcenter
{
    class ExportTemplateGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  REQ_API Teamcenter_alias::ExportTemplateDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ExportTemplateDelegate instance
    static ExportTemplateDelegate&  getInstance();

    //  Method to create the ExportTemplateImpl pointer
    static ExportTemplateImpl*  createImpl( ExportTemplate&  ifObj );

    //  Method to delete the ExportTemplateImpl pointer
    static void deleteImpl( ExportTemplateImpl*  impl );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const ExportTemplate &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static ExportTemplateDelegate*  m_pInstance;

    ExportTemplateDelegate();
    virtual ~ExportTemplateDelegate();
    static void setInstance( ExportTemplateDelegate*  instance );


private:
    friend class  ::Teamcenter::ExportTemplateGenImpl;

};

#include <req/libreq_undef.h>
#endif  //  TEAMCENTER__EXPORTTEMPLATEDELEGATE_HXX
