//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ExportTemplateRevision
    Filename:   ExportTemplateRevision.hxx
    Module:     req
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EXPORTTEMPLATEREVISION__HXX
#define TEAMCENTER__EXPORTTEMPLATEREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <req/libreq_exports.h>

namespace Teamcenter
{
    class ExportTemplateRevision;
}
namespace Teamcenter
{
    class ExportTemplateRevisionImpl;
}
namespace Teamcenter
{
    class ExportTemplateRevisionDelegate;
}
namespace Teamcenter
{
    class ExportTemplateRevisionDispatch;
}
namespace Teamcenter
{
    class ExportTemplateRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  REQ_API  Teamcenter::ExportTemplateRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ExportTemplateRevision();

    /**
     * Destructor
     */
    virtual ~ExportTemplateRevision();

private:
    //  Getter method for the Implementation Object
    ExportTemplateRevisionImpl*  getExportTemplateRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setExportTemplateRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ExportTemplateRevisionImpl*  m_exporttemplaterevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ExportTemplateRevision - desc for ExportTemplateRevision parameter
     */
    ExportTemplateRevision( const ExportTemplateRevision& );
    ExportTemplateRevision& operator=( const ExportTemplateRevision& );

    friend class  ExportTemplateRevisionDelegate;
    friend class  ExportTemplateRevisionDispatch;
    friend class  ExportTemplateRevisionGenImpl;
};

#include <req/libreq_undef.h>
#endif //   TEAMCENTER__EXPORTTEMPLATEREVISION__HXX
