//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0HTMLObjTmplRevision
    Filename:   Fnd0HTMLObjTmplRevision.hxx
    Module:     req
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0HTMLOBJTMPLREVISION__HXX
#define TEAMCENTER__FND0HTMLOBJTMPLREVISION__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <req/ExportTemplateRevision.hxx>

#include <req/libreq_exports.h>

namespace Teamcenter
{
    class Fnd0HTMLObjTmplRevision;
}
namespace Teamcenter
{
    class Fnd0HTMLObjTmplRevisionImpl;
}
namespace Teamcenter
{
    class Fnd0HTMLObjTmplRevisionDelegate;
}
namespace Teamcenter
{
    class Fnd0HTMLObjTmplRevisionDispatch;
}
namespace Teamcenter
{
    class Fnd0HTMLObjTmplRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  REQ_API  Teamcenter::Fnd0HTMLObjTmplRevision
     : public  ::Teamcenter::ExportTemplateRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 11.5
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0AssociatedWith( const std::vector< std::string > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0HTMLObjTmplRevision();

    /**
     * Destructor
     */
    virtual ~Fnd0HTMLObjTmplRevision();

private:
    //  Getter method for the Implementation Object
    Fnd0HTMLObjTmplRevisionImpl*  getFnd0HTMLObjTmplRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0HTMLObjTmplRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0HTMLObjTmplRevisionImpl*  m_fnd0htmlobjtmplrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0HTMLObjTmplRevision - desc for Fnd0HTMLObjTmplRevision parameter
     */
    Fnd0HTMLObjTmplRevision( const Fnd0HTMLObjTmplRevision& );
    Fnd0HTMLObjTmplRevision& operator=( const Fnd0HTMLObjTmplRevision& );

    friend class  Fnd0HTMLObjTmplRevisionDelegate;
    friend class  Fnd0HTMLObjTmplRevisionDispatch;
    friend class  Fnd0HTMLObjTmplRevisionGenImpl;
};

#include <req/libreq_undef.h>
#endif //   TEAMCENTER__FND0HTMLOBJTMPLREVISION__HXX
