//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ListsParamReqments
    Filename:   Fnd0ListsParamReqments.hxx
    Module:     req
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0LISTSPARAMREQMENTS__HXX
#define TEAMCENTER__FND0LISTSPARAMREQMENTS__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/FND_TraceLink.hxx>

#include <req/libreq_exports.h>

namespace Teamcenter
{
    class Fnd0ListsParamReqments;
}
namespace Teamcenter
{
    class Fnd0ListsParamReqmentsImpl;
}
namespace Teamcenter
{
    class Fnd0ListsParamReqmentsDelegate;
}
namespace Teamcenter
{
    class Fnd0ListsParamReqmentsDispatch;
}
namespace Teamcenter
{
    class Fnd0ListsParamReqmentsGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  REQ_API  Teamcenter::Fnd0ListsParamReqments
     : public  ::Teamcenter::FND_TraceLink
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0parameter( std::vector< std::string > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0value( std::vector< std::string > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 8.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0parameter( const std::vector< std::string > &values, const std::vector< int > *isNull=0 );

    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 8.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0value( const std::vector< std::string > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0ListsParamReqments();

    /**
     * Destructor
     */
    virtual ~Fnd0ListsParamReqments();

private:
    //  Getter method for the Implementation Object
    Fnd0ListsParamReqmentsImpl*  getFnd0ListsParamReqmentsImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0ListsParamReqmentsImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0ListsParamReqmentsImpl*  m_fnd0listsparamreqmentsImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0ListsParamReqments - desc for Fnd0ListsParamReqments parameter
     */
    Fnd0ListsParamReqments( const Fnd0ListsParamReqments& );
    Fnd0ListsParamReqments& operator=( const Fnd0ListsParamReqments& );

    friend class  Fnd0ListsParamReqmentsDelegate;
    friend class  Fnd0ListsParamReqmentsDispatch;
    friend class  Fnd0ListsParamReqmentsGenImpl;
};

#include <req/libreq_undef.h>
#endif //   TEAMCENTER__FND0LISTSPARAMREQMENTS__HXX
