//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ListsParamReqmentsDelegate
    Filename:   Fnd0ListsParamReqmentsDelegate.hxx
    Module:     req
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0LISTSPARAMREQMENTSDELEGATE_HXX
#define TEAMCENTER__FND0LISTSPARAMREQMENTSDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <req/Fnd0ListsParamReqments.hxx>

#include <req/libreq_exports.h>

namespace Teamcenter
{
    class Fnd0ListsParamReqmentsDelegate;
}
namespace Teamcenter
{
    class Fnd0ListsParamReqmentsImpl;
}
namespace Teamcenter
{
    class Fnd0ListsParamReqments;
}
namespace Teamcenter
{
    class Fnd0ListsParamReqmentsGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  REQ_API Teamcenter_alias::Fnd0ListsParamReqmentsDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0ListsParamReqmentsDelegate instance
    static Fnd0ListsParamReqmentsDelegate&  getInstance();

    //  Method to create the Fnd0ListsParamReqmentsImpl pointer
    static Fnd0ListsParamReqmentsImpl*  createImpl( Fnd0ListsParamReqments&  ifObj );

    //  Method to delete the Fnd0ListsParamReqmentsImpl pointer
    static void deleteImpl( Fnd0ListsParamReqmentsImpl*  impl );


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0parameterBase(const Fnd0ListsParamReqments &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0valueBase(const Fnd0ListsParamReqments &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 8.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0parameterBase(Fnd0ListsParamReqments &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 8.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0valueBase(Fnd0ListsParamReqments &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Fnd0ListsParamReqments &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Fnd0ListsParamReqments &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Fnd0ListsParamReqmentsDelegate*  m_pInstance;

    Fnd0ListsParamReqmentsDelegate();
    virtual ~Fnd0ListsParamReqmentsDelegate();
    static void setInstance( Fnd0ListsParamReqmentsDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0ListsParamReqmentsGenImpl;

};

#include <req/libreq_undef.h>
#endif  //  TEAMCENTER__FND0LISTSPARAMREQMENTSDELEGATE_HXX
