//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0RequirementBOMLine
    Filename:   Fnd0RequirementBOMLine.hxx
    Module:     req
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0REQUIREMENTBOMLINE__HXX
#define TEAMCENTER__FND0REQUIREMENTBOMLINE__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <secore/Fnd0BuildingBlockBOMLine.hxx>

#include <req/libreq_exports.h>

namespace Teamcenter
{
    class Fnd0RequirementBOMLine;
}
namespace Teamcenter
{
    class Fnd0RequirementBOMLineImpl;
}
namespace Teamcenter
{
    class Fnd0RequirementBOMLineDelegate;
}
namespace Teamcenter
{
    class Fnd0RequirementBOMLineDispatch;
}
namespace Teamcenter
{
    class Fnd0RequirementBOMLineGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  REQ_API  Teamcenter::Fnd0RequirementBOMLine
     : public  ::Teamcenter::Fnd0BuildingBlockBOMLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// This operation is designed to allow pre and post hooks.
    /// @version Teamcenter 11.1
    /// @param specType - Specification type.
    /// @param specElementType - Specification element type.
    /// @param top_bom_line - Top bom line.
    /// @return - An ifail integer.
    ///
    int  fnd0req_live_import_post( const char *specType, const char *specElementType, tag_t top_bom_line );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0RequirementBOMLine();

    /**
     * Destructor
     */
    virtual ~Fnd0RequirementBOMLine();

private:
    //  Getter method for the Implementation Object
    Fnd0RequirementBOMLineImpl*  getFnd0RequirementBOMLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0RequirementBOMLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0RequirementBOMLineImpl*  m_fnd0requirementbomlineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0RequirementBOMLine - desc for Fnd0RequirementBOMLine parameter
     */
    Fnd0RequirementBOMLine( const Fnd0RequirementBOMLine& );
    Fnd0RequirementBOMLine& operator=( const Fnd0RequirementBOMLine& );

    friend class  Fnd0RequirementBOMLineDelegate;
    friend class  Fnd0RequirementBOMLineDispatch;
    friend class  Fnd0RequirementBOMLineGenImpl;
};

#include <req/libreq_undef.h>
#endif //   TEAMCENTER__FND0REQUIREMENTBOMLINE__HXX
