//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, FullTextDelegate
    Filename:   FullTextDelegate.hxx
    Module:     req
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FULLTEXTDELEGATE_HXX
#define TEAMCENTER__FULLTEXTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <req/FullText.hxx>

#include <req/libreq_exports.h>

namespace Teamcenter
{
    class FullTextDelegate;
}
namespace Teamcenter
{
    class FullTextImpl;
}
namespace Teamcenter
{
    class FullText;
}
namespace Teamcenter
{
    class FullTextGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  REQ_API Teamcenter_alias::FullTextDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the FullTextDelegate instance
    static FullTextDelegate&  getInstance();

    //  Method to create the FullTextImpl pointer
    static FullTextImpl*  createImpl( FullText&  ifObj );

    //  Method to delete the FullTextImpl pointer
    static void deleteImpl( FullTextImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBody_cleartextBase(const FullText &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBody_textBase(const FullText &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getContent_typeBase(const FullText &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setBody_cleartextBase(FullText &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setBody_textBase(FullText &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setContent_typeBase(FullText &ifObj,  const std::string &value, bool isNull );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const FullText &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Generic saveAsPost operation.
    /// @version Teamcenter 8.1
    /// @param pSavAsInput - Input argument as SaveAsInput object.
    /// @param vecDeepCopyData - vector deepcopy data
    /// @return - Return integer value.
    ///
    int  saveAsPostBase(const FullText &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const FullText &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static FullTextDelegate*  m_pInstance;

    FullTextDelegate();
    virtual ~FullTextDelegate();
    static void setInstance( FullTextDelegate*  instance );


private:
    friend class  ::Teamcenter::FullTextGenImpl;

};

#include <req/libreq_undef.h>
#endif  //  TEAMCENTER__FULLTEXTDELEGATE_HXX
