//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Paragraph
    Filename:   Paragraph.hxx
    Module:     req
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PARAGRAPH__HXX
#define TEAMCENTER__PARAGRAPH__HXX

#include <common/tc_deprecation_macros.h>
#include <req/SpecElement.hxx>

#include <req/libreq_exports.h>

namespace Teamcenter
{
    class Paragraph;
}
namespace Teamcenter
{
    class ParagraphImpl;
}
namespace Teamcenter
{
    class ParagraphDelegate;
}
namespace Teamcenter
{
    class ParagraphDispatch;
}
namespace Teamcenter
{
    class ParagraphGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  REQ_API  Teamcenter::Paragraph
     : public  ::Teamcenter::SpecElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Paragraph();

    /**
     * Destructor
     */
    virtual ~Paragraph();

private:
    //  Getter method for the Implementation Object
    ParagraphImpl*  getParagraphImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setParagraphImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ParagraphImpl*  m_paragraphImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Paragraph - desc for Paragraph parameter
     */
    Paragraph( const Paragraph& );
    Paragraph& operator=( const Paragraph& );

    friend class  ParagraphDelegate;
    friend class  ParagraphDispatch;
    friend class  ParagraphGenImpl;
};

#include <req/libreq_undef.h>
#endif //   TEAMCENTER__PARAGRAPH__HXX
