//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Requirement
    Filename:   Requirement.hxx
    Module:     req
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REQUIREMENT__HXX
#define TEAMCENTER__REQUIREMENT__HXX

#include <common/tc_deprecation_macros.h>
#include <req/SpecElement.hxx>

#include <req/libreq_exports.h>

namespace Teamcenter
{
    class Requirement;
}
namespace Teamcenter
{
    class RequirementImpl;
}
namespace Teamcenter
{
    class RequirementDelegate;
}
namespace Teamcenter
{
    class RequirementDispatch;
}
namespace Teamcenter
{
    class RequirementGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  REQ_API  Teamcenter::Requirement
     : public  ::Teamcenter::SpecElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Requirement();

    /**
     * Destructor
     */
    virtual ~Requirement();

private:
    //  Getter method for the Implementation Object
    RequirementImpl*  getRequirementImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRequirementImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    RequirementImpl*  m_requirementImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Requirement - desc for Requirement parameter
     */
    Requirement( const Requirement& );
    Requirement& operator=( const Requirement& );

    friend class  RequirementDelegate;
    friend class  RequirementDispatch;
    friend class  RequirementGenImpl;
};

#include <req/libreq_undef.h>
#endif //   TEAMCENTER__REQUIREMENT__HXX
