//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RequirementSpec
    Filename:   RequirementSpec.hxx
    Module:     req
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REQUIREMENTSPEC__HXX
#define TEAMCENTER__REQUIREMENTSPEC__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Document.hxx>

#include <req/libreq_exports.h>

namespace Teamcenter
{
    class RequirementSpec;
}
namespace Teamcenter
{
    class RequirementSpecImpl;
}
namespace Teamcenter
{
    class RequirementSpecDelegate;
}
namespace Teamcenter
{
    class RequirementSpecDispatch;
}
namespace Teamcenter
{
    class RequirementSpecGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  REQ_API  Teamcenter::RequirementSpec
     : public  ::Teamcenter::Document
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    RequirementSpec();

    /**
     * Destructor
     */
    virtual ~RequirementSpec();

private:
    //  Getter method for the Implementation Object
    RequirementSpecImpl*  getRequirementSpecImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRequirementSpecImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    RequirementSpecImpl*  m_requirementspecImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param RequirementSpec - desc for RequirementSpec parameter
     */
    RequirementSpec( const RequirementSpec& );
    RequirementSpec& operator=( const RequirementSpec& );

    friend class  RequirementSpecDelegate;
    friend class  RequirementSpecDispatch;
    friend class  RequirementSpecGenImpl;
};

#include <req/libreq_undef.h>
#endif //   TEAMCENTER__REQUIREMENTSPEC__HXX
