//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SpecElement
    Filename:   SpecElement.hxx
    Module:     req
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECELEMENT__HXX
#define TEAMCENTER__SPECELEMENT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <req/libreq_exports.h>

namespace Teamcenter
{
    class SpecElement;
}
namespace Teamcenter
{
    class SpecElementImpl;
}
namespace Teamcenter
{
    class SpecElementDelegate;
}
namespace Teamcenter
{
    class SpecElementDispatch;
}
namespace Teamcenter
{
    class SpecElementGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  REQ_API  Teamcenter::SpecElement
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SpecElement();

    /**
     * Destructor
     */
    virtual ~SpecElement();

private:
    //  Getter method for the Implementation Object
    SpecElementImpl*  getSpecElementImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSpecElementImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SpecElementImpl*  m_specelementImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SpecElement - desc for SpecElement parameter
     */
    SpecElement( const SpecElement& );
    SpecElement& operator=( const SpecElement& );

    friend class  SpecElementDelegate;
    friend class  SpecElementDispatch;
    friend class  SpecElementGenImpl;
};

#include <req/libreq_undef.h>
#endif //   TEAMCENTER__SPECELEMENT__HXX
