//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SpecElementRevision
    Filename:   SpecElementRevision.hxx
    Module:     req
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECELEMENTREVISION__HXX
#define TEAMCENTER__SPECELEMENTREVISION__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <req/libreq_exports.h>

namespace Teamcenter
{
    class SpecElementRevision;
}
namespace Teamcenter
{
    class SpecElementRevisionImpl;
}
namespace Teamcenter
{
    class SpecElementRevisionDelegate;
}
namespace Teamcenter
{
    class SpecElementRevisionDispatch;
}
namespace Teamcenter
{
    class SpecElementRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  REQ_API  Teamcenter::SpecElementRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0_body_text_url( std::string &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SpecElementRevision();

    /**
     * Destructor
     */
    virtual ~SpecElementRevision();

private:
    //  Getter method for the Implementation Object
    SpecElementRevisionImpl*  getSpecElementRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSpecElementRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SpecElementRevisionImpl*  m_specelementrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SpecElementRevision - desc for SpecElementRevision parameter
     */
    SpecElementRevision( const SpecElementRevision& );
    SpecElementRevision& operator=( const SpecElementRevision& );

    friend class  SpecElementRevisionDelegate;
    friend class  SpecElementRevisionDispatch;
    friend class  SpecElementRevisionGenImpl;
};

#include <req/libreq_undef.h>
#endif //   TEAMCENTER__SPECELEMENTREVISION__HXX
