//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SpecElementRevisionDelegate
    Filename:   SpecElementRevisionDelegate.hxx
    Module:     req
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECELEMENTREVISIONDELEGATE_HXX
#define TEAMCENTER__SPECELEMENTREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <req/SpecElementRevision.hxx>

#include <req/libreq_exports.h>

namespace Teamcenter
{
    class SpecElementRevisionDelegate;
}
namespace Teamcenter
{
    class SpecElementRevisionImpl;
}
namespace Teamcenter
{
    class SpecElementRevision;
}
namespace Teamcenter
{
    class SpecElementRevisionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  REQ_API Teamcenter_alias::SpecElementRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SpecElementRevisionDelegate instance
    static SpecElementRevisionDelegate&  getInstance();

    //  Method to create the SpecElementRevisionImpl pointer
    static SpecElementRevisionImpl*  createImpl( SpecElementRevision&  ifObj );

    //  Method to delete the SpecElementRevisionImpl pointer
    static void deleteImpl( SpecElementRevisionImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0_body_text_urlBase(const SpecElementRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Generic revisePost operation.
    /// @version Teamcenter 10.1
    /// @param pReviseInput - Input ReviseInput object.
    /// @param vecDeepCopyData - Vector of deep copy data.
    /// @return - Returns an integer value.
    ///
    int  revisePostBase(const SpecElementRevision &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// Generic saveAsPost operation.
    /// @version Teamcenter 8.1
    /// @param pSavAsInput - Input argument as SaveAsInput object.
    /// @param vecDeepCopyData - vector deepcopy data
    /// @return - Return integer value.
    ///
    int  saveAsPostBase(const SpecElementRevision &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const SpecElementRevision &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static SpecElementRevisionDelegate*  m_pInstance;

    SpecElementRevisionDelegate();
    virtual ~SpecElementRevisionDelegate();
    static void setInstance( SpecElementRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::SpecElementRevisionGenImpl;

};

#include <req/libreq_undef.h>
#endif  //  TEAMCENTER__SPECELEMENTREVISIONDELEGATE_HXX
