//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  req

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libreq

#if !defined(LIBREQ) && !defined(IPLIB)
#   error IPLIB or LIBREQ is not defined
#endif

/* Handwritten code should use REQ_API, not REQEXPORT */

#define REQ_API REQEXPORT

#if IPLIB==libreq || defined(LIBREQ)
#   if defined(__lint)
#       define REQEXPORT       __export(req)
#       define REQGLOBAL       extern __global(req)
#       define REQPRIVATE      extern __private(req)
#   elif defined(_WIN32)
#       define REQEXPORT       __declspec(dllexport)
#       define REQGLOBAL       extern __declspec(dllexport)
#       define REQPRIVATE      extern
#   else
#       define REQEXPORT
#       define REQGLOBAL       extern
#       define REQPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define REQEXPORT       __export(req)
#       define REQGLOBAL       extern __global(req)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define REQEXPORT      __declspec(dllimport)
#       define REQGLOBAL       extern __declspec(dllimport)
#   else
#       define REQEXPORT
#       define REQGLOBAL       extern
#   endif
#endif
