//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ImanReservation
    Filename:   ImanReservation.hxx
    Module:     res
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IMANRESERVATION__HXX
#define TEAMCENTER__IMANRESERVATION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <res/libres_exports.h>

namespace Teamcenter
{
    class ImanReservation;
}
namespace Teamcenter
{
    class ImanReservationImpl;
}
namespace Teamcenter
{
    class ImanReservationDelegate;
}
namespace Teamcenter
{
    class ImanReservationDispatch;
}
namespace Teamcenter
{
    class ImanReservationGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RES_API  Teamcenter::ImanReservation
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ImanReservation();

    /**
     * Destructor
     */
    virtual ~ImanReservation();

private:
    //  Getter method for the Implementation Object
    ImanReservationImpl*  getImanReservationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setImanReservationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ImanReservationImpl*  m_imanreservationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ImanReservation - desc for ImanReservation parameter
     */
    ImanReservation( const ImanReservation& );
    ImanReservation& operator=( const ImanReservation& );

    friend class  ImanReservationDelegate;
    friend class  ImanReservationDispatch;
    friend class  ImanReservationGenImpl;
};

#include <res/libres_undef.h>
#endif //   TEAMCENTER__IMANRESERVATION__HXX
