//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Reservation
    Filename:   Reservation.hxx
    Module:     res
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__RESERVATION__HXX
#define TEAMCENTER__RESERVATION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <res/libres_exports.h>

namespace Teamcenter
{
    class Reservation;
}
namespace Teamcenter
{
    class ReservationImpl;
}
namespace Teamcenter
{
    class ReservationDelegate;
}
namespace Teamcenter
{
    class ReservationDispatch;
}
namespace Teamcenter
{
    class ReservationGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RES_API  Teamcenter::Reservation
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Reservation();

    /**
     * Destructor
     */
    virtual ~Reservation();

private:
    //  Getter method for the Implementation Object
    ReservationImpl*  getReservationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setReservationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ReservationImpl*  m_reservationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Reservation - desc for Reservation parameter
     */
    Reservation( const Reservation& );
    Reservation& operator=( const Reservation& );

    friend class  ReservationDelegate;
    friend class  ReservationDispatch;
    friend class  ReservationGenImpl;
};

#include <res/libres_undef.h>
#endif //   TEAMCENTER__RESERVATION__HXX
