//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ReservationDelegate
    Filename:   ReservationDelegate.hxx
    Module:     res
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__RESERVATIONDELEGATE_HXX
#define TEAMCENTER__RESERVATIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <res/Reservation.hxx>

#include <res/libres_exports.h>

namespace Teamcenter
{
    class ReservationDelegate;
}
namespace Teamcenter
{
    class ReservationImpl;
}
namespace Teamcenter
{
    class Reservation;
}
namespace Teamcenter
{
    class ReservationGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  RES_API Teamcenter_alias::ReservationDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ReservationDelegate instance
    static ReservationDelegate&  getInstance();

    //  Method to create the ReservationImpl pointer
    static ReservationImpl*  createImpl( Reservation&  ifObj );

    //  Method to delete the ReservationImpl pointer
    static void deleteImpl( ReservationImpl*  impl );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const Reservation &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static ReservationDelegate*  m_pInstance;

    ReservationDelegate();
    virtual ~ReservationDelegate();
    static void setInstance( ReservationDelegate*  instance );


private:
    friend class  ::Teamcenter::ReservationGenImpl;

};

#include <res/libres_undef.h>
#endif  //  TEAMCENTER__RESERVATIONDELEGATE_HXX
