//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  res

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libres

#if !defined(LIBRES) && !defined(IPLIB)
#   error IPLIB or LIBRES is not defined
#endif

/* Handwritten code should use RES_API, not RESEXPORT */

#define RES_API RESEXPORT

#if IPLIB==libres || defined(LIBRES)
#   if defined(__lint)
#       define RESEXPORT       __export(res)
#       define RESGLOBAL       extern __global(res)
#       define RESPRIVATE      extern __private(res)
#   elif defined(_WIN32)
#       define RESEXPORT       __declspec(dllexport)
#       define RESGLOBAL       extern __declspec(dllexport)
#       define RESPRIVATE      extern
#   else
#       define RESEXPORT
#       define RESGLOBAL       extern
#       define RESPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define RESEXPORT       __export(res)
#       define RESGLOBAL       extern __global(res)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define RESEXPORT      __declspec(dllimport)
#       define RESGLOBAL       extern __declspec(dllimport)
#   else
#       define RESEXPORT
#       define RESGLOBAL       extern
#   endif
#endif
