//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Rlz0Composition
    Filename:   Rlz0Composition.hxx
    Module:     rlz0realization
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REALIZATION__RLZ0COMPOSITION__HXX
#define TEAMCENTER__REALIZATION__RLZ0COMPOSITION__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0ConditionalElement.hxx>

#include <rlz0realization/librlz0realization_exports.h>

namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0Composition;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0CompositionImpl;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0CompositionDelegate;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0CompositionDispatch;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0CompositionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RLZ0REALIZATION_API  Teamcenter::Realization::Rlz0Composition
     : public  ::Teamcenter::AppModel::Mdl0ConditionalElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.2.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getRlz0AssociatedSubsets( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Rlz0Composition();

    /**
     * Destructor
     */
    virtual ~Rlz0Composition();

private:
    //  Getter method for the Implementation Object
    Rlz0CompositionImpl*  getRlz0CompositionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRlz0CompositionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Rlz0CompositionImpl*  m_rlz0compositionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Rlz0Composition - desc for Rlz0Composition parameter
     */
    Rlz0Composition( const Rlz0Composition& );
    Rlz0Composition& operator=( const Rlz0Composition& );

    friend class  Rlz0CompositionDelegate;
    friend class  Rlz0CompositionDispatch;
    friend class  Rlz0CompositionGenImpl;
};

#include <rlz0realization/librlz0realization_undef.h>
#endif //   TEAMCENTER__REALIZATION__RLZ0COMPOSITION__HXX
