//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Rlz0CompositionDelegate
    Filename:   Rlz0CompositionDelegate.hxx
    Module:     rlz0realization
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REALIZATION__RLZ0COMPOSITIONDELEGATE_HXX
#define TEAMCENTER__REALIZATION__RLZ0COMPOSITIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <rlz0realization/Rlz0Composition.hxx>

#include <rlz0realization/librlz0realization_exports.h>

namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0CompositionDelegate;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0CompositionImpl;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0Composition;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0CompositionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  RLZ0REALIZATION_API Teamcenter_alias::Realization::Rlz0CompositionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Rlz0CompositionDelegate instance
    static Rlz0CompositionDelegate&  getInstance();

    //  Method to create the Rlz0CompositionImpl pointer
    static Rlz0CompositionImpl*  createImpl( Rlz0Composition&  ifObj );

    //  Method to delete the Rlz0CompositionImpl pointer
    static void deleteImpl( Rlz0CompositionImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.2.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getRlz0AssociatedSubsetsBase(const Rlz0Composition &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;



protected:
    //  Pointer to the instance
    static Rlz0CompositionDelegate*  m_pInstance;

    Rlz0CompositionDelegate();
    virtual ~Rlz0CompositionDelegate();
    static void setInstance( Rlz0CompositionDelegate*  instance );


private:
    friend class  ::Teamcenter::Realization::Rlz0CompositionGenImpl;

};

#include <rlz0realization/librlz0realization_undef.h>
#endif  //  TEAMCENTER__REALIZATION__RLZ0COMPOSITIONDELEGATE_HXX
