//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Rlz0GDEArtifact
    Filename:   Rlz0GDEArtifact.hxx
    Module:     rlz0realization
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REALIZATION__RLZ0GDEARTIFACT__HXX
#define TEAMCENTER__REALIZATION__RLZ0GDEARTIFACT__HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0ModelArtifact.hxx>

#include <rlz0realization/librlz0realization_exports.h>

namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0GDEArtifact;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0GDEArtifactImpl;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0GDEArtifactDelegate;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0GDEArtifactDispatch;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0GDEArtifactGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RLZ0REALIZATION_API  Teamcenter::Realization::Rlz0GDEArtifact
     : public  ::Teamcenter::AppModel::Mdl0ModelArtifact
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Rlz0GDEArtifact();

    /**
     * Destructor
     */
    virtual ~Rlz0GDEArtifact();

private:
    //  Getter method for the Implementation Object
    Rlz0GDEArtifactImpl*  getRlz0GDEArtifactImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRlz0GDEArtifactImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Rlz0GDEArtifactImpl*  m_rlz0gdeartifactImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Rlz0GDEArtifact - desc for Rlz0GDEArtifact parameter
     */
    Rlz0GDEArtifact( const Rlz0GDEArtifact& );
    Rlz0GDEArtifact& operator=( const Rlz0GDEArtifact& );

    friend class  Rlz0GDEArtifactDelegate;
    friend class  Rlz0GDEArtifactDispatch;
    friend class  Rlz0GDEArtifactGenImpl;
};

#include <rlz0realization/librlz0realization_undef.h>
#endif //   TEAMCENTER__REALIZATION__RLZ0GDEARTIFACT__HXX
