//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Rlz0GDEArtifactDelegate
    Filename:   Rlz0GDEArtifactDelegate.hxx
    Module:     rlz0realization
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REALIZATION__RLZ0GDEARTIFACTDELEGATE_HXX
#define TEAMCENTER__REALIZATION__RLZ0GDEARTIFACTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <rlz0realization/Rlz0GDEArtifact.hxx>

#include <rlz0realization/librlz0realization_exports.h>

namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0GDEArtifactDelegate;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0GDEArtifactImpl;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0GDEArtifact;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0GDEArtifactGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  RLZ0REALIZATION_API Teamcenter_alias::Realization::Rlz0GDEArtifactDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Rlz0GDEArtifactDelegate instance
    static Rlz0GDEArtifactDelegate&  getInstance();

    //  Method to create the Rlz0GDEArtifactImpl pointer
    static Rlz0GDEArtifactImpl*  createImpl( Rlz0GDEArtifact&  ifObj );

    //  Method to delete the Rlz0GDEArtifactImpl pointer
    static void deleteImpl( Rlz0GDEArtifactImpl*  impl );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Rlz0GDEArtifact &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be created
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0FinalizeCreateInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static Rlz0GDEArtifactDelegate*  m_pInstance;

    Rlz0GDEArtifactDelegate();
    virtual ~Rlz0GDEArtifactDelegate();
    static void setInstance( Rlz0GDEArtifactDelegate*  instance );


private:
    friend class  ::Teamcenter::Realization::Rlz0GDEArtifactGenImpl;

};

#include <rlz0realization/librlz0realization_undef.h>
#endif  //  TEAMCENTER__REALIZATION__RLZ0GDEARTIFACTDELEGATE_HXX
