//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Rlz0ItemInstance
    Filename:   Rlz0ItemInstance.hxx
    Module:     rlz0realization
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REALIZATION__RLZ0ITEMINSTANCE__HXX
#define TEAMCENTER__REALIZATION__RLZ0ITEMINSTANCE__HXX

#include <common/tc_deprecation_macros.h>
#include <rlz0realization/Rlz0ItemRealization.hxx>

#include <rlz0realization/librlz0realization_exports.h>

namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0ItemInstance;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0ItemInstanceImpl;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0ItemInstanceDelegate;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0ItemInstanceDispatch;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0ItemInstanceGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RLZ0REALIZATION_API  Teamcenter::Realization::Rlz0ItemInstance
     : public  ::Teamcenter::Realization::Rlz0ItemRealization
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Rlz0ItemInstance();

    /**
     * Destructor
     */
    virtual ~Rlz0ItemInstance();

private:
    //  Getter method for the Implementation Object
    Rlz0ItemInstanceImpl*  getRlz0ItemInstanceImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRlz0ItemInstanceImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Rlz0ItemInstanceImpl*  m_rlz0iteminstanceImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Rlz0ItemInstance - desc for Rlz0ItemInstance parameter
     */
    Rlz0ItemInstance( const Rlz0ItemInstance& );
    Rlz0ItemInstance& operator=( const Rlz0ItemInstance& );

    friend class  Rlz0ItemInstanceDelegate;
    friend class  Rlz0ItemInstanceDispatch;
    friend class  Rlz0ItemInstanceGenImpl;
};

#include <rlz0realization/librlz0realization_undef.h>
#endif //   TEAMCENTER__REALIZATION__RLZ0ITEMINSTANCE__HXX
