//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Rlz0ItemInstanceDelegate
    Filename:   Rlz0ItemInstanceDelegate.hxx
    Module:     rlz0realization
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REALIZATION__RLZ0ITEMINSTANCEDELEGATE_HXX
#define TEAMCENTER__REALIZATION__RLZ0ITEMINSTANCEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <rlz0realization/Rlz0ItemInstance.hxx>

#include <rlz0realization/librlz0realization_exports.h>

namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0ItemInstanceDelegate;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0ItemInstanceImpl;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0ItemInstance;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0ItemInstanceGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  RLZ0REALIZATION_API Teamcenter_alias::Realization::Rlz0ItemInstanceDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Rlz0ItemInstanceDelegate instance
    static Rlz0ItemInstanceDelegate&  getInstance();

    //  Method to create the Rlz0ItemInstanceImpl pointer
    static Rlz0ItemInstanceImpl*  createImpl( Rlz0ItemInstance&  ifObj );

    //  Method to delete the Rlz0ItemInstanceImpl pointer
    static void deleteImpl( Rlz0ItemInstanceImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static Rlz0ItemInstanceDelegate*  m_pInstance;

    Rlz0ItemInstanceDelegate();
    virtual ~Rlz0ItemInstanceDelegate();
    static void setInstance( Rlz0ItemInstanceDelegate*  instance );


private:
    friend class  ::Teamcenter::Realization::Rlz0ItemInstanceGenImpl;

};

#include <rlz0realization/librlz0realization_undef.h>
#endif  //  TEAMCENTER__REALIZATION__RLZ0ITEMINSTANCEDELEGATE_HXX
