//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Rlz0ItemRealization
    Filename:   Rlz0ItemRealization.hxx
    Module:     rlz0realization
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REALIZATION__RLZ0ITEMREALIZATION__HXX
#define TEAMCENTER__REALIZATION__RLZ0ITEMREALIZATION__HXX

#include <string>
#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <rlz0realization/Rlz0Realization.hxx>

#include <rlz0realization/librlz0realization_exports.h>

namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0ItemRealization;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0ItemRealizationImpl;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0ItemRealizationDelegate;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0ItemRealizationDispatch;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0ItemRealizationGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RLZ0REALIZATION_API  Teamcenter::Realization::Rlz0ItemRealization
     : public  ::Teamcenter::Realization::Rlz0Realization
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRlz0bom_view( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRlz0product( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRlz0variant_rule( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setRlz0bom_view( const std::string &value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setRlz0product( const tag_t &value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setRlz0variant_rule( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Rlz0ItemRealization();

    /**
     * Destructor
     */
    virtual ~Rlz0ItemRealization();

private:
    //  Getter method for the Implementation Object
    Rlz0ItemRealizationImpl*  getRlz0ItemRealizationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRlz0ItemRealizationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Rlz0ItemRealizationImpl*  m_rlz0itemrealizationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Rlz0ItemRealization - desc for Rlz0ItemRealization parameter
     */
    Rlz0ItemRealization( const Rlz0ItemRealization& );
    Rlz0ItemRealization& operator=( const Rlz0ItemRealization& );

    friend class  Rlz0ItemRealizationDelegate;
    friend class  Rlz0ItemRealizationDispatch;
    friend class  Rlz0ItemRealizationGenImpl;
};

#include <rlz0realization/librlz0realization_undef.h>
#endif //   TEAMCENTER__REALIZATION__RLZ0ITEMREALIZATION__HXX
