//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Rlz0ItemRealizationDelegate
    Filename:   Rlz0ItemRealizationDelegate.hxx
    Module:     rlz0realization
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REALIZATION__RLZ0ITEMREALIZATIONDELEGATE_HXX
#define TEAMCENTER__REALIZATION__RLZ0ITEMREALIZATIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <rlz0realization/Rlz0ItemRealization.hxx>

#include <rlz0realization/librlz0realization_exports.h>

namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0ItemRealizationDelegate;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0ItemRealizationImpl;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0ItemRealization;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0ItemRealizationGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  RLZ0REALIZATION_API Teamcenter_alias::Realization::Rlz0ItemRealizationDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Rlz0ItemRealizationDelegate instance
    static Rlz0ItemRealizationDelegate&  getInstance();

    //  Method to create the Rlz0ItemRealizationImpl pointer
    static Rlz0ItemRealizationImpl*  createImpl( Rlz0ItemRealization&  ifObj );

    //  Method to delete the Rlz0ItemRealizationImpl pointer
    static void deleteImpl( Rlz0ItemRealizationImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRlz0bom_viewBase(const Rlz0ItemRealization &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRlz0productBase(const Rlz0ItemRealization &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRlz0variant_ruleBase(const Rlz0ItemRealization &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setRlz0bom_viewBase(Rlz0ItemRealization &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setRlz0productBase(Rlz0ItemRealization &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setRlz0variant_ruleBase(Rlz0ItemRealization &ifObj,  const tag_t &value, bool isNull );



protected:
    //  Pointer to the instance
    static Rlz0ItemRealizationDelegate*  m_pInstance;

    Rlz0ItemRealizationDelegate();
    virtual ~Rlz0ItemRealizationDelegate();
    static void setInstance( Rlz0ItemRealizationDelegate*  instance );


private:
    friend class  ::Teamcenter::Realization::Rlz0ItemRealizationGenImpl;

};

#include <rlz0realization/librlz0realization_undef.h>
#endif  //  TEAMCENTER__REALIZATION__RLZ0ITEMREALIZATIONDELEGATE_HXX
