//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Rlz0ItemRealizationMap
    Filename:   Rlz0ItemRealizationMap.hxx
    Module:     rlz0realization
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REALIZATION__RLZ0ITEMREALIZATIONMAP__HXX
#define TEAMCENTER__REALIZATION__RLZ0ITEMREALIZATIONMAP__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <rlz0realization/Rlz0RealizationMap.hxx>

#include <rlz0realization/librlz0realization_exports.h>

namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0ItemRealizationMap;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0ItemRealizationMapImpl;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0ItemRealizationMapDelegate;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0ItemRealizationMapDispatch;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0ItemRealizationMapGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RLZ0REALIZATION_API  Teamcenter::Realization::Rlz0ItemRealizationMap
     : public  ::Teamcenter::Realization::Rlz0RealizationMap
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRlz0is_source_occ_id_fnv( bool &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRlz0source_occ_id( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setRlz0is_source_occ_id_fnv( bool value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setRlz0source_occ_id( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Rlz0ItemRealizationMap();

    /**
     * Destructor
     */
    virtual ~Rlz0ItemRealizationMap();

private:
    //  Getter method for the Implementation Object
    Rlz0ItemRealizationMapImpl*  getRlz0ItemRealizationMapImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRlz0ItemRealizationMapImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Rlz0ItemRealizationMapImpl*  m_rlz0itemrealizationmapImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Rlz0ItemRealizationMap - desc for Rlz0ItemRealizationMap parameter
     */
    Rlz0ItemRealizationMap( const Rlz0ItemRealizationMap& );
    Rlz0ItemRealizationMap& operator=( const Rlz0ItemRealizationMap& );

    friend class  Rlz0ItemRealizationMapDelegate;
    friend class  Rlz0ItemRealizationMapDispatch;
    friend class  Rlz0ItemRealizationMapGenImpl;
};

#include <rlz0realization/librlz0realization_undef.h>
#endif //   TEAMCENTER__REALIZATION__RLZ0ITEMREALIZATIONMAP__HXX
