//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Rlz0ItemRealizationMapDelegate
    Filename:   Rlz0ItemRealizationMapDelegate.hxx
    Module:     rlz0realization
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REALIZATION__RLZ0ITEMREALIZATIONMAPDELEGATE_HXX
#define TEAMCENTER__REALIZATION__RLZ0ITEMREALIZATIONMAPDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <rlz0realization/Rlz0ItemRealizationMap.hxx>

#include <rlz0realization/librlz0realization_exports.h>

namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0ItemRealizationMapDelegate;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0ItemRealizationMapImpl;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0ItemRealizationMap;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0ItemRealizationMapGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  RLZ0REALIZATION_API Teamcenter_alias::Realization::Rlz0ItemRealizationMapDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Rlz0ItemRealizationMapDelegate instance
    static Rlz0ItemRealizationMapDelegate&  getInstance();

    //  Method to create the Rlz0ItemRealizationMapImpl pointer
    static Rlz0ItemRealizationMapImpl*  createImpl( Rlz0ItemRealizationMap&  ifObj );

    //  Method to delete the Rlz0ItemRealizationMapImpl pointer
    static void deleteImpl( Rlz0ItemRealizationMapImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRlz0is_source_occ_id_fnvBase(const Rlz0ItemRealizationMap &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRlz0source_occ_idBase(const Rlz0ItemRealizationMap &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setRlz0is_source_occ_id_fnvBase(Rlz0ItemRealizationMap &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setRlz0source_occ_idBase(Rlz0ItemRealizationMap &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static Rlz0ItemRealizationMapDelegate*  m_pInstance;

    Rlz0ItemRealizationMapDelegate();
    virtual ~Rlz0ItemRealizationMapDelegate();
    static void setInstance( Rlz0ItemRealizationMapDelegate*  instance );


private:
    friend class  ::Teamcenter::Realization::Rlz0ItemRealizationMapGenImpl;

};

#include <rlz0realization/librlz0realization_undef.h>
#endif  //  TEAMCENTER__REALIZATION__RLZ0ITEMREALIZATIONMAPDELEGATE_HXX
