//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Rlz0ModelRealization
    Filename:   Rlz0ModelRealization.hxx
    Module:     rlz0realization
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REALIZATION__RLZ0MODELREALIZATION__HXX
#define TEAMCENTER__REALIZATION__RLZ0MODELREALIZATION__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <rlz0realization/Rlz0Realization.hxx>

#include <rlz0realization/librlz0realization_exports.h>

namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0ModelRealization;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0ModelRealizationImpl;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0ModelRealizationDelegate;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0ModelRealizationDispatch;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0ModelRealizationGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RLZ0REALIZATION_API  Teamcenter::Realization::Rlz0ModelRealization
     : public  ::Teamcenter::Realization::Rlz0Realization
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRlz0ConfiguredSourceModel( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRlz0source_model( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setRlz0source_model( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Rlz0ModelRealization();

    /**
     * Destructor
     */
    virtual ~Rlz0ModelRealization();

private:
    //  Getter method for the Implementation Object
    Rlz0ModelRealizationImpl*  getRlz0ModelRealizationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRlz0ModelRealizationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Rlz0ModelRealizationImpl*  m_rlz0modelrealizationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Rlz0ModelRealization - desc for Rlz0ModelRealization parameter
     */
    Rlz0ModelRealization( const Rlz0ModelRealization& );
    Rlz0ModelRealization& operator=( const Rlz0ModelRealization& );

    friend class  Rlz0ModelRealizationDelegate;
    friend class  Rlz0ModelRealizationDispatch;
    friend class  Rlz0ModelRealizationGenImpl;
};

#include <rlz0realization/librlz0realization_undef.h>
#endif //   TEAMCENTER__REALIZATION__RLZ0MODELREALIZATION__HXX
