//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Rlz0ModelRealizationDelegate
    Filename:   Rlz0ModelRealizationDelegate.hxx
    Module:     rlz0realization
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REALIZATION__RLZ0MODELREALIZATIONDELEGATE_HXX
#define TEAMCENTER__REALIZATION__RLZ0MODELREALIZATIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <rlz0realization/Rlz0ModelRealization.hxx>

#include <rlz0realization/librlz0realization_exports.h>

namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0ModelRealizationDelegate;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0ModelRealizationImpl;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0ModelRealization;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0ModelRealizationGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  RLZ0REALIZATION_API Teamcenter_alias::Realization::Rlz0ModelRealizationDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Rlz0ModelRealizationDelegate instance
    static Rlz0ModelRealizationDelegate&  getInstance();

    //  Method to create the Rlz0ModelRealizationImpl pointer
    static Rlz0ModelRealizationImpl*  createImpl( Rlz0ModelRealization&  ifObj );

    //  Method to delete the Rlz0ModelRealizationImpl pointer
    static void deleteImpl( Rlz0ModelRealizationImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRlz0ConfiguredSourceModelBase(const Rlz0ModelRealization &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRlz0source_modelBase(const Rlz0ModelRealization &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setRlz0source_modelBase(Rlz0ModelRealization &ifObj,  const tag_t &value, bool isNull );



protected:
    //  Pointer to the instance
    static Rlz0ModelRealizationDelegate*  m_pInstance;

    Rlz0ModelRealizationDelegate();
    virtual ~Rlz0ModelRealizationDelegate();
    static void setInstance( Rlz0ModelRealizationDelegate*  instance );


private:
    friend class  ::Teamcenter::Realization::Rlz0ModelRealizationGenImpl;

};

#include <rlz0realization/librlz0realization_undef.h>
#endif  //  TEAMCENTER__REALIZATION__RLZ0MODELREALIZATIONDELEGATE_HXX
