//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Rlz0ModelRealizationMapDelegate
    Filename:   Rlz0ModelRealizationMapDelegate.hxx
    Module:     rlz0realization
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REALIZATION__RLZ0MODELREALIZATIONMAPDELEGATE_HXX
#define TEAMCENTER__REALIZATION__RLZ0MODELREALIZATIONMAPDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <rlz0realization/Rlz0ModelRealizationMap.hxx>

#include <rlz0realization/librlz0realization_exports.h>

namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0ModelRealizationMapDelegate;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0ModelRealizationMapImpl;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0ModelRealizationMap;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0ModelRealizationMapGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  RLZ0REALIZATION_API Teamcenter_alias::Realization::Rlz0ModelRealizationMapDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Rlz0ModelRealizationMapDelegate instance
    static Rlz0ModelRealizationMapDelegate&  getInstance();

    //  Method to create the Rlz0ModelRealizationMapImpl pointer
    static Rlz0ModelRealizationMapImpl*  createImpl( Rlz0ModelRealizationMap&  ifObj );

    //  Method to delete the Rlz0ModelRealizationMapImpl pointer
    static void deleteImpl( Rlz0ModelRealizationMapImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRlz0is_realizedBase(const Rlz0ModelRealizationMap &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRlz0sourceBase(const Rlz0ModelRealizationMap &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setRlz0is_realizedBase(Rlz0ModelRealizationMap &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setRlz0sourceBase(Rlz0ModelRealizationMap &ifObj,  const std::string &value, bool isNull );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Rlz0ModelRealizationMap &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// finalize operation input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  finalizeSaveAsInputBase(const Rlz0ModelRealizationMap &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0CreatePostBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.3
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0FinalizeSaveAsInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static Rlz0ModelRealizationMapDelegate*  m_pInstance;

    Rlz0ModelRealizationMapDelegate();
    virtual ~Rlz0ModelRealizationMapDelegate();
    static void setInstance( Rlz0ModelRealizationMapDelegate*  instance );


private:
    friend class  ::Teamcenter::Realization::Rlz0ModelRealizationMapGenImpl;

};

#include <rlz0realization/librlz0realization_undef.h>
#endif  //  TEAMCENTER__REALIZATION__RLZ0MODELREALIZATIONMAPDELEGATE_HXX
