//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Rlz0PopulateInstantiation
    Filename:   Rlz0PopulateInstantiation.hxx
    Module:     rlz0realization
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REALIZATION__RLZ0POPULATEINSTANTIATION__HXX
#define TEAMCENTER__REALIZATION__RLZ0POPULATEINSTANTIATION__HXX

#include <common/tc_deprecation_macros.h>
#include <rlz0realization/Rlz0ItemRealization.hxx>

#include <rlz0realization/librlz0realization_exports.h>

namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0PopulateInstantiation;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0PopulateInstantiationImpl;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0PopulateInstantiationDelegate;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0PopulateInstantiationDispatch;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0PopulateInstantiationGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RLZ0REALIZATION_API  Teamcenter::Realization::Rlz0PopulateInstantiation
     : public  ::Teamcenter::Realization::Rlz0ItemRealization
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Rlz0PopulateInstantiation();

    /**
     * Destructor
     */
    virtual ~Rlz0PopulateInstantiation();

private:
    //  Getter method for the Implementation Object
    Rlz0PopulateInstantiationImpl*  getRlz0PopulateInstantiationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRlz0PopulateInstantiationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Rlz0PopulateInstantiationImpl*  m_rlz0populateinstantiationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Rlz0PopulateInstantiation - desc for Rlz0PopulateInstantiation parameter
     */
    Rlz0PopulateInstantiation( const Rlz0PopulateInstantiation& );
    Rlz0PopulateInstantiation& operator=( const Rlz0PopulateInstantiation& );

    friend class  Rlz0PopulateInstantiationDelegate;
    friend class  Rlz0PopulateInstantiationDispatch;
    friend class  Rlz0PopulateInstantiationGenImpl;
};

#include <rlz0realization/librlz0realization_undef.h>
#endif //   TEAMCENTER__REALIZATION__RLZ0POPULATEINSTANTIATION__HXX
