//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Rlz0RealizationContainer
    Filename:   Rlz0RealizationContainer.hxx
    Module:     rlz0realization
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REALIZATION__RLZ0REALIZATIONCONTAINER__HXX
#define TEAMCENTER__REALIZATION__RLZ0REALIZATIONCONTAINER__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0ModelElement.hxx>

#include <rlz0realization/librlz0realization_exports.h>

namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0RealizationContainer;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0RealizationContainerImpl;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0RealizationContainerDelegate;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0RealizationContainerDispatch;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0RealizationContainerGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RLZ0REALIZATION_API  Teamcenter::Realization::Rlz0RealizationContainer
     : public  ::Teamcenter::AppModel::Mdl0ModelElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRlz0instance( tag_t &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Rlz0RealizationContainer();

    /**
     * Destructor
     */
    virtual ~Rlz0RealizationContainer();

private:
    //  Getter method for the Implementation Object
    Rlz0RealizationContainerImpl*  getRlz0RealizationContainerImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRlz0RealizationContainerImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Rlz0RealizationContainerImpl*  m_rlz0realizationcontainerImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Rlz0RealizationContainer - desc for Rlz0RealizationContainer parameter
     */
    Rlz0RealizationContainer( const Rlz0RealizationContainer& );
    Rlz0RealizationContainer& operator=( const Rlz0RealizationContainer& );

    friend class  Rlz0RealizationContainerDelegate;
    friend class  Rlz0RealizationContainerDispatch;
    friend class  Rlz0RealizationContainerGenImpl;
};

#include <rlz0realization/librlz0realization_undef.h>
#endif //   TEAMCENTER__REALIZATION__RLZ0REALIZATIONCONTAINER__HXX
