//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Rlz0RealizationContainerDelegate
    Filename:   Rlz0RealizationContainerDelegate.hxx
    Module:     rlz0realization
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REALIZATION__RLZ0REALIZATIONCONTAINERDELEGATE_HXX
#define TEAMCENTER__REALIZATION__RLZ0REALIZATIONCONTAINERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <rlz0realization/Rlz0RealizationContainer.hxx>

#include <rlz0realization/librlz0realization_exports.h>

namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0RealizationContainerDelegate;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0RealizationContainerImpl;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0RealizationContainer;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0RealizationContainerGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  RLZ0REALIZATION_API Teamcenter_alias::Realization::Rlz0RealizationContainerDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Rlz0RealizationContainerDelegate instance
    static Rlz0RealizationContainerDelegate&  getInstance();

    //  Method to create the Rlz0RealizationContainerImpl pointer
    static Rlz0RealizationContainerImpl*  createImpl( Rlz0RealizationContainer&  ifObj );

    //  Method to delete the Rlz0RealizationContainerImpl pointer
    static void deleteImpl( Rlz0RealizationContainerImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRlz0instanceBase(const Rlz0RealizationContainer &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Rlz0RealizationContainer &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Rlz0RealizationContainerDelegate*  m_pInstance;

    Rlz0RealizationContainerDelegate();
    virtual ~Rlz0RealizationContainerDelegate();
    static void setInstance( Rlz0RealizationContainerDelegate*  instance );


private:
    friend class  ::Teamcenter::Realization::Rlz0RealizationContainerGenImpl;

};

#include <rlz0realization/librlz0realization_undef.h>
#endif  //  TEAMCENTER__REALIZATION__RLZ0REALIZATIONCONTAINERDELEGATE_HXX
