//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Rlz0RealizationMapDelegate
    Filename:   Rlz0RealizationMapDelegate.hxx
    Module:     rlz0realization
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REALIZATION__RLZ0REALIZATIONMAPDELEGATE_HXX
#define TEAMCENTER__REALIZATION__RLZ0REALIZATIONMAPDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <rlz0realization/Rlz0RealizationMap.hxx>

#include <rlz0realization/librlz0realization_exports.h>

namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0RealizationMapDelegate;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0RealizationMapImpl;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0RealizationMap;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0RealizationMapGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  RLZ0REALIZATION_API Teamcenter_alias::Realization::Rlz0RealizationMapDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Rlz0RealizationMapDelegate instance
    static Rlz0RealizationMapDelegate&  getInstance();

    //  Method to create the Rlz0RealizationMapImpl pointer
    static Rlz0RealizationMapImpl*  createImpl( Rlz0RealizationMap&  ifObj );

    //  Method to delete the Rlz0RealizationMapImpl pointer
    static void deleteImpl( Rlz0RealizationMapImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRlz0cs_idBase(const Rlz0RealizationMap &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRlz0realizationBase(const Rlz0RealizationMap &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRlz0targetBase(const Rlz0RealizationMap &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setRlz0cs_idBase(Rlz0RealizationMap &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setRlz0realizationBase(Rlz0RealizationMap &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setRlz0targetBase(Rlz0RealizationMap &ifObj,  const std::string &value, bool isNull );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Rlz0RealizationMap &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0CreatePostBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static Rlz0RealizationMapDelegate*  m_pInstance;

    Rlz0RealizationMapDelegate();
    virtual ~Rlz0RealizationMapDelegate();
    static void setInstance( Rlz0RealizationMapDelegate*  instance );


private:
    friend class  ::Teamcenter::Realization::Rlz0RealizationMapGenImpl;

};

#include <rlz0realization/librlz0realization_undef.h>
#endif  //  TEAMCENTER__REALIZATION__RLZ0REALIZATIONMAPDELEGATE_HXX
