//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Rlz0RealizedItem
    Filename:   Rlz0RealizedItem.hxx
    Module:     rlz0realization
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REALIZATION__RLZ0REALIZEDITEM__HXX
#define TEAMCENTER__REALIZATION__RLZ0REALIZEDITEM__HXX

#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0ConditionalElement.hxx>

#include <rlz0realization/librlz0realization_exports.h>

namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0RealizedItem;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0RealizedItemImpl;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0RealizedItemDelegate;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0RealizedItemDispatch;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0RealizedItemGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RLZ0REALIZATION_API  Teamcenter::Realization::Rlz0RealizedItem
     : public  ::Teamcenter::AppModel::Mdl0ConditionalElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Rlz0RealizedItem();

    /**
     * Destructor
     */
    virtual ~Rlz0RealizedItem();

private:
    //  Getter method for the Implementation Object
    Rlz0RealizedItemImpl*  getRlz0RealizedItemImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRlz0RealizedItemImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Rlz0RealizedItemImpl*  m_rlz0realizeditemImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Rlz0RealizedItem - desc for Rlz0RealizedItem parameter
     */
    Rlz0RealizedItem( const Rlz0RealizedItem& );
    Rlz0RealizedItem& operator=( const Rlz0RealizedItem& );

    friend class  Rlz0RealizedItemDelegate;
    friend class  Rlz0RealizedItemDispatch;
    friend class  Rlz0RealizedItemGenImpl;
};

#include <rlz0realization/librlz0realization_undef.h>
#endif //   TEAMCENTER__REALIZATION__RLZ0REALIZEDITEM__HXX
