//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Rlz0RefCompositionProvider
    Filename:   Rlz0RefCompositionProvider.hxx
    Module:     rlz0realization
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REALIZATION__RLZ0REFCOMPOSITIONPROVIDER__HXX
#define TEAMCENTER__REALIZATION__RLZ0REFCOMPOSITIONPROVIDER__HXX

#include <common/tc_deprecation_macros.h>
#include <tc/Fnd0BaseProvider.hxx>

#include <rlz0realization/librlz0realization_exports.h>

namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0RefCompositionProvider;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0RefCompositionProviderImpl;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0RefCompositionProviderDelegate;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0RefCompositionProviderDispatch;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0RefCompositionProviderGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RLZ0REALIZATION_API  Teamcenter::Realization::Rlz0RefCompositionProvider
     : public  ::Teamcenter::Fnd0BaseProvider
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Rlz0RefCompositionProvider();

    /**
     * Destructor
     */
    virtual ~Rlz0RefCompositionProvider();

private:
    //  Getter method for the Implementation Object
    Rlz0RefCompositionProviderImpl*  getRlz0RefCompositionProviderImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRlz0RefCompositionProviderImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Rlz0RefCompositionProviderImpl*  m_rlz0refcompositionproviderImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Rlz0RefCompositionProvider - desc for Rlz0RefCompositionProvider parameter
     */
    Rlz0RefCompositionProvider( const Rlz0RefCompositionProvider& );
    Rlz0RefCompositionProvider& operator=( const Rlz0RefCompositionProvider& );

    friend class  Rlz0RefCompositionProviderDelegate;
    friend class  Rlz0RefCompositionProviderDispatch;
    friend class  Rlz0RefCompositionProviderGenImpl;
};

#include <rlz0realization/librlz0realization_undef.h>
#endif //   TEAMCENTER__REALIZATION__RLZ0REFCOMPOSITIONPROVIDER__HXX
