//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Rlz0RefCompositionProviderDelegate
    Filename:   Rlz0RefCompositionProviderDelegate.hxx
    Module:     rlz0realization
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REALIZATION__RLZ0REFCOMPOSITIONPROVIDERDELEGATE_HXX
#define TEAMCENTER__REALIZATION__RLZ0REFCOMPOSITIONPROVIDERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <rlz0realization/Rlz0RefCompositionProvider.hxx>

#include <rlz0realization/librlz0realization_exports.h>

namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0RefCompositionProviderDelegate;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0RefCompositionProviderImpl;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0RefCompositionProvider;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0RefCompositionProviderGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  RLZ0REALIZATION_API Teamcenter_alias::Realization::Rlz0RefCompositionProviderDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Rlz0RefCompositionProviderDelegate instance
    static Rlz0RefCompositionProviderDelegate&  getInstance();

    //  Method to create the Rlz0RefCompositionProviderImpl pointer
    static Rlz0RefCompositionProviderImpl*  createImpl( Rlz0RefCompositionProvider&  ifObj );

    //  Method to delete the Rlz0RefCompositionProviderImpl pointer
    static void deleteImpl( Rlz0RefCompositionProviderImpl*  impl );


    ///
    /// This operation returns a structure containing search results, search filters for each search filter field based on the search results, and search filter categories.
    /// @version Teamcenter 9.1.2
    /// @param searchInput - The input to the search
    /// @param searchOutput - The output from the search.
    /// @return - Status. 0 if successful
    ///
    int  fnd0performSearchBase(const Rlz0RefCompositionProvider &ifObj,  ::Teamcenter::OperationInput *searchInput, ::Teamcenter::OperationInput *searchOutput );



protected:
    //  Pointer to the instance
    static Rlz0RefCompositionProviderDelegate*  m_pInstance;

    Rlz0RefCompositionProviderDelegate();
    virtual ~Rlz0RefCompositionProviderDelegate();
    static void setInstance( Rlz0RefCompositionProviderDelegate*  instance );


private:
    friend class  ::Teamcenter::Realization::Rlz0RefCompositionProviderGenImpl;

};

#include <rlz0realization/librlz0realization_undef.h>
#endif  //  TEAMCENTER__REALIZATION__RLZ0REFCOMPOSITIONPROVIDERDELEGATE_HXX
