//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Rlz0SourceObjectRefByProvider
    Filename:   Rlz0SourceObjectRefByProvider.hxx
    Module:     rlz0realization
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REALIZATION__RLZ0SOURCEOBJECTREFBYPROVIDER__HXX
#define TEAMCENTER__REALIZATION__RLZ0SOURCEOBJECTREFBYPROVIDER__HXX

#include <common/tc_deprecation_macros.h>
#include <tc/Fnd0BaseProvider.hxx>

#include <rlz0realization/librlz0realization_exports.h>

namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0SourceObjectRefByProvider;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0SourceObjectRefByProviderImpl;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0SourceObjectRefByProviderDelegate;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0SourceObjectRefByProviderDispatch;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0SourceObjectRefByProviderGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RLZ0REALIZATION_API  Teamcenter::Realization::Rlz0SourceObjectRefByProvider
     : public  ::Teamcenter::Fnd0BaseProvider
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Rlz0SourceObjectRefByProvider();

    /**
     * Destructor
     */
    virtual ~Rlz0SourceObjectRefByProvider();

private:
    //  Getter method for the Implementation Object
    Rlz0SourceObjectRefByProviderImpl*  getRlz0SourceObjectRefByProviderImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRlz0SourceObjectRefByProviderImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Rlz0SourceObjectRefByProviderImpl*  m_rlz0sourceobjectrefbyproviderImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Rlz0SourceObjectRefByProvider - desc for Rlz0SourceObjectRefByProvider parameter
     */
    Rlz0SourceObjectRefByProvider( const Rlz0SourceObjectRefByProvider& );
    Rlz0SourceObjectRefByProvider& operator=( const Rlz0SourceObjectRefByProvider& );

    friend class  Rlz0SourceObjectRefByProviderDelegate;
    friend class  Rlz0SourceObjectRefByProviderDispatch;
    friend class  Rlz0SourceObjectRefByProviderGenImpl;
};

#include <rlz0realization/librlz0realization_undef.h>
#endif //   TEAMCENTER__REALIZATION__RLZ0SOURCEOBJECTREFBYPROVIDER__HXX
