//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Rlz0Subset
    Filename:   Rlz0Subset.hxx
    Module:     rlz0realization
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REALIZATION__RLZ0SUBSET__HXX
#define TEAMCENTER__REALIZATION__RLZ0SUBSET__HXX

#include <unidefs.h>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0ModelArtifact.hxx>

#include <rlz0realization/librlz0realization_exports.h>

namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0Subset;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0SubsetImpl;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0SubsetDelegate;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0SubsetDispatch;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0SubsetGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RLZ0REALIZATION_API  Teamcenter::Realization::Rlz0Subset
     : public  ::Teamcenter::AppModel::Mdl0ModelArtifact
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.2.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRlz0SubsetInstance( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Double Array Property
    /// @version Teamcenter 11.2
    /// @param values - Values to be set for the paramter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setRlz0Transform( const std::vector< double > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Rlz0Subset();

    /**
     * Destructor
     */
    virtual ~Rlz0Subset();

private:
    //  Getter method for the Implementation Object
    Rlz0SubsetImpl*  getRlz0SubsetImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRlz0SubsetImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Rlz0SubsetImpl*  m_rlz0subsetImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Rlz0Subset - desc for Rlz0Subset parameter
     */
    Rlz0Subset( const Rlz0Subset& );
    Rlz0Subset& operator=( const Rlz0Subset& );

    friend class  Rlz0SubsetDelegate;
    friend class  Rlz0SubsetDispatch;
    friend class  Rlz0SubsetGenImpl;
};

#include <rlz0realization/librlz0realization_undef.h>
#endif //   TEAMCENTER__REALIZATION__RLZ0SUBSET__HXX
