//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Rlz0SubsetDelegate
    Filename:   Rlz0SubsetDelegate.hxx
    Module:     rlz0realization
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REALIZATION__RLZ0SUBSETDELEGATE_HXX
#define TEAMCENTER__REALIZATION__RLZ0SUBSETDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <rlz0realization/Rlz0Subset.hxx>

#include <rlz0realization/librlz0realization_exports.h>

namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0SubsetDelegate;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0SubsetImpl;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0Subset;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0SubsetGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  RLZ0REALIZATION_API Teamcenter_alias::Realization::Rlz0SubsetDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Rlz0SubsetDelegate instance
    static Rlz0SubsetDelegate&  getInstance();

    //  Method to create the Rlz0SubsetImpl pointer
    static Rlz0SubsetImpl*  createImpl( Rlz0Subset&  ifObj );

    //  Method to delete the Rlz0SubsetImpl pointer
    static void deleteImpl( Rlz0SubsetImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.2.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRlz0SubsetInstanceBase(const Rlz0Subset &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Double Array Property
    /// @version Teamcenter 11.2
    /// @param values - Values to be set for the paramter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setRlz0TransformBase(Rlz0Subset &ifObj,  const std::vector< double > &values, const std::vector< int > *isNull );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Rlz0Subset &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0CreatePostBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static Rlz0SubsetDelegate*  m_pInstance;

    Rlz0SubsetDelegate();
    virtual ~Rlz0SubsetDelegate();
    static void setInstance( Rlz0SubsetDelegate*  instance );


private:
    friend class  ::Teamcenter::Realization::Rlz0SubsetGenImpl;

};

#include <rlz0realization/librlz0realization_undef.h>
#endif  //  TEAMCENTER__REALIZATION__RLZ0SUBSETDELEGATE_HXX
