//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Rlz0SubsetInstance
    Filename:   Rlz0SubsetInstance.hxx
    Module:     rlz0realization
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REALIZATION__RLZ0SUBSETINSTANCE__HXX
#define TEAMCENTER__REALIZATION__RLZ0SUBSETINSTANCE__HXX

#include <common/tc_deprecation_macros.h>
#include <rlz0realization/Rlz0ModelRealization.hxx>

#include <rlz0realization/librlz0realization_exports.h>

namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0SubsetInstance;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0SubsetInstanceImpl;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0SubsetInstanceDelegate;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0SubsetInstanceDispatch;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0SubsetInstanceGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  RLZ0REALIZATION_API  Teamcenter::Realization::Rlz0SubsetInstance
     : public  ::Teamcenter::Realization::Rlz0ModelRealization
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Rlz0SubsetInstance();

    /**
     * Destructor
     */
    virtual ~Rlz0SubsetInstance();

private:
    //  Getter method for the Implementation Object
    Rlz0SubsetInstanceImpl*  getRlz0SubsetInstanceImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRlz0SubsetInstanceImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Rlz0SubsetInstanceImpl*  m_rlz0subsetinstanceImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Rlz0SubsetInstance - desc for Rlz0SubsetInstance parameter
     */
    Rlz0SubsetInstance( const Rlz0SubsetInstance& );
    Rlz0SubsetInstance& operator=( const Rlz0SubsetInstance& );

    friend class  Rlz0SubsetInstanceDelegate;
    friend class  Rlz0SubsetInstanceDispatch;
    friend class  Rlz0SubsetInstanceGenImpl;
};

#include <rlz0realization/librlz0realization_undef.h>
#endif //   TEAMCENTER__REALIZATION__RLZ0SUBSETINSTANCE__HXX
