//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Rlz0SubsetInstanceDelegate
    Filename:   Rlz0SubsetInstanceDelegate.hxx
    Module:     rlz0realization
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REALIZATION__RLZ0SUBSETINSTANCEDELEGATE_HXX
#define TEAMCENTER__REALIZATION__RLZ0SUBSETINSTANCEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <rlz0realization/Rlz0SubsetInstance.hxx>

#include <rlz0realization/librlz0realization_exports.h>

namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0SubsetInstanceDelegate;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0SubsetInstanceImpl;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0SubsetInstance;
    }
}
namespace Teamcenter
{
    namespace Realization
    {
        class Rlz0SubsetInstanceGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  RLZ0REALIZATION_API Teamcenter_alias::Realization::Rlz0SubsetInstanceDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Rlz0SubsetInstanceDelegate instance
    static Rlz0SubsetInstanceDelegate&  getInstance();

    //  Method to create the Rlz0SubsetInstanceImpl pointer
    static Rlz0SubsetInstanceImpl*  createImpl( Rlz0SubsetInstance&  ifObj );

    //  Method to delete the Rlz0SubsetInstanceImpl pointer
    static void deleteImpl( Rlz0SubsetInstanceImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static Rlz0SubsetInstanceDelegate*  m_pInstance;

    Rlz0SubsetInstanceDelegate();
    virtual ~Rlz0SubsetInstanceDelegate();
    static void setInstance( Rlz0SubsetInstanceDelegate*  instance );


private:
    friend class  ::Teamcenter::Realization::Rlz0SubsetInstanceGenImpl;

};

#include <rlz0realization/librlz0realization_undef.h>
#endif  //  TEAMCENTER__REALIZATION__RLZ0SUBSETINSTANCEDELEGATE_HXX
