//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AuditDefinition
    Filename:   AuditDefinition.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__AUDITDEFINITION__HXX
#define TEAMCENTER__AUDITDEFINITION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class AuditDefinition;
}
namespace Teamcenter
{
    class AuditDefinitionImpl;
}
namespace Teamcenter
{
    class AuditDefinitionDelegate;
}
namespace Teamcenter
{
    class AuditDefinitionDispatch;
}
namespace Teamcenter
{
    class AuditDefinitionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SA_API  Teamcenter::AuditDefinition
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AuditDefinition();

    /**
     * Destructor
     */
    virtual ~AuditDefinition();

private:
    //  Getter method for the Implementation Object
    AuditDefinitionImpl*  getAuditDefinitionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAuditDefinitionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AuditDefinitionImpl*  m_auditdefinitionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AuditDefinition - desc for AuditDefinition parameter
     */
    AuditDefinition( const AuditDefinition& );
    AuditDefinition& operator=( const AuditDefinition& );

    friend class  AuditDefinitionDelegate;
    friend class  AuditDefinitionDispatch;
    friend class  AuditDefinitionGenImpl;
};

#include <sa/libsa_undef.h>
#endif //   TEAMCENTER__AUDITDEFINITION__HXX
