//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AuditDefinitionDelegate
    Filename:   AuditDefinitionDelegate.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__AUDITDEFINITIONDELEGATE_HXX
#define TEAMCENTER__AUDITDEFINITIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <sa/AuditDefinition.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class AuditDefinitionDelegate;
}
namespace Teamcenter
{
    class AuditDefinitionImpl;
}
namespace Teamcenter
{
    class AuditDefinition;
}
namespace Teamcenter
{
    class AuditDefinitionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  SA_API Teamcenter_alias::AuditDefinitionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the AuditDefinitionDelegate instance
    static AuditDefinitionDelegate&  getInstance();

    //  Method to create the AuditDefinitionImpl pointer
    static AuditDefinitionImpl*  createImpl( AuditDefinition&  ifObj );

    //  Method to delete the AuditDefinitionImpl pointer
    static void deleteImpl( AuditDefinitionImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static AuditDefinitionDelegate*  m_pInstance;

    AuditDefinitionDelegate();
    virtual ~AuditDefinitionDelegate();
    static void setInstance( AuditDefinitionDelegate*  instance );


private:
    friend class  ::Teamcenter::AuditDefinitionGenImpl;

};

#include <sa/libsa_undef.h>
#endif  //  TEAMCENTER__AUDITDEFINITIONDELEGATE_HXX
