//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Discipline
    Filename:   Discipline.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__DISCIPLINE__HXX
#define TEAMCENTER__DISCIPLINE__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <cxpom/POM_system_class.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class Discipline;
}
namespace Teamcenter
{
    class DisciplineImpl;
}
namespace Teamcenter
{
    class DisciplineDelegate;
}
namespace Teamcenter
{
    class DisciplineDispatch;
}
namespace Teamcenter
{
    class DisciplineGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SA_API  Teamcenter::Discipline
     : public  ::Teamcenter::POM_system_class
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0OrganizationAuditLogs( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Discipline();

    /**
     * Destructor
     */
    virtual ~Discipline();

private:
    //  Getter method for the Implementation Object
    DisciplineImpl*  getDisciplineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDisciplineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DisciplineImpl*  m_disciplineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Discipline - desc for Discipline parameter
     */
    Discipline( const Discipline& );
    Discipline& operator=( const Discipline& );

    friend class  DisciplineDelegate;
    friend class  DisciplineDispatch;
    friend class  DisciplineGenImpl;
};

#include <sa/libsa_undef.h>
#endif //   TEAMCENTER__DISCIPLINE__HXX
