//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DisciplineDelegate
    Filename:   DisciplineDelegate.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__DISCIPLINEDELEGATE_HXX
#define TEAMCENTER__DISCIPLINEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <sa/Discipline.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class DisciplineDelegate;
}
namespace Teamcenter
{
    class DisciplineImpl;
}
namespace Teamcenter
{
    class Discipline;
}
namespace Teamcenter
{
    class DisciplineGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  SA_API Teamcenter_alias::DisciplineDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the DisciplineDelegate instance
    static DisciplineDelegate&  getInstance();

    //  Method to create the DisciplineImpl pointer
    static DisciplineImpl*  createImpl( Discipline&  ifObj );

    //  Method to delete the DisciplineImpl pointer
    static void deleteImpl( DisciplineImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0OrganizationAuditLogsBase(const Discipline &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static DisciplineDelegate*  m_pInstance;

    DisciplineDelegate();
    virtual ~DisciplineDelegate();
    static void setInstance( DisciplineDelegate*  instance );


private:
    friend class  ::Teamcenter::DisciplineGenImpl;

};

#include <sa/libsa_undef.h>
#endif  //  TEAMCENTER__DISCIPLINEDELEGATE_HXX
