//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EncryptionKey
    Filename:   EncryptionKey.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ENCRYPTIONKEY__HXX
#define TEAMCENTER__ENCRYPTIONKEY__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class EncryptionKey;
}
namespace Teamcenter
{
    class EncryptionKeyImpl;
}
namespace Teamcenter
{
    class EncryptionKeyDelegate;
}
namespace Teamcenter
{
    class EncryptionKeyDispatch;
}
namespace Teamcenter
{
    class EncryptionKeyGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SA_API  Teamcenter::EncryptionKey
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    EncryptionKey();

    /**
     * Destructor
     */
    virtual ~EncryptionKey();

private:
    //  Getter method for the Implementation Object
    EncryptionKeyImpl*  getEncryptionKeyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setEncryptionKeyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    EncryptionKeyImpl*  m_encryptionkeyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param EncryptionKey - desc for EncryptionKey parameter
     */
    EncryptionKey( const EncryptionKey& );
    EncryptionKey& operator=( const EncryptionKey& );

    friend class  EncryptionKeyDelegate;
    friend class  EncryptionKeyDispatch;
    friend class  EncryptionKeyGenImpl;
};

#include <sa/libsa_undef.h>
#endif //   TEAMCENTER__ENCRYPTIONKEY__HXX
