//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ClientSessionInfo
    Filename:   Fnd0ClientSessionInfo.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0CLIENTSESSIONINFO__HXX
#define TEAMCENTER__FND0CLIENTSESSIONINFO__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class Fnd0ClientSessionInfo;
}
namespace Teamcenter
{
    class Fnd0ClientSessionInfoImpl;
}
namespace Teamcenter
{
    class Fnd0ClientSessionInfoDelegate;
}
namespace Teamcenter
{
    class Fnd0ClientSessionInfoDispatch;
}
namespace Teamcenter
{
    class Fnd0ClientSessionInfoGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SA_API  Teamcenter::Fnd0ClientSessionInfo
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Setter for a Date Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0current_start_time( const date_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0ClientSessionInfo();

    /**
     * Destructor
     */
    virtual ~Fnd0ClientSessionInfo();

private:
    //  Getter method for the Implementation Object
    Fnd0ClientSessionInfoImpl*  getFnd0ClientSessionInfoImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0ClientSessionInfoImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0ClientSessionInfoImpl*  m_fnd0clientsessioninfoImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0ClientSessionInfo - desc for Fnd0ClientSessionInfo parameter
     */
    Fnd0ClientSessionInfo( const Fnd0ClientSessionInfo& );
    Fnd0ClientSessionInfo& operator=( const Fnd0ClientSessionInfo& );

    friend class  Fnd0ClientSessionInfoDelegate;
    friend class  Fnd0ClientSessionInfoDispatch;
    friend class  Fnd0ClientSessionInfoGenImpl;
};

#include <sa/libsa_undef.h>
#endif //   TEAMCENTER__FND0CLIENTSESSIONINFO__HXX
