//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0GDPRConsentDelegate
    Filename:   Fnd0GDPRConsentDelegate.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0GDPRCONSENTDELEGATE_HXX
#define TEAMCENTER__FND0GDPRCONSENTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <sa/Fnd0GDPRConsent.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class Fnd0GDPRConsentDelegate;
}
namespace Teamcenter
{
    class Fnd0GDPRConsentImpl;
}
namespace Teamcenter
{
    class Fnd0GDPRConsent;
}
namespace Teamcenter
{
    class Fnd0GDPRConsentGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  SA_API Teamcenter_alias::Fnd0GDPRConsentDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0GDPRConsentDelegate instance
    static Fnd0GDPRConsentDelegate&  getInstance();

    //  Method to create the Fnd0GDPRConsentImpl pointer
    static Fnd0GDPRConsentImpl*  createImpl( Fnd0GDPRConsent&  ifObj );

    //  Method to delete the Fnd0GDPRConsentImpl pointer
    static void deleteImpl( Fnd0GDPRConsentImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.4
    /// @param inputs - A vector of data that contains reference information to the object to be created
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0ValidateCreateInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.3
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - 
    ///
    int  fnd0ValidateSaveAsInputBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Fnd0GDPRConsent &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// validate saveas input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  validateSaveAsInputBase(const Fnd0GDPRConsent &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static Fnd0GDPRConsentDelegate*  m_pInstance;

    Fnd0GDPRConsentDelegate();
    virtual ~Fnd0GDPRConsentDelegate();
    static void setInstance( Fnd0GDPRConsentDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0GDPRConsentGenImpl;

};

#include <sa/libsa_undef.h>
#endif  //  TEAMCENTER__FND0GDPRCONSENTDELEGATE_HXX
