//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0OARAccessDlg
    Filename:   Fnd0OARAccessDlg.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0OARACCESSDLG__HXX
#define TEAMCENTER__FND0OARACCESSDLG__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class Fnd0OARAccessDlg;
}
namespace Teamcenter
{
    class Fnd0OARAccessDlgImpl;
}
namespace Teamcenter
{
    class Fnd0OARAccessDlgDelegate;
}
namespace Teamcenter
{
    class Fnd0OARAccessDlgDispatch;
}
namespace Teamcenter
{
    class Fnd0OARAccessDlgGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SA_API  Teamcenter::Fnd0OARAccessDlg
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 12.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0OARCanSeeAccessDetails( bool &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 12.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0OARCanSeeOthersAccess( bool &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 12.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0OAREvalCtxtGrp( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 12.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0OAREvalCtxtProj( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 12.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0OAREvalCtxtRole( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 12.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0OAREvalCtxtUsr( tag_t &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0OARAccessDlg();

    /**
     * Destructor
     */
    virtual ~Fnd0OARAccessDlg();

private:
    //  Getter method for the Implementation Object
    Fnd0OARAccessDlgImpl*  getFnd0OARAccessDlgImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0OARAccessDlgImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0OARAccessDlgImpl*  m_fnd0oaraccessdlgImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0OARAccessDlg - desc for Fnd0OARAccessDlg parameter
     */
    Fnd0OARAccessDlg( const Fnd0OARAccessDlg& );
    Fnd0OARAccessDlg& operator=( const Fnd0OARAccessDlg& );

    friend class  Fnd0OARAccessDlgDelegate;
    friend class  Fnd0OARAccessDlgDispatch;
    friend class  Fnd0OARAccessDlgGenImpl;
};

#include <sa/libsa_undef.h>
#endif //   TEAMCENTER__FND0OARACCESSDLG__HXX
