//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0OARAccessDlgDelegate
    Filename:   Fnd0OARAccessDlgDelegate.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0OARACCESSDLGDELEGATE_HXX
#define TEAMCENTER__FND0OARACCESSDLGDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <sa/Fnd0OARAccessDlg.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class Fnd0OARAccessDlgDelegate;
}
namespace Teamcenter
{
    class Fnd0OARAccessDlgImpl;
}
namespace Teamcenter
{
    class Fnd0OARAccessDlg;
}
namespace Teamcenter
{
    class Fnd0OARAccessDlgGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  SA_API Teamcenter_alias::Fnd0OARAccessDlgDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0OARAccessDlgDelegate instance
    static Fnd0OARAccessDlgDelegate&  getInstance();

    //  Method to create the Fnd0OARAccessDlgImpl pointer
    static Fnd0OARAccessDlgImpl*  createImpl( Fnd0OARAccessDlg&  ifObj );

    //  Method to delete the Fnd0OARAccessDlgImpl pointer
    static void deleteImpl( Fnd0OARAccessDlgImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 12.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0OARCanSeeAccessDetailsBase(const Fnd0OARAccessDlg &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 12.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0OARCanSeeOthersAccessBase(const Fnd0OARAccessDlg &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 12.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0OAREvalCtxtGrpBase(const Fnd0OARAccessDlg &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 12.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0OAREvalCtxtProjBase(const Fnd0OARAccessDlg &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 12.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0OAREvalCtxtRoleBase(const Fnd0OARAccessDlg &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 12.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0OAREvalCtxtUsrBase(const Fnd0OARAccessDlg &ifObj,  tag_t &value, bool &isNull ) const;



protected:
    //  Pointer to the instance
    static Fnd0OARAccessDlgDelegate*  m_pInstance;

    Fnd0OARAccessDlgDelegate();
    virtual ~Fnd0OARAccessDlgDelegate();
    static void setInstance( Fnd0OARAccessDlgDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0OARAccessDlgGenImpl;

};

#include <sa/libsa_undef.h>
#endif  //  TEAMCENTER__FND0OARACCESSDLGDELEGATE_HXX
