//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0OARAccessGroupsDynamicDelegate
    Filename:   Fnd0OARAccessGroupsDynamicDelegate.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0OARACCESSGROUPSDYNAMICDELEGATE_HXX
#define TEAMCENTER__FND0OARACCESSGROUPSDYNAMICDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <sa/Fnd0OARAccessGroupsDynamic.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class Fnd0OARAccessGroupsDynamicDelegate;
}
namespace Teamcenter
{
    class Fnd0OARAccessGroupsDynamicImpl;
}
namespace Teamcenter
{
    class Fnd0OARAccessGroupsDynamic;
}
namespace Teamcenter
{
    class Fnd0OARAccessGroupsDynamicGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  SA_API Teamcenter_alias::Fnd0OARAccessGroupsDynamicDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0OARAccessGroupsDynamicDelegate instance
    static Fnd0OARAccessGroupsDynamicDelegate&  getInstance();

    //  Method to create the Fnd0OARAccessGroupsDynamicImpl pointer
    static Fnd0OARAccessGroupsDynamicImpl*  createImpl( Fnd0OARAccessGroupsDynamic&  ifObj );

    //  Method to delete the Fnd0OARAccessGroupsDynamicImpl pointer
    static void deleteImpl( Fnd0OARAccessGroupsDynamicImpl*  impl );


    ///
    /// Returns List Of Values based on Dynamic LOV definition and user search criteria.
    /// @version Teamcenter 10
    /// @param operationInputTag - Operation Input containing the modified values.
    /// @param propertyName - Name of the selected property.
    /// @param searchString - User entered search string.
    /// @param sortByProp - Property to use for sorting.
    /// @param sortOrder - order for sorting (0=Ascending, 1=Descending).
    /// @param nResults - Number of returned results.
    /// @param results - Returned Values for LOV.
    /// @return - Zero (0) if everything is alright otherwise the error code.
    ///
    int  fnd0askLOVValuesBase(const Fnd0OARAccessGroupsDynamic &ifObj,  const tag_t operationInputTag, const std::string *propertyName, const std::string *searchString, const char *sortByProp, const int sortOrder, int *nResults, tag_t **results ) const;


    ///
    /// Returns true if the input value is valid for the Dynamic LOV.
    /// @version Teamcenter 10
    /// @param operationInput - Operation Input containing the modified values.
    /// @param propertyName - Name of the selected property.
    /// @param value - Value to validate.
    /// @param verdict - true if value is valid.
    /// @return - Zero (0) if everything is alright otherwise the error code.
    ///
    int  fnd0isValueValidBase(const Fnd0OARAccessGroupsDynamic &ifObj,  const tag_t operationInput, const std::string *propertyName, const tag_t value, bool *verdict ) const;



protected:
    //  Pointer to the instance
    static Fnd0OARAccessGroupsDynamicDelegate*  m_pInstance;

    Fnd0OARAccessGroupsDynamicDelegate();
    virtual ~Fnd0OARAccessGroupsDynamicDelegate();
    static void setInstance( Fnd0OARAccessGroupsDynamicDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0OARAccessGroupsDynamicGenImpl;

};

#include <sa/libsa_undef.h>
#endif  //  TEAMCENTER__FND0OARACCESSGROUPSDYNAMICDELEGATE_HXX
