//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0OARAccessUsersDynamicDelegate
    Filename:   Fnd0OARAccessUsersDynamicDelegate.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0OARACCESSUSERSDYNAMICDELEGATE_HXX
#define TEAMCENTER__FND0OARACCESSUSERSDYNAMICDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <sa/Fnd0OARAccessUsersDynamic.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class Fnd0OARAccessUsersDynamicDelegate;
}
namespace Teamcenter
{
    class Fnd0OARAccessUsersDynamicImpl;
}
namespace Teamcenter
{
    class Fnd0OARAccessUsersDynamic;
}
namespace Teamcenter
{
    class Fnd0OARAccessUsersDynamicGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  SA_API Teamcenter_alias::Fnd0OARAccessUsersDynamicDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0OARAccessUsersDynamicDelegate instance
    static Fnd0OARAccessUsersDynamicDelegate&  getInstance();

    //  Method to create the Fnd0OARAccessUsersDynamicImpl pointer
    static Fnd0OARAccessUsersDynamicImpl*  createImpl( Fnd0OARAccessUsersDynamic&  ifObj );

    //  Method to delete the Fnd0OARAccessUsersDynamicImpl pointer
    static void deleteImpl( Fnd0OARAccessUsersDynamicImpl*  impl );


    ///
    /// Returns List Of Values based on Dynamic LOV definition and user search criteria.
    /// @version Teamcenter 10
    /// @param operationInputTag - Operation Input containing the modified values.
    /// @param propertyName - Name of the selected property.
    /// @param searchString - User entered search string.
    /// @param sortByProp - Property to use for sorting.
    /// @param sortOrder - order for sorting (0=Ascending, 1=Descending).
    /// @param nResults - Number of returned results.
    /// @param results - Returned Values for LOV.
    /// @return - Zero (0) if everything is alright otherwise the error code.
    ///
    int  fnd0askLOVValuesBase(const Fnd0OARAccessUsersDynamic &ifObj,  const tag_t operationInputTag, const std::string *propertyName, const std::string *searchString, const char *sortByProp, const int sortOrder, int *nResults, tag_t **results ) const;


    ///
    /// Returns true if the input value is valid for the Dynamic LOV.
    /// @version Teamcenter 10
    /// @param operationInput - Operation Input containing the modified values.
    /// @param propertyName - Name of the selected property.
    /// @param value - Value to validate.
    /// @param verdict - true if value is valid.
    /// @return - Zero (0) if everything is alright otherwise the error code.
    ///
    int  fnd0isValueValidBase(const Fnd0OARAccessUsersDynamic &ifObj,  const tag_t operationInput, const std::string *propertyName, const tag_t value, bool *verdict ) const;



protected:
    //  Pointer to the instance
    static Fnd0OARAccessUsersDynamicDelegate*  m_pInstance;

    Fnd0OARAccessUsersDynamicDelegate();
    virtual ~Fnd0OARAccessUsersDynamicDelegate();
    static void setInstance( Fnd0OARAccessUsersDynamicDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0OARAccessUsersDynamicGenImpl;

};

#include <sa/libsa_undef.h>
#endif  //  TEAMCENTER__FND0OARACCESSUSERSDYNAMICDELEGATE_HXX
