//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0OARConditionProp
    Filename:   Fnd0OARConditionProp.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0OARCONDITIONPROP__HXX
#define TEAMCENTER__FND0OARCONDITIONPROP__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class Fnd0OARConditionProp;
}
namespace Teamcenter
{
    class Fnd0OARConditionPropImpl;
}
namespace Teamcenter
{
    class Fnd0OARConditionPropDelegate;
}
namespace Teamcenter
{
    class Fnd0OARConditionPropDispatch;
}
namespace Teamcenter
{
    class Fnd0OARConditionPropGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SA_API  Teamcenter::Fnd0OARConditionProp
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 12.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0PropDesc( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 12.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0PropName( std::string &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0OARConditionProp();

    /**
     * Destructor
     */
    virtual ~Fnd0OARConditionProp();

private:
    //  Getter method for the Implementation Object
    Fnd0OARConditionPropImpl*  getFnd0OARConditionPropImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0OARConditionPropImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0OARConditionPropImpl*  m_fnd0oarconditionpropImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0OARConditionProp - desc for Fnd0OARConditionProp parameter
     */
    Fnd0OARConditionProp( const Fnd0OARConditionProp& );
    Fnd0OARConditionProp& operator=( const Fnd0OARConditionProp& );

    friend class  Fnd0OARConditionPropDelegate;
    friend class  Fnd0OARConditionPropDispatch;
    friend class  Fnd0OARConditionPropGenImpl;
};

#include <sa/libsa_undef.h>
#endif //   TEAMCENTER__FND0OARCONDITIONPROP__HXX
