//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0OARFunctionArgValue
    Filename:   Fnd0OARFunctionArgValue.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0OARFUNCTIONARGVALUE__HXX
#define TEAMCENTER__FND0OARFUNCTIONARGVALUE__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class Fnd0OARFunctionArgValue;
}
namespace Teamcenter
{
    class Fnd0OARFunctionArgValueImpl;
}
namespace Teamcenter
{
    class Fnd0OARFunctionArgValueDelegate;
}
namespace Teamcenter
{
    class Fnd0OARFunctionArgValueDispatch;
}
namespace Teamcenter
{
    class Fnd0OARFunctionArgValueGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SA_API  Teamcenter::Fnd0OARFunctionArgValue
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 12
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0OARArgumentValues( std::vector< std::string > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0OARFunctionArgValue();

    /**
     * Destructor
     */
    virtual ~Fnd0OARFunctionArgValue();

private:
    //  Getter method for the Implementation Object
    Fnd0OARFunctionArgValueImpl*  getFnd0OARFunctionArgValueImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0OARFunctionArgValueImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0OARFunctionArgValueImpl*  m_fnd0oarfunctionargvalueImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0OARFunctionArgValue - desc for Fnd0OARFunctionArgValue parameter
     */
    Fnd0OARFunctionArgValue( const Fnd0OARFunctionArgValue& );
    Fnd0OARFunctionArgValue& operator=( const Fnd0OARFunctionArgValue& );

    friend class  Fnd0OARFunctionArgValueDelegate;
    friend class  Fnd0OARFunctionArgValueDispatch;
    friend class  Fnd0OARFunctionArgValueGenImpl;
};

#include <sa/libsa_undef.h>
#endif //   TEAMCENTER__FND0OARFUNCTIONARGVALUE__HXX
