//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0OARFunctionArgValueLOVDelegate
    Filename:   Fnd0OARFunctionArgValueLOVDelegate.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0OARFUNCTIONARGVALUELOVDELEGATE_HXX
#define TEAMCENTER__FND0OARFUNCTIONARGVALUELOVDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <sa/Fnd0OARFunctionArgValueLOV.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class Fnd0OARFunctionArgValueLOVDelegate;
}
namespace Teamcenter
{
    class Fnd0OARFunctionArgValueLOVImpl;
}
namespace Teamcenter
{
    class Fnd0OARFunctionArgValueLOV;
}
namespace Teamcenter
{
    class Fnd0OARFunctionArgValueLOVGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  SA_API Teamcenter_alias::Fnd0OARFunctionArgValueLOVDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0OARFunctionArgValueLOVDelegate instance
    static Fnd0OARFunctionArgValueLOVDelegate&  getInstance();

    //  Method to create the Fnd0OARFunctionArgValueLOVImpl pointer
    static Fnd0OARFunctionArgValueLOVImpl*  createImpl( Fnd0OARFunctionArgValueLOV&  ifObj );

    //  Method to delete the Fnd0OARFunctionArgValueLOVImpl pointer
    static void deleteImpl( Fnd0OARFunctionArgValueLOVImpl*  impl );


    ///
    /// Returns List Of Values based on Dynamic LOV definition and user search criteria.
    /// @version Teamcenter 10
    /// @param operationInputTag - Operation Input containing the modified values.
    /// @param propertyName - Name of the selected property.
    /// @param searchString - User entered search string.
    /// @param sortByProp - Property to use for sorting.
    /// @param sortOrder - order for sorting (0=Ascending, 1=Descending).
    /// @param nResults - Number of returned results.
    /// @param results - Returned Values for LOV.
    /// @return - Zero (0) if everything is alright otherwise the error code.
    ///
    int  fnd0askLOVValuesBase(const Fnd0OARFunctionArgValueLOV &ifObj,  const tag_t operationInputTag, const std::string *propertyName, const std::string *searchString, const char *sortByProp, const int sortOrder, int *nResults, tag_t **results ) const;


    ///
    /// Returns true if the input value is valid for the Dynamic LOV.
    /// @version Teamcenter 10
    /// @param operationInputTag - Operation Input containing the modified values.
    /// @param propertyName - Name of the selected property.
    /// @param value - Value to validate.
    /// @param verdict - true if value is valid.
    /// @return - Zero (0) if everything is alright otherwise the error code.
    ///
    int  fnd0isValueValidBase(const Fnd0OARFunctionArgValueLOV &ifObj,  const tag_t operationInputTag, const std::string *propertyName, const std::string *value, bool *verdict ) const;



protected:
    //  Pointer to the instance
    static Fnd0OARFunctionArgValueLOVDelegate*  m_pInstance;

    Fnd0OARFunctionArgValueLOVDelegate();
    virtual ~Fnd0OARFunctionArgValueLOVDelegate();
    static void setInstance( Fnd0OARFunctionArgValueLOVDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0OARFunctionArgValueLOVGenImpl;

};

#include <sa/libsa_undef.h>
#endif  //  TEAMCENTER__FND0OARFUNCTIONARGVALUELOVDELEGATE_HXX
