//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0OAROp
    Filename:   Fnd0OAROp.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0OAROP__HXX
#define TEAMCENTER__FND0OAROP__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class Fnd0OAROp;
}
namespace Teamcenter
{
    class Fnd0OAROpImpl;
}
namespace Teamcenter
{
    class Fnd0OAROpDelegate;
}
namespace Teamcenter
{
    class Fnd0OAROpDispatch;
}
namespace Teamcenter
{
    class Fnd0OAROpGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SA_API  Teamcenter::Fnd0OAROp
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 12
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0OAROpDesc( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 12
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0OAROpName( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 12
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0OAROpType( std::string &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0OAROp();

    /**
     * Destructor
     */
    virtual ~Fnd0OAROp();

private:
    //  Getter method for the Implementation Object
    Fnd0OAROpImpl*  getFnd0OAROpImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0OAROpImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0OAROpImpl*  m_fnd0oaropImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0OAROp - desc for Fnd0OAROp parameter
     */
    Fnd0OAROp( const Fnd0OAROp& );
    Fnd0OAROp& operator=( const Fnd0OAROp& );

    friend class  Fnd0OAROpDelegate;
    friend class  Fnd0OAROpDispatch;
    friend class  Fnd0OAROpGenImpl;
};

#include <sa/libsa_undef.h>
#endif //   TEAMCENTER__FND0OAROP__HXX
