//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0OARRuleAccessor
    Filename:   Fnd0OARRuleAccessor.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0OARRULEACCESSOR__HXX
#define TEAMCENTER__FND0OARRULEACCESSOR__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class Fnd0OARRuleAccessor;
}
namespace Teamcenter
{
    class Fnd0OARRuleAccessorImpl;
}
namespace Teamcenter
{
    class Fnd0OARRuleAccessorDelegate;
}
namespace Teamcenter
{
    class Fnd0OARRuleAccessorDispatch;
}
namespace Teamcenter
{
    class Fnd0OARRuleAccessorGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SA_API  Teamcenter::Fnd0OARRuleAccessor
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 12
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0AccessorDesc( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 12
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0AccessorName( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 12
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0AccessorDesc( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0OARRuleAccessor();

    /**
     * Destructor
     */
    virtual ~Fnd0OARRuleAccessor();

private:
    //  Getter method for the Implementation Object
    Fnd0OARRuleAccessorImpl*  getFnd0OARRuleAccessorImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0OARRuleAccessorImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0OARRuleAccessorImpl*  m_fnd0oarruleaccessorImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0OARRuleAccessor - desc for Fnd0OARRuleAccessor parameter
     */
    Fnd0OARRuleAccessor( const Fnd0OARRuleAccessor& );
    Fnd0OARRuleAccessor& operator=( const Fnd0OARRuleAccessor& );

    friend class  Fnd0OARRuleAccessorDelegate;
    friend class  Fnd0OARRuleAccessorDispatch;
    friend class  Fnd0OARRuleAccessorGenImpl;
};

#include <sa/libsa_undef.h>
#endif //   TEAMCENTER__FND0OARRULEACCESSOR__HXX
