//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0OARRuleAccessorLOVDelegate
    Filename:   Fnd0OARRuleAccessorLOVDelegate.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0OARRULEACCESSORLOVDELEGATE_HXX
#define TEAMCENTER__FND0OARRULEACCESSORLOVDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <sa/Fnd0OARRuleAccessorLOV.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class Fnd0OARRuleAccessorLOVDelegate;
}
namespace Teamcenter
{
    class Fnd0OARRuleAccessorLOVImpl;
}
namespace Teamcenter
{
    class Fnd0OARRuleAccessorLOV;
}
namespace Teamcenter
{
    class Fnd0OARRuleAccessorLOVGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  SA_API Teamcenter_alias::Fnd0OARRuleAccessorLOVDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0OARRuleAccessorLOVDelegate instance
    static Fnd0OARRuleAccessorLOVDelegate&  getInstance();

    //  Method to create the Fnd0OARRuleAccessorLOVImpl pointer
    static Fnd0OARRuleAccessorLOVImpl*  createImpl( Fnd0OARRuleAccessorLOV&  ifObj );

    //  Method to delete the Fnd0OARRuleAccessorLOVImpl pointer
    static void deleteImpl( Fnd0OARRuleAccessorLOVImpl*  impl );


    ///
    /// Returns List Of Values based on Dynamic LOV definition and user search criteria.
    /// @version Teamcenter 10
    /// @param operationInputTag - Operation Input containing the modified values.
    /// @param propertyName - Name of the selected property.
    /// @param searchString - User entered search string.
    /// @param sortByProp - Property to use for sorting.
    /// @param sortOrder - order for sorting (0=Ascending, 1=Descending).
    /// @param nResults - Number of returned results.
    /// @param results - Returned Values for LOV.
    /// @return - Zero (0) if everything is alright otherwise the error code.
    ///
    int  fnd0askLOVValuesBase(const Fnd0OARRuleAccessorLOV &ifObj,  const tag_t operationInputTag, const std::string *propertyName, const std::string *searchString, const char *sortByProp, const int sortOrder, int *nResults, tag_t **results ) const;


    ///
    /// Returns true if the input value is valid for the Dynamic LOV.
    /// @version Teamcenter 10
    /// @param operationInputTag - Operation Input containing the modified values.
    /// @param propertyName - Name of the selected property.
    /// @param value - Value to validate.
    /// @param verdict - true if value is valid.
    /// @return - Zero (0) if everything is alright otherwise the error code.
    ///
    int  fnd0isValueValidBase(const Fnd0OARRuleAccessorLOV &ifObj,  const tag_t operationInputTag, const std::string *propertyName, const std::string *value, bool *verdict ) const;



protected:
    //  Pointer to the instance
    static Fnd0OARRuleAccessorLOVDelegate*  m_pInstance;

    Fnd0OARRuleAccessorLOVDelegate();
    virtual ~Fnd0OARRuleAccessorLOVDelegate();
    static void setInstance( Fnd0OARRuleAccessorLOVDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0OARRuleAccessorLOVGenImpl;

};

#include <sa/libsa_undef.h>
#endif  //  TEAMCENTER__FND0OARRULEACCESSORLOVDELEGATE_HXX
