//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0PrivateKey
    Filename:   Fnd0PrivateKey.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0PRIVATEKEY__HXX
#define TEAMCENTER__FND0PRIVATEKEY__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class Fnd0PrivateKey;
}
namespace Teamcenter
{
    class Fnd0PrivateKeyImpl;
}
namespace Teamcenter
{
    class Fnd0PrivateKeyDelegate;
}
namespace Teamcenter
{
    class Fnd0PrivateKeyDispatch;
}
namespace Teamcenter
{
    class Fnd0PrivateKeyGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SA_API  Teamcenter::Fnd0PrivateKey
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// 
    /// @version Teamcenter 11.1
    /// @param identifier - External identifier for identifying the matching public key for decryption.
    /// @return - 
    ///
    int  fnd0GetExternalIdentifier( char **identifier );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0PrivateKey();

    /**
     * Destructor
     */
    virtual ~Fnd0PrivateKey();

private:
    //  Getter method for the Implementation Object
    Fnd0PrivateKeyImpl*  getFnd0PrivateKeyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0PrivateKeyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0PrivateKeyImpl*  m_fnd0privatekeyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0PrivateKey - desc for Fnd0PrivateKey parameter
     */
    Fnd0PrivateKey( const Fnd0PrivateKey& );
    Fnd0PrivateKey& operator=( const Fnd0PrivateKey& );

    friend class  Fnd0PrivateKeyDelegate;
    friend class  Fnd0PrivateKeyDispatch;
    friend class  Fnd0PrivateKeyGenImpl;
};

#include <sa/libsa_undef.h>
#endif //   TEAMCENTER__FND0PRIVATEKEY__HXX
