//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0PrivateKeyDelegate
    Filename:   Fnd0PrivateKeyDelegate.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0PRIVATEKEYDELEGATE_HXX
#define TEAMCENTER__FND0PRIVATEKEYDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <sa/Fnd0PrivateKey.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class Fnd0PrivateKeyDelegate;
}
namespace Teamcenter
{
    class Fnd0PrivateKeyImpl;
}
namespace Teamcenter
{
    class Fnd0PrivateKey;
}
namespace Teamcenter
{
    class Fnd0PrivateKeyGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  SA_API Teamcenter_alias::Fnd0PrivateKeyDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0PrivateKeyDelegate instance
    static Fnd0PrivateKeyDelegate&  getInstance();

    //  Method to create the Fnd0PrivateKeyImpl pointer
    static Fnd0PrivateKeyImpl*  createImpl( Fnd0PrivateKey&  ifObj );

    //  Method to delete the Fnd0PrivateKeyImpl pointer
    static void deleteImpl( Fnd0PrivateKeyImpl*  impl );


    ///
    /// 
    /// @version Teamcenter 11.1
    /// @param identifier - External identifier for identifying the matching public key for decryption.
    /// @return - 
    ///
    int  fnd0GetExternalIdentifierBase(const Fnd0PrivateKey &ifObj,  char **identifier );



protected:
    //  Pointer to the instance
    static Fnd0PrivateKeyDelegate*  m_pInstance;

    Fnd0PrivateKeyDelegate();
    virtual ~Fnd0PrivateKeyDelegate();
    static void setInstance( Fnd0PrivateKeyDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0PrivateKeyGenImpl;

};

#include <sa/libsa_undef.h>
#endif  //  TEAMCENTER__FND0PRIVATEKEYDELEGATE_HXX
