//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, GroupMember
    Filename:   GroupMember.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__GROUPMEMBER__HXX
#define TEAMCENTER__GROUPMEMBER__HXX

#include <string>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <sa/POM_member.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class GroupMember;
}
namespace Teamcenter
{
    class GroupMemberImpl;
}
namespace Teamcenter
{
    class GroupMemberDelegate;
}
namespace Teamcenter
{
    class GroupMemberDispatch;
}
namespace Teamcenter
{
    class GroupMemberGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SA_API  Teamcenter::GroupMember
     : public  ::Teamcenter::POM_member
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0export_sites( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0OrganizationAuditLogs( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    GroupMember();

    /**
     * Destructor
     */
    virtual ~GroupMember();

private:
    //  Getter method for the Implementation Object
    GroupMemberImpl*  getGroupMemberImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setGroupMemberImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    GroupMemberImpl*  m_groupmemberImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param GroupMember - desc for GroupMember parameter
     */
    GroupMember( const GroupMember& );
    GroupMember& operator=( const GroupMember& );

    friend class  GroupMemberDelegate;
    friend class  GroupMemberDispatch;
    friend class  GroupMemberGenImpl;
};

#include <sa/libsa_undef.h>
#endif //   TEAMCENTER__GROUPMEMBER__HXX
