//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, GroupMemberDelegate
    Filename:   GroupMemberDelegate.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__GROUPMEMBERDELEGATE_HXX
#define TEAMCENTER__GROUPMEMBERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <sa/GroupMember.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class GroupMemberDelegate;
}
namespace Teamcenter
{
    class GroupMemberImpl;
}
namespace Teamcenter
{
    class GroupMember;
}
namespace Teamcenter
{
    class GroupMemberGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  SA_API Teamcenter_alias::GroupMemberDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the GroupMemberDelegate instance
    static GroupMemberDelegate&  getInstance();

    //  Method to create the GroupMemberImpl pointer
    static GroupMemberImpl*  createImpl( GroupMember&  ifObj );

    //  Method to delete the GroupMemberImpl pointer
    static void deleteImpl( GroupMemberImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0export_sitesBase(const GroupMember &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0OrganizationAuditLogsBase(const GroupMember &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static GroupMemberDelegate*  m_pInstance;

    GroupMemberDelegate();
    virtual ~GroupMemberDelegate();
    static void setInstance( GroupMemberDelegate*  instance );


private:
    friend class  ::Teamcenter::GroupMemberGenImpl;

};

#include <sa/libsa_undef.h>
#endif  //  TEAMCENTER__GROUPMEMBERDELEGATE_HXX
