//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, HSM_Info
    Filename:   HSM_Info.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__HSM_INFO__HXX
#define TEAMCENTER__HSM_INFO__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class HSM_Info;
}
namespace Teamcenter
{
    class HSM_InfoImpl;
}
namespace Teamcenter
{
    class HSM_InfoDelegate;
}
namespace Teamcenter
{
    class HSM_InfoDispatch;
}
namespace Teamcenter
{
    class HSM_InfoGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SA_API  Teamcenter::HSM_Info
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    HSM_Info();

    /**
     * Destructor
     */
    virtual ~HSM_Info();

private:
    //  Getter method for the Implementation Object
    HSM_InfoImpl*  getHSM_InfoImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setHSM_InfoImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    HSM_InfoImpl*  m_hsm_infoImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param HSM_Info - desc for HSM_Info parameter
     */
    HSM_Info( const HSM_Info& );
    HSM_Info& operator=( const HSM_Info& );

    friend class  HSM_InfoDelegate;
    friend class  HSM_InfoDispatch;
    friend class  HSM_InfoGenImpl;
};

#include <sa/libsa_undef.h>
#endif //   TEAMCENTER__HSM_INFO__HXX
