//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, HSM_Policy
    Filename:   HSM_Policy.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__HSM_POLICY__HXX
#define TEAMCENTER__HSM_POLICY__HXX

#include <common/tc_deprecation_macros.h>
#include <sa/Migration_Policy.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class HSM_Policy;
}
namespace Teamcenter
{
    class HSM_PolicyImpl;
}
namespace Teamcenter
{
    class HSM_PolicyDelegate;
}
namespace Teamcenter
{
    class HSM_PolicyDispatch;
}
namespace Teamcenter
{
    class HSM_PolicyGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SA_API  Teamcenter::HSM_Policy
     : public  ::Teamcenter::Migration_Policy
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    HSM_Policy();

    /**
     * Destructor
     */
    virtual ~HSM_Policy();

private:
    //  Getter method for the Implementation Object
    HSM_PolicyImpl*  getHSM_PolicyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setHSM_PolicyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    HSM_PolicyImpl*  m_hsm_policyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param HSM_Policy - desc for HSM_Policy parameter
     */
    HSM_Policy( const HSM_Policy& );
    HSM_Policy& operator=( const HSM_Policy& );

    friend class  HSM_PolicyDelegate;
    friend class  HSM_PolicyDispatch;
    friend class  HSM_PolicyGenImpl;
};

#include <sa/libsa_undef.h>
#endif //   TEAMCENTER__HSM_POLICY__HXX
