//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ImanFile
    Filename:   ImanFile.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IMANFILE__HXX
#define TEAMCENTER__IMANFILE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class ImanFile;
}
namespace Teamcenter
{
    class ImanFileImpl;
}
namespace Teamcenter
{
    class ImanFileDelegate;
}
namespace Teamcenter
{
    class ImanFileDispatch;
}
namespace Teamcenter
{
    class ImanFileGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SA_API  Teamcenter::ImanFile
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ImanFile();

    /**
     * Destructor
     */
    virtual ~ImanFile();

private:
    //  Getter method for the Implementation Object
    ImanFileImpl*  getImanFileImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setImanFileImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ImanFileImpl*  m_imanfileImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ImanFile - desc for ImanFile parameter
     */
    ImanFile( const ImanFile& );
    ImanFile& operator=( const ImanFile& );

    friend class  ImanFileDelegate;
    friend class  ImanFileDispatch;
    friend class  ImanFileGenImpl;
};

#include <sa/libsa_undef.h>
#endif //   TEAMCENTER__IMANFILE__HXX
