//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ImanVolume
    Filename:   ImanVolume.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IMANVOLUME__HXX
#define TEAMCENTER__IMANVOLUME__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class ImanVolume;
}
namespace Teamcenter
{
    class ImanVolumeImpl;
}
namespace Teamcenter
{
    class ImanVolumeDelegate;
}
namespace Teamcenter
{
    class ImanVolumeDispatch;
}
namespace Teamcenter
{
    class ImanVolumeGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SA_API  Teamcenter::ImanVolume
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0OrganizationAuditLogs( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ImanVolume();

    /**
     * Destructor
     */
    virtual ~ImanVolume();

private:
    //  Getter method for the Implementation Object
    ImanVolumeImpl*  getImanVolumeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setImanVolumeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ImanVolumeImpl*  m_imanvolumeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ImanVolume - desc for ImanVolume parameter
     */
    ImanVolume( const ImanVolume& );
    ImanVolume& operator=( const ImanVolume& );

    friend class  ImanVolumeDelegate;
    friend class  ImanVolumeDispatch;
    friend class  ImanVolumeGenImpl;
};

#include <sa/libsa_undef.h>
#endif //   TEAMCENTER__IMANVOLUME__HXX
