//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ImanVolumeDelegate
    Filename:   ImanVolumeDelegate.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IMANVOLUMEDELEGATE_HXX
#define TEAMCENTER__IMANVOLUMEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <sa/ImanVolume.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class ImanVolumeDelegate;
}
namespace Teamcenter
{
    class ImanVolumeImpl;
}
namespace Teamcenter
{
    class ImanVolume;
}
namespace Teamcenter
{
    class ImanVolumeGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  SA_API Teamcenter_alias::ImanVolumeDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ImanVolumeDelegate instance
    static ImanVolumeDelegate&  getInstance();

    //  Method to create the ImanVolumeImpl pointer
    static ImanVolumeImpl*  createImpl( ImanVolume&  ifObj );

    //  Method to delete the ImanVolumeImpl pointer
    static void deleteImpl( ImanVolumeImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0OrganizationAuditLogsBase(const ImanVolume &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @param isLockForDelete - A boolean to indicate if object(s) are to be locked for deletion
    /// @param allowRelock - A boolean to indicate if object(s) can be relocked, which will discard all unsaved changes, if already locked by the same user
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0LockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd, const bool isLockForDelete, const bool allowRelock );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0RefreshBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0UnlockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static ImanVolumeDelegate*  m_pInstance;

    ImanVolumeDelegate();
    virtual ~ImanVolumeDelegate();
    static void setInstance( ImanVolumeDelegate*  instance );


private:
    friend class  ::Teamcenter::ImanVolumeGenImpl;

};

#include <sa/libsa_undef.h>
#endif  //  TEAMCENTER__IMANVOLUMEDELEGATE_HXX
