//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Migration_Distribution
    Filename:   Migration_Distribution.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MIGRATION_DISTRIBUTION__HXX
#define TEAMCENTER__MIGRATION_DISTRIBUTION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class Migration_Distribution;
}
namespace Teamcenter
{
    class Migration_DistributionImpl;
}
namespace Teamcenter
{
    class Migration_DistributionDelegate;
}
namespace Teamcenter
{
    class Migration_DistributionDispatch;
}
namespace Teamcenter
{
    class Migration_DistributionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SA_API  Teamcenter::Migration_Distribution
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Migration_Distribution();

    /**
     * Destructor
     */
    virtual ~Migration_Distribution();

private:
    //  Getter method for the Implementation Object
    Migration_DistributionImpl*  getMigration_DistributionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMigration_DistributionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Migration_DistributionImpl*  m_migration_distributionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Migration_Distribution - desc for Migration_Distribution parameter
     */
    Migration_Distribution( const Migration_Distribution& );
    Migration_Distribution& operator=( const Migration_Distribution& );

    friend class  Migration_DistributionDelegate;
    friend class  Migration_DistributionDispatch;
    friend class  Migration_DistributionGenImpl;
};

#include <sa/libsa_undef.h>
#endif //   TEAMCENTER__MIGRATION_DISTRIBUTION__HXX
