//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Migration_Pending
    Filename:   Migration_Pending.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MIGRATION_PENDING__HXX
#define TEAMCENTER__MIGRATION_PENDING__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class Migration_Pending;
}
namespace Teamcenter
{
    class Migration_PendingImpl;
}
namespace Teamcenter
{
    class Migration_PendingDelegate;
}
namespace Teamcenter
{
    class Migration_PendingDispatch;
}
namespace Teamcenter
{
    class Migration_PendingGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SA_API  Teamcenter::Migration_Pending
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Migration_Pending();

    /**
     * Destructor
     */
    virtual ~Migration_Pending();

private:
    //  Getter method for the Implementation Object
    Migration_PendingImpl*  getMigration_PendingImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMigration_PendingImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Migration_PendingImpl*  m_migration_pendingImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Migration_Pending - desc for Migration_Pending parameter
     */
    Migration_Pending( const Migration_Pending& );
    Migration_Pending& operator=( const Migration_Pending& );

    friend class  Migration_PendingDelegate;
    friend class  Migration_PendingDispatch;
    friend class  Migration_PendingGenImpl;
};

#include <sa/libsa_undef.h>
#endif //   TEAMCENTER__MIGRATION_PENDING__HXX
