//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Migration_PendingDelegate
    Filename:   Migration_PendingDelegate.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MIGRATION_PENDINGDELEGATE_HXX
#define TEAMCENTER__MIGRATION_PENDINGDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <sa/Migration_Pending.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class Migration_PendingDelegate;
}
namespace Teamcenter
{
    class Migration_PendingImpl;
}
namespace Teamcenter
{
    class Migration_Pending;
}
namespace Teamcenter
{
    class Migration_PendingGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  SA_API Teamcenter_alias::Migration_PendingDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Migration_PendingDelegate instance
    static Migration_PendingDelegate&  getInstance();

    //  Method to create the Migration_PendingImpl pointer
    static Migration_PendingImpl*  createImpl( Migration_Pending&  ifObj );

    //  Method to delete the Migration_PendingImpl pointer
    static void deleteImpl( Migration_PendingImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static Migration_PendingDelegate*  m_pInstance;

    Migration_PendingDelegate();
    virtual ~Migration_PendingDelegate();
    static void setInstance( Migration_PendingDelegate*  instance );


private:
    friend class  ::Teamcenter::Migration_PendingGenImpl;

};

#include <sa/libsa_undef.h>
#endif  //  TEAMCENTER__MIGRATION_PENDINGDELEGATE_HXX
