//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Migration_Policy
    Filename:   Migration_Policy.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MIGRATION_POLICY__HXX
#define TEAMCENTER__MIGRATION_POLICY__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class Migration_Policy;
}
namespace Teamcenter
{
    class Migration_PolicyImpl;
}
namespace Teamcenter
{
    class Migration_PolicyDelegate;
}
namespace Teamcenter
{
    class Migration_PolicyDispatch;
}
namespace Teamcenter
{
    class Migration_PolicyGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SA_API  Teamcenter::Migration_Policy
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Migration_Policy();

    /**
     * Destructor
     */
    virtual ~Migration_Policy();

private:
    //  Getter method for the Implementation Object
    Migration_PolicyImpl*  getMigration_PolicyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMigration_PolicyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Migration_PolicyImpl*  m_migration_policyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Migration_Policy - desc for Migration_Policy parameter
     */
    Migration_Policy( const Migration_Policy& );
    Migration_Policy& operator=( const Migration_Policy& );

    friend class  Migration_PolicyDelegate;
    friend class  Migration_PolicyDispatch;
    friend class  Migration_PolicyGenImpl;
};

#include <sa/libsa_undef.h>
#endif //   TEAMCENTER__MIGRATION_POLICY__HXX
