//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Migration_Report
    Filename:   Migration_Report.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MIGRATION_REPORT__HXX
#define TEAMCENTER__MIGRATION_REPORT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class Migration_Report;
}
namespace Teamcenter
{
    class Migration_ReportImpl;
}
namespace Teamcenter
{
    class Migration_ReportDelegate;
}
namespace Teamcenter
{
    class Migration_ReportDispatch;
}
namespace Teamcenter
{
    class Migration_ReportGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SA_API  Teamcenter::Migration_Report
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Migration_Report();

    /**
     * Destructor
     */
    virtual ~Migration_Report();

private:
    //  Getter method for the Implementation Object
    Migration_ReportImpl*  getMigration_ReportImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setMigration_ReportImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Migration_ReportImpl*  m_migration_reportImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Migration_Report - desc for Migration_Report parameter
     */
    Migration_Report( const Migration_Report& );
    Migration_Report& operator=( const Migration_Report& );

    friend class  Migration_ReportDelegate;
    friend class  Migration_ReportDispatch;
    friend class  Migration_ReportGenImpl;
};

#include <sa/libsa_undef.h>
#endif //   TEAMCENTER__MIGRATION_REPORT__HXX
