//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, POM_group
    Filename:   POM_group.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__POM_GROUP__HXX
#define TEAMCENTER__POM_GROUP__HXX

#include <string>
#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <cxpom/POM_system_class.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class POM_group;
}
namespace Teamcenter
{
    class POM_groupImpl;
}
namespace Teamcenter
{
    class POM_groupDelegate;
}
namespace Teamcenter
{
    class POM_groupDispatch;
}
namespace Teamcenter
{
    class POM_groupGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SA_API  Teamcenter::POM_group
     : public  ::Teamcenter::POM_system_class
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setName( const std::string &value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setParent( const tag_t &value, bool isNull=false );

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPrivilege( int value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    POM_group();

    /**
     * Destructor
     */
    virtual ~POM_group();

private:
    //  Getter method for the Implementation Object
    POM_groupImpl*  getPOM_groupImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPOM_groupImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    POM_groupImpl*  m_pom_groupImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param POM_group - desc for POM_group parameter
     */
    POM_group( const POM_group& );
    POM_group& operator=( const POM_group& );

    friend class  POM_groupDelegate;
    friend class  POM_groupDispatch;
    friend class  POM_groupGenImpl;
};

#include <sa/libsa_undef.h>
#endif //   TEAMCENTER__POM_GROUP__HXX
