//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, POM_groupDelegate
    Filename:   POM_groupDelegate.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__POM_GROUPDELEGATE_HXX
#define TEAMCENTER__POM_GROUPDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <sa/POM_group.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class POM_groupDelegate;
}
namespace Teamcenter
{
    class POM_groupImpl;
}
namespace Teamcenter
{
    class POM_group;
}
namespace Teamcenter
{
    class POM_groupGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  SA_API Teamcenter_alias::POM_groupDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the POM_groupDelegate instance
    static POM_groupDelegate&  getInstance();

    //  Method to create the POM_groupImpl pointer
    static POM_groupImpl*  createImpl( POM_group&  ifObj );

    //  Method to delete the POM_groupImpl pointer
    static void deleteImpl( POM_groupImpl*  impl );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setNameBase(POM_group &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setParentBase(POM_group &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPrivilegeBase(POM_group &ifObj,  int value, bool isNull );



protected:
    //  Pointer to the instance
    static POM_groupDelegate*  m_pInstance;

    POM_groupDelegate();
    virtual ~POM_groupDelegate();
    static void setInstance( POM_groupDelegate*  instance );


private:
    friend class  ::Teamcenter::POM_groupGenImpl;

};

#include <sa/libsa_undef.h>
#endif  //  TEAMCENTER__POM_GROUPDELEGATE_HXX
