//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, POM_member
    Filename:   POM_member.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__POM_MEMBER__HXX
#define TEAMCENTER__POM_MEMBER__HXX

#include <common/tc_deprecation_macros.h>
#include <cxpom/POM_system_class.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class POM_member;
}
namespace Teamcenter
{
    class POM_memberImpl;
}
namespace Teamcenter
{
    class POM_memberDelegate;
}
namespace Teamcenter
{
    class POM_memberDispatch;
}
namespace Teamcenter
{
    class POM_memberGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SA_API  Teamcenter::POM_member
     : public  ::Teamcenter::POM_system_class
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    POM_member();

    /**
     * Destructor
     */
    virtual ~POM_member();

private:
    //  Getter method for the Implementation Object
    POM_memberImpl*  getPOM_memberImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPOM_memberImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    POM_memberImpl*  m_pom_memberImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param POM_member - desc for POM_member parameter
     */
    POM_member( const POM_member& );
    POM_member& operator=( const POM_member& );

    friend class  POM_memberDelegate;
    friend class  POM_memberDispatch;
    friend class  POM_memberGenImpl;
};

#include <sa/libsa_undef.h>
#endif //   TEAMCENTER__POM_MEMBER__HXX
