//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, POM_user
    Filename:   POM_user.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__POM_USER__HXX
#define TEAMCENTER__POM_USER__HXX

#include <common/tc_deprecation_macros.h>
#include <cxpom/POM_system_class.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class POM_user;
}
namespace Teamcenter
{
    class POM_userImpl;
}
namespace Teamcenter
{
    class POM_userDelegate;
}
namespace Teamcenter
{
    class POM_userDispatch;
}
namespace Teamcenter
{
    class POM_userGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SA_API  Teamcenter::POM_user
     : public  ::Teamcenter::POM_system_class
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    POM_user();

    /**
     * Destructor
     */
    virtual ~POM_user();

private:
    //  Getter method for the Implementation Object
    POM_userImpl*  getPOM_userImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPOM_userImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    POM_userImpl*  m_pom_userImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param POM_user - desc for POM_user parameter
     */
    POM_user( const POM_user& );
    POM_user& operator=( const POM_user& );

    friend class  POM_userDelegate;
    friend class  POM_userDispatch;
    friend class  POM_userGenImpl;
};

#include <sa/libsa_undef.h>
#endif //   TEAMCENTER__POM_USER__HXX
