//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PersonDelegate
    Filename:   PersonDelegate.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PERSONDELEGATE_HXX
#define TEAMCENTER__PERSONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <sa/Person.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class PersonDelegate;
}
namespace Teamcenter
{
    class PersonImpl;
}
namespace Teamcenter
{
    class Person;
}
namespace Teamcenter
{
    class PersonGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  SA_API Teamcenter_alias::PersonDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PersonDelegate instance
    static PersonDelegate&  getInstance();

    //  Method to create the PersonImpl pointer
    static PersonImpl*  createImpl( Person&  ifObj );

    //  Method to delete the PersonImpl pointer
    static void deleteImpl( PersonImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0export_sitesBase(const Person &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0OrganizationAuditLogsBase(const Person &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const Person &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Person &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static PersonDelegate*  m_pInstance;

    PersonDelegate();
    virtual ~PersonDelegate();
    static void setInstance( PersonDelegate*  instance );


private:
    friend class  ::Teamcenter::PersonGenImpl;

};

#include <sa/libsa_undef.h>
#endif  //  TEAMCENTER__PERSONDELEGATE_HXX
