//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Range
    Filename:   Range.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__RANGE__HXX
#define TEAMCENTER__RANGE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class Range;
}
namespace Teamcenter
{
    class RangeImpl;
}
namespace Teamcenter
{
    class RangeDelegate;
}
namespace Teamcenter
{
    class RangeDispatch;
}
namespace Teamcenter
{
    class RangeGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SA_API  Teamcenter::Range
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Range();

    /**
     * Destructor
     */
    virtual ~Range();

private:
    //  Getter method for the Implementation Object
    RangeImpl*  getRangeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRangeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    RangeImpl*  m_rangeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Range - desc for Range parameter
     */
    Range( const Range& );
    Range& operator=( const Range& );

    friend class  RangeDelegate;
    friend class  RangeDispatch;
    friend class  RangeGenImpl;
};

#include <sa/libsa_undef.h>
#endif //   TEAMCENTER__RANGE__HXX
