//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Role
    Filename:   Role.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ROLE__HXX
#define TEAMCENTER__ROLE__HXX

#include <string>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class Role;
}
namespace Teamcenter
{
    class RoleImpl;
}
namespace Teamcenter
{
    class RoleDelegate;
}
namespace Teamcenter
{
    class RoleDispatch;
}
namespace Teamcenter
{
    class RoleGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SA_API  Teamcenter::Role
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0export_sites( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0OrganizationAuditLogs( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Role();

    /**
     * Destructor
     */
    virtual ~Role();

private:
    //  Getter method for the Implementation Object
    RoleImpl*  getRoleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRoleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    RoleImpl*  m_roleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Role - desc for Role parameter
     */
    Role( const Role& );
    Role& operator=( const Role& );

    friend class  RoleDelegate;
    friend class  RoleDispatch;
    friend class  RoleGenImpl;
};

#include <sa/libsa_undef.h>
#endif //   TEAMCENTER__ROLE__HXX
