//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, RoleInOwningGroup
    Filename:   RoleInOwningGroup.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ROLEINOWNINGGROUP__HXX
#define TEAMCENTER__ROLEINOWNINGGROUP__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class RoleInOwningGroup;
}
namespace Teamcenter
{
    class RoleInOwningGroupImpl;
}
namespace Teamcenter
{
    class RoleInOwningGroupDelegate;
}
namespace Teamcenter
{
    class RoleInOwningGroupDispatch;
}
namespace Teamcenter
{
    class RoleInOwningGroupGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SA_API  Teamcenter::RoleInOwningGroup
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    RoleInOwningGroup();

    /**
     * Destructor
     */
    virtual ~RoleInOwningGroup();

private:
    //  Getter method for the Implementation Object
    RoleInOwningGroupImpl*  getRoleInOwningGroupImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setRoleInOwningGroupImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    RoleInOwningGroupImpl*  m_roleinowninggroupImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param RoleInOwningGroup - desc for RoleInOwningGroup parameter
     */
    RoleInOwningGroup( const RoleInOwningGroup& );
    RoleInOwningGroup& operator=( const RoleInOwningGroup& );

    friend class  RoleInOwningGroupDelegate;
    friend class  RoleInOwningGroupDispatch;
    friend class  RoleInOwningGroupGenImpl;
};

#include <sa/libsa_undef.h>
#endif //   TEAMCENTER__ROLEINOWNINGGROUP__HXX
