//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SFRInfo
    Filename:   SFRInfo.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SFRINFO__HXX
#define TEAMCENTER__SFRINFO__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class SFRInfo;
}
namespace Teamcenter
{
    class SFRInfoImpl;
}
namespace Teamcenter
{
    class SFRInfoDelegate;
}
namespace Teamcenter
{
    class SFRInfoDispatch;
}
namespace Teamcenter
{
    class SFRInfoGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SA_API  Teamcenter::SFRInfo
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SFRInfo();

    /**
     * Destructor
     */
    virtual ~SFRInfo();

private:
    //  Getter method for the Implementation Object
    SFRInfoImpl*  getSFRInfoImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSFRInfoImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SFRInfoImpl*  m_sfrinfoImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SFRInfo - desc for SFRInfo parameter
     */
    SFRInfo( const SFRInfo& );
    SFRInfo& operator=( const SFRInfo& );

    friend class  SFRInfoDelegate;
    friend class  SFRInfoDispatch;
    friend class  SFRInfoGenImpl;
};

#include <sa/libsa_undef.h>
#endif //   TEAMCENTER__SFRINFO__HXX
