//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SingleFileRecovery
    Filename:   SingleFileRecovery.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SINGLEFILERECOVERY__HXX
#define TEAMCENTER__SINGLEFILERECOVERY__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class SingleFileRecovery;
}
namespace Teamcenter
{
    class SingleFileRecoveryImpl;
}
namespace Teamcenter
{
    class SingleFileRecoveryDelegate;
}
namespace Teamcenter
{
    class SingleFileRecoveryDispatch;
}
namespace Teamcenter
{
    class SingleFileRecoveryGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SA_API  Teamcenter::SingleFileRecovery
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SingleFileRecovery();

    /**
     * Destructor
     */
    virtual ~SingleFileRecovery();

private:
    //  Getter method for the Implementation Object
    SingleFileRecoveryImpl*  getSingleFileRecoveryImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSingleFileRecoveryImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SingleFileRecoveryImpl*  m_singlefilerecoveryImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SingleFileRecovery - desc for SingleFileRecovery parameter
     */
    SingleFileRecovery( const SingleFileRecovery& );
    SingleFileRecovery& operator=( const SingleFileRecovery& );

    friend class  SingleFileRecoveryDelegate;
    friend class  SingleFileRecoveryDispatch;
    friend class  SingleFileRecoveryGenImpl;
};

#include <sa/libsa_undef.h>
#endif //   TEAMCENTER__SINGLEFILERECOVERY__HXX
