//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, StorageMedia
    Filename:   StorageMedia.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__STORAGEMEDIA__HXX
#define TEAMCENTER__STORAGEMEDIA__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class StorageMedia;
}
namespace Teamcenter
{
    class StorageMediaImpl;
}
namespace Teamcenter
{
    class StorageMediaDelegate;
}
namespace Teamcenter
{
    class StorageMediaDispatch;
}
namespace Teamcenter
{
    class StorageMediaGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SA_API  Teamcenter::StorageMedia
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    StorageMedia();

    /**
     * Destructor
     */
    virtual ~StorageMedia();

private:
    //  Getter method for the Implementation Object
    StorageMediaImpl*  getStorageMediaImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setStorageMediaImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    StorageMediaImpl*  m_storagemediaImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param StorageMedia - desc for StorageMedia parameter
     */
    StorageMedia( const StorageMedia& );
    StorageMedia& operator=( const StorageMedia& );

    friend class  StorageMediaDelegate;
    friend class  StorageMediaDispatch;
    friend class  StorageMediaGenImpl;
};

#include <sa/libsa_undef.h>
#endif //   TEAMCENTER__STORAGEMEDIA__HXX
