//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, StorageMediaDelegate
    Filename:   StorageMediaDelegate.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__STORAGEMEDIADELEGATE_HXX
#define TEAMCENTER__STORAGEMEDIADELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <sa/StorageMedia.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class StorageMediaDelegate;
}
namespace Teamcenter
{
    class StorageMediaImpl;
}
namespace Teamcenter
{
    class StorageMedia;
}
namespace Teamcenter
{
    class StorageMediaGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  SA_API Teamcenter_alias::StorageMediaDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the StorageMediaDelegate instance
    static StorageMediaDelegate&  getInstance();

    //  Method to create the StorageMediaImpl pointer
    static StorageMediaImpl*  createImpl( StorageMedia&  ifObj );

    //  Method to delete the StorageMediaImpl pointer
    static void deleteImpl( StorageMediaImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const StorageMedia &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static StorageMediaDelegate*  m_pInstance;

    StorageMediaDelegate();
    virtual ~StorageMediaDelegate();
    static void setInstance( StorageMediaDelegate*  instance );


private:
    friend class  ::Teamcenter::StorageMediaGenImpl;

};

#include <sa/libsa_undef.h>
#endif  //  TEAMCENTER__STORAGEMEDIADELEGATE_HXX
