//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TCCalendar
    Filename:   TCCalendar.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TCCALENDAR__HXX
#define TEAMCENTER__TCCALENDAR__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class TCCalendar;
}
namespace Teamcenter
{
    class TCCalendarImpl;
}
namespace Teamcenter
{
    class TCCalendarDelegate;
}
namespace Teamcenter
{
    class TCCalendarDispatch;
}
namespace Teamcenter
{
    class TCCalendarGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SA_API  Teamcenter::TCCalendar
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0OrganizationAuditLogs( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    TCCalendar();

    /**
     * Destructor
     */
    virtual ~TCCalendar();

private:
    //  Getter method for the Implementation Object
    TCCalendarImpl*  getTCCalendarImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTCCalendarImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    TCCalendarImpl*  m_tccalendarImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param TCCalendar - desc for TCCalendar parameter
     */
    TCCalendar( const TCCalendar& );
    TCCalendar& operator=( const TCCalendar& );

    friend class  TCCalendarDelegate;
    friend class  TCCalendarDispatch;
    friend class  TCCalendarGenImpl;
};

#include <sa/libsa_undef.h>
#endif //   TEAMCENTER__TCCALENDAR__HXX
