//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TCCalendarEvent
    Filename:   TCCalendarEvent.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TCCALENDAREVENT__HXX
#define TEAMCENTER__TCCALENDAREVENT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class TCCalendarEvent;
}
namespace Teamcenter
{
    class TCCalendarEventImpl;
}
namespace Teamcenter
{
    class TCCalendarEventDelegate;
}
namespace Teamcenter
{
    class TCCalendarEventDispatch;
}
namespace Teamcenter
{
    class TCCalendarEventGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SA_API  Teamcenter::TCCalendarEvent
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    TCCalendarEvent();

    /**
     * Destructor
     */
    virtual ~TCCalendarEvent();

private:
    //  Getter method for the Implementation Object
    TCCalendarEventImpl*  getTCCalendarEventImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTCCalendarEventImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    TCCalendarEventImpl*  m_tccalendareventImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param TCCalendarEvent - desc for TCCalendarEvent parameter
     */
    TCCalendarEvent( const TCCalendarEvent& );
    TCCalendarEvent& operator=( const TCCalendarEvent& );

    friend class  TCCalendarEventDelegate;
    friend class  TCCalendarEventDispatch;
    friend class  TCCalendarEventGenImpl;
};

#include <sa/libsa_undef.h>
#endif //   TEAMCENTER__TCCALENDAREVENT__HXX
