//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TC_WorkContext
    Filename:   TC_WorkContext.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TC_WORKCONTEXT__HXX
#define TEAMCENTER__TC_WORKCONTEXT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class TC_WorkContext;
}
namespace Teamcenter
{
    class TC_WorkContextImpl;
}
namespace Teamcenter
{
    class TC_WorkContextDelegate;
}
namespace Teamcenter
{
    class TC_WorkContextDispatch;
}
namespace Teamcenter
{
    class TC_WorkContextGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SA_API  Teamcenter::TC_WorkContext
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    TC_WorkContext();

    /**
     * Destructor
     */
    virtual ~TC_WorkContext();

private:
    //  Getter method for the Implementation Object
    TC_WorkContextImpl*  getTC_WorkContextImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTC_WorkContextImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    TC_WorkContextImpl*  m_tc_workcontextImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param TC_WorkContext - desc for TC_WorkContext parameter
     */
    TC_WorkContext( const TC_WorkContext& );
    TC_WorkContext& operator=( const TC_WorkContext& );

    friend class  TC_WorkContextDelegate;
    friend class  TC_WorkContextDispatch;
    friend class  TC_WorkContextGenImpl;
};

#include <sa/libsa_undef.h>
#endif //   TEAMCENTER__TC_WORKCONTEXT__HXX
