//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TC_WorkContextDelegate
    Filename:   TC_WorkContextDelegate.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TC_WORKCONTEXTDELEGATE_HXX
#define TEAMCENTER__TC_WORKCONTEXTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <sa/TC_WorkContext.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class TC_WorkContextDelegate;
}
namespace Teamcenter
{
    class TC_WorkContextImpl;
}
namespace Teamcenter
{
    class TC_WorkContext;
}
namespace Teamcenter
{
    class TC_WorkContextGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  SA_API Teamcenter_alias::TC_WorkContextDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the TC_WorkContextDelegate instance
    static TC_WorkContextDelegate&  getInstance();

    //  Method to create the TC_WorkContextImpl pointer
    static TC_WorkContextImpl*  createImpl( TC_WorkContext&  ifObj );

    //  Method to delete the TC_WorkContextImpl pointer
    static void deleteImpl( TC_WorkContextImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static TC_WorkContextDelegate*  m_pInstance;

    TC_WorkContextDelegate();
    virtual ~TC_WorkContextDelegate();
    static void setInstance( TC_WorkContextDelegate*  instance );


private:
    friend class  ::Teamcenter::TC_WorkContextGenImpl;

};

#include <sa/libsa_undef.h>
#endif  //  TEAMCENTER__TC_WORKCONTEXTDELEGATE_HXX
