//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, VM_Info
    Filename:   VM_Info.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VM_INFO__HXX
#define TEAMCENTER__VM_INFO__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class VM_Info;
}
namespace Teamcenter
{
    class VM_InfoImpl;
}
namespace Teamcenter
{
    class VM_InfoDelegate;
}
namespace Teamcenter
{
    class VM_InfoDispatch;
}
namespace Teamcenter
{
    class VM_InfoGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SA_API  Teamcenter::VM_Info
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    VM_Info();

    /**
     * Destructor
     */
    virtual ~VM_Info();

private:
    //  Getter method for the Implementation Object
    VM_InfoImpl*  getVM_InfoImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setVM_InfoImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    VM_InfoImpl*  m_vm_infoImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param VM_Info - desc for VM_Info parameter
     */
    VM_Info( const VM_Info& );
    VM_Info& operator=( const VM_Info& );

    friend class  VM_InfoDelegate;
    friend class  VM_InfoDispatch;
    friend class  VM_InfoGenImpl;
};

#include <sa/libsa_undef.h>
#endif //   TEAMCENTER__VM_INFO__HXX
