//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, VM_Policy
    Filename:   VM_Policy.hxx
    Module:     sa
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VM_POLICY__HXX
#define TEAMCENTER__VM_POLICY__HXX

#include <common/tc_deprecation_macros.h>
#include <sa/Migration_Policy.hxx>

#include <sa/libsa_exports.h>

namespace Teamcenter
{
    class VM_Policy;
}
namespace Teamcenter
{
    class VM_PolicyImpl;
}
namespace Teamcenter
{
    class VM_PolicyDelegate;
}
namespace Teamcenter
{
    class VM_PolicyDispatch;
}
namespace Teamcenter
{
    class VM_PolicyGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SA_API  Teamcenter::VM_Policy
     : public  ::Teamcenter::Migration_Policy
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    VM_Policy();

    /**
     * Destructor
     */
    virtual ~VM_Policy();

private:
    //  Getter method for the Implementation Object
    VM_PolicyImpl*  getVM_PolicyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setVM_PolicyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    VM_PolicyImpl*  m_vm_policyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param VM_Policy - desc for VM_Policy parameter
     */
    VM_Policy( const VM_Policy& );
    VM_Policy& operator=( const VM_Policy& );

    friend class  VM_PolicyDelegate;
    friend class  VM_PolicyDispatch;
    friend class  VM_PolicyGenImpl;
};

#include <sa/libsa_undef.h>
#endif //   TEAMCENTER__VM_POLICY__HXX
