//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  sa

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libsa

#if !defined(LIBSA) && !defined(IPLIB)
#   error IPLIB or LIBSA is not defined
#endif

/* Handwritten code should use SA_API, not SAEXPORT */

#define SA_API SAEXPORT

#if IPLIB==libsa || defined(LIBSA)
#   if defined(__lint)
#       define SAEXPORT       __export(sa)
#       define SAGLOBAL       extern __global(sa)
#       define SAPRIVATE      extern __private(sa)
#   elif defined(_WIN32)
#       define SAEXPORT       __declspec(dllexport)
#       define SAGLOBAL       extern __declspec(dllexport)
#       define SAPRIVATE      extern
#   else
#       define SAEXPORT
#       define SAGLOBAL       extern
#       define SAPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define SAEXPORT       __export(sa)
#       define SAGLOBAL       extern __global(sa)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define SAEXPORT      __declspec(dllimport)
#       define SAGLOBAL       extern __declspec(dllimport)
#   else
#       define SAEXPORT
#       define SAGLOBAL       extern
#   endif
#endif
