//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BillRate
    Filename:   BillRate.hxx
    Module:     schmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BILLRATE__HXX
#define TEAMCENTER__BILLRATE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <schmgt/libschmgt_exports.h>

namespace Teamcenter
{
    class BillRate;
}
namespace Teamcenter
{
    class BillRateImpl;
}
namespace Teamcenter
{
    class BillRateDelegate;
}
namespace Teamcenter
{
    class BillRateDispatch;
}
namespace Teamcenter
{
    class BillRateGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SCHMGT_API  Teamcenter::BillRate
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    BillRate();

    /**
     * Destructor
     */
    virtual ~BillRate();

private:
    //  Getter method for the Implementation Object
    BillRateImpl*  getBillRateImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBillRateImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    BillRateImpl*  m_billrateImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param BillRate - desc for BillRate parameter
     */
    BillRate( const BillRate& );
    BillRate& operator=( const BillRate& );

    friend class  BillRateDelegate;
    friend class  BillRateDispatch;
    friend class  BillRateGenImpl;
};

#include <schmgt/libschmgt_undef.h>
#endif //   TEAMCENTER__BILLRATE__HXX
