//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BillRateDelegate
    Filename:   BillRateDelegate.hxx
    Module:     schmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BILLRATEDELEGATE_HXX
#define TEAMCENTER__BILLRATEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <schmgt/BillRate.hxx>

#include <schmgt/libschmgt_exports.h>

namespace Teamcenter
{
    class BillRateDelegate;
}
namespace Teamcenter
{
    class BillRateImpl;
}
namespace Teamcenter
{
    class BillRate;
}
namespace Teamcenter
{
    class BillRateGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  SCHMGT_API Teamcenter_alias::BillRateDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the BillRateDelegate instance
    static BillRateDelegate&  getInstance();

    //  Method to create the BillRateImpl pointer
    static BillRateImpl*  createImpl( BillRate&  ifObj );

    //  Method to delete the BillRateImpl pointer
    static void deleteImpl( BillRateImpl*  impl );



protected:
    //  Pointer to the instance
    static BillRateDelegate*  m_pInstance;

    BillRateDelegate();
    virtual ~BillRateDelegate();
    static void setInstance( BillRateDelegate*  instance );


private:
    friend class  ::Teamcenter::BillRateGenImpl;

};

#include <schmgt/libschmgt_undef.h>
#endif  //  TEAMCENTER__BILLRATEDELEGATE_HXX
