//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CostValueDelegate
    Filename:   CostValueDelegate.hxx
    Module:     schmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__COSTVALUEDELEGATE_HXX
#define TEAMCENTER__COSTVALUEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <schmgt/CostValue.hxx>

#include <schmgt/libschmgt_exports.h>

namespace Teamcenter
{
    class CostValueDelegate;
}
namespace Teamcenter
{
    class CostValueImpl;
}
namespace Teamcenter
{
    class CostValue;
}
namespace Teamcenter
{
    class CostValueGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  SCHMGT_API Teamcenter_alias::CostValueDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CostValueDelegate instance
    static CostValueDelegate&  getInstance();

    //  Method to create the CostValueImpl pointer
    static CostValueImpl*  createImpl( CostValue&  ifObj );

    //  Method to delete the CostValueImpl pointer
    static void deleteImpl( CostValueImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCostBase(const CostValue &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCurrencyBase(const CostValue &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCostBase(CostValue &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCurrencyBase(CostValue &ifObj,  const std::string &value, bool isNull );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static CostValueDelegate*  m_pInstance;

    CostValueDelegate();
    virtual ~CostValueDelegate();
    static void setInstance( CostValueDelegate*  instance );


private:
    friend class  ::Teamcenter::CostValueGenImpl;

};

#include <schmgt/libschmgt_undef.h>
#endif  //  TEAMCENTER__COSTVALUEDELEGATE_HXX
