//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0GnWOTask
    Filename:   Fnd0GnWOTask.hxx
    Module:     schmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0GNWOTASK__HXX
#define TEAMCENTER__FND0GNWOTASK__HXX

#include <vector>
#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <schmgt/ScheduleTask.hxx>

#include <schmgt/libschmgt_exports.h>

namespace Teamcenter
{
    class Fnd0GnWOTask;
}
namespace Teamcenter
{
    class Fnd0GnWOTaskImpl;
}
namespace Teamcenter
{
    class Fnd0GnWOTaskDelegate;
}
namespace Teamcenter
{
    class Fnd0GnWOTaskDispatch;
}
namespace Teamcenter
{
    class Fnd0GnWOTaskGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SCHMGT_API  Teamcenter::Fnd0GnWOTask
     : public  ::Teamcenter::ScheduleTask
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Get utilization that has been recorded on the generic work order task.
    /// @version Teamcenter 11.1
    /// @param utilization - Vector containing utilization objects.
    /// @return - ifail code
    ///
    int  fnd0getUtilization( std::vector< tag_t > *utilization );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0GnWOTask();

    /**
     * Destructor
     */
    virtual ~Fnd0GnWOTask();

private:
    //  Getter method for the Implementation Object
    Fnd0GnWOTaskImpl*  getFnd0GnWOTaskImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0GnWOTaskImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0GnWOTaskImpl*  m_fnd0gnwotaskImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0GnWOTask - desc for Fnd0GnWOTask parameter
     */
    Fnd0GnWOTask( const Fnd0GnWOTask& );
    Fnd0GnWOTask& operator=( const Fnd0GnWOTask& );

    friend class  Fnd0GnWOTaskDelegate;
    friend class  Fnd0GnWOTaskDispatch;
    friend class  Fnd0GnWOTaskGenImpl;
};

#include <schmgt/libschmgt_undef.h>
#endif //   TEAMCENTER__FND0GNWOTASK__HXX
