//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0GnWOTaskDelegate
    Filename:   Fnd0GnWOTaskDelegate.hxx
    Module:     schmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0GNWOTASKDELEGATE_HXX
#define TEAMCENTER__FND0GNWOTASKDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <schmgt/Fnd0GnWOTask.hxx>

#include <schmgt/libschmgt_exports.h>

namespace Teamcenter
{
    class Fnd0GnWOTaskDelegate;
}
namespace Teamcenter
{
    class Fnd0GnWOTaskImpl;
}
namespace Teamcenter
{
    class Fnd0GnWOTask;
}
namespace Teamcenter
{
    class Fnd0GnWOTaskGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  SCHMGT_API Teamcenter_alias::Fnd0GnWOTaskDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0GnWOTaskDelegate instance
    static Fnd0GnWOTaskDelegate&  getInstance();

    //  Method to create the Fnd0GnWOTaskImpl pointer
    static Fnd0GnWOTaskImpl*  createImpl( Fnd0GnWOTask&  ifObj );

    //  Method to delete the Fnd0GnWOTaskImpl pointer
    static void deleteImpl( Fnd0GnWOTaskImpl*  impl );


    ///
    /// Get utilization that has been recorded on the generic work order task.
    /// @version Teamcenter 11.1
    /// @param utilization - Vector containing utilization objects.
    /// @return - ifail code
    ///
    int  fnd0getUtilizationBase(const Fnd0GnWOTask &ifObj,  std::vector< tag_t > *utilization );



protected:
    //  Pointer to the instance
    static Fnd0GnWOTaskDelegate*  m_pInstance;

    Fnd0GnWOTaskDelegate();
    virtual ~Fnd0GnWOTaskDelegate();
    static void setInstance( Fnd0GnWOTaskDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0GnWOTaskGenImpl;

};

#include <schmgt/libschmgt_undef.h>
#endif  //  TEAMCENTER__FND0GNWOTASKDELEGATE_HXX
