//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0GnWOTaskRevision
    Filename:   Fnd0GnWOTaskRevision.hxx
    Module:     schmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0GNWOTASKREVISION__HXX
#define TEAMCENTER__FND0GNWOTASKREVISION__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <schmgt/ScheduleTaskRevision.hxx>

#include <schmgt/libschmgt_exports.h>

namespace Teamcenter
{
    class Fnd0GnWOTaskRevision;
}
namespace Teamcenter
{
    class Fnd0GnWOTaskRevisionImpl;
}
namespace Teamcenter
{
    class Fnd0GnWOTaskRevisionDelegate;
}
namespace Teamcenter
{
    class Fnd0GnWOTaskRevisionDispatch;
}
namespace Teamcenter
{
    class Fnd0GnWOTaskRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SCHMGT_API  Teamcenter::Fnd0GnWOTaskRevision
     : public  ::Teamcenter::ScheduleTaskRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Get utilization that has been recorded on the generic work order task.
    /// @version Teamcenter 9.1
    /// @param utilization - Vector containing utilization objects.
    /// @return - ifail code
    ///
    int  fnd0getUtilization( std::vector< tag_t > *utilization );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0GnWOTaskRevision();

    /**
     * Destructor
     */
    virtual ~Fnd0GnWOTaskRevision();

private:
    //  Getter method for the Implementation Object
    Fnd0GnWOTaskRevisionImpl*  getFnd0GnWOTaskRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0GnWOTaskRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0GnWOTaskRevisionImpl*  m_fnd0gnwotaskrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0GnWOTaskRevision - desc for Fnd0GnWOTaskRevision parameter
     */
    Fnd0GnWOTaskRevision( const Fnd0GnWOTaskRevision& );
    Fnd0GnWOTaskRevision& operator=( const Fnd0GnWOTaskRevision& );

    friend class  Fnd0GnWOTaskRevisionDelegate;
    friend class  Fnd0GnWOTaskRevisionDispatch;
    friend class  Fnd0GnWOTaskRevisionGenImpl;
};

#include <schmgt/libschmgt_undef.h>
#endif //   TEAMCENTER__FND0GNWOTASKREVISION__HXX
