//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0GnWOTaskRevisionDelegate
    Filename:   Fnd0GnWOTaskRevisionDelegate.hxx
    Module:     schmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0GNWOTASKREVISIONDELEGATE_HXX
#define TEAMCENTER__FND0GNWOTASKREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <schmgt/Fnd0GnWOTaskRevision.hxx>

#include <schmgt/libschmgt_exports.h>

namespace Teamcenter
{
    class Fnd0GnWOTaskRevisionDelegate;
}
namespace Teamcenter
{
    class Fnd0GnWOTaskRevisionImpl;
}
namespace Teamcenter
{
    class Fnd0GnWOTaskRevision;
}
namespace Teamcenter
{
    class Fnd0GnWOTaskRevisionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  SCHMGT_API Teamcenter_alias::Fnd0GnWOTaskRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0GnWOTaskRevisionDelegate instance
    static Fnd0GnWOTaskRevisionDelegate&  getInstance();

    //  Method to create the Fnd0GnWOTaskRevisionImpl pointer
    static Fnd0GnWOTaskRevisionImpl*  createImpl( Fnd0GnWOTaskRevision&  ifObj );

    //  Method to delete the Fnd0GnWOTaskRevisionImpl pointer
    static void deleteImpl( Fnd0GnWOTaskRevisionImpl*  impl );


    ///
    /// Get utilization that has been recorded on the generic work order task.
    /// @version Teamcenter 9.1
    /// @param utilization - Vector containing utilization objects.
    /// @return - ifail code
    ///
    int  fnd0getUtilizationBase(const Fnd0GnWOTaskRevision &ifObj,  std::vector< tag_t > *utilization );



protected:
    //  Pointer to the instance
    static Fnd0GnWOTaskRevisionDelegate*  m_pInstance;

    Fnd0GnWOTaskRevisionDelegate();
    virtual ~Fnd0GnWOTaskRevisionDelegate();
    static void setInstance( Fnd0GnWOTaskRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0GnWOTaskRevisionGenImpl;

};

#include <schmgt/libschmgt_undef.h>
#endif  //  TEAMCENTER__FND0GNWOTASKREVISIONDELEGATE_HXX
