//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ScheduleTaskProxyLink
    Filename:   Fnd0ScheduleTaskProxyLink.hxx
    Module:     schmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0SCHEDULETASKPROXYLINK__HXX
#define TEAMCENTER__FND0SCHEDULETASKPROXYLINK__HXX

#include <unidefs.h>
#include <string>
#include <common/tc_deprecation_macros.h>
#include <wproxy/ProxyLink.hxx>

#include <schmgt/libschmgt_exports.h>

namespace Teamcenter
{
    class Fnd0ScheduleTaskProxyLink;
}
namespace Teamcenter
{
    class Fnd0ScheduleTaskProxyLinkImpl;
}
namespace Teamcenter
{
    class Fnd0ScheduleTaskProxyLinkDelegate;
}
namespace Teamcenter
{
    class Fnd0ScheduleTaskProxyLinkDispatch;
}
namespace Teamcenter
{
    class Fnd0ScheduleTaskProxyLinkGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SCHMGT_API  Teamcenter::Fnd0ScheduleTaskProxyLink
     : public  ::Teamcenter::ProxyLink
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Setter for a Date Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0FinishDate( const date_t &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0Status( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0ScheduleTaskProxyLink();

    /**
     * Destructor
     */
    virtual ~Fnd0ScheduleTaskProxyLink();

private:
    //  Getter method for the Implementation Object
    Fnd0ScheduleTaskProxyLinkImpl*  getFnd0ScheduleTaskProxyLinkImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0ScheduleTaskProxyLinkImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0ScheduleTaskProxyLinkImpl*  m_fnd0scheduletaskproxylinkImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0ScheduleTaskProxyLink - desc for Fnd0ScheduleTaskProxyLink parameter
     */
    Fnd0ScheduleTaskProxyLink( const Fnd0ScheduleTaskProxyLink& );
    Fnd0ScheduleTaskProxyLink& operator=( const Fnd0ScheduleTaskProxyLink& );

    friend class  Fnd0ScheduleTaskProxyLinkDelegate;
    friend class  Fnd0ScheduleTaskProxyLinkDispatch;
    friend class  Fnd0ScheduleTaskProxyLinkGenImpl;
};

#include <schmgt/libschmgt_undef.h>
#endif //   TEAMCENTER__FND0SCHEDULETASKPROXYLINK__HXX
