//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ResourceAssignmentDelegate
    Filename:   ResourceAssignmentDelegate.hxx
    Module:     schmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__RESOURCEASSIGNMENTDELEGATE_HXX
#define TEAMCENTER__RESOURCEASSIGNMENTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <schmgt/ResourceAssignment.hxx>

#include <schmgt/libschmgt_exports.h>

namespace Teamcenter
{
    class ResourceAssignmentDelegate;
}
namespace Teamcenter
{
    class ResourceAssignmentImpl;
}
namespace Teamcenter
{
    class ResourceAssignment;
}
namespace Teamcenter
{
    class ResourceAssignmentGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  SCHMGT_API Teamcenter_alias::ResourceAssignmentDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ResourceAssignmentDelegate instance
    static ResourceAssignmentDelegate&  getInstance();

    //  Method to create the ResourceAssignmentImpl pointer
    static ResourceAssignmentImpl*  createImpl( ResourceAssignment&  ifObj );

    //  Method to delete the ResourceAssignmentImpl pointer
    static void deleteImpl( ResourceAssignmentImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDisciplineBase(const ResourceAssignment &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0AssignedDisciplineBase(const ResourceAssignment &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0AssignedUserBase(const ResourceAssignment &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0IsPlaceholderBase(const ResourceAssignment &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ResourcePoolBase(const ResourceAssignment &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0WhatIfModeBase(const ResourceAssignment &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getResource_levelBase(const ResourceAssignment &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDisciplineBase(ResourceAssignment &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 11.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0IsPlaceholderBase(ResourceAssignment &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0ResourcePoolBase(ResourceAssignment &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 11.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0WhatIfModeBase(ResourceAssignment &ifObj,  int value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Teamcenter 11.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setResource_levelBase(ResourceAssignment &ifObj,  double value, bool isNull );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @param isLockForDelete - A boolean to indicate if object(s) are to be locked for deletion
    /// @param allowRelock - A boolean to indicate if object(s) can be relocked, which will discard all unsaved changes, if already locked by the same user
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0LockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd, const bool isLockForDelete, const bool allowRelock );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0RefreshBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0UnlockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const ResourceAssignment &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static ResourceAssignmentDelegate*  m_pInstance;

    ResourceAssignmentDelegate();
    virtual ~ResourceAssignmentDelegate();
    static void setInstance( ResourceAssignmentDelegate*  instance );


private:
    friend class  ::Teamcenter::ResourceAssignmentGenImpl;

};

#include <schmgt/libschmgt_undef.h>
#endif  //  TEAMCENTER__RESOURCEASSIGNMENTDELEGATE_HXX
