//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SchDeliverable
    Filename:   SchDeliverable.hxx
    Module:     schmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SCHDELIVERABLE__HXX
#define TEAMCENTER__SCHDELIVERABLE__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <schmgt/libschmgt_exports.h>

namespace Teamcenter
{
    class SchDeliverable;
}
namespace Teamcenter
{
    class SchDeliverableImpl;
}
namespace Teamcenter
{
    class SchDeliverableDelegate;
}
namespace Teamcenter
{
    class SchDeliverableDispatch;
}
namespace Teamcenter
{
    class SchDeliverableGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SCHMGT_API  Teamcenter::SchDeliverable
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ScheduleAuditLogs( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SchDeliverable();

    /**
     * Destructor
     */
    virtual ~SchDeliverable();

private:
    //  Getter method for the Implementation Object
    SchDeliverableImpl*  getSchDeliverableImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSchDeliverableImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SchDeliverableImpl*  m_schdeliverableImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SchDeliverable - desc for SchDeliverable parameter
     */
    SchDeliverable( const SchDeliverable& );
    SchDeliverable& operator=( const SchDeliverable& );

    friend class  SchDeliverableDelegate;
    friend class  SchDeliverableDispatch;
    friend class  SchDeliverableGenImpl;
};

#include <schmgt/libschmgt_undef.h>
#endif //   TEAMCENTER__SCHDELIVERABLE__HXX
