//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SchDeliverableDelegate
    Filename:   SchDeliverableDelegate.hxx
    Module:     schmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SCHDELIVERABLEDELEGATE_HXX
#define TEAMCENTER__SCHDELIVERABLEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <schmgt/SchDeliverable.hxx>

#include <schmgt/libschmgt_exports.h>

namespace Teamcenter
{
    class SchDeliverableDelegate;
}
namespace Teamcenter
{
    class SchDeliverableImpl;
}
namespace Teamcenter
{
    class SchDeliverable;
}
namespace Teamcenter
{
    class SchDeliverableGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  SCHMGT_API Teamcenter_alias::SchDeliverableDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SchDeliverableDelegate instance
    static SchDeliverableDelegate&  getInstance();

    //  Method to create the SchDeliverableImpl pointer
    static SchDeliverableImpl*  createImpl( SchDeliverable&  ifObj );

    //  Method to delete the SchDeliverableImpl pointer
    static void deleteImpl( SchDeliverableImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ScheduleAuditLogsBase(const SchDeliverable &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static SchDeliverableDelegate*  m_pInstance;

    SchDeliverableDelegate();
    virtual ~SchDeliverableDelegate();
    static void setInstance( SchDeliverableDelegate*  instance );


private:
    friend class  ::Teamcenter::SchDeliverableGenImpl;

};

#include <schmgt/libschmgt_undef.h>
#endif  //  TEAMCENTER__SCHDELIVERABLEDELEGATE_HXX
