//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SchMgtCostForm
    Filename:   SchMgtCostForm.hxx
    Module:     schmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SCHMGTCOSTFORM__HXX
#define TEAMCENTER__SCHMGTCOSTFORM__HXX

#include <common/tc_deprecation_macros.h>
#include <form/Form.hxx>

#include <schmgt/libschmgt_exports.h>

namespace Teamcenter
{
    class SchMgtCostForm;
}
namespace Teamcenter
{
    class SchMgtCostFormImpl;
}
namespace Teamcenter
{
    class SchMgtCostFormDelegate;
}
namespace Teamcenter
{
    class SchMgtCostFormDispatch;
}
namespace Teamcenter
{
    class SchMgtCostFormGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SCHMGT_API  Teamcenter::SchMgtCostForm
     : public  ::Teamcenter::Form
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SchMgtCostForm();

    /**
     * Destructor
     */
    virtual ~SchMgtCostForm();

private:
    //  Getter method for the Implementation Object
    SchMgtCostFormImpl*  getSchMgtCostFormImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSchMgtCostFormImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SchMgtCostFormImpl*  m_schmgtcostformImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SchMgtCostForm - desc for SchMgtCostForm parameter
     */
    SchMgtCostForm( const SchMgtCostForm& );
    SchMgtCostForm& operator=( const SchMgtCostForm& );

    friend class  SchMgtCostFormDelegate;
    friend class  SchMgtCostFormDispatch;
    friend class  SchMgtCostFormGenImpl;
};

#include <schmgt/libschmgt_undef.h>
#endif //   TEAMCENTER__SCHMGTCOSTFORM__HXX
