//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SchMgtCostFormStorageDelegate
    Filename:   SchMgtCostFormStorageDelegate.hxx
    Module:     schmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SCHMGTCOSTFORMSTORAGEDELEGATE_HXX
#define TEAMCENTER__SCHMGTCOSTFORMSTORAGEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <schmgt/SchMgtCostFormStorage.hxx>

#include <schmgt/libschmgt_exports.h>

namespace Teamcenter
{
    class SchMgtCostFormStorageDelegate;
}
namespace Teamcenter
{
    class SchMgtCostFormStorageImpl;
}
namespace Teamcenter
{
    class SchMgtCostFormStorage;
}
namespace Teamcenter
{
    class SchMgtCostFormStorageGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  SCHMGT_API Teamcenter_alias::SchMgtCostFormStorageDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SchMgtCostFormStorageDelegate instance
    static SchMgtCostFormStorageDelegate&  getInstance();

    //  Method to create the SchMgtCostFormStorageImpl pointer
    static SchMgtCostFormStorageImpl*  createImpl( SchMgtCostFormStorage&  ifObj );

    //  Method to delete the SchMgtCostFormStorageImpl pointer
    static void deleteImpl( SchMgtCostFormStorageImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBill_codeBase(const SchMgtCostFormStorage &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBill_sub_codeBase(const SchMgtCostFormStorage &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBill_typeBase(const SchMgtCostFormStorage &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBillrate_tagBase(const SchMgtCostFormStorage &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Tc 8
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFixed_cost_taglistBase(const SchMgtCostFormStorage &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setBill_codeBase(SchMgtCostFormStorage &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setBill_sub_codeBase(SchMgtCostFormStorage &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setBill_typeBase(SchMgtCostFormStorage &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setBillrate_tagBase(SchMgtCostFormStorage &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Tc 8
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFixed_cost_taglistBase(SchMgtCostFormStorage &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );



protected:
    //  Pointer to the instance
    static SchMgtCostFormStorageDelegate*  m_pInstance;

    SchMgtCostFormStorageDelegate();
    virtual ~SchMgtCostFormStorageDelegate();
    static void setInstance( SchMgtCostFormStorageDelegate*  instance );


private:
    friend class  ::Teamcenter::SchMgtCostFormStorageGenImpl;

};

#include <schmgt/libschmgt_undef.h>
#endif  //  TEAMCENTER__SCHMGTCOSTFORMSTORAGEDELEGATE_HXX
