//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SchTaskDeliverable
    Filename:   SchTaskDeliverable.hxx
    Module:     schmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SCHTASKDELIVERABLE__HXX
#define TEAMCENTER__SCHTASKDELIVERABLE__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <schmgt/libschmgt_exports.h>

namespace Teamcenter
{
    class SchTaskDeliverable;
}
namespace Teamcenter
{
    class SchTaskDeliverableImpl;
}
namespace Teamcenter
{
    class SchTaskDeliverableDelegate;
}
namespace Teamcenter
{
    class SchTaskDeliverableDispatch;
}
namespace Teamcenter
{
    class SchTaskDeliverableGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SCHMGT_API  Teamcenter::SchTaskDeliverable
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ScheduleAuditLogs( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SchTaskDeliverable();

    /**
     * Destructor
     */
    virtual ~SchTaskDeliverable();

private:
    //  Getter method for the Implementation Object
    SchTaskDeliverableImpl*  getSchTaskDeliverableImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSchTaskDeliverableImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SchTaskDeliverableImpl*  m_schtaskdeliverableImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SchTaskDeliverable - desc for SchTaskDeliverable parameter
     */
    SchTaskDeliverable( const SchTaskDeliverable& );
    SchTaskDeliverable& operator=( const SchTaskDeliverable& );

    friend class  SchTaskDeliverableDelegate;
    friend class  SchTaskDeliverableDispatch;
    friend class  SchTaskDeliverableGenImpl;
};

#include <schmgt/libschmgt_undef.h>
#endif //   TEAMCENTER__SCHTASKDELIVERABLE__HXX
