//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SchTaskDeliverableDelegate
    Filename:   SchTaskDeliverableDelegate.hxx
    Module:     schmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SCHTASKDELIVERABLEDELEGATE_HXX
#define TEAMCENTER__SCHTASKDELIVERABLEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <schmgt/SchTaskDeliverable.hxx>

#include <schmgt/libschmgt_exports.h>

namespace Teamcenter
{
    class SchTaskDeliverableDelegate;
}
namespace Teamcenter
{
    class SchTaskDeliverableImpl;
}
namespace Teamcenter
{
    class SchTaskDeliverable;
}
namespace Teamcenter
{
    class SchTaskDeliverableGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  SCHMGT_API Teamcenter_alias::SchTaskDeliverableDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SchTaskDeliverableDelegate instance
    static SchTaskDeliverableDelegate&  getInstance();

    //  Method to create the SchTaskDeliverableImpl pointer
    static SchTaskDeliverableImpl*  createImpl( SchTaskDeliverable&  ifObj );

    //  Method to delete the SchTaskDeliverableImpl pointer
    static void deleteImpl( SchTaskDeliverableImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ScheduleAuditLogsBase(const SchTaskDeliverable &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0RefreshBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static SchTaskDeliverableDelegate*  m_pInstance;

    SchTaskDeliverableDelegate();
    virtual ~SchTaskDeliverableDelegate();
    static void setInstance( SchTaskDeliverableDelegate*  instance );


private:
    friend class  ::Teamcenter::SchTaskDeliverableGenImpl;

};

#include <schmgt/libschmgt_undef.h>
#endif  //  TEAMCENTER__SCHTASKDELIVERABLEDELEGATE_HXX
