//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ScheduleDeliverable
    Filename:   ScheduleDeliverable.hxx
    Module:     schmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SCHEDULEDELIVERABLE__HXX
#define TEAMCENTER__SCHEDULEDELIVERABLE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <schmgt/libschmgt_exports.h>

namespace Teamcenter
{
    class ScheduleDeliverable;
}
namespace Teamcenter
{
    class ScheduleDeliverableImpl;
}
namespace Teamcenter
{
    class ScheduleDeliverableDelegate;
}
namespace Teamcenter
{
    class ScheduleDeliverableDispatch;
}
namespace Teamcenter
{
    class ScheduleDeliverableGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SCHMGT_API  Teamcenter::ScheduleDeliverable
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ScheduleDeliverable();

    /**
     * Destructor
     */
    virtual ~ScheduleDeliverable();

private:
    //  Getter method for the Implementation Object
    ScheduleDeliverableImpl*  getScheduleDeliverableImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setScheduleDeliverableImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ScheduleDeliverableImpl*  m_scheduledeliverableImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ScheduleDeliverable - desc for ScheduleDeliverable parameter
     */
    ScheduleDeliverable( const ScheduleDeliverable& );
    ScheduleDeliverable& operator=( const ScheduleDeliverable& );

    friend class  ScheduleDeliverableDelegate;
    friend class  ScheduleDeliverableDispatch;
    friend class  ScheduleDeliverableGenImpl;
};

#include <schmgt/libschmgt_undef.h>
#endif //   TEAMCENTER__SCHEDULEDELIVERABLE__HXX
