//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ScheduleMember
    Filename:   ScheduleMember.hxx
    Module:     schmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SCHEDULEMEMBER__HXX
#define TEAMCENTER__SCHEDULEMEMBER__HXX

#include <unidefs.h>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <schmgt/libschmgt_exports.h>

namespace Teamcenter
{
    class ScheduleMember;
}
namespace Teamcenter
{
    class ScheduleMemberImpl;
}
namespace Teamcenter
{
    class ScheduleMemberDelegate;
}
namespace Teamcenter
{
    class ScheduleMemberDispatch;
}
namespace Teamcenter
{
    class ScheduleMemberGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SCHMGT_API  Teamcenter::ScheduleMember
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCostvalue_form_tag( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ScheduleAuditLogs( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ScheduleTag( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCostvalue_form_tag( const tag_t &value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0ScheduleTag( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ScheduleMember();

    /**
     * Destructor
     */
    virtual ~ScheduleMember();

private:
    //  Getter method for the Implementation Object
    ScheduleMemberImpl*  getScheduleMemberImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setScheduleMemberImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ScheduleMemberImpl*  m_schedulememberImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ScheduleMember - desc for ScheduleMember parameter
     */
    ScheduleMember( const ScheduleMember& );
    ScheduleMember& operator=( const ScheduleMember& );

    friend class  ScheduleMemberDelegate;
    friend class  ScheduleMemberDispatch;
    friend class  ScheduleMemberGenImpl;
};

#include <schmgt/libschmgt_undef.h>
#endif //   TEAMCENTER__SCHEDULEMEMBER__HXX
