//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ScheduleMemberDelegate
    Filename:   ScheduleMemberDelegate.hxx
    Module:     schmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SCHEDULEMEMBERDELEGATE_HXX
#define TEAMCENTER__SCHEDULEMEMBERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <schmgt/ScheduleMember.hxx>

#include <schmgt/libschmgt_exports.h>

namespace Teamcenter
{
    class ScheduleMemberDelegate;
}
namespace Teamcenter
{
    class ScheduleMemberImpl;
}
namespace Teamcenter
{
    class ScheduleMember;
}
namespace Teamcenter
{
    class ScheduleMemberGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  SCHMGT_API Teamcenter_alias::ScheduleMemberDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ScheduleMemberDelegate instance
    static ScheduleMemberDelegate&  getInstance();

    //  Method to create the ScheduleMemberImpl pointer
    static ScheduleMemberImpl*  createImpl( ScheduleMember&  ifObj );

    //  Method to delete the ScheduleMemberImpl pointer
    static void deleteImpl( ScheduleMemberImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCostvalue_form_tagBase(const ScheduleMember &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ScheduleAuditLogsBase(const ScheduleMember &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ScheduleTagBase(const ScheduleMember &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCostvalue_form_tagBase(ScheduleMember &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0ScheduleTagBase(ScheduleMember &ifObj,  const tag_t &value, bool isNull );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const ScheduleMember &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static ScheduleMemberDelegate*  m_pInstance;

    ScheduleMemberDelegate();
    virtual ~ScheduleMemberDelegate();
    static void setInstance( ScheduleMemberDelegate*  instance );


private:
    friend class  ::Teamcenter::ScheduleMemberGenImpl;

};

#include <schmgt/libschmgt_undef.h>
#endif  //  TEAMCENTER__SCHEDULEMEMBERDELEGATE_HXX
