//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ScheduleRevisionDelegate
    Filename:   ScheduleRevisionDelegate.hxx
    Module:     schmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SCHEDULEREVISIONDELEGATE_HXX
#define TEAMCENTER__SCHEDULEREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <schmgt/ScheduleRevision.hxx>

#include <schmgt/libschmgt_exports.h>

namespace Teamcenter
{
    class ScheduleRevisionDelegate;
}
namespace Teamcenter
{
    class ScheduleRevisionImpl;
}
namespace Teamcenter
{
    class ScheduleRevision;
}
namespace Teamcenter
{
    class ScheduleRevisionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  SCHMGT_API Teamcenter_alias::ScheduleRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ScheduleRevisionDelegate instance
    static ScheduleRevisionDelegate&  getInstance();

    //  Method to create the ScheduleRevisionImpl pointer
    static ScheduleRevisionImpl*  createImpl( ScheduleRevision&  ifObj );

    //  Method to delete the ScheduleRevisionImpl pointer
    static void deleteImpl( ScheduleRevisionImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0allowExecUpdatesBase(const ScheduleRevision &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0proxy_tasksBase(const ScheduleRevision &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0allowExecUpdatesBase(ScheduleRevision &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0proxy_tasksBase(ScheduleRevision &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0stateBase(ScheduleRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0statusBase(ScheduleRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setStatusBase(ScheduleRevision &ifObj,  int value, bool isNull );



protected:
    //  Pointer to the instance
    static ScheduleRevisionDelegate*  m_pInstance;

    ScheduleRevisionDelegate();
    virtual ~ScheduleRevisionDelegate();
    static void setInstance( ScheduleRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::ScheduleRevisionGenImpl;

};

#include <schmgt/libschmgt_undef.h>
#endif  //  TEAMCENTER__SCHEDULEREVISIONDELEGATE_HXX
