//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ScheduleTaskRevision
    Filename:   ScheduleTaskRevision.hxx
    Module:     schmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SCHEDULETASKREVISION__HXX
#define TEAMCENTER__SCHEDULETASKREVISION__HXX

#include <unidefs.h>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <schmgt/libschmgt_exports.h>

namespace Teamcenter
{
    class ScheduleTaskRevision;
}
namespace Teamcenter
{
    class ScheduleTaskRevisionImpl;
}
namespace Teamcenter
{
    class ScheduleTaskRevisionDelegate;
}
namespace Teamcenter
{
    class ScheduleTaskRevisionDispatch;
}
namespace Teamcenter
{
    class ScheduleTaskRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SCHMGT_API  Teamcenter::ScheduleTaskRevision
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0workflow_owner( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 9.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setChild_task_taglist( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0workflow_owner( const tag_t &value, bool isNull=false );

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPriority( int value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ScheduleTaskRevision();

    /**
     * Destructor
     */
    virtual ~ScheduleTaskRevision();

private:
    //  Getter method for the Implementation Object
    ScheduleTaskRevisionImpl*  getScheduleTaskRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setScheduleTaskRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ScheduleTaskRevisionImpl*  m_scheduletaskrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ScheduleTaskRevision - desc for ScheduleTaskRevision parameter
     */
    ScheduleTaskRevision( const ScheduleTaskRevision& );
    ScheduleTaskRevision& operator=( const ScheduleTaskRevision& );

    friend class  ScheduleTaskRevisionDelegate;
    friend class  ScheduleTaskRevisionDispatch;
    friend class  ScheduleTaskRevisionGenImpl;
};

#include <schmgt/libschmgt_undef.h>
#endif //   TEAMCENTER__SCHEDULETASKREVISION__HXX
