//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ScheduleTaskRevisionDelegate
    Filename:   ScheduleTaskRevisionDelegate.hxx
    Module:     schmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SCHEDULETASKREVISIONDELEGATE_HXX
#define TEAMCENTER__SCHEDULETASKREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <schmgt/ScheduleTaskRevision.hxx>

#include <schmgt/libschmgt_exports.h>

namespace Teamcenter
{
    class ScheduleTaskRevisionDelegate;
}
namespace Teamcenter
{
    class ScheduleTaskRevisionImpl;
}
namespace Teamcenter
{
    class ScheduleTaskRevision;
}
namespace Teamcenter
{
    class ScheduleTaskRevisionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  SCHMGT_API Teamcenter_alias::ScheduleTaskRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ScheduleTaskRevisionDelegate instance
    static ScheduleTaskRevisionDelegate&  getInstance();

    //  Method to create the ScheduleTaskRevisionImpl pointer
    static ScheduleTaskRevisionImpl*  createImpl( ScheduleTaskRevision&  ifObj );

    //  Method to delete the ScheduleTaskRevisionImpl pointer
    static void deleteImpl( ScheduleTaskRevisionImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0workflow_ownerBase(const ScheduleTaskRevision &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 9.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setChild_task_taglistBase(ScheduleTaskRevision &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0workflow_ownerBase(ScheduleTaskRevision &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPriorityBase(ScheduleTaskRevision &ifObj,  int value, bool isNull );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const ScheduleTaskRevision &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static ScheduleTaskRevisionDelegate*  m_pInstance;

    ScheduleTaskRevisionDelegate();
    virtual ~ScheduleTaskRevisionDelegate();
    static void setInstance( ScheduleTaskRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::ScheduleTaskRevisionGenImpl;

};

#include <schmgt/libschmgt_undef.h>
#endif  //  TEAMCENTER__SCHEDULETASKREVISIONDELEGATE_HXX
