//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SchedulingFixedCost
    Filename:   SchedulingFixedCost.hxx
    Module:     schmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SCHEDULINGFIXEDCOST__HXX
#define TEAMCENTER__SCHEDULINGFIXEDCOST__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <schmgt/libschmgt_exports.h>

namespace Teamcenter
{
    class SchedulingFixedCost;
}
namespace Teamcenter
{
    class SchedulingFixedCostImpl;
}
namespace Teamcenter
{
    class SchedulingFixedCostDelegate;
}
namespace Teamcenter
{
    class SchedulingFixedCostDispatch;
}
namespace Teamcenter
{
    class SchedulingFixedCostGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SCHMGT_API  Teamcenter::SchedulingFixedCost
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SchedulingFixedCost();

    /**
     * Destructor
     */
    virtual ~SchedulingFixedCost();

private:
    //  Getter method for the Implementation Object
    SchedulingFixedCostImpl*  getSchedulingFixedCostImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSchedulingFixedCostImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SchedulingFixedCostImpl*  m_schedulingfixedcostImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SchedulingFixedCost - desc for SchedulingFixedCost parameter
     */
    SchedulingFixedCost( const SchedulingFixedCost& );
    SchedulingFixedCost& operator=( const SchedulingFixedCost& );

    friend class  SchedulingFixedCostDelegate;
    friend class  SchedulingFixedCostDispatch;
    friend class  SchedulingFixedCostGenImpl;
};

#include <schmgt/libschmgt_undef.h>
#endif //   TEAMCENTER__SCHEDULINGFIXEDCOST__HXX
