//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TaskDeliverable
    Filename:   TaskDeliverable.hxx
    Module:     schmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TASKDELIVERABLE__HXX
#define TEAMCENTER__TASKDELIVERABLE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <schmgt/libschmgt_exports.h>

namespace Teamcenter
{
    class TaskDeliverable;
}
namespace Teamcenter
{
    class TaskDeliverableImpl;
}
namespace Teamcenter
{
    class TaskDeliverableDelegate;
}
namespace Teamcenter
{
    class TaskDeliverableDispatch;
}
namespace Teamcenter
{
    class TaskDeliverableGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SCHMGT_API  Teamcenter::TaskDeliverable
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    TaskDeliverable();

    /**
     * Destructor
     */
    virtual ~TaskDeliverable();

private:
    //  Getter method for the Implementation Object
    TaskDeliverableImpl*  getTaskDeliverableImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTaskDeliverableImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    TaskDeliverableImpl*  m_taskdeliverableImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param TaskDeliverable - desc for TaskDeliverable parameter
     */
    TaskDeliverable( const TaskDeliverable& );
    TaskDeliverable& operator=( const TaskDeliverable& );

    friend class  TaskDeliverableDelegate;
    friend class  TaskDeliverableDispatch;
    friend class  TaskDeliverableGenImpl;
};

#include <schmgt/libschmgt_undef.h>
#endif //   TEAMCENTER__TASKDELIVERABLE__HXX
