//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TaskDependency
    Filename:   TaskDependency.hxx
    Module:     schmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TASKDEPENDENCY__HXX
#define TEAMCENTER__TASKDEPENDENCY__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <schmgt/libschmgt_exports.h>

namespace Teamcenter
{
    class TaskDependency;
}
namespace Teamcenter
{
    class TaskDependencyImpl;
}
namespace Teamcenter
{
    class TaskDependencyDelegate;
}
namespace Teamcenter
{
    class TaskDependencyDispatch;
}
namespace Teamcenter
{
    class TaskDependencyGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SCHMGT_API  Teamcenter::TaskDependency
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDependency_type( int &value, bool &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0WhatIfMode( int &value, bool &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLag_time( int &value, bool &isNull ) const;

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 11.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDependency_type( int value, bool isNull=false );

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 11.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0WhatIfMode( int value, bool isNull=false );

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 11.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLag_time( int value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    TaskDependency();

    /**
     * Destructor
     */
    virtual ~TaskDependency();

private:
    //  Getter method for the Implementation Object
    TaskDependencyImpl*  getTaskDependencyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTaskDependencyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    TaskDependencyImpl*  m_taskdependencyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param TaskDependency - desc for TaskDependency parameter
     */
    TaskDependency( const TaskDependency& );
    TaskDependency& operator=( const TaskDependency& );

    friend class  TaskDependencyDelegate;
    friend class  TaskDependencyDispatch;
    friend class  TaskDependencyGenImpl;
};

#include <schmgt/libschmgt_undef.h>
#endif //   TEAMCENTER__TASKDEPENDENCY__HXX
