//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TaskExecutionFormInfo
    Filename:   TaskExecutionFormInfo.hxx
    Module:     schmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TASKEXECUTIONFORMINFO__HXX
#define TEAMCENTER__TASKEXECUTIONFORMINFO__HXX

#include <unidefs.h>
#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <schmgt/libschmgt_exports.h>

namespace Teamcenter
{
    class TaskExecutionFormInfo;
}
namespace Teamcenter
{
    class TaskExecutionFormInfoImpl;
}
namespace Teamcenter
{
    class TaskExecutionFormInfoDelegate;
}
namespace Teamcenter
{
    class TaskExecutionFormInfoDispatch;
}
namespace Teamcenter
{
    class TaskExecutionFormInfoGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SCHMGT_API  Teamcenter::TaskExecutionFormInfo
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getApproved_work( int &value, bool &isNull ) const;

    ///
    /// Setter for a Date Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setActual_finish_date( const date_t &value, bool isNull=false );

    ///
    /// Setter for a Date Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setActual_start_date( const date_t &value, bool isNull=false );

    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setApproved_work( int value, bool isNull=false );

    ///
    /// Setter for a Double Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setComplete_percent( double value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0state( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0status( const std::string &value, bool isNull=false );

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setStatus( int value, bool isNull=false );

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setWork_complete( int value, bool isNull=false );

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setWork_remaining( int value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    TaskExecutionFormInfo();

    /**
     * Destructor
     */
    virtual ~TaskExecutionFormInfo();

private:
    //  Getter method for the Implementation Object
    TaskExecutionFormInfoImpl*  getTaskExecutionFormInfoImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTaskExecutionFormInfoImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    TaskExecutionFormInfoImpl*  m_taskexecutionforminfoImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param TaskExecutionFormInfo - desc for TaskExecutionFormInfo parameter
     */
    TaskExecutionFormInfo( const TaskExecutionFormInfo& );
    TaskExecutionFormInfo& operator=( const TaskExecutionFormInfo& );

    friend class  TaskExecutionFormInfoDelegate;
    friend class  TaskExecutionFormInfoDispatch;
    friend class  TaskExecutionFormInfoGenImpl;
};

#include <schmgt/libschmgt_undef.h>
#endif //   TEAMCENTER__TASKEXECUTIONFORMINFO__HXX
