//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TaskExecutionFormInfoDelegate
    Filename:   TaskExecutionFormInfoDelegate.hxx
    Module:     schmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TASKEXECUTIONFORMINFODELEGATE_HXX
#define TEAMCENTER__TASKEXECUTIONFORMINFODELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <schmgt/TaskExecutionFormInfo.hxx>

#include <schmgt/libschmgt_exports.h>

namespace Teamcenter
{
    class TaskExecutionFormInfoDelegate;
}
namespace Teamcenter
{
    class TaskExecutionFormInfoImpl;
}
namespace Teamcenter
{
    class TaskExecutionFormInfo;
}
namespace Teamcenter
{
    class TaskExecutionFormInfoGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  SCHMGT_API Teamcenter_alias::TaskExecutionFormInfoDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the TaskExecutionFormInfoDelegate instance
    static TaskExecutionFormInfoDelegate&  getInstance();

    //  Method to create the TaskExecutionFormInfoImpl pointer
    static TaskExecutionFormInfoImpl*  createImpl( TaskExecutionFormInfo&  ifObj );

    //  Method to delete the TaskExecutionFormInfoImpl pointer
    static void deleteImpl( TaskExecutionFormInfoImpl*  impl );


    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getApproved_workBase(const TaskExecutionFormInfo &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Setter for a Date Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setActual_finish_dateBase(TaskExecutionFormInfo &ifObj,  const date_t &value, bool isNull );


    ///
    /// Setter for a Date Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setActual_start_dateBase(TaskExecutionFormInfo &ifObj,  const date_t &value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setApproved_workBase(TaskExecutionFormInfo &ifObj,  int value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setComplete_percentBase(TaskExecutionFormInfo &ifObj,  double value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0stateBase(TaskExecutionFormInfo &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0statusBase(TaskExecutionFormInfo &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setStatusBase(TaskExecutionFormInfo &ifObj,  int value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setWork_completeBase(TaskExecutionFormInfo &ifObj,  int value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setWork_remainingBase(TaskExecutionFormInfo &ifObj,  int value, bool isNull );



protected:
    //  Pointer to the instance
    static TaskExecutionFormInfoDelegate*  m_pInstance;

    TaskExecutionFormInfoDelegate();
    virtual ~TaskExecutionFormInfoDelegate();
    static void setInstance( TaskExecutionFormInfoDelegate*  instance );


private:
    friend class  ::Teamcenter::TaskExecutionFormInfoGenImpl;

};

#include <schmgt/libschmgt_undef.h>
#endif  //  TEAMCENTER__TASKEXECUTIONFORMINFODELEGATE_HXX
