//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TaskSchedulingFormInfo
    Filename:   TaskSchedulingFormInfo.hxx
    Module:     schmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TASKSCHEDULINGFORMINFO__HXX
#define TEAMCENTER__TASKSCHEDULINGFORMINFO__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <schmgt/libschmgt_exports.h>

namespace Teamcenter
{
    class TaskSchedulingFormInfo;
}
namespace Teamcenter
{
    class TaskSchedulingFormInfoImpl;
}
namespace Teamcenter
{
    class TaskSchedulingFormInfoDelegate;
}
namespace Teamcenter
{
    class TaskSchedulingFormInfoDispatch;
}
namespace Teamcenter
{
    class TaskSchedulingFormInfoGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SCHMGT_API  Teamcenter::TaskSchedulingFormInfo
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getWorkflow_template( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDuration( int value, bool isNull=false );

    ///
    /// Setter for a Date Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFinish_date( const date_t &value, bool isNull=false );

    ///
    /// Setter for a Date Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setStart_date( const date_t &value, bool isNull=false );

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setWork_estimate( int value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setWorkflow_template( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    TaskSchedulingFormInfo();

    /**
     * Destructor
     */
    virtual ~TaskSchedulingFormInfo();

private:
    //  Getter method for the Implementation Object
    TaskSchedulingFormInfoImpl*  getTaskSchedulingFormInfoImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTaskSchedulingFormInfoImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    TaskSchedulingFormInfoImpl*  m_taskschedulingforminfoImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param TaskSchedulingFormInfo - desc for TaskSchedulingFormInfo parameter
     */
    TaskSchedulingFormInfo( const TaskSchedulingFormInfo& );
    TaskSchedulingFormInfo& operator=( const TaskSchedulingFormInfo& );

    friend class  TaskSchedulingFormInfoDelegate;
    friend class  TaskSchedulingFormInfoDispatch;
    friend class  TaskSchedulingFormInfoGenImpl;
};

#include <schmgt/libschmgt_undef.h>
#endif //   TEAMCENTER__TASKSCHEDULINGFORMINFO__HXX
