//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TaskSchedulingFormInfoDelegate
    Filename:   TaskSchedulingFormInfoDelegate.hxx
    Module:     schmgt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TASKSCHEDULINGFORMINFODELEGATE_HXX
#define TEAMCENTER__TASKSCHEDULINGFORMINFODELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <schmgt/TaskSchedulingFormInfo.hxx>

#include <schmgt/libschmgt_exports.h>

namespace Teamcenter
{
    class TaskSchedulingFormInfoDelegate;
}
namespace Teamcenter
{
    class TaskSchedulingFormInfoImpl;
}
namespace Teamcenter
{
    class TaskSchedulingFormInfo;
}
namespace Teamcenter
{
    class TaskSchedulingFormInfoGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  SCHMGT_API Teamcenter_alias::TaskSchedulingFormInfoDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the TaskSchedulingFormInfoDelegate instance
    static TaskSchedulingFormInfoDelegate&  getInstance();

    //  Method to create the TaskSchedulingFormInfoImpl pointer
    static TaskSchedulingFormInfoImpl*  createImpl( TaskSchedulingFormInfo&  ifObj );

    //  Method to delete the TaskSchedulingFormInfoImpl pointer
    static void deleteImpl( TaskSchedulingFormInfoImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getWorkflow_templateBase(const TaskSchedulingFormInfo &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDurationBase(TaskSchedulingFormInfo &ifObj,  int value, bool isNull );


    ///
    /// Setter for a Date Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFinish_dateBase(TaskSchedulingFormInfo &ifObj,  const date_t &value, bool isNull );


    ///
    /// Setter for a Date Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setStart_dateBase(TaskSchedulingFormInfo &ifObj,  const date_t &value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setWork_estimateBase(TaskSchedulingFormInfo &ifObj,  int value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setWorkflow_templateBase(TaskSchedulingFormInfo &ifObj,  const tag_t &value, bool isNull );



protected:
    //  Pointer to the instance
    static TaskSchedulingFormInfoDelegate*  m_pInstance;

    TaskSchedulingFormInfoDelegate();
    virtual ~TaskSchedulingFormInfoDelegate();
    static void setInstance( TaskSchedulingFormInfoDelegate*  instance );


private:
    friend class  ::Teamcenter::TaskSchedulingFormInfoGenImpl;

};

#include <schmgt/libschmgt_undef.h>
#endif  //  TEAMCENTER__TASKSCHEDULINGFORMINFODELEGATE_HXX
