//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  schmgt

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libschmgt

#if !defined(LIBSCHMGT) && !defined(IPLIB)
#   error IPLIB or LIBSCHMGT is not defined
#endif

/* Handwritten code should use SCHMGT_API, not SCHMGTEXPORT */

#define SCHMGT_API SCHMGTEXPORT

#if IPLIB==libschmgt || defined(LIBSCHMGT)
#   if defined(__lint)
#       define SCHMGTEXPORT       __export(schmgt)
#       define SCHMGTGLOBAL       extern __global(schmgt)
#       define SCHMGTPRIVATE      extern __private(schmgt)
#   elif defined(_WIN32)
#       define SCHMGTEXPORT       __declspec(dllexport)
#       define SCHMGTGLOBAL       extern __declspec(dllexport)
#       define SCHMGTPRIVATE      extern
#   else
#       define SCHMGTEXPORT
#       define SCHMGTGLOBAL       extern
#       define SCHMGTPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define SCHMGTEXPORT       __export(schmgt)
#       define SCHMGTGLOBAL       extern __global(schmgt)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define SCHMGTEXPORT      __declspec(dllimport)
#       define SCHMGTGLOBAL       extern __declspec(dllimport)
#   else
#       define SCHMGTEXPORT
#       define SCHMGTGLOBAL       extern
#   endif
#endif
