//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SCMConfigContextDispatch
    Filename:   SCMConfigContextDispatch.hxx
    Module:     scmccdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SCMCONFIGCONTEXTDISPATCH_HXX
#define TEAMCENTER__SCMCONFIGCONTEXTDISPATCH_HXX

#include <vector>
#include <mechatronics/SCMConfigContext.hxx>
#include <mechatronics/SCMConfigContextDelegate.hxx>
#include <foundationdispatch/POM_objectDispatch.hxx>
#include <scmccdispatch/initializescmcc.hxx>

#include <scmccdispatch/libscmccdispatch_exports.h>

namespace Teamcenter
{
    class SCMConfigContextDispatch;
}
namespace Teamcenter
{
    class SCMConfigContextDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  SCMCCDISPATCH_API  Teamcenter::SCMConfigContextDispatch
    : public  Teamcenter::SCMConfigContextDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SCMConfigContextDispatch instance
    static SCMConfigContextDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static SCMConfigContextDispatch*  m_dispatch;

    //  Default Constructor
    SCMConfigContextDispatch();

    //  Default Destructor
    virtual ~SCMConfigContextDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a SCMConfigContextDispatch
    SCMConfigContextDispatch( const SCMConfigContextDispatch& );

    //  Assignment operator
    SCMConfigContextDispatch&  operator = ( const SCMConfigContextDispatch& );

    //  friend
    friend void   ::Teamcenter::initializescmccInternal();
    friend void   ::Teamcenter::initializescmccExtenders();
    friend class  Teamcenter::SCMConfigContextDelegate;
};

#include <scmccdispatch/libscmccdispatch_undef.h>
#endif  //  TEAMCENTER__SCMCONFIGCONTEXTDISPATCH_HXX
