//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SCMServerDispatch
    Filename:   SCMServerDispatch.hxx
    Module:     scmccdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SCMSERVERDISPATCH_HXX
#define TEAMCENTER__SCMSERVERDISPATCH_HXX

#include <vector>
#include <mechatronics/SCMServer.hxx>
#include <mechatronics/SCMServerDelegate.hxx>
#include <foundationdispatch/WorkspaceObjectDispatch.hxx>
#include <scmccdispatch/initializescmcc.hxx>

#include <scmccdispatch/libscmccdispatch_exports.h>

namespace Teamcenter
{
    class SCMServerDispatch;
}
namespace Teamcenter
{
    class SCMServerDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  SCMCCDISPATCH_API  Teamcenter::SCMServerDispatch
    : public  Teamcenter::SCMServerDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SCMServerDispatch instance
    static SCMServerDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static SCMServerDispatch*  m_dispatch;

    //  Default Constructor
    SCMServerDispatch();

    //  Default Destructor
    virtual ~SCMServerDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a SCMServerDispatch
    SCMServerDispatch( const SCMServerDispatch& );

    //  Assignment operator
    SCMServerDispatch&  operator = ( const SCMServerDispatch& );

    //  friend
    friend void   ::Teamcenter::initializescmccInternal();
    friend void   ::Teamcenter::initializescmccExtenders();
    friend class  Teamcenter::SCMServerDelegate;
};

#include <scmccdispatch/libscmccdispatch_undef.h>
#endif  //  TEAMCENTER__SCMSERVERDISPATCH_HXX
