//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  scmccdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libscmccdispatch

#if !defined(LIBSCMCCDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBSCMCCDISPATCH is not defined
#endif

/* Handwritten code should use SCMCCDISPATCH_API, not SCMCCDISPATCHEXPORT */

#define SCMCCDISPATCH_API SCMCCDISPATCHEXPORT

#if IPLIB==libscmccdispatch || defined(LIBSCMCCDISPATCH)
#   if defined(__lint)
#       define SCMCCDISPATCHEXPORT       __export(scmccdispatch)
#       define SCMCCDISPATCHGLOBAL       extern __global(scmccdispatch)
#       define SCMCCDISPATCHPRIVATE      extern __private(scmccdispatch)
#   elif defined(_WIN32)
#       define SCMCCDISPATCHEXPORT       __declspec(dllexport)
#       define SCMCCDISPATCHGLOBAL       extern __declspec(dllexport)
#       define SCMCCDISPATCHPRIVATE      extern
#   else
#       define SCMCCDISPATCHEXPORT
#       define SCMCCDISPATCHGLOBAL       extern
#       define SCMCCDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define SCMCCDISPATCHEXPORT       __export(scmccdispatch)
#       define SCMCCDISPATCHGLOBAL       extern __global(scmccdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define SCMCCDISPATCHEXPORT      __declspec(dllimport)
#       define SCMCCDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define SCMCCDISPATCHEXPORT
#       define SCMCCDISPATCHGLOBAL       extern
#   endif
#endif
