//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0BuildingBlockBOMLine
    Filename:   Fnd0BuildingBlockBOMLine.hxx
    Module:     secore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0BUILDINGBLOCKBOMLINE__HXX
#define TEAMCENTER__FND0BUILDINGBLOCKBOMLINE__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <bom/ImanItemLine.hxx>

#include <secore/libsecore_exports.h>

namespace Teamcenter
{
    class Fnd0BuildingBlockBOMLine;
}
namespace Teamcenter
{
    class Fnd0BuildingBlockBOMLineImpl;
}
namespace Teamcenter
{
    class Fnd0BuildingBlockBOMLineDelegate;
}
namespace Teamcenter
{
    class Fnd0BuildingBlockBOMLineDispatch;
}
namespace Teamcenter
{
    class Fnd0BuildingBlockBOMLineGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SECORE_API  Teamcenter::Fnd0BuildingBlockBOMLine
     : public  ::Teamcenter::ImanItemLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0bl_hierarchical_number( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0bl_hierarchical_number( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0BuildingBlockBOMLine();

    /**
     * Destructor
     */
    virtual ~Fnd0BuildingBlockBOMLine();

private:
    //  Getter method for the Implementation Object
    Fnd0BuildingBlockBOMLineImpl*  getFnd0BuildingBlockBOMLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0BuildingBlockBOMLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0BuildingBlockBOMLineImpl*  m_fnd0buildingblockbomlineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0BuildingBlockBOMLine - desc for Fnd0BuildingBlockBOMLine parameter
     */
    Fnd0BuildingBlockBOMLine( const Fnd0BuildingBlockBOMLine& );
    Fnd0BuildingBlockBOMLine& operator=( const Fnd0BuildingBlockBOMLine& );

    friend class  Fnd0BuildingBlockBOMLineDelegate;
    friend class  Fnd0BuildingBlockBOMLineDispatch;
    friend class  Fnd0BuildingBlockBOMLineGenImpl;
};

#include <secore/libsecore_undef.h>
#endif //   TEAMCENTER__FND0BUILDINGBLOCKBOMLINE__HXX
