//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ColumnConfiguration
    Filename:   Fnd0ColumnConfiguration.hxx
    Module:     secore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0COLUMNCONFIGURATION__HXX
#define TEAMCENTER__FND0COLUMNCONFIGURATION__HXX

#include <common/tc_deprecation_macros.h>
#include <secore/Fnd0UIConfiguration.hxx>

#include <secore/libsecore_exports.h>

namespace Teamcenter
{
    class Fnd0ColumnConfiguration;
}
namespace Teamcenter
{
    class Fnd0ColumnConfigurationImpl;
}
namespace Teamcenter
{
    class Fnd0ColumnConfigurationDelegate;
}
namespace Teamcenter
{
    class Fnd0ColumnConfigurationDispatch;
}
namespace Teamcenter
{
    class Fnd0ColumnConfigurationGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SECORE_API  Teamcenter::Fnd0ColumnConfiguration
     : public  ::Teamcenter::Fnd0UIConfiguration
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0ColumnConfiguration();

    /**
     * Destructor
     */
    virtual ~Fnd0ColumnConfiguration();

private:
    //  Getter method for the Implementation Object
    Fnd0ColumnConfigurationImpl*  getFnd0ColumnConfigurationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0ColumnConfigurationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0ColumnConfigurationImpl*  m_fnd0columnconfigurationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0ColumnConfiguration - desc for Fnd0ColumnConfiguration parameter
     */
    Fnd0ColumnConfiguration( const Fnd0ColumnConfiguration& );
    Fnd0ColumnConfiguration& operator=( const Fnd0ColumnConfiguration& );

    friend class  Fnd0ColumnConfigurationDelegate;
    friend class  Fnd0ColumnConfigurationDispatch;
    friend class  Fnd0ColumnConfigurationGenImpl;
};

#include <secore/libsecore_undef.h>
#endif //   TEAMCENTER__FND0COLUMNCONFIGURATION__HXX
