//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ColumnConfigurationDelegate
    Filename:   Fnd0ColumnConfigurationDelegate.hxx
    Module:     secore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0COLUMNCONFIGURATIONDELEGATE_HXX
#define TEAMCENTER__FND0COLUMNCONFIGURATIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <secore/Fnd0ColumnConfiguration.hxx>

#include <secore/libsecore_exports.h>

namespace Teamcenter
{
    class Fnd0ColumnConfigurationDelegate;
}
namespace Teamcenter
{
    class Fnd0ColumnConfigurationImpl;
}
namespace Teamcenter
{
    class Fnd0ColumnConfiguration;
}
namespace Teamcenter
{
    class Fnd0ColumnConfigurationGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  SECORE_API Teamcenter_alias::Fnd0ColumnConfigurationDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0ColumnConfigurationDelegate instance
    static Fnd0ColumnConfigurationDelegate&  getInstance();

    //  Method to create the Fnd0ColumnConfigurationImpl pointer
    static Fnd0ColumnConfigurationImpl*  createImpl( Fnd0ColumnConfiguration&  ifObj );

    //  Method to delete the Fnd0ColumnConfigurationImpl pointer
    static void deleteImpl( Fnd0ColumnConfigurationImpl*  impl );


    ///
    /// To publish the column configuration
    /// @version Teamcenter 9
    /// @return - Returns status as an integer
    ///
    int  fnd0PublishBase(const Fnd0ColumnConfiguration &ifObj  );



protected:
    //  Pointer to the instance
    static Fnd0ColumnConfigurationDelegate*  m_pInstance;

    Fnd0ColumnConfigurationDelegate();
    virtual ~Fnd0ColumnConfigurationDelegate();
    static void setInstance( Fnd0ColumnConfigurationDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0ColumnConfigurationGenImpl;

};

#include <secore/libsecore_undef.h>
#endif  //  TEAMCENTER__FND0COLUMNCONFIGURATIONDELEGATE_HXX
