//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0FunctionalBOMLine
    Filename:   Fnd0FunctionalBOMLine.hxx
    Module:     secore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0FUNCTIONALBOMLINE__HXX
#define TEAMCENTER__FND0FUNCTIONALBOMLINE__HXX

#include <common/tc_deprecation_macros.h>
#include <secore/Fnd0BuildingBlockBOMLine.hxx>

#include <secore/libsecore_exports.h>

namespace Teamcenter
{
    class Fnd0FunctionalBOMLine;
}
namespace Teamcenter
{
    class Fnd0FunctionalBOMLineImpl;
}
namespace Teamcenter
{
    class Fnd0FunctionalBOMLineDelegate;
}
namespace Teamcenter
{
    class Fnd0FunctionalBOMLineDispatch;
}
namespace Teamcenter
{
    class Fnd0FunctionalBOMLineGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SECORE_API  Teamcenter::Fnd0FunctionalBOMLine
     : public  ::Teamcenter::Fnd0BuildingBlockBOMLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0FunctionalBOMLine();

    /**
     * Destructor
     */
    virtual ~Fnd0FunctionalBOMLine();

private:
    //  Getter method for the Implementation Object
    Fnd0FunctionalBOMLineImpl*  getFnd0FunctionalBOMLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0FunctionalBOMLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0FunctionalBOMLineImpl*  m_fnd0functionalbomlineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0FunctionalBOMLine - desc for Fnd0FunctionalBOMLine parameter
     */
    Fnd0FunctionalBOMLine( const Fnd0FunctionalBOMLine& );
    Fnd0FunctionalBOMLine& operator=( const Fnd0FunctionalBOMLine& );

    friend class  Fnd0FunctionalBOMLineDelegate;
    friend class  Fnd0FunctionalBOMLineDispatch;
    friend class  Fnd0FunctionalBOMLineGenImpl;
};

#include <secore/libsecore_undef.h>
#endif //   TEAMCENTER__FND0FUNCTIONALBOMLINE__HXX
