//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0LogicConn
    Filename:   Fnd0LogicConn.hxx
    Module:     secore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0LOGICCONN__HXX
#define TEAMCENTER__FND0LOGICCONN__HXX

#include <common/tc_deprecation_macros.h>
#include <mechatronics/PSConnection.hxx>

#include <secore/libsecore_exports.h>

namespace Teamcenter
{
    class Fnd0LogicConn;
}
namespace Teamcenter
{
    class Fnd0LogicConnImpl;
}
namespace Teamcenter
{
    class Fnd0LogicConnDelegate;
}
namespace Teamcenter
{
    class Fnd0LogicConnDispatch;
}
namespace Teamcenter
{
    class Fnd0LogicConnGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SECORE_API  Teamcenter::Fnd0LogicConn
     : public  ::Teamcenter::PSConnection
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0LogicConn();

    /**
     * Destructor
     */
    virtual ~Fnd0LogicConn();

private:
    //  Getter method for the Implementation Object
    Fnd0LogicConnImpl*  getFnd0LogicConnImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0LogicConnImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0LogicConnImpl*  m_fnd0logicconnImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0LogicConn - desc for Fnd0LogicConn parameter
     */
    Fnd0LogicConn( const Fnd0LogicConn& );
    Fnd0LogicConn& operator=( const Fnd0LogicConn& );

    friend class  Fnd0LogicConnDelegate;
    friend class  Fnd0LogicConnDispatch;
    friend class  Fnd0LogicConnGenImpl;
};

#include <secore/libsecore_undef.h>
#endif //   TEAMCENTER__FND0LOGICCONN__HXX
