//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0LogicConnRevision
    Filename:   Fnd0LogicConnRevision.hxx
    Module:     secore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0LOGICCONNREVISION__HXX
#define TEAMCENTER__FND0LOGICCONNREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <mechatronics/PSConnectionRevision.hxx>

#include <secore/libsecore_exports.h>

namespace Teamcenter
{
    class Fnd0LogicConnRevision;
}
namespace Teamcenter
{
    class Fnd0LogicConnRevisionImpl;
}
namespace Teamcenter
{
    class Fnd0LogicConnRevisionDelegate;
}
namespace Teamcenter
{
    class Fnd0LogicConnRevisionDispatch;
}
namespace Teamcenter
{
    class Fnd0LogicConnRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SECORE_API  Teamcenter::Fnd0LogicConnRevision
     : public  ::Teamcenter::PSConnectionRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0LogicConnRevision();

    /**
     * Destructor
     */
    virtual ~Fnd0LogicConnRevision();

private:
    //  Getter method for the Implementation Object
    Fnd0LogicConnRevisionImpl*  getFnd0LogicConnRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0LogicConnRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0LogicConnRevisionImpl*  m_fnd0logicconnrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0LogicConnRevision - desc for Fnd0LogicConnRevision parameter
     */
    Fnd0LogicConnRevision( const Fnd0LogicConnRevision& );
    Fnd0LogicConnRevision& operator=( const Fnd0LogicConnRevision& );

    friend class  Fnd0LogicConnRevisionDelegate;
    friend class  Fnd0LogicConnRevisionDispatch;
    friend class  Fnd0LogicConnRevisionGenImpl;
};

#include <secore/libsecore_undef.h>
#endif //   TEAMCENTER__FND0LOGICCONNREVISION__HXX
