//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0LogicIntrfce
    Filename:   Fnd0LogicIntrfce.hxx
    Module:     secore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0LOGICINTRFCE__HXX
#define TEAMCENTER__FND0LOGICINTRFCE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccoreext/GeneralDesignElement.hxx>

#include <secore/libsecore_exports.h>

namespace Teamcenter
{
    class Fnd0LogicIntrfce;
}
namespace Teamcenter
{
    class Fnd0LogicIntrfceImpl;
}
namespace Teamcenter
{
    class Fnd0LogicIntrfceDelegate;
}
namespace Teamcenter
{
    class Fnd0LogicIntrfceDispatch;
}
namespace Teamcenter
{
    class Fnd0LogicIntrfceGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SECORE_API  Teamcenter::Fnd0LogicIntrfce
     : public  ::Teamcenter::GeneralDesignElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0LogicIntrfce();

    /**
     * Destructor
     */
    virtual ~Fnd0LogicIntrfce();

private:
    //  Getter method for the Implementation Object
    Fnd0LogicIntrfceImpl*  getFnd0LogicIntrfceImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0LogicIntrfceImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0LogicIntrfceImpl*  m_fnd0logicintrfceImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0LogicIntrfce - desc for Fnd0LogicIntrfce parameter
     */
    Fnd0LogicIntrfce( const Fnd0LogicIntrfce& );
    Fnd0LogicIntrfce& operator=( const Fnd0LogicIntrfce& );

    friend class  Fnd0LogicIntrfceDelegate;
    friend class  Fnd0LogicIntrfceDispatch;
    friend class  Fnd0LogicIntrfceGenImpl;
};

#include <secore/libsecore_undef.h>
#endif //   TEAMCENTER__FND0LOGICINTRFCE__HXX
