//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0LogicalBOMLine
    Filename:   Fnd0LogicalBOMLine.hxx
    Module:     secore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0LOGICALBOMLINE__HXX
#define TEAMCENTER__FND0LOGICALBOMLINE__HXX

#include <common/tc_deprecation_macros.h>
#include <secore/Fnd0BuildingBlockBOMLine.hxx>

#include <secore/libsecore_exports.h>

namespace Teamcenter
{
    class Fnd0LogicalBOMLine;
}
namespace Teamcenter
{
    class Fnd0LogicalBOMLineImpl;
}
namespace Teamcenter
{
    class Fnd0LogicalBOMLineDelegate;
}
namespace Teamcenter
{
    class Fnd0LogicalBOMLineDispatch;
}
namespace Teamcenter
{
    class Fnd0LogicalBOMLineGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SECORE_API  Teamcenter::Fnd0LogicalBOMLine
     : public  ::Teamcenter::Fnd0BuildingBlockBOMLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0LogicalBOMLine();

    /**
     * Destructor
     */
    virtual ~Fnd0LogicalBOMLine();

private:
    //  Getter method for the Implementation Object
    Fnd0LogicalBOMLineImpl*  getFnd0LogicalBOMLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0LogicalBOMLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0LogicalBOMLineImpl*  m_fnd0logicalbomlineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0LogicalBOMLine - desc for Fnd0LogicalBOMLine parameter
     */
    Fnd0LogicalBOMLine( const Fnd0LogicalBOMLine& );
    Fnd0LogicalBOMLine& operator=( const Fnd0LogicalBOMLine& );

    friend class  Fnd0LogicalBOMLineDelegate;
    friend class  Fnd0LogicalBOMLineDispatch;
    friend class  Fnd0LogicalBOMLineGenImpl;
};

#include <secore/libsecore_undef.h>
#endif //   TEAMCENTER__FND0LOGICALBOMLINE__HXX
