//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0LogicalBlock
    Filename:   Fnd0LogicalBlock.hxx
    Module:     secore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0LOGICALBLOCK__HXX
#define TEAMCENTER__FND0LOGICALBLOCK__HXX

#include <common/tc_deprecation_macros.h>
#include <secore/Fnd0SEBlock.hxx>

#include <secore/libsecore_exports.h>

namespace Teamcenter
{
    class Fnd0LogicalBlock;
}
namespace Teamcenter
{
    class Fnd0LogicalBlockImpl;
}
namespace Teamcenter
{
    class Fnd0LogicalBlockDelegate;
}
namespace Teamcenter
{
    class Fnd0LogicalBlockDispatch;
}
namespace Teamcenter
{
    class Fnd0LogicalBlockGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SECORE_API  Teamcenter::Fnd0LogicalBlock
     : public  ::Teamcenter::Fnd0SEBlock
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0LogicalBlock();

    /**
     * Destructor
     */
    virtual ~Fnd0LogicalBlock();

private:
    //  Getter method for the Implementation Object
    Fnd0LogicalBlockImpl*  getFnd0LogicalBlockImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0LogicalBlockImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0LogicalBlockImpl*  m_fnd0logicalblockImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0LogicalBlock - desc for Fnd0LogicalBlock parameter
     */
    Fnd0LogicalBlock( const Fnd0LogicalBlock& );
    Fnd0LogicalBlock& operator=( const Fnd0LogicalBlock& );

    friend class  Fnd0LogicalBlockDelegate;
    friend class  Fnd0LogicalBlockDispatch;
    friend class  Fnd0LogicalBlockGenImpl;
};

#include <secore/libsecore_undef.h>
#endif //   TEAMCENTER__FND0LOGICALBLOCK__HXX
