//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0LogicalBlockRevision
    Filename:   Fnd0LogicalBlockRevision.hxx
    Module:     secore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0LOGICALBLOCKREVISION__HXX
#define TEAMCENTER__FND0LOGICALBLOCKREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <secore/Fnd0SEBlockRevision.hxx>

#include <secore/libsecore_exports.h>

namespace Teamcenter
{
    class Fnd0LogicalBlockRevision;
}
namespace Teamcenter
{
    class Fnd0LogicalBlockRevisionImpl;
}
namespace Teamcenter
{
    class Fnd0LogicalBlockRevisionDelegate;
}
namespace Teamcenter
{
    class Fnd0LogicalBlockRevisionDispatch;
}
namespace Teamcenter
{
    class Fnd0LogicalBlockRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SECORE_API  Teamcenter::Fnd0LogicalBlockRevision
     : public  ::Teamcenter::Fnd0SEBlockRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0LogicalBlockRevision();

    /**
     * Destructor
     */
    virtual ~Fnd0LogicalBlockRevision();

private:
    //  Getter method for the Implementation Object
    Fnd0LogicalBlockRevisionImpl*  getFnd0LogicalBlockRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0LogicalBlockRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0LogicalBlockRevisionImpl*  m_fnd0logicalblockrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0LogicalBlockRevision - desc for Fnd0LogicalBlockRevision parameter
     */
    Fnd0LogicalBlockRevision( const Fnd0LogicalBlockRevision& );
    Fnd0LogicalBlockRevision& operator=( const Fnd0LogicalBlockRevision& );

    friend class  Fnd0LogicalBlockRevisionDelegate;
    friend class  Fnd0LogicalBlockRevisionDispatch;
    friend class  Fnd0LogicalBlockRevisionGenImpl;
};

#include <secore/libsecore_undef.h>
#endif //   TEAMCENTER__FND0LOGICALBLOCKREVISION__HXX
