//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0SEBlock
    Filename:   Fnd0SEBlock.hxx
    Module:     secore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0SEBLOCK__HXX
#define TEAMCENTER__FND0SEBLOCK__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <secore/libsecore_exports.h>

namespace Teamcenter
{
    class Fnd0SEBlock;
}
namespace Teamcenter
{
    class Fnd0SEBlockImpl;
}
namespace Teamcenter
{
    class Fnd0SEBlockDelegate;
}
namespace Teamcenter
{
    class Fnd0SEBlockDispatch;
}
namespace Teamcenter
{
    class Fnd0SEBlockGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SECORE_API  Teamcenter::Fnd0SEBlock
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0SEBlock();

    /**
     * Destructor
     */
    virtual ~Fnd0SEBlock();

private:
    //  Getter method for the Implementation Object
    Fnd0SEBlockImpl*  getFnd0SEBlockImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0SEBlockImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0SEBlockImpl*  m_fnd0seblockImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0SEBlock - desc for Fnd0SEBlock parameter
     */
    Fnd0SEBlock( const Fnd0SEBlock& );
    Fnd0SEBlock& operator=( const Fnd0SEBlock& );

    friend class  Fnd0SEBlockDelegate;
    friend class  Fnd0SEBlockDispatch;
    friend class  Fnd0SEBlockGenImpl;
};

#include <secore/libsecore_undef.h>
#endif //   TEAMCENTER__FND0SEBLOCK__HXX
