//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0SEBlockRevision
    Filename:   Fnd0SEBlockRevision.hxx
    Module:     secore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0SEBLOCKREVISION__HXX
#define TEAMCENTER__FND0SEBLOCKREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <secore/libsecore_exports.h>

namespace Teamcenter
{
    class Fnd0SEBlockRevision;
}
namespace Teamcenter
{
    class Fnd0SEBlockRevisionImpl;
}
namespace Teamcenter
{
    class Fnd0SEBlockRevisionDelegate;
}
namespace Teamcenter
{
    class Fnd0SEBlockRevisionDispatch;
}
namespace Teamcenter
{
    class Fnd0SEBlockRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SECORE_API  Teamcenter::Fnd0SEBlockRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0SEBlockRevision();

    /**
     * Destructor
     */
    virtual ~Fnd0SEBlockRevision();

private:
    //  Getter method for the Implementation Object
    Fnd0SEBlockRevisionImpl*  getFnd0SEBlockRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0SEBlockRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0SEBlockRevisionImpl*  m_fnd0seblockrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0SEBlockRevision - desc for Fnd0SEBlockRevision parameter
     */
    Fnd0SEBlockRevision( const Fnd0SEBlockRevision& );
    Fnd0SEBlockRevision& operator=( const Fnd0SEBlockRevision& );

    friend class  Fnd0SEBlockRevisionDelegate;
    friend class  Fnd0SEBlockRevisionDispatch;
    friend class  Fnd0SEBlockRevisionGenImpl;
};

#include <secore/libsecore_undef.h>
#endif //   TEAMCENTER__FND0SEBLOCKREVISION__HXX
