//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0UIConfiguration
    Filename:   Fnd0UIConfiguration.hxx
    Module:     secore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0UICONFIGURATION__HXX
#define TEAMCENTER__FND0UICONFIGURATION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <secore/libsecore_exports.h>

namespace Teamcenter
{
    class Fnd0UIConfiguration;
}
namespace Teamcenter
{
    class Fnd0UIConfigurationImpl;
}
namespace Teamcenter
{
    class Fnd0UIConfigurationDelegate;
}
namespace Teamcenter
{
    class Fnd0UIConfigurationDispatch;
}
namespace Teamcenter
{
    class Fnd0UIConfigurationGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SECORE_API  Teamcenter::Fnd0UIConfiguration
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// To publish the column configuration
    /// @version Teamcenter 9
    /// @return - Returns status as an integer
    ///
    int  fnd0Publish(  );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0UIConfiguration();

    /**
     * Destructor
     */
    virtual ~Fnd0UIConfiguration();

private:
    //  Getter method for the Implementation Object
    Fnd0UIConfigurationImpl*  getFnd0UIConfigurationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0UIConfigurationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0UIConfigurationImpl*  m_fnd0uiconfigurationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0UIConfiguration - desc for Fnd0UIConfiguration parameter
     */
    Fnd0UIConfiguration( const Fnd0UIConfiguration& );
    Fnd0UIConfiguration& operator=( const Fnd0UIConfiguration& );

    friend class  Fnd0UIConfigurationDelegate;
    friend class  Fnd0UIConfigurationDispatch;
    friend class  Fnd0UIConfigurationGenImpl;
};

#include <secore/libsecore_undef.h>
#endif //   TEAMCENTER__FND0UICONFIGURATION__HXX
