//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ServiceEvent
    Filename:   ServiceEvent.hxx
    Module:     serviceeventmanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEEVENTMANAGEMENT__SERVICEEVENT__HXX
#define TEAMCENTER__SERVICEEVENTMANAGEMENT__SERVICEEVENT__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <serviceprocessing/ServicePerformed.hxx>

#include <serviceeventmanagement/libserviceeventmanagement_exports.h>

namespace Teamcenter
{
    namespace serviceeventmanagement
    {
        class ServiceEvent;
    }
}
namespace Teamcenter
{
    namespace serviceeventmanagement
    {
        class ServiceEventImpl;
    }
}
namespace Teamcenter
{
    namespace serviceeventmanagement
    {
        class ServiceEventDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceeventmanagement
    {
        class ServiceEventDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceeventmanagement
    {
        class ServiceEventGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEEVENTMANAGEMENT_API  Teamcenter::serviceeventmanagement::ServiceEvent
     : public  ::Teamcenter::serviceprocessing::ServicePerformed
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getJob_cards( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSigned_off_by( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getWork_location( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getZones( std::string &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ServiceEvent();

    /**
     * Destructor
     */
    virtual ~ServiceEvent();

private:
    //  Getter method for the Implementation Object
    ServiceEventImpl*  getServiceEventImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setServiceEventImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ServiceEventImpl*  m_serviceeventImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ServiceEvent - desc for ServiceEvent parameter
     */
    ServiceEvent( const ServiceEvent& );
    ServiceEvent& operator=( const ServiceEvent& );

    friend class  ServiceEventDelegate;
    friend class  ServiceEventDispatch;
    friend class  ServiceEventGenImpl;
};

#include <serviceeventmanagement/libserviceeventmanagement_undef.h>
#endif //   TEAMCENTER__SERVICEEVENTMANAGEMENT__SERVICEEVENT__HXX
