//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ServiceEventDelegate
    Filename:   ServiceEventDelegate.hxx
    Module:     serviceeventmanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEEVENTMANAGEMENT__SERVICEEVENTDELEGATE_HXX
#define TEAMCENTER__SERVICEEVENTMANAGEMENT__SERVICEEVENTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <serviceeventmanagement/ServiceEvent.hxx>

#include <serviceeventmanagement/libserviceeventmanagement_exports.h>

namespace Teamcenter
{
    namespace serviceeventmanagement
    {
        class ServiceEventDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceeventmanagement
    {
        class ServiceEventImpl;
    }
}
namespace Teamcenter
{
    namespace serviceeventmanagement
    {
        class ServiceEvent;
    }
}
namespace Teamcenter
{
    namespace serviceeventmanagement
    {
        class ServiceEventGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SERVICEEVENTMANAGEMENT_API Teamcenter_alias::serviceeventmanagement::ServiceEventDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ServiceEventDelegate instance
    static ServiceEventDelegate&  getInstance();

    //  Method to create the ServiceEventImpl pointer
    static ServiceEventImpl*  createImpl( ServiceEvent&  ifObj );

    //  Method to delete the ServiceEventImpl pointer
    static void deleteImpl( ServiceEventImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getJob_cardsBase(const ServiceEvent &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSigned_off_byBase(const ServiceEvent &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getWork_locationBase(const ServiceEvent &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getZonesBase(const ServiceEvent &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Approval operation
    /// @version Teamcenter 8.0.1
    /// @param strucRoot - Root of the Service Group or Service Event structure
    /// @return - success or failure
    ///
    int  approvalBase(const ServiceEvent &ifObj,  tag_t strucRoot );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const ServiceEvent &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// processes the part movements
    /// @version Teamcenter 8.0.1
    /// @param serviceEvents - service event vector
    /// @param partMovements - part movement vectors
    /// @return - returns success or failure
    ///
    int  processPartMovementsBase(const ServiceEvent &ifObj,  std::vector< tag_t > &serviceEvents, std::vector< tag_t > &partMovements );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const ServiceEvent &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static ServiceEventDelegate*  m_pInstance;

    ServiceEventDelegate();
    virtual ~ServiceEventDelegate();
    static void setInstance( ServiceEventDelegate*  instance );


private:
    friend class  ::Teamcenter::serviceeventmanagement::ServiceEventGenImpl;

};

#include <serviceeventmanagement/libserviceeventmanagement_undef.h>
#endif  //  TEAMCENTER__SERVICEEVENTMANAGEMENT__SERVICEEVENTDELEGATE_HXX
