//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ServiceGroup
    Filename:   ServiceGroup.hxx
    Module:     serviceeventmanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEEVENTMANAGEMENT__SERVICEGROUP__HXX
#define TEAMCENTER__SERVICEEVENTMANAGEMENT__SERVICEGROUP__HXX

#include <common/tc_deprecation_macros.h>
#include <transactionprocessing/Transaction.hxx>

#include <serviceeventmanagement/libserviceeventmanagement_exports.h>

namespace Teamcenter
{
    namespace serviceeventmanagement
    {
        class ServiceGroup;
    }
}
namespace Teamcenter
{
    namespace serviceeventmanagement
    {
        class ServiceGroupImpl;
    }
}
namespace Teamcenter
{
    namespace serviceeventmanagement
    {
        class ServiceGroupDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceeventmanagement
    {
        class ServiceGroupDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceeventmanagement
    {
        class ServiceGroupGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEEVENTMANAGEMENT_API  Teamcenter::serviceeventmanagement::ServiceGroup
     : public  ::Teamcenter::transactionprocessing::Transaction
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ServiceGroup();

    /**
     * Destructor
     */
    virtual ~ServiceGroup();

private:
    //  Getter method for the Implementation Object
    ServiceGroupImpl*  getServiceGroupImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setServiceGroupImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ServiceGroupImpl*  m_servicegroupImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ServiceGroup - desc for ServiceGroup parameter
     */
    ServiceGroup( const ServiceGroup& );
    ServiceGroup& operator=( const ServiceGroup& );

    friend class  ServiceGroupDelegate;
    friend class  ServiceGroupDispatch;
    friend class  ServiceGroupGenImpl;
};

#include <serviceeventmanagement/libserviceeventmanagement_undef.h>
#endif //   TEAMCENTER__SERVICEEVENTMANAGEMENT__SERVICEGROUP__HXX
