//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ServiceGroupDelegate
    Filename:   ServiceGroupDelegate.hxx
    Module:     serviceeventmanagement
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEEVENTMANAGEMENT__SERVICEGROUPDELEGATE_HXX
#define TEAMCENTER__SERVICEEVENTMANAGEMENT__SERVICEGROUPDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <serviceeventmanagement/ServiceGroup.hxx>

#include <serviceeventmanagement/libserviceeventmanagement_exports.h>

namespace Teamcenter
{
    namespace serviceeventmanagement
    {
        class ServiceGroupDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceeventmanagement
    {
        class ServiceGroupImpl;
    }
}
namespace Teamcenter
{
    namespace serviceeventmanagement
    {
        class ServiceGroup;
    }
}
namespace Teamcenter
{
    namespace serviceeventmanagement
    {
        class ServiceGroupGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SERVICEEVENTMANAGEMENT_API Teamcenter_alias::serviceeventmanagement::ServiceGroupDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ServiceGroupDelegate instance
    static ServiceGroupDelegate&  getInstance();

    //  Method to create the ServiceGroupImpl pointer
    static ServiceGroupImpl*  createImpl( ServiceGroup&  ifObj );

    //  Method to delete the ServiceGroupImpl pointer
    static void deleteImpl( ServiceGroupImpl*  impl );


    ///
    /// Approval operation
    /// @version Teamcenter 8.0.1
    /// @param strucRoot - Root of the Service Group or Service Event structure
    /// @return - success or failure
    ///
    int  approvalBase(const ServiceGroup &ifObj,  tag_t strucRoot );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const ServiceGroup &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// processes the part movements
    /// @version Teamcenter 8.0.1
    /// @param serviceEvents - service event vector
    /// @param partMovements - part movement vectors
    /// @return - returns success or failure
    ///
    int  processPartMovementsBase(const ServiceGroup &ifObj,  std::vector< tag_t > &serviceEvents, std::vector< tag_t > &partMovements );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const ServiceGroup &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static ServiceGroupDelegate*  m_pInstance;

    ServiceGroupDelegate();
    virtual ~ServiceGroupDelegate();
    static void setInstance( ServiceGroupDelegate*  instance );


private:
    friend class  ::Teamcenter::serviceeventmanagement::ServiceGroupGenImpl;

};

#include <serviceeventmanagement/libserviceeventmanagement_undef.h>
#endif  //  TEAMCENTER__SERVICEEVENTMANAGEMENT__SERVICEGROUPDELEGATE_HXX
