//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0BvrFrequency
    Filename:   SSP0BvrFrequency.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0BVRFREQUENCY__HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0BVRFREQUENCY__HXX

#include <common/tc_deprecation_macros.h>
#include <me/ImanItemBOPLine.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0BvrFrequency;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0BvrFrequencyImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0BvrFrequencyDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0BvrFrequencyDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0BvrFrequencyGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEPLANNING_API  Teamcenter::serviceplanning::SSP0BvrFrequency
     : public  ::Teamcenter::ImanItemBOPLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SSP0BvrFrequency();

    /**
     * Destructor
     */
    virtual ~SSP0BvrFrequency();

private:
    //  Getter method for the Implementation Object
    SSP0BvrFrequencyImpl*  getSSP0BvrFrequencyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSSP0BvrFrequencyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SSP0BvrFrequencyImpl*  m_ssp0bvrfrequencyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SSP0BvrFrequency - desc for SSP0BvrFrequency parameter
     */
    SSP0BvrFrequency( const SSP0BvrFrequency& );
    SSP0BvrFrequency& operator=( const SSP0BvrFrequency& );

    friend class  SSP0BvrFrequencyDelegate;
    friend class  SSP0BvrFrequencyDispatch;
    friend class  SSP0BvrFrequencyGenImpl;
};

#include <serviceplanning/libserviceplanning_undef.h>
#endif //   TEAMCENTER__SERVICEPLANNING__SSP0BVRFREQUENCY__HXX
