//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0BvrServiceContainer
    Filename:   SSP0BvrServiceContainer.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0BVRSERVICECONTAINER__HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0BVRSERVICECONTAINER__HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrProcess.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0BvrServiceContainer;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0BvrServiceContainerImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0BvrServiceContainerDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0BvrServiceContainerDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0BvrServiceContainerGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEPLANNING_API  Teamcenter::serviceplanning::SSP0BvrServiceContainer
     : public  ::Teamcenter::Mfg0BvrProcess
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SSP0BvrServiceContainer();

    /**
     * Destructor
     */
    virtual ~SSP0BvrServiceContainer();

private:
    //  Getter method for the Implementation Object
    SSP0BvrServiceContainerImpl*  getSSP0BvrServiceContainerImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSSP0BvrServiceContainerImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SSP0BvrServiceContainerImpl*  m_ssp0bvrservicecontainerImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SSP0BvrServiceContainer - desc for SSP0BvrServiceContainer parameter
     */
    SSP0BvrServiceContainer( const SSP0BvrServiceContainer& );
    SSP0BvrServiceContainer& operator=( const SSP0BvrServiceContainer& );

    friend class  SSP0BvrServiceContainerDelegate;
    friend class  SSP0BvrServiceContainerDispatch;
    friend class  SSP0BvrServiceContainerGenImpl;
};

#include <serviceplanning/libserviceplanning_undef.h>
#endif //   TEAMCENTER__SERVICEPLANNING__SSP0BVRSERVICECONTAINER__HXX
