//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0BvrServicePartition
    Filename:   SSP0BvrServicePartition.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0BVRSERVICEPARTITION__HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0BVRSERVICEPARTITION__HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrProcessPartition.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0BvrServicePartition;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0BvrServicePartitionImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0BvrServicePartitionDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0BvrServicePartitionDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0BvrServicePartitionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEPLANNING_API  Teamcenter::serviceplanning::SSP0BvrServicePartition
     : public  ::Teamcenter::Mfg0BvrProcessPartition
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SSP0BvrServicePartition();

    /**
     * Destructor
     */
    virtual ~SSP0BvrServicePartition();

private:
    //  Getter method for the Implementation Object
    SSP0BvrServicePartitionImpl*  getSSP0BvrServicePartitionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSSP0BvrServicePartitionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SSP0BvrServicePartitionImpl*  m_ssp0bvrservicepartitionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SSP0BvrServicePartition - desc for SSP0BvrServicePartition parameter
     */
    SSP0BvrServicePartition( const SSP0BvrServicePartition& );
    SSP0BvrServicePartition& operator=( const SSP0BvrServicePartition& );

    friend class  SSP0BvrServicePartitionDelegate;
    friend class  SSP0BvrServicePartitionDispatch;
    friend class  SSP0BvrServicePartitionGenImpl;
};

#include <serviceplanning/libserviceplanning_undef.h>
#endif //   TEAMCENTER__SERVICEPLANNING__SSP0BVRSERVICEPARTITION__HXX
