//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0BvrServicePlan
    Filename:   SSP0BvrServicePlan.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0BVRSERVICEPLAN__HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0BVRSERVICEPLAN__HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrEBopContext.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0BvrServicePlan;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0BvrServicePlanImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0BvrServicePlanDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0BvrServicePlanDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0BvrServicePlanGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEPLANNING_API  Teamcenter::serviceplanning::SSP0BvrServicePlan
     : public  ::Teamcenter::Mfg0BvrEBopContext
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SSP0BvrServicePlan();

    /**
     * Destructor
     */
    virtual ~SSP0BvrServicePlan();

private:
    //  Getter method for the Implementation Object
    SSP0BvrServicePlanImpl*  getSSP0BvrServicePlanImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSSP0BvrServicePlanImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SSP0BvrServicePlanImpl*  m_ssp0bvrserviceplanImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SSP0BvrServicePlan - desc for SSP0BvrServicePlan parameter
     */
    SSP0BvrServicePlan( const SSP0BvrServicePlan& );
    SSP0BvrServicePlan& operator=( const SSP0BvrServicePlan& );

    friend class  SSP0BvrServicePlanDelegate;
    friend class  SSP0BvrServicePlanDispatch;
    friend class  SSP0BvrServicePlanGenImpl;
};

#include <serviceplanning/libserviceplanning_undef.h>
#endif //   TEAMCENTER__SERVICEPLANNING__SSP0BVRSERVICEPLAN__HXX
