//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0BvrServiceRequirement
    Filename:   SSP0BvrServiceRequirement.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0BVRSERVICEREQUIREMENT__HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0BVRSERVICEREQUIREMENT__HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrProcess.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0BvrServiceRequirement;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0BvrServiceRequirementImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0BvrServiceRequirementDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0BvrServiceRequirementDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0BvrServiceRequirementGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEPLANNING_API  Teamcenter::serviceplanning::SSP0BvrServiceRequirement
     : public  ::Teamcenter::Mfg0BvrProcess
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSsp0HasPartApplicabilityRel( bool &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSsp0HasRequiresRel( bool &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSsp0HasSatisfiesRel( bool &value, bool &isNull ) const;

    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSsp0HasPartApplicabilityRel( bool value, bool isNull=false );

    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSsp0HasRequiresRel( bool value, bool isNull=false );

    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSsp0HasSatisfiesRel( bool value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SSP0BvrServiceRequirement();

    /**
     * Destructor
     */
    virtual ~SSP0BvrServiceRequirement();

private:
    //  Getter method for the Implementation Object
    SSP0BvrServiceRequirementImpl*  getSSP0BvrServiceRequirementImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSSP0BvrServiceRequirementImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SSP0BvrServiceRequirementImpl*  m_ssp0bvrservicerequirementImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SSP0BvrServiceRequirement - desc for SSP0BvrServiceRequirement parameter
     */
    SSP0BvrServiceRequirement( const SSP0BvrServiceRequirement& );
    SSP0BvrServiceRequirement& operator=( const SSP0BvrServiceRequirement& );

    friend class  SSP0BvrServiceRequirementDelegate;
    friend class  SSP0BvrServiceRequirementDispatch;
    friend class  SSP0BvrServiceRequirementGenImpl;
};

#include <serviceplanning/libserviceplanning_undef.h>
#endif //   TEAMCENTER__SERVICEPLANNING__SSP0BVRSERVICEREQUIREMENT__HXX
