//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0BvrServiceRequirementDelegate
    Filename:   SSP0BvrServiceRequirementDelegate.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0BVRSERVICEREQUIREMENTDELEGATE_HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0BVRSERVICEREQUIREMENTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <serviceplanning/SSP0BvrServiceRequirement.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0BvrServiceRequirementDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0BvrServiceRequirementImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0BvrServiceRequirement;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0BvrServiceRequirementGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SERVICEPLANNING_API Teamcenter_alias::serviceplanning::SSP0BvrServiceRequirementDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SSP0BvrServiceRequirementDelegate instance
    static SSP0BvrServiceRequirementDelegate&  getInstance();

    //  Method to create the SSP0BvrServiceRequirementImpl pointer
    static SSP0BvrServiceRequirementImpl*  createImpl( SSP0BvrServiceRequirement&  ifObj );

    //  Method to delete the SSP0BvrServiceRequirementImpl pointer
    static void deleteImpl( SSP0BvrServiceRequirementImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSsp0HasPartApplicabilityRelBase(const SSP0BvrServiceRequirement &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSsp0HasRequiresRelBase(const SSP0BvrServiceRequirement &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSsp0HasSatisfiesRelBase(const SSP0BvrServiceRequirement &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSsp0HasPartApplicabilityRelBase(SSP0BvrServiceRequirement &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSsp0HasRequiresRelBase(SSP0BvrServiceRequirement &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSsp0HasSatisfiesRelBase(SSP0BvrServiceRequirement &ifObj,  bool value, bool isNull );



protected:
    //  Pointer to the instance
    static SSP0BvrServiceRequirementDelegate*  m_pInstance;

    SSP0BvrServiceRequirementDelegate();
    virtual ~SSP0BvrServiceRequirementDelegate();
    static void setInstance( SSP0BvrServiceRequirementDelegate*  instance );


private:
    friend class  ::Teamcenter::serviceplanning::SSP0BvrServiceRequirementGenImpl;

};

#include <serviceplanning/libserviceplanning_undef.h>
#endif  //  TEAMCENTER__SERVICEPLANNING__SSP0BVRSERVICEREQUIREMENTDELEGATE_HXX
