//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0BvrSkill
    Filename:   SSP0BvrSkill.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0BVRSKILL__HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0BVRSKILL__HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrResource.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0BvrSkill;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0BvrSkillImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0BvrSkillDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0BvrSkillDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0BvrSkillGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEPLANNING_API  Teamcenter::serviceplanning::SSP0BvrSkill
     : public  ::Teamcenter::Mfg0BvrResource
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SSP0BvrSkill();

    /**
     * Destructor
     */
    virtual ~SSP0BvrSkill();

private:
    //  Getter method for the Implementation Object
    SSP0BvrSkillImpl*  getSSP0BvrSkillImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSSP0BvrSkillImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SSP0BvrSkillImpl*  m_ssp0bvrskillImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SSP0BvrSkill - desc for SSP0BvrSkill parameter
     */
    SSP0BvrSkill( const SSP0BvrSkill& );
    SSP0BvrSkill& operator=( const SSP0BvrSkill& );

    friend class  SSP0BvrSkillDelegate;
    friend class  SSP0BvrSkillDispatch;
    friend class  SSP0BvrSkillGenImpl;
};

#include <serviceplanning/libserviceplanning_undef.h>
#endif //   TEAMCENTER__SERVICEPLANNING__SSP0BVRSKILL__HXX
