//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0BvrWorkCard
    Filename:   SSP0BvrWorkCard.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0BVRWORKCARD__HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0BVRWORKCARD__HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/Mfg0BvrOperation.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0BvrWorkCard;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0BvrWorkCardImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0BvrWorkCardDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0BvrWorkCardDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0BvrWorkCardGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEPLANNING_API  Teamcenter::serviceplanning::SSP0BvrWorkCard
     : public  ::Teamcenter::Mfg0BvrOperation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SSP0BvrWorkCard();

    /**
     * Destructor
     */
    virtual ~SSP0BvrWorkCard();

private:
    //  Getter method for the Implementation Object
    SSP0BvrWorkCardImpl*  getSSP0BvrWorkCardImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSSP0BvrWorkCardImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SSP0BvrWorkCardImpl*  m_ssp0bvrworkcardImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SSP0BvrWorkCard - desc for SSP0BvrWorkCard parameter
     */
    SSP0BvrWorkCard( const SSP0BvrWorkCard& );
    SSP0BvrWorkCard& operator=( const SSP0BvrWorkCard& );

    friend class  SSP0BvrWorkCardDelegate;
    friend class  SSP0BvrWorkCardDispatch;
    friend class  SSP0BvrWorkCardGenImpl;
};

#include <serviceplanning/libserviceplanning_undef.h>
#endif //   TEAMCENTER__SERVICEPLANNING__SSP0BVRWORKCARD__HXX
