//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0CollectsData
    Filename:   SSP0CollectsData.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0COLLECTSDATA__HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0COLLECTSDATA__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0CollectsData;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0CollectsDataImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0CollectsDataDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0CollectsDataDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0CollectsDataGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEPLANNING_API  Teamcenter::serviceplanning::SSP0CollectsData
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SSP0CollectsData();

    /**
     * Destructor
     */
    virtual ~SSP0CollectsData();

private:
    //  Getter method for the Implementation Object
    SSP0CollectsDataImpl*  getSSP0CollectsDataImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSSP0CollectsDataImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SSP0CollectsDataImpl*  m_ssp0collectsdataImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SSP0CollectsData - desc for SSP0CollectsData parameter
     */
    SSP0CollectsData( const SSP0CollectsData& );
    SSP0CollectsData& operator=( const SSP0CollectsData& );

    friend class  SSP0CollectsDataDelegate;
    friend class  SSP0CollectsDataDispatch;
    friend class  SSP0CollectsDataGenImpl;
};

#include <serviceplanning/libserviceplanning_undef.h>
#endif //   TEAMCENTER__SERVICEPLANNING__SSP0COLLECTSDATA__HXX
