//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0CollectsDataDelegate
    Filename:   SSP0CollectsDataDelegate.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0COLLECTSDATADELEGATE_HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0COLLECTSDATADELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <serviceplanning/SSP0CollectsData.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0CollectsDataDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0CollectsDataImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0CollectsData;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0CollectsDataGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SERVICEPLANNING_API Teamcenter_alias::serviceplanning::SSP0CollectsDataDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SSP0CollectsDataDelegate instance
    static SSP0CollectsDataDelegate&  getInstance();

    //  Method to create the SSP0CollectsDataImpl pointer
    static SSP0CollectsDataImpl*  createImpl( SSP0CollectsData&  ifObj );

    //  Method to delete the SSP0CollectsDataImpl pointer
    static void deleteImpl( SSP0CollectsDataImpl*  impl );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const SSP0CollectsData &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static SSP0CollectsDataDelegate*  m_pInstance;

    SSP0CollectsDataDelegate();
    virtual ~SSP0CollectsDataDelegate();
    static void setInstance( SSP0CollectsDataDelegate*  instance );


private:
    friend class  ::Teamcenter::serviceplanning::SSP0CollectsDataGenImpl;

};

#include <serviceplanning/libserviceplanning_undef.h>
#endif  //  TEAMCENTER__SERVICEPLANNING__SSP0COLLECTSDATADELEGATE_HXX
