//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0Frequency
    Filename:   SSP0Frequency.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0FREQUENCY__HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0FREQUENCY__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0Frequency;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0FrequencyImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0FrequencyDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0FrequencyDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0FrequencyGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEPLANNING_API  Teamcenter::serviceplanning::SSP0Frequency
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SSP0Frequency();

    /**
     * Destructor
     */
    virtual ~SSP0Frequency();

private:
    //  Getter method for the Implementation Object
    SSP0FrequencyImpl*  getSSP0FrequencyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSSP0FrequencyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SSP0FrequencyImpl*  m_ssp0frequencyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SSP0Frequency - desc for SSP0Frequency parameter
     */
    SSP0Frequency( const SSP0Frequency& );
    SSP0Frequency& operator=( const SSP0Frequency& );

    friend class  SSP0FrequencyDelegate;
    friend class  SSP0FrequencyDispatch;
    friend class  SSP0FrequencyGenImpl;
};

#include <serviceplanning/libserviceplanning_undef.h>
#endif //   TEAMCENTER__SERVICEPLANNING__SSP0FREQUENCY__HXX
