//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0FrequencyDelegate
    Filename:   SSP0FrequencyDelegate.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0FREQUENCYDELEGATE_HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0FREQUENCYDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <serviceplanning/SSP0Frequency.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0FrequencyDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0FrequencyImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0Frequency;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0FrequencyGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SERVICEPLANNING_API Teamcenter_alias::serviceplanning::SSP0FrequencyDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SSP0FrequencyDelegate instance
    static SSP0FrequencyDelegate&  getInstance();

    //  Method to create the SSP0FrequencyImpl pointer
    static SSP0FrequencyImpl*  createImpl( SSP0Frequency&  ifObj );

    //  Method to delete the SSP0FrequencyImpl pointer
    static void deleteImpl( SSP0FrequencyImpl*  impl );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const SSP0Frequency &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static SSP0FrequencyDelegate*  m_pInstance;

    SSP0FrequencyDelegate();
    virtual ~SSP0FrequencyDelegate();
    static void setInstance( SSP0FrequencyDelegate*  instance );


private:
    friend class  ::Teamcenter::serviceplanning::SSP0FrequencyGenImpl;

};

#include <serviceplanning/libserviceplanning_undef.h>
#endif  //  TEAMCENTER__SERVICEPLANNING__SSP0FREQUENCYDELEGATE_HXX
