//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0FrequencyRevision
    Filename:   SSP0FrequencyRevision.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0FREQUENCYREVISION__HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0FREQUENCYREVISION__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0FrequencyRevision;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0FrequencyRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0FrequencyRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0FrequencyRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0FrequencyRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEPLANNING_API  Teamcenter::serviceplanning::SSP0FrequencyRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSsp0FreqDBExpression( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSsp0FrequencyExpression( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSsp0FreqDBExpression( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSsp0FrequencyExpression( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SSP0FrequencyRevision();

    /**
     * Destructor
     */
    virtual ~SSP0FrequencyRevision();

private:
    //  Getter method for the Implementation Object
    SSP0FrequencyRevisionImpl*  getSSP0FrequencyRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSSP0FrequencyRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SSP0FrequencyRevisionImpl*  m_ssp0frequencyrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SSP0FrequencyRevision - desc for SSP0FrequencyRevision parameter
     */
    SSP0FrequencyRevision( const SSP0FrequencyRevision& );
    SSP0FrequencyRevision& operator=( const SSP0FrequencyRevision& );

    friend class  SSP0FrequencyRevisionDelegate;
    friend class  SSP0FrequencyRevisionDispatch;
    friend class  SSP0FrequencyRevisionGenImpl;
};

#include <serviceplanning/libserviceplanning_undef.h>
#endif //   TEAMCENTER__SERVICEPLANNING__SSP0FREQUENCYREVISION__HXX
