//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0FrequencyRevisionDelegate
    Filename:   SSP0FrequencyRevisionDelegate.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0FREQUENCYREVISIONDELEGATE_HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0FREQUENCYREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <serviceplanning/SSP0FrequencyRevision.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0FrequencyRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0FrequencyRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0FrequencyRevision;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0FrequencyRevisionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SERVICEPLANNING_API Teamcenter_alias::serviceplanning::SSP0FrequencyRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SSP0FrequencyRevisionDelegate instance
    static SSP0FrequencyRevisionDelegate&  getInstance();

    //  Method to create the SSP0FrequencyRevisionImpl pointer
    static SSP0FrequencyRevisionImpl*  createImpl( SSP0FrequencyRevision&  ifObj );

    //  Method to delete the SSP0FrequencyRevisionImpl pointer
    static void deleteImpl( SSP0FrequencyRevisionImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSsp0FreqDBExpressionBase(const SSP0FrequencyRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSsp0FrequencyExpressionBase(const SSP0FrequencyRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSsp0FreqDBExpressionBase(SSP0FrequencyRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSsp0FrequencyExpressionBase(SSP0FrequencyRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const SSP0FrequencyRevision &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static SSP0FrequencyRevisionDelegate*  m_pInstance;

    SSP0FrequencyRevisionDelegate();
    virtual ~SSP0FrequencyRevisionDelegate();
    static void setInstance( SSP0FrequencyRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::serviceplanning::SSP0FrequencyRevisionGenImpl;

};

#include <serviceplanning/libserviceplanning_undef.h>
#endif  //  TEAMCENTER__SERVICEPLANNING__SSP0FREQUENCYREVISIONDELEGATE_HXX
