//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0HasWarning
    Filename:   SSP0HasWarning.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0HASWARNING__HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0HASWARNING__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0HasWarning;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0HasWarningImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0HasWarningDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0HasWarningDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0HasWarningGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEPLANNING_API  Teamcenter::serviceplanning::SSP0HasWarning
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SSP0HasWarning();

    /**
     * Destructor
     */
    virtual ~SSP0HasWarning();

private:
    //  Getter method for the Implementation Object
    SSP0HasWarningImpl*  getSSP0HasWarningImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSSP0HasWarningImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SSP0HasWarningImpl*  m_ssp0haswarningImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SSP0HasWarning - desc for SSP0HasWarning parameter
     */
    SSP0HasWarning( const SSP0HasWarning& );
    SSP0HasWarning& operator=( const SSP0HasWarning& );

    friend class  SSP0HasWarningDelegate;
    friend class  SSP0HasWarningDispatch;
    friend class  SSP0HasWarningGenImpl;
};

#include <serviceplanning/libserviceplanning_undef.h>
#endif //   TEAMCENTER__SERVICEPLANNING__SSP0HASWARNING__HXX
