//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0PartApplicability
    Filename:   SSP0PartApplicability.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0PARTAPPLICABILITY__HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0PARTAPPLICABILITY__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0PartApplicability;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0PartApplicabilityImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0PartApplicabilityDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0PartApplicabilityDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0PartApplicabilityGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEPLANNING_API  Teamcenter::serviceplanning::SSP0PartApplicability
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SSP0PartApplicability();

    /**
     * Destructor
     */
    virtual ~SSP0PartApplicability();

private:
    //  Getter method for the Implementation Object
    SSP0PartApplicabilityImpl*  getSSP0PartApplicabilityImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSSP0PartApplicabilityImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SSP0PartApplicabilityImpl*  m_ssp0partapplicabilityImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SSP0PartApplicability - desc for SSP0PartApplicability parameter
     */
    SSP0PartApplicability( const SSP0PartApplicability& );
    SSP0PartApplicability& operator=( const SSP0PartApplicability& );

    friend class  SSP0PartApplicabilityDelegate;
    friend class  SSP0PartApplicabilityDispatch;
    friend class  SSP0PartApplicabilityGenImpl;
};

#include <serviceplanning/libserviceplanning_undef.h>
#endif //   TEAMCENTER__SERVICEPLANNING__SSP0PARTAPPLICABILITY__HXX
