//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0PartApplicabilityData
    Filename:   SSP0PartApplicabilityData.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0PARTAPPLICABILITYDATA__HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0PARTAPPLICABILITYDATA__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0PartApplicabilityData;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0PartApplicabilityDataImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0PartApplicabilityDataDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0PartApplicabilityDataDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0PartApplicabilityDataGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEPLANNING_API  Teamcenter::serviceplanning::SSP0PartApplicabilityData
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SSP0PartApplicabilityData();

    /**
     * Destructor
     */
    virtual ~SSP0PartApplicabilityData();

private:
    //  Getter method for the Implementation Object
    SSP0PartApplicabilityDataImpl*  getSSP0PartApplicabilityDataImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSSP0PartApplicabilityDataImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SSP0PartApplicabilityDataImpl*  m_ssp0partapplicabilitydataImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SSP0PartApplicabilityData - desc for SSP0PartApplicabilityData parameter
     */
    SSP0PartApplicabilityData( const SSP0PartApplicabilityData& );
    SSP0PartApplicabilityData& operator=( const SSP0PartApplicabilityData& );

    friend class  SSP0PartApplicabilityDataDelegate;
    friend class  SSP0PartApplicabilityDataDispatch;
    friend class  SSP0PartApplicabilityDataGenImpl;
};

#include <serviceplanning/libserviceplanning_undef.h>
#endif //   TEAMCENTER__SERVICEPLANNING__SSP0PARTAPPLICABILITYDATA__HXX
