//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0PartApplicabilityDelegate
    Filename:   SSP0PartApplicabilityDelegate.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0PARTAPPLICABILITYDELEGATE_HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0PARTAPPLICABILITYDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <serviceplanning/SSP0PartApplicability.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0PartApplicabilityDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0PartApplicabilityImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0PartApplicability;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0PartApplicabilityGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SERVICEPLANNING_API Teamcenter_alias::serviceplanning::SSP0PartApplicabilityDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SSP0PartApplicabilityDelegate instance
    static SSP0PartApplicabilityDelegate&  getInstance();

    //  Method to create the SSP0PartApplicabilityImpl pointer
    static SSP0PartApplicabilityImpl*  createImpl( SSP0PartApplicability&  ifObj );

    //  Method to delete the SSP0PartApplicabilityImpl pointer
    static void deleteImpl( SSP0PartApplicabilityImpl*  impl );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const SSP0PartApplicability &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static SSP0PartApplicabilityDelegate*  m_pInstance;

    SSP0PartApplicabilityDelegate();
    virtual ~SSP0PartApplicabilityDelegate();
    static void setInstance( SSP0PartApplicabilityDelegate*  instance );


private:
    friend class  ::Teamcenter::serviceplanning::SSP0PartApplicabilityGenImpl;

};

#include <serviceplanning/libserviceplanning_undef.h>
#endif  //  TEAMCENTER__SERVICEPLANNING__SSP0PARTAPPLICABILITYDELEGATE_HXX
