//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0PlanForNeutralProduct
    Filename:   SSP0PlanForNeutralProduct.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0PLANFORNEUTRALPRODUCT__HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0PLANFORNEUTRALPRODUCT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0PlanForNeutralProduct;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0PlanForNeutralProductImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0PlanForNeutralProductDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0PlanForNeutralProductDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0PlanForNeutralProductGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEPLANNING_API  Teamcenter::serviceplanning::SSP0PlanForNeutralProduct
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SSP0PlanForNeutralProduct();

    /**
     * Destructor
     */
    virtual ~SSP0PlanForNeutralProduct();

private:
    //  Getter method for the Implementation Object
    SSP0PlanForNeutralProductImpl*  getSSP0PlanForNeutralProductImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSSP0PlanForNeutralProductImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SSP0PlanForNeutralProductImpl*  m_ssp0planforneutralproductImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SSP0PlanForNeutralProduct - desc for SSP0PlanForNeutralProduct parameter
     */
    SSP0PlanForNeutralProduct( const SSP0PlanForNeutralProduct& );
    SSP0PlanForNeutralProduct& operator=( const SSP0PlanForNeutralProduct& );

    friend class  SSP0PlanForNeutralProductDelegate;
    friend class  SSP0PlanForNeutralProductDispatch;
    friend class  SSP0PlanForNeutralProductGenImpl;
};

#include <serviceplanning/libserviceplanning_undef.h>
#endif //   TEAMCENTER__SERVICEPLANNING__SSP0PLANFORNEUTRALPRODUCT__HXX
