//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0Requires
    Filename:   SSP0Requires.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0REQUIRES__HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0REQUIRES__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0Requires;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0RequiresImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0RequiresDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0RequiresDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0RequiresGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEPLANNING_API  Teamcenter::serviceplanning::SSP0Requires
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SSP0Requires();

    /**
     * Destructor
     */
    virtual ~SSP0Requires();

private:
    //  Getter method for the Implementation Object
    SSP0RequiresImpl*  getSSP0RequiresImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSSP0RequiresImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SSP0RequiresImpl*  m_ssp0requiresImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SSP0Requires - desc for SSP0Requires parameter
     */
    SSP0Requires( const SSP0Requires& );
    SSP0Requires& operator=( const SSP0Requires& );

    friend class  SSP0RequiresDelegate;
    friend class  SSP0RequiresDispatch;
    friend class  SSP0RequiresGenImpl;
};

#include <serviceplanning/libserviceplanning_undef.h>
#endif //   TEAMCENTER__SERVICEPLANNING__SSP0REQUIRES__HXX
