//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0Resolves
    Filename:   SSP0Resolves.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0RESOLVES__HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0RESOLVES__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0Resolves;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ResolvesImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ResolvesDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ResolvesDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ResolvesGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEPLANNING_API  Teamcenter::serviceplanning::SSP0Resolves
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SSP0Resolves();

    /**
     * Destructor
     */
    virtual ~SSP0Resolves();

private:
    //  Getter method for the Implementation Object
    SSP0ResolvesImpl*  getSSP0ResolvesImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSSP0ResolvesImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SSP0ResolvesImpl*  m_ssp0resolvesImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SSP0Resolves - desc for SSP0Resolves parameter
     */
    SSP0Resolves( const SSP0Resolves& );
    SSP0Resolves& operator=( const SSP0Resolves& );

    friend class  SSP0ResolvesDelegate;
    friend class  SSP0ResolvesDispatch;
    friend class  SSP0ResolvesGenImpl;
};

#include <serviceplanning/libserviceplanning_undef.h>
#endif //   TEAMCENTER__SERVICEPLANNING__SSP0RESOLVES__HXX
