//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0ResolvesDelegate
    Filename:   SSP0ResolvesDelegate.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0RESOLVESDELEGATE_HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0RESOLVESDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <serviceplanning/SSP0Resolves.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ResolvesDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ResolvesImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0Resolves;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ResolvesGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SERVICEPLANNING_API Teamcenter_alias::serviceplanning::SSP0ResolvesDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SSP0ResolvesDelegate instance
    static SSP0ResolvesDelegate&  getInstance();

    //  Method to create the SSP0ResolvesImpl pointer
    static SSP0ResolvesImpl*  createImpl( SSP0Resolves&  ifObj );

    //  Method to delete the SSP0ResolvesImpl pointer
    static void deleteImpl( SSP0ResolvesImpl*  impl );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const SSP0Resolves &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static SSP0ResolvesDelegate*  m_pInstance;

    SSP0ResolvesDelegate();
    virtual ~SSP0ResolvesDelegate();
    static void setInstance( SSP0ResolvesDelegate*  instance );


private:
    friend class  ::Teamcenter::serviceplanning::SSP0ResolvesGenImpl;

};

#include <serviceplanning/libserviceplanning_undef.h>
#endif  //  TEAMCENTER__SERVICEPLANNING__SSP0RESOLVESDELEGATE_HXX
