//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0Satisfies
    Filename:   SSP0Satisfies.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0SATISFIES__HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0SATISFIES__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0Satisfies;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0SatisfiesImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0SatisfiesDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0SatisfiesDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0SatisfiesGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEPLANNING_API  Teamcenter::serviceplanning::SSP0Satisfies
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SSP0Satisfies();

    /**
     * Destructor
     */
    virtual ~SSP0Satisfies();

private:
    //  Getter method for the Implementation Object
    SSP0SatisfiesImpl*  getSSP0SatisfiesImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSSP0SatisfiesImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SSP0SatisfiesImpl*  m_ssp0satisfiesImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SSP0Satisfies - desc for SSP0Satisfies parameter
     */
    SSP0Satisfies( const SSP0Satisfies& );
    SSP0Satisfies& operator=( const SSP0Satisfies& );

    friend class  SSP0SatisfiesDelegate;
    friend class  SSP0SatisfiesDispatch;
    friend class  SSP0SatisfiesGenImpl;
};

#include <serviceplanning/libserviceplanning_undef.h>
#endif //   TEAMCENTER__SERVICEPLANNING__SSP0SATISFIES__HXX
