//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0ServicePartition
    Filename:   SSP0ServicePartition.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0SERVICEPARTITION__HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0SERVICEPARTITION__HXX

#include <common/tc_deprecation_macros.h>
#include <mfgbvr/MEProcessPartition.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ServicePartition;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ServicePartitionImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ServicePartitionDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ServicePartitionDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ServicePartitionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEPLANNING_API  Teamcenter::serviceplanning::SSP0ServicePartition
     : public  ::Teamcenter::MEProcessPartition
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SSP0ServicePartition();

    /**
     * Destructor
     */
    virtual ~SSP0ServicePartition();

private:
    //  Getter method for the Implementation Object
    SSP0ServicePartitionImpl*  getSSP0ServicePartitionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSSP0ServicePartitionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SSP0ServicePartitionImpl*  m_ssp0servicepartitionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SSP0ServicePartition - desc for SSP0ServicePartition parameter
     */
    SSP0ServicePartition( const SSP0ServicePartition& );
    SSP0ServicePartition& operator=( const SSP0ServicePartition& );

    friend class  SSP0ServicePartitionDelegate;
    friend class  SSP0ServicePartitionDispatch;
    friend class  SSP0ServicePartitionGenImpl;
};

#include <serviceplanning/libserviceplanning_undef.h>
#endif //   TEAMCENTER__SERVICEPLANNING__SSP0SERVICEPARTITION__HXX
