//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0ServicePartitionDelegate
    Filename:   SSP0ServicePartitionDelegate.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0SERVICEPARTITIONDELEGATE_HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0SERVICEPARTITIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <serviceplanning/SSP0ServicePartition.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ServicePartitionDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ServicePartitionImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ServicePartition;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ServicePartitionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SERVICEPLANNING_API Teamcenter_alias::serviceplanning::SSP0ServicePartitionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SSP0ServicePartitionDelegate instance
    static SSP0ServicePartitionDelegate&  getInstance();

    //  Method to create the SSP0ServicePartitionImpl pointer
    static SSP0ServicePartitionImpl*  createImpl( SSP0ServicePartition&  ifObj );

    //  Method to delete the SSP0ServicePartitionImpl pointer
    static void deleteImpl( SSP0ServicePartitionImpl*  impl );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const SSP0ServicePartition &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static SSP0ServicePartitionDelegate*  m_pInstance;

    SSP0ServicePartitionDelegate();
    virtual ~SSP0ServicePartitionDelegate();
    static void setInstance( SSP0ServicePartitionDelegate*  instance );


private:
    friend class  ::Teamcenter::serviceplanning::SSP0ServicePartitionGenImpl;

};

#include <serviceplanning/libserviceplanning_undef.h>
#endif  //  TEAMCENTER__SERVICEPLANNING__SSP0SERVICEPARTITIONDELEGATE_HXX
