//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0ServicePlan
    Filename:   SSP0ServicePlan.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0SERVICEPLAN__HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0SERVICEPLAN__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ServicePlan;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ServicePlanImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ServicePlanDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ServicePlanDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ServicePlanGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEPLANNING_API  Teamcenter::serviceplanning::SSP0ServicePlan
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SSP0ServicePlan();

    /**
     * Destructor
     */
    virtual ~SSP0ServicePlan();

private:
    //  Getter method for the Implementation Object
    SSP0ServicePlanImpl*  getSSP0ServicePlanImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSSP0ServicePlanImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SSP0ServicePlanImpl*  m_ssp0serviceplanImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SSP0ServicePlan - desc for SSP0ServicePlan parameter
     */
    SSP0ServicePlan( const SSP0ServicePlan& );
    SSP0ServicePlan& operator=( const SSP0ServicePlan& );

    friend class  SSP0ServicePlanDelegate;
    friend class  SSP0ServicePlanDispatch;
    friend class  SSP0ServicePlanGenImpl;
};

#include <serviceplanning/libserviceplanning_undef.h>
#endif //   TEAMCENTER__SERVICEPLANNING__SSP0SERVICEPLAN__HXX
