//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0ServicePlanDelegate
    Filename:   SSP0ServicePlanDelegate.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0SERVICEPLANDELEGATE_HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0SERVICEPLANDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <serviceplanning/SSP0ServicePlan.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ServicePlanDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ServicePlanImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ServicePlan;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ServicePlanGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SERVICEPLANNING_API Teamcenter_alias::serviceplanning::SSP0ServicePlanDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SSP0ServicePlanDelegate instance
    static SSP0ServicePlanDelegate&  getInstance();

    //  Method to create the SSP0ServicePlanImpl pointer
    static SSP0ServicePlanImpl*  createImpl( SSP0ServicePlan&  ifObj );

    //  Method to delete the SSP0ServicePlanImpl pointer
    static void deleteImpl( SSP0ServicePlanImpl*  impl );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const SSP0ServicePlan &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static SSP0ServicePlanDelegate*  m_pInstance;

    SSP0ServicePlanDelegate();
    virtual ~SSP0ServicePlanDelegate();
    static void setInstance( SSP0ServicePlanDelegate*  instance );


private:
    friend class  ::Teamcenter::serviceplanning::SSP0ServicePlanGenImpl;

};

#include <serviceplanning/libserviceplanning_undef.h>
#endif  //  TEAMCENTER__SERVICEPLANNING__SSP0SERVICEPLANDELEGATE_HXX
