//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0ServicePlanRevision
    Filename:   SSP0ServicePlanRevision.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0SERVICEPLANREVISION__HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0SERVICEPLANREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ServicePlanRevision;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ServicePlanRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ServicePlanRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ServicePlanRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ServicePlanRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEPLANNING_API  Teamcenter::serviceplanning::SSP0ServicePlanRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SSP0ServicePlanRevision();

    /**
     * Destructor
     */
    virtual ~SSP0ServicePlanRevision();

private:
    //  Getter method for the Implementation Object
    SSP0ServicePlanRevisionImpl*  getSSP0ServicePlanRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSSP0ServicePlanRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SSP0ServicePlanRevisionImpl*  m_ssp0serviceplanrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SSP0ServicePlanRevision - desc for SSP0ServicePlanRevision parameter
     */
    SSP0ServicePlanRevision( const SSP0ServicePlanRevision& );
    SSP0ServicePlanRevision& operator=( const SSP0ServicePlanRevision& );

    friend class  SSP0ServicePlanRevisionDelegate;
    friend class  SSP0ServicePlanRevisionDispatch;
    friend class  SSP0ServicePlanRevisionGenImpl;
};

#include <serviceplanning/libserviceplanning_undef.h>
#endif //   TEAMCENTER__SERVICEPLANNING__SSP0SERVICEPLANREVISION__HXX
