//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0ServiceReq
    Filename:   SSP0ServiceReq.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0SERVICEREQ__HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0SERVICEREQ__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <me/MEProcess.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ServiceReq;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ServiceReqImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ServiceReqDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ServiceReqDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ServiceReqGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEPLANNING_API  Teamcenter::serviceplanning::SSP0ServiceReq
     : public  ::Teamcenter::MEProcess
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSsp0IsUpgradeRequirement( bool &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getSsp0RequiredBy( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getSsp0SatisfiedBy( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 8.3
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setSsp0RequiredBy( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );

    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 8.3
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setSsp0SatisfiedBy( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SSP0ServiceReq();

    /**
     * Destructor
     */
    virtual ~SSP0ServiceReq();

private:
    //  Getter method for the Implementation Object
    SSP0ServiceReqImpl*  getSSP0ServiceReqImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSSP0ServiceReqImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SSP0ServiceReqImpl*  m_ssp0servicereqImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SSP0ServiceReq - desc for SSP0ServiceReq parameter
     */
    SSP0ServiceReq( const SSP0ServiceReq& );
    SSP0ServiceReq& operator=( const SSP0ServiceReq& );

    friend class  SSP0ServiceReqDelegate;
    friend class  SSP0ServiceReqDispatch;
    friend class  SSP0ServiceReqGenImpl;
};

#include <serviceplanning/libserviceplanning_undef.h>
#endif //   TEAMCENTER__SERVICEPLANNING__SSP0SERVICEREQ__HXX
