//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0ServiceReqDelegate
    Filename:   SSP0ServiceReqDelegate.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0SERVICEREQDELEGATE_HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0SERVICEREQDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <serviceplanning/SSP0ServiceReq.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ServiceReqDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ServiceReqImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ServiceReq;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ServiceReqGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SERVICEPLANNING_API Teamcenter_alias::serviceplanning::SSP0ServiceReqDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SSP0ServiceReqDelegate instance
    static SSP0ServiceReqDelegate&  getInstance();

    //  Method to create the SSP0ServiceReqImpl pointer
    static SSP0ServiceReqImpl*  createImpl( SSP0ServiceReq&  ifObj );

    //  Method to delete the SSP0ServiceReqImpl pointer
    static void deleteImpl( SSP0ServiceReqImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSsp0IsUpgradeRequirementBase(const SSP0ServiceReq &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getSsp0RequiredByBase(const SSP0ServiceReq &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getSsp0SatisfiedByBase(const SSP0ServiceReq &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 8.3
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setSsp0RequiredByBase(SSP0ServiceReq &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 8.3
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setSsp0SatisfiedByBase(SSP0ServiceReq &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const SSP0ServiceReq &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static SSP0ServiceReqDelegate*  m_pInstance;

    SSP0ServiceReqDelegate();
    virtual ~SSP0ServiceReqDelegate();
    static void setInstance( SSP0ServiceReqDelegate*  instance );


private:
    friend class  ::Teamcenter::serviceplanning::SSP0ServiceReqGenImpl;

};

#include <serviceplanning/libserviceplanning_undef.h>
#endif  //  TEAMCENTER__SERVICEPLANNING__SSP0SERVICEREQDELEGATE_HXX
