//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0ServiceReqRevision
    Filename:   SSP0ServiceReqRevision.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0SERVICEREQREVISION__HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0SERVICEREQREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <me/MEProcessRevision.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ServiceReqRevision;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ServiceReqRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ServiceReqRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ServiceReqRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0ServiceReqRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEPLANNING_API  Teamcenter::serviceplanning::SSP0ServiceReqRevision
     : public  ::Teamcenter::MEProcessRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SSP0ServiceReqRevision();

    /**
     * Destructor
     */
    virtual ~SSP0ServiceReqRevision();

private:
    //  Getter method for the Implementation Object
    SSP0ServiceReqRevisionImpl*  getSSP0ServiceReqRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSSP0ServiceReqRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SSP0ServiceReqRevisionImpl*  m_ssp0servicereqrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SSP0ServiceReqRevision - desc for SSP0ServiceReqRevision parameter
     */
    SSP0ServiceReqRevision( const SSP0ServiceReqRevision& );
    SSP0ServiceReqRevision& operator=( const SSP0ServiceReqRevision& );

    friend class  SSP0ServiceReqRevisionDelegate;
    friend class  SSP0ServiceReqRevisionDispatch;
    friend class  SSP0ServiceReqRevisionGenImpl;
};

#include <serviceplanning/libserviceplanning_undef.h>
#endif //   TEAMCENTER__SERVICEPLANNING__SSP0SERVICEREQREVISION__HXX
