//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0Skill
    Filename:   SSP0Skill.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0SKILL__HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0SKILL__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0Skill;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0SkillImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0SkillDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0SkillDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0SkillGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEPLANNING_API  Teamcenter::serviceplanning::SSP0Skill
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SSP0Skill();

    /**
     * Destructor
     */
    virtual ~SSP0Skill();

private:
    //  Getter method for the Implementation Object
    SSP0SkillImpl*  getSSP0SkillImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSSP0SkillImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SSP0SkillImpl*  m_ssp0skillImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SSP0Skill - desc for SSP0Skill parameter
     */
    SSP0Skill( const SSP0Skill& );
    SSP0Skill& operator=( const SSP0Skill& );

    friend class  SSP0SkillDelegate;
    friend class  SSP0SkillDispatch;
    friend class  SSP0SkillGenImpl;
};

#include <serviceplanning/libserviceplanning_undef.h>
#endif //   TEAMCENTER__SERVICEPLANNING__SSP0SKILL__HXX
