//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0SkillDelegate
    Filename:   SSP0SkillDelegate.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0SKILLDELEGATE_HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0SKILLDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <serviceplanning/SSP0Skill.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0SkillDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0SkillImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0Skill;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0SkillGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SERVICEPLANNING_API Teamcenter_alias::serviceplanning::SSP0SkillDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SSP0SkillDelegate instance
    static SSP0SkillDelegate&  getInstance();

    //  Method to create the SSP0SkillImpl pointer
    static SSP0SkillImpl*  createImpl( SSP0Skill&  ifObj );

    //  Method to delete the SSP0SkillImpl pointer
    static void deleteImpl( SSP0SkillImpl*  impl );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const SSP0Skill &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static SSP0SkillDelegate*  m_pInstance;

    SSP0SkillDelegate();
    virtual ~SSP0SkillDelegate();
    static void setInstance( SSP0SkillDelegate*  instance );


private:
    friend class  ::Teamcenter::serviceplanning::SSP0SkillGenImpl;

};

#include <serviceplanning/libserviceplanning_undef.h>
#endif  //  TEAMCENTER__SERVICEPLANNING__SSP0SKILLDELEGATE_HXX
