//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0SkillRevision
    Filename:   SSP0SkillRevision.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0SKILLREVISION__HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0SKILLREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0SkillRevision;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0SkillRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0SkillRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0SkillRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0SkillRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEPLANNING_API  Teamcenter::serviceplanning::SSP0SkillRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SSP0SkillRevision();

    /**
     * Destructor
     */
    virtual ~SSP0SkillRevision();

private:
    //  Getter method for the Implementation Object
    SSP0SkillRevisionImpl*  getSSP0SkillRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSSP0SkillRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SSP0SkillRevisionImpl*  m_ssp0skillrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SSP0SkillRevision - desc for SSP0SkillRevision parameter
     */
    SSP0SkillRevision( const SSP0SkillRevision& );
    SSP0SkillRevision& operator=( const SSP0SkillRevision& );

    friend class  SSP0SkillRevisionDelegate;
    friend class  SSP0SkillRevisionDispatch;
    friend class  SSP0SkillRevisionGenImpl;
};

#include <serviceplanning/libserviceplanning_undef.h>
#endif //   TEAMCENTER__SERVICEPLANNING__SSP0SKILLREVISION__HXX
