//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0SvcContainer
    Filename:   SSP0SvcContainer.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0SVCCONTAINER__HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0SVCCONTAINER__HXX

#include <common/tc_deprecation_macros.h>
#include <me/MEProcess.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0SvcContainer;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0SvcContainerImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0SvcContainerDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0SvcContainerDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0SvcContainerGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEPLANNING_API  Teamcenter::serviceplanning::SSP0SvcContainer
     : public  ::Teamcenter::MEProcess
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SSP0SvcContainer();

    /**
     * Destructor
     */
    virtual ~SSP0SvcContainer();

private:
    //  Getter method for the Implementation Object
    SSP0SvcContainerImpl*  getSSP0SvcContainerImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSSP0SvcContainerImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SSP0SvcContainerImpl*  m_ssp0svccontainerImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SSP0SvcContainer - desc for SSP0SvcContainer parameter
     */
    SSP0SvcContainer( const SSP0SvcContainer& );
    SSP0SvcContainer& operator=( const SSP0SvcContainer& );

    friend class  SSP0SvcContainerDelegate;
    friend class  SSP0SvcContainerDispatch;
    friend class  SSP0SvcContainerGenImpl;
};

#include <serviceplanning/libserviceplanning_undef.h>
#endif //   TEAMCENTER__SERVICEPLANNING__SSP0SVCCONTAINER__HXX
