//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0SvcContainerDelegate
    Filename:   SSP0SvcContainerDelegate.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0SVCCONTAINERDELEGATE_HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0SVCCONTAINERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <serviceplanning/SSP0SvcContainer.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0SvcContainerDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0SvcContainerImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0SvcContainer;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0SvcContainerGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SERVICEPLANNING_API Teamcenter_alias::serviceplanning::SSP0SvcContainerDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SSP0SvcContainerDelegate instance
    static SSP0SvcContainerDelegate&  getInstance();

    //  Method to create the SSP0SvcContainerImpl pointer
    static SSP0SvcContainerImpl*  createImpl( SSP0SvcContainer&  ifObj );

    //  Method to delete the SSP0SvcContainerImpl pointer
    static void deleteImpl( SSP0SvcContainerImpl*  impl );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const SSP0SvcContainer &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static SSP0SvcContainerDelegate*  m_pInstance;

    SSP0SvcContainerDelegate();
    virtual ~SSP0SvcContainerDelegate();
    static void setInstance( SSP0SvcContainerDelegate*  instance );


private:
    friend class  ::Teamcenter::serviceplanning::SSP0SvcContainerGenImpl;

};

#include <serviceplanning/libserviceplanning_undef.h>
#endif  //  TEAMCENTER__SERVICEPLANNING__SSP0SVCCONTAINERDELEGATE_HXX
