//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0SvcContainerRevision
    Filename:   SSP0SvcContainerRevision.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0SVCCONTAINERREVISION__HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0SVCCONTAINERREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <me/MEProcessRevision.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0SvcContainerRevision;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0SvcContainerRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0SvcContainerRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0SvcContainerRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0SvcContainerRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEPLANNING_API  Teamcenter::serviceplanning::SSP0SvcContainerRevision
     : public  ::Teamcenter::MEProcessRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SSP0SvcContainerRevision();

    /**
     * Destructor
     */
    virtual ~SSP0SvcContainerRevision();

private:
    //  Getter method for the Implementation Object
    SSP0SvcContainerRevisionImpl*  getSSP0SvcContainerRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSSP0SvcContainerRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SSP0SvcContainerRevisionImpl*  m_ssp0svccontainerrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SSP0SvcContainerRevision - desc for SSP0SvcContainerRevision parameter
     */
    SSP0SvcContainerRevision( const SSP0SvcContainerRevision& );
    SSP0SvcContainerRevision& operator=( const SSP0SvcContainerRevision& );

    friend class  SSP0SvcContainerRevisionDelegate;
    friend class  SSP0SvcContainerRevisionDispatch;
    friend class  SSP0SvcContainerRevisionGenImpl;
};

#include <serviceplanning/libserviceplanning_undef.h>
#endif //   TEAMCENTER__SERVICEPLANNING__SSP0SVCCONTAINERREVISION__HXX
