//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0WorkCard
    Filename:   SSP0WorkCard.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0WORKCARD__HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0WORKCARD__HXX

#include <common/tc_deprecation_macros.h>
#include <me/MEOP.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0WorkCard;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0WorkCardImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0WorkCardDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0WorkCardDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0WorkCardGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEPLANNING_API  Teamcenter::serviceplanning::SSP0WorkCard
     : public  ::Teamcenter::MEOP
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSsp0IsRebase( bool &value, bool &isNull ) const;

    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSsp0IsRebase( bool value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SSP0WorkCard();

    /**
     * Destructor
     */
    virtual ~SSP0WorkCard();

private:
    //  Getter method for the Implementation Object
    SSP0WorkCardImpl*  getSSP0WorkCardImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSSP0WorkCardImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SSP0WorkCardImpl*  m_ssp0workcardImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SSP0WorkCard - desc for SSP0WorkCard parameter
     */
    SSP0WorkCard( const SSP0WorkCard& );
    SSP0WorkCard& operator=( const SSP0WorkCard& );

    friend class  SSP0WorkCardDelegate;
    friend class  SSP0WorkCardDispatch;
    friend class  SSP0WorkCardGenImpl;
};

#include <serviceplanning/libserviceplanning_undef.h>
#endif //   TEAMCENTER__SERVICEPLANNING__SSP0WORKCARD__HXX
