//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0WorkCardDelegate
    Filename:   SSP0WorkCardDelegate.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0WORKCARDDELEGATE_HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0WORKCARDDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <serviceplanning/SSP0WorkCard.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0WorkCardDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0WorkCardImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0WorkCard;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0WorkCardGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SERVICEPLANNING_API Teamcenter_alias::serviceplanning::SSP0WorkCardDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SSP0WorkCardDelegate instance
    static SSP0WorkCardDelegate&  getInstance();

    //  Method to create the SSP0WorkCardImpl pointer
    static SSP0WorkCardImpl*  createImpl( SSP0WorkCard&  ifObj );

    //  Method to delete the SSP0WorkCardImpl pointer
    static void deleteImpl( SSP0WorkCardImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSsp0IsRebaseBase(const SSP0WorkCard &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSsp0IsRebaseBase(SSP0WorkCard &ifObj,  bool value, bool isNull );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const SSP0WorkCard &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static SSP0WorkCardDelegate*  m_pInstance;

    SSP0WorkCardDelegate();
    virtual ~SSP0WorkCardDelegate();
    static void setInstance( SSP0WorkCardDelegate*  instance );


private:
    friend class  ::Teamcenter::serviceplanning::SSP0WorkCardGenImpl;

};

#include <serviceplanning/libserviceplanning_undef.h>
#endif  //  TEAMCENTER__SERVICEPLANNING__SSP0WORKCARDDELEGATE_HXX
