//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0WorkCardRevision
    Filename:   SSP0WorkCardRevision.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0WORKCARDREVISION__HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0WORKCARDREVISION__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <me/MEOPRevision.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0WorkCardRevision;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0WorkCardRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0WorkCardRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0WorkCardRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0WorkCardRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEPLANNING_API  Teamcenter::serviceplanning::SSP0WorkCardRevision
     : public  ::Teamcenter::MEOPRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getSsp0Qualifications( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SSP0WorkCardRevision();

    /**
     * Destructor
     */
    virtual ~SSP0WorkCardRevision();

private:
    //  Getter method for the Implementation Object
    SSP0WorkCardRevisionImpl*  getSSP0WorkCardRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSSP0WorkCardRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SSP0WorkCardRevisionImpl*  m_ssp0workcardrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SSP0WorkCardRevision - desc for SSP0WorkCardRevision parameter
     */
    SSP0WorkCardRevision( const SSP0WorkCardRevision& );
    SSP0WorkCardRevision& operator=( const SSP0WorkCardRevision& );

    friend class  SSP0WorkCardRevisionDelegate;
    friend class  SSP0WorkCardRevisionDispatch;
    friend class  SSP0WorkCardRevisionGenImpl;
};

#include <serviceplanning/libserviceplanning_undef.h>
#endif //   TEAMCENTER__SERVICEPLANNING__SSP0WORKCARDREVISION__HXX
