//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSP0WorkCardRevisionDelegate
    Filename:   SSP0WorkCardRevisionDelegate.hxx
    Module:     serviceplanning
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPLANNING__SSP0WORKCARDREVISIONDELEGATE_HXX
#define TEAMCENTER__SERVICEPLANNING__SSP0WORKCARDREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <serviceplanning/SSP0WorkCardRevision.hxx>

#include <serviceplanning/libserviceplanning_exports.h>

namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0WorkCardRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0WorkCardRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0WorkCardRevision;
    }
}
namespace Teamcenter
{
    namespace serviceplanning
    {
        class SSP0WorkCardRevisionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SERVICEPLANNING_API Teamcenter_alias::serviceplanning::SSP0WorkCardRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SSP0WorkCardRevisionDelegate instance
    static SSP0WorkCardRevisionDelegate&  getInstance();

    //  Method to create the SSP0WorkCardRevisionImpl pointer
    static SSP0WorkCardRevisionImpl*  createImpl( SSP0WorkCardRevision&  ifObj );

    //  Method to delete the SSP0WorkCardRevisionImpl pointer
    static void deleteImpl( SSP0WorkCardRevisionImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getSsp0QualificationsBase(const SSP0WorkCardRevision &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;



protected:
    //  Pointer to the instance
    static SSP0WorkCardRevisionDelegate*  m_pInstance;

    SSP0WorkCardRevisionDelegate();
    virtual ~SSP0WorkCardRevisionDelegate();
    static void setInstance( SSP0WorkCardRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::serviceplanning::SSP0WorkCardRevisionGenImpl;

};

#include <serviceplanning/libserviceplanning_undef.h>
#endif  //  TEAMCENTER__SERVICEPLANNING__SSP0WORKCARDREVISIONDELEGATE_HXX
