//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  serviceplanning

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libserviceplanning

#if !defined(LIBSERVICEPLANNING) && !defined(IPLIB)
#   error IPLIB or LIBSERVICEPLANNING is not defined
#endif

/* Handwritten code should use SERVICEPLANNING_API, not SERVICEPLANNINGEXPORT */

#define SERVICEPLANNING_API SERVICEPLANNINGEXPORT

#if IPLIB==libserviceplanning || defined(LIBSERVICEPLANNING)
#   if defined(__lint)
#       define SERVICEPLANNINGEXPORT       __export(serviceplanning)
#       define SERVICEPLANNINGGLOBAL       extern __global(serviceplanning)
#       define SERVICEPLANNINGPRIVATE      extern __private(serviceplanning)
#   elif defined(_WIN32)
#       define SERVICEPLANNINGEXPORT       __declspec(dllexport)
#       define SERVICEPLANNINGGLOBAL       extern __declspec(dllexport)
#       define SERVICEPLANNINGPRIVATE      extern
#   else
#       define SERVICEPLANNINGEXPORT
#       define SERVICEPLANNINGGLOBAL       extern
#       define SERVICEPLANNINGPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define SERVICEPLANNINGEXPORT       __export(serviceplanning)
#       define SERVICEPLANNINGGLOBAL       extern __global(serviceplanning)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define SERVICEPLANNINGEXPORT      __declspec(dllimport)
#       define SERVICEPLANNINGGLOBAL       extern __declspec(dllimport)
#   else
#       define SERVICEPLANNINGEXPORT
#       define SERVICEPLANNINGGLOBAL       extern
#   endif
#endif
