//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  serviceplanningdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libserviceplanningdispatch

#if !defined(LIBSERVICEPLANNINGDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBSERVICEPLANNINGDISPATCH is not defined
#endif

/* Handwritten code should use SERVICEPLANNINGDISPATCH_API, not SERVICEPLANNINGDISPATCHEXPORT */

#define SERVICEPLANNINGDISPATCH_API SERVICEPLANNINGDISPATCHEXPORT

#if IPLIB==libserviceplanningdispatch || defined(LIBSERVICEPLANNINGDISPATCH)
#   if defined(__lint)
#       define SERVICEPLANNINGDISPATCHEXPORT       __export(serviceplanningdispatch)
#       define SERVICEPLANNINGDISPATCHGLOBAL       extern __global(serviceplanningdispatch)
#       define SERVICEPLANNINGDISPATCHPRIVATE      extern __private(serviceplanningdispatch)
#   elif defined(_WIN32)
#       define SERVICEPLANNINGDISPATCHEXPORT       __declspec(dllexport)
#       define SERVICEPLANNINGDISPATCHGLOBAL       extern __declspec(dllexport)
#       define SERVICEPLANNINGDISPATCHPRIVATE      extern
#   else
#       define SERVICEPLANNINGDISPATCHEXPORT
#       define SERVICEPLANNINGDISPATCHGLOBAL       extern
#       define SERVICEPLANNINGDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define SERVICEPLANNINGDISPATCHEXPORT       __export(serviceplanningdispatch)
#       define SERVICEPLANNINGDISPATCHGLOBAL       extern __global(serviceplanningdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define SERVICEPLANNINGDISPATCHEXPORT      __declspec(dllimport)
#       define SERVICEPLANNINGDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define SERVICEPLANNINGDISPATCHEXPORT
#       define SERVICEPLANNINGDISPATCHGLOBAL       extern
#   endif
#endif
