//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ActivityEntryValue
    Filename:   ActivityEntryValue.hxx
    Module:     serviceprocessing
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPROCESSING__ACTIVITYENTRYVALUE__HXX
#define TEAMCENTER__SERVICEPROCESSING__ACTIVITYENTRYVALUE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <serviceprocessing/libserviceprocessing_exports.h>

namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ActivityEntryValue;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ActivityEntryValueImpl;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ActivityEntryValueDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ActivityEntryValueDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ActivityEntryValueGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEPROCESSING_API  Teamcenter::serviceprocessing::ActivityEntryValue
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCharacteristic_value( double &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ActivityEntryValue();

    /**
     * Destructor
     */
    virtual ~ActivityEntryValue();

private:
    //  Getter method for the Implementation Object
    ActivityEntryValueImpl*  getActivityEntryValueImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setActivityEntryValueImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ActivityEntryValueImpl*  m_activityentryvalueImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ActivityEntryValue - desc for ActivityEntryValue parameter
     */
    ActivityEntryValue( const ActivityEntryValue& );
    ActivityEntryValue& operator=( const ActivityEntryValue& );

    friend class  ActivityEntryValueDelegate;
    friend class  ActivityEntryValueDispatch;
    friend class  ActivityEntryValueGenImpl;
};

#include <serviceprocessing/libserviceprocessing_undef.h>
#endif //   TEAMCENTER__SERVICEPROCESSING__ACTIVITYENTRYVALUE__HXX
