//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ActivityEntryValueDelegate
    Filename:   ActivityEntryValueDelegate.hxx
    Module:     serviceprocessing
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPROCESSING__ACTIVITYENTRYVALUEDELEGATE_HXX
#define TEAMCENTER__SERVICEPROCESSING__ACTIVITYENTRYVALUEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <serviceprocessing/ActivityEntryValue.hxx>

#include <serviceprocessing/libserviceprocessing_exports.h>

namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ActivityEntryValueDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ActivityEntryValueImpl;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ActivityEntryValue;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ActivityEntryValueGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SERVICEPROCESSING_API Teamcenter_alias::serviceprocessing::ActivityEntryValueDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ActivityEntryValueDelegate instance
    static ActivityEntryValueDelegate&  getInstance();

    //  Method to create the ActivityEntryValueImpl pointer
    static ActivityEntryValueImpl*  createImpl( ActivityEntryValue&  ifObj );

    //  Method to delete the ActivityEntryValueImpl pointer
    static void deleteImpl( ActivityEntryValueImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCharacteristic_valueBase(const ActivityEntryValue &ifObj,  double &value, bool &isNull ) const;


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const ActivityEntryValue &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const ActivityEntryValue &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static ActivityEntryValueDelegate*  m_pInstance;

    ActivityEntryValueDelegate();
    virtual ~ActivityEntryValueDelegate();
    static void setInstance( ActivityEntryValueDelegate*  instance );


private:
    friend class  ::Teamcenter::serviceprocessing::ActivityEntryValueGenImpl;

};

#include <serviceprocessing/libserviceprocessing_undef.h>
#endif  //  TEAMCENTER__SERVICEPROCESSING__ACTIVITYENTRYVALUEDELEGATE_HXX
