//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AsMaintainedBOMLine
    Filename:   AsMaintainedBOMLineExt.hxx
    Module:     serviceprocessing
    @BMIDE autogenerated
==================================================================================================*/

#ifndef SPR0__TEAMCENTER__SERVICEPROCESSING__ASMAINTAINEDBOMLINE__HXX
#define SPR0__TEAMCENTER__SERVICEPROCESSING__ASMAINTAINEDBOMLINE__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/BusinessObjectExtender.hxx>
#include <metaframework/BusinessObjectExtenderRef.hxx>
#include <metaframework/BusinessObjectExtenderRegistry.hxx>

#include <serviceprocessing/libserviceprocessing_exports.h>

namespace spr0
{
    namespace Teamcenter
    {
        namespace serviceprocessing
        {
            class AsMaintainedBOMLine;
        }
    }
}
namespace spr0
{
    namespace Teamcenter
    {
        namespace serviceprocessing
        {
            class AsMaintainedBOMLineImpl;
        }
    }
}
namespace spr0
{
    namespace Teamcenter
    {
        namespace serviceprocessing
        {
            class AsMaintainedBOMLineDelegate;
        }
    }
}
namespace spr0
{
    namespace Teamcenter
    {
        namespace serviceprocessing
        {
            class AsMaintainedBOMLineDispatch;
        }
    }
}
namespace spr0
{
    namespace Teamcenter
    {
        namespace serviceprocessing
        {
            class AsMaintainedBOMLineGenImpl;
        }
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEPROCESSING_API  spr0::Teamcenter::serviceprocessing::AsMaintainedBOMLine
     : public  ::Teamcenter::BusinessObjectExtender
{
public:

    /**
     * Constructor
     */
    AsMaintainedBOMLine( tag_t  objTag );
    /**
     * Get the Extender Registry
     * @return - return Extender Registry
     */
    static ::Teamcenter::BusinessObjectExtenderRegistry< spr0::Teamcenter::serviceprocessing::AsMaintainedBOMLine >&  extenderRegistry();

    /**
     * Get the Extender Interface Name
     * @return - return desc for getExtenderInterfaceName
     */
    static const std::string&  getExtenderInterfaceName();


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 13.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSpr0HasOpenDiscrepancy( bool &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );


    /**
     * Destructor
     */
    virtual ~AsMaintainedBOMLine();

private:
    //  Getter method for the Implementation Object
    AsMaintainedBOMLineImpl*  getAsMaintainedBOMLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAsMaintainedBOMLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AsMaintainedBOMLineImpl*  m_asmaintainedbomlineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AsMaintainedBOMLine - desc for AsMaintainedBOMLine parameter
     */
    AsMaintainedBOMLine( const AsMaintainedBOMLine& );
    AsMaintainedBOMLine& operator=( const AsMaintainedBOMLine& );

    friend class  AsMaintainedBOMLineDelegate;
    friend class  AsMaintainedBOMLineDispatch;
    friend class  AsMaintainedBOMLineGenImpl;
};

#include <serviceprocessing/libserviceprocessing_undef.h>
#endif //   SPR0__TEAMCENTER__SERVICEPROCESSING__ASMAINTAINEDBOMLINE__HXX
