//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CorrectiveAction
    Filename:   CorrectiveAction.hxx
    Module:     serviceprocessing
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPROCESSING__CORRECTIVEACTION__HXX
#define TEAMCENTER__SERVICEPROCESSING__CORRECTIVEACTION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <serviceprocessing/libserviceprocessing_exports.h>

namespace Teamcenter
{
    namespace serviceprocessing
    {
        class CorrectiveAction;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class CorrectiveActionImpl;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class CorrectiveActionDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class CorrectiveActionDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class CorrectiveActionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEPROCESSING_API  Teamcenter::serviceprocessing::CorrectiveAction
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CorrectiveAction();

    /**
     * Destructor
     */
    virtual ~CorrectiveAction();

private:
    //  Getter method for the Implementation Object
    CorrectiveActionImpl*  getCorrectiveActionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCorrectiveActionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CorrectiveActionImpl*  m_correctiveactionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CorrectiveAction - desc for CorrectiveAction parameter
     */
    CorrectiveAction( const CorrectiveAction& );
    CorrectiveAction& operator=( const CorrectiveAction& );

    friend class  CorrectiveActionDelegate;
    friend class  CorrectiveActionDispatch;
    friend class  CorrectiveActionGenImpl;
};

#include <serviceprocessing/libserviceprocessing_undef.h>
#endif //   TEAMCENTER__SERVICEPROCESSING__CORRECTIVEACTION__HXX
