//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CorrectiveActionDelegate
    Filename:   CorrectiveActionDelegate.hxx
    Module:     serviceprocessing
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPROCESSING__CORRECTIVEACTIONDELEGATE_HXX
#define TEAMCENTER__SERVICEPROCESSING__CORRECTIVEACTIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <serviceprocessing/CorrectiveAction.hxx>

#include <serviceprocessing/libserviceprocessing_exports.h>

namespace Teamcenter
{
    namespace serviceprocessing
    {
        class CorrectiveActionDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class CorrectiveActionImpl;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class CorrectiveAction;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class CorrectiveActionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SERVICEPROCESSING_API Teamcenter_alias::serviceprocessing::CorrectiveActionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CorrectiveActionDelegate instance
    static CorrectiveActionDelegate&  getInstance();

    //  Method to create the CorrectiveActionImpl pointer
    static CorrectiveActionImpl*  createImpl( CorrectiveAction&  ifObj );

    //  Method to delete the CorrectiveActionImpl pointer
    static void deleteImpl( CorrectiveActionImpl*  impl );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const CorrectiveAction &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static CorrectiveActionDelegate*  m_pInstance;

    CorrectiveActionDelegate();
    virtual ~CorrectiveActionDelegate();
    static void setInstance( CorrectiveActionDelegate*  instance );


private:
    friend class  ::Teamcenter::serviceprocessing::CorrectiveActionGenImpl;

};

#include <serviceprocessing/libserviceprocessing_undef.h>
#endif  //  TEAMCENTER__SERVICEPROCESSING__CORRECTIVEACTIONDELEGATE_HXX
