//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SPR0PartRequest
    Filename:   SPR0PartRequest.hxx
    Module:     serviceprocessing
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPROCESSING__SPR0PARTREQUEST__HXX
#define TEAMCENTER__SERVICEPROCESSING__SPR0PARTREQUEST__HXX

#include <common/tc_deprecation_macros.h>
#include <transactionprocessing/TransactionActivity.hxx>

#include <serviceprocessing/libserviceprocessing_exports.h>

namespace Teamcenter
{
    namespace serviceprocessing
    {
        class SPR0PartRequest;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class SPR0PartRequestImpl;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class SPR0PartRequestDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class SPR0PartRequestDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class SPR0PartRequestGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEPROCESSING_API  Teamcenter::serviceprocessing::SPR0PartRequest
     : public  ::Teamcenter::transactionprocessing::TransactionActivity
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SPR0PartRequest();

    /**
     * Destructor
     */
    virtual ~SPR0PartRequest();

private:
    //  Getter method for the Implementation Object
    SPR0PartRequestImpl*  getSPR0PartRequestImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSPR0PartRequestImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SPR0PartRequestImpl*  m_spr0partrequestImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SPR0PartRequest - desc for SPR0PartRequest parameter
     */
    SPR0PartRequest( const SPR0PartRequest& );
    SPR0PartRequest& operator=( const SPR0PartRequest& );

    friend class  SPR0PartRequestDelegate;
    friend class  SPR0PartRequestDispatch;
    friend class  SPR0PartRequestGenImpl;
};

#include <serviceprocessing/libserviceprocessing_undef.h>
#endif //   TEAMCENTER__SERVICEPROCESSING__SPR0PARTREQUEST__HXX
