//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SPR0PartRequestDelegate
    Filename:   SPR0PartRequestDelegate.hxx
    Module:     serviceprocessing
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPROCESSING__SPR0PARTREQUESTDELEGATE_HXX
#define TEAMCENTER__SERVICEPROCESSING__SPR0PARTREQUESTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <serviceprocessing/SPR0PartRequest.hxx>

#include <serviceprocessing/libserviceprocessing_exports.h>

namespace Teamcenter
{
    namespace serviceprocessing
    {
        class SPR0PartRequestDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class SPR0PartRequestImpl;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class SPR0PartRequest;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class SPR0PartRequestGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SERVICEPROCESSING_API Teamcenter_alias::serviceprocessing::SPR0PartRequestDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SPR0PartRequestDelegate instance
    static SPR0PartRequestDelegate&  getInstance();

    //  Method to create the SPR0PartRequestImpl pointer
    static SPR0PartRequestImpl*  createImpl( SPR0PartRequest&  ifObj );

    //  Method to delete the SPR0PartRequestImpl pointer
    static void deleteImpl( SPR0PartRequestImpl*  impl );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const SPR0PartRequest &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static SPR0PartRequestDelegate*  m_pInstance;

    SPR0PartRequestDelegate();
    virtual ~SPR0PartRequestDelegate();
    static void setInstance( SPR0PartRequestDelegate*  instance );


private:
    friend class  ::Teamcenter::serviceprocessing::SPR0PartRequestGenImpl;

};

#include <serviceprocessing/libserviceprocessing_undef.h>
#endif  //  TEAMCENTER__SERVICEPROCESSING__SPR0PARTREQUESTDELEGATE_HXX
