//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SPR0RequestedPart
    Filename:   SPR0RequestedPart.hxx
    Module:     serviceprocessing
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPROCESSING__SPR0REQUESTEDPART__HXX
#define TEAMCENTER__SERVICEPROCESSING__SPR0REQUESTEDPART__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <serviceprocessing/libserviceprocessing_exports.h>

namespace Teamcenter
{
    namespace serviceprocessing
    {
        class SPR0RequestedPart;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class SPR0RequestedPartImpl;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class SPR0RequestedPartDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class SPR0RequestedPartDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class SPR0RequestedPartGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEPROCESSING_API  Teamcenter::serviceprocessing::SPR0RequestedPart
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SPR0RequestedPart();

    /**
     * Destructor
     */
    virtual ~SPR0RequestedPart();

private:
    //  Getter method for the Implementation Object
    SPR0RequestedPartImpl*  getSPR0RequestedPartImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSPR0RequestedPartImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SPR0RequestedPartImpl*  m_spr0requestedpartImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SPR0RequestedPart - desc for SPR0RequestedPart parameter
     */
    SPR0RequestedPart( const SPR0RequestedPart& );
    SPR0RequestedPart& operator=( const SPR0RequestedPart& );

    friend class  SPR0RequestedPartDelegate;
    friend class  SPR0RequestedPartDispatch;
    friend class  SPR0RequestedPartGenImpl;
};

#include <serviceprocessing/libserviceprocessing_undef.h>
#endif //   TEAMCENTER__SERVICEPROCESSING__SPR0REQUESTEDPART__HXX
