//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SPR0RequestedPartInfo
    Filename:   SPR0RequestedPartInfo.hxx
    Module:     serviceprocessing
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPROCESSING__SPR0REQUESTEDPARTINFO__HXX
#define TEAMCENTER__SERVICEPROCESSING__SPR0REQUESTEDPARTINFO__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <serviceprocessing/libserviceprocessing_exports.h>

namespace Teamcenter
{
    namespace serviceprocessing
    {
        class SPR0RequestedPartInfo;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class SPR0RequestedPartInfoImpl;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class SPR0RequestedPartInfoDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class SPR0RequestedPartInfoDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class SPR0RequestedPartInfoGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEPROCESSING_API  Teamcenter::serviceprocessing::SPR0RequestedPartInfo
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SPR0RequestedPartInfo();

    /**
     * Destructor
     */
    virtual ~SPR0RequestedPartInfo();

private:
    //  Getter method for the Implementation Object
    SPR0RequestedPartInfoImpl*  getSPR0RequestedPartInfoImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSPR0RequestedPartInfoImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SPR0RequestedPartInfoImpl*  m_spr0requestedpartinfoImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SPR0RequestedPartInfo - desc for SPR0RequestedPartInfo parameter
     */
    SPR0RequestedPartInfo( const SPR0RequestedPartInfo& );
    SPR0RequestedPartInfo& operator=( const SPR0RequestedPartInfo& );

    friend class  SPR0RequestedPartInfoDelegate;
    friend class  SPR0RequestedPartInfoDispatch;
    friend class  SPR0RequestedPartInfoGenImpl;
};

#include <serviceprocessing/libserviceprocessing_undef.h>
#endif //   TEAMCENTER__SERVICEPROCESSING__SPR0REQUESTEDPARTINFO__HXX
