//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ServiceAction
    Filename:   ServiceAction.hxx
    Module:     serviceprocessing
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPROCESSING__SERVICEACTION__HXX
#define TEAMCENTER__SERVICEPROCESSING__SERVICEACTION__HXX

#include <common/tc_deprecation_macros.h>
#include <serviceprocessing/ServiceActivity.hxx>

#include <serviceprocessing/libserviceprocessing_exports.h>

namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServiceAction;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServiceActionImpl;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServiceActionDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServiceActionDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServiceActionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEPROCESSING_API  Teamcenter::serviceprocessing::ServiceAction
     : public  ::Teamcenter::serviceprocessing::ServiceActivity
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ServiceAction();

    /**
     * Destructor
     */
    virtual ~ServiceAction();

private:
    //  Getter method for the Implementation Object
    ServiceActionImpl*  getServiceActionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setServiceActionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ServiceActionImpl*  m_serviceactionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ServiceAction - desc for ServiceAction parameter
     */
    ServiceAction( const ServiceAction& );
    ServiceAction& operator=( const ServiceAction& );

    friend class  ServiceActionDelegate;
    friend class  ServiceActionDispatch;
    friend class  ServiceActionGenImpl;
};

#include <serviceprocessing/libserviceprocessing_undef.h>
#endif //   TEAMCENTER__SERVICEPROCESSING__SERVICEACTION__HXX
