//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ServiceActionDelegate
    Filename:   ServiceActionDelegate.hxx
    Module:     serviceprocessing
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPROCESSING__SERVICEACTIONDELEGATE_HXX
#define TEAMCENTER__SERVICEPROCESSING__SERVICEACTIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <serviceprocessing/ServiceAction.hxx>

#include <serviceprocessing/libserviceprocessing_exports.h>

namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServiceActionDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServiceActionImpl;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServiceAction;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServiceActionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SERVICEPROCESSING_API Teamcenter_alias::serviceprocessing::ServiceActionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ServiceActionDelegate instance
    static ServiceActionDelegate&  getInstance();

    //  Method to create the ServiceActionImpl pointer
    static ServiceActionImpl*  createImpl( ServiceAction&  ifObj );

    //  Method to delete the ServiceActionImpl pointer
    static void deleteImpl( ServiceActionImpl*  impl );


    ///
    /// Approval operation
    /// @version Teamcenter 8.0.1
    /// @param strucRoot - Root of the Service Group or Service Event structure
    /// @return - success or failure
    ///
    int  approvalBase(const ServiceAction &ifObj,  tag_t strucRoot );



protected:
    //  Pointer to the instance
    static ServiceActionDelegate*  m_pInstance;

    ServiceActionDelegate();
    virtual ~ServiceActionDelegate();
    static void setInstance( ServiceActionDelegate*  instance );


private:
    friend class  ::Teamcenter::serviceprocessing::ServiceActionGenImpl;

};

#include <serviceprocessing/libserviceprocessing_undef.h>
#endif  //  TEAMCENTER__SERVICEPROCESSING__SERVICEACTIONDELEGATE_HXX
