//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ServiceActivity
    Filename:   ServiceActivity.hxx
    Module:     serviceprocessing
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPROCESSING__SERVICEACTIVITY__HXX
#define TEAMCENTER__SERVICEPROCESSING__SERVICEACTIVITY__HXX

#include <string>
#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <transactionprocessing/TransactionActivity.hxx>

#include <serviceprocessing/libserviceprocessing_exports.h>

namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServiceActivity;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServiceActivityImpl;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServiceActivityDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServiceActivityDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServiceActivityGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEPROCESSING_API  Teamcenter::serviceprocessing::ServiceActivity
     : public  ::Teamcenter::transactionprocessing::TransactionActivity
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getActivity_number( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAuthorized_by( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCategory( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIs_preventative_maintenance( bool &value, bool &isNull ) const;

    ///
    /// Getter for a Date Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getNeeded_by_date( date_t &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getUsage_path( std::string &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ServiceActivity();

    /**
     * Destructor
     */
    virtual ~ServiceActivity();

private:
    //  Getter method for the Implementation Object
    ServiceActivityImpl*  getServiceActivityImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setServiceActivityImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ServiceActivityImpl*  m_serviceactivityImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ServiceActivity - desc for ServiceActivity parameter
     */
    ServiceActivity( const ServiceActivity& );
    ServiceActivity& operator=( const ServiceActivity& );

    friend class  ServiceActivityDelegate;
    friend class  ServiceActivityDispatch;
    friend class  ServiceActivityGenImpl;
};

#include <serviceprocessing/libserviceprocessing_undef.h>
#endif //   TEAMCENTER__SERVICEPROCESSING__SERVICEACTIVITY__HXX
