//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ServiceActivityDelegate
    Filename:   ServiceActivityDelegate.hxx
    Module:     serviceprocessing
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPROCESSING__SERVICEACTIVITYDELEGATE_HXX
#define TEAMCENTER__SERVICEPROCESSING__SERVICEACTIVITYDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <serviceprocessing/ServiceActivity.hxx>

#include <serviceprocessing/libserviceprocessing_exports.h>

namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServiceActivityDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServiceActivityImpl;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServiceActivity;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServiceActivityGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SERVICEPROCESSING_API Teamcenter_alias::serviceprocessing::ServiceActivityDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ServiceActivityDelegate instance
    static ServiceActivityDelegate&  getInstance();

    //  Method to create the ServiceActivityImpl pointer
    static ServiceActivityImpl*  createImpl( ServiceActivity&  ifObj );

    //  Method to delete the ServiceActivityImpl pointer
    static void deleteImpl( ServiceActivityImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getActivity_numberBase(const ServiceActivity &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAuthorized_byBase(const ServiceActivity &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCategoryBase(const ServiceActivity &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIs_preventative_maintenanceBase(const ServiceActivity &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Date Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getNeeded_by_dateBase(const ServiceActivity &ifObj,  date_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getUsage_pathBase(const ServiceActivity &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// processes the part movements
    /// @version Teamcenter 8.0.1
    /// @param serviceEvents - service event vector
    /// @param partMovements - part movement vectors
    /// @return - returns success or failure
    ///
    int  processPartMovementsBase(const ServiceActivity &ifObj,  std::vector< tag_t > &serviceEvents, std::vector< tag_t > &partMovements );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const ServiceActivity &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static ServiceActivityDelegate*  m_pInstance;

    ServiceActivityDelegate();
    virtual ~ServiceActivityDelegate();
    static void setInstance( ServiceActivityDelegate*  instance );


private:
    friend class  ::Teamcenter::serviceprocessing::ServiceActivityGenImpl;

};

#include <serviceprocessing/libserviceprocessing_undef.h>
#endif  //  TEAMCENTER__SERVICEPROCESSING__SERVICEACTIVITYDELEGATE_HXX
