//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ServiceDiscrepancy
    Filename:   ServiceDiscrepancy.hxx
    Module:     serviceprocessing
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPROCESSING__SERVICEDISCREPANCY__HXX
#define TEAMCENTER__SERVICEPROCESSING__SERVICEDISCREPANCY__HXX

#include <unidefs.h>
#include <string>
#include <common/tc_deprecation_macros.h>
#include <serviceprocessing/ServiceActivity.hxx>

#include <serviceprocessing/libserviceprocessing_exports.h>

namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServiceDiscrepancy;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServiceDiscrepancyImpl;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServiceDiscrepancyDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServiceDiscrepancyDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServiceDiscrepancyGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEPROCESSING_API  Teamcenter::serviceprocessing::ServiceDiscrepancy
     : public  ::Teamcenter::serviceprocessing::ServiceActivity
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Date Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDiscovery_date( date_t &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIs_failure( bool &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSeverity( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a Date Property
    /// @version Teamcenter 8.0.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDiscovery_date( const date_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ServiceDiscrepancy();

    /**
     * Destructor
     */
    virtual ~ServiceDiscrepancy();

private:
    //  Getter method for the Implementation Object
    ServiceDiscrepancyImpl*  getServiceDiscrepancyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setServiceDiscrepancyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ServiceDiscrepancyImpl*  m_servicediscrepancyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ServiceDiscrepancy - desc for ServiceDiscrepancy parameter
     */
    ServiceDiscrepancy( const ServiceDiscrepancy& );
    ServiceDiscrepancy& operator=( const ServiceDiscrepancy& );

    friend class  ServiceDiscrepancyDelegate;
    friend class  ServiceDiscrepancyDispatch;
    friend class  ServiceDiscrepancyGenImpl;
};

#include <serviceprocessing/libserviceprocessing_undef.h>
#endif //   TEAMCENTER__SERVICEPROCESSING__SERVICEDISCREPANCY__HXX
