//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ServiceDiscrepancyDelegate
    Filename:   ServiceDiscrepancyDelegate.hxx
    Module:     serviceprocessing
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPROCESSING__SERVICEDISCREPANCYDELEGATE_HXX
#define TEAMCENTER__SERVICEPROCESSING__SERVICEDISCREPANCYDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <serviceprocessing/ServiceDiscrepancy.hxx>

#include <serviceprocessing/libserviceprocessing_exports.h>

namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServiceDiscrepancyDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServiceDiscrepancyImpl;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServiceDiscrepancy;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServiceDiscrepancyGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SERVICEPROCESSING_API Teamcenter_alias::serviceprocessing::ServiceDiscrepancyDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ServiceDiscrepancyDelegate instance
    static ServiceDiscrepancyDelegate&  getInstance();

    //  Method to create the ServiceDiscrepancyImpl pointer
    static ServiceDiscrepancyImpl*  createImpl( ServiceDiscrepancy&  ifObj );

    //  Method to delete the ServiceDiscrepancyImpl pointer
    static void deleteImpl( ServiceDiscrepancyImpl*  impl );


    ///
    /// Getter for a Date Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDiscovery_dateBase(const ServiceDiscrepancy &ifObj,  date_t &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIs_failureBase(const ServiceDiscrepancy &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSeverityBase(const ServiceDiscrepancy &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a Date Property
    /// @version Teamcenter 8.0.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDiscovery_dateBase(ServiceDiscrepancy &ifObj,  const date_t &value, bool isNull );


    ///
    /// Approval operation
    /// @version Teamcenter 8.0.1
    /// @param strucRoot - Root of the Service Group or Service Event structure
    /// @return - success or failure
    ///
    int  approvalBase(const ServiceDiscrepancy &ifObj,  tag_t strucRoot );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const ServiceDiscrepancy &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// validate objects prior to the approval
    /// @version Teamcenter 8.0.1
    /// @return - success or failure
    ///
    int  validateApprovalBase(const ServiceDiscrepancy &ifObj  );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const ServiceDiscrepancy &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static ServiceDiscrepancyDelegate*  m_pInstance;

    ServiceDiscrepancyDelegate();
    virtual ~ServiceDiscrepancyDelegate();
    static void setInstance( ServiceDiscrepancyDelegate*  instance );


private:
    friend class  ::Teamcenter::serviceprocessing::ServiceDiscrepancyGenImpl;

};

#include <serviceprocessing/libserviceprocessing_undef.h>
#endif  //  TEAMCENTER__SERVICEPROCESSING__SERVICEDISCREPANCYDELEGATE_HXX
