//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ServicePerformed
    Filename:   ServicePerformed.hxx
    Module:     serviceprocessing
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPROCESSING__SERVICEPERFORMED__HXX
#define TEAMCENTER__SERVICEPROCESSING__SERVICEPERFORMED__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <serviceprocessing/ServiceActivity.hxx>

#include <serviceprocessing/libserviceprocessing_exports.h>

namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServicePerformed;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServicePerformedImpl;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServicePerformedDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServicePerformedDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServicePerformedGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEPROCESSING_API  Teamcenter::serviceprocessing::ServicePerformed
     : public  ::Teamcenter::serviceprocessing::ServiceActivity
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Date Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getWork_start_date( date_t &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ServicePerformed();

    /**
     * Destructor
     */
    virtual ~ServicePerformed();

private:
    //  Getter method for the Implementation Object
    ServicePerformedImpl*  getServicePerformedImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setServicePerformedImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ServicePerformedImpl*  m_serviceperformedImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ServicePerformed - desc for ServicePerformed parameter
     */
    ServicePerformed( const ServicePerformed& );
    ServicePerformed& operator=( const ServicePerformed& );

    friend class  ServicePerformedDelegate;
    friend class  ServicePerformedDispatch;
    friend class  ServicePerformedGenImpl;
};

#include <serviceprocessing/libserviceprocessing_undef.h>
#endif //   TEAMCENTER__SERVICEPROCESSING__SERVICEPERFORMED__HXX
