//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ServicePerformedDelegate
    Filename:   ServicePerformedDelegate.hxx
    Module:     serviceprocessing
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPROCESSING__SERVICEPERFORMEDDELEGATE_HXX
#define TEAMCENTER__SERVICEPROCESSING__SERVICEPERFORMEDDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <serviceprocessing/ServicePerformed.hxx>

#include <serviceprocessing/libserviceprocessing_exports.h>

namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServicePerformedDelegate;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServicePerformedImpl;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServicePerformed;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServicePerformedGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SERVICEPROCESSING_API Teamcenter_alias::serviceprocessing::ServicePerformedDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ServicePerformedDelegate instance
    static ServicePerformedDelegate&  getInstance();

    //  Method to create the ServicePerformedImpl pointer
    static ServicePerformedImpl*  createImpl( ServicePerformed&  ifObj );

    //  Method to delete the ServicePerformedImpl pointer
    static void deleteImpl( ServicePerformedImpl*  impl );


    ///
    /// Getter for a Date Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getWork_start_dateBase(const ServicePerformed &ifObj,  date_t &value, bool &isNull ) const;


    ///
    /// validate objects prior to the approval
    /// @version Teamcenter 8.0.1
    /// @return - success or failure
    ///
    int  validateApprovalBase(const ServicePerformed &ifObj  );



protected:
    //  Pointer to the instance
    static ServicePerformedDelegate*  m_pInstance;

    ServicePerformedDelegate();
    virtual ~ServicePerformedDelegate();
    static void setInstance( ServicePerformedDelegate*  instance );


private:
    friend class  ::Teamcenter::serviceprocessing::ServicePerformedGenImpl;

};

#include <serviceprocessing/libserviceprocessing_undef.h>
#endif  //  TEAMCENTER__SERVICEPROCESSING__SERVICEPERFORMEDDELEGATE_HXX
