//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  serviceprocessing

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libserviceprocessing

#if !defined(LIBSERVICEPROCESSING) && !defined(IPLIB)
#   error IPLIB or LIBSERVICEPROCESSING is not defined
#endif

/* Handwritten code should use SERVICEPROCESSING_API, not SERVICEPROCESSINGEXPORT */

#define SERVICEPROCESSING_API SERVICEPROCESSINGEXPORT

#if IPLIB==libserviceprocessing || defined(LIBSERVICEPROCESSING)
#   if defined(__lint)
#       define SERVICEPROCESSINGEXPORT       __export(serviceprocessing)
#       define SERVICEPROCESSINGGLOBAL       extern __global(serviceprocessing)
#       define SERVICEPROCESSINGPRIVATE      extern __private(serviceprocessing)
#   elif defined(_WIN32)
#       define SERVICEPROCESSINGEXPORT       __declspec(dllexport)
#       define SERVICEPROCESSINGGLOBAL       extern __declspec(dllexport)
#       define SERVICEPROCESSINGPRIVATE      extern
#   else
#       define SERVICEPROCESSINGEXPORT
#       define SERVICEPROCESSINGGLOBAL       extern
#       define SERVICEPROCESSINGPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define SERVICEPROCESSINGEXPORT       __export(serviceprocessing)
#       define SERVICEPROCESSINGGLOBAL       extern __global(serviceprocessing)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define SERVICEPROCESSINGEXPORT      __declspec(dllimport)
#       define SERVICEPROCESSINGGLOBAL       extern __declspec(dllimport)
#   else
#       define SERVICEPROCESSINGEXPORT
#       define SERVICEPROCESSINGGLOBAL       extern
#   endif
#endif
