//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ServiceActionDispatch
    Filename:   ServiceActionDispatch.hxx
    Module:     serviceprocessingdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPROCESSING__SERVICEACTIONDISPATCH_HXX
#define TEAMCENTER__SERVICEPROCESSING__SERVICEACTIONDISPATCH_HXX

#include <vector>
#include <serviceprocessing/ServiceAction.hxx>
#include <serviceprocessing/ServiceActionDelegate.hxx>
#include <serviceprocessingdispatch/ServiceActivityDispatch.hxx>
#include <serviceprocessingdispatch/initializeserviceprocessing.hxx>

#include <serviceprocessingdispatch/libserviceprocessingdispatch_exports.h>

namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServiceActionDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServiceActionDelegate;
    }
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  SERVICEPROCESSINGDISPATCH_API  Teamcenter::serviceprocessing::ServiceActionDispatch
    : public  Teamcenter::serviceprocessing::ServiceActionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ServiceActionDispatch instance
    static ServiceActionDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static ServiceActionDispatch*  m_dispatch;

    //  Default Constructor
    ServiceActionDispatch();

    //  Default Destructor
    virtual ~ServiceActionDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a ServiceActionDispatch
    ServiceActionDispatch( const ServiceActionDispatch& );

    //  Assignment operator
    ServiceActionDispatch&  operator = ( const ServiceActionDispatch& );

    //  friend
    friend void   ::Teamcenter::serviceprocessing::initializeserviceprocessingInternal();
    friend void   ::Teamcenter::serviceprocessing::initializeserviceprocessingExtenders();
    friend class  Teamcenter::serviceprocessing::ServiceActionDelegate;
};

#include <serviceprocessingdispatch/libserviceprocessingdispatch_undef.h>
#endif  //  TEAMCENTER__SERVICEPROCESSING__SERVICEACTIONDISPATCH_HXX
