//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ServiceActivityDispatch
    Filename:   ServiceActivityDispatch.hxx
    Module:     serviceprocessingdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPROCESSING__SERVICEACTIVITYDISPATCH_HXX
#define TEAMCENTER__SERVICEPROCESSING__SERVICEACTIVITYDISPATCH_HXX

#include <vector>
#include <serviceprocessing/ServiceActivity.hxx>
#include <serviceprocessing/ServiceActivityDelegate.hxx>
#include <transactionprocessingdispatch/TransactionActivityDispatch.hxx>
#include <serviceprocessingdispatch/initializeserviceprocessing.hxx>

#include <serviceprocessingdispatch/libserviceprocessingdispatch_exports.h>

namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServiceActivityDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServiceActivityDelegate;
    }
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  SERVICEPROCESSINGDISPATCH_API  Teamcenter::serviceprocessing::ServiceActivityDispatch
    : public  Teamcenter::serviceprocessing::ServiceActivityDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ServiceActivityDispatch instance
    static ServiceActivityDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static ServiceActivityDispatch*  m_dispatch;

    //  Default Constructor
    ServiceActivityDispatch();

    //  Default Destructor
    virtual ~ServiceActivityDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a ServiceActivityDispatch
    ServiceActivityDispatch( const ServiceActivityDispatch& );

    //  Assignment operator
    ServiceActivityDispatch&  operator = ( const ServiceActivityDispatch& );

    //  friend
    friend void   ::Teamcenter::serviceprocessing::initializeserviceprocessingInternal();
    friend void   ::Teamcenter::serviceprocessing::initializeserviceprocessingExtenders();
    friend class  Teamcenter::serviceprocessing::ServiceActivityDelegate;
};

#include <serviceprocessingdispatch/libserviceprocessingdispatch_undef.h>
#endif  //  TEAMCENTER__SERVICEPROCESSING__SERVICEACTIVITYDISPATCH_HXX
