//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ServiceDiscrepancyDispatch
    Filename:   ServiceDiscrepancyDispatch.hxx
    Module:     serviceprocessingdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPROCESSING__SERVICEDISCREPANCYDISPATCH_HXX
#define TEAMCENTER__SERVICEPROCESSING__SERVICEDISCREPANCYDISPATCH_HXX

#include <vector>
#include <serviceprocessing/ServiceDiscrepancy.hxx>
#include <serviceprocessing/ServiceDiscrepancyDelegate.hxx>
#include <serviceprocessingdispatch/ServiceActivityDispatch.hxx>
#include <serviceprocessingdispatch/initializeserviceprocessing.hxx>

#include <serviceprocessingdispatch/libserviceprocessingdispatch_exports.h>

namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServiceDiscrepancyDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServiceDiscrepancyDelegate;
    }
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  SERVICEPROCESSINGDISPATCH_API  Teamcenter::serviceprocessing::ServiceDiscrepancyDispatch
    : public  Teamcenter::serviceprocessing::ServiceDiscrepancyDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ServiceDiscrepancyDispatch instance
    static ServiceDiscrepancyDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static ServiceDiscrepancyDispatch*  m_dispatch;

    //  Default Constructor
    ServiceDiscrepancyDispatch();

    //  Default Destructor
    virtual ~ServiceDiscrepancyDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a ServiceDiscrepancyDispatch
    ServiceDiscrepancyDispatch( const ServiceDiscrepancyDispatch& );

    //  Assignment operator
    ServiceDiscrepancyDispatch&  operator = ( const ServiceDiscrepancyDispatch& );

    //  friend
    friend void   ::Teamcenter::serviceprocessing::initializeserviceprocessingInternal();
    friend void   ::Teamcenter::serviceprocessing::initializeserviceprocessingExtenders();
    friend class  Teamcenter::serviceprocessing::ServiceDiscrepancyDelegate;
};

#include <serviceprocessingdispatch/libserviceprocessingdispatch_undef.h>
#endif  //  TEAMCENTER__SERVICEPROCESSING__SERVICEDISCREPANCYDISPATCH_HXX
