//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ServicePerformedDispatch
    Filename:   ServicePerformedDispatch.hxx
    Module:     serviceprocessingdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEPROCESSING__SERVICEPERFORMEDDISPATCH_HXX
#define TEAMCENTER__SERVICEPROCESSING__SERVICEPERFORMEDDISPATCH_HXX

#include <vector>
#include <serviceprocessing/ServicePerformed.hxx>
#include <serviceprocessing/ServicePerformedDelegate.hxx>
#include <serviceprocessingdispatch/ServiceActivityDispatch.hxx>
#include <serviceprocessingdispatch/initializeserviceprocessing.hxx>

#include <serviceprocessingdispatch/libserviceprocessingdispatch_exports.h>

namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServicePerformedDispatch;
    }
}
namespace Teamcenter
{
    namespace serviceprocessing
    {
        class ServicePerformedDelegate;
    }
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  SERVICEPROCESSINGDISPATCH_API  Teamcenter::serviceprocessing::ServicePerformedDispatch
    : public  Teamcenter::serviceprocessing::ServicePerformedDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ServicePerformedDispatch instance
    static ServicePerformedDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static ServicePerformedDispatch*  m_dispatch;

    //  Default Constructor
    ServicePerformedDispatch();

    //  Default Destructor
    virtual ~ServicePerformedDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a ServicePerformedDispatch
    ServicePerformedDispatch( const ServicePerformedDispatch& );

    //  Assignment operator
    ServicePerformedDispatch&  operator = ( const ServicePerformedDispatch& );

    //  friend
    friend void   ::Teamcenter::serviceprocessing::initializeserviceprocessingInternal();
    friend void   ::Teamcenter::serviceprocessing::initializeserviceprocessingExtenders();
    friend class  Teamcenter::serviceprocessing::ServicePerformedDelegate;
};

#include <serviceprocessingdispatch/libserviceprocessingdispatch_undef.h>
#endif  //  TEAMCENTER__SERVICEPROCESSING__SERVICEPERFORMEDDISPATCH_HXX
