//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  serviceprocessingdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libserviceprocessingdispatch

#if !defined(LIBSERVICEPROCESSINGDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBSERVICEPROCESSINGDISPATCH is not defined
#endif

/* Handwritten code should use SERVICEPROCESSINGDISPATCH_API, not SERVICEPROCESSINGDISPATCHEXPORT */

#define SERVICEPROCESSINGDISPATCH_API SERVICEPROCESSINGDISPATCHEXPORT

#if IPLIB==libserviceprocessingdispatch || defined(LIBSERVICEPROCESSINGDISPATCH)
#   if defined(__lint)
#       define SERVICEPROCESSINGDISPATCHEXPORT       __export(serviceprocessingdispatch)
#       define SERVICEPROCESSINGDISPATCHGLOBAL       extern __global(serviceprocessingdispatch)
#       define SERVICEPROCESSINGDISPATCHPRIVATE      extern __private(serviceprocessingdispatch)
#   elif defined(_WIN32)
#       define SERVICEPROCESSINGDISPATCHEXPORT       __declspec(dllexport)
#       define SERVICEPROCESSINGDISPATCHGLOBAL       extern __declspec(dllexport)
#       define SERVICEPROCESSINGDISPATCHPRIVATE      extern
#   else
#       define SERVICEPROCESSINGDISPATCHEXPORT
#       define SERVICEPROCESSINGDISPATCHGLOBAL       extern
#       define SERVICEPROCESSINGDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define SERVICEPROCESSINGDISPATCHEXPORT       __export(serviceprocessingdispatch)
#       define SERVICEPROCESSINGDISPATCHGLOBAL       extern __global(serviceprocessingdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define SERVICEPROCESSINGDISPATCHEXPORT      __declspec(dllimport)
#       define SERVICEPROCESSINGDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define SERVICEPROCESSINGDISPATCHEXPORT
#       define SERVICEPROCESSINGDISPATCHGLOBAL       extern
#   endif
#endif
