//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SRP0GnSrvRequest
    Filename:   SRP0GnSrvRequest.hxx
    Module:     servicerequest
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEREQUEST__SRP0GNSRVREQUEST__HXX
#define TEAMCENTER__SERVICEREQUEST__SRP0GNSRVREQUEST__HXX

#include <common/tc_deprecation_macros.h>
#include <cm/GnChangeRequest.hxx>

#include <servicerequest/libservicerequest_exports.h>

namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0GnSrvRequest;
    }
}
namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0GnSrvRequestImpl;
    }
}
namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0GnSrvRequestDelegate;
    }
}
namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0GnSrvRequestDispatch;
    }
}
namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0GnSrvRequestGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEREQUEST_API  Teamcenter::servicerequest::SRP0GnSrvRequest
     : public  ::Teamcenter::GnChangeRequest
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SRP0GnSrvRequest();

    /**
     * Destructor
     */
    virtual ~SRP0GnSrvRequest();

private:
    //  Getter method for the Implementation Object
    SRP0GnSrvRequestImpl*  getSRP0GnSrvRequestImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSRP0GnSrvRequestImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SRP0GnSrvRequestImpl*  m_srp0gnsrvrequestImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SRP0GnSrvRequest - desc for SRP0GnSrvRequest parameter
     */
    SRP0GnSrvRequest( const SRP0GnSrvRequest& );
    SRP0GnSrvRequest& operator=( const SRP0GnSrvRequest& );

    friend class  SRP0GnSrvRequestDelegate;
    friend class  SRP0GnSrvRequestDispatch;
    friend class  SRP0GnSrvRequestGenImpl;
};

#include <servicerequest/libservicerequest_undef.h>
#endif //   TEAMCENTER__SERVICEREQUEST__SRP0GNSRVREQUEST__HXX
