//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SRP0GnSrvRequestRevision
    Filename:   SRP0GnSrvRequestRevision.hxx
    Module:     servicerequest
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEREQUEST__SRP0GNSRVREQUESTREVISION__HXX
#define TEAMCENTER__SERVICEREQUEST__SRP0GNSRVREQUESTREVISION__HXX

#include <unidefs.h>
#include <string>
#include <common/tc_deprecation_macros.h>
#include <cm/GnChangeRequestRevision.hxx>

#include <servicerequest/libservicerequest_exports.h>

namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0GnSrvRequestRevision;
    }
}
namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0GnSrvRequestRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0GnSrvRequestRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0GnSrvRequestRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0GnSrvRequestRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEREQUEST_API  Teamcenter::servicerequest::SRP0GnSrvRequestRevision
     : public  ::Teamcenter::GnChangeRequestRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSrp0MROSupervisor( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSrp0ParentRequest( std::string &value, bool &isNull ) const;

    ///
    /// Validate whether the physical part being related to the service request is a child of a physical part related via the MROProducts relationship with the service request.
    /// @version Teamcenter 8.2
    /// @param childPhysicalPart - The child physical part being related to a service request or requested activity
    /// @param result - Returns true when the validation is successful else returns false
    /// @return - 1 or 0
    ///
    int  srp0ValidatePhysicalPart( tag_t childPhysicalPart, bool *result );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SRP0GnSrvRequestRevision();

    /**
     * Destructor
     */
    virtual ~SRP0GnSrvRequestRevision();

private:
    //  Getter method for the Implementation Object
    SRP0GnSrvRequestRevisionImpl*  getSRP0GnSrvRequestRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSRP0GnSrvRequestRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SRP0GnSrvRequestRevisionImpl*  m_srp0gnsrvrequestrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SRP0GnSrvRequestRevision - desc for SRP0GnSrvRequestRevision parameter
     */
    SRP0GnSrvRequestRevision( const SRP0GnSrvRequestRevision& );
    SRP0GnSrvRequestRevision& operator=( const SRP0GnSrvRequestRevision& );

    friend class  SRP0GnSrvRequestRevisionDelegate;
    friend class  SRP0GnSrvRequestRevisionDispatch;
    friend class  SRP0GnSrvRequestRevisionGenImpl;
};

#include <servicerequest/libservicerequest_undef.h>
#endif //   TEAMCENTER__SERVICEREQUEST__SRP0GNSRVREQUESTREVISION__HXX
