//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SRP0GnSrvRequestRevisionDelegate
    Filename:   SRP0GnSrvRequestRevisionDelegate.hxx
    Module:     servicerequest
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEREQUEST__SRP0GNSRVREQUESTREVISIONDELEGATE_HXX
#define TEAMCENTER__SERVICEREQUEST__SRP0GNSRVREQUESTREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <servicerequest/SRP0GnSrvRequestRevision.hxx>

#include <servicerequest/libservicerequest_exports.h>

namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0GnSrvRequestRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0GnSrvRequestRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0GnSrvRequestRevision;
    }
}
namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0GnSrvRequestRevisionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SERVICEREQUEST_API Teamcenter_alias::servicerequest::SRP0GnSrvRequestRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SRP0GnSrvRequestRevisionDelegate instance
    static SRP0GnSrvRequestRevisionDelegate&  getInstance();

    //  Method to create the SRP0GnSrvRequestRevisionImpl pointer
    static SRP0GnSrvRequestRevisionImpl*  createImpl( SRP0GnSrvRequestRevision&  ifObj );

    //  Method to delete the SRP0GnSrvRequestRevisionImpl pointer
    static void deleteImpl( SRP0GnSrvRequestRevisionImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSrp0MROSupervisorBase(const SRP0GnSrvRequestRevision &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSrp0ParentRequestBase(const SRP0GnSrvRequestRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Validate whether the physical part being related to the service request is a child of a physical part related via the MROProducts relationship with the service request.
    /// @version Teamcenter 8.2
    /// @param childPhysicalPart - The child physical part being related to a service request or requested activity
    /// @param result - Returns true when the validation is successful else returns false
    /// @return - 1 or 0
    ///
    int  srp0ValidatePhysicalPartBase(const SRP0GnSrvRequestRevision &ifObj,  tag_t childPhysicalPart, bool *result );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const SRP0GnSrvRequestRevision &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static SRP0GnSrvRequestRevisionDelegate*  m_pInstance;

    SRP0GnSrvRequestRevisionDelegate();
    virtual ~SRP0GnSrvRequestRevisionDelegate();
    static void setInstance( SRP0GnSrvRequestRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::servicerequest::SRP0GnSrvRequestRevisionGenImpl;

};

#include <servicerequest/libservicerequest_undef.h>
#endif  //  TEAMCENTER__SERVICEREQUEST__SRP0GNSRVREQUESTREVISIONDELEGATE_HXX
