//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SRP0MROSupervisor
    Filename:   SRP0MROSupervisor.hxx
    Module:     servicerequest
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEREQUEST__SRP0MROSUPERVISOR__HXX
#define TEAMCENTER__SERVICEREQUEST__SRP0MROSUPERVISOR__HXX

#include <common/tc_deprecation_macros.h>
#include <epm/Participant.hxx>

#include <servicerequest/libservicerequest_exports.h>

namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0MROSupervisor;
    }
}
namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0MROSupervisorImpl;
    }
}
namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0MROSupervisorDelegate;
    }
}
namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0MROSupervisorDispatch;
    }
}
namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0MROSupervisorGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEREQUEST_API  Teamcenter::servicerequest::SRP0MROSupervisor
     : public  ::Teamcenter::Participant
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SRP0MROSupervisor();

    /**
     * Destructor
     */
    virtual ~SRP0MROSupervisor();

private:
    //  Getter method for the Implementation Object
    SRP0MROSupervisorImpl*  getSRP0MROSupervisorImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSRP0MROSupervisorImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SRP0MROSupervisorImpl*  m_srp0mrosupervisorImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SRP0MROSupervisor - desc for SRP0MROSupervisor parameter
     */
    SRP0MROSupervisor( const SRP0MROSupervisor& );
    SRP0MROSupervisor& operator=( const SRP0MROSupervisor& );

    friend class  SRP0MROSupervisorDelegate;
    friend class  SRP0MROSupervisorDispatch;
    friend class  SRP0MROSupervisorGenImpl;
};

#include <servicerequest/libservicerequest_undef.h>
#endif //   TEAMCENTER__SERVICEREQUEST__SRP0MROSUPERVISOR__HXX
