//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SRP0MROSupervisorDelegate
    Filename:   SRP0MROSupervisorDelegate.hxx
    Module:     servicerequest
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEREQUEST__SRP0MROSUPERVISORDELEGATE_HXX
#define TEAMCENTER__SERVICEREQUEST__SRP0MROSUPERVISORDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <servicerequest/SRP0MROSupervisor.hxx>

#include <servicerequest/libservicerequest_exports.h>

namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0MROSupervisorDelegate;
    }
}
namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0MROSupervisorImpl;
    }
}
namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0MROSupervisor;
    }
}
namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0MROSupervisorGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SERVICEREQUEST_API Teamcenter_alias::servicerequest::SRP0MROSupervisorDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SRP0MROSupervisorDelegate instance
    static SRP0MROSupervisorDelegate&  getInstance();

    //  Method to create the SRP0MROSupervisorImpl pointer
    static SRP0MROSupervisorImpl*  createImpl( SRP0MROSupervisor&  ifObj );

    //  Method to delete the SRP0MROSupervisorImpl pointer
    static void deleteImpl( SRP0MROSupervisorImpl*  impl );


    ///
    /// This operation determines if the participant is assignable.
    /// @version Tc 8
    /// @param user - A user tag
    /// @param object - An object tag
    /// @param assignable - A pointer to a boolean whose value, when returned, is the result of the evaluation
    /// @return - An ifail integer
    ///
    int  isAssignableBase(const SRP0MROSupervisor &ifObj,  tag_t user, tag_t object, bool *assignable );



protected:
    //  Pointer to the instance
    static SRP0MROSupervisorDelegate*  m_pInstance;

    SRP0MROSupervisorDelegate();
    virtual ~SRP0MROSupervisorDelegate();
    static void setInstance( SRP0MROSupervisorDelegate*  instance );


private:
    friend class  ::Teamcenter::servicerequest::SRP0MROSupervisorGenImpl;

};

#include <servicerequest/libservicerequest_undef.h>
#endif  //  TEAMCENTER__SERVICEREQUEST__SRP0MROSUPERVISORDELEGATE_HXX
