//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SRP0RqstActivityRevisionDelegate
    Filename:   SRP0RqstActivityRevisionDelegate.hxx
    Module:     servicerequest
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEREQUEST__SRP0RQSTACTIVITYREVISIONDELEGATE_HXX
#define TEAMCENTER__SERVICEREQUEST__SRP0RQSTACTIVITYREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <servicerequest/SRP0RqstActivityRevision.hxx>

#include <servicerequest/libservicerequest_exports.h>

namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0RqstActivityRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0RqstActivityRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0RqstActivityRevision;
    }
}
namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0RqstActivityRevisionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SERVICEREQUEST_API Teamcenter_alias::servicerequest::SRP0RqstActivityRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SRP0RqstActivityRevisionDelegate instance
    static SRP0RqstActivityRevisionDelegate&  getInstance();

    //  Method to create the SRP0RqstActivityRevisionImpl pointer
    static SRP0RqstActivityRevisionImpl*  createImpl( SRP0RqstActivityRevision&  ifObj );

    //  Method to delete the SRP0RqstActivityRevisionImpl pointer
    static void deleteImpl( SRP0RqstActivityRevisionImpl*  impl );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const SRP0RqstActivityRevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const SRP0RqstActivityRevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSrp0ParentRequestBase(const SRP0RqstActivityRevision &ifObj,  std::string &value, bool &isNull ) const;



protected:
    //  Pointer to the instance
    static SRP0RqstActivityRevisionDelegate*  m_pInstance;

    SRP0RqstActivityRevisionDelegate();
    virtual ~SRP0RqstActivityRevisionDelegate();
    static void setInstance( SRP0RqstActivityRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::servicerequest::SRP0RqstActivityRevisionGenImpl;

};

#include <servicerequest/libservicerequest_undef.h>
#endif  //  TEAMCENTER__SERVICEREQUEST__SRP0RQSTACTIVITYREVISIONDELEGATE_HXX
