//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SRP0ServiceCatalog
    Filename:   SRP0ServiceCatalog.hxx
    Module:     servicerequest
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEREQUEST__SRP0SERVICECATALOG__HXX
#define TEAMCENTER__SERVICEREQUEST__SRP0SERVICECATALOG__HXX

#include <common/tc_deprecation_macros.h>
#include <mrocore/HierarchicalWSO.hxx>

#include <servicerequest/libservicerequest_exports.h>

namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0ServiceCatalog;
    }
}
namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0ServiceCatalogImpl;
    }
}
namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0ServiceCatalogDelegate;
    }
}
namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0ServiceCatalogDispatch;
    }
}
namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0ServiceCatalogGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEREQUEST_API  Teamcenter::servicerequest::SRP0ServiceCatalog
     : public  ::Teamcenter::mrocore::HierarchicalWSO
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SRP0ServiceCatalog();

    /**
     * Destructor
     */
    virtual ~SRP0ServiceCatalog();

private:
    //  Getter method for the Implementation Object
    SRP0ServiceCatalogImpl*  getSRP0ServiceCatalogImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSRP0ServiceCatalogImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SRP0ServiceCatalogImpl*  m_srp0servicecatalogImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SRP0ServiceCatalog - desc for SRP0ServiceCatalog parameter
     */
    SRP0ServiceCatalog( const SRP0ServiceCatalog& );
    SRP0ServiceCatalog& operator=( const SRP0ServiceCatalog& );

    friend class  SRP0ServiceCatalogDelegate;
    friend class  SRP0ServiceCatalogDispatch;
    friend class  SRP0ServiceCatalogGenImpl;
};

#include <servicerequest/libservicerequest_undef.h>
#endif //   TEAMCENTER__SERVICEREQUEST__SRP0SERVICECATALOG__HXX
