//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SRP0ServiceCatalogDelegate
    Filename:   SRP0ServiceCatalogDelegate.hxx
    Module:     servicerequest
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEREQUEST__SRP0SERVICECATALOGDELEGATE_HXX
#define TEAMCENTER__SERVICEREQUEST__SRP0SERVICECATALOGDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <servicerequest/SRP0ServiceCatalog.hxx>

#include <servicerequest/libservicerequest_exports.h>

namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0ServiceCatalogDelegate;
    }
}
namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0ServiceCatalogImpl;
    }
}
namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0ServiceCatalog;
    }
}
namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0ServiceCatalogGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SERVICEREQUEST_API Teamcenter_alias::servicerequest::SRP0ServiceCatalogDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SRP0ServiceCatalogDelegate instance
    static SRP0ServiceCatalogDelegate&  getInstance();

    //  Method to create the SRP0ServiceCatalogImpl pointer
    static SRP0ServiceCatalogImpl*  createImpl( SRP0ServiceCatalog&  ifObj );

    //  Method to delete the SRP0ServiceCatalogImpl pointer
    static void deleteImpl( SRP0ServiceCatalogImpl*  impl );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const SRP0ServiceCatalog &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const SRP0ServiceCatalog &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static SRP0ServiceCatalogDelegate*  m_pInstance;

    SRP0ServiceCatalogDelegate();
    virtual ~SRP0ServiceCatalogDelegate();
    static void setInstance( SRP0ServiceCatalogDelegate*  instance );


private:
    friend class  ::Teamcenter::servicerequest::SRP0ServiceCatalogGenImpl;

};

#include <servicerequest/libservicerequest_undef.h>
#endif  //  TEAMCENTER__SERVICEREQUEST__SRP0SERVICECATALOGDELEGATE_HXX
