//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SRP0ServiceOffering
    Filename:   SRP0ServiceOffering.hxx
    Module:     servicerequest
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEREQUEST__SRP0SERVICEOFFERING__HXX
#define TEAMCENTER__SERVICEREQUEST__SRP0SERVICEOFFERING__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <mrocore/HierarchicalWSO.hxx>

#include <servicerequest/libservicerequest_exports.h>

namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0ServiceOffering;
    }
}
namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0ServiceOfferingImpl;
    }
}
namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0ServiceOfferingDelegate;
    }
}
namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0ServiceOfferingDispatch;
    }
}
namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0ServiceOfferingGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEREQUEST_API  Teamcenter::servicerequest::SRP0ServiceOffering
     : public  ::Teamcenter::mrocore::HierarchicalWSO
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSrp0ServiceCatalog( tag_t &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SRP0ServiceOffering();

    /**
     * Destructor
     */
    virtual ~SRP0ServiceOffering();

private:
    //  Getter method for the Implementation Object
    SRP0ServiceOfferingImpl*  getSRP0ServiceOfferingImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSRP0ServiceOfferingImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SRP0ServiceOfferingImpl*  m_srp0serviceofferingImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SRP0ServiceOffering - desc for SRP0ServiceOffering parameter
     */
    SRP0ServiceOffering( const SRP0ServiceOffering& );
    SRP0ServiceOffering& operator=( const SRP0ServiceOffering& );

    friend class  SRP0ServiceOfferingDelegate;
    friend class  SRP0ServiceOfferingDispatch;
    friend class  SRP0ServiceOfferingGenImpl;
};

#include <servicerequest/libservicerequest_undef.h>
#endif //   TEAMCENTER__SERVICEREQUEST__SRP0SERVICEOFFERING__HXX
