//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SRP0ServiceOfferingDelegate
    Filename:   SRP0ServiceOfferingDelegate.hxx
    Module:     servicerequest
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEREQUEST__SRP0SERVICEOFFERINGDELEGATE_HXX
#define TEAMCENTER__SERVICEREQUEST__SRP0SERVICEOFFERINGDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <servicerequest/SRP0ServiceOffering.hxx>

#include <servicerequest/libservicerequest_exports.h>

namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0ServiceOfferingDelegate;
    }
}
namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0ServiceOfferingImpl;
    }
}
namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0ServiceOffering;
    }
}
namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0ServiceOfferingGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SERVICEREQUEST_API Teamcenter_alias::servicerequest::SRP0ServiceOfferingDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SRP0ServiceOfferingDelegate instance
    static SRP0ServiceOfferingDelegate&  getInstance();

    //  Method to create the SRP0ServiceOfferingImpl pointer
    static SRP0ServiceOfferingImpl*  createImpl( SRP0ServiceOffering&  ifObj );

    //  Method to delete the SRP0ServiceOfferingImpl pointer
    static void deleteImpl( SRP0ServiceOfferingImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSrp0ServiceCatalogBase(const SRP0ServiceOffering &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const SRP0ServiceOffering &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const SRP0ServiceOffering &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static SRP0ServiceOfferingDelegate*  m_pInstance;

    SRP0ServiceOfferingDelegate();
    virtual ~SRP0ServiceOfferingDelegate();
    static void setInstance( SRP0ServiceOfferingDelegate*  instance );


private:
    friend class  ::Teamcenter::servicerequest::SRP0ServiceOfferingGenImpl;

};

#include <servicerequest/libservicerequest_undef.h>
#endif  //  TEAMCENTER__SERVICEREQUEST__SRP0SERVICEOFFERINGDELEGATE_HXX
