//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SRP0SrvRequestRevision
    Filename:   SRP0SrvRequestRevision.hxx
    Module:     servicerequest
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICEREQUEST__SRP0SRVREQUESTREVISION__HXX
#define TEAMCENTER__SERVICEREQUEST__SRP0SRVREQUESTREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <servicerequest/SRP0GnSrvRequestRevision.hxx>

#include <servicerequest/libservicerequest_exports.h>

namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0SrvRequestRevision;
    }
}
namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0SrvRequestRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0SrvRequestRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0SrvRequestRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace servicerequest
    {
        class SRP0SrvRequestRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SERVICEREQUEST_API  Teamcenter::servicerequest::SRP0SrvRequestRevision
     : public  ::Teamcenter::servicerequest::SRP0GnSrvRequestRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SRP0SrvRequestRevision();

    /**
     * Destructor
     */
    virtual ~SRP0SrvRequestRevision();

private:
    //  Getter method for the Implementation Object
    SRP0SrvRequestRevisionImpl*  getSRP0SrvRequestRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSRP0SrvRequestRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SRP0SrvRequestRevisionImpl*  m_srp0srvrequestrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SRP0SrvRequestRevision - desc for SRP0SrvRequestRevision parameter
     */
    SRP0SrvRequestRevision( const SRP0SrvRequestRevision& );
    SRP0SrvRequestRevision& operator=( const SRP0SrvRequestRevision& );

    friend class  SRP0SrvRequestRevisionDelegate;
    friend class  SRP0SrvRequestRevisionDispatch;
    friend class  SRP0SrvRequestRevisionGenImpl;
};

#include <servicerequest/libservicerequest_undef.h>
#endif //   TEAMCENTER__SERVICEREQUEST__SRP0SRVREQUESTREVISION__HXX
