//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  servicerequest

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libservicerequest

#if !defined(LIBSERVICEREQUEST) && !defined(IPLIB)
#   error IPLIB or LIBSERVICEREQUEST is not defined
#endif

/* Handwritten code should use SERVICEREQUEST_API, not SERVICEREQUESTEXPORT */

#define SERVICEREQUEST_API SERVICEREQUESTEXPORT

#if IPLIB==libservicerequest || defined(LIBSERVICEREQUEST)
#   if defined(__lint)
#       define SERVICEREQUESTEXPORT       __export(servicerequest)
#       define SERVICEREQUESTGLOBAL       extern __global(servicerequest)
#       define SERVICEREQUESTPRIVATE      extern __private(servicerequest)
#   elif defined(_WIN32)
#       define SERVICEREQUESTEXPORT       __declspec(dllexport)
#       define SERVICEREQUESTGLOBAL       extern __declspec(dllexport)
#       define SERVICEREQUESTPRIVATE      extern
#   else
#       define SERVICEREQUESTEXPORT
#       define SERVICEREQUESTGLOBAL       extern
#       define SERVICEREQUESTPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define SERVICEREQUESTEXPORT       __export(servicerequest)
#       define SERVICEREQUESTGLOBAL       extern __global(servicerequest)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define SERVICEREQUESTEXPORT      __declspec(dllimport)
#       define SERVICEREQUESTGLOBAL       extern __declspec(dllimport)
#   else
#       define SERVICEREQUESTEXPORT
#       define SERVICEREQUESTGLOBAL       extern
#   endif
#endif
