//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SM0MadeFrom
    Filename:   SM0MadeFrom.hxx
    Module:     sm0stockmaterial
    @BMIDE autogenerated
==================================================================================================*/

#ifndef STOCKMATERIAL__SM0MADEFROM__HXX
#define STOCKMATERIAL__SM0MADEFROM__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <sm0stockmaterial/libsm0stockmaterial_exports.h>

namespace stockmaterial
{
    class SM0MadeFrom;
}
namespace stockmaterial
{
    class SM0MadeFromImpl;
}
namespace stockmaterial
{
    class SM0MadeFromDelegate;
}
namespace stockmaterial
{
    class SM0MadeFromDispatch;
}
namespace stockmaterial
{
    class SM0MadeFromGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SM0STOCKMATERIAL_API  stockmaterial::SM0MadeFrom
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SM0MadeFrom();

    /**
     * Destructor
     */
    virtual ~SM0MadeFrom();

private:
    //  Getter method for the Implementation Object
    SM0MadeFromImpl*  getSM0MadeFromImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSM0MadeFromImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SM0MadeFromImpl*  m_sm0madefromImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SM0MadeFrom - desc for SM0MadeFrom parameter
     */
    SM0MadeFrom( const SM0MadeFrom& );
    SM0MadeFrom& operator=( const SM0MadeFrom& );

    friend class  SM0MadeFromDelegate;
    friend class  SM0MadeFromDispatch;
    friend class  SM0MadeFromGenImpl;
};

#include <sm0stockmaterial/libsm0stockmaterial_undef.h>
#endif //   STOCKMATERIAL__SM0MADEFROM__HXX
