//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TCX_SCConfig
    Filename:   TCX_SCConfig.hxx
    Module:     smartuibldr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TCX_SCCONFIG__HXX
#define TEAMCENTER__TCX_SCCONFIG__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <smartuibldr/libsmartuibldr_exports.h>

namespace Teamcenter
{
    class TCX_SCConfig;
}
namespace Teamcenter
{
    class TCX_SCConfigImpl;
}
namespace Teamcenter
{
    class TCX_SCConfigDelegate;
}
namespace Teamcenter
{
    class TCX_SCConfigDispatch;
}
namespace Teamcenter
{
    class TCX_SCConfigGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SMARTUIBLDR_API  Teamcenter::TCX_SCConfig
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    TCX_SCConfig();

    /**
     * Destructor
     */
    virtual ~TCX_SCConfig();

private:
    //  Getter method for the Implementation Object
    TCX_SCConfigImpl*  getTCX_SCConfigImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTCX_SCConfigImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    TCX_SCConfigImpl*  m_tcx_scconfigImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param TCX_SCConfig - desc for TCX_SCConfig parameter
     */
    TCX_SCConfig( const TCX_SCConfig& );
    TCX_SCConfig& operator=( const TCX_SCConfig& );

    friend class  TCX_SCConfigDelegate;
    friend class  TCX_SCConfigDispatch;
    friend class  TCX_SCConfigGenImpl;
};

#include <smartuibldr/libsmartuibldr_undef.h>
#endif //   TEAMCENTER__TCX_SCCONFIG__HXX
