//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TCX_SCNumber
    Filename:   TCX_SCNumber.hxx
    Module:     smartuibldr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TCX_SCNUMBER__HXX
#define TEAMCENTER__TCX_SCNUMBER__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <smartuibldr/libsmartuibldr_exports.h>

namespace Teamcenter
{
    class TCX_SCNumber;
}
namespace Teamcenter
{
    class TCX_SCNumberImpl;
}
namespace Teamcenter
{
    class TCX_SCNumberDelegate;
}
namespace Teamcenter
{
    class TCX_SCNumberDispatch;
}
namespace Teamcenter
{
    class TCX_SCNumberGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SMARTUIBLDR_API  Teamcenter::TCX_SCNumber
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    TCX_SCNumber();

    /**
     * Destructor
     */
    virtual ~TCX_SCNumber();

private:
    //  Getter method for the Implementation Object
    TCX_SCNumberImpl*  getTCX_SCNumberImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTCX_SCNumberImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    TCX_SCNumberImpl*  m_tcx_scnumberImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param TCX_SCNumber - desc for TCX_SCNumber parameter
     */
    TCX_SCNumber( const TCX_SCNumber& );
    TCX_SCNumber& operator=( const TCX_SCNumber& );

    friend class  TCX_SCNumberDelegate;
    friend class  TCX_SCNumberDispatch;
    friend class  TCX_SCNumberGenImpl;
};

#include <smartuibldr/libsmartuibldr_undef.h>
#endif //   TEAMCENTER__TCX_SCNUMBER__HXX
