//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TCX_SCSetValue
    Filename:   TCX_SCSetValue.hxx
    Module:     smartuibldr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TCX_SCSETVALUE__HXX
#define TEAMCENTER__TCX_SCSETVALUE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <smartuibldr/libsmartuibldr_exports.h>

namespace Teamcenter
{
    class TCX_SCSetValue;
}
namespace Teamcenter
{
    class TCX_SCSetValueImpl;
}
namespace Teamcenter
{
    class TCX_SCSetValueDelegate;
}
namespace Teamcenter
{
    class TCX_SCSetValueDispatch;
}
namespace Teamcenter
{
    class TCX_SCSetValueGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SMARTUIBLDR_API  Teamcenter::TCX_SCSetValue
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    TCX_SCSetValue();

    /**
     * Destructor
     */
    virtual ~TCX_SCSetValue();

private:
    //  Getter method for the Implementation Object
    TCX_SCSetValueImpl*  getTCX_SCSetValueImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTCX_SCSetValueImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    TCX_SCSetValueImpl*  m_tcx_scsetvalueImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param TCX_SCSetValue - desc for TCX_SCSetValue parameter
     */
    TCX_SCSetValue( const TCX_SCSetValue& );
    TCX_SCSetValue& operator=( const TCX_SCSetValue& );

    friend class  TCX_SCSetValueDelegate;
    friend class  TCX_SCSetValueDispatch;
    friend class  TCX_SCSetValueGenImpl;
};

#include <smartuibldr/libsmartuibldr_undef.h>
#endif //   TEAMCENTER__TCX_SCSETVALUE__HXX
