//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TCX_SCType
    Filename:   TCX_SCType.hxx
    Module:     smartuibldr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TCX_SCTYPE__HXX
#define TEAMCENTER__TCX_SCTYPE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <smartuibldr/libsmartuibldr_exports.h>

namespace Teamcenter
{
    class TCX_SCType;
}
namespace Teamcenter
{
    class TCX_SCTypeImpl;
}
namespace Teamcenter
{
    class TCX_SCTypeDelegate;
}
namespace Teamcenter
{
    class TCX_SCTypeDispatch;
}
namespace Teamcenter
{
    class TCX_SCTypeGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SMARTUIBLDR_API  Teamcenter::TCX_SCType
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    TCX_SCType();

    /**
     * Destructor
     */
    virtual ~TCX_SCType();

private:
    //  Getter method for the Implementation Object
    TCX_SCTypeImpl*  getTCX_SCTypeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTCX_SCTypeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    TCX_SCTypeImpl*  m_tcx_sctypeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param TCX_SCType - desc for TCX_SCType parameter
     */
    TCX_SCType( const TCX_SCType& );
    TCX_SCType& operator=( const TCX_SCType& );

    friend class  TCX_SCTypeDelegate;
    friend class  TCX_SCTypeDispatch;
    friend class  TCX_SCTypeGenImpl;
};

#include <smartuibldr/libsmartuibldr_undef.h>
#endif //   TEAMCENTER__TCX_SCTYPE__HXX
