//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  smartuibldr

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libsmartuibldr

#if !defined(LIBSMARTUIBLDR) && !defined(IPLIB)
#   error IPLIB or LIBSMARTUIBLDR is not defined
#endif

/* Handwritten code should use SMARTUIBLDR_API, not SMARTUIBLDREXPORT */

#define SMARTUIBLDR_API SMARTUIBLDREXPORT

#if IPLIB==libsmartuibldr || defined(LIBSMARTUIBLDR)
#   if defined(__lint)
#       define SMARTUIBLDREXPORT       __export(smartuibldr)
#       define SMARTUIBLDRGLOBAL       extern __global(smartuibldr)
#       define SMARTUIBLDRPRIVATE      extern __private(smartuibldr)
#   elif defined(_WIN32)
#       define SMARTUIBLDREXPORT       __declspec(dllexport)
#       define SMARTUIBLDRGLOBAL       extern __declspec(dllexport)
#       define SMARTUIBLDRPRIVATE      extern
#   else
#       define SMARTUIBLDREXPORT
#       define SMARTUIBLDRGLOBAL       extern
#       define SMARTUIBLDRPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define SMARTUIBLDREXPORT       __export(smartuibldr)
#       define SMARTUIBLDRGLOBAL       extern __global(smartuibldr)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define SMARTUIBLDREXPORT      __declspec(dllimport)
#       define SMARTUIBLDRGLOBAL       extern __declspec(dllimport)
#   else
#       define SMARTUIBLDREXPORT
#       define SMARTUIBLDRGLOBAL       extern
#   endif
#endif
