//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, bldb0
    Filename:   bldb0.hxx
    Module:     sml
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BLDB0__HXX
#define TEAMCENTER__BLDB0__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <sml/libsml_exports.h>

namespace Teamcenter
{
    class bldb0;
}
namespace Teamcenter
{
    class bldb0Impl;
}
namespace Teamcenter
{
    class bldb0Delegate;
}
namespace Teamcenter
{
    class bldb0Dispatch;
}
namespace Teamcenter
{
    class bldb0GenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SML_API  Teamcenter::bldb0
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    bldb0();

    /**
     * Destructor
     */
    virtual ~bldb0();

private:
    //  Getter method for the Implementation Object
    bldb0Impl*  getbldb0Impl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setbldb0Impl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    bldb0Impl*  m_bldb0Impl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param bldb0 - desc for bldb0 parameter
     */
    bldb0( const bldb0& );
    bldb0& operator=( const bldb0& );

    friend class  bldb0Delegate;
    friend class  bldb0Dispatch;
    friend class  bldb0GenImpl;
};

#include <sml/libsml_undef.h>
#endif //   TEAMCENTER__BLDB0__HXX
