//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, bldb0Delegate
    Filename:   bldb0Delegate.hxx
    Module:     sml
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BLDB0DELEGATE_HXX
#define TEAMCENTER__BLDB0DELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <sml/bldb0.hxx>

#include <sml/libsml_exports.h>

namespace Teamcenter
{
    class bldb0Delegate;
}
namespace Teamcenter
{
    class bldb0Impl;
}
namespace Teamcenter
{
    class bldb0;
}
namespace Teamcenter
{
    class bldb0GenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  SML_API Teamcenter_alias::bldb0Delegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the bldb0Delegate instance
    static bldb0Delegate&  getInstance();

    //  Method to create the bldb0Impl pointer
    static bldb0Impl*  createImpl( bldb0&  ifObj );

    //  Method to delete the bldb0Impl pointer
    static void deleteImpl( bldb0Impl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static bldb0Delegate*  m_pInstance;

    bldb0Delegate();
    virtual ~bldb0Delegate();
    static void setInstance( bldb0Delegate*  instance );


private:
    friend class  ::Teamcenter::bldb0GenImpl;

};

#include <sml/libsml_undef.h>
#endif  //  TEAMCENTER__BLDB0DELEGATE_HXX
