//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, icm0
    Filename:   icm0.hxx
    Module:     sml
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ICM0__HXX
#define TEAMCENTER__ICM0__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <sml/libsml_exports.h>

namespace Teamcenter
{
    class icm0;
}
namespace Teamcenter
{
    class icm0Impl;
}
namespace Teamcenter
{
    class icm0Delegate;
}
namespace Teamcenter
{
    class icm0Dispatch;
}
namespace Teamcenter
{
    class icm0GenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SML_API  Teamcenter::icm0
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    icm0();

    /**
     * Destructor
     */
    virtual ~icm0();

private:
    //  Getter method for the Implementation Object
    icm0Impl*  geticm0Impl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  seticm0Impl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    icm0Impl*  m_icm0Impl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param icm0 - desc for icm0 parameter
     */
    icm0( const icm0& );
    icm0& operator=( const icm0& );

    friend class  icm0Delegate;
    friend class  icm0Dispatch;
    friend class  icm0GenImpl;
};

#include <sml/libsml_undef.h>
#endif //   TEAMCENTER__ICM0__HXX
