//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  sml

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libsml

#if !defined(LIBSML) && !defined(IPLIB)
#   error IPLIB or LIBSML is not defined
#endif

/* Handwritten code should use SML_API, not SMLEXPORT */

#define SML_API SMLEXPORT

#if IPLIB==libsml || defined(LIBSML)
#   if defined(__lint)
#       define SMLEXPORT       __export(sml)
#       define SMLGLOBAL       extern __global(sml)
#       define SMLPRIVATE      extern __private(sml)
#   elif defined(_WIN32)
#       define SMLEXPORT       __declspec(dllexport)
#       define SMLGLOBAL       extern __declspec(dllexport)
#       define SMLPRIVATE      extern
#   else
#       define SMLEXPORT
#       define SMLGLOBAL       extern
#       define SMLPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define SMLEXPORT       __export(sml)
#       define SMLGLOBAL       extern __global(sml)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define SMLEXPORT      __declspec(dllimport)
#       define SMLGLOBAL       extern __declspec(dllimport)
#   else
#       define SMLEXPORT
#       define SMLGLOBAL       extern
#   endif
#endif
