//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, smlb0
    Filename:   smlb0.hxx
    Module:     sml
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SMLB0__HXX
#define TEAMCENTER__SMLB0__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <sml/libsml_exports.h>

namespace Teamcenter
{
    class smlb0;
}
namespace Teamcenter
{
    class smlb0Impl;
}
namespace Teamcenter
{
    class smlb0Delegate;
}
namespace Teamcenter
{
    class smlb0Dispatch;
}
namespace Teamcenter
{
    class smlb0GenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SML_API  Teamcenter::smlb0
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    smlb0();

    /**
     * Destructor
     */
    virtual ~smlb0();

private:
    //  Getter method for the Implementation Object
    smlb0Impl*  getsmlb0Impl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setsmlb0Impl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    smlb0Impl*  m_smlb0Impl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param smlb0 - desc for smlb0 parameter
     */
    smlb0( const smlb0& );
    smlb0& operator=( const smlb0& );

    friend class  smlb0Delegate;
    friend class  smlb0Dispatch;
    friend class  smlb0GenImpl;
};

#include <sml/libsml_undef.h>
#endif //   TEAMCENTER__SMLB0__HXX
