//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, smlb0Delegate
    Filename:   smlb0Delegate.hxx
    Module:     sml
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SMLB0DELEGATE_HXX
#define TEAMCENTER__SMLB0DELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <sml/smlb0.hxx>

#include <sml/libsml_exports.h>

namespace Teamcenter
{
    class smlb0Delegate;
}
namespace Teamcenter
{
    class smlb0Impl;
}
namespace Teamcenter
{
    class smlb0;
}
namespace Teamcenter
{
    class smlb0GenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  SML_API Teamcenter_alias::smlb0Delegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the smlb0Delegate instance
    static smlb0Delegate&  getInstance();

    //  Method to create the smlb0Impl pointer
    static smlb0Impl*  createImpl( smlb0&  ifObj );

    //  Method to delete the smlb0Impl pointer
    static void deleteImpl( smlb0Impl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const smlb0 &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// validate saveas input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  validateSaveAsInputBase(const smlb0 &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static smlb0Delegate*  m_pInstance;

    smlb0Delegate();
    virtual ~smlb0Delegate();
    static void setInstance( smlb0Delegate*  instance );


private:
    friend class  ::Teamcenter::smlb0GenImpl;

};

#include <sml/libsml_undef.h>
#endif  //  TEAMCENTER__SMLB0DELEGATE_HXX
