//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPBOM
    Filename:   CPBOM.hxx
    Module:     specmgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECMGR__CPBOM__HXX
#define TEAMCENTER__SPECMGR__CPBOM__HXX

#include <common/tc_deprecation_macros.h>
#include <req/SpecElement.hxx>

#include <specmgr/libspecmgr_exports.h>

namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPBOM;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPBOMImpl;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPBOMDelegate;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPBOMDispatch;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPBOMGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SPECMGR_API  Teamcenter::SPECMGR::CPBOM
     : public  ::Teamcenter::SpecElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CPBOM();

    /**
     * Destructor
     */
    virtual ~CPBOM();

private:
    //  Getter method for the Implementation Object
    CPBOMImpl*  getCPBOMImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCPBOMImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CPBOMImpl*  m_cpbomImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CPBOM - desc for CPBOM parameter
     */
    CPBOM( const CPBOM& );
    CPBOM& operator=( const CPBOM& );

    friend class  CPBOMDelegate;
    friend class  CPBOMDispatch;
    friend class  CPBOMGenImpl;
};

#include <specmgr/libspecmgr_undef.h>
#endif //   TEAMCENTER__SPECMGR__CPBOM__HXX
