//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPBOMRevisionDelegate
    Filename:   CPBOMRevisionDelegate.hxx
    Module:     specmgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECMGR__CPBOMREVISIONDELEGATE_HXX
#define TEAMCENTER__SPECMGR__CPBOMREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <specmgr/CPBOMRevision.hxx>

#include <specmgr/libspecmgr_exports.h>

namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPBOMRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPBOMRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPBOMRevision;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPBOMRevisionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SPECMGR_API Teamcenter_alias::SPECMGR::CPBOMRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CPBOMRevisionDelegate instance
    static CPBOMRevisionDelegate&  getInstance();

    //  Method to create the CPBOMRevisionImpl pointer
    static CPBOMRevisionImpl*  createImpl( CPBOMRevision&  ifObj );

    //  Method to delete the CPBOMRevisionImpl pointer
    static void deleteImpl( CPBOMRevisionImpl*  impl );


    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBase_quantityBase(const CPBOMRevision &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMax_quantityBase(const CPBOMRevision &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMin_quantityBase(const CPBOMRevision &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getOther_uomBase(const CPBOMRevision &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getProperty_list_formatBase(const CPBOMRevision &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setBase_quantityBase(CPBOMRevision &ifObj,  double value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMax_quantityBase(CPBOMRevision &ifObj,  double value, bool isNull );


    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMin_quantityBase(CPBOMRevision &ifObj,  double value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setOther_uomBase(CPBOMRevision &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setProperty_list_formatBase(CPBOMRevision &ifObj,  const tag_t &value, bool isNull );



protected:
    //  Pointer to the instance
    static CPBOMRevisionDelegate*  m_pInstance;

    CPBOMRevisionDelegate();
    virtual ~CPBOMRevisionDelegate();
    static void setInstance( CPBOMRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::SPECMGR::CPBOMRevisionGenImpl;

};

#include <specmgr/libspecmgr_undef.h>
#endif  //  TEAMCENTER__SPECMGR__CPBOMREVISIONDELEGATE_HXX
