//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPComponent
    Filename:   CPComponent.hxx
    Module:     specmgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECMGR__CPCOMPONENT__HXX
#define TEAMCENTER__SPECMGR__CPCOMPONENT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <specmgr/libspecmgr_exports.h>

namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPComponent;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPComponentImpl;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPComponentDelegate;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPComponentDispatch;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPComponentGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SPECMGR_API  Teamcenter::SPECMGR::CPComponent
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CPComponent();

    /**
     * Destructor
     */
    virtual ~CPComponent();

private:
    //  Getter method for the Implementation Object
    CPComponentImpl*  getCPComponentImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCPComponentImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CPComponentImpl*  m_cpcomponentImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CPComponent - desc for CPComponent parameter
     */
    CPComponent( const CPComponent& );
    CPComponent& operator=( const CPComponent& );

    friend class  CPComponentDelegate;
    friend class  CPComponentDispatch;
    friend class  CPComponentGenImpl;
};

#include <specmgr/libspecmgr_undef.h>
#endif //   TEAMCENTER__SPECMGR__CPCOMPONENT__HXX
