//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPComponentList
    Filename:   CPComponentList.hxx
    Module:     specmgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECMGR__CPCOMPONENTLIST__HXX
#define TEAMCENTER__SPECMGR__CPCOMPONENTLIST__HXX

#include <common/tc_deprecation_macros.h>
#include <req/SpecElement.hxx>

#include <specmgr/libspecmgr_exports.h>

namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPComponentList;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPComponentListImpl;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPComponentListDelegate;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPComponentListDispatch;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPComponentListGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SPECMGR_API  Teamcenter::SPECMGR::CPComponentList
     : public  ::Teamcenter::SpecElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CPComponentList();

    /**
     * Destructor
     */
    virtual ~CPComponentList();

private:
    //  Getter method for the Implementation Object
    CPComponentListImpl*  getCPComponentListImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCPComponentListImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CPComponentListImpl*  m_cpcomponentlistImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CPComponentList - desc for CPComponentList parameter
     */
    CPComponentList( const CPComponentList& );
    CPComponentList& operator=( const CPComponentList& );

    friend class  CPComponentListDelegate;
    friend class  CPComponentListDispatch;
    friend class  CPComponentListGenImpl;
};

#include <specmgr/libspecmgr_undef.h>
#endif //   TEAMCENTER__SPECMGR__CPCOMPONENTLIST__HXX
