//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPComponentListRevision
    Filename:   CPComponentListRevision.hxx
    Module:     specmgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECMGR__CPCOMPONENTLISTREVISION__HXX
#define TEAMCENTER__SPECMGR__CPCOMPONENTLISTREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <req/SpecElementRevision.hxx>

#include <specmgr/libspecmgr_exports.h>

namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPComponentListRevision;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPComponentListRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPComponentListRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPComponentListRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPComponentListRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SPECMGR_API  Teamcenter::SPECMGR::CPComponentListRevision
     : public  ::Teamcenter::SpecElementRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CPComponentListRevision();

    /**
     * Destructor
     */
    virtual ~CPComponentListRevision();

private:
    //  Getter method for the Implementation Object
    CPComponentListRevisionImpl*  getCPComponentListRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCPComponentListRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CPComponentListRevisionImpl*  m_cpcomponentlistrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CPComponentListRevision - desc for CPComponentListRevision parameter
     */
    CPComponentListRevision( const CPComponentListRevision& );
    CPComponentListRevision& operator=( const CPComponentListRevision& );

    friend class  CPComponentListRevisionDelegate;
    friend class  CPComponentListRevisionDispatch;
    friend class  CPComponentListRevisionGenImpl;
};

#include <specmgr/libspecmgr_undef.h>
#endif //   TEAMCENTER__SPECMGR__CPCOMPONENTLISTREVISION__HXX
