//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPComponentRevision
    Filename:   CPComponentRevision.hxx
    Module:     specmgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECMGR__CPCOMPONENTREVISION__HXX
#define TEAMCENTER__SPECMGR__CPCOMPONENTREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <specmgr/libspecmgr_exports.h>

namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPComponentRevision;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPComponentRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPComponentRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPComponentRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPComponentRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SPECMGR_API  Teamcenter::SPECMGR::CPComponentRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CPComponentRevision();

    /**
     * Destructor
     */
    virtual ~CPComponentRevision();

private:
    //  Getter method for the Implementation Object
    CPComponentRevisionImpl*  getCPComponentRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCPComponentRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CPComponentRevisionImpl*  m_cpcomponentrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CPComponentRevision - desc for CPComponentRevision parameter
     */
    CPComponentRevision( const CPComponentRevision& );
    CPComponentRevision& operator=( const CPComponentRevision& );

    friend class  CPComponentRevisionDelegate;
    friend class  CPComponentRevisionDispatch;
    friend class  CPComponentRevisionGenImpl;
};

#include <specmgr/libspecmgr_undef.h>
#endif //   TEAMCENTER__SPECMGR__CPCOMPONENTREVISION__HXX
