//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPFreeText
    Filename:   CPFreeText.hxx
    Module:     specmgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECMGR__CPFREETEXT__HXX
#define TEAMCENTER__SPECMGR__CPFREETEXT__HXX

#include <common/tc_deprecation_macros.h>
#include <req/Paragraph.hxx>

#include <specmgr/libspecmgr_exports.h>

namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPFreeText;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPFreeTextImpl;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPFreeTextDelegate;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPFreeTextDispatch;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPFreeTextGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SPECMGR_API  Teamcenter::SPECMGR::CPFreeText
     : public  ::Teamcenter::Paragraph
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CPFreeText();

    /**
     * Destructor
     */
    virtual ~CPFreeText();

private:
    //  Getter method for the Implementation Object
    CPFreeTextImpl*  getCPFreeTextImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCPFreeTextImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CPFreeTextImpl*  m_cpfreetextImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CPFreeText - desc for CPFreeText parameter
     */
    CPFreeText( const CPFreeText& );
    CPFreeText& operator=( const CPFreeText& );

    friend class  CPFreeTextDelegate;
    friend class  CPFreeTextDispatch;
    friend class  CPFreeTextGenImpl;
};

#include <specmgr/libspecmgr_undef.h>
#endif //   TEAMCENTER__SPECMGR__CPFREETEXT__HXX
