//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPFreeTextRevision
    Filename:   CPFreeTextRevision.hxx
    Module:     specmgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECMGR__CPFREETEXTREVISION__HXX
#define TEAMCENTER__SPECMGR__CPFREETEXTREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <req/Paragraph_0_Revision_alt.hxx>

#include <specmgr/libspecmgr_exports.h>

namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPFreeTextRevision;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPFreeTextRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPFreeTextRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPFreeTextRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPFreeTextRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SPECMGR_API  Teamcenter::SPECMGR::CPFreeTextRevision
     : public  ::Teamcenter::Paragraph_0_Revision_alt
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CPFreeTextRevision();

    /**
     * Destructor
     */
    virtual ~CPFreeTextRevision();

private:
    //  Getter method for the Implementation Object
    CPFreeTextRevisionImpl*  getCPFreeTextRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCPFreeTextRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CPFreeTextRevisionImpl*  m_cpfreetextrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CPFreeTextRevision - desc for CPFreeTextRevision parameter
     */
    CPFreeTextRevision( const CPFreeTextRevision& );
    CPFreeTextRevision& operator=( const CPFreeTextRevision& );

    friend class  CPFreeTextRevisionDelegate;
    friend class  CPFreeTextRevisionDispatch;
    friend class  CPFreeTextRevisionGenImpl;
};

#include <specmgr/libspecmgr_undef.h>
#endif //   TEAMCENTER__SPECMGR__CPFREETEXTREVISION__HXX
