//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPKeywordDelegate
    Filename:   CPKeywordDelegate.hxx
    Module:     specmgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECMGR__CPKEYWORDDELEGATE_HXX
#define TEAMCENTER__SPECMGR__CPKEYWORDDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <specmgr/CPKeyword.hxx>

#include <specmgr/libspecmgr_exports.h>

namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPKeywordDelegate;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPKeywordImpl;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPKeyword;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPKeywordGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SPECMGR_API Teamcenter_alias::SPECMGR::CPKeywordDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CPKeywordDelegate instance
    static CPKeywordDelegate&  getInstance();

    //  Method to create the CPKeywordImpl pointer
    static CPKeywordImpl*  createImpl( CPKeyword&  ifObj );

    //  Method to delete the CPKeywordImpl pointer
    static void deleteImpl( CPKeywordImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIs_fixedBase(const CPKeyword &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getKeyword_valueBase(const CPKeyword &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a Boolean Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIs_fixedBase(CPKeyword &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setKeyword_valueBase(CPKeyword &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static CPKeywordDelegate*  m_pInstance;

    CPKeywordDelegate();
    virtual ~CPKeywordDelegate();
    static void setInstance( CPKeywordDelegate*  instance );


private:
    friend class  ::Teamcenter::SPECMGR::CPKeywordGenImpl;

};

#include <specmgr/libspecmgr_undef.h>
#endif  //  TEAMCENTER__SPECMGR__CPKEYWORDDELEGATE_HXX
