//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPManufacturer
    Filename:   CPManufacturer.hxx
    Module:     specmgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECMGR__CPMANUFACTURER__HXX
#define TEAMCENTER__SPECMGR__CPMANUFACTURER__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <specmgr/libspecmgr_exports.h>

namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPManufacturer;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPManufacturerImpl;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPManufacturerDelegate;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPManufacturerDispatch;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPManufacturerGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SPECMGR_API  Teamcenter::SPECMGR::CPManufacturer
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CPManufacturer();

    /**
     * Destructor
     */
    virtual ~CPManufacturer();

private:
    //  Getter method for the Implementation Object
    CPManufacturerImpl*  getCPManufacturerImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCPManufacturerImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CPManufacturerImpl*  m_cpmanufacturerImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CPManufacturer - desc for CPManufacturer parameter
     */
    CPManufacturer( const CPManufacturer& );
    CPManufacturer& operator=( const CPManufacturer& );

    friend class  CPManufacturerDelegate;
    friend class  CPManufacturerDispatch;
    friend class  CPManufacturerGenImpl;
};

#include <specmgr/libspecmgr_undef.h>
#endif //   TEAMCENTER__SPECMGR__CPMANUFACTURER__HXX
