//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPPlant
    Filename:   CPPlant.hxx
    Module:     specmgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECMGR__CPPLANT__HXX
#define TEAMCENTER__SPECMGR__CPPLANT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <specmgr/libspecmgr_exports.h>

namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPPlant;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPPlantImpl;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPPlantDelegate;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPPlantDispatch;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPPlantGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SPECMGR_API  Teamcenter::SPECMGR::CPPlant
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CPPlant();

    /**
     * Destructor
     */
    virtual ~CPPlant();

private:
    //  Getter method for the Implementation Object
    CPPlantImpl*  getCPPlantImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCPPlantImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CPPlantImpl*  m_cpplantImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CPPlant - desc for CPPlant parameter
     */
    CPPlant( const CPPlant& );
    CPPlant& operator=( const CPPlant& );

    friend class  CPPlantDelegate;
    friend class  CPPlantDispatch;
    friend class  CPPlantGenImpl;
};

#include <specmgr/libspecmgr_undef.h>
#endif //   TEAMCENTER__SPECMGR__CPPLANT__HXX
