//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPProcLine
    Filename:   CPProcLine.hxx
    Module:     specmgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECMGR__CPPROCLINE__HXX
#define TEAMCENTER__SPECMGR__CPPROCLINE__HXX

#include <common/tc_deprecation_macros.h>
#include <req/SpecElement.hxx>

#include <specmgr/libspecmgr_exports.h>

namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPProcLine;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPProcLineImpl;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPProcLineDelegate;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPProcLineDispatch;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPProcLineGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SPECMGR_API  Teamcenter::SPECMGR::CPProcLine
     : public  ::Teamcenter::SpecElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CPProcLine();

    /**
     * Destructor
     */
    virtual ~CPProcLine();

private:
    //  Getter method for the Implementation Object
    CPProcLineImpl*  getCPProcLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCPProcLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CPProcLineImpl*  m_cpproclineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CPProcLine - desc for CPProcLine parameter
     */
    CPProcLine( const CPProcLine& );
    CPProcLine& operator=( const CPProcLine& );

    friend class  CPProcLineDelegate;
    friend class  CPProcLineDispatch;
    friend class  CPProcLineGenImpl;
};

#include <specmgr/libspecmgr_undef.h>
#endif //   TEAMCENTER__SPECMGR__CPPROCLINE__HXX
