//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPProcLineRevisionDelegate
    Filename:   CPProcLineRevisionDelegate.hxx
    Module:     specmgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECMGR__CPPROCLINEREVISIONDELEGATE_HXX
#define TEAMCENTER__SPECMGR__CPPROCLINEREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <specmgr/CPProcLineRevision.hxx>

#include <specmgr/libspecmgr_exports.h>

namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPProcLineRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPProcLineRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPProcLineRevision;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPProcLineRevisionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SPECMGR_API Teamcenter_alias::SPECMGR::CPProcLineRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CPProcLineRevisionDelegate instance
    static CPProcLineRevisionDelegate&  getInstance();

    //  Method to create the CPProcLineRevisionImpl pointer
    static CPProcLineRevisionImpl*  createImpl( CPProcLineRevision&  ifObj );

    //  Method to delete the CPProcLineRevisionImpl pointer
    static void deleteImpl( CPProcLineRevisionImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPlantBase(const CPProcLineRevision &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSpecificationBase(const CPProcLineRevision &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPlantBase(CPProcLineRevision &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSpecificationBase(CPProcLineRevision &ifObj,  const tag_t &value, bool isNull );



protected:
    //  Pointer to the instance
    static CPProcLineRevisionDelegate*  m_pInstance;

    CPProcLineRevisionDelegate();
    virtual ~CPProcLineRevisionDelegate();
    static void setInstance( CPProcLineRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::SPECMGR::CPProcLineRevisionGenImpl;

};

#include <specmgr/libspecmgr_undef.h>
#endif  //  TEAMCENTER__SPECMGR__CPPROCLINEREVISIONDELEGATE_HXX
