//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPProcStage
    Filename:   CPProcStage.hxx
    Module:     specmgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECMGR__CPPROCSTAGE__HXX
#define TEAMCENTER__SPECMGR__CPPROCSTAGE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <specmgr/libspecmgr_exports.h>

namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPProcStage;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPProcStageImpl;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPProcStageDelegate;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPProcStageDispatch;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPProcStageGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SPECMGR_API  Teamcenter::SPECMGR::CPProcStage
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CPProcStage();

    /**
     * Destructor
     */
    virtual ~CPProcStage();

private:
    //  Getter method for the Implementation Object
    CPProcStageImpl*  getCPProcStageImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCPProcStageImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CPProcStageImpl*  m_cpprocstageImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CPProcStage - desc for CPProcStage parameter
     */
    CPProcStage( const CPProcStage& );
    CPProcStage& operator=( const CPProcStage& );

    friend class  CPProcStageDelegate;
    friend class  CPProcStageDispatch;
    friend class  CPProcStageGenImpl;
};

#include <specmgr/libspecmgr_undef.h>
#endif //   TEAMCENTER__SPECMGR__CPPROCSTAGE__HXX
