//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPProcStageRevisionDelegate
    Filename:   CPProcStageRevisionDelegate.hxx
    Module:     specmgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECMGR__CPPROCSTAGEREVISIONDELEGATE_HXX
#define TEAMCENTER__SPECMGR__CPPROCSTAGEREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <specmgr/CPProcStageRevision.hxx>

#include <specmgr/libspecmgr_exports.h>

namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPProcStageRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPProcStageRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPProcStageRevision;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPProcStageRevisionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SPECMGR_API Teamcenter_alias::SPECMGR::CPProcStageRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CPProcStageRevisionDelegate instance
    static CPProcStageRevisionDelegate&  getInstance();

    //  Method to create the CPProcStageRevisionImpl pointer
    static CPProcStageRevisionImpl*  createImpl( CPProcStageRevision&  ifObj );

    //  Method to delete the CPProcStageRevisionImpl pointer
    static void deleteImpl( CPProcStageRevisionImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getParent_lineBase(const CPProcStageRevision &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getProperty_list_formatBase(const CPProcStageRevision &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRecirculate_toBase(const CPProcStageRevision &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSequence_numberBase(const CPProcStageRevision &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setParent_lineBase(CPProcStageRevision &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setProperty_list_formatBase(CPProcStageRevision &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setRecirculate_toBase(CPProcStageRevision &ifObj,  int value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSequence_numberBase(CPProcStageRevision &ifObj,  int value, bool isNull );



protected:
    //  Pointer to the instance
    static CPProcStageRevisionDelegate*  m_pInstance;

    CPProcStageRevisionDelegate();
    virtual ~CPProcStageRevisionDelegate();
    static void setInstance( CPProcStageRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::SPECMGR::CPProcStageRevisionGenImpl;

};

#include <specmgr/libspecmgr_undef.h>
#endif  //  TEAMCENTER__SPECMGR__CPPROCSTAGEREVISIONDELEGATE_HXX
