//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPProperty
    Filename:   CPProperty.hxx
    Module:     specmgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECMGR__CPPROPERTY__HXX
#define TEAMCENTER__SPECMGR__CPPROPERTY__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <specmgr/libspecmgr_exports.h>

namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPProperty;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPPropertyImpl;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPPropertyDelegate;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPPropertyDispatch;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPPropertyGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SPECMGR_API  Teamcenter::SPECMGR::CPProperty
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CPProperty();

    /**
     * Destructor
     */
    virtual ~CPProperty();

private:
    //  Getter method for the Implementation Object
    CPPropertyImpl*  getCPPropertyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCPPropertyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CPPropertyImpl*  m_cppropertyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CPProperty - desc for CPProperty parameter
     */
    CPProperty( const CPProperty& );
    CPProperty& operator=( const CPProperty& );

    friend class  CPPropertyDelegate;
    friend class  CPPropertyDispatch;
    friend class  CPPropertyGenImpl;
};

#include <specmgr/libspecmgr_undef.h>
#endif //   TEAMCENTER__SPECMGR__CPPROPERTY__HXX
