//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPPropertyList
    Filename:   CPPropertyList.hxx
    Module:     specmgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECMGR__CPPROPERTYLIST__HXX
#define TEAMCENTER__SPECMGR__CPPROPERTYLIST__HXX

#include <common/tc_deprecation_macros.h>
#include <req/SpecElement.hxx>

#include <specmgr/libspecmgr_exports.h>

namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPPropertyList;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPPropertyListImpl;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPPropertyListDelegate;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPPropertyListDispatch;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPPropertyListGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SPECMGR_API  Teamcenter::SPECMGR::CPPropertyList
     : public  ::Teamcenter::SpecElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CPPropertyList();

    /**
     * Destructor
     */
    virtual ~CPPropertyList();

private:
    //  Getter method for the Implementation Object
    CPPropertyListImpl*  getCPPropertyListImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCPPropertyListImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CPPropertyListImpl*  m_cppropertylistImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CPPropertyList - desc for CPPropertyList parameter
     */
    CPPropertyList( const CPPropertyList& );
    CPPropertyList& operator=( const CPPropertyList& );

    friend class  CPPropertyListDelegate;
    friend class  CPPropertyListDispatch;
    friend class  CPPropertyListGenImpl;
};

#include <specmgr/libspecmgr_undef.h>
#endif //   TEAMCENTER__SPECMGR__CPPROPERTYLIST__HXX
