//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPPropertyListColumnDelegate
    Filename:   CPPropertyListColumnDelegate.hxx
    Module:     specmgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECMGR__CPPROPERTYLISTCOLUMNDELEGATE_HXX
#define TEAMCENTER__SPECMGR__CPPROPERTYLISTCOLUMNDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <specmgr/CPPropertyListColumn.hxx>

#include <specmgr/libspecmgr_exports.h>

namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPPropertyListColumnDelegate;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPPropertyListColumnImpl;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPPropertyListColumn;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPPropertyListColumnGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SPECMGR_API Teamcenter_alias::SPECMGR::CPPropertyListColumnDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CPPropertyListColumnDelegate instance
    static CPPropertyListColumnDelegate&  getInstance();

    //  Method to create the CPPropertyListColumnImpl pointer
    static CPPropertyListColumnImpl*  createImpl( CPPropertyListColumn&  ifObj );

    //  Method to delete the CPPropertyListColumnImpl pointer
    static void deleteImpl( CPPropertyListColumnImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDisplay_nameBase(const CPPropertyListColumn &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getParent_formatBase(const CPPropertyListColumn &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSequence_noBase(const CPPropertyListColumn &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getStorage_classBase(const CPPropertyListColumn &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getStorage_columnBase(const CPPropertyListColumn &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDisplay_nameBase(CPPropertyListColumn &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setParent_formatBase(CPPropertyListColumn &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSequence_noBase(CPPropertyListColumn &ifObj,  int value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setStorage_classBase(CPPropertyListColumn &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setStorage_columnBase(CPPropertyListColumn &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static CPPropertyListColumnDelegate*  m_pInstance;

    CPPropertyListColumnDelegate();
    virtual ~CPPropertyListColumnDelegate();
    static void setInstance( CPPropertyListColumnDelegate*  instance );


private:
    friend class  ::Teamcenter::SPECMGR::CPPropertyListColumnGenImpl;

};

#include <specmgr/libspecmgr_undef.h>
#endif  //  TEAMCENTER__SPECMGR__CPPROPERTYLISTCOLUMNDELEGATE_HXX
