//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPPropertyListFormatDelegate
    Filename:   CPPropertyListFormatDelegate.hxx
    Module:     specmgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECMGR__CPPROPERTYLISTFORMATDELEGATE_HXX
#define TEAMCENTER__SPECMGR__CPPROPERTYLISTFORMATDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <specmgr/CPPropertyListFormat.hxx>

#include <specmgr/libspecmgr_exports.h>

namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPPropertyListFormatDelegate;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPPropertyListFormatImpl;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPPropertyListFormat;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPPropertyListFormatGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SPECMGR_API Teamcenter_alias::SPECMGR::CPPropertyListFormatDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CPPropertyListFormatDelegate instance
    static CPPropertyListFormatDelegate&  getInstance();

    //  Method to create the CPPropertyListFormatImpl pointer
    static CPPropertyListFormatImpl*  createImpl( CPPropertyListFormat&  ifObj );

    //  Method to delete the CPPropertyListFormatImpl pointer
    static void deleteImpl( CPPropertyListFormatImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFormat_idBase(const CPPropertyListFormat &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFormat_nameBase(const CPPropertyListFormat &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFormat_idBase(CPPropertyListFormat &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFormat_nameBase(CPPropertyListFormat &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static CPPropertyListFormatDelegate*  m_pInstance;

    CPPropertyListFormatDelegate();
    virtual ~CPPropertyListFormatDelegate();
    static void setInstance( CPPropertyListFormatDelegate*  instance );


private:
    friend class  ::Teamcenter::SPECMGR::CPPropertyListFormatGenImpl;

};

#include <specmgr/libspecmgr_undef.h>
#endif  //  TEAMCENTER__SPECMGR__CPPROPERTYLISTFORMATDELEGATE_HXX
