//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPPropertyListRevision
    Filename:   CPPropertyListRevision.hxx
    Module:     specmgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECMGR__CPPROPERTYLISTREVISION__HXX
#define TEAMCENTER__SPECMGR__CPPROPERTYLISTREVISION__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <req/SpecElementRevision.hxx>

#include <specmgr/libspecmgr_exports.h>

namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPPropertyListRevision;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPPropertyListRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPPropertyListRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPPropertyListRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPPropertyListRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SPECMGR_API  Teamcenter::SPECMGR::CPPropertyListRevision
     : public  ::Teamcenter::SpecElementRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getProperty_list_format( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setProperty_list_format( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CPPropertyListRevision();

    /**
     * Destructor
     */
    virtual ~CPPropertyListRevision();

private:
    //  Getter method for the Implementation Object
    CPPropertyListRevisionImpl*  getCPPropertyListRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCPPropertyListRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CPPropertyListRevisionImpl*  m_cppropertylistrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CPPropertyListRevision - desc for CPPropertyListRevision parameter
     */
    CPPropertyListRevision( const CPPropertyListRevision& );
    CPPropertyListRevision& operator=( const CPPropertyListRevision& );

    friend class  CPPropertyListRevisionDelegate;
    friend class  CPPropertyListRevisionDispatch;
    friend class  CPPropertyListRevisionGenImpl;
};

#include <specmgr/libspecmgr_undef.h>
#endif //   TEAMCENTER__SPECMGR__CPPROPERTYLISTREVISION__HXX
