//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPPropertyListRevisionDelegate
    Filename:   CPPropertyListRevisionDelegate.hxx
    Module:     specmgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECMGR__CPPROPERTYLISTREVISIONDELEGATE_HXX
#define TEAMCENTER__SPECMGR__CPPROPERTYLISTREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <specmgr/CPPropertyListRevision.hxx>

#include <specmgr/libspecmgr_exports.h>

namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPPropertyListRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPPropertyListRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPPropertyListRevision;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPPropertyListRevisionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SPECMGR_API Teamcenter_alias::SPECMGR::CPPropertyListRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CPPropertyListRevisionDelegate instance
    static CPPropertyListRevisionDelegate&  getInstance();

    //  Method to create the CPPropertyListRevisionImpl pointer
    static CPPropertyListRevisionImpl*  createImpl( CPPropertyListRevision&  ifObj );

    //  Method to delete the CPPropertyListRevisionImpl pointer
    static void deleteImpl( CPPropertyListRevisionImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getProperty_list_formatBase(const CPPropertyListRevision &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setProperty_list_formatBase(CPPropertyListRevision &ifObj,  const tag_t &value, bool isNull );



protected:
    //  Pointer to the instance
    static CPPropertyListRevisionDelegate*  m_pInstance;

    CPPropertyListRevisionDelegate();
    virtual ~CPPropertyListRevisionDelegate();
    static void setInstance( CPPropertyListRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::SPECMGR::CPPropertyListRevisionGenImpl;

};

#include <specmgr/libspecmgr_undef.h>
#endif  //  TEAMCENTER__SPECMGR__CPPROPERTYLISTREVISIONDELEGATE_HXX
