//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPPropertyRevision
    Filename:   CPPropertyRevision.hxx
    Module:     specmgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECMGR__CPPROPERTYREVISION__HXX
#define TEAMCENTER__SPECMGR__CPPROPERTYREVISION__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <specmgr/libspecmgr_exports.h>

namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPPropertyRevision;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPPropertyRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPPropertyRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPPropertyRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPPropertyRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SPECMGR_API  Teamcenter::SPECMGR::CPPropertyRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getParent_property_group( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSequence_number( int &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setParent_property_group( const tag_t &value, bool isNull=false );

    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSequence_number( int value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CPPropertyRevision();

    /**
     * Destructor
     */
    virtual ~CPPropertyRevision();

private:
    //  Getter method for the Implementation Object
    CPPropertyRevisionImpl*  getCPPropertyRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCPPropertyRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CPPropertyRevisionImpl*  m_cppropertyrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CPPropertyRevision - desc for CPPropertyRevision parameter
     */
    CPPropertyRevision( const CPPropertyRevision& );
    CPPropertyRevision& operator=( const CPPropertyRevision& );

    friend class  CPPropertyRevisionDelegate;
    friend class  CPPropertyRevisionDispatch;
    friend class  CPPropertyRevisionGenImpl;
};

#include <specmgr/libspecmgr_undef.h>
#endif //   TEAMCENTER__SPECMGR__CPPROPERTYREVISION__HXX
