//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPPropertyRevisionDelegate
    Filename:   CPPropertyRevisionDelegate.hxx
    Module:     specmgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECMGR__CPPROPERTYREVISIONDELEGATE_HXX
#define TEAMCENTER__SPECMGR__CPPROPERTYREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <specmgr/CPPropertyRevision.hxx>

#include <specmgr/libspecmgr_exports.h>

namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPPropertyRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPPropertyRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPPropertyRevision;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPPropertyRevisionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SPECMGR_API Teamcenter_alias::SPECMGR::CPPropertyRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CPPropertyRevisionDelegate instance
    static CPPropertyRevisionDelegate&  getInstance();

    //  Method to create the CPPropertyRevisionImpl pointer
    static CPPropertyRevisionImpl*  createImpl( CPPropertyRevision&  ifObj );

    //  Method to delete the CPPropertyRevisionImpl pointer
    static void deleteImpl( CPPropertyRevisionImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getParent_property_groupBase(const CPPropertyRevision &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSequence_numberBase(const CPPropertyRevision &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setParent_property_groupBase(CPPropertyRevision &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSequence_numberBase(CPPropertyRevision &ifObj,  int value, bool isNull );



protected:
    //  Pointer to the instance
    static CPPropertyRevisionDelegate*  m_pInstance;

    CPPropertyRevisionDelegate();
    virtual ~CPPropertyRevisionDelegate();
    static void setInstance( CPPropertyRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::SPECMGR::CPPropertyRevisionGenImpl;

};

#include <specmgr/libspecmgr_undef.h>
#endif  //  TEAMCENTER__SPECMGR__CPPROPERTYREVISIONDELEGATE_HXX
