//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPRefObject
    Filename:   CPRefObject.hxx
    Module:     specmgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECMGR__CPREFOBJECT__HXX
#define TEAMCENTER__SPECMGR__CPREFOBJECT__HXX

#include <common/tc_deprecation_macros.h>
#include <req/SpecElement.hxx>

#include <specmgr/libspecmgr_exports.h>

namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPRefObject;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPRefObjectImpl;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPRefObjectDelegate;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPRefObjectDispatch;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPRefObjectGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SPECMGR_API  Teamcenter::SPECMGR::CPRefObject
     : public  ::Teamcenter::SpecElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CPRefObject();

    /**
     * Destructor
     */
    virtual ~CPRefObject();

private:
    //  Getter method for the Implementation Object
    CPRefObjectImpl*  getCPRefObjectImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCPRefObjectImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CPRefObjectImpl*  m_cprefobjectImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CPRefObject - desc for CPRefObject parameter
     */
    CPRefObject( const CPRefObject& );
    CPRefObject& operator=( const CPRefObject& );

    friend class  CPRefObjectDelegate;
    friend class  CPRefObjectDispatch;
    friend class  CPRefObjectGenImpl;
};

#include <specmgr/libspecmgr_undef.h>
#endif //   TEAMCENTER__SPECMGR__CPREFOBJECT__HXX
