//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPRefObjectRevision
    Filename:   CPRefObjectRevision.hxx
    Module:     specmgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECMGR__CPREFOBJECTREVISION__HXX
#define TEAMCENTER__SPECMGR__CPREFOBJECTREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <req/SpecElementRevision.hxx>

#include <specmgr/libspecmgr_exports.h>

namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPRefObjectRevision;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPRefObjectRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPRefObjectRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPRefObjectRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPRefObjectRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SPECMGR_API  Teamcenter::SPECMGR::CPRefObjectRevision
     : public  ::Teamcenter::SpecElementRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CPRefObjectRevision();

    /**
     * Destructor
     */
    virtual ~CPRefObjectRevision();

private:
    //  Getter method for the Implementation Object
    CPRefObjectRevisionImpl*  getCPRefObjectRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCPRefObjectRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CPRefObjectRevisionImpl*  m_cprefobjectrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CPRefObjectRevision - desc for CPRefObjectRevision parameter
     */
    CPRefObjectRevision( const CPRefObjectRevision& );
    CPRefObjectRevision& operator=( const CPRefObjectRevision& );

    friend class  CPRefObjectRevisionDelegate;
    friend class  CPRefObjectRevisionDispatch;
    friend class  CPRefObjectRevisionGenImpl;
};

#include <specmgr/libspecmgr_undef.h>
#endif //   TEAMCENTER__SPECMGR__CPREFOBJECTREVISION__HXX
