//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPRefSpec
    Filename:   CPRefSpec.hxx
    Module:     specmgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECMGR__CPREFSPEC__HXX
#define TEAMCENTER__SPECMGR__CPREFSPEC__HXX

#include <common/tc_deprecation_macros.h>
#include <req/SpecElement.hxx>

#include <specmgr/libspecmgr_exports.h>

namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPRefSpec;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPRefSpecImpl;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPRefSpecDelegate;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPRefSpecDispatch;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPRefSpecGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SPECMGR_API  Teamcenter::SPECMGR::CPRefSpec
     : public  ::Teamcenter::SpecElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CPRefSpec();

    /**
     * Destructor
     */
    virtual ~CPRefSpec();

private:
    //  Getter method for the Implementation Object
    CPRefSpecImpl*  getCPRefSpecImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCPRefSpecImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CPRefSpecImpl*  m_cprefspecImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CPRefSpec - desc for CPRefSpec parameter
     */
    CPRefSpec( const CPRefSpec& );
    CPRefSpec& operator=( const CPRefSpec& );

    friend class  CPRefSpecDelegate;
    friend class  CPRefSpecDispatch;
    friend class  CPRefSpecGenImpl;
};

#include <specmgr/libspecmgr_undef.h>
#endif //   TEAMCENTER__SPECMGR__CPREFSPEC__HXX
