//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPRefSpecRevisionDelegate
    Filename:   CPRefSpecRevisionDelegate.hxx
    Module:     specmgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECMGR__CPREFSPECREVISIONDELEGATE_HXX
#define TEAMCENTER__SPECMGR__CPREFSPECREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <specmgr/CPRefSpecRevision.hxx>

#include <specmgr/libspecmgr_exports.h>

namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPRefSpecRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPRefSpecRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPRefSpecRevision;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPRefSpecRevisionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SPECMGR_API Teamcenter_alias::SPECMGR::CPRefSpecRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CPRefSpecRevisionDelegate instance
    static CPRefSpecRevisionDelegate&  getInstance();

    //  Method to create the CPRefSpecRevisionImpl pointer
    static CPRefSpecRevisionImpl*  createImpl( CPRefSpecRevision&  ifObj );

    //  Method to delete the CPRefSpecRevisionImpl pointer
    static void deleteImpl( CPRefSpecRevisionImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSpecificationBase(const CPRefSpecRevision &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSpecificationBase(CPRefSpecRevision &ifObj,  const tag_t &value, bool isNull );



protected:
    //  Pointer to the instance
    static CPRefSpecRevisionDelegate*  m_pInstance;

    CPRefSpecRevisionDelegate();
    virtual ~CPRefSpecRevisionDelegate();
    static void setInstance( CPRefSpecRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::SPECMGR::CPRefSpecRevisionGenImpl;

};

#include <specmgr/libspecmgr_undef.h>
#endif  //  TEAMCENTER__SPECMGR__CPREFSPECREVISIONDELEGATE_HXX
