//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPRefText
    Filename:   CPRefText.hxx
    Module:     specmgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECMGR__CPREFTEXT__HXX
#define TEAMCENTER__SPECMGR__CPREFTEXT__HXX

#include <common/tc_deprecation_macros.h>
#include <req/Paragraph.hxx>

#include <specmgr/libspecmgr_exports.h>

namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPRefText;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPRefTextImpl;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPRefTextDelegate;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPRefTextDispatch;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPRefTextGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SPECMGR_API  Teamcenter::SPECMGR::CPRefText
     : public  ::Teamcenter::Paragraph
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CPRefText();

    /**
     * Destructor
     */
    virtual ~CPRefText();

private:
    //  Getter method for the Implementation Object
    CPRefTextImpl*  getCPRefTextImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCPRefTextImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CPRefTextImpl*  m_cpreftextImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CPRefText - desc for CPRefText parameter
     */
    CPRefText( const CPRefText& );
    CPRefText& operator=( const CPRefText& );

    friend class  CPRefTextDelegate;
    friend class  CPRefTextDispatch;
    friend class  CPRefTextGenImpl;
};

#include <specmgr/libspecmgr_undef.h>
#endif //   TEAMCENTER__SPECMGR__CPREFTEXT__HXX
