//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPRefTextRevision
    Filename:   CPRefTextRevision.hxx
    Module:     specmgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECMGR__CPREFTEXTREVISION__HXX
#define TEAMCENTER__SPECMGR__CPREFTEXTREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <req/Paragraph_0_Revision_alt.hxx>

#include <specmgr/libspecmgr_exports.h>

namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPRefTextRevision;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPRefTextRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPRefTextRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPRefTextRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPRefTextRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SPECMGR_API  Teamcenter::SPECMGR::CPRefTextRevision
     : public  ::Teamcenter::Paragraph_0_Revision_alt
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CPRefTextRevision();

    /**
     * Destructor
     */
    virtual ~CPRefTextRevision();

private:
    //  Getter method for the Implementation Object
    CPRefTextRevisionImpl*  getCPRefTextRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCPRefTextRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CPRefTextRevisionImpl*  m_cpreftextrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CPRefTextRevision - desc for CPRefTextRevision parameter
     */
    CPRefTextRevision( const CPRefTextRevision& );
    CPRefTextRevision& operator=( const CPRefTextRevision& );

    friend class  CPRefTextRevisionDelegate;
    friend class  CPRefTextRevisionDispatch;
    friend class  CPRefTextRevisionGenImpl;
};

#include <specmgr/libspecmgr_undef.h>
#endif //   TEAMCENTER__SPECMGR__CPREFTEXTREVISION__HXX
