//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPSpecSection
    Filename:   CPSpecSection.hxx
    Module:     specmgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECMGR__CPSPECSECTION__HXX
#define TEAMCENTER__SPECMGR__CPSPECSECTION__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <req/SpecElement.hxx>

#include <specmgr/libspecmgr_exports.h>

namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPSpecSection;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPSpecSectionImpl;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPSpecSectionDelegate;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPSpecSectionDispatch;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPSpecSectionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SPECMGR_API  Teamcenter::SPECMGR::CPSpecSection
     : public  ::Teamcenter::SpecElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getParent_specification( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setParent_specification( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CPSpecSection();

    /**
     * Destructor
     */
    virtual ~CPSpecSection();

private:
    //  Getter method for the Implementation Object
    CPSpecSectionImpl*  getCPSpecSectionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCPSpecSectionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CPSpecSectionImpl*  m_cpspecsectionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CPSpecSection - desc for CPSpecSection parameter
     */
    CPSpecSection( const CPSpecSection& );
    CPSpecSection& operator=( const CPSpecSection& );

    friend class  CPSpecSectionDelegate;
    friend class  CPSpecSectionDispatch;
    friend class  CPSpecSectionGenImpl;
};

#include <specmgr/libspecmgr_undef.h>
#endif //   TEAMCENTER__SPECMGR__CPSPECSECTION__HXX
