//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPSpecSectionDelegate
    Filename:   CPSpecSectionDelegate.hxx
    Module:     specmgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECMGR__CPSPECSECTIONDELEGATE_HXX
#define TEAMCENTER__SPECMGR__CPSPECSECTIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <specmgr/CPSpecSection.hxx>

#include <specmgr/libspecmgr_exports.h>

namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPSpecSectionDelegate;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPSpecSectionImpl;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPSpecSection;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPSpecSectionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SPECMGR_API Teamcenter_alias::SPECMGR::CPSpecSectionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CPSpecSectionDelegate instance
    static CPSpecSectionDelegate&  getInstance();

    //  Method to create the CPSpecSectionImpl pointer
    static CPSpecSectionImpl*  createImpl( CPSpecSection&  ifObj );

    //  Method to delete the CPSpecSectionImpl pointer
    static void deleteImpl( CPSpecSectionImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getParent_specificationBase(const CPSpecSection &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setParent_specificationBase(CPSpecSection &ifObj,  const tag_t &value, bool isNull );



protected:
    //  Pointer to the instance
    static CPSpecSectionDelegate*  m_pInstance;

    CPSpecSectionDelegate();
    virtual ~CPSpecSectionDelegate();
    static void setInstance( CPSpecSectionDelegate*  instance );


private:
    friend class  ::Teamcenter::SPECMGR::CPSpecSectionGenImpl;

};

#include <specmgr/libspecmgr_undef.h>
#endif  //  TEAMCENTER__SPECMGR__CPSPECSECTIONDELEGATE_HXX
