//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPSpecSectionRevision
    Filename:   CPSpecSectionRevision.hxx
    Module:     specmgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECMGR__CPSPECSECTIONREVISION__HXX
#define TEAMCENTER__SPECMGR__CPSPECSECTIONREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <req/SpecElementRevision.hxx>

#include <specmgr/libspecmgr_exports.h>

namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPSpecSectionRevision;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPSpecSectionRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPSpecSectionRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPSpecSectionRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPSpecSectionRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SPECMGR_API  Teamcenter::SPECMGR::CPSpecSectionRevision
     : public  ::Teamcenter::SpecElementRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CPSpecSectionRevision();

    /**
     * Destructor
     */
    virtual ~CPSpecSectionRevision();

private:
    //  Getter method for the Implementation Object
    CPSpecSectionRevisionImpl*  getCPSpecSectionRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCPSpecSectionRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CPSpecSectionRevisionImpl*  m_cpspecsectionrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CPSpecSectionRevision - desc for CPSpecSectionRevision parameter
     */
    CPSpecSectionRevision( const CPSpecSectionRevision& );
    CPSpecSectionRevision& operator=( const CPSpecSectionRevision& );

    friend class  CPSpecSectionRevisionDelegate;
    friend class  CPSpecSectionRevisionDispatch;
    friend class  CPSpecSectionRevisionGenImpl;
};

#include <specmgr/libspecmgr_undef.h>
#endif //   TEAMCENTER__SPECMGR__CPSPECSECTIONREVISION__HXX
