//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPSpecTypeDelegate
    Filename:   CPSpecTypeDelegate.hxx
    Module:     specmgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECMGR__CPSPECTYPEDELEGATE_HXX
#define TEAMCENTER__SPECMGR__CPSPECTYPEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <specmgr/CPSpecType.hxx>

#include <specmgr/libspecmgr_exports.h>

namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPSpecTypeDelegate;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPSpecTypeImpl;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPSpecType;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPSpecTypeGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SPECMGR_API Teamcenter_alias::SPECMGR::CPSpecTypeDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CPSpecTypeDelegate instance
    static CPSpecTypeDelegate&  getInstance();

    //  Method to create the CPSpecTypeImpl pointer
    static CPSpecTypeImpl*  createImpl( CPSpecType&  ifObj );

    //  Method to delete the CPSpecTypeImpl pointer
    static void deleteImpl( CPSpecTypeImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getType_descriptionBase(const CPSpecType &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getType_nameBase(const CPSpecType &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setType_descriptionBase(CPSpecType &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setType_nameBase(CPSpecType &ifObj,  const std::string &value, bool isNull );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getObject_stringBase(const CPSpecType &ifObj,  std::string &value, bool &isNull ) const;



protected:
    //  Pointer to the instance
    static CPSpecTypeDelegate*  m_pInstance;

    CPSpecTypeDelegate();
    virtual ~CPSpecTypeDelegate();
    static void setInstance( CPSpecTypeDelegate*  instance );


private:
    friend class  ::Teamcenter::SPECMGR::CPSpecTypeGenImpl;

};

#include <specmgr/libspecmgr_undef.h>
#endif  //  TEAMCENTER__SPECMGR__CPSPECTYPEDELEGATE_HXX
