//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPSpecificationDelegate
    Filename:   CPSpecificationDelegate.hxx
    Module:     specmgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECMGR__CPSPECIFICATIONDELEGATE_HXX
#define TEAMCENTER__SPECMGR__CPSPECIFICATIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <specmgr/CPSpecification.hxx>

#include <specmgr/libspecmgr_exports.h>

namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPSpecificationDelegate;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPSpecificationImpl;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPSpecification;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPSpecificationGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SPECMGR_API Teamcenter_alias::SPECMGR::CPSpecificationDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CPSpecificationDelegate instance
    static CPSpecificationDelegate&  getInstance();

    //  Method to create the CPSpecificationImpl pointer
    static CPSpecificationImpl*  createImpl( CPSpecification&  ifObj );

    //  Method to delete the CPSpecificationImpl pointer
    static void deleteImpl( CPSpecificationImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAuthoring_systemBase(const CPSpecification &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSpec_typeBase(const CPSpecification &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAuthoring_systemBase(CPSpecification &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSpec_typeBase(CPSpecification &ifObj,  const tag_t &value, bool isNull );



protected:
    //  Pointer to the instance
    static CPSpecificationDelegate*  m_pInstance;

    CPSpecificationDelegate();
    virtual ~CPSpecificationDelegate();
    static void setInstance( CPSpecificationDelegate*  instance );


private:
    friend class  ::Teamcenter::SPECMGR::CPSpecificationGenImpl;

};

#include <specmgr/libspecmgr_undef.h>
#endif  //  TEAMCENTER__SPECMGR__CPSPECIFICATIONDELEGATE_HXX
