//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPSpecificationRevisionDelegate
    Filename:   CPSpecificationRevisionDelegate.hxx
    Module:     specmgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECMGR__CPSPECIFICATIONREVISIONDELEGATE_HXX
#define TEAMCENTER__SPECMGR__CPSPECIFICATIONREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <specmgr/CPSpecificationRevision.hxx>

#include <specmgr/libspecmgr_exports.h>

namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPSpecificationRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPSpecificationRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPSpecificationRevision;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPSpecificationRevisionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SPECMGR_API Teamcenter_alias::SPECMGR::CPSpecificationRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CPSpecificationRevisionDelegate instance
    static CPSpecificationRevisionDelegate&  getInstance();

    //  Method to create the CPSpecificationRevisionImpl pointer
    static CPSpecificationRevisionImpl*  createImpl( CPSpecificationRevision&  ifObj );

    //  Method to delete the CPSpecificationRevisionImpl pointer
    static void deleteImpl( CPSpecificationRevisionImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getAuthoring_systemBase(const CPSpecificationRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getBase_uomBase(const CPSpecificationRevision &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Tc 8
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getKeywordsBase(const CPSpecificationRevision &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Tc 8
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getManufacturersBase(const CPSpecificationRevision &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Tc 8
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getOther_uomBase(const CPSpecificationRevision &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Tc 8
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getPlantsBase(const CPSpecificationRevision &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSpec_typeBase(const CPSpecificationRevision &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setAuthoring_systemBase(CPSpecificationRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setBase_uomBase(CPSpecificationRevision &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Tc 8
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setKeywordsBase(CPSpecificationRevision &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Tc 8
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setManufacturersBase(CPSpecificationRevision &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Tc 8
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setOther_uomBase(CPSpecificationRevision &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Tc 8
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setPlantsBase(CPSpecificationRevision &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSpec_typeBase(CPSpecificationRevision &ifObj,  const tag_t &value, bool isNull );



protected:
    //  Pointer to the instance
    static CPSpecificationRevisionDelegate*  m_pInstance;

    CPSpecificationRevisionDelegate();
    virtual ~CPSpecificationRevisionDelegate();
    static void setInstance( CPSpecificationRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::SPECMGR::CPSpecificationRevisionGenImpl;

};

#include <specmgr/libspecmgr_undef.h>
#endif  //  TEAMCENTER__SPECMGR__CPSPECIFICATIONREVISIONDELEGATE_HXX
