//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPSynonym
    Filename:   CPSynonym.hxx
    Module:     specmgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECMGR__CPSYNONYM__HXX
#define TEAMCENTER__SPECMGR__CPSYNONYM__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <specmgr/libspecmgr_exports.h>

namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPSynonym;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPSynonymImpl;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPSynonymDelegate;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPSynonymDispatch;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPSynonymGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SPECMGR_API  Teamcenter::SPECMGR::CPSynonym
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CPSynonym();

    /**
     * Destructor
     */
    virtual ~CPSynonym();

private:
    //  Getter method for the Implementation Object
    CPSynonymImpl*  getCPSynonymImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCPSynonymImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CPSynonymImpl*  m_cpsynonymImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CPSynonym - desc for CPSynonym parameter
     */
    CPSynonym( const CPSynonym& );
    CPSynonym& operator=( const CPSynonym& );

    friend class  CPSynonymDelegate;
    friend class  CPSynonymDispatch;
    friend class  CPSynonymGenImpl;
};

#include <specmgr/libspecmgr_undef.h>
#endif //   TEAMCENTER__SPECMGR__CPSYNONYM__HXX
