//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CPSynonymRevision
    Filename:   CPSynonymRevision.hxx
    Module:     specmgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECMGR__CPSYNONYMREVISION__HXX
#define TEAMCENTER__SPECMGR__CPSYNONYMREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <specmgr/libspecmgr_exports.h>

namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPSynonymRevision;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPSynonymRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPSynonymRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPSynonymRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class CPSynonymRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SPECMGR_API  Teamcenter::SPECMGR::CPSynonymRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CPSynonymRevision();

    /**
     * Destructor
     */
    virtual ~CPSynonymRevision();

private:
    //  Getter method for the Implementation Object
    CPSynonymRevisionImpl*  getCPSynonymRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCPSynonymRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CPSynonymRevisionImpl*  m_cpsynonymrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CPSynonymRevision - desc for CPSynonymRevision parameter
     */
    CPSynonymRevision( const CPSynonymRevision& );
    CPSynonymRevision& operator=( const CPSynonymRevision& );

    friend class  CPSynonymRevisionDelegate;
    friend class  CPSynonymRevisionDispatch;
    friend class  CPSynonymRevisionGenImpl;
};

#include <specmgr/libspecmgr_undef.h>
#endif //   TEAMCENTER__SPECMGR__CPSYNONYMREVISION__HXX
