//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, UOMWithConversion
    Filename:   UOMWithConversion.hxx
    Module:     specmgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECMGR__UOMWITHCONVERSION__HXX
#define TEAMCENTER__SPECMGR__UOMWITHCONVERSION__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <specmgr/libspecmgr_exports.h>

namespace Teamcenter
{
    namespace SPECMGR
    {
        class UOMWithConversion;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class UOMWithConversionImpl;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class UOMWithConversionDelegate;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class UOMWithConversionDispatch;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class UOMWithConversionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SPECMGR_API  Teamcenter::SPECMGR::UOMWithConversion
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getConversion_factor( double &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getUom( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setConversion_factor( double value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setUom( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    UOMWithConversion();

    /**
     * Destructor
     */
    virtual ~UOMWithConversion();

private:
    //  Getter method for the Implementation Object
    UOMWithConversionImpl*  getUOMWithConversionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setUOMWithConversionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    UOMWithConversionImpl*  m_uomwithconversionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param UOMWithConversion - desc for UOMWithConversion parameter
     */
    UOMWithConversion( const UOMWithConversion& );
    UOMWithConversion& operator=( const UOMWithConversion& );

    friend class  UOMWithConversionDelegate;
    friend class  UOMWithConversionDispatch;
    friend class  UOMWithConversionGenImpl;
};

#include <specmgr/libspecmgr_undef.h>
#endif //   TEAMCENTER__SPECMGR__UOMWITHCONVERSION__HXX
