//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, UOMWithConversionDelegate
    Filename:   UOMWithConversionDelegate.hxx
    Module:     specmgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SPECMGR__UOMWITHCONVERSIONDELEGATE_HXX
#define TEAMCENTER__SPECMGR__UOMWITHCONVERSIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <specmgr/UOMWithConversion.hxx>

#include <specmgr/libspecmgr_exports.h>

namespace Teamcenter
{
    namespace SPECMGR
    {
        class UOMWithConversionDelegate;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class UOMWithConversionImpl;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class UOMWithConversion;
    }
}
namespace Teamcenter
{
    namespace SPECMGR
    {
        class UOMWithConversionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SPECMGR_API Teamcenter_alias::SPECMGR::UOMWithConversionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the UOMWithConversionDelegate instance
    static UOMWithConversionDelegate&  getInstance();

    //  Method to create the UOMWithConversionImpl pointer
    static UOMWithConversionImpl*  createImpl( UOMWithConversion&  ifObj );

    //  Method to delete the UOMWithConversionImpl pointer
    static void deleteImpl( UOMWithConversionImpl*  impl );


    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getConversion_factorBase(const UOMWithConversion &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getUomBase(const UOMWithConversion &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setConversion_factorBase(UOMWithConversion &ifObj,  double value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setUomBase(UOMWithConversion &ifObj,  const tag_t &value, bool isNull );



protected:
    //  Pointer to the instance
    static UOMWithConversionDelegate*  m_pInstance;

    UOMWithConversionDelegate();
    virtual ~UOMWithConversionDelegate();
    static void setInstance( UOMWithConversionDelegate*  instance );


private:
    friend class  ::Teamcenter::SPECMGR::UOMWithConversionGenImpl;

};

#include <specmgr/libspecmgr_undef.h>
#endif  //  TEAMCENTER__SPECMGR__UOMWITHCONVERSIONDELEGATE_HXX
