//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  specmgr

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libspecmgr

#if !defined(LIBSPECMGR) && !defined(IPLIB)
#   error IPLIB or LIBSPECMGR is not defined
#endif

/* Handwritten code should use SPECMGR_API, not SPECMGREXPORT */

#define SPECMGR_API SPECMGREXPORT

#if IPLIB==libspecmgr || defined(LIBSPECMGR)
#   if defined(__lint)
#       define SPECMGREXPORT       __export(specmgr)
#       define SPECMGRGLOBAL       extern __global(specmgr)
#       define SPECMGRPRIVATE      extern __private(specmgr)
#   elif defined(_WIN32)
#       define SPECMGREXPORT       __declspec(dllexport)
#       define SPECMGRGLOBAL       extern __declspec(dllexport)
#       define SPECMGRPRIVATE      extern
#   else
#       define SPECMGREXPORT
#       define SPECMGRGLOBAL       extern
#       define SPECMGRPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define SPECMGREXPORT       __export(specmgr)
#       define SPECMGRGLOBAL       extern __global(specmgr)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define SPECMGREXPORT      __declspec(dllimport)
#       define SPECMGRGLOBAL       extern __declspec(dllimport)
#   else
#       define SPECMGREXPORT
#       define SPECMGRGLOBAL       extern
#   endif
#endif
