//Copyright 2020 Siemens Digital Industries Software
//==================================================
//
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  specmgrdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libspecmgrdispatch

#if !defined(LIBSPECMGRDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBSPECMGRDISPATCH is not defined
#endif

/* Handwritten code should use SPECMGRDISPATCH_API, not SPECMGRDISPATCHEXPORT */

#define SPECMGRDISPATCH_API SPECMGRDISPATCHEXPORT

#if IPLIB==libspecmgrdispatch || defined(LIBSPECMGRDISPATCH)
#   if defined(__lint)
#       define SPECMGRDISPATCHEXPORT       __export(specmgrdispatch)
#       define SPECMGRDISPATCHGLOBAL       extern __global(specmgrdispatch)
#       define SPECMGRDISPATCHPRIVATE      extern __private(specmgrdispatch)
#   elif defined(_WIN32)
#       define SPECMGRDISPATCHEXPORT       __declspec(dllexport)
#       define SPECMGRDISPATCHGLOBAL       extern __declspec(dllexport)
#       define SPECMGRDISPATCHPRIVATE      extern
#   else
#       define SPECMGRDISPATCHEXPORT
#       define SPECMGRDISPATCHGLOBAL       extern
#       define SPECMGRDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define SPECMGRDISPATCHEXPORT       __export(specmgrdispatch)
#       define SPECMGRDISPATCHGLOBAL       extern __global(specmgrdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define SPECMGRDISPATCHEXPORT      __declspec(dllimport)
#       define SPECMGRDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define SPECMGRDISPATCHEXPORT
#       define SPECMGRDISPATCHGLOBAL       extern
#   endif
#endif
