//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SPI0ResultsIn
    Filename:   SPI0ResultsIn.hxx
    Module:     sspspralignment
    @BMIDE autogenerated
==================================================================================================*/

#ifndef SSPSPRALIGNMENT__SPI0RESULTSIN__HXX
#define SSPSPRALIGNMENT__SPI0RESULTSIN__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <sspspralignment/libsspspralignment_exports.h>

namespace sspspralignment
{
    class SPI0ResultsIn;
}
namespace sspspralignment
{
    class SPI0ResultsInImpl;
}
namespace sspspralignment
{
    class SPI0ResultsInDelegate;
}
namespace sspspralignment
{
    class SPI0ResultsInDispatch;
}
namespace sspspralignment
{
    class SPI0ResultsInGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SSPSPRALIGNMENT_API  sspspralignment::SPI0ResultsIn
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SPI0ResultsIn();

    /**
     * Destructor
     */
    virtual ~SPI0ResultsIn();

private:
    //  Getter method for the Implementation Object
    SPI0ResultsInImpl*  getSPI0ResultsInImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSPI0ResultsInImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SPI0ResultsInImpl*  m_spi0resultsinImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SPI0ResultsIn - desc for SPI0ResultsIn parameter
     */
    SPI0ResultsIn( const SPI0ResultsIn& );
    SPI0ResultsIn& operator=( const SPI0ResultsIn& );

    friend class  SPI0ResultsInDelegate;
    friend class  SPI0ResultsInDispatch;
    friend class  SPI0ResultsInGenImpl;
};

#include <sspspralignment/libsspspralignment_undef.h>
#endif //   SSPSPRALIGNMENT__SPI0RESULTSIN__HXX
