//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  sspspralignment

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libsspspralignment

#if !defined(LIBSSPSPRALIGNMENT) && !defined(IPLIB)
#   error IPLIB or LIBSSPSPRALIGNMENT is not defined
#endif

/* Handwritten code should use SSPSPRALIGNMENT_API, not SSPSPRALIGNMENTEXPORT */

#define SSPSPRALIGNMENT_API SSPSPRALIGNMENTEXPORT

#if IPLIB==libsspspralignment || defined(LIBSSPSPRALIGNMENT)
#   if defined(__lint)
#       define SSPSPRALIGNMENTEXPORT       __export(sspspralignment)
#       define SSPSPRALIGNMENTGLOBAL       extern __global(sspspralignment)
#       define SSPSPRALIGNMENTPRIVATE      extern __private(sspspralignment)
#   elif defined(_WIN32)
#       define SSPSPRALIGNMENTEXPORT       __declspec(dllexport)
#       define SSPSPRALIGNMENTGLOBAL       extern __declspec(dllexport)
#       define SSPSPRALIGNMENTPRIVATE      extern
#   else
#       define SSPSPRALIGNMENTEXPORT
#       define SSPSPRALIGNMENTGLOBAL       extern
#       define SSPSPRALIGNMENTPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define SSPSPRALIGNMENTEXPORT       __export(sspspralignment)
#       define SSPSPRALIGNMENTGLOBAL       extern __global(sspspralignment)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define SSPSPRALIGNMENTEXPORT      __declspec(dllimport)
#       define SSPSPRALIGNMENTGLOBAL       extern __declspec(dllimport)
#   else
#       define SSPSPRALIGNMENTEXPORT
#       define SSPSPRALIGNMENTGLOBAL       extern
#   endif
#endif
