//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSS0DiscrepancyDiscovered
    Filename:   SSS0DiscrepancyDiscovered.hxx
    Module:     sss0svcscheduling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICESCHEDULING__SSS0DISCREPANCYDISCOVERED__HXX
#define TEAMCENTER__SERVICESCHEDULING__SSS0DISCREPANCYDISCOVERED__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <sss0svcscheduling/libsss0svcscheduling_exports.h>

namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0DiscrepancyDiscovered;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0DiscrepancyDiscoveredImpl;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0DiscrepancyDiscoveredDelegate;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0DiscrepancyDiscoveredDispatch;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0DiscrepancyDiscoveredGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SSS0SVCSCHEDULING_API  Teamcenter::servicescheduling::SSS0DiscrepancyDiscovered
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SSS0DiscrepancyDiscovered();

    /**
     * Destructor
     */
    virtual ~SSS0DiscrepancyDiscovered();

private:
    //  Getter method for the Implementation Object
    SSS0DiscrepancyDiscoveredImpl*  getSSS0DiscrepancyDiscoveredImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSSS0DiscrepancyDiscoveredImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SSS0DiscrepancyDiscoveredImpl*  m_sss0discrepancydiscoveredImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SSS0DiscrepancyDiscovered - desc for SSS0DiscrepancyDiscovered parameter
     */
    SSS0DiscrepancyDiscovered( const SSS0DiscrepancyDiscovered& );
    SSS0DiscrepancyDiscovered& operator=( const SSS0DiscrepancyDiscovered& );

    friend class  SSS0DiscrepancyDiscoveredDelegate;
    friend class  SSS0DiscrepancyDiscoveredDispatch;
    friend class  SSS0DiscrepancyDiscoveredGenImpl;
};

#include <sss0svcscheduling/libsss0svcscheduling_undef.h>
#endif //   TEAMCENTER__SERVICESCHEDULING__SSS0DISCREPANCYDISCOVERED__HXX
