//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSS0JobActivity
    Filename:   SSS0JobActivity.hxx
    Module:     sss0svcscheduling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICESCHEDULING__SSS0JOBACTIVITY__HXX
#define TEAMCENTER__SERVICESCHEDULING__SSS0JOBACTIVITY__HXX

#include <unidefs.h>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <schmgt/Fnd0GnWOTask.hxx>

#include <sss0svcscheduling/libsss0svcscheduling_exports.h>

namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobActivity;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobActivityImpl;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobActivityDelegate;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobActivityDispatch;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobActivityGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SSS0SVCSCHEDULING_API  Teamcenter::servicescheduling::SSS0JobActivity
     : public  ::Teamcenter::Fnd0GnWOTask
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getSss0Assignments( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getSss0CorrectedDiscrepancy( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getSss0RequiredResources( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getSss0Utilization( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Performs Physical Configuration updates based on the Part Movements and Upgrades defined on the Task. This is a recursive call that will perform the updates for the Task Structue below.
    /// @version Teamcenter 11.1
    /// @param configDate - Performs Physical Configuration updates based on the Part Movements and Upgrades defined on the Task. This is a recursive call that will perform the updates for the Task Structue below.
    /// @return - Error code if any
    ///
    int  sss0UpdateConfiguration( date_t configDate );

    ///
    /// Validate whether the Job Activity has related Characteric Values.
    /// @version Teamcenter 11.1
    /// @param result - Validate whether the Job Activity has related Characteric Values.
    /// @return - 1 or 0
    ///
    int  sss0ValidateCharacteristicValues( bool *result );

    ///
    /// Validate whether the Job Activity has part movements.
    /// @version Teamcenter 11.1
    /// @param result - Validate whether the Job Activity has part movements.
    /// @return - 1 or 0
    ///
    int  sss0ValidatePartsMoved( bool *result );

    ///
    /// To check if the characteristic values are recorded for attached characteristic definition.
    /// @version Teamcenter 11.1
    /// @param result - To check if the characteristic values are recorded for attached characteristic definition.
    /// @return - Returns the status
    ///
    int  sss0ValidateUtilizationRecorded( bool *result );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SSS0JobActivity();

    /**
     * Destructor
     */
    virtual ~SSS0JobActivity();

private:
    //  Getter method for the Implementation Object
    SSS0JobActivityImpl*  getSSS0JobActivityImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSSS0JobActivityImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SSS0JobActivityImpl*  m_sss0jobactivityImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SSS0JobActivity - desc for SSS0JobActivity parameter
     */
    SSS0JobActivity( const SSS0JobActivity& );
    SSS0JobActivity& operator=( const SSS0JobActivity& );

    friend class  SSS0JobActivityDelegate;
    friend class  SSS0JobActivityDispatch;
    friend class  SSS0JobActivityGenImpl;
};

#include <sss0svcscheduling/libsss0svcscheduling_undef.h>
#endif //   TEAMCENTER__SERVICESCHEDULING__SSS0JOBACTIVITY__HXX
