//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSS0JobActivityDelegate
    Filename:   SSS0JobActivityDelegate.hxx
    Module:     sss0svcscheduling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICESCHEDULING__SSS0JOBACTIVITYDELEGATE_HXX
#define TEAMCENTER__SERVICESCHEDULING__SSS0JOBACTIVITYDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <sss0svcscheduling/SSS0JobActivity.hxx>

#include <sss0svcscheduling/libsss0svcscheduling_exports.h>

namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobActivityDelegate;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobActivityImpl;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobActivity;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobActivityGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SSS0SVCSCHEDULING_API Teamcenter_alias::servicescheduling::SSS0JobActivityDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SSS0JobActivityDelegate instance
    static SSS0JobActivityDelegate&  getInstance();

    //  Method to create the SSS0JobActivityImpl pointer
    static SSS0JobActivityImpl*  createImpl( SSS0JobActivity&  ifObj );

    //  Method to delete the SSS0JobActivityImpl pointer
    static void deleteImpl( SSS0JobActivityImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getSss0AssignmentsBase(const SSS0JobActivity &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getSss0CorrectedDiscrepancyBase(const SSS0JobActivity &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getSss0RequiredResourcesBase(const SSS0JobActivity &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getSss0UtilizationBase(const SSS0JobActivity &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Performs Physical Configuration updates based on the Part Movements and Upgrades defined on the Task. This is a recursive call that will perform the updates for the Task Structue below.
    /// @version Teamcenter 11.1
    /// @param configDate - Performs Physical Configuration updates based on the Part Movements and Upgrades defined on the Task. This is a recursive call that will perform the updates for the Task Structue below.
    /// @return - Error code if any
    ///
    int  sss0UpdateConfigurationBase(const SSS0JobActivity &ifObj,  date_t configDate );


    ///
    /// Validate whether the Job Activity has related Characteric Values.
    /// @version Teamcenter 11.1
    /// @param result - Validate whether the Job Activity has related Characteric Values.
    /// @return - 1 or 0
    ///
    int  sss0ValidateCharacteristicValuesBase(const SSS0JobActivity &ifObj,  bool *result );


    ///
    /// Validate whether the Job Activity has part movements.
    /// @version Teamcenter 11.1
    /// @param result - Validate whether the Job Activity has part movements.
    /// @return - 1 or 0
    ///
    int  sss0ValidatePartsMovedBase(const SSS0JobActivity &ifObj,  bool *result );


    ///
    /// To check if the characteristic values are recorded for attached characteristic definition.
    /// @version Teamcenter 11.1
    /// @param result - To check if the characteristic values are recorded for attached characteristic definition.
    /// @return - Returns the status
    ///
    int  sss0ValidateUtilizationRecordedBase(const SSS0JobActivity &ifObj,  bool *result );


    ///
    /// Get utilization that has been recorded on the generic work order task.
    /// @version Teamcenter 11.1
    /// @param utilization - Vector containing utilization objects.
    /// @return - ifail code
    ///
    int  fnd0getUtilizationBase(const SSS0JobActivity &ifObj,  std::vector< tag_t > *utilization );



protected:
    //  Pointer to the instance
    static SSS0JobActivityDelegate*  m_pInstance;

    SSS0JobActivityDelegate();
    virtual ~SSS0JobActivityDelegate();
    static void setInstance( SSS0JobActivityDelegate*  instance );


private:
    friend class  ::Teamcenter::servicescheduling::SSS0JobActivityGenImpl;

};

#include <sss0svcscheduling/libsss0svcscheduling_undef.h>
#endif  //  TEAMCENTER__SERVICESCHEDULING__SSS0JOBACTIVITYDELEGATE_HXX
