//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSS0JobActivityRevision
    Filename:   SSS0JobActivityRevision.hxx
    Module:     sss0svcscheduling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICESCHEDULING__SSS0JOBACTIVITYREVISION__HXX
#define TEAMCENTER__SERVICESCHEDULING__SSS0JOBACTIVITYREVISION__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <schmgt/Fnd0GnWOTaskRevision.hxx>

#include <sss0svcscheduling/libsss0svcscheduling_exports.h>

namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobActivityRevision;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobActivityRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobActivityRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobActivityRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobActivityRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SSS0SVCSCHEDULING_API  Teamcenter::servicescheduling::SSS0JobActivityRevision
     : public  ::Teamcenter::Fnd0GnWOTaskRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Performs Physical Configuration updates based on the Part Movements and Upgrades defined on the Task Revision. This is a recursive call that will perform the updates for the Task Structue below.
    /// @version Teamcenter 9.1
    /// @param configDate - Date of updating the configuration, typically used for Rebase/Upgrade
    /// @return - Error code if any
    ///
    int  sss0UpdateConfiguration( date_t configDate );

    ///
    /// Validate whether the Job Activity Revision has related Characteric Values.
    /// @version Teamcenter 9.1
    /// @param result - Returns true if the Job Activity Revision has related characteristic values.
    /// @return - 1 or 0
    ///
    int  sss0ValidateCharacteristicValues( bool *result );

    ///
    /// Validate whether the Job Activity Revision has part movements.
    /// @version Teamcenter 9.1
    /// @param result - Returns true if there are part movements defined.
    /// @return - 1 or 0
    ///
    int  sss0ValidatePartsMoved( bool *result );

    ///
    /// To check if the characteristic values are recorded for attached characteristic definition.
    /// @version Teamcenter 9.1
    /// @param result - Returns the true or false
    /// @return - Returns the status
    ///
    int  sss0ValidateUtilizationRecorded( bool *result );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SSS0JobActivityRevision();

    /**
     * Destructor
     */
    virtual ~SSS0JobActivityRevision();

private:
    //  Getter method for the Implementation Object
    SSS0JobActivityRevisionImpl*  getSSS0JobActivityRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSSS0JobActivityRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SSS0JobActivityRevisionImpl*  m_sss0jobactivityrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SSS0JobActivityRevision - desc for SSS0JobActivityRevision parameter
     */
    SSS0JobActivityRevision( const SSS0JobActivityRevision& );
    SSS0JobActivityRevision& operator=( const SSS0JobActivityRevision& );

    friend class  SSS0JobActivityRevisionDelegate;
    friend class  SSS0JobActivityRevisionDispatch;
    friend class  SSS0JobActivityRevisionGenImpl;
};

#include <sss0svcscheduling/libsss0svcscheduling_undef.h>
#endif //   TEAMCENTER__SERVICESCHEDULING__SSS0JOBACTIVITYREVISION__HXX
