//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSS0JobActivityRevisionDelegate
    Filename:   SSS0JobActivityRevisionDelegate.hxx
    Module:     sss0svcscheduling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICESCHEDULING__SSS0JOBACTIVITYREVISIONDELEGATE_HXX
#define TEAMCENTER__SERVICESCHEDULING__SSS0JOBACTIVITYREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <sss0svcscheduling/SSS0JobActivityRevision.hxx>

#include <sss0svcscheduling/libsss0svcscheduling_exports.h>

namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobActivityRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobActivityRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobActivityRevision;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobActivityRevisionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SSS0SVCSCHEDULING_API Teamcenter_alias::servicescheduling::SSS0JobActivityRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SSS0JobActivityRevisionDelegate instance
    static SSS0JobActivityRevisionDelegate&  getInstance();

    //  Method to create the SSS0JobActivityRevisionImpl pointer
    static SSS0JobActivityRevisionImpl*  createImpl( SSS0JobActivityRevision&  ifObj );

    //  Method to delete the SSS0JobActivityRevisionImpl pointer
    static void deleteImpl( SSS0JobActivityRevisionImpl*  impl );


    ///
    /// Performs Physical Configuration updates based on the Part Movements and Upgrades defined on the Task Revision. This is a recursive call that will perform the updates for the Task Structue below.
    /// @version Teamcenter 9.1
    /// @param configDate - Date of updating the configuration, typically used for Rebase/Upgrade
    /// @return - Error code if any
    ///
    int  sss0UpdateConfigurationBase(const SSS0JobActivityRevision &ifObj,  date_t configDate );


    ///
    /// Validate whether the Job Activity Revision has related Characteric Values.
    /// @version Teamcenter 9.1
    /// @param result - Returns true if the Job Activity Revision has related characteristic values.
    /// @return - 1 or 0
    ///
    int  sss0ValidateCharacteristicValuesBase(const SSS0JobActivityRevision &ifObj,  bool *result );


    ///
    /// Validate whether the Job Activity Revision has part movements.
    /// @version Teamcenter 9.1
    /// @param result - Returns true if there are part movements defined.
    /// @return - 1 or 0
    ///
    int  sss0ValidatePartsMovedBase(const SSS0JobActivityRevision &ifObj,  bool *result );


    ///
    /// To check if the characteristic values are recorded for attached characteristic definition.
    /// @version Teamcenter 9.1
    /// @param result - Returns the true or false
    /// @return - Returns the status
    ///
    int  sss0ValidateUtilizationRecordedBase(const SSS0JobActivityRevision &ifObj,  bool *result );


    ///
    /// Get utilization that has been recorded on the generic work order task.
    /// @version Teamcenter 11.1
    /// @param utilization - Vector containing utilization objects.
    /// @return - ifail code
    ///
    int  fnd0getUtilizationBase(const SSS0JobActivityRevision &ifObj,  std::vector< tag_t > *utilization );



protected:
    //  Pointer to the instance
    static SSS0JobActivityRevisionDelegate*  m_pInstance;

    SSS0JobActivityRevisionDelegate();
    virtual ~SSS0JobActivityRevisionDelegate();
    static void setInstance( SSS0JobActivityRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::servicescheduling::SSS0JobActivityRevisionGenImpl;

};

#include <sss0svcscheduling/libsss0svcscheduling_undef.h>
#endif  //  TEAMCENTER__SERVICESCHEDULING__SSS0JOBACTIVITYREVISIONDELEGATE_HXX
