//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSS0JobCard
    Filename:   SSS0JobCard.hxx
    Module:     sss0svcscheduling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICESCHEDULING__SSS0JOBCARD__HXX
#define TEAMCENTER__SERVICESCHEDULING__SSS0JOBCARD__HXX

#include <common/tc_deprecation_macros.h>
#include <sss0svcscheduling/SSS0JobActivity.hxx>

#include <sss0svcscheduling/libsss0svcscheduling_exports.h>

namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobCard;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobCardImpl;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobCardDelegate;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobCardDispatch;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobCardGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SSS0SVCSCHEDULING_API  Teamcenter::servicescheduling::SSS0JobCard
     : public  ::Teamcenter::servicescheduling::SSS0JobActivity
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SSS0JobCard();

    /**
     * Destructor
     */
    virtual ~SSS0JobCard();

private:
    //  Getter method for the Implementation Object
    SSS0JobCardImpl*  getSSS0JobCardImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSSS0JobCardImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SSS0JobCardImpl*  m_sss0jobcardImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SSS0JobCard - desc for SSS0JobCard parameter
     */
    SSS0JobCard( const SSS0JobCard& );
    SSS0JobCard& operator=( const SSS0JobCard& );

    friend class  SSS0JobCardDelegate;
    friend class  SSS0JobCardDispatch;
    friend class  SSS0JobCardGenImpl;
};

#include <sss0svcscheduling/libsss0svcscheduling_undef.h>
#endif //   TEAMCENTER__SERVICESCHEDULING__SSS0JOBCARD__HXX
