//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSS0JobCardRevision
    Filename:   SSS0JobCardRevision.hxx
    Module:     sss0svcscheduling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICESCHEDULING__SSS0JOBCARDREVISION__HXX
#define TEAMCENTER__SERVICESCHEDULING__SSS0JOBCARDREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <sss0svcscheduling/SSS0JobActivityRevision.hxx>

#include <sss0svcscheduling/libsss0svcscheduling_exports.h>

namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobCardRevision;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobCardRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobCardRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobCardRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobCardRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SSS0SVCSCHEDULING_API  Teamcenter::servicescheduling::SSS0JobCardRevision
     : public  ::Teamcenter::servicescheduling::SSS0JobActivityRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SSS0JobCardRevision();

    /**
     * Destructor
     */
    virtual ~SSS0JobCardRevision();

private:
    //  Getter method for the Implementation Object
    SSS0JobCardRevisionImpl*  getSSS0JobCardRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSSS0JobCardRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SSS0JobCardRevisionImpl*  m_sss0jobcardrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SSS0JobCardRevision - desc for SSS0JobCardRevision parameter
     */
    SSS0JobCardRevision( const SSS0JobCardRevision& );
    SSS0JobCardRevision& operator=( const SSS0JobCardRevision& );

    friend class  SSS0JobCardRevisionDelegate;
    friend class  SSS0JobCardRevisionDispatch;
    friend class  SSS0JobCardRevisionGenImpl;
};

#include <sss0svcscheduling/libsss0svcscheduling_undef.h>
#endif //   TEAMCENTER__SERVICESCHEDULING__SSS0JOBCARDREVISION__HXX
