//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSS0JobTask
    Filename:   SSS0JobTask.hxx
    Module:     sss0svcscheduling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICESCHEDULING__SSS0JOBTASK__HXX
#define TEAMCENTER__SERVICESCHEDULING__SSS0JOBTASK__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <sss0svcscheduling/SSS0JobActivity.hxx>

#include <sss0svcscheduling/libsss0svcscheduling_exports.h>

namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobTask;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobTaskImpl;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobTaskDelegate;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobTaskDispatch;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobTaskGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SSS0SVCSCHEDULING_API  Teamcenter::servicescheduling::SSS0JobTask
     : public  ::Teamcenter::servicescheduling::SSS0JobActivity
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSss0impactedPhysicalPart( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSss0workForAsset( tag_t &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SSS0JobTask();

    /**
     * Destructor
     */
    virtual ~SSS0JobTask();

private:
    //  Getter method for the Implementation Object
    SSS0JobTaskImpl*  getSSS0JobTaskImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSSS0JobTaskImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SSS0JobTaskImpl*  m_sss0jobtaskImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SSS0JobTask - desc for SSS0JobTask parameter
     */
    SSS0JobTask( const SSS0JobTask& );
    SSS0JobTask& operator=( const SSS0JobTask& );

    friend class  SSS0JobTaskDelegate;
    friend class  SSS0JobTaskDispatch;
    friend class  SSS0JobTaskGenImpl;
};

#include <sss0svcscheduling/libsss0svcscheduling_undef.h>
#endif //   TEAMCENTER__SERVICESCHEDULING__SSS0JOBTASK__HXX
