//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSS0JobTaskDelegate
    Filename:   SSS0JobTaskDelegate.hxx
    Module:     sss0svcscheduling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICESCHEDULING__SSS0JOBTASKDELEGATE_HXX
#define TEAMCENTER__SERVICESCHEDULING__SSS0JOBTASKDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <sss0svcscheduling/SSS0JobTask.hxx>

#include <sss0svcscheduling/libsss0svcscheduling_exports.h>

namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobTaskDelegate;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobTaskImpl;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobTask;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobTaskGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SSS0SVCSCHEDULING_API Teamcenter_alias::servicescheduling::SSS0JobTaskDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SSS0JobTaskDelegate instance
    static SSS0JobTaskDelegate&  getInstance();

    //  Method to create the SSS0JobTaskImpl pointer
    static SSS0JobTaskImpl*  createImpl( SSS0JobTask&  ifObj );

    //  Method to delete the SSS0JobTaskImpl pointer
    static void deleteImpl( SSS0JobTaskImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSss0impactedPhysicalPartBase(const SSS0JobTask &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSss0workForAssetBase(const SSS0JobTask &ifObj,  tag_t &value, bool &isNull ) const;



protected:
    //  Pointer to the instance
    static SSS0JobTaskDelegate*  m_pInstance;

    SSS0JobTaskDelegate();
    virtual ~SSS0JobTaskDelegate();
    static void setInstance( SSS0JobTaskDelegate*  instance );


private:
    friend class  ::Teamcenter::servicescheduling::SSS0JobTaskGenImpl;

};

#include <sss0svcscheduling/libsss0svcscheduling_undef.h>
#endif  //  TEAMCENTER__SERVICESCHEDULING__SSS0JOBTASKDELEGATE_HXX
