//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSS0JobTaskRevision
    Filename:   SSS0JobTaskRevision.hxx
    Module:     sss0svcscheduling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICESCHEDULING__SSS0JOBTASKREVISION__HXX
#define TEAMCENTER__SERVICESCHEDULING__SSS0JOBTASKREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <sss0svcscheduling/SSS0JobActivityRevision.hxx>

#include <sss0svcscheduling/libsss0svcscheduling_exports.h>

namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobTaskRevision;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobTaskRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobTaskRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobTaskRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0JobTaskRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SSS0SVCSCHEDULING_API  Teamcenter::servicescheduling::SSS0JobTaskRevision
     : public  ::Teamcenter::servicescheduling::SSS0JobActivityRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SSS0JobTaskRevision();

    /**
     * Destructor
     */
    virtual ~SSS0JobTaskRevision();

private:
    //  Getter method for the Implementation Object
    SSS0JobTaskRevisionImpl*  getSSS0JobTaskRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSSS0JobTaskRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SSS0JobTaskRevisionImpl*  m_sss0jobtaskrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SSS0JobTaskRevision - desc for SSS0JobTaskRevision parameter
     */
    SSS0JobTaskRevision( const SSS0JobTaskRevision& );
    SSS0JobTaskRevision& operator=( const SSS0JobTaskRevision& );

    friend class  SSS0JobTaskRevisionDelegate;
    friend class  SSS0JobTaskRevisionDispatch;
    friend class  SSS0JobTaskRevisionGenImpl;
};

#include <sss0svcscheduling/libsss0svcscheduling_undef.h>
#endif //   TEAMCENTER__SERVICESCHEDULING__SSS0JOBTASKREVISION__HXX
