//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSS0RequestsPart
    Filename:   SSS0RequestsPart.hxx
    Module:     sss0svcscheduling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICESCHEDULING__SSS0REQUESTSPART__HXX
#define TEAMCENTER__SERVICESCHEDULING__SSS0REQUESTSPART__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <sss0svcscheduling/libsss0svcscheduling_exports.h>

namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0RequestsPart;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0RequestsPartImpl;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0RequestsPartDelegate;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0RequestsPartDispatch;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0RequestsPartGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SSS0SVCSCHEDULING_API  Teamcenter::servicescheduling::SSS0RequestsPart
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SSS0RequestsPart();

    /**
     * Destructor
     */
    virtual ~SSS0RequestsPart();

private:
    //  Getter method for the Implementation Object
    SSS0RequestsPartImpl*  getSSS0RequestsPartImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSSS0RequestsPartImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SSS0RequestsPartImpl*  m_sss0requestspartImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SSS0RequestsPart - desc for SSS0RequestsPart parameter
     */
    SSS0RequestsPart( const SSS0RequestsPart& );
    SSS0RequestsPart& operator=( const SSS0RequestsPart& );

    friend class  SSS0RequestsPartDelegate;
    friend class  SSS0RequestsPartDispatch;
    friend class  SSS0RequestsPartGenImpl;
};

#include <sss0svcscheduling/libsss0svcscheduling_undef.h>
#endif //   TEAMCENTER__SERVICESCHEDULING__SSS0REQUESTSPART__HXX
