//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSS0ResultingInformation
    Filename:   SSS0ResultingInformation.hxx
    Module:     sss0svcscheduling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICESCHEDULING__SSS0RESULTINGINFORMATION__HXX
#define TEAMCENTER__SERVICESCHEDULING__SSS0RESULTINGINFORMATION__HXX

#include <common/tc_deprecation_macros.h>
#include <cm/CMRelation.hxx>

#include <sss0svcscheduling/libsss0svcscheduling_exports.h>

namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0ResultingInformation;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0ResultingInformationImpl;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0ResultingInformationDelegate;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0ResultingInformationDispatch;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0ResultingInformationGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SSS0SVCSCHEDULING_API  Teamcenter::servicescheduling::SSS0ResultingInformation
     : public  ::Teamcenter::CMRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SSS0ResultingInformation();

    /**
     * Destructor
     */
    virtual ~SSS0ResultingInformation();

private:
    //  Getter method for the Implementation Object
    SSS0ResultingInformationImpl*  getSSS0ResultingInformationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSSS0ResultingInformationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SSS0ResultingInformationImpl*  m_sss0resultinginformationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SSS0ResultingInformation - desc for SSS0ResultingInformation parameter
     */
    SSS0ResultingInformation( const SSS0ResultingInformation& );
    SSS0ResultingInformation& operator=( const SSS0ResultingInformation& );

    friend class  SSS0ResultingInformationDelegate;
    friend class  SSS0ResultingInformationDispatch;
    friend class  SSS0ResultingInformationGenImpl;
};

#include <sss0svcscheduling/libsss0svcscheduling_undef.h>
#endif //   TEAMCENTER__SERVICESCHEDULING__SSS0RESULTINGINFORMATION__HXX
