//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSS0SvcWorkOrder
    Filename:   SSS0SvcWorkOrder.hxx
    Module:     sss0svcscheduling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICESCHEDULING__SSS0SVCWORKORDER__HXX
#define TEAMCENTER__SERVICESCHEDULING__SSS0SVCWORKORDER__HXX

#include <common/tc_deprecation_macros.h>
#include <cm/Cm0GnWorkOrder.hxx>

#include <sss0svcscheduling/libsss0svcscheduling_exports.h>

namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0SvcWorkOrder;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0SvcWorkOrderImpl;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0SvcWorkOrderDelegate;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0SvcWorkOrderDispatch;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0SvcWorkOrderGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SSS0SVCSCHEDULING_API  Teamcenter::servicescheduling::SSS0SvcWorkOrder
     : public  ::Teamcenter::Cm0GnWorkOrder
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SSS0SvcWorkOrder();

    /**
     * Destructor
     */
    virtual ~SSS0SvcWorkOrder();

private:
    //  Getter method for the Implementation Object
    SSS0SvcWorkOrderImpl*  getSSS0SvcWorkOrderImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSSS0SvcWorkOrderImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SSS0SvcWorkOrderImpl*  m_sss0svcworkorderImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SSS0SvcWorkOrder - desc for SSS0SvcWorkOrder parameter
     */
    SSS0SvcWorkOrder( const SSS0SvcWorkOrder& );
    SSS0SvcWorkOrder& operator=( const SSS0SvcWorkOrder& );

    friend class  SSS0SvcWorkOrderDelegate;
    friend class  SSS0SvcWorkOrderDispatch;
    friend class  SSS0SvcWorkOrderGenImpl;
};

#include <sss0svcscheduling/libsss0svcscheduling_undef.h>
#endif //   TEAMCENTER__SERVICESCHEDULING__SSS0SVCWORKORDER__HXX
