//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSS0SvcWorkOrderRevision
    Filename:   SSS0SvcWorkOrderRevision.hxx
    Module:     sss0svcscheduling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICESCHEDULING__SSS0SVCWORKORDERREVISION__HXX
#define TEAMCENTER__SERVICESCHEDULING__SSS0SVCWORKORDERREVISION__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <cm/Cm0GnWorkOrderRevision.hxx>

#include <sss0svcscheduling/libsss0svcscheduling_exports.h>

namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0SvcWorkOrderRevision;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0SvcWorkOrderRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0SvcWorkOrderRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0SvcWorkOrderRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0SvcWorkOrderRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SSS0SVCSCHEDULING_API  Teamcenter::servicescheduling::SSS0SvcWorkOrderRevision
     : public  ::Teamcenter::Cm0GnWorkOrderRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getSss0ChildTasks( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getSss0CorrectedDiscrepancy( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SSS0SvcWorkOrderRevision();

    /**
     * Destructor
     */
    virtual ~SSS0SvcWorkOrderRevision();

private:
    //  Getter method for the Implementation Object
    SSS0SvcWorkOrderRevisionImpl*  getSSS0SvcWorkOrderRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSSS0SvcWorkOrderRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SSS0SvcWorkOrderRevisionImpl*  m_sss0svcworkorderrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SSS0SvcWorkOrderRevision - desc for SSS0SvcWorkOrderRevision parameter
     */
    SSS0SvcWorkOrderRevision( const SSS0SvcWorkOrderRevision& );
    SSS0SvcWorkOrderRevision& operator=( const SSS0SvcWorkOrderRevision& );

    friend class  SSS0SvcWorkOrderRevisionDelegate;
    friend class  SSS0SvcWorkOrderRevisionDispatch;
    friend class  SSS0SvcWorkOrderRevisionGenImpl;
};

#include <sss0svcscheduling/libsss0svcscheduling_undef.h>
#endif //   TEAMCENTER__SERVICESCHEDULING__SSS0SVCWORKORDERREVISION__HXX
