//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSS0SvcWorkOrderRevisionDelegate
    Filename:   SSS0SvcWorkOrderRevisionDelegate.hxx
    Module:     sss0svcscheduling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICESCHEDULING__SSS0SVCWORKORDERREVISIONDELEGATE_HXX
#define TEAMCENTER__SERVICESCHEDULING__SSS0SVCWORKORDERREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <sss0svcscheduling/SSS0SvcWorkOrderRevision.hxx>

#include <sss0svcscheduling/libsss0svcscheduling_exports.h>

namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0SvcWorkOrderRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0SvcWorkOrderRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0SvcWorkOrderRevision;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0SvcWorkOrderRevisionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SSS0SVCSCHEDULING_API Teamcenter_alias::servicescheduling::SSS0SvcWorkOrderRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the SSS0SvcWorkOrderRevisionDelegate instance
    static SSS0SvcWorkOrderRevisionDelegate&  getInstance();

    //  Method to create the SSS0SvcWorkOrderRevisionImpl pointer
    static SSS0SvcWorkOrderRevisionImpl*  createImpl( SSS0SvcWorkOrderRevision&  ifObj );

    //  Method to delete the SSS0SvcWorkOrderRevisionImpl pointer
    static void deleteImpl( SSS0SvcWorkOrderRevisionImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getSss0ChildTasksBase(const SSS0SvcWorkOrderRevision &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getSss0CorrectedDiscrepancyBase(const SSS0SvcWorkOrderRevision &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const SSS0SvcWorkOrderRevision &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static SSS0SvcWorkOrderRevisionDelegate*  m_pInstance;

    SSS0SvcWorkOrderRevisionDelegate();
    virtual ~SSS0SvcWorkOrderRevisionDelegate();
    static void setInstance( SSS0SvcWorkOrderRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::servicescheduling::SSS0SvcWorkOrderRevisionGenImpl;

};

#include <sss0svcscheduling/libsss0svcscheduling_undef.h>
#endif  //  TEAMCENTER__SERVICESCHEDULING__SSS0SVCWORKORDERREVISIONDELEGATE_HXX
