//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, SSS0WorkForAsset
    Filename:   SSS0WorkForAsset.hxx
    Module:     sss0svcscheduling
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SERVICESCHEDULING__SSS0WORKFORASSET__HXX
#define TEAMCENTER__SERVICESCHEDULING__SSS0WORKFORASSET__HXX

#include <common/tc_deprecation_macros.h>
#include <cm/CMRelation.hxx>

#include <sss0svcscheduling/libsss0svcscheduling_exports.h>

namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0WorkForAsset;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0WorkForAssetImpl;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0WorkForAssetDelegate;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0WorkForAssetDispatch;
    }
}
namespace Teamcenter
{
    namespace servicescheduling
    {
        class SSS0WorkForAssetGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SSS0SVCSCHEDULING_API  Teamcenter::servicescheduling::SSS0WorkForAsset
     : public  ::Teamcenter::CMRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    SSS0WorkForAsset();

    /**
     * Destructor
     */
    virtual ~SSS0WorkForAsset();

private:
    //  Getter method for the Implementation Object
    SSS0WorkForAssetImpl*  getSSS0WorkForAssetImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSSS0WorkForAssetImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    SSS0WorkForAssetImpl*  m_sss0workforassetImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param SSS0WorkForAsset - desc for SSS0WorkForAsset parameter
     */
    SSS0WorkForAsset( const SSS0WorkForAsset& );
    SSS0WorkForAsset& operator=( const SSS0WorkForAsset& );

    friend class  SSS0WorkForAssetDelegate;
    friend class  SSS0WorkForAssetDispatch;
    friend class  SSS0WorkForAssetGenImpl;
};

#include <sss0svcscheduling/libsss0svcscheduling_undef.h>
#endif //   TEAMCENTER__SERVICESCHEDULING__SSS0WORKFORASSET__HXX
