//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  stockmaterialdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libstockmaterialdispatch

#if !defined(LIBSTOCKMATERIALDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBSTOCKMATERIALDISPATCH is not defined
#endif

/* Handwritten code should use STOCKMATERIALDISPATCH_API, not STOCKMATERIALDISPATCHEXPORT */

#define STOCKMATERIALDISPATCH_API STOCKMATERIALDISPATCHEXPORT

#if IPLIB==libstockmaterialdispatch || defined(LIBSTOCKMATERIALDISPATCH)
#   if defined(__lint)
#       define STOCKMATERIALDISPATCHEXPORT       __export(stockmaterialdispatch)
#       define STOCKMATERIALDISPATCHGLOBAL       extern __global(stockmaterialdispatch)
#       define STOCKMATERIALDISPATCHPRIVATE      extern __private(stockmaterialdispatch)
#   elif defined(_WIN32)
#       define STOCKMATERIALDISPATCHEXPORT       __declspec(dllexport)
#       define STOCKMATERIALDISPATCHGLOBAL       extern __declspec(dllexport)
#       define STOCKMATERIALDISPATCHPRIVATE      extern
#   else
#       define STOCKMATERIALDISPATCHEXPORT
#       define STOCKMATERIALDISPATCHGLOBAL       extern
#       define STOCKMATERIALDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define STOCKMATERIALDISPATCHEXPORT       __export(stockmaterialdispatch)
#       define STOCKMATERIALDISPATCHGLOBAL       extern __global(stockmaterialdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define STOCKMATERIALDISPATCHEXPORT      __declspec(dllimport)
#       define STOCKMATERIALDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define STOCKMATERIALDISPATCHEXPORT
#       define STOCKMATERIALDISPATCHGLOBAL       extern
#   endif
#endif
