//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EventTypeMapping
    Filename:   EventTypeMapping.hxx
    Module:     sub_mgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EVENTTYPEMAPPING__HXX
#define TEAMCENTER__EVENTTYPEMAPPING__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <sub_mgr/libsub_mgr_exports.h>

namespace Teamcenter
{
    class EventTypeMapping;
}
namespace Teamcenter
{
    class EventTypeMappingImpl;
}
namespace Teamcenter
{
    class EventTypeMappingDelegate;
}
namespace Teamcenter
{
    class EventTypeMappingDispatch;
}
namespace Teamcenter
{
    class EventTypeMappingGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SUB_MGR_API  Teamcenter::EventTypeMapping
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    EventTypeMapping();

    /**
     * Destructor
     */
    virtual ~EventTypeMapping();

private:
    //  Getter method for the Implementation Object
    EventTypeMappingImpl*  getEventTypeMappingImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setEventTypeMappingImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    EventTypeMappingImpl*  m_eventtypemappingImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param EventTypeMapping - desc for EventTypeMapping parameter
     */
    EventTypeMapping( const EventTypeMapping& );
    EventTypeMapping& operator=( const EventTypeMapping& );

    friend class  EventTypeMappingDelegate;
    friend class  EventTypeMappingDispatch;
    friend class  EventTypeMappingGenImpl;
};

#include <sub_mgr/libsub_mgr_undef.h>
#endif //   TEAMCENTER__EVENTTYPEMAPPING__HXX
