//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EventTypeMappingDelegate
    Filename:   EventTypeMappingDelegate.hxx
    Module:     sub_mgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EVENTTYPEMAPPINGDELEGATE_HXX
#define TEAMCENTER__EVENTTYPEMAPPINGDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <sub_mgr/EventTypeMapping.hxx>

#include <sub_mgr/libsub_mgr_exports.h>

namespace Teamcenter
{
    class EventTypeMappingDelegate;
}
namespace Teamcenter
{
    class EventTypeMappingImpl;
}
namespace Teamcenter
{
    class EventTypeMapping;
}
namespace Teamcenter
{
    class EventTypeMappingGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  SUB_MGR_API Teamcenter_alias::EventTypeMappingDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the EventTypeMappingDelegate instance
    static EventTypeMappingDelegate&  getInstance();

    //  Method to create the EventTypeMappingImpl pointer
    static EventTypeMappingImpl*  createImpl( EventTypeMapping&  ifObj );

    //  Method to delete the EventTypeMappingImpl pointer
    static void deleteImpl( EventTypeMappingImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const EventTypeMapping &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const EventTypeMapping &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static EventTypeMappingDelegate*  m_pInstance;

    EventTypeMappingDelegate();
    virtual ~EventTypeMappingDelegate();
    static void setInstance( EventTypeMappingDelegate*  instance );


private:
    friend class  ::Teamcenter::EventTypeMappingGenImpl;

};

#include <sub_mgr/libsub_mgr_undef.h>
#endif  //  TEAMCENTER__EVENTTYPEMAPPINGDELEGATE_HXX
