//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0NotificationTemplate
    Filename:   Fnd0NotificationTemplate.hxx
    Module:     sub_mgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0NOTIFICATIONTEMPLATE__HXX
#define TEAMCENTER__FND0NOTIFICATIONTEMPLATE__HXX

#include <string>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <sub_mgr/libsub_mgr_exports.h>

namespace Teamcenter
{
    class Fnd0NotificationTemplate;
}
namespace Teamcenter
{
    class Fnd0NotificationTemplateImpl;
}
namespace Teamcenter
{
    class Fnd0NotificationTemplateDelegate;
}
namespace Teamcenter
{
    class Fnd0NotificationTemplateDispatch;
}
namespace Teamcenter
{
    class Fnd0NotificationTemplateGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SUB_MGR_API  Teamcenter::Fnd0NotificationTemplate
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMessage( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMessage_modified( bool &value, bool &isNull ) const;

    ///
    /// Getter for an String Array Property
    /// @version Tc 8
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getProperties( std::vector< std::string > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getProperties_modified( bool &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSubject( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSubject_modified( bool &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMessage( const std::string &value, bool isNull=false );

    ///
    /// Setter for a Boolean Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMessage_modified( bool value, bool isNull=false );

    ///
    /// Setter for an string Array Property
    /// @version Tc 8
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setProperties( const std::vector< std::string > &values, const std::vector< int > *isNull=0 );

    ///
    /// Setter for a Boolean Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setProperties_modified( bool value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSubject( const std::string &value, bool isNull=false );

    ///
    /// Setter for a Boolean Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSubject_modified( bool value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0NotificationTemplate();

    /**
     * Destructor
     */
    virtual ~Fnd0NotificationTemplate();

private:
    //  Getter method for the Implementation Object
    Fnd0NotificationTemplateImpl*  getFnd0NotificationTemplateImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0NotificationTemplateImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0NotificationTemplateImpl*  m_fnd0notificationtemplateImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0NotificationTemplate - desc for Fnd0NotificationTemplate parameter
     */
    Fnd0NotificationTemplate( const Fnd0NotificationTemplate& );
    Fnd0NotificationTemplate& operator=( const Fnd0NotificationTemplate& );

    friend class  Fnd0NotificationTemplateDelegate;
    friend class  Fnd0NotificationTemplateDispatch;
    friend class  Fnd0NotificationTemplateGenImpl;
};

#include <sub_mgr/libsub_mgr_undef.h>
#endif //   TEAMCENTER__FND0NOTIFICATIONTEMPLATE__HXX
