//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0NotificationTemplateDelegate
    Filename:   Fnd0NotificationTemplateDelegate.hxx
    Module:     sub_mgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0NOTIFICATIONTEMPLATEDELEGATE_HXX
#define TEAMCENTER__FND0NOTIFICATIONTEMPLATEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <sub_mgr/Fnd0NotificationTemplate.hxx>

#include <sub_mgr/libsub_mgr_exports.h>

namespace Teamcenter
{
    class Fnd0NotificationTemplateDelegate;
}
namespace Teamcenter
{
    class Fnd0NotificationTemplateImpl;
}
namespace Teamcenter
{
    class Fnd0NotificationTemplate;
}
namespace Teamcenter
{
    class Fnd0NotificationTemplateGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  SUB_MGR_API Teamcenter_alias::Fnd0NotificationTemplateDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0NotificationTemplateDelegate instance
    static Fnd0NotificationTemplateDelegate&  getInstance();

    //  Method to create the Fnd0NotificationTemplateImpl pointer
    static Fnd0NotificationTemplateImpl*  createImpl( Fnd0NotificationTemplate&  ifObj );

    //  Method to delete the Fnd0NotificationTemplateImpl pointer
    static void deleteImpl( Fnd0NotificationTemplateImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMessageBase(const Fnd0NotificationTemplate &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMessage_modifiedBase(const Fnd0NotificationTemplate &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Tc 8
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getPropertiesBase(const Fnd0NotificationTemplate &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getProperties_modifiedBase(const Fnd0NotificationTemplate &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSubjectBase(const Fnd0NotificationTemplate &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSubject_modifiedBase(const Fnd0NotificationTemplate &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMessageBase(Fnd0NotificationTemplate &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMessage_modifiedBase(Fnd0NotificationTemplate &ifObj,  bool value, bool isNull );


    ///
    /// Setter for an string Array Property
    /// @version Tc 8
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setPropertiesBase(Fnd0NotificationTemplate &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setProperties_modifiedBase(Fnd0NotificationTemplate &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSubjectBase(Fnd0NotificationTemplate &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSubject_modifiedBase(Fnd0NotificationTemplate &ifObj,  bool value, bool isNull );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Fnd0NotificationTemplate &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Fnd0NotificationTemplateDelegate*  m_pInstance;

    Fnd0NotificationTemplateDelegate();
    virtual ~Fnd0NotificationTemplateDelegate();
    static void setInstance( Fnd0NotificationTemplateDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0NotificationTemplateGenImpl;

};

#include <sub_mgr/libsub_mgr_undef.h>
#endif  //  TEAMCENTER__FND0NOTIFICATIONTEMPLATEDELEGATE_HXX
