//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0SubscriptionTemplate
    Filename:   Fnd0SubscriptionTemplate.hxx
    Module:     sub_mgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0SUBSCRIPTIONTEMPLATE__HXX
#define TEAMCENTER__FND0SUBSCRIPTIONTEMPLATE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <sub_mgr/libsub_mgr_exports.h>

namespace Teamcenter
{
    class Fnd0SubscriptionTemplate;
}
namespace Teamcenter
{
    class Fnd0SubscriptionTemplateImpl;
}
namespace Teamcenter
{
    class Fnd0SubscriptionTemplateDelegate;
}
namespace Teamcenter
{
    class Fnd0SubscriptionTemplateDispatch;
}
namespace Teamcenter
{
    class Fnd0SubscriptionTemplateGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SUB_MGR_API  Teamcenter::Fnd0SubscriptionTemplate
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0SubscriptionTemplate();

    /**
     * Destructor
     */
    virtual ~Fnd0SubscriptionTemplate();

private:
    //  Getter method for the Implementation Object
    Fnd0SubscriptionTemplateImpl*  getFnd0SubscriptionTemplateImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0SubscriptionTemplateImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0SubscriptionTemplateImpl*  m_fnd0subscriptiontemplateImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0SubscriptionTemplate - desc for Fnd0SubscriptionTemplate parameter
     */
    Fnd0SubscriptionTemplate( const Fnd0SubscriptionTemplate& );
    Fnd0SubscriptionTemplate& operator=( const Fnd0SubscriptionTemplate& );

    friend class  Fnd0SubscriptionTemplateDelegate;
    friend class  Fnd0SubscriptionTemplateDispatch;
    friend class  Fnd0SubscriptionTemplateGenImpl;
};

#include <sub_mgr/libsub_mgr_undef.h>
#endif //   TEAMCENTER__FND0SUBSCRIPTIONTEMPLATE__HXX
