//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ImanAction
    Filename:   ImanAction.hxx
    Module:     sub_mgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IMANACTION__HXX
#define TEAMCENTER__IMANACTION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <sub_mgr/libsub_mgr_exports.h>

namespace Teamcenter
{
    class ImanAction;
}
namespace Teamcenter
{
    class ImanActionImpl;
}
namespace Teamcenter
{
    class ImanActionDelegate;
}
namespace Teamcenter
{
    class ImanActionDispatch;
}
namespace Teamcenter
{
    class ImanActionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SUB_MGR_API  Teamcenter::ImanAction
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ImanAction();

    /**
     * Destructor
     */
    virtual ~ImanAction();

private:
    //  Getter method for the Implementation Object
    ImanActionImpl*  getImanActionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setImanActionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ImanActionImpl*  m_imanactionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ImanAction - desc for ImanAction parameter
     */
    ImanAction( const ImanAction& );
    ImanAction& operator=( const ImanAction& );

    friend class  ImanActionDelegate;
    friend class  ImanActionDispatch;
    friend class  ImanActionGenImpl;
};

#include <sub_mgr/libsub_mgr_undef.h>
#endif //   TEAMCENTER__IMANACTION__HXX
