//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ImanActionHandler
    Filename:   ImanActionHandler.hxx
    Module:     sub_mgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IMANACTIONHANDLER__HXX
#define TEAMCENTER__IMANACTIONHANDLER__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <sub_mgr/libsub_mgr_exports.h>

namespace Teamcenter
{
    class ImanActionHandler;
}
namespace Teamcenter
{
    class ImanActionHandlerImpl;
}
namespace Teamcenter
{
    class ImanActionHandlerDelegate;
}
namespace Teamcenter
{
    class ImanActionHandlerDispatch;
}
namespace Teamcenter
{
    class ImanActionHandlerGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SUB_MGR_API  Teamcenter::ImanActionHandler
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ImanActionHandler();

    /**
     * Destructor
     */
    virtual ~ImanActionHandler();

private:
    //  Getter method for the Implementation Object
    ImanActionHandlerImpl*  getImanActionHandlerImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setImanActionHandlerImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ImanActionHandlerImpl*  m_imanactionhandlerImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ImanActionHandler - desc for ImanActionHandler parameter
     */
    ImanActionHandler( const ImanActionHandler& );
    ImanActionHandler& operator=( const ImanActionHandler& );

    friend class  ImanActionHandlerDelegate;
    friend class  ImanActionHandlerDispatch;
    friend class  ImanActionHandlerGenImpl;
};

#include <sub_mgr/libsub_mgr_undef.h>
#endif //   TEAMCENTER__IMANACTIONHANDLER__HXX
