//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ImanActionHandlerDelegate
    Filename:   ImanActionHandlerDelegate.hxx
    Module:     sub_mgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IMANACTIONHANDLERDELEGATE_HXX
#define TEAMCENTER__IMANACTIONHANDLERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <sub_mgr/ImanActionHandler.hxx>

#include <sub_mgr/libsub_mgr_exports.h>

namespace Teamcenter
{
    class ImanActionHandlerDelegate;
}
namespace Teamcenter
{
    class ImanActionHandlerImpl;
}
namespace Teamcenter
{
    class ImanActionHandler;
}
namespace Teamcenter
{
    class ImanActionHandlerGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  SUB_MGR_API Teamcenter_alias::ImanActionHandlerDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ImanActionHandlerDelegate instance
    static ImanActionHandlerDelegate&  getInstance();

    //  Method to create the ImanActionHandlerImpl pointer
    static ImanActionHandlerImpl*  createImpl( ImanActionHandler&  ifObj );

    //  Method to delete the ImanActionHandlerImpl pointer
    static void deleteImpl( ImanActionHandlerImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static ImanActionHandlerDelegate*  m_pInstance;

    ImanActionHandlerDelegate();
    virtual ~ImanActionHandlerDelegate();
    static void setInstance( ImanActionHandlerDelegate*  instance );


private:
    friend class  ::Teamcenter::ImanActionHandlerGenImpl;

};

#include <sub_mgr/libsub_mgr_undef.h>
#endif  //  TEAMCENTER__IMANACTIONHANDLERDELEGATE_HXX
