//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ImanEvent
    Filename:   ImanEvent.hxx
    Module:     sub_mgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IMANEVENT__HXX
#define TEAMCENTER__IMANEVENT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <sub_mgr/libsub_mgr_exports.h>

namespace Teamcenter
{
    class ImanEvent;
}
namespace Teamcenter
{
    class ImanEventImpl;
}
namespace Teamcenter
{
    class ImanEventDelegate;
}
namespace Teamcenter
{
    class ImanEventDispatch;
}
namespace Teamcenter
{
    class ImanEventGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SUB_MGR_API  Teamcenter::ImanEvent
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ImanEvent();

    /**
     * Destructor
     */
    virtual ~ImanEvent();

private:
    //  Getter method for the Implementation Object
    ImanEventImpl*  getImanEventImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setImanEventImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ImanEventImpl*  m_imaneventImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ImanEvent - desc for ImanEvent parameter
     */
    ImanEvent( const ImanEvent& );
    ImanEvent& operator=( const ImanEvent& );

    friend class  ImanEventDelegate;
    friend class  ImanEventDispatch;
    friend class  ImanEventGenImpl;
};

#include <sub_mgr/libsub_mgr_undef.h>
#endif //   TEAMCENTER__IMANEVENT__HXX
