//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ImanEventType
    Filename:   ImanEventType.hxx
    Module:     sub_mgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IMANEVENTTYPE__HXX
#define TEAMCENTER__IMANEVENTTYPE__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <sub_mgr/libsub_mgr_exports.h>

namespace Teamcenter
{
    class ImanEventType;
}
namespace Teamcenter
{
    class ImanEventTypeImpl;
}
namespace Teamcenter
{
    class ImanEventTypeDelegate;
}
namespace Teamcenter
{
    class ImanEventTypeDispatch;
}
namespace Teamcenter
{
    class ImanEventTypeGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SUB_MGR_API  Teamcenter::ImanEventType
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0eventtype_name( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0eventtype_name( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ImanEventType();

    /**
     * Destructor
     */
    virtual ~ImanEventType();

private:
    //  Getter method for the Implementation Object
    ImanEventTypeImpl*  getImanEventTypeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setImanEventTypeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ImanEventTypeImpl*  m_imaneventtypeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ImanEventType - desc for ImanEventType parameter
     */
    ImanEventType( const ImanEventType& );
    ImanEventType& operator=( const ImanEventType& );

    friend class  ImanEventTypeDelegate;
    friend class  ImanEventTypeDispatch;
    friend class  ImanEventTypeGenImpl;
};

#include <sub_mgr/libsub_mgr_undef.h>
#endif //   TEAMCENTER__IMANEVENTTYPE__HXX
