//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ImanEventTypeDelegate
    Filename:   ImanEventTypeDelegate.hxx
    Module:     sub_mgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IMANEVENTTYPEDELEGATE_HXX
#define TEAMCENTER__IMANEVENTTYPEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <sub_mgr/ImanEventType.hxx>

#include <sub_mgr/libsub_mgr_exports.h>

namespace Teamcenter
{
    class ImanEventTypeDelegate;
}
namespace Teamcenter
{
    class ImanEventTypeImpl;
}
namespace Teamcenter
{
    class ImanEventType;
}
namespace Teamcenter
{
    class ImanEventTypeGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  SUB_MGR_API Teamcenter_alias::ImanEventTypeDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ImanEventTypeDelegate instance
    static ImanEventTypeDelegate&  getInstance();

    //  Method to create the ImanEventTypeImpl pointer
    static ImanEventTypeImpl*  createImpl( ImanEventType&  ifObj );

    //  Method to delete the ImanEventTypeImpl pointer
    static void deleteImpl( ImanEventTypeImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0eventtype_nameBase(const ImanEventType &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0eventtype_nameBase(ImanEventType &ifObj,  const std::string &value, bool isNull );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static ImanEventTypeDelegate*  m_pInstance;

    ImanEventTypeDelegate();
    virtual ~ImanEventTypeDelegate();
    static void setInstance( ImanEventTypeDelegate*  instance );


private:
    friend class  ::Teamcenter::ImanEventTypeGenImpl;

};

#include <sub_mgr/libsub_mgr_undef.h>
#endif  //  TEAMCENTER__IMANEVENTTYPEDELEGATE_HXX
