//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ImanSubscriptionDelegate
    Filename:   ImanSubscriptionDelegate.hxx
    Module:     sub_mgr
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IMANSUBSCRIPTIONDELEGATE_HXX
#define TEAMCENTER__IMANSUBSCRIPTIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <sub_mgr/ImanSubscription.hxx>

#include <sub_mgr/libsub_mgr_exports.h>

namespace Teamcenter
{
    class ImanSubscriptionDelegate;
}
namespace Teamcenter
{
    class ImanSubscriptionImpl;
}
namespace Teamcenter
{
    class ImanSubscription;
}
namespace Teamcenter
{
    class ImanSubscriptionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  SUB_MGR_API Teamcenter_alias::ImanSubscriptionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ImanSubscriptionDelegate instance
    static ImanSubscriptionDelegate&  getInstance();

    //  Method to create the ImanSubscriptionImpl pointer
    static ImanSubscriptionImpl*  createImpl( ImanSubscription&  ifObj );

    //  Method to delete the ImanSubscriptionImpl pointer
    static void deleteImpl( ImanSubscriptionImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0IsClassBasedBase(const ImanSubscription &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIs_modifiableBase(const ImanSubscription &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getNotificationBase(const ImanSubscription &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Date Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setExecution_timeBase(ImanSubscription &ifObj,  const date_t &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setNotificationBase(ImanSubscription &ifObj,  const tag_t &value, bool isNull );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const ImanSubscription &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const ImanSubscription &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const ImanSubscription &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static ImanSubscriptionDelegate*  m_pInstance;

    ImanSubscriptionDelegate();
    virtual ~ImanSubscriptionDelegate();
    static void setInstance( ImanSubscriptionDelegate*  instance );


private:
    friend class  ::Teamcenter::ImanSubscriptionGenImpl;

};

#include <sub_mgr/libsub_mgr_undef.h>
#endif  //  TEAMCENTER__IMANSUBSCRIPTIONDELEGATE_HXX
