//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  sub_mgr

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libsub_mgr

#if !defined(LIBSUB_MGR) && !defined(IPLIB)
#   error IPLIB or LIBSUB_MGR is not defined
#endif

/* Handwritten code should use SUB_MGR_API, not SUB_MGREXPORT */

#define SUB_MGR_API SUB_MGREXPORT

#if IPLIB==libsub_mgr || defined(LIBSUB_MGR)
#   if defined(__lint)
#       define SUB_MGREXPORT       __export(sub_mgr)
#       define SUB_MGRGLOBAL       extern __global(sub_mgr)
#       define SUB_MGRPRIVATE      extern __private(sub_mgr)
#   elif defined(_WIN32)
#       define SUB_MGREXPORT       __declspec(dllexport)
#       define SUB_MGRGLOBAL       extern __declspec(dllexport)
#       define SUB_MGRPRIVATE      extern
#   else
#       define SUB_MGREXPORT
#       define SUB_MGRGLOBAL       extern
#       define SUB_MGRPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define SUB_MGREXPORT       __export(sub_mgr)
#       define SUB_MGRGLOBAL       extern __global(sub_mgr)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define SUB_MGREXPORT      __declspec(dllimport)
#       define SUB_MGRGLOBAL       extern __declspec(dllimport)
#   else
#       define SUB_MGREXPORT
#       define SUB_MGRGLOBAL       extern
#   endif
#endif
