//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Seg0Alignment
    Filename:   Seg0Alignment.hxx
    Module:     systemsengineering
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SYSTEMSENGINEERING__SEG0ALIGNMENT__HXX
#define TEAMCENTER__SYSTEMSENGINEERING__SEG0ALIGNMENT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <systemsengineering/libsystemsengineering_exports.h>

namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0Alignment;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0AlignmentImpl;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0AlignmentDelegate;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0AlignmentDispatch;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0AlignmentGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SYSTEMSENGINEERING_API  Teamcenter::systemsengineering::Seg0Alignment
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.2.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIs_modifiable( bool &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Seg0Alignment();

    /**
     * Destructor
     */
    virtual ~Seg0Alignment();

private:
    //  Getter method for the Implementation Object
    Seg0AlignmentImpl*  getSeg0AlignmentImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSeg0AlignmentImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Seg0AlignmentImpl*  m_seg0alignmentImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Seg0Alignment - desc for Seg0Alignment parameter
     */
    Seg0Alignment( const Seg0Alignment& );
    Seg0Alignment& operator=( const Seg0Alignment& );

    friend class  Seg0AlignmentDelegate;
    friend class  Seg0AlignmentDispatch;
    friend class  Seg0AlignmentGenImpl;
};

#include <systemsengineering/libsystemsengineering_undef.h>
#endif //   TEAMCENTER__SYSTEMSENGINEERING__SEG0ALIGNMENT__HXX
