//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Seg0AlignmentDelegate
    Filename:   Seg0AlignmentDelegate.hxx
    Module:     systemsengineering
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SYSTEMSENGINEERING__SEG0ALIGNMENTDELEGATE_HXX
#define TEAMCENTER__SYSTEMSENGINEERING__SEG0ALIGNMENTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <systemsengineering/Seg0Alignment.hxx>

#include <systemsengineering/libsystemsengineering_exports.h>

namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0AlignmentDelegate;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0AlignmentImpl;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0Alignment;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0AlignmentGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SYSTEMSENGINEERING_API Teamcenter_alias::systemsengineering::Seg0AlignmentDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Seg0AlignmentDelegate instance
    static Seg0AlignmentDelegate&  getInstance();

    //  Method to create the Seg0AlignmentImpl pointer
    static Seg0AlignmentImpl*  createImpl( Seg0Alignment&  ifObj );

    //  Method to delete the Seg0AlignmentImpl pointer
    static void deleteImpl( Seg0AlignmentImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.2.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIs_modifiableBase(const Seg0Alignment &ifObj,  bool &value, bool &isNull ) const;



protected:
    //  Pointer to the instance
    static Seg0AlignmentDelegate*  m_pInstance;

    Seg0AlignmentDelegate();
    virtual ~Seg0AlignmentDelegate();
    static void setInstance( Seg0AlignmentDelegate*  instance );


private:
    friend class  ::Teamcenter::systemsengineering::Seg0AlignmentGenImpl;

};

#include <systemsengineering/libsystemsengineering_undef.h>
#endif  //  TEAMCENTER__SYSTEMSENGINEERING__SEG0ALIGNMENTDELEGATE_HXX
