//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Seg0AlignmentMapRevision
    Filename:   Seg0AlignmentMapRevision.hxx
    Module:     systemsengineering
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SYSTEMSENGINEERING__SEG0ALIGNMENTMAPREVISION__HXX
#define TEAMCENTER__SYSTEMSENGINEERING__SEG0ALIGNMENTMAPREVISION__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <systemsengineering/libsystemsengineering_exports.h>

namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0AlignmentMapRevision;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0AlignmentMapRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0AlignmentMapRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0AlignmentMapRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0AlignmentMapRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SYSTEMSENGINEERING_API  Teamcenter::systemsengineering::Seg0AlignmentMapRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.2.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getSeg0Alignments( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Seg0AlignmentMapRevision();

    /**
     * Destructor
     */
    virtual ~Seg0AlignmentMapRevision();

private:
    //  Getter method for the Implementation Object
    Seg0AlignmentMapRevisionImpl*  getSeg0AlignmentMapRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSeg0AlignmentMapRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Seg0AlignmentMapRevisionImpl*  m_seg0alignmentmaprevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Seg0AlignmentMapRevision - desc for Seg0AlignmentMapRevision parameter
     */
    Seg0AlignmentMapRevision( const Seg0AlignmentMapRevision& );
    Seg0AlignmentMapRevision& operator=( const Seg0AlignmentMapRevision& );

    friend class  Seg0AlignmentMapRevisionDelegate;
    friend class  Seg0AlignmentMapRevisionDispatch;
    friend class  Seg0AlignmentMapRevisionGenImpl;
};

#include <systemsengineering/libsystemsengineering_undef.h>
#endif //   TEAMCENTER__SYSTEMSENGINEERING__SEG0ALIGNMENTMAPREVISION__HXX
