//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Seg0AlignmentMapRevisionDelegate
    Filename:   Seg0AlignmentMapRevisionDelegate.hxx
    Module:     systemsengineering
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SYSTEMSENGINEERING__SEG0ALIGNMENTMAPREVISIONDELEGATE_HXX
#define TEAMCENTER__SYSTEMSENGINEERING__SEG0ALIGNMENTMAPREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <systemsengineering/Seg0AlignmentMapRevision.hxx>

#include <systemsengineering/libsystemsengineering_exports.h>

namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0AlignmentMapRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0AlignmentMapRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0AlignmentMapRevision;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0AlignmentMapRevisionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SYSTEMSENGINEERING_API Teamcenter_alias::systemsengineering::Seg0AlignmentMapRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Seg0AlignmentMapRevisionDelegate instance
    static Seg0AlignmentMapRevisionDelegate&  getInstance();

    //  Method to create the Seg0AlignmentMapRevisionImpl pointer
    static Seg0AlignmentMapRevisionImpl*  createImpl( Seg0AlignmentMapRevision&  ifObj );

    //  Method to delete the Seg0AlignmentMapRevisionImpl pointer
    static void deleteImpl( Seg0AlignmentMapRevisionImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.2.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getSeg0AlignmentsBase(const Seg0AlignmentMapRevision &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;



protected:
    //  Pointer to the instance
    static Seg0AlignmentMapRevisionDelegate*  m_pInstance;

    Seg0AlignmentMapRevisionDelegate();
    virtual ~Seg0AlignmentMapRevisionDelegate();
    static void setInstance( Seg0AlignmentMapRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::systemsengineering::Seg0AlignmentMapRevisionGenImpl;

};

#include <systemsengineering/libsystemsengineering_undef.h>
#endif  //  TEAMCENTER__SYSTEMSENGINEERING__SEG0ALIGNMENTMAPREVISIONDELEGATE_HXX
