//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Seg0Budget
    Filename:   Seg0Budget.hxx
    Module:     systemsengineering
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SYSTEMSENGINEERING__SEG0BUDGET__HXX
#define TEAMCENTER__SYSTEMSENGINEERING__SEG0BUDGET__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <systemsengineering/libsystemsengineering_exports.h>

namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0Budget;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0BudgetImpl;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0BudgetDelegate;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0BudgetDispatch;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0BudgetGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SYSTEMSENGINEERING_API  Teamcenter::systemsengineering::Seg0Budget
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Seg0Budget();

    /**
     * Destructor
     */
    virtual ~Seg0Budget();

private:
    //  Getter method for the Implementation Object
    Seg0BudgetImpl*  getSeg0BudgetImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSeg0BudgetImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Seg0BudgetImpl*  m_seg0budgetImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Seg0Budget - desc for Seg0Budget parameter
     */
    Seg0Budget( const Seg0Budget& );
    Seg0Budget& operator=( const Seg0Budget& );

    friend class  Seg0BudgetDelegate;
    friend class  Seg0BudgetDispatch;
    friend class  Seg0BudgetGenImpl;
};

#include <systemsengineering/libsystemsengineering_undef.h>
#endif //   TEAMCENTER__SYSTEMSENGINEERING__SEG0BUDGET__HXX
