//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Seg0BudgetDefinition
    Filename:   Seg0BudgetDefinition.hxx
    Module:     systemsengineering
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SYSTEMSENGINEERING__SEG0BUDGETDEFINITION__HXX
#define TEAMCENTER__SYSTEMSENGINEERING__SEG0BUDGETDEFINITION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <systemsengineering/libsystemsengineering_exports.h>

namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0BudgetDefinition;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0BudgetDefinitionImpl;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0BudgetDefinitionDelegate;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0BudgetDefinitionDispatch;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0BudgetDefinitionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SYSTEMSENGINEERING_API  Teamcenter::systemsengineering::Seg0BudgetDefinition
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Seg0BudgetDefinition();

    /**
     * Destructor
     */
    virtual ~Seg0BudgetDefinition();

private:
    //  Getter method for the Implementation Object
    Seg0BudgetDefinitionImpl*  getSeg0BudgetDefinitionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSeg0BudgetDefinitionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Seg0BudgetDefinitionImpl*  m_seg0budgetdefinitionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Seg0BudgetDefinition - desc for Seg0BudgetDefinition parameter
     */
    Seg0BudgetDefinition( const Seg0BudgetDefinition& );
    Seg0BudgetDefinition& operator=( const Seg0BudgetDefinition& );

    friend class  Seg0BudgetDefinitionDelegate;
    friend class  Seg0BudgetDefinitionDispatch;
    friend class  Seg0BudgetDefinitionGenImpl;
};

#include <systemsengineering/libsystemsengineering_undef.h>
#endif //   TEAMCENTER__SYSTEMSENGINEERING__SEG0BUDGETDEFINITION__HXX
