//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Seg0BudgetRelation
    Filename:   Seg0BudgetRelation.hxx
    Module:     systemsengineering
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SYSTEMSENGINEERING__SEG0BUDGETRELATION__HXX
#define TEAMCENTER__SYSTEMSENGINEERING__SEG0BUDGETRELATION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <systemsengineering/libsystemsengineering_exports.h>

namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0BudgetRelation;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0BudgetRelationImpl;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0BudgetRelationDelegate;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0BudgetRelationDispatch;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0BudgetRelationGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SYSTEMSENGINEERING_API  Teamcenter::systemsengineering::Seg0BudgetRelation
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Seg0BudgetRelation();

    /**
     * Destructor
     */
    virtual ~Seg0BudgetRelation();

private:
    //  Getter method for the Implementation Object
    Seg0BudgetRelationImpl*  getSeg0BudgetRelationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSeg0BudgetRelationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Seg0BudgetRelationImpl*  m_seg0budgetrelationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Seg0BudgetRelation - desc for Seg0BudgetRelation parameter
     */
    Seg0BudgetRelation( const Seg0BudgetRelation& );
    Seg0BudgetRelation& operator=( const Seg0BudgetRelation& );

    friend class  Seg0BudgetRelationDelegate;
    friend class  Seg0BudgetRelationDispatch;
    friend class  Seg0BudgetRelationGenImpl;
};

#include <systemsengineering/libsystemsengineering_undef.h>
#endif //   TEAMCENTER__SYSTEMSENGINEERING__SEG0BUDGETRELATION__HXX
