//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Seg0Diagram
    Filename:   Seg0Diagram.hxx
    Module:     systemsengineering
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SYSTEMSENGINEERING__SEG0DIAGRAM__HXX
#define TEAMCENTER__SYSTEMSENGINEERING__SEG0DIAGRAM__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <ae/Dataset.hxx>

#include <systemsengineering/libsystemsengineering_exports.h>

namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0Diagram;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0DiagramImpl;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0DiagramDelegate;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0DiagramDispatch;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0DiagramGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SYSTEMSENGINEERING_API  Teamcenter::systemsengineering::Seg0Diagram
     : public  ::Teamcenter::Dataset
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSeg0OwningModel( tag_t &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Seg0Diagram();

    /**
     * Destructor
     */
    virtual ~Seg0Diagram();

private:
    //  Getter method for the Implementation Object
    Seg0DiagramImpl*  getSeg0DiagramImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSeg0DiagramImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Seg0DiagramImpl*  m_seg0diagramImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Seg0Diagram - desc for Seg0Diagram parameter
     */
    Seg0Diagram( const Seg0Diagram& );
    Seg0Diagram& operator=( const Seg0Diagram& );

    friend class  Seg0DiagramDelegate;
    friend class  Seg0DiagramDispatch;
    friend class  Seg0DiagramGenImpl;
};

#include <systemsengineering/libsystemsengineering_undef.h>
#endif //   TEAMCENTER__SYSTEMSENGINEERING__SEG0DIAGRAM__HXX
