//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Seg0Implements
    Filename:   Seg0Implements.hxx
    Module:     systemsengineering
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SYSTEMSENGINEERING__SEG0IMPLEMENTS__HXX
#define TEAMCENTER__SYSTEMSENGINEERING__SEG0IMPLEMENTS__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <systemsengineering/libsystemsengineering_exports.h>

namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0Implements;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0ImplementsImpl;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0ImplementsDelegate;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0ImplementsDispatch;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0ImplementsGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SYSTEMSENGINEERING_API  Teamcenter::systemsengineering::Seg0Implements
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSeg0Direction( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Seg0Implements();

    /**
     * Destructor
     */
    virtual ~Seg0Implements();

private:
    //  Getter method for the Implementation Object
    Seg0ImplementsImpl*  getSeg0ImplementsImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSeg0ImplementsImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Seg0ImplementsImpl*  m_seg0implementsImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Seg0Implements - desc for Seg0Implements parameter
     */
    Seg0Implements( const Seg0Implements& );
    Seg0Implements& operator=( const Seg0Implements& );

    friend class  Seg0ImplementsDelegate;
    friend class  Seg0ImplementsDispatch;
    friend class  Seg0ImplementsGenImpl;
};

#include <systemsengineering/libsystemsengineering_undef.h>
#endif //   TEAMCENTER__SYSTEMSENGINEERING__SEG0IMPLEMENTS__HXX
