//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Seg0ImplementsDelegate
    Filename:   Seg0ImplementsDelegate.hxx
    Module:     systemsengineering
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SYSTEMSENGINEERING__SEG0IMPLEMENTSDELEGATE_HXX
#define TEAMCENTER__SYSTEMSENGINEERING__SEG0IMPLEMENTSDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <systemsengineering/Seg0Implements.hxx>

#include <systemsengineering/libsystemsengineering_exports.h>

namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0ImplementsDelegate;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0ImplementsImpl;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0Implements;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0ImplementsGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SYSTEMSENGINEERING_API Teamcenter_alias::systemsengineering::Seg0ImplementsDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Seg0ImplementsDelegate instance
    static Seg0ImplementsDelegate&  getInstance();

    //  Method to create the Seg0ImplementsImpl pointer
    static Seg0ImplementsImpl*  createImpl( Seg0Implements&  ifObj );

    //  Method to delete the Seg0ImplementsImpl pointer
    static void deleteImpl( Seg0ImplementsImpl*  impl );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSeg0DirectionBase(Seg0Implements &ifObj,  const std::string &value, bool isNull );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Seg0Implements &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Seg0ImplementsDelegate*  m_pInstance;

    Seg0ImplementsDelegate();
    virtual ~Seg0ImplementsDelegate();
    static void setInstance( Seg0ImplementsDelegate*  instance );


private:
    friend class  ::Teamcenter::systemsengineering::Seg0ImplementsGenImpl;

};

#include <systemsengineering/libsystemsengineering_undef.h>
#endif  //  TEAMCENTER__SYSTEMSENGINEERING__SEG0IMPLEMENTSDELEGATE_HXX
