//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Seg0Interaction
    Filename:   Seg0Interaction.hxx
    Module:     systemsengineering
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SYSTEMSENGINEERING__SEG0INTERACTION__HXX
#define TEAMCENTER__SYSTEMSENGINEERING__SEG0INTERACTION__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <systemsengineering/Seg0Alignment.hxx>

#include <systemsengineering/libsystemsengineering_exports.h>

namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0Interaction;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InteractionImpl;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InteractionDelegate;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InteractionDispatch;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InteractionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SYSTEMSENGINEERING_API  Teamcenter::systemsengineering::Seg0Interaction
     : public  ::Teamcenter::systemsengineering::Seg0Alignment
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.2.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getSeg0InteractionElements( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Seg0Interaction();

    /**
     * Destructor
     */
    virtual ~Seg0Interaction();

private:
    //  Getter method for the Implementation Object
    Seg0InteractionImpl*  getSeg0InteractionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSeg0InteractionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Seg0InteractionImpl*  m_seg0interactionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Seg0Interaction - desc for Seg0Interaction parameter
     */
    Seg0Interaction( const Seg0Interaction& );
    Seg0Interaction& operator=( const Seg0Interaction& );

    friend class  Seg0InteractionDelegate;
    friend class  Seg0InteractionDispatch;
    friend class  Seg0InteractionGenImpl;
};

#include <systemsengineering/libsystemsengineering_undef.h>
#endif //   TEAMCENTER__SYSTEMSENGINEERING__SEG0INTERACTION__HXX
