//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Seg0InteractionDelegate
    Filename:   Seg0InteractionDelegate.hxx
    Module:     systemsengineering
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SYSTEMSENGINEERING__SEG0INTERACTIONDELEGATE_HXX
#define TEAMCENTER__SYSTEMSENGINEERING__SEG0INTERACTIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <systemsengineering/Seg0Interaction.hxx>

#include <systemsengineering/libsystemsengineering_exports.h>

namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InteractionDelegate;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InteractionImpl;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0Interaction;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InteractionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SYSTEMSENGINEERING_API Teamcenter_alias::systemsengineering::Seg0InteractionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Seg0InteractionDelegate instance
    static Seg0InteractionDelegate&  getInstance();

    //  Method to create the Seg0InteractionImpl pointer
    static Seg0InteractionImpl*  createImpl( Seg0Interaction&  ifObj );

    //  Method to delete the Seg0InteractionImpl pointer
    static void deleteImpl( Seg0InteractionImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.2.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getSeg0InteractionElementsBase(const Seg0Interaction &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Seg0Interaction &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const Seg0Interaction &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Seg0Interaction &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Seg0InteractionDelegate*  m_pInstance;

    Seg0InteractionDelegate();
    virtual ~Seg0InteractionDelegate();
    static void setInstance( Seg0InteractionDelegate*  instance );


private:
    friend class  ::Teamcenter::systemsengineering::Seg0InteractionGenImpl;

};

#include <systemsengineering/libsystemsengineering_undef.h>
#endif  //  TEAMCENTER__SYSTEMSENGINEERING__SEG0INTERACTIONDELEGATE_HXX
