//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Seg0InteractionElement
    Filename:   Seg0InteractionElement.hxx
    Module:     systemsengineering
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SYSTEMSENGINEERING__SEG0INTERACTIONELEMENT__HXX
#define TEAMCENTER__SYSTEMSENGINEERING__SEG0INTERACTIONELEMENT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <systemsengineering/libsystemsengineering_exports.h>

namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InteractionElement;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InteractionElementImpl;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InteractionElementDelegate;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InteractionElementDispatch;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InteractionElementGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SYSTEMSENGINEERING_API  Teamcenter::systemsengineering::Seg0InteractionElement
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Seg0InteractionElement();

    /**
     * Destructor
     */
    virtual ~Seg0InteractionElement();

private:
    //  Getter method for the Implementation Object
    Seg0InteractionElementImpl*  getSeg0InteractionElementImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSeg0InteractionElementImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Seg0InteractionElementImpl*  m_seg0interactionelementImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Seg0InteractionElement - desc for Seg0InteractionElement parameter
     */
    Seg0InteractionElement( const Seg0InteractionElement& );
    Seg0InteractionElement& operator=( const Seg0InteractionElement& );

    friend class  Seg0InteractionElementDelegate;
    friend class  Seg0InteractionElementDispatch;
    friend class  Seg0InteractionElementGenImpl;
};

#include <systemsengineering/libsystemsengineering_undef.h>
#endif //   TEAMCENTER__SYSTEMSENGINEERING__SEG0INTERACTIONELEMENT__HXX
