//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Seg0InteractionElementDelegate
    Filename:   Seg0InteractionElementDelegate.hxx
    Module:     systemsengineering
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SYSTEMSENGINEERING__SEG0INTERACTIONELEMENTDELEGATE_HXX
#define TEAMCENTER__SYSTEMSENGINEERING__SEG0INTERACTIONELEMENTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <systemsengineering/Seg0InteractionElement.hxx>

#include <systemsengineering/libsystemsengineering_exports.h>

namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InteractionElementDelegate;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InteractionElementImpl;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InteractionElement;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InteractionElementGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SYSTEMSENGINEERING_API Teamcenter_alias::systemsengineering::Seg0InteractionElementDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Seg0InteractionElementDelegate instance
    static Seg0InteractionElementDelegate&  getInstance();

    //  Method to create the Seg0InteractionElementImpl pointer
    static Seg0InteractionElementImpl*  createImpl( Seg0InteractionElement&  ifObj );

    //  Method to delete the Seg0InteractionElementImpl pointer
    static void deleteImpl( Seg0InteractionElementImpl*  impl );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Seg0InteractionElement &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Seg0InteractionElementDelegate*  m_pInstance;

    Seg0InteractionElementDelegate();
    virtual ~Seg0InteractionElementDelegate();
    static void setInstance( Seg0InteractionElementDelegate*  instance );


private:
    friend class  ::Teamcenter::systemsengineering::Seg0InteractionElementGenImpl;

};

#include <systemsengineering/libsystemsengineering_undef.h>
#endif  //  TEAMCENTER__SYSTEMSENGINEERING__SEG0INTERACTIONELEMENTDELEGATE_HXX
