//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Seg0InteractionLink
    Filename:   Seg0InteractionLink.hxx
    Module:     systemsengineering
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SYSTEMSENGINEERING__SEG0INTERACTIONLINK__HXX
#define TEAMCENTER__SYSTEMSENGINEERING__SEG0INTERACTIONLINK__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <systemsengineering/libsystemsengineering_exports.h>

namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InteractionLink;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InteractionLinkImpl;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InteractionLinkDelegate;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InteractionLinkDispatch;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InteractionLinkGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SYSTEMSENGINEERING_API  Teamcenter::systemsengineering::Seg0InteractionLink
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Seg0InteractionLink();

    /**
     * Destructor
     */
    virtual ~Seg0InteractionLink();

private:
    //  Getter method for the Implementation Object
    Seg0InteractionLinkImpl*  getSeg0InteractionLinkImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSeg0InteractionLinkImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Seg0InteractionLinkImpl*  m_seg0interactionlinkImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Seg0InteractionLink - desc for Seg0InteractionLink parameter
     */
    Seg0InteractionLink( const Seg0InteractionLink& );
    Seg0InteractionLink& operator=( const Seg0InteractionLink& );

    friend class  Seg0InteractionLinkDelegate;
    friend class  Seg0InteractionLinkDispatch;
    friend class  Seg0InteractionLinkGenImpl;
};

#include <systemsengineering/libsystemsengineering_undef.h>
#endif //   TEAMCENTER__SYSTEMSENGINEERING__SEG0INTERACTIONLINK__HXX
