//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Seg0InteractionLinkDelegate
    Filename:   Seg0InteractionLinkDelegate.hxx
    Module:     systemsengineering
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SYSTEMSENGINEERING__SEG0INTERACTIONLINKDELEGATE_HXX
#define TEAMCENTER__SYSTEMSENGINEERING__SEG0INTERACTIONLINKDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <systemsengineering/Seg0InteractionLink.hxx>

#include <systemsengineering/libsystemsengineering_exports.h>

namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InteractionLinkDelegate;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InteractionLinkImpl;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InteractionLink;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InteractionLinkGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SYSTEMSENGINEERING_API Teamcenter_alias::systemsengineering::Seg0InteractionLinkDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Seg0InteractionLinkDelegate instance
    static Seg0InteractionLinkDelegate&  getInstance();

    //  Method to create the Seg0InteractionLinkImpl pointer
    static Seg0InteractionLinkImpl*  createImpl( Seg0InteractionLink&  ifObj );

    //  Method to delete the Seg0InteractionLinkImpl pointer
    static void deleteImpl( Seg0InteractionLinkImpl*  impl );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Seg0InteractionLink &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Seg0InteractionLinkDelegate*  m_pInstance;

    Seg0InteractionLinkDelegate();
    virtual ~Seg0InteractionLinkDelegate();
    static void setInstance( Seg0InteractionLinkDelegate*  instance );


private:
    friend class  ::Teamcenter::systemsengineering::Seg0InteractionLinkGenImpl;

};

#include <systemsengineering/libsystemsengineering_undef.h>
#endif  //  TEAMCENTER__SYSTEMSENGINEERING__SEG0INTERACTIONLINKDELEGATE_HXX
