//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Seg0Interconnection
    Filename:   Seg0Interconnection.hxx
    Module:     systemsengineering
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SYSTEMSENGINEERING__SEG0INTERCONNECTION__HXX
#define TEAMCENTER__SYSTEMSENGINEERING__SEG0INTERCONNECTION__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <Att0attrtargetmgmt/Att0AbstractMapping.hxx>

#include <systemsengineering/libsystemsengineering_exports.h>

namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0Interconnection;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InterconnectionImpl;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InterconnectionDelegate;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InterconnectionDispatch;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InterconnectionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SYSTEMSENGINEERING_API  Teamcenter::systemsengineering::Seg0Interconnection
     : public  ::att0attrtargetmgmt::Att0AbstractMapping
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.4
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getSeg0FromSystems( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.4
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getSeg0ToSystems( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Seg0Interconnection();

    /**
     * Destructor
     */
    virtual ~Seg0Interconnection();

private:
    //  Getter method for the Implementation Object
    Seg0InterconnectionImpl*  getSeg0InterconnectionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSeg0InterconnectionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Seg0InterconnectionImpl*  m_seg0interconnectionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Seg0Interconnection - desc for Seg0Interconnection parameter
     */
    Seg0Interconnection( const Seg0Interconnection& );
    Seg0Interconnection& operator=( const Seg0Interconnection& );

    friend class  Seg0InterconnectionDelegate;
    friend class  Seg0InterconnectionDispatch;
    friend class  Seg0InterconnectionGenImpl;
};

#include <systemsengineering/libsystemsengineering_undef.h>
#endif //   TEAMCENTER__SYSTEMSENGINEERING__SEG0INTERCONNECTION__HXX
