//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Seg0InterconnectionDelegate
    Filename:   Seg0InterconnectionDelegate.hxx
    Module:     systemsengineering
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SYSTEMSENGINEERING__SEG0INTERCONNECTIONDELEGATE_HXX
#define TEAMCENTER__SYSTEMSENGINEERING__SEG0INTERCONNECTIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <systemsengineering/Seg0Interconnection.hxx>

#include <systemsengineering/libsystemsengineering_exports.h>

namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InterconnectionDelegate;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InterconnectionImpl;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0Interconnection;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InterconnectionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SYSTEMSENGINEERING_API Teamcenter_alias::systemsengineering::Seg0InterconnectionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Seg0InterconnectionDelegate instance
    static Seg0InterconnectionDelegate&  getInstance();

    //  Method to create the Seg0InterconnectionImpl pointer
    static Seg0InterconnectionImpl*  createImpl( Seg0Interconnection&  ifObj );

    //  Method to delete the Seg0InterconnectionImpl pointer
    static void deleteImpl( Seg0InterconnectionImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.4
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getSeg0FromSystemsBase(const Seg0Interconnection &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.4
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getSeg0ToSystemsBase(const Seg0Interconnection &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Seg0Interconnection &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Seg0InterconnectionDelegate*  m_pInstance;

    Seg0InterconnectionDelegate();
    virtual ~Seg0InterconnectionDelegate();
    static void setInstance( Seg0InterconnectionDelegate*  instance );


private:
    friend class  ::Teamcenter::systemsengineering::Seg0InterconnectionGenImpl;

};

#include <systemsengineering/libsystemsengineering_undef.h>
#endif  //  TEAMCENTER__SYSTEMSENGINEERING__SEG0INTERCONNECTIONDELEGATE_HXX
