//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Seg0InterfaceElement
    Filename:   Seg0InterfaceElement.hxx
    Module:     systemsengineering
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SYSTEMSENGINEERING__SEG0INTERFACEELEMENT__HXX
#define TEAMCENTER__SYSTEMSENGINEERING__SEG0INTERFACEELEMENT__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <systemsengineering/libsystemsengineering_exports.h>

namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InterfaceElement;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InterfaceElementImpl;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InterfaceElementDelegate;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InterfaceElementDispatch;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InterfaceElementGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SYSTEMSENGINEERING_API  Teamcenter::systemsengineering::Seg0InterfaceElement
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIs_modifiable( bool &value, bool &isNull ) const;

    ///
    /// Operation to set seg0Direction property seg0InterfaceElement
    /// @version Teamcenter 11.2.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSeg0Direction( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSeg0Subject( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Seg0InterfaceElement();

    /**
     * Destructor
     */
    virtual ~Seg0InterfaceElement();

private:
    //  Getter method for the Implementation Object
    Seg0InterfaceElementImpl*  getSeg0InterfaceElementImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSeg0InterfaceElementImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Seg0InterfaceElementImpl*  m_seg0interfaceelementImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Seg0InterfaceElement - desc for Seg0InterfaceElement parameter
     */
    Seg0InterfaceElement( const Seg0InterfaceElement& );
    Seg0InterfaceElement& operator=( const Seg0InterfaceElement& );

    friend class  Seg0InterfaceElementDelegate;
    friend class  Seg0InterfaceElementDispatch;
    friend class  Seg0InterfaceElementGenImpl;
};

#include <systemsengineering/libsystemsengineering_undef.h>
#endif //   TEAMCENTER__SYSTEMSENGINEERING__SEG0INTERFACEELEMENT__HXX
