//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Seg0InterfaceElementDelegate
    Filename:   Seg0InterfaceElementDelegate.hxx
    Module:     systemsengineering
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SYSTEMSENGINEERING__SEG0INTERFACEELEMENTDELEGATE_HXX
#define TEAMCENTER__SYSTEMSENGINEERING__SEG0INTERFACEELEMENTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <systemsengineering/Seg0InterfaceElement.hxx>

#include <systemsengineering/libsystemsengineering_exports.h>

namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InterfaceElementDelegate;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InterfaceElementImpl;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InterfaceElement;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0InterfaceElementGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SYSTEMSENGINEERING_API Teamcenter_alias::systemsengineering::Seg0InterfaceElementDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Seg0InterfaceElementDelegate instance
    static Seg0InterfaceElementDelegate&  getInstance();

    //  Method to create the Seg0InterfaceElementImpl pointer
    static Seg0InterfaceElementImpl*  createImpl( Seg0InterfaceElement&  ifObj );

    //  Method to delete the Seg0InterfaceElementImpl pointer
    static void deleteImpl( Seg0InterfaceElementImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.2.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIs_modifiableBase(const Seg0InterfaceElement &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Operation to set seg0Direction property seg0InterfaceElement
    /// @version Teamcenter 11.2.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSeg0DirectionBase(Seg0InterfaceElement &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSeg0SubjectBase(Seg0InterfaceElement &ifObj,  const std::string &value, bool isNull );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Seg0InterfaceElement &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Deletes the instance.
    /// @version Teamcenter 11.1
    /// @return - Failure code.
    ///
    int  fnd0DeleteBase(const Seg0InterfaceElement &ifObj  );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Seg0InterfaceElement &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Seg0InterfaceElementDelegate*  m_pInstance;

    Seg0InterfaceElementDelegate();
    virtual ~Seg0InterfaceElementDelegate();
    static void setInstance( Seg0InterfaceElementDelegate*  instance );


private:
    friend class  ::Teamcenter::systemsengineering::Seg0InterfaceElementGenImpl;

};

#include <systemsengineering/libsystemsengineering_undef.h>
#endif  //  TEAMCENTER__SYSTEMSENGINEERING__SEG0INTERFACEELEMENTDELEGATE_HXX
