//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Seg0IntfSpecRevision
    Filename:   Seg0IntfSpecRevision.hxx
    Module:     systemsengineering
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SYSTEMSENGINEERING__SEG0INTFSPECREVISION__HXX
#define TEAMCENTER__SYSTEMSENGINEERING__SEG0INTFSPECREVISION__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <systemsengineering/libsystemsengineering_exports.h>

namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0IntfSpecRevision;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0IntfSpecRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0IntfSpecRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0IntfSpecRevisionDispatch;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0IntfSpecRevisionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  SYSTEMSENGINEERING_API  Teamcenter::systemsengineering::Seg0IntfSpecRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Identifies and returns list of Seg0InterfaceElement attached to this business object.
    /// @version Teamcenter 11.2.3
    /// @param interfaceElements - List of Seg0InterfaceElement attached to this business object.
    /// @return - Returns list of Seg0InterfaceElement attached to this business object.
    ///
    int  seg0GetSeg0InterfaceElements( std::vector< tag_t > &interfaceElements );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Seg0IntfSpecRevision();

    /**
     * Destructor
     */
    virtual ~Seg0IntfSpecRevision();

private:
    //  Getter method for the Implementation Object
    Seg0IntfSpecRevisionImpl*  getSeg0IntfSpecRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setSeg0IntfSpecRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Seg0IntfSpecRevisionImpl*  m_seg0intfspecrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Seg0IntfSpecRevision - desc for Seg0IntfSpecRevision parameter
     */
    Seg0IntfSpecRevision( const Seg0IntfSpecRevision& );
    Seg0IntfSpecRevision& operator=( const Seg0IntfSpecRevision& );

    friend class  Seg0IntfSpecRevisionDelegate;
    friend class  Seg0IntfSpecRevisionDispatch;
    friend class  Seg0IntfSpecRevisionGenImpl;
};

#include <systemsengineering/libsystemsengineering_undef.h>
#endif //   TEAMCENTER__SYSTEMSENGINEERING__SEG0INTFSPECREVISION__HXX
