//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Seg0IntfSpecRevisionDelegate
    Filename:   Seg0IntfSpecRevisionDelegate.hxx
    Module:     systemsengineering
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__SYSTEMSENGINEERING__SEG0INTFSPECREVISIONDELEGATE_HXX
#define TEAMCENTER__SYSTEMSENGINEERING__SEG0INTFSPECREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <systemsengineering/Seg0IntfSpecRevision.hxx>

#include <systemsengineering/libsystemsengineering_exports.h>

namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0IntfSpecRevisionDelegate;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0IntfSpecRevisionImpl;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0IntfSpecRevision;
    }
}
namespace Teamcenter
{
    namespace systemsengineering
    {
        class Seg0IntfSpecRevisionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  SYSTEMSENGINEERING_API Teamcenter_alias::systemsengineering::Seg0IntfSpecRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Seg0IntfSpecRevisionDelegate instance
    static Seg0IntfSpecRevisionDelegate&  getInstance();

    //  Method to create the Seg0IntfSpecRevisionImpl pointer
    static Seg0IntfSpecRevisionImpl*  createImpl( Seg0IntfSpecRevision&  ifObj );

    //  Method to delete the Seg0IntfSpecRevisionImpl pointer
    static void deleteImpl( Seg0IntfSpecRevisionImpl*  impl );


    ///
    /// Identifies and returns list of Seg0InterfaceElement attached to this business object.
    /// @version Teamcenter 11.2.3
    /// @param interfaceElements - List of Seg0InterfaceElement attached to this business object.
    /// @return - Returns list of Seg0InterfaceElement attached to this business object.
    ///
    int  seg0GetSeg0InterfaceElementsBase(const Seg0IntfSpecRevision &ifObj,  std::vector< tag_t > &interfaceElements );



protected:
    //  Pointer to the instance
    static Seg0IntfSpecRevisionDelegate*  m_pInstance;

    Seg0IntfSpecRevisionDelegate();
    virtual ~Seg0IntfSpecRevisionDelegate();
    static void setInstance( Seg0IntfSpecRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::systemsengineering::Seg0IntfSpecRevisionGenImpl;

};

#include <systemsengineering/libsystemsengineering_undef.h>
#endif  //  TEAMCENTER__SYSTEMSENGINEERING__SEG0INTFSPECREVISIONDELEGATE_HXX
