//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  systemsengineering

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libsystemsengineering

#if !defined(LIBSYSTEMSENGINEERING) && !defined(IPLIB)
#   error IPLIB or LIBSYSTEMSENGINEERING is not defined
#endif

/* Handwritten code should use SYSTEMSENGINEERING_API, not SYSTEMSENGINEERINGEXPORT */

#define SYSTEMSENGINEERING_API SYSTEMSENGINEERINGEXPORT

#if IPLIB==libsystemsengineering || defined(LIBSYSTEMSENGINEERING)
#   if defined(__lint)
#       define SYSTEMSENGINEERINGEXPORT       __export(systemsengineering)
#       define SYSTEMSENGINEERINGGLOBAL       extern __global(systemsengineering)
#       define SYSTEMSENGINEERINGPRIVATE      extern __private(systemsengineering)
#   elif defined(_WIN32)
#       define SYSTEMSENGINEERINGEXPORT       __declspec(dllexport)
#       define SYSTEMSENGINEERINGGLOBAL       extern __declspec(dllexport)
#       define SYSTEMSENGINEERINGPRIVATE      extern
#   else
#       define SYSTEMSENGINEERINGEXPORT
#       define SYSTEMSENGINEERINGGLOBAL       extern
#       define SYSTEMSENGINEERINGPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define SYSTEMSENGINEERINGEXPORT       __export(systemsengineering)
#       define SYSTEMSENGINEERINGGLOBAL       extern __global(systemsengineering)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define SYSTEMSENGINEERINGEXPORT      __declspec(dllimport)
#       define SYSTEMSENGINEERINGGLOBAL       extern __declspec(dllimport)
#   else
#       define SYSTEMSENGINEERINGEXPORT
#       define SYSTEMSENGINEERINGGLOBAL       extern
#   endif
#endif
