//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ContactInCompany
    Filename:   ContactInCompany.hxx
    Module:     tc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__CONTACTINCOMPANY__HXX
#define TEAMCENTER__CONTACTINCOMPANY__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <tc/libtc_exports.h>

namespace Teamcenter
{
    class ContactInCompany;
}
namespace Teamcenter
{
    class ContactInCompanyImpl;
}
namespace Teamcenter
{
    class ContactInCompanyDelegate;
}
namespace Teamcenter
{
    class ContactInCompanyDispatch;
}
namespace Teamcenter
{
    class ContactInCompanyGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TC_API  Teamcenter::ContactInCompany
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ContactInCompany();

    /**
     * Destructor
     */
    virtual ~ContactInCompany();

private:
    //  Getter method for the Implementation Object
    ContactInCompanyImpl*  getContactInCompanyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setContactInCompanyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ContactInCompanyImpl*  m_contactincompanyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ContactInCompany - desc for ContactInCompany parameter
     */
    ContactInCompany( const ContactInCompany& );
    ContactInCompany& operator=( const ContactInCompany& );

    friend class  ContactInCompanyDelegate;
    friend class  ContactInCompanyDispatch;
    friend class  ContactInCompanyGenImpl;
};

#include <tc/libtc_undef.h>
#endif //   TEAMCENTER__CONTACTINCOMPANY__HXX
