//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DistributionList
    Filename:   DistributionList.hxx
    Module:     tc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__DISTRIBUTIONLIST__HXX
#define TEAMCENTER__DISTRIBUTIONLIST__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <tc/libtc_exports.h>

namespace Teamcenter
{
    class DistributionList;
}
namespace Teamcenter
{
    class DistributionListImpl;
}
namespace Teamcenter
{
    class DistributionListDelegate;
}
namespace Teamcenter
{
    class DistributionListDispatch;
}
namespace Teamcenter
{
    class DistributionListGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TC_API  Teamcenter::DistributionList
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    DistributionList();

    /**
     * Destructor
     */
    virtual ~DistributionList();

private:
    //  Getter method for the Implementation Object
    DistributionListImpl*  getDistributionListImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDistributionListImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DistributionListImpl*  m_distributionlistImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param DistributionList - desc for DistributionList parameter
     */
    DistributionList( const DistributionList& );
    DistributionList& operator=( const DistributionList& );

    friend class  DistributionListDelegate;
    friend class  DistributionListDispatch;
    friend class  DistributionListGenImpl;
};

#include <tc/libtc_undef.h>
#endif //   TEAMCENTER__DISTRIBUTIONLIST__HXX
