//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Envelope
    Filename:   Envelope.hxx
    Module:     tc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ENVELOPE__HXX
#define TEAMCENTER__ENVELOPE__HXX

#include <common/tc_deprecation_macros.h>
#include <tc/Folder.hxx>

#include <tc/libtc_exports.h>

namespace Teamcenter
{
    class Envelope;
}
namespace Teamcenter
{
    class EnvelopeImpl;
}
namespace Teamcenter
{
    class EnvelopeDelegate;
}
namespace Teamcenter
{
    class EnvelopeDispatch;
}
namespace Teamcenter
{
    class EnvelopeGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TC_API  Teamcenter::Envelope
     : public  ::Teamcenter::Folder
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Envelope();

    /**
     * Destructor
     */
    virtual ~Envelope();

private:
    //  Getter method for the Implementation Object
    EnvelopeImpl*  getEnvelopeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setEnvelopeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    EnvelopeImpl*  m_envelopeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Envelope - desc for Envelope parameter
     */
    Envelope( const Envelope& );
    Envelope& operator=( const Envelope& );

    friend class  EnvelopeDelegate;
    friend class  EnvelopeDispatch;
    friend class  EnvelopeGenImpl;
};

#include <tc/libtc_undef.h>
#endif //   TEAMCENTER__ENVELOPE__HXX
