//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EnvelopeDelegate
    Filename:   EnvelopeDelegate.hxx
    Module:     tc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ENVELOPEDELEGATE_HXX
#define TEAMCENTER__ENVELOPEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tc/Envelope.hxx>

#include <tc/libtc_exports.h>

namespace Teamcenter
{
    class EnvelopeDelegate;
}
namespace Teamcenter
{
    class EnvelopeImpl;
}
namespace Teamcenter
{
    class Envelope;
}
namespace Teamcenter
{
    class EnvelopeGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TC_API Teamcenter_alias::EnvelopeDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the EnvelopeDelegate instance
    static EnvelopeDelegate&  getInstance();

    //  Method to create the EnvelopeImpl pointer
    static EnvelopeImpl*  createImpl( Envelope&  ifObj );

    //  Method to delete the EnvelopeImpl pointer
    static void deleteImpl( EnvelopeImpl*  impl );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const Envelope &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static EnvelopeDelegate*  m_pInstance;

    EnvelopeDelegate();
    virtual ~EnvelopeDelegate();
    static void setInstance( EnvelopeDelegate*  instance );


private:
    friend class  ::Teamcenter::EnvelopeGenImpl;

};

#include <tc/libtc_undef.h>
#endif  //  TEAMCENTER__ENVELOPEDELEGATE_HXX
