//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0BaseProvider
    Filename:   Fnd0BaseProvider.hxx
    Module:     tc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0BASEPROVIDER__HXX
#define TEAMCENTER__FND0BASEPROVIDER__HXX

#include <metaframework/OperationInput.hxx>
#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <tc/libtc_exports.h>

namespace Teamcenter
{
    class Fnd0BaseProvider;
}
namespace Teamcenter
{
    class Fnd0BaseProviderImpl;
}
namespace Teamcenter
{
    class Fnd0BaseProviderDelegate;
}
namespace Teamcenter
{
    class Fnd0BaseProviderDispatch;
}
namespace Teamcenter
{
    class Fnd0BaseProviderGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TC_API  Teamcenter::Fnd0BaseProvider
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// This operation returns a structure containing search results, search filters for each search filter field based on the search results, and search filter categories.
    /// @version Teamcenter 9.1.2
    /// @param searchInput - The input to the search
    /// @param searchOutput - The output from the search.
    /// @return - Status. 0 if successful
    ///
    int  fnd0performSearch( ::Teamcenter::OperationInput *searchInput, ::Teamcenter::OperationInput *searchOutput );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0BaseProvider();

    /**
     * Destructor
     */
    virtual ~Fnd0BaseProvider();

private:
    //  Getter method for the Implementation Object
    Fnd0BaseProviderImpl*  getFnd0BaseProviderImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0BaseProviderImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0BaseProviderImpl*  m_fnd0baseproviderImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0BaseProvider - desc for Fnd0BaseProvider parameter
     */
    Fnd0BaseProvider( const Fnd0BaseProvider& );
    Fnd0BaseProvider& operator=( const Fnd0BaseProvider& );

    friend class  Fnd0BaseProviderDelegate;
    friend class  Fnd0BaseProviderDispatch;
    friend class  Fnd0BaseProviderGenImpl;
};

#include <tc/libtc_undef.h>
#endif //   TEAMCENTER__FND0BASEPROVIDER__HXX
