//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0LicenseInfo
    Filename:   Fnd0LicenseInfo.hxx
    Module:     tc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0LICENSEINFO__HXX
#define TEAMCENTER__FND0LICENSEINFO__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <tc/libtc_exports.h>

namespace Teamcenter
{
    class Fnd0LicenseInfo;
}
namespace Teamcenter
{
    class Fnd0LicenseInfoImpl;
}
namespace Teamcenter
{
    class Fnd0LicenseInfoDelegate;
}
namespace Teamcenter
{
    class Fnd0LicenseInfoDispatch;
}
namespace Teamcenter
{
    class Fnd0LicenseInfoGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TC_API  Teamcenter::Fnd0LicenseInfo
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 10.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0license_bundles( const std::vector< std::string > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0LicenseInfo();

    /**
     * Destructor
     */
    virtual ~Fnd0LicenseInfo();

private:
    //  Getter method for the Implementation Object
    Fnd0LicenseInfoImpl*  getFnd0LicenseInfoImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0LicenseInfoImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0LicenseInfoImpl*  m_fnd0licenseinfoImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0LicenseInfo - desc for Fnd0LicenseInfo parameter
     */
    Fnd0LicenseInfo( const Fnd0LicenseInfo& );
    Fnd0LicenseInfo& operator=( const Fnd0LicenseInfo& );

    friend class  Fnd0LicenseInfoDelegate;
    friend class  Fnd0LicenseInfoDispatch;
    friend class  Fnd0LicenseInfoGenImpl;
};

#include <tc/libtc_undef.h>
#endif //   TEAMCENTER__FND0LICENSEINFO__HXX
