//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0LicenseUsage
    Filename:   Fnd0LicenseUsage.hxx
    Module:     tc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0LICENSEUSAGE__HXX
#define TEAMCENTER__FND0LICENSEUSAGE__HXX

#include <string>
#include <unidefs.h>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <tc/libtc_exports.h>

namespace Teamcenter
{
    class Fnd0LicenseUsage;
}
namespace Teamcenter
{
    class Fnd0LicenseUsageImpl;
}
namespace Teamcenter
{
    class Fnd0LicenseUsageDelegate;
}
namespace Teamcenter
{
    class Fnd0LicenseUsageDispatch;
}
namespace Teamcenter
{
    class Fnd0LicenseUsageGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TC_API  Teamcenter::Fnd0LicenseUsage
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0home_site( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Date Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0last_usage_record_date( date_t &value, bool &isNull ) const;

    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0license_bundles( std::vector< std::string > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0LicenseServerName( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Date Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0login_time( date_t &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0pseudo_user_id( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0feature_keys( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0LicenseServerName( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0LicenseUsage();

    /**
     * Destructor
     */
    virtual ~Fnd0LicenseUsage();

private:
    //  Getter method for the Implementation Object
    Fnd0LicenseUsageImpl*  getFnd0LicenseUsageImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0LicenseUsageImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0LicenseUsageImpl*  m_fnd0licenseusageImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0LicenseUsage - desc for Fnd0LicenseUsage parameter
     */
    Fnd0LicenseUsage( const Fnd0LicenseUsage& );
    Fnd0LicenseUsage& operator=( const Fnd0LicenseUsage& );

    friend class  Fnd0LicenseUsageDelegate;
    friend class  Fnd0LicenseUsageDispatch;
    friend class  Fnd0LicenseUsageGenImpl;
};

#include <tc/libtc_undef.h>
#endif //   TEAMCENTER__FND0LICENSEUSAGE__HXX
