//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0LicenseUsageDelegate
    Filename:   Fnd0LicenseUsageDelegate.hxx
    Module:     tc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0LICENSEUSAGEDELEGATE_HXX
#define TEAMCENTER__FND0LICENSEUSAGEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tc/Fnd0LicenseUsage.hxx>

#include <tc/libtc_exports.h>

namespace Teamcenter
{
    class Fnd0LicenseUsageDelegate;
}
namespace Teamcenter
{
    class Fnd0LicenseUsageImpl;
}
namespace Teamcenter
{
    class Fnd0LicenseUsage;
}
namespace Teamcenter
{
    class Fnd0LicenseUsageGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TC_API Teamcenter_alias::Fnd0LicenseUsageDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0LicenseUsageDelegate instance
    static Fnd0LicenseUsageDelegate&  getInstance();

    //  Method to create the Fnd0LicenseUsageImpl pointer
    static Fnd0LicenseUsageImpl*  createImpl( Fnd0LicenseUsage&  ifObj );

    //  Method to delete the Fnd0LicenseUsageImpl pointer
    static void deleteImpl( Fnd0LicenseUsageImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0home_siteBase(const Fnd0LicenseUsage &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Date Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0last_usage_record_dateBase(const Fnd0LicenseUsage &ifObj,  date_t &value, bool &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0license_bundlesBase(const Fnd0LicenseUsage &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0LicenseServerNameBase(const Fnd0LicenseUsage &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Date Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0login_timeBase(const Fnd0LicenseUsage &ifObj,  date_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0pseudo_user_idBase(const Fnd0LicenseUsage &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0feature_keysBase(Fnd0LicenseUsage &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0LicenseServerNameBase(Fnd0LicenseUsage &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static Fnd0LicenseUsageDelegate*  m_pInstance;

    Fnd0LicenseUsageDelegate();
    virtual ~Fnd0LicenseUsageDelegate();
    static void setInstance( Fnd0LicenseUsageDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0LicenseUsageGenImpl;

};

#include <tc/libtc_undef.h>
#endif  //  TEAMCENTER__FND0LICENSEUSAGEDELEGATE_HXX
