//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0Message
    Filename:   Fnd0Message.hxx
    Module:     tc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0MESSAGE__HXX
#define TEAMCENTER__FND0MESSAGE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <tc/libtc_exports.h>

namespace Teamcenter
{
    class Fnd0Message;
}
namespace Teamcenter
{
    class Fnd0MessageImpl;
}
namespace Teamcenter
{
    class Fnd0MessageDelegate;
}
namespace Teamcenter
{
    class Fnd0MessageDispatch;
}
namespace Teamcenter
{
    class Fnd0MessageGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TC_API  Teamcenter::Fnd0Message
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0Message();

    /**
     * Destructor
     */
    virtual ~Fnd0Message();

private:
    //  Getter method for the Implementation Object
    Fnd0MessageImpl*  getFnd0MessageImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0MessageImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0MessageImpl*  m_fnd0messageImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0Message - desc for Fnd0Message parameter
     */
    Fnd0Message( const Fnd0Message& );
    Fnd0Message& operator=( const Fnd0Message& );

    friend class  Fnd0MessageDelegate;
    friend class  Fnd0MessageDispatch;
    friend class  Fnd0MessageGenImpl;
};

#include <tc/libtc_undef.h>
#endif //   TEAMCENTER__FND0MESSAGE__HXX
