//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0MessageDelegate
    Filename:   Fnd0MessageDelegate.hxx
    Module:     tc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0MESSAGEDELEGATE_HXX
#define TEAMCENTER__FND0MESSAGEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tc/Fnd0Message.hxx>

#include <tc/libtc_exports.h>

namespace Teamcenter
{
    class Fnd0MessageDelegate;
}
namespace Teamcenter
{
    class Fnd0MessageImpl;
}
namespace Teamcenter
{
    class Fnd0Message;
}
namespace Teamcenter
{
    class Fnd0MessageGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TC_API Teamcenter_alias::Fnd0MessageDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0MessageDelegate instance
    static Fnd0MessageDelegate&  getInstance();

    //  Method to create the Fnd0MessageImpl pointer
    static Fnd0MessageImpl*  createImpl( Fnd0Message&  ifObj );

    //  Method to delete the Fnd0MessageImpl pointer
    static void deleteImpl( Fnd0MessageImpl*  impl );


    ///
    /// This operation deletes inputs objects in bulk. It either deletes none of the input objects or deletes all the input objects. It doesn't support partial deletion.
    /// @version Teamcenter 11.6
    /// @param inputs - A vector of data that contains reference to the object to be deleted.
    /// @param bd - A data structure to store objects and other information relevant for set-based operation.
    /// @return - Returns ITK_ok on Success. Otherwise, returns the specific error code.
    ///
    int  fnd0BulkDeleteBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const Fnd0Message &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Fnd0Message &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Fnd0MessageDelegate*  m_pInstance;

    Fnd0MessageDelegate();
    virtual ~Fnd0MessageDelegate();
    static void setInstance( Fnd0MessageDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0MessageGenImpl;

};

#include <tc/libtc_undef.h>
#endif  //  TEAMCENTER__FND0MESSAGEDELEGATE_HXX
