//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0MessageProvider
    Filename:   Fnd0MessageProvider.hxx
    Module:     tc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0MESSAGEPROVIDER__HXX
#define TEAMCENTER__FND0MESSAGEPROVIDER__HXX

#include <common/tc_deprecation_macros.h>
#include <tc/Fnd0BaseProvider.hxx>

#include <tc/libtc_exports.h>

namespace Teamcenter
{
    class Fnd0MessageProvider;
}
namespace Teamcenter
{
    class Fnd0MessageProviderImpl;
}
namespace Teamcenter
{
    class Fnd0MessageProviderDelegate;
}
namespace Teamcenter
{
    class Fnd0MessageProviderDispatch;
}
namespace Teamcenter
{
    class Fnd0MessageProviderGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TC_API  Teamcenter::Fnd0MessageProvider
     : public  ::Teamcenter::Fnd0BaseProvider
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0MessageProvider();

    /**
     * Destructor
     */
    virtual ~Fnd0MessageProvider();

private:
    //  Getter method for the Implementation Object
    Fnd0MessageProviderImpl*  getFnd0MessageProviderImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0MessageProviderImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0MessageProviderImpl*  m_fnd0messageproviderImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0MessageProvider - desc for Fnd0MessageProvider parameter
     */
    Fnd0MessageProvider( const Fnd0MessageProvider& );
    Fnd0MessageProvider& operator=( const Fnd0MessageProvider& );

    friend class  Fnd0MessageProviderDelegate;
    friend class  Fnd0MessageProviderDispatch;
    friend class  Fnd0MessageProviderGenImpl;
};

#include <tc/libtc_undef.h>
#endif //   TEAMCENTER__FND0MESSAGEPROVIDER__HXX
