//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ImanAliasList
    Filename:   ImanAliasList.hxx
    Module:     tc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IMANALIASLIST__HXX
#define TEAMCENTER__IMANALIASLIST__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <tc/libtc_exports.h>

namespace Teamcenter
{
    class ImanAliasList;
}
namespace Teamcenter
{
    class ImanAliasListImpl;
}
namespace Teamcenter
{
    class ImanAliasListDelegate;
}
namespace Teamcenter
{
    class ImanAliasListDispatch;
}
namespace Teamcenter
{
    class ImanAliasListGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TC_API  Teamcenter::ImanAliasList
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ImanAliasList();

    /**
     * Destructor
     */
    virtual ~ImanAliasList();

private:
    //  Getter method for the Implementation Object
    ImanAliasListImpl*  getImanAliasListImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setImanAliasListImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ImanAliasListImpl*  m_imanaliaslistImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ImanAliasList - desc for ImanAliasList parameter
     */
    ImanAliasList( const ImanAliasList& );
    ImanAliasList& operator=( const ImanAliasList& );

    friend class  ImanAliasListDelegate;
    friend class  ImanAliasListDispatch;
    friend class  ImanAliasListGenImpl;
};

#include <tc/libtc_undef.h>
#endif //   TEAMCENTER__IMANALIASLIST__HXX
