//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ImanIDCreator
    Filename:   ImanIDCreator.hxx
    Module:     tc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IMANIDCREATOR__HXX
#define TEAMCENTER__IMANIDCREATOR__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <tc/libtc_exports.h>

namespace Teamcenter
{
    class ImanIDCreator;
}
namespace Teamcenter
{
    class ImanIDCreatorImpl;
}
namespace Teamcenter
{
    class ImanIDCreatorDelegate;
}
namespace Teamcenter
{
    class ImanIDCreatorDispatch;
}
namespace Teamcenter
{
    class ImanIDCreatorGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TC_API  Teamcenter::ImanIDCreator
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ImanIDCreator();

    /**
     * Destructor
     */
    virtual ~ImanIDCreator();

private:
    //  Getter method for the Implementation Object
    ImanIDCreatorImpl*  getImanIDCreatorImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setImanIDCreatorImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ImanIDCreatorImpl*  m_imanidcreatorImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ImanIDCreator - desc for ImanIDCreator parameter
     */
    ImanIDCreator( const ImanIDCreator& );
    ImanIDCreator& operator=( const ImanIDCreator& );

    friend class  ImanIDCreatorDelegate;
    friend class  ImanIDCreatorDispatch;
    friend class  ImanIDCreatorGenImpl;
};

#include <tc/libtc_undef.h>
#endif //   TEAMCENTER__IMANIDCREATOR__HXX
