//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TC_UserContext
    Filename:   TC_UserContext.hxx
    Module:     tc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TC_USERCONTEXT__HXX
#define TEAMCENTER__TC_USERCONTEXT__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <tc/libtc_exports.h>

namespace Teamcenter
{
    class TC_UserContext;
}
namespace Teamcenter
{
    class TC_UserContextImpl;
}
namespace Teamcenter
{
    class TC_UserContextDelegate;
}
namespace Teamcenter
{
    class TC_UserContextDispatch;
}
namespace Teamcenter
{
    class TC_UserContextGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TC_API  Teamcenter::TC_UserContext
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0LocationCodePref( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0LocationCodePref( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    TC_UserContext();

    /**
     * Destructor
     */
    virtual ~TC_UserContext();

private:
    //  Getter method for the Implementation Object
    TC_UserContextImpl*  getTC_UserContextImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTC_UserContextImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    TC_UserContextImpl*  m_tc_usercontextImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param TC_UserContext - desc for TC_UserContext parameter
     */
    TC_UserContext( const TC_UserContext& );
    TC_UserContext& operator=( const TC_UserContext& );

    friend class  TC_UserContextDelegate;
    friend class  TC_UserContextDispatch;
    friend class  TC_UserContextGenImpl;
};

#include <tc/libtc_undef.h>
#endif //   TEAMCENTER__TC_USERCONTEXT__HXX
