//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TC_UserContextDelegate
    Filename:   TC_UserContextDelegate.hxx
    Module:     tc
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TC_USERCONTEXTDELEGATE_HXX
#define TEAMCENTER__TC_USERCONTEXTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tc/TC_UserContext.hxx>

#include <tc/libtc_exports.h>

namespace Teamcenter
{
    class TC_UserContextDelegate;
}
namespace Teamcenter
{
    class TC_UserContextImpl;
}
namespace Teamcenter
{
    class TC_UserContext;
}
namespace Teamcenter
{
    class TC_UserContextGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TC_API Teamcenter_alias::TC_UserContextDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the TC_UserContextDelegate instance
    static TC_UserContextDelegate&  getInstance();

    //  Method to create the TC_UserContextImpl pointer
    static TC_UserContextImpl*  createImpl( TC_UserContext&  ifObj );

    //  Method to delete the TC_UserContextImpl pointer
    static void deleteImpl( TC_UserContextImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0LocationCodePrefBase(const TC_UserContext &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0LocationCodePrefBase(TC_UserContext &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static TC_UserContextDelegate*  m_pInstance;

    TC_UserContextDelegate();
    virtual ~TC_UserContextDelegate();
    static void setInstance( TC_UserContextDelegate*  instance );


private:
    friend class  ::Teamcenter::TC_UserContextGenImpl;

};

#include <tc/libtc_undef.h>
#endif  //  TEAMCENTER__TC_USERCONTEXTDELEGATE_HXX
