//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  tc

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libtc

#if !defined(LIBTC) && !defined(IPLIB)
#   error IPLIB or LIBTC is not defined
#endif

/* Handwritten code should use TC_API, not TCEXPORT */

#define TC_API TCEXPORT

#if IPLIB==libtc || defined(LIBTC)
#   if defined(__lint)
#       define TCEXPORT       __export(tc)
#       define TCGLOBAL       extern __global(tc)
#       define TCPRIVATE      extern __private(tc)
#   elif defined(_WIN32)
#       define TCEXPORT       __declspec(dllexport)
#       define TCGLOBAL       extern __declspec(dllexport)
#       define TCPRIVATE      extern
#   else
#       define TCEXPORT
#       define TCGLOBAL       extern
#       define TCPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define TCEXPORT       __export(tc)
#       define TCGLOBAL       extern __global(tc)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define TCEXPORT      __declspec(dllimport)
#       define TCGLOBAL       extern __declspec(dllimport)
#   else
#       define TCEXPORT
#       define TCGLOBAL       extern
#   endif
#endif
