//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ADA_LicenseDelegate
    Filename:   ADA_LicenseDelegate.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ADA_LICENSEDELEGATE_HXX
#define TEAMCENTER__ADA_LICENSEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ADA_License.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class ADA_LicenseDelegate;
}
namespace Teamcenter
{
    class ADA_LicenseImpl;
}
namespace Teamcenter
{
    class ADA_License;
}
namespace Teamcenter
{
    class ADA_LicenseGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TCCORE_API Teamcenter_alias::ADA_LicenseDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ADA_LicenseDelegate instance
    static ADA_LicenseDelegate&  getInstance();

    //  Method to create the ADA_LicenseImpl pointer
    static ADA_LicenseImpl*  createImpl( ADA_License&  ifObj );

    //  Method to delete the ADA_LicenseImpl pointer
    static void deleteImpl( ADA_LicenseImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0license_categoryBase(const ADA_License &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0LicenseChangeAuditLogsBase(const ADA_License &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0user_citizenshipsBase(const ADA_License &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getGroupsBase(const ADA_License &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Date Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLock_dateBase(const ADA_License &ifObj,  date_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getQualifying_cfrBase(const ADA_License &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0license_categoryBase(ADA_License &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 10.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0user_citizenshipsBase(ADA_License &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 8.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setGroupsBase(ADA_License &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Date Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLock_dateBase(ADA_License &ifObj,  const date_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setQualifying_cfrBase(ADA_License &ifObj,  const std::string &value, bool isNull );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const ADA_License &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0LicenseExportAuditLogsBase(const ADA_License &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;



protected:
    //  Pointer to the instance
    static ADA_LicenseDelegate*  m_pInstance;

    ADA_LicenseDelegate();
    virtual ~ADA_LicenseDelegate();
    static void setInstance( ADA_LicenseDelegate*  instance );


private:
    friend class  ::Teamcenter::ADA_LicenseGenImpl;

};

#include <tccore/libtccore_undef.h>
#endif  //  TEAMCENTER__ADA_LICENSEDELEGATE_HXX
