//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Anchor
    Filename:   Anchor.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ANCHOR__HXX
#define TEAMCENTER__ANCHOR__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class Anchor;
}
namespace Teamcenter
{
    class AnchorImpl;
}
namespace Teamcenter
{
    class AnchorDelegate;
}
namespace Teamcenter
{
    class AnchorDispatch;
}
namespace Teamcenter
{
    class AnchorGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::Anchor
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Anchor();

    /**
     * Destructor
     */
    virtual ~Anchor();

private:
    //  Getter method for the Implementation Object
    AnchorImpl*  getAnchorImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAnchorImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AnchorImpl*  m_anchorImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Anchor - desc for Anchor parameter
     */
    Anchor( const Anchor& );
    Anchor& operator=( const Anchor& );

    friend class  AnchorDelegate;
    friend class  AnchorDispatch;
    friend class  AnchorGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__ANCHOR__HXX
