//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AnchorDelegate
    Filename:   AnchorDelegate.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__ANCHORDELEGATE_HXX
#define TEAMCENTER__ANCHORDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Anchor.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class AnchorDelegate;
}
namespace Teamcenter
{
    class AnchorImpl;
}
namespace Teamcenter
{
    class Anchor;
}
namespace Teamcenter
{
    class AnchorGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TCCORE_API Teamcenter_alias::AnchorDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the AnchorDelegate instance
    static AnchorDelegate&  getInstance();

    //  Method to create the AnchorImpl pointer
    static AnchorImpl*  createImpl( Anchor&  ifObj );

    //  Method to delete the AnchorImpl pointer
    static void deleteImpl( AnchorImpl*  impl );



protected:
    //  Pointer to the instance
    static AnchorDelegate*  m_pInstance;

    AnchorDelegate();
    virtual ~AnchorDelegate();
    static void setInstance( AnchorDelegate*  instance );


private:
    friend class  ::Teamcenter::AnchorGenImpl;

};

#include <tccore/libtccore_undef.h>
#endif  //  TEAMCENTER__ANCHORDELEGATE_HXX
