//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AuthorizationRule
    Filename:   AuthorizationRule.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__AUTHORIZATIONRULE__HXX
#define TEAMCENTER__AUTHORIZATIONRULE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/BusinessRule.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class AuthorizationRule;
}
namespace Teamcenter
{
    class AuthorizationRuleImpl;
}
namespace Teamcenter
{
    class AuthorizationRuleDelegate;
}
namespace Teamcenter
{
    class AuthorizationRuleDispatch;
}
namespace Teamcenter
{
    class AuthorizationRuleGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::AuthorizationRule
     : public  ::Teamcenter::BusinessRule
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    AuthorizationRule();

    /**
     * Destructor
     */
    virtual ~AuthorizationRule();

private:
    //  Getter method for the Implementation Object
    AuthorizationRuleImpl*  getAuthorizationRuleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setAuthorizationRuleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    AuthorizationRuleImpl*  m_authorizationruleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param AuthorizationRule - desc for AuthorizationRule parameter
     */
    AuthorizationRule( const AuthorizationRule& );
    AuthorizationRule& operator=( const AuthorizationRule& );

    friend class  AuthorizationRuleDelegate;
    friend class  AuthorizationRuleDispatch;
    friend class  AuthorizationRuleGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__AUTHORIZATIONRULE__HXX
