//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, AuthorizationRuleDelegate
    Filename:   AuthorizationRuleDelegate.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__AUTHORIZATIONRULEDELEGATE_HXX
#define TEAMCENTER__AUTHORIZATIONRULEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/AuthorizationRule.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class AuthorizationRuleDelegate;
}
namespace Teamcenter
{
    class AuthorizationRuleImpl;
}
namespace Teamcenter
{
    class AuthorizationRule;
}
namespace Teamcenter
{
    class AuthorizationRuleGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TCCORE_API Teamcenter_alias::AuthorizationRuleDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the AuthorizationRuleDelegate instance
    static AuthorizationRuleDelegate&  getInstance();

    //  Method to create the AuthorizationRuleImpl pointer
    static AuthorizationRuleImpl*  createImpl( AuthorizationRule&  ifObj );

    //  Method to delete the AuthorizationRuleImpl pointer
    static void deleteImpl( AuthorizationRuleImpl*  impl );



protected:
    //  Pointer to the instance
    static AuthorizationRuleDelegate*  m_pInstance;

    AuthorizationRuleDelegate();
    virtual ~AuthorizationRuleDelegate();
    static void setInstance( AuthorizationRuleDelegate*  instance );


private:
    friend class  ::Teamcenter::AuthorizationRuleGenImpl;

};

#include <tccore/libtccore_undef.h>
#endif  //  TEAMCENTER__AUTHORIZATIONRULEDELEGATE_HXX
