//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BusinessRule
    Filename:   BusinessRule.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BUSINESSRULE__HXX
#define TEAMCENTER__BUSINESSRULE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class BusinessRule;
}
namespace Teamcenter
{
    class BusinessRuleImpl;
}
namespace Teamcenter
{
    class BusinessRuleDelegate;
}
namespace Teamcenter
{
    class BusinessRuleDispatch;
}
namespace Teamcenter
{
    class BusinessRuleGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::BusinessRule
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    BusinessRule();

    /**
     * Destructor
     */
    virtual ~BusinessRule();

private:
    //  Getter method for the Implementation Object
    BusinessRuleImpl*  getBusinessRuleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBusinessRuleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    BusinessRuleImpl*  m_businessruleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param BusinessRule - desc for BusinessRule parameter
     */
    BusinessRule( const BusinessRule& );
    BusinessRule& operator=( const BusinessRule& );

    friend class  BusinessRuleDelegate;
    friend class  BusinessRuleDispatch;
    friend class  BusinessRuleGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__BUSINESSRULE__HXX
