//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BusinessRuleDescriptor
    Filename:   BusinessRuleDescriptor.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BUSINESSRULEDESCRIPTOR__HXX
#define TEAMCENTER__BUSINESSRULEDESCRIPTOR__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class BusinessRuleDescriptor;
}
namespace Teamcenter
{
    class BusinessRuleDescriptorImpl;
}
namespace Teamcenter
{
    class BusinessRuleDescriptorDelegate;
}
namespace Teamcenter
{
    class BusinessRuleDescriptorDispatch;
}
namespace Teamcenter
{
    class BusinessRuleDescriptorGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::BusinessRuleDescriptor
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    BusinessRuleDescriptor();

    /**
     * Destructor
     */
    virtual ~BusinessRuleDescriptor();

private:
    //  Getter method for the Implementation Object
    BusinessRuleDescriptorImpl*  getBusinessRuleDescriptorImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBusinessRuleDescriptorImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    BusinessRuleDescriptorImpl*  m_businessruledescriptorImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param BusinessRuleDescriptor - desc for BusinessRuleDescriptor parameter
     */
    BusinessRuleDescriptor( const BusinessRuleDescriptor& );
    BusinessRuleDescriptor& operator=( const BusinessRuleDescriptor& );

    friend class  BusinessRuleDescriptorDelegate;
    friend class  BusinessRuleDescriptorDispatch;
    friend class  BusinessRuleDescriptorGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__BUSINESSRULEDESCRIPTOR__HXX
