//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DeepCopyRule
    Filename:   DeepCopyRule.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__DEEPCOPYRULE__HXX
#define TEAMCENTER__DEEPCOPYRULE__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/BusinessRule.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class DeepCopyRule;
}
namespace Teamcenter
{
    class DeepCopyRuleImpl;
}
namespace Teamcenter
{
    class DeepCopyRuleDelegate;
}
namespace Teamcenter
{
    class DeepCopyRuleDispatch;
}
namespace Teamcenter
{
    class DeepCopyRuleGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::DeepCopyRule
     : public  ::Teamcenter::BusinessRule
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPropertyType( int &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getReference_property_name( std::string &value, bool &isNull ) const;

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPropertyType( int value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setReference_property_name( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    DeepCopyRule();

    /**
     * Destructor
     */
    virtual ~DeepCopyRule();

private:
    //  Getter method for the Implementation Object
    DeepCopyRuleImpl*  getDeepCopyRuleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDeepCopyRuleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DeepCopyRuleImpl*  m_deepcopyruleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param DeepCopyRule - desc for DeepCopyRule parameter
     */
    DeepCopyRule( const DeepCopyRule& );
    DeepCopyRule& operator=( const DeepCopyRule& );

    friend class  DeepCopyRuleDelegate;
    friend class  DeepCopyRuleDispatch;
    friend class  DeepCopyRuleGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__DEEPCOPYRULE__HXX
