//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DeepCopyRuleDelegate
    Filename:   DeepCopyRuleDelegate.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__DEEPCOPYRULEDELEGATE_HXX
#define TEAMCENTER__DEEPCOPYRULEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/DeepCopyRule.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class DeepCopyRuleDelegate;
}
namespace Teamcenter
{
    class DeepCopyRuleImpl;
}
namespace Teamcenter
{
    class DeepCopyRule;
}
namespace Teamcenter
{
    class DeepCopyRuleGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TCCORE_API Teamcenter_alias::DeepCopyRuleDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the DeepCopyRuleDelegate instance
    static DeepCopyRuleDelegate&  getInstance();

    //  Method to create the DeepCopyRuleImpl pointer
    static DeepCopyRuleImpl*  createImpl( DeepCopyRule&  ifObj );

    //  Method to delete the DeepCopyRuleImpl pointer
    static void deleteImpl( DeepCopyRuleImpl*  impl );


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPropertyTypeBase(const DeepCopyRule &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getReference_property_nameBase(const DeepCopyRule &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPropertyTypeBase(DeepCopyRule &ifObj,  int value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setReference_property_nameBase(DeepCopyRule &ifObj,  const std::string &value, bool isNull );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static DeepCopyRuleDelegate*  m_pInstance;

    DeepCopyRuleDelegate();
    virtual ~DeepCopyRuleDelegate();
    static void setInstance( DeepCopyRuleDelegate*  instance );


private:
    friend class  ::Teamcenter::DeepCopyRuleGenImpl;

};

#include <tccore/libtccore_undef.h>
#endif  //  TEAMCENTER__DEEPCOPYRULEDELEGATE_HXX
