//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Design
    Filename:   Design.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__DESIGN__HXX
#define TEAMCENTER__DESIGN__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class Design;
}
namespace Teamcenter
{
    class DesignImpl;
}
namespace Teamcenter
{
    class DesignDelegate;
}
namespace Teamcenter
{
    class DesignDispatch;
}
namespace Teamcenter
{
    class DesignGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::Design
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Design();

    /**
     * Destructor
     */
    virtual ~Design();

private:
    //  Getter method for the Implementation Object
    DesignImpl*  getDesignImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDesignImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DesignImpl*  m_designImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Design - desc for Design parameter
     */
    Design( const Design& );
    Design& operator=( const Design& );

    friend class  DesignDelegate;
    friend class  DesignDispatch;
    friend class  DesignGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__DESIGN__HXX
