//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Document
    Filename:   Document.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__DOCUMENT__HXX
#define TEAMCENTER__DOCUMENT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class Document;
}
namespace Teamcenter
{
    class DocumentImpl;
}
namespace Teamcenter
{
    class DocumentDelegate;
}
namespace Teamcenter
{
    class DocumentDispatch;
}
namespace Teamcenter
{
    class DocumentGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::Document
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Document();

    /**
     * Destructor
     */
    virtual ~Document();

private:
    //  Getter method for the Implementation Object
    DocumentImpl*  getDocumentImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDocumentImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DocumentImpl*  m_documentImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Document - desc for Document parameter
     */
    Document( const Document& );
    Document& operator=( const Document& );

    friend class  DocumentDelegate;
    friend class  DocumentDispatch;
    friend class  DocumentGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__DOCUMENT__HXX
