//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DocumentDelegate
    Filename:   DocumentDelegate.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__DOCUMENTDELEGATE_HXX
#define TEAMCENTER__DOCUMENTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Document.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class DocumentDelegate;
}
namespace Teamcenter
{
    class DocumentImpl;
}
namespace Teamcenter
{
    class Document;
}
namespace Teamcenter
{
    class DocumentGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TCCORE_API Teamcenter_alias::DocumentDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the DocumentDelegate instance
    static DocumentDelegate&  getInstance();

    //  Method to create the DocumentImpl pointer
    static DocumentImpl*  createImpl( Document&  ifObj );

    //  Method to delete the DocumentImpl pointer
    static void deleteImpl( DocumentImpl*  impl );



protected:
    //  Pointer to the instance
    static DocumentDelegate*  m_pInstance;

    DocumentDelegate();
    virtual ~DocumentDelegate();
    static void setInstance( DocumentDelegate*  instance );


private:
    friend class  ::Teamcenter::DocumentGenImpl;

};

#include <tccore/libtccore_undef.h>
#endif  //  TEAMCENTER__DOCUMENTDELEGATE_HXX
