//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DocumentRevision
    Filename:   DocumentRevision.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__DOCUMENTREVISION__HXX
#define TEAMCENTER__DOCUMENTREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class DocumentRevision;
}
namespace Teamcenter
{
    class DocumentRevisionImpl;
}
namespace Teamcenter
{
    class DocumentRevisionDelegate;
}
namespace Teamcenter
{
    class DocumentRevisionDispatch;
}
namespace Teamcenter
{
    class DocumentRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::DocumentRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    DocumentRevision();

    /**
     * Destructor
     */
    virtual ~DocumentRevision();

private:
    //  Getter method for the Implementation Object
    DocumentRevisionImpl*  getDocumentRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDocumentRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DocumentRevisionImpl*  m_documentrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param DocumentRevision - desc for DocumentRevision parameter
     */
    DocumentRevision( const DocumentRevision& );
    DocumentRevision& operator=( const DocumentRevision& );

    friend class  DocumentRevisionDelegate;
    friend class  DocumentRevisionDispatch;
    friend class  DocumentRevisionGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__DOCUMENTREVISION__HXX
