//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DocumentRevisionDelegate
    Filename:   DocumentRevisionDelegate.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__DOCUMENTREVISIONDELEGATE_HXX
#define TEAMCENTER__DOCUMENTREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/DocumentRevision.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class DocumentRevisionDelegate;
}
namespace Teamcenter
{
    class DocumentRevisionImpl;
}
namespace Teamcenter
{
    class DocumentRevision;
}
namespace Teamcenter
{
    class DocumentRevisionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TCCORE_API Teamcenter_alias::DocumentRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the DocumentRevisionDelegate instance
    static DocumentRevisionDelegate&  getInstance();

    //  Method to create the DocumentRevisionImpl pointer
    static DocumentRevisionImpl*  createImpl( DocumentRevision&  ifObj );

    //  Method to delete the DocumentRevisionImpl pointer
    static void deleteImpl( DocumentRevisionImpl*  impl );



protected:
    //  Pointer to the instance
    static DocumentRevisionDelegate*  m_pInstance;

    DocumentRevisionDelegate();
    virtual ~DocumentRevisionDelegate();
    static void setInstance( DocumentRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::DocumentRevisionGenImpl;

};

#include <tccore/libtccore_undef.h>
#endif  //  TEAMCENTER__DOCUMENTREVISIONDELEGATE_HXX
