//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Drawing
    Filename:   Drawing.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__DRAWING__HXX
#define TEAMCENTER__DRAWING__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class Drawing;
}
namespace Teamcenter
{
    class DrawingImpl;
}
namespace Teamcenter
{
    class DrawingDelegate;
}
namespace Teamcenter
{
    class DrawingDispatch;
}
namespace Teamcenter
{
    class DrawingGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::Drawing
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Drawing();

    /**
     * Destructor
     */
    virtual ~Drawing();

private:
    //  Getter method for the Implementation Object
    DrawingImpl*  getDrawingImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDrawingImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DrawingImpl*  m_drawingImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Drawing - desc for Drawing parameter
     */
    Drawing( const Drawing& );
    Drawing& operator=( const Drawing& );

    friend class  DrawingDelegate;
    friend class  DrawingDispatch;
    friend class  DrawingGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__DRAWING__HXX
