//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DrawingDelegate
    Filename:   DrawingDelegate.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__DRAWINGDELEGATE_HXX
#define TEAMCENTER__DRAWINGDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Drawing.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class DrawingDelegate;
}
namespace Teamcenter
{
    class DrawingImpl;
}
namespace Teamcenter
{
    class Drawing;
}
namespace Teamcenter
{
    class DrawingGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TCCORE_API Teamcenter_alias::DrawingDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the DrawingDelegate instance
    static DrawingDelegate&  getInstance();

    //  Method to create the DrawingImpl pointer
    static DrawingImpl*  createImpl( Drawing&  ifObj );

    //  Method to delete the DrawingImpl pointer
    static void deleteImpl( DrawingImpl*  impl );



protected:
    //  Pointer to the instance
    static DrawingDelegate*  m_pInstance;

    DrawingDelegate();
    virtual ~DrawingDelegate();
    static void setInstance( DrawingDelegate*  instance );


private:
    friend class  ::Teamcenter::DrawingGenImpl;

};

#include <tccore/libtccore_undef.h>
#endif  //  TEAMCENTER__DRAWINGDELEGATE_HXX
