//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Effectivity
    Filename:   Effectivity.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EFFECTIVITY__HXX
#define TEAMCENTER__EFFECTIVITY__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class Effectivity;
}
namespace Teamcenter
{
    class EffectivityImpl;
}
namespace Teamcenter
{
    class EffectivityDelegate;
}
namespace Teamcenter
{
    class EffectivityDispatch;
}
namespace Teamcenter
{
    class EffectivityGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::Effectivity
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Effectivity();

    /**
     * Destructor
     */
    virtual ~Effectivity();

private:
    //  Getter method for the Implementation Object
    EffectivityImpl*  getEffectivityImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setEffectivityImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    EffectivityImpl*  m_effectivityImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Effectivity - desc for Effectivity parameter
     */
    Effectivity( const Effectivity& );
    Effectivity& operator=( const Effectivity& );

    friend class  EffectivityDelegate;
    friend class  EffectivityDispatch;
    friend class  EffectivityGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__EFFECTIVITY__HXX
