//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EffectivityMapping
    Filename:   EffectivityMapping.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EFFECTIVITYMAPPING__HXX
#define TEAMCENTER__EFFECTIVITYMAPPING__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class EffectivityMapping;
}
namespace Teamcenter
{
    class EffectivityMappingImpl;
}
namespace Teamcenter
{
    class EffectivityMappingDelegate;
}
namespace Teamcenter
{
    class EffectivityMappingDispatch;
}
namespace Teamcenter
{
    class EffectivityMappingGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::EffectivityMapping
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    EffectivityMapping();

    /**
     * Destructor
     */
    virtual ~EffectivityMapping();

private:
    //  Getter method for the Implementation Object
    EffectivityMappingImpl*  getEffectivityMappingImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setEffectivityMappingImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    EffectivityMappingImpl*  m_effectivitymappingImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param EffectivityMapping - desc for EffectivityMapping parameter
     */
    EffectivityMapping( const EffectivityMapping& );
    EffectivityMapping& operator=( const EffectivityMapping& );

    friend class  EffectivityMappingDelegate;
    friend class  EffectivityMappingDispatch;
    friend class  EffectivityMappingGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__EFFECTIVITYMAPPING__HXX
