//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, EffectivityMode
    Filename:   EffectivityMode.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EFFECTIVITYMODE__HXX
#define TEAMCENTER__EFFECTIVITYMODE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class EffectivityMode;
}
namespace Teamcenter
{
    class EffectivityModeImpl;
}
namespace Teamcenter
{
    class EffectivityModeDelegate;
}
namespace Teamcenter
{
    class EffectivityModeDispatch;
}
namespace Teamcenter
{
    class EffectivityModeGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::EffectivityMode
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    EffectivityMode();

    /**
     * Destructor
     */
    virtual ~EffectivityMode();

private:
    //  Getter method for the Implementation Object
    EffectivityModeImpl*  getEffectivityModeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setEffectivityModeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    EffectivityModeImpl*  m_effectivitymodeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param EffectivityMode - desc for EffectivityMode parameter
     */
    EffectivityMode( const EffectivityMode& );
    EffectivityMode& operator=( const EffectivityMode& );

    friend class  EffectivityModeDelegate;
    friend class  EffectivityModeDispatch;
    friend class  EffectivityModeGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__EFFECTIVITYMODE__HXX
