//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, FND_TraceLink
    Filename:   FND_TraceLink.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND_TRACELINK__HXX
#define TEAMCENTER__FND_TRACELINK__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class FND_TraceLink;
}
namespace Teamcenter
{
    class FND_TraceLinkImpl;
}
namespace Teamcenter
{
    class FND_TraceLinkDelegate;
}
namespace Teamcenter
{
    class FND_TraceLinkDispatch;
}
namespace Teamcenter
{
    class FND_TraceLinkGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::FND_TraceLink
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// fnd0IsOccurrenceTraceLink is a boolean flag that will return true if primary or secondary object of this relation is pointing to absolute occurrence object such as AbsOccData. The user can easily determine which trace links are in-context to an occurrence verses between ItemRevisions.
    /// @version Teamcenter 11.4
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0IsOccurrenceTraceLink( bool &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getName( std::string &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    FND_TraceLink();

    /**
     * Destructor
     */
    virtual ~FND_TraceLink();

private:
    //  Getter method for the Implementation Object
    FND_TraceLinkImpl*  getFND_TraceLinkImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFND_TraceLinkImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    FND_TraceLinkImpl*  m_fnd_tracelinkImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param FND_TraceLink - desc for FND_TraceLink parameter
     */
    FND_TraceLink( const FND_TraceLink& );
    FND_TraceLink& operator=( const FND_TraceLink& );

    friend class  FND_TraceLinkDelegate;
    friend class  FND_TraceLinkDispatch;
    friend class  FND_TraceLinkGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__FND_TRACELINK__HXX
