//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, FND_TraceLinkDelegate
    Filename:   FND_TraceLinkDelegate.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND_TRACELINKDELEGATE_HXX
#define TEAMCENTER__FND_TRACELINKDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/FND_TraceLink.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class FND_TraceLinkDelegate;
}
namespace Teamcenter
{
    class FND_TraceLinkImpl;
}
namespace Teamcenter
{
    class FND_TraceLink;
}
namespace Teamcenter
{
    class FND_TraceLinkGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TCCORE_API Teamcenter_alias::FND_TraceLinkDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the FND_TraceLinkDelegate instance
    static FND_TraceLinkDelegate&  getInstance();

    //  Method to create the FND_TraceLinkImpl pointer
    static FND_TraceLinkImpl*  createImpl( FND_TraceLink&  ifObj );

    //  Method to delete the FND_TraceLinkImpl pointer
    static void deleteImpl( FND_TraceLinkImpl*  impl );


    ///
    /// fnd0IsOccurrenceTraceLink is a boolean flag that will return true if primary or secondary object of this relation is pointing to absolute occurrence object such as AbsOccData. The user can easily determine which trace links are in-context to an occurrence verses between ItemRevisions.
    /// @version Teamcenter 11.4
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0IsOccurrenceTraceLinkBase(const FND_TraceLink &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getNameBase(const FND_TraceLink &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const FND_TraceLink &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const FND_TraceLink &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const FND_TraceLink &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static FND_TraceLinkDelegate*  m_pInstance;

    FND_TraceLinkDelegate();
    virtual ~FND_TraceLinkDelegate();
    static void setInstance( FND_TraceLinkDelegate*  instance );


private:
    friend class  ::Teamcenter::FND_TraceLinkGenImpl;

};

#include <tccore/libtccore_undef.h>
#endif  //  TEAMCENTER__FND_TRACELINKDELEGATE_HXX
