//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0AbstractPersistentProxy
    Filename:   Fnd0AbstractPersistentProxy.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0ABSTRACTPERSISTENTPROXY__HXX
#define TEAMCENTER__FND0ABSTRACTPERSISTENTPROXY__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class Fnd0AbstractPersistentProxy;
}
namespace Teamcenter
{
    class Fnd0AbstractPersistentProxyImpl;
}
namespace Teamcenter
{
    class Fnd0AbstractPersistentProxyDelegate;
}
namespace Teamcenter
{
    class Fnd0AbstractPersistentProxyDispatch;
}
namespace Teamcenter
{
    class Fnd0AbstractPersistentProxyGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::Fnd0AbstractPersistentProxy
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0InactiveFlag( bool value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0AbstractPersistentProxy();

    /**
     * Destructor
     */
    virtual ~Fnd0AbstractPersistentProxy();

private:
    //  Getter method for the Implementation Object
    Fnd0AbstractPersistentProxyImpl*  getFnd0AbstractPersistentProxyImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0AbstractPersistentProxyImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0AbstractPersistentProxyImpl*  m_fnd0abstractpersistentproxyImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0AbstractPersistentProxy - desc for Fnd0AbstractPersistentProxy parameter
     */
    Fnd0AbstractPersistentProxy( const Fnd0AbstractPersistentProxy& );
    Fnd0AbstractPersistentProxy& operator=( const Fnd0AbstractPersistentProxy& );

    friend class  Fnd0AbstractPersistentProxyDelegate;
    friend class  Fnd0AbstractPersistentProxyDispatch;
    friend class  Fnd0AbstractPersistentProxyGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__FND0ABSTRACTPERSISTENTPROXY__HXX
