//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ChangeContext
    Filename:   Fnd0ChangeContext.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0CHANGECONTEXT__HXX
#define TEAMCENTER__FND0CHANGECONTEXT__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class Fnd0ChangeContext;
}
namespace Teamcenter
{
    class Fnd0ChangeContextImpl;
}
namespace Teamcenter
{
    class Fnd0ChangeContextDelegate;
}
namespace Teamcenter
{
    class Fnd0ChangeContextDispatch;
}
namespace Teamcenter
{
    class Fnd0ChangeContextGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::Fnd0ChangeContext
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0ChangeContext();

    /**
     * Destructor
     */
    virtual ~Fnd0ChangeContext();

private:
    //  Getter method for the Implementation Object
    Fnd0ChangeContextImpl*  getFnd0ChangeContextImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0ChangeContextImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0ChangeContextImpl*  m_fnd0changecontextImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0ChangeContext - desc for Fnd0ChangeContext parameter
     */
    Fnd0ChangeContext( const Fnd0ChangeContext& );
    Fnd0ChangeContext& operator=( const Fnd0ChangeContext& );

    friend class  Fnd0ChangeContextDelegate;
    friend class  Fnd0ChangeContextDispatch;
    friend class  Fnd0ChangeContextGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__FND0CHANGECONTEXT__HXX
