//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0DeployVersion
    Filename:   Fnd0DeployVersion.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0DEPLOYVERSION__HXX
#define TEAMCENTER__FND0DEPLOYVERSION__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class Fnd0DeployVersion;
}
namespace Teamcenter
{
    class Fnd0DeployVersionImpl;
}
namespace Teamcenter
{
    class Fnd0DeployVersionDelegate;
}
namespace Teamcenter
{
    class Fnd0DeployVersionDispatch;
}
namespace Teamcenter
{
    class Fnd0DeployVersionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::Fnd0DeployVersion
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0name( std::string &value, bool &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0version( int &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0name( const std::string &value, bool isNull=false );

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 8.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0version( int value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0DeployVersion();

    /**
     * Destructor
     */
    virtual ~Fnd0DeployVersion();

private:
    //  Getter method for the Implementation Object
    Fnd0DeployVersionImpl*  getFnd0DeployVersionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0DeployVersionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0DeployVersionImpl*  m_fnd0deployversionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0DeployVersion - desc for Fnd0DeployVersion parameter
     */
    Fnd0DeployVersion( const Fnd0DeployVersion& );
    Fnd0DeployVersion& operator=( const Fnd0DeployVersion& );

    friend class  Fnd0DeployVersionDelegate;
    friend class  Fnd0DeployVersionDispatch;
    friend class  Fnd0DeployVersionGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__FND0DEPLOYVERSION__HXX
