//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0DeployVersionDelegate
    Filename:   Fnd0DeployVersionDelegate.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0DEPLOYVERSIONDELEGATE_HXX
#define TEAMCENTER__FND0DEPLOYVERSIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Fnd0DeployVersion.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class Fnd0DeployVersionDelegate;
}
namespace Teamcenter
{
    class Fnd0DeployVersionImpl;
}
namespace Teamcenter
{
    class Fnd0DeployVersion;
}
namespace Teamcenter
{
    class Fnd0DeployVersionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TCCORE_API Teamcenter_alias::Fnd0DeployVersionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0DeployVersionDelegate instance
    static Fnd0DeployVersionDelegate&  getInstance();

    //  Method to create the Fnd0DeployVersionImpl pointer
    static Fnd0DeployVersionImpl*  createImpl( Fnd0DeployVersion&  ifObj );

    //  Method to delete the Fnd0DeployVersionImpl pointer
    static void deleteImpl( Fnd0DeployVersionImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0nameBase(const Fnd0DeployVersion &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0versionBase(const Fnd0DeployVersion &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0nameBase(Fnd0DeployVersion &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 8.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0versionBase(Fnd0DeployVersion &ifObj,  int value, bool isNull );



protected:
    //  Pointer to the instance
    static Fnd0DeployVersionDelegate*  m_pInstance;

    Fnd0DeployVersionDelegate();
    virtual ~Fnd0DeployVersionDelegate();
    static void setInstance( Fnd0DeployVersionDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0DeployVersionGenImpl;

};

#include <tccore/libtccore_undef.h>
#endif  //  TEAMCENTER__FND0DEPLOYVERSIONDELEGATE_HXX
