//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0DetailedMessage
    Filename:   Fnd0DetailedMessage.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0DETAILEDMESSAGE__HXX
#define TEAMCENTER__FND0DETAILEDMESSAGE__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class Fnd0DetailedMessage;
}
namespace Teamcenter
{
    class Fnd0DetailedMessageImpl;
}
namespace Teamcenter
{
    class Fnd0DetailedMessageDelegate;
}
namespace Teamcenter
{
    class Fnd0DetailedMessageDispatch;
}
namespace Teamcenter
{
    class Fnd0DetailedMessageGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::Fnd0DetailedMessage
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0Detail( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0Message( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0Detail( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0Message( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0DetailedMessage();

    /**
     * Destructor
     */
    virtual ~Fnd0DetailedMessage();

private:
    //  Getter method for the Implementation Object
    Fnd0DetailedMessageImpl*  getFnd0DetailedMessageImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0DetailedMessageImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0DetailedMessageImpl*  m_fnd0detailedmessageImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0DetailedMessage - desc for Fnd0DetailedMessage parameter
     */
    Fnd0DetailedMessage( const Fnd0DetailedMessage& );
    Fnd0DetailedMessage& operator=( const Fnd0DetailedMessage& );

    friend class  Fnd0DetailedMessageDelegate;
    friend class  Fnd0DetailedMessageDispatch;
    friend class  Fnd0DetailedMessageGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__FND0DETAILEDMESSAGE__HXX
