//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0DigitalSignature
    Filename:   Fnd0DigitalSignature.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0DIGITALSIGNATURE__HXX
#define TEAMCENTER__FND0DIGITALSIGNATURE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class Fnd0DigitalSignature;
}
namespace Teamcenter
{
    class Fnd0DigitalSignatureImpl;
}
namespace Teamcenter
{
    class Fnd0DigitalSignatureDelegate;
}
namespace Teamcenter
{
    class Fnd0DigitalSignatureDispatch;
}
namespace Teamcenter
{
    class Fnd0DigitalSignatureGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::Fnd0DigitalSignature
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0State( int &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0DigitalSignature();

    /**
     * Destructor
     */
    virtual ~Fnd0DigitalSignature();

private:
    //  Getter method for the Implementation Object
    Fnd0DigitalSignatureImpl*  getFnd0DigitalSignatureImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0DigitalSignatureImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0DigitalSignatureImpl*  m_fnd0digitalsignatureImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0DigitalSignature - desc for Fnd0DigitalSignature parameter
     */
    Fnd0DigitalSignature( const Fnd0DigitalSignature& );
    Fnd0DigitalSignature& operator=( const Fnd0DigitalSignature& );

    friend class  Fnd0DigitalSignatureDelegate;
    friend class  Fnd0DigitalSignatureDispatch;
    friend class  Fnd0DigitalSignatureGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__FND0DIGITALSIGNATURE__HXX
