//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0DigitalSignatureDelegate
    Filename:   Fnd0DigitalSignatureDelegate.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0DIGITALSIGNATUREDELEGATE_HXX
#define TEAMCENTER__FND0DIGITALSIGNATUREDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Fnd0DigitalSignature.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class Fnd0DigitalSignatureDelegate;
}
namespace Teamcenter
{
    class Fnd0DigitalSignatureImpl;
}
namespace Teamcenter
{
    class Fnd0DigitalSignature;
}
namespace Teamcenter
{
    class Fnd0DigitalSignatureGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TCCORE_API Teamcenter_alias::Fnd0DigitalSignatureDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0DigitalSignatureDelegate instance
    static Fnd0DigitalSignatureDelegate&  getInstance();

    //  Method to create the Fnd0DigitalSignatureImpl pointer
    static Fnd0DigitalSignatureImpl*  createImpl( Fnd0DigitalSignature&  ifObj );

    //  Method to delete the Fnd0DigitalSignatureImpl pointer
    static void deleteImpl( Fnd0DigitalSignatureImpl*  impl );


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0StateBase(const Fnd0DigitalSignature &ifObj,  int &value, bool &isNull ) const;


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Fnd0DigitalSignature &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Fnd0DigitalSignature &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Fnd0DigitalSignatureDelegate*  m_pInstance;

    Fnd0DigitalSignatureDelegate();
    virtual ~Fnd0DigitalSignatureDelegate();
    static void setInstance( Fnd0DigitalSignatureDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0DigitalSignatureGenImpl;

};

#include <tccore/libtccore_undef.h>
#endif  //  TEAMCENTER__FND0DIGITALSIGNATUREDELEGATE_HXX
