//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0KeyValuePair
    Filename:   Fnd0KeyValuePair.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0KEYVALUEPAIR__HXX
#define TEAMCENTER__FND0KEYVALUEPAIR__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class Fnd0KeyValuePair;
}
namespace Teamcenter
{
    class Fnd0KeyValuePairImpl;
}
namespace Teamcenter
{
    class Fnd0KeyValuePairDelegate;
}
namespace Teamcenter
{
    class Fnd0KeyValuePairDispatch;
}
namespace Teamcenter
{
    class Fnd0KeyValuePairGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::Fnd0KeyValuePair
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0Key( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0Value( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0Key( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0Value( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0KeyValuePair();

    /**
     * Destructor
     */
    virtual ~Fnd0KeyValuePair();

private:
    //  Getter method for the Implementation Object
    Fnd0KeyValuePairImpl*  getFnd0KeyValuePairImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0KeyValuePairImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0KeyValuePairImpl*  m_fnd0keyvaluepairImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0KeyValuePair - desc for Fnd0KeyValuePair parameter
     */
    Fnd0KeyValuePair( const Fnd0KeyValuePair& );
    Fnd0KeyValuePair& operator=( const Fnd0KeyValuePair& );

    friend class  Fnd0KeyValuePairDelegate;
    friend class  Fnd0KeyValuePairDispatch;
    friend class  Fnd0KeyValuePairGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__FND0KEYVALUEPAIR__HXX
