//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0KeyValuePairDelegate
    Filename:   Fnd0KeyValuePairDelegate.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0KEYVALUEPAIRDELEGATE_HXX
#define TEAMCENTER__FND0KEYVALUEPAIRDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Fnd0KeyValuePair.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class Fnd0KeyValuePairDelegate;
}
namespace Teamcenter
{
    class Fnd0KeyValuePairImpl;
}
namespace Teamcenter
{
    class Fnd0KeyValuePair;
}
namespace Teamcenter
{
    class Fnd0KeyValuePairGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TCCORE_API Teamcenter_alias::Fnd0KeyValuePairDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0KeyValuePairDelegate instance
    static Fnd0KeyValuePairDelegate&  getInstance();

    //  Method to create the Fnd0KeyValuePairImpl pointer
    static Fnd0KeyValuePairImpl*  createImpl( Fnd0KeyValuePair&  ifObj );

    //  Method to delete the Fnd0KeyValuePairImpl pointer
    static void deleteImpl( Fnd0KeyValuePairImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0KeyBase(const Fnd0KeyValuePair &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ValueBase(const Fnd0KeyValuePair &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0KeyBase(Fnd0KeyValuePair &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0ValueBase(Fnd0KeyValuePair &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static Fnd0KeyValuePairDelegate*  m_pInstance;

    Fnd0KeyValuePairDelegate();
    virtual ~Fnd0KeyValuePairDelegate();
    static void setInstance( Fnd0KeyValuePairDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0KeyValuePairGenImpl;

};

#include <tccore/libtccore_undef.h>
#endif  //  TEAMCENTER__FND0KEYVALUEPAIRDELEGATE_HXX
