//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0LogicalObject
    Filename:   Fnd0LogicalObject.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0LOGICALOBJECT__HXX
#define TEAMCENTER__FND0LOGICALOBJECT__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class Fnd0LogicalObject;
}
namespace Teamcenter
{
    class Fnd0LogicalObjectImpl;
}
namespace Teamcenter
{
    class Fnd0LogicalObjectDelegate;
}
namespace Teamcenter
{
    class Fnd0LogicalObjectDispatch;
}
namespace Teamcenter
{
    class Fnd0LogicalObjectGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::Fnd0LogicalObject
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0LogicalObject();

    /**
     * Destructor
     */
    virtual ~Fnd0LogicalObject();

private:
    //  Getter method for the Implementation Object
    Fnd0LogicalObjectImpl*  getFnd0LogicalObjectImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0LogicalObjectImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0LogicalObjectImpl*  m_fnd0logicalobjectImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0LogicalObject - desc for Fnd0LogicalObject parameter
     */
    Fnd0LogicalObject( const Fnd0LogicalObject& );
    Fnd0LogicalObject& operator=( const Fnd0LogicalObject& );

    friend class  Fnd0LogicalObjectDelegate;
    friend class  Fnd0LogicalObjectDispatch;
    friend class  Fnd0LogicalObjectGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__FND0LOGICALOBJECT__HXX
