//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0LogicalObjectDelegate
    Filename:   Fnd0LogicalObjectDelegate.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0LOGICALOBJECTDELEGATE_HXX
#define TEAMCENTER__FND0LOGICALOBJECTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Fnd0LogicalObject.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class Fnd0LogicalObjectDelegate;
}
namespace Teamcenter
{
    class Fnd0LogicalObjectImpl;
}
namespace Teamcenter
{
    class Fnd0LogicalObject;
}
namespace Teamcenter
{
    class Fnd0LogicalObjectGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TCCORE_API Teamcenter_alias::Fnd0LogicalObjectDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0LogicalObjectDelegate instance
    static Fnd0LogicalObjectDelegate&  getInstance();

    //  Method to create the Fnd0LogicalObjectImpl pointer
    static Fnd0LogicalObjectImpl*  createImpl( Fnd0LogicalObject&  ifObj );

    //  Method to delete the Fnd0LogicalObjectImpl pointer
    static void deleteImpl( Fnd0LogicalObjectImpl*  impl );


    ///
    /// This is the getter for retrieving the recipe/permanent ID if its been created (and cached on the instance). Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param uid - Recipe/permanent ID
    /// @param isFirstTime - If Session Recovery Uid is yet to be set or does the object need to be serialized again?
    /// @return - Failure code
    ///
    int  fnd0AskSRUidBase(const Fnd0LogicalObject &ifObj,  std::string *uid, bool *isFirstTime ) const;


    ///
    /// Generates permanent ID/recipe. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param recipe - Permanent ID/recipe
    /// @return - Failure code.
    ///
    int  fnd0GenerateRecipeBase(const Fnd0LogicalObject &ifObj,  std::string *recipe );


    ///
    /// If Business Object supports recoverable ID. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param isPersistedRecipe - isPersistedRecipe param should be set to true if the recipe is limited to the user session and should be serialized to the database
    /// @param isRecoverableIDSupported - Returning true indicates support for recoverability/permanent IDs
    /// @return - Failure code.
    ///
    int  fnd0IsRecoverableBase(const Fnd0LogicalObject &ifObj,  bool *isPersistedRecipe, bool *isRecoverableIDSupported ) const;


    ///
    /// This is the setter for the recipe/permanent ID when it is created (to be cached on the instance). Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param uid - Rrecipe/permanent ID
    /// @return - Failure code.
    ///
    int  fnd0SetSRUidBase(const Fnd0LogicalObject &ifObj,  const std::string *uid );



protected:
    //  Pointer to the instance
    static Fnd0LogicalObjectDelegate*  m_pInstance;

    Fnd0LogicalObjectDelegate();
    virtual ~Fnd0LogicalObjectDelegate();
    static void setInstance( Fnd0LogicalObjectDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0LogicalObjectGenImpl;

};

#include <tccore/libtccore_undef.h>
#endif  //  TEAMCENTER__FND0LOGICALOBJECTDELEGATE_HXX
