//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0LogicalObjectTypeDelegate
    Filename:   Fnd0LogicalObjectTypeDelegate.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0LOGICALOBJECTTYPEDELEGATE_HXX
#define TEAMCENTER__FND0LOGICALOBJECTTYPEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Fnd0LogicalObjectType.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class Fnd0LogicalObjectTypeDelegate;
}
namespace Teamcenter
{
    class Fnd0LogicalObjectTypeImpl;
}
namespace Teamcenter
{
    class Fnd0LogicalObjectType;
}
namespace Teamcenter
{
    class Fnd0LogicalObjectTypeGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TCCORE_API Teamcenter_alias::Fnd0LogicalObjectTypeDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0LogicalObjectTypeDelegate instance
    static Fnd0LogicalObjectTypeDelegate&  getInstance();

    //  Method to create the Fnd0LogicalObjectTypeImpl pointer
    static Fnd0LogicalObjectTypeImpl*  createImpl( Fnd0LogicalObjectType&  ifObj );

    //  Method to delete the Fnd0LogicalObjectTypeImpl pointer
    static void deleteImpl( Fnd0LogicalObjectTypeImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0DisplayNameBase(const Fnd0LogicalObjectType &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.6
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0IncludedLogicalObjectsBase(const Fnd0LogicalObjectType &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.4
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0MembersBase(const Fnd0LogicalObjectType &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ObjectStringExpressionBase(const Fnd0LogicalObjectType &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.4
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0PresentedPropertiesBase(const Fnd0LogicalObjectType &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.4
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0RootTypeNameBase(const Fnd0LogicalObjectType &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for Property Display Value
    /// @version Teamcenter 11.6
    /// @param values - Parameter value
    /// @return - Status. 0 if successful
    ///
    int  getFnd0RootTypeNameDisplayableValuesBase(Fnd0LogicalObjectType &ifObj,  std::vector< std::string > &values );


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.5
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIs_modifiableBase(const Fnd0LogicalObjectType &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 11.5
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0DisplayNameBase(Fnd0LogicalObjectType &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static Fnd0LogicalObjectTypeDelegate*  m_pInstance;

    Fnd0LogicalObjectTypeDelegate();
    virtual ~Fnd0LogicalObjectTypeDelegate();
    static void setInstance( Fnd0LogicalObjectTypeDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0LogicalObjectTypeGenImpl;

};

#include <tccore/libtccore_undef.h>
#endif  //  TEAMCENTER__FND0LOGICALOBJECTTYPEDELEGATE_HXX
