//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ObjectStatusDelegate
    Filename:   Fnd0ObjectStatusDelegate.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0OBJECTSTATUSDELEGATE_HXX
#define TEAMCENTER__FND0OBJECTSTATUSDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Fnd0ObjectStatus.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class Fnd0ObjectStatusDelegate;
}
namespace Teamcenter
{
    class Fnd0ObjectStatusImpl;
}
namespace Teamcenter
{
    class Fnd0ObjectStatus;
}
namespace Teamcenter
{
    class Fnd0ObjectStatusGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TCCORE_API Teamcenter_alias::Fnd0ObjectStatusDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0ObjectStatusDelegate instance
    static Fnd0ObjectStatusDelegate&  getInstance();

    //  Method to create the Fnd0ObjectStatusImpl pointer
    static Fnd0ObjectStatusImpl*  createImpl( Fnd0ObjectStatus&  ifObj );

    //  Method to delete the Fnd0ObjectStatusImpl pointer
    static void deleteImpl( Fnd0ObjectStatusImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0DetailedMessagesBase(const Fnd0ObjectStatus &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0KeyValuePairsBase(const Fnd0ObjectStatus &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0MyStatusBase(const Fnd0ObjectStatus &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ResourcesBase(const Fnd0ObjectStatus &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 9
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0StatusTypeBase(const Fnd0ObjectStatus &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0DetailedMessagesBase(Fnd0ObjectStatus &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0KeyValuePairsBase(Fnd0ObjectStatus &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 9
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0ResourcesBase(Fnd0ObjectStatus &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 9
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0StatusTypeBase(Fnd0ObjectStatus &ifObj,  int value, bool isNull );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static Fnd0ObjectStatusDelegate*  m_pInstance;

    Fnd0ObjectStatusDelegate();
    virtual ~Fnd0ObjectStatusDelegate();
    static void setInstance( Fnd0ObjectStatusDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0ObjectStatusGenImpl;

};

#include <tccore/libtccore_undef.h>
#endif  //  TEAMCENTER__FND0OBJECTSTATUSDELEGATE_HXX
