//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ObjectThread
    Filename:   Fnd0ObjectThread.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0OBJECTTHREAD__HXX
#define TEAMCENTER__FND0OBJECTTHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class Fnd0ObjectThread;
}
namespace Teamcenter
{
    class Fnd0ObjectThreadImpl;
}
namespace Teamcenter
{
    class Fnd0ObjectThreadDelegate;
}
namespace Teamcenter
{
    class Fnd0ObjectThreadDispatch;
}
namespace Teamcenter
{
    class Fnd0ObjectThreadGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::Fnd0ObjectThread
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0ObjectThread();

    /**
     * Destructor
     */
    virtual ~Fnd0ObjectThread();

private:
    //  Getter method for the Implementation Object
    Fnd0ObjectThreadImpl*  getFnd0ObjectThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0ObjectThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0ObjectThreadImpl*  m_fnd0objectthreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0ObjectThread - desc for Fnd0ObjectThread parameter
     */
    Fnd0ObjectThread( const Fnd0ObjectThread& );
    Fnd0ObjectThread& operator=( const Fnd0ObjectThread& );

    friend class  Fnd0ObjectThreadDelegate;
    friend class  Fnd0ObjectThreadDispatch;
    friend class  Fnd0ObjectThreadGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__FND0OBJECTTHREAD__HXX
