//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ProductSessionData
    Filename:   Fnd0ProductSessionData.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0PRODUCTSESSIONDATA__HXX
#define TEAMCENTER__FND0PRODUCTSESSIONDATA__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class Fnd0ProductSessionData;
}
namespace Teamcenter
{
    class Fnd0ProductSessionDataImpl;
}
namespace Teamcenter
{
    class Fnd0ProductSessionDataDelegate;
}
namespace Teamcenter
{
    class Fnd0ProductSessionDataDispatch;
}
namespace Teamcenter
{
    class Fnd0ProductSessionDataGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::Fnd0ProductSessionData
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Create the clone of the Fnd0ProductSessionData object. Every subclass of the Fnd0ProductSessionData has to implement this operation.
    /// @version Teamcenter 12.2
    /// @param clonedObject - The cloned Object tag.
    /// @return - 
    ///
    int  fnd0Clone( tag_t *clonedObject );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0ProductSessionData();

    /**
     * Destructor
     */
    virtual ~Fnd0ProductSessionData();

private:
    //  Getter method for the Implementation Object
    Fnd0ProductSessionDataImpl*  getFnd0ProductSessionDataImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0ProductSessionDataImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0ProductSessionDataImpl*  m_fnd0productsessiondataImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0ProductSessionData - desc for Fnd0ProductSessionData parameter
     */
    Fnd0ProductSessionData( const Fnd0ProductSessionData& );
    Fnd0ProductSessionData& operator=( const Fnd0ProductSessionData& );

    friend class  Fnd0ProductSessionDataDelegate;
    friend class  Fnd0ProductSessionDataDispatch;
    friend class  Fnd0ProductSessionDataGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__FND0PRODUCTSESSIONDATA__HXX
