//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0PropagationRule
    Filename:   Fnd0PropagationRule.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0PROPAGATIONRULE__HXX
#define TEAMCENTER__FND0PROPAGATIONRULE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Fnd0TraversalRule.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class Fnd0PropagationRule;
}
namespace Teamcenter
{
    class Fnd0PropagationRuleImpl;
}
namespace Teamcenter
{
    class Fnd0PropagationRuleDelegate;
}
namespace Teamcenter
{
    class Fnd0PropagationRuleDispatch;
}
namespace Teamcenter
{
    class Fnd0PropagationRuleGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::Fnd0PropagationRule
     : public  ::Teamcenter::Fnd0TraversalRule
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0PropagationRule();

    /**
     * Destructor
     */
    virtual ~Fnd0PropagationRule();

private:
    //  Getter method for the Implementation Object
    Fnd0PropagationRuleImpl*  getFnd0PropagationRuleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0PropagationRuleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0PropagationRuleImpl*  m_fnd0propagationruleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0PropagationRule - desc for Fnd0PropagationRule parameter
     */
    Fnd0PropagationRule( const Fnd0PropagationRule& );
    Fnd0PropagationRule& operator=( const Fnd0PropagationRule& );

    friend class  Fnd0PropagationRuleDelegate;
    friend class  Fnd0PropagationRuleDispatch;
    friend class  Fnd0PropagationRuleGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__FND0PROPAGATIONRULE__HXX
