//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0SharedEffExprBlock
    Filename:   Fnd0SharedEffExprBlock.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0SHAREDEFFEXPRBLOCK__HXX
#define TEAMCENTER__FND0SHAREDEFFEXPRBLOCK__HXX

#include <common/tc_deprecation_macros.h>
#include <fnd0booleansolve/Fnd0EffectivityExprBlock.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class Fnd0SharedEffExprBlock;
}
namespace Teamcenter
{
    class Fnd0SharedEffExprBlockImpl;
}
namespace Teamcenter
{
    class Fnd0SharedEffExprBlockDelegate;
}
namespace Teamcenter
{
    class Fnd0SharedEffExprBlockDispatch;
}
namespace Teamcenter
{
    class Fnd0SharedEffExprBlockGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::Fnd0SharedEffExprBlock
     : public  ::Teamcenter::Fnd0EffectivityExprBlock
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0SharedEffExprBlock();

    /**
     * Destructor
     */
    virtual ~Fnd0SharedEffExprBlock();

private:
    //  Getter method for the Implementation Object
    Fnd0SharedEffExprBlockImpl*  getFnd0SharedEffExprBlockImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0SharedEffExprBlockImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0SharedEffExprBlockImpl*  m_fnd0sharedeffexprblockImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0SharedEffExprBlock - desc for Fnd0SharedEffExprBlock parameter
     */
    Fnd0SharedEffExprBlock( const Fnd0SharedEffExprBlock& );
    Fnd0SharedEffExprBlock& operator=( const Fnd0SharedEffExprBlock& );

    friend class  Fnd0SharedEffExprBlockDelegate;
    friend class  Fnd0SharedEffExprBlockDispatch;
    friend class  Fnd0SharedEffExprBlockGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__FND0SHAREDEFFEXPRBLOCK__HXX
