//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0StaticTable
    Filename:   Fnd0StaticTable.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0STATICTABLE__HXX
#define TEAMCENTER__FND0STATICTABLE__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class Fnd0StaticTable;
}
namespace Teamcenter
{
    class Fnd0StaticTableImpl;
}
namespace Teamcenter
{
    class Fnd0StaticTableDelegate;
}
namespace Teamcenter
{
    class Fnd0StaticTableDispatch;
}
namespace Teamcenter
{
    class Fnd0StaticTableGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::Fnd0StaticTable
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0StaticTableData( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 8.3
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0StaticTableData( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0StaticTable();

    /**
     * Destructor
     */
    virtual ~Fnd0StaticTable();

private:
    //  Getter method for the Implementation Object
    Fnd0StaticTableImpl*  getFnd0StaticTableImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0StaticTableImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0StaticTableImpl*  m_fnd0statictableImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0StaticTable - desc for Fnd0StaticTable parameter
     */
    Fnd0StaticTable( const Fnd0StaticTable& );
    Fnd0StaticTable& operator=( const Fnd0StaticTable& );

    friend class  Fnd0StaticTableDelegate;
    friend class  Fnd0StaticTableDispatch;
    friend class  Fnd0StaticTableGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__FND0STATICTABLE__HXX
