//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0StaticTableDelegate
    Filename:   Fnd0StaticTableDelegate.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0STATICTABLEDELEGATE_HXX
#define TEAMCENTER__FND0STATICTABLEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Fnd0StaticTable.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class Fnd0StaticTableDelegate;
}
namespace Teamcenter
{
    class Fnd0StaticTableImpl;
}
namespace Teamcenter
{
    class Fnd0StaticTable;
}
namespace Teamcenter
{
    class Fnd0StaticTableGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TCCORE_API Teamcenter_alias::Fnd0StaticTableDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0StaticTableDelegate instance
    static Fnd0StaticTableDelegate&  getInstance();

    //  Method to create the Fnd0StaticTableImpl pointer
    static Fnd0StaticTableImpl*  createImpl( Fnd0StaticTable&  ifObj );

    //  Method to delete the Fnd0StaticTableImpl pointer
    static void deleteImpl( Fnd0StaticTableImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.3
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0StaticTableDataBase(const Fnd0StaticTable &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 8.3
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0StaticTableDataBase(Fnd0StaticTable &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );



protected:
    //  Pointer to the instance
    static Fnd0StaticTableDelegate*  m_pInstance;

    Fnd0StaticTableDelegate();
    virtual ~Fnd0StaticTableDelegate();
    static void setInstance( Fnd0StaticTableDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0StaticTableGenImpl;

};

#include <tccore/libtccore_undef.h>
#endif  //  TEAMCENTER__FND0STATICTABLEDELEGATE_HXX
