//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0TraversalRule
    Filename:   Fnd0TraversalRule.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0TRAVERSALRULE__HXX
#define TEAMCENTER__FND0TRAVERSALRULE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/BusinessRule.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class Fnd0TraversalRule;
}
namespace Teamcenter
{
    class Fnd0TraversalRuleImpl;
}
namespace Teamcenter
{
    class Fnd0TraversalRuleDelegate;
}
namespace Teamcenter
{
    class Fnd0TraversalRuleDispatch;
}
namespace Teamcenter
{
    class Fnd0TraversalRuleGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::Fnd0TraversalRule
     : public  ::Teamcenter::BusinessRule
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0TraversalRule();

    /**
     * Destructor
     */
    virtual ~Fnd0TraversalRule();

private:
    //  Getter method for the Implementation Object
    Fnd0TraversalRuleImpl*  getFnd0TraversalRuleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0TraversalRuleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0TraversalRuleImpl*  m_fnd0traversalruleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0TraversalRule - desc for Fnd0TraversalRule parameter
     */
    Fnd0TraversalRule( const Fnd0TraversalRule& );
    Fnd0TraversalRule& operator=( const Fnd0TraversalRule& );

    friend class  Fnd0TraversalRuleDelegate;
    friend class  Fnd0TraversalRuleDispatch;
    friend class  Fnd0TraversalRuleGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__FND0TRAVERSALRULE__HXX
