//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0TypeSearchProvider
    Filename:   Fnd0TypeSearchProvider.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0TYPESEARCHPROVIDER__HXX
#define TEAMCENTER__FND0TYPESEARCHPROVIDER__HXX

#include <common/tc_deprecation_macros.h>
#include <tc/Fnd0BaseProvider.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class Fnd0TypeSearchProvider;
}
namespace Teamcenter
{
    class Fnd0TypeSearchProviderImpl;
}
namespace Teamcenter
{
    class Fnd0TypeSearchProviderDelegate;
}
namespace Teamcenter
{
    class Fnd0TypeSearchProviderDispatch;
}
namespace Teamcenter
{
    class Fnd0TypeSearchProviderGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::Fnd0TypeSearchProvider
     : public  ::Teamcenter::Fnd0BaseProvider
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0TypeSearchProvider();

    /**
     * Destructor
     */
    virtual ~Fnd0TypeSearchProvider();

private:
    //  Getter method for the Implementation Object
    Fnd0TypeSearchProviderImpl*  getFnd0TypeSearchProviderImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0TypeSearchProviderImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0TypeSearchProviderImpl*  m_fnd0typesearchproviderImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0TypeSearchProvider - desc for Fnd0TypeSearchProvider parameter
     */
    Fnd0TypeSearchProvider( const Fnd0TypeSearchProvider& );
    Fnd0TypeSearchProvider& operator=( const Fnd0TypeSearchProvider& );

    friend class  Fnd0TypeSearchProviderDelegate;
    friend class  Fnd0TypeSearchProviderDispatch;
    friend class  Fnd0TypeSearchProviderGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__FND0TYPESEARCHPROVIDER__HXX
