//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0TypeSearchProviderDelegate
    Filename:   Fnd0TypeSearchProviderDelegate.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0TYPESEARCHPROVIDERDELEGATE_HXX
#define TEAMCENTER__FND0TYPESEARCHPROVIDERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Fnd0TypeSearchProvider.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class Fnd0TypeSearchProviderDelegate;
}
namespace Teamcenter
{
    class Fnd0TypeSearchProviderImpl;
}
namespace Teamcenter
{
    class Fnd0TypeSearchProvider;
}
namespace Teamcenter
{
    class Fnd0TypeSearchProviderGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TCCORE_API Teamcenter_alias::Fnd0TypeSearchProviderDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0TypeSearchProviderDelegate instance
    static Fnd0TypeSearchProviderDelegate&  getInstance();

    //  Method to create the Fnd0TypeSearchProviderImpl pointer
    static Fnd0TypeSearchProviderImpl*  createImpl( Fnd0TypeSearchProvider&  ifObj );

    //  Method to delete the Fnd0TypeSearchProviderImpl pointer
    static void deleteImpl( Fnd0TypeSearchProviderImpl*  impl );


    ///
    /// This operation returns a structure containing search results, search filters for each search filter field based on the search results, and search filter categories.
    /// @version Teamcenter 9.1.2
    /// @param searchInput - The input to the search
    /// @param searchOutput - The output from the search.
    /// @return - Status. 0 if successful
    ///
    int  fnd0performSearchBase(const Fnd0TypeSearchProvider &ifObj,  ::Teamcenter::OperationInput *searchInput, ::Teamcenter::OperationInput *searchOutput );



protected:
    //  Pointer to the instance
    static Fnd0TypeSearchProviderDelegate*  m_pInstance;

    Fnd0TypeSearchProviderDelegate();
    virtual ~Fnd0TypeSearchProviderDelegate();
    static void setInstance( Fnd0TypeSearchProviderDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0TypeSearchProviderGenImpl;

};

#include <tccore/libtccore_undef.h>
#endif  //  TEAMCENTER__FND0TYPESEARCHPROVIDERDELEGATE_HXX
