//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0WSOThread
    Filename:   Fnd0WSOThread.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0WSOTHREAD__HXX
#define TEAMCENTER__FND0WSOTHREAD__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/Fnd0ObjectThread.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class Fnd0WSOThread;
}
namespace Teamcenter
{
    class Fnd0WSOThreadImpl;
}
namespace Teamcenter
{
    class Fnd0WSOThreadDelegate;
}
namespace Teamcenter
{
    class Fnd0WSOThreadDispatch;
}
namespace Teamcenter
{
    class Fnd0WSOThreadGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::Fnd0WSOThread
     : public  ::Teamcenter::Fnd0ObjectThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ThreadId( std::string &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0WSOThread();

    /**
     * Destructor
     */
    virtual ~Fnd0WSOThread();

private:
    //  Getter method for the Implementation Object
    Fnd0WSOThreadImpl*  getFnd0WSOThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0WSOThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0WSOThreadImpl*  m_fnd0wsothreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0WSOThread - desc for Fnd0WSOThread parameter
     */
    Fnd0WSOThread( const Fnd0WSOThread& );
    Fnd0WSOThread& operator=( const Fnd0WSOThread& );

    friend class  Fnd0WSOThreadDelegate;
    friend class  Fnd0WSOThreadDispatch;
    friend class  Fnd0WSOThreadGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__FND0WSOTHREAD__HXX
