//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0WSOThreadDelegate
    Filename:   Fnd0WSOThreadDelegate.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0WSOTHREADDELEGATE_HXX
#define TEAMCENTER__FND0WSOTHREADDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Fnd0WSOThread.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class Fnd0WSOThreadDelegate;
}
namespace Teamcenter
{
    class Fnd0WSOThreadImpl;
}
namespace Teamcenter
{
    class Fnd0WSOThread;
}
namespace Teamcenter
{
    class Fnd0WSOThreadGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TCCORE_API Teamcenter_alias::Fnd0WSOThreadDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0WSOThreadDelegate instance
    static Fnd0WSOThreadDelegate&  getInstance();

    //  Method to create the Fnd0WSOThreadImpl pointer
    static Fnd0WSOThreadImpl*  createImpl( Fnd0WSOThread&  ifObj );

    //  Method to delete the Fnd0WSOThreadImpl pointer
    static void deleteImpl( Fnd0WSOThreadImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ThreadIdBase(const Fnd0WSOThread &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Fnd0WSOThread &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// finalize operation input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  finalizeSaveAsInputBase(const Fnd0WSOThread &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Fnd0WSOThread &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// validate saveas input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  validateSaveAsInputBase(const Fnd0WSOThread &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static Fnd0WSOThreadDelegate*  m_pInstance;

    Fnd0WSOThreadDelegate();
    virtual ~Fnd0WSOThreadDelegate();
    static void setInstance( Fnd0WSOThreadDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0WSOThreadGenImpl;

};

#include <tccore/libtccore_undef.h>
#endif  //  TEAMCENTER__FND0WSOTHREADDELEGATE_HXX
