//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, IdContext
    Filename:   IdContext.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IDCONTEXT__HXX
#define TEAMCENTER__IDCONTEXT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class IdContext;
}
namespace Teamcenter
{
    class IdContextImpl;
}
namespace Teamcenter
{
    class IdContextDelegate;
}
namespace Teamcenter
{
    class IdContextDispatch;
}
namespace Teamcenter
{
    class IdContextGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::IdContext
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    IdContext();

    /**
     * Destructor
     */
    virtual ~IdContext();

private:
    //  Getter method for the Implementation Object
    IdContextImpl*  getIdContextImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setIdContextImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    IdContextImpl*  m_idcontextImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param IdContext - desc for IdContext parameter
     */
    IdContext( const IdContext& );
    IdContext& operator=( const IdContext& );

    friend class  IdContextDelegate;
    friend class  IdContextDispatch;
    friend class  IdContextGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__IDCONTEXT__HXX
