//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, IdContextRule
    Filename:   IdContextRule.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IDCONTEXTRULE__HXX
#define TEAMCENTER__IDCONTEXTRULE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/BusinessRule.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class IdContextRule;
}
namespace Teamcenter
{
    class IdContextRuleImpl;
}
namespace Teamcenter
{
    class IdContextRuleDelegate;
}
namespace Teamcenter
{
    class IdContextRuleDispatch;
}
namespace Teamcenter
{
    class IdContextRuleGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::IdContextRule
     : public  ::Teamcenter::BusinessRule
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    IdContextRule();

    /**
     * Destructor
     */
    virtual ~IdContextRule();

private:
    //  Getter method for the Implementation Object
    IdContextRuleImpl*  getIdContextRuleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setIdContextRuleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    IdContextRuleImpl*  m_idcontextruleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param IdContextRule - desc for IdContextRule parameter
     */
    IdContextRule( const IdContextRule& );
    IdContextRule& operator=( const IdContextRule& );

    friend class  IdContextRuleDelegate;
    friend class  IdContextRuleDispatch;
    friend class  IdContextRuleGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__IDCONTEXTRULE__HXX
