//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, IdContextRuleDelegate
    Filename:   IdContextRuleDelegate.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IDCONTEXTRULEDELEGATE_HXX
#define TEAMCENTER__IDCONTEXTRULEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/IdContextRule.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class IdContextRuleDelegate;
}
namespace Teamcenter
{
    class IdContextRuleImpl;
}
namespace Teamcenter
{
    class IdContextRule;
}
namespace Teamcenter
{
    class IdContextRuleGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TCCORE_API Teamcenter_alias::IdContextRuleDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the IdContextRuleDelegate instance
    static IdContextRuleDelegate&  getInstance();

    //  Method to create the IdContextRuleImpl pointer
    static IdContextRuleImpl*  createImpl( IdContextRule&  ifObj );

    //  Method to delete the IdContextRuleImpl pointer
    static void deleteImpl( IdContextRuleImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static IdContextRuleDelegate*  m_pInstance;

    IdContextRuleDelegate();
    virtual ~IdContextRuleDelegate();
    static void setInstance( IdContextRuleDelegate*  instance );


private:
    friend class  ::Teamcenter::IdContextRuleGenImpl;

};

#include <tccore/libtccore_undef.h>
#endif  //  TEAMCENTER__IDCONTEXTRULEDELEGATE_HXX
