//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, IdDispRule
    Filename:   IdDispRule.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IDDISPRULE__HXX
#define TEAMCENTER__IDDISPRULE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class IdDispRule;
}
namespace Teamcenter
{
    class IdDispRuleImpl;
}
namespace Teamcenter
{
    class IdDispRuleDelegate;
}
namespace Teamcenter
{
    class IdDispRuleDispatch;
}
namespace Teamcenter
{
    class IdDispRuleGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::IdDispRule
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    IdDispRule();

    /**
     * Destructor
     */
    virtual ~IdDispRule();

private:
    //  Getter method for the Implementation Object
    IdDispRuleImpl*  getIdDispRuleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setIdDispRuleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    IdDispRuleImpl*  m_iddispruleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param IdDispRule - desc for IdDispRule parameter
     */
    IdDispRule( const IdDispRule& );
    IdDispRule& operator=( const IdDispRule& );

    friend class  IdDispRuleDelegate;
    friend class  IdDispRuleDispatch;
    friend class  IdDispRuleGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__IDDISPRULE__HXX
