//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, IdDispRuleList
    Filename:   IdDispRuleList.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IDDISPRULELIST__HXX
#define TEAMCENTER__IDDISPRULELIST__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class IdDispRuleList;
}
namespace Teamcenter
{
    class IdDispRuleListImpl;
}
namespace Teamcenter
{
    class IdDispRuleListDelegate;
}
namespace Teamcenter
{
    class IdDispRuleListDispatch;
}
namespace Teamcenter
{
    class IdDispRuleListGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::IdDispRuleList
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    IdDispRuleList();

    /**
     * Destructor
     */
    virtual ~IdDispRuleList();

private:
    //  Getter method for the Implementation Object
    IdDispRuleListImpl*  getIdDispRuleListImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setIdDispRuleListImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    IdDispRuleListImpl*  m_iddisprulelistImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param IdDispRuleList - desc for IdDispRuleList parameter
     */
    IdDispRuleList( const IdDispRuleList& );
    IdDispRuleList& operator=( const IdDispRuleList& );

    friend class  IdDispRuleListDelegate;
    friend class  IdDispRuleListDispatch;
    friend class  IdDispRuleListGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__IDDISPRULELIST__HXX
