//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, IdDispRuleListDelegate
    Filename:   IdDispRuleListDelegate.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IDDISPRULELISTDELEGATE_HXX
#define TEAMCENTER__IDDISPRULELISTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/IdDispRuleList.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class IdDispRuleListDelegate;
}
namespace Teamcenter
{
    class IdDispRuleListImpl;
}
namespace Teamcenter
{
    class IdDispRuleList;
}
namespace Teamcenter
{
    class IdDispRuleListGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TCCORE_API Teamcenter_alias::IdDispRuleListDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the IdDispRuleListDelegate instance
    static IdDispRuleListDelegate&  getInstance();

    //  Method to create the IdDispRuleListImpl pointer
    static IdDispRuleListImpl*  createImpl( IdDispRuleList&  ifObj );

    //  Method to delete the IdDispRuleListImpl pointer
    static void deleteImpl( IdDispRuleListImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const IdDispRuleList &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static IdDispRuleListDelegate*  m_pInstance;

    IdDispRuleListDelegate();
    virtual ~IdDispRuleListDelegate();
    static void setInstance( IdDispRuleListDelegate*  instance );


private:
    friend class  ::Teamcenter::IdDispRuleListGenImpl;

};

#include <tccore/libtccore_undef.h>
#endif  //  TEAMCENTER__IDDISPRULELISTDELEGATE_HXX
