//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, IdDispRuleSpec
    Filename:   IdDispRuleSpec.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IDDISPRULESPEC__HXX
#define TEAMCENTER__IDDISPRULESPEC__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class IdDispRuleSpec;
}
namespace Teamcenter
{
    class IdDispRuleSpecImpl;
}
namespace Teamcenter
{
    class IdDispRuleSpecDelegate;
}
namespace Teamcenter
{
    class IdDispRuleSpecDispatch;
}
namespace Teamcenter
{
    class IdDispRuleSpecGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::IdDispRuleSpec
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    IdDispRuleSpec();

    /**
     * Destructor
     */
    virtual ~IdDispRuleSpec();

private:
    //  Getter method for the Implementation Object
    IdDispRuleSpecImpl*  getIdDispRuleSpecImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setIdDispRuleSpecImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    IdDispRuleSpecImpl*  m_iddisprulespecImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param IdDispRuleSpec - desc for IdDispRuleSpec parameter
     */
    IdDispRuleSpec( const IdDispRuleSpec& );
    IdDispRuleSpec& operator=( const IdDispRuleSpec& );

    friend class  IdDispRuleSpecDelegate;
    friend class  IdDispRuleSpecDispatch;
    friend class  IdDispRuleSpecGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__IDDISPRULESPEC__HXX
