//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ImanParameters
    Filename:   ImanParameters.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IMANPARAMETERS__HXX
#define TEAMCENTER__IMANPARAMETERS__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class ImanParameters;
}
namespace Teamcenter
{
    class ImanParametersImpl;
}
namespace Teamcenter
{
    class ImanParametersDelegate;
}
namespace Teamcenter
{
    class ImanParametersDispatch;
}
namespace Teamcenter
{
    class ImanParametersGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::ImanParameters
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ImanParameters();

    /**
     * Destructor
     */
    virtual ~ImanParameters();

private:
    //  Getter method for the Implementation Object
    ImanParametersImpl*  getImanParametersImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setImanParametersImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ImanParametersImpl*  m_imanparametersImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ImanParameters - desc for ImanParameters parameter
     */
    ImanParameters( const ImanParameters& );
    ImanParameters& operator=( const ImanParameters& );

    friend class  ImanParametersDelegate;
    friend class  ImanParametersDispatch;
    friend class  ImanParametersGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__IMANPARAMETERS__HXX
