//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ImanRelation
    Filename:   ImanRelation.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IMANRELATION__HXX
#define TEAMCENTER__IMANRELATION__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class ImanRelation;
}
namespace Teamcenter
{
    class ImanRelationImpl;
}
namespace Teamcenter
{
    class ImanRelationDelegate;
}
namespace Teamcenter
{
    class ImanRelationDispatch;
}
namespace Teamcenter
{
    class ImanRelationGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::ImanRelation
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0IsCsIdMigratedOnly( bool &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0IsPrimaryInSync( bool &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIs_modifiable( bool &value, bool &isNull ) const;

    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 11.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0IsPrimaryInSync( bool value, bool isNull=false );

    ///
    /// This operation returns the Copy Stable Last Modified Date for the secondary object.
    /// @version Teamcenter 11.2
    /// @param copyStableLmd - The Copy Stable Lmd of the secondary data on the relation.
    /// @param isNull - True if the value of lmd or lsd is  not set on the secondary object
    /// @return - 
    ///
    int  fnd0AskCopyStableLmd( date_t *copyStableLmd, bool *isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ImanRelation();

    /**
     * Destructor
     */
    virtual ~ImanRelation();

private:
    //  Getter method for the Implementation Object
    ImanRelationImpl*  getImanRelationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setImanRelationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ImanRelationImpl*  m_imanrelationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ImanRelation - desc for ImanRelation parameter
     */
    ImanRelation( const ImanRelation& );
    ImanRelation& operator=( const ImanRelation& );

    friend class  ImanRelationDelegate;
    friend class  ImanRelationDispatch;
    friend class  ImanRelationGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__IMANRELATION__HXX
