//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ImanType
    Filename:   ImanType.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IMANTYPE__HXX
#define TEAMCENTER__IMANTYPE__HXX

#include <string>
#include <extensionframework/OperationDispatcher.hxx>
#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class ImanType;
}
namespace Teamcenter
{
    class ImanTypeImpl;
}
namespace Teamcenter
{
    class ImanTypeDelegate;
}
namespace Teamcenter
{
    class ImanTypeDispatch;
}
namespace Teamcenter
{
    class ImanTypeGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::ImanType
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getArtifactName( std::string &value, bool &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCategory( int &value, bool &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIsAbstract( bool &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getParent_type( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getType_class( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getType_name( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setArtifactName( const std::string &value, bool isNull=false );

    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCategory( int value, bool isNull=false );

    ///
    /// Setter for a Boolean Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIsAbstract( bool value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setParent_type( const tag_t &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setType_class( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setType_name( const std::string &value, bool isNull=false );

    ///
    /// Returns Operation Dispatcher
    /// @version Tc 8
    /// @param propName - Property name
    /// @param msgName - Message name
    /// @param opInt - Operation Int
    /// @param opDispatcher - Operation Dispatcher
    /// @return - Returns Int
    ///
    int  getOperationDispatcher( const std::string &propName, const std::string &msgName, int &opInt,  ::Teamcenter::OperationDispatcher *&opDispatcher );

    ///
    /// Returns Operation Dispatcher
    /// @version Tc 8
    /// @param opId - Operation ID
    /// @param opInt - Operation Int
    /// @param opDispatcher - Operation Dispatcher
    /// @return - Returns int value
    ///
    int  getOperationDispatcher( const std::string &opId, int &opInt,  ::Teamcenter::OperationDispatcher *&opDispatcher );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ImanType();

    /**
     * Destructor
     */
    virtual ~ImanType();

private:
    //  Getter method for the Implementation Object
    ImanTypeImpl*  getImanTypeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setImanTypeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ImanTypeImpl*  m_imantypeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ImanType - desc for ImanType parameter
     */
    ImanType( const ImanType& );
    ImanType& operator=( const ImanType& );

    friend class  ImanTypeDelegate;
    friend class  ImanTypeDispatch;
    friend class  ImanTypeGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__IMANTYPE__HXX
