//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ImanTypeDelegate
    Filename:   ImanTypeDelegate.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__IMANTYPEDELEGATE_HXX
#define TEAMCENTER__IMANTYPEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanType.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class ImanTypeDelegate;
}
namespace Teamcenter
{
    class ImanTypeImpl;
}
namespace Teamcenter
{
    class ImanType;
}
namespace Teamcenter
{
    class ImanTypeGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TCCORE_API Teamcenter_alias::ImanTypeDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ImanTypeDelegate instance
    static ImanTypeDelegate&  getInstance();

    //  Method to create the ImanTypeImpl pointer
    static ImanTypeImpl*  createImpl( ImanType&  ifObj );

    //  Method to delete the ImanTypeImpl pointer
    static void deleteImpl( ImanTypeImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getArtifactNameBase(const ImanType &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getCategoryBase(const ImanType &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIsAbstractBase(const ImanType &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getParent_typeBase(const ImanType &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getType_classBase(const ImanType &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getType_nameBase(const ImanType &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setArtifactNameBase(ImanType &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setCategoryBase(ImanType &ifObj,  int value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIsAbstractBase(ImanType &ifObj,  bool value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setParent_typeBase(ImanType &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setType_classBase(ImanType &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setType_nameBase(ImanType &ifObj,  const std::string &value, bool isNull );


    ///
    /// Returns Operation Dispatcher
    /// @version Tc 8
    /// @param propName - Property name
    /// @param msgName - Message name
    /// @param opInt - Operation Int
    /// @param opDispatcher - Operation Dispatcher
    /// @return - Returns Int
    ///
    int  getOperationDispatcherBase(const ImanType &ifObj,  const std::string &propName, const std::string &msgName, int &opInt,  ::Teamcenter::OperationDispatcher *&opDispatcher );


    ///
    /// Returns Operation Dispatcher
    /// @version Tc 8
    /// @param opId - Operation ID
    /// @param opInt - Operation Int
    /// @param opDispatcher - Operation Dispatcher
    /// @return - Returns int value
    ///
    int  getOperationDispatcherBase(const ImanType &ifObj,  const std::string &opId, int &opInt,  ::Teamcenter::OperationDispatcher *&opDispatcher );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @param isLockForDelete - A boolean to indicate if object(s) are to be locked for deletion
    /// @param allowRelock - A boolean to indicate if object(s) can be relocked, which will discard all unsaved changes, if already locked by the same user
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0LockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd, const bool isLockForDelete, const bool allowRelock );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0RefreshBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0UnlockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static ImanTypeDelegate*  m_pInstance;

    ImanTypeDelegate();
    virtual ~ImanTypeDelegate();
    static void setInstance( ImanTypeDelegate*  instance );


private:
    friend class  ::Teamcenter::ImanTypeGenImpl;

};

#include <tccore/libtccore_undef.h>
#endif  //  TEAMCENTER__IMANTYPEDELEGATE_HXX
