//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ManagedRelation
    Filename:   ManagedRelation.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MANAGEDRELATION__HXX
#define TEAMCENTER__MANAGEDRELATION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class ManagedRelation;
}
namespace Teamcenter
{
    class ManagedRelationImpl;
}
namespace Teamcenter
{
    class ManagedRelationDelegate;
}
namespace Teamcenter
{
    class ManagedRelationDispatch;
}
namespace Teamcenter
{
    class ManagedRelationGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::ManagedRelation
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ManagedRelation();

    /**
     * Destructor
     */
    virtual ~ManagedRelation();

private:
    //  Getter method for the Implementation Object
    ManagedRelationImpl*  getManagedRelationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setManagedRelationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ManagedRelationImpl*  m_managedrelationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ManagedRelation - desc for ManagedRelation parameter
     */
    ManagedRelation( const ManagedRelation& );
    ManagedRelation& operator=( const ManagedRelation& );

    friend class  ManagedRelationDelegate;
    friend class  ManagedRelationDispatch;
    friend class  ManagedRelationGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__MANAGEDRELATION__HXX
