//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, POM_application_objectDelegate
    Filename:   POM_application_objectDelegate.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__POM_APPLICATION_OBJECTDELEGATE_HXX
#define TEAMCENTER__POM_APPLICATION_OBJECTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class POM_application_objectDelegate;
}
namespace Teamcenter
{
    class POM_application_objectImpl;
}
namespace Teamcenter
{
    class POM_application_object;
}
namespace Teamcenter
{
    class POM_application_objectGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TCCORE_API Teamcenter_alias::POM_application_objectDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the POM_application_objectDelegate instance
    static POM_application_objectDelegate&  getInstance();

    //  Method to create the POM_application_objectImpl pointer
    static POM_application_objectImpl*  createImpl( POM_application_object&  ifObj );

    //  Method to delete the POM_application_objectImpl pointer
    static void deleteImpl( POM_application_objectImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0DigitalSignAuditLogsBase(const POM_application_object &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 10.1.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0DSStateBase(const POM_application_object &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Operation to apply Digital Signature
    /// @version Teamcenter 10.1.1
    /// @param encryptedString - encryptedString
    /// @return - returns an int value
    ///
    int  fnd0ApplySignatureBase(const POM_application_object &ifObj,  const std::string *encryptedString );


    ///
    /// OwningGroup
    /// @version Teamcenter 9
    /// @param groupName - groupName
    /// @param output - output
    /// @return - int
    ///
    int  fnd0isOwningGroupBase(const POM_application_object &ifObj,  const std::string &groupName, bool *output );


    ///
    /// OwningUser
    /// @version Teamcenter 9
    /// @param userName - OwningUser
    /// @param output - output
    /// @return - int
    ///
    int  fnd0isOwningUserBase(const POM_application_object &ifObj,  const std::string &userName, bool *output );


    ///
    /// Operation for voiding Digital Signatures
    /// @version Teamcenter 10.1.1
    /// @param dsObjsToVoid - List of digital signature objects to be voided
    /// @param comments - Void Comments
    /// @return - returns int
    ///
    int  fnd0VoidSignatureBase(const POM_application_object &ifObj,  const std::vector< tag_t > *dsObjsToVoid, const std::string *comments );


    ///
    /// This operation deletes inputs objects in bulk. It either deletes none of the input objects or deletes all the input objects. It doesn't support partial deletion.
    /// @version Teamcenter 11.6
    /// @param inputs - A vector of data that contains reference to the object to be deleted.
    /// @param bd - A data structure to store objects and other information relevant for set-based operation.
    /// @return - Returns ITK_ok on Success. Otherwise, returns the specific error code.
    ///
    int  fnd0BulkDeleteBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static POM_application_objectDelegate*  m_pInstance;

    POM_application_objectDelegate();
    virtual ~POM_application_objectDelegate();
    static void setInstance( POM_application_objectDelegate*  instance );


private:
    friend class  ::Teamcenter::POM_application_objectGenImpl;

};

#include <tccore/libtccore_undef.h>
#endif  //  TEAMCENTER__POM_APPLICATION_OBJECTDELEGATE_HXX
