//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Part
    Filename:   Part.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PART__HXX
#define TEAMCENTER__PART__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class Part;
}
namespace Teamcenter
{
    class PartImpl;
}
namespace Teamcenter
{
    class PartDelegate;
}
namespace Teamcenter
{
    class PartDispatch;
}
namespace Teamcenter
{
    class PartGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::Part
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Part();

    /**
     * Destructor
     */
    virtual ~Part();

private:
    //  Getter method for the Implementation Object
    PartImpl*  getPartImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPartImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PartImpl*  m_partImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Part - desc for Part parameter
     */
    Part( const Part& );
    Part& operator=( const Part& );

    friend class  PartDelegate;
    friend class  PartDispatch;
    friend class  PartGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__PART__HXX
