//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PartDelegate
    Filename:   PartDelegate.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PARTDELEGATE_HXX
#define TEAMCENTER__PARTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Part.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class PartDelegate;
}
namespace Teamcenter
{
    class PartImpl;
}
namespace Teamcenter
{
    class Part;
}
namespace Teamcenter
{
    class PartGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TCCORE_API Teamcenter_alias::PartDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PartDelegate instance
    static PartDelegate&  getInstance();

    //  Method to create the PartImpl pointer
    static PartImpl*  createImpl( Part&  ifObj );

    //  Method to delete the PartImpl pointer
    static void deleteImpl( PartImpl*  impl );



protected:
    //  Pointer to the instance
    static PartDelegate*  m_pInstance;

    PartDelegate();
    virtual ~PartDelegate();
    static void setInstance( PartDelegate*  instance );


private:
    friend class  ::Teamcenter::PartGenImpl;

};

#include <tccore/libtccore_undef.h>
#endif  //  TEAMCENTER__PARTDELEGATE_HXX
