//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ProgressData
    Filename:   ProgressData.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROGRESSDATA__HXX
#define TEAMCENTER__PROGRESSDATA__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class ProgressData;
}
namespace Teamcenter
{
    class ProgressDataImpl;
}
namespace Teamcenter
{
    class ProgressDataDelegate;
}
namespace Teamcenter
{
    class ProgressDataDispatch;
}
namespace Teamcenter
{
    class ProgressDataGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::ProgressData
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ProgressData();

    /**
     * Destructor
     */
    virtual ~ProgressData();

private:
    //  Getter method for the Implementation Object
    ProgressDataImpl*  getProgressDataImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setProgressDataImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ProgressDataImpl*  m_progressdataImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ProgressData - desc for ProgressData parameter
     */
    ProgressData( const ProgressData& );
    ProgressData& operator=( const ProgressData& );

    friend class  ProgressDataDelegate;
    friend class  ProgressDataDispatch;
    friend class  ProgressDataGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__PROGRESSDATA__HXX
