//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ProjectObjectRelation
    Filename:   ProjectObjectRelation.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROJECTOBJECTRELATION__HXX
#define TEAMCENTER__PROJECTOBJECTRELATION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class ProjectObjectRelation;
}
namespace Teamcenter
{
    class ProjectObjectRelationImpl;
}
namespace Teamcenter
{
    class ProjectObjectRelationDelegate;
}
namespace Teamcenter
{
    class ProjectObjectRelationDispatch;
}
namespace Teamcenter
{
    class ProjectObjectRelationGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::ProjectObjectRelation
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ProjectObjectRelation();

    /**
     * Destructor
     */
    virtual ~ProjectObjectRelation();

private:
    //  Getter method for the Implementation Object
    ProjectObjectRelationImpl*  getProjectObjectRelationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setProjectObjectRelationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ProjectObjectRelationImpl*  m_projectobjectrelationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ProjectObjectRelation - desc for ProjectObjectRelation parameter
     */
    ProjectObjectRelation( const ProjectObjectRelation& );
    ProjectObjectRelation& operator=( const ProjectObjectRelation& );

    friend class  ProjectObjectRelationDelegate;
    friend class  ProjectObjectRelationDispatch;
    friend class  ProjectObjectRelationGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__PROJECTOBJECTRELATION__HXX
