//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ProjectObjectRelationDelegate
    Filename:   ProjectObjectRelationDelegate.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROJECTOBJECTRELATIONDELEGATE_HXX
#define TEAMCENTER__PROJECTOBJECTRELATIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ProjectObjectRelation.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class ProjectObjectRelationDelegate;
}
namespace Teamcenter
{
    class ProjectObjectRelationImpl;
}
namespace Teamcenter
{
    class ProjectObjectRelation;
}
namespace Teamcenter
{
    class ProjectObjectRelationGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TCCORE_API Teamcenter_alias::ProjectObjectRelationDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ProjectObjectRelationDelegate instance
    static ProjectObjectRelationDelegate&  getInstance();

    //  Method to create the ProjectObjectRelationImpl pointer
    static ProjectObjectRelationImpl*  createImpl( ProjectObjectRelation&  ifObj );

    //  Method to delete the ProjectObjectRelationImpl pointer
    static void deleteImpl( ProjectObjectRelationImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static ProjectObjectRelationDelegate*  m_pInstance;

    ProjectObjectRelationDelegate();
    virtual ~ProjectObjectRelationDelegate();
    static void setInstance( ProjectObjectRelationDelegate*  instance );


private:
    friend class  ::Teamcenter::ProjectObjectRelationGenImpl;

};

#include <tccore/libtccore_undef.h>
#endif  //  TEAMCENTER__PROJECTOBJECTRELATIONDELEGATE_HXX
