//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ProjectPreference
    Filename:   ProjectPreference.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROJECTPREFERENCE__HXX
#define TEAMCENTER__PROJECTPREFERENCE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class ProjectPreference;
}
namespace Teamcenter
{
    class ProjectPreferenceImpl;
}
namespace Teamcenter
{
    class ProjectPreferenceDelegate;
}
namespace Teamcenter
{
    class ProjectPreferenceDispatch;
}
namespace Teamcenter
{
    class ProjectPreferenceGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::ProjectPreference
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ProjectPreference();

    /**
     * Destructor
     */
    virtual ~ProjectPreference();

private:
    //  Getter method for the Implementation Object
    ProjectPreferenceImpl*  getProjectPreferenceImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setProjectPreferenceImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ProjectPreferenceImpl*  m_projectpreferenceImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ProjectPreference - desc for ProjectPreference parameter
     */
    ProjectPreference( const ProjectPreference& );
    ProjectPreference& operator=( const ProjectPreference& );

    friend class  ProjectPreferenceDelegate;
    friend class  ProjectPreferenceDispatch;
    friend class  ProjectPreferenceGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__PROJECTPREFERENCE__HXX
