//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ProjectPreferenceDelegate
    Filename:   ProjectPreferenceDelegate.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROJECTPREFERENCEDELEGATE_HXX
#define TEAMCENTER__PROJECTPREFERENCEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ProjectPreference.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class ProjectPreferenceDelegate;
}
namespace Teamcenter
{
    class ProjectPreferenceImpl;
}
namespace Teamcenter
{
    class ProjectPreference;
}
namespace Teamcenter
{
    class ProjectPreferenceGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TCCORE_API Teamcenter_alias::ProjectPreferenceDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ProjectPreferenceDelegate instance
    static ProjectPreferenceDelegate&  getInstance();

    //  Method to create the ProjectPreferenceImpl pointer
    static ProjectPreferenceImpl*  createImpl( ProjectPreference&  ifObj );

    //  Method to delete the ProjectPreferenceImpl pointer
    static void deleteImpl( ProjectPreferenceImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static ProjectPreferenceDelegate*  m_pInstance;

    ProjectPreferenceDelegate();
    virtual ~ProjectPreferenceDelegate();
    static void setInstance( ProjectPreferenceDelegate*  instance );


private:
    friend class  ::Teamcenter::ProjectPreferenceGenImpl;

};

#include <tccore/libtccore_undef.h>
#endif  //  TEAMCENTER__PROJECTPREFERENCEDELEGATE_HXX
