//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ProjectSmartFolder
    Filename:   ProjectSmartFolder.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROJECTSMARTFOLDER__HXX
#define TEAMCENTER__PROJECTSMARTFOLDER__HXX

#include <string>
#include <unidefs.h>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class ProjectSmartFolder;
}
namespace Teamcenter
{
    class ProjectSmartFolderImpl;
}
namespace Teamcenter
{
    class ProjectSmartFolderDelegate;
}
namespace Teamcenter
{
    class ProjectSmartFolderDispatch;
}
namespace Teamcenter
{
    class ProjectSmartFolderGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::ProjectSmartFolder
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFolder_name( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getOwning_project( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getProject_data( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFolder_name( const std::string &value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setOwning_project( const tag_t &value, bool isNull=false );

    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setProject_data( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ProjectSmartFolder();

    /**
     * Destructor
     */
    virtual ~ProjectSmartFolder();

private:
    //  Getter method for the Implementation Object
    ProjectSmartFolderImpl*  getProjectSmartFolderImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setProjectSmartFolderImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ProjectSmartFolderImpl*  m_projectsmartfolderImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ProjectSmartFolder - desc for ProjectSmartFolder parameter
     */
    ProjectSmartFolder( const ProjectSmartFolder& );
    ProjectSmartFolder& operator=( const ProjectSmartFolder& );

    friend class  ProjectSmartFolderDelegate;
    friend class  ProjectSmartFolderDispatch;
    friend class  ProjectSmartFolderGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__PROJECTSMARTFOLDER__HXX
