//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ProjectSmartFolderDelegate
    Filename:   ProjectSmartFolderDelegate.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROJECTSMARTFOLDERDELEGATE_HXX
#define TEAMCENTER__PROJECTSMARTFOLDERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ProjectSmartFolder.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class ProjectSmartFolderDelegate;
}
namespace Teamcenter
{
    class ProjectSmartFolderImpl;
}
namespace Teamcenter
{
    class ProjectSmartFolder;
}
namespace Teamcenter
{
    class ProjectSmartFolderGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TCCORE_API Teamcenter_alias::ProjectSmartFolderDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ProjectSmartFolderDelegate instance
    static ProjectSmartFolderDelegate&  getInstance();

    //  Method to create the ProjectSmartFolderImpl pointer
    static ProjectSmartFolderImpl*  createImpl( ProjectSmartFolder&  ifObj );

    //  Method to delete the ProjectSmartFolderImpl pointer
    static void deleteImpl( ProjectSmartFolderImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFolder_nameBase(const ProjectSmartFolder &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getOwning_projectBase(const ProjectSmartFolder &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getProject_dataBase(const ProjectSmartFolder &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFolder_nameBase(ProjectSmartFolder &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setOwning_projectBase(ProjectSmartFolder &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setProject_dataBase(ProjectSmartFolder &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// This is the getter for retrieving the recipe/permanent ID if its been created (and cached on the instance). Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param uid - Recipe/permanent ID
    /// @param isFirstTime - If Session Recovery Uid is yet to be set or does the object need to be serialized again?
    /// @return - Failure code
    ///
    int  fnd0AskSRUidBase(const ProjectSmartFolder &ifObj,  std::string *uid, bool *isFirstTime ) const;


    ///
    /// Generates permanent ID/recipe. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param recipe - Permanent ID/recipe
    /// @return - Failure code.
    ///
    int  fnd0GenerateRecipeBase(const ProjectSmartFolder &ifObj,  std::string *recipe );


    ///
    /// If Business Object supports recoverable ID. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param isPersistedRecipe - isPersistedRecipe param should be set to true if the recipe is limited to the user session and should be serialized to the database
    /// @param isRecoverableIDSupported - Returning true indicates support for recoverability/permanent IDs
    /// @return - Failure code.
    ///
    int  fnd0IsRecoverableBase(const ProjectSmartFolder &ifObj,  bool *isPersistedRecipe, bool *isRecoverableIDSupported ) const;


    ///
    /// This is the setter for the recipe/permanent ID when it is created (to be cached on the instance). Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param uid - Rrecipe/permanent ID
    /// @return - Failure code.
    ///
    int  fnd0SetSRUidBase(const ProjectSmartFolder &ifObj,  const std::string *uid );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getObject_stringBase(const ProjectSmartFolder &ifObj,  std::string &value, bool &isNull ) const;



protected:
    //  Pointer to the instance
    static ProjectSmartFolderDelegate*  m_pInstance;

    ProjectSmartFolderDelegate();
    virtual ~ProjectSmartFolderDelegate();
    static void setInstance( ProjectSmartFolderDelegate*  instance );


private:
    friend class  ::Teamcenter::ProjectSmartFolderGenImpl;

};

#include <tccore/libtccore_undef.h>
#endif  //  TEAMCENTER__PROJECTSMARTFOLDERDELEGATE_HXX
