//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ProjectTeam
    Filename:   ProjectTeam.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROJECTTEAM__HXX
#define TEAMCENTER__PROJECTTEAM__HXX

#include <common/tc_deprecation_macros.h>
#include <sa/Group.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class ProjectTeam;
}
namespace Teamcenter
{
    class ProjectTeamImpl;
}
namespace Teamcenter
{
    class ProjectTeamDelegate;
}
namespace Teamcenter
{
    class ProjectTeamDispatch;
}
namespace Teamcenter
{
    class ProjectTeamGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::ProjectTeam
     : public  ::Teamcenter::Group
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ProjectTeam();

    /**
     * Destructor
     */
    virtual ~ProjectTeam();

private:
    //  Getter method for the Implementation Object
    ProjectTeamImpl*  getProjectTeamImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setProjectTeamImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ProjectTeamImpl*  m_projectteamImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ProjectTeam - desc for ProjectTeam parameter
     */
    ProjectTeam( const ProjectTeam& );
    ProjectTeam& operator=( const ProjectTeam& );

    friend class  ProjectTeamDelegate;
    friend class  ProjectTeamDispatch;
    friend class  ProjectTeamGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__PROJECTTEAM__HXX
