//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ProjectTeamDelegate
    Filename:   ProjectTeamDelegate.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROJECTTEAMDELEGATE_HXX
#define TEAMCENTER__PROJECTTEAMDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ProjectTeam.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class ProjectTeamDelegate;
}
namespace Teamcenter
{
    class ProjectTeamImpl;
}
namespace Teamcenter
{
    class ProjectTeam;
}
namespace Teamcenter
{
    class ProjectTeamGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TCCORE_API Teamcenter_alias::ProjectTeamDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ProjectTeamDelegate instance
    static ProjectTeamDelegate&  getInstance();

    //  Method to create the ProjectTeamImpl pointer
    static ProjectTeamImpl*  createImpl( ProjectTeam&  ifObj );

    //  Method to delete the ProjectTeamImpl pointer
    static void deleteImpl( ProjectTeamImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static ProjectTeamDelegate*  m_pInstance;

    ProjectTeamDelegate();
    virtual ~ProjectTeamDelegate();
    static void setInstance( ProjectTeamDelegate*  instance );


private:
    friend class  ::Teamcenter::ProjectTeamGenImpl;

};

#include <tccore/libtccore_undef.h>
#endif  //  TEAMCENTER__PROJECTTEAMDELEGATE_HXX
