//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PseudoFolder
    Filename:   PseudoFolder.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PSEUDOFOLDER__HXX
#define TEAMCENTER__PSEUDOFOLDER__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class PseudoFolder;
}
namespace Teamcenter
{
    class PseudoFolderImpl;
}
namespace Teamcenter
{
    class PseudoFolderDelegate;
}
namespace Teamcenter
{
    class PseudoFolderDispatch;
}
namespace Teamcenter
{
    class PseudoFolderGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::PseudoFolder
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PseudoFolder();

    /**
     * Destructor
     */
    virtual ~PseudoFolder();

private:
    //  Getter method for the Implementation Object
    PseudoFolderImpl*  getPseudoFolderImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPseudoFolderImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PseudoFolderImpl*  m_pseudofolderImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PseudoFolder - desc for PseudoFolder parameter
     */
    PseudoFolder( const PseudoFolder& );
    PseudoFolder& operator=( const PseudoFolder& );

    friend class  PseudoFolderDelegate;
    friend class  PseudoFolderDispatch;
    friend class  PseudoFolderGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__PSEUDOFOLDER__HXX
