//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PseudoFolderDelegate
    Filename:   PseudoFolderDelegate.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PSEUDOFOLDERDELEGATE_HXX
#define TEAMCENTER__PSEUDOFOLDERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/PseudoFolder.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class PseudoFolderDelegate;
}
namespace Teamcenter
{
    class PseudoFolderImpl;
}
namespace Teamcenter
{
    class PseudoFolder;
}
namespace Teamcenter
{
    class PseudoFolderGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TCCORE_API Teamcenter_alias::PseudoFolderDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the PseudoFolderDelegate instance
    static PseudoFolderDelegate&  getInstance();

    //  Method to create the PseudoFolderImpl pointer
    static PseudoFolderImpl*  createImpl( PseudoFolder&  ifObj );

    //  Method to delete the PseudoFolderImpl pointer
    static void deleteImpl( PseudoFolderImpl*  impl );


    ///
    /// This is the getter for retrieving the recipe/permanent ID if its been created (and cached on the instance). Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param uid - Recipe/permanent ID
    /// @param isFirstTime - If Session Recovery Uid is yet to be set or does the object need to be serialized again?
    /// @return - Failure code
    ///
    int  fnd0AskSRUidBase(const PseudoFolder &ifObj,  std::string *uid, bool *isFirstTime ) const;


    ///
    /// Generates permanent ID/recipe. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param recipe - Permanent ID/recipe
    /// @return - Failure code.
    ///
    int  fnd0GenerateRecipeBase(const PseudoFolder &ifObj,  std::string *recipe );


    ///
    /// This operation returns the children to be displayed when expanding this object.
    /// @version Teamcenter 10
    /// @param propertyNames - The list of propertyNames to expand.  If empty, then the properties defined in <TYPE>_DefaultChildProperties and <TYPE>_DefaultPseudoFolder are returned.
    /// @param childTags - Tags of children.
    /// @param childContextPropertyNames - The propertyName in which this child exists in the parent.
    /// @return - status
    ///
    int  fnd0GetChildrenBase(const PseudoFolder &ifObj,  const std::vector< std::string > *propertyNames, std::vector< tag_t > *childTags, std::vector< std::string > *childContextPropertyNames );


    ///
    /// If Business Object supports recoverable ID. Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param isPersistedRecipe - isPersistedRecipe param should be set to true if the recipe is limited to the user session and should be serialized to the database
    /// @param isRecoverableIDSupported - Returning true indicates support for recoverability/permanent IDs
    /// @return - Failure code.
    ///
    int  fnd0IsRecoverableBase(const PseudoFolder &ifObj,  bool *isPersistedRecipe, bool *isRecoverableIDSupported ) const;


    ///
    /// This is the setter for the recipe/permanent ID when it is created (to be cached on the instance). Every Business Object should implement this operation.
    /// @version Teamcenter 11.1
    /// @param uid - Rrecipe/permanent ID
    /// @return - Failure code.
    ///
    int  fnd0SetSRUidBase(const PseudoFolder &ifObj,  const std::string *uid );



protected:
    //  Pointer to the instance
    static PseudoFolderDelegate*  m_pInstance;

    PseudoFolderDelegate();
    virtual ~PseudoFolderDelegate();
    static void setInstance( PseudoFolderDelegate*  instance );


private:
    friend class  ::Teamcenter::PseudoFolderGenImpl;

};

#include <tccore/libtccore_undef.h>
#endif  //  TEAMCENTER__PSEUDOFOLDERDELEGATE_HXX
