//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ReleaseStatus
    Filename:   ReleaseStatus.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__RELEASESTATUS__HXX
#define TEAMCENTER__RELEASESTATUS__HXX

#include <string>
#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class ReleaseStatus;
}
namespace Teamcenter
{
    class ReleaseStatusImpl;
}
namespace Teamcenter
{
    class ReleaseStatusDelegate;
}
namespace Teamcenter
{
    class ReleaseStatusDispatch;
}
namespace Teamcenter
{
    class ReleaseStatusGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::ReleaseStatus
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getObject_name( std::string &value, bool &isNull ) const;

    ///
    /// Getter for Property Display Value
    /// @version Teamcenter 11.4
    /// @param values - Parameter value
    /// @return - Status. 0 if successful
    ///
    int  getObject_nameDisplayableValues( std::vector< std::string > &values );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ReleaseStatus();

    /**
     * Destructor
     */
    virtual ~ReleaseStatus();

private:
    //  Getter method for the Implementation Object
    ReleaseStatusImpl*  getReleaseStatusImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setReleaseStatusImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ReleaseStatusImpl*  m_releasestatusImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ReleaseStatus - desc for ReleaseStatus parameter
     */
    ReleaseStatus( const ReleaseStatus& );
    ReleaseStatus& operator=( const ReleaseStatus& );

    friend class  ReleaseStatusDelegate;
    friend class  ReleaseStatusDispatch;
    friend class  ReleaseStatusGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__RELEASESTATUS__HXX
