//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TC_Program_Preferred_Items
    Filename:   TC_Program_Preferred_Items.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TC_PROGRAM_PREFERRED_ITEMS__HXX
#define TEAMCENTER__TC_PROGRAM_PREFERRED_ITEMS__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class TC_Program_Preferred_Items;
}
namespace Teamcenter
{
    class TC_Program_Preferred_ItemsImpl;
}
namespace Teamcenter
{
    class TC_Program_Preferred_ItemsDelegate;
}
namespace Teamcenter
{
    class TC_Program_Preferred_ItemsDispatch;
}
namespace Teamcenter
{
    class TC_Program_Preferred_ItemsGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::TC_Program_Preferred_Items
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    TC_Program_Preferred_Items();

    /**
     * Destructor
     */
    virtual ~TC_Program_Preferred_Items();

private:
    //  Getter method for the Implementation Object
    TC_Program_Preferred_ItemsImpl*  getTC_Program_Preferred_ItemsImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTC_Program_Preferred_ItemsImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    TC_Program_Preferred_ItemsImpl*  m_tc_program_preferred_itemsImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param TC_Program_Preferred_Items - desc for TC_Program_Preferred_Items parameter
     */
    TC_Program_Preferred_Items( const TC_Program_Preferred_Items& );
    TC_Program_Preferred_Items& operator=( const TC_Program_Preferred_Items& );

    friend class  TC_Program_Preferred_ItemsDelegate;
    friend class  TC_Program_Preferred_ItemsDispatch;
    friend class  TC_Program_Preferred_ItemsGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__TC_PROGRAM_PREFERRED_ITEMS__HXX
