//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TableCellBCDDelegate
    Filename:   TableCellBCDDelegate.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TABLECELLBCDDELEGATE_HXX
#define TEAMCENTER__TABLECELLBCDDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/TableCellBCD.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class TableCellBCDDelegate;
}
namespace Teamcenter
{
    class TableCellBCDImpl;
}
namespace Teamcenter
{
    class TableCellBCD;
}
namespace Teamcenter
{
    class TableCellBCDGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TCCORE_API Teamcenter_alias::TableCellBCDDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the TableCellBCDDelegate instance
    static TableCellBCDDelegate&  getInstance();

    //  Method to create the TableCellBCDImpl pointer
    static TableCellBCDImpl*  createImpl( TableCellBCD&  ifObj );

    //  Method to delete the TableCellBCDImpl pointer
    static void deleteImpl( TableCellBCDImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValueBase(const TableCellBCD &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValueBase(TableCellBCD &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static TableCellBCDDelegate*  m_pInstance;

    TableCellBCDDelegate();
    virtual ~TableCellBCDDelegate();
    static void setInstance( TableCellBCDDelegate*  instance );


private:
    friend class  ::Teamcenter::TableCellBCDGenImpl;

};

#include <tccore/libtccore_undef.h>
#endif  //  TEAMCENTER__TABLECELLBCDDELEGATE_HXX
