//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TableCellDateDelegate
    Filename:   TableCellDateDelegate.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TABLECELLDATEDELEGATE_HXX
#define TEAMCENTER__TABLECELLDATEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/TableCellDate.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class TableCellDateDelegate;
}
namespace Teamcenter
{
    class TableCellDateImpl;
}
namespace Teamcenter
{
    class TableCellDate;
}
namespace Teamcenter
{
    class TableCellDateGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TCCORE_API Teamcenter_alias::TableCellDateDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the TableCellDateDelegate instance
    static TableCellDateDelegate&  getInstance();

    //  Method to create the TableCellDateImpl pointer
    static TableCellDateImpl*  createImpl( TableCellDate&  ifObj );

    //  Method to delete the TableCellDateImpl pointer
    static void deleteImpl( TableCellDateImpl*  impl );


    ///
    /// Getter for a Date Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValueBase(const TableCellDate &ifObj,  date_t &value, bool &isNull ) const;


    ///
    /// Setter for a Date Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValueBase(TableCellDate &ifObj,  const date_t &value, bool isNull );



protected:
    //  Pointer to the instance
    static TableCellDateDelegate*  m_pInstance;

    TableCellDateDelegate();
    virtual ~TableCellDateDelegate();
    static void setInstance( TableCellDateDelegate*  instance );


private:
    friend class  ::Teamcenter::TableCellDateGenImpl;

};

#include <tccore/libtccore_undef.h>
#endif  //  TEAMCENTER__TABLECELLDATEDELEGATE_HXX
