//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TableCellDelegate
    Filename:   TableCellDelegate.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TABLECELLDELEGATE_HXX
#define TEAMCENTER__TABLECELLDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/TableCell.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class TableCellDelegate;
}
namespace Teamcenter
{
    class TableCellImpl;
}
namespace Teamcenter
{
    class TableCell;
}
namespace Teamcenter
{
    class TableCellGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TCCORE_API Teamcenter_alias::TableCellDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the TableCellDelegate instance
    static TableCellDelegate&  getInstance();

    //  Method to create the TableCellImpl pointer
    static TableCellImpl*  createImpl( TableCell&  ifObj );

    //  Method to delete the TableCellImpl pointer
    static void deleteImpl( TableCellImpl*  impl );


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getColBase(const TableCell &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDescBase(const TableCell &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRowBase(const TableCell &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setColBase(TableCell &ifObj,  int value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDescBase(TableCell &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setRowBase(TableCell &ifObj,  int value, bool isNull );



protected:
    //  Pointer to the instance
    static TableCellDelegate*  m_pInstance;

    TableCellDelegate();
    virtual ~TableCellDelegate();
    static void setInstance( TableCellDelegate*  instance );


private:
    friend class  ::Teamcenter::TableCellGenImpl;

};

#include <tccore/libtccore_undef.h>
#endif  //  TEAMCENTER__TABLECELLDELEGATE_HXX
