//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TableCellDouble
    Filename:   TableCellDouble.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TABLECELLDOUBLE__HXX
#define TEAMCENTER__TABLECELLDOUBLE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/TableCell.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class TableCellDouble;
}
namespace Teamcenter
{
    class TableCellDoubleImpl;
}
namespace Teamcenter
{
    class TableCellDoubleDelegate;
}
namespace Teamcenter
{
    class TableCellDoubleDispatch;
}
namespace Teamcenter
{
    class TableCellDoubleGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::TableCellDouble
     : public  ::Teamcenter::TableCell
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValue( double &value, bool &isNull ) const;

    ///
    /// Setter for a Double Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValue( double value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    TableCellDouble();

    /**
     * Destructor
     */
    virtual ~TableCellDouble();

private:
    //  Getter method for the Implementation Object
    TableCellDoubleImpl*  getTableCellDoubleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTableCellDoubleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    TableCellDoubleImpl*  m_tablecelldoubleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param TableCellDouble - desc for TableCellDouble parameter
     */
    TableCellDouble( const TableCellDouble& );
    TableCellDouble& operator=( const TableCellDouble& );

    friend class  TableCellDoubleDelegate;
    friend class  TableCellDoubleDispatch;
    friend class  TableCellDoubleGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__TABLECELLDOUBLE__HXX
