//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TableCellDoubleDelegate
    Filename:   TableCellDoubleDelegate.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TABLECELLDOUBLEDELEGATE_HXX
#define TEAMCENTER__TABLECELLDOUBLEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/TableCellDouble.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class TableCellDoubleDelegate;
}
namespace Teamcenter
{
    class TableCellDoubleImpl;
}
namespace Teamcenter
{
    class TableCellDouble;
}
namespace Teamcenter
{
    class TableCellDoubleGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TCCORE_API Teamcenter_alias::TableCellDoubleDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the TableCellDoubleDelegate instance
    static TableCellDoubleDelegate&  getInstance();

    //  Method to create the TableCellDoubleImpl pointer
    static TableCellDoubleImpl*  createImpl( TableCellDouble&  ifObj );

    //  Method to delete the TableCellDoubleImpl pointer
    static void deleteImpl( TableCellDoubleImpl*  impl );


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValueBase(const TableCellDouble &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Setter for a Double Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValueBase(TableCellDouble &ifObj,  double value, bool isNull );



protected:
    //  Pointer to the instance
    static TableCellDoubleDelegate*  m_pInstance;

    TableCellDoubleDelegate();
    virtual ~TableCellDoubleDelegate();
    static void setInstance( TableCellDoubleDelegate*  instance );


private:
    friend class  ::Teamcenter::TableCellDoubleGenImpl;

};

#include <tccore/libtccore_undef.h>
#endif  //  TEAMCENTER__TABLECELLDOUBLEDELEGATE_HXX
