//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TableCellHex
    Filename:   TableCellHex.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TABLECELLHEX__HXX
#define TEAMCENTER__TABLECELLHEX__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/TableCell.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class TableCellHex;
}
namespace Teamcenter
{
    class TableCellHexImpl;
}
namespace Teamcenter
{
    class TableCellHexDelegate;
}
namespace Teamcenter
{
    class TableCellHexDispatch;
}
namespace Teamcenter
{
    class TableCellHexGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::TableCellHex
     : public  ::Teamcenter::TableCell
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValue( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValue( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    TableCellHex();

    /**
     * Destructor
     */
    virtual ~TableCellHex();

private:
    //  Getter method for the Implementation Object
    TableCellHexImpl*  getTableCellHexImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTableCellHexImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    TableCellHexImpl*  m_tablecellhexImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param TableCellHex - desc for TableCellHex parameter
     */
    TableCellHex( const TableCellHex& );
    TableCellHex& operator=( const TableCellHex& );

    friend class  TableCellHexDelegate;
    friend class  TableCellHexDispatch;
    friend class  TableCellHexGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__TABLECELLHEX__HXX
