//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TableCellInt
    Filename:   TableCellInt.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TABLECELLINT__HXX
#define TEAMCENTER__TABLECELLINT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/TableCell.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class TableCellInt;
}
namespace Teamcenter
{
    class TableCellIntImpl;
}
namespace Teamcenter
{
    class TableCellIntDelegate;
}
namespace Teamcenter
{
    class TableCellIntDispatch;
}
namespace Teamcenter
{
    class TableCellIntGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::TableCellInt
     : public  ::Teamcenter::TableCell
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValue( int &value, bool &isNull ) const;

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValue( int value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    TableCellInt();

    /**
     * Destructor
     */
    virtual ~TableCellInt();

private:
    //  Getter method for the Implementation Object
    TableCellIntImpl*  getTableCellIntImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTableCellIntImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    TableCellIntImpl*  m_tablecellintImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param TableCellInt - desc for TableCellInt parameter
     */
    TableCellInt( const TableCellInt& );
    TableCellInt& operator=( const TableCellInt& );

    friend class  TableCellIntDelegate;
    friend class  TableCellIntDispatch;
    friend class  TableCellIntGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__TABLECELLINT__HXX
