//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TableCellIntDelegate
    Filename:   TableCellIntDelegate.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TABLECELLINTDELEGATE_HXX
#define TEAMCENTER__TABLECELLINTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/TableCellInt.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class TableCellIntDelegate;
}
namespace Teamcenter
{
    class TableCellIntImpl;
}
namespace Teamcenter
{
    class TableCellInt;
}
namespace Teamcenter
{
    class TableCellIntGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TCCORE_API Teamcenter_alias::TableCellIntDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the TableCellIntDelegate instance
    static TableCellIntDelegate&  getInstance();

    //  Method to create the TableCellIntImpl pointer
    static TableCellIntImpl*  createImpl( TableCellInt&  ifObj );

    //  Method to delete the TableCellIntImpl pointer
    static void deleteImpl( TableCellIntImpl*  impl );


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValueBase(const TableCellInt &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValueBase(TableCellInt &ifObj,  int value, bool isNull );



protected:
    //  Pointer to the instance
    static TableCellIntDelegate*  m_pInstance;

    TableCellIntDelegate();
    virtual ~TableCellIntDelegate();
    static void setInstance( TableCellIntDelegate*  instance );


private:
    friend class  ::Teamcenter::TableCellIntGenImpl;

};

#include <tccore/libtccore_undef.h>
#endif  //  TEAMCENTER__TABLECELLINTDELEGATE_HXX
