//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TableCellLogical
    Filename:   TableCellLogical.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TABLECELLLOGICAL__HXX
#define TEAMCENTER__TABLECELLLOGICAL__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/TableCell.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class TableCellLogical;
}
namespace Teamcenter
{
    class TableCellLogicalImpl;
}
namespace Teamcenter
{
    class TableCellLogicalDelegate;
}
namespace Teamcenter
{
    class TableCellLogicalDispatch;
}
namespace Teamcenter
{
    class TableCellLogicalGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::TableCellLogical
     : public  ::Teamcenter::TableCell
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValue( bool &value, bool &isNull ) const;

    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValue( bool value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    TableCellLogical();

    /**
     * Destructor
     */
    virtual ~TableCellLogical();

private:
    //  Getter method for the Implementation Object
    TableCellLogicalImpl*  getTableCellLogicalImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTableCellLogicalImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    TableCellLogicalImpl*  m_tablecelllogicalImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param TableCellLogical - desc for TableCellLogical parameter
     */
    TableCellLogical( const TableCellLogical& );
    TableCellLogical& operator=( const TableCellLogical& );

    friend class  TableCellLogicalDelegate;
    friend class  TableCellLogicalDispatch;
    friend class  TableCellLogicalGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__TABLECELLLOGICAL__HXX
