//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TableCellLogicalDelegate
    Filename:   TableCellLogicalDelegate.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TABLECELLLOGICALDELEGATE_HXX
#define TEAMCENTER__TABLECELLLOGICALDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/TableCellLogical.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class TableCellLogicalDelegate;
}
namespace Teamcenter
{
    class TableCellLogicalImpl;
}
namespace Teamcenter
{
    class TableCellLogical;
}
namespace Teamcenter
{
    class TableCellLogicalGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TCCORE_API Teamcenter_alias::TableCellLogicalDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the TableCellLogicalDelegate instance
    static TableCellLogicalDelegate&  getInstance();

    //  Method to create the TableCellLogicalImpl pointer
    static TableCellLogicalImpl*  createImpl( TableCellLogical&  ifObj );

    //  Method to delete the TableCellLogicalImpl pointer
    static void deleteImpl( TableCellLogicalImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValueBase(const TableCellLogical &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValueBase(TableCellLogical &ifObj,  bool value, bool isNull );



protected:
    //  Pointer to the instance
    static TableCellLogicalDelegate*  m_pInstance;

    TableCellLogicalDelegate();
    virtual ~TableCellLogicalDelegate();
    static void setInstance( TableCellLogicalDelegate*  instance );


private:
    friend class  ::Teamcenter::TableCellLogicalGenImpl;

};

#include <tccore/libtccore_undef.h>
#endif  //  TEAMCENTER__TABLECELLLOGICALDELEGATE_HXX
