//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TableCellSED
    Filename:   TableCellSED.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TABLECELLSED__HXX
#define TEAMCENTER__TABLECELLSED__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/TableCell.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class TableCellSED;
}
namespace Teamcenter
{
    class TableCellSEDImpl;
}
namespace Teamcenter
{
    class TableCellSEDDelegate;
}
namespace Teamcenter
{
    class TableCellSEDDispatch;
}
namespace Teamcenter
{
    class TableCellSEDGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::TableCellSED
     : public  ::Teamcenter::TableCell
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0DomainElementDesc( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValue( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0DomainElementDesc( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValue( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    TableCellSED();

    /**
     * Destructor
     */
    virtual ~TableCellSED();

private:
    //  Getter method for the Implementation Object
    TableCellSEDImpl*  getTableCellSEDImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTableCellSEDImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    TableCellSEDImpl*  m_tablecellsedImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param TableCellSED - desc for TableCellSED parameter
     */
    TableCellSED( const TableCellSED& );
    TableCellSED& operator=( const TableCellSED& );

    friend class  TableCellSEDDelegate;
    friend class  TableCellSEDDispatch;
    friend class  TableCellSEDGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__TABLECELLSED__HXX
