//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TableCellSEDDelegate
    Filename:   TableCellSEDDelegate.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TABLECELLSEDDELEGATE_HXX
#define TEAMCENTER__TABLECELLSEDDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/TableCellSED.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class TableCellSEDDelegate;
}
namespace Teamcenter
{
    class TableCellSEDImpl;
}
namespace Teamcenter
{
    class TableCellSED;
}
namespace Teamcenter
{
    class TableCellSEDGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TCCORE_API Teamcenter_alias::TableCellSEDDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the TableCellSEDDelegate instance
    static TableCellSEDDelegate&  getInstance();

    //  Method to create the TableCellSEDImpl pointer
    static TableCellSEDImpl*  createImpl( TableCellSED&  ifObj );

    //  Method to delete the TableCellSEDImpl pointer
    static void deleteImpl( TableCellSEDImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0DomainElementDescBase(const TableCellSED &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValueBase(const TableCellSED &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0DomainElementDescBase(TableCellSED &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValueBase(TableCellSED &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static TableCellSEDDelegate*  m_pInstance;

    TableCellSEDDelegate();
    virtual ~TableCellSEDDelegate();
    static void setInstance( TableCellSEDDelegate*  instance );


private:
    friend class  ::Teamcenter::TableCellSEDGenImpl;

};

#include <tccore/libtccore_undef.h>
#endif  //  TEAMCENTER__TABLECELLSEDDELEGATE_HXX
