//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TableCellStringDelegate
    Filename:   TableCellStringDelegate.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TABLECELLSTRINGDELEGATE_HXX
#define TEAMCENTER__TABLECELLSTRINGDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/TableCellString.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class TableCellStringDelegate;
}
namespace Teamcenter
{
    class TableCellStringImpl;
}
namespace Teamcenter
{
    class TableCellString;
}
namespace Teamcenter
{
    class TableCellStringGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TCCORE_API Teamcenter_alias::TableCellStringDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the TableCellStringDelegate instance
    static TableCellStringDelegate&  getInstance();

    //  Method to create the TableCellStringImpl pointer
    static TableCellStringImpl*  createImpl( TableCellString&  ifObj );

    //  Method to delete the TableCellStringImpl pointer
    static void deleteImpl( TableCellStringImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValueBase(const TableCellString &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValueBase(TableCellString &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static TableCellStringDelegate*  m_pInstance;

    TableCellStringDelegate();
    virtual ~TableCellStringDelegate();
    static void setInstance( TableCellStringDelegate*  instance );


private:
    friend class  ::Teamcenter::TableCellStringGenImpl;

};

#include <tccore/libtccore_undef.h>
#endif  //  TEAMCENTER__TABLECELLSTRINGDELEGATE_HXX
