//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TableDefinitionDelegate
    Filename:   TableDefinitionDelegate.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TABLEDEFINITIONDELEGATE_HXX
#define TEAMCENTER__TABLEDEFINITIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/TableDefinition.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class TableDefinitionDelegate;
}
namespace Teamcenter
{
    class TableDefinitionImpl;
}
namespace Teamcenter
{
    class TableDefinition;
}
namespace Teamcenter
{
    class TableDefinitionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TCCORE_API Teamcenter_alias::TableDefinitionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the TableDefinitionDelegate instance
    static TableDefinitionDelegate&  getInstance();

    //  Method to create the TableDefinitionImpl pointer
    static TableDefinitionImpl*  createImpl( TableDefinition&  ifObj );

    //  Method to delete the TableDefinitionImpl pointer
    static void deleteImpl( TableDefinitionImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getColLabelsBase(const TableDefinition &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getColsBase(const TableDefinition &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getRowLabelsBase(const TableDefinition &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRowsBase(const TableDefinition &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setColLabelsBase(TableDefinition &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setColsBase(TableDefinition &ifObj,  int value, bool isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setRowLabelsBase(TableDefinition &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setRowsBase(TableDefinition &ifObj,  int value, bool isNull );



protected:
    //  Pointer to the instance
    static TableDefinitionDelegate*  m_pInstance;

    TableDefinitionDelegate();
    virtual ~TableDefinitionDelegate();
    static void setInstance( TableDefinitionDelegate*  instance );


private:
    friend class  ::Teamcenter::TableDefinitionGenImpl;

};

#include <tccore/libtccore_undef.h>
#endif  //  TEAMCENTER__TABLEDEFINITIONDELEGATE_HXX
