//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TableDelegate
    Filename:   TableDelegate.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TABLEDELEGATE_HXX
#define TEAMCENTER__TABLEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Table.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class TableDelegate;
}
namespace Teamcenter
{
    class TableImpl;
}
namespace Teamcenter
{
    class Table;
}
namespace Teamcenter
{
    class TableGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TCCORE_API Teamcenter_alias::TableDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the TableDelegate instance
    static TableDelegate&  getInstance();

    //  Method to create the TableImpl pointer
    static TableImpl*  createImpl( Table&  ifObj );

    //  Method to delete the TableImpl pointer
    static void deleteImpl( TableImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCellsBase(const Table &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDefinitionBase(const Table &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 8.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setCellsBase(Table &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setDefinitionBase(Table &ifObj,  const tag_t &value, bool isNull );



protected:
    //  Pointer to the instance
    static TableDelegate*  m_pInstance;

    TableDelegate();
    virtual ~TableDelegate();
    static void setInstance( TableDelegate*  instance );


private:
    friend class  ::Teamcenter::TableGenImpl;

};

#include <tccore/libtccore_undef.h>
#endif  //  TEAMCENTER__TABLEDELEGATE_HXX
