//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TableLabelDelegate
    Filename:   TableLabelDelegate.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TABLELABELDELEGATE_HXX
#define TEAMCENTER__TABLELABELDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/TableLabel.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class TableLabelDelegate;
}
namespace Teamcenter
{
    class TableLabelImpl;
}
namespace Teamcenter
{
    class TableLabel;
}
namespace Teamcenter
{
    class TableLabelGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TCCORE_API Teamcenter_alias::TableLabelDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the TableLabelDelegate instance
    static TableLabelDelegate&  getInstance();

    //  Method to create the TableLabelImpl pointer
    static TableLabelImpl*  createImpl( TableLabel&  ifObj );

    //  Method to delete the TableLabelImpl pointer
    static void deleteImpl( TableLabelImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLabelBase(const TableLabel &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getLocationBase(const TableLabel &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLabelBase(TableLabel &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setLocationBase(TableLabel &ifObj,  int value, bool isNull );



protected:
    //  Pointer to the instance
    static TableLabelDelegate*  m_pInstance;

    TableLabelDelegate();
    virtual ~TableLabelDelegate();
    static void setInstance( TableLabelDelegate*  instance );


private:
    friend class  ::Teamcenter::TableLabelGenImpl;

};

#include <tccore/libtccore_undef.h>
#endif  //  TEAMCENTER__TABLELABELDELEGATE_HXX
