//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TypeCannedMethod
    Filename:   TypeCannedMethod.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TYPECANNEDMETHOD__HXX
#define TEAMCENTER__TYPECANNEDMETHOD__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/BusinessRule.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class TypeCannedMethod;
}
namespace Teamcenter
{
    class TypeCannedMethodImpl;
}
namespace Teamcenter
{
    class TypeCannedMethodDelegate;
}
namespace Teamcenter
{
    class TypeCannedMethodDispatch;
}
namespace Teamcenter
{
    class TypeCannedMethodGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::TypeCannedMethod
     : public  ::Teamcenter::BusinessRule
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    TypeCannedMethod();

    /**
     * Destructor
     */
    virtual ~TypeCannedMethod();

private:
    //  Getter method for the Implementation Object
    TypeCannedMethodImpl*  getTypeCannedMethodImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTypeCannedMethodImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    TypeCannedMethodImpl*  m_typecannedmethodImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param TypeCannedMethod - desc for TypeCannedMethod parameter
     */
    TypeCannedMethod( const TypeCannedMethod& );
    TypeCannedMethod& operator=( const TypeCannedMethod& );

    friend class  TypeCannedMethodDelegate;
    friend class  TypeCannedMethodDispatch;
    friend class  TypeCannedMethodGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__TYPECANNEDMETHOD__HXX
