//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TypeCannedMethodDelegate
    Filename:   TypeCannedMethodDelegate.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TYPECANNEDMETHODDELEGATE_HXX
#define TEAMCENTER__TYPECANNEDMETHODDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/TypeCannedMethod.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class TypeCannedMethodDelegate;
}
namespace Teamcenter
{
    class TypeCannedMethodImpl;
}
namespace Teamcenter
{
    class TypeCannedMethod;
}
namespace Teamcenter
{
    class TypeCannedMethodGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TCCORE_API Teamcenter_alias::TypeCannedMethodDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the TypeCannedMethodDelegate instance
    static TypeCannedMethodDelegate&  getInstance();

    //  Method to create the TypeCannedMethodImpl pointer
    static TypeCannedMethodImpl*  createImpl( TypeCannedMethod&  ifObj );

    //  Method to delete the TypeCannedMethodImpl pointer
    static void deleteImpl( TypeCannedMethodImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static TypeCannedMethodDelegate*  m_pInstance;

    TypeCannedMethodDelegate();
    virtual ~TypeCannedMethodDelegate();
    static void setInstance( TypeCannedMethodDelegate*  instance );


private:
    friend class  ::Teamcenter::TypeCannedMethodGenImpl;

};

#include <tccore/libtccore_undef.h>
#endif  //  TEAMCENTER__TYPECANNEDMETHODDELEGATE_HXX
