//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, UnitOfMeasure
    Filename:   UnitOfMeasure.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__UNITOFMEASURE__HXX
#define TEAMCENTER__UNITOFMEASURE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class UnitOfMeasure;
}
namespace Teamcenter
{
    class UnitOfMeasureImpl;
}
namespace Teamcenter
{
    class UnitOfMeasureDelegate;
}
namespace Teamcenter
{
    class UnitOfMeasureDispatch;
}
namespace Teamcenter
{
    class UnitOfMeasureGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::UnitOfMeasure
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    UnitOfMeasure();

    /**
     * Destructor
     */
    virtual ~UnitOfMeasure();

private:
    //  Getter method for the Implementation Object
    UnitOfMeasureImpl*  getUnitOfMeasureImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setUnitOfMeasureImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    UnitOfMeasureImpl*  m_unitofmeasureImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param UnitOfMeasure - desc for UnitOfMeasure parameter
     */
    UnitOfMeasure( const UnitOfMeasure& );
    UnitOfMeasure& operator=( const UnitOfMeasure& );

    friend class  UnitOfMeasureDelegate;
    friend class  UnitOfMeasureDispatch;
    friend class  UnitOfMeasureGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__UNITOFMEASURE__HXX
