//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, WorkspaceObjectThread
    Filename:   WorkspaceObjectThread.hxx
    Module:     tccore
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__WORKSPACEOBJECTTHREAD__HXX
#define TEAMCENTER__WORKSPACEOBJECTTHREAD__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Fnd0ObjectThread.hxx>

#include <tccore/libtccore_exports.h>

namespace Teamcenter
{
    class WorkspaceObjectThread;
}
namespace Teamcenter
{
    class WorkspaceObjectThreadImpl;
}
namespace Teamcenter
{
    class WorkspaceObjectThreadDelegate;
}
namespace Teamcenter
{
    class WorkspaceObjectThreadDispatch;
}
namespace Teamcenter
{
    class WorkspaceObjectThreadGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCORE_API  Teamcenter::WorkspaceObjectThread
     : public  ::Teamcenter::Fnd0ObjectThread
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    WorkspaceObjectThread();

    /**
     * Destructor
     */
    virtual ~WorkspaceObjectThread();

private:
    //  Getter method for the Implementation Object
    WorkspaceObjectThreadImpl*  getWorkspaceObjectThreadImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setWorkspaceObjectThreadImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    WorkspaceObjectThreadImpl*  m_workspaceobjectthreadImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param WorkspaceObjectThread - desc for WorkspaceObjectThread parameter
     */
    WorkspaceObjectThread( const WorkspaceObjectThread& );
    WorkspaceObjectThread& operator=( const WorkspaceObjectThread& );

    friend class  WorkspaceObjectThreadDelegate;
    friend class  WorkspaceObjectThreadDispatch;
    friend class  WorkspaceObjectThreadGenImpl;
};

#include <tccore/libtccore_undef.h>
#endif //   TEAMCENTER__WORKSPACEOBJECTTHREAD__HXX
