//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  tccore

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libtccore

#if !defined(LIBTCCORE) && !defined(IPLIB)
#   error IPLIB or LIBTCCORE is not defined
#endif

/* Handwritten code should use TCCORE_API, not TCCOREEXPORT */

#define TCCORE_API TCCOREEXPORT

#if IPLIB==libtccore || defined(LIBTCCORE)
#   if defined(__lint)
#       define TCCOREEXPORT       __export(tccore)
#       define TCCOREGLOBAL       extern __global(tccore)
#       define TCCOREPRIVATE      extern __private(tccore)
#   elif defined(_WIN32)
#       define TCCOREEXPORT       __declspec(dllexport)
#       define TCCOREGLOBAL       extern __declspec(dllexport)
#       define TCCOREPRIVATE      extern
#   else
#       define TCCOREEXPORT
#       define TCCOREGLOBAL       extern
#       define TCCOREPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define TCCOREEXPORT       __export(tccore)
#       define TCCOREGLOBAL       extern __global(tccore)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define TCCOREEXPORT      __declspec(dllimport)
#       define TCCOREGLOBAL       extern __declspec(dllimport)
#   else
#       define TCCOREEXPORT
#       define TCCOREGLOBAL       extern
#   endif
#endif
