//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, GDEOccurrence
    Filename:   GDEOccurrence.hxx
    Module:     tccoreext
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__GDEOCCURRENCE__HXX
#define TEAMCENTER__GDEOCCURRENCE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <tccoreext/libtccoreext_exports.h>

namespace Teamcenter
{
    class GDEOccurrence;
}
namespace Teamcenter
{
    class GDEOccurrenceImpl;
}
namespace Teamcenter
{
    class GDEOccurrenceDelegate;
}
namespace Teamcenter
{
    class GDEOccurrenceDispatch;
}
namespace Teamcenter
{
    class GDEOccurrenceGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCOREEXT_API  Teamcenter::GDEOccurrence
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    GDEOccurrence();

    /**
     * Destructor
     */
    virtual ~GDEOccurrence();

private:
    //  Getter method for the Implementation Object
    GDEOccurrenceImpl*  getGDEOccurrenceImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setGDEOccurrenceImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    GDEOccurrenceImpl*  m_gdeoccurrenceImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param GDEOccurrence - desc for GDEOccurrence parameter
     */
    GDEOccurrence( const GDEOccurrence& );
    GDEOccurrence& operator=( const GDEOccurrence& );

    friend class  GDEOccurrenceDelegate;
    friend class  GDEOccurrenceDispatch;
    friend class  GDEOccurrenceGenImpl;
};

#include <tccoreext/libtccoreext_undef.h>
#endif //   TEAMCENTER__GDEOCCURRENCE__HXX
