//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, GDEOccurrenceList
    Filename:   GDEOccurrenceList.hxx
    Module:     tccoreext
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__GDEOCCURRENCELIST__HXX
#define TEAMCENTER__GDEOCCURRENCELIST__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <tccoreext/libtccoreext_exports.h>

namespace Teamcenter
{
    class GDEOccurrenceList;
}
namespace Teamcenter
{
    class GDEOccurrenceListImpl;
}
namespace Teamcenter
{
    class GDEOccurrenceListDelegate;
}
namespace Teamcenter
{
    class GDEOccurrenceListDispatch;
}
namespace Teamcenter
{
    class GDEOccurrenceListGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCOREEXT_API  Teamcenter::GDEOccurrenceList
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    GDEOccurrenceList();

    /**
     * Destructor
     */
    virtual ~GDEOccurrenceList();

private:
    //  Getter method for the Implementation Object
    GDEOccurrenceListImpl*  getGDEOccurrenceListImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setGDEOccurrenceListImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    GDEOccurrenceListImpl*  m_gdeoccurrencelistImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param GDEOccurrenceList - desc for GDEOccurrenceList parameter
     */
    GDEOccurrenceList( const GDEOccurrenceList& );
    GDEOccurrenceList& operator=( const GDEOccurrenceList& );

    friend class  GDEOccurrenceListDelegate;
    friend class  GDEOccurrenceListDispatch;
    friend class  GDEOccurrenceListGenImpl;
};

#include <tccoreext/libtccoreext_undef.h>
#endif //   TEAMCENTER__GDEOCCURRENCELIST__HXX
