//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, GDETypeDefinition
    Filename:   GDETypeDefinition.hxx
    Module:     tccoreext
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__GDETYPEDEFINITION__HXX
#define TEAMCENTER__GDETYPEDEFINITION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <tccoreext/libtccoreext_exports.h>

namespace Teamcenter
{
    class GDETypeDefinition;
}
namespace Teamcenter
{
    class GDETypeDefinitionImpl;
}
namespace Teamcenter
{
    class GDETypeDefinitionDelegate;
}
namespace Teamcenter
{
    class GDETypeDefinitionDispatch;
}
namespace Teamcenter
{
    class GDETypeDefinitionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCOREEXT_API  Teamcenter::GDETypeDefinition
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    GDETypeDefinition();

    /**
     * Destructor
     */
    virtual ~GDETypeDefinition();

private:
    //  Getter method for the Implementation Object
    GDETypeDefinitionImpl*  getGDETypeDefinitionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setGDETypeDefinitionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    GDETypeDefinitionImpl*  m_gdetypedefinitionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param GDETypeDefinition - desc for GDETypeDefinition parameter
     */
    GDETypeDefinition( const GDETypeDefinition& );
    GDETypeDefinition& operator=( const GDETypeDefinition& );

    friend class  GDETypeDefinitionDelegate;
    friend class  GDETypeDefinitionDispatch;
    friend class  GDETypeDefinitionGenImpl;
};

#include <tccoreext/libtccoreext_undef.h>
#endif //   TEAMCENTER__GDETYPEDEFINITION__HXX
