//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, GDEbvr
    Filename:   GDEbvr.hxx
    Module:     tccoreext
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__GDEBVR__HXX
#define TEAMCENTER__GDEBVR__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <tccoreext/libtccoreext_exports.h>

namespace Teamcenter
{
    class GDEbvr;
}
namespace Teamcenter
{
    class GDEbvrImpl;
}
namespace Teamcenter
{
    class GDEbvrDelegate;
}
namespace Teamcenter
{
    class GDEbvrDispatch;
}
namespace Teamcenter
{
    class GDEbvrGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCOREEXT_API  Teamcenter::GDEbvr
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    GDEbvr();

    /**
     * Destructor
     */
    virtual ~GDEbvr();

private:
    //  Getter method for the Implementation Object
    GDEbvrImpl*  getGDEbvrImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setGDEbvrImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    GDEbvrImpl*  m_gdebvrImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param GDEbvr - desc for GDEbvr parameter
     */
    GDEbvr( const GDEbvr& );
    GDEbvr& operator=( const GDEbvr& );

    friend class  GDEbvrDelegate;
    friend class  GDEbvrDispatch;
    friend class  GDEbvrGenImpl;
};

#include <tccoreext/libtccoreext_undef.h>
#endif //   TEAMCENTER__GDEBVR__HXX
