//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, GDEbvrDelegate
    Filename:   GDEbvrDelegate.hxx
    Module:     tccoreext
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__GDEBVRDELEGATE_HXX
#define TEAMCENTER__GDEBVRDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tccoreext/GDEbvr.hxx>

#include <tccoreext/libtccoreext_exports.h>

namespace Teamcenter
{
    class GDEbvrDelegate;
}
namespace Teamcenter
{
    class GDEbvrImpl;
}
namespace Teamcenter
{
    class GDEbvr;
}
namespace Teamcenter
{
    class GDEbvrGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TCCOREEXT_API Teamcenter_alias::GDEbvrDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the GDEbvrDelegate instance
    static GDEbvrDelegate&  getInstance();

    //  Method to create the GDEbvrImpl pointer
    static GDEbvrImpl*  createImpl( GDEbvr&  ifObj );

    //  Method to delete the GDEbvrImpl pointer
    static void deleteImpl( GDEbvrImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @param isLockForDelete - A boolean to indicate if object(s) are to be locked for deletion
    /// @param allowRelock - A boolean to indicate if object(s) can be relocked, which will discard all unsaved changes, if already locked by the same user
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0LockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd, const bool isLockForDelete, const bool allowRelock );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0RefreshBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0UnlockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const GDEbvr &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const GDEbvr &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static GDEbvrDelegate*  m_pInstance;

    GDEbvrDelegate();
    virtual ~GDEbvrDelegate();
    static void setInstance( GDEbvrDelegate*  instance );


private:
    friend class  ::Teamcenter::GDEbvrGenImpl;

};

#include <tccoreext/libtccoreext_undef.h>
#endif  //  TEAMCENTER__GDEBVRDELEGATE_HXX
