//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, GeneralDesignElement
    Filename:   GeneralDesignElement.hxx
    Module:     tccoreext
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__GENERALDESIGNELEMENT__HXX
#define TEAMCENTER__GENERALDESIGNELEMENT__HXX

#include <common/tc_deprecation_macros.h>
#include <form/Form.hxx>

#include <tccoreext/libtccoreext_exports.h>

namespace Teamcenter
{
    class GeneralDesignElement;
}
namespace Teamcenter
{
    class GeneralDesignElementImpl;
}
namespace Teamcenter
{
    class GeneralDesignElementDelegate;
}
namespace Teamcenter
{
    class GeneralDesignElementDispatch;
}
namespace Teamcenter
{
    class GeneralDesignElementGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCOREEXT_API  Teamcenter::GeneralDesignElement
     : public  ::Teamcenter::Form
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    GeneralDesignElement();

    /**
     * Destructor
     */
    virtual ~GeneralDesignElement();

private:
    //  Getter method for the Implementation Object
    GeneralDesignElementImpl*  getGeneralDesignElementImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setGeneralDesignElementImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    GeneralDesignElementImpl*  m_generaldesignelementImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param GeneralDesignElement - desc for GeneralDesignElement parameter
     */
    GeneralDesignElement( const GeneralDesignElement& );
    GeneralDesignElement& operator=( const GeneralDesignElement& );

    friend class  GeneralDesignElementDelegate;
    friend class  GeneralDesignElementDispatch;
    friend class  GeneralDesignElementGenImpl;
};

#include <tccoreext/libtccoreext_undef.h>
#endif //   TEAMCENTER__GENERALDESIGNELEMENT__HXX
