//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, GeneralDesignElementLink
    Filename:   GeneralDesignElementLink.hxx
    Module:     tccoreext
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__GENERALDESIGNELEMENTLINK__HXX
#define TEAMCENTER__GENERALDESIGNELEMENTLINK__HXX

#include <common/tc_deprecation_macros.h>
#include <tccoreext/GeneralDesignElement.hxx>

#include <tccoreext/libtccoreext_exports.h>

namespace Teamcenter
{
    class GeneralDesignElementLink;
}
namespace Teamcenter
{
    class GeneralDesignElementLinkImpl;
}
namespace Teamcenter
{
    class GeneralDesignElementLinkDelegate;
}
namespace Teamcenter
{
    class GeneralDesignElementLinkDispatch;
}
namespace Teamcenter
{
    class GeneralDesignElementLinkGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TCCOREEXT_API  Teamcenter::GeneralDesignElementLink
     : public  ::Teamcenter::GeneralDesignElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    GeneralDesignElementLink();

    /**
     * Destructor
     */
    virtual ~GeneralDesignElementLink();

private:
    //  Getter method for the Implementation Object
    GeneralDesignElementLinkImpl*  getGeneralDesignElementLinkImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setGeneralDesignElementLinkImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    GeneralDesignElementLinkImpl*  m_generaldesignelementlinkImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param GeneralDesignElementLink - desc for GeneralDesignElementLink parameter
     */
    GeneralDesignElementLink( const GeneralDesignElementLink& );
    GeneralDesignElementLink& operator=( const GeneralDesignElementLink& );

    friend class  GeneralDesignElementLinkDelegate;
    friend class  GeneralDesignElementLinkDispatch;
    friend class  GeneralDesignElementLinkGenImpl;
};

#include <tccoreext/libtccoreext_undef.h>
#endif //   TEAMCENTER__GENERALDESIGNELEMENTLINK__HXX
