//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  tccoreext

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libtccoreext

#if !defined(LIBTCCOREEXT) && !defined(IPLIB)
#   error IPLIB or LIBTCCOREEXT is not defined
#endif

/* Handwritten code should use TCCOREEXT_API, not TCCOREEXTEXPORT */

#define TCCOREEXT_API TCCOREEXTEXPORT

#if IPLIB==libtccoreext || defined(LIBTCCOREEXT)
#   if defined(__lint)
#       define TCCOREEXTEXPORT       __export(tccoreext)
#       define TCCOREEXTGLOBAL       extern __global(tccoreext)
#       define TCCOREEXTPRIVATE      extern __private(tccoreext)
#   elif defined(_WIN32)
#       define TCCOREEXTEXPORT       __declspec(dllexport)
#       define TCCOREEXTGLOBAL       extern __declspec(dllexport)
#       define TCCOREEXTPRIVATE      extern
#   else
#       define TCCOREEXTEXPORT
#       define TCCOREEXTGLOBAL       extern
#       define TCCOREEXTPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define TCCOREEXTEXPORT       __export(tccoreext)
#       define TCCOREEXTGLOBAL       extern __global(tccoreext)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define TCCOREEXTEXPORT      __declspec(dllimport)
#       define TCCOREEXTGLOBAL       extern __declspec(dllimport)
#   else
#       define TCCOREEXTEXPORT
#       define TCCOREEXTGLOBAL       extern
#   endif
#endif
