//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Tgm0AbsTargetElement
    Filename:   Tgm0AbsTargetElement.hxx
    Module:     tgm0targetmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TGM0TARGETMGMT__TGM0ABSTARGETELEMENT__HXX
#define TEAMCENTER__TGM0TARGETMGMT__TGM0ABSTARGETELEMENT__HXX

#include <vector>
#include <string>
#include <common/tc_deprecation_macros.h>
#include <mdl0model/Mdl0ConditionalElement.hxx>

#include <tgm0targetmgmt/libtgm0targetmgmt_exports.h>

namespace Teamcenter
{
    namespace Tgm0TargetMgmt
    {
        class Tgm0AbsTargetElement;
    }
}
namespace Teamcenter
{
    namespace Tgm0TargetMgmt
    {
        class Tgm0AbsTargetElementImpl;
    }
}
namespace Teamcenter
{
    namespace Tgm0TargetMgmt
    {
        class Tgm0AbsTargetElementDelegate;
    }
}
namespace Teamcenter
{
    namespace Tgm0TargetMgmt
    {
        class Tgm0AbsTargetElementDispatch;
    }
}
namespace Teamcenter
{
    namespace Tgm0TargetMgmt
    {
        class Tgm0AbsTargetElementGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TGM0TARGETMGMT_API  Teamcenter::Tgm0TargetMgmt::Tgm0AbsTargetElement
     : public  ::Teamcenter::AppModel::Mdl0ConditionalElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.2.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getTgm0ChildTargets( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.2.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getTgm0IsDistributionAllowed( bool &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.2.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getTgm0UoM( std::string &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Tgm0AbsTargetElement();

    /**
     * Destructor
     */
    virtual ~Tgm0AbsTargetElement();

private:
    //  Getter method for the Implementation Object
    Tgm0AbsTargetElementImpl*  getTgm0AbsTargetElementImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTgm0AbsTargetElementImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Tgm0AbsTargetElementImpl*  m_tgm0abstargetelementImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Tgm0AbsTargetElement - desc for Tgm0AbsTargetElement parameter
     */
    Tgm0AbsTargetElement( const Tgm0AbsTargetElement& );
    Tgm0AbsTargetElement& operator=( const Tgm0AbsTargetElement& );

    friend class  Tgm0AbsTargetElementDelegate;
    friend class  Tgm0AbsTargetElementDispatch;
    friend class  Tgm0AbsTargetElementGenImpl;
};

#include <tgm0targetmgmt/libtgm0targetmgmt_undef.h>
#endif //   TEAMCENTER__TGM0TARGETMGMT__TGM0ABSTARGETELEMENT__HXX
