//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Tgm0AbsTargetElementDelegate
    Filename:   Tgm0AbsTargetElementDelegate.hxx
    Module:     tgm0targetmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TGM0TARGETMGMT__TGM0ABSTARGETELEMENTDELEGATE_HXX
#define TEAMCENTER__TGM0TARGETMGMT__TGM0ABSTARGETELEMENTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tgm0targetmgmt/Tgm0AbsTargetElement.hxx>

#include <tgm0targetmgmt/libtgm0targetmgmt_exports.h>

namespace Teamcenter
{
    namespace Tgm0TargetMgmt
    {
        class Tgm0AbsTargetElementDelegate;
    }
}
namespace Teamcenter
{
    namespace Tgm0TargetMgmt
    {
        class Tgm0AbsTargetElementImpl;
    }
}
namespace Teamcenter
{
    namespace Tgm0TargetMgmt
    {
        class Tgm0AbsTargetElement;
    }
}
namespace Teamcenter
{
    namespace Tgm0TargetMgmt
    {
        class Tgm0AbsTargetElementGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  TGM0TARGETMGMT_API Teamcenter_alias::Tgm0TargetMgmt::Tgm0AbsTargetElementDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Tgm0AbsTargetElementDelegate instance
    static Tgm0AbsTargetElementDelegate&  getInstance();

    //  Method to create the Tgm0AbsTargetElementImpl pointer
    static Tgm0AbsTargetElementImpl*  createImpl( Tgm0AbsTargetElement&  ifObj );

    //  Method to delete the Tgm0AbsTargetElementImpl pointer
    static void deleteImpl( Tgm0AbsTargetElementImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.2.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getTgm0ChildTargetsBase(const Tgm0AbsTargetElement &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 11.2.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getTgm0IsDistributionAllowedBase(const Tgm0AbsTargetElement &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 11.2.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getTgm0UoMBase(const Tgm0AbsTargetElement &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const Tgm0AbsTargetElement &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Tgm0AbsTargetElementDelegate*  m_pInstance;

    Tgm0AbsTargetElementDelegate();
    virtual ~Tgm0AbsTargetElementDelegate();
    static void setInstance( Tgm0AbsTargetElementDelegate*  instance );


private:
    friend class  ::Teamcenter::Tgm0TargetMgmt::Tgm0AbsTargetElementGenImpl;

};

#include <tgm0targetmgmt/libtgm0targetmgmt_undef.h>
#endif  //  TEAMCENTER__TGM0TARGETMGMT__TGM0ABSTARGETELEMENTDELEGATE_HXX
