//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, GMSMappingHolderDelegate
    Filename:   GMSMappingHolderDelegate.hxx
    Module:     tie
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__GMSMAPPINGHOLDERDELEGATE_HXX
#define TEAMCENTER__GMSMAPPINGHOLDERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <tie/GMSMappingHolder.hxx>

#include <tie/libtie_exports.h>

namespace Teamcenter
{
    class GMSMappingHolderDelegate;
}
namespace Teamcenter
{
    class GMSMappingHolderImpl;
}
namespace Teamcenter
{
    class GMSMappingHolder;
}
namespace Teamcenter
{
    class GMSMappingHolderGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  TIE_API Teamcenter_alias::GMSMappingHolderDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the GMSMappingHolderDelegate instance
    static GMSMappingHolderDelegate&  getInstance();

    //  Method to create the GMSMappingHolderImpl pointer
    static GMSMappingHolderImpl*  createImpl( GMSMappingHolder&  ifObj );

    //  Method to delete the GMSMappingHolderImpl pointer
    static void deleteImpl( GMSMappingHolderImpl*  impl );


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getAttrNamesBase(const GMSMappingHolder &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 8.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getAttrValuesBase(const GMSMappingHolder &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getChildBase(const GMSMappingHolder &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getClassBase(const GMSMappingHolder &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getParentBase(const GMSMappingHolder &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSavedElemIdBase(const GMSMappingHolder &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSystemBase(const GMSMappingHolder &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 8.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setAttrNamesBase(GMSMappingHolder &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 8.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setAttrValuesBase(GMSMappingHolder &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setChildBase(GMSMappingHolder &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setClassBase(GMSMappingHolder &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setParentBase(GMSMappingHolder &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSavedElemIdBase(GMSMappingHolder &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.1
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSystemBase(GMSMappingHolder &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static GMSMappingHolderDelegate*  m_pInstance;

    GMSMappingHolderDelegate();
    virtual ~GMSMappingHolderDelegate();
    static void setInstance( GMSMappingHolderDelegate*  instance );


private:
    friend class  ::Teamcenter::GMSMappingHolderGenImpl;

};

#include <tie/libtie_undef.h>
#endif  //  TEAMCENTER__GMSMAPPINGHOLDERDELEGATE_HXX
