//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  tie

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libtie

#if !defined(LIBTIE) && !defined(IPLIB)
#   error IPLIB or LIBTIE is not defined
#endif

/* Handwritten code should use TIE_API, not TIEEXPORT */

#define TIE_API TIEEXPORT

#if IPLIB==libtie || defined(LIBTIE)
#   if defined(__lint)
#       define TIEEXPORT       __export(tie)
#       define TIEGLOBAL       extern __global(tie)
#       define TIEPRIVATE      extern __private(tie)
#   elif defined(_WIN32)
#       define TIEEXPORT       __declspec(dllexport)
#       define TIEGLOBAL       extern __declspec(dllexport)
#       define TIEPRIVATE      extern
#   else
#       define TIEEXPORT
#       define TIEGLOBAL       extern
#       define TIEPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define TIEEXPORT       __export(tie)
#       define TIEGLOBAL       extern __global(tie)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define TIEEXPORT      __declspec(dllimport)
#       define TIEGLOBAL       extern __declspec(dllimport)
#   else
#       define TIEEXPORT
#       define TIEGLOBAL       extern
#   endif
#endif
