//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ActivityCost
    Filename:   ActivityCost.hxx
    Module:     transactionprocessing
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TRANSACTIONPROCESSING__ACTIVITYCOST__HXX
#define TEAMCENTER__TRANSACTIONPROCESSING__ACTIVITYCOST__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <transactionprocessing/libtransactionprocessing_exports.h>

namespace Teamcenter
{
    namespace transactionprocessing
    {
        class ActivityCost;
    }
}
namespace Teamcenter
{
    namespace transactionprocessing
    {
        class ActivityCostImpl;
    }
}
namespace Teamcenter
{
    namespace transactionprocessing
    {
        class ActivityCostDelegate;
    }
}
namespace Teamcenter
{
    namespace transactionprocessing
    {
        class ActivityCostDispatch;
    }
}
namespace Teamcenter
{
    namespace transactionprocessing
    {
        class ActivityCostGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TRANSACTIONPROCESSING_API  Teamcenter::transactionprocessing::ActivityCost
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getActual_labor_cost( double &value, bool &isNull ) const;

    ///
    /// Getter for a Double Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getActual_labor_hours( double &value, bool &isNull ) const;

    ///
    /// Getter for a Double Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getActual_material_cost( double &value, bool &isNull ) const;

    ///
    /// Getter for a Double Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getActual_total_cost( double &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ActivityCost();

    /**
     * Destructor
     */
    virtual ~ActivityCost();

private:
    //  Getter method for the Implementation Object
    ActivityCostImpl*  getActivityCostImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setActivityCostImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ActivityCostImpl*  m_activitycostImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ActivityCost - desc for ActivityCost parameter
     */
    ActivityCost( const ActivityCost& );
    ActivityCost& operator=( const ActivityCost& );

    friend class  ActivityCostDelegate;
    friend class  ActivityCostDispatch;
    friend class  ActivityCostGenImpl;
};

#include <transactionprocessing/libtransactionprocessing_undef.h>
#endif //   TEAMCENTER__TRANSACTIONPROCESSING__ACTIVITYCOST__HXX
