//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ActivityCostDelegate
    Filename:   ActivityCostDelegate.hxx
    Module:     transactionprocessing
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TRANSACTIONPROCESSING__ACTIVITYCOSTDELEGATE_HXX
#define TEAMCENTER__TRANSACTIONPROCESSING__ACTIVITYCOSTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <transactionprocessing/ActivityCost.hxx>

#include <transactionprocessing/libtransactionprocessing_exports.h>

namespace Teamcenter
{
    namespace transactionprocessing
    {
        class ActivityCostDelegate;
    }
}
namespace Teamcenter
{
    namespace transactionprocessing
    {
        class ActivityCostImpl;
    }
}
namespace Teamcenter
{
    namespace transactionprocessing
    {
        class ActivityCost;
    }
}
namespace Teamcenter
{
    namespace transactionprocessing
    {
        class ActivityCostGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  TRANSACTIONPROCESSING_API Teamcenter_alias::transactionprocessing::ActivityCostDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ActivityCostDelegate instance
    static ActivityCostDelegate&  getInstance();

    //  Method to create the ActivityCostImpl pointer
    static ActivityCostImpl*  createImpl( ActivityCost&  ifObj );

    //  Method to delete the ActivityCostImpl pointer
    static void deleteImpl( ActivityCostImpl*  impl );


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getActual_labor_costBase(const ActivityCost &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getActual_labor_hoursBase(const ActivityCost &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getActual_material_costBase(const ActivityCost &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getActual_total_costBase(const ActivityCost &ifObj,  double &value, bool &isNull ) const;



protected:
    //  Pointer to the instance
    static ActivityCostDelegate*  m_pInstance;

    ActivityCostDelegate();
    virtual ~ActivityCostDelegate();
    static void setInstance( ActivityCostDelegate*  instance );


private:
    friend class  ::Teamcenter::transactionprocessing::ActivityCostGenImpl;

};

#include <transactionprocessing/libtransactionprocessing_undef.h>
#endif  //  TEAMCENTER__TRANSACTIONPROCESSING__ACTIVITYCOSTDELEGATE_HXX
