//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Transaction
    Filename:   Transaction.hxx
    Module:     transactionprocessing
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TRANSACTIONPROCESSING__TRANSACTION__HXX
#define TEAMCENTER__TRANSACTIONPROCESSING__TRANSACTION__HXX

#include <common/tc_deprecation_macros.h>
#include <transactionprocessing/TransactionElement.hxx>

#include <transactionprocessing/libtransactionprocessing_exports.h>

namespace Teamcenter
{
    namespace transactionprocessing
    {
        class Transaction;
    }
}
namespace Teamcenter
{
    namespace transactionprocessing
    {
        class TransactionImpl;
    }
}
namespace Teamcenter
{
    namespace transactionprocessing
    {
        class TransactionDelegate;
    }
}
namespace Teamcenter
{
    namespace transactionprocessing
    {
        class TransactionDispatch;
    }
}
namespace Teamcenter
{
    namespace transactionprocessing
    {
        class TransactionGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TRANSACTIONPROCESSING_API  Teamcenter::transactionprocessing::Transaction
     : public  ::Teamcenter::transactionprocessing::TransactionElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Transaction();

    /**
     * Destructor
     */
    virtual ~Transaction();

private:
    //  Getter method for the Implementation Object
    TransactionImpl*  getTransactionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTransactionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    TransactionImpl*  m_transactionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Transaction - desc for Transaction parameter
     */
    Transaction( const Transaction& );
    Transaction& operator=( const Transaction& );

    friend class  TransactionDelegate;
    friend class  TransactionDispatch;
    friend class  TransactionGenImpl;
};

#include <transactionprocessing/libtransactionprocessing_undef.h>
#endif //   TEAMCENTER__TRANSACTIONPROCESSING__TRANSACTION__HXX
