//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TransactionActivity
    Filename:   TransactionActivity.hxx
    Module:     transactionprocessing
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TRANSACTIONPROCESSING__TRANSACTIONACTIVITY__HXX
#define TEAMCENTER__TRANSACTIONPROCESSING__TRANSACTIONACTIVITY__HXX

#include <common/tc_deprecation_macros.h>
#include <transactionprocessing/TransactionElement.hxx>

#include <transactionprocessing/libtransactionprocessing_exports.h>

namespace Teamcenter
{
    namespace transactionprocessing
    {
        class TransactionActivity;
    }
}
namespace Teamcenter
{
    namespace transactionprocessing
    {
        class TransactionActivityImpl;
    }
}
namespace Teamcenter
{
    namespace transactionprocessing
    {
        class TransactionActivityDelegate;
    }
}
namespace Teamcenter
{
    namespace transactionprocessing
    {
        class TransactionActivityDispatch;
    }
}
namespace Teamcenter
{
    namespace transactionprocessing
    {
        class TransactionActivityGenImpl;
    }
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  TRANSACTIONPROCESSING_API  Teamcenter::transactionprocessing::TransactionActivity
     : public  ::Teamcenter::transactionprocessing::TransactionElement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    TransactionActivity();

    /**
     * Destructor
     */
    virtual ~TransactionActivity();

private:
    //  Getter method for the Implementation Object
    TransactionActivityImpl*  getTransactionActivityImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTransactionActivityImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    TransactionActivityImpl*  m_transactionactivityImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param TransactionActivity - desc for TransactionActivity parameter
     */
    TransactionActivity( const TransactionActivity& );
    TransactionActivity& operator=( const TransactionActivity& );

    friend class  TransactionActivityDelegate;
    friend class  TransactionActivityDispatch;
    friend class  TransactionActivityGenImpl;
};

#include <transactionprocessing/libtransactionprocessing_undef.h>
#endif //   TEAMCENTER__TRANSACTIONPROCESSING__TRANSACTIONACTIVITY__HXX
