//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TransactionActivityDelegate
    Filename:   TransactionActivityDelegate.hxx
    Module:     transactionprocessing
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TRANSACTIONPROCESSING__TRANSACTIONACTIVITYDELEGATE_HXX
#define TEAMCENTER__TRANSACTIONPROCESSING__TRANSACTIONACTIVITYDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <transactionprocessing/TransactionActivity.hxx>

#include <transactionprocessing/libtransactionprocessing_exports.h>

namespace Teamcenter
{
    namespace transactionprocessing
    {
        class TransactionActivityDelegate;
    }
}
namespace Teamcenter
{
    namespace transactionprocessing
    {
        class TransactionActivityImpl;
    }
}
namespace Teamcenter
{
    namespace transactionprocessing
    {
        class TransactionActivity;
    }
}
namespace Teamcenter
{
    namespace transactionprocessing
    {
        class TransactionActivityGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  TRANSACTIONPROCESSING_API Teamcenter_alias::transactionprocessing::TransactionActivityDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the TransactionActivityDelegate instance
    static TransactionActivityDelegate&  getInstance();

    //  Method to create the TransactionActivityImpl pointer
    static TransactionActivityImpl*  createImpl( TransactionActivity&  ifObj );

    //  Method to delete the TransactionActivityImpl pointer
    static void deleteImpl( TransactionActivityImpl*  impl );


    ///
    /// Approval operation
    /// @version Teamcenter 8.0.1
    /// @param strucRoot - Root of the Service Group or Service Event structure
    /// @return - success or failure
    ///
    int  approvalBase(const TransactionActivity &ifObj,  tag_t strucRoot );



protected:
    //  Pointer to the instance
    static TransactionActivityDelegate*  m_pInstance;

    TransactionActivityDelegate();
    virtual ~TransactionActivityDelegate();
    static void setInstance( TransactionActivityDelegate*  instance );


private:
    friend class  ::Teamcenter::transactionprocessing::TransactionActivityGenImpl;

};

#include <transactionprocessing/libtransactionprocessing_undef.h>
#endif  //  TEAMCENTER__TRANSACTIONPROCESSING__TRANSACTIONACTIVITYDELEGATE_HXX
