//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TransactionDelegate
    Filename:   TransactionDelegate.hxx
    Module:     transactionprocessing
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TRANSACTIONPROCESSING__TRANSACTIONDELEGATE_HXX
#define TEAMCENTER__TRANSACTIONPROCESSING__TRANSACTIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <transactionprocessing/Transaction.hxx>

#include <transactionprocessing/libtransactionprocessing_exports.h>

namespace Teamcenter
{
    namespace transactionprocessing
    {
        class TransactionDelegate;
    }
}
namespace Teamcenter
{
    namespace transactionprocessing
    {
        class TransactionImpl;
    }
}
namespace Teamcenter
{
    namespace transactionprocessing
    {
        class Transaction;
    }
}
namespace Teamcenter
{
    namespace transactionprocessing
    {
        class TransactionGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  TRANSACTIONPROCESSING_API Teamcenter_alias::transactionprocessing::TransactionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the TransactionDelegate instance
    static TransactionDelegate&  getInstance();

    //  Method to create the TransactionImpl pointer
    static TransactionImpl*  createImpl( Transaction&  ifObj );

    //  Method to delete the TransactionImpl pointer
    static void deleteImpl( TransactionImpl*  impl );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Transaction &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Approval operation
    /// @version Teamcenter 8.0.1
    /// @param strucRoot - Root of the Service Group or Service Event structure
    /// @return - success or failure
    ///
    int  approvalBase(const Transaction &ifObj,  tag_t strucRoot );


    ///
    /// validate objects prior to the approval
    /// @version Teamcenter 8.0.1
    /// @return - success or failure
    ///
    int  validateApprovalBase(const Transaction &ifObj  );



protected:
    //  Pointer to the instance
    static TransactionDelegate*  m_pInstance;

    TransactionDelegate();
    virtual ~TransactionDelegate();
    static void setInstance( TransactionDelegate*  instance );


private:
    friend class  ::Teamcenter::transactionprocessing::TransactionGenImpl;

};

#include <transactionprocessing/libtransactionprocessing_undef.h>
#endif  //  TEAMCENTER__TRANSACTIONPROCESSING__TRANSACTIONDELEGATE_HXX
