//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TransactionElementDelegate
    Filename:   TransactionElementDelegate.hxx
    Module:     transactionprocessing
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TRANSACTIONPROCESSING__TRANSACTIONELEMENTDELEGATE_HXX
#define TEAMCENTER__TRANSACTIONPROCESSING__TRANSACTIONELEMENTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <transactionprocessing/TransactionElement.hxx>

#include <transactionprocessing/libtransactionprocessing_exports.h>

namespace Teamcenter
{
    namespace transactionprocessing
    {
        class TransactionElementDelegate;
    }
}
namespace Teamcenter
{
    namespace transactionprocessing
    {
        class TransactionElementImpl;
    }
}
namespace Teamcenter
{
    namespace transactionprocessing
    {
        class TransactionElement;
    }
}
namespace Teamcenter
{
    namespace transactionprocessing
    {
        class TransactionElementGenImpl;
    }
}

namespace Teamcenter_alias = ::Teamcenter;


class  TRANSACTIONPROCESSING_API Teamcenter_alias::transactionprocessing::TransactionElementDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the TransactionElementDelegate instance
    static TransactionElementDelegate&  getInstance();

    //  Method to create the TransactionElementImpl pointer
    static TransactionElementImpl*  createImpl( TransactionElement&  ifObj );

    //  Method to delete the TransactionElementImpl pointer
    static void deleteImpl( TransactionElementImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getActivity_costBase(const TransactionElement &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getApprovalBase(const TransactionElement &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDispositionBase(const TransactionElement &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Date Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDisposition_dateBase(const TransactionElement &ifObj,  date_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDispositioned_byBase(const TransactionElement &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Date Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getDue_dateBase(const TransactionElement &ifObj,  date_t &value, bool &isNull ) const;


    ///
    /// Getter for a Date Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getInitiation_dateBase(const TransactionElement &ifObj,  date_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMropurposeBase(const TransactionElement &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getTransaction_element_typeBase(const TransactionElement &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.0.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getTransaction_idBase(const TransactionElement &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Approval operation
    /// @version Teamcenter 8.0.1
    /// @param strucRoot - Root of the Service Group or Service Event structure
    /// @return - success or failure
    ///
    int  approvalBase(const TransactionElement &ifObj,  tag_t strucRoot );


    ///
    /// Approval process
    /// @version Teamcenter 8.0.1
    /// @return - Success or failure
    ///
    int  approvalProcessBase(const TransactionElement &ifObj  );


    ///
    /// processes the part movements
    /// @version Teamcenter 8.0.1
    /// @param serviceEvents - service event vector
    /// @param partMovements - part movement vectors
    /// @return - returns success or failure
    ///
    int  processPartMovementsBase(const TransactionElement &ifObj,  std::vector< tag_t > &serviceEvents, std::vector< tag_t > &partMovements );


    ///
    /// The operation determines if the given object is a subtype of the given Business Object.
    /// @version Teamcenter 9.1
    /// @param inputObject - Object to be validated
    /// @param typeName - Type name to validate if the object is a subtype of it.
    /// @param result - Return true if the object is subtype of the given type.
    /// @return - Return true if the given object is a subtype of the given Business Object.
    ///
    int  stp0isObjSubTypeofBase(const TransactionElement &ifObj,  tag_t inputObject, std::string &typeName, bool *result );


    ///
    /// validate objects prior to the approval
    /// @version Teamcenter 8.0.1
    /// @return - success or failure
    ///
    int  validateApprovalBase(const TransactionElement &ifObj  );



protected:
    //  Pointer to the instance
    static TransactionElementDelegate*  m_pInstance;

    TransactionElementDelegate();
    virtual ~TransactionElementDelegate();
    static void setInstance( TransactionElementDelegate*  instance );


private:
    friend class  ::Teamcenter::transactionprocessing::TransactionElementGenImpl;

};

#include <transactionprocessing/libtransactionprocessing_undef.h>
#endif  //  TEAMCENTER__TRANSACTIONPROCESSING__TRANSACTIONELEMENTDELEGATE_HXX
