//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TransactionActivityDispatch
    Filename:   TransactionActivityDispatch.hxx
    Module:     transactionprocessingdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TRANSACTIONPROCESSING__TRANSACTIONACTIVITYDISPATCH_HXX
#define TEAMCENTER__TRANSACTIONPROCESSING__TRANSACTIONACTIVITYDISPATCH_HXX

#include <vector>
#include <transactionprocessing/TransactionActivity.hxx>
#include <transactionprocessing/TransactionActivityDelegate.hxx>
#include <transactionprocessingdispatch/TransactionElementDispatch.hxx>
#include <transactionprocessingdispatch/initializetransactionprocessing.hxx>

#include <transactionprocessingdispatch/libtransactionprocessingdispatch_exports.h>

namespace Teamcenter
{
    namespace transactionprocessing
    {
        class TransactionActivityDispatch;
    }
}
namespace Teamcenter
{
    namespace transactionprocessing
    {
        class TransactionActivityDelegate;
    }
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  TRANSACTIONPROCESSINGDISPATCH_API  Teamcenter::transactionprocessing::TransactionActivityDispatch
    : public  Teamcenter::transactionprocessing::TransactionActivityDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the TransactionActivityDispatch instance
    static TransactionActivityDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static TransactionActivityDispatch*  m_dispatch;

    //  Default Constructor
    TransactionActivityDispatch();

    //  Default Destructor
    virtual ~TransactionActivityDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a TransactionActivityDispatch
    TransactionActivityDispatch( const TransactionActivityDispatch& );

    //  Assignment operator
    TransactionActivityDispatch&  operator = ( const TransactionActivityDispatch& );

    //  friend
    friend void   ::Teamcenter::transactionprocessing::initializetransactionprocessingInternal();
    friend void   ::Teamcenter::transactionprocessing::initializetransactionprocessingExtenders();
    friend class  Teamcenter::transactionprocessing::TransactionActivityDelegate;
};

#include <transactionprocessingdispatch/libtransactionprocessingdispatch_undef.h>
#endif  //  TEAMCENTER__TRANSACTIONPROCESSING__TRANSACTIONACTIVITYDISPATCH_HXX
