//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TransactionDispatch
    Filename:   TransactionDispatch.hxx
    Module:     transactionprocessingdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TRANSACTIONPROCESSING__TRANSACTIONDISPATCH_HXX
#define TEAMCENTER__TRANSACTIONPROCESSING__TRANSACTIONDISPATCH_HXX

#include <vector>
#include <transactionprocessing/Transaction.hxx>
#include <transactionprocessing/TransactionDelegate.hxx>
#include <transactionprocessingdispatch/TransactionElementDispatch.hxx>
#include <transactionprocessingdispatch/initializetransactionprocessing.hxx>

#include <transactionprocessingdispatch/libtransactionprocessingdispatch_exports.h>

namespace Teamcenter
{
    namespace transactionprocessing
    {
        class TransactionDispatch;
    }
}
namespace Teamcenter
{
    namespace transactionprocessing
    {
        class TransactionDelegate;
    }
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  TRANSACTIONPROCESSINGDISPATCH_API  Teamcenter::transactionprocessing::TransactionDispatch
    : public  Teamcenter::transactionprocessing::TransactionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the TransactionDispatch instance
    static TransactionDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static TransactionDispatch*  m_dispatch;

    //  Default Constructor
    TransactionDispatch();

    //  Default Destructor
    virtual ~TransactionDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a TransactionDispatch
    TransactionDispatch( const TransactionDispatch& );

    //  Assignment operator
    TransactionDispatch&  operator = ( const TransactionDispatch& );

    //  friend
    friend void   ::Teamcenter::transactionprocessing::initializetransactionprocessingInternal();
    friend void   ::Teamcenter::transactionprocessing::initializetransactionprocessingExtenders();
    friend class  Teamcenter::transactionprocessing::TransactionDelegate;
};

#include <transactionprocessingdispatch/libtransactionprocessingdispatch_undef.h>
#endif  //  TEAMCENTER__TRANSACTIONPROCESSING__TRANSACTIONDISPATCH_HXX
