//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TransactionElementDispatch
    Filename:   TransactionElementDispatch.hxx
    Module:     transactionprocessingdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TRANSACTIONPROCESSING__TRANSACTIONELEMENTDISPATCH_HXX
#define TEAMCENTER__TRANSACTIONPROCESSING__TRANSACTIONELEMENTDISPATCH_HXX

#include <vector>
#include <transactionprocessing/TransactionElement.hxx>
#include <transactionprocessing/TransactionElementDelegate.hxx>
#include <mrocoredispatch/HierarchicalWSODispatch.hxx>
#include <transactionprocessingdispatch/initializetransactionprocessing.hxx>

#include <transactionprocessingdispatch/libtransactionprocessingdispatch_exports.h>

namespace Teamcenter
{
    namespace transactionprocessing
    {
        class TransactionElementDispatch;
    }
}
namespace Teamcenter
{
    namespace transactionprocessing
    {
        class TransactionElementDelegate;
    }
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  TRANSACTIONPROCESSINGDISPATCH_API  Teamcenter::transactionprocessing::TransactionElementDispatch
    : public  Teamcenter::transactionprocessing::TransactionElementDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the TransactionElementDispatch instance
    static TransactionElementDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static TransactionElementDispatch*  m_dispatch;

    //  Default Constructor
    TransactionElementDispatch();

    //  Default Destructor
    virtual ~TransactionElementDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a TransactionElementDispatch
    TransactionElementDispatch( const TransactionElementDispatch& );

    //  Assignment operator
    TransactionElementDispatch&  operator = ( const TransactionElementDispatch& );

    //  friend
    friend void   ::Teamcenter::transactionprocessing::initializetransactionprocessingInternal();
    friend void   ::Teamcenter::transactionprocessing::initializetransactionprocessingExtenders();
    friend class  Teamcenter::transactionprocessing::TransactionElementDelegate;
};

#include <transactionprocessingdispatch/libtransactionprocessingdispatch_undef.h>
#endif  //  TEAMCENTER__TRANSACTIONPROCESSING__TRANSACTIONELEMENTDISPATCH_HXX
