//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  transactionprocessingdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libtransactionprocessingdispatch

#if !defined(LIBTRANSACTIONPROCESSINGDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBTRANSACTIONPROCESSINGDISPATCH is not defined
#endif

/* Handwritten code should use TRANSACTIONPROCESSINGDISPATCH_API, not TRANSACTIONPROCESSINGDISPATCHEXPORT */

#define TRANSACTIONPROCESSINGDISPATCH_API TRANSACTIONPROCESSINGDISPATCHEXPORT

#if IPLIB==libtransactionprocessingdispatch || defined(LIBTRANSACTIONPROCESSINGDISPATCH)
#   if defined(__lint)
#       define TRANSACTIONPROCESSINGDISPATCHEXPORT       __export(transactionprocessingdispatch)
#       define TRANSACTIONPROCESSINGDISPATCHGLOBAL       extern __global(transactionprocessingdispatch)
#       define TRANSACTIONPROCESSINGDISPATCHPRIVATE      extern __private(transactionprocessingdispatch)
#   elif defined(_WIN32)
#       define TRANSACTIONPROCESSINGDISPATCHEXPORT       __declspec(dllexport)
#       define TRANSACTIONPROCESSINGDISPATCHGLOBAL       extern __declspec(dllexport)
#       define TRANSACTIONPROCESSINGDISPATCHPRIVATE      extern
#   else
#       define TRANSACTIONPROCESSINGDISPATCHEXPORT
#       define TRANSACTIONPROCESSINGDISPATCHGLOBAL       extern
#       define TRANSACTIONPROCESSINGDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define TRANSACTIONPROCESSINGDISPATCHEXPORT       __export(transactionprocessingdispatch)
#       define TRANSACTIONPROCESSINGDISPATCHGLOBAL       extern __global(transactionprocessingdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define TRANSACTIONPROCESSINGDISPATCHEXPORT      __declspec(dllimport)
#       define TRANSACTIONPROCESSINGDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define TRANSACTIONPROCESSINGDISPATCHEXPORT
#       define TRANSACTIONPROCESSINGDISPATCHGLOBAL       extern
#   endif
#endif
