//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0AbstractCommand
    Filename:   Fnd0AbstractCommand.hxx
    Module:     uiconfig
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0ABSTRACTCOMMAND__HXX
#define TEAMCENTER__FND0ABSTRACTCOMMAND__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <uiconfig/Fnd0UIConfigurationObject.hxx>

#include <uiconfig/libuiconfig_exports.h>

namespace Teamcenter
{
    class Fnd0AbstractCommand;
}
namespace Teamcenter
{
    class Fnd0AbstractCommandImpl;
}
namespace Teamcenter
{
    class Fnd0AbstractCommandDelegate;
}
namespace Teamcenter
{
    class Fnd0AbstractCommandDispatch;
}
namespace Teamcenter
{
    class Fnd0AbstractCommandGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  UICONFIG_API  Teamcenter::Fnd0AbstractCommand
     : public  ::Teamcenter::Fnd0UIConfigurationObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0RenderingHint( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0RenderingHint( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0AbstractCommand();

    /**
     * Destructor
     */
    virtual ~Fnd0AbstractCommand();

private:
    //  Getter method for the Implementation Object
    Fnd0AbstractCommandImpl*  getFnd0AbstractCommandImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0AbstractCommandImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0AbstractCommandImpl*  m_fnd0abstractcommandImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0AbstractCommand - desc for Fnd0AbstractCommand parameter
     */
    Fnd0AbstractCommand( const Fnd0AbstractCommand& );
    Fnd0AbstractCommand& operator=( const Fnd0AbstractCommand& );

    friend class  Fnd0AbstractCommandDelegate;
    friend class  Fnd0AbstractCommandDispatch;
    friend class  Fnd0AbstractCommandGenImpl;
};

#include <uiconfig/libuiconfig_undef.h>
#endif //   TEAMCENTER__FND0ABSTRACTCOMMAND__HXX
