//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0AbstractCommandDelegate
    Filename:   Fnd0AbstractCommandDelegate.hxx
    Module:     uiconfig
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0ABSTRACTCOMMANDDELEGATE_HXX
#define TEAMCENTER__FND0ABSTRACTCOMMANDDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <uiconfig/Fnd0AbstractCommand.hxx>

#include <uiconfig/libuiconfig_exports.h>

namespace Teamcenter
{
    class Fnd0AbstractCommandDelegate;
}
namespace Teamcenter
{
    class Fnd0AbstractCommandImpl;
}
namespace Teamcenter
{
    class Fnd0AbstractCommand;
}
namespace Teamcenter
{
    class Fnd0AbstractCommandGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  UICONFIG_API Teamcenter_alias::Fnd0AbstractCommandDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0AbstractCommandDelegate instance
    static Fnd0AbstractCommandDelegate&  getInstance();

    //  Method to create the Fnd0AbstractCommandImpl pointer
    static Fnd0AbstractCommandImpl*  createImpl( Fnd0AbstractCommand&  ifObj );

    //  Method to delete the Fnd0AbstractCommandImpl pointer
    static void deleteImpl( Fnd0AbstractCommandImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0RenderingHintBase(const Fnd0AbstractCommand &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0RenderingHintBase(Fnd0AbstractCommand &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static Fnd0AbstractCommandDelegate*  m_pInstance;

    Fnd0AbstractCommandDelegate();
    virtual ~Fnd0AbstractCommandDelegate();
    static void setInstance( Fnd0AbstractCommandDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0AbstractCommandGenImpl;

};

#include <uiconfig/libuiconfig_undef.h>
#endif  //  TEAMCENTER__FND0ABSTRACTCOMMANDDELEGATE_HXX
