//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0Client
    Filename:   Fnd0Client.hxx
    Module:     uiconfig
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0CLIENT__HXX
#define TEAMCENTER__FND0CLIENT__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <uiconfig/Fnd0UIConfigurationObject.hxx>

#include <uiconfig/libuiconfig_exports.h>

namespace Teamcenter
{
    class Fnd0Client;
}
namespace Teamcenter
{
    class Fnd0ClientImpl;
}
namespace Teamcenter
{
    class Fnd0ClientDelegate;
}
namespace Teamcenter
{
    class Fnd0ClientDispatch;
}
namespace Teamcenter
{
    class Fnd0ClientGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  UICONFIG_API  Teamcenter::Fnd0Client
     : public  ::Teamcenter::Fnd0UIConfigurationObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0Abbreviation( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0Name( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0Abbreviation( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0Client();

    /**
     * Destructor
     */
    virtual ~Fnd0Client();

private:
    //  Getter method for the Implementation Object
    Fnd0ClientImpl*  getFnd0ClientImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0ClientImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0ClientImpl*  m_fnd0clientImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0Client - desc for Fnd0Client parameter
     */
    Fnd0Client( const Fnd0Client& );
    Fnd0Client& operator=( const Fnd0Client& );

    friend class  Fnd0ClientDelegate;
    friend class  Fnd0ClientDispatch;
    friend class  Fnd0ClientGenImpl;
};

#include <uiconfig/libuiconfig_undef.h>
#endif //   TEAMCENTER__FND0CLIENT__HXX
