//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ClientDelegate
    Filename:   Fnd0ClientDelegate.hxx
    Module:     uiconfig
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0CLIENTDELEGATE_HXX
#define TEAMCENTER__FND0CLIENTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <uiconfig/Fnd0Client.hxx>

#include <uiconfig/libuiconfig_exports.h>

namespace Teamcenter
{
    class Fnd0ClientDelegate;
}
namespace Teamcenter
{
    class Fnd0ClientImpl;
}
namespace Teamcenter
{
    class Fnd0Client;
}
namespace Teamcenter
{
    class Fnd0ClientGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  UICONFIG_API Teamcenter_alias::Fnd0ClientDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0ClientDelegate instance
    static Fnd0ClientDelegate&  getInstance();

    //  Method to create the Fnd0ClientImpl pointer
    static Fnd0ClientImpl*  createImpl( Fnd0Client&  ifObj );

    //  Method to delete the Fnd0ClientImpl pointer
    static void deleteImpl( Fnd0ClientImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0AbbreviationBase(const Fnd0Client &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0NameBase(const Fnd0Client &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0AbbreviationBase(Fnd0Client &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static Fnd0ClientDelegate*  m_pInstance;

    Fnd0ClientDelegate();
    virtual ~Fnd0ClientDelegate();
    static void setInstance( Fnd0ClientDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0ClientGenImpl;

};

#include <uiconfig/libuiconfig_undef.h>
#endif  //  TEAMCENTER__FND0CLIENTDELEGATE_HXX
