//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ClientScope
    Filename:   Fnd0ClientScope.hxx
    Module:     uiconfig
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0CLIENTSCOPE__HXX
#define TEAMCENTER__FND0CLIENTSCOPE__HXX

#include <unidefs.h>
#include <string>
#include <common/tc_deprecation_macros.h>
#include <uiconfig/Fnd0UIConfigurationObject.hxx>

#include <uiconfig/libuiconfig_exports.h>

namespace Teamcenter
{
    class Fnd0ClientScope;
}
namespace Teamcenter
{
    class Fnd0ClientScopeImpl;
}
namespace Teamcenter
{
    class Fnd0ClientScopeDelegate;
}
namespace Teamcenter
{
    class Fnd0ClientScopeDispatch;
}
namespace Teamcenter
{
    class Fnd0ClientScopeGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  UICONFIG_API  Teamcenter::Fnd0ClientScope
     : public  ::Teamcenter::Fnd0UIConfigurationObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0Client( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ClientScopeURI( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0Description( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0HostingClient( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0Name( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9.1.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0Client( const tag_t &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0Description( const std::string &value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9.1.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0HostingClient( const tag_t &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0Name( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0ClientScope();

    /**
     * Destructor
     */
    virtual ~Fnd0ClientScope();

private:
    //  Getter method for the Implementation Object
    Fnd0ClientScopeImpl*  getFnd0ClientScopeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0ClientScopeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0ClientScopeImpl*  m_fnd0clientscopeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0ClientScope - desc for Fnd0ClientScope parameter
     */
    Fnd0ClientScope( const Fnd0ClientScope& );
    Fnd0ClientScope& operator=( const Fnd0ClientScope& );

    friend class  Fnd0ClientScopeDelegate;
    friend class  Fnd0ClientScopeDispatch;
    friend class  Fnd0ClientScopeGenImpl;
};

#include <uiconfig/libuiconfig_undef.h>
#endif //   TEAMCENTER__FND0CLIENTSCOPE__HXX
