//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ClientScopeDelegate
    Filename:   Fnd0ClientScopeDelegate.hxx
    Module:     uiconfig
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0CLIENTSCOPEDELEGATE_HXX
#define TEAMCENTER__FND0CLIENTSCOPEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <uiconfig/Fnd0ClientScope.hxx>

#include <uiconfig/libuiconfig_exports.h>

namespace Teamcenter
{
    class Fnd0ClientScopeDelegate;
}
namespace Teamcenter
{
    class Fnd0ClientScopeImpl;
}
namespace Teamcenter
{
    class Fnd0ClientScope;
}
namespace Teamcenter
{
    class Fnd0ClientScopeGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  UICONFIG_API Teamcenter_alias::Fnd0ClientScopeDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0ClientScopeDelegate instance
    static Fnd0ClientScopeDelegate&  getInstance();

    //  Method to create the Fnd0ClientScopeImpl pointer
    static Fnd0ClientScopeImpl*  createImpl( Fnd0ClientScope&  ifObj );

    //  Method to delete the Fnd0ClientScopeImpl pointer
    static void deleteImpl( Fnd0ClientScopeImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ClientBase(const Fnd0ClientScope &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ClientScopeURIBase(const Fnd0ClientScope &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0DescriptionBase(const Fnd0ClientScope &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0HostingClientBase(const Fnd0ClientScope &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0NameBase(const Fnd0ClientScope &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9.1.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0ClientBase(Fnd0ClientScope &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0DescriptionBase(Fnd0ClientScope &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9.1.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0HostingClientBase(Fnd0ClientScope &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0NameBase(Fnd0ClientScope &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static Fnd0ClientScopeDelegate*  m_pInstance;

    Fnd0ClientScopeDelegate();
    virtual ~Fnd0ClientScopeDelegate();
    static void setInstance( Fnd0ClientScopeDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0ClientScopeGenImpl;

};

#include <uiconfig/libuiconfig_undef.h>
#endif  //  TEAMCENTER__FND0CLIENTSCOPEDELEGATE_HXX
