//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0CmdConfigRule
    Filename:   Fnd0CmdConfigRule.hxx
    Module:     uiconfig
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0CMDCONFIGRULE__HXX
#define TEAMCENTER__FND0CMDCONFIGRULE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/BusinessRule.hxx>

#include <uiconfig/libuiconfig_exports.h>

namespace Teamcenter
{
    class Fnd0CmdConfigRule;
}
namespace Teamcenter
{
    class Fnd0CmdConfigRuleImpl;
}
namespace Teamcenter
{
    class Fnd0CmdConfigRuleDelegate;
}
namespace Teamcenter
{
    class Fnd0CmdConfigRuleDispatch;
}
namespace Teamcenter
{
    class Fnd0CmdConfigRuleGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  UICONFIG_API  Teamcenter::Fnd0CmdConfigRule
     : public  ::Teamcenter::BusinessRule
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0CmdConfigRule();

    /**
     * Destructor
     */
    virtual ~Fnd0CmdConfigRule();

private:
    //  Getter method for the Implementation Object
    Fnd0CmdConfigRuleImpl*  getFnd0CmdConfigRuleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0CmdConfigRuleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0CmdConfigRuleImpl*  m_fnd0cmdconfigruleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0CmdConfigRule - desc for Fnd0CmdConfigRule parameter
     */
    Fnd0CmdConfigRule( const Fnd0CmdConfigRule& );
    Fnd0CmdConfigRule& operator=( const Fnd0CmdConfigRule& );

    friend class  Fnd0CmdConfigRuleDelegate;
    friend class  Fnd0CmdConfigRuleDispatch;
    friend class  Fnd0CmdConfigRuleGenImpl;
};

#include <uiconfig/libuiconfig_undef.h>
#endif //   TEAMCENTER__FND0CMDCONFIGRULE__HXX
