//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ColumnConfig
    Filename:   Fnd0ColumnConfig.hxx
    Module:     uiconfig
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0COLUMNCONFIG__HXX
#define TEAMCENTER__FND0COLUMNCONFIG__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <uiconfig/Fnd0UIConfigurationObject.hxx>

#include <uiconfig/libuiconfig_exports.h>

namespace Teamcenter
{
    class Fnd0ColumnConfig;
}
namespace Teamcenter
{
    class Fnd0ColumnConfigImpl;
}
namespace Teamcenter
{
    class Fnd0ColumnConfigDelegate;
}
namespace Teamcenter
{
    class Fnd0ColumnConfigDispatch;
}
namespace Teamcenter
{
    class Fnd0ColumnConfigGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  UICONFIG_API  Teamcenter::Fnd0ColumnConfig
     : public  ::Teamcenter::Fnd0UIConfigurationObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ColumnConfigId( std::string &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0ColumnConfig();

    /**
     * Destructor
     */
    virtual ~Fnd0ColumnConfig();

private:
    //  Getter method for the Implementation Object
    Fnd0ColumnConfigImpl*  getFnd0ColumnConfigImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0ColumnConfigImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0ColumnConfigImpl*  m_fnd0columnconfigImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0ColumnConfig - desc for Fnd0ColumnConfig parameter
     */
    Fnd0ColumnConfig( const Fnd0ColumnConfig& );
    Fnd0ColumnConfig& operator=( const Fnd0ColumnConfig& );

    friend class  Fnd0ColumnConfigDelegate;
    friend class  Fnd0ColumnConfigDispatch;
    friend class  Fnd0ColumnConfigGenImpl;
};

#include <uiconfig/libuiconfig_undef.h>
#endif //   TEAMCENTER__FND0COLUMNCONFIG__HXX
