//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ColumnDef
    Filename:   Fnd0ColumnDef.hxx
    Module:     uiconfig
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0COLUMNDEF__HXX
#define TEAMCENTER__FND0COLUMNDEF__HXX

#include <unidefs.h>
#include <string>
#include <common/tc_deprecation_macros.h>
#include <uiconfig/Fnd0UIConfigurationObject.hxx>

#include <uiconfig/libuiconfig_exports.h>

namespace Teamcenter
{
    class Fnd0ColumnDef;
}
namespace Teamcenter
{
    class Fnd0ColumnDefImpl;
}
namespace Teamcenter
{
    class Fnd0ColumnDefDelegate;
}
namespace Teamcenter
{
    class Fnd0ColumnDefDispatch;
}
namespace Teamcenter
{
    class Fnd0ColumnDefGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  UICONFIG_API  Teamcenter::Fnd0ColumnDef
     : public  ::Teamcenter::Fnd0UIConfigurationObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ObjectType( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0PropertyName( std::string &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0ColumnDef();

    /**
     * Destructor
     */
    virtual ~Fnd0ColumnDef();

private:
    //  Getter method for the Implementation Object
    Fnd0ColumnDefImpl*  getFnd0ColumnDefImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0ColumnDefImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0ColumnDefImpl*  m_fnd0columndefImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0ColumnDef - desc for Fnd0ColumnDef parameter
     */
    Fnd0ColumnDef( const Fnd0ColumnDef& );
    Fnd0ColumnDef& operator=( const Fnd0ColumnDef& );

    friend class  Fnd0ColumnDefDelegate;
    friend class  Fnd0ColumnDefDispatch;
    friend class  Fnd0ColumnDefGenImpl;
};

#include <uiconfig/libuiconfig_undef.h>
#endif //   TEAMCENTER__FND0COLUMNDEF__HXX
