//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ColumnOrderRel
    Filename:   Fnd0ColumnOrderRel.hxx
    Module:     uiconfig
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0COLUMNORDERREL__HXX
#define TEAMCENTER__FND0COLUMNORDERREL__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <uiconfig/Fnd0UIConfigOrderRel.hxx>

#include <uiconfig/libuiconfig_exports.h>

namespace Teamcenter
{
    class Fnd0ColumnOrderRel;
}
namespace Teamcenter
{
    class Fnd0ColumnOrderRelImpl;
}
namespace Teamcenter
{
    class Fnd0ColumnOrderRelDelegate;
}
namespace Teamcenter
{
    class Fnd0ColumnOrderRelDispatch;
}
namespace Teamcenter
{
    class Fnd0ColumnOrderRelGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  UICONFIG_API  Teamcenter::Fnd0ColumnOrderRel
     : public  ::Teamcenter::Fnd0UIConfigOrderRel
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 9.1.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0IsSortByColumn( bool &value, bool &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 9.1.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0PixelWidth( int &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0SortDirection( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 9.1.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0IsSortByColumn( bool value, bool isNull=false );

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 9.1.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0PixelWidth( int value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0SortDirection( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0ColumnOrderRel();

    /**
     * Destructor
     */
    virtual ~Fnd0ColumnOrderRel();

private:
    //  Getter method for the Implementation Object
    Fnd0ColumnOrderRelImpl*  getFnd0ColumnOrderRelImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0ColumnOrderRelImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0ColumnOrderRelImpl*  m_fnd0columnorderrelImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0ColumnOrderRel - desc for Fnd0ColumnOrderRel parameter
     */
    Fnd0ColumnOrderRel( const Fnd0ColumnOrderRel& );
    Fnd0ColumnOrderRel& operator=( const Fnd0ColumnOrderRel& );

    friend class  Fnd0ColumnOrderRelDelegate;
    friend class  Fnd0ColumnOrderRelDispatch;
    friend class  Fnd0ColumnOrderRelGenImpl;
};

#include <uiconfig/libuiconfig_undef.h>
#endif //   TEAMCENTER__FND0COLUMNORDERREL__HXX
