//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ColumnOrderRelDelegate
    Filename:   Fnd0ColumnOrderRelDelegate.hxx
    Module:     uiconfig
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0COLUMNORDERRELDELEGATE_HXX
#define TEAMCENTER__FND0COLUMNORDERRELDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <uiconfig/Fnd0ColumnOrderRel.hxx>

#include <uiconfig/libuiconfig_exports.h>

namespace Teamcenter
{
    class Fnd0ColumnOrderRelDelegate;
}
namespace Teamcenter
{
    class Fnd0ColumnOrderRelImpl;
}
namespace Teamcenter
{
    class Fnd0ColumnOrderRel;
}
namespace Teamcenter
{
    class Fnd0ColumnOrderRelGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  UICONFIG_API Teamcenter_alias::Fnd0ColumnOrderRelDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0ColumnOrderRelDelegate instance
    static Fnd0ColumnOrderRelDelegate&  getInstance();

    //  Method to create the Fnd0ColumnOrderRelImpl pointer
    static Fnd0ColumnOrderRelImpl*  createImpl( Fnd0ColumnOrderRel&  ifObj );

    //  Method to delete the Fnd0ColumnOrderRelImpl pointer
    static void deleteImpl( Fnd0ColumnOrderRelImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 9.1.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0IsSortByColumnBase(const Fnd0ColumnOrderRel &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 9.1.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0PixelWidthBase(const Fnd0ColumnOrderRel &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0SortDirectionBase(const Fnd0ColumnOrderRel &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 9.1.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0IsSortByColumnBase(Fnd0ColumnOrderRel &ifObj,  bool value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 9.1.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0PixelWidthBase(Fnd0ColumnOrderRel &ifObj,  int value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 9.1.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0SortDirectionBase(Fnd0ColumnOrderRel &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static Fnd0ColumnOrderRelDelegate*  m_pInstance;

    Fnd0ColumnOrderRelDelegate();
    virtual ~Fnd0ColumnOrderRelDelegate();
    static void setInstance( Fnd0ColumnOrderRelDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0ColumnOrderRelGenImpl;

};

#include <uiconfig/libuiconfig_undef.h>
#endif  //  TEAMCENTER__FND0COLUMNORDERRELDELEGATE_HXX
