//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0CommandCollection
    Filename:   Fnd0CommandCollection.hxx
    Module:     uiconfig
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0COMMANDCOLLECTION__HXX
#define TEAMCENTER__FND0COMMANDCOLLECTION__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <uiconfig/Fnd0AbstractCommand.hxx>

#include <uiconfig/libuiconfig_exports.h>

namespace Teamcenter
{
    class Fnd0CommandCollection;
}
namespace Teamcenter
{
    class Fnd0CommandCollectionImpl;
}
namespace Teamcenter
{
    class Fnd0CommandCollectionDelegate;
}
namespace Teamcenter
{
    class Fnd0CommandCollectionDispatch;
}
namespace Teamcenter
{
    class Fnd0CommandCollectionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  UICONFIG_API  Teamcenter::Fnd0CommandCollection
     : public  ::Teamcenter::Fnd0AbstractCommand
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0CommandCollectionId( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0Mnemonic( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0Name( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0Mnemonic( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0Name( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0CommandCollection();

    /**
     * Destructor
     */
    virtual ~Fnd0CommandCollection();

private:
    //  Getter method for the Implementation Object
    Fnd0CommandCollectionImpl*  getFnd0CommandCollectionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0CommandCollectionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0CommandCollectionImpl*  m_fnd0commandcollectionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0CommandCollection - desc for Fnd0CommandCollection parameter
     */
    Fnd0CommandCollection( const Fnd0CommandCollection& );
    Fnd0CommandCollection& operator=( const Fnd0CommandCollection& );

    friend class  Fnd0CommandCollectionDelegate;
    friend class  Fnd0CommandCollectionDispatch;
    friend class  Fnd0CommandCollectionGenImpl;
};

#include <uiconfig/libuiconfig_undef.h>
#endif //   TEAMCENTER__FND0COMMANDCOLLECTION__HXX
