//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0CommandCollectionDelegate
    Filename:   Fnd0CommandCollectionDelegate.hxx
    Module:     uiconfig
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0COMMANDCOLLECTIONDELEGATE_HXX
#define TEAMCENTER__FND0COMMANDCOLLECTIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <uiconfig/Fnd0CommandCollection.hxx>

#include <uiconfig/libuiconfig_exports.h>

namespace Teamcenter
{
    class Fnd0CommandCollectionDelegate;
}
namespace Teamcenter
{
    class Fnd0CommandCollectionImpl;
}
namespace Teamcenter
{
    class Fnd0CommandCollection;
}
namespace Teamcenter
{
    class Fnd0CommandCollectionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  UICONFIG_API Teamcenter_alias::Fnd0CommandCollectionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0CommandCollectionDelegate instance
    static Fnd0CommandCollectionDelegate&  getInstance();

    //  Method to create the Fnd0CommandCollectionImpl pointer
    static Fnd0CommandCollectionImpl*  createImpl( Fnd0CommandCollection&  ifObj );

    //  Method to delete the Fnd0CommandCollectionImpl pointer
    static void deleteImpl( Fnd0CommandCollectionImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 9.1.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0CommandCollectionIdBase(const Fnd0CommandCollection &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0MnemonicBase(const Fnd0CommandCollection &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0NameBase(const Fnd0CommandCollection &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0MnemonicBase(Fnd0CommandCollection &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10.1.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0NameBase(Fnd0CommandCollection &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static Fnd0CommandCollectionDelegate*  m_pInstance;

    Fnd0CommandCollectionDelegate();
    virtual ~Fnd0CommandCollectionDelegate();
    static void setInstance( Fnd0CommandCollectionDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0CommandCollectionGenImpl;

};

#include <uiconfig/libuiconfig_undef.h>
#endif  //  TEAMCENTER__FND0COMMANDCOLLECTIONDELEGATE_HXX
