//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0UIConfigCollectionRel
    Filename:   Fnd0UIConfigCollectionRel.hxx
    Module:     uiconfig
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0UICONFIGCOLLECTIONREL__HXX
#define TEAMCENTER__FND0UICONFIGCOLLECTIONREL__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <uiconfig/libuiconfig_exports.h>

namespace Teamcenter
{
    class Fnd0UIConfigCollectionRel;
}
namespace Teamcenter
{
    class Fnd0UIConfigCollectionRelImpl;
}
namespace Teamcenter
{
    class Fnd0UIConfigCollectionRelDelegate;
}
namespace Teamcenter
{
    class Fnd0UIConfigCollectionRelDispatch;
}
namespace Teamcenter
{
    class Fnd0UIConfigCollectionRelGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  UICONFIG_API  Teamcenter::Fnd0UIConfigCollectionRel
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 9.1.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0Hidden( bool &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0PrimaryObject( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0SecondaryObject( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 9.1.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0Hidden( bool value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0UIConfigCollectionRel();

    /**
     * Destructor
     */
    virtual ~Fnd0UIConfigCollectionRel();

private:
    //  Getter method for the Implementation Object
    Fnd0UIConfigCollectionRelImpl*  getFnd0UIConfigCollectionRelImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0UIConfigCollectionRelImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0UIConfigCollectionRelImpl*  m_fnd0uiconfigcollectionrelImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0UIConfigCollectionRel - desc for Fnd0UIConfigCollectionRel parameter
     */
    Fnd0UIConfigCollectionRel( const Fnd0UIConfigCollectionRel& );
    Fnd0UIConfigCollectionRel& operator=( const Fnd0UIConfigCollectionRel& );

    friend class  Fnd0UIConfigCollectionRelDelegate;
    friend class  Fnd0UIConfigCollectionRelDispatch;
    friend class  Fnd0UIConfigCollectionRelGenImpl;
};

#include <uiconfig/libuiconfig_undef.h>
#endif //   TEAMCENTER__FND0UICONFIGCOLLECTIONREL__HXX
