//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0UIConfigOrderRelDelegate
    Filename:   Fnd0UIConfigOrderRelDelegate.hxx
    Module:     uiconfig
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0UICONFIGORDERRELDELEGATE_HXX
#define TEAMCENTER__FND0UICONFIGORDERRELDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <uiconfig/Fnd0UIConfigOrderRel.hxx>

#include <uiconfig/libuiconfig_exports.h>

namespace Teamcenter
{
    class Fnd0UIConfigOrderRelDelegate;
}
namespace Teamcenter
{
    class Fnd0UIConfigOrderRelImpl;
}
namespace Teamcenter
{
    class Fnd0UIConfigOrderRel;
}
namespace Teamcenter
{
    class Fnd0UIConfigOrderRelGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  UICONFIG_API Teamcenter_alias::Fnd0UIConfigOrderRelDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0UIConfigOrderRelDelegate instance
    static Fnd0UIConfigOrderRelDelegate&  getInstance();

    //  Method to create the Fnd0UIConfigOrderRelImpl pointer
    static Fnd0UIConfigOrderRelImpl*  createImpl( Fnd0UIConfigOrderRel&  ifObj );

    //  Method to delete the Fnd0UIConfigOrderRelImpl pointer
    static void deleteImpl( Fnd0UIConfigOrderRelImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ClientBase(const Fnd0UIConfigOrderRel &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 9.1.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0HiddenBase(const Fnd0UIConfigOrderRel &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0PrimaryObjectBase(const Fnd0UIConfigOrderRel &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 9.1.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0PriorityBase(const Fnd0UIConfigOrderRel &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ScopeBase(const Fnd0UIConfigOrderRel &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 9.1.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0SecondaryObjectBase(const Fnd0UIConfigOrderRel &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9.1.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0ClientBase(Fnd0UIConfigOrderRel &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 9.1.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0HiddenBase(Fnd0UIConfigOrderRel &ifObj,  bool value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 9.1.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0PriorityBase(Fnd0UIConfigOrderRel &ifObj,  int value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 9.1.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0ScopeBase(Fnd0UIConfigOrderRel &ifObj,  const tag_t &value, bool isNull );



protected:
    //  Pointer to the instance
    static Fnd0UIConfigOrderRelDelegate*  m_pInstance;

    Fnd0UIConfigOrderRelDelegate();
    virtual ~Fnd0UIConfigOrderRelDelegate();
    static void setInstance( Fnd0UIConfigOrderRelDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0UIConfigOrderRelGenImpl;

};

#include <uiconfig/libuiconfig_undef.h>
#endif  //  TEAMCENTER__FND0UICONFIGORDERRELDELEGATE_HXX
