//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0UIConfigurationObject
    Filename:   Fnd0UIConfigurationObject.hxx
    Module:     uiconfig
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0UICONFIGURATIONOBJECT__HXX
#define TEAMCENTER__FND0UICONFIGURATIONOBJECT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <uiconfig/libuiconfig_exports.h>

namespace Teamcenter
{
    class Fnd0UIConfigurationObject;
}
namespace Teamcenter
{
    class Fnd0UIConfigurationObjectImpl;
}
namespace Teamcenter
{
    class Fnd0UIConfigurationObjectDelegate;
}
namespace Teamcenter
{
    class Fnd0UIConfigurationObjectDispatch;
}
namespace Teamcenter
{
    class Fnd0UIConfigurationObjectGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  UICONFIG_API  Teamcenter::Fnd0UIConfigurationObject
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0UIConfigurationObject();

    /**
     * Destructor
     */
    virtual ~Fnd0UIConfigurationObject();

private:
    //  Getter method for the Implementation Object
    Fnd0UIConfigurationObjectImpl*  getFnd0UIConfigurationObjectImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0UIConfigurationObjectImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0UIConfigurationObjectImpl*  m_fnd0uiconfigurationobjectImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0UIConfigurationObject - desc for Fnd0UIConfigurationObject parameter
     */
    Fnd0UIConfigurationObject( const Fnd0UIConfigurationObject& );
    Fnd0UIConfigurationObject& operator=( const Fnd0UIConfigurationObject& );

    friend class  Fnd0UIConfigurationObjectDelegate;
    friend class  Fnd0UIConfigurationObjectDispatch;
    friend class  Fnd0UIConfigurationObjectGenImpl;
};

#include <uiconfig/libuiconfig_undef.h>
#endif //   TEAMCENTER__FND0UICONFIGURATIONOBJECT__HXX
