//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, PartOcc
    Filename:   PartOcc.hxx
    Module:     usage
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PARTOCC__HXX
#define TEAMCENTER__PARTOCC__HXX

#include <common/tc_deprecation_macros.h>
#include <metaframework/RuntimeBusinessObject.hxx>

#include <usage/libusage_exports.h>

namespace Teamcenter
{
    class PartOcc;
}
namespace Teamcenter
{
    class PartOccImpl;
}
namespace Teamcenter
{
    class PartOccDelegate;
}
namespace Teamcenter
{
    class PartOccDispatch;
}
namespace Teamcenter
{
    class PartOccGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  USAGE_API  Teamcenter::PartOcc
     : public  ::Teamcenter::RuntimeBusinessObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    PartOcc();

    /**
     * Destructor
     */
    virtual ~PartOcc();

private:
    //  Getter method for the Implementation Object
    PartOccImpl*  getPartOccImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setPartOccImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    PartOccImpl*  m_partoccImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param PartOcc - desc for PartOcc parameter
     */
    PartOcc( const PartOcc& );
    PartOcc& operator=( const PartOcc& );

    friend class  PartOccDelegate;
    friend class  PartOccDispatch;
    friend class  PartOccGenImpl;
};

#include <usage/libusage_undef.h>
#endif //   TEAMCENTER__PARTOCC__HXX
