//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  usage

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libusage

#if !defined(LIBUSAGE) && !defined(IPLIB)
#   error IPLIB or LIBUSAGE is not defined
#endif

/* Handwritten code should use USAGE_API, not USAGEEXPORT */

#define USAGE_API USAGEEXPORT

#if IPLIB==libusage || defined(LIBUSAGE)
#   if defined(__lint)
#       define USAGEEXPORT       __export(usage)
#       define USAGEGLOBAL       extern __global(usage)
#       define USAGEPRIVATE      extern __private(usage)
#   elif defined(_WIN32)
#       define USAGEEXPORT       __declspec(dllexport)
#       define USAGEGLOBAL       extern __declspec(dllexport)
#       define USAGEPRIVATE      extern
#   else
#       define USAGEEXPORT
#       define USAGEGLOBAL       extern
#       define USAGEPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define USAGEEXPORT       __export(usage)
#       define USAGEGLOBAL       extern __global(usage)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define USAGEEXPORT      __declspec(dllimport)
#       define USAGEGLOBAL       extern __declspec(dllimport)
#   else
#       define USAGEEXPORT
#       define USAGEGLOBAL       extern
#   endif
#endif
