//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DesignReq
    Filename:   DesignReq.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__DESIGNREQ__HXX
#define TEAMCENTER__DESIGNREQ__HXX

#include <common/tc_deprecation_macros.h>
#include <validation/ModelReq.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class DesignReq;
}
namespace Teamcenter
{
    class DesignReqImpl;
}
namespace Teamcenter
{
    class DesignReqDelegate;
}
namespace Teamcenter
{
    class DesignReqDispatch;
}
namespace Teamcenter
{
    class DesignReqGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VALIDATION_API  Teamcenter::DesignReq
     : public  ::Teamcenter::ModelReq
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    DesignReq();

    /**
     * Destructor
     */
    virtual ~DesignReq();

private:
    //  Getter method for the Implementation Object
    DesignReqImpl*  getDesignReqImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDesignReqImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DesignReqImpl*  m_designreqImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param DesignReq - desc for DesignReq parameter
     */
    DesignReq( const DesignReq& );
    DesignReq& operator=( const DesignReq& );

    friend class  DesignReqDelegate;
    friend class  DesignReqDispatch;
    friend class  DesignReqGenImpl;
};

#include <validation/libvalidation_undef.h>
#endif //   TEAMCENTER__DESIGNREQ__HXX
