//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DesignReqRevision
    Filename:   DesignReqRevision.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__DESIGNREQREVISION__HXX
#define TEAMCENTER__DESIGNREQREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <validation/ModelReqRevision.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class DesignReqRevision;
}
namespace Teamcenter
{
    class DesignReqRevisionImpl;
}
namespace Teamcenter
{
    class DesignReqRevisionDelegate;
}
namespace Teamcenter
{
    class DesignReqRevisionDispatch;
}
namespace Teamcenter
{
    class DesignReqRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VALIDATION_API  Teamcenter::DesignReqRevision
     : public  ::Teamcenter::ModelReqRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    DesignReqRevision();

    /**
     * Destructor
     */
    virtual ~DesignReqRevision();

private:
    //  Getter method for the Implementation Object
    DesignReqRevisionImpl*  getDesignReqRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setDesignReqRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    DesignReqRevisionImpl*  m_designreqrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param DesignReqRevision - desc for DesignReqRevision parameter
     */
    DesignReqRevision( const DesignReqRevision& );
    DesignReqRevision& operator=( const DesignReqRevision& );

    friend class  DesignReqRevisionDelegate;
    friend class  DesignReqRevisionDispatch;
    friend class  DesignReqRevisionGenImpl;
};

#include <validation/libvalidation_undef.h>
#endif //   TEAMCENTER__DESIGNREQREVISION__HXX
