//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, DesignReqRevisionDelegate
    Filename:   DesignReqRevisionDelegate.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__DESIGNREQREVISIONDELEGATE_HXX
#define TEAMCENTER__DESIGNREQREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <validation/DesignReqRevision.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class DesignReqRevisionDelegate;
}
namespace Teamcenter
{
    class DesignReqRevisionImpl;
}
namespace Teamcenter
{
    class DesignReqRevision;
}
namespace Teamcenter
{
    class DesignReqRevisionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  VALIDATION_API Teamcenter_alias::DesignReqRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the DesignReqRevisionDelegate instance
    static DesignReqRevisionDelegate&  getInstance();

    //  Method to create the DesignReqRevisionImpl pointer
    static DesignReqRevisionImpl*  createImpl( DesignReqRevision&  ifObj );

    //  Method to delete the DesignReqRevisionImpl pointer
    static void deleteImpl( DesignReqRevisionImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0_req_expression_strBase(const DesignReqRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0_req_expression_strBase(DesignReqRevision &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static DesignReqRevisionDelegate*  m_pInstance;

    DesignReqRevisionDelegate();
    virtual ~DesignReqRevisionDelegate();
    static void setInstance( DesignReqRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::DesignReqRevisionGenImpl;

};

#include <validation/libvalidation_undef.h>
#endif  //  TEAMCENTER__DESIGNREQREVISIONDELEGATE_HXX
