//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ModelReqBOMLine
    Filename:   Fnd0ModelReqBOMLine.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0MODELREQBOMLINE__HXX
#define TEAMCENTER__FND0MODELREQBOMLINE__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <req/Fnd0RequirementBOMLine.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class Fnd0ModelReqBOMLine;
}
namespace Teamcenter
{
    class Fnd0ModelReqBOMLineImpl;
}
namespace Teamcenter
{
    class Fnd0ModelReqBOMLineDelegate;
}
namespace Teamcenter
{
    class Fnd0ModelReqBOMLineDispatch;
}
namespace Teamcenter
{
    class Fnd0ModelReqBOMLineGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VALIDATION_API  Teamcenter::Fnd0ModelReqBOMLine
     : public  ::Teamcenter::Fnd0RequirementBOMLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0bl_req_expression_str( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0bl_req_expression_str( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0ModelReqBOMLine();

    /**
     * Destructor
     */
    virtual ~Fnd0ModelReqBOMLine();

private:
    //  Getter method for the Implementation Object
    Fnd0ModelReqBOMLineImpl*  getFnd0ModelReqBOMLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0ModelReqBOMLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0ModelReqBOMLineImpl*  m_fnd0modelreqbomlineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0ModelReqBOMLine - desc for Fnd0ModelReqBOMLine parameter
     */
    Fnd0ModelReqBOMLine( const Fnd0ModelReqBOMLine& );
    Fnd0ModelReqBOMLine& operator=( const Fnd0ModelReqBOMLine& );

    friend class  Fnd0ModelReqBOMLineDelegate;
    friend class  Fnd0ModelReqBOMLineDispatch;
    friend class  Fnd0ModelReqBOMLineGenImpl;
};

#include <validation/libvalidation_undef.h>
#endif //   TEAMCENTER__FND0MODELREQBOMLINE__HXX
