//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0NXCMValDataResult
    Filename:   Fnd0NXCMValDataResult.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0NXCMVALDATARESULT__HXX
#define TEAMCENTER__FND0NXCMVALDATARESULT__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <validation/Fnd0NXValDataResult.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class Fnd0NXCMValDataResult;
}
namespace Teamcenter
{
    class Fnd0NXCMValDataResultImpl;
}
namespace Teamcenter
{
    class Fnd0NXCMValDataResultDelegate;
}
namespace Teamcenter
{
    class Fnd0NXCMValDataResultDispatch;
}
namespace Teamcenter
{
    class Fnd0NXCMValDataResultGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VALIDATION_API  Teamcenter::Fnd0NXCMValDataResult
     : public  ::Teamcenter::Fnd0NXValDataResult
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0parent_valdata_names( std::vector< std::string > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 10.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0parent_valdata_names( const std::vector< std::string > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0NXCMValDataResult();

    /**
     * Destructor
     */
    virtual ~Fnd0NXCMValDataResult();

private:
    //  Getter method for the Implementation Object
    Fnd0NXCMValDataResultImpl*  getFnd0NXCMValDataResultImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0NXCMValDataResultImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0NXCMValDataResultImpl*  m_fnd0nxcmvaldataresultImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0NXCMValDataResult - desc for Fnd0NXCMValDataResult parameter
     */
    Fnd0NXCMValDataResult( const Fnd0NXCMValDataResult& );
    Fnd0NXCMValDataResult& operator=( const Fnd0NXCMValDataResult& );

    friend class  Fnd0NXCMValDataResultDelegate;
    friend class  Fnd0NXCMValDataResultDispatch;
    friend class  Fnd0NXCMValDataResultGenImpl;
};

#include <validation/libvalidation_undef.h>
#endif //   TEAMCENTER__FND0NXCMVALDATARESULT__HXX
