//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0NXCMValDataResultDelegate
    Filename:   Fnd0NXCMValDataResultDelegate.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0NXCMVALDATARESULTDELEGATE_HXX
#define TEAMCENTER__FND0NXCMVALDATARESULTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <validation/Fnd0NXCMValDataResult.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class Fnd0NXCMValDataResultDelegate;
}
namespace Teamcenter
{
    class Fnd0NXCMValDataResultImpl;
}
namespace Teamcenter
{
    class Fnd0NXCMValDataResult;
}
namespace Teamcenter
{
    class Fnd0NXCMValDataResultGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  VALIDATION_API Teamcenter_alias::Fnd0NXCMValDataResultDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0NXCMValDataResultDelegate instance
    static Fnd0NXCMValDataResultDelegate&  getInstance();

    //  Method to create the Fnd0NXCMValDataResultImpl pointer
    static Fnd0NXCMValDataResultImpl*  createImpl( Fnd0NXCMValDataResult&  ifObj );

    //  Method to delete the Fnd0NXCMValDataResultImpl pointer
    static void deleteImpl( Fnd0NXCMValDataResultImpl*  impl );


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0parent_valdata_namesBase(const Fnd0NXCMValDataResult &ifObj,  std::vector< std::string > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 10.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0parent_valdata_namesBase(Fnd0NXCMValDataResult &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// perform deep copy
    /// @version Teamcenter 9
    /// @param pOperationInput - desc
    /// @param vecDeepCopyData - deep copy data
    /// @return - returns an int
    ///
    int  performDeepCopyBase(const Fnd0NXCMValDataResult &ifObj,  ::Teamcenter::OperationInput *pOperationInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// Generic saveAsPost operation.
    /// @version Teamcenter 8.1
    /// @param pSavAsInput - Input argument as SaveAsInput object.
    /// @param vecDeepCopyData - vector deepcopy data
    /// @return - Return integer value.
    ///
    int  saveAsPostBase(const Fnd0NXCMValDataResult &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const Fnd0NXCMValDataResult &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// setproperties from saveas input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @return - returns an int
    ///
    int  setPropertiesFromSaveAsInputBase(const Fnd0NXCMValDataResult &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput );



protected:
    //  Pointer to the instance
    static Fnd0NXCMValDataResultDelegate*  m_pInstance;

    Fnd0NXCMValDataResultDelegate();
    virtual ~Fnd0NXCMValDataResultDelegate();
    static void setInstance( Fnd0NXCMValDataResultDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0NXCMValDataResultGenImpl;

};

#include <validation/libvalidation_undef.h>
#endif  //  TEAMCENTER__FND0NXCMVALDATARESULTDELEGATE_HXX
