//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0NXPartTable
    Filename:   Fnd0NXPartTable.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0NXPARTTABLE__HXX
#define TEAMCENTER__FND0NXPARTTABLE__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class Fnd0NXPartTable;
}
namespace Teamcenter
{
    class Fnd0NXPartTableImpl;
}
namespace Teamcenter
{
    class Fnd0NXPartTableDelegate;
}
namespace Teamcenter
{
    class Fnd0NXPartTableDispatch;
}
namespace Teamcenter
{
    class Fnd0NXPartTableGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VALIDATION_API  Teamcenter::Fnd0NXPartTable
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 10.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0part_type_data( const std::vector< std::string > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0NXPartTable();

    /**
     * Destructor
     */
    virtual ~Fnd0NXPartTable();

private:
    //  Getter method for the Implementation Object
    Fnd0NXPartTableImpl*  getFnd0NXPartTableImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0NXPartTableImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0NXPartTableImpl*  m_fnd0nxparttableImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0NXPartTable - desc for Fnd0NXPartTable parameter
     */
    Fnd0NXPartTable( const Fnd0NXPartTable& );
    Fnd0NXPartTable& operator=( const Fnd0NXPartTable& );

    friend class  Fnd0NXPartTableDelegate;
    friend class  Fnd0NXPartTableDispatch;
    friend class  Fnd0NXPartTableGenImpl;
};

#include <validation/libvalidation_undef.h>
#endif //   TEAMCENTER__FND0NXPARTTABLE__HXX
