//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0NXPartTableDelegate
    Filename:   Fnd0NXPartTableDelegate.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0NXPARTTABLEDELEGATE_HXX
#define TEAMCENTER__FND0NXPARTTABLEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <validation/Fnd0NXPartTable.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class Fnd0NXPartTableDelegate;
}
namespace Teamcenter
{
    class Fnd0NXPartTableImpl;
}
namespace Teamcenter
{
    class Fnd0NXPartTable;
}
namespace Teamcenter
{
    class Fnd0NXPartTableGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  VALIDATION_API Teamcenter_alias::Fnd0NXPartTableDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0NXPartTableDelegate instance
    static Fnd0NXPartTableDelegate&  getInstance();

    //  Method to create the Fnd0NXPartTableImpl pointer
    static Fnd0NXPartTableImpl*  createImpl( Fnd0NXPartTable&  ifObj );

    //  Method to delete the Fnd0NXPartTableImpl pointer
    static void deleteImpl( Fnd0NXPartTableImpl*  impl );


    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 10.1
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0part_type_dataBase(Fnd0NXPartTable &ifObj,  const std::vector< std::string > &values, const std::vector< int > *isNull );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @param isLockForDelete - A boolean to indicate if object(s) are to be locked for deletion
    /// @param allowRelock - A boolean to indicate if object(s) can be relocked, which will discard all unsaved changes, if already locked by the same user
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0LockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd, const bool isLockForDelete, const bool allowRelock );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Fnd0NXPartTable &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Fnd0NXPartTableDelegate*  m_pInstance;

    Fnd0NXPartTableDelegate();
    virtual ~Fnd0NXPartTableDelegate();
    static void setInstance( Fnd0NXPartTableDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0NXPartTableGenImpl;

};

#include <validation/libvalidation_undef.h>
#endif  //  TEAMCENTER__FND0NXPARTTABLEDELEGATE_HXX
