//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0NXValDataResult
    Filename:   Fnd0NXValDataResult.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0NXVALDATARESULT__HXX
#define TEAMCENTER__FND0NXVALDATARESULT__HXX

#include <common/tc_deprecation_macros.h>
#include <validation/Fnd0ValDataResult.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class Fnd0NXValDataResult;
}
namespace Teamcenter
{
    class Fnd0NXValDataResultImpl;
}
namespace Teamcenter
{
    class Fnd0NXValDataResultDelegate;
}
namespace Teamcenter
{
    class Fnd0NXValDataResultDispatch;
}
namespace Teamcenter
{
    class Fnd0NXValDataResultGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VALIDATION_API  Teamcenter::Fnd0NXValDataResult
     : public  ::Teamcenter::Fnd0ValDataResult
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0NXValDataResult();

    /**
     * Destructor
     */
    virtual ~Fnd0NXValDataResult();

private:
    //  Getter method for the Implementation Object
    Fnd0NXValDataResultImpl*  getFnd0NXValDataResultImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0NXValDataResultImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0NXValDataResultImpl*  m_fnd0nxvaldataresultImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0NXValDataResult - desc for Fnd0NXValDataResult parameter
     */
    Fnd0NXValDataResult( const Fnd0NXValDataResult& );
    Fnd0NXValDataResult& operator=( const Fnd0NXValDataResult& );

    friend class  Fnd0NXValDataResultDelegate;
    friend class  Fnd0NXValDataResultDispatch;
    friend class  Fnd0NXValDataResultGenImpl;
};

#include <validation/libvalidation_undef.h>
#endif //   TEAMCENTER__FND0NXVALDATARESULT__HXX
