//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0NXValDataResultDelegate
    Filename:   Fnd0NXValDataResultDelegate.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0NXVALDATARESULTDELEGATE_HXX
#define TEAMCENTER__FND0NXVALDATARESULTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <validation/Fnd0NXValDataResult.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class Fnd0NXValDataResultDelegate;
}
namespace Teamcenter
{
    class Fnd0NXValDataResultImpl;
}
namespace Teamcenter
{
    class Fnd0NXValDataResult;
}
namespace Teamcenter
{
    class Fnd0NXValDataResultGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  VALIDATION_API Teamcenter_alias::Fnd0NXValDataResultDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0NXValDataResultDelegate instance
    static Fnd0NXValDataResultDelegate&  getInstance();

    //  Method to create the Fnd0NXValDataResultImpl pointer
    static Fnd0NXValDataResultImpl*  createImpl( Fnd0NXValDataResult&  ifObj );

    //  Method to delete the Fnd0NXValDataResultImpl pointer
    static void deleteImpl( Fnd0NXValDataResultImpl*  impl );


    ///
    /// perform deep copy
    /// @version Teamcenter 9
    /// @param pOperationInput - desc
    /// @param vecDeepCopyData - deep copy data
    /// @return - returns an int
    ///
    int  performDeepCopyBase(const Fnd0NXValDataResult &ifObj,  ::Teamcenter::OperationInput *pOperationInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// Generic saveAsPost operation.
    /// @version Teamcenter 8.1
    /// @param pSavAsInput - Input argument as SaveAsInput object.
    /// @param vecDeepCopyData - vector deepcopy data
    /// @return - Return integer value.
    ///
    int  saveAsPostBase(const Fnd0NXValDataResult &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const Fnd0NXValDataResult &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// setproperties from saveas input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @return - returns an int
    ///
    int  setPropertiesFromSaveAsInputBase(const Fnd0NXValDataResult &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Fnd0NXValDataResult &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Fnd0NXValDataResultDelegate*  m_pInstance;

    Fnd0NXValDataResultDelegate();
    virtual ~Fnd0NXValDataResultDelegate();
    static void setInstance( Fnd0NXValDataResultDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0NXValDataResultGenImpl;

};

#include <validation/libvalidation_undef.h>
#endif  //  TEAMCENTER__FND0NXVALDATARESULTDELEGATE_HXX
