//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0TC_valdata_result
    Filename:   Fnd0TC_valdata_result.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0TC_VALDATA_RESULT__HXX
#define TEAMCENTER__FND0TC_VALDATA_RESULT__HXX

#include <common/tc_deprecation_macros.h>
#include <validation/TC_Validation.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class Fnd0TC_valdata_result;
}
namespace Teamcenter
{
    class Fnd0TC_valdata_resultImpl;
}
namespace Teamcenter
{
    class Fnd0TC_valdata_resultDelegate;
}
namespace Teamcenter
{
    class Fnd0TC_valdata_resultDispatch;
}
namespace Teamcenter
{
    class Fnd0TC_valdata_resultGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VALIDATION_API  Teamcenter::Fnd0TC_valdata_result
     : public  ::Teamcenter::TC_Validation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0TC_valdata_result();

    /**
     * Destructor
     */
    virtual ~Fnd0TC_valdata_result();

private:
    //  Getter method for the Implementation Object
    Fnd0TC_valdata_resultImpl*  getFnd0TC_valdata_resultImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0TC_valdata_resultImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0TC_valdata_resultImpl*  m_fnd0tc_valdata_resultImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0TC_valdata_result - desc for Fnd0TC_valdata_result parameter
     */
    Fnd0TC_valdata_result( const Fnd0TC_valdata_result& );
    Fnd0TC_valdata_result& operator=( const Fnd0TC_valdata_result& );

    friend class  Fnd0TC_valdata_resultDelegate;
    friend class  Fnd0TC_valdata_resultDispatch;
    friend class  Fnd0TC_valdata_resultGenImpl;
};

#include <validation/libvalidation_undef.h>
#endif //   TEAMCENTER__FND0TC_VALDATA_RESULT__HXX
