//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0TC_valdata_resultDelegate
    Filename:   Fnd0TC_valdata_resultDelegate.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0TC_VALDATA_RESULTDELEGATE_HXX
#define TEAMCENTER__FND0TC_VALDATA_RESULTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <validation/Fnd0TC_valdata_result.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class Fnd0TC_valdata_resultDelegate;
}
namespace Teamcenter
{
    class Fnd0TC_valdata_resultImpl;
}
namespace Teamcenter
{
    class Fnd0TC_valdata_result;
}
namespace Teamcenter
{
    class Fnd0TC_valdata_resultGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  VALIDATION_API Teamcenter_alias::Fnd0TC_valdata_resultDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0TC_valdata_resultDelegate instance
    static Fnd0TC_valdata_resultDelegate&  getInstance();

    //  Method to create the Fnd0TC_valdata_resultImpl pointer
    static Fnd0TC_valdata_resultImpl*  createImpl( Fnd0TC_valdata_result&  ifObj );

    //  Method to delete the Fnd0TC_valdata_resultImpl pointer
    static void deleteImpl( Fnd0TC_valdata_resultImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const Fnd0TC_valdata_result &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static Fnd0TC_valdata_resultDelegate*  m_pInstance;

    Fnd0TC_valdata_resultDelegate();
    virtual ~Fnd0TC_valdata_resultDelegate();
    static void setInstance( Fnd0TC_valdata_resultDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0TC_valdata_resultGenImpl;

};

#include <validation/libvalidation_undef.h>
#endif  //  TEAMCENTER__FND0TC_VALDATA_RESULTDELEGATE_HXX
