//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ValidationHome
    Filename:   Fnd0ValidationHome.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0VALIDATIONHOME__HXX
#define TEAMCENTER__FND0VALIDATIONHOME__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tc/Folder.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class Fnd0ValidationHome;
}
namespace Teamcenter
{
    class Fnd0ValidationHomeImpl;
}
namespace Teamcenter
{
    class Fnd0ValidationHomeDelegate;
}
namespace Teamcenter
{
    class Fnd0ValidationHomeDispatch;
}
namespace Teamcenter
{
    class Fnd0ValidationHomeGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VALIDATION_API  Teamcenter::Fnd0ValidationHome
     : public  ::Teamcenter::Folder
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0override_approvers( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0ValidationHome();

    /**
     * Destructor
     */
    virtual ~Fnd0ValidationHome();

private:
    //  Getter method for the Implementation Object
    Fnd0ValidationHomeImpl*  getFnd0ValidationHomeImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0ValidationHomeImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0ValidationHomeImpl*  m_fnd0validationhomeImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0ValidationHome - desc for Fnd0ValidationHome parameter
     */
    Fnd0ValidationHome( const Fnd0ValidationHome& );
    Fnd0ValidationHome& operator=( const Fnd0ValidationHome& );

    friend class  Fnd0ValidationHomeDelegate;
    friend class  Fnd0ValidationHomeDispatch;
    friend class  Fnd0ValidationHomeGenImpl;
};

#include <validation/libvalidation_undef.h>
#endif //   TEAMCENTER__FND0VALIDATIONHOME__HXX
