//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ValidationHomeDelegate
    Filename:   Fnd0ValidationHomeDelegate.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0VALIDATIONHOMEDELEGATE_HXX
#define TEAMCENTER__FND0VALIDATIONHOMEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <validation/Fnd0ValidationHome.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class Fnd0ValidationHomeDelegate;
}
namespace Teamcenter
{
    class Fnd0ValidationHomeImpl;
}
namespace Teamcenter
{
    class Fnd0ValidationHome;
}
namespace Teamcenter
{
    class Fnd0ValidationHomeGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  VALIDATION_API Teamcenter_alias::Fnd0ValidationHomeDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0ValidationHomeDelegate instance
    static Fnd0ValidationHomeDelegate&  getInstance();

    //  Method to create the Fnd0ValidationHomeImpl pointer
    static Fnd0ValidationHomeImpl*  createImpl( Fnd0ValidationHome&  ifObj );

    //  Method to delete the Fnd0ValidationHomeImpl pointer
    static void deleteImpl( Fnd0ValidationHomeImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 10.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0override_approversBase(const Fnd0ValidationHome &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// perform deep copy
    /// @version Teamcenter 9
    /// @param pOperationInput - desc
    /// @param vecDeepCopyData - deep copy data
    /// @return - returns an int
    ///
    int  performDeepCopyBase(const Fnd0ValidationHome &ifObj,  ::Teamcenter::OperationInput *pOperationInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @param isLockForDelete - A boolean to indicate if object(s) are to be locked for deletion
    /// @param allowRelock - A boolean to indicate if object(s) can be relocked, which will discard all unsaved changes, if already locked by the same user
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0LockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd, const bool isLockForDelete, const bool allowRelock );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0RefreshBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static Fnd0ValidationHomeDelegate*  m_pInstance;

    Fnd0ValidationHomeDelegate();
    virtual ~Fnd0ValidationHomeDelegate();
    static void setInstance( Fnd0ValidationHomeDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0ValidationHomeGenImpl;

};

#include <validation/libvalidation_undef.h>
#endif  //  TEAMCENTER__FND0VALIDATIONHOMEDELEGATE_HXX
