//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0ValidationReqBOMLine
    Filename:   Fnd0ValidationReqBOMLine.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0VALIDATIONREQBOMLINE__HXX
#define TEAMCENTER__FND0VALIDATIONREQBOMLINE__HXX

#include <common/tc_deprecation_macros.h>
#include <validation/Fnd0ModelReqBOMLine.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class Fnd0ValidationReqBOMLine;
}
namespace Teamcenter
{
    class Fnd0ValidationReqBOMLineImpl;
}
namespace Teamcenter
{
    class Fnd0ValidationReqBOMLineDelegate;
}
namespace Teamcenter
{
    class Fnd0ValidationReqBOMLineDispatch;
}
namespace Teamcenter
{
    class Fnd0ValidationReqBOMLineGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VALIDATION_API  Teamcenter::Fnd0ValidationReqBOMLine
     : public  ::Teamcenter::Fnd0ModelReqBOMLine
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0ValidationReqBOMLine();

    /**
     * Destructor
     */
    virtual ~Fnd0ValidationReqBOMLine();

private:
    //  Getter method for the Implementation Object
    Fnd0ValidationReqBOMLineImpl*  getFnd0ValidationReqBOMLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0ValidationReqBOMLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0ValidationReqBOMLineImpl*  m_fnd0validationreqbomlineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0ValidationReqBOMLine - desc for Fnd0ValidationReqBOMLine parameter
     */
    Fnd0ValidationReqBOMLine( const Fnd0ValidationReqBOMLine& );
    Fnd0ValidationReqBOMLine& operator=( const Fnd0ValidationReqBOMLine& );

    friend class  Fnd0ValidationReqBOMLineDelegate;
    friend class  Fnd0ValidationReqBOMLineDispatch;
    friend class  Fnd0ValidationReqBOMLineGenImpl;
};

#include <validation/libvalidation_undef.h>
#endif //   TEAMCENTER__FND0VALIDATIONREQBOMLINE__HXX
