//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ModelReq
    Filename:   ModelReq.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MODELREQ__HXX
#define TEAMCENTER__MODELREQ__HXX

#include <common/tc_deprecation_macros.h>
#include <req/Requirement.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class ModelReq;
}
namespace Teamcenter
{
    class ModelReqImpl;
}
namespace Teamcenter
{
    class ModelReqDelegate;
}
namespace Teamcenter
{
    class ModelReqDispatch;
}
namespace Teamcenter
{
    class ModelReqGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VALIDATION_API  Teamcenter::ModelReq
     : public  ::Teamcenter::Requirement
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ModelReq();

    /**
     * Destructor
     */
    virtual ~ModelReq();

private:
    //  Getter method for the Implementation Object
    ModelReqImpl*  getModelReqImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setModelReqImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ModelReqImpl*  m_modelreqImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ModelReq - desc for ModelReq parameter
     */
    ModelReq( const ModelReq& );
    ModelReq& operator=( const ModelReq& );

    friend class  ModelReqDelegate;
    friend class  ModelReqDispatch;
    friend class  ModelReqGenImpl;
};

#include <validation/libvalidation_undef.h>
#endif //   TEAMCENTER__MODELREQ__HXX
