//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ModelReqRevisionDelegate
    Filename:   ModelReqRevisionDelegate.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MODELREQREVISIONDELEGATE_HXX
#define TEAMCENTER__MODELREQREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <validation/ModelReqRevision.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class ModelReqRevisionDelegate;
}
namespace Teamcenter
{
    class ModelReqRevisionImpl;
}
namespace Teamcenter
{
    class ModelReqRevision;
}
namespace Teamcenter
{
    class ModelReqRevisionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  VALIDATION_API Teamcenter_alias::ModelReqRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ModelReqRevisionDelegate instance
    static ModelReqRevisionDelegate&  getInstance();

    //  Method to create the ModelReqRevisionImpl pointer
    static ModelReqRevisionImpl*  createImpl( ModelReqRevision&  ifObj );

    //  Method to delete the ModelReqRevisionImpl pointer
    static void deleteImpl( ModelReqRevisionImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0_req_expression_strBase(const ModelReqRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Tc 8
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getRequirement_expressionsBase(const ModelReqRevision &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Date Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRequirement_modified_dateBase(const ModelReqRevision &ifObj,  date_t &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0_req_expression_strBase(ModelReqRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Array Property
    /// @version Tc 8
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setRequirement_expressionsBase(ModelReqRevision &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Setter for a Date Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setRequirement_modified_dateBase(ModelReqRevision &ifObj,  const date_t &value, bool isNull );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const ModelReqRevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const ModelReqRevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const ModelReqRevision &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static ModelReqRevisionDelegate*  m_pInstance;

    ModelReqRevisionDelegate();
    virtual ~ModelReqRevisionDelegate();
    static void setInstance( ModelReqRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::ModelReqRevisionGenImpl;

};

#include <validation/libvalidation_undef.h>
#endif  //  TEAMCENTER__MODELREQREVISIONDELEGATE_HXX
