//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, NXAgent
    Filename:   NXAgent.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__NXAGENT__HXX
#define TEAMCENTER__NXAGENT__HXX

#include <common/tc_deprecation_macros.h>
#include <validation/ValToolAgent.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class NXAgent;
}
namespace Teamcenter
{
    class NXAgentImpl;
}
namespace Teamcenter
{
    class NXAgentDelegate;
}
namespace Teamcenter
{
    class NXAgentDispatch;
}
namespace Teamcenter
{
    class NXAgentGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VALIDATION_API  Teamcenter::NXAgent
     : public  ::Teamcenter::ValToolAgent
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    NXAgent();

    /**
     * Destructor
     */
    virtual ~NXAgent();

private:
    //  Getter method for the Implementation Object
    NXAgentImpl*  getNXAgentImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setNXAgentImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    NXAgentImpl*  m_nxagentImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param NXAgent - desc for NXAgent parameter
     */
    NXAgent( const NXAgent& );
    NXAgent& operator=( const NXAgent& );

    friend class  NXAgentDelegate;
    friend class  NXAgentDispatch;
    friend class  NXAgentGenImpl;
};

#include <validation/libvalidation_undef.h>
#endif //   TEAMCENTER__NXAGENT__HXX
