//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, NXAgentRevision
    Filename:   NXAgentRevision.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__NXAGENTREVISION__HXX
#define TEAMCENTER__NXAGENTREVISION__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <validation/ValToolAgentRevision.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class NXAgentRevision;
}
namespace Teamcenter
{
    class NXAgentRevisionImpl;
}
namespace Teamcenter
{
    class NXAgentRevisionDelegate;
}
namespace Teamcenter
{
    class NXAgentRevisionDispatch;
}
namespace Teamcenter
{
    class NXAgentRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VALIDATION_API  Teamcenter::NXAgentRevision
     : public  ::Teamcenter::ValToolAgentRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValidation_closure_rule( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValidation_closure_rule( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    NXAgentRevision();

    /**
     * Destructor
     */
    virtual ~NXAgentRevision();

private:
    //  Getter method for the Implementation Object
    NXAgentRevisionImpl*  getNXAgentRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setNXAgentRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    NXAgentRevisionImpl*  m_nxagentrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param NXAgentRevision - desc for NXAgentRevision parameter
     */
    NXAgentRevision( const NXAgentRevision& );
    NXAgentRevision& operator=( const NXAgentRevision& );

    friend class  NXAgentRevisionDelegate;
    friend class  NXAgentRevisionDispatch;
    friend class  NXAgentRevisionGenImpl;
};

#include <validation/libvalidation_undef.h>
#endif //   TEAMCENTER__NXAGENTREVISION__HXX
