//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, NXCMValData
    Filename:   NXCMValData.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__NXCMVALDATA__HXX
#define TEAMCENTER__NXCMVALDATA__HXX

#include <common/tc_deprecation_macros.h>
#include <validation/NXValData.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class NXCMValData;
}
namespace Teamcenter
{
    class NXCMValDataImpl;
}
namespace Teamcenter
{
    class NXCMValDataDelegate;
}
namespace Teamcenter
{
    class NXCMValDataDispatch;
}
namespace Teamcenter
{
    class NXCMValDataGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VALIDATION_API  Teamcenter::NXCMValData
     : public  ::Teamcenter::NXValData
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    NXCMValData();

    /**
     * Destructor
     */
    virtual ~NXCMValData();

private:
    //  Getter method for the Implementation Object
    NXCMValDataImpl*  getNXCMValDataImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setNXCMValDataImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    NXCMValDataImpl*  m_nxcmvaldataImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param NXCMValData - desc for NXCMValData parameter
     */
    NXCMValData( const NXCMValData& );
    NXCMValData& operator=( const NXCMValData& );

    friend class  NXCMValDataDelegate;
    friend class  NXCMValDataDispatch;
    friend class  NXCMValDataGenImpl;
};

#include <validation/libvalidation_undef.h>
#endif //   TEAMCENTER__NXCMVALDATA__HXX
