//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, NXCMValDataDelegate
    Filename:   NXCMValDataDelegate.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__NXCMVALDATADELEGATE_HXX
#define TEAMCENTER__NXCMVALDATADELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <validation/NXCMValData.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class NXCMValDataDelegate;
}
namespace Teamcenter
{
    class NXCMValDataImpl;
}
namespace Teamcenter
{
    class NXCMValData;
}
namespace Teamcenter
{
    class NXCMValDataGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  VALIDATION_API Teamcenter_alias::NXCMValDataDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the NXCMValDataDelegate instance
    static NXCMValDataDelegate&  getInstance();

    //  Method to create the NXCMValDataImpl pointer
    static NXCMValDataImpl*  createImpl( NXCMValData&  ifObj );

    //  Method to delete the NXCMValDataImpl pointer
    static void deleteImpl( NXCMValDataImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const NXCMValData &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const NXCMValData &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const NXCMValData &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const NXCMValData &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static NXCMValDataDelegate*  m_pInstance;

    NXCMValDataDelegate();
    virtual ~NXCMValDataDelegate();
    static void setInstance( NXCMValDataDelegate*  instance );


private:
    friend class  ::Teamcenter::NXCMValDataGenImpl;

};

#include <validation/libvalidation_undef.h>
#endif  //  TEAMCENTER__NXCMVALDATADELEGATE_HXX
