//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, NXCheckMate
    Filename:   NXCheckMate.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__NXCHECKMATE__HXX
#define TEAMCENTER__NXCHECKMATE__HXX

#include <common/tc_deprecation_macros.h>
#include <validation/NXAgent.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class NXCheckMate;
}
namespace Teamcenter
{
    class NXCheckMateImpl;
}
namespace Teamcenter
{
    class NXCheckMateDelegate;
}
namespace Teamcenter
{
    class NXCheckMateDispatch;
}
namespace Teamcenter
{
    class NXCheckMateGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VALIDATION_API  Teamcenter::NXCheckMate
     : public  ::Teamcenter::NXAgent
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    NXCheckMate();

    /**
     * Destructor
     */
    virtual ~NXCheckMate();

private:
    //  Getter method for the Implementation Object
    NXCheckMateImpl*  getNXCheckMateImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setNXCheckMateImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    NXCheckMateImpl*  m_nxcheckmateImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param NXCheckMate - desc for NXCheckMate parameter
     */
    NXCheckMate( const NXCheckMate& );
    NXCheckMate& operator=( const NXCheckMate& );

    friend class  NXCheckMateDelegate;
    friend class  NXCheckMateDispatch;
    friend class  NXCheckMateGenImpl;
};

#include <validation/libvalidation_undef.h>
#endif //   TEAMCENTER__NXCHECKMATE__HXX
