//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, NXCheckMateDelegate
    Filename:   NXCheckMateDelegate.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__NXCHECKMATEDELEGATE_HXX
#define TEAMCENTER__NXCHECKMATEDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <validation/NXCheckMate.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class NXCheckMateDelegate;
}
namespace Teamcenter
{
    class NXCheckMateImpl;
}
namespace Teamcenter
{
    class NXCheckMate;
}
namespace Teamcenter
{
    class NXCheckMateGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  VALIDATION_API Teamcenter_alias::NXCheckMateDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the NXCheckMateDelegate instance
    static NXCheckMateDelegate&  getInstance();

    //  Method to create the NXCheckMateImpl pointer
    static NXCheckMateImpl*  createImpl( NXCheckMate&  ifObj );

    //  Method to delete the NXCheckMateImpl pointer
    static void deleteImpl( NXCheckMateImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const NXCheckMate &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const NXCheckMate &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const NXCheckMate &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const NXCheckMate &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static NXCheckMateDelegate*  m_pInstance;

    NXCheckMateDelegate();
    virtual ~NXCheckMateDelegate();
    static void setInstance( NXCheckMateDelegate*  instance );


private:
    friend class  ::Teamcenter::NXCheckMateGenImpl;

};

#include <validation/libvalidation_undef.h>
#endif  //  TEAMCENTER__NXCHECKMATEDELEGATE_HXX
