//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, NXCheckMateRevision
    Filename:   NXCheckMateRevision.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__NXCHECKMATEREVISION__HXX
#define TEAMCENTER__NXCHECKMATEREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <validation/NXAgentRevision.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class NXCheckMateRevision;
}
namespace Teamcenter
{
    class NXCheckMateRevisionImpl;
}
namespace Teamcenter
{
    class NXCheckMateRevisionDelegate;
}
namespace Teamcenter
{
    class NXCheckMateRevisionDispatch;
}
namespace Teamcenter
{
    class NXCheckMateRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VALIDATION_API  Teamcenter::NXCheckMateRevision
     : public  ::Teamcenter::NXAgentRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    NXCheckMateRevision();

    /**
     * Destructor
     */
    virtual ~NXCheckMateRevision();

private:
    //  Getter method for the Implementation Object
    NXCheckMateRevisionImpl*  getNXCheckMateRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setNXCheckMateRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    NXCheckMateRevisionImpl*  m_nxcheckmaterevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param NXCheckMateRevision - desc for NXCheckMateRevision parameter
     */
    NXCheckMateRevision( const NXCheckMateRevision& );
    NXCheckMateRevision& operator=( const NXCheckMateRevision& );

    friend class  NXCheckMateRevisionDelegate;
    friend class  NXCheckMateRevisionDispatch;
    friend class  NXCheckMateRevisionGenImpl;
};

#include <validation/libvalidation_undef.h>
#endif //   TEAMCENTER__NXCHECKMATEREVISION__HXX
