//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, NXRDDV
    Filename:   NXRDDV.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__NXRDDV__HXX
#define TEAMCENTER__NXRDDV__HXX

#include <common/tc_deprecation_macros.h>
#include <validation/NXAgent.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class NXRDDV;
}
namespace Teamcenter
{
    class NXRDDVImpl;
}
namespace Teamcenter
{
    class NXRDDVDelegate;
}
namespace Teamcenter
{
    class NXRDDVDispatch;
}
namespace Teamcenter
{
    class NXRDDVGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VALIDATION_API  Teamcenter::NXRDDV
     : public  ::Teamcenter::NXAgent
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    NXRDDV();

    /**
     * Destructor
     */
    virtual ~NXRDDV();

private:
    //  Getter method for the Implementation Object
    NXRDDVImpl*  getNXRDDVImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setNXRDDVImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    NXRDDVImpl*  m_nxrddvImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param NXRDDV - desc for NXRDDV parameter
     */
    NXRDDV( const NXRDDV& );
    NXRDDV& operator=( const NXRDDV& );

    friend class  NXRDDVDelegate;
    friend class  NXRDDVDispatch;
    friend class  NXRDDVGenImpl;
};

#include <validation/libvalidation_undef.h>
#endif //   TEAMCENTER__NXRDDV__HXX
