//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, NXRDDVRevision
    Filename:   NXRDDVRevision.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__NXRDDVREVISION__HXX
#define TEAMCENTER__NXRDDVREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <validation/NXAgentRevision.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class NXRDDVRevision;
}
namespace Teamcenter
{
    class NXRDDVRevisionImpl;
}
namespace Teamcenter
{
    class NXRDDVRevisionDelegate;
}
namespace Teamcenter
{
    class NXRDDVRevisionDispatch;
}
namespace Teamcenter
{
    class NXRDDVRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VALIDATION_API  Teamcenter::NXRDDVRevision
     : public  ::Teamcenter::NXAgentRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    NXRDDVRevision();

    /**
     * Destructor
     */
    virtual ~NXRDDVRevision();

private:
    //  Getter method for the Implementation Object
    NXRDDVRevisionImpl*  getNXRDDVRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setNXRDDVRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    NXRDDVRevisionImpl*  m_nxrddvrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param NXRDDVRevision - desc for NXRDDVRevision parameter
     */
    NXRDDVRevision( const NXRDDVRevision& );
    NXRDDVRevision& operator=( const NXRDDVRevision& );

    friend class  NXRDDVRevisionDelegate;
    friend class  NXRDDVRevisionDispatch;
    friend class  NXRDDVRevisionGenImpl;
};

#include <validation/libvalidation_undef.h>
#endif //   TEAMCENTER__NXRDDVREVISION__HXX
