//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, NXRDDVValData
    Filename:   NXRDDVValData.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__NXRDDVVALDATA__HXX
#define TEAMCENTER__NXRDDVVALDATA__HXX

#include <common/tc_deprecation_macros.h>
#include <validation/NXValData.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class NXRDDVValData;
}
namespace Teamcenter
{
    class NXRDDVValDataImpl;
}
namespace Teamcenter
{
    class NXRDDVValDataDelegate;
}
namespace Teamcenter
{
    class NXRDDVValDataDispatch;
}
namespace Teamcenter
{
    class NXRDDVValDataGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VALIDATION_API  Teamcenter::NXRDDVValData
     : public  ::Teamcenter::NXValData
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    NXRDDVValData();

    /**
     * Destructor
     */
    virtual ~NXRDDVValData();

private:
    //  Getter method for the Implementation Object
    NXRDDVValDataImpl*  getNXRDDVValDataImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setNXRDDVValDataImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    NXRDDVValDataImpl*  m_nxrddvvaldataImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param NXRDDVValData - desc for NXRDDVValData parameter
     */
    NXRDDVValData( const NXRDDVValData& );
    NXRDDVValData& operator=( const NXRDDVValData& );

    friend class  NXRDDVValDataDelegate;
    friend class  NXRDDVValDataDispatch;
    friend class  NXRDDVValDataGenImpl;
};

#include <validation/libvalidation_undef.h>
#endif //   TEAMCENTER__NXRDDVVALDATA__HXX
