//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, NXRDDVValDataRevision
    Filename:   NXRDDVValDataRevision.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__NXRDDVVALDATAREVISION__HXX
#define TEAMCENTER__NXRDDVVALDATAREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <validation/NXValDataRevision.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class NXRDDVValDataRevision;
}
namespace Teamcenter
{
    class NXRDDVValDataRevisionImpl;
}
namespace Teamcenter
{
    class NXRDDVValDataRevisionDelegate;
}
namespace Teamcenter
{
    class NXRDDVValDataRevisionDispatch;
}
namespace Teamcenter
{
    class NXRDDVValDataRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VALIDATION_API  Teamcenter::NXRDDVValDataRevision
     : public  ::Teamcenter::NXValDataRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    NXRDDVValDataRevision();

    /**
     * Destructor
     */
    virtual ~NXRDDVValDataRevision();

private:
    //  Getter method for the Implementation Object
    NXRDDVValDataRevisionImpl*  getNXRDDVValDataRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setNXRDDVValDataRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    NXRDDVValDataRevisionImpl*  m_nxrddvvaldatarevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param NXRDDVValDataRevision - desc for NXRDDVValDataRevision parameter
     */
    NXRDDVValDataRevision( const NXRDDVValDataRevision& );
    NXRDDVValDataRevision& operator=( const NXRDDVValDataRevision& );

    friend class  NXRDDVValDataRevisionDelegate;
    friend class  NXRDDVValDataRevisionDispatch;
    friend class  NXRDDVValDataRevisionGenImpl;
};

#include <validation/libvalidation_undef.h>
#endif //   TEAMCENTER__NXRDDVVALDATAREVISION__HXX
