//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, NXRDDVValDataRevisionDelegate
    Filename:   NXRDDVValDataRevisionDelegate.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__NXRDDVVALDATAREVISIONDELEGATE_HXX
#define TEAMCENTER__NXRDDVVALDATAREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <validation/NXRDDVValDataRevision.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class NXRDDVValDataRevisionDelegate;
}
namespace Teamcenter
{
    class NXRDDVValDataRevisionImpl;
}
namespace Teamcenter
{
    class NXRDDVValDataRevision;
}
namespace Teamcenter
{
    class NXRDDVValDataRevisionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  VALIDATION_API Teamcenter_alias::NXRDDVValDataRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the NXRDDVValDataRevisionDelegate instance
    static NXRDDVValDataRevisionDelegate&  getInstance();

    //  Method to create the NXRDDVValDataRevisionImpl pointer
    static NXRDDVValDataRevisionImpl*  createImpl( NXRDDVValDataRevision&  ifObj );

    //  Method to delete the NXRDDVValDataRevisionImpl pointer
    static void deleteImpl( NXRDDVValDataRevisionImpl*  impl );


    ///
    /// Finalize operation input.
    /// @version Teamcenter 10.1
    /// @param pReviseInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns n int.
    ///
    int  finalizeReviseInputBase(const NXRDDVValDataRevision &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const NXRDDVValDataRevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const NXRDDVValDataRevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// finalize operation input
    /// @version Teamcenter 9
    /// @param pSavAsInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - returns an int
    ///
    int  finalizeSaveAsInputBase(const NXRDDVValDataRevision &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const NXRDDVValDataRevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const NXRDDVValDataRevision &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static NXRDDVValDataRevisionDelegate*  m_pInstance;

    NXRDDVValDataRevisionDelegate();
    virtual ~NXRDDVValDataRevisionDelegate();
    static void setInstance( NXRDDVValDataRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::NXRDDVValDataRevisionGenImpl;

};

#include <validation/libvalidation_undef.h>
#endif  //  TEAMCENTER__NXRDDVVALDATAREVISIONDELEGATE_HXX
