//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, NXValData
    Filename:   NXValData.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__NXVALDATA__HXX
#define TEAMCENTER__NXVALDATA__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <validation/ValData.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class NXValData;
}
namespace Teamcenter
{
    class NXValDataImpl;
}
namespace Teamcenter
{
    class NXValDataDelegate;
}
namespace Teamcenter
{
    class NXValDataDispatch;
}
namespace Teamcenter
{
    class NXValDataGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VALIDATION_API  Teamcenter::NXValData
     : public  ::Teamcenter::ValData
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValdata_name( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValdata_name( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    NXValData();

    /**
     * Destructor
     */
    virtual ~NXValData();

private:
    //  Getter method for the Implementation Object
    NXValDataImpl*  getNXValDataImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setNXValDataImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    NXValDataImpl*  m_nxvaldataImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param NXValData - desc for NXValData parameter
     */
    NXValData( const NXValData& );
    NXValData& operator=( const NXValData& );

    friend class  NXValDataDelegate;
    friend class  NXValDataDispatch;
    friend class  NXValDataGenImpl;
};

#include <validation/libvalidation_undef.h>
#endif //   TEAMCENTER__NXVALDATA__HXX
