//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, NXValDataDelegate
    Filename:   NXValDataDelegate.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__NXVALDATADELEGATE_HXX
#define TEAMCENTER__NXVALDATADELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <validation/NXValData.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class NXValDataDelegate;
}
namespace Teamcenter
{
    class NXValDataImpl;
}
namespace Teamcenter
{
    class NXValData;
}
namespace Teamcenter
{
    class NXValDataGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  VALIDATION_API Teamcenter_alias::NXValDataDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the NXValDataDelegate instance
    static NXValDataDelegate&  getInstance();

    //  Method to create the NXValDataImpl pointer
    static NXValDataImpl*  createImpl( NXValData&  ifObj );

    //  Method to delete the NXValDataImpl pointer
    static void deleteImpl( NXValDataImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValdata_nameBase(const NXValData &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValdata_nameBase(NXValData &ifObj,  const std::string &value, bool isNull );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const NXValData &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const NXValData &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const NXValData &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const NXValData &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static NXValDataDelegate*  m_pInstance;

    NXValDataDelegate();
    virtual ~NXValDataDelegate();
    static void setInstance( NXValDataDelegate*  instance );


private:
    friend class  ::Teamcenter::NXValDataGenImpl;

};

#include <validation/libvalidation_undef.h>
#endif  //  TEAMCENTER__NXVALDATADELEGATE_HXX
