//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, NXValDataRevision
    Filename:   NXValDataRevision.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__NXVALDATAREVISION__HXX
#define TEAMCENTER__NXVALDATAREVISION__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <validation/ValDataRevision.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class NXValDataRevision;
}
namespace Teamcenter
{
    class NXValDataRevisionImpl;
}
namespace Teamcenter
{
    class NXValDataRevisionDelegate;
}
namespace Teamcenter
{
    class NXValDataRevisionDispatch;
}
namespace Teamcenter
{
    class NXValDataRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VALIDATION_API  Teamcenter::NXValDataRevision
     : public  ::Teamcenter::ValDataRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIs_mandatory( bool &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValdata_name( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 8.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIs_mandatory( bool value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    NXValDataRevision();

    /**
     * Destructor
     */
    virtual ~NXValDataRevision();

private:
    //  Getter method for the Implementation Object
    NXValDataRevisionImpl*  getNXValDataRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setNXValDataRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    NXValDataRevisionImpl*  m_nxvaldatarevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param NXValDataRevision - desc for NXValDataRevision parameter
     */
    NXValDataRevision( const NXValDataRevision& );
    NXValDataRevision& operator=( const NXValDataRevision& );

    friend class  NXValDataRevisionDelegate;
    friend class  NXValDataRevisionDispatch;
    friend class  NXValDataRevisionGenImpl;
};

#include <validation/libvalidation_undef.h>
#endif //   TEAMCENTER__NXVALDATAREVISION__HXX
