//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, NXValDataRevisionDelegate
    Filename:   NXValDataRevisionDelegate.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__NXVALDATAREVISIONDELEGATE_HXX
#define TEAMCENTER__NXVALDATAREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <validation/NXValDataRevision.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class NXValDataRevisionDelegate;
}
namespace Teamcenter
{
    class NXValDataRevisionImpl;
}
namespace Teamcenter
{
    class NXValDataRevision;
}
namespace Teamcenter
{
    class NXValDataRevisionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  VALIDATION_API Teamcenter_alias::NXValDataRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the NXValDataRevisionDelegate instance
    static NXValDataRevisionDelegate&  getInstance();

    //  Method to create the NXValDataRevisionImpl pointer
    static NXValDataRevisionImpl*  createImpl( NXValDataRevision&  ifObj );

    //  Method to delete the NXValDataRevisionImpl pointer
    static void deleteImpl( NXValDataRevisionImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIs_mandatoryBase(const NXValDataRevision &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValdata_nameBase(const NXValDataRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 8.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIs_mandatoryBase(NXValDataRevision &ifObj,  bool value, bool isNull );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const NXValDataRevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const NXValDataRevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const NXValDataRevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const NXValDataRevision &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static NXValDataRevisionDelegate*  m_pInstance;

    NXValDataRevisionDelegate();
    virtual ~NXValDataRevisionDelegate();
    static void setInstance( NXValDataRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::NXValDataRevisionGenImpl;

};

#include <validation/libvalidation_undef.h>
#endif  //  TEAMCENTER__NXVALDATAREVISIONDELEGATE_HXX
