//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ReqBooleanExp
    Filename:   ReqBooleanExp.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REQBOOLEANEXP__HXX
#define TEAMCENTER__REQBOOLEANEXP__HXX

#include <common/tc_deprecation_macros.h>
#include <validation/ReqExpression.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class ReqBooleanExp;
}
namespace Teamcenter
{
    class ReqBooleanExpImpl;
}
namespace Teamcenter
{
    class ReqBooleanExpDelegate;
}
namespace Teamcenter
{
    class ReqBooleanExpDispatch;
}
namespace Teamcenter
{
    class ReqBooleanExpGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VALIDATION_API  Teamcenter::ReqBooleanExp
     : public  ::Teamcenter::ReqExpression
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Boolean Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValue( bool &value, bool &isNull ) const;

    ///
    /// Setter for a Boolean Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValue( bool value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ReqBooleanExp();

    /**
     * Destructor
     */
    virtual ~ReqBooleanExp();

private:
    //  Getter method for the Implementation Object
    ReqBooleanExpImpl*  getReqBooleanExpImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setReqBooleanExpImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ReqBooleanExpImpl*  m_reqbooleanexpImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ReqBooleanExp - desc for ReqBooleanExp parameter
     */
    ReqBooleanExp( const ReqBooleanExp& );
    ReqBooleanExp& operator=( const ReqBooleanExp& );

    friend class  ReqBooleanExpDelegate;
    friend class  ReqBooleanExpDispatch;
    friend class  ReqBooleanExpGenImpl;
};

#include <validation/libvalidation_undef.h>
#endif //   TEAMCENTER__REQBOOLEANEXP__HXX
