//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ReqBooleanExpDelegate
    Filename:   ReqBooleanExpDelegate.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REQBOOLEANEXPDELEGATE_HXX
#define TEAMCENTER__REQBOOLEANEXPDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <validation/ReqBooleanExp.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class ReqBooleanExpDelegate;
}
namespace Teamcenter
{
    class ReqBooleanExpImpl;
}
namespace Teamcenter
{
    class ReqBooleanExp;
}
namespace Teamcenter
{
    class ReqBooleanExpGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  VALIDATION_API Teamcenter_alias::ReqBooleanExpDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ReqBooleanExpDelegate instance
    static ReqBooleanExpDelegate&  getInstance();

    //  Method to create the ReqBooleanExpImpl pointer
    static ReqBooleanExpImpl*  createImpl( ReqBooleanExp&  ifObj );

    //  Method to delete the ReqBooleanExpImpl pointer
    static void deleteImpl( ReqBooleanExpImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValueBase(const ReqBooleanExp &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Setter for a Boolean Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValueBase(ReqBooleanExp &ifObj,  bool value, bool isNull );



protected:
    //  Pointer to the instance
    static ReqBooleanExpDelegate*  m_pInstance;

    ReqBooleanExpDelegate();
    virtual ~ReqBooleanExpDelegate();
    static void setInstance( ReqBooleanExpDelegate*  instance );


private:
    friend class  ::Teamcenter::ReqBooleanExpGenImpl;

};

#include <validation/libvalidation_undef.h>
#endif  //  TEAMCENTER__REQBOOLEANEXPDELEGATE_HXX
