//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ReqDoubleExp
    Filename:   ReqDoubleExp.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REQDOUBLEEXP__HXX
#define TEAMCENTER__REQDOUBLEEXP__HXX

#include <common/tc_deprecation_macros.h>
#include <validation/ReqNumberExp.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class ReqDoubleExp;
}
namespace Teamcenter
{
    class ReqDoubleExpImpl;
}
namespace Teamcenter
{
    class ReqDoubleExpDelegate;
}
namespace Teamcenter
{
    class ReqDoubleExpDispatch;
}
namespace Teamcenter
{
    class ReqDoubleExpGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VALIDATION_API  Teamcenter::ReqDoubleExp
     : public  ::Teamcenter::ReqNumberExp
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValue( double &value, bool &isNull ) const;

    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValue( double value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ReqDoubleExp();

    /**
     * Destructor
     */
    virtual ~ReqDoubleExp();

private:
    //  Getter method for the Implementation Object
    ReqDoubleExpImpl*  getReqDoubleExpImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setReqDoubleExpImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ReqDoubleExpImpl*  m_reqdoubleexpImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ReqDoubleExp - desc for ReqDoubleExp parameter
     */
    ReqDoubleExp( const ReqDoubleExp& );
    ReqDoubleExp& operator=( const ReqDoubleExp& );

    friend class  ReqDoubleExpDelegate;
    friend class  ReqDoubleExpDispatch;
    friend class  ReqDoubleExpGenImpl;
};

#include <validation/libvalidation_undef.h>
#endif //   TEAMCENTER__REQDOUBLEEXP__HXX
