//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ReqDoubleExpDelegate
    Filename:   ReqDoubleExpDelegate.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REQDOUBLEEXPDELEGATE_HXX
#define TEAMCENTER__REQDOUBLEEXPDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <validation/ReqDoubleExp.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class ReqDoubleExpDelegate;
}
namespace Teamcenter
{
    class ReqDoubleExpImpl;
}
namespace Teamcenter
{
    class ReqDoubleExp;
}
namespace Teamcenter
{
    class ReqDoubleExpGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  VALIDATION_API Teamcenter_alias::ReqDoubleExpDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ReqDoubleExpDelegate instance
    static ReqDoubleExpDelegate&  getInstance();

    //  Method to create the ReqDoubleExpImpl pointer
    static ReqDoubleExpImpl*  createImpl( ReqDoubleExp&  ifObj );

    //  Method to delete the ReqDoubleExpImpl pointer
    static void deleteImpl( ReqDoubleExpImpl*  impl );


    ///
    /// Getter for a Double Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValueBase(const ReqDoubleExp &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Setter for a Double Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValueBase(ReqDoubleExp &ifObj,  double value, bool isNull );



protected:
    //  Pointer to the instance
    static ReqDoubleExpDelegate*  m_pInstance;

    ReqDoubleExpDelegate();
    virtual ~ReqDoubleExpDelegate();
    static void setInstance( ReqDoubleExpDelegate*  instance );


private:
    friend class  ::Teamcenter::ReqDoubleExpGenImpl;

};

#include <validation/libvalidation_undef.h>
#endif  //  TEAMCENTER__REQDOUBLEEXPDELEGATE_HXX
