//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ReqExpression
    Filename:   ReqExpression.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REQEXPRESSION__HXX
#define TEAMCENTER__REQEXPRESSION__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_application_object.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class ReqExpression;
}
namespace Teamcenter
{
    class ReqExpressionImpl;
}
namespace Teamcenter
{
    class ReqExpressionDelegate;
}
namespace Teamcenter
{
    class ReqExpressionDispatch;
}
namespace Teamcenter
{
    class ReqExpressionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VALIDATION_API  Teamcenter::ReqExpression
     : public  ::Teamcenter::POM_application_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFormula( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getObject_name( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFormula( const std::string &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setObject_name( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ReqExpression();

    /**
     * Destructor
     */
    virtual ~ReqExpression();

private:
    //  Getter method for the Implementation Object
    ReqExpressionImpl*  getReqExpressionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setReqExpressionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ReqExpressionImpl*  m_reqexpressionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ReqExpression - desc for ReqExpression parameter
     */
    ReqExpression( const ReqExpression& );
    ReqExpression& operator=( const ReqExpression& );

    friend class  ReqExpressionDelegate;
    friend class  ReqExpressionDispatch;
    friend class  ReqExpressionGenImpl;
};

#include <validation/libvalidation_undef.h>
#endif //   TEAMCENTER__REQEXPRESSION__HXX
