//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ReqExpressionDelegate
    Filename:   ReqExpressionDelegate.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REQEXPRESSIONDELEGATE_HXX
#define TEAMCENTER__REQEXPRESSIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <validation/ReqExpression.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class ReqExpressionDelegate;
}
namespace Teamcenter
{
    class ReqExpressionImpl;
}
namespace Teamcenter
{
    class ReqExpression;
}
namespace Teamcenter
{
    class ReqExpressionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  VALIDATION_API Teamcenter_alias::ReqExpressionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ReqExpressionDelegate instance
    static ReqExpressionDelegate&  getInstance();

    //  Method to create the ReqExpressionImpl pointer
    static ReqExpressionImpl*  createImpl( ReqExpression&  ifObj );

    //  Method to delete the ReqExpressionImpl pointer
    static void deleteImpl( ReqExpressionImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFormulaBase(const ReqExpression &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getObject_nameBase(const ReqExpression &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFormulaBase(ReqExpression &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setObject_nameBase(ReqExpression &ifObj,  const std::string &value, bool isNull );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0RefreshBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static ReqExpressionDelegate*  m_pInstance;

    ReqExpressionDelegate();
    virtual ~ReqExpressionDelegate();
    static void setInstance( ReqExpressionDelegate*  instance );


private:
    friend class  ::Teamcenter::ReqExpressionGenImpl;

};

#include <validation/libvalidation_undef.h>
#endif  //  TEAMCENTER__REQEXPRESSIONDELEGATE_HXX
