//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ReqIntExp
    Filename:   ReqIntExp.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REQINTEXP__HXX
#define TEAMCENTER__REQINTEXP__HXX

#include <common/tc_deprecation_macros.h>
#include <validation/ReqNumberExp.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class ReqIntExp;
}
namespace Teamcenter
{
    class ReqIntExpImpl;
}
namespace Teamcenter
{
    class ReqIntExpDelegate;
}
namespace Teamcenter
{
    class ReqIntExpDispatch;
}
namespace Teamcenter
{
    class ReqIntExpGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VALIDATION_API  Teamcenter::ReqIntExp
     : public  ::Teamcenter::ReqNumberExp
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValue( int &value, bool &isNull ) const;

    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValue( int value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ReqIntExp();

    /**
     * Destructor
     */
    virtual ~ReqIntExp();

private:
    //  Getter method for the Implementation Object
    ReqIntExpImpl*  getReqIntExpImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setReqIntExpImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ReqIntExpImpl*  m_reqintexpImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ReqIntExp - desc for ReqIntExp parameter
     */
    ReqIntExp( const ReqIntExp& );
    ReqIntExp& operator=( const ReqIntExp& );

    friend class  ReqIntExpDelegate;
    friend class  ReqIntExpDispatch;
    friend class  ReqIntExpGenImpl;
};

#include <validation/libvalidation_undef.h>
#endif //   TEAMCENTER__REQINTEXP__HXX
