//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ReqIntExpDelegate
    Filename:   ReqIntExpDelegate.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REQINTEXPDELEGATE_HXX
#define TEAMCENTER__REQINTEXPDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <validation/ReqIntExp.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class ReqIntExpDelegate;
}
namespace Teamcenter
{
    class ReqIntExpImpl;
}
namespace Teamcenter
{
    class ReqIntExp;
}
namespace Teamcenter
{
    class ReqIntExpGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  VALIDATION_API Teamcenter_alias::ReqIntExpDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ReqIntExpDelegate instance
    static ReqIntExpDelegate&  getInstance();

    //  Method to create the ReqIntExpImpl pointer
    static ReqIntExpImpl*  createImpl( ReqIntExp&  ifObj );

    //  Method to delete the ReqIntExpImpl pointer
    static void deleteImpl( ReqIntExpImpl*  impl );


    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValueBase(const ReqIntExp &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValueBase(ReqIntExp &ifObj,  int value, bool isNull );



protected:
    //  Pointer to the instance
    static ReqIntExpDelegate*  m_pInstance;

    ReqIntExpDelegate();
    virtual ~ReqIntExpDelegate();
    static void setInstance( ReqIntExpDelegate*  instance );


private:
    friend class  ::Teamcenter::ReqIntExpGenImpl;

};

#include <validation/libvalidation_undef.h>
#endif  //  TEAMCENTER__REQINTEXPDELEGATE_HXX
