//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ReqNumberExp
    Filename:   ReqNumberExp.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REQNUMBEREXP__HXX
#define TEAMCENTER__REQNUMBEREXP__HXX

#include <common/tc_deprecation_macros.h>
#include <validation/ReqExpression.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class ReqNumberExp;
}
namespace Teamcenter
{
    class ReqNumberExpImpl;
}
namespace Teamcenter
{
    class ReqNumberExpDelegate;
}
namespace Teamcenter
{
    class ReqNumberExpDispatch;
}
namespace Teamcenter
{
    class ReqNumberExpGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VALIDATION_API  Teamcenter::ReqNumberExp
     : public  ::Teamcenter::ReqExpression
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMeasure( int &value, bool &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getUnit( int &value, bool &isNull ) const;

    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMeasure( int value, bool isNull=false );

    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setUnit( int value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ReqNumberExp();

    /**
     * Destructor
     */
    virtual ~ReqNumberExp();

private:
    //  Getter method for the Implementation Object
    ReqNumberExpImpl*  getReqNumberExpImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setReqNumberExpImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ReqNumberExpImpl*  m_reqnumberexpImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ReqNumberExp - desc for ReqNumberExp parameter
     */
    ReqNumberExp( const ReqNumberExp& );
    ReqNumberExp& operator=( const ReqNumberExp& );

    friend class  ReqNumberExpDelegate;
    friend class  ReqNumberExpDispatch;
    friend class  ReqNumberExpGenImpl;
};

#include <validation/libvalidation_undef.h>
#endif //   TEAMCENTER__REQNUMBEREXP__HXX
