//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ReqNumberExpDelegate
    Filename:   ReqNumberExpDelegate.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REQNUMBEREXPDELEGATE_HXX
#define TEAMCENTER__REQNUMBEREXPDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <validation/ReqNumberExp.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class ReqNumberExpDelegate;
}
namespace Teamcenter
{
    class ReqNumberExpImpl;
}
namespace Teamcenter
{
    class ReqNumberExp;
}
namespace Teamcenter
{
    class ReqNumberExpGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  VALIDATION_API Teamcenter_alias::ReqNumberExpDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ReqNumberExpDelegate instance
    static ReqNumberExpDelegate&  getInstance();

    //  Method to create the ReqNumberExpImpl pointer
    static ReqNumberExpImpl*  createImpl( ReqNumberExp&  ifObj );

    //  Method to delete the ReqNumberExpImpl pointer
    static void deleteImpl( ReqNumberExpImpl*  impl );


    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getMeasureBase(const ReqNumberExp &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getUnitBase(const ReqNumberExp &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setMeasureBase(ReqNumberExp &ifObj,  int value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setUnitBase(ReqNumberExp &ifObj,  int value, bool isNull );



protected:
    //  Pointer to the instance
    static ReqNumberExpDelegate*  m_pInstance;

    ReqNumberExpDelegate();
    virtual ~ReqNumberExpDelegate();
    static void setInstance( ReqNumberExpDelegate*  instance );


private:
    friend class  ::Teamcenter::ReqNumberExpGenImpl;

};

#include <validation/libvalidation_undef.h>
#endif  //  TEAMCENTER__REQNUMBEREXPDELEGATE_HXX
