//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ReqStringExp
    Filename:   ReqStringExp.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REQSTRINGEXP__HXX
#define TEAMCENTER__REQSTRINGEXP__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <validation/ReqExpression.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class ReqStringExp;
}
namespace Teamcenter
{
    class ReqStringExpImpl;
}
namespace Teamcenter
{
    class ReqStringExpDelegate;
}
namespace Teamcenter
{
    class ReqStringExpDispatch;
}
namespace Teamcenter
{
    class ReqStringExpGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VALIDATION_API  Teamcenter::ReqStringExp
     : public  ::Teamcenter::ReqExpression
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValue( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValue( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ReqStringExp();

    /**
     * Destructor
     */
    virtual ~ReqStringExp();

private:
    //  Getter method for the Implementation Object
    ReqStringExpImpl*  getReqStringExpImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setReqStringExpImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ReqStringExpImpl*  m_reqstringexpImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ReqStringExp - desc for ReqStringExp parameter
     */
    ReqStringExp( const ReqStringExp& );
    ReqStringExp& operator=( const ReqStringExp& );

    friend class  ReqStringExpDelegate;
    friend class  ReqStringExpDispatch;
    friend class  ReqStringExpGenImpl;
};

#include <validation/libvalidation_undef.h>
#endif //   TEAMCENTER__REQSTRINGEXP__HXX
