//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ReqStringExpDelegate
    Filename:   ReqStringExpDelegate.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__REQSTRINGEXPDELEGATE_HXX
#define TEAMCENTER__REQSTRINGEXPDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <validation/ReqStringExp.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class ReqStringExpDelegate;
}
namespace Teamcenter
{
    class ReqStringExpImpl;
}
namespace Teamcenter
{
    class ReqStringExp;
}
namespace Teamcenter
{
    class ReqStringExpGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  VALIDATION_API Teamcenter_alias::ReqStringExpDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ReqStringExpDelegate instance
    static ReqStringExpDelegate&  getInstance();

    //  Method to create the ReqStringExpImpl pointer
    static ReqStringExpImpl*  createImpl( ReqStringExp&  ifObj );

    //  Method to delete the ReqStringExpImpl pointer
    static void deleteImpl( ReqStringExpImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValueBase(const ReqStringExp &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValueBase(ReqStringExp &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static ReqStringExpDelegate*  m_pInstance;

    ReqStringExpDelegate();
    virtual ~ReqStringExpDelegate();
    static void setInstance( ReqStringExpDelegate*  instance );


private:
    friend class  ::Teamcenter::ReqStringExpGenImpl;

};

#include <validation/libvalidation_undef.h>
#endif  //  TEAMCENTER__REQSTRINGEXPDELEGATE_HXX
