//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TC_Validation
    Filename:   TC_Validation.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TC_VALIDATION__HXX
#define TEAMCENTER__TC_VALIDATION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class TC_Validation;
}
namespace Teamcenter
{
    class TC_ValidationImpl;
}
namespace Teamcenter
{
    class TC_ValidationDelegate;
}
namespace Teamcenter
{
    class TC_ValidationDispatch;
}
namespace Teamcenter
{
    class TC_ValidationGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VALIDATION_API  Teamcenter::TC_Validation
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    TC_Validation();

    /**
     * Destructor
     */
    virtual ~TC_Validation();

private:
    //  Getter method for the Implementation Object
    TC_ValidationImpl*  getTC_ValidationImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setTC_ValidationImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    TC_ValidationImpl*  m_tc_validationImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param TC_Validation - desc for TC_Validation parameter
     */
    TC_Validation( const TC_Validation& );
    TC_Validation& operator=( const TC_Validation& );

    friend class  TC_ValidationDelegate;
    friend class  TC_ValidationDispatch;
    friend class  TC_ValidationGenImpl;
};

#include <validation/libvalidation_undef.h>
#endif //   TEAMCENTER__TC_VALIDATION__HXX
