//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, TC_ValidationDelegate
    Filename:   TC_ValidationDelegate.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__TC_VALIDATIONDELEGATE_HXX
#define TEAMCENTER__TC_VALIDATIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <validation/TC_Validation.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class TC_ValidationDelegate;
}
namespace Teamcenter
{
    class TC_ValidationImpl;
}
namespace Teamcenter
{
    class TC_Validation;
}
namespace Teamcenter
{
    class TC_ValidationGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  VALIDATION_API Teamcenter_alias::TC_ValidationDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the TC_ValidationDelegate instance
    static TC_ValidationDelegate&  getInstance();

    //  Method to create the TC_ValidationImpl pointer
    static TC_ValidationImpl*  createImpl( TC_Validation&  ifObj );

    //  Method to delete the TC_ValidationImpl pointer
    static void deleteImpl( TC_ValidationImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const TC_Validation &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static TC_ValidationDelegate*  m_pInstance;

    TC_ValidationDelegate();
    virtual ~TC_ValidationDelegate();
    static void setInstance( TC_ValidationDelegate*  instance );


private:
    friend class  ::Teamcenter::TC_ValidationGenImpl;

};

#include <validation/libvalidation_undef.h>
#endif  //  TEAMCENTER__TC_VALIDATIONDELEGATE_HXX
