//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ValData
    Filename:   ValData.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VALDATA__HXX
#define TEAMCENTER__VALDATA__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class ValData;
}
namespace Teamcenter
{
    class ValDataImpl;
}
namespace Teamcenter
{
    class ValDataDelegate;
}
namespace Teamcenter
{
    class ValDataDispatch;
}
namespace Teamcenter
{
    class ValDataGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VALIDATION_API  Teamcenter::ValData
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ValData();

    /**
     * Destructor
     */
    virtual ~ValData();

private:
    //  Getter method for the Implementation Object
    ValDataImpl*  getValDataImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setValDataImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ValDataImpl*  m_valdataImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ValData - desc for ValData parameter
     */
    ValData( const ValData& );
    ValData& operator=( const ValData& );

    friend class  ValDataDelegate;
    friend class  ValDataDispatch;
    friend class  ValDataGenImpl;
};

#include <validation/libvalidation_undef.h>
#endif //   TEAMCENTER__VALDATA__HXX
