//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ValDataRevision
    Filename:   ValDataRevision.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VALDATAREVISION__HXX
#define TEAMCENTER__VALDATAREVISION__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class ValDataRevision;
}
namespace Teamcenter
{
    class ValDataRevisionImpl;
}
namespace Teamcenter
{
    class ValDataRevisionDelegate;
}
namespace Teamcenter
{
    class ValDataRevisionDispatch;
}
namespace Teamcenter
{
    class ValDataRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VALIDATION_API  Teamcenter::ValDataRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getUsage_status( int &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValidation_parameters( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 8.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setUsage_status( int value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ValDataRevision();

    /**
     * Destructor
     */
    virtual ~ValDataRevision();

private:
    //  Getter method for the Implementation Object
    ValDataRevisionImpl*  getValDataRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setValDataRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ValDataRevisionImpl*  m_valdatarevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ValDataRevision - desc for ValDataRevision parameter
     */
    ValDataRevision( const ValDataRevision& );
    ValDataRevision& operator=( const ValDataRevision& );

    friend class  ValDataRevisionDelegate;
    friend class  ValDataRevisionDispatch;
    friend class  ValDataRevisionGenImpl;
};

#include <validation/libvalidation_undef.h>
#endif //   TEAMCENTER__VALDATAREVISION__HXX
