//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ValDataRevisionDelegate
    Filename:   ValDataRevisionDelegate.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VALDATAREVISIONDELEGATE_HXX
#define TEAMCENTER__VALDATAREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <validation/ValDataRevision.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class ValDataRevisionDelegate;
}
namespace Teamcenter
{
    class ValDataRevisionImpl;
}
namespace Teamcenter
{
    class ValDataRevision;
}
namespace Teamcenter
{
    class ValDataRevisionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  VALIDATION_API Teamcenter_alias::ValDataRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ValDataRevisionDelegate instance
    static ValDataRevisionDelegate&  getInstance();

    //  Method to create the ValDataRevisionImpl pointer
    static ValDataRevisionImpl*  createImpl( ValDataRevision&  ifObj );

    //  Method to delete the ValDataRevisionImpl pointer
    static void deleteImpl( ValDataRevisionImpl*  impl );


    ///
    /// Getter for an Integer Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getUsage_statusBase(const ValDataRevision &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValidation_parametersBase(const ValDataRevision &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for an Integer Property
    /// @version Teamcenter 8.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setUsage_statusBase(ValDataRevision &ifObj,  int value, bool isNull );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const ValDataRevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const ValDataRevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const ValDataRevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const ValDataRevision &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static ValDataRevisionDelegate*  m_pInstance;

    ValDataRevisionDelegate();
    virtual ~ValDataRevisionDelegate();
    static void setInstance( ValDataRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::ValDataRevisionGenImpl;

};

#include <validation/libvalidation_undef.h>
#endif  //  TEAMCENTER__VALDATAREVISIONDELEGATE_HXX
