//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ValReqResult
    Filename:   ValReqResult.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VALREQRESULT__HXX
#define TEAMCENTER__VALREQRESULT__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <validation/ValidationResult.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class ValReqResult;
}
namespace Teamcenter
{
    class ValReqResultImpl;
}
namespace Teamcenter
{
    class ValReqResultDelegate;
}
namespace Teamcenter
{
    class ValReqResultDispatch;
}
namespace Teamcenter
{
    class ValReqResultGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VALIDATION_API  Teamcenter::ValReqResult
     : public  ::Teamcenter::ValidationResult
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValidation_requirement( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValidation_requirement( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ValReqResult();

    /**
     * Destructor
     */
    virtual ~ValReqResult();

private:
    //  Getter method for the Implementation Object
    ValReqResultImpl*  getValReqResultImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setValReqResultImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ValReqResultImpl*  m_valreqresultImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ValReqResult - desc for ValReqResult parameter
     */
    ValReqResult( const ValReqResult& );
    ValReqResult& operator=( const ValReqResult& );

    friend class  ValReqResultDelegate;
    friend class  ValReqResultDispatch;
    friend class  ValReqResultGenImpl;
};

#include <validation/libvalidation_undef.h>
#endif //   TEAMCENTER__VALREQRESULT__HXX
