//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ValReqResultDelegate
    Filename:   ValReqResultDelegate.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VALREQRESULTDELEGATE_HXX
#define TEAMCENTER__VALREQRESULTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <validation/ValReqResult.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class ValReqResultDelegate;
}
namespace Teamcenter
{
    class ValReqResultImpl;
}
namespace Teamcenter
{
    class ValReqResult;
}
namespace Teamcenter
{
    class ValReqResultGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  VALIDATION_API Teamcenter_alias::ValReqResultDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ValReqResultDelegate instance
    static ValReqResultDelegate&  getInstance();

    //  Method to create the ValReqResultImpl pointer
    static ValReqResultImpl*  createImpl( ValReqResult&  ifObj );

    //  Method to delete the ValReqResultImpl pointer
    static void deleteImpl( ValReqResultImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getValidation_requirementBase(const ValReqResult &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setValidation_requirementBase(ValReqResult &ifObj,  const tag_t &value, bool isNull );



protected:
    //  Pointer to the instance
    static ValReqResultDelegate*  m_pInstance;

    ValReqResultDelegate();
    virtual ~ValReqResultDelegate();
    static void setInstance( ValReqResultDelegate*  instance );


private:
    friend class  ::Teamcenter::ValReqResultGenImpl;

};

#include <validation/libvalidation_undef.h>
#endif  //  TEAMCENTER__VALREQRESULTDELEGATE_HXX
