//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ValToolAgent
    Filename:   ValToolAgent.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VALTOOLAGENT__HXX
#define TEAMCENTER__VALTOOLAGENT__HXX

#include <common/tc_deprecation_macros.h>
#include <validation/ValidationAgent.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class ValToolAgent;
}
namespace Teamcenter
{
    class ValToolAgentImpl;
}
namespace Teamcenter
{
    class ValToolAgentDelegate;
}
namespace Teamcenter
{
    class ValToolAgentDispatch;
}
namespace Teamcenter
{
    class ValToolAgentGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VALIDATION_API  Teamcenter::ValToolAgent
     : public  ::Teamcenter::ValidationAgent
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIs_client_utility( bool &value, bool &isNull ) const;

    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 8.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIs_client_utility( bool value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ValToolAgent();

    /**
     * Destructor
     */
    virtual ~ValToolAgent();

private:
    //  Getter method for the Implementation Object
    ValToolAgentImpl*  getValToolAgentImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setValToolAgentImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ValToolAgentImpl*  m_valtoolagentImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ValToolAgent - desc for ValToolAgent parameter
     */
    ValToolAgent( const ValToolAgent& );
    ValToolAgent& operator=( const ValToolAgent& );

    friend class  ValToolAgentDelegate;
    friend class  ValToolAgentDispatch;
    friend class  ValToolAgentGenImpl;
};

#include <validation/libvalidation_undef.h>
#endif //   TEAMCENTER__VALTOOLAGENT__HXX
