//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ValToolAgentDelegate
    Filename:   ValToolAgentDelegate.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VALTOOLAGENTDELEGATE_HXX
#define TEAMCENTER__VALTOOLAGENTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <validation/ValToolAgent.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class ValToolAgentDelegate;
}
namespace Teamcenter
{
    class ValToolAgentImpl;
}
namespace Teamcenter
{
    class ValToolAgent;
}
namespace Teamcenter
{
    class ValToolAgentGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  VALIDATION_API Teamcenter_alias::ValToolAgentDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ValToolAgentDelegate instance
    static ValToolAgentDelegate&  getInstance();

    //  Method to create the ValToolAgentImpl pointer
    static ValToolAgentImpl*  createImpl( ValToolAgent&  ifObj );

    //  Method to delete the ValToolAgentImpl pointer
    static void deleteImpl( ValToolAgentImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 8.2
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getIs_client_utilityBase(const ValToolAgent &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// Setter for a Boolean Property
    /// @version Teamcenter 8.2
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setIs_client_utilityBase(ValToolAgent &ifObj,  bool value, bool isNull );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const ValToolAgent &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const ValToolAgent &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const ValToolAgent &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const ValToolAgent &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static ValToolAgentDelegate*  m_pInstance;

    ValToolAgentDelegate();
    virtual ~ValToolAgentDelegate();
    static void setInstance( ValToolAgentDelegate*  instance );


private:
    friend class  ::Teamcenter::ValToolAgentGenImpl;

};

#include <validation/libvalidation_undef.h>
#endif  //  TEAMCENTER__VALTOOLAGENTDELEGATE_HXX
