//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ValToolAgentRevision
    Filename:   ValToolAgentRevision.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VALTOOLAGENTREVISION__HXX
#define TEAMCENTER__VALTOOLAGENTREVISION__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <validation/ValidationAgentRevision.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class ValToolAgentRevision;
}
namespace Teamcenter
{
    class ValToolAgentRevisionImpl;
}
namespace Teamcenter
{
    class ValToolAgentRevisionDelegate;
}
namespace Teamcenter
{
    class ValToolAgentRevisionDispatch;
}
namespace Teamcenter
{
    class ValToolAgentRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VALIDATION_API  Teamcenter::ValToolAgentRevision
     : public  ::Teamcenter::ValidationAgentRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for an String Array Property
    /// @version Teamcenter 8.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getValidation_arguments( std::vector< std::string > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for an string Array Property
    /// @version Teamcenter 8.2
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setValidation_arguments( const std::vector< std::string > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ValToolAgentRevision();

    /**
     * Destructor
     */
    virtual ~ValToolAgentRevision();

private:
    //  Getter method for the Implementation Object
    ValToolAgentRevisionImpl*  getValToolAgentRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setValToolAgentRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ValToolAgentRevisionImpl*  m_valtoolagentrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ValToolAgentRevision - desc for ValToolAgentRevision parameter
     */
    ValToolAgentRevision( const ValToolAgentRevision& );
    ValToolAgentRevision& operator=( const ValToolAgentRevision& );

    friend class  ValToolAgentRevisionDelegate;
    friend class  ValToolAgentRevisionDispatch;
    friend class  ValToolAgentRevisionGenImpl;
};

#include <validation/libvalidation_undef.h>
#endif //   TEAMCENTER__VALTOOLAGENTREVISION__HXX
