//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ValidationAgent
    Filename:   ValidationAgent.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VALIDATIONAGENT__HXX
#define TEAMCENTER__VALIDATIONAGENT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class ValidationAgent;
}
namespace Teamcenter
{
    class ValidationAgentImpl;
}
namespace Teamcenter
{
    class ValidationAgentDelegate;
}
namespace Teamcenter
{
    class ValidationAgentDispatch;
}
namespace Teamcenter
{
    class ValidationAgentGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VALIDATION_API  Teamcenter::ValidationAgent
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ValidationAgent();

    /**
     * Destructor
     */
    virtual ~ValidationAgent();

private:
    //  Getter method for the Implementation Object
    ValidationAgentImpl*  getValidationAgentImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setValidationAgentImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ValidationAgentImpl*  m_validationagentImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ValidationAgent - desc for ValidationAgent parameter
     */
    ValidationAgent( const ValidationAgent& );
    ValidationAgent& operator=( const ValidationAgent& );

    friend class  ValidationAgentDelegate;
    friend class  ValidationAgentDispatch;
    friend class  ValidationAgentGenImpl;
};

#include <validation/libvalidation_undef.h>
#endif //   TEAMCENTER__VALIDATIONAGENT__HXX
