//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ValidationMaster
    Filename:   ValidationMaster.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VALIDATIONMASTER__HXX
#define TEAMCENTER__VALIDATIONMASTER__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class ValidationMaster;
}
namespace Teamcenter
{
    class ValidationMasterImpl;
}
namespace Teamcenter
{
    class ValidationMasterDelegate;
}
namespace Teamcenter
{
    class ValidationMasterDispatch;
}
namespace Teamcenter
{
    class ValidationMasterGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VALIDATION_API  Teamcenter::ValidationMaster
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ValidationMaster();

    /**
     * Destructor
     */
    virtual ~ValidationMaster();

private:
    //  Getter method for the Implementation Object
    ValidationMasterImpl*  getValidationMasterImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setValidationMasterImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ValidationMasterImpl*  m_validationmasterImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ValidationMaster - desc for ValidationMaster parameter
     */
    ValidationMaster( const ValidationMaster& );
    ValidationMaster& operator=( const ValidationMaster& );

    friend class  ValidationMasterDelegate;
    friend class  ValidationMasterDispatch;
    friend class  ValidationMasterGenImpl;
};

#include <validation/libvalidation_undef.h>
#endif //   TEAMCENTER__VALIDATIONMASTER__HXX
