//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ValidationMasterDelegate
    Filename:   ValidationMasterDelegate.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VALIDATIONMASTERDELEGATE_HXX
#define TEAMCENTER__VALIDATIONMASTERDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <validation/ValidationMaster.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class ValidationMasterDelegate;
}
namespace Teamcenter
{
    class ValidationMasterImpl;
}
namespace Teamcenter
{
    class ValidationMaster;
}
namespace Teamcenter
{
    class ValidationMasterGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  VALIDATION_API Teamcenter_alias::ValidationMasterDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ValidationMasterDelegate instance
    static ValidationMasterDelegate&  getInstance();

    //  Method to create the ValidationMasterImpl pointer
    static ValidationMasterImpl*  createImpl( ValidationMaster&  ifObj );

    //  Method to delete the ValidationMasterImpl pointer
    static void deleteImpl( ValidationMasterImpl*  impl );


    ///
    /// perform deep copy
    /// @version Teamcenter 9
    /// @param pOperationInput - desc
    /// @param vecDeepCopyData - deep copy data
    /// @return - returns an int
    ///
    int  performDeepCopyBase(const ValidationMaster &ifObj,  ::Teamcenter::OperationInput *pOperationInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0RefreshBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static ValidationMasterDelegate*  m_pInstance;

    ValidationMasterDelegate();
    virtual ~ValidationMasterDelegate();
    static void setInstance( ValidationMasterDelegate*  instance );


private:
    friend class  ::Teamcenter::ValidationMasterGenImpl;

};

#include <validation/libvalidation_undef.h>
#endif  //  TEAMCENTER__VALIDATIONMASTERDELEGATE_HXX
