//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ValidationParams
    Filename:   ValidationParams.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VALIDATIONPARAMS__HXX
#define TEAMCENTER__VALIDATIONPARAMS__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class ValidationParams;
}
namespace Teamcenter
{
    class ValidationParamsImpl;
}
namespace Teamcenter
{
    class ValidationParamsDelegate;
}
namespace Teamcenter
{
    class ValidationParamsDispatch;
}
namespace Teamcenter
{
    class ValidationParamsGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VALIDATION_API  Teamcenter::ValidationParams
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ValidationParams();

    /**
     * Destructor
     */
    virtual ~ValidationParams();

private:
    //  Getter method for the Implementation Object
    ValidationParamsImpl*  getValidationParamsImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setValidationParamsImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ValidationParamsImpl*  m_validationparamsImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ValidationParams - desc for ValidationParams parameter
     */
    ValidationParams( const ValidationParams& );
    ValidationParams& operator=( const ValidationParams& );

    friend class  ValidationParamsDelegate;
    friend class  ValidationParamsDispatch;
    friend class  ValidationParamsGenImpl;
};

#include <validation/libvalidation_undef.h>
#endif //   TEAMCENTER__VALIDATIONPARAMS__HXX
