//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ValidationReq
    Filename:   ValidationReq.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VALIDATIONREQ__HXX
#define TEAMCENTER__VALIDATIONREQ__HXX

#include <common/tc_deprecation_macros.h>
#include <validation/ModelReq.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class ValidationReq;
}
namespace Teamcenter
{
    class ValidationReqImpl;
}
namespace Teamcenter
{
    class ValidationReqDelegate;
}
namespace Teamcenter
{
    class ValidationReqDispatch;
}
namespace Teamcenter
{
    class ValidationReqGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VALIDATION_API  Teamcenter::ValidationReq
     : public  ::Teamcenter::ModelReq
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ValidationReq();

    /**
     * Destructor
     */
    virtual ~ValidationReq();

private:
    //  Getter method for the Implementation Object
    ValidationReqImpl*  getValidationReqImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setValidationReqImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ValidationReqImpl*  m_validationreqImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ValidationReq - desc for ValidationReq parameter
     */
    ValidationReq( const ValidationReq& );
    ValidationReq& operator=( const ValidationReq& );

    friend class  ValidationReqDelegate;
    friend class  ValidationReqDispatch;
    friend class  ValidationReqGenImpl;
};

#include <validation/libvalidation_undef.h>
#endif //   TEAMCENTER__VALIDATIONREQ__HXX
