//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ValidationReqRevision
    Filename:   ValidationReqRevision.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VALIDATIONREQREVISION__HXX
#define TEAMCENTER__VALIDATIONREQREVISION__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <validation/ModelReqRevision.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class ValidationReqRevision;
}
namespace Teamcenter
{
    class ValidationReqRevisionImpl;
}
namespace Teamcenter
{
    class ValidationReqRevisionDelegate;
}
namespace Teamcenter
{
    class ValidationReqRevisionDispatch;
}
namespace Teamcenter
{
    class ValidationReqRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VALIDATION_API  Teamcenter::ValidationReqRevision
     : public  ::Teamcenter::ModelReqRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRequirement_formula( std::string &value, bool &isNull ) const;

    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSeverity( int &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setRequirement_formula( const std::string &value, bool isNull=false );

    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSeverity( int value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ValidationReqRevision();

    /**
     * Destructor
     */
    virtual ~ValidationReqRevision();

private:
    //  Getter method for the Implementation Object
    ValidationReqRevisionImpl*  getValidationReqRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setValidationReqRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ValidationReqRevisionImpl*  m_validationreqrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ValidationReqRevision - desc for ValidationReqRevision parameter
     */
    ValidationReqRevision( const ValidationReqRevision& );
    ValidationReqRevision& operator=( const ValidationReqRevision& );

    friend class  ValidationReqRevisionDelegate;
    friend class  ValidationReqRevisionDispatch;
    friend class  ValidationReqRevisionGenImpl;
};

#include <validation/libvalidation_undef.h>
#endif //   TEAMCENTER__VALIDATIONREQREVISION__HXX
