//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ValidationReqRevisionDelegate
    Filename:   ValidationReqRevisionDelegate.hxx
    Module:     validation
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VALIDATIONREQREVISIONDELEGATE_HXX
#define TEAMCENTER__VALIDATIONREQREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <validation/ValidationReqRevision.hxx>

#include <validation/libvalidation_exports.h>

namespace Teamcenter
{
    class ValidationReqRevisionDelegate;
}
namespace Teamcenter
{
    class ValidationReqRevisionImpl;
}
namespace Teamcenter
{
    class ValidationReqRevision;
}
namespace Teamcenter
{
    class ValidationReqRevisionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  VALIDATION_API Teamcenter_alias::ValidationReqRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ValidationReqRevisionDelegate instance
    static ValidationReqRevisionDelegate&  getInstance();

    //  Method to create the ValidationReqRevisionImpl pointer
    static ValidationReqRevisionImpl*  createImpl( ValidationReqRevision&  ifObj );

    //  Method to delete the ValidationReqRevisionImpl pointer
    static void deleteImpl( ValidationReqRevisionImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getRequirement_formulaBase(const ValidationReqRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for an Integer Property
    /// @version Tc 8
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getSeverityBase(const ValidationReqRevision &ifObj,  int &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setRequirement_formulaBase(ValidationReqRevision &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for an Integer Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setSeverityBase(ValidationReqRevision &ifObj,  int value, bool isNull );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0_req_expression_strBase(const ValidationReqRevision &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0_req_expression_strBase(ValidationReqRevision &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static ValidationReqRevisionDelegate*  m_pInstance;

    ValidationReqRevisionDelegate();
    virtual ~ValidationReqRevisionDelegate();
    static void setInstance( ValidationReqRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::ValidationReqRevisionGenImpl;

};

#include <validation/libvalidation_undef.h>
#endif  //  TEAMCENTER__VALIDATIONREQREVISIONDELEGATE_HXX
