//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  validation

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libvalidation

#if !defined(LIBVALIDATION) && !defined(IPLIB)
#   error IPLIB or LIBVALIDATION is not defined
#endif

/* Handwritten code should use VALIDATION_API, not VALIDATIONEXPORT */

#define VALIDATION_API VALIDATIONEXPORT

#if IPLIB==libvalidation || defined(LIBVALIDATION)
#   if defined(__lint)
#       define VALIDATIONEXPORT       __export(validation)
#       define VALIDATIONGLOBAL       extern __global(validation)
#       define VALIDATIONPRIVATE      extern __private(validation)
#   elif defined(_WIN32)
#       define VALIDATIONEXPORT       __declspec(dllexport)
#       define VALIDATIONGLOBAL       extern __declspec(dllexport)
#       define VALIDATIONPRIVATE      extern
#   else
#       define VALIDATIONEXPORT
#       define VALIDATIONGLOBAL       extern
#       define VALIDATIONPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define VALIDATIONEXPORT       __export(validation)
#       define VALIDATIONGLOBAL       extern __global(validation)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define VALIDATIONEXPORT      __declspec(dllimport)
#       define VALIDATIONGLOBAL       extern __declspec(dllimport)
#   else
#       define VALIDATIONEXPORT
#       define VALIDATIONGLOBAL       extern
#   endif
#endif
