//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CommercialPartDispatch
    Filename:   CommercialPartDispatch.hxx
    Module:     vendormanagementdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__COMMERCIALPARTDISPATCH_HXX
#define TEAMCENTER__COMMERCIALPARTDISPATCH_HXX

#include <vector>
#include <vm/CommercialPart.hxx>
#include <vm/CommercialPartDelegate.hxx>
#include <foundationdispatch/PartDispatch.hxx>
#include <vendormanagementdispatch/initializevendormanagement.hxx>

#include <vendormanagementdispatch/libvendormanagementdispatch_exports.h>

namespace Teamcenter
{
    class CommercialPartDispatch;
}
namespace Teamcenter
{
    class CommercialPartDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  VENDORMANAGEMENTDISPATCH_API  Teamcenter::CommercialPartDispatch
    : public  Teamcenter::CommercialPartDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the CommercialPartDispatch instance
    static CommercialPartDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static CommercialPartDispatch*  m_dispatch;

    //  Default Constructor
    CommercialPartDispatch();

    //  Default Destructor
    virtual ~CommercialPartDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a CommercialPartDispatch
    CommercialPartDispatch( const CommercialPartDispatch& );

    //  Assignment operator
    CommercialPartDispatch&  operator = ( const CommercialPartDispatch& );

    //  friend
    friend void   ::Teamcenter::initializevendormanagementInternal();
    friend void   ::Teamcenter::initializevendormanagementExtenders();
    friend class  Teamcenter::CommercialPartDelegate;
};

#include <vendormanagementdispatch/libvendormanagementdispatch_undef.h>
#endif  //  TEAMCENTER__COMMERCIALPARTDISPATCH_HXX
