//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, LineItemConfigContextDispatch
    Filename:   LineItemConfigContextDispatch.hxx
    Module:     vendormanagementdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LINEITEMCONFIGCONTEXTDISPATCH_HXX
#define TEAMCENTER__LINEITEMCONFIGCONTEXTDISPATCH_HXX

#include <vector>
#include <vm/LineItemConfigContext.hxx>
#include <vm/LineItemConfigContextDelegate.hxx>
#include <foundationdispatch/ConfigurationContextDispatch.hxx>
#include <vendormanagementdispatch/initializevendormanagement.hxx>

#include <vendormanagementdispatch/libvendormanagementdispatch_exports.h>

namespace Teamcenter
{
    class LineItemConfigContextDispatch;
}
namespace Teamcenter
{
    class LineItemConfigContextDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  VENDORMANAGEMENTDISPATCH_API  Teamcenter::LineItemConfigContextDispatch
    : public  Teamcenter::LineItemConfigContextDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the LineItemConfigContextDispatch instance
    static LineItemConfigContextDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static LineItemConfigContextDispatch*  m_dispatch;

    //  Default Constructor
    LineItemConfigContextDispatch();

    //  Default Destructor
    virtual ~LineItemConfigContextDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a LineItemConfigContextDispatch
    LineItemConfigContextDispatch( const LineItemConfigContextDispatch& );

    //  Assignment operator
    LineItemConfigContextDispatch&  operator = ( const LineItemConfigContextDispatch& );

    //  friend
    friend void   ::Teamcenter::initializevendormanagementInternal();
    friend void   ::Teamcenter::initializevendormanagementExtenders();
    friend class  Teamcenter::LineItemConfigContextDelegate;
};

#include <vendormanagementdispatch/libvendormanagementdispatch_undef.h>
#endif  //  TEAMCENTER__LINEITEMCONFIGCONTEXTDISPATCH_HXX
