//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ManufacturerPartDispatch
    Filename:   ManufacturerPartDispatch.hxx
    Module:     vendormanagementdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MANUFACTURERPARTDISPATCH_HXX
#define TEAMCENTER__MANUFACTURERPARTDISPATCH_HXX

#include <vector>
#include <vm/ManufacturerPart.hxx>
#include <vm/ManufacturerPartDelegate.hxx>
#include <foundationdispatch/PartDispatch.hxx>
#include <vendormanagementdispatch/initializevendormanagement.hxx>

#include <vendormanagementdispatch/libvendormanagementdispatch_exports.h>

namespace Teamcenter
{
    class ManufacturerPartDispatch;
}
namespace Teamcenter
{
    class ManufacturerPartDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  VENDORMANAGEMENTDISPATCH_API  Teamcenter::ManufacturerPartDispatch
    : public  Teamcenter::ManufacturerPartDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ManufacturerPartDispatch instance
    static ManufacturerPartDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static ManufacturerPartDispatch*  m_dispatch;

    //  Default Constructor
    ManufacturerPartDispatch();

    //  Default Destructor
    virtual ~ManufacturerPartDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a ManufacturerPartDispatch
    ManufacturerPartDispatch( const ManufacturerPartDispatch& );

    //  Assignment operator
    ManufacturerPartDispatch&  operator = ( const ManufacturerPartDispatch& );

    //  friend
    friend void   ::Teamcenter::initializevendormanagementInternal();
    friend void   ::Teamcenter::initializevendormanagementExtenders();
    friend class  Teamcenter::ManufacturerPartDelegate;
};

#include <vendormanagementdispatch/libvendormanagementdispatch_undef.h>
#endif  //  TEAMCENTER__MANUFACTURERPARTDISPATCH_HXX
