//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, VMRepresentsDispatch
    Filename:   VMRepresentsDispatch.hxx
    Module:     vendormanagementdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VMREPRESENTSDISPATCH_HXX
#define TEAMCENTER__VMREPRESENTSDISPATCH_HXX

#include <vector>
#include <vm/VMRepresents.hxx>
#include <vm/VMRepresentsDelegate.hxx>
#include <foundationdispatch/ImanRelationDispatch.hxx>
#include <vendormanagementdispatch/initializevendormanagement.hxx>

#include <vendormanagementdispatch/libvendormanagementdispatch_exports.h>

namespace Teamcenter
{
    class VMRepresentsDispatch;
}
namespace Teamcenter
{
    class VMRepresentsDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  VENDORMANAGEMENTDISPATCH_API  Teamcenter::VMRepresentsDispatch
    : public  Teamcenter::VMRepresentsDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the VMRepresentsDispatch instance
    static VMRepresentsDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static VMRepresentsDispatch*  m_dispatch;

    //  Default Constructor
    VMRepresentsDispatch();

    //  Default Destructor
    virtual ~VMRepresentsDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a VMRepresentsDispatch
    VMRepresentsDispatch( const VMRepresentsDispatch& );

    //  Assignment operator
    VMRepresentsDispatch&  operator = ( const VMRepresentsDispatch& );

    //  friend
    friend void   ::Teamcenter::initializevendormanagementInternal();
    friend void   ::Teamcenter::initializevendormanagementExtenders();
    friend class  Teamcenter::VMRepresentsDelegate;
};

#include <vendormanagementdispatch/libvendormanagementdispatch_undef.h>
#endif  //  TEAMCENTER__VMREPRESENTSDISPATCH_HXX
