//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, VendorDispatch
    Filename:   VendorDispatch.hxx
    Module:     vendormanagementdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VENDORDISPATCH_HXX
#define TEAMCENTER__VENDORDISPATCH_HXX

#include <vector>
#include <vm/Vendor.hxx>
#include <vm/VendorDelegate.hxx>
#include <foundationdispatch/ItemDispatch.hxx>
#include <vendormanagementdispatch/initializevendormanagement.hxx>

#include <vendormanagementdispatch/libvendormanagementdispatch_exports.h>

namespace Teamcenter
{
    class VendorDispatch;
}
namespace Teamcenter
{
    class VendorDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  VENDORMANAGEMENTDISPATCH_API  Teamcenter::VendorDispatch
    : public  Teamcenter::VendorDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the VendorDispatch instance
    static VendorDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static VendorDispatch*  m_dispatch;

    //  Default Constructor
    VendorDispatch();

    //  Default Destructor
    virtual ~VendorDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a VendorDispatch
    VendorDispatch( const VendorDispatch& );

    //  Assignment operator
    VendorDispatch&  operator = ( const VendorDispatch& );

    //  friend
    friend void   ::Teamcenter::initializevendormanagementInternal();
    friend void   ::Teamcenter::initializevendormanagementExtenders();
    friend class  Teamcenter::VendorDelegate;
};

#include <vendormanagementdispatch/libvendormanagementdispatch_undef.h>
#endif  //  TEAMCENTER__VENDORDISPATCH_HXX
