//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, VendorRevisionDispatch
    Filename:   VendorRevisionDispatch.hxx
    Module:     vendormanagementdispatch
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VENDORREVISIONDISPATCH_HXX
#define TEAMCENTER__VENDORREVISIONDISPATCH_HXX

#include <vector>
#include <vm/VendorRevision.hxx>
#include <vm/VendorRevisionDelegate.hxx>
#include <foundationdispatch/ItemRevisionDispatch.hxx>
#include <vendormanagementdispatch/initializevendormanagement.hxx>

#include <vendormanagementdispatch/libvendormanagementdispatch_exports.h>

namespace Teamcenter
{
    class VendorRevisionDispatch;
}
namespace Teamcenter
{
    class VendorRevisionDelegate;
}
namespace Teamcenter
{
    class BusinessObjectImpl;
}

class  VENDORMANAGEMENTDISPATCH_API  Teamcenter::VendorRevisionDispatch
    : public  Teamcenter::VendorRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the VendorRevisionDispatch instance
    static VendorRevisionDispatch&  getInstance();


private:
    //  Pointer to the dispatch instance
    static VendorRevisionDispatch*  m_dispatch;

    //  Default Constructor
    VendorRevisionDispatch();

    //  Default Destructor
    virtual ~VendorRevisionDispatch();

    //  Constructor Method
    static ::Teamcenter::RootObject*  constructor();

    //  Copy Constructor for a VendorRevisionDispatch
    VendorRevisionDispatch( const VendorRevisionDispatch& );

    //  Assignment operator
    VendorRevisionDispatch&  operator = ( const VendorRevisionDispatch& );

    //  friend
    friend void   ::Teamcenter::initializevendormanagementInternal();
    friend void   ::Teamcenter::initializevendormanagementExtenders();
    friend class  Teamcenter::VendorRevisionDelegate;
};

#include <vendormanagementdispatch/libvendormanagementdispatch_undef.h>
#endif  //  TEAMCENTER__VENDORREVISIONDISPATCH_HXX
