//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0Snapshot3DVisibleLInfo
    Filename:   Fnd0Snapshot3DVisibleLInfo.hxx
    Module:     visualization
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0SNAPSHOT3DVISIBLELINFO__HXX
#define TEAMCENTER__FND0SNAPSHOT3DVISIBLELINFO__HXX

#include <string>
#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <visualization/libvisualization_exports.h>

namespace Teamcenter
{
    class Fnd0Snapshot3DVisibleLInfo;
}
namespace Teamcenter
{
    class Fnd0Snapshot3DVisibleLInfoImpl;
}
namespace Teamcenter
{
    class Fnd0Snapshot3DVisibleLInfoDelegate;
}
namespace Teamcenter
{
    class Fnd0Snapshot3DVisibleLInfoDispatch;
}
namespace Teamcenter
{
    class Fnd0Snapshot3DVisibleLInfoGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VISUALIZATION_API  Teamcenter::Fnd0Snapshot3DVisibleLInfo
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0CloneStableOccIDChain( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ItemRevision( tag_t &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0JTFileInfo( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0SnapshotViewData( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0CloneStableOccIDChain( const std::string &value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0ItemRevision( const tag_t &value, bool isNull=false );

    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0JTFileInfo( const std::string &value, bool isNull=false );

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0SnapshotViewData( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0Snapshot3DVisibleLInfo();

    /**
     * Destructor
     */
    virtual ~Fnd0Snapshot3DVisibleLInfo();

private:
    //  Getter method for the Implementation Object
    Fnd0Snapshot3DVisibleLInfoImpl*  getFnd0Snapshot3DVisibleLInfoImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0Snapshot3DVisibleLInfoImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0Snapshot3DVisibleLInfoImpl*  m_fnd0snapshot3dvisiblelinfoImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0Snapshot3DVisibleLInfo - desc for Fnd0Snapshot3DVisibleLInfo parameter
     */
    Fnd0Snapshot3DVisibleLInfo( const Fnd0Snapshot3DVisibleLInfo& );
    Fnd0Snapshot3DVisibleLInfo& operator=( const Fnd0Snapshot3DVisibleLInfo& );

    friend class  Fnd0Snapshot3DVisibleLInfoDelegate;
    friend class  Fnd0Snapshot3DVisibleLInfoDispatch;
    friend class  Fnd0Snapshot3DVisibleLInfoGenImpl;
};

#include <visualization/libvisualization_undef.h>
#endif //   TEAMCENTER__FND0SNAPSHOT3DVISIBLELINFO__HXX
