//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0Snapshot3DVisibleLInfoDelegate
    Filename:   Fnd0Snapshot3DVisibleLInfoDelegate.hxx
    Module:     visualization
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0SNAPSHOT3DVISIBLELINFODELEGATE_HXX
#define TEAMCENTER__FND0SNAPSHOT3DVISIBLELINFODELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <visualization/Fnd0Snapshot3DVisibleLInfo.hxx>

#include <visualization/libvisualization_exports.h>

namespace Teamcenter
{
    class Fnd0Snapshot3DVisibleLInfoDelegate;
}
namespace Teamcenter
{
    class Fnd0Snapshot3DVisibleLInfoImpl;
}
namespace Teamcenter
{
    class Fnd0Snapshot3DVisibleLInfo;
}
namespace Teamcenter
{
    class Fnd0Snapshot3DVisibleLInfoGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  VISUALIZATION_API Teamcenter_alias::Fnd0Snapshot3DVisibleLInfoDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0Snapshot3DVisibleLInfoDelegate instance
    static Fnd0Snapshot3DVisibleLInfoDelegate&  getInstance();

    //  Method to create the Fnd0Snapshot3DVisibleLInfoImpl pointer
    static Fnd0Snapshot3DVisibleLInfoImpl*  createImpl( Fnd0Snapshot3DVisibleLInfo&  ifObj );

    //  Method to delete the Fnd0Snapshot3DVisibleLInfoImpl pointer
    static void deleteImpl( Fnd0Snapshot3DVisibleLInfoImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0CloneStableOccIDChainBase(const Fnd0Snapshot3DVisibleLInfo &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ItemRevisionBase(const Fnd0Snapshot3DVisibleLInfo &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Getter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0JTFileInfoBase(const Fnd0Snapshot3DVisibleLInfo &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0SnapshotViewDataBase(const Fnd0Snapshot3DVisibleLInfo &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0CloneStableOccIDChainBase(Fnd0Snapshot3DVisibleLInfo &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0ItemRevisionBase(Fnd0Snapshot3DVisibleLInfo &ifObj,  const tag_t &value, bool isNull );


    ///
    /// Setter for a string Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0JTFileInfoBase(Fnd0Snapshot3DVisibleLInfo &ifObj,  const std::string &value, bool isNull );


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0SnapshotViewDataBase(Fnd0Snapshot3DVisibleLInfo &ifObj,  const tag_t &value, bool isNull );



protected:
    //  Pointer to the instance
    static Fnd0Snapshot3DVisibleLInfoDelegate*  m_pInstance;

    Fnd0Snapshot3DVisibleLInfoDelegate();
    virtual ~Fnd0Snapshot3DVisibleLInfoDelegate();
    static void setInstance( Fnd0Snapshot3DVisibleLInfoDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0Snapshot3DVisibleLInfoGenImpl;

};

#include <visualization/libvisualization_undef.h>
#endif  //  TEAMCENTER__FND0SNAPSHOT3DVISIBLELINFODELEGATE_HXX
