//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0Vis3DSnapshot
    Filename:   Fnd0Vis3DSnapshot.hxx
    Module:     visualization
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0VIS3DSNAPSHOT__HXX
#define TEAMCENTER__FND0VIS3DSNAPSHOT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <visualization/libvisualization_exports.h>

namespace Teamcenter
{
    class Fnd0Vis3DSnapshot;
}
namespace Teamcenter
{
    class Fnd0Vis3DSnapshotImpl;
}
namespace Teamcenter
{
    class Fnd0Vis3DSnapshotDelegate;
}
namespace Teamcenter
{
    class Fnd0Vis3DSnapshotDispatch;
}
namespace Teamcenter
{
    class Fnd0Vis3DSnapshotGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VISUALIZATION_API  Teamcenter::Fnd0Vis3DSnapshot
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0order( double &value, bool &isNull ) const;

    ///
    /// Setter for a Double Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0order( double value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Fnd0Vis3DSnapshot();

    /**
     * Destructor
     */
    virtual ~Fnd0Vis3DSnapshot();

private:
    //  Getter method for the Implementation Object
    Fnd0Vis3DSnapshotImpl*  getFnd0Vis3DSnapshotImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setFnd0Vis3DSnapshotImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Fnd0Vis3DSnapshotImpl*  m_fnd0vis3dsnapshotImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Fnd0Vis3DSnapshot - desc for Fnd0Vis3DSnapshot parameter
     */
    Fnd0Vis3DSnapshot( const Fnd0Vis3DSnapshot& );
    Fnd0Vis3DSnapshot& operator=( const Fnd0Vis3DSnapshot& );

    friend class  Fnd0Vis3DSnapshotDelegate;
    friend class  Fnd0Vis3DSnapshotDispatch;
    friend class  Fnd0Vis3DSnapshotGenImpl;
};

#include <visualization/libvisualization_undef.h>
#endif //   TEAMCENTER__FND0VIS3DSNAPSHOT__HXX
