//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Fnd0Vis3DSnapshotDelegate
    Filename:   Fnd0Vis3DSnapshotDelegate.hxx
    Module:     visualization
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__FND0VIS3DSNAPSHOTDELEGATE_HXX
#define TEAMCENTER__FND0VIS3DSNAPSHOTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <visualization/Fnd0Vis3DSnapshot.hxx>

#include <visualization/libvisualization_exports.h>

namespace Teamcenter
{
    class Fnd0Vis3DSnapshotDelegate;
}
namespace Teamcenter
{
    class Fnd0Vis3DSnapshotImpl;
}
namespace Teamcenter
{
    class Fnd0Vis3DSnapshot;
}
namespace Teamcenter
{
    class Fnd0Vis3DSnapshotGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  VISUALIZATION_API Teamcenter_alias::Fnd0Vis3DSnapshotDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Fnd0Vis3DSnapshotDelegate instance
    static Fnd0Vis3DSnapshotDelegate&  getInstance();

    //  Method to create the Fnd0Vis3DSnapshotImpl pointer
    static Fnd0Vis3DSnapshotImpl*  createImpl( Fnd0Vis3DSnapshot&  ifObj );

    //  Method to delete the Fnd0Vis3DSnapshotImpl pointer
    static void deleteImpl( Fnd0Vis3DSnapshotImpl*  impl );


    ///
    /// Getter for a Double Property
    /// @version Teamcenter 8.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0orderBase(const Fnd0Vis3DSnapshot &ifObj,  double &value, bool &isNull ) const;


    ///
    /// Setter for a Double Property
    /// @version Teamcenter 8.3
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setFnd0orderBase(Fnd0Vis3DSnapshot &ifObj,  double value, bool isNull );



protected:
    //  Pointer to the instance
    static Fnd0Vis3DSnapshotDelegate*  m_pInstance;

    Fnd0Vis3DSnapshotDelegate();
    virtual ~Fnd0Vis3DSnapshotDelegate();
    static void setInstance( Fnd0Vis3DSnapshotDelegate*  instance );


private:
    friend class  ::Teamcenter::Fnd0Vis3DSnapshotGenImpl;

};

#include <visualization/libvisualization_undef.h>
#endif  //  TEAMCENTER__FND0VIS3DSNAPSHOTDELEGATE_HXX
