//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  visualization

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libvisualization

#if !defined(LIBVISUALIZATION) && !defined(IPLIB)
#   error IPLIB or LIBVISUALIZATION is not defined
#endif

/* Handwritten code should use VISUALIZATION_API, not VISUALIZATIONEXPORT */

#define VISUALIZATION_API VISUALIZATIONEXPORT

#if IPLIB==libvisualization || defined(LIBVISUALIZATION)
#   if defined(__lint)
#       define VISUALIZATIONEXPORT       __export(visualization)
#       define VISUALIZATIONGLOBAL       extern __global(visualization)
#       define VISUALIZATIONPRIVATE      extern __private(visualization)
#   elif defined(_WIN32)
#       define VISUALIZATIONEXPORT       __declspec(dllexport)
#       define VISUALIZATIONGLOBAL       extern __declspec(dllexport)
#       define VISUALIZATIONPRIVATE      extern
#   else
#       define VISUALIZATIONEXPORT
#       define VISUALIZATIONGLOBAL       extern
#       define VISUALIZATIONPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define VISUALIZATIONEXPORT       __export(visualization)
#       define VISUALIZATIONGLOBAL       extern __global(visualization)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define VISUALIZATIONEXPORT      __declspec(dllimport)
#       define VISUALIZATIONGLOBAL       extern __declspec(dllimport)
#   else
#       define VISUALIZATIONEXPORT
#       define VISUALIZATIONGLOBAL       extern
#   endif
#endif
