//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BidPackage
    Filename:   BidPackage.hxx
    Module:     vm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BIDPACKAGE__HXX
#define TEAMCENTER__BIDPACKAGE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <vm/libvm_exports.h>

namespace Teamcenter
{
    class BidPackage;
}
namespace Teamcenter
{
    class BidPackageImpl;
}
namespace Teamcenter
{
    class BidPackageDelegate;
}
namespace Teamcenter
{
    class BidPackageDispatch;
}
namespace Teamcenter
{
    class BidPackageGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VM_API  Teamcenter::BidPackage
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    BidPackage();

    /**
     * Destructor
     */
    virtual ~BidPackage();

private:
    //  Getter method for the Implementation Object
    BidPackageImpl*  getBidPackageImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBidPackageImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    BidPackageImpl*  m_bidpackageImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param BidPackage - desc for BidPackage parameter
     */
    BidPackage( const BidPackage& );
    BidPackage& operator=( const BidPackage& );

    friend class  BidPackageDelegate;
    friend class  BidPackageDispatch;
    friend class  BidPackageGenImpl;
};

#include <vm/libvm_undef.h>
#endif //   TEAMCENTER__BIDPACKAGE__HXX
