//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BidPackageContent
    Filename:   BidPackageContent.hxx
    Module:     vm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BIDPACKAGECONTENT__HXX
#define TEAMCENTER__BIDPACKAGECONTENT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <vm/libvm_exports.h>

namespace Teamcenter
{
    class BidPackageContent;
}
namespace Teamcenter
{
    class BidPackageContentImpl;
}
namespace Teamcenter
{
    class BidPackageContentDelegate;
}
namespace Teamcenter
{
    class BidPackageContentDispatch;
}
namespace Teamcenter
{
    class BidPackageContentGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VM_API  Teamcenter::BidPackageContent
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    BidPackageContent();

    /**
     * Destructor
     */
    virtual ~BidPackageContent();

private:
    //  Getter method for the Implementation Object
    BidPackageContentImpl*  getBidPackageContentImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBidPackageContentImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    BidPackageContentImpl*  m_bidpackagecontentImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param BidPackageContent - desc for BidPackageContent parameter
     */
    BidPackageContent( const BidPackageContent& );
    BidPackageContent& operator=( const BidPackageContent& );

    friend class  BidPackageContentDelegate;
    friend class  BidPackageContentDispatch;
    friend class  BidPackageContentGenImpl;
};

#include <vm/libvm_undef.h>
#endif //   TEAMCENTER__BIDPACKAGECONTENT__HXX
