//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BidPackageContentDelegate
    Filename:   BidPackageContentDelegate.hxx
    Module:     vm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BIDPACKAGECONTENTDELEGATE_HXX
#define TEAMCENTER__BIDPACKAGECONTENTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <vm/BidPackageContent.hxx>

#include <vm/libvm_exports.h>

namespace Teamcenter
{
    class BidPackageContentDelegate;
}
namespace Teamcenter
{
    class BidPackageContentImpl;
}
namespace Teamcenter
{
    class BidPackageContent;
}
namespace Teamcenter
{
    class BidPackageContentGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  VM_API Teamcenter_alias::BidPackageContentDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the BidPackageContentDelegate instance
    static BidPackageContentDelegate&  getInstance();

    //  Method to create the BidPackageContentImpl pointer
    static BidPackageContentImpl*  createImpl( BidPackageContent&  ifObj );

    //  Method to delete the BidPackageContentImpl pointer
    static void deleteImpl( BidPackageContentImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static BidPackageContentDelegate*  m_pInstance;

    BidPackageContentDelegate();
    virtual ~BidPackageContentDelegate();
    static void setInstance( BidPackageContentDelegate*  instance );


private:
    friend class  ::Teamcenter::BidPackageContentGenImpl;

};

#include <vm/libvm_undef.h>
#endif  //  TEAMCENTER__BIDPACKAGECONTENTDELEGATE_HXX
