//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BidPackageLineItem
    Filename:   BidPackageLineItem.hxx
    Module:     vm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BIDPACKAGELINEITEM__HXX
#define TEAMCENTER__BIDPACKAGELINEITEM__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <vm/libvm_exports.h>

namespace Teamcenter
{
    class BidPackageLineItem;
}
namespace Teamcenter
{
    class BidPackageLineItemImpl;
}
namespace Teamcenter
{
    class BidPackageLineItemDelegate;
}
namespace Teamcenter
{
    class BidPackageLineItemDispatch;
}
namespace Teamcenter
{
    class BidPackageLineItemGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VM_API  Teamcenter::BidPackageLineItem
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    BidPackageLineItem();

    /**
     * Destructor
     */
    virtual ~BidPackageLineItem();

private:
    //  Getter method for the Implementation Object
    BidPackageLineItemImpl*  getBidPackageLineItemImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBidPackageLineItemImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    BidPackageLineItemImpl*  m_bidpackagelineitemImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param BidPackageLineItem - desc for BidPackageLineItem parameter
     */
    BidPackageLineItem( const BidPackageLineItem& );
    BidPackageLineItem& operator=( const BidPackageLineItem& );

    friend class  BidPackageLineItemDelegate;
    friend class  BidPackageLineItemDispatch;
    friend class  BidPackageLineItemGenImpl;
};

#include <vm/libvm_undef.h>
#endif //   TEAMCENTER__BIDPACKAGELINEITEM__HXX
