//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BidPackageRevision
    Filename:   BidPackageRevision.hxx
    Module:     vm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BIDPACKAGEREVISION__HXX
#define TEAMCENTER__BIDPACKAGEREVISION__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <vm/libvm_exports.h>

namespace Teamcenter
{
    class BidPackageRevision;
}
namespace Teamcenter
{
    class BidPackageRevisionImpl;
}
namespace Teamcenter
{
    class BidPackageRevisionDelegate;
}
namespace Teamcenter
{
    class BidPackageRevisionDispatch;
}
namespace Teamcenter
{
    class BidPackageRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VM_API  Teamcenter::BidPackageRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getLineitems( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 8.2
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setLineitems( const std::vector< tag_t > &values, const std::vector< int > *isNull=0 );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    BidPackageRevision();

    /**
     * Destructor
     */
    virtual ~BidPackageRevision();

private:
    //  Getter method for the Implementation Object
    BidPackageRevisionImpl*  getBidPackageRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setBidPackageRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    BidPackageRevisionImpl*  m_bidpackagerevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param BidPackageRevision - desc for BidPackageRevision parameter
     */
    BidPackageRevision( const BidPackageRevision& );
    BidPackageRevision& operator=( const BidPackageRevision& );

    friend class  BidPackageRevisionDelegate;
    friend class  BidPackageRevisionDispatch;
    friend class  BidPackageRevisionGenImpl;
};

#include <vm/libvm_undef.h>
#endif //   TEAMCENTER__BIDPACKAGEREVISION__HXX
