//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, BidPackageRevisionDelegate
    Filename:   BidPackageRevisionDelegate.hxx
    Module:     vm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__BIDPACKAGEREVISIONDELEGATE_HXX
#define TEAMCENTER__BIDPACKAGEREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <vm/BidPackageRevision.hxx>

#include <vm/libvm_exports.h>

namespace Teamcenter
{
    class BidPackageRevisionDelegate;
}
namespace Teamcenter
{
    class BidPackageRevisionImpl;
}
namespace Teamcenter
{
    class BidPackageRevision;
}
namespace Teamcenter
{
    class BidPackageRevisionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  VM_API Teamcenter_alias::BidPackageRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the BidPackageRevisionDelegate instance
    static BidPackageRevisionDelegate&  getInstance();

    //  Method to create the BidPackageRevisionImpl pointer
    static BidPackageRevisionImpl*  createImpl( BidPackageRevision&  ifObj );

    //  Method to delete the BidPackageRevisionImpl pointer
    static void deleteImpl( BidPackageRevisionImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getLineitemsBase(const BidPackageRevision &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Setter for a Tag Array Property
    /// @version Teamcenter 8.2
    /// @param values - Values to be set for the parameter
    /// @param isNull - If array element is true, set the parameter value at that location as null
    /// @return - Status. 0 if successful
    ///
    int  setLineitemsBase(BidPackageRevision &ifObj,  const std::vector< tag_t > &values, const std::vector< int > *isNull );


    ///
    /// Description for the Finalize Create Input
    /// @version Tc 8
    /// @param creInput - desc for  creInput parameter
    /// @return - Return desc for Initialize for Create
    ///
    int  finalizeCreateInputBase(const BidPackageRevision &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static BidPackageRevisionDelegate*  m_pInstance;

    BidPackageRevisionDelegate();
    virtual ~BidPackageRevisionDelegate();
    static void setInstance( BidPackageRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::BidPackageRevisionGenImpl;

};

#include <vm/libvm_undef.h>
#endif  //  TEAMCENTER__BIDPACKAGEREVISIONDELEGATE_HXX
