//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, CommercialPart
    Filename:   CommercialPart.hxx
    Module:     vm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__COMMERCIALPART__HXX
#define TEAMCENTER__COMMERCIALPART__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/Part.hxx>

#include <vm/libvm_exports.h>

namespace Teamcenter
{
    class CommercialPart;
}
namespace Teamcenter
{
    class CommercialPartImpl;
}
namespace Teamcenter
{
    class CommercialPartDelegate;
}
namespace Teamcenter
{
    class CommercialPartDispatch;
}
namespace Teamcenter
{
    class CommercialPartGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VM_API  Teamcenter::CommercialPart
     : public  ::Teamcenter::Part
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    CommercialPart();

    /**
     * Destructor
     */
    virtual ~CommercialPart();

private:
    //  Getter method for the Implementation Object
    CommercialPartImpl*  getCommercialPartImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setCommercialPartImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    CommercialPartImpl*  m_commercialpartImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param CommercialPart - desc for CommercialPart parameter
     */
    CommercialPart( const CommercialPart& );
    CommercialPart& operator=( const CommercialPart& );

    friend class  CommercialPartDelegate;
    friend class  CommercialPartDispatch;
    friend class  CommercialPartGenImpl;
};

#include <vm/libvm_undef.h>
#endif //   TEAMCENTER__COMMERCIALPART__HXX
