//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, LineItemConfigContext
    Filename:   LineItemConfigContext.hxx
    Module:     vm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LINEITEMCONFIGCONTEXT__HXX
#define TEAMCENTER__LINEITEMCONFIGCONTEXT__HXX

#include <common/tc_deprecation_macros.h>
#include <collabctx/ConfigurationContext.hxx>

#include <vm/libvm_exports.h>

namespace Teamcenter
{
    class LineItemConfigContext;
}
namespace Teamcenter
{
    class LineItemConfigContextImpl;
}
namespace Teamcenter
{
    class LineItemConfigContextDelegate;
}
namespace Teamcenter
{
    class LineItemConfigContextDispatch;
}
namespace Teamcenter
{
    class LineItemConfigContextGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VM_API  Teamcenter::LineItemConfigContext
     : public  ::Teamcenter::ConfigurationContext
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    LineItemConfigContext();

    /**
     * Destructor
     */
    virtual ~LineItemConfigContext();

private:
    //  Getter method for the Implementation Object
    LineItemConfigContextImpl*  getLineItemConfigContextImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setLineItemConfigContextImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    LineItemConfigContextImpl*  m_lineitemconfigcontextImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param LineItemConfigContext - desc for LineItemConfigContext parameter
     */
    LineItemConfigContext( const LineItemConfigContext& );
    LineItemConfigContext& operator=( const LineItemConfigContext& );

    friend class  LineItemConfigContextDelegate;
    friend class  LineItemConfigContextDispatch;
    friend class  LineItemConfigContextGenImpl;
};

#include <vm/libvm_undef.h>
#endif //   TEAMCENTER__LINEITEMCONFIGCONTEXT__HXX
