//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, LineItemConfigContextDelegate
    Filename:   LineItemConfigContextDelegate.hxx
    Module:     vm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__LINEITEMCONFIGCONTEXTDELEGATE_HXX
#define TEAMCENTER__LINEITEMCONFIGCONTEXTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <vm/LineItemConfigContext.hxx>

#include <vm/libvm_exports.h>

namespace Teamcenter
{
    class LineItemConfigContextDelegate;
}
namespace Teamcenter
{
    class LineItemConfigContextImpl;
}
namespace Teamcenter
{
    class LineItemConfigContext;
}
namespace Teamcenter
{
    class LineItemConfigContextGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  VM_API Teamcenter_alias::LineItemConfigContextDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the LineItemConfigContextDelegate instance
    static LineItemConfigContextDelegate&  getInstance();

    //  Method to create the LineItemConfigContextImpl pointer
    static LineItemConfigContextImpl*  createImpl( LineItemConfigContext&  ifObj );

    //  Method to delete the LineItemConfigContextImpl pointer
    static void deleteImpl( LineItemConfigContextImpl*  impl );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference information to the object to be saved
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0SaveBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );



protected:
    //  Pointer to the instance
    static LineItemConfigContextDelegate*  m_pInstance;

    LineItemConfigContextDelegate();
    virtual ~LineItemConfigContextDelegate();
    static void setInstance( LineItemConfigContextDelegate*  instance );


private:
    friend class  ::Teamcenter::LineItemConfigContextGenImpl;

};

#include <vm/libvm_undef.h>
#endif  //  TEAMCENTER__LINEITEMCONFIGCONTEXTDELEGATE_HXX
