//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ManufacturerPart
    Filename:   ManufacturerPart.hxx
    Module:     vm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MANUFACTURERPART__HXX
#define TEAMCENTER__MANUFACTURERPART__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <tccore/Part.hxx>

#include <vm/libvm_exports.h>

namespace Teamcenter
{
    class ManufacturerPart;
}
namespace Teamcenter
{
    class ManufacturerPartImpl;
}
namespace Teamcenter
{
    class ManufacturerPartDelegate;
}
namespace Teamcenter
{
    class ManufacturerPartDispatch;
}
namespace Teamcenter
{
    class ManufacturerPartGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VM_API  Teamcenter::ManufacturerPart
     : public  ::Teamcenter::Part
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getVm0Location( tag_t &value, bool &isNull ) const;

    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setVm0location( const tag_t &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ManufacturerPart();

    /**
     * Destructor
     */
    virtual ~ManufacturerPart();

private:
    //  Getter method for the Implementation Object
    ManufacturerPartImpl*  getManufacturerPartImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setManufacturerPartImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ManufacturerPartImpl*  m_manufacturerpartImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ManufacturerPart - desc for ManufacturerPart parameter
     */
    ManufacturerPart( const ManufacturerPart& );
    ManufacturerPart& operator=( const ManufacturerPart& );

    friend class  ManufacturerPartDelegate;
    friend class  ManufacturerPartDispatch;
    friend class  ManufacturerPartGenImpl;
};

#include <vm/libvm_undef.h>
#endif //   TEAMCENTER__MANUFACTURERPART__HXX
