//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ManufacturerPartDelegate
    Filename:   ManufacturerPartDelegate.hxx
    Module:     vm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__MANUFACTURERPARTDELEGATE_HXX
#define TEAMCENTER__MANUFACTURERPARTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <vm/ManufacturerPart.hxx>

#include <vm/libvm_exports.h>

namespace Teamcenter
{
    class ManufacturerPartDelegate;
}
namespace Teamcenter
{
    class ManufacturerPartImpl;
}
namespace Teamcenter
{
    class ManufacturerPart;
}
namespace Teamcenter
{
    class ManufacturerPartGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  VM_API Teamcenter_alias::ManufacturerPartDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ManufacturerPartDelegate instance
    static ManufacturerPartDelegate&  getInstance();

    //  Method to create the ManufacturerPartImpl pointer
    static ManufacturerPartImpl*  createImpl( ManufacturerPart&  ifObj );

    //  Method to delete the ManufacturerPartImpl pointer
    static void deleteImpl( ManufacturerPartImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getVm0LocationBase(const ManufacturerPart &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// Setter for a Tag Property
    /// @version Teamcenter 10
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setVm0locationBase(ManufacturerPart &ifObj,  const tag_t &value, bool isNull );


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const ManufacturerPart &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const ManufacturerPart &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static ManufacturerPartDelegate*  m_pInstance;

    ManufacturerPartDelegate();
    virtual ~ManufacturerPartDelegate();
    static void setInstance( ManufacturerPartDelegate*  instance );


private:
    friend class  ::Teamcenter::ManufacturerPartGenImpl;

};

#include <vm/libvm_undef.h>
#endif  //  TEAMCENTER__MANUFACTURERPARTDELEGATE_HXX
