//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ProvidedFrom
    Filename:   ProvidedFrom.hxx
    Module:     vm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROVIDEDFROM__HXX
#define TEAMCENTER__PROVIDEDFROM__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <vm/libvm_exports.h>

namespace Teamcenter
{
    class ProvidedFrom;
}
namespace Teamcenter
{
    class ProvidedFromImpl;
}
namespace Teamcenter
{
    class ProvidedFromDelegate;
}
namespace Teamcenter
{
    class ProvidedFromDispatch;
}
namespace Teamcenter
{
    class ProvidedFromGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VM_API  Teamcenter::ProvidedFrom
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ProvidedFrom();

    /**
     * Destructor
     */
    virtual ~ProvidedFrom();

private:
    //  Getter method for the Implementation Object
    ProvidedFromImpl*  getProvidedFromImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setProvidedFromImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ProvidedFromImpl*  m_providedfromImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ProvidedFrom - desc for ProvidedFrom parameter
     */
    ProvidedFrom( const ProvidedFrom& );
    ProvidedFrom& operator=( const ProvidedFrom& );

    friend class  ProvidedFromDelegate;
    friend class  ProvidedFromDispatch;
    friend class  ProvidedFromGenImpl;
};

#include <vm/libvm_undef.h>
#endif //   TEAMCENTER__PROVIDEDFROM__HXX
