//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, VMRepresents
    Filename:   VMRepresents.hxx
    Module:     vm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VMREPRESENTS__HXX
#define TEAMCENTER__VMREPRESENTS__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/ImanRelation.hxx>

#include <vm/libvm_exports.h>

namespace Teamcenter
{
    class VMRepresents;
}
namespace Teamcenter
{
    class VMRepresentsImpl;
}
namespace Teamcenter
{
    class VMRepresentsDelegate;
}
namespace Teamcenter
{
    class VMRepresentsDispatch;
}
namespace Teamcenter
{
    class VMRepresentsGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VM_API  Teamcenter::VMRepresents
     : public  ::Teamcenter::ImanRelation
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPreferred_status( std::string &value, bool &isNull ) const;

    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPreferred_status( const std::string &value, bool isNull=false );
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    VMRepresents();

    /**
     * Destructor
     */
    virtual ~VMRepresents();

private:
    //  Getter method for the Implementation Object
    VMRepresentsImpl*  getVMRepresentsImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setVMRepresentsImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    VMRepresentsImpl*  m_vmrepresentsImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param VMRepresents - desc for VMRepresents parameter
     */
    VMRepresents( const VMRepresents& );
    VMRepresents& operator=( const VMRepresents& );

    friend class  VMRepresentsDelegate;
    friend class  VMRepresentsDispatch;
    friend class  VMRepresentsGenImpl;
};

#include <vm/libvm_undef.h>
#endif //   TEAMCENTER__VMREPRESENTS__HXX
