//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, VMRepresentsDelegate
    Filename:   VMRepresentsDelegate.hxx
    Module:     vm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VMREPRESENTSDELEGATE_HXX
#define TEAMCENTER__VMREPRESENTSDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <vm/VMRepresents.hxx>

#include <vm/libvm_exports.h>

namespace Teamcenter
{
    class VMRepresentsDelegate;
}
namespace Teamcenter
{
    class VMRepresentsImpl;
}
namespace Teamcenter
{
    class VMRepresents;
}
namespace Teamcenter
{
    class VMRepresentsGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  VM_API Teamcenter_alias::VMRepresentsDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the VMRepresentsDelegate instance
    static VMRepresentsDelegate&  getInstance();

    //  Method to create the VMRepresentsImpl pointer
    static VMRepresentsImpl*  createImpl( VMRepresents&  ifObj );

    //  Method to delete the VMRepresentsImpl pointer
    static void deleteImpl( VMRepresentsImpl*  impl );


    ///
    /// Getter for a string Property
    /// @version Tc 8
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getPreferred_statusBase(const VMRepresents &ifObj,  std::string &value, bool &isNull ) const;


    ///
    /// Setter for a string Property
    /// @version Tc 8
    /// @param value - Value to be set for the parameter
    /// @param isNull - If true, set the parameter value to null
    /// @return - Status. 0 if successful
    ///
    int  setPreferred_statusBase(VMRepresents &ifObj,  const std::string &value, bool isNull );



protected:
    //  Pointer to the instance
    static VMRepresentsDelegate*  m_pInstance;

    VMRepresentsDelegate();
    virtual ~VMRepresentsDelegate();
    static void setInstance( VMRepresentsDelegate*  instance );


private:
    friend class  ::Teamcenter::VMRepresentsGenImpl;

};

#include <vm/libvm_undef.h>
#endif  //  TEAMCENTER__VMREPRESENTSDELEGATE_HXX
