//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Vendor
    Filename:   Vendor.hxx
    Module:     vm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VENDOR__HXX
#define TEAMCENTER__VENDOR__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/Item.hxx>

#include <vm/libvm_exports.h>

namespace Teamcenter
{
    class Vendor;
}
namespace Teamcenter
{
    class VendorImpl;
}
namespace Teamcenter
{
    class VendorDelegate;
}
namespace Teamcenter
{
    class VendorDispatch;
}
namespace Teamcenter
{
    class VendorGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VM_API  Teamcenter::Vendor
     : public  ::Teamcenter::Item
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCommercialparts( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getVendorparts( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Vendor();

    /**
     * Destructor
     */
    virtual ~Vendor();

private:
    //  Getter method for the Implementation Object
    VendorImpl*  getVendorImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setVendorImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    VendorImpl*  m_vendorImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Vendor - desc for Vendor parameter
     */
    Vendor( const Vendor& );
    Vendor& operator=( const Vendor& );

    friend class  VendorDelegate;
    friend class  VendorDispatch;
    friend class  VendorGenImpl;
};

#include <vm/libvm_undef.h>
#endif //   TEAMCENTER__VENDOR__HXX
