//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, VendorDelegate
    Filename:   VendorDelegate.hxx
    Module:     vm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VENDORDELEGATE_HXX
#define TEAMCENTER__VENDORDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <vm/Vendor.hxx>

#include <vm/libvm_exports.h>

namespace Teamcenter
{
    class VendorDelegate;
}
namespace Teamcenter
{
    class VendorImpl;
}
namespace Teamcenter
{
    class Vendor;
}
namespace Teamcenter
{
    class VendorGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  VM_API Teamcenter_alias::VendorDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the VendorDelegate instance
    static VendorDelegate&  getInstance();

    //  Method to create the VendorImpl pointer
    static VendorImpl*  createImpl( Vendor&  ifObj );

    //  Method to delete the VendorImpl pointer
    static void deleteImpl( VendorImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getCommercialpartsBase(const Vendor &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getVendorpartsBase(const Vendor &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Vendor &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Generic saveAsPost operation.
    /// @version Teamcenter 8.1
    /// @param pSavAsInput - Input argument as SaveAsInput object.
    /// @param vecDeepCopyData - vector deepcopy data
    /// @return - Return integer value.
    ///
    int  saveAsPostBase(const Vendor &ifObj,  ::Teamcenter::SaveAsInput *pSavAsInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static VendorDelegate*  m_pInstance;

    VendorDelegate();
    virtual ~VendorDelegate();
    static void setInstance( VendorDelegate*  instance );


private:
    friend class  ::Teamcenter::VendorGenImpl;

};

#include <vm/libvm_undef.h>
#endif  //  TEAMCENTER__VENDORDELEGATE_HXX
