//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, VendorRevision
    Filename:   VendorRevision.hxx
    Module:     vm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VENDORREVISION__HXX
#define TEAMCENTER__VENDORREVISION__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <vm/libvm_exports.h>

namespace Teamcenter
{
    class VendorRevision;
}
namespace Teamcenter
{
    class VendorRevisionImpl;
}
namespace Teamcenter
{
    class VendorRevisionDelegate;
}
namespace Teamcenter
{
    class VendorRevisionDispatch;
}
namespace Teamcenter
{
    class VendorRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VM_API  Teamcenter::VendorRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getVendor_role_info( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    VendorRevision();

    /**
     * Destructor
     */
    virtual ~VendorRevision();

private:
    //  Getter method for the Implementation Object
    VendorRevisionImpl*  getVendorRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setVendorRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    VendorRevisionImpl*  m_vendorrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param VendorRevision - desc for VendorRevision parameter
     */
    VendorRevision( const VendorRevision& );
    VendorRevision& operator=( const VendorRevision& );

    friend class  VendorRevisionDelegate;
    friend class  VendorRevisionDispatch;
    friend class  VendorRevisionGenImpl;
};

#include <vm/libvm_undef.h>
#endif //   TEAMCENTER__VENDORREVISION__HXX
