//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, VendorRevisionDelegate
    Filename:   VendorRevisionDelegate.hxx
    Module:     vm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VENDORREVISIONDELEGATE_HXX
#define TEAMCENTER__VENDORREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <vm/VendorRevision.hxx>

#include <vm/libvm_exports.h>

namespace Teamcenter
{
    class VendorRevisionDelegate;
}
namespace Teamcenter
{
    class VendorRevisionImpl;
}
namespace Teamcenter
{
    class VendorRevision;
}
namespace Teamcenter
{
    class VendorRevisionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  VM_API Teamcenter_alias::VendorRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the VendorRevisionDelegate instance
    static VendorRevisionDelegate&  getInstance();

    //  Method to create the VendorRevisionImpl pointer
    static VendorRevisionImpl*  createImpl( VendorRevision&  ifObj );

    //  Method to delete the VendorRevisionImpl pointer
    static void deleteImpl( VendorRevisionImpl*  impl );


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 8.2
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getVendor_role_infoBase(const VendorRevision &ifObj,  std::vector< tag_t > &values, std::vector< int > &isNull ) const;



protected:
    //  Pointer to the instance
    static VendorRevisionDelegate*  m_pInstance;

    VendorRevisionDelegate();
    virtual ~VendorRevisionDelegate();
    static void setInstance( VendorRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::VendorRevisionGenImpl;

};

#include <vm/libvm_undef.h>
#endif  //  TEAMCENTER__VENDORREVISIONDELEGATE_HXX
