//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, VendorRole
    Filename:   VendorRole.hxx
    Module:     vm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VENDORROLE__HXX
#define TEAMCENTER__VENDORROLE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <vm/libvm_exports.h>

namespace Teamcenter
{
    class VendorRole;
}
namespace Teamcenter
{
    class VendorRoleImpl;
}
namespace Teamcenter
{
    class VendorRoleDelegate;
}
namespace Teamcenter
{
    class VendorRoleDispatch;
}
namespace Teamcenter
{
    class VendorRoleGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VM_API  Teamcenter::VendorRole
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    VendorRole();

    /**
     * Destructor
     */
    virtual ~VendorRole();

private:
    //  Getter method for the Implementation Object
    VendorRoleImpl*  getVendorRoleImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setVendorRoleImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    VendorRoleImpl*  m_vendorroleImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param VendorRole - desc for VendorRole parameter
     */
    VendorRole( const VendorRole& );
    VendorRole& operator=( const VendorRole& );

    friend class  VendorRoleDelegate;
    friend class  VendorRoleDispatch;
    friend class  VendorRoleGenImpl;
};

#include <vm/libvm_undef.h>
#endif //   TEAMCENTER__VENDORROLE__HXX
