//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Vm0ExchangeLine
    Filename:   Vm0ExchangeLine.hxx
    Module:     vm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VM0EXCHANGELINE__HXX
#define TEAMCENTER__VM0EXCHANGELINE__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <vm/libvm_exports.h>

namespace Teamcenter
{
    class Vm0ExchangeLine;
}
namespace Teamcenter
{
    class Vm0ExchangeLineImpl;
}
namespace Teamcenter
{
    class Vm0ExchangeLineDelegate;
}
namespace Teamcenter
{
    class Vm0ExchangeLineDispatch;
}
namespace Teamcenter
{
    class Vm0ExchangeLineGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VM_API  Teamcenter::Vm0ExchangeLine
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Vm0ExchangeLine();

    /**
     * Destructor
     */
    virtual ~Vm0ExchangeLine();

private:
    //  Getter method for the Implementation Object
    Vm0ExchangeLineImpl*  getVm0ExchangeLineImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setVm0ExchangeLineImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Vm0ExchangeLineImpl*  m_vm0exchangelineImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Vm0ExchangeLine - desc for Vm0ExchangeLine parameter
     */
    Vm0ExchangeLine( const Vm0ExchangeLine& );
    Vm0ExchangeLine& operator=( const Vm0ExchangeLine& );

    friend class  Vm0ExchangeLineDelegate;
    friend class  Vm0ExchangeLineDispatch;
    friend class  Vm0ExchangeLineGenImpl;
};

#include <vm/libvm_undef.h>
#endif //   TEAMCENTER__VM0EXCHANGELINE__HXX
