//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Vm0PrtnrContractRevision
    Filename:   Vm0PrtnrContractRevision.hxx
    Module:     vm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VM0PRTNRCONTRACTREVISION__HXX
#define TEAMCENTER__VM0PRTNRCONTRACTREVISION__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <vm/libvm_exports.h>

namespace Teamcenter
{
    class Vm0PrtnrContractRevision;
}
namespace Teamcenter
{
    class Vm0PrtnrContractRevisionImpl;
}
namespace Teamcenter
{
    class Vm0PrtnrContractRevisionDelegate;
}
namespace Teamcenter
{
    class Vm0PrtnrContractRevisionDispatch;
}
namespace Teamcenter
{
    class Vm0PrtnrContractRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VM_API  Teamcenter::Vm0PrtnrContractRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 12.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getVm0isContractActive( bool &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Vm0PrtnrContractRevision();

    /**
     * Destructor
     */
    virtual ~Vm0PrtnrContractRevision();

private:
    //  Getter method for the Implementation Object
    Vm0PrtnrContractRevisionImpl*  getVm0PrtnrContractRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setVm0PrtnrContractRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Vm0PrtnrContractRevisionImpl*  m_vm0prtnrcontractrevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Vm0PrtnrContractRevision - desc for Vm0PrtnrContractRevision parameter
     */
    Vm0PrtnrContractRevision( const Vm0PrtnrContractRevision& );
    Vm0PrtnrContractRevision& operator=( const Vm0PrtnrContractRevision& );

    friend class  Vm0PrtnrContractRevisionDelegate;
    friend class  Vm0PrtnrContractRevisionDispatch;
    friend class  Vm0PrtnrContractRevisionGenImpl;
};

#include <vm/libvm_undef.h>
#endif //   TEAMCENTER__VM0PRTNRCONTRACTREVISION__HXX
