//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Vm0PrtnrContractRevisionDelegate
    Filename:   Vm0PrtnrContractRevisionDelegate.hxx
    Module:     vm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VM0PRTNRCONTRACTREVISIONDELEGATE_HXX
#define TEAMCENTER__VM0PRTNRCONTRACTREVISIONDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <vm/Vm0PrtnrContractRevision.hxx>

#include <vm/libvm_exports.h>

namespace Teamcenter
{
    class Vm0PrtnrContractRevisionDelegate;
}
namespace Teamcenter
{
    class Vm0PrtnrContractRevisionImpl;
}
namespace Teamcenter
{
    class Vm0PrtnrContractRevision;
}
namespace Teamcenter
{
    class Vm0PrtnrContractRevisionGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  VM_API Teamcenter_alias::Vm0PrtnrContractRevisionDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the Vm0PrtnrContractRevisionDelegate instance
    static Vm0PrtnrContractRevisionDelegate&  getInstance();

    //  Method to create the Vm0PrtnrContractRevisionImpl pointer
    static Vm0PrtnrContractRevisionImpl*  createImpl( Vm0PrtnrContractRevision&  ifObj );

    //  Method to delete the Vm0PrtnrContractRevisionImpl pointer
    static void deleteImpl( Vm0PrtnrContractRevisionImpl*  impl );


    ///
    /// Getter for a Boolean Property
    /// @version Teamcenter 12.3
    /// @param value - Parameter Value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getVm0isContractActiveBase(const Vm0PrtnrContractRevision &ifObj,  bool &value, bool &isNull ) const;


    ///
    /// desc for createPost
    /// @version Tc 8
    /// @param creInput - Description for the Create Input
    /// @return - return desc for createPost
    ///
    int  createPostBase(const Vm0PrtnrContractRevision &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// Generic revisePost operation.
    /// @version Teamcenter 10.1
    /// @param pReviseInput - Input ReviseInput object.
    /// @param vecDeepCopyData - Vector of deep copy data.
    /// @return - Returns an integer value.
    ///
    int  revisePostBase(const Vm0PrtnrContractRevision &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );


    ///
    /// Validate revise input.
    /// @version Teamcenter 10.1
    /// @param pReviseInput - desc
    /// @param vecDeepCopyData - desc
    /// @return - Returns an int.
    ///
    int  validateReviseInputBase(const Vm0PrtnrContractRevision &ifObj,  ::Teamcenter::ReviseInput *pReviseInput, std::vector<  ::Teamcenter::DeepCopyData* > *vecDeepCopyData );



protected:
    //  Pointer to the instance
    static Vm0PrtnrContractRevisionDelegate*  m_pInstance;

    Vm0PrtnrContractRevisionDelegate();
    virtual ~Vm0PrtnrContractRevisionDelegate();
    static void setInstance( Vm0PrtnrContractRevisionDelegate*  instance );


private:
    friend class  ::Teamcenter::Vm0PrtnrContractRevisionGenImpl;

};

#include <vm/libvm_undef.h>
#endif  //  TEAMCENTER__VM0PRTNRCONTRACTREVISIONDELEGATE_HXX
