//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Vm0SupplierResponseObject
    Filename:   Vm0SupplierResponseObject.hxx
    Module:     vm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VM0SUPPLIERRESPONSEOBJECT__HXX
#define TEAMCENTER__VM0SUPPLIERRESPONSEOBJECT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/WorkspaceObject.hxx>

#include <vm/libvm_exports.h>

namespace Teamcenter
{
    class Vm0SupplierResponseObject;
}
namespace Teamcenter
{
    class Vm0SupplierResponseObjectImpl;
}
namespace Teamcenter
{
    class Vm0SupplierResponseObjectDelegate;
}
namespace Teamcenter
{
    class Vm0SupplierResponseObjectDispatch;
}
namespace Teamcenter
{
    class Vm0SupplierResponseObjectGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VM_API  Teamcenter::Vm0SupplierResponseObject
     : public  ::Teamcenter::WorkspaceObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Vm0SupplierResponseObject();

    /**
     * Destructor
     */
    virtual ~Vm0SupplierResponseObject();

private:
    //  Getter method for the Implementation Object
    Vm0SupplierResponseObjectImpl*  getVm0SupplierResponseObjectImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setVm0SupplierResponseObjectImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Vm0SupplierResponseObjectImpl*  m_vm0supplierresponseobjectImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Vm0SupplierResponseObject - desc for Vm0SupplierResponseObject parameter
     */
    Vm0SupplierResponseObject( const Vm0SupplierResponseObject& );
    Vm0SupplierResponseObject& operator=( const Vm0SupplierResponseObject& );

    friend class  Vm0SupplierResponseObjectDelegate;
    friend class  Vm0SupplierResponseObjectDispatch;
    friend class  Vm0SupplierResponseObjectGenImpl;
};

#include <vm/libvm_undef.h>
#endif //   TEAMCENTER__VM0SUPPLIERRESPONSEOBJECT__HXX
