//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Vm0VendorXChangeRevision
    Filename:   Vm0VendorXChangeRevision.hxx
    Module:     vm
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__VM0VENDORXCHANGEREVISION__HXX
#define TEAMCENTER__VM0VENDORXCHANGEREVISION__HXX

#include <vector>
#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <vm/libvm_exports.h>

namespace Teamcenter
{
    class Vm0VendorXChangeRevision;
}
namespace Teamcenter
{
    class Vm0VendorXChangeRevisionImpl;
}
namespace Teamcenter
{
    class Vm0VendorXChangeRevisionDelegate;
}
namespace Teamcenter
{
    class Vm0VendorXChangeRevisionDispatch;
}
namespace Teamcenter
{
    class Vm0VendorXChangeRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  VM_API  Teamcenter::Vm0VendorXChangeRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getVm0ExchangeLines( std::vector< tag_t > &values, std::vector< int > &isNull ) const;

    ///
    /// Getter for a Tag Array Property
    /// @version Teamcenter 11.1
    /// @param values - Parameter value
    /// @param isNull - Returns true for an array element if the parameter value at that location is null
    /// @return - Status. 0 if successful
    ///
    int  getVm0ResponseLines( std::vector< tag_t > &values, std::vector< int > &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Vm0VendorXChangeRevision();

    /**
     * Destructor
     */
    virtual ~Vm0VendorXChangeRevision();

private:
    //  Getter method for the Implementation Object
    Vm0VendorXChangeRevisionImpl*  getVm0VendorXChangeRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setVm0VendorXChangeRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Vm0VendorXChangeRevisionImpl*  m_vm0vendorxchangerevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Vm0VendorXChangeRevision - desc for Vm0VendorXChangeRevision parameter
     */
    Vm0VendorXChangeRevision( const Vm0VendorXChangeRevision& );
    Vm0VendorXChangeRevision& operator=( const Vm0VendorXChangeRevision& );

    friend class  Vm0VendorXChangeRevisionDelegate;
    friend class  Vm0VendorXChangeRevisionDispatch;
    friend class  Vm0VendorXChangeRevisionGenImpl;
};

#include <vm/libvm_undef.h>
#endif //   TEAMCENTER__VM0VENDORXCHANGEREVISION__HXX
