//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  vm

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libvm

#if !defined(LIBVM) && !defined(IPLIB)
#   error IPLIB or LIBVM is not defined
#endif

/* Handwritten code should use VM_API, not VMEXPORT */

#define VM_API VMEXPORT

#if IPLIB==libvm || defined(LIBVM)
#   if defined(__lint)
#       define VMEXPORT       __export(vm)
#       define VMGLOBAL       extern __global(vm)
#       define VMPRIVATE      extern __private(vm)
#   elif defined(_WIN32)
#       define VMEXPORT       __declspec(dllexport)
#       define VMGLOBAL       extern __declspec(dllexport)
#       define VMPRIVATE      extern
#   else
#       define VMEXPORT
#       define VMGLOBAL       extern
#       define VMPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define VMEXPORT       __export(vm)
#       define VMGLOBAL       extern __global(vm)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define VMEXPORT      __declspec(dllimport)
#       define VMGLOBAL       extern __declspec(dllimport)
#   else
#       define VMEXPORT
#       define VMGLOBAL       extern
#   endif
#endif
