//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, Wpm0WorkPackageRevision
    Filename:   Wpm0WorkPackageRevision.hxx
    Module:     wpm0pkgmgmt
    @BMIDE autogenerated
==================================================================================================*/

#ifndef PKGMGMT__WPM0WORKPACKAGEREVISION__HXX
#define PKGMGMT__WPM0WORKPACKAGEREVISION__HXX

#include <string>
#include <common/tc_deprecation_macros.h>
#include <tccore/ItemRevision.hxx>

#include <wpm0pkgmgmt/libwpm0pkgmgmt_exports.h>

namespace pkgmgmt
{
    class Wpm0WorkPackageRevision;
}
namespace pkgmgmt
{
    class Wpm0WorkPackageRevisionImpl;
}
namespace pkgmgmt
{
    class Wpm0WorkPackageRevisionDelegate;
}
namespace pkgmgmt
{
    class Wpm0WorkPackageRevisionDispatch;
}
namespace pkgmgmt
{
    class Wpm0WorkPackageRevisionGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  WPM0PKGMGMT_API  pkgmgmt::Wpm0WorkPackageRevision
     : public  ::Teamcenter::ItemRevision
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getWpm0WorkPackageComplexity( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getWpm0WorkPackageSecurity( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getWpm0WorkPackageType( std::string &value, bool &isNull ) const;

    ///
    /// Getter for a string Property
    /// @version Teamcenter 10
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getWpm0WorkPackageVendor( std::string &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    Wpm0WorkPackageRevision();

    /**
     * Destructor
     */
    virtual ~Wpm0WorkPackageRevision();

private:
    //  Getter method for the Implementation Object
    Wpm0WorkPackageRevisionImpl*  getWpm0WorkPackageRevisionImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setWpm0WorkPackageRevisionImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    Wpm0WorkPackageRevisionImpl*  m_wpm0workpackagerevisionImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param Wpm0WorkPackageRevision - desc for Wpm0WorkPackageRevision parameter
     */
    Wpm0WorkPackageRevision( const Wpm0WorkPackageRevision& );
    Wpm0WorkPackageRevision& operator=( const Wpm0WorkPackageRevision& );

    friend class  Wpm0WorkPackageRevisionDelegate;
    friend class  Wpm0WorkPackageRevisionDispatch;
    friend class  Wpm0WorkPackageRevisionGenImpl;
};

#include <wpm0pkgmgmt/libwpm0pkgmgmt_undef.h>
#endif //   PKGMGMT__WPM0WORKPACKAGEREVISION__HXX
