//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ExportedProxyLink
    Filename:   ExportedProxyLink.hxx
    Module:     wproxy
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__EXPORTEDPROXYLINK__HXX
#define TEAMCENTER__EXPORTEDPROXYLINK__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <wproxy/libwproxy_exports.h>

namespace Teamcenter
{
    class ExportedProxyLink;
}
namespace Teamcenter
{
    class ExportedProxyLinkImpl;
}
namespace Teamcenter
{
    class ExportedProxyLinkDelegate;
}
namespace Teamcenter
{
    class ExportedProxyLinkDispatch;
}
namespace Teamcenter
{
    class ExportedProxyLinkGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  WPROXY_API  Teamcenter::ExportedProxyLink
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ExportedProxyLink();

    /**
     * Destructor
     */
    virtual ~ExportedProxyLink();

private:
    //  Getter method for the Implementation Object
    ExportedProxyLinkImpl*  getExportedProxyLinkImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setExportedProxyLinkImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ExportedProxyLinkImpl*  m_exportedproxylinkImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ExportedProxyLink - desc for ExportedProxyLink parameter
     */
    ExportedProxyLink( const ExportedProxyLink& );
    ExportedProxyLink& operator=( const ExportedProxyLink& );

    friend class  ExportedProxyLinkDelegate;
    friend class  ExportedProxyLinkDispatch;
    friend class  ExportedProxyLinkGenImpl;
};

#include <wproxy/libwproxy_undef.h>
#endif //   TEAMCENTER__EXPORTEDPROXYLINK__HXX
