//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ProxyLink
    Filename:   ProxyLink.hxx
    Module:     wproxy
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROXYLINK__HXX
#define TEAMCENTER__PROXYLINK__HXX

#include <unidefs.h>
#include <common/tc_deprecation_macros.h>
#include <wproxy/WolfObject.hxx>

#include <wproxy/libwproxy_exports.h>

namespace Teamcenter
{
    class ProxyLink;
}
namespace Teamcenter
{
    class ProxyLinkImpl;
}
namespace Teamcenter
{
    class ProxyLinkDelegate;
}
namespace Teamcenter
{
    class ProxyLinkDispatch;
}
namespace Teamcenter
{
    class ProxyLinkGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  WPROXY_API  Teamcenter::ProxyLink
     : public  ::Teamcenter::WolfObject
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ExtSite( tag_t &value, bool &isNull ) const;
protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ProxyLink();

    /**
     * Destructor
     */
    virtual ~ProxyLink();

private:
    //  Getter method for the Implementation Object
    ProxyLinkImpl*  getProxyLinkImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setProxyLinkImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ProxyLinkImpl*  m_proxylinkImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ProxyLink - desc for ProxyLink parameter
     */
    ProxyLink( const ProxyLink& );
    ProxyLink& operator=( const ProxyLink& );

    friend class  ProxyLinkDelegate;
    friend class  ProxyLinkDispatch;
    friend class  ProxyLinkGenImpl;
};

#include <wproxy/libwproxy_undef.h>
#endif //   TEAMCENTER__PROXYLINK__HXX
