//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ProxyLinkDelegate
    Filename:   ProxyLinkDelegate.hxx
    Module:     wproxy
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROXYLINKDELEGATE_HXX
#define TEAMCENTER__PROXYLINKDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <wproxy/ProxyLink.hxx>

#include <wproxy/libwproxy_exports.h>

namespace Teamcenter
{
    class ProxyLinkDelegate;
}
namespace Teamcenter
{
    class ProxyLinkImpl;
}
namespace Teamcenter
{
    class ProxyLink;
}
namespace Teamcenter
{
    class ProxyLinkGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  WPROXY_API Teamcenter_alias::ProxyLinkDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the ProxyLinkDelegate instance
    static ProxyLinkDelegate&  getInstance();

    //  Method to create the ProxyLinkImpl pointer
    static ProxyLinkImpl*  createImpl( ProxyLink&  ifObj );

    //  Method to delete the ProxyLinkImpl pointer
    static void deleteImpl( ProxyLinkImpl*  impl );


    ///
    /// Getter for a Tag Property
    /// @version Teamcenter 11.1
    /// @param value - Parameter value
    /// @param isNull - Returns true if the Parameter value is null
    /// @return - Status. 0 if successful
    ///
    int  getFnd0ExtSiteBase(const ProxyLink &ifObj,  tag_t &value, bool &isNull ) const;


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @param isLockForDelete - A boolean to indicate if object(s) are to be locked for deletion
    /// @param allowRelock - A boolean to indicate if object(s) can be relocked, which will discard all unsaved changes, if already locked by the same user
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0LockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd, const bool isLockForDelete, const bool allowRelock );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0RefreshBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// This operation is not supported now, there will be no support for issues stemming from uses of this operation.
    /// @version Teamcenter 11.2.2
    /// @param inputs - A vector of data that contains reference to the object to be refreshed
    /// @param bd - A data structure to store objects and other information relevant for set-based operation
    /// @return - This operation returns ITK_ok on success. Otherwise, it will return specific error code.
    ///
    int  fnd0UnlockBase( std::vector<  ::Teamcenter::BulkInput* > *inputs, ::Teamcenter::BulkData *bd );


    ///
    /// desc for setPropertiesFromCreateInpu
    /// @version Tc 8
    /// @param creInput - Description for CreateInput
    /// @return - return desc for setPropertiesFromCreateInput
    ///
    int  setPropertiesFromCreateInputBase(const ProxyLink &ifObj,  ::Teamcenter::CreateInput *creInput );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const ProxyLink &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static ProxyLinkDelegate*  m_pInstance;

    ProxyLinkDelegate();
    virtual ~ProxyLinkDelegate();
    static void setInstance( ProxyLinkDelegate*  instance );


private:
    friend class  ::Teamcenter::ProxyLinkGenImpl;

};

#include <wproxy/libwproxy_undef.h>
#endif  //  TEAMCENTER__PROXYLINKDELEGATE_HXX
