//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ProxyLinkEng
    Filename:   ProxyLinkEng.hxx
    Module:     wproxy
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROXYLINKENG__HXX
#define TEAMCENTER__PROXYLINKENG__HXX

#include <common/tc_deprecation_macros.h>
#include <wproxy/ProxyLink.hxx>

#include <wproxy/libwproxy_exports.h>

namespace Teamcenter
{
    class ProxyLinkEng;
}
namespace Teamcenter
{
    class ProxyLinkEngImpl;
}
namespace Teamcenter
{
    class ProxyLinkEngDelegate;
}
namespace Teamcenter
{
    class ProxyLinkEngDispatch;
}
namespace Teamcenter
{
    class ProxyLinkEngGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  WPROXY_API  Teamcenter::ProxyLinkEng
     : public  ::Teamcenter::ProxyLink
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ProxyLinkEng();

    /**
     * Destructor
     */
    virtual ~ProxyLinkEng();

private:
    //  Getter method for the Implementation Object
    ProxyLinkEngImpl*  getProxyLinkEngImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setProxyLinkEngImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ProxyLinkEngImpl*  m_proxylinkengImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ProxyLinkEng - desc for ProxyLinkEng parameter
     */
    ProxyLinkEng( const ProxyLinkEng& );
    ProxyLinkEng& operator=( const ProxyLinkEng& );

    friend class  ProxyLinkEngDelegate;
    friend class  ProxyLinkEngDispatch;
    friend class  ProxyLinkEngGenImpl;
};

#include <wproxy/libwproxy_undef.h>
#endif //   TEAMCENTER__PROXYLINKENG__HXX
