//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ProxyLinkRemoteWkf
    Filename:   ProxyLinkRemoteWkf.hxx
    Module:     wproxy
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROXYLINKREMOTEWKF__HXX
#define TEAMCENTER__PROXYLINKREMOTEWKF__HXX

#include <common/tc_deprecation_macros.h>
#include <wproxy/ProxyLink.hxx>

#include <wproxy/libwproxy_exports.h>

namespace Teamcenter
{
    class ProxyLinkRemoteWkf;
}
namespace Teamcenter
{
    class ProxyLinkRemoteWkfImpl;
}
namespace Teamcenter
{
    class ProxyLinkRemoteWkfDelegate;
}
namespace Teamcenter
{
    class ProxyLinkRemoteWkfDispatch;
}
namespace Teamcenter
{
    class ProxyLinkRemoteWkfGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  WPROXY_API  Teamcenter::ProxyLinkRemoteWkf
     : public  ::Teamcenter::ProxyLink
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ProxyLinkRemoteWkf();

    /**
     * Destructor
     */
    virtual ~ProxyLinkRemoteWkf();

private:
    //  Getter method for the Implementation Object
    ProxyLinkRemoteWkfImpl*  getProxyLinkRemoteWkfImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setProxyLinkRemoteWkfImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ProxyLinkRemoteWkfImpl*  m_proxylinkremotewkfImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ProxyLinkRemoteWkf - desc for ProxyLinkRemoteWkf parameter
     */
    ProxyLinkRemoteWkf( const ProxyLinkRemoteWkf& );
    ProxyLinkRemoteWkf& operator=( const ProxyLinkRemoteWkf& );

    friend class  ProxyLinkRemoteWkfDelegate;
    friend class  ProxyLinkRemoteWkfDispatch;
    friend class  ProxyLinkRemoteWkfGenImpl;
};

#include <wproxy/libwproxy_undef.h>
#endif //   TEAMCENTER__PROXYLINKREMOTEWKF__HXX
