//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, ProxyLinkReq
    Filename:   ProxyLinkReq.hxx
    Module:     wproxy
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__PROXYLINKREQ__HXX
#define TEAMCENTER__PROXYLINKREQ__HXX

#include <common/tc_deprecation_macros.h>
#include <wproxy/ProxyLink.hxx>

#include <wproxy/libwproxy_exports.h>

namespace Teamcenter
{
    class ProxyLinkReq;
}
namespace Teamcenter
{
    class ProxyLinkReqImpl;
}
namespace Teamcenter
{
    class ProxyLinkReqDelegate;
}
namespace Teamcenter
{
    class ProxyLinkReqDispatch;
}
namespace Teamcenter
{
    class ProxyLinkReqGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  WPROXY_API  Teamcenter::ProxyLinkReq
     : public  ::Teamcenter::ProxyLink
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    ProxyLinkReq();

    /**
     * Destructor
     */
    virtual ~ProxyLinkReq();

private:
    //  Getter method for the Implementation Object
    ProxyLinkReqImpl*  getProxyLinkReqImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setProxyLinkReqImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    ProxyLinkReqImpl*  m_proxylinkreqImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param ProxyLinkReq - desc for ProxyLinkReq parameter
     */
    ProxyLinkReq( const ProxyLinkReq& );
    ProxyLinkReq& operator=( const ProxyLinkReq& );

    friend class  ProxyLinkReqDelegate;
    friend class  ProxyLinkReqDispatch;
    friend class  ProxyLinkReqGenImpl;
};

#include <wproxy/libwproxy_undef.h>
#endif //   TEAMCENTER__PROXYLINKREQ__HXX
