//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, WolfObject
    Filename:   WolfObject.hxx
    Module:     wproxy
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__WOLFOBJECT__HXX
#define TEAMCENTER__WOLFOBJECT__HXX

#include <common/tc_deprecation_macros.h>
#include <tccore/POM_object.hxx>

#include <wproxy/libwproxy_exports.h>

namespace Teamcenter
{
    class WolfObject;
}
namespace Teamcenter
{
    class WolfObjectImpl;
}
namespace Teamcenter
{
    class WolfObjectDelegate;
}
namespace Teamcenter
{
    class WolfObjectDispatch;
}
namespace Teamcenter
{
    class WolfObjectGenImpl;
}
namespace Teamcenter
{
    class RootObjectImpl;
}

class  WPROXY_API  Teamcenter::WolfObject
     : public  ::Teamcenter::POM_object
{
public:

    /**
     * Get the Interface Name
     * @return - return desc for getInterfaceName
     */
    static const std::string&  getInterfaceName();

protected:
    //  Method to initialize
    virtual void initialize( ::Teamcenter::RootObjectImpl*  impl );

    /**
     * Constructor
     */
    WolfObject();

    /**
     * Destructor
     */
    virtual ~WolfObject();

private:
    //  Getter method for the Implementation Object
    WolfObjectImpl*  getWolfObjectImpl() const;
    //  Setter method for the Implementation Object
    ::Teamcenter::RootObjectImpl*  setWolfObjectImpl( ::Teamcenter::RootObjectImpl*  impl );

    //  Method to set the delete impl boolean
    void setDeleteImpl( bool  del );

    // Pointer to the Implementation object
    WolfObjectImpl*  m_wolfobjectImpl;

    //  Flag to indicate if Implementation object needs to be deleted
    bool  m_deleteImpl;

    /**
     * Name of the Business Object
     */
    static std::string  name;

    /**
     * Private default constructor. We do not want this class instantiated without the business object passed in.
     * @param WolfObject - desc for WolfObject parameter
     */
    WolfObject( const WolfObject& );
    WolfObject& operator=( const WolfObject& );

    friend class  WolfObjectDelegate;
    friend class  WolfObjectDispatch;
    friend class  WolfObjectGenImpl;
};

#include <wproxy/libwproxy_undef.h>
#endif //   TEAMCENTER__WOLFOBJECT__HXX
