//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/*==================================================================================================
File description:
    This file contains the declaration for the Business Object, WolfObjectDelegate
    Filename:   WolfObjectDelegate.hxx
    Module:     wproxy
    @BMIDE autogenerated
==================================================================================================*/

#ifndef TEAMCENTER__WOLFOBJECTDELEGATE_HXX
#define TEAMCENTER__WOLFOBJECTDELEGATE_HXX

#include <common/tc_deprecation_macros.h>
#include <wproxy/WolfObject.hxx>

#include <wproxy/libwproxy_exports.h>

namespace Teamcenter
{
    class WolfObjectDelegate;
}
namespace Teamcenter
{
    class WolfObjectImpl;
}
namespace Teamcenter
{
    class WolfObject;
}
namespace Teamcenter
{
    class WolfObjectGenImpl;
}

namespace Teamcenter_alias = ::Teamcenter;


class  WPROXY_API Teamcenter_alias::WolfObjectDelegate
{
public:
    //  Method to initialize this Class
    static int initializeClass();

    //  Method to get the WolfObjectDelegate instance
    static WolfObjectDelegate&  getInstance();

    //  Method to create the WolfObjectImpl pointer
    static WolfObjectImpl*  createImpl( WolfObject&  ifObj );

    //  Method to delete the WolfObjectImpl pointer
    static void deleteImpl( WolfObjectImpl*  impl );


    ///
    /// desc for validate for create
    /// @version Tc 8
    /// @param creInput - desc for creInput parameter
    /// @return - ret desc for validate for create
    ///
    int  validateCreateInputBase(const WolfObject &ifObj,  ::Teamcenter::CreateInput *creInput );



protected:
    //  Pointer to the instance
    static WolfObjectDelegate*  m_pInstance;

    WolfObjectDelegate();
    virtual ~WolfObjectDelegate();
    static void setInstance( WolfObjectDelegate*  instance );


private:
    friend class  ::Teamcenter::WolfObjectGenImpl;

};

#include <wproxy/libwproxy_undef.h>
#endif  //  TEAMCENTER__WOLFOBJECTDELEGATE_HXX
