//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  wproxy

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libwproxy

#if !defined(LIBWPROXY) && !defined(IPLIB)
#   error IPLIB or LIBWPROXY is not defined
#endif

/* Handwritten code should use WPROXY_API, not WPROXYEXPORT */

#define WPROXY_API WPROXYEXPORT

#if IPLIB==libwproxy || defined(LIBWPROXY)
#   if defined(__lint)
#       define WPROXYEXPORT       __export(wproxy)
#       define WPROXYGLOBAL       extern __global(wproxy)
#       define WPROXYPRIVATE      extern __private(wproxy)
#   elif defined(_WIN32)
#       define WPROXYEXPORT       __declspec(dllexport)
#       define WPROXYGLOBAL       extern __declspec(dllexport)
#       define WPROXYPRIVATE      extern
#   else
#       define WPROXYEXPORT
#       define WPROXYGLOBAL       extern
#       define WPROXYPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define WPROXYEXPORT       __export(wproxy)
#       define WPROXYGLOBAL       extern __global(wproxy)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define WPROXYEXPORT      __declspec(dllimport)
#       define WPROXYGLOBAL       extern __declspec(dllimport)
#   else
#       define WPROXYEXPORT
#       define WPROXYGLOBAL       extern
#   endif
#endif
